/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../core/mathUtils","../views/3d/webgl-engine/core/shaderLibrary/ScreenSpacePass.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/Gamma.glsl","../views/3d/webgl-engine/core/shaderModules/FloatPassUniform","../views/3d/webgl-engine/core/shaderModules/IntegerPassUniform","../views/3d/webgl-engine/core/shaderModules/interfaces","../views/3d/webgl-engine/core/shaderModules/ShaderBuilder","../views/3d/webgl-engine/core/shaderModules/Texture2DPassUniform"],(function(o,e,r,s,l,t,i,a,n){"use strict";var u;o.BloomCompositionPass=void 0,(u=o.BloomCompositionPass||(o.BloomCompositionPass={}))[u.BlurHorizontal=0]="BlurHorizontal",u[u.BlurVertical=1]="BlurVertical",u[u.Composite=2]="Composite",u[u.COUNT=3]="COUNT";class m extends i.NoParameters{constructor(){super(...arguments),this.exposure=25,this.blurRadius=.0033,this.bloomLod=-1}}function c(u){const m=new a.ShaderBuilder,c=m.fragment;switch(m.include(r.ScreenSpacePass),u.bloomStage){case o.BloomCompositionPass.BlurHorizontal:case o.BloomCompositionPass.BlurVertical:{m.include(s.Gamma),c.uniforms.add(new n.Texture2DPassUniform("colorTexture",(o=>o.colorTexture)),new l.FloatPassUniform("blurRadius",(o=>o.blurRadius)));let r="";const t=15;for(let o=0;o<t;o++){r+=`locations1D[${o}] = ${(o/(t-1)*2-1).toFixed(3).toString()};`}const a=2;let d="";for(let o=0;o<t;o++){d+=`locations1DWeights[${o}] = ${e.gauss(o-Math.floor(t/2),a).toFixed(7).toString()};`}const f=u.bloomStage===o.BloomCompositionPass.BlurHorizontal;c.code.add(i.glsl`
      float locations1D[${i.glsl.int(t)}];
      float locations1DWeights[${i.glsl.int(t)}];

      vec4 blurUniformSamples(sampler2D toBlur) {
        vec4 res = vec4(0.0);
        vec2 size = vec2(textureSize(toBlur, 0));
        vec2 aspectCorrection = vec2(1.0, size.x / size.y);
        vec2 uvInPixel = uv * size;

        ${r}
        ${d}
        vec2 pixelCenterShift = 0.5 / size;

        for(int i=0;i < ${i.glsl.int(t)}; i++) {
          float uv1D = locations1D[i] + ${f?"pixelCenterShift.x":"pixelCenterShift.y"};
          vec2 uvOffset = ${f?"vec2(uv1D, 0.0)":"vec2(0.0, uv1D)"};

          vec2 uvDistorted = uv + uvOffset * blurRadius * aspectCorrection;
          vec4 sampleColor = texture(toBlur, uvDistorted);
          res += pow(sampleColor, vec4(2.2)) * locations1DWeights[i];
        }
        res = pow(res, vec4(1.0/2.2));
        res.a = 1.0;

        return res;
      }
    `),c.main.add(i.glsl`fragColor = blurUniformSamples(colorTexture);`)}break;case o.BloomCompositionPass.Composite:m.include(s.Gamma),c.uniforms.add(new n.Texture2DPassUniform("colorTexture",(o=>o.colorTexture))),c.uniforms.add(new n.Texture2DPassUniform("bloomTexture0",(o=>o.bloomTexture0))),c.uniforms.add(new n.Texture2DPassUniform("bloomTexture1",(o=>o.bloomTexture1))),c.uniforms.add(new n.Texture2DPassUniform("bloomTexture2",(o=>o.bloomTexture2))),c.uniforms.add(new n.Texture2DPassUniform("bloomTexture3",(o=>o.bloomTexture3))),c.uniforms.add(new n.Texture2DPassUniform("bloomTexture4",(o=>o.bloomTexture4))),c.uniforms.add(new l.FloatPassUniform("exposure",(o=>o.exposure))),c.uniforms.add(new t.IntegerPassUniform("bloomLod",(o=>o.bloomLod))),c.uniforms.add(new l.FloatPassUniform("blurRadius",(o=>o.blurRadius))),c.code.add(i.glsl`float factors[5] = float[5]( 1.0, 0.8, 0.6, 0.4, 0.2 );`),c.code.add(i.glsl`vec3 simpleExposureTonemap(vec3 hdrColor, float exposure) {
vec3 mapped = vec3(1.0) - exp(-hdrColor * exposure);
return mapped;
}`),c.main.add(i.glsl`vec4 color = texture(colorTexture, uv);
color = vec4(linearizeGamma(color.rgb), color.w);
vec4 bloomLod0 = pow(texture(bloomTexture0, uv), vec4(2.2));
vec4 bloomLod1 = pow(texture(bloomTexture1, uv), vec4(2.2));
vec4 bloomLod2 = pow(texture(bloomTexture2, uv), vec4(2.2));
vec4 bloomLod3 = pow(texture(bloomTexture3, uv), vec4(2.2));
vec4 bloomLod4 = pow(texture(bloomTexture4, uv), vec4(2.2));
fragColor = factors[0] * bloomLod0 + factors[1] * bloomLod1 + factors[2] * bloomLod2 + factors[3] * bloomLod3 + factors[4] * bloomLod4;
fragColor = vec4(simpleExposureTonemap(fragColor.rgb, exposure), fragColor.w);
fragColor += color;
fragColor = vec4(pow(fragColor.rgb, vec3(1.0 / 2.2)), fragColor.a);`)}return m}const d=Object.freeze(Object.defineProperty({__proto__:null,get BloomCompositionPass(){return o.BloomCompositionPass},BloomCompositionPassParameters:m,build:c},Symbol.toStringTag,{value:"Module"}));o.BloomComposition=d,o.BloomCompositionPassParameters=m,o.build=c}));
