/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../views/3d/webgl-engine/core/shaderLibrary/Slice.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/TerrainDepthTest.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/ColorConversion.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/View.glsl","../views/3d/webgl-engine/core/shaderModules/Float2PassUniform","../views/3d/webgl-engine/core/shaderModules/Float4PassUniform","../views/3d/webgl-engine/core/shaderModules/interfaces","../views/3d/webgl-engine/core/shaderModules/ShaderBuilder","../views/3d/webgl-engine/lib/VertexAttribute","../views/3d/webgl-engine/shaders/OutputColorHighlightOID.glsl"],(function(e,i,r,o,t,l,s,a,d,n,c){"use strict";function g(e){const g=new d.ShaderBuilder,{vertex:u,fragment:v,varyings:h}=g;return g.include(i.SliceDraw,e),g.include(r.terrainDepthTest,e),g.include(c.outputColorHighlightOID,e),t.addProjViewLocalOrigin(u,e),g.attributes.add(n.VertexAttribute.POSITION,"vec3"),g.attributes.add(n.VertexAttribute.UV0,"vec2"),h.add("vUV","vec2"),h.add("vpos","vec3"),e.terrainDepthTest&&g.varyings.add("depth","float"),u.main.add(a.glsl`
      vUV = uv0;
      vpos = position;
      ${e.terrainDepthTest?"depth = (view * vec4(position, 1.0)).z;":""}
      gl_Position = proj * view * vec4(position, 1.0);`),v.uniforms.add(new l.Float2PassUniform("size",(e=>e.size))),v.uniforms.add(new s.Float4PassUniform("color1",(e=>e.color1))),v.uniforms.add(new s.Float4PassUniform("color2",(e=>e.color2))),v.include(o.ColorConversion),v.main.add(a.glsl`
      ${e.terrainDepthTest?"terrainDepthTest(depth);":""}
      vec2 uvScaled = vUV / (2.0 * size);

      vec2 uv = fract(uvScaled - 0.25);
      vec2 ab = clamp((abs(uv - 0.5) - 0.25) / fwidth(uvScaled), -0.5, 0.5);
      float fade = smoothstep(0.25, 0.5, max(fwidth(uvScaled.x), fwidth(uvScaled.y)));
      float t = mix(abs(ab.x + ab.y), 0.5, fade);

      fragColor = mix(color2, color1, t);
      outputColorHighlightOID(fragColor, vpos);`),g}const u=Object.freeze(Object.defineProperty({__proto__:null,build:g},Symbol.toStringTag,{value:"Module"}));e.CheckerBoard=u,e.build=g}));
