/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../geometry/support/Ellipsoid","../views/3d/terrain/OverlayContent","../views/3d/webgl-engine/collections/Component/Material/ComponentTechniqueConfiguration","../views/3d/webgl-engine/collections/Component/Material/shader/ComponentData.glsl","../views/3d/webgl-engine/collections/Component/Material/shader/VertexDiscardByOpacity.glsl","../views/3d/webgl-engine/core/shaderLibrary/ForwardLinearDepth.glsl","../views/3d/webgl-engine/core/shaderLibrary/ShaderOutput","../views/3d/webgl-engine/core/shaderLibrary/Slice.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/TextureCoordinateAttribute.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/VertexColor.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/VertexNormal.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/VertexPosition.glsl","../views/3d/webgl-engine/core/shaderLibrary/output/OutputDepth.glsl","../views/3d/webgl-engine/core/shaderLibrary/output/OutputHighlight.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/ComputeFragmentNormals.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/ComputeMaterialColor.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/ComputeNormalTexture.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/EvaluateSceneLighting.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/MainLighting.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/PhysicallyBasedRenderingParameters.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/ReadBaseColorTexture.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/ReadShadowMap.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/TerrainDepthTest.glsl","../views/3d/webgl-engine/core/shaderLibrary/terrain/Overlay.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/AlphaCutoff","../views/3d/webgl-engine/core/shaderLibrary/util/DiscardOrAdjustAlpha.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/EllipsoidMode","../views/3d/webgl-engine/core/shaderModules/interfaces","../views/3d/webgl-engine/core/shaderModules/ShaderBuilder","../views/3d/webgl-engine/core/shaderModules/Texture2DPassUniform","../views/3d/webgl-engine/shaders/OutputColorHighlightOID.glsl"],(function(e,a,o,r,l,i,t,n,d,s,g,c,u,h,v,m,w,C,b,p,y,f,x,O,S,L,M,T,N,I,D,A){"use strict";function P(e){const P=new I.ShaderBuilder;P.include(u.VertexPosition,e),P.include(c.VertexNormal,e),P.include(g.VertexColor,e),P.include(s.TextureCoordinateAttribute,e),P.include(t.ForwardLinearDepth,e),P.include(l.ComponentData,e),P.include(M.DiscardOrAdjustAlphaDraw,e),P.include(d.SlicePass,e),P.include(f.ReadBaseColorTexture,e),P.include(i.VertexDiscardByOpacity,e);const{vertex:$,fragment:W}=P,{output:B,pbrMode:R,hasNormalTexture:E,snowCover:F,receiveShadows:V,spherical:z,ellipsoidMode:H}=e,j=R===y.PBRMode.Normal||R===y.PBRMode.Schematic;j&&(P.include(y.PhysicallyBasedRenderingParameters,e),E&&P.include(C.ComputeNormalTexture,e));const G=B===n.ShaderOutput.Shadow||B===n.ShaderOutput.ShadowHighlight||B===n.ShaderOutput.ShadowExcludeHighlight,_=G&&e.componentData===l.ComponentDataType.Varying;$.code.add(`#define discardShadows(castShadows) { ${N.If(_,"if(!castShadows) { gl_Position = vec4(vec3(1e38), 1.0); return; }")} }`);const k=e.integratedMeshMode===r.IntegratedMeshMode.ColorOverlay||e.integratedMeshMode===r.IntegratedMeshMode.ColorOverlayWithWater;if(k){P.include(b.EvaluateSceneLighting,e),P.include(S.OverlayIM,e);const o=H===T.EllipsoidMode.Earth,r=H===T.EllipsoidMode.Earth,l=o?a.earth.radius:r?a.mars.radius:a.moon.radius;$.code.add(`\n      ${N.If(z,`const float invRadius = ${N.glsl.float(1/l)};`)}\n      vec2 projectOverlay(vec3 pos) { return pos.xy ${N.If(z,"/ (1.0 + invRadius * pos.z);")}; }`)}const U=k&&n.isColorOrColorEmission(B)&&R===y.PBRMode.WaterOnIntegratedMesh;if(U&&(P.varyings.add("tbnTangent","vec3"),P.varyings.add("tbnBiTangent","vec3"),P.varyings.add("groundNormal","vec3")),$.main.add(N.glsl`
    bool castShadows;
    vec4 externalColor = forwardExternalColor(castShadows);
    discardShadows(castShadows);

    vertexDiscardByOpacity(externalColor.a);

    ${B===n.ShaderOutput.ObjectAndLayerIdColor?N.glsl`externalColor.a = 1.0;`:""}

    if (externalColor.a < ${N.glsl.float(L.alphaCutoff)}) {
      // Discard this vertex
      gl_Position = vec4(1e38, 1e38, 1e38, 1.0);
      return;
    }

    forwardPosition(readElevationOffset());
    forwardNormal();
    forwardTextureCoordinates();
    forwardVertexColor();
    forwardLinearDepth();
    forwardObjectAndLayerIdColor();
    ${U?z?N.glsl`
              groundNormal = normalize(positionWorld());
              tbnTangent = normalize(cross(vec3(0.0, 0.0, 1.0), groundNormal));
              tbnBiTangent = normalize(cross(groundNormal, tbnTangent));`:N.glsl`
              groundNormal = vec3(0.0, 0.0, 1.0);
              tbnTangent = vec3(1.0, 0.0, 0.0);
              tbnBiTangent = vec3(0.0, 1.0, 0.0);`:""}
    ${k?N.glsl`setOverlayVTC(projectOverlay(position));`:""}
  `),n.isColorOrColorEmission(B))return P.include(O.terrainDepthTest,e),P.include(w.ComputeMaterialColor,e),P.include(m.computeFragmentNormals,e),P.include(b.EvaluateSceneLighting,e),P.include(A.outputColorHighlightOID,e),V&&P.include(x.ReadShadowMapPass,e),W.code.add(N.glsl`
      float evaluateShadow() {
        return ${V?"readShadowMap(vPositionWorldCameraRelative, linearDepth)":"0.0"};
      }`),k&&W.uniforms.add(new D.Texture2DPassUniform("ovColorTex",((e,a)=>S.getIMColorTexture(e,a)))),W.main.add(N.glsl`
      discardBySlice(vPositionWorldCameraRelative);
      terrainDepthTest(vPosition_view.z);

      vec4 textureColor = readBaseColorTexture();
      discardOrAdjustAlpha(textureColor);

      vec4 externalColor;
      int externalColorMixMode;
      readExternalColor(externalColor, externalColorMixMode);

      vec4 materialColor = computeMaterialColor(textureColor, externalColor, externalColorMixMode);
      ${k?N.glsl`vec4 overlayColor = getOverlayColor(ovColorTex, vtcOverlay);`:""}
    `),j?(p.addMainLightIntensity(W),z&&b.addLightingGlobalFactor(W),W.main.add(N.glsl`
        applyPBRFactors();
        ${N.If(R===y.PBRMode.Normal,N.glsl`if (externalColorMixMode == 3) {
              mrr = vec3(0.0, 0.6, 0.2);
            }`)}
        float additionalIrradiance = 0.02 * mainLightIntensity[2];
        ${N.If(E,"mat3 tangentSpace = computeTangentSpace(fragmentShadingNormal, vPositionWorldCameraRelative, vuv0);")}
        vec3 shadingNormal = ${E?"computeTextureNormal(tangentSpace, vuv0)":"fragmentShadingNormal"};
        vec3 normalGround = ${z?N.glsl`normalize(positionWorld())`:N.glsl`vec3(0.0, 0.0, 1.0)`};

        vec3 viewDir = normalize(vPositionWorldCameraRelative);
        float ssao = 1.0 - occlusion * evaluateAmbientOcclusionInverse();
        ${N.If(F,N.glsl`float snow = smoothstep(0.5, 0.55, dot(fragmentFaceNormal, normalize(positionWorld())));
                 materialColor.rgb = mix(materialColor.rgb, vec3(1.1), snow);
                 ssao = mix(ssao, 0.5 * ssao, snow);
                 shadingNormal = mix(shadingNormal, fragmentFaceNormal, snow);`)}
        ${N.If(k,"materialColor = materialColor * (1.0 - overlayColor.a) + overlayColor;")}

        vec3 additionalLight = evaluateAdditionalLighting(ssao, positionWorld());
        vec4 emission = getEmissions();
        ${N.If(z,"float additionalAmbientScale = additionalDirectedAmbientLight(positionWorld());")}
        ${z?N.glsl`float shadow = max(lightingGlobalFactor * (1.0 - additionalAmbientScale), evaluateShadow());`:"float shadow = evaluateShadow();"}
        vec4 shadedColor = vec4(evaluateSceneLightingPBR(shadingNormal, materialColor.rgb, shadow, ssao, additionalLight, viewDir, normalGround, mrr, emission, additionalIrradiance), materialColor.a);
        `)):(z&&b.addLightingGlobalFactor(W),U&&W.uniforms.add(new D.Texture2DPassUniform("ovNormalTex",((e,a)=>a.overlay?.getTexture(o.OverlayContent.WaterNormal)))),W.main.add(N.glsl`
        ${N.If(z,"float additionalAmbientScale = additionalDirectedAmbientLight(positionWorld());")}
        float shadow = ${V?z?"max(lightingGlobalFactor * (1.0 - additionalAmbientScale), evaluateShadow())":"evaluateShadow()":z?"lightingGlobalFactor * (1.0 - additionalAmbientScale)":"0.0"};

        ${N.If(F,N.glsl`float snow = smoothstep(0.5, 0.55, dot(fragmentFaceNormal, normalize(positionWorld())));
               materialColor.rgb = mix(materialColor.rgb, vec3(1), snow);`)}

        // At global scale we create some additional ambient light based on the main light to simulate global illumination
        float ssao = evaluateAmbientOcclusion();
        vec3 additionalLight = evaluateAdditionalLighting(ssao, positionWorld());

        ${k?N.glsl` materialColor = materialColor * (1.0 - overlayColor.a) + overlayColor;`:""}

        vec4 shadedColor = vec4(evaluateSceneLighting(fragmentShadingNormal, materialColor.rgb, shadow, ssao, additionalLight), materialColor.a);
        ${N.If(U,N.glsl`vec4 overlayWaterMask = getOverlayColor(ovNormalTex, vtcOverlay);
                 float waterNormalLength = length(overlayWaterMask);
                 if (waterNormalLength > 0.95) {
                   mat3 tbnMatrix = mat3(tbnTangent, tbnBiTangent, groundNormal);
                   vec4 waterColorLinear = getOverlayWaterColor(overlayWaterMask, overlayColor, -normalize(vPositionWorldCameraRelative), shadow, groundNormal, tbnMatrix, vPosition_view, positionWorld());
                   vec4 waterColorNonLinear = delinearizeGamma(vec4(waterColorLinear.xyz, 1.0));
                   // un-gamma the ground color to mix in linear space
                   shadedColor = mix(shadedColor, waterColorNonLinear, waterColorLinear.w);
                 }`)}
      `)),W.main.add(N.glsl`outputColorHighlightOID(shadedColor, vPositionWorldCameraRelative);`),P;const q=B===n.ShaderOutput.Normal,J=B===n.ShaderOutput.ObjectAndLayerIdColor,K=B===n.ShaderOutput.Highlight,Q=G||B===n.ShaderOutput.ViewshedShadow;return Q&&P.include(h.OutputDepth,e),q&&P.include(m.computeFragmentNormals,e),P.include(v.OutputHighlight,e),W.main.add(N.glsl`
    discardBySlice(vPositionWorldCameraRelative);

    vec4 textureColor = readBaseColorTexture();
    discardOrAdjustAlpha(textureColor);

    ${N.If(Q,"outputDepth(linearDepth);")}
    ${N.If(q,N.glsl`fragColor = vec4(vec3(0.5) + 0.5 * fragmentFaceNormalView, 1.0);`)}
    ${N.If(J,k?"fragColor = getOverlayColorTexel(vtcOverlay);":"outputObjectAndLayerIdColor();")}
    ${N.If(K,N.glsl`${N.If(k,N.glsl`
           vec2 overlayHighlightTexel = getAllOverlayHighlightValuesEncoded();
           outputAllHighlights(overlayHighlightTexel);`,N.glsl`calculateOcclusionAndOutputHighlight();`)}`)}`),P}const $=Object.freeze(Object.defineProperty({__proto__:null,build:P},Symbol.toStringTag,{value:"Module"}));e.ComponentShader=$,e.build=P}));
