/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../views/3d/webgl-engine/core/shaderLibrary/ForwardLinearDepth.glsl","../views/3d/webgl-engine/core/shaderLibrary/Offset.glsl","../views/3d/webgl-engine/core/shaderLibrary/ShaderOutput","../views/3d/webgl-engine/core/shaderLibrary/Slice.glsl","../views/3d/webgl-engine/core/shaderLibrary/Transform.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/InstancedDoublePrecision.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/NormalAttribute.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/PositionAttribute.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/SymbolColor.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/TextureCoordinateAttribute.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/VertexColor.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/VertexNormal.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/VerticalOffset.glsl","../views/3d/webgl-engine/core/shaderLibrary/default/DefaultMaterialAuxiliaryPasses.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/ComputeNormalTexture.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/EvaluateAmbientOcclusion.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/EvaluateSceneLighting.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/MainLighting.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/Normals.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/PhysicallyBasedRendering.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/PhysicallyBasedRenderingParameters.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/ReadShadowMap.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/TerrainDepthTest.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/TextureTransformUV.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/VisualVariables.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/AlphaCutoff","../views/3d/webgl-engine/core/shaderLibrary/util/DiscardOrAdjustAlpha.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/MixExternalColor.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/View.glsl","../views/3d/webgl-engine/core/shaderModules/Float3PassUniform","../views/3d/webgl-engine/core/shaderModules/Float4PassUniform","../views/3d/webgl-engine/core/shaderModules/FloatPassUniform","../views/3d/webgl-engine/core/shaderModules/interfaces","../views/3d/webgl-engine/core/shaderModules/ShaderBuilder","../views/3d/webgl-engine/core/shaderModules/Texture2DPassUniform","../views/3d/webgl-engine/lib/VertexAttribute","../views/3d/webgl-engine/shaders/OutputColorHighlightOID.glsl"],(function(e,r,a,i,o,l,s,n,t,d,c,g,u,m,v,b,h,w,f,p,x,y,C,L,P,T,V,O,A,N,S,D,M,I,U,$,E,F){"use strict";function B(e){const B=new U.ShaderBuilder,{vertex:R,fragment:_,varyings:j}=B,{output:G,normalType:z,offsetBackfaces:W,instancedColor:k,spherical:H,receiveShadows:q,snowCover:J,pbrMode:K,textureAlphaPremultiplied:Q,instancedDoublePrecision:X,hasVertexColors:Y,hasVertexTangents:Z,hasColorTexture:ee,hasNormalTexture:re,hasNormalTextureTransform:ae,hasColorTextureTransform:ie}=e;if(N.addProjViewLocalOrigin(R,e),B.include(t.PositionAttribute),j.add("vpos","vec3"),B.include(T.VisualVariables,e),B.include(s.InstancedDoublePrecision,e),B.include(m.VerticalOffset,e),B.include(P.colorTextureUV,e),!i.isColorOrColorEmission(G))return B.include(v.DefaultMaterialAuxiliaryPasses,e),B;B.include(P.normalTextureUV,e),B.include(P.emissiveTextureUV,e),B.include(P.occlusionTextureUV,e),B.include(P.metallicRoughnessTextureUV,e),N.addCameraPosition(R,e),B.include(n.NormalAttribute,e),B.include(l.Transform,e);const oe=z===n.NormalType.Attribute||z===n.NormalType.Compressed;return oe&&W&&B.include(a.Offset),B.include(b.ComputeNormalTexture,e),B.include(u.VertexNormal,e),k&&B.attributes.add(E.VertexAttribute.INSTANCECOLOR,"vec4"),j.add("vPositionLocal","vec3"),B.include(c.TextureCoordinateAttribute,e),B.include(r.ForwardLinearDepth,e),B.include(d.SymbolColor,e),B.include(g.VertexColor,e),R.uniforms.add(new D.Float4PassUniform("externalColor",(e=>e.externalColor))),j.add("vcolorExt","vec4"),e.terrainDepthTest&&j.add("depth","float"),R.main.add(I.glsl`
    forwardNormalizedVertexColor();
    vcolorExt = externalColor;
    ${I.If(k,"vcolorExt *= instanceColor * 0.003921568627451;")}
    vcolorExt *= vvColor();
    vcolorExt *= getSymbolColor();
    forwardColorMixMode();

    if (vcolorExt.a < ${I.glsl.float(V.alphaCutoff)}) {
      gl_Position = vec4(1e38, 1e38, 1e38, 1.0);
    } else {
      vpos = getVertexInLocalOriginSpace();
      vPositionLocal = vpos - view[3].xyz;
      vpos = subtractOrigin(vpos);
      ${I.If(oe,"vNormalWorld = dpNormal(vvLocalNormal(normalModel()));")}
      vpos = addVerticalOffset(vpos, localOrigin);
      ${I.If(Z,"vTangent = dpTransformVertexTangent(tangent);")}
      gl_Position = transformPosition(proj, view, vpos);
      ${I.If(oe&&W,"gl_Position = offsetBackfacingClipPosition(gl_Position, vpos, vNormalWorld, cameraPosition);")}
    }

    ${I.If(e.terrainDepthTest,"depth = (view * vec4(vpos, 1.0)).z;")}
    forwardLinearDepth();
    forwardTextureCoordinates();
    forwardColorUV();
    forwardNormalUV();
    forwardEmissiveUV();
    forwardOcclusionUV();
    forwardMetallicRoughnessUV();
  `),B.include(w.EvaluateSceneLighting,e),B.include(h.EvaluateAmbientOcclusion,e),B.include(O.DiscardOrAdjustAlphaPass,e),B.include(X?C.ReadShadowMapPass:C.ReadShadowMapDraw,e),B.include(L.terrainDepthTest,e),B.include(o.SliceDraw,e),B.include(F.outputColorHighlightOID,e),N.addCameraPosition(_,e),_.uniforms.add(R.uniforms.get("localOrigin"),new S.Float3PassUniform("ambient",(e=>e.ambient)),new S.Float3PassUniform("diffuse",(e=>e.diffuse)),new M.FloatPassUniform("opacity",(e=>e.opacity)),new M.FloatPassUniform("layerOpacity",(e=>e.layerOpacity))),ee&&_.uniforms.add(new $.Texture2DPassUniform("tex",(e=>e.texture))),B.include(y.PhysicallyBasedRenderingParameters,e),B.include(x.PhysicallyBasedRendering,e),_.include(A.MixExternalColor),B.include(p.Normals,e),w.addAmbientBoostFactor(_),w.addLightingGlobalFactor(_),f.addMainLightIntensity(_),_.main.add(I.glsl`
      discardBySlice(vpos);
      ${I.If(e.terrainDepthTest,"terrainDepthTest(depth);")}
      ${ee?I.glsl`
              vec4 texColor = texture(tex, ${ie?"colorUV":"vuv0"});
              ${I.If(Q,"texColor.rgb /= texColor.a;")}
              discardOrAdjustAlpha(texColor);`:I.glsl`vec4 texColor = vec4(1.0);`}
      shadingParams.viewDirection = normalize(vpos - cameraPosition);
      ${z===n.NormalType.ScreenDerivative?I.glsl`vec3 normal = screenDerivativeNormal(vPositionLocal);`:I.glsl`shadingParams.normalView = vNormalWorld;
                 vec3 normal = shadingNormal(shadingParams);`}
      applyPBRFactors();
      float ssao = evaluateAmbientOcclusionInverse() * getBakedOcclusion();

      vec3 posWorld = vpos + localOrigin;

      float additionalAmbientScale = additionalDirectedAmbientLight(posWorld);
      float shadow = ${q?"max(lightingGlobalFactor * (1.0 - additionalAmbientScale), readShadowMap(vpos, linearDepth))":I.If(H,"lightingGlobalFactor * (1.0 - additionalAmbientScale)","0.0")};

      vec3 matColor = max(ambient, diffuse);
      vec3 albedo = mixExternalColor(${I.If(Y,"vColor.rgb *")} matColor, texColor.rgb, vcolorExt.rgb, int(colorMixMode));
      float opacity_ = layerOpacity * mixExternalOpacity(${I.If(Y,"vColor.a * ")} opacity, texColor.a, vcolorExt.a, int(colorMixMode));
      ${re?`mat3 tangentSpace = computeTangentSpace(${Z?"normal":"normal, vpos, vuv0"});\n             vec3 shadingNormal = computeTextureNormal(tangentSpace, ${ae?"normalUV":"vuv0"});`:"vec3 shadingNormal = normal;"}
      vec3 normalGround = ${H?"normalize(posWorld);":"vec3(0.0, 0.0, 1.0);"}

      ${I.If(J,I.glsl`
            float snow = smoothstep(0.5, 0.55, dot(normal, normalGround));
            albedo = mix(albedo, vec3(1), snow);
            shadingNormal = mix(shadingNormal, normal, snow);
            ssao = mix(ssao, 1.0, snow);`)}

      vec3 additionalLight = ssao * mainLightIntensity * additionalAmbientScale * ambientBoostFactor * lightingGlobalFactor;

      ${K===y.PBRMode.Normal||K===y.PBRMode.Schematic?I.glsl`
              float additionalAmbientIrradiance = additionalAmbientIrradianceFactor * mainLightIntensity[2];
              ${I.If(J,I.glsl`mrr = mix(mrr, vec3(0.0, 1.0, 0.04), snow);`)}
              vec4 emission = ${J?"mix(getEmissions(), vec4(0.0), snow)":"getEmissions()"};
              vec3 shadedColor = evaluateSceneLightingPBR(shadingNormal, albedo, shadow, 1.0 - ssao, additionalLight, shadingParams.viewDirection, normalGround, mrr, emission, additionalAmbientIrradiance);`:I.glsl`vec3 shadedColor = evaluateSceneLighting(shadingNormal, albedo, shadow, 1.0 - ssao, additionalLight);`}
      vec4 finalColor = vec4(shadedColor, opacity_);
      outputColorHighlightOID(finalColor, vpos);
  `),B}const R=Object.freeze(Object.defineProperty({__proto__:null,build:B},Symbol.toStringTag,{value:"Module"}));e.DefaultMaterial=R,e.build=B}));
