/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../core/libs/gl-matrix-2/factories/vec3f64","../views/3d/webgl-engine/core/shaderLibrary/shading/Gamma.glsl","../views/3d/webgl-engine/core/shaderModules/Float2PassUniform","../views/3d/webgl-engine/core/shaderModules/Float3PassUniform","../views/3d/webgl-engine/core/shaderModules/FloatPassUniform","../views/3d/webgl-engine/core/shaderModules/interfaces","../views/3d/webgl-engine/core/shaderModules/ShaderBuilder","../views/3d/webgl-engine/core/shaderModules/Texture2DPassUniform","../views/3d/webgl-engine/shaders/ScreenSpacePassAtmosphere.glsl","../views/3d/webgl-engine/shaders/SphereIntersect.glsl","../views/3d/webgl-engine/shaders/ToneMapping.glsl"],(function(e,a,r,o,n,s,t,i,l,d,m,c){"use strict";class g extends t.NoParameters{constructor(){super(...arguments),this.color=a.create(),this.strength=4e-6,this.atmosphereC=1,this.amount=0}}function h(){const e=new i.ShaderBuilder;e.include(d.ScreenSpacePassAtmosphere,{needUVs:!0,needEyeDirection:!0});const a=e.fragment;return a.uniforms.add(new s.FloatPassUniform("atmosphereC",(e=>e.atmosphereC)),new n.Float3PassUniform("cameraPosition",((e,a)=>a.camera.eye)),new o.Float2PassUniform("nearFar",((e,a)=>a.camera.nearFar)),new l.Texture2DPassUniform("depthTexture",((e,a)=>a.mainDepth)),new s.FloatPassUniform("fogStrength",(e=>e.strength)),new s.FloatPassUniform("fogAmount",(e=>e.amount)),new n.Float3PassUniform("fogColor",(e=>e.color))),e.include(r.Gamma),a.include(m.SphereIntersect),a.include(c.ToneMapping),a.code.add(t.glsl`float getFogAmount(float dist, vec3 rayDir) {
if(dist == -1.0){
dist = 0.055 * sphereIntersect(cameraPosition, rayDir, atmosphereC).y;
}
return fogAmount * (1.0 - exp(-dist * fogStrength));
}`),a.main.add(t.glsl`vec3 rayDir = normalize(worldRay);
float terrainDepth = -1.0;
float depthSample = texture(depthTexture, uv).r;
float zNorm = 2.0 * depthSample - 1.0;
float linDepth = 2.0 * nearFar[0] * nearFar[1] / (nearFar[1] + nearFar[0] - zNorm * (nearFar[1] - nearFar[0]));
if(depthSample < 1.0 && depthSample > 0.0){
vec3 cameraSpaceRay = normalize(eyeDir);
cameraSpaceRay /= cameraSpaceRay.z;
cameraSpaceRay *= linDepth;
terrainDepth = max(0.0, length(cameraSpaceRay));
}
float fogAmount = getFogAmount(terrainDepth, rayDir);
vec4 fog = vec4(fogColor, 1.0) * fogAmount;
fragColor = delinearizeGamma(vec4(tonemapACES(fog.rgb), fog.a));`),e}const f=Object.freeze(Object.defineProperty({__proto__:null,FogPassParameters:g,build:h},Symbol.toStringTag,{value:"Module"}));e.Fog=f,e.FogPassParameters=g,e.build=h}));
