/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../core/libs/gl-matrix-2/math/vec2","../core/libs/gl-matrix-2/factories/vec2f64","../core/libs/gl-matrix-2/factories/vec4f64","../geometry/support/Ellipsoid","../views/3d/webgl-engine/core/shaderLibrary/ShaderOutput","../views/3d/webgl-engine/core/shaderLibrary/Slice.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/ObjectAndLayerIdColor.glsl","../views/3d/webgl-engine/core/shaderLibrary/hud/AlignPixel.glsl","../views/3d/webgl-engine/core/shaderLibrary/hud/HUD.glsl","../views/3d/webgl-engine/core/shaderLibrary/hud/HUDOcclusionPass.glsl","../views/3d/webgl-engine/core/shaderLibrary/hud/HUDVisibility.glsl","../views/3d/webgl-engine/core/shaderLibrary/output/OutputHighlight.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/VisualVariables.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/AlphaCutoff","../views/3d/webgl-engine/core/shaderLibrary/util/ColorConversion.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/RgbaFloatEncoding.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/ScreenSizePerspective.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/View.glsl","../views/3d/webgl-engine/core/shaderModules/Float2PassUniform","../views/3d/webgl-engine/core/shaderModules/Float4DrawUniform","../views/3d/webgl-engine/core/shaderModules/Float4PassUniform","../views/3d/webgl-engine/core/shaderModules/FloatPassUniform","../views/3d/webgl-engine/core/shaderModules/interfaces","../views/3d/webgl-engine/core/shaderModules/ShaderBuilder","../views/3d/webgl-engine/core/shaderModules/Texture2DPassUniform","../views/3d/webgl-engine/lib/OITPass","../views/3d/webgl-engine/lib/VertexAttribute"],(function(e,o,l,i,r,a,t,s,n,d,c,u,g,f,p,v,b,h,m,x,w,P,C,S,z,A,y,O){"use strict";const F={occludedFadeFactor:.6};function D(e){const l=new z.ShaderBuilder,D=e.signedDistanceFieldEnabled;if(l.include(d.HUD,e),l.include(t.SliceDraw,e),e.occlusionPass)return l.include(c.HUDOcclusionPass,e),l;const{vertex:$,fragment:U}=l;l.include(h.ScreenSizePerspective),l.include(f.VisualVariables,e),l.include(s.ObjectAndLayerIdColor,e),l.include(u.HUDVisibility),U.include(b.RgbaFloatEncoding),U.include(v.ColorConversion),l.varyings.add("vcolor","vec4"),l.varyings.add("vtc","vec2"),l.varyings.add("vsize","vec2"),l.varyings.add("voccluded","float"),$.uniforms.add(new P.Float4PassUniform("viewport",((e,o)=>o.camera.fullViewport)),new x.Float2PassUniform("screenOffset",((e,l)=>o.set(T,2*e.screenOffset[0]*l.camera.pixelRatio,2*e.screenOffset[1]*l.camera.pixelRatio))),new x.Float2PassUniform("anchorPosition",(e=>I(e))),new P.Float4PassUniform("materialColor",(e=>e.color)),new C.FloatPassUniform("materialRotation",(e=>e.rotation))),m.addPixelRatio($),D&&($.uniforms.add(new P.Float4PassUniform("outlineColor",(e=>e.outlineColor))),U.uniforms.add(new P.Float4PassUniform("outlineColor",(e=>j(e)?e.outlineColor:i.ZEROS)),new C.FloatPassUniform("outlineSize",(e=>j(e)?e.outlineSize:0)))),e.horizonCullingEnabled&&$.uniforms.add(new w.Float4DrawUniform("pointDistanceSphere",((e,o)=>{const l=o.camera.eye,a=e.origin;return i.fromValues(a[0]-l[0],a[1]-l[1],a[2]-l[2],r.earth.radius)}))),e.pixelSnappingEnabled&&$.include(n.AlignPixel),e.hasScreenSizePerspective&&(h.addScreenSizePerspective($),h.addScreenSizePerspectiveAlignment($)),e.debugDrawLabelBorder&&l.varyings.add("debugBorderCoords","vec4"),l.attributes.add(O.VertexAttribute.UV0,"vec2"),l.attributes.add(O.VertexAttribute.COLOR,"vec4"),l.attributes.add(O.VertexAttribute.SIZE,"vec2"),l.attributes.add(O.VertexAttribute.ROTATION,"float"),l.attributes.add(O.VertexAttribute.FEATUREATTRIBUTE,"vec4"),$.code.add(e.horizonCullingEnabled?S.glsl`bool behindHorizon(vec3 posModel) {
vec3 camToEarthCenter = pointDistanceSphere.xyz - localOrigin;
vec3 camToPos = pointDistanceSphere.xyz + posModel;
float earthRadius = pointDistanceSphere.w;
float a = dot(camToPos, camToPos);
float b = dot(camToPos, camToEarthCenter);
float c = dot(camToEarthCenter, camToEarthCenter) - earthRadius * earthRadius;
return  b > 0.0 && b < a && b * b  > a * c;
}`:S.glsl`bool behindHorizon(vec3 posModel) { return false; }`),$.main.add(S.glsl`
      ProjectHUDAux projectAux;
      vec4 posProj = projectPositionHUD(projectAux);
      forwardObjectAndLayerIdColor();

      if (rejectBySlice(projectAux.posModel)) {
        // Project outside of clip plane
        gl_Position = vec4(1e038, 1e038, 1e038, 1.0);
        return;
      }

      if (behindHorizon(projectAux.posModel)) {
        // Project outside of clip plane
        gl_Position = vec4(1e038, 1e038, 1e038, 1.0);
        return;
      }

      vec2 inputSize;
      ${S.If(e.hasScreenSizePerspective,S.glsl`
          inputSize = screenSizePerspectiveScaleVec2(size, projectAux.absCosAngle, projectAux.distanceToCamera, screenSizePerspective);
          vec2 screenOffsetScaled = screenSizePerspectiveScaleVec2(screenOffset, projectAux.absCosAngle, projectAux.distanceToCamera, screenSizePerspectiveAlignment);`,S.glsl`
          inputSize = size;
          vec2 screenOffsetScaled = screenOffset;`)}
      ${S.If(e.vvSize,S.glsl`inputSize *= vvScale(featureAttribute).xx;`)}

      vec2 combinedSize = inputSize * pixelRatio;
      vec4 quadOffset = vec4(0.0);
      bool visible = testHUDVisibility(posProj);
      voccluded = visible ? 0.0 : 1.0;
    `);const L=S.glsl`
      vec2 uv01 = floor(uv0);
      vec2 uv = uv0 - uv01;
      quadOffset.xy = (uv01 - anchorPosition) * 2.0 * combinedSize;

      ${S.If(e.hasRotation,S.glsl`
          float angle = radians(materialRotation + rotation);
          float cosAngle = cos(angle);
          float sinAngle = sin(angle);
          mat2 rotate = mat2(cosAngle, -sinAngle, sinAngle,  cosAngle);

          quadOffset.xy = rotate * quadOffset.xy;
        `)}

      quadOffset.xy = (quadOffset.xy + screenOffsetScaled) / viewport.zw * posProj.w;
  `,B=e.pixelSnappingEnabled?D?S.glsl`posProj = alignToPixelOrigin(posProj, viewport.zw) + quadOffset;`:S.glsl`posProj += quadOffset;
if (inputSize.x == size.x) {
posProj = alignToPixelOrigin(posProj, viewport.zw);
}`:S.glsl`posProj += quadOffset;`;$.main.add(S.glsl`
    ${S.If(e.occlusionTestEnabled,S.glsl`
      if (!visible) {
        vtc = vec2(0.0);
        ${S.If(e.debugDrawLabelBorder,"debugBorderCoords = vec4(0.5, 0.5, 1.5 / combinedSize);")}
        return;
      }`)}
    ${L}
    ${e.vvColor?"vcolor = interpolateVVColor(featureAttribute.y) * materialColor;":"vcolor = color / 255.0 * materialColor;"}

    ${S.If(e.output===a.ShaderOutput.ObjectAndLayerIdColor,S.glsl`vcolor.a = 1.0;`)}

    bool alphaDiscard = vcolor.a < ${S.glsl.float(p.alphaCutoff)};
    ${S.If(D,`alphaDiscard = alphaDiscard && outlineColor.a < ${S.glsl.float(p.alphaCutoff)};`)}
    if (alphaDiscard) {
      // "early discard" if both symbol color (= fill) and outline color (if applicable) are transparent
      gl_Position = vec4(1e38, 1e38, 1e38, 1.0);
      return;
    } else {
      ${B}
      gl_Position = posProj;
    }

    vtc = uv;

    ${S.If(e.debugDrawLabelBorder,S.glsl`debugBorderCoords = vec4(uv01, 1.5 / combinedSize);`)}
    vsize = inputSize;
  `),U.uniforms.add(new A.Texture2DPassUniform("tex",(e=>e.texture))),e.occludedFragmentFade&&(U.uniforms.add(new A.Texture2DPassUniform("depthMap",((e,o)=>o.mainDepth))),U.uniforms.add(new C.FloatPassUniform("fadeFactor",(()=>F.occludedFadeFactor))));const V=e.debugDrawLabelBorder?S.glsl`(isBorder > 0.0 ? 0.0 : ${S.glsl.float(p.alphaCutoff)})`:S.glsl.float(p.alphaCutoff),R=e.output===a.ShaderOutput.Highlight,E=S.glsl`
    ${S.If(e.debugDrawLabelBorder,S.glsl`float isBorder = float(any(lessThan(debugBorderCoords.xy, debugBorderCoords.zw)) || any(greaterThan(debugBorderCoords.xy, 1.0 - debugBorderCoords.zw)));`)}

    ${S.If(e.sampleSignedDistanceFieldTexelCenter,S.glsl`
      float txSize = float(textureSize(tex, 0).x);
      float texelSize = 1.0 / txSize;

      // Calculate how much we have to add/subtract to/from each texel to reach the size of an onscreen pixel
      vec2 scaleFactor = (vsize - txSize) * texelSize;
      vec2 samplePos = vtc + (vec2(1.0, -1.0) * texelSize) * scaleFactor;`,S.glsl`vec2 samplePos = vtc;`)}

    ${D?S.glsl`
      vec4 fillPixelColor = vcolor;

      // Get distance and map it into [-0.5, 0.5]
      float d = rgba2float(texture(tex, samplePos)) - 0.5;

      // Distance in output units (i.e. pixels)
      float dist = d * vsize.x;

      // Create smooth transition from the icon into its outline
      float fillAlphaFactor = clamp(0.5 - dist, 0.0, 1.0);
      fillPixelColor.a *= fillAlphaFactor;

      if (outlineSize > 0.25) {
        vec4 outlinePixelColor = outlineColor;
        float clampedOutlineSize = min(outlineSize, 0.5*vsize.x);

        // Create smooth transition around outline
        float outlineAlphaFactor = clamp(0.5 - (abs(dist) - 0.5*clampedOutlineSize), 0.0, 1.0);
        outlinePixelColor.a *= outlineAlphaFactor;

        if (
          outlineAlphaFactor + fillAlphaFactor < ${V} ||
          fillPixelColor.a + outlinePixelColor.a < ${S.glsl.float(p.alphaCutoff)}
        ) {
          discard;
        }

        // perform un-premultiplied over operator (see https://en.wikipedia.org/wiki/Alpha_compositing#Description)
        float compositeAlpha = outlinePixelColor.a + fillPixelColor.a * (1.0 - outlinePixelColor.a);
        vec3 compositeColor = vec3(outlinePixelColor) * outlinePixelColor.a +
          vec3(fillPixelColor) * fillPixelColor.a * (1.0 - outlinePixelColor.a);

        ${S.If(!R,S.glsl`fragColor = vec4(compositeColor, compositeAlpha);`)}
      } else {
        if (fillAlphaFactor < ${V}) {
          discard;
        }

        ${S.If(!R,S.glsl`fragColor = premultiplyAlpha(fillPixelColor);`)}
      }

      // visualize SDF:
      // fragColor = vec4(clamp(-dist/vsize.x*2.0, 0.0, 1.0), clamp(dist/vsize.x*2.0, 0.0, 1.0), 0.0, 1.0);
      `:S.glsl`
          vec4 texColor = texture(tex, vtc, -0.5);
          if (texColor.a < ${V}) {
            discard;
          }
          ${S.If(!R,S.glsl`fragColor = texColor * premultiplyAlpha(vcolor);`)}
          `}

    ${S.If(e.occludedFragmentFade&&!R,S.glsl`
        float zSample = texelFetch(depthMap, ivec2(gl_FragCoord.xy), 0).x;
        if (zSample < gl_FragCoord.z) {
          fragColor *= fadeFactor;
        }
        `)}

    ${S.If(!R&&e.debugDrawLabelBorder,S.glsl`fragColor = mix(fragColor, vec4(1.0, 0.0, 1.0, 1.0), isBorder * 0.5);`)}
  `;switch(e.output){case a.ShaderOutput.Color:e.oitPass===y.OITPass.ColorAlpha&&(l.outputs.add("fragColor","vec4",0),l.outputs.add("fragAlpha","float",1)),U.main.add(S.glsl`
        ${E}
        ${S.If(e.oitPass===y.OITPass.FrontFace,S.glsl`fragColor.rgb /= fragColor.a;`)}
        ${S.If(e.oitPass===y.OITPass.ColorAlpha,S.glsl`fragAlpha = fragColor.a;`)}`);break;case a.ShaderOutput.ObjectAndLayerIdColor:U.main.add(S.glsl`
        ${E}
        outputObjectAndLayerIdColor();`);break;case a.ShaderOutput.Highlight:l.include(g.OutputHighlight,e),U.main.add(S.glsl`
        ${E}
        outputHighlight(voccluded == 1.0);`)}return l}function j(e){return e.outlineColor[3]>0&&e.outlineSize>0}function I(e,l=T){return e.textureIsSignedDistanceField?$(e.anchorPosition,e.distanceFieldBoundingBox,l):o.copy(l,e.anchorPosition),l}function $(e,l,i){null!=l?o.set(i,e[0]*(l[2]-l[0])+l[0],e[1]*(l[3]-l[1])+l[1]):o.set(i,0,0)}const T=l.create(),U=Object.freeze(Object.defineProperty({__proto__:null,build:D,calculateAnchorPosForRendering:I,shaderSettings:F},Symbol.toStringTag,{value:"Module"}));e.HUDMaterial=U,e.build=D,e.calculateAnchorPosForRendering=I,e.shaderSettings=F}));
