/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../views/3d/webgl-engine/core/shaderLibrary/ScreenSpacePass.glsl","../views/3d/webgl-engine/core/shaderModules/interfaces","../views/3d/webgl-engine/core/shaderModules/ShaderBuilder","../views/3d/webgl-engine/core/shaderModules/Texture2DDrawUniform"],(function(e,r,i,t,n){"use strict";class l extends i.NoParameters{}function o(){const e=new t.ShaderBuilder,{outputs:l,fragment:o}=e;return e.include(r.ScreenSpacePass),o.uniforms.add(new n.Texture2DDrawUniform("textureInput",(e=>e.input))),o.constants.add("outlineWidth","int",Math.ceil(u)),o.constants.add("cellSize","int",a),l.add("fragGrid","vec2"),o.main.add(i.glsl`vec2 inputTextureSize = vec2(textureSize(textureInput, 0));
vec2 cellBottomLeftCornerInput = floor(gl_FragCoord.xy) * vec2(cellSize);
vec2 coordMid =  (cellBottomLeftCornerInput + 0.5 * vec2(cellSize)) / inputTextureSize;
vec2 commonValue = texture(textureInput, coordMid).rg;
int margin = outlineWidth;
float marginSquare = float(margin*margin);
for(int y = -margin; y <= cellSize + margin; y+=2) {
int dy = y < 0 ? -y : y > cellSize ? y-cellSize : 0;
int xMargin = dy > 0 ? int(ceil(sqrt(marginSquare - float(dy*dy)))) : margin;
for(int x = -xMargin; x <= cellSize + xMargin; x+=2) {
vec2 coord = (cellBottomLeftCornerInput + vec2(x, y)) / inputTextureSize;
vec2 value = texture(textureInput, coord).rg;
if (value != commonValue){
fragGrid = vec2(1.0, 1.0);
return;
}
}
}
bool hasAny = commonValue != vec2(0.0);
fragGrid = vec2(hasAny ? 1.0 : 0.0, 0.0);`),e}const a=32,u=9,c=.4,d=Object.freeze(Object.defineProperty({__proto__:null,HighlightDownsampleDrawParameters:l,blurSize:c,build:o,gridCellPixelSize:a,outlineSize:u},Symbol.toStringTag,{value:"Module"}));e.HighlightDownsample=d,e.HighlightDownsampleDrawParameters=l,e.blurSize=c,e.build=o,e.gridCellPixelSize=a,e.outlineSize=u}));
