/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../views/3d/webgl-engine/core/shaderLibrary/ShaderOutput","../views/3d/webgl-engine/core/shaderLibrary/Slice.glsl","../views/3d/webgl-engine/core/shaderLibrary/Transform.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/ObjectAndLayerIdColor.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/TerrainDepthTest.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/ColorConversion.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/View.glsl","../views/3d/webgl-engine/core/shaderModules/FloatPassUniform","../views/3d/webgl-engine/core/shaderModules/interfaces","../views/3d/webgl-engine/core/shaderModules/ShaderBuilder","../views/3d/webgl-engine/core/shaderModules/Texture2DPassUniform","../views/3d/webgl-engine/lib/VertexAttribute","../views/3d/webgl-engine/shaders/OutputColorHighlightOID.glsl"],(function(e,r,i,t,o,n,s,d,l,a,g,u,c,v){"use strict";function b(e){const b=new g.ShaderBuilder,{vertex:p,fragment:w}=b;return d.addProjViewLocalOrigin(p,e),b.include(t.Transform,e),b.include(n.terrainDepthTest,e),b.include(i.SliceDraw,e),b.include(o.ObjectAndLayerIdColor,e),b.include(v.outputColorHighlightOID,e),b.attributes.add(c.VertexAttribute.POSITION,"vec3"),b.attributes.add(c.VertexAttribute.UV0,"vec2"),e.perspectiveInterpolation&&b.attributes.add(c.VertexAttribute.PERSPECTIVEDIVIDE,"float"),b.varyings.add("vpos","vec3"),e.terrainDepthTest&&b.varyings.add("depth","float"),p.main.add(a.glsl`
    vpos = position;
    ${e.terrainDepthTest?"depth = (view * vec4(vpos, 1.0)).z;":""}
    vTexCoord = uv0;
    gl_Position = transformPosition(proj, view, vpos);
    ${e.perspectiveInterpolation?"gl_Position *= perspectiveDivide;":""}`),w.uniforms.add(new u.Texture2DPassUniform("tex",(e=>e.texture)),new l.FloatPassUniform("opacity",(e=>e.opacity))),b.varyings.add("vTexCoord","vec2"),w.include(s.ColorConversion),w.main.add(a.glsl`
    discardBySlice(vpos);
    ${e.terrainDepthTest?"terrainDepthTest(depth);":""}
    ${e.output===r.ShaderOutput.ObjectAndLayerIdColor?"fragColor = vec4(0, 0, 0, 1);\n           return;":""}
    vec4 finalColor = texture(tex, vTexCoord) * opacity;
    outputColorHighlightOID(finalColor, vpos);`),b}const p=Object.freeze(Object.defineProperty({__proto__:null,build:b},Symbol.toStringTag,{value:"Module"}));e.ImageMaterial=p,e.build=b}));
