/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../views/3d/webgl-engine/core/shaderLibrary/ForwardLinearDepth.glsl","../views/3d/webgl-engine/core/shaderLibrary/ShaderOutput","../views/3d/webgl-engine/core/shaderLibrary/Slice.glsl","../views/3d/webgl-engine/core/shaderLibrary/Transform.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/ObjectAndLayerIdColor.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/PathVertexPosition.glsl","../views/3d/webgl-engine/core/shaderLibrary/output/OutputDepth.glsl","../views/3d/webgl-engine/core/shaderLibrary/output/OutputHighlight.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/EvaluateAmbientOcclusion.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/EvaluateSceneLighting.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/MainLighting.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/Normals.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/NormalUtils.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/PhysicallyBasedRenderingParameters.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/ReadShadowMap.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/TerrainDepthTest.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/ColorConversion.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/View.glsl","../views/3d/webgl-engine/core/shaderModules/Float3PassUniform","../views/3d/webgl-engine/core/shaderModules/FloatPassUniform","../views/3d/webgl-engine/core/shaderModules/interfaces","../views/3d/webgl-engine/core/shaderModules/ShaderBuilder","../views/3d/webgl-engine/shaders/OutputColorHighlightOID.glsl"],(function(e,a,i,r,o,l,n,d,s,t,c,g,h,u,m,v,p,w,b,y,f,S,L,P){"use strict";function O(e){const O=new L.ShaderBuilder,{vertex:D,fragment:C}=O;b.addProjViewLocalOrigin(D,e),O.varyings.add("vpos","vec3"),O.include(n.PathVertexPosition,e);const{output:A,spherical:F,pbrMode:I,receiveShadows:B}=e,j=i.isColorOrColorEmission(A);switch((j||A===i.ShaderOutput.ObjectAndLayerIdColor)&&(O.include(o.Transform,e),O.include(v.ReadShadowMapDraw,e),O.include(a.ForwardLinearDepth,e),O.include(l.ObjectAndLayerIdColor,e),O.varyings.add("vnormal","vec3"),O.varyings.add("vcolor","vec4"),e.terrainDepthTest&&O.varyings.add("depth","float"),D.main.add(S.glsl`
      vpos = calculateVPos();
      vnormal = normalize(localNormal());

      ${e.terrainDepthTest?"depth = (view * vec4(vpos, 1.0)).z;":""}
      gl_Position = transformPosition(proj, view, vpos);

      ${j?"forwardLinearDepth();":""}
      forwardObjectAndLayerIdColor();

      vcolor = getColor();`)),O.include(p.terrainDepthTest,e),A){case i.ShaderOutput.ColorEmission:case i.ShaderOutput.Color:O.include(m.PhysicallyBasedRenderingParameters,e),O.include(c.EvaluateSceneLighting,e),O.include(t.EvaluateAmbientOcclusion,e),O.include(v.ReadShadowMapDraw,e),O.include(h.Normals,e),O.include(r.SliceDraw,e),O.include(P.outputColorHighlightOID,e),b.addCameraPosition(C,e),c.addAmbientBoostFactor(C),c.addLightingGlobalFactor(C),C.uniforms.add(D.uniforms.get("localOrigin"),new y.Float3PassUniform("ambient",(e=>e.ambient)),new y.Float3PassUniform("diffuse",(e=>e.diffuse)),new y.Float3PassUniform("specular",(e=>e.specular)),new f.FloatPassUniform("opacity",(e=>e.opacity))),C.include(w.ColorConversion),g.addMainLightIntensity(C),C.main.add(S.glsl`
        discardBySlice(vpos);
        ${e.terrainDepthTest?S.glsl`terrainDepthTest(depth);`:""}

        shadingParams.viewDirection = normalize(vpos - cameraPosition);
        shadingParams.normalView = vnormal;
        vec3 normal = shadingNormal(shadingParams);
        float ssao = evaluateAmbientOcclusionInverse();

        vec3 posWorld = vpos + localOrigin;
        vec3 normalGround = ${F?"normalize(posWorld);":"vec3(0.0, 0.0, 1.0);"}

        float additionalAmbientScale = additionalDirectedAmbientLight(posWorld);
        vec3 additionalLight = ssao * mainLightIntensity * additionalAmbientScale * ambientBoostFactor * lightingGlobalFactor;
        float shadow = ${B?"max(lightingGlobalFactor * (1.0 - additionalAmbientScale), readShadowMap(vpos, linearDepth));":F?"lightingGlobalFactor * (1.0 - additionalAmbientScale);":"0.0;"}
        vec3 albedo = vcolor.rgb * max(ambient, diffuse); // combine the old material parameters into a single one
        float combinedOpacity = vcolor.a * opacity;
        albedo += 0.25 * specular; // don't completely ignore specular for now

        ${S.If(I===m.PBRMode.Schematic,"float additionalAmbientIrradiance = additionalAmbientIrradianceFactor * mainLightIntensity[2];\n           vec4 emission = getEmissions();")}

        vec3 shadedColor = ${I===m.PBRMode.Schematic?"evaluateSceneLightingPBR(normal, albedo, shadow, 1.0 - ssao, additionalLight, shadingParams.viewDirection, normalGround, mrr, emission, additionalAmbientIrradiance);":"evaluateSceneLighting(normal, albedo, shadow, 1.0 - ssao, additionalLight);"}
        vec4 finalColor = vec4(shadedColor, combinedOpacity);
        outputColorHighlightOID(finalColor, vpos);`);break;case i.ShaderOutput.Depth:O.include(o.Transform,e),D.main.add(S.glsl`vpos = calculateVPos();
gl_Position = transformPosition(proj, view, vpos);`),O.include(r.SliceDraw,e),C.main.add(S.glsl`discardBySlice(vpos);`);break;case i.ShaderOutput.Shadow:case i.ShaderOutput.ShadowHighlight:case i.ShaderOutput.ShadowExcludeHighlight:case i.ShaderOutput.ViewshedShadow:O.include(o.Transform,e),a.addNearFar(O),O.varyings.add("depth","float"),D.main.add(S.glsl`vpos = calculateVPos();
gl_Position = transformPositionWithDepth(proj, view, vpos, nearFar, depth);`),O.include(r.SliceDraw,e),O.include(d.OutputDepth,e),C.main.add(S.glsl`discardBySlice(vpos);
outputDepth(depth);`);break;case i.ShaderOutput.ObjectAndLayerIdColor:O.include(r.SliceDraw,e),C.main.add(S.glsl`discardBySlice(vpos);
outputObjectAndLayerIdColor();`);break;case i.ShaderOutput.Normal:O.include(o.Transform,e),O.include(u.NormalUtils,e),b.addViewNormal(D),O.varyings.add("vnormal","vec3"),D.main.add(S.glsl`vpos = calculateVPos();
vnormal = normalize((viewNormal * vec4(localNormal(), 1.0)).xyz);
gl_Position = transformPosition(proj, view, vpos);`),O.include(r.SliceDraw,e),C.main.add(S.glsl`discardBySlice(vpos);
vec3 normal = normalize(vnormal);
if (gl_FrontFacing == false) normal = -normal;
fragColor = vec4(vec3(0.5) + 0.5 * normal, 1.0);`);break;case i.ShaderOutput.Highlight:O.include(o.Transform,e),O.include(u.NormalUtils,e),O.varyings.add("vnormal","vec3"),D.main.add(S.glsl`vpos = calculateVPos();
gl_Position = transformPosition(proj, view, vpos);`),O.include(r.SliceDraw,e),O.include(s.OutputHighlight,e),C.main.add(S.glsl`discardBySlice(vpos);
calculateOcclusionAndOutputHighlight();`)}return O}const D=Object.freeze(Object.defineProperty({__proto__:null,build:O},Symbol.toStringTag,{value:"Module"}));e.Path=D,e.build=O}));
