/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../views/3d/webgl-engine/core/shaderLibrary/ShaderOutput","../views/3d/webgl-engine/core/shaderLibrary/Slice.glsl","../views/3d/webgl-engine/core/shaderLibrary/Transform.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/ObjectAndLayerIdColor.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/VertexColor.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/TerrainDepthTest.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/VisualVariables.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/ColorConversion.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/View.glsl","../views/3d/webgl-engine/core/shaderModules/Float4PassUniform","../views/3d/webgl-engine/core/shaderModules/FloatPassUniform","../views/3d/webgl-engine/core/shaderModules/interfaces","../views/3d/webgl-engine/core/shaderModules/ShaderBuilder","../views/3d/webgl-engine/lib/VertexAttribute","../views/3d/webgl-engine/materials/PatternStyle","../views/3d/webgl-engine/shaders/OutputColorHighlightOID.glsl"],(function(e,o,t,a,l,r,i,n,d,c,s,g,v,u,p,f,m){"use strict";const w=.70710678118,h=w,b=.08715574274,y=10,S=1;function C(e){const C=new u.ShaderBuilder,{vertex:P,fragment:T,attributes:V,varyings:R}=C,D=e.terrainDepthTest&&e.output===o.ShaderOutput.Color,j=e.output===o.ShaderOutput.Highlight;c.addProjViewLocalOrigin(P,e),C.include(a.Transform,e),C.include(r.VertexColor,e),C.include(n.VisualVariables,e),C.include(l.ObjectAndLayerIdColor,e),C.include(t.SliceDraw,e),C.include(m.outputColorHighlightOID,e),e.draped?P.uniforms.add(new g.FloatPassUniform("worldToScreenRatio",((e,o)=>1/o.screenToPCSRatio))):V.add(p.VertexAttribute.BOUNDINGRECT,"mat3"),V.add(p.VertexAttribute.POSITION,"vec3"),V.add(p.VertexAttribute.UVMAPSPACE,"vec4"),e.vvColor&&V.add(p.VertexAttribute.COLORFEATUREATTRIBUTE,"float"),R.add("vColor","vec4"),R.add("vpos","vec3"),R.add("vuv","vec2"),D&&R.add("depth","float"),P.uniforms.add(new s.Float4PassUniform("uColor",(e=>e.color)));const O=e.style===f.Style.ForwardDiagonal||e.style===f.Style.BackwardDiagonal||e.style===f.Style.DiagonalCross;return O&&P.code.add(v.glsl`
      const mat2 rotate45 = mat2(${v.glsl.float(w)}, ${v.glsl.float(-h)},
                                 ${v.glsl.float(h)}, ${v.glsl.float(w)});
    `),e.draped||(c.addCameraPosition(P,e),P.uniforms.add(new g.FloatPassUniform("worldToScreenPerDistanceRatio",((e,o)=>1/o.camera.perScreenPixelRatio))),P.code.add(v.glsl`vec3 projectPointToLineSegment(vec3 center, vec3 halfVector, vec3 point) {
float projectedLength = dot(halfVector, point - center) / dot(halfVector, halfVector);
return center + halfVector * clamp(projectedLength, -1.0, 1.0);
}`),P.code.add(v.glsl`vec3 intersectRayPlane(vec3 rayDir, vec3 rayOrigin, vec3 planeNormal, vec3 planePoint) {
float d = dot(planeNormal, planePoint);
float t = (d - dot(planeNormal, rayOrigin)) / dot(planeNormal, rayDir);
return rayOrigin + t * rayDir;
}`),P.code.add(v.glsl`
      float boundingRectDistanceToCamera() {
        vec3 center = vec3(boundingRect[0][0], boundingRect[0][1], boundingRect[0][2]);
        vec3 halfU = vec3(boundingRect[1][0], boundingRect[1][1], boundingRect[1][2]);
        vec3 halfV = vec3(boundingRect[2][0], boundingRect[2][1], boundingRect[2][2]);
        vec3 n = normalize(cross(halfU, halfV));

        vec3 viewDir = - vec3(view[0][2], view[1][2], view[2][2]);

        float viewAngle = dot(viewDir, n);
        float minViewAngle = ${v.glsl.float(b)};

        if (abs(viewAngle) < minViewAngle) {
          // view direction is (almost) parallel to plane -> clamp it to min angle
          float normalComponent = sign(viewAngle) * minViewAngle - viewAngle;
          viewDir = normalize(viewDir + normalComponent * n);
        }

        // intersect view direction with infinite plane that contains bounding rect
        vec3 planeProjected = intersectRayPlane(viewDir, cameraPosition, n, center);

        // clip to bounds by projecting to u and v line segments individually
        vec3 uProjected = projectPointToLineSegment(center, halfU, planeProjected);
        vec3 vProjected = projectPointToLineSegment(center, halfV, planeProjected);

        // use to calculate the closest point to camera on bounding rect
        vec3 closestPoint = uProjected + vProjected - center;

        return length(closestPoint - cameraPosition);
      }
    `)),P.code.add(v.glsl`
    vec2 scaledUV() {
      vec2 uv = uvMapSpace.xy ${O?" * rotate45":""};
      vec2 uvCellOrigin = uvMapSpace.zw ${O?" * rotate45":""};

      ${e.draped?"":v.glsl`
            float distanceToCamera = boundingRectDistanceToCamera();
            float worldToScreenRatio = worldToScreenPerDistanceRatio / distanceToCamera;
          `}

      // Logarithmically discretize ratio to avoid jittering
      float step = 0.1;
      float discreteWorldToScreenRatio = log(worldToScreenRatio);
      discreteWorldToScreenRatio = ceil(discreteWorldToScreenRatio / step) * step;
      discreteWorldToScreenRatio = exp(discreteWorldToScreenRatio);

      vec2 uvOffset = mod(uvCellOrigin * discreteWorldToScreenRatio, ${v.glsl.float(y)});
      return uvOffset + (uv * discreteWorldToScreenRatio);
    }
  `),P.main.add(v.glsl`
    vuv = scaledUV();
    vpos = position;
    ${D?"depth = (view * vec4(vpos, 1.0)).z;":""}
    forwardNormalizedVertexColor();
    forwardObjectAndLayerIdColor();
    ${e.hasVertexColors?"vColor *= uColor;":e.vvColor?"vColor = uColor * interpolateVVColor(colorFeatureAttribute);":"vColor = uColor;"}
    gl_Position = transformPosition(proj, view, vpos);
  `),T.include(d.ColorConversion),e.draped&&T.uniforms.add(new g.FloatPassUniform("texelSize",((e,o)=>1/o.camera.pixelRatio))),D&&C.include(i.terrainDepthTest,e),j||(T.code.add(v.glsl`
      const float lineWidth = ${v.glsl.float(S)};
      const float spacing = ${v.glsl.float(y)};
      const float spacingINV = ${v.glsl.float(1/y)};

      float coverage(float p, float txlSize) {
        p = mod(p, spacing);

        float halfTxlSize = txlSize / 2.0;

        float start = p - halfTxlSize;
        float end = p + halfTxlSize;

        float coverage = (ceil(end * spacingINV) - floor(start * spacingINV)) * lineWidth;
        coverage -= min(lineWidth, mod(start, spacing));
        coverage -= max(lineWidth - mod(end, spacing), 0.0);

        return coverage / txlSize;
      }
    `),e.draped||T.code.add(v.glsl`const int maxSamples = 5;
float sampleAA(float p) {
vec2 dxdy = abs(vec2(dFdx(p), dFdy(p)));
float fwidth = dxdy.x + dxdy.y;
ivec2 samples = 1 + ivec2(clamp(dxdy, 0.0, float(maxSamples - 1)));
vec2 invSamples = 1.0 / vec2(samples);
float accumulator = 0.0;
for (int j = 0; j < maxSamples; j++) {
if(j >= samples.y) {
break;
}
for (int i = 0; i < maxSamples; i++) {
if(i >= samples.x) {
break;
}
vec2 step = vec2(i,j) * invSamples - 0.5;
accumulator += coverage(p + step.x * dxdy.x + step.y * dxdy.y, fwidth);
}
}
accumulator /= float(samples.x * samples.y);
return accumulator;
}`)),T.main.add(v.glsl`
    discardBySlice(vpos);
    ${D?"terrainDepthTest(depth);":""}
    vec4 color = vColor;
    ${j?"":v.glsl`color.a *= ${x(e)};`}
    outputColorHighlightOID(color, vpos);
  `),C}function x(e){function o(o){return e.draped?v.glsl`coverage(vuv.${o}, texelSize)`:v.glsl`sampleAA(vuv.${o})`}switch(e.style){case f.Style.ForwardDiagonal:case f.Style.Horizontal:return o("y");case f.Style.BackwardDiagonal:case f.Style.Vertical:return o("x");case f.Style.DiagonalCross:case f.Style.Cross:return v.glsl`1.0 - (1.0 - ${o("x")}) * (1.0 - ${o("y")})`;default:return"0.0"}}const P=Object.freeze(Object.defineProperty({__proto__:null,build:C},Symbol.toStringTag,{value:"Module"}));e.Pattern=P,e.build=C}));
