/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../views/3d/webgl-engine/core/shaderLibrary/ForwardLinearDepth.glsl","../views/3d/webgl-engine/core/shaderLibrary/Offset.glsl","../views/3d/webgl-engine/core/shaderLibrary/ShaderOutput","../views/3d/webgl-engine/core/shaderLibrary/Slice.glsl","../views/3d/webgl-engine/core/shaderLibrary/Transform.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/InstancedDoublePrecision.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/NormalAttribute.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/PositionAttribute.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/SymbolColor.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/TextureCoordinateAttribute.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/VertexColor.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/VerticalOffset.glsl","../views/3d/webgl-engine/core/shaderLibrary/default/DefaultMaterialAuxiliaryPasses.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/EvaluateAmbientOcclusion.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/EvaluateSceneLighting.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/MainLighting.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/PhysicallyBasedRendering.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/PhysicallyBasedRenderingParameters.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/ReadShadowMap.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/TerrainDepthTest.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/VisualVariables.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/AlphaCutoff","../views/3d/webgl-engine/core/shaderLibrary/util/DiscardOrAdjustAlpha.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/MixExternalColor.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/View.glsl","../views/3d/webgl-engine/core/shaderModules/Float3PassUniform","../views/3d/webgl-engine/core/shaderModules/Float4PassUniform","../views/3d/webgl-engine/core/shaderModules/FloatPassUniform","../views/3d/webgl-engine/core/shaderModules/interfaces","../views/3d/webgl-engine/core/shaderModules/ShaderBuilder","../views/3d/webgl-engine/core/shaderModules/Texture2DPassUniform","../views/3d/webgl-engine/lib/VertexAttribute","../views/3d/webgl-engine/shaders/OutputColorHighlightOID.glsl"],(function(e,i,a,r,o,l,t,n,s,d,c,g,v,b,u,h,w,m,f,p,x,y,C,L,P,O,M,A,D,S,F,I,E,T){"use strict";function V(e){const V=new F.ShaderBuilder,{vertex:$,fragment:B,varyings:N}=V,{output:R,offsetBackfaces:U,instancedColor:_,pbrMode:j,snowCover:z,spherical:G}=e,k=j===f.PBRMode.Normal||j===f.PBRMode.Schematic;if(O.addProjViewLocalOrigin($,e),V.include(s.PositionAttribute),N.add("vpos","vec3"),V.include(y.VisualVariables,e),V.include(t.InstancedDoublePrecision,e),V.include(v.VerticalOffset,e),R===r.ShaderOutput.Color&&(O.addCameraPosition(V.vertex,e),V.include(n.NormalAttribute,e),V.include(l.Transform,e),U&&V.include(a.Offset),_&&V.attributes.add(E.VertexAttribute.INSTANCECOLOR,"vec4"),N.add("vNormalWorld","vec3"),N.add("localvpos","vec3"),e.terrainDepthTest&&N.add("depth","float"),V.include(c.TextureCoordinateAttribute,e),V.include(i.ForwardLinearDepth,e),V.include(d.SymbolColor,e),V.include(g.VertexColor,e),$.uniforms.add(new A.Float4PassUniform("externalColor",(e=>e.externalColor))),N.add("vcolorExt","vec4"),$.main.add(S.glsl`
      forwardNormalizedVertexColor();
      vcolorExt = externalColor;
      ${S.If(_,"vcolorExt *= instanceColor * 0.003921568627451;")}
      vcolorExt *= vvColor();
      vcolorExt *= getSymbolColor();
      forwardColorMixMode();

      if (vcolorExt.a < ${S.glsl.float(C.alphaCutoff)}) {
        gl_Position = vec4(1e38, 1e38, 1e38, 1.0);
      } else {
        vpos = getVertexInLocalOriginSpace();
        localvpos = vpos - view[3].xyz;
        vpos = subtractOrigin(vpos);
        vNormalWorld = dpNormal(vvLocalNormal(normalModel()));
        vpos = addVerticalOffset(vpos, localOrigin);
        gl_Position = transformPosition(proj, view, vpos);
        ${S.If(U,"gl_Position = offsetBackfacingClipPosition(gl_Position, vpos, vNormalWorld, cameraPosition);")}
      }
      ${S.If(e.terrainDepthTest,"depth = (view * vec4(vpos, 1.0)).z;")}
      forwardLinearDepth();
      forwardTextureCoordinates();`)),R===r.ShaderOutput.Color){const{hasColorTexture:i,hasColorTextureTransform:a,receiveShadows:r}=e;V.include(h.EvaluateSceneLighting,e),V.include(u.EvaluateAmbientOcclusion,e),V.include(L.DiscardOrAdjustAlphaPass,e),V.include(e.instancedDoublePrecision?p.ReadShadowMapPass:p.ReadShadowMapDraw,e),V.include(x.terrainDepthTest,e),V.include(o.SliceDraw,e),V.include(T.outputColorHighlightOID,e),O.addCameraPosition(V.fragment,e),w.addMainLightDirection(B),h.addAmbientBoostFactor(B),h.addLightingGlobalFactor(B),B.uniforms.add($.uniforms.get("localOrigin"),$.uniforms.get("view"),new M.Float3PassUniform("ambient",(e=>e.ambient)),new M.Float3PassUniform("diffuse",(e=>e.diffuse)),new D.FloatPassUniform("opacity",(e=>e.opacity)),new D.FloatPassUniform("layerOpacity",(e=>e.layerOpacity))),i&&B.uniforms.add(new I.Texture2DPassUniform("tex",(e=>e.texture))),V.include(f.PhysicallyBasedRenderingParameters,e),V.include(m.PhysicallyBasedRendering,e),B.include(P.MixExternalColor),w.addMainLightIntensity(B),B.main.add(S.glsl`
      discardBySlice(vpos);
      ${S.If(e.terrainDepthTest,"terrainDepthTest(depth);")}
      vec4 texColor = ${i?`texture(tex, ${a?"colorUV":"vuv0"})`:" vec4(1.0)"};
      ${S.If(i,`${S.If(e.textureAlphaPremultiplied,"texColor.rgb /= texColor.a;")}\n        discardOrAdjustAlpha(texColor);`)}
      vec3 viewDirection = normalize(vpos - cameraPosition);
      applyPBRFactors();
      float ssao = evaluateAmbientOcclusionInverse();
      ssao *= getBakedOcclusion();

      float additionalAmbientScale = additionalDirectedAmbientLight(vpos + localOrigin);
      vec3 additionalLight = ssao * mainLightIntensity * additionalAmbientScale * ambientBoostFactor * lightingGlobalFactor;
      float shadow = ${r?"max(lightingGlobalFactor * (1.0 - additionalAmbientScale), readShadowMap(vpos, linearDepth))":G?"lightingGlobalFactor * (1.0 - additionalAmbientScale)":"0.0"};
      vec3 matColor = max(ambient, diffuse);
      ${e.hasVertexColors?S.glsl`vec3 albedo = mixExternalColor(vColor.rgb * matColor, texColor.rgb, vcolorExt.rgb, int(colorMixMode));
             float opacity_ = layerOpacity * mixExternalOpacity(vColor.a * opacity, texColor.a, vcolorExt.a, int(colorMixMode));`:S.glsl`vec3 albedo = mixExternalColor(matColor, texColor.rgb, vcolorExt.rgb, int(colorMixMode));
             float opacity_ = layerOpacity * mixExternalOpacity(opacity, texColor.a, vcolorExt.a, int(colorMixMode));`}
      ${S.If(z,"albedo = mix(albedo, vec3(1), 0.9);")}
      ${S.glsl`vec3 shadingNormal = normalize(vNormalWorld);
             albedo *= 1.2;
             vec3 viewForward = vec3(view[0][2], view[1][2], view[2][2]);
             float alignmentLightView = clamp(dot(viewForward, -mainLightDirection), 0.0, 1.0);
             float transmittance = 1.0 - clamp(dot(viewForward, shadingNormal), 0.0, 1.0);
             float treeRadialFalloff = vColor.r;
             float backLightFactor = 0.5 * treeRadialFalloff * alignmentLightView * transmittance * (1.0 - shadow);
             additionalLight += backLightFactor * mainLightIntensity;`}
      ${S.If(k,`vec3 normalGround = ${G?"normalize(vpos + localOrigin)":"vec3(0.0, 0.0, 1.0)"};`)}
      ${k?S.glsl`float additionalAmbientIrradiance = additionalAmbientIrradianceFactor * mainLightIntensity[2];
                 ${S.If(z,S.glsl`mrr = vec3(0.0, 1.0, 0.04);`)}
            vec4 emission = ${z?"vec4(0.0)":"getEmissions()"};
            vec3 shadedColor = evaluateSceneLightingPBR(shadingNormal, albedo, shadow, 1.0 - ssao, additionalLight, viewDirection, normalGround, mrr, emission, additionalAmbientIrradiance);`:S.glsl`vec3 shadedColor = evaluateSceneLighting(shadingNormal, albedo, shadow, 1.0 - ssao, additionalLight);`}
      vec4 finalColor = vec4(shadedColor, opacity_);
      outputColorHighlightOID(finalColor, vpos);`)}return V.include(b.DefaultMaterialAuxiliaryPasses,e),V}const $=Object.freeze(Object.defineProperty({__proto__:null,build:V},Symbol.toStringTag,{value:"Module"}));e.RealisticTree=$,e.build=V}));
