/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../core/libs/gl-matrix-2/factories/vec4f64","../views/3d/webgl-engine/core/shaderLibrary/ScreenSizeScaling.glsl","../views/3d/webgl-engine/core/shaderLibrary/ShaderOutput","../views/3d/webgl-engine/core/shaderLibrary/Slice.glsl","../views/3d/webgl-engine/core/shaderLibrary/Transform.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/TerrainDepthTest.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/ColorConversion.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/View.glsl","../views/3d/webgl-engine/core/shaderModules/Float3PassUniform","../views/3d/webgl-engine/core/shaderModules/Float4PassUniform","../views/3d/webgl-engine/core/shaderModules/interfaces","../views/3d/webgl-engine/core/shaderModules/ShaderBuilder","../views/3d/webgl-engine/lib/VertexAttribute","../views/3d/webgl-engine/shaders/OutputColorHighlightOID.glsl"],(function(e,i,r,o,l,n,a,s,d,t,g,c,u,v,w){"use strict";function h(e){const i=new u.ShaderBuilder,h=e.terrainDepthTest&&e.output===o.ShaderOutput.Color;i.include(n.Transform,e),i.include(r.ScreenSizeScaling,e),i.include(l.SliceDraw,e),i.include(w.outputColorHighlightOID,e);const{vertex:m,fragment:f}=i;return f.include(s.ColorConversion),d.addProjViewLocalOrigin(m,e),f.uniforms.add(new g.Float4PassUniform("uColor",(e=>e.color))),i.attributes.add(v.VertexAttribute.POSITION,"vec3"),i.varyings.add("vWorldPosition","vec3"),h&&i.varyings.add("depth","float"),e.screenSizeEnabled&&i.attributes.add(v.VertexAttribute.OFFSET,"vec3"),e.shadingEnabled&&(d.addViewNormal(m),i.attributes.add(v.VertexAttribute.NORMAL,"vec3"),i.varyings.add("vViewNormal","vec3"),f.uniforms.add(new t.Float3PassUniform("shadingDirection",(e=>e.shadingDirection))),f.uniforms.add(new g.Float4PassUniform("shadedColor",(e=>b(e.shadingTint,e.color))))),m.main.add(c.glsl`
      vWorldPosition = ${e.screenSizeEnabled?c.glsl`screenSizeScaling(offset, position)`:c.glsl`position`};
      ${e.shadingEnabled?c.glsl`vec3 worldNormal = normal;
                 vViewNormal = (viewNormal * vec4(worldNormal, 1)).xyz;`:""}
      ${h?c.glsl`depth = (view * vec4(vWorldPosition, 1.0)).z;`:""}
      gl_Position = transformPosition(proj, view, vWorldPosition);
  `),h&&i.include(a.terrainDepthTest,e),f.main.add(c.glsl`
      discardBySlice(vWorldPosition);
      ${h?c.glsl`terrainDepthTest(depth);`:""}
      ${e.shadingEnabled?c.glsl`vec3 viewNormalNorm = normalize(vViewNormal);
             float shadingFactor = 1.0 - clamp(-dot(viewNormalNorm, shadingDirection), 0.0, 1.0);
             vec4 finalColor = mix(uColor, shadedColor, shadingFactor);`:c.glsl`vec4 finalColor = uColor;`}
      outputColorHighlightOID(finalColor, vWorldPosition);`),i}function b(e,i){const r=1-e[3],o=e[3]+i[3]*r;return 0===o?(m[3]=o,m):(m[0]=(e[0]*e[3]+i[0]*i[3]*r)/o,m[1]=(e[1]*e[3]+i[1]*i[3]*r)/o,m[2]=(e[2]*e[3]+i[2]*i[3]*r)/o,m[3]=i[3],m)}const m=i.create(),f=Object.freeze(Object.defineProperty({__proto__:null,build:h},Symbol.toStringTag,{value:"Module"}));e.ShadedColorMaterial=f,e.build=h}));
