/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../core/libs/gl-matrix-2/math/mat4","../core/libs/gl-matrix-2/factories/mat4f64","../views/3d/webgl-engine/core/shaderLibrary/ScreenSpacePass.glsl","../views/3d/webgl-engine/core/shaderLibrary/output/ReadDepth.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/ReadShadowMap.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/CameraSpace.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/RgbaFloatEncoding.glsl","../views/3d/webgl-engine/core/shaderModules/interfaces","../views/3d/webgl-engine/core/shaderModules/Matrix4PassUniform","../views/3d/webgl-engine/core/shaderModules/ShaderBuilder","../views/3d/webgl-engine/core/shaderModules/Texture2DPassUniform","../views/3d/webgl-engine/shaders/ReadShadowMapConfiguration"],(function(e,a,r,t,i,s,o,d,n,l,c,h,p){"use strict";const u=255,w=1/u;function g(){const e=new c.ShaderBuilder,r=e.fragment;return r.include(d.RgbaFloatEncoding),r.include(i.ReadDepth),e.include(o.CameraSpace),e.include(t.ScreenSpacePass),e.include(s.ReadShadowMapPass,x),r.uniforms.add(new h.Texture2DPassUniform("shadowMap",((e,a)=>a.shadowMap.depthTexture)),new h.Texture2DPassUniform("depthMap",((e,a)=>a.depth?.attachment)),new l.Matrix4PassUniform("inverseViewMatrix",((e,r)=>a.invert(v,a.translate(v,r.camera.viewMatrix,r.camera.center))))),r.constants.add("sampleValue","float",w),e.outputs.add("sampleCount","float"),r.main.add(n.glsl`sampleCount = 0.0;
float depth = depthFromTexture(depthMap, uv);
if (depth >= 1.0 || depth <= 0.0) {
return;
}
float currentPixelDepth = linearizeDepth(depth);
vec4 currentPixelPos = vec4(reconstructPosition(gl_FragCoord.xy, currentPixelDepth), 1.0);
vec4 worldSpacePos = inverseViewMatrix * currentPixelPos;
mat4 shadowMatrix;
float linearDepth = -currentPixelDepth;
int i = chooseCascade(linearDepth, shadowMatrix);
if (i >= numCascades) {
return;
}
vec3 lvpos = lightSpacePosition(worldSpacePos.xyz, shadowMatrix);
if (lvpos.z >= 1.0 || lvpos.x < 0.0 || lvpos.x > 1.0 || lvpos.y < 0.0 || lvpos.y > 1.0) {
return;
}
ivec2 texSize = textureSize(shadowMap, 0);
ivec2 uvShadow = ivec2(cascadeCoordinates(i, texSize, lvpos) * vec2(texSize));
float depthShadow = readShadowMapDepth(uvShadow, shadowMap);
bool shadow = depthShadow < lvpos.z;
if (shadow) {
sampleCount = sampleValue;
}`),e}const v=r.create(),x=new p.ReadShadowMapConfiguration,S=Object.freeze(Object.defineProperty({__proto__:null,ShadowCastMaxSamples:u,build:g},Symbol.toStringTag,{value:"Module"}));e.ShadowCastAccumulate=S,e.ShadowCastMaxSamples=u,e.build=g}));
