/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../core/libs/gl-matrix-2/factories/vec4f64","../views/3d/webgl-engine/core/shaderLibrary/ScreenSpacePass.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/CameraSpace.glsl","../views/3d/webgl-engine/core/shaderModules/Float4PassUniform","../views/3d/webgl-engine/core/shaderModules/FloatPassUniform","../views/3d/webgl-engine/core/shaderModules/interfaces","../views/3d/webgl-engine/core/shaderModules/ShaderBuilder","../views/3d/webgl-engine/core/shaderModules/Texture2DPassUniform","./ShadowCastAccumulate.glsl","../views/3d/webgl-engine/shaders/ShadowCastVisualizeTechniqueConfiguration"],(function(e,a,s,o,r,t,l,i,n,d,c){"use strict";class u extends l.NoParameters{constructor(e){super(),this._data=e,this.sampleScale=0,this.opacityFromElevation=1,this.color=a.clone(h),this.bandSize=.1,this.threshold=.5}get shadowCastMap(){return this._data.shadowCastTexture}}const h=a.fromValues(.01,0,.25,1);function m(e){const a=new i.ShaderBuilder,u=a.fragment;a.include(o.CameraSpace),a.include(s.ScreenSpacePass);const{visualization:h,bandsEnabled:m}=e;u.constants.add("inverseSampleValue","float",d.ShadowCastMaxSamples),u.uniforms.add(new n.Texture2DPassUniform("shadowCastMap",(e=>e.shadowCastMap)),new t.FloatPassUniform("sampleScale",(e=>e.sampleScale)),new t.FloatPassUniform("opacityFromElevation",(e=>e.opacityFromElevation)),new r.Float4PassUniform("uColor",(e=>e.color)));const w=h===c.ShadowCastVisualization.Gradient,g=h===c.ShadowCastVisualization.Threshold;return w&&m?u.uniforms.add(new t.FloatPassUniform("bandSize",(e=>e.bandSize))):g&&u.uniforms.add(new t.FloatPassUniform("threshold",(e=>e.threshold))),u.main.add(l.glsl`
    float record = texture(shadowCastMap, uv).r;
    float pixelSamples = record * inverseSampleValue;

    fragColor = vec4(0.0);
    if (pixelSamples < 1.0) {
      return;
    }

    float strength = pixelSamples * sampleScale;
    ${g?l.glsl`if (strength <= threshold) return;`:""}
    ${w&&m?l.glsl`strength = ceil(strength / bandSize) * bandSize;`:""}
    fragColor = vec4(uColor.xyz, uColor.a * opacityFromElevation ${w?"* strength":""});
  `),a}const w=Object.freeze(Object.defineProperty({__proto__:null,ShadowCastVisualizePassParameters:u,build:m},Symbol.toStringTag,{value:"Module"}));e.ShadowCastVisualize=w,e.ShadowCastVisualizePassParameters=u,e.build=m}));
