/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../core/libs/gl-matrix-2/math/mat4","../core/libs/gl-matrix-2/factories/mat4f64","./vec32","../core/libs/gl-matrix-2/factories/vec3f64","../views/3d/webgl-engine/core/shaderLibrary/NormalFromDepth.glsl","../views/3d/webgl-engine/core/shaderLibrary/ScreenSpacePass.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/ReadShadowMap.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/RgbaFloatEncoding.glsl","../views/3d/webgl-engine/core/shaderModules/Float3PassUniform","../views/3d/webgl-engine/core/shaderModules/Float4PassUniform","../views/3d/webgl-engine/core/shaderModules/FloatPassUniform","../views/3d/webgl-engine/core/shaderModules/interfaces","../views/3d/webgl-engine/core/shaderModules/Matrix4PassUniform","../views/3d/webgl-engine/core/shaderModules/ShaderBuilder","../views/3d/webgl-engine/core/shaderModules/Texture2DPassUniform","../views/3d/webgl-engine/lib/ShadowMap","../views/3d/webgl-engine/shaders/ReadShadowMapConfiguration"],(function(e,i,t,a,o,r,l,h,n,s,d,g,c,u,p,w,f,v){"use strict";const x=.025;function m(){const e=new p.ShaderBuilder;e.include(h.ReadShadowMapPass,M),e.include(l.ScreenSpacePass),e.include(r.NormalFromDepth);const t=e.fragment;return t.include(n.RgbaFloatEncoding),t.uniforms.add(new w.Texture2DPassUniform("defaultDepthTex",((e,i)=>i.shadowMap.getSnapshot(f.SnapshotSlot.ExcludeHighlight))),new w.Texture2DPassUniform("highlightDepthTex",((e,i)=>i.shadowMap.getSnapshot(f.SnapshotSlot.Highlight))),new w.Texture2DPassUniform("depthMap",((e,i)=>i.depth?.attachment)),new w.Texture2DPassUniform("highlightTexture",(e=>e.highlight)),new d.Float4PassUniform("uColor",(e=>e.shadowColor)),new g.FloatPassUniform("opacity",(e=>e.shadowOpacity)),new g.FloatPassUniform("occludedOpacity",(e=>e.occludedShadowOpacity)),new g.FloatPassUniform("terminationFactor",(e=>e.opacityElevation*e.dayNightTerminator)),new s.Float3PassUniform("lightingMainDirectionView",((e,i)=>a.normalize(S,a.transformMat4(S,i.lighting.mainLight.direction,i.camera.viewInverseTransposeMatrix)))),new u.Matrix4PassUniform("inverseViewMatrix",((e,t)=>i.invert(b,i.translate(b,t.camera.viewMatrix,t.camera.center))))).main.add(c.glsl`
    ivec2 highlightTextureSize = textureSize(highlightTexture, 0);
    ivec2 highlightIUV = ivec2(uv * vec2(highlightTextureSize));
    vec4 highlightInfo = texelFetch(highlightTexture, highlightIUV, 0);

    fragColor = vec4(0.0);

    // Calculate bit mask to check if pixel is highlit unoccluded at any level
    int ored =
         (int(highlightInfo.r*255.0) << 0)
       | (int(highlightInfo.g*255.0) << 8)
       | (int(highlightInfo.b*255.0) << 16)
       | (int(highlightInfo.a*255.0) << 24);
    bool visiblyHighlighted = ((ored & ~(ored >> 1)) & (1+4+16+64)) != 0;
    if (visiblyHighlighted) {
      return;
    }

    // 1.0 is the clear value of depthMap, which means nothing has been drawn there and we should discard
    float depth = depthFromTexture(depthMap, uv);
    if (depth >= 1.0 || depth <= 0.0) {
      return;
    }

    float currentPixelDepth = linearizeDepth(depth);
    vec4 currentPixelPos = vec4(reconstructPosition(gl_FragCoord.xy, currentPixelDepth), 1.0);
    vec4 worldSpacePos = inverseViewMatrix * currentPixelPos;

    mat4 shadowMatrix;
    float linearDepth = -currentPixelDepth;
    int i = chooseCascade(linearDepth, shadowMatrix);
    if (i >= numCascades) {
      return;
    }

    // vertex completely outside? -> no shadow
    vec3 lvpos = lightSpacePosition(worldSpacePos.xyz, shadowMatrix);
    if (lvpos.z >= 1.0 || lvpos.x < 0.0 || lvpos.x > 1.0 || lvpos.y < 0.0 || lvpos.y > 1.0) {
      return;
    }

    ivec2 texSize = textureSize(highlightDepthTex, 0);
    ivec2 uvShadow = ivec2(cascadeCoordinates(i, texSize, lvpos) * vec2(texSize));

    float depthHighlight = readShadowMapDepth(uvShadow, highlightDepthTex);
    bool shadowHighlight = depthHighlight < lvpos.z;
    if (!shadowHighlight) {
      return;
    }

    float depthDefault = readShadowMapDepth(uvShadow, defaultDepthTex);
    bool shadowDefault = depthDefault < lvpos.z;

    vec3 normal = normalFromDepth(depthMap, currentPixelPos.xyz, gl_FragCoord.xy, uv);
    bool shaded = dot(normal, lightingMainDirectionView) < ${c.glsl.float(x)};

    float fragOpacity = (shadowDefault || shaded) ? occludedOpacity : opacity;
    fragColor = vec4(uColor.rgb, uColor.a * fragOpacity * terminationFactor);
  `),e}const b=t.create(),S=o.create(),M=new v.ReadShadowMapConfiguration,P=Object.freeze(Object.defineProperty({__proto__:null,build:m},Symbol.toStringTag,{value:"Module"}));e.ShadowHighlight=P,e.build=m}));
