/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../core/libs/gl-matrix-2/math/mat4","../core/libs/gl-matrix-2/factories/mat4f64","./vec32","../core/libs/gl-matrix-2/factories/vec3f64","../views/3d/terrain/OverlayContent","../views/3d/terrain/TransparencyMode","../views/3d/webgl-engine/core/shaderLibrary/ForwardLinearDepth.glsl","../views/3d/webgl-engine/core/shaderLibrary/ShaderOutput","../views/3d/webgl-engine/core/shaderLibrary/Slice.glsl","../views/3d/webgl-engine/core/shaderLibrary/Transform.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/NormalAttribute.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/PositionAttribute.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/TextureCoordinateAttribute.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/VertexTangent.glsl","../views/3d/webgl-engine/core/shaderLibrary/output/OutputDepth.glsl","../views/3d/webgl-engine/core/shaderLibrary/output/OutputHighlight.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/EvaluateAmbientOcclusion.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/EvaluateSceneLighting.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/MainLighting.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/NormalUtils.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/PhysicallyBasedRenderingParameters.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/ReadShadowMap.glsl","../views/3d/webgl-engine/core/shaderLibrary/terrain/Overlay.glsl","../views/3d/webgl-engine/core/shaderLibrary/terrain/TerrainTexture.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/AlphaCutoff","../views/3d/webgl-engine/core/shaderLibrary/util/View.glsl","../views/3d/webgl-engine/core/shaderModules/Float3PassUniform","../views/3d/webgl-engine/core/shaderModules/interfaces","../views/3d/webgl-engine/core/shaderModules/Matrix4DrawUniform","../views/3d/webgl-engine/core/shaderModules/ShaderBuilder","../views/3d/webgl-engine/core/shaderModules/Texture2DPassUniform"],(function(e,a,r,i,o,l,t,n,s,d,c,g,v,m,u,h,p,f,w,b,y,C,O,S,x,T,L,P,M,z,D,$){"use strict";class I extends x.OverlayTerrainPassParameters{}function N(e){const r=new D.ShaderBuilder,{vertex:o,fragment:I,varyings:N}=r,{output:F,pbrMode:W,overlayMode:U,tileBorders:B,spherical:j,transparencyMode:_,screenSizePerspective:H}=e;r.include(v.PositionAttribute),r.include(g.NormalAttribute,e),r.include(m.TextureCoordinateAttribute,e);const R=()=>{r.include(y.NormalUtils,e),o.code.add(M.glsl`vec3 getNormal() {
float z = 1.0 - abs(normalCompressed.x) - abs(normalCompressed.y);
vec3 n = vec3(normalCompressed + vec2(normalCompressed.x >= 0.0 ? 1.0 : -1.0,
normalCompressed.y >= 0.0 ? 1.0 : -1.0) * min(z, 0.0), z);
return normalize(n);
}`)};L.addProjViewLocalOrigin(o,e),r.include(c.Transform,e);const E=_===t.TransparencyMode.InvisibleWithDraped||_===t.TransparencyMode.Invisible,k=U!==S.OverlayMode.Disabled,G=k&&E;switch(F){case s.ShaderOutput.ColorEmission:case s.ShaderOutput.Color:{r.include(x.TerrainTexture,e),r.include(w.EvaluateSceneLighting,e),k&&(e.pbrMode=W===C.PBRMode.Simplified?C.PBRMode.TerrainWithWater:C.PBRMode.Water,r.include(S.OverlayTerrain,e),e.pbrMode=W);const t=U===S.OverlayMode.EnabledWithWater;t&&r.include(u.VertexTangent,e),N.add("vnormal","vec3"),N.add("vpos","vec3"),N.add("vup","vec3"),R(),H&&L.addViewNormal(o);const s=e.receiveShadows&&!e.renderOccluded;s&&r.include(n.ForwardLinearDepth,e),H&&(N.add("screenSizeDistanceToCamera","float"),N.add("screenSizeCosAngle","float")),o.main.add(M.glsl`
          vpos = position;
          vec3 positionWorld = position + localOrigin;
          gl_Position = transformPosition(proj, view, vpos);
          vnormal = getNormal();
          vup = getLocalUp(position, localOrigin);
          ${M.If(t,M.glsl`forwardVertexTangent(vnormal);`)}

          vec2 uv = getUV0();
          forwardTextureCoordinatesWithTransform(uv);
          ${M.If(k,"setOverlayVTC(uv);")}
          ${M.If(B,"forwardTextureCoordinates();")}
          ${M.If(H,M.glsl`vec3 viewPos = (view * vec4(vpos, 1.0)).xyz;
                 screenSizeDistanceToCamera = length(viewPos);
                 vec3 viewSpaceNormal = (viewNormal * vec4(normalize(positionWorld), 1.0)).xyz;
                 screenSizeCosAngle = abs(viewSpaceNormal.z);`)}
          ${M.If(s,"forwardLinearDepth();")}`),r.include(d.SliceDraw,e),r.include(w.EvaluateSceneLighting,e),r.include(f.EvaluateAmbientOcclusion,e),r.include(O.ReadShadowMapDraw,e),L.addCameraPosition(I,e),w.addAmbientBoostFactor(I),w.addLightingGlobalFactor(I),I.uniforms.add(o.uniforms.get("localOrigin"),new P.Float3PassUniform("viewDirection",((e,a)=>i.normalize(V,i.set(V,a.camera.viewMatrix[12],a.camera.viewMatrix[13],a.camera.viewMatrix[14]))))),t&&I.uniforms.add(new $.Texture2DPassUniform("ovWaterTex",((e,a)=>a.overlay?.getTexture(l.OverlayContent.WaterNormal))),new z.Matrix4DrawUniform("view",((e,r)=>a.translate(A,r.camera.viewMatrix,e.origin))));const c=.2;I.code.add(M.glsl`float lum(vec3 c) {
return (min(min(c.r, c.g), c.b) + max(max(c.r, c.g), c.b)) * 0.5;
}`),b.addMainLightDirection(I),b.addMainLightIntensity(I),I.main.add(M.glsl`
          vec3 normal = normalize(vnormal);
          float vndl = dot(normal, mainLightDirection);

          float additionalAmbientScale = smoothstep(0.0, 1.0, clamp(vndl*2.5, 0.0, 1.0));
          float shadow = ${s?"max(lightingGlobalFactor * (1.0 - additionalAmbientScale), readShadowMap(vpos, linearDepth))":j?"lightingGlobalFactor * (1.0 - additionalAmbientScale)":"0.0"};

          float ssao = evaluateAmbientOcclusionInverse();
          vec4 tileColor = getTileColor();

          ${M.If(k,M.glsl`vec4 overlayColorOpaque = getOverlayColor(ovColorTex, vtcOverlay);
                   vec4 overlayColor = overlayOpacity * overlayColorOpaque;
                   ${M.If(E,`if (overlayColor.a < ${M.glsl.float(T.alphaCutoff)}) { discard; }`)}
                   vec4 groundColor = tileColor;
                   tileColor = tileColor * (1.0 - overlayColor.a) + overlayColor;`)}

          // If combined alpha is 0 we can discard pixel. The performance impact by having a discard here
          // is neglectable because terrain typically renders first into the framebuffer.
          if(tileColor.a < ${M.glsl.float(T.alphaCutoff)}) {
            discard;
          }

          bool sliced = rejectBySlice(vpos);
          if (sliced) {
            tileColor *= ${M.glsl.float(c)};
          }

          vec3 albedo = tileColor.rgb;

          // heuristic shading function used in the old terrain, now used to add ambient lighting

          vec3 additionalLight = ssao * mainLightIntensity * additionalAmbientScale * ambientBoostFactor * lightingGlobalFactor;

          ${W===C.PBRMode.Simplified||W===C.PBRMode.TerrainWithWater?M.glsl`fragColor = vec4(evaluatePBRSimplifiedLighting(normal, albedo, shadow, 1.0 - ssao, additionalLight, normalize(vpos - cameraPosition), vup), tileColor.a);`:M.glsl`fragColor = vec4(evaluateSceneLighting(normal, albedo, shadow, 1.0 - ssao, additionalLight), tileColor.a);`}
          ${M.If(t,M.glsl`vec4 overlayWaterMask = getOverlayColor(ovWaterTex, vtcOverlay);
                   float waterNormalLength = length(overlayWaterMask);
                   if (waterNormalLength > 0.95) {
                     mat3 tbnMatrix = mat3(tbnTangent, tbnBiTangent, vnormal);
                     vec4 waterOverlayColor = vec4(overlayColor.w > 0.0 ? overlayColorOpaque.xyz/overlayColor.w : vec3(1.0), overlayColor.w);
                     vec4 viewPosition = view*vec4(vpos, 1.0);
                     vec4 waterColorLinear = getOverlayWaterColor(overlayWaterMask, waterOverlayColor, -normalize(vpos - cameraPosition), shadow, vnormal, tbnMatrix, viewPosition.xyz,  vpos + localOrigin);
                     vec4 waterColorNonLinear = delinearizeGamma(vec4(waterColorLinear.xyz, 1.0));
                     float opacity = sliced ? ${M.glsl.float(c)} : 1.0;
                     // un-gamma the ground color to mix in linear space
                     fragColor = mix(groundColor, waterColorNonLinear, waterColorLinear.w) * opacity;
                   }`)}
          ${M.If(H,M.glsl`float perspectiveScale = screenSizePerspectiveScaleFloat(1.0, screenSizeCosAngle, screenSizeDistanceToCamera, vec4(0.0));
                   if (perspectiveScale <= 0.25) {
                     fragColor = mix(fragColor, vec4(1.0, 0.0, 0.0, 1.0), perspectiveScale * 4.0);
                   } else if (perspectiveScale <= 0.5) {
                     fragColor = mix(fragColor, vec4(0.0, 0.0, 1.0, 1.0), (perspectiveScale - 0.25) * 4.0);
                   } else if (perspectiveScale >= 0.99) {
                     fragColor = mix(fragColor, vec4(0.0, 1.0, 0.0, 1.0), 0.2);
                   } else {
                     fragColor = mix(fragColor, vec4(1.0, 0.0, 1.0, 1.0), (perspectiveScale - 0.5) * 2.0);
                   }`)}
          ${M.If(e.visualizeNormals,j?M.glsl`
                  vec3 localUp = normalize(vpos + localOrigin);
                  vec3 right = normalize(cross(vec3(0.0, 0.0, 1.0), localUp));
                  vec3 forward = normalize(cross(localUp, right));
                  mat3 tbn = mat3(right, forward, localUp);
                  vec3 tNormal = normalize(normal * tbn);
                  fragColor = vec4(vec3(0.5) + 0.5 * tNormal, 0.0);`:M.glsl`
                  vec3 tNormal = normalize(normal);
                  fragColor = vec4(vec3(0.5) + 0.5 * tNormal, 0.0);`)}
          ${M.If(B,M.glsl`vec2 dVuv = fwidth(vuv0);
                 vec2 edgeFactors = smoothstep(vec2(0.0), 1.5 * dVuv, min(vuv0, 1.0 - vuv0));
                 float edgeFactor = 1.0 - min(edgeFactors.x, edgeFactors.y);
                 fragColor = mix(fragColor, vec4(1.0, 0.0, 0.0, 1.0), edgeFactor);`)}
          fragColor = highlightSlice(fragColor, vpos);`)}break;case s.ShaderOutput.Depth:G&&r.include(S.OverlayTerrain,e),o.main.add(M.glsl`
        ${M.If(G,"setOverlayVTC(getUV0());")}
        gl_Position = transformPosition(proj, view, position);`),I.main.add(`${M.If(G,`if (getCombinedOverlayColor().a < ${M.glsl.float(T.alphaCutoff)}) discard;`)}`);break;case s.ShaderOutput.Shadow:case s.ShaderOutput.ShadowHighlight:case s.ShaderOutput.ShadowExcludeHighlight:case s.ShaderOutput.ViewshedShadow:r.include(h.OutputDepth,e),n.addLinearDepth(r),n.addNearFar(r),o.main.add(M.glsl`gl_Position = transformPositionWithDepth(proj, view, position, nearFar, linearDepth);`),I.main.add(M.glsl`outputDepth(linearDepth);`);break;case s.ShaderOutput.Normal:G&&r.include(S.OverlayTerrain,e),N.add("vnormal","vec3"),L.addViewNormal(o),R(),o.main.add(M.glsl`
        ${M.If(G,"setOverlayVTC(getUV0());")}
        gl_Position = transformPosition(proj, view, position);
        vnormal = normalize((viewNormal * vec4(getNormal(), 1.0)).xyz);`),I.main.add(M.glsl`
        ${M.If(G,`if (getCombinedOverlayColor().a < ${M.glsl.float(T.alphaCutoff)}) discard;`)}
        vec3 normal = normalize(vnormal);
        if (gl_FrontFacing == false) {
          normal = -normal;
        }
        fragColor = vec4(vec3(0.5) + 0.5 * normal, 1.0);`);break;case s.ShaderOutput.Highlight:k&&r.include(S.OverlayTerrain,e),o.main.add(M.glsl`
        ${M.If(k,"setOverlayVTC(getUV0());")}
        gl_Position = transformPosition(proj, view, position);`),r.include(p.OutputHighlight,e),I.main.add(M.glsl`
        ${M.If(k,M.glsl`
           vec2 overlayHighlightTexel = getAllOverlayHighlightValuesEncoded();
           outputAllHighlights(overlayHighlightTexel);`,"calculateOcclusionAndOutputHighlight();")}
      `)}if(F===s.ShaderOutput.ObjectAndLayerIdColor)if(k)e.pbrMode=C.PBRMode.Disabled,r.include(S.OverlayTerrain,e),e.pbrMode=W,o.main.add(M.glsl`gl_Position = transformPosition(proj, view, position);
setOverlayVTC(getUV0());`),I.main.add(M.glsl`fragColor = getOverlayColorTexel(vtcOverlay);`);else{const e=_===t.TransparencyMode.Opaque;o.main.add(M.glsl`${M.If(e,"gl_Position = transformPosition(proj, view, position);")}`),I.main.add(M.glsl`fragColor = vec4(0.0);`)}return r}const A=r.create(),V=o.create(),F=Object.freeze(Object.defineProperty({__proto__:null,TerrainPassParameters:I,build:N},Symbol.toStringTag,{value:"Module"}));e.Terrain=F,e.TerrainPassParameters=I,e.build=N}));
