/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../views/3d/webgl-engine/core/shaderLibrary/ForwardLinearDepth.glsl","../views/3d/webgl-engine/core/shaderLibrary/ShaderOutput","../views/3d/webgl-engine/core/shaderLibrary/Slice.glsl","../views/3d/webgl-engine/core/shaderLibrary/Transform.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/ObjectAndLayerIdColor.glsl","../views/3d/webgl-engine/core/shaderLibrary/output/OutputHighlight.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/EvaluateAmbientLighting.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/MainLighting.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/NormalUtils.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/PhysicallyBasedRenderingParameters.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/ReadShadowMap.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/TerrainDepthTest.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/Water.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/WaterDistortion.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/AlphaCutoff","../views/3d/webgl-engine/core/shaderLibrary/util/ColorConversion.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/View.glsl","../views/3d/webgl-engine/core/shaderModules/Float4PassUniform","../views/3d/webgl-engine/core/shaderModules/FloatPassUniform","../views/3d/webgl-engine/core/shaderModules/interfaces","../views/3d/webgl-engine/core/shaderModules/ShaderBuilder","../views/3d/webgl-engine/lib/VertexAttribute","../views/3d/webgl-engine/shaders/OutputColorHighlightOID.glsl"],(function(e,a,i,r,o,t,l,n,s,d,g,c,v,u,h,p,w,m,b,f,y,C,L,S){"use strict";function O(e){const O=new C.ShaderBuilder,{vertex:P,fragment:D}=O;m.addProjViewLocalOrigin(P,e),O.include(o.Transform,e),O.attributes.add(L.VertexAttribute.POSITION,"vec3"),O.attributes.add(L.VertexAttribute.UV0,"vec2");const x=new b.Float4PassUniform("waterColor",(e=>e.color));if(e.output===i.ShaderOutput.Color&&e.draped)return O.varyings.add("vpos","vec3"),P.uniforms.add(x),P.main.add(y.glsl`
      if (waterColor.a < ${y.glsl.float(p.alphaCutoff)}) {
        // Discard this vertex
        gl_Position = vec4(1e38, 1e38, 1e38, 1.0);
        return;
      }

      vpos = position;
      gl_Position = transformPosition(proj, view, vpos);`),D.uniforms.add(x),D.main.add(y.glsl`fragColor = waterColor;`),O;switch(e.output===i.ShaderOutput.Color&&(O.include(d.NormalUtils,e),O.include(a.ForwardLinearDepth,e),O.varyings.add("vuv","vec2"),O.varyings.add("vpos","vec3"),O.varyings.add("vnormal","vec3"),O.varyings.add("vtbnMatrix","mat3"),e.terrainDepthTest&&O.varyings.add("depth","float"),P.uniforms.add(x),P.main.add(y.glsl`
      if (waterColor.a < ${y.glsl.float(p.alphaCutoff)}) {
        // Discard this vertex
        gl_Position = vec4(1e38, 1e38, 1e38, 1.0);
        return;
      }

      vuv = uv0;
      vpos = position;

      vnormal = getLocalUp(vpos, localOrigin);
      vtbnMatrix = getTBNMatrix(vnormal);

      ${e.terrainDepthTest?"depth = (view * vec4(vpos, 1.0)).z;":""}

      gl_Position = transformPosition(proj, view, vpos);
      ${e.output===i.ShaderOutput.Color?"forwardLinearDepth();":""}`)),O.include(v.terrainDepthTest,e),e.output){case i.ShaderOutput.Color:O.include(n.EvaluateAmbientLighting,{pbrMode:g.PBRMode.Disabled,lightingSphericalHarmonicsOrder:2}),O.include(h.WaterDistortion),O.include(c.ReadShadowMapDraw,e),O.include(u.Water,e),O.include(r.SliceDraw,e),O.include(S.outputColorHighlightOID,e),D.uniforms.add(x,new f.FloatPassUniform("timeElapsed",(e=>e.timeElapsed)),P.uniforms.get("view"),P.uniforms.get("localOrigin")),m.addCameraPosition(D,e),D.include(w.ColorConversion),s.addMainLightDirection(D),s.addMainLightIntensity(D),D.main.add(y.glsl`
        discardBySlice(vpos);
        ${e.terrainDepthTest?"terrainDepthTest(depth);":""}
        vec3 localUp = vnormal;
        // the created normal is in tangent space
        vec4 tangentNormalFoam = getSurfaceNormalAndFoam(vuv, timeElapsed);

        // we rotate the normal according to the tangent-bitangent-normal-Matrix
        vec3 n = normalize(vtbnMatrix * tangentNormalFoam.xyz);
        vec3 v = -normalize(vpos - cameraPosition);
        float shadow = ${e.receiveShadows?y.glsl`1.0 - readShadowMap(vpos, linearDepth)`:"1.0"};
        vec4 vPosView = view * vec4(vpos, 1.0);
        vec4 final = vec4(getSeaColor(n, v, mainLightDirection, waterColor.rgb, mainLightIntensity, localUp, shadow, tangentNormalFoam.w, vPosView.xyz, vpos + localOrigin), waterColor.w);

        // gamma correction
        fragColor = delinearizeGamma(final);
        outputColorHighlightOID(fragColor, vpos);`);break;case i.ShaderOutput.Normal:O.include(d.NormalUtils,e),O.include(h.WaterDistortion,e),O.include(r.SliceDraw,e),O.varyings.add("vpos","vec3"),O.varyings.add("vuv","vec2"),P.uniforms.add(x),P.main.add(y.glsl`
        if (waterColor.a < ${y.glsl.float(p.alphaCutoff)}) {
          // Discard this vertex
          gl_Position = vec4(1e38, 1e38, 1e38, 1.0);
          return;
        }

        vuv = uv0;
        vpos = position;

        gl_Position = transformPosition(proj, view, vpos);`),D.uniforms.add(new f.FloatPassUniform("timeElapsed",(e=>e.timeElapsed))),D.main.add(y.glsl`discardBySlice(vpos);
vec4 tangentNormalFoam = getSurfaceNormalAndFoam(vuv, timeElapsed);
tangentNormalFoam.xyz = normalize(tangentNormalFoam.xyz);
fragColor = vec4((tangentNormalFoam.xyz + vec3(1.0)) * 0.5, tangentNormalFoam.w);`);break;case i.ShaderOutput.Highlight:O.include(l.OutputHighlight,e),O.varyings.add("vpos","vec3"),P.uniforms.add(x),P.main.add(y.glsl`
        if (waterColor.a < ${y.glsl.float(p.alphaCutoff)}) {
          // Discard this vertex
          gl_Position = vec4(1e38, 1e38, 1e38, 1.0);
          return;
        }

        vpos = position;
        gl_Position = transformPosition(proj, view, vpos);`),O.include(r.SliceDraw,e),D.main.add(y.glsl`discardBySlice(vpos);
calculateOcclusionAndOutputHighlight();`);break;case i.ShaderOutput.ObjectAndLayerIdColor:O.include(t.ObjectAndLayerIdColor,e),O.varyings.add("vpos","vec3"),P.uniforms.add(x),P.main.add(y.glsl`
        if (waterColor.a < ${y.glsl.float(p.alphaCutoff)}) {
          // Discard this vertex
          gl_Position = vec4(1e38, 1e38, 1e38, 1.0);
          return;
        }

        vpos = position;
        gl_Position = transformPosition(proj, view, vpos);
        forwardObjectAndLayerIdColor();`),O.include(r.SliceDraw,e),D.main.add(y.glsl`discardBySlice(vpos);
outputObjectAndLayerIdColor();`)}return O}const P=Object.freeze(Object.defineProperty({__proto__:null,build:O},Symbol.toStringTag,{value:"Module"}));e.WaterSurface=P,e.build=O}));
