/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../shaderModules/Integer2PassUniform","../shaderModules/interfaces","../shaderModules/Texture2DPassUniform","../../../../../chunks/HighlightDownsample.glsl"],(function(e,l,i,t,s){"use strict";function c(e){const{vertex:c}=e;c.uniforms.add(new t.Texture2DPassUniform("coverageTexture",(e=>e.coverageTexture)),new l.Integer2PassUniform("highlightRenderCellCount",(e=>[e.horizontalCellCount,e.verticalCellCount])),new l.Integer2PassUniform("highlightTextureResolution",(e=>[e.highlightTexture.descriptor.width,e.highlightTexture.descriptor.height]))),c.constants.add("cellSize","int",s.gridCellPixelSize),e.varyings.add("sUV","vec2"),e.varyings.add("vOutlinePossible","float"),c.code.add(i.glsl`const ivec2 cellVertices[4] = ivec2[4](ivec2(0,0), ivec2(1,0), ivec2(0,1), ivec2(1,1));`),c.main.add(i.glsl`int cellIndex = gl_InstanceID;
int cellX = cellIndex % highlightRenderCellCount[0];
int cellY = (cellIndex - cellX) / highlightRenderCellCount[0];
ivec2 cellPos = ivec2(cellX, cellY);
vec4 cov = texelFetch(coverageTexture, cellPos, 0);
if (cov.r == 0.0) {
gl_Position = vec4(0.0);
return;
}
vOutlinePossible = cov.g;
ivec2 iPosInCell = cellVertices[gl_VertexID];
vec2 sPos = vec2(cellPos * cellSize + iPosInCell * (cellSize));
vec2 vPos = sPos / vec2(highlightTextureResolution);
sUV = vPos;
gl_Position = vec4(2.0 * vPos - vec2(1.0), 0.0, 1.0);`)}e.HighlightCellGridScreenSpacePass=c,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
