/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../../../core/libs/gl-matrix-2/math/mat3","../../../../../../core/libs/gl-matrix-2/factories/mat3f64","../../../../../../core/libs/gl-matrix-2/factories/mat4f64","../../../../../../chunks/vec32","../../../../../../core/libs/gl-matrix-2/factories/vec3f64","../ShaderOutput","../util/DoublePrecision.glsl","../util/View.glsl","../../shaderModules/Float3DrawUniform","../../shaderModules/interfaces","../../shaderModules/Matrix3PassUniform","../../shaderModules/Matrix4PassUniform","../../../lib/VertexAttribute","../../../../../webgl/doublePrecisionUtils"],(function(e,r,a,o,n,t,i,s,l,c,d,m,u,g,v){"use strict";class x extends d.NoParameters{constructor(){super(...arguments),this.modelTransformation=null}}const M=a.create();function f(e,a){const t=a.hasModelTransformation,x=a.instancedDoublePrecision;t&&(e.vertex.uniforms.add(new u.Matrix4PassUniform("model",(e=>e.modelTransformation??o.IDENTITY))),e.vertex.uniforms.add(new m.Matrix3PassUniform("normalLocalOriginFromModel",(e=>(r.normalFromMat4(M,e.modelTransformation??o.IDENTITY),M))))),a.instanced&&x&&(e.attributes.add(g.VertexAttribute.INSTANCEMODELORIGINHI,"vec3"),e.attributes.add(g.VertexAttribute.INSTANCEMODELORIGINLO,"vec3"),e.attributes.add(g.VertexAttribute.INSTANCEMODEL,"mat3"),e.attributes.add(g.VertexAttribute.INSTANCEMODELNORMAL,"mat3"));const f=e.vertex;x&&(f.include(s.DoublePrecision,a),f.uniforms.add(new c.Float3DrawUniform("viewOriginHi",((e,r)=>v.encodeDoubleHi(n.set(b,r.camera.viewInverseTransposeMatrix[3],r.camera.viewInverseTransposeMatrix[7],r.camera.viewInverseTransposeMatrix[11]),b))),new c.Float3DrawUniform("viewOriginLo",((e,r)=>v.encodeDoubleLo(n.set(b,r.camera.viewInverseTransposeMatrix[3],r.camera.viewInverseTransposeMatrix[7],r.camera.viewInverseTransposeMatrix[11]),b))))),f.code.add(d.glsl`
    vec3 getVertexInLocalOriginSpace() {
      return ${t?x?"(model * vec4(instanceModel * localPosition().xyz, 1.0)).xyz":"(model * localPosition()).xyz":x?"instanceModel * localPosition().xyz":"localPosition().xyz"};
    }

    vec3 subtractOrigin(vec3 _pos) {
      ${x?d.glsl`
          // Negated inputs are intentionally the first two arguments. The other way around the obfuscation in dpAdd() stopped
          // working for macOS 14+ and iOS 17+.
          // Issue: https://devtopia.esri.com/WebGIS/arcgis-js-api/issues/56280
          vec3 originDelta = dpAdd(-instanceModelOriginHi, -instanceModelOriginLo, viewOriginHi, viewOriginLo);
          return _pos - originDelta;`:"return vpos;"}
    }
    `),f.code.add(d.glsl`
    vec3 dpNormal(vec4 _normal) {
      return normalize(${t?x?"normalLocalOriginFromModel * (instanceModelNormal * _normal.xyz)":"normalLocalOriginFromModel * _normal.xyz":x?"instanceModelNormal * _normal.xyz":"_normal.xyz"});
    }
    `),a.output===i.ShaderOutput.Normal&&(l.addViewNormal(f),f.code.add(d.glsl`
    vec3 dpNormalView(vec4 _normal) {
      return normalize((viewNormal * ${t?x?"vec4(normalLocalOriginFromModel * (instanceModelNormal * _normal.xyz), 1.0)":"vec4(normalLocalOriginFromModel * _normal.xyz, 1.0)":x?"vec4(instanceModelNormal * _normal.xyz, 1.0)":"_normal"}).xyz);
    }
    `)),a.hasVertexTangents&&f.code.add(d.glsl`
    vec4 dpTransformVertexTangent(vec4 _tangent) {
      ${t?x?"return vec4(normalLocalOriginFromModel * (instanceModelNormal * _tangent.xyz), _tangent.w);":"return vec4(normalLocalOriginFromModel * _tangent.xyz, _tangent.w);":x?"return vec4(instanceModelNormal * _tangent.xyz, _tangent.w);":"return _tangent;"}
    }`)}const b=t.create();e.InstancedDoublePassParameters=x,e.InstancedDoublePrecision=f,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
