/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../ForwardLinearDepth.glsl","../ShaderOutput","../Slice.glsl","../Transform.glsl","../attributes/NormalAttribute.glsl","../attributes/ObjectAndLayerIdColor.glsl","../attributes/TextureCoordinateAttribute.glsl","../attributes/VertexNormal.glsl","../output/OutputDepth.glsl","../output/OutputHighlight.glsl","../shading/VisualVariables.glsl","../util/DiscardOrAdjustAlpha.glsl","../util/View.glsl","../../shaderModules/interfaces","../../shaderModules/Texture2DPassUniform","../../../lib/basicInterfaces"],(function(e,r,t,a,i,o,l,s,d,u,n,c,p,g,v,h,O){"use strict";function m(e,m){const{vertex:x,fragment:f}=e,A=m.hasColorTexture&&m.alphaDiscardMode!==O.AlphaDiscardMode.Opaque,{output:w,normalType:b,hasColorTextureTransform:V}=m;switch(w){case t.ShaderOutput.Depth:g.addProjViewLocalOrigin(x,m),e.include(i.Transform,m),e.include(a.SliceDraw,m),e.include(s.TextureCoordinateAttribute,m),A&&f.uniforms.add(new h.Texture2DPassUniform("tex",(e=>e.texture))),x.main.add(v.glsl`vpos = getVertexInLocalOriginSpace();
vpos = subtractOrigin(vpos);
vpos = addVerticalOffset(vpos, localOrigin);
gl_Position = transformPosition(proj, view, vpos);
forwardTextureCoordinates();`),e.include(p.DiscardOrAdjustAlphaPass,m),f.main.add(v.glsl`
          discardBySlice(vpos);
          ${v.If(A,v.glsl`vec4 texColor = texture(tex, ${V?"colorUV":"vuv0"});
                 discardOrAdjustAlpha(texColor);`)}`);break;case t.ShaderOutput.Shadow:case t.ShaderOutput.ShadowHighlight:case t.ShaderOutput.ShadowExcludeHighlight:case t.ShaderOutput.ViewshedShadow:case t.ShaderOutput.ObjectAndLayerIdColor:g.addProjViewLocalOrigin(x,m),e.include(i.Transform,m),e.include(s.TextureCoordinateAttribute,m),e.include(c.VisualVariables,m),e.include(u.OutputDepth,m),e.include(a.SliceDraw,m),e.include(l.ObjectAndLayerIdColor,m),r.addNearFar(e),e.varyings.add("depth","float"),A&&f.uniforms.add(new h.Texture2DPassUniform("tex",(e=>e.texture))),x.main.add(v.glsl`vpos = getVertexInLocalOriginSpace();
vpos = subtractOrigin(vpos);
vpos = addVerticalOffset(vpos, localOrigin);
gl_Position = transformPositionWithDepth(proj, view, vpos, nearFar, depth);
forwardTextureCoordinates();
forwardObjectAndLayerIdColor();`),e.include(p.DiscardOrAdjustAlphaPass,m),f.main.add(v.glsl`
          discardBySlice(vpos);
          ${v.If(A,v.glsl`vec4 texColor = texture(tex, ${V?"colorUV":"vuv0"});
                 discardOrAdjustAlpha(texColor);`)}
          ${w===t.ShaderOutput.ObjectAndLayerIdColor?v.glsl`outputObjectAndLayerIdColor();`:v.glsl`outputDepth(depth);`}`);break;case t.ShaderOutput.Normal:{g.addProjViewLocalOrigin(x,m),e.include(i.Transform,m),e.include(o.NormalAttribute,m),e.include(d.VertexNormal,m),e.include(s.TextureCoordinateAttribute,m),e.include(c.VisualVariables,m),A&&f.uniforms.add(new h.Texture2DPassUniform("tex",(e=>e.texture))),b===o.NormalType.ScreenDerivative&&e.varyings.add("vPositionView","vec3");const r=b===o.NormalType.Attribute||b===o.NormalType.Compressed;x.main.add(v.glsl`
          vpos = getVertexInLocalOriginSpace();
          ${r?v.glsl`vNormalWorld = dpNormalView(vvLocalNormal(normalModel()));`:v.glsl`vPositionView = (view * vec4(vpos, 1.0)).xyz;`}
          vpos = subtractOrigin(vpos);
          vpos = addVerticalOffset(vpos, localOrigin);
          gl_Position = transformPosition(proj, view, vpos);
          forwardTextureCoordinates();`),e.include(a.SliceDraw,m),e.include(p.DiscardOrAdjustAlphaPass,m),f.main.add(v.glsl`
          discardBySlice(vpos);
          ${v.If(A,v.glsl`vec4 texColor = texture(tex, ${V?"colorUV":"vuv0"});
                 discardOrAdjustAlpha(texColor);`)}

          ${b===o.NormalType.ScreenDerivative?v.glsl`vec3 normal = screenDerivativeNormal(vPositionView);`:v.glsl`vec3 normal = normalize(vNormalWorld);
                     if (gl_FrontFacing == false){
                       normal = -normal;
                     }`}
          fragColor = vec4(0.5 + 0.5 * normal, 1.0);`);break}case t.ShaderOutput.Highlight:g.addProjViewLocalOrigin(x,m),e.include(i.Transform,m),e.include(s.TextureCoordinateAttribute,m),e.include(c.VisualVariables,m),A&&f.uniforms.add(new h.Texture2DPassUniform("tex",(e=>e.texture))),x.main.add(v.glsl`vpos = getVertexInLocalOriginSpace();
vpos = subtractOrigin(vpos);
vpos = addVerticalOffset(vpos, localOrigin);
gl_Position = transformPosition(proj, view, vpos);
forwardTextureCoordinates();`),e.include(a.SliceDraw,m),e.include(p.DiscardOrAdjustAlphaPass,m),e.include(n.OutputHighlight,m),f.main.add(v.glsl`
          discardBySlice(vpos);
          ${v.If(A,v.glsl`vec4 texColor = texture(tex, ${V?"colorUV":"vuv0"});
                 discardOrAdjustAlpha(texColor);`)}
          calculateOcclusionAndOutputHighlight();`)}}e.DefaultMaterialAuxiliaryPasses=m,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
