/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","./AlignPixel.glsl","../shading/TerrainDepthTest.glsl","../../shaderModules/interfaces"],(function(e,o,t,r){"use strict";function i(e,i){const{vertex:s,fragment:n}=e;e.include(t.terrainDepthTest,i),s.include(o.AlignPixel),i.terrainDepthTest&&e.varyings.add("depth","float"),s.main.add(r.glsl`
    vec4 posProjCenter;
    if (dot(position, position) > 0.0) {
      // Render single point to center of the pixel to avoid subpixel filtering to affect the marker color
      ProjectHUDAux projectAux;
      vec4 posProj = projectPositionHUD(projectAux);
      posProjCenter = alignToPixelCenter(posProj, viewport.zw);

      ${i.terrainDepthTest?r.glsl`depth = projectAux.posView.z;`:""}
      vec3 vpos = projectAux.posModel;
      if (rejectBySlice(vpos)) {
        // Project out of clip space
        posProjCenter = vec4(1e038, 1e038, 1e038, 1.0);
      }

    } else {
      // Project out of clip space
      posProjCenter = vec4(1e038, 1e038, 1e038, 1.0);
    }

    gl_Position = posProjCenter;
    gl_PointSize = 1.0;
  `),n.main.add(r.glsl`fragColor = vec4(1);
if(terrainDepthTest(depth)) {
fragColor.g = 0.5;
}`)}e.HUDOcclusionPass=i,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
