/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../ShaderOutput","../../shaderModules/Integer2PassUniform","../../shaderModules/IntegerPassUniform","../../shaderModules/interfaces","../../shaderModules/Texture2DPassUniform"],(function(i,e,t,l,h,g){"use strict";function d(i,d){const{fragment:c}=i;d.output===e.ShaderOutput.Highlight?(c.uniforms.add(new g.Texture2DPassUniform("depthTexture",((i,e)=>e.mainDepth)),new g.Texture2DPassUniform("highlightTexture",((i,e)=>e.highlightMixTexture)),new l.IntegerPassUniform("highlightLevel",((i,e)=>e.highlightLevel)),new t.Integer2PassUniform("highlightMixOrigin",((i,e)=>e.highlightMixOrigin))),i.outputs.add("fragHighlight","vec2",0),c.code.add(h.glsl`vec2 getAccumulatedHighlight() {
return texelFetch(highlightTexture, ivec2(gl_FragCoord.xy) - highlightMixOrigin, 0).rg;
}
void outputHighlight(bool occluded) {
if (highlightLevel == 0) {
uint bits = occluded ? 3u : 1u;
fragHighlight = vec2(float(bits) / 255.0, 0.0);
} else {
int ll = (highlightLevel & 3) << 1;
int li = (highlightLevel >> 2) & 3;
uint bits;
if (occluded) {
bits = 3u << ll;
} else {
bits = 1u << ll;
}
vec2 combinedHighlight = getAccumulatedHighlight();
uint accumulatedI = uint(combinedHighlight[li] * 255.0);
combinedHighlight[li] = float(bits | accumulatedI) / 255.0;
fragHighlight = combinedHighlight;
}
}
bool isHighlightOccluded() {
float sceneDepth = texelFetch(depthTexture, ivec2(gl_FragCoord.xy), 0).x;
return gl_FragCoord.z > sceneDepth + 5e-7;
}
void calculateOcclusionAndOutputHighlight() {
outputHighlight(isHighlightOccluded());
}`),d.canHaveOverlay&&(c.constants.add("occlusionAndMask","int",85),c.code.add(h.glsl`void outputAllHighlights(vec2 highlightToAdd) {
if (highlightToAdd == vec2(0.0)) { discard; }
int occludedOrMask = isHighlightOccluded() ? 0xaa : 0;
ivec2 added = ivec2(highlightToAdd * 255.0);
ivec2 masked = (added & ivec2(occlusionAndMask)) | (ivec2(occludedOrMask) & (added<<1));
fragHighlight = vec2(masked) / 255.0;
}`))):c.code.add(h.glsl`void calculateOcclusionAndOutputHighlight() {}`)}i.OutputHighlight=d,Object.defineProperty(i,Symbol.toStringTag,{value:"Module"})}));
