/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../attributes/VertexTextureCoordinates.glsl","../../shaderModules/Float3DrawUniform","../../shaderModules/Float3PassUniform","../../shaderModules/interfaces","../../shaderModules/Texture2DDrawUniform","../../shaderModules/Texture2DPassUniform","../../shaderTechnique/BindType","../../../lib/GLTextureMaterial","../../../materials/pbrUtils"],(function(e,r,s,o,a,t,i,l,c,n){"use strict";var u;e.PBRMode=void 0,(u=e.PBRMode||(e.PBRMode={}))[u.Disabled=0]="Disabled",u[u.Normal=1]="Normal",u[u.Schematic=2]="Schematic",u[u.Water=3]="Water",u[u.WaterOnIntegratedMesh=4]="WaterOnIntegratedMesh",u[u.Simplified=5]="Simplified",u[u.TerrainWithWater=6]="TerrainWithWater",u[u.COUNT=7]="COUNT";class d extends c.GLTextureMaterialBindParameters{constructor(){super(...arguments),this.mrrFactors=n.schematicMRRFactors}}function m(c,n){const u=n.pbrMode,d=c.fragment;if(u!==e.PBRMode.Schematic&&u!==e.PBRMode.Disabled&&u!==e.PBRMode.Normal)return void d.code.add(a.glsl`void applyPBRFactors() {}`);if(u===e.PBRMode.Disabled)return void d.code.add(a.glsl`void applyPBRFactors() {}
float getBakedOcclusion() { return 1.0; }`);if(u===e.PBRMode.Schematic)return void d.code.add(a.glsl`vec3 mrr = vec3(0.0, 0.6, 0.2);
float occlusion = 1.0;
void applyPBRFactors() {}
float getBakedOcclusion() { return 1.0; }`);const{hasMetallicRoughnessTexture:m,hasMetallicRoughnessTextureTransform:f,hasOcclusionTexture:h,hasOcclusionTextureTransform:g,bindType:p}=n;(m||h)&&c.include(r.VertexTextureCoordinates,n),d.code.add(a.glsl`vec3 mrr;
float occlusion;`),m&&d.uniforms.add(p===l.BindType.Pass?new i.Texture2DPassUniform("texMetallicRoughness",(e=>e.textureMetallicRoughness)):new t.Texture2DDrawUniform("texMetallicRoughness",(e=>e.textureMetallicRoughness))),h&&d.uniforms.add(p===l.BindType.Pass?new i.Texture2DPassUniform("texOcclusion",(e=>e.textureOcclusion)):new t.Texture2DDrawUniform("texOcclusion",(e=>e.textureOcclusion))),d.uniforms.add(p===l.BindType.Pass?new o.Float3PassUniform("mrrFactors",(e=>e.mrrFactors)):new s.Float3DrawUniform("mrrFactors",(e=>e.mrrFactors))),d.code.add(a.glsl`
    ${a.If(m,a.glsl`void applyMetallicRoughness(vec2 uv) {
            vec3 metallicRoughness = textureLookup(texMetallicRoughness, uv).rgb;
            mrr[0] *= metallicRoughness.b;
            mrr[1] *= metallicRoughness.g;
          }`)}

    ${a.If(h,"void applyOcclusion(vec2 uv) { occlusion *= textureLookup(texOcclusion, uv).r; }")}

    float getBakedOcclusion() {
      return ${h?"occlusion":"1.0"};
    }

    void applyPBRFactors() {
      mrr = mrrFactors;
      occlusion = 1.0;

      ${a.If(m,`applyMetallicRoughness(${f?"metallicRoughnessUV":"vuv0"});`)}
      ${a.If(h,`applyOcclusion(${g?"occlusionUV":"vuv0"});`)}
    }
  `)}e.PBRRenderingParameters=d,e.PhysicallyBasedRenderingParameters=m,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
