/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","./chunks/tslib.es6","./request","./core/Collection","./core/collectionUtils","./core/JSONSupport","./core/lang","./core/Loadable","./core/loadAll","./core/Logger","./core/maybe","./core/promiseUtils","./core/urlUtils","./core/accessorSupport/decorators/property","./core/has","./core/accessorSupport/decorators/subclass","./core/accessorSupport/decorators/writer","./geometry/SpatialReference","./portal/Portal","./portal/PortalItem","./support/basemapDefinitions","./support/BasemapStyle","./webdoc/support/writeUtils"],(function(e,r,t,a,s,o,i,n,l,c,p,y,d,h,u,f,m,b,L,w,g,I,_){"use strict";var S;let v=0,O=S=class extends(o.JSONSupportMixin(n)){constructor(e){super(e),this.id=null,this.portalItem=null,this.spatialReference=null,this.style=null,this.thumbnailUrl=null,this.title="Basemap",this.id=Date.now().toString(16)+"-basemap-"+v++,this.baseLayers=new a,this.referenceLayers=new a;const r=e=>{e.parent&&e.parent!==this&&"remove"in e.parent&&e.parent.remove(e),e.parent=this,"elevation"===e.type&&c.getLogger(this).error(`Layer '${e.title}, id:${e.id}' of type '${e.type}' is not supported as a basemap layer and will therefore be ignored.`)},t=e=>{e.parent=null};this.addHandles([this.baseLayers.on("after-add",(e=>r(e.item))),this.referenceLayers.on("after-add",(e=>r(e.item))),this.baseLayers.on("after-remove",(e=>t(e.item))),this.referenceLayers.on("after-remove",(e=>t(e.item)))])}initialize(){this.when().catch((e=>{c.getLogger(this).error("#load()",`Failed to load basemap (title: '${this.title}', id: '${this.id}')`,e)})),this.resourceInfo&&this.read(this.resourceInfo.data,this.resourceInfo.context)}destroy(){const e=this.baseLayers.toArray();for(const t of e)t.destroy();const r=this.referenceLayers.toArray();for(const t of r)t.destroy();this.baseLayers.destroy(),this.referenceLayers.destroy(),this.portalItem=p.destroyMaybe(this.portalItem)}normalizeCtorArgs(e){return e&&"resourceInfo"in e&&(this._set("resourceInfo",e.resourceInfo),delete(e={...e}).resourceInfo),e}set baseLayers(e){this._set("baseLayers",s.referenceSetter(e,this._get("baseLayers")))}_writeBaseLayers(e,r,t){const a=[];e?(t={...t,layerContainerType:"basemap"},this.baseLayers.forEach((e=>{const r=_.getLayerJSON(e,t.webmap?t.webmap.getLayerJSONFromResourceInfo(e):null,t);null!=r&&a.push(r)})),this.referenceLayers.forEach((e=>{const r=_.getLayerJSON(e,t.webmap?t.webmap.getLayerJSONFromResourceInfo(e):null,t);null!=r&&("scene"!==e.type&&(r.isReference=!0),a.push(r))})),r.baseMapLayers=a):r.baseMapLayers=a}set referenceLayers(e){this._set("referenceLayers",s.referenceSetter(e,this._get("referenceLayers")))}writeTitle(e,r){r.title=e||"Basemap"}load(e){return this.addResolvingPromise(this._loadFromSource(e)),Promise.resolve(this)}loadAll(){return l.loadAll(this,(e=>{e(this.baseLayers,this.referenceLayers)}))}clone(){const e={id:this.id,title:this.title,portalItem:this.portalItem,baseLayers:this.baseLayers.map((e=>i.isClonable(e)?e.clone():e)),referenceLayers:this.referenceLayers.map((e=>i.isClonable(e)?e.clone():e))};return this.loaded&&(e.loadStatus="loaded"),new S({resourceInfo:this.resourceInfo}).set(e)}read(e,r){this.resourceInfo||this._set("resourceInfo",{data:e,context:r}),super.read(e,r)}write(e,r){return e=e||{},r?.origin||(r={origin:"web-map",...r}),super.write(e,r),!this.loaded&&this.resourceInfo?.data.baseMapLayers&&(e.baseMapLayers=this.resourceInfo.data.baseMapLayers.map((e=>{const r=i.clone(e);return r.url&&d.isProtocolRelative(r.url)&&(r.url=`https:${r.url}`),r.templateUrl&&d.isProtocolRelative(r.templateUrl)&&(r.templateUrl=`https:${r.templateUrl}`),r}))),e}async _loadFromSource(e){const{resourceInfo:r,portalItem:t,style:a}=this;y.throwIfAborted(e);const s=[];if(r){const t=r.context?r.context.url:null;if(s.push(this._loadLayersFromJSON(r.data,t,e)),r.data.id&&!r.data.title){const e=r.data.id;s.push(g.getBasemapTitle(e).then((e=>{e&&this.read({title:e},r.context)})))}}else t?s.push(this._loadFromItem(t,e)):a&&s.push(this._loadFromStylesService(a,e));await Promise.all(s)}async _loadLayersFromJSON(r,t,a){const s=this.resourceInfo?.context,o=this.portalItem?.portal||s?.portal||null,i=x[s?.origin||""]??"web-map",{populateOperationalLayers:n}=await new Promise(((r,t)=>e(["./layers/support/layersCreator"],r,t))),l=[];if(y.throwIfAborted(a),r.baseMapLayers&&Array.isArray(r.baseMapLayers)){const e={context:{...s,origin:i,url:t,portal:o,layerContainerType:"basemap"},defaultLayerType:"DefaultTileLayer"},a=e=>"web-scene"===i&&"ArcGISSceneServiceLayer"===e.layerType||e.isReference,c=n(this.baseLayers,r.baseMapLayers.filter((e=>!a(e))),e);l.push(c);const p=n(this.referenceLayers,r.baseMapLayers.filter(a),e);l.push(p)}await Promise.allSettled(l)}async _loadFromItem(e,r){const t=await e.load(r),a=await t.fetchData("json",r),s=d.urlToObject(e.itemUrl??"");return this._set("resourceInfo",{data:a.baseMap??{},context:{origin:M[e.type||""]??"web-map",portal:e.portal||L.getDefault(),url:s}}),this.read(this.resourceInfo.data,this.resourceInfo.context),this.read({spatialReference:a.spatialReference},this.resourceInfo.context),this.read({title:e.title,thumbnailUrl:e.thumbnailUrl},{origin:"portal-item",portal:e.portal||L.getDefault(),url:s}),this._loadLayersFromJSON(this.resourceInfo.data,s,r)}async _loadFromStylesService(e,r){const a=`${e.serviceUrl}/${e.id}`,s=(await t(a,{query:{language:e.getLanguageParamValue(),places:e.places,worldview:e.worldview,token:e.apiKey},signal:r?.signal})).data,o=d.urlToObject(a);if(this._set("resourceInfo",{data:s.baseMap??{},context:{origin:"web-map",url:o}}),this.read(this.resourceInfo.data,this.resourceInfo.context),this.read({spatialReference:s.spatialReference},this.resourceInfo.context),await this._loadLayersFromJSON(this.resourceInfo.data,o,r),e.apiKey)for(const t of[...this.baseLayers,...this.referenceLayers])"apiKey"in t&&(t.apiKey=e.apiKey)}static fromId(e){const r=g.esriBasemapDefinitions[e];return r?r.itemId?new S({portalItem:{id:r.itemId,portal:{url:"https://www.arcgis.com"}}}):S.fromJSON(r,{origin:r.is3d?"web-scene":"web-map"}):null}};r.__decorate([h.property({json:{write:{ignoreOrigin:!0,target:"baseMapLayers",writer(e,r,t,a){this._writeBaseLayers(e,r,a)}},origins:{"web-scene":{write:{ignoreOrigin:!0,target:{baseMapLayers:{type:a}},writer(e,r,t,a){this._writeBaseLayers(e,r,a)}}}}}})],O.prototype,"baseLayers",null),r.__decorate([h.property({type:String,json:{origins:{"web-scene":{write:!0}}}})],O.prototype,"id",void 0),r.__decorate([h.property({type:w})],O.prototype,"portalItem",void 0),r.__decorate([h.property()],O.prototype,"referenceLayers",null),r.__decorate([h.property({readOnly:!0})],O.prototype,"resourceInfo",void 0),r.__decorate([h.property({type:b})],O.prototype,"spatialReference",void 0),r.__decorate([h.property({type:I})],O.prototype,"style",void 0),r.__decorate([h.property()],O.prototype,"thumbnailUrl",void 0),r.__decorate([h.property({type:String,json:{origins:{"web-scene":{write:{isRequired:!0}}}}})],O.prototype,"title",void 0),r.__decorate([m.writer("title")],O.prototype,"writeTitle",null),O=S=r.__decorate([f.subclass("esri.Basemap")],O);const M={"Web Scene":"web-scene","Web Map":"web-map","Link Chart":"link-chart"},x={"web-scene":"web-scene","web-map":"web-map","link-chart":"link-chart"};return O}));
