/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","./chunks/tslib.es6","./Color","./core/Collection","./core/collectionUtils","./core/compilerUtils","./core/Error","./core/JSONSupport","./core/lang","./core/Loadable","./core/loadAll","./core/Logger","./core/maybe","./core/promiseUtils","./core/accessorSupport/decorators/property","./core/accessorSupport/ensureType","./core/accessorSupport/decorators/subclass","./core/accessorSupport/decorators/writer","./ground/NavigationConstraint","./webdoc/support/opacityUtils"],(function(e,r,t,o,a,s,n,i,l,c,p,y,u,d,h,f,g,v,w,m){"use strict";var _;let S=_=class extends(i.JSONSupportMixin(c)){constructor(e){super(e),this.opacity=1,this.surfaceColor=null,this.navigationConstraint=null,this.layers=new o;const r=e=>{e.parent&&e.parent!==this&&"remove"in e.parent&&e.parent.remove(e),e.parent=this,"elevation"!==e.type&&"base-elevation"!==e.type&&y.getLogger(this).error(`Layer '${e.title}, id:${e.id}' of type '${e.type}' is not supported as a ground layer and will therefore be ignored. Only layers of type 'elevation' are supported.`)},t=e=>{e.parent=null};this.addHandles([this.layers.on("after-add",(e=>r(e.item))),this.layers.on("after-remove",(e=>t(e.item)))])}initialize(){this.when().catch((e=>{d.isAbortError(e)||y.getLogger(this).error("#load()","Failed to load ground",e)})),this.resourceInfo&&this.read(this.resourceInfo.data,this.resourceInfo.context)}destroy(){const e=this.layers.removeAll();for(const r of e)u.destroyMaybe(r);this.layers.destroy()}normalizeCtorArgs(e){return e&&"resourceInfo"in e&&(this._set("resourceInfo",e.resourceInfo),delete(e={...e}).resourceInfo),e}set layers(e){this._set("layers",a.referenceSetter(e,this._get("layers")))}writeLayers(e,r,t,o){const a=[];e?(o={...o,layerContainerType:"ground"},e.forEach((e=>{if("write"in e){const r={};s.typeCast(e)().write(r,o)&&a.push(r)}else o?.messages&&o.messages.push(new n("layer:unsupported",`Layers (${e.title}, ${e.id}) of type '${e.declaredClass}' cannot be persisted in the ground`,{layer:e}))})),r.layers=a):r.layers=a}load(e){return this.addResolvingPromise(this._loadFromSource(e)),Promise.resolve(this)}loadAll(){return p.loadAll(this,(e=>{e(this.layers)}))}async queryElevation(r,t){await this.load({signal:t?.signal});const{ElevationQuery:o}=await new Promise(((r,t)=>e(["./layers/support/ElevationQuery"],r,t)));d.throwIfAborted(t);const a=new o,s=this.layers.filter(I).toArray();return a.queryAll(s,r,t)}async createElevationSampler(r,t){await this.load({signal:t?.signal});const{ElevationQuery:o}=await new Promise(((r,t)=>e(["./layers/support/ElevationQuery"],r,t)));d.throwIfAborted(t);const a=new o,s=this.layers.filter(I).toArray();return a.createSamplerAll(s,r,t)}clone(){const e={opacity:this.opacity,surfaceColor:l.clone(this.surfaceColor),navigationConstraint:l.clone(this.navigationConstraint),layers:this.layers.slice()};return this.loaded&&(e.loadStatus="loaded"),new _({resourceInfo:this.resourceInfo}).set(e)}read(e,r){this.resourceInfo||this._set("resourceInfo",{data:e,context:r}),super.read(e,r)}_loadFromSource(e){const r=this.resourceInfo;return r?this._loadLayersFromJSON(r.data,r.context,e):Promise.resolve()}async _loadLayersFromJSON(r,t,o){const a=t?.origin||"web-scene",s=t?.portal||null,n=t?.url||null,{populateOperationalLayers:i}=await new Promise(((r,t)=>e(["./layers/support/layersCreator"],r,t)));d.throwIfAborted(o);const l=[];if(r.layers&&Array.isArray(r.layers)){const e={context:{origin:a,url:n,portal:s,layerContainerType:"ground"},defaultLayerType:"ArcGISTiledElevationServiceLayer"};l.push(i(this.layers,r.layers,e))}await Promise.allSettled(l)}};function C(e){return e&&"createElevationSampler"in e}function I(e){return"elevation"===e.type||C(e)}r.__decorate([h.property({json:{read:!1}})],S.prototype,"layers",null),r.__decorate([v.writer("layers")],S.prototype,"writeLayers",null),r.__decorate([h.property({readOnly:!0})],S.prototype,"resourceInfo",void 0),r.__decorate([h.property({type:Number,nonNullable:!0,range:{min:0,max:1},json:{type:f.Integer,read:{reader:m.transparencyToOpacity,source:"transparency"},write:{writer:(e,r)=>{r.transparency=m.opacityToTransparency(e)},target:"transparency"}}})],S.prototype,"opacity",void 0),r.__decorate([h.property({type:t,json:{type:[f.Integer],write:(e,r)=>{r.surfaceColor=e.toJSON().slice(0,3)}}})],S.prototype,"surfaceColor",void 0),r.__decorate([h.property({type:w.NavigationConstraint,json:{write:!0}})],S.prototype,"navigationConstraint",void 0),S=_=r.__decorate([g.subclass("esri.Ground")],S);return S}));
