/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["./chunks/tslib.es6","./core/Clonable","./core/Collection","./core/JSONSupport","./core/lang","./core/Logger","./core/promiseUtils","./core/accessorSupport/decorators/property","./core/accessorSupport/decorators/cast","./core/accessorSupport/decorators/reader","./core/accessorSupport/decorators/subclass","./core/accessorSupport/decorators/writer","./core/accessorSupport/ensureType","./layers/support/fieldUtils","./popup/content","./popup/ExpressionInfo","./popup/FieldInfo","./popup/LayerOptions","./popup/RelatedRecordsInfo","./popup/content/support/mediaInfoTypes","./support/actions/ActionBase","./support/actions/ActionButton","./support/actions/ActionToggle","./popup/content/MediaContent","./popup/content/TextContent","./popup/content/AttachmentsContent","./popup/content/FieldsContent","./popup/content/ExpressionContent","./popup/content/RelationshipContent","./popup/content/UtilityNetworkAssociationsContent","./popup/content/Content","./popup/content/CustomContent"],(function(e,t,o,s,i,r,n,p,a,l,d,c,f,u,y,h,m,_,I,w,F,x,g,N,A,C,S,O,b,E,R,T){"use strict";const v="relationships/",J="expression/",L=o.ofType({key:"type",defaultKeyValue:"button",base:F,typeMap:{button:x,toggle:g}}),B={base:R,key:"type",typeMap:{media:N,custom:T,text:A,attachments:C,fields:S,expression:O,relationship:b,utilityNetworkAssociations:E}},M=new Set(["attachments","fields","media","text","expression","relationship"]),k=new Set([...M,"utility-network-associations"]);let P=class extends(t.ClonableMixin(s.JSONSupport)){constructor(){super(...arguments),this.actions=null,this.content="",this.expressionInfos=null,this.fieldInfos=null,this.layerOptions=null,this.lastEditInfoEnabled=!0,this.outFields=null,this.overwriteActions=!1,this.returnGeometry=!1,this.title=""}castContent(e){return Array.isArray(e)?e.map((e=>f.ensureOneOfType(B,e))):"string"==typeof e||"function"==typeof e||e instanceof HTMLElement||n.isPromiseLike(e)?e:(r.getLogger(this).error("content error","unsupported content value",{value:e}),null)}readContent(e,t){const{popupElements:o}=t;return Array.isArray(o)&&o.length>0?this._readPopupInfoElements(t.description,t.mediaInfos,o):this._readPopupInfo(t)}writeWebSceneContent(e,t,o,s){this._writePopupTemplateContent(e,t,s)}writeWebMapContent(e,t,o,s){this._writePopupTemplateContent(e,t,s)}writeFieldInfos(e,t,o,s){const{content:i}=this,r=Array.isArray(i)?i:null;if(e){const o=r?r.filter((e=>"fields"===e.type)):[],i=o.length&&o.every((e=>e.fieldInfos?.length));t.fieldInfos=e.filter(Boolean).map((e=>{const t=e.toJSON(s);return i&&(t.visible=!1),t}))}if(r)for(const n of r)"fields"===n.type&&this._writeFieldsContent(n,t)}writeLayerOptions(e,t,o,s){t[o]=!e||null===e.showNoDataRecords&&null===e.returnTopmostRaster?null:e.toJSON(s)}writeTitle(e,t){t.title=e||""}async collectRequiredFields(e,t){const o=this.expressionInfos||[];await this._collectExpressionInfoFields(e,t,[...o,...this._getContentExpressionInfos(this.content,o)]),u.collectFields(e,t,[...this.outFields||[],...this._getActionsFields(this.actions),...this._getTitleFields(this.title),...this._getContentFields(this.content)])}async getRequiredFields(e){const t=new Set;return await this.collectRequiredFields(t,e),[...t].sort()}_writePopupTemplateContent(e,t,o){"string"!=typeof e?Array.isArray(e)&&(t.popupElements=e.filter((e=>"web-scene"===o?.origin?M.has(e.type):k.has(e.type))).map((e=>e?.toJSON(o))),t.popupElements.forEach((e=>{"attachments"===e.type?this._writeAttachmentContent(t):"media"===e.type?this._writeMediaContent(e,t):"text"===e.type?this._writeTextContent(e,t):"relationship"===e.type&&this._writeRelationshipContent(e,t)}))):t.description=e}_writeFieldsContent(e,t){if(!Array.isArray(e.fieldInfos)||!e.fieldInfos.length)return;const o=i.clone(e.fieldInfos);Array.isArray(t.fieldInfos)?o.forEach((e=>{const o=t.fieldInfos.find((t=>t.fieldName?.toLowerCase()===e.fieldName?.toLowerCase()));o?o.visible=!0:t.fieldInfos.push(e)})):t.fieldInfos=o}_writeAttachmentContent(e){e.showAttachments||(e.showAttachments=!0)}_writeRelationshipContent(e,t){const o=e.orderByFields?.map((t=>this._toFieldOrderJSON(t,e.relationshipId)))||[],s=[...t.relatedRecordsInfo?.orderByFields||[],...o];t.relatedRecordsInfo={showRelatedRecords:!0,...s?.length&&{orderByFields:s}}}_writeTextContent(e,t){!t.description&&e.text&&(t.description=e.text)}_writeMediaContent(e,t){if(!Array.isArray(e.mediaInfos)||!e.mediaInfos.length)return;const o=i.clone(e.mediaInfos);Array.isArray(t.mediaInfos)?t.mediaInfos=[...t.mediaInfos,...o]:t.mediaInfos=o}_readPopupInfoElements(e,t,o){const s={description:!1,mediaInfos:!1};return o.map((o=>"media"===o.type?(o.mediaInfos||!t||s.mediaInfos||(o.mediaInfos=t,s.mediaInfos=!0),N.fromJSON(o)):"text"===o.type?(o.text||!e||s.description||(o.text=e,s.description=!0),A.fromJSON(o)):"attachments"===o.type?C.fromJSON(o):"fields"===o.type?S.fromJSON(o):"expression"===o.type?O.fromJSON(o):"relationship"===o.type?b.fromJSON(o):"utilityNetworkAssociations"===o.type?E.fromJSON(o):void 0)).filter(Boolean)}_toRelationshipContent(e){const{field:t,order:o}=e;if(!t?.startsWith(v))return null;const s=t.replace(v,"").split("/");if(2!==s.length)return null;const i=parseInt(s[0],10),r=s[1];return"number"==typeof i&&r?b.fromJSON({relationshipId:i,orderByFields:[{field:r,order:o}]}):null}_toFieldOrderJSON(e,t){const{order:o,field:s}=e;return{field:`${v}${t}/${s}`,order:o}}_readPopupInfo({description:e,mediaInfos:t,showAttachments:o,relatedRecordsInfo:s={showRelatedRecords:!1}}){const i=[];e?i.push(new A({text:e})):i.push(new S),Array.isArray(t)&&t.length&&i.push(N.fromJSON({mediaInfos:t})),o&&i.push(C.fromJSON({displayType:"auto"}));const{showRelatedRecords:r,orderByFields:n}=s;return r&&n?.length&&n.forEach((e=>{const t=this._toRelationshipContent(e);t&&i.push(t)})),i.length?i:e}_getContentElementFields(e){const t=e?.type;if("attachments"===t)return[...this._extractFieldNames(e.title),...this._extractFieldNames(e.description)];if("custom"===t)return e.outFields||[];if("fields"===t)return[...this._extractFieldNames(e.title),...this._extractFieldNames(e.description),...this._getFieldInfoFields(e.fieldInfos??this.fieldInfos)];if("media"===t){const t=e.mediaInfos||[];return[...this._extractFieldNames(e.title),...this._extractFieldNames(e.description),...t.reduce(((e,t)=>[...e,...this._getMediaInfoFields(t)]),[])]}return"text"===t?this._extractFieldNames(e.text):"relationship"===t||"utility-network-associations"===t?[...this._extractFieldNames(e.title),...this._extractFieldNames(e.description)]:[]}_getMediaInfoFields(e){const{caption:t,title:o,value:s}=e,i=s||{},{fields:r,normalizeField:n,tooltipField:p,sourceURL:a,linkURL:l}=i,d=[...this._extractFieldNames(o),...this._extractFieldNames(t),...this._extractFieldNames(a),...this._extractFieldNames(l),...r??[]];return n&&d.push(n),p&&d.push(p),d}_getContentExpressionInfos(e,t){return Array.isArray(e)?e.reduce(((e,t)=>[...e,..."expression"===t.type&&t.expressionInfo?[t.expressionInfo]:[]]),t):[]}_getContentFields(e){return"string"==typeof e?this._extractFieldNames(e):Array.isArray(e)?e.reduce(((e,t)=>[...e,...this._getContentElementFields(t)]),[]):[]}async _collectExpressionInfoFields(e,t,o){o&&await Promise.all(o.map((o=>u.collectArcadeFieldNames(e,t,o.expression))))}_getFieldInfoFields(e){return e?e.filter((({fieldName:e,visible:t})=>!(void 0!==t&&!t||!e||e.startsWith(v)||e.startsWith(J)))).map((e=>e.fieldName)):[]}_getActionsFields(e){return e?e.toArray().reduce(((e,t)=>[...e,...this._getActionFields(t)]),[]):[]}_getActionFields(e){const{className:t,title:o,type:s}=e,i="button"===s||"toggle"===s?e.image:"";return[...this._extractFieldNames(o),...this._extractFieldNames(t),...this._extractFieldNames(i)]}_getTitleFields(e){return"string"==typeof e?this._extractFieldNames(e):[]}_extractFieldNames(e){return u.extractSubstitutionTemplatesFromString(e).filter((e=>!(0===e.indexOf(v)||0===e.indexOf(J))))}};e.__decorate([p.property({type:L})],P.prototype,"actions",void 0),e.__decorate([p.property()],P.prototype,"content",void 0),e.__decorate([a.cast("content")],P.prototype,"castContent",null),e.__decorate([l.reader("content",["description","fieldInfos","popupElements","mediaInfos","showAttachments","relatedRecordsInfo"])],P.prototype,"readContent",null),e.__decorate([c.writer("web-scene","content",{popupElements:{type:o.ofType(y.persistableWebSceneTypes)},showAttachments:{type:Boolean},mediaInfos:{type:o.ofType(w.types)},description:{type:String},relatedRecordsInfo:{type:I}})],P.prototype,"writeWebSceneContent",null),e.__decorate([c.writer("content",{popupElements:{type:o.ofType(y.persistableTypes)},showAttachments:{type:Boolean},mediaInfos:{type:o.ofType(w.types)},description:{type:String},relatedRecordsInfo:{type:I}})],P.prototype,"writeWebMapContent",null),e.__decorate([p.property({type:[h],json:{write:!0}})],P.prototype,"expressionInfos",void 0),e.__decorate([p.property({type:[m]})],P.prototype,"fieldInfos",void 0),e.__decorate([c.writer("fieldInfos")],P.prototype,"writeFieldInfos",null),e.__decorate([p.property({type:_})],P.prototype,"layerOptions",void 0),e.__decorate([c.writer("layerOptions")],P.prototype,"writeLayerOptions",null),e.__decorate([p.property({type:Boolean,json:{read:{source:"showLastEditInfo"},write:{target:"showLastEditInfo"},default:!0}})],P.prototype,"lastEditInfoEnabled",void 0),e.__decorate([p.property()],P.prototype,"outFields",void 0),e.__decorate([p.property()],P.prototype,"overwriteActions",void 0),e.__decorate([p.property()],P.prototype,"returnGeometry",void 0),e.__decorate([p.property({json:{type:String}})],P.prototype,"title",void 0),e.__decorate([c.writer("title")],P.prototype,"writeTitle",null),P=e.__decorate([d.subclass("esri.PopupTemplate")],P);return P}));
