/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","./chunks/tslib.es6","./core/Accessor","./core/Collection","./core/reactiveUtils","./core/accessorSupport/decorators/property","./core/has","./core/Logger","./core/RandomLCG","./core/accessorSupport/decorators/subclass","./core/support/UpdatingHandles","./undoredo/OperationStatus","./undoredo/UndoableOperation","./undoredo/UndoRedoError"],(function(t,o,e,s,i,n,a,d,r,c,h,p,_,u){"use strict";t.UndoRedo=class extends e{constructor(){super(...arguments),this._stack=new s,this._stackPosition=-1,this._updatingHandles=new h.UpdatingHandles}get updating(){return this._updatingHandles.updating}get canUndo(){return this.hasUndo&&!this.updating}get hasUndo(){return this._stackPosition>=0}get canRedo(){return this.hasRedo&&!this.updating}get hasRedo(){return this._stackPosition<this._stack.length-1}_truncateForwardStack(){this._stack.splice(this._stackPosition+1,this._stack.length-this._stackPosition).forEach((t=>t.destroy()))}_drainStack(){this._stack.drain((t=>t.destroy())),this._stackPosition=-1}async undo(){if(!this.hasUndo)throw new u.UndoInvalidError;if(this.updating)throw new u.UndoRedoUpdatingError;const t=this._stack.getItemAt(this._stackPosition);t&&await this._updatingHandles.addPromise((async()=>{await t.executeUndoRedoOperation(_.UndoRedoExecutionMethod.Undo),--this._stackPosition,t.canRedo||this._truncateForwardStack()})())}async redo(){if(!this.hasRedo)throw new u.RedoInvalidError;if(this.updating)throw new u.UndoRedoUpdatingError;const t=this._stack.getItemAt(this._stackPosition+1);if(!t)throw new u.RedoInvalidError;await this._updatingHandles.addPromise((async()=>{await t.executeUndoRedoOperation(_.UndoRedoExecutionMethod.Redo),++this._stackPosition})())}peekUndo(){if(this.canUndo)return this._stack.getItemAt(this._stackPosition)}peekRedo(){if(this.canRedo)return this._stack.getItemAt(this._stackPosition+1)}async inject(t){if(this.updating)throw new u.UndoRedoUpdatingError;await this._updatingHandles.addPromise((async()=>{t.status===p.OperationStatus.NeverApplied&&await t.executeUndoRedoOperation(_.UndoRedoExecutionMethod.Apply),t.canUndo?(this._stack.splice(this._stackPosition+1,0,t),this._stackPosition++):this._stackPosition>-1&&(this._stack.splice(0,this._stackPosition+1).forEach((t=>t.destroy())),this._stackPosition=-1)})())}async add(t){if(this.updating)throw new u.UndoRedoUpdatingError;await this._updatingHandles.addPromise((async()=>{t.status===p.OperationStatus.NeverApplied&&await t.executeUndoRedoOperation(_.UndoRedoExecutionMethod.Apply),this._stackPosition>=-1&&this._truncateForwardStack(),t.canUndo?(this._stack.push(t),this._stackPosition=this._stack.length-1):this._drainStack()})())}async removeTagged(t,o=!1){if(this.updating&&!o)return;await i.whenOnce((()=>!this.updating));const e=new s;for(let s=0;s<this._stack.length;s++){const o=this._stack.getItemAt(s);o&&(o.tag===t?(o.destroy(),s===this._stackPosition&&(this._stackPosition=e.length-1)):e.push(o))}this._stack=e,this._stackPosition>e.length-1&&(this._stackPosition=e.length-1)}async clear(t=!1){if(this.updating&&!t)throw new u.UndoRedoUpdatingError;await i.whenOnce((()=>!this.updating)),this._drainStack()}},o.__decorate([n.property()],t.UndoRedo.prototype,"_stack",void 0),o.__decorate([n.property()],t.UndoRedo.prototype,"_stackPosition",void 0),o.__decorate([n.property()],t.UndoRedo.prototype,"updating",null),o.__decorate([n.property({readOnly:!0})],t.UndoRedo.prototype,"canUndo",null),o.__decorate([n.property({readOnly:!0})],t.UndoRedo.prototype,"hasUndo",null),o.__decorate([n.property({readOnly:!0})],t.UndoRedo.prototype,"canRedo",null),o.__decorate([n.property({readOnly:!0})],t.UndoRedo.prototype,"hasRedo",null),t.UndoRedo=o.__decorate([c.subclass("esri.UndoRedo")],t.UndoRedo),Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
