/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","./chunks/tslib.es6","./kernel","./Map","./Viewpoint","./core/arrayUtils","./core/Collection","./core/Error","./core/Loadable","./core/loadAll","./core/Logger","./core/maybe","./core/MultiOriginJSONSupport","./core/Promise","./core/promiseUtils","./core/reactiveUtils","./core/urlUtils","./core/accessorSupport/decorators/property","./core/has","./core/accessorSupport/decorators/reader","./core/accessorSupport/decorators/subclass","./core/accessorSupport/decorators/writer","./core/accessorSupport/read","./geometry/SpatialReference","./portal/PortalItem","./portal/support/portalItemUtils","./support/MapFloorInfo","./time/TimeExtent","./webdoc/interfaces","./webdoc/RangeInfo","./webdoc/Widgets","./webdoc/support/thumbnailUtils","./webdoc/support/webdocLoadUtils","./webdoc/support/writeUtils","./webmap/ApplicationProperties","./webmap/Bookmark","./webmap/InitialViewProperties","./webmap/Version","./webmap/background/ColorBackground"],(function(e,t,r,i,o,a,n,s,p,l,u,h,c,d,m,g,y,b,w,_,f,A,S,v,V,I,U,O,P,x,L,F,T,E,R,k,N,B,j){"use strict";const J=n.ofType(k),M=new Map([["image/jpeg","jpeg"],["image/jpg","jpg"],["image/png","png"],["image/gif","gif"]]),Z="ArcGIS Pro",C=I.typeKeyword.JSAPI;let D=class extends(c.MultiOriginJSONMixin(p.LoadableMixin(d.EsriPromiseMixin(i)))){constructor(t){super(t),this._isAuthoringAppSetByUser=!1,this._isAuthoringAppVersionSetByUser=!1,this._thumbnailFilename=null,this._updateFromPromise=null,this.resourceReferences={portalItem:null,paths:[]},this.applicationProperties=null,this.bookmarks=new J,this.floorInfo=null,this.initialViewProperties=new N,this.portalItem=null,this.sourceVersion=null,this.widgets=null,this._debouncedSaveOperations=m.debounce((async(t,r,i)=>{const{save:o,saveAs:a}=await new Promise(((t,r)=>e(["./webdoc/support/webdocSaveUtils"],t,r)));switch(t){case P.SaveOperationType.SAVE:return o(this.context,this,r);case P.SaveOperationType.SAVE_AS:return a(this.context,this,i,r)}})),this.authoringApp=this.authoringAppVersion=null,this._isAuthoringAppSetByUser=this._isAuthoringAppVersionSetByUser=!1}destroy(){this.portalItem=h.destroyMaybe(this.portalItem)}initialize(){if(this.when().catch((e=>{u.getLogger(this).error("#load()","Failed to load web map",e)})),this.resourceInfo){let t;try{t=this._validateJSON(this.resourceInfo)}catch(e){return void this.addResolvingPromise(Promise.reject(e))}this.read(t)}}set authoringApp(e){this._isAuthoringAppSetByUser=!0,this._set("authoringApp",e)}writeAuthoringApp(e,t){e&&this._isAuthoringAppSetByUser?t.authoringApp=e:t.authoringApp=C}set authoringAppVersion(e){this._isAuthoringAppVersionSetByUser=!0,this._set("authoringAppVersion",e)}writeAuthoringAppVersion(e,t){e&&this._isAuthoringAppVersionSetByUser?t.authoringAppVersion=e:t.authoringAppVersion=r.version}readInitialViewProperties(e,t){const r=new N;t.background&&(r.background=j.fromJSON(t.background));const i=t.initialState?.timeExtent;i&&(r.timeExtent=O.fromArray(i));const a=t.initialState?.viewpoint;if(a){if(a.rotation){B.Version.parse(t.version||"","webmap").lessThan(2,20)&&t.authoringApp===Z&&(a.rotation*=-1)}r.viewpoint=o.fromJSON(a)}return t.mapRangeInfo&&(r.rangeInfo=x.fromJSON(t.mapRangeInfo)),t.spatialReference&&(r.spatialReference=v.fromJSON(t.spatialReference)),t.timeZone&&(r.timeZone=t.timeZone),r}writeInitialViewProperties(e,t,r,i){if(!e)return;e.background?.color&&(t.background=e.background.write({},i));const{timeExtent:o,viewpoint:a}=e;if(a||o){const e={};a&&(e.viewpoint=a.write({},i)),o&&(e.timeExtent=o.toArray()),t.initialState=e}e.rangeInfo&&(t.mapRangeInfo=e.rangeInfo.toJSON(i)),e.spatialReference&&(t.spatialReference=e.spatialReference.write({},i)),t.timeZone=e.timeZone}writeLayers(e,t,r,i){t[r]=this._writeLayers(e,i,"operational-layers")}readSourceVersion(e,t){const[r,i]=t.version.split(".");return new B.Version(parseInt(r,10),parseInt(i,10))}writeSourceVersion(e,t,r){t[r]=`${this.context.currentVersion.major}.${this.context.currentVersion.minor}`}writeTables(e,t,r,i){const o=this._writeLayers(e,i,"tables");o.length&&(t[r]=o)}get thumbnailUrl(){return this.portalItem?.thumbnailUrl||null}set thumbnailUrl(e){e?(this._override("thumbnailUrl",e),this._thumbnailFilename=this._generateCustomThumbnailFilename(e)):this._clearThumbnailOverride()}get updatingFromView(){return!!this._updateFromPromise}load(e){return this.addResolvingPromise(T.loadFromSource(this.context,this)),Promise.resolve(this)}loadAll(){return l.loadAll(this,(e=>{e(this.ground,this.basemap,this.layers,this.tables)}))}read(e,t){t={...t,origin:this.context.origin};const r=this._getAuthoringPropsState();S.readLoadable(this,e,(t=>super.read(e,t)),t),this._restoreAuthoringPropsFromState(r)}write(e,t){if("loaded"!==this.loadStatus){const e=new s("webmap:not-loaded","Web map must be loaded before it can be serialized");throw u.getLogger(this).error("#toJSON()","Web map must be loaded before it can be serialized",this.loadError||this.loadStatus),e}return this._removeDanglingLayerRefs(),t={...t,origin:this.context.origin,restrictedWebMapWriting:!0,webmap:this},super.write(e,t)}async save(e){return this._debouncedSaveOperations(P.SaveOperationType.SAVE,e)}async saveAs(e,t){return this._debouncedSaveOperations(P.SaveOperationType.SAVE_AS,t,e)}async updateFrom(e,t){const r=this._updateFromInternal(e,t);this._updateFromPromise=r,await r;r===this._updateFromPromise&&(this._updateFromPromise=null)}getLayerJSONFromResourceInfo(e){const t=this.resourceInfo;return this._collectAllLayersJSON([...t?.baseMap?.baseMapLayers||[],...t?.operationalLayers||[],...this.basemap?.resourceInfo?.data?.baseMapLayers||[]]).find((t=>t.id===e.id))}async updateItemThumbnail(){this.thumbnailUrl&&this._isOverridden("thumbnailUrl")&&(await(this.portalItem?.updateThumbnail({thumbnail:this.thumbnailUrl,filename:this._thumbnailFilename})),this._clearThumbnailOverride())}getThumbnailState(){let e=this.thumbnailUrl;return e&&(e=this._isOverridden("thumbnailUrl")?e:y.addQueryParameter(e,"w","8192")),{thumbnailUrl:e,filename:this._thumbnailFilename}}restoreThumbnailFromState(e){this.thumbnailUrl=e.thumbnailUrl,this._thumbnailFilename=e.filename}_collectAllLayersJSON(e){return e.reduce(((e,t)=>(e.push(t),"GroupLayer"===t.layerType&&(e=e.concat(this._collectAllLayersJSON(t.layers||[]))),e)),[])}_writeLayers(e,t,r){t={...t,layerContainerType:r};return e.map((e=>E.getLayerJSON(e,"tables"===r?null:this.getLayerJSONFromResourceInfo(e),t))).filter(a.isSome).toArray()}_validateJSON(e){const t=B.Version.parse(e.version||"","webmap");return this.context.currentVersion.validate(t),e.version=`${t.major}.${t.minor}`,e}_removeDanglingLayerRefs(){const e=this.applicationProperties,t=e?.viewing?.search,r=e=>this.allLayers.some((t=>t.id===e));if(t?.layers&&(t.layers=t.layers.filter((e=>r(e.id)))),t?.tables&&(t.tables=t.tables.filter((e=>this.tables.some((t=>t.id===e.id))))),e){const t=e.editing?.locationTracking;t?.info&&!r(t.info.layerId)&&(e.editing=null)}const i="presentation"in this?this.presentation:null,o=i?.slides;o&&o.forEach((e=>{e.visibleLayers&&(e.visibleLayers=e.visibleLayers.filter((e=>r(e.id))))}))}async _updateFromInternal(e,t){if(t??={},await g.whenOnce((()=>e.ready)),this._updateInitialViewProperties(e,t),e.map===this)for(const r of e.allLayerViews)"visible"in r&&"visible"in r.layer&&r._isOverridden("visible")&&(r.layer.visible=r.visible),"featureEffect"in r&&"featureEffect"in r.layer&&r._isOverridden("featureEffect")&&(r.layer.featureEffect=r.featureEffect);await this._updateThumbnailUrl(e,t)}_updateInitialViewProperties(e,t){if(t.backgroundExcluded||(this.initialViewProperties.background=e.background?.clone()),this.initialViewProperties.spatialReference=e.spatialReference?.clone(),this.initialViewProperties.timeZone=e.timeZone,t.viewpointExcluded||(this.initialViewProperties.viewpoint=new o({rotation:e.rotation,scale:t.scalePreserved?e.scale:null,targetGeometry:this._getViewExtent(e)})),!t.widgetsExcluded)for(const r of e.persistableViewModels)r.updateWebDocument(this)}_getViewExtent(e){const t=e.center.clone().normalize(),r=e.extent.clone(),i=r.width/2;return r.xmin=t.x-i,r.xmax=t.x+i,r}async _updateThumbnailUrl(e,t){if(t.thumbnailExcluded)return;const r=F.getOptimalThumbnailSize(e,t.thumbnailSize),i=await e.takeScreenshot({format:"png",width:r.width,height:r.height});this._setAutoGeneratedThumbnail(i.dataUrl)}_setAutoGeneratedThumbnail(e){this.thumbnailUrl=e,this._thumbnailFilename=null}_clearThumbnailOverride(){this._clearOverride("thumbnailUrl"),this.clear("thumbnailUrl","user"),this._thumbnailFilename=null}_generateCustomThumbnailFilename(e){if(y.isDataProtocol(e)){const t=y.dataComponents(e),r=t?.mediaType,i=r&&M.get(r.toLowerCase())||null,o=`thumbnail${Date.now()}`;return i?`${o}.${i}`:o}return null}_getAuthoringPropsState(){return{authoringApp:this.authoringApp,authoringAppVersion:this.authoringAppVersion,isAuthoringAppSetByUser:this._isAuthoringAppSetByUser,isAuthoringAppVersionSetByUser:this._isAuthoringAppVersionSetByUser}}_restoreAuthoringPropsFromState(e){e.isAuthoringAppSetByUser?this.authoringApp=e.authoringApp:this._isAuthoringAppSetByUser=!1,e.isAuthoringAppVersionSetByUser?this.authoringAppVersion=e.authoringAppVersion:this._isAuthoringAppVersionSetByUser=!1}};t.__decorate([b.property()],D.prototype,"_updateFromPromise",void 0),t.__decorate([b.property({type:R,json:{write:!0}})],D.prototype,"applicationProperties",void 0),t.__decorate([b.property({type:String,json:{write:{allowNull:!0,ignoreOrigin:!0}}})],D.prototype,"authoringApp",null),t.__decorate([A.writer("authoringApp")],D.prototype,"writeAuthoringApp",null),t.__decorate([b.property({type:String,json:{write:{allowNull:!0,ignoreOrigin:!0}}})],D.prototype,"authoringAppVersion",null),t.__decorate([A.writer("authoringAppVersion")],D.prototype,"writeAuthoringAppVersion",null),t.__decorate([b.property({type:J,json:{write:{overridePolicy:e=>({enabled:!!(e&&e.length>0),ignoreOrigin:!0})}}})],D.prototype,"bookmarks",void 0),t.__decorate([b.property({type:U,json:{name:"mapFloorInfo",write:!0}})],D.prototype,"floorInfo",void 0),t.__decorate([b.property({type:N,nonNullable:!0,json:{read:{source:["background","initialState.timeExtent","initialState.viewpoint","mapRangeInfo","spatialReference","timeZone"]},write:{ignoreOrigin:!0,target:{background:{type:j},"initialState.timeExtent":{type:O},"initialState.viewpoint":{type:o},mapRangeInfo:{type:x},spatialReference:{type:v},"timeZone:":{type:String}}}}})],D.prototype,"initialViewProperties",void 0),t.__decorate([_.reader("initialViewProperties")],D.prototype,"readInitialViewProperties",null),t.__decorate([A.writer("initialViewProperties")],D.prototype,"writeInitialViewProperties",null),t.__decorate([b.property({json:{read:!1,write:{target:"operationalLayers",ignoreOrigin:!0}}})],D.prototype,"layers",void 0),t.__decorate([A.writer("layers")],D.prototype,"writeLayers",null),t.__decorate([b.property({type:V})],D.prototype,"portalItem",void 0),t.__decorate([b.property()],D.prototype,"resourceInfo",void 0),t.__decorate([b.property({readOnly:!0,type:B.Version,json:{read:{source:"version"},write:{allowNull:!0,ignoreOrigin:!0,target:"version",isRequired:!0}}})],D.prototype,"sourceVersion",void 0),t.__decorate([_.reader("sourceVersion")],D.prototype,"readSourceVersion",null),t.__decorate([A.writer("sourceVersion")],D.prototype,"writeSourceVersion",null),t.__decorate([b.property({json:{read:!1,write:{ignoreOrigin:!0}}})],D.prototype,"tables",void 0),t.__decorate([A.writer("tables")],D.prototype,"writeTables",null),t.__decorate([b.property()],D.prototype,"thumbnailUrl",null),t.__decorate([b.property()],D.prototype,"updatingFromView",null),t.__decorate([b.property({type:L,json:{write:!0}})],D.prototype,"widgets",void 0),D=t.__decorate([f.subclass("esri.WebDocument2D")],D);return D}));
