/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","./chunks/tslib.es6","./kernel","./Map","./Viewpoint","./core/Collection","./core/Error","./core/lang","./core/Loadable","./core/loadAll","./core/Logger","./core/maybe","./core/MultiOriginJSONSupport","./core/Promise","./core/promiseUtils","./core/reactiveUtils","./core/urlUtils","./core/accessorSupport/decorators/property","./core/has","./core/accessorSupport/decorators/reader","./core/accessorSupport/decorators/subclass","./core/accessorSupport/decorators/writer","./core/accessorSupport/originUtils","./core/accessorSupport/read","./geometry/Extent","./geometry/HeightModelInfo","./geometry/projection","./geometry/SpatialReference","./geometry/support/heightModelInfoUtils","./geometry/support/jsonUtils","./geometry/support/spatialReferenceUtils","./portal/Portal","./portal/PortalItem","./portal/support/jsonContext","./portal/support/portalItemUtils","./support/basemapUtils","./support/MapFloorInfo","./support/tagSymbols","./support/webSceneUtils","./time/TimeExtent","./views/ViewingMode","./views/support/spatialReferenceSupport","./webdoc/interfaces","./webdoc/Widgets","./webdoc/support/resourceUtils","./webdoc/support/saveUtils","./webdoc/support/thumbnailUtils","./webdoc/support/webdocSaveUtils","./webscene/ApplicationProperties","./webscene/Environment","./webscene/InitialViewProperties","./webscene/Presentation","./webscene/TransportationNetwork","./webscene/Version","./webscene/support/schemaValidatorLoader"],(function(e,t,r,i,o,a,s,n,l,p,c,d,h,u,y,w,m,g,b,v,f,_,S,A,I,L,O,V,R,E,M,P,U,T,j,N,C,x,W,F,G,J,$,B,q,k,D,K,z,H,Q,X,Y,Z,ee){"use strict";var te;const re=new Z.Version(1,35),ie=()=>{const e=8,t=[],r=re.major;for(let i=e;i<=re.minor;i++)t.push(`${r}.${i}`);return t},oe="Web Scene";let ae=class extends(l.LoadableMixin(u.EsriPromiseMixin(h.MultiOriginJSONMixin(i)))){constructor(e){super(e),this[te]=!0,this._layersIdGCTimeoutId=void 0,this._updateFromPromise=null,this.applicationProperties=null,this.clippingArea=null,this.clippingEnabled=!1,this.floorInfo=null,this.heightModelInfo=void 0,this.sourceVersion=null,this.transportationNetworks=null,this.presentation=new X,this.initialViewProperties=new Q,this.portalItem=null,this.resourceInfo=null,this.widgets=null,this._debouncedSaveOperations=y.debounce((async(e,t,r)=>{switch(e){case $.SaveOperationType.SAVE:return this._saveImpl(t);case $.SaveOperationType.SAVE_AS:return this._saveAsImpl(r,t)}})),this._resourceReferences={portalItem:null,paths:[]},this.authoringApp=null,this.authoringAppVersion=null,this._isAuthoringAppSetByUser=!1,this._isAuthoringAppVersionSetByUser=!1}initialize(){if(this.when().catch((e=>{c.getLogger(this).error("#load()","Failed to load web scene",e)})),this.resourceInfo){let t;try{t=this._validateJSON(this.resourceInfo)}catch(e){return void this.addResolvingPromise(Promise.reject(e))}this.read(t),this.addResolvingPromise(this._validateSpatialReference()),this.addResolvingPromise(this._validateHeightModelInfo())}this.addHandles(w.on((()=>this.allLayers),"change",(()=>this._scheduleLayersIdGC())))}destroy(){this._unscheduleLayersIdGC(),this.presentation&&this.presentation.destroy(),this.portalItem=d.destroyMaybe(this.portalItem)}writeClippingArea(e,t){t.clippingArea||(t.clippingArea={}),t.clippingArea.geometry=e.toJSON()}readClippingEnabled(e,t){return!!t.clippingArea&&!!t.clippingArea.clip}writeClippingEnabled(e,t){this.clippingArea&&(t.clippingArea||(t.clippingArea={}),t.clippingArea.clip=e)}writeLayers(e,t,r,i){t[r]=this._layersToJSON(e,"operational-layers",i)}readSourceVersion(e,t){const[r,i]=t.version.split(".");return new Z.Version(parseInt(r,10),parseInt(i,10))}writeSourceVersion(e,t,r){t[r]=`${re.major}.${re.minor}`}writeTables(e,t,r,i){const o=this._layersToJSON(e,"tables",i);o.length&&(t[r]=o)}get thumbnailUrl(){return this.portalItem?.thumbnailUrl??null}set thumbnailUrl(e){e?this._override("thumbnailUrl",e):(this._clearOverride("thumbnailUrl"),this.clear("thumbnailUrl","user"))}set authoringApp(e){this._isAuthoringAppSetByUser=!0,this._set("authoringApp",e)}writeAuthoringApp(e,t){e&&this._isAuthoringAppSetByUser?t.authoringApp=e:t.authoringApp="ArcGIS API for JavaScript"}set authoringAppVersion(e){this._isAuthoringAppVersionSetByUser=!0,this._set("authoringAppVersion",e)}writeAuthoringAppVersion(e,t){e&&this._isAuthoringAppVersionSetByUser?t.authoringAppVersion=e:t.authoringAppVersion=r.version}writeGround(e,t,r,i){t[r]=e?e.write({},i):{transparency:0,layers:[]}}readInitialViewProperties(e,t){const r={};t.initialState?.environment&&(r.environment=H.fromJSON(t.initialState.environment)),r.spatialReference=t.spatialReference?V.fromJSON(t.spatialReference):V.WebMercator,r.viewingMode=t.viewingMode??"global",t.initialState?.viewpoint&&(r.viewpoint=o.fromJSON(t.initialState.viewpoint));const i=t.initialState?.timeExtent;return null!=i&&(r.timeExtent=F.fromArray(i)),new Q(r)}get spatialReference(){return this.initialViewProperties?.spatialReference??V.WebMercator}get viewingMode(){return this.initialViewProperties?.viewingMode??"global"}load(e){const t=this.ground;return this.addResolvingPromise(this._loadFromSource().then((()=>{t&&t!==this.ground&&t.destroy(),this._validateFeatureLayerSymbolVisibility()}))),Promise.resolve(this)}loadAll(){return p.loadAll(this,(e=>{const t=this.presentation&&this.presentation.slides;e(this.ground,this.basemap,this.layers,t&&t.map((e=>e.basemap)),this.tables)}))}read(e,t){t={...t,origin:"web-scene"};const r=this._isAuthoringAppVersionSetByUser,i=this._isAuthoringAppSetByUser;if(A.readLoadable(this,e,(t=>super.read(e,t)),t),i||(this._isAuthoringAppSetByUser=!1),r||(this._isAuthoringAppVersionSetByUser=!1),e.baseMap&&Array.isArray(e.baseMap.elevationLayers)&&this.sourceVersion?.supportsVisibleElevationLayersInSlides){const t=e.baseMap.elevationLayers.map((e=>({id:e.id}))),r=this.presentation.slides,i=(e,t)=>e.visibleLayers.some((e=>e.id===t)),o=t.filter((e=>!r.some((t=>i(t,e.id)))));r.forEach((e=>{e.visibleLayers.addMany(o)}))}}_writeBasemapElevationLayers(e){const t=e.ground?.layers;!e.baseMap&&t?.length&&(e.baseMap={title:"Basemap",baseMapLayers:[]}),e.baseMap&&(e.baseMap.elevationLayers=n.clone(t))}_layersToJSON(e,t,r){const i={...r,layerContainerType:t};return e.map((e=>this._verifyWritableLayer(e,r)?e.write({},i):null)).filter((e=>!!e)).toArray()}_verifyWritableLayer(e,t){return!!e.persistenceEnabled&&("write"in e||(t?.messages&&t.messages.push(new s("layer:unsupported",`Layers (${e.title}, ${e.id}) of type '${e.declaredClass}' cannot be persisted in web scenes`,{layer:e})),!1))}write(e,t){if("loaded"!==this.loadStatus){const e=new s("webscene:not-loaded","Web scene must be loaded before it can be serialized");throw c.getLogger(this).error("#toJSON()","Web scene must be loaded before it can be serialized",this.loadError||this.loadStatus),e}this._runLayersIdGC();const r=!t?.messages;t={messages:[],...t,origin:"web-scene"};const i=super.write(e,t);if(r){const e=t.messages?.filter((e=>"web-document-write:property-required"===e.name))??[];if(e.length){const t=new s("web-document:property-required","One or more properties that are required in the webscene JSON are missing, see details for the specific errors",{errors:e});throw c.getLogger(this).error("#toJSON()","One or more properties that are required in the webscene JSON are missing",e),t}}return this._writeBasemapElevationLayers(i),i}async save(e){return this._debouncedSaveOperations($.SaveOperationType.SAVE,e)}async _saveImpl(e){if(!this.portalItem)throw new s("webscene:portal-item-not-set","Portal item to save to has not been set on the WebScene");if(this.portalItem?.type!==oe)throw new s("webscene:portal-item-wrong-type",`Portal item needs to have type "${oe}"`);const t=this._updateFromPromise;await this._ensureLoadBeforeSave();const r=this._enableVerifyItemRelativeUrls(T.createForItemWrite(this.portalItem,"web-scene",!0)),i=this.write({},r);return await Promise.all(r.resources.pendingOperations),await this._verifySave(i,r,$.SaveOperationType.SAVE,e),this._updateTypeKeywords(this.portalItem),await q.updateItemWithResources(this.portalItem,i,this._resourceReferences,r),S.updateOrigins(r),t&&await t,await this._saveThumbnail(),this.portalItem}async saveAs(e,t){return this._debouncedSaveOperations($.SaveOperationType.SAVE_AS,t,e)}async _saveAsImpl(e,t){let r=U.from(e);if(!r)throw new s("webscene:portal-item-required","saveAs requires a portal item to save to");r.id&&(r=r.clone(),r.id=null);const i=r.portal||P.getDefault();await this._ensureLoadBeforeSave(),r.type=oe,r.portal=i;const o=this._enableVerifyItemRelativeUrls(T.createForItemWrite(r,"web-scene",!0)),a=this.write({},o);await Promise.all(o.resources.pendingOperations),await this._verifySaveAs(a,o,t);const n=this.thumbnailUrl,l=!this._isOverridden("thumbnailUrl");this._updateTypeKeywords(r),await i.signIn();const p=this.portalItem,c={item:p,authenticated:!(!p?.id||!p.portal.user)},{copyAllowed:d,itemReloaded:u}=await K.isCopyAllowed(c,i);if(c.authenticated||=u,!d)throw new s(`${o.name}:save-as-copy-not-allowed`,"Owner of this map does not allow others to save a copy");const y={...t,copyAllResources:!0};return await K.initializeNewItem(r,c,a,y)&&(this._resourceReferences.portalItem=r),await q.saveResources(this._resourceReferences,o),this.portalItem=r,h.MultiOriginJSONSupport.prototype.read.call(this,{version:a.version,authoringApp:a.authoringApp,authoringAppVersion:a.authoringAppVersion},{name:"web-scene",ignoreDefaults:!0,url:r.itemUrl?m.urlToObject(r.itemUrl):void 0}),S.updateOrigins(o),n&&(this.thumbnailUrl=l?m.addQueryParameter(n,"w","8192"):n),o.portalItem=r,await this._saveThumbnail(),r}async _saveThumbnail(){this._isOverridden("thumbnailUrl")&&(await(this.portalItem?.updateThumbnail({thumbnail:this.thumbnailUrl})),this._clearOverride("thumbnailUrl"),this.clear("thumbnailUrl","user"))}async _verifySave(e,t,r,i){if(!M.isEarth(this.spatialReference))throw new s("webscene:unsupported-spatial-reference","Webscenes using spatial reference systems from Mars or Moon can not be saved currently.");const{ignoreUnsupported:o,requiredPropertyChecksDisabled:a,strictSchemaValidationEnabled:n}=i||{};k.evaluateWriteErrors(t,{errorName:"webscene:save"},{ignoreUnsupported:o,supplementalUnsupportedErrors:["scenemodification:unsupported"],requiredPropertyChecksDisabled:a});const l=ee.getLoader();if(n&&l){const t=(await l()).validate(e);if(!t.length)return;const i=`webscene did not validate:\n${t.join("\n")}`;c.getLogger(this).error(`${r===$.SaveOperationType.SAVE_AS?"saveAs":"save"}(): ${i}`);const o=t.map((e=>new s("webscene:schema-validation",e)));throw W.createSchemaValidationError(o)}}_verifySaveAs(e,t,r){return this._verifySave(e,t,$.SaveOperationType.SAVE_AS,r)}verifySaveAs(e){const t=this._enableVerifyItemRelativeUrls({origin:"web-scene",messages:[]}),r=this.write({},t);return this._verifySaveAs(r,t,e)}canNotSaveAs(){return!1}async updateFrom(e,t={}){const r=this._updateFrom(e,t);this._updateFromPromise=r,await r;this._updateFromPromise===r&&(this._updateFromPromise=null)}async _updateFrom(e,t={}){if(await e.whenReady(),!t.environmentExcluded&&e.environment&&(this.initialViewProperties.environment=H.prototype.clone.apply(e.environment)),!t.viewpointExcluded&&e.viewpoint&&(this.initialViewProperties.viewpoint=e.viewpoint.clone()),this.initialViewProperties.spatialReference=e.spatialReference.clone(),this.initialViewProperties.viewingMode=e.viewingMode,this.initialViewProperties.timeExtent=e.timeExtent?.clone()??null,null!=e.clippingArea?e.clippingArea!==this.clippingArea&&(this.clippingArea=e.clippingArea.clone(),this.clippingEnabled=!0):this.clippingEnabled=!1,e.heightModelInfo&&(this.heightModelInfo=e.heightModelInfo.clone()),e.map===this)for(const r of e.allLayerViews){const e="visible";e in r&&e in r.layer&&r._isOverridden(e)&&(r.layer[e]=r[e])}if(!t.widgetsExcluded)for(const r of e.persistableViewModels)r.updateWebDocument(this);(!1===t.thumbnailExcluded||null==t.thumbnailExcluded&&!t.viewpointExcluded)&&await this._updateFromThumbnail(e,t.thumbnailSize??void 0)}async _updateFromThumbnail(e,t){const r=D.getOptimalThumbnailSize(e,t),i=await e.takeScreenshot({format:"jpg",width:r.width,height:r.height,disableDecorations:!0});this.thumbnailUrl=i.dataUrl}_loadFromSource(){return this.resourceInfo?this._loadFromJSON(this.resourceInfo,{origin:"web-scene"}):this.portalItem?.id?this._loadFromItem(this.portalItem):this._loadObjectsWithLayers()}_readAndLoadFromJSON(e,t){const r=this._validateJSON(e);return this.read(r,t),this._loadFromJSON(r,t)}_extractOperationalLayers(e){const t=[];if(!this.sourceVersion?.supportsGround&&e.baseMap&&Array.isArray(e.baseMap.elevationLayers))for(const o of e.baseMap.elevationLayers)t.push(o);const r=[],i=e=>(e.layers&&(e.layers=e.layers.filter(i)),"ArcGISTiledElevationServiceLayer"!==e.layerType||(this.sourceVersion?.supportsGround||r.push(e),!1));return{operationalLayers:e.operationalLayers?e.operationalLayers.filter(i):[],operationalElevationLayers:r,basemapElevationLayers:t}}async _loadFromJSON(t,r){const i=new a;await this._validateSpatialReference(),await this._validateHeightModelInfo();const{populateOperationalLayers:o}=await new Promise(((t,r)=>e(["./layers/support/layersCreator"],t,r))),{operationalLayers:s,operationalElevationLayers:n,basemapElevationLayers:l}=this._extractOperationalLayers(t),p=[],c={context:{...r,layerContainerType:"operational-layers"}};if(this.portalItem&&(c.context.portal=this.portalItem.portal||P.getDefault()),l.length>0){const e={...c,context:{...c.context,layerContainerType:"ground"}};e.defaultLayerType="ArcGISTiledElevationServiceLayer",p.push(o(this.ground.layers,l,e))}if(n.length>0){const e={...c,context:{...c.context,layerContainerType:"ground"}};e.defaultLayerType="ArcGISTiledElevationServiceLayer",p.push(o(i,n,e))}s&&s.length>0&&p.push(o(this.layers,s,c)),t.tables?.length&&p.push(o(this.tables,t.tables,{...c,context:{...c.context,layerContainerType:"tables"},defaultLayerType:"ArcGISFeatureLayer"})),await Promise.allSettled(p),await this._loadObjectsWithLayers(),this.ground.layers.addMany(i.filter((e=>"base-elevation"===e.type||"elevation"===e.type)))}async _ensureLoadBeforeSave(){await this.load(),await this._loadObjectsWithLayers();const e=[],t=[...this.allLayers.items];for(const{basemap:r}of this.presentation.slides.items)r&&(t.push(...r.baseLayers.items),t.push(...r.referenceLayers.items));for(const r of t)if("beforeSave"in r&&"function"==typeof r.beforeSave){const t=r.beforeSave();t&&e.push(t)}await Promise.allSettled(e)}async _loadObjectsWithLayers(){const e=[];this.ground&&e.push(this.ground.load()),this.basemap&&e.push(this.basemap.load()),this.presentation.slides.forEach((t=>{t.basemap&&e.push(t.basemap.load())})),await Promise.allSettled(e)}async _loadFromItem(e){if(await e.load().catch((e=>{throw new s("webscene:load-portal-item","Failed to load portal item",{error:e})})),"Web Scene"!==e.type)throw new s("webscene:invalid-portal-item","Invalid portal item type '${type}', expected 'Web Scene'",{type:e.type});const t=await e.fetchData();this.resourceInfo=t;const r={origin:"web-scene",url:m.urlToObject(e.itemUrl),portal:e.portal||P.getDefault(),portalItem:e,readResourcePaths:[]};await this._readAndLoadFromJSON(t,r),this._resourceReferences={portalItem:e,paths:r.readResourcePaths??[]}}_validateSpatialReference(){const e=this.initialViewProperties,t=this._sceneSpatialReference;let r;if("local"!==e.viewingMode){if(!J.isSpatialReferenceSupported(t,G.ViewingMode.Global))return Promise.reject(new s("webscene:unsupported-spatial-reference","Unsupported spatial reference (${spatialReference.wkid}) in global mode, only Web Mercator, WGS84 GCS or CGCS2000 are supported",{spatialReference:t,viewingMode:e.viewingMode}));r=e=>!e||O.canProjectWithoutEngine(e,t)}else{if(!J.isSpatialReferenceSupported(t,G.ViewingMode.Local))return Promise.reject(new s("webscene:unsupported-spatial-reference","Unsupported spatial reference (${spatialReference.wkid}) in local mode, only projected coordinate systems are supported",{spatialReference:t,viewingMode:e.viewingMode}));r=e=>!e||e.equals(t)}const i=e=>e?.camera?.position.spatialReference??e?.targetGeometry?.spatialReference,o=e.viewpoint,a=i(o);if(a&&!r(a))return Promise.reject(new s("webscene:incompatible-camera-spatial-reference","Camera spatial reference (${cameraSpatialReference.wkid}) is incompatible with the scene spatial reference (${sceneSpatialReference.wkid})",{cameraSpatialReference:a,sceneSpatialReference:t,viewingMode:e.viewingMode}));const n=this.presentation.slides.find((e=>!r(i(e.viewpoint))));if(n){const r=i(n.viewpoint);return Promise.reject(new s("webscene:incompatible-slide-spatial-reference","Slide spatial reference (${slideSpatialReference.wkid}) is incompatible with the scene spatial reference (${sceneSpatialReference.wkid})",{slideSpatialReference:r,sceneSpatialReference:t,viewingMode:e.viewingMode}))}return Promise.resolve()}_validateHeightModelInfo(){const e=this._sceneSpatialReference,t=R.validateWebSceneError(this.heightModelInfo,e);return t?Promise.reject(t):Promise.resolve()}_validateFeatureLayerSymbolVisibility(){this.sourceVersion?.greaterEqual(1,35)||this.layers.forEach((e=>{"feature"===e.type&&w.watch((()=>e.loaded),(()=>e.warnInvisibleDrapedSymbols()),{once:!0,sync:!0})}))}_validateJSON(e){const t=Z.Version.parse(e.version||"","webscene");return re.validate(t),e.version=`${t.major}.${t.minor}`,1===t.major&&t.minor<=2&&(e.spatialReference=V.WebMercator.toJSON()),e}_updateTypeKeywords(e){j.toggleTypeKeyword(e,j.typeKeyword.LOCAL_SCENE,"local"===this.initialViewProperties.viewingMode),j.toggleTypeKeyword(e,j.typeKeyword.DEVELOPER_BASEMAP,N.hasDeveloperBasemapLayer(this.basemap)||this.presentation.slides.some((({basemap:e})=>!!e&&N.hasDeveloperBasemapLayer(e)))),e.typeKeywords&&(e.typeKeywords=e.typeKeywords.filter(((e,t,r)=>r.indexOf(e)===t)))}get _sceneSpatialReference(){return this.initialViewProperties.spatialReference||V.WebMercator}get _verifyItemRelativeRootPath(){return this.portalItem?.itemUrl?m.urlToObject(this.portalItem.itemUrl).path:null}_enableVerifyItemRelativeUrls(e){const t=this._verifyItemRelativeRootPath;return t&&(e.verifyItemRelativeUrls={rootPath:t,writtenUrls:[]}),e}_unscheduleLayersIdGC(){this._layersIdGCTimeoutId&&(clearTimeout(this._layersIdGCTimeoutId),this._layersIdGCTimeoutId=0)}_scheduleLayersIdGC(){this._unscheduleLayersIdGC(),this._layersIdGCTimeoutId=setTimeout((()=>{this._layersIdGCTimeoutId=0,this._runLayersIdGC()}),3e3)}_runLayersIdGC(){this._unscheduleLayersIdGC();const e=this.applicationProperties?.viewing?.search,t=e=>this.allLayers.some((t=>t.id===e&&t.persistenceEnabled));e?.layers&&(e.layers=e.layers.filter((e=>t(e.id))));const r=this.presentation&&this.presentation.slides;r&&r.forEach((e=>{e.visibleLayers&&(e.visibleLayers=e.visibleLayers.filter((e=>t(e.id))))}))}static fromJSON(e){if(!e)throw new s("webscene:empty-resource","Expected a JSON resource but got nothing");return new this({resourceInfo:e})}};te=x.WebSceneTag,ae.version=`${re.major}.${re.minor}`,t.__decorate([g.property({type:z,json:{write:!0}})],ae.prototype,"applicationProperties",void 0),t.__decorate([g.property({type:I,json:{read:{source:"clippingArea.geometry",reader:E.fromJSON},write:{target:"clippingArea.geometry"}}})],ae.prototype,"clippingArea",void 0),t.__decorate([_.writer("clippingArea")],ae.prototype,"writeClippingArea",null),t.__decorate([g.property({type:Boolean,json:{write:{target:"clippingArea.clip"}}})],ae.prototype,"clippingEnabled",void 0),t.__decorate([v.reader("clippingEnabled",["clippingArea"])],ae.prototype,"readClippingEnabled",null),t.__decorate([_.writer("clippingEnabled")],ae.prototype,"writeClippingEnabled",null),t.__decorate([g.property({type:C,json:{read:{source:"mapFloorInfo"},write:{target:"mapFloorInfo"}}})],ae.prototype,"floorInfo",void 0),t.__decorate([g.property({type:L,json:{write:!0}})],ae.prototype,"heightModelInfo",void 0),t.__decorate([g.property({json:{write:{target:"operationalLayers",ignoreOrigin:!0}}})],ae.prototype,"layers",void 0),t.__decorate([_.writer("layers")],ae.prototype,"writeLayers",null),t.__decorate([g.property({readOnly:!0,type:Z.Version,json:{type:ie(),write:{ignoreOrigin:!0,target:"version",isRequired:!0,overridePolicy:()=>({enabled:!0,allowNull:!0,ignoreOrigin:!0})}}})],ae.prototype,"sourceVersion",void 0),t.__decorate([v.reader("sourceVersion",["version"])],ae.prototype,"readSourceVersion",null),t.__decorate([_.writer("sourceVersion")],ae.prototype,"writeSourceVersion",null),t.__decorate([g.property({json:{read:!1,write:{enabled:!0,ignoreOrigin:!0}}})],ae.prototype,"tables",void 0),t.__decorate([_.writer("tables")],ae.prototype,"writeTables",null),t.__decorate([g.property()],ae.prototype,"thumbnailUrl",null),t.__decorate([g.property({type:String,json:{write:{writerEnsuresNonNull:!0,ignoreOrigin:!0}}})],ae.prototype,"authoringApp",null),t.__decorate([_.writer("authoringApp")],ae.prototype,"writeAuthoringApp",null),t.__decorate([g.property({type:String,json:{write:{writerEnsuresNonNull:!0,ignoreOrigin:!0}}})],ae.prototype,"authoringAppVersion",null),t.__decorate([_.writer("authoringAppVersion")],ae.prototype,"writeAuthoringAppVersion",null),t.__decorate([g.property({json:{write:{isRequired:!0,allowNull:!0,ignoreOrigin:!0,enabled:!0}}})],ae.prototype,"ground",void 0),t.__decorate([_.writer("ground")],ae.prototype,"writeGround",null),t.__decorate([g.property({type:a.ofType(Y),json:{write:!0}})],ae.prototype,"transportationNetworks",void 0),t.__decorate([g.property({type:X,nonNullable:!0,json:{write:{ignoreOrigin:!0,writer:(e,t,r,i)=>{if(e.slides&&e.slides.length>0){const r={...i,isPresentation:!0};t.presentation=e.write({},r)}}}}})],ae.prototype,"presentation",void 0),t.__decorate([g.property({type:Q,nonNullable:!0,json:{write:{target:"initialState",isRequired:!0,ignoreOrigin:!0},default:()=>new Q({viewingMode:"global",spatialReference:V.WebMercator})}})],ae.prototype,"initialViewProperties",void 0),t.__decorate([v.reader("initialViewProperties",["initialState.timeExtent","initialState.environment","initialState.viewpoint","spatialReference","viewingMode"])],ae.prototype,"readInitialViewProperties",null),t.__decorate([g.property({type:V,json:{read:!1,write:{isRequired:!0,ignoreOrigin:!0}}})],ae.prototype,"spatialReference",null),t.__decorate([g.property({type:["local","global"],json:{read:!1,write:{isRequired:!0,ignoreOrigin:!0}}})],ae.prototype,"viewingMode",null),t.__decorate([g.property({type:U})],ae.prototype,"portalItem",void 0),t.__decorate([g.property()],ae.prototype,"resourceInfo",void 0),t.__decorate([g.property({type:B,json:{write:!0}})],ae.prototype,"widgets",void 0),ae=t.__decorate([f.subclass("esri.WebScene")],ae);return ae}));
