/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../geometry","./Analysis","./Viewshed","../core/Collection","../core/collectionUtils","../core/Cyclical","../core/mathUtils","../core/reactiveUtils","../core/accessorSupport/decorators/property","../core/has","../core/Logger","../core/RandomLCG","../core/accessorSupport/decorators/subclass","../geometry/projection","../geometry/Extent"],(function(e,t,r,n,s,i,o,l,c,a,p,u,d,h,y,m){"use strict";const g=s.ofType(n);let f=class extends r{constructor(e){super(e),this.type="viewshed",this._extent=null}initialize(){this.addHandles(c.watch((()=>this._computeExtent()),(e=>{null==e.pending&&(this._extent=e.extent)}),c.syncAndInitial))}get viewsheds(){return this._get("viewsheds")||new g}set viewsheds(e){this._set("viewsheds",i.referenceSetter(e,this.viewsheds,g))}get spatialReference(){for(const e of this.viewsheds)if(null!=e.observer)return e.observer.spatialReference;return null}get extent(){return this._extent}get requiredPropertiesForEditing(){return this.viewsheds.items.map((({observer:e})=>e))}async waitComputeExtent(){const e=this._computeExtent();null!=e.pending&&await e.pending}_computeExtent(){const{spatialReference:e}=this;if(null==e)return{pending:null,extent:null};const t=this.viewsheds.filter((e=>null!=e.observer)),r=t.map((e=>e.observer)).toArray(),n=y.projectOrLoadMany(r,e);if(null!=n.pending)return{pending:n.pending,extent:null};return{pending:null,extent:n.geometries.map(((e,r)=>{const n=t.at(r);return null!=e&&null!=n?this._computeViewshedExtent(this.viewsheds.at(r),e):null})).filter((e=>null!=e)).reduce(((e,t)=>_(e,t)),null)}}_computeViewshedExtent(e,t){const{farDistance:r,heading:n,tilt:s,horizontalFieldOfView:i,verticalFieldOfView:c}=e,{spatialReference:a}=t,p=i/2,u=c/2,d=r/a.metersPerUnit,h=[o.cyclicalDegrees.normalize(n-p),n,o.cyclicalDegrees.normalize(n+p)],y=m.fromPoint(t),g=e=>{const t=h.map((t=>o.cyclicalDegrees.normalize(t-e)));if(t[0]>t[2]||360===i)return d;const r=t.map((e=>Math.abs(e>180?360-e:e))).reduce(((e,t)=>e>t?t:e));return r>90?0:d*Math.cos(l.deg2rad(r))};y.xmax+=g(90),y.xmin-=g(-90),y.ymax+=g(0),y.ymin-=g(180);const f=t.z;if(null!=f){let e=f,t=f;const n=s-90,i=l.clamp(n+u,-90,90),o=l.clamp(n-u,-90,90),c=a?.isGeographic?r:d;e+=c*v(i),t+=c*v(o);const h=x(u)*c,m=v(n)*h*(1-x(p));s<90&&(e-=m),s>90&&(t-=m),y.zmax=Math.max(e,f),y.zmin=Math.min(t,f)}return y}clear(){this.viewsheds.removeAll()}};function _(e,t){return null==e?t:null==t?e:e.union(t)}function x(e){return Math.cos(l.deg2rad(e))}function v(e){return Math.sin(l.deg2rad(e))}e.__decorate([a.property({type:["viewshed"]})],f.prototype,"type",void 0),e.__decorate([a.property({cast:i.castForReferenceSetter,type:g,nonNullable:!0})],f.prototype,"viewsheds",null),e.__decorate([a.property({readOnly:!0})],f.prototype,"spatialReference",null),e.__decorate([a.property()],f.prototype,"_extent",void 0),e.__decorate([a.property({readOnly:!0})],f.prototype,"extent",null),e.__decorate([a.property({readOnly:!0})],f.prototype,"requiredPropertiesForEditing",null),f=e.__decorate([h.subclass("esri.analysis.ViewshedAnalysis")],f);return f}));
