/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","./Graphic","./arcade/ArcadeDate","./arcade/ImmutableArray","./core/Error","./core/lang","./core/sql/DateOnly","./core/sql/TimeOnly","./layers/FeatureLayer","./portal/Portal","./rest/support/FeatureSet","./support/arcadeOnDemand"],(function(e,t,a,r,n,o,c,s,i,l,u,p){"use strict";let f=null;function y(e,t,a,n={}){const o=t.elementType,c="value",s="array"===o.type?[{name:c,type:o.type,elementType:o.elementType}]:"dictionary"===o.type?[{name:c,type:o.type,properties:o.properties}]:[{name:c,type:o.type}];return new r(e.map((e=>{const t={};return S(t,s,{[c]:e},a,n),t[c]})))}function m(e,t,a={}){const r=e instanceof u?new i({source:e.features,geometryType:e.geometryType,fields:e.fields,spatialReference:e.spatialReference}):e;return t.constructFeatureSet(r,a.spatialReference,null,!0,a.lruCache,a.interceptor)}function d(e,t,a={}){const{spatialReference:r,interceptor:n,lruCache:o}=a;return"string"==typeof e?t.createFeatureSetCollectionFromService(e,r,o,n):t.createFeatureSetCollectionFromMap(e,r,o,n)}function b(e,t,a,r={}){const n={};return S(n,t.properties,e,a,r),new f.Dictionary(n)}function S(e,t,r,n,o={}){const i={};for(const a of Object.keys(r))i[a.toLowerCase()]=r[a];for(const l of t){const t=l.name.toLowerCase();if(o.variablesPreProcessed)e[t]=i[t];else switch(l.type){case"array":{const a=i[t];e[t]=null==a?null:y(a,l,n,o);break}case"feature":{const a=i[t];e[t]=null==a?null:f.Feature.createFromGraphic(a,o?.timeZone);break}case"featureSet":{const a=i[t];e[t]=null==a?null:n?m(a,n,o):null;break}case"featureSetCollection":{const a=i[t];e[t]=null==a?null:n?d(a,n,o):null;break}case"dictionary":{const a=i[t];e[t]=null==a?null:b(a,l,n,o);break}case"date":{const r=i[t];r?r instanceof a.ArcadeDate?e[t]=r:e[t]=o?.timeZone?a.ArcadeDate.dateJSAndZoneToArcadeDate(r,o?.timeZone):a.ArcadeDate.dateJSToArcadeDate(r):e[t]=null;break}case"dateOnly":{const a=i[t];a?a instanceof c.DateOnly?e[t]=a:e[t]=c.DateOnly.fromReader(a):e[t]=null;break}case"time":{const a=i[t];a?a instanceof s.TimeOnly?e[t]=a:e[t]=s.TimeOnly.fromReader(a):e[t]=null;break}case"knowledgeGraph":case"geometry":case"boolean":case"text":case"number":e[t]=i[t]}}}function g(e,t){for(const a of e)t.push(a),"dictionary"===a.type&&g(a.properties,t);return t}function v(e,t,a,r,n){const{spatialReference:o,interceptor:c,lruCache:s,console:i,abortSignal:u,timeZone:p,services:f={portal:l.getDefault()}}=a,y={vars:{},spatialReference:o,interceptor:c,timeZone:p,lrucache:s,useAsync:n,services:f,console:i,abortSignal:u};return t?(S(y.vars,e.variables,t,r,a),y):y}function w(e,a){switch(a.getArcadeType(e)){case"number":case"text":case"boolean":case"point":case"polygon":case"polyline":case"multipoint":case"extent":return e;case"date":return e.toJSDate();case"time":case"dateOnly":return e.toString();case"feature":{const a=(e.type,e),r="geometry"in a?a.geometry():null,n="readAttributes"in a?a.readAttributes():a.attributes;return new t({geometry:r,attributes:n})}case"dictionary":{const t=e,r=t.attributes,n={};for(const e of Object.keys(r))n[e]=w(t.field(e),a);return n}case"array":return("toArray"in e?e.toArray():e).map((e=>w(e,a)))}return e}const $={variables:[{name:"$feature",type:"feature"},{name:"$layer",type:"featureSet"},{name:"$datastore",type:"featureSetCollection"},{name:"$map",type:"featureSetCollection"},{name:"$userInput",type:"geometry"},{name:"$graph",type:"knowledgeGraph"}]},A={variables:[{name:"$feature",type:"feature"},{name:"$aggregatedFeatures",type:"featureSet"}]},h=new Map([["aggregate-field",{variables:[{name:"$feature",type:"feature"}]}],["form-constraint",{variables:[{name:"$feature",type:"feature"}]}],["feature-z",{variables:[{name:"$feature",type:"feature"}]}],["field-calculation",{variables:[{name:"$feature",type:"feature"},{name:"$datastore",type:"featureSetCollection"}]}],["form-calculation",{variables:[{name:"$feature",type:"feature"},{name:"$originalFeature",type:"feature"},{name:"$layer",type:"featureSet"},{name:"$featureSet",type:"featureSet"},{name:"$datastore",type:"featureSetCollection"},{name:"$map",type:"featureSetCollection"},{name:"$editContext",type:"dictionary",properties:[{name:"editType",type:"text"}]}]}],["labeling",{variables:[{name:"$feature",type:"feature"}]}],["popup",$],["popup-element",$],["feature-reduction-popup",A],["feature-reduction-popup-element",A],["visualization",{variables:[{name:"$feature",type:"feature"},{name:"$view",type:"dictionary",properties:[{name:"scale",type:"number"}]}]}]]);function C(e){const t=h.get(e);if(!t){const t=Array.from(h.keys()).map((e=>`'${e}'`)).join(", ");throw new n("createArcadeProfile:invalid-profile-name",`Invalid profile name '${e}'. You must specify one of the following values: ${t}`)}return o.clone(t)}async function T(e,t,a={}){f||(f=await p.loadArcade());const{arcade:r,arcadeUtils:o}=f,{loadScriptDependencies:c,referencesMember:s,scriptIsAsync:i}=r,l=g(t.variables,[]),u=l.filter((e=>"featureSet"===e.type||"featureSetCollection"===e.type)).map((e=>e.name.toLowerCase())),y=r.parseScript(e,u);if(!y)throw new n("arcade:invalid-script","Unable to create SyntaxTree");const m=o.extractFieldNames(y),d=r.scriptTouchesGeometry(y),b=l.map((e=>e.name.toLowerCase())).filter((e=>s(y,e))),S=i(y,u);await c(y,S,u);const $={vars:{},spatialReference:null,useAsync:S};for(const n of b)$.vars[n]="any";const{lruCache:A}=a,h=r.compileScript(y,$),C=r.featureSetUtils(),{services:T}=a;return{execute:(e,a={})=>{if(S)throw new n("arcade:invalid-execution-mode","Cannot execute the script in synchronous mode");const r=h(v(t,e,{lruCache:A,...a},C,S));return a.rawOutput?r:w(r,o)},executeAsync:async(e,a={})=>{const r=await h(v(t,e,{lruCache:A,services:T,...a},C,S));return a.rawOutput?r:w(r,o)},isAsync:S,variablesUsed:b,fieldsUsed:m,geometryUsed:d,syntaxTree:y}}e.createArcadeExecutor=T,e.createArcadeProfile=C,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
