/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../core/string","../core/sql/UnknownTimeZone","../chunks/datetime"],(function(e,t,n,r){"use strict";e.ArcadeDateErrorCodes=void 0,(e.ArcadeDateErrorCodes||(e.ArcadeDateErrorCodes={})).TimeZoneNotRecognized="TimeZoneNotRecognized";const o={[e.ArcadeDateErrorCodes.TimeZoneNotRecognized]:"Timezone identifier has not been recognized."};class i extends Error{constructor(e,n){super(t.replace(o[e],n)),this.declaredRootClass="esri.arcade.arcadedate.dateerror",Error.captureStackTrace&&Error.captureStackTrace(this,i)}}function s(e,t,n){return e<t?e-t:e>n?e-n:0}function a(e,t,n){return e<t?t:e>n?n:e}class d{constructor(e){this._date=e,this.declaredRootClass="esri.arcade.arcadedate"}static fromParts(e=0,t=1,n=1,o=0,i=0,m=0,u=0,h){if(isNaN(e)||isNaN(t)||isNaN(n)||isNaN(o)||isNaN(i)||isNaN(m)||isNaN(u))return null;const l=r.DateTime.local(e,t).daysInMonth;let T=r.DateTime.fromObject({day:a(n,1,l),year:e,month:a(t,1,12),hour:a(o,0,23),minute:a(i,0,59),second:a(m,0,59),millisecond:a(u,0,999)},{zone:c(h)});return T=T.plus({months:s(t,1,12),days:s(n,1,l),hours:s(o,0,23),minutes:s(i,0,59),seconds:s(m,0,59),milliseconds:s(u,0,999)}),new d(T)}static get systemTimeZoneCanonicalName(){return Intl.DateTimeFormat().resolvedOptions().timeZone??"system"}static arcadeDateAndZoneToArcadeDate(e,t){const r=c(t);return e.isUnknownTimeZone||r===n.UnknownTimeZone.instance?d.fromParts(e.year,e.monthJS+1,e.day,e.hour,e.minute,e.second,e.millisecond,r):new d(e._date.setZone(r))}static dateJSToArcadeDate(e){return new d(r.DateTime.fromJSDate(e,{zone:"system"}))}static dateJSAndZoneToArcadeDate(e,t="system"){const n=c(t);return new d(r.DateTime.fromJSDate(e,{zone:n}))}static unknownEpochToArcadeDate(e){return new d(r.DateTime.fromMillis(e,{zone:n.UnknownTimeZone.instance}))}static unknownDateJSToArcadeDate(e){return new d(r.DateTime.fromMillis(e.getTime(),{zone:n.UnknownTimeZone.instance}))}static epochToArcadeDate(e,t="system"){const n=c(t);return new d(r.DateTime.fromMillis(e,{zone:n}))}static dateTimeToArcadeDate(e){return new d(e)}clone(){return new d(this._date)}changeTimeZone(e){const t=c(e);return d.dateTimeToArcadeDate(this._date.setZone(t))}static dateTimeAndZoneToArcadeDate(e,t){const r=c(t);return e.zone===n.UnknownTimeZone.instance||r===n.UnknownTimeZone.instance?d.fromParts(e.year,e.month,e.day,e.hour,e.minute,e.second,e.millisecond,r):new d(e.setZone(r))}static nowToArcadeDate(e){const t=c(e);return new d(r.DateTime.fromJSDate(new Date,{zone:t}))}static nowUTCToArcadeDate(){return new d(r.DateTime.utc())}get isSystem(){return"system"===this.timeZone||this.timeZone===d.systemTimeZoneCanonicalName}equals(e){return this.isSystem&&e.isSystem?this.toNumber()===e.toNumber():this.isUnknownTimeZone===e.isUnknownTimeZone&&this._date.equals(e._date)}get isUnknownTimeZone(){return this._date.zone===n.UnknownTimeZone.instance}get isValid(){return this._date.isValid}get hour(){return this._date.hour}get second(){return this._date.second}get day(){return this._date.day}get dayOfWeekISO(){return this._date.weekday}get dayOfWeekJS(){let e=this._date.weekday;return e>6&&(e=0),e}get millisecond(){return this._date.millisecond}get monthISO(){return this._date.month}get weekISO(){return this._date.weekNumber}get yearISO(){return this._date.weekYear}get monthJS(){return this._date.month-1}get year(){return this._date.year}get minute(){return this._date.minute}get zone(){return this._date.zone}get timeZoneOffset(){return this.isUnknownTimeZone?0:this._date.offset}get timeZone(){if(this.isUnknownTimeZone)return"unknown";if("system"===this._date.zone.type)return"system";const e=this.zone;return"fixed"===e.type?0===e.fixed?"UTC":e.formatOffset(0,"short"):e.name}stringify(){return JSON.stringify(this.toJSDate())}plus(e){return new d(this._date.plus(e))}diff(e,t="milliseconds"){return this._date.diff(e._date,t)[t]}toISODate(){return this._date.toISODate()}toISOString(e){return e?this._date.toISO({suppressMilliseconds:!0,includeOffset:!this.isUnknownTimeZone}):this._date.toISO({includeOffset:!this.isUnknownTimeZone})}toISOTime(e,t){return this._date.toISOTime({suppressMilliseconds:e,includeOffset:t&&!this.isUnknownTimeZone})}toFormat(e,t){return this.isUnknownTimeZone&&(e=e.replaceAll("Z","")),this._date.toFormat(e,t)}toJSDate(){return this._date.toJSDate()}toSQLValue(){return this._date.toFormat("yyyy-LL-dd HH:mm:ss")}toSQLWithKeyword(){return`timestamp '${this.toSQLValue()}'`}toDateTime(){return this._date}toNumber(){return this._date.toMillis()}getTime(){return this._date.toMillis()}toUTC(){return new d(this._date.toUTC())}toLocal(){return new d(this._date.toLocal())}toString(){return this.toISOString(!0)}static fromReaderAsTimeStampOffset(e){if(!e)return null;const t=r.DateTime.fromISO(e,{setZone:!0});return new d(t)}}function c(t,o=!0){if(t instanceof r.Zone)return t;if("system"===t.toLowerCase())return"system";if("utc"===t.toLowerCase())return"UTC";if("unknown"===t.toLowerCase())return n.UnknownTimeZone.instance;if(/^[+-]?[0-9]{1,2}([:][0-9]{2})?$/.test(t)){const e=r.FixedOffsetZone.parseSpecifier("UTC"+(t.startsWith("+")||t.startsWith("-")?"":"+")+t);if(e)return e}const s=r.IANAZone.create(t);if(!s.isValid){if(o)throw new i(e.ArcadeDateErrorCodes.TimeZoneNotRecognized);return null}return s}e.ArcadeDate=d,e.ArcadeDateError=i,e.arcadeDateErrorMessages=o,e.createDateTimeZone=c,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
