/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["./ArcadeDate","./deepClone","./Dictionary","./executionError","./ImmutableArray","../chunks/languageUtils","../core/sql/DateOnly","../core/sql/TimeOnly","../geometry/Geometry","../geometry/Point","../geometry/support/jsonUtils","../layers/graphics/featureConversionUtils","../layers/support/FieldsIndex"],(function(e,t,i,s,r,n,a,o,l,u,d,c,f){"use strict";class y{constructor(){this.arcadeDeclaredClass="esri.arcade.Feature",this._optimizedGeomDefinition=null,this._geometry=null,this.attributes=null,this._layer=null,this._fieldTypesFixed=!0,this.fieldsIndex=null,this.contextTimeZone=null,this.immutable=!0,this._fieldsToFixDataTypes=null,this.immutable=!0}static createFromGraphic(e,t){const i=new y;return i.contextTimeZone=t??null,i._geometry=null!=e.geometry?e.geometry:null,void 0===e.attributes||null===e.attributes?i.attributes={}:i.attributes=e.attributes,e._sourceLayer?(i._layer=e._sourceLayer,i._fieldTypesFixed=!1):e._layer?(i._layer=e._layer,i._fieldTypesFixed=!1):e.layer&&"fields"in e.layer?(i._layer=e.layer,i._fieldTypesFixed=!1):e.sourceLayer&&"fields"in e.sourceLayer&&(i._layer=e.sourceLayer,i._fieldTypesFixed=!1),i._layer&&!i._fieldTypesFixed&&(i.fieldsIndex=this.hydrateFieldsIndex(i._layer)),i}static createFromArcadeFeature(e){if(e instanceof y){const t=new y;return t._fieldTypesFixed=e._fieldTypesFixed,t.attributes=e.attributes,t._geometry=e._geometry,t._optimizedGeomDefinition=e._optimizedGeomDefinition,e._layer&&(t._layer=e._layer),t.fieldsIndex=e.fieldsIndex,t.contextTimeZone=e.contextTimeZone,t}const t={};for(const i of e.keys())t[i]=e.field(i);return y.createFromGraphicLikeObject(e.geometry(),t,e.fullSchema(),e.contextTimeZone)}static createFromOptimisedFeature(e,t,i){const s=new y;return s._geometry=e.geometry?{geometry:e.geometry}:null,s._optimizedGeomDefinition=i,s.attributes=e.attributes||{},s._layer=t,s._fieldTypesFixed=!1,s}static createFromArcadeDictionary(e,t){const s=new y;return s.attributes=e.field("attributes"),null!==s.attributes&&s.attributes instanceof i?(s.attributes=s.attributes.attributes,null===s.attributes&&(s.attributes={})):s.attributes={},s._geometry=e.field("geometry"),null!==s._geometry&&(s._geometry instanceof i?s._geometry=y.parseGeometryFromDictionary(s._geometry,t):s._geometry instanceof l||(s._geometry=null)),s}static createFromGraphicLikeObject(e,t,i=null,s){const r=new y;return r.contextTimeZone=s??null,null===t&&(t={}),r.attributes=t,r._geometry=null!=e?e:null,r._layer=i,r._layer&&(r._fieldTypesFixed=!1,r.fieldsIndex=this.hydrateFieldsIndex(r._layer)),r}static hydrateFieldsIndex(e){return null===e?null:n.isFeatureSet(e)?e.getFieldsIndex():e.fieldsIndex?e.fieldsIndex:f.fromLayerJSON({datesInUnknownTimezone:e.datesInUnknownTimezone,fields:e.fields,timeInfo:e.timeInfo,editFieldsInfo:e.editFieldsInfo,dateFieldsTimeReference:e.dateFieldsTimeReference??{timeZone:"UTC",respectsDaylightSaving:!1}})}repurposeFromGraphicLikeObject(e,t,i=null){null===t&&(t={}),this.attributes=t,this._geometry=e??null,this._layer=i,this._layer?this._fieldTypesFixed=!1:this._fieldTypesFixed=!0}castToText(t=!1){let i="";!1===this._fieldTypesFixed&&this._fixFieldTypes();for(const s in this.attributes){""!==i&&(i+=",");const u=this.attributes[s];null==u?i+=JSON.stringify(s)+":null":n.isBoolean(u)||n.isNumber(u)||n.isString(u)?i+=JSON.stringify(s)+":"+JSON.stringify(u):u instanceof l?i+=JSON.stringify(s)+":"+n.toStringExplicit(u):u instanceof o.TimeOnly||u instanceof a.DateOnly?i+=`${JSON.stringify(s)}:${JSON.stringify(u.toString())}`:u instanceof r||Array.isArray(u)?i+=JSON.stringify(s)+":"+n.toStringExplicit(u,null,t):u instanceof e.ArcadeDate?i+=t?JSON.stringify(s)+":"+JSON.stringify(u.getTime()):JSON.stringify(s)+":"+u.stringify():null!==u&&"object"==typeof u&&void 0!==u.castToText&&(i+=JSON.stringify(s)+":"+u.castToText(t))}return'{"geometry":'+(null===this.geometry()?"null":n.toStringExplicit(this.geometry()))+',"attributes":{'+i+"}}"}_fixFieldTypes(){if(this._fieldsToFixDataTypes&&this._fieldsToFixDataTypes?.length>0)return this._fixAllFields(this._fieldsToFixDataTypes),void(this._fieldTypesFixed=!0);const e=[],t=this._layer.fields;for(let i=0;i<t.length;i++){const s=t[i],{name:r,type:n}=s;switch(n){case"date":case"esriFieldTypeDate":e.push({field:r,dataType:"date"});break;case"date-only":case"esriFieldTypeDateOnly":e.push({field:r,dataType:"date-only"});break;case"time-only":case"esriFieldTypeTimeOnly":e.push({field:r,dataType:"time-only"});break;case"timestamp-offset":case"esriFieldTypeTimestampOffset":e.push({field:r,dataType:"timestamp-offset"})}}this._fieldsToFixDataTypes=e,e.length>0&&this._fixAllFields(e),this._fieldTypesFixed=!0}isUnknownDateTimeField(e){return"unknown"===this.fieldsIndex?.getTimeZone(e)}_fixAllFields(t){this.attributes={...this.attributes};const i=this.contextTimeZone??"system";for(let s=0;s<t.length;s++){const r=t[s].field,l=t[s].dataType;let u=this.attributes[r];if(void 0===u){for(const t in this.attributes)if(t.toLowerCase()===r.toLowerCase()){if(u=this.attributes[t],null!==u){if("time-only"===l){n.isTime(u)||(this.attributes[t]=o.TimeOnly.fromReader(u.toString()));break}if("date-only"===l){n.isDateOnly(u)||(this.attributes[t]=a.DateOnly.fromReader(u.toString()));break}if("timestamp-offset"===l){n.isDate(u)||(this.attributes[t]=e.ArcadeDate.fromReaderAsTimeStampOffset(u.toString()));break}const s=this.isUnknownDateTimeField(t);u instanceof Date?this.attributes[t]=s?e.ArcadeDate.unknownDateJSToArcadeDate(u):e.ArcadeDate.dateJSAndZoneToArcadeDate(u,i):n.isDate(u)||(this.attributes[t]=s?e.ArcadeDate.unknownEpochToArcadeDate(u):e.ArcadeDate.epochToArcadeDate(u,i))}break}}else if(null!==u){if("time-only"===l){n.isTime(u)?this.attributes[r]=u:this.attributes[r]=o.TimeOnly.fromReader(u.toString());continue}if("date-only"===l){n.isDateOnly(u)?this.attributes[r]=u:this.attributes[r]=a.DateOnly.fromReader(u.toString());continue}if("timestamp-offset"===l){n.isDate(u)?this.attributes[r]=u:this.attributes[r]=e.ArcadeDate.fromReaderAsTimeStampOffset(u.toString());continue}const t=this.isUnknownDateTimeField(r);n.isDate(u)?this.attributes[r]=u:u instanceof Date?this.attributes[r]=t?e.ArcadeDate.unknownDateJSToArcadeDate(u):e.ArcadeDate.dateJSAndZoneToArcadeDate(u,i):this.attributes[r]=t?e.ArcadeDate.unknownEpochToArcadeDate(u):e.ArcadeDate.epochToArcadeDate(u,i)}}}geometry(){return null===this._geometry||this._geometry instanceof l||(this._optimizedGeomDefinition?(this._geometry=d.fromJSON(c.convertToGeometry(this._geometry,this._optimizedGeomDefinition.geometryType,this._optimizedGeomDefinition.hasZ,this._optimizedGeomDefinition.hasM)),this._geometry.spatialReference=this._optimizedGeomDefinition.spatialReference):this._geometry=d.fromJSON(this._geometry)),this._geometry}field(e){this._fieldTypesFixed||this._fixFieldTypes();const t=this.attributes[e];if(void 0!==t)return t;const i=e.toLowerCase();for(const s in this.attributes)if(s.toLowerCase()===i)return this.attributes[s];if(this._hasFieldDefinition(i))return null;throw new s.ArcadeExecutionError(null,s.ExecutionErrorCodes.FieldNotFound,null,{key:e})}_hasFieldDefinition(e){if(null===this._layer)return!1;for(let t=0;t<this._layer.fields.length;t++){if(this._layer.fields[t].name.toLowerCase()===e)return!0}return!1}setField(t,i){if(this.immutable)throw new s.ArcadeExecutionError(null,s.ExecutionErrorCodes.Immutable,null);if(i instanceof Date&&(i=this.isUnknownDateTimeField(t)?e.ArcadeDate.unknownDateJSToArcadeDate(i):e.ArcadeDate.dateJSToArcadeDate(i)),!1===n.isSimpleType(i))throw new s.ArcadeExecutionError(null,s.ExecutionErrorCodes.TypeNotAllowedInFeature,null);const r=t.toLowerCase();if(void 0===this.attributes[t]){for(const e in this.attributes)if(e.toLowerCase()===r)return void(this.attributes[e]=i);this.attributes[t]=i}else this.attributes[t]=i}hasField(e){const t=e.toLowerCase();if(void 0!==this.attributes[e])return!0;for(const i in this.attributes)if(i.toLowerCase()===t)return!0;return!!this._hasFieldDefinition(t)}keys(){let e=[];const t={};for(const i in this.attributes)e.push(i),t[i.toLowerCase()]=1;if(null!==this._layer)for(let i=0;i<this._layer.fields.length;i++){const s=this._layer.fields[i];1!==t[s.name.toLowerCase()]&&e.push(s.name)}return e=e.sort(),e}static parseGeometryFromDictionary(e,t){const i=y._convertDictionaryToJson(e,!0);return void 0!==i.hasm&&(i.hasM=i.hasm,delete i.hasm),void 0!==i.hasz&&(i.hasZ=i.hasz,delete i.hasz),void 0!==i.spatialreference&&(i.spatialReference=i.spatialreference,delete i.spatialreference),i.spatialReference||(i.spatialReference=t),void 0!==i.rings&&(i.rings=this._fixPathArrays(i.rings,!0===i.hasZ,!0===i.hasZ)),void 0!==i.paths&&(i.paths=this._fixPathArrays(i.paths,!0===i.hasZ,!0===i.hasM)),void 0!==i.points&&(i.points=this._fixPointArrays(i.points,!0===i.hasZ,!0===i.hasM)),d.fromJSON(i)}static _fixPathArrays(e,t,i){const s=[];if(Array.isArray(e))for(let r=0;r<e.length;r++)s.push(this._fixPointArrays(e[r],t,i));else if(e instanceof r)for(let r=0;r<e.length();r++)s.push(this._fixPointArrays(e.get(r),t,i));return s}static _fixPointArrays(e,t,i){const s=[];if(Array.isArray(e))for(let n=0;n<e.length;n++){const a=e[n];a instanceof u?t&&i?s.push([a.x,a.y,a.z,a.m]):t?s.push([a.x,a.y,a.z]):i?s.push([a.x,a.y,a.m]):s.push([a.x,a.y]):a instanceof r?s.push(a.toArray()):s.push(a)}else if(e instanceof r)for(let n=0;n<e.length();n++){const a=e.get(n);a instanceof u?t&&i?s.push([a.x,a.y,a.z,a.m]):t?s.push([a.x,a.y,a.z]):i?s.push([a.x,a.y,a.m]):s.push([a.x,a.y]):a instanceof r?s.push(a.toArray()):s.push(a)}return s}static _convertDictionaryToJson(e,t=!1){const s={};for(const r in e.attributes){let n=e.attributes[r];n instanceof i&&(n=y._convertDictionaryToJson(n)),t?s[r.toLowerCase()]=n:s[r]=n}return s}static parseAttributesFromDictionary(e){const t={};for(const i in e.attributes){const r=e.attributes[i];if(!n.isSimpleType(r))throw new s.ArcadeExecutionError(null,s.ExecutionErrorCodes.InvalidParameter,null);t[i]=r}return t}static fromJson(e,t){let i=null;null!==e.geometry&&void 0!==e.geometry&&(i=d.fromJSON(e.geometry));const r={};if(null!==e.attributes&&void 0!==e.attributes)for(const a in e.attributes){const t=e.attributes[a];if(null===t)r[a]=t;else{if(!(n.isString(t)||n.isNumber(t)||n.isBoolean(t)||n.isDate(t)||n.isTime(t)||n.isDateOnly(t)))throw new s.ArcadeExecutionError(null,s.ExecutionErrorCodes.InvalidParameter,null);r[a]=t}}return y.createFromGraphicLikeObject(i,r,null,t??null)}fullSchema(){return this._layer}gdbVersion(){if(null===this._layer)return"";const e=this._layer.gdbVersion;return void 0===e?"":""===e&&this._layer.capabilities?.isVersioned?"SDE.DEFAULT":e}castAsJson(e){const t={attributes:{},geometry:!0===e?.keepGeometryType?this.geometry():this.geometry()?.toJSON()??null};for(const i in this.attributes){const s=this.attributes[i];void 0!==s&&(t.attributes[i]=n.castAsJson(s,e))}return t}async castAsJsonAsync(e=null,t){return this.castAsJson(t)}}return t.configureDeepClone(y),y}));
