/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","exports","./arcadeEnvironment","./ArcadeModule","./ArcadeModuleLoader","./containerUtils","./Dictionary","./executionError","./Feature","./FunctionWrapper","../chunks/languageUtils","./treeAnalysis","../chunks/array","./functions/date","./functions/geometry","./functions/geomsync","./functions/maths","./functions/stats","./functions/string","../core/promiseUtils","../geometry/Geometry","../geometry/SpatialReference"],(function(e,n,r,t,o,l,a,i,c,s,u,d,p,m,g,f,E,h,y,b,x,S){"use strict";class w extends s.ArcadeFunction{constructor(e,n){super(),this.paramCount=n,this.fn=e}createFunction(e){return(...n)=>{if(n.length!==this.paramCount)throw new i.ArcadeExecutionError(e,i.ExecutionErrorCodes.WrongNumberOfParameters,null);return this.fn(...n)}}call(e,n){return this.fn(...n.arguments)}marshalledCall(e,n,r,t){return t(e,n,((n,o,l)=>{l=l.map((n=>!u.isFunctionParameter(n)||n instanceof s.ScopeMarshalledFunction?n:s.wrapModuleScopedResponse(n,e,t)));const a=this.call(r,{arguments:l});return b.isPromiseLike(a)?a.then((e=>s.wrapModuleScopedResponse(e,r,t))):a}))}}function v(e,n){const r=[];for(let t=0;t<n.arguments.length;t++)r.push(A(e,n.arguments[t]));return r}function C(e,n,r){try{return r(e,null,n.arguments)}catch(t){throw t}}function A(e,n){switch(n.type){case"AssignmentExpression":return $(e,n);case"UpdateExpression":return O(e,n);case"TemplateLiteral":return V(e,n);case"Identifier":return H(e,n);case"MemberExpression":return K(e,n);case"Literal":return null===n.value||void 0===n.value?"null":JSON.stringify(n.value);case"CallExpression":return Y(e,n);case"UnaryExpression":return W(e,n);case"BinaryExpression":return z(e,n);case"LogicalExpression":return J(e,n);case"ArrayExpression":return q(e,n);case"ObjectExpression":return M(e,n);default:throw new i.ArcadeCompilationError(e,i.ExecutionErrorCodes.Unrecognized,n)}}function F(e,n){switch(n.type){case"EmptyStatement":return"lc.voidOperation";case"VariableDeclaration":return j(e,n);case"BlockStatement":return R(e,n);case"FunctionDeclaration":return T(e,n);case"ImportDeclaration":return U(e,n);case"ExportNamedDeclaration":return D(e,n);case"ReturnStatement":return L(e,n);case"IfStatement":return B(e,n);case"ExpressionStatement":return k(e,n);case"BreakStatement":return"break";case"ContinueStatement":return"continue";case"ForStatement":return N(e,n);case"ForInStatement":return I(e,n);case"WhileStatement":return _(e,n);default:throw new i.ArcadeCompilationError(e,i.ExecutionErrorCodes.Unrecognized,n)}}function M(e,n){let r="lang.dictionary([";for(let t=0;t<n.properties.length;t++){const o=n.properties[t];let l;"Identifier"===o.key.type?(P(o.key.name),l="'"+o.key.name+"'"):l=A(e,o.key);t>0&&(r+=","),r+="lang.strCheck("+l+",'ObjectExpression'),lang.aCheck("+A(e,o.value)+", 'ObjectExpression')"}return r+="])",r}function I(e,n){const t=oe(e),o=oe(e),l=oe(e);let a="var "+t+" = "+A(e,n.right)+";\n";"VariableDeclaration"===n.left.type&&(a+=F(e,n.left));const i=r.toSymbolId("VariableDeclaration"===n.left.type?n.left.declarations[0].id:n.left);P(i);let c="";null!==e.localScope&&(void 0!==e.localScope[i]?c="lscope['"+i+"']":void 0!==e.localScope._SymbolsMap[i]&&(c="lscope['"+e.localScope._SymbolsMap[i]+"']"));let s="";if(""===c)if(void 0!==e.globalScope[i])c="gscope['"+i+"']";else if(void 0!==e.globalScope._SymbolsMap[i])c="gscope['"+e.globalScope._SymbolsMap[i]+"']";else if(null!==e.localScope)if(e.undeclaredGlobalsInFunctions.has(i))c="gscope['"+e.undeclaredGlobalsInFunctions.get(i).manglename+"']",s=e.undeclaredGlobalsInFunctions.get(i).manglename;else{const r={manglename:te(e),node:n.left};e.undeclaredGlobalsInFunctions.set(i,r),c="gscope['"+r.manglename+"']",s=r.manglename}return s&&(a+="lang.chkAssig('"+s+"',runtimeCtx); \n"),a+="if ("+t+"===null) {  lastStatement = lc.voidOperation; }\n ",a+="else if (lc.isArray("+t+") || lc.isString("+t+")) {",a+="var "+o+"="+t+".length; \n",a+="for(var "+l+"=0; "+l+"<"+o+"; "+l+"++) {\n",a+=c+"="+l+";\n",a+=F(e,n.body),a+="\n}\n",a+=" lastStatement = lc.voidOperation; \n",a+=" \n}\n",a+="else if (lc.isImmutableArray("+t+")) {",a+="var "+o+"="+t+".length(); \n",a+="for(var "+l+"=0; "+l+"<"+o+"; "+l+"++) {\n",a+=c+"="+l+";\n",a+=F(e,n.body),a+="\n}\n",a+=" lastStatement = lc.voidOperation; \n",a+=" \n}\n",a+="else if (( "+t+" instanceof lang.Dictionary) || ( "+t+" instanceof lang.Feature)) {",a+="var "+o+"="+t+".keys(); \n",a+="for(var "+l+"=0; "+l+"<"+o+".length; "+l+"++) {\n",a+=c+"="+o+"["+l+"];\n",a+=F(e,n.body),a+="\n}\n",a+=" lastStatement = lc.voidOperation; \n",a+=" \n}\n",e.isAsync&&(a+="else if (lc.isFeatureSet("+t+")) {",a+="var "+o+"="+t+".iterator(runtimeCtx.abortSignal); \n",a+="for(var "+l+"=lang. graphicToFeature( yield "+o+".next(),"+t+", runtimeCtx); "+l+"!=null; "+l+"=lang. graphicToFeature( yield "+o+".next(),"+t+", runtimeCtx)) {\n",a+=c+"="+l+";\n",a+=F(e,n.body),a+="\n}\n",a+=" lastStatement = lc.voidOperation; \n",a+=" \n}\n"),a+="else { lastStatement = lc.voidOperation; } \n",a}function N(e,n){let r="lastStatement = lc.voidOperation; \n";null!==n.init&&("VariableDeclaration"===n.init.type?r+=F(e,n.init):r+=A(e,n.init)+"; ");const t=oe(e),o=oe(e);return r+="var "+t+" = true; ",r+="\n do { ",null!==n.update&&(r+=" if ("+t+"===false) {\n "+A(e,n.update)+"  \n}\n "+t+"=false; \n"),null!==n.test&&(r+="var "+o+" = "+A(e,n.test)+"; ",r+="if ("+o+"===false) { break; } else if ("+o+"!==true) { lang.error('"+i.ExecutionErrorCodes.BooleanConditionRequired+"');   }\n"),r+=F(e,n.body),null!==n.update&&(r+="\n "+A(e,n.update)),r+="\n"+t+" = true; \n} while(true);  lastStatement = lc.voidOperation; ",r}function O(e,n){if("CallExpression"===n.argument.type)throw new i.ArcadeCompilationError(e,i.ExecutionErrorCodes.NeverReach,n);let t;if("MemberExpression"===n.argument.type){const r=A(e,n.argument.object);return!0===n.argument.computed?t=A(e,n.argument.property):(P(n.argument.property.name),t="'"+n.argument.property.name+"'"),"lang.memberupdate("+r+","+t+",'"+n.operator+"',"+n.prefix+")"}const o=r.toSymbolId(n.argument);if(P(o),null!==e.localScope){if(void 0!==e.localScope[o])return"lang.update(lscope, '"+o+"','"+n.operator+"',"+n.prefix+")";if(void 0!==e.localScope._SymbolsMap[o])return"lang.update(lscope, '"+e.localScope._SymbolsMap[o]+"','"+n.operator+"',"+n.prefix+")"}if(void 0!==e.globalScope[o])return"lang.update(gscope, '"+o+"','"+n.operator+"',"+n.prefix+")";if(void 0!==e.globalScope._SymbolsMap[o])return"lang.update(gscope, '"+e.globalScope._SymbolsMap[o]+"','"+n.operator+"',"+n.prefix+")";if(null!==e.localScope){if(e.undeclaredGlobalsInFunctions.has(o))return"lang.update(gscope,lang.chkAssig( '"+e.undeclaredGlobalsInFunctions.get(o).manglename+"',runtimeCtx),'"+n.operator+"',"+n.prefix+")";const r={manglename:te(e),node:n.argument};return e.undeclaredGlobalsInFunctions.set(o,r),"lang.update(gscope, lang.chkAssig('"+r.manglename+"',runtimeCtx),'"+n.operator+"',"+n.prefix+")"}throw new i.ArcadeExecutionError(e,i.ExecutionErrorCodes.InvalidIdentifier,n)}function _(e,n){let r="lastStatement = lc.voidOperation; \n";const t=oe(e);return r+=`\n  var ${t} = true;\n    do {\n      ${t} = ${A(e,n.test)};\n      if (${t}==false) {\n        break;\n      }\n      if (${t}!==true) {\n        lang.error('${i.ExecutionErrorCodes.BooleanConditionRequired}');\n      }\n      ${F(e,n.body)}\n    }\n    while (${t} !== false);\n    lastStatement = lc.voidOperation;\n  `,r}function $(e,n){const t=A(e,n.right);if("MemberExpression"===n.left.type){let r;const o=A(e,n.left.object);return!0===n.left.computed?r=A(e,n.left.property):(r="'"+n.left.property.name+"'",P(n.left.property.name)),"lang.assignmember("+o+","+r+",'"+n.operator+"',"+t+")"}const o=r.toSymbolId(n.left);if(P(o),null!==e.localScope){if(void 0!==e.localScope[o])return"lscope['"+o+"']=lang.assign("+t+",'"+n.operator+"', lscope['"+o+"'])";if(void 0!==e.localScope._SymbolsMap[o])return"lscope['"+e.localScope._SymbolsMap[o]+"']=lang.assign("+t+",'"+n.operator+"', lscope['"+e.localScope._SymbolsMap[o]+"'])"}if(void 0!==e.globalScope[o])return"gscope['"+o+"']=lang.assign("+t+",'"+n.operator+"', gscope['"+o+"'])";if(void 0!==e.globalScope._SymbolsMap[o])return"gscope['"+e.globalScope._SymbolsMap[o]+"']=lang.assign("+t+",'"+n.operator+"', gscope['"+e.globalScope._SymbolsMap[o]+"'])";if(null!==e.localScope){if(e.undeclaredGlobalsInFunctions.has(o))return"gscope[lang.chkAssig('"+e.undeclaredGlobalsInFunctions.get(o).manglename+"',runtimeCtx)]=lang.assign("+t+",'"+n.operator+"', gscope['"+e.undeclaredGlobalsInFunctions.get(o).manglename+"'])";const r={manglename:te(e),node:n.left};return e.undeclaredGlobalsInFunctions.set(o,r),"gscope[lang.chkAssig('"+r.manglename+"',runtimeCtx)]=lang.assign("+t+",'"+n.operator+"', gscope['"+r.manglename+"'])"}throw new i.ArcadeExecutionError(e,i.ExecutionErrorCodes.InvalidIdentifier,n)}function k(e,n){return"AssignmentExpression"===n.expression.type?"lastStatement = lc.voidOperation; "+A(e,n.expression)+"; \n ":"lastStatement = "+A(e,n.expression)+"; "}function G(e,n){return"BlockStatement"===n.type?F(e,n):"ReturnStatement"===n.type||"BreakStatement"===n.type||"ContinueStatement"===n.type?F(e,n)+"; ":"ExpressionStatement"===n.type?F(e,n):F(e,n)+"; "}function B(e,n){return`if (lang.mustBoolean(${A(e,n.test)}, runtimeCtx) === true) {\n    ${G(e,n.consequent)}\n  } `+(null!==n.alternate?"IfStatement"===n.alternate.type?" else "+B(e,n.alternate):` else {\n      ${G(e,n.alternate)}\n    }\n`:" else {\n      lastStatement = lc.voidOperation;\n    }\n")}function R(e,n){let r="";for(let t=0;t<n.body.length;t++)"EmptyStatement"!==n.body[t].type&&("ReturnStatement"===n.body[t].type||"BreakStatement"===n.body[t].type||"ContinueStatement"===n.body[t].type?r+=F(e,n.body[t])+"; \n":r+=F(e,n.body[t])+" \n");return r}function L(e,n){if(null===n.argument)return"return lc.voidOperation";return"return "+A(e,n.argument)}function U(e,n){const t=r.toSymbolId(n.specifiers[0].local);P(t);const o=e.libraryResolver?.loadLibrary(t),l=te(e);void 0===e.moduleFactory[o.uri]&&(e.moduleFactory[o.uri]=xe(o.syntax,{interceptor:e.interceptor,services:e.services,moduleFactory:e.moduleFactory,lrucache:e.lrucache,timeZone:e.timeZone??null,libraryResolver:e.libraryResolver,customfunctions:e.customfunctions,vars:{}},e.isAsync)),e.moduleFactoryMap[l]=o.uri;let a,i="";return i=e.isAsync?"(yield lang.loadModule('"+l+"', runtimeCtx) ); ":"lang.loadModule('"+l+"', runtimeCtx); ",void 0!==e.globalScope[t]?"gscope['"+t+"']="+i:void 0!==e.globalScope._SymbolsMap[t]?"gscope['"+e.globalScope._SymbolsMap[t]+"']="+i:(e.undeclaredGlobalsInFunctions.has(t)?(a=e.undeclaredGlobalsInFunctions.get(t).manglename,e.undeclaredGlobalsInFunctions.delete(t)):a=te(e),e.globalScope._SymbolsMap[t]=a,e.mangleMap[t]=a,"gscope[lang.setAssig('"+a+"', runtimeCtx)]="+i)}function D(e,n){const t=F(e,n.declaration);if("FunctionDeclaration"===n.declaration.type)e.exports[r.toSymbolId(n.declaration.id)]="function";else if("VariableDeclaration"===n.declaration.type)for(const o of n.declaration.declarations)e.exports[r.toSymbolId(o.id)]="variable";return t}function P(e){if("iif"===e)throw new i.ArcadeUncompilableError;if("decode"===e)throw new i.ArcadeUncompilableError;if("when"===e)throw new i.ArcadeUncompilableError;if("defaultvalue"===e)throw new i.ArcadeUncompilableError}function T(e,n){const t=r.toSymbolId(n.id);let o;P(t);let l=!1;void 0!==e.globalScope[t]?o=t:void 0!==e.globalScope._SymbolsMap[t]?o=e.globalScope._SymbolsMap[t]:e.undeclaredGlobalsInFunctions.has(t)?(o=e.undeclaredGlobalsInFunctions.get(t).manglename,e.globalScope._SymbolsMap[t]=o,e.mangleMap[t]=o,e.undeclaredGlobalsInFunctions.delete(t),l=!0):(o=te(e),e.globalScope._SymbolsMap[t]=o,e.mangleMap[t]=o);const a={isAsync:e.isAsync,console:e.console,exports:e.exports,undeclaredGlobalsInFunctions:e.undeclaredGlobalsInFunctions,customfunctions:e.customfunctions,moduleFactory:e.moduleFactory,moduleFactoryMap:e.moduleFactoryMap,libraryResolver:e.libraryResolver,lrucache:e.lrucache,interceptor:e.interceptor,services:e.services,symbols:e.symbols,mangleMap:e.mangleMap,localScope:{_SymbolsMap:{}},depthCounter:e.depthCounter,globalScope:e.globalScope};let i="new lang.UserDefinedCompiledFunction( lang.functionDepthchecker(function() { var lastStatement = lc.voidOperation; \n   var lscope = runtimeCtx.localStack[runtimeCtx.localStack.length-1];\n";for(let c=0;c<n.params.length;c++){const t=r.toSymbolId(n.params[c]);P(t);const o=te(e);a.localScope._SymbolsMap[t]=o,a.mangleMap[t]=o,i+="lscope['"+o+"']=arguments["+c.toString()+"];\n"}return!0===e.isAsync?(i+="return lang.__awaiter(this, void 0, void 0, function* () {\n",i+=R(a,n.body)+"\n return lastStatement; ",i+="});  }",i+=", runtimeCtx),"+n.params.length+")",i+="\n lastStatement = lc.voidOperation; \n"):(i+=R(a,n.body)+"\n return lastStatement; }, runtimeCtx),"+n.params.length+")",i+="\n lastStatement = lc.voidOperation; \n"),l?"gscope[lang.setAssig('"+o+"', runtimeCtx)]="+i:"gscope['"+o+"']="+i}function j(e,n){const r=[];for(let t=0;t<n.declarations.length;t++)r.push(Z(e,n.declarations[t]));return r.join("\n")+" \n lastStatement=  lc.voidOperation; \n"}function Z(e,n){const t=null===n.init?null:A(e,n.init),o=r.toSymbolId(n.id);if(P(o),null!==e.localScope){if(void 0!==e.localScope[o])return"lscope['"+o+"']="+t+"; ";if(void 0!==e.localScope._SymbolsMap[o])return"lscope['"+e.localScope._SymbolsMap[o]+"']="+t+"; ";const n=te(e);return e.localScope._SymbolsMap[o]=n,e.mangleMap[o]=n,"lscope['"+n+"']="+t+"; "}if(void 0!==e.globalScope[o])return"gscope['"+o+"']="+t+"; ";if(void 0!==e.globalScope._SymbolsMap[o])return"gscope['"+e.globalScope._SymbolsMap[o]+"']="+t+"; ";if(e.undeclaredGlobalsInFunctions.has(o)){const n=e.undeclaredGlobalsInFunctions.get(o).manglename;return e.globalScope._SymbolsMap[o]=n,e.mangleMap[o]=n,e.undeclaredGlobalsInFunctions.delete(o),"gscope[lang.setAssig('"+n+"', runtimeCtx)]="+t+"; "}const l=te(e);return e.globalScope._SymbolsMap[o]=l,e.mangleMap[o]=l,"gscope['"+l+"']="+t+"; "}function K(e,n){try{let r;return!0===n.computed?r=A(e,n.property):(P(n.property.name),r="'"+n.property.name+"'"),"lang.member("+A(e,n.object)+","+r+")"}catch(r){throw r}}function W(e,n){try{return"lang.unary("+A(e,n.argument)+",'"+n.operator+"')"}catch(r){throw r}}function q(e,n){try{const r=[];for(let t=0;t<n.elements.length;t++)"Literal"===n.elements[t].type?r.push(A(e,n.elements[t])):r.push("lang.aCheck("+A(e,n.elements[t])+",'ArrayExpression')");return"["+r.join(",")+"]"}catch(r){throw r}}function V(e,n){try{const r=[];let t=0;for(const o of n.quasis)r.push(o.value?JSON.stringify(o.value.cooked):JSON.stringify("")),!1===o.tail&&(r.push(n.expressions[t]?"lang.castString(lang.aCheck("+A(e,n.expressions[t])+", 'TemplateLiteral'))":""),t++);return"(["+r.join(",")+"]).join('')"}catch(r){throw r}}function z(e,n){try{return"lang.binary("+A(e,n.left)+","+A(e,n.right)+",'"+n.operator+"')"}catch(r){throw r}}function J(e,n){try{if("AssignmentExpression"===n.left.type||"UpdateExpression"===n.left.type)throw new i.ArcadeCompilationError(e,i.ExecutionErrorCodes.LogicalExpressionOnlyBoolean,n);if("AssignmentExpression"===n.right.type||"UpdateExpression"===n.right.type)throw new i.ArcadeCompilationError(e,i.ExecutionErrorCodes.LogicalExpressionOnlyBoolean,n);if("&&"===n.operator||"||"===n.operator)return"(lang.logicalCheck("+A(e,n.left)+") "+n.operator+" lang.logicalCheck("+A(e,n.right)+"))";throw new i.ArcadeCompilationError(null,i.ExecutionErrorCodes.LogicExpressionOrAnd,null)}catch(r){throw r}}function H(e,n){try{const t=r.toSymbolId(n);if(P(t),null!==e.localScope){if(void 0!==e.localScope[t])return"lscope['"+t+"']";if(void 0!==e.localScope._SymbolsMap[t])return"lscope['"+e.localScope._SymbolsMap[t]+"']"}if(void 0!==e.globalScope[t])return"gscope['"+t+"']";if(void 0!==e.globalScope._SymbolsMap[t])return"gscope['"+e.globalScope._SymbolsMap[t]+"']";if(null!==e.localScope){if(e.undeclaredGlobalsInFunctions.has(t))return"gscope[lang.chkAssig('"+e.undeclaredGlobalsInFunctions.get(t).manglename+"',runtimeCtx)]";const r={manglename:te(e),node:n};return e.undeclaredGlobalsInFunctions.set(t,r),"gscope[lang.chkAssig('"+r.manglename+"',runtimeCtx)]"}throw new i.ArcadeCompilationError(e,i.ExecutionErrorCodes.InvalidIdentifier,n)}catch(t){throw t}}function Y(e,n){try{if("MemberExpression"===n.callee.type){let r;!0===n.callee.computed?r=A(e,n.callee.property):(P(n.callee.property.name),r="'"+n.callee.property.name+"'");let t="[";for(let o=0;o<n.arguments.length;o++)o>0&&(t+=", "),t+=A(e,n.arguments[o]);return t+="]",e.isAsync?"(yield lang.callModuleFunction("+A(e,n.callee.object)+","+t+","+r+",runtimeCtx))":"lang.callModuleFunction("+A(e,n.callee.object)+","+t+","+r+",runtimeCtx)"}if("Identifier"!==n.callee.type)throw new i.ArcadeCompilationError(e,i.ExecutionErrorCodes.FunctionNotFound,n);const t=r.toSymbolId(n.callee);if("iif"===t)return Q(e,n);if("when"===t)return ee(e,n);if("defaultvalue"===t)return X(e,n);if("decode"===t)return ne(e,n);let o="";if(null!==e.localScope&&(void 0!==e.localScope[t]?o="lscope['"+t+"']":void 0!==e.localScope._SymbolsMap[t]&&(o="lscope['"+e.localScope._SymbolsMap[t]+"']")),""===o)if(void 0!==e.globalScope[t])o="gscope['"+t+"']";else if(void 0!==e.globalScope._SymbolsMap[t])o="gscope['"+e.globalScope._SymbolsMap[t]+"']";else if(null!==e.localScope)if(e.undeclaredGlobalsInFunctions.has(t))o="gscope[lang.chkAssig('"+e.undeclaredGlobalsInFunctions.get(t).manglename+"',runtimeCtx)]";else{const r={manglename:te(e),node:n.callee};e.undeclaredGlobalsInFunctions.set(t,r),o="gscope[lang.chkAssig('"+r.manglename+"',runtimeCtx)]"}if(""!==o){let r="[";for(let t=0;t<n.arguments.length;t++)t>0&&(r+=", "),r+=A(e,n.arguments[t]);return r+="]",e.isAsync?"(yield lang.callfunc("+o+","+r+",runtimeCtx) )":"lang.callfunc("+o+","+r+",runtimeCtx)"}throw new i.ArcadeCompilationError(e,i.ExecutionErrorCodes.FunctionNotFound,n)}catch(t){throw t}}function Q(e,n){try{if(3!==n.arguments.length)throw new i.ArcadeCompilationError(e,i.ExecutionErrorCodes.WrongNumberOfParameters,n);const r=oe(e);return`${e.isAsync?"(yield (function() { \n return lang.__awaiter(this, void 0, void 0, function* () {":"function() {"}\n        var ${r} = ${A(e,n.arguments[0])};\n\n        if (${r} === true) {\n          return  ${A(e,n.arguments[1])};\n        }\n        else if (${r} === false) {\n          return ${A(e,n.arguments[2])};\n        }\n        else {\n          lang.error('ExecutionErrorCodes.BooleanConditionRequired');\n        }\n      ${e.isAsync?"})}()))":"}()"}`}catch(r){throw r}}function X(e,n){try{if(n.arguments.length<2||n.arguments.length>3)throw new i.ArcadeCompilationError(e,i.ExecutionErrorCodes.WrongNumberOfParameters,n);const r=oe(e),t=oe(e);return 3===n.arguments.length?`${e.isAsync?"(yield (function() { \n return lang.__awaiter(this, void 0, void 0, function* () {":"function() {"}\n      var ${r} = ${A(e,n.arguments[0])};\n      var ${t} = ${A(e,n.arguments[1])};\n      ${r} = lang.getNestedOptionalValue(${r}, ${t});\n      return ${r} != null && ${r} !== "" ? ${r} : ${A(e,n.arguments[2])};\n      ${e.isAsync?"})}()))":"}()"}`:`${e.isAsync?"(yield (function() { \n return lang.__awaiter(this, void 0, void 0, function* () {":"function() {"}\n        var ${r} = ${A(e,n.arguments[0])};\n        if (${r} === null) {\n          return  ${A(e,n.arguments[1])};\n        }\n        if (${r} === "") {\n          return  ${A(e,n.arguments[1])};\n        }\n        if (${r} === undefined) {\n          return  ${A(e,n.arguments[1])};\n        }\n        return ${r};\n      ${e.isAsync?"})}()))":"}()"}`}catch(r){throw r}}function ee(e,n){try{if(n.arguments.length<3)throw new i.ArcadeCompilationError(e,i.ExecutionErrorCodes.WrongNumberOfParameters,n);if(n.arguments.length%2==0)throw new i.ArcadeCompilationError(e,i.ExecutionErrorCodes.WrongNumberOfParameters,n);const r=oe(e);let t="var ";for(let o=0;o<n.arguments.length-1;o+=2)t+=`${r} = lang.mustBoolean(${A(e,n.arguments[o])}, runtimeCtx);\n      if (${r} === true ) {\n        return ${A(e,n.arguments[o+1])}\n      }\n`;return`${e.isAsync?"(yield (function() { \n return lang.__awaiter(this, void 0, void 0, function* () {":"function() {"}\n        ${t}\n        return ${A(e,n.arguments[n.arguments.length-1])}\n        ${e.isAsync?"})}()))":"}()"}`}catch(r){throw r}}function ne(e,n){try{if(n.arguments.length<2)throw new i.ArcadeCompilationError(e,i.ExecutionErrorCodes.WrongNumberOfParameters,n);if(2===n.arguments.length)return`(${A(e,n.arguments[1])})`;if((n.arguments.length-1)%2==0)throw new i.ArcadeCompilationError(e,i.ExecutionErrorCodes.WrongNumberOfParameters,n);const r=oe(e),t=oe(e);let o="var ";for(let l=1;l<n.arguments.length-1;l+=2)o+=`${t} = ${A(e,n.arguments[l])};\n      if (lang.binary(${t}, ${r}, "==") === true ) {\n        return ${A(e,n.arguments[l+1])}\n      }\n`;return`${e.isAsync?"(yield (function() { \n return lang.__awaiter(this, void 0, void 0, function* () {":"function() {"}\n        var ${r} = ${A(e,n.arguments[0])};\n        ${o}\n        return ${A(e,n.arguments[n.arguments.length-1])}\n        ${e.isAsync?"})}()))":"}()"}`}catch(r){throw r}}const re={};function te(e){return e.symbols.symbolCounter++,`_T${e.symbols.symbolCounter}`}function oe(e){return e.symbols.symbolCounter++,`_Tvar${e.symbols.symbolCounter}`}m.registerFunctions(re,C),y.registerFunctions(re,C),E.registerFunctions(re,C),g.registerFunctions(re,C),h.registerFunctions(re,C),re.iif=function(e,n){try{return C(e,n,((r,t,o)=>{throw new i.ArcadeExecutionError(e,i.ExecutionErrorCodes.Unrecognized,n)}))}catch(r){throw r}},re.decode=function(e,n){try{return C(e,n,((r,t,o)=>{throw new i.ArcadeExecutionError(e,i.ExecutionErrorCodes.Unrecognized,n)}))}catch(r){throw r}},re.when=function(e,n){try{return C(e,n,((r,t,o)=>{throw new i.ArcadeExecutionError(e,i.ExecutionErrorCodes.Unrecognized,n)}))}catch(r){throw r}},re.defaultvalue=function(e,n){try{return C(e,n,((r,t,o)=>{throw new i.ArcadeExecutionError(e,i.ExecutionErrorCodes.Unrecognized,n)}))}catch(r){throw r}};const le={};for(const Se in re)le[Se]=new s.NativeFunction(re[Se]);f.registerFunctions(re,C);for(const Se in re)re[Se]=new s.NativeFunction(re[Se]);const ae=function(){};ae.prototype=re;const ie=function(){};function ce(e,n,r){const t={_SymbolsMap:{}};e||(e={}),r||(r={}),t.textformatting=1,t.infinity=1,t.pi=1;for(const o in n)t[o]=1;for(const o in r)t[o]=1;for(const o in e)t[o]=1;return t}function se(e,n,r,t){const o=r?new ie:new ae;e||(e={}),n||(n={});const l=new a({newline:"\n",tab:"\t",singlequote:"'",doublequote:'"',forwardslash:"/",backwardslash:"\\"});l.immutable=!1,o._SymbolsMap={textformatting:1,infinity:1,pi:1},o.textformatting=l,o.infinity=Number.POSITIVE_INFINITY,o.pi=Math.PI;for(const a in n)o[a]=n[a],o._SymbolsMap[a]=1;for(const a in e){const n=e[a];o._SymbolsMap[a]=1,u.isGraphic(n)?o[a]=c.createFromGraphic(n,t??null):o[a]=n}return o}ie.prototype=le;const ue={fixSpatialReference:u.fixSpatialReference,parseArguments:v,standardFunction:C};function de(e,n){const r={mode:n,compiled:!0,functions:{},signatures:[],standardFunction:C,standardFunctionAsync:C,evaluateIdentifier:me};for(let t=0;t<e.length;t++)e[t].registerFunctions(r);if("sync"===n){for(const e in r.functions)re[e]=new s.NativeFunction(r.functions[e]),ae.prototype[e]=re[e];for(let e=0;e<r.signatures.length;e++)d.addFunctionDeclaration(r.signatures[e],"sync")}else{for(const e in r.functions)le[e]=new s.NativeFunction(r.functions[e]),ie.prototype[e]=le[e];for(let e=0;e<r.signatures.length;e++)d.addFunctionDeclaration(r.signatures[e],"async")}}function pe(e,n){return e(n)}function me(e,n){const r=n.name;if("_SymbolsMap"===r)throw new i.ArcadeExecutionError(e,i.ExecutionErrorCodes.InvalidIdentifier,null);if(e.localStack.length>0){if(!r.toLowerCase().startsWith("_t")&&void 0!==e.localStack[e.localStack.length-1][r])return e.localStack[e.localStack.length-1][r];const n=e.mangleMap[r];if(void 0!==n&&void 0!==e.localStack[e.localStack.length-1][n])return e.localStack[e.localStack.length-1][n]}if(!r.toLowerCase().startsWith("_t")&&void 0!==e.globalScope[r])return e.globalScope[r];if(1===e.globalScope._SymbolsMap[r])return e.globalScope[r];const t=e.mangleMap[r];return void 0!==t?e.globalScope[t]:void 0}de([p.ArrayFunctions],"sync"),de([p.ArrayFunctions],"async");let ge=0;const fe={isNumber:e=>u.isNumber(e),isArray:e=>u.isArray(e),isImmutableArray:e=>u.isImmutableArray(e),isFeature:e=>u.isFeature(e),isString:e=>u.isString(e),isDictionary:e=>u.isDictionary(e),isGeometry:e=>u.isGeometry(e),geometryMember:(e,n,r,t,o=1)=>l.geometryMember(e,n,r,t,o),error(e){throw new i.ArcadeExecutionError(null,e,null)},__awaiter:(e,n,r,t)=>new Promise(((r,o)=>{function l(e){try{i(t.next(e))}catch(n){o(n)}}function a(e){try{i(t.throw(e))}catch(n){o(n)}}function i(e){e.done?r(e.value):e.value?.then?e.value.then(l,a):(ge++,ge%100==0?setTimeout((()=>{ge=0,l(e.value)}),0):l(e.value))}i((t=t.apply(e,n||[])).next())})),functionDepthchecker:(e,n)=>function(){if(n.depthCounter.depth++,n.localStack.push({}),n.depthCounter.depth>64)throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.MaximumCallDepth,null);const r=e.apply(this,arguments);return b.isPromiseLike(r)?r.then((e=>(n.depthCounter.depth--,n.localStack.length=n.localStack.length-1,e))):(n.depthCounter.depth--,n.localStack.length=n.localStack.length-1,r)},chkAssig(e,n){if(void 0===n.gdefs[e])throw new i.ArcadeExecutionError(n,i.ExecutionErrorCodes.InvalidIdentifier,null);return e},mustBoolean(e,n){if(!0===e||!1===e)return e;throw new i.ArcadeExecutionError(n,i.ExecutionErrorCodes.BooleanConditionRequired,null)},setAssig:(e,n)=>(n.gdefs[e]=1,e),castString:e=>u.toString(e),aCheck(e,n){if(u.isFunctionParameter(e)){if("ArrayExpression"===n)throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.NoFunctionInArray,null);if("ObjectExpression"===n)throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.NoFunctionInDictionary,null);throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.NoFunctionInTemplateLiteral,null)}return e===u.voidOperation?null:e},Dictionary:a,Feature:c,UserDefinedCompiledFunction:w,dictionary(e){const n={},r=new Map;for(let o=0;o<e.length;o+=2){if(u.isFunctionParameter(e[o+1]))throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.NoFunctionInDictionary,null);if(!1===u.isString(e[o]))throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.KeyMustBeString,null);let t=e[o].toString();const l=t.toLowerCase();r.has(l)?t=r.get(l):r.set(l,t),e[o+1]===u.voidOperation?n[t]=null:n[t]=e[o+1]}const t=new a(n);return t.immutable=!1,t},strCheck(e){if(!1===u.isString(e))throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.KeyMustBeString,null);return e},unary(e,n){if(u.isBoolean(e)){if("!"===n)return!e;if("-"===n)return-1*u.toNumber(e);if("+"===n)return 1*u.toNumber(e);if("~"===n)return~u.toNumber(e);throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.UnsupportedUnaryOperator,null)}if("-"===n)return-1*u.toNumber(e);if("+"===n)return 1*u.toNumber(e);if("~"===n)return~u.toNumber(e);throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.UnsupportedUnaryOperator,null)},logicalCheck(e){if(!1===u.isBoolean(e))throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.LogicExpressionOrAnd,null);return e},logical(e,n,r){if(u.isBoolean(e)&&u.isBoolean(n))switch(r){case"||":return e||n;case"&&":return e&&n;default:throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.LogicExpressionOrAnd,null)}throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.LogicExpressionOrAnd,null)},binary(e,n,r){switch(r){case"|":case"<<":case">>":case">>>":case"^":case"&":return u.binaryOperator(u.toNumber(e),u.toNumber(n),r);case"==":case"=":return u.equalityTest(e,n);case"!=":return!u.equalityTest(e,n);case"<":case">":case"<=":case">=":return u.greaterThanLessThan(e,n,r);case"+":return u.isString(e)||u.isString(n)?u.toString(e)+u.toString(n):u.toNumber(e)+u.toNumber(n);case"-":return u.toNumber(e)-u.toNumber(n);case"*":return u.toNumber(e)*u.toNumber(n);case"/":return u.toNumber(e)/u.toNumber(n);case"%":return u.toNumber(e)%u.toNumber(n);default:throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.UnsupportedOperator,null)}},assign(e,n,r){switch(n){case"=":return e===u.voidOperation?null:e;case"/=":return u.toNumber(r)/u.toNumber(e);case"*=":return u.toNumber(r)*u.toNumber(e);case"-=":return u.toNumber(r)-u.toNumber(e);case"+=":return u.isString(r)||u.isString(e)?u.toString(r)+u.toString(e):u.toNumber(r)+u.toNumber(e);case"%=":return u.toNumber(r)%u.toNumber(e);default:throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.UnsupportedOperator,null)}},update(e,n,r,t){const o=u.toNumber(e[n]);return e[n]="++"===r?o+1:o-1,!1===t?o:"++"===r?o+1:o-1},graphicToFeature:(e,n,r)=>null===e?null:c.createFromGraphicLikeObject(e.geometry,e.attributes,n,r.timeZone),memberupdate(e,n,r,t){let o;if(u.isArray(e)){if(!u.isNumber(n))throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.ArrayAccessorMustBeNumber,null);if(n<0&&(n=e.length+n),n<0||n>=e.length)throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.OutOfBounds,null);o=u.toNumber(e[n]),e[n]="++"===r?o+1:o-1}else if(e instanceof a){if(!1===u.isString(n))throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.KeyAccessorMustBeString,null);if(!0!==e.hasField(n))throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.FieldNotFound,null,{key:n});o=u.toNumber(e.field(n)),e.setField(n,"++"===r?o+1:o-1)}else if(u.isFeature(e)){if(!1===u.isString(n))throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.KeyAccessorMustBeString,null);if(!0!==e.hasField(n))throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.FieldNotFound,null);o=u.toNumber(e.field(n)),e.setField(n,"++"===r?o+1:o-1)}else{if(u.isImmutableArray(e))throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.Immutable,null);if(!(e instanceof be))throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.InvalidIdentifier,null);if(!1===u.isString(n))throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.ModuleAccessorMustBeString,null);if(!0!==e.hasGlobal(n))throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.ModuleExportNotFound,null);o=u.toNumber(e.global(n)),e.setGlobal(n,"++"===r?o+1:o-1)}return!1===t?o:"++"===r?o+1:o-1},assignmember(e,n,r,t){if(u.isArray(e)){if(!u.isNumber(n))throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.ArrayAccessorMustBeNumber,null);if(n<0&&(n=e.length+n),n<0||n>e.length)throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.OutOfBounds,null);if(n===e.length){if("="!==r)throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.OutOfBounds,null);e[n]=this.assign(t,r,e[n])}else e[n]=this.assign(t,r,e[n])}else if(e instanceof a){if(!1===u.isString(n))throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.KeyAccessorMustBeString,null);if(!0===e.hasField(n))e.setField(n,this.assign(t,r,e.field(n)));else{if("="!==r)throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.FieldNotFound,null);e.setField(n,this.assign(t,r,null))}}else if(u.isFeature(e)){if(!1===u.isString(n))throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.KeyAccessorMustBeString,null);if(!0===e.hasField(n))e.setField(n,this.assign(t,r,e.field(n)));else{if("="!==r)throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.FieldNotFound,null);e.setField(n,this.assign(t,r,null))}}else{if(u.isImmutableArray(e))throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.Immutable,null);if(!(e instanceof be))throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.InvalidIdentifier,null);if(!1===u.isString(n))throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.ModuleAccessorMustBeString,null);if(!e.hasGlobal(n))throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.ModuleExportNotFound,null);e.setGlobal(n,this.assign(t,r,e.global(n)))}},member(e,n){if(null===e)throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.MemberOfNull,null);if(e instanceof a||u.isFeature(e)){if(u.isString(n))return e.field(n);throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.InvalidMemberAccessKey,null)}if(e instanceof x){if(u.isString(n))return l.geometryMember(e,n,null,null);throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.InvalidMemberAccessKey,null)}if(u.isArray(e)){if(u.isNumber(n)&&isFinite(n)&&Math.floor(n)===n){if(n<0&&(n=e.length+n),n>=e.length||n<0)throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.OutOfBounds,null);return e[n]}throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.InvalidMemberAccessKey,null)}if(u.isString(e)){if(u.isNumber(n)&&isFinite(n)&&Math.floor(n)===n){if(n<0&&(n=e.length+n),n>=e.length||n<0)throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.OutOfBounds,null);return e[n]}throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.InvalidMemberAccessKey,null)}if(u.isImmutableArray(e)){if(u.isNumber(n)&&isFinite(n)&&Math.floor(n)===n){if(n<0&&(n=e.length()+n),n>=e.length()||n<0)throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.OutOfBounds,null);return e.get(n)}throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.InvalidMemberAccessKey,null)}if(e instanceof be){if(u.isString(n))return e.global(n);throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.InvalidMemberAccessKey,null)}throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.InvalidMemberAccessKey,null)},callfunc:(e,n,r)=>e.call(r,{arguments:n,preparsed:!0}),loadModule(e,n){const r=n.moduleFactoryMap[e];if(n.moduleSingletons[r])return n.moduleSingletons[r];const t=n.moduleFactory[r]({vars:{},moduleSingletons:n.moduleSingletons,depthCounter:n.depthCounter,console:n.console,abortSignal:n.abortSignal,isAsync:n.isAsync,services:n.services,lrucache:n.lrucache,timeZone:n.timeZone??null,interceptor:n.interceptor},n.spatialReference);return n.moduleSingletons[r]=t,t},callModuleFunction(e,n,r,t){if(!(e instanceof be))throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.FunctionNotFound,null);const o=e.global(r);if(!1===u.isFunctionParameter(o))throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.CallNonFunction,null);return o.call(t,{preparsed:!0,arguments:n})},getNestedOptionalValue:(e,n)=>l.getNestedOptionalValue(e,n)};function Ee(e){console.log(e)}function he(e,n,r=!1){null===n&&(n={vars:{},customfunctions:{}});let t=null;e.usesModules&&(t=new o.ArcadeModuleLoader(null,e.loadedModules));const l={isAsync:r,globalScope:ce(n.vars,r?le:re,n.customfunctions),moduleFactory:{},moduleFactoryMap:{},undeclaredGlobalsInFunctions:new Map,customfunctions:n.customfunctions,libraryResolver:t,localScope:null,mangleMap:{},depthCounter:{depth:1},exports:{},console:Ee,lrucache:n.lrucache,timeZone:n.timeZone??null,interceptor:n.interceptor,services:n.services,symbols:{symbolCounter:0}};let a=R(l,e);""===a&&(a="lc.voidOperation; "),l.undeclaredGlobalsInFunctions.size>0&&l.undeclaredGlobalsInFunctions.forEach((e=>{throw new i.ArcadeCompilationError(n,i.ExecutionErrorCodes.InvalidIdentifier,e.node)}));let c="";c=r?"var runtimeCtx=this.prepare(context, true);\n var lc = this.lc;  var lang = this.lang; var gscope=runtimeCtx.globalScope; \nreturn lang.__awaiter(this, void 0, void 0, function* () {\n\n function mainBody() {\n var lastStatement=lc.voidOperation;\n return lang.__awaiter(this, void 0, void 0, function* () {\n"+a+"\n return lastStatement; }); } \n return this.postProcess(yield mainBody()); }); ":"var runtimeCtx=this.prepare(context, false);\n var lc = this.lc;  var lang = this.lang; var gscope=runtimeCtx.globalScope; \n function mainBody() {\n var lastStatement=lc.voidOperation;\n "+a+"\n return lastStatement; } \n return this.postProcess(mainBody()); ";const s=l.moduleFactory,d=l.moduleFactoryMap,p=l.exports,m={};let g;for(g in p)m[g]=l.mangleMap[g]??g;const f={lc:u.lc,lang:fe,mangles:l.mangleMap,postProcess(e){if(e instanceof u.ReturnResult&&(e=e.value),e instanceof u.ImplicitResult&&(e=e.value),e===u.voidOperation&&(e=null),e===u.breakResult)throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.IllegalResult,null);if(e===u.continueResult)throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.IllegalResult,null);if(u.isFunctionParameter(e))throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.IllegalResult,null);return e},prepare(e,n){let r=e.spatialReference;null==r&&(r=S.WebMercator);const t=se(e.vars,e.customfunctions,n,e.timeZone);return{localStack:[],isAsync:n,moduleFactory:s,moduleFactoryMap:d,mangleMap:this.mangles,moduleSingletons:{},exports:p,gdefs:{},exportmangle:m,spatialReference:r,globalScope:t,abortSignal:void 0===e.abortSignal||null===e.abortSignal?{aborted:!1}:e.abortSignal,localScope:null,services:e.services,console:e.console??Ee,lrucache:e.lrucache,timeZone:e.timeZone??null,interceptor:e.interceptor,symbols:{symbolCounter:0},depthCounter:{depth:1}}}};return new Function("context","spatialReference",c).bind(f)}async function ye(){return de([await new Promise(((n,r)=>e(["./functions/geomasync"],n,r)))],"async"),!0}class be extends t.ArcadeModule{constructor(e){super(),this.moduleContext=e}hasGlobal(e){return void 0===this.moduleContext.exports[e]&&(e=e.toLowerCase()),void 0!==this.moduleContext.exports[e]}setGlobal(e,n){const r=this.moduleContext.globalScope,t=e.toLowerCase();if(u.isFunctionParameter(n))throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.AssignModuleFunction,null);r[this.moduleContext.exportmangle[t]]=n}global(e){const n=this.moduleContext.globalScope,r=e.toLowerCase(),t=n[this.moduleContext.exportmangle[r]];if(void 0===t)throw new i.ArcadeExecutionError(null,i.ExecutionErrorCodes.InvalidIdentifier,null);if(u.isFunctionParameter(t)&&!(t instanceof s.ScopeMarshalledFunction)){const e=new s.ScopeMarshalledFunction;return e.fn=t,e.parameterEvaluator=C,e.context=this.moduleContext,n[this.moduleContext.exportmangle[r]]=e,e}return t}}function xe(e,n,r=!1){const t={isAsync:r,moduleFactory:n.moduleFactory,moduleFactoryMap:{},libraryResolver:new o.ArcadeModuleLoader(null,e.loadedModules),globalScope:ce(n.vars,r?le:re,n.customfunctions),customfunctions:n.customfunctions,localScope:null,mangleMap:{},undeclaredGlobalsInFunctions:new Map,depthCounter:{depth:1},exports:{},console:Ee,lrucache:n.lrucache,timeZone:n.timeZone??null,interceptor:n.interceptor,services:n.services,symbols:{symbolCounter:0}};let l=R(t,e);""===l&&(l="lc.voidOperation; ");let a="";a=r?"var runtimeCtx=this.prepare(context, true);\n var lc = this.lc;  var lang = this.lang; var gscope=runtimeCtx.globalScope; \nreturn lang.__awaiter(this, void 0, void 0, function* () {\n\n function mainBody() {\n var lastStatement=lc.voidOperation;\n return lang.__awaiter(this, void 0, void 0, function* () {\n"+l+"\n return lastStatement; }); } \n yield mainBody(); \n return this.prepareModule(runtimeCtx); }); ":"var runtimeCtx=this.prepare(context, false);\n var lc = this.lc;  var lang = this.lang; var gscope=runtimeCtx.globalScope; \n function mainBody() {\n var lastStatement=lc.voidOperation;\n "+l+"\n return lastStatement; } \n mainBody(); \n return this.prepareModule(runtimeCtx); ";const i=t.moduleFactory,c=t.moduleFactoryMap,s=t.exports,d={};let p;for(p in s)d[p]=t.mangleMap[p]??p;const m={lc:u.lc,lang:fe,mangles:t.mangleMap,prepareModule:e=>new be(e),prepare(e,n){let r=e.spatialReference;null==r&&(r=new S({wkid:102100}));const t=se(e.vars,e.customfunctions,n,e.timeZone);return{localStack:[],isAsync:n,exports:s,exportmangle:d,gdefs:{},moduleFactory:i,moduleFactoryMap:c,moduleSingletons:e.moduleSingletons,mangleMap:this.mangles,spatialReference:r,globalScope:t,abortSignal:void 0===e.abortSignal||null===e.abortSignal?{aborted:!1}:e.abortSignal,localScope:null,services:e.services,console:e.console??Ee,lrucache:e.lrucache,timeZone:e.timeZone??null,interceptor:e.interceptor,symbols:{symbolCounter:0},depthCounter:e.depthCounter}}};return new Function("context","spatialReference",a).bind(m)}n.UserDefinedCompiledFunction=w,n.compileScript=he,n.enableAsyncSupport=ye,n.executeScript=pe,n.extend=de,n.functionHelper=ue,Object.defineProperty(n,Symbol.toStringTag,{value:"Module"})}));
