/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","./arcadeEnvironment","./ArcadeModule","./ArcadeModuleLoader","./containerUtils","./Dictionary","./executionError","./Feature","./FunctionWrapper","../chunks/languageUtils","./treeAnalysis","../chunks/array","./functions/date","./functions/geometry","./functions/geomsync","./functions/maths","./functions/stats","./functions/string","../geometry/Geometry","../geometry/SpatialReference"],(function(e,r,t,o,n,i,c,u,a,s,l,d,E,f,p,h,x,w,m,g){"use strict";class b extends a.ArcadeFunction{constructor(e,r){super(),this.definition=e,this.context=r}createFunction(e){return(...r)=>{const t={spatialReference:this.context.spatialReference,console:this.context.console,services:this.context.services,timeZone:this.context.timeZone??null,lrucache:this.context.lrucache,exports:this.context.exports,libraryResolver:this.context.libraryResolver,interceptor:this.context.interceptor,localScope:{},depthCounter:{depth:e.depthCounter.depth+1},globalScope:this.context.globalScope};if(t.depthCounter.depth>64)throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.MaximumCallDepth,null);return re(this.definition,t,r,null)}}call(e,r){return A(e,r,((t,o,n)=>{const i={spatialReference:e.spatialReference,services:e.services,globalScope:e.globalScope,depthCounter:{depth:e.depthCounter.depth+1},libraryResolver:e.libraryResolver,exports:e.exports,timeZone:e.timeZone??null,console:e.console,lrucache:e.lrucache,interceptor:e.interceptor,localScope:{}};if(i.depthCounter.depth>64)throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.MaximumCallDepth,r);return re(this.definition,i,n,r)}))}marshalledCall(e,r,t,o){return o(e,r,((n,i,c)=>{const u={spatialReference:e.spatialReference,globalScope:t.globalScope,services:e.services,depthCounter:{depth:e.depthCounter.depth+1},libraryResolver:e.libraryResolver,exports:e.exports,console:e.console,timeZone:e.timeZone??null,lrucache:e.lrucache,interceptor:e.interceptor,localScope:{}};return c=c.map((r=>!s.isFunctionParameter(r)||r instanceof a.ScopeMarshalledFunction?r:a.wrapModuleScopedResponse(r,e,o))),a.wrapModuleScopedResponse(re(this.definition,u,c,r),t,o)}))}}class v extends t.ArcadeModule{constructor(e){super(),this.source=e}global(e){const r=this.executingContext.globalScope[e.toLowerCase()];if(r.valueset||(r.value=C(this.executingContext,r.node),r.valueset=!0),s.isFunctionParameter(r.value)&&!(r.value instanceof a.ScopeMarshalledFunction)){const e=new a.ScopeMarshalledFunction;e.fn=r.value,e.parameterEvaluator=A,e.context=this.executingContext,r.value=e}return r.value}setGlobal(e,r){if(s.isFunctionParameter(r))throw new c.ArcadeExecutionError(null,c.ExecutionErrorCodes.AssignModuleFunction,null);this.executingContext.globalScope[e.toLowerCase()]={value:r,valueset:!0,node:null}}hasGlobal(e){return void 0===this.executingContext.exports[e]&&(e=e.toLowerCase()),void 0!==this.executingContext.exports[e]}loadModule(e){let r=e.spatialReference;null==r&&(r=new g({wkid:102100})),this.moduleScope=oe({},e.customfunctions,e.timeZone),this.executingContext={spatialReference:r,globalScope:this.moduleScope,localScope:null,libraryResolver:new o.ArcadeModuleLoader(e.libraryResolver._moduleSingletons,this.source.syntax.loadedModules),exports:{},services:e.services,console:e.console??ie,timeZone:e.timeZone??null,lrucache:e.lrucache,interceptor:e.interceptor,depthCounter:{depth:1}},U(this.executingContext,this.source.syntax)}}function y(e,r){const t=[];for(let o=0;o<r.arguments.length;o++)t.push(C(e,r.arguments[o]));return t}function A(e,r,t){try{return!0===r.preparsed?t(e,null,r.arguments):t(e,r,y(e,r))}catch(o){throw o}}function C(e,r){try{switch(r.type){case"AssignmentExpression":return k(e,r);case"UpdateExpression":return M(e,r);case"TemplateLiteral":return Y(e,r);case"Identifier":return J(e,r);case"MemberExpression":return V(e,r);case"Literal":return r.value;case"CallExpression":return Q(e,r);case"UnaryExpression":return W(e,r);case"BinaryExpression":return _(e,r);case"LogicalExpression":return z(e,r);case"ArrayExpression":return j(e,r);case"ObjectExpression":return R(e,r);default:throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.Unrecognized,r)}}catch(t){throw c.ensureArcadeExecutionError(e,r,t)}}function S(e,r){switch(r.type){case"EmptyStatement":return s.voidOperation;case"VariableDeclaration":return Z(e,r);case"ImportDeclaration":return K(e,r);case"ExportNamedDeclaration":return T(e,r);case"BlockStatement":return U(e,r);case"FunctionDeclaration":return D(e,r);case"ReturnStatement":return q(e,r);case"IfStatement":return L(e,r);case"ExpressionStatement":return P(e,r);case"BreakStatement":return s.breakResult;case"ContinueStatement":return s.continueResult;case"ForStatement":return N(e,r);case"ForInStatement":return F(e,r);case"WhileStatement":return I(e,r);default:throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.Unrecognized,r)}}function R(e,r){const t={},o=new Map;for(let i=0;i<r.properties.length;i++){const n=r.properties[i],u="Identifier"===n.key.type?n.key.name:C(e,n.key),a=C(e,n.value);if(s.isFunctionParameter(a))throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.NoFunctionInDictionary,r);if(!1===s.isString(u))throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.KeyMustBeString,r);let l=u.toString();const d=l.toLowerCase();o.has(d)?l=o.get(d):o.set(d,l),a===s.voidOperation?t[l]=null:t[l]=a}const n=new i(t);return n.immutable=!1,n}function F(e,t){const o=C(e,t.right);"VariableDeclaration"===t.left.type&&Z(e,t.left);const n=r.toSymbolId("VariableDeclaration"===t.left.type?t.left.declarations[0].id:t.left);let u=null;if(null!=e.localScope&&void 0!==e.localScope[n]&&(u=e.localScope[n]),null===u&&void 0!==e.globalScope[n]&&(u=e.globalScope[n]),null===u)throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.InvalidIdentifier,t);if(s.isArray(o)||s.isString(o)){const r=o.length;for(let o=0;o<r;o++){u.value=o;const r=S(e,t.body);if(r===s.breakResult)break;if(r instanceof s.ReturnResult)return r}return s.voidOperation}if(s.isImmutableArray(o)){for(let r=0;r<o.length();r++){u.value=r;const o=S(e,t.body);if(o===s.breakResult)break;if(o instanceof s.ReturnResult)return o}return s.voidOperation}if(o instanceof i||s.isFeature(o)){const r=o.keys();for(let o=0;o<r.length;o++){u.value=r[o];const n=S(e,t.body);if(n===s.breakResult)break;if(n instanceof s.ReturnResult)return n}}return s.voidOperation}function N(e,r){null!==r.init&&("VariableDeclaration"===r.init.type?S(e,r.init):C(e,r.init));const t={testResult:!0,lastAction:s.voidOperation};do{O(e,r,t)}while(!0===t.testResult);return t.lastAction instanceof s.ReturnResult?t.lastAction:s.voidOperation}function I(e,r){const t={testResult:!0,lastAction:s.voidOperation};if(t.testResult=C(e,r.test),!1===t.testResult)return s.voidOperation;if(!0!==t.testResult)throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.BooleanConditionRequired,r);for(;!0===t.testResult&&(t.lastAction=S(e,r.body),t.lastAction!==s.breakResult)&&!(t.lastAction instanceof s.ReturnResult);)if(t.testResult=C(e,r.test),!0!==t.testResult&&!1!==t.testResult)throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.BooleanConditionRequired,r);return t.lastAction instanceof s.ReturnResult?t.lastAction:s.voidOperation}function O(e,r,t){if(null!==r.test){if(t.testResult=C(e,r.test),!1===t.testResult)return;if(!0!==t.testResult)throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.BooleanConditionRequired,r)}t.lastAction=S(e,r.body),t.lastAction!==s.breakResult?t.lastAction instanceof s.ReturnResult?t.testResult=!1:null!==r.update&&C(e,r.update):t.testResult=!1}function M(e,t){if("CallExpression"===t.argument.type)throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.NeverReach,t);let o;if("MemberExpression"===t.argument.type){const r=C(e,t.argument.object);let n;if(!0===t.argument.computed)n=C(e,t.argument.property);else{if("Identifier"!==t.argument.property.type)throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.Unrecognized,t);n=t.argument.property.name}if(s.isArray(r)){if(!s.isNumber(n))throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.ArrayAccessorMustBeNumber,t);if(n<0&&(n=r.length+n),n<0||n>=r.length)throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.OutOfBounds,t);o=s.toNumber(r[n]),r[n]="++"===t.operator?o+1:o-1}else if(r instanceof i){if(!1===s.isString(n))throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.KeyAccessorMustBeString,t);if(!0!==r.hasField(n))throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.FieldNotFound,t);o=s.toNumber(r.field(n)),r.setField(n,"++"===t.operator?o+1:o-1)}else if(s.isFeature(r)){if(!1===s.isString(n))throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.KeyAccessorMustBeString,t);if(!0!==r.hasField(n))throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.FieldNotFound,t);o=s.toNumber(r.field(n)),r.setField(n,"++"===t.operator?o+1:o-1)}else{if(s.isImmutableArray(r))throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.Immutable,t);if(!(r instanceof v))throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.InvalidParameter,t);if(!1===s.isString(n))throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.ModuleAccessorMustBeString,t);if(!0!==r.hasGlobal(n))throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.ModuleExportNotFound,t);o=s.toNumber(r.global(n)),r.setGlobal(n,"++"===t.operator?o+1:o-1)}return!1===t.prefix?o:"++"===t.operator?o+1:o-1}const n=r.toSymbolId(t.argument);if(null!=e.localScope&&void 0!==e.localScope[n])return o=s.toNumber(e.localScope[n].value),e.localScope[n]={value:"++"===t.operator?o+1:o-1,valueset:!0,node:t},!1===t.prefix?o:"++"===t.operator?o+1:o-1;if(void 0!==e.globalScope[n])return o=s.toNumber(e.globalScope[n].value),e.globalScope[n]={value:"++"===t.operator?o+1:o-1,valueset:!0,node:t},!1===t.prefix?o:"++"===t.operator?o+1:o-1;throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.InvalidIdentifier,t)}function B(e,r,t,o,n){switch(r){case"=":return e===s.voidOperation?null:e;case"/=":return s.toNumber(t)/s.toNumber(e);case"*=":return s.toNumber(t)*s.toNumber(e);case"-=":return s.toNumber(t)-s.toNumber(e);case"+=":return s.isString(t)||s.isString(e)?s.toString(t)+s.toString(e):s.toNumber(t)+s.toNumber(e);case"%=":return s.toNumber(t)%s.toNumber(e);default:throw new c.ArcadeExecutionError(n,c.ExecutionErrorCodes.UnsupportedOperator,o)}}function k(e,t){if("MemberExpression"===t.left.type){const r=C(e,t.left.object);let o;if(!0===t.left.computed)o=C(e,t.left.property);else{if("Identifier"!==t.left.property.type)throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.InvalidIdentifier,t);o=t.left.property.name}const n=C(e,t.right);if(s.isArray(r)){if(!s.isNumber(o))throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.ArrayAccessorMustBeNumber,t);if(o<0&&(o=r.length+o),o<0||o>r.length)throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.OutOfBounds,t);if(o===r.length){if("="!==t.operator)throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.OutOfBounds,t);r[o]=B(n,t.operator,r[o],t,e)}else r[o]=B(n,t.operator,r[o],t,e)}else if(r instanceof i){if(!1===s.isString(o))throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.KeyAccessorMustBeString,t);if(!0===r.hasField(o))r.setField(o,B(n,t.operator,r.field(o),t,e));else{if("="!==t.operator)throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.FieldNotFound,t,{key:o});r.setField(o,B(n,t.operator,null,t,e))}}else if(s.isFeature(r)){if(!1===s.isString(o))throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.KeyAccessorMustBeString,t);if(!0===r.hasField(o))r.setField(o,B(n,t.operator,r.field(o),t,e));else{if("="!==t.operator)throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.FieldNotFound,t,{key:o});r.setField(o,B(n,t.operator,null,t,e))}}else{if(s.isImmutableArray(r))throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.Immutable,t);if(!(r instanceof v))throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.InvalidIdentifier,t);if(!1===s.isString(o))throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.ModuleAccessorMustBeString,t);if(!0!==r.hasGlobal(o))throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.ModuleExportNotFound,t);r.setGlobal(o,B(n,t.operator,r.global(o),t,e))}return s.voidOperation}const o=r.toSymbolId(t.left),n=C(e,t.right);if(null!=e.localScope&&void 0!==e.localScope[o])return e.localScope[o]={value:B(n,t.operator,e.localScope[o].value,t,e),valueset:!0,node:t.right},s.voidOperation;if(void 0!==e.globalScope[o])return e.globalScope[o]={value:B(n,t.operator,e.globalScope[o].value,t,e),valueset:!0,node:t.right},s.voidOperation;throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.InvalidIdentifier,t)}function P(e,r){const t=C(e,r.expression);return t===s.voidOperation?s.voidOperation:new s.ImplicitResult(t)}function L(e,r){const t=C(e,r.test);if(!0===t)return S(e,r.consequent);if(!1===t)return null!==r.alternate?S(e,r.alternate):s.voidOperation;throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.BooleanConditionRequired,r)}function U(e,r){let t=s.voidOperation;for(let o=0;o<r.body.length;o++)if(t=S(e,r.body[o]),t instanceof s.ReturnResult||t===s.breakResult||t===s.continueResult)return t;return t}function q(e,r){if(null===r.argument)return new s.ReturnResult(s.voidOperation);const t=C(e,r.argument);return new s.ReturnResult(t)}function D(e,t){const o=r.toSymbolId(t.id);return e.globalScope[o]={valueset:!0,node:null,value:new b(t,e)},s.voidOperation}function K(e,t){const o=r.toSymbolId(t.specifiers[0].local),n=e.libraryResolver.loadLibrary(o);let i;return e.libraryResolver._moduleSingletons?.has(n.uri)?i=e.libraryResolver._moduleSingletons.get(n.uri):(i=new v(n),i.loadModule(e),e.libraryResolver._moduleSingletons?.set(n.uri,i)),e.globalScope[o]={value:i,valueset:!0,node:t},s.voidOperation}function T(e,t){if(S(e,t.declaration),"FunctionDeclaration"===t.declaration.type)e.exports[r.toSymbolId(t.declaration.id)]="function";else if("VariableDeclaration"===t.declaration.type)for(const o of t.declaration.declarations)e.exports[r.toSymbolId(o.id)]="variable";return s.voidOperation}function Z(e,r){for(let t=0;t<r.declarations.length;t++)G(e,r.declarations[t]);return s.voidOperation}function G(e,t){let o=null===t.init?null:C(e,t.init);if(o===s.voidOperation&&(o=null),"Identifier"!==t.id.type)throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.InvalidIdentifier,t);const n=r.toSymbolId(t.id);null!=e.localScope?e.localScope[n]={value:o,valueset:!0,node:t.init}:e.globalScope[n]={value:o,valueset:!0,node:t.init}}function V(e,r){try{const t=C(e,r.object);if(null===t)throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.MemberOfNull,r);if(!1===r.computed){if("Identifier"===r.property.type){if(t instanceof i||s.isFeature(t))return t.field(r.property.name);if(t instanceof m)return n.geometryMember(t,r.property.name,e,r);if(t instanceof v){if(!t.hasGlobal(r.property.name))throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.InvalidIdentifier,r);return t.global(r.property.name)}}throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.InvalidMemberAccessKey,r)}let o=C(e,r.property);if(t instanceof i||s.isFeature(t)){if(s.isString(o))return t.field(o);throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.InvalidMemberAccessKey,r)}if(t instanceof v){if(s.isString(o))return t.global(o);throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.InvalidMemberAccessKey,r)}if(t instanceof m){if(s.isString(o))return n.geometryMember(t,o,e,r);throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.InvalidMemberAccessKey,r)}if(s.isArray(t)){if(s.isNumber(o)&&isFinite(o)&&Math.floor(o)===o){if(o<0&&(o=t.length+o),o>=t.length||o<0)throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.OutOfBounds,r);return t[o]}throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.InvalidMemberAccessKey,r)}if(s.isString(t)){if(s.isNumber(o)&&isFinite(o)&&Math.floor(o)===o){if(o<0&&(o=t.length+o),o>=t.length||o<0)throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.OutOfBounds,r);return t[o]}throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.InvalidMemberAccessKey,r)}if(s.isImmutableArray(t)){if(s.isNumber(o)&&isFinite(o)&&Math.floor(o)===o){if(o<0&&(o=t.length()+o),o>=t.length()||o<0)throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.OutOfBounds,r);return t.get(o)}throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.InvalidMemberAccessKey,r)}throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.InvalidMemberAccessKey,r)}catch(t){throw t}}function W(e,r){try{const t=C(e,r.argument);if(s.isBoolean(t)){if("!"===r.operator)return!t;if("-"===r.operator)return-1*s.toNumber(t);if("+"===r.operator)return 1*s.toNumber(t);if("~"===r.operator)return~s.toNumber(t);throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.UnsupportedUnaryOperator,r)}if("~"===r.operator)return~s.toNumber(t);if("-"===r.operator)return-1*s.toNumber(t);if("+"===r.operator)return 1*s.toNumber(t);throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.UnsupportedUnaryOperator,r)}catch(t){throw t}}function j(e,r){try{const t=[];for(let o=0;o<r.elements.length;o++){const n=C(e,r.elements[o]);if(s.isFunctionParameter(n))throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.NoFunctionInArray,r);n===s.voidOperation?t.push(null):t.push(n)}return t}catch(t){throw t}}function _(e,r){try{const t=C(e,r.left),o=C(e,r.right);switch(r.operator){case"|":case"<<":case">>":case">>>":case"^":case"&":return s.binaryOperator(s.toNumber(t),s.toNumber(o),r.operator);case"==":return s.equalityTest(t,o);case"!=":return!s.equalityTest(t,o);case"<":case">":case"<=":case">=":return s.greaterThanLessThan(t,o,r.operator);case"+":return s.isString(t)||s.isString(o)?s.toString(t)+s.toString(o):s.toNumber(t)+s.toNumber(o);case"-":return s.toNumber(t)-s.toNumber(o);case"*":return s.toNumber(t)*s.toNumber(o);case"/":return s.toNumber(t)/s.toNumber(o);case"%":return s.toNumber(t)%s.toNumber(o);default:throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.UnsupportedOperator,r)}}catch(t){throw t}}function z(e,r){try{const t=C(e,r.left);if(s.isBoolean(t))switch(r.operator){case"||":{if(!0===t)return t;const o=C(e,r.right);if(s.isBoolean(o))return o;throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.LogicExpressionOrAnd,r)}case"&&":{if(!1===t)return t;const o=C(e,r.right);if(s.isBoolean(o))return o;throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.LogicExpressionOrAnd,r)}default:throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.LogicExpressionOrAnd,r)}throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.LogicalExpressionOnlyBoolean,r)}catch(t){throw t}}function H(e,r,t){if(s.isFunctionParameter(e))throw new c.ArcadeExecutionError(r,c.ExecutionErrorCodes.NoFunctionInTemplateLiteral,t);return e}function Y(e,r){let t="",o=0;for(const n of r.quasis)if(t+=n.value?n.value.cooked:"",!1===n.tail){t+=r.expressions[o]?s.toString(H(C(e,r.expressions[o]),e,r)):"",o++}return t}function J(e,t){try{const o=r.toSymbolId(t);if(null!=e.localScope&&void 0!==e.localScope[o]){const r=e.localScope[o];return!0===r.valueset||(r.value=C(e,r.node),r.valueset=!0),r.value}if(void 0!==e.globalScope[o]){const r=e.globalScope[o];return!0===r.valueset||(r.value=C(e,r.node),r.valueset=!0),r.value}throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.InvalidIdentifier,t)}catch(o){throw o}}function Q(e,t){try{if("MemberExpression"===t.callee.type){const r=C(e,t.callee.object);if(!(r instanceof v))throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.FunctionNotFound,t);const o=!1===t.callee.computed?t.callee.property.name:C(e,t.callee.property);if(!r.hasGlobal(o))throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.FunctionNotFound,t);const n=r.global(o);if(!s.isFunctionParameter(n))throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.CallNonFunction,t);return n.call(e,t)}if("Identifier"!==t.callee.type)throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.FunctionNotFound,t);const o=r.toSymbolId(t.callee);if(null!=e.localScope&&void 0!==e.localScope[o]){const r=e.localScope[o];if(s.isFunctionParameter(r.value))return r.value.call(e,t);throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.CallNonFunction,t)}if(void 0!==e.globalScope[o]){const r=e.globalScope[o];if(s.isFunctionParameter(r.value))return r.value.call(e,t);throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.CallNonFunction,t)}throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.FunctionNotFound,t)}catch(o){throw o}}const X={};function $(e,r,t,o){try{const n=r.arguments,i=C(e,n[t]);if(s.equalityTest(i,o))return C(e,n[t+1]);{const i=n.length-t;return 1===i?C(e,n[t]):2===i?null:3===i?C(e,n[t+2]):$(e,r,t+2,o)}}catch(n){throw n}}function ee(e,r,t,o){try{const n=r.arguments;if(!0===o)return C(e,n[t+1]);if(3===n.length-t)return C(e,n[t+2]);{const o=C(e,n[t+2]);if(!1===s.isBoolean(o))throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.BooleanConditionRequired,n[t+2]);return ee(e,r,t+2,o)}}catch(n){throw n}}function re(e,t,o,n){try{const i=e.body;if(o.length!==e.params.length)throw new c.ArcadeExecutionError(t,c.ExecutionErrorCodes.WrongNumberOfParameters,n);if(null!=t.localScope)for(let n=0;n<o.length;n++)t.localScope[r.toSymbolId(e.params[n])]={value:o[n],valueset:!0,node:null};const u=S(t,i);if(u instanceof s.ReturnResult)return u.value;if(u===s.breakResult)throw new c.ArcadeExecutionError(t,c.ExecutionErrorCodes.UnexpectedToken,n);if(u===s.continueResult)throw new c.ArcadeExecutionError(t,c.ExecutionErrorCodes.UnexpectedToken,n);return u instanceof s.ImplicitResult?u.value:u}catch(i){throw i}}E.registerFunctions(X,A),w.registerFunctions(X,A),h.registerFunctions(X,A),f.registerFunctions(X,A),x.registerFunctions(X,A),p.registerFunctions(X,A),X.iif=function(e,r){try{if(!0===r.preparsed)throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.NeverReach,r);const t=r.arguments;s.pcCheck(null===t?[]:t,3,3,e,r);const o=C(e,t[0]);if(!1===s.isBoolean(o))throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.BooleanConditionRequired,r);return C(e,!0===o?t[1]:t[2])}catch(t){throw t}},X.defaultvalue=function(e,r){try{if(!0===r.preparsed)throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.NeverReach,r);const t=r.arguments;s.pcCheck(null===t?[]:t,2,3,e,r);const o=C(e,t[0]);if(3===t.length){const r=C(e,t[1]),i=n.getNestedOptionalValue(o,r);return null!=i&&""!==i?i:C(e,t[2])}return null===o||""===o||void 0===o?C(e,t[1]):o}catch(t){throw t}},X.decode=function(e,r){try{if(!0===r.preparsed)throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.NeverReach,r);const t=r.arguments;if(t.length<2)throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.WrongNumberOfParameters,r);if(2===t.length)return C(e,t[1]);{if((t.length-1)%2==0)throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.WrongNumberOfParameters,r);const o=C(e,t[0]);return $(e,r,1,o)}}catch(t){throw t}},X.when=function(e,r){try{if(!0===r.preparsed)throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.NeverReach,r);const t=r.arguments;if(t.length<3)throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.WrongNumberOfParameters,r);if(t.length%2==0)throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.WrongNumberOfParameters,r);const o=C(e,t[0]);if(!1===s.isBoolean(o))throw new c.ArcadeExecutionError(e,c.ExecutionErrorCodes.BooleanConditionRequired,t[0]);return ee(e,r,0,o)}catch(t){throw t}};for(const ae in X)X[ae]={value:new a.NativeFunction(X[ae]),valueset:!0,node:null};const te=function(){};function oe(e,r,t){const o=new te;e||(e={}),r||(r={});const n=new i({newline:"\n",tab:"\t",singlequote:"'",doublequote:'"',forwardslash:"/",backwardslash:"\\"});n.immutable=!1,o.textformatting={value:n,valueset:!0,node:null};for(const i in r)o[i]={value:new a.NativeFunction(r[i]),native:!0,valueset:!0,node:null};for(const i in e)o[i]={value:s.isGraphic(e[i])?u.createFromGraphic(e[i],t):e[i],valueset:!0,node:null};return o}te.prototype=X,te.prototype.infinity={value:Number.POSITIVE_INFINITY,valueset:!0,node:null},te.prototype.pi={value:Math.PI,valueset:!0,node:null};const ne={fixSpatialReference:s.fixSpatialReference,parseArguments:y,standardFunction:A};function ie(e){console.log(e)}function ce(e){const r={mode:"sync",compiled:!1,functions:{},signatures:[],standardFunction:A,evaluateIdentifier:J};for(let t=0;t<e.length;t++)e[t].registerFunctions(r);for(const t in r.functions)X[t]={value:new a.NativeFunction(r.functions[t]),valueset:!0,node:null},te.prototype[t]=X[t];for(let t=0;t<r.signatures.length;t++)l.addFunctionDeclaration(r.signatures[t],"sync")}function ue(e,r){let t=r.spatialReference;null==t&&(t=new g({wkid:102100}));let n=null;e.usesModules&&(n=new o.ArcadeModuleLoader(new Map,e.loadedModules));const i={spatialReference:t,globalScope:oe(r.vars,r.customfunctions,r.timeZone),localScope:null,services:r.services,exports:{},libraryResolver:n,console:r.console??ie,timeZone:r.timeZone??null,lrucache:r.lrucache,interceptor:r.interceptor,depthCounter:{depth:1}},u=U(i,e);if(u instanceof s.ReturnResult||u instanceof s.ImplicitResult){const e=u.value;if(e===s.voidOperation)return null;if(s.isFunctionParameter(e))throw new c.ArcadeExecutionError(i,c.ExecutionErrorCodes.IllegalResult,null);return e}if(u===s.voidOperation)return null;if(u===s.breakResult)throw new c.ArcadeExecutionError(i,c.ExecutionErrorCodes.IllegalResult,null);if(u===s.continueResult)throw new c.ArcadeExecutionError(i,c.ExecutionErrorCodes.IllegalResult,null);throw new c.ArcadeExecutionError(i,c.ExecutionErrorCodes.NeverReach,null)}ce([d.ArrayFunctions]),e.executeScript=ue,e.extend=ce,e.functionHelper=ne,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
