/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../core/string"],(function(e,r){"use strict";var o;e.ExecutionErrorCodes=void 0,(o=e.ExecutionErrorCodes||(e.ExecutionErrorCodes={})).AsyncNotEnabled="AsyncNotEnabled",o.ModulesNotSupported="ModulesNotSupported",o.CircularModules="CircularModules",o.CannotCompareDateAndTime="CannotCompareDateAndTime",o.NeverReach="NeverReach",o.UnsupportedHashType="UnsupportedHashType",o.InvalidParameter="InvalidParameter",o.FeatureSetDoesNotHaveSubtypes="FeatureSetDoesNotHaveSubtypes",o.UnexpectedToken="UnexpectedToken",o.Unrecognized="Unrecognized",o.UnrecognizedType="UnrecognizedType",o.MaximumCallDepth="MaximumCallDepth",o.BooleanConditionRequired="BooleanConditionRequired",o.TypeNotAllowedInFeature="TypeNotAllowedInFeature",o.KeyMustBeString="KeyMustBeString",o.WrongNumberOfParameters="WrongNumberOfParameters",o.CallNonFunction="CallNonFunction",o.NoFunctionInTemplateLiteral="NoFunctionInTemplateLiteral",o.NoFunctionInDictionary="NoFunctionInDictionary",o.NoFunctionInArray="NoFunctionInArray",o.AssignModuleFunction="AssignModuleFunction",o.LogicExpressionOrAnd="LogicExpressionOrAnd",o.LogicalExpressionOnlyBoolean="LogicalExpressionOnlyBoolean",o.FunctionNotFound="FunctionNotFound",o.InvalidMemberAccessKey="InvalidMemberAccessKey",o.UnsupportedUnaryOperator="UnsupportUnaryOperator",o.InvalidIdentifier="InvalidIdentifier",o.MemberOfNull="MemberOfNull",o.UnsupportedOperator="UnsupportedOperator",o.Cancelled="Cancelled",o.ModuleAccessorMustBeString="ModuleAccessorMustBeString",o.ModuleExportNotFound="ModuleExportNotFound",o.Immutable="Immutable",o.OutOfBounds="OutOfBounds",o.IllegalResult="IllegalResult",o.FieldNotFound="FieldNotFound",o.PortalRequired="PortalRequired",o.LogicError="LogicError",o.ArrayAccessorMustBeNumber="ArrayAccessMustBeNumber",o.KeyAccessorMustBeString="KeyAccessorMustBeString",o.WrongSpatialReference="WrongSpatialReference",o.CannotChangeTimeZoneTime="CannotChangeTimeZoneTime",o.CannotChangeTimeZoneDateOnly="CannotChangeTimeZoneDateOnly";const n={[e.ExecutionErrorCodes.TypeNotAllowedInFeature]:"Feature attributes only support dates, numbers, strings, guids.",[e.ExecutionErrorCodes.LogicError]:"Logic error - {reason}",[e.ExecutionErrorCodes.CannotCompareDateAndTime]:"Cannot compare date or dateonly with timeonly types",[e.ExecutionErrorCodes.NeverReach]:"Encountered unreachable logic",[e.ExecutionErrorCodes.AsyncNotEnabled]:"Async Arcade must be enabled for this script",[e.ExecutionErrorCodes.ModuleAccessorMustBeString]:"Module accessor must be a string",[e.ExecutionErrorCodes.ModuleExportNotFound]:"Module has no export with provided identifier",[e.ExecutionErrorCodes.ModulesNotSupported]:"Current profile does not support modules",[e.ExecutionErrorCodes.ArrayAccessorMustBeNumber]:"Array accessor must be a number",[e.ExecutionErrorCodes.FunctionNotFound]:"Function not found",[e.ExecutionErrorCodes.FieldNotFound]:"Key not found - {key}",[e.ExecutionErrorCodes.CircularModules]:"Circular module dependencies are not allowed",[e.ExecutionErrorCodes.Cancelled]:"Execution cancelled",[e.ExecutionErrorCodes.UnsupportedHashType]:"Type not supported in hash function",[e.ExecutionErrorCodes.IllegalResult]:"Value is not a supported return type",[e.ExecutionErrorCodes.PortalRequired]:"Portal is required",[e.ExecutionErrorCodes.InvalidParameter]:"Invalid parameter",[e.ExecutionErrorCodes.WrongNumberOfParameters]:"Call with wrong number of parameters",[e.ExecutionErrorCodes.Unrecognized]:"Unrecognized code structure",[e.ExecutionErrorCodes.UnrecognizedType]:"Unrecognized type",[e.ExecutionErrorCodes.WrongSpatialReference]:"Cannot work with geometry in this spatial reference. It is different to the execution spatial reference",[e.ExecutionErrorCodes.BooleanConditionRequired]:"Conditions must use booleans",[e.ExecutionErrorCodes.NoFunctionInDictionary]:"Dictionaries cannot contain functions.",[e.ExecutionErrorCodes.NoFunctionInArray]:"Arrays cannot contain functions.",[e.ExecutionErrorCodes.NoFunctionInTemplateLiteral]:"Template Literals do not expect functions by value.",[e.ExecutionErrorCodes.KeyAccessorMustBeString]:"Accessor must be a string",[e.ExecutionErrorCodes.KeyMustBeString]:"Object keys must be a string",[e.ExecutionErrorCodes.Immutable]:"Object is immutable",[e.ExecutionErrorCodes.UnexpectedToken]:"Unexpected token",[e.ExecutionErrorCodes.MemberOfNull]:"Cannot access property of null object",[e.ExecutionErrorCodes.MaximumCallDepth]:"Exceeded maximum function depth",[e.ExecutionErrorCodes.OutOfBounds]:"Out of bounds",[e.ExecutionErrorCodes.InvalidIdentifier]:"Identifier not recognized",[e.ExecutionErrorCodes.CallNonFunction]:"Expression is not a function",[e.ExecutionErrorCodes.InvalidMemberAccessKey]:"Cannot access value using a key of this type",[e.ExecutionErrorCodes.AssignModuleFunction]:"Cannot assign function to module variable",[e.ExecutionErrorCodes.UnsupportedUnaryOperator]:"Unsupported unary operator",[e.ExecutionErrorCodes.UnsupportedOperator]:"Unsupported operator",[e.ExecutionErrorCodes.LogicalExpressionOnlyBoolean]:"Logical expressions must be boolean",[e.ExecutionErrorCodes.LogicExpressionOrAnd]:"Logical expression can only be combined with || or &&",[e.ExecutionErrorCodes.CannotChangeTimeZoneTime]:"Cannot change the timezone of a Time",[e.ExecutionErrorCodes.CannotChangeTimeZoneDateOnly]:"Cannot change the timezone of a DateOnly",[e.ExecutionErrorCodes.FeatureSetDoesNotHaveSubtypes]:"FeatureSet does not have subtypes"};class t extends Error{constructor(...e){super(...e)}}class a extends t{constructor(e,r){super(c(r)+e.message,{cause:e}),this.loc=null,Error.captureStackTrace&&Error.captureStackTrace(this,a),r?.loc&&(this.loc=r.loc)}}class s extends Error{constructor(e,o,t,a){super("Execution error - "+c(t)+r.replace(n[o],a)),this.loc=null,this.declaredRootClass="esri.arcade.arcadeexecutionerror",Error.captureStackTrace&&Error.captureStackTrace(this,s),t?.loc&&(this.loc=t.loc)}}function c(e){return e&&e.loc?`Line : ${e.loc.start?.line}, ${e.loc.start?.column}: `:""}class i extends Error{constructor(e,o,t,a){super("Compilation error - "+c(t)+r.replace(n[o],a)),this.loc=null,this.declaredRootClass="esri.arcade.arcadecompilationerror",Error.captureStackTrace&&Error.captureStackTrace(this,i),t?.loc&&(this.loc=t.loc)}}class u extends Error{constructor(){super("Uncompilable code structures"),this.declaredRootClass="esri.arcade.arcadeuncompilableerror",Error.captureStackTrace&&Error.captureStackTrace(this,u)}}function d(e,r,o){return"esri.arcade.arcadeexecutionerror"===o.declaredRootClass||"esri.arcade.arcadecompilationerror"===o.declaredRootClass?null===o.loc&&r?.loc?new a(o,{cause:o}):o:("esri.arcade.featureset.support.featureseterror"===o.declaredRootClass||"esri.arcade.featureset.support.sqlerror"===o.declaredRootClass||o.declaredRootClass,r?.loc?new a(o,{cause:o}):o)}var l;e.ModuleErrorCodes=void 0,(l=e.ModuleErrorCodes||(e.ModuleErrorCodes={})).UnrecognizedUri="UnrecognizedUri",l.UnsupportedUriProtocol="UnsupportedUriProtocol";const p={[e.ModuleErrorCodes.UnrecognizedUri]:"Unrecognized uri - {uri}",[e.ModuleErrorCodes.UnsupportedUriProtocol]:"Unrecognized uri protocol"};class E extends Error{constructor(e,o){super(r.replace(p[e],o)),this.declaredRootClass="esri.arcade.arcademoduleerror",Error.captureStackTrace&&Error.captureStackTrace(this,E)}}function C(e,o,t){return"Parsing error - "+c(e)+r.replace(n[o],t)}e.ArcadeCompilationError=i,e.ArcadeExecutionError=s,e.ArcadeUncompilableError=u,e.ErrorWithCause=t,e.LocatableArcadeExecutionError=a,e.ModuleError=E,e.ensureArcadeExecutionError=d,e.executionErrorMessages=n,e.moduleErrorMessages=p,e.parsingValidationMessage=C,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
