/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../Graphic","../../kernel","../support/errorsupport","../support/FeatureSet","../support/IdSet","../support/shared","../support/sqlUtils","../../../core/maybe","../../../core/sql/errorSupport","../../../core/sql/WhereClause","../../../geometry/SpatialReference"],(function(e,t,r,a,s,i,l,n,o,u,h,c){"use strict";class d{constructor(e){this.field=e,this.sqlRewritable=!1}postInitialization(e,t){}}class p extends d{constructor(e){super(e),this.sqlRewritable=!0}extractValue(e){return e.attributes[this.field.name]}rewriteSql(e){return{rewritten:this.sqlRewritable,where:e}}}class f extends d{constructor(e,t,r){super(l.cloneField(e)),this.originalField=e,this.sqlRewritable=!0,this.field.name=t,this.field.alias=r}rewriteSql(e,t){return{rewritten:this.sqlRewritable,where:n.reformulateWithoutField(e,this.field.name,this.originalField.name,t.getFieldsIndex())}}extractValue(e){return e.attributes[this.originalField.name]}}class S extends d{constructor(e,t,r){super(e),this.codefield=t,this.lkp=r,this.reverseLkp={};for(const a in r)this.reverseLkp[r[a]]=a;this.sqlRewritable=!0}rewriteSql(e,t){const r=this.evaluateNodeToWhereClause(e.parseTree,l.FeatureServiceDatabaseType.Standardised,this.field.name,this.codefield instanceof h.WhereClause?n.toWhereClause(this.codefield,l.FeatureServiceDatabaseType.Standardised):this.codefield,e.parameters);return r.includes(S.BADNESS)?{rewritten:!1,where:e}:{rewritten:this.sqlRewritable,where:h.WhereClause.create(r,{fieldsIndex:t._parent.getFieldsIndex(),timeZone:t.dateFieldsTimeZoneDefaultUTC})}}evaluateNodeToWhereClause(e,t,r=null,a=null,s){let i,o,h,c;switch(e.type){case"interval":return n.convertIntervalToSql(this.evaluateNodeToWhereClause(e.value,t,r,a,s),e.qualifier,e.op);case"case-expression":{let a=" CASE ";"simple"===e.format&&(a+=this.evaluateNodeToWhereClause(e.operand,t,r,S.BADNESS,s));for(let i=0;i<e.clauses.length;i++)a+=" WHEN "+this.evaluateNodeToWhereClause(e.clauses[i].operand,t,r,S.BADNESS,s)+" THEN "+this.evaluateNodeToWhereClause(e.clauses[i].value,t,r,S.BADNESS,s);return null!==e.else&&(a+=" ELSE "+this.evaluateNodeToWhereClause(e.else,t,r,S.BADNESS,s)),a+=" END ",a}case"parameter":{const r=s[e.value.toLowerCase()];if("string"==typeof r)return"'"+r.toString().replaceAll("'","''")+"'";if(l.isDate(r))return n.makeSqlFromDateTimeParameter(r,t);if(l.isLuxonDate(r))return n.makeSqlFromDateTimeParameter(r,t);if(l.isArcadeTime(r))return n.makeTimeString(r,t);if(l.isArcadeDate(r))return n.arcadeDateToSqlString(r,t);if(l.isArcadeDateOnly(r))return n.arcadeDateOnlyToSqlString(r,t);if(Array.isArray(r)){const e=[];for(let a=0;a<r.length;a++)"string"==typeof r[a]?e.push("'"+r[a].toString().replaceAll("'","''")+"'"):l.isDate(r[a])||l.isLuxonDate(r[a])?e.push(n.makeSqlFromDateTimeParameter(r[a],t)):l.isArcadeTime(r[a])?e.push(n.makeTimeString(r[a],t)):l.isArcadeDate(r[a])?e.push(n.arcadeDateToSqlString(r[a],t)):l.isArcadeDateOnly(r[a])?e.push(n.arcadeDateOnlyToSqlString(r[a],t)):e.push(r[a].toString());return e}return r.toString()}case"expression-list":o=[];for(const i of e.value)o.push(this.evaluateNodeToWhereClause(i,t,r,a,s));return o;case"unary-expression":return" ( NOT "+this.evaluateNodeToWhereClause(e.expr,t,r,S.BADNESS,s)+" ) ";case"binary-expression":switch(e.operator){case"AND":return" ("+this.evaluateNodeToWhereClause(e.left,t,r,a,s)+" AND "+this.evaluateNodeToWhereClause(e.right,t,r,a,s)+") ";case"OR":return" ("+this.evaluateNodeToWhereClause(e.left,t,r,a,s)+" OR "+this.evaluateNodeToWhereClause(e.right,t,r,a,s)+") ";case"IS":if("null"!==e.right.type)throw new u.SqlError(u.SqlErrorCodes.UnsupportedIsRhs);return" ("+this.evaluateNodeToWhereClause(e.left,t,r,a,s)+" IS NULL )";case"ISNOT":if("null"!==e.right.type)throw new u.SqlError(u.SqlErrorCodes.UnsupportedIsRhs);return" ("+this.evaluateNodeToWhereClause(e.left,t,r,a,s)+" IS NOT NULL )";case"IN":if(i=[],"expression-list"===e.right.type){if("column-reference"===e.left.type&&e.left.column.toUpperCase()===this.field.name.toUpperCase()){const i=[];let l=!0;for(const t of e.right.value){if("string"!==t.type){l=!1;break}if(void 0===this.lkp[t.value]){l=!1;break}i.push(this.lkp[t.value].toString())}if(l)return" ("+this.evaluateNodeToWhereClause(e.left,t,r,a,s)+" IN ("+i.join(",")+")) "}return i=this.evaluateNodeToWhereClause(e.right,t,r,a,s)," ("+this.evaluateNodeToWhereClause(e.left,t,r,a,s)+" IN ("+i.join(",")+")) "}return c=this.evaluateNodeToWhereClause(e.right,t,r,a,s),Array.isArray(c)?" ("+this.evaluateNodeToWhereClause(e.left,t,r,a,s)+" IN ("+c.join(",")+")) ":" ("+this.evaluateNodeToWhereClause(e.left,t,r,a,s)+" IN ("+c+")) ";case"NOT IN":if(i=[],"expression-list"===e.right.type){if("column-reference"===e.left.type&&e.left.column.toUpperCase()===this.field.name.toUpperCase()){const i=[];let l=!0;for(const t of e.right.value){if("string"!==t.type){l=!1;break}if(void 0===this.lkp[t.value]){l=!1;break}i.push(this.lkp[t.value].toString())}if(l)return" ("+this.evaluateNodeToWhereClause(e.left,t,r,a,s)+" NOT IN ("+i.join(",")+")) "}return i=this.evaluateNodeToWhereClause(e.right,t,r,a,s)," ("+this.evaluateNodeToWhereClause(e.left,t,r,a,s)+" NOT IN ("+i.join(",")+")) "}return c=this.evaluateNodeToWhereClause(e.right,t,r,a,s),Array.isArray(c)?" ("+this.evaluateNodeToWhereClause(e.left,t,r,a,s)+" NOT IN ("+c.join(",")+")) ":" ("+this.evaluateNodeToWhereClause(e.left,t,r,a,s)+" NOT IN ("+c+")) ";case"BETWEEN":return h=this.evaluateNodeToWhereClause(e.right,t,r,S.BADNESS,s)," ("+this.evaluateNodeToWhereClause(e.left,t,r,S.BADNESS,s)+" BETWEEN "+h[0]+" AND "+h[1]+" ) ";case"NOTBETWEEN":return h=this.evaluateNodeToWhereClause(e.right,t,r,S.BADNESS,s)," ("+this.evaluateNodeToWhereClause(e.left,t,r,S.BADNESS,s)+" NOT BETWEEN "+h[0]+" AND "+h[1]+" ) ";case"LIKE":return""!==e.escape?" ("+this.evaluateNodeToWhereClause(e.left,t,r,S.BADNESS,s)+" LIKE "+this.evaluateNodeToWhereClause(e.right,t,r,S.BADNESS,s)+" ESCAPE '"+e.escape+"') ":" ("+this.evaluateNodeToWhereClause(e.left,t,r,S.BADNESS,s)+" LIKE "+this.evaluateNodeToWhereClause(e.right,t,r,S.BADNESS,s)+") ";case"NOT LIKE":return""!==e.escape?" ("+this.evaluateNodeToWhereClause(e.left,t,r,S.BADNESS,s)+" NOT LIKE "+this.evaluateNodeToWhereClause(e.right,t,r,S.BADNESS,s)+" ESCAPE '"+e.escape+"') ":" ("+this.evaluateNodeToWhereClause(e.left,t,r,S.BADNESS,s)+" NOT LIKE "+this.evaluateNodeToWhereClause(e.right,t,r,S.BADNESS,s)+") ";case"<>":case"=":if("column-reference"===e.left.type&&"string"===e.right.type){if(e.left.column.toUpperCase()===this.field.name.toUpperCase()&&void 0!==this.lkp[e.right.value.toString()])return" ("+a+" "+e.operator+" "+this.lkp[e.right.value.toString()].toString()+") "}else if("column-reference"===e.right.type&&"string"===e.left.type&&e.right.column.toUpperCase()===this.field.name.toUpperCase())return" ("+this.lkp[e.right.value.toString()].toString()+" "+e.operator+" "+a+") ";return" ("+this.evaluateNodeToWhereClause(e.left,t,r,S.BADNESS,s)+" "+e.operator+" "+this.evaluateNodeToWhereClause(e.right,t,r,S.BADNESS,s)+") ";case"<":case">":case">=":case"<=":case"*":case"-":case"+":case"/":case"||":return" ("+this.evaluateNodeToWhereClause(e.left,t,r,S.BADNESS,s)+" "+e.operator+" "+this.evaluateNodeToWhereClause(e.right,t,r,S.BADNESS,s)+") "}case"null":return"null";case"boolean":return!0===e.value?"1":"0";case"string":return"'"+e.value.toString().replaceAll("'","''")+"'";case"timestamp":return`timestamp '${e.value}'`;case"date":return`date '${e.value}'`;case"time":return`time '${e.value}'`;case"number":return e.value.toString();case"current-time":return n.makeToday(e.mode,t);case"current-user":return"CURRENT_USER";case"column-reference":return r&&r.toLowerCase()===e.column.toLowerCase()?"("+a+")":n.convertColumnReferenceToSql(e.column);case"data-type":return e.value;case"function":{const a=this.evaluateNodeToWhereClause(e.args,t,r,S.BADNESS,s);return n.translateFunctionToDatabaseSpecific(e.name,a,t)}}throw new u.SqlError(u.SqlErrorCodes.UnsupportedSyntax,{node:e.type})}extractValue(e){return this.codefield instanceof h.WhereClause?this.reverseLkp[h.WhereClause.convertValueToStorageFormat(this.codefield.calculateValueCompiled(e))]:this.reverseLkp[e.attributes[this.codefield]]}}S.BADNESS="_!!!_BAD_LKP_!!!!";class g extends d{constructor(e,t){super(e),this._sql=t}rewriteSql(e,t){return{rewritten:!0,where:n.reformulateWithoutField(e,this.field.name,n.toWhereClause(this._sql,l.FeatureServiceDatabaseType.Standardised),t.getFieldsIndex())}}extractValue(e){return h.WhereClause.convertValueToStorageFormat(this._sql.calculateValueCompiled(e),this.field.type)}}class N extends s{static findField(e,t){for(const r of e)if(r.name.toLowerCase()===t.toString().toLowerCase())return r;return null}constructor(e){super(e),this._calcFunc=null,this.declaredClass="esri.arcade.featureset.actions.Adapted",this.adaptedFields=[],this._extraFilter=null,this._extraFilter=e.extraFilter,this._parent=e.parentfeatureset,this._maxProcessing=30,this.adaptedFields=e.adaptedFields}_initialiseFeatureSet(){null!==this._parent?(this.geometryType=this._parent.geometryType,this.objectIdField=this._parent.objectIdField,this.globalIdField=this._parent.globalIdField,this.spatialReference=this._parent.spatialReference,this.hasM=this._parent.hasM,this.hasZ=this._parent.hasZ,this.typeIdField=this._parent.typeIdField,this.types=this._parent.types):(this.spatialReference=new c({wkid:4326}),this.objectIdField="",this.globalIdField="",this.geometryType=l.layerGeometryEsriConstants.point,this.typeIdField="",this.types=null,this.subtypeField=null,this.subtypes=null),this.fields=[];for(const e of this.adaptedFields)e.postInitialization(this,this._parent),this.fields.push(e.field)}async _getSet(e){if(null===this._wset){await this._ensureLoaded();let t=null;return t=this._extraFilter?await this._getFilteredSet("",null,null,null,e):await(this._parent?._getSet(e)),this._checkCancelled(e),o.assertIsSome(t),this._wset=new i(t._candidates.slice(),t._known.slice(),t._ordered,this._clonePageDefinition(t.pagesDefinition)),this._wset}return this._wset}_isInFeatureSet(e){return this._parent._isInFeatureSet(e)}async _getFeatures(e,a,s,l){const n=[];-1!==a&&void 0===this._featureCache[a]&&n.push(a);const o=this._maxQueryRate();if(!0===this._checkIfNeedToExpandKnownPage(e,o))return await this._expandPagedSet(e,o,0,0,l),this._getFeatures(e,a,s,l);let u=0;for(let t=e._lastFetchedIndex;t<e._known.length&&(u++,u<=s&&(e._lastFetchedIndex+=1),!(void 0===this._featureCache[e._known[t]]&&(e._known[t]!==a&&n.push(e._known[t]),n.length>=o)));t++);if(0===n.length)return"success";e=new i([],n,e._ordered,null);const h=Math.min(n.length,s);await(this._parent?._getFeatures(e,-1,h,l)),this._checkCancelled(l);const c=[];for(let t=0;t<h;t++){const e=this._parent?._featureFromCache(n[t]);void 0!==e&&c.push({geometry:e.geometry,attributes:e.attributes,id:n[t]})}for(const i of c){const e=[];for(const t of this.adaptedFields)e[t.field.name]=t.extractValue(i);this._featureCache[i.id]=new t({attributes:e,geometry:r.cloneGeometry(i.geometry)})}return"success"}async _fetchAndRefineFeatures(){throw new a.FeatureSetError(a.FeatureSetErrorCodes.NeverReach)}async _getFilteredSet(e,t,r,a,s){let l=!1;const o=this._reformulateWithoutAdaptions(r);l=o.cannot,r=o.where;let u=!1;if(null!==a){u=!0;const e=[];for(const t of this.adaptedFields)if(!(t instanceof p)&&!0===a.scanForField(t.field.name)){if(!(t instanceof f)){a=null,u=!1;break}e.push({field:t.field.name,newfield:t.originalField.name})}a&&e.length>0&&(a=a.replaceFields(e))}null!==r?null!==this._extraFilter&&(r=n.combine(this._extraFilter,r)):r=this._extraFilter,await this._ensureLoaded();const h=await this._parent._getFilteredSet(e,t,r,a,s);let c;return this._checkCancelled(s),c=!0===l?new i(h._candidates.slice().concat(h._known.slice()),[],!0===u&&h._ordered,this._clonePageDefinition(h.pagesDefinition)):new i(h._candidates.slice(),h._known.slice(),!0===u&&h._ordered,this._clonePageDefinition(h.pagesDefinition)),c}_reformulateWithoutAdaptions(e){const t={cannot:!1,where:e};if(null!==e)for(const r of this.adaptedFields)if(!0===n.scanForField(e,r.field.name)){const a=r.rewriteSql(e,this);if(!0!==a.rewritten){t.cannot=!0,t.where=null;break}t.where=a.where}return t}async _stat(e,t,r,a,s,i,l){let o=!1,u=this._reformulateWithoutAdaptions(t);if(o=u.cannot,t=u.where,u=this._reformulateWithoutAdaptions(s),o=o||u.cannot,null!==(s=u.where)?null!==this._extraFilter&&(s=n.combine(this._extraFilter,s)):s=this._extraFilter,!0===o)return null===s&&""===r&&null===a?this._manualStat(e,t,i,l):{calculated:!1};const h=await this._parent._stat(e,t,r,a,s,i,l);return!1===h.calculated?null===s&&""===r&&null===a?this._manualStat(e,t,i,l):{calculated:!1}:h}async _canDoAggregates(e,t,r,a,s){if(null===this._parent)return!1;for(let n=0;n<e.length;n++)for(const t of this.adaptedFields)if(e[n].toLowerCase()===t.field.name.toLowerCase()&&!(t instanceof p))return!1;const i=[];for(let n=0;n<t.length;n++){const e=t[n];if(null!==e.workingexpr){const t=this._reformulateWithoutAdaptions(e.workingexpr);if(t.cannot)return!1;const r=e.clone();r.workingexpr=t.where,i.push(r)}else i.push(e)}const l=this._reformulateWithoutAdaptions(s);return!l.cannot&&(null!==(s=l.where)?null!==this._extraFilter&&(s=n.combine(this._extraFilter,s)):s=this._extraFilter,this._parent._canDoAggregates(e,i,r,a,s))}async _getAggregatePagesDataSourceDefinition(e,t,r,s,i,l,o){if(null===this._parent)throw new a.FeatureSetError(a.FeatureSetErrorCodes.NeverReach);const u=[];for(let n=0;n<t.length;n++){const e=t[n];if(null!==e.workingexpr){const t=this._reformulateWithoutAdaptions(e.workingexpr);if(t.cannot)throw new a.FeatureSetError(a.FeatureSetErrorCodes.NeverReach);const r=e.clone();r.workingexpr=t.where,u.push(r)}else u.push(e)}const h=this._reformulateWithoutAdaptions(i);if(h.cannot)throw new a.FeatureSetError(a.FeatureSetErrorCodes.NeverReach);return null!==(i=h.where)?null!==this._extraFilter&&(i=n.combine(this._extraFilter,i)):i=this._extraFilter,this._parent._getAggregatePagesDataSourceDefinition(e,u,r,s,i,l,o)}}e.AdaptedFeatureSet=N,e.AdaptedField=d,e.FieldRename=f,e.OriginalField=p,e.SqlExpressionAdapted=g,e.StringToCodeAdapted=S,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
