/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../Graphic","../../../chunks/languageUtils","./Adapted","./AttributeFilter","./OrderBy","../support/errorsupport","../support/FeatureSet","../support/IdSet","../support/OrderbyClause","../support/shared","../support/sqlUtils","../support/StatsField","../../../core/MD5","../../../core/sql/AggregateFunctions","../../../core/sql/DateOnly","../../../core/sql/SqlTimestampOffset","../../../core/sql/TimeOnly","../../../core/sql/WhereClause","../../../geometry/SpatialReference","../../../layers/support/Field","../../../layers/support/FieldsIndex"],(function(e,t,i,s,n,a,r,l,o,d,u,f,c,h,p,g,_,y,m,F,b){"use strict";function w(e){if(!e)return"COUNT";switch(e.toLowerCase()){case"max":return"MAX";case"var":case"variance":return"VAR";case"avg":case"average":case"mean":return"AVG";case"min":return"MIN";case"sum":return"SUM";case"stdev":case"stddev":return"STDDEV";case"count":return"COUNT"}return"COUNT"}class S extends r{constructor(e){super(e),this._decodedStatsfield=[],this._decodedGroupbyfield=[],this._candosimplegroupby=!0,this.phsyicalgroupbyfields=[],this.objectIdField="ROW__ID",this._internalObjectIdField="ROW__ID",this._adaptedFields=[],this.declaredClass="esri.arcade.featureset.actions.Aggregate",this._uniqueIds=1,this._maxQuery=10,this._maxProcessing=10,this._parent=e.parentfeatureset,this._config=e}isTable(){return!0}async _getSet(e){if(null===this._wset){const t=await this._getFilteredSet("",null,null,null,e);return this._wset=t,this._wset}return this._wset}_isInFeatureSet(){return d.IdState.InFeatureSet}_nextUniqueName(e){for(;1===e["T"+this._uniqueIds.toString()];)this._uniqueIds++;const t="T"+this._uniqueIds.toString();return e[t]=1,t}_convertToEsriFieldType(e){return e}_initialiseFeatureSet(){const e={};let t=!1,s=1;const n=this._parent?this._parent.getFieldsIndex():new b([]);for(this.objectIdField="ROW__ID",this.globalIdField="";!1===t;){let e=!1;for(let t=0;t<this._config.groupbyfields.length;t++)if(this._config.groupbyfields[t].name.toLowerCase()===this.objectIdField.toLowerCase()){e=!0;break}if(!1===e)for(let t=0;t<this._config.statsfields.length;t++)if(this._config.statsfields[t].name.toLowerCase()===this.objectIdField.toLowerCase()){e=!0;break}!1===e?t=!0:(this.objectIdField="ROW__ID"+s.toString(),s++)}for(const i of this._config.statsfields){const e=new f;e.field=i.name,e.tofieldname=i.name,e.workingexpr=i.expression instanceof y.WhereClause?i.expression:y.WhereClause.create(i.expression,{fieldsIndex:n,timeZone:this.dateFieldsTimeZoneDefaultUTC}),e.typeofstat=w(i.statistic),this._decodedStatsfield.push(e)}this._decodedGroupbyfield=[];for(const i of this._config.groupbyfields){const e={name:i.name,singlefield:null,tofieldname:i.name,expression:i.expression instanceof y.WhereClause?i.expression:y.WhereClause.create(i.expression,{fieldsIndex:n,timeZone:this.dateFieldsTimeZoneDefaultUTC}),sqlType:null};this._decodedGroupbyfield.push(e)}if(null!==this._parent){this.geometryType=this._parent.geometryType,this.spatialReference=this._parent.spatialReference,this.hasM=this._parent.hasM,this.hasZ=this._parent.hasZ,this.typeIdField="";for(const t of this._parent.fields)e[t.name.toUpperCase()]=1;this.types=null,this.subtypes=null,this.subtypeField=""}else this.geometryType=d.layerGeometryEsriConstants.point,this.typeIdField="",this.types=null,this.subtypes=null,this.subtypeField="",this.spatialReference=new m({wkid:4326});this.fields=[];const r=new f;r.field=this._nextUniqueName(e),r.tofieldname=this.objectIdField,r.workingexpr=y.WhereClause.create(this._parent.objectIdField,{fieldsIndex:this._parent.getFieldsIndex(),timeZone:this.dateFieldsTimeZoneDefaultUTC}),r.typeofstat="MIN",this._decodedStatsfield.push(r);for(const l of this._decodedGroupbyfield){const t=new F;if(l.name=this._nextUniqueName(e),t.name=l.tofieldname,t.alias=t.name,u.isSingleField(l.expression)){const e=this._parent.getField(u.toWhereClause(l.expression,d.FeatureServiceDatabaseType.Standardised));if(!e)throw new a.FeatureSetError(a.FeatureSetErrorCodes.AggregationFieldNotFound);l.name=e.name,l.singlefield=e.name,this.phsyicalgroupbyfields.push(e.name),t.type=e.type,l.sqlType=e.type}else{t.type=this._convertToEsriFieldType(u.predictType(l.expression,this._parent.fields));const e=new F;e.name=l.name,e.alias=e.name,this.phsyicalgroupbyfields.push(l.name),this._adaptedFields.push(new i.SqlExpressionAdapted(e,l.expression)),this._candosimplegroupby=!1,l.sqlType=t.type}this.fields.push(t)}if(this._adaptedFields.length>0)for(const a of this._parent.fields)this._adaptedFields.push(new i.OriginalField(a));for(let i=0;i<this._decodedStatsfield.length;i++){const t=new F;let s=null;const n=this._decodedStatsfield[i];n.field=this._nextUniqueName(e),n.tofieldname===this.objectIdField&&(this._internalObjectIdField=n.field),t.name=n.tofieldname,t.alias=t.name;const r=null!==n.workingexpr&&u.isSingleField(n.workingexpr)?u.toWhereClause(n.workingexpr,d.FeatureServiceDatabaseType.Standardised):"";switch(this._decodedStatsfield[i].typeofstat){case"SUM":if(""!==r){if(s=this._parent.getField(r),!s)throw new a.FeatureSetError(a.FeatureSetErrorCodes.AggregationFieldNotFound);t.type=s.type}else t.type="double";break;case"MIN":case"MAX":if(""!==r){if(s=this._parent.getField(r),!s)throw new a.FeatureSetError(a.FeatureSetErrorCodes.AggregationFieldNotFound);t.type=s.type}else t.type="double";break;case"COUNT":t.type="integer";break;case"STDDEV":case"VAR":case"AVG":if(""!==r&&(s=this._parent.getField(r),!s))throw new a.FeatureSetError(a.FeatureSetErrorCodes.AggregationFieldNotFound);t.type="double"}this.fields.push(t)}}async _canDoAggregates(){return!1}async _getFeatures(e,t,i,s){-1!==t&&this._featureCache[t];const n=this._maxQuery;return!0===this._checkIfNeedToExpandKnownPage(e,n)?(await this._expandPagedSet(e,n,0,0,s),this._getFeatures(e,t,i,s)):"success"}async _getFilteredSet(e,t,a,r,d){if(""!==e)return new l([],[],!0,null);let f=null;const c={ordered:!1,nowhereclause:!1};if(await this._ensureLoaded(),null!==a)for(let i=0;i<this._decodedStatsfield.length;i++)if(!0===u.scanForField(a,this._decodedStatsfield[i].tofieldname)){c.nowhereclause=!0,a=null;break}if(null!==r){c.ordered=!0;for(let e=0;e<this._decodedStatsfield.length;e++)if(!0===r.scanForField(this._decodedStatsfield[e].tofieldname)){r=null,c.ordered=!1;break}if(null!==r)for(const e of this._decodedGroupbyfield)if(null===e.singlefield&&!0===r.scanForField(e.tofieldname)){r=null,c.ordered=!1;break}}if(!1!==this._candosimplegroupby&&await this._parent._canDoAggregates(this.phsyicalgroupbyfields,this._decodedStatsfield,"",null,null)){let e=null;a&&(e=this._reformulateWhereClauseWithoutGroupByFields(a));let t=null;r&&(t=this._reformulateOrderClauseWithoutGroupByFields(r));const i=await this._parent._getAggregatePagesDataSourceDefinition(this.phsyicalgroupbyfields,this._decodedStatsfield,"",null,e,t,this._internalObjectIdField);return this._checkCancelled(d),f=!0===c.nowhereclause?new l(i._candidates.slice().concat(i._known.slice()),[],!0===c.ordered&&i._ordered,this._clonePageDefinition(i.pagesDefinition)):new l(i._candidates.slice(),i._known.slice(),!0===c.ordered&&i._ordered,this._clonePageDefinition(i.pagesDefinition)),f}let h=this._parent;if(this._adaptedFields.length>0&&(h=new i.AdaptedFeatureSet({parentfeatureset:this._parent,adaptedFields:this._adaptedFields,extraFilter:null})),!0===c.nowhereclause)f=new l(["GETPAGES"],[],!1,{aggregatefeaturesetpagedefinition:!0,resultOffset:0,resultRecordCount:this._maxQuery,internal:{fullyResolved:!1,workingItem:null,type:"manual",iterator:null,set:[],subfeatureset:new n({parentfeatureset:h,orderbyclause:new o(this.phsyicalgroupbyfields.join(",")+","+this._parent.objectIdField+" ASC")})}});else{let e=h;if(null!==a){let t=null;a&&(t=this._reformulateWhereClauseWithoutGroupByFields(a)),e=new s({parentfeatureset:e,whereclause:t})}f=new l(["GETPAGES"],[],!1,{aggregatefeaturesetpagedefinition:!0,resultOffset:0,resultRecordCount:this._maxQuery,internal:{fullyResolved:!1,workingItem:null,type:"manual",iterator:null,set:[],subfeatureset:new n({parentfeatureset:e,orderbyclause:new o(this.phsyicalgroupbyfields.join(",")+","+this._parent.objectIdField+" ASC")})}})}return f}_reformulateWhereClauseWithoutStatsFields(e){for(const t of this._decodedStatsfield)e=u.reformulateWithoutField(e,t.tofieldname,u.toWhereClause(t.workingexpr,d.FeatureServiceDatabaseType.Standardised),this._parent.getFieldsIndex());return e}_reformulateWhereClauseWithoutGroupByFields(e){for(const t of this._decodedGroupbyfield)t.tofieldname!==t.name&&(e=u.reformulateWithoutField(e,t.tofieldname,u.toWhereClause(t.expression,d.FeatureServiceDatabaseType.Standardised),this._parent.getFieldsIndex()));return e}_reformulateOrderClauseWithoutGroupByFields(e){const t=[];for(const i of this._decodedGroupbyfield)i.tofieldname!==i.name&&t.push({field:i.tofieldname,newfield:i.name});return t.length>0?e.replaceFields(t):e}_clonePageDefinition(e){return null===e?null:!0===e.aggregatefeaturesetpagedefinition?{aggregatefeaturesetpagedefinition:!0,resultRecordCount:e.resultRecordCount,resultOffset:e.resultOffset,internal:e.internal}:this._parent._clonePageDefinition(e)}async _refineSetBlock(e,t,i){if(!0===this._checkIfNeedToExpandCandidatePage(e,this._maxQuery))return await this._expandPagedSet(e,this._maxQuery,0,0,i),this._refineSetBlock(e,t,i);this._checkCancelled(i);const s=e._candidates.length;this._refineKnowns(e,t);e._candidates.length;return e._candidates.length,e}_expandPagedSet(e,t,i,s,n){return this._expandPagedSetFeatureSet(e,t,i,s,n)}async _getPhysicalPage(t,i,s){if(!0===t.pagesDefinition.aggregatefeaturesetpagedefinition)return this._sequentialGetPhysicalItem(t,t.pagesDefinition.resultRecordCount,s,[]);const n=await this._getAgregagtePhysicalPage(t,i,s);for(const a of n){const t={geometry:a.geometry,attributes:{}},i={};for(const e in a.attributes)i[e.toLowerCase()]=a.attributes[e];for(const e of this._decodedGroupbyfield)t.attributes[e.tofieldname]=i[e.name.toLowerCase()];for(const e of this._decodedStatsfield)t.attributes[e.tofieldname]=i[e.field.toLowerCase()];this._featureCache[t.attributes[this.objectIdField]]=new e(t)}return n.length}_sequentialGetPhysicalItem(e,t,i,s){return new Promise(((n,a)=>{null===e.pagesDefinition.internal.iterator&&(e.pagesDefinition.internal.iterator=e.pagesDefinition.internal.subfeatureset.iterator(i)),!0===e.pagesDefinition.internal.fullyResolved||0===t?n(s.length):this._nextAggregateItem(e,t,i,s,(a=>{null===a?n(s.length):(t-=1,n(this._sequentialGetPhysicalItem(e,t,i,s)))}),a)}))}_nextAggregateItem(e,i,s,n,a,r){try{t.tick(e.pagesDefinition.internal.iterator.next()).then((t=>{if(null===t)if(null!==e.pagesDefinition.internal.workingItem){const t=this._calculateAndAppendAggregateItem(e.pagesDefinition.internal.workingItem);n.push(t),e.pagesDefinition.internal.workingItem=null,e.pagesDefinition.internal.set.push(t.attributes[this.objectIdField]),e.pagesDefinition.internal.fullyResolved=!0,a(null)}else e.pagesDefinition.internal.fullyResolved=!0,a(null);else{const l=this._generateAggregateHash(t);if(null===e.pagesDefinition.internal.workingItem)e.pagesDefinition.internal.workingItem={features:[t],id:l};else{if(l!==e.pagesDefinition.internal.workingItem.id){const s=this._calculateAndAppendAggregateItem(e.pagesDefinition.internal.workingItem);return n.push(s),e.pagesDefinition.internal.workingItem=null,e.pagesDefinition.internal.set.push(s.attributes[this.objectIdField]),i-=1,e.pagesDefinition.internal.workingItem={features:[t],id:l},void a(s)}e.pagesDefinition.internal.workingItem.features.push(t)}this._nextAggregateItem(e,i,s,n,a,r)}}),r)}catch(l){r(l)}}_calculateFieldStat(e,t,i){const s=[];for(const n of e.features)if(null!==t.workingexpr){const e=t.workingexpr.calculateValue(n);null!==e&&(e instanceof p.DateOnly||e instanceof _.TimeOnly?s.push(e.toNumber()):e instanceof g.SqlTimeStampOffset?s.push(e.toMilliseconds()):s.push(e))}else s.push(null);i.attributes[t.tofieldname]=h.aggregateFunction(t.typeofstat,[s])}_calculateAndAppendAggregateItem(t){const i={attributes:{},geometry:null};for(const e of this._decodedGroupbyfield){const s=e.singlefield?t.features[0].attributes[e.singlefield]:y.WhereClause.convertValueToStorageFormat(e.expression.calculateValue(t.features[0]),e.sqlType);i.attributes[e.tofieldname]=s}for(const e of this._decodedStatsfield)this._calculateFieldStat(t,e,i);const s=[];for(let e=0;e<this._decodedStatsfield.length;e++)s.push(this._calculateFieldStat(t,this._decodedStatsfield[e],i));return this._featureCache[i.attributes[this.objectIdField]]=new e({attributes:i.attributes,geometry:i.geometry}),i}_generateAggregateHash(e){let t="";for(const i of this._decodedGroupbyfield){const s=i.singlefield?e.attributes[i.singlefield]:i.expression.calculateValue(e);t+=null==s?":":":"+s.toString()}return c.createMD5Hash(t,c.outputTypes.String)}async _stat(){return{calculated:!1}}async getFeatureByObjectId(){return null}static registerAction(){r._featuresetFunctions.groupby=function(e,t){return new S({parentfeatureset:this,groupbyfields:e,statsfields:t})}}}return S}));
