/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["./cache","./errorsupport","./FeatureSetIterator","./IdSet","./shared","./stats","../../../core/promiseUtils","../../../core/sql/WhereClause","../../../geometry/geometryEngineAsync","../../../geometry/SpatialReference","../../../layers/support/FieldsIndex"],(function(e,t,s,n,r,a,i,l,u,h,o){"use strict";class c{constructor(e){this.recentlyUsedQueries=null,this.featureSetQueryInterceptor=null,this._idstates=[],this._parent=null,this._wset=null,this._mainSetInUse=null,this._maxProcessing=200,this._maxQuery=500,this._totalCount=-1,this._databaseType=r.FeatureServiceDatabaseType.NotEvaluated,this._databaseTypeProbed=null,this.declaredRootClass="esri.arcade.featureset.support.FeatureSet",this._featureCache=Object.create(null),this.typeIdField=null,this.types=null,this.subtypeField=null,this.subtypes=null,this.fields=null,this.geometryType="",this.objectIdField="",this.globalIdField="",this.spatialReference=null,this.hasM=!1,this.hasZ=!1,this._transparent=!1,this.loaded=!1,this._loadPromise=null,this._fieldsIndex=null,this.fsetInfo=null,e?.lrucache&&(this.recentlyUsedQueries=e.lrucache),e?.interceptor&&(this.featureSetQueryInterceptor=e.interceptor)}optimisePagingFeatureQueries(e){this._parent&&this._parent.optimisePagingFeatureQueries(e)}_hasMemorySource(){return!0}prop(e,t){return void 0===t?this[e]:(void 0!==this[e]&&(this[e]=t),this)}end(){return null!==this._parent&&!0===this._parent._transparent?this._parent.end():this._parent}_ensureLoaded(){return this.load()}load(){return null===this._loadPromise&&(this._loadPromise=this.loadImpl()),this._loadPromise}async loadImpl(){return!0===this._parent?.loaded?(this._initialiseFeatureSet(),this):(await(this._parent?.load()),this._initialiseFeatureSet(),this)}_initialiseFeatureSet(){null!==this._parent?(this.fields=this._parent.fields.slice(),this.geometryType=this._parent.geometryType,this.objectIdField=this._parent.objectIdField,this.globalIdField=this._parent.globalIdField,this.spatialReference=this._parent.spatialReference,this.hasM=this._parent.hasM,this.hasZ=this._parent.hasZ,this.typeIdField=this._parent.typeIdField,this.types=this._parent.types,this.subtypeField=this._parent.subtypeField,this.subtypes=this._parent.subtypes):(this.fields=[],this.typeIdField="",this.subtypeField="",this.objectIdField="",this.globalIdField="",this.spatialReference=new h({wkid:4326}),this.geometryType=r.layerGeometryEsriConstants.point)}getField(e,t){let s;return(t=t||this.fields)&&(e=e.toLowerCase(),t.some((t=>(t&&t.name.toLowerCase()===e&&(s=t),!!s)))),s}getFieldsIndex(){return null===this._fieldsIndex&&(this._fieldsIndex=o.fromLayer({timeInfo:this.timeInfo,editFieldsInfo:this.editFieldsInfo,dateFieldsTimeZone:this.dateFieldsTimeZone,datesInUnknownTimezone:this.datesInUnknownTimezone,fields:this.fields})),this._fieldsIndex}_maxProcessingRate(){return null!==this._parent?Math.min(this._maxProcessing,this._parent._maxProcessingRate()):Math.min(this._maxProcessing,this._maxQueryRate())}_maxQueryRate(){return null!==this._parent?Math.max(this._maxQuery,this._parent._maxQueryRate()):this._maxQuery}_checkCancelled(e){if(null!=e&&e.aborted)throw new t.FeatureSetError(t.FeatureSetErrorCodes.Cancelled)}nativeCapabilities(){return this._parent.nativeCapabilities()}async _canDoAggregates(e,t,s,n,r){return null!==this._parent&&this._parent._canDoAggregates(e,t,s,n,r)}async _getAggregatePagesDataSourceDefinition(e,s,n,r,a,i,l){if(null===this._parent)throw new t.FeatureSetError(t.FeatureSetErrorCodes.NeverReach);return this._parent._getAggregatePagesDataSourceDefinition(e,s,n,r,a,i,l)}async _getAgregagtePhysicalPage(e,s,n){if(null===this._parent)throw new t.FeatureSetError(t.FeatureSetErrorCodes.NeverReach);return this._parent._getAgregagtePhysicalPage(e,s,n)}async databaseType(){if(this._databaseType===r.FeatureServiceDatabaseType.NotEvaluated){if(null!==e.applicationCache){const t=e.applicationCache.getDatabaseType(this._cacheableFeatureSetSourceKey());if(null!==t)return t}if(null!==this._databaseTypeProbed)return this._databaseTypeProbed;try{this._databaseTypeProbed=this._getDatabaseTypeImpl(),null!==e.applicationCache&&e.applicationCache.setDatabaseType(this._cacheableFeatureSetSourceKey(),this._databaseTypeProbed)}catch(t){throw null!==e.applicationCache&&e.applicationCache.clearDatabaseType(this._cacheableFeatureSetSourceKey()),t}return this._databaseTypeProbed}return this._databaseType}async _getDatabaseTypeImpl(){const e=[{thetype:r.FeatureServiceDatabaseType.SqlServer,testwhere:"(CAST( '2015-01-01' as DATETIME) = CAST( '2015-01-01' as DATETIME)) AND OBJECTID<0"},{thetype:r.FeatureServiceDatabaseType.Oracle,testwhere:"(TO_DATE('2003-11-18','YYYY-MM-DD') = TO_DATE('2003-11-18','YYYY-MM-DD')) AND OBJECTID<0"},{thetype:r.FeatureServiceDatabaseType.StandardisedNoInterval,testwhere:"(date '2015-01-01 10:10:10' = date '2015-01-01 10:10:10') AND OBJECTID<0"}];for(const t of e){if(!0===await this._runDatabaseProbe(t.testwhere))return t.thetype}return r.FeatureServiceDatabaseType.StandardisedNoInterval}_cacheableFeatureSetSourceKey(){return"MUSTBESET"}async _runDatabaseProbe(e){if(null!==this._parent)return this._parent._runDatabaseProbe(e);throw new t.FeatureSetError(t.FeatureSetErrorCodes.NotImplemented)}isTable(){return this._parent?.isTable()??!1}_featureFromCache(e){if(void 0!==this._featureCache[e])return this._featureCache[e]}_isInFeatureSet(e){return r.IdState.Unknown}_getSet(e){throw new t.FeatureSetError(t.FeatureSetErrorCodes.NotImplemented)}async _getFeature(e,s,n){if(this._checkCancelled(n),void 0!==this._featureFromCache(s))return this._featureFromCache(s);if(await this._getFeatures(e,s,this._maxProcessingRate(),n),this._checkCancelled(n),void 0!==this._featureFromCache(s))return this._featureFromCache(s);throw new t.FeatureSetError(t.FeatureSetErrorCodes.MissingFeatures)}async _getFeatureBatch(e,t){this._checkCancelled(t);const s=new n([],e,!1,null),r=[];await this._getFeatures(s,-1,e.length,t),this._checkCancelled(t);for(const n of e)void 0!==this._featureFromCache(n)&&r.push(this._featureFromCache(n));return r}async _getFeatures(e,t,s,n){return"success"}_getFilteredSet(e,s,n,r,a){throw new t.FeatureSetError(t.FeatureSetErrorCodes.NotImplemented)}async _refineSetBlock(e,t,s){if(!0===this._checkIfNeedToExpandCandidatePage(e,this._maxQueryRate()))return await this._expandPagedSet(e,this._maxQueryRate(),0,0,s),this._refineSetBlock(e,t,s);this._checkCancelled(s);const n=e._candidates.length;this._refineKnowns(e,t);let r=n-e._candidates.length;if(0===e._candidates.length)return e;if(r>=t)return e;if(await this._refineIfParentKnown(e,t-r,s),this._checkCancelled(s),this._refineKnowns(e,t-r),r=n-e._candidates.length,r<t&&e._candidates.length>0){const n=t-r,a=this._prepareFetchAndRefineSet(e._candidates);return await this._fetchAndRefineFeatures(a,a.length>n?n:e._candidates.length,s),this._checkCancelled(s),this._refineKnowns(e,t-r),e}return e}_fetchAndRefineFeatures(e,t,s){return null}_prepareFetchAndRefineSet(e){const t=[];for(let s=0;s<e.length;s++)this._isPhysicalFeature(e[s])&&t.push(e[s]);return t}_isPhysicalFeature(e){return null===this._parent||this._parent._isPhysicalFeature(e)}_refineKnowns(e,t){let s=0,n=null;const a=[];t=this._maxQueryRate();for(let i=0;i<e._candidates.length&&"GETPAGES"!==e._candidates[i];i++){let l=!1;const u=this._candidateIdTransform(e._candidates[i]);u!==e._candidates[i]&&(l=!0);const h=this._isInFeatureSet(u);if(h===r.IdState.InFeatureSet)!0===l?e._known.includes(u)||(e._known.push(u),s+=1):(e._known.push(e._candidates[i]),s+=1),null===n?n={start:i,end:i}:n.end===i-1?n.end=i:(a.push(n),n={start:i,end:i});else if(h===r.IdState.NotInFeatureSet)null===n?n={start:i,end:i}:n.end===i-1?n.end=i:(a.push(n),n={start:i,end:i}),s+=1;else if(h===r.IdState.Unknown&&(s+=1,!0===e._ordered))break;if(s>=t)break}null!==n&&a.push(n);for(let r=a.length-1;r>=0;r--)e._candidates.splice(a[r].start,a[r].end-a[r].start+1)}_refineIfParentKnown(e,t,s){const r=new n([],[],e._ordered,null);return r._candidates=e._candidates.slice(),this._parent._refineSetBlock(r,t,s)}_candidateIdTransform(e){return this._parent._candidateIdTransform(e)}_checkIfNeedToExpandKnownPage(e,t){if(null===e.pagesDefinition)return!1;let s=0;for(let n=e._lastFetchedIndex;n<e._known.length;n++){if("GETPAGES"===e._known[n])return!0;if(void 0===this._featureCache[e._known[n]]&&(s+=1,s>=t))break}return!1}_checkIfNeedToExpandCandidatePage(e,t){if(null===e.pagesDefinition)return!1;let s=0;for(let n=0;n<e._candidates.length;n++){if("GETPAGES"===e._candidates[n])return!0;if(s+=1,s>=t)break}return!1}async _expandPagedSet(e,s,n,r,a){if(null===this._parent)throw new t.FeatureSetError(t.FeatureSetErrorCodes.NotImplemented);return this._parent._expandPagedSet(e,s,n,r,a)}async _expandPagedSetFeatureSet(e,t,s,n,r){if(e._known.length>0&&"GETPAGES"===e._known[e._known.length-1]&&(n=1),0===n&&e._candidates.length>0&&"GETPAGES"===e._candidates[e._candidates.length-1]&&(n=2),0===n)return"finished";const a=await this._getPage(e,n,r);return s+a<t?this._expandPagedSet(e,t,s+a,0,r):"success"}async _getPage(e,t,s){const n=1===t?e._known:e._candidates;if(e.pagesDefinition.internal.set.length>e.pagesDefinition.resultOffset||!0===e.pagesDefinition.internal.fullyResolved){n.length=n.length-1;let t=0;for(let r=0;r<e.pagesDefinition.resultRecordCount&&!(e.pagesDefinition.resultOffset+r>=e.pagesDefinition.internal.set.length);r++)n[n.length]=e.pagesDefinition.internal.set[e.pagesDefinition.resultOffset+r],t++;e.pagesDefinition.resultOffset+=t;let s=!1;return!0===e.pagesDefinition.internal.fullyResolved&&e.pagesDefinition.internal.set.length<=e.pagesDefinition.resultOffset&&(s=!0),!1===s&&n.push("GETPAGES"),t}return await this._getPhysicalPage(e,t,s),this._getPage(e,t,s)}_getPhysicalPage(e,t,s){return null}_clonePageDefinition(e){return null===this._parent?null:this._parent._clonePageDefinition(e)}_first(e){return this.iterator(e).next()}first(e){return this._first(e)}async calculateStatistic(e,t,s,n){await this._ensureLoaded();let r=await this._stat(e,t,"",null,null,s,n);return!1===r.calculated&&(r=await this._manualStat(e,t,s,n)),r.result}async _manualStat(e,t,s,n){let r=null;switch(e.toLowerCase()){case"count":return r=await a.count(this,n),{calculated:!0,result:r};case"distinct":return r=await a.distinct(this,t,s,n),{calculated:!0,result:r};case"avg":case"mean":return r=await a.mean(this,t,n),{calculated:!0,result:r};case"stdev":return r=await a.stdev(this,t,n),{calculated:!0,result:r};case"variance":return r=await a.variance(this,t,n),{calculated:!0,result:r};case"sum":return r=await a.sum(this,t,n),{calculated:!0,result:r};case"min":return r=await a.min(this,t,n),{calculated:!0,result:r};case"max":return r=await a.max(this,t,n),{calculated:!0,result:r};default:return{calculated:!0,result:0}}}async _stat(e,t,s,n,r,a,i){const l=await this._parent._stat(e,t,s,n,r,a,i);return!1===l.calculated?null===r&&""===s&&null===n?this._manualStat(e,t,a,i):{calculated:!1}:l}_unionAllGeomSelf(e){const t=this.iterator(this._defaultTracker(e)),s=[];return new Promise(((e,n)=>{this._unionShapeInBatches(s,t,e,n)}))}_unionAllGeom(e){return new Promise(((t,s)=>{const n=this.iterator(this._defaultTracker(e)),r=[];this._unionShapeInBatches(r,n,t,s)}))}_unionShapeInBatches(e,t,s,n){t.next().then((r=>{try{null!==r&&null!==r.geometry&&e.push(r.geometry),e.length>30||null===r&&e.length>1?u.union(e).then((a=>{try{null===r?s(a):(e=[a],this._unionShapeInBatches(e,t,s,n))}catch(i){n(i)}}),n):null===r?1===e.length?s(e[0]):s(null):this._unionShapeInBatches(e,t,s,n)}catch(a){n(a)}}),n)}iterator(e){return new s(this,e)}intersection(e,t=!1){return c._featuresetFunctions.intersection.bind(this)(e,t)}difference(e,t=!1,s=!0){return c._featuresetFunctions.difference.bind(this)(e,t,s)}symmetricDifference(e,t=!1,s=!0){return c._featuresetFunctions.symmetricDifference.bind(this)(e,t,s)}morphShape(e,t,s="unknown",n=null){return c._featuresetFunctions.morphShape.bind(this)(e,t,s,n)}morphShapeAndAttributes(e,t,s="unknown"){return c._featuresetFunctions.morphShapeAndAttributes.bind(this)(e,t,s)}union(e,t=!1){return c._featuresetFunctions.union.bind(this)(e,t)}intersects(e){return c._featuresetFunctions.intersects.bind(this)(e)}envelopeIntersects(e){return c._featuresetFunctions.envelopeIntersects.bind(this)(e)}contains(e){return c._featuresetFunctions.contains.bind(this)(e)}overlaps(e){return c._featuresetFunctions.overlaps.bind(this)(e)}relate(e,t){return c._featuresetFunctions.relate.bind(this)(e,t)}within(e){return c._featuresetFunctions.within.bind(this)(e)}touches(e){return c._featuresetFunctions.touches.bind(this)(e)}top(e){return c._featuresetFunctions.top.bind(this)(e)}crosses(e){return c._featuresetFunctions.crosses.bind(this)(e)}buffer(e,t,s,n=!0){return c._featuresetFunctions.buffer.bind(this)(e,t,s,n)}filter(e,t=null){return c._featuresetFunctions.filter.bind(this)(e,t)}orderBy(e){return c._featuresetFunctions.orderBy.bind(this)(e)}dissolve(e,t){return c._featuresetFunctions.dissolve.bind(this)(e,t)}groupby(e,t){return c._featuresetFunctions.groupby.bind(this)(e,t)}reduce(e,t=null,s){return new Promise(((n,r)=>{this._reduceImpl(this.iterator(this._defaultTracker(s)),e,t,0,n,r,0)}))}_reduceImpl(e,t,s,n,r,a,l){try{if(++l>1e3)return void setTimeout((()=>{l=0,this._reduceImpl(e,t,s,n,r,a,l)}));e.next().then((u=>{try{if(null===u)r(s);else{const h=t(s,u,n,this);i.isPromiseLike(h)?h.then((s=>{this._reduceImpl(e,t,s,n+1,r,a,l)}),a):this._reduceImpl(e,t,h,n+1,r,a,l)}}catch(h){a(h)}}),a)}catch(u){a(u)}}removeField(e){return c._featuresetFunctions.removeField.bind(this)(e)}addField(e,t,s=null){return c._featuresetFunctions.addField.bind(this)(e,t,s)}sumArea(e,t=!1,s){const n=r.convertSquareUnitsToCode(e);return this.reduce(((e,s)=>null===s.geometry?0:t?u.geodesicArea(s.geometry,n).then((t=>e+t)):u.planarArea(s.geometry,n).then((t=>e+t))),0,s)}sumLength(e,t=!1,s){const n=r.convertLinearUnitsToCode(e);return this.reduce(((e,s)=>null===s.geometry?0:t?u.geodesicLength(s.geometry,n).then((t=>e+t)):u.planarLength(s.geometry,n).then((t=>e+t))),0,s)}async distinct(e,t=1e3,s=null,n){await this.load();const r=l.WhereClause.create(e,{fieldsIndex:this.getFieldsIndex(),timeZone:this.dateFieldsTimeZoneDefaultUTC});return d(r,s),this.calculateStatistic("distinct",r,t,this._defaultTracker(n))}async min(e,t=null,s){await this.load();const n=l.WhereClause.create(e,{fieldsIndex:this.getFieldsIndex(),timeZone:this.dateFieldsTimeZoneDefaultUTC});return d(n,t),this.calculateStatistic("min",n,-1,this._defaultTracker(s))}async max(e,t=null,s){await this.load();const n=l.WhereClause.create(e,{fieldsIndex:this.getFieldsIndex(),timeZone:this.dateFieldsTimeZoneDefaultUTC});return d(n,t),this.calculateStatistic("max",n,-1,this._defaultTracker(s))}async avg(e,t=null,s){await this.load();const n=l.WhereClause.create(e,{fieldsIndex:this.getFieldsIndex(),timeZone:this.dateFieldsTimeZoneDefaultUTC});return d(n,t),this.calculateStatistic("avg",n,-1,this._defaultTracker(s))}async sum(e,t=null,s){await this.load();const n=l.WhereClause.create(e,{fieldsIndex:this.getFieldsIndex(),timeZone:this.dateFieldsTimeZoneDefaultUTC});return d(n,t),this.calculateStatistic("sum",n,-1,this._defaultTracker(s))}async stdev(e,t=null,s){await this.load();const n=l.WhereClause.create(e,{fieldsIndex:this.getFieldsIndex(),timeZone:this.dateFieldsTimeZoneDefaultUTC});return d(n,t),this.calculateStatistic("stdev",n,-1,this._defaultTracker(s))}async variance(e,t=null,s){await this.load();const n=l.WhereClause.create(e,{fieldsIndex:this.getFieldsIndex(),timeZone:this.dateFieldsTimeZoneDefaultUTC});return d(n,t),this.calculateStatistic("variance",n,-1,this._defaultTracker(s))}async count(e){return await this.load(),this.calculateStatistic("count",l.WhereClause.create("1",{fieldsIndex:this.getFieldsIndex(),timeZone:this.dateFieldsTimeZoneDefaultUTC}),-1,this._defaultTracker(e))}_defaultTracker(e){return e??{aborted:!1}}forEach(e,t){return new Promise(((s,n)=>{this._forEachImpl(this.iterator(this._defaultTracker(t)),e,this,s,n,0)}))}_forEachImpl(e,t,s,n,r,a){try{if(++a>1e3)return void setTimeout((()=>{a=0,this._forEachImpl(e,t,s,n,r,a)}),0);e.next().then((l=>{try{if(null===l)n(s);else{const u=t(l);null==u?this._forEachImpl(e,t,s,n,r,a):i.isPromiseLike(u)?u.then((()=>{try{this._forEachImpl(e,t,s,n,r,a)}catch(i){r(i)}}),r):this._forEachImpl(e,t,s,n,r,a)}}catch(u){r(u)}}),r)}catch(l){r(l)}}convertToJSON(e){const t={layerDefinition:{geometryType:this.geometryType,fields:[]},featureSet:{features:[],geometryType:this.geometryType}};for(let s=0;s<this.fields.length;s++)t.layerDefinition.fields.push(r.esriFieldToJson(this.fields[s]));return this.reduce(((e,s)=>{const n={geometry:s.geometry?.toJSON(),attributes:{}};for(const t in s.attributes)n.attributes[t]=s.attributes[t];return t.featureSet.features.push(n),1}),0,e).then((()=>t))}castToText(e=!1){return"object, FeatureSet"}queryAttachments(e,t,s,n,r){return this._parent.queryAttachments(e,t,s,n,r)}serviceUrl(){return this._parent.serviceUrl()}subtypeMetaData(){return this.subtypeField&&this.subtypes?{subtypeField:this.subtypeField,subtypes:this.subtypes?this.subtypes.map((e=>({name:e.name,code:e.code}))):[]}:this.typeIdField?{subtypeField:this.typeIdField,subtypes:this.types?this.types.map((e=>({name:e.name,code:e.id}))):[]}:null}relationshipMetaData(){return this._parent.relationshipMetaData()}get gdbVersion(){return this._parent?this._parent.gdbVersion:""}schema(){const e=[];for(const t of this.fields)e.push(r.esriFieldToJson(t));return{objectIdField:this.objectIdField,globalIdField:this.globalIdField,geometryType:void 0===r.layerGeometryEsriRestConstants[this.geometryType]?"esriGeometryNull":r.layerGeometryEsriRestConstants[this.geometryType],fields:e}}async convertToText(e,t){if("schema"===e)return await this._ensureLoaded(),JSON.stringify(this.schema());if("featureset"===e){await this._ensureLoaded();const e=[];await this.reduce(((t,s)=>{const n={geometry:s.geometry?s.geometry.toJSON():null,attributes:s.attributes};return null!==n.geometry&&n.geometry.spatialReference&&delete n.geometry.spatialReference,e.push(n),1}),0,t);const s=this.schema();return s.features=e,s.spatialReference=this.spatialReference.toJSON(),JSON.stringify(s)}return this.castToText()}getFeatureByObjectId(e,t){return this._parent.getFeatureByObjectId(e,t)}getOwningSystemUrl(){return this._parent.getOwningSystemUrl()}getIdentityUser(){return this._parent.getIdentityUser()}getRootFeatureSet(){return null!==this._parent?this._parent.getRootFeatureSet():this}getDataSourceFeatureSet(){return null!==this._parent?this._parent.getDataSourceFeatureSet():this}castAsJson(e=null){return"keeptype"===e?.featureset?this:"none"===e?.featureset?null:{type:"FeatureSet"}}async castAsJsonAsync(e=null,t=null){if("keeptype"===t?.featureset)return this;if("schema"===t?.featureset)return await this._ensureLoaded(),JSON.parse(JSON.stringify(this.schema()));if("none"===t?.featureset)return null;await this._ensureLoaded();const s=[];await this.reduce(((e,n)=>{const r={geometry:n.geometry?!0===t?.keepGeometryType?n.geometry:n.geometry.toJSON():null,attributes:n.attributes};return null!==r.geometry&&r.geometry.spatialReference&&!0!==t?.keepGeometryType&&delete r.geometry.spatialReference,s.push(r),1}),0,e);const n=this.schema();return n.features=s,n.spatialReference=!0===t?.keepGeometryType?this.spatialReference:this.spatialReference?.toJSON(),n}fieldTimeZone(e){return this.getFieldsIndex().getTimeZone(e)}get preferredTimeZone(){return this._parent?.preferredTimeZone??null}get dateFieldsTimeZone(){return this._parent?.dateFieldsTimeZone??null}get dateFieldsTimeZoneDefaultUTC(){if(this.datesInUnknownTimezone)return"unknown";const e=this.dateFieldsTimeZone??"UTC";return""===e?"UTC":e}get datesInUnknownTimezone(){return this._parent.datesInUnknownTimezone}get editFieldsInfo(){return this._parent?.editFieldsInfo??null}get timeInfo(){return this._parent?.timeInfo??null}set featureSetInfo(e){this.fsetInfo=e}async getFeatureSetInfo(){return this.fsetInfo??await(this._parent?.getFeatureSetInfo())??null}}function d(e,t){if(null!==t){const s={};for(const e in t)s[e.toLowerCase()]=t[e];e.parameters=s}}return c._featuresetFunctions={},c}));
