/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../ArcadeDate","./shared","../../../core/sql/errorSupport","../../../core/sql/TimeOnly","../../../core/sql/WhereClause","../../../chunks/datetime"],(function(e,r,t,a,s,n,c){"use strict";function i(e,r){return p(e?.parseTree,r,e?.parameters)}function o(e,r,t){return p(e,r,t)}function u(e,r,a,s){const c=p(e.parseTree,t.FeatureServiceDatabaseType.Standardised,e.parameters,r,a);return n.WhereClause.create(c,{fieldsIndex:s,timeZone:e.timeZone,currentUser:e.currentUser})}function l(e,r,a="AND"){return n.WhereClause.create("(("+i(e,t.FeatureServiceDatabaseType.Standardised)+")"+a+"("+i(r,t.FeatureServiceDatabaseType.Standardised)+"))",{fieldsIndex:e.fieldsIndex,timeZone:e.timeZone,currentUser:e.currentUser})}function d(e){return!0===e.delimited?`"${e.column.split('"').join('""')}"`:e.column}function p(e,r,s,n=null,c=null){let i,o,u,l;switch(e.type){case"interval":return L(p(e.value,r,s,n,c),e.qualifier,e.op);case"case-expression":{let t=" CASE ";"simple"===e.format&&(t+=p(e.operand,r,s,n,c));for(let a=0;a<e.clauses.length;a++)t+=" WHEN "+p(e.clauses[a].operand,r,s,n,c)+" THEN "+p(e.clauses[a].value,r,s,n,c);return null!==e.else&&(t+=" ELSE "+p(e.else,r,s,n,c)),t+=" END ",t}case"parameter":{const a=s[e.value.toLowerCase()];if("string"==typeof a){return"'"+s[e.value.toLowerCase()].toString().replaceAll("'","''")+"'"}if(t.isDate(a))return f(a,r);if(t.isLuxonDate(a))return f(a,r);if(t.isArcadeTime(a))return m(a,r);if(t.isArcadeDate(a))return T(a,r);if(t.isArcadeDateOnly(a))return y(a,r);if(Array.isArray(a)){const e=[];for(let s=0;s<a.length;s++)"string"==typeof a[s]?e.push("'"+a[s].toString().replaceAll("'","''")+"'"):t.isDate(a[s])||t.isLuxonDate(a[s])?e.push(f(a[s],r)):t.isArcadeTime(a[s])?e.push(m(a[s],r)):t.isArcadeDate(a[s])?e.push(T(a[s],r)):t.isArcadeDateOnly(a[s])?e.push(y(a[s],r)):e.push(a[s].toString());return e}return a.toString()}case"expression-list":o=[];for(const t of e.value)o.push(p(t,r,s,n,c));return o;case"unary-expression":return" ( NOT "+p(e.expr,r,s,n,c)+" ) ";case"binary-expression":switch(e.operator){case"AND":return" ("+p(e.left,r,s,n,c)+" AND "+p(e.right,r,s,n,c)+") ";case"OR":return" ("+p(e.left,r,s,n,c)+" OR "+p(e.right,r,s,n,c)+") ";case"IS":if("null"!==e.right.type)throw new a.SqlError(a.SqlErrorCodes.UnsupportedIsRhs);return" ("+p(e.left,r,s,n,c)+" IS NULL )";case"ISNOT":if("null"!==e.right.type)throw new a.SqlError(a.SqlErrorCodes.UnsupportedIsRhs);return" ("+p(e.left,r,s,n,c)+" IS NOT NULL )";case"IN":return i=[],"expression-list"===e.right.type?(i=p(e.right,r,s,n,c)," ("+p(e.left,r,s,n,c)+" IN ("+i.join(",")+")) "):(l=p(e.right,r,s,n,c),Array.isArray(l)?" ("+p(e.left,r,s,n,c)+" IN ("+l.join(",")+")) ":" ("+p(e.left,r,s,n,c)+" IN ("+l+")) ");case"NOT IN":return i=[],"expression-list"===e.right.type?(i=p(e.right,r,s,n,c)," ("+p(e.left,r,s,n,c)+" NOT IN ("+i.join(",")+")) "):(l=p(e.right,r,s,n,c),Array.isArray(l)?" ("+p(e.left,r,s,n,c)+" NOT IN ("+l.join(",")+")) ":" ("+p(e.left,r,s,n,c)+" NOT IN ("+l+")) ");case"BETWEEN":return u=p(e.right,r,s,n,c)," ("+p(e.left,r,s,n,c)+" BETWEEN "+u[0]+" AND "+u[1]+" ) ";case"NOTBETWEEN":return u=p(e.right,r,s,n,c)," ("+p(e.left,r,s,n,c)+" NOT BETWEEN "+u[0]+" AND "+u[1]+" ) ";case"LIKE":return""!==e.escape?" ("+p(e.left,r,s,n,c)+" LIKE "+p(e.right,r,s,n,c)+" ESCAPE '"+e.escape+"') ":" ("+p(e.left,r,s,n,c)+" LIKE "+p(e.right,r,s,n,c)+") ";case"NOT LIKE":return""!==e.escape?" ("+p(e.left,r,s,n,c)+" NOT LIKE "+p(e.right,r,s,n,c)+" ESCAPE '"+e.escape+"') ":" ("+p(e.left,r,s,n,c)+" NOT LIKE "+p(e.right,r,s,n,c)+") ";case"<>":case"<":case">":case">=":case"<=":case"=":case"*":case"-":case"+":case"/":return" ("+p(e.left,r,s,n,c)+" "+e.operator+" "+p(e.right,r,s,n,c)+") ";case"||":return" ("+p(e.left,r,s,n,c)+" "+(r===t.FeatureServiceDatabaseType.SqlServer?"+":e.operator)+" "+p(e.right,r,s,n,c)+") "}throw new a.SqlError(a.SqlErrorCodes.UnsupportedOperator,{operator:e.operator});case"null":return"null";case"boolean":return!0===e.value?"1":"0";case"string":return"'"+e.value.toString().replaceAll("'","''")+"'";case"timestamp":return`timestamp '${e.value}'`;case"date":return`date '${e.value}'`;case"time":return`time '${e.value}'`;case"number":return e.value.toString();case"current-time":return g(e.mode,r);case"current-user":return"CURRENT_USER";case"column-reference":return n&&n.toLowerCase()===e.column.toLowerCase()?"("+c+")":d(e);case"data-type":return e.value;case"function":{const t=p(e.args,r,s,n,c);return S(e.name,t,r)}}throw new a.SqlError(a.SqlErrorCodes.UnsupportedSyntax,{node:e.type})}function S(e,r,s){switch(e.toLowerCase().trim()){case"cos":case"sin":case"tan":case"cosh":case"tanh":case"sinh":case"acos":case"asin":case"atan":case"floor":case"log10":case"log":case"abs":if(1!==r.length)throw new a.SqlError(a.SqlErrorCodes.InvalidFunctionParameters,{function:e.toLowerCase().trim()});return`${e.toUpperCase().trim()}(${r[0]})`;case"ceiling":case"ceil":if(1!==r.length)throw new a.SqlError(a.SqlErrorCodes.InvalidFunctionParameters,{function:"ceiling"});switch(s){case t.FeatureServiceDatabaseType.Standardised:case t.FeatureServiceDatabaseType.StandardisedNoInterval:}return"CEILING("+r[0]+")";case"mod":case"power":case"nullif":if(2!==r.length)throw new a.SqlError(a.SqlErrorCodes.InvalidFunctionParameters,{function:e.toLowerCase().trim()});return`${e.toUpperCase().trim()}(${r[0]},${r[1]})`;case"round":if(2===r.length)return"ROUND("+r[0]+","+r[1]+")";if(1===r.length)return"ROUND("+r[0]+")";throw new a.SqlError(a.SqlErrorCodes.InvalidFunctionParameters,{function:"round"});case"truncate":if(r.length<1||r.length>2)throw new a.SqlError(a.SqlErrorCodes.InvalidFunctionParameters,{function:"truncate"});return s===t.FeatureServiceDatabaseType.SqlServer?"ROUND("+r[0]+(1===r.length?"0":","+r[1])+",1)":"TRUNCATE("+r[0]+(1===r.length?")":","+r[1]+")");case"char_length":case"len":if(1!==r.length)throw new a.SqlError(a.SqlErrorCodes.InvalidFunctionParameters,{function:"char_length"});switch(s){case t.FeatureServiceDatabaseType.SqlServer:return"LEN("+r[0]+")";case t.FeatureServiceDatabaseType.Oracle:return"LENGTH("+r[0]+")";default:return"CHAR_LENGTH("+r[0]+")"}case"coalesce":case"concat":{if(r.length<1)throw new a.SqlError(a.SqlErrorCodes.InvalidFunctionParameters,{function:e.toLowerCase()});let t=e.toUpperCase().trim()+"(";for(let e=0;e<r.length;e++)0!==e&&(t+=","),t+=r[e];return t+=")",t}case"lower":case"lcase":if(1!==r.length)throw new a.SqlError(a.SqlErrorCodes.InvalidFunctionParameters,{function:"lower"});return"LOWER("+r[0]+")";case"upper":case"ucase":if(1!==r.length)throw new a.SqlError(a.SqlErrorCodes.InvalidFunctionParameters,{function:"upper"});return"UPPER("+r[0]+")";case"substring":{let e="";switch(s){case t.FeatureServiceDatabaseType.Oracle:return e="SUBSTR("+r[0]+","+r[1],3===r.length&&(e+=","+r[2]),e+=")",e;case t.FeatureServiceDatabaseType.SqlServer:return e=3===r.length?"SUBSTRING("+r[0]+","+r[1]+","+r[2]+")":"SUBSTRING("+r[0]+",  "+r[1]+", LEN("+r[0]+") - "+r[1]+")",e;default:return e="SUBSTRING("+r[0]+" FROM "+r[1],3===r.length&&(e+=" FOR "+r[2]),e+=")",e}}case"extract":return"EXTRACT("+r[0].replaceAll("'","")+" FROM "+r[1]+")";case"cast":{let e="";switch(s){case t.FeatureServiceDatabaseType.Oracle:switch(r[1].type){case"date":e="DATE";break;case"float":e="DOUBLE";break;case"integer":e="INTEGER";break;case"real":e="REAL";break;case"smallint":e="SMALLINT";break;case"timestamp":e="TIMESTAMP";break;case"varchar":e="VARCHAR("+r[1].size.toString()+")"}return`CAST(${r[0]} AS ${e})`;case t.FeatureServiceDatabaseType.Postgres:switch(r[1].type){case"date":e="DATE";break;case"float":e="DOUBLE PRECISION";break;case"integer":e="INT";break;case"real":e="REAL";break;case"smallint":e="SMALLINT";break;case"timestamp":e="TIMESTAMP";break;case"varchar":e="VARCHAR("+r[1].size.toString()+")"}return`CAST(${r[0]} AS ${e})`;case t.FeatureServiceDatabaseType.SqlServer:switch(r[1].type){case"date":e="DATE";break;case"float":e="FLOAT";break;case"integer":e="INT";break;case"real":e="REAL";break;case"smallint":e="SMALLINT";break;case"timestamp":e="DATETIME";break;case"varchar":e="VARCHAR("+r[1].size.toString()+")"}return`CAST(${r[0]} AS ${e})`;default:switch(r[1].type){case"date":e="DATE";break;case"float":e="FLOAT";break;case"integer":e="INTEGER";break;case"real":e="REAL";break;case"smallint":e="SMALLINT";break;case"timestamp":e="TIMESTAMP";break;case"varchar":e="VARCHAR("+r[1].size.toString()+")"}return`CAST(${r[0]} AS ${e})`}}}throw new a.SqlError(a.SqlErrorCodes.InvalidFunctionParameters,{function:e})}function T(e,r){const a=e.toDateTime(),s=0===a.hour&&0===a.minute&&0===a.second&&0===a.millisecond;switch(r){case t.FeatureServiceDatabaseType.FILEGDB:case t.FeatureServiceDatabaseType.Standardised:case t.FeatureServiceDatabaseType.StandardisedNoInterval:return s?`date '${a.toFormat("yyyy-LL-dd")}'`:`timestamp '${a.toFormat("yyyy-LL-dd HH:mm:ss")}'`;case t.FeatureServiceDatabaseType.Oracle:return s?`TO_DATE('${a.toFormat("yyyy-LL-dd")}','YYYY-MM-DD')`:`TO_DATE('${a.toFormat("yyyy-LL-dd HH:mm:ss")}','YYYY-MM-DD HH24:MI:SS')`;case t.FeatureServiceDatabaseType.SqlServer:return`'${a.toFormat(s?"yyyy-LL-dd":"yyyy-LL-dd HH:mm:ss")}'`;case t.FeatureServiceDatabaseType.PGDB:return`#${a.toFormat(s?"LL-dd-yyyy":"LL-dd-yyyy HH:mm:ss")}#`;case t.FeatureServiceDatabaseType.Postgres:return`TIMESTAMP '${a.toFormat(s?"yyyy-LL-dd":"yyyy-LL-dd HH:mm:ss")}'`;default:return`timestamp '${a.toFormat("yyyy-LL-dd HH:mm:ss")}'`}}function y(e,r){switch(r){case t.FeatureServiceDatabaseType.FILEGDB:case t.FeatureServiceDatabaseType.Standardised:case t.FeatureServiceDatabaseType.StandardisedNoInterval:return e.toSQLWithKeyword();case t.FeatureServiceDatabaseType.Oracle:return`TO_DATE('${e.toFormat("Y-MM-DD")}'`;case t.FeatureServiceDatabaseType.SqlServer:return`'${e.toFormat("Y-MM-DD")}'`;case t.FeatureServiceDatabaseType.PGDB:return`#${e.toFormat("Y-MM-DD")}#`;case t.FeatureServiceDatabaseType.Postgres:return`TIMESTAMP '${e.toFormat("Y-MM-DD")}'`;default:return e.toSQLWithKeyword()}}function m(e,r){switch(e instanceof s.TimeOnly&&(e=e.toStorageString()),r){case t.FeatureServiceDatabaseType.Oracle:return`TO_DATE('${e}', 'HH24:MI:SS')`;case t.FeatureServiceDatabaseType.SqlServer:return`'${e}'`;case t.FeatureServiceDatabaseType.FILEGDB:case t.FeatureServiceDatabaseType.Standardised:case t.FeatureServiceDatabaseType.StandardisedNoInterval:case t.FeatureServiceDatabaseType.Postgres:default:return`time '${e}'`}}function f(e,a){return T(r.ArcadeDate.dateTimeToArcadeDate(t.isLuxonDate(e)?e:c.DateTime.fromJSDate(e)),a)}function g(e,r){switch(r){case t.FeatureServiceDatabaseType.FILEGDB:case t.FeatureServiceDatabaseType.Standardised:case t.FeatureServiceDatabaseType.StandardisedNoInterval:case t.FeatureServiceDatabaseType.Oracle:case t.FeatureServiceDatabaseType.PGDB:default:return"date"===e?"CURRENT_DATE":"time"===e?"CURRENT_TIME":"CURRENT_TIMESTAMP";case t.FeatureServiceDatabaseType.SqlServer:return"date"===e?"CAST(GETDATE() AS DATE)":"time"===e?"CAST(GETDATE() AS TIME)":"GETDATE()";case t.FeatureServiceDatabaseType.Postgres:return"date"===e?"CURRENT_DATE":"time"===e?"LOCALTIME":"CURRENT_TIMESTAMP"}}function E(e,r,t={}){const a={},s={},n={esriFieldTypeSmallInteger:"integer",esriFieldTypeInteger:"integer",esriFieldTypeBigInteger:"integer",esriFieldTypeSingle:"double",esriFieldTypeDouble:"double",esriFieldTypeString:"string",esriFieldTypeTimeOnly:"time-only",esriFieldTypeDateOnly:"date-only",esriFieldTypeTimestampOffset:"timestamp-offset",esriFieldTypeDate:"date",esriFieldTypeOID:"integer",esriFieldTypeGUID:"guid",esriFieldTypeGlobalID:"guid",oid:"integer",long:"integer","small-integer":"integer",integer:"integer","big-integer":"integer",single:"double","time-only":"time-only","date-only":"date-only","timestamp-offset":"timestemp-offset",double:"double",date:"date",guid:"guid","global-id":"guid",string:"string"};for(const c of r){const e=c.type?n[c.type]:void 0;a[c.name.toLowerCase()]=void 0===e?"":e}for(const c in t){const e=n[t[c]];s[c.toLowerCase()]=void 0===e?"":e}switch(h(a,e.parseTree,e.parameters,s)){case"double":return"double";case"integer":return"integer";case"date":return"date";case"date-only":return"date-only";case"time-only":return"time-only";case"timestamp-offset":return"timestamp-offset";case"string":return"string";case"global-id":case"guid":return"guid"}return""}function h(e,r,s,n){let c;switch(r.type){case"interval":return"integer";case"case-expression":{const t=[];if("simple"===r.format){for(let a=0;a<r.clauses.length;a++)t.push(h(e,r.clauses[a].value,s,n));null!==r.else&&t.push(h(e,r.else,s,n))}else{for(let a=0;a<r.clauses.length;a++)t.push(h(e,r.clauses[a].value,s,n));null!==r.else&&t.push(h(e,r.else,s,n))}return b(t)}case"parameter":{const e=n[r.value.toLowerCase()];if(void 0===e&&s){const e=s[r.value.toLowerCase()];if(void 0===e)return"";if(null===e)return"";if("string"==typeof e||e instanceof String)return"string";if("boolean"==typeof e)return"boolean";if(t.isDate(e))return"date";if(t.isArcadeDate(e))return"date";if(t.isArcadeDateOnly(e))return"date-only";if(t.isArcadeTime(e))return"time-only";if("number"==typeof e)return e%1==0?"integer":"double"}return void 0===e?"":e}case"expression-list":{const t=[];for(const a of r.value)t.push(h(e,a,s,n));return t}case"unary-expression":return"boolean";case"binary-expression":switch(r.operator){case"AND":case"OR":case"IN":case"NOT IN":case"BETWEEN":case"NOTBETWEEN":case"LIKE":case"NOT LIKE":case"<>":case"<":case">":case">=":case"<=":case"=":return"boolean";case"IS":case"ISNOT":if("null"!==r.right.type)throw new a.SqlError(a.SqlErrorCodes.UnsupportedIsRhs);return"boolean";case"*":case"-":case"+":case"/":return b([h(e,r.left,s,n),h(e,r.right,s,n)]);case"||":return"string";default:throw new a.SqlError(a.SqlErrorCodes.UnsupportedOperator,{operator:r.operator})}case"null":return"";case"boolean":return"boolean";case"string":return"string";case"number":return null===r.value?"":r.value%1==0?"integer":"double";case"date":return"date";case"timestamp":return r.withtimezone?"timestamp-offset":"date";case"time":return"time-only";case"current-time":return"time"===r.mode?"time-only":"date";case"current-user":return"string";case"column-reference":{const t=e[r.column.toLowerCase()];return void 0===t?"":t}case"function":switch(r.name.toLowerCase()){case"cast":switch(r.args?.value[1]?.value.type??""){case"integer":case"smallint":return"integer";case"real":case"float":return"double";case"date":case"timestamp":return!0===r.args?.value[1]?.value?.withtimezone?"timestamp-offset":"date";case"time":return"time-only";case"varchar":return"string";default:return""}case"position":case"extract":case"char_length":case"mod":return"integer";case"round":if(c=h(e,r.args,s,n),Array.isArray(c)){if(c.length<=0)return"double";c=c[0]}return c;case"sign":return"integer";case"ceiling":case"floor":case"abs":return c=h(e,r.args,s,n),Array.isArray(c)&&(c=b(c)),"integer"===c||"double"===c?c:"double";case"area":case"length":case"log":case"log10":case"sin":case"cos":case"tan":case"asin":case"acos":case"atan":case"cosh":case"sinh":case"tanh":case"power":return"double";case"substring":case"trim":case"concat":case"lower":case"upper":return"string";case"truncate":return"double";case"nullif":case"coalesce":return c=h(e,r.args,s,n),Array.isArray(c)?c.length>0?c[0]:"":c}return""}throw new a.SqlError(a.SqlErrorCodes.UnsupportedSyntax,{node:r.type})}const D={boolean:1,string:2,integer:3,double:4,date:5};function b(e){if(e){let r="";for(const t of e)""!==t&&(r=""===r||D[r]<D[t]?t:r);return r}return""}function v(e,r){return F(e.parseTree,r)}function A(e){return"column-reference"===e?.parseTree.type}function F(e,r){if(null==e)return!1;switch(e.type){case"when-clause":return F(e.operand,r)||F(e.value,r);case"case-expression":for(const t of e.clauses)if(F(t,r))return!0;return!("simple"!==e.format||!F(e.operand,r))||!(null===e.else||!F(e.else,r));case"parameter":case"null":case"boolean":case"date":case"timestamp":case"time":case"string":case"number":return!1;case"expression-list":for(const t of e.value)if(F(t,r))return!0;return!1;case"unary-expression":return F(e.expr,r);case"binary-expression":return F(e.left,r)||F(e.right,r);case"column-reference":return r.toLowerCase()===e.column.toLowerCase();case"function":return F(e.args,r)}return!1}function I(e){let r="";return r+=e.period.toUpperCase(),r}function L(e,r,t){let a="";return a="interval-period"===r.type?I(r):I(r.start)+" TO "+I(r.end),"INTERVAL "+t+" "+e+" "+a}e.arcadeDateOnlyToSqlString=y,e.arcadeDateToSqlString=T,e.combine=l,e.convertColumnReferenceToSql=d,e.convertIntervalToSql=L,e.isSingleField=A,e.makeSqlFromDateTimeParameter=f,e.makeTimeString=m,e.makeToday=g,e.predictType=E,e.reformulateWithoutField=u,e.scanForField=v,e.toWhereClause=i,e.toWhereClauseFromTree=o,e.translateFunctionToDatabaseSpecific=S,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
