/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../Dictionary","../executionError","../../chunks/languageUtils","../../core/maybe"],(function(e,r,n,t,s){"use strict";const o=e=>(r,n,t=14)=>+e(r,n).toFixed(t),i=(e,r)=>e+r,a=(e,r)=>e-r,c=(e,r)=>e*r,u=(e,r)=>e/r,d=(e,r,n)=>o(i)(e,r,n),l=(e,r,n)=>o(a)(e,r,n),h=(e,r,n)=>o(c)(e,r,n),g=(e,r,n)=>o(u)(e,r,n),m=360,E=400,_=2*Math.PI,f=3600,w=3240,A=60,x=60,D=180*f/Math.PI,p=m*A*x,S=90*f,T=180*f,R=270*f,M=String.fromCharCode(7501),v="°";function C(e){if(!1===t.isString(e))throw new n.ArcadeExecutionError(null,n.ExecutionErrorCodes.InvalidParameter,null);return e}function F(e,r){const n=10**r;return Math.round(e*n)/n}function L(e,r){return e%r}function U(e){const r=parseFloat(e.toString().replace(Math.trunc(e).toString(),"0"))*Math.sign(e);if(e<0){return{fraction:r,integer:Math.ceil(e)}}return{fraction:r,integer:Math.floor(e)}}var N,b,I,O;function z(e,r){switch(e){case N.north:return"SHORT"===r?"N":"North";case N.east:return"SHORT"===r?"E":"East";case N.south:return"SHORT"===r?"S":"South";case N.west:return"SHORT"===r?"W":"West"}}function G(e,r){return e-Math.floor(e/r)*r}function y(e){switch(e){case b.truncated_degrees:case b.decimal_degrees:return m;case b.radians:return _;case b.gradians:return E;case b.seconds:return p;case b.fractional_degree_minutes:return A;case b.fractional_minute_seconds:return x;default:throw new n.ArcadeExecutionError(null,n.ExecutionErrorCodes.LogicError,null,{reason:"unsupported evaluations"})}}function H(e){switch(e.toUpperCase().trim()){case"NORTH":case"NORTHAZIMUTH":case"NORTH AZIMUTH":return I.north_azimuth;case"POLAR":return I.polar;case"QUADRANT":return I.quadrant;case"SOUTH":case"SOUTHAZIMUTH":case"SOUTH AZIMUTH":return I.south_azimuth}throw new n.ArcadeExecutionError(null,n.ExecutionErrorCodes.LogicError,null,{reason:"unsupported directionType"})}function q(e){switch(e.toUpperCase().trim()){case"D":case"DD":case"DECIMALDEGREE":case"DECIMAL DEGREE":case"DEGREE":case"DECIMALDEGREES":case"DECIMAL DEGREES":case"DEGREES":return b.decimal_degrees;case"DMS":case"DEGREESMINUTESSECONDS":case"DEGREES MINUTES SECONDS":return b.degrees_minutes_seconds;case"R":case"RAD":case"RADS":case"RADIAN":case"RADIANS":return b.radians;case"G":case"GON":case"GONS":case"GRAD":case"GRADS":case"GRADIAN":case"GRADIANS":return b.gradians}throw new n.ArcadeExecutionError(null,n.ExecutionErrorCodes.LogicError,null,{reason:"unsupported units"})}!function(e){e[e.north=0]="north",e[e.east=1]="east",e[e.south=2]="south",e[e.west=3]="west"}(N||(N={})),function(e){e[e.decimal_degrees=1]="decimal_degrees",e[e.seconds=2]="seconds",e[e.degrees_minutes_seconds=3]="degrees_minutes_seconds",e[e.radians=4]="radians",e[e.gradians=5]="gradians",e[e.truncated_degrees=6]="truncated_degrees",e[e.fractional_degree_minutes=7]="fractional_degree_minutes",e[e.fractional_minute_seconds=8]="fractional_minute_seconds"}(b||(b={})),function(e){e[e.north_azimuth=1]="north_azimuth",e[e.polar=2]="polar",e[e.quadrant=3]="quadrant",e[e.south_azimuth=4]="south_azimuth"}(I||(I={})),function(e){e[e.meridian=0]="meridian",e[e.direction=1]="direction"}(O||(O={}));class k{constructor(e,r,n){this.m_degrees=e,this.m_minutes=r,this.m_seconds=n}getField(e){switch(e){case b.decimal_degrees:case b.truncated_degrees:return this.m_degrees;case b.fractional_degree_minutes:return this.m_minutes;case b.seconds:case b.fractional_minute_seconds:return this.m_seconds;default:throw new n.ArcadeExecutionError(null,n.ExecutionErrorCodes.LogicError,null,{reason:"unexpected evaluation"})}}static secondsToDMS(e){const r=U(e).fraction;let n=U(e).integer;const t=Math.floor(n/f);n-=t*f;const s=Math.floor(n/x);return n-=s*x,new k(t,s,n+r)}static numberToDms(e){const r=U(e).fraction,n=U(e).integer,t=h(U(100*r).fraction,100),s=U(100*r).integer;return new k(n,s,t)}format(e,r){let n=F(this.m_seconds,r),t=this.m_minutes,s=this.m_degrees;if(e===b.seconds||e===b.fractional_minute_seconds)x<=n&&(n-=x,++t),A<=t&&(t=0,++s),m<=s&&(s=0);else if(e===b.fractional_degree_minutes)n=0,t=30<=this.m_seconds?this.m_minutes+1:this.m_minutes,s=this.m_degrees,A<=t&&(t=0,++s),m<=s&&(s=0);else if(e===b.decimal_degrees||e===b.truncated_degrees){const e=g(this.m_seconds,f),r=g(this.m_minutes,A);s=Math.round(this.m_degrees+r+e),t=0,n=0}return new k(s,t,n)}static dmsToSeconds(e,r,n){return e*f+r*x+n}}class P{constructor(e,r,n){this.meridian=e,this.angle=r,this.direction=n}fetchAzimuth(e){return e===O.meridian?this.meridian:this.direction}}class Q{constructor(e){this._angle=e}static createFromAngleAndDirection(e,r){return new Q(new Z(Q._convertDirectionFormat(e.extractAngularUnits(b.seconds),r,I.north_azimuth)))}getAngle(e){const r=this._angle.extractAngularUnits(b.seconds);switch(e){case I.north_azimuth:case I.south_azimuth:case I.polar:return new Z(Q._convertDirectionFormat(r,I.north_azimuth,e));case I.quadrant:{const e=Q.secondsNorthAzimuthToQuadrant(r);return new Z(e.angle)}}}getMeridian(e){const r=this._angle.extractAngularUnits(b.seconds);switch(e){case I.north_azimuth:return N.north;case I.south_azimuth:return N.south;case I.polar:return N.east;case I.quadrant:return Q.secondsNorthAzimuthToQuadrant(r).meridian}}getDirection(e){const r=this._angle.extractAngularUnits(b.seconds);switch(e){case I.north_azimuth:return N.east;case I.south_azimuth:return N.west;case I.polar:return N.north;case I.quadrant:return Q.secondsNorthAzimuthToQuadrant(r).direction}}static secondsNorthAzimuthToQuadrant(e){const r=e<=S||e>=R?N.north:N.south,n=r===N.north?Math.min(p-e,e):Math.abs(e-T),t=e>T?N.west:N.east;return new P(r,n,t)}static createFromAngleMeridianAndDirection(e,r,n){return new Q(new Z(Q.secondsQuadrantToNorthAzimuth(e.extractAngularUnits(b.seconds),r,n)))}static secondsQuadrantToNorthAzimuth(e,r,n){return r===N.north?n===N.east?e:p-e:n===N.east?T-e:T+e}static _convertDirectionFormat(e,r,t){let s=0;switch(r){case I.north_azimuth:s=e;break;case I.polar:s=S-e;break;case I.quadrant:throw new n.ArcadeExecutionError(null,n.ExecutionErrorCodes.LogicError,null,{reason:"unexpected evaluation"});case I.south_azimuth:s=e+T}let o=0;switch(t){case I.north_azimuth:o=s;break;case I.polar:o=S-s;break;case I.quadrant:throw new n.ArcadeExecutionError(null,n.ExecutionErrorCodes.LogicError,null,{reason:"unexpected evaluation"});case I.south_azimuth:o=s-T}return o=L(o,p),o<0?p+o:o}}function W(e,r,t){let s=null;switch(r){case b.decimal_degrees:s=h(e,f);break;case b.seconds:s=e;break;case b.gradians:s=h(e,w);break;case b.radians:s=h(e,D);break;default:throw new n.ArcadeExecutionError(null,n.ExecutionErrorCodes.LogicError,null,{reason:"unexpected evaluation"})}switch(t){case b.decimal_degrees:return g(s,f);case b.seconds:return s;case b.gradians:return g(s,w);case b.radians:return s/D;default:throw new n.ArcadeExecutionError(null,n.ExecutionErrorCodes.LogicError,null,{reason:"unexpected evaluation"})}}class Z{constructor(e){this._seconds=e}static createFromAngleAndUnits(e,r){return new Z(W(e,r,b.seconds))}extractAngularUnits(e){return W(this._seconds,b.seconds,B(e))}static createFromDegreesMinutesSeconds(e,r,n){return new Z(d(d(h(e,f),h(r,x)),n))}}function B(e){switch(s.assertIsSome(e),e){case b.decimal_degrees:case b.truncated_degrees:case b.degrees_minutes_seconds:return b.decimal_degrees;case b.gradians:return b.gradians;case b.fractional_degree_minutes:return b.fractional_degree_minutes;case b.radians:return b.radians;case b.seconds:case b.fractional_minute_seconds:return b.seconds}}class V{constructor(e,r,n,t){this.view=e,this.angle=r,this.merdian=n,this.direction=t,this._dms=null,this._formattedDms=null}static createFromStringAndBearing(e,r,n){return new V(e,r.getAngle(n),r.getMeridian(n),r.getDirection(n))}fetchAngle(){return this.angle}fetchMeridian(){return this.merdian}fetchDirection(){return this.direction}fetchView(){return this.view}fetchDms(){return null===this._dms&&this._calculateDms(),this._dms}fetchFormattedDms(){return null===this._formattedDms&&this._calculateDms(),this._formattedDms}_calculateDms(){let e=null,r=b.truncated_degrees,n=0;for(let t=0;t<this.view.length;t++){const s=this.view[t];switch(s){case"m":e=oe(this.view,t,s),r=r===b.truncated_degrees?b.fractional_degree_minutes:r,t=e.newpos;continue;case"s":e=oe(this.view,t,s),r=b.fractional_minute_seconds,n=n<e.rounding?e.rounding:n,t=e.newpos;continue;default:continue}}this._dms=k.secondsToDMS(this.angle.extractAngularUnits(b.seconds)),this._formattedDms=k.secondsToDMS(this.angle.extractAngularUnits(b.seconds)).format(r,n)}}function X(e,r,t,s,o){let i=null;switch(r){case b.decimal_degrees:case b.radians:case b.gradians:return i=G(F(e.extractAngularUnits(r),s),y(r)),i.toFixed(s).padStart(t+s+(s>0?1:0),"0");case b.truncated_degrees:case b.fractional_degree_minutes:return i=G(o.fetchFormattedDms().getField(r),y(r)),i.toFixed(s).padStart(t+s+(s>0?1:0),"0");case b.fractional_minute_seconds:return i=G(F(o.fetchDms().getField(r),s),y(r)),i.toFixed(s).padStart(t+s+(s>0?1:0),"0");default:throw new n.ArcadeExecutionError(null,n.ExecutionErrorCodes.LogicError,null,{reason:"unexpected evaluation"})}}function j(e,r,t){if(t===I.quadrant)throw new n.ArcadeExecutionError(null,n.ExecutionErrorCodes.LogicError,null,{reason:"conversion error"});if(r===b.degrees_minutes_seconds){const r=k.numberToDms(e);return Q.createFromAngleAndDirection(Z.createFromDegreesMinutesSeconds(r.m_degrees,r.m_minutes,r.m_seconds),t)}return Q.createFromAngleAndDirection(Z.createFromAngleAndUnits(e,B(r)),t)}function J(e){switch(t.toNumber(e)){case 1:return{first:N.north,second:N.east};case 2:return{first:N.south,second:N.east};case 3:return{first:N.south,second:N.west};case 4:return{first:N.north,second:N.west}}return null}function K(e){switch(e.toUpperCase().trim()){case"N":case"NORTH":return N.north;case"E":case"EAST":return N.east;case"S":case"SOUTH":return N.south;case"W":case"WEST":return N.west}return null}function Y(e){const r=parseFloat(e);if(t.isNumber(r)){if(isNaN(r))throw new n.ArcadeExecutionError(null,n.ExecutionErrorCodes.LogicError,null,{reason:"invalid conversion"});return r}throw new n.ArcadeExecutionError(null,n.ExecutionErrorCodes.LogicError,null,{reason:"invalid conversion"})}function $(e,r,s){const o=s===I.quadrant;let i=null,a=null,c=0,u=0,d=0;if(o){if(e.length<2)throw new n.ArcadeExecutionError(null,n.ExecutionErrorCodes.LogicError,null,{reason:"conversion error"});d=1;const r=J(t.toString(e[e.length-1]));if(r?(i=r.first,a=r.second):(c=1,i=K(t.toString(e[0])),a=K(t.toString(e[e.length-1]))),null===i||null===a)throw new n.ArcadeExecutionError(null,n.ExecutionErrorCodes.LogicError,null,{reason:"invalid conversion"})}switch(r){case b.decimal_degrees:case b.radians:case b.gradians:if(0===e.length)throw new n.ArcadeExecutionError(null,n.ExecutionErrorCodes.LogicError,null,{reason:"invalid conversion"});return o?Q.createFromAngleMeridianAndDirection(Z.createFromAngleAndUnits(Y(e[c]),B(r)),i,a):Q.createFromAngleAndDirection(Z.createFromAngleAndUnits(Y(e[c]),B(r)),s);case b.degrees_minutes_seconds:if(u=e.length-d-c,3===u){const r=Z.createFromDegreesMinutesSeconds(Y(e[c]),Y(e[c+1]),Y(e[c+2]));return o?Q.createFromAngleMeridianAndDirection(r,i,a):Q.createFromAngleAndDirection(r,s)}if(1===u){const r=Y(e[c]),n=k.numberToDms(r),t=Z.createFromDegreesMinutesSeconds(n.m_degrees,n.m_minutes,n.m_seconds);return o?Q.createFromAngleMeridianAndDirection(t,i,a):Q.createFromAngleAndDirection(t,s)}}throw new n.ArcadeExecutionError(null,n.ExecutionErrorCodes.LogicError,null,{reason:"invalid conversion"})}function ee(e){const r=new Set([" ","-","/","'",'"',"\\","^",v,M,"\t","\r","\n","*"]);let n="";for(let t=0;t<e.length;t++){const s=e.charAt(t);r.has(s)?n+="RRSPLITRRSPLITRR":n+=s}return n.split("RRSPLITRRSPLITRR").filter((e=>""!==e))}function re(e,r,s){if(t.isNumber(e))return j(t.toNumber(e),r,s);if(t.isString(e))return $(ee(e),r,s);if(t.isArray(e))return $(e,r,s);if(t.isImmutableArray(e))return $(e.toArray(),r,s);throw new n.ArcadeExecutionError(null,n.ExecutionErrorCodes.LogicError,null,{reason:"conversion error"})}function ne(e,r,t){const s=B(t);if(s&&t!==b.degrees_minutes_seconds){return e.getAngle(r).extractAngularUnits(s)}throw new n.ArcadeExecutionError(null,n.ExecutionErrorCodes.LogicError,null,{reason:"conversion error"})}function te(e,r,n){const t=e.getAngle(r);if(r===I.quadrant&&n===b.degrees_minutes_seconds){const n=k.secondsToDMS(t.extractAngularUnits(b.seconds));return[z(e.getMeridian(r),"SHORT"),n.m_degrees,n.m_minutes,n.m_seconds,z(e.getDirection(r),"SHORT")]}if(n===b.degrees_minutes_seconds){const e=k.secondsToDMS(t.extractAngularUnits(b.seconds));return[e.m_degrees,e.m_minutes,e.m_seconds]}return r===I.quadrant?[z(e.getMeridian(r),"SHORT"),t.extractAngularUnits(n),z(e.getDirection(r),"SHORT")]:[t.extractAngularUnits(n)]}function se(e,r){let t="";switch(e){case b.decimal_degrees:t=r===I.quadrant?"DD.DD"+v:"DDD.DD"+v;break;case b.degrees_minutes_seconds:t=r===I.quadrant?"dd"+v+" mm' ss\"":"ddd"+v+" mm' ss.ss\"";break;case b.radians:t="R.RR";break;case b.gradians:t="GGG.GG"+M;break;default:throw new n.ArcadeExecutionError(null,n.ExecutionErrorCodes.LogicError,null,{reason:"conversion error"})}return r===I.quadrant&&(t="p "+t+" b"),t}function oe(e,r,n){const t={padding:0,rounding:0,newpos:r};let s=!1;for(;r<e.length;){const o=e[r];if(o===n)s?t.rounding++:t.padding++,r++;else{if("."!==o)break;s=!0,r++}}return t.newpos=r-1,t}function ie(e,r,n){const t={escaped:"",newpos:r};for(r++;r<e.length;){const n=e[r];if(r++,"]"===n)break;t.escaped+=n}return t.newpos=r-1,t}function ae(e,r,n){let t="",s=null,o=null;const i=V.createFromStringAndBearing(r,e,n),a={D:b.decimal_degrees,d:b.truncated_degrees,m:b.fractional_degree_minutes,s:b.fractional_minute_seconds,R:b.radians,G:b.gradians};for(let c=0;c<r.length;c++){const u=r[c];switch(u){case"[":s=ie(r,c),t+=s.escaped,c=s.newpos;continue;case"D":case"d":case"m":case"s":case"R":case"G":s=oe(r,c,u),o=e.getAngle(n),t+=X(o,a[u],s.padding,s.rounding,i),c=s.newpos;continue;case"P":case"p":t+=z(i.fetchMeridian(),"p"===u?"SHORT":"LONG");continue;case"B":case"b":t+=z(i.fetchDirection(),"b"===u?"SHORT":"LONG");continue;default:t+=u}}return t}function ce(e,s,o){if(!(s instanceof r))throw new n.ArcadeExecutionError(null,n.ExecutionErrorCodes.InvalidParameter,null);if(!1===s.hasField("directionType"))throw new n.ArcadeExecutionError(null,n.ExecutionErrorCodes.LogicError,null,{reason:"missing directionType"});if(!1===s.hasField("angleType"))throw new n.ArcadeExecutionError(null,n.ExecutionErrorCodes.LogicError,null,{reason:"missing angleType"});const i=H(C(s.field("directiontype"))),a=re(e,q(C(s.field("angletype"))),i);if(!(o instanceof r))throw new n.ArcadeExecutionError(null,n.ExecutionErrorCodes.InvalidParameter,null);if(!1===o.hasField("directionType"))throw new n.ArcadeExecutionError(null,n.ExecutionErrorCodes.LogicError,null,{reason:"missing directionType"});if(!1===o.hasField("outputType"))throw new n.ArcadeExecutionError(null,n.ExecutionErrorCodes.LogicError,null,{reason:"missing angleType"});const c=H(C(o.field("directiontype"))),u=o.hasField("angleType")?q(C(o.field("angletype"))):null,d=C(o.field("outputType")).toUpperCase().trim();if(!c||!d)throw new n.ArcadeExecutionError(null,n.ExecutionErrorCodes.LogicError,null,{reason:"conversion error"});if(!(u||"TEXT"===d&&o.hasField("format")))throw new n.ArcadeExecutionError(null,n.ExecutionErrorCodes.LogicError,null,{reason:"invalid unit"});switch(d){case"VALUE":return c===I.quadrant||u===b.degrees_minutes_seconds?te(a,c,u):ne(a,c,u);case"TEXT":{let e="";return o.hasField("format")&&(e=t.toString(o.field("format"))),null!==e&&""!==e||(e=se(u,c)),ae(a,e,c)}default:throw new n.ArcadeExecutionError(null,n.ExecutionErrorCodes.InvalidParameter,null)}}e.convertDirection=ce,e.preciseAdd=d,e.preciseDivide=g,e.preciseMinus=l,e.preciseMultiply=h,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
