/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../ArcadeDate","../executionError","../../chunks/languageUtils","../../core/sql/DateOnly","../../core/sql/TimeOnly","../../intl/locale","../../chunks/datetime"],(function(e,t,n,r,o,a,u,i){"use strict";function c(e,t,n){return e+(l(n)?m:s)[t]}function l(e){return e%4==0&&(e%100!=0||e%400==0)}const s=[0,31,59,90,120,151,181,212,243,273,304,334],m=[0,31,60,91,121,152,182,213,244,274,305,335];function d(e){return null===e?e:!1===e.isValid?null:e}function f(e,t){return""===e||"default"===e.toLowerCase().trim()?r.defaultTimeZone(t):"z"===e||"Z"===e?"UTC":e}function D(e,t){return r.isDateOnly(e)?e.toArcadeDate():r.toDate(e,r.defaultTimeZone(t))}function N(e,l){e.today=function(e,n){return l(e,n,((o,a,u)=>{r.pcCheck(u,0,0,e,n);const i=new Date;return i.setHours(0,0,0,0),t.ArcadeDate.dateJSAndZoneToArcadeDate(i,r.defaultTimeZone(e))}))},e.time=function(e,o){return l(e,o,((u,i,c)=>{switch(r.pcCheck(c,0,4,e,o),c.length){case 0:{const n=t.ArcadeDate.nowToArcadeDate(r.defaultTimeZone(e));return new a.TimeOnly(n.hour,n.minute,n.second,n.millisecond)}case 1:{if(r.isTime(c[0]))return c[0].clone();if(r.isDate(c[0]))return new a.TimeOnly(c[0].hour,c[0].minute,c[0].second,c[0].millisecond);if(r.isDateOnly(c[0]))return new a.TimeOnly(0,0,0,0);if(r.isString(c[0]))return a.TimeOnly.fromString(c[0]);const e=r.toNumber(c[0]);return!1===isNaN(e)?a.TimeOnly.fromMilliseconds(e):null}case 2:return r.isString(c[0])&&r.isString(c[1])?a.TimeOnly.fromString(c[0],c[1]):a.TimeOnly.fromParts(r.toNumber(c[0]),r.toNumber(c[1]),0,0);case 3:return a.TimeOnly.fromParts(r.toNumber(c[0]),r.toNumber(c[1]),r.toNumber(c[2]),0);case 4:return a.TimeOnly.fromParts(r.toNumber(c[0]),r.toNumber(c[1]),r.toNumber(c[2]),r.toNumber(c[3]))}throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,o)}))},e.dateonly=function(e,n){return l(e,n,((a,u,i)=>{if(r.pcCheck(i,0,3,e,n),3===i.length)return o.DateOnly.fromParts(r.toNumber(i[0]),r.toNumber(i[1])+1,r.toNumber(i[2]));if(2===i.length){const e=r.toString(i[1]);return""===e?null:"X"===e?o.DateOnly.fromSeconds(r.toNumber(i[0])):"x"===e?o.DateOnly.fromMilliseconds(r.toNumber(i[0])):o.DateOnly.fromString(r.toString(i[0]),e)}if(1===i.length){if(r.isString(i[0])){if(""===i[0].replaceAll(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g,""))return null;if(!0===/^[0-9][0-9][0-9][0-9]$/.test(i[0]))return o.DateOnly.fromString(i[0]+"-01-01")}if(r.isDateOnly(i[0]))return i[0].clone();if(r.isDate(i[0]))return o.DateOnly.fromParts(i[0].year,i[0].monthJS+1,i[0].day);const e=r.toNumber(i[0]);return!1===isNaN(e)?o.DateOnly.fromMilliseconds(e):r.isString(i[0])?o.DateOnly.fromString(i[0]):null}if(0===i.length){const n=t.ArcadeDate.nowToArcadeDate(r.defaultTimeZone(e));return!1===n.isValid?null:o.DateOnly.fromParts(n.year,n.monthJS+1,n.day)}return null}))},e.changetimezone=function(e,o){return l(e,o,((a,u,i)=>{if(r.pcCheck(i,2,2,e,o),null===i[0])return null;if(r.isDateOnly(i[0]))throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.CannotChangeTimeZoneDateOnly,o);if(r.isDateOnly(i[0]))throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.CannotChangeTimeZoneTime,o);const c=r.toDate(i[0],r.defaultTimeZone(e));if(null===c)throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,o);const l=t.createDateTimeZone(f(r.toString(i[1]),e),!1);if(null===l)return null;const s=t.ArcadeDate.arcadeDateAndZoneToArcadeDate(c,l);return!1===s.isValid?null:s}))},e.timezone=function(e,n){return l(e,n,((o,a,u)=>{if(r.pcCheck(u,1,2,e,n),r.isTime(u[0]))return"Unknown";if(r.isDateOnly(u[0]))return"Unknown";const i=r.toDate(u[0],r.defaultTimeZone(e));if(null===i)return null;const c=i.timeZone;return"system"===c?t.ArcadeDate.systemTimeZoneCanonicalName:"utc"===c.toLowerCase()?"UTC":"unknown"===c.toLowerCase()?"Unknown":c}))},e.timezoneoffset=function(e,t){return l(e,t,((n,o,a)=>{r.pcCheck(a,1,1,e,t);const u=r.toDate(a[0],r.defaultTimeZone(e));return null===u?null:60*u.timeZoneOffset*1e3}))},e.now=function(e,n){return l(e,n,((o,a,u)=>{r.pcCheck(u,0,0,e,n);const i=t.ArcadeDate.nowToArcadeDate(r.defaultTimeZone(e));return!1===i.isValid?null:i}))},e.timestamp=function(e,n){return l(e,n,((o,a,u)=>{r.pcCheck(u,0,0,e,n);const i=t.ArcadeDate.nowUTCToArcadeDate();return!1===i.isValid?null:i}))},e.toutc=function(e,t){return l(e,t,((n,o,a)=>{r.pcCheck(a,1,1,e,t);const u=r.toDate(a[0],r.defaultTimeZone(e));return null===u?null:u.toUTC()}))},e.tolocal=function(e,t){return l(e,t,((n,o,a)=>{r.pcCheck(a,1,1,e,t);const u=r.toDate(a[0],r.defaultTimeZone(e));return null===u?null:u.toLocal()}))},e.day=function(e,t){return l(e,t,((n,o,a)=>{r.pcCheck(a,1,1,e,t);const u=D(a[0],r.defaultTimeZone(e));return null===u?NaN:u.day}))},e.month=function(e,t){return l(e,t,((n,o,a)=>{r.pcCheck(a,1,1,e,t);const u=D(a[0],r.defaultTimeZone(e));return null===u?NaN:u.monthJS}))},e.year=function(e,t){return l(e,t,((n,o,a)=>{r.pcCheck(a,1,1,e,t);const u=D(a[0],r.defaultTimeZone(e));return null===u?NaN:u.year}))},e.hour=function(e,t){return l(e,t,((n,o,a)=>{if(r.pcCheck(a,1,1,e,t),r.isTime(a[0]))return a[0].hour;const u=r.toDate(a[0],r.defaultTimeZone(e));return null===u?NaN:u.hour}))},e.second=function(e,t){return l(e,t,((n,o,a)=>{if(r.pcCheck(a,1,1,e,t),r.isTime(a[0]))return a[0].second;const u=r.toDate(a[0],r.defaultTimeZone(e));return null===u?NaN:u.second}))},e.millisecond=function(e,t){return l(e,t,((n,o,a)=>{if(r.pcCheck(a,1,1,e,t),r.isTime(a[0]))return a[0].millisecond;const u=r.toDate(a[0],r.defaultTimeZone(e));return null===u?NaN:u.millisecond}))},e.minute=function(e,t){return l(e,t,((n,o,a)=>{if(r.pcCheck(a,1,1,e,t),r.isTime(a[0]))return a[0].minute;const u=r.toDate(a[0],r.defaultTimeZone(e));return null===u?NaN:u.minute}))},e.week=function(e,t){return l(e,t,((o,a,u)=>{r.pcCheck(u,1,2,e,t);const i=D(u[0],r.defaultTimeZone(e));if(null===i)return NaN;const l=r.toNumber(r.defaultUndefined(u[1],0));if(l<0||l>6)throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,t);const s=i.day,m=i.monthJS,d=i.year,f=i.dayOfWeekJS,N=c(s,m,d)-1,T=Math.floor(N/7);return f-l+(f-l<0?7:0)<N-7*T?T+1:T}))},e.weekday=function(e,t){return l(e,t,((n,o,a)=>{r.pcCheck(a,1,1,e,t);const u=D(a[0],r.defaultTimeZone(e));return null===u?NaN:u.dayOfWeekJS}))},e.isoweekday=function(e,t){return l(e,t,((n,o,a)=>{r.pcCheck(a,1,1,e,t);const u=D(a[0],r.defaultTimeZone(e));return null===u?NaN:u.dayOfWeekISO}))},e.isomonth=function(e,t){return l(e,t,((n,o,a)=>{r.pcCheck(a,1,1,e,t);const u=D(a[0],r.defaultTimeZone(e));return null===u?NaN:u.monthISO}))},e.isoweek=function(e,t){return l(e,t,((n,o,a)=>{r.pcCheck(a,1,1,e,t);const u=D(a[0],r.defaultTimeZone(e));return null===u?NaN:u.weekISO}))},e.isoyear=function(e,t){return l(e,t,((n,o,a)=>{r.pcCheck(a,1,1,e,t);const u=D(a[0],r.defaultTimeZone(e));return null===u?NaN:u.yearISO}))},e.date=function(e,n){return l(e,n,((o,a,c)=>{if(r.pcCheck(c,0,8,e,n),3===c.length){if(r.isDateOnly(c[0])&&r.isTime(c[1])&&r.isString(c[2])){const n=t.createDateTimeZone(f(r.toString(c[2])??"unknown",e),!1);return null===n?null:d(t.ArcadeDate.fromParts(c[0].year,c[0].month,c[0].day,c[1].hour,c[1].minute,c[1].second,c[1].millisecond,n))}return d(t.ArcadeDate.fromParts(r.toNumber(c[0]),r.toNumber(c[1])+1,r.toNumber(c[2]),0,0,0,0,r.defaultTimeZone(e)))}if(4===c.length)return d(t.ArcadeDate.fromParts(r.toNumber(c[0]),r.toNumber(c[1])+1,r.toNumber(c[2]),r.toNumber(c[3]),0,0,0,r.defaultTimeZone(e)));if(5===c.length)return d(t.ArcadeDate.fromParts(r.toNumber(c[0]),r.toNumber(c[1])+1,r.toNumber(c[2]),r.toNumber(c[3]),r.toNumber(c[4]),0,0,r.defaultTimeZone(e)));if(6===c.length)return d(t.ArcadeDate.fromParts(r.toNumber(c[0]),r.toNumber(c[1])+1,r.toNumber(c[2]),r.toNumber(c[3]),r.toNumber(c[4]),r.toNumber(c[5]),0,r.defaultTimeZone(e)));if(7===c.length)return d(t.ArcadeDate.fromParts(r.toNumber(c[0]),r.toNumber(c[1])+1,r.toNumber(c[2]),r.toNumber(c[3]),r.toNumber(c[4]),r.toNumber(c[5]),r.toNumber(c[6]),r.defaultTimeZone(e)));if(8===c.length){const n=t.createDateTimeZone(f(r.toString(c[7])??"unknown",e),!1);return null===n?null:d(t.ArcadeDate.fromParts(r.toNumber(c[0]),r.toNumber(c[1])+1,r.toNumber(c[2]),r.toNumber(c[3]),r.toNumber(c[4]),r.toNumber(c[5]),r.toNumber(c[6]),n))}if(2===c.length){if(r.isDateOnly(c[0])&&r.isString(c[1])){const n=t.createDateTimeZone(f(r.toString(c[1])??"unknown",e),!1);return null===n?null:d(t.ArcadeDate.fromParts(c[0].year,c[0].month,c[0].day,0,0,0,0,n))}if(r.isDateOnly(c[0])&&r.isTime(c[1]))return d(t.ArcadeDate.fromParts(c[0].year,c[0].month,c[0].day,c[1].hour,c[1].minute,c[1].second,c[1].millisecond,"unknown"));let n,o=r.toString(c[1]);return""===o?null:(o=r.standardiseDateFormat(o,!0),n="X"===o?i.DateTime.fromSeconds(r.toNumber(c[0])):"x"===o?i.DateTime.fromMillis(r.toNumber(c[0])):i.DateTime.fromFormat(r.toString(c[0]),o,{locale:u.getLocale(),numberingSystem:"latn"}),n.isValid?t.ArcadeDate.dateTimeToArcadeDate(n):null)}if(1===c.length){if(r.isDateOnly(c[0]))return d(t.ArcadeDate.fromParts(c[0].year,c[0].month,c[0].day,0,0,0,0,"unknown"));if(r.isString(c[0])){if(""===c[0].replaceAll(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g,""))return null;if(!0===/^[0-9][0-9][0-9][0-9]$/.test(c[0]))return r.toDate(c[0]+"-01-01",r.defaultTimeZone(e))}const n=r.toNumber(c[0]);if(!1===isNaN(n)){const o=i.DateTime.fromMillis(n);return o.isValid?t.ArcadeDate.dateTimeAndZoneToArcadeDate(o,r.defaultTimeZone(e)):null}return r.toDate(c[0],r.defaultTimeZone(e))}return 0===c.length?t.ArcadeDate.nowToArcadeDate(r.defaultTimeZone(e)):null}))},e.datediff=function(e,n){return l(e,n,((o,a,u)=>{if(r.pcCheck(u,2,4,e,n),r.isTime(u[0]))return r.isTime(u[1])?u[0].difference(u[1],r.toString(u[2])):NaN;if(r.isTime(u[1]))return NaN;if(r.isDateOnly(u[0]))return r.isDateOnly(u[1])?u[0].difference(u[1],r.toString(u[2])):NaN;if(r.isDateOnly(u[1]))return NaN;let i=r.toDate(u[0],r.defaultTimeZone(e)),c=r.toDate(u[1],r.defaultTimeZone(e));if(null===i||null===c)return NaN;let l=r.defaultUndefined(u[3],"");switch(""!==l&&null!==l?(l=f(r.toString(l),e),i=t.ArcadeDate.arcadeDateAndZoneToArcadeDate(i,l),c=t.ArcadeDate.arcadeDateAndZoneToArcadeDate(c,l)):i.timeZone!==c.timeZone&&(i.isUnknownTimeZone?i=t.ArcadeDate.arcadeDateAndZoneToArcadeDate(i,c.timeZone):c=(c.isUnknownTimeZone,t.ArcadeDate.arcadeDateAndZoneToArcadeDate(c,i.timeZone))),r.toString(u[2]).toLowerCase()){case"days":case"day":case"d":return i.diff(c,"days");case"months":case"month":return i.diff(c,"months");case"minutes":case"minute":case"m":return"M"===u[2]?i.diff(c,"months"):i.diff(c,"minutes");case"seconds":case"second":case"s":return i.diff(c,"seconds");case"milliseconds":case"millisecond":case"ms":default:return i.diff(c);case"hours":case"hour":case"h":return i.diff(c,"hours");case"years":case"year":case"y":return i.diff(c,"years")}}))},e.dateadd=function(e,t){return l(e,t,((n,o,a)=>{r.pcCheck(a,2,3,e,t);let u=r.toNumber(a[1]);if(isNaN(u)||u===1/0||u===-1/0)return r.isTime(a[0])||r.isDateOnly(a[0])?a[0].clone():r.toDate(a[0],r.defaultTimeZone(e));let i="milliseconds";switch(r.toString(a[2]).toLowerCase()){case"days":case"day":case"d":i="days",u=r.isDateOnly(a[0])?u:r.absRound(u);break;case"months":case"month":i="months",u=r.isDateOnly(a[0])?u:r.absRound(u);break;case"minutes":case"minute":case"m":i="M"===a[2]?"months":"minutes";break;case"seconds":case"second":case"s":i="seconds";break;case"milliseconds":case"millisecond":case"ms":i="milliseconds";break;case"hours":case"hour":case"h":i="hours";break;case"years":case"year":case"y":i="years"}if(r.isTime(a[0]))return a[0].plus(i,u);if(r.isDateOnly(a[0]))return a[0].plus(i,u);const c=r.toDate(a[0],r.defaultTimeZone(e));return null===c?null:c.plus({[i]:u})}))}}e.registerFunctions=N,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
