/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../ArcadeDate","../ArcadePortal","../Dictionary","../executionError","../Feature","../featureSetUtils","../ImmutableArray","../../chunks/languageUtils","../portalUtils","../featureset/actions/Adapted","../featureset/actions/AttributeFilter","../featureset/actions/OrderBy","../featureset/actions/Top","../featureset/sources/Empty","../featureset/sources/FeatureLayerMemory","../featureset/support/OrderbyClause","../featureset/support/shared","../featureset/support/sqlUtils","./fieldStats","../../core/promiseUtils","../../core/sql/WhereClause","../../layers/FeatureLayer","../../layers/support/Field","../../portal/Portal"],(function(e,t,n,r,i,a,o,s,l,u,d,c,f,m,E,p,y,h,F,g,w,x,I,A,C){"use strict";function S(e){if(1===e.length){if(l.isArray(e[0]))return g.calculateStat("distinct",e[0],-1);if(l.isImmutableArray(e[0]))return g.calculateStat("distinct",e[0].toArray(),-1)}return g.calculateStat("distinct",e,-1)}async function D(e,t,n){const r=e.getVariables();if(r.length>0){const i=[];for(let e=0;e<r.length;e++){const a={name:r[e]};i.push(await t.evaluateIdentifier(n,a))}const a={};for(let e=0;e<r.length;e++)a[r[e]]=i[e];return e.parameters=a,e}return e}function T(e,t,n=null){for(const r in e)if(r.toLowerCase()===t.toLowerCase())return e[r];return n}function b(e){if(null===e)return null;const t={type:T(e,"type",""),name:T(e,"name","")};if("range"===t.type)t.range=T(e,"range",[]);else{t.codedValues=[];for(const n of T(e,"codedValues",[]))t.codedValues.push({name:T(n,"name",""),code:T(n,"code",null)})}return t}function N(e){if(null===e)return null;const t={},n=T(e,"wkt");null!==n&&(t.wkt=n);const r=T(e,"wkid");return null!==r&&(t.wkid=r),t}function L(e){if(null===e)return null;const t={hasZ:T(e,"hasz",!1),hasM:T(e,"hasm",!1)},n=T(e,"spatialreference");null!=n&&(t.spatialReference=N(n));const r=T(e,"x",null);if(null!==r)return t.x=r,t.y=T(e,"y",null),t.hasZ&&(t.z=T(e,"z",null)),t.hasM&&(t.m=T(e,"m",null)),t;const i=T(e,"rings",null);if(null!==i)return t.rings=i,t;const a=T(e,"paths",null);if(null!==a)return t.paths=a,t;const o=T(e,"points",null);if(null!==o)return t.points=o,t;for(const s of["xmin","xmax","ymin","ymax","zmin","zmax","mmin","mmax"]){const n=T(e,s,null);null!==n&&(t[s]=n)}return t}function Z(e,t){for(const n of t)if(n===e)return!0;return!1}function v(e){return!!e.layerDefinition&&(!!e.featureSet&&(!1!==Z(e.layerDefinition.geometryType,["",null,"esriGeometryNull","esriGeometryPoint","esriGeometryPolyline","esriGeometryPolygon","esriGeometryMultipoint","esriGeometryEnvelope"])&&(!1!==l.isArray(e.layerDefinition.fields)&&!1!==l.isArray(e.featureSet.features))))}function $(e){return"utc"===e?.toLowerCase()?"UTC":"unknown"===e?.toLowerCase()?"Unknown":e}function P(e){"async"===e.mode&&(e.functions.timezone=function(n,a){return e.standardFunctionAsync(n,a,(async(e,o,s)=>{if(l.pcCheck(s,1,2,n,a),l.isTime(s[0]))return"Unknown";if(l.isDateOnly(s[0]))return"Unknown";if(l.isFeatureSet(s[0])){if(await s[0].load(),1===s.length||null===s[1])return s[0].datesInUnknownTimezone?$("unknown"):$(s[0].dateFieldsTimeZone);if(!(s[1]instanceof r)||!1===s[1].hasField("type"))throw new i.ArcadeExecutionError(n,i.ExecutionErrorCodes.InvalidParameter,a);const e=s[1].field("type");if(!1===l.isString(e))throw new i.ArcadeExecutionError(n,i.ExecutionErrorCodes.InvalidParameter,a);switch(l.toString(e).toLowerCase()){case"preferredtimezone":return $(s[0].preferredTimeZone);case"editfieldsinfo":return $(s[0].editFieldsInfo?.timeZone??null);case"timeinfo":return $(s[0].timeInfo?.timeZone??null);case"field":if(s[1].hasField("fieldname")&&l.isString(s[1].field("fieldname")))return $(s[0].fieldTimeZone(l.toString(s[1].field("fieldname"))))}throw new i.ArcadeExecutionError(n,i.ExecutionErrorCodes.InvalidParameter,a)}const u=l.toDate(s[0],l.defaultTimeZone(n));if(null===u)return null;const d=u.timeZone;return"system"===d?t.ArcadeDate.systemTimeZoneCanonicalName:"utc"===d.toLowerCase()?"UTC":"unknown"===d.toLowerCase()?"Unknown":d}))},e.functions.sqltimestamp=function(t,n){return e.standardFunctionAsync(t,n,(async(e,r,a)=>{l.pcCheck(a,1,3,t,n);const o=a[0];if(l.isDate(o)){if(1===a.length)return o.toSQLWithKeyword();if(2===a.length)return o.changeTimeZone(l.toString(a[1])).toSQLWithKeyword();throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n)}if(l.isDateOnly(o))return o.toSQLWithKeyword();if(l.isFeatureSet(o)){if(3!==a.length)throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n);await o.load();const e=l.toString(a[1]);if(l.isDateOnly(a[2]))return a[2].toSQLWithKeyword();if(!1===l.isDate(a[2]))throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n);const r=o.fieldTimeZone(e);return null===r?a[2].toSQLWithKeyword():a[2].changeTimeZone(r).toSQLWithKeyword()}throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n)}))},e.signatures.push({name:"sqltimestamp",min:2,max:4}),e.functions.featuresetbyid=function(t,n){return e.standardFunctionAsync(t,n,((e,r,a)=>{if(l.pcCheck(a,2,4,t,n),l.isFeatureSetCollection(a[0])){const e=l.toString(a[1]);let r=l.defaultUndefined(a[2],null);const o=l.toBoolean(l.defaultUndefined(a[3],!0));if(null===r&&(r=["*"]),!1===l.isArray(r))throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n);return a[0].featureSetById(e,o,r)}throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n)}))},e.signatures.push({name:"featuresetbyid",min:2,max:4}),e.functions.getfeatureset=function(t,n){return e.standardFunctionAsync(t,n,(async(e,r,a)=>{if(l.pcCheck(a,1,2,t,n),l.isFeature(a[0])){let e=l.defaultUndefined(a[1],"datasource");return null===e&&(e="datasource"),e=l.toString(e).toLowerCase(),o.convertToFeatureSet(a[0].fullSchema(),e,t.lrucache,t.interceptor,t.spatialReference??null)}throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n)}))},e.signatures.push({name:"getfeatureset",min:1,max:2}),e.functions.featuresetbyportalitem=function(t,r){return e.standardFunctionAsync(t,r,((e,a,s)=>{if(l.pcCheck(s,2,5,t,r),null===s[0])throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.PortalRequired,r);if(s[0]instanceof n){const e=l.toString(s[1]),n=l.toString(s[2]);let a=l.defaultUndefined(s[3],null);const d=l.toBoolean(l.defaultUndefined(s[4],!0));if(null===a&&(a=["*"]),!1===l.isArray(a))throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,r);let c;return c=t.services?.portal?t.services.portal:C.getDefault(),c=u.getPortal(s[0],c),o.constructFeatureSetFromPortalItem(e,n,t.spatialReference??null,a,d,c,t.lrucache,t.interceptor)}if(!1===l.isString(s[0]))throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.PortalRequired,r);const d=l.toString(s[0]),c=l.toString(s[1]);let f=l.defaultUndefined(s[2],null);const m=l.toBoolean(l.defaultUndefined(s[3],!0));if(null===f&&(f=["*"]),!1===l.isArray(f))throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,r);return o.constructFeatureSetFromPortalItem(d,c,t.spatialReference??null,f,m,t.services?.portal??C.getDefault(),t.lrucache,t.interceptor)}))},e.signatures.push({name:"featuresetbyportalitem",min:2,max:5}),e.functions.featuresetbyname=function(t,n){return e.standardFunctionAsync(t,n,((e,r,a)=>{if(l.pcCheck(a,2,4,t,n),l.isFeatureSetCollection(a[0])){const e=l.toString(a[1]);let r=l.defaultUndefined(a[2],null);const o=l.toBoolean(l.defaultUndefined(a[3],!0));if(null===r&&(r=["*"]),!1===l.isArray(r))throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n);return a[0].featureSetByName(e,o,r)}throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n)}))},e.signatures.push({name:"featuresetbyname",min:2,max:4}),e.functions.featureset=function(t,n){return e.standardFunction(t,n,((e,a,o)=>{l.pcCheck(o,1,1,t,n);const s={layerDefinition:{geometryType:"",objectIdField:"",globalIdField:"",typeIdField:"",hasM:!1,hasZ:!1,fields:[]},featureSet:{geometryType:"",features:[]}};if(l.isString(o[0])){const e=JSON.parse(o[0]);void 0!==e.layerDefinition?(s.layerDefinition=e.layerDefinition,s.featureSet=e.featureSet,e.layerDefinition.spatialReference&&(s.layerDefinition.spatialReference=e.layerDefinition.spatialReference)):(s.featureSet.features=e.features,s.featureSet.geometryType=e.geometryType,s.layerDefinition.geometryType=s.featureSet.geometryType,s.layerDefinition.objectIdField=e.objectIdFieldName??"",s.layerDefinition.typeIdField=e.typeIdFieldName,s.layerDefinition.globalIdField=e.globalIdFieldName,s.layerDefinition.fields=e.fields,e.spatialReference&&(s.layerDefinition.spatialReference=e.spatialReference))}else{if(!(o[0]instanceof r))throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n);{const e=JSON.parse(o[0].castToText(!0)),r=T(e,"layerdefinition");if(null!==r){s.layerDefinition.geometryType=T(r,"geometrytype",""),s.featureSet.geometryType=s.layerDefinition.geometryType,s.layerDefinition.globalIdField=T(r,"globalidfield",""),s.layerDefinition.objectIdField=T(r,"objectidfield",""),s.layerDefinition.typeIdField=T(r,"typeidfield",""),s.layerDefinition.hasZ=!0===T(r,"hasz",!1),s.layerDefinition.hasM=!0===T(r,"hasm",!1);const t=T(r,"spatialreference");t&&(s.layerDefinition.spatialReference=N(t));const n=[];for(const e of T(r,"fields",[])){const t={name:T(e,"name",""),alias:T(e,"alias",""),type:T(e,"type",""),nullable:T(e,"nullable",!0),editable:T(e,"editable",!0),length:T(e,"length",null),domain:b(T(e,"domain"))};n.push(t)}s.layerDefinition.fields=n;const i=T(e,"featureset");if(i){const e={};for(const t of n)e[t.name.toLowerCase()]=t.name;for(const t of T(i,"features",[])){const n={},r=T(t,"attributes",{});for(const t in r)n[e[t.toLowerCase()]]=r[t];s.featureSet.features.push({attributes:n,geometry:L(T(t,"geometry"))})}}}else{s.layerDefinition.hasZ=!0===T(e,"hasz",!1),s.layerDefinition.hasM=!0===T(e,"hasm",!1),s.layerDefinition.geometryType=T(e,"geometrytype",""),s.featureSet.geometryType=s.layerDefinition.geometryType,s.layerDefinition.objectIdField=T(e,"objectidfieldname",""),s.layerDefinition.typeIdField=T(e,"typeidfieldname","");const r=T(e,"spatialreference");r&&(s.layerDefinition.spatialReference=N(r));const a=[],o=T(e,"fields",null);if(!l.isArray(o))throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n);for(const e of o){const t={name:T(e,"name",""),alias:T(e,"alias",""),type:T(e,"type",""),nullable:T(e,"nullable",!0),editable:T(e,"editable",!0),length:T(e,"length",null),domain:b(T(e,"domain"))};a.push(t)}s.layerDefinition.fields=a;const u={};for(const e of a)u[e.name.toLowerCase()]=e.name;let d=T(e,"features",null);if(l.isArray(d))for(const e of d){const t={},n=T(e,"attributes",{});for(const e in n)t[u[e.toLowerCase()]]=n[e];s.featureSet.features.push({attributes:t,geometry:L(T(e,"geometry",null))})}else d=null,s.featureSet.features=d}}}if(!1===v(s))throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n);return s.layerDefinition.geometryType||(s.layerDefinition.geometryType="esriGeometryNull"),p.create(s,t.spatialReference)}))},e.signatures.push({name:"featureset",min:1,max:1}),e.functions.filter=function(t,n){return e.standardFunctionAsync(t,n,(async(r,a,o)=>{if(l.pcCheck(o,2,2,t,n),l.isArray(o[0])||l.isImmutableArray(o[0])){const e=[];let r,a=o[0];if(a instanceof s&&(a=a.toArray()),!l.isFunctionParameter(o[1]))throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n);r=o[1].createFunction(t);for(const t of a){const n=r(t);w.isPromiseLike(n)?!0===await n&&e.push(t):!0===n&&e.push(t)}return e}if(l.isFeatureSet(o[0])){const n=await o[0].load(),r=x.WhereClause.create(o[1],{fieldsIndex:n.getFieldsIndex(),timeZone:n.dateFieldsTimeZoneDefaultUTC}),i=r.getVariables();if(i.length>0){const n=[];for(let r=0;r<i.length;r++){const a={name:i[r]};n.push(await e.evaluateIdentifier(t,a))}const a={};for(let e=0;e<i.length;e++)a[i[e]]=n[e];return r.parameters=a,new c({parentfeatureset:o[0],whereclause:r})}return new c({parentfeatureset:o[0],whereclause:r})}throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n)}))},e.signatures.push({name:"filter",min:2,max:2}),e.functions.orderby=function(t,n){return e.standardFunctionAsync(t,n,(async(e,r,a)=>{if(l.pcCheck(a,2,2,t,n),l.isFeatureSet(a[0])){const e=new y(a[1]);return new f({parentfeatureset:a[0],orderbyclause:e})}throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n)}))},e.signatures.push({name:"orderby",min:2,max:2}),e.functions.top=function(t,n){return e.standardFunctionAsync(t,n,(async(e,r,a)=>{if(l.pcCheck(a,2,2,t,n),l.isFeatureSet(a[0]))return new m({parentfeatureset:a[0],topnum:a[1]});if(l.isArray(a[0]))return l.toNumber(a[1])>=a[0].length?a[0].slice():a[0].slice(0,l.toNumber(a[1]));if(l.isImmutableArray(a[0]))return l.toNumber(a[1])>=a[0].length()?a[0].slice():a[0].slice(0,l.toNumber(a[1]));throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n)}))},e.signatures.push({name:"top",min:2,max:2}),e.functions.first=function(t,n){return e.standardFunctionAsync(t,n,(async(e,r,i)=>{if(l.pcCheck(i,1,1,t,n),l.isFeatureSet(i[0])){const n=await i[0].first(e.abortSignal);if(null!==n){const e=a.createFromGraphicLikeObject(n.geometry,n.attributes,i[0],t.timeZone);return e._underlyingGraphic=n,e}return n}return l.isArray(i[0])?0===i[0].length?null:i[0][0]:l.isImmutableArray(i[0])?0===i[0].length()?null:i[0].get(0):null}))},e.signatures.push({name:"first",min:1,max:1}),e.functions.attachments=function(t,n){return e.standardFunctionAsync(t,n,(async(e,a,s)=>{l.pcCheck(s,1,2,t,n);const u={minsize:-1,maxsize:-1,types:null,returnMetadata:!1};if(s.length>1)if(s[1]instanceof r){if(s[1].hasField("minsize")&&(u.minsize=l.toNumber(s[1].field("minsize"))),s[1].hasField("metadata")&&(u.returnMetadata=l.toBoolean(s[1].field("metadata"))),s[1].hasField("maxsize")&&(u.maxsize=l.toNumber(s[1].field("maxsize"))),s[1].hasField("types")){const e=l.toStringArray(s[1].field("types"),!1);e.length>0&&(u.types=e)}}else if(null!==s[1])throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n);if(l.isFeature(s[0])){let e=s[0]._layer;return e instanceof I&&(e=o.constructFeatureSet(e,t.spatialReference,["*"],!0,t.lrucache,t.interceptor)),null===e?[]:!1===l.isFeatureSet(e)?[]:(await e.load(),e.queryAttachments(s[0].field(e.objectIdField),u.minsize,u.maxsize,u.types,u.returnMetadata))}if(null===s[0])return[];throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n)}))},e.signatures.push({name:"attachments",min:1,max:2}),e.functions.featuresetbyrelationshipname=function(t,n){return e.standardFunctionAsync(t,n,(async(e,r,a)=>{l.pcCheck(a,2,4,t,n);const s=a[0],u=l.toString(a[1]);let d=l.defaultUndefined(a[2],null);const c=l.toBoolean(l.defaultUndefined(a[3],!0));if(null===d&&(d=["*"]),!1===l.isArray(d))throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n);if(null===a[0])return null;if(!l.isFeature(a[0]))throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n);let f=s._layer;if(f instanceof I&&(f=o.constructFeatureSet(f,t.spatialReference,["*"],!0,t.lrucache,t.interceptor)),null===f)return null;if(!1===l.isFeatureSet(f))return null;f=await f.load();const m=f.relationshipMetaData().filter((e=>e.name===u));if(0===m.length)return null;if(void 0!==m[0].relationshipTableId&&null!==m[0].relationshipTableId&&m[0].relationshipTableId>-1)return o.constructFeatureSetFromRelationship(f,m[0],s.field(f.objectIdField),f.spatialReference,d,c,t.lrucache,t.interceptor);let p=f.serviceUrl();if(!p)return null;p="/"===p.charAt(p.length-1)?p+m[0].relatedTableId.toString():p+"/"+m[0].relatedTableId.toString();const y=await o.constructFeatureSetFromUrl(p,f.spatialReference,d,c,t.lrucache,t.interceptor);await y.load();let h=y.relationshipMetaData();if(h=h.filter((e=>e.id===m[0].id)),!1===s.hasField(m[0].keyField)||null===s.field(m[0].keyField)){const e=await f.getFeatureByObjectId(s.field(f.objectIdField),[m[0].keyField]);if(e){const t=x.WhereClause.create(h[0].keyField+"= @id",{fieldsIndex:y.getFieldsIndex(),timeZone:y.dateFieldsTimeZoneDefaultUTC});return t.parameters={id:e.attributes[m[0].keyField]},y.filter(t)}return new E({parentfeatureset:y})}const F=x.WhereClause.create(h[0].keyField+"= @id",{fieldsIndex:y.getFieldsIndex(),timeZone:y.dateFieldsTimeZoneDefaultUTC});return F.parameters={id:s.field(m[0].keyField)},y.filter(F)}))},e.signatures.push({name:"featuresetbyrelationshipname",min:2,max:4}),e.functions.featuresetbyassociation=function(t,n){return e.standardFunctionAsync(t,n,(async(e,r,a)=>{l.pcCheck(a,2,3,t,n);const s=a[0],u=l.toString(l.defaultUndefined(a[1],"")).toLowerCase(),c=l.isString(a[2])?l.toString(a[2]):null;if(null===a[0])return null;if(!l.isFeature(a[0]))throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n);let f=s._layer;if(f instanceof I&&(f=o.constructFeatureSet(f,t.spatialReference,["*"],!0,t.lrucache,t.interceptor)),null===f)return null;if(!1===l.isFeatureSet(f))return null;await f.load();const m=f.serviceUrl(),E=await o.constructAssociationMetaDataFeatureSetFromUrl(m,t.spatialReference);let p=null,y=null,F=!1;if(null!==c&&""!==c&&void 0!==c){for(const e of E.terminals)e.terminalName===c&&(y=e.terminalId);null===y&&(F=!0)}const g=E.associations.getFieldsIndex(),w=g.get("TOGLOBALID").name,C=g.get("FROMGLOBALID").name,S=g.get("TOTERMINALID").name,D=g.get("FROMTERMINALID").name,T=g.get("FROMNETWORKSOURCEID").name,b=g.get("TONETWORKSOURCEID").name,N=g.get("ASSOCIATIONTYPE").name,L=g.get("ISCONTENTVISIBLE").name,Z=g.get("OBJECTID").name;for(const t of f.fields)if("global-id"===t.type){p=s.field(t.name);break}let v=null,$=new d.SqlExpressionAdapted(new A({name:"percentalong",alias:"percentalong",type:"double"}),x.WhereClause.create("0",{fieldsIndex:E.associations.getFieldsIndex(),timeZone:E.associations.dateFieldsTimeZoneDefaultUTC})),P=new d.SqlExpressionAdapted(new A({name:"side",alias:"side",type:"string"}),x.WhereClause.create("''",{fieldsIndex:E.associations.getFieldsIndex(),timeZone:E.associations.dateFieldsTimeZoneDefaultUTC}));const U="globalid",k="globalId",R={};for(const t in E.lkp)R[t]=E.lkp[t].sourceId;const W=new d.StringToCodeAdapted(new A({name:"classname",alias:"classname",type:"string"}),null,R);let M="";switch(u){case"midspan":{M=`((${w}='${p}') OR ( ${C}='${p}')) AND (${N} IN (5))`,W.codefield=x.WhereClause.create(`CASE WHEN (${w}='${p}') THEN ${T} ELSE ${b} END`,{fieldsIndex:E.associations.getFieldsIndex(),timeZone:E.associations.dateFieldsTimeZoneDefaultUTC});const e=h.cloneField(d.AdaptedFeatureSet.findField(E.associations.fields,C));e.name=U,e.alias=U,v=new d.SqlExpressionAdapted(e,x.WhereClause.create(`CASE WHEN (${C}='${p}') THEN ${w} ELSE ${C} END`,{fieldsIndex:E.associations.getFieldsIndex(),timeZone:E.associations.dateFieldsTimeZoneDefaultUTC})),$=E.unVersion>=4?new d.OriginalField(d.AdaptedFeatureSet.findField(E.associations.fields,g.get("PERCENTALONG").name)):new d.SqlExpressionAdapted(new A({name:"percentalong",alias:"percentalong",type:"double"}),x.WhereClause.create("0",{fieldsIndex:E.associations.getFieldsIndex(),timeZone:E.associations.dateFieldsTimeZoneDefaultUTC}));break}case"junctionedge":{M=`((${w}='${p}') OR ( ${C}='${p}')) AND (${N} IN (4,6))`,W.codefield=x.WhereClause.create(`CASE WHEN (${w}='${p}') THEN ${T} ELSE ${b} END`,{fieldsIndex:E.associations.getFieldsIndex(),timeZone:E.associations.dateFieldsTimeZoneDefaultUTC});const e=h.cloneField(d.AdaptedFeatureSet.findField(E.associations.fields,C));e.name=U,e.alias=U,v=new d.SqlExpressionAdapted(e,x.WhereClause.create(`CASE WHEN (${C}='${p}') THEN ${w} ELSE ${C} END`,{fieldsIndex:E.associations.getFieldsIndex(),timeZone:E.associations.dateFieldsTimeZoneDefaultUTC})),P=new d.SqlExpressionAdapted(new A({name:"side",alias:"side",type:"string"}),x.WhereClause.create(`CASE WHEN (${N}=4) THEN 'from' ELSE 'to' END`,{fieldsIndex:E.associations.getFieldsIndex(),timeZone:E.associations.dateFieldsTimeZoneDefaultUTC}));break}case"connected":{let e=`${w}='@T'`,t=`${C}='@T'`;null!==y&&(e+=` AND ${S}=@A`,t+=` AND ${D}=@A`),M="(("+e+") OR ("+t+"))",M=l.multiReplace(M,"@T",p??""),e=l.multiReplace(e,"@T",p??""),null!==y&&(e=l.multiReplace(e,"@A",y.toString()),M=l.multiReplace(M,"@A",y.toString())),W.codefield=x.WhereClause.create("CASE WHEN "+e+` THEN ${T} ELSE ${b} END`,{fieldsIndex:E.associations.getFieldsIndex(),timeZone:E.associations.dateFieldsTimeZoneDefaultUTC});const n=h.cloneField(d.AdaptedFeatureSet.findField(E.associations.fields,C));n.name=U,n.alias=U,v=new d.SqlExpressionAdapted(n,x.WhereClause.create("CASE WHEN "+e+` THEN ${C} ELSE ${w} END`,{fieldsIndex:E.associations.getFieldsIndex(),timeZone:E.associations.dateFieldsTimeZoneDefaultUTC}));break}case"container":M=`${w}='${p}' AND ${N} = 2`,null!==y&&(M+=` AND ${S} = `+y.toString()),W.codefield=T,M="( "+M+" )",v=new d.FieldRename(d.AdaptedFeatureSet.findField(E.associations.fields,C),U,U);break;case"content":M=`(${C}='${p}' AND ${N} = 2)`,null!==y&&(M+=` AND ${D} = `+y.toString()),W.codefield=b,M="( "+M+" )",v=new d.FieldRename(d.AdaptedFeatureSet.findField(E.associations.fields,w),U,U);break;case"structure":M=`(${w}='${p}' AND ${N} = 3)`,null!==y&&(M+=` AND ${S} = `+y.toString()),W.codefield=T,M="( "+M+" )",v=new d.FieldRename(d.AdaptedFeatureSet.findField(E.associations.fields,C),U,k);break;case"attached":M=`(${C}='${p}' AND ${N} = 3)`,null!==y&&(M+=` AND ${D} = `+y.toString()),W.codefield=b,M="( "+M+" )",v=new d.FieldRename(d.AdaptedFeatureSet.findField(E.associations.fields,w),U,k);break;default:throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n)}F&&(M="1 <> 1");return new d.AdaptedFeatureSet({parentfeatureset:E.associations,adaptedFields:[new d.OriginalField(d.AdaptedFeatureSet.findField(E.associations.fields,Z)),new d.OriginalField(d.AdaptedFeatureSet.findField(E.associations.fields,L)),v,P,W,$],extraFilter:M?x.WhereClause.create(M,{fieldsIndex:E.associations.getFieldsIndex(),timeZone:E.associations.dateFieldsTimeZoneDefaultUTC}):null})}))},e.signatures.push({name:"featuresetbyassociation",min:2,max:6}),e.functions.groupby=function(t,n){return e.standardFunctionAsync(t,n,(async(a,o,s)=>{if(l.pcCheck(s,3,3,t,n),!l.isFeatureSet(s[0]))throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n);const u=await s[0].load(),d=[],c=[];let f=!1,m=[];if(l.isString(s[1]))m.push(s[1]);else if(s[1]instanceof r)m.push(s[1]);else if(l.isArray(s[1]))m=s[1];else{if(!l.isImmutableArray(s[1]))throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n);m=s[1].toArray()}for(const e of m)if(l.isString(e)){const t=x.WhereClause.create(l.toString(e),{fieldsIndex:u.getFieldsIndex(),timeZone:u.dateFieldsTimeZoneDefaultUTC}),n=!0===F.isSingleField(t)?l.toString(e):"%%%%FIELDNAME";d.push({name:n,expression:t}),"%%%%FIELDNAME"===n&&(f=!0)}else{if(!(e instanceof r))throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n);{const r=e.hasField("name")?e.field("name"):"%%%%FIELDNAME",a=e.hasField("expression")?e.field("expression"):"";if("%%%%FIELDNAME"===r&&(f=!0),!r)throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n);d.push({name:r,expression:x.WhereClause.create(a||r,{fieldsIndex:u.getFieldsIndex(),timeZone:u.dateFieldsTimeZoneDefaultUTC})})}}if(m=[],l.isString(s[2]))m.push(s[2]);else if(l.isArray(s[2]))m=s[2];else if(l.isImmutableArray(s[2]))m=s[2].toArray();else{if(!(s[2]instanceof r))throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n);m.push(s[2])}for(const e of m){if(!(e instanceof r))throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n);{const r=e.hasField("name")?e.field("name"):"",a=e.hasField("statistic")?e.field("statistic"):"",o=e.hasField("expression")?e.field("expression"):"";if(!r||!a||!o)throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n);c.push({name:r,statistic:a.toLowerCase(),expression:x.WhereClause.create(o,{fieldsIndex:u.getFieldsIndex(),timeZone:u.dateFieldsTimeZoneDefaultUTC})})}}if(f){const e={};for(const n of u.fields)e[n.name.toLowerCase()]=1;for(const n of d)"%%%%FIELDNAME"!==n.name&&(e[n.name.toLowerCase()]=1);for(const n of c)"%%%%FIELDNAME"!==n.name&&(e[n.name.toLowerCase()]=1);let t=0;for(const n of d)if("%%%%FIELDNAME"===n.name){for(;1===e["field_"+t.toString()];)t++;e["field_"+t.toString()]=1,n.name="FIELD_"+t.toString()}}for(const n of d)await D(n.expression,e,t);for(const n of c)await D(n.expression,e,t);return s[0].groupby(d,c)}))},e.signatures.push({name:"groupby",min:3,max:3}),e.functions.distinct=function(t,n){return e.standardFunctionAsync(t,n,(async(a,o,s)=>{if(l.isFeatureSet(s[0])){l.pcCheck(s,2,2,t,n);const a=await s[0].load(),o=[];let u=[];if(l.isString(s[1]))u.push(s[1]);else if(s[1]instanceof r)u.push(s[1]);else if(l.isArray(s[1]))u=s[1];else{if(!l.isImmutableArray(s[1]))throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n);u=s[1].toArray()}let d=!1;for(const e of u)if(l.isString(e)){const t=x.WhereClause.create(l.toString(e),{fieldsIndex:a.getFieldsIndex(),timeZone:a.dateFieldsTimeZoneDefaultUTC}),n=!0===F.isSingleField(t)?l.toString(e):"%%%%FIELDNAME";o.push({name:n,expression:t}),"%%%%FIELDNAME"===n&&(d=!0)}else{if(!(e instanceof r))throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n);{const r=e.hasField("name")?e.field("name"):"%%%%FIELDNAME",s=e.hasField("expression")?e.field("expression"):"";if("%%%%FIELDNAME"===r&&(d=!0),!r)throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n);o.push({name:r,expression:x.WhereClause.create(s||r,{fieldsIndex:a.getFieldsIndex(),timeZone:a.dateFieldsTimeZoneDefaultUTC})})}}if(d){const e={};for(const n of a.fields)e[n.name.toLowerCase()]=1;for(const n of o)"%%%%FIELDNAME"!==n.name&&(e[n.name.toLowerCase()]=1);let t=0;for(const n of o)if("%%%%FIELDNAME"===n.name){for(;1===e["field_"+t.toString()];)t++;e["field_"+t.toString()]=1,n.name="FIELD_"+t.toString()}}for(const n of o)await D(n.expression,e,t);return s[0].groupby(o,[])}return S(s)}))},e.functions.getfeaturesetinfo=function(t,n){return e.standardFunctionAsync(t,n,(async(e,i,a)=>{if(l.pcCheck(a,1,1,t,n),!l.isFeatureSet(a[0]))return null;const o=await a[0].getFeatureSetInfo();return o?r.convertObjectToArcadeDictionary({layerId:o.layerId,layerName:o.layerName,itemId:o.itemId,serviceLayerUrl:o.serviceLayerUrl,webMapLayerId:o.webMapLayerId??null,webMapLayerTitle:o.webMapLayerTitle??null,className:null,objectClassId:null},l.defaultTimeZone(t),!1,!1):null}))},e.signatures.push({name:"getfeaturesetinfo",min:1,max:1}),e.functions.filterbysubtypecode=function(t,n){return e.standardFunctionAsync(t,n,(async(e,r,a)=>{if(l.pcCheck(a,2,2,t,n),l.isFeatureSet(a[0])){const e=await a[0].load(),r=a[1];if(!l.isInteger(r))throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n);if(e.subtypeField){const t=x.WhereClause.create(`${e.subtypeField}= ${a[1]}`,{fieldsIndex:e.getFieldsIndex(),timeZone:e.dateFieldsTimeZoneDefaultUTC});return new c({parentfeatureset:a[0],whereclause:t})}if(null===e.typeIdField||""===e.typeIdField)throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.FeatureSetDoesNotHaveSubtypes,n);const o=x.WhereClause.create(`${e.typeIdField}= ${a[1]}`,{fieldsIndex:e.getFieldsIndex(),timeZone:e.dateFieldsTimeZoneDefaultUTC});return new c({parentfeatureset:a[0],whereclause:o})}throw new i.ArcadeExecutionError(t,i.ExecutionErrorCodes.InvalidParameter,n)}))},e.signatures.push({name:"filterbysubtypecode",min:2,max:2}))}e.registerFunctions=P,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
