/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../ArcadePortal","../Dictionary","../executionError","../kernel","../../chunks/languageUtils","../portalUtils","./centroid","./measures","../../core/unitUtils","../../geometry/Extent","../../geometry/Geometry","../../geometry/geometryEngineAsync","../../geometry/Multipoint","../../geometry/Point","../../geometry/Polygon","../../geometry/Polyline","../../geometry/support/jsonUtils","../../portal/Portal","../../portal/support/utils"],(function(e,n,r,t,o,a,i,c,u,s,l,d,f,E,m,y,C,h,A,x){"use strict";function w(e,n,r){if(a.pcCheck(e,2,2,n,r),e[0]instanceof d&&e[1]instanceof d);else if(e[0]instanceof d&&null===e[1]);else if(e[1]instanceof d&&null===e[0]);else if(null!==e[0]||null!==e[1])throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r)}async function p(e,n){if("polygon"!==e.type&&"polyline"!==e.type&&"extent"!==e.type)return 0;let r=1;if(e.spatialReference.vcsWkid||e.spatialReference.latestVcsWkid){r=c.getMetersPerVerticalUnitForSR(e.spatialReference)/s.getMetersPerUnitForSR(e.spatialReference)}let t=0;if("polyline"===e.type)for(const a of e.paths)for(let e=1;e<a.length;e++)t+=c.segmentLength3d(a[e],a[e-1],r);else if("polygon"===e.type)for(const a of e.rings){for(let e=1;e<a.length;e++)t+=c.segmentLength3d(a[e],a[e-1],r);(a[0][0]!==a[a.length-1][0]||a[0][1]!==a[a.length-1][1]||void 0!==a[0][2]&&a[0][2]!==a[a.length-1][2])&&(t+=c.segmentLength3d(a[0],a[a.length-1],r))}else"extent"===e.type&&(t+=2*c.segmentLength3d([e.xmin,e.ymin,0],[e.xmax,e.ymin,0],r),t+=2*c.segmentLength3d([e.xmin,e.ymin,0],[e.xmin,e.ymax,0],r),t*=2,t+=4*Math.abs(a.defaultUndefined(e.zmax,0)*r-a.defaultUndefined(e.zmin,0)*r));const o=new C({hasZ:!1,hasM:!1,spatialReference:e.spatialReference,paths:[[[0,0],[0,t]]]});return f.planarLength(o,n)}function g(e){"async"===e.mode&&(e.functions.disjoint=function(n,r){return e.standardFunctionAsync(n,r,((e,t,o)=>(w(o=a.autoCastFeatureToGeometry(o),n,r),null===o[0]||null===o[1]||f.disjoint(o[0],o[1]))))},e.functions.intersects=function(n,r){return e.standardFunctionAsync(n,r,((e,t,o)=>(w(o=a.autoCastFeatureToGeometry(o),n,r),null!==o[0]&&null!==o[1]&&f.intersects(o[0],o[1]))))},e.functions.touches=function(n,r){return e.standardFunctionAsync(n,r,((e,t,o)=>(w(o=a.autoCastFeatureToGeometry(o),n,r),null!==o[0]&&null!==o[1]&&f.touches(o[0],o[1]))))},e.functions.crosses=function(n,r){return e.standardFunctionAsync(n,r,((e,t,o)=>(w(o=a.autoCastFeatureToGeometry(o),n,r),null!==o[0]&&null!==o[1]&&f.crosses(o[0],o[1]))))},e.functions.within=function(n,r){return e.standardFunctionAsync(n,r,((e,t,o)=>(w(o=a.autoCastFeatureToGeometry(o),n,r),null!==o[0]&&null!==o[1]&&f.within(o[0],o[1]))))},e.functions.contains=function(n,r){return e.standardFunctionAsync(n,r,((e,t,o)=>(w(o=a.autoCastFeatureToGeometry(o),n,r),null!==o[0]&&null!==o[1]&&f.contains(o[0],o[1]))))},e.functions.overlaps=function(n,r){return e.standardFunctionAsync(n,r,((e,t,o)=>(w(o=a.autoCastFeatureToGeometry(o),n,r),null!==o[0]&&null!==o[1]&&f.overlaps(o[0],o[1]))))},e.functions.equals=function(n,r){return e.standardFunctionAsync(n,r,((e,t,o)=>(a.pcCheck(o,2,2,n,r),o[0]===o[1]||(o[0]instanceof d&&o[1]instanceof d?f.equals(o[0],o[1]):(a.isDate(o[0])&&a.isDate(o[1])||!!(a.isTime(o[0])&&a.isTime(o[1])||a.isDateOnly(o[0])&&a.isDateOnly(o[1])))&&o[0].equals(o[1])))))},e.functions.relate=function(n,r){return e.standardFunctionAsync(n,r,((e,o,i)=>{if(i=a.autoCastFeatureToGeometry(i),a.pcCheck(i,3,3,n,r),i[0]instanceof d&&i[1]instanceof d)return f.relate(i[0],i[1],a.toString(i[2]));if(i[0]instanceof d&&null===i[1])return!1;if(i[1]instanceof d&&null===i[0])return!1;if(null===i[0]&&null===i[1])return!1;throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r)}))},e.functions.intersection=function(n,r){return e.standardFunctionAsync(n,r,((e,t,o)=>(w(o=a.autoCastFeatureToGeometry(o),n,r),null===o[0]||null===o[1]?null:f.intersect(o[0],o[1]))))},e.functions.union=function(n,r){return e.standardFunctionAsync(n,r,((e,i,c)=>{const u=[];if(0===(c=a.autoCastFeatureToGeometry(c)).length)throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.WrongNumberOfParameters,r);if(1===c.length)if(a.isArray(c[0])){const e=a.autoCastFeatureToGeometry(c[0]);for(let o=0;o<e.length;o++)if(null!==e[o]){if(!(e[o]instanceof d))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);u.push(e[o])}}else{if(!a.isImmutableArray(c[0])){if(c[0]instanceof d)return a.fixSpatialReference(o.cloneGeometry(c[0]),n.spatialReference);if(null===c[0])return null;throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r)}{const e=a.autoCastFeatureToGeometry(c[0].toArray());for(let o=0;o<e.length;o++)if(null!==e[o]){if(!(e[o]instanceof d))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);u.push(e[o])}}}else for(let o=0;o<c.length;o++)if(null!==c[o]){if(!(c[o]instanceof d))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);u.push(c[o])}return 0===u.length?null:f.union(u)}))},e.functions.difference=function(n,r){return e.standardFunctionAsync(n,r,((e,t,i)=>(w(i=a.autoCastFeatureToGeometry(i),n,r),null===i[0]?null:null===i[1]?o.cloneGeometry(i[0]):f.difference(i[0],i[1]))))},e.functions.symmetricdifference=function(n,r){return e.standardFunctionAsync(n,r,((e,t,i)=>(w(i=a.autoCastFeatureToGeometry(i),n,r),null===i[0]&&null===i[1]?null:null===i[0]?o.cloneGeometry(i[1]):null===i[1]?o.cloneGeometry(i[0]):f.symmetricDifference(i[0],i[1]))))},e.functions.clip=function(n,r){return e.standardFunctionAsync(n,r,((e,o,i)=>{if(i=a.autoCastFeatureToGeometry(i),a.pcCheck(i,2,2,n,r),!(i[1]instanceof l)&&null!==i[1])throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);if(null===i[0])return null;if(!(i[0]instanceof d))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);return null===i[1]?null:f.clip(i[0],i[1])}))},e.functions.cut=function(n,r){return e.standardFunctionAsync(n,r,((e,i,c)=>{if(c=a.autoCastFeatureToGeometry(c),a.pcCheck(c,2,2,n,r),!(c[1]instanceof C)&&null!==c[1])throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);if(null===c[0])return[];if(!(c[0]instanceof d))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);return null===c[1]?[o.cloneGeometry(c[0])]:f.cut(c[0],c[1])}))},e.functions.area=function(n,r){return e.standardFunctionAsync(n,r,(async(e,i,c)=>{if(a.pcCheck(c,1,2,n,r),null===(c=a.autoCastFeatureToGeometry(c))[0])return 0;if(a.isFeatureSet(c[0])){const e=await c[0].sumArea(o.convertSquareUnitsToCode(a.defaultUndefined(c[1],-1)),!1,n.abortSignal);if(n.abortSignal.aborted)throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.Cancelled,r);return e}if(a.isArray(c[0])||a.isImmutableArray(c[0])){const e=a.autoCastArrayOfPointsToPolygon(c[0],n.spatialReference);return null===e?0:f.planarArea(e,o.convertSquareUnitsToCode(a.defaultUndefined(c[1],-1)))}if(!(c[0]instanceof d))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);return f.planarArea(c[0],o.convertSquareUnitsToCode(a.defaultUndefined(c[1],-1)))}))},e.functions.areageodetic=function(n,r){return e.standardFunctionAsync(n,r,(async(e,i,c)=>{if(a.pcCheck(c,1,2,n,r),null===(c=a.autoCastFeatureToGeometry(c))[0])return 0;if(a.isFeatureSet(c[0])){const e=await c[0].sumArea(o.convertSquareUnitsToCode(a.defaultUndefined(c[1],-1)),!0,n.abortSignal);if(n.abortSignal.aborted)throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.Cancelled,r);return e}if(a.isArray(c[0])||a.isImmutableArray(c[0])){const e=a.autoCastArrayOfPointsToPolygon(c[0],n.spatialReference);return null===e?0:f.geodesicArea(e,o.convertSquareUnitsToCode(a.defaultUndefined(c[1],-1)))}if(!(c[0]instanceof d))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);return f.geodesicArea(c[0],o.convertSquareUnitsToCode(a.defaultUndefined(c[1],-1)))}))},e.functions.length=function(n,r){return e.standardFunctionAsync(n,r,(async(e,i,c)=>{if(a.pcCheck(c,1,2,n,r),null===(c=a.autoCastFeatureToGeometry(c))[0])return 0;if(a.isFeatureSet(c[0])){const e=await c[0].sumLength(o.convertLinearUnitsToCode(a.defaultUndefined(c[1],-1)),!1,n.abortSignal);if(n.abortSignal.aborted)throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.Cancelled,r);return e}if(a.isArray(c[0])||a.isImmutableArray(c[0])){const e=a.autoCastArrayOfPointsToPolyline(c[0],n.spatialReference);return null===e?0:f.planarLength(e,o.convertLinearUnitsToCode(a.defaultUndefined(c[1],-1)))}if(!(c[0]instanceof d))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);return f.planarLength(c[0],o.convertLinearUnitsToCode(a.defaultUndefined(c[1],-1)))}))},e.functions.length3d=function(n,r){return e.standardFunctionAsync(n,r,((e,i,c)=>{if(a.pcCheck(c,1,2,n,r),null===(c=a.autoCastFeatureToGeometry(c))[0])return 0;if(a.isArray(c[0])||a.isImmutableArray(c[0])){const e=a.autoCastArrayOfPointsToPolyline(c[0],n.spatialReference);return null===e?0:!0===e.hasZ?p(e,o.convertLinearUnitsToCode(a.defaultUndefined(c[1],-1))):f.planarLength(e,o.convertLinearUnitsToCode(a.defaultUndefined(c[1],-1)))}if(!(c[0]instanceof d))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);return!0===c[0].hasZ?p(c[0],o.convertLinearUnitsToCode(a.defaultUndefined(c[1],-1))):f.planarLength(c[0],o.convertLinearUnitsToCode(a.defaultUndefined(c[1],-1)))}))},e.functions.lengthgeodetic=function(n,r){return e.standardFunctionAsync(n,r,(async(e,i,c)=>{if(a.pcCheck(c,1,2,n,r),null===(c=a.autoCastFeatureToGeometry(c))[0])return 0;if(a.isFeatureSet(c[0])){const e=await c[0].sumLength(o.convertLinearUnitsToCode(a.defaultUndefined(c[1],-1)),!0,n.abortSignal);if(n.abortSignal.aborted)throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.Cancelled,r);return e}if(a.isArray(c[0])||a.isImmutableArray(c[0])){const e=a.autoCastArrayOfPointsToPolyline(c[0],n.spatialReference);return null===e?0:f.geodesicLength(e,o.convertLinearUnitsToCode(a.defaultUndefined(c[1],-1)))}if(!(c[0]instanceof d))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);return f.geodesicLength(c[0],o.convertLinearUnitsToCode(a.defaultUndefined(c[1],-1)))}))},e.functions.distance=function(n,r){return e.standardFunctionAsync(n,r,((e,i,c)=>{c=a.autoCastFeatureToGeometry(c),a.pcCheck(c,2,3,n,r);let u=c[0];(a.isArray(c[0])||a.isImmutableArray(c[0]))&&(u=a.autoCastArrayOfPointsToMultiPoint(c[0],n.spatialReference));let s=c[1];if((a.isArray(c[1])||a.isImmutableArray(c[1]))&&(s=a.autoCastArrayOfPointsToMultiPoint(c[1],n.spatialReference)),!(u instanceof d))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);if(!(s instanceof d))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);return f.distance(u,s,o.convertLinearUnitsToCode(a.defaultUndefined(c[2],-1)))}))},e.functions.distancegeodetic=function(n,r){return e.standardFunctionAsync(n,r,((e,i,c)=>{c=a.autoCastFeatureToGeometry(c),a.pcCheck(c,2,3,n,r);const u=c[0],s=c[1];if(!(u instanceof m))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);if(!(s instanceof m))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);const l=new C({paths:[],spatialReference:u.spatialReference});return l.addPath([u,s]),f.geodesicLength(l,o.convertLinearUnitsToCode(a.defaultUndefined(c[2],-1)))}))},e.functions.densify=function(n,r){return e.standardFunctionAsync(n,r,((e,i,c)=>{if(c=a.autoCastFeatureToGeometry(c),a.pcCheck(c,2,3,n,r),null===c[0])return null;if(!(c[0]instanceof d))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);const u=a.toNumber(c[1]);if(isNaN(u))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);if(u<=0)throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);return c[0]instanceof y||c[0]instanceof C?f.densify(c[0],u,o.convertLinearUnitsToCode(a.defaultUndefined(c[2],-1))):c[0]instanceof l?f.densify(y.fromExtent(c[0]),u,o.convertLinearUnitsToCode(a.defaultUndefined(c[2],-1))):c[0]}))},e.functions.densifygeodetic=function(n,r){return e.standardFunctionAsync(n,r,((e,i,c)=>{if(c=a.autoCastFeatureToGeometry(c),a.pcCheck(c,2,3,n,r),null===c[0])return null;if(!(c[0]instanceof d))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);const u=a.toNumber(c[1]);if(isNaN(u))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);if(u<=0)throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);return c[0]instanceof y||c[0]instanceof C?f.geodesicDensify(c[0],u,o.convertLinearUnitsToCode(a.defaultUndefined(c[2],-1))):c[0]instanceof l?f.geodesicDensify(y.fromExtent(c[0]),u,o.convertLinearUnitsToCode(a.defaultUndefined(c[2],-1))):c[0]}))},e.functions.generalize=function(n,r){return e.standardFunctionAsync(n,r,((e,i,c)=>{if(c=a.autoCastFeatureToGeometry(c),a.pcCheck(c,2,4,n,r),null===c[0])return null;if(!(c[0]instanceof d))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);const u=a.toNumber(c[1]);if(isNaN(u))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);return f.generalize(c[0],u,a.toBoolean(a.defaultUndefined(c[2],!0)),o.convertLinearUnitsToCode(a.defaultUndefined(c[3],-1)))}))},e.functions.buffer=function(n,r){return e.standardFunctionAsync(n,r,((e,i,c)=>{if(c=a.autoCastFeatureToGeometry(c),a.pcCheck(c,2,3,n,r),null===c[0])return null;if(!(c[0]instanceof d))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);const u=a.toNumber(c[1]);if(isNaN(u))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);return 0===u?o.cloneGeometry(c[0]):f.buffer(c[0],u,o.convertLinearUnitsToCode(a.defaultUndefined(c[2],-1)))}))},e.functions.buffergeodetic=function(n,r){return e.standardFunctionAsync(n,r,((e,i,c)=>{if(c=a.autoCastFeatureToGeometry(c),a.pcCheck(c,2,3,n,r),null===c[0])return null;if(!(c[0]instanceof d))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);const u=a.toNumber(c[1]);if(isNaN(u))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);return 0===u?o.cloneGeometry(c[0]):f.geodesicBuffer(c[0],u,o.convertLinearUnitsToCode(a.defaultUndefined(c[2],-1)))}))},e.functions.offset=function(n,r){return e.standardFunctionAsync(n,r,((e,i,c)=>{if(c=a.autoCastFeatureToGeometry(c),a.pcCheck(c,2,6,n,r),null===c[0])return null;if(!(c[0]instanceof y||c[0]instanceof C))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);const u=a.toNumber(c[1]);if(isNaN(u))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);const s=a.toNumber(a.defaultUndefined(c[4],10));if(isNaN(s))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);const l=a.toNumber(a.defaultUndefined(c[5],0));if(isNaN(l))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);return f.offset(c[0],u,o.convertLinearUnitsToCode(a.defaultUndefined(c[2],-1)),a.toString(a.defaultUndefined(c[3],"round")).toLowerCase(),s,l)}))},e.functions.rotate=function(n,r){return e.standardFunctionAsync(n,r,((e,o,i)=>{if(i=a.autoCastFeatureToGeometry(i),a.pcCheck(i,2,3,n,r),null===i[0])return null;if(!(i[0]instanceof d))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);const c=i[0]instanceof l?y.fromExtent(i[0]):i[0],u=a.toNumber(i[1]);if(isNaN(u))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);const s=a.defaultUndefined(i[2],null);if(null===s)return f.rotate(c,u);if(s instanceof m)return f.rotate(c,u,s);throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r)}))},e.functions.centroid=function(n,r){return e.standardFunctionAsync(n,r,((e,i,u)=>{if(u=a.autoCastFeatureToGeometry(u),a.pcCheck(u,1,1,n,r),null===u[0])return null;let s=u[0];if((a.isArray(u[0])||a.isImmutableArray(u[0]))&&(s=a.autoCastArrayOfPointsToMultiPoint(u[0],n.spatialReference)),null===s)return null;if(!(s instanceof d))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);return s instanceof m?a.fixSpatialReference(o.cloneGeometry(s),n.spatialReference):s instanceof y?s.centroid:s instanceof C?c.centroidPolyline(s):s instanceof E?c.centroidMultiPoint(s):s instanceof l?s.center:null}))},e.functions.measuretocoordinate=function(n,o){return e.standardFunctionAsync(n,o,((e,i,c)=>{if(c=a.autoCastFeatureToGeometry(c),a.pcCheck(c,2,2,n,o),null===c[0])return null;let s=c[0];if((a.isArray(c[0])||a.isImmutableArray(c[0]))&&(s=a.autoCastArrayOfPointsToPolyline(c[0],n.spatialReference)),null===s)return null;if(!(s instanceof d))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,o);if(!(s instanceof C))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,o);if(a.isNumber(!1===c[1]))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,o);const l=u.measureToCoordinate(s,c[1]);return l?r.convertObjectToArcadeDictionary(l,a.defaultTimeZone(n),!1,!0):null}))},e.functions.pointtocoordinate=function(n,o){return e.standardFunctionAsync(n,o,((e,i,c)=>{if(c=a.autoCastFeatureToGeometry(c),a.pcCheck(c,2,2,n,o),null===c[0])return null;let s=c[0];if((a.isArray(c[0])||a.isImmutableArray(c[0]))&&(s=a.autoCastArrayOfPointsToPolyline(c[0],n.spatialReference)),null===s)return null;if(!(s instanceof d))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,o);if(!(s instanceof C))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,o);const l=c[1];if(null===l)return null;if(!(l instanceof m))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,o);if(a.isNumber(!1===c[1]))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,o);const f=u.pointToCoordinate(s,l);return f?r.convertObjectToArcadeDictionary(f,a.defaultTimeZone(n),!1,!0):null}))},e.functions.distancetocoordinate=function(n,o){return e.standardFunctionAsync(n,o,((e,i,c)=>{if(c=a.autoCastFeatureToGeometry(c),a.pcCheck(c,2,2,n,o),null===c[0])return null;let s=c[0];if((a.isArray(c[0])||a.isImmutableArray(c[0]))&&(s=a.autoCastArrayOfPointsToPolyline(c[0],n.spatialReference)),null===s)return null;if(!(s instanceof d))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,o);if(!(s instanceof C))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,o);if(a.isNumber(!1===c[1]))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,o);const l=u.distanceToCoordinate(s,c[1]);return l?r.convertObjectToArcadeDictionary(l,a.defaultTimeZone(n),!1,!0):null}))},e.functions.multiparttosinglepart=function(n,r){return e.standardFunctionAsync(n,r,(async(e,i,c)=>{if(c=a.autoCastFeatureToGeometry(c),a.pcCheck(c,1,1,n,r),null===c[0])return null;if(!(c[0]instanceof d))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);if(c[0]instanceof m)return[a.fixSpatialReference(o.cloneGeometry(c[0]),n.spatialReference)];if(c[0]instanceof l)return[a.fixSpatialReference(o.cloneGeometry(c[0]),n.spatialReference)];const u=await f.simplify(c[0]);if(u instanceof y){const e=[],n=[];for(let r=0;r<u.rings.length;r++)if(u.isClockwise(u.rings[r])){const n=h.fromJSON({rings:[u.rings[r]],hasZ:!0===u.hasZ,hasM:!0===u.hasM,spatialReference:u.spatialReference.toJSON()});e.push(n)}else n.push({ring:u.rings[r],pt:u.getPoint(r,0)});for(let r=0;r<n.length;r++)for(let t=0;t<e.length;t++)if(e[t].contains(n[r].pt)){e[t].addRing(n[r].ring);break}return e}if(u instanceof C){const e=[];for(let n=0;n<u.paths.length;n++){const r=h.fromJSON({paths:[u.paths[n]],hasZ:!0===u.hasZ,hasM:!0===u.hasM,spatialReference:u.spatialReference.toJSON()});e.push(r)}return e}if(c[0]instanceof E){const e=[],r=a.fixSpatialReference(o.cloneGeometry(c[0]),n.spatialReference);for(let n=0;n<r.points.length;n++)e.push(r.getPoint(n));return e}return null}))},e.functions.issimple=function(n,r){return e.standardFunctionAsync(n,r,((e,o,i)=>{if(i=a.autoCastFeatureToGeometry(i),a.pcCheck(i,1,1,n,r),null===i[0])return!0;if(!(i[0]instanceof d))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);return f.isSimple(i[0])}))},e.functions.simplify=function(n,r){return e.standardFunctionAsync(n,r,((e,o,i)=>{if(i=a.autoCastFeatureToGeometry(i),a.pcCheck(i,1,1,n,r),null===i[0])return null;if(!(i[0]instanceof d))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);return f.simplify(i[0])}))},e.functions.convexhull=function(n,r){return e.standardFunctionAsync(n,r,((e,o,i)=>{if(i=a.autoCastFeatureToGeometry(i),a.pcCheck(i,1,1,n,r),null===i[0])return null;if(!(i[0]instanceof d))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,r);return f.convexHull(i[0])}))},e.functions.getuser=function(o,c){return e.standardFunctionAsync(o,c,(async(e,u,s)=>{a.pcCheck(s,0,2,o,c);let l=a.defaultUndefined(s[1],""),d=!0===l;if(l=!0===l||!1===l?"":a.toString(l),0===s.length||s[0]instanceof n){let e;e=o.services?.portal?o.services.portal:A.getDefault(),s.length>0&&(e=i.getPortal(s[0],e));const n=await x.lookupUser(e,l,d);if(n){const e=JSON.parse(JSON.stringify(n));for(const n of["lastLogin","created","modified"])void 0!==e[n]&&null!==e[n]&&(e[n]=new Date(e[n]));return r.convertObjectToArcadeDictionary(e,a.defaultTimeZone(o))}return null}let f=null;if(a.isFeatureSet(s[0])&&(f=s[0]),f){if(d=!1,l)return null;await f.load();const e=await f.getOwningSystemUrl();if(!e){if(!l){const e=await f.getIdentityUser();return e?r.convertObjectToArcadeDictionary({username:e},a.defaultTimeZone(o)):null}return null}let t;t=o.services?.portal?o.services.portal:A.getDefault(),t=i.getPortal(new n(e),t);const c=await x.lookupUser(t,l,d);if(c){const e=JSON.parse(JSON.stringify(c));for(const n of["lastLogin","created","modified"])void 0!==e[n]&&null!==e[n]&&(e[n]=new Date(e[n]));return r.convertObjectToArcadeDictionary(e,a.defaultTimeZone(o))}return null}throw new t.ArcadeExecutionError(o,t.ExecutionErrorCodes.InvalidParameter,c)}))},e.functions.nearestcoordinate=function(n,o){return e.standardFunctionAsync(n,o,(async(e,i,c)=>{if(c=a.autoCastFeatureToGeometry(c),a.pcCheck(c,2,2,n,o),!(c[0]instanceof d||null===c[0]))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,o);if(!(c[1]instanceof m||null===c[1]))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,o);if(null===c[0]||null===c[1])return null;const u=await f.nearestCoordinate(c[0],c[1]);return null===u?null:r.convertObjectToArcadeDictionary({coordinate:u.coordinate,distance:u.distance,sideOfLine:0===u.distance?"straddle":u.isRightSide?"right":"left"},a.defaultTimeZone(n),!1,!0)}))},e.functions.nearestvertex=function(n,o){return e.standardFunctionAsync(n,o,(async(e,i,c)=>{if(c=a.autoCastFeatureToGeometry(c),a.pcCheck(c,2,2,n,o),!(c[0]instanceof d||null===c[0]))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,o);if(!(c[1]instanceof m||null===c[1]))throw new t.ArcadeExecutionError(n,t.ExecutionErrorCodes.InvalidParameter,o);if(null===c[0]||null===c[1])return null;const u=await f.nearestVertex(c[0],c[1]);return null===u?null:r.convertObjectToArcadeDictionary({coordinate:u.coordinate,distance:u.distance,sideOfLine:0===u.distance?"straddle":u.isRightSide?"right":"left"},a.defaultTimeZone(n),!1,!0)}))})}e.registerFunctions=g,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
