/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../containerUtils","../Dictionary","../executionError","../Feature","../ImmutablePointArray","../../chunks/languageUtils","./centroid","../../geometry/Extent","../../geometry/Geometry","../../geometry/Multipoint","../../geometry/Point","../../geometry/Polygon","../../geometry/Polyline","../../geometry/support/coordsUtils","../../geometry/support/jsonUtils"],(function(e,r,t,n,o,i,a,c,l,s,f,u,m,E,d,p){"use strict";function x(e,x){e.ringisclockwise=function(e,r){return x(e,r,((t,o,c)=>{a.pcCheck(c,1,1,e,r);let l=[];if(null===c[0])return!1;if(a.isArray(c[0]))for(const i of c[0]){if(!(i instanceof u))throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,r);l.push(i.hasZ?i.hasM?[i.x,i.y,i.z,i.m]:[i.x,i.y,i.z]:[i.x,i.y])}else if(c[0]instanceof i)l=c[0]._elements;else{if(!a.isImmutableArray(c[0]))throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,r);for(const t of c[0].toArray()){if(!(t instanceof u))throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,r);l.push(t.hasZ?t.hasM?[t.x,t.y,t.z,t.m]:[t.x,t.y,t.z]:[t.x,t.y])}}return!(l.length<3)&&d.isClockwise(l)}))},e.polygon=function(e,r){return x(e,r,((i,c,l)=>{let s;if(a.pcCheck(l,1,1,e,r),l[0]instanceof t){const t=a.fixSpatialReference(o.parseGeometryFromDictionary(l[0],e.spatialReference),e.spatialReference);if(t instanceof m==!1)throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,r);s=t}else if(l[0]instanceof m)s=p.fromJSON(l[0].toJSON());else{const r=JSON.parse(l[0]);r&&!r.spatialReference&&(r.spatialReference=e.spatialReference),s=a.fixSpatialReference(new m(r),e.spatialReference)}if(null!==s&&!1===s.spatialReference.equals(e.spatialReference))throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.WrongSpatialReference,r);return a.fixNullGeometry(s)}))},e.polyline=function(e,r){return x(e,r,((i,c,l)=>{let s;if(a.pcCheck(l,1,1,e,r),l[0]instanceof t){const t=a.fixSpatialReference(o.parseGeometryFromDictionary(l[0],e.spatialReference),e.spatialReference);if(t instanceof E==!1)throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,r);s=t}else if(l[0]instanceof E)s=p.fromJSON(l[0].toJSON());else{const r=JSON.parse(l[0]);r&&!r.spatialReference&&(r.spatialReference=e.spatialReference),s=a.fixSpatialReference(new E(r),e.spatialReference)}if(null!==s&&!1===s.spatialReference.equals(e.spatialReference))throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.WrongSpatialReference,r);return a.fixNullGeometry(s)}))},e.point=function(e,r){return x(e,r,((i,c,l)=>{let s;if(a.pcCheck(l,1,1,e,r),l[0]instanceof t){const t=a.fixSpatialReference(o.parseGeometryFromDictionary(l[0],e.spatialReference),e.spatialReference);if(t instanceof u==!1)throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,r);s=t}else if(l[0]instanceof u)s=p.fromJSON(l[0].toJSON());else{const r=JSON.parse(l[0]);r&&!r.spatialReference&&(r.spatialReference=e.spatialReference),s=a.fixSpatialReference(new u(r),e.spatialReference)}if(null!==s&&!1===s.spatialReference.equals(e.spatialReference))throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.WrongSpatialReference,r);return a.fixNullGeometry(s)}))},e.multipoint=function(e,r){return x(e,r,((i,c,l)=>{let s;if(a.pcCheck(l,1,1,e,r),l[0]instanceof t){const t=a.fixSpatialReference(o.parseGeometryFromDictionary(l[0],e.spatialReference),e.spatialReference);if(t instanceof f==!1)throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,r);s=t}else if(l[0]instanceof f)s=p.fromJSON(l[0].toJSON());else{const r=JSON.parse(l[0]);r&&!r.spatialReference&&(r.spatialReference=e.spatialReference),s=a.fixSpatialReference(new f(r),e.spatialReference)}if(null!==s&&!1===s.spatialReference.equals(e.spatialReference))throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.WrongSpatialReference,r);return a.fixNullGeometry(s)}))},e.extent=function(e,r){return x(e,r,((i,c,s)=>{s=a.autoCastFeatureToGeometry(s),a.pcCheck(s,1,1,e,r);let d=null;if(s[0]instanceof t)d=a.fixSpatialReference(o.parseGeometryFromDictionary(s[0],e.spatialReference),e.spatialReference);else if(s[0]instanceof u){const e={xmin:s[0].x,ymin:s[0].y,xmax:s[0].x,ymax:s[0].y,spatialReference:s[0].spatialReference.toJSON()},r=s[0];r.hasZ?(e.zmin=r.z,e.zmax=r.z):r.hasM&&(e.mmin=r.m,e.mmax=r.m),d=p.fromJSON(e)}else if(s[0]instanceof m)d=p.fromJSON(s[0].extent?.toJSON());else if(s[0]instanceof E)d=p.fromJSON(s[0].extent?.toJSON());else if(s[0]instanceof f)d=p.fromJSON(s[0].extent?.toJSON());else if(s[0]instanceof l)d=p.fromJSON(s[0].toJSON());else{const r=JSON.parse(s[0]);r&&!r.spatialReference&&(r.spatialReference=e.spatialReference),d=a.fixSpatialReference(new l(r),e.spatialReference)}if(null!==d&&!1===d.spatialReference.equals(e.spatialReference))throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.WrongSpatialReference,r);return a.fixNullGeometry(d)}))},e.geometry=function(e,r){return x(e,r,((i,c,l)=>{a.pcCheck(l,1,1,e,r);let s=null;if(null===l[0])return null;if(a.isFeature(l[0]))s=a.fixSpatialReference(l[0].geometry(),e.spatialReference);else if(l[0]instanceof t)s=a.fixSpatialReference(o.parseGeometryFromDictionary(l[0],e.spatialReference),e.spatialReference);else{const r=JSON.parse(l[0]);r&&!r.spatialReference&&(r.spatialReference=e.spatialReference),s=a.fixSpatialReference(p.fromJSON(r),e.spatialReference)}if(null!==s&&!1===s.spatialReference.equals(e.spatialReference))throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.WrongSpatialReference,r);return a.fixNullGeometry(s)}))},e.setgeometry=function(e,r){return x(e,r,((t,o,i)=>{if(a.pcCheck(i,2,2,e,r),!a.isFeature(i[0]))throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,r);if(!0===i[0].immutable)throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.Immutable,r);if(!(i[1]instanceof s||null===i[1]))throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,r);return i[0]._geometry=i[1],a.voidOperation}))},e.feature=function(e,r){return x(e,r,((i,c,l)=>{if(0===l.length)throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.WrongNumberOfParameters,r);let f;if(1===l.length)if(a.isString(l[0]))f=o.fromJson(JSON.parse(l[0]),e.timeZone);else if(a.isFeature(l[0]))f=o.createFromArcadeFeature(l[0]);else if(l[0]instanceof s)f=o.createFromGraphicLikeObject(l[0],null,null,e.timeZone);else{if(!(l[0]instanceof t))throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,r);{let r=l[0].hasField("geometry")?l[0].field("geometry"):null,n=l[0].hasField("attributes")?l[0].field("attributes"):null;null!==r&&r instanceof t&&(r=o.parseGeometryFromDictionary(r,e.spatialReference)),null!==n&&(n=o.parseAttributesFromDictionary(n)),f=o.createFromGraphicLikeObject(r,n,null,e.timeZone)}}else if(2===l.length){let i=null,a=null;if(null!==l[0])if(l[0]instanceof s)i=l[0];else{if(!(i instanceof t))throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,r);i=o.parseGeometryFromDictionary(l[0],e.spatialReference)}if(null!==l[1]){if(!(l[1]instanceof t))throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,r);a=o.parseAttributesFromDictionary(l[1])}f=o.createFromGraphicLikeObject(i,a,null,e.timeZone)}else{let i=null;const c={};if(null!==l[0])if(l[0]instanceof s)i=l[0];else{if(!(i instanceof t))throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,r);i=o.parseGeometryFromDictionary(l[0],e.spatialReference)}for(let t=1;t<l.length;t+=2){const o=a.toString(l[t]),i=l[t+1];if(!(null==i||a.isString(i)||isNaN(i)||a.isDate(i)||a.isNumber(i)||a.isTime(i)||a.isDateOnly(i)||a.isBoolean(i)))throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,r);if(a.isFunctionParameter(i)||!1===a.isSimpleType(i))throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,r);i===a.voidOperation?c[o]=null:c[o]=i}f=o.createFromGraphicLikeObject(i,c,null,e.timeZone)}return f._geometry=a.fixSpatialReference(f.geometry(),e.spatialReference),f.immutable=!1,f}))},e.dictionary=function(e,r){return x(e,r,((o,i,c)=>{if(0===c.length||1===c.length&&null===c[0]){const e=new t;return e.immutable=!1,e}if(1===c.length&&a.isString(c[0]))try{const r=JSON.parse(c[0]),n=t.convertObjectToArcadeDictionary(r,a.defaultTimeZone(e),!1);return n.immutable=!1,n}catch(u){throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,r)}if(1===c.length&&c[0]instanceof s)try{const r=c[0].toJSON();r.hasZ=!0===c[0].hasZ,r.hasM=!0===c[0].hasM;const n=t.convertObjectToArcadeDictionary(r,a.defaultTimeZone(e),!1);return n.immutable=!1,n}catch(u){throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,r)}if(1===c.length&&a.isFeature(c[0]))try{const e=new t;e.immutable=!1,e.setField("geometry",c[0].geometry());const r=new t;r.immutable=!1,e.setField("attributes",r);for(const t of c[0].keys())r.setField(t,c[0].field(t));return e}catch(u){throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,r)}if(1===c.length&&c[0]instanceof t)try{const e=new t;e.immutable=!1;for(const r of c[0].keys())e.setField(r,c[0].field(r));return e}catch(u){throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,r)}if(2===c.length&&c[0]instanceof t&&a.isBoolean(c[1]))try{if(!(!0===c[1])){const e=new t;e.immutable=!1;for(const r of c[0].keys())e.setField(r,c[0].field(r));return e}return c[0].deepClone()}catch(u){throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,r)}if(c.length%2!=0)throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.WrongNumberOfParameters,r);const l={};for(let t=0;t<c.length;t+=2){const o=a.toString(c[t]),i=c[t+1];if(!(null==i||a.isString(i)||isNaN(i)||a.isDate(i)||a.isNumber(i)||a.isBoolean(i)||a.isDateOnly(i)||a.isTime(i)||a.isArray(i)||a.isImmutableArray(i)))throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,r);if(a.isFunctionParameter(i))throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,r);i===a.voidOperation?l[o]=null:l[o]=i}const f=new t(l);return f.immutable=!1,f}))},e.haskey=function(e,o){return x(e,o,((i,c,l)=>{a.pcCheck(l,2,2,e,o);const f=a.toString(l[1]);if(a.isFeature(l[0]))return l[0].hasField(f);if(l[0]instanceof t)return l[0].hasField(f);if(l[0]instanceof s){const e=r.geometryMember(l[0],f,null,null,2);return!e||"notfound"!==e.keystate}throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,o)}))},e.hasvalue=function(e,t){return x(e,t,((n,o,i)=>(a.pcCheck(i,2,2,e,t),null!=r.getNestedOptionalValue(i[0],i[1]))))},e.indexof=function(e,r){return x(e,r,((t,o,i)=>{a.pcCheck(i,2,2,e,r);const c=i[1];if(a.isArray(i[0])){for(let e=0;e<i[0].length;e++)if(a.equalityTest(c,i[0][e]))return e;return-1}if(a.isImmutableArray(i[0])){const e=i[0].length();for(let r=0;r<e;r++)if(a.equalityTest(c,i[0].get(r)))return r;return-1}throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,r)}))},e.angle=function(e,r){return x(e,r,((t,o,i)=>{if(i=a.autoCastFeatureToGeometry(i),a.pcCheck(i,2,3,e,r),!(i[0]instanceof u))throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,r);if(!(i[1]instanceof u))throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,r);if(i.length>2&&!(i[2]instanceof u))throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,r);return 2===i.length?c.angle2D(i[0],i[1]):c.angleBetween2D(i[0],i[1],i[2])}))},e.bearing=function(e,r){return x(e,r,((t,o,i)=>{if(i=a.autoCastFeatureToGeometry(i),a.pcCheck(i,2,3,e,r),!(i[0]instanceof u))throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,r);if(!(i[1]instanceof u))throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,r);if(i.length>2&&!(i[2]instanceof u))throw new n.ArcadeExecutionError(e,n.ExecutionErrorCodes.InvalidParameter,r);return 2===i.length?c.bearing2D(i[0],i[1]):c.bearingBetween2D(i[0],i[1],i[2])}))},e.isselfintersecting=function(e,r){return x(e,r,((t,n,o)=>{o=a.autoCastFeatureToGeometry(o),a.pcCheck(o,1,1,e,r);let i=o[0];if(i instanceof m)return i.isSelfIntersecting;if(i instanceof E)return c.pathsSelfIntersecting(i.paths);if(i instanceof f){const e=i.points;for(let r=0;r<e.length;r++)for(let t=0;t<e.length;t++)if(t!==r){let n=!0;for(let o=0;o<e[r].length;o++)if(e[r][o]!==e[t][o]){n=!1;break}if(!0===n)return!0}}if(a.isArray(i)||a.isImmutableArray(i)){const r=a.autoCastArrayOfPointsToPolyline(i,e.spatialReference);return null!==r&&(i=r.paths),c.pathsSelfIntersecting(i)}return!1}))}}e.registerFunctions=x,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
