/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","exports","../../config","../../geometry","../ArcadePortal","../Dictionary","../executionError","../../chunks/languageUtils","../portalUtils","../../geometry/Geometry","../../geometry/projection","../../geometry/support/webMercatorUtils","../../portal/Portal","../../portal/PortalItem","../../rest/geometryService/project","../../rest/knowledgeGraph/Entity","../../rest/knowledgeGraph/GraphQueryStreaming","../../rest/knowledgeGraph/ObjectValue","../../rest/knowledgeGraph/Path","../../rest/knowledgeGraph/Relationship","../../rest/support/ProjectParameters","../../geometry/SpatialReference"],(function(e,r,t,n,o,i,a,s,c,l,u,p,f,d,g,h,m,y,w,S,E,x){"use strict";let G=null;async function v(e){const r=t.geometryServiceUrl??"";if(!r){u.isLoaded()||await u.load();for(const r of e)r.container[r.indexer]=u.project(r.container[r.indexer],x.WGS84);return}const n=e.map((e=>e.container[e.indexer])),o=new E({geometries:n,outSpatialReference:x.WGS84}),i=await g.project(r,o);for(let t=0;t<i.length;t++){const r=e[t];r.container[r.indexer]=i[t]}}async function P(r,t){const n=new d({portal:r,id:t});return await n.load(),null===G&&(G=await new Promise(((r,t)=>e(["../../rest/knowledgeGraphService"],r,t)))),await G.fetchKnowledgeGraph(n.url)}function R(e,r,t,n,o){if(null===e)return null;if(s.isString(e)||s.isNumber(e))return e;if(s.isDate(e))return e.toJSDate();if(s.isDate(e))return e.toJSDate();if(s.isDateOnly(e))return e.toStorageFormat();if(s.isTime(e))return e.toStorageString();if(s.isDictionary(e)){const i={};for(const a of e.keys())i[a]=R(e.field(a),r,t,n,o),i[a]instanceof l&&o.push({container:i,indexer:a});return i}if(s.isArray(e)){const i=e.map((e=>R(e,r,t,n,o)));for(let e=0;e<i.length;e++)i[e]instanceof l&&o.push({container:i,indexer:e});return i}return s.isGeometry(e)?e.spatialReference.isWGS84?e:e.spatialReference.isWebMercator&&r?p.webMercatorToGeographic(e):e:void 0}function b(e,r){if(!e)return e;if(e.spatialReference.isWGS84&&r.spatialReference.isWebMercator)return p.geographicToWebMercator(e);if(e.spatialReference.equals(r.spatialReference))return e;throw new a.ArcadeExecutionError(r,a.ExecutionErrorCodes.WrongSpatialReference,null)}function k(e,r){if(!e)return null;const t={};for(const n in e)t[n]=A(e[n],r);return t}function A(e,r){return null===e?null:s.isArray(e)?e.map((e=>A(e,r))):e instanceof h?{graphTypeName:e.typeName,id:e.id,graphType:"entity",properties:k(e.properties,r)}:e instanceof y?{graphType:"object",properties:k(e.properties,r)}:e instanceof S?{graphTypeName:e.typeName,id:e.id,graphType:"relationship",originId:e.originId??null,destinationId:e.destinationId??null,properties:k(e.properties,r)}:e instanceof w?{graphType:"path",path:e.path?e.path.map((e=>A(e,r))):null}:s.isGeometry(e)?b(e,r):s.isString(e)||s.isNumber(e)||s.isJsDate(e)?e:null}function T(r){"async"===r.mode&&(r.functions.knowledgegraphbyportalitem=function(e,t){return r.standardFunctionAsync(e,t,((r,n,i)=>{if(s.pcCheck(i,2,2,e,t),null===i[0])throw new a.ArcadeExecutionError(e,a.ExecutionErrorCodes.PortalRequired,t);if(i[0]instanceof o){const r=s.toString(i[1]);let t;t=e.services?.portal?e.services.portal:f.getDefault();return P(c.getPortal(i[0],t),r)}if(!1===s.isString(i[0]))throw new a.ArcadeExecutionError(e,a.ExecutionErrorCodes.InvalidParameter,t);const l=s.toString(i[0]);return P(e.services?.portal??f.getDefault(),l)}))},r.signatures.push({name:"knowledgegraphbyportalitem",min:2,max:2}),r.functions.querygraph=function(t,n){return r.standardFunctionAsync(t,n,(async(r,o,c)=>{s.pcCheck(c,2,4,t,n);const l=c[0];if(!s.isKnowledgeGraph(l))throw new a.ArcadeExecutionError(t,a.ExecutionErrorCodes.InvalidParameter,n);const u=c[1];if(!s.isString(u))throw new a.ArcadeExecutionError(t,a.ExecutionErrorCodes.InvalidParameter,n);null===G&&(G=await new Promise(((r,t)=>e(["../../rest/knowledgeGraphService"],r,t))));let p=null;const f=s.defaultUndefined(c[2],null);if(!(f instanceof i||null===f))throw new a.ArcadeExecutionError(t,a.ExecutionErrorCodes.InvalidParameter,n);if(f){let e=[];p=R(f,!0,!1,t,e),e=e.filter((e=>!e.container[e.indexer].spatialReference.isWGS84)),e.length>0&&await v(e)}const d=new m({openCypherQuery:u,bindParameters:p});(l?.serviceDefinition?.currentVersion??11.3)>11.2&&(d.outputSpatialReference=t.spatialReference);const g=(await G.executeQueryStreaming(l,d)).resultRowsStream.getReader(),h=[];try{for(;;){const{done:e,value:r}=await g.read();if(e)break;if(s.isArray(r))for(const n of r)h.push(A(n,t));else{const e=[];for(const n of r)e.push(A(r[n],t));h.push(e)}}}catch(y){throw y}return i.convertJsonToArcade(h,s.defaultTimeZone(t),!1,!0)}))},r.signatures.push({name:"querygraph",min:2,max:4}))}r.registerFunctions=T,Object.defineProperty(r,Symbol.toStringTag,{value:"Module"})}));
