/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../chunks/index","./diagnosticMessages","./languageKeywords","./types"],(function(i,e,t,n,s){"use strict";function o(i,e){return e?i.replaceAll(/\${(.*?)}/g,((i,t)=>e[t]?.toString()??"")):i}function a(i){return!!i&&"dictionary"!==i.type}class r{constructor(i,e=[]){this._apiDefinitions=i,this._profileVariables=e,this._isInBlock=!1,this._identifierBeingAssigned=void 0,this._assignmentValidationMode="disabled",this._scriptScopeIdentifiers=new Map,this._diagnostics=new Array,this._undeclaredIdentifiersInFunctions=new Map}validateScript(i){if(!i)return{diagnostics:[],program:null};this._isInBlock=!1,this._identifierBeingAssigned=void 0,this._assignmentValidationMode="disabled",this._diagnostics=[],this._scriptScopeIdentifiers.clear(),this._undeclaredIdentifiersInFunctions.clear(),this._functionScopeIdentifiers=void 0;let n=null;try{n=e.rt(i,{tolerant:!0}),this.handleErrors(n.errors),n.body.forEach((i=>this.validateStatement(i))),this.diagnoseIdentifiers(),this._undeclaredIdentifiersInFunctions.size>0&&this._undeclaredIdentifiersInFunctions.forEach((i=>{for(const e of i)this.logDiagnostic(e.node.loc,{code:t.DiagnosticCodes.NotDefined,data:{identifier:e.node.name}})}))}catch(s){this.handleException(s)}return{diagnostics:this._diagnostics,program:n}}disableRecordIdentifierAssignment(i,e){const t=this._assignmentValidationMode;this._assignmentValidationMode="disabled",i.call(this,e),this._assignmentValidationMode=t}inBlock(i,e){const t=this._isInBlock;this._isInBlock=!0,i.call(this,e),this._isInBlock=t}get _isInFunctionScope(){return!!this._functionScopeIdentifiers}inFunctionScope(i){this._functionScopeIdentifiers=new Map,i.call(this),this.diagnoseIdentifiers(),this._functionScopeIdentifiers=void 0}logDiagnostic(i,n){const a={severity:s.DiagnosticSeverity.Error,...n,message:o(t.diagnosticMessages[n.code]??e.q[n.code],n.data),range:{start:{line:i.start.line-1,character:i.start.column},end:{line:i.end.line-1,character:i.end.column}}};this._diagnostics.push(a)}handleErrors(i){(i??[]).forEach(this.handleException,this)}handleException(i){if(d(i)){const{range:e,code:t,data:n}=i;this.logDiagnostic(e,{code:t,data:n})}else this.logDiagnostic({start:{line:1,column:0},end:{line:1,column:0}},{code:t.DiagnosticCodes.ExecutionError,data:{stack:i.stack}})}getIdentifierInfo(i){return this._functionScopeIdentifiers?.get(i)??this._scriptScopeIdentifiers.get(i)}setIdentiferInfo(i,e){this._functionScopeIdentifiers?this._functionScopeIdentifiers.set(i,e):((this._functionScopeIdentifiers??this._scriptScopeIdentifiers).set(i,e),this._functionScopeIdentifiers||this._undeclaredIdentifiersInFunctions.has(i)&&(this._undeclaredIdentifiersInFunctions.delete(i),e.used=!0))}isProfileVariable(i){return(this._profileVariables??[]).some((e=>e.name.toLowerCase()===i))}isApiItem(i){const e=!!this._apiDefinitions?.constantDefinitions?.get(i),t=!!this._apiDefinitions?.functionDefinitions?.get(i);return e||t}validateStatement(i){if(i)switch(i.type){case e.i.BlockStatement:return void i.body.forEach((i=>this.validateStatement(i)));case e.i.VariableDeclaration:return void i.declarations.forEach((i=>this.validateVariableDeclarator(i)));case e.i.FunctionDeclaration:return void this.validateFunctionDeclaration(i);case e.i.ExportNamedDeclaration:return void this.validateExportDeclaration(i);case e.i.ImportDeclaration:return void this.validateImportDeclaration(i);case e.i.WhileStatement:return void this.validateWhileStatement(i);case e.i.ForStatement:return void this.validateForStatement(i);case e.i.ForInStatement:return void this.validateForInStatement(i);case e.i.IfStatement:return void this.validateIfStatement(i);case e.i.ReturnStatement:return void this.validateExpression(i.argument);case e.i.ExpressionStatement:return void this.validateExpression(i.expression);case e.i.BreakStatement:case e.i.ContinueStatement:case e.i.EmptyStatement:return}}validateVariableDeclarator(i){this.validateExpression(i.init),this.recordVariableIdentifier(i.id,{initialized:!!i.init})}validateFunctionDeclaration(i){this.recordFunctionIdentifier(i),this.inFunctionScope((()=>{i.params.forEach((i=>this.recordParamAsIdentifier(i))),c(i.body)&&this.logDiagnostic(i.body.loc,{code:t.DiagnosticCodes.UnexpectedEmptyFunction,data:{identifier:i.id.name},severity:s.DiagnosticSeverity.Warning}),this.validateStatement(i.body)}))}validateExportDeclaration(i){this.validateStatement(i.declaration)}validateImportDeclaration(i){this.recordImportIdentifier(i)}validateForStatement(i){e.Ee(i.init)?this.inBlock(this.validateStatement,i.init):this.validateExpression(i.init),this.validateExpression(i.update),this.validateExpression(i.test),c(i.body)&&this.logDiagnostic(i.body.loc,{code:t.DiagnosticCodes.EmptyBlockStatement,severity:s.DiagnosticSeverity.Warning}),this.inBlock(this.validateStatement,i.body)}validateWhileStatement(i){this.validateExpression(i.test),c(i.body)&&this.logDiagnostic(i.body.loc,{code:t.DiagnosticCodes.EmptyBlockStatement,severity:s.DiagnosticSeverity.Warning}),this.inBlock(this.validateStatement,i.body)}validateForInStatement(i){e.ke(i.left)?this.validateExpression(i.left):this.recordVariableIdentifier(i.left.declarations[0].id,{initialized:!0,inBlock:!0}),this.validateExpression(i.right),c(i.body)&&this.logDiagnostic(i.body.loc,{code:t.DiagnosticCodes.EmptyBlockStatement,severity:s.DiagnosticSeverity.Warning}),this.validateStatement(i.body)}validateIfStatement(i){this.validateExpression(i.test),c(i.consequent)&&this.logDiagnostic(i.consequent.loc,{code:t.DiagnosticCodes.EmptyBlockStatement,severity:s.DiagnosticSeverity.Warning}),i.alternate&&c(i.alternate)&&this.logDiagnostic(i.alternate.loc,{code:t.DiagnosticCodes.EmptyBlockStatement,severity:s.DiagnosticSeverity.Warning}),this.inBlock(this.validateStatement,i.consequent),this.inBlock(this.validateStatement,i.alternate)}validateExpression(i){if(i)switch(i.type){case e.i.AssignmentExpression:return void this.validateAssignmentExpression(i);case e.i.CallExpression:return void this.validateCallExpression(i);case e.i.Identifier:return void this.validateIdentifier(i);case e.i.Literal:return void this.validateLiteral(i);case e.i.ArrayExpression:return void i.elements.forEach((i=>this.validateExpression(i)));case e.i.ObjectExpression:return void this.validateObjectExpression(i);case e.i.UnaryExpression:return void this.validateUnaryExpression(i);case e.i.UpdateExpression:return void this.validateUpdateExpression(i);case e.i.BinaryExpression:case e.i.LogicalExpression:return void this.validateBinaryAndLogicalExpression(i);case e.i.MemberExpression:return void this.validateMemberExpression(i);case e.i.TemplateLiteral:return void i.expressions.forEach((i=>this.validateExpression(i)));default:return}}validateAssignmentExpression(i){const t=this._identifierBeingAssigned,n=this._assignmentValidationMode;e.ke(i.left)&&(this._identifierBeingAssigned=i.left.name.toLowerCase(),this._assignmentValidationMode="left"),this.validateExpression(i.left),e.ke(i.left)&&(this._assignmentValidationMode="right"),this.validateExpression(i.right),this._identifierBeingAssigned=t,this._assignmentValidationMode=n}validateCallExpression(i){if(this.validateExpression(i.callee),e.ke(i.callee)){const e=i.callee.name.toLowerCase(),t=this.getIdentifierInfo(e),n=this._apiDefinitions?.functionDefinitions?.get(e);if(!t&&n){const e=l(n,i.arguments.length);e&&this.logDiagnostic(i.loc,e)}}i.arguments.forEach((i=>this.validateExpression(i)))}validateIdentifier(i){const e=i.name.toLowerCase(),n=this.getIdentifierInfo(e);if(n){if("left"===this._assignmentValidationMode&&this._identifierBeingAssigned===e)return void(n.initialized=!0);if("right"===this._assignmentValidationMode&&this._identifierBeingAssigned===e)return;n.used=!0}else if(!this.isProfileVariable(e)&&!this.isApiItem(e)){if(this._isInFunctionScope){let t=this._undeclaredIdentifiersInFunctions.get(e);return t||(t=[],this._undeclaredIdentifiersInFunctions.set(e,t)),void t.push({node:i,identifier:e})}this.logDiagnostic(i.loc,{code:t.DiagnosticCodes.NotDefined,data:{identifier:i.name}})}}validateLiteral(i){f(i.raw).forEach((i=>{const e=this.getIdentifierInfo(i.toLowerCase());e&&(e.used=!0)}))}logProfileOrApiConflict(i){const e=i.name.toLowerCase(),n=this.isProfileVariable(e),o=this.isApiItem(e);(n||o)&&this.logDiagnostic(i.loc,{code:n?t.DiagnosticCodes.ProfileVariablesConflict:t.DiagnosticCodes.ApiConflict,severity:s.DiagnosticSeverity.Warning,data:{identifier:i.name}})}logReservedKeywordsConflict(i){const e=i.name.toLowerCase();n.arcadeReservedKeywords.includes(e)&&this.logDiagnostic(i.loc,{code:t.DiagnosticCodes.ReservedKeyword,severity:s.DiagnosticSeverity.Warning,data:{identifier:i.name}})}validateObjectExpression(i){i.properties.forEach((i=>{this.validateExpression(i.value)}))}validateUnaryExpression(i){this.validateExpression(i.argument)}validateUpdateExpression(i){this.validateExpression(i.argument)}validateBinaryAndLogicalExpression(i){this.validateExpression(i.left),this.validateExpression(i.right)}validateMemberExpression(i){const t=this.flattenMemberExpressionAndValidate(i),n=t[0].object;this.disableRecordIdentifierAssignment(this.validateExpression,n),e.ke(n)&&(this.getIdentifierInfo(n.name.toLowerCase())||this.validateMemberExpressionWithProfile(t)||this.validateConstantMemberExpression(t))}flattenMemberExpressionAndValidate(i){return i.type===e.i.MemberExpression?(e.ke(i.property)&&!i.computed||this.validateExpression(i.property),[...this.flattenMemberExpressionAndValidate(i.object),i]):[]}extractAndValidatePropertyName(i){switch(i.type){case"Identifier":return i.name.toLowerCase();case"Literal":return"string"!=typeof i.value?(this.logDiagnostic(i.loc,{code:t.DiagnosticCodes.UnexpectedPropertyIdentifier}),null):i.value.toLowerCase();default:return this.logDiagnostic(i.loc,{code:t.DiagnosticCodes.UnexpectedPropertyIdentifier}),null}}validateConstantMemberExpression(i){const n=i[0];if(!e.ke(n.object))return!1;const s=n.object.name.toLowerCase(),o=this._apiDefinitions?.constantDefinitions?.get(s);if(!o)return!1;if("namespace"!==o.type)return this.logDiagnostic(n.property.loc,{code:t.DiagnosticCodes.NotADictionary,data:{identifier:s}}),!0;const a=this.extractAndValidatePropertyName(n.property);if(!a)return!0;if(!o.members.some((i=>i.key===a))){const i=o.members.reduce(((i,e)=>`${i}${i?" | ":""}${e.completion.label.split(".").pop()}`),"");this.logDiagnostic(n.property.loc,{code:t.DiagnosticCodes.InvalidConstantIdentifier,data:{list:i}})}return i.length>1&&this.logDiagnostic(i[1].property.loc,{code:t.DiagnosticCodes.UnexpectedPropertyIdentifier}),!0}validateMemberExpressionWithProfile(i){const n=i[0];if(n.object.type!==e.i.Identifier)return!1;const o=n.object.name.toLowerCase(),r=this._profileVariables?.find((i=>i.key===o));if(!r)return!1;if(a(r))return this.logDiagnostic(n.object.loc,{code:t.DiagnosticCodes.NotADictionary,data:{identifier:r.name}}),!0;if(this._identifierBeingAssigned===o)return this.logDiagnostic(n.loc,{code:t.DiagnosticCodes.ProfileVariablesAreImmutable}),!0;let d=r;for(let e=0;e<i.length;e++){if(i[e].computed)return!0;if(a(d))return this.logDiagnostic(i[e-1]?.property.loc??i[e].object.loc,{code:t.DiagnosticCodes.NotADictionary,data:{identifier:d.name}}),!0;const n=this.extractAndValidatePropertyName(i[e].property);if(!n)return!0;if(0===d.properties.length)return this.logDiagnostic(i[e].property.loc,{code:t.DiagnosticCodes.UnknownPropertyIdentifier,data:{identifier:n},severity:s.DiagnosticSeverity.Warning}),!0;const o=d.properties.find((i=>i.name.toLowerCase()===n));if(!o){const n=d.properties.reduce(((i,e)=>`${i}${i?" | ":""}${e.name.split(".").pop()}`),"");return this.logDiagnostic(i[e].property.loc,{code:t.DiagnosticCodes.InvalidPropertyIdentifier,data:{list:n}}),!0}d=o}return!0}recordVariableIdentifier(i,e){this.logReservedKeywordsConflict(i),this.logProfileOrApiConflict(i);const n=i.name.toLowerCase();let o=this.getIdentifierInfo(n);const a=o&&this._isInFunctionScope&&"function"===o.scope,r=o&&!this._isInFunctionScope&&"script"===o.scope;(a||r)&&this.logDiagnostic(i.loc,{code:t.DiagnosticCodes.AlreadyDefined,data:{identifier:i.name},severity:s.DiagnosticSeverity.Warning});const d=e.inBlock??this._isInBlock,{initialized:c}=e;if(!o||this._isInFunctionScope&&"function"!==o.scope){o={node:i,used:!1,initialized:c,scope:this._isInFunctionScope?"function":d?"block":"script"}}else o.node=i,o.used=!1,o.initialized=c;return"block"!==o.scope||d||(o.scope="script",this.logDiagnostic(i.loc,{code:t.DiagnosticCodes.AlreadyDefined,data:{identifier:i.name},severity:s.DiagnosticSeverity.Warning})),this.setIdentiferInfo(n,o),!1}recordImportIdentifier(i){const e=i.specifiers[0].local;this.logProfileOrApiConflict(e);const n=e.name.toLowerCase();let o=this.getIdentifierInfo(n);o?.scope&&this.logDiagnostic(i.specifiers[0].local.loc,{code:t.DiagnosticCodes.AlreadyDefined,data:{identifier:i.specifiers[0].local.name},severity:s.DiagnosticSeverity.Warning}),o={node:i.specifiers[0].local,used:!1,...o,scope:"script",initialized:!0},this.setIdentiferInfo(n,o)}recordFunctionIdentifier(i){this.logProfileOrApiConflict(i.id);const e=i.id.name.toLowerCase();let n=this.getIdentifierInfo(e);n?.scope&&this.logDiagnostic(i.id.loc,{code:t.DiagnosticCodes.AlreadyDefined,data:{identifier:i.id.name},severity:s.DiagnosticSeverity.Warning}),n={node:i.id,used:!1,...n,scope:"script",initialized:!0},this.setIdentiferInfo(e,n)}recordParamAsIdentifier(i){return this.recordVariableIdentifier(i,{initialized:!0})}diagnoseIdentifiers(){(this._functionScopeIdentifiers??this._scriptScopeIdentifiers).forEach((i=>{i.node&&(i.used?i.initialized||this.logDiagnostic(i.node.loc,{code:t.DiagnosticCodes.DefinedNeverAssigned,data:{identifier:i.node.name},severity:s.DiagnosticSeverity.Warning}):this.logDiagnostic(i.node.loc,{code:i.initialized?t.DiagnosticCodes.AssignedNeverUsed:t.DiagnosticCodes.DefinedNeverUsed,data:{identifier:i.node.name},severity:s.DiagnosticSeverity.Warning}))}))}}function d(i){return"ParsingError"===i?.name}function c(i){return e.Q(i)||e.j(i)&&!i?.body.length}function l(i,e){if(!i||null==e||e<0)return null;const{min:n,max:s}=i.overloads.reduce(((i,e)=>{const{min:t,max:n}=e.parametersInfo;return i.min>=0&&(i.min=Math.min(t,i.min)),i.max>=0&&(i.max=n<0?n:Math.max(n,i.max)),i}),{min:1/0,max:0});return e<n?n>0?{code:t.DiagnosticCodes.NotEnoughArguments,data:{min:n}}:{code:t.DiagnosticCodes.NoArgumentExpected}:s>=0&&e>s?{code:t.DiagnosticCodes.TooManyArguments,data:{max:s}}:null}const h=new RegExp(/\B@\w+/g);function f(i){return Array.from((i??"").matchAll(h),(i=>i[0].slice(1)))}function g(i,e=[],t){if(!i)return{diagnostics:[]};return new r(t,e).validateScript(i)}i.ArcadeValidationService=r,i.format=o,i.isValueVariable=a,i.validateScript=g,Object.defineProperty(i,Symbol.toStringTag,{value:"Module"})}));
