/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports"],(function(e){"use strict";function n(e){switch(e){case 1:return"Unknown error";case 2:return"Corrupted geometry";case 3:return"Empty geometry";case 4:return"Math singularity";case 5:return"Buffer is too small";case 6:return"Invalid shape type";case 7:return"Projection out of supported range";case 8:return"Non simple geometry";case 9:return"Cannot calculate geodesic";case 10:return"Notation conversion";case 11:return"Missing grid file";case 12:return"Invalid call";case 13:return"Internal error";case 14:return"Not implemented";case 15:return"IO error";case 16:return"Invalid 3D";case 17:return"An ambiguous geography edge with antipodal points";case 18:return"Geocentric coordinates require ellipsoidal height";case 19:return"Geography cannot be projected into a gnomonic plane or a result of an operation cannot fit into a gnomonic plane";case 20:return"Geometry is too large to be exported in to a given format";case 21:return"Operation is canceled by the user";default:return"unknown error"}}function t(e,n){try{if(!e)throw new Error(n)}catch(t){throw t}}class r extends Error{constructor(e,n){super(),this.m_AdditionalMessage=n,this.m_ErrorType=e}what(){return n(this.m_ErrorType)}additionalMessage(){return this.m_AdditionalMessage?this.m_AdditionalMessage:""}code(){return this.m_ErrorType}}class o extends r{constructor(e){super(2,e),this.name="corrupted geometry exception"}}class i extends r{constructor(e){super(3,e),this.name="empty gemetry exception"}}class u extends r{constructor(e){super(4,e),this.name="match singularity exception"}}class c extends r{constructor(e){super(8,e),this.name="non simple geometry exception"}}var s;e.GeometryType=void 0,(s=e.GeometryType||(e.GeometryType={}))[s.enumUnknown=0]="enumUnknown",s[s.enumPoint=513]="enumPoint",s[s.enumLine=5122]="enumLine",s[s.enumBezier=5123]="enumBezier",s[s.enumEllipticArc=5124]="enumEllipticArc",s[s.enumEnvelope=3077]="enumEnvelope",s[s.enumMultiPoint=8710]="enumMultiPoint",s[s.enumPolyline=25607]="enumPolyline",s[s.enumPolygon=27656]="enumPolygon",s[s.enumMultipatch=40969]="enumMultipatch",s[s.enumGeometryCollection=3594]="enumGeometryCollection",s[s.enumRationalBezier2=5134]="enumRationalBezier2",s[s.enumBezier2=5135]="enumBezier2",s[s.enumRationalBezier23d=5392]="enumRationalBezier23d",s[s.enumGreatArc3d=5393]="enumGreatArc3d";const a=[0,0,1,1,1,2,0,1,2,3,-1,-1,-1,-1,1,1];function m(e){return a[15&e]}function p(e){return!!(512&e)}function l(e){return!!(1024&e)}function y(e){return!!(2048&e)}function h(e){return!!(4096&e)}function d(e){return!!(8192&e)}function f(e){return!!(16384&e)}function g(e){return!!(32768&e)}function w(n){const t=n.getGeometryType();return d(t)?n.getPointCount():n.isEmpty()?0:t===e.GeometryType.enumEnvelope?4:t===e.GeometryType.enumPoint?1:h(t)?2:void A("missing type")}function G(n){const t=n.getGeometryType();if(f(t))return n.hasNonLinearSegments();if(t===e.GeometryType.enumGeometryCollection){const e=n;for(let n=0,t=e.getGeometryCount();n<t;n++)if(G(e.getGeometry(n)))return!0;return!1}return!!h(t)&&t!==e.GeometryType.enumLine}function E(e){throw new o(e)}function x(e){const n=new Error(e);throw n.name="invalid argument exception",n}function v(e){const n=new u(e);throw n.name="invalid argument exception",n}function T(){x("Geometry type is not supported for 3D operations.")}function I(e){throw new r(12,e)}function M(e){throw new i(e)}function C(e){const n=new r(14,e);throw n.name="not implemented",n}function P(e){const n=new Error(e);throw n.name="out of range exception",n}function A(e){const n=new r(13,e);throw n.name="internal error",n}function k(e){const n=new Error(e);throw n.name="logic error exception",n}function B(e){throw new c(e)}function z(){C("operation does not support curves yet")}function L(e){e&&G(e)&&z()}function N(e){e&&g(e.getGeometryType())&&C("Unsupported geometry type.")}function _(n){n===e.GeometryType.enumGeometryCollection&&x("Geometry_collection instances are not supported in this operation")}function b(e){_(e.getGeometryType())}function R(e){x(`bad wkid: ${e}`)}function O(e){let n="bad wkt: ";n+=e,n+="...",x(n)}function S(e,n){e||x(n)}e.checkAndThrow=S,e.geometryReleaseAssert=t,e.getDimensionFromType=m,e.hasNonLinearSegments=G,e.isArea=y,e.isLinear=l,e.isMesh=g,e.isMultiPath=f,e.isMultiVertex=d,e.isPoint=p,e.isSegment=h,e.throwCorruptedGeometryException=E,e.throwEmptyGeometryException=M,e.throwIfCurves=L,e.throwIfGeometryCollection=b,e.throwIfGeometryCollectionType=_,e.throwIfMesh=N,e.throwInternalErrorException=A,e.throwInvalidArgumentException=x,e.throwInvalidCallException=I,e.throwInvalidGeometryTypeFor3DOps=T,e.throwInvalidWkidException=R,e.throwInvalidWktException=O,e.throwLogicErrorException=k,e.throwMathSingularityException=v,e.throwNonSimpleGeometryException=B,e.throwNotImplementedException=C,e.throwOutOfRangeException=P,e.vertexCount=w}));
