/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../core/has","../core/Logger","../core/mathUtils","../core/ObjectStack","../core/libs/gl-matrix-2/math/mat4","../core/libs/gl-matrix-2/factories/mat4f64","./vec32","../core/libs/gl-matrix-2/factories/vec3f64","../geometry/support/aaBoundingRect","../geometry/support/Axis","../geometry/support/lineSegment","../geometry/support/plane","../geometry/support/ray","../geometry/support/vector","../geometry/support/vectorStacks"],(function(t,e,n,i,o,s,r,a,c,u,g,l,d,p,b,f){"use strict";const m=()=>n.getLogger("esri.views.3d.support.geometryUtils.boundedPlane");class h{constructor(){this.plane=d.create(),this.origin=c.create(),this.basis1=c.create(),this.basis2=c.create()}}const y=h;function P(t=$){return{plane:d.create(t.plane),origin:c.clone(t.origin),basis1:c.clone(t.basis1),basis2:c.clone(t.basis2)}}function v(t,e,n){const i=it.get();return i.origin=t,i.basis1=e,i.basis2=n,i.plane=d.wrap(0,0,0,0),A(i),i}function S(t,e=P()){return I(t.origin,t.basis1,t.basis2,e)}function x(t,e){a.copy(e.origin,t.origin),a.copy(e.basis1,t.basis1),a.copy(e.basis2,t.basis2),d.copy(e.plane,t.plane)}function I(t,e,n,i=P()){return a.copy(i.origin,t),a.copy(i.basis1,e),a.copy(i.basis2,n),A(i),K(i,"fromValues()"),i}function A(t){d.fromVectorsAndPoint(t.basis2,t.basis1,t.origin,t.plane)}function j(t,e,n){t!==n&&S(t,n);const i=a.scale(f.sv3d.get(),X(t),e);return a.add(n.origin,n.origin,i),n.plane[3]-=e,n}function M(t,e,n){return V(e,n),j(n,Y(t,t.origin),n),n}function N(t,e){const n=t.basis1[0],i=t.basis2[1],[o,s]=t.origin;return u.fromValues(o-n,s-i,o+n,s+i,e)}function V(t,e=P()){const n=(t[2]-t[0])/2,i=(t[3]-t[1])/2;return a.set(e.origin,t[0]+n,t[1]+i,0),a.set(e.basis1,n,0,0),a.set(e.basis2,0,i,0),d.fromValues(0,0,1,0,e.plane),e}function w(t,e,n){return!!d.intersectRay(t.plane,e,n)&&D(t,n)}function C(t,e,n){if(w(t,e,n))return n;const i=E(t,e,f.sv3d.get());return a.add(n,e.origin,a.scale(f.sv3d.get(),e.direction,a.distance(e.origin,i)/a.length(e.direction))),n}function E(t,e,n){const o=tt.get();Q(t,e,o,tt.get());let s=Number.POSITIVE_INFINITY;for(const r of ot){const c=J(t,r,et.get()),u=f.sv3d.get();if(d.intersectLineSegment(o,c,u)){const t=a.direction(f.sv3d.get(),e.origin,u),o=Math.abs(i.acosClamped(a.dot(e.direction,t)));o<s&&(s=o,a.copy(n,u))}}return s===Number.POSITIVE_INFINITY?O(t,e,n):n}function L(t,e){return(e-t)/e}function O(t,e,n){if(w(t,e,n))return n;const i=tt.get(),o=tt.get();Q(t,e,i,o);let s=Number.POSITIVE_INFINITY;for(const r of ot){const c=J(t,r,et.get()),u=f.sv3d.get();if(d.intersectLineSegmentClamp(i,c,u)){const t=p.distance2(e,u);if(!d.isPointInside(o,u))continue;t<s&&(s=t,a.copy(n,u))}}return R(t,e.origin)<s&&T(t,e.origin,n),n}function T(t,e,n){const i=d.projectPoint(t.plane,e,f.sv3d.get()),o=l.projectPointClamp(H(t,t.basis1),i,-1,1,f.sv3d.get()),s=l.projectPointClamp(H(t,t.basis2),i,-1,1,f.sv3d.get());return a.subtract(n,a.add(f.sv3d.get(),o,s),t.origin),n}function q(t,e,n){const{origin:i,basis1:o,basis2:s}=t,r=a.subtract(f.sv3d.get(),e,i),c=b.projectPointSignedLength(o,r),u=b.projectPointSignedLength(s,r),g=b.projectPointSignedLength(X(t),r);return a.set(n,c,u,g)}function R(t,e){const n=q(t,e,f.sv3d.get()),{basis1:i,basis2:o}=t,s=a.length(i),r=a.length(o),c=Math.max(Math.abs(n[0])-s,0),u=Math.max(Math.abs(n[1])-r,0),g=n[2];return c*c+u*u+g*g}function _(t,e){return Math.sqrt(R(t,e))}function k(t,e){let n=Number.NEGATIVE_INFINITY;for(const i of ot){const o=J(t,i,et.get()),s=l.distance2(o,e);s>n&&(n=s)}return Math.sqrt(n)}function F(t,e){return d.isPointInside(t.plane,e)&&D(t,e)}function B(t,e,n,i){return Z(t,n,i)}function Y(t,e){const n=-t.plane[3];return b.projectPointSignedLength(X(t),e)-n}function U(t,e,n,i){const o=Y(t,e),s=a.scale(nt,X(t),n-o);return a.add(i,e,s),i}function z(t,e){return a.exactEquals(t.basis1,e.basis1)&&a.exactEquals(t.basis2,e.basis2)&&a.exactEquals(t.origin,e.origin)}function W(t,e,n){return t!==n&&S(t,n),s.invert(st,e),s.transpose(st,st),a.transformMat4(n.basis1,t.basis1,st),a.transformMat4(n.basis2,t.basis2,st),a.transformMat4(d.getNormal(n.plane),d.getNormal(t.plane),st),a.transformMat4(n.origin,t.origin,e),d.setOffsetFromPoint(n.plane,n.plane,n.origin),n}function G(t,e,n,i){return t!==i&&S(t,i),s.fromRotation(rt,e,n),a.transformMat4(i.basis1,t.basis1,rt),a.transformMat4(i.basis2,t.basis2,rt),A(i),i}function X(t){return d.getNormal(t.plane)}function Z(t,e,n){switch(e){case g.Axis.X:a.copy(n,t.basis1),a.normalize(n,n);break;case g.Axis.Y:a.copy(n,t.basis2),a.normalize(n,n);break;case g.Axis.Z:a.copy(n,X(t))}return n}function D(t,e){const n=a.subtract(f.sv3d.get(),e,t.origin),i=a.squaredLength(t.basis1),o=a.squaredLength(t.basis2),s=a.dot(t.basis1,n),r=a.dot(t.basis2,n);return-s-i<0&&s-i<0&&-r-o<0&&r-o<0}function H(t,e){const n=et.get();return a.copy(n.origin,t.origin),a.copy(n.vector,e),n}function J(t,e,n){const{basis1:i,basis2:o,origin:s}=t,r=a.scale(f.sv3d.get(),i,e.origin[0]),c=a.scale(f.sv3d.get(),o,e.origin[1]);a.add(n.origin,r,c),a.add(n.origin,n.origin,s);const u=a.scale(f.sv3d.get(),i,e.direction[0]),g=a.scale(f.sv3d.get(),o,e.direction[1]);return a.scale(n.vector,a.add(u,u,g),2),n}function K(t,e){Math.abs(a.dot(t.basis1,t.basis2)/(a.length(t.basis1)*a.length(t.basis2)))>1e-6&&m().warn(e,"Provided basis vectors are not perpendicular"),Math.abs(a.dot(t.basis1,X(t)))>1e-6&&m().warn(e,"Basis vectors and plane normal are not perpendicular"),Math.abs(-a.dot(X(t),t.origin)-t.plane[3])>1e-6&&m().warn(e,"Plane offset is not consistent with plane origin")}function Q(t,e,n,i){const o=X(t);d.fromVectorsAndPoint(o,e.direction,e.origin,n),d.fromVectorsAndPoint(d.getNormal(n),o,e.origin,i)}const $={plane:d.create(),origin:c.fromValues(0,0,0),basis1:c.fromValues(1,0,0),basis2:c.fromValues(0,1,0)},tt=new o.ObjectStack(d.create),et=new o.ObjectStack(l.create),nt=c.create(),it=new o.ObjectStack((()=>P())),ot=[{origin:[-1,-1],direction:[1,0]},{origin:[1,-1],direction:[0,1]},{origin:[1,1],direction:[-1,0]},{origin:[-1,1],direction:[0,-1]}],st=r.create(),rt=r.create(),at=Object.freeze(Object.defineProperty({__proto__:null,BoundedPlaneClass:y,altitudeAt:Y,axisAt:B,cameraFrustumCoverage:L,closestPoint:O,closestPointOnSilhouette:E,copy:S,copyWithoutVerify:x,create:P,distance:_,distance2:R,distanceToSilhouette:k,elevate:j,equals:z,extrusionContainsPoint:F,fromAABoundingRect:V,fromValues:I,getExtent:N,intersectRay:w,intersectRayClosestSilhouette:C,normal:X,projectPoint:T,projectPointLocal:q,rotate:G,setAltitudeAt:U,setExtent:M,transform:W,up:$,updateUnboundedPlane:A,wrap:v},Symbol.toStringTag,{value:"Module"}));t.BoundedPlaneClass=y,t.altitudeAt=Y,t.axisAt=B,t.boundedPlane=at,t.cameraFrustumCoverage=L,t.closestPoint=O,t.closestPointOnSilhouette=E,t.copy=S,t.copyWithoutVerify=x,t.create=P,t.distance=_,t.distance2=R,t.distanceToSilhouette=k,t.elevate=j,t.equals=z,t.extrusionContainsPoint=F,t.fromAABoundingRect=V,t.fromValues=I,t.getExtent=N,t.intersectRay=w,t.intersectRayClosestSilhouette=C,t.normal=X,t.projectPoint=T,t.projectPointLocal=q,t.rotate=G,t.setAltitudeAt=U,t.setExtent=M,t.transform=W,t.up=$,t.updateUnboundedPlane=A,t.wrap=v}));
