/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","./componentsUtils","./loadable","./t9n","./locale","./component","./icon"],(function(e,t,l,o,i,n,c){"use strict";
/*!
     * All material copyright ESRI, All Rights Reserved, unless otherwise specified.
     * See https://github.com/Esri/calcite-design-system/blob/dev/LICENSE.md for details.
     * v2.13.0
     */const s={contentCell:"content-cell",numberCell:"number-cell",selectionCell:"selection-cell",bodyRow:"body-row",footerRow:"footer-row",heading:"heading",description:"description",multipleSelectionCell:"cell--multiple-selection",assistiveText:"assistive-text",active:"active",selectedCell:"selected-cell",lastCell:"last-cell",staticCell:"static-cell"},a={checked:"check-square-f",indeterminate:"minus-square-f",unchecked:"square"},r=":host{--calcite-internal-table-header-background:var(--calcite-table-header-background, var(--calcite-color-foreground-2));--calcite-internal-table-header-border-color:var(--calcite-table-border-color, var(--calcite-color-border-3));display:contents}:host([alignment=center]) th{text-align:center}:host([alignment=end]) th{text-align:end}.assistive-text{position:absolute;inline-size:1px;block-size:1px;padding:0;margin:-1px;overflow:hidden;clip:rect(0, 0, 0, 0);white-space:nowrap;border-width:0}th{white-space:normal;text-align:start;font-weight:var(--calcite-font-weight-medium);color:var(--calcite-color-text-1);font-size:var(--calcite-internal-table-cell-font-size);border-inline-end:1px solid var(--calcite-internal-table-header-border-color);border-block-end:1px solid var(--calcite-internal-table-header-border-color);padding-block:calc(var(--calcite-internal-table-cell-padding) * 1.5);padding-inline:var(--calcite-internal-table-cell-padding);background-color:var(--calcite-internal-table-header-background)}th:not(.static-cell){outline-color:transparent}th:not(.static-cell):not(.static-cell):focus-within{outline:2px solid var(--calcite-ui-focus-color, var(--calcite-color-brand));outline-offset:calc(\n            -2px *\n            calc(\n              1 -\n              2 * clamp(\n                0,\n                var(--calcite-offset-invert-focus),\n                1\n              )\n            )\n          )}th:not(.center):not(.end).content-cell{vertical-align:top}th.center{vertical-align:middle}th.end.content-cell{vertical-align:bottom}th.body-row,th.footer-row{padding-block:var(--calcite-internal-table-cell-padding);border-block-end:0}th.footer-row{border-block-start:1px solid var(--calcite-internal-table-header-border-color)}th.last-cell{border-inline-end:0}.cell--multiple-selection{cursor:pointer;vertical-align:middle;color:var(--calcite-color-text-3)}.cell--multiple-selection:not(.end){vertical-align:middle}.selected-cell:not(.number-cell):not(.footer-cell){--calcite-internal-table-header-background:var(--calcite-color-foreground-current)}.number-cell,.selection-cell{color:var(--calcite-color-text-2);inline-size:2rem;min-inline-size:2rem}.selection-cell calcite-icon.active{color:var(--calcite-color-brand)}.number-cell calcite-icon,.selection-cell calcite-icon{margin-inline-start:auto;margin-inline-end:auto;vertical-align:middle}.heading{color:var(--calcite-color-text-1)}.description{color:var(--calcite-color-text-3);font-size:var(--calcite-internal-table-cell-font-size-secondary)}",d=t.proxyCustomElement(class extends t.H{constructor(){super(),this.__registerHost(),this.__attachShadow(),this.onContainerBlur=()=>{this.focused=!1},this.onContainerFocus=()=>{this.focused=!0},this.alignment="start",this.colSpan=void 0,this.description=void 0,this.heading=void 0,this.rowSpan=void 0,this.interactionMode="interactive",this.lastCell=void 0,this.numberCell=!1,this.parentRowAlignment="start",this.parentRowIsSelected=void 0,this.parentRowType=void 0,this.positionInRow=void 0,this.scale=void 0,this.selectedRowCount=void 0,this.selectedRowCountLocalized=void 0,this.selectionCell=!1,this.selectionMode=void 0,this.bodyRowCount=void 0,this.messages=void 0,this.messageOverrides=void 0,this.defaultMessages=void 0,this.focused=!1,this.screenReaderText="",this.effectiveLocale=""}onSelectedChange(){this.updateScreenReaderText()}onMessagesChange(){}async componentWillLoad(){l.setUpLoadableComponent(this),await o.setUpMessages(this),this.updateScreenReaderText()}componentDidLoad(){l.setComponentLoaded(this)}connectedCallback(){i.connectLocalized(this),o.connectMessages(this)}disconnectedCallback(){i.disconnectLocalized(this),o.disconnectMessages(this)}effectiveLocaleChange(){o.updateMessages(this,this.effectiveLocale)}async setFocus(){await l.componentFocusable(this),this.containerEl.focus()}updateScreenReaderText(){let e="";const t=`${this.selectedRowCountLocalized} ${this.messages?.selected}`;e=this.numberCell?this.messages?.rowNumber:"single"===this.selectionMode?`${this.messages?.selectionColumn}. ${t}`:this.bodyRowCount===this.selectedRowCount?`${this.messages?.selectionColumn}. ${this.messages?.all} ${t} ${this.messages?.keyboardDeselectAll}`:`${this.messages?.selectionColumn}. ${t} ${this.messages?.keyboardSelectAll}`,this.screenReaderText=e}render(){const e=this.rowSpan?"rowgroup":this.colSpan?"colgroup":"body"===this.parentRowType?"row":"col",l=this.selectedRowCount===this.bodyRowCount,o=this.selectedRowCount>0,i=l?a.checked:o?a.indeterminate:a.unchecked,c="static"===this.interactionMode&&!this.selectionCell;return t.h(t.Host,{key:"447a58f1a2aa774bbe128ddd6f5d5c0a03bf7bc7"},t.h("th",{key:"ee6cf5d248ed63e8212ffc5614d9c72cd4854bda","aria-colindex":"head"===this.parentRowType?this.positionInRow:void 0,class:{[s.bodyRow]:"body"===this.parentRowType,[s.footerRow]:"foot"===this.parentRowType,[s.contentCell]:!this.numberCell&&!this.selectionCell,[s.numberCell]:this.numberCell,[s.selectionCell]:this.selectionCell,[s.selectedCell]:this.parentRowIsSelected,[s.multipleSelectionCell]:"multiple"===this.selectionMode,[s.staticCell]:c,[s.lastCell]:this.lastCell&&(!this.rowSpan||this.colSpan&&!!this.rowSpan),[this.parentRowAlignment]:"center"===this.parentRowAlignment||"end"===this.parentRowAlignment},colSpan:this.colSpan,onBlur:this.onContainerBlur,onFocus:this.onContainerFocus,ref:e=>this.containerEl=e,role:"head"===this.parentRowType?"columnheader":"rowheader",rowSpan:this.rowSpan,scope:e,tabIndex:this.selectionCell?0:c?-1:0},this.heading&&t.h("div",{key:"549f6ea3faaa3fe66565de1d67567bfaa38cad50",class:s.heading},this.heading),this.description&&t.h("div",{key:"27f7b8de72e154917efd88d9d7f9653df65b0459",class:s.description},this.description),this.selectionCell&&"multiple"===this.selectionMode&&t.h("calcite-icon",{key:"41fb8e9cdc09f24c326d8edd70d600fee4920bc3",class:{[s.active]:o||l},icon:i,scale:n.getIconScale(this.scale)}),(this.selectionCell||this.numberCell)&&t.h("span",{key:"119b6c72bd3cc17a19863841e02b04c2312e7984","aria-live":this.focused?"polite":"off",class:s.assistiveText},this.screenReaderText)))}static get assetsDirs(){return["assets"]}get el(){return this}static get watchers(){return{selectedRowCount:["onSelectedChange"],selectedRowCountLocalized:["onSelectedChange"],messageOverrides:["onMessagesChange"],effectiveLocale:["effectiveLocaleChange"]}}static get style(){return r}},[1,"calcite-table-header",{alignment:[513],colSpan:[514,"col-span"],description:[513],heading:[513],rowSpan:[514,"row-span"],interactionMode:[1,"interaction-mode"],lastCell:[4,"last-cell"],numberCell:[4,"number-cell"],parentRowAlignment:[1,"parent-row-alignment"],parentRowIsSelected:[4,"parent-row-is-selected"],parentRowType:[1,"parent-row-type"],positionInRow:[2,"position-in-row"],scale:[1],selectedRowCount:[2,"selected-row-count"],selectedRowCountLocalized:[1,"selected-row-count-localized"],selectionCell:[4,"selection-cell"],selectionMode:[1,"selection-mode"],bodyRowCount:[2,"body-row-count"],messages:[1040],messageOverrides:[1040],defaultMessages:[32],focused:[32],screenReaderText:[32],effectiveLocale:[32],setFocus:[64]},void 0,{selectedRowCount:["onSelectedChange"],selectedRowCountLocalized:["onSelectedChange"],messageOverrides:["onMessagesChange"],effectiveLocale:["effectiveLocaleChange"]}]);function h(){if("undefined"==typeof customElements)return;["calcite-table-header","calcite-icon"].forEach((e=>{switch(e){case"calcite-table-header":customElements.get(e)||customElements.define(e,d);break;case"calcite-icon":customElements.get(e)||c.defineCustomElement()}}))}h(),e.TableHeader=d,e.defineCustomElement=h}));
