/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","./ArrayPool","./Evented","./handleUtils","./lang","./ObjectPool","./ObservableChangesType","./scheduling","./accessorSupport/ensureType","./accessorSupport/tracking","./accessorSupport/decorators/property","./accessorSupport/decorators/shared","./accessorSupport/decorators/subclass","./accessorSupport/tracking/SimpleObservable"],(function(e,t,s,i,r,n,h,a,c,l,o,_,f,g){"use strict";var b;class u{constructor(){this.target=null,this.cancellable=!1,this.defaultPrevented=!1,this.item=void 0,this.type=void 0}preventDefault(){this.cancellable&&(this.defaultPrevented=!0)}reset(e){this.defaultPrevented=!1,this.item=e}}class p{constructor(e,t,s,i,r){this.target=e,this.added=t,this.removed=s,this.start=i,this.deleteCount=r}}const d=new n(u,void 0,(e=>{e.item=null,e.target=null,e.defaultPrevented=!1,e.cancellable=!1}));function m(e){e&&"object"==typeof e&&"destroy"in e&&"function"==typeof e.destroy&&e.destroy()}function v(e){return e?e instanceof D?e.toArray():e.length?Array.prototype.slice.apply(e):[]:[]}function y(e){if(e?.length)return e[0]}function A(e,t,s,i){const r=Math.min(e.length-s,t.length-i);let n=0;for(;n<r&&e[s+n]===t[i+n];)n++;return n}function C(e,t,s,i){t&&t.forEach(((t,r,n)=>{e.push(t),C(e,s.call(i,t,r,n),s,i)}))}const O=new Set,E=new Set,k=new Set,T=new Map;let M=0,D=b=class extends s.EventedAccessor{static isCollection(e){return null!=e&&e instanceof b}constructor(e){super(e),this._chgListeners=[],this._notifications=null,this._updating=!1,this._timer=null,this._observable=new g.SimpleObservable,this.length=0,this._items=[],Object.defineProperty(this,"uid",{value:M++})}normalizeCtorArgs(e){return e?Array.isArray(e)||e instanceof b?{items:e}:e:{}}destroy(){this._removeAllRaw(),this._timer&&this._timer.remove(),this._emitter.destroy(),this._notifications=null}*[Symbol.iterator](){yield*this.items}get items(){return l.trackAccess(this._observable),this._items}set items(e){this._emitBeforeChanges(h.ObservableChangesType.ADD)||(this._splice(0,this.length,v(e)),this._emitAfterChanges(h.ObservableChangesType.ADD))}hasEventListener(e){return!this.destroyed&&("change"===e?this._chgListeners.length>0:this._emitter.hasEventListener(e))}on(e,t){if(this.destroyed)return i.makeHandle();if("change"===e){const e=this._chgListeners,s={removed:!1,callback:t};return e.push(s),this._notifications&&this._notifications.push({listeners:e.slice(),items:this._items.slice(),changes:[]}),i.makeHandle((()=>{s.removed=!0,e.splice(e.indexOf(s),1)}))}return this._emitter.on(e,t)}once(e,t){const s="deref"in t?()=>t.deref():()=>t,i=this.on(e,(e=>{s()?.call(null,e),i.remove()}));return i}add(e,t){if(l.trackAccess(this._observable),this._emitBeforeChanges(h.ObservableChangesType.ADD))return this;const s=this.getNextIndex(t??null);return this._splice(s,0,[e]),this._emitAfterChanges(h.ObservableChangesType.ADD),this}addMany(e,t=this._items.length){if(l.trackAccess(this._observable),!e?.length)return this;if(this._emitBeforeChanges(h.ObservableChangesType.ADD))return this;const s=this.getNextIndex(t);return this._splice(s,0,v(e)),this._emitAfterChanges(h.ObservableChangesType.ADD),this}at(e){if(l.trackAccess(this._observable),(e=Math.trunc(e)||0)<0&&(e+=this.length),!(e<0||e>=this.length))return this._items[e]}removeAll(){if(l.trackAccess(this._observable),!this.length||this._emitBeforeChanges(h.ObservableChangesType.REMOVE))return[];const e=this._removeAllRaw();return this._emitAfterChanges(h.ObservableChangesType.REMOVE),e}_removeAllRaw(){return 0===this.length?[]:this._splice(0,this.length)||[]}clone(){return l.trackAccess(this._observable),this._createNewInstance({items:this._items.map(r.clone)})}concat(...e){l.trackAccess(this._observable);const t=e.map(v);return this._createNewInstance({items:this._items.concat(...t)})}drain(e,t){if(l.trackAccess(this._observable),!this.length||this._emitBeforeChanges(h.ObservableChangesType.REMOVE))return;const s=this._splice(0,this.length),i=s.length;for(let r=0;r<i;r++)e.call(t,s[r],r,s);this._emitAfterChanges(h.ObservableChangesType.REMOVE)}destroyAll(){this.drain(m)}destroyMany(e){const t=this.removeMany(e);return t.forEach(m),t}every(e,t){return l.trackAccess(this._observable),this._items.every(e,t)}filter(e,t){let s;return l.trackAccess(this._observable),s=2===arguments.length?this._items.filter(e,t):this._items.filter(e),this._createNewInstance({items:s})}find(e,t){return l.trackAccess(this._observable),this._items.find(e,t)}findIndex(e,t){return l.trackAccess(this._observable),this._items.findIndex(e,t)}flatten(e,t){l.trackAccess(this._observable);const s=[];return C(s,this,e,t),new b(s)}forEach(e,t){return l.trackAccess(this._observable),this._items.forEach(e,t)}getItemAt(e){return l.trackAccess(this._observable),this._items[e]}getNextIndex(e){l.trackAccess(this._observable);const t=this.length;return(e=e??t)<0?e=0:e>t&&(e=t),e}includes(e,t=0){return l.trackAccess(this._observable),this._items.includes(e,t)}indexOf(e,t=0){return l.trackAccess(this._observable),this._items.indexOf(e,t)}join(e=","){return l.trackAccess(this._observable),this._items.join(e)}lastIndexOf(e,t=this.length-1){return l.trackAccess(this._observable),this._items.lastIndexOf(e,t)}map(e,t){l.trackAccess(this._observable);const s=this._items.map(e,t);return new b({items:s})}reorder(e,t=this.length-1){l.trackAccess(this._observable);const s=this.indexOf(e);if(-1!==s){if(t<0?t=0:t>=this.length&&(t=this.length-1),s!==t){if(this._emitBeforeChanges(h.ObservableChangesType.MOVE))return e;this._splice(s,1),this._splice(t,0,[e]),this._emitAfterChanges(h.ObservableChangesType.MOVE)}return e}}pop(){if(l.trackAccess(this._observable),!this.length||this._emitBeforeChanges(h.ObservableChangesType.REMOVE))return;const e=y(this._splice(this.length-1,1));return this._emitAfterChanges(h.ObservableChangesType.REMOVE),e}push(...e){return l.trackAccess(this._observable),this._emitBeforeChanges(h.ObservableChangesType.ADD)||(this._splice(this.length,0,e),this._emitAfterChanges(h.ObservableChangesType.ADD)),this.length}reduce(e,t){l.trackAccess(this._observable);const s=this._items;return 2===arguments.length?s.reduce(e,t):s.reduce(e)}reduceRight(e,t){l.trackAccess(this._observable);const s=this._items;return 2===arguments.length?s.reduceRight(e,t):s.reduceRight(e)}remove(e){return l.trackAccess(this._observable),this.removeAt(this.indexOf(e))}removeAt(e){if(l.trackAccess(this._observable),e<0||e>=this.length||this._emitBeforeChanges(h.ObservableChangesType.REMOVE))return;const t=y(this._splice(e,1));return this._emitAfterChanges(h.ObservableChangesType.REMOVE),t}removeMany(e){if(l.trackAccess(this._observable),!e?.length||this._emitBeforeChanges(h.ObservableChangesType.REMOVE))return[];const t=e instanceof b?e.toArray():e,s=this._items,i=[],r=t.length;for(let n=0;n<r;n++){const e=t[n],r=s.indexOf(e);if(r>-1){const e=1+A(t,s,n+1,r+1),h=this._splice(r,e);h&&h.length>0&&i.push.apply(i,h),n+=e-1}}return this._emitAfterChanges(h.ObservableChangesType.REMOVE),i}reverse(){if(l.trackAccess(this._observable),this._emitBeforeChanges(h.ObservableChangesType.MOVE))return this;const e=this._splice(0,this.length);return e&&(e.reverse(),this._splice(0,0,e)),this._emitAfterChanges(h.ObservableChangesType.MOVE),this}shift(){if(l.trackAccess(this._observable),!this.length||this._emitBeforeChanges(h.ObservableChangesType.REMOVE))return;const e=y(this._splice(0,1));return this._emitAfterChanges(h.ObservableChangesType.REMOVE),e}slice(e=0,t=this.length){return l.trackAccess(this._observable),this._createNewInstance({items:this._items.slice(e,t)})}some(e,t){return l.trackAccess(this._observable),this._items.some(e,t)}sort(e){if(l.trackAccess(this._observable),!this.length||this._emitBeforeChanges(h.ObservableChangesType.MOVE))return this;const t=this._splice(0,this.length);return arguments.length?t.sort(e):t.sort(),this._splice(0,0,t),this._emitAfterChanges(h.ObservableChangesType.MOVE),this}splice(e,t,...s){l.trackAccess(this._observable);const i=(t?h.ObservableChangesType.REMOVE:0)|(s.length?h.ObservableChangesType.ADD:0);if(this._emitBeforeChanges(i))return[];const r=this._splice(e,t,s)||[];return this._emitAfterChanges(i),r}toArray(){return l.trackAccess(this._observable),this._items.slice()}toJSON(){return l.trackAccess(this._observable),this.toArray()}toLocaleString(){return l.trackAccess(this._observable),this._items.toLocaleString()}toString(){return l.trackAccess(this._observable),this._items.toString()}unshift(...e){return l.trackAccess(this._observable),!e.length||this._emitBeforeChanges(h.ObservableChangesType.ADD)||(this._splice(0,0,e),this._emitAfterChanges(h.ObservableChangesType.ADD)),this.length}_createNewInstance(e){return new this.constructor(e)}_splice(e,t,s){const i=this._items,r=this.itemType;let n,h;if(!this._notifications&&this.hasEventListener("change")&&(this._notifications=[{listeners:this._chgListeners.slice(),items:this._items.slice(),changes:[]}],this._timer&&this._timer.remove(),this._updating=!0,this._timer=a.schedule((()=>this._dispatchChange()))),e<0&&(e+=this.length),t){if(h=i.splice(e,t),this.hasEventListener("before-remove")){const t=d.acquire();t.target=this,t.cancellable=!0;for(let s=0,r=h.length;s<r;s++)n=h[s],t.reset(n),this.emit("before-remove",t),t.defaultPrevented&&(h.splice(s,1),i.splice(e,0,n),e+=1,s-=1,r-=1);d.release(t)}if(this.length=this._items.length,this.hasEventListener("after-remove")){const e=d.acquire();e.target=this,e.cancellable=!1;const t=h.length;for(let s=0;s<t;s++)e.reset(h[s]),this.emit("after-remove",e);d.release(e)}}if(s?.length){if(r){const e=[];for(const t of s){const s=r.ensureType(t);null==s&&null!=t||e.push(s)}s=e}const t=this.hasEventListener("before-add"),n=this.hasEventListener("after-add"),h=e===this.length;if(t||n){const r=d.acquire();r.target=this,r.cancellable=!0;const a=d.acquire();a.target=this,a.cancellable=!1;for(const c of s)t?(r.reset(c),this.emit("before-add",r),r.defaultPrevented||(h?i.push(c):i.splice(e++,0,c),this._set("length",i.length),n&&(a.reset(c),this.emit("after-add",a)))):(h?i.push(c):i.splice(e++,0,c),this._set("length",i.length),a.reset(c),this.emit("after-add",a));d.release(a),d.release(r)}else{if(h)for(const e of s)i.push(e);else i.splice(e,0,...s);this._set("length",i.length)}}if((s?.length||h?.length)&&this._notifyChangeEvent(s,h),this.hasEventListener("after-splice")){const i=new p(this,s,h,e,t);this.emit("after-splice",i)}return h}_emitBeforeChanges(e){let t=!1;if(this.hasEventListener("before-changes")){const s=d.acquire();s.target=this,s.cancellable=!0,s.type=e,this.emit("before-changes",s),t=s.defaultPrevented,d.release(s)}return t}_emitAfterChanges(e){if(this.hasEventListener("after-changes")){const t=d.acquire();t.target=this,t.cancellable=!1,t.type=e,this.emit("after-changes",t),d.release(t)}this._observable.notify()}_notifyChangeEvent(e,t){this.hasEventListener("change")&&this._notifications&&this._notifications[this._notifications.length-1].changes.push({added:e,removed:t})}get updating(){return this._updating}_dispatchChange(){if(this._timer&&(this._timer.remove(),this._timer=null),this._updating=!1,!this._notifications)return;const e=this._notifications;this._notifications=null;for(const s of e){const e=s.changes;O.clear(),E.clear(),k.clear();for(const{added:t,removed:s}of e){if(t)if(0===k.size&&0===E.size)for(const e of t)O.add(e);else for(const e of t)E.has(e)?(k.add(e),E.delete(e)):k.has(e)||O.add(e);if(s)if(0===k.size&&0===O.size)for(const e of s)E.add(e);else for(const e of s)O.has(e)?O.delete(e):(k.delete(e),E.add(e))}const i=t.acquire();O.forEach((e=>{i.push(e)}));const r=t.acquire();E.forEach((e=>{r.push(e)}));const n=this._items,h=s.items,a=t.acquire();if(k.forEach((e=>{h.indexOf(e)!==n.indexOf(e)&&a.push(e)})),s.listeners&&(i.length||r.length||a.length)){const e={target:this,added:i,removed:r,moved:a},t=s.listeners.length;for(let i=0;i<t;i++){const t=s.listeners[i];t.removed||t.callback.call(this,e)}}t.release(i),t.release(r),t.release(a)}O.clear(),E.clear(),k.clear()}};D.ofType=t=>{if(!t)return b;if(T.has(t))return T.get(t);let s=null;if("function"==typeof t)s=t.prototype.declaredClass;else if(t.base)s=t.base.prototype.declaredClass;else for(const e in t.typeMap){const i=t.typeMap[e].prototype.declaredClass;s?s+=` | ${i}`:s=i}let i=class extends b{};return e.__decorate([_.shared({Type:t,ensureType:"function"==typeof t?c.ensureType(t):c.ensureOneOfType(t)})],i.prototype,"itemType",void 0),i=e.__decorate([f.subclass(`esri.core.Collection<${s}>`)],i),T.set(t,i),i},e.__decorate([o.property()],D.prototype,"_updating",void 0),e.__decorate([o.property()],D.prototype,"length",void 0),e.__decorate([o.property()],D.prototype,"items",null),e.__decorate([o.property({readOnly:!0})],D.prototype,"updating",null),D=b=e.__decorate([f.subclass("esri.core.Collection")],D);return D}));
