/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","./PooledArray"],(function(e,t){"use strict";const i=-3,s=i-1;var r;e.RemoveMode=void 0,(r=e.RemoveMode||(e.RemoveMode={}))[r.ALL=0]="ALL",r[r.SOME=1]="SOME";class h{constructor(e,t,i){this.name=e,this._storage=t,this.id=n+++":",this.size=0,this.maxSize=-1,this._removeFunc=!1,this._hit=0,this._miss=0,this._storage.register(this),i&&(this._storage.registerRemoveFunc(this.id,i),this._removeFunc=!0)}destroy(){this._storage.clear(this),this._removeFunc&&this._storage.deregisterRemoveFunc(this.id),this._storage.deregister(this),this._storage=null}get hitRate(){return this._hit/(this._hit+this._miss)}get storageSize(){return this._storage.size}getSize(e){return this._storage.getSize(this,e)}resetHitRate(){this._hit=this._miss=0}put(e,t,i,s=0){this._storage.put(this,e,t,i,s)}pop(e){const t=this._storage.pop(this,e);return void 0===t?++this._miss:++this._hit,t}get(e){const t=this._storage.get(this,e);return void 0===t?++this._miss:++this._hit,t}peek(e){return this._storage.peek(this,e)}updateSize(e,t,i){this._storage.updateSize(this,e,t,i)}clear(){this._storage.clear(this)}clearAll(){this._storage.clearAll()}get performanceInfo(){return this._storage.performanceInfo}resetStats(){this._storage.resetStats()}}class o{get size(){return this._size}constructor(e=10485760){this._maxSize=e,this._db=new Map,this._size=0,this._hit=0,this._miss=0,this._removeFuncs=new t,this._users=new t}destroy(){this.clearAll(),this._removeFuncs.clear(),this._users.clear(),this._db=null}register(e){this._users.push(e)}deregister(e){this._users.removeUnordered(e)}registerRemoveFunc(e,t){this._removeFuncs.push([e,t])}deregisterRemoveFunc(e){this._removeFuncs.filterInPlace((t=>t[0]!==e))}get maxSize(){return this._maxSize}set maxSize(e){this._maxSize=Math.max(e,-1),this._checkSize()}getSize(e,t){const i=this._db.get(e.id+t);return i?.size??0}put(t,r,h,o,n){r=t.id+r;const a=this._db.get(r);if(a&&(this._size-=a.size,t.size-=a.size,this._db.delete(r),a.entry!==h&&this._notifyRemove(r,a.entry,a.size,e.RemoveMode.ALL)),o>this._maxSize)return void this._notifyRemove(r,h,o,e.RemoveMode.ALL);if(void 0===h)return void console.warn("Refusing to cache undefined entry ");if(!o||o<0)return console.warn(`Refusing to cache entry with size ${o} for key ${r}`),void this._notifyRemove(r,h,0,e.RemoveMode.ALL);const c=1+Math.max(n,s)-i;this._db.set(r,new _(h,o,c)),this._size+=o,t.size+=o,this._checkSize()}updateSize(t,i,s,r){i=t.id+i;const h=this._db.get(i);if(h&&h.entry===s){for(this._size-=h.size,t.size-=h.size;r>this._maxSize;){const t=this._notifyRemove(i,s,r,e.RemoveMode.SOME);if(!(null!=t&&t>0))return void this._db.delete(i);r=t}h.size=r,this._size+=r,t.size+=r,this._checkSize()}}pop(e,t){t=e.id+t;const i=this._db.get(t);if(i)return this._size-=i.size,e.size-=i.size,this._db.delete(t),++this._hit,i.entry;++this._miss}get(e,t){t=e.id+t;const i=this._db.get(t);if(void 0!==i)return this._db.delete(t),i.lives=i.lifetime,this._db.set(t,i),++this._hit,i.entry;++this._miss}peek(e,t){const i=this._db.get(e.id+t);return i?++this._hit:++this._miss,i?.entry}get performanceInfo(){const e={Size:Math.round(this._size/1048576)+"/"+Math.round(this._maxSize/1048576)+"MB","Hit rate":Math.round(100*this._getHitRate())+"%",Entries:this._db.size.toString()},t={},s=new Array;this._db.forEach(((e,i)=>{const r=e.lifetime;s[r]=(s[r]||0)+e.size,this._users.forAll((s=>{const{id:r,name:h}=s;if(i.startsWith(r)){const i=t[h]||0;t[h]=i+e.size}}))}));const r={};this._users.forAll((e=>{const i=e.name;if("hitRate"in e&&"number"==typeof e.hitRate&&!isNaN(e.hitRate)&&e.hitRate>0){const s=t[i]||0;t[i]=s,r[i]=Math.round(100*e.hitRate)+"%"}else r[i]="0%"}));const h=Object.keys(t);h.sort(((e,i)=>t[i]-t[e])),h.forEach((i=>e[i]=Math.round(t[i]/2**20)+"MB / "+r[i]));for(let o=s.length-1;o>=0;--o){const t=s[o];t&&(e["Priority "+(o+i-1)]=Math.round(t/this._size*100)+"%")}return e}resetStats(){this._hit=this._miss=0,this._users.forAll((e=>e.resetHitRate()))}clear(t){const i=t.id;this._db.forEach(((t,s)=>{s.startsWith(i)&&(this._size-=t.size,this._db.delete(s),this._notifyRemove(s,t.entry,t.size,e.RemoveMode.ALL))})),t.size=0}clearAll(){this._db.forEach(((t,i)=>this._notifyRemove(i,t.entry,t.size,e.RemoveMode.ALL))),this._users.forAll((e=>e.size=0)),this._size=0,this._db.clear()}_getHitRate(){return this._hit/(this._hit+this._miss)}_notifyRemove(e,t,i,s){let r;return this._removeFuncs.some((h=>{if(e.startsWith(h[0])){const e=h[1](t,s,i);return"number"==typeof e&&(r=e),!0}return!1})),r}_checkSize(){this._users.forAll((e=>this._checkSizeLimits(e))),this._checkSizeLimits()}_checkSizeLimits(e){const t=e??this;if(t.maxSize<0||t.size<=t.maxSize)return;const i=e?.id;let s=!0;for(;s;){s=!1;for(const[r,h]of this._db)if(0===h.lifetime&&(!i||r.startsWith(i))){if(this._purgeItem(r,h,e),t.size<=.9*t.maxSize)return;s||=this._db.has(r)}}for(const[r,h]of this._db)if((!i||r.startsWith(i))&&(this._purgeItem(r,h,e),t.size<=.9*t.maxSize))return}_purgeItem(t,i,s=this._users.find((e=>t.startsWith(e.id)))){if(this._db.delete(t),i.lives<=1){this._size-=i.size,s&&(s.size-=i.size);const r=this._notifyRemove(t,i.entry,i.size,e.RemoveMode.SOME);null!=r&&r>0&&(this._size+=r,s&&(s.size+=r),i.lives=i.lifetime,i.size=r,this._db.set(t,i))}else--i.lives,this._db.set(t,i)}}let n=0;class _{constructor(e,t,i){this.entry=e,this.size=t,this.lifetime=i,this.lives=i}}e.MemCache=h,e.MemCacheStorage=o,e.MinPriority=i,e.NoPriority=s,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
