/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../has","../Logger","../MapUtils"],(function(e,n,r,t){"use strict";const u=()=>r.getLogger("esri.core.accessorSupport.ensureTypes");function o(e){return null==e?e:new Date(e)}function s(e){return null==e?e:!!e}function a(e){return null==e?e:e.toString()}function l(e,n=0){return null==e?e:(e=parseFloat(e),isNaN(e)?n:e)}function i(e){return null==e?e:Math.round(parseFloat(e))}function c(e){return null}function f(e,n){return r=>{let t=e(r);return null!=n.step&&(t=Math.round(t/n.step)*n.step),null!=n.min&&(t=Math.max(n.min,t)),null!=n.max&&(t=Math.min(n.max,t)),t}}function p(e){return e?.constructor&&void 0!==e.constructor.__accessorMetadata__}function y(e,n){return null!=n&&e&&!(n instanceof e)}function g(e){return e&&"isCollection"in e}function v(e){return e?.Type?"function"==typeof e.Type?e.Type:e.Type.base:null}function d(e,n){if(!n?.constructor||!g(n.constructor))return h(e,n)?n:new e(n);const r=v(e.prototype.itemType),t=v(n.constructor.prototype.itemType);return r?t?r===t?n:r.prototype.isPrototypeOf(t.prototype)?new e(n):(h(e,n),n):new e(n):n}function h(e,n){return!!p(n)&&(u().error("Accessor#set","Assigning an instance of '"+(n.declaredClass||"unknown")+"' which is not a subclass of '"+b(e)+"'"),!0)}function m(e,n){return null==n?n:g(e)?d(e,n):y(e,n)?h(e,n)?n:new e(n):n}function b(e){return e?.prototype?.declaredClass||"unknown"}const A=new WeakMap;function w(e){switch(e){case Number:return e=>l(e);case x:return i;case Boolean:return s;case String:return a;case Date:return o;case B:return c;default:return t.getOrCreateMapValue(A,e,(()=>m.bind(null,e)))}}function T(e,n){const r=w(e);return 1===arguments.length?r:r(n)}function $(e,n,r){return 1===arguments.length?$.bind(null,e):n?Array.isArray(n)?n.map((n=>e(n,r))):[e(n,r)]:n}function M(e,n){return 1===arguments.length?$((n=>T(e,n))):$((n=>T(e,n)),n)}function N(e,n,r){return 0!==n&&Array.isArray(r)?r.map((r=>N(e,n-1,r))):e(r)}function O(e,n,r){if(2===arguments.length)return r=>O(e,n,r);if(!r)return r;r=N(e,n,r);let t=n,u=r;for(;t>0&&Array.isArray(u);)t--,u=u[0];if(void 0!==u)for(let o=0;o<t;o++)r=[r];return r}function S(e,n,r){return 2===arguments.length?O((n=>T(e,n)),n):O((n=>T(e,n)),n,r)}function k(e){return!!Array.isArray(e)&&!e.some((n=>{const r=typeof n;return!("string"===r||"number"===r||"function"===r&&e.length>1)}))}function j(e,n){if(2===arguments.length)return j(e).call(null,n);const r=new Set,t=e.filter((e=>"function"!=typeof e)),o=e.filter((e=>"function"==typeof e));for(const u of e)"string"!=typeof u&&"number"!=typeof u||r.add(u);let s=null,a=null;return(e,n)=>{if(null==e)return e;const l=typeof e,i="string"===l||"number"===l;return i&&(r.has(e)||o.some((e=>"string"===l&&e===String||"number"===l&&e===Number)))||"object"===l&&o.some((n=>!y(e,n)))?e:(i&&t.length?(s||(s=t.map((e=>"string"==typeof e?`'${e}'`:`${e}`)).join(", ")),u().error("Accessor#set",`'${e}' is not a valid value for this property, only the following values are valid: ${s}`)):"object"==typeof e&&o.length?(a||(a=o.map((e=>b(e))).join(", ")),u().error("Accessor#set",`'${e}' is not a valid value for this property, value must be one of ${a}`)):u().error("Accessor#set",`'${e}' is not a valid value for this property`),n&&(n.valid=!1),null)}}function C(e,n){if(2===arguments.length)return C(e).call(null,n);const r={},t=[],o=[];for(const u in e.typeMap){const n=e.typeMap[u];r[u]=T(n),t.push(b(n)),o.push(u)}const s=()=>`'${t.join("', '")}'`,a=()=>`'${o.join("', '")}'`,l="string"==typeof e.key?n=>n[e.key]:e.key;return n=>{if(e.base&&!y(e.base,n))return n;if(null==n)return n;const t=l(n)||e.defaultKeyValue,o=r[t];if(!o)return u().error("Accessor#set",`Invalid property value, value needs to be one of ${s()}, or a plain object that can autocast (having .type = ${a()})`),null;if(!y(e.typeMap[t],n))return n;if("string"==typeof e.key&&!p(n)){const r={};for(const t in n)t!==e.key&&(r[t]=n[t]);return o(r)}return o(n)}}class x{}class B{}const D={native:e=>({type:"native",value:e}),array:e=>({type:"array",value:e}),oneOf:e=>({type:"one-of",values:e})};function F(e){if(!e||!("type"in e))return!1;switch(e.type){case"native":case"array":case"one-of":return!0}return!1}function I(e){switch(e.type){case"native":return T(e.value);case"array":return $(I(e.value));case"one-of":return L(e);default:return null}}function L(e){let n=null;return(r,t)=>P(r,e)?r:(null==n&&(n=_(e)),u().error("Accessor#set",`Invalid property value, value needs to be of type ${n}`),t&&(t.valid=!1),null)}function _(e){switch(e.type){case"native":switch(e.value){case Number:return"number";case String:return"string";case Boolean:return"boolean";case x:return"integer";case Date:return"date";case B:return"null";default:return b(e.value)}case"array":return`array of ${_(e.value)}`;case"one-of":{const n=e.values.map((e=>_(e)));return`one of ${n.slice(0,-1)} or ${n[n.length-1]}`}}return"unknown"}function P(e,n){if(null==e)return!0;switch(n.type){case"native":switch(n.value){case Number:case x:return"number"==typeof e;case Boolean:return"boolean"==typeof e;case String:return"string"==typeof e;case B:return null===e}return e instanceof n.value;case"array":return!!Array.isArray(e)&&!e.some((e=>!P(e,n.value)));case"one-of":return n.values.some((n=>P(e,n)))}}e.Integer=x,e.Null=B,e.ensureArray=M,e.ensureArrayTyped=$,e.ensureBoolean=s,e.ensureClass=m,e.ensureDate=o,e.ensureInteger=i,e.ensureLongFormType=I,e.ensureNArray=S,e.ensureNArrayTyped=O,e.ensureNull=c,e.ensureNumber=l,e.ensureOneOf=j,e.ensureOneOfType=C,e.ensureRange=f,e.ensureString=a,e.ensureType=T,e.isClassedType=p,e.isLongFormType=F,e.isOneOf=k,e.requiresType=y,e.types=D,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
