/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../mathUtils","../string","./DateOnly","./errorSupport","./sqlCompareUtils","./sqlDateParsingUtils","./TimeOnly","../../chunks/datetime"],(function(a,e,r,n,t,l,s,u,o){"use strict";function i(a,e,r){const n=S[a.toLowerCase()];if(null==n)throw new t.SqlError(t.SqlErrorCodes.FunctionNotRecognized);if(e.length<n.minParams||e.length>n.maxParams)throw new t.SqlError(t.SqlErrorCodes.InvalidParameterCount,{name:a.toUpperCase()});return n.evaluate(e,r)}function m(a,e){const r=S[a.toLowerCase()];return null!=r&&e>=r.minParams&&e<=r.maxParams}function c(a){return"string"==typeof a||a instanceof String}function f(a){return!s.isDate(a)&&(!s.isDateOnly(a)&&(!s.isDateTime(a)&&(!s.isTimeOnly(a)&&!s.isTimestampOffset(a))))}function E(a){return s.isDateOnly(a)||s.isTimeOnly(a)?a.toString():s.isTimestampOffset(a)?a.toSQLValue():s.isDateTime(a)?0===a.millisecond?a.toFormat("yyyy-LL-dd HH:mm:ss"):a.toSQL({includeOffset:!1}):s.isDate(a)?E(o.DateTime.fromJSDate(a)):a.toString()}function h(a){if(s.isDate(a))return n.DateOnly.fromDateJS(a);if(s.isDateTime(a))return n.DateOnly.fromParts(a.year,a.month,a.day);if(s.isDateOnly(a))return a;if(s.isTimeOnly(a))throw new t.SqlError(t.SqlErrorCodes.CannotCastValue);if(s.isTimestampOffset(a)){if(null===n.DateOnly.fromParts(a.year,a.month,a.day))throw new t.SqlError(t.SqlErrorCodes.CannotCastValue)}if(c(a)){const e=n.DateOnly.fromReader(a);if(null!==e&&e.isValid)return e}throw new t.SqlError(t.SqlErrorCodes.CannotCastValue)}function P(a,e,r){if(s.isDate(a))return s.convertToExecutingTimeZone(a,e);if(s.isDateTime(a))return a;if(s.isDateOnly(a))return a.toDateTimeLuxon("unknown");if(s.isTimeOnly(a))throw new t.SqlError(t.SqlErrorCodes.CannotCastValue);if(s.isTimestampOffset(a))return a;if(c(a))return s.parseTimestamp(a,"unknown",r);throw new t.SqlError(t.SqlErrorCodes.CannotCastValue)}function C(a){if(s.isDate(a))return u.TimeOnly.fromDateJS(a);if(s.isDateTime(a))return u.TimeOnly.fromDateTime(a);if(s.isDateOnly(a))throw new t.SqlError(t.SqlErrorCodes.CannotCastValue);if(s.isTimeOnly(a))return a;if(s.isTimestampOffset(a))return u.TimeOnly.fromSqlTimeStampOffset(a);if(c(a))return s.parseTime(a);throw new t.SqlError(t.SqlErrorCodes.CannotCastValue)}const S={extract:{minParams:2,maxParams:2,evaluate:([a,e])=>{if(null==e)return null;if(s.isDate(e))switch(a.toUpperCase()){case"SECOND":return e.getSeconds();case"MINUTE":return e.getMinutes();case"HOUR":return e.getHours();case"DAY":return e.getDate();case"MONTH":return e.getMonth()+1;case"YEAR":return e.getFullYear();case"TIMEZONE_HOUR":case"TIMEZONE_MINUTE":return 0}else if(s.isDateTime(e))switch(a.toUpperCase()){case"SECOND":return e.second;case"MINUTE":return e.minute;case"HOUR":return e.hour;case"DAY":return e.day;case"MONTH":return e.month;case"YEAR":return e.year;case"TIMEZONE_HOUR":case"TIMEZONE_MINUTE":throw new t.SqlError(t.SqlErrorCodes.InvalidFunctionParameters,{function:"EXTRACT"})}else if(s.isDateOnly(e))switch(a.toUpperCase()){case"DAY":return e.day;case"MONTH":return e.month;case"YEAR":return e.year;case"TIMEZONE_HOUR":case"TIMEZONE_MINUTE":throw new t.SqlError(t.SqlErrorCodes.InvalidFunctionParameters,{function:"EXTRACT"})}else if(s.isTimeOnly(e))switch(a.toUpperCase()){case"SECOND":return e.second;case"MINUTE":return e.minute;case"HOUR":return e.hour}else if(s.isTimestampOffset(e))switch(a.toUpperCase()){case"SECOND":return e.second;case"MINUTE":return e.minute;case"HOUR":return e.hour;case"DAY":return e.day;case"MONTH":return e.month;case"YEAR":return e.year;case"TIMEZONE_HOUR":return e.timezoneOffsetHour;case"TIMEZONE_MINUTE":return e.timezoneOffsetMinutes}throw new t.SqlError(t.SqlErrorCodes.InvalidFunctionParameters,{function:"EXTRACT"})}},substring:{minParams:2,maxParams:3,evaluate:a=>{if(2===a.length){const[e,r]=a;return null==e||null==r?null:e.toString().substring(r-1)}if(3===a.length){const[e,r,n]=a;return null==e||null==r||null==n?null:n<=0?"":e.toString().substring(r-1,r+n-1)}}},position:{minParams:2,maxParams:2,evaluate:([a,e])=>null==a||null==e?null:e.indexOf(a)+1},trim:{minParams:2,maxParams:3,evaluate:a=>{const e=3===a.length,n=e?a[1]:" ",l=e?a[2]:a[1];if(null==n||null==l)return null;const s=`(${r.escapeRegExpString(n)})`;switch(a[0]){case"BOTH":return l.replaceAll(new RegExp(`^${s}*|${s}*$`,"g"),"");case"LEADING":return l.replaceAll(new RegExp(`^${s}*`,"g"),"");case"TRAILING":return l.replaceAll(new RegExp(`${s}*$`,"g"),"")}throw new t.SqlError(t.SqlErrorCodes.InvalidFunctionParameters,{function:"TRIM"})}},abs:{minParams:1,maxParams:1,evaluate:a=>null==a[0]?null:Math.abs(a[0])},ceiling:{minParams:1,maxParams:1,evaluate:a=>null==a[0]?null:Math.ceil(a[0])},floor:{minParams:1,maxParams:1,evaluate:a=>null==a[0]?null:Math.floor(a[0])},log:{minParams:1,maxParams:1,evaluate:a=>null==a[0]?null:Math.log(a[0])},log10:{minParams:1,maxParams:1,evaluate:a=>null==a[0]?null:Math.log(a[0])*Math.LOG10E},sin:{minParams:1,maxParams:1,evaluate:a=>null==a[0]?null:Math.sin(a[0])},cos:{minParams:1,maxParams:1,evaluate:a=>null==a[0]?null:Math.cos(a[0])},tan:{minParams:1,maxParams:1,evaluate:a=>null==a[0]?null:Math.tan(a[0])},asin:{minParams:1,maxParams:1,evaluate:a=>null==a[0]?null:Math.asin(a[0])},acos:{minParams:1,maxParams:1,evaluate:a=>null==a[0]?null:Math.acos(a[0])},atan:{minParams:1,maxParams:1,evaluate:a=>null==a[0]?null:Math.atan(a[0])},sign:{minParams:1,maxParams:1,evaluate:a=>null==a[0]?null:a[0]>0?1:a[0]<0?-1:0},power:{minParams:2,maxParams:2,evaluate:a=>null==a[0]||null==a[1]?null:a[0]**a[1]},mod:{minParams:2,maxParams:2,evaluate:a=>null==a[0]||null==a[1]?null:a[0]%a[1]},round:{minParams:1,maxParams:2,evaluate:a=>{const e=a[0],r=2===a.length?10**a[1]:1;return null==e?null:Math.round(e*r)/r}},truncate:{minParams:1,maxParams:2,evaluate:a=>null==a[0]?null:1===a.length||0===a[1]?Math.trunc(a[0]):e.decimalAdjust("trunc",a[0],-Number(a[1]))},char_length:{minParams:1,maxParams:1,evaluate:a=>c(a[0])?a[0].length:0},concat:{minParams:1,maxParams:1/0,evaluate:a=>{let e="";for(let r=0;r<a.length;r++){if(null==a[r])return null;e+=a[r].toString()}return e}},lower:{minParams:1,maxParams:1,evaluate:a=>null==a[0]?null:a[0].toString().toLowerCase()},upper:{minParams:1,maxParams:1,evaluate:a=>null==a[0]?null:a[0].toString().toUpperCase()},coalesce:{minParams:1,maxParams:1/0,evaluate:a=>{for(const e of a)if(null!==e)return e;return null}},cosh:{minParams:1,maxParams:1,evaluate:a=>null==a[0]?null:Math.cosh(a[0])},sinh:{minParams:1,maxParams:1,evaluate:a=>null==a[0]?null:Math.sinh(a[0])},tanh:{minParams:1,maxParams:1,evaluate:a=>null==a[0]?null:Math.tanh(a[0])},nullif:{minParams:2,maxParams:2,evaluate:(a,e)=>l.sqlCompare(a[0],a[1],"=")?null:a[0]},cast:{minParams:2,maxParams:2,evaluate:(a,e)=>{const r=a[0],n=a[1];if(null===r)return null;switch(n.type){case"integer":{if(!f(r))throw new t.SqlError(t.SqlErrorCodes.CannotCastValue);const a=parseInt(r,10);if(isNaN(a))throw new t.SqlError(t.SqlErrorCodes.CannotCastValue);return a}case"smallint":{if(!f(r))throw new t.SqlError(t.SqlErrorCodes.CannotCastValue);const a=parseInt(r,10);if(isNaN(a))throw new t.SqlError(t.SqlErrorCodes.CannotCastValue);if(a>32767||a<-32767)throw new t.SqlError(t.SqlErrorCodes.CannotCastValue);return a}case"float":case"real":{if(!f(r))throw new t.SqlError(t.SqlErrorCodes.CannotCastValue);const a=parseFloat(r);if(isNaN(a))throw new t.SqlError(t.SqlErrorCodes.CannotCastValue);return a}case"time":return C(r);case"date":return h(r);case"timestamp":return P(r,e,!0===n.withtimezone);case"varchar":{const a=E(r);if(a.length>n.size)throw new t.SqlError(t.SqlErrorCodes.CannotCastValue);return a}default:throw new t.SqlError(t.SqlErrorCodes.InvalidDataType)}}}};a.evaluateFunction=i,a.isStandardized=m,Object.defineProperty(a,Symbol.toStringTag,{value:"Module"})}));
