/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../arcade/kernel","../../intl/locale","../../chunks/datetime"],(function(t,e,s,i){"use strict";function n(t){if(!t)return"";const e=/(a|A|hh?|HH?|mm?|ss?|SSS|S|.)/g;let s="";for(const i of t.match(e)||[])switch(i){case"SSS":case"m":case"mm":case"h":case"hh":case"H":case"HH":case"s":case"ss":s+=i;break;case"A":case"a":s+="a";break;default:s+=`'${i}'`}return s}class r{constructor(t,e,s,i){this._hour=t,this._minute=e,this._second=s,this._millisecond=i,this.declaredRootClass="esri.core.sql.timeonly"}get hour(){return this._hour}get minute(){return this._minute}get second(){return this._second}get millisecond(){return this._millisecond}equals(t){return t instanceof r&&t.hour===this.hour&&t.minute===this.minute&&t.second===this.second&&t.millisecond===this.millisecond}clone(){return new r(this.hour,this.minute,this.second,this.millisecond)}isValid(){return e.isInteger(this.hour)&&e.isInteger(this.minute)&&e.isInteger(this.second)&&e.isInteger(this.millisecond)&&this.hour>=0&&this.hour<24&&this.minute>=0&&this.minute<60&&this.second>=0&&this.second<60&&this.millisecond>=0&&this.millisecond<1e3}toString(){return`${this.hour.toString().padStart(2,"0")}:${this.minute.toString().padStart(2,"0")}:${this.second.toString().padStart(2,"0")}`+(this.millisecond>0?"."+this.millisecond.toString().padStart(3,"0"):"")}toSQLValue(){return this.toString()}toSQLWithKeyword(){return`time '${this.hour.toString().padStart(2,"0")}:${this.minute.toString().padStart(2,"0")}:${this.second.toString().padStart(2,"0")}${this.millisecond>0?"."+this.millisecond.toString().padStart(3,"0"):""}'`}toStorageString(){return`${this.hour.toString().padStart(2,"0")}:${this.minute.toString().padStart(2,"0")}:${this.second.toString().padStart(2,"0")}`}toFormat(t=null){if(null===t||""===t)return this.toString();if(!(t=n(t)))return"";return i.DateTime.local(1970,1,1,this._hour,this._minute,this._second,this._millisecond).toFormat(t,{locale:s.getLocale(),numberingSystem:"latn"})}toNumber(){return this.millisecond+1e3*this.second+1e3*this.minute*60+60*this.hour*60*1e3}static fromParts(t,e,s,i){const n=new r(t,e,s,i);return n.isValid()?n:null}static fromReader(t){if(!t)return null;const e=t.split(":");return 3!==e.length?null:new r(parseInt(e[0],10),parseInt(e[1],10),parseInt(e[2],10),0)}static fromMilliseconds(t){if(t>864e5||t<0)return null;const e=Math.floor(t/1e3%60),s=Math.floor(t/6e4%60),i=Math.floor(t/36e5%24),n=Math.floor(t%1e3);return new r(i,s,e,n)}static fromDateJS(t){return new r(t.getHours(),t.getMinutes(),t.getSeconds(),t.getMilliseconds())}static fromDateTime(t){return new r(t.hour,t.minute,t.second,t.millisecond)}static fromSqlTimeStampOffset(t){return this.fromDateTime(t.toDateTime())}static fromString(t,e=null){if(""===t)return null;if(null===t)return null;const s=[];e?(e=n(e))&&s.push(e):null!==e&&""!==e||(s.push("HH:mm:ss"),s.push("HH:mm:ss.SSS"),s.push("hh:mm:ss a"),s.push("hh:mm:ss.SSS a"),s.push("HH:mm"),s.push("hh:mm a"),s.push("H:mm"),s.push("h:mm a"),s.push("H:mm:ss"),s.push("h:mm:ss a"),s.push("H:mm:ss.SSS"),s.push("h:mm:ss.SSS a"));for(const n of s){const e=i.DateTime.fromFormat(t,n);if(e.isValid)return new r(e.hour,e.minute,e.second,e.millisecond)}return null}plus(t,e){switch(t){case"days":case"years":case"months":return this.clone();case"hours":case"minutes":case"seconds":case"milliseconds":return r.fromDateTime(this.toUTCDateTime().plus({[t]:e}))}return null}toUTCDateTime(){return i.DateTime.utc(1970,1,1,this.hour,this.minute,this.second,this.millisecond)}difference(t,e){switch(e.toLowerCase()){case"days":case"day":case"d":return this.toUTCDateTime().diff(t.toUTCDateTime(),"days").days;case"months":case"month":return this.toUTCDateTime().diff(t.toUTCDateTime(),"months").months;case"minutes":case"minute":case"m":return"M"===e?this.toUTCDateTime().diff(t.toUTCDateTime(),"months").months:this.toUTCDateTime().diff(t.toUTCDateTime(),"minutes").minutes;case"seconds":case"second":case"s":return this.toUTCDateTime().diff(t.toUTCDateTime(),"seconds").seconds;case"milliseconds":case"millisecond":case"ms":default:return this.toUTCDateTime().diff(t.toUTCDateTime(),"milliseconds").milliseconds;case"hours":case"hour":case"h":return this.toUTCDateTime().diff(t.toUTCDateTime(),"hours").hours;case"years":case"year":case"y":return this.toUTCDateTime().diff(t.toUTCDateTime(),"years").years}}}t.TimeOnly=r,t.standardizeTimeFormat=n,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
