/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../arcade/ArcadeDate","../has","./AggregateFunctions","./DateOnly","./errorSupport","./sqlArithmeticUtils","./sqlCompareUtils","./sqlDateParsingUtils","./SqlInterval","./SqlTimestampOffset","./StandardizedFunctions","./TimeOnly","./WhereGrammar","../../chunks/datetime"],(function(e,t,r,a,s,i,n,l,o,u,c,h,p,m,d){"use strict";const f=new Set(["current_timestamp","current_date","current_time"]);class v{static makeBool(e){return N(e)}static featureValue(e,t,r,a){return E(e,t,r,a)}static equalsNull(e){return null===e}static applyLike(e,t,r){return w(e,t,r)}static ensureArray(e){return S(e)}static applyIn(e,t,r){return O(e,t)}static currentTimestamp(e){return o.convertToExecutingTimeZone(new Date,e)}static currentDate(e){return s.DateOnly.fromNow(e)}static currentTime(e){const t=o.convertToExecutingTimeZone(new Date,e);return p.TimeOnly.fromDateTime(t)}static makeSqlInterval(e,t,r){return u.SqlInterval.createFromValueAndQualifier(e,t,r)}static convertInterval(e){return e instanceof u.SqlInterval?e.valueInMilliseconds():e}static compare(e,t,r,a){return l.sqlCompare(t,r,e)}static calculate(e,t,r,a){return n.sqlCalculateFunction(e,t,r,a)}static evaluateTime(e){return o.parseTime(e)}static evaluateTimestamp(e,t,r){return o.parseTimestamp(e,t,r)}static evaluateDate(e,t){return o.parseDate(e,t)}static evaluateFunction(e,t,r){return h.evaluateFunction(e,t,r)}static lookup(e,t){const r=t[e];return void 0===r?null:r}static between(e,t,r){return null==e||null==t[0]||null==t[1]?null:l.sqlCompare(e,t[0],">=")&&l.sqlCompare(e,t[1],"<=")}static notbetween(e,t,r){return null==e||null==t[0]||null==t[1]?null:l.sqlCompare(e,t[0],"<")||l.sqlCompare(e,t[1],">")}static ternaryNot(e){return g(e)}static ternaryAnd(e,t){return y(e,t)}static ternaryOr(e,t){return _(e,t)}}class T{constructor(e,t,r="UTC",a=null){this.fieldsIndex=t,this.timeZone=r,this.currentUser=a,this.parameters={},this._hasDateFunctions=void 0,this.parseTree=m.WhereGrammar.parse(e);const{isStandardized:s,isAggregate:i,currentUserRequired:n,referencedFieldNames:l}=this._extractExpressionInfo(t);this._referencedFieldNames=l,this.isStandardized=s,this.isAggregate=i,this.currentUserRequired=n}static convertValueToStorageFormat(e,t=null){if(null===t)return o.isDate(e)?e.getTime():o.isDateTime(e)?e.toMillis():o.isTimestampOffset(e)?e.toStorageFormat():o.isTimeOnly(e)?e.toStorageString():o.isDateOnly(e)?e.toStorageFormat():e;switch(t){case"date":return o.isDate(e)?e.getTime():o.isDateTime(e)?e.toMillis():o.isTimestampOffset(e)?e.toMilliseconds():o.isDateOnly(e)?e.toNumber():e;case"date-only":return o.isDate(e)?s.DateOnly.fromDateJS(e).toString():o.isTimestampOffset(e)?s.DateOnly.fromSqlTimeStampOffset(e).toString():o.isDateTime(e)?s.DateOnly.fromDateTime(e).toString():e;case"time-only":return o.isDate(e)?p.TimeOnly.fromDateJS(e).toStorageString():o.isDateTime(e)?p.TimeOnly.fromDateTime(e).toStorageString():o.isTimestampOffset(e)?p.TimeOnly.fromSqlTimeStampOffset(e).toStorageString():o.isTimeOnly(e)?e.toStorageString():e;case"timestamp-offset":if(o.isDate(e))return c.SqlTimeStampOffset.fromJSDate(e).toStorageFormat();if(o.isDateTime(e))return c.SqlTimeStampOffset.fromDateTime(e).toStorageFormat();if(o.isTimestampOffset(e))return e.toStorageFormat()}return e}static create(e,t={}){return new T(e,t.fieldsIndex,t.timeZone??void 0,t.currentUser)}get fieldNames(){return this._referencedFieldNames}testSet(e,t=F,r=this.currentUser){return!!this._evaluateNode(this.parseTree,null,t,e,r)}calculateValue(e,t=F,r=this.currentUser){const a=this._evaluateNode(this.parseTree,e,t,null,r);return a instanceof u.SqlInterval?a.valueInMilliseconds()/864e5:a}calculateValueCompiled(e,t=F,a=this.currentUser){return null!=this.parseTree._compiledVersion?this.parseTree._compiledVersion(e,this.parameters,t,this.fieldsIndex,this.timeZone,a??null):r("esri-csp-restrictions")?this.calculateValue(e,t):(this._compileMe(),this.parseTree._compiledVersion(e,this.parameters,t,this.fieldsIndex,this.timeZone,a??null))}testFeature(e,t=F,r=this.currentUser){return!!this._evaluateNode(this.parseTree,e,t,null,r)}testFeatureCompiled(e,t=F,a=this.currentUser){return null!=this.parseTree._compiledVersion?!!this.parseTree._compiledVersion(e,this.parameters,t,this.fieldsIndex,this.timeZone,a??null):r("esri-csp-restrictions")?this.testFeature(e,t):(this._compileMe(),!!this.parseTree._compiledVersion(e,this.parameters,t,this.fieldsIndex,this.timeZone,a??null))}get hasDateFunctions(){return null!=this._hasDateFunctions||(this._hasDateFunctions=!1,m.visitAll(this.parseTree,(e=>{"current-time"===e.type?this._hasDateFunctions=!0:"function"===e.type&&(this._hasDateFunctions=this._hasDateFunctions||f.has(e.name.toLowerCase()))}))),this._hasDateFunctions}getFunctions(){const e=new Set;return m.visitAll(this.parseTree,(t=>{"function"===t.type&&e.add(t.name.toLowerCase())})),Array.from(e)}getExpressions(){const e=new Map;return m.visitAll(this.parseTree,(t=>{if("function"===t.type){const r=t.name.toLowerCase(),a=t.args.value[0];if("column-reference"===a.type){const t=a.column,s=`${r}-${t}`;e.has(s)||e.set(s,{aggregateType:r,field:t})}}})),[...e.values()]}getVariables(){const e=new Set;return m.visitAll(this.parseTree,(t=>{"parameter"===t.type&&e.add(t.value.toLowerCase())})),Array.from(e)}_compileMe(){const e="return this.convertInterval("+this.evaluateNodeToJavaScript(this.parseTree)+")";this.parseTree._compiledVersion=new Function("feature","lookups","attributeAdapter","fieldsIndex","timeZone","currentUser",e).bind(v)}_extractExpressionInfo(e){const t=[],r=new Set;let s=!0,i=!1,n=!1;return m.visitAll(this.parseTree,(l=>{switch(l.type){case"column-reference":{const a=e?.get(l.column);let s,i;a?s=i=a.name??"":(i=l.column,s=i.toLowerCase()),r.has(s)||(r.add(s),t.push(i)),l.column=i;break}case"current-user":n=!0;break;case"function":{const{name:e,args:t}=l,r=t.value.length;s&&(s=h.isStandardized(e,r)),!1===i&&(i=a.isAggregate(e,r));break}}})),{referencedFieldNames:Array.from(t),isStandardized:s,isAggregate:i,currentUserRequired:n}}evaluateNodeToJavaScript(e){switch(e.type){case"interval":return"this.makeSqlInterval("+this.evaluateNodeToJavaScript(e.value)+", "+JSON.stringify(e.qualifier)+","+JSON.stringify(e.op)+")";case"case-expression":{let t="";if("simple"===e.format){const r=this.evaluateNodeToJavaScript(e.operand);t="( ";for(let a=0;a<e.clauses.length;a++)t+=" (this.compare('=',"+r+","+this.evaluateNodeToJavaScript(e.clauses[a].operand)+") ? ("+this.evaluateNodeToJavaScript(e.clauses[a].value)+") : ";null!==e.else?t+=this.evaluateNodeToJavaScript(e.else):t+="null",t+=" )"}else{t="( ";for(let r=0;r<e.clauses.length;r++)t+=" this.makeBool("+this.evaluateNodeToJavaScript(e.clauses[r].operand)+")===true ? ("+this.evaluateNodeToJavaScript(e.clauses[r].value)+") : ";null!==e.else?t+=this.evaluateNodeToJavaScript(e.else):t+="null",t+=" )"}return t}case"parameter":return"this.lookup("+JSON.stringify(e.value.toLowerCase())+",lookups)";case"expression-list":{let t="[";for(const r of e.value)"["!==t&&(t+=","),t+=this.evaluateNodeToJavaScript(r);return t+="]",t}case"unary-expression":return"this.ternaryNot("+this.evaluateNodeToJavaScript(e.expr)+")";case"binary-expression":switch(e.operator){case"AND":return"this.ternaryAnd("+this.evaluateNodeToJavaScript(e.left)+","+this.evaluateNodeToJavaScript(e.right)+" )";case"OR":return"this.ternaryOr("+this.evaluateNodeToJavaScript(e.left)+","+this.evaluateNodeToJavaScript(e.right)+" )";case"IS":if("null"!==e.right.type)throw new i.SqlError(i.SqlErrorCodes.UnsupportedIsRhs);return"this.equalsNull("+this.evaluateNodeToJavaScript(e.left)+")";case"ISNOT":if("null"!==e.right.type)throw new i.SqlError(i.SqlErrorCodes.UnsupportedIsRhs);return"(!(this.equalsNull("+this.evaluateNodeToJavaScript(e.left)+")))";case"IN":return"this.applyIn("+this.evaluateNodeToJavaScript(e.left)+",this.ensureArray("+this.evaluateNodeToJavaScript(e.right)+"), timeZone)";case"NOT IN":return"this.ternaryNot(this.applyIn("+this.evaluateNodeToJavaScript(e.left)+",this.ensureArray("+this.evaluateNodeToJavaScript(e.right)+"), timeZone))";case"BETWEEN":return"this.between("+this.evaluateNodeToJavaScript(e.left)+","+this.evaluateNodeToJavaScript(e.right)+", timeZone)";case"NOTBETWEEN":return"this.notbetween("+this.evaluateNodeToJavaScript(e.left)+","+this.evaluateNodeToJavaScript(e.right)+", timeZone)";case"LIKE":return"this.applyLike("+this.evaluateNodeToJavaScript(e.left)+","+this.evaluateNodeToJavaScript(e.right)+","+JSON.stringify(e.escape)+")";case"NOT LIKE":return"this.ternaryNot(this.applyLike("+this.evaluateNodeToJavaScript(e.left)+","+this.evaluateNodeToJavaScript(e.right)+","+JSON.stringify(e.escape)+"))";case"<>":case"<":case">":case">=":case"<=":case"=":return"this.compare("+JSON.stringify(e.operator)+","+this.evaluateNodeToJavaScript(e.left)+","+this.evaluateNodeToJavaScript(e.right)+", timeZone)";case"*":case"-":case"+":case"/":case"||":return"this.calculate("+JSON.stringify(e.operator)+","+this.evaluateNodeToJavaScript(e.left)+","+this.evaluateNodeToJavaScript(e.right)+", timeZone)";default:throw new i.SqlError(i.SqlErrorCodes.UnsupportedOperator,{operator:e.operator})}case"null":case"boolean":case"string":case"number":return JSON.stringify(e.value);case"time":return"this.evaluateTime("+JSON.stringify(e.value)+")";case"date":return"this.evaluateDate("+JSON.stringify(e.value)+", 'unknown')";case"timestamp":return"this.evaluateTimestamp("+JSON.stringify(e.value)+", 'unknown')";case"current-time":return"date"===e.mode?"this.currentDate(timeZone)":"time"===e.mode?"this.currentTime(timeZone)":"this.currentTimestamp(timeZone)";case"current-user":return"currentUser";case"column-reference":return"this.featureValue(feature,"+JSON.stringify(e.column)+",fieldsIndex,attributeAdapter)";case"function":return"this.evaluateFunction("+JSON.stringify(e.name)+","+this.evaluateNodeToJavaScript(e.args)+", timeZone)"}throw new i.SqlError(i.SqlErrorCodes.UnsupportedSyntax,{node:e.type})}_evaluateNode(e,r,s,c,p){let m;switch(e.type){case"interval":{const t=this._evaluateNode(e.value,r,s,c,p);return u.SqlInterval.createFromValueAndQualifier(t,e.qualifier,e.op)}case"case-expression":if("simple"===e.format){const t=this._evaluateNode(e.operand,r,s,c,p);for(let a=0;a<e.clauses.length;a++)if(l.sqlCompare(t,this._evaluateNode(e.clauses[a].operand,r,s,c,p),"=",this.timeZone))return this._evaluateNode(e.clauses[a].value,r,s,c,p);if(null!==e.else)return this._evaluateNode(e.else,r,s,c,p)}else{for(let t=0;t<e.clauses.length;t++)if(N(this._evaluateNode(e.clauses[t].operand,r,s,c,p)))return this._evaluateNode(e.clauses[t].value,r,s,c,p);if(null!==e.else)return this._evaluateNode(e.else,r,s,c,p)}return null;case"parameter":return m=this.parameters[e.value.toLowerCase()],o.isDate(m)?d.DateTime.fromJSDate(m):m instanceof t.ArcadeDate?m.toDateTime():m;case"expression-list":{const t=[];for(const a of e.value)t.push(this._evaluateNode(a,r,s,c,p));return t}case"unary-expression":return g(this._evaluateNode(e.expr,r,s,c,p));case"binary-expression":switch(e.operator){case"AND":return y(this._evaluateNode(e.left,r,s,c,p),this._evaluateNode(e.right,r,s,c,p));case"OR":return _(this._evaluateNode(e.left,r,s,c,p),this._evaluateNode(e.right,r,s,c,p));case"IS":if("null"!==e.right.type)throw new i.SqlError(i.SqlErrorCodes.UnsupportedIsRhs);return null===this._evaluateNode(e.left,r,s,c,p);case"ISNOT":if("null"!==e.right.type)throw new i.SqlError(i.SqlErrorCodes.UnsupportedIsRhs);return null!==this._evaluateNode(e.left,r,s,c,p);case"IN":{const t=S(this._evaluateNode(e.right,r,s,c,p));return O(this._evaluateNode(e.left,r,s,c,p),t,this.timeZone)}case"NOT IN":{const t=S(this._evaluateNode(e.right,r,s,c,p));return g(O(this._evaluateNode(e.left,r,s,c,p),t,this.timeZone))}case"BETWEEN":{const t=this._evaluateNode(e.left,r,s,c,p),a=this._evaluateNode(e.right,r,s,c,p);return null==t||null==a[0]||null==a[1]?null:l.sqlCompare(t,a[0],">=",this.timeZone)&&l.sqlCompare(t,a[1],"<=",this.timeZone)}case"NOTBETWEEN":{const t=this._evaluateNode(e.left,r,s,c,p),a=this._evaluateNode(e.right,r,s,c,p);return null==t||null==a[0]||null==a[1]?null:l.sqlCompare(t,a[0],"<",this.timeZone)||l.sqlCompare(t,a[1],">",this.timeZone)}case"LIKE":return w(this._evaluateNode(e.left,r,s,c,p),this._evaluateNode(e.right,r,s,c,p),e.escape);case"NOT LIKE":return g(w(this._evaluateNode(e.left,r,s,c,p),this._evaluateNode(e.right,r,s,c,p),e.escape));case"<>":case"<":case">":case">=":case"<=":case"=":return l.sqlCompare(this._evaluateNode(e.left,r,s,c,p),this._evaluateNode(e.right,r,s,c,p),e.operator,this.timeZone);case"-":case"+":case"*":case"/":case"||":return n.sqlCalculateFunction(e.operator,this._evaluateNode(e.left,r,s,c,p),this._evaluateNode(e.right,r,s,c,p),this.timeZone)}case"null":case"boolean":case"string":case"number":return e.value;case"date":return e.parsedValue??=o.parseDate(e.value,"unknown"),e.parsedValue;case"timestamp":return e.parsedValue??=o.parseTimestamp(e.value,"unknown"),e.parsedValue;case"time":return o.parseTime(e.value);case"current-time":return"date"===e.mode?v.currentDate(this.timeZone):"time"===e.mode?v.currentTime(this.timeZone):v.currentTimestamp(this.timeZone);case"current-user":return p??null;case"column-reference":return E(r,e.column,this.fieldsIndex,s);case"data-type":return e.value;case"function":{if(this.isAggregate&&a.isAggregate(e.name,e.args.value.length)){const t=[];for(const r of e.args?.value||[]){const e=[];for(const t of c||[])e.push(this._evaluateNode(r,t,s,null,p));t.push(e)}return a.aggregateFunction(e.name,t)}const t=this._evaluateNode(e.args,r,s,c,p);return h.evaluateFunction(e.name,t,this.timeZone)}}throw new i.SqlError(i.SqlErrorCodes.UnsupportedSyntax,{node:e.type})}}function N(e){return!0===e}function S(e){return Array.isArray(e)?e:[e]}function g(e){return null!==e?!0!==e:null}function y(e,t){return null!=e&&null!=t?!0===e&&!0===t:!1!==e&&!1!==t&&null}function _(e,t){return null!=e&&null!=t?!0===e||!0===t:!0===e||!0===t||null}function O(e,t,r){if(null==e)return null;let a=!1;for(const s of t)if(null==s)a=null;else{if(e===s){a=!0;break}if(l.isDateOrTimeValue(e)&&l.isDateOrTimeValue(s)&&(a=l.sqlCompare(e,s,"="),a))break}return a}const D="-[]/{}()*+?.\\^$|";var q;function J(e,t){const r=t;let a="",s=q.Normal;for(let i=0;i<e.length;i++){const t=e.charAt(i);switch(s){case q.Normal:t===r?s=q.Escaped:D.includes(t)?a+="\\"+t:a+="%"===t?".*":"_"===t?".":t;break;case q.Escaped:D.includes(t)?a+="\\"+t:a+=t,s=q.Normal}}return new RegExp("^"+a+"$","m")}function w(e,t,r){if(null==e)return null;return J(t,r).test(e)}function I(e){return e&&"object"==typeof e.attributes}function E(e,t,r,a){const i=a.getAttribute(e,t),n=r?.get(t);return null==i||"esriFieldTypeDate"!==n?.type&&"date"!==n?.type?null==i||"esriFieldTypeDateOnly"!==n?.type&&"date-only"!==n?.type?null==i||"esriFieldTypeTimeOnly"!==n?.type&&"time-only"!==n?.type?null==i||"esriFieldTypeTimestampOffset"!==n?.type&&"timestamp-offset"!==n?.type?i:new c.SqlTimeStampOffset(i):p.TimeOnly.fromReader(i):s.DateOnly.fromReader(i):o.convertToExecutingTimeZone(new Date(i),r?.getLuxonTimeZone(n.name)??d.FixedOffsetZone.utcInstance)}!function(e){e[e.Normal=0]="Normal",e[e.Escaped=1]="Escaped"}(q||(q={}));const F={getAttribute:(e,t)=>(I(e)?e.attributes:e)[t]};e.WhereClause=T,e.defaultAttributeAdapter=F,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
