/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","./has","./jsonMap","../geometry/ellipsoidUtils","../geometry/support/Ellipsoid","../geometry/support/spatialReferenceUtils","../geometry/support/WKIDUnitConversion"],(function(e,t,s,n,i,r,a){"use strict";const c=39.37,u=i.earth.radius*Math.PI/200,l=/(?:LENGTH)?UNIT\[([^\]]+)]]$/i,o=a,m=/UNIT\[([^\]]+)]/i,f=new Set([4305,4807,4810,4811,4812,4816,4819,4821,4901,4902,37225,104025,104026,104139,104140]),U=s.strict()({meter:"meters",foot:"feet",foot_us:"us-feet",foot_clarke:"clarke-feet",yard_clarke:"clarke-yards",link_clarke:"clarke-links",yard_sears:"sears-yards",foot_sears:"sears-feet",chain_sears:"sears-chains",chain_benoit_1895_b:"benoit-1895-b-chains",yard_indian:"indian-yards",yard_indian_1937:"indian-1937-yards",foot_gold_coast:"gold-coast-feet",chain:"chains",chain_sears_1922_truncated:"sears-1922-truncated-chains","50_kilometers":"50-kilometers","150_kilometers":"150-kilometers"}),d=e=>e*e,h=e=>e*e*e,B={length:{baseUnit:"meters",units:{millimeters:{inBaseUnits:.001},centimeters:{inBaseUnits:.01},decimeters:{inBaseUnits:.1},meters:{inBaseUnits:1},kilometers:{inBaseUnits:1e3},inches:{inBaseUnits:.0254},feet:{inBaseUnits:.3048},yards:{inBaseUnits:.9144},miles:{inBaseUnits:1609.344},"nautical-miles":{inBaseUnits:1852},"us-feet":{inBaseUnits:1200/3937},"clarke-feet":{inBaseUnits:.3047972654},"clarke-yards":{inBaseUnits:.9143917962},"clarke-links":{inBaseUnits:.201166195164},"sears-yards":{inBaseUnits:.9143984146160287},"sears-feet":{inBaseUnits:.3047994715386762},"sears-chains":{inBaseUnits:20.11676512155263},"benoit-1895-b-chains":{inBaseUnits:20.11678249437587},"indian-yards":{inBaseUnits:.9143985307444408},"indian-1937-yards":{inBaseUnits:.91439523},"gold-coast-feet":{inBaseUnits:.3047997101815088},chains:{inBaseUnits:20.1168},"sears-1922-truncated-chains":{inBaseUnits:20.116756},"50-kilometers":{inBaseUnits:5e4},"150-kilometers":{inBaseUnits:15e4}}},area:{baseUnit:"square-meters",units:{"square-millimeters":{inBaseUnits:d(.001)},"square-centimeters":{inBaseUnits:d(.01)},"square-decimeters":{inBaseUnits:d(.1)},"square-meters":{inBaseUnits:1},"square-kilometers":{inBaseUnits:d(1e3)},"square-inches":{inBaseUnits:d(.0254)},"square-feet":{inBaseUnits:d(.3048)},"square-yards":{inBaseUnits:d(.9144)},"square-miles":{inBaseUnits:d(1609.344)},"square-us-feet":{inBaseUnits:d(1200/3937)},acres:{inBaseUnits:.0015625*d(1609.344)},ares:{inBaseUnits:100},hectares:{inBaseUnits:1e4}}},volume:{baseUnit:"liters",units:{liters:{inBaseUnits:1},"cubic-millimeters":{inBaseUnits:1e3*h(.001)},"cubic-centimeters":{inBaseUnits:1e3*h(.01)},"cubic-decimeters":{inBaseUnits:1e3*h(.1)},"cubic-meters":{inBaseUnits:1e3},"cubic-kilometers":{inBaseUnits:1e3*h(1e3)},"cubic-inches":{inBaseUnits:1e3*h(.0254)},"cubic-feet":{inBaseUnits:1e3*h(.3048)},"cubic-yards":{inBaseUnits:1e3*h(.9144)},"cubic-miles":{inBaseUnits:1e3*h(1609.344)}}},angle:{baseUnit:"radians",units:{radians:{inBaseUnits:1},degrees:{inBaseUnits:Math.PI/180}}}},g=(()=>{const e={};for(const t in B)for(const s in B[t].units)e[s]=t;return e})();function p(e,t,s){return e*B[s].units[t].inBaseUnits}function q(e,t,s){return e/B[s].units[t].inBaseUnits}const k=["metric","imperial","square-inches","square-feet","square-yards","square-miles","square-us-feet","square-meters","square-kilometers","acres","ares","hectares"],b=["metric","imperial","inches","feet","yards","miles","nautical-miles","us-feet","meters","kilometers"],S=new Map([["meters","square-meters"],["feet","square-feet"],["us-feet","square-us-feet"]]);function y(e){return"imperial"===e||"metric"===e}function M(e){const t=g[e];if(!t)throw new Error("unknown type");return t}function w(e){return B[e].baseUnit}function _(e){return w(M(e))}function v(e,t=null){return t=t||M(e),B[t].baseUnit===e}function R(e,t,s){if(t===s)return e;const n=M(t);if(n!==M(s))throw new Error("incompatible units");const i=v(t,n)?e:p(e,t,n);return v(s,n)?i:q(i,s,n)}function F(e,t,s,n=!1){if(!n&&t.isGeographic)throw new Error("Unable to convert from an angular unit to a linear unit.");const i=Q(t);return i!==s&&(e=i?R(e,i,s):R(e*=j(t),"meters",s)),e}function P(e,t,s,n=!1){if(!n&&s.isGeographic)throw new Error("Unable to convert from a linear unit to an angular unit.");const i=Q(s);return t!==i&&(e=i?R(e,t,i):R(e,t,"meters")/j(s)),e}function D(e){switch(e){case"metric":return"meters";case"imperial":return"feet";default:return e}}function I(e){return D(e)}function E(e){switch(e){case"metric":return"square-meters";case"imperial":return"square-feet";default:return e}}function L(e,t,s){switch(s){case"metric":return T(e,t);case"imperial":return N(e,t);default:return s}}function C(e,t,s){switch(s){case"metric":return O(e,t);case"imperial":return J(e,t);default:return s}}function T(e,t){const s=R(e,t,"meters");return Math.abs(s)<3e3?"meters":"kilometers"}function O(e,t){const s=R(e,t,"meters");return Math.abs(s)<1e5?"meters":"kilometers"}function N(e,t){const s=R(e,t,"feet");return Math.abs(s)<1e3?"feet":"miles"}function J(e,t){const s=R(e,t,"feet");return Math.abs(s)<1e5?"feet":"miles"}function A(e,t){const s=R(e,t,"square-meters");return Math.abs(s)<3e6?"square-meters":"square-kilometers"}function G(e,t){const s=R(e,t,"square-feet");return Math.abs(s)<1e6?"square-feet":"square-miles"}function K(e,t,s){return R(e,t,"meters")/(s*Math.PI/180)}function V(e){return U.fromJSON(e.toLowerCase())||null}function x(e){if(null!=e&&!r.isEarth(e))return 1;const t=j(e);return t>1e5?1:t}function W(e){return j(e)>=n.getReferenceEllipsoid(e).metersPerDegree?"meters":Q(e)}function j(e,t=i.earth.metersPerDegree){return H(e,!0)??t}function H(e,t=!1){const s=e?.wkid??null,n=e?.wkt2??e?.wkt??null;let a=null;if(s){if(r.isWKIDFromMars(s))return i.mars.metersPerDegree;if(r.isWKIDFromMoon(s))return i.moon.metersPerDegree;a=o.values[o[s]],!a&&t&&f.has(s)&&(a=u)}else n&&(se(n)?a=$(l.exec(n),a):te(n)&&(a=$(m.exec(n),a)));return a}function Y(e){return r.isGeographic(e)?1:j(e)}function $(e,t){return e?.[1]?z(e[1]):t}function z(e){return parseFloat(e.split(",")[1])}function Q(e){const t=e?.wkid??null,s=e?.wkt2??e?.wkt??null;let n=null;if(t)n=o.units[o[t]];else if(s){const e=se(s)?l:te(s)?m:null;if(e){const t=e.exec(s);t?.[1]&&(n=ie(t[1]))}}return null!=n?V(n):null}function X(e){const t=Q(e);return null!=t&&b.includes(t)?t:null}function Z(e){const t=W(e);return null!=t&&b.includes(t)?t:null}function ee(e){const t=Q(e);return null==t?null:S.get(t)}function te(e){return/^GEOCCS/i.test(e)}function se(e){return/^\s*(?:PROJCS|PROJCRS|PROJECTEDCRS)/i.test(e)}const ne=1e-7;function ie(e){const t=/[\\"']{1}([^\\"']+)/.exec(e);let s=t?.[1];if(!s||!o.units.includes(s)){const t=z(e);s=null;const n=o.values;for(let e=0;e<n.length;++e)if(Math.abs(t-n[e])<ne){s=o.units[e];break}}return s}function re(e){const t=Q(e);if(null==t)return null;switch(t){case"feet":case"us-feet":case"clarke-feet":case"clarke-yards":case"clarke-links":case"sears-yards":case"sears-feet":case"sears-chains":case"benoit-1895-b-chains":case"indian-yards":case"indian-1937-yards":case"gold-coast-feet":case"chains":case"sears-1922-truncated-chains":return"imperial";case"50-kilometers":case"150-kilometers":case"meters":return"metric"}return null}const ae={esriAcres:"acres",esriAres:"ares",esriHectares:"hectares",esriSquareCentimeters:"square-centimeters",esriSquareDecimeters:"square-decimeters",esriSquareFeet:"square-feet",esriSquareInches:"square-inches",esriSquareKilometers:"square-kilometers",esriSquareMeters:"square-meters",esriSquareMiles:"square-miles",esriSquareMillimeters:"square-millimeters",esriSquareUsFeet:"square-us-feet",esriSquareYards:"square-yards"},ce={esriCentimeters:"centimeters",esriDecimeters:"decimeters",esriFeet:"feet",esriInches:"inches",esriKilometers:"kilometers",esriMeters:"meters",esriMiles:"miles",esriMillimeters:"millimeters",esriNauticalMiles:"nautical-miles",esriYards:"yards"},ue={esriDUDecimalDegrees:"degrees",esriDURadians:"radians"},le=s.strict()(ae),oe=s.strict()(ce),me=s.strict()(ue);e.adaptiveImperialAreaUnit=G,e.adaptiveImperialLengthUnit=N,e.adaptiveImperialVerticalLengthUnit=J,e.adaptiveLengthUnit=L,e.adaptiveMetricAreaUnit=A,e.adaptiveMetricLengthUnit=T,e.adaptiveMetricVerticalLengthUnit=O,e.adaptiveVerticalLengthUnit=C,e.angleUnitsJSONMap=me,e.areaUnitFromSpatialReference=ee,e.areaUnitsJSONMap=le,e.baseUnitForUnit=_,e.baseUnitForUnitType=w,e.convertFromSpatialReferenceUnit=F,e.convertToSpatialReferenceUnit=P,e.convertUnit=R,e.defaultAreaUnit=E,e.defaultLengthUnit=D,e.defaultVerticalLengthUnit=I,e.getDefaultUnitSystem=re,e.getMetersPerCartesianUnitForSR=Y,e.getMetersPerUnit=H,e.getMetersPerUnitForSR=j,e.getMetersPerVerticalUnitForSR=x,e.getUnitString=Q,e.getVerticalUnitStringForSR=W,e.gradGcsIds=f,e.inchesPerMeter=c,e.isBaseUnit=v,e.isMeasurementSystem=y,e.isProjectedWKT=se,e.lengthToDegrees=K,e.lengthUnitFromSpatialReference=X,e.lengthUnitsJSONMap=oe,e.measurementAreaUnits=k,e.measurementLengthUnits=b,e.unitFromRESTJSON=V,e.unitType=M,e.verticalLengthUnitFromSpatialReference=Z,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
