/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../config","./arrayUtils","./Error","./JSONSupport","./Logger","../portal/support/urlUtils","../support/base64Utils"],(function(e,t,n,r,o,i,l,s){"use strict";const u=()=>i.getLogger("esri.core.urlUtils"),c=t.request,a="esri/config: esriConfig.request.proxyUrl is not set.",f=/^\s*[a-z][a-z0-9-+.]*:(?![0-9])/i,p=/^\s*http:/i,h=/^\s*https:/i,d=/^\s*file:/i,m=/:\d+$/,y=/^https?:\/\/[^/]+\.arcgis.com\/sharing(\/|$)/i,g=new RegExp("^(([^:/?#]+):)?(//([^/?#]*))?([^?#]*)(\\?([^#]*))?(#(.*))?$"),x=new RegExp("^((([^[:]+):)?([^@]+)@)?(\\[([^\\]]+)\\]|([^[:]*))(:([0-9]+))?$");class ${constructor(e=""){this.uri=e,this.scheme=null,this.authority=null,this.path=null,this.query=null,this.fragment=null,this.user=null,this.password=null,this.host=null,this.port=null;let t=this.uri.match(g);this.scheme=t[2]||(t[1]?"":null),this.authority=t[4]||(t[3]?"":null),this.path=t[5],this.query=t[7]||(t[6]?"":null),this.fragment=t[9]||(t[8]?"":null),null!=this.authority&&(t=this.authority.match(x),this.user=t[3]||null,this.password=t[4]||null,this.host=t[6]||t[7],this.port=t[9]||null)}toString(){return this.uri}}const O={},w=new $(t.applicationUrl);let U=w;const b=A();let P=b;const S=()=>U,R=()=>P;function A(){const e=U.path,t=e.slice(0,e.lastIndexOf("/")+1);return`${`${U.scheme}://${U.host}${null!=U.port?`:${U.port}`:""}`}${t}`}const C={setAppUrl:e=>U=e,setAppBaseUrl:e=>P=e,restoreUrls:()=>{U=w,P=b}};function q(e){if(!e)return null;const t={path:null,query:null},n=new $(e),r=e.indexOf("?");return null===n.query?t.path=e:(t.path=e.slice(0,r),t.query=T(n.query)),n.fragment&&(t.hash=n.fragment,null===n.query&&(t.path=t.path.slice(0,t.path.length-(n.fragment.length+1)))),t}function T(e){const t=e.split("&"),n={};for(const r of t){if(!r)continue;const e=r.indexOf("=");let t,o;e<0?(t=decodeURIComponent(r),o=""):(t=decodeURIComponent(r.slice(0,e)),o=decodeURIComponent(r.slice(e+1)));let i=n[t];"string"==typeof i&&(i=n[t]=[i]),Array.isArray(i)?i.push(o):n[t]=o}return n}function I(e,t){return e?t&&"function"==typeof t?Object.keys(e).map((n=>encodeURIComponent(n)+"="+encodeURIComponent(t(n,e[n])))).join("&"):Object.keys(e).map((n=>{const r=e[n];if(null==r)return"";const i=encodeURIComponent(n)+"=",l=t?.[n];return l?i+encodeURIComponent(l(r)):Array.isArray(r)?r.map((e=>o.isSerializable(e)?i+encodeURIComponent(JSON.stringify(e)):i+encodeURIComponent(e))).join("&"):o.isSerializable(r)?i+encodeURIComponent(JSON.stringify(r)):i+encodeURIComponent(r)})).filter((e=>e)).join("&"):""}function v(e=!1){let t,n=c.proxyUrl;if("string"==typeof e){t=de(e);const r=E(e);r&&(n=r.proxyUrl)}else t=!!e;if(!n)throw u().warn(a),new r("urlUtils:proxy-not-set",a);t&&Oe()&&(n=xe(n));return q(n)}function j(e,t=!1){const n=E(e);let r,o;if(n){const e=B(n.proxyUrl);r=e.path,o=e.query?T(e.query):null}else if(t){const t=v(e);r=t.path,o=t.query}if(r){const t=q(e);e=r+"?"+t.path;const n=I({...o,...t.query});n&&(e=`${e}?${n}`)}return e}const L={path:"",query:""};function B(e){const t=e.indexOf("?");return-1!==t?(L.path=e.slice(0,t),L.query=e.slice(t+1)):(L.path=e,L.query=null),L}function D(e){return e=(e=we(e=Se(e=B(e).path),!0)).toLowerCase()}function k(e){const t={proxyUrl:e.proxyUrl,urlPrefix:D(e.urlPrefix)},n=c.proxyRules,r=t.urlPrefix;let o=n.length;for(let i=0;i<n.length;i++){const e=n[i].urlPrefix;if(0===r.indexOf(e)){if(r.length===e.length)return-1;o=i;break}0===e.indexOf(r)&&(o=i+1)}return n.splice(o,0,t),o}function E(e){const t=c.proxyRules,n=D(e);for(let r=0;r<t.length;r++)if(0===n.indexOf(t[r].urlPrefix))return t[r]}function H(e,t){if(!e||!t)return!1;e=z(e),t=z(t);const n=l.parseKnownArcGISOnlineDomain(e),r=l.parseKnownArcGISOnlineDomain(t);return null!=n&&null!=r?n.portalHostname===r.portalHostname:null==n&&null==r&&K(e,t,!0)}function G(e,t){if(!e||!t)return!1;e=z(e),t=z(t);const n=l.parseKnownArcGISOnlineDomain(e),r=l.parseKnownArcGISOnlineDomain(t);return null!=n&&null!=r&&n.portalHostname===r.portalHostname}function Q(e,t){return e=z(e),t=z(t),we(e)===we(t)}function z(e){const t=(e=V(e)).indexOf("/sharing");return t>0?e.slice(0,t):e.replace(/\/+$/,"")}function F(e,t=c.interceptors){const n=t=>null==t||t instanceof RegExp&&t.test(e)||"string"==typeof t&&e.startsWith(t);if(t)for(const r of t)if(Array.isArray(r.urls)){if(r.urls.some(n))return r}else if(n(r.urls))return r;return null}function K(e,t,n=!1){if(!e||!t)return!1;const r=Ie(e),o=Ie(t);return!(!n&&r.scheme!==o.scheme)&&(null!=r.host&&null!=o.host&&(r.host.toLowerCase()===o.host.toLowerCase()&&r.port===o.port))}function W(e){if("string"==typeof e){if(!Y(e))return!0;e=Ie(e)}if(K(e,U))return!0;const t=c.trustedServers||[];for(let n=0;n<t.length;n++){const r=J(t[n]);for(let t=0;t<r.length;t++)if(K(e,r[t]))return!0}return!1}function J(e){return O[e]||(he(e)||pe(e)?O[e]=[new $(N(e))]:O[e]=[new $(`http://${e}`),new $(`https://${e}`)]),O[e]}function N(e,t=P,n){return pe(e)?n?.preserveProtocolRelative?e:"http"===U.scheme&&U.authority===X(e).slice(2)?`http:${e}`:`https:${e}`:he(e)?e:_("/"===e[0]?Ue(t):t,e)}function M(e,t=P,n){if(null==e||!Y(e))return e;const r=V(e),o=r.toLowerCase(),i=V(t).toLowerCase().replace(/\/+$/,""),l=n?V(n).toLowerCase().replace(/\/+$/,""):null;if(l&&0!==i.indexOf(l))return e;const s=(e,t,n)=>-1===(n=e.indexOf(t,n))?e.length:n;let u=s(o,"/",o.indexOf("//")+2),c=-1;for(;o.slice(0,u+1)===i.slice(0,u)+"/"&&(c=u+1,u!==o.length);)u=s(o,"/",u+1);if(-1===c)return e;if(l&&c<l.length)return e;e=r.slice(c);const a=i.slice(c-1).replaceAll(/[^/]+/g,"").length;if(a>0)for(let f=0;f<a;f++)e=`../${e}`;else e=`./${e}`;return e}function V(e){return e=qe(e=Ce(e=Ae(e=N(e=e.trim()))))}function _(...e){const t=e.filter(n.isSome);if(!t?.length)return;const r=[];if(Y(t[0])){const e=t[0],n=e.indexOf("//");-1!==n&&(r.push(e.slice(0,n+1)),ye(t[0])&&(r[0]+="/"),t[0]=e.slice(n+2))}else"/"===t[0][0]&&r.push("");const o=t.reduce(((e,t)=>t?e.concat(t.split("/")):e),[]);for(let n=0;n<o.length;n++){const e=o[n];".."===e&&r.length>0&&".."!==r[r.length-1]?r.pop():(!e&&n===o.length-1||e&&("."!==e||0===r.length))&&r.push(e)}return r.join("/")}function X(e,t=!1){if(null==e||Z(e)||ee(e))return null;let n=e.indexOf("://");if(-1===n&&pe(e))n=2;else{if(-1===n)return null;n+=3}const r=e.indexOf("/",n);return-1!==r&&(e=e.slice(0,r)),t&&(e=we(e,!0)),e}function Y(e){return pe(e)||he(e)}function Z(e){return null!=e&&"blob:"===e.slice(0,5)}function ee(e){return null!=e&&"data:"===e.slice(0,5)}function te(e){const t=oe(e);return t?.isBase64?s.base64ToArrayBuffer(t.data):null}function ne(e){return s.arrayBufferToBase64(e).replaceAll("+","-").replaceAll("/","_").replace(/=+$/,"")}const re=/^data:(.*?)(;base64)?,(.*)$/;function oe(e){const t=e.match(re);if(!t)return null;const[,n,r,o]=t;return{mediaType:n,isBase64:!!r,data:o}}function ie(e){return e.isBase64?`data:${e.mediaType};base64,${e.data}`:`data:${e.mediaType},${e.data}`}async function le(e){return(await fetch(e)).blob()}function se(e){const t=te(e);if(!t)return null;const n=oe(e);return new Blob([t],{type:n.mediaType})}function ue(e,t){ae(e,t)}function ce(e,t){fe(e,t)}function ae(e,t){const n=se(e);return!!n&&fe(n,t)}function fe(e,t){if(!e)return!1;const n=document.createElement("a");if(!("download"in n))return!1;const r=URL.createObjectURL(e);return n.download=t,n.href=r,n.style.display="none",document.body.appendChild(n),n.click(),document.body.removeChild(n),URL.revokeObjectURL(r),!0}function pe(e){return null!=e&&"/"===e[0]&&"/"===e[1]}function he(e){return null!=e&&f.test(e)}function de(e){return null!=e&&h.test(e)||"https"===U.scheme&&pe(e)}function me(e){return null!=e&&p.test(e)||"http"===U.scheme&&pe(e)}function ye(e){return null!=e&&d.test(e)}function ge(e){return pe(e)?`http:${e}`:e.replace(h,"http:")}function xe(e){return pe(e)?`https:${e}`:e.replace(p,"https:")}function $e(){return"http"===U.scheme}function Oe(){return"https"===U.scheme}function we(e,t=!1){return pe(e)?e.slice(2):(e=e.replace(f,""),t&&e.length>1&&"/"===e[0]&&"/"===e[1]&&(e=e.slice(2)),e)}function Ue(e){const t=e.indexOf("//"),n=e.indexOf("/",t+2);return-1===n?e:e.slice(0,n)}function be(e){let t=0;if(Y(e)){const n=e.indexOf("//");-1!==n&&(t=n+2)}const n=e.lastIndexOf("/");return n<t?e:e.slice(0,n+1)}function Pe(e,t){if(!e)return"";const n=q(e).path.replace(/\/+$/,""),r=n.slice(n.lastIndexOf("/")+1);if(!t?.length)return r;const o=new RegExp(`\\.(${t.join("|")})$`,"i");return r.replace(o,"")}function Se(e){return e.endsWith("/")?e:`${e}/`}function Re(e){return e.replace(/\/+$/,"")}function Ae(e){if(/^https?:\/\//i.test(e)){const t=B(e);e=(e=t.path.replaceAll(/\/{2,}/g,"/")).replace("/","//"),t.query&&(e+=`?${t.query}`)}return e}function Ce(e){return e.replace(/^(https?:\/\/)(arcgis\.com)/i,"$1www.$2")}function qe(e){const t=c.httpsDomains;if(!me(e))return e;const n=e.indexOf("/",7);let r;if(r=-1===n?e:e.slice(0,n),r=r.toLowerCase().slice(7),m.test(r)){if(!r.endsWith(":80"))return e;r=r.slice(0,-3),e=e.replace(":80","")}return $e()&&r===U.authority&&!y.test(e)||(Oe()&&r===U.authority||t&&t.some((e=>r===e||r.endsWith(`.${e}`)))||Oe()&&!E(e))&&(e=xe(e)),e}function Te(e,t,n){if(!(t&&n&&e&&Y(e)))return e;const r=e.indexOf("//"),o=e.indexOf("/",r+2),i=e.indexOf(":",r+2),l=Math.min(o<0?e.length:o,i<0?e.length:i);if(e.slice(r+2,l).toLowerCase()!==t.toLowerCase())return e;return`${e.slice(0,r+2)}${n}${e.slice(l)}`}function Ie(e){return"string"==typeof e?new $(N(e)):(e.scheme||(e.scheme=U.scheme),e)}function ve(e){return Qe.test(e)}function je(e,t){const n=q(e),r=Object.keys(n.query||{});return r.length>0&&t&&t.warn("removeQueryParameters()",`Url query parameters are not supported, the following parameters have been removed: ${r.join(", ")}.`),n.path}function Le(e,t,n){const r=q(e),o=r.query||{};return o[t]=String(n),`${r.path}?${I(o)}`}function Be(e,t){if(!t)return e;const n=q(e),r=n.query||{};for(const[i,l]of Object.entries(t))null!=l&&(r[i]=l);const o=I(r);return o?`${n.path}?${o}`:n.path}function De(e,t){const{path:n,query:r}=q(e);if(!r)return e;delete r[t];const o=I(r);return o?`${n}?${o}`:n}function ke(e){if(null==e)return null;const t=e.match(Ge);return t?t[2]:null}function Ee(e){if(null==e)return null;const t=e.match(Ge);return t?{path:t[1],extension:t[2]}:{path:e,extension:null}}async function He(e){if("string"==typeof e){return oe(e)??{data:e}}return new Promise(((t,n)=>{const r=new FileReader;r.readAsDataURL(e),r.onload=()=>t(oe(r.result)),r.onerror=e=>n(e)}))}const Ge=/([^.]*)\.([^/]*)$/,Qe=/(^data:image\/svg|\.svg$)/i;e.Url=$,e.addProxy=j,e.addProxyRule=k,e.addQueryParameter=Le,e.addQueryParameters=Be,e.base64UrlEncode=ne,e.blobUrlToBlob=le,e.changeDomain=Te,e.dataComponents=oe,e.dataToArrayBuffer=te,e.dataToBlob=se,e.downloadBlobAsFile=ce,e.downloadDataAsFile=ue,e.ensureTrailingSlash=Se,e.getAppBaseUrl=R,e.getAppUrl=S,e.getFilename=Pe,e.getInterceptor=F,e.getOrigin=X,e.getPathExtension=ke,e.getProxyRule=E,e.getProxyUrl=v,e.hasProtocol=he,e.hasSameCanonicalArcGISOnlinePortal=G,e.hasSameCanonicalPortal=H,e.hasSameOrigin=K,e.hasSamePortal=Q,e.isAbsolute=Y,e.isAppHTTPS=Oe,e.isBlobProtocol=Z,e.isDataProtocol=ee,e.isHTTPSProtocol=de,e.isProtocolRelative=pe,e.isSVG=ve,e.isTrustedServer=W,e.join=_,e.makeAbsolute=N,e.makeData=ie,e.makeRelative=M,e.normalize=V,e.objectToQuery=I,e.parseData=He,e.queryToObject=T,e.removeFile=be,e.removeQueryParameter=De,e.removeQueryParameters=je,e.removeTrailingSlash=Re,e.splitPathExtension=Ee,e.test=C,e.toHTTP=ge,e.toHTTPS=xe,e.trustedServersUrlCache=O,e.urlToObject=q,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
