/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../assets","../../config","../../intl","../../kernel","../has","../Logger","../urlUtils","./loaderConfig","./utils","./WorkerFallback","../../intl/locale","../../support/revision"],(function(e,r,t,o,s,a,n,i,l,f,u,c,d){"use strict";const g=()=>n.getLogger("esri.core.workers.workerFactory"),{HANDSHAKE:m}=f.MessageType,p='let globalId=0;const outgoing=new Map,configuration={CONFIGURATION};self.esriConfig=configuration.esriConfig;const workerPath=self.esriConfig.workers.workerPath,HANDSHAKE=0,OPEN=1,OPENED=2,RESPONSE=3,INVOKE=4,ABORT=5;function createAbortError(){const e=new Error("Aborted");return e.name="AbortError",e}function receiveMessage(e){return e&&e.data?"string"==typeof e.data?JSON.parse(e.data):e.data:null}function invokeStaticMessage(e,o,r){const t=r&&r.signal,n=globalId++;let s=null;return new Promise(((r,i)=>{if(t){if(t.aborted)return i(createAbortError());s=()=>{outgoing.get(n)&&(outgoing.delete(n),self.postMessage({type:5,jobId:n}),i(createAbortError()))},t.addEventListener("abort",s)}outgoing.set(n,{resolve:r,reject:i}),self.postMessage({type:4,jobId:n,methodName:e,abortable:null!=t,data:o})})).finally((()=>{t&&t.removeEventListener("abort",s)}))}let workerRevisionChecked=!1;function checkWorkerRevision(e){if(!workerRevisionChecked&&e.kernelInfo){workerRevisionChecked=!0;const{revision:o,fullVersion:r}=configuration.kernelInfo,{revision:t,fullVersion:n,version:s}=e.kernelInfo;esriConfig.assetsPath!==esriConfig.defaultAssetsPath&&o!==t&&console.warn(`Version mismatch detected between ArcGIS Maps SDK for JavaScript modules and assets. For more information visit https://bit.ly/3QnsuSo.\nModules version: ${r}\nAssets version: ${n??s}\nAssets path: ${esriConfig.assetsPath}`)}}function messageHandler(e){const o=receiveMessage(e);if(!o)return;const r=o.jobId;switch(o.type){case 1:let n;function t(e){const o=n.connect(e);self.postMessage({type:2,jobId:r,data:o},[o])}"function"==typeof define&&define.amd?require([workerPath],(e=>{n=e.default||e,checkWorkerRevision(n),n.loadWorker(o.modulePath).then((e=>e||new Promise((e=>{require([o.modulePath],e)})))).then(t)})):"System"in self&&"function"==typeof System.import?System.import(workerPath).then((e=>(n=e.default,checkWorkerRevision(n),n.loadWorker(o.modulePath)))).then((e=>e||System.import(o.modulePath))).then(t):esriConfig.workers.useDynamicImport?import(workerPath).then((e=>{n=e.default||e,checkWorkerRevision(n),n.loadWorker(o.modulePath).then((e=>e||import(o.modulePath))).then(t)})):(self.RemoteClient||importScripts(workerPath),n=self.RemoteClient.default||self.RemoteClient,checkWorkerRevision(n),n.loadWorker(o.modulePath).then(t));break;case 3:if(outgoing.has(r)){const s=outgoing.get(r);outgoing.delete(r),o.error?s.reject(JSON.parse(o.error)):s.resolve(o.data)}}}self.dojoConfig=configuration.loaderConfig,esriConfig.workers.loaderUrl&&(self.importScripts(esriConfig.workers.loaderUrl),"function"==typeof require&&"function"==typeof require.config&&require.config(configuration.loaderConfig)),self.addEventListener("message",messageHandler),self.postMessage({type:0});';let k,h;const y="Failed to create Worker. Fallback to execute module in main thread";async function b(){if(!a("esri-workers"))return w(new u);if(!k&&!h)try{const e=p.split("{CONFIGURATION}").join(v());k=URL.createObjectURL(new Blob([e],{type:"text/javascript"}))}catch(r){h=r||{}}let e;if(k)try{e=new Worker(k,{name:"esri-worker-"+P++})}catch(r){g().warn(y,h),e=new u}else g().warn(y,h),e=new u;return w(e)}async function w(e){return new Promise((r=>{function t(s){const a=f.receiveMessage(s);a&&a.type===m&&(e.removeEventListener("message",t),e.removeEventListener("error",o),r(e))}function o(r){r.preventDefault(),e.removeEventListener("message",t),e.removeEventListener("error",o),g().warn("Failed to create Worker. Fallback to execute module in main thread",r),(e=new u).addEventListener("message",t),e.addEventListener("error",o)}e.addEventListener("message",t),e.addEventListener("error",o)}))}function v(){let e;if(null!=t.default){const r={...t};delete r.default,e=JSON.parse(JSON.stringify(r))}else e=JSON.parse(JSON.stringify(t));e.assetsPath=i.makeAbsolute(e.assetsPath),e.defaultAssetsPath=e.defaultAssetsPath?i.makeAbsolute(e.defaultAssetsPath):void 0,e.request.interceptors=[],e.log.interceptors=[],e.locale=c.getLocale(),e.has={"esri-csp-restrictions":a("esri-csp-restrictions"),"esri-2d-debug":!1,"esri-2d-update-debug":a("esri-2d-update-debug"),"esri-2d-log-updating":a("esri-2d-log-updating"),"featurelayer-pbf":a("featurelayer-pbf"),"featurelayer-fast-triangulation-enabled":a("featurelayer-fast-triangulation-enabled"),"featurelayer-simplify-thresholds":a("featurelayer-simplify-thresholds"),"featurelayer-simplify-payload-size-factors":a("featurelayer-simplify-payload-size-factors"),"featurelayer-simplify-mobile-factor":a("featurelayer-simplify-mobile-factor"),"featurelayer-query-max-depth":a("featurelayer-query-max-depth"),"featurelayer-query-pausing-enabled":a("featurelayer-query-pausing-enabled"),"featurelayer-snapshot-enabled":a("featurelayer-snapshot-enabled"),"esri-atomics":a("esri-atomics"),"esri-shared-array-buffer":a("esri-shared-array-buffer"),"esri-tiles-debug":a("esri-tiles-debug"),"esri-workers-arraybuffer-transfer":a("esri-workers-arraybuffer-transfer"),"feature-polyline-generalization-factor":a("feature-polyline-generalization-factor"),"host-webworker":1},e.workers.loaderUrl&&(e.workers.loaderUrl=i.makeAbsolute(e.workers.loaderUrl)),e.workers.workerPath?e.workers.workerPath=i.makeAbsolute(e.workers.workerPath):e.workers.workerPath=i.makeAbsolute(r.getAssetUrl("esri/core/workers/RemoteClient.js")),e.workers.useDynamicImport=!1;const o=t.workers.loaderConfig,n=l.loaderConfig({baseUrl:o?.baseUrl,locale:c.getLocale(),has:{"csp-restrictions":1,"dojo-test-sniff":0,"host-webworker":1,...o?.has},map:{...o?.map},paths:{...o?.paths},packages:o?.packages||[]}),f={buildDate:d.buildDate,fullVersion:s.fullVersion,revision:d.commitHash};return JSON.stringify({esriConfig:e,loaderConfig:n,kernelInfo:f})}let P=0;e.createWorker=b,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
