/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../core/string","../core/accessorSupport/decorators/property","../core/has","../core/Logger","../core/RandomLCG","../core/accessorSupport/decorators/subclass","./Geometry","./Point","./SpatialReference","./support/contains","./support/intersectsBase","./support/spatialReferenceUtils","./support/webMercatorUtils"],(function(t,e,i,s,n,r,a,m,h,o,x,c,l,p){"use strict";var y;function u(t){return t&&("esri.geometry.SpatialReference"===t.declaredClass||null!=t.wkid)}function f(t,e,i){return null==e?i:null==i?e:t(e,i)}let d=y=class extends m{constructor(...t){super(...t),this.type="extent",this.xmin=0,this.ymin=0,this.mmin=void 0,this.zmin=void 0,this.xmax=0,this.ymax=0,this.mmax=void 0,this.zmax=void 0}normalizeCtorArgs(t,e,i,s,n){return u(t)?{spatialReference:t,xmin:0,ymin:0,xmax:0,ymax:0}:"object"==typeof t?(t.spatialReference=null==t.spatialReference?o.WGS84:t.spatialReference,t):{xmin:t,ymin:e,xmax:i,ymax:s,spatialReference:n??o.WGS84}}static fromBounds(t,e){return new y({xmin:t[0],ymin:t[1],xmax:t[2],ymax:t[3],spatialReference:e})}static fromPoint(t){return new y({xmin:t.x,ymin:t.y,zmin:t.z,xmax:t.x,ymax:t.y,zmax:t.z,spatialReference:t.spatialReference})}get cache(){return this.commitProperty("xmin"),this.commitProperty("ymin"),this.commitProperty("zmin"),this.commitProperty("mmin"),this.commitProperty("xmax"),this.commitProperty("ymax"),this.commitProperty("zmax"),this.commitProperty("mmax"),this.commitProperty("spatialReference"),{}}get center(){const t=new h({x:.5*(this.xmin+this.xmax),y:.5*(this.ymin+this.ymax),spatialReference:this.spatialReference});return this.hasZ&&(t.z=.5*(this.zmin+this.zmax)),this.hasM&&(t.m=.5*(this.mmin+this.mmax)),t}get extent(){return this.clone()}get hasM(){return null!=this.mmin&&null!=this.mmax}get hasZ(){return null!=this.zmin&&null!=this.zmax}get height(){return Math.abs(this.ymax-this.ymin)}get width(){return Math.abs(this.xmax-this.xmin)}centerAt(t){const e=this.center;return null!=t.z&&this.hasZ?this.offset(t.x-e.x,t.y-e.y,t.z-e.z):this.offset(t.x-e.x,t.y-e.y)}clone(){const t=new y;return t.xmin=this.xmin,t.ymin=this.ymin,t.xmax=this.xmax,t.ymax=this.ymax,t.spatialReference=this.spatialReference,null!=this.zmin&&(t.zmin=this.zmin,t.zmax=this.zmax),null!=this.mmin&&(t.mmin=this.mmin,t.mmax=this.mmax),t}contains(t){if(!t)return!1;const e=this.spatialReference,i=t.spatialReference;return e&&i&&!e.equals(i)&&p.canProject(e,i)&&(t=e.isWebMercator?p.geographicToWebMercator(t):p.webMercatorToGeographic(t,!0)),"point"===t.type?x.extentContainsPoint(this,t):"extent"===t.type&&x.extentContainsExtent(this,t)}equals(t){if(this===t)return!0;if(null==t)return!1;const e=this.spatialReference,i=t.spatialReference;return e&&i&&!e.equals(i)&&p.canProject(e,i)&&(t=e.isWebMercator?p.geographicToWebMercator(t):p.webMercatorToGeographic(t,!0)),this.xmin===t.xmin&&this.ymin===t.ymin&&this.zmin===t.zmin&&this.mmin===t.mmin&&this.xmax===t.xmax&&this.ymax===t.ymax&&this.zmax===t.zmax&&this.mmax===t.mmax}expand(t){const e=.5*(1-t),i=this.width*e,s=this.height*e;if(this.xmin+=i,this.ymin+=s,this.xmax-=i,this.ymax-=s,this.hasZ){const t=(this.zmax-this.zmin)*e;this.zmin+=t,this.zmax-=t}if(this.hasM){const t=(this.mmax-this.mmin)*e;this.mmin+=t,this.mmax-=t}return this}intersects(t){if(null==t)return!1;"mesh"===t.type&&(t=t.extent);const e=this.spatialReference,i=t.spatialReference;e&&i&&!l.equals(e,i)&&p.canProject(e,i)&&(t=e.isWebMercator?p.geographicToWebMercator(t):p.webMercatorToGeographic(t,!0));return c.getFeatureExtentIntersector(t.type)(this,t)}normalize(){const t=this._normalize(!1,!0);return Array.isArray(t)?t:[t]}offset(t,e,i){return this.xmin+=t,this.ymin+=e,this.xmax+=t,this.ymax+=e,null!=i&&(this.zmin+=i,this.zmax+=i),this}shiftCentralMeridian(){return this._normalize(!0)}union(t){return this===t||(this.xmin=Math.min(this.xmin,t.xmin),this.ymin=Math.min(this.ymin,t.ymin),this.xmax=Math.max(this.xmax,t.xmax),this.ymax=Math.max(this.ymax,t.ymax),(this.hasZ||t.hasZ)&&(this.zmin=f(Math.min,this.zmin,t.zmin),this.zmax=f(Math.max,this.zmax,t.zmax)),(this.hasM||t.hasM)&&(this.mmin=f(Math.min,this.mmin,t.mmin),this.mmax=f(Math.max,this.mmax,t.mmax))),this}intersection(t){return this===t?this:null!=t&&this.intersects(t)?(this.xmin=Math.max(this.xmin,t.xmin),this.ymin=Math.max(this.ymin,t.ymin),this.xmax=Math.min(this.xmax,t.xmax),this.ymax=Math.min(this.ymax,t.ymax),(this.hasZ||t.hasZ)&&(this.zmin=f(Math.max,this.zmin,t.zmin),this.zmax=f(Math.min,this.zmax,t.zmax)),(this.hasM||t.hasM)&&(this.mmin=f(Math.max,this.mmin,t.mmin),this.mmax=f(Math.min,this.mmax,t.mmax)),this):null}toJSON(t){return this.write({},t)}_shiftCM(t=l.getInfo(this.spatialReference)){if(!t||!this.spatialReference)return this;const i=this.spatialReference,s=this._getCM(t);if(s){const n=i.isWebMercator?p.webMercatorToGeographic(s):s;this.xmin-=s.x,this.xmax-=s.x,i.isWebMercator||(n.x=z(n.x,t).x),this.spatialReference=new o(e.replace((i.isWGS84?t.altTemplate:null)??t.wkTemplate,{Central_Meridian:n.x}))}return this}_getCM(t){let e=null;const[i,s]=t.valid,n=this.xmin,r=this.xmax;return n>=i&&n<=s&&(r>=i&&r<=s)||(e=this.center),e}_normalize(t,e,i){const s=this.spatialReference;if(!s)return this;const n=i??l.getInfo(s);if(null==n)return this;const r=this._getParts(n).map((t=>t.extent));if(r.length<2)return r[0]||this;if(r.length>2)return t?this._shiftCM(n):this.set({xmin:n.valid[0],xmax:n.valid[1]});if(t)return this._shiftCM(n);if(e)return r;let a=!0,m=!0;return r.forEach((t=>{t.hasZ||(a=!1),t.hasM||(m=!1)})),{rings:r.map((t=>{const e=[[t.xmin,t.ymin],[t.xmin,t.ymax],[t.xmax,t.ymax],[t.xmax,t.ymin],[t.xmin,t.ymin]];if(a){const i=(t.zmax-t.zmin)/2;for(let t=0;t<e.length;t++)e[t].push(i)}if(m){const i=(t.mmax-t.mmin)/2;for(let t=0;t<e.length;t++)e[t].push(i)}return e})),hasZ:a,hasM:m,spatialReference:s}}_getParts(t){let e=this.cache._parts;if(!e){e=[];const{ymin:i,ymax:s,spatialReference:n}=this,r=this.width,a=this.xmin,m=this.xmax;let h;t=t||l.getInfo(n);const[o,x]=t.valid;h=z(this.xmin,t);const c=h.x,p=h.frameId;h=z(this.xmax,t);const u=h.x,f=h.frameId,d=c===u&&r>0;if(r>2*x){const t=new y(a<m?c:u,i,x,s,n),r=new y(o,i,a<m?u:c,s,n),h=new y(0,i,x,s,n),l=new y(o,i,0,s,n),d=[],z=[];t.contains(h)&&d.push(p),t.contains(l)&&z.push(p),r.contains(h)&&d.push(f),r.contains(l)&&z.push(f);for(let e=p+1;e<f;e++)d.push(e),z.push(e);e.push({extent:t,frameIds:[p]},{extent:r,frameIds:[f]},{extent:h,frameIds:d},{extent:l,frameIds:z})}else c>u||d?e.push({extent:new y(c,i,x,s,n),frameIds:[p]},{extent:new y(o,i,u,s,n),frameIds:[f]}):e.push({extent:new y(c,i,u,s,n),frameIds:[p]});this.cache._parts=e}const i=this.hasZ,s=this.hasM;if(i||s){const t={};i&&(t.zmin=this.zmin,t.zmax=this.zmax),s&&(t.mmin=this.mmin,t.mmax=this.mmax);for(let i=0;i<e.length;i++)e[i].extent.set(t)}return e}};function z(t,e){const[i,s]=e.valid,n=2*s;let r,a=0;return t>s?(r=Math.ceil(Math.abs(t-s)/n),t-=r*n,a=r):t<i&&(r=Math.ceil(Math.abs(t-i)/n),t+=r*n,a=-r),{x:t,frameId:a}}t.__decorate([i.property({readOnly:!0})],d.prototype,"cache",null),t.__decorate([i.property({readOnly:!0})],d.prototype,"center",null),t.__decorate([i.property({readOnly:!0})],d.prototype,"extent",null),t.__decorate([i.property({readOnly:!0,json:{write:{enabled:!1,overridePolicy:null}}})],d.prototype,"hasM",null),t.__decorate([i.property({readOnly:!0,json:{write:{enabled:!1,overridePolicy:null}}})],d.prototype,"hasZ",null),t.__decorate([i.property({readOnly:!0})],d.prototype,"height",null),t.__decorate([i.property({readOnly:!0})],d.prototype,"width",null),t.__decorate([i.property({type:Number,json:{type:[Number,String],write:{enabled:!0,allowNull:!0}}})],d.prototype,"xmin",void 0),t.__decorate([i.property({type:Number,json:{write:!0}})],d.prototype,"ymin",void 0),t.__decorate([i.property({type:Number,json:{origins:{"web-scene":{write:!1}},write:{overridePolicy(){return{enabled:this.hasM}}}}})],d.prototype,"mmin",void 0),t.__decorate([i.property({type:Number,json:{origins:{"web-scene":{write:!1}},write:{overridePolicy(){return{enabled:this.hasZ}}}}})],d.prototype,"zmin",void 0),t.__decorate([i.property({type:Number,json:{write:!0}})],d.prototype,"xmax",void 0),t.__decorate([i.property({type:Number,json:{write:!0}})],d.prototype,"ymax",void 0),t.__decorate([i.property({type:Number,json:{origins:{"web-scene":{write:!1}},write:{overridePolicy(){return{enabled:this.hasM}}}}})],d.prototype,"mmax",void 0),t.__decorate([i.property({type:Number,json:{origins:{"web-scene":{write:!1}},write:{overridePolicy(){return{enabled:this.hasZ}}}}})],d.prototype,"zmax",void 0),d=y=t.__decorate([a.subclass("esri.geometry.Extent")],d),d.prototype.toJSON.isDefaultToJSON=!0;return d}));
