/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../core/deprecate","../core/Error","../core/Loadable","../core/Logger","../core/Promise","../core/promiseUtils","../core/reactiveUtils","../core/accessorSupport/decorators/property","../core/has","../core/RandomLCG","../core/accessorSupport/decorators/subclass","../core/libs/gl-matrix-2/factories/vec3f64","./Geometry","./Point","./Polygon","./support/aaBoundingBox","./support/axisAngleDegrees","./support/MeshComponent","./support/meshErrors","./support/MeshGeoreferencedVertexSpace","./support/MeshLocalVertexSpace","./support/MeshTransform","./support/MeshVertexAttributes","./support/meshVertexSpaceUtils","./support/triangulationUtils","./support/meshUtils/centerAt","./support/meshUtils/extent","./support/meshUtils/loadExternal","./support/meshUtils/Metadata","./support/meshUtils/primitives","./support/meshUtils/rotate","./support/meshUtils/scale"],(function(e,t,r,o,n,s,a,i,c,l,p,h,u,d,m,f,x,y,v,g,S,w,_,M,b,A,L,U,F,P,R,C,E,V){"use strict";var B;const G="esri.geometry.Mesh";function z(){return s.getLogger(G)}const I={base:null,key:"type",defaultKeyValue:"georeferenced",typeMap:{georeferenced:w,local:_}};let O=B=class extends(n.LoadableMixin(a.EsriPromiseMixin(m))){constructor(e){super(e),this.components=null,this.vertexSpace=new w,this.transform=null,this.metadata=new R.Metadata,this.hasZ=!0,this.hasM=!1,this.vertexAttributes=new b.MeshVertexAttributes,this.type="mesh"}initialize(){(0===this.metadata.externalSources.length||this.vertexAttributes.position.length)&&(this.loadStatus="loaded"),this.when((()=>{this.addHandles(c.watch((()=>({vertexAttributes:this.vertexAttributes,components:this.components?.map((e=>e.clone()))})),(()=>this._clearSources()),{once:!0,sync:!0}))}))}get hasExtent(){return this.loaded?this.vertexAttributes.position.length>0&&(!this.components||this.components.length>0):null!=this.metadata.displaySource?.extent}get _transformedExtent(){const{spatialReference:e,vertexSpace:t}=this,r=this;return F.computeMeshExtent({get transform(){return r.transform},vertexSpace:t,spatialReference:e,untransformedBounds:this._untransformedBounds})}get _untransformedBounds(){const{vertexAttributes:{position:e},components:t}=this;return 0===e.length||0===t?.length?y.create(y.zero):y.fromBuffer(e)}get origin(){const e=A.vertexSpaceOriginToPoint(this.vertexSpace,this.spatialReference);if(null!=e)return e;const{center:t,zmin:r}=this._transformedExtent;return new f({x:t.x,y:t.y,z:r,spatialReference:this.spatialReference})}get extent(){return this.loaded||null==this.metadata?.displaySource?.extent?this._transformedExtent:this.metadata.displaySource.extent.clone()}addComponent(e){this._checkIfLoaded("addComponent()")&&(this.components||(this.components=[]),this.components.push(g.from(e)),this.notifyChange("components"))}removeComponent(e){if(this._checkIfLoaded("removeComponent()")){if(this.components){const t=this.components.indexOf(e);if(-1!==t)return this.components.splice(t,1),void this.notifyChange("components")}z().error("removeComponent()",S.componentNotFoundMessage)}}rotate(e,t,r,o){return v.composeAxes(e,t,r,j),E.rotate(this,j,o),this}offset(e,t,r){if(!this._checkIfLoaded("offset()"))return this;const{vertexSpace:o,vertexAttributes:n}=this,s=n?.position;if(!s)return this;if(A.isRelativeVertexSpace(o)){const[n,s,a]=o.origin;o.origin=d.fromValues(n+e,s+t,a+r)}else{for(let o=0;o<s.length;o+=3)s[o]+=e,s[o+1]+=t,s[o+2]+=r;this.vertexAttributesChanged()}return this}scale(e,t){return this._checkIfLoaded("scale()")?(V.scale(this,e,t),this):this}centerAt(e,t){return this._checkIfLoaded("centerAt()")?(U.centerAt(this,e,t),this):this}load(e){const{metadata:{displaySource:t}}=this;return t&&this.addResolvingPromise(P.loadExternal(this,t,e)),Promise.resolve(this)}addExternalSources(e){this.metadata.externalSources.addMany(e)}updateDisplaySource(e){this.metadata.displaySource=e}clone(){return this.cloneAndModifyVertexAttributes(this.vertexAttributes.clone(),this.vertexSpace.clone(),{preserveMetadata:!0})}cloneAndModifyVertexAttributes(e,t,r){let o=null;if(this.components){const e=new Map,t=new Map;o=this.components.map((r=>r.cloneWithDeduplication(e,t)))}const n={components:o,spatialReference:this.spatialReference,vertexAttributes:e,vertexSpace:t,transform:this.transform?.clone()??null,metadata:r?.preserveMetadata?this.metadata.clone():new R.Metadata};return new B(n)}cloneShallow(){return new B({components:this.components,spatialReference:this.spatialReference,vertexAttributes:this.vertexAttributes,vertexSpace:this.vertexSpace.clone(),transform:this.transform,metadata:this.metadata})}vertexAttributesChanged(){this.notifyChange("vertexAttributes")}async toBinaryGLTF(t){const[{toBinaryGLTF:r}]=await Promise.all([new Promise(((t,r)=>e(["./support/meshUtils/exporters/gltf/gltfexport"],t,r))),this.load(t)]);return i.throwIfAborted(t),await r(this,t)}get memoryUsage(){let e=0;if(e+=this.vertexAttributes.memoryUsage,null!=this.components)for(const t of this.components)e+=t.memoryUsage;return e}_clearSources(){this.metadata.clearSources()}_checkIfLoaded(e){return!!this.loaded||(z().error(e,S.meshNotLoadedMessage),!1)}static createBox(e,t){if(!(e instanceof f))return z().error(".createBox()",S.invalidLocationMessage),null;const r=new B(C.convertUnitGeometry(C.createUnitSizeBox(),e,t));return t?.imageFace&&"all"!==t.imageFace?C.extractSingleFaceOfBox(r,t.imageFace):r}static createSphere(e,t){return e instanceof f?new B(C.convertUnitGeometry(C.createUnitSizeSphere(t?.densificationFactor||0),e,t)):(z().error(".createSphere()",S.invalidLocationMessage),null)}static createCylinder(e,t){return e instanceof f?new B(C.convertUnitGeometry(C.createUnitSizeCylinder(t?.densificationFactor||0),e,t)):(z().error(".createCylinder()",S.invalidLocationMessage),null)}static createPlane(e,t){if(!(e instanceof f))return z().error(".createPlane()",S.invalidLocationMessage),null;const r=t?.facing??"up",o=C.convertPlaneSizeParameter(r,t?.size);return new B(C.convertUnitGeometry(C.createUnitSizePlane(r),e,{...t,size:o}))}static createFromPolygon(e,t){if(!(e instanceof x))return z().error(".createFromPolygon()",S.invalidPolygonMessage),null;const r=L.triangulate(e);return new B({vertexAttributes:new b.MeshVertexAttributes({position:r.position}),components:[new g({faces:r.faces,shading:"flat",material:t?.material??null})],spatialReference:e.spatialReference,vertexSpace:new w})}static async createFromGLTF(t,r,o){if(!(t instanceof f)){const e=new S.InvalidLocationError;throw z().error(".createfromGLTF()",e.message),e}const{loadGLTFMesh:n}=await i.whenOrAbort(new Promise(((t,r)=>e(["./support/meshUtils/loadGLTFMesh"],t,r))),o);return new B(await n(t,r,o))}static async createFromFiles(e,t,n){r.deprecatedFunction(z(),"`Mesh.createFromFiles` is deprecated in favor of 'SceneLayer.convertMesh'",{replacement:"SceneLayer.convertMesh",version:"4.29"});const s=e=>z().error(".createFromFiles()",e.message);if(!(e instanceof f)){const e=new S.InvalidLocationError;throw s(e),e}if(!n?.layer)throw new o("invalid:no-layer","SceneLayer required for file to mesh conversion.");return n.layer.convertMesh(t,{location:e,...n})}static createWithExternalSource(e,t,r){const o=r?.extent??null,{spatialReference:n}=e,s=r?.transform?.clone()??new M,a=A.selectVertexSpace(e,r),i=r?.unitConversionDisabled,c={source:t,extent:o,unitConversionDisabled:i},l=new R.Metadata;return l.externalSources.push(c),new B({metadata:l,transform:s,vertexSpace:a,spatialReference:n})}static createIncomplete(e,t){const{spatialReference:r}=e,n=t?.transform?.clone()??new M,s=A.selectVertexSpace(e,t),a=new B({transform:n,vertexSpace:s,spatialReference:r});return a.addResolvingPromise(Promise.reject(new o("mesh-incomplete","Mesh resources are not complete"))),a}};t.__decorate([l.property({type:[g],json:{write:!0}})],O.prototype,"components",void 0),t.__decorate([l.property({nonNullable:!0,types:I,constructOnly:!0,json:{write:!0}})],O.prototype,"vertexSpace",void 0),t.__decorate([l.property({type:M,json:{write:!0}})],O.prototype,"transform",void 0),t.__decorate([l.property({constructOnly:!0})],O.prototype,"metadata",void 0),t.__decorate([l.property()],O.prototype,"hasExtent",null),t.__decorate([l.property()],O.prototype,"_transformedExtent",null),t.__decorate([l.property()],O.prototype,"_untransformedBounds",null),t.__decorate([l.property()],O.prototype,"origin",null),t.__decorate([l.property({readOnly:!0,json:{read:!1}})],O.prototype,"extent",null),t.__decorate([l.property({readOnly:!0,json:{read:!1,write:!0,default:!0}})],O.prototype,"hasZ",void 0),t.__decorate([l.property({readOnly:!0,json:{read:!1,write:!0,default:!1}})],O.prototype,"hasM",void 0),t.__decorate([l.property({type:b.MeshVertexAttributes,nonNullable:!0,json:{write:!0}})],O.prototype,"vertexAttributes",void 0),O=B=t.__decorate([u.subclass(G)],O);const j=v.create();return O}));
