/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../core/Accessor","../core/Logger","../core/accessorSupport/decorators/property","../core/accessorSupport/decorators/cast","../core/RandomLCG","../core/has","../core/accessorSupport/decorators/reader","../core/accessorSupport/decorators/subclass","../core/accessorSupport/decorators/writer","../core/accessorSupport/ensureType","./Geometry","./SpatialReference","./support/pointUtils","./support/spatialReferenceUtils","./support/webMercatorUtils"],(function(e,t,r,s,i,o,a,n,l,c,u,p,d,h,y,g){"use strict";var _;const f=[0,0];function m(e){return e&&("esri.geometry.SpatialReference"===e.declaredClass||null!=e.wkid)}let w=_=class extends p{static copy(e,r){r._set("x",e._get("x")),r._set("y",e._get("y")),r._set("z",e._get("z")),r._set("m",e._get("m"));const s=e._get("spatialReference");r._set("spatialReference",t.isFrozen(s)?s:s.clone())}constructor(...e){super(...e),this.x=0,this.y=0,this.z=void 0,this.m=void 0,this.type="point"}normalizeCtorArgs(e,t,s,i,o){let a;if(Array.isArray(e))a=e,o=t,e=a[0],t=a[1],s=a[2],i=a[3];else if(e&&"object"==typeof e){if(a=e,e=null!=a.x?a.x:a.longitude,t=null!=a.y?a.y:a.latitude,s=a.z,i=a.m,(o=a.spatialReference)&&"esri.geometry.SpatialReference"!==o.declaredClass&&(o=new d(o)),null!=a.longitude||null!=a.latitude)if(null==a.longitude)r.getLogger(this).warn(".longitude=","Latitude was defined without longitude");else if(null==a.latitude)r.getLogger(this).warn(".latitude=","Longitude was defined without latitude");else if(!a.declaredClass&&o?.isWebMercator){const r=g.lngLatToXY(a.longitude,a.latitude,f);e=r[0],t=r[1]}}else m(s)?(o=s,s=null):m(i)&&(o=i,i=null);const n={x:e,y:t};return null==n.x&&null!=n.y?r.getLogger(this).warn(".y=","Y coordinate was defined without an X coordinate"):null==n.y&&null!=n.x&&r.getLogger(this).warn(".x=","X coordinate was defined without a Y coordinate"),null!=o&&(n.spatialReference=o),null!=s&&(n.z=s),null!=i&&(n.m=i),n}get cache(){return this.commitProperty("x"),this.commitProperty("y"),this.commitProperty("z"),this.commitProperty("m"),this.commitProperty("spatialReference"),{}}get hasM(){return void 0!==this.m}set hasM(e){e!==(void 0!==this._get("m"))&&(this._set("m",e?0:void 0),this._set("hasM",e))}get hasZ(){return void 0!==this.z}set hasZ(e){e!==(void 0!==this._get("z"))&&(this._set("z",e?0:void 0),this._set("hasZ",e))}get latitude(){return h.getLatitude(this)}set latitude(e){const{spatialReference:t,x:r}=this;null!=e&&t&&(t.isWebMercator?this._set("y",g.lngLatToXY(r,e,f)[1]):t.isGeographic&&this._set("y",e),this._set("latitude",e))}get longitude(){return h.getLongitude(this)}set longitude(e){const{y:t,spatialReference:r}=this;null!=e&&r&&(r.isWebMercator?this._set("x",g.lngLatToXY(e,t,f)[0]):r.isGeographic&&this._set("x",e),this._set("longitude",e))}writeX(e,t,r){t[r]=isNaN(e)?"NaN":e}readX(e){return"string"==typeof e?NaN:e}clone(){const e=new _;return e.x=this.x,e.y=this.y,e.z=this.z,e.m=this.m,e.spatialReference=this.spatialReference,e}copy(e){return _.copy(e,this),this}equals(e){if(null==e)return!1;const{x:t,y:r,z:s,m:i,spatialReference:o}=this,{z:a,m:n}=e;let{x:l,y:c,spatialReference:u}=e;if(!o.equals(u))if(o.isWebMercator&&u.isWGS84)[l,c]=g.lngLatToXY(l,c),u=o;else{if(!o.isWGS84||!u.isWebMercator)return!1;[l,c]=g.xyToLngLat(l,c),u=o}return t===l&&r===c&&s===a&&i===n&&o.wkid===u.wkid}offset(e,t,r){return this.x+=e,this.y+=t,null!=r&&(this.z=(this.z??0)+r),this}normalize(){if(!this.spatialReference)return this;const e=y.getInfo(this.spatialReference);if(!e)return this;let t=this.x;const[r,s]=e.valid,i=2*s;let o;return t>s?(o=Math.ceil(Math.abs(t-s)/i),t-=o*i):t<r&&(o=Math.ceil(Math.abs(t-r)/i),t+=o*i),this._set("x",t),this}distance(e){return h.distance(this,e)}toArray(){const e=this.hasZ,t=this.hasM;return e&&t?[this.x,this.y,this.z,this.m]:e?[this.x,this.y,this.z]:t?[this.x,this.y,this.m]:[this.x,this.y]}toJSON(e){return this.write({},e)}};e.__decorate([s.property({readOnly:!0})],w.prototype,"cache",null),e.__decorate([s.property({type:Boolean,json:{read:!1,write:{enabled:!1,overridePolicy:null}}})],w.prototype,"hasM",null),e.__decorate([s.property({type:Boolean,json:{read:!1,write:{enabled:!1,overridePolicy:null}}})],w.prototype,"hasZ",null),e.__decorate([s.property({type:Number})],w.prototype,"latitude",null),e.__decorate([s.property({type:Number})],w.prototype,"longitude",null),e.__decorate([s.property({type:Number,json:{type:[Number,String],write:{isRequired:!0,allowNull:!0}}}),i.cast((e=>isNaN(e)?e:u.ensureNumber(e)))],w.prototype,"x",void 0),e.__decorate([c.writer("x")],w.prototype,"writeX",null),e.__decorate([n.reader("x")],w.prototype,"readX",null),e.__decorate([s.property({type:Number,json:{write:!0}})],w.prototype,"y",void 0),e.__decorate([s.property({type:Number,json:{write:{overridePolicy(){return{enabled:this.hasZ}}}}})],w.prototype,"z",void 0),e.__decorate([s.property({type:Number,json:{write:{overridePolicy(){return{enabled:this.hasM}}}}})],w.prototype,"m",void 0),w=_=e.__decorate([l.subclass("esri.geometry.Point")],w),w.prototype.toJSON.isDefaultToJSON=!0;return w}));
