/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../chunks/SimpleGeometryCursor","../../../chunks/Geometry","../../../chunks/Transformation2D","../../../chunks/QuadraticBezier"],(function(e,t,n,r,o){"use strict";function i(e,t,n,r,o){return new s(t,n,r,o).processGeometry(e)}class s{constructor(e,t,r,i){this.m_interval=r,this.m_progressTracker=i,this.m_attribute=e,this.m_ord=t,(o.VertexDescription.getComponentCount(this.m_attribute)<=t||t<0)&&n.throwInvalidArgumentException("LocateBetween: ordinate");2===o.VertexDescription.getInterpolation(this.m_attribute)&&n.throwInvalidArgumentException("LocateBetween: angular interpolation")}processGeometry(e){const t=e.getGeometryType();if(t===n.GeometryType.enumGeometryCollection)return this.processGeometryCollection(e);if(n.isArea(t)&&n.throwInvalidArgumentException("LocateBetween does not support Polygons and Envelopes."),e.isEmpty()||!e.hasAttribute(this.m_attribute))return new o.Point({vd:e.getDescription()});if(n.isSegment(t))return this.processSegment(e);switch(t){case n.GeometryType.enumPoint:return this.processPoint(e);case n.GeometryType.enumMultiPoint:return this.processMultiPoint(e);case n.GeometryType.enumPolyline:return this.processPolyline(e);default:n.throwInternalErrorException("LocateBetween")}}processPoint(e){const t=e.getAttributeAsDbl(this.m_attribute,this.m_ord);return this.m_interval.containsCoordinate(t)?new o.MultiPoint({point:e}):new o.Point({vd:e.getDescription()})}processMultiPoint(e){let t=null,n=-1;const r=e.getAttributeStreamRef(this.m_attribute),i=o.VertexDescription.getComponentCount(this.m_attribute);for(let s=0,u=0,l=e.getPointCount();s<l;++s,u+=i){const i=r.readAsDbl(u);this.m_interval.containsCoordinate(i)?-1===n&&(n=s):n>=0&&(t||(t=new o.MultiPoint({vd:e.getDescription()})),t.addPoints(e,n,s),n=-1)}return n>=0&&(t||(t=new o.MultiPoint({vd:e.getDescription()})),t.addPoints(e,n,-1)),t||new o.Point({vd:e.getDescription()})}processPolyline(e){const t=e.queryInterval(this.m_attribute,this.m_ord);if(this.m_interval.contains(t))return e;if(!this.m_interval.isIntersecting(t))return new o.Point({vd:e.getDescription()});let r=null,i=null;const s=e.querySegmentIterator(),u=new o.SegmentBuffer,l=new o.Point,m=new o.Point,c=new o.Point;let a=!0,p=!1;for(;s.nextPath();)for(a=!0,p=!1;s.hasNextSegment();){const e=s.nextSegment(),t=[null],y=this.processSegmentHelper(e,u,t,l);if(y!==n.GeometryType.enumUnknown)if(y===n.GeometryType.enumPoint){if(!a&&(i.getPointByVal(i.getPointCount()-1,m),m.equals(l)))continue;if(a=!0,p&&(e.queryStart(m),l.equals(m)))continue;e.queryEnd(m),p=l.equals(m),r?r.add(l):r=new o.MultiPoint({point:l})}else y===n.GeometryType.enumLine&&(p=!1,i||(i=new o.Polyline),a&&(null===r||r.isEmpty()||(r.getPointByVal(r.getPointCount()-1,m),t[0].queryStart(l),m.equals(l)&&r.removePoint(r.getPointCount()-1))),i.addSegment(t[0],a),e.queryEnd(m),t[0].queryEnd(c),a=!m.equals(c));else a=!0,p=!1}if(null!==r&&r.isEmpty()&&(r=null),null!==r&&null!==i){const e=new o.GeometryCollection;return e.addGeometry(i),e.addGeometry(r),e}return null!==r?r:null!==i?i:new o.Point({vd:e.getDescription()})}processSegment(e){return n.geometryReleaseAssert(0),{}}processGeometryCollection(e){if(e.isEmpty()||!e.hasAttribute(this.m_attribute))return new o.Point({vd:e.getDescription()});const t=o.generateGeometryCursor(e),n=new o.GeometryCollection;for(let r=t.next();null!==r;r=t.next()){const e=this.processGeometry(r);e.isEmpty()||n.addGeometry(e)}return n.isEmpty()?new o.Point({vd:e.getDescription()}):n}processSegmentHelper(e,t,o,i){const s=e.getAttributeAsDbl(0,this.m_attribute,this.m_ord),u=e.getAttributeAsDbl(1,this.m_attribute,this.m_ord),l=Number.isNaN(s)?u:s,m=Number.isNaN(u)?s:u,c=new r.Envelope1D;c.setCoords(l,m);const a=c.clone();if(a.intersect(this.m_interval),a.isEmpty())return n.GeometryType.enumUnknown;if(c.equals(a))return o[0]=e,n.GeometryType.enumLine;const p=m-l,y=e.calculateLength2D();if(0===a.width()){const t=(a.vmin-l)/p,r=1===t?1:e.lengthToT(t*y);return e.queryCoord(r,i),n.GeometryType.enumPoint}let h=(a.vmin-l)/p,g=(a.vmax-l)/p;return h>g&&(g=r.swap(h,h=g)),h=1===h?1:e.lengthToT(h*y),g=1===g?1:e.lengthToT(g*y),e.queryCut(h,g,t),o[0]=t.get(),n.GeometryType.enumLine}}class u{getOperatorType(){return 10801}accelerateGeometry(e,t,n){return!1}canAccelerateGeometry(e){return!1}supportsCurves(){return!0}executeMany(e,t,n){return new l(e,t,n)}}class l extends t.GeometryCursor{constructor(e,t,n){super(),this.m_collectionCursor=null,this.m_interval=t,this.m_progressTracker=n,this.m_inputGeoms=e,this.m_index=-1}tock(){return n.geometryReleaseAssert(0),!1}getRank(){return n.geometryReleaseAssert(0),0}next(){if(this.m_collectionCursor){const e=this.m_collectionCursor.next();if(e)return e;this.m_collectionCursor=null}const e=this.m_inputGeoms.next();if(null===e)return null;n.throwIfMesh(e),this.m_index=this.m_inputGeoms.getGeometryID();const t=i(e,2,0,this.m_interval,this.m_progressTracker);if(t.getGeometryType()===n.GeometryType.enumGeometryCollection){this.m_collectionCursor=o.generateGeometryCursor(t);return this.m_collectionCursor.next()}return t}getGeometryID(){return this.m_index}}const m=new u;function c(e,n){const r=m.executeMany(new t.SimpleGeometryCursor(e),n,null);return Array.from(r)}function a(){return m.supportsCurves()}e.executeMany=c,e.supportsCurves=a,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
