/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../chunks/Transformation2D","../../../chunks/QuadraticBezier","../../../chunks/Geometry","../../../geometry","../../../core/unitUtils","../../support/spatialReferenceUtils","../../Extent","../../Multipoint","../../Point","../../Polygon","../../Polyline"],(function(e,t,n,o,r,s,a,i,u,c,l,h){"use strict";const p="_gxVersion",f=2,g=1;function m(e){return Array.isArray(e)?e[0].spatialReference:e.spatialReference}function y(e){switch(e.type){case"point":return w(e);case"multipoint":return M(e);case"polyline":return x(e);case"polygon":return C(e);case"extent":return P(e);default:throw new Error(`Unsupported geometry type: ${e.type}`)}}function P(e){if(!e.getCacheValue(p)){const t=new n.Envelope;t.setCoords(e.xmin,e.ymin,e.xmax,e.ymax),e.hasM&&t.setInterval(f,0,e.mmin,e.mmax),e.hasZ&&t.setInterval(g,0,e.zmin,e.zmax),e.setCacheValue(p,t)}return e.getCacheValue(p)}function M(e){if(!e.getCacheValue(p)){const t=new n.MultiPoint,o=new n.Point,r=e.points,s=e.hasM,a=e.hasZ,i=a?3:2;for(let e=0,n=r.length;e<n;e++){const n=r[e];o.setXYCoords(n[0],n[1]),a&&o.setZ(n[2]??0),s&&o.setM(n[i]??NaN),t.add(o)}e.setCacheValue(p,t)}return e.getCacheValue(p)}function w(e){if(!e.getCacheValue(p)){const t=new n.Point;t.setXYCoords(e.x,e.y),e.hasM&&t.setM(e.m),e.hasZ&&t.setZ(e.z),e.setCacheValue(p,t)}return e.getCacheValue(p)}function C(e){if(!e.getCacheValue(p)){const t=new n.Polygon;V(t,e),e.setCacheValue(p,t)}return e.getCacheValue(p)}function x(e){if(!e.getCacheValue(p)){const t=new n.Polyline;V(t,e),e.setCacheValue(p,t)}return e.getCacheValue(p)}function V(e,t){const o="polygon"===t.type,r=new n.Point,s=o?t.rings:t.paths,a=t.hasM,i=t.hasZ,u=i?3:2;for(let n=0,c=s.length;n<c;n++){const t=s[n],c=o?t.length-1:t.length;for(let n=0;n<c;n++){const o=t[n];r.setXYCoords(o[0],o[1]),i&&r.setZ(o[2]??0),a&&r.setM(o[u]??NaN),0===n?e.startPathPoint(r):e.lineToPoint(r)}}}function d(e){if(e.wkid)return n.create$2(e.wkid);const t=e.wkt2||e.wkt;return t?n.createFromWKT$2(t):null}function Z(e,t){if(e)switch(e.getGeometryType()){case o.GeometryType.enumPoint:return R(e,t);case o.GeometryType.enumEnvelope:return E(e,t);case o.GeometryType.enumMultiPoint:return G(e,t);case o.GeometryType.enumPolyline:return k(e,t);case o.GeometryType.enumPolygon:return T(e,t)}return null}function E(e,t){if(e.isEmpty())return null;const n=new i({xmin:e.getXMin(),ymin:e.getYMin(),xmax:e.getXMax(),ymax:e.getYMax(),spatialReference:t}),o=e.getDescription();if(o.hasM()){const t=e.queryInterval(f,0);n.mmin=t.vmin,n.mmax=t.vmax}if(o.hasZ()){const t=e.queryInterval(g,0);n.zmin=t.vmin,n.zmax=t.vmax}return n.setCacheValue(p,e),n}function G(e,t){if(e.isEmpty())return null;const o=e.getDescription(),r=o.hasM(),s=o.hasZ(),a=[],i=new n.Point;for(let n=0,u=e.getPointCount();n<u;n++){e.getPointByVal(n,i);const t=[i.getX(),i.getY()];s&&t.push(i.getZ()),r&&t.push(i.getM()),a.push(t)}const c=new u({hasM:r,hasZ:s,points:a,spatialReference:t});return c.setCacheValue(p,e),c}function R(e,n){if(e instanceof t.Point2D)return new c({x:e.x,y:e.y,spatialReference:n});if(e.isEmpty())return null;const o=new c({x:e.getX(),y:e.getY(),spatialReference:n}),r=e.getDescription();return r.hasM()&&(o.m=e.getM()),r.hasZ()&&(o.z=e.getZ()),o.setCacheValue(p,e),o}function T(e,t){if(e.isEmpty())return null;const n=new l({spatialReference:t});return v(n,e),n.setCacheValue(p,e),n}function k(e,t){if(e.isEmpty())return null;const n=new h({spatialReference:t});return v(n,e),n.setCacheValue(p,e),n}function v(e,t){const o="polygon"===e.type,r=t.getDescription(),s=r.hasM(),a=r.hasZ(),i=[],u=new n.Point;for(let n=0,c=t.getPathCount();n<c;n++){i.push([]);for(let e=t.getPathStart(n),o=t.getPathEnd(n);e<o;e++){t.getPointByVal(e,u);const o=[u.getX(),u.getY()];a&&o.push(u.getZ()),s&&o.push(u.getM()),i[n].push(o)}o&&i[n].push(i[n][0].slice())}e.hasM=s,e.hasZ=a,o?e.rings=i:e.paths=i}n.injectNoPe$1((e=>{let t,n;"number"==typeof e?t=e:n=e;const o={wkid:t,wkt:n};let r,i;if(n){r=s.isProjectedWKT(n);const e=a.isGeographic(o);if(!r&&!e)throw new Error(`Unsupported WKT type: ${n}`)}else r=!a.isGeographic(o);return i=t&&s.gradGcsIds.has(t)?Math.PI/200:r?s.getMetersPerUnit(o):Math.PI/180,{isPCS:r,metersOrRadiansPerUnit:i,semiMajor:0,wkidOrWkt:e}})),e.fromExtent=P,e.fromGeometry=y,e.fromMultipoint=M,e.fromPoint=w,e.fromPolygon=C,e.fromPolyline=x,e.fromSpatialReference=d,e.getSpatialReference=m,e.toExtent=E,e.toGeometry=Z,e.toMultipoint=G,e.toPoint=R,e.toPolygon=T,e.toPolyline=k,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
