/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","exports","../core/Error","../core/promiseUtils","../core/accessorSupport/tracking","../core/accessorSupport/tracking/SimpleObservable","../core/libs/gl-matrix-2/factories/vec3f64","./ellipsoidUtils","./Extent","./Multipoint","../chunks/pe","./Point","./Polygon","./Polyline","./SpatialReference","./projection/projectBuffer","./projection/projectors","./projection/projectXYZToVector","./support/GeographicTransformation","./support/spatialReferenceUtils","./support/zscale"],(function(e,n,r,t,l,i,o,a,s,u,c,f,p,m,h,d,g,y,j,R,P){"use strict";let x=null,S=null,w=null,C={};const M=new i.SimpleObservable;function Z(){return!!x&&c.isLoaded()}function E(){return!!Z()||(l.trackAccess(M),b(),!1)}function v(e,n){return!e||!n||(_(e,n)||E())}function z(e,n){return!_(e,n)&&!Z()}function b(n){return null==w&&(w=Promise.all([c.load(),new Promise(((n,r)=>e(["../chunks/geometryEngineBase"],n,r))).then((e=>e.geometryEngineBase)),new Promise(((n,r)=>e(["./geometryAdapters/hydrated"],n,r)))])),w.then((([,e,{hydratedAdapter:r}])=>{t.throwIfAborted(n),S=r,x=e.default,x._enableProjection(c.pe),M.notify()}))}function G(e,n,r=null,t=null){return Array.isArray(e)?0===e.length?[]:T(S,e,e[0].spatialReference,n,r,t):T(S,[e],e.spatialReference,n,r,t)[0]}function T(e,n,r,t,l=null,i=null){if(null==r||null==t)return n;if(_(r,t,l))return n.map((e=>Y(e,r,t)));if(null==l&&a.isSphericalECEF(r)){return n.map((e=>Y(e,r,h.WGS84))).map((e=>q(e,t)))}if(null==l&&a.isSphericalECEF(t)){return n.map((e=>q(e,h.WGS84))).map((e=>Y(e,h.WGS84,t)))}if(null==l){const e=j.cacheKey(r,t);void 0!==C[e]?l=C[e]:(null==(l=W(r,t,void 0))&&(l=new j),C[e]=l)}if(null==x||null==e)throw new L;return null!=i?x._project(e,n,r,t,l,i):x._project(e,n,r,t,l)}function A(e,n){const r=V([e],n);return null!=r.pending?{pending:r.pending,geometry:null}:null!=r.geometries?{pending:null,geometry:r.geometries[0]}:{pending:null,geometry:null}}function V(e,n){if(!Z())for(const r of e)if(null!=r&&!R.equals(r.spatialReference,n)&&R.isValid(r.spatialReference)&&R.isValid(n)&&!_(r.spatialReference,n))return l.trackAccess(M),{pending:b(),geometries:null};return{pending:null,geometries:e.map((e=>null==e?null:R.equals(e.spatialReference,n)?e:R.isValid(e.spatialReference)&&R.isValid(n)?q(e,n):null))}}function W(e,n,r=null){if(null==e||null==n)return null;if(null==x||null==S)throw new L;const t=x._getTransformation(S,e,n,r,r?.spatialReference);return null!==t?j.fromGE(t):null}function F(e,n,r=null){if(null==x||null==S)throw new L;const t=x._getTransformationBySuitability(S,e,n,r,r?.spatialReference);if(null!==t){const e=[];for(const n of t)e.push(j.fromGE(n));return e}return[]}class L extends r{constructor(){super("projection:not-loaded","projection engine not fully loaded yet, please call load()")}}function k(){x=null,S=null,w=null,C={}}const B={get loadPromise(){return w}};function q(e,n){try{const r=G(e,n);if(null==r)return null;"xmin"in e&&"xmin"in r&&(r.zmin=e.zmin,r.zmax=e.zmax);const t=P.getGeometryZScaler(r.type,e.spatialReference,n);return null!=t&&t(r),r}catch(r){if(!(r instanceof L))throw r;return null}}async function O(e,n,r){const t=e.spatialReference;return null!=t&&null!=n&&await X(t,n,null,r),q(e,n)}function _(e,n,r){return!r&&(!!R.equals(e,n)||R.isValid(e)&&R.isValid(n)&&!!g.getProjector(e,n,g.projectorCache))}function U(e,n){if(R.equals(e,n))return!0;if(!R.isValid(e)||!R.isValid(n))return!1;const r=R.isWGS84(e)||R.isWebMercator(e)||R.isCGCS2000(e),t=R.isWGS84(n)||R.isWebMercator(n)||R.isCGCS2000(n);return r&&t}async function X(e,n,r,l){if(Z())return t.waitTick(l);if(Array.isArray(e)){for(const{source:t,dest:i,geographicTransformation:o}of e)if(t&&i&&!_(t,i,o))return b(l)}else if(e&&n&&!_(e,n,r))return b(l);return t.waitTick(l)}function Y(e,n,r){return e?"x"in e?K(e,n,new f,r,0):"xmin"in e?ne(e,n,new s,r,0):"rings"in e?$(e,n,new p,r,0):"paths"in e?N(e,n,new m,r,0):"points"in e?H(e,n,new u,r,0):null:null}function I(e,n,r=n.spatialReference,t=0){return null!=r&&null!=e.spatialReference&&null!=K(e,e.spatialReference,n,r,t)}function K(e,n,r,t,l){te[0]=e.x,te[1]=e.y;const i=e.z;return te[2]=void 0!==i?i:l,d.projectBuffer(te,n,0,te,t,0)?(r.x=te[0],r.y=te[1],r.spatialReference=t,void 0!==i||a.isSphericalPCPF(t)?(r.z=te[2],r.hasZ=!0):(r.z=void 0,r.hasZ=!1),void 0===e.m?(r.m=void 0,r.hasM=!1):(r.m=e.m,r.hasM=!0),r):null}function D(e,n,r=n.spatialReference,t=0){return null!=e.spatialReference&&null!=r&&null!=H(e,e.spatialReference,n,r,t)}function H(e,n,r,t,l){const{points:i,hasZ:o,hasM:s}=e,u=[],c=i.length,f=[];for(const a of i)f.push(a[0],a[1],o?a[2]:l);if(!d.projectBuffer(f,n,0,f,t,0,c))return null;const p=o||a.isSphericalPCPF(t);for(let a=0;a<c;++a){const e=3*a,n=f[e],r=f[e+1];p&&s?u.push([n,r,f[e+2],i[a][3]]):p?u.push([n,r,f[e+2]]):s?u.push([n,r,i[a][2]]):u.push([n,r])}return r.points=u,r.spatialReference=t,r.hasZ=o,r.hasM=s,r}function J(e,n,r=n.spatialReference,t=0){return null!=e.spatialReference&&null!=r&&null!=N(e,e.spatialReference,n,r,t)}function N(e,n,r,t,l){const{paths:i,hasZ:o,hasM:s}=e,u=[];if(!re(i,o??!1,s??!1,n,u,t,l))return null;const c=o||a.isSphericalPCPF(t);return r.paths=u,r.spatialReference=t,r.hasZ=c,r.hasM=s,r}function Q(e,n,r=n.spatialReference,t=0){return null!=e.spatialReference&&null!=r&&null!=$(e,e.spatialReference,n,r,t)}function $(e,n,r,t,l){const{rings:i,hasZ:o,hasM:s}=e,u=[];if(!re(i,o??!1,s??!1,n,u,t,l))return null;const c=o||a.isSphericalPCPF(t);return r.rings=u,r.spatialReference=t,r.hasZ=c,r.hasM=s,r}function ee(e,n,r=n.spatialReference,t=0){return null!=e.spatialReference&&null!=r&&null!=ne(e,e.spatialReference,n,r,t)}function ne(e,n,r,t,l){const{xmin:i,ymin:o,xmax:s,ymax:u,hasZ:c,hasM:f}=e,p=c?e.zmin:l;if(!y.projectXYZToVector(i,o,p,n,te,t))return null;const m=c||a.isSphericalPCPF(t);r.xmin=te[0],r.ymin=te[1],m&&(r.zmin=te[2]);const h=c?e.zmax:l;return y.projectXYZToVector(s,u,h,n,te,t)?(r.xmax=te[0],r.ymax=te[1],m&&(r.zmax=te[2]),f&&(r.mmin=e.mmin,r.mmax=e.mmax),r.spatialReference=t,r):null}function re(e,n,r,t,l,i,o=0){const s=new Array;for(const a of e)for(const e of a)s.push(e[0],e[1],n?e[2]:o);if(!d.projectBuffer(s,t,0,s,i,0))return!1;let u=0;l.length=0;const c=n||a.isSphericalPCPF(i);for(const a of e){const e=new Array;for(const n of a)c&&r?e.push([s[u++],s[u++],s[u++],n[3]]):c?e.push([s[u++],s[u++],s[u++]]):r?(e.push([s[u++],s[u++],n[2]]),u++):(e.push([s[u++],s[u++]]),u++);l.push(e)}return!0}const te=o.create();n.canProjectWithoutEngine=_,n.getTransformation=W,n.getTransformations=F,n.initializeProjection=X,n.isEqualBaseGCS=U,n.isLoaded=Z,n.isLoadedOrLoad=E,n.isLoadedOrLoadFor=v,n.load=b,n.project=G,n.projectExtent=ee,n.projectMany=T,n.projectMultipoint=D,n.projectOrLoad=A,n.projectOrLoadMany=V,n.projectPoint=I,n.projectPolygon=Q,n.projectPolyline=J,n.projectWithZConversion=O,n.projectWithoutEngine=Y,n.requiresLoad=z,n.test=B,n.tryProjectWithZConversion=q,n.unload=k,Object.defineProperty(n,Symbol.toStringTag,{value:"Module"})}));
