/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../core/mathUtils","../../core/unitUtils","../ellipsoidUtils","../support/Ellipsoid","../support/geodesicConstants","../support/spatialReferenceUtils","../support/SupportedGCSWkids"],(function(o,e,n,t,r,c,P,i){"use strict";var l;o.ProjectionID=void 0,(l=o.ProjectionID||(o.ProjectionID={}))[l.UNKNOWN=0]="UNKNOWN",l[l.SPHERICAL_ECEF=1]="SPHERICAL_ECEF",l[l.WGS84=2]="WGS84",l[l.WEB_MERCATOR=3]="WEB_MERCATOR",l[l.WGS84_ECEF=4]="WGS84_ECEF",l[l.CGCS2000=5]="CGCS2000",l[l.SPHERICAL_MARS_PCPF=6]="SPHERICAL_MARS_PCPF",l[l.GCSMARS2000=7]="GCSMARS2000",l[l.SPHERICAL_MOON_PCPF=8]="SPHERICAL_MOON_PCPF",l[l.GCSMOON2000=9]="GCSMOON2000",l[l.LON_LAT=10]="LON_LAT",l[l.PLATE_CARREE=11]="PLATE_CARREE";const C={[o.ProjectionID.WGS84]:{[o.ProjectionID.CGCS2000]:S,[o.ProjectionID.GCSMARS2000]:null,[o.ProjectionID.GCSMOON2000]:null,[o.ProjectionID.LON_LAT]:S,[o.ProjectionID.SPHERICAL_ECEF]:T,[o.ProjectionID.SPHERICAL_MARS_PCPF]:null,[o.ProjectionID.SPHERICAL_MOON_PCPF]:null,[o.ProjectionID.UNKNOWN]:null,[o.ProjectionID.WEB_MERCATOR]:s,[o.ProjectionID.PLATE_CARREE]:A,[o.ProjectionID.WGS84]:S,[o.ProjectionID.WGS84_ECEF]:g},[o.ProjectionID.CGCS2000]:{[o.ProjectionID.CGCS2000]:S,[o.ProjectionID.GCSMARS2000]:null,[o.ProjectionID.GCSMOON2000]:null,[o.ProjectionID.LON_LAT]:S,[o.ProjectionID.SPHERICAL_ECEF]:T,[o.ProjectionID.SPHERICAL_MARS_PCPF]:null,[o.ProjectionID.SPHERICAL_MOON_PCPF]:null,[o.ProjectionID.UNKNOWN]:null,[o.ProjectionID.WEB_MERCATOR]:s,[o.ProjectionID.PLATE_CARREE]:A,[o.ProjectionID.WGS84]:S,[o.ProjectionID.WGS84_ECEF]:g},[o.ProjectionID.GCSMARS2000]:{[o.ProjectionID.CGCS2000]:null,[o.ProjectionID.GCSMARS2000]:S,[o.ProjectionID.GCSMOON2000]:null,[o.ProjectionID.LON_LAT]:S,[o.ProjectionID.SPHERICAL_ECEF]:null,[o.ProjectionID.SPHERICAL_MARS_PCPF]:f,[o.ProjectionID.SPHERICAL_MOON_PCPF]:null,[o.ProjectionID.UNKNOWN]:null,[o.ProjectionID.WEB_MERCATOR]:null,[o.ProjectionID.PLATE_CARREE]:null,[o.ProjectionID.WGS84]:null,[o.ProjectionID.WGS84_ECEF]:null},[o.ProjectionID.GCSMOON2000]:{[o.ProjectionID.CGCS2000]:null,[o.ProjectionID.GCSMARS2000]:null,[o.ProjectionID.GCSMOON2000]:S,[o.ProjectionID.LON_LAT]:S,[o.ProjectionID.SPHERICAL_ECEF]:null,[o.ProjectionID.SPHERICAL_MARS_PCPF]:null,[o.ProjectionID.SPHERICAL_MOON_PCPF]:p,[o.ProjectionID.UNKNOWN]:null,[o.ProjectionID.WEB_MERCATOR]:null,[o.ProjectionID.PLATE_CARREE]:null,[o.ProjectionID.WGS84]:null,[o.ProjectionID.WGS84_ECEF]:null},[o.ProjectionID.WEB_MERCATOR]:{[o.ProjectionID.CGCS2000]:j,[o.ProjectionID.GCSMARS2000]:null,[o.ProjectionID.GCSMOON2000]:null,[o.ProjectionID.LON_LAT]:j,[o.ProjectionID.SPHERICAL_ECEF]:u,[o.ProjectionID.SPHERICAL_MARS_PCPF]:null,[o.ProjectionID.SPHERICAL_MOON_PCPF]:null,[o.ProjectionID.UNKNOWN]:null,[o.ProjectionID.WEB_MERCATOR]:S,[o.ProjectionID.PLATE_CARREE]:M,[o.ProjectionID.WGS84]:j,[o.ProjectionID.WGS84_ECEF]:D},[o.ProjectionID.WGS84_ECEF]:{[o.ProjectionID.CGCS2000]:B,[o.ProjectionID.GCSMARS2000]:null,[o.ProjectionID.GCSMOON2000]:null,[o.ProjectionID.LON_LAT]:B,[o.ProjectionID.SPHERICAL_ECEF]:b,[o.ProjectionID.SPHERICAL_MARS_PCPF]:null,[o.ProjectionID.SPHERICAL_MOON_PCPF]:null,[o.ProjectionID.UNKNOWN]:null,[o.ProjectionID.WEB_MERCATOR]:k,[o.ProjectionID.PLATE_CARREE]:O,[o.ProjectionID.WGS84]:B,[o.ProjectionID.WGS84_ECEF]:S},[o.ProjectionID.SPHERICAL_ECEF]:{[o.ProjectionID.CGCS2000]:U,[o.ProjectionID.GCSMARS2000]:null,[o.ProjectionID.GCSMOON2000]:null,[o.ProjectionID.LON_LAT]:U,[o.ProjectionID.SPHERICAL_ECEF]:S,[o.ProjectionID.SPHERICAL_MARS_PCPF]:null,[o.ProjectionID.SPHERICAL_MOON_PCPF]:null,[o.ProjectionID.UNKNOWN]:null,[o.ProjectionID.WEB_MERCATOR]:K,[o.ProjectionID.PLATE_CARREE]:N,[o.ProjectionID.WGS84]:U,[o.ProjectionID.WGS84_ECEF]:w},[o.ProjectionID.SPHERICAL_MARS_PCPF]:{[o.ProjectionID.CGCS2000]:null,[o.ProjectionID.GCSMARS2000]:H,[o.ProjectionID.GCSMOON2000]:null,[o.ProjectionID.LON_LAT]:H,[o.ProjectionID.SPHERICAL_ECEF]:null,[o.ProjectionID.SPHERICAL_MARS_PCPF]:S,[o.ProjectionID.SPHERICAL_MOON_PCPF]:null,[o.ProjectionID.UNKNOWN]:null,[o.ProjectionID.WEB_MERCATOR]:null,[o.ProjectionID.PLATE_CARREE]:null,[o.ProjectionID.WGS84]:null,[o.ProjectionID.WGS84_ECEF]:null},[o.ProjectionID.SPHERICAL_MOON_PCPF]:{[o.ProjectionID.CGCS2000]:null,[o.ProjectionID.GCSMARS2000]:null,[o.ProjectionID.GCSMOON2000]:d,[o.ProjectionID.LON_LAT]:d,[o.ProjectionID.SPHERICAL_ECEF]:null,[o.ProjectionID.SPHERICAL_MARS_PCPF]:null,[o.ProjectionID.SPHERICAL_MOON_PCPF]:S,[o.ProjectionID.UNKNOWN]:null,[o.ProjectionID.WEB_MERCATOR]:null,[o.ProjectionID.PLATE_CARREE]:null,[o.ProjectionID.WGS84]:null,[o.ProjectionID.WGS84_ECEF]:null},[o.ProjectionID.UNKNOWN]:{[o.ProjectionID.CGCS2000]:null,[o.ProjectionID.GCSMARS2000]:null,[o.ProjectionID.GCSMOON2000]:null,[o.ProjectionID.LON_LAT]:null,[o.ProjectionID.SPHERICAL_ECEF]:null,[o.ProjectionID.SPHERICAL_MARS_PCPF]:null,[o.ProjectionID.SPHERICAL_MOON_PCPF]:null,[o.ProjectionID.UNKNOWN]:S,[o.ProjectionID.WEB_MERCATOR]:null,[o.ProjectionID.PLATE_CARREE]:null,[o.ProjectionID.WGS84]:null,[o.ProjectionID.WGS84_ECEF]:null},[o.ProjectionID.LON_LAT]:{[o.ProjectionID.CGCS2000]:S,[o.ProjectionID.GCSMARS2000]:S,[o.ProjectionID.GCSMOON2000]:S,[o.ProjectionID.LON_LAT]:S,[o.ProjectionID.SPHERICAL_ECEF]:T,[o.ProjectionID.SPHERICAL_MARS_PCPF]:f,[o.ProjectionID.SPHERICAL_MOON_PCPF]:p,[o.ProjectionID.UNKNOWN]:null,[o.ProjectionID.WEB_MERCATOR]:s,[o.ProjectionID.PLATE_CARREE]:A,[o.ProjectionID.WGS84]:S,[o.ProjectionID.WGS84_ECEF]:g},[o.ProjectionID.PLATE_CARREE]:{[o.ProjectionID.CGCS2000]:_,[o.ProjectionID.GCSMARS2000]:null,[o.ProjectionID.GCSMOON2000]:null,[o.ProjectionID.LON_LAT]:_,[o.ProjectionID.SPHERICAL_ECEF]:L,[o.ProjectionID.SPHERICAL_MARS_PCPF]:null,[o.ProjectionID.SPHERICAL_MOON_PCPF]:null,[o.ProjectionID.UNKNOWN]:null,[o.ProjectionID.WEB_MERCATOR]:G,[o.ProjectionID.PLATE_CARREE]:S,[o.ProjectionID.WGS84]:_,[o.ProjectionID.WGS84_ECEF]:W}};function I(o,e,n=y()){return null==o||null==e?null:q(o,e,n).projector}function E(o,e){switch(I(o,e,z)){case S:return"copy3";case T:return"wgs84ToSphericalECEF";case s:return"wgs84ToWebMercator";case A:return"wgs84ToPlateCarree";case g:return"wgs84ToWGS84ECEF";case j:return"webMercatorToWGS84";case u:return"webMercatorToSphericalECEF";case D:return"webMercatorToWGS84ECEF";case M:return"webMercatorToPlateCarree";case B:return"wgs84ECEFToWGS84";case b:return"wgs84ECEFToSphericalECEF";case k:return"wgs84ECEFToWebMercator";case U:return"sphericalECEFToWGS84";case K:return"sphericalECEFToWebMercator";case H:return"sphericalMarsPCPFToMars2000";case d:return"sphericalMoonPCPFToMoon2000";case w:return"sphericalECEFToWGS84ECEF";case f:return"mars2000ToSphericalPCPF";case p:return"moon2000ToSphericalPCPF";default:return null}}function a(e,r){return e?r.spatialReference===e?r.spatialReferenceId:(r.spatialReference=e,"metersPerUnit"in r&&(r.metersPerUnit=n.getMetersPerUnitForSR(e,1)),t.isSphericalECEF(e)?r.spatialReferenceId=o.ProjectionID.SPHERICAL_ECEF:P.isWGS84(e)?r.spatialReferenceId=o.ProjectionID.WGS84:P.isWebMercator(e)?r.spatialReferenceId=o.ProjectionID.WEB_MERCATOR:P.isPlateCarree(e)?r.spatialReferenceId=o.ProjectionID.PLATE_CARREE:e.wkt===t.WGS84ECEFSpatialReferenceLike.wkt?r.spatialReferenceId=o.ProjectionID.WGS84_ECEF:e.wkid===i.SupportedGCSWkids.CGCS2000?r.spatialReferenceId=o.ProjectionID.CGCS2000:e.wkt===t.SphericalPCPFMarsLike.wkt?r.spatialReferenceId=o.ProjectionID.SPHERICAL_MARS_PCPF:e.wkt===t.SphericalPCPFMoonLike.wkt?r.spatialReferenceId=o.ProjectionID.SPHERICAL_MOON_PCPF:P.isMars(e)?r.spatialReferenceId=o.ProjectionID.GCSMARS2000:P.isMoon(e)?r.spatialReferenceId=o.ProjectionID.GCSMOON2000:r.spatialReferenceId=o.ProjectionID.UNKNOWN):o.ProjectionID.UNKNOWN}function S(o,e,n,t){o!==n&&(n[t++]=o[e++],n[t++]=o[e++],n[t]=o[e])}function j(o,e,n,t){n[t]=Q*(o[e]/Y),n[t+1]=Q*(X-2*Math.atan(Math.exp(-o[e+1]/Y))),n[t+2]=o[e+2]}function u(o,e,n,t){const r=o[e]/Y,c=X-2*Math.atan(Math.exp(-o[e+1]/Y)),P=Y+o[e+2],i=Math.cos(c)*P;n[t]=Math.cos(r)*i,n[t+1]=Math.sin(r)*i,n[t+2]=Math.sin(c)*P}function D(o,e,n,t){j(o,e,n,t),g(n,t,n,t)}function R(o,n,t,r,c){const P=.4999999*V,i=e.clamp(J*o[n+1],-P,P),l=Math.sin(i);t[r++]=J*o[n]*c.radius,t[r++]=c.halfSemiMajorAxis*Math.log((1+l)/(1-l)),t[r]=o[n+2]}function s(o,e,n,t){R(o,e,n,t,r.earth)}function A(o,e,n,t){n[t]=o[e]*Z,n[t+1]=o[e+1]*Z,n[t+2]=o[e+2]}function _(o,e,n,t){n[t]=o[e]*$,n[t+1]=o[e+1]*$,n[t+2]=o[e+2]}function M(o,e,n,t){j(o,e,n,t),A(n,t,n,t)}function O(o,e,n,t){B(o,e,n,t),A(n,t,n,t)}function N(o,e,n,t){U(o,e,n,t),A(n,t,n,t)}function L(o,e,n,t){_(o,e,n,t),T(n,t,n,t)}function G(o,e,n,t){_(o,e,n,t),s(n,t,n,t)}function W(o,e,n,t){_(o,e,n,t),g(n,t,n,t)}function F(o,e,n,t,r){const c=r+o[e+2],P=J*o[e+1],i=J*o[e],l=Math.cos(P)*c;n[t]=Math.cos(i)*l,n[t+1]=Math.sin(i)*l,n[t+2]=Math.sin(P)*c}function p(o,e,n,t){F(o,e,n,t,r.moon.radius)}function f(o,e,n,t){F(o,e,n,t,r.mars.radius)}function T(o,e,n,t){F(o,e,n,t,r.earth.radius)}function h(o,n,t,r,c){const P=o[n],i=o[n+1],l=o[n+2],C=Math.sqrt(P*P+i*i+l*l),I=e.asinClamped(l/(0===C?1:C)),E=Math.atan2(i,P);t[r++]=Q*E,t[r++]=Q*I,t[r]=C-c}function d(o,e,n,t){h(o,e,n,t,r.moon.radius)}function H(o,e,n,t){h(o,e,n,t,r.mars.radius)}function U(o,e,n,t){h(o,e,n,t,r.earth.radius)}function K(o,e,n,t){U(o,e,n,t),s(n,t,n,t)}function w(o,e,n,t){U(o,e,n,t),g(n,t,n,t)}function m(o,e,n,t,r){const c=J*o[e],P=J*o[e+1],i=o[e+2],l=Math.sin(P),C=Math.cos(P),I=r.radius/Math.sqrt(1-r.eccentricitySquared*l*l);n[t++]=(I+i)*C*Math.cos(c),n[t++]=(I+i)*C*Math.sin(c),n[t++]=(I*(1-r.eccentricitySquared)+i)*l}function g(o,e,n,t){m(o,e,n,t,r.earth)}function B(o,e,n,t){const P=c.earthEllipsoidConstants,i=o[e],l=o[e+1],C=o[e+2];let I,E,a,S,j,u,D,R,s,A,_,M,O,N,L,G,W,F,p,f,T;I=Math.abs(C),E=i*i+l*l,a=Math.sqrt(E),S=E+C*C,j=Math.sqrt(S),f=Math.atan2(l,i),u=C*C/S,D=E/S,N=P.a2/j,L=P.a3-P.a4/j,D>.3?(R=I/j*(1+D*(P.a1+N+u*L)/j),p=Math.asin(R),A=R*R,s=Math.sqrt(1-A)):(s=a/j*(1-u*(P.a5-N-D*L)/j),p=Math.acos(s),A=1-s*s,R=Math.sqrt(A)),_=1-r.earth.eccentricitySquared*A,M=r.earth.radius/Math.sqrt(_),O=P.a6*M,N=a-M*s,L=I-O*R,W=s*N+R*L,G=s*L-R*N,F=G/(O/_+W),p+=F,T=W+G*F/2,C<0&&(p=-p),n[t++]=Q*f,n[t++]=Q*p,n[t]=T}function b(o,e,n,t){B(o,e,n,t),T(n,t,n,t)}function k(o,e,n,t){B(o,e,n,t),s(n,t,n,t)}function q(e,n,t){if(null==e||null==n||t.source.spatialReference===e&&t.dest.spatialReference===n)return t;const r=a(e,t.source),c=a(n,t.dest);return r===o.ProjectionID.UNKNOWN&&c===o.ProjectionID.UNKNOWN?P.equals(e,n)?t.projector=S:t.projector=null:t.projector=C[r][c],t}function y(){return{source:{spatialReference:null,spatialReferenceId:o.ProjectionID.UNKNOWN,metersPerUnit:1},dest:{spatialReference:null,spatialReferenceId:o.ProjectionID.UNKNOWN,metersPerUnit:1},projector:S}}const v={spatialReference:null,spatialReferenceId:o.ProjectionID.UNKNOWN},x={spatialReference:null,spatialReferenceId:o.ProjectionID.UNKNOWN},z=y(),J=e.deg2rad(1),Q=e.rad2deg(1),V=Math.PI,X=.5*V,Y=r.earth.radius,Z=Y*V/180,$=180/(Y*V);o.classifySpatialReference=a,o.copy3=S,o.createEmptyProjectorCache=y,o.destClassificationCache=x,o.getProjector=I,o.getProjectorName=E,o.invPlateCarreeScale=$,o.lonLatToWebMercatorComparable=R,o.populateProjectorCache=q,o.projectionTable=C,o.projectorCache=z,o.sourceClassificationCache=v,o.sphericalPCPFtoLonLatElevation=h,o.wgs84ToWebMercator=s,Object.defineProperty(o,Symbol.toStringTag,{value:"Module"})}));
