/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../geometry","../../core/Error","../../core/unitUtils","../../core/accessorSupport/ensureType","./geodesicConstants","./spatialReferenceUtils","../SpatialReference","../Polyline","../Polygon","../Point"],(function(e,t,n,i,s,a,o,r,c,l,h){"use strict";function u(e){if(!e)return null;const t=e.wkid;if(t)return a.spheroids[t];const n=e.wkt2??e.wkt;return n?p(n):null}function p(e){const t=a.wktSpheroidRegex.exec(e);if(!t||2!==t.length)return null;const n=t[1].split(",");if(!n||n.length<3)return null;const i=parseFloat(n[1]),s=parseFloat(n[2]);if(isNaN(i)||isNaN(s))return null;return{a:i,f:0===s?0:1/s}}function f(e){const t=u(e);if(d(t))return t;const n=t.a*(1-t.f);return Object.assign(t,{b:n,eSq:1-(n/t.a)**2,radius:(2*t.a+n)/3,densificationRatio:1e4/((2*t.a+n)/3)})}function d(e){return null!=e&&"b"in e&&"eSq"in e&&"radius"in e}function g(e){return null!=e&&e<0?e+360:e}function m(e,t,n){const{a:i,eSq:s}=f(n),o=Math.sqrt(s),r=Math.sin(t[1]*a.toRadians),c=i*t[0]*a.toRadians;let l;if(s>0){l=i*((1-s)*(r/(1-s*(r*r))-1/(2*o)*Math.log((1-o*r)/(1+o*r))))*.5}else l=i*r;return e[0]=c,e[1]=l,e}function M(e){return o.isGeographic(e)&&!!u(e)}function w(e,t="square-meters"){if(e.some((e=>!M(e.spatialReference))))throw new n("geodesic-areas:invalid-spatial-reference","the input geometries spatial reference is not supported");const s=[];for(let n=0;n<e.length;n++){const t=e[n],i=t.spatialReference,{radius:a,densificationRatio:o}=f(i),r=a*o;s.push(y(t,r))}const a=[],o=[0,0],r=[0,0];for(let n=0;n<s.length;n++){const{rings:e,spatialReference:c}=s[n];let l=0;for(let t=0;t<e.length;t++){const n=e[t];m(o,n[0],c),m(r,n[n.length-1],c);let i=r[0]*o[1]-o[0]*r[1];for(let e=0;e<n.length-1;e++)m(o,n[e+1],c),m(r,n[e],c),i+=r[0]*o[1]-o[0]*r[1];l+=i}l=i.convertUnit(l,"square-meters",t),a.push(l/-2)}return a}function R(e,t="meters"){if(!e)throw new n("geodesic-lengths:invalid-geometries","the input geometries type is not supported");const s=e.some((e=>!M(e.spatialReference)));if(s)throw new n("geodesic-lengths:invalid-spatial-reference","the input geometries spatial reference is not supported");const a=[];for(let n=0;n<e.length;n++){const s=e[n],{spatialReference:o}=s,r="polyline"===s.type?s.paths:s.rings;let c=0;for(let e=0;e<r.length;e++){const t=r[e];let n=0;for(let e=1;e<t.length;e++){const i=t[e-1][0],s=t[e][0],a=t[e-1][1],r=t[e][1];if(a!==r||i!==s){const e=new v;z(e,[i,a],[s,r],o),n+=e.distance}}c+=n}c=i.convertUnit(c,"meters",t),a.push(c)}return a}function y(e,t){if("polyline"!==e.type&&"polygon"!==e.type)throw new n("geodesic-densify:invalid-geometry","the input geometry is neither polyline nor polygon");const{spatialReference:i}=e;if(!M(i))throw new n("geodesic-densify:invalid-spatial-reference","the input geometry spatial reference is not supported");const a="polyline"===e.type?e.paths:e.rings,o=[],h=[0,0],u=new v;for(const n of a){const e=[];o.push(e),e.push([n[0][0],n[0][1]]);let s,a,r=n[0][0],c=n[0][1];for(let o=0;o<n.length-1;o++){if(s=n[o+1][0],a=n[o+1][1],r===s&&c===a)continue;const l=[r,c];z(u,[r,c],[s,a],i);const{azimuth:p,distance:f}=u,d=f/t;if(d>1){for(let n=1;n<=d-1;n++){b(h,l,p,n*t,i),e.push(h.slice())}b(h,l,p,(f+Math.floor(d-1)*t)/2,i),e.push(h.slice())}b(h,l,p,f,i),e.push(h.slice()),r=h[0],c=h[1]}}const p=s.ensureClass(r,i);return"polyline"===e.type?new c({paths:o,spatialReference:p}):new l({rings:o,spatialReference:p})}class v{constructor(e=0,t=void 0,n=void 0){this.distance=e,this.azimuth=t,this.reverseAzimuth=n}}function b(e,t,n,i,s){const o=t[0],r=t[1],c=o*a.toRadians,l=r*a.toRadians,h=(n??0)*a.toRadians,{a:u,b:p,f:d}=f(s),g=Math.sin(h),m=Math.cos(h),M=(1-d)*Math.tan(l),w=1/Math.sqrt(1+M*M),R=M*w,y=Math.atan2(M,m),v=w*g,b=v*v,z=1-b,S=z*(u*u-p*p)/(p*p),q=1+S/16384*(4096+S*(S*(320-175*S)-768)),x=S/1024*(256+S*(S*(74-47*S)-128));let A,N,G,P,U=i/(p*q),k=2*Math.PI;for(;Math.abs(U-k)>1e-12;)G=Math.cos(2*y+U),A=Math.sin(U),N=Math.cos(U),P=x*A*(G+x/4*(N*(2*G*G-1)-x/6*G*(4*A*A-3)*(4*G*G-3))),k=U,U=i/(p*q)+P;const C=R*A-w*N*m,D=Math.atan2(R*N+w*A*m,(1-d)*Math.sqrt(b+C*C)),F=d/16*z*(4+d*(4-3*z)),j=Math.atan2(A*g,w*N-R*A*m)-(1-F)*d*v*(U+F*A*(G+F*N*(2*G*G-1))),I=D/a.toRadians,O=(c+j)/a.toRadians;return e[0]=O,e[1]=I,e}function z(e,t,n,i){const s=t[0]*a.toRadians,o=t[1]*a.toRadians,r=n[0]*a.toRadians,c=n[1]*a.toRadians,{a:l,b:h,f:u,radius:p}=f(i),d=r-s,g=Math.atan((1-u)*Math.tan(o)),m=Math.atan((1-u)*Math.tan(c)),M=Math.sin(g),w=Math.cos(g),R=Math.sin(m),y=Math.cos(m);let v,b,z,S,q,x,A,N,G,P,U=1e3,k=d;do{if(A=Math.sin(k),N=Math.cos(k),z=Math.sqrt(y*A*(y*A)+(w*R-M*y*N)*(w*R-M*y*N)),0===z)return e.distance=0,e.azimuth=void 0,e.reverseAzimuth=void 0,e;q=M*R+w*y*N,x=Math.atan2(z,q),G=w*y*A/z,b=1-G*G,S=q-2*M*R/b,isNaN(S)&&(S=0),P=u/16*b*(4+u*(4-3*b)),v=k,k=d+(1-P)*u*G*(x+P*z*(S+P*q*(2*S*S-1)))}while(Math.abs(k-v)>1e-12&&--U>0);if(0===U){const t=p,n=Math.acos(Math.sin(o)*Math.sin(c)+Math.cos(o)*Math.cos(c)*Math.cos(r-s))*t,i=r-s,l=Math.sin(i)*Math.cos(c),h=Math.cos(o)*Math.sin(c)-Math.sin(o)*Math.cos(c)*Math.cos(i),u=Math.atan2(l,h);return e.azimuth=u/a.toRadians,e.distance=n,e.reverseAzimuth=void 0,e}const C=b*(l*l-h*h)/(h*h),D=C/1024*(256+C*(C*(74-47*C)-128)),F=h*(1+C/16384*(4096+C*(C*(320-175*C)-768)))*(x-D*z*(S+D/4*(q*(2*S*S-1)-D/6*S*(4*z*z-3)*(4*S*S-3)))),j=Math.atan2(y*Math.sin(k),w*R-M*y*Math.cos(k)),I=Math.atan2(w*Math.sin(k),w*R*Math.cos(k)-M*y);return e.azimuth=j/a.toRadians,e.distance=F,e.reverseAzimuth=I/a.toRadians,e}function S(e,t,s="meters"){if(!e||!t)throw new n("geodesic-distance:missing-parameters","one or both input parameters are missing");if(!e.spatialReference||!t.spatialReference)throw new n("geodesic-distance:invalid-parameters","one or both input points do not have a spatial reference");if(!o.equals(e.spatialReference,t.spatialReference))throw new n("geodesic-distance:invalid-parameters","spatial references of input parameters do not match");const{spatialReference:a}=e;if(!M(a))throw new n("geodesic-distance:not-supported","input geometry spatial reference is not supported");if(e.x===t.x&&e.y===t.y)return new v(0,0,0);const r=new v;return z(r,[e.x,e.y],[t.x,t.y],a),r.distance=i.convertUnit(r.distance,"meters",s),r.azimuth=g(r.azimuth),r.reverseAzimuth=g(r.reverseAzimuth),r}function q(e,t,i){if(!e||null==t||null==i)throw new n("point-from-distance:missing-parameters","one or more input parameters are missing or undefined");if(i<0||i>360)throw new n("point-from-distance:-of-bounds","azimuth is restricted to angles between, and including, 0° to 360° degrees");if(!e.spatialReference)throw new n("point-from-distance:missing-spatial-reference","the input point must have a spatial reference");const{spatialReference:s}=e;if(!M(s))throw new n("geodesic-distance:not-supported","input geometry spatial reference is not supported");const a=[0,0];return b(a,[e.x,e.y],i,t,s),new h({x:a[0],y:a[1],spatialReference:s})}function x(e){return M(e)?e:o.isWebMercator(e)?r.WGS84:null}e.InverseGeodeticSolverResult=v,e.directGeodeticSolver=b,e.geodesicAreas=w,e.geodesicCompatibleSpatialReference=x,e.geodesicDensify=y,e.geodesicDistance=S,e.geodesicLengths=R,e.inverseGeodeticSolver=z,e.isSupported=M,e.pointFromDistance=q,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
