/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../core/has","../../core/Error","../HeightModelInfo","../../layers/support/arcgisLayerUrl"],(function(e,t,n,i,a){"use strict";function r(e,t){if(!e)return null;if(!l(e))return new n("webscene:unsupported-height-model-info","The vertical coordinate system of the scene is not supported",{heightModelInfo:e});const a=e.heightUnit,r=i.deriveUnitFromSR(e,t).heightUnit;return a!==r?new n("webscene:incompatible-height-unit",`The vertical units of the scene (${a}) must match the horizontal units of the scene (${r})`,{verticalUnit:a,horizontalUnit:r}):null}function o(e,t,a){const r=u(e),o=t,l=s(r,o,a);if(r){const t=i.deriveUnitFromSR(r,e.spatialReference).heightUnit;if(!a&&t!==r.heightUnit){const e=new n("layerview:unmatched-height-unit",`The vertical units of the layer must match the horizontal units (${t})`,{horizontalUnit:t});return new n("layerview:unsupported-height-model-info","The vertical coordinate system of the layer is not supported",{heightModelInfo:r,error:e})}}if(!h(e)||l===c.Unsupported)return new n("layerview:unsupported-height-model-info","The vertical coordinate system of the layer is not supported",{heightModelInfo:r});switch(l){case c.Units:{const e=r?.heightUnit||"unknown",t=o?.heightUnit||"unknown",i=new n("layerview:incompatible-height-unit",`The vertical units of the layer (${e}) must match the vertical units of the scene (${t})`,{layerUnit:e,sceneUnit:t});return new n("layerview:incompatible-height-model-info","The vertical coordinate system of the layer is incompatible with the scene",{layerHeightModelInfo:r,sceneHeightModelInfo:o,error:i})}case c.HeightModel:{const e=r?.heightModel||"unknown",t=o?.heightModel||"unknown",i=new n("layerview:incompatible-height-model",`The height model of the layer (${e}) must match the height model of the scene (${t})`,{layerHeightModel:e,sceneHeightModel:t});return new n("layerview:incompatible-height-model-info","The vertical coordinate system of the layer is incompatible with the scene",{layerHeightModelInfo:r,sceneHeightModelInfo:o,error:i})}case c.CRS:{const e=r?.vertCRS||"unknown",t=o?.vertCRS||"unknown",i=new n("layerview:incompatible-vertical-datum",`The vertical datum of the layer (${e}) must match the vertical datum of the scene (${t})`,{layerDatum:e,sceneDatum:t});return new n("layerview:incompatible-height-model-info","The vertical coordinate system of the layer is incompatible with the scene",{layerHeightModelInfo:r,sceneHeightModelInfo:o,error:i})}}return null}function s(e,t,n){if(!l(e)||!l(t))return c.Unsupported;if(null==e||null==t)return c.Ok;if(!n&&e.heightUnit!==t.heightUnit)return c.Units;if(e.heightModel!==t.heightModel)return c.HeightModel;switch(e.heightModel){case"gravity-related-height":return c.Ok;case"ellipsoidal":return e.vertCRS===t.vertCRS?c.Ok:c.CRS;default:return c.Unsupported}}var c;function l(e){return null==e||null!=e.heightModel&&null!=e.heightUnit}function h(e){return"heightModelInfo"in e&&null!=e.heightModelInfo||null!=e.spatialReference||!f(e)}function u(e){if("integrated-mesh-3dtiles"===e.type)return null;const t=e.url?a.parse(e.url):void 0,n=e.spatialReference?.vcsWkid;return!(null==n&&null!=t&&"ImageServer"===t.serverType)&&d(e)&&e.heightModelInfo?e.heightModelInfo:f(e)?i.deriveUnitFromSR(y,e.spatialReference):null}function d(e){return"heightModelInfo"in e}function g(e){if("unknown"===e.type||!("capabilities"in e))return!1;switch(e.type){case"catalog":case"catalog-footprint":case"csv":case"feature":case"geojson":case"subtype-group":case"ogc-feature":case"oriented-imagery":case"wfs":case"knowledge-graph-sublayer":return!0;default:return!1}}function f(e){return g(e)?!!(e.capabilities&&e.capabilities.data&&e.capabilities.data.supportsZ):m(e)}function p(e){return null!=e.layers||m(e)||g(e)||d(e)}function m(e){switch(e.type){case"building-scene":case"elevation":case"integrated-mesh":case"integrated-mesh-3dtiles":case"point-cloud":case"scene":case"voxel":return!0;case"base-dynamic":case"base-elevation":case"base-tile":case"bing-maps":case"catalog":case"catalog-footprint":case"catalog-dynamic-group":case"csv":case"dimension":case"geojson":case"feature":case"focusArea":case"subtype-group":case"geo-rss":case"graphics":case"group":case"imagery":case"imagery-tile":case"kml":case"knowledge-graph":case"link-chart":case"knowledge-graph-sublayer":case"line-of-sight":case"map-image":case"map-notes":case"media":case"ogc-feature":case"open-street-map":case"oriented-imagery":case"parquet":case"route":case"stream":case"tile":case"unknown":case"unsupported":case"vector-tile":case"video":case"viewshed":case"wcs":case"web-tile":case"wfs":case"wms":case"wmts":case null:return!1}return!1}!function(e){e[e.Ok=0]="Ok",e[e.Units=1]="Units",e[e.HeightModel=2]="HeightModel",e[e.CRS=3]="CRS",e[e.Unsupported=4]="Unsupported"}(c||(c={}));const y=new i({heightModel:"gravity-related-height"});e.deriveHeightModelInfoFromLayer=u,e.rejectLayerError=o,e.supportsHeightModelInfo=p,e.validateWebSceneError=r,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
