/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../../core/Logger","../../../../../core/MapUtils","../../../../../core/mathUtils","../../../../../core/libs/gl-matrix-2/math/quat","../../../../../core/libs/gl-matrix-2/factories/quatf64","../../../../../chunks/vec32","../../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../MeshMaterialMetallicRoughness","../../vertexSpaceConversion","./buffer","./geometry","./types","./imageutils","../../../../../views/3d/glTF/internal/resourceUtils","../../../../../views/webgl/enums"],(function(e,t,s,r,a,i,n,o,l,u,c,h,f,p,d,g){"use strict";const m=()=>t.getLogger("esri.geometry.support.meshUtils.exporters.gltf.gltf");class T{constructor(e,t){this.options=t,this._materialMap=new Array,this._imageMap=new Map,this._textureMap=new Map,this.gltf={asset:{version:"2.0",copyright:e.copyright,generator:e.generator},extras:{output:t.output,binChunkBuffer:null,promises:[]}},this._addScenes(e)}_addScenes(e){this.gltf.scene=e.defaultScene;const t=this.gltf.extras,s=t.output.buffer===f.BufferOutputType.GLB||t.output.image===f.ImageOutputType.GLB;s&&(t.binChunkBuffer=new c.Buffer(this.gltf)),e.forEachScene((e=>{this._addScene(e)})),s&&t.binChunkBuffer.finalize()}_addScene(e){this.gltf.scenes||(this.gltf.scenes=[]);const t={};e.name&&(t.name=e.name),e.forEachNode((e=>{t.nodes||(t.nodes=[]),t.nodes.push(...this._addNodes(e))})),this.gltf.scenes.push(t)}_addNodes(e){this.gltf.nodes||(this.gltf.nodes=[]);const t={};e.name&&(t.name=e.name);const s=e.translation;n.exactEquals(s,o.ZEROS)||(t.translation=o.clone(s));const r=e.rotation;a.exactEquals(r,i.IDENTITY)||(t.rotation=i.clone(r));const l=e.scale;n.exactEquals(l,o.ONES)||(t.scale=o.clone(l));const u=this.gltf.nodes.length;if(this.gltf.nodes.push(t),e.mesh&&e.mesh.vertexAttributes.position){const s=this._createMeshes(e.mesh),r=[u];if(1===s.length)this._addMesh(t,s[0]);else for(const e of s){const t={};this._addMesh(t,e),r.push(this.gltf.nodes.length),this.gltf.nodes.push(t)}return r}return e.forEachNode((e=>{t.children||(t.children=[]),t.children.push(...this._addNodes(e))})),[u]}_addMesh(e,t){this.gltf.meshes??=[];const s=this.gltf.meshes.length;this.gltf.meshes.push(t),e.mesh=s}_createMeshes(e){const t=this.gltf.extras,s=t.output.buffer===f.BufferOutputType.GLB;let r;r=s?t.binChunkBuffer:new c.Buffer(this.gltf);const a=this.options.origin,i=e.vertexSpace.clone();i.origin=[a.x,a.y,a.z??0];const n=u.convertVertexSpace({vertexAttributes:e.vertexAttributes,vertexSpace:e.vertexSpace,transform:this.options?.ignoreLocalTransform?null:e.transform,spatialReference:e.spatialReference},i,{targetUnit:this.options.unitConversionDisabled?void 0:"meters"});if(!n)return[];h.smoothNormals(e,n),x(n);const{position:o,normal:l,tangent:p}=n,{uv:d,color:m}=e.vertexAttributes,T=r.addBufferView(g.DataType.FLOAT,f.AttributeType.VEC3,f.TargetBuffer.ARRAY_BUFFER);let _,A,M,b;l&&(_=r.addBufferView(g.DataType.FLOAT,f.AttributeType.VEC3,f.TargetBuffer.ARRAY_BUFFER)),d&&(A=r.addBufferView(g.DataType.FLOAT,f.AttributeType.VEC2,f.TargetBuffer.ARRAY_BUFFER)),p&&(M=r.addBufferView(g.DataType.FLOAT,f.AttributeType.VEC4,f.TargetBuffer.ARRAY_BUFFER)),m&&(b=r.addBufferView(g.DataType.UNSIGNED_BYTE,f.AttributeType.VEC4,f.TargetBuffer.ARRAY_BUFFER)),T.startAccessor("POSITION"),_&&_.startAccessor("NORMAL"),A&&A.startAccessor("TEXCOORD_0"),M&&M.startAccessor("TANGENT"),b&&b.startAccessor("COLOR_0");const R=n.position.length/3;for(let u=0;u<R;++u)T.push(o[3*u]),T.push(o[3*u+1]),T.push(o[3*u+2]),_&&null!=l&&(_.push(l[3*u]),_.push(l[3*u+1]),_.push(l[3*u+2])),A&&null!=d&&(A.push(d[2*u]),A.push(d[2*u+1])),M&&null!=p&&(M.push(p[4*u]),M.push(p[4*u+1]),M.push(p[4*u+2]),M.push(p[4*u+3])),b&&null!=m&&(b.push(m[4*u]),b.push(m[4*u+1]),b.push(m[4*u+2]),b.push(m[4*u+3]));const E=T.endAccessor(),O=this._addAccessor(T.index,E);let y,B,w,I,N;if(_){const e=_.endAccessor();y=this._addAccessor(_.index,e)}if(A){const e=A.endAccessor();B=this._addAccessor(A.index,e)}if(M){const e=M.endAccessor();w=this._addAccessor(M.index,e)}if(b){const e=b.endAccessor();I=this._addAccessor(b.index,e)}const v=[];return e.components&&e.components.length>0&&e.components[0].faces?(N=r.addBufferView(g.DataType.UNSIGNED_INT,f.AttributeType.SCALAR,f.TargetBuffer.ELEMENT_ARRAY_BUFFER),this._addMeshVertexIndexed(N,e.components,v,O,y,B,w,I)):this._addMeshVertexNonIndexed(e.components,v,O,y,B,w,I),T.finalize(),_&&_.finalize(),A&&A.finalize(),M&&M.finalize(),N&&N.finalize(),b&&b.finalize(),s||r.finalize(),v}_addMaterial(e){if(null===e)return;const t=this._materialMap.indexOf(e);if(-1!==t)return t;this.gltf.materials||(this.gltf.materials=[]);const s={};switch(e.alphaMode){case"mask":s.alphaMode=f.AlphaMode.MASK;break;case"auto":case"blend":s.alphaMode=f.AlphaMode.BLEND}s.alphaCutoff=e.alphaCutoff,e.doubleSided&&(s.doubleSided=e.doubleSided),s.pbrMetallicRoughness={};const r=e=>e**2.1,a=e=>{const t=e.toRgba();return t[0]=r(t[0]/255),t[1]=r(t[1]/255),t[2]=r(t[2]/255),t};if(null!=e.color&&(s.pbrMetallicRoughness.baseColorFactor=a(e.color)),null!=e.colorTexture&&(s.pbrMetallicRoughness.baseColorTexture=this._createTextureInfo(e.colorTexture,e.colorTextureTransform)),null!=e.normalTexture&&(s.normalTexture=this._createTextureInfo(e.normalTexture,e.normalTextureTransform)),e instanceof l){if(null!=e.emissiveTexture&&(s.emissiveTexture=this._createTextureInfo(e.emissiveTexture,e.emissiveTextureTransform)),null!=e.emissiveColor){const t=a(e.emissiveColor);s.emissiveFactor=[t[0],t[1],t[2]]}null!=e.occlusionTexture&&(s.occlusionTexture=this._createTextureInfo(e.occlusionTexture,e.occlusionTextureTransform)),null!=e.metallicRoughnessTexture&&(s.pbrMetallicRoughness.metallicRoughnessTexture=this._createTextureInfo(e.metallicRoughnessTexture,e.metallicRoughnessTextureTransform)),s.pbrMetallicRoughness.metallicFactor=e.metallic,s.pbrMetallicRoughness.roughnessFactor=e.roughness}else s.pbrMetallicRoughness.metallicFactor=1,s.pbrMetallicRoughness.roughnessFactor=1,m().warnOnce("Meshes exported to GLTF without MeshMaterialMetallicRoughness material will appear different when imported back.");const i=this.gltf.materials.length;return this.gltf.materials.push(s),this._materialMap.push(e),i}_createTextureInfo(e,t){const s={index:this._addTexture(e)};return t?(s.extensions||(s.extensions={}),s.extensions.KHR_texture_transform={scale:t.scale,offset:t.offset,rotation:r.deg2rad(t.rotation)},s):s}_addTexture(e){const t=this.gltf.textures??[];return this.gltf.textures=t,s.getOrCreateMapValue(this._textureMap,e,(()=>{const s={sampler:this._addSampler(e),source:this._addImage(e)},r=t.length;return t.push(s),r}))}_addImage(e){const t=this._imageMap.get(e);if(null!=t)return t;this.gltf.images||(this.gltf.images=[]);const s={};if(e.url)s.uri=e.url;else{const t=e.data;s.extras=t;for(let e=0;e<this.gltf.images.length;++e)if(t===this.gltf.images[e].extras)return e;const r=this.gltf.extras;switch(r.output.image){case f.ImageOutputType.GLB:{const e=r.binChunkBuffer.addBufferView(g.DataType.UNSIGNED_BYTE,f.AttributeType.SCALAR);if(d.isEncodedMeshTexture(t))null!=t.data&&e.writeOutToBuffer(t.data,0);else{const a=p.imageToArrayBuffer(t,this.options.signal).then((({data:e,type:t})=>(s.mimeType=t,e)));r.promises.push(e.writeAsync(a).then((()=>{e.finalize()})))}s.bufferView=e.index;break}case f.ImageOutputType.DataURI:if(d.isEncodedMeshTexture(t)){m().warnOnce("Image export for basis compressed textures not available.");break}s.uri=p.imageToDataURI(t);break;default:if(d.isEncodedMeshTexture(t)){m().warnOnce("Image export for basis compressed textures not available.");break}r.promises.push(p.imageToArrayBuffer(t,this.options.signal).then((({data:e,type:t})=>{s.uri=e,s.mimeType=t})))}}const r=this.gltf.images.length;return this.gltf.images.push(s),this._imageMap.set(e,r),r}_addSampler(e){this.gltf.samplers||(this.gltf.samplers=[]);let t=g.TextureWrapMode.REPEAT,s=g.TextureWrapMode.REPEAT;if("string"==typeof e.wrap)switch(e.wrap){case"clamp":t=g.TextureWrapMode.CLAMP_TO_EDGE,s=g.TextureWrapMode.CLAMP_TO_EDGE;break;case"mirror":t=g.TextureWrapMode.MIRRORED_REPEAT,s=g.TextureWrapMode.MIRRORED_REPEAT}else{switch(e.wrap.vertical){case"clamp":s=g.TextureWrapMode.CLAMP_TO_EDGE;break;case"mirror":s=g.TextureWrapMode.MIRRORED_REPEAT}switch(e.wrap.horizontal){case"clamp":t=g.TextureWrapMode.CLAMP_TO_EDGE;break;case"mirror":t=g.TextureWrapMode.MIRRORED_REPEAT}}const r={wrapS:t,wrapT:s};for(let i=0;i<this.gltf.samplers.length;++i)if(JSON.stringify(r)===JSON.stringify(this.gltf.samplers[i]))return i;const a=this.gltf.samplers.length;return this.gltf.samplers.push(r),a}_addAccessor(e,t){this.gltf.accessors||(this.gltf.accessors=[]);const s={bufferView:e,byteOffset:t.byteOffset,componentType:t.componentType,count:t.count,type:t.type,min:t.min,max:t.max,name:t.name};t.normalized&&(s.normalized=!0);const r=this.gltf.accessors.length;return this.gltf.accessors.push(s),r}_addMeshVertexIndexed(e,t,s,r,a,i,n,o){const l=new Map;for(const u of t){e.startAccessor("INDICES");for(let s=0;s<u.faces.length;++s)e.push(u.faces[s]);const t=e.endAccessor(),c={attributes:{POSITION:r},indices:this._addAccessor(e.index,t),material:this._addMaterial(u.material)};a&&"flat"!==u.shading&&(c.attributes.NORMAL=a),i&&(c.attributes.TEXCOORD_0=i),n&&"flat"!==u.shading&&(c.attributes.TANGENT=n),o&&(c.attributes.COLOR_0=o);const h=l.get(u.name);if(h)h.primitives.push(c);else{const e={name:u.name,primitives:[c]};l.set(u.name,e),s.push(e)}}}_addMeshVertexNonIndexed(e,t,s,r,a,i,n){const o={primitives:[]};t.push(o);const l={attributes:{POSITION:s}};r&&(l.attributes.NORMAL=r),a&&(l.attributes.TEXCOORD_0=a),i&&(l.attributes.TANGENT=i),n&&(l.attributes.COLOR_0=n),e&&(l.material=this._addMaterial(e[0].material)),o.primitives.push(l)}}function x({position:e,normal:t,tangent:s}){_(e,3),_(t,3),_(s,4)}function _(e,t){if(null!=e)for(let s=1,r=2;s<e.length;s+=t,r+=t){const t=e[s],a=e[r];e[s]=a,e[r]=-t}}e.GLTF=T,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
