/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../Color","../../../request","../../../core/Error","../../../core/MapUtils","../../../core/mathUtils","../../../core/libs/gl-matrix-2/math/mat3","../../../core/libs/gl-matrix-2/factories/mat3f64","../../../core/libs/gl-matrix-2/factories/vec3f64","../../../core/libs/gl-matrix-2/factories/vec4f64","../MeshComponent","../MeshMaterialMetallicRoughness","../MeshTexture","../MeshTextureTransform","../MeshVertexAttributes","../meshVertexSpaceUtils","../buffer/BufferView","../../../chunks/vec3","../../../chunks/vec4","../buffer/utils","./vertexSpaceConversion","../../../views/3d/glTF/DefaultLoadingContext","../../../views/3d/glTF/loader","../../../views/3d/glTF/internal/indexUtils","../../../views/3d/glTF/internal/resourceUtils","../../../views/3d/webgl-engine/materials/DefaultMaterial_COLOR_GAMMA","../../../views/webgl/enums","../../../chunks/vec33","../../../chunks/vec43","../../../chunks/vec2"],(function(e,t,r,n,o,a,s,i,l,c,u,f,m,p,d,g,x,w,T,V,h,v,M,b,B,y,C,R,S,A){"use strict";async function E(e,t,r){const o=new v.DefaultLoadingContext(F(r)),a=(await M.loadGLTF(o,t,r,!0)).model,s=a.lods.shift(),i=new Map,l=new Map;a.textures.forEach(((e,t)=>i.set(t,U(e)))),a.materials.forEach(((e,t)=>l.set(t,D(e,i))));const c=L(s);for(const n of c.parts)k(c,n,l);const{position:u,normal:f,tangent:m,color:p,texCoord0:x}=c.vertexAttributes,w=g.selectVertexSpace(e,r),T=e.spatialReference.isGeographic?g.selectVertexSpace(e):w,V=h.convertVertexSpace({vertexAttributes:{position:u.typedBuffer,normal:f?.typedBuffer,tangent:m?.typedBuffer},vertexSpace:T,spatialReference:e.spatialReference},w,{allowBufferReuse:!0,sourceUnit:r?.unitConversionDisabled?void 0:"meters"});if(!V)throw new n("load-gltf-mesh:vertex-space-projection",`Failed to load mesh from glTF because we could not convert the vertex space from ${T.type} to ${w.type}`);return{transform:null,vertexSpace:w,components:c.components,spatialReference:e.spatialReference,vertexAttributes:new d.MeshVertexAttributes({...V,color:p?.typedBuffer,uv:x?.typedBuffer})}}function F(e){const t=e?.resolveFile;return t?{busy:!1,request:async(e,n,o)=>{const a=t?.(e)??e,s="image"===n?"image":"binary"===n||"image+type"===n?"array-buffer":"json";return(await r(a,{responseType:s,signal:o?.signal,timeout:0})).data}}:null}function $(e,t){if(null==e)return"-";const r=e.typedBuffer;return`${o.getOrCreateMapValue(t,r.buffer,(()=>t.size))}/${r.byteOffset}/${r.byteLength}`}function O(e){return null!=e?e.toString():"-"}function L(e){let t=0;const r={color:!1,tangent:!1,normal:!1,texCoord0:!1},n=new Map,a=new Map,s=[];for(const i of e.parts){const{attributes:{position:e,normal:l,color:c,tangent:u,texCoord0:f}}=i,m=`\n      ${$(e,n)}/\n      ${$(l,n)}/\n      ${$(c,n)}/\n      ${$(u,n)}/\n      ${$(f,n)}/\n      ${O(i.transform)}\n    `;let p=!1;const d=o.getOrCreateMapValue(a,m,(()=>(p=!0,{start:t,length:e.count})));p&&(t+=e.count),l&&(r.normal=!0),c&&(r.color=!0),u&&(r.tangent=!0),f&&(r.texCoord0=!0),s.push({gltf:i,writeVertices:p,region:d})}return{vertexAttributes:{position:V.createBuffer(x.BufferViewVec3f64,t),normal:r.normal?V.createBuffer(x.BufferViewVec3f,t):null,tangent:r.tangent?V.createBuffer(x.BufferViewVec4f,t):null,color:r.color?V.createBuffer(x.BufferViewVec4u8,t):null,texCoord0:r.texCoord0?V.createBuffer(x.BufferViewVec2f,t):null},parts:s,components:[]}}function U(e){return new m({data:(B.isEncodedMeshTexture(e.data),e.data),wrap:z(e.parameters.wrap)})}function D(e,r){const n=new t(j(e.color,e.opacity)),o=e.emissiveFactor?new t(q(e.emissiveFactor)):null,s=e=>e?new p({scale:e.scale?[e.scale[0],e.scale[1]]:[1,1],rotation:a.rad2deg(e.rotation??0),offset:e.offset?[e.offset[0],e.offset[1]]:[0,0]}):null;return new f({color:n,colorTexture:r.get(e.textureColor),normalTexture:r.get(e.textureNormal),emissiveColor:o,emissiveTexture:r.get(e.textureEmissive),occlusionTexture:r.get(e.textureOcclusion),alphaMode:P(e.alphaMode),alphaCutoff:e.alphaCutoff,doubleSided:e.doubleSided,metallic:e.metallicFactor,roughness:e.roughnessFactor,metallicRoughnessTexture:r.get(e.textureMetallicRoughness),colorTextureTransform:s(e.colorTextureTransform),normalTextureTransform:s(e.normalTextureTransform),occlusionTextureTransform:s(e.occlusionTextureTransform),emissiveTextureTransform:s(e.emissiveTextureTransform),metallicRoughnessTextureTransform:s(e.metallicRoughnessTextureTransform)})}function k(e,t,r){t.writeVertices&&G(e,t);const{indices:n,attributes:o,primitiveType:a,material:s}=t.gltf;let i=b.convertPrimitiveToTriangles(n||o.position.count,a);const l=t.region.start;if(l){const e=new Uint32Array(i);for(let t=0;t<i.length;t++)e[t]+=l;i=e}e.components.push(new u({name:t.gltf.name,faces:i,material:r.get(s),shading:o.normal?"source":"flat",trustSourceNormals:!0}))}function G(e,t){const{position:r,normal:n,tangent:o,color:l,texCoord0:c}=e.vertexAttributes,u=t.region.start,{attributes:f,transform:m}=t.gltf,p=f.position.count;if(w.transformMat4View(r.slice(u,p),f.position,m),null!=f.normal&&null!=n){const e=s.normalFromMat4(i.create(),m),t=n.slice(u,p);w.transformMat3View(t,f.normal,e),a.hasScaling(e)&&w.normalizeView(t,t)}else null!=n&&R.fill(n,0,0,1,{dstIndex:u,count:p});if(null!=f.tangent&&null!=o){const e=s.fromMat4(i.create(),m),t=o.slice(u,p);T.transformMat3View(t,f.tangent,e),a.hasScaling(e)&&T.normalize(t,t)}else null!=o&&S.fill(o,0,0,1,1,{dstIndex:u,count:p});if(null!=f.texCoord0&&null!=c?A.normalizeIntegerBufferView(c.slice(u,p),f.texCoord0):null!=c&&A.fill(c,0,0,{dstIndex:u,count:p}),null!=f.color&&null!=l){const e=f.color,t=l.slice(u,p);if(4===e.elementCount)e instanceof x.BufferViewVec4f?T.scaleView(t,e,255):e instanceof x.BufferViewVec4u8?S.copyView(t,e):e instanceof x.BufferViewVec4u16&&T.scaleView(t,e,1/256);else{S.fill(t,255,255,255,255);const r=x.BufferViewVec3u8.fromTypedArray(t.typedBuffer,t.typedBufferStride);e instanceof x.BufferViewVec3f?w.scaleView(r,e,255):e instanceof x.BufferViewVec3u8?R.copyView(r,e):e instanceof x.BufferViewVec3u16&&w.scaleView(r,e,1/256)}}else null!=l&&S.fill(l.slice(u,p),255,255,255,255)}function P(e){switch(e){case"OPAQUE":return"opaque";case"MASK":return"mask";case"BLEND":return"blend"}}function z(e){return{horizontal:I(e.s),vertical:I(e.t)}}function I(e){switch(e){case C.TextureWrapMode.CLAMP_TO_EDGE:return"clamp";case C.TextureWrapMode.MIRRORED_REPEAT:return"mirror";case C.TextureWrapMode.REPEAT:return"repeat"}}function _(e){return e**(1/y.colorGamma)*255}function j(e,t){return c.fromValues(_(e[0]),_(e[1]),_(e[2]),t)}function q(e){return l.fromValues(_(e[0]),_(e[1]),_(e[2]))}e.loadGLTFMesh=E,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
