/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../core/Logger","../../../chunks/vec32","../../../core/libs/gl-matrix-2/factories/vec3f64","../MeshComponent","../MeshVertexAttributes","./vertexSpaceConversion"],(function(e,t,n,r,o,l,i){"use strict";const s=()=>t.getLogger("esri.geometry.support.triangleMeshMerge");function a(e,t){if(0===e.length)return s().error("merge()","Must specify one more geometries to merge"),null;const n=e[0].spatialReference;for(const i of e){if(!i.spatialReference.equals(n))return s().error("merge()","Geometries must all be in the same spatial reference"),null;if(!i.loaded)return s().error("merge()","Geometries must all be loaded before merging"),null}const r=c(e);if(null==r)return null;const o=h(e),l=[],a={position:0,uv:0,normal:0,tangent:0,color:0},u=new Map,f=new Map;for(const c of e){const e=r.rebake?i.convertVertexSpace(c,r.vertexSpace,{allowBufferReuse:!0}):c.vertexAttributes;if(!e)return s().error("merge()","Failed to convert vertex space due to projection errors"),null;if(t&&t.reuseMaterials&&c.components)for(const t of c.components)t.material&&u.set(t.material,t.material);p(c,a,u,f,l),g("position",e,o,a,0),g("normal",e,o,a,0),g("tangent",e,o,a,0),g("uv",c.vertexAttributes,o,a,0),g("color",c.vertexAttributes,o,a,255)}return{vertexAttributes:o,components:l,vertexSpace:r.vertexSpace,transform:r.rebake?null:r.transform,spatialReference:n}}function c(e){let t=null,o=null,l=!0,i=!0,a=null;const c=r.create();let u=0;for(const r of e){const{vertexSpace:e,transform:f}=r;if(null==o){o=e;const t=o.origin;t&&(a=t)}if(o.type!==e.type)return s().error("merge()",`Inconsistent mesh vertex space for provided geometries. One was ${o.type} while another is ${e.type}. Unable to merge geometries.`),null;null==t||null!=f&&f.equals(t)||(l=!1),null!=f&&null==t&&(t=f);const p=e.origin;p&&(a&&!n.equals(p,a)&&(i=!1),u++,n.add(c,c,p))}if(null==o)throw new Error;const f=o.clone();if(null==f.origin)return{rebake:!1,vertexSpace:f};if(i&&l)return{rebake:!1,vertexSpace:f,transform:t?.clone()};const p=n.scale(c,c,1/u);return f.origin=p,{rebake:!0,vertexSpace:f}}function u(e,t){return t.normal>0&&!e.vertexAttributes.normal}function f(e,t,n){u(e,t)&&"source"===n.shading&&(n.shading="flat")}function p(e,t,n,r,l){if(e.components)for(const o of e.components){const i=o.cloneWithDeduplication(n,r),s=t.position/3;if(i.faces)for(let e=0;e<i.faces.length;e++)i.faces[e]+=s;else{i.faces=new Uint32Array(e.vertexAttributes.position.length/3);for(let e=0;e<i.faces.length;e++)i.faces[e]=e+s}f(e,t,i),l.push(i)}else if(e.vertexAttributes&&e.vertexAttributes.position){const n=e.vertexAttributes.position.length/3,r=new Uint32Array(n),i=t.position/3;for(let e=0;e<n;e++)r[e]=e+i;const s=new o({faces:r});f(e,t,s),l.push(s)}}function g(e,t,n,r,o){if(!t)return;const l=t.position;if(!l)return;const i=t[e],s=n[e];if(null==i){let t=r[e];const n=b[e];if(null!=s){for(let e=0;e<l.length;e+=3)for(let r=0;r<n;r++)s[t++]=o;r[e]=t}}else null!=s&&null!=i&&(m(i,0,s,r[e],i.length),r[e]+=i.length)}function m(e,t,n,r,o){for(let l=0;l<o;l++)n[r++]=e[t++];return n}function v(e){let t=!1,n=!1,r=!1,o=!1;for(const l of e){const e=l.vertexAttributes;if(e?.position&&(e.uv&&(t=!0),e.normal&&(n=!0),e.tangent&&(o=!0),e.color&&(r=!0),n&&t&&r&&o))break}return{normal:n,uv:t,color:r,tangent:o}}function h(e){let t=0,n=0,r=0,o=0,i=0;const s=v(e);for(const l of e){const e=l.vertexAttributes;e?.position&&(t+=e.position.length,s.uv&&(n+=e.position.length/b.position*b.uv),s.normal&&(r+=e.position.length/b.position*b.normal),s.color&&(o+=e.position.length/b.position*b.color),s.tangent&&(i+=e.position.length/b.position*b.tangent))}return new l.MeshVertexAttributes({position:new Float64Array(t),uv:n?new Float32Array(n):null,normal:r?new Float32Array(r):null,tangent:i?new Float32Array(i):null,color:o?new Uint8Array(o):null})}const b={position:3,normal:3,tangent:4,uv:2,color:4};e.merge=a,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
