/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../core/mathUtils","../../../core/libs/gl-matrix-2/math/mat3","../../../core/libs/gl-matrix-2/factories/mat3f64","../../../core/libs/gl-matrix-2/math/mat4","../../../core/libs/gl-matrix-2/factories/mat4f64","../../../chunks/vec32","../../../core/libs/gl-matrix-2/factories/vec3f64","../../projection/computeTranslationToOriginAndRotation","../../projection/projectBuffer","../Ellipsoid","../spatialReferenceUtils","../webMercatorUtils","../buffer/BufferView","../../../chunks/vec3","../../../chunks/vec4"],(function(r,e,t,o,f,n,c,a,i,u,l,T,s,m,V,y){"use strict";const p="Projection may be possible after calling projection.load().";function P(r,e,t,o){r.error(`Failed to project from (wkid:${e.wkid}) to (wkid:${t.wkid}).${o?" ":""}${o}`)}function A(e,t,o,f,n,c){return _(R.TO_PCPF,m.BufferViewVec3f.fromTypedArray(e),r.VectorType.NORMAL,m.BufferViewVec3f64.fromTypedArray(t),o,m.BufferViewVec3f64.fromTypedArray(f),n,m.BufferViewVec3f.fromTypedArray(c))?c:null}function d(e,t,o,f,n,c){return _(R.FROM_PCPF,m.BufferViewVec3f.fromTypedArray(e),r.VectorType.NORMAL,m.BufferViewVec3f64.fromTypedArray(t),o,m.BufferViewVec3f64.fromTypedArray(f),n,m.BufferViewVec3f.fromTypedArray(c))?c:null}function M(r,e,t,o){return u.projectBuffer(r,e,0,t,o,0)?t:null}function F(r,e,t,o){return u.projectBuffer(r,e,0,t,o,0)?t:null}function g(r,o,f){return t.normalFromMat4(S,f),V.transformMat3(o,r,S),e.hasScaling(S)&&V.normalize(o,o),o}function N(r,o,f){return t.fromMat4(S,f),y.transformMat3(o,r,S),e.hasScaling(S)&&V.normalize(o,o,4),o}function w(t,o,f,n){const c=o===r.VectorType.NORMAL;return O(t,o,f,((r,t)=>{const o=Math.cos(e.deg2rad(r));t[0]=c?o:1/o,t[1]=1}),n)}function B(e,t,o,f){const n=t===r.VectorType.NORMAL;return O(e,t,o,((r,e)=>{const t=Math.cosh(-r/l.earth.radius);e[0]=1,e[1]=n?t:1/t}),f)}function O(e,t,o,f,n){const c=t===r.VectorType.NORMAL?3:4,a=[0,0];for(let r=0,i=1;r<e.length;r+=c,i+=3){f(o[i],a);const t=e[r]*a[0],u=e[r+1]*a[1],l=e[r+2],T=1/Math.sqrt(t*t+u*u+l*l);n[r]=t*T,n[r+1]=u*T,n[r+2]=l*T,4===c&&(n[r+3]=e[r+3])}return n}function C(e,t,o,f,n,c){if(!_(R.TO_PCPF,m.BufferViewVec3f.fromTypedArray(e,4*Float32Array.BYTES_PER_ELEMENT),r.VectorType.TANGENT,m.BufferViewVec3f64.fromTypedArray(t),o,m.BufferViewVec3f64.fromTypedArray(f),n,m.BufferViewVec3f.fromTypedArray(c,4*Float32Array.BYTES_PER_ELEMENT)))return null;for(let r=3;r<e.length;r+=4)c[r]=e[r];return c}function E(e,t,o,f,n,c){if(!_(R.FROM_PCPF,m.BufferViewVec3f.fromTypedArray(e,16),r.VectorType.TANGENT,m.BufferViewVec3f64.fromTypedArray(t),o,m.BufferViewVec3f64.fromTypedArray(f),n,m.BufferViewVec3f.fromTypedArray(c,16)))return null;for(let r=3;r<e.length;r+=4)c[r]=e[r];return c}var h,R;function j(e,o,n,c,a){switch(i.computeTranslationToOriginAndRotation(c,n,G,c),e===R.FROM_PCPF&&f.invert(G,G),o){case r.VectorType.NORMAL:return t.normalFromMat4(a,G);case r.VectorType.TANGENT:return t.fromMat4(a,G)}}function _(e,t,o,f,n,a,i,u){if(!t)return;const l=f.count;if(b(n))for(let r=0;r<l;r++)a.getVec(r,L),t.getVec(r,v),c.transformMat3(v,v,j(e,o,L,i,S)),u.setVec(r,v);else for(let T=0;T<l;T++){a.getVec(T,L),t.getVec(T,v);const n=s.y2lat(f.get(T,1));let l=Math.cos(n);o===r.VectorType.TANGENT!=(e===R.TO_PCPF)&&(l=1/l),j(e,o,L,i,S),e===R.TO_PCPF?(S[0]*=l,S[1]*=l,S[2]*=l,S[3]*=l,S[4]*=l,S[5]*=l):(S[0]*=l,S[3]*=l,S[6]*=l,S[1]*=l,S[4]*=l,S[7]*=l),c.transformMat3(v,v,S),c.normalize(v,v),u.setVec(T,v)}return u}function b(r){return r.isWGS84||T.isCGCS2000(r)||T.isMars(r)||T.isMoon(r)}r.VectorType=void 0,(h=r.VectorType||(r.VectorType={}))[h.NORMAL=0]="NORMAL",h[h.TANGENT=1]="TANGENT",function(r){r[r.TO_PCPF=0]="TO_PCPF",r[r.FROM_PCPF=1]="FROM_PCPF"}(R||(R={}));const L=a.create(),v=a.create(),G=n.create(),S=o.create();r.loadProjectErrorMessage=p,r.logProjectionError=P,r.projectFromPCPF=F,r.projectNormalFromPCPF=d,r.projectNormalToPCPF=A,r.projectTangentFromPCPF=E,r.projectTangentToPCPF=C,r.projectToPCPF=M,r.transformNormal=g,r.transformTangent=N,r.transformVectorENUPlateCarree=w,r.transformVectorWMPlateCarree=B,Object.defineProperty(r,Symbol.toStringTag,{value:"Module"})}));
