/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../core/Logger","../../../core/mathUtils","../../../core/unitUtils","../../../core/libs/gl-matrix-2/math/mat3","../../../core/libs/gl-matrix-2/factories/mat3f64","../../../core/libs/gl-matrix-2/math/mat4","../../../core/libs/gl-matrix-2/factories/mat4f64","../../../chunks/vec32","../../../core/libs/gl-matrix-2/factories/vec3f64","../../spatialReferenceEllipsoidUtils","../../projection/computeTranslationToOriginAndRotation","../../projection/projectPointToVector","../meshVertexSpaceUtils","../spatialReferenceUtils","../../../chunks/vec3","./projection"],(function(t,n,r,e,o,i,a,l,c,s,u,f,g,p,m,T,E){"use strict";const A=()=>n.getLogger("esri.geometry.support.meshUtils.vertexSpaceConversion");function R(t,n,{vertexSpace:r,spatialReference:e}){if("georeferenced"===r.type){const o=t;if(!g.projectPointToVector(n,o,e))return!1;const{origin:i}=r;return c.subtract(t,o,i),!0}const o=u.getSphericalPCPF(e),i=t;if(!g.projectPointToVector(n,i,o))return!1;const{origin:l}=r,s=k;if(!f.computeTranslationToOriginAndRotation(e,l,s,o))return!1;const p=a.invert(k,s);return null!=p&&(c.transformMat4(t,i,p),!0)}function P(t,n,r){const{vertexSpace:e,transform:o,vertexAttributes:i}=t,c=p.isRelativeVertexSpace(e)?o:null,s=d(t.spatialReference,r,B.SOURCE_AND_TARGET);if(p.vertexSpaceEquals(e,n)&&(!c||a.exactEquals(c.localMatrix,l.IDENTITY))&&N(s)){const{position:t,normal:n,tangent:e}=i,o=r?.allowBufferReuse;return{position:o?t:t.slice(),normal:o?n:n?.slice(),tangent:o?e:e?.slice()}}switch(t.vertexSpace.type){case"local":return"local"===n.type?j(t,t.vertexSpace,n.origin,r):x(t,t.vertexSpace,n.origin,r);case"georeferenced":return"local"===n.type?F(t,t.vertexSpace,n.origin,r):S(t,t.vertexSpace,n.origin,r)}}function S({vertexAttributes:t,transform:n,spatialReference:r},{origin:e},o,i){const s=d(r,i,B.SOURCE_AND_TARGET),u=e||!N(s)?a.copy(D,n?.localMatrix??l.IDENTITY):null;u&&w(u,r,i,B.SOURCE_AND_TARGET);const{position:f,normal:g,tangent:p}=u?y(t,u):t,m=i?.allowBufferReuse,E=m?f:new Float64Array(f.length);let A=f;if(e&&(A=T.translate(E,A,e)),o){const t=c.negate(q,o);A=T.translate(E,A,t)}return{position:A!==t.position||m?A:A.slice(),normal:g!==t.normal||m?g:g?.slice(),tangent:p!==t.tangent||m?p:p?.slice()}}function v(t,n){return n?.useEllipsoid&&m.isEarth(t)?u.WGS84ECEFSpatialReference:u.getSphericalPCPF(t)}function x({spatialReference:t,vertexAttributes:n,transform:r},{origin:e},o,i){const l=v(t,i);if(!f.computeTranslationToOriginAndRotation(t,e,D,l))return E.logProjectionError(A(),t,l),null;r&&a.multiply(D,D,r.localMatrix),w(D,t,i,B.SOURCE);const s=new Float64Array(n.position.length),u=C(n.position,D,t,s,l);if(!u)return null;const g=U(u,t,s,l,n.normal,D);if(n.normal&&!g)return null;const p=O(u,t,s,l,n.tangent,D);if(n.tangent&&!p)return null;if(o){const t=c.negate(q,o);T.translate(u,u,t)}return{position:u,normal:g,tangent:p}}function F({vertexAttributes:t,spatialReference:n,transform:r},{origin:e},i,l){const c=v(n,l);if(!f.computeTranslationToOriginAndRotation(n,i,D,c))return E.logProjectionError(A(),n,c),null;const s=1/d(n,l,B.TARGET);a.scale(D,D,[s,s,s]);const u=a.invert(V,D),{position:g,normal:p,tangent:m}=h(t,e,r),T=new Float64Array(g.length),R=M(g,n,u,T,c);if(!R)return null;const P=o.normalFromMat4(I,u),S=b(p,g,n,T,c,P,p!==t.normal?p:void 0);if(!S&&p)return null;const x=_(m,g,n,T,c,P,m!==t.tangent?m:void 0);return!x&&m?null:{position:R,normal:S,tangent:x}}function h(t,n,r){if(!n)return t;if(!r){const{position:r,normal:e,tangent:o}=t;return{position:T.translate(new Float64Array(r.length),r,n),tangent:o,normal:e}}const e=y(t,r.localMatrix);return T.translate(e.position,e.position,n),e}function j({vertexAttributes:t,spatialReference:n,transform:r},{origin:e},o,i){const l=v(n,i);if(!f.computeTranslationToOriginAndRotation(n,e,D,l))return E.logProjectionError(A(),n,l),null;if(r&&a.multiply(D,D,r.localMatrix),!f.computeTranslationToOriginAndRotation(n,o,V,l))return E.logProjectionError(A(),l,n),null;a.invert(V,V);const c=a.multiply(D,V,D);return w(c,n,i,B.SOURCE_AND_TARGET),y(t,c)}function y(t,n){const r=new Float64Array(t.position.length);T.transformMat4(r,t.position,n);const e=t.normal?new Float32Array(t.normal.length):null,o=t.tangent?new Float32Array(t.tangent.length):null;return e&&t.normal&&E.transformNormal(t.normal,e,n),o&&t.tangent&&E.transformTangent(t.tangent,o,n),{position:r,normal:e,tangent:o}}function C(t,n,r,e,o){T.transformMat4(e,t,n);const i=new Float64Array(t.length);return E.projectFromPCPF(e,o,i,r)?i:(E.logProjectionError(A(),o,r),null)}function U(t,n,r,e,o,i){if(null==o)return null;const a=new Float32Array(o.length);return E.transformNormal(o,a,i),E.projectNormalFromPCPF(a,t,n,r,e,a)?a:(E.logProjectionError(A(),e,n),null)}function O(t,n,r,e,o,i){if(null==o)return null;const a=new Float32Array(o.length);return E.transformTangent(o,a,i),E.projectTangentFromPCPF(a,t,n,r,e,a)?a:(E.logProjectionError(A(),e,n),null)}function w(t,n,r,e){const o=d(n,r,e);N(o)||a.scale(t,t,[o,o,o])}function d(t,n,r){const e=!!(r&B.SOURCE),o=!!(r&B.TARGET),i=n?.sourceUnit,a=n?.targetUnit;if(!i&&!a)return 1;let l=G(i,t);e||!i||N(l)||(A().warn("source unit conversion not supported"),l=1);let c=1/G(a,t);return o||!a||N(c)||(A().warn("target unit conversion not supported"),c=1),l*c}function N(t){return r.floatEqualUlp(t,1)}function M(t,n,r,e,o){const i=E.projectToPCPF(t,n,e,o);if(!i)return E.logProjectionError(A(),n,o),null;const a=new Float64Array(i.length);return T.transformMat4(a,i,r),a}function b(t,n,r,e,o,i,a){if(null==t)return null;const l=a??new Float32Array(t.length);return E.projectNormalToPCPF(t,n,r,e,o,l)?(T.transformMat3(l,l,i),l):(E.logProjectionError(A(),r,o),null)}function _(t,n,r,e,o,i,a){if(null==t)return null;const l=a??new Float32Array(t.length);return E.projectTangentToPCPF(t,n,r,e,o,l)?(T.transformMat3(l,l,i,4),l):(E.logProjectionError(A(),r,o),null)}function G(t,n){if(null==t)return 1;const r=e.getMetersPerCartesianUnitForSR(n);return 1/e.convertUnit(r,"meters",t)}const D=l.create(),V=l.create(),I=i.create(),q=s.create(),k=l.create();var B;!function(t){t[t.NONE=0]="NONE",t[t.SOURCE=1]="SOURCE",t[t.TARGET=2]="TARGET",t[t.SOURCE_AND_TARGET=3]="SOURCE_AND_TARGET"}(B||(B={})),t.convertVertexSpace=P,t.getUnitToSpatialReferenceScaleConversion=G,t.projectPointToVertexSpace=R,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
