/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../geometry","../request","../core/Error","../core/jsonMap","../core/MultiOriginJSONSupport","../core/accessorSupport/decorators/property","../core/has","../core/Logger","../core/RandomLCG","../core/accessorSupport/decorators/subclass","../geometry/SpatialReference","./BaseTileLayer","./mixins/BlendLayer","./mixins/OperationalLayer","./support/LOD","./support/TileInfo","../geometry/Point"],(function(e,t,r,a,o,n,i,s,l,p,u,d,g,y,c,h,b,m){"use strict";const w=new o.JSONMap({BingMapsAerial:"aerial",BingMapsRoad:"road",BingMapsHybrid:"hybrid"}),v="https://dev.virtualearth.net";let M=class extends(y.BlendLayer(c.OperationalLayer(n.MultiOriginJSONMixin(g)))){constructor(e){super(e),this.type="bing-maps",this.tileInfo=new b({size:[256,256],dpi:96,origin:new m({x:-20037508.342787,y:20037508.342787,spatialReference:d.WebMercator}),spatialReference:d.WebMercator,lods:[new h({level:1,resolution:78271.5169639999,scale:295828763.795777}),new h({level:2,resolution:39135.7584820001,scale:147914381.897889}),new h({level:3,resolution:19567.8792409999,scale:73957190.948944}),new h({level:4,resolution:9783.93962049996,scale:36978595.474472}),new h({level:5,resolution:4891.96981024998,scale:18489297.737236}),new h({level:6,resolution:2445.98490512499,scale:9244648.868618}),new h({level:7,resolution:1222.99245256249,scale:4622324.434309}),new h({level:8,resolution:611.49622628138,scale:2311162.217155}),new h({level:9,resolution:305.748113140558,scale:1155581.108577}),new h({level:10,resolution:152.874056570411,scale:577790.554289}),new h({level:11,resolution:76.4370282850732,scale:288895.277144}),new h({level:12,resolution:38.2185141425366,scale:144447.638572}),new h({level:13,resolution:19.1092570712683,scale:72223.819286}),new h({level:14,resolution:9.55462853563415,scale:36111.909643}),new h({level:15,resolution:4.77731426794937,scale:18055.954822}),new h({level:16,resolution:2.38865713397468,scale:9027.977411}),new h({level:17,resolution:1.19432856685505,scale:4513.988705}),new h({level:18,resolution:.597164283559817,scale:2256.994353}),new h({level:19,resolution:.298582141647617,scale:1128.497176}),new h({level:20,resolution:.1492910708238085,scale:564.248588})]}),this.key=null,this.style="road",this.culture="en-US",this.region=null,this.portalUrl=null,this.hasAttributionData=!0}get bingMetadata(){return this._get("bingMetadata")}set bingMetadata(e){this._set("bingMetadata",e)}get copyright(){return null!=this.bingMetadata?this.bingMetadata.copyright:null}get operationalLayerType(){return w.toJSON(this.style)}get bingLogo(){return null!=this.bingMetadata?this.bingMetadata.brandLogoUri:null}load(e){return this.key?this.addResolvingPromise(this._getMetadata()):this.portalUrl?this.addResolvingPromise(this._getPortalBingKey().then((()=>this._getMetadata()))):this.addResolvingPromise(Promise.reject(new a("bingmapslayer:load","Bing layer must have bing key."))),Promise.resolve(this)}getTileUrl(e,t,r){if(!this.loaded||null==this.bingMetadata)return null;const a=this.bingMetadata.resourceSets[0].resources[0],o=a.imageUrlSubdomains[t%a.imageUrlSubdomains.length],n=this._getQuadKey(e,t,r);return a.imageUrl.replace("{subdomain}",o).replace("{quadkey}",n)}async fetchAttributionData(){return this.load().then((()=>{if(null==this.bingMetadata)return null;return{contributors:this.bingMetadata.resourceSets[0].resources[0].imageryProviders.map((e=>({attribution:e.attribution,coverageAreas:e.coverageAreas.map((e=>({zoomMin:e.zoomMin,zoomMax:e.zoomMax,score:1,bbox:[e.bbox[0],e.bbox[1],e.bbox[2],e.bbox[3]]})))})))}}))}_getMetadata(){const e={road:"roadOnDemand",aerial:"aerial",hybrid:"aerialWithLabelsOnDemand"}[this.style];return r(`${v}/REST/v1/Imagery/Metadata/${e}`,{responseType:"json",query:{include:"ImageryProviders",uriScheme:"https",key:this.key,suppressStatus:!0,output:"json",culture:this.culture,userRegion:this.region}}).then((e=>{const t=e.data;if(200!==t.statusCode)throw new a("bingmapslayer:getmetadata",t.statusDescription);if(this.bingMetadata=t,0===this.bingMetadata.resourceSets.length)throw new a("bingmapslayer:getmetadata","no bing resourcesets");if(0===this.bingMetadata.resourceSets[0].resources.length)throw new a("bingmapslayer:getmetadata","no bing resources")})).catch((e=>{throw new a("bingmapslayer:getmetadata",e.message)}))}_getPortalBingKey(){return r(this.portalUrl??"",{responseType:"json",authMode:"no-prompt",query:{f:"json"}}).then((e=>{if(!e.data.bingKey)throw new a("bingmapslayer:getportalbingkey","The referenced Portal does not contain a valid bing key");this.key=e.data.bingKey})).catch((e=>{throw new a("bingmapslayer:getportalbingkey",e.message)}))}_getQuadKey(e,t,r){let a="";for(let o=e;o>0;o--){let e=0;const n=1<<o-1;r&n&&(e+=1),t&n&&(e+=2),a+=e.toString()}return a}};e.__decorate([i.property({json:{read:!1,write:!1},value:null})],M.prototype,"bingMetadata",null),e.__decorate([i.property({json:{read:!1,write:!1},value:"bing-maps",readOnly:!0})],M.prototype,"type",void 0),e.__decorate([i.property({type:b})],M.prototype,"tileInfo",void 0),e.__decorate([i.property({type:String,readOnly:!0,json:{read:!1,write:!1}})],M.prototype,"copyright",null),e.__decorate([i.property({type:String,json:{write:!1,read:!1}})],M.prototype,"key",void 0),e.__decorate([i.property({type:w.apiValues,nonNullable:!0,json:{read:{source:"layerType",reader:w.read}}})],M.prototype,"style",void 0),e.__decorate([i.property({type:["BingMapsAerial","BingMapsHybrid","BingMapsRoad"]})],M.prototype,"operationalLayerType",null),e.__decorate([i.property({type:String,json:{write:!1,read:!1}})],M.prototype,"culture",void 0),e.__decorate([i.property({type:String,json:{write:!1,read:!1}})],M.prototype,"region",void 0),e.__decorate([i.property({type:String,json:{write:!0,read:!0}})],M.prototype,"portalUrl",void 0),e.__decorate([i.property({type:Boolean,json:{write:!1,read:!1}})],M.prototype,"hasAttributionData",void 0),e.__decorate([i.property({type:String,readOnly:!0})],M.prototype,"bingLogo",null),M=e.__decorate([u.subclass("esri.layers.BingMapsLayer")],M);return M}));
