/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../core/Collection","../core/CollectionFlattener","../core/Error","../core/lang","../core/loadAll","../core/Logger","../core/MultiOriginJSONSupport","../core/promiseUtils","../core/urlUtils","../core/accessorSupport/decorators/property","../core/has","../core/accessorSupport/decorators/reader","../core/accessorSupport/decorators/subclass","../geometry/SpatialReference","./Layer","./buildingSublayers/BuildingComponentSublayer","./buildingSublayers/BuildingGroupSublayer","./mixins/APIKeyMixin","./mixins/ArcGISService","./mixins/CustomParametersMixin","./mixins/OperationalLayer","./mixins/PortalLayer","./mixins/ScaleRangeLayer","./mixins/SceneService","./support/associatedFeatureServiceUtils","./support/BuildingFilter","./support/BuildingSummaryStatistics","./support/commonProperties","../support/elevationInfoUtils"],(function(e,r,t,i,s,o,a,l,n,y,c,p,u,d,h,g,v,S,b,_,m,f,I,w,O,L,E,A,x,T){"use strict";const F=r.ofType(E),P=s.clone(S.sublayersProperty),M=P.json?.origins;M&&(M["web-scene"]={type:[v],write:{enabled:!0,overridePolicy:()=>({enabled:!1})}},M["portal-item"]={type:[v],write:{enabled:!0,overridePolicy:()=>({enabled:!1})}});let B=class extends(O.SceneService(_.ArcGISService(f.OperationalLayer(I.PortalLayer(w.ScaleRangeLayer(l.MultiOriginJSONMixin(m.CustomParametersMixin(b.APIKeyMixin(g))))))))){constructor(e){super(e),this.operationalLayerType="BuildingSceneLayer",this.allSublayers=new t({getCollections:()=>[this.sublayers],getChildrenFunction:e=>"building-group"===e.type?e.sublayers:null}),this.sublayers=null,this._allSublayerOverrides=null,this.filters=new F,this.activeFilterId=null,this.summaryStatistics=null,this.outFields=null,this.legendEnabled=!0,this.type="building-scene"}normalizeCtorArgs(e){return"string"==typeof e?{url:e}:e??{}}destroy(){this.allSublayers.destroy()}readSublayers(e,r,t){const i=S.readSublayers(e,r,t);return S.forEachSublayer(i,(e=>e.layer=this)),this._allSublayerOverrides&&(j(i,this._allSublayerOverrides),this._allSublayerOverrides=null),i}write(e,r){return e=super.write(e,r),!r||"web-scene"!==r.origin&&"portal-item"!==r.origin||(this.sublayers?C(this.sublayers,e,r):this._allSublayerOverrides&&U(this._allSublayerOverrides,e,r)),e}read(e,r){if(super.read(e,r),("web-scene"===r?.origin||"portal-item"===r?.origin)&&Array.isArray(e?.sublayers)){const t=R(e.sublayers,r);this.sublayers?K(this.sublayers,t):(this._allSublayerOverrides??=new Map,this._allSublayerOverrides.set(r.origin,t))}}readSummaryStatistics(e,r){if("string"==typeof r.statisticsHRef){const e=y.join(this.parsedUrl?.path,r.statisticsHRef);return new A({url:e})}return null}set elevationInfo(e){this._set("elevationInfo",e),this._validateElevationInfo()}load(e){const r=null!=e?e.signal:null,t=this.loadFromPortal({supportedTypes:["Scene Service"]},e).catch(n.throwIfAbortError).then((()=>this._fetchService(r))).then((()=>this._fetchAssociatedFeatureService(r)));return this.addResolvingPromise(t),Promise.resolve(this)}loadAll(){return o.loadAll(this,(e=>{S.forEachSublayer(this.sublayers,(r=>{"building-group"!==r.type&&e(r)})),this.summaryStatistics&&e(this.summaryStatistics)}))}async saveAs(e,r){return this._debouncedSaveOperations(O.SaveOperationType.SAVE_AS,{...r,getTypeKeywords:()=>this._getTypeKeywords(),portalItemLayerType:"building-scene"},e)}async save(){const e={getTypeKeywords:()=>this._getTypeKeywords(),portalItemLayerType:"building-scene"};return this._debouncedSaveOperations(O.SaveOperationType.SAVE,e)}validateLayer(e){if(!e.layerType||"Building"!==e.layerType)throw new i("buildingscenelayer:layer-type-not-supported","BuildingSceneLayer does not support this layer type",{layerType:e.layerType})}_getTypeKeywords(){return["Building"]}async _fetchAssociatedFeatureService(e){try{const{portalItem:r}=await L.findAssociatedFeatureService(`${this.url}/layers/${this.layerId}`,{sceneLayerItem:this.portalItem,customParameters:this.customParameters,apiKey:this.apiKey,signal:e});this.associatedFeatureServiceItem=r}catch(r){a.getLogger(this).warn("Associated feature service item could not be loaded",r)}}_validateElevationInfo(){const e=this.elevationInfo,r="Building scene layers";T.logInvalidElevationInfoWarning(a.getLogger(this),T.elevationModeRequiredMessage(r,"absolute-height",e)),T.logInvalidElevationInfoWarning(a.getLogger(this),T.featureExpressionUnsupportedMessage(r,e))}};function j(e,r){r.forEach((r=>K(e,r)))}function K(e,r){const{overrides:t,context:i}=r;S.forEachSublayer(e,(e=>e.read(t.get(e.id),i)))}function R(e,r){const t=new Map;for(const s of e)null!=s&&"object"==typeof s&&"number"==typeof s.id?t.set(s.id,s):r.messages?.push(new i("building-scene-layer:invalid-sublayer-override","Invalid value for sublayer override. Not an object or no id specified.",{value:s}));return{overrides:t,context:r}}function C(e,r,t){const i=[];S.forEachSublayer(e,(e=>{const r=e.write({},t);Object.keys(r).length>1&&i.push(r)})),i.length>0&&(r.sublayers=i)}function U(e,r,t){const i=t?.origin&&e.get(t.origin);i&&(r.sublayers=[],i.overrides.forEach((e=>{r.sublayers.push(s.clone(e))})))}e.__decorate([c.property({type:["BuildingSceneLayer"]})],B.prototype,"operationalLayerType",void 0),e.__decorate([c.property({readOnly:!0})],B.prototype,"allSublayers",void 0),e.__decorate([c.property(P)],B.prototype,"sublayers",void 0),e.__decorate([u.reader("service","sublayers")],B.prototype,"readSublayers",null),e.__decorate([c.property({type:F,nonNullable:!0,json:{write:!0}})],B.prototype,"filters",void 0),e.__decorate([c.property({type:String,json:{write:!0}})],B.prototype,"activeFilterId",void 0),e.__decorate([c.property({readOnly:!0,type:A})],B.prototype,"summaryStatistics",void 0),e.__decorate([u.reader("summaryStatistics",["statisticsHRef"])],B.prototype,"readSummaryStatistics",null),e.__decorate([c.property({type:[String],json:{read:!1}})],B.prototype,"outFields",void 0),e.__decorate([c.property(x.sceneLayerFullExtent)],B.prototype,"fullExtent",void 0),e.__decorate([c.property(x.legendEnabled)],B.prototype,"legendEnabled",void 0),e.__decorate([c.property({type:["show","hide","hide-children"]})],B.prototype,"listMode",void 0),e.__decorate([c.property(x.readOnlyService(h))],B.prototype,"spatialReference",void 0),e.__decorate([c.property(x.elevationInfo)],B.prototype,"elevationInfo",null),e.__decorate([c.property({json:{read:!1},readOnly:!0})],B.prototype,"type",void 0),e.__decorate([c.property()],B.prototype,"associatedFeatureServiceItem",void 0),B=e.__decorate([d.subclass("esri.layers.BuildingSceneLayer")],B);return B}));
