/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../request","../core/Collection","../core/Error","../core/MapUtils","../core/MultiOriginJSONSupport","../core/promiseUtils","../core/urlUtils","../core/accessorSupport/decorators/property","../core/has","../core/Logger","../core/RandomLCG","../core/accessorSupport/decorators/subclass","./Layer","./catalog/CatalogDynamicGroupLayer","./catalog/CatalogFootprintLayer","./graphics/sources/FeatureLayerSource","./mixins/APIKeyMixin","./mixins/ArcGISService","./mixins/BlendLayer","./mixins/CustomParametersMixin","./mixins/EditBusLayer","./mixins/FeatureLayerBase","./mixins/OperationalLayer","./mixins/OrderedLayer","./mixins/PortalLayer","./mixins/RefreshableLayer","./mixins/ScaleRangeLayer","./mixins/TemporalLayer","./support/commonProperties","./support/featureLayerUtils","./support/FeatureType","./support/fieldProperties","./support/lazyLayerLoader","./support/versionUtils","../portal/Portal","../portal/PortalItem","../portal/support/urlUtils","../rest/support/Query"],(function(e,t,r,i,o,a,s,n,l,p,d,y,c,u,h,m,f,g,_,F,L,S,w,v,I,O,x,b,E,P,T,C,j,G,A,M,U,q,D){"use strict";const R=j.defineFieldProperties();function B(e){return"object"==typeof e&&null!=e&&"itemId"in e&&"portalUrl"in e}function N(e){return"object"==typeof e&&null!=e&&"url"in e}function Q(e){if(null==e)return!0;const t=Object.keys(e);return!t.length||1===t.length&&"id"===t[0]}function V(e,t,r,i){const o=e.write({},i);Q(o)||(t[r]=o)}let k=class extends(w.FeatureLayerBase(S.EditBusLayer(F.BlendLayer(I.OrderedLayer(E.TemporalLayer(b.ScaleRangeLayer(x.RefreshableLayer(_.ArcGISService(v.OperationalLayer(O.PortalLayer(a.MultiOriginJSONMixin(L.CustomParametersMixin(g.APIKeyMixin(u)))))))))))))){constructor(e){super(e),this.legendEnabled=!0,this._portals=new Map,this._layerToFootprint=new WeakMap,this.drawOrderField="cd_draworder",this.dynamicGroupLayer=new h({parent:this}),this.elevationInfo=null,this.fields=null,this.fieldsIndex=null,this.floorInfo=null,this.footprintLayer=new m({parent:this}),this.itemNameField="cd_itemname",this.itemSourceField="cd_itemsource",this.itemTypeField="cd_itemtype",this.layers=new r([this.dynamicGroupLayer,this.footprintLayer]),this.maxScaleField="cd_maxscale",this.minScaleField="cd_minscale",this.orderBy=null,this.outFields=null,this.supportedSourceTypes=new Set(["Catalog Layer"]),this.source=new f({layer:this,supportedSourceTypes:this.supportedSourceTypes}),this.type="catalog",this.typeIdField=null,this.types=null}load(e){const t=null!=e?e.signal:null,r=this.loadFromPortal({supportedTypes:["Feature Service"]},e).catch(s.throwIfAbortError).then((async()=>{const{url:e,source:r,portalItem:o}=this;if(!e)throw new i("catalog-layer:missing-url","Catalog layer must be created with a url");if(null==this.layerId){const r=await this._fetchFirstValidLayerId(t);if(null==r)throw new i("catalog-layer:missing-layerId","There is no Catalog Layer in the service",{service:e});this.layerId=r}await r.load({signal:t});const{sourceJSON:a}=r;a&&(this.sourceJSON=a,this.read(a,{origin:"service",portalItem:o,portal:o?.portal,url:this.parsedUrl}))})).then((()=>{const e=[this.itemNameField,this.itemSourceField,this.itemTypeField,this.minScaleField,this.maxScaleField],t=e.filter((e=>!this.fieldsIndex.has(e)));if(t.length)throw new i("catalog-layer:missing-fields","There are missing fields to operate properly",{requiredFields:e,missingFields:t})})).then((()=>T.ensureLayerCredential(this,"load",e)));return this.addResolvingPromise(r),Promise.resolve(this)}destroy(){this.footprintLayer.destroy(),this.dynamicGroupLayer.destroy();for(const e of this._portals.values())e.destroy();this._portals.clear()}get createQueryVersion(){return this.commitProperty("definitionExpression"),this.commitProperty("timeExtent"),this.commitProperty("timeOffset"),this.commitProperty("geometryType"),this.commitProperty("capabilities"),(this._get("createQueryVersion")??0)+1}get editingEnabled(){return this.loaded&&null!=this.capabilities&&this.capabilities.operations.supportsEditing&&this.userHasEditingPrivileges}get effectiveEditingEnabled(){return!1}get parsedUrl(){const e=n.urlToObject(this.url);return null!=e&&null!=this.layerId&&(e.path=n.join(e.path,this.layerId.toString())),e}async applyEdits(e,t){return T.applyEdits(this,e,t)}on(e,t){return super.on(e,t)}async createLayerFromFootprint(e){const t=await this._createLayer(e);return this._configureLayer(t,e),this._layerToFootprint.set(t,e),t}createFootprintFromLayer(e){return this._layerToFootprint.get(e)?.clone()}createQuery(){const e=new D,t=this.capabilities?.query;e.returnGeometry=!0,t&&(e.compactGeometryEnabled=t.supportsCompactGeometry,e.defaultSpatialReferenceEnabled=t.supportsDefaultSpatialReference),e.outFields=["*"];const{timeOffset:r,timeExtent:i}=this;return e.timeExtent=null!=r&&null!=i?i.offset(-r.value,r.unit):i||null,e.where=this.definitionExpression||"1=1",e}getFeatureType(e){return T.getFeatureType(this.types,this.typeIdField,e)}getField(e){return this.fieldsIndex.get(e)}getFieldDomain(e,t){const r=t?.feature,i=this.getFeatureType(r);if(i){const t=i.domains&&i.domains[e];if(t&&"inherited"!==t.type)return t}return this.getField(e)?.domain}async hasDataChanged(){return T.hasDataChanged(this)}async queryFeatures(e,t){const r=await this.load(),i=await r.source.queryFeatures(D.from(e)??r.createQuery(),t);if(i?.features)for(const o of i.features)o.layer=o.sourceLayer=r.footprintLayer;return i}async queryObjectIds(e,t){return(await this.load()).source.queryObjectIds(D.from(e)??this.createQuery(),t)}async queryFeatureCount(e,t){return(await this.load()).source.queryFeatureCount(D.from(e)??this.createQuery(),t)}async queryExtent(e,t){return(await this.load()).source.queryExtent(D.from(e)??this.createQuery(),t)}serviceSupportsSpatialReference(e){return this.loaded&&A.serviceSupportsSpatialReference(this,e)}read(e,t){if(super.read(e,t),e){const{footprintLayer:r,dynamicGroupLayer:i}=e;r&&this.footprintLayer.read(r,t),i&&this.dynamicGroupLayer.read(i,t)}}async _fetchFirstValidLayerId(e){const{data:r}=await t(this.url,{query:{f:"json",...this.customParameters,token:this.apiKey},responseType:"json",signal:e});if(Array.isArray(r?.layers))return r.layers.find((({type:e})=>this.supportedSourceTypes.has(e)))?.id}async _createLayer(e){const t=e.getAttribute(this.itemSourceField);if(!t)throw new i("catalog-layer:item-source-missing",`The footprint is missing the "${this.itemSourceField}" attribute`);const r=JSON.parse(t);if(B(r)){const{itemId:e,portalUrl:t}=r,i=q.normalizeArcGISOnlineOrgDomain(t),a=this.portalItem?.portal,s=M.getDefault();let l,p=!0;a&&n.hasSamePortal(t,a.url)?l=a:n.hasSamePortal(t,s.url)?l=s:(l=o.getOrCreateMapValue(this._portals,i,(()=>new M({url:i}))),p=!1);const d=await u.fromPortalItem(new U({id:e,portal:l}));return p||await J(d),d}if(N(r))return u.fromArcGISServerUrl({url:r.url});return new(await G.layerLookupMap.UnsupportedLayer())}_configureLayer(e,t){const r=t.getAttribute(this.itemNameField);r&&(e.title=r);const i=t.getAttribute(this.maxScaleField);null!=i&&"maxScale"in e&&(e.maxScale=i);const o=t.getAttribute(this.minScaleField);null!=o&&"minScale"in e&&(e.minScale=o)}};async function J(e){if("portalItem"in e&&e.portalItem){try{await e.load()}catch{}e.portalItem=null,"group"===e.type&&await Promise.allSettled([...e.layers.map((e=>J(e))),...e.tables.map((e=>J(e)))])}}e.__decorate([l.property(P.legendEnabled)],k.prototype,"legendEnabled",void 0),e.__decorate([l.property({readOnly:!0})],k.prototype,"createQueryVersion",null),e.__decorate([l.property({readOnly:!0})],k.prototype,"drawOrderField",void 0),e.__decorate([l.property({type:h,readOnly:!0,json:{read:!1,write:{ignoreOrigin:!0,writer:V}}})],k.prototype,"dynamicGroupLayer",void 0),e.__decorate([l.property({readOnly:!0})],k.prototype,"editingEnabled",null),e.__decorate([l.property({readOnly:!0})],k.prototype,"effectiveEditingEnabled",null),e.__decorate([l.property({json:{origins:{"web-scene":{name:"layerDefinition.elevationInfo",read:!1,write:!1}}}})],k.prototype,"elevationInfo",void 0),e.__decorate([l.property({...R.fields,readOnly:!0,json:{origins:{service:{read:!0}},read:!1}})],k.prototype,"fields",void 0),e.__decorate([l.property(R.fieldsIndex)],k.prototype,"fieldsIndex",void 0),e.__decorate([l.property({json:{origins:{"web-scene":{name:"layerDefinition.floorInfo",read:!1,write:!1}}}})],k.prototype,"floorInfo",void 0),e.__decorate([l.property({type:m,readOnly:!0,json:{read:!1,write:{ignoreOrigin:!0,writer:V}}})],k.prototype,"footprintLayer",void 0),e.__decorate([l.property(P.id)],k.prototype,"id",void 0),e.__decorate([l.property({readOnly:!0})],k.prototype,"itemNameField",void 0),e.__decorate([l.property({readOnly:!0})],k.prototype,"itemSourceField",void 0),e.__decorate([l.property({readOnly:!0})],k.prototype,"itemTypeField",void 0),e.__decorate([l.property({readOnly:!0})],k.prototype,"layers",void 0),e.__decorate([l.property({type:["show","hide","hide-children"]})],k.prototype,"listMode",void 0),e.__decorate([l.property({readOnly:!0})],k.prototype,"maxScaleField",void 0),e.__decorate([l.property({readOnly:!0})],k.prototype,"minScaleField",void 0),e.__decorate([l.property({value:"CatalogLayer",type:["CatalogLayer"]})],k.prototype,"operationalLayerType",void 0),e.__decorate([l.property({json:{origins:{"web-scene":{name:"layerDefinition.orderBy",write:!0,read:!0}}}})],k.prototype,"orderBy",void 0),e.__decorate([l.property(R.outFields)],k.prototype,"outFields",void 0),e.__decorate([l.property({readOnly:!0})],k.prototype,"parsedUrl",null),e.__decorate([l.property({readOnly:!0})],k.prototype,"source",void 0),e.__decorate([l.property({json:{read:!1}})],k.prototype,"type",void 0),e.__decorate([l.property({type:String})],k.prototype,"typeIdField",void 0),e.__decorate([l.property({type:[C]})],k.prototype,"types",void 0),k=e.__decorate([c.subclass("esri.layers.CatalogLayer")],k);return k}));
