/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../PopupTemplate","../renderers/ClassBreaksRenderer","../renderers/DictionaryRenderer","../renderers/DotDensityRenderer","../renderers/HeatmapRenderer","../renderers/PieChartRenderer","../renderers/Renderer","../renderers/SimpleRenderer","../renderers/UniqueValueRenderer","../renderers/support/jsonUtils","../renderers/support/types","../request","../symbols","../core/Clonable","../core/Collection","../core/Error","../core/lang","../core/Logger","../core/MultiOriginJSONSupport","../core/object","../core/promiseUtils","../core/sql","../core/urlUtils","../core/Warning","../core/accessorSupport/decorators/property","../core/accessorSupport/decorators/cast","../core/accessorSupport/decorators/reader","../core/accessorSupport/decorators/subclass","../core/accessorSupport/decorators/writer","../core/accessorSupport/layerContainerType","../form/FormTemplate","../geometry/SpatialReference","./Layer","./graphics/sources/MemorySource","./mixins/APIKeyMixin","./mixins/ArcGISService","./mixins/BlendLayer","./mixins/CustomParametersMixin","./mixins/EditBusLayer","./mixins/FeatureEffectLayer","./mixins/FeatureLayerBase","./mixins/FeatureReductionLayer","./mixins/OperationalLayer","./mixins/OrderedLayer","./mixins/PortalLayer","./mixins/PublishableLayer","./mixins/RefreshableLayer","./mixins/ScaleRangeLayer","./mixins/TemporalLayer","./support/arcgisLayerUrl","./support/commonProperties","./support/featureLayerUtils","./support/FeatureTemplate","./support/FeatureType","./support/fieldProperties","./support/fieldUtils","./support/LabelClass","./support/labelingInfo","./support/serviceCapabilitiesUtils","./support/TimeInfo","./support/versionUtils","./support/source/DataLayerSource","../renderers/support/styleUtils","../rest/support/FeatureSet","../rest/support/Query","../support/popupUtils","../views/3d/webgl-engine/core/shaderLibrary/util/AlphaCutoff","../webdoc/interfaces","../webdoc/support/opacityUtils"],(function(e,r,t,i,o,a,s,n,l,p,d,u,y,c,h,m,f,b,g,_,w,v,S,F,T,I,E,D,L,x,P,j,O,q,C,M,R,A,V,Q,U,B,N,G,J,$,W,z,K,Z,H,k,X,Y,ee,re,te,ie,oe,ae,se,ne,le,pe,de,ue,ye,ce,he,me,fe){"use strict";const be=e=>Object.freeze(Object.defineProperty({__proto__:null,default:e},Symbol.toStringTag,{value:"Module"})),ge="FeatureLayer";function _e(e,r){return new b("layer:unsupported",`Layer (${e.title}, ${e.id}) of type '${e.declaredClass}' ${r}`,{layer:e})}function we(e){return e&&e instanceof f}const ve=te.defineFieldProperties();function Se(e,r,t){const i=!!t?.writeLayerSchema;return{enabled:i,ignoreOrigin:i}}let Fe=class extends(N.FeatureLayerBase(G.FeatureReductionLayer(B.FeatureEffectLayer(z.PublishableLayer(U.EditBusLayer(V.BlendLayer($.OrderedLayer(H.TemporalLayer(Z.ScaleRangeLayer(K.RefreshableLayer(A.ArcGISService(J.OperationalLayer(W.PortalLayer(w.MultiOriginJSONMixin(Q.CustomParametersMixin(R.APIKeyMixin(m.ClonableMixin(C)))))))))))))))))){constructor(...r){super(...r),this.attributeTableTemplate=null,this.charts=null,this.copyright=null,this.displayField=null,this.dynamicDataSource=null,this.fields=null,this.fieldsIndex=null,this.formTemplate=null,this.fullExtent=null,this.geometryType=null,this.hasM=void 0,this.hasZ=void 0,this.infoFor3D=null,this.isTable=!1,this.labelsVisible=!0,this.labelingInfo=null,this.legendEnabled=!0,this.objectIdField=null,this.outFields=null,this.path=null,this.popupEnabled=!0,this.popupTemplate=null,this.resourceInfo=null,this.screenSizePerspectiveEnabled=!0,this.spatialReference=q.WGS84,this.subtypeCode=null,this.supportedSourceTypes=new Set(["Feature Layer","Oriented Imagery Layer","Table","Catalog Layer"]),this.templates=null,this.timeInfo=null,this.title=null,this.sublayerTitleMode="item-title",this.type="feature",this.typeIdField=null,this.types=null,this.visible=!0,this._debouncedSaveOperations=S.debounce((async(r,t,i)=>{const{save:o,saveAs:a}=await new Promise(((r,t)=>e(["./save/featureLayerUtils"],r,t)));switch(r){case me.SaveOperationType.SAVE:return o(this,t);case me.SaveOperationType.SAVE_AS:return a(this,i,t)}}))}destroy(){this.source?.destroy()}normalizeCtorArgs(e,r){return"string"==typeof e?{url:e,...r}:e}load(e){const r=null!=e?e.signal:null;if(this.portalItem?.loaded&&this.source)return this.addResolvingPromise(this.createGraphicsSource(r).then((e=>this.initLayerProperties(e)))),Promise.resolve(this);const t=this.loadFromPortal({supportedTypes:["Feature Service","Feature Collection","Scene Service"]},e).catch(S.throwIfAbortError).then((async()=>{if(this.url&&null==this.layerId&&/FeatureServer|MapServer\/*$/i.test(this.url)){const e=await this._fetchFirstValidLayerId(r);null!=e&&(this.layerId=e)}if(!this.url&&!this._hasMemorySource())throw new b("feature-layer:missing-url-or-source","Feature layer must be created with either a url or a source");return this.initLayerProperties(await this.createGraphicsSource(r))})).then((()=>Y.ensureLayerCredential(this,"load",e)));return this.addResolvingPromise(t),Promise.resolve(this)}warnInvisibleDrapedSymbols(){"on-the-ground"===this.elevationInfo?.mode&&"simple"===this.renderer?.type&&"polygon-3d"===this.renderer.symbol?.type&&this.renderer.symbol.symbolLayers.some((e=>"fill"===e.type&&null!=e.material&&((!e.material.color||e.material.color.a*this.opacity<he.alphaCutoff)&&(this.loadWarnings.push(new I("feature-layer:invisible-draped-symbols","FeatureLayer has fully transparent symbols which will no longer render or highlight",{layer:this})),!0))))}readCapabilities(e,r){return r=r.layerDefinition||r,se.getFeatureLayerCapabilities(r,this.url)}get createQueryVersion(){return this.commitProperty("definitionExpression"),this.commitProperty("dynamicDataSource"),this.commitProperty("timeExtent"),this.commitProperty("timeOffset"),this.commitProperty("geometryType"),this.commitProperty("gdbVersion"),this.commitProperty("historicMoment"),this.commitProperty("returnZ"),this.commitProperty("capabilities"),this.commitProperty("returnM"),(this._get("createQueryVersion")??0)+1}get editingEnabled(){return!(this.loaded&&!this.capabilities?.operations.supportsEditing)&&(this._isOverridden("editingEnabled")?this._get("editingEnabled"):this._hasMemorySource()||this.userHasEditingPrivileges)}set editingEnabled(e){this._overrideIfSome("editingEnabled",e)}readEditingEnabled(e,r){return this._readEditingEnabled(r,!1)}readEditingEnabledFromWebMap(e,r,t){return this._readEditingEnabled(r,!0,t)}writeEditingEnabled(e,r){this._writeEditingEnabled(e,r,!1)}writeEditingEnabledToWebMap(e,r,t,i){this._writeEditingEnabled(e,r,!0,i)}get effectiveEditingEnabled(){return Y.computeEffectiveEditingEnabled(this)}readIsTable(e,r){return"Table"===(r=r?.layerDefinition??r).type||!r.geometryType}writeIsTable(e,r,t,i){i?.writeLayerSchema&&v.setDeepValue(t,e?"Table":"Feature Layer",r)}readGlobalIdField(e,r){return Y.readGlobalIdField(r.layerDefinition||r)}readObjectIdField(e,r){return Y.readObjectIdField(r.layerDefinition||r)}get parsedUrl(){const e=T.urlToObject(this.url);return null!=e&&(null!=this.dynamicDataSource?e.path=T.join(e.path,"dynamicLayer"):null!=this.layerId&&(e.path=T.join(e.path,this.layerId.toString()))),e}get defaultPopupTemplate(){return this.createPopupTemplate()}set renderer(e){ie.fixRendererFields(e,this.fieldsIndex),this._set("renderer",e)}readRenderer(e,r,t){r=r.layerDefinition||r;const i=r.drawingInfo?.renderer;if(i){const e=u.read(i,r,t)??void 0;return e||_.getLogger(this).error("Failed to create renderer",{rendererDefinition:r.drawingInfo.renderer,layer:this,context:t}),e}return Y.createDefaultRenderer(r,t)}set source(e){const r=this._get("source");r!==e&&(we(r)&&this._resetMemorySource(r),we(e)&&this._initMemorySource(e),this._set("source",e))}castSource(e){return e?Array.isArray(e)||e instanceof f?new M.MemorySource({layer:this,items:e}):e:null}readSource(e,r){const t=ue.fromJSON(r.featureSet);return new M.MemorySource({layer:this,items:t?.features??[]})}readTemplates(e,r){const t=r.editFieldsInfo,i=t?.creatorField,o=t?.editorField;return e=e?.map((e=>ee.fromJSON(e))),this._fixTemplates(e,i),this._fixTemplates(e,o),e}readTitle(e,r){const t=r.layerDefinition?.name??r.name,i=r.title||r.layerDefinition?.title;if(t){const e=this.portalItem?.title;if("item-title"===this.sublayerTitleMode)return this.url?k.titleFromUrlAndName(this.url,t):t;let r=t;if(!r&&this.url){const e=k.parse(this.url);null!=e&&(r=e.title)}if(!r)return;return"item-title-and-service-name"===this.sublayerTitleMode&&e&&e!==r&&(r=e+" - "+r),k.cleanTitle(r)}if("item-title"===this.sublayerTitleMode&&i)return i}readTitleFromWebMap(e,r){return r.title||r.layerDefinition?.name}readTypeIdField(e,r){let t=(r=r.layerDefinition||r).typeIdField;if(t&&r.fields){t=t.toLowerCase();const e=r.fields.find((e=>e.name.toLowerCase()===t));e&&(t=e.name)}return t}readTypes(e,r){e=(r=r.layerDefinition||r).types;const t=r.editFieldsInfo,i=t?.creatorField,o=t?.editorField;return e?.map((e=>(e=re.fromJSON(e),this._fixTemplates(e.templates,i),this._fixTemplates(e.templates,o),e)))}readVisible(e,r){return null!=r.layerDefinition?.defaultVisibility?!!r.layerDefinition.defaultVisibility:null!=r.visibility?!!r.visibility:void 0}async addAttachment(e,r){const t=await Y.addAttachment(this,e,r,ge);return this.lastEditsEventDate=new Date,t}async updateAttachment(e,r,t){const i=await Y.updateAttachment(this,e,r,t,ge);return this.lastEditsEventDate=new Date,i}async applyEdits(e,r){return Y.applyEdits(this,e,r)}async uploadAssets(e,r){return Y.uploadAssets(this,e,r)}on(e,r){return super.on(e,r)}createPopupTemplate(e){return ce.createPopupTemplate(this,e)}async createGraphicsSource(r){if(this._hasMemorySource()&&this.source)return this.source.load({signal:r});const{default:t}=await S.whenOrAbort(new Promise(((r,t)=>e(["./graphics/sources/FeatureLayerSource"],(e=>r(be(e))),t))),r);return new t({layer:this,supportedSourceTypes:this.supportedSourceTypes}).load({signal:r})}createQuery(){const e=Y.createQuery(this);e.dynamicDataSource=this.dynamicDataSource;const r=null!=this.subtypeCode?`${this.subtypeField} = ${this.subtypeCode}`:null,t=F.sqlAnd(this.definitionExpression,r);return e.where=t||"1=1",e}async deleteAttachments(e,r){const t=await Y.deleteAttachments(this,e,r,ge);return this.lastEditsEventDate=new Date,t}async fetchRecomputedExtents(e){return Y.fetchRecomputedExtents(this,e,ge)}getFeatureType(e){return Y.getFeatureType(this.types,this.typeIdField,e)}getFieldDomain(e,r){const t=r?.feature,i=!!this.subtypes?.length;if(i&&!r?.excludeImpliedDomains){const r=Y.computeDomainFromSubtypes(this,e);if(r)return r}const o=i&&Y.getFeatureSubtype(this,t);if(o){const r=o?.domains?.[e];return"inherited"===r?.type?this._getLayerDomain(e):r}const a=this.getFeatureType(t),s=this._getLayerDomain(e);if(a){const r=a.domains&&a.domains[e];if(r&&"inherited"!==r?.type)return r}if(s)return s;if(!r?.excludeImpliedDomains){const r=Y.computeDomainFromTypes(this,e);if(r)return r}return null}getField(e){return this.fieldsIndex.get(e)}async queryAttachments(e,r){return Y.queryAttachments(this,e,r,ge)}async queryFeatures(e,r){const t=await this.load(),i=await t.source.queryFeatures(ye.from(e)??t.createQuery(),r);if(i?.features)for(const o of i.features)o.layer=o.sourceLayer=t;return i}async queryObjectIds(e,r){return Y.queryObjectIds(this,e,r,ge)}async queryFeatureCount(e,r){return Y.queryFeatureCount(this,e,r,ge)}async queryExtent(e,r){return Y.queryExtent(this,e,r,ge)}async queryRelatedFeatures(e,r){return Y.queryRelatedFeatures(this,e,r,ge)}async queryRelatedFeaturesCount(e,r){return Y.queryRelatedFeaturesCount(this,e,r,ge)}async queryTopFeatures(r,t){const{source:i,capabilities:o}=await this.load();if(!i.queryTopFeatures||!o?.query?.supportsTopFeaturesQuery)throw new b(ge,"Layer source does not support queryTopFeatures capability");const a=await new Promise(((r,t)=>e(["../rest/support/TopFeaturesQuery"],(e=>r(be(e))),t))),s=await i.queryTopFeatures(a.default.from(r),t);if(s?.features)for(const e of s.features)e.layer=e.sourceLayer=this;return s}async queryBins(r,t){const{source:i,capabilities:o}=await this.load();if(!i.queryBins||!o?.operations?.supportsQueryBins)throw new b(ge,"Layer source does not support queryBins capability");Y.validateBinsQuery(r,o,ge);const a=await new Promise(((r,t)=>e(["../rest/support/BinsQuery"],(e=>r(be(e))),t))),s=await i.queryBins(a.default.from(r),t);if(s.features)for(const e of s.features)e.layer=e.sourceLayer=this;return s}async queryTopObjectIds(r,t){const{source:i,capabilities:o}=await this.load();if(!i.queryTopObjectIds||!o?.query.supportsTopFeaturesQuery)throw new b(ge,"Layer source does not support queryTopObjectIds capability");const a=await new Promise(((r,t)=>e(["../rest/support/TopFeaturesQuery"],(e=>r(be(e))),t)));return i.queryTopObjectIds(a.default.from(r),t)}async queryTopFeaturesExtent(r,t){const{source:i,capabilities:o}=await this.load();if(!i.queryTopExtents||!o?.query?.supportsTopFeaturesQuery)throw new b(ge,"Layer source does not support queryTopExtents capability");const a=await new Promise(((r,t)=>e(["../rest/support/TopFeaturesQuery"],(e=>r(be(e))),t)));return i.queryTopExtents(a.default.from(r),t)}async queryTopFeatureCount(r,t){const{source:i,capabilities:o}=await this.load();if(!i.queryTopCount||!o?.query?.supportsTopFeaturesQuery)throw new b(ge,"Layer source does not support queryFeatureCount capability");const a=await new Promise(((r,t)=>e(["../rest/support/TopFeaturesQuery"],(e=>r(be(e))),t)));return i.queryTopCount(a.default.from(r),t)}read(e,r){const t=e.featureCollection;if((t||"Feature Collection"===e.type)&&(this.resourceInfo=e),t){const e=t.layers;e&&1===e.length&&(super.read(e[0],r),null!=t.showLegend&&super.read({showLegend:t.showLegend},r))}super.read(e,r),r&&"service"===r.origin&&(this.revert(["objectIdField","fields","timeInfo","dateFieldsTimeZone"],"service"),this.spatialReference||this.revert(["spatialReference"],"service"))}write(e,r){r={...r,origin:r?.origin??void 0,writeLayerSchema:r?.writeLayerSchema??this._hasMemorySource()};const{origin:t,layerContainerType:i,messages:o}=r;if(this.dynamicDataSource)return o?.push(_e(this,"using a dynamic data source cannot be written to web scenes, web maps and feature service items")),null;if(this.isTable){if(("web-map"===t||"web-scene"===t)&&"tables"!==i)return o?.push(_e(this,`a table source can only be written to tables, not ${i}`)),null;if(this._hasMemorySource())return o?.push(_e(this,"using an in-memory table source cannot be written to web scenes and web maps")),null}else if(this.loaded&&("web-map"===t||"web-scene"===t)&&"tables"===i)return o?.push(_e(this,"using a non-table source cannot be written to tables in web maps or web scenes")),null;return super.write(e,r)}clone(){if(this._hasMemorySource())throw new b(ge,`FeatureLayer (title: ${this.title}, id: ${this.id}) created using in-memory source cannot be cloned`);return super.clone()}serviceSupportsSpatialReference(e){return!!this.loaded&&("memory"===this.source?.type||le.serviceSupportsSpatialReference(this,e))}async save(e){return this._debouncedSaveOperations(me.SaveOperationType.SAVE,e)}async saveAs(e,r){return this._debouncedSaveOperations(me.SaveOperationType.SAVE_AS,r,e)}_readEditingEnabled(e,r,t){let i=e.layerDefinition?.capabilities;return i?this._hasEditingCapability(i):(i=e.capabilities,r&&"web-map"===t?.origin&&!this._hasMemorySource()&&i?this._hasEditingCapability(i):void 0)}_hasEditingCapability(e){return e.toLowerCase().split(",").map((e=>e.trim())).includes("editing")}_writeEditingEnabled(e,r,t,i){if(!e){const e=this.capabilities?.operations?.supportsSync?"Query,Sync":"Query";v.setDeepValue("layerDefinition.capabilities",e,r),t&&!i?.writeLayerSchema&&(r.capabilities=e)}}_getLayerDomain(e){const r=this.fieldsIndex.get(e);return r?r.domain:null}_fetchFirstValidLayerId(e){return c(this.url??"",{query:{f:"json",...this.customParameters,token:this.apiKey},responseType:"json",signal:e}).then((e=>{const r=e.data;if(r)return this.findFirstValidLayerId(r)}))}async initLayerProperties(e){return this._set("source",e),e.sourceJSON&&(this.sourceJSON=e.sourceJSON,this.read(e.sourceJSON,{origin:"service",portalItem:this.portalItem,portal:this.portalItem?.portal,url:this.parsedUrl})),this._verifySource(),this._verifyFields(),ie.fixRendererFields(this.renderer,this.fieldsIndex),ie.fixTimeInfoFields(this.timeInfo,this.fieldsIndex),de.loadStyleRenderer(this,{origin:"service"})}async hasDataChanged(){return Y.hasDataChanged(this)}async fetchPublishingStatus(){const e=this.source;return e?.fetchPublishingStatus?e.fetchPublishingStatus():"unavailable"}_verifyFields(){const e=this.parsedUrl?.path??"undefined";this.objectIdField||console.log("FeatureLayer: 'objectIdField' property is not defined (url: "+e+")"),this.isTable||this._hasMemorySource()||-1!==e.search(/\/FeatureServer\//i)||this.fields?.some((e=>"geometry"===e.type))||console.log("FeatureLayer: unable to find field of type 'geometry' in the layer 'fields' list. If you are using a map service layer, features will not have geometry (url: "+e+")")}_fixTemplates(e,r){e&&e.forEach((e=>{const t=e.prototype?.attributes;t&&r&&delete t[r]}))}_verifySource(){if(this._hasMemorySource()){if(this.url)throw new b("feature-layer:mixed-source-and-url","FeatureLayer cannot be created with both an in-memory source and a url")}else if(!this.url)throw new b("feature-layer:source-or-url-required","FeatureLayer requires either a url, a valid portal item or a source")}_initMemorySource(e){e.forEach((e=>{e.layer=this,e.sourceLayer=this})),this.addHandles([e.on("after-add",(e=>{e.item.layer=this,e.item.sourceLayer=this})),e.on("after-remove",(e=>{e.item.layer=null,e.item.sourceLayer=null}))],"fl-source")}_resetMemorySource(e){e.forEach((e=>{e.layer=null,e.sourceLayer=null})),this.removeHandles("fl-source")}_hasMemorySource(){return!(this.url||!this.source)}findFirstValidLayerId(e){return Array.isArray(e.layers)&&e.layers.length>0?e.layers[0].id:Array.isArray(e.tables)&&e.tables.length>0?e.tables[0].id:void 0}};r.__decorate([E.property(X.attributeTableTemplate)],Fe.prototype,"attributeTableTemplate",void 0),r.__decorate([L.reader("service","capabilities")],Fe.prototype,"readCapabilities",null),r.__decorate([E.property({json:{origins:{"web-scene":{write:!1}},write:!0}})],Fe.prototype,"charts",void 0),r.__decorate([E.property({readOnly:!0})],Fe.prototype,"createQueryVersion",null),r.__decorate([E.property({json:{read:{source:"layerDefinition.copyrightText"}}})],Fe.prototype,"copyright",void 0),r.__decorate([E.property({json:{read:{source:"layerDefinition.displayField"}}})],Fe.prototype,"displayField",void 0),r.__decorate([E.property({types:h.symbolTypes,readOnly:!0})],Fe.prototype,"defaultSymbol",void 0),r.__decorate([E.property({type:pe.DataLayerSource})],Fe.prototype,"dynamicDataSource",void 0),r.__decorate([E.property({type:Boolean})],Fe.prototype,"editingEnabled",null),r.__decorate([L.reader(["portal-item","web-scene"],"editingEnabled",["layerDefinition.capabilities"])],Fe.prototype,"readEditingEnabled",null),r.__decorate([L.reader("web-map","editingEnabled",["capabilities","layerDefinition.capabilities"])],Fe.prototype,"readEditingEnabledFromWebMap",null),r.__decorate([P.writer(["portal-item","web-scene"],"editingEnabled",{"layerDefinition.capabilities":{type:String}})],Fe.prototype,"writeEditingEnabled",null),r.__decorate([P.writer("web-map","editingEnabled",{capabilities:{type:String},"layerDefinition.capabilities":{type:String}})],Fe.prototype,"writeEditingEnabledToWebMap",null),r.__decorate([E.property({readOnly:!0})],Fe.prototype,"effectiveEditingEnabled",null),r.__decorate([E.property({...ve.fields,json:{read:{source:"layerDefinition.fields"},origins:{service:{name:"fields"},"web-map":{write:{target:"layerDefinition.fields",overridePolicy:Se}}}}})],Fe.prototype,"fields",void 0),r.__decorate([E.property(ve.fieldsIndex)],Fe.prototype,"fieldsIndex",void 0),r.__decorate([E.property({type:O,json:{name:"formInfo",write:!0,origins:{"web-scene":{read:!1,write:!1}}}})],Fe.prototype,"formTemplate",void 0),r.__decorate([E.property({json:{read:{source:"layerDefinition.extent"}}})],Fe.prototype,"fullExtent",void 0),r.__decorate([E.property({json:{origins:{"web-map":{write:{target:"layerDefinition.geometryType",overridePolicy:Se,writer(e,r,t){const i=e?Y.geometryTypeKebabDict.toJSON(e):null;i&&v.setDeepValue(t,i,r)}}}},read:{source:"layerDefinition.geometryType",reader:Y.geometryTypeKebabDict.read}}})],Fe.prototype,"geometryType",void 0),r.__decorate([E.property({json:{read:{source:"layerDefinition.hasM"}}})],Fe.prototype,"hasM",void 0),r.__decorate([E.property({json:{read:{source:"layerDefinition.hasZ"}}})],Fe.prototype,"hasZ",void 0),r.__decorate([E.property(X.id)],Fe.prototype,"id",void 0),r.__decorate([E.property({readOnly:!0,json:{origins:{service:{read:!0}},read:!1}})],Fe.prototype,"infoFor3D",void 0),r.__decorate([E.property({json:{origins:{"web-map":{write:{target:"layerDefinition.type"}}}}})],Fe.prototype,"isTable",void 0),r.__decorate([L.reader("service","isTable",["type","geometryType"]),L.reader("isTable",["layerDefinition.type","layerDefinition.geometryType"])],Fe.prototype,"readIsTable",null),r.__decorate([P.writer("web-map","isTable")],Fe.prototype,"writeIsTable",null),r.__decorate([E.property(X.labelsVisible)],Fe.prototype,"labelsVisible",void 0),r.__decorate([E.property({type:[oe],json:{origins:{service:{name:"drawingInfo.labelingInfo",read:ae.reader,write:!1},"web-scene":{name:"layerDefinition.drawingInfo.labelingInfo",read:ae.reader,write:{enabled:!0,layerContainerTypes:j.excludeTables}}},name:"layerDefinition.drawingInfo.labelingInfo",read:ae.reader,write:!0}})],Fe.prototype,"labelingInfo",void 0),r.__decorate([E.property((()=>{const e=g.clone(X.opacityDrawingInfo);return e.json.origins["portal-item"]={write:{target:"layerDefinition.drawingInfo.transparency",writer(e,r,t){v.setDeepValue(t,fe.opacityToTransparency(e),r)}}},e})())],Fe.prototype,"opacity",void 0),r.__decorate([E.property(X.legendEnabled)],Fe.prototype,"legendEnabled",void 0),r.__decorate([E.property({type:["show","hide"],json:(()=>{const e=g.clone(X.listMode.json);return e.origins["portal-item"]={read:!1,write:!1},e})()})],Fe.prototype,"listMode",void 0),r.__decorate([L.reader("globalIdField",["layerDefinition.globalIdField","layerDefinition.fields"])],Fe.prototype,"readGlobalIdField",null),r.__decorate([E.property({json:{origins:{"web-map":{write:{target:"layerDefinition.objectIdField",overridePolicy:Se}}}}})],Fe.prototype,"objectIdField",void 0),r.__decorate([L.reader("objectIdField",["layerDefinition.objectIdField","layerDefinition.fields"])],Fe.prototype,"readObjectIdField",null),r.__decorate([E.property({value:"ArcGISFeatureLayer",type:["ArcGISFeatureLayer"]})],Fe.prototype,"operationalLayerType",void 0),r.__decorate([E.property(ve.outFields)],Fe.prototype,"outFields",void 0),r.__decorate([E.property({readOnly:!0})],Fe.prototype,"parsedUrl",null),r.__decorate([E.property({type:String,json:{origins:{"web-scene":{read:!0,write:!0}},read:!1}})],Fe.prototype,"path",void 0),r.__decorate([E.property(X.popupEnabled)],Fe.prototype,"popupEnabled",void 0),r.__decorate([E.property({type:t,json:{name:"popupInfo",write:!0}})],Fe.prototype,"popupTemplate",void 0),r.__decorate([E.property({readOnly:!0})],Fe.prototype,"defaultPopupTemplate",null),r.__decorate([E.property({types:y.rendererTypes,json:{origins:{service:{write:{target:"drawingInfo.renderer",enabled:!1}},"web-scene":{types:y.webSceneRendererTypes,name:"layerDefinition.drawingInfo.renderer",write:{layerContainerTypes:j.excludeTables,overridePolicy:(e,r,t)=>({ignoreOrigin:t?.writeLayerSchema})}}},write:{target:"layerDefinition.drawingInfo.renderer",overridePolicy:(e,r,t)=>({ignoreOrigin:t?.writeLayerSchema})}}})],Fe.prototype,"renderer",null),r.__decorate([L.reader("service","renderer",["drawingInfo.renderer","defaultSymbol"]),L.reader("renderer",["layerDefinition.drawingInfo.renderer","layerDefinition.defaultSymbol"])],Fe.prototype,"readRenderer",null),r.__decorate([E.property()],Fe.prototype,"resourceInfo",void 0),r.__decorate([E.property((()=>{const e=g.clone(X.screenSizePerspectiveEnabled);return e.json.origins["portal-item"]={read:!1,write:!1},e})())],Fe.prototype,"screenSizePerspectiveEnabled",void 0),r.__decorate([E.property({clonable:!1})],Fe.prototype,"source",null),r.__decorate([D.cast("source")],Fe.prototype,"castSource",null),r.__decorate([L.reader("portal-item","source",["featureSet"]),L.reader("web-map","source",["featureSet"])],Fe.prototype,"readSource",null),r.__decorate([E.property({json:{read:{source:"layerDefinition.extent.spatialReference"}}})],Fe.prototype,"spatialReference",void 0),r.__decorate([E.property({type:Number})],Fe.prototype,"subtypeCode",void 0),r.__decorate([E.property({type:[ee]})],Fe.prototype,"templates",void 0),r.__decorate([L.reader("templates",["editFieldsInfo","creatorField","editorField","templates"])],Fe.prototype,"readTemplates",null),r.__decorate([E.property({type:ne})],Fe.prototype,"timeInfo",void 0),r.__decorate([E.property()],Fe.prototype,"title",void 0),r.__decorate([L.reader("service","title",["name"]),L.reader("portal-item","title",["layerDefinition.title","layerDefinition.name","title"])],Fe.prototype,"readTitle",null),r.__decorate([L.reader("web-map","title",["layerDefinition.name","title"])],Fe.prototype,"readTitleFromWebMap",null),r.__decorate([E.property({type:String})],Fe.prototype,"sublayerTitleMode",void 0),r.__decorate([E.property({json:{read:!1}})],Fe.prototype,"type",void 0),r.__decorate([E.property({type:String})],Fe.prototype,"typeIdField",void 0),r.__decorate([L.reader("service","typeIdField"),L.reader("typeIdField",["layerDefinition.typeIdField"])],Fe.prototype,"readTypeIdField",null),r.__decorate([E.property({type:[re]})],Fe.prototype,"types",void 0),r.__decorate([L.reader("service","types",["types"]),L.reader("types",["layerDefinition.types"])],Fe.prototype,"readTypes",null),r.__decorate([E.property({type:Boolean,json:{origins:{"portal-item":{write:{target:"layerDefinition.defaultVisibility"}}}}})],Fe.prototype,"visible",void 0),r.__decorate([L.reader("portal-item","visible",["visibility","layerDefinition.defaultVisibility"])],Fe.prototype,"readVisible",null),Fe=r.__decorate([x.subclass("esri.layers.FeatureLayer")],Fe);return Fe}));
