/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../geometry","../PopupTemplate","../renderers/ClassBreaksRenderer","../renderers/DictionaryRenderer","../renderers/DotDensityRenderer","../renderers/HeatmapRenderer","../renderers/PieChartRenderer","../renderers/Renderer","../renderers/SimpleRenderer","../renderers/UniqueValueRenderer","../renderers/support/jsonUtils","../renderers/support/types","../core/MultiOriginJSONSupport","../core/promiseUtils","../core/urlUtils","../core/accessorSupport/decorators/property","../core/has","../core/Logger","../core/RandomLCG","../core/accessorSupport/decorators/subclass","../geometry/support/typeUtils","./Layer","./graphics/sources/GeoJSONSource","./mixins/BlendLayer","./mixins/CustomParametersMixin","./mixins/FeatureEffectLayer","./mixins/FeatureReductionLayer","./mixins/OperationalLayer","./mixins/OrderedLayer","./mixins/PortalLayer","./mixins/RefreshableLayer","./mixins/ScaleRangeLayer","./mixins/TemporalLayer","./support/commonProperties","./support/FeatureTemplate","./support/Field","./support/fieldProperties","./support/fieldUtils","./support/LabelClass","./support/labelingInfo","../rest/support/Query","../support/popupUtils","../time/timeZoneUtils","../geometry/SpatialReference","../geometry/Extent"],(function(e,r,t,o,i,s,p,n,a,l,d,y,u,c,h,m,f,_,g,b,v,x,T,F,O,I,P,S,E,L,R,w,j,q,D,J,N,U,G,C,Q,Z,V,B,M,z,k){"use strict";const A=G.defineFieldProperties();let H=class extends(R.OrderedLayer(P.CustomParametersMixin(E.FeatureReductionLayer(S.FeatureEffectLayer(I.BlendLayer(D.TemporalLayer(q.ScaleRangeLayer(j.RefreshableLayer(L.OperationalLayer(w.PortalLayer(h.MultiOriginJSONMixin(F)))))))))))){constructor(e){super(e),this.attributeTableTemplate=null,this.copyright=null,this.dateFieldsTimeZone=null,this.definitionExpression=null,this.displayField=null,this.editingEnabled=!1,this.elevationInfo=null,this.fields=null,this.fieldsIndex=null,this.fullExtent=null,this.geometryType=null,this.hasZ=void 0,this.labelsVisible=!0,this.labelingInfo=null,this.legendEnabled=!0,this.objectIdField=null,this.operationalLayerType="GeoJSON",this.outFields=null,this.popupEnabled=!0,this.popupTemplate=null,this.screenSizePerspectiveEnabled=!0,this.source=new O.GeoJSONSource({layer:this}),this.spatialReference=z.WGS84,this.templates=null,this.title="GeoJSON",this.type="geojson"}destroy(){this.source?.destroy()}load(e){const r=this.loadFromPortal({supportedTypes:["GeoJson"],supportsData:!1},e).catch(m.throwIfAbortError).then((()=>this.source.load(e))).then((()=>{this.read(this.source.sourceJSON,{origin:"service",url:this.parsedUrl}),this.revert(["objectIdField","fields","timeInfo"],"service"),C.fixRendererFields(this.renderer,this.fieldsIndex),C.fixTimeInfoFields(this.timeInfo,this.fieldsIndex)}));return this.addResolvingPromise(r),Promise.resolve(this)}get capabilities(){return this.source?this.source.capabilities:null}get createQueryVersion(){return this.commitProperty("definitionExpression"),this.commitProperty("timeExtent"),this.commitProperty("timeOffset"),this.commitProperty("geometryType"),this.commitProperty("capabilities"),(this._get("createQueryVersion")||0)+1}get defaultPopupTemplate(){return this.createPopupTemplate()}get isTable(){return this.loaded&&null==this.geometryType}get parsedUrl(){return this.url?f.urlToObject(this.url):null}set renderer(e){C.fixRendererFields(e,this.fieldsIndex),this._set("renderer",e)}set url(e){if(!e)return void this._set("url",e);const r=f.urlToObject(e);this._set("url",r.path),r.query&&(this.customParameters={...this.customParameters,...r.query})}async applyEdits(r,t){const{applyEdits:o}=await new Promise(((r,t)=>e(["./graphics/editingSupport"],r,t)));await this.load();const i=await o(this,this.source,r,t);return this.read({extent:this.source.sourceJSON.extent,timeInfo:this.source.sourceJSON.timeInfo},{origin:"service",ignoreDefaults:!0}),i}on(e,r){return super.on(e,r)}createPopupTemplate(e){return B.createPopupTemplate(this,e)}createQuery(){const e=new V,r=this.capabilities?.data;e.returnGeometry=!0,r&&r.supportsZ&&(e.returnZ=!0),e.outFields=["*"],e.where=this.definitionExpression||"1=1";const{timeOffset:t,timeExtent:o}=this;return e.timeExtent=null!=t&&null!=o?o.offset(-t.value,t.unit):o||null,e}getFieldDomain(e,r){return this.getField(e)?.domain}getField(e){return this.fieldsIndex.get(e)}queryFeatures(e,r){return this.load().then((()=>this.source.queryFeatures(V.from(e)||this.createQuery(),r))).then((e=>{if(e?.features)for(const r of e.features)r.layer=r.sourceLayer=this;return e}))}queryObjectIds(e,r){return this.load().then((()=>this.source.queryObjectIds(V.from(e)||this.createQuery(),r)))}queryFeatureCount(e,r){return this.load().then((()=>this.source.queryFeatureCount(V.from(e)||this.createQuery(),r)))}queryExtent(e,r){return this.load().then((()=>this.source.queryExtent(V.from(e)||this.createQuery(),r)))}async hasDataChanged(){try{const{dataChanged:e,updates:r}=await this.source.refresh(this.customParameters);return null!=r&&this.read(r,{origin:"service",url:this.parsedUrl,ignoreDefaults:!0}),e}catch{}return!1}};r.__decorate([_.property(J.attributeTableTemplate)],H.prototype,"attributeTableTemplate",void 0),r.__decorate([_.property({readOnly:!0,json:{read:!1,write:!1}})],H.prototype,"capabilities",null),r.__decorate([_.property({type:String})],H.prototype,"copyright",void 0),r.__decorate([_.property({readOnly:!0})],H.prototype,"createQueryVersion",null),r.__decorate([_.property(M.timeZoneProperty("dateFieldsTimeReference"))],H.prototype,"dateFieldsTimeZone",void 0),r.__decorate([_.property({readOnly:!0})],H.prototype,"defaultPopupTemplate",null),r.__decorate([_.property({type:String,json:{name:"layerDefinition.definitionExpression",write:{enabled:!0,allowNull:!0}}})],H.prototype,"definitionExpression",void 0),r.__decorate([_.property({type:String})],H.prototype,"displayField",void 0),r.__decorate([_.property({type:Boolean})],H.prototype,"editingEnabled",void 0),r.__decorate([_.property(J.elevationInfo)],H.prototype,"elevationInfo",void 0),r.__decorate([_.property({type:[U],json:{name:"layerDefinition.fields",write:{ignoreOrigin:!0,isRequired:!0},origins:{service:{name:"fields"}}}})],H.prototype,"fields",void 0),r.__decorate([_.property(A.fieldsIndex)],H.prototype,"fieldsIndex",void 0),r.__decorate([_.property({type:k,json:{name:"extent"}})],H.prototype,"fullExtent",void 0),r.__decorate([_.property({type:["point","polygon","polyline","multipoint"],json:{read:{reader:T.featureGeometryTypeKebabDictionary.read}}})],H.prototype,"geometryType",void 0),r.__decorate([_.property({type:Boolean})],H.prototype,"hasZ",void 0),r.__decorate([_.property(J.id)],H.prototype,"id",void 0),r.__decorate([_.property({type:Boolean,readOnly:!0})],H.prototype,"isTable",null),r.__decorate([_.property(J.labelsVisible)],H.prototype,"labelsVisible",void 0),r.__decorate([_.property({type:[Q],json:{name:"layerDefinition.drawingInfo.labelingInfo",read:{reader:Z.reader},write:!0}})],H.prototype,"labelingInfo",void 0),r.__decorate([_.property(J.legendEnabled)],H.prototype,"legendEnabled",void 0),r.__decorate([_.property({type:["show","hide"]})],H.prototype,"listMode",void 0),r.__decorate([_.property({type:String,json:{name:"layerDefinition.objectIdField",write:{ignoreOrigin:!0,isRequired:!0},origins:{service:{name:"objectIdField"}}}})],H.prototype,"objectIdField",void 0),r.__decorate([_.property(J.opacity)],H.prototype,"opacity",void 0),r.__decorate([_.property({type:["GeoJSON"]})],H.prototype,"operationalLayerType",void 0),r.__decorate([_.property(A.outFields)],H.prototype,"outFields",void 0),r.__decorate([_.property({readOnly:!0})],H.prototype,"parsedUrl",null),r.__decorate([_.property(J.popupEnabled)],H.prototype,"popupEnabled",void 0),r.__decorate([_.property({type:o,json:{name:"popupInfo",write:!0}})],H.prototype,"popupTemplate",void 0),r.__decorate([_.property({types:c.rendererTypes,json:{name:"layerDefinition.drawingInfo.renderer",write:!0,origins:{service:{name:"drawingInfo.renderer"},"web-scene":{types:c.webSceneRendererTypes}}}})],H.prototype,"renderer",null),r.__decorate([_.property(J.screenSizePerspectiveEnabled)],H.prototype,"screenSizePerspectiveEnabled",void 0),r.__decorate([_.property({readOnly:!0})],H.prototype,"source",void 0),r.__decorate([_.property({type:z})],H.prototype,"spatialReference",void 0),r.__decorate([_.property({type:[N]})],H.prototype,"templates",void 0),r.__decorate([_.property()],H.prototype,"title",void 0),r.__decorate([_.property({json:{read:!1},readOnly:!0})],H.prototype,"type",void 0),r.__decorate([_.property(J.url)],H.prototype,"url",null),H=r.__decorate([x.subclass("esri.layers.GeoJSONLayer")],H);return H}));
