/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../core/CollectionFlattener","../core/loadAll","../core/Logger","../core/MultiOriginJSONSupport","../core/promiseUtils","../core/reactiveUtils","../core/accessorSupport/decorators/property","../core/has","../core/RandomLCG","../core/accessorSupport/utils","../core/accessorSupport/decorators/reader","../core/accessorSupport/decorators/subclass","../core/accessorSupport/decorators/writer","../core/accessorSupport/PropertyOrigin","./Layer","./mixins/BlendLayer","./mixins/OperationalLayer","./mixins/PortalLayer","./mixins/ScaleRangeLayer","./support/lazyLayerLoader","../portal/PortalItem","../support/collectionUtils","../support/LayersMixin","../support/TablesMixin","../support/tagSymbols","../webdoc/interfaces","../webdoc/support/saveUtils","../webdoc/support/writeUtils"],(function(e,t,r,i,s,o,a,l,n,p,d,y,c,h,u,b,v,_,m,L,w,f,g,S,O,I,M,P,x,A){"use strict";let T=class extends(_.BlendLayer(w.ScaleRangeLayer(m.OperationalLayer(L.PortalLayer(I.TablesMixin(O.LayersMixin(o.MultiOriginJSONMixin(v)))))))){constructor(t){super(t),this.allLayers=new r({getCollections:()=>[this.layers],getChildrenFunction:e=>"layers"in e?e.layers:null}),this.allTables=S.createFlattenedTablesCollection(this),this.fullExtent=void 0,this.operationalLayerType="GroupLayer",this.spatialReference=void 0,this.type="group",this._debouncedSaveOperations=a.debounce((async(t,r,i)=>{const{save:s,saveAs:o}=await new Promise(((t,r)=>e(["./save/groupLayerUtils"],t,r)));switch(t){case P.SaveOperationType.SAVE:return s(this,r);case P.SaveOperationType.SAVE_AS:return o(this,i,r)}}))}initialize(){this._enforceVisibility(this.visibilityMode,this.visible),this.addHandles([l.watch((()=>{let e=this.parent;for(;e&&"parent"in e&&e.parent;)e=e.parent;return e&&M.WebSceneTag in e}),(e=>{const t="prevent-adding-tables";this.removeHandles(t),e&&(this.tables.removeAll(),this.addHandles(l.on((()=>this.tables),"before-add",(e=>{e.preventDefault(),s.getLogger(this).errorOnce("tables","tables in group layers in a webscene are not supported. Please move the tables from the group layer to the webscene if you want to persist them.")})),t))}),l.syncAndInitial),l.watch((()=>this.visible),this._onVisibilityChange.bind(this),l.sync)])}destroy(){this.allLayers.destroy(),this.allTables.destroy()}get sourceIsPortalItem(){return this.portalItem&&this.originIdOf("portalItem")===b.OriginId.USER}_writeLayers(e,t,r,i){const s=[];if(!e)return s;e.forEach((e=>{const t=A.getLayerJSON(e,i.webmap?i.webmap.getLayerJSONFromResourceInfo(e):null,i);t?.layerType&&s.push(t)})),t.layers=s}set portalItem(e){this._set("portalItem",e)}readPortalItem(e,t,r){const{itemId:i,layerType:s}=t;if("GroupLayer"===s&&i)return new g({id:i,portal:r?.portal})}writePortalItem(e,t){e?.id&&(t.itemId=e.id)}set visibilityMode(e){const t=this._get("visibilityMode")!==e;this._set("visibilityMode",e),t&&this._enforceVisibility(e,this.visible)}async beforeSave(){return x.beforeSave(this)}load(e){const t=this.loadFromPortal({supportedTypes:["Feature Service","Feature Collection","Group Layer","Scene Service"],layerModuleTypeMap:f.layerLookupMap},e).catch((e=>{if(a.throwIfAbortError(e),this.sourceIsPortalItem)throw e}));return this.addResolvingPromise(t),Promise.resolve(this)}async loadAll(){return i.loadAll(this,(e=>{e(this.layers,this.tables)}))}async save(e){return this._debouncedSaveOperations(P.SaveOperationType.SAVE,e)}async saveAs(e,t){return this._debouncedSaveOperations(P.SaveOperationType.SAVE_AS,t,e)}layerAdded(e){e.visible&&"exclusive"===this.visibilityMode?this._turnOffOtherLayers(e):"inherited"===this.visibilityMode&&(e.visible=this.visible),this.hasHandles(e.uid)?console.error(`Layer read to Grouplayer: uid=${e.uid}`):this.addHandles(l.watch((()=>e.visible),(t=>this._onChildVisibilityChange(e,t)),l.sync),e.uid)}layerRemoved(e){this.removeHandles(e.uid),this._enforceVisibility(this.visibilityMode,this.visible)}_turnOffOtherLayers(e){this.layers.forEach((t=>{t!==e&&(t.visible=!1)}))}_enforceVisibility(e,t){if(!y.getProperties(this).initialized)return;const r=this.layers;let i=r.find((e=>e.visible));switch(e){case"exclusive":r.length&&!i&&(i=r.at(0),i.visible=!0),this._turnOffOtherLayers(i);break;case"inherited":r.forEach((e=>{e.visible=t}))}}_onVisibilityChange(e){"inherited"===this.visibilityMode&&this.layers.forEach((t=>{t.visible=e}))}_onChildVisibilityChange(e,t){switch(this.visibilityMode){case"exclusive":t?this._turnOffOtherLayers(e):this._isAnyLayerVisible()||(e.visible=!0);break;case"inherited":e.visible=this.visible}}_isAnyLayerVisible(){return this.layers.some((e=>e.visible))}};t.__decorate([n.property({readOnly:!0,dependsOn:[]})],T.prototype,"allLayers",void 0),t.__decorate([n.property({readOnly:!0})],T.prototype,"allTables",void 0),t.__decorate([n.property({json:{read:!0,write:!0}})],T.prototype,"blendMode",void 0),t.__decorate([n.property()],T.prototype,"fullExtent",void 0),t.__decorate([n.property({readOnly:!0})],T.prototype,"sourceIsPortalItem",null),t.__decorate([n.property({json:{read:!1,write:{ignoreOrigin:!0}}})],T.prototype,"layers",void 0),t.__decorate([u.writer("layers")],T.prototype,"_writeLayers",null),t.__decorate([n.property({type:["GroupLayer"]})],T.prototype,"operationalLayerType",void 0),t.__decorate([n.property({json:{origins:{"web-map":{read:!1,write:{overridePolicy(e,t,r){return{enabled:"Group Layer"===e?.type&&r?.initiator!==this}}}},"web-scene":{read:!1,write:!1}}}})],T.prototype,"portalItem",null),t.__decorate([c.reader("web-map","portalItem",["itemId"])],T.prototype,"readPortalItem",null),t.__decorate([u.writer("web-map","portalItem",{itemId:{type:String}})],T.prototype,"writePortalItem",null),t.__decorate([n.property()],T.prototype,"spatialReference",void 0),t.__decorate([n.property({json:{read:!1},readOnly:!0,value:"group"})],T.prototype,"type",void 0),t.__decorate([n.property({type:["independent","inherited","exclusive"],value:"independent",json:{write:!0,origins:{"web-map":{type:["independent","exclusive"],write:(e,t,r)=>{"inherited"!==e&&(t[r]=e)}}}}})],T.prototype,"visibilityMode",null),T=t.__decorate([h.subclass("esri.layers.GroupLayer")],T);return T}));
