/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../PopupTemplate","../core/Clonable","../core/Error","../core/MultiOriginJSONSupport","../core/promiseUtils","../core/accessorSupport/decorators/property","../core/has","../core/Logger","../core/RandomLCG","../core/accessorSupport/decorators/subclass","../core/accessorSupport/decorators/writer","./Layer","./mixins/ArcGISImageService","./mixins/ArcGISService","./mixins/BlendLayer","./mixins/CustomParametersMixin","./mixins/OperationalLayer","./mixins/PortalLayer","./mixins/RasterPresetRendererMixin","./mixins/RefreshableLayer","./mixins/ScaleRangeLayer","./mixins/TemporalLayer","./support/commonProperties","./support/versionUtils","../support/popupUtils","../webdoc/interfaces"],(function(e,r,t,a,i,s,o,p,n,l,c,d,y,u,h,m,v,S,g,f,_,L,w,b,I,T,P,x){"use strict";let A=class extends(v.BlendLayer(b.TemporalLayer(w.ScaleRangeLayer(g.OperationalLayer(f.PortalLayer(_.RasterPresetRendererMixin(h.ArcGISImageService(L.RefreshableLayer(S.CustomParametersMixin(m.ArcGISService(s.MultiOriginJSONMixin(a.ClonableMixin(u))))))))))))){constructor(...r){super(...r),this.isReference=null,this.operationalLayerType="ArcGISImageServiceLayer",this.popupEnabled=!0,this.popupTemplate=null,this.type="imagery",this._debouncedSaveOperations=o.debounce((async(r,t,a)=>{const{save:i,saveAs:s}=await new Promise(((r,t)=>e(["./save/imageryUtils"],r,t)));switch(r){case x.SaveOperationType.SAVE:return i(this,t);case x.SaveOperationType.SAVE_AS:return s(this,a,t)}}))}normalizeCtorArgs(e,r){return"string"==typeof e?{url:e,...r}:e}load(e){const r=null!=e?e.signal:null;return this.addResolvingPromise(this.loadFromPortal({supportedTypes:["Image Service"]},e).catch(o.throwIfAbortError).then((()=>this._fetchService(r)))),Promise.resolve(this)}get legendEnabled(){return!this._isPreviewLayer&&(this._get("legendEnabled")??!0)}set legendEnabled(e){this._set("legendEnabled",e)}get listMode(){return this._isPreviewLayer?"hide":this._get("listMode")}set listMode(e){this._set("listMode",e)}writeOperationalLayerType(e,r,t){const a="vector-field"===this.renderer?.type;r[t]=a?"ArcGISImageServiceVectorLayer":"ArcGISImageServiceLayer"}get defaultPopupTemplate(){return this.createPopupTemplate()}get _isPreviewLayer(){return!(!this.raster||!this.url?.toLowerCase().includes("/rasterrendering/imageserver"))}createPopupTemplate(e){const r=this.rasterFields,t=this.title,a=new Set;let i=!1,s=!1;this.capabilities&&(i=this.capabilities.operations.supportsQuery&&this.fields&&this.fields.length>0,s="esriImageServiceDataTypeVector-UV"===this.serviceDataType||"esriImageServiceDataTypeVector-MagDir"===this.serviceDataType);const o=new Set;i&&o.add("raster.itempixelvalue");for(const n of r){const e=n.name.toLowerCase();o.has(e)||e.includes("raster.servicepixelvalue.")||a.add(n.name)}s&&a.add("raster.magnitude").add("raster.direction");const p=P.createPopupTemplate({fields:r,title:t},{...e,visibleFieldNames:a});return p?.fieldInfos&&this.rasterInfo?.pixelType.startsWith("f")&&p.fieldInfos.forEach((({format:e,fieldName:r})=>{e&&r&&/^raster\.(item|service)pixelvalue/i.test(r)&&(e.places=2)})),p}queryFeatures(e,r){return this.queryRasters(e,r).then((e=>{if(e?.features)for(const r of e.features)r.layer=r.sourceLayer=this;return e}))}queryFeatureCount(e,r){return this.queryRasterCount(e,r)}redraw(){this.emit("redraw")}async save(e){return this._debouncedSaveOperations(x.SaveOperationType.SAVE,e)}async saveAs(e,r){return this._debouncedSaveOperations(x.SaveOperationType.SAVE_AS,r,e)}serviceSupportsSpatialReference(e){return T.serviceSupportsSpatialReference(this,e)}write(e,r){if(!this._isPreviewLayer)return super.write(e,r);if(r?.messages){const e=`${r.origin}/${r.layerContainerType||"operational-layers"}`;r.messages.push(new i("layer:unsupported",`Imagery preview layer (${this.title}, ${this.id}) of type '${this.declaredClass}' are not supported in the context of '${e}'`,{layer:this}))}return null}};r.__decorate([p.property(I.legendEnabled)],A.prototype,"legendEnabled",null),r.__decorate([p.property({type:["show","hide"]})],A.prototype,"listMode",null),r.__decorate([p.property({type:Boolean,json:{read:!1,write:{enabled:!0,overridePolicy:()=>({enabled:!1})}}})],A.prototype,"isReference",void 0),r.__decorate([p.property({type:["ArcGISImageServiceLayer"],json:{origins:{"web-map":{type:["ArcGISImageServiceLayer","ArcGISImageServiceVectorLayer"],read:!1,write:{target:"layerType",ignoreOrigin:!0}}}}})],A.prototype,"operationalLayerType",void 0),r.__decorate([y.writer("web-map","operationalLayerType")],A.prototype,"writeOperationalLayerType",null),r.__decorate([p.property(I.popupEnabled)],A.prototype,"popupEnabled",void 0),r.__decorate([p.property({type:t,json:{read:{source:"popupInfo"},write:{target:"popupInfo"}}})],A.prototype,"popupTemplate",void 0),r.__decorate([p.property({readOnly:!0})],A.prototype,"defaultPopupTemplate",null),r.__decorate([p.property({readOnly:!0,json:{read:!1}})],A.prototype,"type",void 0),r.__decorate([p.property({readOnly:!0})],A.prototype,"_isPreviewLayer",null),A=r.__decorate([d.subclass("esri.layers.ImageryLayer")],A);return A}));
