/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../request","../core/Error","../core/Logger","../core/mathUtils","../core/MultiOriginJSONSupport","../core/promiseUtils","../core/accessorSupport/decorators/property","../core/has","../core/RandomLCG","../core/accessorSupport/decorators/subclass","../chunks/vec32","../core/libs/gl-matrix-2/factories/vec3f64","../geometry/ellipsoidUtils","../geometry/Extent","../geometry/SpatialReference","../geometry/projection/projectBuffer","./Layer","./mixins/APIKeyMixin","./mixins/ArcGISService","./mixins/CustomParametersMixin","./mixins/OperationalLayer","./mixins/PortalLayer","./mixins/ScaleRangeLayer","./support/commonProperties","../support/elevationInfoUtils"],(function(e,t,r,i,a,o,s,n,l,p,c,d,y,u,f,m,h,x,g,v,_,b,S,E,A,L){"use strict";let I=class extends(v.ArcGISService(b.OperationalLayer(S.PortalLayer(E.ScaleRangeLayer(o.MultiOriginJSONMixin(_.CustomParametersMixin(g.APIKeyMixin(x)))))))){constructor(e){super(e),this.operationalLayerType="IntegratedMesh3DTilesLayer",this.spatialReference=new m({wkid:4326,vcsWkid:115700}),this.fullExtent=new f(-180,-90,180,90,this.spatialReference),this.url=null,this.type="integrated-mesh-3dtiles",this.path=null,this.minScale=0,this.maxScale=0}set elevationInfo(e){this._set("elevationInfo",e),this._validateElevationInfo()}_verifyArray(e,t){if(!Array.isArray(e)||e.length<t)return!1;for(const r of e)if("number"!=typeof r)return!1;return!0}_initFullExtent(e){const t=e.root?.boundingVolume;if(!t)return;if(t.box){const e=t?.box;if(e[3]>7972671&&e[7]>7972671&&e[11]>7945940)return}const r=e.root?.transform,i=y.create();if(t.region&&this._verifyArray(t.region,6)){const e=t.region,r=a.rad2deg(e[0]),i=a.rad2deg(e[1]),o=e[4],s=a.rad2deg(e[2]),n=a.rad2deg(e[3]),l=e[5];this.fullExtent=new f({xmin:r,ymin:i,zmin:o,xmax:s,ymax:n,zmax:l,spatialReference:this.spatialReference})}else if(t.sphere&&this._verifyArray(t.sphere,4)){const e=t.sphere,a=y.fromValues(e[0],e[1],e[2]),o=e[3]/Math.sqrt(3),s=y.create();d.subtract(s,a,y.fromValues(o,o,o));const n=y.create();if(d.add(n,a,y.fromValues(o,o,o)),r&&this._verifyArray(r,16)){const e=r;d.transformMat4(i,s,e),d.copy(s,i),d.transformMat4(i,n,e),d.copy(n,i)}h.projectBuffer(s,u.WGS84ECEFSpatialReferenceLike,0,s,m.WGS84,0),h.projectBuffer(n,u.WGS84ECEFSpatialReferenceLike,0,n,m.WGS84,0);const l=y.create(),p=y.create();d.min(l,s,n),d.max(p,s,n),this.fullExtent=new f({xmin:l[0],ymin:l[1],zmin:l[2],xmax:p[0],ymax:p[1],zmax:p[2],spatialReference:this.spatialReference})}else if(t.box&&this._verifyArray(t.box,12)){const e=t.box,i=y.fromValues(e[0],e[1],e[2]),a=y.fromValues(e[3],e[4],e[5]),o=y.fromValues(e[6],e[7],e[8]),s=y.fromValues(e[9],e[10],e[11]),n=[];for(let t=0;t<8;++t)n.push(y.create());if(d.add(n[0],i,a),d.add(n[0],n[0],o),d.add(n[0],n[0],s),d.sub(n[1],i,a),d.add(n[1],n[1],o),d.add(n[1],n[1],s),d.add(n[2],i,a),d.sub(n[2],n[2],o),d.add(n[2],n[2],s),d.sub(n[3],i,a),d.sub(n[3],n[3],o),d.add(n[3],n[3],s),d.add(n[4],i,a),d.add(n[4],n[4],o),d.sub(n[4],n[4],s),d.sub(n[5],i,a),d.add(n[5],n[5],o),d.sub(n[5],n[5],s),d.add(n[6],i,a),d.sub(n[6],n[6],o),d.sub(n[6],n[6],s),d.sub(n[7],i,a),d.sub(n[7],n[7],o),d.sub(n[7],n[7],s),r&&this._verifyArray(r,16)){const e=r;for(let t=0;t<8;++t)d.transformMat4(n[t],n[t],e)}const l=y.fromValues(-Number.MAX_VALUE,-Number.MAX_VALUE,-Number.MAX_VALUE),p=y.fromValues(Number.MAX_VALUE,Number.MAX_VALUE,Number.MAX_VALUE);for(let t=0;t<8;++t)h.projectBuffer(n[t],u.WGS84ECEFSpatialReferenceLike,0,n[t],m.WGS84,0),d.min(p,p,n[t]),d.max(l,l,n[t]);this.fullExtent=new f({xmin:p[0],ymin:p[1],zmin:p[2],xmax:l[0],ymax:l[1],zmax:l[2],spatialReference:this.spatialReference})}}async load(e){return this.addResolvingPromise(this._doLoad(e)),this}async _doLoad(e){const i=null!=e?e.signal:null;try{await this.loadFromPortal({supportedTypes:["3DTiles Service"],validateItem:e=>{if(e.typeKeywords?.includes("IntegratedMesh"))return!0;throw new r("portal:invalid-layer-item-type","Invalid layer item, expected '${expectedType}' ",{expectedType:"3DTiles Service containing IntegratedMesh"})}},e)}catch(a){s.throwIfAbortError(a)}if(this.url){const e=t(this.url,{query:{f:"json",...this.customParameters,token:this.apiKey},responseType:"json",signal:i}).then((e=>{this._initFullExtent(e.data)}),(e=>{s.throwIfAbortError(e)}));await e}}async fetchAttributionData(){return this.load().then((()=>({})))}_validateElevationInfo(){const e=this.elevationInfo,t="Integrated mesh 3d tiles layers";L.logInvalidElevationInfoWarning(i.getLogger(this),L.elevationModeRequiredMessage(t,"absolute-height",e)),L.logInvalidElevationInfoWarning(i.getLogger(this),L.featureExpressionUnsupportedMessage(t,e))}};e.__decorate([n.property({type:["IntegratedMesh3DTilesLayer"]})],I.prototype,"operationalLayerType",void 0),e.__decorate([n.property({type:m})],I.prototype,"spatialReference",void 0),e.__decorate([n.property({type:f})],I.prototype,"fullExtent",void 0),e.__decorate([n.property(A.elevationInfo)],I.prototype,"elevationInfo",null),e.__decorate([n.property({type:["show","hide"]})],I.prototype,"listMode",void 0),e.__decorate([n.property(A.url)],I.prototype,"url",void 0),e.__decorate([n.property({readOnly:!0})],I.prototype,"type",void 0),e.__decorate([n.property({type:String,json:{origins:{"web-scene":{read:!0,write:!0},"portal-item":{read:!0,write:!0}},read:!1}})],I.prototype,"path",void 0),e.__decorate([n.property({type:Number,json:{name:"layerDefinition.minScale",write:!0,origins:{service:{read:!1,write:!1}}}})],I.prototype,"minScale",void 0),e.__decorate([n.property({type:Number,json:{name:"layerDefinition.maxScale",write:!0,origins:{service:{read:!1,write:!1}}}})],I.prototype,"maxScale",void 0),I=e.__decorate([c.subclass("esri.layers.IntegratedMesh3DTilesLayer")],I);return I}));
