/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../core/Collection","../core/Error","../core/Logger","../core/MapUtils","../core/MultiOriginJSONSupport","../core/promiseUtils","../core/reactiveUtils","../core/urlUtils","../core/uuid","../core/accessorSupport/decorators/property","../core/has","../core/RandomLCG","../core/accessorSupport/decorators/reader","../core/accessorSupport/decorators/subclass","../core/accessorSupport/decorators/writer","../core/accessorSupport/PropertyOrigin","./Layer","./knowledgeGraph/KnowledgeGraphLayerDataManager","./knowledgeGraph/KnowledgeGraphSublayer","./knowledgeGraph/layerUtils","./knowledgeGraph/supportUtils","./mixins/ArcGISService","./mixins/BlendLayer","./mixins/CustomParametersMixin","./mixins/OperationalLayer","./mixins/PortalLayer","./mixins/RefreshableLayer","./mixins/ScaleRangeLayer","./support/commonProperties","../rest/knowledgeGraphService","../chunks/persistableUrlUtils"],(function(e,t,i,a,r,o,s,n,p,l,d,h,y,c,u,f,g,m,w,_,b,M,T,S,L,D,v,I,C,G,k,N){"use strict";let A=class extends(S.BlendLayer(C.ScaleRangeLayer(I.RefreshableLayer(T.ArcGISService(D.OperationalLayer(v.PortalLayer(o.MultiOriginJSONMixin(L.CustomParametersMixin(m))))))))){constructor(e){super(e),this._graphTypeLookup=new Map,this._namedTypesModified=!1,this.dataManager=null,this.definitionSetMap=null,this.knowledgeGraph=null,this.layers=new(t.ofType(_)),this.memberEntityTypes=null,this.memberRelationshipTypes=null,this.operationalLayerType="KnowledgeGraphLayer",this.sublayerIdsCache=new Map,this.tables=new(t.ofType(_)),this.type="knowledge-graph",this.url=null,this.addHandles(n.watch((()=>this.layers.concat(this.tables)),((e,t)=>this._handleSublayersChange(e,t)),n.sync))}load(e){return this.addResolvingPromise(this._doLoad(e)),Promise.resolve(this)}async _doLoad(e){try{await this.loadFromPortal({supportedTypes:["Knowledge Graph Layer"]},e)}catch(t){s.throwIfAbortError(t)}await this._fetchMetadata(),await this._initializeLayerProperties(),this.loadLayerAssumingLocalCache(),await b.initializeLayersFromClientData(this)}async _fetchMetadata(){if(!this.url)throw new i("knowledge-graph:missing-url","KnowledgeGraphLayer must be created with a url");const e=await k.fetchKnowledgeGraph(this.url);this.knowledgeGraph=e,this._forEachGraphType((e=>{e.name&&this._graphTypeLookup.set(e.name,e)}))}async _initializeLayerProperties(){this.originIdOf("inclusionModeDefinition")===g.OriginId.USER?this._validateInclusionModeDefinition():await this._initializeInclusionModeDefinition(),this._setMemberTypes(),this.dataManager=new w.KnowledgeGraphLayerDataManager({knowledgeGraph:this.knowledgeGraph,inclusionModeDefinition:this.inclusionModeDefinition})}async _initializeInclusionModeDefinition(){const e=this.definitionSetMap?await M.fetchAndConvertSerializedKgIdMap(this.definitionSetMap,!0):{generateAllSublayers:!0,namedTypeDefinitions:new Map};[...this.layers.toArray(),...this.tables.toArray()].forEach((t=>{const i=this._graphTypeLookup.get(t.graphTypeName);i&&!e.namedTypeDefinitions.has(i.name)&&e.namedTypeDefinitions.set(i.name,{useAllData:!0})})),this.setAtOrigin("inclusionModeDefinition",e,g.idToName(this.originIdOf("definitionSetMap")))}_validateInclusionModeDefinition(){const{inclusionModeDefinition:e}=this;if(!e)return;const{namedTypeDefinitions:t}=e;if(t?.size>0)t.forEach(((e,i)=>{const r=this._graphTypeLookup.get(i);if(!r)return a.getLogger(this).warn(`A named type, ${i}, was in the inclusion list that wasn't in the data model and will be removed`),void t.delete(i);"relationship"!==r.type&&"entity"!==r.type&&(a.getLogger(this).warn(`A named type, ${i}, was in the inclusion list that wasn't properly modeled and will be removed`),t.delete(i))}));else if(!e.generateAllSublayers)throw new i("knowledge-graph:composite-layer-constructor","If an explicit inclusion definition is defined, at least one namedTypeDefinition must also be defined")}_setMemberTypes(){let e=[],t=[];const{inclusionModeDefinition:i}=this,a=i?.namedTypeDefinitions;!i||i.generateAllSublayers?(e=this.knowledgeGraph.dataModel?.entityTypes??[],t=this.knowledgeGraph.dataModel?.relationshipTypes??[]):a&&a.size>0&&a.forEach(((i,a)=>{const r=this._graphTypeLookup.get(a);switch(r?.type){case"relationship":t.push(r);break;case"entity":e.push(r)}})),this.memberEntityTypes=e,this.memberRelationshipTypes=t}_forEachGraphType(e){[...this.knowledgeGraph.dataModel?.entityTypes??[],...this.knowledgeGraph.dataModel?.relationshipTypes??[]].forEach((t=>{e(t)}))}_refreshNamedTypes(){this._namedTypesModified=!0;for(const e of this.layers)e.emit("refresh",{dataChanged:!0});for(const e of this.tables)e.emit("refresh",{dataChanged:!0})}async _handleNewRecords(e){const t=[];this.dataManager.addToLayer(e);for(const i of e)this.sublayerIdsCache.has(i.typeName)||(this.sublayerIdsCache.set(i.typeName,new Set),t.push(i.typeName)),this.sublayerIdsCache.get(i.typeName).add(i.id);for(const i of t){const e=this._graphTypeLookup.get(i);e&&(this._addSublayer(e),"entity"===e.type?this.dataManager.entityTypeNames.add(i):this.dataManager.relationshipTypeNames.add(i),this.dataManager.sublayerCaches.set(i,new Map))}await b.initializeLayersFromClientData(this,t),this._refreshNamedTypes()}_createSublayers(e,t,i){e.forEach((e=>{const a=this._createSublayer(e);i(a)&&t.push(a),this._updateSublayerCaches(e)}))}_addSublayer(e){const t=this._createSublayer(e);return t.geometryType?this.layers.push(t):this.tables.push(t),t}_createSublayer(e){return new _({objectType:e,parentCompositeLayer:this,graphType:e.type})}_updateSublayers(e,t){t.forEach((t=>{t.parentCompositeLayer=this;const i=e.find((e=>e.type===t.graphType&&e.name===t.graphTypeName));i&&(t.objectType=i,this._updateSublayerCaches(i))}))}_updateSublayerCaches(e){const t=this.dataManager.sublayerCaches;t.has(e.name)||t.set(e.name,new Map)}_saveUrlAsNewResource(e,t,i,a){e[t]="<pending>",i.pendingOperations.push(O(this.inclusionModeDefinition).then((r=>{const o=E(a);e[t]=o.itemRelativeUrl,i.toAdd.push({resource:o,content:{type:"blob",blob:r},compress:!1,finish:e=>{this.definitionSetMap=e.url}})})))}_displaysAllRecords(e){for(const[,{useAllData:t}]of e.namedTypeDefinitions)if(!t)return!1;return!0}_handleSublayersChange(e,t){t&&(t.forEach((e=>{e.parent=null})),this.removeHandles("sublayers-owner")),e&&(e.forEach((e=>{e.parent=this})),this.addHandles([e.on("after-add",(({item:e})=>{e.parent=this})),e.on("after-remove",(({item:e})=>{e.parent=null}))],"sublayers-owner"))}readDefinitionSetMap(e,t,i){return N.fromJSON(e,i)}writeDefinitionSetMap(e,t,i,a){const r=a?.portalItem,o=a?.resources,s=g.nameToId(a?.origin);if(!r||!o||null==s)return void(e&&(t[i]=N.toJSON(e,a)));const{inclusionModeDefinition:n}=this;if(!n||this._displaysAllRecords(n))return void(this.definitionSetMap=null);const l=this.originIdOf("inclusionModeDefinition");if(l===g.OriginId.USER||this._namedTypesModified||s<l)this._saveUrlAsNewResource(t,i,o,r);else if(s===l&&e){const s=N.toJSON(e,a);p.isAbsolute(s)?this._saveUrlAsNewResource(t,i,o,r):t[i]=s}}set inclusionModeDefinition(e){"loaded"!==this.loadStatus&&"failed"!==this.loadStatus?this._set("inclusionModeDefinition",e):a.getLogger(this).error("#inclusionModeDefinition","inclusionModeDefinition cannot be changed after the layer is loaded.")}loadLayerAssumingLocalCache(){const e=[...this.memberEntityTypes,...this.memberRelationshipTypes];this.originIdOf("layers")===g.OriginId.DEFAULTS?this._createSublayers(e,this.layers,(e=>!!e.geometryType)):this._updateSublayers(e,this.layers),this.originIdOf("tables")===g.OriginId.DEFAULTS?this._createSublayers(e,this.tables,(e=>!e.geometryType)):this._updateSublayers(e,this.tables),this.dataManager.inclusionModeDefinition?.namedTypeDefinitions?.forEach(((e,t)=>{const i=r.getOrCreateMapValue(this.sublayerIdsCache,t,(()=>new Set));e.members?.forEach((e=>{i.add(e.id)}))}))}async addRecords(e){await this._handleNewRecords(e)}async removeRecords(e){const t=[];for(const i of e)!1===this.dataManager.inclusionModeDefinition?.namedTypeDefinitions?.get(i.typeName)?.useAllData&&this.dataManager.inclusionModeDefinition?.namedTypeDefinitions?.get(i.typeName)?.members?.has(i.id)&&t.push(i);this.dataManager.removeFromLayer(t);for(const i of t)this.sublayerIdsCache.get(i.typeName)?.delete(i.id);return this._refreshNamedTypes(),t}};e.__decorate([d.property()],A.prototype,"dataManager",void 0),e.__decorate([d.property({json:{write:{ignoreOrigin:!0,writerEnsuresNonNull:!0}}})],A.prototype,"definitionSetMap",void 0),e.__decorate([c.reader("definitionSetMap")],A.prototype,"readDefinitionSetMap",null),e.__decorate([f.writer("definitionSetMap")],A.prototype,"writeDefinitionSetMap",null),e.__decorate([d.property()],A.prototype,"inclusionModeDefinition",null),e.__decorate([d.property()],A.prototype,"knowledgeGraph",void 0),e.__decorate([d.property({type:t.ofType(_),json:{write:{ignoreOrigin:!0}}})],A.prototype,"layers",void 0),e.__decorate([d.property()],A.prototype,"memberEntityTypes",void 0),e.__decorate([d.property()],A.prototype,"memberRelationshipTypes",void 0),e.__decorate([d.property({type:["KnowledgeGraphLayer"]})],A.prototype,"operationalLayerType",void 0),e.__decorate([d.property()],A.prototype,"sublayerIdsCache",void 0),e.__decorate([d.property({type:t.ofType(_),json:{write:{ignoreOrigin:!0}}})],A.prototype,"tables",void 0),e.__decorate([d.property({json:{read:!1}})],A.prototype,"type",void 0),e.__decorate([d.property(G.url)],A.prototype,"url",void 0),A=e.__decorate([u.subclass("esri.layers.KnowledgeGraphLayer")],A);async function O(e){const t=await M.serializeInclusionDefinitionToIdCollectionsMapPbf(e);return new Blob([t],{type:"application/x-protobuf"})}function E(e){const t=`definitionSetMap-${l.generateUUID()}.dat`,i=p.join("knowledgeGraphLayer",t);return e.resourceFromPath(i)}return A}));
