/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../geometry","../core/Collection","../core/Error","../core/Logger","../core/MapUtils","../core/MultiOriginJSONSupport","../core/promiseUtils","../core/reactiveUtils","../core/accessorSupport/decorators/property","../core/has","../core/RandomLCG","../core/accessorSupport/decorators/subclass","../core/accessorSupport/PropertyOrigin","./Layer","./graphics/featureConversionUtils","./graphics/OptimizedGeometry","./knowledgeGraph/IdealEdgeLengthTypeOptions","./knowledgeGraph/KnowledgeGraphLayerDataManager","./knowledgeGraph/KnowledgeGraphSublayer","./knowledgeGraph/layerUtils","./knowledgeGraph/SessionMemoryStorage","./knowledgeGraph/supportUtils","./mixins/BlendLayer","./mixins/OperationalLayer","./mixins/ScaleRangeLayer","../libs/linkchartlayout/LinkChartLayout","../rest/knowledgeGraphService","../geometry/Extent","../geometry/Point","../geometry/Polyline"],(function(e,t,a,i,n,o,s,r,l,d,h,y,u,c,p,g,m,L,f,C,N,w,M,b,k,T,I,E,_,O,D){"use strict";let G=class extends(k.OperationalLayer(b.BlendLayer(T.ScaleRangeLayer(s.MultiOriginJSONMixin(p))))){constructor(e){if(super(e),this.dataPreloadedInLocalCache=!1,this.defaultLinkChartConfig=null,this._currentLinkChartConfig={layoutMode:"RADIAL_TREE"},this._graphTypeLookup=new Map,this.dataManager=null,this.knowledgeGraph=null,this.layers=new(a.ofType(C)),this.entityLinkChartDiagramLookup=new Map,this.relationshipLinkChartDiagramLookup=new Map,this.linkChartExtent=new _({xmin:-1e-7,ymin:-1e-7,xmax:1e-7,ymax:1e-7}),this.memberEntityTypes=null,this.memberRelationshipTypes=null,this.operationalLayerType="LinkChartLayer",this.sublayerIdsCache=new Map,this.tables=new(a.ofType(C)),this.type="link-chart",this.chronologicalAuxiliaryGraphics=null,this._originalInclusionList=e?.inclusionModeDefinition,e?.dataPreloadedInLocalCache&&!e?.inclusionModeDefinition)throw new i("knowledge-graph:linkchart-layer-constructor","If creating a link chart composite layer and configured that data is already loaded in the cache, you must specify an inclusion list so the Composite Layer knows what records belong to it");this.addHandles(l.watch((()=>this.layers.concat(this.tables)),((e,t)=>this._handleSublayersChange(e,t)),l.sync))}normalizeCtorArgs(e){if(!e)return{};const{url:t,title:a,dataPreloadedInLocalCache:i,defaultLinkChartConfig:n}=e;return{url:t,title:a,dataPreloadedInLocalCache:i,defaultLinkChartConfig:n}}_initializeLayerProperties(e){if(!this.title&&this.url){const e=this.url.split("/");this.title=e[e.length-2]}const t=new Set;let a=[],o=[];if(e.inclusionModeDefinition&&(!e.inclusionModeDefinition.namedTypeDefinitions||e.inclusionModeDefinition.namedTypeDefinitions.size<1))throw new i("knowledge-graph:composite-layer-constructor","If an explicit inclusion definition is defined, at least one namedTypeDefinition must also be defined");e.knowledgeGraph.dataModel.entityTypes?.forEach((e=>{e.name&&this._graphTypeLookup.set(e.name,e)})),e.knowledgeGraph.dataModel.relationshipTypes?.forEach((e=>{e.name&&this._graphTypeLookup.set(e.name,e)})),e.inclusionModeDefinition?.generateAllSublayers?(a=e.knowledgeGraph.dataModel.entityTypes??[],o=e.knowledgeGraph.dataModel.relationshipTypes??[]):e.inclusionModeDefinition?.namedTypeDefinitions&&e.inclusionModeDefinition?.namedTypeDefinitions.size>0?e.inclusionModeDefinition?.namedTypeDefinitions.forEach(((i,s)=>{const r=this._graphTypeLookup.get(s);if(!r)return n.getLogger(this).warn(`A named type, ${s}, was in the inclusion list that wasn't in the data model and will be removed`),void e.inclusionModeDefinition?.namedTypeDefinitions.delete(s);"relationship"===r.type?t.has(s)||(t.add(s),o.push(r)):"entity"===r.type?t.has(s)||(t.add(s),a.push(r)):(n.getLogger(this).warn(`A named type, ${s}, was in the inclusion list that wasn't properly modeled and will be removed`),e.inclusionModeDefinition?.namedTypeDefinitions.delete(s))})):(a=e.knowledgeGraph.dataModel.entityTypes??[],o=e.knowledgeGraph.dataModel.relationshipTypes??[]);const s=new f.KnowledgeGraphLayerDataManager({knowledgeGraph:e.knowledgeGraph,inclusionModeDefinition:e.inclusionModeDefinition});this.knowledgeGraph=e.knowledgeGraph,this.memberEntityTypes=a,this.memberRelationshipTypes=o,this.dataManager=s}load(e){const t=async()=>{const e=[],t=[];this.loadLayerAssumingLocalCache(),await N.initializeLayersFromClientData(this),this.dataManager.inclusionModeDefinition&&(this.dataManager.inclusionModeDefinition.generateAllSublayers=!1),this.dataManager.inclusionModeDefinition?.namedTypeDefinitions.forEach((e=>{e.useAllData=!1})),await this._initializeDiagram(),this.layers.forEach((a=>{t.push(a.refreshCachedQueryEngine()),e.push(new Promise((e=>{a.on("layerview-create",(()=>{e(null)}))})))})),this.tables.forEach((e=>{t.push(e.refreshCachedQueryEngine())})),await Promise.all(t)};return this.addResolvingPromise(new Promise((a=>{E.fetchKnowledgeGraph(this.url).then((async i=>{if(this._initializeLayerProperties({knowledgeGraph:i,inclusionModeDefinition:this._originalInclusionList}),this.dataManager.inclusionModeDefinition?.namedTypeDefinitions?.size||(this.dataManager.inclusionModeDefinition={generateAllSublayers:!1,namedTypeDefinitions:new Map},this.dataManager.knowledgeGraph.dataModel.entityTypes?.forEach((e=>{e.name&&this.dataManager.inclusionModeDefinition?.namedTypeDefinitions.set(e.name,{useAllData:!0})})),this.dataManager.knowledgeGraph.dataModel.relationshipTypes?.forEach((e=>{e.name&&this.dataManager.inclusionModeDefinition?.namedTypeDefinitions.set(e.name,{useAllData:!0})}))),this.dataPreloadedInLocalCache){const e=w.getInstance();for(const[t,a]of this.dataManager.inclusionModeDefinition?.namedTypeDefinitions??[])for(const i of a.members?.values()??[]){const a=e.readFromStoreById(`${t}__${i.id}`);if(a){o.getOrCreateMapValue(this.dataManager.sublayerCaches,t,(()=>new Map)).set(i.id,a)}}await t()}else{const a="GEOGRAPHIC"===this.defaultLinkChartConfig?.layoutMode;this.addResolvingPromise(this.dataManager.refreshCacheContent(void 0,!1,a,!0).then((async()=>{r.throwIfAborted(e),await t()})))}a(null)}))}))),Promise.resolve(this)}set inclusionModeDefinition(e){"loaded"!==this.loadStatus&&"failed"!==this.loadStatus?this._set("inclusionModeDefinition",e):n.getLogger(this).error("#inclusionModeDefinition","inclusionModeDefinition cannot be changed after the layer is loaded.")}async addRecords(e,t){let a=[];t?.cascadeAddRelationshipEndNodes&&this.dataManager.knowledgeGraph.dataModel&&(a=await M.getRelationshipEndNodeIds(e,this.dataManager.knowledgeGraph));const i=e.concat(a).filter((e=>!this.sublayerIdsCache.get(e.typeName)?.has(e.id)));await this._handleNewRecords(i)}async removeRecords(e,{cascadeRemoveRelationships:t=!0,recalculateLayout:a=!1}={cascadeRemoveRelationships:!0,recalculateLayout:!1}){let i=[];for(const o of e)!1===this.dataManager.inclusionModeDefinition?.namedTypeDefinitions?.get(o.typeName)?.useAllData&&this.dataManager.inclusionModeDefinition?.namedTypeDefinitions?.get(o.typeName)?.members?.has(o.id)&&i.push(o);if(t){const e=new Set,t=[];for(const a of i)if(this.dataManager.nodeConnectionsLookup.has(a.id))for(const t of this.dataManager.nodeConnectionsLookup.get(a.id))e.add(t);for(const a of e)if(this.dataManager.memberIdTypeLookup.has(a))for(const e of this.dataManager.memberIdTypeLookup.get(a))this.dataManager.relationshipTypeNames.has(e)&&t.push({id:a,typeName:e});i=i.concat(t)}this.dataManager.removeFromLayer(i);for(const o of i)this.sublayerIdsCache.get(o.typeName)?.delete(o.id),this.dataManager.relationshipTypeNames.has(o.typeName)?this.relationshipLinkChartDiagramLookup.delete(o.id):this.entityLinkChartDiagramLookup.delete(o.id);a&&await this._calculateLayoutWithSublayerTimeInfo(this._currentLinkChartConfig.layoutMode,this._currentLinkChartConfig.layoutOptions);const n=[];return this.layers.forEach((e=>{n.push(e.refreshCachedQueryEngine())})),await Promise.all(n),this._refreshNamedTypes(),i}async expand(e,t){const a=await this.dataManager.getConnectedRecordIds(e,t),i=a.filter((e=>!this.sublayerIdsCache.get(e.typeName)?.has(e.id)));return await this._handleNewRecords(a),{records:i}}loadLayerAssumingLocalCache(){const e=[...this.memberRelationshipTypes,...this.memberEntityTypes];this.originIdOf("layers")===c.OriginId.DEFAULTS?this._createSublayers(e,this.layers,(e=>!!e.geometryType)):this._updateSublayers(e,this.layers),this.originIdOf("tables")===c.OriginId.DEFAULTS?this._createSublayers(e,this.tables,(e=>!e.geometryType)):this._updateSublayers(e,this.tables),this.dataManager.inclusionModeDefinition?.namedTypeDefinitions?.forEach(((e,t)=>{const a=o.getOrCreateMapValue(this.sublayerIdsCache,t,(()=>new Set));e.members?.forEach((({id:e,linkChartLocation:i})=>{if(a.add(e),i){const a=i instanceof m?i:g.convertFromGeometry(i);this.dataManager.relationshipTypeNames.has(t)?this.relationshipLinkChartDiagramLookup.set(e,a):this.entityLinkChartDiagramLookup.set(e,a)}}))}))}async calculateLinkChartLayout(e="RADIAL_TREE",t){const a=[],o=[],s=[];this.dataManager.sublayerCaches.forEach(((e,t)=>{this.dataManager.entityTypeNames.has(t)?e.forEach((e=>{a.push({typeName:t,feature:e})})):this.dataManager.relationshipTypeNames.has(t)&&e.forEach((e=>{o.push({typeName:t,feature:e})}))})),this.entityLinkChartDiagramLookup=new Map,this.relationshipLinkChartDiagramLookup=new Map;const r=new Map,l=new Map,d=new Map,h=new Map,y=new Uint8Array(a.length),u=new Float64Array(a.length),c=new Float64Array(a.length),p=new Float64Array(a.length),m=new Float64Array(a.length),L=new Uint32Array(o.length),f=new Uint32Array(o.length),C=new Float64Array(o.length),w=new Float64Array(o.length),M=[],b="FORCE_DIRECTED",k=new _({xmin:-1e-7,ymin:-1e-7,xmax:1e-7,ymax:1e-7});let T,E="FORCE_DIRECTED",G=0,x=0;const R=I.LCChronologicalLayout.apply;switch(E="GEOGRAPHIC"===e?b:e,E){case"FORCE_DIRECTED":T=I.LCForceDirectedLayout.apply;break;case"COMMUNITY":T=I.LCCommunityLayout.apply;break;case"HIERARCHICAL":T=I.LCHierarchicalLayout.apply;break;case"RADIAL_TREE":T=I.LCRadialTreeLayout.apply;break;case"SMART_TREE":T=I.LCSmartTreeLayout.apply;break;default:T=I.LCSimpleLayout.apply}let S=!1;a.forEach((({typeName:a,feature:i})=>{if("CHRONOLOGICAL_SINGLE"!==e&&"CHRONOLOGICAL_MULTIPLE"!==e&&t?.lockedNodeLocations?.has(i.attributes[N.systemOidFieldName])){"GEOGRAPHIC"===e&&this.dataManager.geographicLookup.has(a)?y[G]=I.NodeFlag.IsGeographic:y[G]=I.NodeFlag.None;const n=t.lockedNodeLocations.get(i.attributes[N.systemOidFieldName]);u[G]=n.x,c[G]=n.y}else if("GEOGRAPHIC"===e&&this.dataManager.geographicLookup.has(a)){y[G]=I.NodeFlag.IsGeographic;let e=null;const t=i.attributes[this.dataManager.geographicLookup.get(a).name],n=this.dataManager.geographicLookup.get(a)?.geometryType;switch(n){case"esriGeometryPoint":u[G]=t?.x,c[G]=t?.y;break;case"esriGeometryPolygon":e=t?.centroid,null!=e?.x&&null!=e?.y?(u[G]=e.x,c[G]=e.y):y[G]=I.NodeFlag.IsMovable;break;case"esriGeometryPolyline":case"esriGeometryMultipoint":e=t?.extent?.center,null!=e?.x&&null!=e?.y?(u[G]=e.x,c[G]=e.y):y[G]=I.NodeFlag.IsMovable;break;default:y[G]=I.NodeFlag.IsMovable}(null==u[G]||null==c[G]||Number.isNaN(u[G])||Number.isNaN(c[G]))&&(y[G]=I.NodeFlag.IsMovable,u[G]=0,c[G]=0)}else if("CHRONOLOGICAL_SINGLE"===e||"CHRONOLOGICAL_MULTIPLE"===e){!S&&t?.lockedNodeLocations?.has(i.attributes[N.systemOidFieldName])&&(S=!0);const e=t?.timeInfoByTypeName?.get(a),n=e?.startField,o=n&&e?.startField?i.attributes[n]:null;p[G]=o?new Date(o).getTime():NaN;const s=e?.endField,r=s&&e?.endField?i.attributes[s]:null;m[G]=r?new Date(r).getTime():NaN,u[G]=0,c[G]=0,y[G]=I.NodeFlag.IsMovable}else y[G]=I.NodeFlag.IsMovable,u[G]=0,c[G]=0;h.set(i.attributes[N.systemOidFieldName],G),M[G]={feature:i,typeName:a},G++})),S&&n.getLogger(this).warn("Locked node locations are not supported for chronological layout at this time.  Requested node locations were ignored");let v=!1;const A=new Map;o.forEach((a=>{const i=a.feature.attributes[N.systemOriginIdFieldName],n=a.feature.attributes[N.systemDestinationIdFieldName],o=h.get(i),r=h.get(n),l=t?.timeInfoByTypeName?.get(a.typeName),d=t?.timeInfoByTypeName?l?.startField:null,y=d?a.feature.attributes[d]:null,u=l?.endField,c=u?a.feature.attributes[u]:null;if(void 0!==o&&void 0!==r){let t=i+"-"+n;"CHRONOLOGICAL_SINGLE"!==e&&"CHRONOLOGICAL_MULTIPLE"!==e||(t=t+"-"+y+"-"+c);const l=A.get(t),d=l?.has(a.typeName);d||(L[x]=o,f[x]=r,"CHRONOLOGICAL_SINGLE"!==e&&"CHRONOLOGICAL_MULTIPLE"!==e||(C[x]=y?new Date(y).getTime():NaN,w[x]=c?new Date(c).getTime():NaN),void 0===l?A.set(t,new Map([[a.typeName,x]])):l.set(a.typeName,x),x++),s.push(a)}else v=!0,this.relationshipLinkChartDiagramLookup.set(i,null)})),v&&n.getLogger(this).warn("A relationship is a member of this layer that has either origin or destination entity nodes that are not members. The diagram geometry will be set to null");const F=this._validateLayoutSettings(e,t),P=this._convertLayoutSettingsToCalculationSettings(F);await I.load();let H=!1,U=null;if("CHRONOLOGICAL_SINGLE"===e||"CHRONOLOGICAL_MULTIPLE"===e){let a;({success:H,links:U,graphics:a}=R(y,u,c,p,m,L.subarray(0,x),f.subarray(0,x),C.subarray(0,x),w.subarray(0,x),"CHRONOLOGICAL_MULTIPLE"===e,t?.chronologicalLayoutSettings??{})),H&&(this.chronologicalAuxiliaryGraphics=a)}else({success:H,links:U}=T(y,u,c,L.subarray(0,x),f.subarray(0,x),P.computationBudgetTime,P.idealEdgeLengthMultiplier,P.repulsionRadiusMultiplier));if(!H)throw new i("knowledge-graph:layout-failed","Attempting to arrange the records in the specified layout failed");for(let i=0;i<M.length;i++){if(c[i]>84.9999?c[i]=84.9999:c[i]<-84.9999&&(c[i]=-84.9999),u[i]>179.9999?u[i]=179.9999:u[i]<-179.9999&&(u[i]=-179.9999),M[i].feature.attributes[N.systemLayoutGeometryFieldName]=new O(u[i],c[i]),r.has(M[i].typeName)){const e=r.get(M[i].typeName);e?.set(M[i].feature.attributes[N.systemOidFieldName],M[i].feature)}else{const e=new Map;e.set(M[i].feature.attributes[N.systemOidFieldName],M[i].feature),r.set(M[i].typeName,e)}d.set(M[i].feature.attributes[N.systemOidFieldName],M[i].feature);const e=g.convertFromGeometry(M[i].feature.attributes[N.systemLayoutGeometryFieldName]);this.entityLinkChartDiagramLookup.set(M[i].feature.attributes[N.systemOidFieldName],M[i].feature.attributes[N.systemLayoutGeometryFieldName]?e:null),M[i].feature.attributes[N.systemLayoutGeometryFieldName].x<k.xmin&&(k.xmin=M[i].feature.attributes[N.systemLayoutGeometryFieldName].x),M[i].feature.attributes[N.systemLayoutGeometryFieldName].x>k.xmax&&(k.xmax=M[i].feature.attributes[N.systemLayoutGeometryFieldName].x),M[i].feature.attributes[N.systemLayoutGeometryFieldName].y<k.ymin&&(k.ymin=M[i].feature.attributes[N.systemLayoutGeometryFieldName].y),M[i].feature.attributes[N.systemLayoutGeometryFieldName].y>k.ymax&&(k.ymax=M[i].feature.attributes[N.systemLayoutGeometryFieldName].y)}if(this.linkChartExtent.xmin=k.xmin,this.linkChartExtent.xmax=k.xmax,this.linkChartExtent.ymin=k.ymin,this.linkChartExtent.ymax=k.ymax,!U)throw new i("knowledge-graph:layout-failed","Attempting to retrieve link geometry from diagram engine failed");const B=new Map,z=new Map,j=new Map,W=new Set;for(let i=0;i<s.length;i++){const a=[],o=s[i],r=o.feature.attributes[N.systemOriginIdFieldName],y=o.feature.attributes[N.systemDestinationIdFieldName];let u=r+"-"+y;if("CHRONOLOGICAL_SINGLE"===e||"CHRONOLOGICAL_MULTIPLE"===e){const e=t?.timeInfoByTypeName?.get(o.typeName),a=t?.timeInfoByTypeName?e?.startField:null,i=a?o.feature.attributes[a]:null,n=e?.endField;u+="-"+i+"-"+(n?o.feature.attributes[n]:null)}const c=A.get(u).get(o.typeName),p=0===c?0:U?.vertexEndIndex[c-1];if(!W.has(c)){if(W.add(c),U.types[c]===I.LinkType.Recursive){const e=[U.vertices[2*p],U.vertices[2*p+1]],t=[U.vertices[2*(p+1)],U.vertices[2*(p+1)+1]],i=[.5*(e[0]+t[0]),.5*(e[1]+t[1])],n=[i[0]-e[0],i[1]-e[1]],o=[i[0]+n[1],i[1]-n[0]],s=[i[0]-n[1],i[1]+n[0]];a.push(e),a.push(o),a.push(t),a.push(s),a.push(e)}else{if(U.types[c]!==I.LinkType.Regular){n.getLogger(this).warn("A relationship generated an unsupported link geometry type.  It will not be rendered");continue}for(let e=p;e<U.vertexEndIndex[c];e++)a.push([U.vertices[2*e],U.vertices[2*e+1]])}if("CHRONOLOGICAL_SINGLE"!==e&&"CHRONOLOGICAL_MULTIPLE"!==e){const e=M[h.get(r)]?.feature.attributes[N.systemLayoutGeometryFieldName],t=M[h.get(y)]?.feature.attributes[N.systemLayoutGeometryFieldName];a[0][0]===e.x&&a[0][1]===e.y||(a[0]=[e.x,e.y]),a[a.length-1][0]===t.x&&a[a.length-1][1]===t.y||(a[a.length-1]=[t.x,t.y])}for(let e=1;e<a.length-1;e++)a[e][1]>85.5?a[e][1]=85.5:a[e][1]<-85.5&&(a[e][1]=-85.5),a[e][0]>179.9999?a[e][0]=179.9999:a[e][0]<-179.9999&&(a[e][0]=-179.9999);B.has(u)?B.get(u).push(a):B.set(u,[a])}const m=B.get(u);z.has(u)||(z.set(u,new Map),j.set(u,new Map));const L=z.get(u),f=j.get(u);L.has(o.typeName)||(L.set(o.typeName,m.shift()),f.set(o.typeName,0));const C=L.get(o.typeName);f.set(o.typeName,f.get(o.typeName)+1);const w=new D({paths:[C]});if(o.feature.attributes[N.systemLayoutGeometryFieldName]=w,l.has(o.typeName)){const e=l.get(o.typeName);e?.set(o.feature.attributes[N.systemOidFieldName],o.feature)}else{const e=new Map;e.set(o.feature.attributes[N.systemOidFieldName],o.feature),l.set(o.typeName,e)}d.set(o.feature.attributes[N.systemOidFieldName],o.feature);const b=g.convertFromGeometry(o.feature.attributes[N.systemLayoutGeometryFieldName]);this.relationshipLinkChartDiagramLookup.set(o.feature.attributes[N.systemOidFieldName],o.feature.attributes[N.systemLayoutGeometryFieldName]?b:null)}for(const i of s)i.feature.attributes[N.systemAggregationCountFieldName]=j.get(i.feature.attributes[N.systemOriginIdFieldName]+"-"+i.feature.attributes[N.systemDestinationIdFieldName])?.get(i.typeName)??null;return this._currentLinkChartConfig={layoutMode:e,layoutOptions:F},{nodes:r,links:l,idMap:d}}async applyNewLinkChartLayout(e="RADIAL_TREE",t){const a=[];await this._calculateLayoutWithSublayerTimeInfo(e,t),this.layers.forEach((e=>{a.push(e.refreshCachedQueryEngine())})),await Promise.all(a),this._refreshNamedTypes()}getCurrentNodeLocations(){const e=new Map;return this.dataManager.inclusionModeDefinition?.namedTypeDefinitions?.forEach((t=>{t?.members?.forEach((t=>{const a=t.linkChartLocation;let i;const n=t.id;a&&(i="x"in a?{x:a.x,y:a.y}:{x:a.coords[0],y:a.coords[1]},e.set(n,new O({x:i.x,y:i.y})))}))})),e}async synchronizeInclusionListWithCache(){return new Promise((e=>{this.dataManager.inclusionModeDefinition?.namedTypeDefinitions.forEach(((e,t)=>{if(e.useAllData=!1,e.members&&e.members.size>0){if(!this.dataManager.sublayerCaches.get(t))return;const a=new Set(Array.from(this.dataManager.sublayerCaches.get(t).keys()));Array.from(e.members.keys()).filter((e=>!a.has(e))).forEach((t=>{e.members?.delete(t)}))}})),e()}))}async refreshLinkChartCache(e){await this.dataManager.refreshCacheContent(e);const t=[];this.layers.forEach((e=>{t.push(e.refreshCachedQueryEngine())})),await Promise.all(t),this._refreshNamedTypes()}async connectBetweenEntities(e){let t=[];for(const i of this.dataManager.relationshipTypeNames){const e=this.sublayerIdsCache.get(i);e&&(t=t.concat(Array.from(e.keys())))}const a=await this.dataManager.getRelationshipsBetweenNodes(e,t);return await this._handleNewRecords(a),{records:a}}async connectFromEntities(e){let t=[];for(const n of this.dataManager.relationshipTypeNames){const e=this.sublayerIdsCache.get(n);e&&(t=t.concat(Array.from(e.keys())))}let a=[];for(const n of this.dataManager.entityTypeNames){const e=this.sublayerIdsCache.get(n);e&&(a=a.concat(Array.from(e)))}const i=await this.dataManager.getRelationshipsFromNodes(e,a,t);return await this._handleNewRecords(i),{records:i}}getCurrentLayout(){return this._currentLinkChartConfig.layoutMode}async _calculateLayoutWithSublayerTimeInfo(e="RADIAL_TREE",t){const a=new Map;this.layers.forEach((e=>{a.set(e.objectType.name,e.timeInfo)})),await this.calculateLinkChartLayout(e,{timeInfoByTypeName:a,...t})}async _handleNewRecords(e){const t=[];this.dataManager.addToLayer(e);for(const i of e)this.sublayerIdsCache.has(i.typeName)||(this.sublayerIdsCache.set(i.typeName,new Set),t.push(i.typeName)),this.sublayerIdsCache.get(i.typeName).add(i.id);for(const i of t){const e=this._graphTypeLookup.get(i);if(e){const t=this._createSublayer(e);"entity"===e.type?this.dataManager.entityTypeNames.add(i):this.dataManager.relationshipTypeNames.add(i),t.geometryType?this.layers.push(t):this.tables.push(t),this.dataManager.sublayerCaches.set(i,new Map)}}await N.initializeLayersFromClientData(this,t),await this.dataManager.refreshCacheContent(e.map((e=>e.id)));const a=Object.assign({},this._currentLinkChartConfig.layoutOptions);a.lockedNodeLocations=new Map;for(const[i,n]of this.entityLinkChartDiagramLookup.entries())n&&a.lockedNodeLocations.set(i,new O(n.coords[0],n.coords[1]));await this.applyNewLinkChartLayout(this._currentLinkChartConfig.layoutMode,a)}_createSublayers(e,t,a){e.forEach((e=>{const i=this._createSublayer(e);a(i)&&t.push(i),this._updateSublayerCaches(e)}))}_updateSublayers(e,t){t.forEach((t=>{t.parentCompositeLayer=this;const a=e.find((e=>e.type===t.graphType&&e.name===t.graphTypeName));a&&(t.objectType=a,t.read({title:a.name},{origin:"service"}),this._updateSublayerCaches(a))}))}_updateSublayerCaches(e){const t=this.dataManager.sublayerCaches;t.has(e.name)||t.set(e.name,new Map)}async _initializeDiagram(){this.defaultLinkChartConfig?this.defaultLinkChartConfig.doNotRecalculateLayout?(this.dataManager.inclusionModeDefinition?.namedTypeDefinitions?.forEach(((e,t)=>{e?.members?.forEach((e=>{const a=e.linkChartLocation;let i;const n=e.id;if(!a)return;i="x"in a?{x:a.x,y:a.y}:{x:a.coords[0],y:a.coords[1]};const o=g.convertFromGeometry(i);this.dataManager.relationshipTypeNames.has(t)?this.relationshipLinkChartDiagramLookup.set(n,o):this.entityLinkChartDiagramLookup.set(n,o),this.linkChartExtent.xmin>i.x&&(this.linkChartExtent.xmin=i.x),this.linkChartExtent.xmax<i.x&&(this.linkChartExtent.xmax=i.x),this.linkChartExtent.ymin>i.y&&(this.linkChartExtent.ymin=i.y),this.linkChartExtent.ymax<i.y&&(this.linkChartExtent.ymax=i.y)}))})),this.memberRelationshipTypes.forEach((e=>{e.name&&this.dataManager.sublayerCaches.get(e.name)?.forEach((e=>{const t=this.relationshipLinkChartDiagramLookup.get(e.attributes[N.systemOriginIdFieldName]),a=this.relationshipLinkChartDiagramLookup.get(e.attributes[N.systemDestinationIdFieldName]);if(t&&a){const i=g.convertFromGeometry(new D({paths:[[[t.coords[0],t.coords[1]],[a.coords[0],a.coords[1]]]]}));this.relationshipLinkChartDiagramLookup.set(e.attributes[N.systemOidFieldName],i)}else this.relationshipLinkChartDiagramLookup.set(e.attributes[N.systemOidFieldName],null)}))}))):await this._calculateLayoutWithSublayerTimeInfo(this.defaultLinkChartConfig.layoutMode,{lockedNodeLocations:this.getCurrentNodeLocations(),...this.defaultLinkChartConfig.layoutOptions||{}}):await this._calculateLayoutWithSublayerTimeInfo("RADIAL_TREE",{lockedNodeLocations:this.getCurrentNodeLocations()})}_refreshNamedTypes(){for(const e of this.layers)e.emit("refresh",{dataChanged:!0});for(const e of this.tables)e.emit("refresh",{dataChanged:!0})}_validateLayoutSettings(e,t){const a=e=>"number"==typeof e&&!isNaN(e),i=e=>a(e)&&e>=1,o=e=>a(e)&&e>=1,s=e=>Object.values(L.IdealEdgeLengthTypeOptions).includes(e),r=e=>a(e)&&e>=0,l={organicLayoutSettings:{},chronologicalLayoutSettings:{}};if(!new Set(["FORCE_DIRECTED","COMMUNITY","GEOGRAPHIC","CHRONOLOGICAL_MULTIPLE","CHRONOLOGICAL_SINGLE"]).has(e)||!t)return l;t.organicLayoutSettings??={};const{computationBudgetTime:d,repulsionRadiusMultiplier:h,idealEdgeLength:y,idealEdgeLengthType:u}=t.organicLayoutSettings;o(d)?l.organicLayoutSettings.computationBudgetTime=d:void 0!==d&&n.getLogger(this).warn("Invalid layout computationBudgetTime setting, will revert to default setting"),i(h)?l.organicLayoutSettings.repulsionRadiusMultiplier=h:void 0!==h&&n.getLogger(this).warn("Invalid layout repulsionRadiusMultiplier setting, will revert to default setting");if("GEOGRAPHIC"===e&&(void 0!==y||void 0!==u)&&(s(u)?l.organicLayoutSettings.idealEdgeLengthType=u:void 0!==u&&n.getLogger(this).warn('Invalid layout idealEdgeLengthType setting, will revert to "multiplier" setting'),r(y)?l.organicLayoutSettings.idealEdgeLength=y:void 0!==y&&n.getLogger(this).warn("Invalid layout idealEdgeLength setting, will revert to default setting")),("CHRONOLOGICAL_MULTIPLE"===e||"CHRONOLOGICAL_SINGLE"===e)&&t.chronologicalLayoutSettings){const e=t.chronologicalLayoutSettings;e.durationLineWidth&&e.durationLineWidth<0&&n.getLogger(this).warn("Invalid layout durationLineWidth setting, will revert to default setting")}return l}_convertLayoutSettingsToCalculationSettings(e){e.organicLayoutSettings??={};let t=e.organicLayoutSettings.idealEdgeLength;return e.organicLayoutSettings.idealEdgeLengthType===L.IdealEdgeLengthTypeOptions.ABSOLUTE&&(void 0===t?t=-1:t*=-1),{computationBudgetTime:e.organicLayoutSettings.computationBudgetTime,repulsionRadiusMultiplier:e.organicLayoutSettings.repulsionRadiusMultiplier,idealEdgeLengthMultiplier:t}}_createSublayer(e){return new C({objectType:e,parentCompositeLayer:this,graphType:e.type})}_handleSublayersChange(e,t){t&&(t.forEach((e=>{e.parent=null})),this.removeHandles("sublayers-owner")),e&&(e.forEach((e=>{e.parent=this})),this.addHandles([e.on("after-add",(({item:e})=>{e.parent=this})),e.on("after-remove",(({item:e})=>{e.parent=null}))],"sublayers-owner"))}};e.__decorate([d.property()],G.prototype,"dataPreloadedInLocalCache",void 0),e.__decorate([d.property()],G.prototype,"defaultLinkChartConfig",void 0),e.__decorate([d.property()],G.prototype,"dataManager",void 0),e.__decorate([d.property()],G.prototype,"inclusionModeDefinition",null),e.__decorate([d.property()],G.prototype,"knowledgeGraph",void 0),e.__decorate([d.property({type:a.ofType(C),json:{write:{ignoreOrigin:!0}}})],G.prototype,"layers",void 0),e.__decorate([d.property()],G.prototype,"entityLinkChartDiagramLookup",void 0),e.__decorate([d.property()],G.prototype,"relationshipLinkChartDiagramLookup",void 0),e.__decorate([d.property()],G.prototype,"linkChartExtent",void 0),e.__decorate([d.property()],G.prototype,"memberEntityTypes",void 0),e.__decorate([d.property()],G.prototype,"memberRelationshipTypes",void 0),e.__decorate([d.property({type:["LinkChartLayer"]})],G.prototype,"operationalLayerType",void 0),e.__decorate([d.property()],G.prototype,"sublayerIdsCache",void 0),e.__decorate([d.property({type:a.ofType(C),json:{write:{ignoreOrigin:!0}}})],G.prototype,"tables",void 0),e.__decorate([d.property({json:{read:!1}})],G.prototype,"type",void 0),e.__decorate([d.property({json:{read:!1}})],G.prototype,"chronologicalAuxiliaryGraphics",void 0),G=e.__decorate([u.subclass("esri.layers.LinkChartLayer")],G);return G}));
