/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../request","../core/Accessor","../core/Logger","../core/promiseUtils","../core/reactiveUtils","../core/scheduling","../core/accessorSupport/decorators/property","../core/has","../core/RandomLCG","../core/accessorSupport/decorators/subclass","./ILyr3DWasmPerSceneView","./Lyr3DWorkerHandle","../libs/lyr3d/Lyr3DModule","../support/elevationInfoUtils","../views/3d/layers/support/makeScheduleFunction"],(function(e,t,r,i,s,a,n,o,l,d,h,u,_,y,c,g){"use strict";var b,m;!function(e){e[e.Lifetime=0]="Lifetime",e[e.Jobs=1]="Jobs",e[e.Renderables=2]="Renderables"}(b||(b={})),function(e){e[e.Critical=0]="Critical",e[e.Error=1]="Error",e[e.Warning=2]="Warning",e[e.Info=3]="Info"}(m||(m={}));let w=class extends r{constructor(e){super(e),this._lyr3DMainPromise=null,this._lyr3DMain=null,this._layers=new Map,this._debugFlags=new Set,this._debugLevel=m.Critical,this._wasmNotLoaded="method requiring WASM was called when WASM isn't loaded",this._pulseTaskHandle=null,this._session=null,this._debugFlags.add(b.Lifetime),this._debugFlags.add(b.Jobs),this._debugFlags.add(b.Renderables)}_debugLog(e,t,r,s=!0){if(this._debugFlags.has(e)&&this._debugLevel>=t){const e=s?`[js] ${r}`:`${r}`;t===m.Critical||t===m.Error?i.getLogger(this).error(e):t===m.Warning&&i.getLogger(this).warn(e),i.getLogger(this).info(e)}}initialize(){this._debugLevel>m.Warning&&(i.getLogger(this).level="info"),this._debugLog(b.Lifetime,m.Info,"Lyr3DWasmPerSceneView.initialize()"),this.addHandles([a.watch((()=>this.view.state?.contentCamera),(()=>this._updateWasmCamera()))]),this._pulseTaskHandle=n.addFrameTask({preRender:()=>this._pulseTask()})}destroy(){this._debugLog(b.Lifetime,m.Info,"Lyr3DWasmPerSceneView.destroy()"),this._lyr3DMain&&(this._layers.forEach((e=>{e.abortController.abort()})),this._lyr3DMain.uninitialize_lyr3d_wasm(),this._lyr3DMain=null);const e=this._worker;e&&e.destroyWasm().then((()=>{this._worker?.destroy(),this._worker=null})),this._pulseTaskHandle?.remove(),this._pulseTaskHandle=null}add3DTilesLayerView(e){return this._lyr3DMain?this._add3DTilesLayerView(e):(this._debugLog(b.Lifetime,m.Error,"Lyr3DWasmPerSceneView.add3DTilesLayerView() called when WASM wasn't initialized"),u.wasmFailedToInit)}remove3DTilesLayerView(e){if(!this._lyr3DMain)return this._debugLog(b.Lifetime,m.Error,this._wasmNotLoaded),0;this._doRemoveLayerView(e);const t=this._layers.size;return 0===t&&(this._debugLog(b.Lifetime,m.Info,"Lyr3DWasmPerSceneView.remove3DTilesLayerView() no Lyr3D layers left after removing a layer, destroying"),this.destroy()),t}setEnabled(e,t){if(!this._lyr3DMain)return void this._debugLog(b.Lifetime,m.Error,this._wasmNotLoaded);const r=this._layers.get(e.wasmLayerId);r&&(this._lyr3DMain.set_enabled(e.wasmLayerId,t),r.needMemoryUsageUpdate=!0,r.needFrame=!0,r.layerView.updatingFlagChanged())}setLayerOffset(e,t){if(!this._lyr3DMain)return void this._debugLog(b.Lifetime,m.Error,this._wasmNotLoaded);this._layers.get(e.wasmLayerId)&&this._lyr3DMain.set_carto_offset_z(e.wasmLayerId,t)}getAttributionText(){if(!this._lyr3DMain)return this._debugLog(b.Lifetime,m.Error,this._wasmNotLoaded),[];return this._lyr3DMain.get_current_attribution_text().split("|")}onRenderableEvicted(e,t,r){if(!this._lyr3DMain)return void this._debugLog(b.Lifetime,m.Error,this._wasmNotLoaded);this._layers.get(e.wasmLayerId)&&this._lyr3DMain.on_renderable_evicted(e.wasmLayerId,t,r)}isUpdating(e){if(!this._lyr3DMain&&this._lyr3DMainPromise)return!0;const t=this._layers.get(e);return!!t&&(t.outstandingJobCount>0||t.outstandingRenderableCount>0||t.needFrame)}initializeWasm(e){return this._lyr3DMain?Promise.resolve():(this._debugLog(b.Lifetime,m.Info,"Lyr3DWasmPerSceneView.initializeWasm()"),this._lyr3DMainPromise||(this._lyr3DMainPromise=y.loadLyr3DMainWASM().then((t=>{this._lyr3DMain=t,this._lyr3DMainPromise=null;const r=this._lyr3DMain.addFunction(this._onNewJob.bind(this),"v"),i=this._lyr3DMain.addFunction(this._onNewRenderable.bind(this),"v"),s=this._lyr3DMain.addFunction(this._freeRenderables.bind(this),"viii"),a=this._lyr3DMain.addFunction(this._setRenderableVisibility.bind(this),"viiii"),n=this._lyr3DMain.addFunction(this._onWasmError.bind(this),"viiii"),o="global"===this.view.viewingMode,l=this.view.renderSpatialReference?.isWebMercator?3857:this.view.renderSpatialReference?.wkid??-1,d=this.view.heightModelInfo?.heightModel,h=!d||"gravity-related-height"===d;return this._lyr3DMain.initialize_lyr3d_wasm(n,r,i,s,a,e,o,h,l,this._debugLevel)?(this._worker=new _.Lyr3DWorkerHandle(g.makeScheduleFunction(this.view.resourceController)),this._worker.promise?this._worker.promise:void 0):(this._lyr3DMain=null,void this._debugLog(b.Lifetime,m.Critical,"Lyr3d Main WASM failed to initialize",!1))})).catch((e=>{this._debugLog(b.Lifetime,m.Critical,`Lyr3d WASM failed to download error = ${e}`,!1)}))),this._lyr3DMainPromise)}_pulseTask(){if(this._lyr3DMain){let e=0,t=0;this._layers.forEach((r=>{e+=r.layerView.usedMemory,t+=r.layerView.cachedMemory})),e/=1048576,t/=1048576;const r=this.view.resourceController.memoryController,i=r.usedMemory*r.maxMemory-e;this._lyr3DMain.frame_pulse(r.memoryFactor,e,t,i,r.maxMemory),this._layers.forEach((e=>{!0===e.needFrame&&(e.needFrame=!1,e.layerView.updatingFlagChanged())}))}}_incrementJobCount(e){e.outstandingJobCount+=1,1===e.outstandingJobCount&&e.outstandingRenderableCount<1&&e.layerView.updatingFlagChanged()}_decrementJobCount(e){e.outstandingJobCount-=1,0===e.outstandingJobCount&&e.outstandingRenderableCount<1&&e.layerView.updatingFlagChanged()}_incrementRenderableCount(e){e.outstandingRenderableCount+=1,e.outstandingJobCount<1&&1===e.outstandingRenderableCount&&e.layerView.updatingFlagChanged()}_decrementRenderableCount(e){e.outstandingRenderableCount-=1,e.outstandingJobCount<1&&0===e.outstandingRenderableCount&&e.layerView.updatingFlagChanged()}_onJobFailed(e,t,r){t.error.length&&this._debugLog(b.Jobs,m.Error,t.error,!1),this._lyr3DMain&&this._lyr3DMain.on_job_failed(r.jobId,r.desc),this._decrementJobCount(e)}_onJobSucceeded(e,t,r){if(this._lyr3DMain){const e=t.data.byteLength,i=this._lyr3DMain._malloc(e);new Uint8Array(this._lyr3DMain.HEAPU8.buffer,i,e).set(t.data),this._lyr3DMain.on_job_completed(r.jobId,t.jobDescJson,i,e),this._lyr3DMain._free(i)}this._decrementJobCount(e)}_getRequestPromises(e,r,i){const s=[];for(const a of e){const e=new URL(a),n=e.searchParams.get("session");n?this._session=n:!this._session||e.origin===i.origin&&e.pathname===i.pathname||e.searchParams.append("session",this._session),s.push(t(e.toString(),r).then((e=>e.data)))}return s}_onNewJob(){const e=this._lyr3DMain.get_next_job(),t=this._layers.get(e.layerId);if(!t)return;this._incrementJobCount(t);const r=t.abortController.signal,i={responseType:"array-buffer",signal:r,query:{...t.customParameters,token:t.apiKey}},a={inputs:[],jobDescJson:e.desc,isMissingResourceCase:!1},n=new URL(t.layerView.layer.url),o=this._getRequestPromises(e.urls,i,n);Promise.all(o).then((e=>(a.inputs=e,this._worker.invoke(a,r)))).then((e=>e)).catch((t=>(s.isAbortError(t)?this._debugLog(b.Jobs,m.Warning,`job ${e.jobId} was cancelled.`):this._debugLog(b.Jobs,m.Error,`job ${e.jobId} failed with error ${t}.`),{status:u.Lyr3DWasmWorkerOutputStatus.Failed,error:"",jobDescJson:"",data:new Uint8Array(0),missingInputUrls:[],inputs:[]}))).then((o=>{if(o.status===u.Lyr3DWasmWorkerOutputStatus.Failed)this._onJobFailed(t,o,e);else if(o.status===u.Lyr3DWasmWorkerOutputStatus.Succeeded)this._onJobSucceeded(t,o,e);else if(o.status===u.Lyr3DWasmWorkerOutputStatus.MissingInputs){const l=this._getRequestPromises(o.missingInputUrls,i,n);Promise.all(l).then((e=>{a.jobDescJson=o.jobDescJson,o.originalInputs?a.inputs=o.originalInputs:a.inputs=[],a.isMissingResourceCase=!0;for(const t of e)a.inputs.push(t);return this._worker.invoke(a,r)})).then((r=>{r.status===u.Lyr3DWasmWorkerOutputStatus.Failed?this._onJobFailed(t,r,e):r.status===u.Lyr3DWasmWorkerOutputStatus.Succeeded&&this._onJobSucceeded(t,r,e)})).catch((r=>{this._decrementJobCount(t),s.isAbortError(r)?this._debugLog(b.Jobs,m.Warning,`job ${e.jobId} was cancelled.`):this._debugLog(b.Jobs,m.Error,`job ${e.jobId} failed with error2 ${r}.`),this._lyr3DMain&&this._lyr3DMain.on_job_failed(e.jobId,e.desc)}))}}))}_onNewRenderable(){const e=this._lyr3DMain.get_next_renderable(),t=e.meshData;if(t.data&&t.data.byteLength>0){const e=t.data.slice();t.data=e}const r=this._layers.get(e.layerId);r&&(this._incrementRenderableCount(r),r.layerView.createRenderable(e).then((t=>{this._lyr3DMain&&this._lyr3DMain.on_renderable_created(!0,e.layerId,e.handle,t.memUsageBytes),this._decrementRenderableCount(r)})).catch((t=>{s.isAbortError(t)||this._debugLog(b.Renderables,m.Error,`createRenderable failed with error ${t}.`),this._lyr3DMain&&this._lyr3DMain.on_renderable_created(!1,e.layerId,e.handle,0),this._decrementRenderableCount(r)})))}_freeRenderables(e,t,r){if(r<1)return;const i=this._layers.get(e);if(!i)return;const s=i.layerView,a=[],n=new Uint32Array(this._lyr3DMain.HEAPU32.buffer,t,r);for(let o=0;o<r;++o)a.push(n[o]);for(let o=0;o<r;++o)s.freeRenderable(a[o])}_setRenderableVisibility(e,t,r,i){if(i<1)return;const s=this._layers.get(e);if(!s)return;const a=s.layerView,n=[],o=[],l=new Uint32Array(this._lyr3DMain.HEAPU32.buffer,t,i),d=new Uint8Array(this._lyr3DMain.HEAPU8.buffer,r,i);for(let h=0;h<i;++h)n.push(l[h]),o.push(1===d[h]);a.setRenderableVisibility(n,o,i)}_onWasmError(e,t,r,i){this._lyr3DMain&&this._debugLog(r,i,this._lyr3DMain.UTF8ToString(e,t),!1)}_doRemoveLayerView(e){const t=this._layers.get(e.wasmLayerId);return!!t&&(t.abortController.abort(),this._lyr3DMain.remove_layer(e.wasmLayerId),this._layers.delete(e.wasmLayerId),!0)}_add3DTilesLayerView(e){const t=e.layer;if(!t.url)return u.invalidLayerView;const r=this._lyr3DMain.get_next_layer_id(),i=new AbortController;this._layers.set(r,{layerView:e,abortController:i,needMemoryUsageUpdate:!1,outstandingJobCount:0,outstandingRenderableCount:0,customParameters:t.customParameters,apiKey:t.apiKey,needFrame:!1});const s=c.getElevationOffsetInMeters(t.elevationInfo);return this._lyr3DMain.add_layer(t.url,r,s)?(this._updateWasmCamera(),r):(this._layers.delete(r),u.invalidLayerView)}_updateWasmCamera(){const e=this.view.state?.contentCamera;if(!e||!this._lyr3DMain)return;const{eye:t,center:r,up:i,near:s,far:a,fovY:n}=e,o=[e.viewport[2],e.viewport[3]],l=e.width/e.height;this._lyr3DMain.set_camera_parameters({eye:t,center:r,up:i,near:s,far:a,fov:n,aspectRatio:l,viewport:o})}};e.__decorate([o.property({constructOnly:!0})],w.prototype,"view",void 0),w=e.__decorate([h.subclass("esri.layers.Lyr3DWasmPerSceneView")],w);return w}));
