/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../request","../core/Error","../core/loadAll","../core/MultiOriginJSONSupport","../core/promiseUtils","../core/accessorSupport/decorators/property","../core/accessorSupport/ensureType","../core/RandomLCG","../core/has","../core/accessorSupport/decorators/reader","../core/accessorSupport/decorators/subclass","../core/accessorSupport/decorators/writer","../core/accessorSupport/PropertyOrigin","../geometry/Extent","../geometry/support/scaleUtils","../geometry/support/spatialReferenceUtils","./Layer","./mixins/APIKeyMixin","./mixins/ArcGISMapService","./mixins/ArcGISService","./mixins/BlendLayer","./mixins/CustomParametersMixin","./mixins/OperationalLayer","./mixins/PortalLayer","./mixins/RefreshableLayer","./mixins/ScaleRangeLayer","./mixins/SublayersOwner","./mixins/TemporalLayer","./support/commonProperties","./support/ExportImageParameters","./support/imageBitmapUtils","./support/Sublayer","./support/sublayerUtils","./support/versionUtils","../time/TimeExtent","../time/timeZoneUtils"],(function(e,r,t,i,a,o,s,p,n,l,c,y,u,d,m,h,g,S,b,x,_,f,v,I,O,L,P,w,T,E,M,R,A,U,F,N,J){"use strict";let j=class extends(f.BlendLayer(T.TemporalLayer(P.ScaleRangeLayer(w.SublayersOwner(x.ArcGISMapService(_.ArcGISService(I.OperationalLayer(O.PortalLayer(a.MultiOriginJSONMixin(L.RefreshableLayer(b.APIKeyMixin(v.CustomParametersMixin(S))))))))))))){constructor(...e){super(...e),this._exportImageParameters=new M.ExportImageParameters({layer:this}),this.dateFieldsTimeZone=null,this.datesInUnknownTimezone=!1,this.dpi=96,this.gdbVersion=null,this.imageFormat="png24",this.imageMaxHeight=2048,this.imageMaxWidth=2048,this.imageTransparency=!0,this.isReference=null,this.labelsVisible=!1,this.operationalLayerType="ArcGISMapServiceLayer",this.preferredTimeZone=null,this.sourceJSON=null,this.sublayers=null,this.type="map-image",this.url=null}normalizeCtorArgs(e,r){return"string"==typeof e?{url:e,...r}:e}load(e){const r=null!=e?e.signal:null;return this.addResolvingPromise(this.loadFromPortal({supportedTypes:["Map Service"]},e).catch(o.throwIfAbortError).then((()=>this._fetchService(r)))),Promise.resolve(this)}destroy(){this._exportImageParameters.destroy()}readImageFormat(e,r){const t=r.supportedImageFormatTypes;return t&&t.includes("PNG32")?"png32":"png24"}writeSublayers(e,r,t,i){if(!this.loaded||!e)return;const a=e.slice().reverse().flatten((({sublayers:e})=>e&&e.toArray().reverse())).toArray();let o=!1;const s=d.nameToId(i.origin);if(this.capabilities?.operations.supportsExportMap&&this.capabilities?.exportMap?.supportsDynamicLayers)if(s===d.OriginId.PORTAL_ITEM){const e=this.createSublayersForOrigin("service").sublayers;o=U.shouldWriteSublayerStructure(a,e,d.OriginId.SERVICE)}else if(s>d.OriginId.PORTAL_ITEM){const e=this.createSublayersForOrigin("portal-item");o=U.shouldWriteSublayerStructure(a,e.sublayers,d.nameToId(e.origin))}const p=[],n={writeSublayerStructure:o,...i};let l=o||this.hasVisibleLayersForOrigin(s);a.forEach((e=>{const r=e.write({},n);p.push(r),l=l||"user"===e.originOf("visible")}));p.some((e=>Object.keys(e).length>1))&&(r.layers=p),l&&(r.visibleLayers=a.filter((e=>e.visible)).map((e=>e.id)))}createExportImageParameters(e,r,t,i){const a=i?.pixelRatio||1;e&&this.version>=10&&(e=e.clone().shiftCentralMeridian()),this._exportImageParameters.floors=i?.floors??null,this._exportImageParameters.scale=h.getScale({extent:e,width:r})*a;const o=this._exportImageParameters.toJSON(),s=!i?.rotation||this.version<10.3?{}:{rotation:-i.rotation},p=e?.spatialReference,n=g.srToRESTValue(p);o.dpi*=a;const l={};if(i?.timeExtent){const{start:e,end:r}=i.timeExtent.toJSON();l.time=e&&r&&e===r?""+e:`${e??"null"},${r??"null"}`}else this.timeInfo&&!this.timeInfo.hasLiveData&&(l.time="null,null");return{bbox:e&&e.xmin+","+e.ymin+","+e.xmax+","+e.ymax,bboxSR:n,imageSR:n,size:r+","+t,...o,...s,...l}}async fetchImage(e,r,t,i){const{data:a}=await this._fetchImage("image",e,r,t,i);return a}async fetchImageBitmap(e,r,t,i){const{data:a,url:o}=await this._fetchImage("blob",e,r,t,i);return R.createBitmap(a,o,i?.signal)}async fetchRecomputedExtents(e={}){const t={...e,query:{returnUpdates:!0,f:"json",...this.customParameters,token:this.apiKey}},{data:i}=await r(this.url,t),{extent:a,fullExtent:o,timeExtent:s}=i,p=a||o;return{fullExtent:p&&m.fromJSON(p),timeExtent:s&&N.fromJSON({start:s[0],end:s[1]})}}loadAll(){return i.loadAll(this,(e=>{e(this.allSublayers),e(this.subtables)}))}serviceSupportsSpatialReference(e){return F.serviceSupportsSpatialReference(this,e)}async _fetchImage(e,i,a,s,p){const n={responseType:e,signal:p?.signal??null,query:{...this.parsedUrl.query,...this.createExportImageParameters(i,a,s,p),f:"image",...this.refreshParameters,...this.customParameters,token:this.apiKey}},l=this.parsedUrl.path+"/export";if(null!=n.query?.dynamicLayers&&!this.capabilities?.exportMap?.supportsDynamicLayers)throw new t("mapimagelayer:dynamiclayer-not-supported",`service ${this.url} doesn't support dynamic layers, which is required to be able to change the sublayer's order, rendering, labeling or source.`,{query:n.query});try{const{data:e}=await r(l,n);return{data:e,url:l}}catch(c){if(o.isAbortError(c))throw c;throw new t("mapimagelayer:image-fetch-error",`Unable to load image: ${l}`,{error:c})}}async _fetchService(e){if(this.sourceJSON)return void this.read(this.sourceJSON,{origin:"service",url:this.parsedUrl});const{data:t,ssl:i}=await r(this.parsedUrl.path,{query:{f:"json",...this.parsedUrl.query,...this.customParameters,token:this.apiKey},signal:e});i&&(this.url=this.url.replace(/^http:/i,"https:")),this.sourceJSON=t,this.read(t,{origin:"service",url:this.parsedUrl})}hasVisibleLayersForOrigin(e){return!(null==e||!this.sublayersSourceJSON[e]?.visibleLayers)}};e.__decorate([s.property(J.timeZoneProperty("dateFieldsTimeReference"))],j.prototype,"dateFieldsTimeZone",void 0),e.__decorate([s.property({type:Boolean})],j.prototype,"datesInUnknownTimezone",void 0),e.__decorate([s.property()],j.prototype,"dpi",void 0),e.__decorate([s.property()],j.prototype,"gdbVersion",void 0),e.__decorate([s.property()],j.prototype,"imageFormat",void 0),e.__decorate([c.reader("imageFormat",["supportedImageFormatTypes"])],j.prototype,"readImageFormat",null),e.__decorate([s.property({json:{origins:{service:{read:{source:"maxImageHeight"}}}}})],j.prototype,"imageMaxHeight",void 0),e.__decorate([s.property({json:{origins:{service:{read:{source:"maxImageWidth"}}}}})],j.prototype,"imageMaxWidth",void 0),e.__decorate([s.property()],j.prototype,"imageTransparency",void 0),e.__decorate([s.property({type:Boolean,json:{read:!1,write:{enabled:!0,overridePolicy:()=>({enabled:!1})}}})],j.prototype,"isReference",void 0),e.__decorate([s.property({json:{read:!1,write:!1}})],j.prototype,"labelsVisible",void 0),e.__decorate([s.property({type:["ArcGISMapServiceLayer"]})],j.prototype,"operationalLayerType",void 0),e.__decorate([s.property({json:{read:!1,write:!1}})],j.prototype,"popupEnabled",void 0),e.__decorate([s.property(J.timeZoneProperty("preferredTimeReference"))],j.prototype,"preferredTimeZone",void 0),e.__decorate([s.property()],j.prototype,"sourceJSON",void 0),e.__decorate([s.property({json:{write:{ignoreOrigin:!0}}})],j.prototype,"sublayers",void 0),e.__decorate([u.writer("sublayers",{layers:{type:[A]},visibleLayers:{type:[p.Integer]}})],j.prototype,"writeSublayers",null),e.__decorate([s.property({type:["show","hide","hide-children"]})],j.prototype,"listMode",void 0),e.__decorate([s.property({json:{read:!1},readOnly:!0,value:"map-image"})],j.prototype,"type",void 0),e.__decorate([s.property(E.url)],j.prototype,"url",void 0),j=e.__decorate([y.subclass("esri.layers.MapImageLayer")],j);return j}));
