/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../core/Collection","../core/Error","../core/Logger","../core/MultiOriginJSONSupport","../core/promiseUtils","../core/accessorSupport/decorators/property","../core/accessorSupport/decorators/cast","../core/RandomLCG","../core/has","../core/accessorSupport/decorators/reader","../core/accessorSupport/decorators/subclass","../core/accessorSupport/decorators/writer","../core/accessorSupport/PropertyOrigin","./Layer","./mixins/BlendLayer","./mixins/OperationalLayer","./mixins/PortalLayer","./mixins/ScaleRangeLayer","./support/ControlPointsGeoreference","./support/ImageElement","./support/LocalMediaElementSource","./support/mediaUtils","./support/VideoElement","../webdoc/interfaces"],(function(e,r,t,o,i,s,a,n,c,d,p,l,u,y,g,m,f,h,S,_,w,v,O,L,b,E){"use strict";function I(e){return"object"==typeof e&&null!=e&&"type"in e}function A(e){return I(e)&&("image"===e.type||"video"===e.type)}let T=class extends(f.BlendLayer(_.ScaleRangeLayer(h.OperationalLayer(S.PortalLayer(s.MultiOriginJSONMixin(m)))))){constructor(r){super(r),this.effectiveSource=null,this.georeference=null,this.copyright=null,this.operationalLayerType="MediaLayer",this.spatialReference=null,this.type="media",this._debouncedSaveOperations=a.debounce((async(r,t,o)=>{const{save:i,saveAs:s}=await new Promise(((r,t)=>e(["./save/mediaLayerUtils"],r,t)));switch(r){case E.SaveOperationType.SAVE:return i(this,t);case E.SaveOperationType.SAVE_AS:return s(this,o,t)}})),this.source=new O}load(e){return this.addResolvingPromise(this._doLoad(e)),Promise.resolve(this)}async _doLoad(e){await this.loadFromPortal({supportedTypes:["Media Layer"]},e);let r=this.source;if(!r)throw new o("media-layer:source-missing","Set 'MediaLayer.source' before loading the layer.");const i=this._getSourceOverride(r,this.georeference);i&&(this.setAtOrigin("source",i,"web-map"),this.setAtOrigin("source",i,"web-scene"),r=i);const s=I(r)?new O({elements:new t([r])}):r;this._set("effectiveSource",s),this.spatialReference&&(s.spatialReference=this.spatialReference),await s.load(e),this.spatialReference=s.spatialReference}destroy(){this.effectiveSource?.destroy(),this.effectiveSource!==this.source&&this.source?.destroy()}readGeoreference(e,r){return e&&"itemId"in r&&r.itemId?e:void 0}get fullExtent(){return this.loaded?this.effectiveSource.fullExtent:null}set source(e){"loaded"!==this.loadStatus&&"failed"!==this.loadStatus?this._set("source",e):i.getLogger(this).error("#source","source cannot be changed after the layer is loaded.")}castSource(e){return e?Array.isArray(e)?new O({elements:new t(e)}):e instanceof t?new O({elements:e}):e:null}readSource(e,r,t){if("itemId"in r&&r.itemId)return;const o=this._createSource(r);return o?.read(r,t),o}writeSource(e,r,t,i){if(e&&e instanceof O){const r=e.elements.length;if(1!==r)return void(i?.messages&&i.messages.push(new o("media-layer:unsupported-source",`local media element source can only be persisted if it contains exactly one ImageElement, but it has ${r}.`)));e=e.elements.at(0)}A(e)?e.write(r,i):i?.messages&&(e?i.messages.push(new o("media-layer:unsupported-source","only media elements of type 'ImageElement' or 'VideoElement' can be persisted")):i.messages.push(new o("media-layer:unsupported-source","the media layer is missing a source")))}async save(e){return this._debouncedSaveOperations(E.SaveOperationType.SAVE,e)}async saveAs(e,r){return this._debouncedSaveOperations(E.SaveOperationType.SAVE_AS,r,e)}_createSource(e){if("mediaType"in e)switch(e.mediaType){case"image":return new v;case"video":return new b}return null}_getSourceOverride(e,r){if(I(e)&&this.originIdOf("source")===g.OriginId.PORTAL_ITEM&&r&&(this.originIdOf("georeference")===g.OriginId.WEB_MAP||this.originIdOf("georeference")===g.OriginId.WEB_SCENE)){const t=e.toJSON(),o=this._createSource(t);return o.read({...t},{origin:"portal-item"}),o.read({georeference:r},{origin:"web-map"}),o.read({georeference:r},{origin:"web-scene"}),o}return null}};r.__decorate([n.property({readOnly:!0})],T.prototype,"effectiveSource",void 0),r.__decorate([n.property({readOnly:!0,json:{read:!1,write:!1,origins:{"web-document":{read:!0}}}})],T.prototype,"georeference",void 0),r.__decorate([l.reader("web-document","georeference")],T.prototype,"readGeoreference",null),r.__decorate([n.property({type:String})],T.prototype,"copyright",void 0),r.__decorate([n.property({readOnly:!0})],T.prototype,"fullExtent",null),r.__decorate([n.property({type:["MediaLayer"]})],T.prototype,"operationalLayerType",void 0),r.__decorate([n.property({type:["show","hide"]})],T.prototype,"listMode",void 0),r.__decorate([n.property({nonNullable:!0,json:{write:{enabled:!0,allowNull:!1,target:{url:{type:String},mediaType:{type:["image","video"]},georeference:{type:w}},overridePolicy(e,r,t){return{enabled:!0,allowNull:!1,ignoreOrigin:L.isWritingLayerFromItemToWebDocument(this,t?.origin)&&A(e)&&!!e.georeference&&e.originIdOf("georeference")>g.OriginId.PORTAL_ITEM}}}}})],T.prototype,"source",null),r.__decorate([c.cast("source")],T.prototype,"castSource",null),r.__decorate([l.reader("source",["url"])],T.prototype,"readSource",null),r.__decorate([y.writer("source")],T.prototype,"writeSource",null),r.__decorate([n.property()],T.prototype,"spatialReference",void 0),r.__decorate([n.property({readOnly:!0})],T.prototype,"type",void 0),T=r.__decorate([u.subclass("esri.layers.MediaLayer")],T);return T}));
