/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../geometry","../PopupTemplate","../renderers/ClassBreaksRenderer","../renderers/DictionaryRenderer","../renderers/DotDensityRenderer","../renderers/HeatmapRenderer","../renderers/PieChartRenderer","../renderers/Renderer","../renderers/SimpleRenderer","../renderers/UniqueValueRenderer","../renderers/support/jsonUtils","../renderers/support/types","../core/MultiOriginJSONSupport","../core/accessorSupport/decorators/property","../core/has","../core/Logger","../core/RandomLCG","../core/accessorSupport/decorators/subclass","../geometry/support/typeUtils","./Layer","./graphics/sources/OGCFeatureSource","./mixins/APIKeyMixin","./mixins/BlendLayer","./mixins/CustomParametersMixin","./mixins/FeatureEffectLayer","./mixins/FeatureReductionLayer","./mixins/OperationalLayer","./mixins/OrderedLayer","./mixins/PortalLayer","./mixins/RefreshableLayer","./mixins/ScaleRangeLayer","./mixins/TemporalLayer","./support/commonProperties","./support/FeatureType","./support/Field","./support/fieldProperties","./support/fieldUtils","./support/LabelClass","./support/labelingInfo","../rest/support/Query","../support/popupUtils","../geometry/Extent","../geometry/SpatialReference"],(function(e,r,t,o,i,n,p,s,a,l,d,y,u,c,h,f,m,_,g,v,b,x,I,L,R,F,S,T,O,P,D,j,w,C,E,G,M,q,B,U,V,K,N,z){"use strict";const Q=M.defineFieldProperties();let Z=class extends(I.APIKeyMixin(R.CustomParametersMixin(S.FeatureReductionLayer(F.FeatureEffectLayer(L.BlendLayer(O.OrderedLayer(w.TemporalLayer(j.ScaleRangeLayer(T.OperationalLayer(P.PortalLayer(D.RefreshableLayer(c.MultiOriginJSONMixin(b))))))))))))){constructor(e){super(e),this.capabilities=null,this.collectionId=null,this.copyright=null,this.description=null,this.displayField=null,this.elevationInfo=null,this.fields=null,this.fieldsIndex=null,this.fullExtent=null,this.geometryType=null,this.hasZ=void 0,this.labelingInfo=null,this.labelsVisible=!0,this.legendEnabled=!0,this.maxRecordCount=null,this.objectIdField=null,this.operationalLayerType="OGCFeatureLayer",this.popupEnabled=!0,this.popupTemplate=null,this.screenSizePerspectiveEnabled=!0,this.source=new x.OGCFeatureSource({layer:this}),this.spatialReference=null,this.title=null,this.type="ogc-feature",this.typeIdField=null,this.types=null,this.url=null}destroy(){this.source?.destroy()}load(e){return this.addResolvingPromise(this.loadFromPortal({supportedTypes:["OGCFeatureServer"]},e).then((()=>this._fetchService(e)))),this.when()}get defaultPopupTemplate(){return this.createPopupTemplate()}get effectiveMaxRecordCount(){return this.maxRecordCount??this.capabilities?.query.maxRecordCount??5e3}get isTable(){return this.loaded&&null==this.geometryType}set renderer(e){q.fixRendererFields(e,this.fieldsIndex),this._set("renderer",e)}on(e,r){return super.on(e,r)}createPopupTemplate(e){return K.createPopupTemplate(this,e)}createQuery(){return new V}getField(e){return this.fieldsIndex.get(e)}getFieldDomain(e,r){let t,o=!1;const i=r?.feature?.attributes,n=this.typeIdField&&i?.[this.typeIdField];return null!=n&&this.types&&(o=this.types.some((r=>r.id==n&&(t=r.domains?.[e],"inherited"===t?.type&&(t=this._getLayerDomain(e)),!0)))),o||t||(t=this._getLayerDomain(e)),t}queryFeatures(e,r){return this.load().then((()=>this.source.queryFeatures(V.from(e)||this.createQuery(),r))).then((e=>(e?.features?.forEach((e=>{e.layer=e.sourceLayer=this})),e)))}serviceSupportsSpatialReference(e){return this.source?.serviceSupportsSpatialReference(e)??!1}async _fetchService(e){await this.source.load(e),this.read(this.source.featureDefinition,{origin:"service"}),q.fixRendererFields(this.renderer,this.fieldsIndex),q.fixTimeInfoFields(this.timeInfo,this.fieldsIndex)}_getLayerDomain(e){if(!this.fields)return null;for(const r of this.fields)if(r.name===e&&r.domain)return r.domain;return null}};e.__decorate([h.property({readOnly:!0,json:{origins:{service:{read:!0}}}})],Z.prototype,"capabilities",void 0),e.__decorate([h.property({type:String,json:{write:!0}})],Z.prototype,"collectionId",void 0),e.__decorate([h.property({type:String})],Z.prototype,"copyright",void 0),e.__decorate([h.property({readOnly:!0})],Z.prototype,"defaultPopupTemplate",null),e.__decorate([h.property({readOnly:!0,type:String,json:{origins:{service:{name:"collection.description"}}}})],Z.prototype,"description",void 0),e.__decorate([h.property({type:String})],Z.prototype,"displayField",void 0),e.__decorate([h.property({type:Number})],Z.prototype,"effectiveMaxRecordCount",null),e.__decorate([h.property(C.elevationInfo)],Z.prototype,"elevationInfo",void 0),e.__decorate([h.property({type:[G],json:{origins:{service:{name:"layerDefinition.fields"}}}})],Z.prototype,"fields",void 0),e.__decorate([h.property(Q.fieldsIndex)],Z.prototype,"fieldsIndex",void 0),e.__decorate([h.property({readOnly:!0,type:N,json:{origins:{service:{name:"layerDefinition.extent"}}}})],Z.prototype,"fullExtent",void 0),e.__decorate([h.property({type:v.featureGeometryTypeKebabDictionary.apiValues,json:{origins:{service:{name:"layerDefinition.geometryType",read:{reader:v.featureGeometryTypeKebabDictionary.read}}}}})],Z.prototype,"geometryType",void 0),e.__decorate([h.property({type:Boolean,json:{origins:{service:{name:"layerDefinition.hasZ"}}}})],Z.prototype,"hasZ",void 0),e.__decorate([h.property({type:Boolean,readOnly:!0})],Z.prototype,"isTable",null),e.__decorate([h.property({type:[B],json:{origins:{"web-document":{name:"layerDefinition.drawingInfo.labelingInfo",read:{reader:U.reader},write:!0}}}})],Z.prototype,"labelingInfo",void 0),e.__decorate([h.property(C.labelsVisible)],Z.prototype,"labelsVisible",void 0),e.__decorate([h.property(C.legendEnabled)],Z.prototype,"legendEnabled",void 0),e.__decorate([h.property({type:Number})],Z.prototype,"maxRecordCount",void 0),e.__decorate([h.property({type:String,json:{origins:{service:{name:"layerDefinition.objectIdField"}}}})],Z.prototype,"objectIdField",void 0),e.__decorate([h.property({type:["OGCFeatureLayer"]})],Z.prototype,"operationalLayerType",void 0),e.__decorate([h.property(C.popupEnabled)],Z.prototype,"popupEnabled",void 0),e.__decorate([h.property({type:t,json:{name:"popupInfo",write:!0}})],Z.prototype,"popupTemplate",void 0),e.__decorate([h.property({types:u.rendererTypes,json:{origins:{service:{name:"layerDefinition.drawingInfo.renderer",write:!1},"web-scene":{types:u.webSceneRendererTypes,name:"layerDefinition.drawingInfo.renderer",write:!0}},name:"layerDefinition.drawingInfo.renderer",write:!0}})],Z.prototype,"renderer",null),e.__decorate([h.property(C.screenSizePerspectiveEnabled)],Z.prototype,"screenSizePerspectiveEnabled",void 0),e.__decorate([h.property({readOnly:!0})],Z.prototype,"source",void 0),e.__decorate([h.property({readOnly:!0,type:z,json:{origins:{service:{read:!0}}}})],Z.prototype,"spatialReference",void 0),e.__decorate([h.property({type:String,json:{write:{enabled:!0,ignoreOrigin:!0,isRequired:!0},origins:{service:{name:"collection.title"}}}})],Z.prototype,"title",void 0),e.__decorate([h.property({readOnly:!0,json:{read:!1}})],Z.prototype,"type",void 0),e.__decorate([h.property({type:String,readOnly:!0})],Z.prototype,"typeIdField",void 0),e.__decorate([h.property({type:[E]})],Z.prototype,"types",void 0),e.__decorate([h.property(C.url)],Z.prototype,"url",void 0),Z=e.__decorate([g.subclass("esri.layers.OGCFeatureLayer")],Z);return Z}));
