/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../core/Error","../core/lang","../core/object","../core/accessorSupport/decorators/property","../core/has","../core/Logger","../core/accessorSupport/decorators/subclass","./FeatureLayer","./mixins/TemporalLayer","./orientedImagery/core/utils","../time/TimeExtent","../webdoc/interfaces"],(function(e,t,r,i,o,a,n,p,s,y,d,c,l){"use strict";const m=new Set(["demPathPrefix","demPathSuffix","depthImagePathPrefix","depthImagePathSuffix","elevationSource","horizontalMeasurementUnit","verticalMeasurementUnit","videoPathPrefix","videoPathSuffix","timeAnimation","visibilityTimeExtent"]),u=(e,t)=>!m.has(t)&&e,h=(e,t,r)=>{const i=`orientedImageryProperties.${e}`;return{name:i,write:t?{ignoreOrigin:!0,target:i,writer:t}:{ignoreOrigin:!0},read:r?{ignoreOrigin:!0,source:i,reader:r}:{ignoreOrigin:!0}}};function v(e){return e.json?(e.json.origins=e.json.origins??{},e.json.origins["web-scene"]={write:!1,read:!1},e):e}function g(e,t,r,i){const{name:o,write:a,read:n}=h(e,t,r),p={name:o,write:a,read:n,origins:{service:{name:`orientedImageryInfo.${o}`,write:t,read:r},"web-scene":{name:o,write:u(a,e),read:u(n,e)},"web-map":{name:o,write:a,read:n}}};return i&&p.origins?(p.type=i,p.origins["web-map"].type=i,p.origins["web-scene"].type=i,p):p}let f=class extends s{constructor(){super(...arguments),this.cameraHeading=null,this.cameraHeight=null,this.cameraPitch=null,this.cameraRoll=null,this.coveragePercent=null,this.demPathPrefix=null,this.demPathSuffix=null,this.depthImagePathPrefix=null,this.depthImagePathSuffix=null,this.elevationSource=null,this.farDistance=null,this.geometryType="point",this.horizontalFieldOfView=null,this.horizontalMeasurementUnit=null,this.imagePathPrefix=null,this.imagePathSuffix=null,this.imageRotation=null,this.maximumDistance=null,this.nearDistance=null,this.operationalLayerType="OrientedImageryLayer",this.orientationAccuracy=null,this.orientedImageryType=null,this.supportedSourceTypes=new Set(["Oriented Imagery Layer"]),this.type="oriented-imagery",this.timeIntervalUnit="days",this.useViewTime=!0,this.verticalFieldOfView=null,this.verticalMeasurementUnit=null,this.videoPathPrefix=null,this.videoPathSuffix=null,this.visibilityTimeExtent=null}get effectiveElevationSource(){const{elevationSource:e,demPathPrefix:t,demPathSuffix:r}=this;return d.getEffectiveElevationSource(e,t,r)}async save(e){return this._debouncedSaveOperations(l.SaveOperationType.SAVE,e)}async saveAs(e,t){return this._debouncedSaveOperations(l.SaveOperationType.SAVE_AS,t,e)}findFirstValidLayerId(e){return e.layers?.find((e=>this.supportedSourceTypes.has(e.type)))?.id}_verifySource(){if(super._verifySource(),"point"!==this.geometryType)throw new t("oriented-imagery-layer:invalid-geometry-type","OrientedImageryLayer only supports point geometry type")}};e.__decorate([o.property({type:Number,json:g("cameraHeading")})],f.prototype,"cameraHeading",void 0),e.__decorate([o.property({type:Number,json:g("cameraHeight")})],f.prototype,"cameraHeight",void 0),e.__decorate([o.property({type:Number,json:g("cameraPitch")})],f.prototype,"cameraPitch",void 0),e.__decorate([o.property({type:Number,json:g("cameraRoll")})],f.prototype,"cameraRoll",void 0),e.__decorate([o.property({type:Number,json:g("coveragePercent")})],f.prototype,"coveragePercent",void 0),e.__decorate([o.property({type:String,json:g("demPathPrefix")})],f.prototype,"demPathPrefix",void 0),e.__decorate([o.property({type:String,json:g("demPathSuffix")})],f.prototype,"demPathSuffix",void 0),e.__decorate([o.property({type:String,json:g("depthImagePathPrefix")})],f.prototype,"depthImagePathPrefix",void 0),e.__decorate([o.property({type:String,json:g("depthImagePathSuffix")})],f.prototype,"depthImagePathSuffix",void 0),e.__decorate([o.property({type:Object,json:g("elevationSource")})],f.prototype,"elevationSource",void 0),e.__decorate([o.property({readOnly:!0})],f.prototype,"effectiveElevationSource",null),e.__decorate([o.property({type:Number,json:g("farDistance")})],f.prototype,"farDistance",void 0),e.__decorate([o.property()],f.prototype,"geometryType",void 0),e.__decorate([o.property({type:Number,json:g("horizontalFieldOfView")})],f.prototype,"horizontalFieldOfView",void 0),e.__decorate([o.property({type:String,json:g("horizontalMeasurementUnit")})],f.prototype,"horizontalMeasurementUnit",void 0),e.__decorate([o.property({type:String,json:g("imagePathPrefix")})],f.prototype,"imagePathPrefix",void 0),e.__decorate([o.property({type:String,json:g("imagePathSuffix")})],f.prototype,"imagePathSuffix",void 0),e.__decorate([o.property({type:Number,json:g("imageRotation")})],f.prototype,"imageRotation",void 0),e.__decorate([o.property({type:Number,json:g("maximumDistance")})],f.prototype,"maximumDistance",void 0),e.__decorate([o.property({type:Number,json:g("nearDistance")})],f.prototype,"nearDistance",void 0),e.__decorate([o.property({type:["OrientedImageryLayer"],json:{origins:{"portal-item":{name:"layerType",write:{enabled:!0,ignoreOrigin:!0}}}}})],f.prototype,"operationalLayerType",void 0),e.__decorate([o.property({json:{...g("orientationAccuracy",((e,t,r)=>{i.setDeepValue(r,e.join(";"),t)}),(e=>{const t=e?.split(";")?.map(Number);return d.isOrientationAccuracy(t)?t:[0,0,0,0,0,0,0,0,0]}),String)}})],f.prototype,"orientationAccuracy",void 0),e.__decorate([o.property({json:{...g("orientedImageryType",d.orientedImageryTypeMap.write,d.orientedImageryTypeMap.read,d.orientedImageryTypeMap.jsonValues.slice(1))}})],f.prototype,"orientedImageryType",void 0),e.__decorate([o.property({json:{read:!1},value:"oriented-imagery",readOnly:!0})],f.prototype,"type",void 0),e.__decorate([o.property({type:d.timeIntervalUnitTypeMap.apiValues,json:{...g("timeIntervalUnit",d.timeIntervalUnitTypeMap.write,d.timeIntervalUnitTypeMap.read,d.timeIntervalUnitTypeMap.jsonValues)}})],f.prototype,"timeIntervalUnit",void 0),e.__decorate([o.property(v(r.clone(y.useViewTimeProperty)))],f.prototype,"useViewTime",void 0),e.__decorate([o.property({type:Number,json:g("verticalFieldOfView")})],f.prototype,"verticalFieldOfView",void 0),e.__decorate([o.property({type:d.verticalMeasurementTypeMap.apiValues,json:{...g("verticalMeasurementUnit",d.verticalMeasurementTypeMap.write,d.verticalMeasurementTypeMap.read,d.verticalMeasurementTypeMap.jsonValues)}})],f.prototype,"verticalMeasurementUnit",void 0),e.__decorate([o.property({type:String,json:g("videoPathPrefix")})],f.prototype,"videoPathPrefix",void 0),e.__decorate([o.property({type:String,json:g("videoPathSuffix")})],f.prototype,"videoPathSuffix",void 0),e.__decorate([o.property({type:c,json:{origins:{"web-scene":{write:!1,read:!1}}}})],f.prototype,"visibilityTimeExtent",void 0),f=e.__decorate([p.subclass("esri.layers.OrientedImageryLayer")],f);return f}));
