/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../config","../geometry","../Graphic","../PopupTemplate","../renderers/ClassBreaksRenderer","../renderers/DictionaryRenderer","../renderers/DotDensityRenderer","../renderers/HeatmapRenderer","../renderers/PieChartRenderer","../renderers/Renderer","../renderers/SimpleRenderer","../renderers/UniqueValueRenderer","../renderers/support/jsonUtils","../core/Logger","../core/Collection","../core/Error","../core/MultiOriginJSONSupport","../core/object","../core/promiseUtils","../core/reactiveUtils","../core/unitUtils","../core/urlUtils","../core/accessorSupport/decorators/property","../core/has","../core/RandomLCG","../core/accessorSupport/decorators/reader","../core/accessorSupport/decorators/subclass","../core/accessorSupport/decorators/writer","../core/accessorSupport/originUtils","../geometry/Extent","../geometry/projection","../geometry/support/spatialReferenceUtils","./Layer","./mixins/BlendLayer","./mixins/OperationalLayer","./mixins/PortalLayer","./mixins/ScaleRangeLayer","./support/arcgisLayerUrl","./support/RouteSymbols","../portal/Portal","../portal/PortalItem","../portal/support/portalItemUtils","../rest/networkService","../rest/route","../rest/support/DirectionLine","../rest/support/DirectionPoint","../rest/support/PointBarrier","../rest/support/PolygonBarrier","../rest/support/PolylineBarrier","../rest/support/RouteInfo","../rest/support/RouteParameters","../rest/support/RouteSettings","../rest/support/Stop","../geometry/SpatialReference","../geometry/Multipoint"],(function(e,t,r,o,i,s,n,a,l,u,p,c,y,d,m,f,h,w,S,g,_,b,v,B,P,N,R,L,D,C,I,O,F,T,x,k,A,G,J,M,U,j,q,E,W,V,z,K,H,Q,Y,Z,$,X,ee,te){"use strict";function re(e){return e.length?e:null}function oe(e){switch(e){case"esriGeometryPoint":return{type:"esriSMS",style:"esriSMSCircle",size:12,color:[0,0,0,0],outline:oe("esriGeometryPolyline")};case"esriGeometryPolyline":return{type:"esriSLS",style:"esriSLSSolid",width:1,color:[0,0,0,0]};case"esriGeometryPolygon":return{type:"esriSFS",style:"esriSFSNull",outline:oe("esriGeometryPolyline")}}}function ie(e){return"layers"in e}function se(e){return"esri.rest.support.FeatureSet"===e.declaredClass}function ne(e){return"esri.rest.support.NetworkFeatureSet"===e.declaredClass}function ae(e,t,r){const o=t.networkDataset?.networkAttributes,i=o?.filter((({usageType:e})=>"cost"===e))??[],s=r.travelMode??t.defaultTravelMode;if(null==s)return void ge().warn("route-layer:missing-travel-mode","The routing service must have a default travel mode or one must be specified in the route parameter.");const{timeAttributeName:n,distanceAttributeName:a}=s,l=i.find((({name:e})=>e===n)),u=i.find((({name:e})=>e===a)),p=r.travelMode?.impedanceAttributeName??r.impedanceAttribute??t.impedance,c=l?.units,y=u?.units;if(!c||!y)throw new h("routelayer:unknown-impedance-units","the units of either the distance or time impedance are unknown");const d=r.directionsLanguage??t.directionsLanguage,m=r.accumulateAttributes??t.accumulateAttributeNames??[],f=new Set(i.filter((({name:e})=>e===n||e===a||e===p||null!=e&&m.includes(e))).map((({name:e})=>e))),w=e=>{for(const t in e)f.has(t)||delete e[t]};for(const h of e.pointBarriers)null!=h.costs&&(h.addedCost=h.costs[p]??0,w(h.costs));for(const h of e.polygonBarriers)null!=h.costs&&(h.scaleFactor=h.costs[p]??1,w(h.costs));for(const h of e.polylineBarriers)null!=h.costs&&(h.scaleFactor=h.costs[p]??1,w(h.costs));const{routeInfo:S}=e,{findBestSequence:g,preserveFirstStop:_,preserveLastStop:b,startTimeIsUTC:v,timeWindowsAreUTC:B}=r;S.analysisSettings=new $({accumulateAttributes:m,directionsLanguage:d,findBestSequence:g,preserveFirstStop:_,preserveLastStop:b,startTimeIsUTC:v,timeWindowsAreUTC:B,travelMode:s}),S.totalDuration=ue(S.totalCosts?.[n]??0,c),S.totalDistance=pe(S.totalCosts?.[a]??0,y),S.totalLateDuration=ue(S.totalViolations?.[n]??0,c),S.totalWaitDuration=ue(S.totalWait?.[n]??0,c),null!=S.totalCosts&&w(S.totalCosts),null!=S.totalViolations&&w(S.totalViolations),null!=S.totalWait&&w(S.totalWait);for(const h of e.stops)null!=h.serviceCosts&&(h.serviceDuration=ue(h.serviceCosts[n]??0,c),h.serviceDistance=pe(h.serviceCosts[a]??0,y),w(h.serviceCosts)),null!=h.cumulativeCosts&&(h.cumulativeDuration=ue(h.cumulativeCosts[n]??0,c),h.cumulativeDistance=pe(h.cumulativeCosts[a]??0,y),w(h.cumulativeCosts)),null!=h.violations&&(h.lateDuration=ue(h.violations[n]??0,c),w(h.violations)),null!=h.wait&&(h.waitDuration=ue(h.wait[n]??0,c),w(h.wait))}async function le(e){const t=ee.WGS84;return await O.initializeProjection(e.spatialReference,t),O.project(e,t)}function ue(e,t){switch(t){case"seconds":return e/60;case"hours":return 60*e;case"days":return 60*e*24;default:return e}}function pe(e,t){return"decimal-degrees"===t||"points"===t||"unknown"===t?e:b.convertUnit(e,t,"meters")}function ce(e){const{attributes:t,geometry:r,popupTemplate:o,symbol:i}=e.toGraphic().toJSON();return{attributes:t,geometry:r,popupInfo:o,symbol:i}}const ye=f.ofType(V),de=f.ofType(z),me=f.ofType(K),fe=f.ofType(H),he=f.ofType(Q),we=f.ofType(X),Se="esri.layers.RouteLayer",ge=()=>m.getLogger(Se);let _e=class extends(x.BlendLayer(G.ScaleRangeLayer(k.OperationalLayer(A.PortalLayer(w.MultiOriginJSONMixin(T)))))){constructor(e){super(e),this._cachedServiceDescription=null,this._featureCollection=null,this._type="Feature Collection",this.defaultSymbols=new M,this.directionLines=null,this.directionPoints=null,this.featureCollectionType="route",this.legendEnabled=!1,this.maxScale=0,this.minScale=0,this.pointBarriers=new me,this.polygonBarriers=new fe,this.polylineBarriers=new he,this.routeInfo=null,this.spatialReference=ee.WGS84,this.stops=new we,this.type="route";const t=()=>{this._setStopSymbol(this.stops)};this.addHandles(_.on((()=>this.stops),"change",t,{sync:!0,onListenerAdd:t}))}writeFeatureCollectionWebmap(e,t,r,o){const i=[this._writePolygonBarriers(),this._writePolylineBarriers(),this._writePointBarriers(),this._writeRouteInfo(),this._writeDirectionLines(),this._writeDirectionPoints(),this._writeStops()].filter((e=>!!e)),s=i.map(((e,t)=>t)),n="web-map"===o.origin?"featureCollection.layers":"layers";S.setDeepValue(n,i,t),t.opacity=this.opacity,t.visibility=this.visible,t.visibleLayers=s}readDirectionLines(e,t){return this._getNetworkFeatures(t,"DirectionLines",(e=>V.fromGraphic(e)))}readDirectionPoints(e,t){return this._getNetworkFeatures(t,"DirectionPoints",(e=>z.fromGraphic(e)))}get fullExtent(){const e=new I({xmin:-180,ymin:-90,xmax:180,ymax:90,spatialReference:ee.WGS84});if(null!=this.routeInfo?.geometry)return this.routeInfo.geometry.extent??e;if(null==this.stops)return e;const t=this.stops.filter((e=>null!=e.geometry));if(t.length<2)return e;const{spatialReference:r}=t.at(0).geometry;if(null==r)return e;const o=t.toArray().map((e=>{const t=e.geometry;return[t.x,t.y]}));return new te({points:o,spatialReference:r}).extent}readMaxScale(e,t){const r=ie(t)?t.layers:t.featureCollection?.layers,o=r?.find((e=>null!=e.layerDefinition.maxScale));return o?.layerDefinition.maxScale??0}readMinScale(e,t){const r=ie(t)?t.layers:t.featureCollection?.layers,o=r?.find((e=>null!=e.layerDefinition.minScale));return o?.layerDefinition.minScale??0}readPointBarriers(e,t){return this._getNetworkFeatures(t,"Barriers",(e=>K.fromGraphic(e)))}readPolygonBarriers(e,t){return this._getNetworkFeatures(t,"PolygonBarriers",(e=>H.fromGraphic(e)))}readPolylineBarriers(e,t){return this._getNetworkFeatures(t,"PolylineBarriers",(e=>Q.fromGraphic(e)))}readRouteInfo(e,t){return this._getNetworkFeatures(t,"RouteInfo",(e=>Y.fromGraphic(e))).at(0)??null}readSpatialReference(e,t){const r=ie(t)?t.layers:t.featureCollection?.layers;if(!r?.length)return ee.WGS84;const{layerDefinition:o,featureSet:i}=r[0],s=i.features[0],n=s?.geometry?.spatialReference??i.spatialReference??o.spatialReference??o.extent.spatialReference??F.wgs84;return ee.fromJSON(n)}readStops(e,t){return this._getNetworkFeatures(t,"Stops",(e=>X.fromGraphic(e)),(e=>this._setStopSymbol(e)))}get title(){return this.routeInfo?.name??"Route"}set title(e){this._overrideIfSome("title",e)}get url(){return t.routeServiceUrl}set url(e){null!=e?this._set("url",J.sanitizeUrl(e,ge())):this._set("url",t.routeServiceUrl)}load(e){return this.addResolvingPromise(this.loadFromPortal({supportedTypes:["Feature Collection"]},e)),Promise.resolve(this)}removeAll(){this.removeResult(),this.pointBarriers.removeAll(),this.polygonBarriers.removeAll(),this.polylineBarriers.removeAll(),this.stops.removeAll()}removeResult(){null!=this.directionLines&&(this.directionLines.removeAll(),this._set("directionLines",null)),null!=this.directionPoints&&(this.directionPoints.removeAll(),this._set("directionPoints",null)),null!=this.routeInfo&&this._set("routeInfo",null)}async save(){await this.load();const{fullExtent:e,portalItem:t}=this;if(!t)throw new h("routelayer:portal-item-not-set","save() requires to the layer to have a portal item");if(!t.id)throw new h("routelayer:portal-item-not-saved","Please use saveAs() first to save the routelayer");if("Feature Collection"!==t.type)throw new h("routelayer:portal-item-wrong-type",'Portal item needs to have type "Feature Collection"');if(null==this.routeInfo)throw new h("routelayer:route-unsolved","save() requires a solved route");const{portal:r}=t;await r.signIn(),r.user||await t.reload();const{itemUrl:o,itemControl:i}=t;if("admin"!==i&&"update"!==i)throw new h("routelayer:insufficient-permissions","To save this layer, you need to be the owner or an administrator of your organization");const s={messages:[],origin:"portal-item",portal:r,url:o?v.urlToObject(o):void 0,writtenProperties:[]},n=this.write(void 0,s);return t.extent=await le(e),t.title=this.title,await t.update({data:n}),t}async saveAs(e,t={}){if(await this.load(),null==this.routeInfo)throw new h("routelayer:route-unsolved","saveAs() requires a solved route");const r=j.from(e).clone();r.extent??=await le(this.fullExtent),r.id=null,r.portal??=U.getDefault(),r.title??=this.title,r.type="Feature Collection",r.typeKeywords=["Data","Feature Collection",q.typeKeyword.MULTI_LAYER,"Route Layer"];const{portal:o}=r,i={messages:[],origin:"portal-item",portal:o,url:null,writtenProperties:[]};await o.signIn();const s=t?.folder,n=this.write(void 0,i);return await o.user.addItem({item:r,folder:s,data:n}),this.portalItem=r,C.updateOrigins(i),i.portalItem=r,r}async solve(e,t){const r=e?.stops??this.stops,o=e?.pointBarriers??re(this.pointBarriers),i=e?.polylineBarriers??re(this.polylineBarriers),s=e?.polygonBarriers??re(this.polygonBarriers);if(null==r)throw new h("routelayer:undefined-stops","the route layer must have stops defined in the route parameters.");if((se(r)||ne(r))&&r.features.length<2||f.isCollection(r)&&r.length<2)throw new h("routelayer:insufficent-stops","the route layer must have two or more stops to solve a route.");if(f.isCollection(r))for(const f of r)f.routeName=null;const n=e?.apiKey,a=this.url,l=await this._getServiceDescription(a,n,t),u=e?.travelMode??l.defaultTravelMode,p=e?.accumulateAttributes??[];null!=u&&(p.push(u.distanceAttributeName),u.timeAttributeName&&p.push(u.timeAttributeName));const c={accumulateAttributes:p,directionsOutputType:"featuresets",ignoreInvalidLocations:!0,pointBarriers:o,polylineBarriers:i,polygonBarriers:s,preserveFirstStop:!0,preserveLastStop:!0,returnBarriers:!!o,returnDirections:!0,returnPolygonBarriers:!!s,returnPolylineBarriers:!!i,returnRoutes:!0,returnStops:!0,stops:r},y=Z.from(e??{});let d;y.set(c);try{d=await W.solve(a,y,t)}catch(w){throw g.isAbortError(w)?w:new h("routelayer:failed-route-request","the routing request failed",{error:w})}const m=this._toRouteLayerSolution(d);return this._isOverridden("title")||(this.title=m.routeInfo.name??"Route"),ae(m,l,y),m}update(e){const{stops:t,directionLines:r,directionPoints:o,pointBarriers:i,polylineBarriers:s,polygonBarriers:n,routeInfo:a}=e;this.set({stops:t,pointBarriers:i,polylineBarriers:s,polygonBarriers:n}),this._set("directionLines",r),this._set("directionPoints",o),this._set("routeInfo",a),null!=a.geometry&&(this.spatialReference=a.geometry.spatialReference)}_getNetworkFeatures(e,t,r,s){const n=ie(e)?e.layers:e.featureCollection?.layers,a=n?.find((e=>e.layerDefinition.name===t));if(null==a)return new f;const{layerDefinition:l,popupInfo:u,featureSet:p}=a,c=l.drawingInfo.renderer,{features:y}=p,m=p.spatialReference??l.spatialReference??l.extent.spatialReference??F.wgs84,h=c&&d.read(c),w=ee.fromJSON(m),S=y.map((e=>{const s=o.fromJSON(e);null!=s.geometry&&null!=e.geometry&&null==e.geometry.spatialReference&&(s.geometry.spatialReference=w);const n=r(s);return n.symbol??=h?.getSymbol(s)??this._getNetworkSymbol(t),n.popupTemplate??=u&&i.fromJSON(u),n}));return s&&S.some((({symbol:e})=>!e))&&s(S),new f(S)}_getNetworkSymbol(e){switch(e){case"Barriers":return this.defaultSymbols.pointBarriers;case"DirectionPoints":return this.defaultSymbols.directionPoints;case"DirectionLines":return this.defaultSymbols.directionLines;case"PolylineBarriers":return this.defaultSymbols.polylineBarriers;case"PolygonBarriers":return this.defaultSymbols.polygonBarriers;case"RouteInfo":return this.defaultSymbols.routeInfo;case"Stops":return null}}async _getServiceDescription(e,t,r){if(null!=this._cachedServiceDescription&&this._cachedServiceDescription.url===e)return this._cachedServiceDescription.serviceDescription;const o=await E.fetchServiceDescription(e,t,r);return this._cachedServiceDescription={serviceDescription:o,url:e},o}_setStopSymbol(e){if(!e||0===e.length)return;if(null==this.defaultSymbols.stops)return;if(e.every((({symbol:e})=>null!=e)))return;const{first:t,last:r,middle:o,unlocated:i,waypoint:s,break:n}=this.defaultSymbols.stops;if(null==this.routeInfo||1===e.length)return void e.forEach(((i,s)=>{switch(s){case 0:i.symbol=t;break;case e.length-1:i.symbol=r;break;default:i.symbol=o}}));const a=e.map((({sequence:e})=>e)).filter((e=>null!=e)),l=Math.min(...a),u=Math.max(...a);for(const p of e)p.sequence!==l?p.sequence!==u?"ok"===p.status||"not-located-on-closest"===p.status?"waypoint"!==p.locationType?"break"!==p.locationType?p.symbol=o:p.symbol=n:p.symbol=s:p.symbol=i:p.symbol=r:p.symbol=t}_toRouteLayerSolution(e){const t=e.routeResults[0].stops?.map((e=>X.fromJSON(e.toJSON())));this._setStopSymbol(t);const r=new we(t),o=new fe(e.polygonBarriers?.map((e=>{const t=H.fromJSON(e.toJSON());return t.symbol=this.defaultSymbols.polygonBarriers,t}))),i=new he(e.polylineBarriers?.map((e=>{const t=Q.fromJSON(e.toJSON());return t.symbol=this.defaultSymbols.polylineBarriers,t}))),s=new me(e.pointBarriers?.map((e=>{const t=K.fromJSON(e.toJSON());return t.symbol=this.defaultSymbols.pointBarriers,t}))),n=e.routeResults[0].route?.toJSON(),a=Y.fromJSON(n);a.symbol=this.defaultSymbols.routeInfo;const l=new de(e.routeResults[0].directionPoints?.features.map((e=>{const t=z.fromJSON(e.toJSON());return t.symbol=this.defaultSymbols.directionPoints,t})));return{directionLines:new ye(e.routeResults[0].directionLines?.features.map((e=>{const t=V.fromJSON(e.toJSON());return t.symbol=this.defaultSymbols.directionLines,t}))),directionPoints:l,pointBarriers:s,polygonBarriers:o,polylineBarriers:i,routeInfo:a,stops:r}}_writeDirectionLines(){return this._writeNetworkFeatures(this.directionLines,this.defaultSymbols.directionLines,"esriGeometryPolyline",V.fields,"DirectionLines","Direction Lines")}_writeDirectionPoints(){return this._writeNetworkFeatures(this.directionPoints,this.defaultSymbols.directionPoints,"esriGeometryPoint",z.fields,"DirectionPoints","Direction Points")}_writeNetworkFeatures(e,t,r,o,i,s){if(!e?.length)return null;const n=this.spatialReference.toJSON(),{fullExtent:a,maxScale:l,minScale:u}=this;return{featureSet:{features:e.toArray().map((e=>ce(e))),geometryType:r,spatialReference:n},layerDefinition:{capabilities:"Query,Update,Editing",drawingInfo:{renderer:{type:"simple",symbol:null!=t?t.toJSON():oe(r)}},extent:a.toJSON(),fields:o,geometryType:r,hasM:!1,hasZ:!1,maxScale:l,minScale:u,name:i,objectIdField:"ObjectID",spatialReference:n,title:s,type:"Feature Layer",typeIdField:""}}}_writePointBarriers(){return this._writeNetworkFeatures(this.pointBarriers,this.defaultSymbols.pointBarriers,"esriGeometryPoint",K.fields,"Barriers","Point Barriers")}_writePolygonBarriers(){return this._writeNetworkFeatures(this.polygonBarriers,this.defaultSymbols.polygonBarriers,"esriGeometryPolygon",H.fields,"PolygonBarriers","Polygon Barriers")}_writePolylineBarriers(){return this._writeNetworkFeatures(this.polylineBarriers,this.defaultSymbols.polylineBarriers,"esriGeometryPolyline",Q.fields,"PolylineBarriers","Line Barriers")}_writeRouteInfo(){return this._writeNetworkFeatures(null!=this.routeInfo?new f([this.routeInfo]):null,this.defaultSymbols.routeInfo,"esriGeometryPolyline",Y.fields,"RouteInfo","Route Details")}_writeStops(){const e=this._writeNetworkFeatures(this.stops,null,"esriGeometryPoint",X.fields,"Stops","Stops");if(null==e)return null;const{stops:t}=this.defaultSymbols,r=t?.first?.toJSON(),o=t?.middle?.toJSON(),i=t?.last?.toJSON();return e.layerDefinition.drawingInfo.renderer={type:"uniqueValue",field1:"Sequence",defaultSymbol:o,uniqueValueInfos:[{value:"1",symbol:r,label:"First Stop"},{value:`${this.stops.length}`,symbol:i,label:"Last Stop"}]},e}};e.__decorate([B.property({readOnly:!0,json:{read:!1,origins:{"portal-item":{write:{allowNull:!0,ignoreOrigin:!0}},"web-map":{write:{overridePolicy(){return{allowNull:!0,ignoreOrigin:null==this.portalItem}}}}}}})],_e.prototype,"_featureCollection",void 0),e.__decorate([D.writer(["web-map","portal-item"],"_featureCollection")],_e.prototype,"writeFeatureCollectionWebmap",null),e.__decorate([B.property({readOnly:!0,json:{read:!1,origins:{"web-map":{write:{target:"type",overridePolicy(){return{ignoreOrigin:null!=this.portalItem}}}}}}})],_e.prototype,"_type",void 0),e.__decorate([B.property({nonNullable:!0,type:M})],_e.prototype,"defaultSymbols",void 0),e.__decorate([B.property({readOnly:!0})],_e.prototype,"directionLines",void 0),e.__decorate([R.reader(["web-map","portal-item"],"directionLines",["layers","featureCollection.layers"])],_e.prototype,"readDirectionLines",null),e.__decorate([B.property({readOnly:!0})],_e.prototype,"directionPoints",void 0),e.__decorate([R.reader(["web-map","portal-item"],"directionPoints",["layers","featureCollection.layers"])],_e.prototype,"readDirectionPoints",null),e.__decorate([B.property({readOnly:!0,json:{read:!1,origins:{"web-map":{write:{ignoreOrigin:!0}}}}})],_e.prototype,"featureCollectionType",void 0),e.__decorate([B.property({readOnly:!0})],_e.prototype,"fullExtent",null),e.__decorate([B.property({json:{origins:{"web-map":{name:"featureCollection.showLegend"}},write:!0}})],_e.prototype,"legendEnabled",void 0),e.__decorate([B.property({type:["show","hide"]})],_e.prototype,"listMode",void 0),e.__decorate([B.property({type:Number,nonNullable:!0,json:{write:!1}})],_e.prototype,"maxScale",void 0),e.__decorate([R.reader(["web-map","portal-item"],"maxScale",["layers","featureCollection.layers"])],_e.prototype,"readMaxScale",null),e.__decorate([B.property({type:Number,nonNullable:!0,json:{write:!1}})],_e.prototype,"minScale",void 0),e.__decorate([R.reader(["web-map","portal-item"],"minScale",["layers","featureCollection.layers"])],_e.prototype,"readMinScale",null),e.__decorate([B.property({type:["ArcGISFeatureLayer"],value:"ArcGISFeatureLayer"})],_e.prototype,"operationalLayerType",void 0),e.__decorate([B.property({nonNullable:!0,type:f.ofType(K)})],_e.prototype,"pointBarriers",void 0),e.__decorate([R.reader(["web-map","portal-item"],"pointBarriers",["layers","featureCollection.layers"])],_e.prototype,"readPointBarriers",null),e.__decorate([B.property({nonNullable:!0,type:f.ofType(H)})],_e.prototype,"polygonBarriers",void 0),e.__decorate([R.reader(["web-map","portal-item"],"polygonBarriers",["layers","featureCollection.layers"])],_e.prototype,"readPolygonBarriers",null),e.__decorate([B.property({nonNullable:!0,type:f.ofType(Q)})],_e.prototype,"polylineBarriers",void 0),e.__decorate([R.reader(["web-map","portal-item"],"polylineBarriers",["layers","featureCollection.layers"])],_e.prototype,"readPolylineBarriers",null),e.__decorate([B.property({readOnly:!0})],_e.prototype,"routeInfo",void 0),e.__decorate([R.reader(["web-map","portal-item"],"routeInfo",["layers","featureCollection.layers"])],_e.prototype,"readRouteInfo",null),e.__decorate([B.property({type:ee})],_e.prototype,"spatialReference",void 0),e.__decorate([R.reader(["web-map","portal-item"],"spatialReference",["layers","featureCollection.layers"])],_e.prototype,"readSpatialReference",null),e.__decorate([B.property({nonNullable:!0,type:f.ofType(X)})],_e.prototype,"stops",void 0),e.__decorate([R.reader(["web-map","portal-item"],"stops",["layers","featureCollection.layers"])],_e.prototype,"readStops",null),e.__decorate([B.property()],_e.prototype,"title",null),e.__decorate([B.property({readOnly:!0,json:{read:!1}})],_e.prototype,"type",void 0),e.__decorate([B.property()],_e.prototype,"url",null),_e=e.__decorate([L.subclass(Se)],_e);return _e}));
