/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../geometry","../request","../core/Error","../core/mathUtils","../core/MultiOriginJSONSupport","../core/reactiveUtils","../core/accessorSupport/decorators/property","../core/has","../core/Logger","../core/RandomLCG","../core/accessorSupport/decorators/reader","../core/accessorSupport/decorators/subclass","../geometry/Polyline","../geometry/SpatialReference","./Layer","./mixins/BlendLayer","./mixins/CustomParametersMixin","./mixins/ScaleRangeLayer","./support/arcgisLayerUrl","./support/commonProperties","./support/PlaybackInfo","./support/serviceCapabilitiesUtils","./support/TelemetryData","./support/TelemetryDisplay","./support/VideoFrame","./video/VideoController","./video/videoUtils","../geometry/Extent"],(function(e,r,t,o,i,l,n,a,s,p,d,y,c,u,h,_,m,g,v,f,O,S,T,b,C,I,P,U,x){"use strict";let L=class extends(m.BlendLayer(v.ScaleRangeLayer(l.MultiOriginJSONMixin(g.CustomParametersMixin(_))))){constructor(e){super(e),this._trailPoints=[],this.capabilities=null,this.connectionInfo=null,this.controller=new P,this.copyright=null,this.created=null,this.description=null,this.elevationSource=null,this.frame=null,this.frameCount=null,this.fullExtent=null,this.initialExtent=null,this.layerId=null,this.playbackInfo=null,this.posterUrl=null,this.qualities=null,this.serviceItemId=null,this.sourceJSON=null,this.sourceQuality=null,this.sourceType=null,this.spatialReference=h.WGS84,this.telemetryDisplay=null,this.title=null,this.type="video",this.url=null,this.videoLayersInfo=null,this.videoTimeExtent=null}initialize(){this.telemetryDisplay=new C({frame:!1,frameCenter:!1,frameOutline:!0,lineOfSight:!0,sensorLocation:!0,sensorTrail:!0}),this.addHandles([n.watch((()=>this.metadata),(()=>{this.notifyChange("telemetry"),this.notifyChange("groundControlPoints"),this.notifyChange("frameHorizonPoints")})),n.watch((()=>this.telemetry?.sensorLocation),(e=>this._setSensorTrail(e)),n.initial)])}load(e){const r=null!=e?e.signal:null;return this.addResolvingPromise(this._fetchService(r)),Promise.resolve(this)}get buffered(){return this.controller.buffered}readCapabilitiesFromService(e,r){return T.getVideoLayerCapabilities(r)}readConnectionInfo(e,r){const t=Object.values(r.connectionUrl);return t?.length&&(this.controller.playerUrl=t[0]),r.connectionUrl}get currentTime(){return this.controller.currentTime}get duration(){return this.controller.duration}get ended(){return this.controller.ended}get frameHorizonPoints(){return U.getFrameHorizonPoints(this.metadata)}get groundControlPoints(){return U.getGroundControlPoints(this.metadata)}get loop(){return this.controller.loop}set loop(e){this.controller.loop=e}get metadata(){return this.controller?.currentMetadata}get mimeType(){return this.controller?.mimeType}get muted(){return this.controller.muted}set muted(e){this.controller.muted=e}get playbackRate(){return this.controller.rate}set playbackRate(e){this.controller.rate=e}get playerUrl(){return this.controller.playerUrl}get playing(){return this.controller.playing}get state(){return this.controller.state}get telemetry(){return U.getTelemetryData(this.metadata)}get videoElement(){return this.controller?.element}get videoHeight(){return this.controller?.videoHeight}readLayerInfosFromService(e,r){return U.getServiceLayersInfo(r)}get videoWidth(){return this.controller?.videoWidth}get waiting(){return this.controller.waiting}play(){this.controller.play()}pause(){this.controller.pause()}reset(){this.controller.reset()}setCurrentTime(e){if(!this.duration)return;const r=i.clamp(e,0,this.duration);this.controller.setCurrentTime(r)}toGround(e,r){return this.controller?.sensorModel?.metadataSupportsTransforms?this.controller.sensorModel.transformImageToGeo(e,r):null}toVideo(e){if(!this.controller?.sensorModel?.metadataSupportsTransforms)return null;const r=this.controller.sensorModel.transformGeoToImage(e.x,e.y,e.z);return{x:r[0],y:r[1]}}async _fetchService(e){if(this.sourceJSON)return void this.read(this.sourceJSON,{origin:"service",url:this.parsedUrl});const r=f.parse(this.parsedUrl?.path);if(null==r)throw new o("arcgis-layers:url-mismatch","The url is not a valid arcgis resource");let i=null;const{data:l,ssl:n}=await t(r.url.path,{query:{f:"json",...this.parsedUrl.query,...this.customParameters},signal:e}),a=l;if(this.url=r.url.path,n&&(this.url=this.url.replace(/^http:/i,"https:")),!a?.currentVersion)return a.currentVersion="11.2",this.sourceJSON=a,void this.read(this.sourceJSON,{origin:"service",url:this.parsedUrl});let s=r?.sublayer;if(null==s&&a.layers?.length&&(s=a.layers[0].id),null==s)throw new o("arcgis-layers:url-mismatch","The url is not a valid arcgis resource");this.url=`${r.url.path}/${s}`,i=await t(this.url,{query:{f:"json",...this.customParameters},signal:e});const p={...a,...i.data};this.sourceJSON=p,this.read(this.sourceJSON,{origin:"service",url:this.parsedUrl})}_setSensorTrail(e){if(!e)return;const r=U.getSensorTrailPoints(e,this._trailPoints);this._trailPoints=[...r];const t=this._trailPoints.map((e=>e.toArray())),o=new u({hasZ:e.hasZ,paths:[t]});this.telemetry.sensorTrail=o.clone()}};e.__decorate([a.property({readOnly:!0})],L.prototype,"buffered",null),e.__decorate([a.property({readOnly:!0,json:{read:!1}})],L.prototype,"capabilities",void 0),e.__decorate([y.reader("service","capabilities",["supportsAppend","supportsCoverageQuery","supportsExportClip","supportsExportFrameset","supportsMensuration","supportsUpdate"])],L.prototype,"readCapabilitiesFromService",null),e.__decorate([a.property({readOnly:!0})],L.prototype,"connectionInfo",void 0),e.__decorate([y.reader("connectionInfo",["connectionUrl"])],L.prototype,"readConnectionInfo",null),e.__decorate([a.property()],L.prototype,"controller",void 0),e.__decorate([a.property({type:String})],L.prototype,"copyright",void 0),e.__decorate([a.property({readOnly:!0,type:Date})],L.prototype,"created",void 0),e.__decorate([a.property({type:Number})],L.prototype,"currentTime",null),e.__decorate([a.property({type:String})],L.prototype,"description",void 0),e.__decorate([a.property({type:Number})],L.prototype,"duration",null),e.__decorate([a.property({readOnly:!0})],L.prototype,"elevationSource",void 0),e.__decorate([a.property({type:Boolean})],L.prototype,"ended",null),e.__decorate([a.property({type:I})],L.prototype,"frame",void 0),e.__decorate([a.property({readOnly:!0,type:Number})],L.prototype,"frameCount",void 0),e.__decorate([a.property({type:x})],L.prototype,"fullExtent",void 0),e.__decorate([a.property({readOnly:!0})],L.prototype,"frameHorizonPoints",null),e.__decorate([a.property({readOnly:!0})],L.prototype,"groundControlPoints",null),e.__decorate([a.property({type:x})],L.prototype,"initialExtent",void 0),e.__decorate([a.property({readOnly:!0,json:{read:{source:"id"}}})],L.prototype,"layerId",void 0),e.__decorate([a.property({type:Boolean})],L.prototype,"loop",null),e.__decorate([a.property({readOnly:!0})],L.prototype,"metadata",null),e.__decorate([a.property({readOnly:!0})],L.prototype,"mimeType",null),e.__decorate([a.property({type:Boolean})],L.prototype,"muted",null),e.__decorate([a.property({type:S})],L.prototype,"playbackInfo",void 0),e.__decorate([a.property({type:Number})],L.prototype,"playbackRate",null),e.__decorate([a.property({type:String})],L.prototype,"playerUrl",null),e.__decorate([a.property({readOnly:!0})],L.prototype,"playing",null),e.__decorate([a.property({readOnly:!0,json:{read:{source:"poster"}}})],L.prototype,"posterUrl",void 0),e.__decorate([a.property({readOnly:!0})],L.prototype,"qualities",void 0),e.__decorate([a.property({readOnly:!0})],L.prototype,"serviceItemId",void 0),e.__decorate([a.property()],L.prototype,"sourceJSON",void 0),e.__decorate([a.property({readOnly:!0})],L.prototype,"sourceQuality",void 0),e.__decorate([a.property({readOnly:!0,json:{name:"serviceType"}})],L.prototype,"sourceType",void 0),e.__decorate([a.property()],L.prototype,"spatialReference",void 0),e.__decorate([a.property({readOnly:!0,type:String})],L.prototype,"state",null),e.__decorate([a.property({readOnly:!0,type:b})],L.prototype,"telemetry",null),e.__decorate([a.property({type:C})],L.prototype,"telemetryDisplay",void 0),e.__decorate([a.property({readOnly:!1,json:{read:{source:"name"}}})],L.prototype,"title",void 0),e.__decorate([a.property({readOnly:!0})],L.prototype,"type",void 0),e.__decorate([a.property(O.url)],L.prototype,"url",void 0),e.__decorate([a.property({readOnly:!0})],L.prototype,"videoElement",null),e.__decorate([a.property({readOnly:!0})],L.prototype,"videoHeight",null),e.__decorate([a.property({readOnly:!0,json:{read:!1}})],L.prototype,"videoLayersInfo",void 0),e.__decorate([y.reader("service","videoLayersInfo",["id","name","poster","serviceType","type"])],L.prototype,"readLayerInfosFromService",null),e.__decorate([a.property({readOnly:!0,nonNullable:!1,json:{read:{reader:U.readVideoTimeExtent,source:"time"}}})],L.prototype,"videoTimeExtent",void 0),e.__decorate([a.property({readOnly:!0})],L.prototype,"videoWidth",null),e.__decorate([a.property({readOnly:!0})],L.prototype,"waiting",null),L=e.__decorate([c.subclass("esri.layers.VideoLayer")],L);return L}));
