/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../PopupTemplate","../core/Collection","../core/Error","../core/Logger","../core/MultiOriginJSONSupport","../core/promiseUtils","../core/accessorSupport/decorators/property","../core/accessorSupport/ensureType","../core/RandomLCG","../core/has","../core/accessorSupport/decorators/reader","../core/accessorSupport/decorators/subclass","../chunks/vec32","../core/libs/gl-matrix-2/factories/vec3f64","../geometry/Extent","./Layer","./mixins/APIKeyMixin","./mixins/ArcGISService","./mixins/CustomParametersMixin","./mixins/OperationalLayer","./mixins/PortalLayer","./mixins/ScaleRangeLayer","./mixins/SceneService","./support/arcgisLayerUrl","./support/commonProperties","./support/Field","./support/FieldsIndex","./support/TimeInfo","./voxel/VoxelSection","./voxel/VoxelSimpleShading","./voxel/VoxelVariable","./voxel/VoxelVariableStyle","./voxel/VoxelVolume","./voxel/VoxelVolumeIndex","./voxel/VoxelVolumeStyle","../support/popupUtils","../time/TimeExtent","../time/TimeInterval"],(function(e,t,r,o,i,n,s,l,a,p,u,c,d,y,m,v,h,f,b,g,S,x,V,_,w,I,T,L,j,D,P,F,O,N,A,E,M,R,z){"use strict";let C=class extends(_.SceneService(b.ArcGISService(S.OperationalLayer(x.PortalLayer(V.ScaleRangeLayer(n.MultiOriginJSONMixin(g.CustomParametersMixin(f.APIKeyMixin(h))))))))){constructor(e){super(e),this.serviceRoot="",this.operationalLayerType="Voxel",this.legendEnabled=!0,this.title=null,this.sections=null,this.currentVariableId=0,this.volumeStyles=null,this.renderMode="volume",this.variableStyles=null,this.enableSlices=!0,this.enableSections=!0,this.enableDynamicSections=!0,this.enableIsosurfaces=!0,this.shading=new P,this.opacity=1,this.variables=new r,this.volumes=new r,this.index=null,this.minScale=0,this.maxScale=0,this.type="voxel",this.version={major:Number.NaN,minor:Number.NaN,versionString:""},this.fullExtent=null,this.popupEnabled=!1,this.popupTemplate=null,this.test=null,this.timeExtent=null,this.timeOffset=null,this.useViewTime=!0,this.volumeStyles=new(r.ofType(E)),this.variableStyles=new(r.ofType(O)),this.sections=new(r.ofType(D))}normalizeCtorArgs(e){return e?.constantUpscaling&&(this.test={constantUpscaling:!0},delete e.constantUpscaling),e}set url(e){this._set("url",w.sanitizeUrl(e,i.getLogger(this)))}load(e){const t=null!=e?e.signal:null,r=this.loadFromPortal({supportedTypes:["Scene Service"]},e).catch(s.throwIfAbortError).then((()=>this._fetchService(t))).then((()=>this.serviceRoot=this.url));return this.addResolvingPromise(r),Promise.resolve(this)}read(e,t){super.read(e,t),"service"===t?.origin&&this.version.major<=3&&this.version.minor<=0&&!this.getAtOrigin("popupTemplate","service")&&this.setAtOrigin("popupTemplate",this.createPopupTemplate(),"service");for(const r of this.volumes)r.spatialReference=this.spatialReference}readVersion(e,t){return super.parseVersionString(e)}validateLayer(e){if(e.layerType&&e.layerType!==this.operationalLayerType)throw new o("voxel-layer:layer-type-not-supported","VoxelLayer does not support this layer type",{layerType:e.layerType});if(isNaN(this.version.major)||isNaN(this.version.minor)||this.version.major<3)throw new o("layer:service-version-not-supported","Service version is not supported.",{serviceVersion:this.version.versionString,supportedVersions:"3.x"});if(this.version.major>3)throw new o("layer:service-version-too-new","Service version is too new.",{serviceVersion:this.version.versionString,supportedVersions:"3.x"})}readFullExtent(e,t,r){if(null!=e&&"object"==typeof e){const o=v.fromJSON(e,r);if(0===o.zmin&&0===o.zmax&&Array.isArray(t.volumes)){const e=N.fromJSON(t.volumes[0]);if(e.isValid&&"xyt"!==e.volumeType){const t=e.dimensions[2];if(t.isRegular){let e=t.regularSpacing.offset,r=t.regularSpacing.offset+t.regularSpacing.scale*(t.size-1);if(e>r){const t=e;e=r,r=t}o.zmin=e,o.zmax=r}}}return o}return null}get fields(){const e=[new T({name:"Voxel.Position",alias:"Voxel Position",domain:null,editable:!1,length:128,type:"string"}),new T({name:"Voxel.CurrentVariable",alias:"Current Variable",domain:null,editable:!1,length:128,type:"string"})];for(const r of this.variables){const t=new T({name:r.name,alias:r.description,domain:null,editable:!1,length:128,type:"discrete"===r.renderingFormat.continuity?"string":"double"});e.push(t)}const t=this.getVolume(null);if(null!=t){if("xyzt"===t.volumeType||"xyt"===t.volumeType){const t=new T({name:"Voxel.LocalTime",alias:"Local Time",domain:null,editable:!1,length:256,type:"date"});e.push(t);const r=new T({name:"Voxel.SourceTime",alias:"Source Time",domain:null,editable:!1,length:256,type:"string"});e.push(r)}if("xyt"!==t.volumeType){const t=new T({name:"Voxel.Depth",alias:"Depth",domain:null,editable:!1,length:128,type:"double"});e.push(t)}}return e}get fieldsIndex(){return this.loaded?new L(this.fields):null}getField(e){return this.fieldsIndex?.get(e)}get defaultPopupTemplate(){return this.createPopupTemplate()}createPopupTemplate(e){const t=this.fields,r="{Voxel.Position}";return M.createPopupTemplate({fields:t,title:r},e)}getConfiguration(){const e={layerType:this.operationalLayerType,version:this.version.versionString,name:this.title,spatialReference:this.spatialReference,fullExtent:this.fullExtent,volumes:this.volumes.toJSON(),variables:this.variables.toJSON(),index:this.index?.toJSON(),sections:this.getSections(),style:{volumeStyles:this.getVolumeStyles(),currentVariableId:this.currentVariableId,renderMode:this.renderMode,variableStyles:this.getVariableStyles(),enableSections:this.enableSections,enableDynamicSections:this.enableDynamicSections,enableIsosurfaces:this.enableIsosurfaces,enableSlices:this.enableSlices,shading:this.shading}};return e.index&&this.index?.isValid()?JSON.stringify(e):""}getVariableStyle(e){let t=-1;t=null!=e?e:this.currentVariableId;if(!this.variableStyles||-1===t)return null;const r=this.variableStyles.findIndex((e=>e.variableId===t));return r<0?null:this.variableStyles.at(r)}getVariable(e){let t=-1;if(t=null!=e?e:this.currentVariableId,!this.variables||-1===t)return null;const r=this.variables.findIndex((e=>e.id===t));return r<0?null:this.variables.at(r)}getVolume(e){const t=this.getVariable(e);return null!=t?this.volumes.find((({id:e})=>e===t.volumeId)):null}get timeInfo(){const e=this.getVolume(null);if("xyzt"!==e?.volumeType)return null;const t=e.timeStops;if(!t?.length)return null;const r=new R({start:t[0],end:t.at(-1)});return new j({fullTimeExtent:r,stops:t})}getVolumeStyle(e){const t=this.getVariable(e);return null!=t?this.volumeStyles.find((({volumeId:e})=>e===t.volumeId)):null}getColorForContinuousDataValue(e,t,r){const o=this.getVariable(e);if(null==o||"continuous"!==o.renderingFormat?.continuity)return null;if(!this.variableStyles)return null;const i=this.variableStyles.findIndex((t=>t.variableId===e));if(i<0)return null;const n=this.variableStyles.at(i);return n?.transferFunction?n.transferFunction.getColorForContinuousDataValue(t,r):null}getSections(){const e=[];for(const t of this.sections)e.push(new D({enabled:t.enabled,href:t.href,id:t.id,label:t.label,normal:t.normal,point:t.point,sizeInPixel:t.sizeInPixel,slices:t.slices,timeId:t.timeId,variableId:t.variableId}));return e}getVariableStyles(){const e=[];for(const t of this.variableStyles){const r=this._getVariable(t);if(null!=r){const o=t.clone();o.isosurfaces.length>4&&(o.isosurfaces=o.isosurfaces.slice(0,3),i.getLogger(this).error("A maximum of 4 isosurfaces are supported for Voxel Layers."));for(const e of o.isosurfaces)if(!e.colorLocked){const t=this.getColorForContinuousDataValue(o.variableId,e.value,!1);null===t||t.equals(e.color)||(e.color=t)}if("continuous"===r.renderingFormat.continuity)(null===o.transferFunction||o.transferFunction.colorStops.length<2)&&i.getLogger(this).error(`VoxelVariableStyle for variable ${r.id} is invalid. At least 2 color stops are required in the transferFunction for continuous Voxel Layer variables.`),null!==o.transferFunction&&(Array.isArray(o.transferFunction.stretchRange)&&2===o.transferFunction.stretchRange.length||(i.getLogger(this).error(`VoxelVariableStyle for variable ${r.id} is invalid. The stretchRange of the transferFunction for continuous Voxel Layer variables must be of the form [minimumDataValue, maximumDataValue].`),o.transferFunction.stretchRange=[0,1],o.transferFunction.colorStops.removeAll()));else if("discrete"===r.renderingFormat.continuity)if(0===t.uniqueValues.length)i.getLogger(this).error(`VoxelVariableStyle for variable ${r.id} is invalid. Unique values are required for discrete Voxel Layer variables.`);else for(const e of t.uniqueValues)null!==e.label&&void 0!==e.label||null===e.value||void 0===e.value||(e.label=e.value.toString());e.push(o)}else i.getLogger(this).error(`VoxelVariable ID=${t.variableId} doesn't exist, VoxelVariableStyle for this VoxelVariable will be ignored.`)}return e}getVolumeStyles(){const e=[];for(const t of this.volumeStyles){const r=this._getVolumeFromVolumeId(t.volumeId);if(null!=r){const o=t.clone();for(const e of o.slices)this._isPlaneValid(e,[0,1,r.zDimension],r.dimensions)||(e.enabled=!1,e.label="invalid");for(const e of o.dynamicSections)this._isPlaneValid(e,[0,1,r.zDimension],r.dimensions)||(e.enabled=!1,e.label="invalid");e.push(o)}else i.getLogger(this).error(`VoxelVolume ID=${t.volumeId} doesn't exist, VoxelVolumeStyle for this VoxelVolume will be ignored.`)}return e}_getVariable(e){const t=e.variableId;for(const r of this.variables)if(r.id===t)return r;return null}_getVolumeFromVolumeId(e){for(const t of this.volumes)if(t.id===e)return t;return null}_isPlaneValid(e,t,r){if(!e.point)return!1;if(!Array.isArray(e.point)||3!==e.point.length)return!1;if(!e.normal)return!1;if(!Array.isArray(e.normal)||3!==e.normal.length)return!1;const o=m.fromValues(e.normal[0],e.normal[1],e.normal[2]);y.normalize(o,o);const i=1e-6;return!(Math.abs(o[0])+Math.abs(o[1])+Math.abs(o[2])<i)&&(e.normal[0]=o[0],e.normal[1]=o[1],e.normal[2]=o[2],!0)}};e.__decorate([l.property({type:["Voxel"]})],C.prototype,"operationalLayerType",void 0),e.__decorate([l.property(I.legendEnabled)],C.prototype,"legendEnabled",void 0),e.__decorate([l.property({json:{write:!0}})],C.prototype,"title",void 0),e.__decorate([l.property(I.url)],C.prototype,"url",null),e.__decorate([l.property({type:r.ofType(D),json:{origins:{"web-scene":{name:"layerDefinition.sections",write:!0}}}})],C.prototype,"sections",void 0),e.__decorate([l.property({type:a.Integer,json:{origins:{"web-scene":{name:"layerDefinition.style.currentVariableId",write:{enabled:!0,isRequired:!0,ignoreOrigin:!0}},service:{name:"style.currentVariableId"}}}})],C.prototype,"currentVariableId",void 0),e.__decorate([l.property({type:r.ofType(E),json:{origins:{"web-scene":{name:"layerDefinition.style.volumeStyles",write:!0},service:{name:"style.volumeStyles"}}}})],C.prototype,"volumeStyles",void 0),e.__decorate([l.property({type:["volume","surfaces"],json:{origins:{"web-scene":{name:"layerDefinition.style.renderMode",write:!0},service:{name:"style.renderMode"}}}})],C.prototype,"renderMode",void 0),e.__decorate([l.property({type:r.ofType(O),json:{origins:{"web-scene":{name:"layerDefinition.style.variableStyles",write:!0},service:{name:"style.variableStyles"}}}})],C.prototype,"variableStyles",void 0),e.__decorate([l.property({type:Boolean,json:{origins:{"web-scene":{name:"layerDefinition.style.enableSlices",write:!0},service:{name:"style.enableSlices"}}}})],C.prototype,"enableSlices",void 0),e.__decorate([l.property({type:Boolean,json:{origins:{"web-scene":{name:"layerDefinition.style.enableSections",write:!0},service:{name:"style.enableSections"}}}})],C.prototype,"enableSections",void 0),e.__decorate([l.property({type:Boolean,json:{origins:{"web-scene":{name:"layerDefinition.style.enableDynamicSections",write:!0},service:{name:"style.enableDynamicSections"}}}})],C.prototype,"enableDynamicSections",void 0),e.__decorate([l.property({type:Boolean,json:{origins:{"web-scene":{name:"layerDefinition.style.enableIsosurfaces",write:!0},service:{name:"style.enableIsosurfaces"}}}})],C.prototype,"enableIsosurfaces",void 0),e.__decorate([l.property({type:P,json:{origins:{"web-scene":{name:"layerDefinition.style.shading",write:!0},service:{name:"style.shading"}}}})],C.prototype,"shading",void 0),e.__decorate([l.property({type:["show","hide"]})],C.prototype,"listMode",void 0),e.__decorate([l.property({type:Number,range:{min:0,max:1},nonNullable:!0,json:{read:!1,write:!1,origins:{"web-scene":{read:!1,write:!1},"portal-item":{read:!1,write:!1}}}})],C.prototype,"opacity",void 0),e.__decorate([l.property({type:r.ofType(F)})],C.prototype,"variables",void 0),e.__decorate([l.property({type:r.ofType(N)})],C.prototype,"volumes",void 0),e.__decorate([l.property({type:A})],C.prototype,"index",void 0),e.__decorate([l.property({type:Number,json:{name:"layerDefinition.minScale",write:!0,origins:{service:{read:!1,write:!1}}}})],C.prototype,"minScale",void 0),e.__decorate([l.property({type:Number,json:{name:"layerDefinition.maxScale",write:!0,origins:{service:{read:!1,write:!1}}}})],C.prototype,"maxScale",void 0),e.__decorate([l.property({json:{read:!1},readOnly:!0})],C.prototype,"type",void 0),e.__decorate([l.property({readOnly:!0,json:{name:"serviceVersion"}})],C.prototype,"version",void 0),e.__decorate([c.reader("service","version")],C.prototype,"readVersion",null),e.__decorate([l.property({type:v})],C.prototype,"fullExtent",void 0),e.__decorate([c.reader("service","fullExtent",["fullExtent"])],C.prototype,"readFullExtent",null),e.__decorate([l.property({readOnly:!0,clonable:!1,json:{read:!1}})],C.prototype,"fields",null),e.__decorate([l.property({readOnly:!0})],C.prototype,"fieldsIndex",null),e.__decorate([l.property({type:Boolean,json:{name:"disablePopup",read:{reader:(e,t)=>!t.disablePopup},write:{enabled:!0,ignoreOrigin:!0,writer(e,t,r){t[r]=!e}},origins:{"portal-item":{default:!0},"web-scene":{default:!0}}}})],C.prototype,"popupEnabled",void 0),e.__decorate([l.property({type:t,json:{name:"popupInfo",write:!0}})],C.prototype,"popupTemplate",void 0),e.__decorate([l.property({readOnly:!0,json:{read:!1}})],C.prototype,"defaultPopupTemplate",null),e.__decorate([l.property({type:j,readOnly:!0,json:{read:!1}})],C.prototype,"timeInfo",null),e.__decorate([l.property({type:R,json:{read:!1}})],C.prototype,"timeExtent",void 0),e.__decorate([l.property({type:z,json:{read:!1}})],C.prototype,"timeOffset",void 0),e.__decorate([l.property({type:Boolean,nonNullable:!0,json:{origins:{"web-scene":{name:"timeAnimation",write:!0},service:{read:!1}}}})],C.prototype,"useViewTime",void 0),C=e.__decorate([d.subclass("esri.layers.VoxelLayer")],C);return C}));
