/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../core/Error","../core/MultiOriginJSONSupport","../core/reactiveUtils","../core/accessorSupport/decorators/property","../core/has","../core/Logger","../core/RandomLCG","../core/accessorSupport/decorators/subclass","./Layer","./mixins/BlendLayer","./mixins/CustomParametersMixin","./mixins/ImageryTileMixin","./mixins/OperationalLayer","./mixins/PortalLayer","./mixins/RefreshableLayer","./mixins/ScaleRangeLayer","./mixins/TemporalLayer","./support/commonProperties","./support/Field","./support/rasterDatasets/WCSRaster","../support/popupUtils"],(function(e,t,r,s,o,i,a,n,l,p,c,u,d,y,m,h,v,g,f,_,I,x){"use strict";const L=new Set(["milliseconds","seconds","minutes","hours","days","weeks","months","years","decades","centuries"]);let P=class extends(c.BlendLayer(v.ScaleRangeLayer(y.OperationalLayer(m.PortalLayer(u.CustomParametersMixin(d.ImageryTileMixin(g.TemporalLayer(h.RefreshableLayer(r.MultiOriginJSONMixin(p)))))))))){constructor(...e){super(...e),this.coverageId=null,this.version=null,this.isReference=null,this.type="wcs",this.popupEnabled=!0,this.popupTemplate=null,this.fields=null}normalizeCtorArgs(e,t){return"string"==typeof e?{url:e,...t}:e}load(e){const t=null!=e?e.signal:null;return this.addResolvingPromise(this._openRaster(t)),Promise.resolve(this)}get coverageInfo(){return this.raster.coverageInfo}get defaultPopupTemplate(){return this.createPopupTemplate()}get rasterFields(){return[new _({name:"Raster.ServicePixelValue",alias:"Pixel Value",domain:null,editable:!1,length:50,type:"string"})]}createPopupTemplate(e){return x.createPopupTemplate({fields:this.rasterFields,title:this.title},e)}async _openRaster(e){const r=new I({url:this.url,version:this.version,coverageId:this.coverageId,ioConfig:{sampling:"closest",...this.ioConfig,customFetchParameters:this.customParameters}});if(await r.open({signal:e}),!r.rasterInfo)throw r.destroy(),new t("wcs-layer:load","cannot load resources on "+this.url);const{rasterInfo:o}=r;this._set("serviceRasterInfo",o),this._set("spatialReference",o.spatialReference),null==this.title&&this.setAtOrigin("title",r.datasetName,"service"),null==this.coverageId&&this.setAtOrigin("coverageId",r.coverageInfo.id,"service"),null==this.version&&r.version&&this.setAtOrigin("version",r.version,"service"),this.setAtOrigin("tileInfo",r.rasterInfo.storageInfo.tileInfo,"service");const{multidimensionalInfo:i}=o;if(null!=i){const e=i.variables[0].dimensions.find((({name:e})=>"StdTime"===e));if(e){let t=e.extent?.[0]??e.values[0];Array.isArray(t)&&(t=t[0]);let r=e.extent?.[1]??e.values[e.values.length-1];Array.isArray(r)&&(r=r[1]);const s=L.has(e.intervalUnit?.toLowerCase())?e.intervalUnit?.toLowerCase():null;this.set("timeInfo",{startField:"StdTime",fullTimeExtent:{start:t,end:r},timeZone:null,interval:s?{value:e.interval,unit:s}:null})}}this.raster=r,this._configDefaultSettings(),this.addHandles(s.watch((()=>this.customParameters),(e=>this.raster.ioConfig.customFetchParameters=e)))}};e.__decorate([o.property({type:String,nonNullable:!0,json:{write:!0}})],P.prototype,"coverageId",void 0),e.__decorate([o.property()],P.prototype,"coverageInfo",null),e.__decorate([o.property()],P.prototype,"version",void 0),e.__decorate([o.property()],P.prototype,"isReference",void 0),e.__decorate([o.property()],P.prototype,"raster",void 0),e.__decorate([o.property({readOnly:!0})],P.prototype,"type",void 0),e.__decorate([o.property(f.popupEnabled)],P.prototype,"popupEnabled",void 0),e.__decorate([o.property()],P.prototype,"popupTemplate",void 0),e.__decorate([o.property({readOnly:!0})],P.prototype,"defaultPopupTemplate",null),e.__decorate([o.property({readOnly:!0,type:[_]})],P.prototype,"fields",void 0),e.__decorate([o.property({readOnly:!0,type:[_]})],P.prototype,"rasterFields",null),P=e.__decorate([l.subclass("esri.layers.WCSLayer")],P);return P}));
