/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../config","../Graphic","../PopupTemplate","../request","../core/Collection","../core/CollectionFlattener","../core/Error","../core/jsonMap","../core/lang","../core/MultiOriginJSONSupport","../core/promiseUtils","../core/reactiveUtils","../core/urlUtils","../core/accessorSupport/decorators/property","../core/accessorSupport/ensureType","../core/accessorSupport/decorators/reader","../core/accessorSupport/decorators/subclass","../core/accessorSupport/decorators/writer","../core/accessorSupport/write","../geometry/Extent","../geometry/SpatialReference","../geometry/support/scaleUtils","../geometry/support/spatialReferenceUtils","./Layer","./mixins/BlendLayer","./mixins/OperationalLayer","./mixins/PortalLayer","./mixins/RefreshableLayer","./mixins/ScaleRangeLayer","./mixins/TemporalLayer","./ogc/crsUtils","./support/arcgisLayerUrl","./support/commonProperties","./support/ExportWMSImageParameters","./support/imageBitmapUtils","./support/WMSSublayer","./support/wmsUtils"],(function(e,r,t,a,o,s,i,n,l,p,u,c,y,d,m,h,f,g,_,b,w,x,v,S,I,F,P,R,E,L,O,M,U,j,T,W,C,q){"use strict";const N=new l.JSONMap({bmp:"image/bmp",gif:"image/gif",jpg:"image/jpeg",png:"image/png",svg:"image/svg+xml"},{ignoreUnknown:!1});function $(e){return"text/html"===e}function B(e){return"text/plain"===e}let k=class extends(F.BlendLayer(O.TemporalLayer(E.RefreshableLayer(L.ScaleRangeLayer(P.OperationalLayer(R.PortalLayer(u.MultiOriginJSONMixin(I)))))))){constructor(...e){super(...e),this.allSublayers=new i({getCollections:()=>[this.sublayers],getChildrenFunction:e=>e.sublayers}),this.customParameters=null,this.customLayerParameters=null,this.copyright=null,this.description=null,this.dimensions=null,this.fullExtent=null,this.fullExtents=null,this.featureInfoFormats=null,this.featureInfoUrl=null,this.fetchFeatureInfoFunction=null,this.imageFormat=null,this.imageMaxHeight=2048,this.imageMaxWidth=2048,this.imageTransparency=!0,this.legendEnabled=!0,this.mapUrl=null,this.isReference=null,this.operationalLayerType="WMS",this.spatialReference=null,this.spatialReferences=null,this.sublayers=null,this.type="wms",this.version=null,this.addHandles([y.on((()=>this.sublayers),"after-add",(({item:e})=>{e.parent=e.layer=this}),y.sync),y.on((()=>this.sublayers),"after-remove",(({item:e})=>{e.layer=e.parent=null}),y.sync),y.watch((()=>this.sublayers),((e,r)=>{if(r)for(const t of r)t.layer=t.parent=null;if(e)for(const t of e)t.parent=t.layer=this}),y.sync)])}normalizeCtorArgs(e,r){return"string"==typeof e?{url:e,...r}:e}destroy(){this.allSublayers.destroy()}load(e){const r=null!=e?e.signal:null;return this.addResolvingPromise(this.loadFromPortal({supportedTypes:["WMS"]},e).catch(c.throwIfAbortError).then((()=>this._fetchService(r))).then((()=>this._checkLayerValidity()))),Promise.resolve(this)}readFullExtentFromItemOrMap(e,r){const t=r.extent;return t?new w({xmin:t[0][0],ymin:t[0][1],xmax:t[1][0],ymax:t[1][1]}):null}writeFullExtent(e,r){r.extent=[[e.xmin,e.ymin],[e.xmax,e.ymax]]}get featureInfoFormat(){return null==this.featureInfoFormats?null:this.featureInfoFormats.find($)??this.featureInfoFormats.find(B)??null}set featureInfoFormat(e){null==e?(this.revert("featureInfoFormat","service"),this._clearOverride("featureInfoFormat")):($(e)||B(e))&&this._override("featureInfoFormat",e)}readImageFormat(e,r){const t=r.supportedImageFormatTypes;return t&&t.includes("image/png")?"image/png":t&&t[0]}readSpatialReferenceFromItemOrDocument(e,r){return new x(r.spatialReferences[0])}writeSpatialReferences(e,r){const t=this.spatialReference?.wkid;e&&t?(r.spatialReferences=e.filter((e=>e!==t)),r.spatialReferences.unshift(t)):r.spatialReferences=e}readSublayersFromItemOrMap(e,r,t){return H(r.layers,t,r.visibleLayers)}readSublayers(e,r,t){return H(r.layers,t)}writeSublayers(e,r,t,a){r.layers=[];const o=new Map,s=e.flatten((({sublayers:e})=>e??[]));for(const i of s)if("number"==typeof i.parent?.id){const e=o.get(i.parent.id);null!=e?e.push(i.id):o.set(i.parent.id,[i.id])}for(const i of s){const e={sublayer:i,...a},t=i.write({parentLayerId:"number"==typeof i.parent?.id?i.parent.id:-1},e);if(o.has(i.id)&&(t.sublayerIds=o.get(i.id)),!i.sublayers&&i.name){const t=i.write({},e);delete t.id,r.layers.push(t)}}r.visibleLayers=s.filter((({visible:e,sublayers:r})=>e&&!r)).map((({name:e})=>e)).toArray()}set url(e){if(!e)return void this._set("url",e);const{path:r,query:t}=d.urlToObject(e);for(const o in t)/^(request|service)$/i.test(o)&&delete t[o];const a=d.addQueryParameters(r,t??{});this._set("url",a)}createExportImageParameters(e,r,t,a){const o=a?.pixelRatio??1,s=v.getScale({extent:e,width:r})*o,i=new T.ExportWMSImageParameters({layer:this,scale:s}),{xmin:n,ymin:l,xmax:p,ymax:u,spatialReference:c}=e,y=q.normalizeWKID(c,this.spatialReferences),d="1.3.0"===this.version&&M.isAxesOrderReversedForWkid(y)?`${l},${n},${u},${p}`:`${n},${l},${p},${u}`,m=i.toJSON(),h="1.3.0"===this.version?"crs":"srs";return{bbox:d,[h]:null==y||isNaN(y)?void 0:"EPSG:"+y,...m}}async fetchImage(e,r,t,a){const s=this.mapUrl,i=this.createExportImageParameters(e,r,t,a);if(!i.layers){const e=document.createElement("canvas");return e.width=r,e.height=t,e}const n=q.toTimeQueryParameter(a?.timeExtent),l={responseType:"image",query:this._mixCustomParameters({width:r,height:t,...i,time:n,...this.refreshParameters}),signal:a?.signal};return o(s??"",l).then((e=>e.data))}async fetchImageBitmap(e,r,t,a){const s=this.mapUrl??"",i=this.createExportImageParameters(e,r,t,a);if(!i.layers){const e=document.createElement("canvas");return e.width=r,e.height=t,e}const n=q.toTimeQueryParameter(a?.timeExtent),l={responseType:"blob",query:this._mixCustomParameters({width:r,height:t,...i,time:n,...this.refreshParameters}),signal:a?.signal},{data:p}=await o(s,l);return W.createBitmap(p,s,a?.signal)}fetchFeatureInfo(e,r,t,a,o){const s=v.getScale({extent:e,width:r}),i=new T.ExportWMSImageParameters({layer:this,scale:s}),n=q.getPopupLayers(i.visibleSublayers);if(null==this.featureInfoUrl||null==n)return Promise.resolve([]);if(null==this.fetchFeatureInfoFunction&&null==this.featureInfoFormat)return Promise.resolve([]);const l="1.3.0"===this.version?{I:a,J:o}:{x:a,y:o},p={query_layers:n,request:"GetFeatureInfo",info_format:this.featureInfoFormat,feature_count:25,width:r,height:t,...l},u={...this.createExportImageParameters(e,r,t),...p},c=this._mixCustomParameters(u);return null!=this.fetchFeatureInfoFunction?this.fetchFeatureInfoFunction(c):this._defaultFetchFeatureInfoFunction(d.addQueryParameters(this.featureInfoUrl,c))}findSublayerById(e){return this.allSublayers.find((r=>r.id===e))}findSublayerByName(e){return this.allSublayers.find((r=>r.name===e))}serviceSupportsSpatialReference(e){return U.isWmsServer(this.url)||null!=this.spatialReferences&&this.spatialReferences.some((r=>{const t=900913===r?x.WebMercator:new x({wkid:r});return S.equals(t,e)}))}_defaultFetchFeatureInfoFunction(e){const r=document.createElement("iframe");r.src=d.addProxy(e),r.style.border="none",r.style.margin="0",r.style.width="100%",r.setAttribute("sandbox","");const o=new a({title:this.title,content:r}),s=new t({sourceLayer:this,popupTemplate:o});return Promise.resolve([s])}async _fetchService(e){if(!this.resourceInfo&&this.parsedUrl?.path){const{path:r,query:t}=this.parsedUrl,{data:a}=await o(r,{query:{SERVICE:"WMS",REQUEST:"GetCapabilities",...t,...this.customParameters},responseType:"xml",signal:e});this.resourceInfo=q.parseCapabilities(a)}if(this.parsedUrl){const e=new d.Url(this.parsedUrl.path),{httpsDomains:t}=r.request;"https"!==e.scheme||e.port&&"443"!==e.port||!e.host||t.includes(e.host)||t.push(e.host)}this.read(this.resourceInfo,{origin:"service"})}_checkLayerValidity(){if(!this.allSublayers.length)throw new n("wmslayer:empty-layer","The layer doesn't have any sublayer")}_mixCustomParameters(e){if(!this.customLayerParameters&&!this.customParameters)return e;const r={...this.customParameters,...this.customLayerParameters};for(const t in r)e[t.toLowerCase()]=r[t];return e}};function A(e,r){return e.some((e=>{for(const t in e)if(b.willPropertyWrite(e,t,null,r))return!0;return!1}))}function H(e,r,t){e=e??[];const a=new Map;e.every((e=>null==e.id))&&(e=p.clone(e)).forEach(((e,r)=>e.id=r));for(const s of e){const e=new C;e.read(s,r),t&&!t.includes(e.name)&&(e.visible=!1),a.set(e.id,e)}const o=[];for(const i of e){const e=null!=i.id?a.get(i.id):null;if(e)if(null!=i.parentLayerId&&i.parentLayerId>=0){const r=a.get(i.parentLayerId);if(!r)continue;r.sublayers||(r.sublayers=new s),r.sublayers.push(e)}else o.push(e)}return o}e.__decorate([m.property({readOnly:!0})],k.prototype,"allSublayers",void 0),e.__decorate([m.property({json:{type:Object,write:!0}})],k.prototype,"customParameters",void 0),e.__decorate([m.property({json:{type:Object,write:!0}})],k.prototype,"customLayerParameters",void 0),e.__decorate([m.property({type:String,json:{write:!0}})],k.prototype,"copyright",void 0),e.__decorate([m.property()],k.prototype,"description",void 0),e.__decorate([m.property({readOnly:!0})],k.prototype,"dimensions",void 0),e.__decorate([m.property({json:{type:[[Number]],read:{source:"extent"},write:{target:"extent"},origins:{"web-document":{write:{ignoreOrigin:!0}},"portal-item":{write:{ignoreOrigin:!0}}}}})],k.prototype,"fullExtent",void 0),e.__decorate([f.reader(["web-document","portal-item"],"fullExtent",["extent"])],k.prototype,"readFullExtentFromItemOrMap",null),e.__decorate([_.writer(["web-document","portal-item"],"fullExtent",{extent:{type:[[Number]]}})],k.prototype,"writeFullExtent",null),e.__decorate([m.property()],k.prototype,"fullExtents",void 0),e.__decorate([m.property({type:String,json:{write:{ignoreOrigin:!0}}})],k.prototype,"featureInfoFormat",null),e.__decorate([m.property({type:[String],readOnly:!0})],k.prototype,"featureInfoFormats",void 0),e.__decorate([m.property({type:String,json:{write:{ignoreOrigin:!0}}})],k.prototype,"featureInfoUrl",void 0),e.__decorate([m.property()],k.prototype,"fetchFeatureInfoFunction",void 0),e.__decorate([m.property({type:String,json:{origins:{"web-document":{default:"image/png",type:N.jsonValues,read:{reader:N.read,source:"format"},write:{writer:N.write,target:"format"}}}}})],k.prototype,"imageFormat",void 0),e.__decorate([f.reader("imageFormat",["supportedImageFormatTypes"])],k.prototype,"readImageFormat",null),e.__decorate([m.property({type:Number,json:{read:{source:"maxHeight"},write:{target:"maxHeight"}}})],k.prototype,"imageMaxHeight",void 0),e.__decorate([m.property({type:Number,json:{read:{source:"maxWidth"},write:{target:"maxWidth"}}})],k.prototype,"imageMaxWidth",void 0),e.__decorate([m.property()],k.prototype,"imageTransparency",void 0),e.__decorate([m.property(j.legendEnabled)],k.prototype,"legendEnabled",void 0),e.__decorate([m.property({type:["show","hide","hide-children"]})],k.prototype,"listMode",void 0),e.__decorate([m.property({type:String,json:{write:{ignoreOrigin:!0}}})],k.prototype,"mapUrl",void 0),e.__decorate([m.property({type:Boolean,json:{read:!1,write:{enabled:!0,overridePolicy:()=>({enabled:!1})}}})],k.prototype,"isReference",void 0),e.__decorate([m.property({type:["WMS"]})],k.prototype,"operationalLayerType",void 0),e.__decorate([m.property()],k.prototype,"resourceInfo",void 0),e.__decorate([m.property({type:x,json:{origins:{service:{read:{source:"extent.spatialReference"}}},write:!1}})],k.prototype,"spatialReference",void 0),e.__decorate([f.reader(["web-document","portal-item"],"spatialReference",["spatialReferences"])],k.prototype,"readSpatialReferenceFromItemOrDocument",null),e.__decorate([m.property({type:[h.Integer],json:{read:!1,origins:{service:{read:!0},"web-document":{read:!1,write:{ignoreOrigin:!0}},"portal-item":{read:!1,write:{ignoreOrigin:!0}}}}})],k.prototype,"spatialReferences",void 0),e.__decorate([_.writer(["web-document","portal-item"],"spatialReferences")],k.prototype,"writeSpatialReferences",null),e.__decorate([m.property({type:s.ofType(C),json:{write:{target:"layers",overridePolicy(e,r,t){if(A(this.allSublayers,t))return{ignoreOrigin:!0}}}}})],k.prototype,"sublayers",void 0),e.__decorate([f.reader(["web-document","portal-item"],"sublayers",["layers","visibleLayers"])],k.prototype,"readSublayersFromItemOrMap",null),e.__decorate([f.reader("service","sublayers",["layers"])],k.prototype,"readSublayers",null),e.__decorate([_.writer("sublayers",{layers:{type:[C]},visibleLayers:{type:[String]}})],k.prototype,"writeSublayers",null),e.__decorate([m.property({json:{read:!1},readOnly:!0,value:"wms"})],k.prototype,"type",void 0),e.__decorate([m.property(j.url)],k.prototype,"url",null),e.__decorate([m.property({type:String,json:{write:{ignoreOrigin:!0}}})],k.prototype,"version",void 0),k=e.__decorate([g.subclass("esri.layers.WMSLayer")],k);return k}));
