/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../request","../core/arrayUtils","../core/Collection","../core/Error","../core/lang","../core/MultiOriginJSONSupport","../core/object","../core/promiseUtils","../core/reactiveUtils","../core/urlUtils","../core/accessorSupport/decorators/property","../core/has","../core/Logger","../core/accessorSupport/decorators/reader","../core/accessorSupport/decorators/subclass","../core/accessorSupport/decorators/writer","../geometry/Extent","./Layer","./WebTileLayer","./mixins/BlendLayer","./mixins/OperationalLayer","./mixins/PortalLayer","./mixins/RefreshableLayer","./mixins/ScaleRangeLayer","./support/imageBitmapUtils","./support/TileInfo","./support/TileInfoTilemapCache","./support/WMTSLayerInfo","./support/WMTSSublayer","./support/wmtsUtils"],(function(e,t,r,a,i,s,o,l,n,c,p,u,y,d,m,h,f,g,v,w,L,I,_,S,T,M,b,P,x,E,C){"use strict";var U;const R={"image/png":".png","image/png8":".png","image/png24":".png","image/png32":".png","image/jpg":".jpg","image/jpeg":".jpeg","image/gif":".gif","image/bmp":".bmp","image/tiff":".tif","image/jpgpng":"","image/jpegpng":"","image/unknown":""},O=new Set(["version","service","request","layer","style","format","tilematrixset","tilematrix","tilerow","tilecol"]);let j=U=class extends(L.BlendLayer(S.RefreshableLayer(T.ScaleRangeLayer(I.OperationalLayer(_.PortalLayer(o.MultiOriginJSONMixin(v))))))){constructor(...e){super(...e),this.activeLayer=null,this.copyright="",this.customParameters=null,this.customLayerParameters=null,this.fullExtent=null,this.operationalLayerType="WebTiledLayer",this.resourceInfo=null,this.serviceMode="RESTful",this.sublayers=null,this.type="wmts",this.version="1.0.0",this.addHandles([c.watch((()=>this.activeLayer),((e,t)=>{t&&!this.sublayers?.includes(t)&&(t.layer=null,t.parent=null),e&&(e.layer=this,e.parent=this)}),c.sync),c.on((()=>this.sublayers),"after-add",(({item:e})=>{e.layer=this,e.parent=this}),c.sync),c.on((()=>this.sublayers),"after-remove",(({item:e})=>{e.layer=null,e.parent=null}),c.sync),c.watch((()=>this.sublayers),((e,t)=>{if(t)for(const r of t)r.layer=null,r.parent=null;if(e)for(const r of e)r.layer=this,r.parent=this}),c.sync)])}normalizeCtorArgs(e,t){return"string"==typeof e?{url:e,...t}:e}load(e){return this.addResolvingPromise(this.loadFromPortal({supportedTypes:["WMTS"]},e).catch(n.throwIfAbortError).then((()=>this._fetchService(e))).catch((e=>{throw n.throwIfAbortError(e),new i("wmtslayer:unsupported-service-data","Invalid response from the WMTS service.",{error:e})}))),Promise.resolve(this)}readActiveLayerFromService(e,t,r){this.activeLayer||(this.activeLayer=new E);let a=t.layers.find((e=>e.id===this.activeLayer.id));return a||(a=t.layers[0]),this.activeLayer.read(a,r),this.activeLayer}readActiveLayerFromItemOrWebDoc(e,t){const{templateUrl:r,wmtsInfo:a}=t,i=r?this._getLowerCasedUrlParams(r):null,s=a?.layerIdentifier;let o=null;const l=a?.tileMatrixSet;l&&(Array.isArray(l)?l.length&&(o=l[0]):o=l);const n=i?.format,c=i?.style;return new E({id:s,imageFormat:n,styleId:c,tileMatrixSetId:o})}writeActiveLayer(e,t,r,a){const i=this.activeLayer;t.templateUrl=this.getUrlTemplate(i.id,i.tileMatrixSetId,i.imageFormat,i.styleId);const s=l.getDeepValue("tileMatrixSet.tileInfo",i);t.tileInfo=s?s.toJSON(a):null,t.wmtsInfo={...t.wmtsInfo,layerIdentifier:i.id,tileMatrixSet:i.tileMatrixSetId}}readCustomParameters(e,t){const r=t.wmtsInfo;return r?this._mergeParams(r.customParameters,r.url):null}get fullExtents(){return this.activeLayer.fullExtents}readServiceMode(e,t){return t.templateUrl.includes("?")?"KVP":"RESTful"}readSublayersFromService(e,t,r){return A(t.layers,r)}get supportedSpatialReferences(){return this.activeLayer.tileMatrixSets?.map((e=>e.tileInfo?.spatialReference)).toArray().filter(r.isSome)??[]}get tilemapCache(){const e=this.activeLayer?.tileMatrixSet?.tileInfo;return e?new P(e):void 0}get title(){return this.activeLayer?.title??"Layer"}set title(e){this._overrideIfSome("title",e)}get url(){return this._get("url")}set url(e){e&&e.endsWith("/")?this._set("url",e.slice(0,-1)):this._set("url",e)}createWebTileLayer(e){const t=this.getUrlTemplate(this.activeLayer.id,this.activeLayer.tileMatrixSetId,this.activeLayer.imageFormat,this.activeLayer.styleId),r=this._getTileMatrixSetById(e.tileMatrixSetId),a=r?.tileInfo,i=e.fullExtent,s=new x.WMTSLayerInfo({layerIdentifier:e.id,tileMatrixSet:e.tileMatrixSetId,url:this.url});return this.customLayerParameters&&(s.customLayerParameters=this.customLayerParameters),this.customParameters&&(s.customParameters=this.customParameters),new w({fullExtent:i,urlTemplate:t,tileInfo:a,wmtsInfo:s})}async fetchTile(e,r,a,i={}){const{signal:s}=i,o=this.getTileUrl(e,r,a),{data:l}=await t(o,{responseType:"image",signal:s});return l}async fetchImageBitmapTile(e,r,a,i={}){const{signal:s}=i;if(this.fetchTile!==U.prototype.fetchTile){const t=await this.fetchTile(e,r,a,i);return M.createTileBitmap(t,e,r,a,s)}const o=this.getTileUrl(e,r,a),{data:l}=await t(o,{responseType:"blob",signal:s});return M.createTileBitmap(l,e,r,a,s)}findSublayerById(e){return this.sublayers?.find((t=>t.id===e))}getTileUrl(e,t,r){const a=this._getTileMatrixSetById(this.activeLayer.tileMatrixSetId),i=a?.tileInfo?.lods[e],s=i?i.levelValue||`${i.level}`:`${e}`;let o=this.resourceInfo?"":C.getTileUrlFromResourceUrls({dimensionMap:this.dimensionMap,layerMap:this.layerMap},this.activeLayer.id,this.activeLayer.tileMatrixSetId,this.activeLayer.imageFormat,this.activeLayer.styleId,s,t,r);if(!o){o=this.getUrlTemplate(this.activeLayer.id,this.activeLayer.tileMatrixSetId,this.activeLayer.imageFormat,this.activeLayer.styleId).replaceAll(/\{level\}/gi,s).replaceAll(/\{row\}/gi,`${t}`).replaceAll(/\{col\}/gi,`${r}`)}return o=this._appendCustomLayerParameters(o),o}getUrlTemplate(e,t,r,a){if(!this.resourceInfo){const r=C.getTileUrlTemplateFromResourceUrls({dimensionMap:this.dimensionMap,layerMap:this.layerMap},e,t,a);if(r)return r}if("KVP"===this.serviceMode)return this.url+"?SERVICE=WMTS&VERSION="+this.version+"&REQUEST=GetTile&LAYER="+e+"&STYLE="+a+"&FORMAT="+r+"&TILEMATRIXSET="+t+"&TILEMATRIX={level}&TILEROW={row}&TILECOL={col}";if("RESTful"===this.serviceMode){let i="";return R[r.toLowerCase()]&&(i=R[r.toLowerCase()]),this.url+e+"/"+a+"/"+t+"/{level}/{row}/{col}"+i}return""}async _fetchService(e){let t;if(this.resourceInfo)"KVP"===this.resourceInfo.serviceMode&&(this.url+=this.url.includes("?")?"":"?"),t={ssl:!1,data:this.resourceInfo};else try{t=await this._getCapabilities(this.serviceMode,e),C.validateCapabilities(t.data)}catch{const a="KVP"===this.serviceMode?"RESTful":"KVP";try{t=await this._getCapabilities(a,e),C.validateCapabilities(t.data),this.serviceMode=a}catch(r){throw new i("wmtslayer:unsupported-service-data","Services does not support RESTful or KVP service modes.",{error:r})}}this.resourceInfo?t.data=C.parseResourceInfo(t.data):t.data=C.parseCapabilities(t.data,{serviceMode:this.serviceMode,url:this.url}),t.data&&this.read(t.data,{origin:"service"})}async _getCapabilities(e,r){const a=this._getCapabilitiesUrl(e);return await t(a,{...r,responseType:"text"})}_getTileMatrixSetById(e){const t=this.findSublayerById(this.activeLayer.id),r=t?.tileMatrixSets?.find((t=>t.id===e));return r}_appendCustomParameters(e){return this._appendParameters(e,this.customParameters)}_appendCustomLayerParameters(e){return this._appendParameters(e,{...s.clone(this.customParameters),...this.customLayerParameters})}_appendParameters(e,t){const r=p.urlToObject(e),a={...r.query,...t},i=p.objectToQuery(a);return""===i?r.path:`${r.path}?${i}`}_getCapabilitiesUrl(e){this.url=p.urlToObject(this.url).path;let t=this.url;switch(e){case"KVP":t+=`?request=GetCapabilities&service=WMTS&version=${this.version}`;break;case"RESTful":{const e=`/${this.version}/WMTSCapabilities.xml`,r=new RegExp(e,"i");t=t.replace(r,""),t+=e;break}}return this._appendCustomParameters(t)}_getLowerCasedUrlParams(e){if(!e)return null;const t=p.urlToObject(e).query;if(!t)return null;const r={};return Object.keys(t).forEach((e=>{r[e.toLowerCase()]=t[e]})),r}_mergeParams(e,t){const r=this._getLowerCasedUrlParams(t);if(r){const t=Object.keys(r);t.length&&(e=e?s.clone(e):{},t.forEach((t=>{e.hasOwnProperty(t)||O.has(t)||(e[t]=r[t])})))}return e}};function A(e,t){return e.map((e=>{const r=new E;return r.read(e,t),r}))}e.__decorate([u.property()],j.prototype,"dimensionMap",void 0),e.__decorate([u.property()],j.prototype,"layerMap",void 0),e.__decorate([u.property({type:E,json:{origins:{"web-document":{write:{ignoreOrigin:!0}}}}})],j.prototype,"activeLayer",void 0),e.__decorate([m.reader("service","activeLayer",["layers"])],j.prototype,"readActiveLayerFromService",null),e.__decorate([m.reader(["web-document","portal-item"],"activeLayer",["wmtsInfo"])],j.prototype,"readActiveLayerFromItemOrWebDoc",null),e.__decorate([f.writer(["web-document","portal-item"],"activeLayer",{templateUrl:{type:String},tileInfo:{type:b},"wmtsInfo.layerIdentifier":{type:String},"wmtsInfo.tileMatrixSet":{type:String}})],j.prototype,"writeActiveLayer",null),e.__decorate([u.property({type:String,value:"",json:{write:!0}})],j.prototype,"copyright",void 0),e.__decorate([u.property({type:["show","hide"]})],j.prototype,"listMode",void 0),e.__decorate([u.property({json:{read:!0,write:!0}})],j.prototype,"blendMode",void 0),e.__decorate([u.property({json:{origins:{"web-document":{read:{source:["wmtsInfo.customParameters","wmtsInfo.url"]},write:{target:"wmtsInfo.customParameters"}},"portal-item":{read:{source:["wmtsInfo.customParameters","wmtsInfo.url"]},write:{target:"wmtsInfo.customParameters"}}}}})],j.prototype,"customParameters",void 0),e.__decorate([m.reader(["portal-item","web-document"],"customParameters")],j.prototype,"readCustomParameters",null),e.__decorate([u.property({json:{origins:{"web-document":{read:{source:"wmtsInfo.customLayerParameters"},write:{target:"wmtsInfo.customLayerParameters"}},"portal-item":{read:{source:"wmtsInfo.customLayerParameters"},write:{target:"wmtsInfo.customLayerParameters"}}}}})],j.prototype,"customLayerParameters",void 0),e.__decorate([u.property({type:g,json:{write:{ignoreOrigin:!0},origins:{"web-document":{read:{source:"fullExtent"}},"portal-item":{read:{source:"fullExtent"}}}}})],j.prototype,"fullExtent",void 0),e.__decorate([u.property({readOnly:!0})],j.prototype,"fullExtents",null),e.__decorate([u.property({type:["WebTiledLayer"]})],j.prototype,"operationalLayerType",void 0),e.__decorate([u.property()],j.prototype,"resourceInfo",void 0),e.__decorate([u.property()],j.prototype,"serviceMode",void 0),e.__decorate([m.reader(["portal-item","web-document"],"serviceMode",["templateUrl"])],j.prototype,"readServiceMode",null),e.__decorate([u.property({type:a.ofType(E)})],j.prototype,"sublayers",void 0),e.__decorate([m.reader("service","sublayers",["layers"])],j.prototype,"readSublayersFromService",null),e.__decorate([u.property({readOnly:!0})],j.prototype,"supportedSpatialReferences",null),e.__decorate([u.property({readOnly:!0})],j.prototype,"tilemapCache",null),e.__decorate([u.property({json:{read:{source:"title"}}})],j.prototype,"title",null),e.__decorate([u.property({json:{read:!1},readOnly:!0,value:"wmts"})],j.prototype,"type",void 0),e.__decorate([u.property({json:{origins:{service:{read:{source:"tileUrl"}},"web-document":{read:{source:"wmtsInfo.url"},write:{target:"wmtsInfo.url"}},"portal-item":{read:{source:"wmtsInfo.url"},write:{target:"wmtsInfo.url"}}}}})],j.prototype,"url",null),e.__decorate([u.property()],j.prototype,"version",void 0),j=U=e.__decorate([h.subclass("esri.layers.WMTSLayer")],j);return j}));
