/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../geometry","../request","../core/Error","../core/MultiOriginJSONSupport","../core/string","../core/urlUtils","../core/accessorSupport/decorators/property","../core/has","../core/Logger","../core/RandomLCG","../core/accessorSupport/decorators/reader","../core/accessorSupport/decorators/subclass","../core/accessorSupport/decorators/writer","./Layer","./mixins/BlendLayer","./mixins/OperationalLayer","./mixins/PortalLayer","./mixins/RefreshableLayer","./mixins/ScaleRangeLayer","./support/imageBitmapUtils","./support/LOD","./support/TileInfo","./support/WMTSLayerInfo","../geometry/Extent","../geometry/SpatialReference","../geometry/Point"],(function(e,t,r,l,o,s,a,i,n,p,c,u,y,d,h,m,f,v,w,g,_,T,b,R,S,L,U){"use strict";var x;let P=x=class extends(m.BlendLayer(w.RefreshableLayer(g.ScaleRangeLayer(f.OperationalLayer(v.PortalLayer(o.MultiOriginJSONMixin(h))))))){constructor(...e){super(...e),this.copyright="",this.fullExtent=new S(-20037508.342787,-20037508.34278,20037508.34278,20037508.342787,L.WebMercator),this.legendEnabled=!1,this.isReference=null,this.popupEnabled=!1,this.spatialReference=L.WebMercator,this.subDomains=null,this.tileInfo=new b({size:[256,256],dpi:96,format:"png8",compressionQuality:0,origin:new U({x:-20037508.342787,y:20037508.342787,spatialReference:L.WebMercator}),spatialReference:L.WebMercator,lods:[new T({level:0,scale:591657527.591555,resolution:156543.033928}),new T({level:1,scale:295828763.795777,resolution:78271.5169639999}),new T({level:2,scale:147914381.897889,resolution:39135.7584820001}),new T({level:3,scale:73957190.948944,resolution:19567.8792409999}),new T({level:4,scale:36978595.474472,resolution:9783.93962049996}),new T({level:5,scale:18489297.737236,resolution:4891.96981024998}),new T({level:6,scale:9244648.868618,resolution:2445.98490512499}),new T({level:7,scale:4622324.434309,resolution:1222.99245256249}),new T({level:8,scale:2311162.217155,resolution:611.49622628138}),new T({level:9,scale:1155581.108577,resolution:305.748113140558}),new T({level:10,scale:577790.554289,resolution:152.874056570411}),new T({level:11,scale:288895.277144,resolution:76.4370282850732}),new T({level:12,scale:144447.638572,resolution:38.2185141425366}),new T({level:13,scale:72223.819286,resolution:19.1092570712683}),new T({level:14,scale:36111.909643,resolution:9.55462853563415}),new T({level:15,scale:18055.954822,resolution:4.77731426794937}),new T({level:16,scale:9027.977411,resolution:2.38865713397468}),new T({level:17,scale:4513.988705,resolution:1.19432856685505}),new T({level:18,scale:2256.994353,resolution:.597164283559817}),new T({level:19,scale:1128.497176,resolution:.298582141647617}),new T({level:20,scale:564.248588,resolution:.14929107082380833}),new T({level:21,scale:282.124294,resolution:.07464553541190416}),new T({level:22,scale:141.062147,resolution:.03732276770595208}),new T({level:23,scale:70.5310735,resolution:.01866138385297604})]}),this.type="web-tile",this.urlTemplate=null,this.wmtsInfo=null}normalizeCtorArgs(e,t){return"string"==typeof e?{urlTemplate:e,...t}:e}load(e){const t=this.loadFromPortal({supportedTypes:["WMTS"]},e).then((()=>{let e="";if(this.urlTemplate)if(this.spatialReference.equals(this.tileInfo.spatialReference)){const t=new a.Url(this.urlTemplate);!(!!this.subDomains&&this.subDomains.length>0)&&t.authority?.includes("{subDomain}")&&(e="is missing 'subDomains' property")}else e="spatialReference must match tileInfo.spatialReference";else e="is missing the required 'urlTemplate' property value";if(e)throw new l("web-tile-layer:load",`WebTileLayer (title: '${this.title}', id: '${this.id}') ${e}`)}));return this.addResolvingPromise(t),Promise.resolve(this)}get levelValues(){const e=[];if(!this.tileInfo)return null;for(const t of this.tileInfo.lods)e[t.level]=t.levelValue||t.level;return e}readSpatialReference(e,t){return e||L.fromJSON(t.fullExtent?.spatialReference)}get tileServers(){if(!this.urlTemplate)return null;const e=[],{urlTemplate:t,subDomains:r}=this,l=new a.Url(t),o=l.scheme?l.scheme+"://":"//",s=o+l.authority+"/",i=l.authority;if(i?.includes("{subDomain}")){if(r&&r.length>0&&i.split(".").length>1)for(const a of r)e.push(o+i.replaceAll(/\{subDomain\}/gi,a)+"/")}else e.push(s);return e.map(a.ensureTrailingSlash)}get urlPath(){if(!this.urlTemplate)return null;const e=this.urlTemplate,t=new a.Url(e),r=(t.scheme?t.scheme+"://":"//")+t.authority+"/";return e.slice(r.length)}readUrlTemplate(e,t){return e||t.templateUrl}writeUrlTemplate(e,t){a.isProtocolRelative(e)&&(e="https:"+e),e&&(e=e.replaceAll(/\{z\}/gi,"{level}").replaceAll(/\{x\}/gi,"{col}").replaceAll(/\{y\}/gi,"{row}"),e=a.normalize(e)),t.templateUrl=e}fetchTile(e,t,l,o={}){const{signal:s}=o,a=this.getTileUrl(e,t,l),i={responseType:"image",signal:s,query:{...this.refreshParameters}};return r(a,i).then((e=>e.data))}async fetchImageBitmapTile(e,t,l,o={}){const{signal:s}=o;if(this.fetchTile!==x.prototype.fetchTile){const r=await this.fetchTile(e,t,l,o);return _.createTileBitmap(r,e,t,l,s)}const a=this.getTileUrl(e,t,l),i={responseType:"blob",signal:s,query:{...this.refreshParameters}},{data:n}=await r(a,i);return _.createTileBitmap(n,e,t,l,s)}getTileUrl(e,t,r){const{levelValues:l,tileServers:o,urlPath:a}=this;if(!l||!o||!a)return"";const i=l[e];return o[t%o.length]+s.replace(a,{level:i,z:i,col:r,x:r,row:t,y:t})}};e.__decorate([i.property({type:String,value:"",json:{write:!0}})],P.prototype,"copyright",void 0),e.__decorate([i.property({type:S,json:{write:!0},nonNullable:!0})],P.prototype,"fullExtent",void 0),e.__decorate([i.property({readOnly:!0,json:{read:!1,write:!1}})],P.prototype,"legendEnabled",void 0),e.__decorate([i.property({type:["show","hide"]})],P.prototype,"listMode",void 0),e.__decorate([i.property({json:{read:!0,write:!0}})],P.prototype,"blendMode",void 0),e.__decorate([i.property()],P.prototype,"levelValues",null),e.__decorate([i.property({type:Boolean,json:{read:!1,write:{enabled:!0,overridePolicy:()=>({enabled:!1})}}})],P.prototype,"isReference",void 0),e.__decorate([i.property({type:["WebTiledLayer"],value:"WebTiledLayer"})],P.prototype,"operationalLayerType",void 0),e.__decorate([i.property({readOnly:!0,json:{read:!1,write:!1}})],P.prototype,"popupEnabled",void 0),e.__decorate([i.property({type:L})],P.prototype,"spatialReference",void 0),e.__decorate([u.reader("spatialReference",["spatialReference","fullExtent.spatialReference"])],P.prototype,"readSpatialReference",null),e.__decorate([i.property({type:[String],json:{write:!0}})],P.prototype,"subDomains",void 0),e.__decorate([i.property({type:b,json:{write:!0}})],P.prototype,"tileInfo",void 0),e.__decorate([i.property({readOnly:!0})],P.prototype,"tileServers",null),e.__decorate([i.property({json:{read:!1}})],P.prototype,"type",void 0),e.__decorate([i.property()],P.prototype,"urlPath",null),e.__decorate([i.property({type:String,json:{origins:{"portal-item":{read:{source:"url"}}}}})],P.prototype,"urlTemplate",void 0),e.__decorate([u.reader("urlTemplate",["urlTemplate","templateUrl"])],P.prototype,"readUrlTemplate",null),e.__decorate([d.writer("urlTemplate",{templateUrl:{type:String}})],P.prototype,"writeUrlTemplate",null),e.__decorate([i.property({type:R.WMTSLayerInfo,json:{write:!0}})],P.prototype,"wmtsInfo",void 0),P=x=e.__decorate([y.subclass("esri.layers.WebTileLayer")],P);return P}));
