/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../Graphic","../../PopupTemplate","../../renderers/ClassBreaksRenderer","../../renderers/DictionaryRenderer","../../renderers/DotDensityRenderer","../../renderers/HeatmapRenderer","../../renderers/PieChartRenderer","../../renderers/Renderer","../../renderers/SimpleRenderer","../../renderers/UniqueValueRenderer","../../renderers/support/jsonUtils","../../renderers/support/types","../../request","../../core/Error","../../core/jsonMap","../../core/Loadable","../../core/Logger","../../core/Promise","../../core/accessorSupport/decorators/property","../../core/has","../../core/RandomLCG","../../core/accessorSupport/decorators/enumeration","../../core/accessorSupport/decorators/reader","../../core/accessorSupport/decorators/subclass","../../geometry/Extent","../../geometry/SpatialReference","../FeatureLayer","./BuildingSublayer","../support/capabilities","../support/commonProperties","../support/fieldProperties","../support/FieldsIndex","../support/fieldUtils","../support/I3SIndexInfo","../support/I3SLayerDefinitions","../../rest/support/Query","../../support/popupUtils","../../symbols/support/ElevationInfo","../../views/3d/layers/i3s/I3SUtil","../../views/layers/support/popupUtils"],(function(e,r,t,o,a,s,i,p,n,l,d,y,u,c,h,f,_,m,g,b,v,I,S,L,F,w,P,O,x,T,q,j,R,D,U,E,Q,A,C,N,M){"use strict";const K=j.defineFieldProperties();let B=class extends(_.LoadableMixin(g.EsriPromiseMixin(x))){constructor(e){super(e),this.type="building-component",this.nodePages=null,this.materialDefinitions=[],this.textureSetDefinitions=[],this.geometryDefinitions=[],this.indexInfo=null,this.serviceUpdateTimeStamp=null,this.store=null,this.attributeStorageInfo=[],this.fields=[],this.associatedLayer=null,this.outFields=null,this.listMode="show",this.renderer=null,this.definitionExpression=null,this.popupEnabled=!0,this.popupTemplate=null,this.layerType="3d-object"}get parsedUrl(){return this.layer?{path:`${this.layer.parsedUrl?.path}/sublayers/${this.id}`,query:this.layer.parsedUrl?.query}:{path:""}}get fieldsIndex(){return new R(this.fields)}readAssociatedLayer(e,r){const t=this.layer.associatedFeatureServiceItem,o=r.associatedLayerID;return null!=t&&"number"==typeof o?new O({portalItem:t,customParameters:this.customParameters,layerId:o}):null}get objectIdField(){if(null!=this.fields)for(const e of this.fields)if("oid"===e.type)return e.name;return null}get displayField(){return null!=this.associatedLayer?this.associatedLayer.displayField:void 0}get apiKey(){return this.layer.apiKey}get customParameters(){return this.layer.customParameters}get fullExtent(){return this.layer.fullExtent}get spatialReference(){return this.layer.spatialReference}get version(){return this.layer.version}get elevationInfo(){return this.layer.elevationInfo}get minScale(){return this.layer.minScale}get maxScale(){return this.layer.maxScale}get effectiveScaleRange(){return this.layer.effectiveScaleRange}get defaultPopupTemplate(){return this.createPopupTemplate()}load(e){const r=null!=e?e.signal:null,t=this._fetchService(r).then((()=>{this.indexInfo=U.fetchIndexInfo(this.parsedUrl.path,this.rootNode,this.nodePages,this.customParameters,this.apiKey,m.getLogger(this),r)}));return this.addResolvingPromise(t),Promise.resolve(this)}createPopupTemplate(e){return A.createPopupTemplate(this,e)}async _fetchService(e){const r=(await c(this.parsedUrl.path,{query:{f:"json",...this.customParameters,token:this.apiKey},responseType:"json",signal:e})).data;this.read(r,{origin:"service",url:this.parsedUrl})}getField(e){return this.fieldsIndex.get(e)}getFieldDomain(e,r){const t=this.getFeatureType(r?.feature)?.domains?.[e];return t&&"inherited"!==t.type?t:this.getField(e)?.domain??null}getFeatureType(e){return e&&null!=this.associatedLayer?this.associatedLayer.getFeatureType(e):null}get types(){return null!=this.associatedLayer?this.associatedLayer.types??[]:[]}get typeIdField(){return null!=this.associatedLayer?this.associatedLayer.typeIdField:null}get geometryType(){return"3d-object"===this.layerType?"mesh":"point"}get profile(){return"3d-object"===this.layerType?"mesh-pyramids":"points"}get capabilities(){const e=null!=this.associatedLayer&&this.associatedLayer.capabilities?this.associatedLayer.capabilities:T.zeroCapabilities,{query:r,data:{supportsZ:t,supportsM:o,isVersioned:a}}=e;return{query:r,data:{supportsZ:t,supportsM:o,isVersioned:a}}}createQuery(){const e=new Q;return"mesh"!==this.geometryType&&(e.returnGeometry=!0,e.returnZ=!0),e.where=this.definitionExpression||"1=1",e.sqlFormat="standard",e}queryExtent(e,r){return this._getAssociatedLayerForQuery().then((t=>t.queryExtent(e||this.createQuery(),r)))}queryFeatureCount(e,r){return this._getAssociatedLayerForQuery().then((t=>t.queryFeatureCount(e||this.createQuery(),r)))}queryFeatures(e,r){return this._getAssociatedLayerForQuery().then((t=>t.queryFeatures(e||this.createQuery(),r))).then((e=>{if(e?.features)for(const r of e.features)r.layer=this.layer,r.sourceLayer=this;return e}))}queryObjectIds(e,r){return this._getAssociatedLayerForQuery().then((t=>t.queryObjectIds(e||this.createQuery(),r)))}async queryCachedAttributes(e,r){const t=D.unpackFieldNames(this.fieldsIndex,await M.getRequiredFields(this,M.getFetchPopupTemplate(this)));return N.queryAttributesFromCachedAttributesId(this.parsedUrl.path,this.attributeStorageInfo,e,r,t,this.apiKey,this.customParameters)}async queryCachedFeature(e,t){const o=await this.queryCachedAttributes(e,[t]);if(!o||0===o.length)throw new h("scenelayer:feature-not-in-cached-data","Feature not found in cached data");return new r({attributes:o[0],layer:this,sourceLayer:this})}getFieldUsageInfo(e){return this.fieldsIndex.has(e)?{supportsLabelingInfo:!1,supportsRenderer:!1,supportsPopupTemplate:!1,supportsLayerQuery:!1}:{supportsLabelingInfo:!1,supportsRenderer:!0,supportsPopupTemplate:!0,supportsLayerQuery:null!=this.associatedLayer}}_getAssociatedLayerForQuery(){const e=this.associatedLayer;return null!=e&&e.loaded?Promise.resolve(e):this._loadAssociatedLayerForQuery()}async _loadAssociatedLayerForQuery(){if(await this.load(),null==this.associatedLayer)throw new h("buildingscenelayer:query-not-available","BuildingSceneLayer component layer queries are not available without an associated feature layer",{layer:this});try{await this.associatedLayer.load()}catch(e){throw new h("buildingscenelayer:query-not-available","BuildingSceneLayer associated feature layer could not be loaded",{layer:this,error:e})}return this.associatedLayer}};e.__decorate([b.property({readOnly:!0})],B.prototype,"parsedUrl",null),e.__decorate([b.property({type:E.I3SNodePageDefinition,readOnly:!0})],B.prototype,"nodePages",void 0),e.__decorate([b.property({type:[E.I3SMaterialDefinition],readOnly:!0})],B.prototype,"materialDefinitions",void 0),e.__decorate([b.property({type:[E.I3STextureSetDefinition],readOnly:!0})],B.prototype,"textureSetDefinitions",void 0),e.__decorate([b.property({type:[E.I3SGeometryDefinition],readOnly:!0})],B.prototype,"geometryDefinitions",void 0),e.__decorate([b.property({readOnly:!0})],B.prototype,"serviceUpdateTimeStamp",void 0),e.__decorate([b.property({readOnly:!0})],B.prototype,"store",void 0),e.__decorate([b.property({type:String,readOnly:!0,json:{read:{source:"store.rootNode"}}})],B.prototype,"rootNode",void 0),e.__decorate([b.property({readOnly:!0})],B.prototype,"attributeStorageInfo",void 0),e.__decorate([b.property(K.fields)],B.prototype,"fields",void 0),e.__decorate([b.property({readOnly:!0})],B.prototype,"fieldsIndex",null),e.__decorate([b.property({readOnly:!0,type:O})],B.prototype,"associatedLayer",void 0),e.__decorate([L.reader("service","associatedLayer",["associatedLayerID"])],B.prototype,"readAssociatedLayer",null),e.__decorate([b.property(K.outFields)],B.prototype,"outFields",void 0),e.__decorate([b.property({type:String,readOnly:!0})],B.prototype,"objectIdField",null),e.__decorate([b.property({readOnly:!0,type:String,json:{read:!1}})],B.prototype,"displayField",null),e.__decorate([b.property({readOnly:!0,type:String})],B.prototype,"apiKey",null),e.__decorate([b.property({readOnly:!0,type:String})],B.prototype,"customParameters",null),e.__decorate([b.property({readOnly:!0,type:w})],B.prototype,"fullExtent",null),e.__decorate([b.property({readOnly:!0,type:P})],B.prototype,"spatialReference",null),e.__decorate([b.property({readOnly:!0})],B.prototype,"version",null),e.__decorate([b.property({readOnly:!0,type:C})],B.prototype,"elevationInfo",null),e.__decorate([b.property({readOnly:!0,type:Number})],B.prototype,"minScale",null),e.__decorate([b.property({readOnly:!0,type:Number})],B.prototype,"maxScale",null),e.__decorate([b.property({readOnly:!0,type:Number})],B.prototype,"effectiveScaleRange",null),e.__decorate([b.property({type:["hide","show"],json:{write:!0}})],B.prototype,"listMode",void 0),e.__decorate([b.property({types:u.webSceneRendererTypes,json:{origins:{service:{read:{source:"drawingInfo.renderer"}}},name:"layerDefinition.drawingInfo.renderer",write:!0},value:null})],B.prototype,"renderer",void 0),e.__decorate([b.property({type:String,json:{origins:{service:{read:!1,write:!1}},name:"layerDefinition.definitionExpression",write:{enabled:!0,allowNull:!0}}})],B.prototype,"definitionExpression",void 0),e.__decorate([b.property(q.popupEnabled)],B.prototype,"popupEnabled",void 0),e.__decorate([b.property({type:t,json:{read:{source:"popupInfo"},write:{target:"popupInfo"}}})],B.prototype,"popupTemplate",void 0),e.__decorate([b.property({readOnly:!0,type:String,json:{origins:{service:{read:{source:"store.normalReferenceFrame"}}},read:!1}})],B.prototype,"normalReferenceFrame",void 0),e.__decorate([b.property({readOnly:!0,json:{read:!1}})],B.prototype,"defaultPopupTemplate",null),e.__decorate([b.property()],B.prototype,"types",null),e.__decorate([b.property()],B.prototype,"typeIdField",null),e.__decorate([b.property({json:{write:!1}}),S.enumeration(new f.JSONMap({"3DObject":"3d-object",Point:"point"}))],B.prototype,"layerType",void 0),e.__decorate([b.property()],B.prototype,"geometryType",null),e.__decorate([b.property()],B.prototype,"profile",null),e.__decorate([b.property({readOnly:!0,json:{read:!1}})],B.prototype,"capabilities",null),e.__decorate([b.property({readOnly:!0})],B.prototype,"statisticsInfo",void 0),B=e.__decorate([F.subclass("esri.layers.buildingSublayers.BuildingComponentSublayer")],B);return B}));
