/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../colorUtils","../../core/screenUtils","../../core/libs/gl-matrix-2/factories/mat4f32","./colorMatrixFunctions"],(function(t,r,s,e,o){"use strict";class i{constructor(t,r,s){this.strength=t,this.radius=r,this.threshold=s,this.type="bloom"}interpolate(t,r,s){this.strength=l(t.strength,r.strength,s),this.radius=l(t.radius,r.radius,s),this.threshold=l(t.threshold,r.threshold,s)}clone(){return new i(this.strength,this.radius,this.threshold)}toJSON(){return{type:"bloom",radius:d(this.radius),strength:this.strength,threshold:this.threshold}}}class a{constructor(t){this.radius=t,this.type="blur"}interpolate(t,r,s){this.radius=Math.round(l(t.radius,r.radius,s))}clone(){return new a(this.radius)}toJSON(){return{type:"blur",radius:d(this.radius)}}}class n{constructor(t,r){this.type=t,this.amount=r,"invert"!==this.type&&"grayscale"!==this.type&&"sepia"!==this.type||(this.amount=Math.min(this.amount,1))}get colorMatrix(){return this._colorMatrix||this._updateMatrix(),this._colorMatrix}interpolate(t,r,s){this.amount=l(t.amount,r.amount,s),this._updateMatrix()}clone(){return new n(this.type,this.amount)}toJSON(){return{type:this.type,amount:this.amount}}_updateMatrix(){const t=this._colorMatrix||e.create();switch(this.type){case"brightness":this._colorMatrix=o.brightness(t,this.amount);break;case"contrast":this._colorMatrix=o.contrast(t,this.amount);break;case"grayscale":this._colorMatrix=o.grayscale(t,this.amount);break;case"invert":this._colorMatrix=o.invert(t,this.amount);break;case"saturate":this._colorMatrix=o.saturate(t,this.amount);break;case"sepia":this._colorMatrix=o.sepia(t,this.amount)}}}class h{constructor(t,r,s,e){this.offsetX=t,this.offsetY=r,this.blurRadius=s,this.color=e,this.type="drop-shadow"}interpolate(t,r,s){this.offsetX=l(t.offsetX,r.offsetX,s),this.offsetY=l(t.offsetY,r.offsetY,s),this.blurRadius=l(t.blurRadius,r.blurRadius,s),this.color[0]=Math.round(l(t.color[0],r.color[0],s)),this.color[1]=Math.round(l(t.color[1],r.color[1],s)),this.color[2]=Math.round(l(t.color[2],r.color[2],s)),this.color[3]=l(t.color[3],r.color[3],s)}clone(){return new h(this.offsetX,this.offsetY,this.blurRadius,[...this.color])}toJSON(){const t=[...this.color];return t[3]*=255,{type:"drop-shadow",xoffset:d(this.offsetX),yoffset:d(this.offsetY),blurRadius:d(this.blurRadius),color:t}}}class u{constructor(t){this.angle=t,this.type="hue-rotate"}get colorMatrix(){return this._colorMatrix||this._updateMatrix(),this._colorMatrix}interpolate(t,r,s){this.angle=l(t.angle,r.angle,s),this._updateMatrix()}clone(){return new u(this.angle)}toJSON(){return{type:"hue-rotate",angle:this.angle}}_updateMatrix(){const t=this._colorMatrix||e.create();this._colorMatrix=o.rotateHue(t,this.angle)}}class c{constructor(t){this.amount=t,this.type="opacity",this.amount=Math.min(this.amount,1)}interpolate(t,r,s){this.amount=l(t.amount,r.amount,s)}clone(){return new c(this.amount)}toJSON(){return{type:"opacity",amount:this.amount}}}function l(t,r,s){return t+(r-t)*s}function d(t){return Math.round(1e3*s.px2pt(t))/1e3}function f(t){switch(t.type){case"grayscale":case"sepia":case"invert":return new n(t.type,0);case"saturate":case"brightness":case"contrast":return new n(t.type,1);case"opacity":return new c(1);case"hue-rotate":return new u(0);case"blur":return new a(0);case"drop-shadow":return new h(0,0,0,[...r.getNamedColor("transparent")]);case"bloom":return new i(0,0,1)}}t.BloomEffect=i,t.BlurEffect=a,t.ColorMatrixEffect=n,t.DropShadowEffect=h,t.HueRotateEffect=u,t.OpacityEffect=c,t.createEffectWithInitialValues=f,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
