/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../core/byteSizeEstimations","../../core/has","../../core/typedArrayUtil","../../core/uid","../../geometry/SpatialReference","../../geometry/support/aaBoundingBox","../../geometry/support/aaBoundingRect","../../geometry/support/quantizationUtils","../../geometry/support/typeUtils","../support/Field","./dehydratedFeatureComparison"],(function(e,t,n,s,r,i,a,o,l,u,c,p){"use strict";class h{constructor(e,t,n){this.uid=e,this.geometry=t,this.attributes=n,this.visible=!0,this.objectId=null,this.centroid=null}}function m(e){return null!=e.geometry}class y{constructor(){this.exceededTransferLimit=!1,this.features=[],this.fields=[],this.hasM=!1,this.hasZ=!1,this.geometryType=null,this.objectIdFieldName=null,this.globalIdFieldName=null,this.geometryProperties=null,this.geohashFieldName=null,this.spatialReference=null,this.transform=null}}function g(e,t){const n=u.featureGeometryTypeKebabDictionary.fromJSON(e.geometryType),s=i.fromJSON(e.spatialReference),r=e.transform,a=e.objectIdFieldName,o=t?.maxStringAttributeLength,p=t?.maxStringAttributeFields;let h;const m=e.features.map((t=>{const i=d(t,n,s,e.objectIdFieldName),u=i.geometry;if(Z(i.attributes,p,o,(e=>{h??=[];const t=F(i,a);null!=t&&h.push({objectId:t,attribute:e})})),null!=u&&r)switch(u.type){case"point":i.geometry=l.unquantizePoint(r,u,u);break;case"multipoint":i.geometry=l.unquantizeMultipoint(r,u,u);break;case"polygon":i.geometry=l.unquantizePolygon(r,u,u);break;case"polyline":i.geometry=l.unquantizePolyline(r,u,u);break;case"extent":case"mesh":i.geometry=u}return i}));return{geometryType:n,features:m,spatialReference:s,fields:e.fields?.map((e=>c.fromJSON(e)))??[],objectIdFieldName:e.objectIdFieldName,globalIdFieldName:e.globalIdFieldName,geohashFieldName:e.geohashFieldName,geometryProperties:e.geometryProperties,hasZ:e.hasZ,hasM:e.hasM,exceededTransferLimit:e.exceededTransferLimit,transform:null,missingAttributes:h}}function d(e,t,n,s){return{uid:r.generateUID(),objectId:s&&e.attributes?e.attributes[s]:null,attributes:e.attributes,geometry:f(e.geometry,t,n),visible:!0}}function f(e,t,n){if(null==e)return null;switch(t){case"point":{const t=e;return{x:t.x,y:t.y,z:t.z,m:t.m,hasZ:null!=t.z,hasM:null!=t.m,type:"point",spatialReference:n}}case"polyline":{const t=e;return{paths:t.paths,hasZ:!!t.hasZ,hasM:!!t.hasM,type:"polyline",spatialReference:n}}case"polygon":{const t=e;return{rings:t.rings,hasZ:!!t.hasZ,hasM:!!t.hasM,type:"polygon",spatialReference:n}}case"multipoint":{const t=e;return{points:t.points,hasZ:!!t.hasZ,hasM:!!t.hasM,type:"multipoint",spatialReference:n}}}}function b(e){if(null==e)return 0;let t=32;switch(e.type){case"point":t+=42;break;case"polyline":case"polygon":{let n=0;const s=2+(e.hasZ?1:0)+(e.hasM?1:0),r="polyline"===e.type?e.paths:e.rings;for(const e of r)n+=e.length;t+=8*n*s+64,t+=128*n,t+=34,t+=32*(r.length+1);break}case"multipoint":{const n=2+(e.hasZ?1:0)+(e.hasM?1:0),s=e.points.length;t+=8*s*n+64,t+=128*s,t+=34,t+=32;break}case"extent":t+=98,e.hasM&&(t+=32),e.hasZ&&(t+=32);break;case"mesh":t+=s.estimateSize(e.vertexAttributes.position,e.vertexAttributes.normal,e.vertexAttributes.uv,e.vertexAttributes.tangent)}return t}function x(e){let n=32;return n+=t.estimateAttributesObjectSize(e.attributes),n+=3,n+=8+b(e.geometry),n}function A(e){if(null==e)return 0;switch(e.type){case"point":return 1;case"polyline":{let t=0;for(const n of e.paths)t+=n.length;return t}case"polygon":{let t=0;for(const n of e.rings)t+=n.length;return t}case"multipoint":return e.points.length;case"extent":return 2;case"mesh":{const t=e.vertexAttributes&&e.vertexAttributes.position;return t?t.length/3:0}default:return}}function N(e){if(null==e)return!1;switch(e.type){case"extent":case"point":return!0;case"polyline":for(const t of e.paths)if(t.length>0)return!0;return!1;case"polygon":for(const t of e.rings)if(t.length>0)return!0;return!1;case"multipoint":return e.points.length>0;case"mesh":return!e.loaded||e.vertexAttributes.position.length>0}}function z(e,t){switch(a.empty(t),"mesh"===e.type&&(e=e.extent),e.type){case"point":t[0]=t[3]=e.x,t[1]=t[4]=e.y,e.hasZ&&(t[2]=t[5]=e.z);break;case"polyline":for(let n=0;n<e.paths.length;n++)a.expandWithNestedArray(t,e.paths[n],!!e.hasZ);break;case"polygon":for(let n=0;n<e.rings.length;n++)a.expandWithNestedArray(t,e.rings[n],!!e.hasZ);break;case"multipoint":a.expandWithNestedArray(t,e.points,!!e.hasZ);break;case"extent":t[0]=e.xmin,t[1]=e.ymin,t[3]=e.xmax,t[4]=e.ymax,null!=e.zmin&&(t[2]=e.zmin),null!=e.zmax&&(t[5]=e.zmax)}}function S(e,t){switch(o.empty(t),"mesh"===e.type&&(e=e.extent),e.type){case"point":t[0]=t[2]=e.x,t[1]=t[3]=e.y;break;case"polyline":for(let n=0;n<e.paths.length;n++)o.expandWithNestedArray(t,e.paths[n]);break;case"polygon":for(let n=0;n<e.rings.length;n++)o.expandWithNestedArray(t,e.rings[n]);break;case"multipoint":o.expandWithNestedArray(t,e.points);break;case"extent":t[0]=e.xmin,t[1]=e.ymin,t[2]=e.xmax,t[3]=e.ymax}}function F(e,t){return null!=e.objectId?e.objectId:e.attributes&&t?e.attributes[t]:null}function Z(e,t,n,s){if(t?.size&&null!=n&&e)for(const r in e){if(!t.has(r))continue;const i=e[r];"string"==typeof i&&i.length>n&&(s(r),e[r]="")}}e.equals=p.equals,e.DehydratedFeatureClass=h,e.DehydratedFeatureSetClass=y,e.computeAABB=z,e.computeAABR=S,e.estimateGeometryObjectSize=b,e.estimateSize=x,e.fromFeatureSetJSON=g,e.fromJSONGeometry=f,e.getObjectId=F,e.hasGeometry=m,e.hasVertices=N,e.numVertices=A,e.removeLargeStringAttributes=Z,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
