/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../core/Error","../../core/Logger","../../core/maybe","../../geometry/support/aaBoundingBox","../../geometry/support/aaBoundingRect","../../geometry/support/jsonUtils","./OptimizedFeature","./OptimizedFeatureSet","./OptimizedGeometry"],(function(e,t,n,o,r,s,u,i,l,c){"use strict";function a(e,t){return e?t?4:3:t?3:2}const f=()=>n.getLogger("esri.layers.graphics.featureConversionUtils"),d={esriGeometryPoint:0,esriGeometryPolyline:2,esriGeometryPolygon:3,esriGeometryMultipoint:0,esriGeometryMultiPatch:3,esriGeometryEnvelope:0},m=(e,t,n,o,r,s)=>{e[n]=r,e[n+1]=s},h=(e,t,n,o,r,s)=>{e[n]=r,e[n+1]=s,e[n+2]=t[o+2]},g=(e,t,n,o,r,s)=>{e[n]=r,e[n+1]=s,e[n+2]=t[o+3]},y=(e,t,n,o,r,s)=>{e[n]=r,e[n+1]=s,e[n+2]=t[o+2],e[n+3]=t[o+3]};function p(e,t,n,o){if(e){if(n)return t&&o?y:h;if(t&&o)return g}else if(t&&o)return h;return m}function F({scale:e,translate:t},n){return Math.round((n-t[0])/e[0])}function I({scale:e,translate:t},n){return Math.round((t[1]-n)/e[1])}function M(e,t){return T(e,t,0)}function b(e,t){return T(e,-t,1)}function T({scale:e,translate:t},n,o){return n*e[o]+t[o]}function v(e,t,n){return e?t?n?x(e):z(e):n?P(e):G(e):null}function G(e){const t=e.coords;return{x:t[0],y:t[1]}}function N(e,t){return e.coords[0]=t.x,e.coords[1]=t.y,e}function z(e){const t=e.coords;return{x:t[0],y:t[1],z:t[2]}}function w(e,t){return e.coords[0]=t.x,e.coords[1]=t.y,e.coords[2]=t.z,e}function P(e){const t=e.coords;return{x:t[0],y:t[1],m:t[2]}}function O(e,t){return e.coords[0]=t.x,e.coords[1]=t.y,e.coords[2]=t.m,e}function x(e){const t=e.coords;return{x:t[0],y:t[1],z:t[2],m:t[3]}}function Z(e,t){return e.coords[0]=t.x,e.coords[1]=t.y,e.coords[2]=t.z,e.coords[3]=t.m,e}function S(e,t,n,o){let r=G;n&&o?r=x:n?r=z:o&&(r=P);for(const s of t){const{geometry:t,attributes:n}=s,o=null!=t?r(t):null;e.push({attributes:n,geometry:o})}return e}function q(e,t){return e&&t?Z:e?w:t?O:N}function E(e,t,n,o,r){const s=q(n,o);for(const{geometry:u,attributes:l}of t){const t=null!=u?s(new c,u):null;e.push(new i.OptimizedFeature(t,l,null,r?l[r]:void 0))}return e}function V(e,t,n=q(null!=t.z,null!=t.m)){return n(e,t)}function j(e,t,n,o){for(const{geometry:r,attributes:s}of t)e.push({attributes:s,geometry:null!=r?Y(r,n,o):null});return e}function Y(e,t,n){if(null==e)return null;const o=a(t,n),r=[];for(let s=0;s<e.coords.length;s+=o){const t=[];for(let n=0;n<o;n++)t.push(e.coords[s+n]);r.push(t)}return t?n?{points:r,hasZ:t,hasM:n}:{points:r,hasZ:t}:n?{points:r,hasM:n}:{points:r}}function k(e,t,n,o,r){const s=a(n,o);for(const{geometry:u,attributes:l}of t){const t=null!=u?_(new c,u,s):null;e.push(new i.OptimizedFeature(t,l,null,r?l[r]:void 0))}return e}function _(e,t,n=a(t.hasZ,t.hasM)){e.lengths[0]=t.points.length;const o=e.coords;let r=0;for(const s of t.points)for(let e=0;e<n;e++)o[r++]=s[e];return e}function A(e,t,n,o){for(const{geometry:r,attributes:s}of t)e.push({attributes:s,geometry:null!=r?L(r,n,o):null});return e}function L(e,t,n){if(!e)return null;const o=a(t,n),{coords:r,lengths:s}=e,u=[];let i=0;for(const l of s){const e=[];for(let t=0;t<l;t++){const t=[];for(let e=0;e<o;e++)t.push(r[i++]);e.push(t)}u.push(e)}return t?n?{paths:u,hasZ:t,hasM:n}:{paths:u,hasZ:t}:n?{paths:u,hasM:n}:{paths:u}}function R(e,t,n,o,r){const s=a(n,o);for(const{geometry:u,attributes:l,centroid:a}of t){const t=null!=u?U(new c,u,s):null,n=null!=a?V(new c,a):null;e.push(new i.OptimizedFeature(t,l,n,r?l[r]:void 0))}return e}function U(e,t,n=a(t.hasZ,t.hasM)){const{lengths:o,coords:r}=e;let s=0;for(const u of t.paths){for(const e of u)for(let t=0;t<n;t++)r[s++]=e[t];o.push(u.length)}return e}function B(e,t,n,o){for(const{geometry:r,attributes:s,centroid:u}of t){const t=null!=r?$(r,n,o):null;if(null!=u){const n=G(u);e.push({attributes:s,centroid:n,geometry:t})}else e.push({attributes:s,geometry:t})}return e}function $(e,t,n){if(!e)return null;const o=a(t,n),{coords:r,lengths:s}=e,u=[];let i=0;for(const l of s){const e=[];for(let t=0;t<l;t++){const t=[];for(let e=0;e<o;e++)t.push(r[i++]);e.push(t)}u.push(e)}return t?n?{rings:u,hasZ:t,hasM:n}:{rings:u,hasZ:t}:n?{rings:u,hasM:n}:{rings:u}}function C(e,t,n,o,r){for(const{geometry:s,centroid:u,attributes:l}of t){const t=null!=s?Q(new c,s,n,o):null,a=r?l[r]:void 0;null!=u?e.push(new i.OptimizedFeature(t,l,N(new c,u),a)):e.push(new i.OptimizedFeature(t,l,null,a))}return e}function Q(e,t,n=t.hasZ,o=t.hasM){return X(e,t.rings,n,o)}function X(e,t,n,o){const r=a(n,o),{lengths:s,coords:u}=e;let i=0;Ie(e);for(const l of t){for(const e of l)for(let t=0;t<r;t++)u[i++]=e[t];s.push(l.length)}return e}const D=[],H=[];function J(e,t,n,o,r){D[0]=e;const[s]=K(H,D,t,n,o,r);return Me(D),Me(H),s}function K(e,n,o,r,s,u){if(Me(e),!o){for(const t of n){const n=u?t.attributes[u]:void 0;e.push(new i.OptimizedFeature(null,t.attributes,null,n))}return e}switch(o){case"esriGeometryPoint":return E(e,n,r,s,u);case"esriGeometryMultipoint":return k(e,n,r,s,u);case"esriGeometryPolyline":return R(e,n,r,s,u);case"esriGeometryPolygon":case"esriGeometryMultiPatch":return C(e,n,r,s,u);default:f().error("convertToFeatureSet:unknown-geometry",new t(`Unable to parse unknown geometry type '${o}'`)),Me(e)}return e}function W(e,t,n,o){H[0]=e,oe(D,H,t,n,o);const r=D[0];return Me(D),Me(H),r}function ee(e,n,o){if(null==e)return null;const r=new c;if("hasZ"in e&&null==n&&(n=e.hasZ),"hasM"in e&&null==o&&(o=e.hasM),u.isPoint(e)){return q(null!=n?n:null!=e.z,null!=o?o:null!=e.m)(r,e)}return u.isPolygon(e)?Q(r,e,n,o):u.isPolyline(e)?U(r,e,a(n,o)):u.isMultipoint(e)?_(r,e,a(n,o)):void f().error("convertFromGeometry:unknown-geometry",new t(`Unable to parse unknown geometry type '${e}'`))}function te(e,n,o,r){const s=e&&("coords"in e?e:e.geometry);if(null==s)return null;switch(n){case"esriGeometryPoint":{let e=G;return o&&r?e=x:o?e=z:r&&(e=P),e(s)}case"esriGeometryMultipoint":return Y(s,o,r);case"esriGeometryPolyline":return L(s,o,r);case"esriGeometryPolygon":return $(s,o,r);default:return f().error("convertToGeometry:unknown-geometry",new t(`Unable to parse unknown geometry type '${n}'`)),null}}function ne(e,t){for(const n of t)e.push({attributes:n.attributes});return e}function oe(e,n,o,r,s){if(Me(e),null==o)return ne(e,n);switch(o){case"esriGeometryPoint":return S(e,n,r,s);case"esriGeometryMultipoint":return j(e,n,r,s);case"esriGeometryPolyline":return A(e,n,r,s);case"esriGeometryPolygon":return B(e,n,r,s);default:f().error("convertToFeatureSet:unknown-geometry",new t(`Unable to parse unknown geometry type '${o}'`))}return e}function re(e){const{objectIdFieldName:t,spatialReference:n,transform:o,fields:r,hasM:s,hasZ:u,features:i,geometryType:l,exceededTransferLimit:c,uniqueIdField:a,queryGeometry:f,queryGeometryType:d}=e,m={features:oe([],i,l,u,s),fields:r,geometryType:l,objectIdFieldName:t,spatialReference:n,uniqueIdField:a,queryGeometry:te(f,d,!1,!1)};return o&&(m.transform=o),c&&(m.exceededTransferLimit=c),s&&(m.hasM=s),u&&(m.hasZ=u),m}function se(e,n){const o=new l,{hasM:r,hasZ:s,features:u,objectIdFieldName:i,spatialReference:c,geometryType:a,exceededTransferLimit:d,transform:m,fields:h}=e;return h&&(o.fields=h),o.geometryType=a??null,o.objectIdFieldName=i??n??null,o.spatialReference=c??null,o.objectIdFieldName?(u&&K(o.features,u,a,s,r,o.objectIdFieldName),d&&(o.exceededTransferLimit=d),r&&(o.hasM=r),s&&(o.hasZ=s),m&&(o.transform=m),o):(f().error(new t("optimized-features:invalid-objectIdFieldName","objectIdFieldName is missing")),o)}function ue(e){const{transform:t,features:n,hasM:o,hasZ:r}=e;if(!t)return e;for(const s of n)null!=s.geometry&&he(s.geometry,s.geometry,o,r,t),null!=s.centroid&&he(s.centroid,s.centroid,o,r,t);return e.transform=null,e}function ie(e,t){const{geometryType:n,features:o,hasM:r,hasZ:s}=t;if(!e)return t;for(let u=0;u<o.length;u++){const t=o[u],i=t.weakClone();i.geometry=new c,le(i.geometry,t.geometry,r,s,n,e),t.centroid&&(i.centroid=new c,le(i.centroid,t.centroid,r,s,"esriGeometryPoint",e)),o[u]=i}return t.transform=e,t}function le(e,t,n,o,r,s,u=n,i=o){if(Ie(e),!t?.coords.length)return null;const l=d[r],{coords:c,lengths:f}=t,m=a(n,o),h=a(n&&u,o&&i),g=p(n,o,u,i);if(!f.length)return g(e.coords,c,0,0,F(s,c[0]),I(s,c[1])),Ie(e,m,0),e;let y,M,b,T,v=0,G=0,N=G;for(const a of f){if(a<l)continue;let t=0;G=N,b=y=F(s,c[v]),T=M=I(s,c[v+1]),g(e.coords,c,G,v,b,T),t++,v+=m,G+=h;for(let n=1;n<a;n++,v+=m)b=F(s,c[v]),T=I(s,c[v+1]),b===y&&T===M||(g(e.coords,c,G,v,b-y,T-M),G+=h,t++,y=b,M=T);t>=l&&(e.lengths.push(t),N=G)}return Me(e.coords,N),e.coords.length?e:null}function ce(e,t,n,o,r,s,u=n,i=o){if(Ie(e),!t?.coords.length)return null;const l=d[r],{coords:c,lengths:f}=t,m=a(n,o),h=a(n&&u,o&&i),g=p(n,o,u,i);if(!f.length)return g(e.coords,c,0,0,c[0],c[1]),Ie(e,m,0),e;let y=0;const F=s*s;for(const a of f){if(a<l){y+=a*m;continue}const t=e.coords.length/h,n=y,o=y+(a-1)*m;g(e.coords,c,e.coords.length,n,c[n],c[n+1]),fe(e.coords,c,m,F,g,n,o),g(e.coords,c,e.coords.length,o,c[o],c[o+1]);const r=e.coords.length/h-t;r>=l?e.lengths.push(r):Me(e.coords,t*h),y+=a*m}return e.coords.length?e:null}function ae(e,t,n,o){const r=e[t],s=e[t+1],u=e[n],i=e[n+1],l=e[o],c=e[o+1];let a=u,f=i,d=l-a,m=c-f;if(0!==d||0!==m){const e=((r-a)*d+(s-f)*m)/(d*d+m*m);e>1?(a=l,f=c):e>0&&(a+=d*e,f+=m*e)}return d=r-a,m=s-f,d*d+m*m}function fe(e,t,n,o,r,s,u){let i,l=o,c=0;for(let a=s+n;a<u;a+=n)i=ae(t,a,s,u),i>l&&(c=a,l=i);l>o&&(c-s>n&&fe(e,t,n,o,r,s,c),r(e,t,e.length,c,t[c],t[c+1]),u-c>n&&fe(e,t,n,o,r,c,u))}function de(e,t,n,o){if(!t?.coords?.length)return null;const u=a(n,o);let i=Number.POSITIVE_INFINITY,l=Number.POSITIVE_INFINITY,c=Number.NEGATIVE_INFINITY,f=Number.NEGATIVE_INFINITY;if(t&&t.coords){const e=t.coords;for(let t=0;t<e.length;t+=u){const n=e[t],o=e[t+1];i=Math.min(i,n),c=Math.max(c,n),l=Math.min(l,o),f=Math.max(f,o)}}return r.is(e)?r.fromRectValues(e,i,l,c,f):s.fromValues(i,l,c,f,e),e}function me(e,t,n,o){const r=a(n,o),{lengths:s,coords:u}=t;let i=Number.POSITIVE_INFINITY,l=Number.POSITIVE_INFINITY,c=Number.NEGATIVE_INFINITY,f=Number.NEGATIVE_INFINITY,d=0;for(const a of s){let e=u[d],t=u[d+1];i=Math.min(e,i),l=Math.min(t,l),c=Math.max(e,c),f=Math.max(t,f),d+=r;for(let n=1;n<a;n++,d+=r){const n=u[d],o=u[d+1];e+=n,t+=o,n<0&&(i=Math.min(i,e)),n>0&&(c=Math.max(c,e)),o<0?l=Math.min(l,t):o>0&&(f=Math.max(f,t))}}return e[0]=i,e[1]=l,e[2]=c,e[3]=f,e}function he(e,t,n,r,s){const{coords:u,lengths:i}=t,l=a(n,r);if(!u.length)return e!==t&&Ie(e),e;o.assertIsSome(s);const{originPosition:c,scale:f,translate:d}=s,m=be;m.originPosition=c;const h=m.scale;h[0]=f[0]??1,h[1]=-(f[1]??1),h[2]=f[2]??1,h[3]=f[3]??1;const g=m.translate;if(g[0]=d[0]??0,g[1]=d[1]??0,g[2]=d[2]??0,g[3]=d[3]??0,!i.length){for(let t=0;t<l;++t)e.coords[t]=T(m,u[t],t);return e!==t&&Ie(e,l,0),e}let y=0;for(let o=0;o<i.length;o++){const t=i[o];e.lengths[o]=t;for(let o=0;o<l;++o)e.coords[y+o]=T(m,u[y+o],o);let n=e.coords[y],r=e.coords[y+1];y+=l;for(let o=1;o<t;o++,y+=l){n+=u[y]*h[0],r+=u[y+1]*h[1],e.coords[y]=n,e.coords[y+1]=r;for(let t=2;t<l;++t)e.coords[y+t]=T(m,u[y+t],t)}}return e!==t&&Ie(e,u.length,i.length),e}function ge(e,t,n,o,r,s){if(Ie(e),e.lengths.push(...t.lengths),n===r&&o===s)for(let u=0;u<t.coords.length;u++)e.coords.push(t.coords[u]);else{const u=a(n,o),i=p(n,o,r,s),l=t.coords;for(let t=0;t<l.length;t+=u)i(e.coords,l,e.coords.length,t,l[t],l[t+1])}return e}function ye(e,t,n,o,r){if(!t?.coords?.length)return null;const s=d[n],{coords:u,lengths:i}=t,l=p(o,r,o,r),c=a(o,r);let f=0,m=0,h=0,g=0;for(const a of i){m=g,l(e.coords,u,m,f,u[f],u[f+1]),f+=c;let t=u[f],n=u[f+1],o=t,r=n,i=n/t;m+=c,l(e.coords,u,m,f,o,r),f+=c;for(let s=2;s<a;s++){t=u[f],n=u[f+1];const s=n/t,a=i===s||!isFinite(i)&&!isFinite(s),d=a&&isFinite(s)?i>=0&&s>=0||i<=0&&s<=0:r>=0&&n>=0||r<=0&&n<=0;a&&d?(o+=t,r+=n):(o=t,r=n,m+=c),l(e.coords,u,m,f,o,r),f+=c,i=s}m+=c;const d=(m-g)/c;d>=s&&(e.lengths[h]=d,g=m,h++)}return e.coords.length>g&&(e.coords.length=g),e.lengths.length>h&&(e.lengths.length=h),e.coords.length&&e.lengths.length?e:null}function pe(e,t,n,o){let r=0,s=e[o*t],u=e[o*(t+1)];for(let i=1;i<n;i++){const n=s+e[o*(t+i)],l=u+e[o*(t+i)+1],c=(n-s)*(l+u);s=n,u=l,r+=c}return.5*r}function Fe(e,t){const{coords:n,lengths:o}=e;let r=0,s=0;for(let u=0;u<o.length;u++){const e=o[u];s+=pe(n,r,e,t),r+=e}return Math.abs(s)}function Ie(e,t=0,n=0){Me(e.lengths,n),Me(e.coords,t)}function Me(e,t=0){e.length!==t&&(e.length=t)}const be={originPosition:"lowerLeft",scale:[1,1,1,1],translate:[0,0,0,0]};e.convertFromFeature=J,e.convertFromFeatureSet=se,e.convertFromFeatures=K,e.convertFromGeometry=ee,e.convertFromMultipoint=_,e.convertFromMultipointFeatures=k,e.convertFromNestedArray=X,e.convertFromPoint=V,e.convertFromPointFeatures=E,e.convertFromPolygon=Q,e.convertFromPolyline=U,e.convertFromPolylineFeatures=R,e.convertToFeature=W,e.convertToFeatureSet=re,e.convertToFeatures=oe,e.convertToGeometry=te,e.convertToMultipoint=Y,e.convertToMultipointFeatures=j,e.convertToPoint=v,e.convertToPolygon=$,e.convertToPolyline=L,e.generalizeOptimizedGeometry=ce,e.getBoundsOptimizedGeometry=de,e.getQuantizedArea=Fe,e.getQuantizedBoundsOptimizedGeometry=me,e.getSignedQuantizedRingArea=pe,e.quantizeOptimizedFeatureSet=ie,e.quantizeOptimizedGeometry=le,e.quantizeX=F,e.quantizeY=I,e.removeCollinearVertices=ye,e.removeZMValues=ge,e.unquantizeOptimizedFeatureSet=ue,e.unquantizeOptimizedGeometry=he,e.unquantizeValue=T,e.unquantizeX=M,e.unquantizeY=b,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
