/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../../../chunks/tslib.es6","../../../config","../../../geometry","../../../request","../../../core/arrayUtils","../../../core/Error","../../../core/has","../../../core/jsonMap","../../../core/Loadable","../../../core/Logger","../../../core/object","../../../core/promiseUtils","../../../core/reactiveUtils","../../../core/urlUtils","../../../core/uuid","../../../core/accessorSupport/decorators/property","../../../core/accessorSupport/decorators/subclass","../../../geometry/Extent","../../../geometry/support/MeshGeoreferencedVertexSpace","../../../geometry/support/meshVertexSpaceUtils","../../../geometry/support/meshUtils/External","../applyEditsUtils","./support/clientSideDefaults","./support/QueryTask","../../support/arcgisLayerUrl","../../support/featureLayerUtils","../../support/infoFor3D","../../../rest/query/executeQueryJSON","../../../rest/query/operations/editsZScale","../../../rest/support/Query","../../../time/TimeExtent","../../../versionManagement/support/versionManagementUtils","../../../geometry/SpatialReference"],(function(e,t,r,s,a,i,n,o,u,l,c,d,p,y,h,g,m,f,S,w,q,E,O,_,b,R,F,I,A,x,v,T,M,N){"use strict";const U=new u.JSONMap({originalAndCurrentFeatures:"original-and-current-features",none:"none"}),J=new u.JSONMap({Started:"published",Publishing:"publishing",Stopped:"unavailable"});let D=class extends l{constructor(e){super(e),this.type="feature-layer",this.supportedSourceTypes=new Set(["Feature Layer","Oriented Imagery Layer","Table","Catalog Layer"]),this.refresh=p.debounce((async()=>{await this.load();const e=this.sourceJSON.editingInfo?.lastEditDate;if(null==e)return{dataChanged:!0,updates:{}};try{await this._fetchService(null)}catch{return{dataChanged:!0,updates:{}}}const t=e!==this.sourceJSON.editingInfo?.lastEditDate;return{dataChanged:t,updates:t?{editingInfo:this.sourceJSON.editingInfo,extent:this.sourceJSON.extent}:null}})),this._ongoingAssetUploads=new Map}load(e){const t=this.layer.sourceJSON,r=this._fetchService(t,{...e}).then((()=>this.layer.setUserPrivileges(this.sourceJSON.serviceItemId,e))).then((()=>this._ensureLatestMetadata(e)));return this.addResolvingPromise(r),Promise.resolve(this)}initialize(){this.addHandles([y.watch((()=>{const e=this.layer;return e&&"lastEditsEventDate"in e?e.lastEditsEventDate:null}),(e=>this._handleLastEditsEventChange(e)))])}destroy(){this._removeEditInterceptor()}get queryTask(){const{capabilities:e,parsedUrl:t,gdbVersion:r,spatialReference:s,fieldsIndex:a}=this.layer,i="infoFor3D"in this.layer?this.layer.infoFor3D:null,n="dynamicDataSource"in this.layer?this.layer.dynamicDataSource:null,u=o("featurelayer-pbf")&&e?.query.supportsFormatPBF&&null==i,l=e?.operations?.supportsQueryAttachments??!1;return new b({url:t.path,pbfSupported:u,fieldsIndex:a,infoFor3D:i,dynamicDataSource:n,gdbVersion:r,sourceSpatialReference:s,queryAttachmentsSupported:l})}async addAttachment(e,t){await this.load();const{layer:r}=this;await F.ensureLayerCredential(r,"editing");const s=e.attributes[r.objectIdField],i=r.parsedUrl.path+"/"+s+"/addAttachment",n=this._getLayerRequestOptions(),o=this._getFormDataForAttachment(t,n.query);try{const e=await a(i,{body:o});return O.createFeatureEditResult(e.data.addAttachmentResult)}catch(u){throw this._createAttachmentErrorResult(s,u)}}async updateAttachment(e,t,r){await this.load();const{layer:s}=this;await F.ensureLayerCredential(s,"editing");const i=e.attributes[s.objectIdField],n=s.parsedUrl.path+"/"+i+"/updateAttachment",o=this._getLayerRequestOptions({query:{attachmentId:t}}),u=this._getFormDataForAttachment(r,o.query);try{const e=await a(n,{body:u});return O.createFeatureEditResult(e.data.updateAttachmentResult)}catch(l){throw this._createAttachmentErrorResult(i,l)}}async applyEdits(e,t){await this.load();const{layer:r}=this;await F.ensureLayerCredential(r,"editing");const s="infoFor3D"in r?r.infoFor3D:null,o=null!=s,u=o||(t?.globalIdUsed??!1),l=o?await this._uploadMeshesAndGetAssetMapEditsJSON(e):null,c=e.addFeatures?.map((e=>O.getFeatureJSON(this.layer,e,s)))??[],d=(await Promise.all(c)).filter(i.isSome),p=e.updateFeatures?.map((e=>O.getFeatureJSON(this.layer,e,s)))??[],y=(await Promise.all(p)).filter(i.isSome),h=O.getFeatureIds(this.layer,e.deleteFeatures,u);x.unapplyEditsZUnitScaling(d,y,r.spatialReference);const g=await O.getAttachmentEditsJSON(this.layer,e),m=r.capabilities.editing.supportsAsyncApplyEdits&&o,f=t?.gdbVersion||r.gdbVersion,S={gdbVersion:f,rollbackOnFailure:t?.rollbackOnFailureEnabled,useGlobalIds:u,returnEditMoment:t?.returnEditMoment,usePreviousEditMoment:t?.usePreviousEditMoment,async:m};await M.isSafeToEditVersion(this.layer.url,f,!0);const w=M.isVersionInEditSession(this.layer.url,f||null);if(await M.isHistoricVersion(r.url,f,r.historicMoment))throw new n("feature-layer-source:historic-version","Editing a historic version is not allowed");t?.returnServiceEditsOption?(S.edits=JSON.stringify([{id:r.layerId,adds:d.length?d:null,updates:y.length?y:null,deletes:h.length?h:null,attachments:g,assetMaps:l}]),S.returnServiceEditsOption=U.toJSON(t?.returnServiceEditsOption),S.returnServiceEditsInSourceSR=t?.returnServiceEditsInSourceSR):(S.adds=d.length?JSON.stringify(d):null,S.updates=y.length?JSON.stringify(y):null,S.deletes=h.length?u?JSON.stringify(h):h.join(","):null,S.attachments=g&&JSON.stringify(g),S.assetMaps=null!=l?JSON.stringify(l):void 0);const q=this._getLayerRequestOptions({method:"post",query:S});w&&(q.authMode="immediate",q.query.returnEditMoment=!0,q.query.sessionId=M.currentSessionId);const E=t?.returnServiceEditsOption?r.url:r.parsedUrl.path;let _;try{_=m?await this._asyncApplyEdits(E+"/applyEdits",q):await a(E+"/applyEdits",q)}catch(b){if(!O.isProtectedOrPrivateVersionError(b))throw b;q.authMode="immediate",_=m?await this._asyncApplyEdits(E+"/applyEdits",q):await a(E+"/applyEdits",q)}return this._createEditsResult(_)}async deleteAttachments(e,t){await this.load();const{layer:r}=this;await F.ensureLayerCredential(r,"editing");const s=e.attributes[r.objectIdField],i=r.parsedUrl.path+"/"+s+"/deleteAttachments";try{return(await a(i,this._getLayerRequestOptions({query:{attachmentIds:t.join(",")},method:"post"}))).data.deleteAttachmentResults.map(O.createFeatureEditResult)}catch(n){throw this._createAttachmentErrorResult(s,n)}}fetchRecomputedExtents(e={}){const t=e.signal;return this.load({signal:t}).then((async()=>{const t=this._getLayerRequestOptions({...e,query:{returnUpdates:!0}}),{layerId:r,url:s}=this.layer,{data:i}=await a(`${s}/${r}`,t),{id:n,extent:o,fullExtent:u,timeExtent:l}=i,c=o||u;return{id:n,fullExtent:c&&S.fromJSON(c),timeExtent:l&&T.fromJSON({start:l[0],end:l[1]})}}))}async queryAttachments(e,t={}){await this.load();const r=this._getLayerRequestOptions(t);return this.queryTask.executeAttachmentQuery(e,r)}async queryFeatures(e,t){await this.load();const r=await this.queryTask.execute(e,{...t,query:this._createRequestQueryOptions(t)});return e.outStatistics?.length&&r.features.length&&r.features.forEach((t=>{const r=t.attributes;e.outStatistics?.forEach((({outStatisticFieldName:e})=>{if(e){const t=e.toLowerCase();t&&t in r&&e!==t&&(r[e]=r[t],delete r[t])}}))})),r}async queryFeaturesJSON(e,t){return await this.load(),this.queryTask.executeJSON(e,{...t,query:this._createRequestQueryOptions(t)})}async queryObjectIds(e,t){return await this.load(),this.queryTask.executeForIds(e,{...t,query:this._createRequestQueryOptions(t)})}async queryFeatureCount(e,t){return await this.load(),this.queryTask.executeForCount(e,{...t,query:this._createRequestQueryOptions(t)})}async queryExtent(e,t){return await this.load(),this.queryTask.executeForExtent(e,{...t,query:this._createRequestQueryOptions(t)})}async queryRelatedFeatures(e,t){return await this.load(),this.queryTask.executeRelationshipQuery(e,{...t,query:this._createRequestQueryOptions(t)})}async queryRelatedFeaturesCount(e,t){return await this.load(),this.queryTask.executeRelationshipQueryForCount(e,{...t,query:this._createRequestQueryOptions(t)})}async queryTopFeatures(e,t){return await this.load(),this.queryTask.executeTopFeaturesQuery(e,{...t,query:this._createRequestQueryOptions(t)})}async queryBins(e,t){return await this.load(),this.queryTask.executeBinsQuery(e,{...t,query:this._createRequestQueryOptions(t)})}async queryTopObjectIds(e,t){return await this.load(),this.queryTask.executeForTopIds(e,{...t,query:this._createRequestQueryOptions(t)})}async queryTopExtents(e,t){return await this.load(),this.queryTask.executeForTopExtents(e,{...t,query:this._createRequestQueryOptions(t)})}async queryTopCount(e,t){return await this.load(),this.queryTask.executeForTopCount(e,{...t,query:this._createRequestQueryOptions(t)})}async fetchPublishingStatus(){if(!R.isHostedAgolService(this.layer.url))return"unavailable";const e=h.join(this.layer.url,"status"),t=await a(e,{query:{f:"json"}});return J.fromJSON(t.data.status)}async uploadAssets(t,r){const{uploadAssets:s}=await new Promise(((t,r)=>e(["./support/uploadAssets"],t,r)));return s(t,{layer:this.layer,ongoingUploads:this._ongoingAssetUploads},r)}_handleLastEditsEventChange(e){const t=this.layer;if(null==e||!("capabilities"in t)||!("effectiveCapabilities"in t))return;if(!(!t.capabilities?.operations?.supportsEditing&&t.effectiveCapabilities?.operations?.supportsEditing))return;const r=t.url;if(null==r)return;"layerId"in t&&h.join(r,t.layerId.toString());this._getOrCreateEditInterceptor(r).before=t=>{const r=t.requestOptions.method??"auto";if("auto"===r||"head"===r){const r=t.requestOptions.query??{};r._ts=e.getTime(),t.requestOptions.query=r}}}_getOrCreateEditInterceptor(e){return null==this._editInterceptor&&(this._editInterceptor={urls:e},r.request.internalInterceptors.push(this._editInterceptor)),this._editInterceptor}_removeEditInterceptor(){null!=this._editInterceptor&&(i.remove(r.request.internalInterceptors,this._editInterceptor),this._editInterceptor=null)}async _asyncApplyEdits(e,t){const r=(await a(e,t)).data.statusUrl;for(;;){const e=(await a(r,{query:{f:"json"},responseType:"json"})).data;switch(e.status){case"Completed":return a(e.resultUrl,{query:{f:"json"},responseType:"json"});case"CompletedWithErrors":throw new n("async-applyEdits-failed","asynchronous applyEdits call failed.");case"Failed ImportChanges":case"InProgress":case"Pending":case"ExportAttachments":case"ExportChanges":case"ExportingData":case"ExportingSnapshot":case"ImportAttachments":case"ProvisioningReplica":case"UnRegisteringReplica":break;default:throw new n("async-applyEdits-failed","asynchronous applyEdits call failed (undefined response status)")}await p.after(C)}}_createRequestQueryOptions(e){const t={...this.layer.customParameters,token:this.layer.apiKey,...e?.query};return this.layer.datesInUnknownTimezone&&(t.timeReferenceUnknownClient=!0),t}async _fetchService(e,t){if(!e){const r={};o("featurelayer-advanced-symbols")&&(r.returnAdvancedSymbols=!0),t?.cacheBust&&(r._ts=Date.now());const{data:s}=await a(this.layer.parsedUrl.path,this._getLayerRequestOptions({query:r,signal:t?.signal}));e=s}this.sourceJSON=await this._patchServiceJSON(e,t?.signal);const r=e.type;if(!this.supportedSourceTypes.has(r))throw new n("feature-layer-source:unsupported-type",`Source type "${r}" is not supported`)}async _patchServiceJSON(e,t){if("Table"!==e.type&&e.geometryType&&!e?.drawingInfo?.renderer&&!e.defaultSymbol){const t=_.createDrawingInfo(e.geometryType).renderer;d.setDeepValue("drawingInfo.renderer",t,e)}if("esriGeometryMultiPatch"===e.geometryType&&e.infoFor3D&&(e.geometryType="mesh"),null==e.extent)try{const{data:r}=await a(this.layer.url,this._getLayerRequestOptions({signal:t}));r.spatialReference&&(e.extent={xmin:0,ymin:0,xmax:0,ymax:0,spatialReference:r.spatialReference})}catch(r){p.throwIfAbortError(r)}return e}async _ensureLatestMetadata(e){if(this.layer.userHasUpdateItemPrivileges&&this.sourceJSON.cacheMaxAge>0)return this._fetchService(null,{...e,cacheBust:!0})}async _uploadMeshesAndGetAssetMapEditsJSON(t){const{addAssetFeatures:r}=t;if(!r?.length)return null;if(await this._areAllAssetsAlreadyMapped(r))return null;const s=t.addFeatures.filter((e=>e.geometry));if(r.length!==s.length+t.updateFeatures.length)throw new n("feature-layer-source:unsupported-mesh-edits","Mixing attribute only edits with mesh geometry edits is not currently supported");const a=new Array,i=new Map;for(const n of r){const{geometry:t}=n,{vertexSpace:r}=t;if(q.isRelativeVertexSpace(r))a.push(t);else{const r=t.origin,{convertMeshVertexSpace:s}=await new Promise(((t,r)=>e(["../../../geometry/support/meshUtils/convertMeshVertexSpace"],t,r))),o=await s(t,new w({origin:[r.x,r.y,r.z??0]}));i.set(o,t),n.geometry=o,a.push(o)}}await this.uploadAssets(a);for(const[e,n]of i)n.addExternalSources(e.metadata.externalSources.items);return{adds:this._getAssetMapEditsJSON(r),updates:[],deletes:[]}}_getAssetMapEditsJSON(e){const t=new Array,r=this.layer.globalIdField,s=this.layer.parsedUrl;for(const a of e){const e=a.geometry,{metadata:i}=e,n=i.getExternalSourcesOnService(s),o=a.getAttribute(r);if(0===n.length){c.getLogger(this).error(`Skipping feature ${o}. The mesh it is associated with has not been uploaded to the service and cannot be mapped to it.`);continue}const{source:u}=n.find(E.isOriginalExternal)??n[0];for(const r of u)1===r.parts.length?t.push({globalId:g.generateBracedUUID(),parentGlobalId:o,assetName:r.assetName,assetHash:r.parts[0].partHash,flags:[]}):c.getLogger(this).error(`Skipping asset ${r.assetName}. It does not have exactly one part, so we cannot map it to a feature.`)}return t}_createEditsResult(e){const t=e.data,{layerId:r}=this.layer,s=[];let a=null;if(Array.isArray(t))for(const n of t)s.push({id:n.id,editedFeatures:n.editedFeatures}),n.id===r&&(a={addResults:n.addResults??[],updateResults:n.updateResults??[],deleteResults:n.deleteResults??[],attachments:n.attachments,editMoment:n.editMoment});else a=t;const i=O.unpackEditResultData(a);if(s.length>0){i.editedFeatureResults=[];for(const e of s){const{editedFeatures:t}=e,r=t?.spatialReference?new N(t.spatialReference):null;i.editedFeatureResults.push({layerId:e.id,editedFeatures:O.createEditedFeatures(t,r)})}}return i}_createAttachmentErrorResult(e,t){const r=t.details.messages?.[0]||t.message,s=t.details.httpStatus||t.details.messageCode;return{objectId:e,globalId:null,error:new n("feature-layer-source:attachment-failure",r,{code:s})}}_getFormDataForAttachment(e,t){const r=e instanceof FormData?e:e&&e.elements?new FormData(e):null;if(r)for(const s in t){const e=t[s];null!=e&&(r.set?r.set(s,e):r.append(s,e))}return r}_getLayerRequestOptions(e={}){const{layer:t,layer:{parsedUrl:r,gdbVersion:s}}=this;return{...e,query:{gdbVersion:s,layer:"dynamicDataSource"in t&&t.dynamicDataSource?JSON.stringify({source:t.dynamicDataSource}):void 0,...r.query,f:"json",...this._createRequestQueryOptions(e)},responseType:"json"}}async _areAllAssetsAlreadyMapped(e){const{layer:t}=this,{globalIdField:r,parsedUrl:s}=t,a="infoFor3D"in t?t.infoFor3D:null;if(null==a||null==r)return!1;const n=I.getAssetMapTable(a);if(null==n)return!1;const o=h.join(s.path,`../${n.id}`),u=new Array;for(const i of e){if(!(i.geometry.metadata.getExternalSourcesOnService(s).length>0))return!1;u.push(i)}const l=u.map((e=>e.getAttribute(r))).filter(i.isSome);if(0===l.length)return!1;const{assetMapFieldRoles:{parentGlobalId:c,assetHash:d}}=a,p=new v({where:`${c} IN (${l.map((e=>`'${e}'`))})`,outFields:[d,c],returnGeometry:!1}),y=await A.executeQueryJSON(o,p),{features:g}=y;return 0!==g.length&&!u.some((e=>{const t=e.getAttribute(r);if(!t)return!0;const{metadata:a}=e.geometry,i=g.filter((e=>e.getAttribute(c)===t));if(0===i.length)return!0;const n=i.map((e=>e.getAttribute(d)));return a.getExternalSourcesOnService(s).flatMap((({source:e})=>e.flatMap((e=>e.parts.map((e=>e.partHash)))))).some((e=>n.every((t=>e!==t))))}))}};t.__decorate([m.property()],D.prototype,"type",void 0),t.__decorate([m.property({constructOnly:!0})],D.prototype,"layer",void 0),t.__decorate([m.property({constructOnly:!0})],D.prototype,"supportedSourceTypes",void 0),t.__decorate([m.property({readOnly:!0})],D.prototype,"queryTask",null),D=t.__decorate([f.subclass("esri.layers.graphics.sources.FeatureLayerSource")],D);const C=1e3;return D}));
