/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../chunks/tslib.es6","../../../geometry","../../../core/Error","../../../core/Loadable","../../../core/string","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/Logger","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../ogc/ogcFeatureUtils","../../support/capabilities","../../../rest/support/FeatureSet","../../../geometry/SpatialReference","../../../geometry/support/typeUtils"],(function(e,t,r,s,o,p,a,i,u,n,c,l,d,y,g,S){"use strict";e.OGCFeatureSource=class extends o{constructor(){super(...arguments),this.featureDefinition=null,this.type="ogc-feature"}load(e){return this.addResolvingPromise(this._loadOGCServices(this.layer,e)),this.when()}getSource(){const{featureDefinition:{collection:e,layerDefinition:t,spatialReference:r,supportedCrs:s},layer:{apiKey:o,customParameters:p,effectiveMaxRecordCount:a}}=this;return{type:"ogc-source",collection:e,layerDefinition:t,maxRecordCount:a,queryParameters:{apiKey:o,customParameters:p},spatialReference:r,supportedCrs:s}}queryExtent(e,t={}){return null}queryFeatureCount(e,t={}){return null}queryFeatures(e,t={}){return this.queryFeaturesJSON(e,t).then((e=>y.fromJSON(e)))}queryFeaturesJSON(e,t={}){const r=this.getSource();return this.load(t).then((()=>l.queryFeatureSetJSON(r,e,t)))}queryObjectIds(e,t={}){return null}serviceSupportsSpatialReference(e){return!(!e.isWGS84&&!e.isWebMercator)||!!this.featureDefinition.supportedCrs[e.wkid]}_conformsToType(e,t){const r=new RegExp(`^${p.escapeRegExpString(t)}$`,"i");return e.conformsTo.some((e=>r.test(e)))??!1}_getCapabilities(e,t){return{analytics:{supportsCacheHint:!1},attachment:null,data:{isVersioned:!1,isBranchVersioned:!1,supportsAttachment:!1,supportsM:!1,supportsZ:e},metadata:{supportsAdvancedFieldProperties:!1},operations:{supportsCalculate:!1,supportsTruncate:!1,supportsValidateSql:!1,supportsAdd:!1,supportsDelete:!1,supportsEditing:!1,supportsChangeTracking:!1,supportsQuery:!1,supportsQueryBins:!1,supportsQueryAnalytics:!1,supportsQueryAttachments:!1,supportsQueryTopFeatures:!1,supportsResizeAttachments:!1,supportsSync:!1,supportsUpdate:!1,supportsExceedsLimitStatistics:!1,supportsAsyncConvert3D:!1},query:{maxRecordCount:t,maxRecordCountFactor:void 0,standardMaxRecordCount:void 0,supportsCacheHint:!1,supportsCentroid:!1,supportsDisjointSpatialRelationship:!1,supportsDistance:!1,supportsDistinct:!1,supportsExtent:!1,supportsFormatPBF:!1,supportsGeometryProperties:!1,supportsHavingClause:!1,supportsHistoricMoment:!1,supportsMaxRecordCountFactor:!1,supportsOrderBy:!1,supportsPagination:!1,supportsPercentileStatistics:!1,supportsQuantization:!1,supportsQuantizationEditMode:!1,supportsQueryByAnonymous:!1,supportsQueryByOthers:!1,supportsQueryGeometry:!1,supportsResultType:!1,supportsStandardizedQueriesOnly:!1,supportsTopFeaturesQuery:!1,supportsStatistics:!1,supportsSpatialAggregationStatistics:!1,supportedSpatialAggregationStatistics:{envelope:!1,centroid:!1,convexHull:!1},supportsDefaultSpatialReference:!1,supportsFullTextSearch:!1,supportsCompactGeometry:!1,supportsSqlExpression:!1,tileMaxRecordCount:void 0},queryRelated:{supportsCount:!1,supportsOrderBy:!1,supportsPagination:!1,supportsCacheHint:!1},queryTopFeatures:{supportsCacheHint:!1},queryBins:d.zeroQueryBins,editing:{supportsDeleteByAnonymous:!1,supportsDeleteByOthers:!1,supportsGeometryUpdate:!1,supportsGlobalId:!1,supportsReturnServiceEditsInSourceSpatialReference:!1,supportsRollbackOnFailure:!1,supportsUpdateByAnonymous:!1,supportsUpdateByOthers:!1,supportsUploadWithItemId:!1,supportsUpdateWithoutM:!1,supportsAsyncApplyEdits:!1,zDefault:void 0}}}_getMaxRecordCount(e){const t=e?.components?.parameters;return t?.limit?.schema?.maximum??t?.limitFeatures?.schema?.maximum}_getStorageSpatialReference(e){const t=e.storageCrs??l.crsDefault,r=l.getSpatialReferenceWkid(t);return null==r?g.WGS84:new g({wkid:r})}_getSupportedSpatialReferences(e,t){const r="#/crs",s=e.crs??[l.crsDefault],o=s.includes(r)?s.filter((e=>e!==r)).concat(t.crs??[]):s,p=/^http:\/\/www\.opengis.net\/def\/crs\/epsg\/.*\/3785$/i;return o.filter((e=>!p.test(e)))}async _loadOGCServices(e,t){const r=null!=t?t.signal:null,{apiKey:o,collectionId:a,customParameters:i,fields:u,geometryType:n,hasZ:c,objectIdField:d,timeInfo:y,url:g}=e,f={fields:u?.map((e=>e.toJSON())),geometryType:S.typeKebabDictionary.toJSON(n),hasZ:c??!1,objectIdField:d,timeInfo:y?.toJSON()},m={apiKey:o,customParameters:i,signal:r},h=await l.getServerLandingPage(g,m),[C,R]=await Promise.all([l.getServerConformance(h,m),l.getServerCollections(h,m)]);if(!this._conformsToType(C,"http://www.opengis.net/spec/ogcapi-features-1/1.0/conf/geojson"))throw new s("ogc-feature-layer:no-geojson-support","Server does not support geojson");const O=R.collections.find((({id:e})=>e===a));if(!O)throw new s("ogc-feature-layer:collection-not-found","Server does not contain the named collection");const F=this._conformsToType(C,"http://www.opengis.net/spec/ogcapi-features-1/1.0/conf/oas30")?await l.getServerOpenApi(h,m):null,v=await l.getCollectionDefinition(O,f,m),x=this._getMaxRecordCount(F),w=this._getCapabilities(v.hasZ,x),D=this._getStorageSpatialReference(O).toJSON(),_=this._getSupportedSpatialReferences(O,R),b=new RegExp(`^${p.escapeRegExpString(l.crsPrefix)}`,"i"),G={};for(const s of _){const e=l.getSpatialReferenceWkid(s);null!=e&&(G[e]||(G[e]=s.replace(b,"")))}this.featureDefinition={capabilities:w,collection:O,layerDefinition:v,spatialReference:D,supportedCrs:G}}},t.__decorate([a.property()],e.OGCFeatureSource.prototype,"featureDefinition",void 0),t.__decorate([a.property({constructOnly:!0})],e.OGCFeatureSource.prototype,"layer",void 0),t.__decorate([a.property()],e.OGCFeatureSource.prototype,"type",void 0),e.OGCFeatureSource=t.__decorate([c.subclass("esri.layers.graphics.sources.OGCFeatureSource")],e.OGCFeatureSource),Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
