/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../core/asyncUtils","../../../core/Error","../../../core/Logger","../../../core/promiseUtils","../../../core/Warning","../../../geometry/support/spatialReferenceUtils","../featureConversionUtils","../data/FeatureStore","../data/projectionSupport","../data/QueryEngine","./geojson/geojson","./support/sourceUtils","../../ogc/wfsUtils","../../support/FieldsIndex","../../../time/timeZoneUtils"],(function(e,t,r,a,s,o,n,i,u,c,l,h,p,m,d){"use strict";const g="esri.layers.WFSLayer";class y{constructor(){this._customParameters=null,this._queryEngine=null,this._supportsPagination=!0}destroy(){this._queryEngine?.destroy(),this._queryEngine=null}async load(e,r={}){const{getFeatureUrl:s,getFeatureOutputFormat:o,fields:n,geometryType:l,featureType:h,maxRecordCount:g,maxTotalRecordCount:y,maxPageCount:_,objectIdField:f,customParameters:w}=e,{spatialReference:C,getFeatureSpatialReference:F}=p.getGetFeatureSpatialReference(s,h,e.spatialReference);try{await u.checkProjectionSupport(F,C)}catch{throw new t("unsupported-projection","Projection not supported",{inSpatialReference:F,outSpatialReference:C})}a.throwIfAborted(r),this._customParameters=w,this._featureType=h,this._fieldsIndex=m.fromLayerJSON({fields:n,dateFieldsTimeReference:n.some((e=>"esriFieldTypeDate"===e.type))?{timeZoneIANA:d.utc}:null}),this._geometryType=l,this._getFeatureUrl=s,this._getFeatureOutputFormat=o,this._getFeatureSpatialReference=F,this._maxRecordCount=g,this._maxTotalRecordCount=y,this._maxPageCount=_,this._objectIdField=f,this._spatialReference=C;let R=await this._snapshotFeatures(r);if(R.errors.length>0&&(this._supportsPagination=!1,R=await this._snapshotFeatures(r),R.errors.length>0))throw R.errors[0];return this._queryEngine=new c.QueryEngine({fieldsIndex:this._fieldsIndex,geometryType:l,hasM:!1,hasZ:!1,objectIdField:f,spatialReference:C,timeInfo:null,featureStore:new i({geometryType:l,hasM:!1,hasZ:!1})}),this._queryEngine.featureStore.addMany(R.features),{warnings:x(R),extent:(await this._queryEngine.fetchRecomputedExtents()).fullExtent}}async applyEdits(){throw new t("wfs-source:editing-not-supported","applyEdits() is not supported on WFSLayer")}async queryFeatures(e={},t={}){return await this._waitSnapshotComplete(),this._queryEngine.executeQuery(e,t.signal)}async queryFeatureCount(e={},t={}){return await this._waitSnapshotComplete(),this._queryEngine.executeQueryForCount(e,t.signal)}async queryObjectIds(e={},t={}){return await this._waitSnapshotComplete(),this._queryEngine.executeQueryForIds(e,t.signal)}async queryExtent(e={},t={}){return await this._waitSnapshotComplete(),this._queryEngine.executeQueryForExtent(e,t.signal)}async querySnapping(e,t={}){return await this._waitSnapshotComplete(),this._queryEngine.executeQueryForSnapping(e,t.signal)}async refresh(t){return this._customParameters=t.customParameters,this._maxRecordCount=t.maxRecordCount,this._maxTotalRecordCount=t.maxTotalRecordCount,this._maxPageCount=t.maxPageCount,this._snapshotTask?.abort(),this._snapshotTask=e.createTask((e=>this._snapshotFeatures({signal:e}))),this._snapshotTask.promise.then((e=>{this._queryEngine.featureStore.clear(),this._queryEngine.featureStore.addMany(e.features);for(const t of x(e))r.getLogger(g).warn(new s("wfs-layer:refresh-warning",t.message,t.details));e.errors?.length&&r.getLogger(g).warn(new s("wfs-layer:refresh-error","Refresh completed with errors",{errors:e.errors}))}),(()=>{this._queryEngine.featureStore.clear()})),await this._waitSnapshotComplete(),{extent:(await this._queryEngine.fetchRecomputedExtents()).fullExtent}}async _waitSnapshotComplete(){if(this._snapshotTask&&!this._snapshotTask.finished){try{await this._snapshotTask.promise}catch{}return this._waitSnapshotComplete()}}async _snapshotFeatures(e){const t=e?.signal,r=this._maxTotalRecordCount,s=this._maxPageCount,o=this._supportsPagination?await p.getFeatureCount(this._getFeatureUrl,this._featureType.typeName,{customParameters:this._customParameters,signal:t}):void 0;let n=[];const i=[];if(null==o)try{n=await this._singleQuery(t)}catch(u){a.isAbortError(u)||i.push(u)}else{const e=Math.min(o,r),a=_(this,Math.max(1,Math.min(Math.ceil(e/this._maxRecordCount),s)),t);await Promise.allSettled(Array.from({length:10}).map((()=>f(a,n,i))))}return a.throwIfAborted(t),{features:n,totalRecordCount:o,maxTotalRecordCount:r,maxPageCount:s,errors:i}}async _singleQuery(e){const t=await p.getFeature(this._getFeatureUrl,this._featureType.typeName,this._getFeatureSpatialReference,this._getFeatureOutputFormat,{customParameters:this._customParameters,signal:e});return this._processGeoJSON(t,{signal:e})}async _pageQuery(e,t){const r=e*this._maxRecordCount,a=await p.getFeature(this._getFeatureUrl,this._featureType.typeName,this._getFeatureSpatialReference,this._getFeatureOutputFormat,{customParameters:this._customParameters,startIndex:r,count:this._maxRecordCount,signal:t});return this._processGeoJSON(a,{startIndex:r,signal:t})}_processGeoJSON(e,t){l.validateGeoJSON(e,this._getFeatureSpatialReference.wkid);const{startIndex:r,signal:s}=t;a.throwIfAborted(s);const i=l.createOptimizedFeatures(e,{geometryType:this._geometryType,hasZ:!1,objectIdField:this._objectIdField});if(!o.equals(this._spatialReference,this._getFeatureSpatialReference))for(const a of i)null!=a.geometry&&(a.geometry=n.convertFromGeometry(u.project(n.convertToGeometry(a.geometry,this._geometryType,!1,!1),this._getFeatureSpatialReference,this._spatialReference)));let c=r??1;for(const a of i){const e={};h.mixAttributes(this._fieldsIndex,e,a.attributes,!0),a.attributes=e,null==e[this._objectIdField]&&(a.objectId=e[this._objectIdField]=c++)}return i}}function*_(e,t,r){for(let a=0;a<t;a++)yield e._pageQuery(a,r)}async function f(e,t,r){let s=e.next();for(;!s.done;){try{const e=await s.value;t.push(...e)}catch(o){a.isAbortError(o)||r.push(o)}s=e.next()}}function x(e){const t=[];return null!=e.totalRecordCount&&(e.features.length<e.totalRecordCount&&t.push({name:"wfs-layer:maxRecordCount-too-low",message:`Could only fetch ${e.features.length} of ${e.totalRecordCount} in ${e.maxPageCount} queries. Try increasing the value of WFSLayer.maxRecordCount.`,details:{recordCount:e.features.length,totalRecordCount:e.totalRecordCount}}),e.totalRecordCount>e.maxTotalRecordCount&&t.push({name:"wfs-layer:large-dataset",message:`The number of ${e.totalRecordCount} features exceeds the maximum allowed of ${e.maxTotalRecordCount}.`,details:{recordCount:e.features.length,totalRecordCount:e.totalRecordCount,maxTotalRecordCount:e.maxTotalRecordCount}})),t}return y}));
