/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../../../../chunks/tslib.es6","../../../../core/Accessor","../../../../core/Error","../../../../core/has","../../../../core/promiseUtils","../../../../core/urlUtils","../../../../core/accessorSupport/decorators/property","../../../../core/Logger","../../../../core/RandomLCG","../../../../core/accessorSupport/decorators/subclass","../../../../geometry/support/spatialReferenceUtils","../../../support/infoFor3D","../../../support/source/DataLayerSource","../../../../rest/utils","../../../../rest/query/executeForCount","../../../../rest/query/executeForExtent","../../../../rest/query/executeForIds","../../../../rest/query/executeQueryJSON","../../../../rest/query/executeQueryPBF","../../../../rest/support/FeatureSet","../../../../rest/support/Query"],(function(e,t,r,o,s,u,a,i,n,c,p,l,y,d,h,f,m,S,F,b,x,w){"use strict";const D=e=>Object.freeze(Object.defineProperty({__proto__:null,default:e},Symbol.toStringTag,{value:"Module"}));let O=class extends r{constructor(e){super(e),this.dynamicDataSource=null,this.fieldsIndex=null,this.gdbVersion=null,this.infoFor3D=null,this.pbfSupported=!1,this.queryAttachmentsSupported=!1,this.sourceSpatialReference=null,this.url=null}get parsedUrl(){return a.urlToObject(this.url)}async execute(e,t){const r=await this.executeJSON(e,t);return this.featureSetFromJSON(e,r,t)}async executeJSON(e,t){const r=this._normalizeQuery(e),o=null!=e.outStatistics?.[0],u=s("featurelayer-pbf-statistics"),a=!o||u;let i;if(this.pbfSupported&&a)try{i=await b.executeRawQueryPBF(this.url,r,t)}catch(n){if("query:parsing-pbf"!==n.name)throw n;this.pbfSupported=!1}return this.pbfSupported&&a||(i=await F.executeRawQueryJSON(this.url,r,t)),this._normalizeFields(i.fields),i}async featureSetFromJSON(t,r,o){if(!this._queryIs3DObjectFormat(t)||null==this.infoFor3D||!r.features)return x.fromJSON(r);const{meshFeatureSetFromJSON:s}=await u.whenOrAbort(new Promise(((t,r)=>e(["../../../../rest/support/meshFeatureSet"],t,r))),o);return s(t,this.infoFor3D,r)}executeForCount(e,t){return f.executeForCount(this.url,this._normalizeQuery(e),t)}executeForExtent(e,t){return m.executeForExtent(this.url,this._normalizeQuery(e),t)}executeForIds(e,t){return S.executeForIds(this.url,this._normalizeQuery(e),t)}async executeRelationshipQuery(t,r){const[{default:o},{executeRelationshipQuery:s}]=await u.whenOrAbort(Promise.all([new Promise(((t,r)=>e(["../../../../rest/support/RelationshipQuery"],(e=>t(D(e))),r))),new Promise(((t,r)=>e(["../../../../rest/query/executeRelationshipQuery"],t,r)))]),r);return t=o.from(t),(this.gdbVersion||this.dynamicDataSource)&&((t=t.clone()).gdbVersion=t.gdbVersion||this.gdbVersion,t.dynamicDataSource=t.dynamicDataSource||this.dynamicDataSource),s(this.url,t,r)}async executeRelationshipQueryForCount(t,r){const[{default:o},{executeRelationshipQueryForCount:s}]=await u.whenOrAbort(Promise.all([new Promise(((t,r)=>e(["../../../../rest/support/RelationshipQuery"],(e=>t(D(e))),r))),new Promise(((t,r)=>e(["../../../../rest/query/executeRelationshipQuery"],t,r)))]),r);return t=o.from(t),(this.gdbVersion||this.dynamicDataSource)&&((t=t.clone()).gdbVersion=t.gdbVersion||this.gdbVersion,t.dynamicDataSource=t.dynamicDataSource||this.dynamicDataSource),s(this.url,t,r)}async executeAttachmentQuery(t,r){const{executeAttachmentQuery:o,fetchAttachments:s,processAttachmentQueryResult:a}=await u.whenOrAbort(new Promise(((t,r)=>e(["../../../../rest/query/operations/queryAttachments"],t,r))),r),i=h.parseUrl(this.url);return a(i,await(this.queryAttachmentsSupported?o(i,t,r):s(i,t,r)))}async executeBinsQuery(t,r){const{executeBinsQuery:o}=await u.whenOrAbort(new Promise(((t,r)=>e(["../../../../rest/query/executeBinsQuery"],t,r))),r);return o(this.parsedUrl,t,r)}async executeTopFeaturesQuery(t,r){const{executeTopFeaturesQuery:o}=await u.whenOrAbort(new Promise(((t,r)=>e(["../../../../rest/query/executeTopFeaturesQuery"],t,r))),r);return o(this.parsedUrl,t,this.sourceSpatialReference,r)}async executeForTopIds(t,r){const{executeForTopIds:o}=await u.whenOrAbort(new Promise(((t,r)=>e(["../../../../rest/query/executeForTopIds"],t,r))),r);return o(this.parsedUrl,t,r)}async executeForTopExtents(t,r){const{executeForTopExtents:o}=await u.whenOrAbort(new Promise(((t,r)=>e(["../../../../rest/query/executeForTopExtents"],t,r))),r);return o(this.parsedUrl,t,r)}async executeForTopCount(t,r){const{executeForTopCount:o}=await u.whenOrAbort(new Promise(((t,r)=>e(["../../../../rest/query/executeForTopCount"],t,r))),r);return o(this.parsedUrl,t,r)}_normalizeQuery(e){let t=w.from(e);t.sourceSpatialReference=t.sourceSpatialReference||this.sourceSpatialReference,(this.gdbVersion||this.dynamicDataSource)&&(t=t===e?t.clone():t,t.gdbVersion=e.gdbVersion||this.gdbVersion,t.dynamicDataSource=e.dynamicDataSource?d.DataLayerSource.from(e.dynamicDataSource):this.dynamicDataSource);const{infoFor3D:r}=this;if(null!=r&&this._queryIs3DObjectFormat(e)){t=t===e?t.clone():t,t.formatOf3DObjects=null;const s=y.getGlbFormatId(r),u=y.getGltfFormatId(r);for(const e of r.queryFormats){if(e===s){t.formatOf3DObjects=e;break}e!==u||t.formatOf3DObjects||(t.formatOf3DObjects=e)}if(!t.formatOf3DObjects)throw new o("query:unsupported-3d-query-formats","Could not find any supported 3D object query format. Only supported formats are 3D_glb and 3D_gltf");if(t.outSpatialReference&&!l.equals(t.outSpatialReference,this.sourceSpatialReference))throw new o("query:unsupported-out-spatial-reference","3D object feature services do not support projection of geometries");if(null==t.outFields||!t.outFields.includes("*")){t=t===e?t.clone():t,null==t.outFields&&(t.outFields=[]);const{originX:o,originY:s,originZ:u,translationX:a,translationY:i,translationZ:n,scaleX:c,scaleY:p,scaleZ:l,rotationX:y,rotationY:d,rotationZ:h,rotationDeg:f}=r.transformFieldRoles;t.outFields.push(o,s,u,a,i,n,c,p,l,y,d,h,f)}}return t}_normalizeFields(e){if(null!=this.fieldsIndex&&null!=e)for(const t of e){const e=this.fieldsIndex.get(t.name);e&&Object.assign(t,e.toJSON())}}_queryIs3DObjectFormat(e){return null!=this.infoFor3D&&!0===e.returnGeometry&&"xyFootprint"!==e.multipatchOption&&!e.outStatistics}};t.__decorate([i.property({type:d.DataLayerSource})],O.prototype,"dynamicDataSource",void 0),t.__decorate([i.property()],O.prototype,"fieldsIndex",void 0),t.__decorate([i.property()],O.prototype,"gdbVersion",void 0),t.__decorate([i.property()],O.prototype,"infoFor3D",void 0),t.__decorate([i.property({readOnly:!0})],O.prototype,"parsedUrl",null),t.__decorate([i.property()],O.prototype,"pbfSupported",void 0),t.__decorate([i.property()],O.prototype,"queryAttachmentsSupported",void 0),t.__decorate([i.property()],O.prototype,"sourceSpatialReference",void 0),t.__decorate([i.property({type:String})],O.prototype,"url",void 0),O=t.__decorate([p.subclass("esri.layers.graphics.sources.support.QueryTask")],O);return O}));
