/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../geometry","../../../../request","../../../../core/has","../../../../core/Logger","../../../../core/promiseUtils","../../../../core/time","../../../../core/urlUtils","../../../../core/uuid","../../../../geometry/support/meshUtils/External","./uploadAssetErrors","./uploadProgressWeights","./uploads","../../../support/infoFor3D","../../../support/meshSpatialReferenceScaleUtils","../../../../rest/support/meshFeatureAttributes","../../../../support/progressUtils","../../../../geometry/SpatialReference"],(function(e,r,s,t,o,a,n,i,c,u,l,p,d,f,g,m,h,y){"use strict";async function w(e,r,s){const t=e.length;if(!t)return s?.onProgress?.(1),[];const o=h.makeProgressManager(t,s?.onProgress,"uploadAssets");return Promise.all(e.map(((e,t)=>P(e,r,{...s,onProgress:o.makeOnProgress(t)}))))}async function P(e,{layer:r,ongoingUploads:s},t){const o=s.get(e);if(o)return o;if(!L(r))throw new l.UnsupportedError;if(b(e,r))return t?.onProgress?.(1),e;const a=A(e,r,t);s.set(e,a);try{await a}finally{s.delete(e)}return e}function b(e,r){const{parsedUrl:s}=r;return null!=s&&e.metadata.externalSources.some((e=>u.externalIsOnService(e,s)))}async function A(e,r,s){const{metadata:o}=e,{displaySource:n}=o,i=v(n?.source,r,{checkForConversionRequired:t("enable-feature:georeferenced-uploads")}),c=null!=i?T(i,r,s):o.externalSources.length>0?F(e,r,s):S(e,r,s),u=await c;return a.throwIfAborted(s),e.addExternalSources([u]),e}async function T(e,r,s){return{source:await x(e,r,s),original:!0,unitConversionDisabled:!0}}async function F(e,r,s){const t=W(r),{externalSources:o}=e.metadata,a=U(o,r);if(!a)throw new l.NoSupportedSourceError;const n=h.makeProgressManager(p.uploadProgressWeights.uploadConvertibleSource,s?.onProgress,"uploadConvertibleSource"),i=await x(a,r,{onProgress:n.makeOnProgress("uploadEditSource")});e.addExternalSources([{source:i,original:!0}]);const c=a.reduce(((e,{asset:r})=>r instanceof File?e+r.size:e),0),u=n.simulate("serviceAssetsToGlb",h.estimatedConversionTime(c));try{const{source:o,transform:a,origin:n}=await C(i,r,t);return e.transform=a,n&&(e.metadata.georeferenced=!0,s?.useAssetOrigin&&(e.vertexSpace.origin=[n.x,n.y,n.z??0],e.spatialReference=n.spatialReference)),{source:o,unitConversionDisabled:!0}}finally{u.remove()}}async function S(e,r,s){const t=h.makeProgressManager(p.uploadProgressWeights.uploadLocalMesh,s?.onProgress,"uploadLocalMesh"),o=I(e,r,{...s,onProgress:t.makeOnProgress("meshToAssetBlob")});return{source:await R([o],r,{...s,onProgress:t.makeOnProgress("uploadAssetBlobs")}),extent:e.extent.clone(),original:!0}}async function I(e,r,s){const t=W(r),o=await e.load(s),n=await o.toBinaryGLTF({origin:o.origin,signal:s?.signal,ignoreLocalTransform:!0,unitConversionDisabled:!0});return a.throwIfAborted(s),{blob:new Blob([n],{type:"model/gltf-binary"}),assetName:`${c.generateBracedUUID()}.glb`,assetType:t}}function U(e,r){for(const s of e){const e=v(s.source,r);if(e)return e}return null}function v(e,{infoFor3D:r},s={}){if(!e)return null;const{supportedFormats:t,editFormats:o}=r,a=u.externalSourceToMultiPart(e),n=new Array,i=f.getPrjFormatId(r),c=f.getWorldFileFormatId(r);let l=!1;for(const u of a){const e=E(u,t);if(!e)return null;const{assetType:r}=e;if(s.checkForConversionRequired&&(r===i||r===c))return null;o.includes(r)&&(l=!0),n.push(e)}return l?n:null}function E(e,r){const s=u.assetFormatId(e,r);return s?{asset:e,assetType:s}:null}async function x(e,r,s){return R(e.map((e=>D(e,s))),r,s)}async function R(e,r,s){const t=h.makeProgressManager(p.uploadProgressWeights.uploadAssetBlobs,s?.onProgress,"uploadAssetBlobs"),o=await M(e,r,{...s,onProgress:t.makeOnProgress("prepareAssetItems")});a.throwIfAborted(s);const n=o.map((({item:e})=>e)),{uploadResults:i}=await O(n,r,{...s,onProgress:t.makeOnProgress("uploadAssetItems")});return a.throwIfAborted(s),e.map(((e,s)=>k(o[s],i[s],r)))}async function D(e,r){const{asset:s,assetType:t}=e;if(s instanceof File)return{blob:s,assetName:s.name,assetType:t};const o=await s.toBlob(r);return a.throwIfAborted(r),{blob:o,assetName:s.assetName,assetType:t}}async function N(e,r,s){const{blob:t,assetType:o,assetName:n}=e;let c=null;try{const e=await d.uploadItem({data:t,name:n},r.url,s);a.throwIfAborted(s),c={assetType:o,assetUploadId:e.itemID}}catch(u){a.throwIfAbortError(u),G().warnOnce(`Service ${r.url} does not support the REST Uploads API.`)}if(!c){const e=await i.parseData(t);if(a.throwIfAborted(s),!e.isBase64)throw new l.NotBase64Error;c={assetType:o,assetData:e.data}}if(!c)throw new l.UnableToPrepareOptionsError;return{item:c,assetName:n}}function M(e,r,s){const t=h.makeProgressManager(e.length,s?.onProgress,"prepareAssetItems");return Promise.all(e.map((async(e,o)=>{const n=N(await e,r,{...s,onProgress:t.makeOnProgress(o)});return a.throwIfAborted(s),n})))}async function O(e,r,t){const o=h.simulateProgress(t?.onProgress);try{const o=await s(i.join(r.parsedUrl.path,"uploadAssets"),{timeout:0,query:{f:"json",assets:JSON.stringify(e)},method:"post",responseType:"json"});if(a.throwIfAborted(t),o.data.uploadResults.length!==e.length)throw new l.BadResponseError(e.length,o.data.uploadResults.length);return o.data}finally{o.remove()}}function k(e,r,s){const{success:t}=r;if(!t){const{error:s}=r;throw new l.UploadFailedError(e.assetName,s)}const{assetHash:o}=r,{assetName:a,item:{assetType:n}}=e,{infoFor3D:{supportedFormats:i}}=s,c=f.getFormatIdMimeType(n,i);if(!c)throw new l.UnsupportedFormatUploadedError(n);return new u.ServiceAsset(a,c,[new u.ServiceAssetPart(`${s.parsedUrl.path}/assets/${o}`,o)])}async function C(e,r,s){const t=e.map((({assetName:e,parts:r})=>({assetName:e,assetHash:r[0].partHash})));let o;try{const e=i.join(r.parsedUrl.path,"convert3D"),a=r.capabilities?.operations.supportsAsyncConvert3D;o=(await(a?q:B)(e,{query:{f:"json",assets:JSON.stringify(t),transportType:"esriTransportTypeUrl",targetFormat:s,async:a},responseType:"json",timeout:0})).data}catch(a){throw new l.Convert3DFailedError}return j(r,o)}function j(e,r){const s={source:r.assets.map((r=>{const s=f.getMimeTypeFormatId(r.contentType,e.infoFor3D.supportedFormats);if(!s)throw new l.UnsupportedFormatUploadedError(s);return new u.ServiceAsset(r.assetName,r.contentType,[new u.ServiceAssetPart(r.assetURL,r.assetHash)])})),origin:void 0,transform:void 0};if(t("enable-feature:georeferenced-uploads")&&r.transform){if(s.transform=m.extractMeshFeatureTransform(r.transform),r.spatialReference){const e=y.fromJSON(r.spatialReference);s.origin=m.extractMeshFeatureOrigin(r.transform,e)}}else s.transform=g.getMeshTransformForMetersToSpatialReference(e.spatialReference);return s}function B(e,r){return s(e,r)}async function q(e,r){const t=(await s(e,r)).data.statusUrl;for(;;){const e=(await s(t,{query:{f:"json"},responseType:"json"})).data;switch(e.status){case"Completed":return s(e.resultUrl,{query:{f:"json"},responseType:"json"});case"CompletedWithErrors":throw new Error(e.status);case"Failed ImportChanges":case"InProgress":case"Pending":case"ExportAttachments":case"ExportChanges":case"ExportingData":case"ExportingSnapshot":case"ImportAttachments":case"ProvisioningReplica":case"UnRegisteringReplica":break;default:throw new Error}await a.after(H)}}function L(e){return!!e.infoFor3D&&!!e.url}function W({infoFor3D:e}){const r=f.getGlbFormatId(e);if(!r)throw new l.NoGlbSupportError;return r}function G(){return o.getLogger("esri.layers.graphics.sources.support.uploadAssets")}const H=n.Milliseconds(1e3);e.uploadAssets=w,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
