/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../chunks/tslib.es6","../../geometry","../../core/Accessor","../../core/Error","../../core/Logger","../../core/MapUtils","../../core/sql","../../core/accessorSupport/decorators/property","../../core/has","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../../geometry/Polygon","../../geometry/projection","../../geometry/support/spatialReferenceUtils","./layerUtils","./SessionMemoryStorage","./supportUtils","../../rest/knowledgeGraphService","../../rest/knowledgeGraph/GraphQueryStreaming","../../rest/support/Query","../../geometry/Extent"],(function(e,t,i,n,a,o,r,s,d,p,l,m,h,c,y,u,g,f,w,b,T,D){"use strict";e.KnowledgeGraphLayerDataManager=class extends n{constructor(e){super(e),this._processingCacheUpdatesLookup=new Map,this.knowledgeGraph=null,this.inclusionModeDefinition={generateAllSublayers:!0,namedTypeDefinitions:new Map},this.entityTypeNames=new Set,this.relationshipTypeNames=new Set,this.geographicLookup=new Map,this.sublayerCaches=new Map,this.nodeConnectionsLookup=new Map,this.relationshipConnectionsLookup=new Map,this.memberIdTypeLookup=new Map;const t=new Map;e.knowledgeGraph.dataModel.entityTypes?.forEach((i=>{i.name&&(t.set(i.name,"entity"),this._processingCacheUpdatesLookup.set(i.name,[]),e.inclusionModeDefinition&&!e.inclusionModeDefinition?.generateAllSublayers||this.entityTypeNames.add(i.name),i.properties?.forEach((e=>{e.geometryType&&"esriGeometryNull"!==e.geometryType&&this.geographicLookup.set(i.name,{name:e.name??"",geometryType:e.geometryType})})))})),e.knowledgeGraph.dataModel.relationshipTypes?.forEach((i=>{i.name&&(t.set(i.name,"relationship"),this._processingCacheUpdatesLookup.set(i.name,[]),e.inclusionModeDefinition&&!e.inclusionModeDefinition?.generateAllSublayers||this.relationshipTypeNames.add(i.name),i.properties?.forEach((e=>{e.geometryType&&"esriGeometryNull"!==e.geometryType&&this.geographicLookup.set(i.name,{name:e.name??"",geometryType:e.geometryType})})))})),e.inclusionModeDefinition?.namedTypeDefinitions.forEach(((i,n)=>{if("entity"===t.get(n))this.entityTypeNames.add(n);else{if("relationship"!==t.get(n))return o.getLogger(this).warn(`A named type, ${n}, was in the inclusion list that wasn't in the data model and will be removed`),void e.inclusionModeDefinition?.namedTypeDefinitions.delete(n);this.relationshipTypeNames.add(n)}const a=new Map;i.members?.forEach((e=>{r.getOrCreateMapValue(this.memberIdTypeLookup,e.id,(()=>new Set)).add(n);const t=this.getById(e.id);t&&a.set(e.id,t)})),this.sublayerCaches.set(n,a)}))}addToLayer(e){e.forEach((({typeName:e,id:t})=>{if(!this.inclusionModeDefinition)throw new a("knowledge-graph:layer-data-manager","You cannot add to a layer's exclusion list if it was not created with an exclusion list originally");if(this.inclusionModeDefinition.namedTypeDefinitions.has(e)){if(this.inclusionModeDefinition.namedTypeDefinitions.has(e)){const i=this.inclusionModeDefinition.namedTypeDefinitions.get(e);i.members||(i.members=new Map),i.members.set(t,{id:t}),r.getOrCreateMapValue(this.memberIdTypeLookup,t,(()=>new Set)).add(e)}}else{const i=new Map;i.set(t,{id:t}),this.inclusionModeDefinition.namedTypeDefinitions.set(e,{useAllData:!1,members:i}),r.getOrCreateMapValue(this.memberIdTypeLookup,t,(()=>new Set)).add(e)}}))}getById(e){return g.getInstance().readFromStoreById(e)}async getData(e,t,i){if(t.objectType.name&&this.inclusionModeDefinition?.namedTypeDefinitions&&this.inclusionModeDefinition.namedTypeDefinitions.size>0&&!this.inclusionModeDefinition.namedTypeDefinitions.has(t.objectType.name))return[];let n;if(n=e||new T({where:"1=1",outFields:["*"]}),"link-chart"===t.parentCompositeLayer.type){const e=t.parentCompositeLayer,i=this._processingCacheUpdatesLookup.get(t.objectType.name??""),a=n.outFields;a&&1===a.length&&a[0]===u.systemOidFieldName&&"1=1"===n.where||await Promise.all(i??[]);const o=this.sublayerCaches.has(t.objectType.name??"")?Array.from(this.sublayerCaches.get(t.objectType.name)?.values()):[],r=[];return o.forEach((i=>{if(this.relationshipTypeNames.has(t.objectType.name)){i.geometry=e.relationshipLinkChartDiagramLookup.get(i.attributes[t.objectIdField]);const n=this.memberIdTypeLookup.get(i.attributes[u.systemOriginIdFieldName]),a=this.memberIdTypeLookup.get(i.attributes[u.systemDestinationIdFieldName]),o=this._isEndEntitySpatial(n,i,u.systemOriginIdFieldName),r=this._isEndEntitySpatial(a,i,u.systemDestinationIdFieldName);i.attributes[u.systemIsSpatialFieldName]=Number(o&&r)}else{i.geometry=e.entityLinkChartDiagramLookup.get(i.attributes[t.objectIdField]);const n=this.geographicLookup.get(t.objectType.name);n&&i.attributes[n.name]?i.attributes[u.systemIsSpatialFieldName]=1:i.attributes[u.systemIsSpatialFieldName]=0}i.attributes[u.systemLayoutGeometryFieldName]=i.geometry,r.push(i)})),r}return this.retrieveDataFromService(n,t,i)}async getConnectedRecordIds(e,t){const i=[];let n="";const a=[],r=new Map;if(e.forEach((e=>{if(this.memberIdTypeLookup.has(e))for(const t of this.memberIdTypeLookup.get(e)){if(!this.entityTypeNames.has(t))return;r.has(t)?r.get(t)?.push(e):r.set(t,[e])}})),t&&0!==t?.length){for(const e of t)n=n+e+"|";n=n.slice(0,-1)}const s={};let d="",p=-1;for(const[o,m]of r){p++,0!==p&&(d+=" UNION ");const e=`${o}_ids`;s[e]=m,d+=t&&0!==t?.length?`MATCH (n:${o}) WHERE id(n) IN $${e} WITH n MATCH (n)-[r:${n}]-(m) RETURN id(r), type(r), id(m), labels(m)[0]`:`MATCH (n:${o}) WHERE id(n) IN $${e} WITH n MATCH (n)-[r]-(m) RETURN id(r), type(r), id(m), labels(m)[0]`}if(!d)return i;const l=new Promise((e=>{(async()=>{const e=(await w.executeQueryStreaming(this.knowledgeGraph,new b({openCypherQuery:d,bindParameters:s}))).resultRowsStream.getReader();try{for(;;){const{done:t,value:n}=await e.read();if(t)break;for(let e=0;e<n.length;e++){const t=n[e];i.push({id:t[0],typeName:t[1]}),i.push({id:t[2],typeName:t[3]})}}}catch(t){if("AbortError"!==t.name)throw t;o.getLogger(this).info("Request aborted as expected")}})().then((()=>{e()}))}));return a.push(l),this.refreshCacheContent(),await Promise.all(a),i}async getRelationshipsBetweenNodes(e,t){const i=[],n="MATCH (n)-[r]->(m) WHERE id(n) IN $nodeIds AND id(m) in $nodeIds AND NOT id(r) IN $relationshipExclusionIds return id(r), type(r)",a=(await w.executeQueryStreaming(this.knowledgeGraph,new b({openCypherQuery:n,bindParameters:{nodeIds:e,relationshipExclusionIds:t}}))).resultRowsStream.getReader();try{for(;;){const{done:e,value:t}=await a.read();if(e)break;for(let n=0;n<t.length;n++){const e=t[n];i.push({id:e[0],typeName:e[1]})}}}catch(r){if("AbortError"!==r.name)throw r;o.getLogger(this).info("Request aborted as expected")}return i}async getRelationshipsFromNodes(e,t,i){const n=[],a="MATCH (n)-[r]-(m) WHERE id(n) IN $targetEntityIds AND id(m) in $possibleConnectionEntityIds AND NOT id(r) IN $relationshipExclusionIds return id(r), type(r)",r=(await w.executeQueryStreaming(this.knowledgeGraph,new b({openCypherQuery:a,bindParameters:{targetEntityIds:e,possibleConnectionEntityIds:t,relationshipExclusionIds:i}}))).resultRowsStream.getReader();try{for(;;){const{done:e,value:t}=await r.read();if(e)break;for(let i=0;i<t.length;i++){const e=t[i];n.push({id:e[0],typeName:e[1]})}}}catch(s){if("AbortError"!==s.name)throw s;o.getLogger(this).info("Request aborted as expected")}return n}async refreshCacheContent(e,t,i,n=!0){const o=g.getInstance(),s=[],d=new Map,p=new Map;this.knowledgeGraph.dataModel.entityTypes?.forEach((e=>{e.name&&p.set(e.name,e)})),this.knowledgeGraph.dataModel.relationshipTypes?.forEach((e=>{e.name&&p.set(e.name,e)})),e||this.inclusionModeDefinition?e?e.forEach((e=>{if(this.memberIdTypeLookup.has(e))for(const t of this.memberIdTypeLookup.get(e))d.has(t)?d.get(t)?.push(e):d.set(t,[e])})):this.inclusionModeDefinition?.namedTypeDefinitions?.forEach(((e,t)=>{e.useAllData?d.set(t,null):e.members&&e.members.forEach((e=>{d.has(t)&&null!==d.get(t)?d.get(t)?.push(e.id):d.set(t,[e.id])}))})):(this.knowledgeGraph.dataModel.entityTypes?.forEach((e=>{e.name&&d.set(e.name,null)})),this.knowledgeGraph.dataModel.entityTypes?.forEach((e=>{e.name&&d.set(e.name,null)})));for(const[l,m]of d){const e=new Promise((e=>{(async()=>{const e=new Set,s=[];let d,h="",c=!1;if(t||p.get(l)?.properties?.forEach((t=>{t.name&&e.add(t.name)})),i&&this.geographicLookup.has(l)){const t=this.geographicLookup.get(l)?.name;t&&e.add(t)}if(this.entityTypeNames.has(l))h=`MATCH (n:${l}) ${m?"WHERE id(n) IN $ids ":""}return ID(n)`,e.forEach((e=>{h+=`, n.${e}`,s.push(e)}));else{if(!this.relationshipTypeNames.has(l))throw new a("knowledge-graph:layer-data-manager",`The graph type of ${l} could not be determined. Was this type set in the KG data model and inclusion definition?`);c=!0,h=`MATCH ()-[n:${l}]->() ${m?"WHERE id(n) IN $ids ":""}return ID(n), id(startNode(n)), id(endNode(n))`,e.forEach((e=>{h+=`, n.${e}`,s.push(e)}))}d=new b(m?{openCypherQuery:h,bindParameters:{ids:m}}:{openCypherQuery:h});const y=(await w.executeQueryStreaming(this.knowledgeGraph,d)).resultRowsStream.getReader();for(;;){const{done:e,value:t}=await y.read();if(e)break;const i=[];for(let n=0;n<t.length;n++){const e=t[n];let a=0,o=0;const d={properties:{}};for(d.id=e[a],a++,o++,c&&(d.originId=e[a],a++,o++,d.destinationId=e[a],a++,o++,r.getOrCreateMapValue(this.nodeConnectionsLookup,d.originId,(()=>new Set)).add(d.id),r.getOrCreateMapValue(this.nodeConnectionsLookup,d.destinationId,(()=>new Set)).add(d.id),r.getOrCreateMapValue(this.relationshipConnectionsLookup,d.id,(()=>[d.originId,d.destinationId])));a<e.length;a++)d.properties[s[a-o]]=e[a];i.push(d)}const a=o.writeToStore(i,u.systemOidFieldName,this.geographicLookup.get(l)?.name);this.sublayerCaches.has(l)||this.sublayerCaches.set(l,new Map),n&&!this.inclusionModeDefinition?.namedTypeDefinitions.has(l)&&this.inclusionModeDefinition?.namedTypeDefinitions.set(l,{useAllData:!1,members:new Map}),n&&!this.inclusionModeDefinition?.namedTypeDefinitions.get(l).members&&(this.inclusionModeDefinition.namedTypeDefinitions.get(l).members=new Map);const d=this.sublayerCaches.get(l);a.forEach((e=>{d?.set(e.attributes[u.systemOidFieldName],e),n&&!this.inclusionModeDefinition?.namedTypeDefinitions.get(l).members.has(e.attributes[u.systemOidFieldName])&&(this.inclusionModeDefinition?.namedTypeDefinitions.get(l).members.set(e.attributes[u.systemOidFieldName],{id:e.attributes[u.systemOidFieldName]}),r.getOrCreateMapValue(this.memberIdTypeLookup,e.attributes[u.systemOidFieldName],(()=>new Set)).add(l))}))}})().then((()=>{e(null)}))}));s.push(e),this._processingCacheUpdatesLookup.get(l)?.push(e)}await Promise.all(s)}removeFromLayer(e){const t=new Set,i=new Set(e.map((e=>e.id)));for(const n of e)t.add(n.typeName),1===this.memberIdTypeLookup.get(n.id)?.size?this.memberIdTypeLookup.delete(n.id):this.memberIdTypeLookup.get(n.id)?.delete(n.typeName),this.inclusionModeDefinition?.namedTypeDefinitions.forEach(((e,t)=>{t===n.typeName&&e.members?.has(n.id)&&e.members.delete(n.id)}));t.forEach((e=>{this.sublayerCaches.get(e)?.forEach(((t,n)=>{i.has(n)&&this.sublayerCaches.get(e)?.delete(n)}))}))}async retrieveDataFromService(e,t,i){const n=g.getInstance(),o=new Set,r=[];let d,p="",l=[];const m="relationship"===t.graphType,T=this.inclusionModeDefinition?.namedTypeDefinitions?.get(t.objectType.name)?.useAllData,M=t.parentCompositeLayer.sublayerIdsCache.get(t.objectType.name);let I=!T&&M?Array.from(M).sort():null;if(this.inclusionModeDefinition?.namedTypeDefinitions?.get(t.objectType.name)?.useAllData)this.inclusionModeDefinition?.namedTypeDefinitions?.get(t.objectType.name)?.useAllData&&null!=e.objectIds&&(I=e.objectIds);else if(null!=e.objectIds&&I&&I.length>0){const t=e.objectIds;e.objectIds=I.filter((e=>t.includes(e)))}else if(null!=e.objectIds)I=e.objectIds;else{if(this.inclusionModeDefinition?.namedTypeDefinitions.has(t.objectType.name)&&(!this.inclusionModeDefinition.namedTypeDefinitions.get(t.objectType.name)?.members||this.inclusionModeDefinition.namedTypeDefinitions.get(t.objectType.name)?.members?.size<1))return e.objectIds=[],[];e.objectIds=I}if(null!=e.outFields){const i=e.outFields;i.includes("*")?t.fields.forEach((e=>{o.add(e.name)})):i.forEach((e=>{e!==u.systemOidFieldName&&e!==t.geometryFieldName&&o.add(e)}))}if(null!=e.geometry){const i=e.geometry;let n;const l=t.parentCompositeLayer.dataManager.knowledgeGraph.serviceDefinition,u=l?.spatialReference,g=l?.serviceCapabilities?.geometryCapabilities;let w=g?.geometryMaxBoundingRectangleSizeX,T=g?.geometryMaxBoundingRectangleSizeY;if("point"===i.type){let e=i;e.spatialReference?.isWGS84||(await c.initializeProjection(e.spatialReference,y.wgs84),e=c.project(e,y.wgs84)),n=new D({spatialReference:y.wgs84,xmin:e.x-1e-4,ymin:e.y-1e-4,xmax:e.x+1e-4,ymax:e.y+1e-4})}else i?.extent?.spatialReference&&!i.spatialReference?.isWGS84?(await c.initializeProjection(i.extent.spatialReference,y.wgs84),n=c.project(i.extent,y.wgs84)):n=i.extent;if(w&&T&&u){if(4326!==u.wkid){const e=new D({spatialReference:u,xmax:w,ymax:T}),t=c.project(e,y.wgs84);w=t.xmax,T=t.ymax}if(n.xmax-n.xmin>w)throw new a("knowledge-graph:layer-data-manager",`Extent x bounds should be within ${w}° latitude, limit exceeded`);if(n.ymax-n.ymin>T)throw new a("knowledge-graph:layer-data-manager",`Extent y bounds should be within ${T}° longitude, limit exceeded`)}if(null!=e.where&&"1=1"!==e.where){const i=await s.parseWhereClause(e.where.toUpperCase(),t.fieldsIndex);t.fields.forEach((e=>{i.fieldNames.includes(e.name)&&o.add(e.name)}))}p=m?`Match ()-[n:${t.objectType.name}]->() WHERE esri.graph.ST_Intersects($param_filter_geom, n.${t.geometryFieldName}) return ID(n), id(startNode(r)), id(endNode(r))`:`Match (n:${t.objectType.name}) WHERE esri.graph.ST_Intersects($param_filter_geom, n.${t.geometryFieldName}) return ID(n)`,t.geometryFieldName&&o.add(t.geometryFieldName),o.forEach((e=>{p+=`, n.${e}`,r.push(e)})),d=new b({openCypherQuery:p,bindParameters:{param_filter_geom:new h({rings:f.extentToInBoundsRings(n)})}})}else{let i="";if(null!=e.where&&"1=1"!==e.where){const n=await s.parseWhereClause(e.where,t.fieldsIndex);t.fields.forEach((e=>{n.fieldNames.includes(e.name)&&o.add(e.name)}));const a=new Set(["column-reference","string","number","binary-expression"]),r=new Set(["=","<","<=","<>",">",">=","AND","OR","LIKE"]);let d=!1;const p=e=>{if("column-reference"===e.type)return`n.${e.column}`;if("string"===e.type)return`'${e.value}'`;if("number"===e.type)return`${e.value}`;if("binary-expression"===e.type&&a.has(e.left.type)&&a.has(e.right.type)&&r.has(e.operator))return`${p(e.left)} ${e.operator} ${p(e.right)}`;if("binary-expression"===e.type&&"LIKE"===e.operator){let t="";if("function"===e.left.type&&"column-reference"===e.left.args.value[0].type)t+=`lower(n.${e.left.args.value[0].column})`;else{if("column-reference"!==e.left.type)return d=!0,"";t+=`lower(n.${e.left.column})`}if(t+=" CONTAINS (","string"!==e.right.type)return d=!0,"";{let i=e.right.value;"%"===i.charAt(0)&&(i=i.slice(1)),"%"===i.charAt(i.length-1)&&(i=i.slice(0,-1)),t+=`'${i.toLowerCase()}')`}return t}return d=!0,""};i=p(n.parseTree),d&&(i="")}let n="";n=m?`Match ()-[n:${t.objectType.name}]->()`:`Match (n:${t.objectType.name})`;let a=!1;I&&(a=!0,n+=" WHERE ID(n) IN $ids"),i&&(n+=a?" AND":" WHERE",n+=` ${i}`),n+=" return ID(n)",m&&(n+=", id(startNode(n)), id(endNode(n))"),e.returnGeometry&&t.geometryFieldName&&o.add(t.geometryFieldName),o.forEach((e=>{n+=`, n.${e}`,r.push(e)})),d=new b(I?{openCypherQuery:n,bindParameters:{ids:I}}:{openCypherQuery:n})}const N=(await w.executeQueryStreaming(t.parentCompositeLayer.dataManager.knowledgeGraph,d,i)).resultRowsStream.getReader();for(;;){const{done:e,value:i}=await N.read();if(e)break;const a=[];for(let t=0;t<i.length;t++){const e=i[t];let n=0,o=0;const s={properties:{}};for(s.id=e[n],n++,o++,m&&(s.originId=e[n],n++,o++,s.destinationId=e[n],n++,o++);n<e.length;n++)s.properties[r[n-o]]=e[n];a.push(s)}l=l.concat(n.writeToStore(a,u.systemOidFieldName,t.parentCompositeLayer.dataManager.geographicLookup.get(t.objectType.name)?.name))}return l}_isEndEntitySpatial(e,t,i){for(const n of e??[])if(this.entityTypeNames.has(n)){const e=this.geographicLookup.get(n),a=e&&this.sublayerCaches.get(n)?.get(t.attributes[i]);if(e&&a?.attributes[e.name])return!0}return!1}},t.__decorate([d.property()],e.KnowledgeGraphLayerDataManager.prototype,"knowledgeGraph",void 0),t.__decorate([d.property()],e.KnowledgeGraphLayerDataManager.prototype,"inclusionModeDefinition",void 0),t.__decorate([d.property()],e.KnowledgeGraphLayerDataManager.prototype,"entityTypeNames",void 0),t.__decorate([d.property()],e.KnowledgeGraphLayerDataManager.prototype,"relationshipTypeNames",void 0),t.__decorate([d.property()],e.KnowledgeGraphLayerDataManager.prototype,"geographicLookup",void 0),t.__decorate([d.property()],e.KnowledgeGraphLayerDataManager.prototype,"sublayerCaches",void 0),t.__decorate([d.property()],e.KnowledgeGraphLayerDataManager.prototype,"nodeConnectionsLookup",void 0),t.__decorate([d.property()],e.KnowledgeGraphLayerDataManager.prototype,"relationshipConnectionsLookup",void 0),t.__decorate([d.property()],e.KnowledgeGraphLayerDataManager.prototype,"memberIdTypeLookup",void 0),e.KnowledgeGraphLayerDataManager=t.__decorate([m.subclass("esri.layers.knowledgeGraph.KnowledgeGraphLayerDataManager")],e.KnowledgeGraphLayerDataManager),Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
