/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../geometry","../../Graphic","../../request","../../symbols","../../core/Error","../../core/MapUtils","../GraphicsLayer","../graphics/featureConversionUtils","../graphics/OptimizedGeometry","./layerUtils","./SessionMemoryStorage","../../libs/linkchartlayout/LinkChartLayout","../../rest/knowledgeGraphService","../../rest/knowledgeGraph/GraphQueryStreaming","../../rest/knowledgeGraph/ProtoFeatureCollection","../../rest/knowledgeGraph/wasmInterface/knowledgeWasmAccess","../../rest/knowledgeGraph/wasmInterface/WasmDataModelWrapperInterfaces","../../rest/knowledgeGraph/wasmInterface/WasmSerializedLayerData","../../rest/knowledgeGraph/wasmInterface/wasmToFeatureFactories","../../symbols/CIMSymbol","../../geometry/Polyline","../../symbols/SimpleFillSymbol","../../geometry/Polygon","../../symbols/TextSymbol","../../geometry/Point"],(function(e,t,r,o,n,i,a,s,l,c,d,u,y,p,f,m,g,h,b,w,_,T,I,C,M,A){"use strict";function F(e){if(!e.spatialReference.isWGS84)throw new i("knowledge-graph:layer-support-utils","The extentToInBoundsRings function only supports WGS84 spatial references.");return e.clone().normalize().map((e=>[[e.xmin,e.ymin],[e.xmin,e.ymax],[e.xmax,e.ymax],[e.xmax,e.ymin],[e.xmin,e.ymin]]))}async function E(e,t){const r=[],o=new Map,n=[];if(t.dataModel?.relationshipTypes)for(const i of t.dataModel.relationshipTypes)i.name&&o.set(i.name,[]);for(const i of e)o.has(i.typeName)&&o.get(i.typeName)?.push(i.id);for(const[i,a]of o){if(a.length<1)continue;const e=new f({openCypherQuery:`MATCH (n)-[r:${i}]->(m) WHERE id(r) in $ids RETURN id(n), labels(n)[0], id(m), labels(m)[0]`,bindParameters:{ids:a}});n.push(p.executeQueryStreaming(t,e).then((async e=>{const t=e.resultRowsStream.getReader();for(;;){const{done:e,value:o}=await t.read();if(e)break;for(const t of o)r.push({id:t[0],typeName:t[1]}),r.push({id:t[2],typeName:t[3]})}})))}return await Promise.all(n),r}async function S(e,t){const r=new Map,o=new Map,n=[];if(t.dataModel?.relationshipTypes)for(const i of t.dataModel.relationshipTypes)i.name&&o.set(i.name,[]);for(const i of e)o.has(i.typeName)&&o.get(i.typeName)?.push(i.id);for(const[i,a]of o){if(a.length<1)continue;const e=new f({openCypherQuery:`MATCH (n)-[r:${i}]->(m) WHERE id(r) in $ids RETURN id(r), id(n), id(m)`,bindParameters:{ids:a}});n.push(p.executeQueryStreaming(t,e).then((async e=>{const t=e.resultRowsStream.getReader();for(;;){const{done:e,value:o}=await t.read();if(e)break;for(const t of o)r.set(t[0],[t[1],t[2]])}})))}return await Promise.all(n),r}async function k(e){const t=[],r={generateAllSublayers:!1,namedTypeDefinitions:new Map};return e.entitiesUrl&&t.push(G(e.entitiesUrl).then((e=>{v(e,r)}))),e.relationshipsUrl&&t.push(G(e.relationshipsUrl).then((e=>{v(e,r)}))),e.idCollectionsUrl&&t.push(L(e.idCollectionsUrl).then((e=>{z(e,r)}))),await Promise.all(t),r}async function R(e,t){t??=!1;const r={generateAllSublayers:t,namedTypeDefinitions:new Map};return await L(e).then((e=>{z(e,r)})),r}async function x(e,t,r){const o=await g.getWasmInterface(),n=new o.FeatureCollection,i=new o.FeatureCollection;try{N(n,o,e,"entities",t,r),N(i,o,e,"relationships",t,r);const a=new o.FeatureCollectionEncoder,s=new o.FeatureCollectionEncoder,l=Y(n,a),c=structuredClone(l),d=Y(i,s),u={entitiesFC:c,relationshipsFC:structuredClone(d),idCollections:await D(e)};return a.delete(),s.delete(),u}finally{n.delete(),i.delete()}}async function D(e){const t=await g.getWasmInterface(),r=new t.MapOfObjectIdentifierSets;P(r,t,e);const o=new t.MapOfObjectIdentifierSetsEncoder;try{o.set_map_of_identifier_sets(r),o.encode();const e=o.get_encoding_result();if(0!==e.error.error_code)throw new i("knowledge-graph:layer-support-utils",e.error.error_message);const t=structuredClone(e.get_byte_buffer());return o.delete(),t}finally{r.delete()}}function N(e,t,r,o,n,i){e.version="";const a=new t.QueryResult,s=new t.FeatureResult,c="entities"===o?m.ProtoOutboundEntityFeatureCollectionAttributionIndexes:m.ProtoOutboundRelationshipFeatureCollectionAttributionIndexes;s.unique_id_field={name:c[c.ELEMENTUID],isSystemMaintained:!1},s.globalid_field_name=c[c.ELEMENTUID],s.geohash_field_name="",s.geometry_properties={shapeAreaFieldName:"",shapeLengthFieldName:"",units:""},s.spatial_reference={wkid:4326,latestWkid:4326,vcsWkid:0,latestVcsWkid:0,wkt:""},s.exceeded_transfer_limit=!1,s.has_z=!1,s.has_m=!1,s.transform={quantizeOriginPosition:{value:b.WasmQuantizeOriginPositionTypeCode.upperLeft},scale:{xScale:1e-9,yScale:1e-9,mScale:1e-4,zScale:1e-4},translate:{xTranslate:-400,yTranslate:-400,mTranslate:-1e5,zTranslate:-1e5}};for(const l of Object.keys(c).filter((e=>isNaN(Number(e))))){const e=new t.Field;if(e.name=l,e.alias=l,e.sql_type={value:b.SqlTypeCode.sqlTypeBigInt},"entities"===o)switch(l){case c[c.ELEMENTUID]:case c[c.TYPENAME]:e.field_type={value:h.EsriFieldTypes.esriFieldTypeString}}else switch(l){case c[c.ELEMENTUID]:case c[c.TYPENAME]:case m.ProtoOutboundRelationshipFeatureCollectionAttributionIndexes[m.ProtoOutboundRelationshipFeatureCollectionAttributionIndexes.FROMUID]:case m.ProtoOutboundRelationshipFeatureCollectionAttributionIndexes[m.ProtoOutboundRelationshipFeatureCollectionAttributionIndexes.TOUID]:e.field_type={value:h.EsriFieldTypes.esriFieldTypeString}}e.domain="",s.add_field(e),e.delete()}const d=new Map;for(const l of n.dataModel.entityTypes)d.set(l.name,"entities");for(const l of n.dataModel.relationshipTypes)d.set(l.name,"relationships");for(const[u,y]of r.namedTypeDefinitions)if(o===d.get(u))for(const e of y.members.values()){const r=new t.Feature;for(const a of Object.keys(c).filter((e=>isNaN(Number(e)))))if("entities"===o)switch(a){case c[c.ELEMENTUID]:r.add_attribute(e.id,t.esriFieldType.esriFieldTypeString);break;case c[c.TYPENAME]:r.add_attribute(u,t.esriFieldType.esriFieldTypeString)}else switch(a){case c[c.ELEMENTUID]:r.add_attribute(e.id,t.esriFieldType.esriFieldTypeString);break;case m.ProtoOutboundRelationshipFeatureCollectionAttributionIndexes[m.ProtoOutboundRelationshipFeatureCollectionAttributionIndexes.FROMUID]:r.add_attribute(i.has(e.id)?i.get(e.id)[0]:"",t.esriFieldType.esriFieldTypeString);break;case m.ProtoOutboundRelationshipFeatureCollectionAttributionIndexes[m.ProtoOutboundRelationshipFeatureCollectionAttributionIndexes.TOUID]:r.add_attribute(i.has(e.id)?i.get(e.id)[1]:"",t.esriFieldType.esriFieldTypeString);break;case c[c.TYPENAME]:r.add_attribute(u,t.esriFieldType.esriFieldTypeString)}let n;if(e.linkChartLocation&&"x"in e.linkChartLocation?n=l.convertFromGeometry(e.linkChartLocation):e.linkChartLocation&&(n=e.linkChartLocation),e.linkChartLocation&&n){const e=new t.FeatureCollectionGeometry;let i=!1;switch(o){case"entities":e.geometry_type=t.esriGeometryType.esriGeometryPoint,i=!0;break;case"relationships":e.geometry_type=t.esriGeometryType.esriGeometryPolyline}e.coords=new Float64Array(n.coords),e.lengths=new Uint32Array(i?[1]:n.lengths),r.set_compressed_geometry(e),e.delete()}s.add_feature(r),r.delete()}switch(o){case"entities":s.geometry_type=t.esriGeometryType.esriGeometryPoint;break;case"relationships":s.geometry_type=t.esriGeometryType.esriGeometryPolyline}return a.set_feature_result(s),e.set_query_result(a),s.delete(),a.delete(),e}function P(e,t,r){for(const[o,n]of r.namedTypeDefinitions){if(!n.members||n.useAllData)continue;const r=n.members.keys();let i=!1,a=!0;const s=new t.ObjectIdArray,l=new t.StringArray,c=new t.GlobalIdArray,d=new t.IdentifierArray,u=new t.ObjectIdentifierSet;for(const e of r)a&&(i=!isNaN(Number(e)),a=!1),i?s.add_objectid(Number(e)):(l.add_string(e),c.add_globalid(e)),d.add_identifier(e);u.set_oid_array(s),u.set_string_array(l),u.set_globalid_array(c),u.set_identifier_array(d),s.delete(),l.delete(),c.delete(),d.delete(),e.put_identifier_set(o,u),u.delete()}return e}async function G(e){const t=await o(e,{responseType:"array-buffer"});return O(await t.data)}async function O(e){const t=new((await g.getWasmInterface()).FeatureCollectionDecoder),r=t.decode(new Uint8Array(e));if(0!==r.error_code)throw new i("knowledge-graph:layer-support-utils",r.error_message);const o=t.get_feature_collection(),n=w.wasmToProtoFeatureCollection(o);return t.delete(),n}async function L(e){const t=await o(e,{responseType:"array-buffer"}),r=await t.data;return U(new Uint8Array(r))}async function U(e){const t=new((await g.getWasmInterface()).MapOfObjectIdentifierSetsDecoder),r=t.decode(new Uint8Array(e)),o=new Map;if(0!==r.error_code)throw new i("knowledge-graph:layer-support-utils",r.error_message);const n=t.get_map_of_identifier_sets(),a=n.keys,s=a.size();for(let l=0;l<s;l++){const e=a.get(l),t=n.query_identifier_set(e),r=[];if(t.id_array_type.value===b.IdArrayType.GLOBALID_ARRAY){const e=t.get_globalid_array(),o=e.count();for(let t=0;t<o;t++)r.push(e.get_globalid_at(t))}else if(t.id_array_type.value===b.IdArrayType.IDENTIFIER_ARRAY){const e=t.get_identifier_array(),o=e.count();for(let t=0;t<o;t++)r.push(e.get_identifier_at(t).toString())}else if(t.id_array_type.value===b.IdArrayType.STRING_ARRAY){const e=t.get_string_array(),o=e.count();for(let t=0;t<o;t++)r.push(e.get_string_at(t))}else{if(t.id_array_type.value!==b.IdArrayType.OID_ARRAY)throw new i("knowledge-graph:layer-support-utils","Tried to encode an unexpected ID Array type.");{const e=t.get_oid_array(),o=e.count();for(let t=0;t<o;t++)r.push(e.get_objectid_at(t).toString())}}o.set(e,r)}return t.delete(),o}function v(e,t){if(!e?.queryResult?.featureResult)return t;const r=e.queryResult.featureResult.fieldNameToAttributeIndexMap;for(const o of e.queryResult.featureResult.features){const e=o.attributes[r[m.ProtoInboundFeatureCollectionAttributionNames.TYPENAME]],n=a.getOrCreateMapValue(t.namedTypeDefinitions,e,(()=>({useAllData:!1,members:new Map}))),i=o.attributes[r[m.ProtoInboundFeatureCollectionAttributionNames.ELEMENTUID]];if(o.compressedGeometry?.coords?.length>0){let e=o.compressedGeometry.lengths;"esriGeometryPoint"===o.compressedGeometry.geometryType&&(e=[]),n.members.set(i,{id:i,linkChartLocation:new c(e,o.compressedGeometry.coords)})}else n.members.set(i,{id:i})}return t}function z(e,t){for(const[r,o]of e){const e=a.getOrCreateMapValue(t.namedTypeDefinitions,r,(()=>({useAllData:!1,members:new Map})));for(const t of o)e.members.has(t)||e.members.set(t,{id:t})}return t}const W="ESRI__ChronologicalLayoutOverlay",q=()=>W,j=e=>{const t=[],o={type:"CIMGeometricEffectCut",beginCut:3,endCut:3};for(const n of e.chronologicalAuxiliaryGraphics?.lines??[]){const e={type:"CIMSolidStroke",enable:!0,width:n.width,color:[n.color.r,n.color.g,n.color.b,Math.round(n.color.a/100*255)],effects:n.dashPattern.length>0?[{type:"CIMGeometricEffectDashes",dashTemplate:n.dashPattern,lineDashEnding:"NoConstraint"},o]:[o]},i={type:"CIMVectorMarker",enable:!0,size:10,frame:{xmin:-5,ymin:-5,xmax:0,ymax:5},markerGraphics:[{type:"CIMMarkerGraphic",geometry:{rings:[[[-12,-3.47],[-12,3.6],[-2.06,-.03],[-12,-3.47]]]},symbol:{type:"CIMPolygonSymbol",symbolLayers:[{type:"CIMSolidFill",enable:!0,color:[n.color.r,n.color.g,n.color.b,Math.round(n.color.a/100*255)]}]}}],markerPlacement:{type:"CIMMarkerPlacementOnLine",angleToLine:!0,relativeTo:"LineEnd",offsetAlongLine:0}},a=new _({data:{type:"CIMSymbolReference",symbol:{type:"CIMLineSymbol",symbolLayers:n.arrowheadSizeAtEnd?[e,i]:[e]}}});for(const o of n.elements){const e=new T({paths:[[[o.origin.x,o.origin.y],[o.destination.x,o.destination.y]]]});t.push(new r({geometry:e,symbol:a}))}}for(const n of e.chronologicalAuxiliaryGraphics?.polygons??[]){const e=new I({color:[n.color.r,n.color.g,n.color.b,n.color.a/100],style:"solid",outline:null});for(const o of n.elements){const n=new C({rings:[o.points.map((e=>[e.x,e.y]))]});t.push(new r({geometry:n,symbol:e}))}}for(const n of e.chronologicalAuxiliaryGraphics?.texts??[]){let e="middle",o="center";switch(n.direction?.value){case y.Direction2D.left:o="right";break;case y.Direction2D.right:o="left";break;case y.Direction2D.bottom:e="bottom"}for(const i of n.elements){const a=new M({color:[n.color.r,n.color.g,n.color.b,n.color.a/100],text:i.str,font:{size:n.height,weight:"bold"},verticalAlignment:e,horizontalAlignment:o}),s=new A({x:i.anchor.x,y:i.anchor.y});t.push(new r({geometry:s,symbol:a}))}}return new s({graphics:t,listMode:"hide",title:W,id:W})},Y=(e,t)=>{t.set_feature_collection(e),t.encode();const r=t.get_encoding_result();if(0!==r.error.error_code)throw new i("knowledge-graph:layer-support-utils",r.error.error_message);return r.get_byte_buffer()},Q=(e,t)=>{const r=new Map;for(const n of[...t.entityTypes??[],...t.relationshipTypes??[]])for(const e of n.properties??[])e.geometryType&&"esriGeometryNull"!==e.geometryType&&r.set(n.name,e.name??"");const o=u.getInstance();for(const n of e)o.writeToStore([n],d.systemOidFieldName,r.get(n.typeName??"")??"")};e.addFeatureCollectionToInclusionDefinition=v,e.addIdMapToInclusionDefinition=z,e.deserializeFeatureCollection=O,e.deserializeIdCollectionMap=U,e.extentToInBoundsRings=F,e.fetchAndConvertSerializedKgIdMap=R,e.fetchAndConvertSerializedLinkChart=k,e.fetchAndDeserializeFeatureCollection=G,e.fetchAndDeserializeIdCollectionMap=L,e.getChronologicalOverlay=j,e.getDefaultChronologicalOverlayLayerId=q,e.getRelationshipEndNodeIds=E,e.getRelationshipEndNodeMap=S,e.loadRecordsIntoLocalCache=Q,e.serializeInclusionDefinitionToAllPbf=x,e.serializeInclusionDefinitionToIdCollectionsMapPbf=D,e.setFeatureCollectionProperties=N,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
