/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../chunks/tslib.es6","../../core/Collection","../../core/lang","../../core/Logger","../../core/accessorSupport/decorators/property","../../core/has","../../core/accessorSupport/decorators/reader","../../core/accessorSupport/decorators/subclass","../../core/accessorSupport/decorators/writer","../../core/accessorSupport/layerContainerType","../../geometry/Extent","../../geometry/HeightModelInfo","../../geometry/SpatialReference","../support/arcgisLayerUrl","../support/commonProperties","../support/EditFieldsInfo","../support/FeatureIndex","../support/featureLayerUtils","../support/GeometryFieldsInfo","../support/LayerFloorInfo","../support/Relationship","../support/serviceCapabilitiesUtils","../support/Subtype","../../time/timeZoneUtils"],(function(e,t,r,o,i,s,p,n,a,d,l,c,u,y,h,_,v,g,f,m,I,F,b,S,x){"use strict";const E=e=>{let p=class extends e{constructor(){super(...arguments),this.copyright=null,this.capabilities=null,this.dateFieldsTimeZone=null,this.datesInUnknownTimezone=!1,this.definitionExpression=null,this.displayField=null,this.editFieldsInfo=null,this.editingInfo=null,this.elevationInfo=null,this.floorInfo=null,this.fullExtent=null,this.gdbVersion=null,this.geometryFieldsInfo=null,this.geometryType=null,this.globalIdField=null,this.hasM=void 0,this.hasZ=void 0,this.heightModelInfo=null,this.historicMoment=null,this.indexes=new(r.ofType(g.FeatureIndex)),this.isTable=!1,this.layerId=void 0,this.maxScale=0,this.minScale=0,this.objectIdField=null,this.preferredTimeZone=null,this.relationships=null,this.returnM=void 0,this.returnZ=void 0,this.serviceDefinitionExpression=null,this.serviceItemId=null,this.sourceJSON=null,this.spatialReference=y.WGS84,this.subtypeField=null,this.subtypes=null,this.trackIdField=null,this.version=void 0}get authenticationTriggerEvent(){if(!this.url)return null;const{capabilities:e}=this;if(e){const{query:t,operations:r,editing:o}=e;if(!t.supportsQueryByOthers||!t.supportsQueryByAnonymous)return"load";if(r.supportsEditing&&!(o.supportsUpdateByOthers&&o.supportsUpdateByAnonymous&&o.supportsDeleteByOthers&&o.supportsDeleteByAnonymous))return"load"}if(this.serviceDefinitionExpression?.toLowerCase().includes("current_user"))return"load";if(this.userHasUpdateItemPrivileges){if(f.isLayerCacheStale(this))return"load";if(this.hasUpdateItemRestrictions)return e.operations.supportsQuery?"editing":"load"}if(this.userHasFullEditingPrivileges&&this.hasFullEditingRestrictions)return"editing";const t=this.editFieldsInfo;return(t?.creatorField||t?.editorField)&&e?.operations.supportsEditing?"editing":null}readCapabilitiesFromService(e,t){return b.getFeatureLayerCapabilities(t,this.url)}readEditingInfo(e,t){const{editingInfo:r}=t;return r?{lastEditDate:null!=r.lastEditDate?new Date(r.lastEditDate):null}:null}get effectiveCapabilities(){const e=this.capabilities;if(!e)return null;const t=o.clone(e),{operations:r,editing:i}=t;return f.supportsQueryOnly(this)?(this.userHasUpdateItemPrivileges&&(r.supportsQuery=!0),t):this.userHasUpdateItemPrivileges?(r.supportsAdd=r.supportsDelete=r.supportsEditing=r.supportsQuery=r.supportsUpdate=i.supportsDeleteByOthers=i.supportsGeometryUpdate=i.supportsUpdateByOthers=!0,t):(this.userHasFullEditingPrivileges&&r.supportsEditing&&(r.supportsAdd=r.supportsDelete=r.supportsUpdate=i.supportsGeometryUpdate=!0),t)}readGlobalIdFieldFromService(e,t){return f.readGlobalIdField(t)}get hasFullEditingRestrictions(){const e=this.capabilities;if(!e||f.supportsQueryOnly(this))return!1;const{operations:t,editing:r}=e;return t.supportsEditing&&!(t.supportsAdd&&t.supportsDelete&&t.supportsUpdate&&r.supportsGeometryUpdate)}get hasUpdateItemRestrictions(){const e=this.capabilities;if(!e)return!1;const{operations:t,editing:r}=e;return f.supportsQueryOnly(this)?!t.supportsQuery:!(t.supportsAdd&&t.supportsDelete&&t.supportsEditing&&t.supportsQuery&&t.supportsUpdate&&r.supportsDeleteByOthers&&r.supportsGeometryUpdate&&r.supportsUpdateByOthers)}readIsTableFromService(e,t){return"Table"===t.type}readMaxScale(e,t){return t.effectiveMaxScale||e||0}readMinScale(e,t){return t.effectiveMinScale||e||0}readObjectIdFieldFromService(e,t){return f.readObjectIdField(t)}readServiceDefinitionExpression(e,t){return t.definitionQuery||t.definitionExpression}set url(e){if(null==e)return void this._set("url",e);const t=h.sanitizeUrlWithLayerId({layer:this,url:e,nonStandardUrlAllowed:!0,logger:i.getLogger(this)});this._set("url",t.url),null!=t.layerId&&this._set("layerId",t.layerId)}writeUrl(e,t,r,o){h.writeUrlWithLayerId(this,e,null,t,o)}readVersion(e,t){return f.readVersion(t)}};return t.__decorate([s.property({readOnly:!0})],p.prototype,"authenticationTriggerEvent",null),t.__decorate([s.property({type:String,json:{origins:{service:{read:{source:"copyrightText"}}}}})],p.prototype,"copyright",void 0),t.__decorate([s.property({readOnly:!0,json:{read:!1,origins:{service:{read:{source:["advancedQueryCapabilities","allowGeometryUpdates","allowUpdateWithoutMValues","archivingInfo","capabilities","datesInUnknownTimezone","hasAttachments","hasM","hasZ","isDataBranchVersioned","isDataVersioned","maxRecordCount","maxRecordCountFactor","ownershipBasedAccessControlForFeatures","standardMaxRecordCount","supportedQueryFormats","supportsAdvancedQueries","supportsApplyEditsWithGlobalIds","supportsAttachmentsByUploadId","supportsAttachmentsResizing","supportsCalculate","supportsCoordinatesQuantization","supportsExceedsLimitStatistics","supportsFieldDescriptionProperty","supportsQuantizationEditMode","supportsRollbackOnFailureParameter","supportsStatistics","supportsTruncate","supportsValidateSql","tileMaxRecordCount","useStandardizedQueries"]}}}}})],p.prototype,"capabilities",void 0),t.__decorate([n.reader("service","capabilities")],p.prototype,"readCapabilitiesFromService",null),t.__decorate([s.property(x.timeZoneProperty("dateFieldsTimeReference"))],p.prototype,"dateFieldsTimeZone",void 0),t.__decorate([s.property({type:Boolean})],p.prototype,"datesInUnknownTimezone",void 0),t.__decorate([s.property({type:String,json:{origins:{service:{read:!1,write:!1}},name:"layerDefinition.definitionExpression",write:{enabled:!0,allowNull:!0}}})],p.prototype,"definitionExpression",void 0),t.__decorate([s.property({type:String,json:{origins:{service:{read:{source:"displayField"}}}}})],p.prototype,"displayField",void 0),t.__decorate([s.property({readOnly:!0,type:v})],p.prototype,"editFieldsInfo",void 0),t.__decorate([s.property({readOnly:!0})],p.prototype,"editingInfo",void 0),t.__decorate([n.reader("editingInfo")],p.prototype,"readEditingInfo",null),t.__decorate([s.property({readOnly:!0})],p.prototype,"effectiveCapabilities",null),t.__decorate([s.property((()=>{const e=o.clone(_.elevationInfo),t=e.json.origins;return t["web-map"]={read:!1,write:!1},t["portal-item"]={read:!1,write:!1},e})())],p.prototype,"elevationInfo",void 0),t.__decorate([s.property({type:I,json:{name:"layerDefinition.floorInfo",write:!0,origins:{"web-scene":{name:"layerDefinition.floorInfo",write:{enabled:!0,layerContainerTypes:l.excludeTables}}}}})],p.prototype,"floorInfo",void 0),t.__decorate([s.property({type:c,json:{origins:{service:{read:{source:"extent"}}}}})],p.prototype,"fullExtent",void 0),t.__decorate([s.property()],p.prototype,"gdbVersion",void 0),t.__decorate([s.property({readOnly:!0,type:m,json:{read:{source:"geometryProperties"}}})],p.prototype,"geometryFieldsInfo",void 0),t.__decorate([s.property({type:["point","polygon","polyline","multipoint","multipatch","mesh"],json:{origins:{service:{read:f.geometryTypeKebabDict.read}}}})],p.prototype,"geometryType",void 0),t.__decorate([s.property({type:String})],p.prototype,"globalIdField",void 0),t.__decorate([n.reader("service","globalIdField",["globalIdField","fields"])],p.prototype,"readGlobalIdFieldFromService",null),t.__decorate([s.property({readOnly:!0})],p.prototype,"hasFullEditingRestrictions",null),t.__decorate([s.property({type:Boolean,json:{origins:{service:{read:!0}}}})],p.prototype,"hasM",void 0),t.__decorate([s.property({readOnly:!0})],p.prototype,"hasUpdateItemRestrictions",null),t.__decorate([s.property({type:Boolean,json:{origins:{service:{read:!0}}}})],p.prototype,"hasZ",void 0),t.__decorate([s.property({readOnly:!0,type:u})],p.prototype,"heightModelInfo",void 0),t.__decorate([s.property({type:Date})],p.prototype,"historicMoment",void 0),t.__decorate([s.property({type:r.ofType(g.FeatureIndex),readOnly:!0})],p.prototype,"indexes",void 0),t.__decorate([s.property({readOnly:!0})],p.prototype,"isTable",void 0),t.__decorate([n.reader("service","isTable",["type"])],p.prototype,"readIsTableFromService",null),t.__decorate([s.property({type:Number,json:{origins:{service:{read:{source:"id"}},"portal-item":{read:!1,write:{target:"id"}}},read:!1}})],p.prototype,"layerId",void 0),t.__decorate([s.property(_.maxScale)],p.prototype,"maxScale",void 0),t.__decorate([n.reader("service","maxScale",["maxScale","effectiveMaxScale"])],p.prototype,"readMaxScale",null),t.__decorate([s.property(_.minScale)],p.prototype,"minScale",void 0),t.__decorate([n.reader("service","minScale",["minScale","effectiveMinScale"])],p.prototype,"readMinScale",null),t.__decorate([s.property({type:String})],p.prototype,"objectIdField",void 0),t.__decorate([n.reader("service","objectIdField",["objectIdField","fields"])],p.prototype,"readObjectIdFieldFromService",null),t.__decorate([s.property(x.timeZoneProperty("preferredTimeReference"))],p.prototype,"preferredTimeZone",void 0),t.__decorate([s.property({type:[F],readOnly:!0})],p.prototype,"relationships",void 0),t.__decorate([s.property({type:Boolean})],p.prototype,"returnM",void 0),t.__decorate([s.property({type:Boolean})],p.prototype,"returnZ",void 0),t.__decorate([s.property({readOnly:!0,json:{write:!1}})],p.prototype,"serverGens",void 0),t.__decorate([s.property({readOnly:!0})],p.prototype,"serviceDefinitionExpression",void 0),t.__decorate([n.reader("service","serviceDefinitionExpression",["definitionQuery","definitionExpression"])],p.prototype,"readServiceDefinitionExpression",null),t.__decorate([s.property({type:String,readOnly:!0,json:{read:!1,origins:{service:{read:!0}}}})],p.prototype,"serviceItemId",void 0),t.__decorate([s.property()],p.prototype,"sourceJSON",void 0),t.__decorate([s.property({type:y,json:{origins:{service:{read:{source:"extent.spatialReference"}}}}})],p.prototype,"spatialReference",void 0),t.__decorate([s.property({type:String,readOnly:!0,json:{origins:{service:{read:!0}}}})],p.prototype,"subtypeField",void 0),t.__decorate([s.property({type:[S],readOnly:!0,json:{read:!1,origins:{service:{read:!0}}}})],p.prototype,"subtypes",void 0),t.__decorate([s.property({type:String,json:{read:{source:"timeInfo.trackIdField"}}})],p.prototype,"trackIdField",void 0),t.__decorate([s.property(_.url)],p.prototype,"url",null),t.__decorate([d.writer("url")],p.prototype,"writeUrl",null),t.__decorate([s.property({json:{origins:{service:{read:!0}},read:!1}})],p.prototype,"version",void 0),t.__decorate([n.reader("service","version",["currentVersion","capabilities","drawingInfo","hasAttachments","htmlPopupType","relationships","timeInfo","typeIdField","types"])],p.prototype,"readVersion",null),p=t.__decorate([a.subclass("esri.layers.mixins.FeatureLayerBase")],p),p};e.FeatureLayerBase=E,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
