/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","exports","../../chunks/tslib.es6","../../config","../../kernel","../../request","../../core/asyncUtils","../../core/Error","../../core/Logger","../../core/maybe","../../core/promiseUtils","../../core/urlUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/RandomLCG","../../core/accessorSupport/decorators/reader","../../core/accessorSupport/decorators/subclass","../../core/accessorSupport/decorators/writer","../support/layerUtils","../../portal/Portal","../../portal/PortalItem","../../portal/PortalUser","../../portal/support/portalItemUtils"],(function(e,t,r,s,a,i,o,l,n,p,u,c,d,h,g,y,m,f,I,P,v,w,_){"use strict";const U=t=>{let h=class extends t{constructor(){super(...arguments),this.resourceReferences={portalItem:null,paths:[]},this.userHasEditingPrivileges=!0,this.userHasFullEditingPrivileges=!1,this.userHasUpdateItemPrivileges=!1}destroy(){this.portalItem=p.destroyMaybe(this.portalItem),this.resourceReferences.portalItem=null,this.resourceReferences.paths.length=0}set portalItem(e){e!==this._get("portalItem")&&(this.removeOrigin("portal-item"),this._set("portalItem",e))}readPortalItem(e,t,r){if(t.itemId)return new v({id:t.itemId,portal:r?.portal})}writePortalItem(e,t){e?.id&&(t.itemId=e.id)}async loadFromPortal(t,r){if(this.portalItem?.id)try{const{load:s}=await new Promise(((t,r)=>e(["../../portal/support/layersLoader"],t,r)));return u.throwIfAborted(r),await s({instance:this,supportedTypes:t.supportedTypes,validateItem:t.validateItem,supportsData:t.supportsData,layerModuleTypeMap:t.layerModuleTypeMap},r)}catch(s){throw u.isAbortError(s)||n.getLogger(this).warn(`Failed to load layer (${this.title}, ${this.id}) portal item (${this.portalItem.id})\n  ${s}`),s}}async finishLoadEditablePortalLayer(e){this._set("userHasEditingPrivileges",await this._fetchUserHasEditingPrivileges(e).catch((e=>(u.throwIfAbortError(e),!0))))}async setUserPrivileges(e,t){if(!s.userPrivilegesApplied)return this.finishLoadEditablePortalLayer(t);if(this.url)try{const{features:{edit:r,fullEdit:s},content:{updateItem:a}}=await this._fetchUserPrivileges(e,t);this._set("userHasEditingPrivileges",r),this._set("userHasFullEditingPrivileges",s),this._set("userHasUpdateItemPrivileges",a)}catch(r){u.throwIfAbortError(r)}}async _fetchUserPrivileges(e,t){let r=this.portalItem;if(!e||!r||!r.loaded||r.sourceUrl)return this._fetchFallbackUserPrivileges(t);const s=e===r.id;if(s&&r.portal.user)return _.getUserPrivileges(r);let i,o;if(s)i=r.portal.url;else try{i=await I.getOwningPortalUrl(this.url,t)}catch(d){u.throwIfAbortError(d)}if(!i||!c.hasSameCanonicalPortal(i,r.portal.url))return this._fetchFallbackUserPrivileges(t);try{const e=null!=t?t.signal:null;o=await(a.id?.getCredential(`${i}/sharing`,{prompt:!1,signal:e}))}catch(d){u.throwIfAbortError(d)}const l=!0,n=!1,p=!1;if(!o)return{features:{edit:l,fullEdit:n},content:{updateItem:p}};try{if(s?await r.reload():(r=new v({id:e,portal:{url:i}}),await r.load(t)),r.portal.user)return _.getUserPrivileges(r)}catch(d){u.throwIfAbortError(d)}return{features:{edit:l,fullEdit:n},content:{updateItem:p}}}async _fetchFallbackUserPrivileges(e){let t=!0;try{t=await this._fetchUserHasEditingPrivileges(e)}catch(r){u.throwIfAbortError(r)}return{features:{edit:t,fullEdit:!1},content:{updateItem:!1}}}async _fetchUserHasEditingPrivileges(e){const t=this.url?a.id?.findCredential(this.url):null;if(!t)return!0;const r=b.credential===t?b.user:await this._fetchEditingUser(e);return b.credential=t,b.user=r,null==r?.privileges||r.privileges.includes("features:user:edit")}async _fetchEditingUser(e){const t=this.portalItem?.portal?.user;if(t)return t;const r=a.id?.findServerInfo(this.url??"");if(!r?.owningSystemUrl)return null;const s=`${r.owningSystemUrl}/sharing/rest`,l=P.getDefault();if(l&&l.loaded&&c.normalize(l.restUrl)===c.normalize(s))return l.user;const n=`${s}/community/self`,p=null!=e?e.signal:null,u=await o.result(i(n,{authMode:"no-prompt",query:{f:"json"},signal:p}));return u.ok?w.fromJSON(u.value.data):null}read(e,t){t&&(t.layer=this),super.read(e,t)}write(e,t){const r=t?.portal,s=this.portalItem?.id&&(this.portalItem.portal||P.getDefault());return r&&s&&!c.hasSamePortal(s.restUrl,r.restUrl)?(t.messages&&t.messages.push(new l("layer:cross-portal",`The layer '${this.title} (${this.id})' cannot be persisted because it refers to an item on a different portal than the one being saved to. To save, set layer.portalItem to null or save to the same portal as the item associated with the layer`,{layer:this})),null):super.write(e,{...t,layer:this})}};return r.__decorate([d.property({type:v})],h.prototype,"portalItem",null),r.__decorate([y.reader("web-document","portalItem",["itemId"])],h.prototype,"readPortalItem",null),r.__decorate([f.writer("web-document","portalItem",{itemId:{type:String}})],h.prototype,"writePortalItem",null),r.__decorate([d.property({clonable:!1})],h.prototype,"resourceReferences",void 0),r.__decorate([d.property({type:Boolean,readOnly:!0})],h.prototype,"userHasEditingPrivileges",void 0),r.__decorate([d.property({type:Boolean,readOnly:!0})],h.prototype,"userHasFullEditingPrivileges",void 0),r.__decorate([d.property({type:Boolean,readOnly:!0})],h.prototype,"userHasUpdateItemPrivileges",void 0),h=r.__decorate([m.subclass("esri.layers.mixins.PortalLayer")],h),h},b={credential:null,user:null};t.PortalLayer=U,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
