/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../geometry","../../request","../../core/Error","../../core/Logger","../../core/urlUtils","../../geometry/support/spatialReferenceUtils","../../geometry/support/webMercatorUtils","../graphics/featureConversionUtils","../graphics/OptimizedFeatureSet","../graphics/sources/geojson/geojson","../graphics/sources/support/clientSideDefaults","../graphics/sources/support/sourceUtils","../support/FieldsIndex","../support/fieldType","../../time/timeZoneUtils","../../geometry/SpatialReference"],(function(e,t,n,i,r,a,o,s,l,c,u,d,f,m,p,g,y){"use strict";const w=()=>r.getLogger("esri.layers.ogc.ogcFeatureUtils"),b="startindex",h=new Set([b,"offset"]),F="http://www.opengis.net/def/crs/",j=`${F}OGC/1.3/CRS84`;var I;async function T(e,t,r={},o=5){const{links:s}=e,l=$(s,"items",I.geojson)||$(s,"http://www.opengis.net/def/rel/ogc/1.0/items",I.geojson);if(null==l)throw new i("ogc-feature-layer:missing-items-page","Missing items url");const{apiKey:c,customParameters:f,signal:y}=r,h=a.makeAbsolute(l.href,e.landingPage.url),F={limit:o,...f,token:c},j=a.addQueryParameters(h,F),T={accept:I.geojson},{data:k}=await n(j,{signal:y,headers:T}),S=M(j,o,k.links)??b;u.validateGeoJSON(k);const x=u.inferLayerProperties(k,{geometryType:t.geometryType}),v=t.fields||x.fields||[],O=null!=t.hasZ?t.hasZ:x.hasZ,P=x.geometryType,N=t.objectIdField||x.objectIdFieldName||"OBJECTID";let q=t.timeInfo;const C=v.find((({name:e})=>e===N));if(C)C.editable=!1,C.nullable=!1;else{if(!x.objectIdFieldType)throw new i("ogc-feature-layer:missing-feature-id","Collection geojson require a feature id as a unique identifier");v.unshift({name:N,alias:N,type:"number"===x.objectIdFieldType?"esriFieldTypeOID":"esriFieldTypeString",editable:!1,nullable:!1})}if(N!==x.objectIdFieldName){const e=v.find((({name:e})=>e===x.objectIdFieldName));e&&(e.type="esriFieldTypeInteger")}v===x.fields&&x.unknownFields.length>0&&w().warn({name:"ogc-feature-layer:unknown-field-types",message:"Some fields types couldn't be inferred from the features and were dropped",details:{unknownFields:x.unknownFields}});for(const n of v){if(null==n.name&&(n.name=n.alias),null==n.alias&&(n.alias=n.name),"esriFieldTypeOID"!==n.type&&"esriFieldTypeGlobalID"!==n.type&&(n.editable=null==n.editable||!!n.editable,n.nullable=null==n.nullable||!!n.nullable),!n.name)throw new i("ogc-feature-layer:invalid-field-name","field name is missing",{field:n});if(!p.kebabDict.jsonValues.includes(n.type))throw new i("ogc-feature-layer:invalid-field-type",`invalid type for field "${n.name}"`,{field:n})}if(q){const e=new m(v);if(q.startTimeField){const t=e.get(q.startTimeField);t?(q.startTimeField=t.name,t.type="esriFieldTypeDate"):q.startTimeField=null}if(q.endTimeField){const t=e.get(q.endTimeField);t?(q.endTimeField=t.name,t.type="esriFieldTypeDate"):q.endTimeField=null}if(q.trackIdField){const t=e.get(q.trackIdField);t?q.trackIdField=t.name:(q.trackIdField=null,w().warn({name:"ogc-feature-layer:invalid-timeInfo-trackIdField",message:"trackIdField is missing",details:{timeInfo:q}}))}q.timeReference||={timeZoneIANA:g.utc},q.startTimeField||q.endTimeField||(w().warn({name:"ogc-feature-layer:invalid-timeInfo",message:"startTimeField and endTimeField are missing",details:{timeInfo:q}}),q=void 0)}return{drawingInfo:P?d.createDrawingInfo(P):null,extent:W(e),geometryType:P,fields:v,hasZ:!!O,objectIdField:N,paginationParameter:S,timeInfo:q}}async function k(e,t={}){const{links:r,url:o}=e,s=$(r,"data",I.json)||$(r,"http://www.opengis.net/def/rel/ogc/1.0/data",I.json);if(null==s)throw new i("ogc-feature-layer:missing-collections-page","Missing collections url");const{apiKey:l,customParameters:c,signal:u}=t,d=a.makeAbsolute(s.href,o),{data:f}=await n(d,{signal:u,headers:{accept:I.json},query:{...c,token:l}});for(const n of f.collections)n.landingPage=e;return f}async function S(e,t={}){const{links:r,url:o}=e,s=$(r,"conformance",I.json)||$(r,"http://www.opengis.net/def/rel/ogc/1.0/conformance",I.json);if(null==s)throw new i("ogc-feature-layer:missing-conformance-page","Missing conformance url");const{apiKey:l,customParameters:c,signal:u}=t,d=a.makeAbsolute(s.href,o),{data:f}=await n(d,{signal:u,headers:{accept:I.json},query:{...c,token:l}});return f}async function x(e,t={}){const{apiKey:i,customParameters:r,signal:a}=t,{data:o}=await n(e,{signal:a,headers:{accept:I.json},query:{...r,token:i}});return o.url=e,o}async function v(e,t={}){const{links:i,url:r}=e,o=$(i,"service-desc",I.openapi);if(null==o)return w().warn("ogc-feature-layer:missing-openapi-page","The OGC API-Features server does not have an OpenAPI page."),null;const{apiKey:s,customParameters:l,signal:c}=t,u=a.makeAbsolute(o.href,r),{data:d}=await n(u,{signal:c,headers:{accept:I.openapi},query:{...l,token:s}});return d}function O(e){const t=/^http:\/\/www\.opengis.net\/def\/crs\/(?<authority>.*)\/(?<version>.*)\/(?<code>.*)$/i.exec(e),n=t?.groups;if(!n)return null;const{authority:i,code:r}=n;switch(i.toLowerCase()){case"ogc":switch(r.toLowerCase()){case"crs27":return y.GCS_NAD_1927.wkid;case"crs83":return 4269;case"crs84":case"crs84h":return y.WGS84.wkid;default:return null}case"esri":case"epsg":{const e=Number.parseInt(r,10);return Number.isNaN(e)?null:e}default:return null}}async function P(e,t,n){const i=await N(e,t,n);return l.convertToFeatureSet(i)}async function N(e,t,r){const{collection:{links:d,landingPage:{url:p}},layerDefinition:g,maxRecordCount:w,queryParameters:{apiKey:b,customParameters:h},spatialReference:F,supportedCrs:j}=e,T=$(d,"items",I.geojson)||$(d,"http://www.opengis.net/def/rel/ogc/1.0/items",I.geojson);if(null==T)throw new i("ogc-feature-layer:missing-items-page","Missing items url");const{geometry:k,num:S,start:x,timeExtent:v,where:O}=t;if(t.objectIds)throw new i("ogc-feature-layer:query-by-objectids-not-supported","Queries with object ids are not supported");const P=y.fromJSON(F),N=t.outSpatialReference??P,q=N.isWGS84?null:C(N,j),D=R(k,j),W=G(v),M=A(O),Z=S??(null==x?w:10),L=0===x?void 0:x,{fields:U,geometryType:J,hasZ:K,objectIdField:z,paginationParameter:E}=g,Q=a.makeAbsolute(T.href,p),{data:_}=await n(Q,{...r,query:{...h,...D,crs:q,datetime:W,query:M,limit:Z,[E]:L,token:b},headers:{accept:I.geojson}}),B=u.createOptimizedFeatures(_,{geometryType:J,hasZ:K,objectIdField:z}),V=B.length===Z&&!!$(_.links??[],"next",I.geojson),H=new m(U);for(const n of B){const e={};f.mixAttributes(H,e,n.attributes,!0);for(const t of H.fields)t.nullable&&!(t.name in e)&&(e[t.name]=null);e[z]=n.attributes[z],n.attributes=e}if(!q&&N.isWebMercator)for(const n of B)if(null!=n.geometry&&null!=J){const e=l.convertToGeometry(n.geometry,J,K,!1);e.spatialReference=y.WGS84,n.geometry=l.convertFromGeometry(s.project(e,N))}for(const n of B)n.objectId=n.attributes[z];const X=q||!q&&N.isWebMercator?N.toJSON():o.wgs84,Y=new c;return Y.exceededTransferLimit=V,Y.features=B,Y.fields=U,Y.geometryType=J,Y.hasZ=K,Y.objectIdFieldName=z,Y.spatialReference=X,Y}function q(e){return null!=e&&"extent"===e.type}function C(e,t){const{isWebMercator:n,wkid:i}=e;if(!i)return null;const r=n?t[3857]??t[102100]??t[102113]??t[900913]:t[e.wkid];return r?`${F}${r}`:null}function D(e){if(null==e)return"";const{xmin:t,ymin:n,xmax:i,ymax:r}=e;return`${t},${n},${i},${r}`}function G(e){if(null==e)return null;const{start:t,end:n}=e;return`${null!=t?t.toISOString():".."}/${null!=n?n.toISOString():".."}`}function A(e){return null!=e&&e&&"1=1"!==e?e:null}function R(e,t){if(!q(e))return null;const{spatialReference:n}=e;if(!n||n.isWGS84)return{bbox:D(e)};const i=C(n,t);return null!=i?{bbox:D(e),"bbox-crs":i}:n.isWebMercator?{bbox:D(s.project(e,y.WGS84))}:null}function W(e){const t=e.extent?.spatial;if(!t)return null;const n=t.bbox[0],i=4===n.length,[r,a]=n,o=i?void 0:n[2];return{xmin:r,ymin:a,xmax:i?n[2]:n[3],ymax:i?n[3]:n[4],zmin:o,zmax:i?void 0:n[5],spatialReference:y.WGS84.toJSON()}}function $(e,t,n){return e.find((({rel:e,type:i})=>e===t&&i===n))??e.find((({rel:e,type:n})=>e===t&&!n))}function M(e,t,n){if(!n)return;const i=$(n,"next",I.geojson),r=a.urlToObject(i?.href)?.query;if(!r)return;const o=a.urlToObject(e).query,s=Object.keys(o??{}),l=Object.entries(r).filter((([e])=>!s.includes(e))).find((([e,n])=>h.has(e.toLowerCase())&&Number.parseInt(n,10)===t)),c=l?.[0];return c}!function(e){e.json="application/json",e.geojson="application/geo+json",e.openapi="application/vnd.oai.openapi+json;version=3.0"}(I||(I={})),e.crsDefault=j,e.crsPrefix=F,e.getCollectionDefinition=T,e.getServerCollections=k,e.getServerConformance=S,e.getServerLandingPage=x,e.getServerOpenApi=v,e.getSpatialReferenceWkid=O,e.queryFeatureSetJSON=P,e.queryOptimizedFeatureSet=N,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
