/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../geometry","../../../core/Clonable","../../../core/Error","../../../core/JSONSupport","../../../core/Logger","../../../core/accessorSupport/decorators/property","../../../core/accessorSupport/decorators/cast","../../../core/accessorSupport/decorators/enumeration","../../../core/accessorSupport/decorators/reader","../../../core/accessorSupport/decorators/subclass","../../../core/accessorSupport/decorators/writer","../../../geometry/support/zscale","./CameraOrientation","./cameraOrientationFactory","./utils","../enums/CameraOrientationType","../transformations/utils","../../../geometry/Point"],(function(e,r,t,o,a,i,n,p,c,s,d,l,y,u,m,_,g,f,h){"use strict";function v(e){throw new o("exposure-point:missing-default-value",`a value for ${e} is missing in default properties`)}function w(e,r){throw new o("exposure-point:missing-attribute-value",`a value for ${e} is missing in attribute table`,{exposurePoint:r})}const b=e=>({cast:e=>{const r=parseFloat(e);return Number.isFinite(r)?r:void 0},json:{name:e,write:{writer:(e,r,t)=>{r[t]=Number.isFinite(e)?e:void 0}}}}),O=e=>({cast:e=>"string"==typeof e?e.split(";").map(Number):e,json:{default:e,write:{writer:(e,r,t)=>{r[t]=e?.join(";")}}}});let S=class extends(t.ClonableMixin(a.JSONSupport)){constructor(e){super(e),this.cameraOrientation=null,this.elevation=null,this.elevationSource=null,this.name=null,this.sourceMap=null}read(e,r){const t={},{attributes:o,layer:a,geometry:i}=e,n={};for(const p in o)t[p.toLowerCase()]=o[p],n[p.toLowerCase()]=p;super.read({geometry:i,layer:a??{},sourceMap:n,...t},r)}write(e,r){const t=super.write(e,r),{sourceMap:o}=this;if(!o||!t)return t;const a={};for(const i in t){const e=o[i.toLowerCase()];e&&(a[e]=t[i])}return a}readCameraHeading(e,r){const{cameraheading:t,camheading:o,layer:a}=r;return t??o??a.cameraHeading}readCameraHeight(e,r){const{cameraheight:t,avghtag:o,layer:a}=r;return t??o??a.cameraHeight}readCamOffset(e,r){const{cameraoffset:t,camoffset:o}=r;return t?.split(";").map(Number)??o?.split(";").map(Number)??null}writeCameraOffset(e,r){e&&(r.cameraOffset=e.join(";"))}readCameraOrientation(e,r){const{cameraorientation:t,camori:o}=r;return t??o}readCameraPitch(e,r){const{camerapitch:t,campitch:o,layer:a}=r;return t??o??a.cameraPitch}readCameraRoll(e,r){const{cameraroll:t,camroll:o,layer:a}=r;return t??o??a.cameraRoll}readDepthImage(e,r){const{depthimage:t,depthimg:o,layer:a}=r,i=t??o??null,{depthImagePathPrefix:n,depthImagePathSuffix:p}=a??{};return _.appendPrefixAndSuffix(i,n,p)}readElevationSource(e,r){const{elevationsource:t,layer:o}=r,{demPathSuffix:a,demPathPrefix:i}=o;if(t){const e=this._parseIfJSON(t);return _.getEffectiveElevationSource(e,i,a)}return o.effectiveElevationSource}readFarDistance(e,r){const{fardistance:t,fardist:o,layer:a}=r;return t??o??a.farDistance}readHFOV(e,r){const{horizontalfieldofview:t,hfov:o,layer:a}=r;return t??o??a.horizontalFieldOfView}readImageURL(e,r){const{imagepath:t,layer:o}=r;t||w("imagePath",this);const{imagePathPrefix:a,imagePathSuffix:i}=o;return _.appendPrefixAndSuffix(t,a,i)}readImageRotation(e,r){const{imagerotation:t,imgrot:o,layer:a}=r;return t??o??a.imageRotation}get isHorizontal(){return"horizontal"===this.orientedImageryType}get isInspection(){return"inspection"===this.orientedImageryType}get isNadir(){return"nadir"===this.orientedImageryType}get isOblique(){return"oblique"===this.orientedImageryType}get isSpherical(){return"360"===this.orientedImageryType}get location(){const{cameraOrientation:e,cameraHeight:r,elevation:t}=this;if(e){const{type:r,x:t,y:o,z:a,horizontalWKID:i,verticalWKID:n}=e,p="number"==typeof i?{wkid:i}:{wkt:i};if(r===g.CameraOrientationType.LTP){const{latitude:r,longitude:t,ellipsoidRadius:o,squaredEccentricity:a,properties:i}=e,{x:n,y:p,z:c}=i;return new h(f.ltpToGeographic([n,p,c],[r,t,o,a]))}const c=new h({x:t,y:o,z:a,spatialReference:p}),s=n?y.getGeometryZScaler("point",{wkid:n},p):null;return s&&s(c),c}if("number"!=typeof r)throw v("cameraHeight");const o=this.geometry.clone();return o.z=o.hasZ?o.z:(t??0)+r,o}set matrix(e){if(!e||9!==e.length)return i.getLogger(this).warn("Ignoring rotation matrix because it doesn't have 9 values",{value:e}),void this._set("matrix",null);this._set("matrix",e)}readNearDistance(e,r){const{neardistance:t,neardist:o,layer:a}=r;return t??o??a.nearDistance}readOrientationAccuracy(e,r){const{accuracy:t,orientationaccuracy:o}=r;return o?.split(";").map(Number)??t?.split(";").map(Number)??null}writeOrientationAccuracy(e,r){e&&(r.orientationAccuracy=e.join(";"))}readOIType(e,r){const{orientedimagerytype:t,oitype:o,camerapitch:a,campitch:i,layer:n}=r,p=_.orientedImageryTypeMap.read(t??o??n.orientedImageryType),c=a??i??n.cameraPitch;return"oblique"===p?c<10?"nadir":"oblique":p}set radial(e){if(e)if("string"!=typeof e)this._set("radial",e);else{const[r,t,o]=e.split(";").map(Number);this._set("radial",[r??0,t??0,o??0])}else this._set("radial",[0,0,0])}set tangential(e){if(e)if("string"!=typeof e)this._set("tangential",e);else{const[r,t]=e.split(";").map(Number);this._set("tangential",[r??0,t??0])}else this._set("tangential",[0,0])}readVFOV(e,r){const{verticalfieldofview:t,vfov:o,layer:a}=r;return t??o??a.verticalFieldOfView}_parseIfJSON(e){let r=null;try{r=JSON.parse(e)}catch(t){i.getLogger(this).error("couldn't parse the given elevation source JSON",e,t)}return r}};e.__decorate([n.property(b())],S.prototype,"a0",void 0),e.__decorate([n.property(b())],S.prototype,"a1",void 0),e.__decorate([n.property(b())],S.prototype,"a2",void 0),e.__decorate([n.property({type:Date,json:{write:{enabled:!0,target:"acquisitionDate"},name:"acquisitiondate"}})],S.prototype,"acquisitionDate",void 0),e.__decorate([n.property(b())],S.prototype,"b0",void 0),e.__decorate([n.property(b())],S.prototype,"b1",void 0),e.__decorate([n.property(b())],S.prototype,"b2",void 0),e.__decorate([n.property({type:Number,json:{write:!0,read:{source:["cameraheading","camheading","layer.cameraHeading"]}}})],S.prototype,"cameraHeading",void 0),e.__decorate([s.reader("cameraHeading")],S.prototype,"readCameraHeading",null),e.__decorate([n.property({type:Number,json:{write:!0}})],S.prototype,"cameraHeight",void 0),e.__decorate([s.reader("cameraHeight",["cameraheight","avghtag","layer.cameraHeight"])],S.prototype,"readCameraHeight",null),e.__decorate([n.property()],S.prototype,"cameraOffset",void 0),e.__decorate([s.reader("cameraOffset",["cameraoffset","camoffset"])],S.prototype,"readCamOffset",null),e.__decorate([l.writer("cameraOffset")],S.prototype,"writeCameraOffset",null),e.__decorate([n.property({json:{write:{writer:(e,r,t)=>{r[t]=e.toString()}}},type:u}),p.cast((e=>e?m.getCameraOrientation(e):null))],S.prototype,"cameraOrientation",void 0),e.__decorate([s.reader("cameraOrientation",["cameraorientation","camori"])],S.prototype,"readCameraOrientation",null),e.__decorate([n.property({type:Number,json:{write:!0}})],S.prototype,"cameraPitch",void 0),e.__decorate([s.reader("cameraPitch",["camerapitch","campitch","layer.cameraPitch"])],S.prototype,"readCameraPitch",null),e.__decorate([n.property({type:Number,json:{write:!0}})],S.prototype,"cameraRoll",void 0),e.__decorate([s.reader("cameraRoll",["cameraroll","camroll","layer.cameraRoll"])],S.prototype,"readCameraRoll",null),e.__decorate([n.property({json:{write:!0},type:String})],S.prototype,"depthImage",void 0),e.__decorate([s.reader("depthImage",["depthimage","depthimg"])],S.prototype,"readDepthImage",null),e.__decorate([n.property({type:Number,json:{write:!0}})],S.prototype,"elevation",void 0),e.__decorate([n.property({json:{write:!0},clonable:"reference"})],S.prototype,"elevationSource",void 0),e.__decorate([s.reader("elevationSource",["elevationsource","layer.effectiveElevationSource"])],S.prototype,"readElevationSource",null),e.__decorate([n.property({json:{name:"exposurestationid",write:{target:"exposureStationId"}},type:String})],S.prototype,"exposureStationId",void 0),e.__decorate([n.property({type:Number,json:{write:!0}})],S.prototype,"farDistance",void 0),e.__decorate([s.reader("farDistance",["fardistance","fardist","layer.farDistance"])],S.prototype,"readFarDistance",null),e.__decorate([n.property(b("focallength"))],S.prototype,"focalLength",void 0),e.__decorate([n.property({type:h,json:{name:"geometry"}})],S.prototype,"geometry",void 0),e.__decorate([n.property({type:Number,json:{write:!0}})],S.prototype,"horizontalFieldOfView",void 0),e.__decorate([s.reader("horizontalFieldOfView",["horizontalfieldofview","hfov","layer.horizontalFieldOfView"])],S.prototype,"readHFOV",null),e.__decorate([n.property({json:{write:!0},type:String})],S.prototype,"imagePath",void 0),e.__decorate([s.reader("imagePath",["imagepath"])],S.prototype,"readImageURL",null),e.__decorate([n.property({type:Number,json:{write:!0}})],S.prototype,"imageRotation",void 0),e.__decorate([s.reader("imageRotation",["imagerotation","imgrot","layer.imageRotation"])],S.prototype,"readImageRotation",null),e.__decorate([n.property()],S.prototype,"isHorizontal",null),e.__decorate([n.property()],S.prototype,"isInspection",null),e.__decorate([n.property()],S.prototype,"isNadir",null),e.__decorate([n.property()],S.prototype,"isOblique",null),e.__decorate([n.property()],S.prototype,"isSpherical",null),e.__decorate([n.property()],S.prototype,"location",null),e.__decorate([n.property(O())],S.prototype,"matrix",null),e.__decorate([n.property({json:{write:!0},type:String})],S.prototype,"name",void 0),e.__decorate([n.property({type:Number,json:{write:!0}})],S.prototype,"nearDistance",void 0),e.__decorate([s.reader("nearDistance",["neardistance","neardist","layer.nearDistance"])],S.prototype,"readNearDistance",null),e.__decorate([n.property({json:{write:!0,name:"objectid"},type:Number})],S.prototype,"objectId",void 0),e.__decorate([n.property()],S.prototype,"orientationAccuracy",void 0),e.__decorate([s.reader("orientationAccuracy",["accuracy","orientationaccuracy"])],S.prototype,"readOrientationAccuracy",null),e.__decorate([l.writer("orientationAccuracy")],S.prototype,"writeOrientationAccuracy",null),e.__decorate([c.enumeration(_.orientedImageryTypeMap)],S.prototype,"orientedImageryType",void 0),e.__decorate([s.reader("orientedImageryType",["orientedimagerytype","oitype","layer.orientedImageryType"])],S.prototype,"readOIType",null),e.__decorate([n.property({type:Number,json:{write:!0}})],S.prototype,"principalX",void 0),e.__decorate([n.property({type:Number,json:{write:!0}})],S.prototype,"principalY",void 0),e.__decorate([n.property(O([0,0,0]))],S.prototype,"radial",null),e.__decorate([n.property({type:Number,json:{name:"sortorder",write:{target:"sortOrder"}}})],S.prototype,"sortOrder",void 0),e.__decorate([n.property({type:Object})],S.prototype,"sourceMap",void 0),e.__decorate([n.property(O([0,0]))],S.prototype,"tangential",null),e.__decorate([n.property({type:Number,json:{write:!0}})],S.prototype,"verticalFieldOfView",void 0),e.__decorate([s.reader("verticalFieldOfView",["verticalfieldofview","vfov","layer.verticalFieldOfView"])],S.prototype,"readVFOV",null),S=e.__decorate([d.subclass("esri.layers.orientedImagery.core.ExposurePoint")],S);return S}));
