/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../core/Error","../../../core/Logger","../../../core/promiseUtils","../../../geometry/projection","../../../geometry/support/aaBoundingRect","../../ElevationLayer","../../ImageryLayer","../../ImageryTileLayer","../../support/ElevationSampler","../../support/ElevationTile","../../support/ElevationTileData","../../support/RasterFunction","../../support/TileInfo","../../support/TileKey","../../../rest/imageService","../../../rest/support/ImageIdentifyParameters","../../../support/requestPresets","../../../widgets/OrientedImageryViewer/utils"],(function(e,t,r,a,n,i,o,s,l,c,u,p,f,w,v,y,g,m,d){"use strict";async function E(e,r,a){if(!r.extent||!r.url)throw d.logAndThrow("esri.layer.orientedImagery.transformations",new t("update-elevation:missing-property","both extent and url are required to create a sampler",r));const n=await A(r);if(!n)throw d.logAndThrow("esri.layers.orientedImagery.transformations",new t("update-elevation:elevation-source","could not create a sampler using provided elevation source",r));return I(e,n,a)}async function I(e,t,r){await a.waitTick(r);const n=R(t,r),i=Array.isArray(e)?e:[e];return await Promise.all(i.map(n))}var h;!function(e){e[e.DYNAMIC=0]="DYNAMIC",e[e.ELEVATION=1]="ELEVATION",e[e.IMAGE=2]="IMAGE"}(h||(h={}));const A=async(e,t)=>{let n;const{extent:i,rasterFunction:o,url:s,lod:l}=e;try{n=await L(s)}catch(c){if(a.isAbortError(c))return;r.getLogger("esri.layers.orientedImagery.transformations").error("updateElevationUsingElevationSource",c)}switch(n){case h.DYNAMIC:return await S(s,i,o,t);case h.ELEVATION:return await T(s,i,l,t);default:return}};async function T(e,t,n,i){const s=new o(e);let l;try{const{tileInfo:e}=await s.load(),r=(n&&e.lodAt(Math.min(e.lods.length-1,n))?.resolution)??"finest-contiguous";l=await s.createElevationSampler(t,{...i,demResolution:r})}catch(c){if(a.isAbortError(c))return;r.getLogger(s).error(c)}finally{s.destroy()}return l}async function S(e,t,r,a){const n=r?new f({functionName:r}):void 0,o=new s({url:e,rasterFunction:n,format:"lerc"});await o.load(a);let l,y=512,g=512;const m=t.width/t.height;m>1?(g/=m,l=t.height/g):(y*=m,l=t.width/y);const d=await o.fetchImage(t,y,g,a),E=w.create({scales:[l],size:512,spatialReference:t.spatialReference}),I=new v.TileKey(null,0,0,0,i.fromExtent(t)),h=new p.ElevationTileData(d.pixelData.pixelBlock.pixels[0],y,g,0),A=new u.ElevationTile(I,h);return new c.TileElevationSampler(A,E,void 0)}async function L(e,r){await a.waitTick(r);const n=await m.fetchArcGISServiceJSON(e),{tileInfo:i,cacheType:o}=n;if(!n.hasOwnProperty("bandCount")||!n.hasOwnProperty("pixelSizeX"))throw new t("elevation-source:invalid-service-url",`ElevationSource URL expects an elevation 3D image service but given ${e}`);return i?"LERC"!==i?.format?.toUpperCase()||o&&"elevation"!==o.toLowerCase()?h.IMAGE:h.ELEVATION:h.DYNAMIC}function R(e,t){return async r=>{let a=r.clone();const i=r.spatialReference.equals(e.spatialReference)?a:await n.projectWithZConversion(r,e.spatialReference,t),o=e.queryElevation(i);if(o){a=r.spatialReference.equals(e.spatialReference)?o.clone():await n.projectWithZConversion(o,r.spatialReference,t)}return a.z=a.z??1,a}}async function N(e,t,r){return await a.waitTick(r),e.map((e=>(e.z=t,e)))}async function C(e,t,n){const{url:i,rasterFunction:o}=t;let s;try{s=await L(i,n)}catch(c){a.isAbortError(c)||r.getLogger("esri.layers.orientedImagery.transformations").error(c)}switch(s){case h.ELEVATION:case h.DYNAMIC:{const t=await y.identify(i,new g({geometry:e,rasterFunction:o?new f({functionName:o}):void 0}));if(t.value?.[0]){const r=e.clone();return r.z=+t.value[0],r}break}case h.IMAGE:{const t=new l(i,n);await t.load();const r=await t.identify(e,n);if(r.value?.[0]){const t=e.clone();return t.z=+r.value[0],t}break}}return e}e.getElevationSampler=A,e.getElevationSamplerFromDynamicImageService=S,e.getElevationSamplerFromElevationLayer=T,e.updateUsingConstant=N,e.updateUsingElevationSampler=I,e.updateUsingElevationSource=E,e.updateZfromService=C,e.validateElevationSourceURL=L,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
