/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../geometry","../../../chunks/languageUtils","../../../core/Error","../../../core/JSONSupport","../../../core/mathUtils","../../../core/promiseUtils","../../../core/libs/gl-matrix-2/factories/mat3f64","../../../core/libs/gl-matrix-2/factories/mat4f64","../../../core/libs/gl-matrix-2/factories/vec4f64","../../../core/libs/gl-matrix-2/factories/vec3f64","../../../core/libs/gl-matrix-2/math/mat3","../../../core/libs/gl-matrix-2/math/mat4","../../../chunks/vec32","../../../geometry/projection","../../../geometry/support/Ellipsoid","../../../geometry/support/spatialReferenceUtils","../../../chunks/vec3","../core/ElevationSourceDefinitions","./updateElevationUtils","../../../widgets/PanoramicViewer/constants","../../../geometry/SpatialReference","../../../geometry/Point"],(function(t,e,a,n,i,o,r,c,s,l,h,u,f,d,m,g,p,v,M,x,y,w,P){"use strict";function O(t,e,a){const[n,i,o,r]=e,[c,l,h,u]=a;S(n,i,o,r);const d=S(c,l,h,u),m=E(n,i,o,r),g=E(c,l,h,u),p=f.invertOrIdentity(s.create(),m),v=f.mul(s.create(),p,g),[M,x,y,w]=z(t,v);return[M/w,x/w,d?0:y/w]}function S(t,e,a,n){return 0===t[2]&&0===e[2]&&0===a[2]&&0===n[2]&&(t[2]=e[2]=a[2]=n[2]=1,!0)}function b(t){return 0===t?1:t}function z(t,e){const[a,n,i]=t,o=[0,0,0,0];return o[0]=a*e[0]+n*e[1]+i*e[2]+e[3],o[1]=a*e[4]+n*e[5]+i*e[6]+e[7],o[2]=a*e[8]+n*e[9]+i*e[10]+e[11],o[3]=b(a*e[12]+n*e[13]+i*e[14]+e[15]),o}function E(t,e,a,n){const i=C(l.fromArray([...n,1]),f.invertOrIdentity(new Array(16),s.fromValues(t[0],e[0],a[0],0,t[1],e[1],a[1],0,t[2],e[2],a[2],0,1,1,1,1))),o=i[0],r=i[1],c=i[2],h=s.create();return h[0]=o*t[0],h[1]=r*e[0],h[2]=c*a[0],h[3]=0,h[4]=o*t[1],h[5]=r*e[1],h[6]=c*a[1],h[7]=0,h[8]=o*t[2],h[9]=r*e[2],h[10]=c*a[2],h[11]=0,h[12]=o,h[13]=r,h[14]=c,h[15]=1,h}function F(t,e,a,n,i=h.zeros()){return i[0]=t[0]+e[0]*a,i[1]=t[1]+e[1]*a,i[2]=t[2]+e[2]*(a/n),i}function T(t,e,a){const n=h.zeros();return n[0]=t[0]*e,n[1]=t[1]*e,n[2]=t[2]*(e/a),n}function V(t,e){const[a,n,i]=t,o=h.zeros();return o[0]=a*e[0]+n*e[3]+i*e[6],o[1]=a*e[1]+n*e[4]+i*e[7],o[2]=a*e[2]+n*e[5]+i*e[8],o}function C(t,e){const[a,n,i,o]=t,r=new Array(4);return r[0]=a*e[0]+n*e[1]+i*e[2]+o*e[3],r[1]=a*e[4]+n*e[5]+i*e[6]+o*e[7],r[2]=a*e[8]+n*e[9]+i*e[10]+o*e[11],r[3]=a*e[12]+n*e[13]+i*e[14]+o*e[15],r}function R(t,e,a,i=!0){if(!Number.isFinite(t))throw new n("InvalidRotationAngle","Please specify a valid angle for rotation");const r=a*(i?o.deg2rad(t):t),s=Math.cos(r),l=Math.sin(r),h=c.create();switch(e){case 0:h[4]=s,h[5]=-l,h[7]=l,h[8]=s;break;case 1:h[0]=s,h[2]=l,h[6]=-l,h[8]=s;break;case 2:h[0]=s,h[1]=-l,h[3]=l,h[4]=s;break;default:throw new n("InvalidRotationAxis","Please specify either 0, 1 or 2 for X, Y or Z axis respectively")}return h}const I={HPR:[[2,-1],[0,1],[2,-1]],OPK:[[0,1],[1,1],[2,1]]};function L(t,e,a=!0){if(3!==t?.length||3!==e?.length)throw new n("InvalidRotationAngles","Please specify three angles with config for rotation");const i=c.create();for(let n=0;n<3;n++){const[o,r]=e[n],c=R(t[n],o,r,a);u.multiply(i,c,i)}return i}function A(t,e=!0){return L(t,I.OPK,e)}function W(t,e=!0){return L(t,I.HPR,e)}function H(t,e,a){const n=Math.sin(o.deg2rad(a)),i=Math.cos(o.deg2rad(a)),r=[[t,0],[t,e],[0,e]];r.forEach(((t,e)=>{r[e]=[i*t[0]-n*t[1],n*t[0]+i*t[1]]}));const c={xmin:Math.min(0,r[0][0],r[1][0],r[2][0]),xmax:Math.max(0,r[0][0],r[1][0],r[2][0]),ymin:Math.min(0,r[0][1],r[1][1],r[2][1]),ymax:Math.max(0,r[0][1],r[1][1],r[2][1])};return{hfov:Math.abs(c.xmax-c.xmin),vfov:Math.abs(c.ymax-c.ymin)}}function N(t,e,a,n,i,o){const r=a*(e.x-t.x)+n*(e.y-t.y)+i*(e.z-t.z);if(0===r)return null;const c=-(a*t.x+n*t.y+i*t.z+o)/r;return{x:t.x+c*(e.x-t.x),y:t.y+c*(e.y-t.y),z:t.z+c*(e.z-t.z)}}function U(t,e){const a=o.deg2rad(t[1]),n=o.deg2rad(t[0]),i=t[2],[r,c,s,l]=e,h=o.deg2rad(r),u=o.deg2rad(c),f=s/Math.sqrt(1-l*Math.sin(h)**2),d=n-u,m=s/Math.sqrt(1-l*Math.sin(h)**2),g=l*(f*Math.sin(h)-m*Math.sin(a));return[(m+i)*Math.cos(a)*Math.sin(d),(m+i)*(Math.sin(a)*Math.cos(h)-Math.sin(h)*Math.cos(h)*Math.cos(d))+g*Math.cos(h),(m+i)*(Math.sin(a)*Math.sin(h)+Math.cos(h)*Math.cos(a)*Math.cos(d))-f+g*Math.sin(h)]}function D(t,e){const a=Number(t[0]),n=Number(t[1]),i=Number(t[2]),[r,c,s,l]=e,h=o.deg2rad(r),u=o.deg2rad(c),f=s/Math.sqrt(1-l*Math.sin(h)**2),d=a/f,m=n/f,g=i/f,p=Math.cos(h)-Math.sin(h)*m+Math.cos(h)*g,v=Math.sin(h)+Math.cos(h)*m+Math.sin(h)*g,M=Math.sqrt(p**2+d**2),x=l*f*Math.sin(h),y=(t,e=5)=>{if(0===e)return t;const a=y(t,e-1);return Math.atan(v/M-(x-l*(s/Math.sqrt(1-l*Math.sin(a)**2))*Math.sin(a))/(f*M))},w=y(h),P=Math.atan(a/(f*p))+u,O=o.rad2deg(w);return[o.rad2deg(P),O,a/(Math.cos(w)*Math.sin(P-u))-s/Math.sqrt(1-l*Math.sin(w)**2)]}function q(t,e,a){const n=360/e,i=180/a;return{heading:(t.x-e/2)*n,pitch:90-(t.y-a/2)*i}}function K(t,e,a,n=y.defaultImageSphereSize/2){const{heading:i,pitch:o}=j(t,n);return k(i,o,e,a)}function k(t,e,a,n){return{x:a/2+t/(360/a),y:n-e/(180/n),heading:t,pitch:e}}function j(t,e){const a=o.rad2deg(Math.acos(-t.z/e));return{heading:o.rad2deg(Math.atan2(t.x,t.y)),pitch:a}}function Z(t,e,a=y.defaultImageSphereSize/2){return[a*(Math.sin(o.deg2rad(t))*Math.sin(o.deg2rad(e))),a*(Math.cos(o.deg2rad(t))*Math.sin(o.deg2rad(e))),a*Math.cos(o.deg2rad(180-e))]}async function G(t,e,a){const n=await m.projectWithZConversion(e,t.spatialReference,a);let i=o.rad2deg(Math.atan2(n.y-t.y,n.x-t.x));return i=i>=0&&i<=90?90-i:i>90&&i<=180?360-i+90:90+Math.abs(i),i}function J(t,e,a){const n=Math.cos(a),i=Math.sin(a),o=[1,0,0,1,0,0],r=o[0]*n+o[2]*i,c=o[1]*n+o[3]*i,s=-o[0]*i+o[2]*n,l=-o[1]*i+o[3]*n;o[0]=r,o[1]=c,o[2]=s,o[3]=l;return[t*o[0]+e*o[2]+o[4],t*o[1]+e*o[3]+o[5]]}function X(t){return 4===t?.type}async function Y(t,e,a){const n=await m.projectWithZConversion(t,w.WGS84,a);return r.throwIfAborted(a),U(n.toArray(),e)}const $=t=>t.toArray(),B=(...t)=>t.some((t=>t));function Q(t,e){if(B(0===t.length,t.some((({x:t,y:e})=>B(null==t,null==e))),!e.hasZ))throw new Error("Input pixels must have x, y and camera location must have z value")}function _(t,e){if(t.some((t=>null==t.z))||null==e.z)throw new Error("Input points and camera location must have z value")}function tt(t){if(9!==t?.length)throw new Error("Rotation matrix is not provided or is not a valid 3x3 matrix")}function et(t,e){return p.isWebMercator(e)?1/Math.cos(Math.PI/2-2*Math.atan(Math.exp(-1*t/g.earth.radius))):1}const at=t=>e=>new P(e,t),nt=t=>null!=t&&"queryExtent"in t;function it(t,e,a,n){return[[-e,-e],[+e,-e],[+e,+e],[-e,+e]].map((([e,i])=>O(v.translate(h.zeros(),a,[e,i,0]),n,t)))}function ot({a0:t,a1:e,a2:a,b0:n,b1:i,b2:o},r,c,s){const l=[t??r/2-.5,e,a??0,n??c/2-.5,i??0,o].map(rt);return null!=s&&ct(l)?{affines:l,focalLength:s}:{affines:[r/2-.5,1,0,c/2-.5,0,-1]}}function rt(t,e){if(null==t)return null;const a=parseFloat(`${t}`);return isNaN(a)?null:a}function ct(t){return null!=t[1]&&null!=t[5]}function st(t,e,a){const{cameraHeight:n,cameraPitch:i,cameraRoll:o,elevation:r,farDistance:c,horizontalFieldOfView:s,location:l,verticalFieldOfView:h}=t,u=r??(l.z??0)-n;return{...ut(t,e,a),averageElevation:u,cameraPitch:i,cameraRoll:o??0,farDistance:c,horizontalFieldOfView:s,verticalFieldOfView:h}}function lt(t,e,a,n){return xt(n)?A([n.omega,n.phi,n.kappa]):yt(n)?W([n.heading,n.pitch,n.roll]):W([t,e,a??0])}function ht(t,e,a){const{cameraHeading:n,cameraHeight:i,elevation:o,farDistance:r,horizontalFieldOfView:c,location:s,verticalFieldOfView:l}=t;return{averageElevation:o??(s.z??0)-i,cameraLocation:s,cameraHeading:n,farDistance:r,horizontalFieldOfView:c,imageHeight:a,imageWidth:e,verticalFieldOfView:l}}function ut(t,e,a){const{a0:n,a1:i,a2:o,b0:r,b1:c,b2:s,cameraHeading:l,cameraOrientation:h,cameraPitch:u,cameraRoll:f,focalLength:d,horizontalFieldOfView:m,location:g,matrix:p,principalX:v,principalY:M,radial:x,tangential:y,verticalFieldOfView:w}=t,{affines:P,focalLength:O}=ot({a0:n,a1:i,a2:o,b0:r,b1:c,b2:s},e,a,d),S=p??lt(l,u,f,h),b=null!=v&&null!=M?[v,M]:void 0;return{affineTransformations:h?.affineTransformations??P,cameraLocation:g.clone(),focalLength:h?.focalLength??O,horizontalFieldOfView:m,imageHeight:a,imageWidth:e,principalOffsetPoint:h?.principalOffsetPoint??b,radialDistortionCoefficients:h?.radialDistortionCoefficients??x,rotationMatrix:S,tangentialDistortionCoefficients:h?.tangentialDistortionCoefficients??y,verticalFieldOfView:w}}const ft=t=>null!=t&&"elevationSample"in t&&null!=t.elevationSample,dt=t=>M.isElevationSource(t?.elevationSource)&&null!=t?.extent,mt=t=>M.isConstantElevation(t?.elevationSource),gt=async(t,e)=>null!=e&&(ft(e)||mt(e))?e:dt(e)?{elevationSample:await x.getElevationSampler({...i.isSerializable(e.elevationSource)?e.elevationSource.toJSON():e.elevationSource,extent:e.extent}),elevationSource:new M.ConstantElevation({constantElevation:t})}:{elevationSource:new M.ConstantElevation({constantElevation:t})},pt=t=>a.isNumber(t?.heading)&&a.isNumber(t?.pitch),vt=(t,e)=>[[-t,-e],[t,-e],[t,e],[-t,e]];function Mt(t){const{cameraLocation:e,farDistance:a,horizontalFieldOfView:n,rotationMatrix:i,scalingFactor:r,verticalFieldOfView:s}=t,l=c.create();u.transpose(l,i);const f=2*Math.tan(o.deg2rad(s)/2)*a*r,m=2*Math.tan(o.deg2rad(n)/2)*a*r,g=V([0,0,-1],l),p=F([e.x,e.y,e.z],g,t.farDistance*r,r),v=V([0,1,0],l),M=V([1,0,0],l),x=T(v,f/2,r),y=T(M,m/2,r),w=d.sub(h.zeros(),x,y),P=d.add(h.zeros(),x,y);return[d.add(h.zeros(),p,w),d.add(h.zeros(),p,P),d.sub(h.zeros(),p,w),d.sub(h.zeros(),p,P)]}const xt=t=>2===t?.type,yt=t=>1===t?.type;var wt;!function(t){t[t.CLOCKWISE=-1]="CLOCKWISE",t[t.COUNTERCLOCKWISE=1]="COUNTERCLOCKWISE"}(wt||(wt={})),t.computeFarplaneVertices=Mt,t.computeHFOVAndVFOV=H,t.computeNewReferenceCoordinates=it,t.convertHeadingPitchToSphereVertex=Z,t.convertOrientationToPixelLocation=k,t.convertPixelToHeadingPitch=q,t.convertSphereVertexToOrientation=j,t.convertSphereVertexToPixelLocation=K,t.convertToLTP=Y,t.createRotationMatrix=L,t.createRotationMatrixFromHPR=W,t.createRotationMatrixFromOPK=A,t.geographicToLTP=U,t.getAffinesAndFocalLength=ot,t.getImageToWorldPanoramicProperties=ht,t.getImageToWorldProperties=st,t.getInitialAngle=G,t.getPlaneLineIntersectionPoint=N,t.getUpdateElevationProps=gt,t.getWebMercatorScalingFactor=et,t.getWorldToImageProperties=ut,t.hasAngles=pt,t.hasCameraOrientationLTP=X,t.hasHeadingPitchRoll=yt,t.hasOmegaPhiKappa=xt,t.isElevationSampler=nt,t.isUpdateElevationWithElevationSampler=ft,t.isUpdateElevationWithElevationSource=dt,t.isUpdateUsingConstantElevation=mt,t.isValidAffines=ct,t.linearEquationSolve=E,t.ltpToGeographic=D,t.or=B,t.pointToArray=$,t.projectiveTransform=O,t.reducerFn=vt,t.rotatePixel=J,t.scaleAndAddWithFactor=F,t.scaleWithFactor=T,t.transformMat3=V,t.transformMat4=C,t.validatePixelsToTransform=Q,t.validatePointsToTransform=_,t.validateRotationMatrix=tt,t.vecToPoint=at,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
