/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../core/arrayUtils","../../core/Error","../../core/accessorSupport/originUtils","./utils","../support/arcgisLayerUrl","../support/fetchService","../support/layerUtils","../support/lazyLayerLoader","../../portal/support/portalItemUtils"],(function(e,r,t,a,o,n,s,i,l,y){"use strict";const c="Feature Service",u="feature-layer-utils",p=`${u}-save`,d=`${u}-save-as`,f=`${u}-saveall`,m=`${u}-saveall-as`;function w(e){return{isValid:i.isLayerWithFeatureLayerSource(e)&&(!("dynamicDataSource"in e)||!e.dynamicDataSource),errorMessage:"Feature layer should be a layer or table in a map or feature service"}}function h(e){const r=[],t=[];for(const{layer:a,layerJSON:o}of e)a.isTable?t.push(o):r.push(o);return{layers:r,tables:t}}function v(e){return h([e])}async function g(e,r){return/\/\d+\/?$/.test(e.url)?v(r[0]):T(r,e)}async function T(e,r){if(e.reverse(),!r)return h(e);const t=await I(r,e);for(const a of e)x(a.layer,a.layerJSON,t);return L(t,e),t}async function I(e,r){let t=await e.fetchData("json");if(S(t))return t;t||={},E(t);const{layer:{url:a,customParameters:o,apiKey:n}}=r[0];return await K(t,{url:a??"",customParameters:o,apiKey:n},r.map((e=>e.layer.layerId))),t}function S(e){return!!(e&&Array.isArray(e.layers)&&Array.isArray(e.tables))}function E(e){e.layers||=[],e.tables||=[]}function L(e,r){const t=[],a=[];for(const{layer:o}of r){const{isTable:e,layerId:r}=o;e?a.push(r):t.push(r)}A(e.layers,t),A(e.tables,a)}function A(e,t){if(e.length<2)return;const a=[];for(const{id:r}of e)a.push(r);r.equals(a.sort(b),t.slice().sort(b))&&e.sort(((e,r)=>{const a=t.indexOf(e.id),o=t.indexOf(r.id);return a<o?-1:a>o?1:0}))}function b(e,r){return e<r?-1:e>r?1:0}async function K(e,r,t){const{url:a,customParameters:o,apiKey:n}=r,{serviceJSON:i,layersJSON:l}=await s.fetchFeatureService(a,{customParameters:o,apiKey:n}),y=P(e.layers,i.layers,t),c=P(e.tables,i.tables,t);e.layers=y.itemResources,e.tables=c.itemResources;const u=[...y.added,...c.added],p=l?[...l.layers,...l.tables]:[];await O(e,u,a,p)}function P(e,t,a){const o=r.difference(e,t,((e,r)=>e.id===r.id));e=e.filter((e=>!o.removed.some((r=>r.id===e.id))));const n=o.added;return n.forEach((({id:r})=>{e.push({id:r})})),{itemResources:e,added:n.filter((({id:e})=>!a.includes(e)))}}async function O(e,r,t,a){const o=await N(r),n=r.map((({id:e,type:r})=>new(o.get(r))({url:t,layerId:e,sourceJSON:a.find((({id:r})=>r===e))})));await Promise.allSettled(n.map((e=>e.load()))),n.forEach((r=>{const{layerId:t,loaded:a,defaultPopupTemplate:o}=r;if(!a||null==o)return;const n={id:t,popupInfo:o.toJSON()};"ArcGISFeatureLayer"!==r.operationalLayerType&&(n.layerType=r.operationalLayerType),x(r,n,e)}))}async function N(e){const r=[];e.forEach((({type:e})=>{const t=s.getLayerModuleType(e),a=l.layerLookupMap[t];r.push(a())}));const t=await Promise.all(r),a=new Map;return e.forEach((({type:e},r)=>{a.set(e,t[r])})),a}function x(e,r,t){e.isTable?$(t.tables,r):$(t.layers,r)}function $(e,r){const t=e.findIndex((({id:e})=>e===r.id));-1===t?e.push(r):e[t]=r}function M(e,r){if(!e.length)throw new t(`${r}:missing-parameters`,"'layers' array should contain at least one feature layer")}function R(e,r){const a=e.map((e=>e.portalItem.id));if(new Set(a).size>1)throw new t(`${r}:invalid-parameters`,"All layers in the 'layers' array should be loaded from the same portal item")}function F(e,r){const a=e.map((e=>e.layerId));if(new Set(a).size!==a.length)throw new t(`${r}:invalid-parameters`,"'layers' array should contain only one instance each of layer or table in a feature service")}async function J(e){M(e,f),await Promise.all(e.map((e=>e.load())));for(const r of e)o.ensureLayerConfig(r,f,w),o.ensureItemConfig({layer:r,itemType:c,errorNamePrefix:f});R(e,f),F(e,f)}function U(e,r){const t=e.layers.some((e=>"OrientedImageryLayer"===e.layerType));y.toggleTypeKeyword(r,y.typeKeyword.ORIENTED_IMAGERY_LAYER,t)}function D(e,r){const t=e.some((e=>"oriented-imagery"===e.type));y.toggleTypeKeyword(r,y.typeKeyword.ORIENTED_IMAGERY_LAYER,t)}async function Y(e,r,t){U(t,r)}async function _(e,r){const{url:t,layerId:a,title:o,fullExtent:s,isTable:i}=e,l=n.parse(t);r.url=("FeatureServer"===l?.serverType?t:`${t}/${a}`)??null,r.title||=o,r.extent=null,i||null==s||(r.extent=await y.getWGS84ExtentForItem(s)),y.removeTypeKeyword(r,y.typeKeyword.METADATA),y.removeTypeKeyword(r,y.typeKeyword.MULTI_LAYER),y.addTypeKeyword(r,y.typeKeyword.SINGLE_LAYER),y.toggleTypeKeyword(r,y.typeKeyword.TABLE,i),D([e],r)}function C(e,r){for(const l of e){const a=l.parsedUrl.path,s=n.parse(a),i=s?.url.path;if(!i)throw new t(`${r}:invalid-parameters`,o.createErrorMessage(l,`has unsupported url pattern: ${a}`),{layer:l});const y=s?.serverType;if("FeatureServer"!==y&&"MapServer"!==y)throw new t(`${r}:invalid-parameters`,o.createErrorMessage(l,`has unsupported server type: ${y}`),{layer:l});if("MapServer"===y&&e.length>1)throw new t(`${r}:invalid-parameters`,"Only one layer or table in a map service can be saved")}const a=n.parse(e[0].parsedUrl.path),s=a?.url.path,i=e.every((e=>{const r=n.parse(e.parsedUrl.path);return r?.url.path===s}));if(!i)throw new t(`${r}:invalid-parameters`,"'layers' array should only contain layers or tables that belong to the same feature service")}async function G(e){M(e,m),await Promise.all(e.map((e=>e.load())));for(const r of e)o.ensureLayerConfig(r,m,w);C(e,m),F(e,m)}function W(e,r){U(r,e),o.setCommonItemProperties(e)}async function z(e,t){let a=0,s=0;for(const{isTable:r}of t)r?s++:a++;const i=t[0].parsedUrl.path,l=n.parse(i);if(e.url="FeatureServer"===l?.serverType?l.url.path:i,e.title||=l.title,e.extent=null,a>0){const a=t.map((e=>e.fullExtent)).filter(r.isSome).reduce(((e,r)=>e.clone().union(r)));a&&(e.extent=await y.getWGS84ExtentForItem(a))}y.removeTypeKeyword(e,y.typeKeyword.METADATA),y.toggleTypeKeyword(e,y.typeKeyword.MULTI_LAYER,t.length>1),y.toggleTypeKeyword(e,y.typeKeyword.SINGLE_LAYER,1===t.length),y.toggleTypeKeyword(e,y.typeKeyword.TABLE,s>0&&0===a),D(t,e),o.setCommonItemProperties(e)}async function j(e,r){const t={layer:e,itemType:c,validateLayer:w,createItemData:(e,r)=>g(r,[e]),errorNamePrefix:p,setItemProperties:Y};return o.save(t,r)}async function B(e,r){await J(e);const t=e[0].portalItem,n=o.createJSONContextForWrite(t),s=await Promise.all(e.map((e=>o.getLayerJSON(e,n,r)))),i=await g(t,e.map(((e,r)=>({layer:e,layerJSON:s[r]}))));return W(t,i),await t.update({data:i}),await Promise.all(e.slice(1).map((e=>e.portalItem.reload()))),a.updateOrigins(n),t.clone()}async function k(e,r,t){const a={layer:e,itemType:c,validateLayer:w,createItemData:(e,r)=>Promise.resolve(v(e)),errorNamePrefix:d,newItem:r,setItemProperties:_};return o.saveAs(a,t)}async function q(e,r,t){await G(e);const n=o.getPortalItem({itemType:c,errorNamePrefix:m,newItem:r}),s=o.createJSONContextForWrite(n),i=await Promise.all(e.map((e=>o.getLayerJSON(e,s,t)))),l=await T(e.map(((e,r)=>({layer:e,layerJSON:i[r]}))));await z(n,e),await o.addItem(n,l,t);for(const a of e)a.portalItem=n.clone();return a.updateOrigins(s),n}e.save=j,e.saveAll=B,e.saveAllAs=q,e.saveAs=k,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
