/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../core/Clonable","../../core/Error","../../core/JSONSupport","../../core/Logger","../../core/perspectiveUtils","../../core/screenUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/RandomLCG","../../core/accessorSupport/decorators/reader","../../core/accessorSupport/decorators/subclass","../../core/accessorSupport/decorators/writer","../../core/libs/gl-matrix-2/math/mat3","../../core/libs/gl-matrix-2/factories/mat3f64","../../core/libs/gl-matrix-2/math/vec2","../../core/libs/gl-matrix-2/factories/vec2f64","../../geometry/Point","../../geometry/Polygon","../../geometry/projection","../../geometry/SpatialReference","./GeoreferenceBase"],(function(e,t,o,r,n,i,s,c,l,a,p,u,P,f,m,h,d,y,g,_,v,w){"use strict";const x=m.create(),S=d.create();let j=class extends r.JSONSupport{};e.__decorate([c.property({type:Number,json:{write:!0}})],j.prototype,"x",void 0),e.__decorate([c.property({type:Number,json:{write:!0}})],j.prototype,"y",void 0),j=e.__decorate([u.subclass("esri.layers.support.ControlPointsGeoreference.ControlPointJSONType")],j);let R=class extends t.Clonable{constructor(){super(...arguments),this.sourcePoint=null,this.mapPoint=null}};e.__decorate([c.property()],R.prototype,"sourcePoint",void 0),e.__decorate([c.property({type:y})],R.prototype,"mapPoint",void 0),R=e.__decorate([u.subclass("esri.layers.support.ControlPointsGeoreference.ControlPoint")],R);let b=class extends(r.JSONSupportMixin(w)){constructor(e){super(e),this.controlPoints=null,this.height=0,this.type="control-points",this.width=0}readControlPoints(e,t){const o=v.fromJSON(t.spatialReference),r=m.fromValues(...t.coefficients,1);return e.map((e=>(h.set(S,e.x,e.y),i.transformProjective(S,S,r),{sourcePoint:e,mapPoint:new y({x:S[0],y:S[1],spatialReference:o})})))}writeControlPoints(e,t,r,i){if(null!=this.transform)null!=e&&C(e[0])&&(t.controlPoints=e.map((e=>{const t=e.sourcePoint;return{x:t.x,y:t.y}})),t.spatialReference=e[0].mapPoint.spatialReference.toJSON(),t.coefficients=this.transform.slice(0,8));else{const e=new o("web-document-write:invalid-georeference","Invalid 'controlPoints', 'width', 'height' configuration. Make sure the parent media element is loaded i.e. the ImageElement or VideoElement set as 'MediaLayer.source'.",{layer:i?.layer,georeference:this});i?.messages?i.messages.push(e):n.getLogger(this).error(e.name,e.message)}}get coords(){if(null==this.controlPoints)return null;const e=this._updateTransform(x);if(null==e||!C(this.controlPoints[0]))return null;const t=this.controlPoints[0].mapPoint.spatialReference;return D(e,this.width,this.height,t)}set coords(e){if(null==this.controlPoints||!C(this.controlPoints[0]))return;const t=this.controlPoints[0].mapPoint.spatialReference;if(null==(e=this.projectOrWarn(e,t)))return;const{width:o,height:r}=this,{rings:[[n,c,l,a]]}=e,p={sourcePoint:s.createScreenPoint(0,r),mapPoint:new y({x:n[0],y:n[1],spatialReference:t})},u={sourcePoint:s.createScreenPoint(0,0),mapPoint:new y({x:c[0],y:c[1],spatialReference:t})},P={sourcePoint:s.createScreenPoint(o,0),mapPoint:new y({x:l[0],y:l[1],spatialReference:t})},f={sourcePoint:s.createScreenPoint(o,r),mapPoint:new y({x:a[0],y:a[1],spatialReference:t})};C(p)&&C(u)&&C(P)&&C(f)&&(A(x,p,u,P,f),this.controlPoints=this.controlPoints.map((({sourcePoint:e})=>(h.set(S,e.x,e.y),i.transformProjective(S,S,x),{sourcePoint:e,mapPoint:new y({x:S[0],y:S[1],spatialReference:t})}))))}get inverseTransform(){return null==this.transform?null:f.invert(m.create(),this.transform)}get transform(){return this._updateTransform()}toMap(e){if(null==e||null==this.transform||null==this.controlPoints||!C(this.controlPoints[0]))return null;h.set(S,e.x,e.y);const t=this.controlPoints[0].mapPoint.spatialReference;return i.transformProjective(S,S,this.transform),new y({x:S[0],y:S[1],spatialReference:t})}toSource(e){if(null==e||null==this.inverseTransform||null==this.controlPoints||!C(this.controlPoints[0]))return null;const t=this.controlPoints[0].mapPoint.spatialReference;return e=e.normalize(),null==(e=_.projectOrLoad(e,t).geometry)?null:(h.set(S,e.x,e.y),i.transformProjective(S,S,this.inverseTransform),s.createScreenPoint(S[0],S[1]))}toSourceNormalized(e){const t=this.toSource(e);return null!=t&&(t.x/=this.width,t.y/=this.height),t}_updateTransform(e){const{controlPoints:t,width:o,height:r}=this;if(!(null!=t&&o>0&&r>0))return null;const[n,i,s,c]=t;if(!C(n))return null;const l=n.mapPoint.spatialReference,a=this._projectControlPoint(i,l),p=this._projectControlPoint(s,l),u=this._projectControlPoint(c,l);if(!a.valid||!p.valid||!u.valid)return null;if(!C(a.controlPoint))return null;null==e&&(e=m.create());let P=null;return P=C(p.controlPoint)&&C(u.controlPoint)?A(e,n,a.controlPoint,p.controlPoint,u.controlPoint):C(p.controlPoint)?z(e,n,a.controlPoint,p.controlPoint):k(e,n,a.controlPoint),P.every((e=>0===e))?null:P}_projectControlPoint(e,t){if(!C(e))return{valid:!0,controlPoint:e};const{sourcePoint:o,mapPoint:r}=e,{geometry:i,pending:s}=_.projectOrLoad(r,t);return s?{valid:!1,controlPoint:null}:s||i?{valid:!0,controlPoint:{sourcePoint:o,mapPoint:i}}:(n.getLogger(this).warn("map point could not be projected to the spatial reference",{georeference:this,controlPoint:e,sourceSpatialReference:r.spatialReference,targetSpatialReference:t}),{valid:!1,controlPoint:null})}};function C(e){return null!=e?.sourcePoint&&null!=e.mapPoint}e.__decorate([c.property({type:[R],json:{write:{allowNull:!1,isRequired:!0,target:{controlPoints:{type:[j]},coefficients:{type:[Number]},spatialReference:{type:v}}}}})],b.prototype,"controlPoints",void 0),e.__decorate([p.reader("controlPoints")],b.prototype,"readControlPoints",null),e.__decorate([P.writer("controlPoints")],b.prototype,"writeControlPoints",null),e.__decorate([c.property({clonable:!1})],b.prototype,"coords",null),e.__decorate([c.property({type:Number,nonNullable:!0,json:{write:!0}})],b.prototype,"height",void 0),e.__decorate([c.property({readOnly:!0})],b.prototype,"inverseTransform",null),e.__decorate([c.property({readOnly:!0})],b.prototype,"transform",null),e.__decorate([c.property({type:Number,nonNullable:!0,json:{write:!0}})],b.prototype,"width",void 0),b=e.__decorate([u.subclass("esri.layers.support.ControlPointsGeoreference")],b);const N=d.create(),O=d.create(),T=d.create(),L=d.create(),M=d.create(),J=d.create(),V=d.create(),G=d.create(),I=Math.PI/2;function E(e,t,o){h.set(e,o.sourcePoint.x,o.sourcePoint.y),h.set(t,o.mapPoint.x,o.mapPoint.y)}function k(e,t,o){return E(N,M,t),E(O,J,o),h.rotate(T,O,N,I),h.rotate(L,N,O,I),h.rotate(V,J,M,-I),h.rotate(G,M,J,-I),W(e,N,O,T,L,M,J,V,G)}function z(e,t,o,r){return E(N,M,t),E(O,J,o),E(T,V,r),h.lerp(L,N,O,.5),h.rotate(L,T,L,Math.PI),h.lerp(G,M,J,.5),h.rotate(G,V,G,Math.PI),W(e,N,O,T,L,M,J,V,G)}function A(e,t,o,r,n){return E(N,M,t),E(O,J,o),E(T,V,r),E(L,G,n),W(e,N,O,T,L,M,J,V,G)}const U=new Array(8).fill(0),q=new Array(8).fill(0);function B(e,t,o,r,n){return e[0]=t[0],e[1]=t[1],e[2]=o[0],e[3]=o[1],e[4]=r[0],e[5]=r[1],e[6]=n[0],e[7]=n[1],e}function W(e,t,o,r,n,s,c,l,a){return i.getProjectiveTransform(e,B(U,t,o,r,n),B(q,s,c,l,a))}function D(e,t,o,r){const n=d.fromValues(0,o),s=d.fromValues(0,0),c=d.fromValues(t,0),l=d.fromValues(t,o);return i.transformProjective(n,n,e),i.transformProjective(s,s,e),i.transformProjective(c,c,e),i.transformProjective(l,l,e),new g({rings:[[n,s,c,l,n]],spatialReference:r})}return b}));
