/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../geometry","../../core/has","../../core/handleUtils","../../core/Logger","../../core/unitUtils","../../geometry/support/aaBoundingRect","../../geometry/support/webMercatorUtils","../../geometry/Point"],(function(e,t,n,s,i,a,o,l,r){"use strict";const c=()=>i.getLogger("esri.layers.support.ElevationSampler");class u{queryElevation(e){return h(e.clone(),this)}on(){return s.makeHandle()}projectIfRequired(e,t){return f(e,t)}}class m extends u{get spatialReference(){return this.extent.spatialReference}constructor(e,t,n){super(),this.tile=e,this.noDataValue=n;const s=e.tile.extent;this.extent=o.toExtent(s,t.spatialReference),this.extent.zmin=e.zmin,this.extent.zmax=e.zmax,this._aaExtent=s;const i=a.getMetersPerUnitForSR(t.spatialReference),l=t.lodAt(e.tile.level).resolution*i;this.demResolution={min:l,max:l}}contains(e){const t=this.projectIfRequired(e,this.spatialReference);return null!=t&&this.containsAt(t.x,t.y)}containsAt(e,t){return o.containsXY(this._aaExtent,e,t)}elevationAt(e,t){if(!this.containsAt(e,t)){const n=this.extent,s=`${n.xmin}, ${n.ymin}, ${n.xmax}, ${n.ymax}`;return c().warn("#elevationAt()",`Point used to sample elevation (${e}, ${t}) is outside of the sampler extent (${s})`),this.noDataValue}return this.tile.sample(e,t)??this.noDataValue}}class p extends u{get spatialReference(){return this.extent.spatialReference}constructor(e,t,n){let s;super(),"number"==typeof t?(this.noDataValue=t,s=null):(s=t,this.noDataValue=n),this.samplers=s?e.map((e=>new m(e,s,this.noDataValue))):e;const i=this.samplers[0];if(i){this.extent=i.extent.clone();const{min:e,max:t}=i.demResolution;this.demResolution={min:e,max:t};for(let n=1;n<this.samplers.length;n++){const e=this.samplers[n];this.extent.union(e.extent),this.demResolution.min=Math.min(this.demResolution.min,e.demResolution.min),this.demResolution.max=Math.max(this.demResolution.max,e.demResolution.max)}}else this.extent=o.toExtent(o.create(),s.spatialReference),this.demResolution={min:0,max:0}}elevationAt(e,t){let n,s=!1;for(const i of this.samplers)if(i.containsAt(e,t)&&(s=!0,n=i.elevationAt(e,t),n!==i.noDataValue))return n;return null!=n?n:(s||c().warn("#elevationAt()",`Point used to sample elevation (${e}, ${t}) is outside of the sampler`),this.noDataValue)}}function h(e,t){const n=f(e,t.spatialReference);if(!n)return null;switch(e.type){case"point":x(e,n,t);break;case"polyline":d(e,n,t);break;case"multipoint":R(e,n,t)}return e}function f(e,t){if(null==e)return null;const n=e.spatialReference;if(n.equals(t))return e;const s=l.project(e,t);return s||c().error(`Cannot project geometry spatial reference (wkid:${n.wkid}) to elevation sampler spatial reference (wkid:${t.wkid})`),s}function x(e,t,n){e.z=n.elevationAt(t.x,t.y)}function d(e,t,n){y.spatialReference=t.spatialReference;const s=e.hasM&&!e.hasZ;for(let i=0;i<e.paths.length;i++){const a=e.paths[i],o=t.paths[i];for(let e=0;e<a.length;e++){const t=a[e],i=o[e];y.x=i[0],y.y=i[1],s&&(t[3]=t[2]),t[2]=n.elevationAt(y.x,y.y)}}e.hasZ=!0}function R(e,t,n){y.spatialReference=t.spatialReference;const s=e.hasM&&!e.hasZ;for(let i=0;i<e.points.length;i++){const a=e.points[i],o=t.points[i];y.x=o[0],y.y=o[1],s&&(a[3]=a[2]),a[2]=n.elevationAt(y.x,y.y)}e.hasZ=!0}const y=new r;e.ElevationSamplerBase=u,e.MultiTileElevationSampler=p,e.TileElevationSampler=m,e.updateGeometryElevation=h,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
