/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../chunks/tslib.es6","../../core/JSONSupport","../../core/accessorSupport/decorators/property","../../core/has","../../core/Logger","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../../core/accessorSupport/decorators/writer","./imageryRendererUtils","./MosaicRule","./rasterEnums","./RasterFunction"],(function(e,r,t,o,i,a,n,s,p,c,l,m,u){"use strict";function y(e,r){const t=new u({functionName:"Clip",functionArguments:{ClippingGeometry:r.toJSON(),ClippingType:1}});return c.combineRenderingRules(t,e)}e.ExportImageServiceParameters=class extends t.JSONSupport{constructor(){super(...arguments),this.layer=null,this.compression=void 0,this.pixelType=void 0,this.lercVersion=2}get adjustAspectRatio(){return this.layer.adjustAspectRatio}writeAdjustAspectRatio(e,r,t){this.layer.version<10.3||(r[t]=e)}get bandIds(){return this.layer.bandIds}get compressionQuality(){return this.layer.compressionQuality}writeCompressionQuality(e,r,t){this.format&&this.format.toLowerCase().includes("jpg")&&null!=e&&(r[t]=e)}get compressionTolerance(){return this.layer.compressionTolerance}writeCompressionTolerance(e,r,t){"lerc"===this.format&&null!=e&&(r[t]=e)}get format(){return"vector-field"===this.layer.renderer?.type?"lerc":this.layer.format}get interpolation(){return this.layer.interpolation}get noData(){return this.layer.noData}get noDataInterpretation(){return this.layer.noDataInterpretation}writeLercVersion(e,r,t){"lerc"===this.format&&this.layer.version>=10.5&&(r[t]=e)}get version(){const e=this.layer;return e.commitProperty("bandIds"),e.commitProperty("format"),e.commitProperty("compressionQuality"),e.commitProperty("compressionTolerance"),e.commitProperty("interpolation"),e.commitProperty("noData"),e.commitProperty("noDataInterpretation"),e.commitProperty("mosaicRule"),e.commitProperty("rasterFunction"),e.commitProperty("adjustAspectRatio"),e.commitProperty("pixelFilter"),e.commitProperty("definitionExpression"),e.commitProperty("multidimensionalSubset"),(this._get("version")||0)+1}set version(e){this._set("version",e)}get mosaicRule(){const e=this.layer;let r=e.mosaicRule;const t=e.definitionExpression;return r?t&&t!==r.where&&(r=r.clone(),r.where=t):t&&(r=new l({where:t})),r}get rasterFunction(){const e=this.layer;let{rasterFunction:r}=e;const t=e.pixelFilter,o=!e.format||e.format.includes("jpg")||e.format.includes("png");r=this._addResampleRasterFunction(r);const i=e.multidimensionalSubset?.areaOfInterest;return i&&(r=y(r,i)),o&&!t&&"vector-field"!==e.renderer?.type&&(r=this.combineRendererWithRenderingRule(r)),r}combineRendererWithRenderingRule(e){const r=this.layer,{rasterInfo:t,renderer:o}=r;if(e=e||r.rasterFunction,!o||!c.isSupportedRendererType(o))return e;return c.combineRenderingRules(c.convertRendererToRenderingRule(o,{rasterAttributeTable:t.attributeTable,pixelType:t.pixelType,dataType:t.dataType,bandNames:t.bandInfos.map((({name:e})=>e)),convertColorRampToColormap:r.version<10.6,convertToRFT:!!e?.rasterFunctionDefinition,bandCount:t.bandCount}),e)}_addResampleRasterFunction(e){if(!("vector-field"===this.layer.renderer?.type)||"Resample"===e?.functionName)return e;const r="esriImageServiceDataTypeVector-UV"===this.layer.serviceDataType?7:10,t=this.layer.serviceRasterInfo.pixelSize;let o=new u({functionName:"Resample",functionArguments:{ResamplingType:r,InputCellSize:t}});return o=e?.rasterFunctionDefinition?new u({rasterFunctionDefinition:c.convertRenderingRuleToRFT(o)}):o,c.combineRenderingRules(o,e)}},r.__decorate([o.property()],e.ExportImageServiceParameters.prototype,"layer",void 0),r.__decorate([o.property({json:{write:!0}})],e.ExportImageServiceParameters.prototype,"adjustAspectRatio",null),r.__decorate([p.writer("adjustAspectRatio")],e.ExportImageServiceParameters.prototype,"writeAdjustAspectRatio",null),r.__decorate([o.property({json:{write:!0}})],e.ExportImageServiceParameters.prototype,"bandIds",null),r.__decorate([o.property({json:{write:!0}})],e.ExportImageServiceParameters.prototype,"compression",void 0),r.__decorate([o.property({json:{write:!0}})],e.ExportImageServiceParameters.prototype,"compressionQuality",null),r.__decorate([p.writer("compressionQuality")],e.ExportImageServiceParameters.prototype,"writeCompressionQuality",null),r.__decorate([o.property({json:{write:!0}})],e.ExportImageServiceParameters.prototype,"compressionTolerance",null),r.__decorate([p.writer("compressionTolerance")],e.ExportImageServiceParameters.prototype,"writeCompressionTolerance",null),r.__decorate([o.property({json:{write:!0}})],e.ExportImageServiceParameters.prototype,"format",null),r.__decorate([o.property({type:String,json:{read:{reader:m.interpolationKebab.read},write:{writer:m.interpolationKebab.write}}})],e.ExportImageServiceParameters.prototype,"interpolation",null),r.__decorate([o.property({json:{write:!0}})],e.ExportImageServiceParameters.prototype,"noData",null),r.__decorate([o.property({type:String,json:{read:{reader:m.noDataInterpretationKebab.read},write:{writer:m.noDataInterpretationKebab.write}}})],e.ExportImageServiceParameters.prototype,"noDataInterpretation",null),r.__decorate([o.property({json:{write:!0}})],e.ExportImageServiceParameters.prototype,"pixelType",void 0),r.__decorate([o.property({json:{write:!0}})],e.ExportImageServiceParameters.prototype,"lercVersion",void 0),r.__decorate([p.writer("lercVersion")],e.ExportImageServiceParameters.prototype,"writeLercVersion",null),r.__decorate([o.property({type:Number})],e.ExportImageServiceParameters.prototype,"version",null),r.__decorate([o.property({json:{write:!0}})],e.ExportImageServiceParameters.prototype,"mosaicRule",null),r.__decorate([o.property({json:{write:!0,name:"renderingRule"}})],e.ExportImageServiceParameters.prototype,"rasterFunction",null),e.ExportImageServiceParameters=r.__decorate([s.subclass("esri.layers.support.ExportImageServiceParameters")],e.ExportImageServiceParameters),Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
