/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../geometry","../../core/Collection","../../core/collectionUtils","../../core/Evented","../../core/Loadable","../../core/Logger","../../core/Promise","../../core/promiseUtils","../../core/reactiveUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../../geometry/Extent","../../geometry/projection","../../geometry/support/aaBoundingRect","../../geometry/support/intersectsBase","../../geometry/support/spatialReferenceUtils","../graphics/data/BoundsStore","./ImageElement","./MediaElementBase","./MediaElementView","./VideoElement","../../geometry/SpatialReference"],(function(e,t,s,n,r,i,o,a,l,c,d,h,m,p,u,f,_,g,x,y,E,R,w,M,I){"use strict";const S={key:"type",defaultKeyValue:"image",base:R,typeMap:{image:E,video:M}},V=s.ofType(S);let b=class extends(i.LoadableMixin(a.EsriPromiseMixin(r.EventedAccessor))){constructor(e){super(e),this._index=new y.BoundsStore,this._elementViewsMap=new Map,this._elementsIndexes=new Map,this._elementsChangedHandler=e=>{for(const s of e.removed){const e=this._elementViewsMap.get(s);this._elementViewsMap.delete(s),this._index.delete(e),this.removeHandles(e),e.destroy(),this.notifyChange("fullExtent")}const{spatialReference:t}=this;for(const s of e.added){if(this._elementViewsMap.get(s))continue;const e=new w.MediaElementView({spatialReference:t,element:s});this._elementViewsMap.set(s,e);const n=c.watch((()=>e.coords),(()=>this._updateIndexForElement(e,!1)));this._updateIndexForElement(e,!0),this.addHandles(n,e)}this._elementsIndexes.clear(),this.elements.forEach(((e,t)=>this._elementsIndexes.set(e,t))),this.emit("refresh")},this.elements=new V}async load(e){if(l.throwIfAborted(e),!this.spatialReference){const e=this.elements.find((e=>null!=e.georeference?.coords));this._set("spatialReference",e?e.georeference.coords.spatialReference:I.WGS84)}return this._elementsChangedHandler({added:this.elements.items,removed:[]}),this.addHandles(this.elements.on("change",this._elementsChangedHandler)),this}destroy(){this._index.clear(),this._elementViewsMap.clear(),this._elementsIndexes.clear()}set elements(e){this._set("elements",n.referenceSetter(e,this._get("elements"),V))}get fullExtent(){if("not-loaded"===this.loadStatus)return null;const e=this._index.fullBounds;return null==e?null:new u({xmin:e[0],ymin:e[1],xmax:e[2],ymax:e[3],spatialReference:this.spatialReference})}set spatialReference(e){"not-loaded"===this.loadStatus?this._set("spatialReference",e):o.getLogger(this).error("#spatialReference","spatialReference cannot be changed after the source is loaded.")}async queryElements(e,t){await this.load(),await f.initializeProjection(e.spatialReference,this.spatialReference,null,t);const s=x.equals(e.spatialReference,this.spatialReference)?e:f.project(e,this.spatialReference);if(!s)return[];const n=s.normalize(),r=[];for(const i of n)this._index.forEachInBounds(_.fromExtent(i),(({normalizedCoords:e,element:t})=>{null!=e&&g.extentIntersectsPolygon(i,e)&&r.push(t)}));return r.sort(((e,t)=>this._elementsIndexes.get(e)-this._elementsIndexes.get(t))),r}hasElement(e){return this.elements.includes(e)}_updateIndexForElement(e,t){const s=e.normalizedBounds,n=this._index.has(e),r=null!=s;this._index.delete(e),r&&this._index.set(e,s),this.notifyChange("fullExtent"),t||(n!==r?this.emit("refresh"):this.emit("change",{element:e.element}))}};e.__decorate([d.property()],b.prototype,"elements",null),e.__decorate([d.property({readOnly:!0})],b.prototype,"fullExtent",null),e.__decorate([d.property()],b.prototype,"spatialReference",null),b=e.__decorate([p.subclass("esri.layers.support.LocalMediaElementSource")],b);return b}));
