/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../../chunks/tslib.es6","../../geometry","../../PopupTemplate","../../renderers/ClassBreaksRenderer","../../renderers/DictionaryRenderer","../../renderers/DotDensityRenderer","../../renderers/HeatmapRenderer","../../renderers/PieChartRenderer","../../renderers/Renderer","../../renderers/SimpleRenderer","../../renderers/UniqueValueRenderer","../../renderers/support/jsonUtils","../../renderers/support/types","../../request","../../symbols","../../core/Collection","../../core/Error","../../core/has","../../core/Identifiable","../../core/lang","../../core/Loadable","../../core/Logger","../../core/MultiOriginJSONSupport","../../core/sql","../../core/urlUtils","../../core/accessorSupport/decorators/property","../../core/accessorSupport/decorators/cast","../../core/accessorSupport/decorators/reader","../../core/accessorSupport/decorators/subclass","../../core/accessorSupport/decorators/writer","../../core/accessorSupport/ensureType","../../core/accessorSupport/PropertyOrigin","../../core/accessorSupport/utils","../graphics/sources/support/QueryTask","./featureLayerUtils","./FeatureType","./Field","./FieldsIndex","./fieldUtils","./LabelClass","./labelingInfo","./LayerFloorInfo","./Relationship","./serviceCapabilitiesUtils","./source/DataLayerSource","./source/MapLayerSource","../../rest/utils","../../rest/support/AttachmentQuery","../../rest/support/Query","../../support/popupUtils","../../geometry/Extent","../../geometry/SpatialReference","../../geometry/support/typeUtils"],(function(e,r,t,i,a,o,s,n,l,p,y,d,u,c,h,f,b,g,m,I,S,_,w,v,O,L,D,F,x,P,T,E,q,j,R,A,C,M,V,k,N,U,Q,B,J,$,K,G,H,z,W,X,Y,Z){"use strict";const ee=e=>Object.freeze(Object.defineProperty({__proto__:null,default:e},Symbol.toStringTag,{value:"Module"}));var re;function te(e){return"esriSMS"===e?.type}function ie(e,r,t){const i=this.originIdOf(r)>=q.nameToId(t.origin);return{ignoreOrigin:!0,allowNull:i,enabled:!!t&&("map-image"===t.layer?.type&&(t.writeSublayerStructure||i))}}function ae(e,r,t){return{enabled:!!t&&("tile"===t.layer?.type&&(t.origin&&this.originIdOf(r)>=q.nameToId(t.origin)||this._isOverridden(r)))}}function oe(e,r,t){return{ignoreOrigin:!0,enabled:t&&t.writeSublayerStructure||!1}}function se(e,r,t){return{ignoreOrigin:!0,enabled:!!t&&(t.writeSublayerStructure||this.originIdOf(r)>=q.nameToId(t.origin))}}let ne=0;const le=new Set(["layer","parent","loaded","loadStatus","loadError","loadWarnings"]);let pe=re=class extends(v.MultiOriginJSONMixin(I.IdentifiableMixin(_))){constructor(e){super(e),this.capabilities=void 0,this.maxScaleRange={minScale:0,maxScale:0},this.fields=null,this.fullExtent=null,this.geometryType=null,this.globalIdField=null,this.isTable=!1,this.legendEnabled=!0,this.objectIdField=null,this.parent=null,this.popupEnabled=!0,this.popupTemplate=null,this.relationships=null,this.sourceJSON=null,this.spatialReference=null,this.title=null,this.typeIdField=null,this.type="sublayer",this.types=null,this._lastParsedUrl=null}async load(e){return this.addResolvingPromise((async()=>{const{layer:r,url:t}=this;if(!r&&!t)throw new g("sublayer:missing-layer","Sublayer can't be loaded without being part of a layer",{sublayer:this});const i=r?await r.fetchSublayerInfo(this,e):(await h(t,{responseType:"json",query:{f:"json"},...e})).data;i&&(this.sourceJSON=i,this.read({layerDefinition:i},{origin:"service",layer:r,url:G.parseUrl(t)}))})()),this}readCapabilities(e,r){r=r.layerDefinition||r;const{operations:{supportsQuery:t,supportsQueryAttachments:i},query:{supportsFormatPBF:a,supportsOrderBy:o,supportsPagination:s},data:{supportsAttachment:n},queryRelated:l}=J.getFeatureLayerCapabilities(r,this.url);return{exportMap:{supportsModification:!!r.canModifyLayer},operations:{supportsQuery:t,supportsQueryAttachments:i},data:{supportsAttachment:n},query:{supportsFormatPBF:a,supportsOrderBy:o,supportsPagination:s},queryRelated:l}}get defaultPopupTemplate(){return this.createPopupTemplate()}set definitionExpression(e){this._setAndNotifyLayer("definitionExpression",e)}get effectiveScaleRange(){const{minScale:e,maxScale:r}=this;return{minScale:e,maxScale:r}}readMaxScaleRange(e,r){return{minScale:(r=r.layerDefinition||r).minScale??0,maxScale:r.maxScale??0}}get fieldsIndex(){return new V(this.fields||[])}set floorInfo(e){this._setAndNotifyLayer("floorInfo",e)}readGlobalIdFieldFromService(e,r){if((r=r.layerDefinition||r).globalIdField)return r.globalIdField;if(r.fields)for(const t of r.fields)if("esriFieldTypeGlobalID"===t.type)return t.name}get id(){const e=this._get("id");return e??ne++}set id(e){this._get("id")!==e&&(!1!==this.layer?.capabilities?.exportMap?.supportsDynamicLayers?this._set("id",e):this._logLockedError("id","capability not available 'layer.capabilities.exportMap.supportsDynamicLayers'"))}readIsTable(e,r){return"Table"===r.type}set labelingInfo(e){this._setAndNotifyLayer("labelingInfo",e)}writeLabelingInfo(e,r,t,i){e&&e.length&&(r.layerDefinition={drawingInfo:{labelingInfo:e.map((e=>e.write({},i)))}})}set labelsVisible(e){this._setAndNotifyLayer("labelsVisible",e)}set layer(e){this._set("layer",e),this.sublayers?.forEach((r=>r.layer=e))}set listMode(e){this._set("listMode",e)}set minScale(e){this._setAndNotifyLayer("minScale",e)}readMinScale(e,r){return r.minScale||r.layerDefinition?.minScale||0}set maxScale(e){this._setAndNotifyLayer("maxScale",e)}readMaxScale(e,r){return r.maxScale||r.layerDefinition?.maxScale||0}readObjectIdFieldFromService(e,r){if((r=r.layerDefinition||r).objectIdField)return r.objectIdField;const t=r.fields?.find((e=>"esriFieldTypeOID"===e.type));return t?.name}set opacity(e){this._setAndNotifyLayer("opacity",e)}readOpacity(e,r){const{layerDefinition:t}=r;return 1-.01*(t?.transparency??t?.drawingInfo?.transparency??0)}writeOpacity(e,r,t,i){r.layerDefinition={drawingInfo:{transparency:100-100*e}}}writeParent(e,r){this.parent&&this.parent!==this.layer?r.parentLayerId=E.ensureInteger(this.parent.id):r.parentLayerId=-1}get queryTask(){if(!this.layer)return null;const{capabilities:e,fieldsIndex:r,layer:t,url:i}=this,{spatialReference:a}=t,o="gdbVersion"in t?t.gdbVersion:void 0,s=m("featurelayer-pbf")&&e?.query.supportsFormatPBF;return new R({fieldsIndex:r,gdbVersion:o,pbfSupported:s,queryAttachmentsSupported:e?.operations?.supportsQueryAttachments??!1,sourceSpatialReference:a,url:i})}set renderer(e){if(k.fixRendererFields(e,this.fieldsIndex),e)for(const r of e.getSymbols())if(f.isSymbol3D(r)){w.getLogger(this).warn("Sublayer renderer should use 2D symbols");break}this._setAndNotifyLayer("renderer",e)}get source(){return this._get("source")||new K.MapLayerSource({mapLayerId:this.id})}set source(e){this._setAndNotifyLayer("source",e)}set sublayers(e){this._handleSublayersChange(e,this._get("sublayers")),this._set("sublayers",e)}castSublayers(e){return E.ensureType(b.ofType(re),e)}writeSublayers(e,r,t){this.sublayers?.length&&(r[t]=this.sublayers.map((e=>e.id)).toArray().reverse())}readTitle(e,r){return r.layerDefinition?.name??r.name}readTypeIdField(e,r){let t=(r=r.layerDefinition||r).typeIdField;if(t&&r.fields){t=t.toLowerCase();const e=r.fields.find((e=>e.name.toLowerCase()===t));e&&(t=e.name)}return t}get url(){const e=this.layer?.parsedUrl??this._lastParsedUrl,r=this.source;if(!e)return null;if(this._lastParsedUrl=e,"map-layer"===r?.type)return`${e.path}/${r.mapLayerId}`;const t={layer:JSON.stringify({source:this.source})};return`${e.path}/dynamicLayer?${L.objectToQuery(t)}`}set url(e){this._overrideIfSome("url",e)}set visible(e){this._setAndNotifyLayer("visible",e)}writeVisible(e,r,t,i){r[t]=this.getAtOrigin("defaultVisibility","service")||e}clone(){const{store:e}=j.getProperties(this),r=new re;return j.getProperties(r).store=e.clone(le),this.commitProperty("url"),r._lastParsedUrl=this._lastParsedUrl,r}createPopupTemplate(e){return W.createPopupTemplate(this,e)}createQuery(){return new z({returnGeometry:!0,where:this.definitionExpression||"1=1"})}async createFeatureLayer(){if(this.hasOwnProperty("sublayers"))return null;const r=(await new Promise(((r,t)=>e(["../FeatureLayer"],(e=>r(ee(e))),t)))).default,{layer:t,url:i}=this;let a;if(i&&this.originIdOf("url")>q.OriginId.SERVICE)a=new r({url:i});else{if(!t?.parsedUrl)throw new g("createFeatureLayer:missing-information","Cannot create a FeatureLayer without a url or a parent layer");{const e=t.parsedUrl;a=new r({url:e.path}),e&&this.source&&("map-layer"===this.source.type?a.layerId=this.source.mapLayerId:a.dynamicDataSource=this.source)}}return null!=t?.refreshInterval&&(a.refreshInterval=t.refreshInterval),this.definitionExpression&&(a.definitionExpression=this.definitionExpression),this.floorInfo&&(a.floorInfo=S.clone(this.floorInfo)),this.originIdOf("labelingInfo")>q.OriginId.SERVICE&&(a.labelingInfo=S.clone(this.labelingInfo)),this.originIdOf("labelsVisible")>q.OriginId.DEFAULTS&&(a.labelsVisible=this.labelsVisible),this.originIdOf("legendEnabled")>q.OriginId.DEFAULTS&&(a.legendEnabled=this.legendEnabled),this.originIdOf("visible")>q.OriginId.DEFAULTS&&(a.visible=this.visible),this.originIdOf("minScale")>q.OriginId.DEFAULTS&&(a.minScale=this.minScale),this.originIdOf("maxScale")>q.OriginId.DEFAULTS&&(a.maxScale=this.maxScale),this.originIdOf("opacity")>q.OriginId.DEFAULTS&&(a.opacity=this.opacity),this.originIdOf("popupTemplate")>q.OriginId.DEFAULTS&&(a.popupTemplate=S.clone(this.popupTemplate)),this.originIdOf("renderer")>q.OriginId.SERVICE&&(a.renderer=S.clone(this.renderer)),"data-layer"===this.source?.type&&(a.dynamicDataSource=this.source.clone()),this.originIdOf("title")>q.OriginId.DEFAULTS&&(a.title=this.title),"map-image"===t?.type&&t.originIdOf("customParameters")>q.OriginId.DEFAULTS&&(a.customParameters=t.customParameters),"tile"===t?.type&&t.originIdOf("customParameters")>q.OriginId.DEFAULTS&&(a.customParameters=t.customParameters),a}getField(e){return this.fieldsIndex.get(e)}getFeatureType(e){return A.getFeatureType(this.types,this.typeIdField,e)}getFieldDomain(e,r){const t=r?.feature,i=this.getFeatureType(t);if(i){const r=i.domains&&i.domains[e];if(r&&"inherited"!==r.type)return r}return this._getLayerDomain(e)}async queryAttachments(e,r){await this.load(),e=H.from(e);const t=this.capabilities;if(!t?.data?.supportsAttachment)throw new g("queryAttachments:not-supported","this layer doesn't support attachments");const{attachmentTypes:i,objectIds:a,globalIds:o,num:s,size:n,start:l,where:p}=e;if(!t?.operations?.supportsQueryAttachments){if(i?.length>0||o?.length>0||n?.length>0||s||l||p)throw new g("queryAttachments:option-not-supported","when 'capabilities.operations.supportsQueryAttachments' is false, only objectIds is supported",e)}if(!(a?.length||o?.length||p))throw new g("queryAttachments:invalid-query","'objectIds', 'globalIds', or 'where' are required to perform attachment query",e);return this.queryTask.executeAttachmentQuery(e,r)}async queryFeatureCount(e=this.createQuery(),r){if(await this.load(),!this.capabilities.operations.supportsQuery)throw new g("queryFeatureCount:not-supported","this layer doesn't support queries.");if(!this.url)throw new g("queryFeatureCount:not-supported","this layer has no url.");const t=this.layer?.apiKey;return await this.queryTask.executeForCount(e,{...r,query:{...this.layer?.customParameters,token:t}})}async queryFeatures(e=this.createQuery(),r){if(await this.load(),!this.capabilities.operations.supportsQuery)throw new g("queryFeatures:not-supported","this layer doesn't support queries.");if(!this.url)throw new g("queryFeatures:not-supported","this layer has no url.");const t=await this.queryTask.execute(e,{...r,query:{...this.layer?.customParameters,token:this.layer?.apiKey}});if(t?.features)for(const i of t.features)i.sourceLayer=this;return t}async queryObjectIds(e=this.createQuery(),r){if(await this.load(),!this.capabilities.operations.supportsQuery)throw new g("queryObjectIds:not-supported","this layer doesn't support queries.");if(!this.url)throw new g("queryObjectIds:not-supported","this layer has no url.");const t=this.layer?.apiKey;return await this.queryTask.executeForIds(e,{...r,query:{...this.layer?.customParameters,token:t}})}async queryRelatedFeatures(e,r){if(await this.load(),!this.capabilities.operations.supportsQuery)throw new g("queryRelatedFeatures:not-supported","this layer doesn't support queries.");if(!this.url)throw new g("queryRelatedFeatures:not-supported","this layer has no url.");const t=this.layer?.apiKey;return await this.queryTask.executeRelationshipQuery(e,{...r,query:{...this.layer?.customParameters,token:t}})}async queryRelatedFeaturesCount(e,r){if(await this.load(),!this.capabilities.operations.supportsQuery)throw new g("queryRelatedFeaturesCount:not-supported","this layer doesn't support queries.");if(!this.capabilities.queryRelated.supportsCount)throw new g("queryRelatedFeaturesCount:not-supported","this layer doesn't support query related counts.");if(!this.url)throw new g("queryRelatedFeaturesCount:not-supported","this layer has no url.");const t=this.layer?.apiKey;return await this.queryTask.executeRelationshipQueryForCount(e,{...r,query:{...this.layer?.customParameters,token:t}})}toExportImageJSON(e){const r={id:this.id,source:this.source?.toJSON()||{mapLayerId:this.id,type:"mapLayer"}},t=O.sqlAnd(e,this.definitionExpression);null!=t&&(r.definitionExpression=t);const i=["renderer","labelingInfo","opacity","labelsVisible"].reduce(((e,r)=>(e[r]=this.originIdOf(r),e)),{});if(Object.keys(i).some((e=>i[e]>q.OriginId.SERVICE))){const e=r.drawingInfo={};if(i.renderer>q.OriginId.SERVICE&&(e.renderer=this.renderer?this.renderer.toJSON():null),i.labelsVisible>q.OriginId.SERVICE&&(e.showLabels=this.labelsVisible),this.labelsVisible&&i.labelingInfo>q.OriginId.SERVICE)if(this.labelingInfo){!this.loaded&&this.labelingInfo?.some((e=>!e.labelPlacement))&&w.getLogger(this).warnOnce(`A Sublayer (title: ${this.title}, id: ${this.id}) has an undefined 'labelPlacement' and so labels cannot be displayed. Either define a valid 'labelPlacement' or call Sublayer.load() to use a default value based on geometry type.`,{sublayer:this});let r=this.labelingInfo;null!=this.geometryType&&(r=U.validateLabelingInfo(this.labelingInfo,Z.featureGeometryTypeKebabDictionary.toJSON(this.geometryType))),e.showLabels=!0,e.labelingInfo=r.filter((e=>e.labelPlacement)).map((e=>e.toJSON({origin:"service",layer:this.layer})))}else e.showLabels=!1;i.opacity>q.OriginId.SERVICE&&(e.transparency=100-100*this.opacity),this._assignDefaultSymbolColors(e.renderer)}return r}_assignDefaultSymbolColors(e){this._forEachSimpleMarkerSymbols(e,(e=>{e.color||"esriSMSX"!==e.style&&"esriSMSCross"!==e.style||(e.outline?.color?e.color=e.outline.color:e.color=[0,0,0,0])}))}_forEachSimpleMarkerSymbols(e,r){if(e){const t=("uniqueValueInfos"in e?e.uniqueValueInfos:"classBreakInfos"in e?e.classBreakInfos:null)??[];for(const e of t)te(e.symbol)&&r(e.symbol);"symbol"in e&&te(e.symbol)&&r(e.symbol),"defaultSymbol"in e&&te(e.defaultSymbol)&&r(e.defaultSymbol)}}_setAndNotifyLayer(e,r){const t=this.layer,i=this._get(e);let a,o;switch(e){case"definitionExpression":case"floorInfo":a="supportsSublayerDefinitionExpression";break;case"minScale":case"maxScale":case"visible":a="supportsSublayerVisibility";break;case"labelingInfo":case"labelsVisible":case"opacity":case"renderer":case"source":a="supportsDynamicLayers",o="supportsModification"}const s=j.getProperties(this).getDefaultOrigin();if("service"!==s){if(a&&!1===this.layer?.capabilities?.exportMap?.[a])return void this._logLockedError(e,`capability not available 'layer.capabilities.exportMap.${a}'`);if(o&&!1===this.capabilities?.exportMap[o])return void this._logLockedError(e,`capability not available 'capabilities.exportMap.${o}'`)}"source"!==e||"not-loaded"===this.loadStatus?(this._set(e,r),"service"!==s&&i!==r&&t&&t.emit&&t.emit("sublayer-update",{propertyName:e,target:this})):this._logLockedError(e,"'source' can't be changed after calling sublayer.load()")}_handleSublayersChange(e,r){r&&(r.forEach((e=>{e.parent=null,e.layer=null})),this.removeAllHandles()),e&&(e.forEach((e=>{e.parent=this,e.layer=this.layer})),this.addHandles([e.on("after-add",(({item:e})=>{e.parent=this,e.layer=this.layer})),e.on("after-remove",(({item:e})=>{e.parent=null,e.layer=null})),e.on("before-changes",(e=>{(this.layer?.capabilities?.exportMap?.supportsSublayersChanges??1)||(w.getLogger(this).error(new g("sublayer:sublayers-non-modifiable","Sublayer can't be added, moved, or removed from the layer's sublayers",{sublayer:this,layer:this.layer})),e.preventDefault())}))]))}_logLockedError(e,r){const{layer:t,declaredClass:i}=this;w.getLogger(i).error(new g("sublayer:locked",`Property '${String(e)}' can't be changed on Sublayer from the layer '${t?.id}'`,{reason:r,sublayer:this,layer:t}))}_getLayerDomain(e){return this.fieldsIndex.get(e)?.domain??null}};pe.test={isMapImageLayerOverridePolicy:e=>e===oe||e===ie,isTileImageLayerOverridePolicy:e=>e===ae},r.__decorate([D.property({readOnly:!0})],pe.prototype,"capabilities",void 0),r.__decorate([x.reader("service","capabilities",["layerDefinition.canModifyLayer","layerDefinition.capabilities"])],pe.prototype,"readCapabilities",null),r.__decorate([D.property()],pe.prototype,"defaultPopupTemplate",null),r.__decorate([D.property({type:String,value:null,json:{name:"layerDefinition.definitionExpression",write:{allowNull:!0,overridePolicy:ie}}})],pe.prototype,"definitionExpression",null),r.__decorate([D.property({readOnly:!0})],pe.prototype,"effectiveScaleRange",null),r.__decorate([x.reader("service","maxScaleRange",["minScale","maxScale"])],pe.prototype,"readMaxScaleRange",null),r.__decorate([D.property({type:[M],json:{origins:{service:{read:{source:"layerDefinition.fields"}}}}})],pe.prototype,"fields",void 0),r.__decorate([D.property({readOnly:!0})],pe.prototype,"fieldsIndex",null),r.__decorate([D.property({type:Q,value:null,json:{name:"layerDefinition.floorInfo",read:{source:"layerDefinition.floorInfo"},write:{target:"layerDefinition.floorInfo",overridePolicy:ie},origins:{"web-scene":{read:!1,write:!1}}}})],pe.prototype,"floorInfo",null),r.__decorate([D.property({type:X,json:{read:{source:"layerDefinition.extent"}}})],pe.prototype,"fullExtent",void 0),r.__decorate([D.property({type:Z.featureGeometryTypeKebabDictionary.apiValues,json:{origins:{service:{name:"layerDefinition.geometryType",read:{reader:Z.featureGeometryTypeKebabDictionary.read}}}}})],pe.prototype,"geometryType",void 0),r.__decorate([D.property({type:String})],pe.prototype,"globalIdField",void 0),r.__decorate([x.reader("service","globalIdField",["layerDefinition.globalIdField","layerDefinition.fields"])],pe.prototype,"readGlobalIdFieldFromService",null),r.__decorate([D.property({type:E.Integer,json:{write:{ignoreOrigin:!0}}})],pe.prototype,"id",null),r.__decorate([D.property({readOnly:!0})],pe.prototype,"isTable",void 0),r.__decorate([x.reader("service","isTable",["type"])],pe.prototype,"readIsTable",null),r.__decorate([D.property({value:null,type:[N],json:{read:{source:"layerDefinition.drawingInfo.labelingInfo"},write:{target:"layerDefinition.drawingInfo.labelingInfo",overridePolicy:oe}}})],pe.prototype,"labelingInfo",null),r.__decorate([T.writer("labelingInfo")],pe.prototype,"writeLabelingInfo",null),r.__decorate([D.property({type:Boolean,value:!0,json:{read:{source:"layerDefinition.drawingInfo.showLabels"},write:{target:"layerDefinition.drawingInfo.showLabels",overridePolicy:oe}}})],pe.prototype,"labelsVisible",null),r.__decorate([D.property({value:null})],pe.prototype,"layer",null),r.__decorate([D.property({type:String,json:{write:{overridePolicy:ae}}})],pe.prototype,"layerItemId",void 0),r.__decorate([D.property({type:Boolean,value:!0,json:{origins:{service:{read:{enabled:!1}}},read:{source:"showLegend"},write:{target:"showLegend",overridePolicy:se}}})],pe.prototype,"legendEnabled",void 0),r.__decorate([D.property({type:["show","hide","hide-children"],value:"show",json:{read:!1,write:!1,origins:{"web-scene":{read:!0,write:!0}}}})],pe.prototype,"listMode",null),r.__decorate([D.property({type:Number,value:0,json:{write:{overridePolicy:oe}}})],pe.prototype,"minScale",null),r.__decorate([x.reader("minScale",["minScale","layerDefinition.minScale"])],pe.prototype,"readMinScale",null),r.__decorate([D.property({type:Number,value:0,json:{write:{overridePolicy:oe}}})],pe.prototype,"maxScale",null),r.__decorate([x.reader("maxScale",["maxScale","layerDefinition.maxScale"])],pe.prototype,"readMaxScale",null),r.__decorate([D.property()],pe.prototype,"objectIdField",void 0),r.__decorate([x.reader("service","objectIdField",["layerDefinition.objectIdField","layerDefinition.fields"])],pe.prototype,"readObjectIdFieldFromService",null),r.__decorate([D.property({type:Number,value:1,json:{write:{target:"layerDefinition.drawingInfo.transparency",overridePolicy:oe}}})],pe.prototype,"opacity",null),r.__decorate([x.reader("opacity",["layerDefinition.drawingInfo.transparency","layerDefinition.transparency"])],pe.prototype,"readOpacity",null),r.__decorate([T.writer("opacity")],pe.prototype,"writeOpacity",null),r.__decorate([D.property({json:{type:E.Integer,write:{target:"parentLayerId",writerEnsuresNonNull:!0,overridePolicy:oe}}})],pe.prototype,"parent",void 0),r.__decorate([T.writer("parent")],pe.prototype,"writeParent",null),r.__decorate([D.property({type:Boolean,value:!0,json:{read:{source:"disablePopup",reader:(e,r)=>!r.disablePopup},write:{target:"disablePopup",overridePolicy:se,writer(e,r,t){r[t]=!e}}}})],pe.prototype,"popupEnabled",void 0),r.__decorate([D.property({type:i,json:{read:{source:"popupInfo"},write:{target:"popupInfo",overridePolicy:se}}})],pe.prototype,"popupTemplate",void 0),r.__decorate([D.property({readOnly:!0})],pe.prototype,"queryTask",null),r.__decorate([D.property({type:[B],readOnly:!0,json:{origins:{service:{read:{source:"layerDefinition.relationships"}}}}})],pe.prototype,"relationships",void 0),r.__decorate([D.property({types:c.rendererTypes,value:null,json:{name:"layerDefinition.drawingInfo.renderer",write:{overridePolicy:oe},origins:{"web-scene":{types:c.webSceneRendererTypes,name:"layerDefinition.drawingInfo.renderer",write:{overridePolicy:oe}}}}})],pe.prototype,"renderer",null),r.__decorate([D.property({types:{key:"type",base:null,typeMap:{"data-layer":$.DataLayerSource,"map-layer":K.MapLayerSource}},cast(e){if(e){if("mapLayerId"in e)return E.ensureClass(K.MapLayerSource,e);if("dataSource"in e)return E.ensureClass($.DataLayerSource,e)}return e},json:{name:"layerDefinition.source",write:{overridePolicy:oe}}})],pe.prototype,"source",null),r.__decorate([D.property()],pe.prototype,"sourceJSON",void 0),r.__decorate([D.property({type:Y,json:{origins:{service:{read:{source:"layerDefinition.extent.spatialReference"}}}}})],pe.prototype,"spatialReference",void 0),r.__decorate([D.property({value:null,json:{type:[E.Integer],write:{target:"subLayerIds",allowNull:!0,overridePolicy:oe}}})],pe.prototype,"sublayers",null),r.__decorate([F.cast("sublayers")],pe.prototype,"castSublayers",null),r.__decorate([T.writer("sublayers")],pe.prototype,"writeSublayers",null),r.__decorate([D.property({type:String,json:{name:"name",write:{overridePolicy:se}}})],pe.prototype,"title",void 0),r.__decorate([x.reader("service","title",["name","layerDefinition.name"])],pe.prototype,"readTitle",null),r.__decorate([D.property({type:String})],pe.prototype,"typeIdField",void 0),r.__decorate([D.property({json:{read:!1},readOnly:!0,value:"sublayer"})],pe.prototype,"type",void 0),r.__decorate([x.reader("typeIdField",["layerDefinition.typeIdField"])],pe.prototype,"readTypeIdField",null),r.__decorate([D.property({type:[C],json:{origins:{service:{read:{source:"layerDefinition.types"}}}}})],pe.prototype,"types",void 0),r.__decorate([D.property({type:String,json:{name:"layerUrl",write:{overridePolicy:ae}}})],pe.prototype,"url",null),r.__decorate([D.property({type:Boolean,value:!0,json:{read:{source:"defaultVisibility"},write:{target:"defaultVisibility",overridePolicy:oe}}})],pe.prototype,"visible",null),r.__decorate([T.writer("visible")],pe.prototype,"writeVisible",null),pe=re=r.__decorate([P.subclass("esri.layers.support.Sublayer")],pe);return pe}));
