/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../core/jsonMap","../../core/JSONSupport","../../core/unitUtils","../../core/accessorSupport/decorators/property","../../core/accessorSupport/ensureType","../../core/RandomLCG","../../core/has","../../core/accessorSupport/decorators/reader","../../core/accessorSupport/decorators/subclass","../../core/accessorSupport/decorators/writer","../../geometry/Point","../../geometry/SpatialReference","../../geometry/support/aaBoundingRect","../../geometry/support/spatialReferenceUtils","../../geometry/support/webMercatorUtils","./LOD","./TileKey"],(function(e,t,r,o,s,i,l,n,a,p,c,u,h,f,d,g,y,v){"use strict";var _;const w=new t.JSONMap({PNG:"png",PNG8:"png8",PNG24:"png24",PNG32:"png32",JPEG:"jpg",JPG:"jpg",DIB:"dib",TIFF:"tiff",EMF:"emf",PS:"ps",PDF:"pdf",GIF:"gif",SVG:"svg",SVGZ:"svgz",Mixed:"mixed",MIXED:"mixed",LERC:"lerc",LERC2D:"lerc2d",RAW:"raw",pbf:"pbf"});let m=_=class extends r.JSONSupport{static create(e={}){const{resolutionFactor:t=1,scales:r,size:s=256,spatialReference:i=h.WebMercator,numLODs:l=24}=e;if(!d.isValid(i)){const e=[];if(r)for(let t=0;t<r.length;t++){const o=r[t];e.push(new y({level:t,scale:o,resolution:o}))}else{let t=5e-4;for(let r=l-1;r>=0;r--)e.unshift(new y({level:r,scale:t,resolution:t})),t*=2}return new _({dpi:96,lods:e,origin:new u(0,0,i),size:[s,s],spatialReference:i})}const n=d.getInfo(i),a=e.origin?new u({x:e.origin.x,y:e.origin.y,spatialReference:i}):new u(n?{x:n.origin[0],y:n.origin[1],spatialReference:i}:{x:0,y:0,spatialReference:i}),p=96,c=1/(o.getMetersPerUnitForSR(i)*39.37*p),f=[];if(r)for(let o=0;o<r.length;o++){const e=r[o],t=e*c;f.push(new y({level:o,scale:e,resolution:t}))}else{let e=d.isGeographic(i)?512/s*591657527.5917094:256/s*591657527.591555;const r=Math.ceil(l/t);f.push(new y({level:0,scale:e,resolution:e*c}));for(let o=1;o<r;o++){const r=e/2**t,s=r*c;f.push(new y({level:o,scale:r,resolution:s})),e=r}}return new _({dpi:p,lods:f,origin:a,size:[s,s],spatialReference:i})}constructor(e){super(e),this.dpi=96,this.format=null,this.origin=null,this.size=null,this.spatialReference=null}get isWrappable(){const{spatialReference:e,origin:t}=this;if(e&&t){const r=d.getInfo(e);return e.isWrappable&&!!r&&Math.abs(r.origin[0]-t.x)<=r.dx}return!1}readOrigin(e,t){return u.fromJSON({spatialReference:t.spatialReference,...e})}set lods(e){let t=0,r=0;const o=[],s=this._levelToLOD={};e&&(t=-1/0,r=1/0,e.forEach((e=>{o.push(e.scale),t=e.scale>t?e.scale:t,r=e.scale<r?e.scale:r,s[e.level]=e}))),this._set("scales",o),this._set("lods",e),this._initializeUpsampleLevels()}readSize(e,t){return[t.cols,t.rows]}writeSize(e,t){t.cols=e[0],t.rows=e[1]}zoomToScale(e){const t=this.scales;if(e<=0)return t[0];if(e>=t.length-1)return t[t.length-1];const r=Math.floor(e),o=r+1;return t[r]/(t[r]/t[o])**(e-r)}scaleToZoom(e){const t=this.scales,r=t.length-1;let o=0;for(;o<r;o++){const r=t[o],s=t[o+1];if(r<=e)return o;if(s===e)return o+1;if(r>e&&s<e)return o+Math.log(r/e)/Math.log(r/s)}return o}tileAt(e,t,r,o){const s=this.lodAt(e);if(!s)return null;let i,l;if("number"==typeof t)i=t,l=r;else if(d.equals(t.spatialReference,this.spatialReference))i=t.x,l=t.y,o=r;else{const e=g.project(t,this.spatialReference);if(null==e)return null;i=e.x,l=e.y,o=r}const n=s.resolution*this.size[0],a=s.resolution*this.size[1];return o||(o=new v.TileKey(null,0,0,0,f.create())),o.level=e,o.row=Math.floor((this.origin.y-l)/a+.001),o.col=Math.floor((i-this.origin.x)/n+.001),this.updateTileInfo(o),o}updateTileInfo(e,t=_.ExtrapolateOptions.NONE){let r=this.lodAt(e.level);if(!r&&t===_.ExtrapolateOptions.POWER_OF_TWO){const t=this.lods[this.lods.length-1];t.level<e.level&&(r=t)}if(!r)return;const o=e.level-r.level,s=r.resolution*this.size[0]/2**o,i=r.resolution*this.size[1]/2**o;e.id=`${e.level}/${e.row}/${e.col}`,e.extent||(e.extent=f.create()),e.extent[0]=this.origin.x+e.col*s,e.extent[1]=this.origin.y-(e.row+1)*i,e.extent[2]=e.extent[0]+s,e.extent[3]=e.extent[1]+i}upsampleTile(e){const t=this._upsampleLevels[e.level];return!(!t||-1===t.parentLevel)&&(e.level=t.parentLevel,e.row=Math.floor(e.row/t.factor+.001),e.col=Math.floor(e.col/t.factor+.001),this.updateTileInfo(e),!0)}getTileBounds(e,t){const r=this.lodAt(t.level);if(null==r)return null;const{resolution:o}=r,s=o*this.size[0],i=o*this.size[1];return e[0]=this.origin.x+t.col*s,e[1]=this.origin.y-(t.row+1)*i,e[2]=e[0]+s,e[3]=e[1]+i,e}lodAt(e){return this._levelToLOD?.[e]??null}clone(){return _.fromJSON(this.write({}))}getCompatibleForVTL(e){if(this.size[0]!==this.size[1]||256===this.size[0]&&512===e)return null;const t=(512===this.size[0]&&256===e?-1:0)+(this.spatialReference.isGeographic?1:0);if(this.size[0]===e&&0===t)return this;const r=[],o=this.lods.length-t;for(let s=0;s<o;s++){const e=s+t,{scale:o,resolution:i}=e>=0?this.lods[e]:{scale:2*this.lods[0].scale,resolution:2*this.lods[0].resolution};r.push(new y({level:s,scale:o,resolution:i}))}return new _({size:[e,e],dpi:this.dpi,format:this.format,compressionQuality:this.compressionQuality,origin:this.origin,spatialReference:this.spatialReference,lods:r})}_initializeUpsampleLevels(){const e=this.lods;this._upsampleLevels=[];let t=null;for(let r=0;r<e.length;r++){const o=e[r];this._upsampleLevels[o.level]={parentLevel:t?t.level:-1,factor:t?t.resolution/o.resolution:0},t=o}}};e.__decorate([s.property({type:Number,json:{write:!0}})],m.prototype,"compressionQuality",void 0),e.__decorate([s.property({type:Number,json:{write:!0}})],m.prototype,"dpi",void 0),e.__decorate([s.property({type:String,json:{read:w.read,write:w.write,origins:{"web-scene":{read:!1,write:!1}}}})],m.prototype,"format",void 0),e.__decorate([s.property({readOnly:!0})],m.prototype,"isWrappable",null),e.__decorate([s.property({type:u,json:{write:!0}})],m.prototype,"origin",void 0),e.__decorate([a.reader("origin")],m.prototype,"readOrigin",null),e.__decorate([s.property({type:[y],value:null,json:{write:!0}})],m.prototype,"lods",null),e.__decorate([s.property({readOnly:!0})],m.prototype,"scales",void 0),e.__decorate([s.property({cast:e=>Array.isArray(e)?e:"number"==typeof e?[e,e]:[256,256]})],m.prototype,"size",void 0),e.__decorate([a.reader("size",["rows","cols"])],m.prototype,"readSize",null),e.__decorate([c.writer("size",{cols:{type:i.Integer},rows:{type:i.Integer}})],m.prototype,"writeSize",null),e.__decorate([s.property({type:h,json:{write:!0}})],m.prototype,"spatialReference",void 0),m=_=e.__decorate([p.subclass("esri.layers.support.TileInfo")],m),function(e){var t;(t=e.ExtrapolateOptions||(e.ExtrapolateOptions={}))[t.NONE=0]="NONE",t[t.POWER_OF_TWO=1]="POWER_OF_TWO"}(m||(m={}));return m}));
