/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","exports","../../core/Error","../../core/urlUtils","./arcgisLayerUrl","./associatedFeatureServiceUtils","./fetchService","./layerUtils","./lazyLayerLoader","../../support/requestPresets"],(function(e,r,a,t,s,l,n,o,c,i){"use strict";const u=e=>Object.freeze(Object.defineProperty({__proto__:null,default:e},Symbol.toStringTag,{value:"Module"})),y={FeatureLayer:!0,SceneLayer:!0};async function S(r){const{properties:a,url:t}=r,s={...a,url:t},l=await v(t,a?.customParameters),{Constructor:n,layerId:o,sourceJSON:c,parsedUrl:i,layers:y,tables:S}=l;if(y.length+S.length===0)return null!=o&&(s.layerId=o),null!=c&&(s.sourceJSON=c),new n(s);const f=new(0,(await new Promise(((r,a)=>e(["../GroupLayer"],(e=>r(u(e))),a)))).default)({title:i.title});return await d(f,l,s),f}function f(e,r){return e?e.find((({id:e})=>e===r)):null}function p(e,r,a,t,s){const l={...s,layerId:r};return null!=e&&(l.url=e),null!=a&&(l.sourceJSON=a),"sublayerTitleMode"in t.prototype&&(l.sublayerTitleMode="service-name"),new t(l)}async function d(e,r,a){const t=r.sublayerConstructorProvider;for(const{id:s,serverUrl:l}of r.layers){const n=f(r.sublayerInfos,s),o=p(l,s,n,(n&&t?.(n))??r.Constructor,a);e.add(o)}if(r.tables.length){const t=await I("FeatureLayer");r.tables.forEach((({id:s,serverUrl:l})=>{const n=p(l,s,f(r.tableInfos,s),t,a);e.tables.add(n)}))}}async function v(e,r){let t=s.parse(e);if(null==t&&(t=await m(e,r)),null==t)throw new a("arcgis-layers:url-mismatch","The url '${url}' is not a valid arcgis resource",{url:e});const{serverType:l,sublayer:c}=t;let u;const S={FeatureServer:"FeatureLayer",KnowledgeGraphServer:"KnowledgeGraphLayer",StreamServer:"StreamLayer",VectorTileServer:"VectorTileLayer",VideoServer:"VideoLayer"},f="FeatureServer"===l,p="SceneServer"===l,d={parsedUrl:t,Constructor:null,layerId:f||p?c??void 0:void 0,layers:[],tables:[]};switch(l){case"MapServer":if(null!=c){const{type:t}=await i.fetchArcGISServiceJSON(e,{customParameters:r});switch(u="FeatureLayer",t){case"Catalog Layer":u="CatalogLayer";break;case"Catalog Dynamic Group Layer":throw new a("arcgis-layers:unsupported",`fromUrl() not supported for "${t}" layers`)}}else{u=await L(e,r)?"TileLayer":"MapImageLayer"}break;case"ImageServer":{const a=await i.fetchArcGISServiceJSON(e,{customParameters:r}),{tileInfo:t,cacheType:s}=a;u=t?"LERC"!==t?.format?.toUpperCase()||s&&"elevation"!==s.toLowerCase()?"ImageryTileLayer":"ElevationLayer":"ImageryLayer";break}case"SceneServer":{const e=await i.fetchArcGISServiceJSON(t.url.path,{customParameters:r});if(u="SceneLayer",e){const r=e?.layers;if("Voxel"===e?.layerType)u="VoxelLayer";else if(r?.length){const e=r[0]?.layerType;null!=e&&null!=o.sceneServiceLayerTypeToClassName[e]&&(u=o.sceneServiceLayerTypeToClassName[e])}}break}case"3DTilesServer":throw new a("arcgis-layers:unsupported","fromUrl() not supported for 3DTiles layers");case"FeatureServer":if(u="FeatureLayer",null!=c){const a=await i.fetchArcGISServiceJSON(e,{customParameters:r});d.sourceJSON=a,u=n.getLayerModuleType(a.type)}break;default:u=S[l]}if(y[u]&&null==c){const a=await h(e,l,r);f&&(d.sublayerInfos=a.layerInfos,d.tableInfos=a.tableInfos);if(1!==a.layers.length+a.tables.length)d.layers=a.layers,d.tables=a.tables,f&&a.layerInfos?.length&&(d.sublayerConstructorProvider=await g(a.layerInfos));else if(f||p){const e=a.layerInfos?.[0]??a.tableInfos?.[0];if(d.layerId=a.layers[0]?.id??a.tables[0]?.id,d.sourceJSON=e,f){const r=e?.type;u=n.getLayerModuleType(r)}}}return d.Constructor=await I(u),d}async function m(e,r){const a=await i.fetchArcGISServiceJSON(e,{customParameters:r});let l=null,n=null;const o=a.type;if("Feature Layer"===o||"Table"===o?(l="FeatureServer",n=a.id??null):"indexedVector"===o?l="VectorTileServer":a.hasOwnProperty("mapName")?l="MapServer":a.hasOwnProperty("bandCount")&&a.hasOwnProperty("pixelSizeX")?l="ImageServer":a.hasOwnProperty("maxRecordCount")&&a.hasOwnProperty("allowGeometryUpdates")?l="FeatureServer":a.hasOwnProperty("streamUrls")?l="StreamServer":w(a)?(l="SceneServer",n=a.id):a.hasOwnProperty("layers")&&w(a.layers?.[0])&&(l="SceneServer"),!l)return null;const c=null!=n?s.parseNonStandardSublayerUrl(e):null;return{title:null!=c&&a.name||t.getFilename(e),serverType:l,sublayer:n,url:{path:null!=c?c.serviceUrl:t.urlToObject(e).path}}}function w(e){return null!=e&&e.hasOwnProperty("store")&&e.hasOwnProperty("id")&&"number"==typeof e.id}async function h(e,r,a){let t,s,l=!1;switch(r){case"FeatureServer":{const r=await n.fetchFeatureService(e,{customParameters:a});l=!!r.layersJSON,t=r.layersJSON||r.serviceJSON;break}case"SceneServer":{const r=await b(e,a);t=r.serviceInfo,s=r.tableServerUrl;break}default:t=await i.fetchArcGISServiceJSON(e,{customParameters:a})}const o=t?.layers,c=t?.tables;return{layers:o?.map((e=>({id:e.id}))).reverse()||[],tables:c?.map((e=>({serverUrl:s,id:e.id}))).reverse()||[],layerInfos:l?o:[],tableInfos:l?c:[]}}async function b(e,r){const a=await i.fetchArcGISServiceJSON(e,{customParameters:r}),t=a.layers?.[0];if(!t)return{serviceInfo:a};try{const{serverUrl:t}=await l.findAssociatedFeatureService(e),s=await i.fetchArcGISServiceJSON(t,{customParameters:r}).catch((()=>null));return s&&(a.tables=s.tables),{serviceInfo:a,tableServerUrl:t}}catch{return{serviceInfo:a}}}async function I(e){return(0,c.layerLookupMap[e])()}async function L(e,r){return(await i.fetchArcGISServiceJSON(e,{customParameters:r})).tileInfo}async function g(e){if(!e.length)return;const r=new Set,a=[];for(const{type:l}of e)r.has(l)||(r.add(l),a.push(I(n.getLayerModuleType(l))));const t=await Promise.all(a),s=new Map;return Array.from(r).forEach(((e,r)=>{s.set(e,t[r])})),e=>s.get(e.type)}r.fromUrl=S,Object.defineProperty(r,Symbol.toStringTag,{value:"Module"})}));
