/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","exports","../../kernel","../../symbols","../../core/asyncUtils","../../core/Error","../../core/jsonMap","../../core/sql","../../core/uuid","../../core/accessorSupport/extensions/serializableProperty/reader","./CodedValue","./CodedValueDomain","./featureQueryAll","./fieldUtils","./layerUtils","../../renderers/SimpleRenderer","../../renderers/UniqueValueRenderer","../../rest/support/AttachmentQuery","../../rest/support/Query","../../rest/support/RelationshipQuery"],(function(e,t,n,r,a,o,i,s,u,l,c,d,p,y,f,m,h,b,w,g){"use strict";const I=new i.JSONMap({esriGeometryPoint:"point",esriGeometryMultipoint:"multipoint",esriGeometryPolyline:"polyline",esriGeometryPolygon:"polygon",esriGeometryMultiPatch:"multipatch"});async function F(e,t,n,r){const a=await k(e);if(await q(e,t,r),!a.addAttachment)throw new o(r,"Layer source does not support addAttachment capability");return a.addAttachment(t,n)}function q(e,t,n){const{attributes:r}=t,{objectIdField:a}=e;return e.capabilities?.data?.supportsAttachment?t?r?a&&r[a]?Promise.resolve():Promise.reject(new o(n,`feature is missing the identifying attribute ${a}`)):Promise.reject(new o(n,"'attributes' are required on a feature to query attachments")):Promise.reject(new o(n,"A feature is required to add/delete/update attachments")):Promise.reject(new o(n,"this layer doesn't support attachments"))}async function S(e,t,n,r,a){const i=await k(e);if(await q(e,t,a),!i.updateAttachment)throw new o(a,"Layer source does not support updateAttachment capability");return i.updateAttachment(t,n,r)}async function A(t,n,r){const{applyEdits:a}=await new Promise(((t,n)=>e(["../graphics/editingSupport"],t,n))),o=await t.load();let i=r;return"feature"===o.type&&o.infoFor3D&&null!=n.deleteFeatures&&null!=o.globalIdField&&(i={...i,globalIdToObjectId:await W(o,n.deleteFeatures,o.globalIdField)}),a(o,o.source,n,r)}async function O(t,n,r){const{uploadAssets:a}=await new Promise(((t,n)=>e(["../graphics/editingSupport"],t,n))),o=await t.load();return a(o,o.source,n,r)}async function x(e,t,n,r){const a=await k(e);if(await q(e,t,r),!a.deleteAttachments)throw new o(r,"Layer source does not support deleteAttachments capability");return a.deleteAttachments(t,n)}async function j(e,t,n){const r=(await e.load({signal:t?.signal})).source;if(!r.fetchRecomputedExtents)throw new o(n,"Layer source does not support fetchUpdates capability");return r.fetchRecomputedExtents(t)}async function v(e,t,n,r){t=b.from(t),await e.load();const a=e.source,i=e.capabilities;if(!i?.data?.supportsAttachment)throw new o(r,"this layer doesn't support attachments");const{attachmentTypes:s,objectIds:u,globalIds:l,num:c,size:d,start:p,where:y}=t;if(!i?.operations?.supportsQueryAttachments){if(s?.length>0||l?.length>0||d?.length>0||c||p||y)throw new o(r,"when 'capabilities.operations.supportsQueryAttachments' is false, only objectIds is supported",t)}if(!(u?.length||l?.length||y))throw new o(r,"'objectIds', 'globalIds', or 'where' are required to perform attachment query",t);if(!a.queryAttachments)throw new o(r,"Layer source does not support queryAttachments capability",t);return a.queryAttachments(t)}async function P(e,t,n,r){const a=await k(e);if(!a.queryObjectIds)throw new o(r,"Layer source does not support queryObjectIds capability");return a.queryObjectIds(w.from(t)??e.createQuery(),n)}async function C(e,t,n,r){const a=await k(e);if(!a.queryFeatureCount)throw new o(r,"Layer source does not support queryFeatureCount capability");return a.queryFeatureCount(w.from(t)??e.createQuery(),n)}async function E(e,t,n,r){const a=await k(e);if(!a.queryExtent)throw new o(r,"Layer source does not support queryExtent capability");return a.queryExtent(w.from(t)??e.createQuery(),n)}async function R(e,t,n,r){const a=await k(e);if(!a.queryRelatedFeatures)throw new o(r,"Layer source does not support queryRelatedFeatures capability");return a.queryRelatedFeatures(g.from(t),n)}async function L(e,t,n,r){const a=await k(e);if(!a.queryRelatedFeaturesCount)throw new o(r,"Layer source does not support queryRelatedFeaturesCount capability");return a.queryRelatedFeaturesCount(g.from(t),n)}async function D(e){const t=e.source;if(t?.refresh)try{const{dataChanged:n,updates:r}=await t.refresh();if(null!=r&&(e.sourceJSON={...e.sourceJSON,...r},e.read(r,{origin:"service",url:e.parsedUrl})),n)return!0}catch{}if(e.definitionExpression)try{return(await s.parseWhereClause(e.definitionExpression,e.fieldsIndex)).hasDateFunctions}catch{}return!1}function M(e){const t=new w,n=e.capabilities?.data,r=e.capabilities?.query;t.historicMoment=e.historicMoment,t.gdbVersion=e.gdbVersion,t.returnGeometry=!0,r&&(t.compactGeometryEnabled=r.supportsCompactGeometry,t.defaultSpatialReferenceEnabled=r.supportsDefaultSpatialReference),n&&(n.supportsZ&&null!=e.returnZ&&(t.returnZ=e.returnZ),n.supportsM&&null!=e.returnM&&(t.returnM=e.returnM)),t.outFields=["*"];const{timeOffset:a,timeExtent:o}=e;return t.timeExtent=null!=a&&null!=o?o.offset(-a.value,a.unit):o||null,t.multipatchOption="multipatch"===e.geometryType?"xyFootprint":null,t}function T(e){const{globalIdField:t,fields:n}=e;if(t)return t;if(n)for(const r of n)if("esriFieldTypeGlobalID"===r.type)return r.name}function V(e){const{objectIdField:t,fields:n}=e;if(t)return t;if(n)for(const r of n)if("esriFieldTypeOID"===r.type)return r.name}function G(e){return e.currentVersion?e.currentVersion:e.hasOwnProperty("capabilities")||e.hasOwnProperty("drawingInfo")||e.hasOwnProperty("hasAttachments")||e.hasOwnProperty("htmlPopupType")||e.hasOwnProperty("relationships")||e.hasOwnProperty("timeInfo")||e.hasOwnProperty("typeIdField")||e.hasOwnProperty("types")?10:9.3}function Q(e,t){const{subtypes:n,subtypeField:r}=e;if(!t?.attributes||!n?.length||!r)return null;const a=t.attributes[r];return null==a?null:n.find((e=>e.code===a))}function U(e,t){const{fieldsIndex:n,subtypeField:r}=e,{name:a,type:o}=n.get(t)??{};if(!a)return null;if((r&&n.get(r)?.name)===a&&e.subtypes?.length){const t=e.subtypes.map((e=>new c.CodedValue({code:J(e.code,o),name:e.name})));if(t?.length)return new d({codedValues:t})}return null}function N(e,t){const{fieldsIndex:n}=e,{name:r,type:a}=n.get(t)??{};if(!r)return null;if(("typeIdField"in e?n.get(e.typeIdField)?.name:null)===r&&"types"in e&&e.types?.length){const t=e.types.map((e=>new c.CodedValue({code:J(e.id,a),name:e.name})));return new d({codedValues:t})}return null}function J(e,t){return t?y.isStringField({type:t})&&"number"==typeof e?`${e}`:y.isIntegerField({type:t})&&"string"==typeof e?Number.parseInt(e,10):e:e}async function k(e){return(await e.load()).source}async function $(e,t){if(!n.id)return;if(n.id.findCredential(e))return;let r;try{const a=await f.getOwningPortalUrl(e,t);a&&(r=await n.id.checkSignInStatus(`${a}/sharing`))}catch(a){}if(r)try{const r=null!=t?t.signal:null;await n.id.getCredential(e,{signal:r})}catch(a){}}async function Z(e,t,n){const r=e.parsedUrl?.path;r&&e.authenticationTriggerEvent===t&&await $(r,n)}function z(e){return!Y(e)&&(e.userHasUpdateItemPrivileges||e.editingEnabled)}const B=l.createTypeReader({types:r.symbolTypesRenderer});function H(e,t){if(e.defaultSymbol)return e.types?.length?new h({defaultSymbol:B(e.defaultSymbol,e,t),field:e.typeIdField,uniqueValueInfos:e.types.map((e=>({id:e.id,symbol:B(e.symbol,e,t)})))}):new m({symbol:B(e.defaultSymbol,e,t)})}function K(e){let t=e.sourceJSON?.cacheMaxAge;if(!t)return!1;const n=e.editingInfo?.lastEditDate?.getTime();return null==n||(t*=1e3,Date.now()-n<t)}async function W(e,t,n){if(null==t)return null;const r=[],{objectIdField:o}=e;if(t.forEach((e=>{let t=null;if("attributes"in e){const{attributes:r}=e;t={globalId:r[n],objectId:null!=r[o]&&-1!==r[o]?r[o]:null}}else t={globalId:e.globalId,objectId:null!=e.objectId&&-1!==e.objectId?e.objectId:null};null!=t.globalId&&(null!=t.objectId&&-1!==t.objectId||r.push(t.globalId))})),0===r.length)return null;const i=e.createQuery();i.where=r.map((e=>`${n}='${e}'`)).join(" OR "),i.returnGeometry=!1,i.outFields=[o,n],i.cacheHint=!1;const s=await a.resultOrAbort(p.queryAllJSON(e,i));if(!s.ok)return null;const l=new Map,c=s.value.features;for(const a of c){const e=a.attributes[n],t=a.attributes[o];null!=e&&null!=t&&-1!==t&&l.set(u.normalizeGlobalID(e),t)}return l}function X(e,t,n){if(!t||!n||!e)return null;const r=n.getAttribute(t);return null==r?null:e.find((e=>{const{id:t}=e;return null!=t&&t.toString()===r.toString()}))??null}function Y(e){return e.sourceJSON?.isMultiServicesView||_(e)}function _(e){return!!e.sourceJSON?.capabilities?.toLowerCase().split(",").map((e=>e.trim())).includes("map")}function ee(e,t,n){const r=t?.queryBins;if(!r)throw new o(n,"Layer source does not support binning");switch(e.binParameters.type){case"auto-interval":if(!r.supportsAutoInterval)throw new o(n,"Layer source does not support auto-interval binning");break;case"date":if(!r.supportsDate)throw new o(n,"Layer source does not support date binning");break;case"fixed-boundaries":if(!r.supportsFixedBoundaries)throw new o(n,"Layer source does not support fixed-boundaries binning");break;case"fixed-interval":if(!r.supportsFixedInterval)throw new o(n,"Layer source does not support fixed-interval binning")}const a=r?.supportedStatistics;if(e.outStatistics&&a){const t=new Map([["count","count"],["sum","sum"],["min","min"],["max","max"],["avg","avg"],["stddev","stddev"],["var","var"],["percentile-continuous","percentileContinuous"],["percentile-discrete","percentileDiscrete"],["centroid-aggregate","centroid"],["convex-hull-aggregate","convexHull"],["envelope-aggregate","envelope"]]);for(const{statisticType:r}of e.outStatistics){const e=t.get(r);if(e&&!a[e])throw new o(n,`Layer source does not support ${r} statistic type`)}}}t.addAttachment=F,t.applyEdits=A,t.computeDomainFromSubtypes=U,t.computeDomainFromTypes=N,t.computeEffectiveEditingEnabled=z,t.createDefaultRenderer=H,t.createQuery=M,t.deleteAttachments=x,t.ensureCredentialIfSignedIn=$,t.ensureLayerCredential=Z,t.fetchRecomputedExtents=j,t.geometryTypeKebabDict=I,t.getFeatureSubtype=Q,t.getFeatureType=X,t.getGlobalIdToObjectIdMap=W,t.hasDataChanged=D,t.isLayerCacheStale=K,t.queryAttachments=v,t.queryExtent=E,t.queryFeatureCount=C,t.queryObjectIds=P,t.queryRelatedFeatures=R,t.queryRelatedFeaturesCount=L,t.readGlobalIdField=T,t.readObjectIdField=V,t.readVersion=G,t.supportsQueryOnly=Y,t.updateAttachment=S,t.uploadAssets=O,t.validateBinsQuery=ee,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
