/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../core/Error","../../core/object","../../core/SetUtils","../../core/sql","./domainUtils","../../support/arcadeOnDemand"],(function(e,i,n,t,r,l,a){"use strict";const o=/^([0-9_])/,s=/[^a-z0-9_\u0080-\uffff]+/gi;function u(e){if(null==e)return null;return e.trim().replaceAll(s,"_").replace(o,"F$1")||null}const d=["field","field2","field3","normalizationField","rotationInfo.field","proportionalSymbolInfo.field","proportionalSymbolInfo.normalizationField","colorInfo.field","colorInfo.normalizationField"],c=["field","normalizationField"];function f(e,i){if(null!=e&&null!=i)for(const n of Array.isArray(e)?e:[e])if(p(d,n,i),"visualVariables"in n&&n.visualVariables)for(const e of n.visualVariables)p(c,e,i)}function p(e,i,t){if(e)for(const r of e){const e=n.getDeepValue(r,i),l=e&&"function"!=typeof e&&t.get(e);l&&n.setDeepValue(r,l.name,i)}}function m(e,i){if(null!=e&&i?.fields?.length)if("startField"in e){const n=i.get(e.startField),t=i.get(e.endField);e.startField=n?.name??null,e.endField=t?.name??null}else{const n=i.get(e.startTimeField),t=i.get(e.endTimeField);e.startTimeField=n?.name??null,e.endTimeField=t?.name??null}}const g=new Set;function F(e,i){return e&&i?(g.clear(),y(g,e,i),Array.from(g).sort()):[]}function y(e,i,n){if(n)if(i?.fields?.length)if(n.includes("*"))for(const{name:t}of i.fields)e.add(t);else for(const t of n)I(e,i,t);else{if(n.includes("*"))return e.clear(),void e.add("*");for(const i of n)null!=i&&e.add(i)}}function I(e,i,n){if("string"==typeof n)if(i){const t=i.get(n);t&&e.add(t.name)}else e.add(n)}function b(e,i){return null==i||null==e?[]:i.includes("*")?(e.fields??[]).map((e=>e.name)):i}function T(e,i,n=1){if(!i||!e)return[];if(i.includes("*"))return["*"];const t=F(e,i);return t.length/e.fields.length>=n?["*"]:t}async function E(e,i,n){if(!n)return;const{arcadeUtils:t}=await a.loadArcade(),r=t.extractFieldNames(n,i?.fields?.map((e=>e.name)));for(const l of r)I(e,i,l)}async function x(e,n,t){if(t&&"1=1"!==t){const l=await r.parseWhereClause(t,n);if(!l.isStandardized)throw new i("fieldUtils:collectFilterFields","Where clause is not standardized",{where:t});y(e,n,l.fieldNames)}}function w({displayField:e,fields:i}){return e||(i?.length?h(i,"name-or-title")||h(i,"unique-identifier")||h(i,"type-or-category")||N(i):null)}function N(e){for(const i of e){if(!i?.name)continue;const e=i.name.toLowerCase();if(e.includes("name")||e.includes("title"))return i.name}return null}function h(e,i){for(const n of e)if(n?.valueType&&n.valueType===i)return n.name;return null}async function V(e){if(!e)return[];const i=new Set;return await S(i,e),Array.from(i).sort()}async function S(e,i){if(!i)return;const n=i.elevationInfo?.featureExpressionInfo;return n?n.collectRequiredFields(e,i.fieldsIndex):void 0}function A(e,i,n){n.onStatisticExpression?E(e,i,n.onStatisticExpression.expression):e.add(n.onStatisticField)}async function _(e,i,n){if(!i||!n||!("fields"in n))return;const t=[],r=n.popupTemplate;t.push(v(e,i,r)),n.fields&&t.push(...n.fields.map((async n=>A(e,i.fieldsIndex,n)))),await Promise.all(t)}async function v(e,i,n){const t=[];n?.expressionInfos&&t.push(...n.expressionInfos.map((n=>E(e,i.fieldsIndex,n.expression))));const r=n?.content;if(Array.isArray(r))for(const l of r)"expression"===l.type&&l.expressionInfo&&t.push(E(e,i.fieldsIndex,l.expressionInfo.expression));await Promise.all(t)}async function D(e,i,n){i&&(i.timeInfo&&n?.timeExtent&&y(e,i.fieldsIndex,[i.timeInfo.startField,i.timeInfo.endField]),i.floorInfo&&y(e,i.fieldsIndex,[i.floorInfo.floorField]),null!=n?.where&&await x(e,i.fieldsIndex,n.where))}async function R(e,i,n){i&&n&&await Promise.all(n.map((n=>L(e,i,n))))}async function L(e,i,n){i&&n&&(n.valueExpression?await E(e,i.fieldsIndex,n.valueExpression):n.field&&I(e,i.fieldsIndex,n.field))}async function $(e){if(!e)return[];const i="timeInfo"in e&&e.timeInfo;return i?F(e.fieldsIndex,[e.trackIdField,i.startField,i.endField]):[]}function O(e){return e?F(e.fieldsIndex,P(e)):[]}function M(e){if(!e)return[];const i=e.geometryFieldsInfo;return i?F(e.fieldsIndex,[i.shapeAreaField,i.shapeLengthField]):[]}const C=new Set(["oid","global-id","guid"]),U=new Set(["oid","global-id"]),k=[/^fnode_$/i,/^tnode_$/i,/^lpoly_$/i,/^rpoly_$/i,/^poly_$/i,/^shape$/i,/^shape_$/i,/^subclass$/i,/^subclass_$/i,/^rings_ok$/i,/^rings_nok$/i,/perimeter/i,/objectid/i,/_i$/i];function G(e){const i=new Set;j(e).forEach((e=>i.add(e))),M(e).forEach((e=>i.add(e.toLowerCase())));const n=e&&"infoFor3D"in e?e.infoFor3D:void 0;return n&&(Object.values(n.assetMapFieldRoles).forEach((e=>i.add(e.toLowerCase()))),Object.values(n.transformFieldRoles).forEach((e=>i.add(e.toLowerCase())))),Array.from(i)}function P(e){if(!e)return[];const i="editFieldsInfo"in e&&e.editFieldsInfo;if(!i)return[];const{creationDateField:n,creatorField:t,editDateField:r,editorField:l}=i;return[n,t,r,l].filter(Boolean)}function j(e){return P(e).map((e=>e.toLowerCase()))}function z(e,i){return e.editable&&!C.has(e.type)&&!j(i).includes(e.name?.toLowerCase()??"")}function X(e,i){const n=e.name?.toLowerCase()??"";return!(null!=i?.objectIdField&&n===i.objectIdField.toLowerCase()||null!=i?.globalIdField&&n===i.globalIdField.toLowerCase()||G(i).includes(n)||U.has(e.type)||k.some((e=>e.test(n))))}async function B(e){if(!e)return[];const i=new Set;return await q(i,e),Array.from(i).sort()}async function q(e,i){const{labelingInfo:n,fieldsIndex:t}=i;n?.length&&await Promise.all(n.map((i=>J(e,t,i))))}async function J(e,i,n){if(!n)return;const t=n.getLabelExpression(),r=n.where;if("arcade"===t.type)await E(e,i,t.expression);else{const n=t.expression.match(/{[^}]*}/g);n&&n.forEach((n=>{I(e,i,n.slice(1,-1))}))}await x(e,i,r)}function W(e){const i=e.defaultValue;return void 0!==i&&ne(e,i)?i:e.nullable?null:void 0}function Y(e){const i="string"==typeof e?{type:e}:e;return pe(i)?255:"esriFieldTypeDate"===i.type||"date"===i.type?8:void 0}function H(e){return"number"==typeof e&&!isNaN(e)&&isFinite(e)}function K(e){return null===e||H(e)}function Q(e){return null===e||Number.isInteger(e)}function Z(e){return null!=e&&"string"==typeof e}function ee(e){return null===e||Z(e)}function ie(){return!0}function ne(e,i){let n;switch(e.type){case"date":case"integer":case"long":case"small-integer":case"big-integer":case"esriFieldTypeDate":case"esriFieldTypeInteger":case"esriFieldTypeLong":case"esriFieldTypeSmallInteger":case"esriFieldTypeBigInteger":n=e.nullable?Q:Number.isInteger;break;case"double":case"single":case"esriFieldTypeSingle":case"esriFieldTypeDouble":n=e.nullable?K:H;break;case"string":case"esriFieldTypeString":n=e.nullable?ee:Z;break;default:n=ie}return 1===arguments.length?n:n(i)}const te=["integer","small-integer","big-integer"],re=["single","double"],le=[...te,...re],ae=["esriFieldTypeInteger","esriFieldTypeSmallInteger","esriFieldTypeBigInteger"],oe=["esriFieldTypeSingle","esriFieldTypeDouble"],se=new Set([...te,...ae]),ue=new Set([...re,...oe]),de=t.union(se,ue);function ce(e){return null!=e&&se.has(e.type)}function fe(e){return null!=e&&de.has(e.type)}function pe(e){return null!=e&&("string"===e.type||"esriFieldTypeString"===e.type)}function me(e){return null!=e&&("date"===e.type||"esriFieldTypeDate"===e.type)}function ge(e){return null!=e&&("date-only"===e.type||"esriFieldTypeDateOnly"===e.type)}function Fe(e){return null!=e&&("timestamp-offset"===e.type||"esriFieldTypeTimestampOffset"===e.type)}function ye(e){return null!=e&&("time-only"===e.type||"esriFieldTypeTimeOnly"===e.type)}function Ie(e){return null!=e&&("oid"===e.type||"esriFieldTypeOID"===e.type)}function be(e){return null!=e&&("global-id"===e.type||"esriFieldTypeGlobalID"===e.type)}function Te(e,i){return null===xe(e,i)}function Ee(e){return null==e||"number"==typeof e&&isNaN(e)?null:e}function xe(i,n){return null==i||i.nullable&&null===n?null:fe(i)&&!we(i.type,Number(n))?e.NumericRangeValidationError.OUT_OF_RANGE:ne(i,n)?i.domain?l.validateDomainValue(i,n):null:e.TypeValidationError.INVALID_TYPE}function we(e,i){const n="string"==typeof e?he(e):e;if(!n)return!1;const t=n.min,r=n.max;return n.isInteger?Number.isInteger(i)&&i>=t&&i<=r:i>=t&&i<=r}function Ne(e,i){const n=l.getDomainRange(e,i);return n||(fe(e)?he(e.type):void 0)}function he(e){switch(e){case"esriFieldTypeSmallInteger":case"small-integer":return Se;case"esriFieldTypeInteger":case"integer":return Ae;case"esriFieldTypeBigInteger":case"big-integer":return _e;case"esriFieldTypeSingle":case"single":return ve;case"esriFieldTypeDouble":case"double":return De}}function Ve(e){if(!H(e))return null;if(Number.isInteger(e)){if(e>=Se.min&&e<=Se.max)return"esriFieldTypeSmallInteger";if(e>=Ae.min&&e<=Ae.max)return"esriFieldTypeInteger";if(e>=_e.min&&e<=_e.max)return"esriFieldTypeBigInteger"}return e>=ve.min&&e<=ve.max?"esriFieldTypeSingle":"esriFieldTypeDouble"}e.NumericRangeValidationError=void 0,(e.NumericRangeValidationError||(e.NumericRangeValidationError={})).OUT_OF_RANGE="numeric-range-validation-error::out-of-range",e.TypeValidationError=void 0,(e.TypeValidationError||(e.TypeValidationError={})).INVALID_TYPE="type-validation-error::invalid-type";const Se={min:-32768,max:32767,isInteger:!0,rawMin:-32768,rawMax:32767},Ae={min:-2147483648,max:2147483647,isInteger:!0,rawMin:-2147483648,rawMax:2147483647},_e={min:-Number.MAX_SAFE_INTEGER,max:Number.MAX_SAFE_INTEGER,isInteger:!0,rawMin:-Number.MAX_SAFE_INTEGER,rawMax:Number.MAX_SAFE_INTEGER},ve={min:-34e37,max:12e37,isInteger:!1,rawMin:-34e37,rawMax:12e37},De={min:-Number.MAX_VALUE,max:Number.MAX_VALUE,isInteger:!1,rawMin:-Number.MAX_VALUE,rawMax:Number.MAX_VALUE};function Re(i,n,t){switch(i){case l.DomainValidationError.INVALID_CODED_VALUE:return`Value ${t} is not in the coded domain - field: ${n.name}, domain: ${JSON.stringify(n.domain)}`;case l.DomainValidationError.VALUE_OUT_OF_RANGE:return`Value ${t} is out of the range of valid values - field: ${n.name}, domain: ${JSON.stringify(n.domain)}`;case e.TypeValidationError.INVALID_TYPE:return`Value ${t} is not a valid value for the field type - field: ${n.name}, type: ${n.type}, nullable: ${n.nullable}`;case e.NumericRangeValidationError.OUT_OF_RANGE:{const{min:e,max:i}=he(n.type);return`Value ${t} is out of range for the number type - field: ${n.name}, type: ${n.type}, value range is ${e} to ${i}`}}}function Le(e,i){return!$e(e,i,null)}function $e(e,i,n){if(!i?.attributes||!e){if(null!=n)for(const i of e??[])n.add(i);return!0}const t=new Set(Object.keys(i.attributes));let r=!1;for(const l of e)if(!t.has(l)){if(r=!0,null==n)break;n.add(l)}return r}async function Oe(e,i){const n=new Set;for(const t of i)await E(n,e.fieldsIndex,t);return Array.from(n).sort()}function Me(e){return!!e&&["raster.itempixelvalue","raster.servicepixelvalue"].some((i=>e.toLowerCase().startsWith(i)))}async function Ce(e,i){const n=new Set;return e?.collectRequiredFields&&await e.collectRequiredFields(n,i),Array.from(n).sort()}function Ue(e){const i=e?.match(/{[^}]+}/g);return i?i.map((e=>e.slice(1,-1).split(":")[0].trim())):[]}e.bigIntegerRange=_e,e.collectArcadeFieldNames=E,e.collectElevationFields=S,e.collectFeatureReductionFields=_,e.collectField=I,e.collectFields=y,e.collectFilterFields=D,e.collectLabelingFields=q,e.collectOrderByInfos=R,e.collectPopupTemplateFields=v,e.doubleRange=De,e.extractSubstitutionTemplatesFromString=Ue,e.featureHasFields=Le,e.fixFields=F,e.fixRendererFields=f,e.fixTimeInfoFields=m,e.floatJSONTypes=oe,e.floatTypes=re,e.getDisplayFieldName=w,e.getEditTrackingFields=P,e.getElevationFields=V,e.getExpressionFields=Oe,e.getFeatureEditFields=O,e.getFeatureGeometryFields=M,e.getFieldDefaultLength=Y,e.getFieldDefaultValue=W,e.getFieldRange=Ne,e.getLabelingFields=B,e.getLowerCaseDefaultHiddenFields=G,e.getLowerCaseEditTrackingFields=j,e.getNumericTypeForValue=Ve,e.getRendererFields=Ce,e.getTimeFields=$,e.integerJSONTypes=ae,e.integerRange=Ae,e.integerTypes=te,e.isDateField=me,e.isDateOnlyField=ge,e.isFieldEditable=z,e.isFieldVisibleByDefault=X,e.isGlobalIDField=be,e.isIntegerField=ce,e.isNumberInRange=we,e.isNumericField=fe,e.isObjectIDField=Ie,e.isRasterPixelValueField=Me,e.isStringField=pe,e.isTimeOnlyField=ye,e.isTimestampOffsetField=Fe,e.isValidFieldValue=Te,e.isValueMatchingFieldType=ne,e.normalizeFieldName=u,e.numericTypes=le,e.packFields=T,e.populateMissingFields=$e,e.rendererFields=d,e.sanitizeNullFieldValue=Ee,e.singleRange=ve,e.smallIntegerRange=Se,e.unpackFieldNames=b,e.validateFieldValue=xe,e.validationErrorToString=Re,e.visualVariableFields=c,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
