/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../core/Collection","../../core/has","./LayerLoadContext","./lazyLayerLoader","../../portal/PortalItem","../../portal/support/featureCollectionUtils","../../portal/support/portalLayers","../../renderers/support/styleUtils"],(function(e,a,r,y,t,L,i,o,n){"use strict";async function l(e,a,r){if(!a)return;const y=a.map((e=>G(e,r))),t=await Promise.allSettled(y);for(const L of t)"rejected"===L.status||L.value&&e.add(L.value)}const c={ArcGISDimensionLayer:"DimensionLayer",ArcGISFeatureLayer:"FeatureLayer",ArcGISImageServiceLayer:"ImageryLayer",ArcGISMapServiceLayer:"MapImageLayer",ArcGISSceneServiceLayer:"SceneLayer",ArcGISTiledElevationServiceLayer:"ElevationLayer",ArcGISTiledImageServiceLayer:"ImageryTileLayer",ArcGISTiledMapServiceLayer:"TileLayer",BuildingSceneLayer:"BuildingSceneLayer",CatalogLayer:"CatalogLayer",CSV:"CSVLayer",DefaultTileLayer:"TileLayer",GeoJSON:"GeoJSONLayer",GroupLayer:"GroupLayer",IntegratedMesh3DTilesLayer:"IntegratedMesh3DTilesLayer",IntegratedMeshLayer:"IntegratedMeshLayer",KML:"KMLLayer",LineOfSightLayer:"LineOfSightLayer",MediaLayer:"MediaLayer",OGCFeatureLayer:"OGCFeatureLayer",OrientedImageryLayer:"OrientedImageryLayer",PointCloudLayer:"PointCloudLayer",RasterDataLayer:"UnsupportedLayer",VectorTileLayer:"VectorTileLayer",ViewshedLayer:"ViewshedLayer",Voxel:"VoxelLayer",WFS:"WFSLayer",WMS:"WMSLayer",WebTiledLayer:"WebTileLayer"},s={ArcGISTiledElevationServiceLayer:"ElevationLayer",DefaultTileLayer:"ElevationLayer",RasterDataElevationLayer:"UnsupportedLayer"},p={ArcGISFeatureLayer:"FeatureLayer"},u={ArcGISImageServiceLayer:"UnsupportedLayer",ArcGISMapServiceLayer:"UnsupportedLayer",ArcGISSceneServiceLayer:"SceneLayer",ArcGISTiledImageServiceLayer:"ImageryTileLayer",ArcGISTiledMapServiceLayer:"TileLayer",DefaultTileLayer:"TileLayer",OpenStreetMap:"OpenStreetMapLayer",VectorTileLayer:"VectorTileLayer",WMS:"UnsupportedLayer",WebTiledLayer:"WebTileLayer"},S={ArcGISAnnotationLayer:"UnsupportedLayer",ArcGISDimensionLayer:"UnsupportedLayer",ArcGISFeatureLayer:"FeatureLayer",ArcGISImageServiceLayer:"ImageryLayer",ArcGISImageServiceVectorLayer:"ImageryLayer",ArcGISMapServiceLayer:"MapImageLayer",ArcGISStreamLayer:"StreamLayer",ArcGISTiledImageServiceLayer:"ImageryTileLayer",ArcGISTiledMapServiceLayer:"TileLayer",BingMapsAerial:"BingMapsLayer",BingMapsHybrid:"BingMapsLayer",BingMapsRoad:"BingMapsLayer",CatalogLayer:"CatalogLayer",CSV:"CSVLayer",DefaultTileLayer:"TileLayer",GeoJSON:"GeoJSONLayer",GeoRSS:"GeoRSSLayer",GroupLayer:"GroupLayer",KML:"KMLLayer",KnowledgeGraphLayer:"KnowledgeGraphLayer",MediaLayer:"MediaLayer",OGCFeatureLayer:"OGCFeatureLayer",OrientedImageryLayer:"OrientedImageryLayer",SubtypeGroupLayer:"SubtypeGroupLayer",VectorTileLayer:"VectorTileLayer",WFS:"WFSLayer",WMS:"WMSLayer",WebTiledLayer:"WebTileLayer"},d={ArcGISFeatureLayer:"FeatureLayer",SubtypeGroupTable:"UnsupportedLayer"},I={ArcGISImageServiceLayer:"ImageryLayer",ArcGISImageServiceVectorLayer:"ImageryLayer",ArcGISMapServiceLayer:"MapImageLayer",ArcGISTiledImageServiceLayer:"ImageryTileLayer",ArcGISTiledMapServiceLayer:"TileLayer",BingMapsAerial:"BingMapsLayer",BingMapsHybrid:"BingMapsLayer",BingMapsRoad:"BingMapsLayer",DefaultTileLayer:"TileLayer",OpenStreetMap:"OpenStreetMapLayer",VectorTileLayer:"VectorTileLayer",WMS:"WMSLayer",WebTiledLayer:"WebTileLayer"},g={...S,LinkChartLayer:"LinkChartLayer"},M={...d},T={...I};async function G(e,a){return f(await m(e,a),e,a)}async function f(e,a,r){const y=new e;return y.read(a,r.context),"group"===y.type&&("GroupLayer"===a.layerType?await w(y,a,r):b(a)?h(y,a,r.context):A(a)&&await C(y,a,r.context)),await n.loadStyleRenderer(y,r.context),y}async function m(e,a){const r=a.context,n=v(r);let l=e.layerType||e.type;!l&&a?.defaultLayerType&&(l=a.defaultLayerType);const c=n[l];let s=c?t.layerLookupMap[c]:t.layerLookupMap.UnknownLayer;if(b(e)){const a=r?.portal;if(e.itemId){const r=new L({id:e.itemId,portal:a});await r.load();const i=(await o.selectLayerClassPath(r,new y.LayerLoadContext)).className||"UnknownLayer";s=t.layerLookupMap[i]}}else"ArcGISFeatureLayer"===l?i.isMapNotesLayer(e)||i.isMarkupLayer(e)?s=t.layerLookupMap.MapNotesLayer:i.isRouteLayer(e)?s=t.layerLookupMap.RouteLayer:A(e)&&(s=t.layerLookupMap.GroupLayer):e.wmtsInfo?.url&&e.wmtsInfo.layerIdentifier?s=t.layerLookupMap.WMTSLayer:"WFS"===l&&"2.0.0"!==e.wfsInfo?.version&&(s=t.layerLookupMap.UnsupportedLayer);return s()}function A(e){if("ArcGISFeatureLayer"!==e.layerType||b(e))return!1;return(e.featureCollection?.layers?.length??0)>1}function b(e){return"Feature Collection"===e.type}function v(e){let a;switch(e.origin){case"web-scene":switch(e.layerContainerType){case"basemap":a=u;break;case"ground":a=s;break;case"tables":a=p;break;default:a=c}break;case"link-chart":switch(e.layerContainerType){case"basemap":a=T;break;case"tables":a=M;break;default:a=g}break;default:switch(e.layerContainerType){case"basemap":a=I;break;case"tables":a=d;break;default:a=S}}return a}async function w(e,r,y){const t=new a,L=l(t,Array.isArray(r.layers)?r.layers:[],y);try{try{if(await L,"group"===e.type)return e.layers.addMany(t),e}catch(i){e.destroy();for(const e of t)e.destroy();throw i}}catch(i){throw i}}function h(e,a,r){a.itemId&&(e.portalItem=new L({id:a.itemId,portal:r?.portal}),e.when((()=>{const y=y=>{const t=y.layerId;k(y,e,a,t,r);const L=a.featureCollection?.layers?.[t];L&&y.read(L,r)};e.layers?.forEach(y),e.tables?.forEach(y)})))}async function C(e,a,r){const y=t.layerLookupMap.FeatureLayer,L=await y(),i=a.featureCollection,o=i?.showLegend,n=i?.layers?.map(((y,t)=>{const i=new L;i.read(y,r);const n={...r,ignoreDefaults:!0};return k(i,e,a,t,n),null!=o&&i.read({showLegend:o},n),i}));e.layers.addMany(n??[])}function k(e,a,r,y,t){e.read({id:`${a.id}-sublayer-${y}`,visibility:r.visibleLayers?.includes(y)??!0},t)}e.populateGroupLayer=w,e.populateOperationalLayers=l,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
