/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../geometry","../../../request","../../../core/Error","../../../core/JSONSupport","../../../core/Logger","../../../core/promiseUtils","../../../core/accessorSupport/decorators/property","../../../core/accessorSupport/ensureType","../../../core/RandomLCG","../../../core/has","../../../core/accessorSupport/decorators/subclass","../arcgisLayerUrl","../commonProperties","../DimensionalDefinition","../LOD","../RasterStorageInfo","../TileInfo","./multidimensionalUtils","./RawBlockCache","../rasterFormats/pixelRangeUtils","../rasterFormats/RasterCodec","../rasterFunctions/pixelUtils","../rasterFunctions/rasterProjectionHelper","../rasterFunctions/vectorFieldUtils","../../../views/support/QueueProcessor","../../../geometry/Point","../../../geometry/Extent","../../../geometry/SpatialReference"],(function(e,t,i,o,r,n,s,l,a,c,u,f,h,p,m,d,x,y,g,I,R,S,w,k,_,T,v,b,P){"use strict";const B=8,W=256;let M=0,C=class extends r.JSONSupport{constructor(){super(...arguments),this._tileFetchQueue=new T.QueueProcessor({concurrency:32,process:(e,t)=>this._fetchRawTile(e.pyramidLevel,e.row,e.col,{...e.options,signal:t})}),this.datasetName=null,this.datasetFormat=null,this.hasUniqueSourceStorageInfo=!0,this.rasterInfo=null,this.ioConfig={sampling:"closest"}}normalizeCtorArgs(e){return e?.ioConfig&&(e={...e,ioConfig:{resolution:null,bandIds:null,sampling:"closest",tileInfo:y.create(),...e.ioConfig}}),e}get _isGlobalWrappableSource(){const{rasterInfo:e}=this,t=k.getWorldWidth(e.spatialReference);return null!=t&&e.extent.width>=t/2}get _hasNoneOrGCSShiftTransform(){const{transform:e}=this.rasterInfo;return null==e||"gcs-shift"===e.type}set rasterJobHandler(e){this._set("rasterJobHandler",e),"Function"===this.datasetFormat&&this.primaryRasters?.rasters?.forEach((t=>t.rasterJobHandler=e))}get rasterId(){return this.url||"rasterId-"+M++}set url(e){this._set("url",h.sanitizeUrl(e,n.getLogger(this)))}async open(e){return this._openPromise??=k.load().then((()=>this._open(e))),this._openPromise}async fetchTile(e,t,i,o={}){const r=o.tileInfo||this.rasterInfo.storageInfo.tileInfo,n=this.getTileExtentFromTileInfo(e,t,i,r);return o={noClip:!0,...o},this.fetchPixels(n,r.size[0],r.size[1],o)}async identify(e,t={}){e=a.ensureClass(v,e).clone().normalize();const{multidimensionalDefinition:i,timeExtent:o}=t,{rasterInfo:r}=this,{hasMultidimensionalTranspose:n,multidimensionalInfo:s}=r;let{transposedVariableName:l}=t;const c=null!=s&&n&&(null!=o||g.isMultiSliceOrRangeDefinition(i));if(c&&!l){l=null!=i&&i.length>0?i[0].variableName??void 0:s.variables[0].name,t={...t,transposedVariableName:l}}t=this._getRequestOptionsWithSliceId(t);const{spatialReference:u,extent:f}=r,{datumTransformation:h}=t;let p=k.projectPoint(e,u,h);if(!f.intersects(p))return{location:p,value:null};if(null!=r.transform){const e=r.transform.inverseTransform(p);if(!r.nativeExtent.intersects(e))return{location:e,value:null};p=e}let m=0;const d=null!=l&&null!=s&&r.hasMultidimensionalTranspose;if("Function"===this.datasetFormat){const e=this.primaryRasters.rasters[0];if(d)return e.identify(p,t);const{pixelSize:o}=r,n=3,s=o.x*n/2,l=o.y*n/2,a=new b({xmin:p.x-s,xmax:p.x+s,ymin:p.y-l,ymax:p.y+l,spatialReference:u}),c={interpolation:"nearest",multidimensionalDefinition:i,sliceId:t.sliceId},{pixelBlock:f}=await e.fetchPixels(a,n,n,c),{pixelBlock:h}=await this.fetchPixels(a,n,n,c);if(null==f)return{location:p,value:null};const m=Math.floor(n*n*.5),x=!f.mask||f.mask[m]?f.pixels.map((e=>e[m])):null;let y;return null!=h&&(y=!h.mask||h.mask[m]?h.pixels.map((e=>e[m])):void 0),{location:p,value:x,processedValue:y,pyramidLevel:0}}if(!d)if(t.srcResolution){m=k.snapPyramid(t.srcResolution,r,this.ioConfig.sampling).pyramidLevel}else if(m=await this.computeBestPyramidLevelForLocation(e,t),null==m)return{location:p,value:null};const x=this.identifyPixelLocation(p,m,null,d);if(null===x)return{location:p,value:null};const{row:y,col:R,rowOffset:S,colOffset:w,blockWidth:_}=x,T=l??t.sliceId,P=I.getRasterId(this.rasterId,T),B=`${m}/${y}/${R}`;let W=I.getBlock(P,null,B);null==W&&(W=this.fetchRawTile(m,y,R,t),I.putBlock(P,null,B,W));const M=await W;if(!M?.pixels?.length)return{location:p,value:null};const C=S*_+w;return this._processIdentifyResult(M,{srcLocation:p,position:C,pyramidLevel:m,useTransposedTile:!!d,requestSomeSlices:c,identifyOptions:t})}async fetchPixels(e,t,i,o={}){e=k.shiftExtent(e),o=this._getRequestOptionsWithSliceId(o);const{_hasNoneOrGCSShiftTransform:r}=this;if(o.requestRawData&&r)return this._fetchPixels(e,t,i,o);const n=k.getWorldWidth(e.spatialReference),s=k.getWorldWrapCount(e);if(null==n||0===s||1===s&&this._isGlobalWrappableSource&&r)return this._fetchPixels(e,t,i,o);if(s>=3)return{extent:e,pixelBlock:null};const l=[],{xmin:a,xmax:c}=e,u=Math.round(n/(c-a)*t),f=u-Math.round((n/2-a)/(c-a)*t);let h=0;const p=[];for(let y=0;y<=s;y++){const r=new b({xmin:0===y?a:-n/2,xmax:y===s?c-n*y:n/2,ymin:e.ymin,ymax:e.ymax,spatialReference:e.spatialReference}),m=0===y?u-f:y===s?t-h:u;h+=m,p.push(m);const d=o.disableWrapAround&&y>0?null:this._fetchPixels(r,m,i,o);l.push(d)}const m=(await Promise.all(l)).map((e=>e?.pixelBlock));let d=null;const x={width:t,height:i};if(this.rasterJobHandler){d=(await this.rasterJobHandler.mosaicAndTransform({srcPixelBlocks:m,srcMosaicSize:x,destDimension:null,coefs:null,sampleSpacing:null,interpolation:"nearest",alignmentInfo:null,blockWidths:p},o)).pixelBlock}else d=w.mosaic(m,x,{blockWidths:p});return{extent:e,srcExtent:k.projectExtent(e,this.rasterInfo.spatialReference,o.datumTransformation),pixelBlock:d}}async fetchRawPixels(e,t,i,o={}){t={x:Math.floor(t.x),y:Math.floor(t.y)};const r=await this._fetchRawTiles(e,t,i,o),{nativeExtent:n,nativePixelSize:s,storageInfo:l}=this.rasterInfo,a=2**e,c=s.x*a,u=s.y*a,f=new b({xmin:n.xmin+c*t.x,xmax:n.xmin+c*(t.x+i.width-1),ymin:n.ymax-u*(t.y+i.height-1),ymax:n.ymax-u*t.y,spatialReference:n.spatialReference});if(!r)return{extent:f,srcExtent:f,pixelBlock:null};const{pixelBlocks:h,mosaicSize:p}=r;if(1===h.length&&null!=h[0]&&h[0].width===i.width&&h[0].height===i.height)return{extent:f,srcExtent:f,pixelBlock:r.pixelBlocks[0]};const m=e>0?l.pyramidBlockWidth:l.blockWidth,d=e>0?l.pyramidBlockHeight:l.blockHeight,x={x:t.x%m,y:t.y%d};let y;if(this.rasterJobHandler){y=(await this.rasterJobHandler.mosaicAndTransform({srcPixelBlocks:h,srcMosaicSize:p,destDimension:i,clipOffset:x,clipSize:i,coefs:null,sampleSpacing:null,interpolation:o.interpolation,alignmentInfo:null,blockWidths:null},o)).pixelBlock}else y=w.mosaic(h,p,{clipOffset:x,clipSize:i});return{extent:f,srcExtent:f,pixelBlock:y}}fetchRawTile(e,t,i,r){throw new o("BaseRaster:read-not-implemented","fetchRawTile() is not implemented")}computeExtent(e){return k.projectExtent(this.rasterInfo.extent,e)}decodePixelBlock(e,t){return!this.rasterJobHandler||t.useCanvas?S.decode(e,t):this.rasterJobHandler.decode({data:e,options:t})}async request(e,t,o=0){const{customFetchParameters:r}=this.ioConfig,{range:n,query:s,headers:l}=t;o=o??t.retryCount??this.ioConfig.retryCount;const a=n?{Range:`bytes=${n.from}-${n.to}`}:null;try{return await i(e,{...t,query:{...s,...r},headers:{...l,...a}})}catch(c){if(o>0)return o--,this.request(e,t,o);throw c}}getSliceIndex(e){const{multidimensionalInfo:t}=this.rasterInfo;return null==t||null==e||0===e.length?null:g.getSliceIndex(e,t)}getTileExtentFromTileInfo(e,t,i,o){const r=o.lodAt(e);return this.getTileExtent({x:r.resolution,y:r.resolution},t,i,o.origin,o.spatialReference,o.size)}updateTileInfo(){const{storageInfo:e,spatialReference:t,extent:i,pixelSize:o}=this.rasterInfo,{pyramidResolutions:r}=e;if(!e.tileInfo){const n=[],s=e.maximumPyramidLevel||0;let l=(o.x+o.y)/2,a=1/.0254*96*l;for(let e=0;e<=s&&(n.unshift(new d({level:s-e,resolution:l,scale:a})),e!==s);e++)if(r){const t=(r[e].x+r[e].y)/2;a*=t/l,l=t}else l*=2,a*=2;const c=new v({x:i.xmin,y:i.ymax,spatialReference:t});e.tileInfo=new y({origin:c,size:[e.blockWidth,e.blockHeight],spatialReference:t,lods:n}),e.isVirtualTileInfo=!0}}createRemoteDatasetStorageInfo(e,t=512,i=512,o){const{width:r,height:n,nativeExtent:s,pixelSize:l,spatialReference:a}=e,c=new v({x:s.xmin,y:s.ymax,spatialReference:a});null==o&&(o=Math.max(0,Math.round(Math.log(Math.max(r,n))/Math.LN2-8)));const u=this.computeBlockBoundary(s,512,512,{x:s.xmin,y:s.ymax},[l],o);e.storageInfo=new x({blockWidth:t,blockHeight:i,pyramidBlockWidth:t,pyramidBlockHeight:i,origin:c,firstPyramidLevel:1,maximumPyramidLevel:o,blockBoundary:u})}async computeBestPyramidLevelForLocation(e,t={}){return 0}computeBlockBoundary(e,t,i,o,r,n=0,s=2){if(1===r.length&&n>0){r=[...r];let{x:e,y:t}=r[0];for(let i=0;i<n;i++)e*=s,t*=s,r.push({x:e,y:t})}const l=[],{x:a,y:c}=o;for(let u=0;u<r.length;u++){const{x:o,y:n}=r[u];l.push({minCol:Math.floor((e.xmin-a+.1*o)/t/o),maxCol:Math.floor((e.xmax-a-.1*o)/t/o),minRow:Math.floor((c-e.ymax+.1*n)/i/n),maxRow:Math.floor((c-e.ymin-.1*n)/i/n)})}return l}getPyramidPixelSize(e){const{nativePixelSize:t}=this.rasterInfo,{pyramidResolutions:i,pyramidScalingFactor:o}=this.rasterInfo.storageInfo;if(0===e)return t;if(null!=i&&i.length)return i[e-1];const r=o**e;return{x:t.x*r,y:t.y*r}}identifyPixelLocation(e,t,i,o){const{spatialReference:r,nativeExtent:n,storageInfo:s}=this.rasterInfo,{maximumPyramidLevel:l,origin:a,transposeInfo:c}=s,u=o&&null!=c?c.tileSize[0]:s.blockWidth,f=o&&null!=c?c.tileSize[1]:s.blockHeight,h=k.projectPoint(e,r,i);if(!n.intersects(h))return null;if(t<0||t>l)return null;const p=this.getPyramidPixelSize(t),{x:m,y:d}=p,x=(a.y-h.y)/d/f,y=(h.x-a.x)/m/u,g=Math.min(f-1,Math.floor((x-Math.floor(x))*f)),I=Math.min(u-1,Math.floor((y-Math.floor(y))*u));return{pyramidLevel:t,row:Math.floor(x),col:Math.floor(y),rowOffset:g,colOffset:I,blockWidth:u,srcLocation:h}}getTileExtent(e,t,i,o,r,n){const[s,l]=n,a=o.x+i*s*e.x,c=a+s*e.x,u=o.y-t*l*e.y,f=u-l*e.y;return new b({xmin:a,xmax:c,ymin:f,ymax:u,spatialReference:r})}getBlockWidthHeight(e){return{blockWidth:e>0?this.rasterInfo.storageInfo.pyramidBlockWidth:this.rasterInfo.storageInfo.blockWidth,blockHeight:e>0?this.rasterInfo.storageInfo.pyramidBlockHeight:this.rasterInfo.storageInfo.blockHeight}}isBlockOutside(e,t,i){const o=this.rasterInfo.storageInfo.blockBoundary[e];return!o||o.maxRow<t||o.maxCol<i||o.minRow>t||o.minCol>i}updateImageSpaceRasterInfo(e){const{pixelSize:t}=e,{width:i,height:o}=e,r=P.WebMercator;e.spatialReference=r,e.extent=e.nativeExtent=new b({xmin:-.5,ymax:.5,xmax:i-.5,ymin:.5-o,spatialReference:r}),e.isPseudoSpatialReference=!0,e.transform=null,e.pixelSize=new v({x:1,y:1,spatialReference:r});const{extent:n,storageInfo:s}=e;if(s){s.origin=new v({x:n.xmin,y:n.ymax,spatialReference:r});const{pyramidResolutions:i,tileInfo:o}=s;if(i&&i.forEach((e=>{e.x/=t.x,e.y/=t.y})),o){o.origin=s.origin;const t=(e.nativePixelSize.x+e.nativePixelSize.y)/2;o.lods.forEach(((e,i)=>{e.resolution=t*2**i,e.scale=96*e.resolution/.0254}))}}}async _fetchPixels(e,t,i,o={}){let r=k.getWorldWrapCount(e);if(r>=2)return{extent:e,pixelBlock:null};const n=this._getSourceDataInfo(e,t,i,o),{pyramidLevel:s,srcResolution:l,srcExtent:a,srcWidth:c,srcHeight:u,ul:f}=n;if(0===c||0===u)return{extent:e,srcExtent:a,pixelBlock:null};const{rasterInfo:h}=this,p=h.transform,m="gcs-shift"===p?.type,d=null!=k.getWorldWidth(e.spatialReference);!m&&d||(r=k.getWorldWrapCount(n.srcExtent,m));const x=await this._fetchRawTiles(s,f,{width:c,height:u,wrapCount:r},o);if(!x)return{extent:e,srcExtent:a,pixelBlock:null};const y=h.storageInfo,g=s>0?y.pyramidBlockWidth:y.blockWidth,I=s>0?y.pyramidBlockHeight:y.blockHeight;let{x:R,y:S}=h.pixelSize;if(s>0){const{pyramidResolutions:e,pyramidScalingFactor:t}=y;if(null!=e&&e[s-1])({x:R,y:S}=e[s-1]);else{const e=t**s;R*=e,S*=e}}const T=h.spatialReference,b=new v({x:R,y:S,spatialReference:T}),P=g===c&&I===u&&f.x%g==0&&f.y%I==0,B=new v({x:(e.xmax-e.xmin)/t,y:(e.ymax-e.ymin)/i,spatialReference:e.spatialReference}),W=!e.spatialReference.equals(T),M=T.isGeographic?1e-9:1e-4,{datumTransformation:C}=o;if(!W&&P&&1===x.pixelBlocks.length&&g===t&&I===i&&E(l,B,M))return{extent:e,srcExtent:a,srcTilePixelSize:b,pixelBlock:x.pixelBlocks[0]};const z=d&&null!=k.getWorldWidth(a.spatialReference)&&this._hasNoneOrGCSShiftTransform,L=o.requestProjectedLocalDirections&&this.rasterInfo.dataType.startsWith("vector");L&&!this.rasterJobHandler&&await k.load();const H=this.rasterJobHandler?await this.rasterJobHandler.getProjectionOffsetGrid({projectedExtent:e,srcBufferExtent:x.extent,pixelSize:B.toJSON(),datumTransformation:C,rasterTransform:p,hasWrapAround:r>0||z,isAdaptive:!1!==this.ioConfig.optimizeProjectionAccuracy,includeGCSGrid:L},o):k.getProjectionOffsetGrid({projectedExtent:e,srcBufferExtent:x.extent,pixelSize:B,datumTransformation:C,rasterTransform:p,hasWrapAround:r>0||z,isAdaptive:!1,includeGCSGrid:L});let D;const O=!o.requestRawData,F={rows:H.spacing[0],cols:H.spacing[1]},A=this._hasNoneOrGCSShiftTransform?this._getRasterTileAlignmentInfo(s,x.extent.xmin):void 0,{pixelBlocks:G,mosaicSize:N,isPartiallyFilled:q}=x;let J=null;if(this.rasterJobHandler){const e=await this.rasterJobHandler.mosaicAndTransform({srcPixelBlocks:G,srcMosaicSize:N,destDimension:O?{width:t,height:i}:null,coefs:O?H.coefficients:null,sampleSpacing:O?F:null,projectDirections:L,gcsGrid:L?H.gcsGrid:null,isUV:"vector-uv"===this.rasterInfo.dataType,interpolation:o.interpolation,alignmentInfo:A,blockWidths:null},o);({pixelBlock:D,localNorthDirections:J}=e)}else{const e=w.mosaic(G,N,{alignmentInfo:A});D=O?w.approximateTransform(e,{width:t,height:i},H.coefficients,F,o.interpolation):e,L&&H.gcsGrid&&(J=w.getLocalArithmeticNorthRotations({width:t,height:i},H.gcsGrid),D=_.convertToLocalDirections(D,this.rasterInfo.dataType,J))}return o.requestRawData||L?{extent:e,srcExtent:a,srcTilePixelSize:b,pixelBlock:D,transformGrid:H,localNorthDirections:J,isPartiallyFilled:q}:{extent:e,srcExtent:a,srcTilePixelSize:b,pixelBlock:D}}async _fetchRawTiles(e,t,i,o){const{origin:r,blockBoundary:n}=this.rasterInfo.storageInfo,{blockWidth:s,blockHeight:l}=this.getBlockWidthHeight(e);let{x:a,y:c}=t,{width:u,height:f,wrapCount:h}=i;const p=this._getRasterTileAlignmentInfo(e,0);o.buffer&&(a-=o.buffer.cols,c-=o.buffer.rows,u+=2*o.buffer.cols,f+=2*o.buffer.rows);let m=0,d=0,x=0;if(h&&null!=p){({worldColumnCountFromOrigin:d,originColumnOffset:x,rightPadding:m}=p);d*p.blockWidth-m>=a+u&&(m=0)}const y=Math.floor(a/s),g=Math.floor(c/l),I=Math.floor((a+u+m-1)/s),R=Math.floor((c+f+m-1)/l),S=n[e];if(!S)return null;const{minRow:w,minCol:k,maxCol:_,maxRow:T}=S;if(0===h&&(R<w||I<k||g>T||y>_))return null;const v=new Array;let P=!1;const B=null==this.ioConfig.allowPartialFill?o.allowPartialFill:this.ioConfig.allowPartialFill;for(let b=g;b<=R;b++)for(let t=y;t<=I;t++){let i=t;if(!o.disableWrapAround&&h&&null!=p&&d<=t&&(i=t-d-x),b>=w&&i>=k&&T>=b&&_>=i){const t=this._tileFetchQueue.push({pyramidLevel:e,row:b,col:i,options:o},{signal:o.signal});B?v.push(new Promise((e=>{t.then((t=>e(t))).catch((()=>{P=!0,e(null)}))}))):v.push(t)}else v.push(Promise.resolve(null))}if(0===v.length)return null;const W=await Promise.all(v),M={height:(R-g+1)*l,width:(I-y+1)*s},{spatialReference:C}=this.rasterInfo,E=this.getPyramidPixelSize(e),{x:z,y:L}=E;return{extent:new b({xmin:r.x+y*s*z,xmax:r.x+(I+1)*s*z,ymin:r.y-(R+1)*l*L,ymax:r.y-g*l*L,spatialReference:C}),pixelBlocks:W,mosaicSize:M,isPartiallyFilled:P}}_fetchRawTile(e,t,i,o){const r=this.rasterInfo.storageInfo.blockBoundary[e];if(!r)return Promise.resolve(null);const{minRow:n,minCol:l,maxCol:a,maxRow:c}=r;if(t<n||i<l||t>c||i>a)return Promise.resolve(null);const u=I.getRasterId(this.rasterId,o.sliceId),f=`${e}/${t}/${i}`;let h=I.getBlock(u,o.registryId,f);if(null==h){const r=new AbortController;h=this.fetchRawTile(e,t,i,{...o,signal:r.signal}),I.putBlock(u,o.registryId,f,h,r),h.catch((()=>I.deleteBlock(u,o.registryId,f)))}return o.signal&&s.onAbort(o,(()=>{I.decreaseRefCount(u,o.registryId,f)})),h}_computeMagDirValues(e){const{bandCount:t,dataType:i}=this.rasterInfo;if(!(2===t&&"vector-magdir"===i||"vector-uv"===i)||2!==e?.length||!e[0]?.length)return null;const o=e[0].length;if("vector-magdir"===i){const t=e[1].map((e=>(e+360)%360));return[e[0],t]}const[r,n]=e,s=[],l=[];for(let a=0;a<o;a++){const[e,t]=_.uvComponentToVector([r[a],n[a]]);s.push(e),l.push(t)}return[s,l]}_getRasterTileAlignmentInfo(e,t){return null==this._rasterTileAlignmentInfo&&(this._rasterTileAlignmentInfo=k.getRasterDatasetAlignmentInfo(this.rasterInfo)),null==this._rasterTileAlignmentInfo.pyramidsInfo?null:{startX:t,halfWorldWidth:this._rasterTileAlignmentInfo.halfWorldWidth,hasGCSSShiftTransform:this._rasterTileAlignmentInfo.hasGCSSShiftTransform,...this._rasterTileAlignmentInfo.pyramidsInfo[e]}}_getSourceDataInfo(e,t,i,o={}){const r={datumTransformation:o.datumTransformation,pyramidLevel:0,pyramidResolution:null,srcExtent:null,srcHeight:0,srcResolution:null,srcWidth:0,ul:{x:0,y:0}};o.srcResolution&&(r.srcResolution=o.srcResolution,this._updateSourceDataInfo(e,r));const n=this.rasterInfo.storageInfo.maximumPyramidLevel||0,{srcWidth:s,srcHeight:l,pyramidLevel:a}=r,c=s/t,u=l/i,f=a<n&&c*u>=16,h=a===n&&this._requireTooManySrcTiles(s,l,t,i);if(f||h||(0===s||0===l)){const s=new v({x:(e.xmax-e.xmin)/t,y:(e.ymax-e.ymin)/i,spatialReference:e.spatialReference});let l=k.projectResolution(s,this.rasterInfo.spatialReference,e,r.datumTransformation);const h=!l||o.srcResolution&&l.x+l.y<o.srcResolution.x+o.srcResolution.y;if(f&&o.srcResolution&&h){const e=Math.round(Math.log(Math.max(c,u))/Math.LN2)-1;if(n-a+3>=e){const t=2**e;l={x:o.srcResolution.x*t,y:o.srcResolution.y*t}}}l&&(r.srcResolution=l,this._updateSourceDataInfo(e,r))}return this._requireTooManySrcTiles(r.srcWidth,r.srcHeight,t,i)&&(r.srcWidth=0,r.srcHeight=0),r}_requireTooManySrcTiles(e,t,i,o){const{tileInfo:r}=this.rasterInfo.storageInfo,n=Math.ceil(e/r.size[0])*Math.ceil(t/r.size[1]),s=e/i,l=t/o,a=Math.max(1,(i+o)/1024);return n>=W*a||s>B||l>B}_updateSourceDataInfo(e,t){t.srcWidth=0,t.srcHeight=0;const{rasterInfo:i}=this,o=i.spatialReference,{srcResolution:r,datumTransformation:n}=t,{pyramidLevel:s,pyramidResolution:l,excessiveReading:a}=k.snapPyramid(r,i,this.ioConfig.sampling);if(a)return;let c=t.srcExtent||k.projectExtent(e,o,n);if(null==c)return;const u=i.transform;u&&(c=u.inverseTransform(c)),t.srcExtent=c;const{x:f,y:h}=i.storageInfo.origin,p=Math.floor((c.xmin-f)/l.x+.1),m=Math.floor((h-c.ymax)/l.y+.1),d=Math.floor((c.xmax-f)/l.x-.1),x=Math.floor((h-c.ymin)/l.y-.1),y=c.width<.1*l.x?0:d-p+1,g=c.height<.1*l.y?0:x-m+1;t.pyramidLevel=s,t.pyramidResolution=l,t.srcWidth=y,t.srcHeight=g,t.ul={x:p,y:m}}_getRequestOptionsWithSliceId(e){return null!=this.rasterInfo.multidimensionalInfo&&null==e.sliceId&&(e={...e,sliceId:this.getSliceIndex(e.multidimensionalDefinition)}),e}_processIdentifyResult(e,t){const{srcLocation:i,position:o,pyramidLevel:r,useTransposedTile:n}=t,s=e.pixels[0].length/e.width/e.height;if(!(!e.mask||e.mask[o]))return{location:i,value:null};const{multidimensionalInfo:l}=this.rasterInfo;if(null==l||!n){const t=e.pixels.map((e=>e[o])),n={location:i,value:t,pyramidLevel:r},s=this._computeMagDirValues(t.map((e=>[e])));return s?.length&&(n.magdirValue=s.map((e=>e[0]))),n}let a=e.pixels.map((e=>e.slice(o*s,o*s+s))),c=this._computeMagDirValues(a);const{requestSomeSlices:u,identifyOptions:f}=t;let h=g.createSlices(l,f.transposedVariableName);if(u){const e=g.getSliceIds(h,f.multidimensionalDefinition,f.timeExtent);a=a.map((t=>e.map((e=>t[e])))),c=c?.map((t=>e.map((e=>t[e])))),h=e.map((e=>h[e]))}const p=e.noDataValues||this.rasterInfo.noDataValue,d={pixels:a,pixelType:e.pixelType};let x;null!=p&&(R.convertNoDataToMask(d,p),x=d.mask);return{location:i,value:null,dataSeries:h.map(((e,t)=>{const i={value:0===x?.[t]?null:a.map((e=>e[t])),multidimensionalDefinition:e.multidimensionalDefinition.map((e=>new m({...e,isSlice:!0})))};return c?.length&&(i.magdirValue=[c[0][t],c[1][t]]),i})),pyramidLevel:r}}};function E(e,t,i){return Math.abs(e.x-t.x)<i&&Math.abs(e.y-t.y)<i}e.__decorate([l.property()],C.prototype,"_rasterTileAlignmentInfo",void 0),e.__decorate([l.property()],C.prototype,"_tileFetchQueue",void 0),e.__decorate([l.property({readOnly:!0})],C.prototype,"_isGlobalWrappableSource",null),e.__decorate([l.property({readOnly:!0})],C.prototype,"_hasNoneOrGCSShiftTransform",null),e.__decorate([l.property()],C.prototype,"_openPromise",void 0),e.__decorate([l.property()],C.prototype,"rasterJobHandler",null),e.__decorate([l.property({readOnly:!0})],C.prototype,"rasterId",null),e.__decorate([l.property(p.url)],C.prototype,"url",null),e.__decorate([l.property({type:String,json:{write:!0}})],C.prototype,"datasetName",void 0),e.__decorate([l.property({type:String,json:{write:!0}})],C.prototype,"datasetFormat",void 0),e.__decorate([l.property()],C.prototype,"hasUniqueSourceStorageInfo",void 0),e.__decorate([l.property()],C.prototype,"rasterInfo",void 0),e.__decorate([l.property()],C.prototype,"ioConfig",void 0),e.__decorate([l.property()],C.prototype,"sourceJSON",void 0),C=e.__decorate([f.subclass("esri.layers.support.rasterDatasets.BaseRaster")],C);return C}));
