/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../../../chunks/tslib.es6","../../../core/Error","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/Logger","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../../geometry/Polygon","./BaseRaster","../rasterFunctions/clipUtils","../rasterFunctions/pixelUtils","../rasterFunctions/rasterProjectionHelper","../../../rest/support/FeatureSet"],(function(e,t,r,s,i,n,a,o,c,l,p,u,h,m){"use strict";const y=40;let d=class extends l{constructor(){super(...arguments),this.datasetFormat="Function",this.tileType="Raster",this.rasterFunction=null,this._clippingGeometry=new Map}async fetchPixels(e,t,r,s={}){const{rasters:i,rasterIds:n}=this.primaryRasters;let a=!1;const{interpolation:o}=s,c=this.rasterFunction.flatWebGLFunctionChain?.hasFocalFunction;!s.requestRawData&&c&&(a=1===i.length&&!s.skipRasterFunction,s={...s,interpolation:"bilinear",requestRawData:a});const l=i.map((i=>i.fetchPixels(e,t,r,s))),h=await Promise.all(l),m=h.map((e=>e.pixelBlock)),y=a||s.requestRawData?h.map((e=>e.srcTilePixelSize)):null;if(s.skipRasterFunction||m.every((e=>null==e)))return h[0];const d=h.find((e=>null!=e.pixelBlock))?.extent??e;let f=this.rasterJobHandler?await this.rasterJobHandler.process({extent:d,primaryPixelBlocks:m,primaryPixelSizes:y,primaryRasterIds:n}):this.rasterFunction.process({extent:d,primaryPixelBlocks:m,primaryPixelSizes:y,primaryRasterIds:n});const{transformGrid:g}=h[0];if(!a||null==f||null==g){const e=s.noClip?null:this.getClippingGeometry(d.spatialReference);return s.noClip||s.requestRawData||null==f||!e||(f=await p.clip(f,d,e)),{...h[0],pixelBlock:f}}const x={rows:g.spacing[0],cols:g.spacing[1]};let R;if(this.rasterJobHandler){R=(await this.rasterJobHandler.mosaicAndTransform({srcPixelBlocks:[f],srcMosaicSize:{width:f.width,height:f.height},destDimension:{width:t,height:r},coefs:g.coefficients,sampleSpacing:x,projectDirections:!1,gcsGrid:null,isUV:!1,interpolation:o,alignmentInfo:void 0,blockWidths:null},s)).pixelBlock}else R=u.approximateTransform(f,{width:t,height:r},g.coefficients,x,o);const w=s.noClip?null:this.getClippingGeometry(e.spatialReference);return s.noClip||s.requestRawData||null==R||null==w||(R=await p.clip(R,e,w)),{extent:e,srcExtent:h[0].srcExtent,pixelBlock:R}}getClippingGeometry(e){const t=this._clippingGeometry.get("0");if(!e||!t)return t;const r=g(e);let s=this._clippingGeometry.get(r);return null!=s||(s=e.equals(t.spatialReference)?t:h.projectPolygon(t,e),this._clippingGeometry.set(r,s)),s}async _open(e){const{rasterFunction:t}=this;this.primaryRasters?.rasters?.length?t.sourceRasters=this.primaryRasters.rasters:(this.primaryRasters=t.getPrimaryRasters(),this.rasterJobHandler&&this.primaryRasters.rasters?.forEach((e=>e.rasterJobHandler=this.rasterJobHandler)));const{rasters:s,rasterIds:i}=this.primaryRasters,n=s.map((t=>t.rasterInfo?void 0:t.open(e)));await Promise.all(n);const a=s.map((({rasterInfo:e})=>e)),o=t.bind({rasterInfos:a,rasterIds:i});if(t.rawSourceRasterInfos=a,!o.success||0===a.length)throw new r("raster-function:open",`cannot bind the function: ${o.error??""}`);const c="Table"===t.functionName?t:t.functionArguments?.raster;"Table"===c?.functionName&&(t.rasterInfo.attributeTable=m.fromJSON(c.functionArguments.attributeTableAsRecordSet)),await this.syncJobHandler();const l=a[0];this.hasUniqueSourceStorageInfo=1===a.length||a.slice(1).every((e=>f(e,l))),this.set("sourceJSON",s[0].sourceJSON),this.set("rasterInfo",t.rasterInfo),await this._updateClipGeometry()}async syncJobHandler(){return this.rasterJobHandler?.updateRasterFunction(this.rasterFunction)}async _updateClipGeometry(){const t=this.rasterFunction.getClippingGeometries()[0];let r=t?.clippingGeometry;if(r&&"inside"===t.clippingType){const{extent:t}=this.rasterInfo,{difference:s,densify:i}=await new Promise(((t,r)=>e(["../../../geometry/geometryEngine"],t,r)));let n=i(c.fromExtent(t),2*(t.width+t.height)/y);n=h.projectPolygon(n,r.spatialReference),r=s(n,r)}this._clippingGeometry.clear(),r&&this._clippingGeometry.set("0",r)}};t.__decorate([s.property({type:String,json:{write:!0}})],d.prototype,"datasetFormat",void 0),t.__decorate([s.property()],d.prototype,"tileType",void 0),t.__decorate([s.property()],d.prototype,"rasterFunction",void 0),t.__decorate([s.property()],d.prototype,"primaryRasters",void 0),d=t.__decorate([o.subclass("esri.layers.support.rasterDatasets.FunctionRaster")],d);function f(e,t){const{storageInfo:r,pixelSize:s,spatialReference:i,extent:n}=e,{storageInfo:a,pixelSize:o,spatialReference:c,extent:l}=t;return s.x===o.x&&s.y===o.y&&i.equals(c)&&n.equals(l)&&r.blockHeight===a.blockHeight&&r.blockWidth===a.blockWidth&&r.maximumPyramidLevel===a.maximumPyramidLevel}function g(e){return String(e.wkid??e.wkt??e.wkt2)}return d}));
