/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../geometry","../../../core/Error","../../../core/maybe","../../../core/urlUtils","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/Logger","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../RasterInfo","../RasterStorageInfo","../TileInfo","../TilemapCache","./BaseRaster","../rasterFunctions/pixelUtils","../rasterTransforms/GCSShiftTransform","../../../rest/imageService/fetchRasterInfo","../../../geometry/SpatialReference","../../../geometry/Point","../../../geometry/Extent"],(function(e,t,i,s,a,l,r,n,o,c,u,h,m,f,p,d,y,x,g,v,S){"use strict";let I=class extends p{constructor(){super(...arguments),this._levelOffset=0,this._tilemapCache=null,this._slices=null,this.datasetFormat="RasterTileServer",this.tileType=null}async fetchRawTile(e,t,i,s={}){const{storageInfo:a,extent:l}=this.rasterInfo,{transposeInfo:r}=a,n=null!=r&&!!s.transposedVariableName;if(this._slices&&!n&&null==s.sliceId)return null;const o=n?0:a.maximumPyramidLevel-e+this._levelOffset,c=`${this.url}/tile/${o}/${t}/${i}`,u=this._slices?n?{variable:s.transposedVariableName}:{sliceId:s.sliceId||0}:null,{data:h}=await this.request(c,{query:u,responseType:"array-buffer",signal:s.signal});if(!h)return null;const m=n?r.tileSize:a.tileInfo.size,f=await this.decodePixelBlock(h,{width:m[0],height:m[1],planes:null,pixelType:null,isPoint:"Elevation"===this.tileType,returnInterleaved:n,noDataValue:this.rasterInfo.noDataValue});if(null==f)return null;const p=a.blockBoundary[e];if("jpg"!==a.compression||i>p.minCol&&i<p.maxCol&&t>p.minRow&&t<p.maxRow)return f;const{origin:y,blockWidth:x,blockHeight:g}=a,{x:v,y:S}=this.getPyramidPixelSize(e),I=Math.round((l.xmin-y.x)/v)%x,w=Math.round((l.xmax-y.x)/v)%x||x,_=Math.round((y.y-l.ymax)/S)%g,b=Math.round((y.y-l.ymin)/S)%g||g,M=i===p.minCol?I:0,T=t===p.minRow?_:0,O=i===p.maxCol?w:x,R=t===p.maxRow?b:g;return d.setValidBoundary(f,{x:M,y:T},{width:O-M,height:R-T}),f}getSliceIndex(e){if(!this._slices||null==e||0===e.length)return null;const t=e;for(let i=0;i<this._slices.length;i++){const e=this._slices[i].multidimensionalDefinition;if(e.length===t.length&&!e.some((e=>{const i=t.find((t=>e.variableName===t.variableName&&t.dimensionName===e.dimensionName));if(!i)return!0;return(Array.isArray(e.values[0])?`${e.values[0][0]}-${e.values[0][1]}`:e.values[0])!==(Array.isArray(i.values[0])?`${i.values[0][0]}-${i.values[0][1]}`:i.values[0])})))return i}return null}async fetchVariableStatisticsHistograms(e,t){const i=this.request(this.url+"/statistics",{query:{variable:e,f:"json"},signal:t}).then((e=>e.data?.statistics)),s=this.request(this.url+"/histograms",{query:{variable:e,f:"json"},signal:t}).then((e=>e.data?.histograms)),a=await Promise.all([i,s]);return a[0]&&a[0].forEach((e=>{e.avg=e.mean,e.stddev=e.standardDeviation})),a[1]?.[0]?.counts?.length||(a[1]=null),{statistics:a[0]||null,histograms:a[1]||null}}async computeBestPyramidLevelForLocation(e,t={}){if(!this._tilemapCache)return 0;let i=this.identifyPixelLocation(e,0,t.datumTransformation);if(null===i)return null;let s=0;const{maximumPyramidLevel:a}=this.rasterInfo.storageInfo;let l=a-s+this._levelOffset;const r=i.srcLocation;for(;l>=0;){try{if("available"===await this._tilemapCache.fetchAvailability(l,i.row,i.col,t))break}catch{}if(l--,s++,i=this.identifyPixelLocation(r,s,t.datumTransformation),null===i)return null}return-1===l||null==i?null:s}async _open(e){const t=e?.signal,l=this.sourceJSON?{data:this.sourceJSON}:await this.request(this.url,{query:{f:"json"},signal:t});l.ssl&&(this.url=this.url.replace(/^http:/i,"https:"));const r=l.data;if(this.sourceJSON=r,!r)throw new i("imageserverraster:open","cannot initialize tiled image service, missing service info");if(!r.tileInfo)throw new i("imageserverraster:open","use ImageryLayer to open non-tiled image services");this._fixScaleInServiceInfo();const n=["jpg","jpeg","png","png8","png24","png32","mixed"];this.tileType=r.cacheType,null==this.tileType&&(n.includes(r.tileInfo.format.toLowerCase())?this.tileType="Map":"lerc"===r.tileInfo.format.toLowerCase()?this.tileType="Elevation":this.tileType="Raster"),this.datasetName=r.name?.slice(r.name.indexOf("/")+1)??"";const o=await this._fetchRasterInfo({signal:t});if(null==o)throw new i("image-server-raster:open","cannot initialize image service");x.patchServiceInfo(o,r);const c="Map"===this.tileType?w(r.tileInfo,r):m.fromJSON(r.tileInfo);s.assertIsSome(c);const[u,p]=this._computeMinMaxLOD(o,c),{extent:d,pixelSize:y}=o,g=.5/o.width*y.x,v=Math.max(y.x,y.y),{lods:S}=c;("Map"!==this.tileType&&0!==r.maxScale||Math.abs(y.x-y.y)>g||!S.some((e=>Math.abs(e.resolution-v)<g)))&&(y.x=y.y=u.resolution,o.width=Math.ceil((d.xmax-d.xmin)/y.x-.1),o.height=Math.ceil((d.ymax-d.ymin)/y.y-.1));const I=u.level-p.level,[b,M]=c.size,T=[],O=[];S.forEach(((e,t)=>{e.level>=p.level&&e.level<=u.level&&T.push({x:e.resolution,y:e.resolution}),t<S.length-1&&O.push(Math.round(10*e.resolution/S[t+1].resolution)/10)})),T.sort(((e,t)=>e.x-t.x));const R=this.computeBlockBoundary(d,b,M,c.origin,T,I),z=T.length>1?T.slice(1):null;let N;r.transposeInfo&&(N={tileSize:[r.transposeInfo.rows,r.transposeInfo.cols],packetSize:o.keyProperties?._yxs.PacketSize??0});const L=O.length<=1||O.length>=3&&O.slice(0,-1).every((e=>e===O[0]))?O[0]??2:Math.round(10/(p.resolution/u.resolution)**(-1/I))/10;if(o.storageInfo=new h({blockWidth:c.size[0],blockHeight:c.size[1],pyramidBlockWidth:c.size[0],pyramidBlockHeight:c.size[1],pyramidResolutions:z,pyramidScalingFactor:L,compression:c.format,origin:c.origin,firstPyramidLevel:1,maximumPyramidLevel:I,tileInfo:c,transposeInfo:N,blockBoundary:R}),_(o),this._set("rasterInfo",o),r.capabilities.toLowerCase().includes("tilemap")){const e={tileInfo:o.storageInfo.tileInfo,parsedUrl:a.urlToObject(this.url),url:this.url,tileServers:[]};this._tilemapCache=new f.TilemapCache({layer:e})}}async _fetchRasterInfo(e){const t=this.sourceJSON;if("Map"===this.tileType){const e=t.fullExtent||t.extent,i=Math.ceil((e.xmax-e.xmin)/t.pixelSizeX-.1),s=Math.ceil((e.ymax-e.ymin)/t.pixelSizeY-.1),a=g.fromJSON(t.spatialReference||e.spatialReference),l=new v({x:t.pixelSizeX,y:t.pixelSizeY,spatialReference:a});return new u({width:i,height:s,bandCount:3,extent:S.fromJSON(e),spatialReference:a,pixelSize:l,pixelType:"u8",statistics:null,keyProperties:{DataType:"processed"}})}const{signal:i}=e,s=x.fetchServiceRasterInfo(this.url,this.sourceJSON,{signal:i,query:this.ioConfig.customFetchParameters}),a=t.hasMultidimensions?this.request(`${this.url}/slices`,{query:{f:"json"},signal:i}).then((e=>e.data?.slices)).catch((()=>null)):null,l=await Promise.all([s,a]);return this._slices=l[1],l[0]}_fixScaleInServiceInfo(){const{sourceJSON:e}=this;e.minScale&&e.minScale<0&&(e.minScale=0),e.maxScale&&e.maxScale<0&&(e.maxScale=0)}_computeMinMaxLOD(e,t){const{pixelSize:i}=e,s=.5/e.width*i.x,{lods:a}=t,l=t.lodAt(Math.max.apply(null,a.map((e=>e.level)))),r=t.lodAt(Math.min.apply(null,a.map((e=>e.level)))),{tileType:n}=this;if("Map"===n)return this._levelOffset=a[0].level,[l,r];if("Raster"===n){return[a.find((e=>e.resolution===i.x))??l,r]}const{minScale:o,maxScale:c}=this.sourceJSON;let u=l;c>0&&(u=a.find((e=>Math.abs(e.scale-c)<s)),u||(u=a.filter((e=>e.scale>c)).sort(((e,t)=>e.scale>t.scale?1:-1))[0]??l));let h=r;return o>0&&(h=a.find((e=>Math.abs(e.scale-o)<s))??r,this._levelOffset=h.level-r.level),[u,h]}};function w(e,t){if(!e)return null;const{minScale:i,maxScale:s,minLOD:a,maxLOD:l}=t;if(null!=a&&null!=l)return m.fromJSON({...e,lods:e.lods.filter((({level:e})=>null!=e&&e>=a&&e<=l))});if(0!==i&&0!==s){const t=e=>Math.round(1e4*e)/1e4,a=i?t(i):1/0,l=s?t(s):-1/0;return m.fromJSON({...e,lods:e.lods.filter((e=>{const i=t(e.scale);return i<=a&&i>=l}))})}return m.fromJSON(e)}function _(e){const{extent:t,spatialReference:i}=e;t.xmin>-1&&t.xmax>181&&i?.wkid&&i.isGeographic&&(e.nativeExtent=e.extent,e.transform=new y,e.extent=e.transform.forwardTransform(t))}e.__decorate([l.property({type:String,json:{write:!0}})],I.prototype,"datasetFormat",void 0),e.__decorate([l.property()],I.prototype,"tileType",void 0),I=e.__decorate([c.subclass("esri.layers.support.rasterDatasets.ImageServerRaster")],I);return I}));
