/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../geometry","../../../core/arrayUtils","../../../core/Error","../../../core/Logger","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/accessorSupport/decorators/subclass","../RasterInfo","../RasterStorageInfo","./BaseRaster","./DBFParser","./pamParser","../rasterFormats/TiffDecoder","../rasterFormats/TiffTags","../rasterFunctions/stretchUtils","../rasterTransforms/PolynomialTransform","../../../rest/support/FeatureSet","../../../geometry/SpatialReference","../../../geometry/Extent","../../../geometry/Point"],(function(e,t,i,a,r,s,n,o,l,f,u,c,p,h,d,m,y,g,x,T,I){"use strict";const w=(e,t)=>e.get(t)?.values,R=(e,t)=>e.get(t)?.values?.[0];let _=class extends u{constructor(){super(...arguments),this._files=null,this._headerInfo=null,this._bufferSize=1048576,this.datasetFormat="TIFF"}async fetchRawTile(e,t,i,a={}){if(!this._headerInfo?.isSupported||this.isBlockOutside(e,t,i))return null;const r=await this._fetchRawTiffTile(e,t,i,!1,a);if(null!=r&&this._headerInfo.hasMaskBand){const s=await this._fetchRawTiffTile(e,t,i,!0,a);null!=s&&s.pixels[0]instanceof Uint8Array&&(r.mask=s.pixels[0])}return r}async _open(e){const t=e?e.signal:null,{data:i}=await this.request(this.url,{range:{from:0,to:this._bufferSize},responseType:"array-buffer",signal:t});if(!i)throw new a("tiffraster:open","failed to open url "+this.url);this.datasetName=this.url.slice(this.url.lastIndexOf("/")+1,this.url.lastIndexOf("."));const{littleEndian:s,firstIFDPos:n,isBigTiff:o}=h.parseSignature(i),l=[];await this._readIFDs(l,i,s,n,0,o?8:4,t);const{imageInfo:f,rasterInfo:u}=S(l),c=h.getPyramidIFDs(l),p=h.getMaskIFDs(l);if(this._headerInfo={littleEndian:s,isBigTiff:o,ifds:l,pyramidIFDs:c,maskIFDs:p,...f},this._set("rasterInfo",u),!f.isSupported)throw new a("tiffraster:open","this tiff is not supported: "+f.message);if(!f.tileWidth)throw new a("tiffraster:open","none-tiled tiff is not optimized for access, convert to COG and retry.");u.isPseudoSpatialReference&&r.getLogger(this).warn("The spatial reference for this tiff is unsupported. Only EPSG spatial reference codes and Esri WKTs are supported.");const d=l[0].get("PREDICTOR")?.values?.[0],m=l[0].get("SAMPLEFORMAT")?.values?.[0];if(3===m&&2===d)throw new a("tiffraster:open","unsupported horizontal difference encoding. Predictor=3 is supported for floating point data");const{skipMapInfo:y,skipExtensions:g=[]}=this.ioConfig;if(!g.includes("aux.xml")&&!y){const t=await this._fetchAuxiliaryMetaData(e);null!=t&&b(t,u)}g.includes("vat.dbf")||1!==u.bandCount||"u8"!==u.pixelType||y||(u.attributeTable=await this._fetchAuxiliaryTable(e),null!=u.attributeTable&&(u.keyProperties.DataType="thematic")),y&&this.updateImageSpaceRasterInfo(u),this.updateTileInfo()}async _readIFDs(e,t,i,a,r,s=4,n){if(!a)return null;if(a>=t.byteLength||a<0){t=(await this.request(this.url,{range:{from:a+r,to:a+r+this._bufferSize},responseType:"array-buffer",signal:n})).data,r=a+r,a=0}const o=await this._readIFD(t,i,a,r,d.tiffTags,s,n);if(e.push(o.ifd),!o.nextIFD)return null;await this._readIFDs(e,t,i,o.nextIFD-r,r,s,n)}async _readIFD(e,t,a,r,s=d.tiffTags,n=4,o){if(!e)return null;const l=h.parseIFD(e,t,a,r,s,n);if(l.success){const a=[];if(l.ifd?.forEach((e=>{e.values||a.push(e)})),a.length>0){const s=a.map((e=>e.offlineOffsetSize)).filter(i.isSome),n=Math.min.apply(null,s.map((e=>e[0])));if(Math.min.apply(null,s.map((e=>e[0]+e[1])))-n<=this._bufferSize){const{data:i}=await this.request(this.url,{range:{from:n,to:n+this._bufferSize},responseType:"array-buffer",signal:o});e=i,r=n,a.forEach((i=>h.parseFieldValues(e,t,i,r)))}}if(l.ifd?.has("GEOKEYDIRECTORY")){const i=l.ifd.get("GEOKEYDIRECTORY"),a=i?.values;if(a&&a.length>4){const s=a[0]+"."+a[1]+"."+a[2],n=await this._readIFD(e,t,i.valueOffset+6-r,r,d.geoKeys,2,o);i.data=n.ifd,i.data&&i.data.set("GEOTIFFVersion",{id:0,type:2,valueCount:1,valueOffset:null,values:[s]})}}return l}if(l.requiredBufferSize&&l.requiredBufferSize!==e.byteLength){const i=await this.request(this.url,{range:{from:r,to:r+l.requiredBufferSize+4},responseType:"array-buffer",signal:o});return(e=i.data).byteLength<l.requiredBufferSize?null:this._readIFD(e,t,0,r,d.tiffTags,4,o)}}async _fetchRawTiffTile(e,t,i,a,r={}){const s=this._getTileLocation(e,t,i,a);if(!s)return null;const{ranges:n,actualTileWidth:o,actualTileHeight:l,ifd:f}=s,u=n.map((e=>this.request(this.url,{range:e,responseType:"array-buffer",signal:r.signal}))),c=await Promise.all(u),p=c.map((e=>e.data.byteLength)).reduce(((e,t)=>e+t)),h=1===c.length?c[0].data:new ArrayBuffer(p),d=[0],m=[0];if(c.length>1){const e=new Uint8Array(h);for(let t=0,i=0;t<c.length;t++){const a=c[t].data;e.set(new Uint8Array(a),i),d[t]=i,i+=a.byteLength,m[t]=a.byteLength}}const{blockWidth:y,blockHeight:g}=this.getBlockWidthHeight(e),x=await this.decodePixelBlock(h,{format:"tiff",customOptions:{headerInfo:this._headerInfo,ifd:f,offsets:d,sizes:m},width:y,height:g,planes:null,pixelType:null});if(null==x)return null;let T,I,w;if(o!==y||l!==g){let e=x.mask;if(e)for(T=0;T<g;T++)if(w=T*y,T<l)for(I=o;I<y;I++)e[w+I]=0;else for(I=0;I<y;I++)e[w+I]=0;else for(e=new Uint8Array(y*g),x.mask=e,T=0;T<l;T++)for(w=T*y,I=0;I<o;I++)e[w+I]=1}return x}_getTileLocation(e,t,i,a=!1){const{firstPyramidLevel:r,blockBoundary:s}=this.rasterInfo.storageInfo,n=0===e?0:e-(r-1),{_headerInfo:o}=this;if(!o)return null;const l=a?o.maskIFDs[n]:0===n?o?.ifds[0]:o?.pyramidIFDs[n-1];if(!l)return null;const f=h.isBSQConfig(l,o),u=w(l,"TILEOFFSETS");if(void 0===u)return null;const c=w(l,"TILEBYTECOUNTS"),{minRow:p,minCol:d,maxRow:m,maxCol:y}=s[n];if(t>m||i>y||t<p||i<d)return null;const g=R(l,"IMAGEWIDTH"),x=R(l,"IMAGELENGTH"),T=R(l,"TILEWIDTH"),I=R(l,"TILELENGTH"),_=[];if(f){const{bandCount:e}=this.rasterInfo;for(let a=0;a<e;a++){const e=a*(m+1)*(y+1)+t*(y+1)+i;_[a]={from:u[e],to:u[e]+c[e]-1}}}else{const e=t*(y+1)+i;_.push({from:u[e],to:u[e]+c[e]-1})}for(let h=0;h<_.length;h++)if(null==_[h].from||!_[h].to||_[h].to<0)return null;return{ranges:_,ifd:l,actualTileWidth:i===y&&g%T||T,actualTileHeight:t===m&&x%I||I}}async _fetchAuxiliaryMetaData(e){try{const{data:t}=await this.request(this.url+".aux.xml",{responseType:"xml",signal:e?.signal});return p.parsePAMInfo(t)}catch{return null}}async _fetchAuxiliaryTable(e){try{const{data:t}=await this.request(this.url+".vat.dbf",{responseType:"array-buffer",signal:e?.signal}),i=c.parse(t);return i?.recordSet?g.fromJSON(i.recordSet):null}catch{return null}}};function S(e){const t=h.getImageInfo(e),{width:i,height:a,tileWidth:r,tileHeight:s,planes:n,pixelType:o,compression:u,firstPyramidLevel:c,maximumPyramidLevel:d,pyramidBlockWidth:m,pyramidBlockHeight:g,pyramidResolutions:_,tileBoundary:S,affine:b,metadata:E}=t,F=t.extent.spatialReference?.wkt||t.extent.spatialReference?.wkid;let D=p.parseSpatialReference(F),P=!!t.isPseudoGeographic;null==D&&(P=!0,D=new x({wkid:3857}));const k=new T({...t.extent,spatialReference:D}),v=new I(k?{x:k.xmin,y:k.ymax,spatialReference:D}:{x:0,y:0}),O=new f({blockWidth:r,blockHeight:s,pyramidBlockWidth:m,pyramidBlockHeight:g,compression:u,origin:v,firstPyramidLevel:c,maximumPyramidLevel:d,pyramidResolutions:_,blockBoundary:S}),B=new I({x:(k.xmax-k.xmin)/i,y:(k.ymax-k.ymin)/a,spatialReference:D}),L=E?{BandProperties:E.bandProperties,DataType:E.dataType}:{};let z=null;const A=R(e[0],"PHOTOMETRICINTERPRETATION"),C=w(e[0],"COLORMAP");if(A<=3&&C?.length>3&&C.length%3==0){z=[];const e=C.length/3;for(let t=0;t<e;t++)z.push([t,C[t]>>>8,C[t+e]>>>8,C[t+2*e]>>>8])}const H=new l({width:i,height:a,bandCount:n,pixelType:o,pixelSize:B,storageInfo:O,spatialReference:D,isPseudoSpatialReference:P,keyProperties:L,extent:k,colormap:z,statistics:E?E.statistics:null});if(b?.length&&(H.nativeExtent=new T({xmin:-.5,ymin:.5-a,xmax:i-.5,ymax:.5,spatialReference:D}),H.transform=new y({polynomialOrder:1,forwardCoefficients:[b[2]+b[0]/2,b[5]-b[3]/2,b[0],b[3],-b[1],-b[4]]}),H.extent=H.transform.forwardTransform(H.nativeExtent),H.pixelSize=new I({x:(k.xmax-k.xmin)/i,y:(k.ymax-k.ymin)/a,spatialReference:D}),O.origin.x=-.5,O.origin.y=.5),_){const{x:e,y:t}=H.pixelSize;_.forEach((i=>{i.x*=e,i.y*=t}))}return{imageInfo:t,rasterInfo:H}}function b(e,t){if(t.statistics=e.statistics??t.statistics,t.histograms=e.histograms,e.histograms&&null==t.statistics&&(t.statistics=m.estimateStatisticsFromHistograms(e.histograms)),e.transform&&null==t.transform){t.transform=e.transform,t.nativeExtent=t.extent;const i=t.transform.forwardTransform(t.nativeExtent);t.pixelSize=new I({x:(i.xmax-i.xmin)/t.width,y:(i.ymax-i.ymin)/t.height,spatialReference:t.spatialReference}),t.extent=i}t.isPseudoSpatialReference&&e.spatialReference&&(t.spatialReference=e.spatialReference,t.extent.spatialReference=t.nativeExtent.spatialReference=t.storageInfo.origin.spatialReference=t.spatialReference)}e.__decorate([s.property()],_.prototype,"_files",void 0),e.__decorate([s.property()],_.prototype,"_headerInfo",void 0),e.__decorate([s.property()],_.prototype,"_bufferSize",void 0),e.__decorate([s.property({type:String,json:{write:!0}})],_.prototype,"datasetFormat",void 0),_=e.__decorate([o.subclass("esri.layers.support.rasterDatasets.TIFFRaster")],_);return _}));
