/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../geometry","../../../core/Error","../../../core/Logger","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../ogc/crsUtils","../../ogc/wcsUtils","../DimensionalDefinition","./BaseRaster","./multipartParser","./wcsCoverageParser","../rasterFormats/RasterCodec","../rasterFunctions/pixelUtils","../../../geometry/Extent"],(function(e,t,i,n,s,r,o,a,l,c,d,p,u,h,g,f,m){"use strict";const w=["nearest neighbor","bilinear","bicubic"],v=["nearest","linear","cubic"],y="response is not a supported multipart/related mediaType with inline tiff,  switching to compatibility mode",x="response is not a supported multipart mediaType with inline tiff",C="response is base64 encoded which may impact layer display performance",I="server returns an exception",b=new Set(["1.0.0","1.1.0","1.1.1","1.1.2","2.0.1"]);let $=class extends p{constructor(){super(...arguments),this.datasetFormat="WCSServer",this.tileType="Raster"}async fetchRawTile(e,t,n,s={}){if(this.isBlockOutside(e,t,n))return null;const{nativePixelSize:r,spatialReference:o}=this.rasterInfo,a=2**e,l=r.x*a,c=r.y*a,{blockWidth:d,blockHeight:p}=this.getBlockWidthHeight(e),{origin:u}=this.rasterInfo.storageInfo.tileInfo,h=this.getTileExtent({x:l,y:c},t,n,u,o,[d,p]),g=this.rasterInfo.extent,m=h.xmax>g.xmax,w=h.ymin<g.ymin,v=m||w;let y=h,x=d,C=p;if(v&&(y=h.clone().intersection(g),null!=y&&(m&&(x=Math.floor((y.xmax-y.xmin)/l),y.xmax=y.xmin+l*x),w&&(C=Math.floor((y.ymax-y.ymin)/c),y.ymin=y.ymax-c*C))),null==y||x<=1||C<=1)return null;const I=await this._getCoverage(y,x,C,a,s);if(!I)return null;const{coverageDescription:b}=this.coverageInfo;let{noDataValue:$,multidimensionalInfo:S}=this.rasterInfo;const{multidimensionalDefinition:T}=s;if(null!=S&&null!=T&&T.length){const e=T[0].variableName;if("2.0"===b.version){const t=b.rangeType[0].find((t=>t.name===e));$=t?.nilValue}else if("1.1"===b.version){const t=b.range.find((t=>t.identifier===e));$=t?.nullValues}}const _=await this.decodePixelBlock(I,{width:x,height:C,planes:null,pixelType:null,noDataValue:Array.isArray($)?$[0]:$});if(null==_)return null;if(_&&(_.width!==x||_.height!==C))throw new i("wcsraster-fetch",`the response has unexpected dimension width: ${_.width}, height: {pixelBlock.height}`);return v?f.clip(_,{x:0,y:0},{width:p,height:p}):_}async _open(e){const{customFetchParameters:t}=this.ioConfig,n=e?.signal,s=await c.getCapabilities(this.url,{version:this.version,customParameters:t,signal:n});if(this.capabilities=s,!this.version){let e=s.version.slice(0,3);"2.0"===e||"1.1"===e||"1.0"===e?this.version=s.version:(e=s.supportedVersions.find((e=>"2.0.1"===e))||s.supportedVersions.find((e=>"2.0"===e.slice(0,3)))||s.supportedVersions.find((e=>"1.1"===e.slice(0,3)))||s.supportedVersions.find((e=>"1.0"===e.slice(0,3)))||"1.0.0",this.version=e)}if(!b.has(this.version))throw new i("wcsraster-open",`unsupported WCS version ${this.version}`);const{gridCoverages:r}=s;if(!r.length)throw new i("wcsraster-open","cannot find rectified grid coverages");null==this.coverageId&&(this.coverageId=r[0].id);const o=r.find((e=>e.id===this.coverageId));if(null==o)throw new i("wcsraster-open",`the coverageId ${this.coverageId} does not exist in capabilities`);const a=await c.describeCoverage(this.url,{coverageIds:[this.coverageId],version:this.version,customParameters:t,signal:n});this.coverageInfo=a[0],"2.0"===this.version.slice(0,3)&&(this.coverageInfo.lonLatEnvelope=o.lonLatEnvelope,this.coverageInfo.supportedInterpolations=h.standardizeInterpolations(s.supportedInterpolations)),this.datasetName=this.coverageInfo.title;const{rasterInfo:l}=this.coverageInfo;if(this.createRemoteDatasetStorageInfo(l,512,512),this._set("rasterInfo",l),null==l.spatialReference)throw new i("wcsraster-open",`coverage without spatial reference is not supported: ${this.coverageId}`);const{pixelType:d,bandCount:p}=await this._getPixelTypeAndBandCount(n);l.pixelType=d,1===l.bandCount&&p>1&&(l.bandCount=p),this.updateTileInfo()}async _getPixelTypeAndBandCount(e){const{pixelSize:t,extent:s,multidimensionalInfo:r}=this.rasterInfo,o=s.center,a=new m({xmin:o.x-t.x,xmax:o.x+t.x,ymin:o.y-t.y,ymax:o.y+t.y,spatialReference:s.spatialReference});let l=[];if(null!=r){const e=r.variables[0];l=[],e.dimensions.forEach((t=>{l.push(new d({variableName:e.name,dimensionName:t.name,values:t.hasRegularIntervals?t.extent?.[0]:t.values?.[0],isSlice:!0}))}))}const{coverageDescription:c}=this.coverageInfo,p={interpolation:"nearest",multidimensionalDefinition:l,signal:e},{version:u}=c,{ioConfig:h}=this,g="2.0"===u&&null==h.allowAnyMediaType||"1.1"===u&&null==h.use2GridOffsets;let f;try{f=await this._getCoverage(a,2,2,1,p,!0)}catch(v){if(!g)throw v;if("1.1"===u){if(!v.details?.isResolutionMismatch)throw v;h.use2GridOffsets=!0}}if(!f&&g&&("2.0"===u&&(h.allowAnyMediaType=!0),f=await this._getCoverage(a,2,2,1,p),f&&n.getLogger(this).warn("wcsraster:getcoverage",y)),!f)throw new i("wcsraster-open","unable to determine pixel type");const w=await this.decodePixelBlock(f,{width:2,height:2,planes:null,pixelType:null});if(null==w)throw new i("wcsraster-open","unable to determine pixel type");return{pixelType:w.pixelType,bandCount:w.getPlaneCount()??0}}async _getCoverage(e,t,s,r,o,a=!1){const{coverageDescription:l}=this.coverageInfo,{version:c}=l,d="2.0"===c?this._getCoverage201Parameters(e,t,s,r,o,l):"1.1"===c?this._getCoverage110Parameters(e,t,s,o,l):this._getCoverage100Parameters(e,t,s,o),p="2.0"===c?await this.request(this._constructWCS201Url(d),{signal:o.signal,responseType:"array-buffer"}):await this.request(this.url,{query:d,signal:o.signal,responseType:"array-buffer"});if("1.0"===c)return p.data;if("2.0"===c&&!1!==this.ioConfig.allowAnyMediaType){if("tiff"===g.getFormat(p.data))return a&&(this.ioConfig.allowAnyMediaType=!0,n.getLogger(this).warn("wcsraster:getcoverage",y)),p.data}const h=u.parse(p);if(h.isMultipart&&h.data){const e=h.data.find((e=>e.contentType?.toLowerCase().includes("image")&&null!=e.contentData));return a&&"base64"===e?.contentTransferEncoding&&n.getLogger(this).warn("wcsraster:getcoverage",C),e?.contentData}const f=new Uint8Array(p.data,0,Math.min(p.data.byteLength,2e3)),m=String.fromCharCode.apply(null,f).toLowerCase().includes("exception"),w=m&&String.fromCharCode.apply(null,f).includes("A non-zero RESX/RESY or WIDTH/HEIGHT is required but neither was provided");if(m)throw new i("wcsraster:getcoverage",I,{isResolutionMismatch:w});throw new i("wcsraster:getcoverage",x)}_getInterpolationIndex(e){return e&&this.coverageInfo.supportedInterpolations?.includes(e)?"nearest"===e?0:"bilinear"===e?1:"cubic"===e?2:0:0}_getCoverage100Parameters(e,t,i,n){const s=`${e.xmin},${e.ymin},${e.xmax},${e.ymax}`,r=e.spatialReference.wkid,o=(this.coverageInfo.supportedFormats||[]).find((e=>e.toLowerCase().includes("tiff")))||"GEOTIFF",{bandIds:a,interpolation:l}=n,c=this._getInterpolationIndex(l),d=a?a.map((e=>this.coverageInfo.bandNames[e])):null,p=w[c],{multidimensionalDefinition:u}=n;let h;if(null!=u&&null!=this.rasterInfo.multidimensionalInfo){const e=u.find((e=>"StdTime"===e.dimensionName));let t=e?.values;t&&t.length>0&&(Array.isArray(t[0])&&(t=t[0]),h=t.map((e=>S(e))).join(","))}return{service:"WCS",request:"GetCoverage",version:this.version,coverage:this.coverageId,format:o,crs:`EPSG:${r}`,bbox:s,width:t,height:i,time:h,interpolation:p,band:d?.join(",")}}_getCoverage110Parameters(e,t,i,n,s){const{multidimensionalDefinition:r,bandIds:o,interpolation:a}=n,c=e.spatialReference.wkid,d=`urn:ogc:def:crs:EPSG::${c}`,p=(this.coverageInfo.supportedFormats||[]).find((e=>e.toLowerCase().includes("tiff")))||"image/tiff",u=this._getInterpolationIndex(a),h=v[u],g=null==a||0===this.coverageInfo.supportedInterpolations?.indexOf(a),f=s.domain.spatialDomain,m=f.origin.x<=f.envelope.xmin&&f.origin.y<=f.envelope.ymin,w=e.width/t,y=e.height/i*(m?1:-1),x=m?[e.xmin,e.ymin]:[e.xmin,e.ymax],C=f.useEPSGAxis&&l.isAxesOrderReversedForWkid(c),I=C?`${x[1]},${x[0]}`:`${x[0]},${x[1]}`,b=this.ioConfig.use2GridOffsets,$=C?b?`${y},${w}`:`${y},0,0,${w}`:b?`${w},${y}`:`${w},0,0,${y}`,T=w/2,_=e.xmin+T,L=e.xmax-T,R=Math.abs(y)/2,P=e.ymin+R,A=e.ymax-R,E=C?`${P},${_},${A},${L},${d}`:`${_},${P},${L},${A},${d}`,D=s.range.find((e=>e.axis.some((e=>e.identifier.toLowerCase().includes("band")))));let j,G=D&&h&&o?g?`${D.identifier}[${D.axis[0].identifier}[${o.join(",")}]]`:`${D.identifier}:${h}[${D.axis[0].identifier}[${o.join(",")}]]`:null;if(null!=r&&r.length)for(let l=0;l<r.length;l++){let e=r[l].values;const t=r[l].dimensionName?.toLowerCase(),i=r[l].variableName?.toLowerCase();if(e.length>0)if(Array.isArray(e[0])&&(e=e[0]),"stdtime"===t)j=e.map((e=>S(e))).join(",");else{const n=s.range.find((e=>e.identifier.toLowerCase()===i));if(n){const i=n.axis.find((e=>e.identifier.toLowerCase()===t));i&&(G=g?n.identifier+"["+i.identifier+"["+e.join(",")+"]]":n.identifier+":"+h+"["+i.identifier+"["+e.join(",")+"]]")}}}return{service:"WCS",request:"GetCoverage",version:this.version,identifier:this.coverageId,format:p,crs:`EPSG:${c}`,boundingbox:E,gridCS:"urn:ogc:def:cs:OGC:0.0:Grid2dSquareCS",gridType:"urn:ogc:def:method:WCS:1.1:2dGridIn2dCrs",gridOrigin:I,gridOffsets:$,gridBaseCRS:d,timeSequence:j,rangeSubset:G}}_getCoverage201Parameters(e,t,i,n,s,r){const{multidimensionalDefinition:o,interpolation:a}=s,l=this._getInterpolationIndex(a);let c=null;const{supportedInterpolations:d}=this.capabilities;if(d?.length)switch(l){case 0:c=d.find((e=>e.toLowerCase().includes("nearest")));break;case 1:c=d.find((e=>e.toLowerCase().includes("linear")));break;case 2:c=d.find((e=>e.toLowerCase().includes("cubic")||e.toLowerCase().includes("quadratic")))}const p=(this.coverageInfo.supportedFormats||[]).find((e=>e.toLowerCase().includes("tiff")))||"image/tiff",{bandNames:u}=this.coverageInfo,{boundedBy:h,domainSet:g,rangeType:f}=r,m=h.isEastFirst?0:1,w=1-m,{axisLabels:v}=h,y=v[m],x=v[w],C=`http://www.opengis.net/def/crs/EPSG/0/${e.spatialReference.wkid}`,I=C,b=[];b.push(`${y}(${e.xmin},${e.xmax})`),b.push(`${x}(${e.ymin},${e.ymax})`);const $=[];if(v.length>2)for(let A=2;A<v.length;A++){const e=g.origin[A];if(v[A].toLowerCase().includes("time")){let t=e.toString();h.uomLabels?.[A].toLowerCase().includes("ole")&&($.push(v[A]),t=S(e,!0)),b.push(v[A]+",http://www.opengis.net("+t+")")}else b.push(v[A]+",http://www.opengis.net("+e+")")}let T=null;if(null!=o&&o.length){const e=[];f.forEach((t=>t.forEach((t=>e.push(t.name)))));const t=[];for(let i=0;i<o.length;i++){const n=v.find((e=>e===o[i].dimensionName)),s=e.find((e=>e===o[i].variableName));if(t.includes(s)||t.push(s),n){let e=o[i].values;if(e.length>0){Array.isArray(e[0])&&(e=e[0]);let t="";t=n.toLowerCase().includes("time")?e.map((e=>S(e))).join(","):e.join(",");const i=b.findIndex((e=>0===e.indexOf(n+",http://www.opengis.net")));-1===i&&b.push(n+",http://www.opengis.net("+t+")"),-1===i||b[i].includes("("+t+")")||b.splice(i,1,n+",http://www.opengis.net("+t+")")}}}t.length&&(T=t.join(","))}else if(u?.length>=2){T=(s.bandIds?s.bandIds.map((e=>u[e])):u).join(",")}const _=b.join("&subset="),L=!r.domainSet.hasSameAxisLabelsAsBoundedBy&&!1!==this.ioConfig.allowScaleFactor,R=L?null:`${y}(${t}),${x}(${i})`,P=L?1/n:null;return{service:"WCS",request:"GetCoverage",version:this.version,coverageId:this.coverageId,rangesubset:T,interpolation:c,scaleSize:R,scaleFactor:P,subset:_,format:p,mediaType:this.ioConfig.allowAnyMediaType?null:"multipart/related",outputcrs:C,subsettingcrs:I}}_constructWCS201Url(e){const t={...this.ioConfig.customFetchParameters,...e},i=[];Object.keys(t).forEach((e=>{const n=t[e];null!=n&&("subset"===e?"string"==typeof n&&n.split("&subset=").forEach((e=>{e&&i.push(`subset=${encodeURIComponent(e)}`)})):i.push(`${e}=${encodeURIComponent(n)}`))}));return`${encodeURI(this.url)}?${i.join("&")}`}};function S(e,t=!1){return(t?new Date(24*(e-25569)*60*60*1e3):new Date(e)).toISOString()}e.__decorate([s.property({type:String,json:{write:!0}})],$.prototype,"datasetFormat",void 0),e.__decorate([s.property({readOnly:!0})],$.prototype,"tileType",void 0),e.__decorate([s.property({type:String,json:{write:!0}})],$.prototype,"version",void 0),e.__decorate([s.property({type:String,json:{write:!0}})],$.prototype,"coverageId",void 0),$=e.__decorate([a.subclass("esri.layers.support.rasterDatasets.WCSRaster")],$);return $}));
