/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../core/Error","../../../core/maybe","../PixelBlock","../SimpleBandStatistics","./ImageCanvasDecoder","./JpgPlus","./Lerc","./Lzw","./pixelRangeUtils","../../../chunks/Zlib","./Raw","./TiffDecoder","./utils"],(function(t,e,a,i,s,r,n,o,h,l,c,d,p,u){"use strict";var f=function(t){var e,a,i,s,r,n;function o(t){var e,a,i,s,r,n,o,h,l,c,d,p,u;for(this.data=t,this.pos=8,this.palette=[],this.imgData=[],this.transparency={},this.animation=null,this.text={},r=null;;){switch(e=this.readUInt32(),h=function(){var t,e;for(e=[],t=0;t<4;++t)e.push(String.fromCharCode(this.data[this.pos++]));return e}.call(this).join(""),h){case"IHDR":this.width=this.readUInt32(),this.height=this.readUInt32(),this.bits=this.data[this.pos++],this.colorType=this.data[this.pos++],this.compressionMethod=this.data[this.pos++],this.filterMethod=this.data[this.pos++],this.interlaceMethod=this.data[this.pos++];break;case"acTL":this.animation={numFrames:this.readUInt32(),numPlays:this.readUInt32()||1/0,frames:[]};break;case"PLTE":this.palette=this.read(e);break;case"fcTL":r&&this.animation.frames.push(r),this.pos+=4,r={width:this.readUInt32(),height:this.readUInt32(),xOffset:this.readUInt32(),yOffset:this.readUInt32()},s=this.readUInt16(),i=this.readUInt16()||100,r.delay=1e3*s/i,r.disposeOp=this.data[this.pos++],r.blendOp=this.data[this.pos++],r.data=[];break;case"IDAT":case"fdAT":for("fdAT"===h&&(this.pos+=4,e-=4),t=(null!=r?r.data:void 0)||this.imgData,d=0;0<=e?d<e:d>e;0<=e?++d:--d)t.push(this.data[this.pos++]);break;case"tRNS":switch(this.transparency={},this.colorType){case 3:if(this.transparency.indexed=this.read(e),(l=255-this.transparency.indexed.length)>0)for(p=0;0<=l?p<l:p>l;0<=l?++p:--p)this.transparency.indexed.push(255);break;case 0:this.transparency.grayscale=this.read(e)[0];break;case 2:this.transparency.rgb=this.read(e)}break;case"tEXt":n=(c=this.read(e)).indexOf(0),o=String.fromCharCode.apply(String,c.slice(0,n)),this.text[o]=String.fromCharCode.apply(String,c.slice(n+1));break;case"IEND":return r&&this.animation.frames.push(r),this.colors=function(){switch(this.colorType){case 0:case 3:case 4:return 1;case 2:case 6:return 3}}.call(this),this.hasAlphaChannel=4===(u=this.colorType)||6===u,a=this.colors+(this.hasAlphaChannel?1:0),this.pixelBitlength=this.bits*a,this.colorSpace=function(){switch(this.colors){case 1:return"DeviceGray";case 3:return"DeviceRGB"}}.call(this),void(this.imgData=new Uint8Array(this.imgData));default:this.pos+=e}if(this.pos+=4,this.pos>this.data.length)throw new Error("Incomplete or corrupt PNG file")}}return o.load=function(t,e,a){var i;return"function"==typeof e&&(a=e),(i=new XMLHttpRequest).open("GET",t,!0),i.responseType="arraybuffer",i.onload=function(){var t;return t=new o(new Uint8Array(i.response||i.mozResponseArrayBuffer)),"function"==typeof(null!=e?e.getContext:void 0)&&t.render(e),"function"==typeof a?a(t):void 0},i.send(null)},a=1,i=2,e=0,o.prototype.read=function(t){var e,a;for(a=[],e=0;0<=t?e<t:e>t;0<=t?++e:--e)a.push(this.data[this.pos++]);return a},o.prototype.readUInt32=function(){return this.data[this.pos++]<<24|this.data[this.pos++]<<16|this.data[this.pos++]<<8|this.data[this.pos++]},o.prototype.readUInt16=function(){return this.data[this.pos++]<<8|this.data[this.pos++]},o.prototype.decodePixels=function(t){var e,a,i,s,r,n,o,h,l,d,p,u,f,g,w,m,y,b,x,k,T,I,v;if(null==t&&(t=this.imgData),0===t.length)return new Uint8Array(0);for(t=(t=new c.Zlib(t)).getBytes(),m=(u=this.pixelBitlength/8)*this.width,f=new Uint8Array(m*this.height),n=t.length,w=0,g=0,a=0;g<n;){switch(t[g++]){case 0:for(s=x=0;x<m;s=x+=1)f[a++]=t[g++];break;case 1:for(s=k=0;k<m;s=k+=1)e=t[g++],r=s<u?0:f[a-u],f[a++]=(e+r)%256;break;case 2:for(s=T=0;T<m;s=T+=1)e=t[g++],i=(s-s%u)/u,y=w&&f[(w-1)*m+i*u+s%u],f[a++]=(y+e)%256;break;case 3:for(s=I=0;I<m;s=I+=1)e=t[g++],i=(s-s%u)/u,r=s<u?0:f[a-u],y=w&&f[(w-1)*m+i*u+s%u],f[a++]=(e+Math.floor((r+y)/2))%256;break;case 4:for(s=v=0;v<m;s=v+=1)e=t[g++],i=(s-s%u)/u,r=s<u?0:f[a-u],0===w?y=b=0:(y=f[(w-1)*m+i*u+s%u],b=i&&f[(w-1)*m+(i-1)*u+s%u]),o=r+y-b,h=Math.abs(o-r),d=Math.abs(o-y),p=Math.abs(o-b),l=h<=d&&h<=p?r:d<=p?y:b,f[a++]=(e+l)%256;break;default:throw new Error("Invalid filter algorithm: "+t[g-1])}w++}return f},o.prototype.decodePalette=function(){var t,e,a,i,s,r,n,o,h;for(a=this.palette,r=this.transparency.indexed||[],s=new Uint8Array((r.length||0)+a.length),i=0,a.length,t=0,e=n=0,o=a.length;n<o;e=n+=3)s[i++]=a[e],s[i++]=a[e+1],s[i++]=a[e+2],s[i++]=null!=(h=r[t++])?h:255;return s},o.prototype.copyToImageData=function(t,e){var a,i,s,r,n,o,h,l,c,d,p;if(i=this.colors,c=null,a=this.hasAlphaChannel,this.palette.length&&(c=null!=(p=this._decodedPalette)?p:this._decodedPalette=this.decodePalette(),i=4,a=!0),l=(s=t.data||t).length,n=c||e,r=o=0,1===i)for(;r<l;)h=c?4*e[r/4]:o,d=n[h++],s[r++]=d,s[r++]=d,s[r++]=d,s[r++]=a?n[h++]:this.transparency.grayscale&&this.transparency.grayscale===d?0:255,o=h;else for(;r<l;)h=c?4*e[r/4]:o,s[r++]=n[h++],s[r++]=n[h++],s[r++]=n[h++],s[r++]=a?n[h++]:this.transparency.rgb&&this.transparency.rgb[1]===n[h-3]&&this.transparency.rgb[3]===n[h-2]&&this.transparency.rgb[5]===n[h-1]?0:255,o=h},o.prototype.decode=function(){var t;return t=new Uint8Array(this.width*this.height*4),this.copyToImageData(t,this.decodePixels()),t},r=t.document&&t.document.createElement("canvas"),n=r&&r.getContext("2d"),s=function(t){var e;return n.width=t.width,n.height=t.height,n.clearRect(0,0,t.width,t.height),n.putImageData(t,0,0),(e=new Image).src=r.toDataURL(),e},o.prototype.decodeFrames=function(t){var e,a,i,r,n,o,h,l;if(this.animation){for(l=[],a=n=0,o=(h=this.animation.frames).length;n<o;a=++n)e=h[a],i=t.createImageData(e.width,e.height),r=this.decodePixels(new Uint8Array(e.data)),this.copyToImageData(i,r),e.imageData=i,l.push(e.image=s(i));return l}},o.prototype.renderFrame=function(t,s){var r,n,o;return r=(n=this.animation.frames)[s],o=n[s-1],0===s&&t.clearRect(0,0,this.width,this.height),(null!=o?o.disposeOp:void 0)===a?t.clearRect(o.xOffset,o.yOffset,o.width,o.height):(null!=o?o.disposeOp:void 0)===i&&t.putImageData(o.imageData,o.xOffset,o.yOffset),r.blendOp===e&&t.clearRect(r.xOffset,r.yOffset,r.width,r.height),t.drawImage(r.image,r.xOffset,r.yOffset)},o.prototype.animate=function(t){var e,a,i,s,r,n,o=this;return a=0,n=this.animation,s=n.numFrames,i=n.frames,r=n.numPlays,(e=function(){var n,h;if(n=a++%s,h=i[n],o.renderFrame(t,n),s>1&&a/s<r)return o.animation._timeout=setTimeout(e,h.delay)})()},o.prototype.stopAnimation=function(){var t;return clearTimeout(null!=(t=this.animation)?t._timeout:void 0)},o.prototype.render=function(t){var e,a;return t._png&&t._png.stopAnimation(),t._png=this,t.width=this.width,t.height=this.height,e=t.getContext("2d"),this.animation?(this.decodeFrames(e),this.animate(e)):(a=e.createImageData(this.width,this.height),this.copyToImageData(a,this.decodePixels()),e.putImageData(a,0,0))},o}(self);const g=new Set(["jpg","png","bmp","gif"]);async function w(t,a){if(!u.isPlatformLittleEndian)throw new e("rasterCoded:decode","lerc decoder is not supported on big endian platform");await o.load();const{offset:r}=a,{width:n,height:h,pixelType:l,statistics:c,depthCount:d,noDataValues:p,bandMasks:f,pixels:g,mask:w}=o.decode(t,{inputOffset:r,returnInterleaved:a.returnInterleaved}),m=new i({width:n,height:h,pixelType:l.toLowerCase(),pixels:g,mask:w,statistics:c.map((({minValue:t,maxValue:e})=>new s.SimpleBandStatistics(t,e))),bandMasks:f,depthCount:d,noDataValues:p});return c?.length||m.updateStatistics(),m}async function m(t,e){const s=await p.decode(t,{...e,noDataValue:null});a.assertIsSome(s);const r=new i({width:s.width,height:s.height,pixels:s.pixels,pixelType:s.pixelType.toLowerCase(),mask:s.mask,bandMasks:s.bandMasks,statistics:null});return r.updateStatistics(),r}async function y(t,e){const a=await p.decodeTileOrStrip(t,e.customOptions),s=new i({width:a.width,height:a.height,pixels:a.pixels,pixelType:a.pixelType.toLowerCase(),mask:a.mask,statistics:null});return s.updateStatistics(),s}function b(t,e){const a=e.pixelType||"u8",s=i.getPixelArrayConstructor(a),r="u8"===a?t:new s(t.buffer),n=[],o=e.planes||1;if(1===o)n.push(r);else for(let i=0;i<o;i++){const a=(e.width||1)*(e.height||t.length),h=new s(a);for(let t=0;t<a;t++)h[t]=r[t*o+i];n.push(h)}const h=new i({width:e.width||1,height:e.height||t.length,pixels:n,pixelType:a,statistics:null});return h.updateStatistics(),h}function x(t,e){return b(new c.Zlib(new Uint8Array(t)).getBytes(),e)}function k(t,e){return b(h.decode(t,e.offset,e.eof,!e.isInputBigEndian),e)}function T(t,e,a){const{pixelTypeCtor:s}=D(e.pixelType),r=(0,d.decode)(t,{width:e.width,height:e.height,pixelType:s,format:a}),n=new i({width:e.width,height:e.height,pixels:r.pixels,pixelType:e.pixelType,mask:r.mask,statistics:null});return n.updateStatistics(),n}function I(t,e){const a=n.decode(t,e.hasNoZlibMask??void 0),s=new i({width:a.width,height:a.height,pixels:a.pixels,pixelType:"u8",mask:a.mask,statistics:null});return s.updateStatistics(),s}function v(t,e){const a=new Uint8Array(t),s=new f(a),{width:r,height:n}=e,o=r*n,h=s.decode();let l,c=0,d=0;const p=new Uint8Array(o);for(c=0;c<o;c++)p[c]=h[4*c+3];const u=new i({width:r,height:n,pixels:[],pixelType:"u8",mask:p,statistics:[]});for(c=0;c<3;c++){for(l=new Uint8Array(o),d=0;d<o;d++)l[d]=h[4*d+c];u.addData({pixels:l})}return u.updateStatistics(),u}async function C(t,e,a,s){const n=new r,o={applyJpegMask:!1,format:e,...a},h=await n.decode(t,o,s),l=new i(h);return l.updateStatistics(),l}function A(t){if(null==t)throw new e("rasterCodec:decode","parameter encodeddata is required.");const a=new Uint8Array(t,0,10);let i="";return 255===a[0]&&216===a[1]?i="jpg":137===a[0]&&80===a[1]&&78===a[2]&&71===a[3]?i="png":67===a[0]&&110===a[1]&&116===a[2]&&90===a[3]&&73===a[4]&&109===a[5]&&97===a[6]&&103===a[7]&&101===a[8]&&32===a[9]?i="lerc":76===a[0]&&101===a[1]&&114===a[2]&&99===a[3]&&50===a[4]&&32===a[5]?i="lerc2":73===a[0]&&73===a[1]&&42===a[2]&&0===a[3]||77===a[0]&&77===a[1]&&0===a[2]&&42===a[3]||73===a[0]&&73===a[1]&&43===a[2]&&0===a[3]||77===a[0]&&77===a[1]&&0===a[2]&&43===a[3]?i="tiff":71===a[0]&&73===a[1]&&70===a[2]?i="gif":66===a[0]&&77===a[1]?i="bmp":String.fromCharCode.apply(null,a).toLowerCase().includes("error")&&(i="error"),i}function U(t){let a=null;switch(t){case"lerc":case"lerc2":a=w;break;case"jpg":a=I;break;case"png":a=v;break;case"bsq":case"bip":a=(e,a)=>T(e,a,t);break;case"tiff":a=m;break;case"deflate":a=x;break;case"lzw":a=k;break;case"error":a=()=>{throw new e("rasterCodec:decode","input data contains error")};break;default:a=()=>{throw new e("rasterCodec:decode","unsupported raster format")}}return a}function D(t){let e=null,a=null;switch(t?t.toLowerCase():"f32"){case"u1":case"u2":case"u4":case"u8":a=255,e=Uint8Array;break;case"u16":a=a||65535,e=Uint16Array;break;case"u32":a=a||2**32-1,e=Uint32Array;break;case"s8":a=a||-128,e=Int8Array;break;case"s16":a=a||-32768,e=Int16Array;break;case"s32":a=a||0-2**31,e=Int32Array;break;default:e=Float32Array}return{pixelTypeCtor:e,noDataValue:a}}function S(t,e=1){if(!t)return;const{pixels:a,width:s,height:r,mask:n}=t;if(!a||0===a.length)return;const o=a.length,h=s-1,l=r-1,c=[];let d,p,u,f,g,w,m=null;const y=i.getPixelArrayConstructor(t.pixelType);if(0===e){for(d=0;d<o;d++){for(g=a[d],w=new y(h*l),p=0;p<l;p++)for(f=p*s,u=0;u<h;u++)w[p*h+u]=g[f+u];c.push(w)}if(null!=n)for(m=new Uint8Array(h*l),p=0;p<l;p++)for(f=p*s,u=0;u<h;u++)m[p*h+u]=n[f+u]}else{for(d=0;d<o;d++){for(g=a[d],w=new y(h*l),p=0;p<l;p++)for(f=p*s,u=0;u<h;u++)w[p*h+u]=(g[f+u]+g[f+u+1]+g[f+s+u]+g[f+s+u+1])/4;c.push(w)}if(n)for(m=new Uint8Array(h*l),p=0;p<l;p++)for(f=p*s,u=0;u<h;u++)m[p*h+u]=Math.min.apply(null,[n[f+u],n[f+u+1],n[f+s+u],n[f+s+u+1]])}t.width=h,t.height=l,t.mask=m,t.pixels=c}function O(t){let e=A(t);return"lerc2"===e?e="lerc":"error"===e&&(e=""),e}async function P(t,a={},s){if(null==t)throw new e("rasterCodec:decode","missing encodeddata parameter.");let r=a.format?.toLowerCase();if(!("bsq"!==r&&"bip"!==r||null!=a.width&&null!=a.height))throw new e("rasterCodec:decode","requires width and height in options parameter.");if("tiff"===r&&a.customOptions)return y(t,a);if((!r||"bsq"!==r&&"bip"!==r&&"deflate"!==r&&"lzw"!==r)&&(r=A(t)),a.useCanvas&&g.has(r))return C(t,r,a,s);const n=U(r);let o;a.isPoint&&(null!=(a={...a}).width&&a.width++,null!=a.height&&a.height++);const{offsets:h}=a;if(h&&h.length>1){const e=h.map(((e,i)=>n(t.slice(e,h[i+1]),a))),s=await Promise.all(e);o=s[0],o.pixels=s.map((t=>t.pixels[0]));const r=s.map((t=>t.mask));s.some((t=>null!=t))&&(r.forEach(((t,e)=>{null==t&&(r[e]=new Uint8Array(o.width*o.height).fill(255))})),o.bandMasks=r,o.mask=i.combineBandMasks(r)),o.updateStatistics()}else o=await n(t,{...a,offset:h?.[0]??a.offset});return"jpg"!==r&&null!=a.noDataValue&&1===o.depthCount&&l.convertNoDataToMask(o,a.noDataValue,{customFloatTolerance:a.tolerance}),a.isPoint&&S(o),o}t.decode=P,t.getFormat=O,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
