/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/Logger","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","./bandIndexUtils","./BaseRasterFunction","./ExtractBandFunctionArguments","./pixelUtils"],(function(t,e,n,s,r,a,o,i,l,u){"use strict";let c=class extends i{constructor(){super(...arguments),this.functionName="ExtractBand",this.functionArguments=null,this.rasterArgumentNames=["raster"]}_bindSourceRasters(){const{functionArguments:t,sourceRasterInfos:e}=this,n=e[0],{method:s,bandNames:r,bandWavelengths:a,bandIds:o,missingBandAction:i}=t,l=r?.length&&("name"===s||"id"!==s&&!o?.length),c=a?.length&&("wavelength"===s||"id"!==s&&!o?.length),m=i===u.MissingBandAction.fail,p=l?d(n,r):c?g(n,a,this.functionArguments,m):h(n,o,m);if(null==p){return{success:!1,supportsGPU:!1,error:`extract-band-function: Invalid ${l?"band names":c?"band wavelengths":"band ids"} for the imagery data source`}}this.functionArguments.bandIds=p,this.functionArguments.method="id",this.outputPixelType=this._getOutputPixelType("f32");const f=n.clone();f.pixelType=this.outputPixelType,f.bandCount=p.length;const{statistics:b,histograms:x}=f;null!=b&&b.length&&(f.statistics=p.map((t=>b[t]||b[b.length-1]))),null!=x&&x.length&&(f.histograms=p.map((t=>x[t]||x[x.length-1]))),f.multidimensionalInfo&&f.multidimensionalInfo.variables.forEach((t=>{const{statistics:e,histograms:n}=t;null!=e&&e.length&&(t.statistics=p.map((t=>e[t]||e[e.length-1]))),null!=n&&n.length&&(t.histograms=p.map((t=>n[t]||n[n.length-1])))}));let I=f.keyProperties?.BandProperties;I?.length&&(I=p.map((t=>t>=I.length?I[I.length-1]:I[t])),f.keyProperties={...f.keyProperties,BandProperties:I}),this.rasterInfo=f;return{success:!0,supportsGPU:f.bandCount<=3}}_processPixels(t){const e=t.pixelBlocks?.[0];if(null==e)return null;const n=e.pixels.length,s=this.functionArguments.bandIds.map((t=>t>=n?n-1:t));return e.extractBands(s)}_getWebGLParameters(){let t;if(this.isInputBandIdsSwizzled)t=this.swizzledBandSelection.length?this.swizzledBandSelection:[0,1,2];else{t=[...this.functionArguments.bandIds],0===t.length?t=[0,1,2]:t.length<3&&(t[1]=t[1]??t[0],t[2]=t[2]??t[1]);for(let e=0;e<3;e++)t[e]=Math.min(t[e],2)}return{bandIndexMat3:o.getBandMatrix3(t)}}_getInputBandIds(t){const e=t.length;return this.functionArguments.bandIds.map((t=>t>=e?e-1:t)).map((e=>t[e]))}};t.__decorate([e.property({json:{write:!0,name:"rasterFunction"}})],c.prototype,"functionName",void 0),t.__decorate([e.property({type:l,json:{write:!0,name:"rasterFunctionArguments"}})],c.prototype,"functionArguments",void 0),t.__decorate([e.property()],c.prototype,"rasterArgumentNames",void 0),c=t.__decorate([a.subclass("esri.layers.support.rasterFunctions.ExtractBandFunction")],c);function d(t,e){const n=t.bandInfos.map((({name:t})=>t.toLowerCase())),s=[];for(let r=0;r<e.length;r++){const t=e[r].toLowerCase();let a=n.indexOf(t);if(-1===a&&"nearinfrared"===t&&(a=n.findIndex((t=>t.startsWith("nearinfrared_1"))),-1===a&&(a=n.findIndex((t=>t.startsWith("nearinfrared"))))),-1===a)return null;s.push(a)}return s}function h(t,e,n){const{bandCount:s}=t;return!e?.length||n&&e.some((t=>t<0||t>=s))?null:e}function g(t,e,{wavelengthMatchTolerance:n},s){const{bandInfos:r}=t,a=[];for(let i=0;i<r.length;i++){const{minWavelength:t,maxWavelength:e}=r[i];if(!t||!e)return null;a.push({minWavelength:t,maxWavelength:e})}const o=[];for(let i=0;i<e.length;i++){const t=e[i];let r=!1,l=-1,u=Number.MAX_VALUE;for(let e=0;e<a.length;e++){const n=a[e],s=t>=n.minWavelength&&t<=n.maxWavelength,o=Math.abs(t-(n.minWavelength+n.maxWavelength)/2);s?o<u&&(r=!0,l=e,u=o):!r&&o<u&&(l=e,u=o)}if(!r&&n&&u<n&&(r=!0),!r&&s)return null;o.push(l)}return o}return c}));
