/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../core/jsonMap","../PixelBlock","../rasterFormats/pixelRangeUtils","./customBandIndexUtils","./pixelUtils"],(function(n,e,t,r,a,i){"use strict";const l=new e.JSONMap({0:"custom",1:"ndvi",2:"savi",3:"tsavi",4:"msavi",5:"gemi",6:"pvi",7:"gvitm",8:"sultan",9:"vari",10:"gndvi",11:"sr",12:"ndvi-re",13:"sr-re",14:"mtvi2",15:"rtvi-core",16:"ci-re",17:"ci-g",18:"ndwi",19:"evi",20:"iron-oxide",21:"ferrous-minerals",22:"clay-minerals",23:"wndwi",24:"bai",25:"nbr",26:"ndbi",27:"ndmi",28:"ndsi",29:"mndwi"},{useNumericKeys:!0});function o(n,e){if(!i.isValidPixelBlock(n))return n;const{equation:l,method:o}=e,s=e.bandIndexes.map((n=>n-1)),{pixels:c,mask:B}=n;let I;switch(o){case"gndvi":case"nbr":case"ndbi":case"ndvi":case"ndvi-re":case"ndsi":case"ndmi":case"mndwi":I=u(B,c[s[0]],c[s[1]]);break;case"ndwi":I=u(B,c[s[1]],c[s[0]]);break;case"sr":case"sr-re":case"iron-oxide":case"ferrous-minerals":case"clay-minerals":I=f(B,c[s[0]],c[s[1]]);break;case"ci-g":case"ci-re":I=d(B,c[s[0]],c[s[1]]);break;case"savi":I=h(B,c[s[0]],c[s[1]],s[2]+1);break;case"tsavi":I=w(B,c[s[0]],c[s[1]],s[2]+1,s[3]+1,s[4]+1);break;case"msavi":I=g(B,c[s[0]],c[s[1]]);break;case"gemi":I=y(B,c[s[0]],c[s[1]]);break;case"pvi":I=m(B,c[s[0]],c[s[1]],s[2]+1,s[3]+1);break;case"gvitm":I=b(B,[c[s[0]],c[s[1]],c[s[2]],c[s[3]],c[s[4]],c[s[5]]]);break;case"sultan":I=p(B,[c[s[0]],c[s[1]],c[s[2]],c[s[3]],c[s[4]]]);break;case"vari":I=v(B,[c[s[0]],c[s[1]],c[s[2]]]);break;case"mtvi2":I=k(B,[c[s[0]],c[s[1]],c[s[2]]]);break;case"rtvi-core":I=A(B,[c[s[0]],c[s[1]],c[s[2]]]);break;case"evi":I=x(B,[c[s[0]],c[s[1]],c[s[2]]]);break;case"wndwi":I=F(B,[c[s[0]],c[s[1]],c[s[2]]],s[3]?s[3]+1:.5);break;case"bai":I=M(B,c[s[0]],c[s[1]]);break;case"custom":I=a.calculateCustomBandIndex(B,c,l);break;default:return n}const{outputPixelType:T="f32"}=e,P=null!=T&&r.isIntegerPixelType(T);let U;B?(U=new Uint8Array(n.width*n.height),U.set(B)):P&&(U=new Uint8Array(n.width*n.height).fill(255)),P&&(I=I.map((n=>{const e=t.createEmptyBand(T,n.length);return r.clipBandToPixelTypeRange(n,U,T,e),e})));const q=new t({width:n.width,height:n.height,pixelType:T,pixels:I,mask:U});return q.updateStatistics(),q}function s(n,e,r,a){const{mask:i,pixels:l,width:o,height:s}=n,c=l[r],u=l[e],f=u.length,d=a?new Uint8Array(f):new Float32Array(f),h=a?100:1,w=a?100.5:0;for(let t=0;t<f;t++)if(null==i||i[t]){const n=c[t],e=u[t],r=n+e;r&&(d[t]=(n-e)/r*h+w)}const g=new t({width:o,height:s,mask:i,pixelType:a?"u8":"f32",pixels:[d]});return g.updateStatistics(),g}function c(n){const e=new Float32Array(9);return e[3*n[0]]=1,e[3*n[1]+1]=1,e[3*n[2]+2]=1,e}function u(n,e,t){const r=t.length,a=new Float32Array(r);for(let i=0;i<r;i++)if(null==n||n[i]){const n=e[i],r=t[i],l=n+r;l&&(a[i]=(n-r)/l)}return[a]}function f(n,e,t){const r=t.length,a=new Float32Array(r);for(let i=0;i<r;i++)if(null==n||n[i]){const n=e[i],r=t[i];r&&(a[i]=n/r)}return[a]}function d(n,e,t){const r=e.length,a=new Float32Array(r);for(let i=0;i<r;i++)if(null==n||n[i]){const n=e[i],r=t[i];r&&(a[i]=n/r-1)}return[a]}function h(n,e,t,r){const a=t.length,i=new Float32Array(a);for(let l=0;l<a;l++)if(null==n||n[l]){const n=t[l],a=e[l],o=a+n+r;o&&(i[l]=(a-n)/o*(1+r))}return[i]}function w(n,e,t,r,a,i){const l=t.length,o=new Float32Array(l),s=-a*r+i*(1+r*r);for(let c=0;c<l;c++)if(null==n||n[c]){const n=t[c],i=e[c],l=a*i+n+s;l&&(o[c]=r*(i-r*n-a)/l)}return[o]}function g(n,e,t){const r=t.length,a=new Float32Array(r);for(let i=0;i<r;i++)if(null==n||n[i]){const n=t[i],r=e[i],l=2*r+1;a[i]=.5*(l-Math.sqrt(l*l-8*(r-n)))}return[a]}function y(n,e,t){const r=t.length,a=new Float32Array(r);for(let i=0;i<r;i++)if(null==n||n[i]){const n=t[i],r=e[i];if(1!==n&&r+n+.5!==0){const e=(2*(r*r-n*n)+1.5*r+.5*n)/(r+n+.5);a[i]=e*(1-.25*e)-(n-.125)/(1-n)}}return[a]}function m(n,e,t,r,a){const i=t.length,l=new Float32Array(i),o=1/Math.sqrt(1+r*r);for(let s=0;s<i;s++)if(null==n||n[s]){const n=t[s],i=e[s];l[s]=(i-r*n-a)*o}return[l]}function b(n,e){const[t,r,a,i,l,o]=e,s=t.length,c=new Float32Array(s);for(let u=0;u<s;u++)(null==n||n[u])&&(c[u]=-.2848*t[u]-.2435*r[u]-.5436*a[u]+.7243*i[u]+.084*l[u]-.18*o[u]);return[c]}function p(n,e){const[t,r,a,i,l]=e,o=t.length,s=new Float32Array(o),c=new Float32Array(o),u=new Float32Array(o);for(let f=0;f<o;f++)(null==n||n[f])&&(s[f]=l[f]?i[f]/l[f]*100:0,c[f]=t[f]?i[f]/t[f]*100:0,u[f]=a[f]?r[f]/a[f]*(i[f]/a[f])*100:0);return[s,c,u]}function v(n,e){const[t,r,a]=e,i=t.length,l=new Float32Array(i);for(let o=0;o<i;o++)if(null==n||n[o])for(o=0;o<i;o++){const n=t[o],e=r[o],i=e+n-a[o];i&&(l[o]=(e-n)/i)}return[l]}function k(n,e){const[t,r,a]=e,i=t.length,l=new Float32Array(i);for(let o=0;o<i;o++)if(null==n||n[o])for(o=0;o<i;o++){const n=t[o],e=r[o],i=a[o],s=Math.sqrt((2*n+1)**2-(6*n-5*Math.sqrt(e))-.5);if(s){const t=1.5*(1.2*(n-i)-2.5*(e-i));l[o]=t/s}}return[l]}function A(n,e){const[t,r,a]=e,i=t.length,l=new Float32Array(i);for(let o=0;o<i;o++)if(null==n||n[o])for(o=0;o<i;o++){const n=t[o],e=r[o],i=a[o];l[o]=100*(n-e)-10*(n-i)}return[l]}function x(n,e){const[t,r,a]=e,i=t.length,l=new Float32Array(i);for(let o=0;o<i;o++)if(null==n||n[o])for(o=0;o<i;o++){const n=t[o],e=r[o],i=n+6*e-7.5*a[o]+1;i&&(l[o]=2.5*(n-e)/i)}return[l]}function F(n,e,t=.5){const[r,a,i]=e,l=a.length,o=new Float32Array(l);for(let s=0;s<l;s++)if(null==n||n[s])for(s=0;s<l;s++){const n=r[s],e=a[s],l=i[s],c=n+t*e+(1-t)*l;c&&(o[s]=(n-t*e-(1-t)*l)/c)}return[o]}function M(n,e,t){const r=t.length,a=new Float32Array(r);for(let i=0;i<r;i++)if(null==n||n[i])for(i=0;i<r;i++){const n=(.1-e[i])**2+(.06-t[i])**2;n&&(a[i]=1/n)}return[a]}n.bandIndexMethodMap=l,n.calculateBandIndex=o,n.calculateNDVI=s,n.getBandMatrix3=c,Object.defineProperty(n,Symbol.toStringTag,{value:"Module"})}));
