/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../core/colorUtils","../../../core/Error","../../../core/lang","./ArithmeticFunction","./AspectFunction","./BandArithmeticFunction","./ClipFunction","./ColormapFunction","./ColormapToRGBFunction","./CompositeBandFunction","./ComputeChangeFunction","./ContrastBrightnessFunction","./ConvolutionFunction","./CurvatureFunction","./ExtractBandFunction","./GrayscaleFunction","./HillshadeFunction","./LocalFunction","./MaskFunction","./NDVIFunction","./RemapFunction","./ShadedReliefFunction","./SlopeFunction","./StatisticsFunction","./StatisticsHistogramFunction","./StretchFunction","./TableFunction"],(function(t,e,r,n,s,o,a,i,c,u,l,m,p,f,d,g,F,h,y,A,b,C,_,R,j,N,S,v){"use strict";const w=new Map;function T(t,e){const{rasterFunctionArguments:r}=t;if(!r)return;(r.rasters||[r.raster,r.raster2]).forEach((t=>{t&&"number"!=typeof t&&("string"==typeof t?t.startsWith("http")&&(e.includes(t)||e.push(t)):"rasterFunctionArguments"in t&&T(t,e))}))}function V(t,e){if(e=e??{},"function"in(t=n.clone(t))&&"arguments"in t&&t.arguments){const n=H(t,new Map,e);if(G(n),!n.renderingRule)throw new r("raster-function-helper","Unsupported raster function json.");t=n.renderingRule}if("rasterFunction"in t)return x(t=k(t),e);throw new r("raster-function-helper","unsupported raster function json.")}function B(t,e){return"rasters"===e[0]&&Array.isArray(t.rasters)?t.rasters:e.map((e=>t[e]))}function D(t){return!!(t&&"object"==typeof t&&t.rasterFunction&&t.rasterFunctionArguments)}function k(t){const{rasterFunction:e,rasterFunctionArguments:r}=t,n={};for(const s in r){let t=r[s];const e=s.toLowerCase();if("rasters"===e&&Array.isArray(t))n.rasters=t.map((t=>D(t)?k(t):t));else switch(D(t)&&(t=k(t)),e){case"dra":n.dra=t;break;case"pspower":n.psPower=t;break;case"pszfactor":n.psZFactor=t;break;case"bandids":n.bandIds=t;break;default:n[s[0].toLowerCase()+s.slice(1)]=t}}return"Local"!==e||n.rasters?.length||(n.rasters=["$$"]),{...t,rasterFunctionArguments:n}}function x(t,e){const{rasterFunction:n,rasterFunctionArguments:s}=t,o=t.outputPixelType?.toLowerCase();if(null==n||!w.has(n))throw new r("raster-function-helper",`unsupported raster function: ${n}`);const a=w.get(n),i=("function"==typeof a.ctor?a.ctor:a.ctor.default).fromJSON({...t,outputPixelType:o}),{rasterArgumentNames:c}=i,u=[],l=B(s,c),m="rasters"===c[0]||c.length>1,p=[];for(let r=0;r<l.length;r++){const t=l[r];let n;null==t||"string"==typeof t&&t.startsWith("$")?u.push(e?.raster):"string"==typeof t?e[t]&&u.push(e[t]):"number"!=typeof t&&"rasterFunction"in t&&(n=x(t,e),m||(i.functionArguments[c[r]]=n),u.push(n)),m&&p.push(n??t)}if(m&&("rasters"===c[0]?i.functionArguments.rasters=p:c.forEach(((t,e)=>{i.functionArguments[t]=p[e]}))),e){i.sourceRasters=u;const t=e.raster?.url;t&&(i.mainPrimaryRasterId=t)}return i}function M(t,e){if(t&&e)for(const r in t){const n=t[r];n&&"object"==typeof n&&"type"in n&&("RasterFunctionTemplate"===n.type?M(n.arguments,e):"RasterFunctionVariable"===n.type&&null!=e[n.name]&&(n.value=e[n.name]))}}function E(t,e){if(!t||"object"!=typeof t)return t;const{value:n}=t;if(!n||"object"!=typeof n)return t.isDataset?"$$":n;if(Array.isArray(n))return 0===n.length?[]:n.map((t=>"object"==typeof t&&"RasterFunctionVariable"===t.type?E(t,e):t));if("value"in n&&["number","string","boolean"].includes(typeof n.value))return n.value;if(t.isDataset&&"Scalar"!==n.type)return"$$";if(!("type"in n))return n;let s=n;switch(n.type){case"Scalar":s=n.value;break;case"AlgorithmicColorRamp":s=$(n);break;case"MultiPartColorRamp":s={type:"multipart",colorRamps:n.ArrayOfColorRamp.map($)};break;case"ArgumentArray":if(n.elements?.length&&"RasterStatistics"!==n.elements[0].type){const t=[];for(let s=0;s<n.elements.length;s++){const o=n.elements[s],{type:a}=o;if(a)if("RasterFunctionTemplate"===a){const{renderingRule:r}=H(o,e);t.push(r),null!=o._object_id&&e.set(o._object_id,r)}else{if("RasterFunctionVariable"!==a)throw new r("raster-function-helper","unsupported raster function json.");{const r=E(o,e);t.push(r),null!=o._object_id&&e.set(o._object_id,r)}}else t.push(o)}s=t}else s=n.elements}return null!=n._object_id&&e.set(n._object_id,s),s}function $(t){const r=t.algorithm??"esriHSVAlgorithm";let{FromColor:n,ToColor:s}=t;if(!Array.isArray(n)){const{r:t,g:r,b:s}=e.toRGB({h:n.Hue,s:n.Saturation,v:n.Value});n=[t,r,s,n.AlphaValue]}if(!Array.isArray(s)){const{r:t,g:r,b:n}=e.toRGB({h:s.Hue,s:s.Saturation,v:s.Value});s=[t,r,n,s.AlphaValue]}return{type:"algorithmic",algorithm:r,fromColor:n,toColor:s}}function H(t,e,r){r&&M(t,r);const n={renderingRule:{},templates:e};return O(t,n),n}function O(t,e){if(!t||!e.renderingRule)return;const{renderingRule:r,templates:n}=e,{function:s,arguments:o,_object_id:a}=t;if(!s||!o)return;null!=a&&n.set(a,r),r.rasterFunction=s.type.replace("Function",""),r.outputPixelType=s.pixelType;const i={};r.rasterFunctionArguments=i;for(const c in o){if("type"===c||"object_id"===c||"_object_ref_id"===c)continue;const t=o[c];t&&"object"==typeof t&&"type"in t&&("RasterFunctionTemplate"===t.type||"RasterFunctionVariable"===t.type)?("RasterFunctionVariable"===t.type?i[c]=E(t,n):(r.rasterFunctionArguments[c]={},O(t,{renderingRule:r.rasterFunctionArguments[c],templates:n})),null!=t._object_id&&n.set(t._object_id,i[c])):i[c]=t}switch(i.DEM&&!i.Raster&&(i.Raster=i.DEM,delete i.DEM),r.rasterFunction){case"Stretch":L(i);break;case"Colormap":P(i);break;case"Convolution":I(i);break;case"Mask":U(i)}}function G(t){const{renderingRule:e,templates:n}=t;if("object"!=typeof e||!e?.rasterFunctionArguments||!n.size)return;const{rasterFunctionArguments:s}=e;for(const o in s){const t=s[o],e="_object_ref_id"===o?t:t&&"object"==typeof t&&"_object_ref_id"in t?t._object_ref_id:null;if(null==e)t&&"object"==typeof t&&(t.rasterFunctionArguments&&G({renderingRule:t,templates:n}),Array.isArray(t)&&t.forEach(((s,o)=>{if("object"==typeof s)if(null!=s._object_ref_id){if(!n.has(s._object_ref_id))throw new r("raster-function-helper",`unsupported raster function json. _object_ref_id: ${t} does not exist`);const a=n.get(e);a&&"object"==typeof a?Object.assign(s,a):t[o]=a}else G({renderingRule:s,templates:n})})));else{if(!n.has(e))throw new r("raster-function-helper",`unsupported raster function json. _object_ref_id: ${e} does not exist`);const t=n.get(e);"_object_ref_id"!==o?s[o]=t:t&&"object"==typeof t&&Object.assign(s,t)}}}function L(t){t.Statistics?.length&&"object"==typeof t.Statistics&&(t.Statistics=t.Statistics.map((t=>[t.min,t.max,t.mean,t.standardDeviation]))),null!=t.NumberOfStandardDeviation&&(t.NumberOfStandardDeviations=t.NumberOfStandardDeviation,delete t.NumberOfStandardDeviation)}function P(t){"randomcolorramp"===t.ColorRamp?.type?.toLowerCase()&&(delete t.ColorRamp,t.ColormapName="Random"),0===t.ColorSchemeType&&delete t.ColorRamp}function I(t){null!=t.ConvolutionType&&(t.Type=t.ConvolutionType,delete t.ConvolutionType)}function U(t){t.NoDataValues?.length&&"string"==typeof t.NoDataValues[0]&&(t.NoDataValues=t.NoDataValues.filter((t=>""!==t)).map((t=>Number(t))))}w.set("Arithmetic",{desc:"Arithmetic Function",ctor:s,rasterArgumentNames:["rasters"]}),w.set("Aspect",{desc:"Aspect Function",ctor:o,rasterArgumentNames:["raster"]}),w.set("BandArithmetic",{desc:"Band Arithmetic Function",ctor:a,rasterArgumentNames:["raster"]}),w.set("Colormap",{desc:"Colormap Function",ctor:c,rasterArgumentNames:["raster"]}),w.set("ColormapToRGB",{desc:"ColormapToRGB Function",ctor:u,rasterArgumentNames:["raster"]}),w.set("CompositeBand",{desc:"CompositeBand Function",ctor:l,rasterArgumentNames:["rasters"]}),w.set("ComputeChange",{desc:"ComputeChange Function",ctor:m,rasterArgumentNames:["rasters"]}),w.set("Convolution",{desc:"Convolution Function",ctor:f,rasterArgumentNames:["raster"]}),w.set("ContrastBrightness",{desc:"Contrast Brightness Function",ctor:p,rasterArgumentNames:["raster"]}),w.set("ExtractBand",{desc:"ExtractBand Function",ctor:g,rasterArgumentNames:["raster"]}),w.set("Curvature",{desc:"Curvature Function",ctor:d,rasterArgumentNames:["raster"]}),w.set("Hillshade",{desc:"Hillshade Function",ctor:h,rasterArgumentNames:["raster"]}),w.set("ShadedRelief",{desc:"ShadedRelief Function",ctor:_,rasterArgumentNames:["raster"]}),w.set("Grayscale",{desc:"Grayscale Function",ctor:F,rasterArgumentNames:["raster"]}),w.set("Clip",{desc:"Clip Function",ctor:i,rasterArgumentNames:["raster"]}),w.set("Local",{desc:"Local Function",ctor:y,rasterArgumentNames:["rasters"]}),w.set("Mask",{desc:"Mask Function",ctor:A,rasterArgumentNames:["raster"]}),w.set("NDVI",{desc:"NDVI Function",ctor:b,rasterArgumentNames:["raster"]}),w.set("Remap",{desc:"Remap Function",ctor:C,rasterArgumentNames:["raster"]}),w.set("Slope",{desc:"Slope Function",ctor:R,rasterArgumentNames:["raster"]}),w.set("Statistics",{desc:"Focal Statistics Function",ctor:j,rasterArgumentNames:["raster"]}),w.set("StatisticsHistogram",{desc:"Statistics Histogram Function",ctor:N,rasterArgumentNames:["raster"]}),w.set("Stretch",{desc:"Stretch Function",ctor:S,rasterArgumentNames:["raster"]}),w.set("Table",{desc:"Attribute Table Function",ctor:v,rasterArgumentNames:["raster"]}),t.create=V,t.getPrimaryRasterUrls=T,t.getRasterValues=B,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
