/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","exports","../../../geometry","../../../core/arrayUtils","../../../core/Error","../../../core/unitUtils","../../../chunks/pe","../../../geometry/projection","../../../geometry/support/spatialReferenceUtils","../../../geometry/Extent","../../../geometry/Polygon","../../../geometry/Point","../../../geometry/SpatialReference"],(function(e,t,n,o,i,r,s,a,l,c,f,u,x){"use strict";var m;function h(e,t,n){return!a.canProjectWithoutEngine(e,t,n)}function p(e,t,n){const o=h(e,t,n);if(o&&!a.isLoaded())throw new i("rasterprojectionhelper-project","projection engine is not loaded");return o}!function(e){e[e.None=0]="None",e[e.North=1]="North",e[e.South=2]="South",e[e.Both=3]="Both"}(m||(m={}));const g=(e,t,n,o=0)=>{if(1===n[0])return[0,0];let i=1,r=-1,s=1,a=-1;for(let g=0;g<e.length;g+=2)isNaN(e[g])||(i=i>e[g]?e[g]:i,r=r>e[g]?r:e[g],s=s>e[g+1]?e[g+1]:s,a=a>e[g+1]?a:e[g+1]);const{cols:l,rows:c}=t,f=(r-i)/l/n[0],u=(a-s)/c/n[1],x=2*o;let m=0,h=!1,p=[0,0];for(let g=0;g<l-3;g++){for(let t=0;t<c-3;t++){const n=g*c*2+2*t,o=(e[n]+e[n+4]+e[n+4*c]+e[n+4*c+4])/4,i=(e[n+1]+e[n+5]+e[n+4*c+1]+e[n+4*c+5])/4,r=Math.abs((o-e[n+2*c+2])/f),s=Math.abs((i-e[n+2*c+3])/u);if(r+s>m&&(m=r+s,p=[r,s]),x&&m>x){h=!0;break}}if(h)break}return p},y={3395:20037508.342789244,3410:17334193.943686873,3857:20037508.342788905,3975:17367530.445161372,4087:20037508.342789244,4088:20015108.787169147,6933:17367530.445161372,32662:20037508.342789244,53001:20015086.79602057,53002:10007543.39801029,53003:20015086.79602057,53004:20015086.79602057,53016:14152803.599503474,53017:17333573.624304302,53034:20015086.79602057,53079:20015114.352186374,53080:20015114.352186374,54001:20037508.342789244,54002:10018754.171394624,54003:20037508.342789244,54004:20037508.342789244,54016:14168658.027268292,54017:17367530.44516137,54034:20037508.342789244,54079:20037508.342789244,54080:20037508.342789244,54100:20037508.342789244,54101:20037508.342789244},d=32,P=4,M=P,w=new Map,R=new Map,S=500;let b=null;async function G(){b&&a.isLoaded()||(a.isLoaded()||await a.load(),b=await new Promise(((t,n)=>e(["../../../geometry/geometryEngine"],t,n))))}function E(e,t,n){p(e.spatialReference,t);return n?a.getTransformation(t,e.spatialReference,e):a.getTransformation(e.spatialReference,t,e)}function k(e,t,n,o=null){const i=e.spatialReference;if(!i||!t||i.equals(t))return e;p(i,t,o);const r=n.center,s=new c({xmin:r.x-e.x/2,xmax:r.x+e.x/2,ymin:r.y-e.y/2,ymax:r.y+e.y/2,spatialReference:i}),l=a.project(s,t,o),f=J(t);return null==l||null!=f&&l.width>=f?N(e,i,t):{x:l.width,y:l.height}}function N(e,t,n){const o=r.getMetersPerUnitForSR(t)/r.getMetersPerUnitForSR(n);return{x:e.x*o,y:e.y*o}}function T(e,t,n){const{spatialReference:o}=n;if(!o||!t||o.equals(t))return e;if(o.isGeographic&&t.isGeographic)return N(e,o,t);if(p(o,t),!b)throw new i("raster-projection-helper:project-dataset-resolution","geometry engine is not loaded");let{x:s,y:l}=e;const c=(s+l)/2*r.getMetersPerUnitForSR(o);let u=1;c>30&&(u=30/c,s*=u,l*=u);const x=256,m=s*x/2,h=l*x/2,{x:g,y}=n.center,d=[];for(let i=0;i<=x;i++)d.push([g-m,y-h+i*l]);for(let i=1;i<=x;i++)d.push([g-m+i*s,y+h]);for(let i=1;i<=x;i++)d.push([g+m,y+h-i*l]);for(let i=1;i<x;i++)d.push([g+m-i*s,y-h]);d.push(d[0]);const P=new f({rings:[d],spatialReference:o}),M=a.project(P,t);if(!M)return N(e,o,t);const w=M.extent,R=J(t);if(null==w||null!=R&&w.width>=R)return N(e,o,t);const S=b.planarArea(M),G=s*l*x*x,E=Math.sqrt(S/G)/u,k={x:w.width/u/x,y:w.height/u/x},T={x:s*E,y:l*E},j=k.x*k.y;return Math.abs(j-T.x*T.y)/j<.1?k:T}function j(e,t=.01){return r.getMetersPerUnitForSR(e)?t/r.getMetersPerUnitForSR(e):0}function C(e,t,n=null,o=!0){const i=e.spatialReference;if(i.equals(t))return e;p(i,t,n);const r=a.project(e,t,n);return o&&r?(v([e],[r],i,t),r):r}function v(e,t,n,o){const i=X(n,!0),r=X(o,!0),s=j(n,S),a=j(o,S);if(s&&null!=i&&null!=r)for(let l=0;l<e.length;l++){const n=t[l];if(!n)continue;const{x:o}=e[l],{x:c}=n;c>=r[1]-a&&Math.abs(o-i[0])<s?n.x-=r[1]-r[0]:c<=r[0]+a&&Math.abs(o-i[1])<s&&(n.x+=r[1]-r[0])}}function F(e){const{inSR:t,outSR:n,datumTransformation:o,preferPE:i}=e;if(t.equals(n)){const{points:t}=D(e,null);return t}if(t.isWebMercator&&n.isWGS84||t.isWGS84&&n.isWebMercator)return W(e);if(p(t,n,o)&&i){if(t.isGeographic)return L(e);if(null!=I(t))return L(e)}return _(e)}function _(e){const{points:t}=D(e,null),{inSR:n,outSR:o,datumTransformation:i}=e,r=t.map((e=>new u(e[0],e[1],n))),s=a.project(r,o,i);return i&&v(r,s,n,o),s.map((e=>e?[e.x,e.y]:[NaN,NaN]))}function L(e){const{inSR:t,outSR:n,datumTransformation:o}=e,i=I(t),{points:r,mask:a}=D(e,i);if(!t.isGeographic){const e=t.wkid?s.PeFactory.coordsys(t.wkid):s.PeFactory.fromString(t.isGeographic?s.PeDefs.PE_TYPE_GEOGCS:s.PeDefs.PE_TYPE_PROJCS,t.wkt2||t.wkt);s.PeCSTransformations.projToGeog(e,r.length,r)}if(null!=o&&o.steps.length){let e;const t=179.9955;if(n.isGeographic&&(e=r.map((([e])=>e>t?1:e<-t?-1:0))),o.steps.forEach((e=>{const t=e.wkid?s.PeFactory.geogtran(e.wkid):s.PeFactory.fromString(s.PeDefs.PE_TYPE_GEOGTRAN,e.wkt);s.PeGTTransformations.geogToGeog(t,r.length,r,null,e.isInverse?s.PeDefs.PE_TRANSFORM_2_TO_1:s.PeDefs.PE_TRANSFORM_1_TO_2)})),e)for(let n=0;n<r.length;n++){const o=e[n],i=r[n][0],s=i>t?1:i<-t?-1:0;o&&s&&o!==s&&(r[n][0]=o>0?i+360:i-360)}}if(!n.isGeographic){const e=I(n,!0),t=null!=e&&e.isEnvelope?[e.bbox[1],e.bbox[3]]:[-90,90];O(r,t);const o=n.wkid?s.PeFactory.coordsys(n.wkid):s.PeFactory.fromString(n.isGeographic?s.PeDefs.PE_TYPE_GEOGCS:s.PeDefs.PE_TYPE_PROJCS,n.wkt2||n.wkt);s.PeCSTransformations.geogToProj(o,r.length,r)}let l=r;if(a&&r.length!==a.length){l=[];for(let e=0,t=0;e<a.length;e++)a[e]?l.push(r[t++]):l.push([NaN,NaN])}return l}function W(e){const{cols:t,rows:n,xres:o,yres:i,usePixelCenter:r,inSR:s,outSR:l}=e;let{xmin:c,ymax:f}=e;r&&(c+=o/2,f-=i/2);const x=[],m=[],h=Math.max(t,n);for(let g=0;g<h;g++){const e=c+o*Math.min(t,g),r=f-i*Math.min(n,g),h=a.project(new u({x:e,y:r,spatialReference:s}),l);g<=t&&x.push(h.x),g<=n&&m.push(h.y)}const p=[];for(let a=0;a<t;a++)for(let e=0;e<n;e++)p.push([x[a],m[e]]);return p}function I(e,t=!1){let n=e.wkid||e.wkt2||e.wkt;if(!n||e.isGeographic)return null;if(n=String(n),w.has(n)){const e=w.get(n);return t?e?.gcs:e?.pcs}const o=e.wkid?s.PeFactory.coordsys(e.wkid):s.PeFactory.fromString(e.isGeographic?s.PeDefs.PE_TYPE_GEOGCS:s.PeDefs.PE_TYPE_PROJCS,e.wkt2||e.wkt),i=z(o,j(e,1e-4)),r=z(o,0,!0);return w.set(n,{pcs:i,gcs:r}),t?r:i}function z(e,t=0,n=!1){const o=s.PePCSInfo.generate(e),i=n?e.horizonGcsGenerate():e.horizonPcsGenerate();if(!o||!i?.length)return null;let r=!1,a=i.find((e=>1===e.getInclusive()&&1===e.getKind()));if(!a){if(a=i.find((e=>1===e.getInclusive()&&0===e.getKind())),!a)return null;r=!0}const l=n?0:(2===o.getNorthPoleLocation()?1:0)|(2===o.getSouthPoleLocation()?2:0),c=o.isPannableRectangle(),f=a.getCoord();if(r)return{isEnvelope:r,isPannable:c,vertices:f,coef:null,bbox:[f[0][0]-t,f[0][1]-t,f[1][0]+t,f[1][1]+t],poleLocation:l};let u=0;const x=[];let[m,h]=f[0],[p,g]=f[0];for(let s=0,y=f.length;s<y;s++){u++,u===y&&(u=0);const[e,t]=f[s],[n,o]=f[u];if(o===t)x.push([e,n,t,o,2]);else{const i=(n-e)/(o-t||1e-4),r=e-i*t;t<o?x.push([i,r,t,o,0]):x.push([i,r,o,t,1])}m=m<e?m:e,h=h<t?h:t,p=p>e?p:e,g=g>t?g:t}return{isEnvelope:!1,isPannable:c,vertices:f,coef:x,bbox:[m,h,p,g],poleLocation:l}}function D(e,t){const n=[],{cols:o,rows:i,xres:r,yres:s,usePixelCenter:a}=e;let{xmin:l,ymax:c}=e;if(a&&(l+=r/2,c-=s/2),null==t){for(let e=0;e<o;e++)for(let t=0;t<i;t++)n.push([l+r*e,c-s*t]);return{points:n}}const f=new Uint8Array(o*i);if(t.isEnvelope){const{bbox:[e,a,u,x]}=t;for(let m=0,h=0;m<o;m++){const o=l+r*m,p=t.isPannable||o>=e&&o<=u;for(let e=0;e<i;e++,h++){const t=c-s*e;p&&t>=a&&t<=x&&(n.push([o,t]),f[h]=1)}}return{points:n,mask:f}}const u=t.coef,x=[];for(let m=0;m<i;m++){const e=c-s*m,t=[],n=[];for(let i=0;i<u.length;i++){const[o,r,s,a,l]=u[i];if(e===s&&s===a)t.push(o),t.push(r),n.push(2),n.push(2);else if(e>=s&&e<=a){const i=o*e+r;t.push(i),n.push(l)}}let o=t;if(t.length>2){let e=2===n[0]?0:n[0],i=t[0];o=[];for(let r=1;r<n.length;r++)2===n[r]&&r!==n.length-1||(n[r]!==e&&(o.push(0===e?Math.min(i,t[r-1]):Math.max(i,t[r-1])),e=n[r],i=t[r]),r===n.length-1&&o.push(0===n[r]?Math.min(i,t[r]):Math.max(i,t[r])));o.sort(((e,t)=>e-t))}else t[0]>t[1]&&(o=[t[1],t[0]]);x.push(o)}for(let m=0,h=0;m<o;m++){const e=l+r*m;for(let t=0;t<i;t++,h++){const o=c-s*t,i=x[t];if(2===i.length)e>=i[0]&&e<=i[1]&&(n.push([e,o]),f[h]=1);else if(i.length>2){let t=!1;for(let n=0;n<i.length;n+=2)if(e>=i[n]&&e<=i[n+1]){t=!0;break}t&&(n.push([e,o]),f[h]=1)}}}return{points:n,mask:f}}function O(e,t){const[n,o]=t;for(let i=0;i<e.length;i++){const t=e[i][1];(t<n||t>o)&&(e[i]=[NaN,NaN])}}function A(e,t){const n=J(e[0].spatialReference);if(e.length<2||null==n)return e[0];if(t=t??j(e[0].spatialReference),1===(e=e.filter((e=>e.width>t))).length)return e[0];let{xmin:o,xmax:i,ymin:r,ymax:s}=e[0];for(let a=1;a<e.length;a++){const t=e[a];i=t.xmax+n*a,r=Math.min(r,t.ymin),s=Math.max(s,t.ymax)}return new c({xmin:o,xmax:i,ymin:r,ymax:s,spatialReference:e[0].spatialReference})}function U(e,t,n=null,i=!0){const r=e.spatialReference;if(r.equals(t))return e;const s=H(e),l=J(r,!0),f=J(t);if(0===s||null==l||null==f){const o=Y(e,t,n,i);if(null==l&&null!=f&&Math.abs(o.width-f)<j(t)&&a.isLoaded()){const n=I(r);if(null!=n&&n.poleLocation===m.None&&e.width<(n.bbox[2]-n.bbox[0])/2)return B(e,t)||o}return o}const u=e.clone().normalize();if(1===u.length&&e.xmax<l&&e.xmax-l/2>j(r)){const{xmin:t,xmax:n}=e;for(let o=0;o<=s;o++){const i=0===o?t:-l/2,a=o===s?n-l*o:l/2;u[o]=new c({xmin:i,xmax:a,ymin:e.ymin,ymax:e.ymax,spatialReference:r})}}return A(u.map((e=>Y(e,t,n,i))).filter(o.isSome))}function q(e,t,n){if("extent"===e.type){const{xmin:t,ymin:n,xmax:o,ymax:i,spatialReference:r}=e;e=new f({rings:[[[t,i],[o,i],[o,n],[t,n],[t,i]]],spatialReference:r})}return e.spatialReference.equals(t)?e:(p(e.spatialReference,t,n),a.project(e,t,n))}function B(e,t){const n=J(t);if(null==n)return null;let{xmin:o,ymin:i,xmax:r,ymax:s}=e;const l=e.spatialReference,u=new f({spatialReference:l,rings:[[[o,i],[r,i],[r,s],[o,s],[o,i]]]}),x=a.project(u,t);if(2!==x.rings.length||!x.rings[0].length||!x.rings[1].length)return null;const{rings:m}=x,h=j(l),p=new c({spatialReference:t});for(let a=0;a<2;a++){o=r=m[a][0][0],i=s=m[a][0][1];for(let e=0;e<m[a].length;e++)o=o>m[a][e][0]?m[a][e][0]:o,r=r<m[a][e][0]?m[a][e][0]:r,i=i>m[a][e][1]?m[a][e][1]:i,s=s<m[a][e][1]?m[a][e][1]:s;if(0===a)p.ymin=i,p.ymax=s,p.xmin=o,p.xmax=r;else if(p.ymin=Math.min(p.ymin,i),p.ymax=Math.max(p.ymax,s),Math.abs(r-n/2)<h)p.xmin=o,p.xmax=p.xmax+n;else{if(!(Math.abs(o+n/2)<h))return null;p.xmax=r+n}}return p}function Y(e,t,n=null,o=!0,i=!0){const r=e.spatialReference;if(r.equals(t)||!t)return e;p(r,t,n);const s=a.project(e,t,n);if(i&&t.isWebMercator&&s&&(s.ymax=Math.min(20037508.342787,s.ymax),s.ymin=Math.max(-20037508.342787,s.ymin),s.ymin>=s.ymax))return null;if(!o||!s)return s;const l=X(r,!0),c=X(t,!0);if(null==l||null==c)return s;const f=j(r,.001),x=j(r,S),m=j(t,.001);if(Math.abs(s.xmin-c[0])<m&&Math.abs(s.xmax-c[1])<m){const o=Math.abs(e.xmin-l[0]),i=Math.abs(l[1]-e.xmax);if(o<f&&i>x){s.xmin=c[0];const o=[];o.push(new u(e.xmax,e.ymin,r)),o.push(new u(e.xmax,(e.ymin+e.ymax)/2,r)),o.push(new u(e.xmax,e.ymax,r));const i=o.map((e=>C(e,t,n))).filter((e=>!isNaN(e?.x))).map((e=>e.x));s.xmax=Math.max.apply(null,i)}if(i<f&&o>x){s.xmax=c[1];const o=[];o.push(new u(e.xmin,e.ymin,r)),o.push(new u(e.xmin,(e.ymin+e.ymax)/2,r)),o.push(new u(e.xmin,e.ymax,r));const i=o.map((e=>C(e,t,n))).filter((e=>!isNaN(e?.x))).map((e=>e.x));s.xmin=Math.min.apply(null,i)}}else{const e=j(t,.001);Math.abs(s.xmin-c[0])<e&&(s.xmin=c[0]),Math.abs(s.xmax-c[1])<e&&(s.xmax=c[1])}return s}function J(e,t=!1){if(!e)return null;const n=t?20037508.342787:20037508.342788905;return e.isWebMercator?2*n:e.wkid&&e.isGeographic?360:2*y[e.wkid]||null}function X(e,t=!1){if(e.isGeographic)return[-180,180];const n=J(e,t);return null!=n?[-n/2,n/2]:null}function K(e,t,n,o){let i=(e-t)/n;return i-Math.floor(i)!=0?i=Math.floor(i):o&&(i-=1),i}function H(e,t=!1){const n=J(e.spatialReference);if(null==n)return 0;const o=t?0:-(n/2),i=j(e.spatialReference),r=!t&&Math.abs(e.xmax-n/2)<i?n/2:e.xmax,s=!t&&Math.abs(e.xmin+n/2)<i?-n/2:e.xmin;return K(r,o,n,!0)-K(s,o,n,!1)}function Q(e){const t=e.storageInfo.origin.x,n=J(e.spatialReference,!0);if(null==n)return{originX:t,halfWorldWidth:null,pyramidsInfo:null};const o=n/2,{nativePixelSize:i,storageInfo:r,extent:s}=e,{maximumPyramidLevel:a,blockWidth:l,pyramidScalingFactor:c}=r;let f=i.x;const u=[],x=null!=e.transform&&"gcs-shift"===e.transform.type,m=t+(x?0:o),h=x?n-t:o-t;for(let p=0;p<=a;p++){const e=(s.xmax-t)/f/l,n=e-Math.floor(e)==0?e:Math.ceil(e),o=h/f/l,i=o-Math.floor(o)==0?o:Math.ceil(o),r=Math.floor(m/f/l),a=Math.round(m/f)%l,x=(l-Math.round(h/f)%l)%l;u.push({resolutionX:f,blockWidth:l,datasetColumnCount:n,worldColumnCountFromOrigin:i,leftMargin:a,rightPadding:x,originColumnOffset:r}),f*=c}return{originX:t,halfWorldWidth:o,pyramidsInfo:u,hasGCSSShiftTransform:x}}function V(e){if(!e||e.isGeographic)return e;const t=String(e.wkid||e.wkt2||e.wkt);let n;if(R.has(t))n=R.get(t);else{n=(e.wkid?s.PeFactory.coordsys(e.wkid):s.PeFactory.fromString(s.PeDefs.PE_TYPE_PROJCS,e.wkt2||e.wkt)).getGeogcs().getCode(),R.set(t,n)}return new x({wkid:n})}function Z(e){const t=e.isAdaptive&&null==e.spacing;let n=e.spacing||[d,d],o=$(e),i={cols:o.size[0]+1,rows:o.size[1]+1};const r=o.outofBoundPointCount>0&&o.outofBoundPointCount<o.offsets.length/2;let s=o.outofBoundPointCount===o.offsets.length/2||t&&r?[0,0]:g(o.offsets,i,n,M);const a=(s[0]+s[1])/2,l=e.projectedExtent.spatialReference,c=e.srcBufferExtent.spatialReference;if(t&&(r||a>M)){h(l,c,e.datumTransformation)&&(l.isGeographic||I(l)),n=[P,P],o=$({...e,spacing:n}),i={cols:o.size[0]+1,rows:o.size[1]+1},s=g(o.offsets,i,n,M)}if(o.error=s,n[0]>1&&(o.coefficients=ee(o.offsets,i,r)),e.includeGCSGrid&&!l.isGeographic&&!l.isWebMercator)if(c.isGeographic)o.gcsGrid={offsets:o.offsets,coefficients:o.coefficients,spacing:n};else{const t=I(l);if(null!=t&&!t.isEnvelope){const t=V(l),s=U(e.projectedExtent,t),{offsets:a}=$({...e,srcBufferExtent:s,spacing:n}),c=ee(a,i,r);o.gcsGrid={offsets:a,coefficients:c,spacing:n}}}return o}function $(e){const{projectedExtent:t,srcBufferExtent:n,pixelSize:o,datumTransformation:i,rasterTransform:r}=e,s=t.spatialReference,a=n.spatialReference,l=p(s,a),{xmin:c,ymin:f,xmax:x,ymax:m}=t,h=J(a),g=null!=h&&(e.hasWrapAround||"gcs-shift"===r?.type),y=e.spacing||[d,d],M=y[0]*o.x,w=y[1]*o.y,R=1===y[0],b=Math.ceil((x-c)/M-.1/y[0])+(R?0:1),G=Math.ceil((m-f)/w-.1/y[1])+(R?0:1),E=F({cols:b,rows:G,xmin:c,ymax:m,xres:M,yres:w,inSR:s,outSR:a,datumTransformation:i,preferPE:y[0]<=P,usePixelCenter:R}),k=[];let N,T=0;const C=R?-1:NaN,{xmin:v,xmax:_,ymax:L,width:W,height:z}=n,D=j(a,S),O=null!=h&&v>0&&_>h/2;let A=!1;if(l){const e=I(s);A=null!=e&&e.poleLocation>0}for(let p=0;p<b;p++){const e=[];for(let t=0;t<G;t++){let n=E[p*G+t];if(g&&n[0]>_&&n[0]>h/2-D?n[0]-=h:g&&0===p&&n[0]<0&&O&&!r&&(n[0]+=h),!n||isNaN(n[0])||isNaN(n[1]))k.push(C),k.push(C),e.push(null),T++;else{if(r){const e=r.inverseTransform(new u({x:n[0],y:n[1],spatialReference:a}));n=[e.x,e.y]}e.push(n),p>0&&g&&N[t]&&n[0]<N[t][0]&&(n[0]+=h,A&&n[0]>_&&n[0]>h&&(n[0]-=h)),k.push((n[0]-v)/W),k.push((L-n[1])/z)}}N=e}return{offsets:k,error:null,coefficients:null,outofBoundPointCount:T,spacing:y,size:R?[b,G]:[b-1,G-1]}}function ee(e,t,n){const{cols:o,rows:i}=t,r=new Float32Array((o-1)*(i-1)*2*6),s=new Float32Array([-0,-1,1,-1,1,-0,1,-0,-0]),a=new Float32Array([-1,1,0,0,-1,1,1,0,0]);for(let l=0;l<o-1;l++){for(let t=0;t<i-1;t++){let n=l*i*2+2*t;const c=e[n],f=e[n+1],u=e[n+2],x=e[n+3];n+=2*i;const m=e[n],h=e[n+1],p=e[n+2],g=e[n+3];let y=0,d=12*(t*(o-1)+l);for(let e=0;e<3;e++)r[d++]=s[y++]*c+s[y++]*u+s[y++]*p;y=0;for(let e=0;e<3;e++)r[d++]=s[y++]*f+s[y++]*x+s[y++]*g;y=0;for(let e=0;e<3;e++)r[d++]=a[y++]*c+a[y++]*m+a[y++]*p;y=0;for(let e=0;e<3;e++)r[d++]=a[y++]*f+a[y++]*h+a[y++]*g}if(n)for(let e=0;e<r.length;e++)isNaN(r[e])&&(r[e]=-1)}return r}function te(e,t){const n=e.clone().normalize();return 1===n.length?n[0]:A(n,t)}function ne(e){const{spatialReference:t}=e,n=l.getInfo(t);if(!n)return e;const[o,i]=n.valid,r=i-o;let s=0;if(e.xmin<o){const t=o-e.xmin;s=Math.ceil(t/r)}else if(e.xmin>i){const t=e.xmin-i;s=-Math.ceil(t/r)}return new c({spatialReference:e.spatialReference,xmin:e.xmin+s*r,ymin:e.ymin,xmax:e.xmax+s*r,ymax:e.ymax})}function oe(e,t,n){const{storageInfo:o,pixelSize:i}=t;let s=0,a=!1;const{pyramidResolutions:l}=o,c="mixed"===o.tileInfo.format?.toLowerCase()?Math.max(1,Math.min(3,o.tileInfo.dpi/96)):1,f=(e.x+e.y)/2/c;if(null!=l&&l.length){const e=l[l.length-1],o=(e.x+e.y)/2,c=(i.x+i.y)/2;if(f<=c)s=0;else if(f>=o)s=l.length,a=f/o>8;else{let e,t=c;for(let o=1;o<=l.length;o++){if(e=(l[o-1].x+l[o-1].y)/2,f<=e){f===e?s=o:"down"===n?(s=o-1,a=f/t>8):s="up"===n||f-t>e-f||f/t>2?o:o-1;break}t=e}}const x=0===s?i:l[s-1];if(a){Math.min(x.x,x.y)*r.getMetersPerUnitForSR(t.spatialReference)>19567&&(a=!1)}return{pyramidLevel:s,pyramidResolution:new u({x:x.x,y:x.y,spatialReference:t.spatialReference}),excessiveReading:a}}const x=Math.log(e.x/i.x)/Math.LN2,m=Math.log(e.y/i.y)/Math.LN2,h=t.storageInfo.maximumPyramidLevel||0;s="down"===n?Math.floor(Math.min(x,m)):"up"===n?Math.ceil(Math.max(x,m)):Math.round((x+m)/2),s<0?s=0:s>h&&(a=s>h+3,s=h);const p=2**s;return{pyramidLevel:s,pyramidResolution:new u({x:p*t.nativePixelSize.x,y:p*t.nativePixelSize.y,spatialReference:t.spatialReference}),excessiveReading:a}}function ie(e,t){const{pixelSize:n,extent:o}=e,i=E(o,t,!1);return U(te(o,(n.x+n.y)/16),t,i)}function re(e,t,n){const o=n?.tileSize??512,i=n?.alignGlobalDatasetWithAGOL??!0,s=!!n?.limitToSrcResolution,{extent:a,spatialReference:l,pixelSize:c}=e,f=T(c,t,a);if(null==f)return{projectedPixelSize:null,scales:null,srcResolutions:null,isCustomTilingScheme:!1};const u=(f.x+f.y)/2,m=r.getMetersPerUnitForSR(t),h=u*m*96*39.37,p=t.isGeographic?256/o*295828763.7958547:256/o*591657527.591555;let g="vector-magdir"===e.dataType||"vector-uv"===e.dataType;const y=ie(e,t),d=Math.min(Math.ceil(Math.log(Math.min(e.width,e.height)/32)/Math.LN2),Math.ceil(Math.log(p/2/h)/Math.LN2));if(!g&&i&&(t.isGeographic||t.isWebMercator)){const n=J(t);if(g=H(y)>0||null!=n&&y.width>n/4,!g&&null!=n){let t=-1;if(d<3)t=2**d*u*o;else if(e.storageInfo){const{maximumPyramidLevel:n=0,pyramidScalingFactor:i=2}=e.storageInfo;t=i**n*u*o}const i=Math.ceil(n/t);g=1===i||2===i&&n/2-y.xmax<t}}let P,M=h;const w=1.001,R=Math.min(2,Math.max(1.414,e.storageInfo?.pyramidScalingFactor||2));if(g){M=p;const n=t.isGeographic?1341104507446289e-21:.29858214164761665,o=n*(96*m*39.37),i=t.isGeographic?4326:3857;P=T({x:n,y:n},l,ie(e,new x({wkid:i}))),P.x*=M/o,P.y*=M/o}else{P={x:c.x,y:c.y};let e=0;for(;M<p*(w/2)&&e<d;)e++,M*=R,P.x*=R,P.y*=R;Math.max(M,p)/Math.min(M,p)<=w&&(M=p)}const S=[M],b=[{x:P.x,y:P.y}],G=70.5310735,E=Math.min(G,h)/w;for(;M>=E;)M/=R,P.x/=R,P.y/=R,S.push(M),b.push({x:P.x,y:P.y});if(s){const e=.001*c.x;let t=b.findIndex((t=>t.x>=c.x-e&&t.x<=c.x+e));t>-1?(b.length=t+1,S.length=t+1):(t=b.findIndex((t=>t.x<=c.x+e)),t>0&&(b.length=t,S.length=t))}return{projectedPixelSize:f,scales:S,srcResolutions:b,isCustomTilingScheme:!g}}t.computeProjectedScales=re,t.defaultGridSpacing=d,t.defaultProjectionToleranceInPixels=M,t.getDefaultDatumTransformationForDataset=E,t.getProjectedGridPoints=F,t.getProjectionOffsetGrid=Z,t.getRasterDatasetAlignmentInfo=Q,t.getWorldWidth=J,t.getWorldWrapCount=H,t.load=G,t.minimumGridSpacing=P,t.projectDatasetExtent=ie,t.projectDatasetResolution=T,t.projectExtent=U,t.projectPoint=C,t.projectPolygon=q,t.projectResolution=k,t.requirePE=h,t.shiftExtent=ne,t.snapExtent=te,t.snapPyramid=oe,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
