/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../core/arrayUtils","../../core/Error","../../core/urlUtils","../../geometry/Extent","../../geometry/SpatialReference","../ogc/crsUtils","../../chunks/datetime"],(function(e,t,n,r,i,s,o,l){"use strict";const a={84:4326,83:4269,27:4267};function u(e){if(!e)return null;const r={idCounter:-1};if("string"==typeof e){e=(new DOMParser).parseFromString(e,"text/xml")}const s=e.documentElement;if("ServiceExceptionReport"===s.nodeName){const e=Array.prototype.slice.call(s.childNodes).map((e=>e.textContent)).join("\r\n");throw new n("wmslayer:wms-capabilities-xml-is-not-valid","The server returned errors when the WMS capabilities were requested.",e)}const o=x("Capability",s),l=x("Service",s),a=o&&x("Request",o);if(!o||!l||!a)return null;const u=x("Layer",o);if(!u)return null;const c="WMS_Capabilities"===s.nodeName||"WMT_MS_Capabilities"===s.nodeName?s.getAttribute("version"):"1.3.0",d=g("Title",l,"")||g("Name",l,""),p=g("AccessConstraints",l,""),h=/^none$/i.test(p)?"":p,N=g("Abstract",l,""),A=parseInt(g("MaxWidth",l,"5000"),10),F=parseInt(g("MaxHeight",l,"5000"),10),T=b(a,"GetMap"),L=y(a,"GetMap"),w=S(u,c,r);if(!w)return null;let M,v=0;const I=Array.prototype.slice.call(o.childNodes),O=w.sublayers??[],R=e=>{null!=e&&O.push(e)};I.forEach((e=>{"Layer"===e.nodeName&&(0===v?M=e:1===v?(w.name&&(w.name="",R(S(M,c,r))),R(S(e,c,r))):R(S(e,c,r)),v++)}));let U=w.sublayers,D=w.extent;const V=w.fullExtents??[];if(U||(U=[]),0===U.length&&U.push(w),!D){const e=new i(U[0].extent);w.extent=e.toJSON(),D=w.extent}const _=w.spatialReferences.length>0?w.spatialReferences:m(w),k=y(a,"GetFeatureInfo"),B=k?b(a,"GetFeatureInfo"):null,W=f(U),q=w.minScale||0,G=w.maxScale||0,P=w.dimensions??[],X=W.reduce(((e,t)=>e.concat(t.dimensions??[])),[]),$=P.concat(X).filter(C);let j=null;if($.length){const e=$.map((e=>{const{extent:t}=e;return E(t)?t.map((e=>e.getTime())):t?.map((e=>[e.min.getTime(),e.max.getTime()]))})).flat(2).filter(t.isSome);j={startTimeField:null,endTimeField:null,trackIdField:void 0,timeExtent:[Math.min(...e),Math.max(...e)]}}return{copyright:h,description:N,dimensions:P,extent:D,fullExtents:V,featureInfoFormats:B,featureInfoUrl:k,mapUrl:L,maxWidth:A,maxHeight:F,maxScale:G,minScale:q,layers:W,spatialReferences:_,supportedImageFormatTypes:T,timeInfo:j,title:d,version:c}}function c(e){const t=e.filter((e=>e.popupEnabled&&e.name&&e.queryable));return t.length?t.map((({name:e})=>e)).join():null}function m(e){if(e.spatialReferences.length>0)return e.spatialReferences;if(e.sublayers)for(const t of e.sublayers){const e=m(t);if(e.length>0)return e}return[]}function f(e){let t=[];for(const n of e)t.push(n),n.sublayers?.length&&(t=t.concat(f(n.sublayers)),delete n.sublayers);return t}function d(e,t,n){return t.getAttribute(e)??n}function p(e,t,n,r){const i=x(e,n);return i?d(t,i,r):r}function x(e,t){for(let n=0;n<t.childNodes.length;n++){const r=t.childNodes[n];if(F(r)&&r.nodeName===e)return r}return null}function h(e,t){if(null==t)return[];const n=[];for(let r=0;r<t.childNodes.length;r++){const i=t.childNodes[r];F(i)&&i.nodeName===e&&n.push(i)}return n}function g(e,t,n){return x(e,t)?.textContent??n}function N(e,t,n){if(!e)return null;const r=parseFloat(e.getAttribute("minx")),o=parseFloat(e.getAttribute("miny")),l=parseFloat(e.getAttribute("maxx")),a=parseFloat(e.getAttribute("maxy"));let u,c,m,f;n?(u=isNaN(o)?-Number.MAX_VALUE:o,c=isNaN(r)?-Number.MAX_VALUE:r,m=isNaN(a)?Number.MAX_VALUE:a,f=isNaN(l)?Number.MAX_VALUE:l):(u=isNaN(r)?-Number.MAX_VALUE:r,c=isNaN(o)?-Number.MAX_VALUE:o,m=isNaN(l)?Number.MAX_VALUE:l,f=isNaN(a)?Number.MAX_VALUE:a);const d=new s({wkid:t});return new i({xmin:u,ymin:c,xmax:m,ymax:f,spatialReference:d})}function y(e,t){const n=x(t,e);if(n){const e=x("DCPType",n);if(e){const t=x("HTTP",e);if(t){const e=x("Get",t);if(e){let t=p("OnlineResource","xlink:href",e,null);if(t){const e=t.indexOf("&");return-1!==e&&e===t.length-1&&(t=t.slice(0,-1)),M(t,["service","request"])}}}}}return null}function b(e,n){const r=h("Operation",e);if(!r.length){return h("Format",x(n,e)).map((({textContent:e})=>e)).filter(t.isSome)}const i=[];for(const t of r)if(t.getAttribute("name")===n){const e=h("Format",t);for(const{textContent:t}of e)null!=t&&i.push(t)}return i}function A(e,t,n){const r=x(t,e);if(!r)return n;const{textContent:i}=r;if(null==i||""===i)return n;const s=Number(i);return isNaN(s)?n:s}function S(e,t,n){if(!e)return null;const r={id:n.idCounter++,fullExtents:[],parentLayerId:null,queryable:"1"===e.getAttribute("queryable"),spatialReferences:[],sublayers:null},l=x("LatLonBoundingBox",e),u=x("EX_GeographicBoundingBox",e);let c=null;l&&(c=N(l,4326)),u&&(c=new i(0,0,0,0,new s({wkid:4326})),c.xmin=parseFloat(g("westBoundLongitude",u,"0")),c.ymin=parseFloat(g("southBoundLatitude",u,"0")),c.xmax=parseFloat(g("eastBoundLongitude",u,"0")),c.ymax=parseFloat(g("northBoundLatitude",u,"0"))),l||u||(c=new i(-180,-90,180,90,new s({wkid:4326}))),r.minScale=A(e,"MaxScaleDenominator",0),r.maxScale=A(e,"MinScaleDenominator",0);const m=["1.0.0","1.1.0","1.1.1"].includes(t)?"SRS":"CRS";return Array.prototype.slice.call(e.childNodes).forEach((e=>{if("Name"===e.nodeName)r.name=e.textContent||"";else if("Title"===e.nodeName)r.title=e.textContent||"";else if("Abstract"===e.nodeName)r.description=e.textContent||"";else if("BoundingBox"===e.nodeName){const n=e.getAttribute(m);if(n&&0===n.indexOf("EPSG:")){const r=parseInt(n.slice(5),10);0===r||isNaN(r)||c||(c="1.3.0"===t?N(e,r,o.isAxesOrderReversedForWkid(r)):N(e,r))}const i=n?.indexOf(":");if(i&&i>-1){let s=parseInt(n.slice(i+1),10);0===s||isNaN(s)||(s=a[s]??s);const l="1.3.0"===t?N(e,s,o.isAxesOrderReversedForWkid(s)):N(e,s);l&&r.fullExtents&&r.fullExtents.push(l)}}else if(e.nodeName===m){(e.textContent?.split(" ")??[]).forEach((e=>{let t=NaN;if(e.includes(":")){const[n,r]=e.toUpperCase().split(":");"CRS"!==n&&"EPSG"!==n||(t=parseInt(r,10))}else t=parseInt(e,10);if(0!==t&&!isNaN(t)){const e=a[t]??t;r.spatialReferences.includes(e)||r.spatialReferences.push(e)}}))}else if("Style"!==e.nodeName||r.legendUrl){if("Layer"===e.nodeName){const i=S(e,t,n);i&&(i.parentLayerId=r.id,r.sublayers||(r.sublayers=[]),r.sublayers.push(i))}}else{const t=x("LegendURL",e);if(t){const e=x("OnlineResource",t);e&&(r.legendUrl=e.getAttribute("xlink:href"))}}})),r.extent=c?.toJSON(),r.dimensions=h("Dimension",e).filter((e=>e.getAttribute("name")&&e.getAttribute("units")&&e.textContent)).map((e=>{const t=e.getAttribute("name"),n=e.getAttribute("units"),r=e.textContent,i=e.getAttribute("unitSymbol")??void 0,s=e.getAttribute("default")??void 0,o="0"!==d("default",e,"0"),l="0"!==d("nearestValue",e,"0"),a="0"!==d("current",e,"0");if(C({name:t,units:n})){return{name:"time",units:"ISO8601",extent:O(r),default:O(s),multipleValues:o,nearestValue:l,current:a}}if(L({name:t,units:n})){return{name:"elevation",units:n,extent:v(r),unitSymbol:i,default:v(s),multipleValues:o,nearestValue:l}}return{name:t,units:n,extent:I(r),unitSymbol:i,default:I(s),multipleValues:o,nearestValue:l}})),r}function E(e){return Array.isArray(e)&&e.length>0&&e[0]instanceof Date}function F(e){return e.nodeType===Node.ELEMENT_NODE}function T(e){return void 0!==e.min&&void 0!==e.max}function L(e){return/^elevation$/i.test(e.name)&&/^(epsg|crs):\d+$/i.test(e.units)}function w(e){return!C(e)&&!L(e)}function C(e){return/^time$/i.test(e.name)&&/^iso8601$/i.test(e.units)}function M(e,t){const n=[],i=r.urlToObject(e);for(const r in i.query)i.query.hasOwnProperty(r)&&(t.includes(r.toLowerCase())||n.push(r+"="+i.query[r]));return i.path+(n.length?"?"+n.join("&"):"")}function v(e){if(!e)return;const n=e.includes("/"),r=e.split(",");return n?r.map((e=>{const t=e.split("/");if(t.length<2)return null;return{min:parseFloat(t[0]),max:parseFloat(t[1]),resolution:t.length>=3&&"0"!==t[2]?parseFloat(t[2]):void 0}})).filter(t.isSome):r.map((e=>parseFloat(e)))}function I(e){if(!e)return;const n=e.includes("/"),r=e.split(",");return n?r.map((e=>{const t=e.split("/");if(t.length<2)return null;return{min:t[0],max:t[1],resolution:t.length>=3&&"0"!==t[2]?t[2]:void 0}})).filter(t.isSome):r}function O(e){if(!e)return;const n=e.includes("/"),r=e.split(",");return n?r.map((e=>{const t=e.split("/");if(t.length<2)return null;return{min:R(t[0]),max:R(t[1]),resolution:t.length>=3&&"0"!==t[2]?U(t[2]):void 0}})).filter(t.isSome):r.map((e=>R(e)))}function R(e){return l.DateTime.fromISO(e,{zone:l.FixedOffsetZone.utcInstance}).toJSDate()}function U(e){const t=/(?:p(\d+y|\d+(?:\.|,)\d+y)?(\d+m|\d+(?:\.|,)\d+m)?(\d+d|\d+(?:\.|,)\d+d)?)?(?:t(\d+h|\d+(?:\.|,)\d+h)?(\d+m|\d+(?:\.|,)\d+m)?(\d+s|\d+(?:\.|,)\d+s)?)?/i,n=e.match(t);if(!n)return null;return{years:D(n[1]),months:D(n[2]),days:D(n[3]),hours:D(n[4]),minutes:D(n[5]),seconds:D(n[6])}}function D(e){if(!e)return 0;const t=/(?:\d+(?:\.|,)\d+|\d+)/,n=e.match(t);if(!n)return 0;const r=n[0].replace(",",".");return Number(r)}function V(e){return e.toISOString().replace(/\.[0-9]{3}/,"")}const _="0000-01-01T00:00:00Z",k="9999-12-31T23:59:59Z";function B(e){if(!e||e.isAllTime||e.isEmpty)return;const{start:t,end:n}=e;if(t&&n&&t.getTime()===n.getTime())return`${V(t)}`;return`${t?V(t):_}/${n?V(n):k}`}const W=new Set([102100,3857,102113,900913]),q=new Set([3395,54004]);function G(e,t){let n=e.wkid;return null==t?n:(null!=n&&t.includes(n)||!e.latestWkid||(n=e.latestWkid),null!=n&&W.has(n)?t.find((e=>W.has(e)))||t.find((e=>q.has(e)))||102100:n)}e.fromISODuration=U,e.getPopupLayers=c,e.isDimensionInterval=T,e.isElevationDimension=L,e.isGenericDimension=w,e.isTimeDimension=C,e.normalizeWKID=G,e.parseCapabilities=u,e.toTimeQueryParameter=B,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
