/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../core/JSONSupport","../../core/Logger","../../core/timeUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../../chunks/vec32","../../core/libs/gl-matrix-2/factories/vec3f64","../../geometry/Point","../../geometry/SpatialReference","../../geometry/support/spatialReferenceUtils","./NCTimeParser","./VoxelDimension"],(function(e,i,s,r,t,n,o,a,l,p,u,c,d,g,y){"use strict";let h=class extends i.JSONSupport{constructor(e){super(e),this.id=0,this.dimensions=null,this.spatialReference=c.WGS84}get zDimension(){if(!this.dimensions)return-1;if(!Array.isArray(this.dimensions))return-1;if(4!==this.dimensions.length)return-1;for(let e=2;e<4;++e)if(this.dimensions[e].size>0)return e;return-1}get isValid(){return!!this.dimensions&&(!!Array.isArray(this.dimensions)&&(4===this.dimensions.length&&(!(this.dimensions[0].size<1||this.dimensions[1].size<1)&&!(-1===this.zDimension||this.dimensions[this.zDimension].size<1))))}get originInLayerSpace3D(){if(!this.isValid||"xyt"===this.volumeType)return[0,0,0];const e=this.dimensions[0].getRange(),i=this.dimensions[1].getRange(),s=this.dimensions[2],r=s.isRegular?s.getRange():[0,s.size];return[e[0],i[0],r[0]]}get voxelSizeInLayerSpaceSigned(){if(!this.isValid||"xyt"===this.volumeType)return[0,0,0];const e=this.dimensions[0].getRange(),i=this.dimensions[1].getRange(),s=this.dimensions[2],r=s.isRegular?s.getRange():[0,s.size],t=[this.sizeInVoxels[0],this.sizeInVoxels[1],this.sizeInVoxels[2]];for(let n=0;n<3;++n)t[n]<2?t[n]=1:t[n]-=1;return s.isRegular&&!s.isPositiveUp&&(t[2]*=-1),[(e[1]-e[0])/t[0],(i[1]-i[0])/t[1],(r[1]-r[0])/t[2]]}get volumeType(){if(this.isValid){const e=this.dimensions[2].size>0;let i=this.dimensions[3].size>0;if(i){const e=this.dimensions[3];if(i="time"===e.quantity,i&&null!==e.unit){i=g.parseTimeDimensionUnit(e.unit).didParse}}if(!e&&i)return"xyt";if(e&&i)return"xyzt"}return"xyz"}get sizeInVoxels(){if(!this.isValid)return[0,0,0];const e=this.zDimension;return[this.dimensions[0].size,this.dimensions[1].size,this.dimensions[e].size]}get timeStops(){if("xyzt"!==this.volumeType)return[];const e=this.dimensions[3],i=[],s=g.parseTimeDimensionUnit(e.unit);if(s.didParse)if(e.isRegular){const t=e.regularSpacing?.offset??0,n=e.regularSpacing?.scale||1;for(let o=0;o<e.size;++o){const e=t+n*o;i.push(r.offsetDateUTC(s.reference,e,s.unit))}}else if(Array.isArray(e.irregularSpacing?.values)&&e.irregularSpacing.values.length>0)for(let t=0;t<e.irregularSpacing.values.length;++t){const n=e.irregularSpacing.values[t];i.push(r.offsetDateUTC(s.reference,n,s.unit))}return i}computeVoxelSpaceLocation(e){if(!this.isValid)return[0,0,0];if("xyt"===this.volumeType)return s.getLogger(this).error("computeVoxelSpacePosition cannot be used with XYT volumes."),[0,0,0];if(!d.equals(this.spatialReference,e.spatialReference))return s.getLogger(this).error("pos argument should have the same spatial reference as the VoxelLayer."),[0,0,0];const i=p.fromValues(e.x,e.y,e.z??0);l.subtract(i,i,this.originInLayerSpace3D),l.divide(i,i,this.voxelSizeInLayerSpaceSigned);const r=this.dimensions[this.zDimension];if(!r.isRegular&&Array.isArray(r.irregularSpacing?.values)&&r.irregularSpacing.values.length>1){const s=e.z??0,t=r.irregularSpacing.values,n=r.isPositiveUp?1:-1,o=t.reduce(((e,i)=>Math.abs(n*i-s)<Math.abs(n*e-s)?i:e));for(let e=0;e<t.length;++e)if(t[e]===o){i[2]=e;break}}return[i[0],i[1],i[2]]}computeLayerSpaceLocation(e){if(!this.isValid)return new u({x:0,y:0,spatialReference:this.spatialReference});const i=p.fromArray(e);if(l.multiply(i,i,this.voxelSizeInLayerSpaceSigned),l.add(i,i,this.originInLayerSpace3D),"xyt"===this.volumeType)return new u({x:i[0],y:i[1],spatialReference:this.spatialReference});const s=this.dimensions[this.zDimension];return s.isRegular||Array.isArray(s.irregularSpacing?.values)&&(e[2]<0?i[2]=s.irregularSpacing.values[0]:e[2]<s.irregularSpacing.values.length?i[2]=s.irregularSpacing.values[e[2]]:i[2]=s.irregularSpacing.values[s.irregularSpacing.values.length-1],s.isPositiveUp||(i[2]*=-1)),new u({x:i[0],y:i[1],z:i[2],spatialReference:this.spatialReference})}};e.__decorate([t.property({type:Number,json:{write:{enabled:!0,isRequired:!0}}})],h.prototype,"id",void 0),e.__decorate([t.property({type:[y],json:{write:{enabled:!0,isRequired:!0}}})],h.prototype,"dimensions",void 0),e.__decorate([t.property({type:c,json:{read:{enabled:!1}}})],h.prototype,"spatialReference",void 0),e.__decorate([t.property({type:Number,json:{read:!1}})],h.prototype,"zDimension",null),e.__decorate([t.property({type:[Boolean],json:{read:!1}})],h.prototype,"isValid",null),e.__decorate([t.property({type:[Number],json:{read:!1}})],h.prototype,"originInLayerSpace3D",null),e.__decorate([t.property({type:[Number],json:{read:!1}})],h.prototype,"voxelSizeInLayerSpaceSigned",null),e.__decorate([t.property({type:["xyz","xyzt","xyt"],json:{read:{enabled:!1}}})],h.prototype,"volumeType",null),e.__decorate([t.property({type:[Number],json:{read:!1}})],h.prototype,"sizeInVoxels",null),e.__decorate([t.property({type:[Date],json:{read:!1,write:!1}})],h.prototype,"timeStops",null),h=e.__decorate([a.subclass("esri.layers.voxel.VoxelVolume")],h);return h}));
