/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../config","../kernel","../request","../core/Error","../core/JSONSupport","../core/Loadable","../core/maybe","../core/promiseUtils","../core/accessorSupport/decorators/property","../core/accessorSupport/ensureType","../core/RandomLCG","../core/has","../core/accessorSupport/decorators/reader","../core/accessorSupport/decorators/subclass","../geometry/Extent","../intl/locale","./portalDefault","./PortalGroup","./PortalQueryParams","./PortalQueryResult","./PortalUser","../support/apiKeyUtils"],(function(e,t,r,o,a,s,i,p,l,u,n,d,y,c,h,_,m,f,v,S,P,g,O,B){"use strict";const D=e=>Object.freeze(Object.defineProperty({__proto__:null,default:e},Symbol.toStringTag,{value:"Module"}));var b;let G;const M={PortalGroup:()=>Promise.resolve({default:S}),PortalItem:()=>new Promise(((t,r)=>e(["./PortalItem"],(e=>t(D(e))),r))),PortalUser:()=>Promise.resolve({default:O})};let w=b=class extends(i.JSONSupportMixin(p)){constructor(e){super(e),this._esriIdCredentialCreateHandle=null,this.access=null,this.allSSL=!1,this.authMode="auto",this.authorizedCrossOriginDomains=null,this.basemapGalleryGroupQuery=null,this.basemapGalleryGroupQuery3D=null,this.bingKey=null,this.canListApps=!1,this.canListData=!1,this.canListPreProvisionedItems=!1,this.canProvisionDirectPurchase=!1,this.canSearchPublic=!0,this.canShareBingPublic=!1,this.canSharePublic=!1,this.canSignInArcGIS=!1,this.canSignInIDP=!1,this.colorSetsGroupQuery=null,this.commentsEnabled=!1,this.created=null,this.culture=null,this.customBaseUrl=null,this.default3DBasemapQuery=null,this.defaultBasemap=null,this.defaultDevBasemap=null,this.defaultExtent=null,this.defaultVectorBasemap=null,this.description=null,this.devBasemapGalleryGroupQuery=null,this.eueiEnabled=null,this.featuredGroups=null,this.featuredItemsGroupQuery=null,this.galleryTemplatesGroupQuery=null,this.layoutGroupQuery=null,this.livingAtlasGroupQuery=null,this.hasCategorySchema=!1,this.hasClassificationSchema=!1,this.helperServices=null,this.homePageFeaturedContent=null,this.homePageFeaturedContentCount=null,this.httpPort=null,this.httpsPort=null,this.id=null,this.ipCntryCode=null,this.isPortal=!1,this.isReadOnly=!1,this.layerTemplatesGroupQuery=null,this.maxTokenExpirationMinutes=null,this.modified=null,this.name=null,this.portalHostname=null,this.portalMode=null,this.portalProperties=null,this.region=null,this.recycleBinEnabled=!1,this.rotatorPanels=null,this.showHomePageDescription=!1,this.sourceJSON=null,this.supportsHostedServices=!1,this.symbolSetsGroupQuery=null,this.templatesGroupQuery=null,this.units=null,this.url=r.portalUrl,this.urlKey=null,this.user=null,this.use3dBasemaps=!0,this.useDefault3dBasemap=!1,this.useStandardizedQuery=!1,this.useVectorBasemaps=!1,this.vectorBasemapGalleryGroupQuery=null}normalizeCtorArgs(e){return"string"==typeof e?{url:e}:e}destroy(){A.unregister(this),this.defaultBasemap=l.destroyMaybe(this.defaultBasemap),this.defaultDevBasemap=l.destroyMaybe(this.defaultDevBasemap),this.defaultVectorBasemap=l.destroyMaybe(this.defaultVectorBasemap),this._esriIdCredentialCreateHandle=l.removeMaybe(this._esriIdCredentialCreateHandle)}readAuthorizedCrossOriginDomains(e){if(e)for(const t of e)r.request.trustedServers.includes(t)||r.request.trustedServers.push(t);return e}readDefaultBasemap(e){return this._readBasemap(e)}readDefaultDevBasemap(e){return this._readBasemap(e)}readDefaultVectorBasemap(e){return this._readBasemap(e)}get extraQuery(){const e=this.user?.orgId,t=!e||this.canSearchPublic;return this.id&&!t?` AND orgid:${this.id}`:null}get hasAPIKey(){return B.isApiKeyApplicable(this.url)}get isOrganization(){return!!this.access}get itemPageUrl(){return this.url?`${this.url}/home/item.html`:null}get restUrl(){let e=this.url;if(e){const t=e.indexOf("/sharing");e=t>0?e.slice(0,t):this.url.replace(/\/+$/,""),e+="/sharing/rest"}return e}get thumbnailUrl(){const e=this.restUrl,t=this.thumbnail;return e&&t?this._normalizeSSL(e+"/portals/self/resources/"+t):null}readUrlKey(e){return e?e.toLowerCase():e}readUser(e){let t=null;return e&&(t=O.fromJSON(e),t.portal=this),t}load(t){const r=new Promise(((t,r)=>e(["../Basemap"],(e=>t(D(e))),r))).then((({default:e})=>{u.throwIfAborted(t),G=e})).then((()=>this.sourceJSON?this.sourceJSON:this.fetchSelf(this.authMode,!1,t))).then((e=>{if(!this.hasAPIKey&&o.id){const e=o.id;this.credential=e.findCredential(this.restUrl),this.credential||this.authMode!==b.AUTH_MODE_AUTO&&this.authMode!==b.AUTH_MODE_NO_PROMPT||(this._esriIdCredentialCreateHandle?.remove(),this._esriIdCredentialCreateHandle=e.on("credential-create",U(new WeakRef(this))),A.register(this,this._esriIdCredentialCreateHandle,this))}this.sourceJSON=e,this.read(e)}));return this.addResolvingPromise(r),Promise.resolve(this)}async createElevationLayers(){await this.load();const t=this._getHelperService("defaultElevationLayers"),r=(await new Promise(((t,r)=>e(["../layers/ElevationLayer"],(e=>t(D(e))),r)))).default;return t?t.map((e=>new r({id:e.id,url:e.url}))):[]}async fetchBasemaps(e,t){const r=await this._fetchBasemaps(e,t);if(!0===t?.include3d&&!1!==this.use3dBasemaps){const o=await this._fetchBasemaps3D(e,t);r.unshift(...o)}return r}async fetchDefault3DBasemap(e){if(!this.useDefault3dBasemap||!this.default3DBasemapQuery||"none"===this.default3DBasemapQuery)return null;const t=new P;t.query=this.default3DBasemapQuery,t.disableExtraQuery=!0;const r=(await this.queryItems(t,e)).results.find((e=>"Web Scene"===e.type));return r?new G({portalItem:r}):null}fetchCategorySchema(e){return this.hasCategorySchema?this.request(this.restUrl+"/portals/self/categorySchema",e).then((e=>e.categorySchema)):u.isAborted(e)?Promise.reject(u.createAbortError()):Promise.resolve([])}fetchFeaturedGroups(e){const t=this.featuredGroups,r=new P({num:100,sortField:"title"});if(t?.length){const o=[];for(const e of t)o.push(`(title:"${e.title}" AND owner:${e.owner})`);return r.query=o.join(" OR "),this.queryGroups(r,e).then((e=>e.results))}return u.isAborted(e)?Promise.reject(u.createAbortError()):Promise.resolve([])}fetchRegions(e){const t=this.user?.culture||this.culture||f.getLocale();return this.request(this.restUrl+"/portals/regions",{...e,query:{culture:t}})}fetchSettings(e){const t=this.user?.culture||this.culture||f.getLocale();return this.request(this.restUrl+"/portals/self/settings",{...e,query:{culture:t}})}static getDefault(){return v.ensureDefaultPortalInstance((()=>new b))}queryGroups(e,t){return this.queryPortal("/community/groups",e,"PortalGroup",t)}queryItems(e,t){return this.queryPortal("/search",e,"PortalItem",t)}queryUsers(e,t){return e.sortField||(e.sortField="username"),this.queryPortal("/community/users",e,"PortalUser",t)}fetchSelf(e=this.authMode,t=!1,r){const o=this.restUrl+"/portals/self",a={authMode:e,query:{culture:f.getLocale().toLowerCase()},withCredentials:!0,...r};return"auto"===a.authMode&&(a.authMode="no-prompt"),t&&(a.query.default=!0),this.request(o,a)}queryPortal(e,t,r,o){const a=d.ensureType(P,t),s=t=>this.request(this.restUrl+e,{...a.toRequestOptions(this),...o}).then((e=>{const r=a.clone();return r.start=e.nextStart,new g({nextQueryParams:r,queryParams:a,total:e.total,results:b._resultsToTypedArray(t,{portal:this},e,o)})})).then((e=>Promise.all(e.results.map((t=>"function"==typeof t.when?t.when():e))).then((()=>e),(t=>(u.throwIfAbortError(t),e)))));return r&&M[r]?M[r]().then((({default:e})=>(u.throwIfAborted(o),s(e)))):s()}signIn(){if(this.hasAPIKey)return this.load().then((()=>{if(!this.user)throw new s("portal:not-authenticated","Unable to authenticate user. Portal.user is missing")}));if(this.authMode===b.AUTH_MODE_ANONYMOUS||this.authMode===b.AUTH_MODE_NO_PROMPT&&!o.id)return Promise.reject(new s("portal:invalid-auth-mode",`Current "authMode"' is "${this.authMode}"`));if("failed"===this.loadStatus)return Promise.reject(this.loadError);const e=e=>Promise.resolve().then((()=>"not-loaded"===this.loadStatus?(e||(this.authMode="immediate"),this.load().then((()=>null))):"loading"===this.loadStatus?this.load().then((()=>this.credential?null:(this.credential=e,this.fetchSelf("immediate")))):this.user&&this.credential===e?null:(this.credential=e,this.fetchSelf("immediate")))).then((e=>{e&&(this.sourceJSON=e,this.read(e))}));return o.id?o.id.getCredential(this.restUrl,{prompt:this.authMode!==b.AUTH_MODE_NO_PROMPT}).then((t=>e(t))):e(this.credential)}normalizeUrl(e){const t=this.credential?.token;return this._normalizeSSL(t?e+(e.includes("?")?"&":"?")+"token="+t:e)}requestToTypedArray(e,t,r){return this.request(e,t).then((e=>{const t=b._resultsToTypedArray(r,{portal:this},e);return Promise.all(t.map((t=>"function"==typeof t.when?t.when():e))).then((()=>t),(()=>t))}))}request(e,t={}){const r={f:"json",...t.query},{authMode:o=(this.authMode===b.AUTH_MODE_ANONYMOUS||this.authMode===b.AUTH_MODE_NO_PROMPT?this.authMode:"auto"),body:s=null,cacheBust:i=!1,method:p="auto",responseType:l="json",signal:u}=t,n={authMode:o,body:s,cacheBust:i,method:p,query:r,responseType:l,timeout:0,signal:u};return t.withCredentials&&(n.withCredentials=!0),a(this._normalizeSSL(e),n).then((e=>e.data))}toJSON(){throw new s("internal:not-yet-implemented","Portal.toJSON is not yet implemented")}static fromJSON(e){if(!e)return null;if(e.declaredClass)throw new Error("JSON object is already hydrated");return new b({sourceJSON:e})}_getHelperService(e){const t=this.helperServices&&this.helperServices[e];if(!t)throw new s("portal:service-not-found",`The \`helperServices\` do not include an entry named "${e}"`);return t}async _fetchBasemaps(e,t){const r=new P;r.query=e||(this.hasAPIKey?this.devBasemapGalleryGroupQuery:this.useVectorBasemaps?this.vectorBasemapGalleryGroupQuery:this.basemapGalleryGroupQuery),r.disableExtraQuery=!0;const o=await this.queryGroups(r,t);if(!o.total)return[];const a=o.results[0];r.num=100,r.query='type:"Web Map" -type:"Web Application"',r.sortField=a.sortField||"name",r.sortOrder=a.sortOrder||"desc";const s=await a.queryItems(r,t);if(!s.total)return[];return s.results.filter((e=>"Web Map"===e.type)).map((e=>new G({portalItem:e})))}async _fetchBasemaps3D(e,t){const r=e||this.basemapGalleryGroupQuery3D;if(!r)return[];const o=new P({query:r,disableExtraQuery:!0}),a=await this.queryGroups(o,t);if(!a.total)return[];const s=a.results[0];o.num=100,o.query='type:"Web Scene"',o.sortField=s.sortField||"name",o.sortOrder=s.sortOrder||"desc";const i=await s.queryItems(o,t);if(!i.total)return[];return i.results.filter((e=>"Web Scene"===e.type)).map((e=>new G({portalItem:e})))}_normalizeSSL(e){return e.replace(/^http:/i,"https:").replace(":7080",":7443")}_readBasemap(e){if(e){const t=G.fromJSON(e);return t.portalItem={portal:this},t}return null}static _resultsToTypedArray(e,t,r,o){let a;if(r){const s=null!=o?o.signal:null;a=r.listings||r.notifications||r.userInvitations||r.tags||r.items||r.groups||r.comments||r.provisions||r.results||r.relatedItems||r,(e||t)&&(a=a.map((r=>{const o=Object.assign(e?e.fromJSON(r):r,t);return"function"==typeof o.load&&o.load(s),o})))}else a=[];return a}};w.AUTH_MODE_ANONYMOUS="anonymous",w.AUTH_MODE_AUTO="auto",w.AUTH_MODE_IMMEDIATE="immediate",w.AUTH_MODE_NO_PROMPT="no-prompt",t.__decorate([n.property()],w.prototype,"access",void 0),t.__decorate([n.property()],w.prototype,"allSSL",void 0),t.__decorate([n.property()],w.prototype,"authMode",void 0),t.__decorate([n.property()],w.prototype,"authorizedCrossOriginDomains",void 0),t.__decorate([h.reader("authorizedCrossOriginDomains")],w.prototype,"readAuthorizedCrossOriginDomains",null),t.__decorate([n.property()],w.prototype,"basemapGalleryGroupQuery",void 0),t.__decorate([n.property({json:{name:"3DBasemapGalleryGroupQuery"}})],w.prototype,"basemapGalleryGroupQuery3D",void 0),t.__decorate([n.property()],w.prototype,"bingKey",void 0),t.__decorate([n.property()],w.prototype,"canListApps",void 0),t.__decorate([n.property()],w.prototype,"canListData",void 0),t.__decorate([n.property()],w.prototype,"canListPreProvisionedItems",void 0),t.__decorate([n.property()],w.prototype,"canProvisionDirectPurchase",void 0),t.__decorate([n.property()],w.prototype,"canSearchPublic",void 0),t.__decorate([n.property()],w.prototype,"canShareBingPublic",void 0),t.__decorate([n.property()],w.prototype,"canSharePublic",void 0),t.__decorate([n.property()],w.prototype,"canSignInArcGIS",void 0),t.__decorate([n.property()],w.prototype,"canSignInIDP",void 0),t.__decorate([n.property()],w.prototype,"colorSetsGroupQuery",void 0),t.__decorate([n.property()],w.prototype,"commentsEnabled",void 0),t.__decorate([n.property({type:Date})],w.prototype,"created",void 0),t.__decorate([n.property()],w.prototype,"credential",void 0),t.__decorate([n.property()],w.prototype,"culture",void 0),t.__decorate([n.property()],w.prototype,"currentVersion",void 0),t.__decorate([n.property()],w.prototype,"customBaseUrl",void 0),t.__decorate([n.property()],w.prototype,"default3DBasemapQuery",void 0),t.__decorate([n.property()],w.prototype,"defaultBasemap",void 0),t.__decorate([h.reader("defaultBasemap")],w.prototype,"readDefaultBasemap",null),t.__decorate([n.property()],w.prototype,"defaultDevBasemap",void 0),t.__decorate([h.reader("defaultDevBasemap")],w.prototype,"readDefaultDevBasemap",null),t.__decorate([n.property({type:m})],w.prototype,"defaultExtent",void 0),t.__decorate([n.property()],w.prototype,"defaultVectorBasemap",void 0),t.__decorate([h.reader("defaultVectorBasemap")],w.prototype,"readDefaultVectorBasemap",null),t.__decorate([n.property()],w.prototype,"description",void 0),t.__decorate([n.property()],w.prototype,"devBasemapGalleryGroupQuery",void 0),t.__decorate([n.property()],w.prototype,"eueiEnabled",void 0),t.__decorate([n.property({readOnly:!0})],w.prototype,"extraQuery",null),t.__decorate([n.property()],w.prototype,"featuredGroups",void 0),t.__decorate([n.property()],w.prototype,"featuredItemsGroupQuery",void 0),t.__decorate([n.property()],w.prototype,"galleryTemplatesGroupQuery",void 0),t.__decorate([n.property()],w.prototype,"layoutGroupQuery",void 0),t.__decorate([n.property()],w.prototype,"livingAtlasGroupQuery",void 0),t.__decorate([n.property({readOnly:!0})],w.prototype,"hasAPIKey",null),t.__decorate([n.property()],w.prototype,"hasCategorySchema",void 0),t.__decorate([n.property()],w.prototype,"hasClassificationSchema",void 0),t.__decorate([n.property()],w.prototype,"helpBase",void 0),t.__decorate([n.property()],w.prototype,"helperServices",void 0),t.__decorate([n.property()],w.prototype,"helpMap",void 0),t.__decorate([n.property()],w.prototype,"homePageFeaturedContent",void 0),t.__decorate([n.property()],w.prototype,"homePageFeaturedContentCount",void 0),t.__decorate([n.property()],w.prototype,"httpPort",void 0),t.__decorate([n.property()],w.prototype,"httpsPort",void 0),t.__decorate([n.property()],w.prototype,"id",void 0),t.__decorate([n.property()],w.prototype,"ipCntryCode",void 0),t.__decorate([n.property({readOnly:!0})],w.prototype,"isOrganization",null),t.__decorate([n.property()],w.prototype,"isPortal",void 0),t.__decorate([n.property()],w.prototype,"isReadOnly",void 0),t.__decorate([n.property({readOnly:!0})],w.prototype,"itemPageUrl",null),t.__decorate([n.property()],w.prototype,"layerTemplatesGroupQuery",void 0),t.__decorate([n.property()],w.prototype,"maxTokenExpirationMinutes",void 0),t.__decorate([n.property({type:Date})],w.prototype,"modified",void 0),t.__decorate([n.property()],w.prototype,"name",void 0),t.__decorate([n.property()],w.prototype,"portalHostname",void 0),t.__decorate([n.property()],w.prototype,"portalMode",void 0),t.__decorate([n.property()],w.prototype,"portalProperties",void 0),t.__decorate([n.property()],w.prototype,"region",void 0),t.__decorate([n.property()],w.prototype,"recycleBinEnabled",void 0),t.__decorate([n.property({readOnly:!0})],w.prototype,"restUrl",null),t.__decorate([n.property()],w.prototype,"rotatorPanels",void 0),t.__decorate([n.property()],w.prototype,"showHomePageDescription",void 0),t.__decorate([n.property()],w.prototype,"sourceJSON",void 0),t.__decorate([n.property()],w.prototype,"staticImagesUrl",void 0),t.__decorate([n.property({json:{name:"2DStylesGroupQuery"}})],w.prototype,"stylesGroupQuery2d",void 0),t.__decorate([n.property({json:{name:"stylesGroupQuery"}})],w.prototype,"stylesGroupQuery3d",void 0),t.__decorate([n.property()],w.prototype,"supportsHostedServices",void 0),t.__decorate([n.property()],w.prototype,"symbolSetsGroupQuery",void 0),t.__decorate([n.property()],w.prototype,"templatesGroupQuery",void 0),t.__decorate([n.property()],w.prototype,"thumbnail",void 0),t.__decorate([n.property({readOnly:!0})],w.prototype,"thumbnailUrl",null),t.__decorate([n.property()],w.prototype,"units",void 0),t.__decorate([n.property()],w.prototype,"url",void 0),t.__decorate([n.property()],w.prototype,"urlKey",void 0),t.__decorate([h.reader("urlKey")],w.prototype,"readUrlKey",null),t.__decorate([n.property()],w.prototype,"user",void 0),t.__decorate([h.reader("user")],w.prototype,"readUser",null),t.__decorate([n.property()],w.prototype,"use3dBasemaps",void 0),t.__decorate([n.property()],w.prototype,"useDefault3dBasemap",void 0),t.__decorate([n.property()],w.prototype,"useStandardizedQuery",void 0),t.__decorate([n.property()],w.prototype,"useVectorBasemaps",void 0),t.__decorate([n.property()],w.prototype,"vectorBasemapGalleryGroupQuery",void 0),w=b=t.__decorate([_.subclass("esri.portal.Portal")],w);const Q=w,A=new FinalizationRegistry((e=>{e.remove()}));function U(e){const t=o.id;return()=>{const r=e.deref();r&&t.findCredential(r.restUrl)&&r.signIn().catch((()=>{}))}}return Q}));
