/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../assets","../core/Error","../core/JSONSupport","../core/lang","../core/Loadable","../core/urlUtils","../core/accessorSupport/decorators/property","../core/accessorSupport/ensureType","../core/accessorSupport/decorators/reader","../core/accessorSupport/decorators/subclass","../geometry/Extent","./Portal","./PortalItemResource","./PortalRating","../chunks/persistableUrlUtils"],(function(e,t,r,i,o,a,s,n,l,p,c,d,u,y,h,m,g){"use strict";var w;const v=new Set(["3DTiles Service","CSV","Feature Collection","Feature Service","Feed","GeoJson","Group Layer","Image Service","KML","Map Service","Media Layer","Scene Service","Stream Service","Vector Tile Service","WFS","WMS","WMTS"]),b=new Set(["KML","GeoJson","CSV"]);let f=w=class extends(o.JSONSupportMixin(s)){static from(e){return p.ensureClass(w,e)}constructor(e){super(e),this.access=null,this.accessInformation=null,this.apiKey=null,this.applicationProxies=null,this.avgRating=null,this.categories=null,this.classification=null,this.created=null,this.culture=null,this.description=null,this.extent=null,this.groupCategories=null,this.id=null,this.isOrgItem=!1,this.itemControl=null,this.licenseInfo=null,this.modified=null,this.name=null,this.numComments=null,this.numRatings=null,this.numViews=null,this.owner=null,this.ownerFolder=null,this.portal=null,this.screenshots=null,this.size=null,this.snippet=null,this.sourceJSON=null,this.sourceUrl=null,this.spatialReference=null,this.tags=null,this.title=null,this.type=null,this.typeKeywords=null,this.url=null}destroy(){this.portal=null}get displayName(){const e=this.type,t=this.typeKeywords||[];let r=e;return"Feature Service"===e||"Feature Collection"===e?r=t.includes("Table")?"Table":t.includes("Route Layer")?"Route Layer":t.includes("Markup")?"Markup":"Feature Layer":"Image Service"===e?r=t.includes("Elevation 3D Layer")?"Elevation Layer":t.includes("Tiled Imagery")?"Tiled Imagery Layer":"Imagery Layer":"Scene Service"===e?r="Scene Layer":"Video Service"===e?r="Video Layer":"Scene Package"===e?r="Scene Layer Package":"Stream Service"===e?r="Feature Layer":"Geoprocessing Service"===e?r=t.includes("Web Tool")?"Tool":"Geoprocessing Service":"Geoenrichment Service"===e?r="GeoEnrichment Service":"Geocoding Service"===e?r="Locator":"Microsoft Powerpoint"===e?r="Microsoft PowerPoint":"GeoJson"===e?r="GeoJSON":"Globe Service"===e?r="Globe Layer":"Vector Tile Service"===e?r="Tile Layer":"netCDF"===e?r="NetCDF":"Map Service"===e?r=t.includes("Spatiotemporal")||!t.includes("Hosted Service")&&!t.includes("Tiled")||t.includes("Relational")?"Map Image Layer":"Tile Layer":e?.toLowerCase().includes("add in")?r=e.replaceAll(/(add in)/gi,"Add-In"):"datastore catalog service"===e?r="Big Data File Share":"Compact Tile Package"===e?r="Tile Package (tpkx)":"Raster function template"===e?r="Raster Function Template":"OGCFeatureServer"===e?r="OGC Feature Layer":"web mapping application"===e&&t.includes("configurableApp")?r="Instant App":"Insights Page"===e?r="Insights Report":"Excalibur Imagery Project"===e?r="Excalibur Project":"3DTiles Service"===e?r="3D tiles layer":"3DTiles Package"===e&&(r="3D tiles package"),r}readExtent(e){return e&&e.length?new u(e[0][0],e[0][1],e[1][0],e[1][1]):null}get iconUrl(){const e=this.type?.toLowerCase()||"",t=this.typeKeywords||[],i="esri/images/portal/",o="16";let a,s=!1,n=!1,l=!1,p=!1,c=!1,d=!1,u=!1,y=!1;return e.indexOf("service")>0||"feature collection"===e||"kml"===e||"wms"===e||"wmts"===e||"wfs"===e?(s=t.includes("Hosted Service"),"feature service"===e||"feature collection"===e||"kml"===e||"wfs"===e?(n=t.includes("Table"),l=t.includes("Route Layer"),p=t.includes("Markup"),c=t.includes("Spatiotemporal"),d=t.includes("UtilityNetwork"),a=c&&n?"spatiotemporaltable":n?"table":l?"routelayer":p?"markup":c?"spatiotemporal":d?"utilitynetwork":s?"featureshosted":"features"):"map service"===e||"wms"===e||"wmts"===e?(c=t.includes("Spatiotemporal"),u=t.includes("Relational"),a=c||u?"mapimages":s||t.includes("Tiled")||"wmts"===e?"maptiles":"mapimages"):a="scene service"===e?t.includes("Line")?"sceneweblayerline":t.includes("3DObject")?"sceneweblayermultipatch":t.includes("Point")?"sceneweblayerpoint":t.includes("IntegratedMesh")?"sceneweblayermesh":t.includes("PointCloud")?"sceneweblayerpointcloud":t.includes("Polygon")?"sceneweblayerpolygon":t.includes("Building")?"sceneweblayerbuilding":t.includes("Voxel")?"sceneweblayervoxel":"sceneweblayer":"image service"===e?t.includes("Elevation 3D Layer")?"elevationlayer":t.includes("Tiled Imagery")?"tiledimagerylayer":"imagery":"stream service"===e?"streamlayer":"vector tile service"===e?"vectortile":"datastore catalog service"===e?"datastorecollection":"geocoding service"===e?"geocodeservice":"video service"===e?t.includes("Live Stream")?"livestreamvideolayer":"videolayer":"geoprocessing service"===e?t.includes("Web Tool")?"tool":"layers":"geodata service"===e?"geodataservice":"3dtiles service"===e?t.includes("3DObject")?"3dobjecttileslayer":t.includes("IntegratedMesh")?"integratedmeshtileslayer":"3dtileslayer":"layers"):"web map"===e||"cityengine web scene"===e?a="maps":"web scene"===e?a=t.includes("ViewingMode-Local")?"webscenelocal":"websceneglobal":"web mapping application"===e&&t.includes("configurableApp")?a="instantapps":"web mapping application"===e||"mobile application"===e||"application"===e||"operation view"===e||"desktop application"===e?a="apps":"map document"===e||"map package"===e||"published map"===e||"scene document"===e||"globe document"===e||"basemap package"===e||"mobile basemap package"===e||"mobile map package"===e||"project package"===e||"project template"===e||"pro map"===e||"layout"===e||"layer"===e&&t.includes("ArcGIS Pro")||"explorer map"===e&&t.indexOf("Explorer Document")?a="mapsgray":"service definition"===e||"shapefile"===e||"cad drawing"===e||"geojson"===e||"netcdf"===e||"administrative report"===e?a="datafiles":"360 vr experience"===e?a="360vr":"explorer add in"===e||"desktop add in"===e||"windows viewer add in"===e||"windows viewer configuration"===e?a="appsgray":"arcgis pro add in"===e||"arcgis pro configuration"===e?a="addindesktop":"pdf"===e?a="pdf":"microsoft word"===e?a="word":"microsoft excel"===e?a="excel":"microsoft powerpoint"===e?a="ppt":"rule package"===e||"file geodatabase"===e||"sqlite geodatabase"===e||"csv collection"===e||"kml collection"===e||"windows mobile package"===e||"map template"===e||"desktop application template"===e||"gml"===e||"arcpad package"===e||"code sample"===e||"document link"===e||"earth configuration"===e||"operations dashboard add in"===e||"rules package"===e||"workflow manager package"===e||"explorer map"===e&&t.includes("Explorer Mapping Application")||t.includes("Document")?a="datafilesgray":"network analysis service"===e||"geoprocessing service"===e||"geodata service"===e||"geometry service"===e||"geoprocessing package"===e||"locator package"===e||"geoprocessing sample"===e||"workflow manager service"===e?a="toolsgray":"layer"===e||"layer package"===e||"explorer layer"===e?a="layersgray":"analysis model"===e?a="analysismodel":"scene package"===e?a="scenepackage":"3dtiles package"===e?a="3dtileslayerpackage":"3dtiles service"===e?a="3dtileslayer":"mobile scene package"===e?a="mobilescenepackage":"tile package"===e||"compact tile package"===e?a="tilepackage":"task file"===e?a="taskfile":"report template"===e?a="report-template":"statistical data collection"===e?a="statisticaldatacollection":"insights workbook"===e?a="workbook":"insights model"===e?a="insightsmodel":"insights page"===e?a="insightspage":"insights theme"===e?a="insightstheme":"hub initiative"===e?a="hubinitiative":"hub page"===e?a="hubpage":"hub site application"===e?a="hubsite":"hub event"===e?a="hubevent":"hub project"===e?a="hubproject":"relational database connection"===e?a="relationaldatabaseconnection":"big data file share"===e?a="datastorecollection":"image collection"===e?a="imagecollection":"desktop style"===e?a="desktopstyle":"style"===e?a=t.includes("Dictionary")?"dictionarystyle":"style":"dashboard"===e?a="dashboard":"raster function template"===e?a="rasterprocessingtemplate":"vector tile package"===e?a="vectortilepackage":"ortho mapping project"===e?a="orthomappingproject":"ortho mapping template"===e?a="orthomappingtemplate":"solution"===e?a="solutions":"geopackage"===e?a="geopackage":"deep learning package"===e?a="deeplearningpackage":"real time analytic"===e?a="realtimeanalytics":"reality mapping project"===e?a="realitymappingproject":"big data analytic"===e?a="bigdataanalytics":"feed"===e?a="feed":"excalibur imagery project"===e?a="excaliburimageryproject":"notebook"===e?a="notebook":"storymap"===e?a="storymap":"survey123 add in"===e?a="survey123addin":"mission"===e?a="mission":"mission report"===e?a="missionreport":"mission template"===e?a="missiontemplate":"quickcapture project"===e?a="quickcaptureproject":"pro report"===e?a="proreport":"pro report template"===e?a="proreporttemplate":"urban model"===e?a="urbanmodel":"urban project"===e?a="urbanproject":"web experience"===e?a="experiencebuilder":"web experience template"===e?a="webexperiencetemplate":"experience builder widget"===e?a="experiencebuilderwidget":"experience builder widget package"===e?a="experiencebuilderwidgetpackage":"workflow"===e?a="workflow":"kernel gateway connection"===e?a="kernelgatewayconnection":"insights script"===e?a="insightsscript":"hub initiative template"===e?a="hubinitiativetemplate":"storymap theme"===e?a="storymaptheme":"knowledge graph"===e?a="knowledgegraph":"knowledge graph layer"===e?a="knowledgegraphlayer":"knowledge studio project"===e?a="knowledgestudio":"native application"===e?a="nativeapp":"native application installer"===e?a="nativeappinstaller":"web link chart"===e?a="linkchart":"knowledge graph web investigation"===e?a="investigation":"ogcfeatureserver"===e?a="features":"pro presentation"===e?a="propresentation":"pro project"===e?a="proproject":"insights workbook package"===e?a="insightsworkbookpackage":"apache parquet"===e?a="apacheparquet":"notebook code snippet library"===e?a="notebookcodesnippets":"suitability model"===e?a="suitabilitymodel":"esri classifier definition"===e?a="classifierdefinition":"esri classification schema"===e?a="classificationschema":"insights data engineering workbook"===e?a="dataengineeringworkbook":"insights data engineering model"===e?a="dataengineeringmodel":"deep learning studio project"===e?a="deeplearningproject":"discussion"===e?a="discussion":"allsource project"===e?a="allsourceproject":"api key"===e?a="apikey":"data pipeline"===e?a="datapipelines":"group layer"===e?(y=t.includes("Map"),a=y?"layergroup2d":"layergroup"):a="media layer"===e?"onlinemedialayer":"form"===e?t.includes("Survey123")?"survey":"datafilesgray":"csv"===e?"csv":"image"===e?"image":"maps",a?r.getAssetUrl(i+a+o+".png"):null}get isLayer(){return null!=this.type&&v.has(this.type)}get itemCdnUrl(){return g.toCDNUrl(this.itemUrl)}get itemPageUrl(){const e=this.portal?.itemPageUrl;return e&&this.id?`${e}?id=${this.id}`:null}get itemUrl(){const e=this.portal?.restUrl;return e&&this.id?`${e}/content/items/${this.id}`:null}get thumbnailUrl(){const e=this.itemUrl,t=this.thumbnail;return e&&t?this.portal?.normalizeUrl(`${e}/info/${t}?f=json`)??null:null}get userItemUrl(){const e=this.portal?.restUrl;if(!e)return null;const t=this.owner||this.portal?.user?.username;if(!t)return null;return`${e}/content/users/${this.ownerFolder?`${t}/${this.ownerFolder}`:t}/items/${this.id}`}load(e){const t=this.portal??(this.portal=y.getDefault()),r=t.load(e).then((()=>this.sourceJSON?this.sourceJSON:this.id&&this.itemUrl?t.request(this.itemUrl,{signal:null!=e?e.signal:null,query:{token:this.apiKey}}):{})).then((e=>{this.sourceJSON=e,this.read(e)}));return this.addResolvingPromise(r),Promise.resolve(this)}async addRating(e){const t={method:"post",query:{}};return e instanceof m&&(e=e.rating),null==e||isNaN(e)||"number"!=typeof e||(t.query.rating=e),this.portal?(await this.portal.request(this.itemUrl+"/addRating",t),new m({rating:e,created:new Date})):null}clone(){const e={access:this.access,accessInformation:this.accessInformation,applicationProxies:a.clone(this.applicationProxies),avgRating:this.avgRating,categories:a.clone(this.categories),classification:a.clone(this.classification),created:a.clone(this.created),culture:this.culture,description:this.description,extent:a.clone(this.extent),groupCategories:a.clone(this.groupCategories),id:this.id,itemControl:this.itemControl,licenseInfo:this.licenseInfo,modified:a.clone(this.modified),name:this.name,numComments:this.numComments,numRatings:this.numRatings,numViews:this.numViews,owner:this.owner,ownerFolder:this.ownerFolder,portal:this.portal,screenshots:a.clone(this.screenshots),size:this.size,snippet:this.snippet,sourceUrl:this.sourceUrl,spatialReference:this.spatialReference,tags:a.clone(this.tags),thumbnail:this.thumbnail,title:this.title,type:this.type,typeKeywords:a.clone(this.typeKeywords),url:this.url};this.loaded&&(e.loadStatus="loaded");const t=new w({sourceJSON:this.sourceJSON}).set(e);return t._set("isOrgItem",this.isOrgItem),t}createPostQuery(){const e=this.toJSON();for(const t of["tags","typeKeywords","categories"])e[t]=e[t]?.join(", ");for(const t of["extent","classification"]){const r=e[t];r&&(e[t]=JSON.stringify(r))}return e}async deleteRating(){await this.portal.request(this.itemUrl+"/deleteRating",{method:"post"})}fetchData(e="json",t){return this.portal.request(this.itemUrl+"/data",{responseType:e,...t,query:{token:this.apiKey}})}async fetchRating(e){const t=await this.portal.request(this.itemUrl+"/rating",{query:{token:this.apiKey},...e});return null!=t.rating?(t.created=new Date(t.created),new m(t)):null}fetchRelatedItems(e,t){return this.portal.requestToTypedArray(this.itemUrl+"/relatedItems",{query:{...e,token:this.apiKey},...t},w)}getThumbnailUrl(e){let t=this.thumbnailUrl;return t&&e&&(t+=`&w=${e}`),t}reload(){return this.portal.request(this.itemUrl??"",{cacheBust:!0,query:{token:this.apiKey}}).then((e=>(this.applicationProxies&&!Object.hasOwn(e,"appProxies")&&(this.applicationProxies=null),this.sourceJSON=e,this.read(e),this)))}update(e){return this.id?this.load().then((()=>this.portal.signIn())).then((()=>{const t=e?.data,r={method:"post"};r.query=this.createPostQuery();for(const e in r.query)null===r.query[e]&&(r.query[e]="");return r.query.clearEmptyFields=!0,null!=t&&("string"==typeof t?r.query.text=t:"object"==typeof t&&(r.query.text=JSON.stringify(t))),this.portal.request(`${this.userItemUrl}/update`,r).then((()=>this.reload()))})):Promise.reject(new i("portal:item-does-not-exist","The item does not exist yet and cannot be updated"))}async copy(e){if(!this.id)throw new i("portal:item-does-not-exist","The item does not exist yet");await this.load();const{portal:t,itemUrl:r}=this;await t.signIn();const{copyResources:o,folder:a,tags:s,title:n}=e||{},l={method:"post",query:{copyPrivateResources:"all"===o,folder:"string"==typeof a?a:a?.id,includeResources:!!o,tags:s?.join(","),title:n}},{itemId:p}=await t.request(`${r}/copy`,l);return new w({id:p,portal:t})}updateThumbnail(e){return this.id?this.load().then((()=>this.portal.signIn())).then((()=>{const t=e.thumbnail,r=e.filename,i={method:"post"};if("string"==typeof t)n.isDataProtocol(t)?i.query={data:t}:i.query={url:n.makeAbsolute(t)},null!=r&&(i.query.filename=r);else{const e=new FormData;null!=r?e.append("file",t,r):e.append("file",t),i.body=e}return this.portal.request(`${this.userItemUrl}/updateThumbnail`,i).then((()=>this.reload()))})):Promise.reject(new i("portal:item-does-not-exist","The item does not exist yet and cannot be updated"))}async fetchResources(t={},r){const{fetchResources:i}=await new Promise(((t,r)=>e(["./support/resourceUtils"],t,r)));return i(this,t,r)}async addResource(t,r,i){const{addOrUpdateResources:o}=await new Promise(((t,r)=>e(["./support/resourceUtils"],t,r)));return t.portalItem=this,await o(this,[{resource:t,content:r,compress:i?.compress,access:i?.access}],"add",i),t}async removeResource(t,r){const{removeResource:o}=await new Promise(((t,r)=>e(["./support/resourceUtils"],t,r)));if(t.portalItem&&t.portalItem.itemUrl!==this.itemUrl)throw new i("removeresource:portal-item-mismatch","The portal item associated with the provided resource does not match the item");return o(this,t,r)}async removeAllResources(t){const{removeAllResources:r}=await new Promise(((t,r)=>e(["./support/resourceUtils"],t,r)));return r(this,t)}resourceFromPath(e){return new h({portalItem:this,path:e})}toJSON(){const e=this.extent,t={accessInformation:this.accessInformation,categories:a.clone(this.categories),classification:a.clone(this.classification),created:this.created?.getTime(),description:this.description,extent:e&&[[e.xmin,e.ymin],[e.xmax,e.ymax]],id:this.id,isOrgItem:this.isOrgItem,licenseInfo:this.licenseInfo,modified:this.modified?.getTime(),name:this.name,owner:this.owner,ownerFolder:this.ownerFolder,snippet:this.snippet,sourceUrl:this.sourceUrl,spatialReference:this.spatialReference,tags:a.clone(this.tags),thumbnail:this.thumbnail,title:this.title,type:this.type,typeKeywords:a.clone(this.typeKeywords),url:this.url};return a.fixJson(t)}static fromJSON(e){if(!e)return null;if(e.declaredClass)throw new Error("JSON object is already hydrated");return new w({sourceJSON:e})}_getPostQuery(){const e=this.toJSON();for(const t in e)"tags"===t&&null!==e[t]&&(e[t]=e[t].join(", ")),"typeKeywords"===t&&null!==e[t]&&(e[t]=e[t].join(", ")),"extent"===t&&e[t]&&(e[t]=JSON.stringify(e[t]));return e}};t.__decorate([l.property({type:["private","shared","org","public"]})],f.prototype,"access",void 0),t.__decorate([l.property()],f.prototype,"accessInformation",void 0),t.__decorate([l.property({type:String})],f.prototype,"apiKey",void 0),t.__decorate([l.property({json:{read:{source:"appProxies"}}})],f.prototype,"applicationProxies",void 0),t.__decorate([l.property()],f.prototype,"avgRating",void 0),t.__decorate([l.property()],f.prototype,"categories",void 0),t.__decorate([l.property()],f.prototype,"classification",void 0),t.__decorate([l.property({type:Date})],f.prototype,"created",void 0),t.__decorate([l.property()],f.prototype,"culture",void 0),t.__decorate([l.property()],f.prototype,"description",void 0),t.__decorate([l.property({readOnly:!0})],f.prototype,"displayName",null),t.__decorate([l.property({type:u})],f.prototype,"extent",void 0),t.__decorate([c.reader("extent")],f.prototype,"readExtent",null),t.__decorate([l.property()],f.prototype,"groupCategories",void 0),t.__decorate([l.property({readOnly:!0})],f.prototype,"iconUrl",null),t.__decorate([l.property()],f.prototype,"id",void 0),t.__decorate([l.property({readOnly:!0})],f.prototype,"isLayer",null),t.__decorate([l.property({type:Boolean,readOnly:!0})],f.prototype,"isOrgItem",void 0),t.__decorate([l.property()],f.prototype,"itemControl",void 0),t.__decorate([l.property({readOnly:!0})],f.prototype,"itemPageUrl",null),t.__decorate([l.property({readOnly:!0})],f.prototype,"itemUrl",null),t.__decorate([l.property()],f.prototype,"licenseInfo",void 0),t.__decorate([l.property({type:Date})],f.prototype,"modified",void 0),t.__decorate([l.property()],f.prototype,"name",void 0),t.__decorate([l.property()],f.prototype,"numComments",void 0),t.__decorate([l.property()],f.prototype,"numRatings",void 0),t.__decorate([l.property()],f.prototype,"numViews",void 0),t.__decorate([l.property()],f.prototype,"owner",void 0),t.__decorate([l.property()],f.prototype,"ownerFolder",void 0),t.__decorate([l.property({type:y})],f.prototype,"portal",void 0),t.__decorate([l.property()],f.prototype,"screenshots",void 0),t.__decorate([l.property()],f.prototype,"size",void 0),t.__decorate([l.property()],f.prototype,"snippet",void 0),t.__decorate([l.property()],f.prototype,"sourceJSON",void 0),t.__decorate([l.property({type:String})],f.prototype,"sourceUrl",void 0),t.__decorate([l.property({type:String})],f.prototype,"spatialReference",void 0),t.__decorate([l.property()],f.prototype,"tags",void 0),t.__decorate([l.property()],f.prototype,"thumbnail",void 0),t.__decorate([l.property({readOnly:!0})],f.prototype,"thumbnailUrl",null),t.__decorate([l.property()],f.prototype,"title",void 0),t.__decorate([l.property()],f.prototype,"type",void 0),t.__decorate([l.property()],f.prototype,"typeKeywords",void 0),t.__decorate([l.property({type:String,json:{read(e,t){if(b.has(t.type)){const t=this.portal?.restUrl;e||=t&&this.id?`${t}/content/items/${this.id}/data`:null}return e}}})],f.prototype,"url",void 0),t.__decorate([l.property({readOnly:!0})],f.prototype,"userItemUrl",null),f=w=t.__decorate([d.subclass("esri.portal.PortalItem")],f);return f}));
