/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../core/Error","../core/JSONSupport","../core/accessorSupport/decorators/property","../core/has","../core/Logger","../core/RandomLCG","../core/accessorSupport/decorators/subclass","./PortalFolder","./PortalGroup"],(function(e,t,r,o,l,s,n,p,i,a,u){"use strict";const d=e=>Object.freeze(Object.defineProperty({__proto__:null,default:e},Symbol.toStringTag,{value:"Module"}));var c;let y=c=class extends o.JSONSupport{constructor(e){super(e),this.access=null,this.created=null,this.culture=null,this.description=null,this.email=null,this.fullName=null,this.modified=null,this.orgId=null,this.portal=null,this.preferredView=null,this.privileges=null,this.region=null,this.role=null,this.roleId=null,this.sourceJSON=null,this.units=null,this.username=null,this.userLicenseTypeId=null,this.userType=null}get thumbnailUrl(){const e=this.url,t=this.thumbnail;return e&&t?this.portal.normalizeUrl(`${e}/info/${t}?f=json`):null}get userContentUrl(){const e=this.portal?.restUrl;return e?`${e}/content/users/${this.username}`:null}get url(){const e=this.portal?.restUrl;return e?`${e}/community/users/${this.username}`:null}addItem(e){const t=e&&e.item,r=e?.data,o=e?.folder,l={method:"post"};t&&(l.query=t.createPostQuery(),null!=r&&("string"==typeof r?l.query.text=r:"object"==typeof r&&(l.query.text=JSON.stringify(r))));let s=this.userContentUrl;return o&&(s+="/"+("string"==typeof o?o:o.id)),this.portal.request(s+"/addItem",l).then((e=>(t.id=e.id,t.portal=this.portal,t.loaded?t.reload():t.load())))}async deleteItem(e,t=!1){let r=this.userContentUrl;e.ownerFolder&&(r+="/"+e.ownerFolder);const o=t?{permanentDelete:!0}:{};await this.portal.request(r+`/items/${e.id}/delete`,{method:"post",query:o}),e.id=null,e.portal=null}async deleteItems(e,t=!1){e=e.slice();const o=this.userContentUrl+"/deleteItems",l=[],s=e.map((e=>e.id));if(s.length){const n={method:"post",query:{items:s.join(","),permanentDelete:t}},p=await this.portal.request(o,n);for(const t of p.results){const o=e.find((e=>t.itemId===e.id)),s=t.success;let n=null;s?(o.id=null,o.portal=null):t.error&&(n=new r("portal:delete-item-failed",t.error.message,t.error)),l.push({item:o,success:s,error:n})}}return l}fetchFolders(){const e={query:{num:1}};return this.portal.request(this.userContentUrl??"",e).then((e=>{let t;return t=e&&e.folders?e.folders.map((e=>{const t=a.fromJSON(e);return t.portal=this.portal,t})):[],t}))}fetchGroups(){return this.portal.request(this.url??"").then((e=>{let t;return t=e&&e.groups?e.groups.map((e=>{const t=u.fromJSON(e);return t.portal=this.portal,t})):[],t}))}async fetchItems(t){t??={};let r=this.userContentUrl??"";t.folder&&(r+="/"+t.folder.id);const{default:o}=await new Promise(((t,r)=>e(["./PortalItem"],(e=>t(d(e))),r))),l={folders:!1,inRecycleBin:!!t.inRecycleBin||null,foldersContent:!(t.folder||!t.includeSubfolderItems)||null,num:t.num||10,start:t.start||1,sortField:t.sortField||"created",sortOrder:t.sortOrder||"asc"},s=await this.portal.request(r,{query:l});let n;return s?.items?(n=s.items.map((e=>{const t=o.fromJSON(e);return t.portal=this.portal,t})),await Promise.all(n.map((e=>e.load()))),{items:n,nextStart:s.nextStart,total:s.total}):{items:[],nextStart:-1,total:0}}fetchTags(){return this.portal.request(this.url+"/tags").then((e=>e.tags))}getThumbnailUrl(e){let t=this.thumbnailUrl;return t&&e&&(t+=`&w=${e}`),t}queryFavorites(e){return this.favGroupId?(this._favGroup||(this._favGroup=new u({id:this.favGroupId,portal:this.portal})),this._favGroup.queryItems(e)):Promise.reject(new r("internal:unknown","Unknown internal error",{internalError:"Unknown favGroupId"}))}async restoreItem(e,t){const r=this.userContentUrl,o=t?{folderID:"string"==typeof t?t:t.id}:null;await this.portal.request(r+`/items/${e.id}/restore`,{method:"post",query:o})}toJSON(){throw new r("internal:not-yet-implemented","PortalUser.toJSON is not yet implemented")}static fromJSON(e){if(!e)return null;if(e.declaredClass)throw new Error("JSON object is already hydrated");const t=new c({sourceJSON:e});return t.read(e),t}};t.__decorate([l.property()],y.prototype,"access",void 0),t.__decorate([l.property({type:Date})],y.prototype,"created",void 0),t.__decorate([l.property()],y.prototype,"culture",void 0),t.__decorate([l.property()],y.prototype,"description",void 0),t.__decorate([l.property()],y.prototype,"email",void 0),t.__decorate([l.property()],y.prototype,"favGroupId",void 0),t.__decorate([l.property()],y.prototype,"fullName",void 0),t.__decorate([l.property({type:Date})],y.prototype,"modified",void 0),t.__decorate([l.property()],y.prototype,"orgId",void 0),t.__decorate([l.property()],y.prototype,"portal",void 0),t.__decorate([l.property()],y.prototype,"preferredView",void 0),t.__decorate([l.property()],y.prototype,"privileges",void 0),t.__decorate([l.property()],y.prototype,"region",void 0),t.__decorate([l.property()],y.prototype,"role",void 0),t.__decorate([l.property()],y.prototype,"roleId",void 0),t.__decorate([l.property()],y.prototype,"sourceJSON",void 0),t.__decorate([l.property()],y.prototype,"thumbnail",void 0),t.__decorate([l.property({readOnly:!0})],y.prototype,"thumbnailUrl",null),t.__decorate([l.property()],y.prototype,"units",void 0),t.__decorate([l.property({readOnly:!0})],y.prototype,"userContentUrl",null),t.__decorate([l.property({readOnly:!0})],y.prototype,"url",null),t.__decorate([l.property()],y.prototype,"username",void 0),t.__decorate([l.property()],y.prototype,"userLicenseTypeId",void 0),t.__decorate([l.property()],y.prototype,"userType",void 0),y=c=t.__decorate([i.subclass("esri.portal.PortalUser")],y);return y}));
