/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../core/Error","../../layers/support/arcgisLayerUrl","../../layers/support/fetchService","../../layers/support/LayerLoadContext","../../layers/support/layersCreator","../../layers/support/lazyLayerLoader","../Portal","./jsonContext","./loadUtils","./portalItemUtils","../../renderers/support/styleUtils","../../support/requestPresets"],(function(e,t,r,a,n,o,s,l,i,c,u,y,p){"use strict";async function d(e,t){const r=e.instance.portalItem;if(r?.id)return await r.load(t),f(e),e.validateItem&&e.validateItem(r),m(e,t)}function f(e){const r=e.instance.portalItem;if(!r?.type||!e.supportedTypes.includes(r.type))throw new t("portal:invalid-layer-item-type","Invalid layer item type '${type}', expected '${expectedType}'",{type:r?.type,expectedType:e.supportedTypes.join(", ")})}async function m(e,t){const r=e.instance,a=r.portalItem;if(!a)return;const{url:o,title:s}=a,l=i.createForItemRead(a,"portal-item");if("group"===r.type)return w(r,l,e);o&&"media"!==r.type&&r.read({url:o},l);const c=new n.LayerLoadContext,u=await S(e,c,t);return u&&r.read(u,l),r.resourceReferences={portalItem:a,paths:l.readResourcePaths??[]},"subtype-group"!==r.type&&r.read({title:s},l),y.loadStyleRenderer(r,l)}async function w(e,r,a){const n=e.portalItem;if(!e.sourceIsPortalItem)return;const{title:o,type:s}=n;if("Group Layer"===s){if(!u.hasTypeKeyword(n,"Map"))throw new t("portal:invalid-layer-item-typekeyword","'Group Layer' item without 'Map' type keyword is not supported");return h(e)}return e.read({title:o},r),L(e,a)}async function h(e){const t=e.portalItem,r=await t.fetchData("json");if(!r)return;const a=i.createForItemRead(t,"web-map");e.read(r,a),await o.populateGroupLayer(e,r,{context:a}),e.resourceReferences={portalItem:t,paths:a.readResourcePaths??[]}}async function L(e,r){let a;const{portalItem:o}=e;if(!o)return;const s=o.type,l=r.layerModuleTypeMap;switch(s){case"Feature Service":case"Feature Collection":a=l.FeatureLayer;break;case"Stream Service":a=l.StreamLayer;break;case"Scene Service":a=l.SceneLayer;break;default:throw new t("portal:unsupported-item-type-as-group",`The item type '${s}' is not supported as a 'IGroupLayer'`)}const i=new n.LayerLoadContext;let[u,y]=await Promise.all([a(),S(r,i)]),p=()=>u;if("Feature Service"===s){const t=c.getFirstLayerOrTable(y)?.customParameters;y=o.url?await c.preprocessFSItemData(y,o.url,i):{},p=await x(y,l)||p;const r=await P(o.url,{customParameters:t,loadContext:i});return await b(e,p,y,r)}return"Scene Service"===s&&o.url&&(y=await c.populateSceneServiceItemData(o,y,i)),c.getNumLayersAndTables(y)>0?await b(e,p,y):await I(e,p)}async function I(e,t){const{portalItem:r}=e;if(!r?.url)return;const a=await p.fetchArcGISServiceJSON(r.url);a&&b(e,t,{layers:a.layers?.map(c.createSublayerData),tables:a.tables?.map(c.createSublayerData)})}async function b(e,t,r,a){let n=r.layers||[];const o=r.tables||[];if("Feature Collection"===e.portalItem?.type?(n.forEach(((e,t)=>{e.id=t,"Table"===e?.layerDefinition?.type&&o.push(e)})),n=n.filter((e=>"Table"!==e?.layerDefinition?.type))):(n.reverse(),o.reverse()),n.forEach((n=>{const o=a?.(n);if(o||!a){const a=g(e,t(n),r,n,o);e.add(a)}})),o.length){const t=await s.layerLookupMap.FeatureLayer();o.forEach((n=>{const o=a?.(n);if(o||!a){const a=g(e,t,r,n,o);e.tables.add(a)}}))}}function g(e,t,r,a,n){const o=e.portalItem,s={portalItem:o.clone(),layerId:a.id};null!=a.url&&(s.url=a.url);const i=new t(s);if("sourceJSON"in i&&(i.sourceJSON=n),"subtype-group"!==i.type&&"catalog"!==i.type&&(i.sublayerTitleMode="service-name"),"Feature Collection"===o.type){const e={origin:"portal-item",portal:o.portal||l.getDefault()};i.read(a,e);const t=r.showLegend;null!=t&&i.read({showLegend:t},e)}return i}async function S(e,t,r){if(!1===e.supportsData)return;const a=e.instance,n=a.portalItem;if(!n)return;let o=null;try{o=await n.fetchData("json",r)}catch(s){}if(F(a)){let e=null;const r=await T(n,o,t);if((o?.layers||o?.tables)&&r>0){if(null==a.layerId){const e=c.instanceTypeToLayerType(a.type),t=e?c.getSublayersByLayerType(o,e)[0]:c.getFirstLayerOrTable(o);t&&(a.layerId=t.id)}e=v(o,a),"OrientedImageryLayer"===e?.layerType&&"oriented-imagery"===a.type&&a.supportedSourceTypes.add("Feature Layer"),e&&null!=o.showLegend&&(e.showLegend=o.showLegend)}return r>1&&"sublayerTitleMode"in a&&"service-name"!==a.sublayerTitleMode&&(a.sublayerTitleMode="item-title-and-service-name"),e}return o}async function T(e,t,a){if(t?.layers&&t?.tables)return c.getNumLayersAndTables(t);const n=r.parse(e.url);if(!n)return 1;const o=await a.fetchServiceMetadata(n.url.path,{customParameters:c.getFirstLayerOrTable(t)?.customParameters}).catch((()=>null));return(t?.layers?.length??o?.layers?.length??0)+(t?.tables?.length??o?.tables?.length??0)}function v(e,t){const{layerId:r}=t,a=e.layers?.find((e=>e.id===r))||e.tables?.find((e=>e.id===r));return a&&M(a,t)?a:null}function F(e){return"stream"!==e.type&&"layerId"in e}function M(e,t){const r="layerType"in e&&e.layerType,{type:a}=t;return!("feature"===a&&r&&"ArcGISFeatureLayer"!==e.layerType||"catalog"===a&&!r||"oriented-imagery"===a&&!r||"subtype-group"===a&&!r)}async function P(e,t){const{layersJSON:r}=await a.fetchFeatureService(e,t);if(!r)return null;const n=[...r.layers,...r.tables];return e=>n.find((t=>t.id===e.id))}async function x(e,t){const{layers:r}=e;if(!r?.length)return;const a=new Set,n=[];for(const{layerType:l}of r){const e=l??"ArcGISFeatureLayer";if(a.has(e))continue;a.add(e);const r=t[c.layerTypeToLayerModuleType(e)];n.push(r())}const o=await Promise.all(n),s=new Map;return Array.from(a).forEach(((e,t)=>{s.set(e,o[t])})),({layerType:e})=>{const t=e??"ArcGISFeatureLayer";return s.get(t)}}e.load=d,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
