/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../core/Error","../../layers/support/associatedFeatureServiceUtils","../../layers/support/fetchService","../../layers/support/LayerLoadContext","../../layers/support/layerUtils","../../layers/support/lazyLayerLoader","../PortalItem","./loadUtils","./portalItemUtils"],(function(e,a,r,t,s,c,n,o,i,u){"use strict";async function l(e){let{portalItem:a}=e;!a||a instanceof o||(a=new o(a));const r=await y(a);return new(0,r.constructor)({portalItem:a,...r.properties})}async function y(e){await e.load();const a=new s.LayerLoadContext;return p(await m(e,a))}async function m(e,r){switch(e.type){case"3DTiles Service":return v();case"CSV":return h();case"Feature Collection":return S(e);case"Feature Service":return L(e,r);case"Feed":return P();case"GeoJson":return g();case"Group Layer":return G();case"Image Service":return w(e,r);case"KML":return I();case"Knowledge Graph Layer":return M();case"Map Service":return f(e,r);case"Media Layer":return K();case"Scene Service":return d(e,r);case"Stream Service":return N();case"Vector Tile Service":return T();case"WFS":return C();case"WMS":return b();case"WMTS":return F();default:throw new a("portal:unknown-item-type","Unknown item type '${type}'",{type:e.type})}}async function p(e){const a=e.className,r=n.layerLookupMap[a];return{constructor:await r(),properties:e.properties}}async function f(e,a){return await O(e,a)?{className:"TileLayer"}:{className:"MapImageLayer"}}async function L(e,a){const r=await j(e,a);if("object"==typeof r){const{sourceJSON:e,className:a}=r,t={sourceJSON:e};return null!=r.id&&(t.layerId=r.id),{className:a||"FeatureLayer",properties:t}}return{className:"GroupLayer"}}async function d(e,a){const t=await j(e,a,(async()=>{try{if(!e.url)return[];const{serverUrl:t}=await r.findAssociatedFeatureService(e.url,{sceneLayerItem:e}),s=await a.fetchServiceMetadata(t);return s?.tables??[]}catch{return[]}}));if("object"==typeof t){const r={};let s;if(null!=t.id?(r.layerId=t.id,s=`${e.url}/layers/${t.id}`):s=e.url,e.typeKeywords?.length)for(const a of Object.keys(c.sceneServiceLayerTypeToClassName))if(e.typeKeywords.includes(a))return{className:c.sceneServiceLayerTypeToClassName[a]};const n=await a.fetchServiceMetadata(s,{customParameters:await a.fetchCustomParameters(e,(e=>i.getFirstLayerOrTable(e)?.customParameters))});return{className:c.sceneServiceLayerTypeToClassName[n?.layerType]||"SceneLayer",properties:r}}if(!1===t){const r=await a.fetchServiceMetadata(e.url);if("Voxel"===r?.layerType)return{className:"VoxelLayer"}}return{className:"GroupLayer"}}async function S(e){await e.load();const a=u.hasTypeKeyword(e,"Map Notes"),r=u.hasTypeKeyword(e,"Markup");if(a||r)return{className:"MapNotesLayer"};if(u.hasTypeKeyword(e,"Route Layer"))return{className:"RouteLayer"};const t=await e.fetchData();return 1===i.getNumLayersAndTables(t)?{className:"FeatureLayer"}:{className:"GroupLayer"}}async function w(e,a){await e.load();const r=e.typeKeywords?.map((e=>e.toLowerCase()))??[];if(r.includes("elevation 3d layer"))return{className:"ElevationLayer"};if(r.includes("tiled imagery"))return{className:"ImageryTileLayer"};const t=await a.fetchItemData(e),s=t?.layerType;if("ArcGISTiledImageServiceLayer"===s)return{className:"ImageryTileLayer"};if("ArcGISImageServiceLayer"===s)return{className:"ImageryLayer"};const c=await a.fetchServiceMetadata(e.url,{customParameters:await a.fetchCustomParameters(e)}),n=c.cacheType?.toLowerCase(),o=c.capabilities?.toLowerCase().includes("tilesonly"),i=c.tileInfo?.format?.toLowerCase()??"",u=null==n&&["jpg","jpeg","png","png8","png24","png32","mixed"].includes(i);return"map"===n||u||o?{className:"ImageryTileLayer"}:{className:"ImageryLayer"}}function N(){return{className:"StreamLayer"}}function T(){return{className:"VectorTileLayer"}}function g(){return{className:"GeoJSONLayer"}}function v(){return{className:"IntegratedMesh3DTilesLayer"}}function h(){return{className:"CSVLayer"}}function I(){return{className:"KMLLayer"}}function M(){return{className:"KnowledgeGraphLayer"}}function C(){return{className:"WFSLayer"}}function b(){return{className:"WMSLayer"}}function F(){return{className:"WMTSLayer"}}function P(){return{className:"StreamLayer"}}function G(){return{className:"GroupLayer"}}function K(){return{className:"MediaLayer"}}async function O(e,a){const{tileInfo:r}=await a.fetchServiceMetadata(e.url,{customParameters:await a.fetchCustomParameters(e)});return r}async function j(e,a,r){const{url:s,type:c}=e,n="Feature Service"===c;if(!s)return{};if(/\/\d+$/.test(s)){if(n){const r=await a.fetchServiceMetadata(s,{customParameters:await a.fetchCustomParameters(e,(e=>i.getFirstLayerOrTable(e)?.customParameters))});return{id:r.id,className:t.getLayerModuleType(r.type),sourceJSON:r}}return{}}await e.load();let o=await a.fetchItemData(e);if(n){const e=await i.preprocessFSItemData(o,s,a),r=D(e);if("object"==typeof r){const a=i.getLayerOrTable(e,r.id);r.className=i.layerTypeToLayerModuleType(a?.layerType)}return r}"Scene Service"===c&&(o=await i.populateSceneServiceItemData(e,o,a));if(i.getNumLayersAndTables(o)>0)return D(o);const u=await a.fetchServiceMetadata(s);return r&&(u.tables=await r()),D(u)}function D(e){return 1===i.getNumLayersAndTables(e)&&{id:i.getFirstLayerOrTable(e)?.id}}e.fromItem=l,e.selectLayerClassPath=m,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
