/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../Color","../symbols","../core/lang","../core/screenUtils","../core/accessorSupport/decorators/property","../core/has","../core/Logger","../core/accessorSupport/decorators/enumeration","../core/accessorSupport/decorators/subclass","../layers/support/fieldUtils","./Renderer","./support/AuthoringInfo","./support/HeatmapColorStop","./support/HeatmapLegendOptions","./support/heatmapUtils","../symbols/SimpleMarkerSymbol"],(function(e,t,i,r,s,o,n,p,a,l,y,u,c,d,m,h,_){"use strict";var g;function x(e){if(null!=e){const{maxDensity:t,minDensity:i,radius:r}=e;if(null!=t||null!=i||null!=r){const{blurRadius:t,maxPixelIntensity:i,minPixelIntensity:r,...s}=e;return s}}return e}let b=g=class extends u{constructor(e){super(e),this.authoringInfo=null,this.colorStops=[new d({ratio:0,color:new t("rgba(255, 140, 0, 0)")}),new d({ratio:.75,color:new t("rgba(255, 140, 0, 1)")}),new d({ratio:.9,color:new t("rgba(255, 0,   0, 1)")})],this.field=null,this.legendOptions=null,this.maxDensity=.04,this.minDensity=0,this.radius=18,this.referenceScale=0,this.type="heatmap",this.valueExpression=null,this.valueExpressionTitle=null}normalizeCtorArgs(e){return x(e)}get blurRadius(){return h.kernelDensityRadiusPtToGaussianBlurRadiusPx(this.radius)}set blurRadius(e){const t=this.maxPixelIntensity,i=this.minPixelIntensity;this._set("radius",h.gaussianBlurRadiusPxToKernelDensityRadiusPt(e)),this._set("maxDensity",t*this._pixelIntensityToDensity),this._set("minDensity",i*this._pixelIntensityToDensity)}get maxPixelIntensity(){return this.maxDensity/this._pixelIntensityToDensity}set maxPixelIntensity(e){this._set("maxDensity",e*this._pixelIntensityToDensity)}get minPixelIntensity(){return this.minDensity/this._pixelIntensityToDensity}set minPixelIntensity(e){this._set("minDensity",e*this._pixelIntensityToDensity)}get _pixelIntensityToDensity(){return 24/(h.magicKernelDensityRadiusInflationFactor**2*this.blurRadius**4)}read(e,t){e=x(e),super.read(e,t)}getSymbol(){return new _}async getSymbolAsync(){return this.getSymbol()}getSymbols(){return[this.getSymbol()]}async collectRequiredFields(e,t){const i=this.field,r=this.valueExpression;i&&"string"==typeof i&&y.collectField(e,t,i),r&&"string"==typeof r&&await y.collectArcadeFieldNames(e,t,r)}getAttributeHash(){return""}getMeshHash(){return`${JSON.stringify(this.colorStops)}.${this.blurRadius}.${this.field}`}clone(){return new g({authoringInfo:this.authoringInfo&&this.authoringInfo.clone(),colorStops:r.clone(this.colorStops),field:this.field,legendOptions:r.clone(this.legendOptions),maxDensity:this.maxDensity,minDensity:this.minDensity,radius:this.radius,referenceScale:this.referenceScale,valueExpression:this.valueExpression,valueExpressionTitle:this.valueExpressionTitle})}};e.__decorate([o.property({type:c,json:{write:!0,origins:{"web-scene":{write:!1,read:!1}}}})],b.prototype,"authoringInfo",void 0),e.__decorate([o.property({type:Number,json:{origins:{"portal-item":{write:!0},"web-map":{write:!0}}}})],b.prototype,"blurRadius",null),e.__decorate([o.property({type:[d],json:{write:!0}})],b.prototype,"colorStops",void 0),e.__decorate([o.property({type:String,json:{write:!0}})],b.prototype,"field",void 0),e.__decorate([o.property({type:m.HeatmapLegendOptions,json:{write:!0}})],b.prototype,"legendOptions",void 0),e.__decorate([o.property({type:Number,json:{write:!0}})],b.prototype,"maxDensity",void 0),e.__decorate([o.property({type:Number,json:{origins:{"portal-item":{write:!0},"web-map":{write:!0}}}})],b.prototype,"maxPixelIntensity",null),e.__decorate([o.property({type:Number,json:{write:!0}})],b.prototype,"minDensity",void 0),e.__decorate([o.property({type:Number,json:{origins:{"portal-item":{write:!0},"web-map":{write:!0}}}})],b.prototype,"minPixelIntensity",null),e.__decorate([o.property({type:Number,cast:s.toPt,json:{write:!0}})],b.prototype,"radius",void 0),e.__decorate([o.property({type:Number,range:{min:0},json:{default:0,write:!0}})],b.prototype,"referenceScale",void 0),e.__decorate([a.enumeration({heatmap:"heatmap"})],b.prototype,"type",void 0),e.__decorate([o.property({type:String,json:{write:!0,origins:{"web-document":{write:!1},"portal-item":{write:!1}}}})],b.prototype,"valueExpression",void 0),e.__decorate([o.property({type:String})],b.prototype,"valueExpressionTitle",void 0),e.__decorate([o.property({readOnly:!0})],b.prototype,"_pixelIntensityToDensity",null),b=g=e.__decorate([l.subclass("esri.renderers.HeatmapRenderer")],b);return b}));
