/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../core/deprecate","../core/JSONSupport","../core/lang","../core/Logger","../core/accessorSupport/decorators/property","../core/has","../core/accessorSupport/decorators/enumeration","../core/accessorSupport/decorators/reader","../core/accessorSupport/decorators/subclass","../core/accessorSupport/decorators/writer","./support/stretchRendererUtils","../rest/support/colorRamps"],(function(t,e,r,o,s,a,i,p,c,n,m,u,d){"use strict";var y;let h=y=class extends r.JSONSupport{constructor(t){super(t),this.colorRamp=null,this.computeGamma=!1,this.dynamicRangeAdjustment=!1,this.gamma=[],this.maxPercent=null,this.minPercent=null,this.numberOfStandardDeviations=null,this.outputMax=null,this.outputMin=null,this.sigmoidStrengthLevel=null,this.histograms=null,this.useGamma=!1,this.stretchType="none",this.type="raster-stretch"}readColorRamp(t){if(t)return d.fromJSON(t)}get statistics(){return this._get("statistics")}set statistics(t){e.deprecatedProperty(s.getLogger(this),"statistics",{replacement:"customStatistics",version:"4.31",warnOnce:!0}),this._set("statistics",t)}get customStatistics(){const t=this.statistics;return t&&Array.isArray(t[0])?t.map((t=>({min:t[0],max:t[1],avg:t[2],stddev:t[3]}))):t}set customStatistics(t){this._set("statistics",t?.map((t=>[t.min,t.max,t.avg??0,t.stddev??1])))}readCustomStatistics(t){return t?.map((t=>({min:t[0],max:t[1],avg:t[2],stddev:t[3]})))}writeCustomStatistics(t,e,r){t?.length&&(e[r]=t.map((t=>[t.min,t.max,t.avg??0,t.stddev??1])))}readStretchType(t,e){let r=e.stretchType;return"number"==typeof r&&(r=u.stretchTypeFunctionEnum[r]),u.stretchTypeJSONDict.read(r)}clone(){return new y({stretchType:this.stretchType,outputMin:this.outputMin,outputMax:this.outputMax,useGamma:this.useGamma,computeGamma:this.computeGamma,statistics:o.clone(this.statistics),customStatistics:o.clone(this.customStatistics),gamma:o.clone(this.gamma),sigmoidStrengthLevel:this.sigmoidStrengthLevel,numberOfStandardDeviations:this.numberOfStandardDeviations,minPercent:this.minPercent,maxPercent:this.maxPercent,colorRamp:o.clone(this.colorRamp),histograms:o.clone(this.histograms),dynamicRangeAdjustment:this.dynamicRangeAdjustment})}};t.__decorate([a.property({types:d.types,json:{write:!0}})],h.prototype,"colorRamp",void 0),t.__decorate([c.reader("colorRamp")],h.prototype,"readColorRamp",null),t.__decorate([a.property({type:Boolean,json:{write:!0}})],h.prototype,"computeGamma",void 0),t.__decorate([a.property({type:Boolean,json:{write:{target:"dra"},read:{source:"dra"}}})],h.prototype,"dynamicRangeAdjustment",void 0),t.__decorate([a.property({type:[Number],json:{write:!0}})],h.prototype,"gamma",void 0),t.__decorate([a.property({type:Number,json:{write:!0}})],h.prototype,"maxPercent",void 0),t.__decorate([a.property({type:Number,json:{write:!0}})],h.prototype,"minPercent",void 0),t.__decorate([a.property({type:Number,json:{write:!0}})],h.prototype,"numberOfStandardDeviations",void 0),t.__decorate([a.property({type:Number,json:{read:{source:"max"},write:{target:"max"}}})],h.prototype,"outputMax",void 0),t.__decorate([a.property({type:Number,json:{read:{source:"min"},write:{target:"min"}}})],h.prototype,"outputMin",void 0),t.__decorate([a.property({type:Number,json:{write:!0}})],h.prototype,"sigmoidStrengthLevel",void 0),t.__decorate([a.property({})],h.prototype,"statistics",null),t.__decorate([a.property()],h.prototype,"histograms",void 0),t.__decorate([a.property({json:{type:[[Number]],name:"statistics",write:!0}})],h.prototype,"customStatistics",null),t.__decorate([c.reader("customStatistics")],h.prototype,"readCustomStatistics",null),t.__decorate([m.writer("customStatistics")],h.prototype,"writeCustomStatistics",null),t.__decorate([a.property({type:Boolean,json:{write:!0}})],h.prototype,"useGamma",void 0),t.__decorate([a.property({type:u.stretchTypeJSONDict.apiValues,json:{type:u.stretchTypeJSONDict.jsonValues,write:u.stretchTypeJSONDict.write}})],h.prototype,"stretchType",void 0),t.__decorate([c.reader("stretchType",["stretchType"])],h.prototype,"readStretchType",null),t.__decorate([p.enumeration({rasterStretch:"raster-stretch"})],h.prototype,"type",void 0),h=y=t.__decorate([n.subclass("esri.renderers.RasterStretchRenderer")],h);return h}));
