/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../symbols","../core/Error","../core/lang","../core/Logger","../core/object","../core/reactiveUtils","../core/accessorSupport/decorators/property","../core/accessorSupport/decorators/cast","../core/accessorSupport/decorators/enumeration","../core/accessorSupport/decorators/reader","../core/accessorSupport/decorators/subclass","../core/accessorSupport/decorators/writer","../core/accessorSupport/diffUtils","../core/accessorSupport/ensureType","../layers/support/fieldUtils","../portal/Portal","./Renderer","./mixins/VisualVariablesMixin","./support/commonProperties","./support/RendererLegendOptions","./support/UniqueValue","./support/UniqueValueClass","./support/UniqueValueGroup","./support/UniqueValueInfo","../support/arcadeOnDemand","../chunks/persistableUrlUtils","../symbols/support/styleUtils","../symbols/WebStyleSymbol"],(function(e,t,s,i,l,o,r,u,n,a,d,p,c,f,h,y,_,m,b,v,V,g,q,I,S,w,U,F,O){"use strict";var G;const D="esri.renderers.UniqueValueRenderer",x=()=>l.getLogger(D),E="uvInfos-watcher",j="uvGroups-watcher",M=",",N=h.ensureType(S);function P(e){const{field1:t,field2:s,field3:i,fieldDelimiter:l,uniqueValueInfos:o,valueExpression:r}=e,u=!(!t||!s);return[{classes:(o??[]).map((e=>{const{symbol:o,label:n,value:a,description:d}=e,[p,c,f]=u?a?.toString()?.split(l||"")||[]:[a],h=[];return(t||r)&&h.push(p),s&&h.push(c),i&&h.push(f),{symbol:o,label:n,values:[h],description:d}}))}]}function R(e){return null!=e&&""!==e&&("string"!=typeof e||""!==e.trim()&&"<null>"!==e.toLowerCase())||(e=null),e+""}let C=G=class extends(b.VisualVariablesMixin(m)){constructor(e){super(e),this._valueInfoMap={},this._isDefaultSymbolDerived=!1,this._isInfosSource=null,this.type="unique-value",this.backgroundFillSymbol=null,this.orderByClassesEnabled=!1,this.valueExpressionTitle=null,this.legendOptions=null,this.defaultLabel=null,this.portal=null,this.styleOrigin=null,this.diff={uniqueValueInfos(e,t){if(!e&&!t)return;if(!e||!t)return{type:"complete",oldValue:e,newValue:t};let s=!1;const i={type:"collection",added:[],removed:[],changed:[],unchanged:[]};for(let l=0;l<t.length;l++){const o=e.find((e=>e.value===t[l].value));o?f.diff(o,t[l])?(i.changed.push({type:"complete",oldValue:o,newValue:t[l]}),s=!0):i.unchanged.push({oldValue:o,newValue:t[l]}):(i.added.push(t[l]),s=!0)}for(let l=0;l<e.length;l++){t.find((t=>t.value===e[l].value))||(i.removed.push(e[l]),s=!0)}return s?i:void 0}},this._set("uniqueValueInfos",[]),this._set("uniqueValueGroups",[])}get _cache(){return{compiledFunc:null}}set field(e){this._set("field",e),this._updateFieldDelimiter(),this._updateUniqueValues()}castField(e){return null==e||"function"==typeof e?e:h.ensureString(e)}writeField(e,t,i,l){"string"==typeof e?t[i]=e:l?.messages?l.messages.push(new s("property:unsupported","UniqueValueRenderer.field set to a function cannot be written to JSON")):x().error(".field: cannot write field to JSON since it's not a string value")}set field2(e){this._set("field2",e),this._updateFieldDelimiter(),this._updateUniqueValues()}set field3(e){this._set("field3",e),this._updateUniqueValues()}set valueExpression(e){this._set("valueExpression",e),this._updateUniqueValues()}set defaultSymbol(e){this._isDefaultSymbolDerived=!1,this._set("defaultSymbol",e)}set fieldDelimiter(e){this._set("fieldDelimiter",e),this._updateUniqueValues()}readPortal(e,t,s){return s.portal||_.getDefault()}readStyleOrigin(e,t,s){if(t.styleName)return Object.freeze({styleName:t.styleName});if(t.styleUrl){const e=U.fromJSON(t.styleUrl,s);return Object.freeze({styleUrl:e})}}writeStyleOrigin(e,t,s,i){e.styleName?t.styleName=e.styleName:e.styleUrl&&(t.styleUrl=U.toJSON(e.styleUrl,i))}set uniqueValueGroups(e){this.styleOrigin?x().error("#uniqueValueGroups=","Cannot modify unique value groups of a UniqueValueRenderer created from a web style"):(this._set("uniqueValueGroups",e),this._updateInfosFromGroups(),this._isInfosSource=!1,this._watchUniqueValueGroups())}set uniqueValueInfos(e){this.styleOrigin?x().error("#uniqueValueInfos=","Cannot modify unique value infos of a UniqueValueRenderer created from a web style"):(this._set("uniqueValueInfos",e),this._updateValueInfoMap(),this._updateGroupsFromInfos(),this._isInfosSource=!0,this._watchUniqueValueInfos())}addUniqueValueInfo(e,s){if(this.styleOrigin)return void x().error("#addUniqueValueInfo()","Cannot modify unique value infos of a UniqueValueRenderer created from a web style");let i;i="object"==typeof e?N(e):new S({value:e,symbol:t.ensureType(s)}),this.uniqueValueInfos?.push(i),this._valueInfoMap[R(i.value)]=i,this._updateGroupsFromInfos(),this._isInfosSource=!0,this._watchUniqueValueInfos()}removeUniqueValueInfo(e){if(this.styleOrigin)return void x().error("#removeUniqueValueInfo()","Cannot modify unique value infos of a UniqueValueRenderer created from a web style");const t=this.uniqueValueInfos;if(t)for(let s=0;s<t.length;s++){const i=t[s];if(String(i.value)===String(e)){delete this._valueInfoMap[R(e)],t.splice(s,1);break}}this._updateGroupsFromInfos(),this._isInfosSource=!0,this._watchUniqueValueInfos()}async getUniqueValueInfo(e,t){let s=t;return this.valueExpression&&null==t?.arcade&&(s={...s,arcade:await w.loadArcade()}),this._getUniqueValueInfo(e,s)}getSymbol(e,t){if(this.valueExpression&&null==t?.arcade)return void x().error("#getSymbol()","Please use getSymbolAsync if valueExpression is used");const s=this._getUniqueValueInfo(e,t);return s?.symbol||this.defaultSymbol}async getSymbolAsync(e,t){let s=t;if(this.valueExpression&&null==s?.arcade){const e=await w.loadArcade(),{arcadeUtils:t}=e;t.hasGeometryOperations(this.valueExpression)&&await t.enableGeometryOperations(),s={...s,arcade:e}}const i=this._getUniqueValueInfo(e,s);return i?.symbol||this.defaultSymbol}getSymbols(){const e=[];for(const t of this.uniqueValueInfos??[])t.symbol&&e.push(t.symbol);return this.defaultSymbol&&e.push(this.defaultSymbol),e}getAttributeHash(){return this.visualVariables?.reduce(((e,t)=>e+t.getAttributeHash()),"")??""}getMeshHash(){const e=JSON.stringify(this.backgroundFillSymbol),t=JSON.stringify(this.defaultSymbol),s=this.uniqueValueInfos?.reduce(((e,t)=>e+t.getMeshHash()),"");return`${e}.${t}.${s}.${`${this.field}.${this.field2}.${this.field3}.${this.fieldDelimiter}`}.${this.valueExpression}`}clone(){const e=new G({field:this.field,field2:this.field2,field3:this.field3,defaultLabel:this.defaultLabel,defaultSymbol:i.clone(this.defaultSymbol),orderByClassesEnabled:this.orderByClassesEnabled,valueExpression:this.valueExpression,valueExpressionTitle:this.valueExpressionTitle,fieldDelimiter:this.fieldDelimiter,visualVariables:i.clone(this.visualVariables),legendOptions:i.clone(this.legendOptions),authoringInfo:i.clone(this.authoringInfo),backgroundFillSymbol:i.clone(this.backgroundFillSymbol)});this._isDefaultSymbolDerived&&(e._isDefaultSymbolDerived=!0),e._set("portal",this.portal);const t=i.clone(this.uniqueValueInfos),s=i.clone(this.uniqueValueGroups);return this.styleOrigin&&(e._set("styleOrigin",Object.freeze(i.clone(this.styleOrigin))),Object.freeze(t),Object.freeze(s)),e._set("uniqueValueInfos",t),e._updateValueInfoMap(),e._set("uniqueValueGroups",s),e._isInfosSource=this._isInfosSource,e._watchUniqueValueInfosAndGroups(),e}get arcadeRequired(){return this.arcadeRequiredForVisualVariables||!!this.valueExpression}async collectRequiredFields(e,t){const s=[this.collectVVRequiredFields(e,t),this.collectSymbolFields(e,t)];await Promise.all(s)}async collectSymbolFields(e,t){const s=[...this.getSymbols().map((s=>s.collectRequiredFields(e,t))),y.collectArcadeFieldNames(e,t,this.valueExpression)];y.collectField(e,t,this.field),y.collectField(e,t,this.field2),y.collectField(e,t,this.field3),await Promise.all(s)}populateFromStyle(){return F.fetchStyle(this.styleOrigin,{portal:this.portal}).then((e=>{const t=[];return this._valueInfoMap={},e?.data&&Array.isArray(e.data.items)&&e.data.items.forEach((s=>{const i=new O({styleUrl:e.styleUrl,styleName:e.styleName,portal:this.portal,name:s.name});this.defaultSymbol||s.name!==e.data.defaultItem||(this.defaultSymbol=i,this._isDefaultSymbolDerived=!0);const l=new S({value:s.name,symbol:i});t.push(l),this._valueInfoMap[R(s.name)]=l})),this._set("uniqueValueInfos",Object.freeze(t)),this._updateGroupsFromInfos(!0),this._isInfosSource=null,this._watchUniqueValueInfos(),!this.defaultSymbol&&this.uniqueValueInfos?.length&&(this.defaultSymbol=this.uniqueValueInfos[0].symbol,this._isDefaultSymbolDerived=!0),this}))}_updateFieldDelimiter(){this.field&&this.field2&&!this.fieldDelimiter&&this._set("fieldDelimiter",M)}_updateUniqueValues(){null!=this._isInfosSource&&(this._isInfosSource?this._updateGroupsFromInfos():this._updateInfosFromGroups())}_updateValueInfoMap(){this._valueInfoMap={};const{uniqueValueInfos:e}=this;if(e)for(const t of e)this._valueInfoMap[R(t.value)]=t}_watchUniqueValueInfosAndGroups(){this._watchUniqueValueInfos(),this._watchUniqueValueGroups()}_watchUniqueValueInfos(){this.removeHandles(E);const{uniqueValueInfos:e}=this;if(e){const t=[];for(const s of e)t.push(r.watch((()=>({symbol:s.symbol,value:s.value,label:s.label,description:s.description})),((e,t)=>{e!==t&&(this._updateGroupsFromInfos(),this._isInfosSource=!0)}),{sync:!0}));this.addHandles(t,E)}}_watchUniqueValueGroups(){this.removeHandles(j);const{uniqueValueGroups:e}=this;if(e){const t=[];for(const s of e){t.push(r.watch((()=>({classes:s.classes})),((e,t)=>{e!==t&&(this._updateInfosFromGroups(),this._isInfosSource=!1)}),{sync:!0}));for(const e of s.classes??[])t.push(r.watch((()=>({symbol:e.symbol,values:e.values,label:e.label,description:e.description})),((e,t)=>{e!==t&&(this._updateInfosFromGroups(),this._isInfosSource=!1)}),{sync:!0}))}this.addHandles(t,j)}}_updateInfosFromGroups(){if(!this.uniqueValueGroups)return this._set("uniqueValueInfos",null),this._updateValueInfoMap(),void this._watchUniqueValueInfos();const e=[],{field:t,field2:s,field3:i,fieldDelimiter:l,uniqueValueGroups:o,valueExpression:r}=this;if(!t&&!r)return this._set("uniqueValueInfos",e),this._updateValueInfoMap(),void this._watchUniqueValueInfos();const u=!(!t||!s);for(const n of o)for(const t of n.classes??[]){const{symbol:o,label:r,values:n,description:a}=t;for(const t of n??[]){const{value:n,value2:d,value3:p}=t,c=[n];s&&c.push(d),i&&c.push(p);const f=u?c.join(l||""):c[0]??void 0;e.push(new S({symbol:o,label:r,value:f,description:a}))}}this._set("uniqueValueInfos",e),this._updateValueInfoMap(),this._watchUniqueValueInfos()}_updateGroupsFromInfos(e=!1){if(!this.uniqueValueInfos)return this._set("uniqueValueGroups",null),void this._watchUniqueValueGroups();const{field:t,field2:s,valueExpression:i,fieldDelimiter:l,uniqueValueInfos:o}=this;if(!t&&!i||!o.length)return this._set("uniqueValueGroups",[]),void this._watchUniqueValueGroups();const r=!(!t||!s),u=o.map((e=>{const{symbol:t,label:s,value:i,description:o}=e,[u,n,a]=r?i?.toString()?.split(l||"")||[]:[i];return new q({symbol:t,label:s,description:o,values:[new g({value:u,value2:n,value3:a})]})})),n=[new I({classes:u})];e&&Object.freeze(n),this._set("uniqueValueGroups",n),this._watchUniqueValueGroups()}_getUniqueValueInfo(e,t){return this.valueExpression?this._getUnqiueValueInfoForExpression(e,t):this._getUnqiueValueInfoForFields(e)}_getUnqiueValueInfoForExpression(e,t){const{viewingMode:s,scale:i,spatialReference:l,arcade:o,timeZone:r}=t??{};let u=this._cache.compiledFunc;const n=o.arcadeUtils;if(!u){const e=n.createSyntaxTree(this.valueExpression);u=n.createFunction(e),this._cache.compiledFunc=u}const a=n.executeFunction(u,n.createExecContext(e,n.getViewInfo({viewingMode:s,scale:i,spatialReference:l}),r));return this._valueInfoMap[R(a)]}_getUnqiueValueInfoForFields(e){const t=this.field,s=e.attributes;let i;if(this.field2){const e=this.field2,l=this.field3,o=[];t&&o.push(s[t]),e&&o.push(s[e]),l&&o.push(s[l]),i=o.join(this.fieldDelimiter||"")}else t&&(i=s[t]);return this._valueInfoMap[R(i)]}static fromPortalStyle(e,t){const s=new G(t?.properties);s._set("styleOrigin",Object.freeze({styleName:e})),s._set("portal",t?.portal||_.getDefault());const i=s.populateFromStyle();return i.catch((t=>{x().error(`#fromPortalStyle('${e}'[, ...])`,"Failed to create unique value renderer from style name",t)})),i}static fromStyleUrl(e,t){const s=new G(t?.properties);s._set("styleOrigin",Object.freeze({styleUrl:e}));const i=s.populateFromStyle();return i.catch((t=>{x().error(`#fromStyleUrl('${e}'[, ...])`,"Failed to create unique value renderer from style URL",t)})),i}};e.__decorate([u.property({readOnly:!0})],C.prototype,"_cache",null),e.__decorate([a.enumeration({uniqueValue:"unique-value"})],C.prototype,"type",void 0),e.__decorate([u.property(v.rendererBackgroundFillSymbolProperty)],C.prototype,"backgroundFillSymbol",void 0),e.__decorate([u.property({value:null,json:{type:String,read:{source:"field1"},write:{target:"field1"}}})],C.prototype,"field",null),e.__decorate([n.cast("field")],C.prototype,"castField",null),e.__decorate([c.writer("field")],C.prototype,"writeField",null),e.__decorate([u.property({type:String,value:null,json:{write:!0}})],C.prototype,"field2",null),e.__decorate([u.property({type:String,value:null,json:{write:!0}})],C.prototype,"field3",null),e.__decorate([u.property({type:Boolean,json:{name:"drawInClassOrder",default:!1,write:!0,origins:{"web-scene":{write:!1}}}})],C.prototype,"orderByClassesEnabled",void 0),e.__decorate([u.property({type:String,value:null,json:{write:!0}})],C.prototype,"valueExpression",null),e.__decorate([u.property({type:String,json:{write:!0}})],C.prototype,"valueExpressionTitle",void 0),e.__decorate([u.property({type:V,json:{write:!0}})],C.prototype,"legendOptions",void 0),e.__decorate([u.property({type:String,json:{write:!0}})],C.prototype,"defaultLabel",void 0),e.__decorate([u.property(o.deepMerge({...v.rendererSymbolProperty},{json:{write:{overridePolicy(){return{enabled:!this._isDefaultSymbolDerived}}},origins:{"web-scene":{write:{overridePolicy(){return{enabled:!this._isDefaultSymbolDerived}}}}}}}))],C.prototype,"defaultSymbol",null),e.__decorate([u.property({type:String,value:null,json:{write:!0}})],C.prototype,"fieldDelimiter",null),e.__decorate([u.property({type:_,readOnly:!0})],C.prototype,"portal",void 0),e.__decorate([d.reader("portal",["styleName"])],C.prototype,"readPortal",null),e.__decorate([u.property({readOnly:!0,json:{write:{enabled:!1,overridePolicy:()=>({enabled:!0})}}})],C.prototype,"styleOrigin",void 0),e.__decorate([d.reader("styleOrigin",["styleName","styleUrl"])],C.prototype,"readStyleOrigin",null),e.__decorate([c.writer("styleOrigin",{styleName:{type:String},styleUrl:{type:String}})],C.prototype,"writeStyleOrigin",null),e.__decorate([u.property({type:[I],json:{read:{source:["uniqueValueGroups","uniqueValueInfos"],reader:(e,t,s)=>(t.uniqueValueGroups||P(t)).map((e=>I.fromJSON(e,s)))},write:{overridePolicy(){return this.styleOrigin?{enabled:!1}:{enabled:!0}}}}})],C.prototype,"uniqueValueGroups",null),e.__decorate([u.property({type:[S],json:{read:!1,write:{overridePolicy(){return this.styleOrigin?{enabled:!1}:{enabled:!0}}}}})],C.prototype,"uniqueValueInfos",null),C=G=e.__decorate([p.subclass(D)],C);return C}));
