/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../Color","../../request","../../core/Error","../../core/has","../../core/lang","../../core/Logger","../../core/LRUCache","../../core/promiseUtils","../../core/Version","../../geometry/support/jsonUtils","../../layers/support/FieldsIndex","../../support/arcadeOnDemand","../../symbols/CIMSymbol","../../symbols/cim/OverrideHelper","../../symbols/cim/utils"],(function(e,t,i,s,r,o,n,l,a,c,u,f,h,y,d,m){"use strict";const p="esri.renderers.support.DictionaryLoader",g={type:"CIMSimpleLineCallout",lineSymbol:{type:"CIMLineSymbol",symbolLayers:[{type:"CIMSolidStroke",width:.5,color:[0,0,0,255]}]}};class b{constructor(e,t,i){this.config=null,this.fieldMap=null,this.url=null,this._ongoingRequests=new Map,this._symbolCache=new l.LRUCache(100),this._dictionaryVersion=null,this._fieldIndex=null,this._dictionaryPromise=null,this.url=e,this.config=t,this.fieldMap=i}getSymbolFields(){return this._symbolFields}async getSymbolAsync(e,i){let s;this._dictionaryPromise||(this._dictionaryPromise=this.fetchResources(i));try{s=await this._dictionaryPromise}catch(y){if(a.isAbortError(y))return this._dictionaryPromise=null,null}const r=this._dictionaryVersion?.greaterEqual(4,0),o={};if(this.fieldMap)for(const t of this._symbolFields){const i=m.getFieldName(this.fieldMap[t],this._fieldIndex);if(i){const s=e.attributes[i];o[t]=r?s:null!=s?""+e.attributes[i]:""}else o[t]=""}let n=null;try{n=s?.(o,i)}catch(d){return null}if(!n||"string"!=typeof n||"invalid"===n)return null;const l=n.split(";"),c=[],f=[];for(let a=0;a<l.length;a++){const i=l[a];if(i)if(i.includes("po:")){const s=i.slice(3).split("|");if(3===s.length){const i=s[0],r=s[1];let o=s[2];const n="countrylabel";if(i===n&&"TextString"===r){if(null!=this.fieldMap){let t=this.fieldMap[n];null==t&&(t=n,this.fieldMap[t]=t),e.attributes[t]=o}continue}if("DashTemplate"===r)o=o.split(" ").map((e=>Number(e)));else if("Color"===r){const e=new t(o).toRgba();o=[e[0],e[1],e[2],255*e[3]]}else o=Number(o);f.push({primitiveName:i,propertyName:r,value:o,defaultValue:null})}}else if(i.includes("|")){for(const e of i.split("|"))if(this._itemNames.has(e)){c.push(e);break}}else if(this._itemNames.has(i))c.push(i);else if(0===a){c.length=0;let t="Invalid_P";null!=e.geometry&&(u.isPolygon(e.geometry)?t="Invalid_A":u.isPolyline(e.geometry)&&(t="Invalid_L")),c.push(t);break}}const h=null==e.geometry||!e.geometry.hasZ&&"point"===e.geometry.type;return this._cimPartsToCIMSymbol(e,c,f,h,i)}async fetchResources(e){if(this._dictionaryPromise)return this._dictionaryPromise;if(!this.url)return void n.getLogger(p).error("no valid URL!");const t=i(this.url+"/resources/styles/dictionary-info.json",{responseType:"json",query:{f:"json"},signal:null!=e?e.signal:null}),[{data:r}]=await Promise.all([t,h.loadArcade()]);if(!r)throw this._dictionaryPromise=null,new s("esri.renderers.DictionaryRenderer","Bad dictionary data!");const{authoringInfo:o,dictionary_version:l,expression:a,itemsNames:u}=r,y=a;let d=!1;l&&(this._dictionaryVersion=c.Version.parse(l),d=this._dictionaryVersion.greaterEqual(4,0)),this._refSymbolUrlTemplate=this.url+"/"+r.cimRefTemplateUrl,this._itemNames=new Set(u),this._symbolFields=o.symbol;const m={};if(this.config){const e=this.config;for(const t in e)m[t]=e[t]}if(o.configuration)for(const i of o.configuration)m.hasOwnProperty(i.name)||(m[i.name]=i.value);const g=[];if(e?.fields&&this.fieldMap)for(const i in this.fieldMap){const t=this.fieldMap[i],s=e.fields.filter((e=>e.name.toLowerCase()===t?.toLowerCase()));s.length>0&&g.push({...s[0],type:d?s[0].type:"esriFieldTypeString"})}g.length>0&&(this._fieldIndex=new f(g));const b=h.createDictionaryExpression(y,null!=e?e.spatialReference:null,g,m).then((e=>{const t={scale:0};return(i,s)=>{if(null==e)return null;const r=e.repurposeFeature({geometry:null,attributes:i});return t.scale=null!=s?s.scale??void 0:void 0,e.evaluate({$feature:r,$view:t},e.services)}})).catch((e=>(n.getLogger(p).error("Creating dictionary expression failed:",e),null)));return this._dictionaryPromise=b,b}async _cimPartsToCIMSymbol(e,t,i,s,r){const n=new Array(t.length);for(let o=0;o<t.length;o++)n[o]=this._getSymbolPart(t[o],r);let l=await Promise.all(n);const a=this.fieldMap;if(a){l=o.clone(l);for(const t of l)d.OverrideHelper.applyDictionaryTextOverrides(t,e,a,this._fieldIndex,m.getTextCasing(t))}return new y({data:_(l,i,s)})}async _getSymbolPart(e,t){const s=this._symbolCache.get(e);if(s)return s;if(this._ongoingRequests.has(e))return this._ongoingRequests.get(e).then((e=>e.data));const r=this._refSymbolUrlTemplate.replaceAll(/\{itemName\}/gi,e),o=i(r,{responseType:"json",query:{f:"json"},...t});this._ongoingRequests.set(e,o),o.finally((()=>this._ongoingRequests.delete(e)));try{const t=await o;return this._symbolCache.put(e,t.data),t.data}catch(n){throw n}}}function _(e,t,i){if(!e||0===e.length)return null;const s={...e[0]};if(e.length>1){s.effects=null,s.symbolLayers=[];for(const t of e){const e=t;if(null!=e.effects)for(const t of e.symbolLayers)null==t.effects?t.effects=e.effects:t.effects.unshift(...e.effects);s.symbolLayers.unshift(...e.symbolLayers)}}return i&&(s.callout=g),{type:"CIMSymbolReference",symbol:s,primitiveOverrides:t}}e.DictionaryLoader=b,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
