/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../Color","../../rasterRenderers","../../core/unitUtils","../../layers/support/Field","../FlowRenderer","./AuthoringInfo","./ClassBreakInfo","./colorRampUtils","./rasterRendererChecks","./UniqueValueInfo","../visualVariables/ColorVariable","../visualVariables/SizeVariable","../visualVariables/support/ColorStop","../../rest/support/ClassBreaksDefinition","../../rest/support/generateRendererUtils","../../rest/support/MultipartColorRamp","../../symbols/SimpleFillSymbol","../RasterStretchRenderer","../UniqueValueRenderer","../RasterColormapRenderer","../RasterShadedReliefRenderer","../ClassBreaksRenderer","../VectorFieldRenderer"],(function(e,t,n,a,r,l,s,o,i,u,c,m,d,f,p,b,h,g,v,R,y,C,w,S){"use strict";const x=.25,M=h.fromJSON({type:"multipart",colorRamps:[{fromColor:[0,0,255],toColor:[0,255,255]},{fromColor:[0,255,255],toColor:[255,255,0]},{fromColor:[255,255,0],toColor:[255,0,0]}]}),V=h.fromJSON(i.predefinedJsonColorRamps[0]),T=new Set(["scientific","standard-time","vector-uv","vector-magdir","vector-u","vector-v","vector-magnitude","vector-direction"]);function F(e){return e.presetRenderers?.find((({method:t,value:n})=>"raster-function-template"===t?n===e.rasterFunctionName:"variable"===t&&n===e.variableName))}function I(e,t){const{attributeTable:n,colormap:a}=e;if(u.isVectorFieldRendererSupported(e)){const t=H(e);if(null!=t)return t}if(t?.rasterFunctionColorRamp){const n=U(e,t);return n.colorRamp=t.rasterFunctionColorRamp,n}if(null!=a){const t=J(e);if(null!=t)return t}if(null!=n){const t=W(e);if(null!=t)return t}return U(e,t)}function k(e,t=!1){const n=["raster-stretch"];return u.isColormapRendererSupported(e,t)&&n.push("raster-colormap"),u.isUVRendererSupported(e)&&n.push("unique-value"),u.isClassBreaksSupported(e,t)&&n.push("class-breaks"),u.isShadedReliefRendererSupported(e)&&n.push("raster-shaded-relief"),u.isVectorFieldRendererSupported(e)&&n.push("vector-field"),u.isFlowRendererSupported(e)&&n.push("flow"),n}function B(e){return"Function"===e.datasetFormat&&"Colormap"===e.rasterFunction.functionName?e.rasterFunction.colorRamp:void 0}function L(e,t,n){const a=["nearest","bilinear","cubic","majority"],r=n?.toLowerCase().replace("bicubic","cubic"),l=a.find((e=>e===r));if("Map"===t)return l??"bilinear";if("standard-time"===e.dataType)return l??"nearest";return"thematic"===e.dataType||e.attributeTable||e.colormap?"nearest"===l||"majority"===l?l:"nearest":l??"bilinear"}function U(e,t){e=q(e,t?.variableName);const{bandCount:n}=e;let{bandIds:a,stretchType:r}=t||{};a?.some((e=>e>=n))&&(a=null);let l=e.statistics,s=e.histograms;n>1?(a=a?.length?a:z(e),l=null==l?null:a?.map((e=>l[e])),s=null==s?null:a?.map((e=>s[e]))):a=[0],null==r&&(r=D(e)),t?.includeStatisticsInStretch&&("percent-clip"===r||"histogram-equalization"===r)&&e.statistics?.length&&(r="min-max");let o=!1;switch(r){case"none":o=!1;break;case"percent-clip":o=!s?.length;break;default:o=!l?.length}const{dataType:i}=e,u=1===a?.length&&T.has(i)?M:null,c=new v({stretchType:r,dynamicRangeAdjustment:o,colorRamp:u,outputMin:0,outputMax:255,gamma:1===a?.length?[1]:[1,1,1],useGamma:!1});return"percent-clip"===r?c.maxPercent=c.minPercent=x:"standard-deviation"===r&&(c.numberOfStandardDeviations=2),o||null==e.multidimensionalInfo&&!t?.includeStatisticsInStretch||("percent-clip"===r?c.histograms=s:"min-max"!==r&&"standard-deviation"!==r||(c.statistics=l)),c}function q(e,t){const{multidimensionalInfo:n}=e;if(!t||!n)return e;const a=n.variables.find((e=>e.name===t));if(!a)return e;if(e=e.clone(),a){const{statistics:t,histograms:n}=a;t?.length&&(e.statistics=t.map((e=>({min:e.min,max:e.max,avg:e.avg,stddev:e.stddev})))),n?.length&&(e.histograms=n)}return e}function z(e){const t=e.bandCount;if(1===t)return null;if(2===t)return[0];const{bandInfos:n}=e;let a;if(n.length===t){const{red:e,green:t,blue:r,nir:l}=N(n);null!=e&&null!=t&&null!=r?a=[e,t,r]:null!=l&&null!=e&&null!=t&&(a=[l,e,t])}return!a&&t>=3&&(a=[0,1,2]),a}function E(e,t){const n=e.bandInfos.map((({name:e})=>e));return t?.length?t.map((e=>n[e])):n}function N(e){const t={};for(let n=0;n<e.length;n++){const a=e[n],r=a.name.toLowerCase();if("red"===r)t.red=n;else if("green"===r)t.green=n;else if("blue"===r)t.blue=n;else if("nearinfrared"===r||"nearinfrared_1"===r||"nir"===r)t.nir=n;else if(a.maxWavelength&&a.minWavelength){const e=a.minWavelength,r=a.maxWavelength;null==t.blue&&e>=410&&e<=480&&r>=480&&r<=540?t.blue=n:null==t.green&&e>=490&&e<=560&&r>=560&&r<=610?t.green=n:null==t.red&&e>=595&&e<=670&&r>=660&&r<=730?t.red=n:null==t.nir&&e>=700&&e<=860&&r>=800&&r<=950&&(t.nir=n)}}return t}function D(e){let t="percent-clip";const{pixelType:n,dataType:a,histograms:r,statistics:l,multidimensionalInfo:s}=e,o=T.has(a)||"generic"===a&&null!=s;return"u8"!==n||"processed"!==a&&null!=r&&null!=l?"u8"===n||"elevation"===a||o?t="min-max":null!=r?t="percent-clip":null!=l&&(t="min-max"):t="none",t}function W(e,n,a,r){if(!u.isUVRendererSupported(e,n))return null;const{attributeTable:l,statistics:o}=e,m=O(l,n),d=P(l,"red"),f=P(l,"green"),p=P(l,"blue"),b=new s,h=[],v=new Set,y=!!(d&&f&&p);if(null!=l)l.features.forEach((e=>{const n=e.attributes[m.name];if(!v.has(e.attributes[m.name])&&null!=n){v.add(n);const a=y&&("single"===d.type||"double"===d.type)&&("single"===f.type||"double"===f.type)&&("single"===p.type||"double"===p.type)&&!l.features.some((e=>e.attributes[d.name]>1||e.attributes[f.name]>1||e.attributes[p.name]>1)),r=a?255:1;h.push(new c({value:e.attributes[m.name],label:e.attributes[m.name]+"",symbol:new g({style:"solid",outline:null,color:new t(y?[e.attributes[d.name]*r,e.attributes[f.name]*r,e.attributes[p.name]*r,1]:[0,0,0,0])})}))}}));else if(o?.[0])for(let s=o[0].min;s<=o[0].max;s++)h.push(new c({value:s,label:s.toString(),symbol:new g({style:"solid",outline:null,color:new t([0,0,0,0])})}));if(h.sort(((e,t)=>e.value&&"string"==typeof e.value.valueOf()?0:e.value>t.value?1:-1)),!y){const e=i.convertColorRampToColormap(V,{numColors:h.length});h.forEach(((n,a)=>n.symbol.color=new t(e[a].slice(1,4)))),b.colorRamp=V}if(a||r){const e=a||i.convertColorRampToColormap(r,{numColors:h.length}).map((e=>e.slice(1)));h.forEach(((n,a)=>n.symbol.color=new t(e[a]))),b.colorRamp=r}return new R({field:m.name,uniqueValueInfos:h,authoringInfo:b})}function O(e,t,n){let a;return null!=e?(a=t?e.fields.find((e=>t.toLowerCase()===e.name.toLowerCase())):j(e.fields),a||(n||(a=e.fields.find((e=>"string"===e.type))),a||(a=P(e,"value")))):a=new r({name:"value"}),a}function j(e){let t;for(let n=0;n<e.length;n++){const a=e[n].name.toLowerCase();if("string"===e[n].type){if(a.startsWith("class")){t=e[n];break}null==t&&(a.endsWith("name")||a.endsWith("type"))&&(t=e[n])}}return t}function P(e,t){return null==e?null:e.fields.find((e=>e.name.toLowerCase()===t))}function J(e){if(!u.isColormapRendererSupported(e))return null;let t;const{attributeTable:n,colormap:a}=e;if(null!=n){const e=P(n,"value"),a=O(n,null,!0);"string"===a.type&&(t={},n.features.forEach((n=>{const r=n.attributes;t[r[e.name]]=a?r[a.name]:r[e.name]})))}return y.createFromColormap(a,t)}function A(e,t="traditional"){if(!u.isShadedReliefRendererSupported(e))return null;const{extent:n}=e,r=n.width*a.getMetersPerUnitForSR(n.spatialReference);return new C({hillshadeType:t,scalingType:r>5e6?"adjusted":"none"})}function G(e,t){e=q(e,t?.variableName);const{attributeTable:n}=e;if(!u.isClassBreaksSupported(e))return null;const a=null!=e.histograms?e.histograms[0]:null,r=null!=t?.numClasses&&isFinite(t?.numClasses)?t.numClasses:5,l=new s({classificationMethod:t?.classificationMethod,colorRamp:t?.colorRamp});let c=t?.field||"value";const m=[],d=[],f=1e3,h=null!=n,v=h&&n.fields.find((e=>"count"===e.name.toLowerCase())),R=h?n.fields.find((e=>e.name.toLowerCase()===c.toLowerCase())):void 0;if(R&&h){c=R.name;const e=n.features.length;let t=0;n.features.forEach((n=>t+=(v?n.attributes[v.name]:50)/e)),n.features.forEach((n=>{const a=n.attributes[R.name],r=v?n.attributes[v.name]:50;if(r>0){d.push(r);const n=Math.max(1,Math.round(r/e/t*f));for(let e=0;e<n;e++)m.push(a)}}))}else{const{pixelType:t}=e,r=(a.max-a.min)/a.size,l=t.includes("s")||t.includes("u"),s=l&&1===r?Math.floor(a.min+.5):a.min,o=l&&1===r?Math.floor(a.max-.5):a.max,i=a.size;let u,c=0;a.counts.forEach((e=>c+=e/i)),a.counts.forEach(((e,t)=>{if(e>0){d.push(e);const l=Math.max(1,Math.round(e/i/c*f));u=h?n.features[t].attributes[R.name]:0===t?s:t===i-1?o:a.min+r*(t+.5);for(let e=0;e<l;e++)m.push(u)}}))}const y=t?.classificationMethod||"natural-breaks";let C=t?.definedInterval;"defined-interval"!==y||C||(C=K(e,R,r));const S=b.createGenerateRendererClassBreaks({values:m,valueFrequency:d,normalizationTotal:null,definition:new p({classificationMethod:y,breakCount:r,definedInterval:C})});let x=t?.colors;if(!x){const e=t?.colorRamp||M;l.colorRamp=e;const n=i.convertColorRampToColormap(e,{numColors:S.classBreaks.length,interpolateAlpha:!0});x=n.map((e=>e.slice(1)))}const V=S.classBreaks.map(((e,t)=>new o({minValue:e.minValue,maxValue:e.maxValue,label:e.label,symbol:new g({color:x[t]})})));return new w({field:c,classBreakInfos:V,authoringInfo:l})}function K(e,t,n){let a=0,r=0;if(null!=e.attributeTable){const n=e.attributeTable;a=r=n.features[0].attributes[t.name],n.features.forEach((e=>{const n=e.attributes[t.name];n<a&&(a=n),n>r&&(r=n)}))}else if(null!=e.histograms){const t=e.histograms;a=t[0].min,r=t[0].max}return(r-a)/n}const _=new Map([["m/s","meter-per-second"],["km/h","kilometer-per-hour"],["knots","knots"],["ft/s","feet-per-second"],["mph","mile-per-hour"]]);function H(e){if(!u.isVectorFieldRendererSupported(e))return null;let t;if(null!=e.statistics&&e.statistics.length&&("vector-magdir"===e.dataType||"vector-uv"===e.dataType)){const{minMagnitude:n,maxMagnitude:a}=Z(e.dataType,e.statistics);t=[new d({field:"Magnitude",minSize:10,maxSize:40,minDataValue:n,maxDataValue:a})]}const n=null!=e.multidimensionalInfo?_.get(e.multidimensionalInfo.variables[0].unit):void 0,a=new S({visualVariables:t,inputUnit:n,rotationType:"geographic"});return a.visualVariables=[...a.sizeVariables,...a.rotationVariables],a}function Q(e){return{color:e.symbolLayers[0].material?.color,type:"esriSFS",style:"esriSFSSolid"}}function X(e){if("uniqueValue"===e.type){const t=e.uniqueValueInfos,n=t?.[0].symbol;return n?.symbolLayers?.length&&(e.uniqueValueInfos=t?.map((e=>({value:e.value,label:e.label,symbol:e.symbol?Q(e.symbol):null})))),e}if("classBreaks"===e.type){const t=e.classBreakInfos,n=t[0].symbol;return n?.symbolLayers?.length&&(e.classBreakInfos=t.map((e=>({classMinValue:e.classMinValue,classMaxValue:e.classMaxValue,label:e.label,symbol:e.symbol?Q(e.symbol):null})))),e}return e}function Y(e){if(!u.isFlowRendererSupported(e))return null;let n;if(null!=e.statistics&&e.statistics.length>0&&("vector-magdir"===e.dataType||"vector-uv"===e.dataType)){const{minMagnitude:a,maxMagnitude:r}=Z(e.dataType,e.statistics);n=[new m({field:"Magnitude",stops:[new f({value:a,color:new t("#1020c0")}),new f({value:r,color:new t("#c02010")})]})]}return new l({visualVariables:n})}function Z(e,t){let n,a;if("vector-magdir"===e)n=t[0].min,a=t[0].max;else{const e=t[0].min,r=t[0].max,l=t[1].min,s=t[1].max;n=0,a=Math.max(Math.abs(e),Math.abs(l),Math.abs(r),Math.abs(s))}return{minMagnitude:n,maxMagnitude:a}}e.createClassBreaksRenderer=G,e.createColormapRenderer=J,e.createDefaultRenderer=I,e.createFlowRenderer=Y,e.createShadedReliefRenderer=A,e.createStretchRenderer=U,e.createUVRenderer=W,e.createVectorFieldRenderer=H,e.estimateMagnitudeRange=Z,e.getBandNames=E,e.getClassField=O,e.getDefaultBandCombination=z,e.getDefaultInterpolation=L,e.getDefinedInterval=K,e.getField=P,e.getFunctionColorRamp=B,e.getSupportedRendererTypes=k,e.getVariableRasterInfo=q,e.getWellKnownBandIndexes=N,e.matchPresetRenderer=F,e.normalizeRendererJSON=X,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
