/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../core/arrayUtils","../../core/Logger","../../core/MapUtils","../../intl/date","../../layers/support/fieldUtils","./numberUtils","../visualVariables/support/ColorStop","../../smartMapping/support/utils","../../symbols/support/utils","../../widgets/Legend/support/colorRampUtils","../../widgets/Legend/support/heatmapRampUtils"],(function(e,l,t,o,a,i,n,r,s,u,f,d){"use strict";const m=()=>t.getLogger("esri.renderers.support.utils"),p={lte:"<=",gte:">=",lt:"<",gt:">",pct:"%",ld:"–"},c={millisecond:0,second:1,minute:2,hour:3,day:4,month:5,year:6},y={millisecond:"long-month-day-year-long-time",second:"long-month-day-year-long-time",minute:"long-month-day-year-short-time",hour:"long-month-day-year-short-time",day:"long-month-day-year",month:"long-month-day-year",year:"year"},g=a.convertDateFormatToIntlOptions("short-date");async function b(e,l,t){o.getOrCreateMapValue(e,l,(()=>[])).push(...t)}async function h(e){const t=new Map;if(!e)return t;if("visualVariables"in e&&e.visualVariables){const l=e.visualVariables.filter((e=>"color"===e.type));for(const e of l){const l=(await f.getRampStops(e)??[]).map((e=>e.color));await b(t,e.field||e.valueExpression,l)}}if("heatmap"===e.type){const l=d.getHeatmapRampStops(e).map((e=>e.color));await b(t,e.field||e.valueExpression,l)}else if("pie-chart"===e.type){for(const l of e.attributes)await b(t,l.field||l.valueExpression,[l.color]);await b(t,"default",[e?.othersCategory?.color,u.getColorFromSymbol(e.backgroundFillSymbol,null)])}else if("dot-density"===e.type){for(const l of e.attributes)await b(t,l.field||l.valueExpression,[l.color]);await b(t,"default",[e.backgroundColor])}else if("unique-value"===e.type)if("predominance"===e.authoringInfo?.type)for(const l of e.uniqueValueInfos??[])await b(t,l.value.toString(),[u.getColorFromSymbol(l.symbol,null)]);else{const l=(e.uniqueValueInfos??[]).map((e=>u.getColorFromSymbol(e.symbol,null))),{field:o,field2:a,field3:i,valueExpression:n}=e;(o||n)&&await b(t,o||n,l),a&&await b(t,a,l),i&&await b(t,i,l)}else if("class-breaks"===e.type){const l=e.classBreakInfos.map((e=>u.getColorFromSymbol(e.symbol,null))),{field:o,valueExpression:a}=e;await b(t,o??a,l)}else"simple"===e.type&&await b(t,"default",[u.getColorFromSymbol(e.symbol,null)]);return"defaultSymbol"in e&&e.defaultSymbol&&await b(t,"default",[u.getColorFromSymbol(e.defaultSymbol,null)]),t.forEach(((e,o)=>{const a=l.unique(e.filter(Boolean),((e,l)=>JSON.stringify(e)===JSON.stringify(l)));t.set(o,a)})),t}async function v(e,l,t){const a=o.getOrCreateMapValue(e,l,(()=>new Map));for(const o of t)a.set(o.value,o.color)}async function F(e){const l=new Map;if(!e)return l;if("unique-value"!==e.type||e.authoringInfo?.type)if("class-breaks"===e.type){const t=e.classBreakInfos.map((e=>({value:e.minValue,color:u.getColorFromSymbol(e.symbol,null)}))).reverse(),{field:o,valueExpression:a}=e;await v(l,o??a,t)}else"simple"===e.type&&await v(l,"default",[{value:"default",color:u.getColorFromSymbol(e.symbol,null)}]);else{const t=(e.uniqueValueInfos??[]).map((e=>({value:e.value,color:u.getColorFromSymbol(e.symbol,null)}))),{field:o,field2:a,field3:i,valueExpression:n,fieldDelimiter:r}=e,s=[o,a,i].filter(Boolean).join(r||"");(s||n)&&await v(l,s||n,t)}if("defaultSymbol"in e&&e.defaultSymbol&&await v(l,"default",[{value:"default",color:u.getColorFromSymbol(e.defaultSymbol,null)}]),"visualVariables"in e&&e.visualVariables){const t=e.visualVariables.filter((e=>"color"===e.type));for(const e of t){const t=await f.getRampStops(e)??[];await v(l,e.field||e.valueExpression,t)}}return l}function S(e,l,t){let o="";return 0===l?o=p.lt+" ":l===t&&(o=p.gt+" "),o+e}function V(e){const{values:l,colors:t,labelIndexes:o,isDate:i}=e;return l.map(((e,s)=>{let u=null;if(!o||o.includes(s)){const t=i?a.formatDate(e):n.format(e);t&&(u=S(t,s,l.length-1))}return new r({value:e,color:t[s],label:u})}))}function w(e){let l=e.minValue,t=e.maxValue;const o=e.isFirstBreak?"":p.gt+" ",a="percent-of-total"===e.normalizationType?p.pct:"";return l=null==l?"":n.format(l),t=null==t?"":n.format(t),o+l+a+" "+p.ld+" "+t+a}function x(e){const l=e.classBreakInfos,t=e.normalizationType;let o=[];if(l?.length)if("standard-deviation"!==e.classificationMethod)if(e.round){o.push(l[0].minValue);for(const e of l)o.push(e.maxValue);o=n.round(o),l.forEach(((e,l)=>{e.label=w({minValue:0===l?o[0]:o[l],maxValue:o[l+1],isFirstBreak:0===l,normalizationType:t})}))}else l.forEach(((e,l)=>{e.label=w({minValue:e.minValue,maxValue:e.maxValue,isFirstBreak:0===l,normalizationType:t})}));else m().warn("setLabelsForClassBreaks","cannot set labels for class breaks generated using 'standard-deviation' method.")}function C(e){const l=e.map((e=>new Date(e))),t=l.length;let o=1/0,a=null;for(let i=0;i<t-1;i++){const e=l[i];let n=1/0,r=null;for(let o=i+1;o<t;o++){const t=l[o],a=(e.getFullYear()!==t.getFullYear()?"year":e.getMonth()!==t.getMonth()&&"month")||e.getDate()!==t.getDate()&&"day"||e.getHours()!==t.getHours()&&"hour"||e.getMinutes()!==t.getMinutes()&&"minute"||e.getSeconds()!==t.getSeconds()&&"second"||"millisecond",i=c[a];i<n&&(n=i,r=a)}n<o&&(o=n,a=r)}return a}function E(e){const{value:l,domain:t,fieldInfo:o,dateFormatOptions:a}=e;let r=String(l);const u=t&&"codedValues"in t&&t.codedValues?t.getName(l):null;return u?r=u:null!=l&&o&&(s.isAnyDateField(o)||i.isTimeOnlyField(o))?r=s.formatAnyDate(l,a??{fieldType:o.type}):"number"==typeof l&&(r=n.format(l)),r}function z(e,l){return"normalizationField"in e&&e.normalizationField?I(e.field,e.normalizationField):"field"in e&&e.field?k(e.field):"valueExpression"in e&&e.valueExpression?M(e.valueExpression,e.valueExpressionTitle,l):null}function k(e){return{type:"field",field:e}}function I(e,l){return{type:"normalized-field",field:e,normalizationField:l}}function M(e,l,t){return{type:"expression",expression:e,title:l,returnType:t}}function B(e,t){const o=[];if("class-breaks"===e.type||"heatmap"===e.type)o.push(z(e,"number"));else if("unique-value"===e.type){const l=e.authoringInfo;if(l&&"relationship"===l.type){if(l.field1&&l.field2){const e=l.field1.field,t=l.field2.field,a=l.field1.normalizationField,i=l.field2.normalizationField;o.push(z({field:e,normalizationField:a})),o.push(z({field:t,normalizationField:i}))}}else{const l=e.uniqueValueInfos?.[0];let t=null;if(l?.value){const e=typeof l.value;"string"!==e&&"number"!==e||(t=e)}o.push(z(e,t)),[e.field2,e.field3].forEach((e=>e&&o.push(k(e))))}}else"attributes"in e&&e.attributes?.forEach((e=>o.push(z(e,"number"))));const a=t?t(e):"visualVariables"in e?e.visualVariables:null;return a&&a.forEach((e=>o.push(z(e,"number")))),l.unique(o.filter(l.isSome),((e,l)=>"field"===e.type&&"field"===l.type?e.field===l.field:"normalized-field"===e.type&&"normalized-field"===l.type?e.field===l.field&&e.normalizationField===l.normalizationField:"expression"===e.type&&"expression"===l.type&&e.expression===l.expression))}e.calculateDateFormatInterval=C,e.createClassBreakLabel=w,e.createColorStops=V,e.createUniqueValueLabel=E,e.dateFormatIntervalOptions=y,e.getAttribute=z,e.getAttributes=B,e.getColorsForRendererValues=F,e.getColorsFromRenderer=h,e.setLabelsForClassBreaks=x,e.timelineDateFormatOptions=g,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
