/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../core/Error","../../core/jsonMap","../../core/Logger","../../core/accessorSupport/decorators/property","../../core/accessorSupport/decorators/cast","../../core/accessorSupport/decorators/reader","../../core/accessorSupport/decorators/subclass","../../core/accessorSupport/decorators/writer","./VisualVariable","./support/castSizeVariable","./support/SizeStop","./support/SizeVariableLegendOptions","./support/sizeVariableUtils","./support/visualVariableUtils"],(function(e,t,i,r,a,s,o,n,l,p,u,c,d,h,m){"use strict";var y;const S=new i.JSONMap({width:"width",depth:"depth",height:"height",widthAndDepth:"width-and-depth",all:"all"}),z=new i.JSONMap({unknown:"unknown",inch:"inches",foot:"feet",yard:"yards",mile:"miles","nautical-mile":"nautical-miles",millimeter:"millimeters",centimeter:"centimeters",decimeter:"decimeters",meter:"meters",kilometer:"kilometers"});function x(e){if(null!=e)return"string"==typeof e||"number"==typeof e?u.castSizeFromStringOrNumber(e):"size"===e.type?h.isSizeVariable(e)?e:(delete(e={...e}).type,new v(e)):void 0}function _(e,t,i){if("object"!=typeof e)return e;const r=new v;return r.read(e,i),r}let v=y=class extends p{constructor(e){super(e),this.axis=null,this.legendOptions=null,this.normalizationField=null,this.scaleBy=null,this.target=null,this.type="size",this.useSymbolValue=null,this.valueExpression=null,this.valueRepresentation=null,this.valueUnit=null}get cache(){return{ipData:this._interpolateData(),hasExpression:!!this.valueExpression,compiledFunc:null,isScaleDriven:null!=this.valueExpression&&m.viewScaleRE.test(this.valueExpression)}}set index(e){h.isSizeVariable(this.maxSize)&&(this.maxSize.index=`visualVariables[${e}].maxSize`),h.isSizeVariable(this.minSize)&&(this.minSize.index=`visualVariables[${e}].minSize`),this._set("index",e)}get inputValueType(){return h.getInputValueType(this)}set maxDataValue(e){e&&this.stops&&(r.getLogger(this).warn("cannot set maxDataValue when stops is not null."),e=null),this._set("maxDataValue",e)}set maxSize(e){e&&this.stops&&(r.getLogger(this).warn("cannot set maxSize when stops is not null."),e=null),this._set("maxSize",e)}castMaxSize(e){return x(e)}readMaxSize(e,t,i){return _(e,t,i)}set minDataValue(e){e&&this.stops&&(r.getLogger(this).warn("cannot set minDataValue when stops is not null."),e=null),this._set("minDataValue",e)}set minSize(e){e&&this.stops&&(r.getLogger(this).warn("cannot set minSize when stops is not null."),e=null),this._set("minSize",e)}castMinSize(e){return x(e)}readMinSize(e,t,i){return _(e,t,i)}get arcadeRequired(){return!!this.valueExpression||(null!=this.minSize&&"object"==typeof this.minSize&&this.minSize.arcadeRequired||null!=this.maxSize&&"object"==typeof this.maxSize&&this.maxSize.arcadeRequired)}set stops(e){null==this.minDataValue&&null==this.maxDataValue&&null==this.minSize&&null==this.maxSize?e&&Array.isArray(e)&&(e=e.filter((e=>!!e))).sort(((e,t)=>e.value-t.value)):e&&(r.getLogger(this).warn("cannot set stops when one of minDataValue, maxDataValue, minSize or maxSize is not null."),e=null),this._set("stops",e)}get transformationType(){return h.getTransformationType(this,this.inputValueType)}readValueExpression(e,t){return e||t.expression&&"$view.scale"}writeValueExpressionWebScene(e,i,r,a){if("$view.scale"===e){if(a?.messages){const e=this.index,i="string"==typeof e?e:`visualVariables[${e}]`;a.messages.push(new t("property:unsupported",this.type+"VisualVariable.valueExpression = '$view.scale' is not supported in Web Scene. Please remove this property to save the Web Scene.",{instance:this,propertyName:i+".valueExpression",context:a}))}}else i[r]=e}readValueUnit(e){return e?z.read(e):null}clone(){return new y({axis:this.axis,field:this.field,valueExpression:this.valueExpression,valueExpressionTitle:this.valueExpressionTitle,maxDataValue:this.maxDataValue,maxSize:h.isSizeVariable(this.maxSize)?this.maxSize.clone():this.maxSize,minDataValue:this.minDataValue,minSize:h.isSizeVariable(this.minSize)?this.minSize.clone():this.minSize,normalizationField:this.normalizationField,stops:this.stops?.map((e=>e.clone())),target:this.target,useSymbolValue:this.useSymbolValue,valueRepresentation:this.valueRepresentation,valueUnit:this.valueUnit,legendOptions:this.legendOptions?.clone()})}flipSizes(){if(this.transformationType===h.TransformationType.ClampedLinear){const{minSize:e,maxSize:t}=this;return this.minSize=t,this.maxSize=e,this}if(this.transformationType===h.TransformationType.Stops){const e=this.stops;if(!e)return this;const t=e.map((e=>e.size)).reverse(),i=e.length;for(let r=0;r<i;r++)e[r].size=t[r];return this}return this}getAttributeHash(){return`${super.getAttributeHash()}-${this.target}-${this.normalizationField}`}_interpolateData(){return this.stops?.map((e=>e.value||0))}};e.__decorate([a.property({readOnly:!0})],v.prototype,"cache",null),e.__decorate([a.property({type:S.apiValues,json:{type:S.jsonValues,origins:{"web-map":{read:!1}},read:S.read,write:S.write}})],v.prototype,"axis",void 0),e.__decorate([a.property()],v.prototype,"index",null),e.__decorate([a.property({type:String,readOnly:!0})],v.prototype,"inputValueType",null),e.__decorate([a.property({type:d,json:{write:!0}})],v.prototype,"legendOptions",void 0),e.__decorate([a.property({type:Number,value:null,json:{write:!0}})],v.prototype,"maxDataValue",null),e.__decorate([a.property({type:Number,value:null,json:{write:!0}})],v.prototype,"maxSize",null),e.__decorate([s.cast("maxSize")],v.prototype,"castMaxSize",null),e.__decorate([o.reader("maxSize")],v.prototype,"readMaxSize",null),e.__decorate([a.property({type:Number,value:null,json:{write:!0}})],v.prototype,"minDataValue",null),e.__decorate([a.property({type:Number,value:null,json:{write:!0}})],v.prototype,"minSize",null),e.__decorate([s.cast("minSize")],v.prototype,"castMinSize",null),e.__decorate([o.reader("minSize")],v.prototype,"readMinSize",null),e.__decorate([a.property({type:String,json:{write:!0}})],v.prototype,"normalizationField",void 0),e.__decorate([a.property({readOnly:!0})],v.prototype,"arcadeRequired",null),e.__decorate([a.property({type:String})],v.prototype,"scaleBy",void 0),e.__decorate([a.property({type:[c],value:null,json:{write:!0}})],v.prototype,"stops",null),e.__decorate([a.property({type:["outline"],json:{write:!0}})],v.prototype,"target",void 0),e.__decorate([a.property({type:String,readOnly:!0})],v.prototype,"transformationType",null),e.__decorate([a.property({type:["size"],json:{type:["sizeInfo"]}})],v.prototype,"type",void 0),e.__decorate([a.property({type:Boolean,json:{write:!0,origins:{"web-map":{read:!1}}}})],v.prototype,"useSymbolValue",void 0),e.__decorate([a.property({type:String,json:{write:!0}})],v.prototype,"valueExpression",void 0),e.__decorate([o.reader("valueExpression",["valueExpression","expression"])],v.prototype,"readValueExpression",null),e.__decorate([l.writer("web-scene","valueExpression")],v.prototype,"writeValueExpressionWebScene",null),e.__decorate([a.property({type:["radius","diameter","area","width","distance"],json:{write:!0}})],v.prototype,"valueRepresentation",void 0),e.__decorate([a.property({type:z.apiValues,json:{write:z.write,origins:{"web-map":{read:!1},"web-scene":{write:!0},"portal-item":{write:!0}}}})],v.prototype,"valueUnit",void 0),e.__decorate([o.reader("valueUnit")],v.prototype,"readValueUnit",null),v=y=e.__decorate([n.subclass("esri.renderers.visualVariables.SizeVariable")],v);return v}));
