/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../Color","../../../Graphic","../../../core/compilerUtils","../../../core/Logger","../../support/lengthUtils","./sizeVariableUtils"],(function(e,a,i,n,t,r,l){"use strict";const s=()=>t.getLogger("esri.renderers.visualVariables.support.visualVariableUtils"),o=e=>s().warn(`The visualVariable should be an instance of esri.renderers.visualVariables.${e}`),c=()=>s().error("Use of arcade expressions requires an arcade context"),u=new i,f=Math.PI,p=/^\s*(return\s+)?\$view\.scale\s*(;)?\s*$/i;function d(e,i,n){const t="visualVariables"in e&&e.visualVariables?e.visualVariables.find((e=>"color"===e.type)):e;if(!t)return;if("esri.renderers.visualVariables.ColorVariable"!==t.declaredClass)return void o("ColorVariable");const r="number"==typeof i,l=r?null:i,s=l?.attributes;let u=r?i:null;const f=t.field,{ipData:p,hasExpression:d}=t.cache;let v=t.cache.compiledFunc;if(!f&&!d){const e=t.stops;return e&&e[0]&&e[0].color}if("number"!=typeof u)if(d){if(null==n?.arcade)return void c();const e={viewingMode:n.viewingMode,scale:n.scale,spatialReference:n.spatialReference},a=n.arcade.arcadeUtils,i=a.getViewInfo(e),r=a.createExecContext(l,i,n.timeZone);if(!v){const e=a.createSyntaxTree(t.valueExpression);v=a.createFunction(e),t.cache.compiledFunc=v}u=a.executeFunction(v,r)}else s&&(u=s[f]);const b=t.normalizationField,m=null!=s&&null!=b?parseFloat(s[b]):void 0;if(null!=u&&(!b||r||!isNaN(m)&&0!==m)){isNaN(m)||r||(u/=m);const e=M(u,p);if(e){const i=e[0],r=e[1],l=i===r?t.stops[i].color:a.blendColors(t.stops[i].color,t.stops[r].color,e[2],null!=n?n.color:void 0);return new a(l)}}}function v(e,a,i){const n="visualVariables"in e&&e.visualVariables?e.visualVariables.find((e=>"opacity"===e.type)):e;if(!n)return;if("esri.renderers.visualVariables.OpacityVariable"!==n.declaredClass)return void o("OpacityVariable");const t="number"==typeof a,r=t?null:a,l=r?.attributes;let s=t?a:null;const u=n.field,{ipData:f,hasExpression:p}=n.cache;let d=n.cache.compiledFunc;if(!u&&!p){const e=n.stops;return e&&e[0]&&e[0].opacity}if("number"!=typeof s)if(p){if(null==i?.arcade)return void c();const e={viewingMode:i.viewingMode,scale:i.scale,spatialReference:i.spatialReference},a=i.arcade.arcadeUtils,t=a.getViewInfo(e),l=a.createExecContext(r,t,i.timeZone);if(!d){const e=a.createSyntaxTree(n.valueExpression);d=a.createFunction(e),n.cache.compiledFunc=d}s=a.executeFunction(d,l)}else l&&(s=l[u]);const v=n.normalizationField,b=null!=l&&null!=v?parseFloat(l[v]):void 0;if(null!=s&&(!v||t||!isNaN(b)&&0!==b)){isNaN(b)||t||(s/=b);const e=M(s,f);if(e){const a=e[0],i=e[1];if(a===i)return n.stops[a].opacity;{const t=n.stops[a].opacity;return t+(n.stops[i].opacity-t)*e[2]}}}}function b(e,a,i){const n="visualVariables"in e&&e.visualVariables?e.visualVariables.find((e=>"rotation"===e.type)):e;if(!n)return;if("esri.renderers.visualVariables.RotationVariable"!==n.declaredClass)return void o("RotationVariable");const t=n.axis||"heading",r="heading"===t&&"arithmetic"===n.rotationType?90:0,l="heading"===t&&"arithmetic"===n.rotationType?-1:1,s="number"==typeof a?null:a,u=s?.attributes,f=n.field,{hasExpression:p}=n.cache;let d=n.cache.compiledFunc,v=0;if(!f&&!p)return v;if(p){if(null==i?.arcade)return void c();const e={viewingMode:i.viewingMode,scale:i.scale,spatialReference:i.spatialReference},a=i.arcade.arcadeUtils,t=a.getViewInfo(e),r=a.createExecContext(s,t,i.timeZone);if(!d){const e=a.createSyntaxTree(n.valueExpression);d=a.createFunction(e),n.cache.compiledFunc=d}v=a.executeFunction(d,r)}else u&&(v=u[f]||0);return v="number"!=typeof v||isNaN(v)?null:r+l*v,v}function m(e,a,i){const n="number"==typeof a,t=n?null:a,r=t?.attributes;let s=n?a:null;const{isScaleDriven:o}=e.cache;let u=e.cache.compiledFunc;if(o){const a=null!=i?i.scale:void 0,n=null!=i?i.view:void 0;s=null==a||"3d"===n?h(e):a}else if(!n)switch(e.inputValueType){case l.InputValueType.Expression:{if(null==i?.arcade)return void c();const a={viewingMode:i.viewingMode,scale:i.scale,spatialReference:i.spatialReference},n=i.arcade.arcadeUtils,r=n.getViewInfo(a),l=n.createExecContext(t,r,i.timeZone);if(!u){const a=n.createSyntaxTree(e.valueExpression);u=n.createFunction(a),e.cache.compiledFunc=u}s=n.executeFunction(u,l);break}case l.InputValueType.Field:r&&(s=r[e.field]);break;case l.InputValueType.Unknown:s=null}if(!l.isValidNumber(s))return null;if(n||!e.normalizationField)return s;const f=r?parseFloat(r[e.normalizationField]):null;return l.isValidNumber(f)&&0!==f?s/f:null}function h(e){let a=null,i=null;const n=e.stops;return n?(a=n[0].value,i=n[n.length-1].value):(a=e.minDataValue||0,i=e.maxDataValue||0),(a+i)/2}function V(e,a,i){const n="visualVariables"in e&&e.visualVariables?e.visualVariables.find((e=>"size"===e.type)):e;if(!n)return;if("esri.renderers.visualVariables.SizeVariable"!==n.declaredClass)return void o("SizeVariable");const t=E(m(n,a,i),n,a,i,n.cache.ipData);return null==t||isNaN(t)?0:t}function y(e,a,i){return null==e?null:l.isSizeVariable(e)?V(e,a,i):l.isValidNumber(e)?e:null}function g(e,a,i){return l.isValidNumber(i)&&e>i?i:l.isValidNumber(a)&&e<a?a:e}function x(e,a,i,n){return e+((y(a.minSize,i,n)||a.minDataValue)??0)}function S(e,a,i){const n=e.stops;let t=n?.length&&n[0].size;return null==t&&(t=e.minSize),y(t,a,i)}function z(e,a,i,n){const t=(e-a.minDataValue)/(a.maxDataValue-a.minDataValue),r=y(a.minSize,i,n),l=y(a.maxSize,i,n),s=null!=n?n.shape:void 0;if(e<=a.minDataValue)return r;if(e>=a.maxDataValue)return l;if(null==r||null==l)return null;if("area"===a.scaleBy&&s){const e="circle"===s,a=e?f*(r/2)**2:r*r,i=a+t*((e?f*(l/2)**2:l*l)-a);return e?2*Math.sqrt(i/f):Math.sqrt(i)}return r+t*(l-r)}function T(e,a,i,n){const t=null!=n?n.shape:void 0,r=e/a.minDataValue,l=y(a.minSize,i,n),s=y(a.maxSize,i,n);let o=null;return o="circle"===t?2*Math.sqrt(r*(l/2)**2):"square"===t||"diamond"===t||"image"===t?Math.sqrt(r*l**2):r*l,g(o,l,s)}function w(e,a,i,n,t){const[r,l,s]=M(e,t);if(r===l)return y(a.stops?.[r].size,i,n);{const e=y(a.stops?.[r].size,i,n);return e+(y(a.stops?.[l].size,i,n)-e)*s}}function F(e,a,i,n){const t=(n?.resolution??1)*r.meterIn[a.valueUnit],l=y(a.minSize,i,n),s=y(a.maxSize,i,n),{valueRepresentation:o}=a;let c=null;return c="area"===o?2*Math.sqrt(e/f)/t:"radius"===o||"distance"===o?2*e/t:e/t,g(c,l,s)}function N(e){return e}function E(e,a,i,n,t){switch(a.transformationType){case l.TransformationType.Additive:return x(e,a,i,n);case l.TransformationType.Constant:return S(a,i,n);case l.TransformationType.ClampedLinear:return z(e,a,i,n);case l.TransformationType.Proportional:return T(e,a,i,n);case l.TransformationType.Stops:return w(e,a,i,n,t);case l.TransformationType.RealWorldSize:return F(e,a,i,n);case l.TransformationType.Identity:return N(e);case l.TransformationType.Unknown:return null}}function R(e,a,i){const{isScaleDriven:n}=e.cache;if(!(n&&"3d"===i||a))return null;const t={scale:a,view:i};let r=y(e.minSize,u,t),l=y(e.maxSize,u,t);if(null!=r||null!=l){if(r>l){const e=l;l=r,r=e}return{minSize:r,maxSize:l}}}function C(e,a,i){if(!e.visualVariables)return;const n=[],t=[],r=[],l=[],s=[];for(const o of e.visualVariables)switch(o.type){case"color":t.push(o);break;case"opacity":r.push(o);break;case"rotation":s.push(o);break;case"size":l.push(o)}return t.forEach((e=>{const t=d(e,a,i);n.push({variable:e,value:t})})),r.forEach((e=>{const t=v(e,a,i);n.push({variable:e,value:t})})),s.forEach((e=>{const t=b(e,a,i);n.push({variable:e,value:t})})),l.forEach((e=>{const t=V(e,a,i);n.push({variable:e,value:t})})),n.filter((e=>null!=e.value))}function M(e,a){if(!a)return;let i=0,n=a.length-1;return a.some(((a,t)=>e<a?(n=t,!0):(i=t,!1))),[i,n,(e-a[i])/(a[n]-a[i])]}function D(e,a,i){const t=["proportional","proportional","proportional"];for(const r of e){const e=r.useSymbolValue?"symbol-value":V(r,a,i);switch(r.axis){case"width":t[0]=e;break;case"depth":t[1]=e;break;case"height":t[2]=e;break;case"width-and-depth":t[0]=e,t[1]=e;break;case"all":case void 0:case null:t[0]=e,t[1]=e,t[2]=e;break;default:n.neverReached(r.axis)}}return t}e.getAllSizes=D,e.getColor=d,e.getOpacity=v,e.getRotationAngle=b,e.getSize=V,e.getSizeForValue=E,e.getSizeFromNumberOrVariable=y,e.getSizeRangeAtScale=R,e.getVisualVariableValues=C,e.viewScaleRE=p,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
