/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../config","../../kernel","../../request","../../core/arrayUtils","../../core/Error","../../core/Identifiable","../../core/JSONSupport","../../core/lang","../../core/Loadable","../../core/promiseUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/Logger","../../core/accessorSupport/decorators/reader","../../core/accessorSupport/decorators/subclass","../../geometry/SpatialReference","../../layers/graphics/applyEditsUtils","../../layers/graphics/editingSupport","../../layers/mixins/EditBusLayer","../../layers/support/featureLayerUtils","../../layers/support/layerUtils","../../layers/support/serviceCapabilitiesUtils","../../portal/PortalItem","../../portal/support/portalItemUtils","../../portal/support/urlUtils","../utils","../query/operations/editsZScale","../support/jsonUtils","../../versionManagement/support/versionManagementUtils"],(function(e,t,r,s,a,i,o,n,l,d,u,p,c,y,h,m,f,g,b,v,S,E,I,_,w,F,A,R,U,C){"use strict";function O(e,t){const r=t.id;return{id:r,name:t.name,url:`${e}/${r}`,type:t.type||"Table"}}function P(e){return{data:V(e),sync:T(e),operations:D(e.capabilities,e),query:k(e),editing:N(e)}}function V(e){return{isDataVersioned:U.readBoolean(e,"hasVersionedData",!1),isDataBranchVersioned:U.readBoolean(e,"hasBranchVersionedData",!1)}}function D(e,t){const r=e?e.toLowerCase().split(",").map((e=>e.trim())):[],s=r.includes("query"),a=r.includes("editing")&&!t.datesInUnknownTimezone;let i=a&&r.includes("create"),o=a&&r.includes("delete"),n=a&&r.includes("update");return a&&!(i||o||n)&&(i=o=n=!0),{supportsAdd:i,supportsDelete:o,supportsEditing:a,supportsChangeTracking:r.includes("changetracking"),supportsQuery:s,supportsQueryDataElements:U.readBoolean(t,"supportsQueryDataElements",!1),supportsQueryDomains:U.readBoolean(t,"supportsQueryDomains",!1),supportsQueryContingentValues:U.readBoolean(t,"supportsQueryContingentValues",!1),supportsSync:r.includes("sync"),supportsUpdate:n}}function k(e){return{maxRecordCountFactor:U.readNumber(e,"maxRecordCountFactor",void 0),maxRecordCount:U.readNumber(e,"maxRecordCount",void 0)}}function N(e){const t=e?.advancedEditingCapabilities;return{supportsGlobalId:U.readBoolean(e,"supportsApplyEditsWithGlobalIds",!1),supportsReturnServiceEditsInSourceSpatialReference:U.readBoolean(t,"supportsReturnServiceEditsInSourceSR",!1),supportsSplit:U.readBoolean(t,"supportsSplit",!1),supportsAsyncApplyEdits:U.readBoolean(t,"supportsAsyncApplyEdits",!1)}}function T(e){const t=e?.syncCapabilities,r=t?.supportedSyncDataOptions;return{supportsAsync:U.readBoolean(t,"supportsAsync",!1),supportedSyncDataOptions:{annotations:!(1&~r),dimensions:!(2&~r),contingentValues:!(4&~r),attributeRules:!(8&~r),utilityNetworkSystem:!(16&~r),annotationFullModel:!(32&~r),include3DObjects:!(64&~r),utilityNetworkMissingLayers:!(128&~r),preserveTrueCurves:!(256&~r)}}}let L=class extends(n.JSONSupportMixin(o.IdentifiableMixin(d))){constructor(e){super(e),this.url=null,this.sourceJSON=null,this.userHasFullEditingPrivileges=!1,this.userHasUpdateItemPrivileges=!1,this.userTypeExtensions=[],this.layerInfos=null,this.tableInfos=null,this.capabilities=null}read(e,t){this.sourceJSON=e,super.read(e,t)}get utilityNetworkUrl(){if(this.sourceJSON)for(const e of this.sourceJSON.layers)if("Utility Network Layer"===e.type)return`${this.url}/${e.id}`;return null}get versionManagementServiceUrl(){return this.sourceJSON?.hasBranchVersionedData&&!F.isSecureProxyService(this.url)?this.url.replace(/\/FeatureServer/i,"/VersionManagementServer"):null}readLayerInfos(e,t){return(t.layers||[]).map((e=>{const{type:t,geometryType:r}=e;return{...O(this.url,e),type:t||"Feature Layer",geometryType:r}}))}readTableInfos(e,t){return(t.tables||[]).map((e=>O(this.url,e)))}readCapabilities(e,t){return P(t)}get effectiveCapabilities(){const e=this.capabilities;if(!e)return null;const t=l.clone(e),{operations:r}=t;return this.userHasUpdateItemPrivileges?(r.supportsAdd=r.supportsDelete=r.supportsEditing=r.supportsQuery=r.supportsUpdate=!0,t):(this.userHasFullEditingPrivileges&&r.supportsEditing&&(r.supportsAdd=r.supportsDelete=r.supportsUpdate=!0),t)}load(e){return this.addResolvingPromise(this._fetchService(this.url,e).then((()=>this._setUserPrivileges(e)))),Promise.resolve(this)}async fetchAllLayersAndTables(e){return await this.load(e),this._fetchLayersAndTablesPromise||=this._fetchLayersAndTables(this.url),u.throwIfAborted(e),this._fetchLayersAndTablesPromise}async applyEdits(e,t){let r=null;try{const{results:s,edits:a,editedFeatures:i}=await this._internalApplyEdits(e,t),o=e=>e.filter((e=>!e.error)).map(l.clone);let n=0;return s.map((e=>{r=v.emitApplyEditsEvent(this.url,e.id,t?.gdbVersion,!0);const s={edits:a[n],addedFeatures:o(e.addFeatureResults),updatedFeatures:o(e.updateFeatureResults),deletedFeatures:o(e.deleteFeatureResults),addedAttachments:o(e.addAttachmentResults),updatedAttachments:o(e.updateAttachmentResults),deletedAttachments:o(e.deleteAttachmentResults),exceededTransferLimit:!1,historicMoment:e.editMoment?new Date(e.editMoment):null};n+=1,i.length>0&&(s.editedFeatures=i),r.resolve(s),r=null})),s}catch(s){throw r&&r.reject(s),s}}async _setUserPrivileges(e){if(t.userPrivilegesApplied)try{const{features:{fullEdit:t},content:{updateItem:r}}=await this._fetchUserPrivileges(this.sourceJSON.serviceItemId,e);this._set("userHasFullEditingPrivileges",t),this._set("userHasUpdateItemPrivileges",r)}catch(r){u.throwIfAbortError(r)}}async _fetchUserPrivileges(e,t){const s=!0,a=!1,i=!1;if(!e)return{features:{edit:s,fullEdit:a},content:{updateItem:i}};let o,n,l;try{o=await E.getOwningPortalUrl(this.url,t)}catch(d){u.throwIfAbortError(d)}try{const e=null!=t?t.signal:null;n=await(r.id?.getCredential(`${o}/sharing`,{prompt:!1,signal:e}))}catch(d){u.throwIfAbortError(d)}if(!n)return{features:{edit:s,fullEdit:a},content:{updateItem:i}};try{if(l=new _({id:e,portal:{url:o}}),await l.load(t),l.portal.user)return w.getUserPrivileges(l)}catch(d){u.throwIfAbortError(d)}return{features:{edit:s,fullEdit:a},content:{updateItem:i}}}async _internalApplyEdits(e,t){await S.ensureCredentialIfSignedIn(this.url);const r=t?.globalIdUsed??!1,i=f.fromJSON(this.sourceJSON.spatialReference),{edits:o,options:n}=await this._processApplyEditsParams(e,t),l=await Promise.all(o.map((async e=>{const t=e.addFeatures?.map((e=>g.getFeatureJSON({spatialReference:i},e,null)))??[],s=(await Promise.all(t)).filter(a.isSome),o=s.length>0?s:null,n=e.updateFeatures?.map((e=>g.getFeatureJSON({spatialReference:i},e,null)))??[],l=(await Promise.all(n)).filter(a.isSome),d=l.length>0?l:null,u=g.getFeatureIds(e.identifierFields,e.deleteFeatures,r),p=u.length>0?u:null;R.unapplyEditsZUnitScaling(o,d,i);const c=await g.getAttachmentEditsJSON(e.identifierFields,e);let y=null;if(c){y={adds:c.adds.length>0?c.adds:void 0,updates:c.updates.length>0?c.updates:void 0,deletes:c.deletes.length>0?c.deletes:void 0}}return{id:e.id,adds:o,updates:d,deletes:p,attachments:y}}))),d={gdbVersion:n?.gdbVersion,rollbackOnFailure:!0,useGlobalIds:r,returnEditMoment:!0,honorSequenceOfEdits:n?.honorSequenceOfEdits,usePreviousEditMoment:n?.usePreviousEditMoment,returnServiceEditsInSourceSR:!1,returnServiceEditsOption:"originalAndCurrentFeatures",async:!1};await C.isSafeToEditVersion(this.url,t?.gdbVersion,!0);const u=C.isVersionInEditSession(this.url,t?.gdbVersion||null);d.edits=JSON.stringify(l);const p=A.parseUrl(this.url),c=A.asValidOptions(p.query,{query:A.encode({...d,f:"json"}),method:"post"});let y;u&&(c.authMode="immediate",c.query.sessionId=C.currentSessionId);try{y=await s(this.url+"/applyEdits",c)}catch(h){if(!g.isProtectedOrPrivateVersionError(h))throw h;c.authMode="immediate",y=await s(this.url+"/applyEdits",c)}return{...M(y),edits:o}}async _processApplyEditsParams(e,t){const r={...t};return{edits:await Promise.all(e.map((async e=>{const r=this.effectiveCapabilities,s=e&&(e.addFeatures||e.updateFeatures||e.deleteFeatures),a=e&&(e.addAttachments||e.updateAttachments||e.deleteAttachments);if(b.checkEditingCapabilities(e,r,t,!!s,!!a,"feature-service"),!r.data.isDataVersioned&&t?.gdbVersion)throw new i("feature-service:invalid-parameter","'gdbVersion' is applicable only if the layer supports versioned data. See: 'capabilities.data.isDataVersioned'");const o=b.normalizeEdits(e,r,"feature-service");return{...await b.normalizeGeometries(o),id:e.id,identifierFields:e.identifierFields}}))),options:r}}async _fetchService(e,t){if(this.sourceJSON)return void this.read(this.sourceJSON,{url:A.parseUrl(e)});const r=await s(e,{responseType:"json",query:{f:"json"},...t});this.read(r.data,{url:A.parseUrl(e)})}async _fetchLayersAndTables(e){const t=`${e}/layers`,r=await s(t,{responseType:"json",query:{f:"json"}});return{layers:r.data.layers.map((e=>{const{type:t,geometryType:r}=e,s=O(this.url,e),a=I.getFeatureLayerCapabilities(e,s.url);return{...s,type:t||"Feature Layer",geometryType:r,capabilities:a}})),tables:r.data.tables.map((e=>{const t=O(this.url,e),r=I.getFeatureLayerCapabilities(e,t.url);return{...t,capabilities:r}}))}}};function M(e){const t=e.data,r=[];return{results:t.map((e=>{const t={addResults:e.addResults??[],updateResults:e.updateResults??[],deleteResults:e.deleteResults??[],attachments:e.attachments,editMoment:e.editMoment},s=g.unpackEditResultData(t),a=e.editedFeatures,i=a?.spatialReference?new f({wkid:a?.spatialReference.wkid,wkt:a?.spatialReference.wkt,latestWkid:a?.spatialReference.latestWkid,latestVcsWkid:a?.spatialReference.latestVcsWkid,vcsWkid:a?.spatialReference.vcsWkid}):null,o=a?g.createEditedFeatures(a,i):null;return o&&r.push({layerId:e.id,editedFeatures:o}),{id:e.id,editedFeatures:o,...s}})),editedFeatures:r}}e.__decorate([p.property()],L.prototype,"url",void 0),e.__decorate([p.property()],L.prototype,"sourceJSON",void 0),e.__decorate([p.property()],L.prototype,"userHasFullEditingPrivileges",void 0),e.__decorate([p.property()],L.prototype,"userHasUpdateItemPrivileges",void 0),e.__decorate([p.property({readOnly:!0})],L.prototype,"utilityNetworkUrl",null),e.__decorate([p.property({readOnly:!0})],L.prototype,"versionManagementServiceUrl",null),e.__decorate([p.property()],L.prototype,"userTypeExtensions",void 0),e.__decorate([p.property({json:{read:{source:["layers"]}}})],L.prototype,"layerInfos",void 0),e.__decorate([h.reader("layerInfos",["layers"])],L.prototype,"readLayerInfos",null),e.__decorate([p.property({json:{read:{source:["tables"]}}})],L.prototype,"tableInfos",void 0),e.__decorate([h.reader("tableInfos",["tables"])],L.prototype,"readTableInfos",null),e.__decorate([p.property({readOnly:!0,json:{read:{source:["hasVersionedData","hasBranchVersionedData","capabilities","supportsQueryDataElements","supportsQueryDomains","supportsQueryContingentValues","maxRecordCountFactor","maxRecordCount","advancedEditingCapabilities","supportsApplyEditsWithGlobalIds","syncCapabilities","datesInUnknownTimezone"]}}})],L.prototype,"capabilities",void 0),e.__decorate([h.reader("capabilities",["hasVersionedData","hasBranchVersionedData","capabilities","supportsQueryDataElements","supportsQueryDomains","supportsQueryContingentValues","maxRecordCountFactor","maxRecordCount","advancedEditingCapabilities","supportsApplyEditsWithGlobalIds","syncCapabilities","datesInUnknownTimezone"])],L.prototype,"readCapabilities",null),e.__decorate([p.property({readOnly:!0})],L.prototype,"effectiveCapabilities",null),L=e.__decorate([m.subclass("esri.rest.featureService.FeatureService")],L);return L}));
