/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../geometry","../request","../core/accessorSupport/ensureType","../geometry/support/normalizeUtils","../geometry/support/spatialReferenceUtils","./utils","./support/FindImagesParameters","./support/FindImagesResult","./support/ImageAngleParameters","./support/ImageAngleResult","./support/ImageAreaParameters","./support/ImageAreaResult","./support/ImageBoundaryParameters","./support/ImageBoundaryResult","./support/ImageDistanceParameters","./support/ImageDistanceResult","./support/ImageGPSInfoParameters","./support/ImageGPSInfoResult","./support/ImageHeightParameters","./support/ImageHeightResult","./support/ImageHistogramParameters","./support/ImageIdentifyParameters","./support/ImageIdentifyResult","./support/ImagePixelLocationParameters","./support/ImagePixelLocationResult","./support/ImagePointParameters","./support/ImagePointResult","./support/ImageSampleParameters","./support/ImageSampleResult","./support/ImageToMapMultirayParameters","./support/ImageToMapParameters","./support/ImageUrlParameters","./support/ImageUrlResult","./support/MapToImageParameters","./support/MeasureAreaFromImageResult","./support/MeasureFromImageParameters","./support/MeasureLengthFromImageResult","../geometry/SpatialReference","../geometry/support/jsonUtils"],(function(e,t,a,r,s,n,o,i,u,l,m,p,c,g,f,d,y,S,I,O,N,R,h,J,w,C,P,j,U,M,q,V,G,T,A,$,b,F,v,z){"use strict";function H(e){const t=e?.time;if(t&&(null!=t.start||null!=t.end)){const a=[];null!=t.start&&a.push(t.start),null==t.end||a.includes(t.end)||a.push(t.end),e.time=a.join(",")}}async function L(e,t,a){t=r.ensureClass(R,t);const n=o.parseUrl(e),i=t.geometry?[t.geometry]:[],u=await s.normalizeCentralMeridian(i),l=t.toJSON();H(l);const m=u?.[0];null!=m&&(l.geometry=ae(m));const p=o.encode({...n.query,f:"json",...l});return o.asValidOptions(p,a)}async function x(e,t,s){const n=(t=r.ensureClass(l,t)).toJSON();null!=n.angleName&&(n.angleName=n.angleName.join(",")),t?.point?.spatialReference?.imageCoordinateSystem&&(n.point.spatialReference=re(t.point.spatialReference)),t?.spatialReference?.imageCoordinateSystem&&(n.spatialReference=se(t.spatialReference));const i=o.parseUrl(e),u=o.encode({...i.query,f:"json",...n}),p=o.asValidOptions(u,s),{data:c}=await a(`${i.path}/computeAngles`,p);return c.spatialReference=c.spatialReference?null!=c.spatialReference.geodataXform?new v({wkid:0,imageCoordinateSystem:c.spatialReference}):v.fromJSON(c.spatialReference):null,"NaN"===c.north&&(c.north=null),"NaN"===c.up&&(c.up=null),new m(c)}async function B(e,t,s){const n=(t=r.ensureClass(w,t)).toJSON(),{geometries:i}=t;if(i)for(let a=0;a<i.length;a++)i[a].spatialReference?.imageCoordinateSystem&&(n.geometries.geometries[a].spatialReference=re(i[a].spatialReference));const u=o.parseUrl(e),l=o.encode({...u.query,f:"json",...n}),m=o.asValidOptions(l,s),{data:p}=await a(`${u.path}/computePixelLocation`,m);return C.fromJSON(p)}async function D(e,t,r){const s=await L(e,t,r),n=o.parseUrl(e),{data:i}=await a(`${n.path}/computeStatisticsHistograms`,s),{statistics:u}=i;return u?.length&&u.forEach((e=>{e.avg=e.mean,e.stddev=e.standardDeviation})),{statistics:u,histograms:i.histograms}}async function E(e,t,r){const s=await L(e,t,r),n=o.parseUrl(e),{data:i}=await a(`${n.path}/computeHistograms`,s);return{histograms:i.histograms}}async function k(e,t,n){const i=(t=r.ensureClass(U,t)).toJSON();H(i),i.outFields?.length&&(i.outFields=i.outFields.join(","));const u=await s.normalizeCentralMeridian(t.geometry),l=u?.[0];null!=l&&(i.geometry=ae(l));const m=o.parseUrl(e),p=o.encode({...m.query,f:"json",...i}),c=o.asValidOptions(p,n),{data:g}=await a(`${m.path}/getSamples`,c),f=g?.samples?.map((e=>{const t="NaN"===e.value||""===e.value?null:e.value.split(" ").map((e=>Number(e)));return{...e,pixelValue:t}}));return M.fromJSON({samples:f})}async function Q(e,t,n){t=r.ensureClass(h,t);const i=o.parseUrl(e),u=t.geometry?[t.geometry]:[];return s.normalizeCentralMeridian(u).then((e=>{const r=t.toJSON(),s=e?.[0];null!=s&&(r.geometry=JSON.stringify(ae(s)));const u=o.encode({...i.query,f:"json",...r}),l=o.asValidOptions(u,n);return a(i.path+"/identify",l)})).then((e=>J.fromJSON(e.data)))}async function X(e,t,a){t=r.ensureClass(O,t);const s=await Z(e,t,[t.fromGeometry,t.toGeometry],a);return N.fromJSON(s)}async function K(e,t,a){t=r.ensureClass(p,t);const s=await Z(e,t,[t.geometry],a);return c.fromJSON(s)}async function W(e,t,a){t=r.ensureClass(P,t);const s=await Z(e,t,[t.geometry],a);return j.fromJSON(s)}async function Y(e,t,a){t=r.ensureClass(d,t);const s=await Z(e,t,[t.fromGeometry,t.toGeometry],a);return y.fromJSON(s)}async function Z(e,t,r,n){const i=o.parseUrl(e),u=await s.normalizeCentralMeridian(r),l=t.toJSON();null!=u[0]&&(l.fromGeometry=JSON.stringify(ae(u[0]))),null!=u[1]&&(l.toGeometry=JSON.stringify(ae(u[1])));const m=o.encode({...i.query,f:"json",...l}),p=o.asValidOptions(m,n),{data:c}=await a(i.path+"/measure",p);return c}async function _(e,t,a){const r=await te(e,t,a);return F.fromJSON(r)}async function ee(e,t,a){const r=await te(e,t,a);return $.fromJSON(r)}async function te(e,t,s){t=r.ensureClass(b,t);const n=o.parseUrl(e),i=t.toJSON(),u=o.encode({...n.query,f:"json",...i}),l=o.asValidOptions(u,s),{data:m}=await a(n.path+"/measureFromImage",l);return m}function ae(e){const t=e.toJSON();return e.spatialReference?.imageCoordinateSystem&&(t.spatialReference=re(e.spatialReference)),t}function re(e){const{imageCoordinateSystem:t}=e;if(t){const{id:e,referenceServiceName:a}=t;return null!=e?a?{icsid:e,icsns:a}:{icsid:e}:{ics:t}}return e.toJSON()}function se(e,t){if(!e.imageCoordinateSystem)return n.srToRESTValue(e);const a=re(e),{icsid:r,icsns:s}=a;return null==r||null!=s&&!t?.toLowerCase().includes("/"+s.toLowerCase()+"/")?JSON.stringify(a):`0:${r}`}async function ne(e,t,s){t=r.ensureClass(g,t);const n=o.parseUrl(e),i=t.toJSON();t.outSpatialReference&&(i.outSR=se(t.outSpatialReference));const u=o.encode({...n.query,f:"json",...i}),l=o.asValidOptions(u,s),{data:m}=await a(n.path+"/queryBoundary",l);return f.fromJSON(m)}async function oe(e,t,n){const i=(t=r.ensureClass(S,t)).toJSON();H(i),i.objectIds?.length&&(i.objectIds=i.objectIds.join(",")),i.geometry||i.objectIds||i.time||i.where||(i.where="1=1");const u=await s.normalizeCentralMeridian(t.geometry),l=u?.[0];null!=l&&(i.geometry=ae(l));const m=l?.spatialReference??t.geometry?.spatialReference;m&&(i.inSR=se(m));const p=o.parseUrl(e),c=o.encode({...p.query,f:"json",...i}),g=o.asValidOptions(c,n),{data:f}=await a(`${p.path}/queryGPSInfo`,g);return I.fromJSON(f)}async function ie(e,t,s){const n=(t=r.ensureClass(V,t)).toJSON();t.geometry.spatialReference.imageCoordinateSystem&&(n.geometry=ae(t.geometry)),t.depthOffset&&t.adjust||delete n.options;const i=o.parseUrl(e),u=o.encode({...i.query,f:"json",...n}),l=o.asValidOptions(u,s),{data:m}=await a(`${i.path}/imageToMap`,l);return z.fromJSON(m)}async function ue(e,t,s){const n=(t=r.ensureClass(q,t)).toJSON();t.rasterIds?.length&&(n.rasterIds=t.rasterIds.join(","));const i=o.parseUrl(e),u=o.encode({...i.query,f:"json",...n}),l=o.asValidOptions(u,s),{data:m}=await a(`${i.path}/imageToMapMultiray`,l);return z.fromJSON(m)}async function le(e,t,n){const i=(t=r.ensureClass(A,t)).toJSON(),u=await s.normalizeCentralMeridian(t.geometry),l=u?.[0];null!=l&&(i.geometry=ae(l)),t.visibleOnly||delete i.options;const m=l?.spatialReference??t.geometry?.spatialReference;m&&(i.inSR=se(m));const p=o.parseUrl(e),c=o.encode({...p.query,f:"json",...i}),g=o.asValidOptions(c,n),{data:f}=await a(`${p.path}/mapToImage`,g);return z.fromJSON(f)}async function me(e,t,s){const n=(t=r.ensureClass(G,t)).toJSON(),i=o.parseUrl(e),u=o.encode({...i.query,f:"json",...n}),l=o.asValidOptions(u,s),{data:m}=await a(`${i.path}/getImageUrl`,l);return T.fromJSON(m)}async function pe(e,t,n){const l=(t=r.ensureClass(i,t)).toJSON(),m=await s.normalizeCentralMeridian([t.fromGeometry,t.toGeometry]);null!=m[0]&&(l.fromGeometry=ae(m[0]),m[0].spatialReference&&(l.inSR=se(m[0].spatialReference))),null!=m[1]&&(l.toGeometry=ae(m[1])),t.objectIds?.length&&(l.objectIds=l.objectIds.join(","));const p=o.parseUrl(e),c=o.encode({...p.query,f:"json",...l}),g=o.asValidOptions(c,n),{data:f}=await a(`${p.path}/find`,g);return u.fromJSON(f)}e.computeAngles=x,e.computeHistograms=E,e.computePixelSpaceLocations=B,e.computeStatisticsHistograms=D,e.findImages=pe,e.getImageSpatialReferenceJSON=re,e.getImageSpatialReferenceQueryParameter=se,e.getImageUrl=me,e.getSamples=k,e.identify=Q,e.imageToMap=ie,e.imageToMapMultiray=ue,e.mapToImage=le,e.measureAreaAndPerimeter=K,e.measureAreaFromImage=ee,e.measureDistanceAndAngle=Y,e.measureHeight=X,e.measureLengthFromImage=_,e.measurePointOrCentroid=W,e.queryBoundary=ne,e.queryGPSInfo=oe,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
