/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../geometry","../../../core/Logger","../Entity","../GraphObject","../GraphQueryResultHeader","../ObjectValue","../Path","../Relationship","./KnowledgeWasmInterface","./WasmQueryWrapperInterfaces","./wasmToGeometryFactories","../../../geometry/SpatialReference"],(function(e,t,n,r,s,o,a,u,i,c,p,y,d){"use strict";const l=()=>n.getLogger("esri.rest.knowledgeGraph.WasmToQueryResponseObjConstructors"),m={decodedWasmObjToQueryResponseObj:(e,t,n)=>{if(null==e)return null;if("object"!=typeof e)return e;if("getDate"in e)return e;if("geometry_type"in e)switch(e.geometry_type.value){case null:return null;case c.WasmGeometryTypeCodes.ESRI_GEOMETRY_POINT:return y.wasmToPointGeometry(e,n);case c.WasmGeometryTypeCodes.ESRI_GEOMETRY_MULTIPOINT:return y.wasmToMultipointGeometry(e,n);case c.WasmGeometryTypeCodes.ESRI_GEOMETRY_POLYLINE:return y.wasmToPolylineGeometry(e,n);case c.WasmGeometryTypeCodes.ESRI_GEOMETRY_POLYGON:return y.wasmToPolygonGeometry(e,n);case c.WasmGeometryTypeCodes.ESRI_GEOMETRY_ENVELOPE:case c.WasmGeometryTypeCodes.ESRI_GEOMETRY_MULTI_PATCH:return l().warnOnce("Envelope and Multipatch are not supported on knowledge entities, but one of those geometry types was detected. Result interpreted as null"),null;case c.WasmGeometryTypeCodes.ESRI_GEOMETRY_NULL:case c.WasmGeometryTypeCodes.ESRI_GEOMETRY_ANY:default:return l().warnOnce("Unknown or blank geometry type returned - Result interpreted as null"),null}else{if(!("object_value_type"in e))return l().warnOnce("A decoded value came back of a type that is not supported. Result interpreted as null"),null;switch(e.object_value_type.value){case p.WasmGraphQueryResponseTypeCodes.OBJECT:return E(e,t,n);case p.WasmGraphQueryResponseTypeCodes.ENTITY:return R(e,t,n);case p.WasmGraphQueryResponseTypeCodes.RELATIONSHIP:return G(e,t,n);case p.WasmGraphQueryResponseTypeCodes.PATH:return f(e,t,n);case p.WasmGraphQueryResponseTypeCodes.ARRAY:return _(e,t,n);default:return l().warnOnce("Unknown graph object type detected!  Result interpreted as null"),null}}}};function _(e,t,n){const r=[],s=e.count();for(let o=0;o<s;o++){const s=e.get_value_at(o);r.push(T(s,t,n))}return r}function T(e,t,n){return m.decodedWasmObjToQueryResponseObj(e,t,n)}function R(e,t,n){const s=e.type_name,o=O(e,t,n),a=e.get_id();return new r(Object.assign({typeName:s,id:a},o))}function g(e,t,n){return new s(O(e,t,n))}function O(e,t,n){const r={},s=e.key_count();for(let o=0;o<s;o++)r[e.get_key_at(o)]=T(e.get_value_at(o),t,n);return{properties:r}}function E(e,t,n){return new a(O(e,t,n))}function f(e,t,n){const r=e.entity_count(),s=e.relationship_count(),o=[];for(let a=0;a<r;a++)o.push(R(e.get_entity_at(a),t,n)),a<s&&o.push(G(e.get_relationship_at(a),t,n));return new u({path:o})}function G(e,t,n){const r=e.type_name,s=O(e,t,n);return new i(Object.assign({typeName:r,id:e.get_id(),originId:e.get_origin_entity_id(),destinationId:e.get_destination_entity_id()},s))}function w(e){const t=[];for(let r=0;r<e.get_header_keys().size();r++)t.push(e.get_header_keys().get(r));const n=new d(e.get_out_sr());return new o({headerKeys:t,outSpatialReference:n,exceededTransferLimit:e.exceeded_transfer_limit()})}e.decodeWasmObjectTest=m,e.decodedWasmObjToQueryResponseObj=T,e.wasmArrayToArray=_,e.wasmToEntity=R,e.wasmToGraphObject=g,e.wasmToGraphQueryResponseHeader=w,e.wasmToObjectValue=E,e.wasmToPath=f,e.wasmToRelationship=G,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
