/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../geometry","../kernel","../request","../core/Error","../core/Logger","./knowledgeGraph/GraphQueryResult","./knowledgeGraph/GraphQueryResultHeader","./knowledgeGraph/GraphQueryStreamingResult","./knowledgeGraph/KnowledgeGraph","./knowledgeGraph/ServiceDefinition","./knowledgeGraph/wasmInterface/clientDataToWasmEncodedFactories","./knowledgeGraph/wasmInterface/knowledgeWasmAccess","./knowledgeGraph/wasmInterface/queryToWasmEncodedFactories","./knowledgeGraph/wasmInterface/updateToWasmEncodedFactories","./knowledgeGraph/wasmInterface/wasmToClientDataFactories","./knowledgeGraph/wasmInterface/wasmToDataModelFactories","./knowledgeGraph/wasmInterface/wasmToQueryResponseObjFactories","./knowledgeGraph/wasmInterface/wasmToUpdateResponseFactories","./knowledgeGraph/wasmInterface/wasmUtils","../geometry/SpatialReference","../geometry/Geometry"],(function(e,t,r,a,n,o,s,i,d,c,l,p,u,h,g,w,y,f,m,k,_,b){"use strict";const v=new Map,T=()=>new Map(v.entries()),S={fetchKnowledgeGraph:async e=>{const t=new c({url:e}),r=[];return r.push(Q(t)),r.push(q(t)),await Promise.all(r),t},refreshDataModel:async e=>{e.dataModel=await $(e)},refreshServiceDefinition:async e=>{const t=(await a(e.url,{query:{f:"json"}})).data;return t.capabilities=t?.capabilities?.split(","),t.supportedQueryFormats=t?.supportedQueryFormats?.split(","),e.serviceDefinition=new l(t),e.serviceDefinition},executeQueryStreaming:async(e,t,r)=>{const a="include",o=`${e.url}/graph/query`;await P(e);const s=await L(o,r);if(!e.serviceDefinition?.supportsProvenance&&t.provenanceBehavior===a)throw new n("knowledge-graph:provenance-not-supported","The Knowledge Graph Service definition indicated that provenance is not supported");s.data.body=await F(t,e);const i=await I(s.data.url,s.data);if(e.dataModel){const t=await j(i,e.dataModel);return new d({resultRowsStream:t.readableStream,resultHeader:t.resultHeader})}throw new n("knowledge-graph:undefined-data-model","The KnowledgeGraph supplied did not have a data model")},executeApplyEdits:async(e,t,r)=>{if(e.serviceDefinition?.dataEditingNotSupported)throw new n("knowledge-graph:data-editing-not-supported","The Knowledge Graph Service definition indicated that data editing is not supported");const a=`${e.url}/graph/applyEdits`;await P(e);const o=await L(a,r);o.data.body=await H(t,e);return z(await I(o.data.url,o.data))},executeQuery:async(e,t,r)=>{const o=`${e.url}/graph/query`,i=await a(o,{responseType:"array-buffer",query:{f:"pbf",openCypherQuery:t.openCypherQuery,...r?.query},signal:r?.signal,timeout:r?.timeout}),d=i.getHeader?.("content-type"),c=i.data;if(d?.includes("application/x-protobuf")){const t=new((await u.getWasmInterface()).GraphQueryDecoder);if(t.deleteLater(),e.dataModel){const r=U(t,c,e.dataModel);return new s({resultRows:r.resultRows,resultHeader:r.resultHeader})}throw new n("knowledge-graph:undefined-data-model","The KnowledgeGraph supplied did not have a data model")}throw new n("knowledge-graph:unexpected-server-response","server returned an unexpected response",{responseType:d,data:i.data})},executeSearch:async(e,t,r)=>{const o=t.typeCategoryFilter,i=`${e.url}/graph/search`,d=await a(i,{responseType:"array-buffer",query:{f:"pbf",searchQuery:`"${t.searchQuery}"`,typeCategoryFilter:o,...r?.query},signal:r?.signal,timeout:r?.timeout}),c=d.getHeader?.("content-type"),l=d.data;if(c?.includes("application/x-protobuf")){const t=new((await u.getWasmInterface()).GraphQueryDecoder);if(t.deleteLater(),e.dataModel){const r=U(t,l,e.dataModel);return new s({resultRows:r.resultRows,resultHeader:r.resultHeader})}throw new n("knowledge-graph:undefined-data-model","The KnowledgeGraph supplied did not have a data model")}throw new n("knowledge-graph:unexpected-server-response","server returned an unexpected response",{responseType:c,data:d.data})},executeSearchStreaming:async(e,t,r)=>{const a=`${e.url}/graph/search`;await P(e);const o=await L(a,r);o.data.body=await O(t);const s=await I(o.data.url,o.data);if(e.dataModel){const t=await j(s,e.dataModel);return new d({resultRowsStream:t.readableStream,resultHeader:t.resultHeader})}throw new n("knowledge-graph:undefined-data-model","The KnowledgeGraph supplied did not have a data model")},fetchClientDataAtKeys:async(e,t,r={ignoreCache:!1})=>{if(!t.length)return new Map;let a=v.get(e.url||"");a||(a=new Map,v.set(e.url||"",a));const o=new Map(a.entries()),s=`${e.url}/clientData/fetch`;t=Array.from(new Set(t));const i=await u.getWasmInterface(),d=p.encodeClientDataAtKeysRequest(t,a,i,r.ignoreCache),c=await L(s,r.requestOptions);c.data.body=d;const l=await I(c.data.url,c.data),h=l.headers.get("content-type");if(h?.includes("application/x-protobuf")){const e=new i.ClientDataFetchResponseDecoder;e.deleteLater();const t=await l.arrayBuffer();return e.decode(new Uint8Array(t)),e.has_error()&&k.checkWasmError(e.error,"knowledge-graph:fetchClientDataAtKeys-decoding-error","An error occurred while decoding the client data keys response"),w.wasmClientDataFetchResponseToClientData(e,a,o,r.ignoreCache)}throw new n("knowledge-graph:unexpected-server-response","server returned an unexpected response when fetching client data",{responseType:h,data:l})},fetchAllClientDataKeys:async(e,t)=>{const r=`${e.url}/clientData`,o=await a(r,{responseType:"array-buffer",query:{f:"pbf"},signal:t?.signal,timeout:t?.timeout}),s=o.getHeader?.("content-type"),i=o.data;if(s?.includes("application/x-protobuf")){const e=new((await u.getWasmInterface()).ClientDataKeysResponseDecoder);return e.deleteLater(),e.decode(new Uint8Array(i)),e.has_error()&&k.checkWasmError(e.error,"knowledge-graph:fetchAllClientDataKeys-decoding-error","An error occurred while decoding the client data keys response"),w.wasmClientDataAllKeysResponseToClientDataKeys(e)}throw new n("knowledge-graph:unexpected-server-response","server returned an unexpected response",{responseType:s,data:o.data})},clearClientDataCache:()=>v.clear(),_fetchWrapper:async(e,t)=>fetch(e,t)};async function C(e,t,r){return S.executeApplyEdits(e,t,r)}async function D(e,t,r){return S.executeQuery(e,t,r)}async function x(e,t,r){return S.executeQueryStreaming(e,t,r)}async function E(e,t,r){return S.executeSearch(e,t,r)}async function W(e,t,r){return S.executeSearchStreaming(e,t,r)}function A(e,t){return S.fetchAllClientDataKeys(e,t)}function G(e,t,r){return S.fetchClientDataAtKeys(e,t,r)}async function R(e){return S.fetchKnowledgeGraph(e)}async function Q(e){return S.refreshDataModel(e)}async function q(e){return S.refreshServiceDefinition(e)}function M(){return S.clearClientDataCache()}async function I(e,t){return S._fetchWrapper(e,t)}async function P(e){const t=r.id?.findCredential(e.url);t||(e.dataModel?await $(e):await Q(e))}function K(e,t,r,a){null==t?r.set_param_key_value(e,""):"object"!=typeof t||t instanceof Date?r.set_param_key_value(e,t):t instanceof b?r.set_param_key_value(e,h.geometryToWasm(t,a)):Array.isArray(t)?r.set_param_key_value(e,h.bindParamArrayToWasm(t,a)):r.set_param_key_value(e,h.bindParamObjectToWasm(t,a))}async function H(e,t){if(t.dataModel||await Q(t),!t.dataModel)throw new n("knowledge-graph:data-model-undefined","Encoding could not proceed because a data model was not provided and it could not be determined from the service");const r=await u.getWasmInterface(),a=!!e.options?.cascadeDelete,o=new r.GraphApplyEditsEncoder(r.SpatialReferenceUtil.WGS84(),e.options?.inputQuantizationParameters?g.inputQuantizationParametersToWasmFormat(e.options?.inputQuantizationParameters):r.InputQuantizationUtil.WGS84_lossless());o.deleteLater(),o.cascade_delete=a;try{let t;e.entityAdds?.forEach((e=>{t=o.add_entity(g.namedObjectToWasm(e,r)),k.checkWasmError(t,"knowledge-graph:applyEdits-encoding-failed","Attempting to encode the applyEdits - an entity failed to be added to the encoder")})),e.relationshipAdds?.forEach((e=>{if(!e.originId||!e.destinationId)throw new n("knowledge-graph:relationship-origin-destination-missing","When adding a new relationship, you must provide both an origin and destination id on the appropriate class property");t=o.add_relationship(g.namedObjectToWasm(e,r)),k.checkWasmError(t,"knowledge-graph:applyEdits-encoding-failed","Attempting to encode the applyEdits - a relationship failed to be added to the encoder")})),e.entityUpdates?.forEach((e=>{if(!e.id)throw new n("knowledge-graph:entity-id-missing","When updating an entity or relationship, you must specify the id on the class level property");t=o.update_entity(g.namedObjectToWasm(e,r)),k.checkWasmError(t,"knowledge-graph:applyEdits-encoding-failed","Attempting to encode the applyEdits - an entity failed to be added to the encoder")})),e.relationshipUpdates?.forEach((e=>{if(!e.id)throw new n("knowledge-graph:relationship-id-missing","When updating an entity or relationship, you must specify the id on the class level property");t=o.update_relationship(g.namedObjectToWasm(e,r)),k.checkWasmError(t,"knowledge-graph:applyEdits-encoding-failed","Attempting to encode the applyEdits - a relationship failed to be added to the encoder")})),e.entityDeletes?.forEach((e=>{if(!e.typeName)throw new n("knowledge-graph:no-type-name","You must indicate the entity/relationship named object type to apply edits - delete");const t=o.make_delete_helper(e.typeName,!0);t.deleteLater(),e.ids?.forEach((e=>{t.delete_by_id(e)}))})),e.relationshipDeletes?.forEach((e=>{if(!e.typeName)throw new n("knowledge-graph:no-type-name","You must indicate the entity/relationship named object type to apply edits - delete");const t=o.make_delete_helper(e.typeName,!1);e.ids?.forEach((e=>{t.delete_by_id(e)}))})),o.encode()}catch(i){throw new n("knowledge-graph:applyEdits-encoding-failed","Attempting to encode the applyEdits failed",{error:i})}const s=o.get_encoding_result();return k.checkWasmError(s.error,"knowledge-graph:applyEdits-encoding-failed","Attempting to encode the applyEdits failed"),structuredClone(s.get_byte_buffer())}async function F(e,t){const r=await u.getWasmInterface(),a=new r.GraphQueryRequestEncoder;if(a.deleteLater(),e.outputSpatialReference?a.output_spatial_reference={wkid:e.outputSpatialReference.wkid,latestWkid:e.outputSpatialReference.latestWkid,vcsWkid:e.outputSpatialReference.vcsWkid,latestVcsWkid:e.outputSpatialReference.latestVcsWkid,wkt:e.outputSpatialReference.wkt??""}:a.output_spatial_reference=r.SpatialReferenceUtil.WGS84(),a.open_cypher_query=e.openCypherQuery,e.bindParameters)for(const[n,i]of Object.entries(e.bindParameters))K(n,i,a,r);if(e.bindGeometryQuantizationParameters)h.setInputQuantizationParametersOnEncoder(e.bindGeometryQuantizationParameters,a);else{if(t.dataModel||await Q(t),4326!==t.dataModel?.spatialReference?.wkid)throw new n("knowledge-graph:SR-quantization-mismatch","If the DataModel indicates a coordinate system other than WGS84, inputQuantizationParameters must be provided to the query encoder");a.input_quantization_parameters=r.InputQuantizationUtil.WGS84_lossless()}e.outputQuantizationParameters&&h.setOutputQuantizationParametersOnEncoder(e.outputQuantizationParameters,a,r),e.provenanceBehavior&&h.setProvenanceBehaviorOnEncoder(e.provenanceBehavior,a);try{a.encode()}catch(s){throw new n("knowledge-graph:query-encoding-failed","Attempting to encode the query failed",{error:s})}const o=a.get_encoding_result();if(0!==o.error.error_code)throw new n("knowledge-graph:query-encoding-failed","Attempting to encode the query failed",{errorCode:o.error.error_code,errorMessage:o.error.error_message});return structuredClone(o.get_byte_buffer())}async function O(e){const t=await u.getWasmInterface(),r=new t.GraphSearchRequestEncoder;if(r.deleteLater(),r.search_query=e.searchQuery,r.type_category_filter=t.esriNamedTypeCategory[e.typeCategoryFilter],!0===e.returnSearchContext&&(r.return_search_context=e.returnSearchContext),null!=e.start&&e.start>0&&(r.start_index=e.start),null!=e.num&&(r.max_num_results=e.num),null!=e.idsFilter&&Array.isArray(e.idsFilter)&&e.idsFilter.length>0)try{r.set_ids_filter(h.bindParamArrayToWasm(e.idsFilter,t))}catch(o){throw new n("knowledge-graph:ids-format-error","Attempting to set ids filter failed.  This is usually caused by an incorrectly formatted UUID string",{error:o})}e.namedTypesFilter?.forEach((e=>{r.add_named_type_filter(e)}));try{r.encode()}catch(o){throw new n("knowledge-graph:search-encoding-failed","Attempting to encode the search failed",{error:o})}const a=r.get_encoding_result();if(0!==a.error.error_code)throw new n("knowledge-graph:search-encoding-failed","Attempting to get encoding result from the query failed",{errorCode:a.error.error_code,errorMessage:a.error.error_message});return structuredClone(a.get_byte_buffer())}async function L(e,t){return a(e,{responseType:"native-request-init",method:"post",query:{f:"pbf",...t?.query},body:"x",headers:{"Content-Type":"application/octet-stream"},signal:t?.signal,timeout:t?.timeout})}async function z(e){const t=e.headers.get("content-type");if(t?.includes("application/x-protobuf")){const t=await e.arrayBuffer(),r=new((await u.getWasmInterface()).GraphApplyEditsDecoder);return r.deleteLater(),r.decode(new Uint8Array(t)),m.decoderToApplyEditsResponse(r)}throw new n("knowledge-graph:unexpected-server-response","server returned an unexpected response",{responseType:t,data:e.text()})}function U(e,t,r,a){e.push_buffer(new Uint8Array(t));const o=[];let s,i,d=0;for(;e.next_row();){s&&i||(s=a??f.wasmToGraphQueryResponseHeader(e),i=s.outSpatialReference??new _({wkid:4326})),d||(d=e.get_header_keys().size());const t=new Array(d);for(let a=0;a<d;a++){const n=e.get_value(a);t[a]=f.decodedWasmObjToQueryResponseObj(n,r,i)}o.push(t)}if(e.has_error())throw new n("knowledge-graph:stream-decoding-error","One or more result rows were not successfully decoded - inner row decoding",{errorCode:e.error.error_code,errorMessage:e.error.error_message});return{resultHeader:s,resultRows:o}}async function j(e,t){const r=e.headers.get("content-type");if(e.headers.get("content-length")&&o.getLogger("esri.rest.knowledgeGraph.knowledgeGraphService").warnOnce("Found `Content-Length` header when expecting a streaming HTTP response! Please investigate whether all intermediate HTTP proxies and/or load balancers are configured such that they don't forcefully buffer the entire response before returning it to the client. A valid HTTP streaming response should use Chunked Transfer Encoding and not have a Content Length defined."),r?.includes("application/x-protobuf")){const r=e.body?.getReader(),a=new((await u.getWasmInterface()).GraphQueryDecoder);let s,d,c;a.deleteLater();const l=new Promise(((e,t)=>{d=e,c=t}));let p=!1;return{readableStream:new ReadableStream({async start(e){try{return l()}catch(u){r?.releaseLock(),e.error(new n("knowledge-graph:stream-decoding-error","The server returned a valid response, but there was an error decoding the response stream",{error:u})),e.close()}function l(){return r?.read().then((({done:u,value:h})=>{try{if(u){let t;if(a.has_error()?t=new n("knowledge-graph:stream-decoding-error","One or more result rows were not successfully decoded - query stream done",{errorCode:a.error.error_code,errorMessage:a.error.error_message}):p||d(new i),r.releaseLock(),t)throw e.error(t),c(t),t;return void e.close()}const o=U(a,h,t,s),g=o.resultRows;return g.length>0&&e.enqueue(g),!s&&o.resultHeader&&(s=o.resultHeader,d(o.resultHeader),p=!0),l()}catch(g){throw o.getLogger("esri.rest.knowledgeGraph.knowledgeGraphService").error(g),c(g),new n("knowledge-graph:unexpected-server-response","Error inside streaming data return parsing",{error:g})}}))}}}),resultHeader:await l}}throw new n("knowledge-graph:unexpected-server-response","server returned an unexpected response",{responseType:r,data:e.text()})}async function $(e){const t=`${e.url}/dataModel/queryDataModel`,r=await a(t,{responseType:"array-buffer",query:{f:"pbf"}}),o=r.getHeader?.("content-type"),s=r.data;if(o?.includes("application/x-protobuf")){const e=(await u.getWasmInterface()).decode_data_model_from_protocol_buffer(new Uint8Array(s));if(!e)throw new n("knowledge-graph:data-model-decode-failure","The server responded to the data model query, but the response failed to be decoded.  This typically occurs when the Knowledge JS API (4.26 or later) is used with an unsupported backend (11.0 or earlier)");return y.wasmToDataModel(e)}throw new n("knowledge-graph:unexpected-server-response","server returned an unexpected response",{responseType:o,data:r.data})}e._fetchWrapper=I,e._getClientDataCacheCopy=T,e.clearClientDataCache=M,e.clientDataCache=v,e.executeApplyEdits=C,e.executeQuery=D,e.executeQueryStreaming=x,e.executeSearch=E,e.executeSearchStreaming=W,e.fetchAllClientDataKeys=A,e.fetchClientDataAtKeys=G,e.fetchKnowledgeGraph=R,e.kgRestServices=S,e.refreshDataModel=Q,e.refreshServiceDefinition=q,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
