/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../kernel","../request","../core/jsonMap","../core/screenUtils","../core/urlUtils","../geometry/Polygon","../layers/support/fieldUtils","../layers/support/floorFilterUtils","../renderers/visualVariables/support/visualVariableUtils","./utils","./geoprocessor/execute","./geoprocessor/submitJob","./support/fileFormat","./support/layoutTemplate","./support/printTaskUtils","./support/PrintTemplate","./support/reportTemplate"],(function(e,t,a,i,r,n,o,s,l,c,u,y,p,d,f,m,g,h){"use strict";const b={Feet:"ft",Kilometers:"km",Meters:"m",Miles:"mi"},w=new i.JSONMap({esriFeet:"Feet",esriKilometers:"Kilometers",esriMeters:"Meters",esriMiles:"Miles"}),S=new i.JSONMap({esriExecutionTypeSynchronous:"sync",esriExecutionTypeAsynchronous:"async"}),x=new Map;async function v(e,t,a){const i=await I(e,a),r=await T(t,i);if("sync"===await D(e,a)){const{results:t}=await y.execute(e,r,void 0,a);return t?.[0]?.value}const n=await p.submitJob(e,r,void 0,a);await n.waitForJobCompletion({interval:t.updateDelay});const{value:o}=await n.fetchResultData("Output_File",null,a);return o}async function I(e,t){const i=P(e),r=x.get(i)??{gpServerUrl:i,legendLayerNameMap:{},legendLayers:[]};return r.gpMetadata??=(await a(i,u.asValidOptions({f:"json"},t))).data,r.cimVersion=r.gpMetadata.cimVersion,x.set(i,r),r}async function D(e,t){return ie(await I(e,t))}async function L(e,t){return(await I(e,t)).gpMetadata.tasks}async function T(e,a){a=a||{is11xService:!1,legendLayerNameMap:{},legendLayers:[]};const i=e.template||new g;null==i.showLabels&&(i.showLabels=!0);const r=i.exportOptions;let n;const o=f.toJSON(i.layout);if(r){if(n={dpi:r.dpi},"map_only"===o?.toLowerCase()||""===o){const{width:e,height:t}=r;n.outputSize=null!=e&&null!=t?[e,t]:void 0}}const s=i.layoutOptions;let l;if(s){let e,t;"Miles"===s.scalebarUnit||"Kilometers"===s.scalebarUnit?(e="Kilometers",t="Miles"):"Meters"!==s.scalebarUnit&&"Feet"!==s.scalebarUnit||(e="Meters",t="Feet"),l={titleText:s.titleText,authorText:s.authorText,copyrightText:s.copyrightText,customTextElements:s.customTextElements,elementOverrides:s.elementOverrides,scaleBarOptions:{metricUnit:w.toJSON(e),metricLabel:e?b[e]:void 0,nonMetricUnit:w.toJSON(t),nonMetricLabel:t?b[t]:void 0}}}let c=null;s?.legendLayers&&(c=s.legendLayers.map((e=>{const t=e.layerId;a.legendLayerNameMap[t]=e.title;const i={id:t};return e.subLayerIds&&(i.subLayerIds=e.subLayerIds),i})));const u=await O(e,i,a);if(u.operationalLayers){const e=new RegExp("[\\u4E00-\\u9FFF\\u0E00-\\u0E7F\\u0900-\\u097F\\u3040-\\u309F\\u30A0-\\u30FF\\u31F0-\\u31FF]"),t=/[\u0600-\u06FF]/,a=a=>{const i=a.text,r=a.font,n=r?.family?.toLowerCase();i&&r&&("arial"===n||"arial unicode ms"===n)&&(r.family=e.test(i)?"Arial Unicode MS":"Arial","normal"!==r.style&&t.test(i)&&(r.family="Arial Unicode MS"))};for(const i of u.operationalLayers)if(i.featureCollection?.layers)for(const e of i.featureCollection.layers){if(e.layerDefinition?.drawingInfo?.renderer?.symbol){const t=e.layerDefinition.drawingInfo.renderer;"esriTS"===t.symbol.type&&a(t.symbol)}if(e.featureSet?.features)for(const t of e.featureSet.features)t.symbol&&"esriTS"===t.symbol.type&&a(t.symbol)}}e.outSpatialReference&&(u.mapOptions.spatialReference=e.outSpatialReference.toJSON()),Object.assign(u,{exportOptions:n,layoutOptions:l||{}}),Object.assign(u.layoutOptions,{legendOptions:{operationalLayers:null!=c?c:a.legendLayers.slice()}}),a.legendLayers.length=0,x.set(a.gpServerUrl,a);const y={Web_Map_as_JSON:JSON.stringify(u),Format:d.formatJsonMap.toJSON(i.format),Layout_Template:o,Layout_Item_ID:void 0,Report_Template:h.toJSON(i.report),Report_Item_ID:void 0};if(i.layoutItem){delete y.Layout_Template;const e=i.layoutItem;await e.load(),"public"!==e.access&&t.id&&await t.id.getCredential(a.gpServerUrl),y.Layout_Item_ID=JSON.stringify({id:e.id})}if(i.reportItem){delete y.Report_Template;const e=i.reportItem;await e.load(),"public"!==e.access&&t.id&&await t.id.getCredential(a.gpServerUrl),y.Report_Item_ID=JSON.stringify({id:e.id})}return e.extraParameters&&Object.assign(y,e.extraParameters),y}async function O(e,t,a){const i=e.view;let r=i.spatialReference;const n={operationalLayers:await M(i,t,a)};t.includeTables&&(n.tables=await K(i));let o=e.extent||a.ssExtent||i.extent;if(r?.isWrappable&&(o=o.clone()._normalize(!0),r=o.spatialReference),n.mapOptions={extent:o&&o.toJSON(),spatialReference:r&&r.toJSON(),showAttribution:t.attributionVisible},a.ssExtent=null,i.background&&(n.background=i.background.toJSON()),i.rotation&&(n.mapOptions.rotation=-i.rotation),t.scalePreserved&&(n.mapOptions.scale=t.outScale||i.scale),null!=i.timeExtent){const e=null!=i.timeExtent.start?i.timeExtent.start.getTime():null,t=null!=i.timeExtent.end?i.timeExtent.end.getTime():null;n.mapOptions.time=[e,t]}return t.reportOptions&&(n.reportOptions=t.reportOptions),n}function P(e){let t=e;const a=t.lastIndexOf("/GPServer/");return a>0&&(t=t.slice(0,a+9)),t}async function M(e,t,a){const i=[],r={layerView:null,printTemplate:t,view:e};let n=0;t.scalePreserved&&(n=t.outScale||e.scale);const o=m.getVisibleLayerViews(e,n);for(const s of o){const e=s.layer;if(!e.loaded||"layers"in e)continue;let t;r.layerView=s,t=m.isScreenshotRequired(s)?await B(e,r,a):m.isBingMapsLayer(e)?E(e):"csv"===e?.type?await F(e,r,a):"catalog-footprint"===e?.type?await V(e,r,a):"feature"===e?.type?await J(e,r,a):"geojson"===e?.type?await R(e,r,a):"graphics"===e?.type?await U(e,r,a):"imagery"===e?.type?k(e,a):"imagery-tile"===e?.type?await C(e,r,a):"kml"===e?.type?await A(e,r,a):"map-image"===e?.type?z(e,r,a):"map-notes"===e?.type?await _(r,a):"open-street-map"===e?.type?$():"stream"===e?.type?await q(e,r,a):"subtype-group"===e?.type?await j(e,a):"tile"===e?.type?W(e,a):"vector-tile"===e?.type?await G(e,r,a):"web-tile"===e?.type?H(e):"wms"===e?.type?Q(e,a):"wmts"===e?.type?X(e):await B(e,r,a),t&&(Array.isArray(t)?i.push(...t):(t.id=e.id,t.title=a.legendLayerNameMap[e.id]||e.title,t.opacity=s.fullOpacity,t.minScale=e.minScale||0,t.maxScale=e.maxScale||0,m.isBlendLayer(e)&&e.blendMode&&"normal"!==e.blendMode&&(t.blendMode=e.blendMode),i.push(t)))}if(n)for(const s of i)s.minScale=0,s.maxScale=0;if(e.graphics?.length){const r=await N(null,e.graphics,t,a);r&&i.push(r)}return i}function E(e){return{culture:e.culture,key:e.key,type:"BingMaps"+("aerial"===e.style?"Aerial":"hybrid"===e.style?"Hybrid":"Road")}}async function V(e,{layerView:t,printTemplate:a},i){if(parseFloat(i.cimVersion)<3.1){return N(e,await te(t),a,i)}const r=e.parent,n={id:(o=ae(r,"web-map")).id,url:o.url,layerType:o.layerType,customParameters:o.customParameters,dynamicGroupLayer:{visibility:!1},footprintLayer:o.footprintLayer,layerDefinition:o.layerDefinition};var o;return Y(n,r),n}async function F(e,t,a){e.legendEnabled&&a.legendLayers.push({id:e.id});const i=t.layerView,r=t.printTemplate;if(!(i.filter||e.portalItem&&"public"!==e.portalItem.access)){const t=ae(e,"web-map");return t.type="CSV",delete t.popupInfo,delete t.layerType,t.showLabels=r.showLabels&&e.labelsVisible,t}return N(e,await te(i),r,a)}async function N(e,t,a,i){let r;const n=m.createPolygonLayer(),l=m.createPolylineLayer(),c=m.createPointLayer(),u=m.createMultipointLayer(),y=m.createPointLayer();if(y.layerDefinition.name="textLayer",delete y.layerDefinition.drawingInfo,e){if("esri.layers.FeatureLayer"===e.declaredClass||"esri.layers.StreamLayer"===e.declaredClass?n.layerDefinition.name=l.layerDefinition.name=c.layerDefinition.name=u.layerDefinition.name=i.legendLayerNameMap[e.id]||e.get("arcgisProps.title")||e.title:"esri.layers.GraphicsLayer"===e.declaredClass&&(t=e.graphics.items),e.renderer){const t=e.renderer.toJSON(),a=n.layerDefinition.drawingInfo;a&&(a.renderer=t);const i=l.layerDefinition.drawingInfo;i&&(i.renderer=t);const r=c.layerDefinition.drawingInfo;r&&(r.renderer=t);const o=u.layerDefinition.drawingInfo;o&&(o.renderer=t)}if(a.showLabels&&e.labelsVisible&&"function"==typeof e.write){const t=ae(e,"web-map"),a=t.layerDefinition?.drawingInfo?.labelingInfo;if(a){r=!0;const e=n.layerDefinition.drawingInfo;e&&(e.labelingInfo=a);const t=l.layerDefinition.drawingInfo;t&&(t.labelingInfo=a);const i=c.layerDefinition.drawingInfo;i&&(i.labelingInfo=a);const o=u.layerDefinition.drawingInfo;o&&(o.labelingInfo=a)}}}let p;e?.renderer||r||(delete n.layerDefinition.drawingInfo,delete l.layerDefinition.drawingInfo,delete c.layerDefinition.drawingInfo,delete u.layerDefinition.drawingInfo);const d=e?.fieldsIndex,f=e?.renderer;if(d){const t=new Set;r&&await s.collectLabelingFields(t,e),f&&"function"==typeof f.collectRequiredFields&&await f.collectRequiredFields(t,d),p=Array.from(t);const a=d.fields.map((e=>e.toJSON()));n.layerDefinition.fields=a,l.layerDefinition.fields=a,c.layerDefinition.fields=a,u.layerDefinition.fields=a}const g=t?.length;let h;for(let s=0;s<g;s++){const e=t[s]||t.at(s);if(!1!==e.visible&&e.geometry){if(h=e.toJSON(),h.hasOwnProperty("popupTemplate")&&delete h.popupTemplate,h.geometry?.z&&delete h.geometry.z,h.symbol&&(h.symbol.angle||delete h.symbol.angle,re(h.symbol)?h.symbol=await Z(h.symbol,i):h.symbol.text&&delete h.attributes),(!a||!a.forceFeatureAttributes)&&p?.length){const e={};for(const t of p)h.attributes?.hasOwnProperty(t)&&(e[t]=h.attributes[t]);h.attributes=e}"polygon"===e.geometry.type?n.featureSet.features.push(h):"polyline"===e.geometry.type?l.featureSet.features.push(h):"point"===e.geometry.type?h.symbol?.text?y.featureSet.features.push(h):c.featureSet.features.push(h):"multipoint"===e.geometry.type?u.featureSet.features.push(h):"extent"===e.geometry.type&&(h.geometry=o.fromExtent(e.geometry).toJSON(),n.featureSet.features.push(h))}}const b=[n,l,u,c,y].filter((e=>e.featureSet.features.length>0));for(const o of b){const e=o.featureSet.features.every((e=>e.symbol));if(e&&(!a||!a.forceFeatureAttributes))for(const t of o.featureSet.features)delete t.attributes;e&&delete o.layerDefinition.drawingInfo,o.layerDefinition.drawingInfo?.renderer&&await ee(o.layerDefinition.drawingInfo.renderer,i)}return b.length?{featureCollection:{layers:b},showLabels:r}:null}async function J(e,t,a){let i;const r=e.renderer,n=parseFloat(a.cimVersion);if("binning"===e.featureReduction?.type||"cluster"===e.featureReduction?.type&&n<2.9||"pie-chart"===r?.type||"dot-density"===r?.type&&n<2.6)return B(e,t,a);e.legendEnabled&&a.legendLayers.push({id:e.id});const o=t.layerView,{printTemplate:s,view:u}=t,y="feature-layer"!==e.source?.type&&"ogc-feature"!==e.source?.type;if(o.filter||y||!r||"field"in r&&null!=r.field&&!e.getField(r.field)){const t=await te(o);i=await N(e,t,s,a)}else{if(i={id:(p=ae(e)).id,title:p.title,url:p.url,layerType:p.layerType,customParameters:p.customParameters,layerDefinition:p.layerDefinition,charts:s.includeCharts?p.charts:void 0},i.showLabels=s.showLabels&&e.labelsVisible,Y(i,e),delete i.layerDefinition?.featureReduction?.disablePopup,delete i.layerDefinition?.featureReduction?.popupInfo,i.layerDefinition?.drawingInfo?.renderer&&(delete i.layerDefinition.minScale,delete i.layerDefinition.maxScale,await ee(i.layerDefinition.drawingInfo.renderer,a),"visualVariables"in r&&r.visualVariables?.[0])){const e=r.visualVariables[0];if("size"===e.type&&e.maxSize&&"number"!=typeof e.maxSize&&e.minSize&&"number"!=typeof e.minSize){const t=c.getSizeRangeAtScale(e,u.scale);i.layerDefinition.drawingInfo.renderer.visualVariables[0].minSize=t.minSize,i.layerDefinition.drawingInfo.renderer.visualVariables[0].maxSize=t.maxSize}}const t=l.getFloorFilterClause(o);if(t&&(i.layerDefinition??={},i.layerDefinition.definitionExpression=i.layerDefinition.definitionExpression?`(${i.layerDefinition.definitionExpression}) AND (${t})`:t),e.gdbVersion&&(i.layerDefinition??={},i.layerDefinition.gdbVersion=e.gdbVersion),o.hasHighlight?.()&&"getHighlightIds"in o){const t=o;i.selectionObjectIds=t.getHighlightIds(),i.selectionSymbol=m.getSelectionSymbol(e.geometryType,t.highlightOptions??u.highlightOptions)}}var p;return i}async function R(e,t,a){if("binning"===e.featureReduction?.type||"cluster"===e.featureReduction?.type)return B(e,t,a);e.legendEnabled&&a.legendLayers.push({id:e.id});return N(e,await te(t.layerView),t.printTemplate,a)}async function U(e,{printTemplate:t},a){return N(e,null,t,a)}function k(e,t){e.legendEnabled&&t.legendLayers.push({id:e.id});const a={layerType:(i=ae(e)).layerType,customParameters:i.customParameters};var i;return a.bandIds=e.bandIds,a.compressionQuality=e.compressionQuality,a.format=e.format,a.interpolation=e.interpolation,(e.mosaicRule||e.definitionExpression)&&(a.mosaicRule=e.exportImageServiceParameters.mosaicRule.toJSON()),e.rasterFunction&&(a.renderingRule=e.rasterFunction.toJSON()),e.renderer&&(a.layerDefinition??={},a.layerDefinition.drawingInfo??={},a.layerDefinition.drawingInfo.renderer=e.renderer.toJSON()),Y(a,e),a}async function C(e,t,a){if("flow"===e.renderer?.type)return B(e,t,a);e.legendEnabled&&a.legendLayers.push({id:e.id});const i={bandIds:(r=ae(e)).bandIds,customParameters:r.customParameters,interpolation:r.interpolation,layerDefinition:r.layerDefinition};var r;return i.layerType="ArcGISImageServiceLayer",Y(i,e),i}async function A(e,t,a){const i=t.printTemplate;if(!e.portalItem||"public"===e.portalItem.access){const t=ae(e,"web-map");return t.type="kml",delete t.layerType,t.url=n.normalize(e.url),t}const r=[],o=t.layerView,s="data:image/png;base64,";o.allVisibleMapImages.forEach(((t,a)=>{const i={id:`${e.id}_image${a}`,type:"image",title:e.id,minScale:e.minScale||0,maxScale:e.maxScale||0,opacity:o.fullOpacity,extent:t.extent};t.href.startsWith(s)?i.imageData=t.href.slice(s.length):i.url=t.href,r.push(i)}));const l=[...o.allVisiblePoints.items,...o.allVisiblePolylines.items,...o.allVisiblePolygons.items],c={id:e.id,...await N(null,l,i,a)};return r.push(c),r}function z(e,{view:t},a){let i;const r={id:e.id,subLayerIds:[]};let n=[];const o=t.scale,s=e=>{const t=0===o,a=0===e.minScale||o<=e.minScale,i=0===e.maxScale||o>=e.maxScale;if(e.visible&&(t||a&&i))if(e.sublayers)e.sublayers.forEach(s);else{const t=e.toExportImageJSON(),a={id:e.id,name:e.title,layerDefinition:{drawingInfo:t.drawingInfo,definitionExpression:t.definitionExpression,source:t.source}};n.unshift(a),r.subLayerIds.push(e.id)}};var l;return e.sublayers&&e.sublayers.forEach(s),n.length&&(n=n.map((({id:e,name:t,layerDefinition:a})=>({id:e,name:t,layerDefinition:a}))),i={layerType:(l=ae(e)).layerType,customParameters:l.customParameters},i.layers=n,i.visibleLayers=e.capabilities?.exportMap?.supportsDynamicLayers?void 0:r.subLayerIds,e.gdbVersion&&(i.gdbVersion=e.gdbVersion),Y(i,e),e.legendEnabled&&a.legendLayers.push(r)),i}async function _({layerView:e,printTemplate:t},a){const i=[],r=e.layer;if(null!=r.featureCollections)for(const n of r.featureCollections){const e=await N(n,n.source,t,a);e&&i.push(...e.featureCollection.layers)}else if(null!=r.sublayers)for(const n of r.sublayers){const e=await N(null,n.graphics,t,a);e&&i.push(...e.featureCollection.layers)}return{featureCollection:{layers:i}}}function $(){return{type:"OpenStreetMap"}}async function B(e,{printTemplate:t,view:a},i){const o={type:"image"},s={format:"png",ignoreBackground:!0,ignorePadding:!0,layers:[e]};0!==a.rotation&&(s.rotation=0);const l=i.ssExtent||a.state.extent.clone();let c=96,u=!0,y=!0;if(t.exportOptions){const e=t.exportOptions;null!=e.dpi&&e.dpi>0&&(c=e.dpi),null!=e.width&&e.width>0&&(u=e.width%2==a.width%2),null!=e.height&&e.height>0&&(y=e.height%2==a.height%2)}if("map-only"===t.layout&&t.scalePreserved&&(!t.outScale||t.outScale===a.scale)&&96===c&&(!u||!y)&&a.state.extent.equals(a.extent)&&(s.area={x:0,y:0,width:a.width,height:a.height},u||(s.area.width-=1),y||(s.area.height-=1),!i.ssExtent)){const e=a.toMap(r.createScreenPoint(s.area.width,s.area.height));l.ymin=e.y,l.xmax=e.x,i.ssExtent=l}o.extent=l.clone()._normalize(!0).toJSON();const p=await a.takeScreenshot(s);return o.imageData=n.dataComponents(p.dataUrl)?.data,o}async function q(e,{layerView:t,printTemplate:a},i){e.legendEnabled&&i.legendLayers.push({id:e.id});return N(e,await te(t),a,i)}async function j(e,t){if(e.legendEnabled)for(const r of e.sublayers)r.legendEnabled&&t.legendLayers.push({id:r.id});const a={customParameters:(i=ae(e)).customParameters,effect:i.effect,layerDefinition:i.layerDefinition,layerType:i.layerType,layers:i.layers,url:i.url};var i;if(Array.isArray(a.layers))for(const r of a.layers)delete r.popupInfo;return Y(a,e),a}async function K(e){const t=[],a=[];for(const r of e.map.allTables)"feature"!==r.type||r.loaded||a.push(r.load());a.length&&await Promise.allSettled(a);for(const r of e.map.allTables)if("feature"===r.type&&r.loaded&&r.isTable&&"feature-layer"===r.source?.type){const e={id:(i=ae(r)).id,title:i.title,customParameters:i.customParameters,layerDefinition:{definitionExpression:i.layerDefinition?.definitionExpression},url:i.url};Y(e,r),t.push(e)}var i;return t.length?t:void 0}function W(e,t){e.legendEnabled&&t.legendLayers.push({id:e.id});const a={layerType:(i=ae(e)).layerType,customParameters:i.customParameters};var i;return Y(a,e),a}async function G(e,t,a){const i=t.layerView;if(e.serviceUrl&&e.styleUrl&&!i.spriteSourceChanged&&!i.styleChanged){const t=u.getToken(e.styleUrl,e.apiKey),i=u.getToken(e.serviceUrl,e.apiKey);if(!t&&!i||"2.1.0"!==a.cimVersion){const a={type:"VectorTileLayer"};return a.styleUrl=n.normalize(e.styleUrl),a.token=t,i!==t&&(a.additionalTokens=[{url:e.serviceUrl,token:i}]),a}}return B(e,t,a)}function H(e){const t=e.urlTemplate?.replace(/\${/g,"{"),a={type:"WebTiledLayer",urlTemplate:t,credits:e.copyright};return e.subDomains&&e.subDomains.length>0&&(a.subDomains=e.subDomains),a}function Q(e,t){let a;const i=[],r=e=>{e.visible&&(e.sublayers?e.sublayers.forEach(r):e.name&&i.unshift(e.name))};return e.sublayers&&e.sublayers.forEach(r),i.length&&(e.legendEnabled&&t.legendLayers.push({id:e.id,subLayerIds:i}),a={type:"wms",customLayerParameters:e.customLayerParameters,customParameters:e.customParameters,transparentBackground:e.imageTransparency,visibleLayers:i,url:n.normalize(e.url),version:e.version}),a}function X(e){const t=e.activeLayer;return{type:"wmts",customLayerParameters:e.customLayerParameters,customParameters:e.customParameters,format:t.imageFormat,layer:t.id,style:t.styleId,tileMatrixSet:t.tileMatrixSetId,url:n.normalize(e.url)}}function Y(e,t){t.url&&(e.url=n.normalize(e.url||t.url),e.token=u.getToken(e.url,t.apiKey))}async function Z(e,t){t.canvas||(t.canvas=document.createElement("canvas"));const i=1024;t.canvas.width=i,t.canvas.height=i;const n=t.canvas.getContext("2d");let o,s;if(e.path){const t=new Path2D(e.path);t.closePath(),n.fillStyle=Array.isArray(e.color)?`rgba(${e.color[0]},${e.color[1]},${e.color[2]},${e.color[3]/255})`:"rgb(0,0,0)",n.fill(t);const a=m.getContextBoundingBox(n);if(!a)return null;n.clearRect(0,0,i,i);const l=r.pt2px(e.size)/Math.max(a.width,a.height);n.scale(l,l);const c=i/l,u=c/2-a.width/2-a.x,y=c/2-a.height/2-a.y;if(n.translate(u,y),Array.isArray(e.color)&&n.fill(t),e.outline?.width&&Array.isArray(e.outline.color)){const i=e.outline;n.lineWidth=r.pt2px(i.width)/l,n.lineJoin="round",n.strokeStyle=`rgba(${i.color[0]},${i.color[1]},${i.color[2]},${i.color[3]/255})`,n.stroke(t),a.width+=n.lineWidth,a.height+=n.lineWidth}a.width*=l,a.height*=l;const p=n.getImageData(i/2-a.width/2,i/2-a.height/2,Math.ceil(a.width),Math.ceil(a.height));o=p.width,s=p.height,n.canvas.width=o,n.canvas.height=s,n.putImageData(p,0,0)}else{const t="image/svg+xml"===e.contentType?"data:image/svg+xml;base64,"+e.imageData:e.url,i=(await a(t,{responseType:"image"})).data;o=r.pt2px(e.width),s=r.pt2px(e.height),n.canvas.width=o,n.canvas.height=s,n.drawImage(i,0,0,n.canvas.width,n.canvas.height)}return{type:"esriPMS",imageData:n.canvas.toDataURL("image/png").slice(22),angle:e.angle,contentType:"image/png",height:r.px2pt(s),width:r.px2pt(o),xoffset:e.xoffset,yoffset:e.yoffset}}async function ee(e,t){const a=e.type;if("simple"===a&&re(e.symbol))e.symbol=await Z(e.symbol,t);else if("uniqueValue"===a||"classBreaks"===a){re(e.defaultSymbol)&&(e.defaultSymbol=await Z(e.defaultSymbol,t));const i=e["uniqueValue"===a?"uniqueValueInfos":"classBreakInfos"];if(i)for(const e of i)re(e.symbol)&&(e.symbol=await Z(e.symbol,t))}}async function te(e){return e.queryFeatures(e.createQuery()).then((e=>e.features))}function ae(e,t){return e.write({},{ignorePersistenceEnabled:!0,origin:t})??{}}function ie(e){return e.gpMetadata?.executionType?S.fromJSON(e.gpMetadata.executionType):"sync"}function re(e){return e&&(e.path||"image/svg+xml"===e.contentType||e.url?.endsWith(".svg"))}e.execute=v,e.getGpPrintParams=T,e.getGpServerUrl=P,e.getMode=D,e.getTasks=L,e.printCacheMap=x,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
