/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../geometry","../../Graphic","../../core/jsonMap","../../core/JSONSupport","../../core/lang","../../core/accessorSupport/decorators/property","../../core/has","../../core/Logger","../../core/accessorSupport/decorators/reader","../../core/accessorSupport/decorators/subclass","../../core/accessorSupport/decorators/writer","../../geometry/SpatialReference","../../geometry/support/jsonUtils","../../layers/support/Field"],(function(e,t,r,o,n,s,i,l,a,p,c,y,u,f,m){"use strict";var h;const d=new o.JSONMap({esriGeometryPoint:"point",esriGeometryMultipoint:"multipoint",esriGeometryPolyline:"polyline",esriGeometryPolygon:"polygon",esriGeometryEnvelope:"extent",mesh:"mesh","":null});let g=h=class extends n.JSONSupport{constructor(e){super(e),this.displayFieldName=null,this.exceededTransferLimit=!1,this.features=[],this.fields=null,this.geometryType=null,this.hasM=!1,this.hasZ=!1,this.queryGeometry=null,this.spatialReference=null}readFeatures(e,t){const o=u.fromJSON(t.spatialReference),n=[];for(let s=0;s<e.length;s++){const t=e[s],i=r.fromJSON(t),l=t.geometry?.spatialReference;null==i.geometry||l||(i.geometry.spatialReference=o);const a=t.aggregateGeometries,p=i.aggregateGeometries;if(a&&null!=p)for(const e in p){const t=p[e],r=a[e],n=r?.spatialReference;null==t||n||(t.spatialReference=o)}n.push(i)}return n}writeGeometryType(e,t,r,o){if(e)return void d.write(e,t,r,o);const{features:n}=this;if(n)for(const s of n)if(null!=s?.geometry)return void d.write(s.geometry.type,t,r,o)}readQueryGeometry(e,t){if(!e)return null;const r=!!e.spatialReference,o=f.fromJSON(e);return o&&!r&&t.spatialReference&&(o.spatialReference=u.fromJSON(t.spatialReference)),o}writeSpatialReference(e,t){if(e)return void(t.spatialReference=e.toJSON());const{features:r}=this;if(r)for(const o of r)if(o&&null!=o.geometry&&o.geometry.spatialReference)return void(t.spatialReference=o.geometry.spatialReference.toJSON())}clone(){return new h(this.cloneProperties())}cloneProperties(){return s.clone({displayFieldName:this.displayFieldName,exceededTransferLimit:this.exceededTransferLimit,features:this.features,fields:this.fields,geometryType:this.geometryType,hasM:this.hasM,hasZ:this.hasZ,queryGeometry:this.queryGeometry,spatialReference:this.spatialReference,transform:this.transform})}toJSON(e){const t=this.write();if(t.features&&Array.isArray(e)&&e.length>0)for(let r=0;r<t.features.length;r++){const o=t.features[r];if(o.geometry){const t=e?.[r];o.geometry=t?.toJSON()||o.geometry}}return t}quantize(e){const{scale:[t,r],translate:[o,n]}=e,s=e=>Math.round((e-o)/t),i=e=>Math.round((n-e)/r),l=this.features,a=this._getQuantizationFunction(this.geometryType,s,i);for(let p=0,c=l.length;p<c;p++)a?.(l[p].geometry)||(l.splice(p,1),p--,c--);return this.transform=e,this}unquantize(){const{geometryType:e,features:t,transform:r}=this;if(!r)return this;const{translate:[o,n],scale:[s,i]}=r,l=e=>e*s+o,a=e=>n-e*i;let p=null,c=null;if(this.hasZ&&null!=r?.scale?.[2]){const{translate:[,,e],scale:[,,t]}=r;p=r=>r*t+e}if(this.hasM&&null!=r?.scale?.[3]){const{translate:[,,,e],scale:[,,,t]}=r;c=r=>null==r?r:r*t+e}const y=this._getHydrationFunction(e,l,a,p,c);for(const{geometry:u}of t)null!=u&&y&&y(u);return this.transform=null,this}_quantizePoints(e,t,r){let o,n;const s=[];for(let i=0,l=e.length;i<l;i++){const l=e[i];if(i>0){const e=t(l[0]),i=r(l[1]);e===o&&i===n||(s.push([e-o,i-n]),o=e,n=i)}else o=t(l[0]),n=r(l[1]),s.push([o,n])}return s.length>0?s:null}_getQuantizationFunction(e,t,r){return"point"===e?e=>(e.x=t(e.x),e.y=r(e.y),e):"polyline"===e||"polygon"===e?e=>{const o=f.isPolygon(e)?e.rings:e.paths,n=[];for(let s=0,i=o.length;s<i;s++){const e=o[s],i=this._quantizePoints(e,t,r);i&&n.push(i)}return n.length>0?(f.isPolygon(e)?e.rings=n:e.paths=n,e):null}:"multipoint"===e?e=>{const o=this._quantizePoints(e.points,t,r);return o&&o.length>0?(e.points=o,e):null}:"extent"===e?e=>e:null}_getHydrationFunction(e,t,r,o,n){return"point"===e?e=>{e.x=t(e.x),e.y=r(e.y),o&&(e.z=o(e.z))}:"polyline"===e||"polygon"===e?e=>{const s=f.isPolygon(e)?e.rings:e.paths;let i,l;for(let o=0,n=s.length;o<n;o++){const e=s[o];for(let o=0,n=e.length;o<n;o++){const n=e[o];o>0?(i+=n[0],l+=n[1]):(i=n[0],l=n[1]),n[0]=t(i),n[1]=r(l)}}if(o&&n)for(let t=0,r=s.length;t<r;t++){const e=s[t];for(let t=0,r=e.length;t<r;t++){const r=e[t];r[2]=o(r[2]),r[3]=n(r[3])}}else if(o)for(let t=0,r=s.length;t<r;t++){const e=s[t];for(let t=0,r=e.length;t<r;t++){const r=e[t];r[2]=o(r[2])}}else if(n)for(let t=0,r=s.length;t<r;t++){const e=s[t];for(let t=0,r=e.length;t<r;t++){const r=e[t];r[2]=n(r[2])}}}:"extent"===e?e=>{e.xmin=t(e.xmin),e.ymin=r(e.ymin),e.xmax=t(e.xmax),e.ymax=r(e.ymax),o&&null!=e.zmax&&null!=e.zmin&&(e.zmax=o(e.zmax),e.zmin=o(e.zmin)),n&&null!=e.mmax&&null!=e.mmin&&(e.mmax=n(e.mmax),e.mmin=n(e.mmin))}:"multipoint"===e?e=>{const s=e.points;let i,l;for(let o=0,n=s.length;o<n;o++){const e=s[o];o>0?(i+=e[0],l+=e[1]):(i=e[0],l=e[1]),e[0]=t(i),e[1]=r(l)}if(o&&n)for(let t=0,r=s.length;t<r;t++){const e=s[t];e[2]=o(e[2]),e[3]=n(e[3])}else if(o)for(let t=0,r=s.length;t<r;t++){const e=s[t];e[2]=o(e[2])}else if(n)for(let t=0,r=s.length;t<r;t++){const e=s[t];e[2]=n(e[2])}}:null}};e.__decorate([i.property({type:String,json:{write:!0}})],g.prototype,"displayFieldName",void 0),e.__decorate([i.property({type:Boolean,json:{write:{overridePolicy:e=>({enabled:e})}}})],g.prototype,"exceededTransferLimit",void 0),e.__decorate([i.property({type:[r],json:{write:!0}})],g.prototype,"features",void 0),e.__decorate([p.reader("features")],g.prototype,"readFeatures",null),e.__decorate([i.property({type:[m],json:{write:!0}})],g.prototype,"fields",void 0),e.__decorate([i.property({type:["point","multipoint","polyline","polygon","extent","mesh"],json:{read:{reader:d.read}}})],g.prototype,"geometryType",void 0),e.__decorate([y.writer("geometryType")],g.prototype,"writeGeometryType",null),e.__decorate([i.property({type:Boolean,json:{write:{overridePolicy:e=>({enabled:e})}}})],g.prototype,"hasM",void 0),e.__decorate([i.property({type:Boolean,json:{write:{overridePolicy:e=>({enabled:e})}}})],g.prototype,"hasZ",void 0),e.__decorate([i.property({types:t.geometryTypes,json:{write:!0}})],g.prototype,"queryGeometry",void 0),e.__decorate([p.reader("queryGeometry")],g.prototype,"readQueryGeometry",null),e.__decorate([i.property({type:u,json:{write:!0}})],g.prototype,"spatialReference",void 0),e.__decorate([y.writer("spatialReference")],g.prototype,"writeSpatialReference",null),e.__decorate([i.property({json:{write:!0}})],g.prototype,"transform",void 0),g=h=e.__decorate([c.subclass("esri.rest.support.FeatureSet")],g),g.prototype.toJSON.isDefaultToJSON=!0;return g}));
