/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../../chunks/tslib.es6","../../request","../../core/has","../../core/jsonMap","../../core/JSONSupport","../../core/promiseUtils","../../core/accessorSupport/decorators/property","../../core/Logger","../../core/RandomLCG","../../core/accessorSupport/decorators/enumeration","../../core/accessorSupport/decorators/subclass","../utils","../geoprocessor/GPOptions","../geoprocessor/utils","./GPMessage"],(function(e,t,o,r,s,a,i,c,n,l,b,u,p,d,h,m){"use strict";const j=e=>Object.freeze(Object.defineProperty({__proto__:null,default:e},Symbol.toStringTag,{value:"Module"}));var g;const _=s.strict()({esriJobCancelled:"job-cancelled",esriJobCancelling:"job-cancelling",esriJobDeleted:"job-deleted",esriJobDeleting:"job-deleting",esriJobTimedOut:"job-timed-out",esriJobExecuting:"job-executing",esriJobFailed:"job-failed",esriJobNew:"job-new",esriJobSubmitted:"job-submitted",esriJobSucceeded:"job-succeeded",esriJobWaiting:"job-waiting"},{ignoreUnknown:!1}),J=1e3;let y=g=class extends a.JSONSupport{constructor(e){super(e),this.jobId=null,this.jobStatus=null,this.messages=null,this.progress=null,this.requestOptions=null,this.sourceUrl=null,this._cancelJobTimer=void 0,this._jobCompletionTimer=void 0}async cancelJob(e){const{jobId:t,sourceUrl:r}=this,{path:s}=p.parseUrl(r),a={...this.requestOptions,...e,query:{f:"json"}},c=`${s}/jobs/${t}/cancel`,{data:n}=await o(c,a),{messages:l,jobStatus:b,progress:u}=g.fromJSON(n);return this.set({messages:l,jobStatus:b,progress:u}),"job-cancelled"===b?this:new Promise(((t,o)=>{i.onAbort(a.signal,(()=>{this._clearCancelJobTimer(),o(i.createAbortError())})),this._clearCancelJobTimer(),this._cancelJobTimer=setInterval((()=>{this._cancelJobTimer||o(i.createAbortError()),this.checkJobStatus(e).then((({jobStatus:e})=>{switch(e){case"job-cancelling":break;case"job-deleted":case"job-deleting":case"job-executing":case"job-failed":case"job-new":case"job-submitted":case"job-succeeded":case"job-timed-out":case"job-waiting":this._clearCancelJobTimer(),o(this);break;case"job-cancelled":this._clearCancelJobTimer(),t(this)}}))}),J)}))}destroy(){clearInterval(this._cancelJobTimer),clearInterval(this._jobCompletionTimer)}async checkJobStatus(e){const{path:t}=p.parseUrl(this.sourceUrl),r={...this.requestOptions,...e,query:{f:"json"}},s=`${t}/jobs/${this.jobId}`,{data:a}=await o(s,r),{messages:i,jobStatus:c,progress:n}=g.fromJSON(a);return this.set({messages:i,jobStatus:c,progress:n}),this}async fetchResultData(e,t,r){t=d.from(t||{});const{returnColumnName:s,returnFeatureCollection:a,returnM:i,returnZ:c,outSpatialReference:n}=t,{path:l}=p.parseUrl(this.sourceUrl),b={returnColumnName:s||null,returnFeatureCollection:a||null,returnM:i||null,returnZ:c||null,outSR:n,returnType:"data",f:"json"},u=h.gpEncode(b,null),m={...this.requestOptions,...r,query:u},j=`${l}/jobs/${this.jobId}/results/${e}`,{data:g}=await o(j,m);return h.decode(g)}async fetchResultImage(e,t,r){const{path:s}=p.parseUrl(this.sourceUrl),a={...t.toJSON(),f:"json"},i=h.gpEncode(a),c={...this.requestOptions,...r,query:i},n=`${s}/jobs/${this.jobId}/results/${e}`,{data:l}=await o(n,c);return h.decode(l)}async fetchResultMapImageLayer(){const{path:t}=p.parseUrl(this.sourceUrl),o=t.indexOf("/GPServer/"),r=`${t.slice(0,Math.max(0,o))}/MapServer/jobs/${this.jobId}`;return new(0,(await new Promise(((t,o)=>e(["../../layers/MapImageLayer"],(e=>t(j(e))),o)))).default)({url:r})}async waitForJobCompletion(e={}){const{interval:t=J,signal:o,statusCallback:r}=e;return new Promise(((e,s)=>{i.onAbort(o,(()=>{this._clearJobCompletionTimer(),s(i.createAbortError())})),this._clearJobCompletionTimer(),this._jobCompletionTimer=setInterval((()=>{this._jobCompletionTimer||s(i.createAbortError()),this.checkJobStatus().then((({jobStatus:t})=>{switch(t){case"job-succeeded":this._clearJobCompletionTimer(),e(this);break;case"job-executing":case"job-new":case"job-submitted":case"job-waiting":r&&r(this);break;case"job-cancelled":case"job-cancelling":case"job-deleted":case"job-deleting":case"job-failed":case"job-timed-out":this._clearJobCompletionTimer(),s(this)}})).catch((e=>{this._clearJobCompletionTimer(),s(e)}))}),t)}))}_clearCancelJobTimer(){clearInterval(this._cancelJobTimer),this._cancelJobTimer=void 0}_clearJobCompletionTimer(){clearInterval(this._jobCompletionTimer),this._jobCompletionTimer=void 0}};t.__decorate([c.property()],y.prototype,"jobId",void 0),t.__decorate([b.enumeration(_,{ignoreUnknown:!1})],y.prototype,"jobStatus",void 0),t.__decorate([c.property({type:[m]})],y.prototype,"messages",void 0),t.__decorate([c.property()],y.prototype,"progress",void 0),t.__decorate([c.property()],y.prototype,"requestOptions",void 0),t.__decorate([c.property({json:{write:!0}})],y.prototype,"sourceUrl",void 0),y=g=t.__decorate([u.subclass("esri.rest.support.JobInfo")],y);return y}));
