/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../Graphic","../../PopupTemplate","../../symbols","../../core/Clonable","../../core/JSONSupport","../../core/accessorSupport/decorators/property","../../core/has","../../core/Logger","../../core/RandomLCG","../../core/accessorSupport/decorators/reader","../../core/accessorSupport/decorators/subclass","../../geometry/Polyline","../route/utils","./RouteSettings"],(function(t,e,r,a,s,o,i,l,n,p,u,d,T,y,m){"use strict";var c;let b=c=class extends(s.ClonableMixin(o.JSONSupport)){constructor(t){super(t),this.analysisSettings=null,this.endTime=null,this.endTimeOffset=null,this.firstStopId=null,this.geometry=null,this.lastStopId=null,this.messages=null,this.name=null,this.objectId=null,this.popupTemplate=null,this.startTime=null,this.startTimeOffset=null,this.stopCount=null,this.symbol=null,this.totalCosts=null,this.totalDistance=null,this.totalDuration=null,this.totalLateDuration=null,this.totalViolations=null,this.totalWait=null,this.totalWaitDuration=null,this.type="route-info",this.version="1.0.0"}readEndTime(t,e){return null!=e.attributes.EndTimeUTC?new Date(e.attributes.EndTimeUTC):null}readEndTimeOffset(t,e){return y.getTimezoneOffset(e.attributes.EndTime,e.attributes.EndTimeUTC)}readStartTime(t,e){return null!=e.attributes.StartTimeUTC?new Date(e.attributes.StartTimeUTC):null}readStartTimeOffset(t,e){return y.getTimezoneOffset(e.attributes.StartTime,e.attributes.StartTimeUTC)}readTotalCosts(t,e){return y.getPrefixedProperties(e.attributes,"Total_")}readTotalViolations(t,e){return y.getPrefixedProperties(e.attributes,"TotalViolation_")}readTotalWait(t,e){return y.getPrefixedProperties(e.attributes,"TotalWait_")}static fromGraphic(t){return new c({analysisSettings:null!=t.attributes.AnalysisSettings?m.fromJSON(JSON.parse(t.attributes.AnalysisSettings)):null,endTime:null!=t.attributes.EndTime?new Date(t.attributes.EndTime):null,endTimeOffset:t.attributes.EndUTCOffset??null,geometry:t.geometry,messages:null!=t.attributes.Messages?JSON.parse(t.attributes.Messages):null,name:t.attributes.RouteName,objectId:t.attributes.ObjectID??t.attributes.__OBJECTID,popupTemplate:t.popupTemplate,startTime:null!=t.attributes.StartTime?new Date(t.attributes.StartTime):null,startTimeOffset:t.attributes.StartUTCOffset??null,symbol:t.symbol,totalCosts:null!=t.attributes.TotalCosts?y.toKebabImpedanceAttributes(JSON.parse(t.attributes.TotalCosts)):null,totalDistance:t.attributes.TotalMeters??null,totalDuration:t.attributes.TotalMinutes??null,totalLateDuration:t.attributes.TotalLateMinutes??null,totalWaitDuration:t.attributes.TotalWaitMinutes??null,version:t.attributes.Version})}toGraphic(){const t={ObjectID:this.objectId,AnalysisSettings:null!=this.analysisSettings?JSON.stringify(this.analysisSettings.toJSON()):null,EndTime:null!=this.endTime?this.endTime.getTime():null,EndUTCOffset:this.endTimeOffset,Messages:null!=this.messages?JSON.stringify(this.messages):null,RouteName:this.name,StartTime:null!=this.startTime?this.startTime.getTime():null,StartUTCOffset:this.startTimeOffset,TotalCosts:null!=this.totalCosts?JSON.stringify(y.fromKebabImpedanceAttributes(this.totalCosts)):null,TotalLateMinutes:this.totalLateDuration,TotalMeters:this.totalDistance,TotalMinutes:this.totalDuration,TotalWaitMinutes:this.totalWaitDuration,Version:this.version};return new e({geometry:this.geometry,attributes:t,symbol:this.symbol,popupTemplate:this.popupTemplate})}};b.fields=[{name:"ObjectID",alias:"ObjectID",type:"esriFieldTypeOID"},{name:"AnalysisSettings",alias:"Analysis Settings",type:"esriFieldTypeString"},{name:"EndTime",alias:"End Time",type:"esriFieldTypeDate"},{name:"EndUTCOffset",alias:"End Time Offset",type:"esriFieldTypeInteger"},{name:"Messages",alias:"Messages",type:"esriFieldTypeString"},{name:"RouteName",alias:"Route Name",type:"esriFieldTypeString"},{name:"StartTime",alias:"Start Time",type:"esriFieldTypeDate"},{name:"StartUTCOffset",alias:"Start Time Offset",type:"esriFieldTypeInteger"},{name:"TotalCosts",alias:"Total Costs",type:"esriFieldTypeString"},{name:"TotalLateMinutes",alias:"Total Late Minutes",type:"esriFieldTypeDouble"},{name:"TotalMeters",alias:"Total Meters",type:"esriFieldTypeDouble"},{name:"TotalMinutes",alias:"Total Minutes",type:"esriFieldTypeDouble"},{name:"TotalWaitMinutes",alias:"Total Wait Minutes",type:"esriFieldTypeDouble"},{name:"Version",alias:"Version",type:"esriFieldTypeString"}],t.__decorate([i.property()],b.prototype,"analysisSettings",void 0),t.__decorate([i.property()],b.prototype,"endTime",void 0),t.__decorate([u.reader("endTime",["attributes.EndTimeUTC"])],b.prototype,"readEndTime",null),t.__decorate([i.property()],b.prototype,"endTimeOffset",void 0),t.__decorate([u.reader("endTimeOffset",["attributes.EndTime","attributes.EndTimeUTC"])],b.prototype,"readEndTimeOffset",null),t.__decorate([i.property({json:{read:{source:"attributes.FirstStopID"}}})],b.prototype,"firstStopId",void 0),t.__decorate([i.property({type:T})],b.prototype,"geometry",void 0),t.__decorate([i.property({json:{read:{source:"attributes.LastStopID"}}})],b.prototype,"lastStopId",void 0),t.__decorate([i.property()],b.prototype,"messages",void 0),t.__decorate([i.property({json:{read:{source:"attributes.Name"}}})],b.prototype,"name",void 0),t.__decorate([i.property({json:{read:{source:"attributes.ObjectID"}}})],b.prototype,"objectId",void 0),t.__decorate([i.property({type:r})],b.prototype,"popupTemplate",void 0),t.__decorate([i.property()],b.prototype,"startTime",void 0),t.__decorate([u.reader("startTime",["attributes.StartTimeUTC"])],b.prototype,"readStartTime",null),t.__decorate([i.property()],b.prototype,"startTimeOffset",void 0),t.__decorate([u.reader("startTimeOffset",["attributes.StartTime","attributes.StartTimeUTC"])],b.prototype,"readStartTimeOffset",null),t.__decorate([i.property({json:{read:{source:"attributes.StopCount"}}})],b.prototype,"stopCount",void 0),t.__decorate([i.property({types:a.symbolTypes})],b.prototype,"symbol",void 0),t.__decorate([i.property()],b.prototype,"totalCosts",void 0),t.__decorate([u.reader("totalCosts",["attributes"])],b.prototype,"readTotalCosts",null),t.__decorate([i.property()],b.prototype,"totalDistance",void 0),t.__decorate([i.property()],b.prototype,"totalDuration",void 0),t.__decorate([i.property()],b.prototype,"totalLateDuration",void 0),t.__decorate([i.property()],b.prototype,"totalViolations",void 0),t.__decorate([u.reader("totalViolations",["attributes"])],b.prototype,"readTotalViolations",null),t.__decorate([i.property()],b.prototype,"totalWait",void 0),t.__decorate([u.reader("totalWait",["attributes"])],b.prototype,"readTotalWait",null),t.__decorate([i.property()],b.prototype,"totalWaitDuration",void 0),t.__decorate([i.property({readOnly:!0,json:{read:!1}})],b.prototype,"type",void 0),t.__decorate([i.property()],b.prototype,"version",void 0),b=c=t.__decorate([d.subclass("esri.rest.support.RouteInfo")],b);return b}));
