/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../Graphic","../../PopupTemplate","../../symbols","../../core/Clonable","../../core/JSONSupport","../../core/accessorSupport/decorators/property","../../core/has","../../core/Logger","../../core/RandomLCG","../../core/accessorSupport/decorators/reader","../../core/accessorSupport/decorators/subclass","../../core/accessorSupport/decorators/writer","../../geometry/Point","../route/utils","./networkEnums"],(function(e,t,r,i,a,o,s,p,u,n,l,d,c,m,y,b){"use strict";var T;let v=T=class extends(a.ClonableMixin(o.JSONSupport)){constructor(e){super(e),this.arriveCurbApproach=null,this.arriveTime=null,this.arriveTimeOffset=null,this.bearing=null,this.bearingTol=null,this.cumulativeCosts=null,this.cumulativeDistance=null,this.cumulativeDuration=null,this.curbApproach=null,this.departCurbApproach=null,this.departTime=null,this.departTimeOffset=null,this.distanceToNetworkInMeters=null,this.geometry=null,this.lateDuration=null,this.locationType=null,this.name=null,this.navLatency=null,this.objectId=null,this.popupTemplate=null,this.posAlong=null,this.routeName=null,this.serviceCosts=null,this.serviceDistance=null,this.serviceDuration=null,this.sequence=null,this.sideOfEdge=null,this.snapX=null,this.snapY=null,this.snapZ=null,this.sourceId=null,this.sourceOid=null,this.status=null,this.symbol=null,this.timeWindowEnd=null,this.timeWindowEndOffset=null,this.timeWindowStart=null,this.timeWindowStartOffset=null,this.type="stop",this.violations=null,this.waitDuration=null,this.wait=null}readArriveTimeOffset(e,t){return y.getTimezoneOffset(t.attributes.ArriveTime,t.attributes.ArriveTimeUTC)}readCumulativeCosts(e,t){return y.getPrefixedProperties(t.attributes,"Cumul_")}readDepartTimeOffset(e,t){return y.getTimezoneOffset(t.attributes.DepartTime,t.attributes.DepartTimeUTC)}readServiceCosts(e,t){return y.getPrefixedProperties(t.attributes,"Attr_")}writeServiceCosts(e,t){y.setPrefixedProperties(e,t,"Attr_")}writeTimeWindowEnd(e,t){null!=e&&(t.attributes||(t.attributes={}),t.attributes.TimeWindowEnd=e.getTime())}writeTimeWindowStart(e,t){null!=e&&(t.attributes||(t.attributes={}),t.attributes.TimeWindowStart=e.getTime())}readViolations(e,t){return y.getPrefixedProperties(t.attributes,"Violation_")}readWait(e,t){return y.getPrefixedProperties(t.attributes,"Wait_")}static fromGraphic(e){return new T({arriveCurbApproach:null!=e.attributes.ArrivalCurbApproach?b.curbApproachJsonMap.fromJSON(e.attributes.ArrivalCurbApproach):null,arriveTime:null!=e.attributes.ArrivalTime?new Date(e.attributes.ArrivalTime):null,arriveTimeOffset:e.attributes.ArrivalUTCOffset,cumulativeCosts:null!=e.attributes.CumulativeCosts?y.toKebabImpedanceAttributes(JSON.parse(e.attributes.CumulativeCosts)):null,cumulativeDistance:e.attributes.CumulativeMeters??null,cumulativeDuration:e.attributes.CumulativeMinutes??null,curbApproach:null!=e.attributes.CurbApproach?b.curbApproachJsonMap.fromJSON(e.attributes.CurbApproach):null,departCurbApproach:null!=e.attributes.DepartureCurbApproach?b.curbApproachJsonMap.fromJSON(e.attributes.DepartureCurbApproach):null,departTime:null!=e.attributes.DepartureTime?new Date(e.attributes.DepartureTime):null,departTimeOffset:e.attributes.DepartureUTCOffset??null,geometry:e.geometry,lateDuration:e.attributes.LateMinutes??null,locationType:null!=e.attributes.LocationType?b.locationTypeJsonMap.fromJSON(e.attributes.LocationType):null,name:e.attributes.Name,objectId:e.attributes.ObjectID??e.attributes.__OBJECTID,popupTemplate:e.popupTemplate,routeName:e.attributes.RouteName,sequence:e.attributes.Sequence??null,serviceCosts:null!=e.attributes.ServiceCosts?y.toKebabImpedanceAttributes(JSON.parse(e.attributes.ServiceCosts)):null,serviceDistance:e.attributes.ServiceMeters??null,serviceDuration:e.attributes.ServiceMinutes??null,status:null!=e.attributes.Status?b.statusJsonMap.fromJSON(e.attributes.Status):null,symbol:e.symbol,timeWindowEnd:null!=e.attributes.TimeWindowEnd?new Date(e.attributes.TimeWindowEnd):null,timeWindowEndOffset:e.attributes.TimeWindowEndUTCOffset??null,timeWindowStart:null!=e.attributes.TimeWindowStart?new Date(e.attributes.TimeWindowStart):null,timeWindowStartOffset:e.attributes.TimeWindowStartUTCOffset??null,waitDuration:e.attributes.WaitMinutes??null})}toGraphic(){const e={ObjectID:this.objectId,ArrivalCurbApproach:null!=this.arriveCurbApproach?b.curbApproachJsonMap.toJSON(this.arriveCurbApproach):null,ArrivalTime:null!=this.arriveTime?this.arriveTime.getTime():null,ArrivalUTCOffset:this.arriveTimeOffset,CumulativeCosts:null!=this.cumulativeCosts?JSON.stringify(y.fromKebabImpedanceAttributes(this.cumulativeCosts)):null,CumulativeMeters:this.cumulativeDistance,CumulativeMinutes:this.cumulativeDuration,CurbApproach:null!=this.curbApproach?b.curbApproachJsonMap.toJSON(this.curbApproach):null,DepartureCurbApproach:null!=this.departCurbApproach?b.curbApproachJsonMap.toJSON(this.departCurbApproach):null,DepartureTime:null!=this.departTime?this.departTime.getTime():null,DepartureUTCOffset:this.departTimeOffset,LateMinutes:this.lateDuration,LocationType:null!=this.locationType?b.locationTypeJsonMap.toJSON(this.locationType):null,Name:this.name,RouteName:this.routeName,Sequence:this.sequence,ServiceCosts:null!=this.serviceCosts?JSON.stringify(y.fromKebabImpedanceAttributes(this.serviceCosts)):null,ServiceMeters:this.serviceDistance,ServiceMinutes:this.serviceDuration,Status:null!=this.status?b.statusJsonMap.toJSON(this.status):null,TimeWindowEnd:null!=this.timeWindowEnd?this.timeWindowEnd.getTime():null,TimeWindowEndUTCOffset:this.timeWindowEndOffset??this.arriveTimeOffset,TimeWindowStart:null!=this.timeWindowStart?this.timeWindowStart.getTime():null,TimeWindowStartUTCOffset:this.timeWindowStartOffset??this.arriveTimeOffset,WaitMinutes:this.waitDuration};return new t({geometry:this.geometry,attributes:e,symbol:this.symbol,popupTemplate:this.popupTemplate})}};v.fields=[{name:"ObjectID",alias:"ObjectID",type:"esriFieldTypeOID"},{name:"ArrivalCurbApproach",alias:"Arrival Curb Approach",type:"esriFieldTypeInteger"},{name:"ArrivalTime",alias:"Arrival Time",type:"esriFieldTypeDate"},{name:"ArrivalUTCOffset",alias:"Arrival Time",type:"esriFieldTypeInteger"},{name:"CumulativeCosts",alias:"Cumulative Costs",type:"esriFieldTypeString"},{name:"CumulativeMeters",alias:"Cumulative Meters",type:"esriFieldTypeDouble"},{name:"CumulativeMinutes",alias:"Cumulative Minutes",type:"esriFieldTypeDouble"},{name:"CurbApproach",alias:"Curb Approach",type:"esriFieldTypeInteger"},{name:"DepartureCurbApproach",alias:"Departure Curb Approach",type:"esriFieldTypeInteger"},{name:"DepartureTime",alias:"Departure Time",type:"esriFieldTypeDate"},{name:"DepartureUTCOffset",alias:"Departure Time",type:"esriFieldTypeInteger"},{name:"LateMinutes",alias:"Minutes Late",type:"esriFieldTypeDouble"},{name:"LocationType",alias:"Location Type",type:"esriFieldTypeInteger"},{name:"Name",alias:"Name",type:"esriFieldTypeString"},{name:"RouteName",alias:"Route Name",type:"esriFieldTypeString"},{name:"Sequence",alias:"Sequence",type:"esriFieldTypeInteger"},{name:"ServiceCosts",alias:"Service Costs",type:"esriFieldTypeString"},{name:"ServiceMeters",alias:"Service Meters",type:"esriFieldTypeDouble"},{name:"ServiceMinutes",alias:"Service Minutes",type:"esriFieldTypeDouble"},{name:"Status",alias:"Status",type:"esriFieldTypeInteger"},{name:"TimeWindowEnd",alias:"Time Window End",type:"esriFieldTypeDate"},{name:"TimeWindowEndUTCOffset",alias:"Time Window End Offset",type:"esriFieldTypeInteger"},{name:"TimeWindowStart",alias:"Time Window Start",type:"esriFieldTypeDate"},{name:"TimeWindowStartUTCOffset",alias:"Time Window Start Offset",type:"esriFieldTypeInteger"},{name:"WaitMinutes",alias:"Minutes Wait",type:"esriFieldTypeDouble"}],e.__decorate([s.property({type:b.curbApproachJsonMap.apiValues,json:{read:{source:"attributes.ArrivalCurbApproach",reader:b.curbApproachJsonMap.read}}})],v.prototype,"arriveCurbApproach",void 0),e.__decorate([s.property({type:Date,json:{read:{source:"attributes.ArriveTimeUTC"}}})],v.prototype,"arriveTime",void 0),e.__decorate([s.property()],v.prototype,"arriveTimeOffset",void 0),e.__decorate([l.reader("arriveTimeOffset",["attributes.ArriveTime","attributes.ArriveTimeUTC"])],v.prototype,"readArriveTimeOffset",null),e.__decorate([s.property({json:{name:"attributes.Bearing",read:!1,write:!0}})],v.prototype,"bearing",void 0),e.__decorate([s.property({json:{name:"attributes.BearingTol",read:!1,write:!0}})],v.prototype,"bearingTol",void 0),e.__decorate([s.property()],v.prototype,"cumulativeCosts",void 0),e.__decorate([l.reader("cumulativeCosts",["attributes"])],v.prototype,"readCumulativeCosts",null),e.__decorate([s.property()],v.prototype,"cumulativeDistance",void 0),e.__decorate([s.property()],v.prototype,"cumulativeDuration",void 0),e.__decorate([s.property({type:b.curbApproachJsonMap.apiValues,json:{name:"attributes.CurbApproach",read:{reader:b.curbApproachJsonMap.read},write:{writer:b.curbApproachJsonMap.write}}})],v.prototype,"curbApproach",void 0),e.__decorate([s.property({type:b.curbApproachJsonMap.apiValues,json:{read:{source:"attributes.DepartCurbApproach",reader:b.curbApproachJsonMap.read}}})],v.prototype,"departCurbApproach",void 0),e.__decorate([s.property({type:Date,json:{read:{source:"attributes.DepartTimeUTC"}}})],v.prototype,"departTime",void 0),e.__decorate([s.property()],v.prototype,"departTimeOffset",void 0),e.__decorate([l.reader("departTimeOffset",["attributes.DepartTime","attributes.DepartTimeUTC"])],v.prototype,"readDepartTimeOffset",null),e.__decorate([s.property({json:{read:{source:"attributes.DistanceToNetworkInMeters"}}})],v.prototype,"distanceToNetworkInMeters",void 0),e.__decorate([s.property({type:m,json:{write:!0}})],v.prototype,"geometry",void 0),e.__decorate([s.property()],v.prototype,"lateDuration",void 0),e.__decorate([s.property({type:b.locationTypeJsonMap.apiValues,json:{name:"attributes.LocationType",read:{reader:b.locationTypeJsonMap.read},write:{writer:b.locationTypeJsonMap.write}}})],v.prototype,"locationType",void 0),e.__decorate([s.property({json:{name:"attributes.Name"}})],v.prototype,"name",void 0),e.__decorate([s.property({json:{name:"attributes.NavLatency",read:!1,write:!0}})],v.prototype,"navLatency",void 0),e.__decorate([s.property({json:{name:"attributes.ObjectID"}})],v.prototype,"objectId",void 0),e.__decorate([s.property({type:r})],v.prototype,"popupTemplate",void 0),e.__decorate([s.property({json:{read:{source:"attributes.PosAlong"}}})],v.prototype,"posAlong",void 0),e.__decorate([s.property({json:{name:"attributes.RouteName"}})],v.prototype,"routeName",void 0),e.__decorate([s.property()],v.prototype,"serviceCosts",void 0),e.__decorate([l.reader("serviceCosts",["attributes"])],v.prototype,"readServiceCosts",null),e.__decorate([c.writer("serviceCosts")],v.prototype,"writeServiceCosts",null),e.__decorate([s.property()],v.prototype,"serviceDistance",void 0),e.__decorate([s.property()],v.prototype,"serviceDuration",void 0),e.__decorate([s.property({json:{name:"attributes.Sequence"}})],v.prototype,"sequence",void 0),e.__decorate([s.property({type:b.sideOfEdgeJsonMap.apiValues,json:{read:{source:"attributes.SideOfEdge",reader:b.sideOfEdgeJsonMap.read}}})],v.prototype,"sideOfEdge",void 0),e.__decorate([s.property({json:{read:{source:"attributes.SnapX"}}})],v.prototype,"snapX",void 0),e.__decorate([s.property({json:{read:{source:"attributes.SnapY"}}})],v.prototype,"snapY",void 0),e.__decorate([s.property({json:{read:{source:"attributes.SnapZ"}}})],v.prototype,"snapZ",void 0),e.__decorate([s.property({json:{read:{source:"attributes.SourceID"}}})],v.prototype,"sourceId",void 0),e.__decorate([s.property({json:{read:{source:"attributes.SourceOID"}}})],v.prototype,"sourceOid",void 0),e.__decorate([s.property({type:b.statusJsonMap.apiValues,json:{read:{source:"attributes.Status",reader:b.statusJsonMap.read}}})],v.prototype,"status",void 0),e.__decorate([s.property({types:i.symbolTypes})],v.prototype,"symbol",void 0),e.__decorate([s.property({type:Date,json:{name:"attributes.TimeWindowEnd"}})],v.prototype,"timeWindowEnd",void 0),e.__decorate([c.writer("timeWindowEnd")],v.prototype,"writeTimeWindowEnd",null),e.__decorate([s.property()],v.prototype,"timeWindowEndOffset",void 0),e.__decorate([s.property({type:Date,json:{name:"attributes.TimeWindowStart"}})],v.prototype,"timeWindowStart",void 0),e.__decorate([c.writer("timeWindowStart")],v.prototype,"writeTimeWindowStart",null),e.__decorate([s.property()],v.prototype,"timeWindowStartOffset",void 0),e.__decorate([s.property({readOnly:!0,json:{read:!1}})],v.prototype,"type",void 0),e.__decorate([s.property()],v.prototype,"violations",void 0),e.__decorate([l.reader("violations",["attributes"])],v.prototype,"readViolations",null),e.__decorate([s.property()],v.prototype,"waitDuration",void 0),e.__decorate([s.property()],v.prototype,"wait",void 0),e.__decorate([l.reader("wait",["attributes"])],v.prototype,"readWait",null),v=T=e.__decorate([d.subclass("esri.rest.support.Stop")],v);return v}));
