/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../core/has","../../core/Error","../../core/screenUtils","../../geometry/support/scaleUtils","../../renderers/visualVariables/SizeVariable","../../renderers/visualVariables/support/SizeStop","./scaleRange","../support/binningUtils","../support/adapters/support/layerUtils"],(function(e,n,l,a,s,i,t,r,o){"use strict";const c=1e8,u=1128.497176,p=591657527.591555,v=[10,8,4,2],f=[100,100,60,30],w=[2,1,.75,.5],m=[32,18,12,6],g=[{level:0,resolution:156543.03392800014,scale:591657527.591555},{level:1,resolution:78271.51696399994,scale:295828763.795777},{level:2,resolution:39135.75848200009,scale:147914381.897889},{level:3,resolution:19567.87924099992,scale:73957190.948944},{level:4,resolution:9783.93962049996,scale:36978595.474472},{level:5,resolution:4891.96981024998,scale:18489297.737236},{level:6,resolution:2445.98490512499,scale:9244648.868618},{level:7,resolution:1222.992452562495,scale:4622324.434309},{level:8,resolution:611.4962262813797,scale:2311162.217155},{level:9,resolution:305.74811314055756,scale:1155581.108577},{level:10,resolution:152.87405657041106,scale:577790.554289},{level:11,resolution:76.43702828507324,scale:288895.277144},{level:12,resolution:38.21851414253662,scale:144447.638572},{level:13,resolution:19.10925707126831,scale:72223.819286},{level:14,resolution:9.554628535634155,scale:36111.909643},{level:15,resolution:4.77731426794937,scale:18055.954822},{level:16,resolution:2.388657133974685,scale:9027.977411},{level:17,resolution:1.1943285668550503,scale:4513.988705},{level:18,resolution:.5971642835598172,scale:2256.994353},{level:19,resolution:.29858214164761665,scale:1128.497176}];async function S(e){const{view:l}=e;if(!(e&&l&&e.layer))throw new n("size-range:missing-parameters","'view' and 'layer' parameters are required");e.forBinning&&r.verifyBinningParams(e,"size-range");const{layer:a,...s}=e,i=e.forBinning?o.binningCapableLayerTypes:o.featureCapableLayerTypes,t=o.createLayerAdapter(a,i,e.forBinning);if(!t)throw new n("size-range:invalid-parameters","'layer' must be one of these types: "+o.getLayerTypeLabels(i).join(", "));const c={layerAdapter:t,...s,view:l};await l.when();const u=null!=c.signal?{signal:c.signal}:null;await t.load(u);const p=t.geometryType;if("point"!==p&&"multipoint"!==p&&"polyline"!==p&&"polygon"!==p)throw new n("size-range:not-supported",`sizeRange is not supported for geometryType: ${p}`);return c}function y(e,n){const l=Math.ceil(e/n);let a=Math.ceil(l/4);a<4?a=4:a>16&&(a=16);const s=5*a;return{min:a,max:s<50?50:s}}function x(e,l){const{view:a}=e;if(!a)throw new n("scale-range:invalid-parameters","'view' is required");const s=l.minScale||c,i=a.constraints&&"effectiveLODs"in a.constraints&&a.constraints.effectiveLODs||g,t=[];for(let n=0;n<i.length;n++){if(i[n].scale>s)continue;const e=Number(n),l=[e-3,e,e+3,e+6];for(const n of l)n>-1&&n<i.length&&t.push(i[n].scale);break}return t.sort(((e,n)=>e-n))}function h(e,l){const{view:s,layerAdapter:i}=e;if(!s)throw new n("scale-range:invalid-parameters","'view' is required");const t=i.fullExtent,r=i.minScale||u,o=i.maxScale||p,c=l.minScale||0,v=l.maxScale||0;let f=null!=t?a.getScale(s,t):0;f=f<r&&f>o?f:0;return{scales:[r,o,c,v,f].map(Math.round).sort(((e,n)=>e-n)).filter(((e,n,l)=>!!e&&l.indexOf(e)===n)).filter(((e,n,l)=>!n||Math.abs(e-l[n-1])>5)),fullExtentScale:f}}function d(e,a){const{minScale:t,maxScale:r}=a,o=x(e,{minScale:t,maxScale:r});if(!o.length)throw new n("scale-range:insufficient-info","not enough scale values");return{minSize:new s({valueExpression:"$view.scale",stops:o.map(((e,n)=>new i({value:e,size:l.px2pt(v[n])})))}),maxSize:new s({valueExpression:"$view.scale",stops:o.map(((e,n)=>new i({value:e,size:l.px2pt(f[n])})))})}}function z(e,a){const{minScale:t,maxScale:r}=a,o=x(e,{minScale:t,maxScale:r});if(!o.length)throw new n("scale-range:insufficient-info","not enough scale values");return{minSize:new s({valueExpression:"$view.scale",stops:o.map(((e,n)=>new i({value:e,size:l.px2pt(w[n])})))}),maxSize:new s({valueExpression:"$view.scale",stops:o.map(((e,n)=>new i({value:e,size:l.px2pt(m[n])})))})}}function b(e,a){const{spatialStatistics:t,minScale:r,maxScale:o}=a;if(!("avgSize"in t)||!t.avgSize)throw new n("size-range:insufficient-info","average polygon size is invalid");const c=t.avgSize,{view:u}=e;if(!u)throw new n("scale-range:invalid-parameters","'view' is required");const{resolution:p,scale:v}=u,f=p/v,{scales:w,fullExtentScale:m}=h(e,{minScale:r,maxScale:o}),g=[],S=[];w.forEach(((e,n)=>{const{min:a,max:s}=y(c,f*e),t=w.indexOf(m),r=t>-1&&n>t?2:1;g.push(new i({value:e,size:l.px2pt(a/r)})),S.push(new i({value:e,size:l.px2pt(s/r)}))}));return{minSize:new s({valueExpression:"$view.scale",stops:g}),maxSize:new s({valueExpression:"$view.scale",stops:S})}}async function E(e){const n=await S(e),{view:l,layerAdapter:a,signal:s,filter:i}=n,r=await t({layer:a,view:l,signal:s,filter:i});switch(a.geometryType){case"point":case"multipoint":return d(n,r);case"polyline":return z(n,r);case"polygon":return b(n,r);case"mesh":case"multipatch":return null}return null}return E}));
