/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../PopupTemplate","../../core/Error","../../intl/messages","../../intl/substitute","../../popup/ExpressionInfo","../../popup/FieldInfo","../../popup/support/FieldInfoFormat","./support/utils","../statistics/support/predominanceUtils"],(function(e,n,o,t,i,r,s,f,a,l){"use strict";function d(e,n){return e.legendOptions?.title??n.competingFields}function p(e,n){return{fieldInfo:new s({fieldName:"expression/predominant-category"}),expressionInfo:new r({name:"predominant-category",title:n.predominantCategory,expression:l.getArcadeForPredominantCategoryAlias(e)})}}function m(e,n){const o=l.fieldNamesFromFieldInfos(e);return{fieldInfo:new s({fieldName:"expression/predominant-value",format:new f({digitSeparator:!0,places:1})}),expressionInfo:new r({name:"predominant-value",title:n.predominantCategoryValue,expression:l.getArcadeForPredominantCategoryValue(o),returnType:"number"})}}function u(e,n){const o=l.fieldNamesFromFieldInfos(e);return{fieldInfo:new s({fieldName:"expression/predominant-margin",format:new f({digitSeparator:!0,places:0})}),expressionInfo:new r({name:"predominant-margin",title:n.marginOfVictory,expression:l.getArcadeForPredominanceMargin(o),returnType:"number"})}}function I(e,n){const o=l.fieldNamesFromFieldInfos(e);return{fieldInfo:new s({fieldName:"expression/predominant-strength",format:new f({digitSeparator:!0,places:0})}),expressionInfo:new r({name:"predominant-strength",title:n.strengthOfPredominance,expression:l.getArcadeForStrengthOfPredominance(o),returnType:"number"})}}function c(e,n){return{fieldInfo:new s({fieldName:"expression/predominant-categories-list"}),expressionInfo:new r({name:"predominant-categories-list",title:n.listOfCategories,expression:l.getArcadeForOrderedFields(e)})}}function g(e,n){const o=l.fieldNamesFromFieldInfos(e);return{fieldInfo:new s({fieldName:"expression/predominant-total",format:new f({digitSeparator:!0,places:0})}),expressionInfo:new r({name:"predominant-total",title:n.sumOfCategories,expression:l.getArcadeForSumOfFields(o),returnType:"number"})}}function x(e,o){const t=p(e.fieldInfos,o),r=new n({expressionInfos:[t.expressionInfo],fieldInfos:[t.fieldInfo],content:i.substitute(o.predominantCategoryContent,{expression:`<b>{${t.fieldInfo.fieldName}}</b>`})});return{name:"predominant-category",title:o.predominantCategory,value:r}}function y(e,o){const{fieldInfos:t}=e,r=p(t,o),s=m(t,o),f=new n({expressionInfos:[s.expressionInfo,r.expressionInfo],fieldInfos:[s.fieldInfo,r.fieldInfo],content:i.substitute(o.predominantCategoryValueContent,{expression1:`<b>{${r.fieldInfo.fieldName}}</b>`,expression2:`<b>{${s.fieldInfo.fieldName}}</b>`})});return{name:"predominant-category-value",title:o.predominantCategoryValue,value:f}}function b(e,o){const{fieldInfos:t}=e,r=p(t,o),s=m(t,o),f=u(t,o),a=new n({expressionInfos:[s.expressionInfo,r.expressionInfo,f.expressionInfo],fieldInfos:[s.fieldInfo,r.fieldInfo,f.fieldInfo],title:i.substitute(o.mostCommon,{expression:"{expression/predominant-category}"}),content:i.substitute(o.predominantCategoryValueMarginContent,{expression1:`<b>{${r.fieldInfo.fieldName}}</b>`,expression2:`<b>{${s.fieldInfo.fieldName}}</b>`,expression3:`<b>{${f.fieldInfo.fieldName}}</b>`})});return{name:"predominant-category-value-margin",title:o.marginOfVictory,value:a}}function w(e,o){const{fieldInfos:t}=e,r=p(t,o),s=m(t,o),f=I(t,o),a=new n({expressionInfos:[s.expressionInfo,r.expressionInfo,f.expressionInfo],fieldInfos:[s.fieldInfo,r.fieldInfo,f.fieldInfo],content:i.substitute(o.predominantCategoryStrengthContent,{expression1:`{${s.fieldInfo.fieldName}}`,expression2:`<b>{${r.fieldInfo.fieldName}}</b>`,expression3:`<b>{${f.fieldInfo.fieldName}}%</b>`})});return{name:"predominant-category-strength",title:o.strengthOfPredominance,value:a}}function N(e,o){const{renderer:t,fieldInfos:r}=e,s=p(r,o),f=m(r,o),a=I(r,o),l=c(r,o),u=new n({expressionInfos:[s.expressionInfo,f.expressionInfo,a.expressionInfo,l.expressionInfo],fieldInfos:[s.fieldInfo,f.fieldInfo,a.fieldInfo,l.fieldInfo],title:d(t,o),content:[{type:"text",text:i.substitute(o.predominantCategoryStrengthContent,{expression1:`{${f.fieldInfo.fieldName}}`,expression2:`<b>{${s.fieldInfo.fieldName}}</b>`,expression3:`<b>{${a.fieldInfo.fieldName}}%</b>`})},{type:"text",text:`{${l.fieldInfo.fieldName}}`}]});return{name:"predominant-categories-list",title:o.orderedListOfValues,value:u}}function C(e,o){const{fieldInfos:t}=e,r=p(t,o),s=m(t,o),f=I(t,o),a=g(t,o),l=new n({expressionInfos:[s.expressionInfo,r.expressionInfo,a.expressionInfo,f.expressionInfo],fieldInfos:[s.fieldInfo,r.fieldInfo,a.fieldInfo,f.fieldInfo],content:i.substitute(o.predominantCategoryTotalStrengthContent,{expression1:`{${s.fieldInfo.fieldName}}`,expression2:`<b>{${r.fieldInfo.fieldName}}</b>`,expression3:`<b>{${f.fieldInfo.fieldName}}%</b>`,expression4:`{${a.fieldInfo.fieldName}}`})});return{name:"predominant-category-total-strength",title:o.predominantCategoryWithTotalAndStrength,value:l}}function h(e,o){const{renderer:t,fieldInfos:r}=e,s=p(r,o),f=m(r,o),a=I(r,o),l=new n({expressionInfos:[f.expressionInfo,s.expressionInfo,a.expressionInfo],fieldInfos:[f.fieldInfo,s.fieldInfo,a.fieldInfo],title:d(t,o),content:[{type:"text",text:i.substitute(o.predominantCategoryStrengthContent,{expression1:`{${f.fieldInfo.fieldName}}`,expression2:`<b>{${s.fieldInfo.fieldName}}</b>`,expression3:`<b>{${a.fieldInfo.fieldName}}%</b>`})},{type:"media",mediaInfos:{type:"pie-chart",value:{fields:r.map((e=>e.fieldName))}}}]});return{name:"predominant-category-chart",title:o.predominantCategoryWithChart,value:l}}function F(e,n){const t=e.authoringInfo,i="predominance"===t?.type?t.fields:[];if(!i?.length)throw new o("predominance-popup:insufficient-info","unable to find input fields in authoringInfo");return i.map((e=>a.getFieldInfo(n,e)))}async function $(e){const{layer:n,renderer:t}=e;await n.load();const i=t||n.renderer;if("unique-value"!==i?.type)throw new o("predominance-popup:invalid-parameters","renderer.type must be 'unique-value'");return{renderer:i,fieldInfos:F(i,n)}}async function v(e){const[n,o]=await Promise.all([$(e),t.fetchMessageBundle("esri/smartMapping/t9n/smartMapping")]);return[x(n,o),y(n,o),b(n,o),C(n,o),N(n,o),w(n,o),h(n,o)]}async function S(e){const[n,o]=await Promise.all([$(e),t.fetchMessageBundle("esri/smartMapping/t9n/smartMapping")]),i=N(n,o),r=await v(e);return{primaryTemplate:i,secondaryTemplates:r.filter((e=>e.name!==i.name))}}e.getAllTemplates=v,e.getTemplates=S,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
