/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../renderers/PointCloudClassBreaksRenderer","../../renderers/PointCloudRenderer","../../renderers/PointCloudRGBRenderer","../../renderers/PointCloudStretchRenderer","../../renderers/PointCloudUniqueValueRenderer","../../renderers/ClassBreaksRenderer","../../renderers/DictionaryRenderer","../../renderers/DotDensityRenderer","../../renderers/HeatmapRenderer","../../renderers/PieChartRenderer","../../renderers/Renderer","../../renderers/SimpleRenderer","../../renderers/UniqueValueRenderer","../../renderers/support/jsonUtils","../../core/Logger","../../core/colorUtils","../../core/Error","../../core/lang","../../core/accessorSupport/ensureType","../../intl/messages","../../renderers/support/AuthoringInfo","../../renderers/support/AuthoringInfoVisualVariable","../../renderers/support/utils","../../renderers/visualVariables/ColorVariable","../../renderers/visualVariables/support/ColorStop","../../renderers/visualVariables/support/VisualVariableLegendOptions","../heuristics/ageUnit","../heuristics/outline","../heuristics/sizeRange","./support/regenerateUtils","./support/utils","../statistics/support/ageUtils","../support/binningUtils","../support/utils","../support/adapters/support/layerUtils","../symbology/color"],(function(e,a,i,r,n,l,o,t,s,d,u,c,m,p,y,f,b,g,h,v,w,T,V,S,z,x,E,I,C,M,B,R,k,F,O,L,P){"use strict";const U="high-to-low",q=2**53-1,A=5;async function D(e){if(!(e&&e.layer&&(e.field||e.valueExpression||e.sqlExpression)))throw new g("color-visual-variable:missing-parameters","'layer' and 'field', 'valueExpression' or 'sqlExpression' parameters are required");if(e.valueExpression&&!e.sqlExpression&&!e.view)throw new g("color-visual-variable:missing-parameters","View is required when 'valueExpression' is specified");e.forBinning&&F.verifyBinningParams(e,"color-visual-variable");const a={...e},i=e.forBinning?L.binningCapableLayerTypes:L.featureCapableLayerTypes,r=L.createLayerAdapter(a.layer,i,e.forBinning);if(!r)throw new g("color-visual-variable:invalid-parameters","'layer' must be one of these types: "+L.getLayerTypeLabels(i).join(", "));const n=null!=a.signal?{signal:a.signal}:null;await r.load(n);if("mesh"!==r.geometryType&&a.worldScale&&(!a.view||"3d"!==a.view.type))throw new g("color-visual-variable:invalid-parameters","'view' parameter should be an instance of SceneView when 'worldScale' parameter is true");const l=await O.getFieldsList({field:a.field,normalizationField:a.normalizationField,valueExpression:a.valueExpression}),o=R.verifyBasicFieldValidity(r,l,"color-visual-variable:invalid-parameters");if(o)throw o;return{...a,layer:r}}async function j(e){if(!(e&&e.layer&&(e.field||e.valueExpression||e.sqlExpression)))throw new g("color-continuous-renderer:missing-parameters","'layer' and 'field', 'valueExpression' or 'sqlExpression' parameters are required");if(e.valueExpression&&!e.sqlExpression&&!e.view)throw new g("color-continuous-renderer:missing-parameters","View is required when 'valueExpression' is specified");e.forBinning&&F.verifyBinningParams(e,"color-continuous-renderer");const a={...e};a.symbolType=a.symbolType||"2d",a.defaultSymbolEnabled??=!0;const i=e.forBinning?L.binningCapableLayerTypes:L.featureCapableLayerTypes,r=L.createLayerAdapter(a.layer,i,e.forBinning);if(!r)throw new g("color-continuous-renderer:invalid-parameters","'layer' must be one of these types: "+L.getLayerTypeLabels(i).join(", "));const n=null!=a.signal?{signal:a.signal}:null;await r.load(n);const l=r.geometryType;if(a.outlineOptimizationEnabled="polygon"===l&&a.outlineOptimizationEnabled,a.sizeOptimizationEnabled=("point"===l||"multipoint"===l||"polyline"===l)&&a.sizeOptimizationEnabled,"mesh"===l)a.symbolType="3d-volumetric",a.colorMixMode=a.colorMixMode||"replace",a.edgesType=a.edgesType||"none";else{if("3d-volumetric-uniform"===a.symbolType&&"point"!==l)throw new g("color-continuous-renderer:not-supported","3d-volumetric-uniform symbols are supported for point layers only");if(a.symbolType.includes("3d-volumetric")&&(!a.view||"3d"!==a.view.type))throw new g("color-continuous-renderer:invalid-parameters","'view' parameter should be an instance of SceneView when 'symbolType' parameter is '3d-volumetric' or '3d-volumetric-uniform'")}const o=await O.getFieldsList({field:a.field,normalizationField:a.normalizationField,valueExpression:a.valueExpression}),t=R.verifyBasicFieldValidity(r,o,"color-continuous-renderer:invalid-parameters");if(t)throw t;return{...a,layer:r}}async function $(e){if(!e||!e.layer||!e.field&&!e.valueExpression)throw new g("color-class-breaks-renderer:missing-parameters","'layer' and 'field' or 'valueExpression' parameters are required");if(e.valueExpression&&!e.view)throw new g("color-class-breaks-renderer:missing-parameters","View is required when 'valueExpression' is specified");e.forBinning&&F.verifyBinningParams(e,"color-class-breaks-renderer");const a={...e};a.symbolType=a.symbolType||"2d",a.defaultSymbolEnabled??=!0,a.classificationMethod??="equal-interval",a.normalizationType=O.getNormalizationType(a);const i=e.forBinning?L.binningCapableLayerTypes:L.featureCapableLayerTypes,r=L.createLayerAdapter(a.layer,i,e.forBinning);if(!r)throw new g("color-class-breaks-renderer:invalid-parameters","'layer' must be one of these types: "+L.getLayerTypeLabels(i).join(", "));if(!(null!=a.minValue&&null!=a.maxValue)&&(null!=a.minValue||null!=a.maxValue))throw new g("color-class-breaks-renderer:missing-parameters","Both 'minValue' and 'maxValue' are required when specifying custom data range");const n=null!=a.signal?{signal:a.signal}:null;await r.load(n);const l=r.geometryType;if(a.outlineOptimizationEnabled="polygon"===l&&a.outlineOptimizationEnabled,"mesh"===l)a.symbolType="3d-volumetric",a.colorMixMode=a.colorMixMode||"replace",a.edgesType=a.edgesType||"none";else{if("3d-volumetric-uniform"===a.symbolType&&"point"!==l)throw new g("color-class-breaks-renderer:not-supported","3d-volumetric-uniform symbols are supported for point layers only");if(a.symbolType.includes("3d-volumetric")&&(!a.view||"3d"!==a.view.type))throw new g("color-class-breaks-renderer:invalid-parameters","'view' parameter should be an instance of SceneView when 'symbolType' parameter is '3d-volumetric' or '3d-volumetric-uniform'")}const o=await O.getFieldsList({field:a.field,normalizationField:a.normalizationField}),t=R.verifyBasicFieldValidity(r,o,"color-class-breaks-renderer:invalid-parameters");if(t)throw t;return{...a,layer:r}}function G(e){const a={...e};delete a.basemap,delete a.colorScheme,delete a.legendOptions,delete a.symbolType,delete a.defaultSymbolEnabled,delete a.colorMixMode,delete a.edgesType;const i=a;return i.analyzeData=!(null!=a.minValue&&null!=a.maxValue),i}async function W(e){if(!e?.layer)throw new g("color-point-cloud-true-color-renderer:missing-parameters","'layer' parameter is required");const a={...e,layer:e.layer},i=[L.LayerType.PointCloudLayer],r=L.createLayerAdapter(a.layer,i);if(!r)throw new g("color-point-cloud-true-color-renderer:invalid-parameters","'layer' must be one of these types: "+L.getLayerTypeLabels(i).join(", "));if(a.layer=r,a.density=a.density||25,a.size=a.size||"100%",!R.isValidPointSize(a.size))throw new g("color-point-cloud-true-color-renderer:invalid-parameters","Invalid 'size' parameter. It should be a string of the form '100%'");const n=null!=a.signal?{signal:a.signal}:null;return await r.load(n),a}async function H(e){if(!e?.layer||!e.field)throw new g("color-point-cloud-continuous-renderer:missing-parameters","'layer' and 'field' parameters are required");const a=e.field.toLowerCase();if("intensity"!==a&&"elevation"!==a)throw new g("color-point-cloud-continuous-renderer:invalid-parameters","'field' should be either 'intensity' or 'elevation'");const i={...e,layer:e.layer,field:e.field},r=[L.LayerType.PointCloudLayer],n=L.createLayerAdapter(i.layer,r);if(!n)throw new g("color-point-cloud-continuous-renderer:invalid-parameters","'layer' must be one of these types: "+L.getLayerTypeLabels(r).join(", "));if(i.layer=n,i.density=i.density||25,i.size=i.size||"100%",!R.isValidPointSize(i.size))throw new g("color-point-cloud-continuous-renderer:invalid-parameters","Invalid 'size' parameter. It should be a string of the form '100%'");const l=null!=i.signal?{signal:i.signal}:null;return await n.load(l),i}function N(e){const a={...e},i=!!a.symbolType?.includes("3d-volumetric");delete a.symbolType,delete a.defaultSymbolEnabled,delete a.colorMixMode,delete a.edgesType;const r=a;return r.worldScale=i,r}async function J(e){if(!(e&&e.layer&&e.view&&e.startTime&&e.endTime))throw new g("color-age-renderer:missing-parameters","'layer', 'view', startTime', 'endTime' parameters are required");const a={...e};a.symbolType=a.symbolType||"2d",a.defaultSymbolEnabled??=!0;const i=L.createLayerAdapter(a.layer,L.featureCapableLayerTypes);if(!i)throw new g("color-age-renderer:invalid-parameters","'layer' must be one of these types: "+L.getLayerTypeLabels(L.featureCapableLayerTypes).join(", "));const r=null!=a.signal?{signal:a.signal}:null;await i.load(r);const n=i.geometryType;if(a.outlineOptimizationEnabled="polygon"===n&&a.outlineOptimizationEnabled,a.sizeOptimizationEnabled=("point"===n||"multipoint"===n||"polyline"===n)&&a.sizeOptimizationEnabled,"mesh"===n)a.symbolType="3d-volumetric",a.colorMixMode=a.colorMixMode||"replace",a.edgesType=a.edgesType||"none";else if("3d-volumetric-uniform"===a.symbolType&&"point"!==n)throw new g("color-continuous-renderer:not-supported","3d-volumetric-uniform symbols are supported for point layers only");if(a.symbolType.includes("3d-volumetric")&&(!a.view||"3d"!==a.view.type))throw new g("color-age-renderer:invalid-parameters","'view' parameter should be an instance of SceneView when 'symbolType' parameter is '3d-volumetric' or '3d-volumetric-uniform'");const l=k.verifyDates(i,a.startTime,a.endTime,"color-age-renderer:invalid-parameters");if(l)throw l;if(a.unit&&!k.supportedAgeUnits.includes(a.unit))throw new g("color-age-renderer:invalid-unit",`Supported units are: ${k.supportedAgeUnits.join(", ")}`);return{...a,layer:i}}async function K(e){const a="regenerate-color-visual-variable";await B.processRegenerateParams(e,a);const i=await B.getRendererToUpdate(e);if("class-breaks"!==i?.type)throw new g(`${a}:invalid-parameters`,"Renderer must be a ClassBreaksRenderer to regenerate a color visual variable");const r=i.authoringInfo,n=r?.visualVariables.find((e=>"color"===e.type)),l=i.visualVariables?.find((e=>"color"===e.type));if(!l)throw new g(`${a}:invalid-parameters`,"Renderer does not have a color visual variable");const{field:o,normalizationField:t,valueExpression:s,valueExpressionTitle:d}=l,u="univariate-color-size"===r?.type?r?.univariateTheme:n?.theme,{layer:c,forBinning:m,filter:p,view:y,signal:f}=e,b=await D({layer:c,field:o,valueExpression:s,valueExpressionTitle:d,normalizationField:t,theme:u,forBinning:m,filter:p,view:y,signal:f});return{...e,creatorParameters:b,renderer:i}}async function Q(e){const a="regenerate-color-continuous-renderer";await B.processRegenerateParams(e,a);const i=await B.getRendererToUpdate(e),r=B.getStyleType(i);if(!r||!["color-continuous","color-size"].includes(r))throw new g(`${a}:invalid-renderer`,"Renderer is invalid");const{authoringInfo:n,field:l,normalizationField:o,valueExpression:t,valueExpressionTitle:s}=i,d=n?.visualVariables.find((e=>"color"===e.type)),u=d?.theme,{layer:c,forBinning:m,filter:p,view:y,signal:f}=e,b=B.hasOutlineVV(i),h=B.hasScaleDependentSizeVV(i),v=await j({layer:c,field:l,valueExpression:t,valueExpressionTitle:s,normalizationField:o,theme:u,outlineOptimizationEnabled:b,sizeOptimizationEnabled:h,forBinning:m,filter:p,view:y,signal:f});return{...e,creatorParameters:v,renderer:i}}async function X(e){const a="regenerate-color-class-breaks-renderer";await B.processRegenerateParams(e,a);const i=await B.getRendererToUpdate(e);if("color-class-breaks"!==B.getStyleType(i))throw new g(`${a}:invalid-parameters`,"Renderer is invalid");const{authoringInfo:r,field:n,normalizationField:l,normalizationType:o,normalizationTotal:t,valueExpression:s,valueExpressionTitle:d}=i,{classificationMethod:u,standardDeviationInterval:c}=r,m=i.classBreakInfos.length,{layer:p,forBinning:y,filter:f,view:b,signal:h}=e,v=B.hasOutlineVV(i),w=await $({layer:p,field:n,valueExpression:s,valueExpressionTitle:d,normalizationType:o,normalizationField:l,normalizationTotal:t,classificationMethod:u,standardDeviationInterval:c,numClasses:m,outlineOptimizationEnabled:v,forBinning:y,filter:f,view:b,signal:h});return{...e,creatorParameters:w,renderer:i}}async function Y(e){const a="regenerate-color-age-renderer";await B.processRegenerateParams(e,a);const i=await B.getRendererToUpdate(e);if("color-age"!==B.getStyleType(i))throw new g(`${a}:invalid-parameters`,"Renderer is invalid");const{authoringInfo:r}=i,n=r?.visualVariables.find((e=>"color"===e.type)),l=n.startTime,o=n.endTime,t=n.units,s=n.theme,{layer:d,filter:u,view:c,signal:m}=e,p=B.hasOutlineVV(i),y=B.hasScaleDependentSizeVV(i),f=await J({layer:d,startTime:l,endTime:o,unit:t,theme:s,outlineOptimizationEnabled:p,sizeOptimizationEnabled:y,filter:u,view:c,signal:m});return{...e,creatorParameters:f,renderer:i}}async function Z(e,a){let i=e.colorScheme,r=null,n=null;const{view:l}=e,o=await R.getBasemapInfo(e.basemap,l);if(r=null!=o.basemapId?o.basemapId:null,n=null!=o.basemapTheme?o.basemapTheme:null,i)return{scheme:P.cloneScheme(i),basemapId:r,basemapTheme:n};const t=e.theme||U,s=P.getSchemes({theme:t,basemapTheme:n,geometryType:e.geometryType,worldScale:e.worldScale,view:l});if(s)if(r=s.basemapId,n=s.basemapTheme,e.schemeId){const a=t+"/"+r+"/"+e.schemeId;i=P.getSchemeById({id:a,geometryType:e.geometryType})}else i=s.primaryScheme;return{scheme:i,basemapId:r,basemapTheme:n}}async function _(e,a){const i=a.layer,r=await Z({basemap:a.basemap,colorScheme:a.colorScheme,geometryType:i.geometryType,schemeId:"elevation"===a.field.toLowerCase()?"point-cloud-elevation-scheme":"point-cloud-intensity-scheme"}),n=r.scheme;if(!n)throw new g("color-point-cloud-continuous-renderer:insufficient-info","Unable to find color scheme");const l=b.createUniqueColors(n.colors,A);if(l.length<A)throw new g("color-point-cloud-continuous-renderer:insufficient-info","Color scheme does not have enough colors");const o=R.getDefaultDataRange(e,!1,!0),t=o?R.createDefaultStopValues(o[0],o[1],5):R.createStopValues(e);return{stops:S.createColorStops({values:t,isDate:!1,colors:l,labelIndexes:[0,2,4]}),basemapId:r.basemapId,basemapTheme:r.basemapTheme,statistics:e,defaultValuesUsed:!!o,colorScheme:P.cloneScheme(n)}}function ee(e,a,i,r){const n=R.getDataRange(e,a,i,!0);return{values:R.createDataValues(n,e,a,r),defaultValuesUsed:n.defaultValuesUsed}}async function ae(e,a,i,r){const{field:n,theme:l}=e,o=await Z({basemap:e.basemap,theme:e.theme,geometryType:i,colorScheme:e.colorScheme,worldScale:e.worldScale,view:e.view}),t=o.scheme;if(!t)throw new g("color-visual-variable:insufficient-info","Unable to find color scheme");const s=b.createUniqueColors(t.colors,A);if(s.length<A)throw new g("color-visual-variable:insufficient-info","Color scheme does not have enough colors");const d=t.id.includes("seq-"),{values:u,defaultValuesUsed:c}=ee(a,l,r,d),m=b.createUniqueColors(s,A),p=new z({field:n??void 0,valueExpression:e.valueExpression,valueExpressionTitle:e.valueExpressionTitle,normalizationField:e.normalizationField,stops:u.map(((e,a)=>new x({value:e,color:m[a]}))),legendOptions:v.ensureClass(E,e.legendOptions)}),y=new V({type:"color",minSliderValue:null!=e.minValue?e.minValue:a.min,maxSliderValue:null!=e.maxValue?e.maxValue:a.max,theme:t.theme}),f=new T({visualVariables:[y]});return{basemapId:o.basemapId,basemapTheme:o.basemapTheme,visualVariable:p,statistics:a,defaultValuesUsed:c,colorScheme:P.cloneScheme(t),authoringInfo:f}}async function ie(e,a,i,r,n,l,t){const s=await w.fetchMessageBundle("esri/smartMapping/t9n/smartMapping"),{field:d,defaultSymbolEnabled:u}=t,c=P.cloneScheme(e.colorScheme),m=a?.opacity,p=[e.visualVariable.clone()];a?.visualVariables?.length&&p.push(...a.visualVariables.map((e=>e.clone()))),i?.minSize&&p.push(i.minSize);return{renderer:new o({classBreakInfos:[{minValue:-q,maxValue:q,symbol:R.createSymbol(l,{type:t.symbolType,color:c.noDataColor,size:R.getSymbolSizeFromScheme(c,l),outline:R.getSymbolOutlineFromScheme(c,l,m),meshInfo:{colorMixMode:t.colorMixMode,edgesType:t.edgesType}})}],defaultLabel:u?s.other:null,defaultSymbol:u?R.createSymbol(l,{type:t.symbolType,color:c.noDataColor,size:R.getSymbolSizeFromScheme(c,l),outline:R.getSymbolOutlineFromScheme(c,l,m),meshInfo:{colorMixMode:t.colorMixMode,edgesType:t.edgesType}}):null,field:d,normalizationType:r,normalizationField:n,valueExpression:t.valueExpression,valueExpressionTitle:t.valueExpressionTitle,visualVariables:p,authoringInfo:e.authoringInfo&&e.authoringInfo.clone()}),visualVariable:e.visualVariable.clone(),statistics:e.statistics,defaultValuesUsed:e.defaultValuesUsed,colorScheme:P.cloneScheme(e.colorScheme),basemapId:e.basemapId,basemapTheme:e.basemapTheme}}async function re(e){const a=await D(e),{view:i,field:r,valueExpression:n,minValue:l,maxValue:o,layer:t,normalizationField:s,signal:d,filter:u,statistics:c}=a,m=s?"field":void 0,p=await(c??R.getSummaryStatistics({layer:t,field:r,valueExpression:n,sqlExpression:a.sqlExpression,sqlWhere:a.sqlWhere,normalizationType:m,normalizationField:s,minValue:l,maxValue:o,filter:u,view:i,signal:d})),y=t,f=r&&"function"!=typeof r?y.getField(r):null;return ae(a,p,y.geometryType,O.isAnyDateField(f))}async function ne(e){const{view:a,filter:i,creatorParameters:r,renderer:n,signal:l}=await K(e),o=n.authoringInfo?.clone(),t=o?.visualVariables.find((e=>"color"===e.type)),s=n.visualVariables?.find((e=>"color"===e.type)),{field:d,normalizationField:u,valueExpression:c,theme:m,layer:p}=r,y=await R.getSummaryStatistics({layer:p,field:d,valueExpression:c,normalizationField:u,filter:i,view:a,signal:l}),f=d&&"function"!=typeof d?p.getField(d):null,{values:b}=ee(y,m,O.isAnyDateField(f),"high-to-low"===m);if(b.length!==s.stops.length)throw new g("regenerate-color-visual-variable:invalid-parameters","Visual variable is invalid");return s.stops.forEach(((e,a)=>e.value=b[a])),t&&(t.minSliderValue=y.min,t.maxSliderValue=y.max),{visualVariable:s,authoringInfo:o,statistics:y}}function le(e,a){const i=e.colorsForClassBreaks;if(i?.length)for(const r of i)if(r.numClasses===a)return h.clone(r.colors);return b.createUniqueColors(e.colors,a)}async function oe(e,a){const i=await w.fetchMessageBundle("esri/smartMapping/t9n/smartMapping"),r=e.layer,n=e.defaultSymbolEnabled,l=r.geometryType,t=e.classificationMethod,s="standard-deviation"===t,d=await Z({basemap:e.basemap,geometryType:l,theme:s?"above-and-below":null,colorScheme:e.colorScheme,worldScale:!!e.symbolType?.includes("3d-volumetric"),view:e.view}),u=d.scheme,{result:c,outlineResult:m}=a,p=c.classBreakInfos,y=e.normalizationType;if(!u)throw new g("color-class-breaks-renderer:insufficient-info","Unable to find color scheme");const f=le(u,p.length);if(!f||f.length!==p.length)throw new g("color-class-breaks-renderer:insufficient-info","Color scheme does not have enough colors");const b=m?.opacity,h=new o({classBreakInfos:p.map(((a,i)=>({minValue:a.minValue,maxValue:a.maxValue,symbol:R.createSymbol(l,{type:e.symbolType,color:f[i],size:R.getSymbolSizeFromScheme(u,l),outline:R.getSymbolOutlineFromScheme(u,l,b),meshInfo:{colorMixMode:e.colorMixMode,edgesType:e.edgesType}}),label:a.label}))),defaultLabel:n?i.other:null,defaultSymbol:n?R.createSymbol(l,{type:e.symbolType,color:u.noDataColor,size:R.getSymbolSizeFromScheme(u,l),outline:R.getSymbolOutlineFromScheme(u,l,b),meshInfo:{colorMixMode:e.colorMixMode,edgesType:e.edgesType}}):null,field:e.field,valueExpression:e.valueExpression,valueExpressionTitle:e.valueExpressionTitle,normalizationType:y,normalizationField:e.normalizationField,normalizationTotal:"percent-of-total"===y?c.normalizationTotal:void 0,legendOptions:e.legendOptions,authoringInfo:new T({type:"class-breaks-color",classificationMethod:t,standardDeviationInterval:e.standardDeviationInterval})});return s||S.setLabelsForClassBreaks({classBreakInfos:h.classBreakInfos,classificationMethod:t,normalizationType:y,round:!0}),m?.visualVariables?.length&&(h.visualVariables=m.visualVariables.map((e=>e.clone()))),{renderer:h,colorScheme:P.cloneScheme(u),classBreaksResult:c,defaultValuesUsed:a.defaultValuesUsed,basemapId:d.basemapId,basemapTheme:d.basemapTheme}}async function te(e){const a=await j(e),{layer:i,view:r,signal:n,filter:l}=a,[o,t,s]=await Promise.all([re(N(a)),a.outlineOptimizationEnabled?C({layer:i,view:r,signal:n,filter:l}).catch(R.errorCallback):null,a.sizeOptimizationEnabled?M({layer:i,view:r,signal:n,filter:l}).catch(R.errorCallback):null]),d=a.normalizationField;return ie(o,t,s,d?"field":void 0,d,i.geometryType,a)}async function se(e){const{renderer:a,view:i,signal:r,filter:n,creatorParameters:l}=await Q(e),{layer:o,outlineOptimizationEnabled:t,sizeOptimizationEnabled:s}=l,[d,u,c]=await Promise.all([ne(e),t?C({layer:o,view:i,signal:r,filter:n}).catch(R.errorCallback):null,s?M({layer:o,view:i,signal:r,filter:n}).catch(R.errorCallback):null]);return B.spliceVisualVariables(a,d.visualVariable,B.findColorVVIndex),B.spliceVisualVariables(a,u?.visualVariables,B.findOutlineVVIndex),B.spliceVisualVariables(a,c?.minSize,B.findScaleDependentSizeVVIndex),B.updateAuthoringInfoVisualVariable(a,d.authoringInfo,"color"),{renderer:a}}async function de(e){const a=await $(e);return oe(a,await R.getClassBreaks(G(a),a.outlineOptimizationEnabled))}async function ue(e){const{renderer:a,creatorParameters:i}=await X(e),{normalizationType:r,outlineOptimizationEnabled:n,classificationMethod:l}=i,{result:o,outlineResult:t}=await R.getClassBreaks(G(i),n),s=o.classBreakInfos;if(i.numClasses!==s.length)throw new g("regenerate-color-class-breaks-renderer:insufficient-info","The number of class breaks generated does not match the number of class breaks in the renderer.");return a.classBreakInfos.forEach(((e,a)=>{e.minValue=s[a].minValue,e.maxValue=s[a].maxValue,e.label=s[a].label})),a.normalizationTotal="percent-of-total"===r?o.normalizationTotal:void 0,"standard-deviation"!==l&&S.setLabelsForClassBreaks({classBreakInfos:a.classBreakInfos,classificationMethod:l,normalizationType:r,round:!0}),B.spliceVisualVariables(a,t?.visualVariables,B.findOutlineVVIndex),{renderer:a}}function ce(e){return W(e).then((e=>({renderer:new r({field:"RGB",pointsPerInch:e.density??void 0,pointSizeAlgorithm:R.getPointSizeAlgorithm(e.size)})})))}async function me(e){const a=await H(e),i=a.statistics??await R.getSummaryStatistics({layer:a.layer,field:a.field,signal:a.signal}),r=await _(i,a);return{renderer:new n({field:a.field,pointsPerInch:a.density??void 0,pointSizeAlgorithm:R.getPointSizeAlgorithm(a.size),stops:r.stops}),basemapId:r.basemapId,basemapTheme:r.basemapTheme,statistics:r.statistics,defaultValuesUsed:r.defaultValuesUsed,colorScheme:r.colorScheme}}async function pe(e){const a=await J(e),{defaultSymbolEnabled:i,view:r,startTime:n,endTime:l,symbolType:o,colorMixMode:t,edgesType:s,minValue:d,maxValue:u,signal:c,filter:m}=a,p=a.layer,[y,f,b]=await Promise.all([a.unit?{unit:a.unit,statistics:null}:I({view:r,layer:p,startTime:n,endTime:l,minValue:d,maxValue:u,signal:c,filter:m}),a.outlineOptimizationEnabled?C({layer:p,view:r,signal:c,filter:m}).catch(R.errorCallback):null,a.sizeOptimizationEnabled?M({layer:p,view:r,signal:c,filter:m}).catch(R.errorCallback):null]),{unit:g,statistics:h}=y,{valueExpression:v,title:w}=await R.getTitleAndExpressionForAgeRenderer(a,g),T=await re(N({layer:p,basemap:a.basemap,valueExpression:v,symbolType:o,statistics:h,legendOptions:{title:w},colorScheme:a.colorScheme,theme:a.theme,view:r,minValue:a.minValue,maxValue:a.maxValue,filter:m,signal:c})),V={layer:p,valueExpression:v,defaultSymbolEnabled:i,symbolType:o,colorMixMode:t,edgesType:s},S=await ie(T,f,b,null,null,p.geometryType,V),z=S.renderer.authoringInfo?.visualVariables;return z?.forEach((e=>R.updateAgeRendererAuthoringInfoVV(e,n,l,g))),{...S,unit:g}}async function ye(e){const{renderer:a,creatorParameters:i}=await Y(e),{layer:r,outlineOptimizationEnabled:n,sizeOptimizationEnabled:l,startTime:o,endTime:t,theme:s,view:d,signal:u,filter:c}=i,[m,p,y]=await Promise.all([I({view:d,layer:r,startTime:o,endTime:t,signal:u,filter:c}),n?C({layer:r,view:d,signal:u,filter:c}).catch(R.errorCallback):null,l?M({layer:r,view:d,signal:u,filter:c}).catch(R.errorCallback):null]),{unit:f,statistics:b}=m,{valueExpression:g,title:h}=await R.getTitleAndExpressionForAgeRenderer(i,f),v=await re(N({layer:r,valueExpression:g,statistics:b,legendOptions:{title:h},theme:s,view:d,filter:c,signal:u}));B.spliceVisualVariables(a,v.visualVariable,B.findColorVVIndex),B.spliceVisualVariables(a,p?.visualVariables,B.findOutlineVVIndex),B.spliceVisualVariables(a,y?.minSize,B.findScaleDependentSizeVVIndex),a.authoringInfo=v.authoringInfo.clone();const w=a.authoringInfo?.visualVariables;return w?.forEach((e=>R.updateAgeRendererAuthoringInfoVV(e,o,t,f))),{renderer:a}}e.createAgeRenderer=pe,e.createClassBreaksRenderer=de,e.createContinuousRenderer=te,e.createPCContinuousRenderer=me,e.createPCTrueColorRenderer=ce,e.createVisualVariable=re,e.regenerateAgeRenderer=ye,e.regenerateClassBreaksRenderer=ue,e.regenerateContinuousRenderer=se,e.regenerateVisualVariable=ne,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
