/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../renderers/ClassBreaksRenderer","../../renderers/DictionaryRenderer","../../renderers/DotDensityRenderer","../../renderers/HeatmapRenderer","../../renderers/PieChartRenderer","../../renderers/Renderer","../../renderers/SimpleRenderer","../../renderers/UniqueValueRenderer","../../renderers/support/jsonUtils","../../core/Logger","../../core/colorUtils","../../core/Error","../../geometry/support/scaleUtils","../../renderers/support/AuthoringInfo","../heuristics/outline","./support/dotDensityUtils","./support/regenerateUtils","./support/utils","../statistics/spatialStatistics","../statistics/summaryStatisticsForAttributes","../statistics/support/attributeDensity","../support/binningUtils","../support/utils","../support/adapters/support/layerUtils","../symbology/dotDensity"],(function(e,r,t,a,i,n,l,s,o,u,d,c,p,m,y,f,g,b,w,v,h,S,V,T,E,x){"use strict";const R=500;async function D(e){const r=e.view;if(!(e?.layer&&r&&e.attributes?.length))throw new p("dot-density-renderer:missing-parameters","'layer', 'view' and 'attributes' parameters are required");if(e.attributes.length>8)throw new p("dot-density-renderer:invalid-parameters","Dot density renderer does not support more than 8 attributes");e.forBinning&&V.verifyBinningParams(e,"dot-density-renderer");const t={...e,view:r,layer:e.layer,attributes:e.attributes},a=[E.LayerType.FeatureLayer,E.LayerType.OGCFeatureLayer,E.LayerType.GeoJSONLayer,E.LayerType.WFSLayer],i=e.forBinning?E.binningCapableLayerTypes:a,n=E.createLayerAdapter(t.layer,i,e.forBinning);if(!n)throw new p("dot-density-renderer:invalid-parameters","'layer' must be one of these types: "+E.getLayerTypeLabels(i).join(", "));t.dotBlendingEnabled??=!0,t.dotValueOptimizationEnabled??=!0;const l=null!=t.signal?{signal:t.signal}:null;await Promise.all([r.when(),n.load(l)]);if("polygon"!==n.geometryType)throw new p("dot-density-renderer:not-supported","Dot density renderer is supported for polygon layers only");const s=[],o=t.attributes;for(const d of o){const e=await T.getFieldsList({field:d.field,valueExpression:d.valueExpression});s.push(...e)}const u=w.verifyBasicFieldValidity(n,s.filter(Boolean),"dot-density-renderer:invalid-parameters");if(u)throw u;return{...t,layer:n}}async function L(e){const r="regenerate-dot-density-renderer";await b.processRegenerateParams(e,r);const t=await b.getRendererToUpdate(e);if("dot-density"!==b.getStyleType(t))throw new p(`${r}:invalid-parameters`,"Renderer is invalid");const{layer:a,forBinning:i,filter:n,view:l,signal:s}=e,o=b.hasOutlineVV(t),u=t.attributes.map((e=>({field:e.field,valueExpression:e.valueExpression,label:e.label,valueExpressionTitle:e.valueExpressionTitle}))),d=await D({layer:a,attributes:u,dotValueOptimizationEnabled:null!=t.referenceScale,outlineOptimizationEnabled:o,forBinning:i,filter:n,view:l,signal:s});return{...e,creatorParameters:d,renderer:t}}async function O(e){let r=e.dotDensityScheme,t=null,a=null;const i=await w.getBasemapInfo(e.basemap,e.view);if(t=null!=i.basemapId?i.basemapId:null,a=null!=i.basemapTheme?i.basemapTheme:null,r)return{scheme:x.cloneScheme(r),basemapId:t,basemapTheme:a};const n=x.getSchemes({numColors:e.attributes.length,basemapTheme:a});return n&&(r=n.primaryScheme,t=n.basemapId,a=n.basemapTheme),{scheme:r,basemapId:t,basemapTheme:a}}function I(e){return{dotValue:1,referenceScale:e.scale,minSliderValue:1,maxSliderValue:100}}async function B(e){const{view:r,layer:t,attributes:a,signal:i,filter:n}=e,l=await t.getSampleFeatures({view:r,sampleSize:R,returnGeometry:!0,filter:n,signal:i},"json"),[s,o]=await Promise.all([v({features:l,geometryType:t.geometryType}),h({layer:t,attributes:a,filter:n,includeZeros:!1,includeNegatives:!1,view:r,signal:i})]),u=null!=s&&"avgSize"in s&&s.avgSize,d=o.avg;if(!u||!d)return I(r);const c=m.getResolutionForScale(r.scale,r.spatialReference),p=u*u/(c*c)*.1;return{dotValue:g.roundValue(d/p)||1,referenceScale:r.scale,minSliderValue:1,maxSliderValue:g.roundValue(d)}}async function F(e){const{view:r,layer:t,attributes:a,signal:i,filter:n}=e,l=[];for(const m of a){const e=await T.getFieldsList({field:m.field,valueExpression:m.valueExpression});l.push(...e)}const s=await t.getSampleFeatures({view:r,sampleSize:R,requiredFields:l,filter:n,returnGeometry:!0,signal:i},"json"),{minDensity:o,maxDensity:u,avgDensity:d}=await S({features:s,attributes:a,includeZeros:!1,includeNegatives:!1,view:r});if(!d||!o||!u)return I(r);const c=m.getResolutionForScale(r.scale,r.spatialReference),p=c*c,y=g.roundValue(o*p),f=g.roundValue(u*p),b=10;let w=g.roundValue(d*p*b)||1;return w>f&&(w=f),{dotValue:w,referenceScale:r.scale,minSliderValue:y,maxSliderValue:f}}async function z(e){const r=await D(e),t=r.layer,i=t.geometryType,n=await O(r),l=n?.scheme;if(!l)throw new p("dot-density-renderer:insufficient-info","Unable to find dot-density scheme");const s=r.view,o=r.filter,u={layer:t,view:s,filter:o,attributes:r.attributes,signal:r.signal},d={layer:r.layer,view:s,filter:o,signal:r.signal},[m,g]=await Promise.all([r.trueDensity?F(u):B(u),r.outlineOptimizationEnabled?f(d).catch(w.errorCallback):null]),{dotValue:b,referenceScale:v,minSliderValue:h,maxSliderValue:S}=m,V=c.createUniqueColors(l.colors,r.attributes.length),T=r.attributes.map(((e,r)=>({field:e.field,valueExpression:e.valueExpression,label:e.label,valueExpressionTitle:e.valueExpressionTitle,color:V[r]}))),E=new a({attributes:T,dotBlendingEnabled:r.dotBlendingEnabled,outline:g?w.getSymbolOutlineFromScheme(l,i,g.opacity):null,dotValue:b,referenceScale:r.dotValueOptimizationEnabled?v:null,legendOptions:r.legendOptions});return g?.visualVariables.length&&(E.visualVariables=g.visualVariables.map((e=>e.clone()))),E.authoringInfo=new y({type:"dot-density",minSliderValue:h,maxSliderValue:S}),{renderer:E,dotDensityScheme:l,basemapId:n.basemapId,basemapTheme:n.basemapTheme}}async function U(e){const{creatorParameters:r,renderer:t}=await L(e),{layer:a,attributes:i,outlineOptimizationEnabled:n,view:l,signal:s,filter:o}=r,u={layer:a,view:l,filter:o,attributes:i,signal:s},[d,c]=await Promise.all([r.trueDensity?F(u):B(u),n?f({layer:a,view:l,signal:s,filter:o}).catch(w.errorCallback):null]),{dotValue:p,referenceScale:m,minSliderValue:y,maxSliderValue:g}=d;return t.dotValue=p,t.referenceScale=r.dotValueOptimizationEnabled?m:null,t.authoringInfo&&(t.authoringInfo.minSliderValue=y,t.authoringInfo.maxSliderValue=g),b.spliceVisualVariables(t,c?.visualVariables,b.findOutlineVVIndex),{renderer:t}}e.createRenderer=z,e.regenerateRenderer=U,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
