/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../Color","../../renderers/ClassBreaksRenderer","../../renderers/DictionaryRenderer","../../renderers/DotDensityRenderer","../../renderers/HeatmapRenderer","../../renderers/PieChartRenderer","../../renderers/Renderer","../../renderers/SimpleRenderer","../../renderers/UniqueValueRenderer","../../renderers/support/jsonUtils","../../core/Logger","../../core/colorUtils","../../core/Error","../../renderers/support/AuthoringInfo","../../renderers/support/HeatmapColorStop","../../renderers/support/heatmapUtils","./support/utils","../statistics/heatmapStatistics","../support/utils","../support/adapters/support/layerUtils","../symbology/heatmap"],(function(e,r,a,t,n,s,i,o,l,d,p,m,u,c,y,h,f,w,b,g,R,T){"use strict";const L=.01;async function S(e){if(!e?.layer||!e.view)throw new c("heatmap-renderer:missing-parameters","'layer' and 'view' parameters are required");const r={...e,layer:e.layer,view:e.view};r.radius??=null==r.blurRadius?18:f.gaussianBlurRadiusPxToKernelDensityRadiusPt(r.blurRadius),r.minRatio??=.01,r.maxRatio??=1,r.fadeRatio??=.2,r.fadeToTransparent??=!0;const a=[R.LayerType.CSVLayer,R.LayerType.FeatureLayer,R.LayerType.GeoJSONLayer,R.LayerType.KnowledgeGraphSublayer,R.LayerType.OGCFeatureLayer,R.LayerType.OrientedImageryLayer,R.LayerType.StreamLayer,R.LayerType.WFSLayer],t=R.createLayerAdapter(r.layer,a);if(!t)throw new c("heatmap-renderer:invalid-parameters","'layer' must be one of these types: "+R.getLayerTypeLabels(a).join(", "));r.layer=t;const n=null!=r.signal?{signal:r.signal}:null;await t.load(n);const s=await g.getFieldsList({field:r.field}),i=w.verifyBasicFieldValidity(t,s,"heatmap-renderer:invalid-parameters");if(i)throw i;return r}async function I(e){let r=e.scheme,a=null,t=null;const n=await w.getBasemapInfo(e.basemap,e.view);if(a=null!=n.basemapId?n.basemapId:null,t=null!=n.basemapTheme?n.basemapTheme:null,r)return{scheme:T.cloneScheme(r),basemapId:a,basemapTheme:t};const s=T.getSchemes({basemapTheme:t});return s&&(r=s.primaryScheme,a=s.basemapId,t=s.basemapTheme),{scheme:r,basemapId:a,basemapTheme:t}}async function v(e,a){const{field:t,basemap:n,radius:i,fadeToTransparent:o,heatmapScheme:l,view:d}=a,{scheme:p,basemapId:m,basemapTheme:c}=await I({basemap:n,scheme:l,view:d}),f=p.colors,w=f.length,b=null==e.min,g=b?[0,.04]:[e.min,e.max];let R;const S=a.fadeRatio??0,v=a.maxRatio??0,C=a.minRatio??0,U=(v-C)/(w-1),D=f[0],F=o?C:L,B=[new h({ratio:0,color:new r([D.r,D.g,D.b,0])}),new h({ratio:L,color:new r([D.r,D.g,D.b,0])}),new h({ratio:F,color:new r([D.r,D.g,D.b,F])})];u.createUniqueColors(f,w).forEach(((e,r)=>{const a=C+U*r;B.push(new h({ratio:a,color:e}))})),o&&(x(B,S),R=new y({fadeRatio:S}));return{renderer:new s({authoringInfo:R,radius:i,colorStops:B,field:t,minDensity:g[0],maxDensity:g[1]}),statistics:e,defaultValuesUsed:b,scheme:T.cloneScheme(p),basemapId:m,basemapTheme:c}}function x(e,r){const a=10*(1-r)+1,t=e.length-3,n=e[2].color.a;e.forEach(((e,s)=>{if(s<=2)return;const{color:i}=e,o=(s-3)/t;i.a=0===r?1:Math.min(Math.max(o*a+o+n,n),1)}))}async function C(e){const r=await S(e);return v(r.statistics??await b({layer:r.layer,field:r.field,radius:r.radius,view:r.view,filter:r.filter,signal:r.signal}),r)}function U(e){const{fadeRatio:r,renderer:a}=e,t=a.clone(),n=r??(t?.authoringInfo?.fadeRatio||0);return x(t.colorStops,n),t.authoringInfo?t.authoringInfo.fadeRatio=n:t.authoringInfo=new y({fadeRatio:n}),t}e.createRenderer=C,e.updateRenderer=U,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
