/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../renderers/ClassBreaksRenderer","../../renderers/DictionaryRenderer","../../renderers/DotDensityRenderer","../../renderers/HeatmapRenderer","../../renderers/PieChartRenderer","../../renderers/Renderer","../../renderers/SimpleRenderer","../../renderers/UniqueValueRenderer","../../renderers/support/jsonUtils","../../core/Logger","../../core/Error","../heuristics/outline","../heuristics/sizeRange","./support/utils","../support/binningUtils","../support/adapters/support/layerUtils","../symbology/location"],(function(e,r,a,i,n,o,l,s,t,m,p,c,d,y,u,b,h,f){"use strict";async function g(e){if(!e?.layer)throw new c("location-renderer:missing-parameters","'layer' parameter is required");e.forBinning&&b.verifyBinningParams(e,"location-renderer");const r={...e,layer:e.layer};r.symbolType=r.symbolType||"2d";const a=e.forBinning?h.binningCapableLayerTypes:h.featureCapableLayerTypes,i=h.createLayerAdapter(r.layer,a,e.forBinning);if(!i)throw new c("location-renderer:invalid-parameters","'layer' must be one of these types: "+h.getLayerTypeLabels(a).join(", "));r.layer=i;const n=null!=r.signal?{signal:r.signal}:null;await i.load(n);const o=i.geometryType;if(r.outlineOptimizationEnabled="polygon"===o&&r.outlineOptimizationEnabled,r.sizeOptimizationEnabled=("point"===o||"multipoint"===o||"polyline"===o)&&r.sizeOptimizationEnabled,"mesh"===o)r.symbolType="3d-volumetric",r.colorMixMode=r.colorMixMode||"replace",r.edgesType=r.edgesType||"none";else{if("3d-volumetric-uniform"===r.symbolType&&"point"!==o)throw new c("location-renderer:not-supported","3d-volumetric-uniform symbols are supported for point layers only");if(r.symbolType.includes("3d-volumetric")&&(!r.view||"3d"!==r.view.type))throw new c("location-renderer:invalid-parameters","'view' parameter should be an instance of SceneView when 'symbolType' parameter is '3d-volumetric' or '3d-volumetric-uniform'")}return r}async function w(e,r){let a=e.locationScheme,i=null,n=null;const o=await u.getBasemapInfo(e.basemap,e.view);if(i=null!=o.basemapId?o.basemapId:null,n=null!=o.basemapTheme?o.basemapTheme:null,a)return{scheme:f.cloneScheme(a),basemapId:i,basemapTheme:n};const l=f.getSchemes({basemapTheme:n,geometryType:r,worldScale:!!e.symbolType?.includes("3d-volumetric"),view:e.view});return l&&(a=l.primaryScheme,i=l.basemapId,n=l.basemapTheme),{scheme:a,basemapId:i,basemapTheme:n}}async function T(e){const r=await g(e),a=r.layer.geometryType,i=await w(r,a),n=i.scheme;if(!n)throw new c("location-renderer:insufficient-info","Unable to find location scheme");const{view:o,layer:l,signal:t,filter:m}=r,[p,b]=await Promise.all([r.outlineOptimizationEnabled?d({view:o,layer:l,signal:t,filter:m}).catch(u.errorCallback):null,r.sizeOptimizationEnabled?y({view:o,layer:l,signal:t,filter:m}).catch(u.errorCallback):null]),h=p?.opacity,T=new s({symbol:u.createSymbol(a,{type:r.symbolType,color:n.color,size:u.getSymbolSizeFromScheme(n,a),outline:u.getSymbolOutlineFromScheme(n,a,h),meshInfo:{colorMixMode:r.colorMixMode,edgesType:r.edgesType}})});return p?.visualVariables.length&&(T.visualVariables=p.visualVariables.map((e=>e.clone()))),b?.minSize&&(T.visualVariables?T.visualVariables.push(b.minSize):T.visualVariables=[b.minSize]),{renderer:T,locationScheme:f.cloneScheme(n),basemapId:i.basemapId,basemapTheme:i.basemapTheme}}e.createRenderer=T,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
