/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../Color","../../renderers/ClassBreaksRenderer","../../renderers/DictionaryRenderer","../../renderers/DotDensityRenderer","../../renderers/HeatmapRenderer","../../renderers/PieChartRenderer","../../renderers/Renderer","../../renderers/SimpleRenderer","../../renderers/UniqueValueRenderer","../../renderers/support/jsonUtils","../../core/Logger","../../symbols","../../core/arrayUtils","../../core/colorUtils","../../core/Error","../../core/screenUtils","../../intl/messages","../../layers/support/AggregateField","../../layers/support/ExpressionInfo","../../renderers/support/AttributeColorInfo","../../renderers/support/OthersCategory","../heuristics/outline","../heuristics/sizeRange","./size","./support/regenerateUtils","./support/utils","../statistics/predominantCategories","../statistics/support/utils","../support/binningUtils","../support/utils","../support/adapters/support/layerUtils","../symbology/pieChart","../../symbols/support/cimSymbolUtils","../../symbols/SimpleLineSymbol"],(function(e,r,a,i,n,t,s,l,o,u,p,c,d,m,f,y,b,h,g,w,v,S,z,V,E,C,T,x,I,L,O,$,k,B,q){"use strict";const R=[$.LayerType.CSVLayer,$.LayerType.FeatureLayer,$.LayerType.GeoJSONLayer,$.LayerType.OGCFeatureLayer,$.LayerType.OrientedImageryLayer,$.LayerType.StreamLayer,$.LayerType.WFSLayer];async function P(e){if(!(e?.layer&&e.view&&e.attributes?.length))throw new y("pie-chart-renderer:missing-parameters","'layer', 'view' and 'attributes' parameters are required");if(e.attributes.length>10)throw new y("pie-chart-renderer:invalid-parameters","PieChart renderer does not support more than 10 attributes");e.forBinning&&L.verifyBinningParams(e,"pie-chart-renderer");const r={...e,layer:e.layer,view:e.view,attributes:e.attributes};r.shape=r.shape||"pie",r.othersCategoryEnabled??=!0,r.includeSizeVariable=e.includeSizeVariable||!1;const a=e.forBinning?$.binningCapableLayerTypes:R,i=$.createLayerAdapter(r.layer,a,e.forBinning);if(!i)throw new y("pie-chart-renderer:invalid-parameters","'layer' must be one of these types: "+$.getLayerTypeLabels(a).join(", "));const n=null!=r.signal?{signal:r.signal}:null;await Promise.all([e.view.when(),i.load(n)]);const t=i.geometryType,s="polygon"===t,l="point"===t||"multipoint"===t||s;if(r.outlineOptimizationEnabled=!!s&&r.outlineOptimizationEnabled,r.sizeOptimizationEnabled=!!l&&r.sizeOptimizationEnabled,!l)throw new y("pie-chart-renderer:not-supported","PieChart renderer is only supported for point and polygon layers");const o=[],u=r.attributes;for(const c of u){const e=await O.getFieldsList({field:c.field,valueExpression:c.valueExpression});o.push(...e)}const p=T.verifyBasicFieldValidity(i,o.filter(Boolean),"pie-chart-renderer:invalid-parameters");if(p)throw p;return{...r,layer:i}}async function U(e){const r="regenerate-pie-chart-renderer";await C.processRegenerateParams(e,r);const a=await C.getRendererToUpdate(e);if("pie-chart"!==C.getStyleType(a))throw new y(`${r}:invalid-parameters`,"Renderer is invalid");const{visualVariables:i}=a,{layer:n,forBinning:t,filter:s,view:l,signal:o}=e,u=C.hasOutlineVV(a),p=C.hasScaleDependentSizeVV(a),c=i?.some(C.isSizeVV),d=a.attributes.map((e=>({field:e.field,label:e.label,valueExpression:e.valueExpression,valueExpressionTitle:e.valueExpressionTitle}))),m=await P({layer:n,attributes:d,outlineOptimizationEnabled:u,sizeOptimizationEnabled:p,includeSizeVariable:c,forBinning:t,filter:s,view:l,signal:o});return{...e,creatorParameters:m,renderer:a}}async function F(e){let r=e.pieChartScheme,a=null,i=null;const n=await T.getBasemapInfo(e.basemap,e.view);if(a=null!=n.basemapId?n.basemapId:null,i=null!=n.basemapTheme?n.basemapTheme:null,r)return{scheme:k.cloneScheme(r),basemapId:a,basemapTheme:i};const t=k.getSchemes({numColors:e.attributes.length,geometryType:e.layer.geometryType,basemapTheme:i});return t&&(r=t.primaryScheme,a=t.basemapId,i=t.basemapTheme),{scheme:r,basemapId:a,basemapTheme:i}}async function M(e,r){const{valueExpression:a,sqlExpression:i,sqlWhere:n}=I.getSumOfAttributesExpr(e.attributes),t=await h.fetchMessageBundle("esri/smartMapping/t9n/smartMapping");return E.createVisualVariables({layer:e.layer,basemap:e.basemap,valueExpression:a,sqlExpression:i,sqlWhere:n,sizeScheme:r,sizeOptimizationEnabled:e.sizeOptimizationEnabled,legendOptions:{title:t.sumOfCategories},view:e.view,signal:e.signal})}async function j(e){const[r,a]=await Promise.all([P(e),h.fetchMessageBundle("esri/smartMapping/t9n/smartMapping")]),i=await F(r),n=i?.scheme;if(!n)throw new y("pie-chart-renderer:insufficient-info","Unable to find pie-chart scheme");const{layer:t,includeSizeVariable:l,sizeOptimizationEnabled:o,outlineOptimizationEnabled:u,view:p,signal:c,filter:d}=r,g=n.sizeScheme,w=r.attributes,E=w.map((e=>e.field)).filter(m.isSome),[C,I,L,O]=await Promise.all([E.length>1?x({layer:t,fields:E,view:p,signal:c,filter:d}):null,l?M(r,g):null,!l&&o?V({layer:t,view:p,signal:c,filter:d}).catch(T.errorCallback):null,u?z({layer:t,view:p,signal:c,filter:d}).catch(T.errorCallback):null]),$=C?.predominantCategoryInfos?{uniqueValueInfos:C.predominantCategoryInfos}:{uniqueValueInfos:E.map((e=>({value:e,count:0})))},B=f.createUniqueColors(n.colors,w.length),R=w.map(((e,r)=>new v({field:e.field,valueExpression:e.valueExpression,label:e.label,valueExpressionTitle:e.valueExpressionTitle,color:B[r]}))),U=t.geometryType,j=null!=g&&"background"in g&&g.background,A=new s({attributes:R,othersCategory:new S.OthersCategory({label:a.other,color:r.othersCategoryEnabled?n.colorForOthersCategory:null,threshold:.04}),holePercentage:"donut"===r.shape?.45:0,backgroundFillSymbol:j?T.createSymbol(U,{type:"2d",color:j.color,outline:T.getSymbolOutlineFromScheme(j,U,O?.opacity)}):null,size:b.toPt(n.size),outline:new q(T.getSymbolOutlineFromScheme(n,"point",O?.opacity)),legendOptions:r.legendOptions});if(I&&(D(I,o,U),A.authoringInfo=I.authoringInfo.clone(),A.visualVariables=I.visualVariables?.map((e=>e.clone()))),O?.visualVariables?.length){const e=O.visualVariables.map((e=>e.clone())).filter((e=>"color"!==e.type&&"rotation"!==e.type));A.visualVariables?A.visualVariables.push(...e):A.visualVariables=e}return L?.minSize&&(N(L,U),A.visualVariables?A.visualVariables.push(L.minSize):A.visualVariables=[L.minSize]),{renderer:A,pieChartScheme:k.cloneScheme(n),size:I,basemapId:i.basemapId,basemapTheme:i.basemapTheme,statistics:$}}async function A(e){const{creatorParameters:r,view:a,signal:i,filter:n,renderer:t}=await U(e),{layer:s,outlineOptimizationEnabled:l,includeSizeVariable:o,sizeOptimizationEnabled:u}=r,p=await F(r),c=p?.scheme?.sizeScheme,[d,m,f]=await Promise.all([l?z({layer:s,view:a,signal:i,filter:n}).catch(T.errorCallback):null,o?M(r,c):null,!o&&u?V({layer:s,view:a,signal:i,filter:n}).catch(T.errorCallback):null]),y=s.geometryType;if(m&&(D(m,u,y),C.spliceVisualVariables(t,m?.visualVariables,C.findSizeVVIndex),C.updateAuthoringInfoVisualVariable(t,m?.authoringInfo,"size")),d?.visualVariables?.length){const e=d.visualVariables.map((e=>e.clone())).filter((e=>"color"!==e.type&&"rotation"!==e.type));C.spliceVisualVariables(t,e,C.findOutlineVVIndex)}return f?.minSize&&(N(f,y),C.spliceVisualVariables(t,f?.minSize,C.findScaleDependentSizeVVIndex)),{renderer:t}}function D(e,r,a){r||e.visualVariables.forEach((e=>{"number"==typeof e.minSize&&"number"==typeof e.maxSize&&(e.minSize*=2.5,e.maxSize*=1.8)})),r&&"point"===a&&e.visualVariables.forEach((e=>{e?.minSize&&"object"==typeof e.minSize&&e.minSize?.stops?.forEach((e=>{e.size*=1.8}))}))}function N(e,r){"point"===r&&e.minSize.stops?.forEach((e=>{e.size*=2.5})),"polygon"===r&&e.minSize.stops?.forEach((e=>{e.size*=1.8}))}const _=new Set(["unique-value","class-breaks"]),W=new r("#aaaaaa"),G=new r("#5c5c5c"),H=[new r("#e60049"),new r("#0bb4ff"),new r("#50e991"),new r("#e6d800"),new r("#9b19f5"),new r("#ffa300"),new r("#dc0ab4"),new r("#b3d4ff"),new r("#00bfa0"),new r("#f0cccc")];async function J(e){if(!e||!e.layer)throw new y("pie-chart-cluster-renderer:missing-parameters","'layer' parameter is required");const r={...e};r.shape=r.shape||"pie",r.defaultSymbolEnabled??=!0;const a=e.layer;if(!$.getLayerTypes(R).includes(a.type))throw new y("pie-chart-cluster-renderer:invalid-parameters","'layer' must be one of these types: "+$.getLayerTypeLabels(R).join(", "));const i=null!=r.signal?{signal:r.signal}:null;await a.load(i);if(!("point"===a.geometryType))throw new y("pie-chart-cluster-renderer:invalid-parameters","Cluster renderers are only supported for point layers");const{renderer:n}=a;if(!n)throw new y("pie-chart-cluster-renderer:invalid-parameters","input layer does not have a renderer.");if(!_.has(n.type))throw new y("pie-chart-cluster-renderer:invalid-parameters",`Cannot create a pie chart renderer for clusters based on a ${n.type} renderer.`);if("valueExpression"in n&&n.valueExpression)throw new y("pie-chart-cluster-renderer:invalid-parameters","Cannot create a pie chart renderer for clusters from a layer whose renderer contains a valueExpression.");if("unique-value"===n.type){if(n.field2)throw new y("pie-chart-cluster-renderer:invalid-parameters","Cannot create a pie chart renderer for clusters from a UniqueValueRenderer using more than one field.");if(null!=n.uniqueValueInfos&&n.uniqueValueInfos.length>10)throw new y("pie-chart-cluster-renderer:invalid-parameters","PieChart cluster renderer cannot be created from a UniqueValueRenderer with more than 10 unique value infos.")}if("class-breaks"===n.type){if(n.classBreakInfos.length<2)throw new y("pie-chart-cluster-renderer:invalid-parameters","Cannot create a pie chart renderer for clusters from a layer renderer with a continuous color or size gradient.");if(n.classBreakInfos.length>10)throw new y("pie-chart-cluster-renderer:invalid-parameters","PieChart cluster renderer can not be created from a ClassBreaksRenderer with more than 10 class break infos.");if("class-breaks-size"===n?.authoringInfo?.type)throw new y("pie-chart-cluster-renderer:invalid-parameters","PieChart cluster renderer can not be created from a ClassBreaksRenderer with breaks varied by size instead of color.")}return r}async function Z(e){const r=await J(e),{layer:a,shape:i,defaultSymbolEnabled:n,legendOptions:t}=r,{renderer:l}=a,o=(await h.fetchMessageBundle("esri/smartMapping/t9n/smartMapping")).other;let u=[];"unique-value"===l?.type&&(u=K({renderer:l,defaultSymbolEnabled:n,defaultLabelBackup:o})),"class-breaks"===l?.type&&(u=Q({renderer:l,defaultSymbolEnabled:n,defaultLabelBackup:o}));const p=[],c=[];for(const s of u){const{field:e,color:r}=s;p.push(e),c.push(new v({color:r,field:e.name,label:e.alias}))}return{fields:p,renderer:new s({attributes:c,legendOptions:t,holePercentage:"donut"===i?.45:0,outline:null,size:9,othersCategory:null})}}function K(e){const{renderer:r,defaultSymbolEnabled:a,defaultLabelBackup:i}=e,{field:n,defaultSymbol:t,defaultLabel:s}=r,l=r.uniqueValueInfos??[],o=t&&a,u=o?9:10,p=f.createUniqueColors(H,u),c=(n?l.slice(0,u).map(((e,r)=>{const a=e.label,i=p[r];return{field:new g({name:X(e.value?.toString()),alias:a,onStatisticExpression:new w({title:`Field definition - ${a}`,expression:ee(n,e),returnType:"number"}),statisticType:"sum"}),color:Y(e.symbol,i)}})):null)??[];if(o){const e="cluster_default",r=s||i;c.push({field:new g({name:X(e),alias:r,onStatisticExpression:new w({title:`Field definition - ${r}`,expression:re(n,l),returnType:"number"}),statisticType:"sum"}),color:Y(t,G)})}return c}function Q(e){const{renderer:r,defaultSymbolEnabled:a,defaultLabelBackup:i}=e,{field:n,classBreakInfos:t,defaultSymbol:s,defaultLabel:l}=r,o=s&&a,u=o?9:10,p=f.createUniqueColors(H,u),c=t.slice(0,u).map(((e,r)=>{const a=e.label||`${e.minValue} - ${e.maxValue}`,i=p[r];return{field:new g({name:X(a),alias:a,onStatisticExpression:new w({title:`Field definition - ${a}`,expression:ae(n,e),returnType:"number"}),statisticType:"sum"}),color:Y(e.symbol,i)}}));if(o){const e="cluster_default",r=l||i;c.push({field:new g({name:X(e),alias:r,onStatisticExpression:new w({title:`Field definition - ${r}`,expression:ie(n,t),returnType:"number"}),statisticType:"sum"}),color:Y(s,G)})}return c}function X(e){return"SUM_"+(e+"").replaceAll(/[^a-zA-Z0-9_]/g,"_")}function Y(e,r){if("simple-marker"===e?.type&&e.color)return e.color.clone();if("cim"===e?.type){const r=B.getCIMSymbolColor(e);if(r)return r.clone()}return r?r.clone():W.clone()}function ee(e,r){return`Number(Text($feature["${e}"]) == "${r.value+""}")`}function re(e,r){return`Number(!(${r.map((r=>`(Text($feature["${e}"]) == "${r.value+""}")`)).join(" || ")}))`}function ae(e,r){return`Number($feature["${e}"] >= ${r.minValue} && $feature["${e}"] < ${r.maxValue})`}function ie(e,r){return`Number(!(${r.map((r=>`($feature["${e}"] >= ${r.minValue} && $feature["${e}"] < ${r.maxValue})`)).join(" || ")}))`}e.createRenderer=j,e.createRendererForClustering=Z,e.regenerateRenderer=A,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
