/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../core/colorUtils","../../core/Error","../../intl/messages","../../renderers/support/AuthoringInfo","../../renderers/support/AuthoringInfoVisualVariable","../../renderers/support/numberUtils","../../renderers/visualVariables/OpacityVariable","../../renderers/visualVariables/support/OpacityStop","../../renderers/visualVariables/support/VisualVariableLegendOptions","../heuristics/outline","./size","./type","./support/regenerateUtils","./support/utils","../statistics/predominantCategories","../statistics/support/predominanceUtils","../support/binningUtils","../support/adapters/support/layerUtils","../symbology/predominance"],(function(e,a,i,n,r,l,s,t,o,p,d,m,u,c,y,b,g,f,h,v){"use strict";async function w(e){if(!(e?.layer&&e.view&&e.fields?.length))throw new i("predominance-renderer:missing-parameters","'layer', 'view' and 'fields' parameters are required");if(e.fields.length<2)throw new i("predominance-renderer:invalid-parameters","Minimum 2 fields are required");if(e.fields.length>10)throw new i("predominance-renderer:invalid-parameters","Maximum 10 fields are supported");e.forBinning&&f.verifyBinningParams(e,"predominance-renderer");const a={...e,layer:e.layer,fields:e.fields};a.symbolType=a.symbolType||"2d",a.defaultSymbolEnabled??=!0,a.includeOpacityVariable=e.includeOpacityVariable||!1,a.includeSizeVariable=e.includeSizeVariable||!1,a.sortBy??="count";const n=e.forBinning?h.binningCapableLayerTypes:h.featureCapableLayerTypes,r=h.createLayerAdapter(a.layer,n,e.forBinning);if(!r)throw new i("predominance-renderer:invalid-parameters","'layer' must be one of these types: "+h.getLayerTypeLabels(h.featureCapableLayerTypes).join(", "));const l=null!=a.signal?{signal:a.signal}:null;await r.load(l);const s=r.geometryType,t=a.symbolType.includes("3d");if(a.outlineOptimizationEnabled="polygon"===s&&a.outlineOptimizationEnabled,a.includeSizeVariable||(a.sizeOptimizationEnabled=("point"===s||"multipoint"===s||"polyline"===s)&&a.sizeOptimizationEnabled),"mesh"===s)a.symbolType="3d-volumetric",a.colorMixMode=a.colorMixMode||"replace",a.edgesType=a.edgesType||"none",a.sizeOptimizationEnabled=!1;else{if(t&&("polyline"===s||"polygon"===s))throw new i("predominance-renderer:not-supported","3d symbols are not supported for polyline and polygon layers");if(a.symbolType.includes("3d-volumetric")&&(!a.view||"3d"!==a.view.type))throw new i("predominance-renderer:invalid-parameters","'view' parameter should be an instance of SceneView when 'symbolType' parameter is '3d-volumetric' or '3d-volumetric-uniform'")}const o=a.fields.map((e=>e.name)),p=y.verifyBasicFieldValidity(r,o,"predominance-renderer:invalid-parameters");if(p)throw p;return{...a,layer:r}}async function V(e){const a="regenerate-predominance-renderer";await c.processRegenerateParams(e,a);const n=await c.getRendererToUpdate(e);if("predominance"!==c.getStyleType(n))throw new i(`${a}:invalid-parameters`,"Renderer is invalid");const{visualVariables:r}=n,{layer:l,forBinning:s,filter:t,view:o,signal:p}=e,d=c.hasOutlineVV(n),m=c.hasScaleDependentSizeVV(n),u=r?.some(c.isSizeVV),y=r?.some((e=>"opacity"===e.type)),b=n.authoringInfo,g=b?.fields?.map((e=>({name:e})));if(!g?.length)throw new i(`${a}:invalid-parameters`,"Fields are required");const f=await w({layer:l,fields:g,outlineOptimizationEnabled:d,sizeOptimizationEnabled:m,includeSizeVariable:u,includeOpacityVariable:y,forBinning:s,filter:t,view:o,signal:p});return{...e,creatorParameters:f,renderer:n}}async function z(e){let a=e.predominanceScheme,i=null,n=null;const r=await y.getBasemapInfo(e.basemap,e.view);if(i=null!=r.basemapId?r.basemapId:null,n=null!=r.basemapTheme?r.basemapTheme:null,a)return{scheme:v.cloneScheme(a),basemapId:i,basemapTheme:n};const l=v.getSchemes({basemapTheme:n,geometryType:e.geometryType,numColors:e.numColors,theme:e.theme,worldScale:e.worldScale,view:e.view});return l&&(a=l.primaryScheme,i=l.basemapId,n=l.basemapTheme),{scheme:a,basemapId:i,basemapTheme:n}}async function S(e,i,l,s){const t=await n.fetchMessageBundle("esri/smartMapping/t9n/smartMapping"),o=e.layer,{view:p,filter:m,signal:c}=e,[g,f]=await Promise.all([b({layer:o,fields:s,view:p,filter:m,signal:c}),e.outlineOptimizationEnabled?d({layer:o,view:p,filter:m,signal:c}).catch(y.errorCallback):null]);let h=g;g?.predominantCategoryInfos||(h={predominantCategoryInfos:s.map((e=>({value:e,count:0})))});const v=f?.opacity,w=await u.createRenderer({layer:o,basemap:e.basemap,valueExpression:i.valueExpression,valueExpressionTitle:t.predominantCategory,numTypes:-1,defaultSymbolEnabled:e.defaultSymbolEnabled,sortBy:e.sortBy,typeScheme:l,statistics:{uniqueValueInfos:h.predominantCategoryInfos},legendOptions:e.legendOptions,outlineOptimizationEnabled:!1,sizeOptimizationEnabled:(!e.includeSizeVariable||!e.sizeOptimizationEnabled)&&e.sizeOptimizationEnabled,symbolType:e.symbolType,colorMixMode:e.colorMixMode,edgesType:e.edgesType,filter:e.filter,view:e.view,signal:e.signal}),{renderer:V,basemapId:z,basemapTheme:S,uniqueValueInfos:T,excludedUniqueValueInfos:E}=w,O=V.uniqueValueInfos??[],I={};for(const a of e.fields){const e=o.getField(a.name);I[e.name]=a.label||e&&e.alias||a.name}if(O.forEach(((e,a)=>{const i=I[e.value];e.label=i,T[a].label=i})),e.includeSizeVariable){let i=o.geometryType,n=null;if("polygon"===i){const a=l.sizeScheme,r=a.background;V.backgroundFillSymbol=y.createSymbol(i,{type:e.symbolType,color:r.color,outline:y.getSymbolOutlineFromScheme(r,i,v)}),n=a.marker.size,i="point"}else if("polyline"===i){n=l.width}else{n=l.size}const r=a.createUniqueColors(l.colors,O.length);O.forEach(((a,s)=>{const t=y.createSymbol(i,{type:e.symbolType,color:r[s],size:n,outline:y.getSymbolOutlineFromScheme(l,i,v),meshInfo:{colorMixMode:e.colorMixMode,edgesType:e.edgesType}});a.symbol=t,T[s].symbol=t.clone()}))}return f?.visualVariables.length&&(V.visualVariables=f.visualVariables.map((e=>e.clone()))),V.authoringInfo=new r({type:"predominance",fields:[...s]}),{renderer:V,predominantCategoryInfos:T,excludedCategoryInfos:E,predominanceScheme:l,basemapId:z,basemapTheme:S}}async function T(e,a,i){const r=await n.fetchMessageBundle("esri/smartMapping/t9n/smartMapping");return m.createVisualVariables({layer:e.layer,basemap:e.basemap,valueExpression:a.valueExpression,sqlExpression:a.statisticsQuery.sqlExpression,sqlWhere:a.statisticsQuery.sqlWhere,sizeScheme:i,sizeOptimizationEnabled:e.sizeOptimizationEnabled,worldScale:!!e.symbolType?.includes("3d-volumetric"),legendOptions:{title:r.sumOfCategories},filter:e.filter,view:e.view,signal:e.signal})}async function E(e,a){const i=await n.fetchMessageBundle("esri/smartMapping/t9n/smartMapping"),d=await y.getSummaryStatistics({layer:e.layer,valueExpression:a.valueExpression,sqlExpression:a.statisticsQuery.sqlExpression,sqlWhere:a.statisticsQuery.sqlWhere,filter:e.filter,view:e.view,signal:e.signal}),{avg:m,stddev:u}=d,c=null==m||null==u,b=1/e.fields.length*100;let g=c?100:m+1.285*u;g>100&&(g=100);const f=s.round([b,g],{strictBounds:!0}),h=new t({valueExpression:a.valueExpression,stops:[new o({value:f[0],opacity:.15}),new o({value:f[1],opacity:1})],legendOptions:new p({title:i.strengthOfPredominance})}),v=new l({type:"opacity",minSliderValue:d.min,maxSliderValue:d.max});return{visualVariable:h,statistics:d,defaultValuesUsed:c,authoringInfo:new r({visualVariables:[v]})}}async function O(e){const a=await w(e),i=a.layer,n=(await z({basemap:a.basemap,geometryType:i.geometryType,numColors:a.fields.length,predominanceScheme:a.predominanceScheme,worldScale:!!a.symbolType?.includes("3d-volumetric"),view:a.view})).scheme,l=a.fields.map((e=>e.name)),s=g.getPredominanceExpressions(i,l),t=S(a,s.predominantCategory,n,l),o=a.includeSizeVariable?T(a,s.size,n.sizeScheme):null,p=a.includeOpacityVariable?E(a,s.opacity):null,[d,m,u]=await Promise.all([t,o,p]),c=[],y=[];if(m&&(Array.prototype.push.apply(c,m.visualVariables.map((e=>e.clone()))),delete m.sizeScheme,d.size=m,Array.prototype.push.apply(y,m.authoringInfo.visualVariables.map((e=>e.clone())))),u&&(c.push(u.visualVariable.clone()),d.opacity=u,Array.prototype.push.apply(y,u.authoringInfo.visualVariables.map((e=>e.clone())))),c.length){const e=d.renderer.visualVariables||[];Array.prototype.push.apply(e,c),d.renderer.visualVariables=e,d.renderer.authoringInfo??=new r,d.renderer.authoringInfo.visualVariables=y}return d}async function I(e){const{creatorParameters:a,view:i,signal:n,filter:r,renderer:l}=await V(e),{layer:s,fields:t,outlineOptimizationEnabled:o,includeSizeVariable:p,includeOpacityVariable:m}=a,u=t.map((e=>e.name)),b=g.getPredominanceExpressions(s,u),f=(await z({geometryType:s.geometryType,numColors:a.fields.length,view:a.view})).scheme,h=f&&"sizeScheme"in f?f.sizeScheme:null,[v,w,S]=await Promise.all([o?d({layer:s,view:i,signal:n,filter:r}).catch(y.errorCallback):null,p?T(a,b.size,h):null,m?E(a,b.opacity):null]);return c.spliceVisualVariables(l,v?.visualVariables,c.findOutlineVVIndex),c.spliceVisualVariables(l,w?.visualVariables,c.findSizeVVIndex),c.spliceVisualVariables(l,S?.visualVariable,c.findOpacityVVIndex),c.updateAuthoringInfoVisualVariable(l,w?.authoringInfo,"size"),c.updateAuthoringInfoVisualVariable(l,S?.authoringInfo,"opacity"),{renderer:l}}e.createRenderer=O,e.regenerateRenderer=I,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
