/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../renderers/ClassBreaksRenderer","../../renderers/DictionaryRenderer","../../renderers/DotDensityRenderer","../../renderers/HeatmapRenderer","../../renderers/PieChartRenderer","../../renderers/Renderer","../../renderers/SimpleRenderer","../../renderers/UniqueValueRenderer","../../renderers/support/jsonUtils","../../core/Logger","../../core/colorUtils","../../core/Error","../../core/screenUtils","../../core/accessorSupport/ensureType","../../intl/messages","../../renderers/support/AuthoringInfo","../../renderers/support/AuthoringInfoSizeStop","../../renderers/support/AuthoringInfoVisualVariable","../../renderers/support/utils","../../renderers/visualVariables/SizeVariable","../../renderers/visualVariables/support/castSizeVariable","../../renderers/visualVariables/support/SizeVariableLegendOptions","../../renderers/visualVariables/support/sizeVariableUtils","../heuristics/ageUnit","../heuristics/outline","../heuristics/referenceSize","../heuristics/sizeRange","./support/referenceSizeUtils","./support/regenerateUtils","./support/utils","../statistics/support/ageUtils","../support/binningUtils","../support/utils","../support/adapters/support/layerUtils","../symbology/size","../../symbols/support/utils"],(function(e,i,a,r,n,s,l,t,o,u,m,d,p,c,y,f,z,b,v,g,h,w,S,V,T,x,E,O,F,R,I,B,k,C,L,q,A){"use strict";const D=2**53-1;async function U(e){if(!(e&&e.layer&&(e.field||e.valueExpression||e.sqlExpression)))throw new p("size-visual-variable:missing-parameters","'layer' and 'field', 'valueExpression' or 'sqlExpression' parameters are required");if(e.valueExpression&&!e.sqlExpression&&!e.view)throw new p("size-visual-variable:missing-parameters","View is required when 'valueExpression' is specified");if("reference-size"===e.theme&&!e.view&&!e.field)throw new p("size-visual-variable:missing-parameters","'view' and 'field' are required when 'theme' is 'reference-size'");if("reference-size"===e.theme&&e.valueExpression)throw new p("size-visual-variable:missing-parameters","'valueExpression' is not supported when 'theme' is 'reference-size'");e.forBinning&&k.verifyBinningParams(e,"size-visual-variable");const i={...e},a=e.forBinning?L.binningCapableLayerTypes:L.featureCapableLayerTypes,r=L.createLayerAdapter(i.layer,a,e.forBinning);if(!r)throw new p("size-visual-variable:invalid-parameters","'layer' must be one of these types: "+L.getLayerTypeLabels(a).join(", "));"height"===i.axis&&(i.sizeOptimizationEnabled=!1);const n=null!=i.signal?{signal:i.signal}:null;await r.load(n);const s=r.geometryType;if("mesh"===s)throw new p("size-visual-variable:invalid-parameters","Size visualization is not applicable to layers with 'mesh' geometry type");if(i.worldScale){if("polyline"===s||"polygon"===s)throw new p("size-visual-variable:not-supported","'worldScale' sizing is not supported for polyline and polygon layers");if(!i.view||"3d"!==i.view.type)throw new p("size-visual-variable:invalid-parameters","'view' parameter should be an instance of SceneView when 'worldScale' parameter is true")}if("reference-size"===i.theme&&!e.forBinning&&"polygon"!==s)throw new p("size-visual-variable:invalid-parameters","Reference size is only supported for polygon layers");const l=await C.getFieldsList({field:i.field,normalizationField:i.normalizationField,valueExpression:i.valueExpression}),t=I.verifyBasicFieldValidity(r,l,"size-visual-variable:invalid-parameters");if(t)throw t;return await G(i),{...i,layer:r}}async function P(e){if(!(e&&e.layer&&(e.field||e.valueExpression||e.sqlExpression)))throw new p("size-continuous-renderer:missing-parameters","'layer' and 'field', 'valueExpression' or 'sqlExpression' parameters are required");if(e.valueExpression&&!e.sqlExpression&&!e.view)throw new p("size-continuous-renderer:missing-parameters","View is required when 'valueExpression' is specified");e.forBinning&&k.verifyBinningParams(e,"size-continuous-renderer");const i={...e};i.symbolType=i.symbolType||"2d",i.defaultSymbolEnabled??=!0;const a=e.forBinning?L.binningCapableLayerTypes:L.featureCapableLayerTypes,r=L.createLayerAdapter(i.layer,a,e.forBinning);if(!r)throw new p("size-continuous-renderer:invalid-parameters","'layer' must be one of these types: "+L.getLayerTypeLabels(a).join(", "));const n=null!=i.signal?{signal:i.signal}:null;await r.load(n);const s=r.geometryType,l=i.symbolType.includes("3d");if(i.outlineOptimizationEnabled="reference-size"!==i.theme&&"polygon"===s&&i.outlineOptimizationEnabled,"mesh"===s)throw new p("size-continuous-renderer:invalid-parameters","Size visualization is not applicable to layers with 'mesh' geometry type");if(l&&("polyline"===s||"polygon"===s))throw new p("size-continuous-renderer:not-supported","3d symbols are not supported for polyline and polygon layers");if(i.symbolType.includes("3d-volumetric")&&(!i.view||"3d"!==i.view.type))throw new p("size-continuous-renderer:invalid-parameters","'view' parameter should be an instance of SceneView when 'symbolType' parameter is '3d-volumetric' or 3d-volumetric-uniform");if("reference-size"===i.theme&&!e.forBinning&&"polygon"!==s)throw new p("size-continuous-renderer:invalid-parameters","Reference size is only supported for polygon layers");const t=await C.getFieldsList({field:i.field,normalizationField:i.normalizationField,valueExpression:i.valueExpression}),o=I.verifyBasicFieldValidity(r,t,"size-continuous-renderer:invalid-parameters");if(o)throw o;return await G(i),{...i,layer:r}}async function G(e){const i=e.layer;if(("polygon"===i.geometryType||e.forBinning)&&e.view&&e.field&&!e.valueExpression&&(!e.theme||"reference-size"===e.theme)){try{e.referenceSizeResult=e.referenceSizeResult??await E({layer:i,view:e.view,filter:e.filter,forBinning:e.forBinning,signal:e.signal})}catch{}!e.theme&&e.referenceSizeResult?.isGrid&&(e.theme="reference-size"),e.referenceSizeOptions?.symbolStyle||(e.referenceSizeOptions?e.referenceSizeOptions.symbolStyle="circle":e.referenceSizeOptions={symbolStyle:"circle"})}}async function M(e){if(!e||!(e.layer&&e.view&&e.sizeStops))throw new p("update-renderer-with-reference-size:missing-parameters","'layer', 'view and 'sizeStops' parameters are required");const{view:i,forBinning:a}=e,r=e.forBinning?L.binningCapableLayerTypes:L.featureCapableLayerTypes,n=L.createLayerAdapter(e.layer,r,e.forBinning);if(!n)throw new p("update-renderer-with-reference-size:invalid-parameters","'layer' must be one of these types: "+L.getLayerTypeLabels(r).join(", "));const s=n.layer;let l=e.renderer;if(!l)if(e.forBinning){if(!("featureReduction"in s&&s.featureReduction&&"renderer"in s.featureReduction&&s.featureReduction.renderer)||"class-breaks"!==s.featureReduction.renderer.type&&"unique-value"!==s.featureReduction.renderer.type)throw new p("update-renderer-with-reference-size:invalid-parameters","Feature reduction renderer is not supported");l=s.featureReduction.renderer}else{if(!("renderer"in s)||!s.renderer||"class-breaks"!==s.renderer.type&&"unique-value"!==s.renderer.type)throw new p("update-renderer-with-reference-size:invalid-parameters","Renderer is not supported");l=s.renderer}const t=l.authoringInfo;if(!t||!t?.visualVariables?.some((e=>"reference-size"===e.theme)))throw new p("update-renderer-with-reference-size:invalid-parameters","'renderer.authoringInfo.visualVariables' should have an authoringInfoVisualVariable with 'theme' set to 'reference-size'");const o=e.isGrid??(await E({view:i,layer:s,forBinning:a}))?.isGrid;return{...e,isGrid:o,renderer:l,layer:n}}async function j(e){if(!e||!e.layer||!e.field&&!e.valueExpression)throw new p("size-class-breaks-renderer:missing-parameters","'layer' and 'field' or 'valueExpression' parameters are required");if(e.valueExpression&&!e.view)throw new p("size-class-breaks-renderer:missing-parameters","View is required when 'valueExpression' is specified");e.forBinning&&k.verifyBinningParams(e,"size-class-breaks-renderer");const i={...e};i.symbolType=i.symbolType||"2d",i.defaultSymbolEnabled??=!0,i.classificationMethod??="equal-interval",i.normalizationType=C.getNormalizationType(i);const a=e.forBinning?L.binningCapableLayerTypes:L.featureCapableLayerTypes,r=L.createLayerAdapter(i.layer,a,e.forBinning);if(!r)throw new p("size-class-breaks-renderer:invalid-parameters","'layer' must be one of these types: "+L.getLayerTypeLabels(a).join(", "));if(!(null!=i.minValue&&null!=i.maxValue)&&(null!=i.minValue||null!=i.maxValue))throw new p("size-class-breaks-renderer:missing-parameters","Both 'minValue' and 'maxValue' are required when specifying custom data range");const n=null!=i.signal?{signal:i.signal}:null;await r.load(n);const s=r.geometryType,l=i.symbolType.includes("3d");if(i.outlineOptimizationEnabled="polygon"===s&&i.outlineOptimizationEnabled,"mesh"===s)throw new p("size-class-breaks-renderer:invalid-parameters","Size visualization is not applicable to layers with 'mesh' geometry type");if(l&&("polyline"===s||"polygon"===s))throw new p("size-class-breaks-renderer:not-supported","3d symbols are not supported for polyline and polygon layers");if(i.symbolType.includes("3d-volumetric")&&(!i.view||"3d"!==i.view.type))throw new p("size-class-breaks-renderer:invalid-parameters","'view' parameter should be an instance of SceneView when 'symbolType' parameter is '3d-volumetric' or 3d-volumetric-uniform");const t=await C.getFieldsList({field:i.field,normalizationField:i.normalizationField}),o=I.verifyBasicFieldValidity(r,t,"size-class-breaks-renderer:invalid-parameters");if(o)throw o;return{...i,layer:r}}function N(e){const i={...e};delete i.basemap,delete i.sizeScheme,delete i.legendOptions,delete i.symbolType,delete i.defaultSymbolEnabled;const a=i;return a.analyzeData=!(null!=i.minValue&&null!=i.maxValue),a}function $(e){const i={...e},a=!!i.symbolType?.includes("3d-volumetric"),r=i;return r.worldScale=a,a&&(r.axis="3d-volumetric-uniform"===i.symbolType?"all":"height"),delete i.symbolType,delete i.defaultSymbolEnabled,r}async function W(e){if(!(e&&e.layer&&e.view&&e.startTime&&e.endTime))throw new p("size-age-renderer:missing-parameters","'layer', 'view', 'startTime', 'endTime' parameters are required");const i={...e};i.symbolType??="2d",i.defaultSymbolEnabled??=!0;const a=L.createLayerAdapter(i.layer,L.featureCapableLayerTypes);if(!a)throw new p("size-age-renderer:invalid-parameters","'layer' must be one of these types: "+L.getLayerTypeLabels(L.featureCapableLayerTypes).join(", "));const r=null!=i.signal?{signal:i.signal}:null;await a.load(r);const n=a.geometryType,s=i.symbolType.includes("3d");if(i.outlineOptimizationEnabled="polygon"===n&&i.outlineOptimizationEnabled,"mesh"===n)throw new p("size-age-renderer:invalid-parameters","Size visualization is not applicable to layers with 'mesh' geometry type");if(s&&("polyline"===n||"polygon"===n))throw new p("size-age-renderer:not-supported","3d symbols are not supported for polyline and polygon layers");if(i.symbolType.includes("3d-volumetric")&&(!i.view||"3d"!==i.view.type))throw new p("size-age-renderer:invalid-parameters","'view' parameter should be an instance of SceneView when 'symbolType' parameter is '3d-volumetric' or 3d-volumetric-uniform");const l=B.verifyDates(a,i.startTime,i.endTime,"size-age-renderer:invalid-parameters");if(l)throw l;if(i.unit&&!B.supportedAgeUnits.includes(i.unit))throw new p("size-age-renderer:invalid-unit",`Supported units are: ${B.supportedAgeUnits.join(", ")}`);return{...i,layer:a}}async function H(e){const i="regenerate-size-visual-variables";R.processRegenerateParams(e,i);const a=await R.getRendererToUpdate(e),r=R.getStyleType(a);if(!r||!["size-continuous","univariate-color-size","color-size","relationship-size","type-size"].includes(r))throw new p(`${i}:invalid-parameters`,"Renderer is invalid");const n=R.getAuthoringInfoVisualVariable(a,"size");if(!n)throw new p(`${i}:invalid-parameters`,"Renderer does not have a size visual variable authoringInfo");const s=n.theme,l="reference-size"===s,t=a.visualVariables?.find(R.isSizeVV);if(!t&&!l)throw new p(`${i}:invalid-parameters`,"Renderer does not have a size visual variable");let o=n.field,u=n.normalizationField,m=null,d=null;o||(t?.field?(o=t.field,u=t.normalizationField):a.field?(o=a.field,u=a.normalizationField):(m=t?.valueExpression??a.valueExpression,d=t?.valueExpressionTitle??a.valueExpressionTitle));const{layer:c,forBinning:y,filter:f,view:z,signal:b}=e,v=R.hasScaleDependentSizeVV(a),g=await U({layer:c,field:o,valueExpression:m,valueExpressionTitle:d,normalizationField:u,theme:s,sizeOptimizationEnabled:v,forBinning:y,filter:f,view:z,signal:b});return{...e,creatorParameters:g,renderer:a}}async function J(e){const i="regenerate-size-continuous-renderer";R.processRegenerateParams(e,i);const a=await R.getRendererToUpdate(e),r=R.getStyleType(a);if(!r||!["size-continuous","univariate-color-size"].includes(r))throw new p(`${i}:invalid-parameters`,"Renderer is invalid");const{authoringInfo:n,field:s,normalizationField:l,valueExpression:t,valueExpressionTitle:o}=a,u=n?.visualVariables.find((e=>"size"===e.type)),m=u.theme,{layer:d,forBinning:c,filter:y,view:f,signal:z}=e,b=R.hasOutlineVV(a),v=R.hasScaleDependentSizeVV(a),g=await P({layer:d,field:s,valueExpression:t,valueExpressionTitle:o,normalizationField:l,theme:m,outlineOptimizationEnabled:b,sizeOptimizationEnabled:v,forBinning:c,filter:y,view:f,signal:z});return{...e,creatorParameters:g,renderer:a}}async function K(e){const i="regenerate-size-class-breaks-renderer";await R.processRegenerateParams(e,i);const a=await R.getRendererToUpdate(e);if("size-class-breaks"!==R.getStyleType(a))throw new p(`${i}:invalid-parameters`,"Renderer is invalid");const{authoringInfo:r,field:n,normalizationField:s,normalizationType:l,normalizationTotal:t,valueExpression:o,valueExpressionTitle:u}=a,{classificationMethod:m,standardDeviationInterval:d}=r,c=a.classBreakInfos.length,{layer:y,forBinning:f,filter:z,view:b,signal:v}=e,g=R.hasOutlineVV(a),h=await j({layer:y,field:n,valueExpression:o,valueExpressionTitle:u,normalizationType:l,normalizationField:s,normalizationTotal:t,classificationMethod:m,standardDeviationInterval:d,numClasses:c,outlineOptimizationEnabled:g,forBinning:f,filter:z,view:b,signal:v});return{...e,creatorParameters:h,renderer:a}}async function Q(e){const i="regenerate-size-age-renderer";await R.processRegenerateParams(e,i);const a=await R.getRendererToUpdate(e);if("size-age"!==R.getStyleType(a))throw new p(`${i}:invalid-parameters`,"Renderer is invalid");const{authoringInfo:r}=a,n=r?.visualVariables.find((e=>"size"===e.type)),s=n.startTime,l=n.endTime,t=n.units,o=n.theme,{layer:u,filter:m,view:d,signal:c}=e,y=R.hasOutlineVV(a),f=R.hasScaleDependentSizeVV(a),z=await W({layer:u,startTime:s,endTime:l,unit:t,theme:o,outlineOptimizationEnabled:y,sizeOptimizationEnabled:f,filter:m,view:d,signal:c});return{...e,creatorParameters:z,renderer:a}}async function X(e){let i=e.sizeScheme,a=null,r=null;const n=await I.getBasemapInfo(e.basemap,e.view);if(a=null!=n.basemapId?n.basemapId:null,r=null!=n.basemapTheme?n.basemapTheme:null,i)return{scheme:q.cloneScheme(i),basemapId:a,basemapTheme:r};const s=q.getSchemes({basemapTheme:r,geometryType:e.geometryType,worldScale:e.worldScale,view:e.view});return s&&(i=s.primaryScheme,a=s.basemapId,r=s.basemapTheme),{scheme:i,basemapId:a,basemapTheme:r}}function Y(e,i){switch(i){case"point":case"multipoint":{const i=e;return[w.castSizeFromStringOrNumber(i.minSize),w.castSizeFromStringOrNumber(i.maxSize)]}case"polyline":{const i=e;return[w.castSizeFromStringOrNumber(i.minWidth),w.castSizeFromStringOrNumber(i.maxWidth)]}case"polygon":{const i=e;return[w.castSizeFromStringOrNumber(i.marker.minSize),w.castSizeFromStringOrNumber(i.marker.maxSize)]}}}function Z(e,i){e.transformationType===V.TransformationType.ClampedLinear&&"below"===i&&e.flipSizes()}async function _(e,i,a,r,n){return"reference-size"===a&&i?[1,i.size]:e?[e.minSize,e.maxSize]:Y(r,n)}function ee(e,i,a){return"reference-size"===a&&i?[1,i.size]:e?[e.minSize,e.maxSize]:null}function ie(e,i){if("reference-size"===i.theme&&null!=e.min&&null!=e.max&&null!=e.avg&&null!=e.stddev){const i=100,a=0,r=0,n=1,s=e.avg,l=e.min,t=e.max,o=e.stddev,u=0!==s?o/s:0,m=l>r&&l<n&&t<2*n&&u<.5,d=l>a&&l<i&&t<2*i&&u<.5;return{minDataValue:m?r:d?a:l,maxDataValue:m?n:d?i:s+2*o,defaultValuesUsed:!1}}const{theme:a,field:r}=i,n=i.layer,s=r&&!("function"==typeof r)?n.getField(r):null,l=C.isAnyDateField(s);return I.getDataRange(e,a,l,"above"===a||"below"===a)}async function ae(e,i,a,r){const{theme:n,field:s,normalizationField:l,minValue:t,maxValue:o,axis:u}=e,m=e.layer.geometryType,d=await X({basemap:e.basemap,geometryType:m,sizeScheme:e.sizeScheme,worldScale:e.worldScale,view:e.view}),c=d.scheme;if(!c)throw new p("size-visual-variable:insufficient-info","Unable to find size scheme");const f=await _(a,r,n,c,m),{minDataValue:g,maxDataValue:w,defaultValuesUsed:V}=ie(i,e),T=[],x="height"===u,E=x?u:void 0,O=f[0];let R=f[1];if(x&&"number"==typeof O&&"number"==typeof R){const e=I.getSizeRangeForAxis({minSize:O,maxSize:R},E);T.push(new h({axis:"width-and-depth",minSize:e.minSize})),R=e.maxSize}const B=new h({field:s??void 0,valueExpression:e.valueExpression,valueExpressionTitle:e.valueExpressionTitle,valueUnit:"unknown",normalizationField:l,axis:E,minSize:O,maxSize:R,minDataValue:g,maxDataValue:w,legendOptions:y.ensureClass(S,e.legendOptions)});Z(B,n),T.unshift(B);const k=new v("reference-size"===n?{type:"size",field:e.field,normalizationField:e.normalizationField,sizeStops:F.getReferenceSizeStops(B).map((({label:e,size:i,value:a})=>new b({label:e,size:i,value:a}))),theme:n,referenceSizeScale:r?.isGrid||e.sizeOptimizationEnabled?e?.view?.scale:void 0,referenceSizeSymbolStyle:e.referenceSizeOptions?.symbolStyle,minSliderValue:null!=t?t:i.min,maxSliderValue:null!=o?o:i.max}:{type:"size",theme:n,minSliderValue:null!=t?t:i.min,maxSliderValue:null!=o?o:i.max}),C=new z({visualVariables:[k]});return{basemapId:d.basemapId,basemapTheme:d.basemapTheme,visualVariables:T,statistics:i,isGrid:r?.isGrid,defaultValuesUsed:V,sizeScheme:q.cloneScheme(c),authoringInfo:C}}async function re(e,a,r,n,s){const l=await f.fetchMessageBundle("esri/smartMapping/t9n/smartMapping"),t=s.layer,o=s.field,u=t.geometryType,m=s.defaultSymbolEnabled,d=q.cloneScheme(e.sizeScheme),p="polygon"===u,c=p?d.marker:d,y=p?d.background:null,z=p?"point":u,b=a?.opacity,v=e.isGrid,g="reference-size"===s.theme,h=g?[]:e.visualVariables.map((e=>e.clone()));a?.visualVariables?.length&&h.push(...a.visualVariables.map((e=>e.clone())));const w=g?F.createPrimitiveOverrides({view:s.view,field:o,normalizationField:n,sizeStops:F.getReferenceSizeStops(e.visualVariables[0]),sizeByScaleEnabled:v||!!s.sizeOptimizationEnabled}):null;return{renderer:new i({backgroundFillSymbol:!v&&y?I.createSymbol(u,{type:s.symbolType,color:y.color,outline:I.getSymbolOutlineFromScheme(y,u,b)}):null,classBreakInfos:[{minValue:-D,maxValue:D,symbol:w?F.createReferenceSizeSymbol({type:s.referenceSizeOptions?.symbolStyle||"circle",color:c.color,primitiveOverrides:w}):I.createSymbol(z,{type:s.symbolType,color:c.color,size:I.getSymbolSizeFromScheme(c,z),outline:I.getSymbolOutlineFromScheme(c,z,b)})}],defaultLabel:m?l.other:null,defaultSymbol:m&&!g?I.createSymbol(z,{type:s.symbolType,color:c.noDataColor,size:I.getSymbolSizeFromScheme(c,z,!0),outline:I.getSymbolOutlineFromScheme(c,z,b)}):null,field:o,normalizationField:n,normalizationType:r,valueExpression:s.valueExpression,valueExpressionTitle:s.valueExpressionTitle,visualVariables:h,authoringInfo:e.authoringInfo?.clone()}),visualVariables:e.visualVariables.map((e=>e.clone())),statistics:e.statistics,defaultValuesUsed:e.defaultValuesUsed,isGrid:v,sizeScheme:q.cloneScheme(e.sizeScheme),basemapId:e.basemapId,basemapTheme:e.basemapTheme}}function ne(e,i){const a=c.toPt(e.minSize),r=(c.toPt(e.maxSize)-a)/(i>=4?i-1:i),n=[];for(let s=0;s<i;s++)n.push(a+r*s);return n}async function se(e,a){const r=await f.fetchMessageBundle("esri/smartMapping/t9n/smartMapping"),n=e.layer,s=e.defaultSymbolEnabled,l=n.geometryType,t="polygon"===l,o=e.symbolType?.includes("3d-volumetric"),u=await X({basemap:e.basemap,geometryType:l,sizeScheme:e.sizeScheme,worldScale:o,view:e.view}),m=u.scheme,{result:d,outlineResult:p}=a,c=d?.classBreakInfos??[],y=e.classificationMethod,b=e.normalizationType,v=t?m.marker:m,h=t?m.background:null,w=t?"point":l,S=Y(v,w),V=o?I.getSizeRangeForAxis({minSize:S[0],maxSize:S[1]},"height"):null,T=ne({minSize:S[0],maxSize:V?V.maxSize:S[1]},c.length),x=p?.opacity,E=new i({backgroundFillSymbol:h&&I.createSymbol(l,{type:e.symbolType,color:h.color,outline:I.getSymbolOutlineFromScheme(h,l,x)}),classBreakInfos:c.map(((i,a)=>({minValue:i.minValue,maxValue:i.maxValue,symbol:I.createSymbol(w,{type:e.symbolType,color:v.color,size:T[a],widthAndDepth:V?.minSize,outline:I.getSymbolOutlineFromScheme(v,w,x)}),label:i.label}))),defaultLabel:s?r.other:null,defaultSymbol:s?I.createSymbol(w,{type:e.symbolType,color:v.noDataColor,size:I.getSymbolSizeFromScheme(v,w,!0),widthAndDepth:V?.minSize,outline:I.getSymbolOutlineFromScheme(v,w,x)}):null,field:e.field,valueExpression:e.valueExpression,valueExpressionTitle:e.valueExpressionTitle,normalizationType:b,normalizationField:e.normalizationField,normalizationTotal:"percent-of-total"===b?d?.normalizationTotal:void 0,legendOptions:e.legendOptions,authoringInfo:new z({type:"class-breaks-size",classificationMethod:y,standardDeviationInterval:e.standardDeviationInterval})});return"standard-deviation"!==y&&g.setLabelsForClassBreaks({classBreakInfos:E.classBreakInfos,classificationMethod:y,normalizationType:b,round:!0}),p?.visualVariables?.length&&(E.visualVariables=p.visualVariables.map((e=>e.clone()))),{renderer:E,sizeScheme:q.cloneScheme(m),classBreaksResult:d,defaultValuesUsed:!!a.defaultValuesUsed,basemapId:u.basemapId,basemapTheme:u.basemapTheme}}async function le(e){const i=await U(e),{view:a,field:r,valueExpression:n,minValue:s,maxValue:l,layer:t,normalizationField:o,signal:u,statistics:m,filter:d}=i,p=o?"field":void 0,[c,y]=await Promise.all([m??I.getSummaryStatistics({layer:t,field:r,valueExpression:n,sqlExpression:i.sqlExpression,sqlWhere:i.sqlWhere,normalizationType:p,normalizationField:o,filter:d,minValue:s,maxValue:l,view:a,signal:u}),i.sizeOptimizationEnabled?O({view:a,layer:t,signal:u,filter:d}).catch(I.errorCallback):null]);return ae(i,c,y,i.referenceSizeResult)}async function te(e){const{view:i,filter:a,renderer:r,signal:n,creatorParameters:s}=await H(e),{field:l,normalizationField:t,valueExpression:o,theme:u,layer:m,sizeOptimizationEnabled:d,referenceSizeResult:p,valueExpressionTitle:c}=s,y=t?"field":void 0,[f,z]=await Promise.all([I.getSummaryStatistics({layer:m,field:l,valueExpression:o,normalizationField:t,normalizationType:y,filter:a,view:i,signal:n}),d?O({view:i,layer:m,signal:n,filter:a}).catch(I.errorCallback):null]),v=ee(z,p,u),{minDataValue:g,maxDataValue:w}=ie(f,{theme:u,layer:m,field:l}),S=r.visualVariables?.find(R.isSizeVV),V=(S?.stops?null:S)??new h({field:l??void 0,valueExpression:o,valueExpressionTitle:c,valueUnit:"unknown",normalizationField:t});v&&(V.minSize=v[0],V.maxSize=v[1]),V.minDataValue=g,V.maxDataValue=w,Z(V,u);const T=R.getAuthoringInfoVisualVariable(r,"size");return T.minSliderValue=f.min,T.maxSliderValue=f.max,"reference-size"===u&&(T.sizeStops=F.getReferenceSizeStops(V).map((({label:e,size:i,value:a})=>new b({label:e,size:i,value:a}))),T.referenceSizeScale=p?.isGrid||d?i?.scale:void 0),{visualVariables:"reference-size"===u?[]:[V],isGrid:!!p?.isGrid,authoringInfo:r.authoringInfo?.clone(),statistics:f}}async function oe(e){const i=await P(e),a={layer:i.layer,view:i.view,filter:i.filter,signal:i.signal},[r,n]=await Promise.all([le($(i)),i.outlineOptimizationEnabled?x(a).catch(I.errorCallback):null]),s=i.normalizationField;return re(r,n,s?"field":void 0,s,i)}async function ue(e){const{renderer:i,view:a,signal:r,filter:n,creatorParameters:s,forBinning:l}=await J(e),{layer:t,outlineOptimizationEnabled:o,theme:u,referenceSizeResult:m}=s,[d,p]=await Promise.all([te({...e,referenceSizeResult:m}),o?x({layer:t,view:a,filter:n,signal:r}).catch(I.errorCallback):null]),c=d.isGrid,y="reference-size"===u;R.spliceVisualVariables(i,d.visualVariables,R.findSizeVVIndex),R.spliceVisualVariables(i,p?.visualVariables,R.findOutlineVVIndex),R.updateAuthoringInfoVisualVariable(i,d.authoringInfo,"size");const f=d.statistics;if(!y)return{renderer:i,statistics:f};return{renderer:await me({layer:t,renderer:i,view:a,forBinning:l,sizeStops:R.getAuthoringInfoVisualVariable(i,"size","reference-size")?.sizeStops,isGrid:c}),isGrid:c,statistics:f}}async function me(e){const{layer:i,referenceSizeOptions:a,renderer:r,sizeScheme:n,sizeStops:s,typeScheme:l,view:t,isGrid:o}=await M(e),u=r.clone();u.authoringInfo??=new z;const m=u.authoringInfo.visualVariables.find((e=>"reference-size"===e.theme)),c=e.field??m?.field,y=e.normalizationField??m?.normalizationField;if(!c)throw new p("update-renderer-with-reference-size:invalid-parameters","'field' parameter or authoring info with 'field' is required.");const f=F.createPrimitiveOverrides({view:t,field:c,normalizationField:y,sizeStops:s,sizeByScaleEnabled:o||!!e.sizeOptimizationEnabled}),v=a?.symbolStyle||m?.referenceSizeSymbolStyle||"circle";if("class-breaks"===u.type){const e="polygon"===("geometryType"in i?i.geometryType:null)&&n&&"marker"in n?n.marker:null;u.classBreakInfos.forEach((i=>{const a=e?.color??A.getColorFromSymbol(i.symbol,1);"cim"===i.symbol.type?F.updateReferenceSizeSymbol(i.symbol,{type:v,color:a,primitiveOverrides:f}):a&&(i.symbol=F.createReferenceSizeSymbol({type:v,color:a,primitiveOverrides:f}))}))}else if("unique-value"===u.type){const e=u.uniqueValueGroups,a="polygon"===("geometryType"in i?i.geometryType:null)&&l&&"colors"in l?l.colors:null,r=a?d.createUniqueColors(a,u.uniqueValueInfos?.length??0):null;let n=0;if(e){for(const i of e)for(const e of i.classes??[]){const i=r?r[n]:A.getColorFromSymbol(e.symbol,1);"cim"===e.symbol?.type?F.updateReferenceSizeSymbol(e.symbol,{type:v,color:i,primitiveOverrides:f}):i&&(e.symbol=F.createReferenceSizeSymbol({type:v,color:i,primitiveOverrides:f})),n++}u.uniqueValueGroups=e}}return m&&(m.field=c,m.normalizationField=y,m.sizeStops=s.map((({label:e,size:i,value:a})=>new b({label:e,size:i,value:a}))),m.referenceSizeScale=o||e.sizeOptimizationEnabled?t.scale:void 0,m.referenceSizeSymbolStyle=v),u}async function de(e){const i=await j(e);return se(i,await I.getClassBreaks(N(i),i.outlineOptimizationEnabled))}async function pe(e){const{renderer:i,creatorParameters:a}=await K(e),{outlineOptimizationEnabled:r,normalizationType:n,classificationMethod:s}=a,{result:l,outlineResult:t}=await I.getClassBreaks(N(a),r),o=l.classBreakInfos;if(a.numClasses!==o.length)throw new p("regenerate-class-breaks-renderer:invalid-parameters","The number of class breaks generated does not match the number of class breaks in the renderer.");return i.classBreakInfos.forEach(((e,i)=>{e.minValue=o[i].minValue,e.maxValue=o[i].maxValue,e.label=o[i].label})),i.normalizationTotal="percent-of-total"===n?l.normalizationTotal:void 0,"standard-deviation"!==s&&g.setLabelsForClassBreaks({classBreakInfos:i.classBreakInfos,classificationMethod:s,normalizationType:n,round:!0}),R.spliceVisualVariables(i,t?.visualVariables,R.findOutlineVVIndex),{renderer:i}}async function ce(e){const i=await W(e),{defaultSymbolEnabled:a,view:r,startTime:n,endTime:s,symbolType:l,minValue:t,maxValue:o,signal:u,filter:m,layer:d}=i,[p,c]=await Promise.all([i.unit?{unit:i.unit,statistics:null,valueExpression:null}:await T({view:r,layer:d,startTime:n,endTime:s,minValue:t,maxValue:o,signal:u,filter:m}),i.outlineOptimizationEnabled?x({layer:d,view:r,filter:m,signal:u}).catch(I.errorCallback):null]),{unit:y,statistics:f}=p,{valueExpression:z,title:b}=await I.getTitleAndExpressionForAgeRenderer(i,y),v=await le($({layer:d,basemap:i.basemap,valueExpression:z,symbolType:l,statistics:f,legendOptions:{title:b},theme:i.theme,sizeScheme:i.sizeScheme,sizeOptimizationEnabled:i.sizeOptimizationEnabled,view:i.view,minValue:t,maxValue:o,filter:m,signal:u})),g={layer:d,valueExpression:z,defaultSymbolEnabled:a,symbolType:l},h=await re(v,c,null,null,g),w=h.renderer.authoringInfo?.visualVariables;return w?.forEach((e=>I.updateAgeRendererAuthoringInfoVV(e,n,s,y))),{...h,unit:y}}async function ye(e){const{renderer:i,creatorParameters:a}=await Q(e),{layer:r,outlineOptimizationEnabled:n,sizeOptimizationEnabled:s,startTime:l,endTime:t,theme:o,view:u,signal:m,filter:d}=a,[p,c]=await Promise.all([T({view:u,layer:r,startTime:l,endTime:t,signal:m,filter:d}),n?x({layer:r,view:u,filter:d,signal:m}).catch(I.errorCallback):null]),{unit:y,statistics:f}=p,{valueExpression:z,title:b}=await I.getTitleAndExpressionForAgeRenderer(a,y),v=await le($({layer:r,valueExpression:z,statistics:f,legendOptions:{title:b},sizeOptimizationEnabled:s,theme:o,view:u,filter:d,signal:m}));R.spliceVisualVariables(i,v.visualVariables,R.findSizeVVIndex),R.spliceVisualVariables(i,c?.visualVariables,R.findOutlineVVIndex),i.authoringInfo=v.authoringInfo.clone();const g=i.authoringInfo?.visualVariables;return g?.forEach((e=>I.updateAgeRendererAuthoringInfoVV(e,l,t,y))),{renderer:i}}e.createAgeRenderer=ce,e.createClassBreaksRenderer=de,e.createContinuousRenderer=oe,e.createVisualVariables=le,e.regenerateAgeRenderer=ye,e.regenerateClassBreaksRenderer=pe,e.regenerateContinuousRenderer=ue,e.regenerateVisualVariables=te,e.updateRendererWithReferenceSize=me,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
