/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../Color","../../../intl","../../../symbols","../../../core/Collection","../../../core/has","../../../core/Error","../../../intl/date","../../../renderers/support/numberUtils","../../../renderers/support/pointCloud/PointSizeSplatAlgorithm","../../heuristics/outline","../../statistics/classBreaks","../../statistics/summaryStatistics","../../statistics/support/ageUtils","../../support/utils","../../../symbols/edges/SketchEdges3D","../../../symbols/edges/SolidEdges3D","../../../time/timeZoneUtils","../../../views/support/colorUtils","../../../symbols/MeshSymbol3D","../../../symbols/FillSymbol3DLayer","../../../symbols/SimpleFillSymbol","../../../symbols/PolygonSymbol3D","../../../symbols/ExtrudeSymbol3DLayer","../../../symbols/SimpleLineSymbol","../../../symbols/LineSymbol3D","../../../symbols/LineSymbol3DLayer","../../../symbols/PathSymbol3DLayer","../../../symbols/SimpleMarkerSymbol","../../../symbols/PointSymbol3D","../../../symbols/IconSymbol3DLayer","../../../symbols/ObjectSymbol3DLayer","../../../intl/messages","../../../intl/substitute"],(function(e,t,n,o,l,i,s,a,r,u,c,m,d,f,y,p,g,h,b,w,S,D,v,T,x,z,V,F,B,U,k,L,A,I){"use strict";const C=/^(\d+(\.\d+)?)\s*(%)$/i,M=new t([0,0,0,.4]),Z=new Set(["hours","minutes","seconds"]),E=[...y.defaultBasemapGroups.light,...y.defaultBasemapGroups.dark];function P(e,t,n,o){if("string"==typeof e){const t=n.getField(e);if(t&&y.isAnyDateField(t))return t.alias||t.name}else if("number"==typeof e||e instanceof Date){const l=null!=t&&Z.has(t),i=l?"short-date-short-time":"short-date",s=a.convertDateFormatToIntlOptions(i);if(o&&l){const t=n.layer,{timeZone:l}=h.getTimeZoneFormattingOptions("preferredTimeZone"in t?t.preferredTimeZone:null,"datesInUnknownTimezone"in t&&t.datesInUnknownTimezone,o.timeZone,s,"date");return a.formatDate(e,{...s,timeZone:l,timeZoneName:h.shortTimeZoneName})}return a.formatDate(e,s)}return e}function R(e,t,n){return e+t>0&&0>e-t&&n<0?0:e}function O(e,t,n,o){const{avg:l,stddev:i,min:s,max:a}=e,r=j(e,!!n,o??!0);let u=r?r[0]:s,c=r?r[1]:a;return r?{minDataValue:u,maxDataValue:c,defaultValuesUsed:!0}:("above"===t?u=R(l,i,s):"below"===t&&(c=R(l,i,s)),{minDataValue:u,maxDataValue:c,defaultValuesUsed:!1})}function j(e,t,n){let o,l;const i=G({statistics:e,isDate:t});return i.defaultValuesUsed?(o=i.min,l=i.max):!n||null!=e.avg&&e.stddev||(o=e.min,l=e.max),null!=o&&null!=l?[o,l]:null}function G(e){let t,n,o=e&&e.statistics;if(o||(o={}),null==o.min)if(e.isDate){const e=N();t=e[0],n=e[1]}else t=0,n=100;else if(o.min===o.max)if(e.isDate){const e=N(o.min);t=e[0],n=e[1]}else o.min<0?(t=2*o.min,n=0):o.min>0?(t=0,n=2*o.min):(t=0,n=100);return{min:null!=t?t:o.min,max:null!=n?n:o.max,defaultValuesUsed:null!=t||null!=n}}function N(e){const t=("number"==typeof e?new Date(e):new Date).getUTCFullYear();let n=Date.UTC(t,0,1,12,0,0,0),o=Date.UTC(t,11,31,12,0,0,0);return"number"==typeof e&&(e<n&&(n=e),e>o&&(o=e)),[n,o]}function Y(e,n){const o=[],l=e.length;for(let i=0;i<n;i++)o.push(new t(e[i%l]));return o}function W({minDataValue:e,maxDataValue:t,defaultValuesUsed:n},o,l,i=!0){return n||"above"===l||"below"===l?_(e,t,5):H(o,i)}function $(e,t){const{avg:n,stddev:o}=e,l=e.min,i=e.max;if(null==n||null==o){const[n,o]=j(e,t,!0);return _(n,o,5)}const s=R(n,o,l),a=i-s,u=s-l,c=Math.max(a,u),m=s+c,d=s-c,f=s-c/2,y=c/2+s;return r.round([d,f,s,y,m],{strictBounds:!0})}function q(e,t){const{min:n,max:o}=t,[l,i,s,a,u]=e,c=null!=n&&l<n,m=null!=o&&u>o;if(null==n||null==o||!c&&!m)return e;const d=c?n:l,f=c?d+(s-d)/2:i,y=m?o:u,p=m?s+(y-s)/2:a;return r.round([d,f,s,p,y],{strictBounds:!0})}function _(e,t,n){const o=(t-e)/(n-1),l=[e];for(let i=1;i<=n-2;i++)l.push(e+i*o);return l.push(t),r.round(l,{strictBounds:!0})}function H({min:e,max:t,avg:n,stddev:o},l=!0){if(null==e||null==t||null==n||null==o)return[];let i=n-o,s=n+o;i<e&&(i=e),s>t&&(s=t),l&&(n=i+(s-i)/2);let a=r.round([i,s],{strictBounds:!0});return i=a[0],s=a[1],a=[i,i+(n-i)/2,n,n+(s-n)/2,s],r.round(a,{strictBounds:!0})}function J(e,t,n){switch(t){case"point":case"multipoint":return n?"noDataSize"in e?e.noDataSize:null:"size"in e?e.size:null;case"polyline":return n?"noDataWidth"in e?e.noDataWidth:null:"width"in e?e.width:null;case"polygon":return"size"in e?e.size:null;default:return}}function K(e,t,n){switch(t){case"point":case"multipoint":case"polygon":{if(!("outline"in e))return null;const t={color:e.outline.color,width:e.outline.width};if(null!=n&&t.color){const e=t.color.clone();e.a=n,t.color=e}return t}default:return}}function Q(e,t){const{type:n,size:o,color:i,outline:s}=t;let a;switch(e){case"point":case"multipoint":if("2d"===n)a=new B({color:i,size:o,outline:{color:s.color,width:s.width}});else if("3d-flat"===n)a=new U({symbolLayers:new l([new k({size:o,resource:{primitive:"circle"},material:{color:i},outline:{color:s.color,size:s.width}})])});else if(n?.includes("3d-volumetric")){const e="3d-volumetric-uniform"===n,s=new L({height:o,resource:{primitive:e?"sphere":"cylinder"},material:{color:i}});e||(s.width=t.widthAndDepth,s.depth=t.widthAndDepth),a=new U({symbolLayers:new l([s])})}break;case"polyline":"2d"===n?a=new x({color:i,width:o}):"3d-flat"===n?a=new z({symbolLayers:new l([new V({size:o,material:{color:i}})])}):"3d-volumetric"===n&&(a=new z({symbolLayers:new l([new F({width:"number"==typeof o?o:parseFloat(o),height:"number"==typeof o?o:parseFloat(o),material:{color:i}})])}));break;case"polygon":"2d"===n?a=new D({color:i,outline:{color:s.color,width:s.width}}):"3d-flat"===n?a=new v({symbolLayers:new l([new S({material:{color:i},outline:{color:s.color,size:s.width}})])}):"3d-volumetric"===n&&(a=new v({symbolLayers:new l([new T({size:o,material:{color:i}})])}));break;case"mesh":{const e=t.meshInfo?.colorMixMode,n=t.meshInfo?.edgesType;a=new w({symbolLayers:new l([new S({material:{color:i,colorMixMode:e||null},edges:"solid"===n?new g({color:M}):"sketch"===n?new p({color:M}):null})])});break}}return a}function X(e,t,n){const o=ee({layer:e,fields:t});if(o.length)return new s(n,"Unknown fields: "+o.join(", ")+". You can only use fields defined in the layer schema");const l=te({layer:e,fields:t});return l.length?new s(n,"Unsupported fields: "+l.join(", ")+". You can only use fields that are accessible to the renderer i.e. FieldUsageInfo.supportsRenderer must be true"):void 0}function ee(e){const t=e.layer;return e.fields.filter((e=>!t.getField(e)))}function te(e){const t=e.layer;return e.fields.filter((e=>{const n=t.getFieldUsageInfo(e);return!n||!n.supportsRenderer}))}async function ne(e,t){const n={layer:e.layer,view:e.view,filter:e.filter,signal:e.signal},[o,l]=await Promise.all([m(e).catch(ue),t?c(n).catch(ue):null]),i=j({min:o?.minValue,max:o?.maxValue,avg:null,stddev:null},!1,!1);return{result:i?await m({...e,classificationMethod:"equal-interval",numClasses:1,analyzeData:!1,minValue:i[0],maxValue:i[1],normalizationTotal:i[0]+i[1]}):o,defaultValuesUsed:!!i,outlineResult:l}}function oe(e){return d({outStatisticTypes:y.defaultStatisticTypes,...e})}function le(e,t){let{minSize:n,maxSize:o}=e;if("height"===t){n=((o-n)/2+n)/(2*2.3),o*=2}return{minSize:n,maxSize:o}}function ie(e){return C.test(e)}function se(e){if(null==e)return;const t=e.match(C),n=Number(t[1]);return"%"===t[3]?new u({scaleFactor:n/100}):void 0}function ae(e,t,n,o){e.startTime=t instanceof Date?t.getTime():t,e.endTime=n instanceof Date?n.getTime():n,e.units=o,e.field="string"==typeof t?t:"string"==typeof n?n:null}async function re(e,t){let n=null,o=null;if(!e&&!t)return{basemapId:n,basemapTheme:o};if(t&&(o=await b.getBackgroundColorTheme(t),e||(e=t.map?.basemap)),e&&(n=y.getBasemapId(e,E,!1),n&&!o)){const e=y.getBasemapGroup(n);null!=e&&(o=e)}return!n&&o&&(n="dark"===o?"dark-gray":"gray"),{basemapId:n,basemapTheme:o}}function ue(e){const t=e.name?.toLowerCase();if(!t||t?.includes(":insufficient-info")||t?.includes(":insufficient-data"))return null;throw e}async function ce(e,t){const{layer:n,startTime:o,endTime:l,view:i}=e,s=f.getAgeExpressions({layer:n,startTime:o,endTime:l,unit:t}).valueExpression,a=await A.fetchMessageBundle("esri/smartMapping/t9n/smartMapping");return{valueExpression:s,title:I.substitute(a[`ageInfo_${t}`],{unit:t,startTime:P(o,t,n,i),endTime:P(l,t,n,i)})}}e.clampAboveAndBelowStopValues=q,e.createColors=Y,e.createDataValues=W,e.createDefaultStopValues=_,e.createStopValues=H,e.createStopValuesForAboveBelow=$,e.createSymbol=Q,e.errorCallback=ue,e.formatDate=P,e.getBaseValueForAboveBelow=R,e.getBasemapInfo=re,e.getClassBreaks=ne,e.getDataRange=O,e.getDefaultDataRange=j,e.getPointSizeAlgorithm=se,e.getSizeRangeForAxis=le,e.getSummaryStatistics=oe,e.getSymbolOutlineFromScheme=K,e.getSymbolSizeFromScheme=J,e.getTitleAndExpressionForAgeRenderer=ce,e.isValidPointSize=ie,e.updateAgeRendererAuthoringInfoVV=ae,e.verifyBasicFieldValidity=X,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
