/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../renderers/PointCloudClassBreaksRenderer","../../renderers/PointCloudRenderer","../../renderers/PointCloudRGBRenderer","../../renderers/PointCloudStretchRenderer","../../renderers/PointCloudUniqueValueRenderer","../../renderers/ClassBreaksRenderer","../../renderers/DictionaryRenderer","../../renderers/DotDensityRenderer","../../renderers/HeatmapRenderer","../../renderers/PieChartRenderer","../../renderers/Renderer","../../renderers/SimpleRenderer","../../renderers/UniqueValueRenderer","../../renderers/support/jsonUtils","../../core/Logger","../../core/colorUtils","../../core/Error","../../core/lang","../../intl/messages","../../layers/support/fieldUtils","../../renderers/support/RendererLegendOptions","../../renderers/support/utils","../../renderers/support/pointCloud/ColorUniqueValueInfo","../heuristics/outline","../heuristics/sizeRange","./support/regenerateUtils","./support/utils","../statistics/uniqueValues","../support/binningUtils","../support/utils","../support/adapters/support/layerUtils","../symbology/type"],(function(e,l,i,n,r,a,t,s,o,d,u,p,c,m,y,f,b,g,v,h,w,T,V,S,z,E,I,x,C,M,O,R,U){"use strict";async function q(e){if(!e?.layer||!e.field&&!e.valueExpression)throw new g("type-renderer:missing-parameters","'layer' and 'field' or 'valueExpression' parameters are required");if(e.valueExpression&&!e.view)throw new g("type-renderer:missing-parameters","View is required when 'valueExpression' is specified");e.forBinning&&M.verifyBinningParams(e,"type-renderer");const l={...e,layer:e.layer};l.symbolType=l.symbolType||"2d",l.defaultSymbolEnabled??=!0,l.sortBy??="count",l.sortEnabled??=!0,l.statistics=v.clone(l.statistics);const i=null==l.numTypes?10:l.numTypes,n=e.forBinning?R.binningCapableLayerTypes:R.featureCapableLayerTypes,r=R.createLayerAdapter(l.layer,n,e.forBinning);if(!r)throw new g("type-renderer:invalid-parameters","'layer' must be one of these types: "+R.getLayerTypeLabels(n).join(", "));const a=null!=l.signal?{signal:l.signal}:null;await r.load(a);const t=r.geometryType;if(l.outlineOptimizationEnabled="polygon"===t&&l.outlineOptimizationEnabled,l.sizeOptimizationEnabled=("point"===t||"multipoint"===t||"polyline"===t)&&l.sizeOptimizationEnabled,"mesh"===t)l.symbolType="3d-volumetric",l.colorMixMode=l.colorMixMode||"replace",l.edgesType=l.edgesType||"none";else{if("3d-volumetric-uniform"===l.symbolType&&"point"!==t)throw new g("type-renderer:not-supported","3d-volumetric-uniform symbols are supported for point layers only");if(l.symbolType.includes("3d-volumetric")&&(!l.view||"3d"!==l.view.type))throw new g("type-renderer:invalid-parameters","'view' parameter should be an instance of SceneView when 'symbolType' parameter is '3d-volumetric' or '3d-volumetric-uniform'")}const s=await O.getFieldsList({field:l.field,field2:l.field2,field3:l.field3,valueExpression:l.valueExpression}),o=x.verifyBasicFieldValidity(r,s,"type-renderer:invalid-parameters");if(o)throw o;return{...l,layer:r,numTypes:i}}async function L(e){const l="regenerate-type-renderer";await I.processRegenerateParams(e,l);const i=await I.getRendererToUpdate(e),n=I.getStyleType(i);if(!n||!["type","type-size"].includes(n))throw new g(`${l}:invalid-parameters`,"Renderer is invalid");const{field:r,field2:a,field3:t,valueExpression:s,valueExpressionTitle:o}=i,d=i.uniqueValueInfos.length,{layer:u,forBinning:p,filter:c,view:m,signal:y}=e,f=I.hasOutlineVV(i),b=I.hasScaleDependentSizeVV(i),v=await q({layer:u,field:r,field2:a,field3:t,valueExpression:s,valueExpressionTitle:o,numTypes:d,outlineOptimizationEnabled:f,sizeOptimizationEnabled:b,forBinning:p,filter:c,view:m,signal:y});return{...e,creatorParameters:v,renderer:i}}async function P(e){if(!e?.layer||!e.field)throw new g("type-point-cloud-class-renderer:missing-parameters","'layer' and 'field' parameters are required");const l={...e,layer:e.layer};l.statistics=v.clone(l.statistics);const i=[R.LayerType.PointCloudLayer],n=R.createLayerAdapter(l.layer,i);if(!n)throw new g("type-point-cloud-class-renderer:invalid-parameters","'layer' must be one of these types: "+R.getLayerTypeLabels(i).join(", "));if(l.layer=n,l.density=l.density||25,l.size=l.size||"100%",!x.isValidPointSize(l.size))throw new g("type-point-cloud-class-renderer:invalid-parameters","Invalid 'size' parameter. It should be a string of the form '100%'");const r=null!=l.signal?{signal:l.signal}:null;await n.load(r);const a=await O.getFieldsList({field:l.field}),t=x.verifyBasicFieldValidity(n,a,"type-point-cloud-class-renderer:invalid-parameters");if(t)throw t;return l}async function F(e){let l=e.typeScheme,i=null,n=null;const r=await x.getBasemapInfo(e.basemap,e.view);if(i=null!=r.basemapId?r.basemapId:null,n=null!=r.basemapTheme?r.basemapTheme:null,l)return{scheme:U.cloneScheme(l),basemapId:i,basemapTheme:n};const a=U.getSchemes({numColors:e.numColors,basemapTheme:n,geometryType:e.geometryType,theme:e.theme,worldScale:e.worldScale,view:e.view});return a&&(l=a.primaryScheme,i=a.basemapId,n=a.basemapTheme),{scheme:l,basemapId:i,basemapTheme:n}}function B(e,l){let i;return i=e.label<l.label?-1:e.label>l.label?1:0,i}function D(e,l){let i;return i=e.value<l.value?-1:e.value>l.value?1:0,i}function k(e,l){let i=l.count-e.count;return 0===i&&(i=B(e,l)),i}function A(e,l){let i=l.count-e.count;return 0===i&&(i=D(e,l)),i}function Z(e,l,i){let n;"count"===l?(n=A,i&&"codedValues"in i&&i.codedValues&&(n=k)):"value"===l&&(n=D,i&&"codedValues"in i&&i.codedValues&&(n=B)),n&&e.sort(n)}async function j(e,l,i,n){const r=await h.fetchMessageBundle("esri/smartMapping/t9n/smartMapping"),{field:a,field2:t,field3:s}=l,o=e.uniqueValueInfos,d=l.layer,u=a?d.getField(a):null,p=u?d.getFieldDomain(u.name):null,c=-1===l.numTypes?o.length:l.numTypes,y=d.geometryType,f=new m({field:a,field2:t,field3:s,fieldDelimiter:a&&t?O.fieldDelimiter:null}),b=[],g=[],v={value:null,domain:p,fieldInfo:u};o.forEach(((e,l)=>{v.value=e.value,e.label=V.createUniqueValueLabel(v);const i=e.value;(null===i||"string"==typeof i&&i.toLowerCase().includes("<null>"))&&b.unshift(l)}));for(const m of b)g.unshift(o.splice(m,1)[0]);!1!==l.sortEnabled&&Z(o,l.sortBy,p),G(v,l,o);const w=i?.opacity,S=await F({numColors:o.length,basemap:l.basemap,geometryType:y,typeScheme:l.typeScheme,worldScale:!!l.symbolType?.includes("3d-volumetric"),view:l.view}),z=S.scheme,E=z.colors.map((e=>e.clone())),I=x.getSymbolSizeFromScheme(z,y),C=x.getSymbolOutlineFromScheme(z,y,w);o.forEach(((e,i)=>{v.value=e.value,e.label=V.createUniqueValueLabel(v),e.symbol=x.createSymbol(y,{type:l.symbolType,color:E[i],size:I,outline:C,meshInfo:{colorMixMode:l.colorMixMode,edgesType:l.edgesType}})})),l.valueExpression&&(f.valueExpression=l.valueExpression,f.valueExpressionTitle=l.valueExpressionTitle),l.legendOptions&&(f.legendOptions=new T(l.legendOptions));for(let m=0;m<c;m++){const e=o[m];e&&f.addUniqueValueInfo({value:e.value,label:e.label,symbol:x.createSymbol(y,{type:l.symbolType,color:E[m].clone(),size:I,outline:C,meshInfo:{colorMixMode:l.colorMixMode,edgesType:l.edgesType}})})}l.defaultSymbolEnabled&&(f.defaultSymbol=x.createSymbol(y,{type:l.symbolType,color:z.noDataColor,size:I,outline:C,meshInfo:{colorMixMode:l.colorMixMode,edgesType:l.edgesType}}),f.defaultLabel=r.other);for(const m of g)m.symbol=x.createSymbol(y,{type:l.symbolType,color:z.noDataColor,size:I,outline:C,meshInfo:{colorMixMode:l.colorMixMode,edgesType:l.edgesType}}),o.push(m);const M=[],R=f.uniqueValueInfos?.length??0,q=R===o.length?-1:R;if(q>-1)for(let m=q;m<o.length;m++)M.push({...o[m]});return i?.visualVariables?.length&&(f.visualVariables=i.visualVariables.map((e=>e.clone()))),n?.minSize&&(f.visualVariables?f.visualVariables.push(n.minSize):f.visualVariables=[n.minSize]),{renderer:f,uniqueValueInfos:o,excludedUniqueValueInfos:M,typeScheme:U.cloneScheme(z),basemapId:S.basemapId,basemapTheme:S.basemapTheme}}function G(e,l,i){const{field:n,numTypes:r,layer:a,view:t}=l,s=n?a.getField(n):null;if(s&&(O.isAnyDateField(s)||w.isTimeOnlyField(s))){const l=i.filter(((e,l)=>l<r)).map((e=>e.value)),n=w.isTimeOnlyField(s)?null:V.calculateDateFormatInterval(l),o=n?V.dateFormatIntervalOptions[n]:void 0;if(e.dateFormatOptions={fieldType:s.type,format:o},t){const l=a.layer;e.dateFormatOptions.timeZoneOptions={layerTimeZone:"preferredTimeZone"in l?l.preferredTimeZone:null,viewTimeZone:t.timeZone,datesInUnknownTimezone:"datesInUnknownTimezone"in l&&l.datesInUnknownTimezone}}}}async function H(e,l){const i=e.uniqueValueInfos,n=await F({numColors:i.length,basemap:"gray",theme:"point-cloud-class",geometryType:"point",typeScheme:l}),r=n?.scheme,a="point-cloud-class"===r?.theme,t=a?r.colors:b.createUniqueColors(r?.colors??[],i.length);return Z(i,"value"),i.map(((e,l)=>{const i=e.value;let n=null;return a?(n=t[i],n||(n=t[t.length-1])):n=t[l],new S({values:[i],color:n,label:e.label})}))}async function $(e){const l=await q(e),{layer:i,view:n,signal:r,filter:a}=l,t={layer:i,field:l.field,field2:l.field2,field3:l.field3,valueExpression:l.valueExpression,returnAllCodedValues:l.returnAllCodedValues,view:n,filter:a,signal:r},[s,o,d]=await Promise.all([null!=l.statistics?l.statistics:C(t),l.outlineOptimizationEnabled?z({layer:i,view:n,signal:r,filter:a}).catch(x.errorCallback):null,l.sizeOptimizationEnabled?E({layer:i,view:n,signal:r,filter:a}).catch(x.errorCallback):null]);return j(s,l,o,d)}async function J(e){const{creatorParameters:l,view:i,signal:n,filter:r,renderer:a}=await L(e),{layer:t,outlineOptimizationEnabled:s,sizeOptimizationEnabled:o}=l,[d,u]=await Promise.all([s?z({layer:t,view:i,signal:n,filter:r}).catch(x.errorCallback):null,o?E({layer:t,view:i,signal:n,filter:r}).catch(x.errorCallback):null]);return I.spliceVisualVariables(a,d?.visualVariables,I.findOutlineVVIndex),I.spliceVisualVariables(a,u?.minSize,I.findScaleDependentSizeVVIndex),{renderer:a}}async function K(e){const l=await P(e),i=null!=l.statistics?l.statistics:await C({layer:l.layer,field:l.field,signal:l.signal});return{renderer:new a({field:l.field,pointsPerInch:l.density??void 0,pointSizeAlgorithm:x.getPointSizeAlgorithm(l.size),colorUniqueValueInfos:await H(i,l.typeScheme)})}}e.createPCClassRenderer=K,e.createRenderer=$,e.regenerateRenderer=J,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
