/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../core/Error","../../renderers/support/AuthoringInfo","../../renderers/support/ClassBreakInfo","../../renderers/visualVariables/support/SizeStop","../../renderers/visualVariables/support/visualVariableUtils","./color","./size","./support/regenerateUtils","./support/utils","../support/binningUtils","../support/utils","../support/adapters/support/layerUtils","../symbology/support/aboveAndBelowUtils","../../symbols/support/cimSymbolUtils","../../symbols/support/Symbol3DMaterial"],(function(e,i,a,s,o,n,l,t,r,u,p,c,m,d,v,b){"use strict";const y=2**53-1;async function f(e){if(!e?.layer||!(e.field||e.valueExpression||e.sqlExpression))throw new i("univariate-colorsize-visual-variables:missing-parameters","'layer' and 'field', 'valueExpression' or 'sqlExpression' parameters are required");if(e.valueExpression&&!e.sqlExpression&&!e.view)throw new i("univariate-colorsize-visual-variables:missing-parameters","View is required when 'valueExpression' is specified");if("above-and-below"===e.theme&&e.sizeOptions?.sizeOptimizationEnabled)throw new i("univariate-colorsize-visual-variables:invalid-parameters","sizeOptimizationEnabled cannot be true for 'above-and-below' theme");e.forBinning&&p.verifyBinningParams(e,"univariate-colorsize-visual-variables");const a={...e,layer:e.layer},s=e.forBinning?m.binningCapableLayerTypes:m.featureCapableLayerTypes,o=m.createLayerAdapter(a.layer,s,e.forBinning);if(!o)throw new i("univariate-colorsize-visual-variables:invalid-parameters","'layer' must be one of these types: "+m.getLayerTypeLabels(s).join(", "));a.layer=o,a.theme=a.theme||a.colorOptions?.theme?a.theme:"high-to-low";const n=null!=a.signal?{signal:a.signal}:null;await o.load(n);const l=await c.getFieldsList({field:a.field,normalizationField:a.normalizationField,valueExpression:a.valueExpression}),t=u.verifyBasicFieldValidity(o,l,"univariate-colorsize-visual-variables:invalid-parameters");if(t)throw t;return a}function w(e,i){const a={...e},{sizeOptions:s,theme:o}=a,n=a.legendOptions||a.sizeOptions?.legendOptions;return delete a.sizeOptions,delete a.colorOptions,{...a,...s,statistics:i||a.statistics,theme:"above-and-below"===o?null:o,legendOptions:n}}function h(e,i){const a={...e},s=a.colorOptions,o=a.theme||s?.theme,n=a.legendOptions||a.colorOptions?.legendOptions;return delete a.sizeOptions,delete a.colorOptions,{...a,...s,statistics:i||a.statistics,theme:o,legendOptions:n}}async function g(e){if(!e?.layer||!(e.field||e.valueExpression||e.sqlExpression))throw new i("univariate-colorsize-continuous-renderer:missing-parameters","'layer' and 'field', 'valueExpression' or 'sqlExpression' parameters are required");if(e.valueExpression&&!e.sqlExpression&&!e.view)throw new i("univariate-colorsize-continuous-renderer:missing-parameters","View is required when 'valueExpression' is specified");e.forBinning&&p.verifyBinningParams(e,"univariate-colorsize-continuous-renderer");const a={...e,layer:e.layer};a.symbolType=a.symbolType||"2d",a.colorOptions||(a.colorOptions={}),a.colorOptions.isContinuous=a.colorOptions.isContinuous??!1;const s=e.forBinning?m.binningCapableLayerTypes:m.featureCapableLayerTypes,o=m.createLayerAdapter(a.layer,s,e.forBinning);if(!o)throw new i("univariate-colorsize-continuous-renderer:invalid-parameters","'layer' must be one of these types: "+m.getLayerTypeLabels(s).join(", "));const n=null!=a.signal?{signal:a.signal}:null;if(await o.load(n),"above-and-below"===a.theme&&a.symbolOptions){if(a.symbolType.includes("3d-volumetric"))throw new i("univariate-colorsize-continuous-renderer:invalid-parameters","'symbolOptions' is applicable for '2d' and '3d-flat' 'symbolType' only");if("point"!==o.geometryType&&"polygon"!==o.geometryType)throw new i("univariate-colorsize-continuous-renderer:invalid-parameters","'symbolOptions' only apply to layers with 'point' or 'polygon' geometryType")}const l=await c.getFieldsList({field:a.field,normalizationField:a.normalizationField,valueExpression:a.valueExpression}),t=u.verifyBasicFieldValidity(o,l,"univariate-colorsize-continuous-renderer:invalid-parameters");if(t)throw t;return{...a,layer:o}}function z(e){const i={...e},a={...i.sizeOptions};return delete i.sizeOptions,delete i.colorOptions,delete a.sizeOptimizationEnabled,{...i,...a}}async function V(e){const a="regenerate-univariate-color-size-renderer";await r.processRegenerateParams(e,a);const s=await r.getRendererToUpdate(e);if("univariate-color-size"!==r.getStyleType(s))throw new i(`${a}:invalid-parameters`,"Renderer is invalid");const{layer:o,forBinning:n,filter:l,view:t,signal:u}=e,{field:p,normalizationField:c,valueExpression:m,valueExpressionTitle:d}=s,v=r.hasOutlineVV(s),b=r.hasScaleDependentSizeVV(s),y=s.authoringInfo?.univariateTheme,f=await g({layer:o,field:p,normalizationField:c,valueExpression:m,valueExpressionTitle:d,outlineOptimizationEnabled:v,theme:y,colorOptions:{isContinuous:"above-and-below"===y?s.visualVariables?.some((e=>"color"===e.type)):void 0},sizeOptions:{sizeOptimizationEnabled:b},forBinning:n,filter:l,view:t,signal:u});return{...e,creatorParameters:f,renderer:s}}function S(e,i){if("type"in e&&"cim"===e.type)v.applyCIMSymbolColor(e,i);else if("type"in e&&e.type.includes("3d")){e.symbolLayers.forEach((e=>{"material"in e&&null!=e.material&&"color"in e.material&&(e.material?e.material.color=i:e.material=new b.Symbol3DMaterial({color:i}))}))}else"color"in e&&(e.color=i)}function O(e,i,a){if((i?.symbolStyle||i?.symbols)&&("point"===a||"polygon"===a))return i.symbols||d.getAboveAndBelowSymbols(i.symbolStyle);const s=e.classBreakInfos[0].symbol;return{above:s.clone(),below:s.clone()}}function x(e,i,a){const o=a.symbolOptions,n=a.layer,l=o?.symbols?"custom":o?.symbolStyle,t=a.colorOptions?.isContinuous;if(E(e,i,t),l||!t){const a=i.size.visualVariables[0].stops,{above:r,below:u}=O(e,o,n.geometryType);if(!t){const e=i.color.colorScheme.colors,a=e[0];S(r,e[e.length-1]),S(u,a)}e.classBreakInfos=[new s({minValue:-y,maxValue:a[2].value,symbol:u}),new s({minValue:a[2].value,maxValue:y,symbol:r})],l&&e.authoringInfo&&(e.authoringInfo.univariateSymbolStyle=l)}}function E(e,i,a=!0){const s=i?.authoringInfo?.clone(),o=s?.visualVariables?.some((e=>"reference-size"===e.theme)),n=o?[]:i.size.visualVariables.map((e=>e.clone()));a?n.push(i.color.visualVariable.clone()):s.visualVariables=s.visualVariables?.filter((e=>"size"===e.type)),e.visualVariables&&n.push(...e.visualVariables.filter((e=>"target"in e&&"outline"===e.target)).map((e=>e.clone()))),e.authoringInfo=s,e.visualVariables=n}function T(e){const i={...e},a=i.symbolType,s=!!a?.includes("3d-volumetric");delete i.symbolType,delete i.defaultSymbolEnabled;const o=i;return o.worldScale=s,s&&(o.sizeOptions={...o.sizeOptions},o.sizeOptions.axis="3d-volumetric-uniform"===a?"all":"height"),o}async function I(e,i,a,s){const l=i[0],t=i[1],r=Math.round((t-l)/2)+l,u=e.clone();u.stops=[new o({value:a[0],size:t}),new o({value:a[1],size:r}),new o({value:a[2],size:l}),new o({value:a[3],size:r}),new o({value:a[4],size:t})],e.stops=[new o({value:s[0],size:n.getSize(u,s[0])}),new o({value:s[1],size:n.getSize(u,s[1])}),new o({value:s[2],size:n.getSize(u,s[2])}),new o({value:s[3],size:n.getSize(u,s[3])}),new o({value:s[4],size:n.getSize(u,s[4])})]}async function B(e,i,a,s,o){const n=e.find((e=>"width-and-depth"!==e.axis&&!e.target)),l="number"==typeof n?.minSize?n?.minSize:null,t="number"==typeof n?.maxSize?n?.maxSize:null;if(null!=n?.minDataValue&&null!=l&&null!=t)if(s)if("above-and-below"===s){n.minDataValue=null,n.maxDataValue=null,n.minSize=null,n.maxSize=null;const e=u.createStopValuesForAboveBelow(a,o),s=u.clampAboveAndBelowStopValues(e,a);await I(n,[l,t],e,s),i.stops.forEach(((e,i)=>e.value=s[i]))}else{const{minDataValue:e,maxDataValue:a}=n,s=u.createDefaultStopValues(e,a,5);i.stops.forEach(((e,i)=>e.value=s[i])),n.minDataValue=s[0],n.maxDataValue=s[s.length-1]}else n.minDataValue=i.stops[0].value,n.maxDataValue=i.stops[i.stops.length-1].value}function C(e,i,s){const{theme:o,minValue:n,maxValue:l}=e,t=i.authoringInfo.visualVariables[0].clone(),r=s.authoringInfo.visualVariables[0].clone(),{stops:u}=i.visualVariable;return"above-and-below"===o?(t.minSliderValue=r.minSliderValue=n??u[0].value,t.maxSliderValue=r.maxSliderValue=l??u.at(-1)?.value,r.theme="above-and-below"):o&&"high-to-low"!==o||"reference-size"!==r.theme||2!==r.sizeStops?.length||(r.sizeStops[0].value=u[0].value,r.sizeStops[1].value=u.at(-1)?.value),new a({type:"univariate-color-size",univariateTheme:o,visualVariables:[t,r]})}async function D(e){const i=await f(e),a=await l.createVisualVariable(h(i)),{visualVariable:s,statistics:o}=a,n=await t.createVisualVariables(w(i,o)),r=n.visualVariables,u=e.layer,p=e.field?u.getField(e.field):null;return await B(r,s,o,i.theme,c.isAnyDateField(p)),{basemapId:n.basemapId,basemapTheme:n.basemapTheme,statistics:o,defaultValuesUsed:a.defaultValuesUsed,color:{visualVariable:s,colorScheme:a.colorScheme},size:{visualVariables:r,sizeScheme:n.sizeScheme},authoringInfo:C(i,a,n)}}async function F(e){return A(e)}async function A(e){const i=await g(e),{renderer:a,statistics:s,defaultValuesUsed:o}=await t.createContinuousRenderer(z(i)),n=T(i);n.statistics=s;const l=await D(n);return"above-and-below"===i.theme?x(a,l,i):E(a,l),{renderer:a,statistics:s,defaultValuesUsed:o,color:i.colorOptions?.isContinuous||"above-and-below"!==i.theme?l.color:null,size:l.size,basemapId:l.basemapId,basemapTheme:l.basemapTheme}}async function L(e){const{creatorParameters:i}=await V(e),{layer:a,field:s,theme:o,colorOptions:n}=i,{renderer:u,statistics:p}=await t.regenerateContinuousRenderer(e),m=await f({...T(i),statistics:p}),d=await l.createVisualVariable(h(m)),v=d.visualVariable,b=(await t.createVisualVariables(w(m))).visualVariables,y=s?a.getField(s):null;await B(b,v,p,o,c.isAnyDateField(y));const g=n?.isContinuous||"above-and-below"!==o,z=u.visualVariables?.find(r.isColorVV);g&&z?.stops&&(z.stops.forEach(((e,i)=>e.value=v.stops[i].value)),r.updateAuthoringInfoVisualVariable(u,d.authoringInfo,"color")),r.spliceVisualVariables(u,b,r.findSizeVVIndex);const S=r.getAuthoringInfoVisualVariable(u,"size");if((!o||"high-to-low"===o)&&S&&"reference-size"===S.theme&&2===S.sizeStops?.length){const{stops:e}=v;S.sizeStops[0].value=e[0].value,S.sizeStops[1].value=e.at(-1)?.value}if("above-and-below"===o&&b[0]?.stops){const e=b[0].stops;u.classBreakInfos[0].maxValue=e[2].value,u.classBreakInfos[1].minValue=e[2].value}return{renderer:u}}e.createContinuousRenderer=F,e.createRenderer=A,e.createVisualVariables=D,e.regenerateRenderer=L,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
