/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../geometry","../../../core/Error","../../../core/screenUtils","../../../core/timeUtils","../../../geometry/SpatialReference","../../../geometry/support/quantizationUtils","../../../geometry/support/spatialReferenceUtils","../../../layers/support/fieldUtils","../../../renderers/support/heatmapUtils","../../support/utils","../../../statistics/utils","../../../support/arcadeOnDemand","../../../geometry/Point"],(function(e,t,n,i,l,r,s,o,a,u,c,f,d,m){"use strict";let p=null;const y=/^(?<hh>([0-1][0-9])|([2][0-3])):(?<mm>[0-5][0-9])(:(?<ss>[0-5][0-9]))?([.](?<ms>\d+))?$/;function h(e,t,n){return e.x<0?e.x+=t:e.x>n&&(e.x-=t),e}function g(e,t,n,i){const l=o.isWrappable(n)?o.getInfo(n):null,r=l?Math.round((l.valid[1]-l.valid[0])/t.scale[0]):null;return e.map((e=>{const n=new m(e.geometry);return s.quantizePoint(t,n,n),e.geometry=l?h(n,r??0,i[0]):n,e}))}function $(e,t=18,n,l,r){const s=new Float64Array(l*r);t=Math.round(i.pt2px(t));let o=Number.POSITIVE_INFINITY,a=Number.NEGATIVE_INFINITY;const c=u.createValueFunction(n);for(const{geometry:i,attributes:f}of e){const{x:e,y:n}=i,d=Math.max(0,e-t),m=Math.max(0,n-t),p=Math.min(r,n+t),y=Math.min(l,e+t),h=+c(f);for(let i=m;i<p;i++)for(let r=d;r<y;r++){const c=i*l+r,f=u.evaluateDensityKernel(r-e,i-n,t)*h,d=s[c]+=f;o=Math.min(o,d),a=Math.max(a,d)}}return{min:o,max:a}}function F(e){const t=y.exec(e);if(!t)return null;const{hh:n,mm:i,ss:r,ms:s}=t.groups;return Number(n)*l.millisecondsPerTimeUnit.hours+Number(i)*l.millisecondsPerTimeUnit.minutes+Number(r)*l.millisecondsPerTimeUnit.seconds+Number(s||0)}async function x(e,t,n=!0){if(!t)return[];const{field:i,field2:l,field3:s,fieldDelimiter:o,fieldInfos:u,timeZone:m}=e,y=i&&u?.find((e=>e.name.toLowerCase()===i.toLowerCase())),h=!!y&&a.isTimeOnlyField(y),g=!!y&&c.isAnyDateField(y),$=e.valueExpression,x=e.normalizationType,b=e.normalizationField,N=e.normalizationTotal,w=[],I=e.viewInfoParams;let v=null,T=null;if($){if(!p){const{arcadeUtils:e}=await d.loadArcade();p=e}p.hasGeometryOperations($)&&await p.enableGeometryOperations(),v=p.createFunction($),T=I?p.getViewInfo({viewingMode:I.viewingMode,scale:I.scale,spatialReference:new r(I.spatialReference)}):null}const E=e.fieldInfos,U=!(t[0]&&"declaredClass"in t[0]&&"esri.Graphic"===t[0].declaredClass)&&E?{fields:E}:null;return t.forEach((e=>{const t=e.attributes;let r;if($){const t=U?{...e,layer:U}:e,n=p.createExecContext(t,T,m);r=p.executeFunction(v,n)}else t&&(r=t[i],l?(r=`${f.processNullValue(r)}${o}${f.processNullValue(t[l])}`,s&&(r=`${r}${o}${f.processNullValue(t[s])}`)):"string"==typeof r&&n&&(g?r=r?new Date(r).getTime():null:h&&(r=r?F(r):null)));if(x&&"number"==typeof r&&isFinite(r)){const e=t&&parseFloat(t[b]);r=f.getNormalizedValue(r,x,e,N)}w.push(r)})),w}function b(e){const t=e.field,n=e.normalizationType,i=e.normalizationField;let l;return"field"===n?l="(NOT "+i+" = 0)":"log"!==n&&"natural-log"!==n&&"square-root"!==n||(l=`(${t} > 0)`),l}function N(e,t,n){const i=null!=t?e+" >= "+t:"",l=null!=n?e+" <= "+n:"";let r="";return r=i&&l?v(i,l):i||l,r?"("+r+")":""}function w(e,t,i,l){let r;return t?t.name!==e.objectIdField&&l.includes(t.type)||(r=new n(i,"'field' should be one of these types: "+l.join(","))):r=new n(i,"'field' is not defined in the layer schema"),r}function I(e,t,i){let l;return t?t.name!==e.objectIdField&&a.isNumericField(t)||(l=new n(i,"'field' should be one of these numeric types: "+a.numericTypes.join(","))):l=new n(i,"'field' is not defined in the layer schema"),l}function v(e,t){let n=null!=e?e:"";return null!=t&&t&&(n=n?"("+n+") AND ("+t+")":t),n}function T(e,t){if(e&&"intersects"!==e.spatialRelationship)return new n(t,"Only 'intersects' spatialRelationship is supported for featureFilter")}function E(e,t,i){const l=U({layer:e,fields:t});if(l.length)return new n(i,"Unknown fields: "+l.join(", ")+". You can only use fields defined in the layer schema");const r=V({layer:e,fields:t});return r.length?new n(i,"Unsupported fields: "+r.join(", ")+". You can only use fields that can be fetched i.e. AdapterFieldUsageInfo.supportsStatistics must be true"):void 0}function U(e){const t=e.layer;return e.fields.filter((e=>!t.getField(e)))}function V(e){const t=e.layer;return e.fields.filter((e=>{const n=t.getFieldUsageInfo(e);return!n||!n.supportsStatistics}))}function j(e,t,n){const i=[],l=[],r=[],s=[],o=[];e.forEach(((e,t)=>{const a=e.field?"field":"expression",u=e.field||e.valueExpression;e.field?(o.push(u),l.push(`var ${a}${t} = Number($feature["${u}"]);`)):(i.push(`function getValueForExpr${t}() {\n  ${u} \n}`),l.push(`var ${a}${t} = Number(getValueForExpr${t}());`)),n||r.push(`${a}${t} = IIf(${a}${t} < 0, 0, ${a}${t});`),s.push(`${a}${t}`)}));const a=i.length?null:o.reduce(((e,t)=>`${e} + ${t}`));let u=null;t||n?t?n||a&&(u=`(( ${a} ) >= 0)`):a&&(u=`(( ${a} ) <> 0)`):a&&(u=`(( ${a} ) > 0)`);return{valueExpression:[i.length?i.join("\n"):"",l.join("\n"),r.join("\n"),`var total = ${s.join(" + ")};`,"return total;"].filter(Boolean).join("\n\n"),sqlExpression:a,sqlWhere:u}}e.calculateHeatmapStats=$,e.getDataValues=x,e.getRangeExpr=N,e.getSQLFilterForNormalization=b,e.getSumOfAttributesExpr=j,e.mergeWhereClauses=v,e.quantizeFeatures=g,e.timeOnlyToMilliseconds=F,e.verifyBasicFieldValidity=E,e.verifyFieldType=w,e.verifyFilterValidity=T,e.verifyNumericField=I,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
