/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../Graphic","../../../core/arrayUtils","../../../core/Error","../../../core/promiseUtils","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/Logger","../../../core/accessorSupport/decorators/subclass","../../../intl/date","../../../layers/support/arcgisLayerUrl","../../../layers/support/fieldUtils","../../../rest/generateRenderer","../../../rest/support/AutoIntervalBinParameters","../../../rest/support/BinsQuery","../../../rest/support/DateBinParameters","../../../rest/support/FixedBoundariesBinParameters","../../../rest/support/FixedIntervalBinParameters","../../../rest/support/GenerateRendererParameters","../../../rest/support/StatisticDefinition","../../../rest/support/UniqueValueDefinition","../../statistics/support/predominanceUtils","../../statistics/support/utils","../../statistics/support/WorkerClient","../utils","./InMemoryLayerAdapter","./support/utils","../../../statistics/utils","../../../views/2d/viewpointUtils"],(function(e,t,i,r,a,s,n,o,l,u,m,d,c,h,p,y,f,F,g,S,w,v,x,z,_,T,E,V,q){"use strict";const Q=5,B=2e4,b=4e5;function L(e,t=!1){if("string"!=typeof e)return e;return(t?new Date(`1970-01-01T${e}Z`):new Date(e)).getTime()}let N=class extends T{constructor(){super(...arguments),this.adapterName="feature-layer-adapter"}_isStatsSupportedOnService(){const e=this.layer;if(!e.capabilities?.query?.supportsStatistics||"multipatch"===this.geometryType&&!m.isHostedAgolService(e.url)&&e.version<10.5)throw new r(`${this.adapterName}:not-supported`,"Layer does not support statistics query");return Promise.resolve()}_fetchFeaturesFromService(e,t){return this.layer.queryFeatures(e,{signal:t}).then((e=>e.features))}_fetchFeaturesJSONFromService(e,t){return this._fetchFeaturesFromService(e,t).then(E.ensureFeaturesJSON)}_summaryStatsFromGenRend(e){const t=e.normalizationType,i=e.normalizationField;return this.classBreaks({field:e.field,numClasses:Q,classificationMethod:"standard-deviation",standardDeviationInterval:.25,normalizationType:t,normalizationField:"field"===t?i:void 0,minValue:e.minValue,maxValue:e.maxValue,filter:e.filter,signal:e.signal}).then((t=>{let i,r,a;if(t.classBreakInfos?.some((e=>(e.hasAvg&&(i=e),!!i))),i){const e=i.maxValue-i.minValue;r=i.minValue+e/2,a=4*e}const s={min:t.minValue,max:t.maxValue,avg:r,stddev:a};return V.processSummaryStatisticsResult(s,e.outStatisticTypes)}))}async _summaryStatsFromServiceQuery(e,t){await this._isStatsSupportedOnService(),"percent-of-total"===e.normalizationType&&(e.normalizationTotal=await this._getNormalizationTotal(e.field,e.normalizationType,e.filter));const i=_.isAnyDateField(t)||d.isTimeOnlyField(t),r=E.getSummaryStatsQuery(this,e,t),a=await this.layer.queryFeatures(r,{signal:e.signal}),s=E.getSummaryStatisticsFromFeatureSet(a,i);return V.processSummaryStatisticsResult(s,e.outStatisticTypes)}_uvFromGenRenderer(e,t){const i=e.field??void 0,r=new w({attributeField:i}),a=new g({classificationDefinition:r});return this.generateRenderer(a,e.signal).then((e=>{const t={},r=this.getField(i);return e.uniqueValues.forEach((e=>{let i=e.value;null!=i&&""!==i&&("string"!=typeof i||""!==i.trim()&&"<null>"!==i.toLowerCase())||(i=null),null==t[i]?t[i]={count:e.count,data:d.isNumericField(r)&&i?Number(i):i}:t[i].count=t[i].count+e.count})),{count:t}})).then((i=>V.createUVResult(i,[t],e.returnAllCodedValues)))}async _uvFromServiceQuery(e,t){return this._isStatsSupportedOnService().then((()=>this.layer.queryFeatures(E.getUVQuery(this,e),{signal:e.signal}))).then((t=>E.getUniqueValuesFromFeatureSet(t,{layer:this,field:e.field,field2:e.field2,field3:e.field3,fieldDelimiter:_.fieldDelimiter,view:e.view,signal:e.signal}))).then((i=>V.createUVResult(i,t,e.returnAllCodedValues,_.fieldDelimiter)))}_getNormalizationTotal(e,t,i,r){return e&&"percent-of-total"===t?this.summaryStatistics({field:e,outStatisticTypes:{include:["sum"]},filter:i,signal:r}).then((e=>e.sum)):Promise.resolve(null)}_getQueryParamsForExpr(e,t){const i=e.valueExpression||e.sqlExpression,r=e.signal;if(!i){const{field:i,normalizationType:a,normalizationField:s}=e,n=i?this.getField(i):null,o=_.isAnyDateField(n)||d.isTimeOnlyField(n),l={field:i,normalizationType:a,normalizationField:s,normalizationTotal:t,layer:this};return{sqlExpression:o?E.getSQLExpressionForDateOrTimeField(this,n):E.getFieldExpr(l),sqlWhere:o?null:e.sqlWhere||x.getSQLFilterForNormalization({field:i,normalizationType:a,normalizationField:s}),filter:e.filter,signal:r}}return{valueExpression:e.valueExpression,sqlExpression:e.sqlExpression,sqlWhere:e.sqlWhere,filter:e.filter,signal:r}}_getDataRange(e,t,i){return null!=t&&null!=i?Promise.resolve({min:t,max:i}):this.summaryStatistics({...e,outStatisticTypes:{include:["min","max"]}}).then((e=>({min:e.min,max:e.max})))}_histogramForExpr(e){return this._getNormalizationTotal(e.field,e.normalizationType,e.filter,e.signal).then((t=>{const i=this._getQueryParamsForExpr(e,t);return this._getDataRange(i,e.minValue,e.maxValue).then((r=>{const a=r.min,s=r.max;if(null==a||null==s)return{bins:[],minValue:a,maxValue:s,normalizationTotal:t};const n=e.numBins||E.defaultNumBins,o=V.getEqualIntervalBins(a,s,n),l=R(i.sqlExpression,o,null!=e.minValue&&null!=e.maxValue),u=new S({statisticType:"count",outStatisticFieldName:"countOFExpr",onStatisticField:"1"}),m=this.layer.createQuery();return m.where=x.mergeWhereClauses(m.where,i.sqlWhere),m.sqlFormat="standard",m.outStatistics=[u],m.groupByFieldsForStatistics=[l],m.orderByFields=[l],E.updateQueryWithFeatureFilter(m,e.filter),this._isStatsSupportedOnService().then((()=>this.layer.queryFeatures(m,{signal:i.signal}))).then((e=>E.getHistogramFromFeatureSet(e,a,s,n,t)))}))}))}async _getBinQueryParams(e,t,i,a){const{field:s,sqlExpression:n,normalizationField:o,classificationMethod:l,normalizationType:u}=e,m=s?this.getField(s):null,c=d.isTimeOnlyField(m),p=d.isDateOnlyField(m)||c,g=e.numBins||E.defaultNumBins;if(p){if(u||l)throw new r(`${this.adapterName}:not-supported`,"NormalizationType and classificationMethod are not supported for date-only and time-only fields");const e=(i-t)/g/1e3,a=e/86400;return new y({field:s,expression:n,interval:{units:c?"seconds":"days",value:Math.ceil(c?e:a)},start:t,end:i})}if("defined-interval"===l)return new F({field:s,expression:n,normalizationField:o,normalizationTotal:a,normalizationType:u,interval:e.definedInterval??Math.ceil((i-t)/g),start:u?null:t,end:u?null:i,normalizationMinValue:u?t:null,normalizationMaxValue:u?i:null});if("manual"===l)throw new r(`${this.adapterName}:not-supported`,"Layer does not support manual classificationMethod");if("natural-breaks"===l||"quantile"===l||"standard-deviation"===l){const i=E.getFieldExpr({field:s,normalizationField:o,normalizationTotal:a,normalizationType:u,layer:this}),l=null!==e.minValue&&null!==e.maxValue?x.getRangeExpr(i,e.minValue,e.maxValue):void 0,m=await this._binParamsFromGenRend(e,l);if(!m.intervals)throw new r(`${this.adapterName}:invalid`,"Invalid intervals returned from generate renderer");const d=[t,...m.intervals.map((e=>e[1]))];return new f({field:u?null:s,expression:u?i:n,boundaries:d})}return new h({field:s,normalizationField:o,normalizationTotal:a,normalizationType:u,expression:n,bins:g,start:u?null:t,end:u?null:i,normalizationMinValue:u?t:null,normalizationMaxValue:u?i:null})}async _histogramFromQueryBins(e){const{field:t,normalizationType:i,minValue:r,maxValue:a,filter:s,view:n,signal:o}=e,l=await this._getNormalizationTotal(t,i,s,o),m=this._getQueryParamsForExpr(e,l),{min:c,max:h}=await this._getDataRange(m,r,a);if(null==c||null==h)return{bins:[],minValue:c,maxValue:h,normalizationTotal:l};const y="countOFExpr",f=new S({statisticType:"count",outStatisticFieldName:y,onStatisticField:"1"}),F=this.layer.createQuery(),g=x.mergeWhereClauses(F.where,m.sqlWhere),w="lowerBoundary",v="upperBoundary",z=new p({binParameters:await this._getBinQueryParams(e,c,h,l),outStatistics:[f],binOrder:e.sortOrder,where:g,lowerBoundaryAlias:w,upperBoundaryAlias:v,outTimeZone:n?.timeZone?u.resolveTimeZone(n?.timeZone):null});E.updateQueryWithFeatureFilter(z,s);const _=await this.layer.queryBins(z,{signal:o}),T=d.isTimeOnlyField(t?this.getField(t):null);return{bins:_.features.map((e=>({minValue:L(e.attributes[w],T),maxValue:L(e.attributes[v],T),count:e.attributes[y]}))),minValue:c,maxValue:h,normalizationTotal:l}}_binParamsFromGenRend(e,t){const{field:i,normalizationType:r,normalizationField:a,signal:s}=e,n=x.getSQLFilterForNormalization({field:i,normalizationType:r,normalizationField:a}),o=new g({classificationDefinition:V.createClassBreaksDefinition({field:i,normalizationType:r,normalizationField:a,classificationMethod:e.classificationMethod,standardDeviationInterval:e.standardDeviationInterval,definedInterval:e.definedInterval,breakCount:e.numBins||E.defaultNumBins}),where:x.mergeWhereClauses(n,t)});return this.generateRenderer(o,s).then((e=>{const{normalizationTotal:t,classBreaks:s}=e;return E.generateBinParams({field:i,normalizationType:r,normalizationField:a,normalizationTotal:t,classBreaks:s,where:n,layer:this})}))}_classBreaksFromGenRend(e){const{field:t,normalizationType:i,normalizationField:r,normalizationTotal:a,signal:s}=e,n=x.getSQLFilterForNormalization({field:t,normalizationType:i,normalizationField:r}),o=E.getFieldExpr({field:t,normalizationType:i,normalizationField:r,normalizationTotal:a,layer:this}),l=x.getRangeExpr(o,e.minValue,e.maxValue),u=V.createClassBreaksDefinition({field:t,normalizationType:i,normalizationField:r,classificationMethod:e.classificationMethod,standardDeviationInterval:e.standardDeviationInterval,breakCount:e.numClasses||Q}),m=new g({classificationDefinition:u});return m.where=x.mergeWhereClauses(n,l),this.generateRenderer(m,s).then((t=>V.resolveCBResult(t,e.classificationMethod)))}async summaryStatistics(e){const{field:t,normalizationType:i,sqlExpression:s,view:n,features:o,useFeaturesInView:l}=e,u=t?this.getField(t):null,m=_.isAnyDateField(u)||d.isTimeOnlyField(u),c=e.valueExpression||s,h=c&&!s,p=this._hasLocalSource||o||l,y=n&&"3d"===n.type;if(p||h)return h||o||l||y?this._summaryStatsFromMemory(e,u):this._summaryStatsFromClientQuery(e,u);if(!this.supportsSQLExpression&&(m||c||"natural-log"===i||"square-root"===i))throw new r(`${this.adapterName}:not-supported`,"Layer does not support standardized SQL expression for queries");return(i&&!this.supportsSQLExpression?this._summaryStatsFromGenRend(e):this._summaryStatsFromServiceQuery(e,u)).catch((()=>(a.throwIfAborted(e.signal),this._summaryStatsFromMemory(e,u))))}async uniqueValues(e){const{valueExpression:t,sqlExpression:i,features:r,useFeaturesInView:s,signal:n}=e,o=t&&(!i||!this.supportsSQLExpression),l=this._hasLocalSource||r||s||o,u=e.view,m=u&&"3d"===u.type,d=await E.getDomainsForFields(e,this);return l?o||r||s||m?this._uvFromMemory(e,d):this._uvFromClientQuery(e,d):this._uvFromServiceQuery(e,d).catch((t=>(a.throwIfAborted(n),!e.field||e.field2||e.field3||e.filter?t:this._uvFromGenRenderer(e,d[0])))).catch((()=>(a.throwIfAborted(n),m?this._uvFromMemory(e,d):this._uvFromClientQuery(e,d))))}async histogram(e){const{field:t,normalizationType:i,normalizationField:a,classificationMethod:s,view:n,filter:o,signal:l}=e,u=t?this.getField(t):null,m=_.isAnyDateField(u)||d.isTimeOnlyField(u),c=e.valueExpression||e.sqlExpression,h=c&&!e.sqlExpression,p=this._hasLocalSource||e.features||e.useFeaturesInView||h,y=this.supportsSQLExpression,f=!s||"equal-interval"===s,F=e.minValue,g=e.maxValue,S=null!=F&&null!=g,w=e.numBins||E.defaultNumBins;if(p)return this._histogramFromMemory(e);if(this.layer.capabilities?.operations?.supportsQueryBins&&e.useQueryBins)return this._histogramFromQueryBins(e);if((c||y)&&f){if(!y&&(c||"natural-log"===i||"square-root"===i))throw new r(`${this.adapterName}:not-supported`,"Layer does not support standardized SQL expression for queries");return this._histogramForExpr(e)}if(m&&f)throw new r(`${this.adapterName}:not-supported`,"Normalization and date field are not allowed when layer does not support standardized SQL expression for queries");return i||!f?this._binParamsFromGenRend(e).then((s=>{if(!S)return E.getBins(this,s,t,w,n,o,l);if(F>s.max||g<s.min)throw new r(`${this.adapterName}:insufficient-data`,"Range defined by 'minValue' and 'maxValue' does not intersect available data range of the field");if(f)return E.getBins(this,{min:F,max:g,sqlExpr:s.sqlExpr,excludeZerosExpr:s.excludeZerosExpr},t,w,n,o,l);{const r={field:t,normalizationType:i,normalizationField:a,normalizationTotal:s.normTotal,layer:this},u=E.getFieldExpr(r),m=x.getRangeExpr(u,F,g);return this._binParamsFromGenRend(e,m).then((e=>E.getBins(this,e,t,w,n,o,l)))}})):this._histogramForField(e)}async classBreaks(e){const t=!1!==e.analyzeData,i=this._hasLocalSource||e.features||e.useFeaturesInView||e.valueExpression||e.filter;if(t&&i)return this._classBreaksFromMemory(e);return(t?this._classBreaksFromGenRend(e):this._classBreaksFromInterpolation(e)).catch((()=>(a.throwIfAborted(e.signal),this._classBreaksFromMemory(e))))}async queryFeatureCount(e){if(this._hasLocalSource)throw new r(`${this.adapterName}:not-supported`,"Layer does not support count query");const t=this.layer,i=t.createQuery();return i.where=x.mergeWhereClauses(i.where,e.whereClause),E.updateQueryWithFeatureFilter(i,e.filter),t.queryFeatureCount(i,{signal:e.signal})}async generateRenderer(e,t){const i=this.layer;if(this._hasLocalSource||i.version<10.1)throw new r(`${this.adapterName}:not-supported`,"Layer does not support generateRenderer operation (requires ArcGIS Server version 10.1+)");const a=i.createQuery();return e.where=x.mergeWhereClauses(e.where,a.where),c.generateRenderer(i.parsedUrl?.path??"",{source:i.dynamicDataSource??void 0,gdbVersion:i.gdbVersion??void 0},e,{signal:t})}async predominantCategories(e){if(!this._hasLocalSource&&!this.supportsSQLExpression)throw new r(`${this.adapterName}:not-supported`,"Layer does not support advanced SQL expressions and standardized queries");const{fields:t,view:i,signal:a,filter:s}=e,n=v.getArcadeForPredominantCategory(t),o=v.getSQLForPredominantCategoryName(t),l=i&&this._hasLocalSource?await this._uvFromMemory({valueExpression:n,view:i,signal:a,filter:s}):await this._uvFromServiceQuery({sqlExpression:o.expression,valueExpression:n,signal:a,filter:s});return E.getPredominantCategoriesFromUVInfos(l.uniqueValueInfos,t)}async getSampleFeatures(e,r){const{view:s,requiredFields:n,returnGeometry:o,filter:l,signal:u}=e,m=e.sampleSize;if(null==m||0===m)return[];const d=this.layer.createQuery(),c=1,h="json"===r;d.outSpatialReference=s?.spatialReference,d.returnGeometry=!!o,d.outFields=n,E.updateQueryWithFeatureFilter(d,l);let p=[],y=!1;if(s)try{const a=await s.whenLayerView(this.layer);if(y=!E.getMissingFields(this,n,a).length,y){if(m>=1&&!e.filter&&"getSampleFeatures"in a){await this._waitForLayerViewUpdate(a);const e=await a.getSampleFeatures({minFeatureCount:m,sampleSize:m});if(null!=e)return h?e:e.map((e=>t.fromJSON(e)))}if(p=await this._fetchFeaturesFromMemory(a,d,u,r),p.length>=m&&m>0)return i.pickRandom(p,m,c)}}catch(f){a.throwIfAborted(u)}try{if(this._hasLocalSource)return y?p:h?await this._fetchFeaturesJSONFromService(d,u):await this._fetchFeaturesFromService(d,u);const t=await this.queryFeatureCount({view:s,filter:l,signal:u}),r=this.layer.capabilities.query.maxRecordCount;let a=-1===m?t:m;if(a=r&&a>r?r:a,t<=p.length||p.length>=r)return p;if(d.maxAllowableOffset=e.resolution||(s?s.extent.width/s.width/s.scale:q.getScaleToResolutionFactor(this.layer.spatialReference))*b,t<=a)return h?await this._fetchFeaturesJSONFromService(d,u):await this._fetchFeaturesFromService(d,u);if(t<=B){const e=this.layer.createQuery();E.updateQueryWithFeatureFilter(e,l);const t=await this.layer.queryObjectIds();return d.objectIds=i.pickRandom(t,a,c),h?await this._fetchFeaturesJSONFromService(d,u):await this._fetchFeaturesFromService(d,u)}return this.layer.capabilities?.query?.supportsPagination&&(d.num=Math.min(a,B)),h?await this._fetchFeaturesJSONFromService(d,u):await this._fetchFeaturesFromService(d,u)}catch(f){return a.throwIfAborted(u),p}}load(e){const t=this.layer.load(e).then((async t=>{this.geometryType=t.geometryType,this.objectIdField=t.objectIdField,this.supportsSQLExpression=t.capabilities?.query?.supportsSqlExpression,this._hasLocalSource=!t.url&&!!t.source,this.hasQueryEngine=this._hasLocalSource,this.minScale=t.minScale,this.maxScale=t.maxScale,this.fullExtent=t.fullExtent,this.workerClient=z.WorkerClient.getInstance(),await this.workerClient.open(e.signal)}));return this.addResolvingPromise(t),Promise.resolve(this)}};function R(e,t,i){const r=[],a=t.length;return t.forEach(((t,s)=>{const[n,o]=t;let l=null;l=0!==s||i?s!==a-1||i?x.mergeWhereClauses(`${e} >= ${n}`,`${e} ${s===a-1?" <= ":" < "} ${o}`):`${e} >= ${n}`:`${e} < ${o}`,r.push("WHEN ("+l+") THEN "+(s+1))})),["CASE",r.join(" "),"ELSE 0","END"].join(" ")}e.__decorate([s.property({constructOnly:!0})],N.prototype,"layer",void 0),N=e.__decorate([l.subclass("esri.smartMapping.support.adapters.FeatureLayerAdapter")],N);return N}));
