/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../../../chunks/tslib.es6","../../../core/arrayUtils","../../../core/Error","../../../core/Logger","../../../core/maybe","../../../core/promiseUtils","../../../core/reactiveUtils","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/accessorSupport/decorators/subclass","../../../geometry/support/quantizationUtils","../../../layers/support/fieldType","../../../layers/support/fieldUtils","../../../rest/support/QuantizationParameters","../../statistics/support/predominanceUtils","../../statistics/support/statsWorker","../../statistics/support/utils","../../statistics/support/WorkerClient","../utils","./LayerAdapter","./support/utils","../../../statistics/utils","../../../support/arcadeOnDemand"],(function(e,t,a,i,r,s,n,o,l,u,m,y,c,d,p,f,h,w,g,F,S,v,V,q){"use strict";const x=5;let z=null,_=class extends S{constructor(){super(...arguments),this._hasLocalSource=!1,this.adapterName="in-memory-layer-adapter"}destroy(){this.workerClient?.destroy()}async _waitForLayerViewUpdate(e){if(!e)throw new i(`${this.adapterName}:insufficient-data", "layerView is required to fetch the features`);const t=new AbortController,a=o.whenOnce((()=>!e.updating),t.signal);await n.timeout(a,5e3,t).catch((e=>{throw r.getLogger(this).warn("LayerView is taking too long to update. Aborting fetch from layerView."),e}))}async _fetchFeatureSetFromMemory(e,t,a){const r=this.layer;if(this._hasLocalSource&&"queryFeatures"in r)return r.queryFeatures(e);if(!t)throw new i(`${this.adapterName}:insufficient-data`,"view is required to fetch the features from layerView");const s=await t.whenLayerView(this.layer);return await this._waitForLayerViewUpdate(s),s.queryFeatures(e,{signal:a})}async _fetchFeaturesFromMemory(e,t,a,r){const s=this.layer,n="json"===r;if(this._hasLocalSource&&"queryFeatures"in s){const e=await s.queryFeatures(t);return n?v.ensureFeaturesJSON(e.features):e.features}if(await this._waitForLayerViewUpdate(e),n&&"queryFeaturesJSON"in e&&e.queryFeaturesJSON){const{features:i}=await e.queryFeaturesJSON(t,{signal:a});return i}if(!("queryFeatures"in e))throw new i(`${this.adapterName}:not-supported`,"'queryFeatures' is not supported on the layerView");const o=await e.queryFeatures(t,{signal:a});return n?v.ensureFeaturesJSON(o.features):o.features}_fetchFeaturesForStats(e,t){return F.getFieldsList({field:e.field,field2:e.field2,field3:e.field3,normalizationField:e.normalizationField,valueExpression:e.valueExpression}).then((a=>this.getSampleFeatures({sampleSize:-1,view:e.view,returnGeometry:e.returnGeometry,filter:e.filter,requiredFields:a,signal:e.signal},t)))}async _summaryStatsFromClientQuery(e,t){const{view:a,signal:i}=e,r=v.getSummaryStatsQuery(this,e,t),s=await this._fetchFeatureSetFromMemory(r,a,i),n=v.getSummaryStatisticsFromFeatureSet(s,F.isAnyDateField(t)||d.isTimeOnlyField(t));return V.processSummaryStatisticsResult(n,e.outStatisticTypes)}async _getNormalizationTotalFromMemory(e,t,a){const{featuresJSON:r,graphics:s,layerView:n,query:o}=t,l={include:["sum"]},u=(!r&&!s&&n&&"querySummaryStatistics"in n?await n.querySummaryStatistics(o,{field:e},{signal:a}):r?await this.workerClient.summaryStatistics({field:e,outStatisticTypes:l},r):await h.summaryStatistics({attribute:{field:e,outStatisticTypes:l},features:s??[]})).sum;if(null==u)throw new i(`${this.adapterName}:invalid`,"invalid normalizationTotal");return u}async _summaryStatsFromMemory(e,t){const{view:a,field:i,valueExpression:r,normalizationType:s,signal:n}=e,o={field:i,valueExpression:r,normalizationType:s,normalizationField:e.normalizationField,normalizationTotal:e.normalizationTotal,minValue:e.minValue,maxValue:e.maxValue,outStatisticTypes:e.outStatisticTypes},{featuresJSON:l,graphics:u,layerView:m,query:y,fieldInfos:d}=await this._processStatsFromMemoryParams({...e,layerViewFunc:"querySummaryStatistics"});return r&&a&&(l||u)&&(o.fieldType=t?.type?c.kebabDict.toJSON(t.type):null,o.viewInfoParams=v.getViewInfoParams(a),o.timeZone=a.timeZone,o.fieldInfos=d),"percent-of-total"===s&&null==e.normalizationTotal&&(o.normalizationTotal=await this._getNormalizationTotalFromMemory(i,{featuresJSON:l,graphics:u,layerView:m,query:y},n)),!l&&!u&&m&&"querySummaryStatistics"in m?m.querySummaryStatistics(y,o,{signal:n}):l?this.workerClient.summaryStatistics(o,l):h.summaryStatistics({attribute:o,features:u})}async _getFilteredFeatures(t,a){let i=[];if("intersects"===a?.spatialRelationship){const{intersect:r}=await new Promise(((t,a)=>e(["../../../geometry/geometryEngineAsync"],t,a))),s=null!=a.geometry?a.geometry:null;for(const e of t){const t=null!=e.geometry?e.geometry:null;if(t&&s){await r(t,s)&&i.push(e)}}}else i=t;return t.length&&"declaredClass"in t[0]&&"esri.Graphic"===t[0].declaredClass?{graphics:i}:{featuresJSON:i}}async _processStatsFromMemoryParams(e){const{features:t,filter:a}=e;if(t?.length)return this._getFilteredFeatures(t,a);const{view:i,field:r,field2:s,field3:n,normalizationField:o,valueExpression:l,layerViewFunc:u,signal:m}=e;let y=e.returnGeometry;if(null==y&&l){if(!z){const{arcadeUtils:e}=await q.loadArcade();z=e}const e=z.hasGeometryOperations(l);e&&await z.enableGeometryOperations(),y=e}let c=null,d=null,p=null,f=null,h=null;if(i)try{const e="subtype-sublayer"===this.layer.type?this.layer.parent:this.layer;c=await i.whenLayerView(e),d=null!=u&&u in c&&"function"==typeof c[u]}catch{d=!1}if(d)try{await this._waitForLayerViewUpdate(c);const e=await F.getFieldsList({field:r,field2:s,field3:n,normalizationField:o,valueExpression:l});v.getMissingFields(this,e,c).length?d=!1:(p=this.layer.createQuery(),p.outFields=e,p.returnGeometry=!1,v.updateQueryWithFeatureFilter(p,a)),c.suspended&&(d=!1)}catch{d=!1}return d||(f=await this._fetchFeaturesForStats({field:r,field2:s,field3:n,valueExpression:l,normalizationField:o,returnGeometry:y,filter:a,view:i,signal:m},"json"),h=(await F.getFieldsList({valueExpression:l})).map((e=>this.getField(e)?.toJSON())).filter(Boolean)),{layerView:c,query:p,featuresJSON:f,fieldInfos:h}}async _uvFromClientQuery(e,t){const{view:a,signal:i}=e,r=v.getUVQuery(this,e),s=await this._fetchFeatureSetFromMemory(r,a,i),n=await v.getUniqueValuesFromFeatureSet(s,{layer:this,field:e.field,field2:e.field2,field3:e.field3,fieldDelimiter:F.fieldDelimiter,view:e.view,signal:e.signal});return V.createUVResult(n,t,e.returnAllCodedValues,F.fieldDelimiter)}async _uvFromMemory(e,t){const{view:a,field:i,valueExpression:r,returnAllCodedValues:s,signal:n}=e,{featuresJSON:o,graphics:l,layerView:u,query:m,fieldInfos:y}=await this._processStatsFromMemoryParams({...e,layerViewFunc:"queryUniqueValues"}),c={field:i,field2:e.field2,field3:e.field3,fieldDelimiter:F.fieldDelimiter,valueExpression:r,domains:t,returnAllCodedValues:s};return r&&a&&(o||l)&&(c.viewInfoParams=v.getViewInfoParams(a),c.timeZone=a.timeZone,c.fieldInfos=y),!o&&!l&&u&&"queryUniqueValues"in u?u.queryUniqueValues(m,c,{signal:n}):o?this.workerClient.uniqueValues(c,o):h.uniqueValues({attribute:c,features:l})}_histogramForField(e){let t=null;return t=null!=e.minValue&&null!=e.maxValue?Promise.resolve({min:e.minValue,max:e.maxValue}):this.summaryStatistics({...e,outStatisticTypes:{include:["min","max","count"]}}).then((e=>{if(!e.count)throw new i(`${this.adapterName}:insufficient-data`,"Either the layer has no features or none of the features have data for the field");return{min:e.min,max:e.max}})),t.then((t=>v.getBins(this,{min:t.min,max:t.max},e.field,e.numBins??void 0,e.view,e.filter,e.signal)))}async _histogramFromMemory(e){const{view:t,field:a,valueExpression:i,signal:r}=e,{featuresJSON:s,graphics:n,layerView:o,query:l,fieldInfos:u}=await this._processStatsFromMemoryParams({...e,layerViewFunc:"queryHistogram"}),m={field:a,valueExpression:i,normalizationType:e.normalizationType,normalizationField:e.normalizationField,normalizationTotal:e.normalizationTotal,minValue:e.minValue,maxValue:e.maxValue,standardDeviationInterval:e.standardDeviationInterval,classificationMethod:e.classificationMethod,numBins:e.numBins};return i&&t&&(s||n)&&(m.viewInfoParams=v.getViewInfoParams(t),m.timeZone=t.timeZone,m.fieldInfos=u),"percent-of-total"===e.normalizationType&&null==e.normalizationTotal&&(m.normalizationTotal=await this._getNormalizationTotalFromMemory(a,{featuresJSON:s,graphics:n,layerView:o,query:l},r)),!s&&!n&&o&&"queryHistogram"in o?o.queryHistogram(l,m,{signal:r}):s?this.workerClient.histogram(m,s):h.histogram({attribute:m,features:n})}_classBreaksFromInterpolation(e){const{minValue:t,maxValue:a}=e,i=e.numClasses||x,r=[],s=(a-t)/i;for(let l=0;l<i;l++){const e=t+l*s;r.push({minValue:e,maxValue:e+s})}r[i-1].maxValue=a;const n={classBreaks:r,normalizationTotal:e.normalizationTotal},o=V.resolveCBResult(n,e.classificationMethod);return Promise.resolve(o)}async _classBreaksFromMemory(e){const{view:t,field:a,valueExpression:i,signal:r}=e,{featuresJSON:s,graphics:n,layerView:o,query:l,fieldInfos:u}=await this._processStatsFromMemoryParams({...e,layerViewFunc:"queryClassBreaks"}),m={field:a,valueExpression:i,normalizationType:e.normalizationType,normalizationField:e.normalizationField,normalizationTotal:e.normalizationTotal,minValue:e.minValue,maxValue:e.maxValue,standardDeviationInterval:e.standardDeviationInterval,classificationMethod:e.classificationMethod,numClasses:e.numClasses};return i&&t&&(s||n)&&(m.viewInfoParams=v.getViewInfoParams(t),m.timeZone=t.timeZone,m.fieldInfos=u),"percent-of-total"===e.normalizationType&&null==e.normalizationTotal&&(m.normalizationTotal=await this._getNormalizationTotalFromMemory(a,{featuresJSON:s,graphics:n,layerView:o,query:l},r)),!s&&!n&&o&&"queryClassBreaks"in o?o.queryClassBreaks(l,m,{signal:r}):s?this.workerClient.classBreaks(m,s):h.classBreaks({attribute:m,features:n})}async _heatmapStatsFromMemory(e){const{view:t,field:a,radius:i,signal:r}=e;s.assertIsSome(t,"InMemoryLayerAdapter: must have a view");try{const a=await t.whenLayerView(this.layer);if("queryHeatmapStatistics"in a&&!a.updating&&!e.filter)return await a.queryHeatmapStatistics({field:e.field,radius:e.radius})}catch{n.throwIfAborted(r)}const{featuresJSON:o,graphics:l}=await this._processStatsFromMemoryParams({...e,returnGeometry:!0}),u=new p({extent:t.extent,tolerance:"2d"===t.type?t.state.resolution:t.pixelSizeAt?.(t.center)}),m={field:a,radius:i,transform:y.toQuantizationTransform(u),spatialReference:t.spatialReference?.toJSON(),size:t.size};return o?.length||l?.length?o?this.workerClient.heatmapStatistics(m,o):h.heatmapStatistics({attribute:m,features:l}):{min:null,max:null}}getField(e=""){return this.layer.getField(e)}getFieldUsageInfo(e){return this.getField(e)?{supportsLabelingInfo:!0,supportsRenderer:!0,supportsPopupTemplate:!0,supportsLayerQuery:!0,supportsStatistics:!0}:null}getFieldDomain(e,t){return this.layer.getFieldDomain(e,t)}createQuery(){return this.layer.createQuery()}async summaryStatistics(e){const{field:t,valueExpression:a,sqlExpression:r,features:s,view:n}=e,o=t?this.getField(t):null,l=!!a,u="3d"===n?.type;if(!a&&r&&!this.supportsSQLExpression)throw new i(`${this.adapterName}:not-supported`,"Layer does not support standardized SQL expression for queries");return l||s||u?this._summaryStatsFromMemory(e,o):this._summaryStatsFromClientQuery(e,o)}async uniqueValues(e){const{valueExpression:t,sqlExpression:a,features:r,view:s}=e,n=await v.getDomainsForFields(e,this),o=!!t,l="3d"===s?.type;if(!t&&a&&!this.supportsSQLExpression)throw new i(`${this.adapterName}:not-supported`,"Layer does not support standardized SQL expression for queries");return o||r||l?this._uvFromMemory(e,n):this._uvFromClientQuery(e,n)}async histogram(e){const{features:t,valueExpression:a,normalizationType:r,sqlExpression:s}=e,n=t||!!a;if(!a&&s&&!this.supportsSQLExpression)throw new i(`${this.adapterName}:not-supported`,"Layer does not support standardized SQL expression for queries");return n||r?this._histogramFromMemory(e):this._histogramForField(e)}async classBreaks(e){return!1!==e.analyzeData?this._classBreaksFromMemory(e):this._classBreaksFromInterpolation(e)}async queryFeatureCount(e){const{whereClause:t,view:a,signal:r}=e;if(!a)throw new i(`${this.adapterName}:insufficient-data`,"view is required to fetch the features from layerView");const s=this.layer.createQuery();s.where=w.mergeWhereClauses(s.where,t);const n=await a.whenLayerView(this.layer);return await o.whenOnce((()=>!n.updating),r),n.queryFeatureCount(s,{signal:r})}async generateRenderer(e,t){throw new i(`${this.adapterName}:not-supported`,"Layer does not support generateRenderer operation")}async predominantCategories(e){const{fields:t,view:a,signal:i,filter:r}=e,s=f.getArcadeForPredominantCategory(t),n=await this._uvFromMemory({valueExpression:s,view:a,signal:i,filter:r});return v.getPredominantCategoriesFromUVInfos(n.uniqueValueInfos,t)}async heatmapStatistics(e){return this._heatmapStatsFromMemory(e)}async getSampleFeatures(e,t){const{view:r,sampleSize:s,requiredFields:n,returnGeometry:o,filter:l,signal:u}=e,m=this.layer.createQuery(),y=1;if(m.outSpatialReference=r?.spatialReference,m.returnGeometry=!!o,m.outFields=n,v.updateQueryWithFeatureFilter(m,l),!r)throw new i(`${this.adapterName}:not-supported`,"view is required to get sample features for Layer");const c=await r.whenLayerView(this.layer);if(v.getMissingFields(this,n,c).length)throw new i(`${this.adapterName}:not-supported`,"Required fields need to be passed in the outFields for Layer");const d=await this._fetchFeaturesFromMemory(c,m,u,t),p=null!=s&&s>0&&s<=d.length?s:d.length;return a.pickRandom(d,p,y)}load(e){const t=this.layer.load(e).then((async t=>{this.geometryType=t.geometryType,this.objectIdField=t.objectIdField,this.supportsSQLExpression="stream"===t.type||!!t.capabilities?.query?.supportsSqlExpression,this.minScale=t.minScale,this.maxScale=t.maxScale,this.fullExtent="fullExtent"in t?t.fullExtent:t.parent?.fullExtent,this._hasLocalSource=!1,this.hasQueryEngine=!0,this.workerClient=g.WorkerClient.getInstance(),await this.workerClient.open(e.signal)}));return this.addResolvingPromise(t),Promise.resolve(this)}};t.__decorate([l.property({constructOnly:!0})],_.prototype,"layer",void 0),_=t.__decorate([m.subclass("esri.smartMapping.support.adapters.InMemoryLayerAdapter")],_);return _}));
