/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../intl/date","../../layers/support/fieldUtils","../../support/arcadeOnDemand","../../support/basemapUtils","../../time/timeZoneUtils"],(function(t,e,r,i,n,a){"use strict";const o=",",s={light:["streets","gray","topo","terrain","oceans","osm","gray-vector","streets-vector","topo-vector","streets-relief-vector","streets-navigation-vector","topo-3d","navigation-3d","streets-3d","osm-3d","gray-3d","arcgis-light-gray","arcgis-navigation","arcgis-streets","arcgis-streets-relief","arcgis-topographic","arcgis-oceans","osm-standard","osm-standard-relief","osm-streets","osm-streets-relief","osm-light-gray","arcgis-terrain","arcgis-charted-territory","arcgis-community","arcgis-colored-pencil","arcgis-modern-antique","arcgis-midcentury","arcgis-newspaper","arcgis-hillshade-light"],dark:["satellite","hybrid","dark-gray","dark-gray-vector","streets-night-vector","navigation-dark-3d","streets-dark-3d","dark-gray-3d","arcgis-imagery","arcgis-imagery-standard","arcgis-dark-gray","arcgis-navigation-night","arcgis-streets-night","osm-dark-gray","arcgis-nova","arcgis-hillshade-dark"]},l="percent-of-total",c="field",d={exclude:["median"]},g={years:365,months:30,days:1,hours:1/24,minutes:1/1440,seconds:1/86400,milliseconds:1/864e5},m=new Set(["integer","small-integer"]);let u=null;const f=["date","date-only","timestamp-offset"];function p(t){return r.isDateField(t)||r.isDateOnlyField(t)||r.isTimestampOffsetField(t)}async function y(t){const{field:e,field2:r,field3:n,normalizationField:a,valueExpression:o}=t;let s=[];if(o){if(!u){const{arcadeUtils:t}=await i.loadArcade();u=t}s=u.extractFieldNames(o)}return e&&s.push(e),r&&s.push(r),n&&s.push(n),a&&s.push(a),s}function h(t){let e=t.normalizationType;return e||(t.normalizationField?e=c:null!=t.normalizationTotal&&(e=l)),e??void 0}function T(t){return String(t).padStart(2,"0")}function D(t,e,r){let i;if("date"===e||"number"===e){"number"===e&&(t=new Date(t));i=`TIMESTAMP'${r?t.getFullYear():t.getUTCFullYear()}-${T((r?t.getMonth():t.getUTCMonth())+1)}-${T(r?t.getDate():t.getUTCDate())} ${T(r?t.getHours():t.getUTCHours())}:${T(r?t.getMinutes():t.getUTCMinutes())}:${T(r?t.getSeconds():t.getUTCSeconds())}'`}else i=t;return i}function v(t,e,r,i){const{hasQueryEngine:n}=t,a=`(${D(r,F(t,r),n)} - ${D(e,F(t,e),n)})`;let o=g[i],s="/";o<1&&(o=1/o,s="*");return{sqlExpression:1===o?a:`(${a} ${s} ${o})`,sqlWhere:null}}function F(t,e){if(e instanceof Date)return"date";if("number"==typeof e)return"number";if("string"==typeof e){const i=t.getField(e);if("<now>"===e.toLowerCase())return;if(r.isDateField(i))return"field"}}function O(t,e=s){for(const r in e)if(e[r].includes(t))return r}function Z(t,e,r=!0){let i=null;return t&&("string"==typeof t?e.includes(t)&&(i=t):i=n.getWellKnownBasemapId(t)),r?i||"gray":i}function I(t,e){const r=e&&t.getField(e);return!!r&&m.has(r.type)}function $(t){return`cast(${t} as float)`}function w(t,r){const{format:i,timeZoneOptions:n,fieldType:o}=r??{};let s,l;if(n&&({timeZone:s,timeZoneName:l}=a.getTimeZoneFormattingOptions(n.layerTimeZone,n.datesInUnknownTimezone,n.viewTimeZone,e.convertDateFormatToIntlOptions(i||"short-date-short-time"),o)),"string"==typeof t&&isNaN(Date.parse("time-only"===o?`1970-01-01T${t}Z`:t)))return t;switch(o){case"date-only":{const r=e.convertDateFormatToIntlOptions(i||"short-date");return"string"==typeof t?e.formatDateOnly(t,{...r}):e.formatDate(t,{...r,timeZone:a.utc})}case"time-only":{const r=e.convertDateFormatToIntlOptions(i||"short-time");return"string"==typeof t?e.formatTimeOnly(t,r):e.formatDate(t,{...r,timeZone:a.utc})}case"timestamp-offset":{if(!s&&"string"==typeof t&&new Date(t).toISOString()!==t)return t;const r=i||n?e.convertDateFormatToIntlOptions(i||"short-date-short-time"):void 0,a=r?{...r,timeZone:s,timeZoneName:l}:void 0;return"string"==typeof t?e.formatTimestamp(t,a):e.formatDate(t,a)}default:{const r=i||n?e.convertDateFormatToIntlOptions(i||"short-date-short-time"):void 0;return e.formatDate("string"==typeof t?new Date(t):t,r?{...r,timeZone:s,timeZoneName:l}:void 0)}}}t.castIntegerFieldToFloat=$,t.dateTypes=f,t.defaultBasemapGroups=s,t.defaultStatisticTypes=d,t.fieldDelimiter=o,t.formatAnyDate=w,t.getBasemapGroup=O,t.getBasemapId=Z,t.getDateDiffSQL=v,t.getDateType=F,t.getFieldsList=y,t.getNormalizationType=h,t.isAnyDateField=p,t.isIntegerField=I,t.unitValueInDays=g,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
