/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../Color","../../core/arrayUtils","./support/colors","./support/symbologyUtils","./support/utils"],(function(e,r,i,l,g,t){"use strict";const a={light:{color:[153,153,153,.25],width:"0.5px"},lighter:{color:[194,194,194,.25],width:"0.5px"},lightest:{color:[153,153,153,.25],width:"0.5px"}},s={lightBasemaps:{outline:a.lighter,fillOpacity:.8,width:"2px",size:"8px"},darkBasemaps:{outline:a.light,fillOpacity:.6,width:"2px",size:"8px"},grayBasemaps:{outline:a.lightest,fillOpacity:.8,width:"2px",size:"8px"}},n="#aaaaaa",o="#ffffff",d="12px",h=["seq-cividis","seq-single-blues","seq-yellow-red-purple","seq-yellow-orange-red","seq-yellow-pink-purple","seq-yellow-purple-blue","seq-yellow-green-blue","seq-teal-lightgreen-bright","seq-green-lightgray-bright","seq-teal-lightbrown-bright","seq-lightred-darkgray-bright","seq-orange-red-light","seq-red-lightgray-bright","seq-blue-lightgray-bright","seq-orange-lightgray-bright","seq-blue-red-yellow-bright","seq-blue-tan-bright","seq-pink-red","seq-red-blue-green","seq-orange-red-dark","seq-magenta-light","seq-red-light","seq-orange-light","seq-mustard-light","seq-yellowgreen-light","seq-green-light","seq-aqua-light","seq-cyan-light","seq-blue-light","seq-purple-light","seq-brown-light","seq-steel-light","seq-brown-palegreen","seq-purple-pink-yellow","seq-blue-green-yellow","seq-green-avocado-lightpurple","seq-turquoise-lightgreen","seq-red-brown-white","seq-purple-pink-white","seq-blue-green-white","seq-green-avocado-white","seq-turquoise-lightgreen-white","seq-snowy-mountain","seq-snow-cactus","seq-subdued-red-yellow","seq-subdued-purple-blue","seq-subdued-blue-cyan","seq-subdued-green-yellow","seq-subdued-green","seq-lines-blue-orange","seq-lines-purple-brown","seq-esribrand-red","seq-esribrand-red-orange","seq-esribrand-orange","seq-esribrand-orangeyellow","seq-esribrand-yellow","seq-esribrand-yellowgreen","seq-esribrand-green","seq-esribrand-greenblue","seq-esribrand-blue","seq-esribrand-violet","seq-esribrand-violetred","seq-esribrand-brown","seq-esribrand-gray","seq-single-greens","seq-single-grays","seq-single-oranges","seq-single-purples","seq-single-reds","seq-multi-bugn","seq-multi-bupu","seq-multi-gnbu","seq-multi-orrd","seq-multi-pubu","seq-multi-pubugn","seq-multi-purd","seq-multi-rdpu","seq-multi-ylgn","seq-multi-ylgnbu","seq-multi-ylorbr","seq-multi-ylorrd","point-cloud-intensity-scheme"],b=["seq-magma","seq-inferno","seq-plasma","seq-viridis","seq-blue-gray-bright","seq-reds-bright","seq-purples-bright","seq-greens-bright","seq-browns-bright","seq-dark-to-light-magenta-bright","seq-dark-to-light-purple-bright","seq-dark-to-light-blue-bright","seq-dark-to-light-green-bright","seq-brown-to-tan-bright","seq-lightgray-blue-bright","seq-lightgray-green-bright","seq-lightgray-darkmagenta-bright","seq-yellow-darkblue-bright","seq-blues-bright","seq-gray-lightgreen-bright","seq-lightmagenta-darkgray-bright","seq-lightblue-darkgray-bright","seq-magenta","seq-red","seq-orange","seq-yellow","seq-yellowgreen","seq-green","seq-turquoise","seq-royal","seq-blueberry","seq-purple","seq-brown","seq-blue","seq-red-darkblue","seq-purple-darkgreen","seq-blue-darkgreen","seq-green-darkpurple","seq-blue-gray","seq-mentone-beach","seq-subdued-brown-tan","seq-subdued-gray-green","seq-subdued-green-tan","seq-subdued-blue-purple","seq-subdued-pink-brown","seq-subdued-green-pink","seq-lines-green-brown","seq-lines-yellow-blue","seq-blue-bright-1","seq-green-bright-1","seq-green-bright-2","seq-green-bright-3","seq-blue-bright-2","seq-blue-bright-3","seq-blue-bright-4","seq-blue-bright-5","seq-red-purple-bright","seq-red-magenta-bright","seq-red-bright-3","seq-red-bright-4","seq-yellow-bright-1","seq-yellow-bright-2","seq-yellow-bright-3","seq-yellow-bright-4","seq-yellow-gray-bright","seq-green-gray-bright","seq-red-gray-bright","seq-gray-redbright","seq-gray-green-bright","seq-gray-blue-bright","seq-gray-purple-bright","seq-plaingray-bright","seq-greengray-bright","seq-coolgray-bright","seq-warmgray-bright","seq-yellow-green-combo-bright","seq-cyan-blue-combo-bright","seq-magenta-purple-combo-bright","point-cloud-elevation-scheme"],u=["div-bluegreen-yellow-orange","div-orange-yellow-blue-light","div-green-yellow-redpurple","div-green-yellow-orange","div-green-gray-bright","div-red-blue-bright","div-blue-orange-bright","div-blue-lightgreen-bright","div-red-gray-bright","div-blue-gray-bright","div-red-lightgreen-bright","div-green-teal-bright","div-bluegreen-orange","div-orange-purple","div-bluegreen-purple","div-orange-pink","div-blue-yellow-red-bright","div-red-green-bright","div-orange-gray-bright","div-blue-green-bright","div-purple-brown-bright","div-blue-brown-bright","div-teal-brown-bright","div-lightblue-gray-bright","div-redpurple-blue","div-orange-blue","div-green-pink","div-bluegreen-redpurple","div-green-redpurple","div-green-orange","div-red-yellow-pink","div-blue-green","div-bluegreen-yellow-redpurple","div-bluegreen-pink","div-red-yellow-purple","div-orange-yellow-pink","div-orange-yellow-blue-dark","div-green-purple-light","div-blue-red-light","div-green-purple-light-2","div-cyan-blue-light","div-blue-yellow-light","div-purple-yellow-light","div-magenta-yellow-light","div-purple-green-light","div-blue-blue","div-green-green","div-blue-green-light","div-red-green-light","div-blue-yellow-brown-light","div-blue-white-brown","div-subdued-red-green","div-subdued-red-purple","div-subdued-brown-gray","div-subdued-sepia-gray","div-subdued-blue-gray","div-subdued-green-brown","div-lines-blue-brown","div-lines-green-purple","div-lines-red-gray","div-esribrand-red-bluegreen","div-esribrand-red-blue","div-esribrand-red-violet","div-esribrand-red-violetred","div-esribrand-red-gray","div-esribrand-redorange-greenblue","div-esribrand-redorange-blue","div-esribrand-redorange-violet","div-esribrand-redorange-violetred","div-esribrand-redorange-gray","div-esribrand-orange-greenblue","div-esribrand-orange-blue","div-esribrand-orange-violet","div-esribrand-orange-violetred","div-esribrand-orange-gray","div-esribrand-orangeyellow-greenblue","div-esribrand-orangeyellow-blue","div-esribrand-orangeyellow-violet","div-esribrand-orangeyellow-violetred","div-esribrand-orangeyellow-gray","div-esribrand-yellow-green-blue","div-esribrand-yellow-blue","div-esribrand-yellow-violet","div-esribrand-yellow-violetred","div-esribrand-yellow-brown","div-esribrand-yellow-gray","div-esribrand-yellowgreen-greenblue","div-esribrand-yellowgreen-blue","div-esribrand-yellowgreen-violet","div-esribrand-yellowgreen-violetred","div-esribrand-yellowgreen-brown","div-esribrand-yellowgreen-gray","div-esribrand-green-blue","div-esribrand-green-violet","div-esribrand-green-violetred","div-esribrand-green-gray","div-esribrand-greenblue-blue","div-esribrand-greenblue-violetred","div-esribrand-greenblue-brown","div-esribrand-greenblue-gray","div-esribrand-blue-brown","div-esribrand-blue-gray","div-esribrand-violet-brown","esribrand-violet-gray","div-esribrand-violetred-gray","div-esribrand-brown-gray","div-blue-yellow-brown","div-purple-yellow-brown","div-purple-beige-green","div-teal-yellow-brown","div-yellow-magenta-light","div-green-yellow-blue","div-brown-blue","div-red-green-cyan","div-yellow-slate-teal","div-brbg","div-piyg","div-prgn","div-puor","div-rdbu","div-rdgy","div-rdylbu","div-rdylgn","div-spectral"],y=["div-blue-green-bright-1","div-blue-red-bright-1","div-lightgreen-yellow-bright","div-lightred-gray-bright","div-lightgreen-gray-bright","div-yellow-green-bright","div-green-darkgray-bright","div-lightmagenta-gray-bright","div-lightblue-yellow-bright","div-yellow-gray-purple","div-red-gray-blue","div-green-gray-purple","div-orange-gray-blue","div-green-purple","div-blue-red","div-green-magenta","div-blue-orange","div-blue-yellow","div-purple-yellow","div-magenta-yellow","div-purple-green-dark","div-green-brown","div-green-gray","div-blue-white","div-red-steel","div-aqua-darkgray-red","div-subdued-tan-blue","div-subdued-green-blue","div-subdued-green-pink","div-lines-green-orange","div-lines-yellow-blue","div-yellow-orange-purple-bright","div-yellow-blue-bright-1","div-yellow-blue-bright-2","div-yellow-blue-bright","div-yellow-blue-bright-3","div-yellow-purple-bright-1","div-yellow-purple-bright-2","div-yellow-red-bright-1","div-yellow-red-bright-2","div-yellow-gray-bright-1","div-yellow-gray-bright-2","div-yellow-gray-bright-3","div-purple-green-bright-1","div-purple-green-bright-2","div-pink-yellow-bright-1","div-pink-yellow-bright-2","div-red-blue-bright-1","div-red-blue-bright-2","div-orange-blue-bright-3","div-orange-blue-bright-4","div-red-purple-bright","div-red-gray-bright-1","div-red-gray-bright-2","div-red-gray-bright-3","div-teal-yellow-bright-1","div-teal-yellow-bright-2","div-teal-orange-bright","div-green-red-bright","div-green-magenta-bright","div-green-purple-bright-1","div-green-purple-bright-2","div-green-blue-bright-1","div-green-blue-bright-2","div-green-gray-bright-1","div-green-gray-bright-2","div-green-gray-bright-3","div-blue-yellow-bright-2","div-blue-lightorange-bright","div-blue-orange-bright-1","div-blue-orange-bright-2","div-blue-red-bright-2","div-blue-tan-bright","div-blue-gray-bright-1","div-blue-gray-bright-2","div-blue-gray-bright-3","div-blue-green-orange","div-purple-orange","div-purple-green","div-teal-orange","div-red-purple-blue","div-yellow-magenta","div-green-blue","div-blue-brown","div-red-cyan","div-yellow-teal"],p=["highlight-orange","highlight-blue","highlight-bluegreen","highlight-pink","highlight-purple","highlight-red","highlight-blue-dark","highlight-orange-dark","highlight-blue-gray","highlight-bluegreen-gray","highlight-orange-gray","highlight-pink-gray","highlight-purple-gray","highlight-red-gray","highlight-blue-gray-dark","highlight-orange-gray-dark","highlight-pink-gray-dark","highlight-purple-gray-dark","highlight-blue-bright-gray-dark","highlight-green-gray-dark","highlight-brown-gray-dark"],m=["highlight-orange-bright","highlight-blue-bright","highlight-blue-gray-bright","highlight-orange-gray-bright","highlight-red-gray-bright","highlight-purple-gray-bright","highlight-blue-bright-gray-bright","highlight-green-gray-bright","highlight-yellow-gray-bright"],v=["extremesdiv-orange-yellow-blue-dark","extremes-blue","extremes-blue-dark","extremes-bluegreen","extremes-orange","extremes-orange-dark","extremes-pink","extremes-purple","extremes-red","extremesdiv-blue-green","extremesdiv-bluegreen-pink","extremesdiv-bluegreen-purple","extremesdiv-bluegreen-redpurple","extremesdiv-bluegreen-yellow-orange","extremesdiv-green-pink","extremesdiv-green-yellow-orange","extremesdiv-green-yellow-redpurple","extremesdiv-orange-pink","extremesdiv-orange-purple","extremesdiv-orange-yellow-blue-light","extremesdiv-red-yellow-pink","extremesdiv-red-yellow-purple","extremesdiv-redpurple-blue","extremes-blue-gray","extremes-blue-gray-dark","extremes-bluegreen-gray","extremes-orange-gray","extremes-orange-gray-dark","extremes-pink-gray","extremes-purple-gray","extremes-red-gray","extremes-pink-gray-dark","extremes-purple-gray-dark","extremes-blue-bright-gray-dark","extremes-green-gray-dark","extremes-brown-gray-dark"],c=["extremes-orange-bright","extremes-blue-bright","extremes-blue-gray-bright","extremes-orange-gray-bright","extremesdiv-green-purple","extremesdiv-orange-blue","extremesdiv-red-blue","extremesdiv-yellow-purple","extremes-red-gray-bright","extremes-purple-gray-bright","extremes-blue-bright-gray-bright","extremes-green-gray-bright","extremes-yellow-gray-bright"],w=["highlight-orange-gray","highlight-bluegreen-gray","highlight-purple-gray","highlight-pink-gray","highlight-blue-gray","highlight-red-gray","highlight-orange-gray-dark","highlight-blue-gray-dark","highlight-orange-gray-bright","highlight-blue-gray-bright","extremes-orange-gray","extremes-bluegreen-gray","extremes-purple-gray","extremes-pink-gray","extremes-blue-gray","extremes-red-gray","extremes-orange-gray-dark","extremes-blue-gray-dark","extremes-orange-gray-bright","extremes-blue-gray-bright","highlight-red-gray-bright","highlight-purple-gray-bright","highlight-blue-bright-gray-bright","highlight-green-gray-bright","highlight-yellow-gray-bright","highlight-pink-gray-dark","highlight-purple-gray-dark","highlight-blue-bright-gray-dark","highlight-green-gray-dark","highlight-brown-gray-dark","extremes-red-gray-bright","extremes-purple-gray-bright","extremes-blue-bright-gray-bright","extremes-green-gray-bright","extremes-yellow-gray-bright","extremes-pink-gray-dark","extremes-purple-gray-dark","extremes-blue-bright-gray-dark","extremes-green-gray-dark","extremes-brown-gray-dark"],q={light:{common:s.grayBasemaps,primary:"seq-single-blues",secondary:[...h,...b].filter((e=>"seq-single-blues"!==e))},dark:{common:s.grayBasemaps,primary:"seq-blue-gray-bright",secondary:[...b,...h].filter((e=>"seq-blue-gray-bright"!==e))}},k={"high-to-low":{name:"high-to-low",label:"TODO",description:"TODO",schemes:{default:q}},"above-and-below":{name:"above-and-below",label:"TODO",description:"TODO",schemes:{default:{light:{common:s.grayBasemaps,primary:"div-rdbu",secondary:[...u,...y].filter((e=>"div-rdbu"!==e))},dark:{common:s.grayBasemaps,primary:"div-blue-red-bright-1",secondary:[...y,...u].filter((e=>"div-blue-red-bright-1"!==e))}}}},"centered-on":{name:"centered-on",label:"TODO",description:"TODO",schemes:{default:{light:{common:{outline:a.lighter,width:"2px",size:"8px"},primary:"highlight-orange",primaryGray:"highlight-orange-gray",secondary:[...p,...m].filter((e=>"highlight-orange"!==e))},dark:{common:{outline:a.light,width:"2px",size:"8px"},primary:"highlight-orange-bright",primaryGray:"highlight-orange-gray-bright",secondary:[...m,...p].filter((e=>"highlight-orange-bright"!==e))}}}},extremes:{name:"extremes",label:"TODO",description:"TODO",schemes:{default:{light:{common:{outline:a.lighter,width:"2px",size:"8px"},primary:"extremesdiv-orange-purple",primaryGray:"extremes-orange-gray",secondary:[...v,...c].filter((e=>"extremesdiv-orange-purple"!==e))},dark:{common:{outline:a.light,width:"2px",size:"8px"},primary:"extremesdiv-orange-blue",primaryGray:"extremes-orange-gray-bright",secondary:[...c,...v].filter((e=>"extremesdiv-orange-blue"!==e))}}}},above:{name:"above",label:"TODO",description:"TODO",schemes:{default:q}},below:{name:"below",label:"TODO",description:"TODO",schemes:{default:q}}},x=g.createThemes({themeDictionary:k});function f(e){return g.getThemesforBasemap(x,e)}function C(e){const r=e.theme,l=g.getRawSchemes({basemap:e.basemap,basemapTheme:e.basemapTheme,theme:r?x.get(r):null});if(!l)return;let t=l.schemesInfo;const a=t.common,{basemapId:s,basemapTheme:n}=l;!e.worldScale||"centered-on"!==r&&"extremes"!==r||(t={...t},t.secondary=t.secondary.slice(),t.secondary.push(t.primary),t.primary=t.primaryGray,delete t.primaryGray,t.secondary=t.secondary.filter((e=>{const r=e.includes("gray");return e!==t.primary&&r})));const o={...e,basemap:s};return{primaryScheme:I(o,t.primary,a),secondarySchemes:t.secondary.map((e=>I(o,e,a))).filter(i.isSome),basemapId:s,basemapTheme:n}}function S(e){return g.filterSchemesByName(e.name,C(e))}function D(e){return g.filterSchemesByTag(e.includedTags,e.excludedTags,C(e))}function O(e){let r,i,l="";const t=e.id;if(t){const e=t.split("/");e&&(l=e[0],r=e[1],i=e[2])}const a=g.getRawSchemes({basemap:r,theme:x.get(l)});if(!a)return;const{schemesInfo:s}=a;return I({theme:l,basemap:r,geometryType:e.geometryType,worldScale:e.worldScale,view:e.view},i,s.common)}function T(e){if(!e)return;const i={...e};return i.colors=i.colors.map((e=>new r(e))),i.tags=[...i.tags],i.colorsForClassBreaks=i.colorsForClassBreaks.map((e=>({numClasses:e.numClasses,colors:e.colors.map((e=>new r(e)))}))),i.noDataColor&&(i.noDataColor=new r(i.noDataColor)),"outline"in i&&i.outline&&(i.outline={color:i.outline.color&&new r(i.outline.color),width:i.outline.width}),i}function B(e){const r=e;return r.colors.reverse(),r.colorsForClassBreaks.forEach((e=>{e.colors.reverse()})),r}function z(e){const r=e.theme,i=e.colors,l=x.get(r).supportedBasemaps,t=[],a={theme:r,basemap:null,geometryType:e.geometryType,worldScale:e.worldScale,view:e.view};return l.forEach((e=>{const l=g.getRawSchemes({basemap:e,theme:x.get(r)}).schemesInfo;if(a.basemap=e,l){const e=F(I(a,l.primary,l.common),i);e&&t.push(e),l.secondary.forEach((e=>{const r=F(I(a,e,l.common),i);r&&t.push(r)}))}})),t}function F(e,r){let i,l;if(l=t.hasIdenticalColors(e.colors,r),l)i=l>0?e:B(e);else{let g;e.colorsForClassBreaks.some((e=>(e.numClasses===r.length&&(g=e.colors),!!g))),g&&(l=t.hasIdenticalColors(g,r),l&&(i=l>0?e:B(e)))}return i}function I(e,r,i){const g=l[r];if(!g)return;const t=e.theme??"",a="mesh"!==e.geometryType&&e.worldScale?e.view:null;let s=i.fillOpacity;null==s&&null!=r&&w.includes(r)&&(s=.8);const h="below"===e.theme,b=h?[...g.stops].reverse():g.stops,u=[];for(const l in g)if("stops"!==l&&"name"!==l&&"tags"!==l){const e=+l;u.push({numClasses:e,colors:h?[...g[e]].reverse():g[e]})}const y=null!=r&&w.includes(r)?o:n,p=t+"/"+e.basemap+"/"+r,m=s||1;switch(e.geometryType){case"point":case"multipoint":return G({id:p,name:g.name,tags:g.tags,theme:t,opacity:m,colors:b,colorsForClassBreaks:u,noDataColor:y,outline:i.outline,size:i.size},a);case"polyline":return L({id:p,name:g.name,tags:g.tags,theme:t,opacity:m,colors:b,colorsForClassBreaks:u,noDataColor:y,width:i.width},a);case"polygon":return E({id:p,name:g.name,tags:g.tags,theme:t,opacity:m,colors:b,colorsForClassBreaks:u,noDataColor:y,outline:i.outline,size:d},a);case"mesh":return R({id:p,name:g.name,tags:g.tags,theme:t,opacity:m,colors:b,colorsForClassBreaks:u,noDataColor:y});default:return}}function G(e,i){return{id:e.id,name:e.name,tags:[...e.tags],theme:e.theme,colors:e.colors.map((e=>new r(e))),colorsForClassBreaks:W(e.colorsForClassBreaks),noDataColor:new r(e.noDataColor),outline:{color:new r(e.outline.color),width:e.outline.width},size:i&&"3d"===i.type?t.toWorldScale(e.size,i):e.size,opacity:e.opacity}}function L(e,i){return{id:e.id,name:e.name,tags:[...e.tags],theme:e.theme,colors:e.colors.map((e=>new r(e))),colorsForClassBreaks:W(e.colorsForClassBreaks),noDataColor:new r(e.noDataColor),width:i&&"3d"===i.type?t.toWorldScale(e.width,i):e.width,opacity:e.opacity}}function E(e,i){return{id:e.id,name:e.name,tags:[...e.tags],theme:e.theme,colors:e.colors.map((e=>new r(e))),colorsForClassBreaks:W(e.colorsForClassBreaks),noDataColor:new r(e.noDataColor),outline:{color:new r(e.outline.color),width:e.outline.width},opacity:e.opacity,size:i&&"3d"===i.type?t.toWorldScale(e.size,i):e.size}}function R(e){return{id:e.id,name:e.name,tags:[...e.tags],theme:e.theme,colors:e.colors.map((e=>new r(e))),colorsForClassBreaks:W(e.colorsForClassBreaks),noDataColor:new r(e.noDataColor),opacity:e.opacity}}function W(e){return e.map((e=>({numClasses:e.numClasses,colors:e.colors.map((e=>new r(e)))})))}e.centeredOnDarkSchemes=m,e.centeredOnLightSchemes=p,e.cloneScheme=T,e.divergingDarkSchemes=y,e.divergingLightSchemes=u,e.extremesDarkSchemes=c,e.extremesLightSchemes=v,e.fadeToGraySchemes=w,e.flipColors=B,e.getMatchingSchemes=z,e.getSchemeById=O,e.getSchemeByName=S,e.getSchemes=C,e.getSchemesByTag=D,e.getThemes=f,e.sequentialDarkSchemes=b,e.sequentialLightSchemes=h,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
