/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../Color","../../core/arrayUtils","../../core/colorUtils","./size","./support/colors","./support/symbologyUtils","./support/utils"],(function(e,o,n,a,r,t,i,c){"use strict";const m={light:{color:[153,153,153,.25],width:"1px"},dark:{color:[153,153,153,.25],width:"1px"},darker:{color:[26,26,26,.25],width:"1px"}},s="#aaaaaa",l=["tropical-bliss","desert-blooms","under-the-sea","vibrant-rainbow","ocean-bay","prairie-summer","pastel-chalk"],p=["cat-symbols-strong","cat-symbols-autumnal","cat-symbols-bright","cat-symbols-midrange","cat-symbols-subdued","cat-symbols-pastel","cat-symbols-red","cat-symbols-blue","cat-symbols-green","cat-symbols-gray"],d={default:{name:"default",label:"Default",description:"Default theme for visualizing features by their predominant category.",schemes:{point:{light:{common:{noDataColor:s,outline:m.light,size:"8px"},primary:"predominant-v1",secondary:["predominant-v2","predominant-v3","predominant-v4","predominant-v5","predominance-race","predominance-money","predominance-race-ethnic","predominance-rainbow","predominance-sequence"].concat(p).concat(l)},dark:{common:{noDataColor:s,outline:m.darker,size:"8px"},primary:"predominant-v2",secondary:["predominant-v1","predominant-v3","predominant-v4","predominant-v5","predominance-race","predominance-money","predominance-race-ethnic","predominance-rainbow","predominance-sequence"].concat(p).concat(l)}},polyline:{light:{common:{noDataColor:s,width:"2px"},primary:"predominant-v1",secondary:["predominant-v2","predominant-v3","predominant-v4","predominant-v5","predominance-race","predominance-money","predominance-race-ethnic","predominance-rainbow","predominance-sequence"].concat(p).concat(l)},dark:{common:{noDataColor:s,width:"2px"},primary:"predominant-v2",secondary:["predominant-v1","predominant-v3","predominant-v4","predominant-v5","predominance-race","predominance-money","predominance-race-ethnic","predominance-rainbow","predominance-sequence"].concat(p).concat(l)}},polygon:{light:{common:{noDataColor:s,outline:m.light,fillOpacity:.8,markerSize:"8px"},primary:"predominant-v1",secondary:["predominant-v2","predominant-v3","predominant-v4","predominant-v5","predominance-race","predominance-money","predominance-race-ethnic","predominance-rainbow","predominance-sequence"].concat(p).concat(l)},dark:{common:{noDataColor:s,outline:m.dark,fillOpacity:.8,markerSize:"8px"},primary:"predominant-v2",secondary:["predominant-v1","predominant-v3","predominant-v4","predominant-v5","predominance-race","predominance-money","predominance-race-ethnic","predominance-rainbow","predominance-sequence"].concat(p).concat(l)}}}}},u=i.createThemes({themeDictionary:d});function y(e){return i.getThemesforBasemap(u,e)}function h(e){const o="default",a=i.getRawSchemes({basemap:e.basemap,geometryType:e.geometryType,basemapTheme:e.basemapTheme,theme:u.get(o)});if(!a)return;const{schemesInfo:t,basemapId:c,basemapTheme:m}=a,s=t.common,l=r.getSchemes({basemap:e.basemap,geometryType:e.geometryType,worldScale:e.worldScale,view:e.view}),p=l?.primaryScheme;return{primaryScheme:S(e,t.primary,s,p),secondarySchemes:t.secondary.map((o=>S(e,o,s,p))).filter(n.isSome),basemapId:c,basemapTheme:m}}function g(e){return i.filterSchemesByName(e.name,h(e))}function w(e){return i.filterSchemesByTag(e.includedTags,e.excludedTags,h(e))}function b(e){if(!e)return;const n={...e};return n.colors=n.colors.map((e=>new o(e))),n.tags=[...n.tags],n.noDataColor&&(n.noDataColor=new o(n.noDataColor)),"outline"in n&&n.outline&&(n.outline={color:n.outline.color&&new o(n.outline.color),width:n.outline.width}),"sizeScheme"in n&&n.sizeScheme&&(n.sizeScheme=r.cloneScheme(n.sizeScheme)),n}function S(e,o,n,r){const i=t[o];if(!i)return;const{numColors:c}=e,m=c?i[c]??a.createUniqueColors(i.stops,c):i.stops,s="mesh"!==e.geometryType&&e.worldScale?e.view:null;switch(e.geometryType){case"point":case"multipoint":{const e=n;return v({name:i.name,tags:i.tags,colors:m,noDataColor:e.noDataColor,opacity:1,sizeScheme:r,outline:e.outline,size:e.size},s)}case"polyline":{const e=n;return f({name:i.name,tags:i.tags,colors:m,noDataColor:e.noDataColor,opacity:1,sizeScheme:r,width:e.width},s)}case"polygon":{const e=n,o=r;o&&o.marker&&null!=e.markerSize&&(o.marker.size=e.markerSize);return z({name:i.name,tags:i.tags,colors:m,noDataColor:e.noDataColor,opacity:e.fillOpacity,outline:e.outline,sizeScheme:o},s)}case"mesh":{const e=n;return C({name:i.name,tags:i.tags,colors:m,noDataColor:e.noDataColor,opacity:e.fillOpacity})}default:return}}function v(e,n){return{name:e.name,tags:[...e.tags],colors:e.colors.map((e=>new o(e))),noDataColor:new o(e.noDataColor),outline:{color:new o(e.outline.color),width:e.outline.width},size:n?c.toWorldScale(e.size,n):e.size,sizeScheme:e.sizeScheme,opacity:e.opacity}}function f(e,n){return{name:e.name,tags:[...e.tags],colors:e.colors.map((e=>new o(e))),noDataColor:new o(e.noDataColor),width:n?c.toWorldScale(e.width,n):e.width,sizeScheme:e.sizeScheme,opacity:e.opacity}}function z(e,n){const{sizeScheme:a}=e;return a.marker.size=n?c.toWorldScale(a.marker.size,n):a.marker.size,{name:e.name,tags:[...e.tags],colors:e.colors.map((e=>new o(e))),noDataColor:new o(e.noDataColor),outline:{color:new o(e.outline.color),width:e.outline.width},sizeScheme:a,opacity:e.opacity}}function C(e){return{name:e.name,tags:[...e.tags],colors:e.colors.map((e=>new o(e))),noDataColor:new o(e.noDataColor),opacity:e.opacity}}e.cloneScheme=b,e.getSchemeByName=g,e.getSchemes=h,e.getSchemesByTag=w,e.getThemes=y,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
