/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../geometry","../chunks/arcade","../arcade/Dictionary","../arcade/Feature","../chunks/languageUtils","../core/lang","../core/sql/DateOnly","../core/sql/TimeOnly","../geometry/Point","../geometry/Polygon","../geometry/Polyline","../geometry/Multipoint","../geometry/Extent"],(function(e,t,n,r,i,o,a,u,c,l,s,f,p,y){"use strict";const m=/^\$(feature|aggregatedFeatures)\./i,d={vars:{$feature:"any",$view:"any"},spatialReference:null};function S(e){return e.replaceAll(/[|\\{}()[\]^$+*?.]/g,"\\$&")}function v(e){return null==e?null:o.isArray(e)||o.isImmutableArray(e)?"array":o.isDate(e)?"date":o.isString(e)?"text":o.isBoolean(e)?"boolean":o.isNumber(e)?"number":e instanceof r?"dictionary":o.isFeature(e)?"feature":e instanceof l?"point":e instanceof s?"polygon":e instanceof f?"polyline":e instanceof p?"multipoint":e instanceof y?"extent":e instanceof u.DateOnly?"dateOnly":e instanceof c.TimeOnly?"time":o.isFeatureSet(e)?"featureSet":o.isFeatureSetCollection(e)?"featureSetCollection":null}function x(e){if(!e)return null;try{return n.parseScript(e)}catch(t){}return null}function g(e,t){const r="string"==typeof e?x(e):e;if(!r)return null;try{return t=t||a.clone(d),n.compileScript(r,t)}catch(i){}return null}function F(e,t,n){return{vars:{$feature:null==e?new i:i.createFromGraphic(e,n),$view:t?.view},spatialReference:t?.sr,timeZone:n??null}}function h(e,t,n){return i.createFromGraphicLikeObject(t,e,n,null)}function b(e,t){null!=e.vars&&(e.vars.$feature=t)}function w(e,t){let r;try{r=n.executeScript(e,t)}catch(i){r=null}return r}function E(e,t){let n;try{n=e?e(t):null}catch(r){n=null}return n}function T(e,t){try{return e?e(t):Promise.resolve(null)}catch(n){return Promise.resolve(null)}}function C(e,t){if(!e)return[];const r="string"==typeof e?x(e):e;if(!r)return[];const i=n.extractExpectedFieldLiterals(r);let o=new Array;i.forEach((e=>{m.test(e)&&(e=e.replace(m,""),o.push(e))}));const a=o.filter((e=>e.includes("*")));return o=o.filter((e=>!a.includes(e))),t&&a.forEach((e=>{const n=new RegExp(`^${e.split(/\*+/).map(S).join(".*")}$`,"i");t.forEach((e=>n.test(e)?o.push(e):null))})),[...new Set(o.sort())]}function O(e){return n.referencesMember(e,"$view")}function $(e,t){return!!e&&n.referencesMember(e,t)}function A(e){if(!e||null==e.spatialReference&&(null==e.scale||null==e.viewingMode))return;return{view:e.viewingMode&&null!=e.scale?new r({viewingMode:e.viewingMode,scale:e.scale}):null,sr:e.spatialReference}}function M({url:e,spatialReference:t,lrucache:r,interceptor:i}){const o=n.featureSetUtils();return o?o.createFeatureSetCollectionFromService(e,t,r,i):null}function G({layer:e,spatialReference:t,outFields:r,returnGeometry:i,lrucache:o,interceptor:a}){if(null===e)return null;const u=n.featureSetUtils();return u?u.constructFeatureSet(e,t,r,i??!0,o,a):null}function R(e){if(null===e?.map)return null;const t=n.featureSetUtils();return t?t.createFeatureSetCollectionFromMap(e.map,e.spatialReference,e.lrucache,e.interceptor):null}function D(e,t){return r.convertJsonToArcade(e,t)}function P(e,t,r=[]){return n.loadScriptDependencies(e,t,r)}function z(){return n.enableGeometrySupport()}function I(){return n.enableFeatureSetSupport()}function U(e){return"simple"===e.type||"class-breaks"===e.type||"unique-value"===e.type||"dot-density"===e.type||"dictionary"===e.type||"pie-chart"===e.type}function V(e){return"esri.layers.support.LabelClass"===e.declaredClass}function k(e){return"esri.PopupTemplate"===e.declaredClass}function L(e,t){if(!e)return!1;if("string"==typeof e)return t(e);const n=e;if(U(n)){if("dot-density"===n.type){const e=n.attributes?.some((e=>t(e.valueExpression)));if(e)return e}const e=n.visualVariables,r=!!e&&e.some((e=>{let n=t(e.valueExpression);return"size"===e.type&&(B(e.minSize)&&(n=n||t(e.minSize.valueExpression)),B(e.maxSize)&&(n=n||t(e.maxSize.valueExpression))),n}));return!(!("valueExpression"in n)||!t(n.valueExpression))||r}if(V(n)){const e=n.labelExpressionInfo?.expression;return!(!e||!t(e))||!1}return!!k(n)&&(!!n.expressionInfos&&n.expressionInfos.some((e=>t(e.expression)))||Array.isArray(n.content)&&n.content.some((e=>"expression"===e.type&&t(e.expressionInfo?.expression))))}function j(e){const t=x(e);return!!t&&n.scriptTouchesGeometry(t)}function q(e){return L(e,j)}function J(e){const t=x(e);return!!t&&n.scriptUsesGeometryEngine(t)}function N(e){return L(e,J)}function B(e){return e&&"esri.renderers.visualVariables.SizeVariable"===e.declaredClass}e.arcade=n.arcade,e.Dictionary=r,e.arcadeFeature=i,e.convertFeatureLayerToFeatureSet=G,e.convertJsonToArcade=D,e.convertMapToFeatureSetCollection=R,e.convertServiceUrlToWorkspace=M,e.createExecContext=F,e.createFeature=h,e.createFunction=g,e.createSyntaxTree=x,e.dependsOnView=O,e.enableFeatureSetOperations=I,e.enableGeometryOperations=z,e.evalSyntaxTree=w,e.executeAsyncFunction=T,e.executeFunction=E,e.extractFieldNames=C,e.getArcadeType=v,e.getViewInfo=A,e.hasGeometryFunctions=q,e.hasGeometryOperations=N,e.hasVariable=$,e.loadScriptDependencies=P,e.updateExecContext=b,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
