/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../Basemap","../config","../core/Collection","../core/Logger","../core/maybe","../core/urlUtils","../core/accessorSupport/ensureType","../layers/effects/utils","./basemapDefinitions"],(function(e,r,a,n,t,i,s,l,u,c){"use strict";const o=()=>t.getLogger("esri.support.basemapUtils");function f(){return{}}function p(e){for(const r in e){const a=e[r];i.destroyMaybe(a),delete e[r]}}function y(e,n){let t;if("string"==typeof e){const i=e in c.esriBasemapDefinitions,s=!i&&e.includes("/");if(!i&&!s){if(a.apiKey)o().warn(`Unable to find basemap definition for: ${e}. See available styles at https://developers.arcgis.com/rest/basemap-styles/`);else{const r=Object.entries(c.esriBasemapDefinitions).filter((([e,r])=>r.classic||r.is3d)).map((([e])=>`"${e}"`)).sort().join(", ");o().warn(`Unable to find basemap definition for: ${e}. Try one of these: ${r}`)}return null}n&&(t=n[e]),t||(t=i?r.fromId(e):new r({style:{id:e}}),n&&(n[e]=t))}else t=l.ensureType(r,e);return t?.destroyed&&(o().warn("The provided basemap is already destroyed",{basemap:t}),t=null),t}function m(e){return"Web Scene"===e.portalItem?.type||e.referenceLayers.some((e=>"scene"===e.type))}function d(e){return!!e?.portalItem?.tags?.some((e=>"beta"===e.toLowerCase()))}function b(e,r){return e.basemap?.referenceLayers?.some((e=>e.uid===r))||e.basemap?.baseLayers?.some((e=>e.uid===r))}function L(e,r=null){const a=y(e);if(!a)return null;const n=a.clone();return r&&(n.baseLayers=I(n.baseLayers,r.baseLayers),n.referenceLayers=I(n.referenceLayers,r.referenceLayers)),n}let v;function S(e){if(v)return v(e);let r=null;const a=q(e),n=!a?.baseLayers.length;for(const t in c.esriBasemapDefinitions){const e=$(a,k(c.esriBasemapDefinitions[t]),{mustMatchReferences:n});if("equal"===e){r=t;break}"base-layers-equal"===e&&(r=t)}return r}function g(e){v=e}function h(e,r){if(e===r)return!0;if(null!=e?.portalItem?.id&&e.portalItem.id===r?.portalItem?.id)return!0;return"equal"===$(q(e),q(r),{mustMatchReferences:!0})}function I(e,r){const a=new n;return e.forEach((e=>{const n=r.find((r=>"scene"!==r.type&&j(D(e),D(r))))||e;a.includes(n)?a.push(e):a.push(n)})),a}function R(e){return!!e?.baseLayers.concat(e.referenceLayers).some(T)}function T(e){if(U(e.url))return!0;if("vector-tile"===e.type)for(const r in e.sourceNameToSource){const a=e.sourceNameToSource[r];if(U(a?.sourceUrl))return!0}return!1}function B(e,r){if(null==r||null==e)return{spatialReference:null,updating:!1};if("not-loaded"===r.loadStatus)return r.load(),{spatialReference:null,updating:!0};if(r.spatialReference)return{spatialReference:r.spatialReference,updating:!1};if(0===r.baseLayers.length)return{spatialReference:null,updating:!1};const a=r.baseLayers.at(0);switch(a.loadStatus){case"not-loaded":a.load();case"loading":return{spatialReference:null,updating:!0};case"failed":return{spatialReference:null,updating:!1}}const n=(("supportedSpatialReferences"in a?a.supportedSpatialReferences:null)||["tileInfo"in a?a.tileInfo?.spatialReference:a.spatialReference]).filter(Boolean),t=e.spatialReference;return t?{spatialReference:n.find((e=>t.equals(e)))??n[0]??null,updating:!1}:{spatialReference:n[0],updating:!1}}const w=/^(basemaps|ibasemaps).*-api\.arcgis\.com$/i;function U(e){if(!e)return!1;const r=new s.Url(s.makeAbsolute(e));return!!r.authority&&w.test(r.authority)}function q(e){return e?!e.loaded&&e.resourceInfo?k(e.resourceInfo.data):{baseLayers:x(e.baseLayers),referenceLayers:x(e.referenceLayers)}:null}function x(e){return(n.isCollection(e)?e.toArray():e).map(D)}function D(e){return{type:e.type,effect:"effect"in e?e.effect:void 0,url:E("urlTemplate"in e&&e.urlTemplate||e.url||"styleUrl"in e&&e.styleUrl||""),minScale:"minScale"in e&&null!=e.minScale?e.minScale:0,maxScale:"maxScale"in e&&null!=e.maxScale?e.maxScale:0,opacity:null!=e.opacity?e.opacity:1,visible:null==e.visible||!!e.visible,sublayers:"map-image"!==e.type&&"wms"!==e.type||null==e.sublayers?void 0:e.sublayers?.map((e=>({id:e.id,visible:e.visible}))),activeLayerId:"wmts"===e.type?e.activeLayer?.id:void 0}}function M(e){return e.isReference||"ArcGISSceneServiceLayer"===e.layerType}function k(e){return e?{baseLayers:C((e.baseMapLayers??[]).filter((e=>!M(e)))),referenceLayers:C((e.baseMapLayers??[]).filter((e=>M(e))))}:null}function C(e){return e.map((e=>A(e)))}function A(e){let r;switch(e.layerType){case"VectorTileLayer":r="vector-tile";break;case"ArcGISTiledMapServiceLayer":r="tile";break;case"ArcGISSceneServiceLayer":r="scene";break;default:r="unknown"}return{type:r,effect:e.effect,url:E(e.templateUrl||e.urlTemplate||e.styleUrl||e.url),minScale:e.minScale??0,maxScale:e.maxScale??0,opacity:e.opacity??1,visible:null==e.visibility||!!e.visibility,sublayers:void 0,activeLayerId:void 0}}function $(e,r,a){if(null!=e!=(null!=r))return"not-equal";if(!e||!r)return"equal";if(!G(e.baseLayers,r.baseLayers))return"not-equal";return G(e.referenceLayers,r.referenceLayers)?"equal":a.mustMatchReferences?"not-equal":"base-layers-equal"}function G(e,r){if(e.length!==r.length)return!1;for(let a=0;a<e.length;a++)if(!j(e[a],r[a]))return!1;return!0}function j(e,r){if(e.type!==r.type||e.url!==r.url||e.minScale!==r.minScale||e.maxScale!==r.maxScale||e.visible!==r.visible||e.opacity!==r.opacity)return!1;if(!u.effectEquals(e.effect,r.effect))return!1;if(null!=e.activeLayerId||null!=r.activeLayerId)return e.activeLayerId===r.activeLayerId;if(null!=e.sublayers||null!=r.sublayers){if(null==e.sublayers||null==r.sublayers||e.sublayers.length!==r.sublayers.length)return!1;for(let a=0;a<e.sublayers.length;a++){const n=e.sublayers.at(a),t=r.sublayers.at(a);if(n?.id!==t?.id||n?.visible!==t?.visible)return!1}}return!0}function E(e){return e?s.normalize(e).replace(/^\s*https?:/i,"").toLowerCase():""}function K(e){if(!e)return null;const{thumbnailUrl:r}=e;if(r)return r;const a=S(e);return a?c.esriBasemapDefinitions[a].thumbnailUrl:i.mappedFind(e.baseLayers,W)}function W(e){return"portalItem"in e?e.portalItem?.thumbnailUrl:void 0}e.clonePreservingTiledLayers=L,e.contentEquals=h,e.createCache=f,e.destroyCache=p,e.ensureType=y,e.findSpatialReference=B,e.getBasemapThumbnailUrl=K,e.getWellKnownBasemapId=S,e.hasDeveloperBasemapLayer=R,e.isBasemap3D=m,e.isBasemapInBeta=d,e.isBasemapLayer=b,e.isDeveloperBasemapLayer=T,e.overrideGetWellKnownBasemapId=g,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
