/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../core/fontUtils","../../core/has","../../core/lang","../../core/Logger","../../core/ObjectPool","../../core/screenUtils","../../geometry/GeometryCursor","../../geometry/support/aaBoundingRect","../../geometry/support/boundsUtils","../../geometry/support/centroid","../../geometry/support/jsonUtils","./CIMEffects","./CIMImageColorSubstitutionHelper","./CIMOperators","./CIMPlacements","./defaultCIMValues","./enums","./imageUtils","./Rect","./TextRasterizer","./utils","../../views/2d/engine/svgUtils","../../views/2d/engine/webgl/definitions","../../views/2d/engine/webgl/mesh/templates/shapingUtils","../../views/2d/layers/graphics/graphicsUtils"],(function(t,e,i,s,r,n,a,o,l,h,c,u,m,f,g,d,p,y,_,P,S,x,M,w,C,b){"use strict";const k=Math.PI/180,I=.5,v=()=>r.getLogger("esri.symbols.cim.CIMSymbolDrawHelper");class T{constructor(t){this._t=t}static createIdentity(){return new T([1,0,0,0,1,0])}clone(){const t=this._t;return new T(t.slice())}transform(t){const e=this._t;return[e[0]*t[0]+e[1]*t[1]+e[2],e[3]*t[0]+e[4]*t[1]+e[5]]}static createScale(t,e){return new T([t,0,0,0,e,0])}scale(t,e){const i=this._t;return i[0]*=t,i[1]*=t,i[2]*=t,i[3]*=e,i[4]*=e,i[5]*=e,this}scaleRatio(){return Math.sqrt(this._t[0]*this._t[0]+this._t[1]*this._t[1])}static createTranslate(t,e){return new T([0,0,t,0,0,e])}translate(t,e){const i=this._t;return i[2]+=t,i[5]+=e,this}static createRotate(t){const e=Math.cos(t),i=Math.sin(t);return new T([e,-i,0,i,e,0])}rotate(t){return T.multiply(this,T.createRotate(t),this)}angle(){const t=this._t[0],e=this._t[3],i=Math.sqrt(t*t+e*e);return[t/i,e/i]}static multiply(t,e,i){const s=t._t,r=e._t,n=s[0]*r[0]+s[3]*r[1],a=s[1]*r[0]+s[4]*r[1],o=s[2]*r[0]+s[5]*r[1]+r[2],l=s[0]*r[3]+s[3]*r[4],h=s[1]*r[3]+s[4]*r[4],c=s[2]*r[3]+s[5]*r[4]+r[5],u=i._t;return u[0]=n,u[1]=a,u[2]=o,u[3]=l,u[4]=h,u[5]=c,i}invert(){const t=this._t;let e=t[0]*t[4]-t[1]*t[3];if(0===e)return new T([0,0,0,0,0,0]);e=1/e;const i=(t[1]*t[5]-t[2]*t[4])*e,s=(t[2]*t[3]-t[0]*t[5])*e,r=t[4]*e,n=-t[1]*e,a=-t[3]*e,o=t[0]*e;return new T([r,n,i,a,o,s])}}class R{constructor(t,e){this._resourceManager=t,this._transfos=[],this._sizeTransfos=[],this._geomUnitsPerPoint=1,this._placementPool=new n(d.Placement,void 0,void 0,100),this._earlyReturn=!1,this._mapRotation=0,this._transfos.push(e||T.createIdentity()),this._sizeTransfos.push(e?e.scaleRatio():1)}setTransform(t,e){this._transfos=[t||T.createIdentity()],this._sizeTransfos=[e||(t?t.scaleRatio():1)]}setGeomUnitsPerPoint(t){this._geomUnitsPerPoint=t}transformPt(t){return this._transfos[this._transfos.length-1].transform(t)}transformSize(t){return t*this._sizeTransfos[this._sizeTransfos.length-1]}reverseTransformPt(t){return this._transfos[this._transfos.length-1].invert().transform(t)}reverseTransformSize(t){return t/this._sizeTransfos[this._sizeTransfos.length-1]}reverseTransformScalar(t){return t/this._transfos[this._transfos.length-1].scaleRatio()}getTransformAngle(){return this._transfos[this._transfos.length-1].angle()}geomUnitsPerPoint(){return this.isEmbedded()?1:this._geomUnitsPerPoint}prevGeomUnitsPerPoint(){return this._transfos.length>2?1:this._geomUnitsPerPoint}isEmbedded(){return this._transfos.length>1}back(){return this._transfos[this._transfos.length-1]}push(t,e){const i=e?t.scaleRatio():1;T.multiply(t,this.back(),t),this._transfos.push(t),this._sizeTransfos.push(this._sizeTransfos[this._sizeTransfos.length-1]*i)}pop(){this._transfos.splice(-1,1),this._sizeTransfos.splice(-1,1)}drawSymbol(t,e,i){if(t)switch(t.type){case"CIMPointSymbol":case"CIMLineSymbol":case"CIMPolygonSymbol":this.drawMultiLayerSymbol(t,e);break;case"CIMTextSymbol":this.drawTextSymbol(t,e,i)}}drawMultiLayerSymbol(t,e){if(!t||!e)return;const i=t.symbolLayers;if(!i)return;const s=t.effects;if(s&&s.length>0){const t=this.executeEffects(s,e);if(t){let e=t.next();for(;e;)this.drawSymbolLayers(i,e.asJSON()),e=t.next()}}else this.drawSymbolLayers(i,e)}executeEffects(t,e){const i=this._resourceManager.geometryEngine;let s=new m.SimpleEffectCursor(o.GeometryCursor.fromJSONCIM(e));for(const r of t){const t=g.getEffectOperator(r);t&&(s=t.execute(s,r,this.geomUnitsPerPoint(),null,i))}return s}drawSymbolLayers(t,e){let i=t.length;for(;i--;){const s=t[i];if(!s||!1===s.enable)continue;const r=s.effects;if(r&&r.length>0){const t=this.executeEffects(r,e);if(t){let e=null;for(;(e=t.next())&&(this.drawSymbolLayer(s,e.asJSON()),!this._earlyReturn););}}else this.drawSymbolLayer(s,e);if(this._earlyReturn)return}}drawSymbolLayer(t,e){switch(t.type){case"CIMSolidFill":this.drawSolidFill(e,t.color,t.path);break;case"CIMHatchFill":this.drawHatchFill(e,t);break;case"CIMPictureFill":this.drawPictureFill(e,t);break;case"CIMGradientFill":this.drawGradientFill(e,t);break;case"CIMSolidStroke":this.drawSolidStroke(e,t.color,t.width,t.capStyle,t.joinStyle,t.miterLimit,t.path);break;case"CIMPictureStroke":this.drawPictureStroke(e,t);break;case"CIMGradientStroke":this.drawGradientStroke(e,t);break;case"CIMCharacterMarker":case"CIMPictureMarker":case"CIMVectorMarker":this.drawMarkerLayer(t,e)}}drawHatchFill(t,e){const i=L(e,t,this.geomUnitsPerPoint());i&&(this.pushClipPath(t),this.drawMultiLayerSymbol(e.lineSymbol,i),this.popClipPath())}drawPictureFill(t,e){}drawGradientFill(t,e){}drawPictureStroke(t,e){}drawGradientStroke(t,e){}drawMarkerLayer(t,e){const i=t.markerPlacement;if(i){const s=g.getPlacementOperator(i);if(s){const r="CIMMarkerPlacementInsidePolygon"===i.type||"CIMMarkerPlacementPolygonCenter"===i.type&&i.clipAtBoundary;r&&this.pushClipPath(e);const n=s.execute(o.GeometryCursor.fromJSONCIM(e),i,this.geomUnitsPerPoint(),null,this._resourceManager.geometryEngine);if(n){let e=null;for(;(e=n.next())&&(this.drawMarker(t,e),!this._earlyReturn););}r&&this.popClipPath()}}else{const i=this._placementPool.acquire();if(u.isPoint(e))i.tx=e.x,i.ty=e.y,this.drawMarker(t,i);else if(u.isPolygon(e)){const s=c.polygonCentroid(e);s&&([i.tx,i.ty]=s,this.drawMarker(t,i))}else for(const s of e.points)if(i.tx=s[0],i.ty=s[1],this.drawMarker(t,i),this._earlyReturn)break;this._placementPool.release(i)}}drawMarker(t,e){switch(t.type){case"CIMCharacterMarker":case"CIMPictureMarker":this.drawPictureMarker(t,e);break;case"CIMVectorMarker":this.drawVectorMarker(t,e)}}drawPictureMarker(t,e){if(!t)return;const i=this._resourceManager.getResource(t.url),s=x.getNumericValue(t.size,p.defaultCIMValues.CIMPictureMarker.size);if(null==i||s<=0)return;const r=i.width,n=i.height;if(!r||!n)return;const a=r/n,o=x.getNumericValue(t.scaleX,1),l=T.createIdentity(),h=t.anchorPoint;if(h){let e=h.x,i=h.y;"Absolute"!==t.anchorPointUnits&&(e*=s*a*o,i*=s),l.translate(-e,-i)}let c=x.getNumericValue(t.rotation);t.rotateClockwise&&(c=-c),this._mapRotation&&(c+=this._mapRotation),c&&l.rotate(c*k);let u=x.getNumericValue(t.offsetX),m=x.getNumericValue(t.offsetY);if(u||m){if(this._mapRotation){const t=k*this._mapRotation,e=Math.cos(t),i=Math.sin(t),s=u*i+m*e;u=u*e-m*i,m=s}l.translate(u,m)}const f=this.geomUnitsPerPoint();1!==f&&l.scale(f,f);const g=e.getAngle();g&&l.rotate(g),l.translate(e.tx,e.ty),this.push(l,!1),this.drawImage(t,s),this.pop()}drawVectorMarker(t,e){if(!t)return;const i=t.markerGraphics;if(!i)return;const s=x.getNumericValue(t.size,p.defaultCIMValues.CIMVectorMarker.size),r=t.frame,n=r?r.ymax-r.ymin:0,a=s&&n?s/n:1,o=T.createIdentity();r&&o.translate(.5*-(r.xmax+r.xmin),.5*-(r.ymax+r.ymin));const l=t.anchorPoint;if(l){let e=l.x,i=l.y;"Absolute"!==t.anchorPointUnits?r&&(e*=r.xmax-r.xmin,i*=r.ymax-r.ymin):(e/=a,i/=a),o.translate(-e,-i)}1!==a&&o.scale(a,a);let h=x.getNumericValue(t.rotation);t.rotateClockwise&&(h=-h),this._mapRotation&&(h+=this._mapRotation),h&&o.rotate(h*k);let c=x.getNumericValue(t.offsetX),u=x.getNumericValue(t.offsetY);if(c||u){if(this._mapRotation){const t=k*this._mapRotation,e=Math.cos(t),i=Math.sin(t),s=c*i+u*e;c=c*e-u*i,u=s}o.translate(c,u)}const m=this.geomUnitsPerPoint();1!==m&&o.scale(m,m);const f=e.getAngle();f&&o.rotate(f),o.translate(e.tx,e.ty),this.push(o,t.scaleSymbolsProportionally);for(const g of i){g?.symbol&&g.geometry||v().error("Invalid marker graphic",g);let t=g.textString;if("number"==typeof t&&(t=t.toString()),this.drawSymbol(g.symbol,g.geometry,t),this._earlyReturn)break}this.pop()}drawTextSymbol(t,e,i){if(!t)return;if(!u.isPoint(e))return;if(x.getNumericValue(t.height,p.defaultCIMValues.CIMTextSymbol.height)<=0)return;const s=T.createIdentity();let r=x.getNumericValue(t.angle);r=-r,r&&s.rotate(r*k);const n=x.getNumericValue(t.offsetX),a=x.getNumericValue(t.offsetY);(n||a)&&s.translate(n,a);const o=this.geomUnitsPerPoint();1!==o&&s.scale(o,o),s.translate(e.x,e.y),this.push(s,!1),this.drawText(t,i),this.pop()}}class F extends R{constructor(t,e){super(t,e),this.reset()}reset(){this._xmin=this._ymin=1/0,this._xmax=this._ymax=-1/0,this._clipCount=0}envelope(){return new P(this._xmin,this._ymin,this._xmax-this._xmin,this._ymax-this._ymin)}bounds(){return l.fromValues(this._xmin,this._ymin,this._xmax,this._ymax)}drawSolidFill(t){if(t&&!(this._clipCount>0))if(u.isPolygon(t))this._processPath(t.rings,0);else if(u.isPolyline(t))this._processPath(t.paths,0);else if(u.isExtent(t)){const e=G(t);e&&this._processPath(e.rings,0)}else console.error("drawSolidFill Unexpected geometry type!")}drawSolidStroke(t,e,i){if(!t||this._clipCount>0||null==i||i<=0)return;const s=Math.max(.5*this.transformSize(x.getNumericValue(i,p.defaultCIMValues.CIMSolidStroke.width)),.5*I);if(u.isPolygon(t))this._processPath(t.rings,s);else if(u.isPolyline(t))this._processPath(t.paths,s);else if(u.isExtent(t)){const e=G(t);e&&this._processPath(e.rings,s)}else console.error("drawSolidStroke unexpected geometry type!")}drawMarkerLayer(t,e){u.isPolygon(e)&&t.markerPlacement&&("CIMMarkerPlacementInsidePolygon"===t.markerPlacement.type||"CIMMarkerPlacementPolygonCenter"===t.markerPlacement.type&&t.markerPlacement.clipAtBoundary)?this._processPath(e.rings,0):super.drawMarkerLayer(t,e)}drawHatchFill(t,e){this.drawSolidFill(t)}drawPictureFill(t,e){this.drawSolidFill(t)}drawGradientFill(t,e){this.drawSolidFill(t)}drawPictureStroke(t,e){this.drawSolidStroke(t,null,e.width)}drawGradientStroke(t,e){this.drawSolidStroke(t,null,e.width)}pushClipPath(t){this.drawSolidFill(t),this._clipCount++}popClipPath(){this._clipCount--}drawImage(t,e){const{url:i}=t,s=x.getNumericValue(t.scaleX,1);let r=s*e,n=e;const a=this._resourceManager.getResource(i);if(null!=a){const t=a.height/a.width;r=s*(e?t>1?e:e/t:a.width),n=e?t>1?e*t:e:a.height}this._merge(this.transformPt([-r/2,-n/2]),0),this._merge(this.transformPt([-r/2,n/2]),0),this._merge(this.transformPt([r/2,-n/2]),0),this._merge(this.transformPt([r/2,n/2]),0)}drawText(t,e){if(!e||0===e.length)return;this._textRasterizer||(this._textRasterizer=new S);const i=E(t);let[s,r]=this._textRasterizer.computeTextSize(e,i);s=a.px2pt(s),r=a.px2pt(r);const n=this.transformSize(1)*this.reverseTransformScalar(1);s*=n,r*=n;let o=0;switch(t.horizontalAlignment){case"Left":o=s/2;break;case"Right":o=-s/2}let l=0;switch(t.verticalAlignment){case"Bottom":l=r/2;break;case"Top":l=-r/2;break;case"Baseline":l=r/6}this._merge(this.transformPt([-s/2+o,-r/2+l]),0),this._merge(this.transformPt([-s/2+o,r/2+l]),0),this._merge(this.transformPt([s/2+o,-r/2+l]),0),this._merge(this.transformPt([s/2+o,r/2+l]),0)}_processPath(t,e){if(t)for(const i of t){const t=i?i.length:0;if(t>1){this._merge(this.transformPt(i[0]),e);for(let s=1;s<t;s++)this._merge(this.transformPt(i[s]),e)}}}_merge(t,e){t[0]-e<this._xmin&&(this._xmin=t[0]-e),t[0]+e>this._xmax&&(this._xmax=t[0]+e),t[1]-e<this._ymin&&(this._ymin=t[1]-e),t[1]+e>this._ymax&&(this._ymax=t[1]+e)}}class z extends R{constructor(){super(...arguments),this._searchPoint=[0,0],this._searchDistPoint=0,this._textInfo=null,this._svg=null,this._path=null,this._canvas=null}destroy(){this._svg=M.destroyHiddenSvg(this._svg),this._path=null,this._canvas=null}hitTest(t,e,s,r,n,o){const l=o*a.pt2px(1);this.setTransform(),this.setGeomUnitsPerPoint(l),this._searchPoint=[(t[0]+t[2])/2,(t[1]+t[3])/2],this._searchDistPoint=(t[2]-t[0])/2/l,this._textInfo=r;const h=e&&("CIMPointSymbol"===e.type&&"Map"!==e.angleAlignment||"CIMTextSymbol"===e.type);if(this._mapRotation=h?n:0,!i("esri-mobile")){const t=a.px2pt(w.hittestToleranceSmallSymbol*window.devicePixelRatio),i=a.px2pt(w.hittestSmallSymbolThreshold);!(("CIMLineSymbol"===e?.type||"CIMPolygonSymbol"===e?.type)&&e.symbolLayers?.some(x.isCIMFill))&&"CIMMeshSymbol"!==e?.type&&(x.getSize(e)??0)<i&&(this._searchDistPoint=t)}return this._earlyReturn=!1,this.drawSymbol(e,s),this._earlyReturn}executeEffects(t,e){return"CIMGeometricEffectDashes"===t.at(-1)?.type&&(t=t.slice(0,-1)),super.executeEffects(t,e)}drawSolidFill(t,e,i){null!=i?this._hittestSvgPath(t,i,!0):this._hitTestFill(t)}drawHatchFill(t,e){this._hitTestFill(t)}drawPictureFill(t,e){this._hitTestFill(t)}drawGradientFill(t,e){this._hitTestFill(t)}drawSolidStroke(t,e,i,s,r,n,a){null!=a?this._hittestSvgPath(t,a,!1,i):this._hitTestStroke(t,i)}drawPictureStroke(t,e){this._hitTestStroke(t,e.width)}drawGradientStroke(t,e){this._hitTestStroke(t,e.width)}drawMarkerLayer(t,e){t.markerPlacement&&("CIMMarkerPlacementInsidePolygon"===t.markerPlacement.type||"CIMMarkerPlacementPolygonCenter"===t.markerPlacement.type&&t.markerPlacement.clipAtBoundary)?this._hitTestFill(e):super.drawMarkerLayer(t,e)}pushClipPath(t){}popClipPath(){}drawImage(t,e){const{url:i}=t,s=x.getNumericValue(t.scaleX,1),r=this._resourceManager.getResource(i);if(null==r||0===r.height||0===e)return;const n=e*this.geomUnitsPerPoint(),a=n*s*(r.width/r.height),o=this.reverseTransformPt(this._searchPoint),l=this._searchDistPoint;Math.abs(o[0])<a/2+l&&Math.abs(o[1])<n/2+l&&(this._earlyReturn=!0)}drawText(t,e){const i=this._textInfo;if(!i)return;const s=i.get(t);if(!s)return;if(!s.glyphMosaicItems.glyphs.length)return;const r=b.roundPtToWholePixel(x.getNumericValue(t.height,p.defaultCIMValues.CIMTextSymbol.height)),{lineGapType:n,lineGap:a}=t,o=n?H(n,x.getNumericValue(a),r):0,l="CIMBackgroundCallout"===t.callout?.type,h=C.shapeGlyphs(s.glyphMosaicItems,{scale:r/w.glyphSize,angle:0,xOffset:0,yOffset:0,horizontalAlignment:t.horizontalAlignment,verticalAlignment:t.verticalAlignment,maxLineWidth:b.getLineWidth(t.lineWidth),lineHeight:w.magicLabelLineHeight*Math.max(.25,Math.min(o||1,4)),decoration:t.font.decoration||"none",useCIMAngleBehavior:!0,hasBackground:l}),c=this.reverseTransformPt(this._searchPoint),u=c[0],m=c[1];for(const f of h.glyphs)if(u>f.xTopLeft&&u<f.xBottomRight&&m>-f.yBottomRight&&m<-f.yTopLeft){this._earlyReturn=!0;break}}_hitTestFill(t){let e=null;if(u.isExtent(t)){const i=t;e=[[[i.xmin,i.ymin],[i.xmin,i.ymax],[i.xmax,i.ymax],[i.xmax,i.ymin],[i.xmin,i.ymin]]]}else if(u.isPolygon(t))e=t.rings;else{if(!u.isPolyline(t))return;e=t.paths}const i=this.reverseTransformPt(this._searchPoint);if(N(i,e)&&(this._earlyReturn=!0),!this._earlyReturn){A(i,e,this.reverseTransformScalar(this._searchDistPoint)*this.prevGeomUnitsPerPoint())&&(this._earlyReturn=!0)}}_getSvgPath(){return null!=this._svg&&null!=this._path||(this._svg??=M.createHiddenSvg(),this._path??=M.createSvgElement("path"),this._svg.appendChild(this._path)),this._path}_getCanvas(){return this._canvas??=document.createElement("canvas"),this._canvas}_hittestSvgPath(t,e,i,s){const r=l.create();h.getBoundsXY(r,t);const n={x:r[0],y:r[1],width:r[2]-r[0],height:r[3]-r[1]},a=this._getSvgPath();a.setAttribute("d",e);const o=a.getBBox(),c=o.width/n.width,u=o.height/n.height,m=this._getCanvas();m.width=o.width,m.height=o.height;const f=m.getContext("2d",{willReadFrequently:!0});f.setTransform(1,0,0,1,o.x,-o.y);const g=new Path2D(e);i?f.fill(g):(f.lineWidth=s*c,f.stroke(g));const d=this.reverseTransformScalar(this._searchDistPoint)*this.prevGeomUnitsPerPoint(),p=this.reverseTransformPt(this._searchPoint),y=(p[0]-n.x-d)*c,_=(n.height-(p[1]-n.y)-d)*u,P=2*d*c,S=2*d*u,x=f.getImageData(y,_,P,S).data;for(let l=3;l<x.length;l+=4)if(x[l]>127.5)return void(this._earlyReturn=!0)}_hitTestStroke(t,e){let i=null;if(u.isExtent(t)){const e=t;i=[[[e.xmin,e.ymin],[e.xmin,e.ymax],[e.xmax,e.ymax],[e.xmax,e.ymin],[e.xmin,e.ymin]]]}else if(u.isPolygon(t))i=t.rings;else{if(!u.isPolyline(t))return;i=t.paths}A(this.reverseTransformPt(this._searchPoint),i,x.getNumericValue(e,p.defaultCIMValues.CIMSolidStroke.width)*this.geomUnitsPerPoint()/2+this.reverseTransformScalar(this._searchDistPoint)*this.prevGeomUnitsPerPoint())&&(this._earlyReturn=!0)}}class V extends R{constructor(t,e,i,s){super(e,i),this._applyAdditionalRenderProps=s,this._colorSubstitutionHelper=new f,this._ctx=t}drawSolidFill(t,e){if(!t)return;if(u.isPolygon(t))this._buildPath(t.rings,!0);else if(u.isPolyline(t))this._buildPath(t.paths,!0);else if(u.isExtent(t))this._buildPath(G(t).rings,!0);else{if(!u.isMultipoint(t))return;console.log("CanvasDrawHelper.drawSolidFill - No implementation!")}const i=this._ctx;i.fillStyle="string"==typeof e?e:"rgba("+Math.round(e[0])+","+Math.round(e[1])+","+Math.round(e[2])+","+(e[3]??255)/255+")",i.fill("evenodd")}drawSolidStroke(t,e,i,s,r,n){if(!t||!e||0===i)return;if(u.isPolygon(t))this._buildPath(t.rings,!0);else if(u.isPolyline(t))this._buildPath(t.paths,!1);else{if(!u.isExtent(t))return void console.log("CanvasDrawHelper.drawSolidStroke isn't implemented!");this._buildPath(G(t).rings,!0)}const a=this._ctx;a.strokeStyle="string"==typeof e?e:"rgba("+Math.round(e[0])+","+Math.round(e[1])+","+Math.round(e[2])+","+(e[3]??255)/255+")",a.lineWidth=Math.max(this.transformSize(i),I),this._setCapStyle(s),this._setJoinStyle(r),a.miterLimit=n,a.stroke()}pushClipPath(t){if(this._ctx.save(),u.isPolygon(t))this._buildPath(t.rings,!0);else if(u.isPolyline(t))this._buildPath(t.paths,!0);else{if(!u.isExtent(t))return;this._buildPath(G(t).rings,!0)}this._ctx.clip("evenodd")}popClipPath(){this._ctx.restore()}drawImage(t,e){const{colorSubstitutions:i,url:s,tintColor:r}=t,n=x.getNumericValue(t.scaleX,1),a=this._resourceManager.getResource(s);if(null==a)return;let o=e*(a.width/a.height),l=e;e||(o=a.width,l=a.height);const h=x.isSVGImage(s)||"src"in a&&x.isSVGImage(a.src);let c="getFrame"in a?_.getFirstFrame(a):a;i&&(c=this._colorSubstitutionHelper.applyColorSubstitution(c,i)),this._applyAdditionalRenderProps&&!h&&r&&(c=this._colorSubstitutionHelper.tintImageData(c,r));const u=this.transformPt([0,0]),[m,f]=this.getTransformAngle(),g=this.transformSize(1),d=this._ctx;d.save(),d.setTransform({m11:n*g*m,m12:n*g*f,m21:-g*f,m22:g*m,m41:u[0],m42:u[1]}),d.drawImage(c,-o/2,-l/2,o,l),d.restore()}drawText(t,e){if(!e||0===e.length)return;this._textRasterizer||(this._textRasterizer=new S);const i=E(t,this.transformSize(a.px2pt(1))),s=this._textRasterizer.rasterizeText(e,i);if(!s)return;const{size:r,anchorX:n,anchorY:o,canvas:l}=s,h=r[0]*(n+.5),c=r[1]*(o-.5),u=this._ctx,m=this.transformPt([0,0]),[f,g]=this.getTransformAngle(),d=1;u.save(),u.setTransform({m11:d*f,m12:d*g,m21:-d*g,m22:d*f,m41:m[0]-d*h,m42:m[1]+d*c}),u.drawImage(l,0,0),u.restore()}drawPictureFill(t,e){if(!t)return;let{colorSubstitutions:i,height:s,offsetX:r,offsetY:n,rotation:a,scaleX:o,tintColor:l,url:h}=e;const c=this._resourceManager.getResource(h);if(null==c)return;if(u.isPolygon(t))this._buildPath(t.rings,!0);else if(u.isPolyline(t))this._buildPath(t.paths,!0);else if(u.isExtent(t))this._buildPath(G(t).rings,!0);else{if(!u.isMultipoint(t))return;console.log("CanvasDrawHelper.drawPictureFill - No implementation!")}const m=this._ctx,f=x.isSVGImage(h)||"src"in c&&x.isSVGImage(c.src);let g,d="getFrame"in c?_.getFirstFrame(c):c;if(i&&(d=this._colorSubstitutionHelper.applyColorSubstitution(d,i)),this._applyAdditionalRenderProps){f||l&&(d=this._colorSubstitutionHelper.tintImageData(d,l)),g=m.createPattern(d,"repeat");const t=this.transformSize(1);a||(a=0),r?r*=t:r=0,n?n*=t:n=0,s&&(s*=t);const e=s?s/c.height:1,i=o&&s?o*s/c.width:1;if(0!==a||1!==e||1!==i||0!==r||0!==n){const t=new DOMMatrix;t.rotateSelf(0,0,-a).translateSelf(r,n).scaleSelf(i,e,1),g.setTransform(t)}}else g=m.createPattern(d,"repeat");m.save(),m.fillStyle=g,m.fill("evenodd"),m.restore()}drawPictureStroke(t,e){if(!t)return;let{colorSubstitutions:i,capStyle:r,joinStyle:n,miterLimit:o,tintColor:l,url:h,width:c}=e;const m=this._resourceManager.getResource(h);if(null==m)return;let f;if(u.isPolygon(t))f=t.rings;else if(u.isPolyline(t))f=t.paths;else{if(!u.isExtent(t))return u.isMultipoint(t)?void console.log("CanvasDrawHelper.drawPictureStroke - No implementation!"):void 0;f=G(t).rings}c||(c=m.width);const g=x.isSVGImage(h)||"src"in m&&x.isSVGImage(m.src);let d="getFrame"in m?_.getFirstFrame(m):m;i&&(d=this._colorSubstitutionHelper.applyColorSubstitution(d,i)),this._applyAdditionalRenderProps&&(g||l&&(d=this._colorSubstitutionHelper.tintImageData(d,l)));const p=Math.max(this.transformSize(a.pt2px(c)),.5),y=p/d.width,P=this._ctx,S=P.createPattern(d,"repeat-y");let M,w;P.save(),this._setCapStyle(r),this._setJoinStyle(n),void 0!==o&&(P.miterLimit=o),P.lineWidth=p;for(let a of f)if(a=s.clone(a),B(a),a&&!(a.length<=1)){M=this.transformPt(a[0]);for(let t=1;t<a.length;t++){w=this.transformPt(a[t]);const e=U(M,w),i=new DOMMatrix;i.translateSelf(0,M[1]-p/2).scaleSelf(y,y,1).rotateSelf(0,0,90-e),S.setTransform(i),P.strokeStyle=S,P.beginPath(),P.moveTo(M[0],M[1]),P.lineTo(w[0],w[1]),P.stroke(),M=w}}P.restore()}_buildPath(t,e){const i=this._ctx;if(i.beginPath(),t)for(const s of t){const t=s?s.length:0;if(t>1){let r=this.transformPt(s[0]);i.moveTo(r[0],r[1]);for(let e=1;e<t;e++)r=this.transformPt(s[e]),i.lineTo(r[0],r[1]);e&&i.closePath()}}}_setCapStyle(t){switch(t){case y.LineCapStyle.Butt:this._ctx.lineCap="butt";break;case y.LineCapStyle.Round:this._ctx.lineCap="round";break;case y.LineCapStyle.Square:this._ctx.lineCap="square"}}_setJoinStyle(t){switch(t){case y.LineJoinStyle.Bevel:this._ctx.lineJoin="bevel";break;case y.LineJoinStyle.Round:this._ctx.lineJoin="round";break;case y.LineJoinStyle.Miter:this._ctx.lineJoin="miter"}}}function L(t,e,i){let s=x.getNumericValue(t.separation,p.defaultCIMValues.CIMHatchFill.separation)*i,r=x.getNumericValue(t.rotation);if(0===s)return null;s<0&&(s=-s);let n=0;const a=.5*s;for(;n>a;)n-=s;for(;n<-a;)n+=s;const o=l.create();h.getBoundsXY(o,e),o[0]-=a,o[1]-=a,o[2]+=a,o[3]+=a;const c=[[o[0],o[1]],[o[0],o[3]],[o[2],o[3]],[o[2],o[1]]];for(;r>180;)r-=180;for(;r<0;)r+=180;const u=Math.cos(r*k),m=Math.sin(r*k),f=-s*m,g=s*u;let d,y,_,P;n=x.getNumericValue(t.offsetX)*i*m-x.getNumericValue(t.offsetY)*i*u,d=_=Number.MAX_VALUE,y=P=-Number.MAX_VALUE;for(const l of c){const t=l[0],e=l[1],i=u*t+m*e,s=-m*t+u*e;d=Math.min(d,i),_=Math.min(_,s),y=Math.max(y,i),P=Math.max(P,s)}_=Math.floor(_/s)*s;let S=u*d-m*_-f*n/s,M=m*d+u*_-g*n/s,w=u*y-m*_-f*n/s,C=m*y+u*_-g*n/s;const b=1+Math.round((P-_)/s),I=[];for(let l=0;l<b;l++)S+=f,M+=g,w+=f,C+=g,I.push([[S,M],[w,C]]);return{paths:I}}function N(t,e){let i=0;for(const s of e){const e=s.length;for(let r=1;r<e;r++){const e=s[r-1],n=s[r];if(e[1]>t[1]==n[1]>t[1])continue;(n[0]-e[0])*(t[1]-e[1])-(n[1]-e[1])*(t[0]-e[0])>0?i++:i--}}return 0!==i}function A(t,e,i){for(const s of e){const e=s.length;for(let r=1;r<e;r++){const e=s[r-1],n=s[r];let a=(n[0]-e[0])*(n[0]-e[0])+(n[1]-e[1])*(n[1]-e[1]);if(0===a)continue;a=Math.sqrt(a);const o=((n[0]-e[0])*(t[1]-e[1])-(n[1]-e[1])*(t[0]-e[0]))/a;if(Math.abs(o)<i){const s=((n[0]-e[0])*(t[0]-e[0])+(n[1]-e[1])*(t[1]-e[1]))/a;if(s>-i&&s<a+i)return!0}}}return!1}function U(t,e){const i=e[0]-t[0],s=e[1]-t[1];return 180/Math.PI*Math.atan2(s,i)}const G=t=>t?{spatialReference:t.spatialReference,rings:[[[t.xmin,t.ymin],[t.xmin,t.ymax],[t.xmax,t.ymax],[t.xmax,t.ymin],[t.xmin,t.ymin]]]}:null,H=(t,e,i)=>{switch(t){case"ExtraLeading":return 1+e/i;case"Multiple":return e;case"Exact":return e/i}};function E(t,i=1){const s=x.fromCIMFontDecoration(t),r=x.fromCIMFontStyle(t.fontStyleName),n=t.fontFamilyName??e.defaultFontFamily,{weight:a,style:o}=r,l=i*(t.height||5),h=x.fromCIMHorizontalAlignment(t.horizontalAlignment),c=x.fromCIMVerticalAlignment(t.verticalAlignment),u=x.getFillColor(t),m=x.getFillColor(t.haloSymbol),f=null!=m?i*(t.haloSize??0):0,g=x.getStrokeColor(t.symbol),d=i*(x.getStrokeWidth(t.symbol)||0),p="CIMBackgroundCallout"===t.callout?.type?t.callout.backgroundSymbol:null,y=x.getFillColor(p),_=x.getStrokeWidth(p),P=x.getStrokeColor(p);return{color:u,size:l,horizontalAlignment:h,verticalAlignment:c,font:{family:n,style:x.getFontStyle(o),weight:x.getFontWeight(a),decoration:s},outline:{size:d||0,color:g},halo:{size:f||0,color:m,style:o},backgroundColor:y,borderLine:null!=_&&null!=P?{size:_,color:P}:null,pixelRatio:1,premultiplyColors:!0}}const D=1e-4;function B(t){let e,i,s,r,n,a=t[0],o=1;for(;o<t.length;)e=t[o][0]-a[0],i=t[o][1]-a[1],r=0!==e?i/e:Math.PI/2,void 0!==s&&r-s<=D?(t.splice(o-1,1),a=n):(n=a,a=t[o],o++),s=r}t.CIMSymbolDrawHelper=R,t.CanvasDrawHelper=V,t.EnvDrawHelper=F,t.HittestDrawHelper=z,t.Transformation=T,t.cDegToRad=k,t.lineGapType2LineHeight=H,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
