/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../core/BidiText","../../core/has","../../core/lang","../../core/Logger","../../core/RandomLCG","../../core/screenUtils","../../geometry/support/aaBoundingRect","../../geometry/support/boundsUtils","../Font","./CIMPlacements","./CIMSymbolDrawHelper","./defaultCIMValues","./enums","./utils","../support/defaults","../../views/2d/engine/vectorTiles/GeometryUtils","../../views/2d/engine/webgl/definitions","../../views/2d/engine/webgl/mesh/templates/shapingUtils","../../views/2d/layers/graphics/graphicsUtils"],(function(e,t,r,a,i,o,n,s,l,c,m,u,f,y,h,p,M,g,S,d){"use strict";const b=Math.PI,C=b/2,x=Math.PI/180,I=96/72,k=1.4142135623730951,P=4,w=()=>i.getLogger("esri.symbols.cim.CIMSymbolHelper");function L(e){let t;switch(e.type){case"cim":return e.data;case"web-style":return e;case"simple-marker":{const r=G.fromSimpleMarker(e);if(!r)throw new Error("InternalError: Cannot convert symbol to CIM");t=r;break}case"picture-marker":t=G.fromPictureMarker(e);break;case"simple-line":t=G.fromSimpleLineSymbol(e);break;case"simple-fill":t=G.fromSimpleFillSymbol(e);break;case"picture-fill":t=G.fromPictureFillSymbol(e);break;case"text":t=G.fromTextSymbol(e)}return{type:"CIMSymbolReference",symbol:t}}function F(e,t,r){switch(t.type){case"CIMSymbolReference":return F(e,t.symbol,r);case"CIMPointSymbol":null==r&&(r={x:0,y:0}),e.drawSymbol(t,r);break;case"CIMLineSymbol":null==r&&(r={paths:[[[0,0],[10,0]]]}),e.drawSymbol(t,r);break;case"CIMPolygonSymbol":null==r&&(r={rings:[[[0,0],[0,10],[10,10],[10,0],[0,0]]]}),e.drawSymbol(t,r);break;case"CIMTextSymbol":{const r={x:0,y:0};e.drawSymbol(t,r);break}case"CIMVectorMarker":{const r=new m.Placement;e.drawMarker(t,r);break}}return e.envelope()}function E(e){if(!e)return 0;switch(e.type){case"CIMMarkerPlacementAlongLineSameSize":case"CIMMarkerPlacementAlongLineRandomSize":case"CIMMarkerPlacementAtExtremities":case"CIMMarkerPlacementAtMeasuredUnits":case"CIMMarkerPlacementAtRatioPositions":case"CIMMarkerPlacementOnLine":case"CIMMarkerPlacementOnVertices":return Math.abs(e.offset);default:return 0}}function T(e){if(!e)return 0;switch(e.type){case"CIMGeometricEffectArrow":return Math.abs(.5*e.width);case"CIMGeometricEffectBuffer":return Math.abs(e.size);case"CIMGeometricEffectControlMeasureLine":return 500;case"CIMGeometricEffectExtension":case"CIMGeometricEffectRadial":return Math.abs(e.length);case"CIMGeometricEffectJog":return Math.abs(.5*e.length);case"CIMGeometricEffectMove":return Math.max(Math.abs(h.getNumericValue(e.offsetX)),Math.abs(h.getNumericValue(e.offsetY)));case"CIMGeometricEffectOffset":case"CIMGeometricEffectOffsetTangent":return Math.abs(e.offset);case"CIMGeometricEffectRegularPolygon":return Math.abs(e.radius);case"CIMGeometricEffectRotate":case"CIMGeometricEffectScale":default:return 0;case"CIMGeometricEffectTaperedPolygon":return.5*Math.max(Math.abs(e.fromWidth),Math.abs(e.toWidth));case"CIMGeometricEffectWave":return Math.abs(e.amplitude);case"CIMGeometricEffectDonut":return Math.abs(e.width)}}function D(e){if(!e)return 0;let t=0;for(const r of e)t+=T(r);return t}class z{static getSymbolInflateSize(e,t,r,a,i){return e||(e=[0,0,0,0]),t?this._getInflateSize(e,t,r,a,i):e}static safeSize(e){const t=Math.max(Math.abs(e[0]),Math.abs(e[2])),r=Math.max(Math.abs(e[1]),Math.abs(e[3]));return Math.sqrt(t*t+r*r)}static _vectorMarkerBounds(e,t,r,a){let i=!0;const o=s.create();if(t?.markerGraphics)for(const n of t.markerGraphics){const t=[0,0,0,0];n.geometry&&(l.getBoundsXY(o,n.geometry),t[0]=0,t[1]=0,t[2]=0,t[3]=0,this.getSymbolInflateSize(t,n.symbol,r,0,a),o[0]+=t[0],o[1]+=t[1],o[2]+=t[2],o[3]+=t[3],i?(e[0]=o[0],e[1]=o[1],e[2]=o[2],e[3]=o[3],i=!1):(e[0]=Math.min(e[0],o[0]),e[1]=Math.min(e[1],o[1]),e[2]=Math.max(e[2],o[2]),e[3]=Math.max(e[3],o[3])))}return e}static _getInflateSize(e,t,r,a,i){if(q(t)){const o=this._getLayersInflateSize(e,t.symbolLayers,r,a,i),n=D(t.effects);return n>0&&(o[0]-=n,o[1]-=n,o[2]+=n,o[3]+=n),o}return this._getTextInflatedSize(e,t,i)}static _getLayersInflateSize(e,t,r,a,i){let o=!0;if(!t)return e;for(const n of t){if(!n)continue;let t=[0,0,0,0];switch(n.type){case"CIMSolidFill":case"CIMPictureFill":case"CIMHatchFill":case"CIMGradientFill":break;case"CIMSolidStroke":case"CIMPictureStroke":case"CIMGradientStroke":{const e=n;let r=e.width;null!=r&&(e.capStyle===y.LineCapStyle.Square||e.joinStyle===y.LineJoinStyle.Miter?r/=k:r/=2,t[0]=-r,t[1]=-r,t[2]=r,t[3]=r);break}case"CIMCharacterMarker":case"CIMVectorMarker":case"CIMPictureMarker":{const e=n;if("CIMVectorMarker"===n.type){const e=n;if(t=this._vectorMarkerBounds(t,e,r,i),e.frame){const r=(e.frame.xmin+e.frame.xmax)/2,a=(e.frame.ymin+e.frame.ymax)/2;if(t[0]-=r,t[1]-=a,t[2]-=r,t[3]-=a,null!=e.size){const r=e.size/(e.frame.ymax-e.frame.ymin);t[0]*=r,t[1]*=r,t[2]*=r,t[3]*=r}}}else if("CIMPictureMarker"===n.type){const a=n,i=r.getResource(a.url);let o=1;if(null!=i&&i.height&&(o=i.width/i.height),null!=e.size){const r=e.size/2,i=e.size*o*a.scaleX/2;t=[-i,-r,i,r]}}else if(null!=e.size){const r=e.size/2;t=[-r,-r,r,r]}if(e.anchorPoint){let r,a;"Absolute"===e.anchorPointUnits?(r=e.anchorPoint.x,a=e.anchorPoint.y):(r=e.anchorPoint.x*(t[2]-t[0]),a=e.anchorPoint.y*(t[3]-t[1]));const i=1.25*Math.sqrt(r*r+a*a);t[0]-=i,t[1]-=i,t[2]+=i,t[3]+=i}let o=h.getNumericValue(e.rotation);if(e.rotateClockwise&&(o=-o),a&&(o-=a),o){const e=x*o,r=Math.cos(e),a=Math.sin(e),i=s.create([M.cInfinity,M.cInfinity,-M.cInfinity,-M.cInfinity]);s.expandPointInPlace(i,[t[0]*r-t[1]*a,t[0]*a+t[1]*r]),s.expandPointInPlace(i,[t[0]*r-t[3]*a,t[0]*a+t[3]*r]),s.expandPointInPlace(i,[t[2]*r-t[1]*a,t[2]*a+t[1]*r]),s.expandPointInPlace(i,[t[2]*r-t[3]*a,t[2]*a+t[3]*r]),t=i}let l=h.getNumericValue(e.offsetX),c=h.getNumericValue(e.offsetY);if(a){const e=x*a,t=Math.cos(e),r=Math.sin(e),i=l*r+c*t;l=l*t-c*r,c=i}t[0]+=l,t[1]+=c,t[2]+=l,t[3]+=c;const m=E(e.markerPlacement);m>0&&(t[0]-=m,t[1]-=m,t[2]+=m,t[3]+=m);break}}const l=D(n.effects);l>0&&(t[0]-=l,t[1]-=l,t[2]+=l,t[3]+=l),o?(e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],o=!1):(e[0]=Math.min(e[0],t[0]),e[1]=Math.min(e[1],t[1]),e[2]=Math.max(e[2],t[2]),e[3]=Math.max(e[3],t[3]))}return e}static _getTextInflatedSize(e,t,r){const a=d.roundPtToWholePixel(t.height??f.defaultCIMValues.CIMTextSymbol.height);if(e[0]=-a/2,e[1]=-a/2,e[2]=a/2,e[3]=a/2,!r)return e;const i=r.get(t);if(!i)return e;if(!i.glyphMosaicItems.glyphs.length)return e;const{lineGapType:o,lineGap:n}=t,s=o?u.lineGapType2LineHeight(o,n??0,a):0,l="CIMBackgroundCallout"===t.callout?.type,c=S.shapeGlyphs(i.glyphMosaicItems,{scale:a/g.glyphSize,angle:h.getNumericValue(t.angle),xOffset:h.getNumericValue(t.offsetX),yOffset:h.getNumericValue(t.offsetY),horizontalAlignment:t.horizontalAlignment,verticalAlignment:t.verticalAlignment,maxLineWidth:d.getLineWidth(t.lineWidth),lineHeight:g.magicLabelLineHeight*Math.max(.25,Math.min(s||1,4)),decoration:t.font.decoration||"none",useCIMAngleBehavior:!0,hasBackground:l}).boundsT,m=Math.sqrt(c.width*c.width+c.height*c.height);return e[0]-=c.x+m,e[1]-=c.y-m,e[2]+=c.x+m,e[3]+=-c.y+m,e}}class G{static getEnvelope(e,t,r){if(!e)return null;const a=new u.EnvDrawHelper(r);if(Array.isArray(e)){let r;for(const i of e)r?r.union(F(a,i,t)):r=F(a,i,t);return r}return F(a,e,t)}static getTextureAnchor(e,t){const r=this.getEnvelope(e,null,t);if(!r)return[0,0,0];const a=(r.x+.5*r.width)*I,i=(r.y+.5*r.height)*I,o=r.width*I+2,n=r.height*I+2;return[-a/o,-i/n,n]}static rasterize(e,t,r,a,i=!0,o){const n=r||this.getEnvelope(t,null,a);if(!n)return[null,0,0,0,0];const s=Math.max(n.width,n.height)*I;let l=null!=o?Math.max(o/s,1):1;l*=I;const c=(n.x+.5*n.width)*l,f=(n.y+.5*n.height)*l;e.width=n.width*l,e.height=n.height*l,r||(e.width+=2,e.height+=2);const y=e.getContext("2d",{willReadFrequently:!0}),h=u.Transformation.createScale(l,-l);h.translate(.5*e.width-c,.5*e.height+f);const p=new u.CanvasDrawHelper(y,a,h);switch(t.type){case"CIMPointSymbol":{const e={type:"point",x:0,y:0};p.drawSymbol(t,e);break}case"CIMVectorMarker":{const e=new m.Placement;p.drawMarker(t,e);break}}const M=y.getImageData(0,0,e.width,e.height),g=new Uint8Array(M.data);if(i){let e;for(let t=0;t<g.length;t+=4)e=g[t+3]/255,g[t]=g[t]*e,g[t+1]=g[t+1]*e,g[t+2]=g[t+2]*e}return[g,e.width,e.height,-c/e.width,-f/e.height]}static fromTextSymbol(e){const{text:t}=e;return{type:"CIMPointSymbol",symbolLayers:[{type:"CIMVectorMarker",enable:!0,anchorPointUnits:"Relative",dominantSizeAxis3D:"Y",size:10,billboardMode3D:"FaceNearPlane",frame:{xmin:-5,ymin:-5,xmax:5,ymax:5},markerGraphics:[{type:"CIMMarkerGraphic",geometry:{x:0,y:0},symbol:G.createCIMTextSymbolfromTextSymbol(e),textString:t}],scaleSymbolsProportionally:!0,respectFrame:!0}],scaleX:1,angleAlignment:"Display"}}static fromPictureFillSymbol(e){const{height:t,outline:r,width:a,xoffset:i,xscale:o,yoffset:n,yscale:s}=e,l=[],c={type:"CIMPolygonSymbol",symbolLayers:l};if(r){const e=J(r);e&&l.push(e)}let m=e.url;"esriPFS"===e.type&&e.imageData&&(m=e.imageData);const u="angle"in e?e.angle??0:0,f=(a??0)*(o||1),p=(t??0)*(s||1);return l.push({type:"CIMPictureFill",invertBackfaceTexture:!1,scaleX:1,textureFilter:y.TextureFilter.Picture,tintColor:null,url:m,height:p,width:f,offsetX:h.getNumericValue(i),offsetY:h.getNumericValue(n),rotation:h.getNumericValue(-u),colorSubstitutions:null}),c}static fromSimpleFillSymbol(e){const{color:t,style:r,outline:i}=e,o=[],s={type:"CIMPolygonSymbol",symbolLayers:o};if(i){const e=J(i);e&&o.push(e)}if(r&&"solid"!==r&&"none"!==r&&"esriSFSSolid"!==r&&"esriSFSNull"!==r){const e={type:"CIMLineSymbol",symbolLayers:[{type:"CIMSolidStroke",color:B(t),capStyle:y.LineCapStyle.Butt,joinStyle:y.LineJoinStyle.Miter,width:.75}]};let i=0;const s=n.px2pt(U(r)?8:10);switch(r){case"vertical":case"esriSFSVertical":i=90;break;case"forward-diagonal":case"esriSFSForwardDiagonal":case"diagonal-cross":case"esriSFSDiagonalCross":i=-45;break;case"backward-diagonal":case"esriSFSBackwardDiagonal":i=45;break;case"cross":case"esriSFSCross":i=0}o.push({type:"CIMHatchFill",lineSymbol:e,offsetX:0,offsetY:0,rotation:i,separation:s}),"cross"===r||"esriSFSCross"===r?o.push({type:"CIMHatchFill",lineSymbol:a.clone(e),offsetX:0,offsetY:0,rotation:90,separation:s}):"diagonal-cross"!==r&&"esriSFSDiagonalCross"!==r||o.push({type:"CIMHatchFill",lineSymbol:a.clone(e),offsetX:0,offsetY:0,rotation:45,separation:s})}else!r||"solid"!==r&&"esriSFSSolid"!==r||o.push({type:"CIMSolidFill",enable:!0,color:B(t)});return s}static fromSimpleLineSymbol(e){const{cap:t,color:r,join:a,marker:i,miterLimit:o,style:n,width:s}=e;let l=null;"solid"!==n&&"none"!==n&&"esriSLSSolid"!==n&&"esriSLSNull"!==n&&(l=[{type:"CIMGeometricEffectDashes",dashTemplate:_(n,t),lineDashEnding:"NoConstraint",scaleDash:!0,offsetAlongLine:null}]);const c=[];if(i){let e;switch(i.placement){case"begin-end":e=y.ExtremityPlacement.Both;break;case"begin":e=y.ExtremityPlacement.JustBegin;break;case"end":e=y.ExtremityPlacement.JustEnd;break;default:e=y.ExtremityPlacement.None}const t=G.fromSimpleMarker(i,s,r).symbolLayers[0];t.markerPlacement={type:"CIMMarkerPlacementAtExtremities",placePerPart:!1,angleToLine:!0,offset:0,extremityPlacement:e,offsetAlongLine:0},c.push(t)}return c.push({type:"CIMSolidStroke",color:"none"!==n&&"esriSLSNull"!==n?B(r):[0,0,0,0],capStyle:N(t),joinStyle:v(a),miterLimit:o,width:s,effects:l}),{type:"CIMLineSymbol",symbolLayers:c}}static fromPictureMarker(e){const{angle:t,height:r,width:a,xoffset:i,yoffset:o}=e;let n=e.url;return"esriPMS"===e.type&&e.imageData&&(n=e.imageData),{type:"CIMPointSymbol",symbolLayers:[{type:"CIMPictureMarker",invertBackfaceTexture:!1,scaleX:1,textureFilter:y.TextureFilter.Picture,tintColor:null,url:n,size:r,width:a,offsetX:h.getNumericValue(i),offsetY:h.getNumericValue(o),rotation:h.getNumericValue(-t)}]}}static createCIMTextSymbolfromTextSymbol(e){const{angle:r,color:a,font:i,haloColor:o,haloSize:n,horizontalAlignment:s,kerning:l,lineWidth:c,text:m,verticalAlignment:u,xoffset:f,yoffset:p,backgroundColor:M,borderLineColor:g,borderLineSize:S}=e;let d,b,C,x,I,k;i&&(d=i.family,b=i.style,C=i.weight,x=i.size,I=i.decoration);let P=!1;if(m){P=t.bidiText(m)[1]}return(M||S)&&(k={type:"CIMBackgroundCallout",margin:null,backgroundSymbol:{type:"CIMPolygonSymbol",symbolLayers:[{type:"CIMSolidFill",color:B(M)},{type:"CIMSolidStroke",color:B(g),width:S}]},accentBarSymbol:null,gap:null,leaderLineSymbol:null,lineStyle:null}),{type:"CIMTextSymbol",angle:r,blockProgression:y.BlockProgression.BTT,depth3D:1,extrapolateBaselines:!0,fontEffects:y.FontEffects.Normal,fontEncoding:y.FontEncoding.Unicode,fontFamilyName:d||"Arial",fontStyleName:X(b,C),fontType:y.FontType.Unspecified,haloSize:n,height:x,hinting:y.GlyphHinting.Default,horizontalAlignment:R(s??"center"),kerning:l,letterWidth:100,ligatures:!0,lineGapType:"Multiple",lineWidth:c,offsetX:h.getNumericValue(f),offsetY:h.getNumericValue(p),strikethrough:"line-through"===I,underline:"underline"===I,symbol:{type:"CIMPolygonSymbol",symbolLayers:[{type:"CIMSolidFill",enable:!0,color:B(a)}]},haloSymbol:{type:"CIMPolygonSymbol",symbolLayers:[{type:"CIMSolidFill",enable:!0,color:B(o)}]},shadowColor:[0,0,0,255],shadowOffsetX:1,shadowOffsetY:1,textCase:"Normal",textDirection:P?y.TextReadingDirection.RTL:y.TextReadingDirection.LTR,verticalAlignment:A(u??"baseline"),verticalGlyphOrientation:y.VerticalGlyphOrientation.Right,wordSpacing:100,billboardMode3D:y.BillBoardMode.FaceNearPlane,callout:k}}static createPictureMarkerRasterizationParam(e){const{angle:t,height:r,width:a,xoffset:i,yoffset:o}=e,n=e.url??e.source?.url??e.source?.imageData;return n?{type:"sprite-rasterization-param",overrides:[],resource:{type:"CIMPictureMarker",invertBackfaceTexture:!1,scaleX:1,textureFilter:y.TextureFilter.Picture,tintColor:null,url:n,size:r,width:a,offsetX:h.getNumericValue(i),offsetY:h.getNumericValue(o),rotation:h.getNumericValue(-t)}}:null}static createPictureFillRasterizationParam(e){const{width:t,height:r,xoffset:a,yoffset:i,url:o}=e;return o?{type:"sprite-rasterization-param",overrides:[],resource:{type:"CIMPictureFill",scaleX:1,textureFilter:y.TextureFilter.Picture,tintColor:null,url:o,width:t,height:r,offsetX:h.getNumericValue(a),offsetY:h.getNumericValue(i),rotation:0}}:null}static fromSimpleMarker(e,t,r){const{style:a}=e,i=e.color??r;if("path"===a||"esriSMSPath"===a){const t=[];if("outline"in e&&e.outline){const r=e.outline;t.push({type:"CIMSolidStroke",enable:!0,width:r.width,color:B(r.color),path:e.path})}t.push({type:"CIMSolidFill",enable:!0,color:B(i),path:e.path});const[r,a]=O("square");return{type:"CIMPointSymbol",symbolLayers:[{type:"CIMVectorMarker",enable:!0,rotation:-h.getNumericValue(e.angle),size:h.getNumericValue(e.size||6),offsetX:h.getNumericValue(e.xoffset),offsetY:h.getNumericValue(e.yoffset),scaleSymbolsProportionally:!1,frame:r,markerGraphics:[{type:"CIMMarkerGraphic",geometry:a,symbol:{type:"CIMPolygonSymbol",symbolLayers:t}}]}]}}const o=[];let n,s,l=e.size;if("outline"in e&&e.outline&&"none"!==e.outline.style&&"esriSLSNull"!==e.outline.style){const t=e.outline,r="solid"!==t.style&&"esriSLSSolid"!==t.style;[n,s]=r?O(a,e.size):O(a);const i=t.width??p.defaultPolylineSymbol2D.width;if(r){const t=i/e.size,r=(n.xmax-n.xmin)*t/2,a=(n.ymax-n.ymin)*t/2;n.xmin-=r,n.xmax+=r,n.ymin-=a,n.ymax+=a,l&&(l+=i)}const c="cross"!==e.style&&"x"!==e.style||"dot"===e?.outline.style||"short-dot"===e?.outline.style?y.LineDashEnding.HalfGap:y.LineDashEnding.FullPattern,m=r?[{type:"CIMGeometricEffectAddControlPoints"},{type:"CIMGeometricEffectDashes",dashTemplate:_(t.style,null).map((e=>t.width&&t.width>0?e*t.width:e)),lineDashEnding:c,controlPointEnding:y.LineDashEnding.FullPattern}]:void 0;o.push({type:"CIMSolidStroke",capStyle:r?y.LineCapStyle.Round:y.LineCapStyle.Butt,enable:!0,width:i,color:B(t.color),effects:m})}else!t||"line-marker"!==e.type||"cross"!==e.style&&"x"!==e.style?[n,s]=O(a):([n,s]=O(a),o.push({type:"CIMSolidStroke",enable:!0,width:t,color:B(i)}));o.push({type:"CIMSolidFill",enable:!0,color:B(i)});const c={type:"CIMPolygonSymbol",symbolLayers:o};return{type:"CIMPointSymbol",symbolLayers:[{type:"CIMVectorMarker",enable:!0,rotation:h.getNumericValue(-e.angle),size:h.getNumericValue(l||6*t),offsetX:h.getNumericValue(e.xoffset),offsetY:h.getNumericValue(e.yoffset),scaleSymbolsProportionally:!1,frame:n,markerGraphics:[{type:"CIMMarkerGraphic",geometry:s,symbol:c}]}]}}static fromCIMHatchFill(e,t){const r=t*(e.separation??f.defaultCIMValues.CIMHatchFill.separation),i=r/2,o=a.clone(e.lineSymbol);o.symbolLayers?.forEach((e=>{switch(e.type){case"CIMSolidStroke":null!=e.width&&(e.width*=t),e.effects?.forEach((e=>{if("CIMGeometricEffectDashes"===e.type){const r=e.dashTemplate;e.dashTemplate=r?.map((e=>e*t))}}));break;case"CIMVectorMarker":{null!=e.size&&(e.size*=t);const r=e.markerPlacement;null!=r&&"placementTemplate"in r&&(r.placementTemplate=r.placementTemplate.map((e=>e*t)));break}}}));let n=this._getLineSymbolPeriod(o)||P;for(;n<P;)n*=2;const s=n/2;return{type:"CIMVectorMarker",frame:{xmin:-s,xmax:s,ymin:-i,ymax:i},markerGraphics:[{type:"CIMMarkerGraphic",geometry:{paths:[[[-s,0],[s,0]]]},symbol:o}],size:r}}static fetchResources(e,t,r,a=null){return e&&t?(V(e,(e=>{W(e,t,r),"url"in e&&e.url&&r.push(t.fetchResource(e.url,{signal:a}))})),r):r}static fetchFonts(e,t,r){if(e&&t)if("symbolLayers"in e&&e.symbolLayers){for(const a of e.symbolLayers)if("CIMVectorMarker"===a.type&&a.markerGraphics)for(const e of a.markerGraphics)e?.symbol&&G.fetchFonts(e.symbol,t,r)}else if("CIMTextSymbol"===e.type){const{fontFamilyName:a,fontStyleName:i}=e;if(!a||"calcitewebcoreicons"===a.toLowerCase())return;const{style:o,weight:n}=h.fromCIMFontStyle(i),s=h.fromCIMFontDecoration(e),l=new c({family:a,style:o,weight:n,decoration:s});r.push(t.loadFont(l).catch((()=>{w().error(`Unsupported font ${a} in CIM symbol`)})))}}static _getLineSymbolPeriod(e){if(e){const t=this._getEffectsRepeat(e.effects);if(t)return t;if(e.symbolLayers)for(const r of e.symbolLayers)if(r){const e=this._getEffectsRepeat(r.effects);if(e)return e;switch(r.type){case"CIMCharacterMarker":case"CIMPictureMarker":case"CIMVectorMarker":case"CIMObjectMarker3D":case"CIMglTFMarker3D":{const e=this._getPlacementRepeat(r.markerPlacement);if(e)return e}}}}return 0}static _getEffectsRepeat(e){if(e)for(const t of e)if(t)switch(t.type){case"CIMGeometricEffectDashes":{const e=t.dashTemplate;if(e&&e.length){let t=0;for(const r of e)t+=r;return 1&e.length&&(t*=2),t}break}case"CIMGeometricEffectWave":return t.period;default:w().error(`unsupported geometric effect type ${t.type}`)}return 0}static _getPlacementRepeat(e){if(e)switch(e.type){case"CIMMarkerPlacementAlongLineSameSize":case"CIMMarkerPlacementAlongLineRandomSize":case"CIMMarkerPlacementAlongLineVariableSize":{const t=e.placementTemplate;if(t&&t.length){let e=0;for(const r of t)e+=+r;return 1&t.length&&(e*=2),e}break}}return 0}static fromCIMInsidePolygon(e){const t=e.markerPlacement,r={...e};r.markerPlacement=null,r.anchorPoint=null;const a=Math.abs(t.stepX),i=Math.abs(t.stepY),s=(t.randomness??100)/100;let l,c,m,u;if("Random"===t.gridType){const e=n.px2pt(g.randomInsidePolygonTextureSize),r=Math.max(Math.floor(e/a),1),f=Math.max(Math.floor(e/i),1);l=r*a/2,c=f*i/2,m=2*c;const y=new o(t.seed),h=s*a/1.5,p=s*i/1.5;u=[];for(let t=0;t<r;t++)for(let e=0;e<f;e++){const r=t*a-l+h*(.5-y.getFloat()),o=e*i-c+p*(.5-y.getFloat());u.push({x:r,y:o}),0===t&&u.push({x:r+2*l,y:o}),0===e&&u.push({x:r,y:o+2*c})}}else!0===t.shiftOddRows?(l=a/2,c=i,m=2*i,u=[{x:-l,y:0},{x:l,y:0},{x:0,y:c},{x:0,y:-c}]):(l=a/2,c=i/2,m=i,u=[{x:-a,y:0},{x:0,y:-i},{x:-a,y:-i},{x:0,y:0},{x:a,y:0},{x:0,y:i},{x:a,y:i},{x:-a,y:i},{x:a,y:-i}]);return{type:"CIMVectorMarker",frame:{xmin:-l,xmax:l,ymin:-c,ymax:c},markerGraphics:u.map((e=>({type:"CIMMarkerGraphic",geometry:e,symbol:{type:"CIMPointSymbol",symbolLayers:[r]}}))),size:m}}}function V(e,t){if(e)switch(e.type){case"CIMPointSymbol":case"CIMLineSymbol":case"CIMPolygonSymbol":{const r=e.symbolLayers;if(!r)return;for(const e of r)if(t(e),"CIMVectorMarker"===e.type){const r=e.markerGraphics;if(!r)continue;for(const e of r)if(e){const r=e.symbol;r&&V(r,t)}}break}}}const N=e=>{if(!e)return y.LineCapStyle.Butt;switch(e){case"butt":return y.LineCapStyle.Butt;case"square":return y.LineCapStyle.Square;case"round":return y.LineCapStyle.Round}},v=e=>{if(!e)return y.LineJoinStyle.Miter;switch(e){case"miter":return y.LineJoinStyle.Miter;case"round":return y.LineJoinStyle.Round;case"bevel":return y.LineJoinStyle.Bevel}},R=e=>{if(null==e)return"Center";switch(e){case"left":return"Left";case"right":return"Right";case"center":return"Center"}},A=e=>{if(null==e)return"Center";switch(e){case"baseline":return"Baseline";case"top":return"Top";case"middle":return"Center";case"bottom":return"Bottom"}},B=e=>{if(!e)return[0,0,0,0];const{r:t,g:r,b:a,a:i}=e;return[t,r,a,255*i]},X=(e,t)=>{const r=H(t),a=Y(e);return r&&a?`${r}-${a}`:`${r}${a}`},H=e=>{if(!e)return"";switch(e.toLowerCase()){case"bold":case"bolder":return"bold"}return""},Y=e=>{if(!e)return"";switch(e.toLowerCase()){case"italic":case"oblique":return"italic"}return""},_=(e,t)=>{const a=r("safari")?.001:0,i="butt"===t;switch(e){case"dash":case"esriSLSDash":return i?[4,3]:[3,4];case"dash-dot":case"esriSLSDashDot":return i?[4,3,1,3]:[3,4,a,4];case"dot":case"esriSLSDot":return i?[1,3]:[a,4];case"long-dash":case"esriSLSLongDash":return i?[8,3]:[7,4];case"long-dash-dot":case"esriSLSLongDashDot":return i?[8,3,1,3]:[7,4,a,4];case"long-dash-dot-dot":case"esriSLSDashDotDot":return i?[8,3,1,3,1,3]:[7,4,a,4,a,4];case"short-dash":case"esriSLSShortDash":return i?[4,1]:[3,2];case"short-dash-dot":case"esriSLSShortDashDot":return i?[4,1,1,1]:[3,2,a,2];case"short-dash-dot-dot":case"esriSLSShortDashDotDot":return i?[4,1,1,1,1,1]:[3,2,a,2,a,2];case"short-dot":case"esriSLSShortDot":return i?[1,1]:[a,2];case"solid":case"esriSLSSolid":case"none":return w().error("Unexpected: style does not require rasterization"),[0,0];default:return w().error(`Tried to rasterize SLS, but found an unexpected style: ${e}!`),[0,0]}};function q(e){return void 0!==e.symbolLayers}const O=(e,t=100)=>{const r=t/2;let a,i;const o=e;if("circle"===o||"esriSMSCircle"===o){const e=.25;let t=Math.acos(1-e/r),o=Math.ceil(b/t/4);0===o&&(o=1),t=C/o,o*=4;const n=[];n.push([r,0]);for(let a=1;a<o;a++)n.push([r*Math.cos(a*t),-r*Math.sin(a*t)]);n.push([r,0]),a={rings:[n]},i={xmin:-r,ymin:-r,xmax:r,ymax:r}}else if("cross"===o||"esriSMSCross"===o){const e=0;a={paths:[[[e,r],[e,-r]],[[r,e],[-r,e]]]},i={xmin:-r,ymin:-r,xmax:r,ymax:r}}else if("diamond"===o||"esriSMSDiamond"===o)a={rings:[[[-r,0],[0,r],[r,0],[0,-r],[-r,0]]]},i={xmin:-r,ymin:-r,xmax:r,ymax:r};else if("square"===o||"esriSMSSquare"===o)a={rings:[[[-r,-r],[-r,r],[r,r],[r,-r],[-r,-r]]]},i={xmin:-r,ymin:-r,xmax:r,ymax:r};else if("x"===o||"esriSMSX"===o)a={paths:[[[r,r],[-r,-r]],[[r,-r],[-r,r]]]},i={xmin:-r,ymin:-r,xmax:r,ymax:r};else if("triangle"===o||"esriSMSTriangle"===o){const e=t*.5773502691896257,r=-e,o=2/3*t,n=o-t;a={rings:[[[r,n],[0,o],[e,n],[r,n]]]},i={xmin:r,ymin:n,xmax:e,ymax:o}}else"arrow"===o&&(a={rings:[[[-50,50],[50,0],[-50,-50],[-33,-20],[-33,20],[-50,50]]]},i={xmin:-r,ymin:-r,xmax:r,ymax:r});return[i,a]},U=e=>"vertical"===e||"horizontal"===e||"cross"===e||"esriSFSCross"===e||"esriSFSVertical"===e||"esriSFSHorizontal"===e;function W(e,t,r){if(!e.effects||null!=t.geometryEngine)return;if(t.geometryEnginePromise)return void r.push(t.geometryEnginePromise);h.isGeometryEngineRequired(e.effects)&&(t.geometryEnginePromise=h.importGeometryEngine(),r.push(t.geometryEnginePromise),t.geometryEnginePromise.then((e=>t.geometryEngine=e)))}function J(e){if(!e)return null;let t=null;const{cap:r,color:a,join:i,miterLimit:o,style:n,width:s}=e;return"solid"!==n&&"none"!==n&&"esriSLSSolid"!==n&&"esriSLSNull"!==n&&(t=[{type:"CIMGeometricEffectDashes",dashTemplate:_(n,r),lineDashEnding:"NoConstraint",scaleDash:!0,offsetAlongLine:null}]),{type:"CIMSolidStroke",color:"esriSLSNull"!==n&&"none"!==n?B(a):[0,0,0,0],capStyle:N(r),joinStyle:v(i),miterLimit:o,width:s,effects:t}}e.CIMSymbolHelper=G,e.CIMSymbolInflatedSizeHelper=z,e.capTypeToEnum=N,e.getEffectsInflateSize=D,e.slsDashToTemplateArray=_,e.symbolToCIM=L,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
