/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../core/Logger","./animationDebugFlags","./defaultCIMValues","./enums","./SDFHelper","./utils","../../views/2d/engine/webgl/animations/instructions"],(function(t,e,r,a,n,o,i,s){"use strict";function m(t,e,r){return{transform:d(t,e,r.transform),fromColor:A(t,e,r.fromColor),toColor:M(t,e,r.toColor),colorMix:C(t,e,r.colorMix),toOpacity:b(t,e,r.toOpacity),opacityMix:T(t,e,r.opacityMix),hasAnimations:r.hasAnimations||!!e.animations&&e.animations.length>0}}function c(t){return!r.animationDebugFlags.forceStaticPath&&(r.animationDebugFlags.forceAnimatedPath||t.hasAnimations)}function l(t,r,a){if("CIMCharacterMarker"===r.type)return e.getLogger("animationUtils").error("#handleMarker()","CIM character markers do not support animations"),a;const n=i.getProcessParam(t,r,"OffsetX"),o=i.getProcessParam(t,r,"OffsetY");if("CIMPictureMarker"===r.type)return{...a,transform:{type:"AnimatedTransform",relativeTranslation:!1,absoluteScale:!0,translation:v([n,o]),rotation:v(0),scale:v(i.getProcessParam(t,r,"Size")),parent:a.transform}};const s=r.frame,m=s.ymax-s.ymin;return{...a,transform:{type:"AnimatedTransform",relativeTranslation:!1,absoluteScale:!1,translation:v([n,o]),rotation:v(0),scale:v({type:"Process",op:"Divide",left:i.getProcessParam(t,r,"Size"),right:m}),parent:a.transform}}}function u(t,e){let r=0,a=0;const n="Absolute"!==t.anchorPointUnits;return t.anchorPoint&&(r=-t.anchorPoint.x,a=-t.anchorPoint.y),{...e,transform:{type:"AnimatedTransform",relativeTranslation:n,absoluteScale:!1,translation:v([r,a]),rotation:v(0),scale:v(1),parent:e.transform}}}function f(t,e){return"Absolute"===t.anchorPointUnits?e:u(t,e)}function p(t,e){return"Absolute"!==t.anchorPointUnits?e:u(t,e)}function y(t,e,r){return{...t,transform:{type:"AnimatedTransform",relativeTranslation:!1,absoluteScale:!1,translation:v([e,r]),rotation:v(0),scale:v(1),parent:t.transform}}}function P(t,e){const r=e?.5*-(e.xmin+e.xmax):0,a=e?.5*-(e.ymin+e.ymax):0;let n=0,i=0;if("x"in t&&"y"in t)n=t.x+r,i=t.y+a;else{const e=o.getExtent(t);if(e){n=(e[0]+e[2])/2+r,i=(e[1]+e[3])/2+a}}return[n,i]}function g(t,e){switch(e.type){case"CIMPictureMarker":case"CIMVectorMarker":return i.getProcessParam(t,e,"Rotation")}return 0}function S(t,e){switch(e.type){case"CIMPointSymbol":case"CIMVectorMarker":return[1,1,1,1];case"CIMSolidStroke":case"CIMSolidFill":return i.getProcessParam(t,e,"Color");case"CIMPictureMarker":case"CIMPictureStroke":case"CIMPictureFill":return i.getProcessParam(t,e,"TintColor")}return[1,1,1,1]}function d(t,e,r){return{type:"AnimatedTransform",relativeTranslation:!1,absoluteScale:!1,translation:O(t,e),rotation:k(t,e),scale:I(t,e),parent:r}}function A(t,e,r){return{type:"AnimatedColor",color:v(S(t,e)),opacity:v(1),parent:r}}function M(t,e,r){const{animations:a}=e;let n=S(t,e);const o=a?.filter((t=>"CIMSymbolAnimationColor"===t.type))[0];return o&&(n=i.getProcessParam(t,o,"ToColor")),{type:"AnimatedColor",color:v(n),opacity:v(1),parent:r}}function C(t,e,r){const{animations:a}=e,n=a?.filter((t=>"CIMSymbolAnimationColor"===t.type))[0];return n?{type:"AnimatedColor",color:v([1,1,1,1]),opacity:{from:0,to:1,timing:h(t,n?.animatedSymbolProperties)},parent:[1,1,1,1]}:r}function b(t,e,r){const{animations:a}=e;let n=v(1);const o=a?.filter((t=>"CIMSymbolAnimationTransparency"===t.type))[0];if(o){n=v({type:"Process",op:"Transparency",value:i.getProcessParam(t,o,"ToTransparency")})}return{type:"AnimatedColor",color:v([1,1,1,1]),opacity:n,parent:r}}function T(t,e,r){const{animations:a}=e,n=a?.filter((t=>"CIMSymbolAnimationTransparency"===t.type))[0];return n?{type:"AnimatedColor",color:v([1,1,1,1]),opacity:{from:0,to:1,timing:h(t,n?.animatedSymbolProperties)},parent:[1,1,1,1]}:r}function h(t,e){if(!e)return{duration:1,startTimeOffset:0,repeatDelay:0,timeOriginSelector:s.TimeOrigin.Local,repeatType:n.AnimatedSymbolRepeatType.Loop,easing:n.AnimatedSymbolEasingType.Linear,playAnimation:1,reverseAnimation:0};const r=i.getProcessParam(t,e,"Duration");let o;if(i.getProcessParam(t,e,"RandomizeStartTime")){o={type:"Process",op:"Random",min:0,max:r,seed:i.getProcessParam(t,e,"RandomizeStartSeed")}}else o=i.getProcessParam(t,e,"StartTimeOffset");const m=i.getProcessParam(t,e,"RepeatDelay"),c=i.getProcessParam(t,e,"PlayAnimation"),l=i.getProcessParam(t,e,"ReverseAnimation"),u=i.getValue(e.repeatType,a.defaultCIMValues.CIMAnimatedSymbolProperties.repeattype);return{duration:r,startTimeOffset:o,repeatDelay:m,timeOriginSelector:u===n.AnimatedSymbolRepeatType.None?s.TimeOrigin.Local:s.TimeOrigin.Global,repeatType:u,easing:i.getValue(e.easing,a.defaultCIMValues.CIMAnimatedSymbolProperties.easing),playAnimation:c,reverseAnimation:l}}function I(t,e){const{animations:r}=e;if("CIMPictureMarker"!==e.type&&"CIMVectorMarker"!==e.type&&"CIMPointSymbol"!==e.type)return v(1);let a;a="CIMPictureMarker"===e.type||"CIMVectorMarker"===e.type?i.getProcessParam(t,e,"Size"):i.getSize(e)||10;const n=r?.filter((t=>"CIMSymbolAnimationScale"===t.type))[0];if(!n){const e=r?.filter((t=>"CIMSymbolAnimationSize"===t.type))[0];if(!e)return v(1);return{from:1,to:{type:"Process",op:"Divide",left:i.getProcessParam(t,e,"ToSize"),right:a},timing:h(t,e.animatedSymbolProperties)}}return{from:1,to:i.getProcessParam(t,n,"ScaleFactor"),timing:h(t,n.animatedSymbolProperties)}}function O(t,e){const{animations:r}=e,a=r?.filter((t=>"CIMSymbolAnimationOffset"===t.type))[0];if(!a)return v([0,0]);return{from:[0,0],to:[i.getProcessParam(t,a,"OffsetX"),i.getProcessParam(t,a,"OffsetY")],timing:h(t,a.animatedSymbolProperties)}}function k(t,e){const{animations:r}=e,a=g(t,e),n=r?.filter((t=>"CIMSymbolAnimationRotation"===t.type))[0];if(!n)return v(a);return{from:a,to:i.getProcessParam(t,n,"ToRotation"),timing:h(t,n.animatedSymbolProperties)}}function v(t){return{from:t,to:t,timing:{duration:1,startTimeOffset:0,repeatDelay:0,timeOriginSelector:s.TimeOrigin.Local,repeatType:n.AnimatedSymbolRepeatType.Loop,easing:n.AnimatedSymbolEasingType.Linear,playAnimation:1,reverseAnimation:0}}}function x(t){if(null==t)return!1;if("object"!=typeof t)return!1;if(t.animations&&Array.isArray(t.animations)&&t.animations.length>0)return!0;for(const e in t)if(x(t[e]))return!0;return!1}t.checkForAnimations=x,t.getAnimationParams=m,t.getFrameTranslation=P,t.getStaticParam=v,t.handleAbsoluteAnchor=p,t.handleAnchor=u,t.handleMarker=l,t.handleRelativeAnchor=f,t.shouldUseAnimatedPath=c,t.translate=y,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
