/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../core/colorUtils","../../core/fontUtils","../../core/lang","../../core/Logger","../../core/screenUtils","../../core/string","./animationUtils","./CIMSymbolHelper","./defaultCIMValues","./enums","./OverrideHelper","./SDFHelper","./utils","./effects/CIMEffectHelper","../../views/2d/engine/webgl/definitions"],(function(e,t,r,i,o,a,s,l,n,c,m,p,u,h,f,y){"use strict";const d=()=>o.getLogger("esri.symbols.cim.cimAnalyzer");function g(e){const t=e.markerPlacement;return t&&t.angleToLine?m.Alignment.MAP:m.Alignment.SCREEN}class v{constructor(e){this._cimLayers=[],this._poMap={},this._primitiveOverrides=[],e&&(this._resourceManager=e)}analyzeSymbolReference(e,r,i){if(this._cimLayers=i??[],!e)return this._cimLayers;if(this._reset(),e.primitiveOverrides){this._primitiveOverrides=e.primitiveOverrides;for(const e of this._primitiveOverrides){const r=e.valueExpressionInfo;if(r)this._setPoMap(e.primitiveName,e.propertyName,r);else if(null!=e.value){let r=e.value;e.propertyName.includes("Color")&&(t.isRGB(r)&&(r=h.colorToArray(r)),r=h.normalizeAlpha(r)),this._setPoMap(e.primitiveName,e.propertyName,r)}}}return this._analyzeSymbol(e.symbol,r),this._cimLayers}_reset(){this._cimLayers=[],this._poMap={},this._primitiveOverrides=[]}_analyzeSymbol(e,t){switch(e?.type){case"CIMPointSymbol":case"CIMLineSymbol":case"CIMPolygonSymbol":this._analyzeMultiLayerSymbol(e,t)}}_analyzeMultiLayerSymbol(e,t){const r=e?.symbolLayers;if(!r)return;const i=e.effects;let o=m.Alignment.SCREEN;const a=h.getSize(e)??0;"CIMPointSymbol"===e.type&&"Map"===e.angleAlignment&&(o=m.Alignment.MAP);let s={transform:[0,0,0,1],fromColor:[1,1,1,1],toColor:[1,1,1,1],colorMix:[0,0,0,0],toOpacity:[1,1,1,1],opacityMix:[0,0,0,0],hasAnimations:l.checkForAnimations(e)};s=l.getAnimationParams(this._poMap,e,s);const n="CIMPolygonSymbol"===e.type;let c=r.length;for(;c--;){const l=r[c];if(!l||!1===l.enable)continue;let m;i?.length&&(m=[...i]);const u=l.effects;u?.length&&(i?m.push(...u):m=[...u]);let f=null;if(m){f=[];for(const e of m){const t=p.OverrideHelper.findEffectOverrides(e,this._primitiveOverrides);t&&f.push(t)}}const y=[];switch(p.OverrideHelper.findApplicableOverrides(l,this._primitiveOverrides,y),l.type){case"CIMSolidFill":this._analyzeSolidFill(l,f);break;case"CIMPictureFill":this._analyzePictureFill(l,f);break;case"CIMHatchFill":this._analyzeHatchFill(l,f);break;case"CIMGradientFill":this._analyzeGradientFill(l,f);break;case"CIMSolidStroke":this._analyzeSolidStroke(l,f,n,a);break;case"CIMPictureStroke":this._analyzePictureStroke(l,f,n,a);break;case"CIMGradientStroke":this._analyzeGradientStroke(l,f,n,a);break;case"CIMCharacterMarker":case"CIMPictureMarker":case"CIMVectorMarker":{"CIMLineSymbol"!==e.type&&"CIMPolygonSymbol"!==e.type||(o=g(l));const r=[],i=l.primitiveName;i&&r.push(i);const c=n&&h.isCIMMarkerStrokePlacement(l.markerPlacement);this._analyzeMarker(l,f,null,r,o,a,t,[],s,!1,c);break}default:d().error("Cannot analyze CIM layer",l.type)}}}_analyzeSolidFill(e,t){const{primitiveName:r,type:i}=e,o=h.normalizeAlpha(e.color);this._cimLayers.push({type:"fill",spriteRasterizationParam:null,colorLocked:!!e.colorLocked,color:this._getValueOrOverrideExpression(i,r,"Color",o),height:0,angle:0,offsetX:0,offsetY:0,scaleX:1,effects:t,applyRandomOffset:!1,sampleAlphaOnly:!0,hasUnresolvedReplacementColor:!1})}_analyzePictureFill(e,t){const{primitiveName:r,type:i}=e,o=h.getTintColor(e),a=h.getNumericValue(e.height,c.defaultCIMValues.CIMPictureFill.height);let s=h.getNumericValue(e.scaleX,1);if("width"in e&&"number"==typeof e.width){const t=e.width;let r=1;const i=this._resourceManager.getResource(e.url);null!=i&&(r=i.width/i.height),s/=r*(a/t)}const l={type:"sprite-rasterization-param",resource:e,overrides:this._getPrimitiveMaterialOverrides(r,i)};this._cimLayers.push({type:"fill",spriteRasterizationParam:l,colorLocked:!!e.colorLocked,effects:t,color:this._getValueOrOverrideExpression(i,r,"TintColor",o),height:this._getValueOrOverrideExpression(i,r,"Height",a),scaleX:this._getValueOrOverrideExpression(i,r,"ScaleX",s),angle:this._getValueOrOverrideExpression(i,r,"Rotation",h.getNumericValue(e.rotation)),offsetX:this._getValueOrOverrideExpression(i,r,"OffsetX",h.getNumericValue(e.offsetX)),offsetY:this._getValueOrOverrideExpression(i,r,"OffsetY",h.getNumericValue(e.offsetY)),applyRandomOffset:!1,sampleAlphaOnly:!1,hasUnresolvedReplacementColor:!1})}_analyzeHatchFill(e,t){const{primitiveName:r,type:i}=e,o=this._analyzeMaterialOverrides(r,["Rotation","OffsetX","OffsetY"]),a=h.normalizePrimitiveOverrideProps(o);let s=[255,255,255,1],l=!1;if(e.lineSymbol?.symbolLayers)for(const c of e.lineSymbol.symbolLayers){if("CIMSolidStroke"!==c.type)continue;const e=c.primitiveName??r;l||!e||c.colorLocked||null==this._poMap[e]?.Color&&null==this._poMap[e]?.StrokeColor||(s=h.normalizeAlpha(c.color),s=this._maybeGetValueOrOverrideExpression(e,"StrokeColor")??this._getValueOrOverrideExpression(i,e,"Color",s),l=!0);const t=this._maybeGetValueOrOverrideExpression(e,"StrokeWidth");if(t){let r=null,o=null;"number"==typeof t?r=t:o=t.valueExpressionInfo;let s=a.find((e=>"strokeWidth"===e.propertyName));s?s.propertyName="width":(s={type:"CIMPrimitiveOverride",primitiveName:e,propertyName:"width",valueExpressionInfo:o,value:r,defaultValue:h.getDefaultCIMValue(i,"width")},a.push(s))}}const n={type:"sprite-rasterization-param",resource:e,overrides:a};this._cimLayers.push({type:"fill",spriteRasterizationParam:n,colorLocked:!!e.colorLocked,effects:t,color:s,height:this._getValueOrOverrideExpression(i,r,"Separation",h.getNumericValue(e.separation,c.defaultCIMValues.CIMHatchFill.separation)),scaleX:1,angle:this._getValueOrOverrideExpression(i,r,"Rotation",h.getNumericValue(e.rotation)),offsetX:this._getValueOrOverrideExpression(i,r,"OffsetX",h.getNumericValue(e.offsetX)),offsetY:this._getValueOrOverrideExpression(i,r,"OffsetY",h.getNumericValue(e.offsetY)),applyRandomOffset:!1,sampleAlphaOnly:!0,hasUnresolvedReplacementColor:!l})}_analyzeGradientFill(e,t){this._cimLayers.push({type:"fill",spriteRasterizationParam:null,colorLocked:!!e.colorLocked,effects:t,color:[128,128,128,1],height:0,angle:0,offsetX:0,offsetY:0,scaleX:1,applyRandomOffset:!1,sampleAlphaOnly:!1,hasUnresolvedReplacementColor:!1})}_analyzeSolidStroke(e,t,r,i){const{primitiveName:o,type:a}=e,s=h.normalizeAlpha(e.color),l=h.getNumericValue(e.width,c.defaultCIMValues.CIMSolidStroke.width),n=h.getEnum(e.capStyle,c.defaultCIMValues.CIMSolidStroke.capstyle),m=h.getEnum(e.joinStyle,c.defaultCIMValues.CIMSolidStroke.joinstyle),p=e.miterLimit;let u,f,y,d,g=[];if(this._analyzePrimitiveOverrides(o,t,null,null)&&(g=this._getPrimitiveMaterialOverrides(o,a)),t&&Array.isArray(t)&&t.length>0){const e=t[t.length-1].effect;e&&"CIMGeometricEffectDashes"===e.type&&"NoConstraint"===e.lineDashEnding&&(u=e.dashTemplate,f=e.scaleDash,y=e.offsetAlongLine,d=e.primitiveName,(t=[...t]).pop())}null!=d&&g.push(...this._getPrimitiveMaterialOverrides(d,a).filter((e=>"dashTemplate"===e.propertyName)));const v=void 0!==u?{type:"sprite-rasterization-param",resource:{type:"dash",dashTemplate:u,primitiveName:d},overrides:g}:null;this._cimLayers.push({type:"line",spriteRasterizationParam:v,isOutline:r,colorLocked:!!e.colorLocked,effects:t,color:this._getValueOrOverrideExpression(a,o,"Color",s),width:this._getValueOrOverrideExpression(a,o,"Width",l),cap:this._getValueOrOverrideExpression(a,o,"CapStyle",n),join:this._getValueOrOverrideExpression(a,o,"JoinStyle",m),miterLimit:p&&this._getValueOrOverrideExpression(a,o,"MiterLimit",p),referenceWidth:i,zOrder:M(e.name),dashTemplate:this._maybeGetValueOrOverrideExpression(d,"DashTemplate")??u,offsetAlongLine:this._getValueOrOverrideExpression(a,d,"OffsetAlongLine",y??0),scaleDash:f,sampleAlphaOnly:!0})}_analyzePictureStroke(e,t,r,i){const{primitiveName:o,type:a}=e,s=h.getTintColor(e),l=h.getNumericValue(e.width,c.defaultCIMValues.CIMPictureStroke.width),n=h.getEnum(e.capStyle,c.defaultCIMValues.CIMPictureStroke.capstyle),m=h.getEnum(e.joinStyle,c.defaultCIMValues.CIMPictureStroke.joinstyle),p=e.miterLimit,u={type:"sprite-rasterization-param",resource:e,overrides:this._getPrimitiveMaterialOverrides(o,a)};this._cimLayers.push({type:"line",spriteRasterizationParam:u,isOutline:r,colorLocked:!!e.colorLocked,effects:t,color:this._getValueOrOverrideExpression(a,o,"TintColor",s),width:this._getValueOrOverrideExpression(a,o,"Width",l),cap:this._getValueOrOverrideExpression(a,o,"CapStyle",n),join:this._getValueOrOverrideExpression(a,o,"JoinStyle",m),miterLimit:p&&this._getValueOrOverrideExpression(a,o,"MiterLimit",p),referenceWidth:i,zOrder:M(e.name),dashTemplate:null,scaleDash:!1,sampleAlphaOnly:!1})}_analyzeGradientStroke(e,t,r,i){const{primitiveName:o,type:a}=e,s=h.getNumericValue(e.width,c.defaultCIMValues.CIMSolidStroke.width),l=h.getEnum(e.capStyle,c.defaultCIMValues.CIMGradientStroke.capstyle),n=h.getEnum(e.joinStyle,c.defaultCIMValues.CIMGradientStroke.joinstyle),m=e.miterLimit;this._cimLayers.push({type:"line",spriteRasterizationParam:null,isOutline:r,colorLocked:!!e.colorLocked,effects:t,color:[128,128,128,1],width:this._getValueOrOverrideExpression(a,o,"Width",s),cap:this._getValueOrOverrideExpression(a,o,"CapStyle",l),join:this._getValueOrOverrideExpression(a,o,"JoinStyle",n),miterLimit:m&&this._getValueOrOverrideExpression(a,o,"MiterLimit",m),referenceWidth:i,zOrder:M(e.name),dashTemplate:null,scaleDash:!1,sampleAlphaOnly:!1})}_analyzeMarker(e,t,r,i,o,a,s,n,m,p=!1,u=!1){if(p||=!!e.colorLocked,this._analyzeMarkerInsidePolygon(e,t,p))return;const f=h.getNumericValue(e.size,c.defaultCIMValues.CIMVectorMarker.size),y=h.getNumericValue(e.rotation),d=h.getNumericValue(e.offsetX),g=h.getNumericValue(e.offsetY),{primitiveName:v,type:O}=e,M=this._getValueOrOverrideExpression(O,v,"Size",f),S=this._getValueOrOverrideExpression(O,v,"Rotation",y),C=this._getValueOrOverrideExpression(O,v,"OffsetX",d),_=this._getValueOrOverrideExpression(O,v,"OffsetY",g);let k=m;switch(k=l.handleAbsoluteAnchor(e,k),k=l.handleMarker(this._poMap,e,k),k=l.handleRelativeAnchor(e,k),k=l.getAnimationParams(this._poMap,e,k),e.type){case"CIMPictureMarker":this._analyzePictureMarker(e,t,r,i,o,a,M,S,C,_,n,k,p,u);break;case"CIMVectorMarker":this._analyzeVectorMarker(e,t,r,i,o,a,M,S,C,_,n,k,s,p,u)}}_analyzeMarkerInsidePolygon(e,t,r){const{markerPlacement:i,type:o}=e;if(!i||"CIMMarkerPlacementInsidePolygon"!==i.type)return!1;if("CIMVectorMarker"===o||"CIMPictureMarker"===o){const r=e.primitiveName;if(r&&this._analyzePrimitiveOverrides([r],t,null,null))return!1;const a=i.primitiveName;if(a&&this._analyzePrimitiveOverrides([a],t,null,null))return!1;if("CIMVectorMarker"===o){const{markerGraphics:t}=e;if(t)for(const e of t){const{symbol:t}=e;if("CIMPolygonSymbol"===t?.type&&t.symbolLayers){const{symbolLayers:e}=t;for(const t of e)if("CIMSolidStroke"===t.type)return!1}}}else{const{animatedSymbolProperties:t}=e;if(t)return!1}}const s=Math.abs(i.stepX),l=Math.abs(i.stepY);if(0===s||0===l)return!0;let n,c;if("Random"===i.gridType){const e=a.px2pt(y.randomInsidePolygonTextureSize),t=Math.max(Math.floor(e/s),1);n=l*Math.max(Math.floor(e/l),1);c=t*s/n}else i.shiftOddRows?(n=2*l,c=s/l*.5):(n=l,c=s/l);const m=h.getTintColor(e),p="CIMCharacterMarker"===e.type?null:{type:"sprite-rasterization-param",resource:e,overrides:[]};return this._cimLayers.push({type:"fill",spriteRasterizationParam:p,colorLocked:r,effects:t,color:m,height:n,scaleX:c,angle:i.gridAngle,offsetX:h.getNumericValue(i.offsetX),offsetY:h.getNumericValue(i.offsetY),applyRandomOffset:"Random"===i.gridType,sampleAlphaOnly:"CIMPictureMarker"!==e.type,hasUnresolvedReplacementColor:!0}),!0}_analyzePictureMarker(e,t,r,o,a,l,n,c,m,p,u,f,y,d){const{animatedSymbolProperties:g,primitiveName:v,type:O}=e;let M=h.getNumericValue(e.scaleX,1);const S=h.getTintColor(e);r||(r=this._createMarkerPlacementOverrideExpression(e.markerPlacement));const C=this._createGIFAnimatedSymbolPropertiesOverrideExpression(g),_=e.anchorPoint??{x:0,y:0};if("width"in e&&"number"==typeof e.width){const t=e.width;let r=1;const i=this._resourceManager.getResource(e.url);null!=i&&(r=i.width/i.height);M/=r*(h.getNumericValue(e.size)/t)}const k=[...o];let b;e.primitiveName&&k.push(e.primitiveName),g||C?b={type:"animated",url:e.url,urlHash:"H"+s.numericHash(e.url),playAnimation:e.animatedSymbolProperties?.playAnimation,reverseAnimation:e.animatedSymbolProperties?.reverseAnimation,randomizeStartTime:e.animatedSymbolProperties?.randomizeStartTime,randomizeStartSeed:e.animatedSymbolProperties?.randomizeStartSeed,startTimeOffset:e.animatedSymbolProperties?.startTimeOffset,duration:e.animatedSymbolProperties?.duration,repeatType:e.animatedSymbolProperties?.repeatType,repeatDelay:e.animatedSymbolProperties?.repeatDelay}:(b=i.clone(e),b.markerPlacement=null);const z={type:"sprite-rasterization-param",resource:b,overrides:this._getMaterialOverrides(k,O)};C&&z.overrides.push(...C.overrides);const V=n;this._cimLayers.push({type:"marker",spriteRasterizationParam:z,colorLocked:y,effects:t,scaleSymbolsProportionally:!1,alignment:a,size:n,scaleX:this._getValueOrOverrideExpression(O,v,"ScaleX",M),rotation:c,offsetX:m,offsetY:p,transform:{type:"cim-marker-transform-param",params:u},color:this._getValueOrOverrideExpression(O,v,"TintColor",S),anchorPoint:{x:_.x,y:_.y},isAbsoluteAnchorPoint:"Relative"!==e.anchorPointUnits,outlineColor:[0,0,0,0],outlineWidth:0,frameHeight:0,widthRatio:1,rotateClockwise:!!e.rotateClockwise,referenceSize:l,sizeRatio:1,isOutline:d,markerPlacement:r,animationParams:P(f),baseSize:V})}_analyzeVectorMarker(e,t,r,i,o,a,s,n,c,m,p,u,h,f,y){const d=e.markerGraphics;if(!d)return;const g=e.frame;let v=0;v=g?g.ymax-g.ymin:a;const O=!!e.scaleSymbolsProportionally;if(v){const t={offsetX:c,offsetY:m,rotation:n,size:s,frameHeight:v,rotateClockWise:!!e.rotateClockwise,absoluteAnchorPoint:!1,scaleSymbolsProportionally:O};p=[...p,t]}r||(r=this._createMarkerPlacementOverrideExpression(e.markerPlacement));for(const M of d)if(M){const s=M.symbol;if(!s)continue;const n=M.primitiveName;n&&i.push(n);let c,m=u;if(("CIMPointSymbol"===s.type||"CIMTextSymbol"===s.type)&&g){let t=0,r=0;const i=M.geometry;"x"in i&&"y"in i&&(t+=i.x-.5*(g.xmin+g.xmax),r+=i.y-.5*(g.ymin+g.ymax));const o=e.anchorPoint;let a=!1;o&&("Absolute"===e.anchorPointUnits?(t-=o.x,r-=o.y,a=!0):g&&(t-=(g.xmax-g.xmin)*o.x,r-=(g.ymax-g.ymin)*o.y));const s={offsetX:t,offsetY:r,rotation:0,size:0,frameHeight:0,rotateClockWise:!1,absoluteAnchorPoint:a,scaleSymbolsProportionally:O};c=[...p,s]}const d=M.geometry,[S,C]=l.getFrameTranslation(d,g);switch(0===S&&0===C||(m=l.translate(m,S,C)),"CIMPointSymbol"===s.type&&(m=l.getAnimationParams(this._poMap,s,m)),s.type){case"CIMPointSymbol":case"CIMLineSymbol":case"CIMPolygonSymbol":h||_(s)?(m={...m,transform:{type:"AnimatedTransform",relativeTranslation:!1,absoluteScale:!0,translation:l.getStaticParam([0,0]),rotation:l.getStaticParam(0),scale:l.getStaticParam(v),parent:u.transform}},this._analyzeMultiLayerGraphicNonSDF(e,t,r,M,i,o,a,c??p,m,v,f,y)):this._analyzeMultiLayerGraphic(e,t,r,M,i,o,a,c??p,m,v,f,y);break;case"CIMTextSymbol":this._analyzeTextGraphic(t,r,M,i,o,a,c??p,f)}n&&i.pop()}}_analyzeMultiLayerGraphic(e,t,r,i,o,a,s,n,m,p,y,d){const g=i.symbol,v=g.symbolLayers;if(!v)return;let O=v.length;if(C(v)&&!l.shouldUseAnimatedPath(m))return void this._analyzeCompositeMarkerGraphic(e,t,r,i,v,a,s,n,p,y,d);const M=this._resourceManager.geometryEngine,S=f.CIMEffectHelper.applyEffects(g.effects,i.geometry,M);if(S)for(;O--;){const g=v[O];if(!g||!1===g.enable)continue;const C=g.primitiveName;switch(C&&o.push(C),g.type){case"CIMSolidFill":case"CIMSolidStroke":{const o=f.CIMEffectHelper.applyEffects(g.effects,S,M),v=u.getExtent(o);if(!v)continue;const O="Relative"!==e.anchorPointUnits,_=h.getStrokeWidth(g)??0,{frameSizeRatio:k,anchorX:b,anchorY:z,widthRatio:V,sdfPaddingRatio:x}=u.getSDFMetrics(v,e.frame,e.size,e.anchorPoint,O,_,e.scaleSymbolsProportionally),I="CIMSolidFill"===g.type,E={type:"sdf",geom:o,sdfPaddingRatio:x,asFill:I},{path:L}=g,N=I?h.normalizeAlpha(h.getFillColor(g)):null==L?h.normalizeAlpha(h.getStrokeColor(g)):[0,0,0,0],A=I?[0,0,0,0]:h.normalizeAlpha(h.getStrokeColor(g));if(!I&&!_)break;const R=i.primitiveName;let w=null;I&&!g.colorLocked&&(w=this._maybeGetValueOrOverrideExpression(R,"FillColor"));let F=null;I||g.colorLocked||(F=this._maybeGetValueOrOverrideExpression(R,"StrokeColor"));const G=w??this._getValueOrOverrideExpression(g.type,C,"Color",N),T=F??this._getValueOrOverrideExpression(g.type,C,"Color",A),X=this._maybeGetValueOrOverrideExpression(R,"StrokeWidth")??this._getValueOrOverrideExpression(g.type,C,"Width",_),D=L?{type:"sprite-rasterization-param",resource:{type:"path",path:L,asFill:I},overrides:[]}:{type:"sprite-rasterization-param",resource:E,overrides:[]},H=l.getAnimationParams(this._poMap,g,m),Y=h.getNumericValue(e.size,c.defaultCIMValues.CIMVectorMarker.size),W=this._getValueOrOverrideExpression(e.type,e.primitiveName,"Size",Y);this._cimLayers.push({type:"marker",spriteRasterizationParam:D,colorLocked:!!g.colorLocked||!!y,effects:t,scaleSymbolsProportionally:!!e.scaleSymbolsProportionally,alignment:a,anchorPoint:{x:b,y:z},isAbsoluteAnchorPoint:O,size:p,rotation:0,offsetX:0,offsetY:0,scaleX:1,transform:{type:"cim-marker-transform-param",params:n},frameHeight:p,widthRatio:V,rotateClockwise:!1,referenceSize:s,sizeRatio:k,color:G,outlineColor:T,outlineWidth:X,isOutline:d,markerPlacement:r,animationParams:P(H),isStroke:"CIMSolidFill"!==g.type,baseSize:W,...u.getSDFDimensions(o,x)});break}case"CIMPictureMarker":case"CIMVectorMarker":g.markerPlacement?this._analyzeMultiLayerGraphicNonSDF(e,t,r,i,o,a,s,n,m,p,!!g.colorLocked||!!y,d):this._analyzeMarker(g,t,r,o,a,s,!1,n,m,y,d);break;default:this._analyzeMultiLayerGraphicNonSDF(e,t,r,i,o,a,s,n,m,p,!!g.colorLocked||!!y,d)}C&&o.pop()}}_analyzeTextGraphic(e,t,i,o,a,s,l,n){const m=[];p.OverrideHelper.findApplicableOverrides(i,this._primitiveOverrides,m);const u=i.geometry;if(!("x"in u)||!("y"in u))return;const f=i.symbol,y=h.fromCIMFontDecoration(f),d=h.fromCIMFontStyle(f.fontStyleName),g=r.getFontFamily(f.fontFamilyName);f.font={family:g,decoration:y,...d};const v=h.getNumericValue(f.height,c.defaultCIMValues.CIMTextSymbol.height),O=h.getNumericValue(f.angle),M=h.getNumericValue(f.offsetX),S=h.getNumericValue(f.offsetY),{haloSymbol:C}=f,_=h.getNumericValue(f.haloSize,0);let k=[0,0,0,0];if(C?.symbolLayers?.length){const e=C.symbolLayers;for(const t of e)if(t.color){k=this._getValueOrOverrideExpression(f?.haloSymbol?.type??"CIMPolygonSymbol",t.primitiveName,"Color",h.normalizeAlpha(t.color));break}}const P=i.primitiveName;let b=[0,0,0,1],z=[0,0,0,0],V=0,x=!1;if(f.symbol?.symbolLayers)for(const r of f.symbol.symbolLayers){const e=r.primitiveName;if("CIMSolidStroke"===r.type)z=this._getValueOrOverrideExpression("CIMSolidStroke",e,"Color",h.normalizeAlpha(r.color)),V=this._getValueOrOverrideExpression("CIMSolidStroke",e,"Width",h.getStrokeWidth(r)??0);else if("CIMSolidFill"===r.type){const t=h.normalizeAlpha(r.color);x=x??!!r.colorLocked,b=this._getValueOrOverrideExpression("CIMSolidFill",e??P,"Color",t)}}let I=null,E=null,L=null,N=null,A=null;P&&(I=this._maybeGetValueOrOverrideExpression(P,"TextSize"),E=this._maybeGetValueOrOverrideExpression(P,"TextAngle"),L=this._maybeGetValueOrOverrideExpression(P,"TextOffsetX"),N=this._maybeGetValueOrOverrideExpression(P,"TextOffsetY"),x||(A=this._maybeGetValueOrOverrideExpression(P,"FillColor")));const R=A??b;let w=null,F=null,G=0;if(f.callout&&"CIMBackgroundCallout"===f.callout.type){const e=f.callout;if(e.backgroundSymbol){const t=e.backgroundSymbol.symbolLayers;if(t)for(const e of t)"CIMSolidFill"===e.type?w=h.normalizeAlpha(e.color):"CIMSolidStroke"===e.type&&(F=h.normalizeAlpha(e.color),G=h.getNumericValue(e.width,c.defaultCIMValues.CIMSolidStroke.width))}}const T=this._getValueOrOverrideExpression(f.type,i.primitiveName,"TextString",i.textString??"");if(null==T)return;const{fontStyleName:X}=f,D=g+(X?"-"+X.toLowerCase():"-regular"),H=this._getMaterialOverrides(o,f.type);H.push(...this._getPrimitiveMaterialOverrides(i.primitiveName,f.type));const Y={type:"text-rasterization-param",resource:{type:"text",textString:i.textString??"",font:f.font,symbol:f,primitiveName:i.primitiveName},overrides:H};this._cimLayers.push({type:"text",lineWidth:f.lineWidth,textRasterizationParam:Y,colorLocked:!!n||!!x,effects:e,alignment:a,anchorPoint:{x:0,y:0},isAbsoluteAnchorPoint:!1,fontName:D,decoration:y,haloSize:_,haloColor:k,weight:d.weight,style:d.style,size:I??v,angle:E??O,offsetX:L??M,offsetY:N??S,transform:{type:"cim-marker-transform-param",params:l},horizontalAlignment:h.fromCIMHorizontalAlignment(f.horizontalAlignment),verticalAlignment:h.fromCIMVerticalAlignment(f.verticalAlignment),text:T,color:R,outlineColor:z,outlineSize:V,backgroundColor:w,borderLineColor:F,borderLineWidth:G,referenceSize:s,sizeRatio:1,markerPlacement:t})}_analyzeMultiLayerGraphicNonSDF(e,t,r,i,o,s,l,m,p,u,f,y){const d=O(e,i),g=e.primitiveName,v=this._analyzeMaterialOverrides(g,["Rotation","OffsetX","OffsetY"]),M=h.normalizePrimitiveOverrideProps(v),[S,C,_]=n.CIMSymbolHelper.getTextureAnchor(d,this._resourceManager),k=this._getMaterialOverrides(o,e.type);k.push(...M);const b={type:"sprite-rasterization-param",resource:{...d,avoidSDFRasterization:!0},overrides:k},z=h.getNumericValue(e.size,c.defaultCIMValues.CIMVectorMarker.size),V=this._getValueOrOverrideExpression(e.type,g,"Size",z);this._cimLayers.push({type:"marker",spriteRasterizationParam:b,colorLocked:f,effects:t,scaleSymbolsProportionally:!!e.scaleSymbolsProportionally,alignment:s,anchorPoint:{x:S,y:C},isAbsoluteAnchorPoint:!1,size:u,rotation:0,offsetX:0,offsetY:0,transform:{type:"cim-marker-transform-param",params:m},color:[255,255,255,1],outlineColor:[0,0,0,0],outlineWidth:0,scaleX:1,frameHeight:u,widthRatio:1,rotateClockwise:!!e.rotateClockwise,referenceSize:l,sizeRatio:_/a.pt2px(e.size),isOutline:y,markerPlacement:r,animationParams:P(p),baseSize:V})}_createMarkerPlacementOverrideExpression(e){if(!e)return null;const t=[];return p.OverrideHelper.findApplicableOverrides(e,this._primitiveOverrides,t),{type:"cim-marker-placement-param",placement:e,overrides:k(t)}}_createGIFAnimatedSymbolPropertiesOverrideExpression(e){if(!e)return null;const t=[];return p.OverrideHelper.findApplicableOverrides(e,this._primitiveOverrides,t),{type:"cim-gif-animation-params",animation:e,overrides:k(t)}}_analyzeCompositeMarkerGraphic(e,t,r,i,o,a,s,l,n,m,p){const f=i.geometry,y=o[0],d=o[1],g=u.getExtent(f);if(!g)return;const v="Relative"!==e.anchorPointUnits,O=h.getNumericValue(y.width,c.defaultCIMValues.CIMSolidStroke.width),{frameSizeRatio:M,anchorX:S,anchorY:C,widthRatio:_,sdfPaddingRatio:k}=u.getSDFMetrics(g,e.frame,e.size,e.anchorPoint,v,O,e.scaleSymbolsProportionally),{path:P}=d,b=d.primitiveName,z=y.primitiveName,V=i.primitiveName;let x=null;d.colorLocked||m||(x=this._maybeGetValueOrOverrideExpression(V,"FillColor"));const I=x??this._getValueOrOverrideExpression(d.type,b,"Color",h.normalizeAlpha(d.color));let E=null;y.colorLocked||m||(E=this._maybeGetValueOrOverrideExpression(V,"StrokeColor"));const L=E??this._getValueOrOverrideExpression(y.type,z,"Color",h.normalizeAlpha(y.color)),N=this._maybeGetValueOrOverrideExpression(V,"StrokeWidth")??this._getValueOrOverrideExpression(y.type,z,"Width",O),A={type:"sprite-rasterization-param",resource:P?{type:"path",path:P,asFill:!0}:{type:"sdf",geom:f,sdfPaddingRatio:k,asFill:!0},overrides:[]};this._cimLayers.push({type:"marker",spriteRasterizationParam:A,colorLocked:m,effects:t,scaleSymbolsProportionally:!!e.scaleSymbolsProportionally,alignment:a,anchorPoint:{x:S,y:C},isAbsoluteAnchorPoint:v,size:n,rotation:0,offsetX:0,offsetY:0,scaleX:1,transform:{type:"cim-marker-transform-param",params:l},frameHeight:n,widthRatio:_,rotateClockwise:!1,referenceSize:s,sizeRatio:M,color:I,outlineColor:L,outlineWidth:N,isOutline:p,markerPlacement:r})}_setPoMap(e,t,r){let i;this._poMap[e]?i=this._poMap[e]:(i={},this._poMap[e]=i),i[t]=r}_maybeGetValueOrOverrideExpression(e,t,r){return this._getValueOrOverrideExpression("",e,t,r,!1)}_getValueOrOverrideExpression(e,t,r,i,o=!0){if(o&&!h.isValidCIMValue(i)&&(i=h.getDefaultCIMValue(e,r.toLowerCase())),null==t)return i;const a=this._poMap[t];if(null==a)return i;const s=a[r];return"string"==typeof s||"number"==typeof s||Array.isArray(s)?s:s?{valueExpressionInfo:s,defaultValue:i}:i}_analyzePrimitiveOverrides(e,t,r,i){if(null==e)return!1;"string"==typeof e&&(e=[e]);for(const o of this._primitiveOverrides)if(e.includes(o.primitiveName)&&o.valueExpressionInfo)return!0;if(null!=t)for(const o of t)if(o?.overrides.length>0)return!0;if(null!=r)for(const o of r)if(o?.overrides.length>0)return!0;if(null!=i)for(const o of i)if(o?.overrides.length>0)return!0;return!1}_getMaterialOverrides(e,t){if(!e)return[];const r=[];for(const i of e)r.push(...this._getPrimitiveMaterialOverrides(i,t));return r}_getPrimitiveMaterialOverrides(e,t){if(!e)return[];const r=h.normalizePrimitiveOverrideProps(this._primitiveOverrides.filter((t=>t.primitiveName===e)));return r.forEach((e=>e.defaultValue=h.getDefaultCIMValue(t,e.propertyName.toLowerCase()))),r}_analyzeMaterialOverrides(e,t){return this._primitiveOverrides.filter((r=>r.primitiveName!==e||!t.includes(r.propertyName)))}}function O(e,t){return{type:e.type,enable:!0,name:e.name,colorLocked:e.colorLocked,primitiveName:e.primitiveName,anchorPoint:e.anchorPoint,anchorPointUnits:e.anchorPointUnits,offsetX:0,offsetY:0,rotateClockwise:e.rotateClockwise,rotation:0,size:e.size,billboardMode3D:e.billboardMode3D,depth3D:e.depth3D,frame:e.frame,markerGraphics:[t],scaleSymbolsProportionally:e.scaleSymbolsProportionally,respectFrame:e.respectFrame,clippingPath:e.clippingPath}}function M(e){if(e&&0===e.indexOf("Level_")){const t=parseInt(e.slice(6),10);if(!isNaN(t))return t}return 0}function S(e,t){if(!t||0===t.length)return e;const r=i.clone(e);return p.OverrideHelper.applyOverrides(r,t),r}const C=e=>e&&2===e.length&&e[0].enable&&e[1].enable&&"CIMSolidStroke"===e[0].type&&"CIMSolidFill"===e[1].type&&null==e[0].path&&null==e[1].path&&!e[0].effects&&!e[1].effects&&!e[0].animations&&!e[1].animations;function _(e){const t=e.symbolLayers;if(!t)return!1;const r=t.find((e=>e.effects?.find((e=>"CIMGeometricEffectDashes"===e.type&&null!=e.dashTemplate)))),i=t.find((e=>e.effects?.find((e=>"CIMGeometricEffectAddControlPoints"===e.type))));return!!r||!!i}function k(e){return i.clone(e).map((e=>({...e,propertyName:h.uncapitalize(e.propertyName)})))}function P(e){return l.shouldUseAnimatedPath(e)?{type:"animation-params",params:e}:null}e.CIMAnalyzer=v,e.analyzeCIMResource=S,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
