/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../chunks/tslib.es6","../../kernel","../../core/Collection","../../core/Error","../../core/Evented","../../core/Loadable","../../core/Logger","../../core/MapUtils","../../core/Promise","../../core/promiseUtils","../../core/ReactiveMap","../../core/reactiveUtils","../../core/urlUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../../core/support/UpdatingHandles","../../layers/support/arcgisLayerUrl","../../layers/support/layerUtils","../../portal/Portal","../../portal/support/utils","../../rest/featureService/FeatureService","./ServiceVersionInfo","../../versionManagement/VersionManagementService"],(function(e,i,r,n,s,t,o,a,d,c,v,l,p,u,h,f,g,y,w,m,S,_,I,b,L,V){"use strict";function U(e){return!e||0===e.trim().length}const A=new Map;function T(i){return d.getOrCreateMapValue(A,i,(()=>{const r=new e.Services({view:i});return i.addHandles({remove(){A.delete(i),r.destroy()}}),r.load().catch((e=>{a.getLogger("esri.views.Services").error("Failed to load service metadata",e)})),r}))}e.Services=class extends(o.LoadableMixin(c.EsriPromiseMixin(t.EventedAccessor))){constructor(e){super(e),this._updatingHandles=new w.UpdatingHandles,this.items=new n,this.tablesAndLayersLookup=new l,this.additionalLayers=new n,this._debouncedCheckAndUpdateServiceInfos=v.debounce((async()=>{const e=[];for(const i of this.items){if(0===i.layersAndTables.length)continue;const r=i.layersAndTables.getItemAt(0);r?.gdbVersion!==i.versionInfo?.versionIdentifier.name&&e.push(i)}0!==e.length&&(await p.whenOnce((()=>!this.updating)),await this._updateVersionInfos(e))})),this._debouncedLayersChanged=v.debounce((async()=>{const e=this._detectNewLayersAndTables();0!==e.length&&(await p.whenOnce((()=>!this.updating)),await this._updatingHandles.addPromise((async()=>{for(const i of e)if("feature"===i.type||"subtype-group"===i.type){if(!i.url)continue;const e=m.parse(i.url).url.path,r=this._findServiceInfo(e);r?(this.tablesAndLayersLookup.set(i,r),i.isTable?r.tables.push(i):r.layers.push(i)):await this._addServiceInfo(e,i)}})()))})),this._processed=new Set}destroy(){this._set("view",null),this.items.removeAll(),this.tablesAndLayersLookup.clear()}async load(e){return v.throwIfAborted(e),this.addHandles([p.watch((()=>this._allLayersAndTables),(()=>{this._debouncedLayersChanged().catch((e=>{a.getLogger(this).warn("Failed to update service info",e)}))})),p.watch((()=>this.items.map((e=>e.layersAndTables.map((e=>e.gdbVersion??"")).join(",")))),(()=>{this.checkAndUpdateServiceInfos().catch((e=>{a.getLogger(this).warn("Failed to update service info",e)}))}))]),this._debouncedLayersChanged(),this}get updating(){return"loading"===this.loadStatus||this._updatingHandles.updating}checkAndUpdateServiceInfos(){return this._debouncedCheckAndUpdateServiceInfos()}changeVersion(e,i,r){return this._updatingHandles.addPromise((async()=>{await this._changeVersionInternal(e,i,r)})())}createVersion(e){return this._updatingHandles.addPromise((async()=>{const i=e.featureServerUrl,r=this._findServiceInfo(i);if(!r?.versionService)throw new s("services:no-version-management-service");const n=r.hasAdvancedEditingUserTypeExtension,t=r.loggedInServiceUser.toUpperCase(),o=U(e.ownerName)?t:e.ownerName?.trim().toUpperCase();if(o!==t){if(r.featureServiceVersion<=11.1)throw new s("services:versioning-api-error");if(!n)throw new s("services:no-advanced-editing-user-type-extension")}if("SDE"===o?.toUpperCase()&&"DEFAULT"===e.versionName.toUpperCase())throw new s("services:no-valid-version-name");{const i=await r.versionService.getVersionInfos();if(i?.find((i=>i.versionIdentifier.name.toUpperCase()===(o+"."+e.versionName).toUpperCase()||i.versionIdentifier.name.toUpperCase()===(t+"."+e.versionName).toUpperCase())))throw new s("services:no-valid-version-name")}const a=await r.versionService.createVersion({versionName:e.versionName,access:o!==t?"public":e.access,description:e.description});if(o!==t){const{guid:i,name:n}=a.versionIdentifier;await r.versionService.alterVersion({guid:i,name:n},{ownerName:o,access:e.access})}e.switchToVersion&&await this._changeVersionInternal(i,a.versionIdentifier.name,a.versionIdentifier.guid),this.emit("version-created",{versionIdentifier:a.versionIdentifier,versionManagementService:r.versionService})})())}deleteVersion(e,i,r){return this._updatingHandles.addPromise((async()=>{const n=this._findServiceInfo(e);if(!n?.versionService)throw new s("services:no-version-management-service");if(n.featureServiceVersion<=11.1)throw new s("services:versioning-api-error");if(!n.hasAdvancedEditingUserTypeExtension)throw new s("services:no-advanced-editing-user-type-extension");const t={name:i,guid:r};await n.versionService.deleteVersion(t)&&(await this._updateVersionInfo(n),this.emit("version-deleted",{versionIdentifier:t,versionManagementService:n.versionService}))})())}startEditing(e){return this._updatingHandles.addPromise((async()=>{const i=this._findServiceInfo(e);if(!i?.versionService)throw new s("services:no-version-management-service");if(!i.hasAdvancedEditingUserTypeExtension)throw new s("services:no-advanced-editing-user-type-extension");const r=i.versionInfo?.versionIdentifier??{name:i.versionService.defaultVersionIdentifier.name,guid:i.versionService.defaultVersionIdentifier.guid};let n=!0;("none"!==i.versionService.getLockType(r)||(n=await i.versionService.startReading(r),n))&&(n=await i.versionService.startEditing(r),i.updateLockType())})())}finishEditing(e,i){return this._updatingHandles.addPromise((async()=>{const r=this._findServiceInfo(e);if(!r?.versionService)throw new s("services:no-version-management-service");if(!r.hasAdvancedEditingUserTypeExtension)throw new s("services:no-advanced-editing-user-type-extension");const n=r.versionInfo?.versionIdentifier??{name:r.versionService.defaultVersionIdentifier.name,guid:r.versionService.defaultVersionIdentifier.guid},t=r.versionService.getLockType(n);if("none"!==t)return"read"===t?(await r.versionService.stopReading(n),void r.updateLockType()):"edit"===t?(await r.versionService.stopEditing(n,i),await r.versionService.stopReading(n),void r.updateLockType()):void 0})())}async _changeVersionInternal(e,i,r){const n=this._findServiceInfo(e);if(!n?.versionService)throw new s("services:no-version-management-service");const t=n.versionInfo?.versionIdentifier??{name:n.versionService.defaultVersionIdentifier.name,guid:n.versionService.defaultVersionIdentifier.guid},o={name:i,guid:r};await n.versionService.changeVersion(this.view?.map,t,o)&&await this._updateVersionInfo(n)}async _updateVersionInfo(e){const i=e.versionService;if(!i)return;if(0===e.layersAndTables.length)return;const r=e.layersAndTables.getItemAt(0)?.gdbVersion,n=r?await i.getVersionIdentifierFromName(r):i.defaultVersionIdentifier;e.versionInfo=await i.getVersionInfoExtended(n)}_findServiceInfo(e){return this.items.find((i=>i.featureService.url===e))??null}_removeFeatureService(e){this.items.remove(e)}async _findPortal(e){const i=r.id?.findServerInfo(e??"");if(!i?.owningSystemUrl)return null;const n=`${i.owningSystemUrl}/sharing/rest`,s=_.getDefault();if(s?.loaded&&u.normalize(s.restUrl)===u.normalize(n))return s;return new _({authMode:"immediate",url:i.owningSystemUrl}).load()}_updateVersionInfos(e){return this._updatingHandles.addPromise((async()=>{for(const i of e)await this._updateVersionInfo(i).catch((e=>{a.getLogger(this).error("Failed to update version details",e)}))})())}async _addServiceInfo(e,i){const r=new b({url:e});await r.load();const s=await this._findPortal(e),t=s?.user?.username;let o=!1;t&&(o=await I.hasUserTypeExtension(s,t,"advediting"));let a=null;r.versionManagementServiceUrl&&(a=new V({url:r.versionManagementServiceUrl}),await a.load());const d=i.isTable?[]:[i],c=i.isTable?[i]:[],v=new L.ServiceVersionInfo({loggedInServiceUser:t??"",hasAdvancedEditingUserTypeExtension:o,versionInfo:null,lockType:"none",canEditVersionedData:!0,canCreateVersion:!0,featureService:r,versionService:a,layers:new n(d),tables:new n(c)});return a&&await this._updateVersionInfo(v),this.items.push(v),this.tablesAndLayersLookup.set(i,v),i.isTable?v.tables.push(i):v.layers.push(i),v}get _allLayersAndTables(){return[...this.view.map.allLayers,...this.view.map.allTables,...this.additionalLayers]}_detectNewLayersAndTables(){const e=new Set(this._allLayersAndTables),i=[];for(const r of e)"feature"!==r.type&&"subtype-group"!==r.type||this._processed.has(r)||i.push(r);for(const r of this._processed)if(!e.has(r)&&(S.isSubtypeGroupLayer(r)||S.isFeatureLayer(r))){const e=this.tablesAndLayersLookup.get(r);if(!e)continue;this.tablesAndLayersLookup.delete(r),r.isTable?e.tables.remove(r):e.layers.remove(r),0===e.layersAndTables.length&&this._removeFeatureService(e)}return this._processed=e,i}},i.__decorate([h.property({constructOnly:!0})],e.Services.prototype,"view",void 0),i.__decorate([h.property()],e.Services.prototype,"items",void 0),i.__decorate([h.property()],e.Services.prototype,"tablesAndLayersLookup",void 0),i.__decorate([h.property()],e.Services.prototype,"additionalLayers",void 0),i.__decorate([h.property()],e.Services.prototype,"updating",null),i.__decorate([h.property()],e.Services.prototype,"_allLayersAndTables",null),e.Services=i.__decorate([y.subclass("esri.undoredo.support.Services")],e.Services),e.getServices=T,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
