/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../geometry","../../Viewpoint","../../core/Accessor","../../core/has","../../core/maybe","../../core/scheduling","../../core/screenUtils","../../core/time","../../core/accessorSupport/decorators/property","../../core/Logger","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../../core/libs/gl-matrix-2/factories/vec2f64","../ViewAnimation","./PaddedViewState","./unitBezier","./viewpointUtils","./pointToPoint/Camera","../animation/pointToPoint/Animation","../animation/pointToPoint/Settings","../../geometry/Point"],(function(t,i,e,n,s,o,a,r,c,h,u,p,d,m,l,w,_,g,v,f,y,S){"use strict";const T=2e3,x=64;class b{constructor(t){this._view=t,this._animation=new f.Animation((()=>new v.Camera(this._view))),this._current=new v.Camera(this._view)}get _source(){return this._animation.definition.source}get _target(){return this._animation.definition.target}get duration(){return this._animation.time}get animation(){return this._animation}update(t,i,e={}){g.copy(this._current.viewpoint,t),g.copy(this._source.viewpoint,t),g.copy(this._target.viewpoint,i),this._animation.update(this._source,this._target,e)}applyRatio(t,i){this._animation.cameraAt(i,this._current),g.copy(t,this._current.viewpoint)}}let F=class extends n{constructor(t){super(t),this._animation=null,this._destinationViewState=new w,this.updateFunction=null,this.easing=_.easingFunctions.ease,this.viewpoint=new e({targetGeometry:new S,scale:0,rotation:0}),this._updateTask=a.addFrameTask({postRender:this._postRender.bind(this)}),this._updateTask.pause(),this._transition=new b(t.view)}destroy(){this._updateTask=o.removeMaybe(this._updateTask)}get animation(){return this._animation}set animation(t){this._animation=t,this.view.animation=t}animate(t,i,e){this.stop();const n=this.viewpoint;g.copy(n,i);const s=("string"==typeof e?.easing?_.parse(e.easing):e?.easing)||this.easing,o=t.target;this._transition.update(this.viewpoint,o,{apex:{maximumDistance:Math.min(Math.min(i.scale,o.scale)*x,this.view.constraints.effectiveMinScale),desiredSlope:5e-8},duration:e?.duration,maxDuration:"auto"===e?.animationMode?c.Milliseconds(1/0):e?.maxDuration??y.defaultSettings2D.maxDuration,speedFactor:e?.speedFactor,easing:"function"==typeof s?t=>s(t):void 0}),"auto"===e?.animationMode&&(this._destinationViewState.copy(this.view.state),this._destinationViewState.viewpoint=o,k(this._transition.animation,e,this.view.state,this._destinationViewState)||this._transition.update(this.viewpoint,o,{duration:c.Milliseconds(0)}));const a=()=>{this.animation===t&&this._updateTask&&("finished"===t.state&&(this._transition.applyRatio(this.viewpoint,1),this.view.state&&(this.view.state.viewpoint=this.viewpoint.clone())),this.animation=null,this.updateFunction=null)};return t.when(a,a),this._startTime=performance.now(),this._updateTask.resume(),this.animation=t,t}animateContinuous(t,i){this.stop(),this.updateFunction=i,this.viewpoint=t;const e=new l({target:t.clone()}),n=()=>{this.animation===e&&this._updateTask&&(this.animation=null,this.updateFunction=null)};return e.when(n,n),this._startTime=performance.now(),this._updateTask.resume(),this.animation=e,e}stop(){this.animation&&(this.animation.stop(),this.animation=null,this.updateFunction=null)}_postRender(t){const i=this.animation;if(i&&i.state!==l.State.STOPPED){if(this.updateFunction)this.updateFunction(this.viewpoint,t.deltaTime),this.animation?.update(this.viewpoint);else{const t=performance.now()-this._startTime,i=this._transition.duration,e=i>0?t/i:1,n=e>=1;this._transition.applyRatio(this.viewpoint,e),n&&this.animation?.finish()}this.view.state&&(this.view.state.viewpoint=this.viewpoint.clone())}else this._updateTask.pause()}};function k(t,i,e,n){if(null!=i?.duration)return!0;const{time:o,isLinear:a}=t,c=i?.speedFactor||1,h=i?.maxDuration??y.defaultSettings2D.maxDuration/c;if(s("esri-goto-debug")&&(console.log("speed factor:",c),console.log("adjusted duration:\t\t",o),console.log("adjusted max duration:\t",h),console.log("is linear:",a)),o>h)return s("esri-goto-debug")&&console.warn(`failed "auto" heuristic: animations must be shorter than ${h/1e3}s`),!1;if(a){const t=1.5,i=m.create(),a=r.createScreenPoint(...n.toScreen(i,...e.center)),u=r.createScreenPoint(...e.toScreen(i,...n.center)),p=null!=u&&u.x>-(t-.5)*e.size[0]&&u.x<(t+.5)*e.size[0]&&u.y>-(t-.5)*e.size[1]&&u.y<(t+.5)*e.size[1],d=null!=a&&a.x>-(t-.5)*n.size[0]&&a.x<(t+.5)*n.size[0]&&a.y>-(t-.5)*n.size[1]&&a.y<(t+.5)*n.size[1];if(s("esri-goto-debug")&&(console.log(`dest is within ${t} screens at start view:`,p),console.log(`start is within ${t} screens at dest view:`,d)),o>T/c&&!p&&!d)return s("esri-goto-debug")&&console.warn(`failed "auto" heuristic: linear animations must be...\n  - shorter than ${T/1e3/c}s, or\n  - shorter than ${h/1e3}s and the destination is close enough to the starting screen, or\n  - shorter than ${h/1e3}s and the start point is close enough to the destination screen`),!1}return!0}t.__decorate([h.property()],F.prototype,"easing",void 0),t.__decorate([h.property()],F.prototype,"view",void 0),t.__decorate([h.property()],F.prototype,"viewpoint",void 0),F=t.__decorate([d.subclass("esri.views.2d.AnimationManager")],F);return F}));
