/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../geometry/support/TileClipper","./GeometryUtils","./TextShaping","./decluttering/config","./style/StyleDefinition"],(function(e,t,i,n,o,l){"use strict";const a=4096,s=512,h=8,c=.5,r=2;class y{constructor(e,t,i=0,n=-1,o=c){this.x=e,this.y=t,this.angle=i,this.segment=n,this.minzoom=o}}class m{constructor(e,t,n,o,l,a=c,s=i.cInfinity){this.anchor=e,this.labelAngle=t,this.glyphAngle=n,this.page=o,this.alternateVerticalGlyph=l,this.minzoom=a,this.maxzoom=s}}class d{constructor(e,t,i,n,o,l,a,s,h,c,r,y){this.tl=e,this.tr=t,this.bl=i,this.br=n,this.mosaicRect=o,this.labelAngle=l,this.minAngle=a,this.maxAngle=s,this.anchor=h,this.minzoom=c,this.maxzoom=r,this.page=y}}class g{constructor(e){this.shapes=e}}class x{getIconPlacement(e,n,a){const s=new t.Point(e.x,e.y),h=a.rotationAlignment===l.RotationAlignment.MAP,c=a.keepUpright;let r=a.rotate*i.cDegToRad;h&&(r+=e.angle);const y=new g([]);return a.allowOverlap&&a.ignorePlacement||!o.declutterTiles||(y.iconColliders=[]),this._addIconPlacement(y,s,n,a,r),h&&c&&this._addIconPlacement(y,s,n,a,r+i.cPi),y}_addIconPlacement(e,n,a,s,h){const r=a.rasterizationScale,y=a.width/r,m=a.height/r,g=s.offset;let x=g[0],p=g[1];switch(s.anchor){case l.SymbolAnchor.CENTER:x-=y/2,p-=m/2;break;case l.SymbolAnchor.LEFT:p-=m/2;break;case l.SymbolAnchor.RIGHT:x-=y,p-=m/2;break;case l.SymbolAnchor.TOP:x-=y/2;break;case l.SymbolAnchor.BOTTOM:x-=y/2,p-=m;break;case l.SymbolAnchor.TOP_LEFT:break;case l.SymbolAnchor.BOTTOM_LEFT:p-=m;break;case l.SymbolAnchor.TOP_RIGHT:x-=y;break;case l.SymbolAnchor.BOTTOM_RIGHT:x-=y,p-=m}const P=a.rect,T=2/r,w=x-T,f=p-T,b=w+P.width/r,I=f+P.height/r,u=new t.Point(w,f),A=new t.Point(b,I),S=new t.Point(w,I),O=new t.Point(b,f);if(0!==h){const e=Math.cos(h),t=Math.sin(h);u.rotate(e,t),A.rotate(e,t),S.rotate(e,t),O.rotate(e,t)}const G=new d(u,O,S,A,P,h,0,256,n,c,i.cInfinity,0);if(e.shapes.push(G),(!s.allowOverlap||!s.ignorePlacement)&&o.declutterTiles){const t=s.size,o=s.padding,l={xTile:n.x,yTile:n.y,dxPixels:x*t-o,dyPixels:p*t-o,hard:!s.optional,partIndex:0,width:y*t+2*o,height:m*t+2*o,angle:h,minLod:c,maxLod:i.cInfinity};e.iconColliders.push(l)}}getTextPlacement(e,o,a,s){const y=new t.Point(e.x,e.y),x=s.rotate*i.cDegToRad,p=s.rotationAlignment===l.RotationAlignment.MAP,P=s.keepUpright,T=s.padding;let w=c;const f=!p?0:e.angle,b=e.segment>=0&&p,I=s.allowOverlap&&s.ignorePlacement?null:[],u=[],A=4,S=!b;let O=Number.POSITIVE_INFINITY,G=Number.NEGATIVE_INFINITY,M=O,_=G;const k=(b||p)&&P,z=s.size/n.sdfGlyphSize;let E=!1;for(const t of o)if(t.vertical){E=!0;break}let N,L=0,R=0;if(!b&&E){const e=n.TextShaping.getTextBox(o,s.lineHeight*n.sdfGlyphSize);switch(s.anchor){case l.SymbolAnchor.LEFT:L=e.height/2,R=-e.width/2;break;case l.SymbolAnchor.RIGHT:L=-e.height/2,R=e.width/2;break;case l.SymbolAnchor.TOP:L=e.height/2,R=e.width/2;break;case l.SymbolAnchor.BOTTOM:L=-e.height/2,R=-e.width/2;break;case l.SymbolAnchor.TOP_LEFT:L=e.height;break;case l.SymbolAnchor.BOTTOM_LEFT:R=-e.width;break;case l.SymbolAnchor.TOP_RIGHT:R=e.width;break;case l.SymbolAnchor.BOTTOM_RIGHT:L=-e.height}}L+=s.offset[0]*n.sdfGlyphSize,R+=s.offset[1]*n.sdfGlyphSize;for(const l of o){const o=l.glyphMosaicItem;if(!o||o.rect.isEmpty)continue;const g=o.rect,v=o.metrics,F=o.page;if(I&&S){if(void 0!==N&&N!==l.y){let t,n,o,l;E?(t=-_+L,n=O+R,o=_-M,l=G-O):(t=O+L,n=M+R,o=G-O,l=_-M);const a={xTile:e.x,yTile:e.y,dxPixels:t*z-T,dyPixels:n*z-T,hard:!s.optional,partIndex:1,width:o*z+2*T,height:l*z+2*T,angle:x,minLod:c,maxLod:i.cInfinity};I.push(a),O=Number.POSITIVE_INFINITY,G=Number.NEGATIVE_INFINITY,M=O,_=G}N=l.y}const B=[];if(b){const t=.5*o.metrics.width,i=(l.x+v.left-A+t)*z*h;if(w=this._placeGlyph(e,w,i,a,e.segment,1,l.vertical,F,B),P&&(w=this._placeGlyph(e,w,i,a,e.segment,-1,l.vertical,F,B)),w>=r)break}else B.push(new m(y,f,f,F,!1)),p&&P&&B.push(new m(y,f+i.cPi,f+i.cPi,F,!1));const H=l.x+v.left,V=l.y-n.sdfGlyphBaseline-v.top,C=H+v.width,Y=V+v.height;let q,D,U,j,J,K,Q,W;if(!b&&E)if(l.vertical){const e=(H+C)/2-v.height/2,i=(V+Y)/2+v.width/2;q=new t.Point(-i-A+L,e-A+R),D=new t.Point(q.x+g.width,q.y+g.height),U=new t.Point(q.x,D.y),j=new t.Point(D.x,q.y)}else q=new t.Point(-V+A+L,H-A+R),D=new t.Point(q.x-g.height,q.y+g.width),U=new t.Point(D.x,q.y),j=new t.Point(q.x,D.y);else q=new t.Point(H-A+L,V-A+R),D=new t.Point(q.x+g.width,q.y+g.height),U=new t.Point(q.x,D.y),j=new t.Point(D.x,q.y);for(const i of B){let n,o,a,h;if(i.alternateVerticalGlyph){if(!J){const e=(H+C)/2+L,i=(V+Y)/2+R;J=new t.Point(e-v.height/2-A,i+v.width/2+A),K=new t.Point(J.x+g.height,J.y-g.width),Q=new t.Point(K.x,J.y),W=new t.Point(J.x,K.y)}n=J,o=Q,a=W,h=K}else n=q,o=U,a=j,h=D;const c=V,y=Y,m=i.glyphAngle+x;if(0!==m){const e=Math.cos(m),t=Math.sin(m);n=n.clone(),o=o?.clone(),a=a?.clone(),h=h?.clone(),n.rotate(e,t),h?.rotate(e,t),o?.rotate(e,t),a?.rotate(e,t)}let p=0,P=256;if(b&&E?l.vertical?i.alternateVerticalGlyph?(p=32,P=96):(p=224,P=32):(p=224,P=96):(p=192,P=64),u.push(new d(n,a,o,h,g,i.labelAngle,p,P,i.anchor,i.minzoom,i.maxzoom,i.page)),I&&(!k||this._legible(i.labelAngle)))if(S)H<O&&(O=H),c<M&&(M=c),C>G&&(G=C),y>_&&(_=y);else if(i.minzoom<r){const t={xTile:e.x,yTile:e.y,dxPixels:(H+L)*z-T,dyPixels:(c+L)*z-T,hard:!s.optional,partIndex:1,width:(C-H)*z+2*T,height:(y-c)*z+2*T,angle:m,minLod:i.minzoom,maxLod:i.maxzoom};I.push(t)}}}if(w>=r)return null;if(I&&S){let t,n,o,l;E?(t=-_+L,n=O+R,o=_-M,l=G-O):(t=O+L,n=M+R,o=G-O,l=_-M);const a={xTile:e.x,yTile:e.y,dxPixels:t*z-T,dyPixels:n*z-T,hard:!s.optional,partIndex:1,width:o*z+2*T,height:l*z+2*T,angle:x,minLod:c,maxLod:i.cInfinity};I.push(a)}const v=new g(u);return I&&I.length>0&&(v.textColliders=I),v}_legible(e){const t=i.radToByte(e);return t<65||t>=193}_placeGlyph(e,n,o,l,a,s,h,c,r){let y=s;const d=y<0?i.positiveMod(e.angle+i.cPi,i.c2pi):e.angle;let g=0;o<0&&(y*=-1,o*=-1,g=i.cPi),y>0&&++a;let x=new t.Point(e.x,e.y),p=l[a],P=i.cInfinity;if(l.length<=a)return P;for(;;){const e=p.x-x.x,t=p.y-x.y,s=Math.sqrt(e*e+t*t),T=Math.max(o/s,n),w=e/s,f=t/s,b=i.positiveMod(Math.atan2(f,w)+g,i.c2pi);if(r.push(new m(x,d,b,c,!1,T,P)),h&&r.push(new m(x,d,b,c,!0,T,P)),T<=n)return T;x=p.clone();do{if(a+=y,l.length<=a||a<0)return T;p=l[a]}while(x.isEqual(p));let I=p.x-x.x,u=p.y-x.y;const A=Math.sqrt(I*I+u*u);I*=s/A,u*=s/A,x.x-=I,x.y-=u,P=T}}}e.Anchor=y,e.PlacedSymbol=d,e.Placement=g,e.PlacementEngine=x,e.tileCoordSize=a,e.tilePixelRatio=h,e.tilePixelSize=s,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
