/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../core/LRUCache","../../../../geometry/support/aaBoundingRect","../../tiling/TileCoverage","../../tiling/TileKey"],(function(e,i,t,l,s){"use strict";const o=512,n=1e-6,r=(e,i)=>e+1/(1<<2*i);class a{constructor(e,t){this._tiles=new Map,this._tileCache=new i.LRUCache(40,(e=>e.dispose())),this._viewSize=[0,0],this._visibleTiles=new Map,this.acquireTile=e.acquireTile,this.releaseTile=e.releaseTile,this.tileInfoView=e.tileInfoView,this._container=t}destroy(){for(const e of this._tiles.values())e.dispose();this._tiles=null,this._tileCache.clear(),this._tileCache=null}update(e){this._updateCacheSize(e);const i=this.tileInfoView,t=i.getTileCoverage(e.state,0,!0,"smallest");if(!t)return!0;const{spans:o,lodInfo:n}=t,{level:r}=n,a=this._tiles,c=new Set,h=new Set;for(const{row:l,colFrom:_,colTo:f}of o)for(let e=_;e<=f;e++){const i=s.getId(r,l,n.normalizeCol(e),n.getWorldForColumn(e)),t=this._getOrAcquireTile(i);c.add(i),t.processed()?this._addToContainer(t):h.add(new s(i))}for(const[l,s]of a)s.isCoverage=c.has(l);for(const l of h)this._findPlaceholdersForMissingTiles(l,c);let d=!1;for(const[l,s]of a)s.neededForCoverage=c.has(l),s.neededForCoverage||s.isHoldingForFade&&i.intersects(t,s.key)&&c.add(l),s.isFading&&(d=!0);for(const l of this._tiles.keys())c.has(l)||this._releaseTile(l);return l.pool.release(t),!d}clear(){this._tiles.clear(),this._tileCache.clear(),this._visibleTiles.clear()}clearCache(){this._tileCache.clear()}getIntersectingTiles(e,i,l,s,o){const n=[0,0],r=[0,0];s.toMap(n,e-l,i+l),s.toMap(r,e+l,i-l);const a=Math.min(n[0],r[0]),c=Math.min(n[1],r[1]),h=Math.max(n[0],r[0]),d=Math.max(n[1],r[1]),_=t.fromValues(a,c,h,d),f=t.create(),u=[];for(const T of this._visibleTiles.values())this.tileInfoView.getTileBounds(f,T.key),t.intersects(_,f)&&u.push(T);if(null!=o&&o.length>0){const e=new Set(u.map((e=>e.id))),i=o.filter((i=>!e.has(i.tileKey.id))).map((e=>this._visibleTiles.get(e.tileKey.id))).filter((e=>void 0!==e));u.push(...i)}return u}_findPlaceholdersForMissingTiles(e,i){const t=[];for(const s of this._tiles.values())this._addPlaceholderChild(t,s,e,i);const l=t.reduce(r,0);Math.abs(1-l)<n||this._addPlaceholderParent(e.id,i)}_addPlaceholderChild(e,i,t,l){i.key.level<=t.level||!i.hasData()||h(t,i.key)&&(this._addToContainer(i),l.add(i.id),e.push(i.key.level-t.level))}_addPlaceholderParent(e,i){const t=this._tiles;let l=e;for(;;){if(l=c(l),!l||i.has(l))return;const e=t.get(l);if(e?.hasData())return this._addToContainer(e),void i.add(e.id)}}_getOrAcquireTile(e){let i=this._tiles.get(e);return i||(i=this._tileCache.pop(e),i||(i=this.acquireTile(new s(e))),this._tiles.set(e,i),i)}_releaseTile(e){const i=this._tiles.get(e);this.releaseTile(i),this._removeFromContainer(i),this._tiles.delete(e),i.hasData()?this._tileCache.put(e,i,1):i.dispose()}_addToContainer(e){let i;const t=[],l=this._container;if(l.contains(e))return;const s=this._visibleTiles;for(const o of s.values())this._canConnectDirectly(e,o)&&t.push(o),null==i&&this._canConnectDirectly(o,e)&&(i=o);if(null!=i){for(const l of t)i.childrenTiles.delete(l),e.childrenTiles.add(l),l.parentTile=e;i.childrenTiles.add(e),e.parentTile=i}else for(const o of t)e.childrenTiles.add(o),o.parentTile=e;s.set(e.id,e),l.addChild(e)}_removeFromContainer(e){if(this._visibleTiles.delete(e.id),this._container.removeChild(e),null!=e.parentTile){e.parentTile.childrenTiles.delete(e);for(const i of e.childrenTiles)null!=e.parentTile&&e.parentTile.childrenTiles.add(i)}for(const i of e.childrenTiles)i.parentTile=e.parentTile;e.parentTile=null,e.childrenTiles.clear()}_canConnectDirectly(e,i){const t=e.key;let{level:l,row:s,col:o,world:n}=i.key;const r=this._visibleTiles;for(;l>0;){if(l--,s>>=1,o>>=1,t.level===l&&t.row===s&&t.col===o&&t.world===n)return!0;if(r.has(`${l}/${s}/${o}/${n}`))return!1}return!1}_updateCacheSize(e){const i=e.state.size;if(i[0]===this._viewSize[0]&&i[1]===this._viewSize[1])return;const t=Math.ceil(i[0]/o)+1,l=Math.ceil(i[1]/o)+1;this._viewSize[0]=i[0],this._viewSize[1]=i[1],this._tileCache.maxSize=5*t*l}}function c(e){const[i,t,l,s]=e.split("/"),o=parseInt(i,10);return 0===o?null:`${o-1}/${parseInt(t,10)>>1}/${parseInt(l,10)>>1}/${parseInt(s,10)}`}function h(e,i){const t=i.level-e.level;return e.row===i.row>>t&&e.col===i.col>>t&&e.world===i.world}e.TileManager=a,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
