/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../geometry/support/aaBoundingRect","../../../../layers/support/TileInfo","./decluttering/SymbolFader","./style/StyleDefinition","../webgl/enums","../webgl/RenderableTile","../webgl/TileContainer","../../tiling/TileCoverage","../../tiling/TileKey","../../../webgl/enums"],(function(e,t,s,r,l,i,n,o,a,d,y){"use strict";const c=1e-6;function h(e,t){if(e){const s=e.getLayoutProperty("visibility");if(!s||s.getValue()!==l.Visibility.NONE&&(void 0===e.minzoom||e.minzoom<t+c)&&(void 0===e.maxzoom||e.maxzoom>=t-c))return!0}return!1}class u extends o{constructor(e){super(e),this._backgroundTiles=[],this._computeDisplayInfoView(e)}destroy(){this.removeAllChildren(),this._spriteMosaic?.dispose(),this._spriteMosaic=null,this._glyphMosaic?.dispose(),this._glyphMosaic=null,null!=this._symbolFader&&(this._symbolFader.clear(),this._symbolFader=null),this._styleRepository=null,this._backgroundTiles=[]}get fading(){return this._symbolFader?.fading??!1}get symbolFader(){return this._symbolFader}get symbolRepository(){return this._symbolFader?.symbolRepository}setStyleResources(e,t,s,l){this._spriteMosaic=e,this._glyphMosaic=t,this._styleRepository=s,this.tileInfoView=l,this._computeDisplayInfoView(l),null==this._symbolFader&&(this._symbolFader=new r.SymbolFader(this._styleRepository,this.children)),this._symbolFader.styleRepository=s}setSpriteMosaic(e){this._spriteMosaic?.dispose(),this._spriteMosaic=e}deleteStyleLayers(e){null!=this._symbolFader&&this._symbolFader.deleteStyleLayers(e)}createRenderParams(e){return{...super.createRenderParams(e),renderPass:null,styleLayer:null,styleLayerUID:-1,glyphMosaic:this._glyphMosaic,spriteMosaic:this._spriteMosaic,hasClipping:!!this._clippingInfos}}doRender(e){!this.visible||e.drawPhase!==i.WGLDrawPhase.MAP&&e.drawPhase!==i.WGLDrawPhase.DEBUG||void 0===this._spriteMosaic||super.doRender(e)}addChild(e){return super.addChild(e),null!=this._symbolFader?this._symbolFader.addTile(e):e.decluttered=!0,this.requestRender(),e}removeChild(e){return null!=this._symbolFader&&this._symbolFader.removeTile(e),this.requestRender(),super.removeChild(e)}renderChildren(e){const{drawPhase:t}=e;t!==i.WGLDrawPhase.DEBUG?this._doRender(e):super.renderChildren(e)}removeAllChildren(){for(let e=0;e<this.children.length;e++){const t=this.children[e];null!=this._symbolFader&&this._symbolFader.removeTile(t),t.dispose()}super.removeAllChildren()}getStencilTarget(){return this.children.filter((e=>e.neededForCoverage&&e.hasData()))}restartDeclutter(){null!=this._symbolFader&&this._symbolFader.restartDeclutter()}_doRender(e){const{context:t,state:s}=e,r=this._styleRepository;if(!r)return;const l=r.layers,n=this._displayInfo.scaleToZoom(s.scale);r.backgroundBucketIds.length>0&&(e.renderPass="background",this._renderBackgroundLayers(e,r.backgroundBucketIds,n)),super.renderChildren(e),e.drawPhase===i.WGLDrawPhase.MAP&&this._fade(n,s);const o=this.children.filter((e=>e.visible&&e.hasData()));if(!o||0===o.length)return t.bindVAO(),t.setStencilTestEnabled(!0),void t.setBlendingEnabled(!0);for(const i of o)i.triangleCount=0;t.setStencilWriteMask(0),t.setColorMask(!0,!0,!0,!0),t.setStencilOp(y.StencilOperation.KEEP,y.StencilOperation.KEEP,y.StencilOperation.REPLACE),t.setStencilTestEnabled(!0),t.setBlendingEnabled(!1),t.setDepthTestEnabled(!0),t.setDepthWriteEnabled(!0),t.setDepthFunction(y.CompareFunction.LEQUAL),t.setClearDepth(1),t.clear(t.gl.DEPTH_BUFFER_BIT),e.renderPass="opaque";for(let i=l.length-1;i>=0;i--)this._renderStyleLayer(l[i],e,o);t.setDepthWriteEnabled(!1),t.setBlendingEnabled(!0),t.setBlendFunctionSeparate(y.BlendFactor.ONE,y.BlendFactor.ONE_MINUS_SRC_ALPHA,y.BlendFactor.ONE,y.BlendFactor.ONE_MINUS_SRC_ALPHA),e.renderPass="translucent";for(let i=0;i<l.length;i++)this._renderStyleLayer(l[i],e,o);t.bindVAO(),t.setStencilTestEnabled(!0),t.setBlendingEnabled(!0);for(const i of o)i.debugInfo.display.triangleCount=i.triangleCount}_fade(e,t){null!=this._symbolFader&&(this._symbolFader.update(e,t)||this.requestRender())}_renderStyleLayer(e,t,s){const{displayLevel:r,painter:i,renderPass:n}=t;if(void 0===e)return;const o=e.getLayoutProperty("visibility");if(o&&o.getValue()===l.Visibility.NONE)return;let a;switch(e.type){case l.StyleLayerType.BACKGROUND:return;case l.StyleLayerType.FILL:if("opaque"!==n&&"translucent"!==t.renderPass)return;a="vtlFill";break;case l.StyleLayerType.LINE:if("translucent"!==n)return;a="vtlLine";break;case l.StyleLayerType.CIRCLE:if("translucent"!==n)return;a="vtlCircle";break;case l.StyleLayerType.SYMBOL:if("translucent"!==n)return;a="vtlSymbol"}if(s=e.type===l.StyleLayerType.SYMBOL?s.filter((e=>e.decluttered)):s.filter((e=>e.neededForCoverage)),"vtlSymbol"!==a&&(0===s.length||void 0!==e.minzoom&&e.minzoom>=r+c||void 0!==e.maxzoom&&e.maxzoom<r-c))return;const d=e.uid;t.styleLayerUID=d,t.styleLayer=e;for(const l of s)if(l.layerData.has(d)){i.renderObjects(t,s,a);break}}_renderBackgroundLayers(e,s,r){const{context:i,painter:o,state:c}=e,u=this._styleRepository;let p=!1;for(const t of s){if(u.getLayerById(t).type===l.StyleLayerType.BACKGROUND&&h(u.getLayerById(t),r)){p=!0;break}}if(!p)return;const m=this.tileInfoView,b=m.getTileCoverage(e.state,0,!0,"smallest"),{spans:g,lodInfo:_}=b,{level:f}=_,L=t.create(),S=[];if(this._renderPasses){const t=this._renderPasses[0];null!=this._clippingInfos&&(t.brushes[0].prepareState(e),t.brushes[0].drawMany(e,this._clippingInfos))}const F=this._backgroundTiles;let C,T=0;for(const{row:l,colFrom:a,colTo:y}of g)for(let e=a;e<=y;e++){if(T<F.length)C=F[T],C.key.set(f,l,_.normalizeCol(e),_.getWorldForColumn(e)),m.getTileBounds(L,C.key,!1),C.x=L[0],C.y=L[3],C.resolution=m.getTileResolution(f);else{const s=new d(f,l,_.normalizeCol(e),_.getWorldForColumn(e)),r=m.getTileBounds(t.create(),s),i=m.getTileResolution(f);C=new n.RenderableTile(s,i,r[0],r[3],512,512,4096,4096),F.push(C)}C.setTransform(c),S.push(C),T++}i.setStencilWriteMask(0),i.setColorMask(!0,!0,!0,!0),i.setStencilOp(y.StencilOperation.KEEP,y.StencilOperation.KEEP,y.StencilOperation.REPLACE),i.setStencilFunction(y.CompareFunction.EQUAL,0,255),i.setStencilTestEnabled(!0);for(const t of s){const s=u.getLayerById(t);s.type===l.StyleLayerType.BACKGROUND&&h(s,r)&&(e.styleLayerUID=s.uid,e.styleLayer=s,o.renderObjects(e,S,"vtlBackground"))}a.pool.release(b)}_computeDisplayInfoView(e){let t=e.tileInfo.lods[0].scale;const r=Math.max(25,e.tileInfo.lods.length),l=[];for(let s=0;s<=r;s++)l.push(t),t/=2;this._displayInfo=s.create({scales:l,size:512,spatialReference:e.spatialReference,numLODs:r})}}e.VectorTileContainer=u,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
