/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../../Graphic","../../../../core/MapUtils","../../../../core/pbf","../../../../core/libs/rbush/PooledRBush","./enums","./Feature","./GeometryUtils","./SourceLayerData","./style/StyleLayer"],(function(e,t,s,r,i,l,n,o,a){"use strict";const y=8,c=512,u=4096,h=(e,t)=>{const s=e.vtlSymbol.sourceTile,r=t.vtlSymbol.sourceTile;return s.level!==r.level?s.level-r.level:s.row!==r.row?s.row-r.row:s.col!==r.col?s.col-r.col:e.styleLayerUID-t.styleLayerUID};class d{constructor(e,t,s,r,i){this.tileKey=e,this._tileLayerData=t,this._styleRepository=s,this._tileHandler=r,this._parentLayer=i,this._index=null,this._tileKeyToPBF=new Map}static create(e,t,s,r,i){return new d(e,t,s,r,i)}clear(){this._index?.clear(),this._tileKeyToPBF.clear()}async queryAttributes(e,t,s,i,l){if(0===this._tileLayerData.size||!this._styleRepository||!this._tileHandler)return[];null===this._index&&(this._index=new r.PooledRBush(100,f),await this._indexLayers());const n=[];return this._queryIndex(n,e,t,s,this.tileKey.level,i),l&&l?.length>0&&await this._getSymbolsAttributes(n,l),n}async _indexLayers(){const e=this.tileKey,t=this._styleRepository.layers,s=await this._getTilePayload(e);for(const[r,l]of this._tileLayerData){const n=t[r],o=s.find((e=>e.sourceName===n.source));if(!o)continue;const{protobuff:a,key:y}=o;if(l.type!==i.BucketType.SYMBOL){const t=1<<e.level-y.level,s=e.row-y.row*t,r=e.col-y.col*t;this._indexLayer(n,a,e.level,t,s,r)}}}_indexLayer(e,t,r,i,y,h){const d=e.sourceLayer,f=e.getFeatureFilter(),_=r,g=r+1,m=n.getTileMargins(_),w=new s(new Uint8Array(t),new DataView(t));for(;w.next();)switch(w.tag()){case 3:{const t=w.getMessage(),s=new o(t);if(t.release(),s.name!==d)continue;const n=s.getData(),x=s.extent/i,b=x*h-m,p=x*y-m,I=b+x+2*m,L=p+x+2*m,v=x/c,T=u/x,D=x*h,P=x*y;for(;n.nextTag(2);){const t=n.getMessage(),i=new l(t,s);if(t.release(),f&&!f.filter(i,r))continue;const o=i.values||{},y=o._minzoom,c=o._maxzoom;if(y&&y>=10*g||c&&c<=10*_)continue;const u=e.getFeatureInflatedBounds(i,_,s.extent,v);null==u||u[0]>I||u[1]>L||u[2]<b||u[3]<p||(u[0]=(u[0]-D)*T,u[1]=(u[1]-P)*T,u[2]=(u[2]-D)*T,u[3]=(u[3]-P)*T,this._index.insert(new a.IndexItem(e,i,u,T,D,P)))}break}default:w.skip()}}async _getSymbolsAttributes(e,t){if(!t||0===t.length)return e;const s=[];t.sort(h);let r=t[0].styleLayerUID,i=0;for(let a=0;a<t.length;a++)r!==t[a].styleLayerUID&&(s.push({from:i,to:a,styleLayerUID:r,sourceTileKey:t[a].vtlSymbol.sourceTile}),i=a,r=t[a].styleLayerUID);s.push({from:i,to:t.length,styleLayerUID:r,sourceTileKey:t[t.length-1].vtlSymbol.sourceTile});const l=this._styleRepository.layers;let n,o=null;for(const a of s){const s=await this._getTilePayload(a.sourceTileKey);n=l[a.styleLayerUID],o=!!n&&s.find((e=>e.sourceName===n.source)),o&&this._addSymbolsAttributes(e,t.slice(a.from,a.to).map((e=>e.vtlSymbol)),r,o)}return e}_addSymbolsAttributes(t,s,r,i){const l=this._styleRepository.layers,n=i.key,o=this.tileKey,a=1<<o.level-n.level,y=o.row-n.row*a,c=o.col-n.col*a;this._getSymbolAttributes(i.protobuff,s,r,a,y,c).forEach((s=>{const{attributes:i,tilePoint:n}=s;t.push({layerId:l[r].id,layerIndex:r,graphic:new e({attributes:i,origin:{type:"vector-tile",layerId:l[r].id,layerIndex:r,layer:this._parentLayer}}),tilePoint:n})}))}_getSymbolAttributes(e,t,r,i,n,a){const y=[],c=this._styleRepository.layers;let h=0;t.sort(((e,t)=>e.featureIndex-t.featureIndex));const d=new s(new Uint8Array(e),new DataView(e));for(;d.next();)switch(d.tag()){case 3:{const e=d.getMessage(),s=new o(e);if(e.release(),s.name!==c[r].sourceLayer)continue;const f=s.getData(),_=s.extent/i,g=u/_,m=_*a,w=_*n;let x=0;for(;f.nextTag(2);){const e=f.getMessage();if(x++===t[h].featureIndex){const t=new l(e,s),r=t.values,i=t.getGeometry(),n=null!=i?[g*(i[0][0].x-m),g*(i[0][0].y-w)]:null;y.push({attributes:r,tilePoint:n}),h++}if(e.release(),h===t.length)return y}break}default:d.skip()}return y}_queryIndex(t,s,r,i,l,n){const o=y*i*(window.devicePixelRatio||1);return this._index?.search({minX:s-o,minY:r-o,maxX:s+o,maxY:r+o},(o=>{const{layer:a,feature:y}=o;a.isIntersectingFeature(s,r,i,y,l,n,o)&&t.push({layerId:a.id,layerIndex:a.uid,tilePoint:null,graphic:new e({attributes:y.values,origin:{type:"vector-tile",layerId:o.layer.id,layerIndex:o.layer.uid,layer:this._parentLayer}})})})),t}async _getTilePayload(e){return t.getOrCreateMapValue(this._tileKeyToPBF,e.id,(()=>this._tileHandler.fetchTilePBFs(e))).then((e=>e))}}const f=e=>({minX:e.bounds[0],minY:e.bounds[1],maxX:e.bounds[2],maxY:e.bounds[3]});return d}));
