/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../../Color","../../../../../core/colorUtils","../../../../../geometry/support/TileClipper","../../../unitBezier","../GeometryUtils","./types"],(function(t,e,r,n,s,a,o){"use strict";class i{constructor(t){this._parent=t,this._vars={}}add(t,e){this._vars[t]=e}get(t){return this._vars[t]?this._vars[t]:this._parent?this._parent.get(t):null}}class l{constructor(){this.type=o.valueType}static parse(t){if(t.length>1)throw new Error('"id" does not expect arguments');return new l}evaluate(t,e){return t?.id}}class u{constructor(){this.type=o.stringType}static parse(t){if(t.length>1)throw new Error('"geometry-type" does not expect arguments');return new u}evaluate(t,e){if(!t)return null;switch(t.type){case n.GeometryType.Point:return"Point";case n.GeometryType.LineString:return"LineString";case n.GeometryType.Polygon:return"Polygon";default:return null}}}class c{constructor(){this.type=o.objectType}static parse(t){if(t.length>1)throw new Error('"properties" does not expect arguments');return new c}evaluate(t,e){return t?.values}}class h{constructor(){this.type=o.numberType}static parse(t){if(t.length>1)throw new Error('"zoom" does not expect arguments');return new h}evaluate(t,e){return e}}class p{constructor(t,e,r){this._lhs=t,this._rhs=e,this._compare=r,this.type=o.booleanType}static parse(t,e,r){if(3!==t.length&&4!==t.length)throw new Error(`"${t[0]}" expects 2 or 3 arguments`);if(4===t.length)throw new Error(`"${t[0]}" collator not supported`);return new p(et(t[1],e),et(t[2],e),r)}evaluate(t,e){return this._compare(this._lhs.evaluate(t,e),this._rhs.evaluate(t,e))}}class g extends p{static parse(t,e){return p.parse(t,e,((t,e)=>t===e))}}class f extends p{static parse(t,e){return p.parse(t,e,((t,e)=>t!==e))}}class w extends p{static parse(t,e){return p.parse(t,e,((t,e)=>t<e))}}class y extends p{static parse(t,e){return p.parse(t,e,((t,e)=>t<=e))}}class m extends p{static parse(t,e){return p.parse(t,e,((t,e)=>t>e))}}class b extends p{static parse(t,e){return p.parse(t,e,((t,e)=>t>=e))}}class v{constructor(t){this._arg=t,this.type=o.booleanType}static parse(t,e){if(2!==t.length)throw new Error('"!" expects 1 argument');return new v(et(t[1],e))}evaluate(t,e){return!this._arg.evaluate(t,e)}}class _{constructor(t){this._args=t,this.type=o.booleanType}static parse(t,e){const r=[];for(let n=1;n<t.length;n++)r.push(et(t[n],e));return new _(r)}evaluate(t,e){for(const r of this._args)if(!r.evaluate(t,e))return!1;return!0}}class d{constructor(t){this._args=t,this.type=o.booleanType}static parse(t,e){const r=[];for(let n=1;n<t.length;n++)r.push(et(t[n],e));return new d(r)}evaluate(t,e){for(const r of this._args)if(r.evaluate(t,e))return!0;return!1}}class E{constructor(t){this._args=t,this.type=o.booleanType}static parse(t,e){const r=[];for(let n=1;n<t.length;n++)r.push(et(t[n],e));return new E(r)}evaluate(t,e){for(const r of this._args)if(r.evaluate(t,e))return!1;return!0}}class x{constructor(t,e,r){this.type=t,this._args=e,this._fallback=r}static parse(t,e,r){if(t.length<4)throw new Error('"case" expects at least 3 arguments');if(t.length%2==1)throw new Error('"case" expects an odd number of arguments');let n;const s=[];for(let o=1;o<t.length-1;o+=2){const a=et(t[o],e),i=et(t[o+1],e,r);n||(n=i.type),s.push({condition:a,output:i})}const a=et(t[t.length-1],e,r);return n||(n=a.type),new x(n,s,a)}evaluate(t,e){for(const r of this._args)if(r.condition.evaluate(t,e))return r.output.evaluate(t,e);return this._fallback.evaluate(t,e)}}class T{constructor(t,e){this.type=t,this._args=e}static parse(t,e){if(t.length<2)throw new Error('"coalesce" expects at least 1 argument');let r;const n=[];for(let s=1;s<t.length;s++){const a=et(t[s],e);r||(r=a.type),n.push(a)}return new T(r,n)}evaluate(t,e){for(const r of this._args){const n=r.evaluate(t,e);if(null!==n)return n}return null}}class M{constructor(t,e,r,n,s){this.type=t,this._input=e,this._labels=r,this._outputs=n,this._fallback=s}static parse(t,e){if(t.length<3)throw new Error('"match" expects at least 3 arguments');if(t.length%2==0)throw new Error('"case" expects an even number of arguments');let r;const n=et(t[1],e),s=[],a={};let o;for(let i=2;i<t.length-1;i+=2){let n=t[i];Array.isArray(n)||(n=[n]);for(const t of n){const e=typeof t;if("string"!==e&&"number"!==e)throw new Error('"match" requires string or number literal as labels');if(o){if(e!==o)throw new Error('"match" requires labels to have the same type')}else o=e;a[t]=s.length}const l=et(t[i+1],e);r||(r=l.type),s.push(l)}return new M(r,n,a,s,et(t[t.length-1],e))}evaluate(t,e){const r=this._input.evaluate(t,e);return(this._outputs[this._labels[r]]||this._fallback).evaluate(t,e)}}class ${constructor(t,e,r,n,s){this._operator=t,this.type=e,this.interpolation=r,this.input=n,this._stops=s}static parse(t,e,r){const n=t[0];if(t.length<5)throw new Error(`"${n}" expects at least 4 arguments`);const s=t[1];if(!Array.isArray(s)||0===s.length)throw new Error(`"${s}" is not a valid interpolation`);switch(s[0]){case"linear":if(1!==s.length)throw new Error("Linear interpolation cannot have parameters");break;case"exponential":if(2!==s.length||"number"!=typeof s[1])throw new Error("Exponential interpolation requires one numeric argument");break;case"cubic-bezier":if(5!==s.length)throw new Error("Cubic bezier interpolation requires four numeric arguments with values between 0 and 1");for(let t=1;t<5;t++){const e=s[t];if("number"!=typeof e||e<0||e>1)throw new Error("Cubic bezier interpolation requires four numeric arguments with values between 0 and 1")}break;default:throw new Error(`"${t[0]}" unknown interpolation type "${s[0]}"`)}if(t.length%2!=1)throw new Error(`"${n}" expects an even number of arguments`);const a=et(t[2],e,o.numberType);let i;"interpolate-hcl"===n||"interpolate-lab"===n?i=o.colorType:r&&"value"!==r.kind&&(i=r);const l=[];for(let o=3;o<t.length;o+=2){const r=t[o];if("number"!=typeof r)throw new Error(`"${n}" requires stop inputs as literal numbers`);if(l.length&&l[l.length-1][0]>=r)throw new Error(`"${n}" requires strictly ascending stop inputs`);const s=et(t[o+1],e,i);i||(i=s.type),l.push([r,s])}if(i&&i!==o.colorType&&i!==o.numberType&&("array"!==i.kind||i.itemType!==o.numberType))throw new Error(`"${n}" cannot interpolate type ${o.typeToString(i)}`);return new $(n,i,s,a,l)}evaluate(t,n){const s=this._stops;if(1===s.length)return s[0][1].evaluate(t,n);const i=this.input.evaluate(t,n);if(i<=s[0][0])return s[0][1].evaluate(t,n);if(i>=s[s.length-1][0])return s[s.length-1][1].evaluate(t,n);let l=0;for(;++l<s.length&&!(i<s[l][0]););const u=s[l-1][0],c=s[l][0],h=$.interpolationRatio(this.interpolation,i,u,c),p=s[l-1][1].evaluate(t,n),g=s[l][1].evaluate(t,n);if("interpolate"===this._operator){if("array"===this.type.kind&&Array.isArray(p)&&Array.isArray(g))return p.map(((t,e)=>a.interpolate(t,g[e],h)));if("color"===this.type.kind&&p instanceof e&&g instanceof e){const t=new e(p),r=new e(g);return new e([a.interpolate(t.r,r.r,h),a.interpolate(t.g,r.g,h),a.interpolate(t.b,r.b,h),a.interpolate(t.a,r.a,h)])}if("number"===this.type.kind&&"number"==typeof p&&"number"==typeof g)return a.interpolate(p,g,h);throw new Error(`"${this._operator}" cannot interpolate type ${o.typeToString(this.type)}`)}if("interpolate-hcl"===this._operator){const t=r.toLCH(p),n=r.toLCH(g),s=n.h-t.h,o=r.toRGB({h:t.h+h*(s>180||s<-180?s-360*Math.round(s/360):s),c:a.interpolate(t.c,n.c,h),l:a.interpolate(t.l,n.l,h)});return new e({a:a.interpolate(p.a,g.a,h),...o})}if("interpolate-lab"===this._operator){const t=r.toLAB(p),n=r.toLAB(g),s=r.toRGB({l:a.interpolate(t.l,n.l,h),a:a.interpolate(t.a,n.a,h),b:a.interpolate(t.b,n.b,h)});return new e({a:a.interpolate(p.a,g.a,h),...s})}throw new Error(`Unexpected operator "${this._operator}"`)}interpolationUniformValue(t,e){const r=this._stops;if(1===r.length)return 0;if(t>=r[r.length-1][0])return 0;let n=0;for(;++n<r.length&&!(t<r[n][0]););const s=r[n-1][0],a=r[n][0];return $.interpolationRatio(this.interpolation,e,s,a)}getInterpolationRange(t){const e=this._stops;if(1===e.length){const t=e[0][0];return[t,t]}const r=e[e.length-1][0];if(t>=r)return[r,r];let n=0;for(;++n<e.length&&!(t<e[n][0]););return[e[n-1][0],e[n][0]]}static interpolationRatio(t,e,r,n){let a=0;if("linear"===t[0])a=$._exponentialInterpolationRatio(e,1,r,n);else if("exponential"===t[0])a=$._exponentialInterpolationRatio(e,t[1],r,n);else if("cubic-bezier"===t[0]){a=s.unitBezier(t[1],t[2],t[3],t[4])($._exponentialInterpolationRatio(e,1,r,n),1e-5)}return a<0?a=0:a>1&&(a=1),a}static _exponentialInterpolationRatio(t,e,r,n){const s=n-r;if(0===s)return 0;const a=t-r;return 1===e?a/s:(e**a-1)/(e**s-1)}}class k{constructor(t,e,r){this.type=t,this._input=e,this._stops=r}static parse(t,e){if(t.length<5)throw new Error('"step" expects at least 4 arguments');if(t.length%2!=1)throw new Error('"step" expects an even number of arguments');const r=et(t[1],e,o.numberType);let n;const s=[];s.push([-1/0,et(t[2],e)]);for(let a=3;a<t.length;a+=2){const r=t[a];if("number"!=typeof r)throw new Error('"step" requires stop inputs as literal numbers');if(s.length&&s[s.length-1][0]>=r)throw new Error('"step" requires strictly ascending stop inputs');const o=et(t[a+1],e);n||(n=o.type),s.push([r,o])}return new k(n,r,s)}evaluate(t,e){const r=this._stops;if(1===r.length)return r[0][1].evaluate(t,e);const n=this._input.evaluate(t,e);let s=0;for(;++s<r.length&&!(n<r[s][0]););return this._stops[s-1][1].evaluate(t,e)}}class A{constructor(t,e){this.type=t,this._output=e}static parse(t,e,r){if(t.length<4)throw new Error('"let" expects at least 3 arguments');if(t.length%2==1)throw new Error('"let" expects an odd number of arguments');const n=new i(e);for(let a=1;a<t.length-1;a+=2){const r=t[a];if("string"!=typeof r)throw new Error(`"let" requires a string to define variable names - found ${r}`);n.add(r,et(t[a+1],e))}const s=et(t[t.length-1],n,r);return new A(s.type,s)}evaluate(t,e){return this._output.evaluate(t,e)}}class L{constructor(t,e){this.type=t,this.output=e}static parse(t,e,r){if(2!==t.length||"string"!=typeof t[1])throw new Error('"var" requires just one literal string argument');const n=e.get(t[1]);if(!n)throw new Error(`${t[1]} must be defined before being used in a "var" expression`);return new L(r||o.valueType,n)}evaluate(t,e){return this.output.evaluate(t,e)}}class S{constructor(t,e,r){this.type=t,this._index=e,this._array=r}static parse(t,e){if(3!==t.length)throw new Error('"at" expects 2 arguments');const r=et(t[1],e,o.numberType),n=et(t[2],e);return new S(n.type.itemType,r,n)}evaluate(t,e){const r=this._index.evaluate(t,e),n=this._array.evaluate(t,e);if(r<0||r>=n.length)throw new Error('"at" index out of bounds');if(r!==Math.floor(r))throw new Error('"at" index must be an integer');return n[r]}}class C{constructor(t,e){this._key=t,this._obj=e,this.type=o.valueType}static parse(t,e){let r,n;switch(t.length){case 2:return r=et(t[1],e),new C(r);case 3:return r=et(t[1],e),n=et(t[2],e),new C(r,n);default:throw new Error('"get" expects 1 or 2 arguments')}}evaluate(t,e){const r=this._key.evaluate(t,e);if(this._obj){return this._obj.evaluate(t,e)[r]}return t?.values[r]}}class N{constructor(t,e){this._key=t,this._obj=e,this.type=o.booleanType}static parse(t,e){let r,n;switch(t.length){case 2:return r=et(t[1],e),new N(r);case 3:return r=et(t[1],e),n=et(t[2],e),new N(r,n);default:throw new Error('"has" expects 1 or 2 arguments')}}evaluate(t,e){const r=this._key.evaluate(t,e);if(this._obj){return r in this._obj.evaluate(t,e)}return!!t?.values[r]}}class q{constructor(t,e){this._key=t,this._vals=e,this.type=o.booleanType}static parse(t,e){if(3!==t.length)throw new Error('"in" expects 2 arguments');return new q(et(t[1],e),et(t[2],e))}evaluate(t,e){const r=this._key.evaluate(t,e);return this._vals.evaluate(t,e).includes(r)}}class R{constructor(t,e,r){this._item=t,this._array=e,this._from=r,this.type=o.numberType}static parse(t,e){if(t.length<3||t.length>4)throw new Error('"index-of" expects 3 or 4 arguments');const r=et(t[1],e),n=et(t[2],e);if(4===t.length){const s=et(t[3],e,o.numberType);return new R(r,n,s)}return new R(r,n)}evaluate(t,e){const r=this._item.evaluate(t,e),n=this._array.evaluate(t,e);if(this._from){const s=this._from.evaluate(t,e);if(s!==Math.floor(s))throw new Error('"index-of" index must be an integer');return n.indexOf(r,s)}return n.indexOf(r)}}class j{constructor(t){this._arg=t,this.type=o.numberType}static parse(t,e){if(2!==t.length)throw new Error('"length" expects 2 arguments');const r=et(t[1],e);return new j(r)}evaluate(t,e){const r=this._arg.evaluate(t,e);if("string"==typeof r)return r.length;if(Array.isArray(r))return r.length;throw new Error('"length" expects string or array')}}class I{constructor(t,e,r,n){this.type=t,this._array=e,this._from=r,this._to=n}static parse(t,e){if(t.length<3||t.length>4)throw new Error('"slice" expects 2 or 3 arguments');const r=et(t[1],e),n=et(t[2],e,o.numberType);if(n.type!==o.numberType)throw new Error('"slice" index must return a number');if(4===t.length){const s=et(t[3],e,o.numberType);if(s.type!==o.numberType)throw new Error('"slice" index must return a number');return new I(r.type,r,n,s)}return new I(r.type,r,n)}evaluate(t,e){const r=this._array.evaluate(t,e);if(!Array.isArray(r)&&"string"!=typeof r)throw new Error('"slice" input must be an array or a string');const n=this._from.evaluate(t,e);if(n<0||n>=r.length)throw new Error('"slice" index out of bounds');if(n!==Math.floor(n))throw new Error('"slice" index must be an integer');if(this._to){const s=this._to.evaluate(t,e);if(s<0||s>=r.length)throw new Error('"slice" index out of bounds');if(s!==Math.floor(s))throw new Error('"slice" index must be an integer');return r.slice(n,s)}return r.slice(n)}}class G{constructor(){this.type=o.booleanType}static parse(t){if(1!==t.length)throw new Error('"has-id" expects no arguments');return new G}evaluate(t,e){return void 0!==t?.id}}class B{constructor(t,e){this._args=t,this._calculate=e,this.type=o.numberType}static parse(t,e,r){const n=t.slice(1).map((t=>et(t,e)));return new B(n,r)}evaluate(t,e){let r;return this._args&&(r=this._args.map((r=>r.evaluate(t,e)))),this._calculate(r)}}class z extends B{static parse(t,e){switch(t.length){case 2:return B.parse(t,e,(t=>-t[0]));case 3:return B.parse(t,e,(t=>t[0]-t[1]));default:throw new Error('"-" expects 1 or 2 arguments')}}}class P extends B{static parse(t,e){return B.parse(t,e,(t=>{let e=1;for(const r of t)e*=r;return e}))}}class O extends B{static parse(t,e){if(3===t.length)return B.parse(t,e,(t=>t[0]/t[1]));throw new Error('"/" expects 2 arguments')}}class U extends B{static parse(t,e){if(3===t.length)return B.parse(t,e,(t=>t[0]%t[1]));throw new Error('"%" expects 2 arguments')}}class H extends B{static parse(t,e){if(3===t.length)return B.parse(t,e,(t=>t[0]**t[1]));throw new Error('"^" expects 1 or 2 arguments')}}class D extends B{static parse(t,e){return B.parse(t,e,(t=>{let e=0;for(const r of t)e+=r;return e}))}}class V{constructor(t,e){this._args=t,this._calculate=e,this.type=o.numberType}static parse(t,e){const r=t.slice(1).map((t=>et(t,e)));return new V(r,V.ops[t[0]])}evaluate(t,e){let r;return this._args&&(r=this._args.map((r=>r.evaluate(t,e)))),this._calculate(r)}}V.ops={abs:t=>Math.abs(t[0]),acos:t=>Math.acos(t[0]),asin:t=>Math.asin(t[0]),atan:t=>Math.atan(t[0]),ceil:t=>Math.ceil(t[0]),cos:t=>Math.cos(t[0]),e:()=>Math.E,floor:t=>Math.floor(t[0]),ln:t=>Math.log(t[0]),ln2:()=>Math.LN2,log10:t=>Math.log(t[0])/Math.LN10,log2:t=>Math.log(t[0])/Math.LN2,max:t=>Math.max(...t),min:t=>Math.min(...t),pi:()=>Math.PI,round:t=>Math.round(t[0]),sin:t=>Math.sin(t[0]),sqrt:t=>Math.sqrt(t[0]),tan:t=>Math.tan(t[0])};class F{constructor(t){this._args=t,this.type=o.stringType}static parse(t,e){return new F(t.slice(1).map((t=>et(t,e))))}evaluate(t,e){return this._args.map((r=>r.evaluate(t,e))).join("")}}class Q{constructor(t,e){this._arg=t,this._calculate=e,this.type=o.stringType}static parse(t,e){if(2!==t.length)throw new Error(`${t[0]} expects 1 argument`);const r=et(t[1],e);return new Q(r,Q.ops[t[0]])}evaluate(t,e){return this._calculate(this._arg.evaluate(t,e))}}Q.ops={downcase:t=>t.toLowerCase(),upcase:t=>t.toUpperCase()};class Y{constructor(t){this._args=t,this.type=o.colorType}static parse(t,e){if(4!==t.length)throw new Error('"rgb" expects 3 arguments');const r=t.slice(1).map((t=>et(t,e)));return new Y(r)}evaluate(t,r){const n=this._validate(this._args[0].evaluate(t,r)),s=this._validate(this._args[1].evaluate(t,r)),a=this._validate(this._args[2].evaluate(t,r));return new e({r:n,g:s,b:a})}_validate(t){if("number"!=typeof t||t<0||t>255)throw new Error(`${t}: invalid color component`);return Math.round(t)}}class Z{constructor(t){this._args=t,this.type=o.colorType}static parse(t,e){if(5!==t.length)throw new Error('"rgba" expects 4 arguments');const r=t.slice(1).map((t=>et(t,e)));return new Z(r)}evaluate(t,r){const n=this._validate(this._args[0].evaluate(t,r)),s=this._validate(this._args[1].evaluate(t,r)),a=this._validate(this._args[2].evaluate(t,r)),o=this._validateAlpha(this._args[3].evaluate(t,r));return new e({r:n,g:s,b:a,a:o})}_validate(t){if("number"!=typeof t||t<0||t>255)throw new Error(`${t}: invalid color component`);return Math.round(t)}_validateAlpha(t){if("number"!=typeof t||t<0||t>1)throw new Error(`${t}: invalid alpha color component`);return t}}class J{constructor(t){this._color=t,this.type=o.arrayType(o.numberType,4)}static parse(t,e){if(2!==t.length)throw new Error('"to-rgba" expects 1 argument');const r=et(t[1],e);return new J(r)}evaluate(t,r){return new e(this._color.evaluate(t,r)).toRgba()}}class K{constructor(t,e){this.type=t,this._args=e}static parse(t,e){const r=t[0];if(t.length<2)throw new Error(`${r} expects at least one argument`);let n,s=1;if("array"===r){if(t.length>2){switch(t[1]){case"string":n=o.stringType;break;case"number":n=o.numberType;break;case"boolean":n=o.booleanType;break;default:throw new Error('"array" type argument must be string, number or boolean')}s++}else n=o.valueType;let e;if(t.length>3){if(e=t[2],null!==e&&("number"!=typeof e||e<0||e!==Math.floor(e)))throw new Error('"array" length argument must be a positive integer literal');s++}n=o.arrayType(n,e)}else switch(r){case"string":n=o.stringType;break;case"number":n=o.numberType;break;case"boolean":n=o.booleanType;break;case"object":n=o.objectType}const a=[];for(;s<t.length;s++){const r=et(t[s],e);a.push(r)}return new K(n,a)}evaluate(t,e){let r;for(const n of this._args){const s=n.evaluate(t,e);if(r=o.getType(s),o.matchType(r,this.type))return s}throw new Error(`Expected ${o.typeToString(this.type)} but got ${o.typeToString(r)}`)}}class W{constructor(t,e){this.type=t,this._args=e}static parse(t,e){const r=t[0],n=W.types[r];if(n===o.booleanType||n===o.stringType){if(2!==t.length)throw new Error(`${r} expects one argument`)}else if(t.length<2)throw new Error(`${r} expects at least one argument`);const s=[];for(let a=1;a<t.length;a++){const r=et(t[a],e);s.push(r)}return new W(n,s)}evaluate(t,r){if(this.type===o.booleanType)return Boolean(this._args[0].evaluate(t,r));if(this.type===o.stringType)return o.valueToString(this._args[0].evaluate(t,r));if(this.type===o.numberType){for(const e of this._args){const n=Number(e.evaluate(t,r));if(!isNaN(n))return n}return null}if(this.type===o.colorType){for(const n of this._args)try{const s=W.toColor(n.evaluate(t,r));if(s instanceof e)return s}catch{}return null}}static toBoolean(t){return Boolean(t)}static toString(t){return o.valueToString(t)}static toNumber(t){const e=Number(t);if(isNaN(e))throw new Error(`"${t}" is not a number`);return e}static toColor(t){if(t instanceof e)return t;if("string"==typeof t){const r=e.fromString(t);if(r)return r;throw new Error(`"${t}" is not a color`)}if(Array.isArray(t))return e.fromArray(t);throw new Error(`"${t}" is not a color`)}}W.types={"to-boolean":o.booleanType,"to-color":o.colorType,"to-number":o.numberType,"to-string":o.stringType};class X{constructor(t){this._val=t,this.type=o.getType(t)}static parse(t){if(2!==t.length)throw new Error('"literal" expects 1 argument');return new X(t[1])}evaluate(t,e){return this._val}}class tt{constructor(t){this._arg=t,this.type=o.stringType}static parse(t,e){if(2!==t.length)throw new Error('"typeof" expects 1 argument');return new tt(et(t[1],e))}evaluate(t,e){return o.typeToString(o.getType(this._arg.evaluate(t,e)))}}function et(t,e,r){const n=typeof t;if("string"===n||"boolean"===n||"number"===n||null===t){if(r)switch(r.kind){case"string":"string"!==n&&(t=W.toString(t));break;case"number":"number"!==n&&(t=W.toNumber(t));break;case"color":t=W.toColor(t)}t=["literal",t]}if(!Array.isArray(t)||0===t.length)throw new Error("Expression must be a non empty array");const s=t[0];if("string"!=typeof s)throw new Error("First element of expression must be a string");const a=rt[s];if(void 0===a)throw new Error(`Invalid expression operator "${s}"`);if(!a)throw new Error(`Unimplemented expression operator "${s}"`);return a.parse(t,e,r)}const rt={array:K,boolean:K,collator:null,format:null,image:null,literal:X,number:K,"number-format":null,object:K,string:K,"to-boolean":W,"to-color":W,"to-number":W,"to-string":W,typeof:tt,accumulated:null,"feature-state":null,"geometry-type":u,id:l,"line-progress":null,properties:c,at:S,get:C,has:N,in:q,"index-of":R,length:j,slice:I,"!":v,"!=":f,"<":w,"<=":y,"==":g,">":m,">=":b,all:_,any:d,case:x,coalesce:T,match:M,within:null,interpolate:$,"interpolate-hcl":$,"interpolate-lab":$,step:k,let:A,var:L,concat:F,downcase:Q,"is-supported-script":null,"resolved-locale":null,upcase:Q,rgb:Y,rgba:Z,"to-rgba":J,"-":z,"*":P,"/":O,"%":U,"^":H,"+":D,abs:V,acos:V,asin:V,atan:V,ceil:V,cos:V,e:V,floor:V,ln:V,ln2:V,log10:V,log2:V,max:V,min:V,pi:V,round:V,sin:V,sqrt:V,tan:V,zoom:h,"heatmap-density":null,"has-id":G,none:E};t.ALL=_,t.ANY=d,t.Add=D,t.Assert=K,t.At=S,t.Calculate=V,t.Case=x,t.Coalesce=T,t.Coerce=W,t.Concat=F,t.Div=O,t.EQ=g,t.GE=b,t.GT=m,t.GeomType=u,t.Get=C,t.Has=N,t.HasID=G,t.ID=l,t.In=q,t.IndexOf=R,t.Interpolate=$,t.LE=y,t.LT=w,t.Length=j,t.Let=A,t.Literal=X,t.Match=M,t.Mod=U,t.Mul=P,t.NE=f,t.NONE=E,t.NOT=v,t.Pow=H,t.Properties=c,t.Rgb=Y,t.Rgba=Z,t.Slice=I,t.Step=k,t.String=Q,t.Sub=z,t.ToRgba=J,t.TypeOf=tt,t.Var=L,t.Zoom=h,t.createExpression=et,t.ops=rt,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
