/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../../geometry/support/aaBoundingRect","../enums","../GeometryUtils","../shaders/VTLBackgroundMaterial","../shaders/VTLCircleMaterial","../shaders/VTLFillMaterial","../shaders/VTLLineMaterial","../shaders/VTLSymbolMaterial","./Filter","./StyleDefinition","./StyleProperty","../../webgl/definitions"],(function(t,e,i,a,r,n,o,s,l,h,u,y,p){"use strict";const g=8;var c;t.CapType=void 0,(c=t.CapType||(t.CapType={}))[c.BUTT=0]="BUTT",c[c.ROUND=1]="ROUND",c[c.SQUARE=2]="SQUARE",c[c.UNKNOWN=4]="UNKNOWN";class P{constructor(t,e,i,a,r,n){this.layer=t,this.feature=e,this.bounds=i,this.normalizationRatio=a,this.normalizationOffsetX=r,this.normalizationOffsetY=n}}class D{constructor(t,e,i,a){switch(this.type=t,this.typeName=e.type,this.id=e.id,this.source=e.source,this.sourceLayer=e["source-layer"],this.minzoom=e.minzoom,this.maxzoom=e.maxzoom,this.filter=e.filter,this.layout=e.layout,this.paint=e.paint,this.z=i,this.uid=a,t){case u.StyleLayerType.BACKGROUND:this._layoutDefinition=u.StyleDefinition.backgroundLayoutDefinition,this._paintDefinition=u.StyleDefinition.backgroundPaintDefinition;break;case u.StyleLayerType.FILL:this._layoutDefinition=u.StyleDefinition.fillLayoutDefinition,this._paintDefinition=u.StyleDefinition.fillPaintDefinition;break;case u.StyleLayerType.LINE:this._layoutDefinition=u.StyleDefinition.lineLayoutDefinition,this._paintDefinition=u.StyleDefinition.linePaintDefinition;break;case u.StyleLayerType.SYMBOL:this._layoutDefinition=u.StyleDefinition.symbolLayoutDefinition,this._paintDefinition=u.StyleDefinition.symbolPaintDefinition;break;case u.StyleLayerType.CIRCLE:this._layoutDefinition=u.StyleDefinition.circleLayoutDefinition,this._paintDefinition=u.StyleDefinition.circlePaintDefinition}this._layoutProperties=this._parseLayout(this.layout),this._paintProperties=this._parsePaint(this.paint)}getFeatureFilter(){return void 0!==this._featureFilter?this._featureFilter:this._featureFilter=h.createFilter(this.filter)}getLayoutProperty(t){return this._layoutProperties[t]}getPaintProperty(t){return this._paintProperties[t]}getLayoutValue(t,e,i){let a;const r=this._layoutProperties[t];return r&&(a=r.getValue(e,i)),void 0===a&&(a=this._layoutDefinition[t].default),a}getPaintValue(t,e,i){let a;const r=this._paintProperties[t];return r&&(a=r.getValue(e,i)),void 0===a&&(a=this._paintDefinition[t].default),a}isPainterDataDriven(){const t=this._paintProperties;if(t)for(const e in t)if(t[e].isDataDriven)return!0;return!1}isIntersectingFeature(t,e,i,a,r,n,o){return!1}getFeatureInflatedBounds(t,e,i,a){return null}_parseLayout(t){const e={};for(const i in t){const a=this._layoutDefinition[i];a&&(e[i]=new y(a,t[i]))}return e}_parsePaint(t){const e={};for(const i in t){const a=this._paintDefinition[i];a&&(e[i]=new y(a,t[i]))}return e}computeAttributesKey(t,e,i,a){let r=0,n=0;for(const o of e){let t=3;if(!o||o!==a){const e=i[o],{isLayout:a,isOptional:r}=e,n=a?this.getLayoutProperty(o):this.getPaintProperty(o);t=n?.interpolator?2:n?.isDataDriven?1:r&&!n?3:0}n|=t<<r,r+=2}return n<<3|t}}class f extends D{constructor(t,e,a,n){super(t,e,a,n),this.backgroundMaterial=new r.VTLBackgroundMaterial(this.computeAttributesKey(i.ShaderProgramType.BACKGROUND,r.VTLBackgroundMaterial.ATTRIBUTES,r.VTLBackgroundMaterial.ATTRIBUTES_INFO))}}class T extends D{constructor(t,e,a,r){super(t,e,a,r);const n=this.getPaintProperty("fill-color"),s=this.getPaintProperty("fill-opacity"),l=this.getPaintProperty("fill-pattern");this.hasDataDrivenColor=n?.isDataDriven,this.hasDataDrivenOpacity=s?.isDataDriven,this.hasDataDrivenFill=this.hasDataDrivenColor||this.hasDataDrivenOpacity||l?.isDataDriven;const h=this.getPaintProperty("fill-outline-color");this.outlineUsesFillColor=!h,this.hasDataDrivenOutlineColor=h?.isDataDriven,this.hasDataDrivenOutline=h?h.isDataDriven:!!n&&n.isDataDriven,this.hasDataDrivenOutline=(h?this.hasDataDrivenOutlineColor:this.hasDataDrivenColor)||this.hasDataDrivenOpacity,this.fillMaterial=new o.VTLFillMaterial(this.computeAttributesKey(i.ShaderProgramType.FILL,o.VTLFillMaterial.ATTRIBUTES,o.VTLFillMaterial.ATTRIBUTES_INFO)),this.outlineMaterial=new o.VTLOutlineMaterial(this.computeAttributesKey(i.ShaderProgramType.OUTLINE,this.outlineUsesFillColor?o.VTLOutlineMaterial.ATTRIBUTES_FILL:o.VTLOutlineMaterial.ATTRIBUTES_OUTLINE,this.outlineUsesFillColor?o.VTLOutlineMaterial.ATTRIBUTES_INFO_FILL:o.VTLOutlineMaterial.ATTRIBUTES_INFO_OUTLINE),this.outlineUsesFillColor)}getFeatureInflatedBounds(t,e,i,a){const r=x(t);if(!r)return null;const n=this.getPaintValue("fill-translate",e,t),o=a*Math.max(n[0],n[1]);return r[0]-=o,r[2]-=o,r[1]+=o,r[3]+=o,r}isIntersectingFeature(t,e,i,r,n,o,s){const l=r.getGeometry();if(!l)return!1;const h=g/s.normalizationRatio;t=t/s.normalizationRatio+s.normalizationOffsetX,e=e/s.normalizationRatio+s.normalizationOffsetY;const u=a.translateAnchor(this.getPaintValue("fill-translate",n,r),this.getPaintValue("fill-translate-anchor",n,r),o,g);t-=h*u.x,e-=h*u.y;return!!a.pointInPolygon(t,e,l)||a.distanceFromToPolylineWithinThreshold(t,e,l,h*i)}}class L extends D{constructor(t,e,a,r){super(t,e,a,r);const n=this.getPaintProperty("line-pattern");if(this.lineMaterial=new s.VTLLineMaterial(this.computeAttributesKey(i.ShaderProgramType.LINE,s.VTLLineMaterial.ATTRIBUTES,s.VTLLineMaterial.ATTRIBUTES_INFO,n?"line-dasharray":"")),this.hasDataDrivenLine=this.getPaintProperty("line-blur")?.isDataDriven||this.getPaintProperty("line-color")?.isDataDriven||this.getPaintProperty("line-gap-width")?.isDataDriven||this.getPaintProperty("line-offset")?.isDataDriven||this.getPaintProperty("line-opacity")?.isDataDriven||this.getPaintProperty("line-pattern")?.isDataDriven||this.getPaintProperty("line-dasharray")?.isDataDriven||this.getLayoutProperty("line-cap")?.isDataDriven||this.getPaintProperty("line-width")?.isDataDriven,this.canUseThinTessellation=!1,!this.hasDataDrivenLine){const t=this.getPaintProperty("line-width");if(!t||"number"==typeof t&&.5*t<p.thinLineHalfWidthThreshold){const t=this.getPaintProperty("line-offset");(!t||"number"==typeof t&&0===t)&&(this.canUseThinTessellation=!0)}}}getDashKey(e,i){let a;switch(i){case t.CapType.BUTT:a="Butt";break;case t.CapType.ROUND:a="Round";break;case t.CapType.SQUARE:a="Square";break;default:a="Butt"}return`dasharray-[${e.toString()}]-${a}`}getFeatureInflatedBounds(t,e,i,a){const r=x(t);if(!r)return null;const n=this.getPaintValue("line-translate",e,t),o=a*Math.max(n[0],n[1]);r[0]-=o,r[2]-=o,r[1]+=o,r[3]+=o;const s=a*Math.abs(this.getPaintValue("line-offset",e,t)||0),l=a*(this.getPaintValue("line-width",e,t)/2);return r[0]-=s+l,r[1]-=s+l,r[2]+=s+l,r[3]+=s+l,r}isIntersectingFeature(t,e,i,r,n,o,s){let l=r.getGeometry();if(!l)return!1;const h=g/s.normalizationRatio;t=t/s.normalizationRatio+s.normalizationOffsetX,e=e/s.normalizationRatio+s.normalizationOffsetY;const u=a.translateAnchor(this.getPaintValue("line-translate",n,r),this.getPaintValue("line-translate-anchor",n,r),o,g);t-=h*u.x,e-=h*u.y;const y=h*this.getPaintValue("line-offset",n,r)||0;0!==y&&(l=a.offsetLine(l,-y));const p=this.getPaintValue("line-width",n,r)/2;return a.distanceFromToPolylineWithinThreshold(t,e,l,h*(i+p))}}class d extends D{constructor(t,e,a,r){super(t,e,a,r),this.iconMaterial=new l.VTLIconMaterial(this.computeAttributesKey(i.ShaderProgramType.ICON,l.VTLIconMaterial.ATTRIBUTES,l.VTLIconMaterial.ATTRIBUTES_INFO)),this.textMaterial=new l.VTLTextMaterial(this.computeAttributesKey(i.ShaderProgramType.TEXT,l.VTLTextMaterial.ATTRIBUTES,l.VTLTextMaterial.ATTRIBUTES_INFO)),this.hasDataDrivenIcon=this.getPaintProperty("icon-color")?.isDataDriven||this.getPaintProperty("icon-halo-blur")?.isDataDriven||this.getPaintProperty("icon-halo-color")?.isDataDriven||this.getPaintProperty("icon-halo-width")?.isDataDriven||this.getPaintProperty("icon-opacity")?.isDataDriven||this.getLayoutProperty("icon-size")?.isDataDriven,this.hasDataDrivenText=this.getPaintProperty("text-color")?.isDataDriven||this.getPaintProperty("text-halo-blur")?.isDataDriven||this.getPaintProperty("text-halo-color")?.isDataDriven||this.getPaintProperty("text-halo-width")?.isDataDriven||this.getPaintProperty("text-opacity")?.isDataDriven||this.getLayoutProperty("text-size")?.isDataDriven}}class m extends D{constructor(t,e,a,r){super(t,e,a,r),this.circleMaterial=new n.VTLCircleMaterial(this.computeAttributesKey(i.ShaderProgramType.CIRCLE,n.VTLCircleMaterial.ATTRIBUTES,n.VTLCircleMaterial.ATTRIBUTES_INFO))}getFeatureInflatedBounds(t,e,i,a){const r=x(t);if(!r)return null;const n=this.getPaintValue("circle-translate",e,t),o=Math.max(n[0],n[1]);r[0]-=o,r[2]-=o,r[1]+=o,r[3]+=o;const s=a*(g*(this.getPaintValue("circle-radius",e,t)+this.getPaintValue("circle-stroke-width",e,t))/2);return r[0]-=s,r[1]-=s,r[2]+=s,r[3]+=s,r}isIntersectingFeature(t,e,i,r,n,o,s){const l=r.getGeometry();if(!l)return!1;const h=g/s.normalizationRatio;t=t/s.normalizationRatio+s.normalizationOffsetX,e=e/s.normalizationRatio+s.normalizationOffsetY,i*=h;const u=a.translateAnchor(this.getPaintValue("circle-translate",n,r),this.getPaintValue("circle-translate-anchor",n,r),o,h),y=h*(this.getPaintValue("circle-radius",n,r)+this.getPaintValue("circle-stroke-width",n,r));let p,c;for(const a of l)if(a)for(const r of a){p=r.x+u.x,c=r.y+u.y;if(Math.sqrt((t-p)*(t-p)+(e-c)*(e-c))-i<=y)return!0}return!1}}class V{constructor(t,e,i){let a;this.allowOverlap=t.getLayoutValue("icon-allow-overlap",e),this.ignorePlacement=t.getLayoutValue("icon-ignore-placement",e),this.keepUpright=t.getLayoutValue("icon-keep-upright",e),this.optional=t.getLayoutValue("icon-optional",e),this.rotationAlignment=t.getLayoutValue("icon-rotation-alignment",e),this.rotationAlignment===u.RotationAlignment.AUTO&&(this.rotationAlignment=i?u.RotationAlignment.MAP:u.RotationAlignment.VIEWPORT),a=t.getLayoutProperty("icon-anchor"),a?.isDataDriven?this._anchorProp=a:this.anchor=t.getLayoutValue("icon-anchor",e),a=t.getLayoutProperty("icon-offset"),a?.isDataDriven?this._offsetProp=a:this.offset=t.getLayoutValue("icon-offset",e),a=t.getLayoutProperty("icon-padding"),a?.isDataDriven?this._paddingProp=a:this.padding=t.getLayoutValue("icon-padding",e),a=t.getLayoutProperty("icon-rotate"),a?.isDataDriven?this._rotateProp=a:this.rotate=t.getLayoutValue("icon-rotate",e),a=t.getLayoutProperty("icon-size"),a?.isDataDriven?this._sizeProp=a:this.size=t.getLayoutValue("icon-size",e)}update(t,e){this._anchorProp&&(this.anchor=this._anchorProp.getValue(t,e)),this._offsetProp&&(this.offset=this._offsetProp.getValue(t,e)),this._paddingProp&&(this.padding=this._paddingProp.getValue(t,e)),this._rotateProp&&(this.rotate=this._rotateProp.getValue(t,e)),this._sizeProp&&(this.size=this._sizeProp.getValue(t,e))}}class _{constructor(t,e,i){let a;this.allowOverlap=t.getLayoutValue("text-allow-overlap",e),this.ignorePlacement=t.getLayoutValue("text-ignore-placement",e),this.keepUpright=t.getLayoutValue("text-keep-upright",e),this.optional=t.getLayoutValue("text-optional",e),this.rotationAlignment=t.getLayoutValue("text-rotation-alignment",e),this.rotationAlignment===u.RotationAlignment.AUTO&&(this.rotationAlignment=i?u.RotationAlignment.MAP:u.RotationAlignment.VIEWPORT),a=t.getLayoutProperty("text-anchor"),a?.isDataDriven?this._anchorProp=a:this.anchor=t.getLayoutValue("text-anchor",e),a=t.getLayoutProperty("text-justify"),a?.isDataDriven?this._justifyProp=a:this.justify=t.getLayoutValue("text-justify",e),a=t.getLayoutProperty("text-letter-spacing"),a?.isDataDriven?this._letterSpacingProp=a:this.letterSpacing=t.getLayoutValue("text-letter-spacing",e),a=t.getLayoutProperty("text-line-height"),a?.isDataDriven?this._lineHeightProp=a:this.lineHeight=t.getLayoutValue("text-line-height",e),a=t.getLayoutProperty("text-max-angle"),a?.isDataDriven?this._maxAngleProp=a:this.maxAngle=t.getLayoutValue("text-max-angle",e),a=t.getLayoutProperty("text-max-width"),a?.isDataDriven?this._maxWidthProp=a:this.maxWidth=t.getLayoutValue("text-max-width",e),a=t.getLayoutProperty("text-offset"),a?.isDataDriven?this._offsetProp=a:this.offset=t.getLayoutValue("text-offset",e),a=t.getLayoutProperty("text-padding"),a?.isDataDriven?this._paddingProp=a:this.padding=t.getLayoutValue("text-padding",e),a=t.getLayoutProperty("text-rotate"),a?.isDataDriven?this._rotateProp=a:this.rotate=t.getLayoutValue("text-rotate",e),a=t.getLayoutProperty("text-size"),a?.isDataDriven?this._sizeProp=a:this.size=t.getLayoutValue("text-size",e),a=t.getLayoutProperty("text-writing-mode"),a?.isDataDriven?this._writingModeProp=a:this.writingMode=t.getLayoutValue("text-writing-mode",e)}update(t,e){this._anchorProp&&(this.anchor=this._anchorProp.getValue(t,e)),this._justifyProp&&(this.justify=this._justifyProp.getValue(t,e)),this._letterSpacingProp&&(this.letterSpacing=this._letterSpacingProp.getValue(t,e)),this._lineHeightProp&&(this.lineHeight=this._lineHeightProp.getValue(t,e)),this._maxAngleProp&&(this.maxAngle=this._maxAngleProp.getValue(t,e)),this._maxWidthProp&&(this.maxWidth=this._maxWidthProp.getValue(t,e)),this._offsetProp&&(this.offset=this._offsetProp.getValue(t,e)),this._paddingProp&&(this.padding=this._paddingProp.getValue(t,e)),this._rotateProp&&(this.rotate=this._rotateProp.getValue(t,e)),this._sizeProp&&(this.size=this._sizeProp.getValue(t,e)),this._writingModeProp&&(this.writingMode=this._writingModeProp.getValue(t,e))}}function x(t){const i=t?.getGeometry();if(null==i)return null;let a=1/0,r=1/0,n=-1/0,o=-1/0;for(const e of i)if(e)for(const t of e)a=Math.min(a,t.x),r=Math.min(r,t.y),n=Math.max(n,t.x),o=Math.max(o,t.y);return e.fromValues(a,r,n,o)}t.BackgroundStyleLayer=f,t.CircleStyleLayer=m,t.FillStyleLayer=T,t.IconLayout=V,t.IndexItem=P,t.LineStyleLayer=L,t.StyleLayer=D,t.SymbolStyleLayer=d,t.TextLayout=_,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
