/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["./StyleDefinition","./StyleLayer"],(function(e,t){"use strict";class r{constructor(t){if(this._style=t,this.backgroundBucketIds=[],this._uidToLayer=new Map,this._layerByName={},this._runningId=0,t.layers||(t.layers=[]),this.version=parseFloat(t.version),this.layers=t.layers.map(((e,t,r)=>this._create(e,t,r))).filter((e=>!!e)),this.layers)for(let r=0;r<this.layers.length;r++){const t=this.layers[r];this._layerByName[t.id]=t,this._uidToLayer.set(t.uid,t),t.type===e.StyleLayerType.BACKGROUND&&this.backgroundBucketIds.push(t.id)}this._identifyRefLayers()}isPainterDataDriven(e){const t=this._layerByName[e];return!!t&&t.isPainterDataDriven()}getStyleLayerId(e){return e>=this.layers.length?null:this.layers[e].id}getStyleLayerByUID(e){return this._uidToLayer.get(e)??null}getStyleLayerIndex(e){const t=this._layerByName[e];return t?this.layers.indexOf(t):-1}setStyleLayer(e,t){if(!e?.id)return;const i=this._style;null!=t&&t>=this.layers.length&&(t=this.layers.length-1);let s,a=!0;const y=this._layerByName[e.id];if(y){const l=this.layers.indexOf(y);t||(t=l),t===l?(a=!1,s=r._recreateLayer(e,y),this.layers[t]=s,i.layers[t]=e):(this.layers.splice(l,1),i.layers.splice(l,1),s=this._create(e,t,this.layers),this.layers.splice(t,0,s),i.layers.splice(t,0,e))}else s=this._create(e,t,this.layers),!t||t>=this.layers.length?(this.layers.push(s),i.layers.push(e)):(this.layers.splice(t,0,s),i.layers.splice(t,0,e));this._layerByName[e.id]=s,this._uidToLayer.set(s.uid,s),a&&this._recomputeZValues(),this._identifyRefLayers()}getStyleLayer(e){const t=this._layerByName[e];return t?{type:t.typeName,id:t.id,source:t.source,"source-layer":t.sourceLayer,minzoom:t.minzoom,maxzoom:t.maxzoom,filter:t.filter,layout:t.layout,paint:t.paint}:null}deleteStyleLayer(e){const t=this._layerByName[e];if(t){delete this._layerByName[e],this._uidToLayer.delete(t.uid);const r=this.layers.indexOf(t);this.layers.splice(r,1),this._style.layers.splice(r,1),this._recomputeZValues(),this._identifyRefLayers()}}getLayerById(e){return this._layerByName[e]}getLayoutProperties(e){const t=this._layerByName[e];return t?t.layout:null}getPaintProperties(e){const t=this._layerByName[e];return t?t.paint:null}setPaintProperties(e,t){const i=this._layerByName[e];if(!i)return;const s={type:i.typeName,id:i.id,source:i.source,"source-layer":i.sourceLayer,minzoom:i.minzoom,maxzoom:i.maxzoom,filter:i.filter,layout:i.layout,paint:t},a=r._recreateLayer(s,i),y=this.layers.indexOf(i);this.layers[y]=a,this._style.layers[y].paint=t,this._layerByName[i.id]=a,this._uidToLayer.set(i.uid,a)}setLayoutProperties(e,t){const i=this._layerByName[e];if(!i)return;const s={type:i.typeName,id:i.id,source:i.source,"source-layer":i.sourceLayer,minzoom:i.minzoom,maxzoom:i.maxzoom,filter:i.filter,layout:t,paint:i.paint},a=r._recreateLayer(s,i),y=this.layers.indexOf(i);this.layers[y]=a,this._style.layers[y].layout=t,this._layerByName[i.id]=a,this._uidToLayer.set(i.uid,a)}setStyleLayerVisibility(e,t){const i=this._layerByName[e];if(!i)return;const s=i.layout||{};s.visibility=t;const a={type:i.typeName,id:i.id,source:i.source,"source-layer":i.sourceLayer,minzoom:i.minzoom,maxzoom:i.maxzoom,filter:i.filter,layout:s,paint:i.paint},y=r._recreateLayer(a,i),l=this.layers.indexOf(i);this.layers[l]=y,this._style.layers[l].layout=s,this._layerByName[i.id]=y,this._uidToLayer.set(i.uid,y)}getStyleLayerVisibility(e){const t=this._layerByName[e];if(!t)return"none";const r=t.layout;return r?.visibility??"visible"}_recomputeZValues(){const e=this.layers,t=1/(e.length+1);for(let r=0;r<e.length;r++)e[r].z=1-(1+r)*t}_identifyRefLayers(){const t=[],r=[];let i=0;for(const s of this.layers){const a=s.layout;if(s.type===e.StyleLayerType.FILL){const e=s;let r=s.source+"|"+s.sourceLayer;r+="|"+(a?.visibility??""),r+="|"+s.minzoom,r+="|"+s.maxzoom,r+="|"+JSON.stringify(s.filter),(e.hasDataDrivenFill||e.hasDataDrivenOutline)&&(r+="|"+i),t.push({key:r,layer:s})}else if(s.type===e.StyleLayerType.LINE){const e=s,t=s.paint,y=null!=t&&(null!=t["line-pattern"]||null!=t["line-dasharray"]);let l=s.source+"|"+s.sourceLayer;l+="|"+(a?.visibility??""),l+="|"+s.minzoom,l+="|"+s.maxzoom,l+="|"+JSON.stringify(s.filter),l+="|"+(void 0!==a?a["line-cap"]:""),l+="|"+(void 0!==a?a["line-join"]:""),(e.hasDataDrivenLine||y)&&(l+="|"+i),r.push({key:l,layer:s})}++i}this._assignRefLayers(t),this._assignRefLayers(r)}_assignRefLayers(t){let r,i;t.sort(((e,t)=>e.key<t.key?-1:e.key>t.key?1:0));const s=t.length;for(let a=0;a<s;a++){const y=t[a];if(y.key===r)y.layer.refLayerId=i;else if(r=y.key,i=y.layer.id,y.layer.type===e.StyleLayerType.FILL){if(!y.layer.getPaintProperty("fill-outline-color"))for(let e=a+1;e<s;e++){const s=t[e];if(s.key!==r)break;if(s.layer.getPaintProperty("fill-outline-color")){t[a]=s,t[e]=y,i=s.layer.id;break}}}else if(y.layer.type===e.StyleLayerType.LINE){let e=y.layer;for(let l=a+1;l<s;l++){const s=t[l];if(s.key!==r)break;const n=s.layer;(e.canUseThinTessellation&&!n.canUseThinTessellation||!e.canUseThinTessellation&&(n.getPaintProperty("line-pattern")||n.getPaintProperty("line-dasharray")))&&(e=n,t[a]=s,t[l]=y,i=s.layer.id)}}}}_create(r,i,s){const a=1-(1+i)*(1/(s.length+1)),y=this._runningId++;switch(r.type){case"background":return new t.BackgroundStyleLayer(e.StyleLayerType.BACKGROUND,r,a,y);case"fill":return new t.FillStyleLayer(e.StyleLayerType.FILL,r,a,y);case"line":return new t.LineStyleLayer(e.StyleLayerType.LINE,r,a,y);case"symbol":return new t.SymbolStyleLayer(e.StyleLayerType.SYMBOL,r,a,y);case"raster":return console.warn(`Unsupported vector tile raster layer ${r.id}`),null;case"circle":return new t.CircleStyleLayer(e.StyleLayerType.CIRCLE,r,a,y)}return null}static _recreateLayer(r,i){switch(r.type){case"background":return new t.BackgroundStyleLayer(e.StyleLayerType.BACKGROUND,r,i.z,i.uid);case"fill":return new t.FillStyleLayer(e.StyleLayerType.FILL,r,i.z,i.uid);case"line":return new t.LineStyleLayer(e.StyleLayerType.LINE,r,i.z,i.uid);case"symbol":return new t.SymbolStyleLayer(e.StyleLayerType.SYMBOL,r,i.z,i.uid);case"raster":return console.warn(`Unsupported vector tile raster layer ${r.id}`),null;case"circle":return new t.CircleStyleLayer(e.StyleLayerType.CIRCLE,r,i.z,i.uid)}return null}}return r}));
