/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../core/Error","../../../../core/has","../../../../core/Logger","./definitions","./DisplayId","./Utils","../../../webgl/enums","../../../webgl/FramebufferObject","../../../webgl/Texture","../../../webgl/TextureDescriptor"],(function(t,e,i,s,r,a,n,u,h,l,o){"use strict";const d=()=>s.getLogger("esri.views.2d.engine.webgl.AttributeStoreView");class g{constructor(t,e,i){this._texture=null,this._lastTexture=null,this._fbos={},this.texelSize=4;const{buffer:s,pixelType:r,textureOnly:a}=t,u=n.getPixelArrayCtor(r);this.blockIndex=i,this.pixelType=r,this.size=e,this.textureOnly=a,a||(this.data=new u(s)),this._resetRange()}destroy(){this._texture?.dispose();for(const t in this._fbos){const e=this._fbos[t];e&&("0"===t&&e.detachColorTexture(),e.dispose()),this._fbos[t]=null}this._texture=null}get _textureDesc(){const t=new o.TextureDescriptor;return t.wrapMode=u.TextureWrapMode.CLAMP_TO_EDGE,t.samplingMode=u.TextureSamplingMode.NEAREST,t.dataType=this.pixelType,t.width=this.size,t.height=this.size,t}setData(t,e,i){const s=a.getDisplayIdTexel(t),r=this.data,n=s*this.texelSize+e;!r||n>=r.length||(r[n]=i,this.dirtyStart=Math.min(this.dirtyStart,s),this.dirtyEnd=Math.max(this.dirtyEnd,s))}getData(t,e){if(null==this.data)return null;const i=a.getDisplayIdTexel(t)*this.texelSize+e;return!this.data||i>=this.data.length?null:this.data[i]}getTexture(t){return this._texture??this._initTexture(t)}getFBO(t,e=0){if(!this._fbos[e]){const i=0===e?this.getTexture(t):this._textureDesc;this._fbos[e]=new h.FramebufferObject(t,i)}return this._fbos[e]}get hasDirty(){const t=this.dirtyStart;return this.dirtyEnd>=t}updateTexture(t,s){try{const r=this.dirtyStart,a=this.dirtyEnd;if(!this.hasDirty)return;i("esri-2d-update-debug")&&console.debug(`Version[${s}] AttributeStoreView.updateTexture`,{start:r,end:a,firstBytes:new Uint8Array(this.data.buffer.slice(0,16)),block:this}),this._resetRange();const u=this.data.buffer,h=this.getTexture(t),l=4,o=(r-r%this.size)/this.size,g=(a-a%this.size)/this.size,p=o,x=this.size,c=g,_=o*this.size*l,b=(x+c*this.size)*l-_,T=n.getPixelArrayCtor(this.pixelType),f=new T(u,_*T.BYTES_PER_ELEMENT,b),y=this.size,D=c-p+1;if(D>this.size)return void d().error(new e("mapview-webgl","Out-of-bounds index when updating AttributeData"));h.updateData(0,0,p,y,D,f)}catch(r){}}update(t){const{data:e,start:i,end:s}=t;if(null!=e&&null!=this.data){const s=this.data,r=i*this.texelSize;for(let i=0;i<e.length;i++){const a=1<<i%this.texelSize;t.layout&a&&(s[r+i]=e[i])}}this.dirtyStart=Math.min(this.dirtyStart,i),this.dirtyEnd=Math.max(this.dirtyEnd,s)}resize(t,e){const i=this.size;if(this.size=e,this.textureOnly)return void(i!==this.size&&(this._lastTexture=this._texture,this._texture=null));const s=n.getPixelArrayCtor(this.pixelType);this.destroy(),this.data=new s(t.buffer)}_resetRange(){this.dirtyStart=2147483647,this.dirtyEnd=0}_initTexture(t){const e=new l.Texture(t,this._textureDesc,this.data??void 0);if(null!=this._lastTexture&&this._fbos[0]){const i=this._lastTexture.descriptor.width,s=this._lastTexture.descriptor.height,r=this._lastTexture.descriptor.dataType,a=this._lastTexture.descriptor.pixelFormat,u=this.getFBO(t),h=n.getPixelBytes(r),l=new(n.getPixelArrayCtor(r))(new ArrayBuffer(i*s*h*this.texelSize)),o=t.getBoundFramebufferObject(),{x:d,y:g,width:p,height:x}=t.getViewport();t.bindFramebuffer(u),u.readPixels(0,0,i,s,a,r,l),e.updateData(0,0,0,2*i,s/2,l),t.setViewport(d,g,p,x),t.bindFramebuffer(o)}return this.destroy(),this._texture=e,this._texture}}class p{constructor(){this.size=0,this._pendingAttributeUpdates=[],this._version=0,this._epoch=0,this._locked=!1}_initialize(t){if(!t)throw new Error("InternalError: initArgs must be defined");const e=t.blockDescriptors;if(this.size=t.blockSize,i("esri-2d-update-debug")&&console.debug("AttributeStoreView.initialize",{message:t}),null==this._data)this._data=e.map(((t,e)=>null!=t?new g(t,this.size,e):null));else for(let i=0;i<this._data.length;i++){const t=this._data[i],s=e[i];null!=s&&(null==t?this._data[i]=new g(s,this.size,i):t.resize(s,this.size))}}destroy(){for(const t of this._data??[])t?.destroy();this._defaultTexture?.dispose(),this._defaultTexture=null,this._pendingAttributeUpdates=[]}isEmpty(){return null==this._data}getBlock(t){if(null==this._data)return null;return this._data[t]}setLabelMinZoom(t,e){this.setData(t,r.AttributeDataType.FilterFlags,1,e)}setLocalTimeOrigin(t,e){this.setData(t,r.AttributeDataType.LocalTimeOrigin,0,e)}getLabelMinZoom(t){return this.getData(t,r.AttributeDataType.FilterFlags,1,255)}getFilterFlags(t){return this.getData(t,r.AttributeDataType.FilterFlags,0,0)}getVisualVariableData(t,e){return this.getData(t,r.AttributeDataType.VV,e,0)}getData(t,e,i,s){if(!this._data)return 0;const r=this._data[e];if(null==r)return 0;const a=r.getData(t,i);return null!=a?a:s}setData(t,e,i,s){this._data[e].setData(t,i,s)}lockTextureUploads(){this._locked=!0}unlockTextureUploads(){this._locked=!1,this.update()}requestUpdate(t){this._version=t.version,this._pendingAttributeUpdates.push(t),i("esri-2d-update-debug")&&console.debug(`Version[${this._version}] AttributeStoreView.requestUpdate`,{message:t})}get currentEpoch(){return this._epoch}update(){if(this._locked)return;const t=this._pendingAttributeUpdates;this._pendingAttributeUpdates=[];for(const e of t){const{blockData:t,initArgs:s,sendUpdateEpoch:r,version:a}=e;i("esri-2d-update-debug")&&console.debug(`Version[${this._version}] Epoch[${r}] AttributeStoreView.applyUpdate`),this._version=a,this._epoch=r,null!=s&&this._initialize(s);const n=this._data;for(let e=0;e<t.length;e++){const s=t[e],r=n[e];null!=r&&null!=s&&(i("esri-2d-update-debug")&&console.debug(`Version[${this._version}] CpuBlock[${e}] AttributeStoreView.update`,{block:s}),r.update(s))}}}getUniforms(t){return{filterFlags:{texture:this._getTexture(t,r.AttributeDataType.FilterFlags),unit:r.filterFlagsUnit},animation:{texture:this._getTexture(t,r.AttributeDataType.Animation),unit:r.animationUnit},gpgpu:{texture:this._getTexture(t,r.AttributeDataType.GPGPU),unit:r.gpgpuUnit},localTimeOrigin:{texture:this._getTexture(t,r.AttributeDataType.LocalTimeOrigin),unit:r.localTimeOriginUnit},visualVariableData:{texture:this._getTexture(t,r.AttributeDataType.VV),unit:r.visualVariableUnit},dataDriven0:{texture:this._getTexture(t,r.AttributeDataType.DD0),unit:r.dataDrivenUnit0},dataDriven1:{texture:this._getTexture(t,r.AttributeDataType.DD1),unit:r.dataDrivenUnit1},dataDriven2:{texture:this._getTexture(t,r.AttributeDataType.DD2),unit:r.dataDrivenUnit2},size:this.size}}_getTexture(t,e){const i=this._data?.[e];return i?(i.updateTexture(t,this._version),i.getTexture(t)):this._getDefaultTexture(t)}_getDefaultTexture(t){if(null==this._defaultTexture){const e=new o.TextureDescriptor;e.wrapMode=u.TextureWrapMode.CLAMP_TO_EDGE,e.samplingMode=u.TextureSamplingMode.NEAREST,e.width=1,e.height=1,this._defaultTexture=new l.Texture(t,e,new Uint8Array(4))}return this._defaultTexture}}t.AttributeStoreView=p,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
