/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../../core/Error","../../../../core/has","./definitions","./GeometryUtils","./Rect","./RectangleBinPack","../../../webgl/enums","../../../webgl/Texture","../../../webgl/TextureDescriptor"],(function(t,e,i,s,a,r,o,h,n){"use strict";function c(t){return t&&"static"===t.type}class g{constructor(t,e,i=0){this._mosaicPages=[],this._maxItemSize=0,this._currentPage=0,this._pageWidth=0,this._pageHeight=0,this._mosaicRects=new Map,this._spriteCopyQueue=[],this.pixelRatio=1,this._pageWidth=t,this._pageHeight=e,i>0&&(this._maxItemSize=i),this.pixelRatio=window.devicePixelRatio||1,this._binPack=new r(this._pageWidth,this._pageHeight);const s=Math.floor(this._pageWidth),a=Math.floor(this._pageHeight);this._mosaicPages.push({mosaicsData:{type:"static",data:new Uint32Array(s*a)},size:[this._pageWidth,this._pageHeight],dirty:!0,texture:void 0})}getWidth(t){return t>=this._mosaicPages.length?-1:this._mosaicPages[t].size[0]}getHeight(t){return t>=this._mosaicPages.length?-1:this._mosaicPages[t].size[1]}getPageTexture(t){return t<this._mosaicPages.length?this._mosaicPages[t].texture:null}has(t){return this._mosaicRects.has(t)}get itemCount(){return this._mosaicRects.size}getSpriteItem(t){return this._mosaicRects.get(t)}addSpriteItem(t,s,r,o,h,n,g=1,d=.5,p=1){if(this._mosaicRects.has(t))return this._mosaicRects.get(t);let u,m,l;if(c(r))[u,m,l]=this._allocateImage(s[0],s[1]);else{u=new a(0,0,s[0],s[1]),m=this._mosaicPages.length;const t=void 0;this._mosaicPages.push({mosaicsData:r,size:[s[0]+2*i.spritePadding,s[1]+2*i.spritePadding],dirty:!0,texture:t})}if(u.width<=0||u.height<=0)return null;const _={type:"sprite",rect:u,width:s[0],height:s[1],sdf:h,simplePattern:n,rasterizationScale:g,sdfPaddingRatio:d,sdfDecodeCoeff:p,page:m};return this._mosaicRects.set(t,_),c(r)&&(e("esri-mosaic-debug")&&this._showDebugSprite(s,r.data),this._copy({rect:u,spriteSize:s,spriteData:r.data,page:m,pageSize:l,repeat:o,sdf:h})),_}hasItemsToProcess(){return 0!==this._spriteCopyQueue.length}processNextItem(){const t=this._spriteCopyQueue.pop();t&&this._copy(t)}getMosaicItemPosition(t){const e=this.getSpriteItem(t),s=e?.rect;if(!s)return null;s.width=e.width,s.height=e.height;const a=e.width,r=e.height,o=i.spritePadding,h=this._mosaicPages[e.page].size;return{size:[e.width,e.height],tl:[(s.x+o)/h[0],(s.y+o)/h[1]],br:[(s.x+o+a)/h[0],(s.y+o+r)/h[1]],page:e.page}}bind(t,i,s=0,a=0){const r=this._mosaicPages[s],o=r.mosaicsData;let h=r.texture;if(h||(h=p(t,r.size),r.texture=h),h.setSamplingMode(i),c(o))t.bindTexture(h,a),r.dirty&&(h.setData(new Uint8Array(o.data.buffer)),h.generateMipmap(),e("esri-mosaic-debug")&&this._showDebugPage(s));else{o.data.loadFrame(h),t.bindTexture(h,a),h.generateMipmap()}r.dirty=!1}getTexture(t,i=0){const s=this._mosaicPages[i],a=s.mosaicsData;let r=s.texture;if(r||(r=p(t,s.size),s.texture=r),c(a))s.dirty&&(r.setData(new Uint8Array(a.data.buffer)),r.generateMipmap(),e("esri-mosaic-debug")&&this._showDebugPage(i));else{a.data.loadFrame(r),r.generateMipmap()}return s.dirty=!1,r}dispose(){this._binPack=null;for(const t of this._mosaicPages){const e=t.texture;e&&e.dispose();const i=t.mosaicsData;if(!c(i)){i.data.destroy()}}this._mosaicPages=null,this._mosaicRects.clear()}static _copyBits(t,e,i,s,a,r,o,h,n,c,g){let d=s*e+i,p=h*r+o;if(g){p-=r;for(let o=-1;o<=c;o++,d=((o+c)%c+s)*e+i,p+=r)for(let e=-1;e<=n;e++)a[p+e]=t[d+(e+n)%n]}else for(let u=0;u<c;u++){for(let e=0;e<n;e++)a[p+e]=t[d+e];d+=e,p+=r}}_copy(e){if(e.page>=this._mosaicPages.length)return;const s=this._mosaicPages[e.page],a=s.mosaicsData;if(!c(s.mosaicsData))throw new t("mapview-invalid-resource","unsuitable data type!");const r=e.spriteData,o=a.data;g._copyBits(r,e.spriteSize[0],0,0,o,e.pageSize[0],e.rect.x+i.spritePadding,e.rect.y+i.spritePadding,e.spriteSize[0],e.spriteSize[1],e.repeat),s.dirty=!0}_allocateImage(t,e){t+=2*i.spritePadding,e+=2*i.spritePadding;const o=Math.max(t,e);if(this._maxItemSize&&this._maxItemSize<o){const i=2**Math.ceil(s.log2(t)),r=2**Math.ceil(s.log2(e)),o=new a(0,0,t,e);return this._mosaicPages.push({mosaicsData:{type:"static",data:new Uint32Array(i*r)},size:[i,r],dirty:!0,texture:void 0}),[o,this._mosaicPages.length-1,[i,r]]}const h=this._binPack.allocate(t,e);if(h.width<=0){const i=this._mosaicPages[this._currentPage];return!i.dirty&&c(i.mosaicsData)&&(i.mosaicsData.data=null),this._currentPage=this._mosaicPages.length,this._mosaicPages.push({mosaicsData:{type:"static",data:new Uint32Array(this._pageWidth*this._pageHeight)},size:[this._pageWidth,this._pageHeight],dirty:!0,texture:void 0}),this._binPack=new r(this._pageWidth,this._pageHeight),this._allocateImage(t,e)}return[h,this._currentPage,[this._pageWidth,this._pageHeight]]}_showDebugSprite([t,e],i){const s=document.createElement("canvas");s.width=t,s.height=e,s.setAttribute("style",`position: absolute; top: ${4+204*d++}px; right: 208px; width: 200px; height: 200px; border: 1px solid black;`);const a=s.getContext("2d"),r=new ImageData(t,e);r.data.set(new Uint8Array(i.buffer)),a.putImageData(r,0,0),document.body.appendChild(s)}_showDebugPage(t){const e=this._mosaicPages[t],{size:[i,s],mosaicsData:a}=e;if(!c(a))return;const r=`mosaicDebugPage${t}`,o=document.getElementById(r)??document.createElement("canvas");o.id=r,o.width=i,o.height=s,o.setAttribute("style",`position: absolute; top: ${4+204*t}px; right: 4px; width: 200px; height: 200px; border: 1px solid black;`);const h=o.getContext("2d"),n=new ImageData(i,s);n.data.set(new Uint8Array(a.data.buffer)),h.putImageData(n,0,0),document.body.appendChild(o)}}let d=0;function p(t,e){const i=new n.TextureDescriptor;return i.width=e[0],i.height=e[1],i.wrapMode=o.TextureWrapMode.CLAMP_TO_EDGE,new h.Texture(t,i,null)}return g}));
