/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../../../../core/MapUtils","../../../../../../../core/screenUtils","../../../../../../../core/libs/gl-matrix-2/math/mat2d","../../../../../../../core/libs/gl-matrix-2/factories/mat2df32","../../../../../../../core/libs/gl-matrix-2/math/vec2","../../../../../../../core/libs/gl-matrix-2/factories/vec2f32","../../../../../../../core/libs/gl-matrix-2/factories/vec2f64","../../../../../../../layers/graphics/featureConversionUtils","../../../../../../../layers/graphics/OptimizedGeometry","../../../alignmentUtils","../../../definitions","../../../DisplayId","../../../collisions/LabelMetric","../../../mesh/templates/segmentUtils","../fill/meshWriterUtils","../text/TextMeshWriter"],(function(e,t,i,s,r,o,a,n,l,c,h,m,d,u,g,f,p){"use strict";const _=1,x=0,M=128,b=t.memoize((e=>{let t=0;if(0===e)return 1/0;for(;!(e%2);)t++,e/=2;return t}));class y extends p.TextMeshWriter{constructor(){super(...arguments),this._zoomLevel=0}_write(e,t,i,s){if(this._zoomLevel=s||0,null!=i)throw new Error("InternalError: EffectGeometry not support for LabelMeshWriter");switch(t.geometryType){case"esriGeometryPoint":{const i=t.readXForDisplay(),s=t.readYForDisplay();this._writePoint(e,i,s,t);break}case"esriGeometryEnvelope":case"esriGeometryPolygon":case"esriGeometryMultipoint":{const i=t.readCentroidForDisplay();if(!i)return;const[s,r]=i.coords;this._writePoint(e,s,r,t);break}case"esriGeometryPolyline":this._writeLines(e,t)}}_createLineLabelMetric(e,t,i,s){const r=d.getDisplayIdTexel(e),o="right"===this.evaluatedMeshParams.horizontalAlignment?-1:1,a="bottom"===this.evaluatedMeshParams.verticalAlignment?-1:1,n=this.evaluatedMeshParams.scaleInfo?.maxScale??0,l=this.evaluatedMeshParams.scaleInfo?.minScale??0;return new u.LabelMetric(r,t,i,o,a,n,l,s??null)}_writePoint(e,t,i,s){const r=this._getShaping();if(!r)return;const o=s.getDisplayId(),a=h.getXAnchorDirection(this.evaluatedMeshParams.horizontalAlignment),n=h.getYAnchorDirection(this.evaluatedMeshParams.verticalAlignment),l=this.evaluatedMeshParams.scaleInfo?.maxScale??0,c=this.evaluatedMeshParams.scaleInfo?.minScale??0,m=d.getDisplayIdTexel(s.getDisplayId()),g=this._getPointReferenceBounds()||{offsetX:0,offsetY:0,size:0};e.metricStart(new u.LabelMetric(m,t,i,a,n,l,c,g)),this._writeGlyphs(e,o,t,i,r,0,g),e.metricBoxWrite(r.boundsT),e.metricEnd()}_getPointReferenceBounds(){if(!this._references)return null;for(const e of this._references){const t=e.getBoundsInfo();if(t)return t}return null}_writeLines(e,t){const{scaleInfo:i,verticalAlignment:s}=this.evaluatedMeshParams,r=this.evaluatedMeshParams.repeatLabelDistance||128,o=this._getShaping("middle");if(!o)return;const a=(e,t,i,s)=>this._placeSubdivGlyphs(e,t,i,s),n=(o.bounds.width+r)/(1<<_);this._current={out:e,id:t.getDisplayId(),shaping:o,zoomRange:f.getMinMaxZoom(i,this.getTileInfo()),referenceBounds:this._getPointReferenceBounds()||{offsetX:0,offsetY:0,size:0},offsetDirection:null},this._verticalPlacement="bottom"===s?"above":"top"===s?"below":null,this._verticalPlacement?this._writeAboveAndBelowAlong(t,a,n):this._writeCenterAlong(t,a,n)}_writeAboveAndBelowAlong(e,t,i){const{repeatLabel:s}=this.evaluatedMeshParams,{shaping:r}=this._current,o=r.bounds.halfHeight,a=e.readGeometryForDisplay();if(!a)return;const n=new c;l.generalizeOptimizedGeometry(n,a,!1,!1,"esriGeometryPolyline",1);const h=v(new c,n,o),m=v(new c,n,-o),d=l.convertToGeometry(m,"esriGeometryPolyline",!1,!1),u=l.convertToGeometry(h,"esriGeometryPolyline",!1,!1),f=g.smoothPaths(u.paths,r.bounds.width),p=g.smoothPaths(d.paths,r.bounds.width);this._current.offsetDirection="above";for(const l of f)g.pathDivide(l,i,t,!!s);this._current.offsetDirection="below";for(const l of p)g.pathDivide(l,i,t,!!s)}_writeCenterAlong(e,t,i){const{repeatLabel:s}=this.evaluatedMeshParams,{shaping:r}=this._current,o=g.smoothPaths(e.readLegacyGeometryForDisplay().paths,r.bounds.width);for(const a of o)g.pathDivide(a,i,t,!!s)}_placeSubdivGlyphs(e,t,i,s){const{allowOverrun:r,labelPosition:o,repeatLabelDistance:a}=this.evaluatedMeshParams,n=this._current.zoomRange[0],l=b(t),c=this._current.shaping.bounds.width/(1<<_),h=Math.sqrt(a||M)/(1<<_),m=Math.min(i,s-i),d=this._current.shaping.isMultiline?p.maxLabelZoom:Math.log2(m/(h+c/2)),u=0===t?d:Math.min(l,d),g=Math.max(n,this._zoomLevel+_-u),f=this._zoomLevel-g,x=this._current.shaping.bounds.width/2*2**f;this._current.shaping.isMultiline?0===t&&this._placeStraight(e,g):r&&f<0?this._placeStraightAlong(e,n):"parallel"===o?this._placeStraightAlong(e,g):"curved"===o&&this._placeCurved(e,g,x)}_placeStraight(e,t){const{out:i,id:s,shaping:r,referenceBounds:o}=this._current,{x:a,y:n}=e;i.metricStart(this._createLineLabelMetric(s,a,n)),i.metricBoxWrite(r.boundsT);const l=e.angle*(180/Math.PI)%360,c=(e.angle*(180/Math.PI)+180)%360;this._writeGlyphs(i,s,a,n,r,0,o,{clipAngle:l,mapAligned:!0,isLineLabel:!0,minZoom:t}),this._writeGlyphs(i,s,a,n,r,0,o,{clipAngle:c,mapAligned:!0,isLineLabel:!0,minZoom:t}),i.metricEnd()}_placeCurved(e,t,i){const{out:s,id:r}=this._current;s.metricStart(this._createLineLabelMetric(r,e.x,e.y));const o=e.clone(),a=e.angle*(180/Math.PI)%360,n=(e.angle*(180/Math.PI)+180)%360;this._verticalPlacement&&this._verticalPlacement!==this._current.offsetDirection||(this._placeFirst(o,t,1,a),this._placeBack(e,o,t,i,1,a),this._placeForward(e,o,t,i,1,a)),this._verticalPlacement&&this._verticalPlacement===this._current.offsetDirection||(this._placeFirst(o,t,0,n),this._placeBack(e,o,t,i,0,n),this._placeForward(e,o,t,i,0,n)),s.metricEnd()}_placeStraightAlong(e,t){const{out:o,id:n,shaping:l,zoomRange:c,referenceBounds:h}=this._current,{boxBorderLineColor:m,boxBackgroundColor:d}=this.evaluatedMeshParams,u=e.clone(),g=e.angle*(180/Math.PI)%360,f=(e.angle*(180/Math.PI)+180)%360,_=l.glyphs.length>0&&!(!m&&!d);if(o.metricStart(this._createLineLabelMetric(n,e.x,e.y)),_){const m=Math.max(t,c[0],0),d=Math.min(p.maxLabelZoom,c[1]),u=s.fromRotation(r.create(),-e.angle),_={minZoom:m,maxZoom:d,clipAngle:g,mapAligned:!0,isLineLabel:!0},x=i.pt2px(this.evaluatedMeshParams.offsetX),M=i.pt2px(this.evaluatedMeshParams.offsetY);if(!this._verticalPlacement||this._verticalPlacement===this._current.offsetDirection){const t=a.fromValues(x,-1*M),[i,c]=l.shapeBackground(s.translate(r.create(),u,t));o.recordStart(this.instanceId,this.attributeLayout,l.glyphs[0].textureBinding);const m=2*Math.max(i.width,i.height);o.recordBounds(e.x+i.x,e.y+i.y,m,m),this._writeTextBox(o,n,e.x,e.y,c,h,_),o.recordEnd()}if(!this._verticalPlacement||this._verticalPlacement!==this._current.offsetDirection){const t=a.fromValues(x,M),[i,c]=l.shapeBackground(s.translate(r.create(),u,t));_.clipAngle=f,o.recordStart(this.instanceId,this.attributeLayout,l.glyphs[0].textureBinding);const m=2*Math.max(i.width,i.height);o.recordBounds(e.x+i.x,e.y+i.y,m,m),this._writeTextBox(o,n,e.x,e.y,c,h,_),o.recordEnd()}}this._verticalPlacement&&this._verticalPlacement!==this._current.offsetDirection||this._placeFirst(u,t,1,g,!0),this._verticalPlacement&&this._verticalPlacement===this._current.offsetDirection||this._placeFirst(u,t,0,f,!0),o.metricEnd()}_placeBack(e,t,i,s,r,o){const a=e.clone();let n=e.backwardLength+x;for(;a.prev()&&!(n>=s);)this._placeOnSegment(a,t,n,i,-1,r,o),n+=a.length+x}_placeForward(e,t,i,s,r,o){const a=e.clone();let n=e.remainingLength+x;for(;a.next()&&!(n>=s);)this._placeOnSegment(a,t,n,i,1,r,o),n+=a.length+x}_placeFirst(e,t,i,s,r=!1){const{out:o,id:a,shaping:n,zoomRange:l,referenceBounds:c}=this._current,h=n.glyphs;for(const m of h){const h=m.x>n.bounds.x?i:1-i,d=h*e.remainingLength+(1-h)*e.backwardLength,u=Math.abs(m.x+m.width/2-n.bounds.x),g=Math.max(0,this._zoomLevel+Math.log2(u/(d+x))),f=Math.max(t,r?0:g);m.maxZoom=Math.min(l[1],p.maxLabelZoom),m.angle=e.angle+(1-i)*Math.PI,m.minZoom=Math.max(l[0],f),this._writeLineGlyph(o,a,e.x,e.y,n.bounds,m,s,c,!0),(i||this._current.offsetDirection)&&this._isVisible(m.minZoom,m.maxZoom)&&o.metricBoxWrite(m.bounds)}}_placeOnSegment(e,t,i,s,r,o,a){const{out:n,id:l,shaping:c,referenceBounds:h}=this._current,m=c.glyphs,d=e.dx/e.length,u=e.dy/e.length,g={x:e.x+i*-r*d,y:e.y+i*-r*u};for(const f of m){const t=f.x>c.bounds.x?o:1-o;if(!(t&&1===r||!t&&-1===r))continue;const m=Math.abs(f.x+f.width/2-c.bounds.x),d=Math.max(0,this._zoomLevel+Math.log2(m/i)-.1),u=Math.max(s,this._zoomLevel+Math.log2(m/(i+e.length+x)));0!==d&&(f.angle=e.angle+(1-o)*Math.PI,f.minZoom=u,f.maxZoom=d,this._writeLineGlyph(n,l,g.x,g.y,c.bounds,f,a,h,!0),(o||this._current.offsetDirection)&&this._isVisible(f.minZoom,f.maxZoom)&&n.metricBoxWrite(f.bounds))}}_writeLineGlyph(e,t,i,s,r,o,a,n,l){const c=i+r.x,h=s+r.y,m=2*(this.evaluatedMeshParams.minPixelBuffer?this.evaluatedMeshParams.minPixelBuffer/this._textMeshTransformProps.fontSize:1),d=Math.max(r.width,r.height)*m;e.recordStart(this.instanceId,this.attributeLayout,o.textureBinding),e.recordBounds(c,h,d,d);const{texcoords:u,offsets:g}=o,{fontSize:p,haloSize:_,outlineSize:x}=this._textMeshTransformProps;this._writeQuad(e,t,i,s,{texcoords:u,offsets:g,fontSize:p,haloSize:_,outlineSize:x,color:f.processColorInput(this.evaluatedMeshParams.color),isBackground:!1,referenceBounds:n,minZoom:Math.max(this._current.zoomRange[0],o.minZoom),maxZoom:Math.min(this._current.zoomRange[1],o.maxZoom),clipAngle:a,mapAligned:l,isLineLabel:!0}),e.recordEnd()}_isVisible(e,t){const i=Math.floor(this._zoomLevel*m.minMaxZoomPrecisionFactor)/m.minMaxZoomPrecisionFactor;return e<=i&&i<=t}}function v(e,t,i){const{coords:s,lengths:r}=t,a=n.create(),l=n.create(),c=n.create(),h=n.create(),m=n.create(),d=n.create(),u=2;let g=0;for(let n=0;n<r.length;n++){const t=r[n];for(let r=0;r<t;r++){const n=u*(r+g-1),f=u*(r+g),p=u*(r+g+1);r>0?o.set(a,s[n],s[n+1]):o.set(a,0,0),o.set(l,s[f],s[f+1]),r<t-1?o.set(c,s[p],s[p+1]):o.set(c,0,0),0===r?o.set(h,0,0):(o.sub(h,l,a),o.normalize(h,h),o.set(h,h[1],-h[0])),r===t-1?o.set(m,0,0):(o.sub(m,c,l),o.normalize(m,m),o.set(m,m[1],-m[0])),o.add(d,h,m),o.normalize(d,d);const _=d[0]*m[0]+d[1]*m[1];0!==_&&o.scale(d,d,_),o.scale(d,d,i),e.coords.push(l[0]+d[0],l[1]+d[1])}e.lengths.push(t),g+=t}return e}e.LabelMeshWriter=y,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
