/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../../../../core/arrayUtils","../../../../../../../core/Error","../../../../../../../core/lang","../../../../../../../core/Logger","../../../grouping","../../../animations/infos","../../../animations/utils","./utils","../../../../../layers/features/support/DictionaryValue"],(function(e,t,r,s,a,o,i,n,c,m){"use strict";const p=()=>a.getLogger("esri.views.2d.engine.webgl.shaderGraph.techniques.mesh.MeshWriterInputEvaluator");async function l(e,t,r=!1){const{defaultValue:s,valueExpressionInfo:a,value:o}=t;if(a){const{expression:o}=a,i=await e.createComputedField({expression:o},r);return i?{...t,computed:i,defaultValue:s}:null}return{...t,computed:new m.DictionaryValue(o),defaultValue:s}}async function f(e,t){const{valueExpressionInfo:r}=t,{expression:s}=r,a=await e.createComputedField({expression:s});return a?{...t,computed:a}:null}function u(e){return"object"==typeof e&&null!=e&&(!(!("valueExpressionInfo"in e)||!e.valueExpressionInfo)||"type"in e&&"Process"===e.type&&"op"in e&&"Random"===e.op)}function d(e){if(Array.isArray(e))for(const t of e)if(d(t))return!0;if("object"==typeof e){if(u(e))return!0;for(const t in e){if(d(e[t]))return!0}}return!1}class h{static async create(e,r,s){const a={},o=new Map,i=new Map,c=new Map,m=new Map,p=new Map,y=new Map;for(const h in s){const v=s[h];if(null!=v&&"object"==typeof v)if(Array.isArray(v)){if("object"==typeof v[0])throw new Error(`InternalError: Cannot handle ${h}. Nested array params are not supported`);a[h]=v}else if("valueExpressionInfo"in v){if(v.value){a[h]=v.value;continue}const t=await f(e,v);if(!t){a[h]=v.defaultValue;continue}o.set(h,t),a[h]=null}else switch(v.type){case"cim-effect-infos":if(v.effectInfos.some((e=>e.overrides.length))){i.set(h,{effects:await Promise.all(v.effectInfos.map((async r=>{const s=r.overrides.map((t=>l(e,t)));return{effect:r.effect,compiledOverrides:(await Promise.all(s)).filter(t.isSome)}})))});break}a[h]=v.effectInfos.map((e=>e.effect));break;case"cim-marker-placement-param":v.overrides.length&&c.set(h,{placementInfo:v,compiledOverrides:(await Promise.all(v.overrides.map((t=>l(e,t))))).filter(t.isSome)}),a[h]=v.placement;break;case"text-rasterization-param":{if(v.overrides.length){const r=v.overrides.map((t=>l(e,t,v.useLegacyLabelEvaluationRules)));m.set(h,{compiledOverrides:(await Promise.all(r)).filter(t.isSome),rasterizationParam:v,objectIdToResourceId:new Map});continue}const s={type:"cim-rasterization-info",resource:v.resource};a[h]=await r.fetchResourceImmediate(s)??null;break}case"sprite-rasterization-param":{if(v.overrides.length){const r=v.overrides.map((t=>l(e,t)));m.set(h,{compiledOverrides:(await Promise.all(r)).filter(t.isSome),rasterizationParam:v,objectIdToResourceId:new Map});continue}if("animated"===v.resource.type){m.set(h,{compiledOverrides:[],rasterizationParam:v,objectIdToResourceId:new Map});continue}const s={type:"cim-rasterization-info",resource:v.resource};a[h]=await r.fetchResourceImmediate(s)??null;break}case"cim-marker-transform-param":{const{params:t}=v;if(d(t)){const r={compiledMarkerInfos:[]};await Promise.all(t.map((async t=>{const s={props:{}};for(const r in t)if(u(t[r])){const a=await f(e,t[r]);s.compiledExpressionMap||(s.compiledExpressionMap=new Map);const o=s.compiledExpressionMap;a&&o.set(r,a)}else s.props[r]=t[r];r.compiledMarkerInfos.push(s)}))),p.set(h,r)}else a[h]={type:"cim-marker-transform-info",infos:t};break}case"animation-params":{const{params:t}=v,s=n.createParamList(t);if(d(s)){const t=await Promise.all(s.map((t=>n.compileAnimationParam(t,e))));y.set(h,{params:t,propertyIdToResourceId:new Map,key:h})}else{const e=n.fromJSON(s),t=await r.fetchResourceImmediate({type:"animation-info",resource:e});null!=t&&"sprite"===t.type&&(a[h]={dataRow:t.rect.y,dataColumn:t.rect.x})}break}default:a[h]=v}else a[h]=v}return new h(s,a,o,i,c,m,p,y)}constructor(e,t,r,s,a,o,i,n){this.inputMeshParams=e,this._resolvedMeshParams=t,this._dynamicProperties=r,this._dynamicEffectProperties=s,this._dynamicPlacementProperties=a,this._dynamicAsyncProperties=o,this._dynamicTransformProperties=i,this._dynamicAsyncAnimations=n,this.evaluator=e=>e}get hasDynamicProperties(){return!!(this._dynamicProperties.size||this._dynamicAsyncProperties.size||this._dynamicEffectProperties.size||this._dynamicTransformProperties.size||this._dynamicPlacementProperties.size||this._dynamicAsyncAnimations.size)}get evaluatedMeshParams(){return this._evaluatedMeshParams||(this._evaluatedMeshParams=this.evaluator(this._resolvedMeshParams)),this._evaluatedMeshParams}enqueueRequest(e,t,a){for(const i of this._dynamicAsyncProperties.values()){const n=s.clone(i.rasterizationParam.resource);"animated"===i.rasterizationParam.resource.type&&i.rasterizationParam.resource.randomizeStartTime&&(n.primitiveName="__RESERVED__PRIMITIVE__NAME__",n.startGroup=o.getStartGroup(t.getObjectId()||0));for(const{primitiveName:e,propertyName:s,computed:o,defaultValue:f,valueExpressionInfo:u}of i.compiledOverrides)try{const r="animated"===i.rasterizationParam.resource.type?n.primitiveName:e;c.applyComputedValue(n,r,s,o,t,a,f)}catch(m){p().errorOnce(new r("invalid-arcade-expression",`Encountered an error when evaluating the arcade expression '${u?.expression}' (primitive: '${e}', property: '${s}')`,m))}const l=e.enqueueRequest({type:"cim-rasterization-info",resource:n});i.objectIdToResourceId.set(t.getObjectId(),l)}for(const r of this._dynamicAsyncAnimations.values()){const s=r.params.map((e=>n.resolveToAnimationInfo(e,t,a))).map(i.hydrate).map((e=>e.simplify())),o=n.encodeParamList(s),c=e.enqueueRequest({type:"animation-info",resource:o});r.propertyIdToResourceId.set(t.getObjectId()+"."+r.key,c)}}evaluateMeshParams(e,t,r){for(const[s,a]of this._dynamicProperties.entries())this._resolvedMeshParams[s]=a.computed.readWithDefault(t,r,a.defaultValue);for(const[s,a]of this._dynamicPlacementProperties.entries())for(const{computed:e,defaultValue:o,propertyName:i}of a.compiledOverrides){const n=e.readWithDefault(t,r,o);a.placementInfo.placement[i]=n,this._resolvedMeshParams[s]=a.placementInfo.placement}for(const[s,a]of this._dynamicEffectProperties.entries())for(const e of a.effects){for(const{computed:s,defaultValue:a,propertyName:o}of e.compiledOverrides){const i=s.readWithDefault(t,r,a);e.effect[o]=i}this._resolvedMeshParams[s]=a.effects.map((e=>e.effect))}for(const[s,a]of this._dynamicTransformProperties.entries()){const e={type:"cim-marker-transform-info",infos:[]};for(const s of a.compiledMarkerInfos){const a={...s.props};if(s.compiledExpressionMap)for(const[e,o]of s.compiledExpressionMap){const s=o.computed.readWithDefault(t,r,o.defaultValue);a[e]="number"==typeof s||"boolean"==typeof s?s:o.defaultValue}e.infos.push(a)}this._resolvedMeshParams[s]=e}for(const[s,a]of this._dynamicAsyncProperties.entries()){const r=a.objectIdToResourceId.get(t.getObjectId());if(null==r)continue;const o=e.getResource(r);this._resolvedMeshParams[s]=o}for(const[s,a]of this._dynamicAsyncAnimations.entries()){const r=a.propertyIdToResourceId.get(t.getObjectId()+"."+s);if(null==r)continue;const o=e.getResource(r);this._resolvedMeshParams[s]={dataRow:o.rect.y,dataColumn:o.rect.x}}return this._evaluatedMeshParams=this.evaluator(this._resolvedMeshParams),this.evaluatedMeshParams}}e.MeshWriterInputEvaluator=h,e.hasExpression=u,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
