/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../../../../core/mathUtils","../../../../../../../core/screenUtils","../../../../../../../geometry/GeometryCursor","../../../../../../../symbols/cim/placements/CIMMarkerPlacementHelper","../../../alignmentUtils","../../../definitions","../../../mesh/templates/shapingUtils","../fill/meshWriterUtils","../mesh/loadGeometryEngine","../mesh/MeshWriter","../shaders/constants","./TextParams","../../../../../../webgl/enums"],(function(t,e,o,r,i,s,n,a,p,c,l,h,u,d){"use strict";const f=28,m=[4,4],x=[16,4],g={topLeft:x,topRight:x,bottomLeft:x,bottomRight:x},y=[4,2],T=[4,6],S={topLeft:y,topRight:y,bottomLeft:T,bottomRight:T},P={topLeft:y,topRight:T,bottomLeft:y,bottomRight:T},_={topLeft:T,topRight:T,bottomLeft:m,bottomRight:m},b={topLeft:m,topRight:m,bottomLeft:T,bottomRight:T},M={topLeft:T,topRight:m,bottomLeft:T,bottomRight:m},k={topLeft:m,topRight:T,bottomLeft:m,bottomRight:T},I={createComputedParams:t=>t,optionalAttributes:{zoomRange:{type:d.DataType.UNSIGNED_SHORT,count:2,packPrecisionFactor:n.minMaxZoomPrecisionFactor,packTessellation:({minZoom:t,maxZoom:e})=>[t||0,e||f]},clipAngle:{type:d.DataType.UNSIGNED_BYTE,count:1,packTessellation:({clipAngle:t})=>B(t||0)},referenceSymbol:{type:d.DataType.BYTE,count:4,packPrecisionFactor:1,packTessellation:(t,e)=>{const r=t.isLineLabel||!t.referenceBounds,i=s.getXDirection(r?"center":e.horizontalAlignment),n=s.getYDirection(r?"middle":e.verticalAlignment),{offsetX:a,offsetY:p,size:c}=r?{offsetX:0,offsetY:0,size:0}:t.referenceBounds;return[o.pt2px(a),-o.pt2px(p),Math.round(o.pt2px(c)),i+1<<2|n+1]}}},attributes:{pos:{type:d.DataType.SHORT,count:2,pack:"position",packPrecisionFactor:10},id:{type:d.DataType.UNSIGNED_BYTE,count:3,pack:"id"},bitset:{type:d.DataType.UNSIGNED_BYTE,count:1,packTessellation:({isBackground:t,mapAligned:e})=>p.packBitset([[h.bitsetTextIsBackground,t],[h.bitsetTextIsMapAligned,!!e]])},offset:{type:d.DataType.SHORT,count:2,packPrecisionFactor:8,packAlternating:{count:4,packTessellation:({offsets:t})=>{const{bottomLeft:e,bottomRight:o,topLeft:r,topRight:i}=t;return[r,i,e,o]}}},textureUV:{type:d.DataType.SHORT,count:2,packPrecisionFactor:4,packAlternating:{count:4,packTessellation:({texcoords:t})=>{const{bottomLeft:e,bottomRight:o,topLeft:r,topRight:i}=t;return[r,i,e,o]}}},color:{type:d.DataType.UNSIGNED_BYTE,count:4,normalized:!0,packTessellation:({color:t})=>t},fontSize:{type:d.DataType.UNSIGNED_SHORT,count:1,packPrecisionFactor:4,packTessellation:({fontSize:t})=>Math.round(o.pt2px(t))},referenceSize:{type:d.DataType.UNSIGNED_BYTE,count:1,packPrecisionFactor:4,packTessellation:({fontSize:t},{referenceSize:e})=>Math.round(o.pt2px(e??t))},outlineColor:{type:d.DataType.UNSIGNED_BYTE,count:4,normalized:!0,pack:({outlineColor:t})=>p.processColorInput(t)},haloColor:{type:d.DataType.UNSIGNED_BYTE,count:4,normalized:!0,pack:({haloColor:t})=>p.processColorInput(t)},outlineAndHaloSize:{type:d.DataType.UNSIGNED_SHORT,count:2,packPrecisionFactor:4,packTessellation:({outlineSize:t,haloSize:e})=>[Math.round(o.pt2px(t)),Math.round(o.pt2px(e))]}}};class z extends l.MeshWriter{constructor(){super(...arguments),this.vertexSpec=I,this._textMeshParamsPropsInitialized=!1}ensurePacked(t,e,o){super.ensurePacked(t,e,o),this._textMeshParamsPropsInitialized&&!this._evaluator.hasDynamicProperties||(this._textMeshTransformProps=new u.TextMeshTransformProps(this.evaluatedMeshParams),this._textMeshParamsPropsInitialized=!0)}_write(t,e,o){const r=this._getShaping();if(!r)return;const i=e.getDisplayId();if(null!=this.evaluatedMeshParams.placement)return this._writePlacedTextMarkers(t,e,r,o);if(o?.nextPath())return o.nextPoint(),this._writeGlyphs(t,i,o.x,o.y,r,0);if("esriGeometryPolygon"===e.geometryType){const o=e.readCentroidForDisplay();if(!o)return;const[s,n]=o.coords;return this._writeGlyphs(t,i,s,n,r,0)}if("esriGeometryMultipoint"===e.geometryType){const o=e.readGeometryForDisplay();return void o?.forEachVertex(((e,o)=>this._writeGlyphs(t,i,e,o,r,0)))}const s=e.readXForDisplay(),n=e.readYForDisplay();return this._writeGlyphs(t,i,s,n,r,0)}_writePlacedTextMarkers(t,e,s,n){const a=n??r.GeometryCursor.fromFeatureSetReaderCIM(e);if(!a)return;const p=-1,l=i.CIMMarkerPlacementHelper.getPlacement(a,p,this.evaluatedMeshParams.placement,o.pt2px(1),t.id,c.getGeometryEngine());if(!l)return;const h=e.getDisplayId();let u=l.next();for(;null!=u;){const e=u.tx,o=-u.ty,r=-u.getAngle();this._writeGlyphs(t,h,e,o,s,r),u=l.next()}}_getShaping(t){const r=this._textMeshTransformProps,i=this.evaluatedMeshParams;if(!i.glyphs?.glyphs.length)return null;const s=o.pt2px(r.fontSize),p=o.pt2px(r.offsetX),c=o.pt2px(r.offsetY),l=e.clamp(o.pt2px(i.lineWidth),n.minTextLineWidth,n.maxTextLineWidth),h=n.magicLabelLineHeight*e.clamp(i.lineHeightRatio,.25,4);return a.shapeGlyphs(i.glyphs,{scale:s/n.glyphSize,angle:r.postAngle,xOffset:p,yOffset:c,horizontalAlignment:i.horizontalAlignment,verticalAlignment:t||i.verticalAlignment,maxLineWidth:l,lineHeight:h,decoration:i.decoration,borderLineSizePx:o.pt2px(i.boxBorderLineSize),hasBackground:!!i.boxBackgroundColor,useCIMAngleBehavior:i.useCIMAngleBehavior})}_writeGlyphs(t,e,r,i,s,n,a,c){const l=this.evaluatedMeshParams,h=this._textMeshTransformProps,u=o.pt2px(h.fontSize),d=h.haloSize,f=h.outlineSize,m=o.pt2px(h.offsetX),x=o.pt2px(h.offsetY),[g,y]=p.getMinMaxZoom(l.scaleInfo,this.getTileInfo());0!==n&&s.setRotation(n);const T=s.bounds,S=r+T.x+m,P=i+T.y-x,_=2*(l.minPixelBuffer?l.minPixelBuffer/u:1),b=Math.max(T.width,T.height)*_;s.textBox&&(t.recordStart(this.instanceId,this.attributeLayout,s.glyphs[0].textureBinding),t.recordBounds(S,P,b,b),this._writeTextBox(t,e,r,i,s.textBox,a,c),t.recordEnd());for(const o of s.glyphs){t.recordStart(this.instanceId,this.attributeLayout,o.textureBinding),t.recordBounds(S,P,b,b);const{texcoords:s,offsets:n}=o;this._writeQuad(t,e,r,i,{texcoords:s,offsets:n,fontSize:u,haloSize:d,outlineSize:f,color:p.processColorInput(l.color),isBackground:!1,referenceBounds:a,minZoom:g,maxZoom:y,...c}),t.recordEnd()}0!==n&&s.setRotation(-n)}_writeTextBox(t,e,o,r,i,s,n){const a=this.evaluatedMeshParams,{fontSize:c,haloSize:l,outlineSize:h}=this._textMeshTransformProps,{boxBackgroundColor:u,boxBorderLineColor:d}=a,f={isBackground:!0,fontSize:c,haloSize:l,outlineSize:h,referenceBounds:s,...n};u&&(this._writeQuad(t,e,o,r,{texcoords:g,offsets:i.main,color:p.processColorInput(u),...f}),d||(this._writeQuad(t,e,o,r,{texcoords:_,offsets:i.top,color:p.processColorInput(u),...f}),this._writeQuad(t,e,o,r,{texcoords:b,offsets:i.bot,color:p.processColorInput(u),...f}),this._writeQuad(t,e,o,r,{texcoords:M,offsets:i.left,color:p.processColorInput(u),...f}),this._writeQuad(t,e,o,r,{texcoords:k,offsets:i.right,color:p.processColorInput(u),...f}))),d&&(this._writeQuad(t,e,o,r,{texcoords:S,offsets:i.top,color:p.processColorInput(d),...f}),this._writeQuad(t,e,o,r,{texcoords:S,offsets:i.bot,color:p.processColorInput(d),...f}),this._writeQuad(t,e,o,r,{texcoords:P,offsets:i.left,color:p.processColorInput(d),...f}),this._writeQuad(t,e,o,r,{texcoords:P,offsets:i.right,color:p.processColorInput(d),...f}))}_writeQuad(t,e,o,r,i){const s=t.vertexCount();this._writeVertex(t,e,o,r,i),t.indexWrite(s+0),t.indexWrite(s+1),t.indexWrite(s+2),t.indexWrite(s+1),t.indexWrite(s+3),t.indexWrite(s+2)}}const B=t=>Math.round(t*(254/360));t.TextMeshWriter=z,t.TextVertexSpec=I,t.maxLabelZoom=f,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
