/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../chunks/tslib.es6","../../../../geometry","../../../../Graphic","../../../../symbols","../../../../core/colorUtils","../../../../core/maybe","../../../../core/reactiveUtils","../../../../core/unitUtils","../../../../core/accessorSupport/decorators/property","../../../../core/has","../../../../core/Logger","../../../../core/RandomLCG","../../../../core/accessorSupport/decorators/subclass","../../../../core/libs/gl-matrix-2/math/vec2","../../../../core/libs/gl-matrix-2/factories/vec2f64","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../geometry/projection","../../../../chunks/boundedPlane","../../../../geometry/support/spatialReferenceUtils","../../../../layers/GraphicsLayer","../../../ViewingMode","./manipulations/DragManipulation","./manipulations/RotateManipulation","./manipulations/ScaleManipulation","./manipulations/utils","../../../input/keys","../../../interactive/InteractiveToolBase","../../../interactive/keybindings","../../../interactive/editGeometry/EditGeometry","../../../interactive/editGeometry/EditGeometryOperations","../../../interactive/editGeometry/interfaces","../../../interactive/editGeometry/operations/UpdateVertices","../../../interactive/editGeometry/support/editPlaneUtils","../../../support/hitTestSelectUtils","../../../support/screenUtils","../../../../geometry/Polygon","../../../../geometry/Point","../../../../symbols/SimpleFillSymbol","../../../../symbols/SimpleMarkerSymbol"],(function(e,t,i,a,s,r,o,n,c,l,h,p,d,_,y,u,g,m,f,v,G,w,b,R,T,C,S,A,M,P,k,O,U,D,x,E,B,L,K,H,I){"use strict";const j={up:"ArrowUp",down:"ArrowDown",left:"ArrowLeft",right:"ArrowRight",plus:"+",minus:"-",toggleOpacity:"t",shift:"Shift",primaryKey:A.primaryKey},z=80,V=10,F=30,N=[[1,1],[1,-1],[-1,-1],[-1,1],[1,0],[0,-1],[-1,0],[0,1]],q=1,W=10;e.TransformTool=class extends M.InteractiveToolBase{constructor(e){super(e),this._initialControlPoints=null,this._initialGeometry=null,this._graphic=null,this._planeCache=v.create(),this._displayPlaneCache=v.create(),this._mainAxisCache=u.create(),this._rotationHandleCache=m.create(),this._cornerA=m.create(),this._cornerB=m.create(),this._cornerC=m.create(),this._cornerD=m.create(),this._avgAB=m.create(),this._avgBC=m.create(),this._avgCD=m.create(),this._avgDA=m.create(),this._preserveAspectRatio=new S.PreserveAspectRatio,this._snapRotation=new S.SnapRotation,this._graphicsLayer=new w({internal:!0,listMode:"hide",visible:!1}),this._sharedUndoStack=[],this._sharedRedoStack=[],this._isOpacityToggled=!1,this._factor=q,this.preserveAspectRatio=null,this.snapRotation=null,this.type="transform"}initialize(){this._initialize()}destroy(){const{map:e}=this.view;this._dragManipulation.destroy(),this._rotateManipulation.destroy(),this._scaleManipulations.forEach((e=>e.destroy())),this._editGeometryOperations.destroy(),e.removeMany([this._graphicsLayer]),this._graphicsLayer.removeAll(),this._graphicsLayer=o.destroyMaybe(this._graphicsLayer),this._initialControlPoints=null,this._initialGeometry=null,this._graphic=null,this._preserveAspectRatio=null,this._snapRotation=null,this._planeCache=null,this._displayPlaneCache=null,this._rotationHandleCache=null,this._mainAxisCache=null,this._cornerA=null,this._cornerB=null,this._cornerC=null,this._cornerD=null,this._avgAB=null,this._avgBC=null,this._avgCD=null,this._avgDA=null,this._sharedUndoStack=null,this._sharedRedoStack=null}get _plane(){const e=this._graphic.geometry;if(null==e)return null;const t=this._editGeometryOperations.data,i=t.components[0].edges[0],a=y.subtract(this._mainAxisCache,i.leftVertex.pos,i.rightVertex.pos);y.normalize(a,a);let s=z*this.view.resolution;const r=this.view.spatialReference;return G.equals(r,e.spatialReference)&&(s*=c.getMetersPerUnitForSR(r)/c.getMetersPerUnitForSR(e.spatialReference)),x.calculateOrientedBounds(a,t,s,this._planeCache)}get _displayPlane(){const e=this._plane;if(!e)return null;const t=this._displayPlaneCache;v.copy(e,t);const i=V*this.view.resolution;return g.scale(t.basis1,t.basis1,1+i/g.length(t.basis1)),g.scale(t.basis2,t.basis2,1+i/g.length(t.basis2)),t}get _backgroundGraphicGeometry(){const e=this._displayPlane;if(!e)return null;const t=this.view.spatialReference;return this._updateDisplayPlaneConrers(e),new L({spatialReference:t,rings:[[this._cornerA,this._cornerB,this._cornerC,this._cornerD,this._cornerA]]})}get _rotateGraphicGeometry(){const e=this._plane;if(!e)return null;const t=this._rotationHandleCache;return g.normalize(t,e.basis1),g.scale(t,t,F*this.view.resolution),g.add(t,t,e.origin),g.add(t,t,e.basis1),new K({x:t[0],y:t[1],spatialReference:this.view.spatialReference})}get _scaleGraphicGeometries(){const e=this._displayPlane;if(!e)return[];const t=this.view.spatialReference;this._updateDisplayPlaneConrers(e);const{_cornerA:i,_cornerB:a,_cornerC:s,_cornerD:r}=this,o=g.lerp(this._avgAB,i,a,.5),n=g.lerp(this._avgBC,a,s,.5),c=g.lerp(this._avgCD,s,r,.5),l=g.lerp(this._avgDA,r,i,.5);return[new K({x:i[0],y:i[1],spatialReference:t}),new K({x:a[0],y:a[1],spatialReference:t}),new K({x:s[0],y:s[1],spatialReference:t}),new K({x:r[0],y:r[1],spatialReference:t}),new K({x:o[0],y:o[1],spatialReference:t}),new K({x:n[0],y:n[1],spatialReference:t}),new K({x:c[0],y:c[1],spatialReference:t}),new K({x:l[0],y:l[1],spatialReference:t})]}onActivate(){this.visible=!0}onDeactivate(){this.visible=!1}onShow(){this._graphicsLayer.visible=!0}onHide(){this._graphicsLayer.visible=!1}canUndo(){return this._editGeometryOperations.canUndo}canRedo(){return this._editGeometryOperations.canRedo}undo(){this._editGeometryOperations.undo(),this.updateGraphics()}redo(){this._editGeometryOperations.redo(),this.updateGraphics()}refresh(){const{view:e,target:t}=this,i="georeference"in t?t.georeference.coords:t.geometry,a=this._editGeometryOperations,s=a.data.components[0].vertices,r=k.EditGeometry.fromGeometry(f.project(i,e.spatialReference),b.ViewingMode.Local).components[0].vertices;s.forEach(((e,t)=>{a.setVertexPosition(e,r[t].pos)})),this.updateGraphics()}reset(){const{target:e}=this;if("georeference"in e){const t=e.georeference;"control-points"===t.type&&(t.controlPoints=this._initialControlPoints)}else e.geometry=this._initialGeometry;this.refresh(),this._sharedUndoStack.length=0,this._sharedRedoStack.length=0}updateGraphics(){const e=this._editGeometryOperations.data.geometry;if("georeference"in this.target){this.target.georeference.coords=e}this._graphic.geometry=e,this._backgroundGraphic.geometry=this._backgroundGraphicGeometry,this._rotateGraphic.geometry=this._rotateGraphicGeometry,this._scaleGraphicGeometries.forEach(((e,t)=>{this._scaleGraphics[t].geometry=e}))}setSharedUndoStack(e){this._sharedUndoStack=e}setSharedRedoStack(e){this._sharedRedoStack=e}async _initialize(){const{view:e,target:t}=this;if("georeference"in t){const e=t.georeference;this._graphic=new a({geometry:e.coords}),this._initialControlPoints="control-points"===e.type?e.controlPoints:null}else this._graphic=t,this._initialGeometry=t.geometry;e.map.addMany([this._graphicsLayer]),e.focus(),this.visible=!1,this.finishToolCreation(),await this._loadProjectionEngine(),this._editGeometryOperations=O.EditGeometryOperations.fromGeometry(f.project(this._graphic.geometry,e.spatialReference),b.ViewingMode.Local),this._backgroundGraphic=new a({symbol:new H({color:"transparent",outline:{type:"simple-line",color:e.effectiveTheme.accentColor,width:2}}),geometry:this._backgroundGraphicGeometry}),this._rotateGraphic=new a({symbol:new I({color:r.getContrast(e.effectiveTheme.accentColor),outline:{type:"simple-line",color:e.effectiveTheme.accentColor,width:1}}),geometry:this._rotateGraphicGeometry}),this._scaleGraphics=this._scaleGraphicGeometries.map((t=>new a({symbol:new I({size:6,style:"square",color:r.getContrast(e.effectiveTheme.accentColor),outline:{type:"simple-line",color:e.effectiveTheme.accentColor,width:1}}),geometry:t}))),this._graphicsLayer.graphics.addMany([this._backgroundGraphic,this._rotateGraphic,...this._scaleGraphics]),this._dragManipulation=new R.DragManipulation({tool:this,view:e,graphic:this._graphic}),this._rotateManipulation=new T.RotateManipulation({tool:this,view:e,graphic:this._rotateGraphic,snapRotation:this._snapRotation}),this._scaleManipulations=this._scaleGraphics.map(((t,i)=>new C.ScaleManipulation({tool:this,view:e,graphic:t,direction:N[i],preserveAspectRatio:this._preserveAspectRatio}))),this.addHandles([this._dragManipulation.createDragPipeline(this._getInfo.bind(this),this._updateGraphics.bind(this)),this._rotateManipulation.createDragPipeline(this._getInfo.bind(this),this._updateGraphics.bind(this)),...this._scaleManipulations.map((e=>e.createDragPipeline(this._getInfo.bind(this),this._updateGraphics.bind(this)))),n.watch((()=>this.view.scale),(()=>this.active?this.updateGraphics():null)),e.on("click",(async i=>{if(null!=e.activeTool&&e.activeTool!==this)return;const a=B.createScreenPointFromEvent(i),s=[];e.map.allLayers.forEach((e=>{"vector-tile"!==e.type&&"imagery"!==e.type||s.push(e)}));const r=await this.view.hitTest(a,{exclude:s}),o=r.results;if(0===o.length)e.activeTool=null;else{const i=E.findFirstGraphicHit(r.results),a="georeference"in t,s=o.map((e=>"media"===e.type?e.element:null)).filter(Boolean),n=new Set([...this._graphicsLayer.graphics,a?null:t].filter(Boolean));a&&s.includes(t)||null!=i&&n.has(i.graphic)?null==e.activeTool&&(e.activeTool=this):e.activeTool=null}}))]);const i=e=>{this.addHandles(e.events.on("grab-changed",(e=>{"georeference"in t&&("start"===e.action?t.opacity*=.5:"end"===e.action&&(t.opacity*=2))})))};this._dragManipulation.forEachManipulator(i),this._rotateManipulation.forEachManipulator(i),this._scaleManipulations.forEach((e=>e.forEachManipulator(i)));const s=new P.KeyBindings;s.addToggle(P.mediaKeys.preserveAspectRatio,(()=>{null==this.preserveAspectRatio&&(this._preserveAspectRatio.enabled=!this._preserveAspectRatio.enabled)})),s.addToggle(P.mediaKeys.rotateIncrements,(()=>{null==this.snapRotation&&(this._snapRotation.enabled=!this._snapRotation.enabled)})),s.add(P.mediaKeys.toggleOpacity,(()=>{"georeference"in t&&(t.opacity*=this._isOpacityToggled?2:.5,this._isOpacityToggled=!this._isOpacityToggled)})),s.addToggle(P.mediaKeys.factorModifier,(e=>this._factor="key-down"===e.type?W:q)),s.add(P.mediaKeys.scaleUp,(()=>this._scale(this._factor))),s.add(P.mediaKeys.scaleDown,(()=>this._scale(-this._factor))),s.add(P.mediaKeys.moveUp,(()=>this._move(0,this._factor))),s.add(P.mediaKeys.moveDown,(()=>this._move(0,-this._factor))),s.add(P.mediaKeys.moveLeft,(()=>this._move(-this._factor,0))),s.add(P.mediaKeys.moveRight,(()=>this._move(this._factor,0))),this.addHandles([e.on("key-down",(t=>{e.activeTool===this&&s.dispatch(e.inputManager,t)})),e.on("key-up",(t=>{e.activeTool===this&&s.dispatch(e.inputManager,t)}))])}async _loadProjectionEngine(){const e=this._graphic.geometry;return f.initializeProjection(e.spatialReference,this.view.spatialReference)}_updateDisplayPlaneConrers(e){const{basis1:t,basis2:i,origin:a}=e,s=this._cornerA;g.add(s,a,t),g.add(s,s,i);const r=this._cornerB;g.add(r,a,t),g.subtract(r,r,i);const o=this._cornerC;g.subtract(o,a,t),g.subtract(o,o,i);const n=this._cornerD;g.subtract(n,a,t),g.add(n,n,i)}_getInfo(){return{editGeometryOperations:this._editGeometryOperations,plane:this._plane,displayPlane:this._displayPlane}}_updateGraphics(e,t){"start"===e.action&&(this._sharedUndoStack.push({tool:this,operation:t}),this._sharedRedoStack.length=0),this.updateGraphics()}_scale(e){const t=this._editGeometryOperations,i=t.data.geometry.extent?.width,a=(i+e*this.view.resolution)/i,s=t.scale(this._plane.origin,u.UNIT_X,a,a,U.AccumulationBehavior.NEW_STEP,D.AccumulationType.REPLACE);this._sharedUndoStack.push({tool:this,operation:s}),this._sharedRedoStack.length=0,this.updateGraphics()}_move(e,t){const i=this._editGeometryOperations.move(e*this.view.resolution,t*this.view.resolution,0,U.AccumulationBehavior.NEW_STEP);this._sharedUndoStack.push({tool:this,operation:i}),this._sharedRedoStack.length=0,this.updateGraphics()}},t.__decorate([l.property()],e.TransformTool.prototype,"_plane",null),t.__decorate([l.property()],e.TransformTool.prototype,"_backgroundGraphicGeometry",null),t.__decorate([l.property()],e.TransformTool.prototype,"_rotateGraphicGeometry",null),t.__decorate([l.property()],e.TransformTool.prototype,"_scaleGraphicGeometries",null),t.__decorate([l.property()],e.TransformTool.prototype,"preserveAspectRatio",void 0),t.__decorate([l.property()],e.TransformTool.prototype,"snapRotation",void 0),t.__decorate([l.property({constructOnly:!0,nonNullable:!0})],e.TransformTool.prototype,"target",void 0),t.__decorate([l.property({readOnly:!0})],e.TransformTool.prototype,"type",void 0),t.__decorate([l.property({constructOnly:!0})],e.TransformTool.prototype,"view",void 0),e.TransformTool=t.__decorate([_.subclass("esri.views.2d.interactive.editingTools.TransformTool")],e.TransformTool),e.keys=j,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
