/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../AggregateGraphic","../../../geometry","../../../Graphic","../../../core/arrayUtils","../../../core/Collection","../../../core/compilerUtils","../../../core/Error","../../../core/handleUtils","../../../core/has","../../../core/Logger","../../../core/maybe","../../../core/object","../../../core/promiseUtils","../../../core/reactiveUtils","../../../core/accessorSupport/decorators/property","../../../core/accessorSupport/decorators/subclass","../../../layers/effects/FeatureEffectView","../../../layers/graphics/featureConversionUtils","../../../layers/support/FeatureFilter","../../../layers/support/fieldUtils","../../../layers/support/layerUtils","../../../layers/support/timeSupport","../../../rest/support/AggregateFeatureSet","../../../rest/support/FeatureSet","../../../rest/support/Query","./LayerView2D","./features/FeatureContainer","./features/FeaturePipelineWorkerProxy","./features/FeatureSourceEventLog","./features/layerAdapters/CatalogFootprintLayerAdapter","./features/layerAdapters/FeatureLayerAdapter","./features/layerAdapters/InMemoryLayerAdapter","./features/layerAdapters/KnowledgeGraphSublayerAdapter","./features/layerAdapters/OGCFeatureLayerAdapter","./features/layerAdapters/OrientedImageryLayerAdapter","./features/layerAdapters/ParquetLayerAdapter","./features/layerAdapters/StreamLayerAdapter","./features/layerAdapters/SubtypeGroupLayerAdapter","./features/schema/processor/symbols/ComplexSymbolSchema","./support/FeatureCommandQueue","./support/handleNoEngineError","./support/HighlightCounter","./support/util","../tiling/FeatureTileSubscriptionManager","../../layers/FeatureLayerView","../../layers/LayerView","../../layers/RefreshableLayerView","../../../geometry/Extent"],(function(e,t,r,a,i,s,n,o,u,l,h,c,d,p,y,g,f,m,_,w,b,E,v,A,F,S,C,x,V,k,R,q,U,I,L,Q,O,N,T,H,P,M,W,D,G,J,$,j,z){"use strict";function B(e,t){const r=new Set;return e&&e.forEach((e=>r.add(e))),t&&t.forEach((e=>r.add(e))),r.has("*")?["*"]:Array.from(r)}const Z=4294967294;let K=class extends(J(j(C.LayerView2DMixin($)))){constructor(){super(...arguments),this._commandsQueue=new P({process:e=>{switch(e.type){case"edit-by-feature":case"edit-by-id":return this._doEdit(e);case"update":return this._doUpdate();case"highlight":return this._updateHighlights()}}}),this._visibilityOverrides=new Set,this._highlightCounter=new W.HighlightCounter,this._lastAvailableFields=[],this._lastTargetState=null,this.eventLog=new k.FeatureSourceEventLog,this._sourceRefreshVersion=1,this._displayRefreshVersion=1,this._pipelineUpdating=!1,this._fields=null,this.featureEffectView=new m}destroy(){this._workerProxy?.destroy(),this._workerAttached.reject(p.createAbortError()),this._commandsQueue.destroy()}initialize(){this._workerAttached=p.createResolver(),p.ignoreAbortErrors(this._workerAttached.promise),this.addResolvingPromise(this._initProxy()),this.featureEffectView.featureEffect=this.featureEffect,this.featureEffectView.endTransition()}async _initProxy(){const e=this.layer;if("isTable"in e&&e.isTable)throw new o("featurelayerview:table-not-supported","table feature layer can't be displayed",{layer:e});if("mesh"===e.geometryType)throw new o("featurelayerview:geometry-type-not-supported",`Geometry type of ${e.geometryType} is not supported`,{layer:e});if(("feature"===e.type||"subtype-group"===e.type)&&!1===E.getEffectiveLayerCapabilities(e)?.operations.supportsQuery)throw new o("featurelayerview:query-not-supported","layer view requires a layer with query capability",{layer:e});this._workerProxy&&this._workerProxy.destroy();const t=this._createClientOptions();this._workerProxy=await V.createFeaturePipelineWorkerProxy(t)}async _attachProxy(){const e={service:await this.layerAdapter.createServiceOptions(this.view),tileInfoJSON:this.view?.featuresTilingScheme?.tileInfo?.toJSON()};let t=[];Array.isArray(e.service.source)&&(t=e.service.source);try{await this._workerProxy.pipeline.onAttach(e,{transferList:t}),this._workerAttached.resolve()}catch(r){this._workerAttached.reject(p.createAbortError()),p.throwIfNotAbortError(r)}}async _detachProxy(){return this._workerProxy.pipeline.onDetach()}async getWorker(){return await this._workerAttached.promise,this._workerProxy}get hasAllFeatures(){return this.layer.visible&&!this.suspended&&this.eventLog.hasAllFeatures}get hasAllFeaturesInView(){return this.layer.visible&&!this.suspended&&this.eventLog.hasAllFeaturesInView}get hasFullGeometries(){return this.layer.visible&&!this.suspended&&this.eventLog.hasFullGeometries}get labelingCollisionInfos(){const e=this.layerAdapter.getLabelingDeconflictionInfo(this.view),t=this.layer.geometryType,r=!this.suspended;return e.map((({vvEvaluators:e,deconflictionEnabled:a})=>({container:this.featureContainer,vvEvaluators:e,deconflictionEnabled:a,geometryType:t,visible:r})))}get layerAdapter(){switch(this.layer.type){case"feature":return"memory"===this.layer.source.type?new U.InMemoryLayerAdapter(this.layer):new q.FeatureLayerAdapter(this.layer);case"geojson":case"csv":case"wfs":return new U.InMemoryLayerAdapter(this.layer);case"parquet":return new O.ParquetLayerAdapter(this.layer);case"subtype-group":return new T.SubtypeGroupLayerAdapter(this.layer);case"ogc-feature":return new L.OGCFeatureLayerAdapter(this.layer);case"stream":return new N.StreamLayerAdapter(this.layer);case"oriented-imagery":return new Q.OrientedImageryLayerAdapter(this.layer);case"knowledge-graph-sublayer":return new I.KnowledgeGraphSublayerAdapter(this.layer);case"catalog-footprint":return new R.CatalogFootprintLayerAdapter(this.layer);default:n.neverReached(this.layer)}return null}get timeExtent(){return v.combineTimeExtent(this.layerAdapter.timeOptions,this.view?.timeExtent,this._get("timeExtent"))}getDisplayStatistics(e,t){return this.featureContainer?.getDisplayStatistics(e,t)}async queryHeatmapStatistics(e){return(await this.getWorker()).pipeline.queryHeatmapStatistics(e)}highlight(e,t="default"){let r;e instanceof a?r=[e.getObjectId()]:"number"==typeof e||"string"==typeof e?r=[e]:s.isCollection(e)&&e.length>0?r=e.map((e=>e?.getObjectId())).toArray():Array.isArray(e)&&e.length>0&&(r="number"==typeof e[0]||"string"==typeof e[0]?e:e.map((e=>e?.getObjectId())));const n=r?.filter(i.isSome);return n?.length?(this._addHighlights(n,t),u.makeHandle((()=>this._removeHighlights(n,t)))):u.makeHandle()}getHighlightIds(){return Array.from(this._highlightCounter.ids())}hasHighlight(){return!this._highlightCounter.empty}async hitTest(e,r){const i=await this.featureContainer.hitTest(r);if(0===i.length)return null;const s=await this.getWorker(),{features:n,aggregates:o}=await s.pipeline.getDisplayFeatures(i),u=this.featureContainer.getSortKeys(i),l=({displayId:e},{displayId:t})=>u.has(e)&&u.has(t)?u.get(e)-u.get(t):e-t;return n.sort(l).reverse(),o.sort(l).reverse(),[...o.map((r=>this._createGraphicHit(e,t.fromJSON(r)))),...n.map((t=>this._createGraphicHit(e,a.fromJSON(t))))]}async queryStatistics(){const e=await this.getWorker();return M.handleNoEngineError(e.pipeline.queryStatistics(),{featureCount:0,ringCount:0,vertexCount:0})}async querySummaryStatistics(e,t,r){const a=await this.getWorker(),i={...t,scale:this.view.scale},s=a.features.executeQueryForSummaryStatistics(this._cleanUpQuery(e),i,r);return M.handleNoEngineError(s,{})}async queryAggregateSummaryStatistics(e,t,r){const a={...t,scale:this.view.scale},i=(await this.getWorker()).aggregates.executeQueryForSummaryStatistics(this._cleanUpAggregateQuery(e),a,r);return M.handleNoEngineError(i,{})}async queryUniqueValues(e,t,r){const a=await this.getWorker(),i={...t,scale:this.view.scale},s=a.features.executeQueryForUniqueValues(this._cleanUpQuery(e),i,r);return M.handleNoEngineError(s,{uniqueValueInfos:[]})}async queryAggregateUniqueValues(e,t,r){const a=await this.getWorker(),i={...t,scale:this.view.scale},s=a.aggregates.executeQueryForUniqueValues(this._cleanUpAggregateQuery(e),i,r);return M.handleNoEngineError(s,{uniqueValueInfos:[]})}async queryClassBreaks(e,t,r){const a=await this.getWorker(),i={...t,scale:this.view.scale},s=a.features.executeQueryForClassBreaks(this._cleanUpQuery(e),i,r);return M.handleNoEngineError(s,{classBreakInfos:[]})}async queryAggregateClassBreaks(e,t,r){const a=await this.getWorker(),i={...t,scale:this.view.scale},s=a.aggregates.executeQueryForClassBreaks(this._cleanUpAggregateQuery(e),i,r);return M.handleNoEngineError(s,{classBreakInfos:[]})}async queryHistogram(e,t,r){const a=await this.getWorker(),i={...t,scale:this.view.scale},s=a.features.executeQueryForHistogram(this._cleanUpQuery(e),i,r);return M.handleNoEngineError(s,{bins:[],maxValue:null,minValue:null,normalizationTotal:null})}async queryAggregateHistogram(e,t,r){const a=await this.getWorker(),i={...t,scale:this.view.scale},s=a.aggregates.executeQueryForHistogram(this._cleanUpAggregateQuery(e),i,r);return M.handleNoEngineError(s,{bins:[],maxValue:null,minValue:null,normalizationTotal:null})}queryFeatures(e,t){return this.queryFeaturesJSON(e,t).then((e=>{const t=F.fromJSON(e);return t.features.forEach((e=>this._setLayersForFeature(e))),t}))}async queryVisibleFeatures(e,t){const r=(await this.getWorker()).pipeline.queryVisibleFeatures(this._cleanUpQuery(e),t),a=await M.handleNoEngineError(r,{features:[]}),i=F.fromJSON(a);return i.features.forEach((e=>this._setLayersForFeature(e))),i}async queryAggregates(e,t){const r=(await this.getWorker()).aggregates.executeQuery(this._cleanUpAggregateQuery(e),t),a=await M.handleNoEngineError(r,{features:[]}),i=A.fromJSON(a);return i.features.forEach((e=>this._setLayersForFeature(e))),i}async queryAggregateIds(e,t){const r=(await this.getWorker()).aggregates.executeQueryForIds(this._cleanUpAggregateQuery(e),t);return M.handleNoEngineError(r,[])}async queryAggregateCount(e,t){const r=(await this.getWorker()).aggregates.executeQueryForCount(this._cleanUpAggregateQuery(e),t);return M.handleNoEngineError(r,0)}async queryAggregateJSON(e,t){const r=(await this.getWorker()).aggregates.executeQuery(this._cleanUpAggregateQuery(e),t);return M.handleNoEngineError(r,{features:[]})}async queryFeaturesJSON(e,t){const r=(await this.getWorker()).features.executeQuery(this._cleanUpQuery(e),t);return M.handleNoEngineError(r,{features:[]})}async queryObjectIds(e,t){const r=(await this.getWorker()).features.executeQueryForIds(this._cleanUpQuery(e),t);return M.handleNoEngineError(r,[])}async queryFeatureCount(e,t){const r=(await this.getWorker()).features.executeQueryForCount(this._cleanUpQuery(e),t);return M.handleNoEngineError(r,0)}async queryExtent(e,t){const r=(await this.getWorker()).features.executeQueryForExtent(this._cleanUpQuery(e),t),a=await M.handleNoEngineError(r,{count:0,extent:null});return{count:a.count,extent:z.fromJSON(a.extent)}}async getSampleFeatures(e){return(await this.getWorker()).pipeline.getSampleFeatures(e)}setVisibility(e,t){t?this._visibilityOverrides.delete(e):this._visibilityOverrides.add(e),this._update()}update(e){if(!this._subscriptionManager)return;this.view.animation&&!this._lastTargetState&&(this._lastTargetState=e.state.clone()),!this.view.animation&&this._lastTargetState&&(this._lastTargetState=null);const t=this._subscriptionManager.update(e.targetState,this._lastTargetState);this.featureContainer.setVisibleTiles(t)}attach(){l("esri-2d-update-debug")&&console.debug("FeatureLayerView2D.attach"),p.ignoreAbortErrors(this._updatingHandles.addPromise(this._workerAttached.promise)),p.ignoreAbortErrors(this._attachProxy()),this.featureContainer=new x.FeatureContainer(this),this.container.addChild(this.featureContainer),this.view.timeline.record(`${this.layer.title} (FeatureLayer) Attach`),this._subscriptionManager=new G.FeatureTileSubscriptionManager({tileInfoView:this.view.featuresTilingScheme,updateSubscriptions:e=>{this.featureContainer.updateSubscriptions(e),p.ignoreAbortErrors(this._updatingHandles.addPromise(this.getWorker().then((t=>t.pipeline.updateSubscriptions(e)))))},isDone:e=>this.featureContainer.isDone(e)}),this.requestUpdate(),this.addAttachHandles([y.watch((()=>JSON.stringify({displayRefreshVersion:this._displayRefreshVersion,timeExtent:this.timeExtent,clips:this.clips,filter:this.filter,featureEffect:this.featureEffect,sourceRefreshVersion:this._sourceRefreshVersion,timeZone:this.view.timeZone,effect:this.featureEffect,...this.layerAdapter.getUpdateHashProperties(this.view)})),(()=>this._update()),y.initial),y.watch((()=>this.updateSuspended),(e=>{e||(this._subscriptionManager.resume(),this.view.labelManager.requestUpdate())})),y.watch((()=>this.visible),(e=>{this.view.labelManager.requestUpdate()}))]),"stream"!==this.layer.type&&"parquet"!==this.layer.type&&"catalog-footprint"!==this.layer.type&&this.addAttachHandles(this.layer.on("edits",(e=>this._edit(e))))}detach(){l("esri-2d-update-debug")&&console.debug("FeatureLayerView2D.detach"),this._detachProxy(),this._fields=null,this.featureContainer.destroy(),this.featureContainer=null,this._commandsQueue.clear(),this.container.removeAllChildren(),this._subscriptionManager=c.destroyMaybe(this._subscriptionManager),this._workerProxy.pipeline.onDetach(),this._workerAttached=p.createResolver(),p.ignoreAbortErrors(this._workerAttached.promise),this._lastAvailableFields=[],this._lastSchema=null}viewChange(){this.requestUpdate()}moveEnd(){this.requestUpdate()}isUpdating(){const e="renderer"in this.layer&&null!=this.layer.renderer,t=this._commandsQueue.updateTracking.updating,r=null!=this._updatingRequiredFieldsPromise,a=this.featureContainer.updatingHandles.updating,i=this.updateRequested||e&&(t||r)||a||this._pipelineUpdating||this.dataUpdating;if(l("esri-2d-log-updating")){console.log(`Updating FLV2D (${this.layer.id}): ${i}\n  -> updateRequested ${this.updateRequested}\n  -> hasRenderer ${e}\n  -> updatingRequiredFields ${r}\n  -> hasPendingCommand ${t}\n  -> dataUpdating ${this.dataUpdating}\n  -> processing ${this._pipelineUpdating}\n  -> updatingContainer ${a}\n`);for(const e of this.featureContainer.subscriptions())console.log(`    -> Tile[${e.id}] Done: ${e.done}`)}return i}_createClientOptions(){const e=this;return{get container(){return e.featureContainer},setUpdating:e=>{this._set("_pipelineUpdating",e.pipeline),this._set("dataUpdating",e.data)},emitEvent:e=>{this.emit(e.name,e.event)},get eventLog(){return e.eventLog},fetch:t=>Promise.all(t.map((t=>e.view.stage.painter.textureManager.rasterizeItem(t)))),fetchDictionary:e=>Promise.all(e.map((e=>this._fetchDictionaryRequest(e))))}}async _fetchDictionaryRequest(e){try{if("subtype-group"===this.layer.type)throw new Error("InternalError: SubtypeGroupLayer does not support dictionary renderer");const t=this.layer.renderer;if(!t||"dictionary"!==t.type)throw new Error("InternalError: Expected layer to have a DictionaryRenderer");const r=this._lastSchema.processor.mesh.factory.symbology;if("dictionary"!==r.type)throw new Error("InternalError: Expected schema to be of type 'dictionary'");const a={cimAnalyzer:this.view.stage.cimAnalyzer,cimResourceManager:this.view.stage.painter.textureManager.resourceManager,store:this.featureContainer.instanceStore,scaleExpression:r.scaleExpression};this._fields||(this._fields=this.layer.fields.map((e=>e.toJSON())));const i=r.visualVariableUniforms,s=await t.getSymbolAsync(e.feature,{fields:this._fields});if(!s||!s.data)return{type:"dictionary-response",meshes:[]};return{type:"dictionary-response",meshes:await H.createComplexSymbolInstances(s.data,{uniforms:i,path:"renderer",schemaOptions:a})}}catch(t){return{type:"dictionary-response",meshes:[]}}}_cleanUpQuery(e){const t=S.from(e)||this.createQuery();return t.outSpatialReference||(t.outSpatialReference=this.view.spatialReference),t.toJSON()}_cleanUpAggregateQuery(e){const t=S.from(e)||this.createAggregateQuery();t.outSpatialReference||(t.outSpatialReference=this.view.spatialReference);const r=t.objectIds??[];for(const a of t.aggregateIds??[])r.push(a);return t.objectIds=r,t.aggregateIds=[],t.toJSON()}async _update(){return this._commandsQueue.push({type:"update"})}async _edit(e){if(this.updateSuspended)return void this._subscriptionManager.suspend();const t=this._getEffectiveEdit(e);return t?this._commandsQueue.push(t).catch(p.throwIfNotAbortError):void 0}async doRefresh(e){this.attached&&(this.updateSuspended&&e||(e?this.incrementSourceRefreshVersion():this.incrementDisplayRefreshVersion()))}incrementSourceRefreshVersion(){this._sourceRefreshVersion=(this._sourceRefreshVersion+1)%Z+1}incrementDisplayRefreshVersion(){this._displayRefreshVersion=(this._displayRefreshVersion+1)%Z+1}_getEffectiveEdit(e){const t="globalIdField"in this.layer&&this.layer.globalIdField,r=e.deletedFeatures.some((e=>-1===e.objectId||!e.objectId)),a=t&&this.availableFields.includes(t);if(r&&!a)return h.getLogger(this).error(new o("mapview-apply-edits",`Editing the specified service requires the layer's globalIdField, ${t} to be included the layer's outFields for updates to be reflected on the map`)),null;const i=this.layer,s=e.historicMoment?.getTime()??null,n="layerId"in i&&e.editedFeatures?.find((e=>e.layerId===i.layerId));if(n&&this._canEditByFeature(n)){const e=!1,r=!1,a=D.toJSONGeometryType(this.layer.geometryType),{adds:i,deletes:o,updates:u}=n.editedFeatures,l=this.layer.objectIdField,h=i.map((t=>_.convertFromFeature(t,a,e,r))),c=u.map((t=>_.convertFromFeature(t.current,a,e,r)));return{type:"edit-by-feature",added:h,removed:o.map((e=>"attributes"in e?{globalId:t?e.attributes[t]:null,objectId:l?e.attributes[l]:null}:e)),updated:c,historicMoment:s}}return{type:"edit-by-id",added:e.addedFeatures,updated:e.updatedFeatures,removed:e.deletedFeatures,historicMoment:s}}_canEditByFeature(e){const{adds:t,updates:r}=e.editedFeatures;return t.every((e=>this.view.spatialReference.equals(e.geometry?.spatialReference)))&&r.every((e=>this.view.spatialReference.equals(e.current.geometry?.spatialReference)))}async _doUpdate(){"featureReduction"in this.layer&&this.layer.featureReduction&&this.layer.featureReduction!==this._lastFeatureReduction&&(this.layer.featureReduction=this.layer.featureReduction?.clone(),this._lastFeatureReduction=this.layer.featureReduction);try{if(await this._updateRequiredFields(),this.destroyed||!this.layerAdapter?.hasRequiredSupport||!this._subscriptionManager)return;const e=this.featureContainer.instanceStore;this.featureContainer.attributeView.lockTextureUploads(),e.updateStart();const t=this.featureEffect,r={store:e,cimAnalyzer:this.view.stage.cimAnalyzer,cimResourceManager:this.view.stage.painter.textureManager.resourceManager,scaleExpression:void 0},a=this._createViewSchemaConfig(),i={source:this.layerAdapter.createSourceSchema(a,this._sourceRefreshVersion),processor:await this.layerAdapter.createProcessorSchema(r,a,this._displayRefreshVersion)},s=d.notDeepEqual(this._lastSchema?.source.mutable,i.source.mutable)||d.notDeepEqual(this._lastSchema?.processor,i.processor);if(!s)return this.featureContainer.requestRender(),this.featureContainer.attributeView.unlockTextureUploads(),e.updateEnd(),void(this.featureEffectView.featureEffect=t);this._lastSchema=i,this._fields=null;const n=Math.round(performance.now());l("esri-2d-update-debug")&&console.debug(`Id[${this.layer.uid}] Version[${n}] FeatureLayerView2D._doUpdate`,{changes:s});const o=await this.getWorker();await o.pipeline.updateSchema(i,n),e.updateEnd(),this.featureEffectView.featureEffect=t,this.featureEffectView.endTransition(),this.featureContainer.restartAllAnimations(),this.featureContainer.attributeView.unlockTextureUploads(),this.featureContainer.swapRenderState(),this.featureContainer.requestRender(),l("esri-2d-update-debug")&&console.debug(`Version[${n}] FeatureLayerView2D.updateEnd`),this.requestUpdate()}catch(e){l("esri-2d-update-debug")&&console.error("Encountered an error during update",e)}}async _doEdit(e){const t=await this.getWorker();try{this.featureContainer.editStart(),await t.pipeline.onEdits(e),this.featureContainer.editEnd()}catch(r){p.isAbortError(r),0}}get hasFilter(){const e=this.layerAdapter.hasFilters?.(this.view)??!1;return null!=this.filter||null!=this.timeExtent||this._visibilityOverrides.size>0||e}_getEffectiveAvailableFields(e){const t=B(this._lastAvailableFields,e);return this._lastAvailableFields=t,b.packFields(this.layer.fieldsIndex,t)}_createViewSchemaConfig(){const e=[X(this.view,this.layerAdapter,this.timeExtent,this._visibilityOverrides,this.filter),this.featureEffect?.filter?.toJSON()??null];return{availableFields:this._getEffectiveAvailableFields(this.availableFields),filters:e,scale:this.view.scale,timeZone:this.view.timeZone}}_addHighlights(e,t){this._highlightCounter.addGroup(e,t),this._commandsQueue.push({type:"highlight"})}_removeHighlights(e,t){this._highlightCounter.deleteGroup(e,t),this._commandsQueue.push({type:"highlight"})}async _updateHighlights(){const e=[];for(const a of this._highlightCounter.ids()){const t=this._highlightCounter.getHighlightGroups(a),r=this._getHighlightBits(t);e.push({objectId:a,highlightFlags:r})}const t=await this.getWorker();if(this.destroyed)return;const r=t.pipeline.updateHighlight({highlights:e}).catch((e=>{p.isAbortError(e)||h.getLogger(this).error(e)}));this._updatingHandles.addPromise(r)}_setLayersForFeature(e){e.layer=e.sourceLayer=this.layer,this.layerAdapter.setGraphicOrigin&&this.layerAdapter.setGraphicOrigin(e)}_createGraphicHit(e,t){return this._setLayersForFeature(t),null!=t.geometry&&(t.geometry.spatialReference=this.view.spatialReference),{type:"graphic",graphic:t,layer:this.layer,mapPoint:e}}};function X(e,t,r,a,i){i&&(i=i.clone());const s=null!=i?i.timeExtent:null,n=null!=r&&null!=s?r.intersection(s):r||s;n&&(i??=new w,i.timeExtent=n),i=t.addFilters?.(i,e)??i;let o=i?.toJSON()??null;return a.size&&(o??=(new w).toJSON(),o.hiddenIds=Array.from(a)),o}e.__decorate([g.property()],K.prototype,"_commandsQueue",void 0),e.__decorate([g.property()],K.prototype,"_sourceRefreshVersion",void 0),e.__decorate([g.property()],K.prototype,"_displayRefreshVersion",void 0),e.__decorate([g.property({readOnly:!0})],K.prototype,"_pipelineUpdating",void 0),e.__decorate([g.property({readOnly:!0})],K.prototype,"hasAllFeatures",null),e.__decorate([g.property({readOnly:!0})],K.prototype,"hasAllFeaturesInView",null),e.__decorate([g.property({readOnly:!0})],K.prototype,"hasFullGeometries",null),e.__decorate([g.property()],K.prototype,"featureEffectView",void 0),e.__decorate([g.property()],K.prototype,"labelingCollisionInfos",null),e.__decorate([g.property()],K.prototype,"layerAdapter",null),e.__decorate([g.property({readOnly:!0})],K.prototype,"timeExtent",null),e.__decorate([g.property()],K.prototype,"updating",void 0),K=e.__decorate([f.subclass("esri.views.2d.layers.FeatureLayerView2D")],K);return K}));
