/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../core/Logger","../../../core/promiseUtils","../../../core/reactiveUtils","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../../layers/support/rasterDatasets/multidimensionalUtils","../engine/flow/FlowView2D","./LayerView2D","./imagery/ImageryTileView2D","./imagery/VectorFieldTileView2D","./support/util","../../layers/ImageryTileLayerView","../../layers/LayerView","../../layers/RefreshableLayerView"],(function(e,i,s,t,r,a,o,n,u,h,l,c,d,p,w,b,v){"use strict";let y=class extends(w(v(l.LayerView2DMixin(b)))){constructor(){super(...arguments),this._useWebGLForProcessing=!0,this._useProgressiveUpdate=!0,this.subview=null}get useWebGLForProcessing(){return this._useWebGLForProcessing}set useWebGLForProcessing(e){this._useWebGLForProcessing=e,this.subview&&"useWebGLForProcessing"in this.subview&&(this.subview.useWebGLForProcessing=e)}get useProgressiveUpdate(){return this._useWebGLForProcessing}set useProgressiveUpdate(e){this._useProgressiveUpdate=e,this.subview&&"useProgressiveUpdate"in this.subview&&(this.subview.useProgressiveUpdate=e)}get displayParameters(){const{layer:e}=this,i=this._get("displayParameters");return e.renderer?{bandIds:e.bandIds,renderer:e.renderer,interpolation:e.interpolation,multidimensionalDefinition:e.multidimensionalDefinition,rasterFunction:"imagery-tile"===e.type?e.rasterFunction:null}:i}update(e){this.subview?.update(e),this.notifyChange("updating")}isUpdating(){return!this.subview||this.subview.updating}attach(){this.layer.increaseRasterJobHandlerUsage(),this._updateSubview(),this.addAttachHandles([t.watch((()=>this.displayParameters),((e,t)=>{const r=e.interpolation!==t?.interpolation&&("majority"===e.interpolation||"majority"===t?.interpolation)&&p.canUseMajorityInterpolationOnDataSource(this.layer),a=e.renderer!==t?.renderer&&this._getSubviewType(t?.renderer)!==this._getSubviewType(e.renderer);a&&this._updateSubview();const o=e.multidimensionalDefinition!==t?.multidimensionalDefinition,n=e.rasterFunction!==t?.rasterFunction,u=n&&!this._useWebGLForProcessing,h=o||r||a||u;this.subview.redrawOrRefetch({refetch:h,reprocess:n}).catch((e=>{s.isAbortError(e)||i.getLogger(this).error(e)})),this.notifyChange("updating")})),t.watch((()=>this.layer.multidimensionalSubset??null),((e,t)=>{const{multidimensionalDefinition:r}=this.layer;null!=r&&u.hasExcludedVariableOrDimension(r,e)!==u.hasExcludedVariableOrDimension(r,t)&&(this.subview.redrawOrRefetch({refetch:!0}).catch((e=>{s.isAbortError(e)||i.getLogger(this).error(e)})),this.notifyChange("updating"))}),t.sync),t.watch((()=>this.timeExtent),(()=>{this.subview.timeExtent=this.timeExtent,this.subview.redrawOrRefetch({refetch:!0}).catch((e=>{s.isAbortError(e)||i.getLogger(this).error(e)}))}),t.initial)])}detach(){this.layer.decreaseRasterJobHandlerUsage(),this._detachSubview(this.subview),this.subview?.destroy(),this.subview=null}viewChange(){this.requestUpdate()}moveEnd(){this.subview.moveEnd()}doRefresh(){return this.subview?this.subview.doRefresh():Promise.resolve()}_updateSubview(){const{renderer:e}=this.layer;if(!e)return;const i=this._getSubviewType(e);if(this.subview){if(this.subview.type===i)return void this._attachSubview(this.subview);this._detachSubview(this.subview),this.subview?.destroy(),this.subview=null}const{layer:s}=this;let t;if(t="rasterVF"===i?new d({layer:s,layerView:this,scheduler:this.scheduler}):"flow"===i?new h({layer:s,layerView:this,scheduler:this.scheduler}):new c({layer:s,layerView:this,scheduler:this.scheduler}),"useWebGLForProcessing"in t&&(t.useWebGLForProcessing=this._useWebGLForProcessing),"useProgressiveUpdate"in t&&(t.useProgressiveUpdate=this._useProgressiveUpdate),"previousLOD"in t){const{subview:e}=this;t.previousLOD=e&&"previousLOD"in e?e.previousLOD:null}this._attachSubview(t),this.subview=t,this.requestUpdate()}_attachSubview(e){e&&!e.attached&&(e.attach(),e.attached=!0,this.container.addChildAt(e.container,0))}_detachSubview(e){e?.attached&&(this.container.removeChild(e.container),e.detach(),e.attached=!1)}_getSubviewType(e){const i=e?.type;return"vector-field"===i?"rasterVF":"flow"===i?"flow":"raster"}};e.__decorate([r.property()],y.prototype,"subview",void 0),e.__decorate([r.property()],y.prototype,"useWebGLForProcessing",null),e.__decorate([r.property()],y.prototype,"useProgressiveUpdate",null),e.__decorate([r.property({readOnly:!0})],y.prototype,"displayParameters",null),y=e.__decorate([n.subclass("esri.views.2d.layers.ImageryTileLayerView2D")],y);return y}));
