/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../kernel","../../../core/Collection","../../../core/maybe","../../../core/reactiveUtils","../../../core/urlUtils","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/Logger","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../../geometry/Extent","../../../geometry/projection","../../../geometry/SpatialReference","../../../layers/support/kmlUtils","../../../rest/utils","../../../support/GraphicsCollection","../engine/Bitmap","../engine/BitmapContainer","./LayerView2D","./graphics/GraphicContainer","./graphics/GraphicsView2D","../../layers/LayerView","../../support/imageReprojection"],(function(e,i,t,a,s,l,o,r,n,h,p,c,y,d,m,g,u,w,_,b,V,v,f,S){"use strict";class C{constructor(){this.allSublayers=new Map,this.allPoints=[],this.allPolylines=[],this.allPolygons=[],this.allMapImages=[]}}let I=class extends(b.LayerView2DMixin(f)){constructor(){super(...arguments),this._bitmapIndex=new Map,this._mapImageContainer=new _.BitmapContainer,this._kmlVisualData=new C,this._fetchController=null,this.allVisiblePoints=new u.GraphicsCollection,this.allVisiblePolylines=new u.GraphicsCollection,this.allVisiblePolygons=new u.GraphicsCollection,this.allVisibleMapImages=new t}async hitTest(e,i){const t=this.layer;return[this._pointsView?.hitTest(e),this._polylinesView?.hitTest(e),this._polygonsView?.hitTest(e)].flat().filter(Boolean).map((i=>(i.layer=t,i.sourceLayer=t,{type:"graphic",graphic:i,layer:t,mapPoint:e})))}update(e){this._polygonsView&&this._polygonsView.processUpdate(e),this._polylinesView&&this._polylinesView.processUpdate(e),this._pointsView&&this._pointsView.processUpdate(e)}attach(){this._fetchController=new AbortController,this.container.addChild(this._mapImageContainer),this._polygonsView=new v({view:this.view,graphics:this.allVisiblePolygons,requestUpdateCallback:()=>this.requestUpdate(),container:new V(this.view.featuresTilingScheme)}),this.container.addChild(this._polygonsView.container),this._polylinesView=new v({view:this.view,graphics:this.allVisiblePolylines,requestUpdateCallback:()=>this.requestUpdate(),container:new V(this.view.featuresTilingScheme)}),this.container.addChild(this._polylinesView.container),this._pointsView=new v({view:this.view,graphics:this.allVisiblePoints,requestUpdateCallback:()=>this.requestUpdate(),container:new V(this.view.featuresTilingScheme)}),this.container.addChild(this._pointsView.container),this.addAttachHandles([this.allVisibleMapImages.on("change",(e=>{e.added.forEach((e=>this._addMapImage(e))),e.removed.forEach((e=>this._removeMapImage(e)))})),s.watch((()=>this.layer.visibleSublayers),(e=>{for(const i of this._kmlVisualData.allSublayers.values())i.visibility=0;for(const i of e){const e=this._kmlVisualData.allSublayers.get(i.id);e&&(e.visibility=1)}this._refreshCollections()}))]),this._updatingHandles.addPromise(this._fetchService(this._fetchController.signal)),this._imageReprojector=new S.ImageReprojector}detach(){this._fetchController=a.abortMaybe(this._fetchController),this._mapImageContainer.removeAllChildren(),this.container.removeAllChildren(),this._bitmapIndex.clear(),this._polygonsView=a.destroyMaybe(this._polygonsView),this._polylinesView=a.destroyMaybe(this._polylinesView),this._pointsView=a.destroyMaybe(this._pointsView),this._imageReprojector=a.destroyMaybe(this._imageReprojector)}viewChange(){this._polygonsView.viewChange(),this._polylinesView.viewChange(),this._pointsView.viewChange()}moveEnd(){}isUpdating(){return this._pointsView.updating||this._polygonsView.updating||this._polylinesView.updating}_addMapImage(e){(this.view.spatialReference?.isWGS84||this.view.spatialReference?.isWebMercator)&&this._imageReprojector.loadAndReprojectBitmapData(e.href,c.fromJSON(e.extent),this.view.spatialReference).then((i=>{const t=new w.Bitmap(i.bitmapData);t.x=i.extent.xmin,t.y=i.extent.ymax,t.resolution=i.extent.width/i.bitmapData.width,t.rotation=e.rotation,this._mapImageContainer.addChild(t),this._bitmapIndex.set(e,t)}))}async _getViewDependentUrl(e,t){const{viewFormat:a,viewBoundScale:s,httpQuery:o}=e;if(null!=a){if(null==t)throw new Error("Loading this network link requires a view state.");let r;if(await y.load(),null!=s&&1!==s){const e=new c(t.extent);e.expand(s),r=e}else r=t.extent;r=y.project(r,d.WGS84);const n=y.project(r,d.WebMercator),h=r.xmin,p=r.xmax,m=r.ymin,u=r.ymax,w=t.size[0]*t.pixelRatio,_=t.size[1]*t.pixelRatio,b=Math.max(n.width,n.height),V={"[bboxWest]":h.toString(),"[bboxEast]":p.toString(),"[bboxSouth]":m.toString(),"[bboxNorth]":u.toString(),"[lookatLon]":r.center.x.toString(),"[lookatLat]":r.center.y.toString(),"[lookatRange]":b.toString(),"[lookatTilt]":"0","[lookatHeading]":t.rotation.toString(),"[lookatTerrainLon]":r.center.x.toString(),"[lookatTerrainLat]":r.center.y.toString(),"[lookatTerrainAlt]":"0","[cameraLon]":r.center.x.toString(),"[cameraLat]":r.center.y.toString(),"[cameraAlt]":b.toString(),"[horizFov]":"60","[vertFov]":"60","[horizPixels]":w.toString(),"[vertPixels]":_.toString(),"[terrainEnabled]":"0","[clientVersion]":i.version,"[kmlVersion]":"2.2","[clientName]":"ArcGIS API for JavaScript","[language]":"en-US"},v=e=>{for(const i in e){let t;for(t in V)e[i]=e[i].replace(t,V[t])}},f=l.queryToObject(a);v(f);let S={};null!=o&&(S=l.queryToObject(o),v(S));const C=g.parseUrl(e.href);C.query={...C.query,...f,...S};return`${C.path}?${l.objectToQuery(f)}`}return e.href}async _fetchService(e){const i=new C;await this._loadVisualData(this.layer.url,i,e),this._kmlVisualData=i,this._refreshCollections()}_refreshCollections(){this.allVisiblePoints.removeAll(),this.allVisiblePolylines.removeAll(),this.allVisiblePolygons.removeAll(),this.allVisibleMapImages.removeAll(),this.allVisiblePoints.addMany(this._kmlVisualData.allPoints.filter((e=>this._isSublayerVisible(e.sublayerId))).map((({item:e})=>e))),this.allVisiblePolylines.addMany(this._kmlVisualData.allPolylines.filter((e=>this._isSublayerVisible(e.sublayerId))).map((({item:e})=>e))),this.allVisiblePolygons.addMany(this._kmlVisualData.allPolygons.filter((e=>this._isSublayerVisible(e.sublayerId))).map((({item:e})=>e))),this.allVisibleMapImages.addMany(this._kmlVisualData.allMapImages.filter((e=>this._isSublayerVisible(e.sublayerId))).map((({item:e})=>e)))}_isSublayerVisible(e){const i=this._kmlVisualData.allSublayers.get(e);return!!i?.visibility&&(-1===i.parentFolderId||this._isSublayerVisible(i.parentFolderId))}_loadVisualData(e,i,t){return this._fetchParsedKML(e,t).then((async e=>{for(const a of e.sublayers){i.allSublayers.set(a.id,a);const e=a.points?await m.getGraphics(a.points):[],s=a.polylines?await m.getGraphics(a.polylines):[],l=a.polygons?await m.getGraphics(a.polygons):[],o=a.mapImages||[];if(i.allPoints.push(...e.map((e=>({item:e,sublayerId:a.id})))),i.allPolylines.push(...s.map((e=>({item:e,sublayerId:a.id})))),i.allPolygons.push(...l.map((e=>({item:e,sublayerId:a.id})))),i.allMapImages.push(...o.map((e=>({item:e,sublayerId:a.id})))),a.networkLink){const e=await this._getViewDependentUrl(a.networkLink,this.view.state);await this._loadVisualData(e,i,t)}}}))}_fetchParsedKML(e,i){return m.fetchService(e,this.layer.spatialReference,this.layer.refreshInterval,i).then((e=>m.parseKML(e.data)))}_removeMapImage(e){const i=this._bitmapIndex.get(e);i&&(this._mapImageContainer.removeChild(i),this._bitmapIndex.delete(e))}};e.__decorate([o.property()],I.prototype,"_pointsView",void 0),e.__decorate([o.property()],I.prototype,"_polylinesView",void 0),e.__decorate([o.property()],I.prototype,"_polygonsView",void 0),e.__decorate([o.property()],I.prototype,"updating",void 0),I=e.__decorate([p.subclass("esri.views.2d.layers.KMLLayerView2D")],I);return I}));
