/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../chunks/tslib.es6","../../../core/Collection","../../../core/collectionUtils","../../../core/Error","../../../core/Logger","../../../core/reactiveUtils","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../../linkChart/utils","../engine/Container","./support/util","../support/HighlightGroup","../support/highlightGroupUtils","../support/HighlightOptions","../../layers/support/ClipRect","../../layers/support/Geometry","../../layers/support/Path","../../support/layerViewUtils"],(function(e,t,i,s,r,a,o,h,n,p,l,c,d,u,g,y,f,v,_,w,R){"use strict";const m=i.ofType({key:"type",base:null,typeMap:{rect:v,path:w,geometry:_}}),S=new(i.ofType(g.HighlightGroup)),b=e=>{let n=class extends e{constructor(){super(...arguments),this.attached=!1,this.clips=new m,this.highlights=null,this.lastUpdateId=-1,this.moving=!1,this.updateRequested=!1,this._visibleAtCurrentScale=!0}initialize(){const e=this.view?.spatialReferenceLocked??!0,t=this.view?.spatialReference;t&&e&&!this.spatialReferenceSupported?this.addResolvingPromise(Promise.reject(new r("layerview:spatial-reference-incompatible","The spatial reference of this layer does not meet the requirements of the view",{layer:this.layer}))):(this.container||(this.container=new d.Container),this.container.fadeTransitionEnabled=!0,this.container.visible=!1,this.container.endTransitions(),this.addHandles([o.watch((()=>this.suspended),(e=>{this.container&&(this.container.visible=!e)}),o.syncAndInitial),o.watch((()=>this.updateSuspended),(e=>{this.view&&!e&&this.updateRequested&&this.view.requestUpdate()}),o.syncAndInitial),o.watch((()=>this.layer?.opacity??1),(e=>{this.container&&(this.container.opacity=e)}),o.syncAndInitial),o.watch((()=>this.layer&&"blendMode"in this.layer?this.layer.blendMode:"normal"),(e=>{this.container&&(this.container.blendMode=e)}),o.syncAndInitial),o.watch((()=>this.layer&&"effect"in this.layer?this.layer.effect:null),(e=>{this.container&&(this.container.effect=e)}),o.syncAndInitial),o.watch((()=>this._mergedHighlights.items.map((e=>({name:e.name,options:{fillColor:e.options.color,haloColor:e.options.haloColor,fillOpacity:e.options.fillOpacity,haloOpacity:e.options.haloOpacity,haloWidth:e.options.haloWidth,haloBlur:e.options.haloBlur}})))),(()=>{this.container.highlightGradient=u.createOrReuseHighlightGradient(this.container.highlightGradient,this._mergedHighlights.items)}),o.syncAndInitial),o.watch((()=>this._mergedHighlights.items.map((e=>e.name))),(()=>{this._updateHighlights()})),o.on((()=>this.clips),"change",(()=>{this.container&&(this.container.clips=this.clips)}),o.syncAndInitial),o.watch((()=>({scale:this.view?.scale,scaleRange:this.layer&&"effectiveScaleRange"in this.layer?this.layer.effectiveScaleRange:null})),(({scale:e,scaleRange:t})=>{const i=R.isInEffectiveScaleRange(t,e);i!==this._visibleAtCurrentScale&&(this._visibleAtCurrentScale=i)}),o.syncAndInitial)],"constructor"),this.view?.whenLayerView?this.view.whenLayerView(this.layer).then((e=>{e===this&&this.processAttach()}),(()=>{})):this.when().then((()=>{this.processAttach()}),(()=>{})))}_updateHighlights(){}destroy(){this.processDetach(),this.updateRequested=!1}get highlightOptions(){return y.getDefaultHighlightOptions(this)}set highlightOptions(e){y.setDefaultHighlightOptions(this,e)}get _mergedHighlights(){if(!this.view)return S;if(!this.highlights)return this.view.highlights;const e=this.view.highlights.clone();for(const t of this.highlights){const i=e.find((e=>e.name===t.name));i&&(i.options=t.options)}return e}get scheduler(){return this.view.scheduler}get spatialReferenceSupported(){const e=this.view?.spatialReference;return null==e||this.supportsSpatialReference(e)}get updating(){return this.spatialReferenceSupported&&(!this.attached||!this.suspended&&(this.updateRequested||this.isUpdating())||!!this._updatingHandles?.updating||this.container.transitioning)}get visibleAtCurrentScale(){return this._visibleAtCurrentScale}processAttach(){this.isResolved()&&!this.attached&&!this.destroyed&&this.spatialReferenceSupported&&(this.attach(),this.attached=!0,this.requestUpdate())}processDetach(){this.attached&&(this.attached=!1,this.removeHandles("attach"),this.detach(),this.updateRequested=!1)}requestUpdate(){this.destroyed||this.updateRequested||(this.updateRequested=!0,this.updateSuspended||this.view.requestUpdate())}processUpdate(e){!this.isFulfilled()||this.isResolved()?(this._set("updateParameters",e),this.updateRequested&&!this.updateSuspended&&(this.updateRequested=!1,this.update(e))):this.updateRequested=!1}hitTest(e,t){return Promise.resolve(null)}supportsSpatialReference(e){return!0}canResume(){if(!this.spatialReferenceSupported)return!1;switch(this.layer?.type){case"link-chart":case"knowledge-graph-sublayer":break;default:if(c.isLinkChartView(this.view)&&!this.view.inGeographicLayout)return!1}return!!super.canResume()&&this.visibleAtCurrentScale}getSuspendInfo(){const e=super.getSuspendInfo(),t=!this.spatialReferenceSupported;return t&&(e.spatialReferenceNotSupported=t),e}addAttachHandles(e){this.addHandles(e,"attach")}_getHighlightBits(e){e=new Set(e);let t=1,i=0;if(!this.view)return 0;const s=this._mergedHighlights;for(const{name:r}of s)e.delete(r)&&(i=t),t<<=1;for(const r of e)a.getLogger(this).error("#highlights",`${r} was not found. Features in this group will not be highlighted.`);return i}};return t.__decorate([h.property()],n.prototype,"attached",void 0),t.__decorate([h.property({type:m,set(e){const t=s.referenceSetter(e,this._get("clips"),m);this._set("clips",t)}})],n.prototype,"clips",void 0),t.__decorate([h.property()],n.prototype,"container",void 0),t.__decorate([h.property({type:f})],n.prototype,"highlightOptions",null),t.__decorate([h.property({type:i.ofType(g.HighlightGroup)})],n.prototype,"highlights",void 0),t.__decorate([h.property()],n.prototype,"_mergedHighlights",null),t.__decorate([h.property()],n.prototype,"moving",void 0),t.__decorate([h.property({readOnly:!0})],n.prototype,"spatialReferenceSupported",null),t.__decorate([h.property({readOnly:!0})],n.prototype,"updateParameters",void 0),t.__decorate([h.property()],n.prototype,"updateRequested",void 0),t.__decorate([h.property()],n.prototype,"updating",null),t.__decorate([h.property()],n.prototype,"view",void 0),t.__decorate([h.property()],n.prototype,"_visibleAtCurrentScale",void 0),t.__decorate([h.property({readOnly:!0})],n.prototype,"visibleAtCurrentScale",null),n=t.__decorate([l.subclass("esri.views.2d.layers.LayerView2D")],n),n};e.LayerView2DMixin=b,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
