/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../../../chunks/tslib.es6","../../../geometry","../../../Graphic","../../../renderers/ClassBreaksRenderer","../../../renderers/DictionaryRenderer","../../../renderers/DotDensityRenderer","../../../renderers/HeatmapRenderer","../../../renderers/PieChartRenderer","../../../renderers/Renderer","../../../renderers/SimpleRenderer","../../../renderers/UniqueValueRenderer","../../../renderers/support/jsonUtils","../../../core/Logger","../../../symbols","../../../core/Collection","../../../core/Error","../../../core/has","../../../core/MapUtils","../../../core/promiseUtils","../../../core/reactiveUtils","../../../core/accessorSupport/decorators/property","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../../geometry/support/aaBoundingRect","../../../geometry/support/contains","../../../geometry/support/intersectsBase","../../../layers/support/MediaElementView","../../../core/scheduling","../../../core/accessorSupport/tracking/Flags","../../../core/colorUtils","../../../config","../../../symbols/cim/defaultCIMValues","../../../symbols/cim/enums","../../../core/floatRGBA","../../../geometry/Extent","../../../geometry/Geometry","../../../geometry/Multipoint","../../../geometry/Point","../../../geometry/Polygon","../../../geometry/Polyline","../engine/webgl/definitions","../engine/webgl/animations/instructions","../../../symbols/Font","../../../core/ObjectPool","../../../geometry/support/Axis","../../../geometry/support/spatialReferenceUtils","../../../geometry/support/TileClipper","../../../symbols/cim/effects/EffectAddControlPoints","../../../symbols/cim/effects/EffectArrow","../../../symbols/cim/effects/EffectBuffer","../../../symbols/cim/effects/EffectControlMeasureLine","../../../symbols/cim/effects/EffectCut","../../../symbols/cim/effects/EffectDashes","../../../symbols/cim/effects/EffectDonut","../../../symbols/cim/effects/EffectJog","../../../symbols/cim/effects/EffectMove","../../../symbols/cim/effects/EffectOffset","../../../symbols/cim/effects/EffectReverse","../../../symbols/cim/effects/EffectRotate","../../../symbols/cim/effects/EffectScale","../../../symbols/cim/effects/EffectWave","../../../symbols/cim/placements/PlacementAlongLineSameSize","../../../symbols/cim/placements/PlacementAtExtremities","../../../symbols/cim/placements/PlacementAtRatioPositions","../../../symbols/cim/placements/PlacementInsidePolygon","../../../symbols/cim/placements/PlacementOnLine","../../../symbols/cim/placements/PlacementOnVertices","../../../symbols/cim/placements/PlacementPolygonCenter","../../../core/mathUtils","../../../core/libs/gl-matrix-2/factories/vec2f32","../engine/webgl/alignmentUtils","../../../symbols/support/defaults","../../../symbols/cim/OverrideHelper","../../../layers/effects/EffectView","../../../core/Evented","../engine/transitions/FadeTransition","../engine/webgl/enums","../engine/webgl/brushes/BrushBitmap","../../../core/libs/gl-matrix-2/factories/vec4f32","../../webgl/checkWebGLError","../../webgl/enums","../../webgl/FramebufferObject","../../webgl/GLObjectType","../../webgl/Texture","../engine/webgl/shaders/BackgroundPrograms","../engine/webgl/DefaultVertexAttributeLayouts","../engine/webgl/AFeatureTile","../engine/webgl/DisplayEntity","../engine/webgl/shaderGraph/techniques/featureTechniqueUtils","../engine/webgl/number","../engine/webgl/PooledUint32Array","../engine/webgl/shaders/TileInfoPrograms","../engine/vectorTiles/style/StyleDefinition","../engine/vectorTiles/enums","../engine/webgl/shaders/BitBlitPrograms","../../../request","../../../core/urlUtils","../../../core/pbf","../engine/webgl/shaders/StencilPrograms","../engine/webgl/shaderGraph/techniques/TechniqueType","../engine/webgl/shaderGraph/techniques/shaders/BlendShader","../engine/webgl/shaderGraph/techniques/shaders/OpacityShader","../engine/webgl/shaders/HighlightPrograms","../engine/webgl/meshing/SimpleMesh","../engine/webgl/Profiler","../engine/webgl/shaderGraph/techniques/TechniqueRegistry","../../../Color","../engine/webgl/shaderGraph/techniques/shaders/constants","../engine/webgl/shaderGraph/techniques/dotDensity/DotDensityMeshWriter","../engine/webgl/shaderGraph/techniques/fill/ComplexFillMeshWriter","../engine/webgl/shaderGraph/techniques/fill/ComplexOutlineFillMeshWriter","../engine/webgl/shaderGraph/techniques/fill/FillMeshWriter","../engine/webgl/shaderGraph/techniques/fill/OutlineFillMeshWriter","../engine/webgl/shaderGraph/techniques/fill/PatternFillMeshWriter","../engine/webgl/shaderGraph/techniques/fill/PatternOutlineFillMeshWriter","../engine/webgl/shaderGraph/techniques/heatmap/HeatmapMeshWriter","../../../geometry/support/aaBoundingBox","../engine/webgl/shaderGraph/techniques/text/TextMeshWriter","../engine/webgl/shaderGraph/techniques/line/LineMeshWriter","../engine/webgl/shaderGraph/techniques/line/TexturedLineMeshWriter","../engine/webgl/shaderGraph/techniques/markers/MarkerMeshWriter","../engine/webgl/shaderGraph/techniques/pieChart/PieChartMeshWriter","../../webgl/renderState","../../3d/webgl-engine/core/shaderModules/interfaces","../../webgl/testSVGPremultipliedAlpha","../LabelManager","./graphics/GraphicsView2D","../../../chunks/earcut","../../../core/libs/gl-matrix-2/factories/vec3f32","../../../geometry/support/normalizeUtilsCommon","../../../geometry/SpatialReference","../../../geometry/support/Ellipsoid","../../../kernel","./support/util","../navigation/MapViewNavigation","../../../core/asyncUtils","../../../core/support/UpdatingHandles","../engine/webgl/shaderGraph/techniques/shaders/MagnifierShader","../../../core/unitUtils","../../../geometry/ellipsoidUtils","../../../chunks/pe","../../../geometry/projection/projectors","../engine/webgl/shaderGraph/techniques/shaders/GridShader","../../../geometry/support/geodesicConstants","../tiling/TileInfoView","../tiling/TileKey","../tiling/TileQueue","../tiling/TileStrategy","../engine/webgl/Overlay","../engine/webgl/OverlayContainer","./LayerView2D","../../layers/LayerView","../../layers/MediaLayerView","../../support/Scheduler"],(function(e,t,i,r,s,n,l,a,o,c,h,m,d,u,g,p,f,y,b,w,_,v,E,G,C,q,S,R,T,M,P,V,x,U,A,L,O,D,W,k,B,H,I,F,z,Q,j,J,K,N,X,Y,Z,$,ee,te,ie,re,se,ne,le,ae,oe,ce,he,me,de,ue,ge,pe,fe,ye,be,we,_e,ve,Ee,Ge,Ce,qe,Se,Re,Te,Me,Pe,Ve,xe,Ue,Ae,Le,Oe,De,We,ke,Be,He,Ie,Fe,ze,Qe,je,Je,Ke,Ne,Xe,Ye,Ze,$e,et,tt,it,rt,st,nt,lt,at,ot,ct,ht,mt,dt,ut,gt,pt,ft,yt,bt,wt,_t,vt,Et,Gt,Ct,qt,St,Rt,Tt,Mt,Pt,Vt,xt,Ut,At,Lt,Ot,Dt,Wt,kt,Bt,Ht,It,Ft,zt,Qt,jt){"use strict";let Jt=class extends(Ft.LayerView2DMixin(Qt(zt))){constructor(){super(...arguments),this._overlayContainer=null,this._fetchQueue=null,this._tileStrategy=null,this._elementReferences=new Map,this._debugGraphicsView=null,this._interaction=null,this.layer=null,this.elements=new p}initialize(){this.addHandles([_.watch((()=>[this.interactive,this.suspended]),(async()=>{if(this.interactive&&!this._interaction){const{MediaLayerInteraction:t}=await new Promise(((t,i)=>e(["./support/MediaLayerInteraction"],t,i)));this._interaction=new t({view:this.view,layer:this.layer}),this.selectedElement!==this._interaction.selectedElement&&(this._interaction.selectedElement=this.selectedElement),this.interactionOptions!==this._interaction.options&&(this._interaction.options=this.interactionOptions)}this._interaction&&(this._interaction.enabled=!this.suspended&&this.interactive)}),_.syncAndInitial),_.watch((()=>this.interactionOptions),(e=>{this._interaction&&(this._interaction.options=e)}),_.syncAndInitial),_.watch((()=>this.selectedElement),(e=>{this._interaction&&(this._interaction.selectedElement=e)}),_.syncAndInitial)])}attach(){this.addAttachHandles([_.on((()=>this.layer.effectiveSource),"refresh",(()=>{this._tileStrategy.refresh((e=>this._updateTile(e))),this.requestUpdate()})),_.on((()=>this.layer.effectiveSource),"change",(({element:e})=>this._elementUpdateHandler(e)))]),this._overlayContainer=new It,this.container.addChild(this._overlayContainer),this._fetchQueue=new kt({tileInfoView:this.view.featuresTilingScheme,concurrency:10,process:(e,t)=>this._queryElements(e,t),scheduler:this.scheduler,priority:jt.TaskPriority.MAPVIEW_FETCH_QUEUE}),this._tileStrategy=new Bt({cachePolicy:"purge",resampling:!0,acquireTile:e=>this._acquireTile(e),releaseTile:e=>this._releaseTile(e),tileInfoView:this.view.featuresTilingScheme}),this.requestUpdate()}detach(){this.elements.removeAll(),this._tileStrategy.destroy(),this._fetchQueue.destroy(),this._overlayContainer.removeAllChildren(),this.container.removeAllChildren(),this._elementReferences.clear(),this._debugGraphicsView?.destroy()}supportsSpatialReference(e){return!0}viewChange(){this.requestUpdate()}moveEnd(){this.requestUpdate()}update(e){this._tileStrategy.update(e),this._debugGraphicsView?.update(e)}async hitTest(e,t){const i=[],r=e.normalize(),s=[r.x,r.y];for(const{elementView:{normalizedCoords:n,element:l}}of this._elementReferences.values())null!=n&&q.ringsContainsCoords(n.rings,s)&&i.push({type:"media",element:l,layer:this.layer,mapPoint:e,sourcePoint:l.toSource(e)});return i.reverse()}canResume(){return null!=this.layer.source&&super.canResume()}async doRefresh(){this._fetchQueue.reset(),this._tileStrategy.refresh((e=>this._updateTile(e)))}_acquireTile(e){const t=new Yt(e.clone());return this._updateTile(t),t}_updateTile(e){this._updatingHandles.addPromise(this._fetchQueue.push(e.key).then((t=>{const[i,r]=e.setElements(t);this._referenceElements(e,i),this._dereferenceElements(e,r),this.requestUpdate()}),(e=>{w.isAbortError(e)||u.getLogger(this).error(e)})))}_releaseTile(e){this._fetchQueue.abort(e.key.id),e.elements&&this._dereferenceElements(e,e.elements),this.requestUpdate()}async _queryElements(e,t){const i=this.layer.effectiveSource;if(null==i)return[];this.view.featuresTilingScheme.getTileBounds(Kt,e,!0);const r=new L({xmin:Kt[0],ymin:Kt[1],xmax:Kt[2],ymax:Kt[3],spatialReference:this.view.spatialReference});return i.queryElements(r,t)}_referenceElements(e,t){if(null!=this.layer.source)for(const i of t)this._referenceElement(e,i)}_referenceElement(e,t){b.getOrCreateMapValue(this._elementReferences,t.uid,(()=>{const e=new R.MediaElementView({element:t,spatialReference:this.view.spatialReference}),i=new Ht(e);return this._overlayContainer.addChild(i),this.elements.add(t),this._updatingHandles.addPromise(t.load().catch((e=>{u.getLogger("esri.views.2d.layers.MediaLayerView2D").error(new f("element-load-error","Element cannot be displayed",{element:t,error:e}))}))),{debugGraphic:null,elementView:e,overlay:i,tiles:new Set}})).tiles.add(e)}_dereferenceElements(e,t){for(const i of t)this._dereferenceElement(e,i)}_dereferenceElement(e,t){const i=this._elementReferences.get(t.uid);i.tiles.delete(e),i.tiles.size||(this._overlayContainer.removeChild(i.overlay),i.overlay.destroy(),i.elementView.destroy(),this._elementReferences.delete(t.uid),this.elements.remove(t),this._debugGraphicsView?.graphics.remove(i.debugGraphic))}_elementUpdateHandler(e){let t=this._elementReferences.get(e.uid);if(t){const i=t.elementView.normalizedCoords;if(null==i)return this._overlayContainer.removeChild(t.overlay),t.overlay.destroy(),t.elementView.destroy(),this._elementReferences.delete(e.uid),this.elements.remove(e),void this._debugGraphicsView?.graphics.remove(t.debugGraphic);const r=[],s=[];for(const e of this._tileStrategy.tiles){const n=Xt(this.view.featuresTilingScheme,e,i);t.tiles.has(e)?n||s.push(e):n&&r.push(e)}for(const t of r)this._referenceElement(t,e);for(const t of s)this._dereferenceElement(t,e);return t=this._elementReferences.get(e.uid),void(t?.debugGraphic&&(t.debugGraphic.geometry=t.elementView.normalizedCoords,this._debugGraphicsView.graphicUpdateHandler({graphic:t.debugGraphic,property:"geometry"})))}const i=new R.MediaElementView({element:e,spatialReference:this.view.spatialReference}).normalizedCoords;if(null!=i)for(const r of this._tileStrategy.tiles){Xt(this.view.featuresTilingScheme,r,i)&&this._referenceElement(r,e)}}};t.__decorate([v.property()],Jt.prototype,"layer",void 0),t.__decorate([v.property({readOnly:!0})],Jt.prototype,"elements",void 0),Jt=t.__decorate([G.subclass("esri.views.2d.layers.MediaLayerView2D")],Jt);const Kt=C.create(),Nt={xmin:0,ymin:0,xmax:0,ymax:0};function Xt(e,t,i){return e.getTileBounds(Kt,t.key,!0),Nt.xmin=Kt[0],Nt.ymin=Kt[1],Nt.xmax=Kt[2],Nt.ymax=Kt[3],S.extentIntersectsPolygon(Nt,i)}class Yt{constructor(e){this.key=e,this.elements=null,this.isReady=!1,this.visible=!0}setElements(e){const t=[],i=new Set(this.elements);this.elements=e;for(const r of e)i.has(r)?i.delete(r):t.push(r);return this.isReady=!0,[t,Array.from(i)]}destroy(){}}return Jt}));
