/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../core/handleUtils","../../../core/Logger","../../../core/promiseUtils","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../../geometry/support/spatialReferenceUtils","../../../support/GraphicsCollection","../../../core/Error","../../../core/scheduling","../../../core/accessorSupport/tracking/Flags","../../../core/colorUtils","../../../config","../../../symbols/cim/defaultCIMValues","../../../symbols/cim/enums","../../../core/floatRGBA","../../../geometry/Extent","../../../geometry/Geometry","../../../geometry/Multipoint","../../../geometry/Point","../../../geometry/Polygon","../../../geometry/Polyline","../engine/webgl/definitions","../engine/webgl/animations/instructions","../../../core/mathUtils","../../../symbols/Font","../../../core/ObjectPool","../../../geometry/support/Axis","../../../geometry/support/TileClipper","../../../symbols/cim/effects/EffectAddControlPoints","../../../symbols/cim/effects/EffectArrow","../../../symbols/cim/effects/EffectBuffer","../../../symbols/cim/effects/EffectControlMeasureLine","../../../symbols/cim/effects/EffectCut","../../../symbols/cim/effects/EffectDashes","../../../symbols/cim/effects/EffectDonut","../../../symbols/cim/effects/EffectJog","../../../symbols/cim/effects/EffectMove","../../../symbols/cim/effects/EffectOffset","../../../symbols/cim/effects/EffectReverse","../../../symbols/cim/effects/EffectRotate","../../../symbols/cim/effects/EffectScale","../../../symbols/cim/effects/EffectWave","../../../symbols/cim/placements/PlacementAlongLineSameSize","../../../symbols/cim/placements/PlacementAtExtremities","../../../symbols/cim/placements/PlacementAtRatioPositions","../../../symbols/cim/placements/PlacementInsidePolygon","../../../symbols/cim/placements/PlacementOnLine","../../../symbols/cim/placements/PlacementOnVertices","../../../symbols/cim/placements/PlacementPolygonCenter","../../../core/libs/gl-matrix-2/factories/vec2f32","../engine/webgl/alignmentUtils","../../../symbols/support/defaults","../../../symbols/cim/OverrideHelper","../../../layers/effects/EffectView","../../../core/Evented","../engine/transitions/FadeTransition","../engine/webgl/enums","../engine/webgl/brushes/BrushBitmap","../../../core/libs/gl-matrix-2/factories/vec4f32","../../webgl/checkWebGLError","../../webgl/enums","../../webgl/FramebufferObject","../../webgl/GLObjectType","../../webgl/Texture","../engine/webgl/shaders/BackgroundPrograms","../engine/webgl/DefaultVertexAttributeLayouts","../engine/webgl/AFeatureTile","../engine/webgl/DisplayEntity","../engine/webgl/shaderGraph/techniques/featureTechniqueUtils","../engine/webgl/number","../engine/webgl/PooledUint32Array","../engine/webgl/shaders/TileInfoPrograms","../engine/vectorTiles/style/StyleDefinition","../engine/vectorTiles/enums","../engine/webgl/shaders/BitBlitPrograms","../../../request","../../../core/urlUtils","../../../core/pbf","../engine/webgl/shaders/StencilPrograms","../engine/webgl/shaderGraph/techniques/TechniqueType","../engine/webgl/shaderGraph/techniques/shaders/BlendShader","../engine/webgl/shaderGraph/techniques/shaders/OpacityShader","../engine/webgl/shaders/HighlightPrograms","../engine/webgl/meshing/SimpleMesh","../engine/webgl/Profiler","../engine/webgl/shaderGraph/techniques/TechniqueRegistry","../../../Color","../engine/webgl/shaderGraph/techniques/shaders/constants","../engine/webgl/shaderGraph/techniques/dotDensity/DotDensityMeshWriter","../engine/webgl/shaderGraph/techniques/fill/ComplexFillMeshWriter","../engine/webgl/shaderGraph/techniques/fill/ComplexOutlineFillMeshWriter","../engine/webgl/shaderGraph/techniques/fill/FillMeshWriter","../engine/webgl/shaderGraph/techniques/fill/OutlineFillMeshWriter","../engine/webgl/shaderGraph/techniques/fill/PatternFillMeshWriter","../engine/webgl/shaderGraph/techniques/fill/PatternOutlineFillMeshWriter","../engine/webgl/shaderGraph/techniques/heatmap/HeatmapMeshWriter","../../../geometry/support/aaBoundingBox","../engine/webgl/shaderGraph/techniques/text/TextMeshWriter","../engine/webgl/shaderGraph/techniques/line/LineMeshWriter","../engine/webgl/shaderGraph/techniques/line/TexturedLineMeshWriter","../engine/webgl/shaderGraph/techniques/markers/MarkerMeshWriter","../engine/webgl/shaderGraph/techniques/pieChart/PieChartMeshWriter","../../webgl/renderState","../../3d/webgl-engine/core/shaderModules/interfaces","../../webgl/testSVGPremultipliedAlpha","../LabelManager","./graphics/GraphicsView2D","../../../core/asyncUtils","../../../core/Collection","../../../core/accessorSupport/watch","../../../core/accessorSupport/tracking/SimpleTrackingTarget","../../../chunks/earcut","../../../core/libs/gl-matrix-2/factories/vec3f32","../../../geometry/support/normalizeUtilsCommon","../../../geometry/SpatialReference","../../../geometry/support/Ellipsoid","../../../geometry","../../../kernel","./support/util","../navigation/MapViewNavigation","../../../core/support/UpdatingHandles","../engine/webgl/shaderGraph/techniques/shaders/MagnifierShader","../../../core/unitUtils","../../../geometry/ellipsoidUtils","../../../chunks/pe","../../../geometry/projection/projectors","../engine/webgl/shaderGraph/techniques/shaders/GridShader","../../../geometry/support/geodesicConstants","./BitmapTileLayerView2D","./LayerView2D","./graphics/HighlightGraphicContainer","./support/imageUtils","../tiling/TileInfoView","../tiling/TileKey","../tiling/TileQueue","../tiling/TileStrategy","../../layers/LayerView","../../layers/RefreshableLayerView","../../layers/support/MapServiceLayerViewHelper","../../support/drapedUtils","../../support/Scheduler"],(function(e,t,i,s,r,l,a,n,h,o,c,g,p,u,m,f,d,y,w,b,_,V,T,q,I,G,v,P,S,C,E,H,U,M,L,k,A,x,F,B,D,W,Q,R,O,z,j,J,K,N,X,Y,Z,$,ee,te,ie,se,re,le,ae,ne,he,oe,ce,ge,pe,ue,me,fe,de,ye,we,be,_e,Ve,Te,qe,Ie,Ge,ve,Pe,Se,Ce,Ee,He,Ue,Me,Le,ke,Ae,xe,Fe,Be,De,We,Qe,Re,Oe,ze,je,Je,Ke,Ne,Xe,Ye,Ze,$e,et,tt,it,st,rt,lt,at,nt,ht,ot,ct,gt,pt,ut,mt,ft,dt,yt,wt,bt,_t,Vt,Tt,qt,It,Gt,vt,Pt,St,Ct,Et,Ht,Ut,Mt,Lt,kt){"use strict";const At=[0,0];let xt=class extends(Ut(qt.BitmapTileLayerView2D(It.LayerView2DMixin(Ht)))){constructor(){super(...arguments),this._fetchQueue=null,this._highlightGraphics=new o.GraphicsCollection,this._highlightView=null,this._popupHighlightHelper=null,this._tileStrategy=null,this.layer=null}get resampling(){return!("resampling"in this.layer)||!1!==this.layer.resampling}get tilemapCache(){return"tilemapCache"in this.layer?this.layer.tilemapCache:null}update(e){this._fetchQueue.pause(),this._fetchQueue.state=e.state,this._tileStrategy.update(e),this._fetchQueue.resume(),this._highlightView?.processUpdate(e)}attach(){const e="tileServers"in this.layer?this.layer.tileServers:null,t=this.tilemapCache;if(this._tileInfoView=new Pt(this.layer.tileInfo,this.layer.fullExtent,t?.effectiveMinLOD,t?.effectiveMaxLOD),this._fetchQueue=new Ct({tileInfoView:this._tileInfoView,concurrency:e&&10*e.length||10,process:(e,t)=>this.fetchTile(e,t),scheduler:this.scheduler,priority:kt.TaskPriority.MAPVIEW_FETCH_QUEUE}),this._tileStrategy=new Et({cachePolicy:"keep",resampling:this.resampling,acquireTile:e=>this.acquireTile(e),releaseTile:e=>this.releaseTile(e),tileInfoView:this._tileInfoView}),Mt.isMapServiceLayerView(this,this.layer)){const e=this._highlightView=new tt({view:this.view,graphics:this._highlightGraphics,requestUpdateCallback:()=>this.requestUpdate(),container:new Gt(this.view.featuresTilingScheme),defaultPointSymbolEnabled:!1});this.container.addChild(this._highlightView.container),this._popupHighlightHelper=new Mt.MapServiceLayerViewHelper({createFetchPopupFeaturesQueryGeometry:(e,t)=>Lt.createQueryGeometry(e,t,this.view),highlightGraphics:this._highlightGraphics,highlightGraphicUpdated:(t,i)=>{e.graphicUpdateHandler({graphic:t,property:i})},layerView:this,updatingHandles:this._updatingHandles})}this.requestUpdate(),this.addAttachHandles(this._updatingHandles.add((()=>this.resampling),(()=>{this.doRefresh()}))),super.attach()}detach(){super.detach(),this._tileStrategy.destroy(),this._fetchQueue.clear(),this.container.removeAllChildren(),this._popupHighlightHelper?.destroy(),this._highlightView?.destroy(),this._fetchQueue=this._tileStrategy=this._tileInfoView=this._popupHighlightHelper=null}async fetchPopupFeaturesAtLocation(e,t){return this._popupHighlightHelper?this._popupHighlightHelper.fetchPopupFeaturesAtLocation(e,t):[]}highlight(e){return this._popupHighlightHelper?this._popupHighlightHelper.highlight(e):t.makeHandle()}viewChange(){this.requestUpdate()}moveEnd(){this.requestUpdate()}supportsSpatialReference(e){return h.equals(this.layer.tileInfo?.spatialReference,e)}async doRefresh(){if(this.attached){if(this.suspended)return this._tileStrategy.clear(),void this.requestUpdate();this._fetchQueue.reset(),this._tileStrategy.refresh((e=>this._updatingHandles.addPromise(this._enqueueTileFetch(e))))}}acquireTile(e){const t=this._bitmapView.createTile(e),i=t.bitmap;return[i.x,i.y]=this._tileInfoView.getTileCoords(At,t.key),i.resolution=this._tileInfoView.getTileResolution(t.key),[i.width,i.height]=this._tileInfoView.tileInfo.size,this._updatingHandles.addPromise(this._enqueueTileFetch(t)),this._bitmapView.addChild(t),this.requestUpdate(),t}releaseTile(e){this._fetchQueue.abort(e.key.id),this._bitmapView.removeChild(e),e.once("detach",(()=>e.destroy())),this.requestUpdate()}async fetchTile(e,t={}){const i=this.tilemapCache,{signal:r,resamplingLevel:l=0}=t;if(!i)try{return await this._fetchImage(e,r)}catch(h){if(!s.isAbortError(h)&&!this.resampling)return vt.createBlankImage(this._tileInfoView.tileInfo.size);if(l<3){const i=this._tileInfoView.getTileParentId(e.id);if(i){const s=new St(i),r=await this.fetchTile(s,{...t,resamplingLevel:l+1});return vt.resampleImage(this._tileInfoView,r,s,e)}}throw h}const a=new St(0,0,0,0);let n;try{if(await i.fetchAvailabilityUpsample(e.level,e.row,e.col,a,{signal:r}),!this.resampling&&a.level!==e.level)return vt.createBlankImage(this._tileInfoView.tileInfo.size);n=await this._fetchImage(a,r)}catch(h){if(s.isAbortError(h))throw h;return vt.createBlankImage(this._tileInfoView.tileInfo.size)}return this.resampling?vt.resampleImage(this._tileInfoView,n,a,e):n}async _enqueueTileFetch(e){if(!this._fetchQueue.has(e.key.id)){try{const t=await this._fetchQueue.push(e.key);e.bitmap.source=t,e.bitmap.width=this._tileInfoView.tileInfo.size[0],e.bitmap.height=this._tileInfoView.tileInfo.size[1],e.once("attach",(()=>this.requestUpdate()))}catch(t){s.isAbortError(t)||i.getLogger(this).error(t)}this.requestUpdate()}}async _fetchImage(e,t){return this.layer.fetchImageBitmapTile(e.level,e.row,e.col,{signal:t})}};e.__decorate([r.property()],xt.prototype,"resampling",null),e.__decorate([r.property()],xt.prototype,"tilemapCache",null),xt=e.__decorate([n.subclass("esri.views.2d.layers.TileLayerView2D")],xt);return xt}));
