/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../../core/has","../../../../core/maybe","../../../../core/object","../../../../core/promiseUtils","../../../../core/accessorSupport/diffUtils","../../../../core/workers/utils","../../../../geometry/SpatialReference","../../engine/webgl/mesh/MultiTileMeshData","../../engine/webgl/mesh/factories/FeatureMeshFactory","../../engine/webgl/mesh/factories/ResourceProxy","../../engine/webgl/shaderGraph/techniques/mesh/MeshWriterRegistry","../../engine/webgl/util/MatcherContext","./ProcessorTileMessageQueue","./processor/BinningStrategy","./processor/ClusterStrategy","./processor/FeatureUpdateStrategy","./support/AttributeStore","./support/ComputedAttributeStorage"],(function(e,t,s,r,i,a,o,n,c,h,u,g,y,d,p,l,_,f){"use strict";class b{constructor(e,t){this._connection=e,this._source=t,this._version=1,this._registry=new u.MeshWriterRegistry,this._proxy=new h.ResourceProxy({fetch:(e,t)=>this._connection.layerView.fetch(e,t),fetchDictionary:(e,t)=>this._connection.layerView.fetchDictionary(e,t)}),this._attributeStore=new _.AttributeStore({isLocal:!1,update:e=>a.ignoreConnectionErrors(this._connection.container.updateAttributeView(e))})}destroy(){this._proxy.destroy(),this._strategy?.destroy(),this._attributeStore.destroy()}get aggregateQueryEngine(){return this._strategy?.aggregateQueryEngine}getDisplayFeatures(e){return this._strategy?this._strategy.getDisplayFeatures(e):{features:[],aggregates:[]}}getDisplayIds(e){const t={};return this._strategy?(this._strategy.displayMap(e,(e=>e),((e,s,r)=>{t[r]=e})),t):t}getFeatureObjectIdsForAggregate(e){return this._strategy?this._strategy.getFeatureObjectIdsForAggregate(e):[]}onSubscribe(e){this._strategy?.onSubscribe(e)}onUnsubscribe(e){this._strategy?.onUnsubscribe(e)}async update(t,r,a,n,h){const u=t.processor,y=s.notDeepEqual(this._schema?.storage,u.storage),d=s.notDeepEqual(this._schema?.mesh.properties,u.mesh.properties),p=s.notDeepEqual(this._schema?.mesh.factory,u.mesh.factory),l=s.notDeepEqual(this._schema?.mesh.strategy,u.mesh.strategy),_=d||p||l;if(!(y||_)&&!n)return;e("esri-2d-update-debug")&&console.debug(`Version[${this._version}] SymbolProcessor.update`,{changes:i.diff(this._schema,u),schema:u}),this._schema=u;const b=o.fromJSON(this._source.service.outSpatialReference),m=new f.ComputedAttributeStorage({fields:this._source.metadata.fieldsIndex,spatialReference:b});if(await this._attributeStore.update(u.storage,m,this._source.metadata,b,r),this._strategy?.invalidateAttributeData(),!n&&!_)return;(l||d)&&await this._updateStrategy(u.mesh.strategy,b,h,u.mesh.properties.timeZone),this._updateSortKey(m,"sortKey"in u.mesh.properties?u.mesh.properties.sortKey:null);const w=new g.MatcherContext(m,this._proxy,a,this._registry);return(p||"dictionary"===u.mesh.factory.symbology.type)&&(this._factory=await c.FeatureMeshFactory.create(w,u.mesh.factory)),this._invalidate(),this._version=r,this._connection.container.updateRenderState(this._version)}async applyLocalEdit(e){if(!this._strategy)return;const t=this._strategy.applyLocalEdit(e);for await(const r of t)try{await this._process(r)}catch(s){}}async updateChunks(){this._strategy?.beforeUpdateChunks(),await this._doUpdateChunks(),this._strategy?.afterUpdateChunks()}async removeChunks(e){this._strategy?.removeChunks(e),this._attributeStore.incrementDisplayIdGeneration()}updateHighlight({highlights:e}){if(!this._strategy)return void this._attributeStore.setHighlight(e.map((({objectId:e,highlightFlags:t})=>({objectId:e,highlightFlags:t,displayId:-1}))),e);const t=this._strategy.displayMap(e,(({objectId:e})=>e),((e,{highlightFlags:t},s)=>({objectId:s,displayId:e,highlightFlags:t})));this._attributeStore.setHighlight(t,e)}async _doUpdateChunks(){if(!this._strategy)return;const t=this._strategy.updateChunks(),s=[],i=new Map;for await(const e of t){let t=i.get(e.id);null==t&&(t=new y.ProcessorTileMessageQueue({concurrency:16,process:e=>this._process(e)}),i.set(e.id,t));const a=t.push(e).catch((e=>r.throwIfNotAbortError(e)));s.push(a)}try{await Promise.all(s)}catch(a){}e("esri-2d-update-debug")&&console.log("SendUpdates"),this._attributeStore.sendUpdates(),e("esri-2d-update-debug")&&console.log("SendUpdates.await")}async _updateStrategy(e,t,s,r){switch(this._strategy?.destroy(),e.type){case"feature":this._strategy=new l.FeatureUpdateStrategy(this._source,this._attributeStore,r);break;case"binning":this._strategy=await d.BinningStrategy.create(e,t,this._source,this._attributeStore,r);break;case"cluster":this._strategy=await p.ClusterStrategy.create(this._connection,e,t,this._source,this._attributeStore,r)}for(const i of s)this._strategy.onSubscribe(i)}async _updateSortKey(e,s){if(this._sortInfo=t.destroyMaybe(this._sortInfo?.computed),null!=s){const t=s.byRenderer?null:await e.createComputedField(s);this._sortInfo={...s,computed:t}}}_invalidate(){this._strategy&&this._strategy.invalidate()}async _process(t){const s=t.subscription;if(e("esri-2d-update-debug")){const e=s.tile;console.debug(`Version[${this._version}] Tile[${e.key.id}, end=${t.end}] Processor._process`)}await this._fetchResources(t),r.throwIfAborted(s.signal);const i=await this._write(t,s.tile.createArcadeEvaluationOptions(this._schema?.mesh.properties.timeZone)),a=s.tile.tileInfoView.getLODInfoAt(s.tile.key),{message:o,transferList:n}=i.serialize(a),c={objectIdMap:null,inner:t.createMessage(o,this._version,this._attributeStore.epoch)};if(this._schema?.mesh.properties.returnMeshObjectId){c.objectIdMap={};const e=t.reader?.getCursor();if(e)for(;e.next();)c.objectIdMap[e.getDisplayId()]=e.getObjectId()}if(r.throwIfAborted(s.signal),await this._connection.container.onMessage(c,{signal:s.signal,transferList:n}),this._attributeStore.sendUpdates(),e("esri-2d-update-debug")){const e=s.tile;console.debug(`Version[${this._version}] Tile[${e.key.id}, end=${t.end}] Processor._process.await`)}}async _fetchResources(e){await this._fetchMatcherResources(e),await this._fetchWriterResources(e)}async _fetchMatcherResources(e){if(e.reader)return this._factory.enqueueMatcherRequests(this._proxy,e.reader)}async _fetchWriterResources(e){if(!e.reader)return;const t=e.reader.getCursor(),s=e.subscription.tile.createArcadeEvaluationOptions(this._schema.mesh.properties.timeZone);for(;t.next();)this._factory.enqueueWriterRequests(this._proxy,t,s);await this._proxy.fetchEnqueuedResources()}async _write(e,t){const s=e.subscription.tile,r=e.reader?.getCursor(),i=r?.getSize()??0,a=s.tileInfoView.tileInfo.isWrappable,o=s.tileInfoView.tileInfo.spatialReference.isWGS84,c=new n.MultiTileMeshData(s.key,this._strategy.enablePixelBuffering,a,o,i);if(!r)return c;const h=s.createArcadeEvaluationOptions(this._schema.mesh.properties.timeZone);for(;r.next();){const e=this._getSortKeyValue(r,t);c.entityStart(r.getDisplayId(),e),this._factory.write(c,this._proxy,r,h,s.level),c.entityEnd()}return c}_getSortKeyValue(e,t){if(!this._sortInfo)return 0;const{computed:s,order:r,byRenderer:i}=this._sortInfo,a=i?this._factory.getSortKey(e,t):s?.read(e,t);return null==a||isNaN(a)?0:a*("asc"===r?-1:1)}}return b}));
