/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../../geometry","../../../../../layers/graphics/featureConversionUtils","../../../../../layers/graphics/OptimizedFeature","../../../../../layers/graphics/data/projectionSupport","../../../../../layers/support/FieldsIndex","../aggregation/ComputedAggregateField","./AAggregateStrategy","./AProcessorStrategy","../sources/FeatureSourceMessage","../sources/strategies/chunks/OverrideChunk","../support/ComputedAttributeStorage","../support/FeatureFilter","../support/FeatureMetadata","../support/FeatureSetReaderJSON","../../../tiling/TileKey","../../../../../geometry/SpatialReference"],(function(e,t,s,a,i,r,o,n,l,d,c,u,p,h,f,g,y){"use strict";class m extends l.ASendState{constructor(e,t){super(e),this.bins=new Map,this.featureCache=new Map,this.done=!1,this._store=t}reset(){this.destroy(),this.done=!1}invaldateForLocalEditDropped(){this.handledChunks.clear(),this.bins.clear()}destroy(){const e=this.subscription.tile.key.level;for(const t of this.featureCache.keys())this._store.releaseDisplayIdForObjectId(`${t}.${e}`);this.bins.clear(),this.featureCache.clear(),this.handledChunks.clear()}get tile(){return this.subscription.tile}*featuresWorldSpace(){for(const e of this.featureCache.values()){const t=e.clone();t.geometry&&s.unquantizeOptimizedGeometry(t.geometry,t.geometry,!1,!1,this.subscription.tile.transform),yield t}}}class S extends n.AAggregateStrategy{static async create(e,t,s,a,r){const n=new u.ComputedAttributeStorage({spatialReference:t}),l=await Promise.all(e.fields.map((async e=>o.ComputedAggregateField.create(n,e)))),d=e.featureFilter?await p.create({geometryType:s.metadata.geometryType,hasM:!1,hasZ:!1,timeInfo:s.metadata.timeInfo,fieldsIndex:s.metadata.fieldsIndex,spatialReference:t,filterJSON:e.featureFilter}):null;return"geohash"===e.index.type&&await i.checkProjectionSupport(t,y.WGS84),new S(e,d,r,l,t,s,a)}constructor(e,t,s,a,i,o,n){super(o,n,i,a),this._schema=e,this._featureFilter=t,this._timeZone=s,this._metadata=h.FeatureMetadata.createFeature({geometryType:"esriGeometryPolygon",objectIdField:"aggregateId",fieldsIndex:new r(e.fields).toJSON(),globalIdField:null,spatialReference:o.metadata.spatialReference,subtypeField:null,subtypes:null,timeInfo:null,timeReferenceUnknownClient:null,typeIdField:null,types:null})}createState(e){return new m(e,this._attributeStore)}async*applyLocalEdit(e){for(const t of this._sendStates.values()){t.reset();const e=new d.FeatureTileAppendMessage(t.subscription,f.FeatureSetReaderJSON.empty(this._source.metadata),!0,!1,{});yield e}}displayMap(e,t,s){const a=new Map(e.map((e=>[t(e),e]))),i=[];for(const r of this._sendStates.values())for(const e of r.featuresWorldSpace()){const{objectId:t,displayId:r}=e,o=a.get(t);if(null!=o){const e=s(r,o,t);i.push(e),a.delete(t)}}return i}getDisplayFeatures(e){const t=new Set(e),a=new Set,i=[];for(const r of this._sendStates.values())for(const e of r.featuresWorldSpace())t.has(e.displayId)&&!a.has(e.objectId)&&(e.geometry&&i.push({...s.convertToFeature(e,this._metadata.geometryType,!1,!1),displayId:e.displayId}),a.add(e.objectId));return{features:[],aggregates:i}}getFeatureObjectIdsForAggregate(e){for(const t of this._sendStates.values())for(const s of t.bins.values())if(s.id===e)return Array.from(s.containedObjectIds);return[]}beforeUpdateChunks(){const e=this._source.chunks();if(!e.length)return;let t=!1;for(const s of e)c.isLocalEditChunk(s)&&s.lastLocalEditDropped!==this._lastHandledLocalEdit&&(this._lastHandledLocalEdit=s.lastLocalEditDropped,t=!0);if(t)for(const s of this._sendStates.values())s.invaldateForLocalEditDropped()}async*updateChunks(){for(const e of this._sendStates.values())yield*this._update(e,this._source)}forEachAggregateWorldSpace(e){const t=new Set;for(const s of this._sendStates.values())for(const a of s.featuresWorldSpace())t.has(a.objectId)||(e(a),t.add(a.objectId))}_createIndexOptions(e){switch(this._schema.index.type){case"geohash":return{type:"geohash",fields:this.aggregateFields,featureFilter:this._featureFilter,geohashLevel:this._schema.index.fixBinLevel,spatialReference:this.spatialReference,timeZone:this._timeZone,scale:e.scale};case"grid":{const t=this._schema.index.fixedBinLevel,s=null!=t?e.tileInfoView.getLODInfoAt(t).scale:e.scale;return{type:"grid",fields:this.aggregateFields,cellSize:this._schema.index.size,featureFilter:this._featureFilter,spatialReference:this.spatialReference,timeZone:this._timeZone,scale:s}}}}async*_update(e,t){const{handledChunks:s,subscription:i,bins:r,featureCache:o}=e,n=i.tile;if(e.done)return;for(const a of t.chunks()){if(s.has(a.chunkId))continue;s.add(a.chunkId);const t=a.queryInfo;if("tileId"in t){const e=new g(t.tileId);if(e.level!==n.level||e.world!==n.key.world)continue}a.getAggregateIndex(this._createIndexOptions(e.tile)).putBounded(r,e.tile.extent,e.tile.resolution)}const l=[],c=i.tile.transform,u=i.tile.key.level;for(const d of r.values()){let e=o.get(d.id);if(e)e.attributes=d.getAttributes();else{const t=d.getGeometry(this.spatialReference,c);e=new a.OptimizedFeature(t,d.getAttributes(),null),t||(e.centroid=d.getGeometricCentroid(this.spatialReference,c)),e.objectId=d.id,e.displayId=this._attributeStore.createDisplayIdForObjectId(`${e.objectId}.${u}`),o.set(d.id,e)}l.push(e)}this.events.emit("changed"),e.done=!t.updateTracking.updating;const p=f.FeatureSetReaderJSON.fromOptimizedFeatures(l,this._metadata,c),h=p.getCursor(),y=e.subscription.tile.createArcadeEvaluationOptions(this._timeZone);for(;h.next();)this._attributeStore.setAttributeData(h.getDisplayId(),h,y);const m=new d.FeatureTileUpdateMessage(e.subscription,p,[],e.done,{});yield m}}e.BinningState=m,e.BinningStrategy=S,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
