/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../../layers/graphics/featureConversionUtils","../../../../../layers/graphics/OptimizedFeature","../../../../../layers/graphics/OptimizedGeometry","../../../../../layers/support/FieldsIndex","../../../engine/webgl/definitions","../aggregation/ComputedAggregateField","../aggregation/GridCell","../aggregation/GridSpatialIndex","./AAggregateStrategy","./AProcessorStrategy","./support/WithDisplayId","../sources/FeatureSourceMessage","../sources/strategies/chunks/OverrideChunk","../support/ComputedAttributeStorage","../support/FeatureFilter","../support/FeatureMetadata","../support/FeatureSetReaderJSON","../../../tiling/TileKey"],(function(e,t,i,s,r,a,n,l,d,o,u,c,h,p,g,f,_,y,S){"use strict";const m=128;class I extends u.ASendState{constructor(e){super(e),this.didSend=!1,this.done=!1}}class x{constructor(e,t,i,s,r){this._level=e,this._scale=t,this._indexOptions=i,this._clusterRadius=s,this._store=r,this._cells=new Map,this._handledChunks=new Set,this._statistics=new Map,this._clusters=new Map}destroy(){this._clearClusters()}_clearClusters(){for(const e of this._clusters.values())this._store.releaseDisplayIdForObjectId(e.inner.id);this._clusters.clear()}*aggregatesWorldSpace(){for(const e of this._clusters.values()){const t=e.inner.getCentroid(null),s=new i.OptimizedFeature(t,e.inner.getAttributes(),null);s.objectId=e.inner.id,s.displayId=e.displayId,yield s}}clusters(){return this._clusters.values()}updateChunks(e,t){let i=!1;for(const n of e){const e=n.queryInfo;if("tileId"in e){if(new S(e.tileId).level!==this._level)continue}if(!this._handledChunks.has(n.normalizedChunkId)){this._handledChunks.add(n.normalizedChunkId),i=!0;n.getAggregateIndex({...this._indexOptions,scale:this._scale}).put(this._cells)}}const s={xMin:1/0,yMin:1/0,xMax:-1/0,yMax:-1/0},r=d.pixelsPerMapUnit(this._indexOptions.spatialReference,this._scale),a=this._indexOptions.cellSize;for(const{subscription:n}of t){const e=n.tile.bounds,t=Math.floor(e[0]*r/a),i=Math.floor(e[1]*r/a),l=Math.ceil(e[2]*r/a),d=Math.ceil(e[3]*r/a);s.xMin=Math.min(s.xMin,t),s.yMin=Math.min(s.yMin,i),s.xMax=Math.max(s.xMax,l),s.yMax=Math.max(s.yMax,d)}return null!=this._lastCellBounds&&s.xMin===this._lastCellBounds.xMin&&s.yMin===this._lastCellBounds.yMin&&s.yMin===this._lastCellBounds.yMin&&s.yMax===this._lastCellBounds.yMax||(i=!0,this._lastCellBounds=s),i&&this._clusterCells(s),i}async updateStatistics(e){let t=!1;for(const i of this._clusters.values())i.inner.count>1&&(t=this._updateAggregateStatistics(this._statistics,i.inner)||t);if(t){const t=Array.from(this._statistics.entries()).map((([e,t])=>({fieldName:e,minValue:t.minValue,maxValue:t.maxValue})));await e.container.updateStatistics(this._level,t)}}createAggregateFeatures(e,t){const r=e.subscription,n=[],l=r.tile.transform;for(const d of this._clusters.values()){let e=d.inner.getCentroidX(l);const t=d.inner.getCentroidY(l),o=r.tile.lod,u=o.wrap?o.worldSize[0]:null,c=1===d.inner.count?d.inner.firstObjectId:d.inner.id,h=d.displayId;if(null!=u)if(1===u){const r=new s([],[e,t]),l=new i.OptimizedFeature(r,d.inner.getAttributes(),null);l.geometry.coords[0]-=a.tileSize,l.objectId=c,l.displayId=h,n.push(l);const o=new s([],[e,t]),u=new i.OptimizedFeature(o,d.inner.getAttributes(),null);u.geometry.coords[0]+=a.tileSize,u.objectId=c,u.displayId=h,n.push(u)}else e>a.tileSize+a.tileSize/2?e-=u*a.tileSize:e<-a.tileSize/2&&(e+=u*a.tileSize);if(e<a.tileSize+m&&e>=-m&&t<a.tileSize+m&&t>=-m){const r=new s([],[e,t]),a=new i.OptimizedFeature(r,d.inner.getAttributes(),null);a.objectId=c,a.displayId=h,n.push(a)}}return y.FeatureSetReaderJSON.fromOptimizedFeatures(n,t,r.tile.transform)}_clusterCells(e){let t=Array.from(this._cells.values());t=t.sort(((e,t)=>t.count-e.count));const i=[];for(const n of this._clusters.values())i.push(n.inner.id);this._clusters.clear();const s=this._clusterRadius*(1/d.pixelsPerMapUnit(this._indexOptions.spatialReference,this._scale)),r=1+this._clusterRadius/this._indexOptions.cellSize,a=new Set;for(const n of t){if(a.has(n.id))continue;if(n.gridX<e.xMin||n.gridX>e.xMax||n.gridY<e.yMin||n.gridY>e.yMax)continue;const t=this._store.createDisplayIdForObjectId(n.id),i=new c.WithDisplayId(n.clone(),t);a.add(n.id),this._clusters.set(n.id,i);const d=n.centroidXWorld,o=n.centroidYWorld;for(let e=n.gridY-r;e<=n.gridY+r;e++)for(let t=n.gridX-r;t<=n.gridX+r;t++){if(e===n.gridY&&t===n.gridX)continue;const r=this._cells.get(l.GridCell.createId(t,e));if(!r||a.has(r.id))continue;const u=Math.abs(r.centroidXWorld-d),c=Math.abs(r.centroidYWorld-o);u<s&&c<s&&(i.inner.merge(r),a.add(r.id))}}for(const n of i)this._store.releaseDisplayIdForObjectId(n)}_updateAggregateStatistics(e,t){let i=!1;for(const s of t.statistics.values()){if("esriFieldTypeString"===s.field.type)continue;const t=s.value,r=s.field,a=e.get(r.name);if(a){const{minValue:e,maxValue:s}=a,r=Math.min(a.minValue,t),n=Math.max(a.maxValue,t);e===r&&s===n||(a.minValue=r,a.maxValue=n,i=!0)}else e.set(r.name,{minValue:t,maxValue:t}),i=!0}return i}}class M extends o.AAggregateStrategy{static async create(e,t,i,s,r,a){const l=new g.ComputedAttributeStorage({spatialReference:i}),d={type:"grid",fields:await Promise.all(t.fields.map((async e=>n.ComputedAggregateField.create(l,e)))),spatialReference:i,featureFilter:t.featureFilter?await f.create({geometryType:s.metadata.geometryType,hasM:!1,hasZ:!1,timeInfo:s.metadata.timeInfo,fieldsIndex:s.metadata.fieldsIndex,spatialReference:i,filterJSON:t.featureFilter}):null,cellSize:t.clusterRadius/4,timeZone:a};return new M(e,t.clusterRadius,d,t.fields,s,r)}constructor(e,t,i,s,a,n){super(a,n,i.spatialReference,i.fields),this._connection=e,this._clusterRadius=t,this._indexOptions=i,this._cellsPerScale=new Map,this._metadata=_.FeatureMetadata.createFeature({geometryType:"esriGeometryPoint",objectIdField:"aggregateId",fieldsIndex:new r([...s,...this._source.metadata.fieldsIndex.fields,{name:"aggregateId",alias:"aggregateId",type:"esriFieldTypeOID"}]).toJSON(),globalIdField:null,spatialReference:a.metadata.spatialReference,subtypeField:null,subtypes:null,timeInfo:null,timeReferenceUnknownClient:null,typeIdField:null,types:null})}get enablePixelBuffering(){return!1}invalidate(){super.invalidate();for(const e of this._cellsPerScale.values())e.destroy();this._cellsPerScale.clear()}onSubscribe(e){super.onSubscribe(e),this._requiredLevel=e.tile.level,this._requiredScale=e.tile.scale}createState(e){return new I(e)}async*applyLocalEdit(e){for(const t of this._cellsPerScale.values())t.destroy();this._cellsPerScale.clear();for(const t of this._sendStates.values())t.done=!1}displayMap(e,t,i){const s=new Map(e.map((e=>[t(e),e]))),r=[],a=this._getClusterState(this._requiredLevel,this._requiredScale);for(const n of a.clusters()){const e=s.get(n.inner.id);if(null==e){if(1===n.inner.count){const e=s.get(n.inner.firstObjectId);if(null!=e){const t=i(n.displayId,e,n.inner.firstObjectId);r.push(t),s.delete(n.inner.firstObjectId)}}}else{const t=i(n.displayId,e,n.inner.id);r.push(t),s.delete(n.inner.id)}}return r}getDisplayFeatures(e){const i=new Set(e),s=new Set,r=[],a=[],n=this._getClusterState(this._requiredLevel,this._requiredScale);for(const l of n.aggregatesWorldSpace())if(i.has(l.displayId)&&!s.has(l.displayId)){const e=t.convertToFeature(l,this._metadata.geometryType,!1,!1);if(s.add(l.displayId),1===e.attributes.cluster_count){r.push({...e,displayId:l.displayId});continue}a.push({...e,displayId:l.displayId})}return{features:r,aggregates:a}}getFeatureObjectIdsForAggregate(e){const t=this._getClusterState(this._requiredLevel,this._requiredScale);for(const i of t.clusters())if(i.inner.id===e)return Array.from(i.inner.containedObjectIds);return[]}async*updateChunks(){const e=this._source.chunks();if(!e.length)return;for(const a of e)p.isLocalEditChunk(a)&&a.lastLocalEditDropped!==this._lastHandledLocalEdit&&(this.invalidate(),this._lastHandledLocalEdit=a.lastLocalEditDropped);const t=this._getClusterState(this._requiredLevel,this._requiredScale),i=Array.from(this._sendStates.values()).filter((e=>e.subscription.tile.level===this._requiredLevel));if(t.updateChunks(e,i)||!this._source.updateTracking.updating)for(const a of i)a.subscription.tile.level===this._requiredLevel&&(a.didSend=!1,a.done=!1);const s=Array.from(this._sendStates.values()).filter((e=>e.done)).map((e=>e.subscription.tile.key)),r=new Set(s);for(const a of this._sendStates.values()){if(this._source.updateTracking.updating){if(s.some((e=>e.containsChild(a.subscription.tile.key))))continue;if(a.subscription.tile.key.getChildKeys().every((e=>r.has(e))))continue}a.didSend||a.subscription.tile.level!==this._requiredLevel||(a.didSend=!0,yield*this._update(a,t,this._source))}await t.updateStatistics(this._connection)}forEachAggregateWorldSpace(e){if(null==this._requiredLevel||null==this._requiredScale)return;const t=this._getClusterState(this._requiredLevel,this._requiredScale);for(const i of t.aggregatesWorldSpace())e(i)}_getClusterState(e,t){if(null==e||null==t)throw new Error("InternalError: Level and scale must be defined");let i=this._cellsPerScale.get(t);return i||(i=new x(e,t,this._indexOptions,this._clusterRadius,this._attributeStore),this._cellsPerScale.set(t,i)),i}async*_update(e,t,i){if(e.done)return;const s=t.createAggregateFeatures(e,this._metadata);this.events.emit("changed"),e.done=!i.updateTracking.updating;const r=s.getCursor(),a=e.subscription.tile.createArcadeEvaluationOptions(this._indexOptions.timeZone);for(;r.next();)this._attributeStore.setAttributeData(r.getDisplayId(),r,a);const n=new h.FeatureTileAppendMessage(e.subscription,s,!0,e.done,{});yield n}}e.ClusterState=I,e.ClusterStrategy=M,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
