/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../../../../symbols","../../../../../../../core/Logger","../../../../../../../core/screenUtils","../../../../../../../renderers/support/heatmapUtils","../../../../../../../symbols/cim/CIMSymbolHelper","../../../../../../../symbols/cim/enums","../../../../../../../symbols/cim/SDFHelper","../../../../../engine/webgl/alignmentUtils","../../../../../engine/webgl/color","../../../../../engine/webgl/definitions","../../../../../engine/webgl/shaderGraph/techniques/TechniqueRegistry","../schemaUtils","../VisualVariablesSchema","./ComplexSymbolSchema","./utils","../../../../../../../symbols/SimpleFillSymbol","../../../../../../../symbols/SimpleMarkerSymbol","../../../../../../../symbols/SimpleLineSymbol"],(function(e,i,a,l,t,r,o,n,s,u,c,p,b,m,f,S,V,y,h){"use strict";async function v(e,i){if(!e)return[];switch(e.type){case"simple-fill":return T(e,i);case"picture-fill":return U(e,i);case"simple-marker":return x(e,i);case"picture-marker":return C(e,i);case"simple-line":return P(e,i,!1);case"text":return A(e,i);case"label":return w(e,i);case"cim":return f.createComplexSymbolInstances(e.data,i);case"web-style":{const a=await e.fetchCIMSymbol();return f.createComplexSymbolInstances(a.data,i)}case"line-3d":return a.getLogger("esri.views.layers.FeatureLayerView").warn("unsupported-symbol",`Symbol of type "${e.type}" unsupported in MapView. Defaulting to simple-line`),P(new h,i,!1);case"point-3d":return a.getLogger("esri.views.layers.FeatureLayerView").warn("unsupported-symbol",`Symbol of type "${e.type}" unsupported in MapView. Defaulting to simple-marker`),x(new y,i);case"polygon-3d":return a.getLogger("esri.views.layers.FeatureLayerView").warn("unsupported-symbol",`Symbol of type "${e.type}" unsupported in MapView. Defaulting to simple-fill`),T(new V,i);case"mesh-3d":case"label-3d":return a.getLogger("esri.views.layers.FeatureLayerView").warn("unsupported-symbol",`Symbol of type "${e.type}" unsupported in MapView. Ignoring`),[];case"CIMSymbolReference":throw new Error("InternalError: CIMSymbolReference should already be resolved")}}async function z(e,i){const{schemaOptions:a}=i,{store:l}=a,t=new Array(c.dotDensityMaxFields),r=new Array(c.dotDensityMaxFields/4);for(let p=0;p<c.dotDensityMaxFields;p++){const i=p<e.attributes.length?e.attributes[p].color:null;t[p]=[0,0,0,0],u.writeColor(t[p],i)}for(let u=0;u<c.dotDensityMaxFields/4;u++)r[u]=[0,0,0,0],r[u][0]=4*u<e.attributes.length?1:0,r[u][1]=4*u+1<e.attributes.length?1:0,r[u][2]=4*u+2<e.attributes.length?1:0,r[u][3]=4*u+3<e.attributes.length?1:0;const o={uniforms:{isActive:r,colors:t,dotValue:e.dotValue,dotScale:e.referenceScale,blending:e.dotBlendingEnabled,dotSize:e.dotSize,seed:e.seed},optionalAttributes:{}},n=l.ensureInstance(p.Techniques.dotDensity,o).createMeshInfo({effects:null}),s=[],b=new V({color:e.backgroundColor??[0,0,0,0],outline:null}),m=await v(b,i);if(s.push(...m),s.push(n),e.outline){const a=P(e.outline,i,!0);s.push(...a)}return s}async function d(e,i){const{store:a}=i,{radius:r,minDensity:o,maxDensity:n,referenceScale:s,field:u,valueExpression:c,colorStops:b}=e,m=t.generateGradient(b);return[a.ensureInstance(p.Techniques.heatmap,{uniforms:{radius:l.pt2px(r),minDensity:o,maxDensity:n,referenceScale:s,isFieldActive:!(!u&&!c),gradient:m,gradientHash:m.join(",")},optionalAttributes:{}}).createMeshInfo({effects:null})]}async function g(e,i){const{store:a}=i,t=e.outline?.width||0,r=m.createVisualVariableUniforms(e),o=a.ensureInstance(p.Techniques.pieChart,{uniforms:{shader:{outlineWidth:Math.round(l.pt2px(t)),defaultColor:b.premultiplyColor(e.defaultColor),outlineColor:b.premultiplyColor(e.outline?.color),othersColor:b.premultiplyColor(e.othersCategory?.color),donutRatio:e.holePercentage,sectorThreshold:e.othersCategory?.threshold||0,colors:e.attributes.map((e=>b.premultiplyColor(e.color))),visualVariableOpacity:r.visualVariableOpacity,visualVariableSizeMinMaxValue:r.visualVariableSizeMinMaxValue,visualVariableSizeScaleStops:r.visualVariableSizeScaleStops,visualVariableSizeStops:r.visualVariableSizeStops,visualVariableSizeUnitValue:r.visualVariableSizeUnitValue,hittestUniforms:null},numberOfFields:e.attributes.length},optionalAttributes:{}}).createMeshInfo({size:e.size,outlineWidth:t,effects:null,scaleInfo:null,minPixelBuffer:m.getMaxSizeVVSize(r)});return[...e.backgroundFillSymbol?await T(e.backgroundFillSymbol,{schemaOptions:i,path:"",uniforms:m.noVisualVariables}):[],o]}function M(e){if("path"===e.style){if(null==e.path)throw new Error("Symbol with a style of type path must define a path");return{type:"sprite-rasterization-param",overrides:[],resource:{type:"path",path:e.path,asFill:!0}}}const i=r.CIMSymbolHelper.fromSimpleMarker(e);if("outline"in e&&e.outline&&"none"!==e.outline.style){if("solid"!==e.outline.style){if(!i||!i.symbolLayers)throw new Error("Error handling marker! ");return{type:"sprite-rasterization-param",resource:i.symbolLayers[0],overrides:[]}}}return{type:"sprite-rasterization-param",resource:n.getSDFInfo(i),overrides:[]}}async function x(e,i){const{uniforms:a,schemaOptions:l}=i,{store:t}=l;if("path"===e.style||e.outline&&"solid"!==e.outline.style&&"none"!==e.outline.style){const l=r.CIMSymbolHelper.fromSimpleMarker(e);if(!l||!l.symbolLayers)throw new Error("Error handling marker! ");if(a.visualVariableRotation&&(l.angleAlignment="Map"),"path"!==e.style){const e=l.symbolLayers[0];if(S.hasSizeVVUniform(i.uniforms)){const a=m.getMaxSizeVVSize(i.uniforms,0,1);if(a>e.size){const i=a/e.size;e.size=a;const l=e.markerGraphics?.[0].symbol;(l.symbolLayers&&l.symbolLayers[0]).width*=i}}}return f.createComplexSymbolInstances({type:"CIMSymbolReference",symbol:l},i)}const n=t.ensureInstance(p.Techniques.marker,{uniforms:{visualVariableColor:a.visualVariableColor,visualVariableOpacity:a.visualVariableOpacity,visualVariableSizeMinMaxValue:a.visualVariableSizeMinMaxValue,visualVariableSizeScaleStops:a.visualVariableSizeScaleStops,visualVariableSizeStops:a.visualVariableSizeStops,visualVariableSizeUnitValue:a.visualVariableSizeUnitValue,visualVariableRotation:a.visualVariableRotation},optionalAttributes:{zoomRange:!1}}),s=M(e);let u=e.color?.toArray()??[0,0,0,0];"CIMVectorMarker"===s.resource.type&&(u=[255,255,255,255]);const c="triangle"===e.style?124/116:1,b=e.size,V=b*c,y=null!=a.visualVariableColor&&("cross"===e.style||"x"===e.style);return[n.createMeshInfo({type:"simple",color:u,height:b,width:V,offsetX:e.xoffset,offsetY:e.yoffset,angle:e.angle,alignment:S.hasRotationVVUniform(a)?o.Alignment.MAP:o.Alignment.SCREEN,outlineColor:e.outline?.color?.toArray()??[0,0,0,0],outlineSize:e.outline?.width??1,referenceSize:b,sprite:s,overrideOutlineColor:y,hasSizeVV:S.hasSizeVVUniform(a),placement:null,effects:null,transforms:null,scaleInfo:null,minPixelBuffer:m.getMaxSizeVVSize(a)})]}function C(e,i){const{uniforms:a,schemaOptions:l}=i,{store:t}=l,n=t.ensureInstance(p.Techniques.marker,{uniforms:{visualVariableColor:a.visualVariableColor,visualVariableOpacity:a.visualVariableOpacity,visualVariableSizeMinMaxValue:a.visualVariableSizeMinMaxValue,visualVariableSizeScaleStops:a.visualVariableSizeScaleStops,visualVariableSizeStops:a.visualVariableSizeStops,visualVariableSizeUnitValue:a.visualVariableSizeUnitValue,visualVariableRotation:a.visualVariableRotation},optionalAttributes:{zoomRange:!1}}),s=r.CIMSymbolHelper.createPictureMarkerRasterizationParam(e);if(!s)return[];return[n.createMeshInfo({type:"picture",color:[255,255,255,255],height:e.height,width:e.width,offsetX:e.xoffset,offsetY:e.yoffset,angle:e.angle,alignment:S.hasRotationVVUniform(a)?o.Alignment.MAP:o.Alignment.SCREEN,outlineColor:null,outlineSize:0,referenceSize:e.height,sprite:s,overrideOutlineColor:!1,hasSizeVV:S.hasSizeVVUniform(a),placement:null,effects:null,transforms:null,scaleInfo:null,minPixelBuffer:m.getMaxSizeVVSize(a)})]}function I(e,i,a){const{uniforms:l,schemaOptions:t}=a,{store:r}=t,n=r.ensureInstance(p.Techniques.marker,{uniforms:{visualVariableColor:l.visualVariableColor,visualVariableOpacity:l.visualVariableOpacity,visualVariableSizeMinMaxValue:l.visualVariableSizeMinMaxValue,visualVariableSizeScaleStops:l.visualVariableSizeScaleStops,visualVariableSizeStops:l.visualVariableSizeStops,visualVariableSizeUnitValue:l.visualVariableSizeUnitValue,visualVariableRotation:l.visualVariableRotation},optionalAttributes:{zoomRange:!1}}),s=M(e),u=6,c=u*i.width,b=c,f=e.color?.toArray()??i.color?.toArray()??[0,0,0,0],V="cross"===e.style||"x"===e.style;let y;switch(e.placement){case"begin-end":y=o.ExtremityPlacement.Both;break;case"begin":y=o.ExtremityPlacement.JustBegin;break;case"end":y=o.ExtremityPlacement.JustEnd;break;default:y=o.ExtremityPlacement.None}const h={type:"cim-marker-placement-param",placement:{type:"CIMMarkerPlacementAtExtremities",angleToLine:!0,offset:0,extremityPlacement:y,offsetAlongLine:0},overrides:[]};return[n.createMeshInfo({type:"simple",color:f,height:b,width:c,offsetX:0,offsetY:0,angle:0,alignment:S.hasRotationVVUniform(l)?o.Alignment.MAP:o.Alignment.SCREEN,outlineColor:f,outlineSize:V?i.width:0,referenceSize:b/u,sprite:s,overrideOutlineColor:V&&null!=l.visualVariableColor,hasSizeVV:S.hasSizeVVUniform(l),placement:h,transforms:null,effects:null,scaleInfo:null,minPixelBuffer:m.getMaxSizeVVSize(l)})]}function A(e,i){const{uniforms:a,schemaOptions:l}=i,{store:t}=l;return[t.ensureInstance(p.Techniques.text,{uniforms:{visualVariableColor:a.visualVariableColor,visualVariableOpacity:a.visualVariableOpacity,visualVariableRotation:a.visualVariableRotation,visualVariableSizeMinMaxValue:a.visualVariableSizeMinMaxValue,visualVariableSizeScaleStops:a.visualVariableSizeScaleStops,visualVariableSizeStops:a.visualVariableSizeStops,visualVariableSizeUnitValue:a.visualVariableSizeUnitValue},optionalAttributes:{zoomRange:!1,clipAngle:!1,referenceSymbol:!1}}).createMeshInfo({boxBackgroundColor:e.backgroundColor?.toArray(),boxBorderLineColor:e.borderLineColor?.toArray(),boxBorderLineSize:e.borderLineSize??0,color:e.color?.toArray()??[0,0,0,0],offsetX:e.xoffset,offsetY:e.yoffset,postAngle:e.angle,fontSize:e.font.size,decoration:e.font.decoration,haloColor:e.haloColor?.toArray()??[0,0,0,0],haloSize:e.haloSize??0,outlineColor:[0,0,0,0],outlineSize:0,lineWidth:e.lineWidth,lineHeightRatio:e.lineHeight,horizontalAlignment:e.horizontalAlignment,verticalAlignment:e.verticalAlignment,useCIMAngleBehavior:!1,glyphs:{type:"text-rasterization-param",resource:{type:"text",font:e.font.toJSON(),textString:e.text,symbol:r.CIMSymbolHelper.createCIMTextSymbolfromTextSymbol(e)},overrides:[]},referenceSize:null,effects:null,placement:null,scaleInfo:null,transforms:null,scaleFactor:1,minPixelBuffer:m.getMaxSizeVVSize(a),repeatLabel:null,repeatLabelDistance:null,allowOverrun:null,labelPosition:null})]}function w(e,i){const{schemaOptions:a,uniforms:t}=i,{store:o}=a,n=e.symbol,{allowOverrun:u,repeatLabel:c,repeatLabelDistance:b}=e,f={maxScale:e.maxScale??0,minScale:e.minScale??0},S=o.ensureInstance(p.Techniques.label,{uniforms:{visualVariableColor:null,visualVariableOpacity:null,visualVariableRotation:t.visualVariableRotation,visualVariableSizeMinMaxValue:t.visualVariableSizeMinMaxValue,visualVariableSizeScaleStops:t.visualVariableSizeScaleStops,visualVariableSizeStops:t.visualVariableSizeStops,visualVariableSizeUnitValue:t.visualVariableSizeUnitValue},optionalAttributes:{zoomRange:!0,clipAngle:!0,referenceSymbol:!0}}),V=e.labelPlacement,[y,h]=s.getAlignmentFromPlacement(V);return[S.createMeshInfo({boxBackgroundColor:n.backgroundColor?.toArray(),boxBorderLineColor:n.borderLineColor?.toArray(),boxBorderLineSize:n.borderLineSize??0,color:n.color?.toArray()??[0,0,0,0],offsetX:n.xoffset,offsetY:n.yoffset,postAngle:n.angle,fontSize:n.font.size,decoration:n.font.decoration,outlineColor:[0,0,0,0],outlineSize:0,haloColor:n.haloColor?.toArray()??[0,0,0,0],haloSize:n.haloSize??0,lineWidth:n.lineWidth,lineHeightRatio:n.lineHeight,horizontalAlignment:y,verticalAlignment:h,repeatLabel:c,repeatLabelDistance:l.pt2px(b),allowOverrun:u,labelPosition:e.labelPosition,scaleInfo:f,minPixelBuffer:m.getMaxSizeVVSize(t),useCIMAngleBehavior:!1,glyphs:{type:"text-rasterization-param",resource:{type:"text",font:n.font.toJSON(),textString:n.text,symbol:r.CIMSymbolHelper.createCIMTextSymbolfromTextSymbol(n),primitiveName:"label-override"},useLegacyLabelEvaluationRules:null==e.labelExpressionInfo?.expression,overrides:[{type:"CIMPrimitiveOverride",valueExpressionInfo:{type:"CIMExpressionInfo",expression:e.labelExpressionInfo?.expression??e.labelExpression,returnType:"String"},primitiveName:"label-override",propertyName:"textString",defaultValue:""}]},referenceSize:null,effects:null,placement:null,transforms:null,scaleFactor:1})]}function O(e,i){const a=e.width;return{outlineColor:e.color?.toArray()||[0,0,0,1],width:a,referenceWidth:a,capType:e.cap??"round",joinType:e.join??"round",miterLimit:e.miterLimit,hasSizeVV:i}}function L(e,i){const{uniforms:a,schemaOptions:l}=i,{store:t}=l,r=e.color?.toArray()??[0,0,0,0],o={type:"sprite-rasterization-param",resource:{type:"fill-style",style:e.style},overrides:[]};if("solid"===e.outline?.style){return[t.ensureInstance(p.Techniques.patternOutlineFill,{uniforms:{visualVariableColor:a.visualVariableColor,visualVariableOpacity:a.visualVariableOpacity,visualVariableSizeScaleStops:a.visualVariableSizeOutlineScaleStops,visualVariableSizeMinMaxValue:null,visualVariableSizeStops:null,visualVariableSizeUnitValue:null},optionalAttributes:{zoomRange:!1}}).createMeshInfo({color:r,...O(e.outline,!!a.visualVariableSizeOutlineScaleStops),sprite:o,scaleInfo:null,effects:null})]}const n=[],s=t.ensureInstance(p.Techniques.patternFill,{uniforms:{visualVariableColor:a.visualVariableColor,visualVariableOpacity:a.visualVariableOpacity},optionalAttributes:{zoomRange:!1}}).createMeshInfo({color:e.color?.toArray()??[0,0,0,0],sprite:o,scaleInfo:null,effects:null});return n.push(s),e.outline&&n.push(...P(e.outline,i,!0)),n}function R(e,i){const{uniforms:a,schemaOptions:l}=i,{store:t}=l,r=e.color?.toArray()??[0,0,0,0];if("none"!==e.style&&"solid"===e.outline?.style){return[t.ensureInstance(p.Techniques.outlineFill,{uniforms:{visualVariableColor:a.visualVariableColor,visualVariableOpacity:a.visualVariableOpacity,visualVariableSizeScaleStops:a.visualVariableSizeOutlineScaleStops,visualVariableSizeMinMaxValue:null,visualVariableSizeStops:null,visualVariableSizeUnitValue:null},optionalAttributes:{zoomRange:!1}}).createMeshInfo({color:r,...O(e.outline,!!a.visualVariableSizeOutlineScaleStops),scaleInfo:null,effects:null})]}const o=[];if("none"!==e.style){const e=t.ensureInstance(p.Techniques.fill,{uniforms:{visualVariableColor:a.visualVariableColor,visualVariableOpacity:a.visualVariableOpacity},optionalAttributes:{zoomRange:!1}}).createMeshInfo({color:r,scaleInfo:null,effects:null});o.push(e)}return e.outline&&o.push(...P(e.outline,i,!0)),o}async function T(e,i){if("cim"===e.type)return f.createComplexSymbolInstances(e.data,i);const{style:a}=e;return a&&"none"!==a&&"solid"!==a?L(e,i):R(e,i)}function U(e,i){const{outline:a}=e,{uniforms:l,schemaOptions:t}=i,{store:o}=t,n=[],s=r.CIMSymbolHelper.createPictureFillRasterizationParam(e);if(!s)return[];const{width:u,height:c,xoffset:b,yoffset:m,xscale:f,yscale:S}=e,V={color:[255,255,255,255],sprite:s,height:c,aspectRatio:u/c,offsetX:b,offsetY:m,scaleX:f,scaleY:S,angle:0,applyRandomOffset:!1,sampleAlphaOnly:!1,scaleProportionally:!1,effects:null,scaleInfo:null};if("solid"===a?.style){return[o.ensureInstance(p.Techniques.complexOutlineFill,{uniforms:{visualVariableColor:l.visualVariableColor,visualVariableOpacity:l.visualVariableOpacity,visualVariableSizeScaleStops:l.visualVariableSizeOutlineScaleStops,visualVariableSizeMinMaxValue:null,visualVariableSizeStops:null,visualVariableSizeUnitValue:null},optionalAttributes:{zoomRange:!1}}).createMeshInfo({...V,...O(a,!!l.visualVariableSizeOutlineScaleStops)})]}const y=o.ensureInstance(p.Techniques.complexFill,{uniforms:{visualVariableColor:l.visualVariableColor,visualVariableOpacity:l.visualVariableOpacity},optionalAttributes:{zoomRange:!1}});return n.push(y.createMeshInfo(V)),a&&n.push(...P(a,i,!0)),n}function P(e,i,a){const{color:l,style:t,width:o,cap:n,join:s}=e,{schemaOptions:u}=i,{store:c}=u,b=[],f=a?{...m.noVisualVariables,visualVariableSizeScaleStops:i.uniforms.visualVariableSizeOutlineScaleStops}:i.uniforms,V={uniforms:{visualVariableColor:f.visualVariableColor,visualVariableOpacity:f.visualVariableOpacity,visualVariableSizeMinMaxValue:f.visualVariableSizeMinMaxValue,visualVariableSizeScaleStops:f.visualVariableSizeScaleStops,visualVariableSizeStops:f.visualVariableSizeStops,visualVariableSizeUnitValue:f.visualVariableSizeUnitValue},optionalAttributes:{zoomRange:!1}},y={color:l?.toArray()??[0,0,0,0],width:o,referenceWidth:o,capType:n,joinType:s,miterLimit:e.miterLimit,hasSizeVV:S.hasSizeVVUniform(f),effects:null,scaleInfo:null};if(null==t||"solid"===t){const e=c.ensureInstance(p.Techniques.line,V).createMeshInfo(y);b.push(e)}else if("none"!==t){const e=c.ensureInstance(p.Techniques.texturedLine,V).createMeshInfo({...y,offsetAlongLine:0,shouldScaleDash:!0,shouldSampleAlphaOnly:!1,isSDF:!0,sprite:{type:"sprite-rasterization-param",resource:{type:"dash",dashTemplate:r.slsDashToTemplateArray(t,n)},overrides:[]}});b.push(e)}return null!=e.marker&&b.push(...I(e.marker,e,i)),b}e.createDotDensityMeshSchemas=z,e.createHeatmapMeshSchemas=d,e.createLineInstance=P,e.createPieChartMeshSchemas=g,e.createSymbolMeshSchemas=v,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
