/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../../request","../../../../../core/has","../../../../../core/promiseUtils","../../../../../core/accessorSupport/diffUtils","../../../../../layers/graphics/OptimizedFeature","../../../../../layers/graphics/data/QueryEngine","../../../../../rest/query/operations/query","../FeatureStoreStatistics","./FeatureSourceQueryInfo","./StreamMessenger","./strategies/DrillDownTileLoadStrategy","./strategies/PagedTileLoadStrategy","./strategies/ParquetLoadStrategy","./strategies/SnapshotLoadStrategy","./strategies/StreamLoadStrategy","./strategies/chunks/SourceChunkStore","../support/FeatureMetadata","../support/FeatureSetReaderJSON","../../support/UpdateTracking2D"],(function(e,t,s,r,a,i,n,o,d,h,u,c,l,g,y,p,_,m,f,S){"use strict";class v{constructor(e,t,s,r,a){this.service=e,this._aggregateAdapter=t,this._subscriptions=s,this._onChange=r,this._connection=a,this._updateTracking=new S.UpdateTracking2D({debugName:"FeatureSource"}),this._didInvalidateData=!1,this._store=new _.FeatureSourceChunkStore(this._onChange),this._metadata=m.FeatureMetadata.createFeature(e.metadata)}destroy(){this._strategy?.destroy(),this._store.destroy(),this._streamMessenger?.destroy(),"memory"===this.service.type&&this.service.source.map((e=>e.close()))}get metadata(){if(!this._metadata)throw new Error("InternalError: Metadata not defined. Was update called?");return this._metadata}get store(){return this._store}get streamMessenger(){return null==this._streamMessenger&&this._initStreamMessenger(),this._streamMessenger}get statistics(){return d.FeatureStoreStatistics.from(this._store)}get updateTracking(){return this._updateTracking}get queryEngine(){if(!this._queryEngine){if(!this._schema)return null;const{dataFilter:e}=this._schema.mutable,t=this._schema.mutable.availableFields,s=this._metadata;this._queryEngine=new n.QueryEngine({featureStore:this._store,fieldsIndex:s.fieldsIndex,geometryType:s.geometryType,objectIdField:s.objectIdField,hasM:!1,hasZ:!1,spatialReference:this.service.outSpatialReference,aggregateAdapter:this._aggregateAdapter,timeInfo:s.timeInfo,definitionExpression:e.definitionExpression,availableFields:t})}return this._queryEngine}get isStream(){return"stream"===this._schema.type}chunks(){return Array.from(this._store.chunks())}cleanupRemovedChunks(){return this._store.cleanupRemovedChunks()}onSubscribe(e){this._connection.onEvent({type:"subscribe",tile:e.tile.id});const t=this._strategy?.load(e);t&&(t.then((()=>this._connection.onEvent({type:"loaded",tile:e.tile.id}))).catch((t=>this._connection.onEvent({type:"error",tile:e.tile.id,error:t}))),this._updateTracking.addPromise(t))}onResume(e){this._updateTracking.addPromise(r.ignoreAbortErrors(this._strategy?.load(e)))}onUnsubscribe(e){this._connection.onEvent({type:"unsubscribe",tile:e.tile.id}),this._strategy?.unload(e)}getLocalEdit(e){return this._updateTracking.addPromise(this._getGetLocalEdit(e))}applyLocalEdit(e){this._didInvalidateData=!0,this._store.applyLocalEdit(e,this.metadata)}async update(e,t){const r=e.source,i=a.diff(this._schema?.mutable,r.mutable);if(!i)return!1;if(s("esri-2d-update-debug")&&console.debug(`Version[${t}] FeatureSource.update`,{changes:i}),this._schema=r,this._queryEngine?.destroy(),this._queryEngine=null,"feature-service"===this.service.type&&null!=this.service.queryMetadata.lastEditDate&&(this._lastEditDate=this.service.queryMetadata.lastEditDate),null==this._streamMessenger&&"stream"===this._schema.type&&this._initStreamMessenger(),a.hasRootDiffOnly(i,"sourceRefreshVersion")&&this._strategy?.refresh)return await this._strategy.refresh(),!0;if(("feature"===r.type||"parquet"===r.type)&&a.hasRootDiffOnly(i,"availableFields")){if(await this._queryLastEditDateChanged()||this._didInvalidateData)this._didInvalidateData=!1,await this._updateStrategy(t);else{this._connection.onEvent({type:"updateFieldsStart"});try{await this._strategy.updateFields(r.mutable.availableFields),this._connection.onEvent({type:"updateFieldsEnd"})}catch(n){this._connection.onEvent({type:"updateFieldsError",error:n})}}return!1}return!(!a.hasRootDiff(i,"dataFilter")&&!a.hasRootDiff(i,"sourceRefreshVersion"))&&(await this._updateStrategy(t),!0)}async addParquetFile(e){this._strategy.addParquetFile(e)}_initStreamMessenger(){null==this._streamMessenger&&(this._streamMessenger=new u.StreamMessenger(this._connection))}async _getGetLocalEdit(e){if(e.historicMoment&&"feature"===this._schema.type&&(this._schema.mutable.dataFilter.historicMoment=e.historicMoment,this._strategy.unsafeSetQueryHistoricMoment(new Date(e.historicMoment))),"edit-by-feature"===e.type){const t=[...e.added,...e.updated].map((e=>i.OptimizedFeature.fromJSON(e,this.metadata.objectIdField)));return{reader:f.FeatureSetReaderJSON.fromOptimizedFeatures(t,this.metadata),removed:this._resolveIdentifiers(e.removed)}}const t=this._resolveIdentifiers(e.removed);if(!e.updated.length&&!e.added.length)return{reader:f.FeatureSetReaderJSON.empty(this.metadata),removed:t};const s=this._resolveIdentifiers([...e.added,...e.updated]);return{reader:await this._strategy.queryByObjectId(s),removed:t}}_resolveIdentifiers(e){const t=[],s=[];for(const r of e)null!=r.objectId&&-1!==r.objectId?s.push(r.objectId):t.push(r.globalId);if(t.length){const e=new Set(t),r=this.metadata.globalIdField;if(null==r)throw new Error("InternalError: Recieved an edit with globalIds, but not supported by the service");this._store.forEachUnsafe((t=>{const a=t.readAttribute(r);e.has(a)&&s.push(t.getObjectId())}))}return s}async _queryLastEditDateChanged(){if(null==this._lastEditDate)return!1;const e=this.service.source,s={...e.query,f:"json"},r=(await t(e.path,{query:s,responseType:"json"})).data.editingInfo.lastEditDate;return r!==this._lastEditDate&&(this._lastEditDate=r,!0)}async _createStrategy(){const e="isSourceHosted"in this.service&&this.service.isSourceHosted,t=Array.isArray(this.service.source),s=this.service.source&&"collection"in this.service.source,r=e||t||s;if("stream"===this._schema.type){const e=new p.StreamLoadStrategy(this.service,this._schema.mutable.dataFilter,this._store,{outSR:this.service.outSpatialReference},this.metadata);return this._streamMessenger.strategy=e,e}if("parquet"===this._schema.type){const e=this.service;return new g.ParquetLoadStrategy(e,this._metadata,this._schema,this._store)}const a=this.service,i=h.FeatureSourceQueryInfo.fromSchema(a,this._schema,this._metadata),n=await this._supportSnapshotMode(a,i);return n?new y.SnapshotLoadStrategy(a,i,this._store,n.featureCount,this.metadata,this._connection):r?new l.PagedTileLoadStrategy(a,i,this._store,this.metadata,this._connection):new c.DrillDownTileLoadStrategy(a,i,this._store,this.metadata,this._connection)}async _updateStrategy(e){const t=await this._createStrategy();this._connection.onEvent({type:"updateStrategyStart",about:t.about});const a=!!this._strategy;this._store.clear(),this._strategy?.destroy(),this._strategy=t,s("esri-2d-update-debug")&&console.debug(`Version[${e}] FeatureSource.updateStrategy`,{strategy:t});const i=Array.from(this._subscriptions.values());if(!i.length)return void this._connection.onEvent({type:"updateStrategyEnd"});const n=Promise.all(i.map((e=>this._strategy.load(e).then((()=>this._connection.onEvent({type:"loaded",tile:e.tile.id}))).catch((t=>this._connection.onEvent({type:"error",tile:e.tile.id,error:t}))))));this._updateTracking.addPromise(n);try{a&&await n}catch(o){r.throwIfNotAbortError(o)}this._connection.onEvent({type:"updateStrategyEnd"}),s("esri-2d-update-debug")&&console.debug(`Version[${e}] FeatureSource.updateStrategyEnd`,{strategy:t})}async _supportSnapshotMode(e,t){const{queryMetadata:s}=e,r=s.snapshotInfo;if(!r||!r.supportsSnapshotMinThreshold||!r.snapshotCountThresholds)return null;const a=e.source,i=t.createQuery();i.inner.orderByFields=[],i.inner.returnGeometry=!1;const n=(await o.executeQueryForCount(a,i.inner,{query:i.customParameters})).data.count,{min:d,max:h}=r.snapshotCountThresholds;return n<=d||r.supportsSnapshotMaxThreshold&&n<h?{featureCount:n}:null}}e.FeatureSource=v,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
