/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../../core/Error","../../../../../core/Logger","../../../../../geometry/support/aaBoundingBox","../../../engine/webgl/DisplayId","./CachedField","./ComputedExpression","./ComputedLegacyLabelExpression","./NormalizedField","./StaticBitSet","./whereUtils"],(function(e,t,s,i,n,r,o,d,a,u,l){"use strict";const h=()=>s.getLogger("esri.views.2d.layers.features.support.ComputedAttributeStorage"),c=4294967295;function p(e,t,s){if(!(e.length>t))for(;e.length<=t;)e.push(s)}class m{constructor(e){this._numerics=[],this._strings=[],this._allocatedSize=256,this._bitsets=[],this._instanceIds=[],this._bounds=[],this._dirtyBitset=this.getBitset(this.createBitset()),this.compilationOptions=e}createBitset(){const e=this._bitsets.length;return this._bitsets.push(u.StaticBitSet.create(this._allocatedSize,n.displayIdTexelMask)),e+1}async createComputedField(e,s=!1){if(e.expression)try{if(!this.compilationOptions)throw new Error("InternalError: Compilation options not defined");if(s)return await d.ComputedLegacyLabelExpression.create(e.expression,this.compilationOptions);return await o.ComputedExpression.create(e.expression,this.compilationOptions)}catch(n){const s=new t("featurelayer","Failed to compile arcade expression",{error:n,expression:e.expression});return h().error(s),null}if(e.normalizationType||e.normalizationField)return new a.NormalizedField(e.field,e);if(e.field)return new r.CachedField(e.field);const i=new t("featurelayer","Unable to create computed field. No expression or field found",{info:e});return h().error(i),null}async createWhereClause(e){return e?l.createWhereClause(e,this.compilationOptions.fields):null}getBitset(e){return this._bitsets[e-1]}getComputedNumeric(e,t){return this.getComputedNumericAtIndex(e&n.displayIdTexelMask,0)}setComputedNumeric(e,t,s){return this.setComputedNumericAtIndex(e&n.displayIdTexelMask,s,0)}getComputedString(e,t){return this.getComputedStringAtIndex(e&n.displayIdTexelMask,0)}setComputedString(e,t,s){return this.setComputedStringAtIndex(e&n.displayIdTexelMask,0,s)}getComputedNumericAtIndex(e,t){const s=e&n.displayIdTexelMask;return this._ensureNumeric(t,s),this._numerics[t][s]}setComputedNumericAtIndex(e,t,s){const i=e&n.displayIdTexelMask;this._ensureNumeric(t,i),this._numerics[t][i]=s}getPackedChunkId(e){const t=e&n.displayIdTexelMask;return this._ensureInstanceId(t),this._instanceIds[t]}setPackedChunkId(e,t){const s=e&n.displayIdTexelMask;this._ensureInstanceId(s),this._instanceIds[s]=t}getComputedStringAtIndex(e,t){const s=e&n.displayIdTexelMask;return this._ensureString(t,s),this._strings[t][s]}setComputedStringAtIndex(e,t,s){const i=e&n.displayIdTexelMask;this._ensureString(t,i),this._strings[t][i]=s}getXMin(e){return this._bounds[4*(e&n.displayIdTexelMask)]}getYMin(e){return this._bounds[4*(e&n.displayIdTexelMask)+1]}getXMax(e){return this._bounds[4*(e&n.displayIdTexelMask)+2]}getYMax(e){return this._bounds[4*(e&n.displayIdTexelMask)+3]}setBounds(e,t,s=!1){const i=e&n.displayIdTexelMask;if(!s&&!this._dirtyBitset.has(e))return this._bounds[4*i]!==c;this._dirtyBitset.unset(e);const r=t.readGeometryWorldSpace();if(p(this._bounds,4*i+4,0),!r||!r.coords.length)return this._bounds[4*i]=c,this._bounds[4*i+1]=c,this._bounds[4*i+2]=c,this._bounds[4*i+3]=c,!1;let o=1/0,d=1/0,a=-1/0,u=-1/0;return r.forEachVertex(((e,t)=>{o=Math.min(o,e),d=Math.min(d,t),a=Math.max(a,e),u=Math.max(u,t)})),this._bounds[4*i]=o,this._bounds[4*i+1]=d,this._bounds[4*i+2]=a,this._bounds[4*i+3]=u,!0}getBounds(e,t){const s=this.getXMin(t),n=this.getYMin(t),r=this.getXMax(t),o=this.getYMax(t);return i.fromRectValues(e,s,n,r,o),s!==c}_ensureNumeric(e,t){this._numerics[e]||(this._numerics[e]=[]);p(this._numerics[e],t,0)}_ensureInstanceId(e){p(this._instanceIds,e,0)}_ensureString(e,t){this._strings[e]||(this._strings[e]=[]);p(this._strings[e],t,null)}}e.ComputedAttributeStorage=m,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
