/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../../core/Error","../../../../../core/has","../../../../../core/Logger","../../../../../core/maybe","../../../../../core/pbf","../../../../../layers/graphics/OptimizedGeometry","./FeatureSetCache","./FeatureSetReader","./FeatureSetReaderPBFHeader"],(function(e,t,r,s,n,a,i,h,o,u){"use strict";const d=!0,c=268435455,g=128,_=128e3,l={small:{delta:new Int32Array(g),decoded:new Int32Array(g)},large:{delta:new Int32Array(_),decoded:new Int32Array(_)}};function f(e){return e<=l.small.delta.length?l.small:(e<=l.large.delta.length||(l.large.delta=new Int32Array(Math.round(1.25*e)),l.large.decoded=new Int32Array(Math.round(1.25*e))),l.large)}function I(e){try{const t=2,r=new a(new Uint8Array(e),new DataView(e));for(;r.next();){if(r.tag()===t)return y(r.getMessage());r.skip()}}catch(r){const e=new t("query:parsing-pbf","Error while parsing FeatureSet PBF payload",{error:r});s.getLogger("esri.view.2d.layers.features.support.FeatureSetReaderPBF").error(e)}return null}function y(e){const t=1;for(;e.next();){if(e.tag()===t)return e.getMessage();e.skip()}return null}function p(e){const t=1,r=2,s=3,n=4,a=5,i=6,h=7,o=8,u=9,d=e.getLength(),c=e.pos()+d;for(;e.pos()<c&&e.next();)switch(e.tag()){case t:return e.getString();case r:return e.getFloat();case s:return e.getDouble();case n:return e.getSInt32();case a:return e.getUInt32();case i:return e.getInt64();case h:return e.getUInt64();case o:return e.getSInt64();case u:return e.getBool();default:return e.skip(),null}return null}function m(e,t,r,s,n,a){return.5*Math.abs(e*s+r*a+n*t-e*a-r*t-n*s)}function x(e,t,r,s,n){if(!e)return!1;return 0===t*n-s*r&&t*s+r*n>0}class S extends o.FeatureSetReader{static fromBuffer(e,t,r=!1){const s=t.geometryType,n=I(e),a=u.parseHeader(n,"esriGeometryPoint"===s,r);return new S(n,a,t)}constructor(e,t,r){super(r),this._hasNext=!1,this._isPoints=!1,this._featureIndex=-1,this._featureOffset=0,this._cache={area:0,unquantGeometry:void 0,geometry:void 0,centroid:void 0,legacyFeature:void 0,optFeature:void 0},this._parseCaches=new Array,this._geometryType=r.geometryType,this._reader=e,this._header=t,this._hasNext=t.hasFeatures,this._isPoints="esriGeometryPoint"===r.geometryType}get _size(){return this._header.featureCount}get fields(){return this._header.fields}get geometryType(){return this._geometryType}get hasZ(){return!1}get hasM(){return!1}get hasFeatures(){return this._header.hasFeatures}get hasNext(){return this._hasNext}get exceededTransferLimit(){return this._header.exceededTransferLimit}getSize(){return this._size}getInTransform(){return this._header.transform}getCursor(){return this.copy()}getIndex(){return this._featureIndex}setIndex(e){this._cache.area=0,this._cache.unquantGeometry=void 0,this._cache.geometry=void 0,this._cache.centroid=void 0,this._cache.legacyFeature=void 0,this._cache.optFeature=void 0,this._featureIndex=e}getAttributeHash(){let e="";for(const t of this._header.fields.fields)e+=this._readAttributeAtIndex(t.index)+".";return e}getObjectId(){return this._readAttributeAtIndex(this._header.objectIdFieldIndex)}getDisplayId(){return this._header.displayIds[this._featureIndex]}setDisplayId(e){this._header.displayIds[this._featureIndex]=e}readGeometryArea(){return this._cache.area||this._readGeometry(!0),this._cache.area}copy(){const e=this._reader.clone(),t=new S(e,this._header,this.metadata);return this.copyInto(t),t}next(){for(this._cache.area=0,this._cache.unquantGeometry=void 0,this._cache.geometry=void 0,this._cache.centroid=void 0,this._cache.legacyFeature=void 0,this._cache.optFeature=void 0;++this._featureIndex<this._size&&!this._getExists(););return this._featureIndex<this._size}_readX(){return this._header.centroid[2*this._featureIndex]}_readY(){return this._header.centroid[2*this._featureIndex+1]}_readServerCentroid(){const e=this._header.centroid[2*this._featureIndex],t=this._header.centroid[2*this._featureIndex+1];return e===c?null:new i([],[e,t])}_readGeometry(e=!1){if(void 0===this._cache.geometry){let r=null;if(this._isPoints){if(this._header.centroid[2*this._featureIndex]===c)return null;const e=this._header.centroid[2*this._featureIndex],t=this._header.centroid[2*this._featureIndex+1];r=new i([],[e,t])}else{const s=this._header.offsets.geometry[this._featureIndex],n=this._reader;if(0===s)return null;n.move(s);try{r=e?this._parseGeometryForDisplay(n):this._parseGeometry(n)}catch(t){return null}}return 0===r?.coords.length&&(r=null),this._cache.geometry=r,r}return this._cache.geometry}_readAttribute(e,t){const r=this._header.fields.get(e);if(null==r)return;const s=this._readAttributeAtIndex(r.index),n=this._header.fields.isDateField(r.name);return t?null==s?s:n?new Date(s):s:s}_readAttributes(){const e={};for(const t of this._header.fields.fields)e[t.name]=this._readAttributeAtIndex(t.index);return e}copyInto(e){super.copyInto(e),e._featureIndex=this._featureIndex,e._featureOffset=this._featureOffset,e._hasNext=this._hasNext,e._parseCaches=this._parseCaches}_readAttributeAtIndex(e){let t=this._parseCaches[e];if(t||(t=new h.FeatureSetCache(this.getSize()),this._parseCaches[e]=t),t.has(this._featureIndex))return t.get(this._featureIndex);const r=this._header.offsets.attributes[this._featureIndex*this._header.fieldCount+e],s=this._reader;s.move(r);const n=p(s);return t.set(this._featureIndex,n),n}_readGeometryDeltaDecoded(e=!1){if(void 0===this._cache.unquantGeometry){const t=this._readGeometry(e);if(!t)return this._cache.unquantGeometry=void 0,null;if(!this.getInTransform())return this._cache.unquantGeometry=t,t;const r=f(t.coords.length).decoded,s=t.clone(r),n=s.coords;let a=0;for(const e of s.lengths){for(let t=1;t<e;t++){const e=2*(a+t),r=2*(a+t-1);n[e]+=n[r],n[e+1]+=n[r+1]}a+=e}return this._cache.unquantGeometry=s,s}return this._cache.unquantGeometry}_parseGeometry(e){const t=2,r=3,s=e.asUnsafe(),n=s.getLength(),a=s.pos()+n,h=[],o=[];for(;s.pos()<a&&s.next();)switch(s.tag()){case t:{const e=s.getUInt32(),t=s.pos()+e;for(;s.pos()<t;)o.push(s.getUInt32());break}case r:{const e=s.getUInt32(),t=s.pos()+e;for(h.push(s.getSInt64()),h.push(s.getSInt64()),this.hasZ&&s.getSInt64(),this.hasM&&s.getSInt64();s.pos()<t;)h.push(s.getSInt64()),h.push(s.getSInt64()),this.hasZ&&s.getSInt64(),this.hasM&&s.getSInt64();break}default:s.skip()}return new i(o,h)}_parseGeometryForDisplay(e){const t=2,r=3,s=e.asUnsafe(),a=s.getLength(),h=s.pos()+a,o=[],u=[];let c=0,g=0,_=null,l=0;const I="esriGeometryPolygon"===this.geometryType,y="esriGeometryPolyline"===this.geometryType,p=I||y;for(;s.pos()<h&&s.next();)switch(s.tag()){case t:{const e=s.getUInt32(),t=s.pos()+e;for(;s.pos()<t;){const e=s.getUInt32();o.push(e),c+=e}_=f(2*c).delta;break}case r:{s.getUInt32();const e=2+(this.hasZ?1:0)+(this.hasM?1:0);n.assertIsSome(_);for(const t of o)if(g+e*t>_.length)for(let e=0;e<t;e++)s.getSInt32(),s.getSInt32(),this.hasZ&&s.getSInt32(),this.hasM&&s.getSInt32();else if(I&&d){const e=this.getAreaSimplificationThreshold(t,this._header.vertexCount);let r=2,n=1;const a=!1;let i=s.getSInt32(),h=s.getSInt32();_[g++]=i,_[g++]=h,this.hasZ&&s.getSInt32(),this.hasM&&s.getSInt32();let o=s.getSInt32(),d=s.getSInt32();for(this.hasZ&&s.getSInt32(),this.hasM&&s.getSInt32();r<t;){let t=s.getSInt32(),a=s.getSInt32();this.hasZ&&s.getSInt32(),this.hasM&&s.getSInt32();const u=i+o,c=h+d;m(i,h,u,c,u+t,c+a)>=e?(l+=-.5*(u-i)*(c+h),n>1&&x(p,_[g-2],_[g-1],o,d)?(_[g-2]+=o,_[g-1]+=d):(_[g++]=o,_[g++]=d,n++),i=u,h=c):(t+=o,a+=d),o=t,d=a,r++}n<3||a?g-=2*n:(l+=-.5*(i+o-i)*(h+d+h),x(p,_[g-2],_[g-1],o,d)?(_[g-2]+=o,_[g-1]+=d,u.push(n)):(_[g++]=o,_[g++]=d,u.push(++n)))}else{let e=0,r=s.getSInt32(),n=s.getSInt32();this.hasZ&&s.getSInt32(),this.hasM&&s.getSInt32(),_[g++]=r,_[g++]=n,e+=1;for(let a=1;a<t;a++){const t=s.getSInt32(),i=s.getSInt32(),h=r+t,o=n+i;l+=-.5*(h-r)*(o+n),this.hasZ&&s.getSInt32(),this.hasM&&s.getSInt32(),a>2&&x(p,_[g-2],_[g-1],t,i)?(_[g-2]+=t,_[g-1]+=i):(_[g++]=t,_[g++]=i,e+=1),r=h,n=o}u.push(e)}break}default:s.skip()}return this._cache.area=l,u.length?new i(u,_):null!=_?this._createQuantizedExtrudedGeometry(_[0],_[1]):null}}e.FeatureSetReaderPBF=S,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
