/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../Viewpoint","../../../core/Accessor","../../../core/maybe","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/Logger","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../../geometry/Point","../viewpointUtils","./duration","./ZoomBox","./actions/Pan","./actions/Pinch","./actions/Rotate"],(function(t,i,e,o,n,s,a,r,c,h,p,u,m,l,d,w){"use strict";const v=10,_=1,y=new i({targetGeometry:new h}),g=[0,0],T=250;let z=class extends e{constructor(t){super(t),this._endTimer=null,this._lastEventTimestamp=null,this.animationManager=null,this.interacting=!1}initialize(){this.pan=new l({navigation:this}),this.rotate=new w({navigation:this}),this.pinch=new d({navigation:this}),this.zoomBox=new m({view:this.view,navigation:this})}destroy(){this.pan=o.destroyMaybe(this.pan),this.rotate=o.destroyMaybe(this.rotate),this.pinch=o.destroyMaybe(this.pinch),this.zoomBox=o.destroyMaybe(this.zoomBox),this.animationManager=null}begin(){this.stop(),this._set("interacting",!0)}end(){this._lastEventTimestamp=performance.now(),this._startTimer(T)}async zoom(t,i=this._getDefaultAnchor()){if(this.begin(),this.view.constraints.snapToZoom&&this.view.constraints.effectiveLODs)return t<1?this.zoomIn(i):this.zoomOut(i);this.setViewpoint(i,t,0,[0,0])}async zoomIn(t){const i=this.view,e=i.constraints.snapToNextScale(i.scale);return this._zoomToScale(e,t)}async zoomOut(t){const i=this.view,e=i.constraints.snapToPreviousScale(i.scale);return this._zoomToScale(e,t)}setViewpoint(t,i,e,o){this.begin(),this.view.stateManager.state.viewpoint=this._scaleRotateTranslateViewpoint(this.view.viewpoint,t,i,e,o),this.end()}setViewpointImmediate(t,i=0,e=[0,0],o=this._getDefaultAnchor()){this.view.stateManager.state.viewpoint=this._scaleRotateTranslateViewpoint(this.view.viewpoint,o,t,i,e)}continuousRotateClockwise(){const t=this.view.viewpoint;this.animationManager?.animateContinuous(t,(t=>{p.rotateBy(t,t,-_)}))}continuousRotateCounterclockwise(){const t=this.view.viewpoint;this.animationManager?.animateContinuous(t,(t=>{p.rotateBy(t,t,_)}))}resetRotation(){this.view.constraints.rotationEnabled&&(this.view.rotation=0)}continuousPanLeft(){this._continuousPan([-v,0])}continuousPanRight(){this._continuousPan([v,0])}continuousPanUp(){this._continuousPan([0,v])}continuousPanDown(){this._continuousPan([0,-v])}continuousPanVector({x:t,y:i}){this._continuousPan([t*v,i*v])}stop(){this.pan.stopMomentumNavigation(),this.animationManager?.stop(),this.end(),null!==this._endTimer&&(clearTimeout(this._endTimer),this._endTimer=null,this._set("interacting",!1))}_continuousPan(t){const i=this.view.viewpoint;this.animationManager?.animateContinuous(i,(i=>{p.translateBy(i,i,t),this.view.constraints.constrainByGeometry(i)}))}_startTimer(t){return null!==this._endTimer||(this._endTimer=setTimeout((()=>{this._endTimer=null;const t=performance.now()-(this._lastEventTimestamp??0);t<T?this._endTimer=this._startTimer(t):this._set("interacting",!1)}),t)),this._endTimer}_getDefaultAnchor(){const{size:t,padding:{left:i,right:e,top:o,bottom:n}}=this.view;return g[0]=.5*(t[0]-e+i),g[1]=.5*(t[1]-n+o),g}async _zoomToScale(t,i=this._getDefaultAnchor()){const{view:e}=this,{constraints:o,scale:n,viewpoint:s,size:a,padding:r}=e,c=o.canZoomInTo(t),h=o.canZoomOutTo(t);if(!(t<n&&!c||t>n&&!h))return p.padAndScaleAndRotateBy(y,s,t/n,0,i,a,r),o.constrainByGeometry(y),e.goTo(y,{animate:!0,animationMode:"always",duration:u.getGoToDuration(),pickClosestTarget:!1})}_scaleRotateTranslateViewpoint(t,i,e,o,n){const{view:s}=this,{size:a,padding:r,constraints:c,scale:h,viewpoint:u}=s,m=h*e,l=c.canZoomInTo(m),d=c.canZoomOutTo(m);return(e<1&&!l||e>1&&!d)&&(e=1),p.translateBy(u,u,n),p.padAndScaleAndRotateBy(t,u,e,o,i,a,r),c.constrainByGeometry(t)}};t.__decorate([n.property()],z.prototype,"animationManager",void 0),t.__decorate([n.property({type:Boolean,readOnly:!0})],z.prototype,"interacting",void 0),t.__decorate([n.property()],z.prototype,"pan",void 0),t.__decorate([n.property()],z.prototype,"pinch",void 0),t.__decorate([n.property()],z.prototype,"rotate",void 0),t.__decorate([n.property()],z.prototype,"view",void 0),t.__decorate([n.property()],z.prototype,"zoomBox",void 0),z=t.__decorate([c.subclass("esri.views.2d.navigation.MapViewNavigation")],z);return z}));
