/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../../chunks/tslib.es6","../../../../../core/Evented","../../../../../core/Logger","../../../../../core/reactiveUtils","../../../../../core/accessorSupport/decorators/property","../../../../../core/has","../../../../../core/RandomLCG","../../../../../core/accessorSupport/decorators/subclass","../../../../../geometry/Point","../../../../../geometry/projection","../../../../../geometry/support/aaBoundingRect","../../support/projectionUtils","../../../../interactive/coordinateHelper","../../../../interactive/editGeometry/EditGeometry","../../../../interactive/editGeometry/EditGeometryOperations"],(function(e,t,r,o,i,n,s,a,l,c,h,m,p,d,u,y){"use strict";e.AreaMeasurement3DPathHelper=class extends r.EventedAccessor{constructor(e={}){super(e),this._version=0,this._internalGeometryChange=!1,this._extent=m.empty()}set areaMeasurement(e){this._set("areaMeasurement",e),null!=e&&null!=this.view&&this._initialize(e,this.view)}set view(e){this._set("view",e),null!=e&&null!=this.areaMeasurement&&this._initialize(this.areaMeasurement,e)}get constructed(){return null!=this.areaMeasurement&&null!=this.view}get version(){return this._version}get isEmptyPolygon(){return!this.constructed||0===this._editGeometry.components.length}get isValidPolygon(){return this.constructed&&this.polygonIsClosed}get extent(){if(this.constructed&&this._editGeometry.components.length>0&&this._editGeometry.components[0].vertices.length>0){const e=m.empty(this._extent);return this.forEachVertex((t=>{m.expandPointInPlace(e,t.pos)})),e}return null}get spatialReference(){return this.constructed?this._editGeometry.coordinateHelper.spatialReference:null}_initialize(e,t){this.removeAllHandles(),this.addHandles(i.watch((()=>e.geometry),(()=>{this._updateEditGeometryFromModelGeometry(e,t)}),i.syncAndInitial)),this._makeDirty(!0)}_makeDirty(e=!1){this.notifyChange("polygonIsClosed"),this.notifyChange("isValidPolygon"),this.notifyChange("initialized"),this.notifyChange("extent"),e&&this.notifyChange("numVertices")}_updateEditGeometryFromModelGeometry(e,t){if(this._version++,this._internalGeometryChange)return;this.removeHandles("EditGeometry");let r=e.geometry;if(null!=r){const i=h.tryProjectWithZConversion(r,t.spatialReference);null==i&&p.logFailedGeometryProjectionError(e,r.spatialReference,o.getLogger(this)),r=i}this._editGeometryOperations=null!=r?y.EditGeometryOperations.fromGeometry(r,t.state.viewingMode):new y.EditGeometryOperations(new u.EditGeometry("polygon",d.createCoordinateHelper(!0,!1,t.spatialReference)),t.state.viewingMode),this._makeDirty(!0),this.emit("change"),this.addHandles(this._editGeometry.on("change",(t=>{this._makeDirty(null!=t.addedVertices||null!=t.removedVertices),this._internalGeometryChange=!0,e.geometry=this.numVertices>0?this._editGeometry.geometry:null,this._internalGeometryChange=!1})),"EditGeometry")}get _editGeometry(){return this._editGeometryOperations.data}get vertices(){const e=[];return this.forEachVertex((t=>{e.push(t)})),e}get numVertices(){return this.constructed&&this._editGeometry.components.length>0?this._editGeometry.components[0].vertices.length:0}get polygonIsClosed(){return this._editGeometry.components.length>0&&this._editGeometry.components[0].isClosed()}get firstPoint(){if(this.constructed&&this._editGeometry.components.length>0){const e=this._editGeometry.components[0].getFirstVertex();if(null!=e)return this._editGeometry.coordinateHelper.vectorToPoint(e.pos)}return null}get lastPoint(){if(this.constructed&&this._editGeometry.components.length>0){const e=this._editGeometry.components[0].getLastVertex();if(null!=e)return this._editGeometry.coordinateHelper.vectorToPoint(e.pos)}return null}getVertex(e){if(!this.constructed||0===this._editGeometry.components.length||0===this._editGeometry.components[0].vertices.length)return null;const t=this._editGeometry.components[0].vertices[0];let r=t;do{if(r.index===e)return r;r=r.rightEdge.rightVertex}while(r!==t&&null!=r);return null}getVertexPositionAsPoint(e){return this._editGeometry.coordinateHelper.vectorToPoint(e.pos)}getVertexPositionAsPointFromIndex(e){return this._editGeometry.coordinateHelper.vectorToPoint(this.getVertex(e).pos)}forEachVertex(e){this.constructed&&this._editGeometry.components.length>0&&this._editGeometry.components[0].iterateVertices(e)}forEachVertexPosition(e){const t=this._editGeometry.coordinateHelper;this.forEachVertex(((r,o)=>{t.vectorToPoint(r.pos,g),e(g,o)}))}clear(){null!=this.areaMeasurement&&(this.areaMeasurement.geometry=null)}add(e){if(!this.constructed)return null;if(0===this._editGeometry.components.length){const e=this.view;this._editGeometry.components.push(new u.Component(e.spatialReference,e.state.viewingMode))}const t=this._editGeometryOperations.appendVertex(this._editGeometry.coordinateHelper.pointToVector(e));return this.emit("change"),t}close(){if(!this.constructed||0===this._editGeometry.components.length)return null;const e=this._editGeometryOperations.closeComponent(this._editGeometry.components[0]);return this.emit("change"),e}ensureContains(e,t=""){let r=!1;if(this._editGeometry.components.forEach((t=>{t.iterateVertices((t=>{t===e&&(r=!0)}))})),!r)throw new Error(`vertex doesnt exist ${t}`);return r}setVertexPosition(e,t){if(!this.constructed)return null;const r=this._editGeometryOperations.setVertexPosition(e,this._editGeometry.coordinateHelper.pointToVector(t));return this.emit("change"),r}equals(e){if(this.numVertices!==e.numVertices)return!1;let t=!0;return this.forEachVertexPosition(((r,o)=>{const i=e.getVertexPositionAsPointFromIndex(o);r.equals(i)||(t=!1)})),!!t}},t.__decorate([n.property({value:null})],e.AreaMeasurement3DPathHelper.prototype,"areaMeasurement",null),t.__decorate([n.property({value:null})],e.AreaMeasurement3DPathHelper.prototype,"view",null),t.__decorate([n.property()],e.AreaMeasurement3DPathHelper.prototype,"isEmptyPolygon",null),t.__decorate([n.property()],e.AreaMeasurement3DPathHelper.prototype,"isValidPolygon",null),t.__decorate([n.property()],e.AreaMeasurement3DPathHelper.prototype,"extent",null),t.__decorate([n.property()],e.AreaMeasurement3DPathHelper.prototype,"spatialReference",null),t.__decorate([n.property()],e.AreaMeasurement3DPathHelper.prototype,"numVertices",null),t.__decorate([n.property()],e.AreaMeasurement3DPathHelper.prototype,"polygonIsClosed",null),e.AreaMeasurement3DPathHelper=t.__decorate([l.subclass("esri.views.3d.analysis.AreaMeasurement.support.AreaMeasurementPathHelper")],e.AreaMeasurement3DPathHelper);const g=new c;Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
