/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../chunks/tslib.es6","../../../../geometry","../../../../core/clock","../../../../core/handleUtils","../../../../core/has","../../../../core/maybe","../../../../core/reactiveUtils","../../../../core/accessorSupport/decorators/property","../../../../core/Logger","../../../../core/RandomLCG","../../../../core/accessorSupport/decorators/subclass","../../../../geometry/support/vectorStacks","./lengthDimensionManipulatorUtils","./LengthDimensionSubTool","./settings","../../../interactive/AnalysisToolBase","../../../interactive/keybindings","../../../interactive/ToolIntersector","../../../support/screenUtils","../../../../geometry/Point"],(function(e,t,o,i,n,s,r,a,l,c,u,p,d,h,m,v,y,_,T,D,g){"use strict";var S;!function(e){e.Ready="ready",e.Creating="creating",e.Created="created"}(S||(S={})),e.DimensionTool=class extends y.AnalysisToolBase{constructor(e){super(e),this.automaticManipulatorSelection=!1,this.removeIncompleteOnCancel=!1,this._pointerMoveTimerMs=v.pointerMoveTimeoutMs,this._prevPointerMoveTimeout=null}initialize(){this._intersector=T.newToolIntersector(this.view.state.viewingMode),this._lengthDimensionSubTool=new m.LengthDimensionSubTool({analysis:this.analysis,analysisViewData:this.analysisViewData,manipulators:this.manipulators,parentTool:this,view:this.view}),this.addHandles([n.destroyHandle(this._lengthDimensionSubTool),n.makeHandle((()=>this._clearPointerMoveTimeout())),a.watch((()=>this.state),(e=>{e===S.Created&&this.finishToolCreation()}),a.syncAndInitial),a.when((()=>this.firstGrabbedManipulator),(e=>{this.selectedDimension=e.metadata}),a.syncAndInitial),a.watch((()=>this.selectedDimension),(()=>this._resetPointerMoveTimeout()),a.syncAndInitial)])}get state(){return this.analysis.dimensions.some((e=>"length"===e.type))?null!=this._activeSubTool?S.Creating:S.Created:S.Ready}get updating(){return this._lengthDimensionSubTool.updating}get cursor(){return this.active?"crosshair":null}get selectedDimension(){return this.analysisViewData.selectedDimension}set selectedDimension(e){this.analysisViewData.selectedDimension=e}onInputEvent(e){switch(e.type){case"immediate-click":this._clickHandler(e);break;case"immediate-double-click":this._doubleClickHandler(e);break;case"pointer-move":this._pointerMoveHandler(e);break;case"key-down":if(_.sketchKeys.cancel===e.key){if(null!=this._activeSubTool&&this._activeSubTool.removeStaged())return void e.stopPropagation();this.active||(this.selectedDimension=null)}else _.sketchKeys.delete.includes(e.key)&&this._deleteKeyHandler()}}onActivate(){this._activeSubTool=this._lengthDimensionSubTool}onDeactivate(){null!=this._activeSubTool&&(this._activeSubTool.onDeactivate(),this._activeSubTool=null)}onShow(){this._resetPointerMoveTimeout()}onManipulatorSelectionChanged(){this._lengthDimensionSubTool.onManipulatorSelectionChanged()}onHide(){this.selectedDimension=null}_clickHandler(e){if(this.hasFocusedManipulators)return void e.stopPropagation();if(null==this._activeSubTool)return;const t=this._intersectScreen(e);null!=t&&(this.selectedDimension=this._activeSubTool.onClick({mapPoint:t,pointerType:e.pointerType}),e.stopPropagation())}_doubleClickHandler(e){this.active&&(this.view.activeTool=null,e.stopPropagation())}_pointerMoveHandler(e){if(this._resetPointerMoveTimeout(),null==this._activeSubTool)return;if(this.hasFocusedManipulators)return;const t=this._intersectScreen(e);null!=t&&this._activeSubTool.onPointerMove({mapPoint:t,pointerType:e.pointerType})}_deleteKeyHandler(){null!=this._activeSubTool&&this._activeSubTool.removeStaged(),this._removeSelected()}_intersectScreen(e){const t=D.createScreenPointArrayFromEvent(e);this.view.sceneIntersectionHelper.intersectToolIntersectorScreen(t,this._intersector);const o=this._intersector.results.min,i=d.sv3d.get();return o.getIntersectionPoint(i)?this.view.renderCoordsHelper.fromRenderCoords(i,new g({spatialReference:this.view.spatialReference})):null}_removeSelected(){null!=this.selectedDimension&&(this.analysis.dimensions.remove(this.selectedDimension),this.selectedDimension=null)}_clearPointerMoveTimeout(){this._prevPointerMoveTimeout=r.removeMaybe(this._prevPointerMoveTimeout)}_resetPointerMoveTimeout(){this._clearPointerMoveTimeout(),this.manipulators.forEach((e=>e.manipulator.state|=h.DidPointerMoveRecentlyFlag)),this._prevPointerMoveTimeout=i.clock.setTimeout((()=>{this.manipulators.forEach((e=>e.manipulator.state&=~h.DidPointerMoveRecentlyFlag))}),this._pointerMoveTimerMs)}get testInfo(){}},t.__decorate([l.property({constructOnly:!0})],e.DimensionTool.prototype,"view",void 0),t.__decorate([l.property({constructOnly:!0})],e.DimensionTool.prototype,"analysis",void 0),t.__decorate([l.property({readOnly:!0})],e.DimensionTool.prototype,"state",null),t.__decorate([l.property({readOnly:!0})],e.DimensionTool.prototype,"updating",null),t.__decorate([l.property({readOnly:!0})],e.DimensionTool.prototype,"cursor",null),t.__decorate([l.property({constructOnly:!0})],e.DimensionTool.prototype,"analysisViewData",void 0),t.__decorate([l.property()],e.DimensionTool.prototype,"selectedDimension",null),t.__decorate([l.property()],e.DimensionTool.prototype,"automaticManipulatorSelection",void 0),t.__decorate([l.property()],e.DimensionTool.prototype,"_activeSubTool",void 0),t.__decorate([l.property()],e.DimensionTool.prototype,"_lengthDimensionSubTool",void 0),e.DimensionTool=t.__decorate([p.subclass("esri.views.3d.analysis.Dimension.DimensionTool")],e.DimensionTool),Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
