/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../chunks/tslib.es6","../../../../Color","../../../../geometry","../../../../analysis/dimensionUtils","../../../../analysis/LengthDimension","../../../../core/Accessor","../../../../core/Handles","../../../../core/handleUtils","../../../../core/has","../../../../core/lang","../../../../core/maybe","../../../../core/memoize","../../../../core/promiseUtils","../../../../core/reactiveUtils","../../../../core/accessorSupport/decorators/property","../../../../core/Logger","../../../../core/accessorSupport/decorators/subclass","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../core/support/UpdatingHandles","../../../../layers/graphics/hydratedFeatures","./lengthDimensionConstraintUtils","./lengthDimensionManipulatorUtils","./lengthDimensionUtils","./settings","../images/Factory","../../interactive/SnappingVisualizer3D","../../interactive/visualElements/LineVisualElement","../../interactive/visualElements/VerticesVisualElement","../../webgl-engine/lib/Material","../../webgl-engine/materials/ImageMaterial","../../webgl-engine/materials/lineStippleUtils","../../webgl-engine/materials/RibbonLineMaterial","../../../interactive/coordinateHelper","../../../interactive/editGeometry/EditGeometry","../../../interactive/editGeometry/EditGeometryOperations","../../../interactive/snapping/SnappingContext","../../../interactive/snapping/SnappingDragPipelineStep","../../../interactive/snapping/SnappingManagerPool","../../../interactive/snapping/SnappingOperation","../../../interactive/snapping/snappingUtils","../../../../geometry/Point"],(function(t,e,n,i,a,o,s,r,l,p,u,d,c,h,g,m,_,M,f,y,v,S,b,C,w,D,T,O,P,H,L,G,x,z,V,I,R,A,U,E,k,F){"use strict";t.LengthDimensionSubTool=class extends s{constructor(t){super(t),this._stagedDimension=null,this._computationManipulators=new Map,this._computationHandles=new r,this._orientationManipulatorTexture=null,this._updatingHandles=new y.UpdatingHandles,this._getSnappingContext=c.memoize((t=>new R.SnappingContext({elevationInfo:{mode:"absolute-height",offset:0},pointer:t,editGeometryOperations:new I.EditGeometryOperations(new V.EditGeometry("point",z.createCoordinateHelper(!0,!1,this.view.spatialReference)),this.view.state.viewingMode),visualizer:new T.SnappingVisualizer3D})));const{view:e}=t;this._snappingManagerResult=U.acquire(e),this.addHandles(this._snappingManagerResult),this._unfocusedOffsetManipulatorMaterial=this._createOffsetManipulatorMaterial(),this._focusedOffsetManipulatorMaterial=this._createOffsetManipulatorMaterial(),this._thinOffsetManipulatorMaterial=this._createOffsetManipulatorMaterial(),this._thinOffsetManipulatorMaterial.setParameters({stipplePattern:G.createStipplePatternSimple(2)}),this._constraintSnappingIndicator=new O.LineVisualElement({view:e,attached:!0,width:1,renderOccluded:H.RenderOccludedFlag.OccludeAndTransparent,stipplePattern:G.createStipplePatternSimple(5),isDecoration:!0});const i=n.toUnitRGBA(w.disabledPointColor);this._stagedStartIndicator=new P.VerticesVisualElement({view:e,attached:!1,elevationInfo:{mode:"absolute-height",offset:0},spatialReference:t.view.renderCoordsHelper.spatialReference,color:i,size:2*w.pointRadius,outlineSize:0,renderOccluded:H.RenderOccludedFlag.OccludeAndTransparent,isDecoration:!0})}initialize(){const{view:t}=this;this._snappingOperation=new E.SnappingOperation({view:t});const e=!t._stage?.renderView.renderingContext.driverTest.svgPremultipliesAlpha.result;this._orientationManipulatorMaterial=new L.ImageMaterial({writeDepth:!1,renderOccluded:H.RenderOccludedFlag.Opaque,isDecoration:!0}),this.addHandles(g.watch((()=>({accentColor:w.getTransparentAccentColor(t.effectiveTheme),contrastColor:w.getContrastColor(t.effectiveTheme)})),(({accentColor:i,contrastColor:a})=>{const o=this._orientationManipulatorTexture,s=D.getRotateHeadingTexture(t.textures,{accentColor:i,contrastColor:a,preMultiplyAlpha:e});this._orientationManipulatorMaterial.setParameters({textureId:s.texture.id}),this._orientationManipulatorTexture=s,o?.release();const r=n.toUnitRGBA(i);this._unfocusedOffsetManipulatorMaterial.setParameters({color:r}),this._focusedOffsetManipulatorMaterial.setParameters({color:r}),this._thinOffsetManipulatorMaterial.setParameters({color:r}),this._constraintSnappingIndicator.color=r}),g.initial));const i=g.mapCollection((()=>this.analysisViewData.computations),(({computation:t})=>this._createManipulators(t)));this.addHandles(l.destroyHandle(i)),this.addHandles([g.watch((()=>({stagedPoint:this._snappingOperation.stagedPoint,stagedComputation:this._stagedComputation})),(({stagedPoint:t,stagedComputation:e})=>{if(null==e||null==t)return;const n=v.clonePoint(t,new F);this._applyPointUpdate(e,{endPoint:n})}),g.sync),g.watch((()=>({stagedDimension:this._stagedDimension,selectedComputation:this.analysisViewData.selectedComputation,firstGrabbedManipulator:this.firstGrabbedManipulator})),((t,e)=>{const{stagedDimension:n,selectedComputation:i,firstGrabbedManipulator:a}=t;if(n===e?.stagedDimension&&a===e?.firstGrabbedManipulator){for(const o of[i,e?.selectedComputation])if(null!=o){const e=this._computationManipulators.get(o);null!=e&&this._updateManipulators(o,e,t)}}else for(const[o,s]of this._computationManipulators)this._updateManipulators(o,s,t)}),g.syncAndInitial),g.watch((()=>this.analysis.style.lineSize),(t=>{this._updateManipulatorStyle(t)}),g.initial),g.watch((()=>this.view.state.camera),(()=>{null!=this._stagedComputation&&this._updateStagedDimensionOffset(this._stagedComputation)})),g.watch((()=>{const t=this._stagedComputation;if(!t)return null;const e=t.elevationAlignedStartPoint,n=f.create();return null!=e&&this.view.renderCoordsHelper.toRenderCoords(e,n)?n:null}),(t=>{null!=t?(this._stagedStartIndicator.vertices=[t],this._stagedStartIndicator.attached=!0):this._stagedStartIndicator.attached=!1}))]),this.addHandles(this._constraintHandles),this.addHandles(this._snappingIndicatorHandles),k.setupSnappingToggleHandles(this,(()=>{const t=this._activeComputation,e=this._stagedComputation;if(null==t||null!=e){const t=this.view.inputManager.latestPointerType??"mouse",e=this._getSnappingContext(t);this._updatingHandles.addPromise(h.ignoreAbortErrors(this._snappingOperation.snapAgainNearPreviousMapPoint(this._snappingManager,e)))}if(null!=t){const{start:e,end:n}=this._computationManipulators.get(t);if(e.grabbing||n.grabbing){const n=e.grabbing?"start":"end",i=this._computeConstraint(t);S.reapplyConstraint(t,n,{constraint:i,view:this.view})}}}))}destroy(){this._snappingOperation=d.destroyMaybe(this._snappingOperation),this._computationHandles.destroy(),this._constraintSnappingIndicator.destroy(),this._stagedStartIndicator.destroy(),this._orientationManipulatorTexture?.release()}get updating(){return this._updatingHandles.updating||this._snappingManager.updating}get firstGrabbedManipulator(){return this.parentTool.firstGrabbedManipulator}get hasGrabbedManipulators(){return this.parentTool.hasGrabbedManipulators}get snappingOptions(){return this._snappingManager.options}get _snappingManager(){return this._snappingManagerResult.snappingManager}get _activeComputation(){if(null!=this._stagedComputation)return this._stagedComputation;const{selectedComputation:t}=this.analysisViewData;return this.hasGrabbedManipulators&&null!=t?t:null}get _stagedComputation(){const t=this._stagedDimension,e=this.analysisViewData.computations.at(-1)?.computation;return null==t||null==e||e.dimension!==t?null:e}get _constraintHandles(){return[g.when((()=>this.analysisViewData.selectedComputation),(t=>{t.previousConstraint=this._computeConstraint(t)}),{...g.syncAndInitial,equals:u.equals}),g.watch((()=>{const t=this._activeComputation;if(null==t)return null;const{measureType:e,orientation:n}=t.dimension;return{measureType:e,orientation:n,computation:t}}),((t,e)=>{if(null!=t&&null==e){const{measureType:e,orientation:n,computation:i}=t;switch(i.previousConstraint){case S.LengthDimensionConstraint.Horizontal:i.preConstraintProperties={measureType:a.LengthDimensionMeasureType.Horizontal,orientation:0};break;case S.LengthDimensionConstraint.Vertical:i.preConstraintProperties={measureType:a.LengthDimensionMeasureType.Vertical,orientation:0};break;case S.LengthDimensionConstraint.Direct:i.preConstraintProperties={measureType:a.LengthDimensionMeasureType.Direct,orientation:n};break;default:i.preConstraintProperties={measureType:e,orientation:n}}}null==t&&null!=e&&(e.computation.preConstraintProperties=null)}),g.sync)]}get _snappingIndicatorHandles(){const t="snapping-indicator-event-handles";return[g.watch((()=>({stagedComputation:this._stagedComputation,activeComputation:this._activeComputation})),(({stagedComputation:e,activeComputation:n})=>{const i=this._constraintSnappingIndicator;if(this.removeHandles(t),null!=n)if(n===e)i.attached=!0;else{const{start:e,end:a}=this._computationManipulators.get(n),o=()=>{i.attached=e.grabbing||a.grabbing};o(),this.addHandles([e.events.on("grab-changed",o),a.events.on("grab-changed",o)],t)}else i.attached=!1})),g.watch((()=>{const t=this._activeComputation;return null!=t?{geometry:t.geometry,constraint:t.previousConstraint}:{}}),(({geometry:t,constraint:e})=>{const n=this._constraintSnappingIndicator;null!=t&&null!=e&&e!==S.LengthDimensionConstraint.Direct?(n.visible=!0,n.setGeometryFromSegment(t.directSegment)):n.visible=!1}))]}removeStaged(){return null!=this._stagedDimension&&(this.analysis.dimensions.remove(this._stagedDimension),this._stagedDimension=null,!0)}onDeactivate(){this.removeStaged(),this._resetSnappingState()}onClick(t){const{_stagedDimension:e}=this;if(null==e){const e=this._onUnstagedClick(t);return this.analysis.dimensions.add(e),null}return this._onStagedClick(t),e}onPointerMove({mapPoint:t,pointerType:e}){if("touch"===e)return;const n=this._getSnappingContext(e);this._updatingHandles.addPromise(h.ignoreAbortErrors(this._snappingOperation.snap({point:t},this._snappingManager,n)))}onManipulatorSelectionChanged(){if(null!=this.analysisViewData.selectedComputation){this._computationManipulators.get(this.analysisViewData.selectedComputation).offset.selected||(this.analysisViewData.selectedDimension=null)}}_onUnstagedClick({mapPoint:t,pointerType:e}){let n=t;if("mouse"===e){const i=this._getSnappingContext(e);n=this._snappingManager.update({point:t,context:i})}const i=new o({startPoint:v.clonePoint(n,new F),endPoint:null,measureType:a.LengthDimensionMeasureType.Horizontal});return this._stagedDimension=i,this._resetSnappingState(),i}_onStagedClick({mapPoint:t,pointerType:e}){const n=this._stagedComputation;if(null==n)return;let i=t;if("mouse"===e){const n=this._getSnappingContext(e);i=this._snappingManager.update({point:t,context:n})}const a=v.clonePoint(i,new F);this._applyPointUpdate(n,{endPoint:a}),this._stagedDimension=null,this._resetSnappingState()}_resetSnappingState(){this._snappingManager.doneSnapping(),this._snappingOperation.abort(),this._snappingOperation.stagedPoint=null}_createManipulators(t){const e=this._setupPointManipulator(t,{isStart:!0}),n=this._setupPointManipulator(t,{isStart:!1}),i=this._setupOffsetManipulator(t),o=this._setupHeadingManipulator(t),s=this._setupRotationManipulator(t),r=this._setupMeasureTypeManipulator(t,a.LengthDimensionMeasureType.Direct),l=this._setupMeasureTypeManipulator(t,a.LengthDimensionMeasureType.Horizontal),p=this._setupMeasureTypeManipulator(t,a.LengthDimensionMeasureType.Vertical),u=new b.LengthDimensionManipulators({start:e,end:n,offset:i,heading:o,rotation:s,direct:r,horizontal:l,vertical:p});return this._setupComputationToManipulatorsSync(t,u),this._computationManipulators.set(t,u),this.manipulators.addMany(u.values()),{manipulators:u,remove:()=>{this._computationHandles.remove(t),this._computationManipulators.delete(t);for(const t of u.values())this.manipulators.remove(t)}}}_setupComputationToManipulatorsSync(t,e){this._computationHandles.add([g.watch((()=>t.geometry),(()=>this._updateManipulators(t,e)),{...g.syncAndInitial,equals:u.equals})],t)}_setupPointManipulator(t,e){const{view:n}=this,{dimension:i}=t,a=new b.LengthDimensionPointManipulator(n,{metadata:i}),o=b.pointManipulatorHandles(a,{isStart:e.isStart,createSnappingPipelineStep:t=>A.createSnapDragEventPipelineStep({snappingContext:this._getSnappingContext(t),snappingManager:this._snappingManager,updatingHandles:this._updatingHandles}),dimension:i,onUpdate:e=>this._applyPointUpdate(t,e),view:n});return this._computationHandles.add(o,t),a}_setupOffsetManipulator(t){const{view:e}=this,n=b.createOffsetManipulator(e,{lineSizePt:this.analysis.style.lineSize,unfocusedMaterial:this._unfocusedOffsetManipulatorMaterial,focusedMaterial:this._focusedOffsetManipulatorMaterial,metadata:t.dimension}),i=b.offsetManipulatorHandles(n,{computation:t,view:e});return this._computationHandles.add(i,t),n}_setupHeadingManipulator(t){const{view:e}=this,n=new b.LineOfSightOrientationManipulator(e,{lineSizePt:this.analysis.style.lineSize,material:this._orientationManipulatorMaterial,metadata:t.dimension}),i=b.headingManipulatorHandles(n,{computation:t,view:e});return this._computationHandles.add(i,t),n}_setupRotationManipulator(t){const{view:e}=this,n=new b.LineOfSightOrientationManipulator(e,{lineSizePt:this.analysis.style.lineSize,material:this._orientationManipulatorMaterial,metadata:t.dimension}),i=b.rotationManipulatorHandles(n,{computation:t,view:e});return this._computationHandles.add(i,t),n}_setupMeasureTypeManipulator(t,e){const{view:n}=this,i=b.createMeasureTypeManipulator(n,{lineSizePt:this.analysis.style.lineSize,unfocusedMaterial:this._unfocusedOffsetManipulatorMaterial,focusedMaterial:this._focusedOffsetManipulatorMaterial,thinOffsetManipulatorMaterial:this._thinOffsetManipulatorMaterial,metadata:t.dimension}),a=b.measureTypeManipulatorHandles(i,{computation:t,manipulatorMeasureType:e,view:n});return this._computationHandles.add(a,t),i}_updateManipulators(t,e,n={stagedDimension:this._stagedDimension,selectedComputation:this.analysisViewData.selectedComputation,firstGrabbedManipulator:this.firstGrabbedManipulator}){const{stagedDimension:i,selectedComputation:o,firstGrabbedManipulator:s}=n,{start:r,end:l,offset:p,heading:u,rotation:d}=e,c=o===t,h=C.isValidComputation(t),{dimension:g}=t;for(const a of e.values()){const t=h&&null==i&&(null==s||a===s);a===p?(a.available=t,a.selected=c):a.available=t&&c}if(!h)return;null!=this._computeConstraint(t)?e.forEachMeasureTypeManipulator((t=>t.available=!1)):e.manipulatorForMeasureType(g.measureType).available=!1;for(const M of[u,d])g.measureType===a.LengthDimensionMeasureType.Direct&&0!==g.offset||(M.available=!1);C.arePointsVerticallyAligned(t)?d.available=!1:u.available=!1;const{geometry:m}=t;r.renderLocation=m.directSegment.startRenderSpace,l.renderLocation=m.directSegment.endRenderSpace;const{renderCoordsHelper:_}=this.view;b.updateOffsetManipulatorTransform(p,m,_),u.available&&b.updateHeadingManipulatorTransform(u,t,_),d.available&&b.updateRotationManipulatorTransform(d,t,_),e.forEachMeasureTypeManipulator(((e,n)=>{e.available&&b.updateMeasureTypeManipulatorTransform(e,t,n,_)}))}_updateManipulatorStyle(t){const e=b.unfocusedOffsetWidth(t),n=b.focusedOffsetWidth(t),i={lineSizePt:t,material:this._orientationManipulatorMaterial};for(const{offset:a,heading:o,rotation:s}of this._computationManipulators.values())a.radius=n/2,o.update(i),s.update(i);this._unfocusedOffsetManipulatorMaterial.setParameters({width:e}),this._focusedOffsetManipulatorMaterial.setParameters({width:n})}_applyPointUpdate(t,e){const{view:n}=this,i=C.computationToGeometryDependencies(t);"startPoint"in e&&(i.elevationAlignedStartPoint=e.startPoint),"endPoint"in e&&(i.elevationAlignedEndPoint=e.endPoint);const a=C.computeGeometryFromDimension(i,n.renderCoordsHelper);if(null==a)return;const o=this._computeConstraint({...i,geometry:a});S.applyConstraint(t,e,{...i,constraint:o,unconstrainedGeometry:a,view:n}),t===this._stagedComputation&&this._updateStagedDimensionOffset(t)}_updateStagedDimensionOffset(t){if(null==t.geometry)return;t.geometry.directSegment.eval(.5,q);const{state:e,renderCoordsHelper:n}=this.view,i=e.camera.computeScreenPixelSizeAt(q);t.dimension.offset=w.initialOffsetPx*i*n.unitInMeters}_computeConstraint(t){return S.computeConstraint(S.constraintDependencies(t,this._snappingManager.options),this.view)}_createOffsetManipulatorMaterial(){return new x.RibbonLineMaterial({width:1,renderOccluded:H.RenderOccludedFlag.OccludeAndTransparent,writeDepth:!1,hasPolygonOffset:!0,isDecoration:!0})}get testInfo(){}},e.__decorate([m.property({constructOnly:!0})],t.LengthDimensionSubTool.prototype,"analysis",void 0),e.__decorate([m.property({constructOnly:!0})],t.LengthDimensionSubTool.prototype,"analysisViewData",void 0),e.__decorate([m.property({constructOnly:!0})],t.LengthDimensionSubTool.prototype,"manipulators",void 0),e.__decorate([m.property({constructOnly:!0})],t.LengthDimensionSubTool.prototype,"parentTool",void 0),e.__decorate([m.property({constructOnly:!0,nonNullable:!0})],t.LengthDimensionSubTool.prototype,"view",void 0),e.__decorate([m.property({readOnly:!0})],t.LengthDimensionSubTool.prototype,"updating",null),e.__decorate([m.property()],t.LengthDimensionSubTool.prototype,"firstGrabbedManipulator",null),e.__decorate([m.property()],t.LengthDimensionSubTool.prototype,"hasGrabbedManipulators",null),e.__decorate([m.property()],t.LengthDimensionSubTool.prototype,"snappingOptions",null),e.__decorate([m.property()],t.LengthDimensionSubTool.prototype,"_stagedDimension",void 0),e.__decorate([m.property()],t.LengthDimensionSubTool.prototype,"_activeComputation",null),e.__decorate([m.property()],t.LengthDimensionSubTool.prototype,"_stagedComputation",null),t.LengthDimensionSubTool=e.__decorate([M.subclass("esri.views.3d.analysis.Dimension.LengthDimensionSubTool")],t.LengthDimensionSubTool);const q=f.create();Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
