/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../Color","../../../../geometry","../../../../analysis/dimensionUtils","../../../../core/Cyclical","../../../../core/mathUtils","../../../../core/reactiveUtils","../../../../core/screenUtils","../../../../core/libs/gl-matrix-2/math/mat4","../../../../core/libs/gl-matrix-2/factories/mat4f64","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../core/libs/gl-matrix-2/factories/vec4f64","../../../../geometry/support/plane","../../../../geometry/support/vectorStacks","../../../../layers/graphics/hydratedFeatures","./lengthDimensionUtils","./settings","../../interactive/Manipulator3D","../../interactive/manipulatorUtils","../../interactive/RenderObject","../../interactive/editingTools/dragEventPipeline3D","../../interactive/visualElements/support/Segment","../../support/engineContent/marker","../../webgl-engine/lib/Attribute","../../webgl-engine/lib/Geometry","../../webgl-engine/lib/GeometryUtil","../../webgl-engine/lib/Material","../../webgl-engine/lib/VertexAttribute","../../webgl-engine/materials/ImageMaterial","../../webgl-engine/materials/RibbonLineMaterial","../../../interactive/dragEventPipeline","../../../interactive/interfaces","../../../../geometry/Point"],(function(e,t,n,a,r,i,o,s,l,c,d,u,p,m,g,f,h,M,y,S,v,T,b,P,w,D,x,O,R,F,C,H,A,E){"use strict";class L{constructor(e){this.start=e.start,this.end=e.end,this.offset=e.offset,this.heading=e.heading,this.rotation=e.rotation,this.direct=e.direct,this.horizontal=e.horizontal,this.vertical=e.vertical}manipulatorName(e){return Object.keys(this).find((t=>this.hasOwnProperty(t)&&e===this[t]))}values(){return[this.start,this.end,this.offset,this.heading,this.rotation,this.direct,this.horizontal,this.vertical]}forEachMeasureTypeManipulator(e){for(const t of a.lengthDimensionMeasureType)e(this.manipulatorForMeasureType(t),t)}manipulatorForMeasureType(e){switch(e){case a.LengthDimensionMeasureType.Direct:return this.direct;case a.LengthDimensionMeasureType.Horizontal:return this.horizontal;case a.LengthDimensionMeasureType.Vertical:return this.vertical}}}class G extends y.Manipulator3D{constructor(e,n){const a=S.createManipulatorMaterial(t.toUnitRGBA(M.getTransparentAccentColor(e.effectiveTheme))),r=[new v.RenderObject(x.createSphereGeometry(a,1,32,32),ue)];super({view:e,renderObjects:r,metadata:n.metadata,available:!1,grabCursor:"crosshair",radius:M.pointRadius,collisionPriority:1}),this._themeHandle=o.watch((()=>({color:t.toUnitRGBA(M.getTransparentAccentColor(e.effectiveTheme))})),(e=>a.setParameters(e)))}destroy(){this._themeHandle.remove(),super.destroy()}}function U(e,t){const n=[u.fromValues(-.5,0,0),u.fromValues(.5,0,0)],a=x.createPolylineGeometry(t.unfocusedMaterial,n.map((e=>d.scale(u.create(),e,M.lengthFraction)))),r=a.instantiate({material:t.focusedMaterial});return new y.Manipulator3D({view:e,renderObjects:[new v.RenderObject(a,A.ManipulatorStateFlags.Unfocused|A.ManipulatorStateFlags.Selected|ue),new v.RenderObject(r,A.ManipulatorStateFlags.Focused|ue)],collisionType:{type:"line",paths:[n]},radius:ce(t.lineSizePt)/2,metadata:t.metadata,available:!1,...S.worldScaledManipulatorSettings})}class j extends y.Manipulator3D{constructor(e,{lineSizePt:n,material:a,metadata:r}){super({view:e,autoScaleRenderObjects:!1,collisionPriority:1,metadata:r}),this._options={calloutColor:p.create(),lineSizePt:n,material:a},this._themeHandle=o.watch((()=>t.toUnitRGBA(M.getTransparentAccentColor(e.effectiveTheme))),(e=>{this._options.calloutColor=e,de(this,z({...this._options,metadata:this.metadata}))}),o.initial)}update({lineSizePt:e,material:t}){this._options.lineSizePt=e,this._options.material=t,de(this,z({...this._options,metadata:this.metadata}))}destroy(){this._themeHandle.remove(),super.destroy()}}function z({calloutColor:e,lineSizePt:t,material:n,metadata:a}){return{calloutLength:.25*P.markerSizePerLineWidth*M.markerLineSizeFraction*s.pt2px(t)+M.orientationCalloutOffsetPx,calloutColor:e,calloutWidth:M.orientationCalloutWidth,customStateMask:ue,discScale:M.orientationDiscScale,focusMultiplier:M.orientationFocusMultiplier,material:n,metadata:a}}function V(e,t){const n=[u.fromValues(-.5,0,0),u.fromValues(.5,0,0)],a=x.createPolylineGeometry(t.thinOffsetManipulatorMaterial,n),r=x.createPolylineGeometry(t.unfocusedMaterial,n.map((e=>d.scale(u.create(),e,M.lengthFraction)))),i=r.instantiate({material:t.focusedMaterial});return new y.Manipulator3D({view:e,renderObjects:[new v.RenderObject(r,A.ManipulatorStateFlags.Unfocused|ue),new v.RenderObject(i,A.ManipulatorStateFlags.Focused|ue),new v.RenderObject(a,ue)],collisionType:{type:"line",paths:[n]},radius:ce(t.lineSizePt)/2,available:!1,metadata:t.metadata,...S.worldScaledManipulatorSettings})}function W(e,{isStart:t,createSnappingPipelineStep:n,dimension:a,onUpdate:r,view:i}){const o=t?"startPoint":"endPoint",s=H.createManipulatorDragEventPipeline(e,((e,t,s,l)=>{const c=T.hideManipulatorWhileDragging(e),{snappingStep:d,cancelSnapping:u}=n(l);s=s.next(c).next(H.resetProperties(a,[o,"measureType","orientation"])).next(u),t.next(c).next(T.screenToMap3D(i)).next(...d).next((e=>{const t=f.clonePoint(e.mapEnd,new E);r("startPoint"===o?{startPoint:t}:{endPoint:t})}))}));return[s]}function _(e,{computation:t,view:n}){return[H.createManipulatorDragEventPipeline(e,((e,a,r)=>{if(!h.isValidComputation(t)||!e.selected)return;const{geometry:i,dimension:o}=t,s=T.hideManipulatorWhileDragging(e);a.next(s).next(J(n,o,i.dimensionSegment,i.primaryOffsetAxis)),r.next(s).next(H.resetProperties(o,["offset"]))}))]}function k(e,{computation:t,view:n}){return[H.createManipulatorDragEventPipeline(e,((e,a,r)=>{B({cancel:r,computation:t,settingHeading:!0,steps:a,view:n})}))]}function I(e,{computation:t,view:n}){return[H.createManipulatorDragEventPipeline(e,((e,a,r)=>{B({cancel:r,computation:t,settingHeading:!1,steps:a,view:n})})),e.events.on("immediate-click",(e=>{N(e,t,n)}))]}function N(e,t,n){const{dimension:a,geometry:i}=t;if(90===a.orientation||270===a.orientation)return a.orientation=0,void e.stopPropagation();if(null==i)return;const{renderCoordsHelper:o}=n,s=h.computeGeometryFromDimension({...h.computationToGeometryDependencies(t),orientation:90},o),l=h.computeGeometryFromDimension({...h.computationToGeometryDependencies(t),orientation:270},o);if(null==s||null==l)return;const c=h.headingFromGeometry(s,o),d=h.headingFromGeometry(l,o),u=K(i,n),p=r.cyclicalDegrees.shortestSignedDiff(u,c),m=r.cyclicalDegrees.shortestSignedDiff(u,d);a.orientation=Math.abs(p)<Math.abs(m)?90:270,e.stopPropagation()}function B(e){const{cancel:t,computation:n,settingHeading:a,steps:r,view:o}=e;if(!h.isValidComputation(n))return;const{renderCoordsHelper:s}=o,{dimension:l,geometry:c}=n,p=u.create(),f=ae(u.create(),c,c.directSegment,s),M=re(g.sv3d.get(),{forHeading:a,geometry:c,renderCoordsHelper:s}),y=m.fromPositionAndNormal(f,M,m.create()),v=a?l.orientation??h.headingFromGeometry(c,o.renderCoordsHelper):l.orientation??0;r.next(T.screenToRenderPlane(o,y)).next((e=>{"start"===e.action&&d.copy(p,e.renderStart);const t=m.getNormal(y),n=S.calculateInputRotationTransform(p,e.renderEnd,f,t);let r=v-i.rad2deg(n);a||(r=Z(r)),l.orientation=r})),t.next(H.resetProperties(l,["orientation"]))}function Z(e){const t=r.cyclicalDegrees.normalize(e)%90;return t<M.orientationSnapThresholdDegrees?e-t:90-t<M.orientationSnapThresholdDegrees?e+(90-t):e}function q(e,{computation:t,manipulatorMeasureType:n,view:r}){let i=a.LengthDimensionMeasureType.Direct,o=0,s=0;return[e.events.on("grab-changed",(a=>{if("start"!==a.action||!h.isValidComputation(t))return;const{dimension:l,geometry:c}=t;i=l.measureType,o=l.offset,s=l.orientation;const u=d.copy(g.sv3d.get(),e.renderLocation);l.measureType=n,l.offset=h.computeOffsetForPoint(u,n,c,r.renderCoordsHelper),l.orientation=0})),H.createManipulatorDragEventPipeline(e,((e,a,l)=>{if(!h.isValidComputation(t))return;const{geometry:c,dimension:d}=t,{renderCoordsHelper:u}=r,p=h.computeSegmentForMeasureType(fe,n,t,u),m=h.computeOffsetAxis(g.sv3d.get(),{measureType:n,directSegment:c.directSegment,renderCoordsHelper:u}),f=T.hideManipulatorWhileDragging(e);a.next(f).next(J(r,d,p,m)),l.next(f).next((e=>(d.measureType=i,d.offset=o,d.orientation=s,e)))}))]}function J(e,t,n,a){const r=d.subtract(g.sv3d.get(),n.endRenderSpace,n.startRenderSpace);d.cross(r,r,a);const i=m.fromPositionAndNormal(n.startRenderSpace,r,m.create()),o=m.fromPositionAndNormal(n.startRenderSpace,a,m.create()),s=t.offset;let l,c=0;const u=new H.EventPipeline;return u.next(T.screenToRenderPlane(e,i)).next((n=>{"start"===n.action&&(c=m.signedDistance(o,n.renderStart));const a=(m.signedDistance(o,n.renderEnd)-c)*e.renderCoordsHelper.unitInMeters;t.offset=s+a,l=n})),e=>(u.execute(e),l)}function K(e,t){const{directSegment:n}=e,{renderCoordsHelper:a}=t,r=h.directUp(g.sv3d.get(),e,a),i=h.directStartToEnd(g.sv3d.get(),e),o=d.cross(g.sv3d.get(),i,r),{viewForward:s}=t.state.camera;d.dot(o,s)>0&&d.scale(o,o,-1);const l=n.eval(.5,g.sv3d.get());return a.headingAtPosition(l,o)}function Q(e,t,n){const{dimensionSegment:a,primaryOffsetAxis:r}=t,i=h.dimensionStartToEnd(pe,t),o=d.exactEquals(i,u.ZEROS)?l.identity(ge):S.calculateTranslateRotateFromBases(i,r,u.ZEROS,ge),s=Math.max(d.length(i),M.minLengthMeters/n.unitInMeters);l.scale(o,o,d.set(pe,s,s,s)),e.modelTransform=o,e.renderLocation=a.eval(.5,pe)}function X(e,t,n){$(e,t,n,{forHeading:!0})}function Y(e,t,n){$(e,t,n,{forHeading:!1})}function $(e,t,n,{forHeading:a}){const{dimension:r,geometry:i}=t,{primaryOffsetAxis:o}=i,s=d.scale(ee,o,r.offset>=0?1:-1),l=re(te,{forHeading:a,geometry:i,renderCoordsHelper:n});d.cross(l,l,s);const c=S.calculateTranslateRotateFromBases(s,l,u.ZEROS,ge);e.modelTransform=c,e.renderLocation=ae(pe,i,i.dimensionSegment,n)}const ee=u.create(),te=u.create();function ne(e,t,n,a){const{geometry:r}=t,i=h.computeSegmentForMeasureType(fe,n,t,a),o=h.computeOffsetAxis(pe,{measureType:n,directSegment:r.directSegment,renderCoordsHelper:a}),s=d.sub(me,i.endRenderSpace,i.startRenderSpace),c=S.calculateTranslateRotateFromBases(s,o,u.ZEROS,ge),p=d.length(s);l.scale(c,c,d.set(me,p,p,p)),e.modelTransform=c,e.renderLocation=i.eval(.5,me)}function ae(e,t,n,a){const{startRenderSpace:r,endRenderSpace:i}=n,o=ie(t,a)?r:i;return d.copy(e,o)}function re(e,{forHeading:t,geometry:n,renderCoordsHelper:a}){return t?h.directUp(e,n,a):h.dimensionStartToEnd(e,n,{invert:!0})}function ie(e,t){const n=h.directStartToEnd(oe,e),a=h.directUp(se,e,t);return d.dot(n,a)>0}const oe=u.create(),se=u.create();function le(e){return s.pt2px(e)+M.linePaddingPx}function ce(e){return s.pt2px(e)+M.focusedLinePaddingPx}function de(e,t){const n=t.material??new F.ImageMaterial({writeDepth:!1,textureId:t.texture?.id,renderOccluded:O.RenderOccludedFlag.Opaque,isDecoration:!0}),a=t.focusMultiplier??S.rotateManipulatorDefaults.focusMultiplier,r=t.calloutLength??S.rotateManipulatorDefaults.calloutLength,i=S.rotateManipulatorDefaults.discRadius*(t.discScale??1),o=i*a,s=(e,t)=>{const n=[0,1,2,2,3,0];return new D.Geometry(t,[[R.VertexAttribute.POSITION,new w.Attribute([r-e,-e,0,r+e,-e,0,r+e,e,0,r-e,e,0],n,3,!0)],[R.VertexAttribute.UV0,new w.Attribute([0,0,1,0,1,1,0,1],n,2,!0)]])},l=t.calloutWidth??S.rotateManipulatorDefaults.calloutWidth,c=new C.RibbonLineMaterial({width:l,color:t.calloutColor,renderOccluded:O.RenderOccludedFlag.OccludeAndTransparent,isDecoration:!0}),d=x.createPolylineGeometry(c,[[0,0,0],[r-i,0,0]]),u=x.createPolylineGeometry(c,[[0,0,0],[r-o,0,0]]),p=t.customStateMask??A.ManipulatorStateCustomFlags.None;e.collisionType={type:"disc",direction:[0,0,1],offset:[r,0,0]},e.focusMultiplier=a,e.metadata=t.metadata,e.radius=i,e.renderObjects=[new v.RenderObject(s(i,n),A.ManipulatorStateFlags.Unfocused|p),new v.RenderObject(d,A.ManipulatorStateFlags.Unfocused|p),new v.RenderObject(s(o,n),A.ManipulatorStateFlags.Focused|p),new v.RenderObject(u,A.ManipulatorStateFlags.Focused|p)]}const ue=A.ManipulatorStateCustomFlags.Custom1,pe=u.create(),me=u.create(),ge=c.create(),fe=new b.EuclideanSegment;e.DidPointerMoveRecentlyFlag=ue,e.LengthDimensionManipulators=L,e.LengthDimensionPointManipulator=G,e.LineOfSightOrientationManipulator=j,e.automaticHeadingFromCamera=K,e.createMeasureTypeManipulator=V,e.createOffsetManipulator=U,e.focusedOffsetWidth=ce,e.headingManipulatorHandles=k,e.measureTypeManipulatorHandles=q,e.offsetManipulatorHandles=_,e.pointManipulatorHandles=W,e.rotationManipulatorHandles=I,e.snapOrientationToNearestRightAngle=Z,e.unfocusedOffsetWidth=le,e.updateHeadingManipulatorTransform=X,e.updateMeasureTypeManipulatorTransform=ne,e.updateOffsetManipulatorTransform=Q,e.updateRotationManipulatorTransform=Y,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
