/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../analysis/dimensionUtils","../../../../core/mathUtils","../../../../core/quantityUtils","../../../../core/unitUtils","../../../../core/libs/gl-matrix-2/math/mat4","../../../../core/libs/gl-matrix-2/factories/mat4f64","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../geometry/support/Axis","../../../../geometry/support/vectorStacks","../../../../layers/graphics/dehydratedPoint","../../../../layers/graphics/hydratedFeatures","../../interactive/visualElements/support/Segment","../../../support/automaticLengthMeasurementUtils","../../../support/euclideanLengthMeasurementUtils","../../../support/geodesicMeasurementUtils"],(function(e,t,n,i,r,o,a,s,d,c,l,u,g,p,m,S,f){"use strict";function v(e,n,o){if(null==e)return null;let a;if(n===t.LengthDimensionMeasureType.Horizontal)a=m.autoDistanceBetweenPoints2D(e.elevationAlignedStartPoint,e.elevationAlignedEndPoint);else{const{startRenderSpace:t,endRenderSpace:n}=e.dimensionSegment;a=S.euclideanDirectDistance(t,n,e.spatialReference)}if(null==a)return null;const s=n===t.LengthDimensionMeasureType.Vertical?r.adaptiveVerticalLengthUnit(a.value,a.unit,o):r.adaptiveLengthUnit(a.value,a.unit,o);return i.toUnit(a,s)}function y(e){const{elevationAlignedStartPoint:t,elevationAlignedEndPoint:n,dimension:{offset:i,measureType:r,orientation:o}}=e;return{elevationAlignedStartPoint:t,elevationAlignedEndPoint:n,offset:i,measureType:r,orientation:o}}function A({elevationAlignedStartPoint:e,elevationAlignedEndPoint:n,offset:i,measureType:r,orientation:o},a,c=null){if(null==e||null==n)return null;const l=D(c?.directSegment??new p.EuclideanSegment,{elevationAlignedStartPoint:e,elevationAlignedEndPoint:n},a),u=c?.primaryOffsetAxis??d.create();U(u,{measureType:r,elevationAlignedStartPoint:e,elevationAlignedEndPoint:n,directSegment:l,orientation:o,renderCoordsHelper:a});const g=c?.dimensionSegment??new p.EuclideanSegment;return w({elevationAlignedStartPoint:e,elevationAlignedEndPoint:n})&&r===t.LengthDimensionMeasureType.Vertical?(s.copy(g.startRenderSpace,l.startRenderSpace),s.copy(g.endRenderSpace,l.endRenderSpace)):C(g,{offsetAxis:u,offset:i,relativeToSegment:l,renderCoordsHelper:a}),{elevationAlignedStartPoint:e,elevationAlignedEndPoint:n,directSegment:l,dimensionSegment:g,primaryOffsetAxis:u,spatialReference:a.spatialReference}}function R(t,n,i,r){return n===e.OffsetSegmentLocation.Start?(s.copy(t.startRenderSpace,i.startRenderSpace),s.copy(t.endRenderSpace,r.startRenderSpace)):(s.copy(t.startRenderSpace,i.endRenderSpace),s.copy(t.endRenderSpace,r.endRenderSpace)),t}var P;function h(e,t,n,i){s.scaleAndAdd(e.startRenderSpace,t.startRenderSpace,n,i),s.scaleAndAdd(e.endRenderSpace,t.endRenderSpace,n,i)}function T(e,n,i,r){switch(n){case t.LengthDimensionMeasureType.Direct:return D(e,i,r);case t.LengthDimensionMeasureType.Horizontal:case t.LengthDimensionMeasureType.Vertical:{const{elevationAlignedStartPoint:o,elevationAlignedEndPoint:a,dimension:s,geometry:d}=i;let c;if(s.measureType===t.LengthDimensionMeasureType.Direct){c=E(d,r)===o.z>a.z,n===t.LengthDimensionMeasureType.Horizontal&&(c=!c)}else c=!L(d);const[l,u]=c?[o,a]:[a,o],p=g.clonePoint(u,M);return n===t.LengthDimensionMeasureType.Horizontal?p.z=l.z:(p.x=l.x,p.y=l.y),r.toRenderCoords(l,e.startRenderSpace),r.toRenderCoords(p,e.endRenderSpace),e}}}function D(e,t,n){return n.toRenderCoords(t.elevationAlignedStartPoint,e.startRenderSpace),n.toRenderCoords(t.elevationAlignedEndPoint,e.endRenderSpace),e}function E(e,t){const n=e.directSegment.eval(.5,l.sv3d.get()),i=t.worldUpAtPosition(n,l.sv3d.get()),r=e.dimensionSegment.eval(.5,l.sv3d.get()),o=s.sub(l.sv3d.get(),r,n);return!s.equals(o,d.ZEROS)&&s.dot(o,i)>0}function L(e){const{startRenderSpace:t,endRenderSpace:n}=e.dimensionSegment,{startRenderSpace:i,endRenderSpace:r}=e.directSegment;return s.sqrDist(i,t)<s.sqrDist(r,n)}e.OffsetSegmentLocation=void 0,(P=e.OffsetSegmentLocation||(e.OffsetSegmentLocation={}))[P.Start=0]="Start",P[P.End=1]="End";const M=u.makeDehydratedPoint(0,0,0,null);function x(e,t,n,i){const{directSegment:r}=n,o=U(l.sv3d.get(),{measureType:t,directSegment:r,renderCoordsHelper:i}),a=C(b,{offsetAxis:o,offset:0,relativeToSegment:r,renderCoordsHelper:i}).eval(.5,l.sv3d.get()),d=s.sub(l.sv3d.get(),e,a);return s.dot(d,o)*i.unitInMeters}const b=new p.EuclideanSegment;function U(e,i){const{measureType:r,elevationAlignedStartPoint:a,elevationAlignedEndPoint:u,directSegment:{startRenderSpace:g,endRenderSpace:p},directSegment:m,renderCoordsHelper:S}=i,f=m.eval(.5,l.sv3d.get()),v=S.worldUpAtPosition(f,l.sv3d.get()),y=S.worldBasisAtPosition(f,c.Axis.Y,l.sv3d.get());switch(r){case t.LengthDimensionMeasureType.Horizontal:s.copy(e,v);break;case t.LengthDimensionMeasureType.Vertical:s.dot(g,v)<s.dot(p,v)?s.sub(e,p,g):s.sub(e,g,p),s.cross(e,e,v),s.cross(e,e,v);break;case t.LengthDimensionMeasureType.Direct:{const t=i.orientation??0;if(w({elevationAlignedStartPoint:a,elevationAlignedEndPoint:u}))o.fromRotation(O,-n.deg2rad(t),v),s.transformMat4(e,y,O);else{const i=s.sub(l.sv3d.get(),p,g),r=s.cross(l.sv3d.get(),i,v);s.cross(r,r,i),o.fromRotation(O,n.deg2rad(t),i),s.transformMat4(e,r,O)}break}}return s.equals(e,d.ZEROS)?s.copy(e,y):s.normalize(e,e)}const O=a.create();function w({elevationAlignedStartPoint:e,elevationAlignedEndPoint:t}){return null!=e&&null!=t&&e.x===t.x&&e.y===t.y}function C(e,t){const{offsetAxis:n,offset:i,relativeToSegment:{startRenderSpace:r,endRenderSpace:o},relativeToSegment:a,renderCoordsHelper:d}=t,c=i/d.unitInMeters,[l,u]=H(r,o,n,c);return s.scaleAndAdd(e.startRenderSpace,a.startRenderSpace,n,l),s.scaleAndAdd(e.endRenderSpace,a.endRenderSpace,n,u),e}function H(e,t,n,i=0){const r=s.dot(t,n),o=s.dot(e,n),a=Math.abs(r-o)+i;return r>o?[a,i]:[i,a]}function z(e,t,n){const i=t.directSegment.eval(.5,l.sv3d.get());return n.worldUpAtPosition(i,e)}function q(e,t){const{startRenderSpace:n,endRenderSpace:i}=t.directSegment;return s.sub(e,i,n)}function V(e,t,n={invert:!1}){const{startRenderSpace:i,endRenderSpace:r}=t.dimensionSegment;return n.invert?s.sub(e,i,r):s.sub(e,r,i)}function k(e,t){const n=e.directSegment.eval(.5,l.sv3d.get());return t.headingAtPosition(n,e.primaryOffsetAxis)}function F(e,t){return s.squaredLength(V(G,e))/t**2}const G=d.create();function B(e){const{elevationAlignedStartPoint:t,elevationAlignedEndPoint:n}=e;if(null==t||null==n)return!1;const r=S.euclideanDirectDistanceBetweenPoints(t,n);return null!=r&&i.toUnit(r,"meters").value>f.geodesicDistanceThreshold}function I(e){return null!=e.geometry}e.arePointsVerticallyAligned=w,e.computationToGeometryDependencies=y,e.computeGeometryFromDimension=A,e.computeLength=v,e.computeOffsetAxis=U,e.computeOffsetForPoint=x,e.computeSegmentForMeasureType=T,e.computeSpanningSegment=R,e.dimensionStartToEnd=V,e.directStartToEnd=q,e.directUp=z,e.headingFromGeometry=k,e.isGeodesicDimension=B,e.isValidComputation=I,e.maxScreenLengthSquaredFromGeometry=F,e.offsetSegment=h,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
