/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../chunks/tslib.es6","../../../../geometry","../../../../analysis/featureReferenceUtils","../../../../core/Accessor","../../../../core/asyncUtils","../../../../core/Evented","../../../../core/Handles","../../../../core/handleUtils","../../../../core/Logger","../../../../core/maybe","../../../../core/promiseUtils","../../../../core/reactiveUtils","../../../../core/accessorSupport/decorators/property","../../../../core/has","../../../../core/RandomLCG","../../../../core/accessorSupport/decorators/subclass","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../core/support/UpdatingHandles","../../../../geometry/projection","../../../../geometry/projection/projectBoundingRect","../../../../geometry/support/aaBoundingRect","../../../../geometry/support/ray","../../../../support/elevationInfoUtils","../LineOfSightAnalysisResult","./LineOfSightComputation","./LineOfSightRayIntersector","../support/projectionUtils","../../webgl-engine/lib/IntersectorInterfaces","../../webgl-engine/lib/intersectorUtilsConversions","../../../support/Scheduler","../../../../geometry/Point"],(function(e,t,o,n,i,r,s,a,l,c,d,u,p,g,h,v,_,f,m,y,b,C,O,T,P,S,I,L,R,w,H,A,E){"use strict";function F(e,t){return e.hasZ?t??{mode:"absolute-height",offset:0}:{mode:"on-the-ground",offset:0}}function j({computation:e,interpolationInfo:t}){const{computationResult:o,inputPoints:n}=e,{start:i,end:r,intersection:s}=o,{originalIntersection:a,originalObserver:l,originalTarget:c}=t;if(f.copy(s,a),n.isValid){const e=G,t=f.dist(l,a)/f.dist(l,c);f.sub(e,i,l),f.scale(e,e,1-t),f.add(s,s,e),f.sub(e,r,c),f.scale(e,e,t),f.add(s,s,e),o.isValid=!0}else e.result=null,o.isValid=!1,o.isTargetVisible=!1}e.LineOfSightController=class extends(s.EventedMixin(i)){constructor(e){super(e),this.updateOnCameraChange=!0,this._observerGroundOffsetRenderSpace=0,this._effectiveObserverElevationMode="absolute-height",this._observerFeatureId=null,this._updatingHandles=new y.UpdatingHandles,this._frameTask=A.ImmediateTask,this._computationHandles=new a,this._externalObserverUpdate=!0}initialize(){const e=this.view.resourceController?.scheduler;this._frameTask=e?e.registerTask(A.TaskPriority.LINE_OF_SIGHT_TOOL):A.ImmediateTask,this._intersector=new L.LineOfSightRayIntersector({view:this.view}),this.addHandles([this._connectObserver(),this._connectComputations(),this._connectTargets()])}destroy(){this._computationHandles.destroy(),this._computations.removeAll(),this._updatingHandles.destroy()}get updating(){return this._frameTask.updating||this._updatingHandles.updating}get priority(){return this._frameTask.priority}set priority(e){this._frameTask.priority=e}get _computations(){return this.analysisViewData.computations}get _elevationAlignedObserverPositionRenderSpace(){return this.analysisViewData.observerEngineLocation}set _elevationAlignedObserverPositionRenderSpace(e){this.analysisViewData.observerEngineLocation=e}get _screenPixelSize(){return this.view.state.camera.computeScreenPixelSizeAt(this._elevationAlignedObserverPositionRenderSpace)}_computeResult(e){const t=e.computation,{inputPoints:o,computationResult:n}=t,{observerAdjusted:i,targetAdjusted:r}=o,{start:s,end:a}=n;f.copy(s,i),f.copy(a,r);this._canCompute(t)?this._computeIntersection(e):j(e),t.notifyResultChanged(),this.emit("result-changed",{target:e.computation.target,result:t.result})}_adjustStartEndPositions(e){const{view:t}=this,{inputPoints:o}=e,{observer:i,target:r,observerAdjusted:s,targetAdjusted:a}=o;f.copy(s,i),f.copy(a,r),n.updatePointsFromFeatureReference(t,this._intersector.intersector,o);const{observerSurfaceNormal:l,targetSurfaceNormal:c}=o,d=this._screenPixelSize,u=G;null!=l?f.copy(u,l):f.subtract(u,a,s);const p=d;f.normalize(u,u),f.scale(u,u,Math.min(p,1)),f.add(s,s,u),null!=c?f.copy(u,c):f.subtract(u,s,a);const g=t.state.camera.computeScreenPixelSizeAt(a);f.normalize(u,u),f.scale(u,u,Math.min(g,1)),f.add(a,a,u)}_computeIntersection({computation:e,interpolationInfo:t}){const{view:o}=this,{sceneIntersectionHelper:n,renderCoordsHelper:i}=o;if(null==n)return;const r=this._intersector.intersector,{computationResult:s,inputPoints:a}=e,{observer:l,target:c}=a,{start:d,end:u}=s,p=T.fromPoints(d,u,k);r.options.store=w.StoreResults.MIN,n.intersectToolIntersectorRay(p,r);const g=r.results.min,h=s.intersection,v=G;let _=!0;if(null!=g&&g.getIntersectionPoint(h)){f.copy(t.originalIntersection,h),f.copy(t.originalObserver,d),f.copy(t.originalTarget,u),i.fromRenderCoords(h,v,o.spatialReference);const e=1-f.dist(u,c)/f.dist(d,c);_=f.dist(l,h)>=e*f.dist(l,c)}const m=new E(v,o.spatialReference);{const{result:t,target:n}=e;null!=t?(t.target=n,t.intersectedGraphic=_?null:H.toGraphic(g,o),t.intersectedLocation=_?null:m,t.visible=_):e.result=new S({target:n,elevationAlignedTargetLocation:e.elevationAlignedTargetLocation,intersectedGraphic:_?null:H.toGraphic(g,o),intersectedLocation:_?null:m,visible:_})}s.isValid=a.isValid=!0,s.isTargetVisible=_}_canCompute(e){const t=this.analysisViewData.elevationAlignedObserver,o=this.view.frustum;if(null==t||null==e.elevationAlignedTargetLocation||null==o)return!1;const{observerAdjusted:n,targetAdjusted:i}=e.inputPoints,r=o.intersectsPoint(n),s=o.intersectsPoint(i);return r&&s}_onObserverPositionChange(e,t,o,i,r){if(this._externalObserverUpdate=r,null==e)return this.analysisViewData.elevationAlignedObserver=null,void(this._observerFeatureId=null);if(null==t)return R.logFailedGeometryProjectionError(this.analysis,e.spatialReference,c.getLogger(this)),void(this.analysisViewData.elevationAlignedObserver=null);const s=F(t,o),{absoluteZ:a,elevation:l}=P.zValueInAbsoluteHeightMode(t.x,t.y,t.z,this.view.spatialReference,this.view,s),d=t.clone();d.z=a,this._effectiveObserverElevationMode=s.mode,this.analysisViewData.elevationAlignedObserver=d;const u=m.create();this.view.renderCoordsHelper.toRenderCoords(d,u),this._elevationAlignedObserverPositionRenderSpace=u,this._observerGroundOffsetRenderSpace=a-l,this._observerFeatureId=n.getFeatureId(i),this.priority=A.TaskPriority.LINE_OF_SIGHT_TOOL_INTERACTIVE}_onObserverRenderSpacePositionChangeForComputation(e,t,o,n,i){const{inputPoints:r}=e;switch(f.copy(r.observer,t),r.observerFeatureId=i,r.observerSurfaceNormal=null,n){case"on-the-ground":case"relative-to-ground":{const e=this._intersector.updateFromGroundIntersection(r.observer,o,r.observer);null==r.observerFeatureId&&(r.observerSurfaceNormal=e)}}this._adjustStartEndPositions(e),e.notifyInputPointsChanged(),this.priority=A.TaskPriority.LINE_OF_SIGHT_TOOL_INTERACTIVE}_onTargetPositionChange(e,t,o,i,r,s=!0){const a=e.inputPoints;if(s&&(a.isValid=!1),null==o)return null!=t&&R.logFailedGeometryProjectionError(this.analysis,t.spatialReference,c.getLogger(this)),e.elevationAlignedTargetLocation=null,void e.notifyInputPointsChanged();const l=F(o,i),{absoluteZ:d,elevation:u}=P.zValueInAbsoluteHeightMode(o.x,o.y,o.z,this.view.spatialReference,this.view,l),p=o.clone();switch(p.z=d,e.elevationAlignedTargetLocation=p,this.view.renderCoordsHelper.toRenderCoords(e.elevationAlignedTargetLocation,a.target),a.targetFeatureId=n.getFeatureId(r),a.targetSurfaceNormal=null,l.mode){case"on-the-ground":case"relative-to-ground":{const e=this._intersector.updateFromGroundIntersection(a.target,d-u,a.target);null==a.targetFeatureId&&(a.targetSurfaceNormal=e)}}this._adjustStartEndPositions(e),e.notifyInputPointsChanged(),this.priority=A.TaskPriority.LINE_OF_SIGHT_TOOL_INTERACTIVE}_connectComputationToTarget(e){return l.handlesGroup([this._updatingHandles.add((()=>({computation:e,targetPosition:e.target.position,targetElevationInfo:e.target.elevationInfo,targetFeatureInfo:e.target.feature,projectedTargetPosition:b.projectOrLoad(e.target.position,this.view.spatialReference)})),(({computation:e,targetPosition:t,targetElevationInfo:o,targetFeatureInfo:n,projectedTargetPosition:i})=>{null==i.pending?this._onTargetPositionChange(e,t,i.geometry,o,n):this._updatingHandles.addPromise(i.pending)}),p.initial)])}_connectComputationToObserver(e){return this._updatingHandles.add((()=>({computation:e,observer:this.analysisViewData.elevationAlignedObserver})),(({computation:e})=>{this._externalObserverUpdate&&(e.inputPoints.isValid=!1,e.notifyInputPointsChanged())}),p.initial)}_connectComputationToRenderSpaceObserver(e){return this._updatingHandles.add((()=>({computation:e,observer:this._elevationAlignedObserverPositionRenderSpace,observerGroundOffset:this._observerGroundOffsetRenderSpace,observerElevationMode:this._effectiveObserverElevationMode,observerFeatureId:this._observerFeatureId})),(({computation:e,observer:t,observerGroundOffset:o,observerElevationMode:n,observerFeatureId:i})=>{this._onObserverRenderSpacePositionChangeForComputation(e,t,o,n,i)}),p.initial)}_connectComputationToCamera(e){return this._updatingHandles.add((()=>({camera:this.view.state.camera,isDirty:this._isCameraDirty})),(({isDirty:t})=>{!this.updateOnCameraChange||e.inputPoints.isValid&&!t||e.notifyInputPointsChanged()}))}_connectComputationToSlicePlane(e){return this._updatingHandles.add((()=>this.view.slicePlane),(()=>{e.inputPoints.isValid=!1,e.notifyInputPointsChanged()}))}_connectComputationToElevation(e){const t=(o,n)=>{const i=this.analysis.observer,r=e.target;let s=null,a=null,l=null,c=null,d=null,u=null;if(null!=i?.position){const e=b.projectOrLoad(i.position,this.view.spatialReference);if(null!=e.pending)return this._updatingHandles.addPromise(e.pending),void e.pending.finally((()=>t(o,n)));s=e.geometry,a=i.elevationInfo,l=i.feature}if(null!=r.position){const e=b.projectOrLoad(r.position,this.view.spatialReference);if(null!=e.pending)return this._updatingHandles.addPromise(e.pending),void e.pending.finally((()=>t(o,n)));c=e.geometry,d=r.elevationInfo,u=r.feature}null==s&&null==c||(C.projectBoundingRect(o,n,x,this.view.spatialReference),null!=s&&O.containsPointObject(x,s)&&this._onObserverPositionChange(null!=i?i.position:null,s,a,l,!1),null!=c&&O.containsPointObject(x,c)&&this._onTargetPositionChange(e,r.position,c,d,u,!1),null!=s&&null!=c&&O.intersectsSegment(x,s,c)&&e.notifyInputPointsChanged())};return this.view.elevationProvider.on("elevation-change",(({extent:e,spatialReference:o})=>t(e,o)))}_connectComputationToTask(e){let t=null;const o={computation:e,interpolationInfo:{originalIntersection:m.create(),originalObserver:m.create(),originalTarget:m.create()}};return l.handlesGroup([this._updatingHandles.add((()=>e.inputPoints),(()=>{t=d.abortMaybe(t),t=r.createTask((async e=>{await u.ignoreAbortErrors(this._frameTask.schedule((()=>this._computeResult(o)),e))}))}),{initial:!0,equals:()=>!1}),l.makeHandle((()=>t=d.abortMaybe(t)))])}_connectComputation(e){const t=this._computationHandles;t.has(e)||t.add([this._connectComputationToTarget(e),this._connectComputationToObserver(e),this._connectComputationToRenderSpaceObserver(e),this._connectComputationToCamera(e),this._connectComputationToSlicePlane(e),this._connectComputationToElevation(e),this._connectComputationToTask(e)],e)}_disconnectComputation(e){this._computationHandles.remove(e)}_onComputationCollectionChange({added:e,removed:t}){for(const o of t)this._disconnectComputation(o);for(const o of e)this._connectComputation(o)}_onTargetCollectionChange({added:e,removed:t}){for(const o of t)this._removeTarget(o);for(const o of e)this._addTarget(o)}_onCursorTargetChange(e,t){null!=t&&this._removeTarget(t),null!=e&&this._addTarget(e)}_addTarget(e){this._computations.some((t=>t.target===e))||this._computations.add(new I.LineOfSightComputation({target:e}))}_removeTarget(e){const t=this._computations.findIndex((t=>t.target===e));this._computations.removeAt(t)}_connectObserver(){return l.handlesGroup([this._updatingHandles.add((()=>({observerPosition:null!=this.analysis.observer?this.analysis.observer.position:null,projectedObserverPosition:b.projectOrLoad(null!=this.analysis.observer?this.analysis.observer.position:null,this.view.spatialReference),observerElevationInfo:null!=this.analysis.observer?this.analysis.observer.elevationInfo:null,observerFeatureInfo:null!=this.analysis.observer?this.analysis.observer.feature:null})),(({observerPosition:e,projectedObserverPosition:t,observerElevationInfo:o,observerFeatureInfo:n})=>{null==t.pending?this._onObserverPositionChange(e,t.geometry,o,n,!0):this._updatingHandles.addPromise(t.pending)}),p.initial)])}_connectComputations(){return this._updatingHandles.addOnCollectionChange((()=>this._computations),(e=>this._onComputationCollectionChange(e)),{initial:!0,final:!0})}_connectTargets(){return l.handlesGroup([this._updatingHandles.addOnCollectionChange((()=>this.analysis.targets),(e=>this._onTargetCollectionChange(e)),{initial:!0,final:!0}),this._updatingHandles.add((()=>this.analysisViewData.cursorTarget),((e,t)=>{this._onCursorTargetChange(e,t)}))])}get _isCameraDirty(){const e=this.analysisViewData.elevationAlignedObserver,{view:t}=this,{renderCoordsHelper:o}=t;if(null==e||null==o)return!1;const n=G;o.toRenderCoords(e,n);const i=t.state.camera.computeScreenPixelSizeAt(n);return Math.abs((i-this._screenPixelSize)/this._screenPixelSize)>V}},t.__decorate([g.property({constructOnly:!0})],e.LineOfSightController.prototype,"analysis",void 0),t.__decorate([g.property({constructOnly:!0})],e.LineOfSightController.prototype,"analysisViewData",void 0),t.__decorate([g.property({constructOnly:!0})],e.LineOfSightController.prototype,"view",void 0),t.__decorate([g.property()],e.LineOfSightController.prototype,"updating",null),t.__decorate([g.property()],e.LineOfSightController.prototype,"priority",null),t.__decorate([g.property()],e.LineOfSightController.prototype,"updateOnCameraChange",void 0),t.__decorate([g.property()],e.LineOfSightController.prototype,"_computations",null),t.__decorate([g.property()],e.LineOfSightController.prototype,"_elevationAlignedObserverPositionRenderSpace",null),t.__decorate([g.property()],e.LineOfSightController.prototype,"_observerGroundOffsetRenderSpace",void 0),t.__decorate([g.property()],e.LineOfSightController.prototype,"_effectiveObserverElevationMode",void 0),t.__decorate([g.property()],e.LineOfSightController.prototype,"_observerFeatureId",void 0),t.__decorate([g.property()],e.LineOfSightController.prototype,"_screenPixelSize",null),t.__decorate([g.property({readOnly:!0})],e.LineOfSightController.prototype,"_updatingHandles",void 0),t.__decorate([g.property()],e.LineOfSightController.prototype,"_frameTask",void 0),t.__decorate([g.property()],e.LineOfSightController.prototype,"_isCameraDirty",null),e.LineOfSightController=t.__decorate([_.subclass("esri.views.3d.analysis.LineOfSight.LineOfSightController")],e.LineOfSightController);const V=.1,G=m.create(),k=T.create(),x=O.empty();Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
