/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../chunks/tslib.es6","../../../../Color","../../../../core/Accessor","../../../../core/Handles","../../../../core/handleUtils","../../../../core/has","../../../../core/maybe","../../../../core/reactiveUtils","../../../../core/accessorSupport/decorators/property","../../../../core/Logger","../../../../core/RandomLCG","../../../../core/accessorSupport/decorators/subclass","../../../../core/libs/gl-matrix-2/factories/mat4f64","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../core/support/UpdatingHandles","./LineOfSightConfiguration","./LineOfSightVisualElement","../../interactive/visualElements/LineVisualElement","../../interactive/visualElements/PointVisualElement","../../webgl-engine/lib/Material"],(function(e,i,t,n,o,a,s,r,l,c,u,d,h,g,p,m,f,v,y,b,_,O){"use strict";e.LineOfSightVisualization=class extends n{constructor(e){super(e),this._lineOfSightVisualElements=new Array,this._computationHandles=new o,this._updatingHandles=new f.UpdatingHandles}initialize(){this.addHandles(this._connectComputations()),this._createObserverVisualization()}destroy(){this._updatingHandles=r.destroyMaybe(this._updatingHandles),this._computationHandles=r.destroyMaybe(this._computationHandles),this._observerVisualElement=r.destroyMaybe(this._observerVisualElement)}get visible(){return this.analysisViewData.visible}get updating(){return this._updatingHandles.updating}get interactiveAndEditable(){return this.analysisViewData.interactive&&this.analysisViewData.editable}get test(){}_createLineOfSightVisualization(){const e=v.lineOfSightConfiguration,i=this.view,n=this.isDecoration,o={view:i,attached:!0,width:e.outerWidth,innerWidth:e.innerWidth,isDecoration:n},a=t.toUnitRGBA(e.visibleOuterColor),s=t.toUnitRGBA(e.visibleInnerColor),r=t.toUnitRGBA(e.occludedOuterColor),l=t.toUnitRGBA(e.occludedInnerColor),c=t.toUnitRGBA(e.undefinedOuterColor),u=t.toUnitRGBA(e.undefinedInnerColor),d=new b.LineVisualElement({...o,color:a,innerColor:s}),h=new b.LineVisualElement({...o,color:r,innerColor:l}),g=new b.LineVisualElement({...o,color:c,innerColor:u}),p=new _.PointVisualElement({view:i,attached:!0,...V,size:8,isDecoration:n}),m=new y.LineOfSightVisualElement(d,h,g,p);return this._lineOfSightVisualElements.push(m),m}_destroyLineOfSightVisualization(e){e.destroy(),this._lineOfSightVisualElements.splice(this._lineOfSightVisualElements.indexOf(e),1)}_updateLineOfSightVisualization(e,i,n){const o=v.lineOfSightConfiguration,{computationResult:a,inputPoints:s}=e,{start:r,end:l,intersection:c,isValid:u,isTargetVisible:d}=a,{observer:h}=s,g=A;g[12]=h[0],g[13]=h[1],g[14]=h[2];const f=p.subtract(C,r,h),y=p.subtract(S,l,h),b=p.subtract(L,c,h),{visibleLineVisualElement:_,occludedLineVisualElement:O,undefinedLineVisualElement:V,targetVisualElement:E}=i,z=null==this.analysisViewData.elevationAlignedObserver||null==e.elevationAlignedTargetLocation,w=this.visible&&!z;_.visible=w,O.visible=w,V.visible=w,E.visible=w,E.attached=!n.interactiveAndEditable,w&&(_.geometry=null,O.geometry=null,V.geometry=null,E.geometry=e.elevationAlignedTargetLocation,u?d?(_.geometry=[[m.fromArray(f),m.fromArray(y)]],_.transform=g,_.color=t.toUnitRGBA(o.visibleOuterColor),E.color=t.toUnitRGBA(o.visibleInnerColor)):(_.geometry=[[m.fromArray(f),m.fromArray(b)]],_.transform=g,_.color=t.toUnitRGBA(o.occludedOuterColor),O.geometry=[[m.fromArray(b),m.fromArray(y)]],O.transform=g,E.color=t.toUnitRGBA(o.occludedInnerColor)):(V.geometry=[[m.fromArray(f),m.fromArray(y)]],V.transform=g,E.color=t.toUnitRGBA(o.undefinedInnerColor)))}_getLineOfSightVisualizationDependencies(e){const{computationResult:i}=e,{occludedOuterColor:t,visibleOuterColor:n}=v.lineOfSightConfiguration;return{computationResult:i,occludedOuterColor:t,visibleOuterColor:n,visible:this.visible,interactiveAndEditable:this.interactiveAndEditable}}_connectComputation(e){const i=this._computationHandles;if(i.has(e))return;const t=this._createLineOfSightVisualization();i.add([this._updatingHandles.add((()=>this._getLineOfSightVisualizationDependencies(e)),(i=>this._updateLineOfSightVisualization(e,t,i)),{initial:!0,equals:()=>!1}),a.makeHandle((()=>this._destroyLineOfSightVisualization(t)))],e)}_disconnectComputation(e){this._computationHandles.remove(e)}_connectComputations(){return this._updatingHandles.addOnCollectionChange((()=>this.analysisViewData.computations),(e=>this._onComputationsCollectionChange(e)),{initial:!0,final:!0})}_onComputationsCollectionChange({added:e,removed:i}){for(const t of i)this._disconnectComputation(t);for(const t of e)this._connectComputation(t)}_createObserverVisualization(){const e=t.toUnitRGBA(v.lineOfSightConfiguration.visibleInnerColor),i=new _.PointVisualElement({view:this.view,color:e,...V,isDecoration:this.isDecoration});this._observerVisualElement=i,this.addHandles(this._updatingHandles.add((()=>({observer:this.analysisViewData.elevationAlignedObserver,interactiveAndEditable:this.interactiveAndEditable,visible:this.visible})),(({observer:e,interactiveAndEditable:t,visible:n})=>{null!=e&&!t&&n?(i.geometry=e,this._observerVisualElement.attached=!0):i.attached=!1}),l.initial))}},i.__decorate([c.property({constructOnly:!0})],e.LineOfSightVisualization.prototype,"analysis",void 0),i.__decorate([c.property({constructOnly:!0})],e.LineOfSightVisualization.prototype,"analysisViewData",void 0),i.__decorate([c.property({constructOnly:!0})],e.LineOfSightVisualization.prototype,"view",void 0),i.__decorate([c.property({readOnly:!0})],e.LineOfSightVisualization.prototype,"visible",null),i.__decorate([c.property({constructOnly:!0})],e.LineOfSightVisualization.prototype,"isDecoration",void 0),i.__decorate([c.property()],e.LineOfSightVisualization.prototype,"updating",null),i.__decorate([c.property()],e.LineOfSightVisualization.prototype,"interactiveAndEditable",null),i.__decorate([c.property()],e.LineOfSightVisualization.prototype,"test",null),e.LineOfSightVisualization=i.__decorate([h.subclass("esri.views.3d.analysis.LineOfSight.LineOfSightVisualization")],e.LineOfSightVisualization);const V={size:6,pixelSnappingEnabled:!1,primitive:"circle",elevationInfo:{mode:"absolute-height",offset:0},outlineSize:0},C=m.create(),S=m.create(),L=m.create(),A=g.create();Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
