/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../chunks/tslib.es6","../../../../analysis/SlicePlane","../../../../core/Accessor","../../../../core/Logger","../../../../core/reactiveUtils","../../../../core/accessorSupport/decorators/property","../../../../core/has","../../../../core/RandomLCG","../../../../core/accessorSupport/decorators/subclass","../../../../chunks/boundedPlane","../../../../layers/Layer","../../../../layers/buildingSublayers/BuildingComponentSublayer","./sliceToolUtils","../support/projectionUtils","../../terrain/isTerrainSurfaceLayer"],(function(e,i,a,l,t,s,n,r,o,c,h,u,d,y,p,w){"use strict";e.SliceController=class extends l{constructor(e){super(e),this._internalChange=!1,this._currentSlicePlane=null}initialize(){this.addHandles(this.analysis.excludedLayers.on("before-add",(e=>{const i=e.item;null!=i&&(i instanceof u||i instanceof d)?i instanceof u&&w.isTerrainSurfaceLayer(i)?(t.getLogger(this).error("excludedLayers",`Layer '${i.title}, id:${i.id}' of type '${i.type}' can not be individually excluded from slicing. Use 'excludeGroundSurface' instead.`),e.preventDefault()):this.analysis.excludedLayers.includes(i)&&e.preventDefault():(t.getLogger(this).error("excludedLayers","Invalid layer type, layer must derive from Layer or BuildingComponentSublayer"),e.preventDefault())}))),S(this.view,this),this.addHandles([s.watch((()=>this.analysisViewData.plane),(()=>{this._internalChange||this._updateSlicePlaneFromBoundedPlane(),this._updateLayerViews()}),{sync:!0}),s.watch((()=>this.analysis.excludeGroundSurface),(()=>this._updateLayerViews()),{sync:!0}),this.analysis.excludedLayers.on("change",(()=>this._updateLayerViews())),s.watch((()=>[this.analysisViewData.active,this.analysisViewData.visible]),(()=>{this._updateActiveController(),this._updateViewSlicePlane()}),{sync:!0}),s.watch((()=>this._allLayerAndSubLayerViews),(()=>this._updateLayerViews()))]),this.addHandles([s.watch((()=>this.analysis.shape),(()=>{this._internalChange||(this._updateBoundedPlaneFromSlicePlane(),this._updateViewSlicePlane())}),{sync:!0})],"analysis"),this._updateActiveController(),this._updateBoundedPlaneFromSlicePlane(),this._updateViewSlicePlane()}destroy(){this.analysisViewData.active&&(this.analysisViewData.active=!1,this.view.slicePlane=null,this._updateActiveController(),this._updateViewSlicePlane()),V(this.view,this),this.set("view",null)}get _allLayerAndSubLayerViews(){const e=this.view.allLayerViews.items;return e.concat(e.filter(y.isIBuildingSceneLayerView3D).flatMap((({sublayerViews:e})=>e.items)))}_updateBoundedPlaneFromSlicePlane(){const e=this.analysis.shape,i=this._currentSlicePlane;if(null==i&&null==e||null!=i&&null!=e&&e.equals(i))return;let a=null,l=null;if(null!=e?.position){const i=e.position.spatialReference,s=y.projectAndElevationAlignShape(e,this.view);null==s&&p.logFailedGeometryProjectionError(this.analysis,i,t.getLogger(this)),a=y.projectedShapeToPlane(s,this.view,{tiltEnabled:this.analysis.tiltEnabled},h.create()),null!=a&&(l={heading:e.heading,tilt:e.tilt,position:e.position,width:e.width,height:e.height})}this._currentSlicePlane=l,this._internalChange=!0,this.analysisViewData.plane=a,this._internalChange=!1}_updateSlicePlaneFromBoundedPlane(){const e=this.analysisViewData.plane,i=y.planeToShape(e,this.view,this.view.spatialReference,new a);let l=null;null!=i&&(l={heading:i.heading,tilt:i.tilt,position:i.position,width:i.width,height:i.height}),this._currentSlicePlane=l,this._internalChange=!0,this.analysis.shape=i,this._internalChange=!1,this._updateViewSlicePlane()}_updateActiveController(){if(_)return;const e=f(this.view);if(!e)return;if(this.analysisViewData.active)null!=e.activeController&&e.activeController!==this?(_=!0,e.activeController.analysisViewData.active=!1,_=!1):null!=e.activeController&&e.activeController,this._updateLayerViews(),e.activeController=this;else{if(null!=e.activeController&&e.activeController!==this)return;null!=e.activeController&&e.activeController===this&&(e.activeController=null,this._updateLayerViews())}}_updateViewSlicePlane(){g(this.view)}_updateLayerViews(){const e=null!=this.analysisViewData.plane&&this.analysisViewData.visible&&this.analysisViewData.active,i=[],a=e=>{"layers"in e?e.layers.forEach(a):i.push(e)};this.analysis.excludedLayers.forEach(a),this.view.allLayerViews.forEach((a=>{a.destroyed||("slicePlaneEnabled"in a&&(a.slicePlaneEnabled=e&&!i.includes(a.layer)),"sublayerViews"in a&&a.sublayerViews.forEach((a=>{a.slicePlaneEnabled=e&&!i.includes(a.sublayer)})))})),null!=this.view.basemapTerrain&&(this.view.basemapTerrain.slicePlaneEnabled=e&&!this.analysis.excludeGroundSurface)}},i.__decorate([n.property()],e.SliceController.prototype,"view",void 0),i.__decorate([n.property()],e.SliceController.prototype,"analysis",void 0),i.__decorate([n.property()],e.SliceController.prototype,"analysisViewData",void 0),i.__decorate([n.property()],e.SliceController.prototype,"_allLayerAndSubLayerViews",null),e.SliceController=i.__decorate([c.subclass("esri.views.3d.analysis.Slice.SliceController")],e.SliceController);const v=new Map;let _=!1;function g(e){const i=f(e),a=i?.activeController;null!=a?.analysisViewData.plane&&a.analysisViewData.visible?e.slicePlane=a.analysisViewData.plane:e.slicePlane=null}function S(e,i){v.has(e)||v.set(e,{all:[],activeController:null}),v.get(e)?.all.push(i)}function f(e){return v.get(e)}function V(e,i){if(!v.has(e))throw new Error("view expected in global slice register");const a=v.get(e),l=a?.all.lastIndexOf(i)??-1;if(!a||-1===l)throw new Error("controller expected in global slice register");a.all.splice(l,1),0===a.all.length&&v.delete(e)}Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
