/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../geometry","../../../../analysis/SlicePlane","../../../../core/has","../../../../core/Logger","../../../../core/mathUtils","../../../../core/screenUtils","../../../../core/libs/gl-matrix-2/math/mat4","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../geometry/projection","../../../../geometry/support/Axis","../../../../chunks/boundedPlane","../../../../geometry/support/plane","../../../../geometry/support/ray","../../../../geometry/support/vector","../../../../geometry/support/vectorStacks","./settings","./sliceToolConfig","../support/projectionUtils","../../interactive/manipulatorUtils","../../interactive/visualElements/LineVisualElement","../../interactive/visualElements/SlicePlaneVisualElement","../../support/RenderCoordsHelper","../../support/geometryUtils/ray","../../webgl-engine/lib/Material","../../../interactive/interfaces","../../../../geometry/Point","../../../../geometry/Extent"],(function(e,t,i,n,s,o,r,a,l,c,d,u,g,p,b,m,f,h,v,T,R,A,I,P,S,E,O,y,V){"use strict";function w(e,t,i,n,s,o,r,a){return L(t,r.worldUpAtPosition(e,f.sv3d.get()),s,o,a.basis1,a.basis2),l.scale(a.basis1,a.basis1,i),l.scale(a.basis2,a.basis2,n),l.copy(a.origin,e),p.fromVectorsAndPoint(a.basis2,a.basis1,a.origin,a.plane),a}function L(t,i,n,s,o,r){const a=l.dot(t,i),c=f.sv3d.get(),d=f.sv3d.get();switch(s===e.SliceOrientation.HORIZONTAL_OR_VERTICAL?Math.abs(a)>v.verticalDotThreshold?e.SliceOrientation.HORIZONTAL:e.SliceOrientation.VERTICAL:s){case e.SliceOrientation.VERTICAL:{const e=Math.abs(a)<=v.smallAngleDotThreshold?t:n.viewUp;l.cross(c,e,i),l.copy(d,i);break}case e.SliceOrientation.HORIZONTAL:l.cross(c,n.viewUp,i),l.cross(d,i,c);break;case e.SliceOrientation.TILTED:{const e=Math.abs(a)<=v.smallAngleDotThreshold?i:n.viewUp;l.cross(c,e,t),l.cross(d,t,c);break}}const u=l.cross(f.sv3d.get(),c,d);l.dot(u,n.viewForward)>0&&l.scale(d,d,-1),l.normalize(o,c),l.normalize(r,d)}function C(e,t,i){const n=t.worldUpAtPosition(e.origin,f.sv3d.get()),s=e.basis1,o=K(e,n),r=Math.round(o/le)*le;return g.rotate(e,r-o,s,i)}function H(e,t,i,n,s,o){const r=l.copy(f.sv3d.get(),s.origin);l.add(r,r,l.scale(f.sv3d.get(),s.basis1,e.direction[0]<0?1:-1)),l.add(r,r,l.scale(f.sv3d.get(),s.basis2,e.direction[1]<0?1:-1));const a=l.length(s.basis1),c=l.length(s.basis2),d=l.subtract(f.sv3d.get(),i,r),u=l.subtract(f.sv3d.get(),t,r);let p=0,b=0;if(Y(e)){const t=B(s),i=B(o);p=a-.5*e.direction[0]*l.dot(s.basis1,u)/a,b=c-.5*e.direction[1]*l.dot(s.basis2,u)/c;const n=i/t;p*=n,b*=n}const m=p+.5*e.direction[0]*l.dot(s.basis1,d)/a,h=b+.5*e.direction[1]*l.dot(s.basis2,d)/c,T=l.scale(f.sv3d.get(),s.basis1,m/a),R=l.scale(f.sv3d.get(),s.basis2,h/c);(m<=0||X(o.origin,T,n)<=v.planeMinBasisScreenLen2)&&l.copy(T,o.basis1),(h<=0||X(o.origin,R,n)<=v.planeMinBasisScreenLen2)&&l.copy(R,o.basis2);const A=l.copy(f.sv3d.get(),r);return l.add(A,A,l.scale(f.sv3d.get(),T,e.direction[0]<0?-1:1)),l.add(A,A,l.scale(f.sv3d.get(),R,e.direction[1]<0?-1:1)),g.fromValues(A,T,R,o)}function M(e,t){return v.initialPlaneHalfSizeViewProportion*Math.min(t.width,t.height)*t.computeRenderPixelSizeAt(e)}function x(e,t,i,n){const s=l.cross(f.sv3d.get(),t,i);return l.cross(s,s,t),p.fromPositionAndNormal(e,s,n)}function _(e,t){return R.calculateTranslateRotateFromBases(e.basis1,e.basis2,e.origin,t)}function N(t,i,n,s){const o=i.worldUpAtPosition(t.origin,f.sv3d.get()),r=f.sv3d.get();switch(n){case e.RotationAxis.HEADING:l.copy(r,o);break;case e.RotationAxis.TILT:l.copy(r,t.basis1)}return p.fromPositionAndNormal(t.origin,r,s)}function z(e,t,i,n){const s=Z(i,G.NEGATIVE_X),o=f.sm4d.get();a.rotateZ(o,t,s.edge*Math.PI/2);const d=l.normalize(f.sv3d.get(),s.basis);let u=l.scale(f.sv3d.get(),d,s.direction*n.computeScreenPixelSizeAt(s.position)*v.shiftRestartOffsetDistance);l.add(u,u,s.position);const p=n.projectToRenderScreen(u,r.castRenderScreenPointArray3(f.sv3d.get())),b=U(n,p);S.fromRender(n,p,ae),l.normalize(ae.direction,ae.direction);const m=f.sv3d.get();!b&&g.intersectRay(i,ae,m)&&(u=m),o[12]=0,o[13]=0,o[14]=0,e.modelTransform=o,e.renderLocation=c.clone(u),b?e.state|=re:e.state&=~re}function U(e,t){const[i,n,s,o]=e.viewport,r=Math.min(s,o)/16;let a=!0;return t[0]<i+r?(t[0]=i+r,a=!1):t[0]>i+s-r&&(t[0]=i+s-r,a=!1),t[1]<n+r?(t[1]=n+r,a=!1):t[1]>n+o-r&&(t[1]=n+o-r,a=!1),a}function D(e,t,i,n){const s=l.length(n.basis1),o=l.length(n.basis2),r=k(n),c=B(n),d=l.set(f.sv3d.get(),0,0,0);l.add(d,l.scale(f.sv3d.get(),n.basis1,t.direction[0]),l.scale(f.sv3d.get(),n.basis2,t.direction[1])),l.add(d,n.origin,d);let u=0,g=1;if(Y(t))1===t.direction[0]&&-1===t.direction[1]?u=le:1===t.direction[0]&&1===t.direction[1]?u=Math.PI:-1===t.direction[0]&&1===t.direction[1]&&(u=3*Math.PI/2),g=c;else{const e=0!==t.direction[0]?1:2;u=1===e?le:0,g=(1===e?o:s)-r}const p=a.fromZRotation(f.sm4d.get(),u);a.scale(p,p,l.set(f.sv3d.get(),g,g,g)),a.multiply(p,i,p),p[12]=0,p[13]=0,p[14]=0,e.modelTransform=p,e.renderLocation=d}function F(e,t,i,n){const s=n.worldUpAtPosition(i.origin,f.sv3d.get()),o=Z(i,G.POSITIVE_X),r=a.fromZRotation(f.sm4d.get(),o.edge*Math.PI/2);a.rotateX(r,r,-K(i,s)),a.multiply(r,t,r),r[12]=0,r[13]=0,r[14]=0,e.modelTransform=r,e.renderLocation=o.position}function j(e,t,i){const n=Z(i,G.POSITIVE_Y),s=a.fromZRotation(f.sm4d.get(),n.edge*Math.PI/2);a.rotateX(s,s,le),a.multiply(s,t,s),s[12]=0,s[13]=0,s[14]=0,e.modelTransform=s,e.renderLocation=n.position}var G;function Z(e,t){switch(t){case G.POSITIVE_X:return{basis:e.basis1,direction:1,position:l.add(f.sv3d.get(),e.origin,e.basis1),edge:t};case G.POSITIVE_Y:return{basis:e.basis2,direction:1,position:l.add(f.sv3d.get(),e.origin,e.basis2),edge:t};case G.NEGATIVE_X:return{basis:e.basis1,direction:-1,position:l.subtract(f.sv3d.get(),e.origin,e.basis1),edge:t};case G.NEGATIVE_Y:return{basis:e.basis2,direction:-1,position:l.subtract(f.sv3d.get(),e.origin,e.basis2),edge:t}}}function X(e,t,i){const n=i.projectToRenderScreen(l.add(f.sv3d.get(),e,t),r.castRenderScreenPointArray3(f.sv3d.get())),s=i.projectToRenderScreen(l.subtract(f.sv3d.get(),e,t),r.castRenderScreenPointArray3(f.sv3d.get()));return l.squaredLength(l.subtract(n,n,s))}function k(e){const t=l.length(e.basis1),i=l.length(e.basis2);return v.resizeHandleEdgePaddingFrac*Math.min(t,i)}function B(e){return k(e)}function Y(e){return 0!==e.direction[0]&&0!==e.direction[1]}function W(e){const t=[[-1,-1,0],[1,-1,0],[1,1,0],[-1,1,0],[-1,-1,0]];return new A.LineVisualElement({view:e,attached:!1,color:h.getOutlineColor(e.effectiveTheme),width:v.planeOutlineWidth,renderOccluded:E.RenderOccludedFlag.OccludeAndTransparent,geometry:[t],isDecoration:!0})}function q(e){return new I.SlicePlaneVisualElement({view:e,attached:!1,backgroundColor:h.planeColor,gridColor:h.getGridColor(e.effectiveTheme),gridWidth:4,renderOccluded:E.RenderOccludedFlag.OccludeAndTransparent,isDecoration:!0})}function $(e,t,n,s=new i){if(null==e)return null;const{renderCoordsHelper:r}=t,a=r.fromRenderCoords(e.origin,new y({spatialReference:t.spatialReference}));if(null==a)return null;const c=d.tryProjectWithZConversion(a,n);if(null==c)return null;s.position=c;const u=2*l.length(e.basis1),g=2*l.length(e.basis2),p=P.RenderCoordsHelper.renderUnitScaleFactor(t.spatialReference,n);s.width=u*p,s.height=g*p;const b=r.worldUpAtPosition(e.origin,f.sv3d.get());return s.tilt=o.rad2deg(K(e,b)),s.heading=r.headingAtPosition(e.origin,e.basis1)-90,s}function J(e,t,i){if(null==e)return null;const n=e.origin,s=f.sv3d.get(),o=f.sv3d.get(),r=f.sv3d.get(),a=f.sv3d.get();let c,d,u,g,p,b;l.add(s,n,e.basis1),l.add(s,s,e.basis2),l.add(o,n,e.basis1),l.sub(o,o,e.basis2),l.sub(r,n,e.basis1),l.sub(r,r,e.basis2),l.sub(a,n,e.basis1),l.add(a,a,e.basis2);for(const l of[s,o,r,a]){const e=t.fromRenderCoords(l,l,i);if(null==e)return null;c=null==c?e[0]:Math.min(c,e[0]),d=null==d?e[0]:Math.max(d,e[0]),u=null==u?e[1]:Math.min(u,e[1]),g=null==g?e[1]:Math.max(g,e[1]),p=null==p?e[2]:Math.min(p,e[2]),b=null==b?e[2]:Math.max(b,e[2])}return new V({xmin:c,xmax:d,ymin:u,ymax:g,zmin:p,zmax:b,spatialReference:i})}function K(e,t){return m.angleAroundAxis(t,e.basis2,e.basis1)+le}function Q(e,t,i,n,r,a,c=g.create()){return a.toRenderCoords(e,c.origin)?(a.worldBasisAtPosition(c.origin,u.Axis.X,c.basis1),a.worldBasisAtPosition(c.origin,u.Axis.Y,c.basis2),p.fromVectorsAndPoint(c.basis2,c.basis1,c.origin,c.plane),g.rotate(c,-o.deg2rad(t),g.normal(c),c),g.rotate(c,o.deg2rad(i),c.basis1,c),l.scale(c.basis1,c.basis1,n/2),l.scale(c.basis2,c.basis2,r/2),g.updateUnboundedPlane(c),c):(s.getLogger("esri.views.3d.analysis.Slice.sliceToolUtils").error(`Failed to project slice plane position, projection from ${e.spatialReference.wkid} is not supported`),null)}function ee(e,t){if(null==e?.position)return null;const i=T.applyProjectionAndElevationAlignment(e.position,t.spatialReference,t.elevationProvider);if(null==i)return null;const n=P.RenderCoordsHelper.renderUnitScaleFactor(e.position.spatialReference,t.spatialReference),s=e.width*n,o=e.height*n;return{position:i,heading:e.heading,tilt:e.tilt,renderWidth:s,renderHeight:o}}function te(e,t,i,n=g.create()){const s=ee(e,t);return null==s?null:ie(s,t,i,n)}function ie(e,t,i,n=g.create()){if(null==e)return null;const s=Q(e.position,e.heading,e.tilt,e.renderWidth,e.renderHeight,t.renderCoordsHelper,n);return i.tiltEnabled||null==s||C(s,t.renderCoordsHelper,s),s}!function(e){e[e.POSITIVE_X=0]="POSITIVE_X",e[e.POSITIVE_Y=1]="POSITIVE_Y",e[e.NEGATIVE_X=2]="NEGATIVE_X",e[e.NEGATIVE_Y=3]="NEGATIVE_Y"}(G||(G={}));const ne=O.ManipulatorStateCustomFlags.Custom1;var se,oe;e.RotationAxis=void 0,(se=e.RotationAxis||(e.RotationAxis={}))[se.HEADING=1]="HEADING",se[se.TILT=2]="TILT",e.SliceOrientation=void 0,(oe=e.SliceOrientation||(e.SliceOrientation={}))[oe.HORIZONTAL_OR_VERTICAL=0]="HORIZONTAL_OR_VERTICAL",oe[oe.HORIZONTAL=1]="HORIZONTAL",oe[oe.VERTICAL=2]="VERTICAL",oe[oe.TILTED=3]="TILTED";const re=O.ManipulatorStateCustomFlags.Custom2,ae=b.create(),le=Math.PI/2,ce=O.ManipulatorStateCustomFlags.Custom1,de=O.ManipulatorStateCustomFlags.Custom2;function ue(e){return null!=("building-scene-3d"===e.type?e:null)}e.DidPointerMoveRecentlyFlag=ne,e.IsShiftEdgeOnScreenFlag=re,e.calculateBoundedPlaneTranslateRotate=_,e.calculateDiagonalResizeHandleScale=B,e.calculatePlaneHalfSize=M,e.createGridVisualElement=q,e.createOutlineVisualElement=W,e.createPlane=w,e.createRotatePlane=N,e.createShiftPlane=x,e.forceHorizontalOrVertical=C,e.isDiagonalResizeHandle=Y,e.isIBuildingSceneLayerView3D=ue,e.normalToBases=L,e.planeToExtent=J,e.planeToShape=$,e.projectAndElevationAlignShape=ee,e.projectedShapeToPlane=ie,e.resizeNormal=ce,e.resizeOutlineOnly=de,e.resizePlane=H,e.shapeToPlane=te,e.updateResizeHandle=D,e.updateRotateHeadingHandle=F,e.updateRotateTiltHandle=j,e.updateShiftRestartHandle=z,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
