/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../Color","../../../../core/Handles","../../../../core/handleUtils","../../../../core/mathUtils","../../../../core/maybe","../../../../core/reactiveUtils","../../../../core/libs/gl-matrix-2/math/mat4","../../../../core/libs/gl-matrix-2/factories/mat4f64","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../chunks/boundedPlane","./ViewshedConfiguration","./viewshedToolUtils","../../interactive/Manipulator3D","../../interactive/RenderObject","../../interactive/editingTools/ManipulatorType","../../interactive/editingTools/manipulations/InteractiveManipulation","../../webgl-engine/lib/GeometryUtil","../../webgl-engine/lib/Material","../../webgl-engine/lib/Util","../../webgl-engine/materials/RibbonLineMaterial","../../../interactive/dragEventPipeline","../../../interactive/interfaces"],(function(t,e,a,i,r,n,o,l,s,c,u,d,p,h,f,m,g,M,b,_,v,w,A,V){"use strict";class y extends M.InteractiveManipulation{constructor(t){super(),this._handles=new a,this._tool=t.tool,this._view=t.view,this._focusedArcMaterial=this._createArcMaterial(!0),this._unfocusedArcMaterial=this._createArcMaterial(!1),this._createManipulators(),this.forEachManipulator((t=>this._tool.manipulators.add(t)))}destroy(){this._handles=n.destroyMaybe(this._handles),this.forEachManipulator((t=>{this._tool.manipulators.remove(t),t.destroy()})),this._tool=null,this._view=null,this._manipulators=null}createDragPipeline(t,e){const a=Object.values(this._manipulators);return i.handlesGroup(a.map((({manipulator:a,side:i})=>A.createManipulatorDragEventPipeline(a,((a,r,n,o,l)=>{const s=F(i,e),c=r.next((t=>({...t,manipulatorType:g.ManipulatorType.SCALE,side:i}))),u=h.screenToCircleAngle(c,this._view,s,e);t(a,u,n)})))))}updateManipulatorsTransform(t){t.arcCentersPoints(D),this._forEachManipulatorInfo((e=>this._updateArcManipulatorTransform(e,t,D[e.side])))}updateManipulatorVisuals(t){this._forEachManipulatorInfo((e=>this._updateArcManipulatorVisuals(e,t)))}_updateArcManipulatorVisuals({manipulator:t,side:e},a){const i=[];if(null!=a){const[r,n]=R(e,a,this._unfocusedArcMaterial);i.push(new m.RenderObject(r,V.ManipulatorStateFlags.Unfocused),new m.RenderObject(r.instantiate({material:this._focusedArcMaterial}),V.ManipulatorStateFlags.Focused)),t.collisionType={type:"line",paths:[n]}}t.renderObjects=i,t.radius=p.viewshedToolManipulatorConfiguration.collisionRadius}_updateArcManipulatorTransform({manipulator:t,side:e},a,i){const n=a.horizontalFieldOfView,o=r.deg2rad(a.verticalFieldOfView/2),u=r.deg2rad(n/2),d=E(e);t.renderLocation=i;const p=s.create(),f=t=>{l.multiply(p,t,p)};f(l.fromYRotation(j,r.deg2rad(-90))),d||f(l.fromXRotation(j,o));const m=a.farDistanceRenderSpace;let g,M;f(l.fromScaling(j,c.set(C,m,m,m))),f(l.fromZRotation(j,S(e))),f(h.getViewshedRotationMatrix(a,j)),d?(g=u,M=a.tiltedUpVector):(M=a.rightVector,g=o),g*="right"===e||"bottom"===e?-1:1;const b=l.fromRotation(j,g,M);null!=b&&f(b),t.modelTransform=p}_createManipulators(){const t=this._createArcManipulator("left"),e=this._createArcManipulator("right"),a=this._createArcManipulator("top"),i=this._createArcManipulator("bottom");this._manipulators={left:t,right:e,top:a,bottom:i};[[i.manipulator,a.manipulator],[t.manipulator,e.manipulator]].forEach((([t,e])=>{t.metadata={pairedManipulator:e},e.metadata={pairedManipulator:t}}))}_createArcManipulator(t){const e=new f.Manipulator3D({view:this._view,autoScaleRenderObjects:!1,worldSized:!0}),a={manipulator:e,side:t};return this._updateArcManipulatorVisuals(a),this._handles.add(e.events.on("focus-changed",(t=>{const a=e.metadata?.pairedManipulator;null!=a&&(a.hovering!==e.hovering&&(a.hovering=e.hovering),a.grabbing!==e.grabbing&&(a.grabbing=e.grabbing))}))),a}_createArcMaterial(t){const a=p.viewshedToolManipulatorConfiguration.getFovArcWidth(t),i=new w.RibbonLineMaterial({renderOccluded:_.RenderOccludedFlag.OccludeAndTransparent,isDecoration:!0,width:a});return this._handles.add(o.watch((()=>e.toUnitRGBA(this._view.effectiveTheme.accentColor)),(t=>i.setParameters({color:t})),o.initial)),i}forEachManipulator(t){Object.values(this._manipulators).forEach((({manipulator:e})=>t(e,g.ManipulatorType.SCALE)))}_forEachManipulatorInfo(t){Object.values(this._manipulators).forEach((e=>t(e)))}get test(){return{manipulators:this._manipulators}}}function R(t,e,a){const{horizontalFieldOfView:i,verticalFieldOfView:n}=e,o=E(t),l=(o?n:i)/2,s=r.deg2rad(r.clamp(l,0,15)),c=T(-s/2,s/2,o?1:Math.max(Math.sin(r.deg2rad(90-n/2)),.1));return[b.createPolylineGeometry(a,c),c]}function T(t,e,a,i=10){v.assert(i>1,"createArcPolylineGeometry() needs at least 2 for numVertices");const r=e-t;if(r<=0||a<=0){const t=.01;return[u.fromValues(0,0,t),u.fromValues(0,0,-t)]}const n=[],o=r/i;for(let l=0;l<i;l++){let r=t+l*o;l===i-1&&(r=e);const s=Math.cos(r)*a,c=Math.sin(r)*a,d=u.fromValues(s-a,0,c);n.push(d)}return n}function O(t){switch(t){case"left":return 0;case"bottom":return 1;case"right":return 2;case"top":return 3}}function S(t){return O(t)*U}function E(t){return"left"===t||"right"===t}function P(t){return"left"===t?"right":"right"===t?"left":"top"===t?"bottom":"top"}function F(t,{observerRenderSpace:e,targetRenderSpace:a,tiltedUpVector:i,rightVector:r,farDistanceRenderSpace:n}){const o=c.sub(C,a,e),l=E(t)?r:i,s=c.scale(x,l,n);return d.fromValues(e,o,s)}const U=Math.PI/2,j=s.create(),C=u.create(),x=u.create(),D={top:u.create(),bottom:u.create(),left:u.create(),right:u.create()};t.FieldOfViewManipulation=y,t.createArcPolylineVertices=T,t.flipSide=P,t.isSideHorizontal=E,t.sideToRad=S,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
