/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../chunks/tslib.es6","../../../../geometry","../../../../core/Accessor","../../../../core/mathUtils","../../../../core/accessorSupport/decorators/property","../../../../core/has","../../../../core/Logger","../../../../core/RandomLCG","../../../../core/accessorSupport/decorators/subclass","../../../../core/libs/gl-matrix-2/factories/mat4f64","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","./viewshedToolUtils","../../../../geometry/Point"],(function(e,t,r,o,a,i,s,p,d,n,c,h,l,u,V){"use strict";var y;e.ViewshedComputedData=y=class extends o{constructor(e){super(e),this.observerRenderSpaceOverride=null}get observer(){return this.viewshed.observer??new V}get effectiveObserverRenderSpace(){return this.observerRenderSpaceOverride??this.observerRenderSpace}get effectiveObserver(){return this.renderSpaceToPoint(this.effectiveObserverRenderSpace,this.observer.spatialReference)}get effectiveTargetRenderSpace(){return this._computeTargetRenderSpace(this.effectiveObserverRenderSpace)}get farDistance(){return this.viewshed.farDistance}get farDistanceRenderSpace(){return this.farDistance/this.metersPerUnit}get heading(){return this.viewshed.heading}get tilt(){return this.viewshed.tilt}get feature(){return this.viewshed.feature}get tiltParallelToSurface(){return this.tilt-90}get horizontalFieldOfView(){return this.viewshed.horizontalFieldOfView}get verticalFieldOfView(){return this.viewshed.verticalFieldOfView}get observerRenderSpace(){return this._pointToRenderSpace(this.observer,l.create())}get target(){const e=this.targetRenderSpace;return this.renderSpaceToPoint(e,this.observer.spatialReference)}get targetRenderSpace(){return this._computeTargetRenderSpace(this.observerRenderSpace)}get targetDirection(){const e=h.sub(l.create(),this.targetRenderSpace,this.observerRenderSpace);return h.normalize(e,e)}get tiltedUpVector(){const e=u.rotateBy(l.create(),this.upVector,-a.deg2rad(this.tiltParallelToSurface),this.leftVector);return h.normalize(e,e)}get _basis(){return this.renderCoordsHelper.basisMatrixAtPosition(this.observerRenderSpace,c.create())}get upVector(){const e=this._basis;return l.fromValues(e[8],e[9],e[10])}get northVector(){const e=this._basis;return l.fromValues(e[4],e[5],e[6])}get leftVector(){const e=this.upVector,t=u.rotateBy(l.create(),this.northVector,-a.deg2rad(this.heading),e);return h.cross(t,e,t)}get rightVector(){return h.negate(l.create(),this.leftVector)}clone(){return new y({renderCoordsHelper:this.renderCoordsHelper,viewshed:this.viewshed.clone()})}isValid(){return this.viewshed.isValid()}get metersPerUnit(){return this.renderCoordsHelper.spatialReference.metersPerUnit}pointOnSphere(e,t,r){const{observerRenderSpace:o,targetRenderSpace:i}=this,s=h.sub(f,i,o);return u.rotateBy(s,s,-a.deg2rad(t),this.leftVector),u.rotateBy(s,s,-a.deg2rad(e),this.tiltedUpVector),h.add(r,s,o)}cornerPoints(e){const t=this.horizontalFieldOfView/2,r=this.verticalFieldOfView/2;this.pointOnSphere(-t,r,e.topLeft),this.pointOnSphere(t,r,e.topRight),this.pointOnSphere(-t,-r,e.bottomLeft),this.pointOnSphere(t,-r,e.bottomRight)}arcCentersPoints(e){const t=this.horizontalFieldOfView/2,r=this.verticalFieldOfView/2;this.pointOnSphere(0,r,e.top),this.pointOnSphere(0,-r,e.bottom),this.pointOnSphere(-t,0,e.left),this.pointOnSphere(t,0,e.right)}parallelCenterPoints(e){const t=this.observerRenderSpace,r=this.farDistanceRenderSpace*Math.sin(a.deg2rad(this.verticalFieldOfView/2)),o=h.scale(f,this.tiltedUpVector,r);h.add(e.top,t,o),h.sub(e.bottom,t,o)}renderSpaceToPoint(e,t){const r=f;return this.renderCoordsHelper.fromRenderCoords(e,r,t),new V(r[0],r[1],r[2],t)}_pointToRenderSpace(e,t){const r=l.fromArray(e.toArray());return this.renderCoordsHelper.toRenderCoords(r,e.spatialReference,t),t}_computeTargetRenderSpace(e){const{leftVector:t,northVector:r,upVector:o}=this,i=this.farDistanceRenderSpace,s=l.create();return h.scale(s,r,i),u.rotateBy(s,s,-a.deg2rad(this.heading),o),u.rotateBy(s,s,-a.deg2rad(this.tiltParallelToSurface),t),h.add(s,e,s),s}},t.__decorate([i.property()],e.ViewshedComputedData.prototype,"renderCoordsHelper",void 0),t.__decorate([i.property()],e.ViewshedComputedData.prototype,"viewshed",void 0),t.__decorate([i.property()],e.ViewshedComputedData.prototype,"observerRenderSpaceOverride",void 0),t.__decorate([i.property()],e.ViewshedComputedData.prototype,"observer",null),t.__decorate([i.property()],e.ViewshedComputedData.prototype,"effectiveObserverRenderSpace",null),t.__decorate([i.property()],e.ViewshedComputedData.prototype,"effectiveObserver",null),t.__decorate([i.property()],e.ViewshedComputedData.prototype,"effectiveTargetRenderSpace",null),t.__decorate([i.property()],e.ViewshedComputedData.prototype,"farDistance",null),t.__decorate([i.property()],e.ViewshedComputedData.prototype,"farDistanceRenderSpace",null),t.__decorate([i.property()],e.ViewshedComputedData.prototype,"heading",null),t.__decorate([i.property()],e.ViewshedComputedData.prototype,"tilt",null),t.__decorate([i.property()],e.ViewshedComputedData.prototype,"feature",null),t.__decorate([i.property()],e.ViewshedComputedData.prototype,"tiltParallelToSurface",null),t.__decorate([i.property()],e.ViewshedComputedData.prototype,"horizontalFieldOfView",null),t.__decorate([i.property()],e.ViewshedComputedData.prototype,"verticalFieldOfView",null),t.__decorate([i.property()],e.ViewshedComputedData.prototype,"observerRenderSpace",null),t.__decorate([i.property()],e.ViewshedComputedData.prototype,"target",null),t.__decorate([i.property()],e.ViewshedComputedData.prototype,"targetRenderSpace",null),t.__decorate([i.property()],e.ViewshedComputedData.prototype,"targetDirection",null),t.__decorate([i.property()],e.ViewshedComputedData.prototype,"tiltedUpVector",null),t.__decorate([i.property()],e.ViewshedComputedData.prototype,"_basis",null),t.__decorate([i.property()],e.ViewshedComputedData.prototype,"upVector",null),t.__decorate([i.property()],e.ViewshedComputedData.prototype,"northVector",null),t.__decorate([i.property()],e.ViewshedComputedData.prototype,"leftVector",null),t.__decorate([i.property()],e.ViewshedComputedData.prototype,"rightVector",null),t.__decorate([i.property()],e.ViewshedComputedData.prototype,"isValid",null),t.__decorate([i.property()],e.ViewshedComputedData.prototype,"metersPerUnit",null),e.ViewshedComputedData=y=t.__decorate([n.subclass("esri.views.3d.analysis.Viewshed.ViewshedComputedData")],e.ViewshedComputedData);const f=l.create();Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
