/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../chunks/tslib.es6","../../../../core/Accessor","../../../../core/arrayUtils","../../../../core/asyncUtils","../../../../core/Cyclical","../../../../core/handleUtils","../../../../core/has","../../../../core/mathUtils","../../../../core/maybe","../../../../core/promiseUtils","../../../../core/reactiveUtils","../../../../core/accessorSupport/decorators/property","../../../../core/Logger","../../../../core/accessorSupport/decorators/subclass","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../geometry/projection","../../../ViewingMode","./FieldOfViewManipulation","./ScaleOrientManipulation","./ViewshedConfiguration","./viewshedToolManipulatorUtils","../../interactive/editingTools/manipulations/config","../../interactive/editingTools/manipulations/MoveManipulation","../../../interactive/dragEventPipeline","../../../interactive/editGeometry/EditGeometryOperations"],(function(e,i,t,a,o,n,r,s,l,u,d,h,c,p,v,b,g,M,_,w,f,m,V,y,O,T,D){"use strict";const S=Symbol("dragHandles"),H=Symbol("hideManipulators"),C=Symbol("hideFoVManipulators"),F=Symbol("hideObserverManipulator");e.ViewshedSubTool=class extends t{constructor(e){super(e),this._moveManipulation=null,this._observerManipulator=null,this._fieldOfViewManipulation=null,this._scaleOrientManipulation=null,this._forceHoveringTask=null,this._forceHoveringTestPromise=null,this._grabbing=!1,this.viewshedComputedData=null}initialize(){this._moveManipulation=this._createMoveManipulation(),this._fieldOfViewManipulation=new w.FieldOfViewManipulation({view:this.view,tool:this.parentTool}),this._scaleOrientManipulation=new f.ScaleOrientManipulation({view:this.view,tool:this.parentTool}),this._observerManipulator=new V.ViewshedObserverManipulator(this.view,this.parentTool),this.addHandles([h.watch((()=>this.viewshedComputedData?.observerRenderSpace),(e=>{null!=e&&(this._moveManipulation.renderLocation=e,this._observerManipulator.renderLocation=e)}),h.syncAndInitial),h.watch((()=>this.viewshedComputedData?.heading),(e=>{e&&(this._moveManipulation.angle=l.deg2rad(90-e))}),h.initial),h.watch((()=>{const{viewshedComputedData:e}=this;return{viewshedComputedData:e,observer:e?.observer}}),(({viewshedComputedData:e,observer:i},t)=>{this._grabbing&&i!==t?.observer||(this.removeHandles(S),e?.isValid()&&this.addHandles([this._buildObserverDragPipeline(e),this._buildFOVDragPipeline(e),this._buildScaleOrientDragPipeline(e)].filter(a.isSome),S))}),h.initial),h.watch((()=>{const e=this.viewshedComputedData;return e?.isValid()?{viewshedCompData:e,target:e.targetRenderSpace,hFOV:e.horizontalFieldOfView,vFOV:e.verticalFieldOfView}:null}),(e=>{null!=e&&this._fieldOfViewManipulation.updateManipulatorsTransform(e.viewshedCompData)}),h.initial),h.watch((()=>{const e=this.viewshedComputedData;return e?.isValid()?{viewshedCompData:e,hFOV:e.horizontalFieldOfView,vFOV:e.verticalFieldOfView,tilt:e.tilt}:null}),(e=>{null!=e&&this._fieldOfViewManipulation.updateManipulatorVisuals(e.viewshedCompData)}),h.initial),h.watch((()=>{const e=this.analysisViewData.visible&&(this.viewshedComputedData?.isValid()??!1),i=this.parentTool.selectedViewshedComputedData===this.viewshedComputedData;return{fovManipulationAvailable:e&&!this.parentTool.isPlacingTarget,nonFOVManipulationAvailable:e&&(!this.parentTool.creating||i)}}),(({fovManipulationAvailable:e,nonFOVManipulationAvailable:i})=>{this._moveManipulation.available=i,this._scaleOrientManipulation.available=i,this._observerManipulator.available=i,this._fieldOfViewManipulation.available=e}),h.initial),h.watch((()=>{const e=this.viewshedComputedData;if(!e?.isValid())return null;const{observer:i,target:t,verticalFieldOfView:a,horizontalFieldOfView:o}=e;return{viewshedCompData:e,observer:i,target:t,verticalFieldOfView:a,horizontalFieldOfView:o}}),(e=>{null!=e&&this._scaleOrientManipulation.updateManipulators(e.viewshedCompData)}),h.initial)]);const e=e=>{const i=this.analysisViewData;this.addHandles([e.events.on("focus-changed",(()=>{const e=this._someManipulatorHovering();e&&this.parentTool.subToolHandles.forEach((({subTool:e})=>{e._resetHoveringTask()})),this._someManipulatorSelected()||e||(this._forceHoveringTask=o.createTask((async e=>{await(this._forceHoveringTestPromise??d.after(m.viewshedToolManipulatorConfiguration.hoverTimeoutMilliseconds,e)),d.throwIfAborted(e),this._forceHoveringTask=null,this._updateManipulatorVisibility()})))})),e.events.on("grab-changed",(t=>{this._grabbing="start"===t.action,"end"===t.action&&i.tool?.updateInteractionVisualsVisibility(),this.parentTool.subToolHandles.forEach((({subTool:e})=>{e!==this&&e._setInteractive(!this._grabbing)})),this._setInteractive((i=>i.hasManipulator(e)||!this._grabbing))})),e.events.on("drag",(e=>{"start"===e.action&&i.tool?.updateInteractionVisualsVisibility()}))])};this._forEachManipulator(e)}destroy(){this._forceHoveringTask=u.abortMaybe(this._forceHoveringTask),this._moveManipulation=u.destroyMaybe(this._moveManipulation),this._fieldOfViewManipulation=u.destroyMaybe(this._fieldOfViewManipulation),this._scaleOrientManipulation=u.destroyMaybe(this._scaleOrientManipulation),this.parentTool.manipulators.remove(this._observerManipulator),this._observerManipulator=u.destroyMaybe(this._observerManipulator)}get viewshed(){return this.viewshedComputedData?.viewshed}get grabbing(){return this._grabbing}get observer(){return this.viewshed?.observer}set observer(e){const i=this.viewshed;null!=i&&(i.observer=e)}get discManipulator(){return this._moveManipulation.xyManipulation.discManipulator}get moveInteractionState(){const{dragging:e,grabbing:i}=this._moveManipulation;return{dragging:e,grabbing:i}}get scaleOrientInteractionState(){const{dragging:e,grabbing:i}=this._scaleOrientManipulation;return{dragging:e,grabbing:i}}_setInteractive(e){const i="boolean"==typeof e;this._forEachManipulation((t=>t.interactive=i?e:e(t)))}onManipulatorSelectionChanged(){if(this._updateManipulatorVisibility(),!this._someManipulatorSelected()){this.analysisViewData.selectedViewshed===this.viewshed&&(this.analysisViewData.selectedViewshed=null),this._resetHoveringTask()}}hasManipulator(e){let i=!1;return this._forEachManipulator((t=>{i=i||t===e})),i}_someManipulatorSelected(){return this._moveManipulation.selected||this._fieldOfViewManipulation.selected||this._scaleOrientManipulation.selected}_someManipulatorHovering(){return this._moveManipulation.hovering||this._fieldOfViewManipulation.hovering||this._scaleOrientManipulation.hovering}_createMoveManipulation(){return new O.MoveManipulation({view:this.view,tool:this.parentTool,snapToScene:!1,xyAvailable:!0,xyAxisAvailable:!0,zAvailable:!0,radius:y.discRadiusSmall})}_buildObserverDragPipeline(e){const i={mode:"absolute-height",offset:0},t=e.observer;if(null==t)return null;const a=this.view.spatialReference;return this._moveManipulation.createDragPipeline(((e,i,o,n,r)=>{n=n.next(T.resetProperties(this,["observer"]));const s=M.tryProjectWithZConversion(t,a);if(null==s)return{steps:o,cancel:n};const l=D.EditGeometryOperations.fromGeometry(s,_.viewingModeFromString(this.view.viewingMode));return{steps:o.next(T.dragManipulatedObject({operations:l})).next((e=>(this.observer=l.data.geometry,e))),cancel:n}}),i,a,void 0)}_buildFOVDragPipeline(e){let i=0,t=0;return this._fieldOfViewManipulation.createDragPipeline(((a,o,r)=>{if(null==e)return{steps:o,cancel:r};const s=e.viewshed;let l=null;r=r.next(T.resetProperties(e,["horizontalFieldOfView","verticalFieldOfView"]));return{steps:o.next((a=>{if("start"===a.action)return l=null,i=e.horizontalFieldOfView,t=e.verticalFieldOfView,a;const o=a.deltaAngle;if(null==l&&0!==o){const e="bottom"===a.side||"left"===a.side?o>0:o<0;l=w.isSideHorizontal(a.side)?0===i&&e||360===i&&!e:0===t&&e}const r=l?w.flipSide(a.side):a.side;let u=0;switch(r){case"left":u=i/2-o;break;case"right":u=i/2+o;break;case"top":u=t+2*o;break;case"bottom":u=t-2*o}return w.isSideHorizontal(r)?(u=n.cyclicalDegrees.normalize(u),u=u>270?0:u>180?180:u,s.horizontalFieldOfView=2*u):s.verticalFieldOfView=u,a})),cancel:r}}),e)}_buildScaleOrientDragPipeline(e){let i=0,t=0;const a=(i,t)=>(a,o,n)=>{if(null==e)return{steps:o,cancel:n};const r=e.viewshed;return n=n.next(T.resetProperties(r,[i])),{steps:o=o.next(t(r,e)),cancel:n}};return r.handlesGroup([this._scaleOrientManipulation.createHeadingDragPipeline(a("heading",((i,a)=>a=>("start"===a.action&&(t=e.heading),i.heading=n.cyclicalDegrees.normalize(t+a.deltaAngle),a))),e),this._scaleOrientManipulation.createTiltDragPipeline(a("tilt",((t,a)=>a=>{"start"===a.action&&(i=e.tilt);let o=i+a.deltaAngle;return o<-90?o=180:o>270&&(o=0),t.tilt=k.clamp(o),a})),e),this._scaleOrientManipulation.createDistanceDragPipeline(a("farDistance",((e,i)=>t=>{const a=b.sub(P,t.renderEnd,i.observerRenderSpace),o=b.len(a)*i.metersPerUnit,n=b.dot(a,i.targetDirection)<0?m.viewshedToolManipulatorConfiguration.scaleOrientMinDistance:o;return e.farDistance=n,t})),e)])}_updateManipulatorVisibility(){const e=this._someManipulatorSelected(),i=null!=this._forceHoveringTask||this._someManipulatorHovering(),t=this._fieldOfViewManipulation.hovering,a=this.parentTool.creating;let o=[];const n=e=>{o.push(e.disableDisplay())};e||!a&&i?this.removeHandles(H):(this._scaleOrientManipulation.forEachManipulator(n),this._moveManipulation.forEachManipulator(n),this.addHandles(o,H),o=[]),e||!a&&i||a&&t?this.removeHandles(C):(this._fieldOfViewManipulation.forEachManipulator(n),this.addHandles(o,C)),e||!a?this.removeHandles(F):this.addHandles(this._observerManipulator.disableDisplay(),F)}_resetHoveringTask(){this._forceHoveringTask=u.abortMaybe(this._forceHoveringTask),this._updateManipulatorVisibility()}_forEachManipulator(e){this._forEachManipulation((i=>{i.forEachManipulator(e)})),e(this._observerManipulator)}_forEachManipulation(e){e(this._moveManipulation),e(this._fieldOfViewManipulation),e(this._scaleOrientManipulation)}get test(){return{moveManipulation:this._moveManipulation,fieldOfViewManipulation:this._fieldOfViewManipulation,scaleOrientManipulation:this._scaleOrientManipulation,viewshedComputedData:this.viewshedComputedData,setHoveringTimeoutPromise:e=>{this._forceHoveringTestPromise=e}}}},i.__decorate([c.property({constructOnly:!0})],e.ViewshedSubTool.prototype,"analysis",void 0),i.__decorate([c.property({constructOnly:!0})],e.ViewshedSubTool.prototype,"analysisViewData",void 0),i.__decorate([c.property({constructOnly:!0})],e.ViewshedSubTool.prototype,"parentTool",void 0),i.__decorate([c.property({constructOnly:!0,nonNullable:!0})],e.ViewshedSubTool.prototype,"view",void 0),i.__decorate([c.property()],e.ViewshedSubTool.prototype,"viewshed",null),i.__decorate([c.property()],e.ViewshedSubTool.prototype,"_grabbing",void 0),i.__decorate([c.property()],e.ViewshedSubTool.prototype,"grabbing",null),i.__decorate([c.property()],e.ViewshedSubTool.prototype,"viewshedComputedData",void 0),i.__decorate([c.property()],e.ViewshedSubTool.prototype,"observer",null),e.ViewshedSubTool=i.__decorate([v.subclass("esri.views.3d.analysis.Viewshed.ViewshedSubTool")],e.ViewshedSubTool);const P=g.create(),k=new n.Cyclical(0,180);Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
