/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../../chunks/tslib.es6","../../../../geometry","../../../../analysis/Viewshed","../../../../core/handleUtils","../../../../core/has","../../../../core/mathUtils","../../../../core/maybe","../../../../core/reactiveUtils","../../../../core/accessorSupport/decorators/property","../../../../core/Logger","../../../../core/RandomLCG","../../../../core/accessorSupport/decorators/subclass","../../../../core/libs/gl-matrix-2/factories/mat4f64","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../geometry/support/plane","./ViewshedConfiguration","./ViewshedSubTool","../../interactive/Manipulator3D","../../interactive/editingTools/settings","../../interactive/visualElements/ExtendedLineVisualElement","../../interactive/visualElements/LaserlineVisualElement","../../webgl-engine/lib/intersectorUtilsConversions","../../webgl-engine/lib/Material","../../../interactive/AnalysisToolBase","../../../interactive/keybindings","../../../interactive/ToolIntersector","../../../support/screenUtils","../../../../geometry/Point"],(function(e,t,i,s,a,n,o,r,l,c,d,h,u,p,g,_,w,v,y,V,b,m,S,f,T,D,C,M,P){"use strict";const H=Symbol("interactionVisuals");let I=class extends T.AnalysisToolBase{constructor(e){super(e),this.removeIncompleteOnCancel=!1,this.automaticManipulatorSelection=!1,this._stagedViewshed=null,this._stagedViewshedComputedData=null,this._creationState=!1,this._interactionVisualElements=null,this._settings=new V.Settings({getTheme:()=>this.view.effectiveTheme}),this._selectedManipulator=null}initialize(){this._intersector=C.newToolIntersector(this.view.state.viewingMode),this._createInteractionVisuals();const e=this.analysisViewData.viewshedComputedDataHandles;this.subToolHandles=r.mapCollection((()=>e),(({viewshedComputedData:e})=>{const t=new v.ViewshedSubTool({analysis:this.analysis,analysisViewData:this.analysisViewData,parentTool:this,view:this.view,viewshedComputedData:e});return{subTool:t,remove:()=>{this.selectedViewshed===e.viewshed&&(this.selectedViewshed=null),t.destroy()}}})),this.addHandles([r.watch((()=>e?.some((e=>e.viewshedComputedData.isValid()))),(e=>{e&&this.finishToolCreation()}),r.syncAndInitial),r.watch((()=>this._stagedViewshed),(e=>{const t=this.analysisViewData.viewshedComputedDataHandles;this._stagedViewshedComputedData=null!=e&&null!=t?this._findSubTool(e)?.viewshedComputedData:null}),r.syncAndInitial),r.watch((()=>this.firstGrabbedManipulator),(e=>{if(null!=e){const t=this._findSubTool(e)?.viewshed;this.selectedViewshed=t,this._selectManipulator(e)}else this._selectedSubTool?.onManipulatorSelectionChanged()}),r.sync),r.watch((()=>this.view.activeTool),(e=>{e!==this&&null!=e&&(this.selectedViewshed=null)})),r.when((()=>{const e=this.selectedViewshedComputedData;return null==e?null:{subTool:this._selectedSubTool,observer:e.observerRenderSpace,target:e.targetRenderSpace}}),(e=>{const{subTool:t,observer:i,target:s}=e;t?.moveInteractionState.dragging?this._updateInteractionVisualsLocation(i,!0):t?.scaleOrientInteractionState.dragging&&this._updateInteractionVisualsLocation(s,!1)}),r.initial),r.watch((()=>this.creating),(()=>this.updateInteractionVisualsVisibility())),r.watch((()=>this.selectedViewshed),(e=>{const t=this._selectedManipulator,i=this._selectedSubTool;null==e?this._selectManipulator(null):null!=t&&i.hasManipulator(t)||this._selectManipulator(i.discManipulator)}),r.initial)])}destroy(){this.subToolHandles=o.destroyMaybe(this.subToolHandles),this.removeHandles(H)}onDeactivate(){this.removeStaged(),this._creationState=!1}get cursor(){return this.creating?"crosshair":null}get _selectedSubTool(){return this._findSubTool(this.selectedViewshed)}_selectManipulator(e){const t=this._selectedManipulator;t!==e&&(this._selectedManipulator=e,null!=t&&(t.selected=!1),null!=e&&(e.selected=!0),this._findSubTool(t)?.onManipulatorSelectionChanged(),this._selectedSubTool?.onManipulatorSelectionChanged())}get selectedViewshed(){return this.analysisViewData.selectedViewshed}set selectedViewshed(e){this.analysisViewData.selectedViewshed=e}get selectedViewshedComputedData(){return this._selectedSubTool?.viewshedComputedData}get stagedViewshed(){return this._stagedViewshed}get grabbing(){return this.subToolHandles.some((({subTool:e})=>e.grabbing))}get creating(){return this._creationState&&this.active}get isPlacingTarget(){return"placing-target"===this._creationState}createViewsheds(){this.selectedViewshed=null,this._creationState="placing-observer"}onManipulatorSelectionChanged(){this.subToolHandles.forEach((e=>e.subTool.onManipulatorSelectionChanged()))}onInputEvent(e){switch(e.type){case"immediate-double-click":this._doubleClickHandler(e);break;case"pointer-move":this._pointerMoveHandler(e);break;case"key-down":D.sketchKeys.cancel===e.key?this._cancelKeyHandler(e):D.sketchKeys.delete.includes(e.key)&&this._deleteKeyHandler();break;case"hold":this.updateInteractionVisualsVisibility(!0)}}onInputEventAfter(e){if("immediate-click"===e.type)this._clickPlacementHandler(e)}_clickPlacementHandler(e){if(!this.creating||this.hasFocusedManipulators)return;const t=this._intersectScreen(e,U);if(null!=t){if("placing-observer"===this._creationState){t.mapPoint.z=(t.mapPoint.z??0)+w.creationVerticalOffset;const e=new i({observer:t.mapPoint.clone(),feature:t.feature});this.analysis.viewsheds.add(e),this._stagedViewshed=e,this._creationState="placing-target",this._updateStagedViewshed(t.scenePoint)}else if("placing-target"===this._creationState){this._updateStagedViewshed(t.scenePoint);const e=this._stagedViewshed;this._creationState="placing-observer",this._stagedViewshed=null,this.selectedViewshed=e}e.stopPropagation()}}_doubleClickHandler(e){this.creating&&(this.removeStaged(),this._creationState=!1,this.view.activeTool=null,e.stopPropagation())}_pointerMoveHandler(e){if(!this.creating)return;const t=this._intersectScreen(e,U);null!=t&&(this._updateInteractionVisualsLocation(t.scenePoint,!1),this._updateStagedViewshed(t.scenePoint))}_cancelKeyHandler(e){if(this.creating){if(this.removeStaged())return this._creationState="placing-observer",this.selectedViewshed=null,void e.stopPropagation();this._creationState=!1}else if(!this.grabbing)return this.selectedViewshed=null,void e.stopPropagation()}_deleteKeyHandler(){this.creating&&(this.removeStaged(),this._creationState="placing-observer"),null!=this.selectedViewshed&&this.analysis.viewsheds.remove(this.selectedViewshed)}_updateStagedViewshed(e){const t=this._stagedViewshed,i=this._stagedViewshedComputedData;if(null==t||null==i)return;const{heading:s,tilt:a,farDistance:n}=E(this.view,i,e);t.farDistance=n,t.tilt=a,t.heading=s}removeStaged(){return null!=this._stagedViewshed&&(this.analysis.viewsheds.remove(this._stagedViewshed),this._stagedViewshed=null,!0)}_intersectScreen(e,t){const i=M.createScreenPointArrayFromEvent(e);this.view.sceneIntersectionHelper.intersectToolIntersectorScreen(i,this._intersector);const s=this._intersector.results.min,a=t.scenePoint;if(!s.getIntersectionPoint(a))return null;const n=t.mapPoint;return n.spatialReference=this.view.spatialReference,this.view.renderCoordsHelper.fromRenderCoords(a,n),null==n?null:(t.feature=S.toGraphic(s,this.view),t)}_createInteractionVisuals(){this.removeHandles(H);const e=this._settings.visualElements,t=new m.LaserlineVisualElement({view:this.view,attached:!1,style:{glowWidth:e.heightPlane.glowWidth,innerWidth:e.heightPlane.innerWidth},isDecoration:!0}),i=new b.ExtendedLineVisualElement({view:this.view,extensionType:e.zVerticalLine.extensionType,attached:!1,innerWidth:1,writeDepthEnabled:!1,renderOccluded:f.RenderOccludedFlag.OccludeAndTransparent,isDecoration:!0});this._interactionVisualElements={laserline:t,verticalLine:i},this.addHandles([r.watch((()=>e.zVerticalLine),(e=>e.apply(i)),r.syncAndInitial),r.watch((()=>e.heightPlane),(e=>e.apply(t)),r.syncAndInitial),s.makeHandle((()=>{t.destroy(),i.destroy(),this._interactionVisualElements=null}))],H)}updateInteractionVisualsVisibility(e=!1){const t=this.creating,i=this.analysisViewData.visible,s=this._selectedSubTool,a=this.selectedViewshedComputedData,n=(e,t)=>{const i=this._interactionVisualElements;null!=i&&(i.verticalLine.attached=t,i.laserline.attached=e)};if(t)return void n(i,!1);if(null==s||null==a)return void n(!1,!1);const o=s.moveInteractionState,r=e?o.grabbing:o.dragging,l=s.scaleOrientInteractionState,c=e?l.grabbing:l.dragging,d=i&&(r||c);if(n(d,r),d){const e=r?a.observerRenderSpace:a.targetRenderSpace;this._updateInteractionVisualsLocation(e,r)}}_updateInteractionVisualsLocation(e,t){const i=this._interactionVisualElements;if(null==i)return;const{laserline:s,verticalLine:a}=i;s.heightManifoldTarget=e,s.intersectsWorldUpAtLocation=t?e:null,null!=e&&a.setStartEndFromWorldDownAtLocation(e)}_findSubTool(e){if(null==e)return null;const t=e instanceof y.Manipulator3D?t=>t.subTool.hasManipulator(e):t=>t.subTool.viewshed===e;return this.subToolHandles?.find(t)?.subTool}get test(){}};function E(e,t,i){const s=t.observerRenderSpace,a=p.sub(k,i,s),o=p.len(a)*t.metersPerUnit,r=e.renderCoordsHelper.basisMatrixAtPosition(s,R),l=p.set(L,r[8],r[9],r[10]),c=_.fromPositionAndNormal(s,l,x),d=_.projectPoint(c,i,A),h=p.sub(d,d,s),u=(p.len(h)<1e-4?90:n.rad2deg(p.angle(a,h)))*(p.dot(l,a)<0?-1:1)+90,g=p.set(O,r[4],r[5],r[6]),w=n.rad2deg(p.angle(g,h)),v=p.set(O,r[0],r[1],r[2]);return{heading:p.dot(h,v)<0?360-w:w,tilt:u,farDistance:o}}e.__decorate([l.property({constructOnly:!0})],I.prototype,"view",void 0),e.__decorate([l.property()],I.prototype,"analysisViewData",void 0),e.__decorate([l.property()],I.prototype,"removeIncompleteOnCancel",void 0),e.__decorate([l.property()],I.prototype,"automaticManipulatorSelection",void 0),e.__decorate([l.property({constructOnly:!0})],I.prototype,"analysis",void 0),e.__decorate([l.property()],I.prototype,"subToolHandles",void 0),e.__decorate([l.property()],I.prototype,"_stagedViewshed",void 0),e.__decorate([l.property()],I.prototype,"_stagedViewshedComputedData",void 0),e.__decorate([l.property()],I.prototype,"_creationState",void 0),e.__decorate([l.property({readOnly:!0})],I.prototype,"cursor",null),e.__decorate([l.property()],I.prototype,"_selectedManipulator",void 0),e.__decorate([l.property()],I.prototype,"_selectedSubTool",null),e.__decorate([l.property()],I.prototype,"selectedViewshed",null),e.__decorate([l.property()],I.prototype,"selectedViewshedComputedData",null),e.__decorate([l.property()],I.prototype,"stagedViewshed",null),e.__decorate([l.property()],I.prototype,"grabbing",null),e.__decorate([l.property()],I.prototype,"creating",null),e.__decorate([l.property()],I.prototype,"isPlacingTarget",null),I=e.__decorate([h.subclass("esri.views.3d.analysis.Viewshed.ViewshedTool")],I);const k=g.create(),L=g.create(),A=g.create(),O=g.create(),R=u.create(),x=_.create(),U={mapPoint:new P,scenePoint:g.create(),feature:null};return I}));
