/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../../chunks/tslib.es6","../../../../Color","../../../../core/Accessor","../../../../core/has","../../../../core/lang","../../../../core/mathUtils","../../../../core/maybe","../../../../core/reactiveUtils","../../../../core/accessorSupport/decorators/property","../../../../core/Logger","../../../../core/accessorSupport/decorators/subclass","../../../../core/libs/gl-matrix-2/math/mat4","../../../../core/libs/gl-matrix-2/factories/mat4f64","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","./ViewshedConfiguration","./ViewshedTool","../../interactive/visualElements/LineVisualElement","../../interactive/visualElements/PointVisualElement","../../interactive/visualElements/ViewshedShapeVisualElement","../../webgl-engine/lib/Material","../../webgl-engine/materials/lineStippleUtils"],(function(e,t,i,s,a,r,l,o,n,c,h,d,u,m,p,_,V,v,f,w,E,b){"use strict";let g=class extends i{constructor(e){super(e),this.visible=!0,this._viewshedCorners={topLeft:p.create(),topRight:p.create(),bottomLeft:p.create(),bottomRight:p.create()},this._arcCenterPoints={top:p.create(),bottom:p.create(),left:p.create(),right:p.create()},this._parallelCenters={top:p.create(),bottom:p.create()}}initialize(){const e={view:this.view,isDecoration:!0},t={...e,color:this._color,renderOccluded:E.RenderOccludedFlag.OccludeAndTransparent},i={...t,stipplePattern:b.createStipplePatternSimple(2)};this._observerVisualElement=new f.PointVisualElement({...e,..._.viewshedVisualizationConfiguration.observerPointConfiguration}),this._shapeVisualElement=new w.ViewshedShapeVisualElement(e),this._frameLinesVisualElement=new v.LineVisualElement(t),this._leftArcVisualElement=new v.LineVisualElement(t),this._rightArcVisualElement=new v.LineVisualElement(t),this._topArcVisualElement=new v.LineVisualElement(t),this._bottomArcVisualElement=new v.LineVisualElement(t),this._centralLongitude=new v.LineVisualElement(i),this._centralLatitude=new v.LineVisualElement(i),this.addHandles([o.watch((()=>{const e=this.viewshedComputedData;if(!e?.isValid())return null;const t=this._viewshedCorners,i=this._arcCenterPoints,s=this._parallelCenters;return e.cornerPoints(t),e.arcCentersPoints(i),e.parallelCenterPoints(s),{viewshedComputedData:e,corners:t,arcCenters:i,parallelCenters:s,interactive:this.analysisViewData.interactive,selected:this._selected}}),(e=>{const t=null!=e;this._forEachVisualElement((e=>e.attached=t)),t&&this._updateVisualElements(e)}),{initial:!0,equals:a.equals}),o.watch((()=>{const{viewshedComputedData:e}=this,{horizontalFieldOfView:t,verticalFieldOfView:i}=e??{};return{viewshedComputedData:e,horizontalFieldOfView:t,verticalFieldOfView:i}}),(({viewshedComputedData:e})=>{const{_shapeVisualElement:t}=this;e!==t.viewshedComputedData&&(t.viewshedComputedData=e),this._shapeVisualElement.recreateGeometry()}),o.initial),o.watch((()=>{const{interactive:e}=this.analysisViewData;return{visible:this.visible,selected:e&&this._selected,staged:e&&this._staged,horFovNot360:360!==this.viewshedComputedData?.horizontalFieldOfView}}),(({visible:e,selected:t,staged:i,horFovNot360:s})=>{const a=t||i;this._shapeVisualElement.visible=e,this._topArcVisualElement.visible=e,this._bottomArcVisualElement.visible=e,this._frameLinesVisualElement.visible=e&&s;const r=e&&(t||s);this._leftArcVisualElement.visible=r,this._rightArcVisualElement.visible=r,this._forEachLineVisualElement((e=>{e.width=a?_.viewshedVisualizationConfiguration.frameWidthSelected:_.viewshedVisualizationConfiguration.frameWidthNotSelected,e.renderOccluded=t?E.RenderOccludedFlag.OccludeAndTransparent:E.RenderOccludedFlag.Occlude})),[this._centralLatitude,this._centralLongitude].forEach((i=>{i.width=2*(a?_.viewshedVisualizationConfiguration.frameWidthSelected:_.viewshedVisualizationConfiguration.frameWidthNotSelected),i.visible=e&&t}))}),o.initial),o.watch((()=>{const{analysisViewData:{interactive:e,tool:t},_selected:i,visible:s}=this,a=this.view.activeTool,r=!t?.active&&a instanceof V&&a.creating;return{observerVisible:s&&!i&&(!e||(t?.creating??!1)||r),color:this._color}}),(({observerVisible:e,color:t})=>{this._observerVisualElement.visible=e,this._forEachLineVisualElement((e=>e.color=t))}),o.initial)])}get _color(){const{viewshedComputedData:e,_selected:i,analysisViewData:s}=this;if(null==e)return t.toUnitRGBA(_.viewshedVisualizationConfiguration.frameColor);const a=s.tool?.active||s.interactive,r=e.viewshed===s.tool?.stagedViewshed,l=a&&(i||r)?this.view.effectiveTheme.accentColor:_.viewshedVisualizationConfiguration.frameColor;return t.toUnitRGBA(l)}get _selected(){const{viewshedComputedData:e,analysisViewData:{selectedViewshedComputedData:t}}=this;return null!=e&&e===t}get _staged(){const{analysisViewData:{tool:e},viewshedComputedData:t}=this;return null!=e&&e.creating&&e.stagedViewshed===t?.viewshed}destroy(){this._observerVisualElement=l.destroyMaybe(this._observerVisualElement),this._shapeVisualElement=l.destroyMaybe(this._shapeVisualElement),this._frameLinesVisualElement=l.destroyMaybe(this._frameLinesVisualElement),this._leftArcVisualElement=l.destroyMaybe(this._leftArcVisualElement),this._rightArcVisualElement=l.destroyMaybe(this._rightArcVisualElement),this._topArcVisualElement=l.destroyMaybe(this._topArcVisualElement),this._bottomArcVisualElement=l.destroyMaybe(this._bottomArcVisualElement),this._centralLongitude=l.destroyMaybe(this._centralLongitude),this._centralLatitude=l.destroyMaybe(this._centralLatitude)}_forEachLineVisualElement(e){[this._frameLinesVisualElement,this._leftArcVisualElement,this._rightArcVisualElement,this._topArcVisualElement,this._bottomArcVisualElement,this._centralLatitude,this._centralLongitude].forEach(e)}_forEachVisualElement(e){this._forEachLineVisualElement(e),e(this._observerVisualElement),e(this._shapeVisualElement)}_updateVisualElements(e){const{viewshedComputedData:t,corners:i,arcCenters:s,parallelCenters:a}=e,r=p.clone(t.observerRenderSpace);this._observerVisualElement.geometry=t.observer,this._shapeVisualElement.updateTransform(),this._updateFrameLines(r,i),this._updateFrameArcs(t,i,a),this._updateCentralHelperArcs(t,s)}_updateFrameLines(e,t){this._frameLinesVisualElement.geometry=[[e,t.topLeft],[e,t.topRight],[e,t.bottomLeft],[e,t.bottomRight]]}_updateFrameArcs(e,t,i){const{observerRenderSpace:s,rightVector:a,horizontalFieldOfView:l,tiltedUpVector:o}=e,n=r.deg2rad(l),c=p.create(),h=u.create();d.fromRotation(h,n/2,o),m.transformMat4(c,a,h),y(this._leftArcVisualElement,s,t.bottomLeft,t.topLeft,"forward",c),d.fromRotation(h,-n/2,o),m.set(c,0,0,0),m.transformMat4(c,a,h),y(this._rightArcVisualElement,s,t.bottomRight,t.topRight,"forward",c);const _=l>180?"backward":"forward";y(this._topArcVisualElement,i.top,t.topRight,t.topLeft,_,o),y(this._bottomArcVisualElement,i.bottom,t.bottomRight,t.bottomLeft,_,o)}_updateCentralHelperArcs(e,t){const i=e.observerRenderSpace,s=e.horizontalFieldOfView>=180?"backward":"forward";y(this._centralLatitude,i,t.right,t.left,s,e.tiltedUpVector),y(this._centralLongitude,i,t.top,t.bottom,"forward",e.leftVector)}get test(){}};function y(e,t,i,s,a,r,l=_.arcAnglePerSegment){const o=p.create();m.sub(o,i,t);const n=m.len(o),c=p.create();m.sub(c,s,t),m.normalize(c,c),m.scale(c,c,n);let h=m.angle(o,c);const V=p.clone(r);"backward"===a&&(m.negate(V,V),h=-(2*Math.PI-h));const v=[],f=Math.ceil(Math.abs(h)/l),w=u.create(),E=h/f;d.fromRotation(w,E,V);const b=p.create();m.copy(b,o);const g=p.create();m.copy(g,i);for(let d=0;d<f;d++){const e=p.create();m.copy(e,g),m.transformMat4(b,b,w),m.add(g,t,b);const i=p.create();m.copy(i,g),v.push([e,i])}e.geometry=v}e.__decorate([n.property()],g.prototype,"view",void 0),e.__decorate([n.property()],g.prototype,"analysisViewData",void 0),e.__decorate([n.property()],g.prototype,"viewshedComputedData",void 0),e.__decorate([n.property()],g.prototype,"visible",void 0),e.__decorate([n.property()],g.prototype,"_color",null),e.__decorate([n.property()],g.prototype,"_selected",null),e.__decorate([n.property()],g.prototype,"_staged",null),g=e.__decorate([h.subclass("esri.views.3d.analysis.Viewshed.ViewshedVisualization")],g);return g}));
