/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../analysis/featureReferenceUtils","../../../core/Accessor","../../../core/has","../../../core/Logger","../../../core/maybe","../../../core/reactiveUtils","../../../core/accessorSupport/decorators/property","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../../chunks/vec32","../../../core/libs/gl-matrix-2/factories/vec3f64","../../../geometry/projection","./AnalysisView3D","./support/projectionUtils","./Viewshed/ViewshedAnalysisVisualization","./Viewshed/ViewshedComputedData","./Viewshed/ViewshedTool","../webgl-engine/lib/Intersector","../webgl-engine/lib/IntersectorInterfaces","../webgl-engine/lib/Viewshed","../../analysis/analysisViewUtils"],(function(e,t,s,i,r,a,o,d,n,l,h,c,p,w,u,v,y,V,_,m,b,g){"use strict";let f=class extends(w.AnalysisView3D(s)){constructor(e){super(e),this.type="viewshed-view-3d",this.analysis=null,this.tool=null,this._selectedViewshed=null,this.viewshedComputedDataHandles=null,this._placementTask=null,this._viewshedRenderer=null,this._intersector=null}get selectedViewshed(){return this._selectedViewshed}set selectedViewshed(e){this._unselectOtherViewsheds(e),this._selectedViewshed=e}get selectedViewshedComputedData(){return this.tool?.selectedViewshedComputedData}initialize(){const e=this.view;this._viewshedRenderer=new b.Viewshed({view:e,selectedViewshed:()=>this.selectedViewshed??this.tool?.stagedViewshed}),this._intersector=_.newIntersector(this.view.state.viewingMode),this._intersector.options.hud=!1,this._intersector.options.store=m.StoreResults.MIN,this.viewshedComputedDataHandles=o.mapCollection((()=>this.analysis.viewsheds),(t=>{const s=new y.ViewshedComputedData({renderCoordsHelper:e.renderCoordsHelper,viewshed:t}),i=Symbol();return this.addHandles([o.watch((()=>({valid:s.isValid(),canProject:p.canProjectWithoutEngine(s.observer?.spatialReference,this.view.spatialReference)||p.isLoaded()})),(({valid:e,canProject:t},i)=>{this.visible&&(e&&t?this._addViewshedsToRenderer(s):i?.valid&&i?.canProject&&this._removeViewshedsFromRenderer(s),t||u.logFailedGeometryProjectionError(this.analysis,s.observer.spatialReference,r.getLogger(this)))}),o.initial),o.watch((()=>[e.state.camera,e.slicePlane,s.viewshed.observer,s.targetRenderSpace,s.verticalFieldOfView,s.horizontalFieldOfView,s.feature]),(()=>{this._updateObserverFromFeature(e,s)}),o.initial)]),{viewshedComputedData:s,remove:()=>{this.removeHandles(i),this._removeViewshedsFromRenderer(s),s.destroy()}}})),this._analysisVisualization=new v.ViewshedAnalysisVisualization({view:e,analysisViewData:this,isDecoration:!this.parent}),this.addHandles([o.watch((()=>this.visible),(e=>{const t=this.viewshedComputedDataHandles;if(null==t)return;e||(this.selectedViewshed=null);const s=t.map((e=>e.viewshedComputedData)).filter((e=>e.isValid())).toArray();e?this._addViewshedsToRenderer(s):this._removeViewshedsFromRenderer(s)})),o.watch((()=>e.renderCoordsHelper),(e=>{this.viewshedComputedDataHandles?.forEach((({viewshedComputedData:t})=>t.renderCoordsHelper=e))})),g.connectAnalysisViewToTool(this,V),o.when((()=>this.interactive),(()=>{this._unselectOtherViewsheds(this.selectedViewshed)}),o.syncAndInitial)])}destroy(){this._placementTask=a.abortMaybe(this._placementTask),g.removeAnalysisViewTool(this),this._analysisVisualization=a.destroyMaybe(this._analysisVisualization);const e=this.viewshedComputedDataHandles;null!=e&&this._removeViewshedsFromRenderer(e.map((e=>e.viewshedComputedData)).toArray())}async createViewsheds(e){return this._placementTask=a.abortMaybe(this._placementTask),this._placementTask=g.activateAnalysisViewTool(this,e),null!=this.tool&&this.tool.createViewsheds(),await this._placementTask.promise}_addViewshedsToRenderer(e){this._viewshedRenderer.updateViewsheds({adds:e})}_removeViewshedsFromRenderer(e){this._viewshedRenderer.updateViewsheds({removes:e})}_updateObserverFromFeature(e,s){const i=s.observerRenderSpace,r=s.targetRenderSpace,a=h.copy(c.create(),i),o={observer:i,observerSurfaceNormal:null,observerAdjusted:a,observerFeatureId:t.getFeatureId(s.feature),target:r,targetSurfaceNormal:null,targetAdjusted:h.copy(c.create(),r),targetFeatureId:null};t.updatePointsFromFeatureReference(e,this._intersector,o,(e=>Math.min(e,.05*s.farDistanceRenderSpace))),s.observerRenderSpaceOverride=h.exactEquals(a,i)?null:a}_unselectOtherViewsheds(e){if(null!=e)for(const t of this.view.tools.items)t!==this.tool&&t instanceof V&&(t.analysisViewData.selectedViewshed=null)}get test(){}};e.__decorate([d.property({readOnly:!0})],f.prototype,"type",void 0),e.__decorate([d.property({constructOnly:!0,nonNullable:!0})],f.prototype,"analysis",void 0),e.__decorate([d.property()],f.prototype,"tool",void 0),e.__decorate([d.property()],f.prototype,"_selectedViewshed",void 0),e.__decorate([d.property()],f.prototype,"selectedViewshed",null),e.__decorate([d.property()],f.prototype,"selectedViewshedComputedData",null),e.__decorate([d.property()],f.prototype,"viewshedComputedDataHandles",void 0),e.__decorate([d.property()],f.prototype,"_analysisVisualization",void 0),e.__decorate([d.property()],f.prototype,"_placementTask",void 0),e.__decorate([d.property()],f.prototype,"_viewshedRenderer",void 0),f=e.__decorate([l.subclass("esri.views.3d.analysis.ViewshedAnalysisView3D")],f);return f}));
