/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../core/compilerUtils","../../../../core/mathUtils","../../../../core/libs/gl-matrix-2/math/mat4","../../../../core/libs/gl-matrix-2/factories/mat4f64","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../geometry/ellipsoidUtils","../../../../chunks/sphere","./common","./ConstraintTypes","./InteractionType","./TiltMode","../../state/utils/viewUtils"],(function(e,t,n,r,a,i,s,c,o,l,u,d,m,f){"use strict";function p(e,n,a,s=!0){q.eyeCenterDistance=0,q.requiresTwoSteps=!1;const c=y(e,n,a,l.defaultConstraintOptions,q);if(0===c)return!1;switch(r.fromRotation(v,-c,n.viewRight),a.tiltMode){case m.TiltMode.LOOK_AROUND:i.transformMat4(x,n.viewForward,v),i.scale(x,x,q.eyeCenterDistance),n.center=i.add(b,n.eye,x);break;case m.TiltMode.TUMBLE:i.subtract(x,n.center,n.eye),i.transformMat4(x,x,v),n.eye=i.subtract(b,n.center,x);break;default:t.neverReached(a.tiltMode)}return n.up=i.transformMat4(b,n.up,v),!q.requiresTwoSteps||!s||p(e,n,a,!1)}function y(e,t,n,r=l.defaultConstraintOptions,a){if(!e.state.constraints.tilt)return 0;const i=t.distance,s=e.state.constraints.tilt(i,U);return w(e,n,s),r.interactionType===d.InteractionType.TUMBLE&&l.hasConstraintType(r.selection,u.ConstraintTypes.ALTITUDE)&&D(e,r.interactionStartCamera,s),n.tiltMode===m.TiltMode.LOOK_AROUND||r.tiltMode===m.TiltMode.LOOK_AROUND?M(e,t,s,a):C(e,t,s)}function C(e,t,r){const a=f.viewAngle(e.renderCoordsHelper,t.center,t.eye),i=a-n.clamp(a,r.min,r.max);return O(i)?i:0}function M(e,t,n,r){switch(r&&(r.requiresTwoSteps=!1),e.viewingMode){case"global":return T(e,t,n,r);case"local":return h(e,t,n,r)}}function h(e,t,r,a){const i=f.viewAngle(e.renderCoordsHelper,t.center,t.eye),s=n.clamp(i,r.min,r.max),c=i-s;if(!O(c))return 0;if(a){const n=Math.abs(e.pointsOfInterest.centerOnSurfaceFrequent.estimatedSurfaceAltitude),r=e.renderCoordsHelper.getAltitude(t.eye)-n,i=Math.max(Math.cos(s),1e-4);Math.abs(i)>1e-4?a.eyeCenterDistance=r/i:a.eyeCenterDistance=t.distance}return c}function T(e,t,r,a){const i=I(e,t,L),s=n.clamp(i.tiltAtCenter,r.min,r.max);if(!O(i.tiltAtCenter-s))return 0;let c,o;return i.centerIsOnSurface?(c=g(i),o=R(i,c)):(c=i.constraints.clampTilt(i.eyeCenterDistance,i.tiltAtCenter),a&&c<Math.PI/2&&(a.requiresTwoSteps=!0,c=Math.PI/2-1e-5),o=S(i,c)),a&&(a.eyeCenterDistance=A(i,c)),o}function I(e,t,r){const a=e.pointsOfInterest.centerOnSurfaceFrequent.estimatedSurfaceAltitude,s=a+c.getReferenceEllipsoid(e.spatialReference).radius,l=e.renderCoordsHelper.intersectManifold(t.ray,a,b);return r.eyeCenterDistance=t.distance,r.centerIsOnSurface=!1,null!=l?(r.eyeCenterDistance=i.distance(t.eye,l),r.tiltAtCenter=f.viewAngle(e.renderCoordsHelper,l,t.eye),r.centerIsOnSurface=!0):e.state.isLocal?r.tiltAtCenter=f.viewAngle(e.renderCoordsHelper,t.center,t.eye):(o.closestPointOnSilhouette(o.fromRadius(o.tmpSphere,s),t.ray,b),r.eyeCenterDistance=i.distance(t.eye,b),r.tiltAtCenter=n.acosClamped(-i.dot(t.viewForward,i.normalize(b,b)))),r.radius=s,r.eyeRadius=i.length(t.eye),r.constraints=e.state.constraints,r}function O(e){return Math.abs(e)>1e-9}function g(e){const{constraints:t,eyeCenterDistance:n,tiltAtCenter:r}=e;let a=r,i=t.clampTilt(n,r);const s=A(e,i);if(t.clampTilt(s,r)===i)return i;let c=0;for(;c<10&&O(i-a);){const n=(a+i)/2,r=A(e,n);O(t.clampTilt(r,n)-n)?a=n:i=n,c++}return i}function A(e,t){if(!e.centerIsOnSurface)return e.eyeCenterDistance;const r=Math.PI-n.clamp(t,0,Math.PI),a=n.asinClamped(e.radius/e.eyeRadius*Math.sin(r)),i=Math.PI-r-a,s=Math.sin(i)/Math.sin(r);if(e.eyeRadius<e.radius&&s>1){const t=Math.PI-a,n=Math.PI-r-t;return Math.sin(n)/Math.sin(r)*e.eyeRadius}return s*e.eyeRadius}function R(e,t){const r=n.asinClamped(e.radius/e.eyeRadius*Math.sin(e.tiltAtCenter)),a=n.asinClamped(e.radius/e.eyeRadius*Math.sin(t));return e.eyeRadius>e.radius?r-a:a-r}function S(e,t){return e.tiltAtCenter-Math.PI/2-(t-Math.PI/2)}function w(e,t,n){if(t.interactionType===d.InteractionType.NONE)return;const{interactionStartCamera:r,interactionFactor:a}=t;if(!r)return;const{min:i,max:s}=n,c=y(e,r,l.defaultConstraintOptions,t),o=0===c?0:f.viewAngle(e.renderCoordsHelper,r.center,r.eye);n.min=i,n.max=s,t.interactionType===d.InteractionType.TUMBLE?(l.hasConstraintType(t.selection,u.ConstraintTypes.ALTITUDE)&&D(e,r,n),l.adjustRangeForInteraction(c,o,!0,a,P,n)):l.adjustRangeForInteraction(c,o,!1,a,P,n)}function D(e,t,r){const a=e.state.constraints;if(e.state.isLocal||!a.altitude||!t)return;const s=i.squaredLength(t.center),o=Math.sqrt(s),l=t.distance,u=c.getReferenceEllipsoid(e.spatialReference).radius,d=a.altitude.min+u,m=a.altitude.max+u,f=(d*d-l*l-s)/(-2*o*l),p=(m*m-l*l-s)/(-2*o*l);r.min=Math.max(r.min,Math.min(Math.PI-n.acosClamped(p),r.max)),r.max=Math.min(r.max,Math.PI-n.acosClamped(f))}const x=s.create(),v=a.create(),b=s.create(),P=n.deg2rad(5),U={min:0,max:0},L={constraints:null,radius:0,eyeRadius:0,centerIsOnSurface:!0,eyeCenterDistance:0,tiltAtCenter:0},q={eyeCenterDistance:0,requiresTwoSteps:!1};e.applyTiltConstraint=p,e.getTiltConstraintError=y,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
