/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../chunks/tslib.es6","../../../core/colorUtils","../../../core/mathUtils","../../../core/maybe","../../../core/reactiveUtils","../../../core/Logger","../../../core/has","../../../core/RandomLCG","../../../core/Error","../../../core/accessorSupport/decorators/subclass","../../../core/libs/gl-matrix-2/math/vec2","../../../chunks/vec32","../../../chunks/vec42","../../../core/libs/gl-matrix-2/factories/vec4f64","../../../geometry/support/Ellipsoid","../webgl","./atmosphereUtils","./ChapmanAtmosphereTechnique","./ChapmanAtmosphereTechniqueConfiguration","../webgl/formats","../webgl-engine/effects/OpaqueEnvironment","../webgl-engine/lib/basicInterfaces","../webgl-engine/lib/glUtil3D","../webgl-engine/lib/textureUtils","../../../chunks/AtmosphereCompositing.glsl","../webgl-engine/shaders/AtmosphereCompositingTechnique","../../webgl/enums","../../../webscene/background/ColorBackground"],(function(e,t,s,r,i,a,n,o,h,c,m,p,u,l,d,g,b,f,_,A,P,T,w,q,C,v,y,R,E){"use strict";e.ChapmanAtmosphere=class extends T.OpaqueEnvironment{constructor(e){super(e),this.requireGeometryDepth=!0,this._compositingPassParameters=new v.AtmosphereCompositingPassParameters,this._vao=null,this._passParameters=new _.ChapmanAtmospherePassParameters,this._configuration=new A.ChapmanAtmosphereTechniqueConfiguration;const{techniques:t}=e;t.precompile(_.ChapmanAtmosphereTechnique,this._configuration),t.precompile(y.AtmosphereCompositingTechnique),this._configuration.reduced=!0,t.precompile(_.ChapmanAtmosphereTechnique,this._configuration),this._configuration.reduced=!1}initialize(){this.addHandles([a.watch((()=>this.view.environment.background),(e=>{const t=e instanceof E?s.unitRGBAFromColor(e.color):d.ZEROS;u.set(this._passParameters.backgroundColor,t[0]*t[3],t[1]*t[3],t[2]*t[3])}),a.syncAndInitial),a.watch((()=>this.view._stage?.renderer?.fullResolutionAtmosphere),(e=>this._configuration.reduced=!e),a.syncAndInitial),a.watch((()=>this.view.environment.atmosphereEnabled),(e=>e?this._enable():this._disable()),a.syncAndInitial)])}destroy(){this._vao=i.disposeMaybe(this._vao)}render(e){const t=e.find((({name:e})=>e===b.InternalRenderCategory.OPAQUE_ENVIRONMENT));if(!this.bindParameters.mainDepth)return t;const s=this.renderingContext;this._vao??=q.createQuadVAO(s,q.Layout.Pos2Tex);const i=t.getAttachment(s.gl.DEPTH_STENCIL_ATTACHMENT);this._update();const a=this.techniques.acquire(_.ChapmanAtmosphereTechnique,this._configuration);if(!a.compiled)return a.release(),this.requestRender(w.RenderRequestType.UPDATE),t;if(!this._configuration.reduced)return t.detachDepth(),s.bindFramebuffer(t.fbo),s.bindTechnique(a,this.bindParameters,this._passParameters),s.bindVAO(this._vao),s.drawArrays(R.PrimitiveType.TRIANGLE_STRIP,0,4),t.attachDepth(i),a.release(),t;const n=this.techniques.acquire(y.AtmosphereCompositingTechnique);if(!n.compiled)return a.release(),n.release(),this.requestRender(w.RenderRequestType.UPDATE),t;const o=s.getViewport(),h=this.bindParameters.camera,c=u.length(h.eye)-g.earth.radius;let m;const p=g.earth.atmosphereHeight;if(c<p){const e=Math.min(1,Math.max(0,c/p));m=r.lerp(.2,.3,e)}else{const e=Math.min(1,Math.max(0,(c-p)/(15*p)));m=r.lerp(.3,.6,e)}const l=C.applyTextureResizeModulo(Math.round(m*h.fullViewport[2])),d=C.applyTextureResizeModulo(Math.round(m*h.fullViewport[3]));s.setViewport(0,0,l,d);const f=this.fboCache.acquire(l,d,"chapman",P.ColorFormat.RGBA);return s.bindFramebuffer(f.fbo),s.clearFramebuffer([0,0,0,1],!0,!0),s.bindTechnique(a,this.bindParameters,this._passParameters),s.bindVAO(this._vao),s.drawArrays(R.PrimitiveType.TRIANGLE_STRIP,0,4),s.setViewport(o.x,o.y,o.width,o.height),this._compositingPassParameters.color=f.getTexture(),t.detachDepth(),s.bindFramebuffer(t.fbo),s.bindTechnique(n,this.bindParameters,this._compositingPassParameters),s.screen.draw(),t.attachDepth(i),a.release(),n.release(),f.release(),t}_update(){const e=this.bindParameters.camera,t=u.squaredLength(e.eye),s=Math.sqrt(t),i=t-this._passParameters.radii[1]**2,a=r.clamp((s-this._passParameters.radii[0])/g.earth.atmosphereHeight,0,1);l.set(this._passParameters.heightParameters,s,t,i,a);const n=this.view.basemapTerrain.getLowerBoundRadius();p.set(this._passParameters.radii,n,n+g.earth.atmosphereHeight),this._passParameters.innerFadeDistance=2*Math.sqrt((2*n-f.innerAtmosphereDepth)*f.innerAtmosphereDepth),this._passParameters.altitudeFade=f.computeInnerAltitudeFade(s-n)}},e.ChapmanAtmosphere=t.__decorate([m.subclass("esri.views.3d.environment.ChapmanAtmosphere")],e.ChapmanAtmosphere),Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
