/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../core/compilerUtils","../../../core/mathUtils","../../../core/signal","../../../core/libs/gl-matrix-2/math/mat4","../../../core/libs/gl-matrix-2/factories/mat4f64","../../../chunks/vec32","../../../core/libs/gl-matrix-2/factories/vec3f64","../../../geometry/support/axisAngleDegrees","../../../geometry/support/Ellipsoid","./Clouds","./weather"],(function(t,a,e,s,i,r,h,d,n,o,c,l){"use strict";class F{constructor(){this.startTime=0,this._data=s.signal(null),this._readChannels=c.CloudsTextureChannels.RG,this.parallax=new _,this.parallaxNew=new _,this._anchorPoint=d.create(),this._fadeState=s.signal(t.FadeState.HIDE),this._fadeFactor=s.signal(1)}get data(){return this._data.value}set data(t){this._data.value=t}get readChannels(){return this._readChannels}get fadeState(){return this._fadeState.value}get fadeFactor(){return this._fadeFactor.value}get opacity(){switch(this.fadeState){case t.FadeState.HIDE:return 0;case t.FadeState.FADE_OUT:return 1-this.fadeFactor;case t.FadeState.FADE_IN:return this.fadeFactor;case t.FadeState.SHOW:case t.FadeState.CROSS_FADE:return 1}}fade(t,a,s){this.isFading&&this.fadeFactor<1&&(this._fadeFactor.value=s?e.clamp((a-this.startTime)/(E*s),0,1):1,1===this.fadeFactor&&this._endFade()),this._evaluateState(t,a),this._updateParallax(t)}_evaluateState(a,e){const s=a.relativeElevation,i=this._updateAnchorPoint(a);(s>1.7*l.heightLimit||s<-l.heightLimit||i>C)&&this.opacity>0?this._startFade(t.FadeState.HIDE,e):this.isFading||(s>l.heightLimit||s<-.35*l.heightLimit||i>D*C?this.opacity>0&&this._startFade(t.FadeState.FADE_OUT,e):c.ensureClouds(this.data)&&(0===this.opacity?this._startFade(t.FadeState.FADE_IN,e):this.data.state===c.CubeMapState.Ready&&(this.fadeState===t.FadeState.SHOW?this._startFade(t.FadeState.CROSS_FADE,e):this._startFade(t.FadeState.SHOW,e))))}_updateParallax(t){const a=h.squaredLength(t.eye);this.parallax.radiusCurvatureCorrection=.84*Math.sqrt(Math.max(a-o.earth.radius*o.earth.radius,0))/Math.sqrt(a),n.fromPoints(u,this.parallax.anchorPoint,p),i.rotate(this.parallax.transform,r.IDENTITY,p[3],n.axis(p)),n.fromPoints(u,this.parallaxNew.anchorPoint,p),i.rotate(this.parallaxNew.transform,r.IDENTITY,p[3],n.axis(p))}_updateAnchorPoint(a){return h.normalize(this._anchorPoint,a.eye),h.scale(this._anchorPoint,this._anchorPoint,o.earth.radius),this.fadeState===t.FadeState.HIDE&&this.data?.state===c.CubeMapState.Ready?(h.copy(this.parallax.anchorPoint,this._anchorPoint),0):h.length(h.subtract(f,this.parallax.anchorPoint,this._anchorPoint))}requestFade(){this._fadeFactor.value=0}_startFade(a,e){switch(this._fadeState.value=a,this.startTime=e,a){case t.FadeState.CROSS_FADE:this.requestFade(),this._switchReadChannels(),h.copy(this.parallaxNew.anchorPoint,this._anchorPoint);break;case t.FadeState.FADE_IN:this.requestFade(),this._switchReadChannels(),h.copy(this.parallax.anchorPoint,this._anchorPoint),h.copy(this.parallaxNew.anchorPoint,this._anchorPoint);break;case t.FadeState.FADE_OUT:this.requestFade();break;case t.FadeState.SHOW:this._switchReadChannels(),h.copy(this.parallax.anchorPoint,this._anchorPoint),h.copy(this.parallaxNew.anchorPoint,this._anchorPoint),this._endFade();break;case t.FadeState.HIDE:this._endFade()}}_endFade(){switch(this._fadeFactor.value=1,this.data&&this.data.state!==c.CubeMapState.Ready&&(this.data.state=c.CubeMapState.Idle),this.fadeState){case t.FadeState.CROSS_FADE:h.copy(this.parallax.anchorPoint,this.parallaxNew.anchorPoint),this._fadeState.value=t.FadeState.SHOW;break;case t.FadeState.FADE_IN:this._fadeState.value=t.FadeState.SHOW;break;case t.FadeState.FADE_OUT:this._fadeState.value=t.FadeState.HIDE;break;case t.FadeState.SHOW:case t.FadeState.HIDE:break;default:a.neverReached(this.fadeState)}}_switchReadChannels(){this.data?.state===c.CubeMapState.Ready&&(this._readChannels=1-this._readChannels,this.data.state=c.CubeMapState.Fading)}get isFading(){return this.fadeState===t.FadeState.FADE_OUT||this.fadeState===t.FadeState.FADE_IN||this.fadeState===t.FadeState.CROSS_FADE}}var S;t.FadeState=void 0,(S=t.FadeState||(t.FadeState={}))[S.HIDE=0]="HIDE",S[S.FADE_IN=1]="FADE_IN",S[S.SHOW=2]="SHOW",S[S.CROSS_FADE=3]="CROSS_FADE",S[S.FADE_OUT=4]="FADE_OUT";class _{constructor(){this.anchorPoint=d.create(),this.radiusCurvatureCorrection=0,this.transform=r.create()}}const u=d.fromValues(0,0,1),p=n.create(),f=d.create(),E=1.25,D=.5,C=2e5;t.CloudsParameters=F,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
