/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../chunks/tslib.es6","../../../geometry","../../../core/Evented","../../../core/has","../../../core/maybe","../../../core/reactiveUtils","../../../core/accessorSupport/decorators/property","../../../core/Logger","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../../chunks/vec32","../../../core/libs/gl-matrix-2/factories/vec3f64","../../../geometry/projection","../../../geometry/projection/projectPointToVector","../../../geometry/support/planetGCSUtils","../../../geometry/support/spatialReferenceUtils","../../ViewingMode","./EnvironmentRenderer","../support/earthUtils","../support/sunUtils","../webgl-engine/lib/Update","../webgl-engine/lighting/Lightsources","../../../geometry/SpatialReference"],(function(e,t,i,n,r,a,o,s,h,c,l,g,d,p,_,u,m,v,y,w,f,b,P,E){"use strict";e.EnvironmentManager=class extends n.EventedAccessor{constructor(){super(),this._tmpLightParameters=new f.ColorAndIntensity,this._defaultLightParameters=new f.ColorAndIntensity,this._tmpDate=new Date,this._tmpTz={hours:0,minutes:0,seconds:0},this._viewHandlesKey="viewHandles",this._trackingEnabled=!1,this._mainLight=new P.MainLight,this._ambientLight=new P.AmbientLight,this._moonLight=new P.FillLight,this._disableProjectionEngineAutoLoad=!1,this._disableWeather=!1,this._renderer=null,this._referencePositionGeographic=null,this._resetReferencePosition()}destroy(){this.disconnectView()}get _view(){return this._renderer?.view}get updating(){return!!this._renderer?.updating||!this._canProjectCameraPosition}get weatherEnabled(){return this._view?.environment.atmosphereEnabled&&!this._disableWeather&&this._view?.state?.viewingMode===v.ViewingMode.Global&&m.isEarth(this._view.spatialReference)}get weatherVisible(){return this.weatherEnabled&&this._renderer?.weatherVisible}get referencePositionGeographic(){return this._referencePositionGeographic}get _canProjectCameraPosition(){const e=this._view?.stateManager?.camera?.position?.spatialReference??E.WGS84,t=u.getGCSForPlanet(e);return this._disableProjectionEngineAutoLoad||p.isLoadedOrLoadFor(e,t)}connectView(e){if(this._renderer)return;this._renderer=new y.EnvironmentRenderer({view:e});const t=()=>this._updateRenderParameters(),i=()=>this._cameraHandler();this.addHandles([o.watch((()=>e.environment.lighting),(e=>this._updateLightingHandler(e)),o.sync),o.watch((()=>"virtual"!==e.environment.lighting.type?e.environment.lighting.date:null),(e=>this._lightingDateHandler(e)),o.sync),o.watch((()=>e.environment.lighting.directShadowsEnabled),t,o.sync),o.watch((()=>e.qualitySettings.ambientOcclusion),t,o.sync),o.watch((()=>e.qualitySettings.reflections),t,o.sync),o.watch((()=>e.spatialReference),(()=>this._resetReferencePosition(!0)),o.sync),o.watch((()=>e.environment.weather.type),(()=>this._updateLighting(null,b.Update.FadeWithWeather)),o.sync),o.watch((()=>this.weatherEnabled),(()=>this._updateLighting(null,b.Update.FadeWithWeather)),o.sync),o.watch((()=>e.viewingMode),(()=>this._resetReferencePosition(!0)),o.syncAndInitial),o.watch((()=>"virtual"!==e.environment.lighting.type&&e.environment.lighting.cameraTrackingEnabled),(e=>this._updateCameraTracking(e)),o.syncAndInitial),o.watch((()=>e.state.camera),i,o.syncAndInitial),o.when((()=>this._canProjectCameraPosition),i,o.sync)],this._viewHandlesKey),this._updateRenderParameters(),this._updateLighting(),this._cameraHandler(),this.notifyChange("updating")}disconnectView(){this.removeHandles(this._viewHandlesKey),this._resetReferencePosition(),this._renderer=a.destroyMaybe(this._renderer)}_updateLightingHandler(e){this._updateCameraTracking("virtual"!==e.type&&e.cameraTrackingEnabled),this._lightingDateHandler("virtual"!==e.type?e.date:null),this._updateRenderParameters()}_updateCameraTracking(e){if(this._trackingEnabled=e,e)this._cameraHandler();else{const e=this._view.environment.lighting;"virtual"!==e?.type&&(e.positionTimezoneInfo.autoUpdated=!1)}}_lightingDateHandler(e){const t=this._view.environment.lighting;if("virtual"!==t?.type){if(e){if(!t.positionTimezoneInfo.autoUpdated&&(this._preupdateTracking(e),null!=this._referencePositionGeographic)){const e=w.positionToTimezoneInfo(this._referencePositionGeographic,this._tmpTz);null!=e&&(t.autoUpdate(null,e),this._trackingEnabled&&(t.positionTimezoneInfo.autoUpdated=!0))}this._updateLighting(e)}}else this._updateLighting()}_preupdateTracking(e){!this._trackingEnabled&&"virtual"!==this._view.environment.lighting.type&&this._view.environment.lighting.cameraTrackingEnabled&&this._cameraHandler(e)}_cameraHandler(e=null){const t=this._view;if(!t.ready)return;const i=t.stateManager.camera;if(!i)return;const{position:n}=i,r=n.spatialReference??E.WGS84,a=u.getGCSForPlanet(r),o=this._referencePositionGeographic??d.create();if(!_.projectPointToVector(n,o,a))return this._referencePositionGeographic=null,void this._updateLighting();this._referencePositionGeographic=o,this.notifyChange("referencePositionGeographic"),this._autoUpdateTimezone(o,e)||this._updateLighting(e)}_updateLighting(e,t=b.Update.Immediate){const i=this._view,{lighting:n}=i.environment,r="virtual"===n.type,a=this._referencePositionGeographic,o=null!=a?this._tmpLightParameters:this._defaultLightParameters;if(a){e??=r?null:n.date;const t=this.weatherVisible?i.environment.weather.type:"disabled";f.computeColorAndIntensity(e,a,i.state.viewingMode,t,i.state.camera,o)}else r&&f.computeVirtualLightDirection(i.state.camera,i.state.viewingMode,o.direct.directionToLightSource);const s=this._mainLight,h=o.direct;g.scale(s.intensity,h.color,h.intensity*Math.PI),g.copy(s.direction,h.directionToLightSource),s.specularStrength=o.specularStrength,s.environmentStrength=o.environmentStrength;const c=this._ambientLight;g.scale(c.intensity,o.ambient.color,o.ambient.intensity);const l=this._moonLight;g.lerp(l.intensity,L,T,o.globalFactor);const d=(1-.5*o.globalFactor)*(1-.4*o.noonFactor*(1-o.globalFactor));g.scale(l.intensity,l.intensity,d),g.copy(l.direction,h.directionToLightSource),this._view._stage.renderer.updateLighting([s,c,l],o.noonFactor,o.globalFactor,t),this._updateRenderParameters()}_autoUpdateTimezone(e,t=null){if("virtual"===this._view.environment.lighting.type||!this._view.environment.lighting.cameraTrackingEnabled||null==e)return!1;const i=this._tmpDate;i.setTime((t||this._view.environment.lighting.date).getTime());const n=w.positionToTimezoneInfo(e,this._tmpTz);if(null==n)return!1;let r=this._view.environment.lighting.positionTimezoneInfo;if(r.autoUpdated){if(r.hours===n.hours&&r.minutes===n.minutes&&r.seconds===n.seconds)return!1}else r=n;const a=i.getUTCHours()-(n.hours-r.hours),o=i.getUTCMinutes()-(n.minutes-r.minutes),s=i.getUTCSeconds()-(n.seconds-r.seconds);return i.setUTCHours(a),i.setUTCMinutes(o),i.setUTCSeconds(s),!t&&this._view.environment.lighting.autoUpdate(i,n)}_updateRenderParameters(){const e=this._view._stage;if(!e)return;const t=null==this._referencePositionGeographic||f.computeShadowsEnabled(this._referencePositionGeographic[2],this._view.state.viewingMode);e.renderer.setParameters({shadowMap:this._view.environment.lighting.directShadowsEnabled&&t,environment:this._view.environment,weatherVisible:this._view.environmentManager.weatherVisible,qualitySettings:this._view.qualitySettings})}_resetReferencePosition(e=!1){this._referencePositionGeographic=null,e&&this._cameraHandler()}get test(){}},t.__decorate([s.property({type:Boolean,readOnly:!0})],e.EnvironmentManager.prototype,"updating",null),t.__decorate([s.property()],e.EnvironmentManager.prototype,"_disableProjectionEngineAutoLoad",void 0),t.__decorate([s.property()],e.EnvironmentManager.prototype,"_disableWeather",void 0),t.__decorate([s.property()],e.EnvironmentManager.prototype,"weatherEnabled",null),t.__decorate([s.property()],e.EnvironmentManager.prototype,"weatherVisible",null),t.__decorate([s.property()],e.EnvironmentManager.prototype,"referencePositionGeographic",null),t.__decorate([s.property()],e.EnvironmentManager.prototype,"_renderer",void 0),t.__decorate([s.property()],e.EnvironmentManager.prototype,"_referencePositionGeographic",void 0),t.__decorate([s.property()],e.EnvironmentManager.prototype,"_canProjectCameraPosition",null),e.EnvironmentManager=t.__decorate([l.subclass("esri.views.3d.environment.EnvironmentManager")],e.EnvironmentManager);const L=d.fromValues(.22,.22,.33),T=d.fromValues(.22,.22,.22);Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
