/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../chunks/tslib.es6","../../../core/mathUtils","../../../core/reactiveUtils","../../../core/Logger","../../../core/has","../../../core/RandomLCG","../../../core/Error","../../../core/accessorSupport/decorators/subclass","../../../chunks/vec32","../../../core/libs/gl-matrix-2/factories/vec3f64","../../../geometry/ellipsoidUtils","../webgl","../../../chunks/Fog.glsl","./FogTechnique","./weather","../webgl-engine/effects/TransparentEnvironment","../webgl-engine/lib/basicInterfaces"],(function(e,t,s,r,a,i,n,o,h,c,m,l,p,d,g,u,_,y){"use strict";const w=.95,P=1;e.Fog=class extends _.TransparentEnvironment{constructor(e){super(e),this.requireGeometryDepth=!0,this._newParameters=new f,this._oldParameters=new f,this._fadedParameters=new f,this._parameters=this._newParameters,this._passParameters=new d.FogPassParameters;const{view:t,techniques:s}=e,r=l.getReferenceEllipsoid(t.spatialReference);this._planetRadius=r.radius,this._atmosphereRadius=r.radius+r.atmosphereHeight,s.precompile(g.FogTechnique)}toogle(){this.view.environment.atmosphereEnabled&&this.view.environment.weather?this._enable():this._disable()}initialize(){this.addHandles([r.watch((()=>this.view.environment.atmosphereEnabled),(()=>this.toogle()),r.syncAndInitial),r.watch((()=>this.view.environment.weather),(()=>this.toogle()),r.syncAndInitial),r.watch((()=>this._updateFogParameters()),(()=>{}),r.syncAndInitial)]),this.addHandles(r.watch((()=>this._fadeFactor),(e=>this._fade(e)),r.syncAndInitial))}get _fadeFactor(){return this.view._stage?.renderer.renderContext.bind.clouds.fadeFactor??1}_fade(e){const{_newParameters:t,_oldParameters:s}=this;e>=1?(this._parameters=t,this._oldParameters.copyFrom(this._newParameters)):e<=0?this._parameters=s:(this._fadedParameters.lerp(s,t,e),this._parameters=this._fadedParameters)}_updateFogParameters(){const e=this.view.environment.weather,t="foggy"===e.type||"snowy"===e.type||"rainy"===e.type;this._newParameters.strength="foggy"===e.type?s.lerp(3e-5,.005,e.fogStrength**3):"snowy"===e.type||"rainy"===e.type?s.lerp(4e-6,2e-4,(e.precipitation??0)**3):0,this._newParameters.amount=t?1:0,"foggy"!==e.type&&"snowy"!==e.type||c.copy(this._newParameters.color,T),"rainy"===e.type&&c.copy(this._newParameters.color,F),this._fadeFactor>=1&&this._oldParameters.copyFrom(this._newParameters),this.requestRender(y.RenderRequestType.UPDATE)}render(e){const t=e.find((({name:e})=>e===p.InternalRenderCategory.TRANSPARENT_ENVIRONMENT));if(0===this._parameters.amount)return t;if(this._update(),this._passParameters.amount<=0)return t;const s=this.techniques.acquire(g.FogTechnique);if(!s.compiled)return this.requestRender(y.RenderRequestType.UPDATE),s.release(),t;const r=this.renderingContext,a=t.getAttachment(r.gl.DEPTH_STENCIL_ATTACHMENT);return t.attachDepth(null),r.bindFramebuffer(t.fbo),r.bindTechnique(s,this.bindParameters,this._passParameters),r.screen.draw(),t.attachDepth(a),s.release(),t}_update(){const e=this.bindParameters.camera;c.normalize(b,e.eye);const t=Math.max(0,c.dot(b,this.bindParameters.lighting.mainLight.direction)),r=this._parameters.color,a=.1;c.scale(v,r,a),c.lerp(this._passParameters.color,v,r,t);const i=c.length(e.eye);this._passParameters.atmosphereC=i**2-this._atmosphereRadius**2,this._passParameters.amount=(1-s.smoothstep(w*u.heightLimit,P*u.heightLimit,Math.abs(i-this._planetRadius)))*this._parameters.amount,this._passParameters.strength=this._parameters.strength}},e.Fog=t.__decorate([h.subclass("esri.views.3d.environment.Fog")],e.Fog);class f{constructor(){this.color=m.create(),this.strength=0,this.amount=0}copyFrom(e){this.amount=e.amount,this.strength=e.strength,c.copy(this.color,e.color)}lerp(e,t,r){this.amount=s.lerp(e.amount,t.amount,r),this.strength=s.lerp(e.strength,t.strength,r),c.lerp(this.color,e.color,t.color,r)}}const b=m.create(),v=m.create(),F=m.fromValues(.5,.5,.5),T=m.fromValues(1.5,1.5,1.5);e.FogParameters=f,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
