/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../core/mathUtils","../../../core/maybe","../../../core/reactiveUtils","../../../core/Logger","../../../core/has","../../../core/RandomLCG","../../../core/Error","../../../core/accessorSupport/decorators/subclass","../../../core/libs/gl-matrix-2/math/mat4","../../../core/libs/gl-matrix-2/factories/mat4f64","../../../core/libs/gl-matrix-2/math/vec2","../../../chunks/vec32","../../../core/libs/gl-matrix-2/factories/vec3f64","../../../geometry/ellipsoidUtils","../../../geometry/support/FloatArray","../webgl","./atmosphereUtils","../../../chunks/SimpleAtmosphere.glsl","./SimpleAtmosphereTechnique","./SimpleAtmosphereTechniqueConfiguration","./resources/MarsAtmosphereTexture","../support/mathUtils","../support/buffer/glUtil","../support/buffer/InterleavedLayout","../webgl-engine/effects/OpaqueEnvironment","../webgl-engine/lib/basicInterfaces","../webgl-engine/lib/DefaultVertexAttributeLocations","../webgl-engine/lib/glUtil3D","../webgl-engine/lib/Util","../webgl-engine/lib/VertexArrayObject","../webgl-engine/lib/VertexAttribute","../../webgl/BufferObject","../../webgl/enums","../../webgl/Texture","../../webgl/TextureDescriptor","../../webgl/Util"],(function(e,t,s,r,i,a,o,n,h,c,l,u,m,p,d,_,g,f,b,A,x,y,V,w,v,P,R,T,S,q,M,C,F,U,E,O,D){"use strict";const I=128,L=-f.innerAtmosphereDepth,j=0,G=50,N=()=>1-511/512,W=V.makePiecewiseLinearFunction([[50,.1015625],[500,.21875],[5e3,1-250/512],[5e4,.4140625]]);let k=class extends P.OpaqueEnvironment{constructor(e){super(e),this._passParameters=new b.SimpleAtmospherePassParameters,this._configuration=new x.SimpleAtmosphereTechniqueConfiguration,this._vao=null,this._vaoCount=0,this._fadeVao=null,this._fadeVaoCount=0,this._texV1=1;const{view:t,techniques:s}=e,r=d.getReferenceEllipsoid(t.spatialReference),{outerAtmosphereRimWidth:i,radius:a}=r;this._planetRadius=a,this._innerRimFactor=1+L/a,this._middleRimFactor=1+j/a,this._outerRimFactor=1+i/a,this._texV0=j/i,this._texVScale=this._texV1-this._texV0,s.precompile(A.SimpleAtmosphereTechnique,this._configuration),this._configuration.geometry=x.SimpleAtmosphereGeometry.Underground,s.precompile(A.SimpleAtmosphereTechnique,this._configuration)}initialize(){this.addHandles(r.watch((()=>this.view.environment.atmosphereEnabled),(e=>e?this._enable():this._disable()),r.initial))}destroy(){this._passParameters.texture=s.disposeMaybe(this._passParameters.texture),this._fadeVao=s.disposeMaybe(this._fadeVao),this._vao=s.disposeMaybe(this._vao)}render(e){const t=e.find((({name:e})=>e===g.InternalRenderCategory.OPAQUE_ENVIRONMENT));this._update();const s=this.renderingContext;if(!this._passParameters.texture){const e=new O.TextureDescriptor;e.wrapMode=U.TextureWrapMode.CLAMP_TO_EDGE,e.flipped=!0,e.width=1,e.height=512,this._passParameters.texture=new E.Texture(s,e,y.marsAtmosphereTextureSimple)}if(this._passParameters.undergroundFadeAlpha<1){this._vao||(this._vao=this._createRibbon(s),this._vaoCount=D.vertexCount(this._vao,"geometry")),this._configuration.geometry=x.SimpleAtmosphereGeometry.Cone;const e=this.techniques.acquire(A.SimpleAtmosphereTechnique,this._configuration);if(!e.compiled)return e.release(),this.requestRender(R.RenderRequestType.UPDATE),t;s.bindTechnique(e,this.bindParameters,this._passParameters),s.bindVAO(this._vao),s.drawArrays(U.PrimitiveType.TRIANGLES,0,this._vaoCount),e.release()}if(this._passParameters.undergroundFadeAlpha>0){this._fadeVao||(this._fadeVao=S.createQuadVAO(s),this._fadeVaoCount=D.vertexCount(this._fadeVao,"geometry")),this._configuration.geometry=x.SimpleAtmosphereGeometry.Underground;const e=this.techniques.acquire(A.SimpleAtmosphereTechnique,this._configuration);if(!e.compiled)return e.release(),this.requestRender(R.RenderRequestType.UPDATE),t;s.bindTechnique(e,this.bindParameters,this._passParameters),s.bindVAO(this._fadeVao),s.drawArrays(U.PrimitiveType.TRIANGLE_STRIP,0,this._fadeVaoCount),e.release()}return t}_update(){const e=this.bindParameters.camera,s=p.create(),r=this._planetRadius,i=m.length(e.eye),a=i-r;if(a<0){const e=Math.min(-a/5e3,1);this._passParameters.undergroundFadeAlpha=e}else this._passParameters.undergroundFadeAlpha=0;const o=Math.max(G,a),n=r+L;this._passParameters.innerScale=J(r+o,r,n)-1,this._passParameters.altitudeFade=f.computeInnerAltitudeFade(a),m.scale(s,e.eye,(r+G)/i),B(s,e.center,e.up,r,this._passParameters.silhouette);const h=this._computeScreenRimWidth(e,s,e.up,this._passParameters.silhouette),c=N(),l=W(a);let d=this._texV0+c*this._texVScale,_=this._texV0+h*l*this._texVScale;if(a>G){B(e.eye,e.center,e.up,r,this._passParameters.silhouette);const s=this._computeScreenRimWidth(e,e.eye,e.up,this._passParameters.silhouette),i=t.clamp((s-1.5)/(h-1.5),0,1);d=this._texV0+i*c*this._texVScale,_=this._texV0+t.lerp(this._texV1,h*l,i)*this._texVScale}u.set(this._passParameters.texV,d,_)}_createRibbon(e){const t=_.newFloatArray(3+3*I*3),s=new Uint32Array(3*I*5);t[0]=0,t[1]=0,t[2]=-1;for(let a=0;a<I;a++){const e=9*a+3;t[e]=a,t[e+1]=this._innerRimFactor,t[e+2]=-1,t[e+3]=a,t[e+4]=this._middleRimFactor,t[e+5]=0,t[e+6]=a,t[e+7]=this._outerRimFactor,t[e+8]=1;const r=3*a+1,i=a===I-1?1:r+3,o=15*a;s[o]=r,s[o+1]=r+1,s[o+2]=i+1,s[o+3]=i+1,s[o+4]=i,s[o+5]=r,s[o+6]=r+1,s[o+7]=r+2,s[o+8]=i+2,s[o+9]=i+2,s[o+10]=i+1,s[o+11]=r+1,s[o+12]=r,s[o+13]=i,s[o+14]=0}const r=K.createBuffer(s.length),i=r.position;for(let a=0;a<s.length;++a){const e=3*s[a];i.set(a,0,t[e]),i.set(a,1,t[e+1]),i.set(a,2,t[e+2])}return new M.VertexArrayObject(e,T.Default3D,new Map([["geometry",w.glLayout(K)]]),new Map([["geometry",F.BufferObject.createVertex(e,U.Usage.STATIC_DRAW,r.buffer)]]))}_computeScreenRimWidth(e,t,s,r){return m.add(z,r.center,r.v2),m.scale(H,z,this._outerRimFactor),c.lookAt(Q,t,z,s),q.project(z,Q,e.projectionMatrix,e.viewport,z),q.project(H,Q,e.projectionMatrix,e.viewport,H),m.distance(z,H)/e.height}};function B(e,t,s,r,i){const a=m.length(e),o=r*Math.sqrt(a*a-r*r)/a,n=Math.sqrt(r*r-o*o),h=i.v1,c=i.v2;return m.scale(i.center,e,n/a),m.cross(h,e,t),m.squaredLength(h)<1&&m.cross(h,e,s),m.scale(h,h,o/m.length(h)),m.cross(c,h,e),m.scale(c,c,o/m.length(c)),o}k=e.__decorate([h.subclass("esri.views.3d.environment.MarsAtmosphere")],k);const Q=l.create(),z=p.create(),H=p.create();function J(e,t,s){return e*e/(Math.sqrt(e*e-t*t)*Math.sqrt(e*e-s*s)+t*s)}const K=v.newLayout().vec3f(C.VertexAttribute.POSITION);return k}));
