/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../chunks/tslib.es6","../../../core/mathUtils","../../../core/maybe","../../../core/reactiveUtils","../../../core/time","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/Logger","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../../geometry/ellipsoidUtils","../webgl","./PrecipitationTechnique","./PrecipitationTechniqueConfiguration","../support/buffer/glUtil","../support/buffer/InterleavedLayout","../webgl/RenderNode","../webgl-engine/lib/basicInterfaces","../webgl-engine/lib/VertexArrayObject","../webgl-engine/lib/VertexAttribute","../../webgl/BufferObject","../../webgl/enums","../../webgl/Util"],(function(e,t,i,r,s,a,n,o,c,d,p,u,l,h,y,_,f,m,P,b,g,T,A,w){"use strict";function I(e,t){const i=new Float32Array([-1,0,1,1,0,-1,1,0,1]);return new b.VertexArrayObject(e,t,new Map([["geometry",_.glLayout(v)]]),new Map([["geometry",T.BufferObject.createVertex(e,A.Usage.STATIC_DRAW,i)]]))}e.Precipitation=class extends m{constructor(e){super(e),this.consumes={required:[l.InternalRenderCategory.TRANSPARENT_ENVIRONMENT]},this.produces=l.InternalRenderCategory.TRANSPARENT_ENVIRONMENT,this._rainSpeed=.1,this._snowSpeed=.01,this._numParticles=0,this._passParameters=new h.PrecipitationPassParameters,this._configuration=new y.PrecipitationTechniqueConfiguration;const{view:t,type:i,techniques:r}=e;this._configuration.type="rainy"===i?y.PrecipitationType.Rain:y.PrecipitationType.Snow,r.precompile(h.PrecipitationTechnique,this._configuration),this._passParameters.time=0,this._passParameters.radius=u.getReferenceEllipsoid(t.spatialReference).radius,this.addHandles(s.watch((()=>t.environment.weather),(e=>{e.type===i&&this.addHandles(s.watch((()=>e.precipitation),(e=>this._adjustParticles(e)),s.syncAndInitial))}),s.syncAndInitial)),this.addHandles(s.watch((()=>t._stage?.renderer.renderContext.bind.clouds.fadeFactor??1),(e=>{this._passParameters.opacity=e,1===e&&(this.removeHandles("opacity"),this.addHandles(s.watch((()=>t._stage?.renderer.renderContext.bind.clouds.opacity??1),(e=>this._passParameters.opacity=e),s.syncAndInitial),"opacity"))}),s.sync),"opacity")}_adjustParticles(e){const t=.35,r=e<.5?i.lerp(0,t,2*e):i.lerp(t,1,2*(e-.5));this._numParticles=R*r}destroy(){this._numParticles=0,this._vao=r.disposeMaybe(this._vao),this._instanceIdBuffer=r.disposeMaybe(this._instanceIdBuffer)}fadeOut(e){this.removeAllHandles(),this.addHandles(s.watch((()=>this.renderContext?.bind.clouds.fadeFactor??1),(t=>{this._passParameters.opacity=1-t,1===t&&(this.removeAllHandles(),e())})),"opacity")}updateAnimation(e){const t=("rainy"===this.type?this._rainSpeed:this._snowSpeed)*a.secondsFromMilliseconds(e.time)%1e5;return this._passParameters.time!==t&&(this._passParameters.time=t,!0)}render(e){const t=this.renderingContext;this._instanceIdBuffer??=this._createInstanceIndices(t);const i=Math.round(this._numParticles*this._passParameters.opacity),r=e.find((({name:e})=>e===l.InternalRenderCategory.TRANSPARENT_ENVIRONMENT));if(i<1)return r;const s=this.techniques.acquire(h.PrecipitationTechnique,this._configuration);if(!s.compiled)return s.release(),this.requestRender(P.RenderRequestType.UPDATE),r;const a=t.bindTechnique(s,this.bindParameters,this._passParameters);return this._vao??=I(t,s.locations),t.bindVAO(this._vao),a.assertCompatibleVertexAttributeLocations(this._vao),w.bindVertexBufferLayout(t,s.locations,this._instanceIdBuffer,N,0),t.drawArraysInstanced(A.PrimitiveType.TRIANGLES,0,3,i),w.unbindVertexBufferLayout(t,s.locations,this._instanceIdBuffer,N),s.release(),r}_createInstanceIndices(e){const t=[];for(let i=0;i<R;i++)t.push(i);return T.BufferObject.createVertex(e,A.Usage.STATIC_DRAW,new Float32Array(t))}},t.__decorate([n.property()],e.Precipitation.prototype,"consumes",void 0),t.__decorate([n.property()],e.Precipitation.prototype,"produces",void 0),t.__decorate([n.property({constructOnly:!0})],e.Precipitation.prototype,"type",void 0),t.__decorate([n.property({constructOnly:!0})],e.Precipitation.prototype,"techniques",void 0),e.Precipitation=t.__decorate([p.subclass("esri.views.3d.environment.Precipitation")],e.Precipitation);const R=25e4,v=f.newLayout().vec3f(g.VertexAttribute.POSITION),N=_.glLayout(f.newLayout().f32(g.VertexAttribute.INSTANCEFEATUREATTRIBUTE),1);Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
