/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../geometry","../../../core/compilerUtils","../../../core/Evented","../../../core/handleUtils","../../../core/has","../../../core/mathUtils","../../../core/maybe","../../../core/screenUtils","../../../core/libs/gl-matrix-2/math/mat3","../../../core/libs/gl-matrix-2/factories/mat3f64","../../../core/libs/gl-matrix-2/math/mat4","../../../core/libs/gl-matrix-2/factories/mat4f64","../../../core/libs/gl-matrix-2/math/vec2","../../../chunks/vec32","../../../core/libs/gl-matrix-2/factories/vec3f64","../../../geometry/ellipsoidUtils","../../../geometry/projection","../../../geometry/projection/localRotationUtils","../../../geometry/projection/projectors","../../../geometry/support/aaBoundingRect","../../../geometry/support/lineSegment","../../../geometry/support/plane","../../../geometry/support/ray","../../../geometry/support/vectorStacks","../../../layers/graphics/hydratedFeatures","../../../support/elevationInfoUtils","../support/ElevationProvider","../support/geometryUtils/ray","../webgl/RenderCamera","../webgl-engine/lib/Object3D","../webgl-engine/lib/UpdatePolicy","../webgl-engine/lib/WebGLLayer","../../interactive/interfaces","../../../geometry/Point"],(function(e,t,i,n,s,o,r,a,c,l,h,d,u,_,g,f,m,p,y,b,v,S,L,R,j,O,w,A,T,E,P,M,F,D,C){"use strict";class z{constructor(e){this.metadata=void 0,this._camera=new E,this._elevation={offset:0,override:null},this.collisionType={type:"point"},this.collisionPriority=0,this._renderObjects=new Array,this.autoScaleRenderObjects=!0,this._available=!0,this._noDisplayCount=0,this._radius=10,this._worldSized=!1,this.focusMultiplier=2,this.touchMultiplier=2.5,this.worldOriented=!1,this._modelTransform=u.create(),this._worldFrame=null,this._renderLocation=f.create(),this._renderLocationDirty=!0,this._location=new C({x:0,y:0,z:0}),this._elevationAlignedLocation=new C,this._elevationAlignedLocationDirty=!0,this.interactive=!0,this.selectable=!1,this.grabbable=!0,this.consumesClicks=!0,this.cursor=null,this.grabCursor=null,this._grabbing=!1,this.dragging=!1,this._hovering=!1,this._selected=!1,this._state=D.ManipulatorStateCustomFlags.None,this._focused=!1,this.events=new n.EventEmitter,this._screenLocation={screenPointArray:c.createScreenPointArray(),renderScreenPointArray:c.createRenderScreenPointArray3(),pixelSize:0},this._screenLocationDirty=!0,this._engineResourcesAddedToStage=!1,this._attached=!1,this._location.spatialReference=e.view.spatialReference,Object.assign(this,e);const t=this.view.state?.camera;t&&this._camera.copyFrom(t)}destroy(){this._applyObjectTransform=X,this._removeResourcesFromStage(),this._engineResources=null,this.view=null,this._camera=null}get _stage(){return this.view?._stage}get elevationInfo(){return this._elevationInfo}set elevationInfo(e){this._elevationInfo=e,this._elevationAlignedLocationDirty=!0,this._renderLocationDirty=!0,this._updateEngineObject()}get renderObjects(){return this._renderObjects}set renderObjects(e){this._removeResourcesFromStage(),this._engineResources=null,this._renderObjects=e.slice(),this._updateEngineObject()}set available(e){e!==this._available&&(this._available=e,this._updateEngineObject())}get available(){return this._available}disableDisplay(){return this._noDisplayCount++,1===this._noDisplayCount&&this._updateEngineObject(),s.makeHandle((()=>{this._noDisplayCount--,0===this._noDisplayCount&&this._updateEngineObject()}))}set radius(e){e!==this._radius&&(this._radius=e,this._updateEngineObject())}get radius(){return this._radius}set worldSized(e){e!==this._worldSized&&(this._worldSized=e,this._updateEngineObject())}get worldSized(){return this._worldSized}get modelTransform(){return this._modelTransform}set modelTransform(e){I(e)&&(this._screenLocationDirty=!0),d.copy(this._modelTransform,e),this._updateEngineObject()}get renderLocation(){return this._renderLocationDirty&&(this._renderLocationDirty=!1,this.view.renderCoordsHelper.toRenderCoords(this.elevationAlignedLocation,this._renderLocation),this.worldOriented?(this._worldFrame||(this._worldFrame=u.create()),x(this.view,this._renderLocation,this._worldFrame)):this._worldFrame&&(this._worldFrame=null)),this._renderLocation}set renderLocation(e){this.view.renderCoordsHelper.fromRenderCoords(e,this._location),this.elevationAlignedLocation=this._location}get location(){return this._location}set location(e){O.clonePoint(e,this._location),this._notifyLocationChanged()}_notifyLocationChanged(){this._renderLocationDirty=!0,this._screenLocationDirty=!0,this._elevationAlignedLocationDirty=!0,this._updateEngineObject(),this.events.emit("location-update",{location:this._location})}get elevationAlignedLocation(){return this._elevationAlignedLocationDirty?(this._evaluateElevationAlignment(),this._updateElevationAlignedLocation(),this._elevationAlignedLocation):this._elevationAlignedLocation}set elevationAlignedLocation(e){O.clonePoint(e,this._location),this._evaluateElevationAlignment(),this._location.z-=this._elevation.offset,this._updateElevationAlignedLocation(),this._updateEngineObject(),this.events.emit("location-update",{location:this._location})}_updateElevationAlignedLocation(){const e=null!=this._elevation.override?this._elevation.override:this.location.z||0;this._elevationAlignedLocation.x=this.location.x,this._elevationAlignedLocation.y=this.location.y,this._elevationAlignedLocation.z=e+this._elevation.offset,this._elevationAlignedLocation.spatialReference=O.hydratedSpatialReference(this.location.spatialReference),this._renderLocationDirty=!0,this._screenLocationDirty=!0,this._elevationAlignedLocationDirty=!1}grabbableForEvent(){return!0}get grabbing(){return this._grabbing}set grabbing(e){e!==this._grabbing&&(this._grabbing=e,this._setFocused(this._hovering||this._grabbing),this._updateEngineObject())}get hovering(){return this._hovering}set hovering(e){e!==this._hovering&&(this._hovering=e,this._setFocused(this._hovering||this._grabbing),this._updateEngineObject())}get selected(){return this._selected}set selected(e){e!==this._selected&&(this._selected=e,this._updateEngineObject(),this.events.emit("select-changed",{action:e?"select":"deselect"}))}get state(){return this._state}set state(e){e!==this._state&&(this._state=e,this._updateEngineObject())}updateStateEnabled(e,t){t?this.state|=e:this.state&=~e}_setFocused(e){e!==this._focused&&(this._focused=e,this.events.emit("focus-changed",{action:!0===e?"focus":"unfocus"}))}get focused(){return this._focused}get screenLocation(){return this._ensureScreenLocation(),this._screenLocation}_ensureScreenLocation(){if(!this._screenLocationDirty)return;this._screenLocation.pixelSize=this._camera.computeScreenPixelSizeAt(this.renderLocation),this._screenLocationDirty=!1;let e;if(I(this._modelTransform)){const t=this._calculateModelTransformOffset(K);e=g.add(t,t,this.renderLocation)}else e=this.renderLocation;this._camera.projectToRenderScreen(e,this._screenLocation.renderScreenPointArray),this._camera.renderToScreen(this._screenLocation.renderScreenPointArray,this._screenLocation.screenPointArray)}get applyObjectTransform(){return this._applyObjectTransform}set applyObjectTransform(e){this._applyObjectTransform=e,this._screenLocationDirty=!0,this._updateEngineObject()}get attached(){return this._attached}intersectionDistance(e,t){if(!this.available)return null;const n=c.screenPointObjectToArray(e,k),s=this._getCollisionRadius(t),o=-1*this.collisionPriority;switch(this.collisionType.type){case"point":if(_.squaredDistance(this.screenLocation.screenPointArray,n)<s*s)return this.screenLocation.renderScreenPointArray[2]+o;break;case"line":{const e=this.collisionType.paths,t=this._getWorldToScreenObjectScale(),i=this._calculateObjectTransform(t,H),r=s*this.screenLocation.pixelSize,a=T.fromScreen(this._camera,n,W);if(null==a)return null;for(const n of e){if(0===n.length)continue;const e=g.transformMat4(G,n[0],i);for(let t=1;t<n.length;t++){const s=g.transformMat4(V,n[t],i),l=S.closestRayDistance2(S.fromPoints(e,s,U),a);if(null!=l&&l<r*r){const t=g.add(j.sv3d.get(),e,s);g.scale(t,t,.5);const i=c.castRenderScreenPointArray(j.sv3d.get());return this._camera.projectToRenderScreen(t,i),i[2]+o}g.copy(e,s)}}break}case"disc":{const e=this.collisionType.direction,t=this.collisionType.offset??f.ZEROS,i=this._getWorldToScreenObjectScale(),r=this._calculateObjectTransform(i,H),a=s*this.screenLocation.pixelSize,c=T.fromScreen(this._camera,n,W);if(null==c)return null;const h=l.fromMat4(N,r),d=g.transformMat3(Z,e,h),u=g.transformMat4(J,t,r);L.fromPositionAndNormal(u,d,q);const _=Y;if(L.intersectRay(q,c,_)&&g.squaredDistance(_,u)<a*a)return this.screenLocation.renderScreenPointArray[2]+o;break}case"ribbon":{const{paths:e,direction:t}=this.collisionType,i=this._getWorldToScreenObjectScale(),r=this._calculateObjectTransform(i,H),a=s*this._camera.computeScreenPixelSizeAt(this.renderLocation),h=T.fromScreen(this._camera,n,W);if(null==h)return null;const d=l.fromMat4(N,r),u=g.transformMat3(Z,t,d),_=this._calculateModelTransformPosition(J);L.fromPositionAndNormal(_,u,q);const f=Y;if(!L.intersectRay(q,h,f))break;for(const n of e){if(0===n.length)continue;const e=g.transformMat4(G,n[0],r);for(let t=1;t<n.length;t++){const i=g.transformMat4(V,n[t],r),s=S.distance2(S.fromPoints(e,i,U),f);if(null!=s&&s<a*a){const t=g.add(j.sv3d.get(),e,i);g.scale(t,t,.5);const n=c.castRenderScreenPointArray(j.sv3d.get());return this._camera.projectToRenderScreen(t,n),n[2]+o}g.copy(e,i)}}break}default:i.neverReached(this.collisionType)}return null}attach(e={manipulator3D:{}}){const t=this._stage;if(!t)return;const i=e.manipulator3D;null==i.engineLayerId?(this._engineLayer=new F.WebGLLayer(t,{pickable:!1,updatePolicy:M.UpdatePolicy.SYNC}),i.engineLayerId=this._engineLayer.id):t?.getObject&&(this._engineLayer=t.getObject(i.engineLayerId)),i.engineLayerReferences=(i.engineLayerReferences||0)+1,this._materialIdReferences=i.materialIdReferences,null==this._materialIdReferences&&(this._materialIdReferences=new Map,i.materialIdReferences=this._materialIdReferences),this._camera.copyFrom(this.view.state.camera),this._attached=!0,this._updateEngineObject(),p.canProjectWithoutEngine(this._location.spatialReference,this.view.spatialReference)||(this.location=new C({x:0,y:0,z:0,spatialReference:this.view.spatialReference}))}detach(e={manipulator3D:{}}){const t=e.manipulator3D;t.engineLayerReferences--;const i=0===t.engineLayerReferences;this._removeResourcesFromStage(),i&&(t.engineLayerId=null,a.destroyMaybe(this._engineLayer)),this._engineResources=null,this._engineLayer=null,this._materialIdReferences=null,this._attached=!1}onViewChange(){this._camera.copyFrom(this.view.state.camera),this._screenLocationDirty=!0,this._updateEngineObject()}onElevationChange(e){p.projectPoint(this.location,Q,e.spatialReference)&&v.containsPointObject(e.extent,Q)&&this._notifyLocationChanged()}_evaluateElevationAlignment(){if(null==this.elevationInfo)return;let e=null,t=0;const i=w.getElevationOffset(this.elevationInfo,this.location.spatialReference??this.view.elevationProvider.spatialReference);switch(this.elevationInfo.mode){case"on-the-ground":e=A.getElevationAtPoint(this.view.elevationProvider,this.location,"ground")??0;break;case"relative-to-ground":t=(A.getElevationAtPoint(this.view.elevationProvider,this.location,"ground")??0)+i;break;case"relative-to-scene":t=(A.getElevationAtPoint(this.view.elevationProvider,this.location,"scene")??0)+i;break;case"absolute-height":t=i}return t!==this._elevation.offset||e!==this._elevation.override?(this._elevation.offset=t,void(this._elevation.override=e)):void 0}_updateEngineObject(){if(!this._attached)return;if(!this.available)return void this._removeResourcesFromStage();const e=this._getWorldToScreenObjectScale(),t=H;if(!0===this.autoScaleRenderObjects){const i=this._getFocusedSize(this._radius,this.focused)*e;this._calculateObjectTransform(i,t)}else this._calculateObjectTransform(e,t);const{objectsByState:i}=this._ensureEngineResources(),n=(this.focused?D.ManipulatorStateFlags.Focused:D.ManipulatorStateFlags.Unfocused)|(this.selected?D.ManipulatorStateFlags.Selected:D.ManipulatorStateFlags.Unselected),s=this._noDisplayCount>0;for(const{stateMask:o,objects:r}of i){if(s){for(const e of r)e.visible=!1;continue}const e=(o&D.ManipulatorStateFlags.All)!==D.ManipulatorStateFlags.None,i=(o&D.ManipulatorStateCustomFlags.All)!==D.ManipulatorStateCustomFlags.None,a=!e||(n&o)==(o&D.ManipulatorStateFlags.All),c=!i||(this.state&o)==(o&D.ManipulatorStateCustomFlags.All);if(a&&c)for(const n of r)n.visible=!0,n.transformation=t;else for(const t of r)t.visible=!1}}_ensureEngineResources(){if(null==this._engineResources){const e=this._engineLayer,t=[],i=new Set;this.renderObjects.forEach((({geometry:{material:e}})=>{i.has(e)||(t.push(e),i.add(e))}));const n=new Map;this._renderObjects.forEach((e=>{const t=new P.Object3D({castShadow:!1,geometries:[e.geometry]}),i=n.get(e.stateMask)||[];i.push(t),n.set(e.stateMask,i)}));const s=[];n.forEach(((e,t)=>s.push({stateMask:t,objects:e}))),this._engineResources={objectsByState:s,layer:e,materials:t}}return this._addResourcesToStage(),this._engineResources}_addResourcesToStage(){const e=this._stage;if(this._engineResourcesAddedToStage||null==this._engineResources||!e)return;const{objectsByState:t,layer:i,materials:n}=this._engineResources;n.forEach((t=>{const i=this._materialIdReferences,n=i.get(t.id)||0;0===n&&e.add(t),i.set(t.id,n+1)})),t.forEach((({objects:t})=>{i.addMany(t),e.addMany(t)})),this._engineResourcesAddedToStage=!0}_removeResourcesFromStage(){const e=this._stage;if(!this._engineResourcesAddedToStage||null==this._engineResources||!e)return;const{objectsByState:t,layer:i,materials:n}=this._engineResources;t.forEach((({objects:t})=>{i.removeMany(t),e.removeMany(t)})),n.forEach((t=>{const i=this._materialIdReferences,n=i.get(t.id);1===n?(e.remove(t),i.delete(t.id)):i.set(t.id,n-1)})),this._engineResourcesAddedToStage=!1}_getCollisionRadius(e){return this._getFocusedSize(this.radius,!0)*("touch"===e?this.touchMultiplier:1)}_getFocusedSize(e,t){return e*(t?this.focusMultiplier:1)}_getWorldToScreenObjectScale(){return this._worldSized?1:this.screenLocation.pixelSize}_calculateModelTransformPosition(e){const t=this._getWorldToScreenObjectScale(),i=this._calculateObjectTransform(t,B);return g.set(e,i[12],i[13],i[14])}_calculateModelTransformOffset(e){const t=this._calculateModelTransformPosition(e);return g.subtract(e,t,this.renderLocation)}_calculateObjectTransform(e,t){return d.set(t,e,0,0,0,0,e,0,0,0,0,e,0,0,0,0,1),this._worldFrame&&d.multiply(t,t,this._worldFrame),d.multiply(t,t,this._modelTransform),t[12]+=this.renderLocation[0],t[13]+=this.renderLocation[1],t[14]+=this.renderLocation[2],t[15]=1,null!=this._applyObjectTransform&&this._applyObjectTransform(t),t}get test(){}}function I(e){return 0!==e[12]||0!==e[13]||0!==e[14]}function x(e,t,i){switch(e.viewingMode){case"local":return d.identity(i),!0;case"global":{const n=m.getReferenceEllipsoid(e.renderCoordsHelper.spatialReference);return b.sphericalPCPFtoLonLatElevation(t,0,G,0,n.radius),y.computeENUToPCPFLocalRotation(r.deg2rad(G[0]),r.deg2rad(G[1]),i),!0}}}const k=c.createScreenPointArray(),U=S.create(),W=R.create(),N=h.create(),B=u.create(),H=u.create(),q=L.create(),G=f.create(),V=f.create(),Y=f.create(),Z=f.create(),J=f.create(),K=f.create(),Q=new C({x:0,y:0,z:0,spatialReference:null}),X=()=>{};e.Manipulator3D=z,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
