/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../Color","../../../core/colorUtils","../../../core/has","../../../core/handleUtils","../../../chunks/vec32","../../../core/libs/gl-matrix-2/factories/vec3f64","../../../geometry/projection/projectVectorToVector","../../../support/elevationInfoUtils","./support/viewUtils","./visualElements/ExtendedLineVisualElement","./visualElements/ParallelLineVisualElement","./visualElements/PointVisualElement","./visualElements/RightAngleQuadVisualElement","../layers/interfaces","../webgl-engine/lib/Material","../../interactive/sketch/normalizedPoint","../../interactive/snapping/Settings","../../interactive/snapping/SnappingDomain","../../interactive/snapping/snappingUtils","../../interactive/snapping/SnappingVisualizer","../../interactive/snapping/hints/LineSnappingHint"],(function(e,n,i,t,r,l,a,o,s,d,c,p,u,g,f,v,h,E,m,S,R,O){"use strict";class H extends R.SnappingVisualizer{sortUniqueHints(e){return e.sort(((e,n)=>(n instanceof O.LineSnappingHint?n.length:0)-(e instanceof O.LineSnappingHint?e.length:0)))}visualizeIntersectionPoint(e,n){const{spatialReference:i,view:t}=n,l=C(n);return r.destroyHandle(new u.PointVisualElement({view:t,primitive:"circle",geometry:h.toDehydratedPoint(e.intersectionPoint,i),elevationInfo:e.isDraped?s.onTheGroundElevationInfo:s.absoluteHeightElevationInfo,size:20,outlineSize:2,color:l.intersectionPointColor,outlineColor:l.intersectionPointOutlineColor,pixelSnappingEnabled:!1,isDecoration:!0,attached:!0}))}visualizePoint(e,n){const{view:i,spatialReference:t}=n,l=C(n),a=D(e.point,e.domain,n);return r.destroyHandle(new u.PointVisualElement({view:i,primitive:"circle",geometry:h.toDehydratedPoint(a,t),elevationInfo:w(e),size:20,outlineSize:2,color:l.pointColor,outlineColor:l.pointOutlineColor,pixelSnappingEnabled:!1,isDecoration:!0,attached:!0}))}visualizeLine(e,n){const{view:i,spatialReference:t}=n,l=C(n),a=D(e.lineStart,e.domain,n),o=D(e.lineEnd,e.domain,n);return r.destroyHandle(y(e.type,a,o,t,w(e),i,l,e.isDraped,e.fadeLeft,e.fadeRight))}visualizeParallelSign(e,n){const{view:i,spatialReference:t}=n,a=C(n),{isDraped:o}=e,s=w(e),d=D(e.lineStart,e.domain,n),c=D(e.lineEnd,e.domain,n),u=T(d,t,s,i,o),g=T(c,t,s,i,o),h=l.lerp(g,u,g,.5),m=new p.ParallelLineVisualElement({view:i,attached:!1,offset:E.defaults.parallelLineHintOffset,length:E.defaults.parallelLineHintLength,width:E.defaults.parallelLineHintWidth,color:a.parallelSignColor,location:h,renderOccluded:o?v.RenderOccludedFlag.OccludeAndTransparent:v.RenderOccludedFlag.Opaque,isDraped:o,renderGroup:f.DrapedRenderGroup.SnappingHint,isDecoration:!0});return m.setDirectionFromPoints(u,h),m.attached=!0,r.destroyHandle(m)}visualizeRightAngleQuad(e,n){const{view:i,spatialReference:t}=n,l=C(n),a=w(e),{isDraped:o}=e,s=D(e.previousVertex,e.domain,n),d=D(e.centerVertex,e.domain,n),c=D(e.nextVertex,e.domain,n),p=T(s,t,a,i,o),u=T(d,t,a,i,o),h=T(c,t,a,i,o);return r.destroyHandle(new g.RightAngleQuadVisualElement({view:i,attached:!0,color:o?l.rightAngleColorDraped:l.rightAngleColor,renderOccluded:o?v.RenderOccludedFlag.OccludeAndTransparent:v.RenderOccludedFlag.Transparent,outlineRenderOccluded:o?v.RenderOccludedFlag.OccludeAndTransparent:v.RenderOccludedFlag.Opaque,outlineColor:l.rightAngleOutlineColor,outlineSize:E.defaults.rightAngleHintOutlineSize,size:E.defaults.rightAngleHintSize,isDraped:o,geometry:{previous:p,center:u,next:h},renderGroup:f.DrapedRenderGroup.SnappingHint,isDecoration:!0}))}}function C(e){const{effectiveTheme:t}=e.view,r=n.toUnitRGBA(t.accentColor),l=[0,0,0,0];return{intersectionPointColor:l,intersectionPointOutlineColor:r,pointColor:l,pointOutlineColor:r,lineColor:r,lineOutlineColor:void 0,parallelSignColor:r,rightAngleColor:r,rightAngleColorDraped:n.toUnitRGBA(i.multiplyOpacity(t.accentColor,.5)),rightAngleOutlineColor:r}}function D(e,n,{selfSnappingZ:i,view:t,spatialReference:r}){return n&m.SnappingDomain.SELF&&h.isTarget(e)&&null!=i?h.withSelfSnappingZ(e,i,t,r):e}function w(e){return e.isDraped?s.onTheGroundElevationInfo:s.absoluteHeightElevationInfo}function y(e,n,i,t,r,l,a,o=!1,s=!0,d=!0){const p=T(n,t,r,l,o),u=T(i,t,r,l,o),g=new c.ExtendedLineVisualElement({view:l,extensionType:c.ExtensionType.FADED,start:p,end:u,isDraped:o,color:a.lineColor,renderOccluded:o?v.RenderOccludedFlag.OccludeAndTransparent:v.RenderOccludedFlag.Opaque,renderGroup:f.DrapedRenderGroup.SnappingHint,isDecoration:!0});switch(e){case S.LineSegmentHintType.TARGET:g.width=E.defaults.lineHintWidthTarget,g.fadedExtensions={start:0,end:E.defaults.lineHintFadedExtensions};break;case S.LineSegmentHintType.REFERENCE_EXTENSION:g.width=E.defaults.lineHintWidthReference,g.fadedExtensions={start:0,end:0};break;case S.LineSegmentHintType.REFERENCE:g.width=E.defaults.lineHintWidthReference,g.fadedExtensions={start:s?E.defaults.lineHintFadedExtensions:0,end:d?E.defaults.lineHintFadedExtensions:0}}return g.attached=!0,g}function T(e,n,i,t,r){const l=a.create();if(r){const i=t.basemapTerrain.overlayManager.renderer.spatialReference;o.projectVectorToVector(e,n,l,i)}else d.vectorToRender(e,n,i,t,l);return l}e.SnappingVisualizer3D=H,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
