/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../../Color","../../../../../core/Evented","../../../../../core/Handles","../../../../../core/handleUtils","../../../../../core/has","../../../../../core/maybe","../../../../../core/reactiveUtils","../../../../../core/libs/gl-matrix-2/math/mat4","../../../../../core/libs/gl-matrix-2/factories/mat4f64","../../../../../chunks/vec32","../../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../../geometry/support/vectorStacks","../../Manipulator3D","../../RenderObject","../dragEventPipeline3D","../ManipulatorType","./config","./Manipulation","./moveUtils","../../../webgl-engine/lib/basicInterfaces","../../../webgl-engine/lib/GeometryUtil","../../../webgl-engine/lib/Material","../../../webgl-engine/materials/ColorMaterial","../../../../interactive/dragEventPipeline","../../../../interactive/interfaces"],(function(t,a,e,r,i,n,s,o,l,u,c,p,d,h,g,_,M,f,m,w,v,T,b,y,A,I){"use strict";class S extends m.Manipulation{constructor(t){super(),this._handles=new r,this._arrowManipulatorInfos=new Array,this._angle=0,this._scale=1,this._radius=f.discRadius,this._updateAfterDrag=!1,this.events=new e,this._tool=t.tool,this._view=t.view,this._opaqueMaterial=this._createMaterial(),this._transparentMaterial=this._createMaterial(.5),null!=t.radius&&(this._radius=t.radius),this._createManipulators(),this.forEachManipulator((t=>this._tool.manipulators.add(t)))}set orthogonalAvailable(t){this._arrowManipulatorInfos.length>=3&&(this._arrowManipulatorInfos[1].manipulator.available=t,this._arrowManipulatorInfos[3].manipulator.available=t)}destroy(){this._handles=s.destroyMaybe(this._handles),this.forEachManipulator((t=>{this._tool.manipulators.remove(t),t.destroy()})),this._tool=null,this._view=null,this._arrowManipulatorInfos.length=0}forEachManipulator(t){for(const{manipulator:a}of this._arrowManipulatorInfos)t(a,M.ManipulatorType.TRANSLATE_XY)}createManipulatedObjectDragPipeline(t,a,e){if(!a.operations)return i.makeHandle();const r=a.operations.data.spatialReference,n=a.graphic;return w.createManipulatedMoveDragPipeline(a,e,(e=>this.createDragPipeline(((a,r,i,n,s)=>(({steps:r,cancel:i}=t(a,r,i,n,s)),e(a,r,i))),a.elevationInfo,r,n)))}createDragPipeline(t,a,e,r){return i.handlesGroup(this._arrowManipulatorInfos.map((({manipulator:i},n)=>A.createManipulatorDragEventPipeline(i,((i,s,o,l,u)=>{const c=s.next((t=>({...t,manipulatorType:M.ManipulatorType.TRANSLATE_XY}))).next(A.dragAtLocation(this._view,i.elevationAlignedLocation)).next(_.screenToMapXYAtLocation(this._view,i.elevationAlignedLocation,a,e,r)).next(A.constrainToMapAxis(i.location,this.angle+(n+1)*Math.PI*.5)).next(A.addScreenDelta());t(i,c,o,l,u)})))))}get angle(){return this._angle}set angle(t){this._angle=t,this.dragging?this._updateAfterDrag=!0:this._updateManipulatorTransform()}get displayScale(){return this._scale}set displayScale(t){this._scale=t,this._updateManipulatorTransform()}get radius(){return this._radius}set radius(t){this._radius!==t&&(this._radius=t,this._updateManipulators())}_updateManipulators(){for(let t=0;t<this._arrowManipulatorInfos.length;t++)this._updateArrowManipulator(this._arrowManipulatorInfos[t],t);this._updateManipulatorTransform()}_updateArrowManipulator({manipulator:t,transform:a},e){const r=this._radius/f.discRadius,i=f.discTranslateArrowSize*r,n=i*Math.sqrt(3)/2,s=T.createExtrudedTriangle(this._opaqueMaterial,n,i/2,i/2,f.discHeight);T.transformInPlace(s,l.fromTranslation(d.sm4d.get(),c.set(d.sv3d.get(),0,-n/3,0))),t.renderObjects=[new g.RenderObject(s,I.ManipulatorStateFlags.Focused),new g.RenderObject(s.instantiate({material:this._transparentMaterial}),I.ManipulatorStateFlags.Unfocused)],t.radius=n/3*2*1.2;const o=l.fromZRotation(d.sm4d.get(),e*Math.PI/2),u=l.fromTranslation(d.sm4d.get(),c.set(d.sv3d.get(),0,f.discTranslateArrowOffset*r,0));l.multiply(a,o,u)}_createManipulators(){for(let t=0;t<4;t++){const a=this._createArrowManipulator(t);this._arrowManipulatorInfos.push(a)}this._updateManipulatorTransform()}_updateManipulatorTransform(){const t=this.angle,a=l.fromRotation(d.sm4d.get(),t,p.fromValues(0,0,1));if(null==a)return;const e=l.fromScaling(d.sm4d.get(),c.set(d.sv3d.get(),this.displayScale,this.displayScale,this.displayScale)),r=l.multiply(d.sm4d.get(),e,a);for(const i of this._arrowManipulatorInfos){const t=l.multiply(d.sm4d.get(),r,i.transform);i.manipulator.modelTransform=t}}_createArrowManipulator(t){const a=new h.Manipulator3D({view:this._view,autoScaleRenderObjects:!1,worldOriented:!0,focusMultiplier:1,touchMultiplier:1,collisionType:{type:"disc",direction:p.fromValues(0,0,1)}}),e={manipulator:a,transform:u.create()};return this._updateArrowManipulator(e,t),this._handles.add(a.events.on("drag",(t=>{this._updateAfterDrag&&"end"===t.action&&!this.dragging&&(this._updateManipulatorTransform(),this._updateAfterDrag=!1)}))),e}_createMaterial(t=1){const e=new y.ColorMaterial({cullFace:v.CullFaceOptions.Back,renderOccluded:b.RenderOccludedFlag.Transparent,isDecoration:!0});return this._handles.add(o.watch((()=>a.toUnitRGBA(this._view.effectiveTheme.accentColor)),(a=>{a[3]*=t,e.setParameters({color:a})}),o.initial)),e}get test(){}}t.MoveXYAxisManipulation=S,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
