/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../../chunks/tslib.es6","../../../../../core/arrayUtils","../../../../../core/Collection","../../../../../core/Evented","../../../../../core/handleUtils","../../../../../core/maybe","../../../../../core/quantityUtils","../../../../../core/reactiveUtils","../../../../../core/accessorSupport/decorators/property","../../../../../core/has","../../../../../core/Logger","../../../../../core/accessorSupport/decorators/subclass","../../../../../core/support/UpdatingHandles","../../../../../layers/graphics/dehydratedPoint","../../../../../support/elevationInfoUtils","../../SnappingVisualizer3D","../geometryUtils","../isSupportedObjectUtils","../manipulatedObjectUtils","../manipulatorUtils","../meshFastUpdateUtils","../tooltipUtils3D","../visualElementUtils","../manipulations/config","../manipulations/MoveManipulation","../manipulations/moveUtils","../manipulations/MoveXYObjectManipulation","./isSupportedObject","../../visualElements/OutlineVisualElement","../../../../interactive/dragEventPipeline","../../../../interactive/InteractiveToolBase","../../../../interactive/editGeometry/EditGeometryOperations","../../../../interactive/sketch/SketchOptions","../../../../interactive/snapping/SnappingContext","../../../../interactive/snapping/SnappingDragPipelineStep","../../../../interactive/tooltip/tooltipCommonUtils","../../../../interactive/tooltip/infos/MovePointTooltipInfo","../../../../interactive/tooltip/infos/TranslateTooltipInfo","../../../../interactive/tooltip/infos/TranslateXYTooltipInfo","../../../../interactive/tooltip/infos/TranslateZTooltipInfo","../../../../support/automaticLengthMeasurementUtils","../../../../support/euclideanLengthMeasurementUtils"],(function(t,e,o,i,n,a,s,l,p,r,c,h,u,d,v,m,M,f,_,g,y,T,b,w,S,j,I,O,D,E,P,x,U,k,H,X,Y,z,R,A,Z,C,V){"use strict";class G{constructor(t){this.objects=t,this.type="move-start"}}class F{constructor(t,e,o){this.dx=t,this.dy=e,this.objects=o,this.type="move"}}class B{constructor(t){this.objects=t,this.type="move-stop"}}const L=Symbol("manipulators"),N=Symbol("tooltips");t.MoveTool3D=class extends x.InteractiveToolBase{constructor(t){super(t),this._infos=new Map,this.events=new n,this.objects=new i,this.enableZ=!0,this.sketchOptions=new k,this.type="move-3d",this._latestTooltipInfo=null,this._translateTooltipInfo=null,this._translateXYTooltipInfo=null,this._translateZTooltipInfo=null,this._updatingHandles=new d.UpdatingHandles,this._moveManipulation=null}initialize(){const{view:t}=this;this.tooltip=Y.makeTooltip((()=>({view:t,options:this.sketchOptions.tooltips}))),this.addHandles([this.objects.on("change",(t=>{t.removed.forEach((t=>this.removeHandles(t))),this._updateObjectInfos(t),this._setupFastTransformUpdates(t.added),this._refreshManipulators()})),this.objects.on("change",(()=>this._connectTooltips()))]);const e=this.objects.toArray();this._updateObjectInfos({added:e,removed:[]}),this._setupFastTransformUpdates(e),this._refreshManipulators(),this._connectTooltips(),this.finishToolCreation()}destroy(){this.tooltip=s.destroyMaybe(this.tooltip),this._moveManipulation=s.destroyMaybe(this._moveManipulation),this._set("view",null),this._updatingHandles.destroy()}onInputEvent(t){if(!this.destroyed&&!Y.enterInputModeIfAvailable(t,this.tooltip))return super.onInputEvent(t)}get updating(){return this._updatingHandles.updating}get _shouldShowMovePointTooltip(){const{objects:t}=this;if(1!==t.length)return!1;const e=g.manipulatedObjectGeometry(t.at(0))?.type;return"point"===e||"mesh"===e}get activeTooltipInfo(){return this._shouldShowMovePointTooltip?this._movePointTooltipInfo:this._latestTooltipInfo}reset(){}_updateObjectInfos({added:t,removed:e}){for(const o of t){if(D.isSupportedObject(o)!==_.SupportedObjectResult.SUPPORTED)continue;const t=new q(o);this._infos.set(o,t)}for(const o of e)this._infos.delete(o)}_setupFastTransformUpdates(t){for(const e of t){const t=this._infos.get(e);this.addHandles(T.meshTransformFastUpdateHandles(t.object),e)}}_refreshManipulators(){if(this.removeHandles(L),this._moveManipulation=s.destroyMaybe(this._moveManipulation),this.manipulators.removeAll(),0===this._infos.size)return;const t=Array.from(this._infos.values());this._createManipulators(t),this._createVisualElements(t),this._updateMoveManipulation(t)}_createManipulators(t){for(const e of t){const o=e.object;e.manipulationXY=new O.MoveXYObjectManipulation({tool:this,view:this.view,object:o}),e.manipulationXY.forEachManipulator((t=>{this.addHandles([t.events.on("immediate-click",(t=>{this.events.emit("immediate-click",{...t,object:o}),t.stopPropagation()})),t.events.on("grab-changed",(({action:t})=>{"start"===t?this._showTooltip(j.ManipulationType.XY):this._hideTooltip()}))],L)})),this.addHandles(e.manipulationXY.createDragPipeline(((e,o,i,n)=>this._buildDragEventPipeline(t,j.ManipulationType.XY,e,o,i,n))),L)}this._createMoveManipulation(t)}_createMoveManipulation(t){const e=new j.MoveManipulation({tool:this,view:this.view,snapToScene:!1,xyAvailable:!0,xyAxisAvailable:!0,zAvailable:!0,radius:1===t.length?j.MoveManipulation.radiusForSymbol(t[0].object.graphic?.symbol):S.discRadius});this._moveManipulation=e,e.elevationInfo={mode:"absolute-height",offset:0},e.forEachManipulator((t=>{this.addHandles(t.events.on("immediate-click",(o=>{const i=this.objects.at(0);!e.zManipulation.hasManipulator(t)&&1===this.objects.length&&i&&this.events.emit("immediate-click",{...o,object:i}),o.stopPropagation()})),L)}));const o=t=>e=>{this.addHandles([e.events.on("focus-changed",(({action:e})=>{"focus"===e?this._showTooltip(t):this._hideTooltip()})),e.events.on("grab-changed",(()=>{this._latestTooltipInfo&&(this._latestTooltipInfo.distance=l.zeroMeters)}))],L)};this._moveManipulation.xyManipulation.forEachManipulator(o(j.ManipulationType.XY)),this._moveManipulation.xyAxisManipulation.forEachManipulator(o(j.ManipulationType.XY_AXIS)),this._moveManipulation.zManipulation.forEachManipulator(o(j.ManipulationType.Z));const i=()=>this._updateMoveManipulation(t);for(const l of t)this.addHandles([l.object.on("committed",i),p.watch((()=>l.object.visible),i)],L);const n=t[t.length-1];this.addHandles(n.object.on("committed",(()=>this._updateMoveManipulationAngle(n))),L);const{object:a}=n,{operations:s}=a;if(s){const o=a.graphic;this.addHandles(e.createDragPipeline(((e,o,i,n,a)=>this._buildDragEventPipeline(t,e,o,i,n,a)),a.elevationInfo,s.data.spatialReference,o),L)}this._updateMoveManipulationAngle(n)}_createVisualElements(t){for(const e of t){const o=e.object,i=w.createVisualElements({view:this.view,object:o,forEachManipulator:t=>{e.manipulationXY?.forEachManipulator(t),this._moveManipulation?.forEachManipulator(t)},onManipulatorsChanged:()=>a.makeHandle()});null!=i&&(e.geometryRepresentation=i.visualElement,e.geometryRepresentation instanceof E.OutlineVisualElement&&this.addHandles([e.geometryRepresentation.events.on("attachment-origin-changed",(()=>{e.object.isDraped||this._updateMoveManipulation(t)})),p.watch((()=>e.object.isDraped),(()=>this._updateMoveManipulation(t)))],L),this.addHandles(i,L))}}_updateMoveManipulationAngle(t){this._moveManipulation&&(this._moveManipulation.angle=f.orientation(g.manipulatedObjectGeometry(t.object)))}_updateMoveManipulation(t){const e=v.makeDehydratedPoint(0,0,0,this.view.spatialReference);let o=0,i=!1;const n=this._moveManipulation;if(n){for(const n of t){if(!n.object.visible)continue;this.enableZ&&y.canMoveZOperations(n.object.operations,n.object.elevationInfo)&&(i=!0);const t=n.geometryRepresentation instanceof E.OutlineVisualElement&&!n.object.isDraped?n.geometryRepresentation.attachmentOrigin:n.object.origin;if(null!=t){const{x:i,y:n,z:a}=t;e.x+=i,e.y+=n,a&&(e.z??=0,e.z+=a),o++}}o>0?(e.x/=o,e.y/=o,e.z??=0,e.z/=o,n.location=e,n.xyManipulation.available=!0,n.xyAxisManipulation.available=!0,n.zManipulation.available=i):n.available=!1}}_buildDragEventPipeline(t,e,o,i,n,a){const s=[],l=[];let p=null,r=null;const c=()=>{for(const t of s)t.dragging=!1;s.length=0,l.length=0,p=null,r=null,this._moveManipulation&&(this._moveManipulation.interactive=!0)};if(1===t.length&&e===j.ManipulationType.XY){const e=t[0].object;({steps:i,cancel:n}=this._buildSnappingPipelineSteps(e,e.elevationInfo,i,n,a))}return n=n.next((t=>r?.(t))).next((()=>(l.length&&this.events.emit("move-stop",new B(l)),this.destroyed||c(),null))),{steps:i=i.next((e=>{if("start"===e.action){s.length=0,l.length=0;for(const e of t)e.dragging||!e.manipulationXY?.hasManipulator(o)&&e.manipulationXY?.grabbing||(s.push(e),l.push(e.object),e.dragging=!0);if(0!==l.length&&(this._moveManipulation&&(this._moveManipulation.interactive=!1),p=P.dragManipulatedObjectMany(l),r=P.resetManipulatedObjectMany(l),this._emitRecordUndo(),this.events.emit("move-start",new G(l)),this.destroyed))return null}return 0!==l.length?e:null})).next((t=>p?.(t))).next((t=>(this._updateMoveTooltip(e,t),t))).next((t=>{switch(t.action){case"start":case"update":if(t.translationX||t.translationY||t.translationZ){const e=this.view.toScreen(t.mapStart),o=this.view.toScreen(t.mapEnd),i=o.x-e.x,n=o.y-e.y;if(this.events.emit("move",new F(i,n,l)),this.destroyed)return null}break;case"end":if(this.events.emit("move-stop",new B(l)),this.destroyed)return null;c()}return null})),cancel:n}}_connectTooltips(){let t;if(this.removeHandles(N),this._shouldShowMovePointTooltip){const e=this.objects.at(0),{events:o}=this;this._movePointTooltipInfo??=new z.MovePointTooltipInfo({viewType:this.view.type,sketchOptions:this.sketchOptions});const i={onBeforeUpdate:()=>this.endDrag(),onMoveStart:()=>{this._emitRecordUndo(),o.emit("move-start",new G([e]))},onMove:()=>o.emit("move",new F(0,0,[e])),onMoveStop:()=>o.emit("move-stop",new B([e])),onRotateStart:()=>{},onRotate:()=>{},onRotateStop:()=>{},onScaleStart:()=>{},onScale:()=>{},onScaleStop:()=>{}};t=b.connectTooltipToManipulatedObject(this.tooltip,e,(()=>({sketchOptions:this.sketchOptions,activeTooltipInfo:this._movePointTooltipInfo,callbacks:i})))}else t=p.watch((()=>this.sketchOptions.tooltips.effectiveEnabled?this._latestTooltipInfo:null),(t=>{this.tooltip.info=t}),p.syncAndInitial);this.addHandles(t,N)}_showTooltip(t){this._shouldShowMovePointTooltip||this._updateMoveTooltip(t)}_hideTooltip(){this._shouldShowMovePointTooltip||(this.tooltip?.clear(),this._latestTooltipInfo=null)}_updateMoveTooltip(t,e){if(this._shouldShowMovePointTooltip)return;const{sketchOptions:o}=this;switch(t){case j.ManipulationType.XY:this._latestTooltipInfo=this._translateTooltipInfo??=new R.TranslateTooltipInfo({sketchOptions:o}),J(this._latestTooltipInfo,e,((t,e)=>C.autoDistanceBetweenPoints2D(t,e)));break;case j.ManipulationType.XY_AXIS:this._latestTooltipInfo=this._translateXYTooltipInfo??=new A.TranslateXYTooltipInfo({sketchOptions:o}),J(this._latestTooltipInfo,e,((t,o)=>l.scale(C.autoDistanceBetweenPoints2D(t,o),I.axisConstrainedDragSign(e))));break;case j.ManipulationType.Z:this._latestTooltipInfo=this._translateZTooltipInfo??=new Z.TranslateZTooltipInfo({sketchOptions:o}),J(this._latestTooltipInfo,e,V.verticalSignedDistanceBetweenPoints)}this._latestTooltipInfo.sketchOptions=o}_emitRecordUndo(){const t=this.objects.toArray().map((t=>t.createUndoRecord?.())).filter(o.isSome);t.length>0&&this.events.emit("record-undo",{updates:t})}_buildSnappingPipelineSteps(t,e,o,i,n){const a=g.manipulatedObjectGeometry(t);if(null==a||"point"!==a.type&&"mesh"!==a.type)return{steps:o,cancel:i};const s=("point"===a.type?a:a.origin).clone(),l=new H.SnappingContext({elevationInfo:e,pointer:n,editGeometryOperations:U.EditGeometryOperations.fromGeometry(s,this.view.state.viewingMode),visualizer:new M.SnappingVisualizer3D,excludeFeature:t.graphic}),p=this.snappingManager,{snappingStep:r,cancelSnapping:c}=X.createSnapDragEventPipelineStep({snappingContext:l,snappingManager:p,updatingHandles:this._updatingHandles});return i=i.next(c),{steps:o=o.next((e=>{s.z=m.getConvertedElevation(this.view,s,t.elevationInfo,{mode:"absolute-height",offset:0});return{...e,snapOrigin:l.coordinateHelper.pointToVector(s)}})).next(...r),cancel:i}}},e.__decorate([r.property({constructOnly:!0,nonNullable:!0})],t.MoveTool3D.prototype,"view",void 0),e.__decorate([r.property()],t.MoveTool3D.prototype,"objects",void 0),e.__decorate([r.property({constructOnly:!0,nonNullable:!0})],t.MoveTool3D.prototype,"enableZ",void 0),e.__decorate([r.property({constructOnly:!0,type:k})],t.MoveTool3D.prototype,"sketchOptions",void 0),e.__decorate([r.property({constructOnly:!0})],t.MoveTool3D.prototype,"snappingManager",void 0),e.__decorate([r.property()],t.MoveTool3D.prototype,"type",void 0),e.__decorate([r.property()],t.MoveTool3D.prototype,"updating",null),e.__decorate([r.property()],t.MoveTool3D.prototype,"_latestTooltipInfo",void 0),e.__decorate([r.property()],t.MoveTool3D.prototype,"_shouldShowMovePointTooltip",null),e.__decorate([r.property()],t.MoveTool3D.prototype,"activeTooltipInfo",null),t.MoveTool3D=e.__decorate([u.subclass("esri.views.3d.interactive.editingTools.move.MoveTool3D")],t.MoveTool3D);class q{constructor(t){this.object=t,this.geometryRepresentation=null,this.manipulationXY=null,this.dragging=!1}}function J(t,e,o){if(null==e||"end"===e.action)return void(t.distance=l.zeroMeters);const{mapStart:i,mapEnd:n}=e,a=o(i,n);t.distance=null!=a?a:l.zeroMeters}t.MoveEvent=F,t.MoveStartEvent=G,t.MoveStopEvent=B,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
