/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../../chunks/tslib.es6","../../../../../core/Evented","../../../../../core/handleUtils","../../../../../core/has","../../../../../core/reactiveUtils","../../../../../core/accessorSupport/decorators/property","../../../../../core/Logger","../../../../../core/RandomLCG","../../../../../core/accessorSupport/decorators/subclass","../../../../../geometry/support/aaBoundingRect","../../../../../geometry/support/vectorStacks","../../../analysis/Slice/sliceToolUtils","../../Manipulator3D","../manipulatedObjectUtils","../ManipulatorType","../manipulatorUtils","../visualElementUtils","./extentTransform/ExtentMove","./extentTransform/ExtentRotate","./extentTransform/ExtentScale","./extentTransform/extentUtils","./extentTransform/PreserveAspectRatio","./extentTransform/SnapRotation","../../visualElements/OutlineVisualElement","../../../../interactive/InteractiveToolBase","../../../../interactive/sketch/SketchOptions","../../../../interactive/tooltip/tooltipCommonUtils"],(function(t,e,o,a,i,n,s,r,l,p,c,h,d,u,_,b,v,T,m,y,g,f,E,x,M,R,S,A){"use strict";t.ExtentTransformTool=class extends R.InteractiveToolBase{get updating(){return!!this.object.updating}constructor(t){super(t),this.events=new o,this.enableZ=!0,this.enableScaling=!0,this.enableRotation=!0,this.sketchOptions=new S,this._preserveAspectRatio=new E.PreserveAspectRatio,this._snapRotation=new x.SnapRotation,this.grabbing=!1,this.inputState=null,this._attachmentOrigin=null,this.type="transform-3d",this._outlineVisualElement=null}initialize(){const{view:t,object:e}=this,o=this._bounds=new f.TransformBounds(this,(()=>this._updateManipulators()));this._extentMove=new m.ExtentMove(this,o),this._extentScale=new g.ExtentScale(this,o,(()=>this._preserveAspectRatio.createDragEventPipelineStep())),this._extentRotate=new y.ExtentRotate(this,o,(()=>this._snapRotation.createDragEventPipelineStep())),this.addHandles([n.watch((()=>this.enableZ),(()=>this._updateManipulatorAvailability(this._extentMove.moveZManipulator,b.ManipulatorType.TRANSLATE_Z))),n.watch((()=>this.enableScaling),(()=>this._extentScale.forEachManipulator((t=>this._updateManipulatorAvailability(t,b.ManipulatorType.SCALE))))),n.watch((()=>this.enableRotation),(()=>this._updateManipulatorAvailability(this._extentRotate.rotateManipulator,b.ManipulatorType.ROTATE)))]),this._updateManipulators(),this._updateAllManipulatorAvailability();const i=T.createVisualElements({view:t,object:e,forEachManipulator:t=>this._forEachManipulator(t),onManipulatorsChanged:()=>a.makeHandle()});if(null!=i){const{visualElement:t}=i;t instanceof M.OutlineVisualElement&&(this._outlineVisualElement=t,this.addHandles(t.events.on("attachment-origin-changed",(()=>this._bounds.updateDisplayBounds())))),this.addHandles(i)}this.addHandles([e.on("committed",(()=>this._onGeometryChanged())),n.watch((()=>this.object.visible),(()=>this._updateAllManipulatorAvailability())),n.watch((()=>this.object.isDraped),(()=>this._graphicDrapedChanged()),n.initial),n.watch((()=>t.pointsOfInterest?.centerOnSurfaceFrequent.location),(()=>o.updateDisplayBounds()))]);const s=t=>{this.addHandles(t.events.on("grab-changed",(()=>{this.grabbing=t.grabbing,this._updateAllManipulatorAvailability()})))};this._forEachManipulator(s);const r=(t,o)=>{this.addHandles(t.events.on("immediate-click",(t=>{o===b.ManipulatorType.TRANSLATE_XY&&this.events.emit("immediate-click",{...t,object:e}),t.stopPropagation()})))};this._forEachManipulator(r),this._initializeTooltip(),this.finishToolCreation()}destroy(){this._extentMove.destroy(),this._extentScale.destroy(),this._extentRotate.destroy(),this.tooltip.destroy(),this._set("view",null),this._set("object",null)}_initializeTooltip(){const{view:t}=this;this.tooltip=A.makeTooltip((()=>({view:t,options:this.sketchOptions.tooltips})));const e=()=>{this.tooltip.info=this._getUpdatedTooltipInfo()};this.addHandles([n.watch((()=>this.sketchOptions.tooltips.effectiveEnabled),e),n.watch((()=>this.preserveAspectRatio),e)]),this._forEachManipulator((t=>{this.addHandles([t.events.on(["focus-changed","grab-changed"],e),t.events.on("drag",(t=>{"cancel"===t.action?this.tooltip.clear():e()}))])}))}_getUpdatedTooltipInfo(){return this.sketchOptions.tooltips.effectiveEnabled?this._extentMove.getUpdatedTooltipInfo()??this._extentScale.getUpdatedTooltipInfo()??this._extentRotate.getUpdatedTooltipInfo():null}_onGeometryChanged(){this._bounds.updateDisplayBounds()}_graphicDrapedChanged(){this.removeHandles(O),this._bounds.updateDisplayBounds(),this.object.isDraped&&this.addHandles(this.view.elevationProvider.on("elevation-change",(t=>{null!=this._attachmentOrigin&&c.containsXY(t.extent,this._attachmentOrigin.x,this._attachmentOrigin.y)&&this._bounds.updateDisplayBounds()})),O)}_updateManipulators(){if(!this.visible)return;const t=this._bounds.displayBounds,e=d.calculateBoundedPlaneTranslateRotate(t,h.sm4d.get());this._extentMove.updateManipulators(e,t),this._extentScale.updateManipulators(e,t),this._extentRotate.updateManipulators(e,t)}_updateAllManipulatorAvailability(){this._forEachManipulator(((t,e)=>this._updateManipulatorAvailability(t,e)))}_updateManipulatorAvailability(t,e){const o=this.grabbing&&!t.grabbing;if(t.interactive=!o,t instanceof u.Manipulator3D){const a=this.object.visible,i=this.enableZ&&v.canMoveZOperations(this.object.operations,this.object.elevationInfo);switch(e){case b.ManipulatorType.ROTATE:t.available=a&&this.enableRotation;break;case b.ManipulatorType.SCALE:t.available=a&&(this.enableScaling||this.enableRotation||i),t.interactive=!o&&this.enableScaling,t.state=this.enableScaling?d.resizeNormal:d.resizeOutlineOnly;break;case b.ManipulatorType.TRANSLATE_Z:t.available=a&&i;break;default:t.available=a}}}_forEachManipulator(t){this._extentMove.forEachManipulator(t),this._extentScale.forEachManipulator(t),this._extentRotate.forEachManipulator(t)}get preserveAspectRatio(){return this._preserveAspectRatio.enabled}set preserveAspectRatio(t){this._preserveAspectRatio.enabled=t,this._set("preserveAspectRatio",t)}get snapRotation(){return this._snapRotation.enabled}set snapRotation(t){this._snapRotation.enabled=t,this._set("snapRotation",t)}get attachmentOrigin(){const t=this.object.isDraped?null:this._outlineVisualElement?.attachmentOrigin;return this._attachmentOrigin=t??this.object.origin??_.manipulatedObjectGeometry(this.object)?.extent?.center,this._attachmentOrigin}reset(){}cancel(){if(this.canUndo){const t=this.object.operations?.undo();t&&this._bounds.updateMapBoundsFromOperationInverse(t)}this.inputState=null}get canUndo(){return!!this.object.operations?.canUndo}undo(){if(null!=this.inputState)this.view.activeTool=null;else if(this.canUndo){const t=this.object.operations?.undo();t&&this._bounds.updateMapBoundsFromOperationInverse(t)}}get canRedo(){return!!this.object.operations?.canRedo}redo(){if(this.canRedo){const t=this.object.operations?.redo();t&&this._bounds.updateMapBoundsFromOperation(t)}}get test(){}},e.__decorate([s.property()],t.ExtentTransformTool.prototype,"updating",null),e.__decorate([s.property({constructOnly:!0,nonNullable:!0})],t.ExtentTransformTool.prototype,"view",void 0),e.__decorate([s.property({constructOnly:!0,nonNullable:!0})],t.ExtentTransformTool.prototype,"object",void 0),e.__decorate([s.property()],t.ExtentTransformTool.prototype,"enableZ",void 0),e.__decorate([s.property()],t.ExtentTransformTool.prototype,"enableScaling",void 0),e.__decorate([s.property()],t.ExtentTransformTool.prototype,"enableRotation",void 0),e.__decorate([s.property({constructOnly:!0,type:S})],t.ExtentTransformTool.prototype,"sketchOptions",void 0),e.__decorate([s.property()],t.ExtentTransformTool.prototype,"preserveAspectRatio",null),e.__decorate([s.property()],t.ExtentTransformTool.prototype,"snapRotation",null),e.__decorate([s.property()],t.ExtentTransformTool.prototype,"grabbing",void 0),e.__decorate([s.property()],t.ExtentTransformTool.prototype,"inputState",void 0),e.__decorate([s.property({readOnly:!0})],t.ExtentTransformTool.prototype,"type",void 0),e.__decorate([s.property()],t.ExtentTransformTool.prototype,"tooltip",void 0),t.ExtentTransformTool=e.__decorate([p.subclass("esri.views.3d.interactive.editingTools.transform.ExtentTransformTool")],t.ExtentTransformTool);const O="draped-elevation-changes";Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
