/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../../chunks/tslib.es6","../../../../../core/arrayUtils","../../../../../core/Evented","../../../../../core/handleUtils","../../../../../core/has","../../../../../core/maybe","../../../../../core/reactiveUtils","../../../../../core/accessorSupport/decorators/property","../../../../../core/Logger","../../../../../core/accessorSupport/decorators/subclass","../../../../../core/support/UpdatingHandles","../../../../../geometry/Point","../../../../ViewingMode","../../Manipulator3D","../../manipulatorUtils","../../SnappingVisualizer3D","../manipulatedObjectUtils","../manipulatorUtils","../meshFastUpdateUtils","../tooltipUtils3D","../visualElementUtils","../manipulations/config","../manipulations/MoveManipulation","./ScaleRotateMeshAdapter","./ScaleRotateObjectSymbol3DAdapter","./ScaleRotateTransform","../../../../interactive/dragEventPipeline","../../../../interactive/InteractiveToolBase","../../../../interactive/editGeometry/EditGeometryOperations","../../../../interactive/sketch/SketchOptions","../../../../interactive/snapping/SnappingContext","../../../../interactive/snapping/SnappingDragPipelineStep","../../../../interactive/tooltip/tooltipCommonUtils","../../../../interactive/tooltip/infos/TransformMeshTooltipInfo","../../../../interactive/tooltip/infos/TransformPointTooltipInfo"],(function(t,e,o,a,i,n,s,r,l,c,p,h,d,u,m,v,_,g,b,y,f,S,M,T,R,w,j,O,A,D,I,k,x,U,E,H){"use strict";t.TransformTool3D=class extends A.InteractiveToolBase{constructor(t){super(t),this.events=new a,this.enableZ=!0,this.enableRotation=!0,this.enableScaling=!0,this.sketchOptions=new I,this.type="transform-3d",this._updatingHandles=new h.UpdatingHandles,this._scaleRotate=null}initialize(){const{events:t,object:e,view:a}=this;this.tooltip=U.makeTooltip((()=>({view:a,options:this.sketchOptions.tooltips}))),this._moveManipulation=new T.MoveManipulation({tool:this,view:a,snapToScene:this.snapToScene,xyAvailable:!0,xyAxisAvailable:!0,zAvailable:this.enableZ&&b.canMoveZOperations(e.operations,e.elevationInfo),radius:T.MoveManipulation.radiusForSymbol(e.graphic?.symbol)}),this._moveManipulation.forEachManipulator((e=>this.addHandles(e.events.on("immediate-click",(e=>{t.emit("immediate-click",{...e,object:this.object}),e.stopPropagation()})))));const n=e.elevationInfo;if(this._moveManipulation.elevationInfo=n,this.addHandles(y.meshTransformFastUpdateHandles(e)),this._moveManipulation.createManipulatedObjectDragPipeline(((t,o,i,s,r)=>{if(t===T.ManipulationType.XY){const{snappingStep:t,cancelSnapping:o}=x.createSnapDragEventPipelineStep({snappingContext:new k.SnappingContext({elevationInfo:n,pointer:r,editGeometryOperations:D.EditGeometryOperations.fromGeometry(new d({spatialReference:e.operations?.data.spatialReference}),a.state.viewingMode),visualizer:new _.SnappingVisualizer3D,excludeFeature:e.graphic}),snappingManager:this.snappingManager,updatingHandles:this._updatingHandles,useZ:!1});s=s.next(o),i=i.next(O.sceneSnappingAtProjectedLocation(this.view,n)).next(...t)}return{steps:i,cancel:s}}),e,(e=>{const{action:o,object:a,dxScreen:i,dyScreen:n}=e,s={object:a,dxScreen:i,dyScreen:n};switch(o){case"start":this._emitRecordUndo(),t.emit("translate-start",s);break;case"update":t.emit("translate",s);break;case"end":t.emit("translate-stop",s)}})),this._moveManipulation.angle=null!=this._scaleRotate?this._scaleRotate.angle:0,this._scaleRotateAdapter=this._createScaleRotateAdapter(),this.addHandles(r.watch((()=>this._scaleRotateAdapter.angle),(()=>this._updateMoveAngle()))),this.enableScaling||this.enableRotation){const t=this.enableScaling&&this.enableRotation?null:this.enableScaling?"scale":"rotate";this._scaleRotate=new j.ScaleRotateTransform({tool:this,mode:t,adapter:this._scaleRotateAdapter,sketchOptions:this.sketchOptions}),this.addHandles(this._scaleRotate.events.on("scale-changed",(()=>this._onScaleChanged())))}this.addHandles([S.createVisualElements({view:this.view,object:e,forEachManipulator:t=>this._forEachManipulator(t),onManipulatorsChanged:()=>i.makeHandle()}),e.on("committed",(()=>this._onGeometryChanged())),this._hideManipulatorsForObjectState(),r.watch((()=>a.scale),(()=>this._updateMoveAngle()))].filter(o.isSome)),this._onGeometryChanged(),this._updateMoveAngle(),this._forEachManipulator((t=>{t instanceof m.Manipulator3D&&this.addHandles(t.events.on("grab-changed",(()=>this._updateManipulatorsInteractive())))}));const s=a?.type,{sketchOptions:l}=this;this._meshTooltipInfo=new E.TransformMeshTooltipInfo({viewType:s,sketchOptions:l}),this._pointTooltipInfo=new H.TransformPointTooltipInfo({viewType:s,sketchOptions:l});const c={object:e,dxScreen:0,dyScreen:0},p={onBeforeUpdate:()=>this.endDrag(),onMoveStart:()=>{this._emitRecordUndo(),t.emit("translate-start",{...c})},onMove:()=>t.emit("translate",{...c}),onMoveStop:()=>t.emit("translate-stop",{...c}),onRotateStart:o=>{this._emitRecordUndo(),t.emit("rotate-start",{object:e,angle:o})},onRotate:o=>t.emit("rotate",{object:e,angle:o}),onRotateStop:o=>t.emit("rotate-stop",{object:e,angle:o}),onScaleStart:(o,a)=>{this._emitRecordUndo(),t.emit("scale-start",{object:e,xScale:o,yScale:a})},onScale:(o,a)=>t.emit("scale",{object:e,xScale:o,yScale:a}),onScaleStop:(o,a)=>t.emit("scale-stop",{object:e,xScale:o,yScale:a})};this.addHandles(f.connectTooltipToManipulatedObject(this.tooltip,this.object,(()=>({sketchOptions:this.sketchOptions,activeTooltipInfo:this.activeTooltipInfo,callbacks:p,scaleRotateTransform:this._scaleRotate})))),this.finishToolCreation()}destroy(){this.tooltip.destroy(),this._moveManipulation.destroy(),this._scaleRotate=s.destroyMaybe(this._scaleRotate),this._scaleRotateAdapter=s.destroyMaybe(this._scaleRotateAdapter),this._updatingHandles.destroy(),this._set("view",null),this._set("object",null)}onInputEvent(t){if(!this.destroyed&&!U.enterInputModeIfAvailable(t,this.tooltip))return super.onInputEvent(t)}_updateManipulatorsInteractive(){null!=this._scaleRotate&&(this._scaleRotate.interactive=!this._moveManipulation.grabbing,this._moveManipulation.interactive=!this._scaleRotate.grabbing)}_createScaleRotateAdapter(){const t=g.manipulatedObjectGeometry(this.object);return"mesh"===t?.type?new R.ScaleRotateMeshAdapter({object:this.object,geometry:t,viewingMode:this.view.state.viewingMode}):new w.ScaleRotateObjectSymbol3DAdapter({graphic:this.object.graphic,sizeFilter:t=>this._enforceNonZeroSize(t),findLayerView:()=>this.view.allLayerViews.find((t=>t.layer===this.object.graphic?.layer)),sizeAxis:this.sketchOptions?.tooltips?.visualVariables?.size?.axis??null})}_forEachManipulator(t){this._moveManipulation?.forEachManipulator(t),this._scaleRotate?.forEachManipulator(t)}_hideManipulatorsForObjectState(){return r.watch((()=>this.object.visible),(t=>{this._forEachManipulator((e=>e.available=t)),this._moveManipulation.zManipulation.available=t&&this.enableZ&&b.canMoveZOperations(this.object.operations,this.object.elevationInfo)}))}_emitRecordUndo(){this.events.emit("record-undo",{updates:[this.object.createUndoRecord()]})}set snapToScene(t){this._moveManipulation&&(this._moveManipulation.snapToScene=t),this._set("snapToScene",t)}get updating(){return this._updatingHandles.updating||!!this._scaleRotate?.updating}get activeTooltipInfo(){return"mesh"===g.manipulatedObjectGeometry(this.object)?.type?this._meshTooltipInfo:this._pointTooltipInfo}set location(t){this._moveManipulation.location=t,this._scaleRotate&&(this._scaleRotate.location=t)}set elevationAlignedLocation(t){this._moveManipulation.elevationAlignedLocation=t,this._scaleRotate&&(this._scaleRotate.elevationAlignedLocation=t)}reset(){}onHide(){this._scaleRotate?.cancelActiveAnimation()}_onScaleChanged(){null!=this._scaleRotate&&(this._moveManipulation.displayScale=this._scaleRotate.getScale())}_updateMoveAngle(){const{view:t}=this,e=t.state.viewingMode===u.ViewingMode.Local||t.scale<M.alignArrowsScaleThreshold;this._moveManipulation.angle=e?this._scaleRotateAdapter.angle:0}_onGeometryChanged(){v.placeAtObject(this,this.object)}_enforceNonZeroSize(t){return t||this.view.state.camera.computeRenderPixelSizeAt(this._moveManipulation.renderLocation)}get test(){}},e.__decorate([l.property({constructOnly:!0,nonNullable:!0})],t.TransformTool3D.prototype,"view",void 0),e.__decorate([l.property({constructOnly:!0,nonNullable:!0})],t.TransformTool3D.prototype,"object",void 0),e.__decorate([l.property({constructOnly:!0,nonNullable:!0})],t.TransformTool3D.prototype,"enableZ",void 0),e.__decorate([l.property()],t.TransformTool3D.prototype,"enableRotation",void 0),e.__decorate([l.property()],t.TransformTool3D.prototype,"enableScaling",void 0),e.__decorate([l.property({constructOnly:!0,type:I})],t.TransformTool3D.prototype,"sketchOptions",void 0),e.__decorate([l.property({value:!1})],t.TransformTool3D.prototype,"snapToScene",null),e.__decorate([l.property({constructOnly:!0})],t.TransformTool3D.prototype,"snappingManager",void 0),e.__decorate([l.property({readOnly:!0})],t.TransformTool3D.prototype,"type",void 0),e.__decorate([l.property({readOnly:!0})],t.TransformTool3D.prototype,"updating",null),e.__decorate([l.property()],t.TransformTool3D.prototype,"activeTooltipInfo",null),t.TransformTool3D=e.__decorate([p.subclass("esri.views.3d.interactive.editingTools.transform.TransformTool3D")],t.TransformTool3D),Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
