/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../../chunks/tslib.es6","../../../../../Color","../../../../../core/Accessor","../../../../../core/colorUtils","../../../../../core/has","../../../../../core/maybe","../../../../../core/reactiveUtils","../../../../../core/accessorSupport/decorators/property","../../../../../core/Logger","../../../../../core/RandomLCG","../../../../../core/accessorSupport/decorators/subclass","../../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../../geometry/support/lineSegment","../../../analysis/interfaces","../../../analysis/DirectLineMeasurement/interfaces","../../Manipulator3D","../../manipulatorUtils","../../RenderObject","../../visualElements/LaserlineVisualElement","../../../webgl-engine/lib/GeometryUtil"],(function(e,t,i,s,r,a,n,o,l,c,d,h,u,p,_,y,w,g,D,m,L){"use strict";var v;!function(e){e.Manipulators="manipulators",e.AnalysisViewDestroyed="analysis-view-destroyed",e.AnalysisView="analysis-view"}(v||(v={})),e.DirectLineMeasurement3DView=class extends s{constructor(e){super(e),this.cursorPoint=null,this._visible=!1,this._laserLine=null,this.laserLineEnabled=!0,this._lastDraggedHandle=null}initialize(){this._laserLine=new m.LaserlineVisualElement({view:this.view,attached:!0,isDecoration:!0}),this._updateVisibility(this._visible),this._connectToAnalysisView(),this.addHandles(o.watch((()=>this._params),(({laserLineGlowColor:e,laserLineInnerColor:t,laserLineGlobalAlpha:i})=>{const s=this._laserLine,r=s.style;s.style={...r,innerColor:t,glowColor:e,globalAlpha:i}})))}destroy(){this._laserLine=n.destroyMaybe(this._laserLine)}get _params(){const{accentColor:e}=this.view.effectiveTheme;return{laserLineGlowColor:i.toUnitRGB(e),laserLineGlowWidth:8,laserLineGlowFalloff:8,laserLineInnerColor:i.toUnitRGB(r.getContrast(e)),laserLineInnerWidth:.75,laserLineGlobalAlpha:.75*e.a,handleColor:r.multiplyOpacityToUnitRGBA(e,.5),handleRadius:5}}get visible(){return this._visible}set visible(e){e?this.show():this.hide()}get testData(){}get _cursorPosition(){const e=u.create(),t=this.cursorPoint;return t&&this.view.renderCoordsHelper.toRenderCoords(t,e),e}get _startPosition(){const e=u.create(),t=this.analysis.startPoint;return t&&this.view.renderCoordsHelper.toRenderCoords(t,e),e}get _endPosition(){const e=u.create(),t=this.analysis.endPoint;return t&&this.view.renderCoordsHelper.toRenderCoords(t,e),e}get _laserLineParams(){const e=this._focusPosition,{active:t,lineState:i}=this.toolState,s=this.analysisViewData,r=this.laserLineEnabled&&!!e&&"measured"!==i&&t;if(!r||!this.visible||null==s||s.destroyed)return{heightManifoldTarget:null,pointDistanceLine:null,lineVerticalPlaneSegment:null};const a=s.actualVisualizedMeasurement,n="local"!==this.view.viewingMode&&r&&!!this.analysis.startPoint&&"geodesic"===a,o=r&&s.viewMode===y.ViewMode.Triangle;return{heightManifoldTarget:"euclidean"===a?e:null,pointDistanceLine:n?this._pointDistanceLine:null,lineVerticalPlaneSegment:o?p.fromPoints(this._startPosition,this._endPosition):null}}get _focusPosition(){const{lineState:e}=this.toolState,t=this.analysisViewData,i=null!=t&&!t.destroyed&&t.measurementMode===_.MeasurementMode.Euclidean&&t.viewMode===y.ViewMode.Direct;switch(e){case"drawing":return i?this._startPosition:this.analysis.endPoint?this._endPosition:this._startPosition;case"editing":return i?"start"===this._lastDraggedHandle?this._endPosition:this._startPosition:"start"===this._lastDraggedHandle?this._startPosition:this._endPosition;default:return null!=this.cursorPoint?this._cursorPosition:null}}get _pointDistanceLine(){return{origin:"drawing"===this.toolState.lineState||"end"===this._lastDraggedHandle?this._startPosition:this._endPosition,target:this._focusPosition}}createManipulators(){const e=this._params,{view:t}=this,i=()=>{const i=g.createManipulatorMaterial(e.handleColor),s=[new D.RenderObject(L.createSphereGeometry(i,1,32,32))],r=new w.Manipulator3D({view:t,renderObjects:s});return r.available=!1,r.radius=e.handleRadius,[r,i]},[s,a]=i(),[n,l]=i(),c=new w.Manipulator3D({view:this.view,available:!1,interactive:!1});null!=this.analysis.startPoint&&(s.location=this.analysis.startPoint,s.available=!0),null!=this.analysis.endPoint&&(n.location=this.analysis.endPoint,n.available=!0);const d=()=>{let e=this._lastDraggedHandle;s.grabbing&&!n.grabbing&&(e="start"),n.grabbing&&!s.grabbing&&(e="end"),s.grabbing||n.grabbing||(e=null),this._lastDraggedHandle=e},h=s.events.on("grab-changed",d),u=n.events.on("grab-changed",d);return this.addHandles([h,u,o.watch((()=>r.colorVectorToColorAndOpacity(this._params.handleColor)),(e=>{a.setParameters({color:e}),l.setParameters({color:e})}),{equals:r.colorVectorEquals})],v.Manipulators),{start:s,end:n,cursor:c}}show(){this.destroyed||this._visible||this._updateVisibility(!0)}hide(){!this.destroyed&&this._visible&&this._updateVisibility(!1)}_connectToAnalysisView(){this.removeHandles(v.AnalysisView),this.addHandles([o.watch((()=>this.analysisViewData?.destroyed),(e=>{e&&this.removeHandles(v.AnalysisView)}),o.initial),o.watch((()=>["measured"===this.toolState.lineState,this.analysisViewData]),(([e,t])=>{null==t||t.destroyed||(t.allowVisualElementsOrientationChange=!e)}),o.initial),o.watch((()=>this._laserLineParams),(e=>{const t=this._laserLine;t.heightManifoldTarget=e.heightManifoldTarget,t.pointDistanceLine=e.pointDistanceLine,t.lineVerticalPlaneSegment=e.lineVerticalPlaneSegment}),o.initial)],v.AnalysisView)}_updateVisibility(e){this.initialized&&(this._visible=e,e?this._laserLine.style={innerColor:this._params.laserLineInnerColor,innerWidth:this._params.laserLineInnerWidth,glowColor:this._params.laserLineGlowColor,glowWidth:this._params.laserLineGlowWidth,glowFalloff:this._params.laserLineGlowFalloff,globalAlpha:this._params.laserLineGlobalAlpha}:this.view.cursor=null,this._laserLine.visible=e)}},t.__decorate([l.property({constructOnly:!0})],e.DirectLineMeasurement3DView.prototype,"view",void 0),t.__decorate([l.property()],e.DirectLineMeasurement3DView.prototype,"_params",null),t.__decorate([l.property({constructOnly:!0})],e.DirectLineMeasurement3DView.prototype,"analysis",void 0),t.__decorate([l.property({constructOnly:!0})],e.DirectLineMeasurement3DView.prototype,"analysisViewData",void 0),t.__decorate([l.property()],e.DirectLineMeasurement3DView.prototype,"cursorPoint",void 0),t.__decorate([l.property()],e.DirectLineMeasurement3DView.prototype,"toolState",void 0),t.__decorate([l.property()],e.DirectLineMeasurement3DView.prototype,"visible",null),t.__decorate([l.property()],e.DirectLineMeasurement3DView.prototype,"testData",null),t.__decorate([l.property()],e.DirectLineMeasurement3DView.prototype,"_visible",void 0),t.__decorate([l.property()],e.DirectLineMeasurement3DView.prototype,"_laserLine",void 0),t.__decorate([l.property({constructOnly:!0})],e.DirectLineMeasurement3DView.prototype,"laserLineEnabled",void 0),t.__decorate([l.property()],e.DirectLineMeasurement3DView.prototype,"_cursorPosition",null),t.__decorate([l.property()],e.DirectLineMeasurement3DView.prototype,"_startPosition",null),t.__decorate([l.property()],e.DirectLineMeasurement3DView.prototype,"_endPosition",null),t.__decorate([l.property()],e.DirectLineMeasurement3DView.prototype,"_lastDraggedHandle",void 0),t.__decorate([l.property()],e.DirectLineMeasurement3DView.prototype,"_laserLineParams",null),t.__decorate([l.property()],e.DirectLineMeasurement3DView.prototype,"_focusPosition",null),t.__decorate([l.property()],e.DirectLineMeasurement3DView.prototype,"_pointDistanceLine",null),e.DirectLineMeasurement3DView=t.__decorate([h.subclass("esri.views.3d.interactive.measurementTools.directLineMeasurement3D.DirectLineMeasurement3DView")],e.DirectLineMeasurement3DView),Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
