/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../Color","../../../../core/Handles","../../../../core/reactiveUtils","../../../../core/screenUtils","../../../../core/libs/gl-matrix-2/math/vec2","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../support/viewUtils","./VisualElement","../../../overlay/LineOverlayItem","../../../overlay/TextOverlayItem"],(function(t,e,o,i,s,r,a,n,c,h,l,_){"use strict";class u extends h.VisualElement{constructor(t){super(t),this._handles=new o,this._textItem=null,this._calloutItem=null,this._showCallout=!0,this._showText=!0,this._geometry=null,this._text="-",this._fontSize=14,this._backgroundColor=new e([0,0,0,.6]),this._calloutColor=new e([0,0,0,.5]),this._textColor=new e([255,255,255]),this._distance=25,this._anchor="right",this.updatePositionOnCameraMove=!0,this.applyProperties(t)}get geometry(){return this._geometry}set geometry(t){this._geometry=t,this.updateLabelPosition()}get isDecoration(){return this._isDecoration}set isDecoration(t){this._isDecoration=t,this._textItem&&(this._textItem.isDecoration=t),this._calloutItem&&(this._calloutItem.isDecoration=t)}get textItem(){return this._textItem}get text(){return this._text}set text(t){this._text=t,this.attached&&(this._textItem.text=this._text)}get fontSize(){return this._fontSize}set fontSize(t){this._fontSize=t,this.attached&&(this._textItem.fontSize=this._fontSize)}get backgroundColor(){return this._backgroundColor}set backgroundColor(t){this._backgroundColor=t,this.attached&&(this._textItem.backgroundColor=this._backgroundColor)}get calloutColor(){return this._calloutColor}set calloutColor(t){this._calloutColor=t,this.attached&&(this._calloutItem.color=this._calloutColor.toRgba())}get textColor(){return this._textColor}set textColor(t){this._textColor=t,this.attached&&(this._textItem.textColor=this._textColor)}get distance(){return this._distance}set distance(t){this._distance!==t&&(this._distance=t,this.updateLabelPosition())}get anchor(){return this._anchor}set anchor(t){this._anchor!==t&&(this._anchor=t,this.updateLabelPosition())}get _camera(){return this.view.state.cssCamera}overlaps(t){return!!this.attached&&(this.textItem.visible&&t.textItem.visible&&!!this.view.overlay?.overlaps(this._textItem,t.textItem))}updateLabelPosition(){if(!this.attached)return;this._showText=!1,this._showCallout=!1;const{geometry:t,view:e,visible:o}=this;if(null!=t&&e._stage)switch(t.type){case"point":if(!this._computeLabelPositionFromPoint(t.point,w))break;if(t.callout){const e=this._camera,o=t.callout.distance;r.add(f,f,[0,t.callout.offset]),e.renderToScreen(f,w),r.set(C,0,1),r.scale(C,C,o),r.add(C,C,f),e.renderToScreen(C,y),this._showCallout=this._updatePosition(w,y)}else this._textItem.position=[w[0],w[1]],this._textItem.anchor="center";this._showText=!0;break;case"corner":if(!this._computeLabelPositionFromCorner(t,this._distance,w,y))break;this._showCallout=this._updatePosition(w,y),this._showText=!0;break;case"segment":{if(!this._computeLabelPositionFromSegment(t,this._distance,this._anchor,w,y))break;this._showText=!0;const e=this._updatePosition(w,y);this._showCallout=!1!==t.callout&&e,this._showCallout||(this._textItem.anchor="center")}}this.updateVisibility(o)}_computeLabelPositionFromPoint(t,e){const o=this._camera;return o.projectToRenderScreen(t,I),!(I[2]<0||I[2]>1)&&(o.renderToScreen(I,e),!0)}_computeLabelPositionFromCorner(t,e,o,i){if(!t)return!1;const s=this._camera;return d(t.left,1,s,p),r.negate(p,p),d(t.right,0,s,v),r.add(C,p,v),r.negate(C,C),r.normalize(C,C),s.projectToRenderScreen(t.left.endRenderSpace,I),!(I[2]<0||I[2]>1)&&(s.renderToScreen(I,o),r.scale(C,C,e),r.add(C,C,I),s.renderToScreen(C,i),!0)}_computeLabelPositionFromSegment(t,e,o,i,s){if(!t)return!1;const a=t.segment,n=this._camera;c.renderScreenSpaceTangent(a.startRenderSpace,a.endRenderSpace,n,p),r.set(C,-p[1],p[0]);let h=!1;switch(o){case"top":h=C[1]<0;break;case"bottom":h=C[1]>0;break;case"left":h=C[0]>0;break;case"right":h=C[0]<0}if(h&&r.negate(C,C),0===r.length(C))switch(o){case"top":C[1]=1;break;case"bottom":C[1]=-1;break;case"left":C[0]=-1;break;case"right":C[0]=1}return a.eval(P[t.sampleLocation],S),n.projectToRenderScreen(S,I),!(I[2]<0||I[2]>1)&&(n.renderToScreen(I,i),r.scale(C,C,e),r.add(C,C,I),n.renderToScreen(C,s),!0)}_updatePosition(t,e){if(e){const o=e[0]-t[0],i=e[1]-t[1];return this._textItem.position=[e[0],e[1]],this._textItem.anchor=Math.abs(o)>Math.abs(i)?o>0?"left":"right":i>0?"top":"bottom",this._calloutItem.startPosition=[t[0],t[1]],this._calloutItem.endPosition=[e[0],e[1]],!0}return this._textItem.position=[t[0],t[1]],this._textItem.anchor="center",!1}createResources(){this._textItem=new _({visible:!0,text:this._text,fontSize:this._fontSize,backgroundColor:this._backgroundColor,textColor:this._textColor,isDecoration:this._isDecoration}),this._calloutItem=new l({color:this._calloutColor.toRgba(),visible:!0,width:2,isDecoration:this._isDecoration}),this.updateLabelPosition(),this.view.overlay?.items.addMany([this._textItem,this._calloutItem]),this.updatePositionOnCameraMove&&this._handles.add(i.watch((()=>this.view.state.camera),(()=>this.updateLabelPosition())))}destroyResources(){this.view.overlay&&!this.view.overlay.destroyed&&this.view.overlay.items.removeMany([this._textItem,this._calloutItem]),this._handles.removeAll()}updateVisibility(t){this._textItem.visible=this._showText&&t,this._calloutItem.visible=this._showCallout&&t}}function d(t,e,o,i){return t.eval(e,b,g),a.add(x,b,g),c.renderScreenSpaceTangent(b,x,o,i)}function m(t){switch(t){case"top":return"bottom";case"right":return"left";case"bottom":return"top";case"left":return"right"}}const b=n.create(),x=n.create(),g=n.create(),p=s.createRenderScreenPointArray(),v=s.createRenderScreenPointArray(),C=s.createRenderScreenPointArray(),S=n.create(),I=s.createRenderScreenPointArray3(),f=s.createRenderScreenPointArray(),w=s.createScreenPointArray(),y=s.createScreenPointArray(),P={start:0,center:.5,end:1};t.LabelVisualElement=u,t.mirrorPosition=m,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
