/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../chunks/languageUtils","../../../core/Accessor","../../../core/Collection","../../../core/handleUtils","../../../core/Logger","../../../core/MapUtils","../../../core/maybe","../../../core/promiseUtils","../../../core/reactiveUtils","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../../layers/buildingSublayers/BuildingGroupSublayer","./BuildingComponentSublayerView3D","./BuildingSublayerView3D","./LayerView3D","./i3s/BuildingFilterUtil","./i3s/I3SUtil","./support/highlightUtils","./support/LayerViewPerformanceInfo","../support/updatingProperties","../../layers/BuildingSceneLayerView","../../support/layerViewUtils"],(function(e,r,t,i,s,n,o,l,a,u,c,h,p,y,d,g,f,w,b,m,V,_,S,C,v){"use strict";const B=f.BuildingSublayerView3DMixin(t);let L=class extends(w.LayerView3D(C)){constructor(e){super(e),this.type="building-scene-3d",this.sublayerViews=new i,this._abortController=new AbortController,this._loadingComponents=0,this._pendingWhenSublayerViews=new Map,this.ignoresMemoryFactor=!1}get filterExpression(){const e=this.layer.activeFilterId,r=null!=e?this.layer.filters.find((r=>r.id===e)):null,t=null!=r?r.filterBlocks?.find((e=>"solid"===e.filterMode.type)):null;return t?t.filterExpression:null}get filterExpressions(){const e=this.layer.activeFilterId,r=null!=e?this.layer.filters.find((r=>r.id===e)):null;return r?.filterBlocks?r.filterBlocks.toArray().map((e=>[e.filterExpression??"",b.parseFilterMode(e)])):[]}get updatingProgressValue(){const e=this.sublayerViews,r=this._loadingComponents+(e?e.length:0);return e.reduce(((e,r)=>e+r.updatingProgress),0)/r}get visibleAtCurrentScale(){return v.isInEffectiveScaleRange(this.layer.effectiveScaleRange,this.view.scale)}isUpdating(){return this._loadingComponents>0||this.sublayerViews&&this.sublayerViews.some((e=>e.updating))}initialize(){m.checkSpatialReference(this.layer.spatialReference,this.view.spatialReference,this.view.viewingMode),this._initializeSubLayerViews(this.layer.sublayers,this)}destroy(){this.sublayerViews&&(this.sublayerViews.forEach((e=>e.destroy())),this.sublayerViews=null),this._abortController=l.abortMaybe(this._abortController)}_initializeSubLayerViews(e,r){const t=this,i=this.view;e.forEach((e=>{if(!e.isEmpty)if("building-group"===e.type){const t=new B({sublayer:e,view:i,parent:r});this._initializeSubLayerViews(e.sublayers,t)}else"mesh"===e.geometryType&&(this._loadingComponents++,e.load({signal:this._abortController.signal}).then((()=>{const s=new g({sublayer:e,layerView:t,view:i,parent:r});this.sublayerViews.push(s);const n=this._pendingWhenSublayerViews.get(e);if(n){for(const e of n)e.resolve(s);this._pendingWhenSublayerViews.delete(e)}this.addHandles([u.watch((()=>s.updating),(()=>this.notifyChange("updating")),u.syncAndInitial),u.watch((()=>s.updatingProgress),(()=>this.notifyChange("updatingProgressValue")),u.syncAndInitial)])})).catch((r=>{a.isAbortError(r)||n.getLogger(this).error(`Error while creating view for sublayer ${e.id}\nLayer: ${this.layer.url}\n`,r)})).then((()=>{this._loadingComponents--,this.notifyChange("updating"),this.notifyChange("updatingProgressValue")})))}))}getGraphicFromIntersectorTarget(e){for(const r of this.sublayerViews.items)if(r.sublayer.uid===e.sublayerUid)return r.getGraphicFromIntersectorTarget(e);return null}async fetchPopupFeaturesFromGraphics(e,r){if(0===e.length)return[];const t=M(e,(e=>e.sourceLayer)),i=[];for(const[n,o]of t){const e=this._findComponent(n);null!=e&&i.push(e.fetchPopupFeaturesFromGraphics(o,r))}const s=await a.allSettledValues(i);return a.throwIfAborted(r),s.flat()}whenGraphicBounds(e){const r=this._findComponent(e.sourceLayer);return null==r?Promise.reject():r.whenGraphicBounds(e)}getAABBFromIntersectorTarget(e){for(const r of this.sublayerViews.items)if(r.sublayer.uid===e.sublayerUid)return r.getAABBFromIntersectorTarget(e);return null}async whenSublayerView(e){const r=this._findComponent(e);if(null!=r)return r;const t=this._pendingWhenSublayerViews.get(e),i=a.createResolver();return t?t.push(i):this._pendingWhenSublayerViews.set(e,[i]),i.promise}_findComponent(e){return this.sublayerViews.find((r=>e===r.sublayer))}highlight(e,t){if(r.isQuery(e))return V.emptyHighlightHandle;const i=V.normalizeHighlightTargetExceptQuery(e);if(0===i.length)return V.emptyHighlightHandle;if(r.isGraphic(i[0])){const e=i,r=new Map;for(const t of e)o.getOrCreateMapValue(r,t.sourceLayer,(()=>[])).push(t);const n=[];return this.sublayerViews.forEach((e=>{const i=r.get(e.sublayer);i&&n.push(e.highlight(i,t))})),s.handlesGroup(n)}return V.emptyHighlightHandle}get usedMemory(){return this.sublayerViews.reduce(((e,r)=>e+r.usedMemory),0)}get unloadedMemory(){return this.sublayerViews.reduce(((e,r)=>e+r.unloadedMemory),0)}get performanceInfo(){return new _.LayerViewPerformanceInfo(this.usedMemory)}};function M(e,r){const t=new Map,i=e.length;for(let s=0;s<i;s++){const i=e[s],n=r(i,s,e),o=t.get(n);o?o.push(i):t.set(n,[i])}return t}e.__decorate([c.property()],L.prototype,"sublayerViews",void 0),e.__decorate([c.property({readOnly:!0})],L.prototype,"filterExpression",null),e.__decorate([c.property({readOnly:!0})],L.prototype,"filterExpressions",null),e.__decorate([c.property(S.updatingProgress)],L.prototype,"updatingProgress",void 0),e.__decorate([c.property({readOnly:!0,dependsOn:[]})],L.prototype,"updatingProgressValue",null),e.__decorate([c.property({readOnly:!0})],L.prototype,"visibleAtCurrentScale",null),L=e.__decorate([y.subclass("esri.views.3d.layers.BuildingSceneLayerView3D")],L);return L}));
