/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../core/asyncUtils","../../../core/handleUtils","../../../core/Logger","../../../core/maybe","../../../core/promiseUtils","../../../core/reactiveUtils","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../../geometry/Extent","../../../geometry/support/aaBoundingRect","./interfaces","./LayerView3D","./support/overlayImageUtils","./support/projectExtentUtils","../support/debugFlags","../terrain/interfaces","../webgl-engine/lib/ModelDirtyTypes","../webgl-engine/lib/RenderGeometry","../webgl-engine/lib/Texture","../webgl-engine/lib/UpdatePolicy","../webgl-engine/materials/ImageMaterial","../../layers/LayerView","../../layers/RefreshableLayerView","../../support/layerViewUtils","../../webgl/enums"],(function(e,t,r,i,a,s,n,o,l,h,d,c,u,g,m,p,y,_,w,x,f,b,v,E,R,I,S,A){"use strict";let D=class extends(I(m.LayerView3D(R))){constructor(){super(...arguments),this.drapeSourceType=g.DrapeSourceType.RasterImage,this.updatePolicy=v.UpdatePolicy.SYNC,this.fullExtentInLocalViewSpatialReference=null,this.maximumDataResolution=null,this._images=new Array,this._extents=new Array,this._overlays=new Array,this.updateWhenStationary=!0,this._drapeSourceRenderer=null,this.refreshDebounced=s.debounce((async e=>{this.destroyed||await this._doRefresh(e).catch((e=>{s.isAbortError(e)||i.getLogger(this).error(e)}))}),2e3)}get visibleAtCurrentScale(){const e=this.layer,t="effectiveScaleRange"in e?e.effectiveScaleRange:null;return S.isInEffectiveScaleRange(t,this.view.scale)}initialize(){this._drapeSourceRenderer=this.view.basemapTerrain.overlayManager.registerGeometryDrapeSource(this),this.addHandles(r.makeHandle((()=>this.view.basemapTerrain.overlayManager.unregisterDrapeSource(this)))),this.addResolvingPromise(y.toViewIfLocal(this).then((e=>this._set("fullExtentInLocalViewSpatialReference",e)))),this._updatingHandles.add((()=>this.suspended),(()=>this._suspendedChangeHandler()))}destroy(){this.clear()}setDrapingExtent(e,t){this._spatialReference=t,e.forEach(((e,t)=>{this._overlays[t]=e,this._updateImageExtent(e,t)}))}_updateImageExtent(e,t){const r=this._clippedExtent(e.extent,O);if(null==r)return;const a=p.computeImageExportSize(e.extent,r,e.resolution);let n=e.pixelRatio*this.view.state.pixelRatio;const{layer:o}=this;if("imageMaxWidth"in o&&null!=o.imageMaxWidth||"imageMaxHeight"in o&&null!=o.imageMaxHeight){const e=o.imageMaxWidth,t=o.imageMaxHeight;if(a.width>e){const t=e/a.width;a.height=Math.floor(a.height*t),a.width=e,n*=t}if(a.height>t){const e=t/a.height;a.width=Math.floor(a.width*e),a.height=t,n*=e}}const l=this._extents[t];l&&u.equals(l.extent,r)&&this._imageSizeEquals(r,l.imageSize,a)||(this._extents[t]={extent:u.create(r),imageSize:a,pixelRatio:n},this.suspended||this._fetch(t).catch((e=>{s.isAbortError(e)||i.getLogger(this).error(e)})))}clear(){for(let e=0;e<this._images.length;e++)this._clearImage(e)}async doRefresh(){return this._doRefresh()}async _doRefresh(e){if(this.suspended)return;const t=[];for(let r=0;r<this._extents.length;r++)this._extents[r]&&t.push(this._fetch(r,e));await Promise.allSettled(t)}async processResult(e,t,r){(t instanceof HTMLImageElement||t instanceof HTMLCanvasElement)&&(e.image=t)}findExtentInfoAt(e){for(const t of this._extents){const r=t.extent;if(new c(r[0],r[1],r[2],r[3],this._spatialReference).contains(e))return t}return null}getFetchOptions(){}async redraw(e,r){await t.forEach(this._images,(async(t,i)=>{t&&(await e(t,r),await this._createStageObjects(i,t.image,r))}))}_imageSizeEquals(e,t,r){if(!this.maximumDataResolution)return!1;const i=u.width(e)/this.maximumDataResolution.x,a=u.height(e)/this.maximumDataResolution.y,s=i/t.width,n=a/t.height,o=i/r.width,l=a/r.height,h=Math.abs(s-o),d=Math.abs(n-l),c=_.debugFlags.TESTS_DISABLE_OPTIMIZATIONS?0:1.5;return h<=c&&d<=c}async _fetch(e,t){if(this.suspended)return;const r=this._extents[e],n=r.extent;this._images[e]||(this._images[e]={texture:null,material:null,renderGeometry:null,loadingPromise:null,loadingAbortController:null,image:null,pixelData:null,renderExtent:u.create(n)});const o=this._images[e];o.loadingAbortController=a.abortMaybe(o.loadingAbortController);const l=new c(n[0],n[1],n[2],n[3],this._spatialReference);if(0===l.width||0===l.height)return void this._clearImage(e);const h=new AbortController;o.loadingAbortController=h,s.onAbort(t,(()=>h.abort()));const d=h.signal,g=this._waitFetchReady(d).then((async()=>{const t={requestAsImageElement:!0,pixelRatio:this._overlays[e].pixelRatio,...this.getFetchOptions(),signal:d},{height:i,width:a}=r.imageSize;return this.layer.fetchImage(l,a,i,t)})).then((e=>{if(s.isAborted(d))throw i.getLogger(this).warnOnce("A call to fetchImage resolved even though the request was aborted. fetchImage should not resolve if options.signal.aborted is true."),s.createAbortError();return this.processResult(o,e)})).then((()=>{u.copy(o.renderExtent,n)}));o.loadingPromise=g,await this._updatingHandles.addPromise(g.then((async()=>{s.throwIfAborted(d),await this._createStageObjects(e,o.image,d)})).catch((e=>{throw e&&!s.isAbortError(e)&&i.getLogger(this).error(e),e})).finally((()=>{g===o.loadingPromise&&(o.loadingPromise=null,o.loadingAbortController=null)})))}_clearImage(e){const t=this._images[e];if(t){null!=t.renderGeometry&&(this._drapeSourceRenderer.removeGeometries([t.renderGeometry],x.DirtyOperation.UPDATE),t.renderGeometry=null);const e=this.view._stage,r=t.texture;r?.unload(),e.remove(r),t.texture=null,e.remove(t.material),t.material=null,t.loadingAbortController=a.abortMaybe(t.loadingAbortController),t.loadingPromise=null,t.image=null,t.pixelData=null}}async _createStageObjects(e,r,i){const a=this.view._stage,n=this._images[e],o=()=>{n.texture?.unload(),a.remove(n.texture),n.texture=null,n.renderGeometry&&(this._drapeSourceRenderer.removeGeometries([n.renderGeometry],x.DirtyOperation.UPDATE),n.renderGeometry=null)};if(r){const l=new b.Texture(r,{width:r.width,height:r.height,preMultiplyAlpha:!0,wrap:{s:A.TextureWrapMode.CLAMP_TO_EDGE,t:A.TextureWrapMode.CLAMP_TO_EDGE}});let h;if(await t.result(this._images[e===w.OverlayIndex.INNER?w.OverlayIndex.OUTER:w.OverlayIndex.INNER].loadingPromise),s.throwIfAborted(i),o(),await a.schedule((()=>l.load(a.renderView.renderingContext)),i),a.add(l),n.texture=l,null==n.material?(n.material=new E.ImageMaterial({textureId:l.id}),a.add(n.material)):n.material.setParameters({textureId:l.id}),e===w.OverlayIndex.INNER)h=p.createGeometryForExtent(n.material,n.renderExtent);else{const e=this._images[0].renderExtent;if(!e)return void o();h=p.createOuterImageGeometry(n.material,e,n.renderExtent)}n.renderGeometry=new f.RenderGeometry(h),n.renderGeometry.localOrigin=this._overlays[e].renderLocalOrigin,this._drapeSourceRenderer.addGeometries([n.renderGeometry],x.DirtyOperation.UPDATE)}else o(),a.remove(n.material),n.material=null}_clippedExtent(e,t){if("local"!==this.view.viewingMode)return u.copy(t,e);const r=this.view.basemapTerrain;return r.ready?u.intersection(e,r.extent,t):u.copy(t,e)}_suspendedChangeHandler(){this.suspended?this.clear():this.refreshDebounced()}async _waitFetchReady(e){await n.whenOnce((()=>this.view.stationary),e),s.throwIfAborted(e)}};e.__decorate([o.property()],D.prototype,"layer",void 0),e.__decorate([o.property()],D.prototype,"suspended",void 0),e.__decorate([o.property({readOnly:!0})],D.prototype,"fullExtentInLocalViewSpatialReference",void 0),e.__decorate([o.property({readOnly:!0})],D.prototype,"visibleAtCurrentScale",null),e.__decorate([o.property()],D.prototype,"updating",void 0),D=e.__decorate([d.subclass("esri.views.3d.layers.DynamicLayerView3D")],D);const M=D,O=u.create();return M}));
