/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","exports","../../../chunks/tslib.es6","../../../Color","../../../Graphic","../../../chunks/languageUtils","../../../core/arrayUtils","../../../core/ByteSizeUnit","../../../core/has","../../../core/Logger","../../../core/maybe","../../../core/PooledArray","../../../core/promiseUtils","../../../core/reactiveUtils","../../../core/scheduling","../../../core/typedArrayUtil","../../../core/accessorSupport/decorators/property","../../../core/accessorSupport/decorators/subclass","../../../core/libs/gl-matrix-2/math/mat3","../../../core/libs/gl-matrix-2/factories/mat3f64","../../../core/libs/gl-matrix-2/math/mat4","../../../core/libs/gl-matrix-2/factories/mat4f64","../../../core/libs/gl-matrix-2/factories/quatf64","../../../chunks/vec32","../../../core/libs/gl-matrix-2/factories/vec3f64","../../../chunks/vec42","../../../core/libs/gl-matrix-2/factories/vec4f64","../../../core/support/UpdatingHandles","../../../geometry/spatialReferenceEllipsoidUtils","../../../geometry/projection/localLinearScaleFactors","../../../geometry/projection/projectBoundingSphere","../../../geometry/projection/projectBuffer","../../../geometry/projection/projectors","../../../geometry/projection/projectVectorToVector","../../../geometry/support/aaBoundingBox","../../../geometry/support/aaBoundingRect","../../../geometry/support/DoubleArray","../../../geometry/support/FloatArray","../../../geometry/support/Indices","../../../chunks/sphere","../../../geometry/support/UByteArray","../../../layers/LayerConstants","../../../layers/graphics/controllers/I3SOnDemandController","../../../layers/support/fieldUtils","../../../layers/support/SceneModification","../../../renderers/visualVariables/support/visualVariableUtils","../../../support/arcadeOnDemand","../../../support/basemapUtils","../../../support/elevationInfoUtils","../../../symbols/MeshSymbol3D","../../../symbols/SimpleFillSymbol","./I3SMeshViewLabeler","./I3SMeshViewPerformanceInfo","./I3SMeshWorkerHandle","./II3SMeshView3D","./SceneLayerWorker","./graphics/graphicUtils","./graphics/Labeler","./i3s/enums","./i3s/Highlights","./i3s/I3SAsyncElevationUpdater","./i3s/I3SCrossfadeHelper","./i3s/I3SGeometryUtil","./i3s/I3SIntersectionHandler","./i3s/I3SMaterialUtil","./i3s/I3SNode","./i3s/I3SOverrides","./i3s/I3SProjectionUtil","./i3s/I3SUtil","./i3s/IDBCache","./i3s/IDBMockCache","./i3s/LayerElevationProvider","./support/attributeUtils","./support/highlightUtils","./support/makeScheduleFunction","./support/symbolColorUtils","../support/debugFlags","../support/ElevationRange","../support/extentUtils","../support/orientedBoundingBox","../support/updatingProperties","../support/buffer/glUtil","../webgl-engine/collections/Component/ObjectParameters","../webgl-engine/collections/Component/SourceGeometry","../webgl-engine/collections/Component/Transform","../webgl-engine/core/shaderLibrary/attributes/TextureCoordinateAttribute.glsl","../webgl-engine/lib/BasisUtil","../webgl-engine/lib/edgeRendering/interfaces","../../support/HighlightDefaults"],(function(e,t,i,s,r,a,o,n,l,d,h,c,u,_,g,p,f,m,y,b,v,I,M,C,E,x,O,R,w,S,T,A,D,F,V,N,P,H,j,U,L,G,k,B,q,W,z,K,$,Q,X,Y,J,Z,ee,te,ie,se,re,ae,oe,ne,le,de,he,ce,ue,_e,ge,pe,fe,me,ye,be,ve,Ie,Me,Ce,Ee,xe,Oe,Re,we,Se,Te,Ae,De,Fe,Ve){"use strict";const Ne="esri.views.3d.layers.I3SMeshView3D",Pe=()=>d.getLogger(Ne),He=[1,1,1,1];class je extends ne.NodeCrossfadeMetaData{constructor(e,t,i,s,r,a,o,n,l){super(),this.node=e,this.featureIds=t,this.objectHandle=i,this.cachedRendererVersion=s,this.attributeInfo=r,this.material=a,this.textures=o,this.anchorIds=n,this.anchors=l,this.cachedElevationAnchors=null,this.cachedEdgeMaterials=new Array,this.edgeMemoryUsage=0}}var Ue;!function(e){e[e.CastShadows=4]="CastShadows",e[e.Pickable=5]="Pickable"}(Ue||(Ue={}));const Le=26,Ge=100*n.ByteSizeUnit.MEGABYTES,ke=t=>{let s=class extends t{constructor(){super(...arguments),this._applySSAO=!0,this._shadeNormals=!0,this._updatingHandles=new R.UpdatingHandles,this._nodeId2Meta=new Map,this._nodeId2MetaReloading=new Map,this._i3sWasmLoaded=!1,this._snappingSourcesTrackers=[],this._hasLoadedPBRTextures=!1,this._asyncModuleLoading=0,this._addTasks=new Map,this._currentRenderer=null,this._rendererVersion=0,this._colorVariable=null,this._opacityVariable=null,this._rendererFields=null,this._symbologyFields=null,this._symbologyOverride=null,this._symbologyOverrideFields=null,this._symbolInfos=new Map,this._visibleGeometryChangedSchedulerHandle=null,this._hasComponentData=!1,this._hasVertexColors=!1,this._nodeColorOverride=null,this.updating=!0,this.holeFilling="auto",this._hasColors=!1,this._hasTextures=!1,this._hasData=!1,this.slicePlaneEnabled=!1,this._modifications=new Array,this.ignoresMemoryFactor=!1,this._layerUrl="",this._cacheKeySuffix=null,this._planetRadiusInGlobalMode=0,this._elevationTask=null,this._filters=[],this._arcade=null,this._tmpAttributeOnlyGraphic=new r,this._crossfadeHelper=new ne.I3SCrossfadeHelper(this)}get lodCrossfadeoutDuration(){return 0}get lodCrossfadeinDuration(){return 0}get lodCrossfadeUncoveredDuration(){return 0}get layerUid(){return this.i3slayer&&this.i3slayer.uid}get sublayerUid(){return null}get layerId(){return this.i3slayer&&this.i3slayer.id}get sublayerId(){return null}get contentVisible(){return!this.suspended&&this._controller?.rootNodeVisible}get legendEnabled(){return this.contentVisible&&!0===this.i3slayer?.legendEnabled}get updatingProgressValue(){return this._controller?.updatingProgress??0}get hasTexturesOrVertexColors(){return this._hasData?this._hasTextures||this._hasColors?"yes":"probably-not":"unknown"}get rendererTextureUsage(){return ge.rendererNeedsTextures(this._currentRenderer)?this._usePBR||this._hasLoadedPBRTextures?re.TextureUsage.AllTexturesPBR:re.TextureUsage.AllTextures:this._usePBR||this._hasLoadedPBRTextures?re.TextureUsage.GeometryTexturesPBR:re.TextureUsage.GeometryTextures}get elevationOffset(){const e=null!=this.i3slayer?this.i3slayer.elevationInfo:null;return null!=e&&"absolute-height"===e.mode?$.getElevationOffset(e,this.i3slayer.spatialReference):0}get elevationInfo(){const e=null!=this.i3slayer?this.i3slayer.elevationInfo:null;if(null==e)return new ot(ee.ElevationMode.Absolute,0);const t=$.getElevationOffset(e,this.i3slayer.spatialReference);switch(e.mode){case"absolute-height":return new ot(ee.ElevationMode.Absolute,t);case"relative-to-ground":return new ot(ee.ElevationMode.RelativeToGround,t);case"on-the-ground":return new ot(ee.ElevationMode.OnTheGround,0);default:return new ot(ee.ElevationMode.Absolute,0)}}get supportedTextureEncodings(){return he.getSupportedEncodings(this.view._stage.renderView.capabilities)}get uncompressedTextureDownsamplingEnabled(){const e=this.view?.qualitySettings.sceneService.uncompressedTextureDownsamplingEnabled,t=!(this.supportedTextureEncodings&re.TextureEncoding.DDS_S3TC);return e&&t}get clientGeometry(){return this.i3sOverrides.geometryOverrides}get elevationRange(){const e=this._nodeId2Meta,t=new Ce.ElevationRange;for(const i of e.values()){if(null==i)continue;const{node:{serviceMbsInIndexSR:e}}=i,[s,r,a,o]=e;t.expandElevationRangeValues(a-o,a+o)}return t.elevationRangeValid?t:null}get fullExtent(){return this.i3slayer.fullExtent}initialize(){const t=l("enable-feature:idb-mock-cache");this._idbCache=t?new fe.IDBMockCache(this.view,t):new pe.IDBCache("esri-scenelayer-cache","geometries"),this._preLoadBasis(),this.addResolvingPromise(this.i3slayer.indexInfo);const i=this.view.resourceController,s=i.memoryController;this.i3sOverrides=new ue.I3SOverrides({view:this.view,layer:this.i3slayer,memoryController:s}),this._worker=new Z.I3SMeshWorkerHandle(ve.makeScheduleFunction(i)),this.addResolvingPromise(this._worker.promise);const r=this.i3slayer.store;this.addResolvingPromise(this._worker.setLegacySchema(this.uid,r.defaultGeometrySchema).catch(u.ignoreAbortErrors)),ge.checkSceneLayerValid(this.i3slayer),ge.checkSceneLayerCompatibleWithView(this.i3slayer,this.view),this._layerUrl=this.i3slayer.parsedUrl.path,this._controller=new k({layerView:this,worker:this._worker}),this._gpuMemoryEstimate=0,this._texMemoryEstimate=0,this._geoMemoryEstimate=0,this._stage=this.view._stage,this._collection=this._stage.renderView.componentObjectCollection,this.resetHighlights();const a=r.defaultGeometrySchema;if(this._isIntegratedMesh||!a)this._hasComponentData=!1;else{const e=a.featureAttributes;this._hasComponentData=!!(e&&e.faceRange&&e.id)}this._hasVertexColors=null!=(a?.vertexAttributes.color??null)&&!this.i3slayer.cachedDrawingInfo?.color;const o=this.view.resourceController.memoryController.newCache(`sl-${this.uid}`,(e=>this._deleteComponentObject(e)));this._memCache=o;const n=this._controller,d=this._nodeId2Meta,c=this._nodeId2MetaReloading,g=e=>{const t=n.index;if(!t)return;const i=t.rootNode;if(!i)return;const s=t=>{const i=t.index,s=d.get(i)||c.get(i);return e(t,s?.objectHandle??null)};t.traverse(i,s)};this._intersectionHandler=new de.I3SIntersectionHandler({layerUid:this.layerUid,sublayerUid:this.sublayerUid,collection:this._collection,slicePlaneEnabled:this.slicePlaneEnabled,isGround:this._isIntegratedMesh,traverseNodeHierarchy:g}),this._updatingHandles.add((()=>this.layerUid),(e=>this._intersectionHandler.layerUid=e)),this._updatingHandles.add((()=>this.sublayerUid),(e=>this._intersectionHandler.sublayerUid=e)),this._elevationProvider=new me.LayerElevationProvider({view:this.view,layerElevationSource:this,intersectionHandler:this._intersectionHandler}),this._hasLoadedPBRTextures=this._usePBR,this._updatingHandles.add((()=>this.view.clippingArea),(()=>this._clippingAreaChanged()),_.initial),this._updatingHandles.add((()=>this.fullOpacity),(e=>this._opacityChange(e))),this._updatingHandles.add((()=>this.slicePlaneEnabled),(e=>this._slicePlaneEnabledChange(e))),this._updatingHandles.add((()=>this.elevationOffset),((e,t)=>{this._reloadAll(t),this._controller.invalidateVisibilityObbs()})),this._updatingHandles.add((()=>this.elevationInfo),((e,t)=>this._elevationInfoChanged(e,t)),_.initial),this._updatingHandles.add((()=>!this.suspended&&this.elevationInfo.mode!==ee.ElevationMode.Absolute),((e,t)=>{e?this.addHandles(this.view.basemapTerrain.on("elevation-change",(({extent:e})=>this._ensureElevationTask().addExtent(e))),dt):t&&this.removeHandles(dt)}),_.initial),this._updatingHandles.add((()=>this._usePBR),(e=>this._updatePBR(e)));const p=()=>{this._reloadAll(),this.clearMemCache()};this._updatingHandles.add((()=>this.rendererTextureUsage),p),this._updatingHandles.add((()=>this.uncompressedTextureDownsamplingEnabled),p),this._updatingHandles.add((()=>this.contentVisible),(e=>this._contentVisibleChanged(e)),_.initial),this._updatingHandles.add((()=>this.i3slayer.labelsVisible),(()=>this._labelingChanged()),_.initial),this._updatingHandles.add((()=>this.i3slayer.labelingInfo),(()=>this._labelingChanged()),_.initial),this._updatingHandles.add((()=>this._modifications),(()=>this._modificationsChanged()),_.initial),this.addHandles([_.watch((()=>Me.debugFlags.I3S_TREE_SHOW_TILES),(t=>{if(t&&!this._treeDebugger){const t=this._controller.crsIndex;new Promise(((t,i)=>e(["./support/I3STreeDebugger"],t,i))).then((({I3STreeDebugger:e})=>{!this._treeDebugger&&Me.debugFlags.I3S_TREE_SHOW_TILES&&(this._treeDebugger=new e({lv:this,view:this.view,nodeSR:t}))}))}else t||Me.debugFlags.I3S_TREE_SHOW_TILES||(this._treeDebugger=h.destroyMaybe(this._treeDebugger))}),_.initial),_.watch((()=>Me.debugFlags.I3S_SHOW_MODIFICATIONS),(()=>this._showModifications()),_.initial)]),this._cacheKeySuffix=this._getCacheKeySuffix(),this._idbCache.init().catch((e=>Pe().warn(`Failed to initialize IndexedDB cache: ${e}`)));const{view:f}=this,{viewingMode:m,renderCoordsHelper:y}=f;this._planetRadiusInGlobalMode="local"===m?0:y.referenceEllipsoid.radius}destroy(){this._clearAddTasks(),this._elevationTask=h.destroyMaybe(this._elevationTask),this.i3sOverrides=h.destroyMaybe(this.i3sOverrides),this._elevationProvider&&(this._elevationProvider.objectsChanged(this.getVisibleObbs()),this.view.elevationProvider.unregister(this._elevationProvider),this._elevationProvider=null),this._intersectionHandler&&(this._stage.view.sceneIntersectionHelper.removeIntersectionHandler(this._intersectionHandler),this._intersectionHandler=null);const e=this._worker;e&&(e.destroyContext(this.uid).then((()=>e.destroy())),this._worker=null),this._removeAllNodeDataFromStage(),this._memCache=h.destroyMaybe(this._memCache),this._collection=null,this._stage=null,this._edgeView=null,this._labeler=h.destroyMaybe(this._labeler),this._treeDebugger=h.destroyMaybe(this._treeDebugger),this._controller=h.destroyMaybe(this._controller),this._highlights.destroy(),this._nodeId2Meta.clear(),this._nodeId2MetaReloading.clear(),this._crossfadeHelper=h.destroyMaybe(this._crossfadeHelper),this.emit("visible-geometry-changed"),this._visibleGeometryChangedSchedulerHandle&&(this._visibleGeometryChangedSchedulerHandle.remove(),this._visibleGeometryChangedSchedulerHandle=null),this._updatingHandles=h.destroyMaybe(this._updatingHandles)}_memEstimateTextureAdded(e){const t=e.memoryEstimate;return this._gpuMemoryEstimate+=t,this._texMemoryEstimate+=t,t}_memEstimateTextureRemoved(e){if(null!=e){const t=e.memoryEstimate;this._gpuMemoryEstimate-=t,this._texMemoryEstimate-=t}}_memEstimateGeometryAdded(e){const t=this._collection.getObjectGPUMemoryUsage(e);return this._gpuMemoryEstimate+=t,this._geoMemoryEstimate+=t,t}_memEstimateGeometryRemoved(e){const t=this._collection.getObjectGPUMemoryUsage(e);this._gpuMemoryEstimate-=t,this._geoMemoryEstimate-=t}isNodeLoaded(e){return this._nodeId2Meta.has(e)}isNodeReloading(e){return this._nodeId2MetaReloading.has(e)}get usedMemory(){let e=null!=this._labeler?this._labeler.usedMemory:0;return this._nodeId2Meta.forEach((t=>e+=null!=t?t.node.memory:0)),this._nodeId2MetaReloading.forEach((t=>e+=null!=t?t.node.memory:0)),e}get unloadedMemory(){return(null!=this._controller?this._controller.unloadedMemoryEstimate:0)+(null!=this._labeler?this._labeler.unloadedMemoryEstimate:0)}_labelingChanged(){if(!(se.areLabelsVisible(this.i3slayer)&&this._supportsLabeling))return void(null!=this._labeler&&(this._labeler.destroy(),this._labeler=null));if(null!=this._labeler)return;const e=new Y({view:this.view,layer:this.i3slayer,collection:this._collection,overrides:this.i3sOverrides});this._nodeId2Meta.forEach((t=>null!=t&&this._addMetaToLabeler(e,t))),this._labeler=e}_loadAsyncModule(e){return++this._asyncModuleLoading,e.then((e=>(--this._asyncModuleLoading,e)),(e=>{throw--this._asyncModuleLoading,e}))}_modificationsChanged(){if(!this._i3sWasmLoaded&&this.hasModifications)return this._i3sWasmLoaded=te.initialize().then((()=>{this._i3sWasmLoaded=!0,this._modificationsChanged(),this.notifyUpdate()})),void this.notifyUpdate();if(!0!==this._i3sWasmLoaded)return;const e=this.uid,t=this.i3slayer.spatialReference;this._worker.setModifications(e,this._layerClippingArea,this._modifications,t);const i=Z.toWasmModification(this._layerClippingArea,this._modifications,t);te.setModificationsSync({context:e,modifications:i,isGeodetic:t.isGeographic}),this._controller.modificationsChanged();const s=this.hasModifications?new c:null;this._nodeId2Meta.forEach(((e,t)=>{null==e?(this._nodeId2Meta.delete(t),this._controller.updateLoadStatus(t,!1)):e.node.hasModifications?(this._nodeId2Meta.delete(t),this._nodeId2MetaReloading.set(t,e)):null!=s&&s.push(e.node)})),this.notifyChange("elevationRange"),null!=s&&this._nodeId2MetaReloading.forEach((e=>s.push(e.node))),null!=s&&s.length>0&&(this.updateNodeModificationStatus(s),s.forAll((e=>{if(e.imModificationImpact!==ce.NodeIMModificationImpact.Culled){const t=this._nodeId2Meta.get(e.index);this._controller.invalidateGeometryVisibility(e.index),null!=t?(this._nodeId2Meta.delete(e.index),this._nodeId2MetaReloading.set(e.index,t),this.notifyChange("elevationRange")):this._nodeId2Meta.has(e.index)&&(this._nodeId2Meta.delete(e.index),this._controller.updateLoadStatus(e.index,!1))}}))),this.clearMemCache(),this._controller.restartNodeLoading(),this._showModifications()}_showModifications(){if(null!=this._modificationGraphics&&(this.view.graphics.removeMany(this._modificationGraphics),this._modificationGraphics=null),!Me.debugFlags.I3S_SHOW_MODIFICATIONS||0===this._modifications.length)return;const e={clip:[227,227,79,.8],mask:[227,139,79,.8],replace:[139,227,79,.8]},t={outline:{color:[255,255,255],width:1}};this._modificationGraphics=new Array;for(const i of this._modifications){const s=i.geometry;s.spatialReference=this.i3slayer.spatialReference;const a=new X({...t,color:e[i.type]});this._modificationGraphics.push(new r({geometry:s,symbol:a}))}this.view.graphics.addMany(this._modificationGraphics)}_addMetaToLabeler(e,t){e.addNodeMeta(t,((e,t)=>this._createAttributes(e,t)))}_contentVisibleChanged(e){e?(this.view.elevationProvider.register(this._elevationContext,this._elevationProvider),this._stage.view.sceneIntersectionHelper.addIntersectionHandler(this._intersectionHandler)):(this._removeAllNodeDataFromStage(),this.view.elevationProvider&&this.view.elevationProvider.unregister(this._elevationProvider),this._stage.view.sceneIntersectionHelper.removeIntersectionHandler(this._intersectionHandler))}getLoadedAttributes(e){const t=this._nodeId2Meta.get(e);if(null!=t?.attributeInfo)return t.attributeInfo.loadedAttributes}getAttributeData(e){const t=this._nodeId2Meta.get(e);if(null!=t?.attributeInfo)return t.attributeInfo.attributeData}setAttributeData(e,t){const i=this._nodeId2Meta.get(e);null!=i?.attributeInfo&&(i.attributeInfo.attributeData=t,this._attributeValuesChanged(i))}async updateAttributes(e,t,i){const s=this._nodeId2Meta.get(e);null!=s&&(await this.i3sOverrides.applyAttributeOverrides(s.featureIds,t,i,this._controller.requiredAttributes),s.attributeInfo=t,this._controller.reschedule((()=>this._attributeValuesChanged(s)),i).catch((e=>{u.isAbortError(e)||Pe().warn("Error while updating attribute values. Layer might not display correctly.",e)})))}_attributeValuesChanged(e){e.cachedRendererVersion=this._getInvalidRendererVersion(),e.filteredIds=null,null!=this._labeler&&this._labeler.setNodeMetaAttributes(e,((e,t)=>this._createAttributes(e,t))),this._updateEngineObject(e)}clearMemCache(){null!=this._memCache&&this._memCache.clear(),this._addTasks.forEach((e=>e.allowMemCache=!1))}getVisibleNodes(){const e=new Array;return this._nodeId2Meta.forEach((t=>null!=t&&e.push(t.node))),e}getVisibleObbs(){const e=new Array;return this._nodeId2Meta.forEach((t=>{if(null!=t){const i=this.getNodeComponentObb(t.node);null!=i&&e.push(i)}})),e}getNodeComponentObb(e){const t=this._nodeId2Meta.get(e.index)??this._nodeId2MetaReloading.get(e.index);return null!=t?this._collection.getComponentObb(t.objectHandle):null}getLoadedNodeIndices(e){this._nodeId2Meta.forEach(((t,i)=>e.push(i))),this._nodeId2MetaReloading.forEach(((t,i)=>e.push(i)))}_preLoadBasis(){!l("disable-feature:i3s-basis")&&this.supportedTextureEncodings&re.TextureEncoding.Basis&&this.i3slayer.textureSetDefinitions?.some((e=>e.formats.some((e=>"basis"===e.format||"ktx2"===e.format))))&&De.loadBasis()}_getVertexBufferLayout(e,t){return Re.glLayout(Se.createVertexBufferLayout(this._getGeometryParameters({hasTexture:Je(e.params.material),hasNormals:t.normal,hasRegions:t.uvRegion})))}_getObjectIdField(){return this.i3slayer.objectIdField||G.fallbackObjectIDAttribute}_getGlobalIdField(){return this.i3slayer.associatedLayer?.globalIdField}_findGraphicNodeAndIndex(e){const t=ye.attributeLookup(this.i3slayer.fieldsIndex,e.attributes,this._getObjectIdField());for(const i of this._nodeId2Meta.values()){const e=i?.featureIds.indexOf(t);if(null!=e&&e>=0)return{node:i.node,index:e}}return null}_getGraphicIndices(e,t){const i=this._nodeId2Meta.get(e.index);if(null==i)return[];const s=[],r=this._getObjectIdField(),a=this.i3slayer.fieldsIndex;for(const o of t){const e=ye.attributeLookup(a,o.attributes,r),t=i.featureIds.indexOf(e);-1!==t&&s.push(t)}return s}whenGraphicBounds(e){const t=this._findGraphicNodeAndIndex(e);if(!t)return Promise.reject();const i=this._getAABB(t.node.index,t.index);return null==i?Promise.reject():Promise.resolve({boundingBox:i,screenSpaceObjects:[]})}getAABBFromIntersectorTarget(e){return null==e.nodeIndex||null==e.componentIndex?null:this._getAABB(e.nodeIndex,e.componentIndex)}_getAABB(e,t){const i=this._nodeId2Meta.get(e);if(null==i?.featureIds||t>=i.featureIds.length)return null;const s=i.objectHandle,r=le.boundingBoxCornerPoints(t,this._collection,s,P.newDoubleArray(24),0),a=this.view.renderSpatialReference,o=this.view.spatialReference;return A.projectBuffer(r,a,0,r,o,0)?V.fromBuffer(r):null}whenGraphicAttributes(e,t){return ge.whenGraphicAttributes(this.i3slayer,e,this._getObjectIdField(),t,(()=>[...this._nodeId2Meta.values()].filter(o.isSome)))}getGraphicFromIntersectorTarget(e){if(null==e.nodeIndex||null==e.componentIndex)return null;const t=this._nodeId2Meta.get(e.nodeIndex);return null==t?.featureIds||e.componentIndex>=t.featureIds.length?null:this._createGraphic(e.componentIndex,t)}_getCacheKey(e){return`${this._layerUrl}/v${Le}/${e}${this._cacheKeySuffix}`}_getCacheKeySuffix(){const e=this.view.renderSpatialReference;if(null==e)return ct;if(e===w.getSphericalPCPF(e))return ut;return this.i3slayer.spatialReference.equals(e)?ht:null!=e.wkid?`@${e.wkid}`:null}_getMemCacheKey(e,t=this.elevationOffset){return e+"#"+t}get _idbCacheEnabled(){return!this._controller.disableIDBCache&&!this.hasModifications&&0===this.elevationOffset&&null!=this._cacheKeySuffix}loadCachedGPUData(e){return null!=this._memCache?this._memCache.pop(this._getMemCacheKey(e)):null}deleteCachedGPUData(e){null!=e&&this._deleteComponentObject(e)}_cacheGPUData(e,t=this.elevationOffset){if(null==this._memCache)return void this._deleteComponentObject(e);const i=this._controller.indexDepth-e.node.level;this._memCache.put(this._getMemCacheKey(e.node.index,t),e,e.node.memory,i)}loadMissingTextures(e,t,i,s){const r=e?.filter(((e,i)=>{if(!(e.usage&this.rendererTextureUsage))return!1;if(null==t)return!0;const s=he.selectEncoding(e.encodings,this.supportedTextureEncodings),r=t[i];return!!(null==r?.data||s&&r.encoding!==s.encoding)}))??[];return 0===r.length?Promise.resolve(!1):i(r,s).then((i=>{let s=0;for(let r=0;r<e.length;r++)s<i.length&&i[s].id===e[r].id&&(t[r]=i[s],s++);return!0}))}loadCachedNodeData(e,t,i){return this._idbCacheEnabled?this._idbCache.get(this._getCacheKey(e.id),t).then((s=>null==s?null:s.nodeVersion!==e.version?(this._idbCache.remove(this._getCacheKey(e.id)),null):(this.elevationInfo.mode===ee.ElevationMode.Absolute&&(e.geometryObbInRenderSR=xe.Obb.fromData(s.geometryObbData)),this.loadMissingTextures(s.requiredTextures,s.textureData,i,t).then((i=>(i&&this._idbCache.initialized&&null!=s.textureData&&(s.byteSize=tt(s.transformedGeometry,s.textureData),s.textureData.every(et)&&it(e,s)&&this._idbCache.put(this._getCacheKey(e.id),s).catch((t=>Pe().warn(`Failed to update node with textures in IndexedDB cache: ${e.id}: ${t}`)))),u.throwIfAborted(t),s)))))):Promise.resolve(null)}addNode(e,t,i){return Ze(t)?null==t.geometryBuffer?(this._addNodeMeta(e.index,null),Promise.resolve()):this._addData(e,t.attributeDataInfo,(()=>this._transformNode(e,t,i).then((s=>this._safeReschedule((()=>{if(null==s)return e.hasModifications=!1,this._addCachedNodeData(e,null,i);e.hasModifications=s.transformedGeometry.hasModifications;const{obb:r,componentOffsets:a,featureIds:o,anchorIds:n,anchors:l,transformedGeometry:d,globalTrafo:h}=s,c=C.set(nt,r.center.x,r.center.y,r.center.z);C.transformMat4(c,c,h);const u=new xe.Obb(c,[r.extents.x,r.extents.y,r.extents.z],M.fromValues(r.orientation.x,r.orientation.y,r.orientation.z,r.orientation.w));this.elevationInfo.mode===ee.ElevationMode.Absolute&&(e.geometryObbInRenderSR=u),t.geometryData.componentOffsets=a,o&&(t.geometryData.featureIds=Array.from(o)),t.geometryData.anchorIds=n,t.geometryData.anchors=l;const _={nodeVersion:e.version,geometryData:t.geometryData,requiredTextures:t.requiredTextures,textureData:t.textureData,transformedGeometry:d,globalTrafo:h,geometryObbData:u.data,byteSize:tt(d,t.textureData)};if(this._idbCacheEnabled&&this._idbCache.initialized&&it(e,_)){const t=null!=_.textureData?_.textureData.map((e=>et(e)?e:null)):null;this._idbCache.put(this._getCacheKey(e.id),{..._,textureData:t}).catch((t=>Pe().warn(`Failed to store node in IndexedDB cache: ${e.id}: ${t}`)))}return this._addCachedNodeData(e,_,i)}),i))))):Promise.reject()}getElevationRange(e){const t=new Ce.ElevationRange,i=this._controller,{index:s}=i;if(!s)return t;const{rootNode:r}=s;if(!r)return t;const a=this._nodeId2Meta,o=e[3],n=i.viewportQueries,l=this._planetRadiusInGlobalMode,{view:d}=this,{renderCoordsHelper:h}=d,c=h.referenceEllipsoid.radius,u=this._collection,_=i=>{const{childrenLoaded:s}=i;if(0===s)return!1;const r=n.getAndUpdateVisibilityObbInRenderSR(i);let d=null,_=-1;if(r){if(_=r.radius,!r.intersectSphereWithMBS(e,_))return!1}else d=n.getServiceMbsInRenderSR(i),d&&(_=d[3]);if(_>=0&&o>=1*_)return null!=r?pt(t,r,l):null!=d&&d[3]>=0&&ft(t,d,l),!1;const g=gt;if(g.elevationRangeMin=1/0,g.elevationRangeMax=-1/0,(null!=r||null!=d)&&(null!=r?pt(g,r,l):null!=d&&ft(g,d,l),g.elevationRangeMin>=t.elevationRangeMin&&g.elevationRangeMax<=t.elevationRangeMax))return!1;const p=a.get(i.index);if(p){const{geometryObbInRenderSR:s}=i;if(!s||s.intersectSphereWithMBS(e)){if(s){if(o>0*s.radius)return pt(t,s,l),!1}const{objectHandle:e}=p,i=u.getObjectTransform(e),r=h.getAltitude(i.position);u.expandRangeWithComponentObjectElevationRange(e,r,c,t)}}return s-(p?1:0)>0};return s.traverse(r,_),t}computeVisibilityObb(e){return ge.computeVisibilityObb(e,this.view.renderSpatialReference,this._controller.crsIndex,this.i3slayer.spatialReference,this.elevationOffset,this._modifications,this.view.renderCoordsHelper.sphericalPCPF)}_transformNode(e,t,i){const s=t.geometryData.geometries??[],r=new Array(s.length);for(let f=0;f<s.length;++f)r[f]=this._getVertexBufferLayout(s[f],t.geometryDescriptor);const a=this.i3slayer.normalReferenceFrame,o=t.normalReferenceFrame??a??"none",n=e.serviceMbsInIndexSR,l=this.elevationOffset,d=this._controller.crsIndex,h=this._controller.crsVertex,c=this.view.renderSpatialReference,u=_e.computeGlobalTransformation(n,l,o,d,c),_=D.getProjectorName(d,h),g=D.getProjectorName(h,c);if(null==_||null==g)return Promise.resolve(null);const p={context:this.uid,geometryBuffer:t.geometryBuffer,geometryData:t.geometryData,geometryDescriptor:t.geometryDescriptor,layouts:r,globalTrafo:u,mbs:n,obbData:e.serviceObbInIndexSR?.data,elevationOffset:l,needNormals:this._controller.isMeshPyramid,normalReferenceFrame:o,indexToVertexProjector:_,vertexToRenderProjector:g};return this._worker.invoke(p,i)}get _supportsNodeCrossFading(){return!this.view?._stage?.renderer.shadowsEnabled}get nodeCrossfadingEnabled(){return this._supportsNodeCrossFading&&(this.lodCrossfadeinDuration>0||this.lodCrossfadeoutDuration>0||this.lodCrossfadeUncoveredDuration>0)}get nodeFadeoutEnabled(){return this._supportsNodeCrossFading&&this.lodCrossfadeoutDuration>0}_setNewNodeOpacity(e){const t=this.nodeCrossfadingEnabled?0:this.fullOpacity;this._setNodeOpacity(e,t)}addCachedGPUData(e,t,i){if(this.elevationInfo.mode===ee.ElevationMode.Absolute&&(e.geometryObbInRenderSR=this._collection.getComponentObb(t.objectHandle).clone()),!this._controller.isGeometryVisible(e))return void this._cacheGPUData(t);null!=this._labeler&&this._addMetaToLabeler(this._labeler,t);const s=e.index;this._addNodeMeta(s,t),this.updateNodeState(s,i),this._collection.setObjectVisibility(t.objectHandle,!0),this._updateMaterial(t),this._setNewNodeOpacity(t),this.elevationInfo.mode!==ee.ElevationMode.Absolute&&this._ensureElevationTask().schedule(s),this._updateEngineObject(t),this._highlights.objectCreated(t),null!=this._treeDebugger&&this._treeDebugger.update()}addCachedNodeData(e,t,i,s){return this._addData(e,i,(()=>this._addCachedNodeData(e,t,s)))}async deleteCachedNodeData(e){if(this._idbCacheEnabled)return this._idbCache.remove(this._getCacheKey(e))}async _addCachedNodeData(e,t,i){if(!this.contentVisible||!this._controller.isGeometryVisible(e))return void this._removeNodeStageData(e.index,this.elevationOffset,this._nodeId2MetaReloading);if(null==t)return void this._addNodeMeta(e.index,null);const s=this._addTasks.get(e.index),{geometryData:r,transformedGeometry:a,globalTrafo:o}=t;await this.i3sOverrides.applyAttributeOverrides(r.featureIds,s.attributeInfo,i,this._controller.requiredAttributes);const n=null!=t.textureData?t.textureData.filter((e=>null!=e&&!!(e.usage&this.rendererTextureUsage))):[];!l("disable-feature:i3s-basis")&&n.some((e=>null!=e&&(e.encoding===re.TextureEncoding.Basis||e.encoding===re.TextureEncoding.KTX2)))&&await De.loadBasis(),e.memory=0;const{componentOffsets:d,geometries:h,featureIds:c,anchorIds:u,anchors:_}=r,g=this._collection,p=h[0],{layout:f,indices:m,interleavedVertexData:M,positionData:x,hasColors:R}=a,{material:w,geometryParameters:T}=this._materialParameters(p,f),A=d||new Uint32Array([0,m?m.length:M.byteLength/f[0].stride]),D={vertices:{data:M,count:M.byteLength/f[0].stride,layoutParameters:T},positionData:{positions:H.compactFloatArray(x.data),indices:j.compactIndices(x.indices)},indices:m,componentOffsets:A},V=p.transformation?I.clone(p.transformation):I.create();v.multiply(V,o,V);const N=v.getTranslation(E.create(),V),P=y.fromMat4(b.create(),V),U=this.view.renderSpatialReference,L=this.view.basemapTerrain.spatialReference,G=xe.Obb.fromData(t.geometryObbData).center,k=[1,1,1];S.localLinearScaleFactors(G,U,k,L)||Pe().errorOnce("Unsupported coordinate system for IM overlay");const B=E.create();F.projectVectorToVector(G,U,B,L);const q=b.create();y.invert(q,P);const W=E.create();C.transformMat3(W,C.sub(W,G,N),q);const z=B[0]-W[0]*k[0],K=B[1]-W[1]*k[1],$=g.createObject(new we.ObjectParameters(O.fromValues(z,K,k[0],k[1]),new Te.Transform(N,P),xe.Obb.fromData(t.geometryObbData),D)),Q=T.textureCoordinates===Ae.TextureCoordinateType.Atlas,{textures:X,texturePromise:Y}=this._initMaterialAndTextures($,w,n,Q);e.memory+=this._memEstimateGeometryAdded($),e.memory+=X.reduce(((e,t)=>e+(null!=t?this._memEstimateTextureAdded(t):0)),0);const J=!!w.hasParametersFromSource,Z="blend"!==w.alphaMode&&w.metallicRoughness.baseColorFactor[3]>=1,ee=new je(e,c,$,this._getInvalidRendererVersion(),s.attributeInfo,{hasParametersFromSource:J,isOpaque:Z},X,u,_);s.meta=ee,!this._hasTextures&&t.requiredTextures?.some((({usage:e})=>!!(e&re.TextureUsage.ColorTextures)))&&(this._hasTextures=!0),this._hasData=!0,this._hasColors=this._hasColors||R,this._hasTextures=this._hasTextures||!!e.resources.texture,this.notifyChange("hasTexturesOrVertexColors");const te=this.slicePlaneEnabled;return Promise.all([this._addOrUpdateEdgeRendering(ee),Y]).then((([t,s])=>(this._addTasks.has(e.index)&&t?.updateObjectVisibility(ee.objectHandle,!1).catch((e=>Be(e,this.i3slayer.title))),this._safeReschedule((()=>{const i=this._addTasks.get(e.index);if(!i)return;if(this._addNodeMeta(e.index,ee),i.meta=null,!this.contentVisible)return void this._removeNodeStageData(e.index,this.elevationOffset);g.setObjectVisibility($,!0),t?.updateObjectVisibility(ee.objectHandle,!0).catch((e=>Be(e,this.i3slayer.title))),ee.attributeInfo=i.attributeInfo;const s=ee.cachedRendererVersion!==this._rendererVersion,r=te!==this.slicePlaneEnabled;this._updateElevationOffsets(ee);const a=ee.elevationOffsets;this._updateComponentData(ee);const o=this._applyFiltersToNode(ee);(s||null!=t&&(r||o||a))&&this._addOrUpdateEdgeRendering(ee),null!=this._labeler&&this._addMetaToLabeler(this._labeler,ee),this._visibleGeometryChanged(ee,qe.ADD),this._highlights.objectCreated(ee),this._updateMaterial(ee),this._setNewNodeOpacity(ee),null!=this._treeDebugger&&this._treeDebugger.update()}),i)))).catch((e=>{const{meta:t,allowMemCache:i}=s;throw s.meta=null,t&&i?this._cacheGPUData(t):t&&this._deleteComponentObject(t),e}))}_addNodeMeta(e,t){if(this._removeNodeStageData(e,this.elevationOffset,this._nodeId2MetaReloading),this._nodeId2Meta.has(e)){Pe().error("Removing duplicated node");const t=this._nodeId2Meta.get(e);null!=t&&this._deleteComponentObject(t)}else this._controller.updateLoadStatus(e,!0);null!=t&&(t.lodCrossfadeProgress=null,this.nodeCrossfadingEnabled&&at(t.cachedEdgeMaterials,0)),this._nodeId2Meta.set(e,t),this.notifyChange("elevationRange")}_updateElevationOffsets(e){const t=this.view.renderSpatialReference,i=this._controller.crsIndex,s=this.elevationInfo,r=this.view.basemapTerrain,a=r.spatialReference,o=s.mode;if(null==t||null==a||o===ee.ElevationMode.Absolute)return void(e.elevationOffsets=null);const n=this._collection.getObjectTransform(e.objectHandle);e.elevationOffsets=e.elevationOffsets??[];const l=nt,d=lt,h=o===ee.ElevationMode.OnTheGround,c=this.view.renderCoordsHelper,u=e.featureIds.length,_=(()=>{if(e.cachedElevationAnchors)return e.cachedElevationAnchors;const s=P.newDoubleArray(3*u);e.cachedElevationAnchors=s;for(let r=0;r<u;r++){const o=3*r,h=e.anchorIds?.indexOf(r)??-1;e.anchors&&h>=0?(C.set(l,e.anchors[3*h],e.anchors[3*h+1],e.anchors[3*h+2]),C.add(l,l,U.getCenter(e.node.serviceMbsInIndexSR)),F.projectVectorToVector(l,i,l,a),s[o]=l[0],s[o+1]=l[1],s[o+2]=c.getAltitude(l)):(this._collection.getComponentAabb(e.objectHandle,r,d,!0),C.set(l,(d[0]+d[3])/2,(d[1]+d[4])/2,d[2]),C.transformMat3(l,l,n.rotationScale),C.add(l,l,n.position),s[o+2]=c.getAltitude(l),F.projectVectorToVector(l,t,l,a),s[o]=l[0],s[o+1]=l[1])}return s})(),g=s.offset,p=e.elevationOffsets,f=(e,t)=>{const i=h?_[3*e+2]:0;p[e]=g+(null!=t?t-i:0)};r.getElevations(_,u,f)}_ensureElevationTask(){return null!=this._elevationTask||(this._elevationTask=new oe.I3SAsyncElevationUpdater(this.view.resourceController.scheduler,(e=>{const t=this._controller.updateElevationChanged(e,this.view.basemapTerrain.spatialReference);return null!=t?t.filterInPlace((e=>null!=this._nodeId2Meta.get(e))):null}),(e=>{const t=this._nodeId2Meta.get(e);this._nodeElevationAlignmentChanged(t)}),(()=>this.elevationInfo?.mode))),this._elevationTask}_elevationInfoChanged(e,t){const i=e.mode!==ee.ElevationMode.Absolute,s=!!t&&t!==e&&t.mode!==ee.ElevationMode.Absolute;this._intersectionHandler.updateElevationAlignState(i,this.view.state.viewingMode),i&&!s&&this._controller.removeAllGeometryObbs(),this._nodeId2Meta.forEach((e=>this._nodeElevationAlignmentChanged(e)))}_nodeElevationAlignmentChanged(e){null!=e&&(this._updateElevationOffsets(e),this._updateComponentData(e),this._updateEdgeRendering(e),null!=this._labeler&&this._labeler.updateLabelPositions(e),this._updateSnappingSources(e,qe.UPDATE))}_safeReschedule(e,t){return u.throwIfAborted(t),this._controller.reschedule(e,t)}_materialParameters(e,t){const i=null!=e.params.material?e.params.material:he.defaultMaterial(),s=t.some((e=>"uvRegion"===e.name)),r=t.some((e=>"normalCompressed"===e.name)),a=Je(i);return{geometryParameters:this._getGeometryParameters({hasTexture:a,hasNormals:r,hasRegions:s}),material:i}}_initMaterialAndTextures(e,t,i,s){const r=this._stage.renderView,a=i.map((e=>he.createTexture(e,t,s,r)));this._stage.addMany(a);let o=null;return this._collection.updateMaterial(e,(e=>{o=he.configureMaterial(e,t,a,i,this.view._stage.renderView.textures,{rendererTextureUsage:this.rendererTextureUsage,usePBR:this._usePBR,isIntegratedMesh:this._isIntegratedMesh,slicePlaneEnabled:this.slicePlaneEnabled,viewSpatialReference:this.view.spatialReference}),this._updateMaterialOverlay(e)})),{textures:a,texturePromise:o}}_getGeometryParameters(e){return new Se.GeometryParameters(this._hasVertexColors,e.hasTexture?e.hasRegions?Ae.TextureCoordinateType.Atlas:Ae.TextureCoordinateType.Default:Ae.TextureCoordinateType.None,e.hasNormals,this._shadeNormals,this._applySSAO)}_addData(e,t,i){let s=this._addTasks.get(e.index);if(s)s.attributeInfo=t;else{const r=u.createResolver();s=new rt(t,null,r.promise),this._addTasks.set(e.index,s),i().then(r.resolve,r.reject).then((()=>this._addTasks.delete(e.index))).catch((t=>{throw this._addTasks.delete(e.index),t}))}return s.promise}_clearAddTasks(){this._addTasks.forEach((e=>{null!=e.meta&&(this._cacheGPUData(e.meta),e.meta=null)})),this._addTasks.clear()}_clippingAreaChanged(){const e=this.view.renderSpatialReference,t=this.i3slayer.spatialReference,i=N.create();this._renderClippingArea=Ee.toBoundingRect(this.view.clippingArea,i,e)?i:null;const s=N.create();this._layerClippingArea=Ee.toBoundingRect(this.view.clippingArea,s,t)?s:null,this._filterChange(),this._controller&&this._controller.updateClippingArea(this.view.clippingArea),this._isIntegratedMesh&&this._modificationsChanged()}get hasGeometryFilter(){return!1}_geometryFilterChange(){const e=this.hasGeometryFilter;this._controller.geometryFilterChanged(e),this._applyFilters(e)}_filterChange(){this._applyFilters(this.hasGeometryFilter)}_applyFilters(e){this._filters=this.getFilters(),e?this._controller&&this._controller.requestUpdate():this._nodeId2Meta.forEach((e=>{null!=e&&this._applyFiltersToNode(e)&&(this._addOrUpdateEdgeRendering(e),this._visibleGeometryChanged(e,qe.UPDATE))}))}getFilters(){const e=[],t=this._renderClippingArea;return null!=t&&e.push(((e,i)=>this._boundingRectFilter(e,i,t))),e}addSqlFilter(e,t,i){if(null!=t){const s=t.fieldNames;e.push(((e,r)=>this._sqlFilter(e,r,t,s,i)))}}_sqlFilter(e,t,i,s,r){const a={},o=this._createLayerGraphic(a),n=this.i3slayer.objectIdField,l=t.featureIds,d=t.attributeInfo?.attributeData;s.every((e=>e===n||null!=d?.[e]))&&ge.filterInPlace(e,l,(e=>{a[n]=l[e];for(const i of s)i!==n&&(a[i]=d?ge.getCachedAttributeValue(d[i],e):null);try{return i.testFeature(o)}catch(t){return r(t),!1}}))}_boundingRectNodeTest(e,t){return T.projectBoundingSphere(e.node.serviceMbsInIndexSR,this._controller.crsIndex,Ye,this.view.renderSpatialReference),ge.intersectBoundingRectWithMbs(t,Ye)}_boundingRectFeatureTest(e,t,i){return this._collection.getComponentAabb(e.objectHandle,t,We),V.toRect(We,ze),N.intersects(i,ze)}_boundingRectFilter(e,t,i){const s=this._collection,r=this._boundingRectNodeTest(t,i);if(r===ge.MbsIntersectResult.INSIDE)return;if(r===ge.MbsIntersectResult.OUTSIDE)return void(e.length=0);const a=s.getComponentCount(t.objectHandle);if(a.invisible+a.visible!==t.featureIds.length)return;const o=this._transformClippingArea(Ke,i,t.objectHandle);ge.filterInPlace(e,t.featureIds,(e=>this._boundingRectFeatureTest(t,e,o)))}_transformClippingArea(e,t,i){const s=this._collection.getObjectTransform(i),r=s.position,a=s.rotationScale;return e[0]=(t[0]-r[0])/a[0],e[1]=(t[1]-r[1])/a[4],e[2]=(t[2]-r[0])/a[0],e[3]=(t[3]-r[1])/a[4],e}async _addOrUpdateEdgeRendering(e,t=!0){const i=e.objectHandle,{hasEdges:s,perFeatureEdgeMaterials:r}=this._getFilteredEdgeMaterials(e);s&&!this._edgeView&&(this._edgeView=await this._stage.renderer.loadEdgeView());const a=this._edgeView;if(!a)return null;const o=a.hasObject(i);if(s){if(o){if(this.nodeCrossfadingEnabled){at(r,this.getNodeOpacity(e))}return a.updateAllComponentMaterials(i,r,this.slicePlaneEnabled,t).catch((e=>Be(e,this.i3slayer.title))),a.updateObjectVisibility(i,!0).catch((e=>Be(e,this.i3slayer.title))),a.updateAllVerticalOffsets(i,e.elevationOffsets).catch((e=>Be(e,this.i3slayer.title))),a}const s=await this._collection.addEdges(i,a,r,this.slicePlaneEnabled,e.elevationOffsets);return e.edgeMemoryUsage=s,e.node.memory+=s,a}return o&&(e.node.memory-=e.edgeMemoryUsage,e.edgeMemoryUsage=0,a.removeObject(i)),null}_applyFiltersToNode(e){return!!this._applyFiltersToNodeComponents(e)&&(null!=this._labeler&&this._labeler.applyFilterChange(e),!0)}_applyFiltersToNodeComponents(e){const t=this._collection,i=t.getComponentCount(e.objectHandle),s=null!=e.filteredIds,r=0===i.invisible;if(t.setAllComponentVisibilities(e.objectHandle,"all"),0===this._filters.length)return e.filteredIds=null,!r;if(this._updateCachedFilteredIds(e),s&&e.filteredIds===e.featureIds)return!r;const a=this._computeFilteredComponentIndices(e);return t.setAllComponentVisibilities(e.objectHandle,a),!0}_updateCachedFilteredIds(e){null!=e.filteredIds&&e.appliedFilters===this._filters||(e.filteredIds=this._computeFilteredIds(e),e.appliedFilters=this._filters)}_computeFilteredIds(e){const t=e.featureIds.slice();for(const i of this._filters)if(i(t,e),0===t.length)break;return t.length===e.featureIds.length?e.featureIds:t}_computeFilteredComponentIndices(e){const t=new Array,i=e.filteredIds;return null!=i&&e.featureIds.forEach(((e,s)=>{i[t.length]===e&&t.push(s)})),t}_removeAllNodeDataFromStage(e=this.elevationOffset){this._nodeId2Meta.forEach(((t,i)=>this._removeNodeStageData(i,e))),this._nodeId2MetaReloading.forEach(((t,i)=>this._removeNodeStageData(i,e,this._nodeId2MetaReloading))),this._elevationTask=h.destroyMaybe(this._elevationTask)}removeNode(e){const t=this.elevationOffset;this._removeNodeStageData(e,t),this._removeNodeStageData(e,t,this._nodeId2MetaReloading),null!=this._elevationTask&&this._elevationTask.remove(e)}_removeNodeStageData(e,t,i=this._nodeId2Meta){i.has(e)&&this._controller.updateLoadStatus(e,!1);const s=i.get(e);null!=s?(this._collection.setObjectVisibility(s.objectHandle,!1),null!=this._edgeView&&this._edgeView.hasObject(s.objectHandle)&&this._edgeView.updateObjectVisibility(s.objectHandle,!1).catch((e=>Be(e,this.i3slayer.title))),this._visibleGeometryChanged(s,qe.REMOVE),null!=this._labeler&&this._labeler.removeNodeMeta(s),i.delete(e),this._highlights.objectDeleted(s),i===this._nodeId2Meta?(this._cacheGPUData(s,t),this.nodeCrossfadingEnabled&&this._crossfadeHelper.stopNodeFading(s)):this._deleteComponentObject(s),null!=this._treeDebugger&&this._treeDebugger.update()):i.delete(e)}_deleteComponentObject(e){if(null!=this._edgeView&&this._edgeView.removeObject(e.objectHandle),this._memEstimateGeometryRemoved(e.objectHandle),this._collection.destroyObject(e.objectHandle),e.textures)for(const t of e.textures)this._memEstimateTextureRemoved(t),this._stage.remove(t)}updateNodeState(e,t){const i=this._nodeId2Meta.get(e);null!=i&&this._collection.updateMaterial(i.objectHandle,(e=>e.polygonOffsetEnabled=t===ce.NodeState.Hole))}updateNodeIndex(e,t){if(this._nodeId2Meta.has(e)){const i=this._nodeId2Meta.get(e);this._nodeId2Meta.delete(e),this._nodeId2Meta.set(t,i),this.notifyChange("elevationRange")}const i=this._nodeId2MetaReloading.get(e);i&&(this._nodeId2MetaReloading.delete(e),this._nodeId2MetaReloading.set(t,i))}_invalidateAllSymbols(){this._rendererVersion=ge.addWraparound(this._rendererVersion,1),this._controller&&this._controller.requestUpdate()}_getInvalidRendererVersion(){return ge.addWraparound(this._rendererVersion,-1)}async _rendererChange(e){if(this._currentRenderer=e,this.notifyChange("rendererTextureUsage"),this._rendererVersion=ge.addWraparound(this._rendererVersion,1),this._rendererFields=null,this._colorVariable=null,this._opacityVariable=null,this._invalidateAllSymbols(),e&&(this._rendererFields=await e.getRequiredFields(this.i3slayer.fieldsIndex)),this._updateSymbologyFields(),!this._arcade&&e&&"arcadeRequired"in e&&e.arcadeRequired&&(this._arcade=await z.loadArcade()),e&&"visualVariables"in e&&e.visualVariables)for(const t of e.visualVariables)"color"===t.type?this._colorVariable=t:"opacity"===t.type?this._opacityVariable=t:Pe().warn(`Unsupported visual variable type for 3D Object Scene Services: ${t.type}`);if(e)for(const t of e.getSymbols())"mesh-3d"!==t.type&&Pe().error(`Symbols of type '${t.type}' are not supported for 3D Object Scene Services.`);this._controller&&this._controller.requestUpdate()}_getCachedEdgeMaterials(e){return this._hasComponentData&&e.cachedRendererVersion!==this._rendererVersion&&this._updateCachedRendererData(e),e.cachedEdgeMaterials}_getComponentParameters(e){this._hasComponentData&&e.cachedRendererVersion!==this._rendererVersion&&this._updateCachedRendererData(e);const t=e.cachedSymbology;return(i,s)=>{const r=5*i;x.set(s.externalColor,t[r]/255,t[r+1]/255,t[r+2]/255,t[r+3]/255);const a=this._stage.renderView.olidRenderHelper;if(a){const t=e.featureIds[i],r=K.isBasemapLayer(this.view.map,this.layerUid);a.setUidToObjectAndLayerId(t,t,this.layerId,this.layerUid+"_"+this.sublayerId,this.layerPopupEnabledAndHasTemplate&&!r,e.node.resources.attributes,i,this.sublayerId),s.objectAndLayerIdColor=this._stage.renderView.getObjectAndLayerIdColor({graphicUid:t,layerUid:this.layerUid+"_"+this.sublayerId})}s.externalColorMixMode=t[r+4]&(1<<Ue.CastShadows)-1,s.castShadows=!!(t[r+4]&1<<Ue.CastShadows),s.pickable=!!(t[r+4]&1<<Ue.Pickable),s.elevationOffset=e.elevationOffsets?.[i]??0}}_getSymbolInfo(e,t){const i=e?.getSymbol(t,{arcade:this._arcade});if(!(i instanceof Q))return null;const s=i.id;if(this._symbolInfos.has(s))return this._symbolInfos.get(s);const r=ge.getSymbolInfo(i);return this._symbolInfos.set(s,r),r}_setSymbologyOverride(e,t){this._symbologyOverride!==e&&(this._symbologyOverride=e,this._symbologyOverrideFields=t,this._invalidateAllSymbols(),this._updateSymbologyFields())}_updateSymbologyFields(){this._symbologyFields=null!=this._symbologyOverrideFields&&this._symbologyOverrideFields.length>0?null!=this._rendererFields&&this._rendererFields.length>0?B.fixFields(this.i3slayer.fieldsIndex,[...this._rendererFields,...this._symbologyOverrideFields]):this._symbologyOverrideFields:this._rendererFields}_updateCachedRendererData(e){if(e.cachedRendererVersion=this._rendererVersion,!this._hasComponentData)return;const t=this._tmpAttributeOnlyGraphic,i={};t.attributes=i;const s=this._currentRenderer,r=e.attributeInfo?.attributeData,a=null!=e.featureIds?this.i3slayer.objectIdField:null,o=null!=r&&null!=this._symbologyFields&&this._symbologyFields.length>0;let n=null,l=null;if(o&&null!=this._symbologyFields){n=[],l=[];for(const e of this._symbologyFields){const t=r[e];t&&(n.push(e),l.push(t))}}e.cachedSymbology||(e.cachedSymbology=L.newUByteArray(5*e.featureIds.length));const d={color:Qe,castShadows:!0,pickable:!0,colorMixMode:Ie.ColorMixModeEnum.Multiply,edgeMaterial:null},h=this.fullOpacity,c=this.nodeCrossfadingEnabled?this.getNodeOpacity(e):h;let u=null,_=Fe.Transparency.OPAQUE,g=ge.transparentEdgeMaterial,p=0;for(let f=0;f<e.featureIds.length;f++){if(null!=a&&(i[a]=e.featureIds[f]),o&&n)for(let e=0;e<n.length;e++)i[n[e]]=ge.getCachedAttributeValue(l[e],f);const r=s?this._getSymbolInfo(s,t):null;let h=null,m=null;if(s&&"visualVariables"in s){if(this._colorVariable){const e=W.getColor(this._colorVariable,t,{color:Xe,arcade:this._arcade});e&&(h=Qe,h[0]=e.r/255,h[1]=e.g/255,h[2]=e.b/255,this._opacityVariable||null===e.a||(m=e.a))}this._opacityVariable&&(m=W.getOpacity(this._opacityVariable,t,{arcade:this._arcade}))}if(r?.material){const e=r.material;h=null==h||null==m?ie.overrideColor(h,m,e.color,e.alpha,He,Qe):ie.overrideColor(h,m,null,null,He,Qe)}if(null==h&&(h=Qe,h[0]=1,h[1]=1,h[2]=1,h[3]=1),d.pickable=!0,d.castShadows=!r||r.castShadows,d.colorMixMode=r?.material?r.material.colorMixMode:Ie.ColorMixModeEnum.Multiply,d.edgeMaterial=r?r.edgeMaterial:null,null!=this._symbologyOverride&&(d.color=h,this._symbologyOverride(t,d),h=d.color),null!=this._nodeColorOverride&&(this._nodeColorOverride(e.node,h),d.colorMixMode=Ie.ColorMixModeEnum.Replace),null!=d.edgeMaterial){const t=h[3]>=1&&(e.material.isOpaque||d.colorMixMode===Ie.ColorMixModeEnum.Replace)?Fe.Transparency.OPAQUE:Fe.Transparency.TRANSPARENT;d.edgeMaterial===u&&t===_||(g={...d.edgeMaterial,opacity:c,objectTransparency:t},u=d.edgeMaterial,_=t),e.cachedEdgeMaterials[f]=g}else e.cachedEdgeMaterials[f]=ge.transparentEdgeMaterial;e.cachedSymbology[p++]=Math.round(255*h[0]),e.cachedSymbology[p++]=Math.round(255*h[1]),e.cachedSymbology[p++]=Math.round(255*h[2]),e.cachedSymbology[p++]=Math.round(255*h[3]),e.cachedSymbology[p++]=d.colorMixMode|+d.castShadows<<Ue.CastShadows|+d.pickable<<Ue.Pickable}}_getFilteredEdgeMaterials(e){const t=this._getCachedEdgeMaterials(e);this.nodeCrossfadingEnabled||at(t,this.fullOpacity);const i=e.filteredIds;if(null==i){return{hasEdges:t.some((e=>e!==ge.transparentEdgeMaterial)),perFeatureEdgeMaterials:t}}let s=0,r=!1;const a=t.map(((t,a)=>e.featureIds[a]!==i[s]?ge.transparentEdgeMaterial:(r=r||t!==ge.transparentEdgeMaterial,s++,t)));return{hasEdges:r,perFeatureEdgeMaterials:a}}_updateComponentData(e){if(!this._hasComponentData)return;const t=e.objectHandle,i=this._getComponentParameters(e);this._collection.setComponentData(t,i),this._stage.renderView.requestRender()}_reloadAll(e=this.elevationOffset){this._removeAllNodeDataFromStage(e),null!=this._controller&&this._controller.restartNodeLoading()}_opacityChange(e){this.nodeCrossfadingEnabled&&this._crossfadeHelper.stopAllNodeFading(),this._nodeId2Meta.forEach((t=>{null!=t&&(this._collection.updateMaterial(t.objectHandle,(t=>t.objectOpacity=e)),at(t.cachedEdgeMaterials,e),this._updateEdgeRendering(t))}))}_updateMaterial(e){this._collection.updateMaterial(e.objectHandle,(e=>{e.commonMaterialParameters.hasSlicePlane=this.slicePlaneEnabled,e.usePBR=this._usePBR,this._updateMaterialOverlay(e)}))}_updateMaterialOverlay(e){}_updateEngineObject(e){this._updateComponentData(e),this._applyFiltersToNode(e),this._addOrUpdateEdgeRendering(e),this._visibleGeometryChanged(e,qe.UPDATE)}_slicePlaneEnabledChange(e){this._intersectionHandler&&(this._intersectionHandler.slicePlaneEnabled=e),null!=this._labeler&&(this._labeler.slicePlaneEnabled=e),this._nodeId2Meta.forEach((t=>{null!=t&&(this._collection.updateMaterial(t.objectHandle,(t=>t.commonMaterialParameters.hasSlicePlane=e)),this._updateEdgeRendering(t,!1))}))}_updatePBR(e){this._nodeId2Meta.forEach((t=>{null!=t&&this._collection.updateMaterial(t.objectHandle,(t=>t.usePBR=e))})),this._hasLoadedPBRTextures=!0}get _usePBR(){return this._shadeNormals&&this.view.qualitySettings.physicallyBasedRenderingEnabled}_updateEdgeRendering(e,t=!0){null!=this._edgeView&&this._edgeView.hasObject(e.objectHandle)&&this._addOrUpdateEdgeRendering(e,t)}_forAllNodes(e){this._nodeId2Meta.forEach(e)}_ignoreClientNodeOverriddenFeatures(e){return this.i3sOverrides.hasGeometryChanges?(t,i,s)=>s.node.index>=0&&this.i3sOverrides.featureHasGeometryChanges(t)?ee.ForAllFeaturesReturnType.CONTINUE:e(t,i,s):e}_forAllFeatures(e,t,i){for(const s of this._nodeId2Meta.values()){if(null==s)continue;if(null!=t){switch(t(s)){case ee.ForAllFeaturesReturnType.EXIT:return;case ee.ForAllFeaturesReturnType.SKIP:continue}}let r=ee.ForAllFeaturesReturnType.CONTINUE;switch(i){case ee.ForAllFeaturesMode.ALL:r=this._forAllFeaturesOfNode(s,e);break;case ee.ForAllFeaturesMode.VISIBLE_ONLY:r=this._forAllVisibleFeaturesOfNode(s,e);break;case ee.ForAllFeaturesMode.QUERYABLE:r=this._forAllQueryableFeaturesOfNode(s,e)}if(r===ee.ForAllFeaturesReturnType.EXIT)return}}_forAllFeaturesOfNode(e,t){let i=ee.ForAllFeaturesReturnType.CONTINUE;const s=e.featureIds;for(let r=0;r<s.length;r++)if(i=t(s[r],r,e),i===ee.ForAllFeaturesReturnType.EXIT)return i;return i}_forAllVisibleFeaturesOfNode(e,t){let i=ee.ForAllFeaturesReturnType.CONTINUE;const s=e.featureIds;return this._collection.forEachVisibleComponent(e.objectHandle,(r=>(i=t(s[r],r,e),i===ee.ForAllFeaturesReturnType.CONTINUE))),i}_forAllQueryableFeaturesOfNode(e,t){const i=this._ignoreClientNodeOverriddenFeatures(t);if(null==this._renderClippingArea)return this._forAllFeaturesOfNode(e,i);const s=this._boundingRectNodeTest(e,this._renderClippingArea);if(s===ge.MbsIntersectResult.OUTSIDE)return ee.ForAllFeaturesReturnType.CONTINUE;if(s===ge.MbsIntersectResult.INSIDE)return this._forAllFeaturesOfNode(e,i);const r=ee.ForAllFeaturesReturnType.CONTINUE,a=e.featureIds,o=e.objectHandle,n=ge.getClipRect(this._renderClippingArea,this._collection.getObjectTransform(o));for(let l=0;l<a.length;l++){if(!this._boundingRectFeatureTest(e,l,n))continue;const t=i(a[l],l,e);if(t===ee.ForAllFeaturesReturnType.EXIT)return t}return r}_createAttributes(e,t){const i={};null!=t.featureIds&&(i[this._getObjectIdField()]=t.featureIds[e]);const s=t.attributeInfo?.attributeData;if(null!=s)for(const r of Object.keys(s))i[r]=ge.getCachedAttributeValue(s[r],e);return i}_createGraphic(e,t){return this._createLayerGraphic(this._createAttributes(e,t))}highlight(e,t){if(a.isQuery(e))return be.emptyHighlightHandle;const i=be.normalizeHighlightTargetExceptQuery(e);if(0===i.length)return be.emptyHighlightHandle;if(t??=Ve.defaultHighlightName,i[0]instanceof r){const e=i,s=this.i3slayer.fieldsIndex,r=this._getObjectIdField(),a=e.map((e=>ye.attributeLookup(s,e.attributes,r))),{set:o,handle:n}=this._highlights.acquireSet(t);return this._highlights.setFeatureIds(o,a,t),n}if("number"==typeof i[0]){const e=i,{set:s,handle:r}=this._highlights.acquireSet(t);return this._highlights.setFeatureIds(s,e,t),r}return be.emptyHighlightHandle}resetHighlights(){h.destroyMaybe(this._highlights),this._highlights=new ae({collection:this._collection,forAllFeatures:e=>this._forAllFeatures(e,null,ee.ForAllFeaturesMode.ALL),forAllFeaturesOfNode:(e,t)=>this._forAllFeaturesOfNode(e,t)})}_visibleGeometryChanged(e,t){if(!this._elevationProvider)return;const i=this.getNodeComponentObb(e.node);i&&this._elevationProvider.objectChanged(i),null==this._visibleGeometryChangedSchedulerHandle&&(this._visibleGeometryChangedSchedulerHandle=g.schedule((()=>{this.emit("visible-geometry-changed"),this._visibleGeometryChangedSchedulerHandle=null}))),this._updateSnappingSources(e,t)}get performanceInfo(){return new J.I3SMeshViewPerformanceInfo(this.usedMemory,this._nodeId2Meta.size,Math.round(this._gpuMemoryEstimate/1048576),Math.round(this._geoMemoryEstimate/1048576),Math.round(this._texMemoryEstimate/1048576),Math.round(this.unloadedMemory/1048576),this._idbCacheEnabled?Math.round(100*this._idbCache.getHitRate()):0)}get test(){}getNodeOpacityByIndex(e){const t=this._nodeId2Meta.get(e);return this.getNodeOpacity(t)}getNodeOpacity(e){return null!=e?this._collection.getMaterial(e.objectHandle).objectOpacity:0}isNodeFullyFadedIn(e){return this._crossfadeHelper.isNodeFullyFadedIn(e)}getNodeCrossfadeMetaData(e){return this._nodeId2Meta.get(e)}markNodeToRemove(e){this._controller&&this._controller.markNodeToRemove(e)}removeMarkedNodes(){this._controller&&this._controller.removeMarkedNodes()}foreachCrossfadeNode(e){this._nodeId2Meta.forEach(e)}fadeNode(e,t,i){if(!this.nodeCrossfadingEnabled)return;const s=this._nodeId2Meta.get(e);null!=s&&this._crossfadeHelper.fadeNode(e,s,t,i)}setNodeOpacityByIndex(e,t){const i=this._nodeId2Meta.get(e);null!=i&&this._setNodeOpacity(i,t)}_setNodeOpacity(e,t){this._collection.updateMaterial(e.objectHandle,(e=>e.objectOpacity=t)),this._setNodeEdgeOpacity(e,t)}_setNodeEdgeOpacity(e,t){if(null==this._edgeView||!e.cachedEdgeMaterials)return;at(e.cachedEdgeMaterials,t);const i=e.objectHandle;this._edgeView.hasObject(i)&&this._edgeView.updateAllComponentOpacities(i,t).catch((e=>Be(e,this.i3slayer.title)))}get hasModifications(){return this._isIntegratedMesh&&null!=this._layerClippingArea||this._modifications&&this._modifications.length>0}updateNodeModificationStatus(e){const t=e.length;if(!this.hasModifications||t<=0||!0!==this._i3sWasmLoaded)return;const i=this.uid,s=st(e);if(s){const t={context:i,buffer:s.buffer};te.filterObbsForModificationsSync(t);const r=new Float64Array(s.buffer);e.forAll(((e,t)=>{const i=r[t],s=te.interpretObbModificationResults(i);e.imModificationImpact=s,s!==ce.NodeIMModificationImpact.Unmodified&&this._controller.invalidateGeometryVisibility(e.index)}))}}notifyUpdate(){this.notifyChange("updating")}notifyLODUpdate(){this._controller.notifyLODUpdate()}isUpdating(){return!(!this._controller||!this._controller.updating)||!!this._visibleGeometryChangedSchedulerHandle||null!=this._labeler&&this._labeler.updating||this._crossfadeHelper?.updating||this._i3sWasmLoaded instanceof Promise||this._asyncModuleLoading>0||null!=this._elevationTask&&this._elevationTask.running}trackSnappingSources(e){const t={events:e,fetchEdgeLocations:async(e,t,i)=>{const s=this._nodeId2Meta.get(e);if(null==s)throw new Error("invalid-node");const{origin:r,buffer:a}=await this._collection.extractEdgeInformation(s.objectHandle,t,i);return this._snappingLocationsApplyElevation(s,a,r),{type:"components",objectIds:s.featureIds,locations:a,origin:r}},remove:()=>o.removeUnordered(this._snappingSourcesTrackers,t)};return this._snappingSourcesTrackers.push(t),this._nodeId2Meta.forEach(((t,i)=>{if(null==t)return;const s=this._controller.getRenderMbs(t.node);s&&e.add(i,s)})),t}_snappingLocationsApplyElevation(e,t,i){if(!e.elevationOffsets||this.elevationInfo.mode===ee.ElevationMode.Absolute)return;const s=t.position0,r=t.position1,a=t.componentIndex,o=E.create(),n=E.create(),l=(e,t)=>{C.add(e,e,i),this.view.renderCoordsHelper.worldUpAtPosition(e,n),C.add(e,e,C.scale(n,n,t)),C.subtract(e,e,i)};for(let d=0;d<s.count;d++){const t=e.elevationOffsets[a.get(d)];s.getVec(d,o),l(o,t),s.setVec(d,o),r.getVec(d,o),l(o,t),r.setVec(d,o)}}_updateSnappingSources(e,t){const{index:i}=e.node,s=this._controller.getRenderMbs(e.node);if(null!=s)for(const r of this._snappingSourcesTrackers)t!==qe.REMOVE&&t!==qe.UPDATE||r.events.remove(i),t!==qe.ADD&&t!==qe.UPDATE||r.events.add(i,s)}};return i.__decorate([f.property()],s.prototype,"_hasLoadedPBRTextures",void 0),i.__decorate([f.property()],s.prototype,"_asyncModuleLoading",void 0),i.__decorate([f.property()],s.prototype,"_visibleGeometryChangedSchedulerHandle",void 0),i.__decorate([f.property()],s.prototype,"view",void 0),i.__decorate([f.property()],s.prototype,"i3slayer",void 0),i.__decorate([f.property()],s.prototype,"_controller",void 0),i.__decorate([f.property()],s.prototype,"_labeler",void 0),i.__decorate([f.property()],s.prototype,"updating",void 0),i.__decorate([f.property()],s.prototype,"suspended",void 0),i.__decorate([f.property()],s.prototype,"contentVisible",null),i.__decorate([f.property({readOnly:!0})],s.prototype,"legendEnabled",null),i.__decorate([f.property()],s.prototype,"holeFilling",void 0),i.__decorate([f.property(Oe.updatingProgress)],s.prototype,"updatingProgress",void 0),i.__decorate([f.property()],s.prototype,"updatingProgressValue",null),i.__decorate([f.property()],s.prototype,"hasTexturesOrVertexColors",null),i.__decorate([f.property()],s.prototype,"rendererTextureUsage",null),i.__decorate([f.property()],s.prototype,"elevationOffset",null),i.__decorate([f.property()],s.prototype,"elevationInfo",null),i.__decorate([f.property({type:Boolean})],s.prototype,"slicePlaneEnabled",void 0),i.__decorate([f.property()],s.prototype,"supportedTextureEncodings",null),i.__decorate([f.property()],s.prototype,"uncompressedTextureDownsamplingEnabled",null),i.__decorate([f.property({type:[q]})],s.prototype,"_modifications",void 0),i.__decorate([f.property({readOnly:!0})],s.prototype,"clientGeometry",null),i.__decorate([f.property()],s.prototype,"elevationRange",null),i.__decorate([f.property()],s.prototype,"fullExtent",null),i.__decorate([f.property()],s.prototype,"_elevationTask",void 0),i.__decorate([f.property({readOnly:!0})],s.prototype,"_usePBR",null),s=i.__decorate([m.subclass(Ne)],s),s};function Be(e,t){u.isAbortError(e)||Pe().warn("Error while processing edges. Edges on this layer might not display correctly",t,e)}var qe;!function(e){e[e.ADD=0]="ADD",e[e.REMOVE=1]="REMOVE",e[e.UPDATE=2]="UPDATE"}(qe||(qe={}));const We=V.create(),ze=N.create(),Ke=N.create(),$e=new xe.Obb,Qe=[0,0,0,0],Xe=new s([0,0,0,0]),Ye=U.fromValues(0,0,0,0);function Je(e){if(null==e)return!1;const t=e.metallicRoughness;return t&&t.baseColorTextureId>=0||t&&t.metallicRoughnessTextureId>=0||e.normalTextureId>=0||e.emissiveTextureId>=0||e.occlusionTextureId>=0}function Ze(e){return"geometryData"in e}function et(e){return null!=e&&p.isArrayBuffer(e.data)}function tt(e,t){let i=1024+e.interleavedVertexData.byteLength+(e.indices?e.indices.byteLength:0)+e.positionData.data.byteLength+e.positionData.indices.byteLength;if(null!=t)for(const s of t)null!=s&&p.isArrayBuffer(s.data)&&(i+=s.data.byteLength);return i}function it(e,t){return t.byteSize>Ge?(Pe().warn(`Node is too big to store in IndexedDB cache: ${e.id} (${t.byteSize} bytes)`),!1):t.byteSize>0}function st(e){if(0===e.length)return;const t=10*e.length,i=new Float64Array(t);let s=0;return e.forAll((e=>{let t=e.serviceObbInIndexSR;null==t&&(t=$e,t.center=U.getCenter(e.serviceMbsInIndexSR),t.halfSize=[e.serviceMbsInIndexSR[3],e.serviceMbsInIndexSR[3],e.serviceMbsInIndexSR[3]]);const r=t.data;i[s++]=r[0],i[s++]=r[1],i[s++]=r[2],i[s++]=r[3],i[s++]=r[4],i[s++]=r[5],i[s++]=r[6],i[s++]=r[7],i[s++]=r[8],i[s++]=r[9]})),i}class rt{constructor(e,t,i){this.attributeInfo=e,this.meta=t,this.promise=i,this.allowMemCache=!0}}function at(e,t){e.forEach((e=>e.opacity=t))}class ot{constructor(e,t){this.mode=e,this.offset=t}}const nt=E.create(),lt=V.create(),dt="elevation-change",ht="",ct="@null",ut="@ECEF",_t=[[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]],gt=new Ce.ElevationRange;function pt(e,t,i){let s=e.elevationRangeMin,r=e.elevationRangeMax;const a=i;if(a>0){t.getCorners(_t);for(const e of _t){const t=C.len(e)-a;s=Math.min(s,t),r=Math.max(r,t)}}else{t.getCorners(_t);for(const e of _t){const t=e[2];s=Math.min(s,t),r=Math.max(r,t)}}e.expandElevationRangeValues(s,r)}function ft(e,t,i){const s=U.getCenter(t),r=i>0?C.len(s)-i:s[2],a=U.getRadius(t);e.expandElevationRangeValues(r-a,r+a)}t.I3SMeshView3D=ke,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
