/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../symbols","../../../core/Accessor","../../../core/arrayUtils","../../../core/has","../../../core/lang","../../../core/mathUtils","../../../core/maybe","../../../core/reactiveUtils","../../../core/uid","../../../core/accessorSupport/decorators/property","../../../core/Logger","../../../core/accessorSupport/decorators/subclass","../../../core/accessorSupport/diffUtils","../../../geometry/projection/projectBuffer","../../../geometry/support/aaBoundingBox","../../../geometry/support/DoubleArray","../../../layers/graphics/dehydratedPoint","./graphics/Graphics3DCore","./graphics/Graphics3DScaleVisibility","./i3s/I3SGeometryUtil","../support/LimitGraphicsMap","../webgl-engine/lib/UpdatePolicy","../../../symbols/PointSymbol3D"],(function(e,t,r,i,o,a,s,n,c,p,l,d,h,u,y,g,f,b,_,m,I,M,v,E){"use strict";class D{constructor(e,t){this.meta=e,this.index=t}}class G{constructor(e,t){this.graphic=e,this.geometry=t,this.components=[],this.overridesDirty=!1}}let w=class extends r{get updating(){return this._graphicsCore?.updating??!1}constructor(e){super(e),this.loadedGraphics=new M.LimitGraphicsMap(5e4),this.slicePlaneEnabled=!1,this._renderingInfo={symbol:new E},this._featuresMap=new Map}initialize(){const e=this.view.basemapTerrain;this._graphicsCore=new _.Graphics3DCore({owner:this,layer:this.layer,preferredUpdatePolicy:v.UpdatePolicy.ASYNC,elevationFeatureExpressionEnabled:!1,graphicSymbolSupported:!1,getRenderingInfoWithoutRenderer:!0,hasZ:!0,hasM:!1,componentFactories:{deconflictor:e=>this.view.deconflictor.addGraphicsOwner(e),labeler:(e,t)=>this.view.labeler.addGraphicsOwner(e,t,{emptySymbolLabelSupported:!0,elevationInfoOverride:{mode:"absolute-height",offset:0},disablePlacement:{logEntityDescription:"3D Object Scene Layer features"}}),scaleVisibility:(t,r)=>new m.Graphics3DScaleVisibility({graphicsCoreOwner:this,layer:this.layer,queryGraphicUIDsInExtent:r,graphicsCore:t,basemapTerrain:e,layerScaleEnabled:!1})}}),this._graphicsCore.initializePromise.then((()=>this._graphicsCore.startCreateGraphics())).catch((()=>{})),this.addHandles(c.watch((()=>this.layer.labelingInfo),((e,t)=>{u.diff(e,t)&&this._graphicsCore.updateLabelingInfo()})))}destroy(){this._graphicsCore=n.destroyMaybe(this._graphicsCore),this.loadedGraphics=n.destroyMaybe(this.loadedGraphics),this.view=null}addNodeMeta(e,t){let r=0;const i=e.filteredIds,o=this.view.spatialReference,a=[];for(let s=0;s<e.featureIds.length;s++){const n=e.featureIds[s];let c=null==i;if(i&&r<i.length&&n===i[r]&&(c=!0,r++),!this._enabledForFeatureInNode(e,s))continue;const l=this._featuresMap.get(n);if(l){l.components.push(new D(e,s)),this._updateLabelPosition(n);continue}const d=t(s,e),h=b.makeDehydratedPoint(0,0,0,o),u={objectId:n,uid:p.generateUID(),attributes:d,visible:c,geometry:h},y=new G(u,h);y.components.push(new D(e,s)),this._featuresMap.set(n,y),this._updateLabelGeometry(n),a.push(u)}this.loadedGraphics.addMany(a)}updateLabelPositions(e){const t=this.view.renderCoordsHelper;this._forEachGraphic(e,((r,i,o)=>{const a=this._graphicsCore.getGraphics3DGraphicById(i.uid);null!=a&&this._updateLabelGeometry(e.featureIds[r])&&a.alignWithAbsoluteElevation(o.z??0,t,!1)}))}setNodeMetaAttributes(e,t){const r=new Array;this._forEachGraphic(e,((i,o)=>{const s=t(i,e);a.equalsShallow(o.attributes,s)||(o.attributes=s,r.push(o.uid))})),this._graphicsCore.updateLabelingInfo(r)}applyFilterChange(e){this._forEachFeature(e,((t,r,i)=>{if(!this._enabledForFeatureInNode(e,t)){const i=e.featureIds[t];switch(this._removeFeature(r,e,t)){case F.REMOVED:this.loadedGraphics.removeManyByObjectId([i]);break;case F.MODIFIED:this._updateLabelPosition(i)}return}const o=r.graphic,a=o.visible;a!==i&&(o.visible=i,C.graphic=o,C.property="visible",C.oldValue=a,C.newValue=i,this._graphicsCore.graphicUpdateHandler(C))}))}removeNodeMeta(e){const t=[];this._forEachGraphic(e,(r=>{const i=e.featureIds[r],o=this._featuresMap.get(i);if(!o)return;switch(this._removeFeature(o,e,r)){case F.MODIFIED:this._updateLabelPosition(i);break;case F.REMOVED:t.push(i)}})),this.loadedGraphics.removeManyByObjectId(t)}_removeFeature(e,t,r){const o=e.components.length;return i.filterInPlace(e.components,(e=>!(e.meta===t&&e.index===r))),0===e.components.length?(this._featuresMap.delete(t.featureIds[r]),F.REMOVED):o!==e.components.length?F.MODIFIED:F.UNMODIFIED}getRenderingInfo(){return this._renderingInfo}notifyGraphicGeometryChanged(){}notifyGraphicVisibilityChanged(){}_updateLabelPosition(e){const t=this._featuresMap.get(e);t&&this._updateLabelGeometry(e)&&(this.loadedGraphics.removeManyByObjectId([e]),this.loadedGraphics.addMany([t.graphic]))}_updateLabelGeometry(e){const t=this._featuresMap.get(e);if(!t)return!1;const r=t.geometry,i=this.view.spatialReference,o=this.view.renderCoordsHelper,a=r.x,n=r.y,c=r.z??0,p=t.components.length,l=f.newDoubleArray(p*I.boundingBoxCornersPointsStride);let d=0;for(const{meta:s,index:h}of t.components)I.boundingBoxCornerPoints(h,this.collection,s.objectHandle,l,d),d+=I.boundingBoxCornersPointsStride;return y.projectBuffer(l,o.spatialReference,0,l,i,0),g.fromBuffer(l,O),r.x=(O[0]+O[3])/2,r.y=(O[1]+O[4])/2,r.z=O[5],!s.floatEqualUlp(r.x,a)||!s.floatEqualUlp(r.y,n)||!s.floatEqualUlp(r.z,c)}_forEachGraphic(e,t){this._forEachFeature(e,((r,{graphic:i,geometry:o},a)=>{this._enabledForFeatureInNode(e,r)&&t(r,i,o,a)}))}_forEachFeature(e,t){let r=0;for(let i=0;i<e.featureIds.length;i++){const o=this._featuresMap.get(e.featureIds[i]);let a=null==e.filteredIds;e.filteredIds&&e.filteredIds[r]===e.featureIds[i]&&(a=!0,r++),o&&t(i,o,a)}}_enabledForFeatureInNode(e,t){return e.node.index<0||!this.overrides?.featureHasGeometryChanges(e.featureIds[t])}get updatePolicy(){return this._graphicsCore.effectiveUpdatePolicy}get usedMemory(){return this._graphicsCore.usedMemory}get unloadedMemoryEstimate(){return this._graphicsCore.unprocessedMemoryEstimate}get test(){}};e.__decorate([l.property()],w.prototype,"view",void 0),e.__decorate([l.property()],w.prototype,"layer",void 0),e.__decorate([l.property()],w.prototype,"collection",void 0),e.__decorate([l.property()],w.prototype,"loadedGraphics",void 0),e.__decorate([l.property()],w.prototype,"overrides",void 0),e.__decorate([l.property()],w.prototype,"updating",null),e.__decorate([l.property()],w.prototype,"slicePlaneEnabled",void 0),e.__decorate([l.property()],w.prototype,"_graphicsCore",void 0),w=e.__decorate([h.subclass("esri.views.3d.layers.I3SMeshViewLabeler")],w);const C={graphic:null,property:null,oldValue:null,newValue:null};var F;!function(e){e[e.UNMODIFIED=0]="UNMODIFIED",e[e.MODIFIED=1]="MODIFIED",e[e.REMOVED=2]="REMOVED"}(F||(F={}));const O=g.create();return w}));
