/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../core/Error","../../../core/reactiveUtils","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/Logger","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../../layers/support/rasterFunctions/rasterProjectionHelper","./LayerView3D","./TiledLayerView3D","../terrain/RasterTile","../../layers/ImageryTileLayerView","../../layers/LayerView","../../layers/RefreshableLayerView","../../support/drapedUtils","../../webgl/capabilities"],(function(e,t,r,i,a,s,n,l,o,c,d,h,y,p,m,u,g){"use strict";let b=class extends(y(m(d.TiledLayerView3D(c.LayerView3D(p))))){constructor(){super(...arguments),this.type="imagery-tile-3d",this._isAlignedMapTile=!0}initialize(){this.layer.increaseRasterJobHandlerUsage(),null==this.fullExtent&&this.addResolvingPromise(Promise.reject(new t("layerview:spatial-reference-incompatible","The layer extent cannot be projected to the view's spatial reference",{layer:this.layer})));const e=r.whenOnce((()=>this.view?.basemapTerrain?.tilingSchemeLocked)).then((()=>{const e=this.view.basemapTerrain.tilingScheme,t=this.layer.tileInfo;this._isAlignedMapTile=["png","png24","png32","jpg","mixed"].includes(t.format)&&e.compatibleWith(t),this.tileInfo=this._isAlignedMapTile?t:e.toTileInfo(),this._updatingHandles.add((()=>[this.layer.renderer,this.layer.interpolation,this.layer.bandIds,this.layer.multidimensionalDefinition,this.layer.multidimensionalSubset,this.layer.rasterFunction,this.timeExtent]),(()=>this.refresh()))}));this.addResolvingPromise(e)}destroy(){this.layer.decreaseRasterJobHandlerUsage()}get _blankTile(){const e=document.createElement("canvas"),t=e.getContext("2d"),[r,i]=this.tileInfo.size;return e.width=r,e.height=i,t.clearRect(0,0,r,i),t.getImageData(0,0,r,i)}get imageFormatIsOpaque(){return"jpg"===this.layer.tileInfo.format}get hasMixedImageFormats(){return"mixed"===this.layer.tileInfo.format}get dataLevelRange(){const e=this.layer.tileInfo,t=this.tileInfo.lodAt(0)?.scale,r=this.layer.tileInfo.lodAt(e.lods.length-1)?.scale;return this.levelRangeFromScaleRange(t,r)}_getFullExtent(){return o.projectDatasetExtent(this.layer.serviceRasterInfo,this.view.basemapTerrain?.spatialReference??this.view.spatialReference)}async fetchTile(e,t){const r=this.tileInfo,i=this._canSymbolizeInWebGL(),a={tileInfo:r,requestRawData:i,signal:t.signal,timeExtent:this.timeExtent,requestAsImageElement:this._isAlignedMapTile,noClip:!1},{layer:s}=this,[n,l,o]=e,c=await s.fetchTile(n,l,o,a);if(c instanceof HTMLImageElement)return c;let d=c?.pixelBlock;if(null==d)return this._blankTile;if(!i&&(d=await s.applyRenderer(c),null==d))return this._blankTile;const y=new h.RasterTile([n,l,o],d,r.size[0],r.size[1]);return i?(y.symbolizerRenderer=s.symbolizer.rendererJSON,y.symbolizerParameters=s.symbolizer.generateWebGLParameters(this._getSymbolizerOptions(n)),y.transformGrid=c.transformGrid,y.bandIds=s.bandIds):(y.isRendereredSource=!0,y.bandIds=null),y.interpolation=s.interpolation,y}_getSymbolizerOptions(e){const t=this.tileInfo.lodAt(e).resolution;return{pixelBlock:null,isGCS:null!=this.view.basemapTerrain?.spatialReference?this.view.basemapTerrain.spatialReference.isGeographic:this.view.spatialReference.isGeographic,resolution:{x:t,y:t},bandIds:this.layer.bandIds}}ensureSymbolizerParameters(e){this._canSymbolizeInWebGL()&&JSON.stringify(e.symbolizerRenderer)!==JSON.stringify(this.layer.symbolizer.rendererJSON)&&(e.symbolizerParameters=this.layer.symbolizer.generateWebGLParameters(this._getSymbolizerOptions(e.lij[0])))}createFetchPopupFeaturesQueryGeometry(e,t){return u.createQueryGeometry(e,t,this.view)}refresh(){this.emit("data-changed")}async doRefresh(){this.suspended||this.emit("data-changed")}_canSymbolizeInWebGL(){const e=g.getWebGLCapabilities(),{symbolizer:t}=this.layer,r=t.lookup?.colormapLut?.indexedColormap,i=!!this.layer.rasterFunction?.hasClipFunction,a=r&&r.length>4*(e.maxTextureSize||4906);return t.canRenderInWebGL&&!a&&!i}};e.__decorate([i.property({readOnly:!0})],b.prototype,"_blankTile",null),e.__decorate([i.property({readOnly:!0})],b.prototype,"imageFormatIsOpaque",null),e.__decorate([i.property({readOnly:!0})],b.prototype,"hasMixedImageFormats",null),e.__decorate([i.property({readOnly:!0})],b.prototype,"dataLevelRange",null),b=e.__decorate([l.subclass("esri.views.3d.layers.ImageryTileLayerView3D")],b);return b}));
