/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../core/Error","../../../core/has","../../../core/Logger","../../../core/maybe","../../../core/reactiveUtils","../../../core/scheduling","../../../core/accessorSupport/decorators/property","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../../core/libs/gl-matrix-2/math/mat3","../../../core/libs/gl-matrix-2/factories/mat3f64","../../../core/libs/gl-matrix-2/math/mat4","../../../core/libs/gl-matrix-2/factories/mat4f64","../../../core/libs/gl-matrix-2/factories/quatf64","../../../chunks/vec32","../../../core/libs/gl-matrix-2/factories/vec3f64","../../../core/libs/gl-matrix-2/factories/vec4f64","../../../geometry/ellipsoidUtils","../../../geometry/projection/computeTranslationToOriginAndRotation","../../../geometry/projection/localLinearScaleFactors","../../../geometry/projection/projectVectorToVector","../../../geometry/support/buffer/BufferView","../../../layers/ILyr3DWasmPerSceneView","../../../support/elevationInfoUtils","../../ViewingMode","./IntegratedMesh3DTilesViewPerformanceInfo","./interfaces","./LayerView3D","./Lyr3DWasm","./i3s/LayerElevationProvider","./support/lyr3dTypeConversions","./support/Tiles3DIntersectionHandler","../support/ElevationRange","../support/orientedBoundingBox","../webgl-engine/collections/Component/ObjectParameters","../webgl-engine/collections/Component/SourceGeometry","../webgl-engine/collections/Component/Transform","../webgl-engine/collections/Component/Material/ComponentMaterial","../webgl-engine/core/material/RenderTexture","../webgl-engine/core/shaderLibrary/attributes/TextureCoordinateAttribute.glsl","../webgl-engine/core/shaderLibrary/util/AlphaCutoff","../webgl-engine/core/shaderLibrary/util/EllipsoidMode","../webgl-engine/lib/Attribute","../webgl-engine/lib/basicInterfaces","../webgl-engine/lib/Normals","../webgl-engine/lib/Texture","../webgl-engine/lib/VertexAttribute","../webgl-engine/materials/internal/bufferWriterUtils","../../layers/LayerView","../../support/layerViewUtils"],(function(e,t,r,i,s,a,o,n,l,c,d,u,h,m,p,g,y,f,b,w,_,v,T,x,C,M,V,P,L,D,O,E,I,U,A,F,S,R,H,B,j,k,N,G,W,z,$,J,Y,q,K){"use strict";var Q;!function(e){e[e.API=1]="API",e[e.VerboseAPI=2]="VerboseAPI",e[e.Error=3]="Error"}(Q||(Q={}));class X{constructor(){this.handle=0,this.isVisible=!1,this.components=[],this.texMemoryUsage=0,this.vboMemoryUsage=0,this.cpuMemoryUsage=0,this.textures=[]}totalMemory(){return this.texMemoryUsage+this.vboMemoryUsage+this.cpuMemoryUsage}}function Z(e){return Math.round(e/1048.576)/1e3}let ee=class extends(L.LayerView3D(q)){constructor(){super(...arguments),this.type="integrated-mesh-3dtiles",this._visibleGeometryChangedSchedulerHandle=null,this._wasmLayerId=-1,this.ignoresMemoryFactor=!1,this.drapeTargetType=P.DrapeTargetType.WithoutRasterImage,this._applySSAO=!r("disable-feature:im-ssao"),this._shadeNormals=!!r("enable-feature:im-shading"),this._lyrHandleToObjects=new Map,this._initialCullFace=new Map,this._suspendedHandle=null,this._dbgFlags=new Set}initialize(){if(this._dbgFlags.add(Q.Error),this._dbg(Q.VerboseAPI,"Tiles3DLayerView3D initialize() called"),!this._canProjectWithoutEngine())throw new t("layerview:spatial-reference-incompatible","The spatial reference of this scene layer is incompatible with the spatial reference of the view",{});const e=D.addLayerViewToWasm(this).then((e=>{this._intersectionHandler=new I.Tiles3DIntersectionHandler(this),this.view.sceneIntersectionHelper.addIntersectionHandler(this._intersectionHandler),this._updatingHandles.add((()=>this.slicePlaneEnabled),(e=>this._slicePlaneEnabledChange(e))),this._elevationProvider=new O.LayerElevationProvider({view:this.view,layerElevationSource:this,intersectionHandler:this._intersectionHandler}),this.view.elevationProvider.register("im",this._elevationProvider),this.view.basemapTerrain.overlayManager.registerDrapeTarget(this),this._wasmLayerId=e;const t=this.view.resourceController.memoryController.newCache(`t3d-${this.uid}`,(e=>this._onRemoveFromCache(e)));this._memCache=t,this.addHandles([a.watch((()=>this.layer.elevationInfo),(e=>this._elevationInfoChanged(e)))]),this._suspendedHandle=a.watch((()=>this.suspended),(e=>this._wasm?.setEnabled(this,!e)),a.initial)})).catch((e=>{if(D.removeLayerViewFromWasm(this),this._wasmLayerId=-1,e===x.invalidLayerView)throw new t("tiles3d:addLayer-failure","The 3d tiles layer description was invalid.",{});if(e===x.wasmFailedToInit)throw new t("tiles3d:addLayer-failure","The 3d tiles layer web assembly module failed to download.",{})}));this.addResolvingPromise(e)}destroy(){this._dbg(Q.VerboseAPI,"Tiles3DLayerView3D destroy() called"),D.removeLayerViewFromWasm(this),this._suspendedHandle&&(this._suspendedHandle.remove(),this._suspendedHandle=null),this._intersectionHandler&&(this.view.sceneIntersectionHelper.removeIntersectionHandler(this._intersectionHandler),this._intersectionHandler=null),this._elevationProvider&&(this._elevationProvider.objectsChanged(this._obbs),this.view.elevationProvider.unregister(this._elevationProvider),this._elevationProvider=null),this.view.basemapTerrain.overlayManager.unregisterDrapeTarget(this),this._lyrHandleToObjects.forEach((e=>this.freeObject(e))),this._lyrHandleToObjects.clear(),this._initialCullFace.clear(),this._memCache=s.destroyMaybe(this._memCache),this._updatingHandles=s.destroyMaybe(this._updatingHandles),this.emit("visible-geometry-changed"),this._visibleGeometryChangedSchedulerHandle&&(this._visibleGeometryChangedSchedulerHandle.remove(),this._visibleGeometryChangedSchedulerHandle=null)}_visibleGeometryChanged(){this._visibleGeometryChangedSchedulerHandle??=o.schedule((()=>{this.emit("visible-geometry-changed"),this._visibleGeometryChangedSchedulerHandle=null}))}_slicePlaneEnabledChange(e){this._intersectionHandler&&(this._intersectionHandler.slicePlaneEnabled=e),this.objects.forEach((t=>{const r=this._collection.getMaterial(t);r.commonMaterialParameters.hasSlicePlane=e,r.commonMaterialParameters.cullFace=e?W.CullFaceOptions.None:this._initialCullFace.get(t)}))}_elevationInfoChanged(e){this._wasm?.setLayerOffset(this,C.getElevationOffsetInMeters(e))}get _obbs(){return this.objects.map((e=>this._collection.getComponentObb(e)))}get _wasm(){return D.getLyr3DWasm(this.view)}get wasmLayerId(){return this._wasmLayerId}get usedMemory(){let e=0;return this._lyrHandleToObjects.forEach((t=>{t.isVisible&&(e+=t.totalMemory())})),e}get unloadedMemory(){return 0}get cachedMemory(){let e=0;return this._lyrHandleToObjects.forEach((t=>{t.isVisible||(e+=t.totalMemory())})),e}get visibleAtCurrentScale(){return K.isInEffectiveScaleRange(this.layer.effectiveScaleRange,this.view.scale)}get performanceInfo(){let e=0,t=0,r=0,i=0,s=0,a=0;return this._lyrHandleToObjects.forEach((o=>{o.isVisible?(e+=o.texMemoryUsage,t+=o.vboMemoryUsage,s++):(r+=o.texMemoryUsage,i+=o.vboMemoryUsage,a++)})),new V.IntegratedMesh3DTilesViewPerformanceInfo(this.usedMemory,s,a,Z(t),Z(e),Z(i),Z(r))}_canProjectWithoutEngine(){if(this.view.state.viewingMode===M.ViewingMode.Local){const e=this.view.renderSpatialReference?.isWebMercator?3857:this.view.renderSpatialReference?.wkid??-1;if(3857!==e&&32662!==e)return!1}return!0}get _stage(){return this.view._stage}get _collection(){return this._stage.renderView.componentObjectCollection}get elevationOffset(){return C.getElevationOffsetInMeters(this.layer.elevationInfo)}get elevationRange(){const e=this.fullExtent;return e?.zmin&&e?.zmax?new U.ElevationRange(e.zmin,e.zmax):null}getElevationRange(e){return null}get fullExtent(){return this.layer.fullExtent}get objects(){return Array.from(this._lyrHandleToObjects.values()).reduce(((e,t)=>e.concat(t.components)),new Array)}isUpdating(){const e=this._wasm;return!(this._wasmLayerId<0||null==e)&&e.isUpdating(this._wasmLayerId)}updatingFlagChanged(){this.notifyChange("updating")}async createRenderable(e){const t=e.meshData;if(null==t.data)throw new Error("meshData.data undefined");if(t.desc=JSON.parse(t.desc),null==t.desc)throw new Error("meshData.desc undefined");const r=y.fromArray(t.desc.origin),i=new Array,s=new Map,a=new X;a.handle=e.handle,this._lyrHandleToObjects.set(e.handle,a);const o=this.view.basemapTerrain.spatialReference;let n,l;if("global"===this.view.viewingMode){const e=m.create();w.computeTranslationToOriginAndRotation(b.SphericalECEFSpatialReferenceLike,r,e,o),n=d.fromMat4(u.create(),e),l=d.invert(u.create(),n)}else n=u.IDENTITY,l=u.IDENTITY;const c=m.create();h.translate(c,c,r);const T=h.getTranslation(y.create(),c);let C=null;const M=y.create();if(t.desc.obb){const e=t.desc.obb.quaternion;C=new A.Obb(t.desc.obb.center,t.desc.obb.halfSize,p.fromValues(e[0],e[1],e[2],e[3]))}for(let d=0;d<t.desc.prims.length;d++){const e=t.desc.prims[d];this._dbg(Q.VerboseAPI,JSON.stringify(e));if(null==E.primTypeConversion[e.ptype]||null==t.data){this._dbg(Q.VerboseAPI,"[Unsupported Feature] Unsupported primitive mode ("+e.ptype+"). Skipping primitive.");continue}const c=t.desc?.materials&&null!=e.materialId?t.desc.materials[e.materialId]:null,h=null!=c?c.lightingModel:x.Lyr3DLightingModel.Unlit,{positionView:m,positionAttr:p,normalsView:b,normalsAttr:w,colorAttr:V,texCoord0Attr:P,indicesView:L}=this.getBufferViews(e,t.data.buffer,n);if(null==p||null==m||null==L)continue;const D=new S.GeometryParameters(null!=V,null!=P?j.TextureCoordinateType.Default:j.TextureCoordinateType.None,null!=b,this._shadeNormals,this._applySSAO),O=p.data.length/p.size,I=(e,t)=>!e||e.data.length/e.size===O||(this._dbg(Q.Error,`${t} !== numPos. Skipping primitive.`),!1);if(!I(P,"numTexcoord")||!I(V,"numColors")||!I(w,"normals"))continue;const U=S.createVertexBufferLayout(D);if(null!=C?C=C.clone():(C=A.compute(p),g.add(M,C.center,r),C.center=M),n!==u.IDENTITY)for(let t=0;t<m.count;t++)m.getVec(t,M),g.transformMat3(M,M,n),m.setVec(t,M);const B=U.createBuffer(p.data.length),G=new Map([[J.VertexAttribute.POSITION,p]]);null!=P&&G.set(J.VertexAttribute.UV0,P),null!=V&&G.set(J.VertexAttribute.COLOR,V),null!=w&&G.set(J.VertexAttribute.NORMALCOMPRESSED,w),G.forEach(((e,t)=>{null!=e&&Y.writeDefaultAttribute(t,e,null,null,B,0)}));const z=new Uint32Array([0,L.typedBuffer.length]),$={vertices:{data:B.buffer,count:B.byteLength/U.stride,layoutParameters:D},positionData:{positions:m.typedBuffer,indices:L.typedBuffer},indices:L.typedBuffer,componentOffsets:z};a.cpuMemoryUsage+=m.count,a.cpuMemoryUsage+=L.count;const q=this.view.renderSpatialReference,K=y.create(),X=[1,1,1];_.localLinearScaleFactors(T,q,X,o)||this._dbg(Q.Error,"Unsupported coordinate system for IM overlay"),v.projectVectorToVector(T,q,K,o);const Z=this._collection.createObject(new F.ObjectParameters(f.fromValues(K[0],K[1],X[0],X[1]),new R.Transform(T,l),C,$));c&&this._collection.updateMaterial(Z,(e=>{e.baseColor=c.baseColorFactor,e.usePBR=h===x.Lyr3DLightingModel.Pbr,e.hasParametersFromSource=!1,e.baseColorTexture=this._getTexture(c.baseColorTex,t,s),e.usePBR&&(e.mrrFactors=[c.metallicFactor,c.roughnessFactor,0],e.emissiveFactor=c.emissiveFactor??[0,0,0],e.metallicRoughnessTexture=this._getTexture(c.metalTex,t,s),e.emissionTexture=this._getTexture(c.emissiveTex,t,s),e.occlusionTexture=this._getTexture(c.occlusionTex,t,s),e.normalTexture=this._getTexture(c.normalTex,t,s)),e.objectOpacity=0,e.alphaDiscardMode=W.AlphaDiscardMode.Mask;const r=[];e.baseColorTexture&&r.push(e.baseColorTexture.loadPromise),e.usePBR&&e.metallicRoughnessTexture&&r.push(e.metallicRoughnessTexture.loadPromise),e.usePBR&&e.emissionTexture&&r.push(e.emissionTexture.loadPromise),e.usePBR&&e.occlusionTexture&&r.push(e.occlusionTexture.loadPromise),e.usePBR&&e.normalTexture&&r.push(e.normalTexture.loadPromise);const o=Promise.all(r);i.push(o),o.then((()=>{e.alphaDiscardMode=E.alphaModeConversion[c.alphaMode],e.objectOpacity=1,a.texMemoryUsage+=e.baseColorTexture?.glTexture?.usedMemory||0,e.usePBR&&(a.texMemoryUsage+=e.metallicRoughnessTexture?.glTexture?.usedMemory||0,a.texMemoryUsage+=e.emissionTexture?.glTexture?.usedMemory||0,a.texMemoryUsage+=e.occlusionTexture?.glTexture?.usedMemory||0,a.texMemoryUsage+=e.normalTexture?.glTexture?.usedMemory||0)})),e.commonMaterialParameters.doubleSided=c.isDoubleSided,e.commonMaterialParameters.cullFace=c.faceCulling?E.faceCullingConversion[c.faceCulling]:W.CullFaceOptions.Back,this._initialCullFace.set(Z,e.commonMaterialParameters.cullFace),e.commonMaterialParameters.hasSlicePlane=this.slicePlaneEnabled,e.componentParameters.castShadows=H.ComponentParameterSummary.All,e.textureAlphaCutoff=c.alphaCutoff??k.alphaCutoff,e.alphaDiscardMode=E.alphaModeConversion[c.alphaMode],e.isIntegratedMesh=!0,e.polygonOffsetEnabled=!1,e.hasOccludees=!1,e.ellipsoidMode=N.getEllipsoidMode(this.view.spatialReference)})),a.components.push(Z),a.vboMemoryUsage+=this._collection.getObjectGPUMemoryUsage(Z)}if(await Promise.all(i),s.forEach((e=>{a.textures.push(e)})),!this._memCache)throw new Error("no memCache");return this._memCache.put(`${a.handle}`,a,a.totalMemory()),{memUsageBytes:a.totalMemory()}}freeRenderable(e){const t=this._lyrHandleToObjects.get(e);t&&(this.freeObject(t),this._lyrHandleToObjects.delete(e))}freeObject(e){this._memCache&&this._memCache.pop(`${e.handle}`),e.components.forEach((t=>{e.textures.forEach((e=>{this._stage.remove(e)})),this._collection.destroyObject(t),this._initialCullFace.delete(t)}))}setRenderableVisibility(e,t,r){if(this._memCache){for(let i=0;i<r;++i){const r=e[i],s=t[i];if(!s)continue;const a=this._lyrHandleToObjects.get(r);a&&(this._visibleGeometryChanged(),a.isVisible=s,a.components.forEach((e=>{this._collection.setObjectVisibility(e,s),this._elevationProvider.objectChanged(this._collection.getComponentObb(e))})),this._memCache.pop(`${r}`))}for(let i=0;i<r;++i){const r=e[i],s=t[i];if(s)continue;const a=this._lyrHandleToObjects.get(r);a&&(this._visibleGeometryChanged(),a.isVisible=s,a.components.forEach((e=>{this._collection.setObjectVisibility(e,s),this._elevationProvider.objectChanged(this._collection.getComponentObb(e))})),this._memCache.put(`${r}`,a,a.totalMemory()))}}}_getTexture(e,t,r){let i=null;if(e&&t.desc?.images&&t.data?.buffer){const s=t.desc.images[e?.imageId];if(i=r.get(s),!i&&s){const a=this._stage.renderView.renderingContext.parameters.maxMaxAnisotropy,o=!!s.mipCount||a>1,n=E.wrapModeConversion[e.wrapMode??x.Lyr3DUvWrapMode.None];let l=s.alpha?4:3;const c=new Uint8Array(t.data.buffer,s.data.byteOffset,s.data.byteCount);let d=null,u=null,h=null;switch(s.format){case x.Lyr3DImageFormat.Raw:s.pixelFormat===x.Lyr3DPixelFormat.R8?(d=c,l=1,u=""):s.pixelFormat===x.Lyr3DPixelFormat.Rgb8?(d=c,l=3,u=""):s.pixelFormat===x.Lyr3DPixelFormat.Rgba8&&(d=c,l=4,u="");break;case x.Lyr3DImageFormat.Dxt1:d=c,l=3,u=W.TextureEncodingMimeType.DDS_ENCODING;break;case x.Lyr3DImageFormat.Dxt5:d=c,l=4,u=W.TextureEncodingMimeType.DDS_ENCODING;break;case x.Lyr3DImageFormat.Png:u="image/png",h=document.createElement("img");break;case x.Lyr3DImageFormat.Jpeg:u="image/jpeg",h=document.createElement("img");break;case x.Lyr3DImageFormat.Etc2:u="image/ktx",h=document.createElement("img");break;case x.Lyr3DImageFormat.Astc:this._dbg(Q.Error,"Astc texture not supported");break;case x.Lyr3DImageFormat.Pvrtc:this._dbg(Q.Error,"Pvrtc texture not supported")}if(h&&u){const e=new Blob([c],{type:u});h.src=URL.createObjectURL(e),d=h}d&&null!=u&&(i=new $.Texture(d,{mipmap:o,maxAnisotropy:a,encoding:u,wrap:n,components:l,noUnpackFlip:!0,width:s.mip0Width,height:s.mip0Height}),this._stage.add(i),r.set(s,i))}}return i?new B.RenderTexture(this.view._stage.renderView.textures,i.id):null}getBufferViews(e,t,r){let i,s,a,o,n,l,c,d=null;for(let h=0;h<e.atrbs.length;h++){const c=e.atrbs[h],m=c.view,p=void 0,g=m.byteOffset+m.byteCount,y=m.byteCount/E.lyr3DTypeToByteSize[m.type],f=[...Array(y).keys()].map((e=>e));try{switch(c.sem){case x.Lyr3DVtxAtrbSemantic.Position:3!==m.ncomp||m.type!==x.Lyr3DType.F32?this._dbg(Q.Error,"[Unsupported Feature] Unsupported view for Position ("+m+")"):(i=new T.BufferViewVec3f(t,m.byteOffset,p,g),s=new G.Attribute(i.typedBuffer,f,3));break;case x.Lyr3DVtxAtrbSemantic.Normal:if(3!==m.ncomp||m.type!==x.Lyr3DType.F32)this._dbg(Q.Error,"[Unsupported Feature] Unsupported view for Normal ("+m+")");else{const e=new T.BufferViewVec3f(t,m.byteOffset,p,g),i=z.compressAndTransformNormals(e.typedBuffer,r);n=new T.BufferViewInt16(i),l=new G.Attribute(n.typedBuffer,f,2)}break;case x.Lyr3DVtxAtrbSemantic.TexCoord:2!==m.ncomp||m.type!==x.Lyr3DType.F32?this._dbg(Q.Error,"[Unsupported Feature] Unsupported view for Texcoord ("+m+")"):void 0===o&&(o=new G.Attribute(new T.BufferViewVec2f(t,m.byteOffset,p,g).typedBuffer,f,2));break;case x.Lyr3DVtxAtrbSemantic.Color:4===m.ncomp?(m.type===x.Lyr3DType.F32&&(d=new T.BufferViewVec4f(t,m.byteOffset,p,g)),m.type===x.Lyr3DType.U8&&(d=new T.BufferViewVec4u8(t,m.byteOffset,p,g)),m.type===x.Lyr3DType.U16&&(d=new T.BufferViewVec4u16(t,m.byteOffset,p,g))):3===m.ncomp&&(m.type===x.Lyr3DType.F32&&(d=new T.BufferViewVec3f(t,m.byteOffset,p,g)),m.type===x.Lyr3DType.U8&&(d=new T.BufferViewVec3u8(t,m.byteOffset,p,g)),m.type===x.Lyr3DType.U16&&(d=new T.BufferViewVec3u16(t,m.byteOffset,p,g))),null==d?this._dbg(Q.VerboseAPI,"[Unsupported Feature] Unsupported view for Color ("+m+")"):a=new G.Attribute(d.typedBuffer,f,m.ncomp);break;case x.Lyr3DVtxAtrbSemantic.FeatureIndex:break;default:this._dbg(Q.VerboseAPI,"[Unsupported Feature] Unsupported semantic ("+c.sem+"). Skipping vertex attribute.")}}catch(u){this._dbg(Q.VerboseAPI,"Error Creating buffer ("+u+"). Skipping vertex attribute.")}}if(e.index){const r=e.index.view,i=void 0,s=r.byteOffset+r.byteCount;switch(e.index.view.type){case x.Lyr3DType.U16:c=new T.BufferViewUint16(t,r.byteOffset,i,s);break;case x.Lyr3DType.U32:c=new T.BufferViewUint32(t,r.byteOffset,i,s);break;case x.Lyr3DType.U8:default:this._dbg(Q.Error,"[Unsupported Feature] index type not supported ("+r.type+").")}}if(null==c&&null!=i){const e=i.count;if(e<65535){const t=new Uint16Array(e);c=new T.BufferViewUint16(t)}else{const t=new Uint32Array(e);c=new T.BufferViewUint32(t)}for(let t=0;t<e;t++)c.set(t,t)}return{positionView:i,positionAttr:s,colorAttr:a,texCoord0Attr:o,indicesView:c,normalsView:n,normalsAttr:l}}_onRemoveFromCache(e){this._wasm?.onRenderableEvicted(this,e.handle,e.totalMemory()),this.freeRenderable(e.handle)}_dbg(e,t){this._dbgFlags.has(e)&&(e===Q.Error?i.getLogger(this).error(t):i.getLogger(this).warn(t))}};e.__decorate([n.property()],ee.prototype,"_visibleGeometryChangedSchedulerHandle",void 0),e.__decorate([n.property()],ee.prototype,"layer",void 0),e.__decorate([n.property({readOnly:!0})],ee.prototype,"visibleAtCurrentScale",null),e.__decorate([n.property()],ee.prototype,"elevationOffset",null),ee=e.__decorate([c.subclass("esri.views.3d.layers.IntegratedMesh3DTilesLayerView3D")],ee);return ee}));
