/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../core/Error","../../../core/handleUtils","../../../core/has","../../../core/perspectiveUtils","../../../core/promiseUtils","../../../core/reactiveUtils","../../../core/accessorSupport/decorators/property","../../../core/Logger","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../../core/libs/gl-matrix-2/factories/mat3f64","../../../geometry/support/aaBoundingRect","../../../layers/support/MediaElementView","./interfaces","./LayerView3D","./support/MediaLayerInteraction","../terrain/OverlayRenderer","../webgl-engine/lib/Attribute","../webgl-engine/lib/Geometry","../webgl-engine/lib/ModelDirtyTypes","../webgl-engine/lib/RenderGeometry","../webgl-engine/lib/Texture","../webgl-engine/lib/UpdatePolicy","../webgl-engine/lib/VertexAttribute","../webgl-engine/materials/ImageMaterial","../../layers/LayerView","../../layers/MediaLayerView","../../support/layerViewUtils","../../webgl/enums"],(function(e,t,r,i,n,a,s,d,o,l,c,u,h,p,m,y,_,g,E,D,w,v,b,f,A,R,x,T,M,P){"use strict";let S=class extends(y.LayerView3D(T(x))){get interactive(){return this._interaction.enabled}set interactive(e){this._interaction&&(this._interaction.enabled=e)}get selectedElement(){return this._interaction.selectedElement}set selectedElement(e){this._interaction&&(this._interaction.selectedElement=e)}get visibleAtCurrentScale(){return M.isInEffectiveScaleRange(this.layer.effectiveScaleRange,this.view.scale)}constructor(e){super(e),this.type="media-3d",this.drapeSourceType=m.DrapeSourceType.Features,this.updatePolicy=f.UpdatePolicy.ASYNC,this._uidToElement=new Map,this._renderedElements=new Map,this._lastDrapingExtent=null,this._update=a.debounce((async(e,t,r)=>{const i=await this._collectMediaElements(e,t,r);this._synchronizeRenderElements(i)}),0);const{view:t,layer:r}=e;this._interaction=new _.MediaLayerInteraction({view:t,layer:r}),this.addHandles(s.watch((()=>this.interactionOptions),(e=>this._interaction.options=e),s.syncAndInitial))}initialize(){const{view:e,layer:t}=this;this._renderer=e.basemapTerrain.overlayManager.registerGeometryDrapeSource(this);const i=()=>this._updateWithLastDrapingExtent();this.addHandles([r.makeHandle((()=>e.basemapTerrain.overlayManager.unregisterDrapeSource(this))),s.on((()=>t.effectiveSource),"change",i),s.on((()=>t.effectiveSource),"refresh",i)]),this._updatingHandles.add((()=>this.suspended),i)}setDrapingExtent(e,t){this._lastDrapingExtent={overlays:e,spatialReference:t},this._updateWithLastDrapingExtent()}getHit(e){const t=this._uidToElement.get(e);return t?{type:"media",element:t,layer:this.layer}:null}isUpdating(){return super.isUpdating()||this._interaction.updating}_updateWithLastDrapingExtent(){if(null==this._lastDrapingExtent||this.suspended)return void(this._renderer&&this._synchronizeRenderElements(new Set));const{overlays:e,spatialReference:t}=this._lastDrapingExtent;this._updatingHandles.addPromise(this._update(e,t).catch((()=>{})))}async _collectMediaElements(e,t,r){const i=this.layer.effectiveSource;return null==i?new Set:new Set((await Promise.all(e.map((e=>i.queryElements(h.toExtent(e.extent,t),{signal:r}))))).flat())}_synchronizeRenderElements(e){this._synchronizeRenderElementsRemove(e),this._synchronizeRenderElementsAdd(e)}_synchronizeRenderElementsRemove(e){this._renderedElements.forEach(((t,r)=>{e.has(r)||(this._removeElement(r,t),this.emit("element-render-changed",{element:r}))}))}_synchronizeRenderElementsAdd(e){for(const t of e)this._renderedElements.has(t)||this._createRenderElement(t)}_removeElement(e,{renderData:t,handle:r}){this._destroyRenderData(e,t),this._renderedElements.delete(e),this._uidToElement.delete(e.uid),r.remove()}async _createRenderElement(e){const t=new p.MediaElementView({spatialReference:this.view.spatialReference,element:e}),i={renderData:null,handle:r.handlesGroup([this._updatingHandles.add((()=>e.opacity),(e=>{null!=i.renderData&&i.renderData.material.setParameters({opacity:e})})),this._updatingHandles.add((()=>t.coords),(()=>{null!=i.renderData?this._updateGeometry(t,i,i.renderData):this._initializeRenderData(t,i)})),this._updatingHandles.add((()=>e.content),(()=>this._initializeRenderData(t,i))),r.destroyHandle(t)])};this._renderedElements.set(e,i),this._uidToElement.set(e.uid,e),this._updatingHandles.addPromise(e.load().catch((()=>{}))),this._initializeRenderData(t,i)}_initializeRenderData(e,t){const{coords:r,element:i}=e,{contentWidth:n,contentHeight:s}=i;if(null==r||null==i.content)return void(t.renderData=this._destroyRenderData(i,t.renderData));if(null!=t.renderData)return;const d=this._createTexture(i.content),o=d.load(this.view._stage.renderView.renderingContext);this.view._stage.add(d),a.isPromiseLike(o)&&this._updatingHandles.addPromise(o);const l=new R.ImageMaterial({initTextureTransparent:!0,textureId:d.id,opacity:i.opacity,perspectiveInterpolation:!0}),c=this._getPositionAttributeArray(r),u=[0,0,1,0,1,1,0,1],h=this._getPerspectiveDivideAttributeArray(c,n,s),p=[0,1,2,0,2,3],m=new D.Geometry(l,[[A.VertexAttribute.POSITION,new E.Attribute(c,p,3,!0)],[A.VertexAttribute.UV0,new E.Attribute(u,p,2,!0)],[A.VertexAttribute.PERSPECTIVEDIVIDE,new E.Attribute(h,p,1,!0)]]),y=new v.RenderGeometry(m,{layerUid:this.layer.uid,graphicUid:i.uid});this._renderer.addGeometries([y],w.DirtyOperation.ADD),t.renderData={renderGeometry:y,texture:d,material:l},this.emit("element-render-changed",{element:i})}_updateGeometry(e,t,r){const{coords:i,element:n}=e;if(null==i||null==n.content)return void(t.renderData=this._destroyRenderData(n,t.renderData));const a=this._getPositionAttributeArray(i);r.renderGeometry.geometry.setAttributeData(A.VertexAttribute.POSITION,a);const s=this._getPerspectiveDivideAttributeArray(a,n.contentWidth,n.contentHeight);r.renderGeometry.geometry.setAttributeData(A.VertexAttribute.PERSPECTIVEDIVIDE,s),r.renderGeometry.geometry.invalidateBoundingInfo(),this._renderer.modifyGeometries([r.renderGeometry],w.DirtyState.GEOMETRY),this.emit("element-render-changed",{element:n})}_getPositionAttributeArray(e){const[t,r,i,n]=e.rings[0];return[t[0],t[1],g.drapedZ,n[0],n[1],g.drapedZ,i[0],i[1],g.drapedZ,r[0],r[1],g.drapedZ]}_getPerspectiveDivideAttributeArray(e,t,r){n.getProjectiveTransform(G,[0,0,t,0,t,r,0,r],[e[0],e[1],e[3],e[4],e[6],e[7],e[9],e[10]]);const i=G[6]/G[8]*t,a=G[7]/G[8]*r;return[1,1+i,1+i+a,1+a]}_destroyRenderData(e,t){if(null==t)return null;const r=t.texture;return r.unload(),this.view._stage.remove(r),this._renderer.removeGeometries([t.renderGeometry],w.DirtyOperation.REMOVE),this.emit("element-render-changed",{element:e}),null}_createTexture(e){const r=e instanceof HTMLImageElement?e.naturalWidth:e.width,i=e instanceof HTMLImageElement?e.naturalHeight:e.height;if("getFrame"in e)throw new t("media-layer-view-3d","animation is not supported");return new b.Texture(e,{wrap:{s:P.TextureWrapMode.CLAMP_TO_EDGE,t:P.TextureWrapMode.CLAMP_TO_EDGE},preMultiplyAlpha:!0,width:r,height:i,mipmap:!0,updateCallback:()=>this.view.basemapTerrain.overlayManager.setDrawTexturesDirty()})}get test(){}};e.__decorate([d.property({readOnly:!0})],S.prototype,"type",void 0),e.__decorate([d.property()],S.prototype,"layer",void 0),e.__decorate([d.property()],S.prototype,"interactive",null),e.__decorate([d.property()],S.prototype,"selectedElement",null),e.__decorate([d.property({readOnly:!0})],S.prototype,"visibleAtCurrentScale",null),S=e.__decorate([c.subclass("esri.views.3d.layers.MediaLayerView3D")],S);const G=u.create();return S}));
