/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../core/arrayUtils","../../../core/asyncUtils","../../../core/Collection","../../../core/has","../../../core/Logger","../../../core/maybe","../../../core/promiseUtils","../../../core/reactiveUtils","../../../core/screenUtils","../../../core/typedArrayUtil","../../../core/accessorSupport/decorators/property","../../../core/accessorSupport/decorators/subclass","../../../chunks/vec32","../../../core/libs/gl-matrix-2/factories/vec3f32","../../../geometry/support/aaBoundingBox","../../../geometry/support/plane","../../../layers/support/CodedValue","../../../layers/support/CodedValueDomain","../../../layers/support/Domain","../../../layers/support/InheritedDomain","../../../layers/support/RangeDomain","../../../layers/support/fieldUtils","../../../layers/support/PromiseQueue","../../../support/elevationInfoUtils","./LayerView3D","./PointCloudLayerViewPerformanceInfo","./PointCloudWorkerHandle","./i3s/I3SUtil","./i3s/LoDUtil","./i3s/PagedNodeIndex","./i3s/PointCloudRendererUtil","./i3s/PointCloudWorkerUtil","./i3s/PointGraphic","./i3s/PointRenderer","./support/highlightUtils","./support/PopupSceneLayerView","../support/extentUtils","../support/hitTest","../support/index","../support/orientedBoundingBox","../support/updatingProperties","../../layers/LayerView","../../support/HighlightDefaults","../../support/layerViewUtils","../../support/Scheduler"],(function(e,t,i,r,s,o,n,a,d,l,h,u,c,p,_,g,m,y,f,b,P,w,N,x,v,C,I,A,S,k,V,R,L,D,Q,U,F,W,z,E,M,H,O,B,G,q){"use strict";const T=8,$=m.create();let j=class extends(F.PopupSceneLayerView(C.LayerView3D(O))){constructor(){super(...arguments),this.type="point-cloud-3d",this.maximumPointCount=4e6,this.slicePlaneEnabled=!1,this._renderer=null,this._rendererAdded=!1,this._renderedNodes=new Set,this._updateViewNeeded=!0,this._lodFactor=1,this._maxLoggedBoxWarnings=5,this._pageMultiplier=1,this._nodeLoadEpoch=0,this._indexQueue=[],this._workQueue=new Array,this._idleQueue=new x.PromiseQueue,this._indexPagesLoading=new Map,this._loadingNodes=new Map,this._recalcWork=!0,this._layerIsVisible=!1,this._codedDomainPopulationPromise=null,this._codedDomainPopulationAbortController=null,this._totalWork=0,this._index=null,this._loadingInitNodePage=!1,this._nodeIdArray=[],this.ignoresMemoryFactor=!1}get baseUrl(){return this.layer.parsedUrl?.path??""}get pointScale(){const e=R.getSplatSizeAlgorithm(this.layer?.renderer),t=1;return null!=e?.scaleFactor?e.scaleFactor:t}get useRealWorldSymbolSizes(){const e=R.getFixedSizeAlgorithm(this.layer?.renderer),t=!1;return null!=e?.useRealWorldSymbolSizes?e.useRealWorldSymbolSizes:t}get pointSize(){const e=R.getFixedSizeAlgorithm(this.layer?.renderer),t=0;return null!=e?.size?e.size:t}get inverseDensity(){const e=96;return this.layer?.renderer?1*e/this.layer.renderer.pointsPerInch:5}get availableFields(){const e=R.getRendererInfo(this.layer),t=new Set;e.primaryAttribute&&t.add(e.primaryAttribute.name),e.modulationAttribute&&t.add(e.modulationAttribute.name);const i=R.getFilterInfo(this.layer);if(i)for(const r of i)r.attributeInfo&&t.add(r.attributeInfo.name);if(this.layer.outFields)for(const r of N.unpackFieldNames(this.layer.fieldsIndex,this.layer.outFields))t.add(r);return Array.from(t)}get _clippingBox(){if(!this.view||!this.view.clippingArea)return null;const e=g.create(),t=this.view.renderSpatialReference;return W.projectToBoundingBox(this.view.clippingArea,e,t)?e:null}get _elevationOffset(){const e=this.layer&&this.layer.elevationInfo;return e&&"absolute-height"===e.mode?v.getElevationOffset(e,this.layer.spatialReference):0}initialize(){const e=this.view.resourceController,t=X(e);this._worker=new A.PointCloudWorkerHandle(t),this.addResolvingPromise(this._worker.promise),S.checkPointCloudLayerValid(this.layer),S.checkPointCloudLayerCompatibleWithView(this.layer,this.view),this._indexRequester=e.createStreamDataRequester(E.ClientType.I3S_INDEX),this._dataRequester=e.createStreamDataRequester(E.ClientType.I3S_DATA),this._initRenderer();const i=this._initNodePages(),r=this.view.resourceController.memoryController;this._memCache=r.newCache(`pcl-${this.layer.uid}`),this._updatingHandles.add((()=>this._clippingBox),(()=>this._setUpdateViewNeeded()),d.initial),this._updatingHandles.add((()=>this._elevationOffset),(()=>this._elevationOffsetChanged()),d.initial),this._updatingHandles.add((()=>this.layer.renderer),(()=>this._rendererChanged()),d.initial),this._updatingHandles.add((()=>this.layer.filters),(()=>this._reload()),d.initial),this._updatingHandles.add((()=>this.layer.outFields),(()=>this._reload()),d.initial),this._updatingHandles.add((()=>this.layer.effectiveScaleRange),(()=>this._setUpdateViewNeeded())),this._updatingHandles.add((()=>this.view.state.contentCamera),(()=>this._setUpdateViewNeeded())),this.addHandles([d.watch((()=>this.view.quality),(()=>this._setUpdateViewNeeded()),d.sync)]),this.addResolvingPromise(i),this.when((()=>{this.addHandles([e.scheduler.registerTask(q.TaskPriority.POINT_CLOUD_LAYER,this),e.scheduler.registerIdleStateCallbacks((()=>this._idleBegin()),(()=>this._idleEnd())),this._updatingHandles.add((()=>this.suspended),(e=>{e?this._clearNodeState():this._setUpdateViewNeeded()}),d.initial)])}),(()=>{this._updatingHandles.removeAll(),this.removeAllHandles()}))}_setUpdateViewNeeded(){this._updateViewNeeded=!0,this._updateLoading()}destroy(){this.cancelLoading(),this._worker=n.destroyMaybe(this._worker),this._destroyRenderer(),this._memCache=n.destroyMaybe(this._memCache),this._codedDomainPopulationAbortController=n.abortMaybe(this._codedDomainPopulationAbortController),this._codedDomainPopulationPromise=null}_initRenderer(){this._renderer=new Q.PointRenderer({createGraphic:(e,t,i)=>this._createGraphic(e,t,i)}),this._renderer.layerUid=this.layer.uid,this._updatingHandles.add((()=>this._clippingBox),(e=>this._renderer.clippingBox=e),d.initial),this._updatingHandles.add((()=>this.suspended),(e=>this._setPointsVisible(!e)),d.initial),this._updatingHandles.add((()=>this.pointScale),(e=>this._renderer.scaleFactor=e),d.initial),this._renderer.minSizePx=Math.sqrt(2),this._updatingHandles.add((()=>this.useRealWorldSymbolSizes),(e=>this._renderer.useRealWorldSymbolSizes=e),d.initial),this._updatingHandles.add((()=>this.pointSize),(e=>{const t=l.pt2px(e);this._renderer.size=e,this._renderer.sizePx=t}),d.initial),this._updatingHandles.add((()=>this.slicePlaneEnabled),(e=>this._renderer.slicePlaneEnabled=e),d.initial),this._updatingHandles.add((()=>this.inverseDensity),(()=>this._setUpdateViewNeeded()),d.initial),this._updatingHandles.add((()=>this.maximumPointCount),(()=>this._setUpdateViewNeeded()),d.initial),this._updatingHandles.add((()=>this.view.qualitySettings.sceneService.pointCloud.lodFactor),(e=>{this._lodFactor=e,this._setUpdateViewNeeded()}),d.initial)}_destroyRenderer(){this._renderer.removeAll(),this._setPointsVisible(!1)}_createGraphic(e,t,i){const r=null!=e.pointIdFilterMap?e.pointIdFilterMap[t]:t,s=z.computeMapPointFromVec3d(this.view,i),o=this._createGraphicAttributes(e,r);return new D.PointGraphic({pointCloudMetadata:{nodeId:e.id,pointIndexInNode:t,attributePointIndexInNode:r,epoch:this._nodeLoadEpoch},geometry:s,attributes:o,layer:this.layer,sourceLayer:this.layer})}_createGraphicAttributes(e,t){const i={};for(const r of e.attributes)this._encodeGraphicAttribute(r.attributeInfo,r.values,t,i);return i}_encodeGraphicAttribute(e,t,i,r){const s=e.storageInfo?.attributeValues,o=s?.valuesPerElement??1;if(1===o)r[e.name]=t[i];else if("UInt8"===s?.valueType&&o<=4){let s=0;const n=i*o;for(let e=n;e<n+o;e++)s=(s<<8)+t[e];r[e.name]=s}else r[e.name]=void 0}_setPointsVisible(e){e&&!this._rendererAdded?(this.view._stage.addRenderPlugin(this._renderer),this._rendererAdded=!0):!e&&this._rendererAdded&&(this.view._stage.removeRenderPlugin(this._renderer),this._rendererAdded=!1)}_rendererChanged(){this._renderer.useFixedSizes=R.rendererUsesFixedSizes(this.layer.renderer),this._reload()}_reload(){this._clearNodeState(),this._memCache.clear(),this._setUpdateViewNeeded()}_elevationOffsetChanged(){this._clearNodeState(),this._memCache.clear(),this._initNodePages()}_displayNodes(e){this._workQueue=k.nodeDiff([...this._renderedNodes],e,this._index),k.sortFrontToBack(this._workQueue,this.view.state.contentCamera.viewForward,this._index),k.splitWorkEntries(this._workQueue,T,this._index),this._updateQueues(),this._totalWork=this._computeWork(),this._updateLoading(),this._layerIsVisible=e.length>0||this._loadingInitNodePage,this.notifyChange("suspended")}cancelLoading(){this._cancelNodeLoading(),this._cancelIndexLoading()}_cancelNodeLoading(){const e=new Array;this._loadingNodes.forEach((({abortController:t})=>e.push(t))),this._loadingNodes.clear();for(const t of e)t.abort();this._workQueue=[],this._idleQueue.cancelAll(),this._totalWork=this._computeWork(),this._updateLoading()}_updateQueues(){const e=new Set;this._workQueue.forEach((t=>t.load.forEach((t=>e.add(t)))));const t=new Array,i=new Map;this._loadingNodes.forEach(((r,s)=>{e.has(s)?i.set(s,r):t.push(r)})),this._loadingNodes=i;for(const{abortController:r}of t)r.abort();this._workQueue=this._workQueue.filter((e=>{for(const t of e.load)if(this._loadingNodes.has(t))return this._recalcWork=!0,!1;return!0})),this._totalWork=this._computeWork(),this._updateLoading()}_cancelIndexLoading(){this._indexQueue=[],this._indexPagesLoading.forEach((({abortController:e})=>e.abort())),this._indexPagesLoading.clear(),this._totalWork=this._computeWork(),this._updateLoading()}_clearNodeState(){this._nodeLoadEpoch++,this._renderedNodes.forEach((e=>this._removeFromRenderer(e))),this._cancelNodeLoading()}_idleBegin(){this._setUpdateViewNeeded()}_idleEnd(){this._setUpdateViewNeeded()}get running(){return this.suspended?this._updateViewNeeded:this._updateViewNeeded||this._indexQueue.length>0||this._workQueue.length>0||this._idleQueue.running}runTask(e){if(this.suspended){if(this._updateViewNeeded){this._updateViewNeeded=!1;const e=this._isRootNodeVisible();e!==this._layerIsVisible&&(this._layerIsVisible=e,this.notifyChange("suspended")),this._updateLoading()}}else{for(e.run((()=>this._updateWorkQueues()));this._indexQueue.length>0&&e.run((()=>this._processIndexQueue())););this._processWorkQueue(e),this._idleQueue.runTask(e)}}_processIndexQueue(){const e=this._indexQueue.shift(),t=this._loadNodePage(e);return this._indexPagesLoading.set(e,t),t.promise.then((t=>{this._index.addPage(e,t,this._elevationOffset),this._setUpdateViewNeeded()})).then((()=>{this._indexPagesLoading.delete(e)}),(()=>{this._indexPagesLoading.delete(e)})),!0}_processWorkQueue(e){for(;!e.done;){const t=this._scheduleWorkEntry();if(null==t)return void e.madeProgress();this._processWorkEntry(t),e.madeProgress()}}_scheduleWorkEntry(){let e=this._workQueue.length;for(;e--;){const e=this._workQueue.shift();if(!e.remove.find((e=>!this._renderedNodes.has(e))))return e;this._workQueue.push(e)}return null}_processWorkEntry(e){if(0!==e.load.length)Promise.all(e.load.map((e=>{const t=new AbortController,i=this._memCache.pop(e.toString());return null!=i?this._loadingNodes.set(e,{abortController:t,promise:Promise.resolve(i)}):this._loadingNodes.has(e)||this._loadingNodes.set(e,{abortController:t,promise:this._loadNode(e,t.signal)}),this._loadingNodes.get(e).promise}))).then((t=>{for(let i=0;i<e.load.length;i++)if(t[i]){const r=this._setupRendererData(e.load[i],t[i]);this._addToRenderer(r)}for(const i of e.remove)this._removeFromRenderer(i)})).catch((()=>{})).then((()=>{for(const t of e.load)this._loadingNodes.delete(t);this._updateLoading(),this._recalcWork&&!this._idleQueue.running&&0===this._indexQueue.length&&0===this._loadingNodes.size&&(this._recalcWork=!1,this._setUpdateViewNeeded())})),this._updateLoading();else for(const t of e.remove)this._removeFromRenderer(t)}async _populateClassCodeCodedDomain(e,t){const r="CLASS_CODE",s=this.layer.fieldsIndex.get(r);if(!s||s.domain)return;if(!e.includes(s.name))return;const o=await i.result(this.layer.queryCachedStatistics(r,{signal:t}));if(!1===o.ok)return;const n=o.value?.stats?.labels?.labels;n&&Array.isArray(n)&&(s.domain=new f({name:"CLASS_CODE",codedValues:n.map((e=>new y.CodedValue({code:e.value,name:e.label})))}))}async prepareFetchPopupFeatures(e){return this._codedDomainPopulationPromise||(this._codedDomainPopulationAbortController=new AbortController,this._codedDomainPopulationPromise=this._populateClassCodeCodedDomain(e,this._codedDomainPopulationAbortController.signal).then((()=>{this._codedDomainPopulationAbortController=null}))),this._codedDomainPopulationPromise}async whenGraphicAttributes(e,r){const s=this._splitGraphicsPerNode(e),o=this.layer.attributeStorageInfo,n=r.map((e=>R.getAttributeInfo(o,e))).filter(t.isSome),a=async(e,t)=>{const r=this._index.getNode(t);await i.forEach(n,(async t=>{const i=t.useElevation?await this._loadElevationAttributeFromGeometry(r.resourceId):await this._loadAndParseAttribute(r,t);if(i)for(const r of e)if(this._isValidPointGraphic(r)){const e=r.pointCloudMetadata.attributePointIndexInNode;this._encodeGraphicAttribute(t,i,e,r.attributes)}}))},d=[];return s.forEach(((e,t)=>{d.push(a(e,t))})),await Promise.allSettled(d),e}_isValidPointGraphic(e){return e instanceof D.PointGraphic&&e.pointCloudMetadata?.epoch===this._nodeLoadEpoch}_splitGraphicsPerNode(e){const t=new Map;for(const i of e){if(!this._isValidPointGraphic(i))continue;const e=i.pointCloudMetadata,r=t.get(e.nodeId);r?r.push(i):t.set(e.nodeId,[i])}return t}async _loadAndParseAttribute(e,t){const i=await this._loadAttribute(e.resourceId,t,null);return null!=i?L.getAttributeValues({attributeInfo:t,buffer:i},null,e.vertexCount):null}async _loadElevationAttributeFromGeometry(e){const t=this.layer.store.defaultGeometrySchema,i=L.readGeometry(t,await this._loadGeometry(e,null));return L.elevationFromPositions(i,i.length/3)}highlight(e,t){if(!e)return U.emptyHighlightHandle;const i=r.isCollection(e)?e.toArray():Array.isArray(e)?e:[e];return 0===i.length?U.emptyHighlightHandle:this._renderer.highlight(i.map((e=>this._graphicToPointDefinition(e))),t??B.defaultHighlightName)}_graphicToPointDefinition(e){if(!this._isValidPointGraphic(e))return null;const{nodeId:t,pointIndexInNode:i}=e.pointCloudMetadata;return null!=t&&null!=i?{nodeId:t,pointId:i}:null}_computeWork(){let e=0;for(const t of this._workQueue)e+=t.load.length+t.remove.length;return e+=this._loadingNodes.size,e+=(this._indexQueue.length+this._indexPagesLoading.size)*this._index.pageSize,e+=this._loadingInitNodePage?100:0,e+=this._updateViewNeeded?100:0,e}get updatingProgressValue(){if(this.suspended)return this._updateViewNeeded?0:1;const e=this._computeWork();return 1-Math.min(this._totalWork,e)/this._totalWork}_updateLoading(){this.notifyChange("updating"),this.notifyChange("updatingProgressValue")}canResume(){return super.canResume()&&this._layerIsVisible}isUpdating(){return this.suspended?this._updateViewNeeded:this._computeWork()>0}get visibleAtCurrentScale(){return G.isInEffectiveScaleRange(this.layer.effectiveScaleRange,this.view.scale)}_initNodePages(){const e=this.layer.store.index,t=e.nodesPerPage||e.nodePerIndexBlock;return this._index=new V.PagedNodeIndex(this.layer.spatialReference,this.view.renderCoordsHelper.spatialReference,t),this._cancelIndexLoading(),this._traverseVisible=this._index.createVisibilityTraverse(),this._loadingInitNodePage=!0,this._layerIsVisible=!0,this.notifyChange("suspended"),this._updateLoading(),this._pageMultiplier=null!=e.nodesPerPage?1:e.nodePerIndexBlock,this._loadNodePage(0).promise.then((e=>{this._index.addPage(0,e,this._elevationOffset),this._loadingInitNodePage=!1,this._setUpdateViewNeeded()}))}_loadNodePage(e){const t=new AbortController,i=`${this.baseUrl}/nodepages/${e*this._pageMultiplier}`;return{promise:this._requestNodePage(i,t.signal).then((t=>t.nodes.map(((t,i)=>({resourceId:null!=t.resourceId?t.resourceId:e*this._index.pageSize+i,obb:M.Obb.fromJSON(t.obb),obbInRenderSR:new M.Obb,firstChild:t.firstChild,childCount:t.childCount,vertexCount:t.vertexCount??t.pointCount,lodThreshold:t.lodThreshold??t.effectiveArea}))))),abortController:t}}_updateWorkQueues(){if(!this._updateViewNeeded)return!1;const e=this.view.quality;let t=this.inverseDensity/this._lodFactor*e;const i=this.maximumPointCount*this._lodFactor*e;let r=this._computeNodesForMinimumDensity(t),s=this._computePointCount(r),o=Math.sqrt(s/(.75*i));for(;s>i;)t*=o,r=this._computeNodesForMinimumDensity(t),s=this._computePointCount(r),o=Math.sqrt(2);return this._displayNodes(r),this._updateViewNeeded=!1,this._updateLoading(),!0}_computePointCount(e){let t=0;for(let i=0;i<e.length;i++){const r=this._index.getNode(e[i]);r&&(t+=r.vertexCount)}return t}_isRootNodeVisible(){let e=!1;return this._traverseVisible({frustum:this.view.state.contentCamera.frustum,clippingBox:this._clippingBox},{predicate:(t,i,r)=>(e=r,!1),pageMiss:()=>{}}),e}_computeNodesForMinimumDensity(e){const t=this.view.state.contentCamera,i=t.frustum,r=this._clippingBox,s=t.viewForward,o=p.dot(s,t.eye),n=m.fromNormalAndOffset(s,-o,$),a=t.perScreenPixelRatio/2,d=e*e,l=this._nodeIdArray;l.length=0;const h=e=>l.push(e);return this._traverseVisible({frustum:i,clippingBox:r},{predicate:(e,t,i)=>{if(!i)return!1;if(0===t.childCount)return h(e),!1;const r=this._index.getRenderObb(e);return!(this._computeAveragePixelArea(r,t.lodThreshold,t.vertexCount,n,a)<=d)||(h(e),!1)},pageMiss:(e,t)=>{h(e),this._indexQueue.includes(t)||this._indexQueue.push(t)}}),l}_computeAveragePixelArea(e,t,i,r,s){const o=1e-7,n=Math.max(o,e.minimumDistancePlane(r));return t/(n*n)/(4*s*s)/i}_loadNode(e,t){try{return this._loadNodeAsync(e,t)}catch(i){throw a.isAbortError(i)||o.getLogger(this).error(i),i}}async _loadAdditionalUserAttributes(e,i,r){const s=this.layer.outFields;if(!s)return[];const o=N.unpackFieldNames(this.layer.fieldsIndex,s),n=new Set(e.map((e=>null!=e?e.name:null))),d=this.layer.attributeStorageInfo,l=[];for(const t of o){if(n.has(t))continue;const e=R.getAttributeInfo(d,t);e&&l.push(i(e))}const h=await a.allSettledValues(l);return a.throwIfAborted(r),h.filter(t.isSome)}async _loadNodeAsync(e,t){const i=this._index.getNode(e),r=R.getRendererInfo(this.layer),s=R.getFilterInfo(this.layer),o=i.resourceId,n=async e=>{if(!e)return null;if(e.useElevation)return{attributeInfo:e,buffer:null};const i=await this._loadAttribute(o,e,t);return null!=i?{attributeInfo:e,buffer:i}:null};return this._idleQueue.push((async()=>{const i=this._loadGeometry(o,t),{primaryAttribute:d,modulationAttribute:l}=r,h=n(d),u=n(l),c=s.map((e=>e.attributeInfo)),p=c.map((e=>n(e))),_=this._loadAdditionalUserAttributes([d,l,...c],n,t),[g,m,y,f,b]=await Promise.all([i,h,u,Promise.all(p),_]);a.throwIfAborted(t);const P={geometryBuffer:g,primaryAttributeData:m,modulationAttributeData:y,filterAttributesData:f,userAttributesData:b,schema:this.layer.store.defaultGeometrySchema,rendererInfo:r,filterInfo:s,obbData:this._index.getRenderObb(e).data,elevationOffset:this._elevationOffset,inSR:this.layer.spatialReference.toJSON(),outSR:this.view.renderCoordsHelper.spatialReference.toJSON()};return this._worker.invoke(P,t)}),t)}async _loadGeometry(e,t){return this._requestData(`${this.baseUrl}/nodes/${e}/geometries/0`,t)}async _loadAttribute(e,t,i){if(!t?.storageInfo)return null;const r=t.storageInfo.key;return this._requestData(`${this.baseUrl}/nodes/${e}/attributes/${r}`,i)}_requestNodePage(e,t){const i={f:"json",...this.layer.customParameters,token:this.layer.apiKey};return this._indexRequester.request(e,"json",{query:i,signal:t})}_requestData(e,t){return this._dataRequester.request(e,"binary",{query:{...this.layer.customParameters,token:this.layer.apiKey},signal:t})}_removeFromRenderer(e){if(this._renderedNodes.has(e)){const t=this._renderer.removeNode(e);this._renderedNodes.delete(e),this._memCache.put(t.id.toString(),t,J(t))}}_addToRenderer(e){this._renderedNodes.has(e.id)||(this._renderedNodes.add(e.id),this._renderer.addNode(e))}_setupRendererData(e,t){const i=this._index.getNode(e),r=Math.sqrt(i.lodThreshold/i.vertexCount),s=this._index.getRenderObb(e);if(Q.isPointRendererNode(t))return t.splatSize=r,t.obb=s,p.copy(t.origin,t.obb.center),t;const n=M.Obb.fromData(t.obbData),a=n.halfSize,d=s.halfSize,l=.01*Math.max(d[0],d[1],d[2]);if(a[0]>d[0]+l||a[1]>d[1]+l||a[2]>d[2]+l){if(this._maxLoggedBoxWarnings>0){const t=e=>`[${e.halfSize[0]}, ${e.halfSize[1]}, ${e.halfSize[2]}]`;o.getLogger(this).warn(`Node ${e} reported bounding box too small. got ${t(s)} but points cover ${t(n)}`),0==--this._maxLoggedBoxWarnings&&o.getLogger(this).warn("  Too many bounding box errors, stopping reporting for this layer.")}this._index.setRenderObb(e,n)}return new Q.PointRendererNode(e,r,_.clone(s.center),s,0===i.childCount,t.points,t.rgb,t.attributes,t.pointIdFilterMap)}get usedMemory(){let e=0;return this._renderer.forEachNode((t=>{e+=K,e+=h.estimateSize(t.coordinates);for(const i of t.attributes){const t=i.values;h.isArrayBuffer(t.buffer)&&(e+=h.estimateSize(t))}})),e}get unloadedMemory(){const e=this._renderedNodes.size;if(e<4)return 0;const t=[...this._renderedNodes].reduce(((e,t)=>e+this._index.getNode(t).vertexCount));let i=this._loadingNodes.size;for(let r=0;r<this._workQueue.length;r++)i+=this._workQueue[r].load.length,i-=this._workQueue[r].remove.length;if(i<0)return 0;return i*t/e*((this.usedMemory-e*K)/t)+i*K}get performanceInfo(){return new I.PointCloudLayerViewPerformanceInfo(this.usedMemory,this._renderedNodes.size,[...this._renderedNodes].reduce(((e,t)=>e+this._index.getNode(t).vertexCount),0),this.maximumPointCount,new I.QueuePerformanceInfo(this._loadingNodes.size,this._indexQueue.length,this._workQueue.length,this._idleQueue.length))}get test(){}};e.__decorate([u.property()],j.prototype,"layer",void 0),e.__decorate([u.property()],j.prototype,"baseUrl",null),e.__decorate([u.property()],j.prototype,"pointScale",null),e.__decorate([u.property()],j.prototype,"useRealWorldSymbolSizes",null),e.__decorate([u.property()],j.prototype,"pointSize",null),e.__decorate([u.property()],j.prototype,"inverseDensity",null),e.__decorate([u.property()],j.prototype,"maximumPointCount",void 0),e.__decorate([u.property({readOnly:!0})],j.prototype,"availableFields",null),e.__decorate([u.property({readOnly:!0})],j.prototype,"_clippingBox",null),e.__decorate([u.property({readOnly:!0})],j.prototype,"_elevationOffset",null),e.__decorate([u.property({type:Boolean})],j.prototype,"slicePlaneEnabled",void 0),e.__decorate([u.property()],j.prototype,"updating",void 0),e.__decorate([u.property(H.updatingProgress)],j.prototype,"updatingProgress",void 0),e.__decorate([u.property({readOnly:!0})],j.prototype,"updatingProgressValue",null),e.__decorate([u.property({readOnly:!0})],j.prototype,"visibleAtCurrentScale",null),j=e.__decorate([c.subclass("esri.views.3d.layers.PointCloudLayerView3D")],j);function J(e){return 5*e.coordinates.length+128}const K=160;function X(e){return t=>e.immediate.schedule(t)}return j}));
