/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../Graphic","../../../core/Logger","../../../core/maybe","../../../core/ReactiveSet","../../../core/reactiveUtils","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../../core/sql/WhereClause","../../../layers/support/FeatureFilter","../../../layers/support/floorFilterUtils","../../../rest/support/Query","./I3SMeshView3D","./II3SMeshView3D","./LayerView3D","./i3s/featureEditing","./i3s/I3SGeometryUtil","./i3s/I3SMeshViewFilter","./i3s/I3SNode","./i3s/I3SOverrides","./i3s/I3SQueryEngine","./i3s/I3SQueryFeatureAdapter","./i3s/I3SQueryFeatureStore","./i3s/I3SUtil","./support/DefinitionExpressionSceneLayerView","./support/fieldProperties","./support/PopupSceneLayerView","./support/SceneLayerViewRequiredFields","./support/TemporalSceneLayerView","../support/updatingProperties","../../layers/SceneLayerView","../../layers/support/popupUtils","../../support/HighlightDefaults","../../support/layerViewUtils","../../support/Scheduler"],(function(e,t,i,r,s,l,n,a,d,o,u,h,p,c,y,g,_,F,f,I,b,v,S,w,E,m,O,x,H,V,C,Q,j,q,L,R,A){"use strict";const D=x.defineFieldProperties();let P=class extends(y.I3SMeshView3D(C.TemporalSceneLayerView(O.DefinitionExpressionSceneLayerView(H.PopupSceneLayerView(_.LayerView3D(j)))))){constructor(){super(...arguments),this.type="scene-layer-3d",this._setVisibilityHiddenObjectIds=new s,this.progressiveLoadFactor=1,this._elevationContext="scene",this._isIntegratedMesh=!1,this._supportsLabeling=!0,this._pendingEditsQueue=Promise.resolve(),this._interactiveEditingSessions=new Map,this._queryEngine=null}get i3slayer(){return this.layer}tryRecycleWith(e,t){return e.url===this.layer.url&&this.i3sOverrides.isEmpty?e.load(t).then((()=>{m.checkRecyclable(this.layer,e,this.i3sOverrides),this.layer=e,this.i3sOverrides.destroy();const t=this.view.resourceController?.memoryController;this.i3sOverrides=new v.I3SOverrides({view:this.view,layer:e,memoryController:t}),this.resetHighlights()})):null}get layerPopupEnabledAndHasTemplate(){return this.layer.popupEnabled&&q.hasPopupTemplate(this.layer,this.view.popup?.defaultPopupTemplateEnabled)}get filter(){return this._get("filter")}set filter(e){this._set("filter",I.I3SMeshViewFilter.checkSupport(e)?e:null)}get viewFilter(){const e=this.mergedFilter,t=this.layerFilter;if(null==e&&null==t)return null;const i=this._get("viewFilter");return null==i?new I.I3SMeshViewFilter({layerFilter:t,viewFilter:e,layerFieldsIndex:this.layer.fieldsIndex,loadAsyncModule:e=>this._loadAsyncModule(e),addSqlFilter:(e,t)=>this.addSqlFilter(e,t,this.logError),addTimeFilter:(e,t)=>this.addTimeFilter(e,t)}):(i.viewFilter=e,i.layerFilter=t,i)}get requiredFields(){return this._fieldsHelper?.requiredFields??[]}get _floorFilterClause(){const e=p.getFloorFilterClause(this);return null!=e?u.WhereClause.create(e,{fieldsIndex:this.layer.fieldsIndex}):null}get _excludeObjectIdsSorted(){const e=this.layer.excludeObjectIds.toArray();return e.length?e.sort(((e,t)=>e-t)):null}get _setVisibilityHiddenObjectIdsSorted(){return this._setVisibilityHiddenObjectIds.size?Array.from(this._setVisibilityHiddenObjectIds).sort(((e,t)=>e-t)):null}get lodFactor(){return this.view?.qualitySettings?.sceneService?.object?.lodFactor??1}get lodCrossfadeUncoveredDuration(){return this.view?.qualitySettings?.fadeDuration??0}get updatingProgressValue(){return this._controller?.updatingProgress??0}get visibleAtCurrentScale(){return R.isInEffectiveScaleRange(this.i3slayer.effectiveScaleRange,this.view.scale)}initialize(){this._fieldsHelper=new V.SceneLayerViewRequiredFields({layerView:this}),this._updatingHandles.add((()=>this.layer.rangeInfos),(e=>this._rangeInfosChanged(e)),l.initial),this._updatingHandles.add((()=>this.layer.renderer),(e=>this._updatingHandles.addPromise(this._rendererChange(e))),l.initial);const e=()=>this._filterChange();this._updatingHandles.add((()=>this.parsedDefinitionExpression),e),this._updatingHandles.add((()=>this.mergedFilter),e),this._updatingHandles.add((()=>this._floorFilterClause),e),this._updatingHandles.add((()=>this._excludeObjectIdsSorted),e),this._updatingHandles.add((()=>this._setVisibilityHiddenObjectIdsSorted),e),this._updatingHandles.add((()=>this.viewFilter?.sortedObjectIds),e),this._updatingHandles.add((()=>this.viewFilter?.parsedWhereClause),e),this._updatingHandles.add((()=>this.getTimeFilterDependencies()),e),this._updatingHandles.add((()=>[this.viewFilter?.parsedGeometry,this.mergedFilter?.spatialRelationship,this.layer.filter?.spatialRelationship]),(()=>this._geometryFilterChange())),this.i3sOverrides.is3DOFL&&this._updatingHandles.add((()=>this.i3sOverrides.sortedGeometryChangedObjectIds),e),this.addHandles(this.layer.on("apply-edits",(e=>this._updatingHandles.addPromise(e.result)))),this.addHandles(this.layer.on("edits",(e=>{const t=this._pendingEditsQueue.then((()=>this._handleEdits(e))).then();this._pendingEditsQueue=t,this._updatingHandles.addPromise(t)})))}destroy(){this._fieldsHelper=r.destroyMaybe(this._fieldsHelper)}_rangeInfosChanged(e){null!=e&&e.length>0&&i.getLogger(this).warn("Unsupported property: rangeInfos are currently only serialized to and from web scenes but do not affect rendering.")}createQuery(){const e={outFields:["*"],returnGeometry:!1,outSpatialReference:this.view.spatialReference};return this.mergedFilter?.createQuery(e)??new c(e)}queryExtent(e,t){return this._ensureQueryEngine().executeQueryForExtent(this._ensureQuery(e),t?.signal)}queryFeatureCount(e,t){return this._ensureQueryEngine().executeQueryForCount(this._ensureQuery(e),t?.signal)}queryFeatures(e,t){return this._ensureQueryEngine().executeQuery(this._ensureQuery(e),t?.signal).then((e=>{if(!e?.features)return e;const t=this.layer;for(const i of e.features)i.layer=t,i.sourceLayer=t;return e}))}queryObjectIds(e,t){return this._ensureQueryEngine().executeQueryForIds(this._ensureQuery(e),t?.signal)}_ensureQueryEngine(){return this._queryEngine||(this._queryEngine=this._createQueryEngine()),this._queryEngine}_createQueryEngine(){const e=f.createGetFeatureExtent(this.view.spatialReference,this.view.renderSpatialReference,this._collection);return new S.I3SQueryEngine({layerView:this,priority:A.TaskPriority.FEATURE_QUERY_ENGINE,spatialIndex:new E.I3SQueryFeatureStore({featureAdapter:new w.I3SQueryFeatureAdapter({objectIdField:this.layer.objectIdField,attributeStorageInfo:this.layer.attributeStorageInfo??[],getFeatureExtent:e}),forAllFeatures:(e,t)=>this._forAllFeatures(((t,i,r)=>e({id:t,index:i,meta:r})),t,g.ForAllFeaturesMode.QUERYABLE),getFeatureExtent:e,sourceSpatialReference:m.getIndexCrs(this.layer),viewSpatialReference:this.view.spatialReference})})}highlight(e,t){const i=this._highlights;if(t??=L.defaultHighlightName,e instanceof c){const{set:r,handle:s}=i.acquireSet(t);return this.queryObjectIds(e).then((e=>i.setFeatureIds(r,e,t))),s}return super.highlight(e,t)}createInteractiveEditSession(e){return F.createInteractiveEditSession(this._attributeEditingContext,e)}_createLayerGraphic(e){return new t({attributes:e,layer:this.layer,sourceLayer:this.layer})}getFilters(){const e=super.getFilters();this.i3sOverrides.is3DOFL&&this.i3sOverrides.sortedGeometryChangedObjectIds.length>0&&e.push(((e,t)=>{t.node.index>=0&&m.objectIdFilter(this.i3sOverrides.sortedGeometryChangedObjectIds,!1,e)}));const t=this._setVisibilityHiddenObjectIdsSorted;null!=t&&e.push((e=>m.objectIdFilter(t,!1,e)));const i=this._excludeObjectIdsSorted;return null!=i&&e.push((e=>m.objectIdFilter(i,!1,e))),this._floorFilterClause&&this.addSqlFilter(e,this._floorFilterClause,this.logError),this.addSqlFilter(e,this.parsedDefinitionExpression,this.logError),null!=this.viewFilter&&this.viewFilter.addFilters(e,this.view,this._controller.crsIndex,this._collection),e}setVisibility(e,t){t?this._setVisibilityHiddenObjectIds.delete(e):this._setVisibilityHiddenObjectIds.add(e)}isUpdating(){return super.isUpdating()||this.layerFilterUpdating||null!=this.viewFilter&&this.viewFilter.updating||null!=this.i3sOverrides&&this.i3sOverrides.updating}_ensureQuery(e){return this._addDefinitionExpressionToQuery(null==e?this.createQuery():c.from(e))}get _attributeEditingContext(){return{sessions:this._interactiveEditingSessions,fieldsIndex:this.layer.fieldsIndex,objectIdField:this._getObjectIdField(),globalIdField:this._getGlobalIdField(),forEachNode:e=>this._forAllNodes((t=>null!=t?e(t.node,t.featureIds):null)),attributeStorageInfo:this.i3slayer.attributeStorageInfo??[],i3sOverrides:this.i3sOverrides,getAttributeData:e=>this.getAttributeData(e),setAttributeData:(e,t)=>this.setAttributeData(e,t),clearMemCache:()=>this.clearMemCache()}}async _handleEdits(e){const t=this._attributeEditingContext,i=await F.normalizeEditResultsEvent(t,e);F.processGeometryEdits(t,i),F.processAttributeEdits(t,i)}get hasGeometryFilter(){const e=this.viewFilter;return null!=e?.parsedGeometry}computeNodeFiltering(e){const t=this.viewFilter;return null==t||!this.view.spatialReference||t.isMBSGeometryVisible(e,this.view.spatialReference,this._controller.crsIndex)?b.NodeFilterImpact.Unmodified:b.NodeFilterImpact.Culled}};e.__decorate([n.property()],P.prototype,"i3slayer",null),e.__decorate([n.property(Q.updatingProgress)],P.prototype,"updatingProgress",void 0),e.__decorate([n.property({type:h})],P.prototype,"filter",null),e.__decorate([n.property({readOnly:!0})],P.prototype,"viewFilter",null),e.__decorate([n.property(D.requiredFields)],P.prototype,"requiredFields",null),e.__decorate([n.property(D.availableFields)],P.prototype,"availableFields",void 0),e.__decorate([n.property()],P.prototype,"_fieldsHelper",void 0),e.__decorate([n.property()],P.prototype,"_floorFilterClause",null),e.__decorate([n.property()],P.prototype,"_excludeObjectIdsSorted",null),e.__decorate([n.property()],P.prototype,"_setVisibilityHiddenObjectIds",void 0),e.__decorate([n.property()],P.prototype,"_setVisibilityHiddenObjectIdsSorted",null),e.__decorate([n.property()],P.prototype,"lodFactor",null),e.__decorate([n.property()],P.prototype,"updatingProgressValue",null),e.__decorate([n.property({readOnly:!0})],P.prototype,"visibleAtCurrentScale",null),P=e.__decorate([o.subclass("esri.views.3d.layers.SceneLayerView3D")],P);return P}));
