/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../chunks/tslib.es6","../../../core/Error","../../../core/reactiveUtils","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/Logger","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","./support/LayerViewPerformanceInfo","../support/updatingProperties","../terrain/terrainUtils","../../support/layerViewUtils"],(function(e,t,a,r,i,l,s,n,o,c,p,h,d){"use strict";const u=e=>{let l=class extends e{constructor(){super(...arguments),this.hasMixedImageFormats=!0}get imageFormatIsOpaque(){return!1}get fullExtent(){return this.layer.fullExtent}get isOpaque(){return this.fullOpacity>=1&&this.imageFormatIsOpaque}get visibleAtCurrentScale(){if(!d.isScaleRangeActive(this.layer.minScale,this.layer.maxScale)||!this.view.scale)return!0;const e=Math.round(this.view.basemapTerrain.tilingScheme.levelAtScale(this.view.scale));return e>=this.displayLevelRange.minLevel&&e<=this.displayLevelRange.maxLevel}get dataScaleRange(){const e=this.tileInfo.lods;let t=e[0].scale,a=e[e.length-1].scale;if("tilemapCache"in this.layer&&this.layer.tilemapCache){const{effectiveMinLOD:e,effectiveMaxLOD:r}=this.layer.tilemapCache;t=this.tileInfo.lodAt(e).scale,a=this.tileInfo.lodAt(r).scale}return{minScale:t,maxScale:a}}canResume(){const e=this.layer&&"effectiveScaleRange"in this.layer?this.layer.effectiveScaleRange:null;return this.visible&&this.layer?.loaded&&!this.parent?.suspended&&this.view?.ready&&d.validateScaleRange(e)&&this.visibleAtCurrentTimeExtent||!1}get dataLevelRange(){const{minScale:e,maxScale:t}=this.dataScaleRange;return this.levelRangeFromScaleRange(e,t)}get displayLevelRange(){const e=this.layer.minScale||this.dataScaleRange.minScale,t=this.layer.maxScale||this.dataScaleRange.maxScale,a=this.levelRangeFromScaleRange(e,t);return this.layer.maxScale&&a.maxLevel++,a}get performanceInfo(){return new c.LayerViewPerformanceInfo(this.view.basemapTerrain.getUsedMemoryForLayerView(this))}getTileUrl(e){return this.layer.getTileUrl(e[0],e[1],e[2])}_addTilingSchemeMatchPromise(){if(null==this.fullExtent)return this.addResolvingPromise(Promise.reject(new a("tilingscheme:extent-not-defined","This layer doesn't define a fullExtent.")));const e=this._getTileInfoSupportError(this.tileInfo,this.fullExtent);if(e)return this.addResolvingPromise(Promise.reject(e));this.addResolvingPromise(r.whenOnce((()=>this.view?.basemapTerrain?.tilingSchemeLocked)).then((()=>{const e=this.view.basemapTerrain.tilingScheme,t="tilemapCache"in this.layer?this.layer.tilemapCache?.effectiveMaxLOD:void 0,a=this._getTileInfoCompatibilityError(this.tileInfo,e,t);if(a)throw a})))}_getTileInfoSupportError(e,t){const r=h.checkIfTileInfoSupportedForView(e,t,this.view.spatialReference,this.view.state.viewingMode,"tilemapCache"in this.layer?this.layer.tilemapCache?.effectiveMaxLOD:void 0);if(!r)return;const i={layer:this.layer,error:r};switch(r.name){case"tilingscheme:spatial-reference-mismatch":case"tilingscheme:global-unsupported-spatial-reference":case"tilingscheme:local-unsupported-spatial-reference":return new a("layerview:spatial-reference-incompatible","The spatial reference of this layer does not meet the requirements of the view",i);default:return new a("layerview:tiling-scheme-unsupported","The tiling scheme of this layer is not supported by SceneView",i)}}_getTileInfoCompatibilityError(e,t,r){return null!=e&&t.compatibleWith(e,r)?null:new a("layerview:tiling-scheme-incompatible","The tiling scheme of this layer is incompatible with the tiling scheme of the surface")}levelRangeFromScaleRange(e,t){const a={minLevel:0,maxLevel:1/0},r=this.view&&this.view.basemapTerrain&&this.view.basemapTerrain.tilingScheme;if(!r)return a;const i=r.levels[0],l=e=>{const t=Math.log(i.scale/e)/Math.LN2;return.5-Math.abs(.5-t%1)<1e-9?Math.round(t):Math.ceil(t)};return null!=e&&e>0&&(a.minLevel=Math.max(0,l(e))),null!=t&&t>0&&(a.maxLevel=Math.max(0,l(t))),a}isUpdating(){return!!(this.view&&this.view.basemapTerrain&&this.view.basemapTerrain.updating)}};return t.__decorate([i.property({readOnly:!0})],l.prototype,"imageFormatIsOpaque",null),t.__decorate([i.property({readOnly:!0})],l.prototype,"updating",void 0),t.__decorate([i.property(p.updatingProgress)],l.prototype,"updatingProgress",void 0),t.__decorate([i.property(p.updatingProgressValue)],l.prototype,"updatingProgressValue",void 0),t.__decorate([i.property()],l.prototype,"hasMixedImageFormats",void 0),t.__decorate([i.property()],l.prototype,"fullExtent",null),t.__decorate([i.property({readOnly:!0})],l.prototype,"isOpaque",null),t.__decorate([i.property({readOnly:!0})],l.prototype,"visibleAtCurrentScale",null),t.__decorate([i.property()],l.prototype,"dataScaleRange",null),t.__decorate([i.property({readOnly:!0})],l.prototype,"dataLevelRange",null),t.__decorate([i.property({readOnly:!0})],l.prototype,"displayLevelRange",null),t.__decorate([i.property()],l.prototype,"layer",void 0),l=t.__decorate([o.subclass("esri.views.3d.layers.TiledLayerView3D")],l),l};e.TiledLayerView3D=u,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
