/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../core/Error","../../../core/has","../../../core/maybe","../../../core/promiseUtils","../../../core/reactiveUtils","../../../core/accessorSupport/decorators/property","../../../core/Logger","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../2d/engine/vectorTiles/SchemaHelper","../../2d/engine/vectorTiles/TileHandler3D","../../2d/engine/vectorTiles/VTLPainter3D","../../2d/engine/vectorTiles/style/StyleRepository","./LayerView3D","./TiledLayerView3D","../terrain/terrainUtils","../../layers/LayerView"],(function(e,t,i,l,r,a,s,n,o,h,c,d,y,p,m,g,u,v){"use strict";let _=class extends(g.TiledLayerView3D(m.LayerView3D(v))){constructor(){super(...arguments),this._tileHandlerController=null,this.type="vector-tile-3d",this.levelShift=i("disable-feature:vtl-level-shift")?0:1}initialize(){if(null==this.layer.fullExtent)return void this.addResolvingPromise(Promise.reject(new t("vectortilelayerview:full-extent-undefined","This layer view's layer does not define a fullExtent.")));const{basemapTerrain:e,spatialReference:i,state:l,viewingMode:s}=this.view,n="local"===s&&!u.vtlAssumes256PixelSizeAsDefault(i)||u.test.force512VTL?this.layer.tileInfo:this.layer.tileInfo.getCompatibleForVTL(256),o=this._getTileInfoSupportError(n,this.layer.fullExtent);if(null!=o)return this.addResolvingPromise(Promise.reject(o));const h=a.whenOnce((()=>this.view?.basemapTerrain?.tilingSchemeLocked)).then((()=>{const t=e.tilingScheme,i=t.pixelSize,l=256===i?1:2,r=e.spatialReference?.isGeographic&&256===i?1:0,a=e.spatialReference?.isGeographic||256!==i?0:1;let s;this.schemaHelper=new c.SchemaHelper(l,r,this.levelShift+a),s=256===i||512===i?this.layer.tileInfo.getCompatibleForVTL(i):this.layer.tileInfo;const n=this._getTileInfoCompatibilityError(s,t);if(n)throw n;this.tileInfo=s}));this._tileHandlerController=new AbortController;const m=this.view.resourceController;this._memCache=m.memoryController.newCache(`vtl-${this.layer.uid}`,(e=>e.release())),this.addHandles(a.watch((()=>this.view.qualitySettings.memoryLimit),(e=>this._memCache.maxSize=Math.ceil(e/10*1048576)),a.syncAndInitial));const g=new p(this.layer.currentStyleInfo.style);this._tileHandler=new d(this.layer,g,l.contentPixelRatio,this._memCache);const v=this._tileHandlerController.signal,_=f(m),S=this._tileHandler.start({signal:v,schedule:_}),w=this._tileHandler.spriteMosaic;w.then((e=>{!r.isAborted(v)&&this._tileHandler&&(this.painter=new y(e,this._tileHandler.glyphMosaic))})),S.then((()=>this._tileHandlerController=null));const H=()=>{this._tileHandlerController&&this._tileHandlerController.abort(),this._tileHandlerController=new AbortController,this._memCache.clear();const e=this.layer.currentStyleInfo.style,t=this.view.state?.contentPixelRatio??1,i=new p(e),l=new d(this.layer,i,t,this._memCache),r=l.start({signal:this._tileHandlerController.signal,schedule:_}),a=l.spriteMosaic;r.then((()=>this._tileHandlerController=null)),this._updatingHandles.addPromise(Promise.all([r,a]).then((([,e])=>{const t=this._tileHandler,i=this.painter;this.painter=new y(e,l.glyphMosaic),this._tileHandler=l,this.emit("data-changed"),t.destroy(),i&&i.dispose()})))};this._updatingHandles.add((()=>({style:this.layer.currentStyleInfo.style,pixelRatio:this.view.state?.contentPixelRatio})),H),this.addHandles([this.layer.on("paint-change",(()=>this.emit("data-changed"))),this.layer.on("style-layer-change",H),this.layer.on("delete-style-layer",H),this.layer.on("spriteSource-change",(()=>this.emit("data-changed"))),this.layer.on("layout-change",(()=>this.emit("data-changed"))),this.layer.on("style-layer-visibility-change",(()=>this.emit("data-changed")))]);const C=Promise.all([h,S,w]);this.addResolvingPromise(C)}destroy(){this.painter=l.disposeMaybe(this.painter),this._tileHandlerController=l.abortMaybe(this._tileHandlerController),this._tileHandler=l.destroyMaybe(this._tileHandler),this._memCache=l.destroyMaybe(this._memCache)}get contentZoom(){return i("disable-feature:vtl-level-shift")?1:this.view.qualitySettings.tiledSurface.vtlContentZoom}get displayLevelRange(){const e=this.tileInfo.lods,t=this.layer.minScale||e[0].scale,i=this.layer.maxScale||e[e.length-1].scale,l=this.levelRangeFromScaleRange(t,i);return this.layer.maxScale?l.maxLevel++:l.maxLevel+=this.levelShift,l}get dataScaleRange(){const e=this.tileInfo.lods;return{minScale:e[0].scale,maxScale:e[e.length-1].scale}}get dataLevelRange(){const{minScale:e,maxScale:t}=this.dataScaleRange,i=this.levelRangeFromScaleRange(e,t);return 1===i.minLevel&&256===this.tileInfo.size[0]&&(i.minLevel=0),i.maxLevel+=this.levelShift,i}async fetchTile(e,t){const i=this.schemaHelper.getLevelRowColumn(e);return this._tileHandler.getVectorTile(i,t)}};e.__decorate([s.property()],_.prototype,"layer",void 0),e.__decorate([s.property()],_.prototype,"levelShift",void 0),e.__decorate([s.property()],_.prototype,"contentZoom",null),e.__decorate([s.property()],_.prototype,"displayLevelRange",null),e.__decorate([s.property()],_.prototype,"tileInfo",void 0),e.__decorate([s.property()],_.prototype,"dataScaleRange",null),e.__decorate([s.property()],_.prototype,"dataLevelRange",null),e.__decorate([s.property()],_.prototype,"updatingProgressValue",void 0),_=e.__decorate([h.subclass("esri.views.3d.layers.VectorTileLayerView3D")],_);function f(e){return t=>e.immediate.schedule(t)}return _}));
