/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../geometry","../../../core/Error","../../../core/Logger","../../../core/reactiveUtils","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../../chunks/vec32","../../../core/libs/gl-matrix-2/factories/vec3f64","../../../geometry/projection/projectVectorToVector","../../../geometry/support/aaBoundingBox","../../../geometry/support/spatialReferenceUtils","./LayerView3D","./VoxelGraphic","./VoxelWasm","./support/LayerViewPerformanceInfo","./support/PopupSceneLayerView","../../layers/LayerView","../../support/layerViewUtils","../../../geometry/SpatialReference"],(function(e,s,t,a,i,r,o,l,n,h,c,d,u,y,m,p,V,w,b,g,_,W){"use strict";var S;!function(e){e[e.API=1]="API",e[e.VerboseAPI=2]="VerboseAPI",e[e.Error=3]="Error"}(S||(S={}));const v=c.create(),f=c.create();let x=class extends(b.PopupSceneLayerView(m.LayerView3D(g))){constructor(){super(...arguments),this._suspendedHandle=null,this._usedMemory=0,this._futureMemory=0,this.type="voxel-3d",this.slicePlaneEnabled=!1,this._wasmLayerId=-1,this.ignoresMemoryFactor=!0,this._dbgFlags=new Set}get baseUrl(){return this.layer.parsedUrl?.path??""}get wasmLayerId(){return this._wasmLayerId}initialize(){if(this._dbgFlags.add(S.Error),"local"!==this.view.viewingMode)throw new t("voxel:unsupported-viewingMode","Voxel layers support local viewingMode only.",{});if(!!!this.view._stage.renderView.renderingContext.capabilities.colorBufferFloat?.textureFloat)throw new t("voxel:missing-color-buffer-float","Voxel layers require the WebGL2 extension EXT_color_buffer_float",{});const e=this.layer.spatialReference;if(!y.equals(e,this.view.spatialReference))throw _.spatialReferenceIncompatibleError("voxel layer",e.wkid,this.view.spatialReference.wkid);const s=this.layer.currentVariableId,a=this.layer.getVolume(s),r=this.layer.getVariable(s);if(null!=a&&null!=r){const e=a.dimensions[0],s=a.dimensions[1],t=a.zDimension;if(t>1){const i=a.dimensions[t],o=e.size*s.size*i.size;let l=1;switch(r.renderingFormat.type){case"Int16":case"UInt16":l=2;break;case"Int32":case"UInt32":case"Float32":l=4}this._futureMemory=l*o}}const o=V.addLayerViewToWasm(this).then((e=>{this._wasmLayerId=e,this._suspendedHandle=i.watch((()=>this.suspended),(e=>{const s=V.getVoxelWasm(this.view);s&&s.setEnabled(this,!e)}),i.initial),this.addHandles([i.watch((()=>this.layer.renderMode),(e=>this._pushRenderModeToWasm(e))),i.watch((()=>this.layer.currentVariableId),(e=>this._pushCurrentVariableIdToWasm(e))),i.watch((()=>this.layer.getSections()),(e=>this._pushSectionsToWasm(e))),i.watch((()=>this.layer.getVariableStyles()),(e=>this._pushVariableStylesToWasm(e))),i.watch((()=>this.layer.getVolumeStyles()),(e=>this._pushVolumeStylesToWasm(e))),i.watch((()=>this.layer.enableDynamicSections),(e=>this._pushEnableDynamicSectionsToWasm(e))),i.watch((()=>this.layer.enableIsosurfaces),(e=>this._pushEnableIsosurfacesToWasm(e))),i.watch((()=>this.layer.enableSections),(e=>this._pushEnableSectionsToWasm(e))),i.watch((()=>this.layer.enableSlices),(e=>this._pushEnableSlicesToWasm(e))),i.watch((()=>[this.layer.timeOffset,this.layer.timeExtent,this.layer.useViewTime]),(()=>this._updateLayerTimeProperties())),i.watch((()=>this.slicePlaneEnabled),(e=>this._pushAnalysisSliceToWasm(e,this.view.slicePlane))),i.watch((()=>this.view.slicePlane),(e=>this._pushAnalysisSliceToWasm(this.slicePlaneEnabled,e)))])})).catch((e=>{if(V.removeLayerViewFromWasm(this),this._wasmLayerId=-1,-1===e)throw new t("voxel:addLayer-failure","The voxel layer description was invalid.",{});if(-2===e)throw new t("voxel:addLayer-failure","The voxel layer web assembly module failed to download.",{})}));this.addResolvingPromise(o)}destroy(){V.removeLayerViewFromWasm(this),this._suspendedHandle&&(this._suspendedHandle.remove(),this._suspendedHandle=null)}isUpdating(){const e=V.getVoxelWasm(this.view);return!(this._wasmLayerId<0||null==e)&&e.isUpdating(this._wasmLayerId)}updatingFlagChanged(){this.notifyChange("updating")}get usedMemory(){return this._usedMemory}get unloadedMemory(){return this._futureMemory}get performanceInfo(){return new w.LayerViewPerformanceInfo(this.usedMemory)}get visibleAtCurrentScale(){return _.isInEffectiveScaleRange(this.layer.effectiveScaleRange,this.view.scale)}whenGraphicBounds(e,s){const t=e.attributes["Voxel.WorldPosition"];if(t){const e=u.empty(),s=JSON.parse(t);if(d.projectVectorToVector(s,this.view.renderSpatialReference,f,this.view.spatialReference||W.WGS84))return u.expandWithVec3(e,f),Promise.resolve({boundingBox:e,screenSpaceObjects:[]})}return Promise.reject()}async whenGraphicAttributes(e,s){const t=V.getVoxelWasm(this.view);if(!t)return e;const a=[];for(const i of e)this._isValidVoxelGraphic(i)&&a.push(i);return a.length&&await t.getOtherFieldPopupValues(a,s),e}_isValidVoxelGraphic(e){return e instanceof p.VoxelGraphic}setUsedMemory(e){this._usedMemory=e,this._futureMemory=0}captureFrustum(){const e=V.getVoxelWasm(this.view);e?.captureFrustum()}toggleFullVolumeExtentDraw(){const e=V.getVoxelWasm(this.view);e?.toggleFullVolumeExtentDraw(this)}getLayerTimes(){const e=V.getVoxelWasm(this.view);return e?.getLayerTimes(this)??[]}getCurrentLayerTimeIndex(){const e=V.getVoxelWasm(this.view);return e?.getCurrentLayerTimeIndex(this)??0}dropQueryRenderTarget(){const e=V.getVoxelWasm(this.view);e?.dropQueryRenderTarget()}_pushRenderModeToWasm(e){const s=V.getVoxelWasm(this.view);this._dbg(S.VerboseAPI,"VoxelLayerView3D._pushRenderModeToWasm() called, "+(s?"have WASM":"don't have WASM!!!")),s?.setRenderMode(this,e)||this._dbg(S.Error,"VoxelLayerView3D._pushRenderModeToWasm() failed!")}_pushSectionsToWasm(e){const s=V.getVoxelWasm(this.view);this._dbg(S.VerboseAPI,"VoxelLayerView3D._pushSectionsToWasm() called, "+(s?"have WASM":"don't have WASM!!!")),s?.setStaticSections(this,e)||this._dbg(S.Error,"VoxelLayerView3D._pushSectionsToWasm() failed!")}_pushCurrentVariableIdToWasm(e){const s=V.getVoxelWasm(this.view);this._dbg(S.VerboseAPI,"VoxelLayerView3D._pushCurrentVariableIdToWasm() called!, "+(s?"have WASM":"don't have WASM!!!")),s?.setCurrentVariable(this,e)||this._dbg(S.Error,"VoxelLayerView3D._pushCurrentVariableIdToWasm() failed!")}_pushVariableStylesToWasm(e){const s=V.getVoxelWasm(this.view);this._dbg(S.VerboseAPI,"VoxelLayerView3D._pushVariableStylesToWasm() called, "+(s?"have WASM":"don't have WASM!!!")),s?.setVariableStyles(this,e)||this._dbg(S.Error,"VoxelLayerView3D._pushVariableStylesToWasm() failed!")}_accountForEnableSlices(e,s){const t=null!=s?s:this.layer.enableSlices;for(let a=0;a<e.length;++a){const s=e[a];for(const e of s.slices)e.enabled=e.enabled&&t}}_pushVolumeStylesToWasm(e){const s=V.getVoxelWasm(this.view);this._dbg(S.VerboseAPI,"VoxelLayerView3D._pushVolumeStylesToWasm() called, "+(s?"have WASM":"don't have WASM!!!")),s&&(this._accountForEnableSlices(e,null),s.setVolumeStyles(this,e)||this._dbg(S.Error,"VoxelLayerView3D._pushVolumeStylesToWasm() failed!"))}_pushAnalysisSliceToWasm(e,s){const t=V.getVoxelWasm(this.view);this._dbg(S.VerboseAPI,"VoxelLayerView3D._pushAnalysisSliceToWasm() called, "+(t?"have WASM":"don't have WASM!!!"));let a=!1;if(t){if(s){const i=s.origin;h.cross(v,s.basis1,s.basis2),h.normalize(v,v),a=t.setAnalysisSlice(this,e,i,v)}else h.set(v,0,0,1),a=t.setAnalysisSlice(this,!1,v,v);a||this._dbg(S.Error,"VoxelLayerView3D._pushAnalysisSliceToWasm() failed!")}}_updateLayerTimeProperties(){const e=V.getVoxelWasm(this.view);this._dbg(S.VerboseAPI,"VoxelLayerView3D._updateLayerTimeProperties() called, "+(e?"have WASM":"don't have WASM!!!")),e&&e.updateLayerTimeProperties(this)}_pushEnableDynamicSectionsToWasm(e){const s=V.getVoxelWasm(this.view);this._dbg(S.VerboseAPI,"VoxelLayerView3D._pushEnableDynamicSectionsToWasm() called, "+(s?"have WASM":"don't have WASM!!!")),s?.setEnableDynamicSections(this,e)||this._dbg(S.Error,"VoxelLayerView3D._pushEnableDynamicSectionsToWasm() failed!")}_pushEnableSlicesToWasm(e){const s=V.getVoxelWasm(this.view);if(this._dbg(S.VerboseAPI,"VoxelLayerView3D._pushEnableSlicesToWasm() called, "+(s?"have WASM":"don't have WASM!!!")),s){const t=this.layer.getVolumeStyles();this._accountForEnableSlices(t,e),s.setVolumeStyles(this,t)||this._dbg(S.Error,"VoxelLayerView3D._pushEnableSlicesToWasm() failed!")}}_pushEnableIsosurfacesToWasm(e){const s=V.getVoxelWasm(this.view);this._dbg(S.VerboseAPI,"VoxelLayerView3D._pushEnableIsosurfacesToWasm() called, "+(s?"have WASM":"don't have WASM!!!")),s?.setEnableIsosurfaces(this,e)||this._dbg(S.Error,"VoxelLayerView3D._pushEnableIsosurfacesToWasm() failed!")}_pushEnableSectionsToWasm(e){const s=V.getVoxelWasm(this.view);this._dbg(S.VerboseAPI,"VoxelLayerView3D._pushEnableSectionsToWasm() called, "+(s?"have WASM":"don't have WASM!!!")),s?.setEnableSections(this,e)||this._dbg(S.Error,"VoxelLayerView3D._pushEnableSectionsToWasm() failed!")}_dbg(e,s){this._dbgFlags.has(e)&&(e===S.Error?a.getLogger(this).error(s):a.getLogger(this).warn(s))}};e.__decorate([r.property()],x.prototype,"layer",void 0),e.__decorate([r.property()],x.prototype,"baseUrl",null),e.__decorate([r.property({type:Boolean})],x.prototype,"slicePlaneEnabled",void 0),e.__decorate([r.property({readOnly:!0})],x.prototype,"visibleAtCurrentScale",null),x=e.__decorate([n.subclass("esri.views.3d.layers.VoxelLayerView3D")],x);return x}));
