/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../chunks/tslib.es6","../../../../core/maybe","../../../../core/reactiveUtils","../../../../core/accessorSupport/decorators/property","../../../../core/has","../../../../core/Logger","../../../../core/RandomLCG","../../../../core/accessorSupport/decorators/subclass","../../../../layers/graphics/hydratedFeatures","../../../../layers/graphics/controllers/FeatureTileController3D","../FeatureLayerViewPerformanceInfo","./Graphics3DGraphicsPipeline","../support/FeatureTileFetcher3DContext","../../support/EventedSet","../../webgl-engine/lib/UpdatePolicy"],(function(e,r,t,s,o,i,a,n,c,l,p,u,h,d,m,y){"use strict";e.FeatureGraphics3DGraphicsPipeline=class extends h.Graphics3DGraphicsPipeline{constructor(e){super(e),this._controllerTotal=0,this._processorTotal=0,this._needsRefresh=!1,this.suspendResumeExtentMode="data"}initialize(){this.addHandles(s.watch((()=>({controller:this.controller,suspended:this.suspended})),(({controller:e,suspended:r})=>{e&&!r&&this._needsRefresh&&(e.refetch(),this._needsRefresh=!1)})))}destroy(){this._fetcherContext=t.destroyMaybe(this._fetcherContext)}get maximumNumberOfFeatures(){return this.controller?.maximumNumberOfFeatures??this._get("maximumNumberOfFeatures")}set maximumNumberOfFeatures(e){this._set("maximumNumberOfFeatures",e),this.controller&&(this.controller.maximumNumberOfFeatures=e)}get maximumNumberOfFeaturesExceeded(){return!!this.controller&&!(this.suspended||!this.controller.maximumNumberOfFeaturesExceeded)}get updatingProgressValue(){let e=0;if(this.controller?.updating){const r=this.controller.updatingRemaining,t=Math.max(this.controller.updatingTotal,this._controllerTotal);t>0&&(e=(t-r)/t,this._controllerTotal=t)}let r=0;if(this.processor?.updating){const e=this.processor.updatingRemaining,t=Math.max(e,this._processorTotal);t>0&&(r=(t-e)/t,this._processorTotal=t)}return.5*(e+r)}get updatePolicy(){if(!this.controller)return y.UpdatePolicy.ASYNC;switch(this.controller.mode){case"snapshot":{const e=F.get(this.layer.geometryType);return null==e||this.controller.serviceDataCount>e?y.UpdatePolicy.ASYNC:y.UpdatePolicy.SYNC}case"tiles":return y.UpdatePolicy.ASYNC}}get usedMemory(){return(this.processor?.usedMemory??0)+(this.controller?.memoryForUnusedFeatures??0)}get unloadedMemory(){const e=this.processor?.unprocessedMemoryEstimate??0,r=this.controller?.expectedFeatureDiff??0,t=this.processor?.loadedFeatures??0,s=t+r>0?t/(t+r):1;return e+r*(this.processor?.usedMemoryPerFeature??0)*s}get ignoresMemoryFactor(){return this.controller?.hasMaximumNumberOfFeaturesOverride}get performanceInfo(){const e=this.controller?.displayFeatureLimit,r=null!=e?e.averageSymbolComplexity:void 0,t=null!=r?`f:${r.verticesPerFeature},v:${r.verticesPerCoordinate}`:"n/a";return new u.FeatureLayerViewPerformanceInfo(super.performanceInfo,this.controller?.performanceInfo?.storedFeatures??0,this.controller?.performanceInfo?.totalVertices??0,this.maximumNumberOfFeaturesExceeded,this.controller?.mode??"n/a",t)}async doRefresh(e){const{controller:r,processor:t,suspended:s}=this;e&&r&&(s?this._needsRefresh=!0:(r.refetch(),this._needsRefresh=!1)),t.refreshFilter()}setVisibility(e,r){this.processor?.setObjectIdVisibility(e,r)}getMissingAttributesForFeature(e){return this.controller.getMissingAttributesForFeature(e)}getHydratedGeometry(e){const r=this.graphics3DProcessor;if(null==r)return null;const t=r.graphics3DGraphicsByObjectID;if(null==t)return null;const s=t.get(e);return null==s?null:l.hydrateGeometry(s.graphic.geometry)}createController(){this._fetcherContext=new d.FeatureTileFetcher3DContext({layerView:this.layerView,returnZ:this.hasZ,returnM:this.hasM});const e=new p.FeatureTileController3D({layerView:this.layerView,context:this._fetcherContext,graphics:new m.EventedSet,extent:this.clippingExtent});return this.updatingHandles.add((()=>e.serviceDataExtent),(e=>{this.processor&&(this.processor.dataExtent=e)}),s.initial),this.addHandles(s.watch((()=>this.suspended&&this.layerView.updateSuspended),(r=>{r?e.suspend():e.resume()}),s.syncAndInitial)),this.updatingHandles.add((()=>this.processor?.displayFeatureLimit),(r=>e.displayFeatureLimit=r),s.initial),this.addHandles(s.when((()=>!this.updating),(()=>{this._controllerTotal=0,this._processorTotal=0}))),e}beforeSetController(e){e.maximumNumberOfFeatures=this.maximumNumberOfFeatures}get test(){return{controller:this.controller,graphics3DProcessor:this.graphics3DProcessor,heatmapProcessor:this.heatmapProcessor,loadedGraphics:this.loadedGraphics}}},r.__decorate([o.property()],e.FeatureGraphics3DGraphicsPipeline.prototype,"layerView",void 0),r.__decorate([o.property()],e.FeatureGraphics3DGraphicsPipeline.prototype,"controller",void 0),r.__decorate([o.property()],e.FeatureGraphics3DGraphicsPipeline.prototype,"_controllerTotal",void 0),r.__decorate([o.property()],e.FeatureGraphics3DGraphicsPipeline.prototype,"_processorTotal",void 0),r.__decorate([o.property()],e.FeatureGraphics3DGraphicsPipeline.prototype,"_needsRefresh",void 0),r.__decorate([o.property()],e.FeatureGraphics3DGraphicsPipeline.prototype,"maximumNumberOfFeatures",null),r.__decorate([o.property()],e.FeatureGraphics3DGraphicsPipeline.prototype,"maximumNumberOfFeaturesExceeded",null),r.__decorate([o.property()],e.FeatureGraphics3DGraphicsPipeline.prototype,"updatingProgressValue",null),r.__decorate([o.property()],e.FeatureGraphics3DGraphicsPipeline.prototype,"updatePolicy",null),r.__decorate([o.property()],e.FeatureGraphics3DGraphicsPipeline.prototype,"suspendResumeExtentMode",void 0),e.FeatureGraphics3DGraphicsPipeline=r.__decorate([c.subclass("esri.views.3d.layers.graphics.FeatureGraphics3DGraphicsPipeline")],e.FeatureGraphics3DGraphicsPipeline);const F=new Map([["point",5e3],["polygon",500],["polyline",1e3]]);Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
