/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../core/arrayUtils","../../../../core/asyncUtils","../../../../core/byteSizeEstimations","../../../../core/has","../../../../core/ObjectPool","../../../../core/libs/gl-matrix-2/math/vec2","../../../../core/libs/gl-matrix-2/factories/vec2f64","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../geometry/Polygon","../../../../geometry/projection/projectBoundingRect","../../../../geometry/support/aaBoundingBox","../../../../geometry/support/aaBoundingRect","../../../../geometry/support/spatialReferenceUtils","../../../../layers/graphics/dehydratedFeatures","../../../../layers/graphics/featureConversionUtils","./enums","./featureExpressionInfoUtils"],(function(e,i,t,r,s,a,o,l,n,c,h,y,u,p,b,d,g,m,_){"use strict";const L=new a(Array,(e=>u.set(e,u.zero)),null,10,5),f=p.create();class E{get labelLayers(){return this._labelLayers||i.emptyArray}get extent(){return this._extent}get isElevationSource(){return this.layers.some((e=>e?.isElevationSource))}constructor(e,i,t,r,s){this.graphic=e,this.graphics3DSymbol=i,this.layers=t,this._visibleFlags=m.VisibilityFlag.ALL_LABEL,this.deconflictionPriority=0,++i.referenced,this._featureExpressionFeature=s?_.createFeature(s,e,r):null}initialize(e){this._layer=e,this._forEachSymbolLayerGraphic((i=>{i.initialize(e),i.setVisibility(this.isVisible())}))}destroy(){this._forEachSymbolLayerGraphic((e=>e.destroy())),this._calloutLayer=null,--this.graphics3DSymbol.referenced,this.graphics3DSymbol=null}get destroyed(){return null==this.layers}clearLabelGraphics(){this._forEachLabelGraphic((e=>e.destroy())),this._labelLayers=null}addLabelGraphic(e,i){this._labelLayers||(this._labelLayers=new Array),this._labelLayers.push(e),e.initialize(i),e.setVisibility(this.isVisible(m.VisibilityGroup.LABEL))}setCalloutGraphic(e){this._calloutLayer=e,this._layer&&(e.initialize(this._layer),e.setVisibility(this.isVisible()))}get calloutLayer(){return this._calloutLayer}get isDraped(){let e=!1;return this._forEachSymbolLayerGraphic((i=>{"draped"===i.type&&(e=!0)})),e}isVisible(e=m.VisibilityGroup.GRAPHIC,i){const t=i?this._visibleFlags|i|m.VisibilityGroup.LABEL*i:this._visibleFlags;return e===m.VisibilityGroup.GRAPHIC?(t&m.VisibilityFlag.ALL_GRAPHIC)===m.VisibilityFlag.ALL_GRAPHIC:(t&m.VisibilityFlag.ALL_LABEL)===m.VisibilityFlag.ALL_LABEL}setVisibilityFlag(e,i,t){const r=this.isVisible(e);t?this._visibleFlags|=e*i:this._visibleFlags&=~(e*i);const s=this.isVisible(e);if(r===s)return!1;if(e===m.VisibilityGroup.LABEL)this._forEachLabelGraphic((e=>e.setVisibility(s)));else{this._forEachSymbolLayerGraphic((e=>e.setVisibility(s)));const e=this.isVisible(m.VisibilityGroup.LABEL);this._forEachLabelGraphic((i=>i.setVisibility(e)))}return!0}getVisibilityFlag(e,i){return!!(this._visibleFlags&e*i)}computeExtent(e){if(!this._extent){const i=this.graphic.geometry;if(null==i)return!1;this._extent=p.create(),d.computeAABR(i,this._extent);const t=i.spatialReference;if(!b.equals(t,e)&&!y.projectBoundingRect(this._extent,t,this._extent,e))return this._extent=null,!1}return!0}getAsOptimizedGeometry(e,i){return this._optimizedGeometry||(this._optimizedGeometry=this._convertGraphicToOptimizedGeometry(this.graphic,e,i)),this._optimizedGeometry}_convertGraphicToOptimizedGeometry(e,i,t){let r=e.geometry;return"mesh"!==r.type&&"extent"!==r.type||(r=h.fromExtent("mesh"===r.type?r.extent:r)),g.convertFromGeometry(r,i,t)}get usedMemory(){let e=r.estimateAttributesObjectSize(this.graphic.attributes);return this._forEachSymbolLayerGraphic((i=>e+=i.graphics3DSymbolLayer.usedMemory)),e}computeAttachmentOrigin(){const e={render:{origin:c.create(),num:0},draped:{origin:l.create(),num:0}};for(const i of this.layers)null!=i&&i.computeAttachmentOrigin(e);return e.render.num>1&&n.scale(e.render.origin,e.render.origin,1/e.render.num),e.draped.num>1&&o.scale(e.draped.origin,e.draped.origin,1/e.draped.num),e}async getProjectedBoundingBox(e,i,r,s,a){return a||(a={boundingBox:null,requiresDrapedElevation:!1,screenSpaceObjects:[]}),a.boundingBox?u.empty(a.boundingBox):a.boundingBox=u.empty(),a.requiresDrapedElevation=!1,await t.forEach(this.layers,(async t=>{if(null==t)return;const o="draped"===t.type?i:e,l=L.acquire(),n=await t.getProjectedBoundingBox(o,r,a.screenSpaceObjects,s,l);isFinite(n[2])&&isFinite(n[5])||(a.requiresDrapedElevation=!0),n&&u.expandWithAABB(a.boundingBox,l),L.release(l)})),u.allFinite(a.boundingBox)||p.allFinite(u.toRect(a.boundingBox,f))?a:null}needsElevationUpdates(){for(const e of this.layers)if(null!=e&&("object3d"===e.type||"lod-instance"===e.type)&&e.needsElevationUpdates)return!0;return this._labelLayers?.some((e=>e?.needsElevationUpdates??!1))??!1}alignWithElevation(e,i,t){this._forEachRenderedGraphic((r=>{"object3d"!==r.type&&"lod-instance"!==r.type||r.alignWithElevation(e,i,this._featureExpressionFeature,t)}))}alignWithAbsoluteElevation(e,i,t){this._forEachRenderedGraphic((r=>{"object3d"===r.type&&r.alignWithAbsoluteElevation(e,i,t)}))}addObjectStateSet(e){this._forEachSymbolLayerGraphic((i=>i.addObjectState(e)))}removeObjectState(e){this._forEachSymbolLayerGraphic((i=>i.removeObjectState(e)))}_forEachGraphicList(e,i){e?.forEach((e=>e&&i(e)))}_forEachSymbolLayerGraphic(e){this._forEachGraphicList(this.layers,e),this._calloutLayer&&e(this._calloutLayer)}_forEachLabelGraphic(e){this._forEachGraphicList(this._labelLayers,e)}_forEachRenderedGraphic(e){this._forEachSymbolLayerGraphic(e),this._forEachLabelGraphic(e)}get test(){}}e.Graphics3DGraphic=E,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
