/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../Color","../../../../core/has","../../../../core/mathUtils","../../../../core/libs/gl-matrix-2/math/mat3","../../../../core/libs/gl-matrix-2/factories/mat3f64","../../../../core/libs/gl-matrix-2/math/mat4","../../../../core/libs/gl-matrix-2/factories/mat4f64","../../../../core/libs/gl-matrix-2/factories/vec2f64","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../core/libs/gl-matrix-2/factories/vec4f64","../../../../geometry/projection","../../../../geometry/projection/computeTranslationToOriginAndRotation","../../../../geometry/projection/projectBuffer","../../../../geometry/projection/projectVectorToPoint","../../../../geometry/support/aaBoundingBox","../../../../geometry/support/FloatArray","../../../../geometry/support/Indices","../../../../geometry/support/MeshComponent","../../../../geometry/support/MeshMaterialMetallicRoughness","../../../../geometry/support/MeshTextureTransform","../../../../geometry/support/meshVertexSpaceUtils","../../../../geometry/support/spatialReferenceUtils","../../../../chunks/vec3","../../../../geometry/support/meshUtils/projection","../../../../geometry/support/meshUtils/projectMeshVertexPositions","../../../../layers/graphics/dehydratedPoint","../../../../layers/graphics/sources/interfaces","../../../ViewingMode","../../glTF/internal/resourceUtils","../../glTF/internal/TextureTransformUtils","./ElevationAligners","./elevationAlignmentUtils","./Graphics3DMeshObject3DGraphicLayer","./Graphics3DObject3DGraphicLayer","./Graphics3DSymbolLayer","./MeshFastUpdateProcessor","../support/edgeUtils","../support/symbolColorUtils","../../support/debugFlags","../../webgl-engine/lib/Attribute","../../webgl-engine/lib/basicInterfaces","../../webgl-engine/lib/ContentObjectType","../../webgl-engine/lib/Geometry","../../webgl-engine/lib/Object3D","../../webgl-engine/lib/Texture","../../webgl-engine/lib/VertexAttribute","../../webgl-engine/materials/DefaultMaterial","../../webgl-engine/materials/NativeLineMaterial","../../webgl-engine/materials/pbrUtils","../../../webgl/enums"],(function(e,t,r,a,n,o,s,i,l,c,u,h,m,f,p,d,g,x,T,b,_,y,M,A,v,w,R,C,P,O,E,N,I,S,F,U,V,j,D,B,G,L,$,H,k,q,z,W,Y,Z,J,K){"use strict";const Q=["mesh"];class X extends V.Graphics3DSymbolLayer{constructor(e,t,r,a){super(e,t,r,a),this._materialInfoCache=new j.MaterialInfoCache,this._fastUpdateProcessor=new j.MeshFastUpdateProcessor,this._textures=new Map,this.ensureDrapedStatus(!1)}async doLoad(){G.debugFlags.DRAW_MESH_GEOMETRY_NORMALS&&(this._debugVertexNormalMaterial=new Z.NativeLineMaterial({color:[1,0,1,1]}),this._debugTangentNormalMaterial=new Z.NativeLineMaterial({color:[1,.5,0,1]}),this._debugFaceNormalMaterial=new Z.NativeLineMaterial({color:[0,1,1,1]}))}destroy(){super.destroy(),this._textures.forEach((e=>e.unload())),this._context.stage.removeMany(this._materialInfoCache.materials),this._context.stage.removeMany(Array.from(this._textures.values())),this._materialInfoCache.clear(),this._textures.clear(),this._fastUpdateProcessor.destroy(this._context.stage)}get materials(){return this._materialInfoCache.materials}createGraphics3DGraphic(e){const t=e.graphic;if(!this._validateGeometry(t.geometry,Q,"fill on mesh-3d"))return null;const r=this.setGraphicElevationContext(t),a=e.renderingInfo;return this._createAs3DShape(t,a,r,t.uid)}onRemoveGraphic(e){this._fastUpdateProcessor.onRemoveGraphic(e,this._materialInfoCache,this._context)}layerOpacityChanged(e,t){const r=this._getLayerOpacity();this._updateMaterialParameters((e=>{e.material.setParameters({layerOpacity:r});const t=e.material.parameters;this._setMaterialTransparentParameter(t,e),e.material.setParameters({transparent:t.transparent})})),e.forEach((e=>t(e)?.layerOpacityChanged(r,this._context.isAsync)))}layerElevationInfoChanged(e,t){return this.updateGraphics3DGraphicElevationInfo(e,t,S.needsElevationUpdates3D)}slicePlaneEnabledChanged(e,t){return this._updateMaterialParameters((({material:e})=>{e.setParameters({hasSlicePlane:this._context.slicePlaneEnabled})})),e.forEach((e=>t(e)?.slicePlaneEnabledChanged(this._context.slicePlaneEnabled,this._context.isAsync))),!0}physicalBasedRenderingChanged(){const e=this._usePBR();return this._updateMaterialParameters((({material:t})=>t.setParameters({usePBR:e}))),!0}updateTransform(e,t,r,a){if(!e.fastTransformUpdatesAllowed)return!1;const n=e.fastTransformUpdatesEnabled;switch(a){case P.MeshTransformUpdateAction.EnableFastUpdates:if(n)return!0;break;case P.MeshTransformUpdateAction.DisableFastUpdates:if(!n)return!0;break;default:if(!n)return!!this.updateTransform(e,t,r,P.MeshTransformUpdateAction.EnableFastUpdates)&&(e.autoDisableFastTransformUpdates((()=>this.updateTransform(e,t,r,P.MeshTransformUpdateAction.DisableFastUpdates))),!0)}const o=this._context.renderCoordsHelper.spatialReference,s=we,{origin:i,transform:l}=r;if(!f.computeTranslationToOriginAndRotation(t,c.set(_e,i.x,i.y,i.z??0),s,o))return!1;switch(a){case P.MeshTransformUpdateAction.EnableFastUpdates:this._fastUpdateProcessor.enable(e,this._materialInfoCache,this._context);break;case P.MeshTransformUpdateAction.DisableFastUpdates:this._fastUpdateProcessor.disable(e,this._materialInfoCache,this._context);break;case P.MeshTransformUpdateAction.UpdateFastLocalOrigin:e.updateFastLocalOrigin(s,l,this._context.localOriginFactory)}const{elevationContext:u}=e;u.centerPointInElevationSR=this._getCenterPointInElevationSR(s);const{elevationProvider:h,renderCoordsHelper:m}=this._context,p=(e,t)=>S.evaluateElevationInfoAtPoint(e,h,u,m,t);return e.alignedSampledElevation=I.perObjectElevationAligner(e,u,h.spatialReference,p,m,s),e.updateTransform(s,l,this._context.isAsync),e.updateAutoDisableFastTransformUpdates((()=>this.updateTransform(e,t,r,P.MeshTransformUpdateAction.DisableFastUpdates))),!0}_requiresSymbolVertexColors(){return this._drivenProperties.color||this._drivenProperties.opacity}_materialPropertiesDefault(e,t){const r=this._requiresSymbolVertexColors(),a=!!e.vertexAttributes.color,n=!!e.vertexAttributes.tangent;return{hasSymbolVertexColors:r,hasVertexColors:a,hasVertexTangents:n,uid:`vc:${a},vt:${n},vct${t},svc:${r}`}}_materialProperties(e,t,r){const a=this._materialPropertiesDefault(e,r);if(!t.material)return a;const{color:n,colorTexture:o,colorTextureTransform:s,normalTexture:i,normalTextureTransform:l,doubleSided:c,alphaCutoff:u,alphaMode:h}=t.material,m=de(n),f=de(o),p=ge(s),d=de(i),g=ge(l);if(a.color=n,a.colorTexture=o,a.normalTexture=i,a.uid=`${a.uid},cmuid:${m},ctmuid:${f},cttuid:${p},ntmuid:${d},nttuid:${g},ds:${c},ac:${u},am:${h}`,t.material instanceof _){const{metallic:e,roughness:r,metallicRoughnessTexture:n,metallicRoughnessTextureTransform:o,emissiveColor:i,emissiveTexture:c,emissiveTextureTransform:u,occlusionTexture:h,occlusionTextureTransform:m}=t.material,f=de(n),p=ge(o),d=de(i),g=de(c),x=ge(u),T=de(h),b=ge(m);a.metallic=e,a.roughness=r,a.metallicRoughnessTexture=n,a.emissiveColor=i,a.emissiveTexture=c,a.occlusionTexture=h,a.colorTextureTransform=ce(s),a.normalTextureTransform=ce(l),a.emissiveTextureTransform=ce(u),a.occlusionTextureTransform=ce(m),a.metallicRoughnessTextureTransform=ce(o),a.uid=`${a.uid},mrm:${e},mrr:${r},mrt:${f},mrtt:${p},emuid:${d},etmuid:${g},ett:${x},otmuid:${T},ott:${b}`}return a}_getInternalTextureId(e){const t=this._getInternalTexture(e,$.AlphaDiscardMode.Opaque);return t?.id}_getInternalTexture(e,t){const r=pe(e);if(!r)return null;const a=`${e.contentHash}/${t}`;let n=this._textures.get(a);if(!n){let o=null;const s=this._context.stage.renderView.renderingContext.parameters.maxMaxAnisotropy,i={wrap:ue(e.wrap),noUnpackFlip:!0,maxAnisotropy:s,mipmap:s>1};E.isEncodedMeshTexture(r)?(o=r.data,i.preMultiplyAlpha=!1,i.encoding=r.encoding):(o=r,i.preMultiplyAlpha=t!==$.AlphaDiscardMode.Opaque,i.downsampleUncompressed=this._context.graphicsCoreOwner.view.qualitySettings.graphics3D.uncompressedTextureDownsamplingEnabled),n=new z.Texture(o,i),this._textures.set(a,n),n.load(this._context.stage.renderView.renderingContext),this._context.stage.add(n),n.events.on("unloaded",(()=>{this._textures.delete(a)}))}return n}_setInternalMaterialTextureParameters(e,r){if(null!=e.colorTexture){const t=this._getInternalTexture(e.colorTexture,r.textureAlphaMode);t?(r.textureId=t.id,r.textureAlphaPremultiplied=!!t.parameters.preMultiplyAlpha):r.textureId=void 0}e.normalTexture&&(r.normalTextureId=this._getInternalTextureId(e.normalTexture)),e.emissiveColor&&(r.emissiveFactor=t.toUnitRGB(e.emissiveColor)),e.emissiveTexture&&(r.emissiveTextureId=this._getInternalTextureId(e.emissiveTexture)),e.occlusionTexture&&(r.occlusionTextureId=this._getInternalTextureId(e.occlusionTexture)),e.metallicRoughnessTexture&&(r.metallicRoughnessTextureId=this._getInternalTextureId(e.metallicRoughnessTexture))}_setInternalMaterialParameters(e,t){null!=e.color&&fe(e.color,t),this._setInternalMaterialTextureParameters(e,t),t.colorTextureTransformMatrix=N.getTransformMatrix(e.colorTextureTransform),t.normalTextureTransformMatrix=N.getTransformMatrix(e.normalTextureTransform);const r=null!=e.normalTextureTransform?.scale?e.normalTextureTransform?.scale:l.ONES;t.scale=[r[0],r[1]],t.occlusionTextureTransformMatrix=N.getTransformMatrix(e.occlusionTextureTransform),t.emissiveTextureTransformMatrix=N.getTransformMatrix(e.emissiveTextureTransform),t.metallicRoughnessTextureTransformMatrix=N.getTransformMatrix(e.metallicRoughnessTextureTransform)}_setExternalMaterialParameters(e){const r=this._drivenProperties.color;let a=this.symbolLayer.material?.colorMixMode??null;if(r)e.externalColor=h.ONES;else{const r=this.symbolLayer.material?.color??null;r?e.externalColor=t.toUnitRGBA(r):(a=null,e.externalColor=h.ONES)}a&&(e.colorMixMode=a),e.castShadows=!!this.symbolLayer.castShadows}_getOrCreateMaterial(e,r){const a=r.material?.color,n=r.material?.colorTexture,o=r.material?.alphaMode,s="blend"===o,i=!("opaque"===o)&&(me(e)||null!=a&&a.a<1||n?.transparent||s),l=this._materialProperties(e,r,i),c=this._materialInfoCache.byUid(l.uid);if(c)return this._setInternalMaterialTextureParameters(l,c.material.parameters),c.material;const h={uid:l.uid,material:null,isComponentTransparent:i,alphaMode:r.material?r.material.alphaMode:"opaque"},m=J.useSchematicPBR({normalTexture:l.normalTexture,metallicRoughnessTexture:l.metallicRoughnessTexture,metallicFactor:l.metallic,roughnessFactor:l.roughness,emissiveTexture:l.emissiveTexture,emissiveFactor:t.toUnitRGB(l.emissiveColor),occlusionTexture:l.occlusionTexture}),f={usePBR:this._usePBR(),isSchematic:m,hasVertexColors:l.hasVertexColors,hasSymbolColors:l.hasSymbolVertexColors,hasVertexTangents:l.hasVertexTangents,ambient:u.ZEROS,diffuse:u.ONES,opacity:1,doubleSided:!0,doubleSidedType:"winding-order",cullFace:$.CullFaceOptions.None,layerOpacity:this._getLayerOpacity(),hasSlicePlane:this._context.slicePlaneEnabled,initTextureTransparent:!0};f.mrrFactors=m?J.schematicMRRFactors:[l.metallic,l.roughness,J.advancedMRRFactors[2]],r.material&&(f.doubleSided=r.material.doubleSided,f.cullFace=r.material.doubleSided?$.CullFaceOptions.None:$.CullFaceOptions.Back,f.textureAlphaCutoff=r.material.alphaCutoff),this._setExternalMaterialParameters(f),this._setMaterialTransparentParameter(f,h),this._setInternalMaterialParameters(l,f);const p=new Y.DefaultMaterial(f,this._context);return h.material=p,this._materialInfoCache.set(l.uid,h),this._context.stage.add(p),p}_usePBR(){return this._context.physicalBasedRenderingEnabled}_setMaterialTransparentParameter(e,t){e.transparent=this.needsDrivenTransparentPass||t.isComponentTransparent||e.layerOpacity<1||e.opacity<1||e.externalColor&&e.externalColor[3]<1,"auto"===t.alphaMode?e.textureAlphaMode=e.transparent?$.AlphaDiscardMode.MaskBlend:$.AlphaDiscardMode.Opaque:e.textureAlphaMode="opaque"===t.alphaMode?$.AlphaDiscardMode.Opaque:"mask"===t.alphaMode?$.AlphaDiscardMode.Mask:$.AlphaDiscardMode.Blend}_createFaceDebugNormals(e,t){const r=t.length,a=e.spatialReference.isGeographic?20015077/180:1,s=.1*Math.max(e.extent.width*a,e.extent.height*a,e.extent.zmax-e.extent.zmin),i=[],l=[],u=t[0].transformation,h=n.normalFromMat4(o.create(),u);for(let n=0;n<r;n++){const e=t[n].attributes.get(W.VertexAttribute.POSITION);if(!e)continue;const r=e.data,a=e.indices;for(let t=0;t<a.length;t+=3)ie(r,a,t,Ae),se(r,a,t,_e,ye,Me),c.add(_e,_e,ye),c.add(_e,_e,Me),c.scale(_e,_e,1/3),c.transformMat4(_e,_e,u),i.push(..._e),c.transformMat3(Ae,Ae,h),c.normalize(Ae,Ae),c.scaleAndAdd(_e,_e,Ae,s),i.push(..._e),l.push(l.length),l.push(l.length)}return i.length?new k.Geometry(this._debugFaceNormalMaterial,[[W.VertexAttribute.POSITION,new L.Attribute(i,l,3,!0)]],null,H.ContentObjectType.Line):null}_createPerVertexDebugVectors(e,t,r,a,s){const i=t.length,l=e.spatialReference.isGeographic?20015077/180:1,u=.1*s*Math.max(e.extent.width*l,e.extent.height*l,e.extent.zmax-e.extent.zmin),h=[],m=[],f=t[0].transformation,p=n.normalFromMat4(o.create(),f);r===W.VertexAttribute.TANGENT&&n.fromMat4(p,f);for(let n=0;n<i;n++){const e=t[n],a=e.attributes.get(W.VertexAttribute.POSITION),o=e.attributes.get(r);if(!a||!o)continue;const s=a.data,i=a.indices,l=o.data,d=o.indices;for(let t=0;t<i.length;t++){const e=3*i[t],r=d[t]*o.stride;c.set(_e,s[e+0],s[e+1],s[e+2]),c.transformMat4(_e,_e,f),h.push(..._e),c.set(ye,l[r+0],l[r+1],l[r+2]),c.transformMat3(ye,ye,p),c.normalize(ye,ye),c.scaleAndAdd(_e,_e,ye,u),h.push(..._e),m.push(m.length),m.push(m.length)}}return h.length?new k.Geometry(a,[[W.VertexAttribute.POSITION,new L.Attribute(h,m,3,!0)]],null,H.ContentObjectType.Line):null}_createAs3DShape(e,t,r,a){const n=e.geometry;if("mesh"!==n.type)return null;const o=this._createGeometryInfo(n,t,a);if(null==o)return null;const{geometries:s,objectTransformation:i}=o;if(G.debugFlags.DRAW_MESH_GEOMETRY_NORMALS){const e=this._createPerVertexDebugVectors(n,s,W.VertexAttribute.NORMAL,this._debugVertexNormalMaterial,1),t=this._createPerVertexDebugVectors(n,s,W.VertexAttribute.TANGENT,this._debugTangentNormalMaterial,.5),r=this._createFaceDebugNormals(n,s);e&&s.push(e),t&&s.push(t),r&&s.push(r)}const l=new q.Object3D({geometries:s,layerUid:this._context.layer.uid,graphicUid:a,isElevationSource:!0});l.transformation=i;const c=D.createMaterial(this.symbolLayer,{opacity:this._getLayerOpacity()}),u=c?new U.Object3DEdgeState(s[0].material,c,this._context.slicePlaneEnabled):null,h=new F.Graphics3DMeshObject3DGraphicLayer(this,l,s,null,null,I.perObjectElevationAligner,r,u);this._fastUpdateProcessor.onAddGraphic(),h.needsElevationUpdates=S.needsElevationUpdates3D(r.mode),h.useObjectOriginAsAttachmentOrigin=!0,h.fastTransformUpdatesAllowed=this._fastTransformUpdatesAllowed(n),r.centerPointInElevationSR=this._getCenterPointInElevationSR(l.transformation);const{elevationProvider:m,renderCoordsHelper:f}=this._context,p=(e,t)=>S.evaluateElevationInfoAtPoint(e,m,r,f,t);return h.alignedSampledElevation=I.perObjectElevationAligner(h,r,m.spatialReference,p,f),h}_fastTransformUpdatesAllowed(e){const{vertexSpace:t,spatialReference:r}=e;if(!M.isRelativeVertexSpace(t))return!1;const{type:a}=t,{view:n}=this._context.graphicsCoreOwner,{viewingMode:o}=n.state,s=n.spatialReference;return o===O.ViewingMode.Global&&"local"===a||o===O.ViewingMode.Local&&A.equals(s,r)&&"georeferenced"===a&&!r.isGeographic}_getCenterPointInElevationSR(e){const t=C.makeDehydratedPoint(0,0,0,null!=this._context.elevationProvider.spatialReference?this._context.elevationProvider.spatialReference:null);return d.projectVectorToPoint([e[12],e[13],e[14]],this._context.renderCoordsHelper.spatialReference,t),t}_passthroughReprojectionInfo(e){return e.reprojection===Pe.NONE&&!!e.objectTransformation}_createPositionBuffer(e,t){const r=e.vertexAttributes.position;let a=r,n=null;if(t.reprojection===Pe.NONE)return{position:a,georeferencedPositionBuffer:n};const o=t.reprojection===Pe.RENDER?t.transformBeforeProject:null;o&&(a=v.transformMat4(new Float64Array(a.length),a,o));const{normal:s,tangent:i}=e.vertexAttributes;this._passthroughReprojectionInfo(t)||!s&&!i||(n=a);const l=a===r||a===n?new Float64Array(a.length):a;return p.projectBuffer(a,e.spatialReference,0,l,this._context.renderCoordsHelper.spatialReference,0),{position:l,georeferencedPositionBuffer:n}}_createNormalBuffer(e,t,r,a){const n=e.vertexAttributes.normal;if(null==n)return null;let o=n;const s=a.reprojection===Pe.RENDER?a.transformBeforeProject:null;s&&(o=w.transformNormal(o,new Float32Array(o.length),s));const i=this._context.graphicsCoreOwner.view.viewingMode;if(a.reprojection===Pe.NONE)return o;if("local"===i){if(!A.isPlateCarree(this._context.renderCoordsHelper.spatialReference))return o;if(null==r)return null;if(e.spatialReference.isGeographic){const e=o===n?new Float32Array(o.length):o;return w.transformVectorENUPlateCarree(o,w.VectorType.NORMAL,r,e)}if(e.spatialReference.isWebMercator){const e=o===n?new Float32Array(o.length):o;return w.transformVectorWMPlateCarree(o,w.VectorType.NORMAL,r,e)}return o}if(null==r)return null;const l=o===n?new Float32Array(o.length):o,c=this._context.renderCoordsHelper.spatialReference;return w.projectNormalToPCPF(o,r,e.spatialReference,t,c,l)}_createTangentBuffer(e,t,r,a){const n=e.vertexAttributes.tangent;if(null==n)return null;let o=n;const s=a.reprojection===Pe.RENDER?a.transformBeforeProject:null;s&&(o=w.transformTangent(o,new Float32Array(o.length),s));const i=this._context.graphicsCoreOwner.view.viewingMode;if(a.reprojection===Pe.NONE)return o;if("local"===i){if(!A.isPlateCarree(this._context.renderCoordsHelper.spatialReference))return o;if(null==r)return null;if(e.spatialReference.isGeographic){const e=o===n?new Float32Array(o.length):o;return w.transformVectorENUPlateCarree(o,w.VectorType.TANGENT,r,e)}if(e.spatialReference.isWebMercator){const e=o===n?new Float32Array(o.length):o;return w.transformVectorWMPlateCarree(o,w.VectorType.TANGENT,r,e)}return o}if(null==r)return null;const l=o===n?new Float32Array(o.length):o,c=this._context.renderCoordsHelper.spatialReference;return w.projectTangentToPCPF(o,r,e.spatialReference,t,c,l)}_createSymbolColorBuffer(e){if(this._requiresSymbolVertexColors()){const t=this._getVertexOpacityAndColor(e),r=B.parseColorMixMode(this.symbolLayer?.material?.colorMixMode),a=new Uint8Array(4);return B.encodeSymbolColor(t,r,a),a}return null}_createBuffers(e,t){const r=e.vertexAttributes&&e.vertexAttributes.position;if(!r)return this.logger.warn("Mesh geometry must contain position vertex attributes"),null;const a=e.vertexAttributes.normal,n=e.vertexAttributes.uv,o=e.vertexAttributes.tangent;if(a&&a.length!==r.length)return this.logger.warn("Mesh normal vertex buffer must contain the same number of elements as the position buffer"),null;if(o&&o.length/4!=r.length/3)return this.logger.warn("Mesh tangent vertex buffer must contain the same number of elements as the position buffer"),null;if(n&&n.length/2!=r.length/3)return this.logger.warn("Mesh uv vertex buffer must contain the same number of elements as the position buffer"),null;const s=this._computeReprojectionInfo(e),{position:l,georeferencedPositionBuffer:c}=this._createPositionBuffer(e,s),u=xe(e),h=this._createSymbolColorBuffer(t),m=this._createNormalBuffer(e,l,c,s),f=this._createTangentBuffer(e,l,c,s),p=n,{transformation:d,position:g,normal:x,tangent:T}=this._passthroughReprojectionInfo(s)?{transformation:s.objectTransformation,position:l,normal:m,tangent:f}:this._transformOriginLocal(e,l,m,f);return{positionBuffer:g,normalBuffer:x,tangentBuffer:T,uvBuffer:p,colorBuffer:u,symbolColorBuffer:h,objectTransformation:d,geometryTransformation:s.reprojection===Pe.NONE&&s.geometryTransformation?s.geometryTransformation:i.create()}}_computeReprojectionInfo(e){const{vertexSpace:t}=e,r="georeferenced"===t.type?A.equals(this._context.renderCoordsHelper.spatialReference,e.spatialReference)?Pe.NONE:Pe.RENDER:Pe.NONE;if(M.isAbsoluteVertexSpace(t))return{reprojection:r};const a=t.origin,n=i.create(),o=e.transform?.localMatrix??i.IDENTITY;if(r===Pe.NONE){f.computeTranslationToOriginAndRotation(e.spatialReference,a,n,this._context.renderCoordsHelper.spatialReference);return{reprojection:r,objectTransformation:n,geometryTransformation:i.clone(o)}}const l=s.fromTranslation(i.create(),a);return s.multiply(l,l,o),{reprojection:r,transformBeforeProject:l}}_transformOriginLocal(e,t,r,a){const n=this._context.renderCoordsHelper.spatialReference,o=e.origin;be[0]=o.x,be[1]=o.y,be[2]=o.z??0;const l=i.create();f.computeTranslationToOriginAndRotation(e.spatialReference,be,l,n),s.invert(ve,l);const{position:c,normal:u,tangent:h}=e.vertexAttributes,m=t===c?new Float64Array(t.length):t;v.transformMat4(m,t,ve);const p=r?r===u?new Float32Array(r.length):r:null,d=a?a===h?new Float32Array(a.length):a:null;return r&&p&&w.transformNormal(r,p,ve),a&&d&&w.transformTangent(a,d,ve),{transformation:l,position:m,normal:p,tangent:d}}_validateFaces(e,t){const r=e.vertexAttributes.position.length/3,a=t.faces;if(a){let e=-1;for(let t=0;t<a.length;t++){const r=a[t];r>e&&(e=r)}if(r<=e)return this.logger.warn(`Vertex index ${e} is out of bounds of the mesh position buffer`),!1}else if(r%3!=0)return this.logger.warn("Mesh position buffer length must be a multiple of 9 if no component faces are defined (3 values per vertex * 3 vertices per triangle)"),!1;return!0}_isOutsideClippingArea(e){if(!this._context.clippingExtent)return!1;const t=e.vertexAttributes?.position;if(!t)return!1;const r=this._context.elevationProvider.spatialReference,a=R.projectMeshVertexPositions(e,r??e.spatialReference);return!!a&&(g.fromBuffer(a,Re),!g.intersectsClippingArea(Re,this._context.clippingExtent))}_createGeometryInfo(e,t,r){if(!m.canProjectWithoutEngine(e.spatialReference,this._context.renderCoordsHelper.spatialReference))return this.logger.warn("Geometry spatial reference is not compatible with the view"),null;if(!this._validateVertexSpace(e))return null;if(this._isOutsideClippingArea(e))return null;const a=this._createBuffers(e,t);if(null==a)return null;const{positionBuffer:n,uvBuffer:o,colorBuffer:i,symbolColorBuffer:l,normalBuffer:c,tangentBuffer:u,objectTransformation:h,geometryTransformation:f}=a,p=le(e),d=new Array;let g=!1;const x=s.getTranslation(_e,h),b=this._context.localOriginFactory.getOrigin(x);for(const s of p){if(!this._validateFaces(e,s))return null;const t=te(e,s);if(0===t.length)continue;const a=re(n,c,s,t);a.didFlipNormals&&(g=!0);const h=[[W.VertexAttribute.POSITION,new L.Attribute(n,t,3,!0)],[W.VertexAttribute.NORMAL,new L.Attribute(a.normals,a.indices,3,!0)]];i&&h.push([W.VertexAttribute.COLOR,new L.Attribute(i,t,4,!0)]),l&&h.push([W.VertexAttribute.SYMBOLCOLOR,new L.Attribute(l,T.getZeroIndexArray(t.length),4,!0)]),o&&h.push([W.VertexAttribute.UV0,new L.Attribute(o,t,2,!0)]),u&&h.push([W.VertexAttribute.TANGENT,new L.Attribute(u,t,4,!0)]);const m=this._context.stage.renderView.getObjectAndLayerIdColor({graphicUid:r,layerUid:this._context.layer.uid}),p=this._getOrCreateMaterial(e,s),x=new k.Geometry(p,h,null,H.ContentObjectType.Mesh,m);x.transformation=f,x.localOrigin=b,d.push(x)}return g&&this.logger.warn("Normals have been automatically flipped to be consistent with the counter clock wise face winding order. It is better to generate mesh geometries that have consistent normals."),{geometries:d,objectTransformation:h}}_updateMaterialParameters(e){this._materialInfoCache.forEachMaterialInfo(e),this._fastUpdateProcessor.forEachMaterialInfo(e),this._fastUpdateProcessor.forEachClonedMaterial(((e,t)=>{t.setParameters(e.parameters)}))}_validateVertexSpace(e){const{_context:{graphicsCoreOwner:{view:{state:{viewingMode:t}}}}}=this,{vertexSpace:r}=e;return t!==O.ViewingMode.Local||"local"!==r.type||(this.logger.warn("Displaying a mesh with a local vertex space in a view in local viewing mode is not supported."),!1)}test(){return{...super.test(),materials:this._materialInfoCache.materials}}}class ee{constructor(e,t,r){this.normals=e,this.indices=t,this.didFlipNormals=r}}function te(e,t){return t.faces??T.getContinuousIndexArray(e.vertexAttributes.position.length/3)}function re(e,t,r,a){switch(r.shading||"flat"){default:case"source":return ne(e,t,r,a);case"flat":return ae(e,a);case"smooth":return oe(e,a)}}function ae(e,t){const r=x.newFloatArray(t.length),a=new Array(3*t.length);for(let n=0;n<t.length;n+=3){const o=ie(e,t,n,Ae);for(let e=0;e<3;e++)r[n+e]=o[e],a[n+e]=n/3}return new ee(r,a,!1)}function ne(e,t,r,a){if(null==t)return ae(e,a);let n=!1;if(!r.trustSourceNormals)for(let o=0;o<a.length;o+=3){ie(e,a,o,Ae);for(let e=0;e<3;e++){const r=3*a[o+e];_e[0]=t[r],_e[1]=t[r+1],_e[2]=t[r+2],c.dot(Ae,_e)<0&&(t[r]=-t[r],t[r+1]=-t[r+1],t[r+2]=-t[r+2],n=!0)}}return new ee(t,a,n)}function oe(e,t){const r={};for(let o=0;o<t.length;o+=3){const a=ie(e,t,o,Ae);for(let e=0;e<3;e++){const n=t[o+e];let s=r[n];s||(s={normal:u.create(),count:0},r[n]=s),c.add(s.normal,s.normal,a),s.count++}}const a=x.newFloatArray(3*t.length),n=new Array(3*t.length);for(let o=0;o<t.length;o++){const e=r[t[o]];1!==e.count&&(c.normalize(e.normal,e.normal),e.count=1);for(let t=0;t<3;t++)a[3*o+t]=e.normal[t];n[o]=o}return new ee(a,n,!1)}function se(e,t,r,a,n,o){const s=3*t[r],i=3*t[r+1],l=3*t[r+2];a[0]=e[s],a[1]=e[s+1],a[2]=e[s+2],n[0]=e[i],n[1]=e[i+1],n[2]=e[i+2],o[0]=e[l],o[1]=e[l+1],o[2]=e[l+2]}function ie(e,t,r,a){return se(e,t,r,_e,ye,Me),c.subtract(ye,ye,_e),c.subtract(Me,Me,_e),c.cross(_e,ye,Me),c.normalize(a,_e),a}function le(e){return e.components??Ce}function ce(e){if(!e)return null;const{scale:t,offset:r,rotation:n}=e;return{scale:t,offset:r,rotation:a.deg2rad(n)}}function ue(e="repeat"){if("string"==typeof e){const t=he(e);return{s:t,t}}return{s:he(e.horizontal),t:he(e.vertical)}}function he(e){switch(e){case"clamp":return K.TextureWrapMode.CLAMP_TO_EDGE;case"mirror":return K.TextureWrapMode.MIRRORED_REPEAT;default:return K.TextureWrapMode.REPEAT}}function me(e){const t=e.vertexAttributes.color;if(null==t)return!1;for(let r=3;r<t.length;r+=4)if(255!==t[r])return!0;return!1}function fe(e,r){r.diffuse=t.toUnitRGB(e),r.opacity=e.a}function pe(e){return e.data??e.url}function de(e){return null==e?"-":e instanceof t?e.toHex():e.contentHash}function ge(e){const{offset:t,scale:r,rotation:a}=e??Te;return`${t[0]},${t[1]},${a},${r[0]},${r[1]}`}function xe(e){return e.vertexAttributes.color}const Te=new y,be=u.create(),_e=u.create(),ye=u.create(),Me=u.create(),Ae=u.create(),ve=i.create(),we=i.create(),Re=g.create(),Ce=[new b];var Pe;!function(e){e[e.NONE=0]="NONE",e[e.RENDER=1]="RENDER"}(Pe||(Pe={})),e.Graphics3DMeshFillSymbolLayer=X,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
