/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../Color","../../../../core/promiseUtils","../../../../core/screenUtils","../../../../core/typedArrayUtil","../../../../core/libs/gl-matrix-2/math/mat4","../../../../core/libs/gl-matrix-2/factories/mat4f64","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../core/libs/gl-matrix-2/factories/vec4f64","../../../../geometry/projection/computeTranslationToOriginAndRotation","../../../../geometry/projection/projectPointToVector","../../../../geometry/support/aaBoundingBox","../../../../symbols/support/ObjectSymbol3DLayerResource","../../../../symbols/support/symbolLayerUtils3D","./defaultSymbolComplexity","./ElevationAligners","./elevationAlignmentUtils","./Graphics3DLodInstanceGraphicLayer","./Graphics3DSymbolLayer","./graphicUtils","./interfaces","./Loadable","./lodResourceUtils","./objectResourceUtils","./pointUtils","./primitiveObjectSymbolUtils","./SymbolComplexity","./webStyleUtils","../support/FastSymbolUpdates","../../webgl-engine/effects/geometry/olidUtils","../../webgl-engine/lib/basicInterfaces","../../webgl-engine/lib/VertexAttribute","../../webgl-engine/lib/lodRendering/LodRenderer","../../webgl-engine/lib/lodRendering/LodResources","../../webgl-engine/materials/DefaultMaterial","../../webgl-engine/materials/pbrUtils"],(function(e,t,s,r,i,a,o,n,l,c,h,d,u,p,m,y,f,b,_,g,R,P,x,S,v,L,C,E,O,U,T,w,A,F,B,D,G){"use strict";class I{constructor(e,t,s,r,i,a,o,n,l,c,h,d){this.lodResources=e,this.lodRenderer=t,this.stageResources=s,this.originalMaterialParameters=r,this.resourceSize=i,this.isEsriSymbolResource=a,this.isWosr=o,this.resourceBoundingBox=n,this.symbolSize=l,this.extentPadding=c,this.physicalBasedRenderingEnabled=h,this.pivotOffset=d}}class z extends g.Graphics3DSymbolLayer{getCachedSize(){const[e,t,s]=null!=this._resources?this._resources.symbolSize:[1,1,1];return{width:e,depth:t,height:s}}constructor(e,t,s,r){super(e,t,s,r),this._resources=null,this._optionalFields=new Array,this._instanceIndexToGraphicUid=new Map,this._hasLoadedPBRTextures=!1,this._disposeResourceHandles=new Array,this.skipHighSymbolLodsChanged=!1,this.ensureDrapedStatus(!1),this._hasLoadedPBRTextures=s.physicalBasedRenderingEnabled}async doLoad(e){if(!this._drivenProperties.size){const e=R.validateSymbolLayerSize(this.symbolLayer);if(e)throw new Error(e)}if(this._isPrimitive){const t=this.symbolLayer.resource,s=t&&C.isValidPrimitive(t?.primitive)?t.primitive:p.defaultPrimitive;this._resources=await this._createResourcesForPrimitive(s,e)}else{const t=await O.getResourceUrlFromSymbolStyle(this.symbol.styleOrigin),s=t?.href??this.symbolLayer.resource?.href;this._resources=await this._createResourcesForUrl(s,e)}this.layerOpacityChanged(),this.slicePlaneEnabledChanged(),this.physicalBasedRenderingChanged(),this.complexity=this.computeComplexity()}get extentPadding(){return null!=this._resources?this._resources.extentPadding:0}get _isPrimitive(){return!this.symbolLayer.resource?.href}get lodRenderer(){return this._resources?.lodRenderer}get materials(){return this._resources?.stageResources.materials??[]}_setMaterialTransparencyParameters(e,t=this.symbolLayer?.material?.color){const s=this._getCombinedOpacity(t),r=s<1||this.needsDrivenTransparentPass;return e.transparent=r,e.opacity=s,e.cullFace=r?w.CullFaceOptions.None:w.CullFaceOptions.Back,e}async _createResourcesForPrimitive(e,s){const i=this.symbolLayer,a=u.create(m.objectSymbolLayerPrimitiveBoundingBox(e)),o=l.fromArray(u.size(a)),h=l.fromArray(m.objectSymbolLayerSizeWithResourceSize(o,i)),d=n.length(h),p=!1,y=!1,f=this.symbolLayer?.material?.emissiveFactor,b=f?n.clamp(l.clone(f)):l.ZEROS,_={usePBR:this._context.physicalBasedRenderingEnabled,isSchematic:!0,mrrFactors:G.schematicMRRFactors,ambient:l.ONES,diffuse:l.ONES,hasSlicePlane:this._context.slicePlaneEnabled,hasSliceHighlight:!1,castShadows:this.symbolLayer.castShadows,emissiveFactor:b,offsetTransparentBackfaces:!this.symbolLayer.isPrimitive},g=!!_.usePBR;this._setMaterialTransparencyParameters(_);const R=this.symbol;if("point-3d"===R.type&&R.verticalOffset){const{screenLength:e,minWorldLength:t,maxWorldLength:s}=R.verticalOffset;_.verticalOffset={screenLength:r.pt2px(e),minWorldLength:t||0,maxWorldLength:null!=s?s:1/0},_.castShadows=!1}if(this._context.screenSizePerspectiveEnabled&&(_.screenSizePerspective=this._context.sharedResources.screenSizePerspectiveSettings),this._drivenProperties.color)_.externalColor=c.ONES;else{const e=null!=i.material?i.material.color:null,s=null!=e?t.toUnitRGBA(e):c.ONES;_.externalColor=s}this._fastUpdates=U.initFastSymbolUpdatesState(this._context.renderer,this._fastVisualVariableConvertOptions(a,h,o,null)),_.isInstanced=!0,this._fastUpdates?(Object.assign(_,this._fastUpdates.materialParameters),this._optionalFields.push(A.VertexAttribute.FEATUREATTRIBUTE)):this._hasPerInstanceColor()&&(_.hasInstancedColor=!0,this._optionalFields.push(A.VertexAttribute.COLOR)),T.olidEnabled()&&this._optionalFields.push(A.VertexAttribute.OBJECTANDLAYERIDCOLOR);const P=new D.DefaultMaterial(_,this._context),x=C.primitiveLodResources(e,P);if(!x)throw new Error(`Unknown object symbol primitive: ${e}`);const S=B.materialsFromLodResources(x).map((e=>({opacity:1,transparent:e.parameters.transparent}))),v=await this._createStageResources(x,g,s),L=await this._createLodRenderer(x,s);return new I(x,L,v,S,o,p,y,a,h,d,g,null)}async _createResourcesForUrl(e,t){const s={isInstanced:!0,hasSlicePlane:this._context.slicePlaneEnabled,castShadows:this.symbolLayer.castShadows},i={spherical:this._context.spherical,doublePrecisionRequiresObfuscation:this._context.doublePrecisionRequiresObfuscation,materialParameters:s,streamDataRequester:this._context.streamDataRequester,cache:this._context.sharedResources.objectResourceCache};this._fastUpdates=U.initFastSymbolUpdatesState(this._context.renderer,this._fastVisualVariableConvertOptions(null,null,null,null)),this._fastUpdates?(Object.assign(i.materialParameters,this._fastUpdates.materialParameters),this._optionalFields.push(A.VertexAttribute.FEATUREATTRIBUTE)):this._hasPerInstanceColor()&&(i.materialParameters.hasInstancedColor=!0,this._optionalFields.push(A.VertexAttribute.COLOR)),T.olidEnabled()&&this._optionalFields.push(A.VertexAttribute.OBJECTANDLAYERIDCOLOR);const a=this.symbol;if("point-3d"===a.type&&a.verticalOffset){const{screenLength:e,minWorldLength:t,maxWorldLength:s}=a.verticalOffset;i.materialParameters.verticalOffset={screenLength:r.pt2px(e),minWorldLength:t||0,maxWorldLength:null!=s?s:1/0},i.materialParameters.castShadows=!1}const o=this._context.physicalBasedRenderingEnabled;i.signal=t,i.usePBR=o,i.skipHighLods=this._context.skipHighSymbolLods;const c=await v.fetch(e,i),h=c.isEsriSymbolResource,d=c.isWosr,p=S.makeLodResources(c.lods),y=this._context,f=this.symbolLayer.material,b=this._getExternalColorParameters(f),_=this.symbolLayer?.material?.color,g=this._getCombinedOpacity(_,{hasIntrinsicColor:!0}),R=this.needsDrivenTransparentPass,P=B.materialsFromLodResources(p),x=B.materialsFromLodResources(p).map((e=>({opacity:e.parameters.opacity||1,transparent:e.parameters.transparent})));P.forEach((e=>{const t=e.parameters;e.setParameters(b);const s=t.opacity*g,r=s<1||R||t.transparent;e.setParameters({opacity:s,transparent:r}),y.screenSizePerspectiveEnabled&&e.setParameters({screenSizePerspective:y.sharedResources.screenSizePerspectiveSettings})}));const L=c.referenceBoundingBox,C=l.fromArray(u.size(L)),E=l.fromArray(p.levels[0].pivotOffset),O=l.fromArray(m.objectSymbolLayerSizeWithResourceSize(C,this.symbolLayer)),w=n.length(O),F=this._fastUpdates;U.updateFastSymbolUpdatesState(F,this._context.renderer,this._fastVisualVariableConvertOptions(L,O,C,E))&&P.forEach((e=>e.setParameters(F.materialParameters)));const D=await this._createStageResources(p,o,t),G=await this._createLodRenderer(p,t);return new I(p,G,D,x,C,h,d,L,O,w,o,E)}_addDisposeResource(e){this._disposeResourceHandles.push(e)}async _createStageResources(e,t,r){const i=this._context.stage,a=B.materialsFromLodResources(e);t!==this._context.physicalBasedRenderingEnabled&&this.physicalBasedRenderingChanged(),i.addMany(a),this._addDisposeResource((()=>i.removeMany(a)));const o=B.texturesFromLodResources(e);i.addMany(o),this._addDisposeResource((()=>{o.forEach((e=>e.unload())),i.removeMany(o)})),await Promise.all(o.map((e=>this._context.stage.schedule((()=>e.load(i.renderView.renderingContext)),r)))),s.throwIfAborted(r);const n=B.geometriesFromLodResources(e);return i.addMany(n),this._addDisposeResource((()=>i.removeMany(n))),{materials:a,textures:o,geometries:n}}async _createLodRenderer(e,t){const s=this._context.stage,r={layerUid:this._context.layer.uid,graphicUid:e=>this._instanceIndexToGraphicUid.get(e),notifyGraphicGeometryChanged:e=>this._context.notifyGraphicGeometryChanged(this._instanceIndexToGraphicUid.get(e)),notifyGraphicVisibilityChanged:e=>this._context.notifyGraphicVisibilityChanged(this._instanceIndexToGraphicUid.get(e))},i=this._fastUpdates,o=i?{applyTransform:(e,t,s)=>{e.getFeatureAttribute(t,k),a.copy(s,U.evaluateModelTransform(i.materialParameters,k,s))},scaleFactor:(e,t,s)=>{t.getFeatureAttribute(s,k),U.evaluateModelTransformScale(e,i.materialParameters,k)}}:null,n=new F.LodRenderer({symbol:e,optionalFields:this._optionalFields,metadata:r,shaderTransformation:o},this._context.scheduler);return n.slicePlaneEnabled=this._context.slicePlaneEnabled,this._addDisposeResource((()=>{s.removeRenderPlugin(n),n.destroy()})),await s.addRenderPlugin(n,t),n}_getExternalColorParameters(e){const s={};return this._drivenProperties.color?s.externalColor=c.ONES:null!=e?.color?s.externalColor=t.toUnitRGBA(e.color):(s.externalColor=c.ONES,s.colorMixMode="ignore"),s}destroy(){super.destroy(),this._cleanupResources()}_cleanupResources(){this._disposeResourceHandles.forEach((e=>e())),this._disposeResourceHandles.length=0,this._resources=null}createGraphics3DGraphic(e){const t=e.graphic;if(!this._validateGeometry(t.geometry))return null;const s=L.placePointOnGeometry(t.geometry);if(null==s)return this.logger.warn(`unsupported geometry type for object symbol: ${t.geometry.type}`),null;const r=this.setGraphicElevationContext(t),i=e.renderingInfo;return this._createAs3DShape(t,s,i,r,t.uid,e.layer.uid)}notifyDestroyGraphicLayer(e){this._instanceIndexToGraphicUid.delete(e.instanceIndex)}graphicLayerToGraphicId(){return 0}layerOpacityChanged(){if(null==this._resources)return;const e=this._drivenProperties.opacity,t=!this._isPrimitive,s=this._resources.stageResources.materials,r=this._resources.originalMaterialParameters;for(let i=0;i<s.length;i++){const a=s[i],o=this.symbolLayer?.material?.color,n=r[i],l=this._getCombinedOpacity(o,{hasIntrinsicColor:t})*n.opacity,c=l<1||e||n.transparent;a.setParameters({opacity:l,transparent:c}),this._isPrimitive&&a.setParameters({cullFace:c?w.CullFaceOptions.None:w.CullFaceOptions.Back})}}layerElevationInfoChanged(e,t){return this.updateGraphics3DGraphicElevationInfo(e,t,b.needsElevationUpdates3D)}slicePlaneEnabledChanged(){if(null==this._resources)return!0;this._resources.lodRenderer.slicePlaneEnabled=this._context.slicePlaneEnabled;for(const e of this._resources.stageResources.materials)e.setParameters({hasSlicePlane:this._context.slicePlaneEnabled});return!0}physicalBasedRenderingChanged(){if(null==this._resources)return!0;const{stageResources:e,isWosr:t}=this._resources;for(const s of e.materials)this._isPrimitive?s.setParameters({usePBR:this._context.physicalBasedRenderingEnabled,isSchematic:!0}):t||s.setParameters({usePBR:this._context.physicalBasedRenderingEnabled,isSchematic:!1});return!1!==this._hasLoadedPBRTextures||!0!==this._context.physicalBasedRenderingEnabled||(this._hasLoadedPBRTextures=!0,!1)}applyRendererDiff(e,t){if(null==this._resources)return P.ApplyRendererDiffResult.RecreateSymbol;const{stageResources:{materials:s},lodRenderer:r,resourceBoundingBox:i,symbolSize:a,resourceSize:o,pivotOffset:n}=this._resources;for(const l in e.diff){if("visualVariables"!==l)return P.ApplyRendererDiffResult.RecreateSymbol;if(!U.updateFastSymbolUpdatesState(this._fastUpdates,t,this._fastVisualVariableConvertOptions(i,a,o,n)))return P.ApplyRendererDiffResult.RecreateSymbol;for(const e of s)e.setParameters(this._fastUpdates.materialParameters);r.notifyShaderTransformationChanged()}return P.ApplyRendererDiffResult.FastUpdate}computeComplexity(){if(null==this._resources)return super.computeComplexity();const e=this._resources.lodResources,t=y.estimateNumVerticesForLods(e.levels),s=e=>Array.from(e.attributes.values()).reduce(((e,t)=>e+i.estimateSize(t.data,t.indices)),0),r=B.geometriesFromLodResources(e).reduce(((e,t)=>e+s(t)),0),a=B.texturesFromLodResources(e).reduce(((e,t)=>e+t.memoryEstimate),0)+r,o={...y.defaultSymbolLayerMemoryComplexity(this.symbol,this.symbolLayer),resourceBytes:a};return new E.SymbolComplexity({verticesPerFeature:t,memory:o})}_hasLodRenderer(){return null!=this._resources}_createAs3DShape(e,t,s,r,i,a){if(!this._hasLodRenderer()||null==this._resources)return null;const o=this.getFastUpdateAttrValues(e),n=this._context.clippingExtent;if(d.projectPointToVector(t,M,this._context.elevationProvider.spatialReference),null!=n&&!u.containsPoint(n,M))return null;const l=j(r),c=this._computeGlobalTransform(t,r,W,H),h=this._computeLocalTransform(this._resources,this.symbolLayer,s,N),p=this._resources.lodRenderer.instanceData,m=p.addInstance();this._instanceIndexToGraphicUid.set(m,i),p.setLocalTransform(m,h,!1),p.setGlobalTransform(m,c),o&&p.setFeatureAttribute(m,o),null==this._fastUpdates&&this._hasPerInstanceColor()&&p.setColor(m,R.mixinColorAndOpacity(s.color,s.opacity,255));const y=this._context.stage.renderView.olidRenderHelper;y&&p.setObjectAndLayerIdColor(m,y.getObjectAndLayerIdColor({graphicUid:i,layerUid:a}));const g=new _.Graphics3DLodInstanceGraphicLayer(this,m,f.perLodInstanceElevationAligner,r);return l&&(g.alignedSampledElevation=H.sampledElevation),g.needsElevationUpdates=b.needsElevationUpdates3D(r.mode),L.extendPointGraphicElevationContext(g,t,this._context.elevationProvider),g}_computeGlobalTransform(e,t,s,r){return b.evaluateElevationInfoAtPoint(e,this._context.elevationProvider,t,this._context.renderCoordsHelper,r),M[0]=e.x,M[1]=e.y,M[2]=r.z,h.computeTranslationToOriginAndRotation(e.spatialReference,M,s,this._context.renderCoordsHelper.spatialReference),s}_computeLocalTransform(e,t,s,r){return a.identity(r),this._applyObjectRotation(s,!1,r),this._applyObjectRotation(t,!0,r),this._applyObjectScale(e,s,r),this._applyAnchor(e,t,r),r}_applyObjectScale(e,t,s){if(this._fastUpdates?.requiresShaderTransformation)return;const r=this._drivenProperties.size&&t.size?t.size:e.symbolSize,i=R.computeObjectScale(r,e.symbolSize,e.resourceSize,this._context.renderCoordsHelper.unitInMeters);1===i[0]&&1===i[1]&&1===i[2]||a.scale(s,s,i)}prepareSymbolLayerPatch(e){if("partial"!==e.diff.type)return;const t=e.diff.diff;this._preparePatchTransform(e,t),this._preparePatchColor(e,t)}updateGeometry(e,t){if(null==this._resources)return!0;const s=t&&L.placePointOnGeometry(t);if(null==s)return!1;const r=this.getGeometryElevationMode(t);return e.elevationContext.mode===r&&(this._computeGlobalTransform(s,e.elevationContext,W,H),j(e.elevationContext)&&(e.alignedSampledElevation=H.sampledElevation),this._resources.lodRenderer.instanceData.setGlobalTransform(e.instanceIndex,W,!0),L.extendPointGraphicElevationContext(e,s,this._context.elevationProvider),!0)}_preparePatchTransform(e,t){if(!(t.heading||t.tilt||t.roll||t.width||t.height||t.depth||t.anchor||t.anchorPosition))return;if(null==this._resources)return;const s=(e,t,s)=>(null!=e&&"complete"===e.type?e.newValue:t)??s,r=s(t.heading,this.symbolLayer.heading,0),i=s(t.tilt,this.symbolLayer.tilt,0),a=s(t.roll,this.symbolLayer.roll,0),o=s(t.width,this.symbolLayer.width,void 0),n=s(t.height,this.symbolLayer.height,void 0),c=s(t.depth,this.symbolLayer.depth,void 0),h=s(t.anchor,this.symbolLayer.anchor,void 0),d=s(t.anchorPosition,this.symbolLayer.anchorPosition,void 0);delete t.heading,delete t.tilt,delete t.roll,delete t.width,delete t.height,delete t.depth,delete t.anchor,delete t.anchorPosition;const u={heading:r,tilt:i,roll:a,anchor:h,anchorPosition:d},p=this._resources;this.loadStatus===x.LoadStatus.LOADED&&e.symbolLayerStatePatches.push((()=>{p.symbolSize=l.fromArray(m.objectSymbolLayerSizeWithResourceSize(p.resourceSize,{width:o,height:n,depth:c,isPrimitive:this.symbolLayer.isPrimitive}))})),e.graphics3DGraphicPatches.push(((e,t)=>{const s=this._computeLocalTransform(p,u,t,N),r=e.instanceIndex;p.lodRenderer.instanceData.setLocalTransform(r,s,!0)}))}_preparePatchColor(e,s){if(!s.material||"partial"!==s.material.type)return;const r=s.material.diff;if(!r.color||"complete"!==r.color.type||null==r.color.newValue||null==r.color.oldValue)return;const i=r.color.newValue,a=null!=i?t.toUnitRGBA(i):c.ONES;delete r.color;const o=this._resources;null!=o&&e.graphics3DGraphicPatches.push((e=>{let t;this._hasPerInstanceColor()?(o.lodRenderer.instanceData.setColor(e.instanceIndex,a),t=this._setMaterialTransparencyParameters({},i)):t=this._setMaterialTransparencyParameters({externalColor:a},i);for(const s of o.stageResources.materials)s.setParameters(t)}))}_applyObjectRotation(e,t,s){if(!this._fastUpdates?.requiresShaderTransformation||!t)return R.computeObjectRotation(e.heading,e.tilt,e.roll,s)}_applyAnchor(e,t,s){if(this._fastUpdates?.requiresShaderTransformation)return;const r=V(e.resourceBoundingBox,e.pivotOffset,t);r&&a.translate(s,s,r)}_hasPerInstanceColor(){return this._drivenProperties.color||this._drivenProperties.opacity}_fastVisualVariableConvertOptions(e,t,s,r){const i=null!=e?l.fromArray(u.size(e)):l.ONES,a=null!=e?V(e,r,this.symbolLayer):l.ZEROS,o=this._context.renderCoordsHelper.unitInMeters,n=R.computeObjectScale(null!=t?t:void 0,t,s,o),c=l.fromValues(this.symbolLayer.tilt||0,this.symbolLayer.roll||0,this.symbolLayer.heading||0);return new U.ConvertOptions({size:!0,color:!0,rotation:!0,opacity:!1},i,t??l.ONES,o,a,n,c)}}function V(e,t,s){const r=l.create();switch(s.anchor){case"center":n.copy(r,u.center(e)),n.negate(r,r);break;case"top":{const t=u.center(e);n.set(r,-t[0],-t[1],-e[5]);break}case"bottom":{const t=u.center(e);n.set(r,-t[0],-t[1],-e[2]);break}case"relative":{const t=u.center(e),i=u.size(e),a=s.anchorPosition,o=a?l.fromValues(a.x,a.y,a.z):l.ZEROS;n.multiply(r,i,o),n.add(r,r,t),n.negate(r,r);break}default:null!=t?n.negate(r,t):n.copy(r,l.ZEROS)}return r}function j(e){return"absolute-height"!==e.mode}const M=l.create(),N=o.create(),W=o.create(),k=c.create(),H=new b.SampleElevationInfo;e.Graphics3DObjectSymbolLayer=z,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
