/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../chunks/tslib.es6","../../../../core/Accessor","../../../../core/Logger","../../../../core/accessorSupport/decorators/property","../../../../core/has","../../../../core/RandomLCG","../../../../core/accessorSupport/decorators/subclass","../../../../core/support/UpdatingHandles","../../../../geometry/projection/projectBoundingRect","../../../../geometry/support/aaBoundingRect","./enums","../../../support/layerViewUtils","../../../support/Scheduler","../../../support/Yield"],(function(e,i,t,a,r,s,l,n,c,o,h,p,y,d,u){"use strict";function g(e,i){return e>0||i>0}e.Graphics3DScaleVisibility=class extends t{constructor(e){super(e),this._scaleRangeActive=!1,this._layerScaleRangeVisibilityQuery=!1,this._extent=null,this._updatingHandles=new c.UpdatingHandles,this.graphicsCoreOwner=null,this.layer=null,this.queryGraphicUIDsInExtent=null,this.graphicsCore=null,this.basemapTerrain=null,this.layerScaleEnabled=!0,this.suspended=!1,this._dirty=!0}initialize(){this.updateScaleRangeActive();const e=this.graphicsCoreOwner.view.resourceController.scheduler;this.addHandles(e.registerTask(d.TaskPriority.SCALE_VISIBILITY,this)),this._updatingHandles.add((()=>this.layer.effectiveScaleRange),(()=>this.layerMinMaxScaleChangeHandler()))}destroy(){this._updatingHandles.destroy(),this.removeHandles(),this._dirty=!1,this._extent=null,this.graphicsCoreOwner=null,this.layer=null,this.queryGraphicUIDsInExtent=null,this.graphicsCore=null,this.basemapTerrain=null}get updating(){return this._dirty||this._updatingHandles.updating}_setDirty(){this._dirty=!0}setExtent(e){const i=this.graphicsCoreOwner.view.spatialReference,t=this.graphicsCoreOwner.view.basemapTerrain.spatialReference;if(i===t)this._extent=e??null;else{const a=h.create();o.projectBoundingRect(e,i,a,t)?this._extent=a:this._extent=null}this._setDirty()}scaleRangeActive(){return this._scaleRangeActive}updateScaleRangeActive(){const e=this.layer,i=e.effectiveScaleRange;let t=this.layerScaleEnabled&&null!=i&&g(i.minScale,i.maxScale);e.labelingInfo&&!t&&(t=e.labelingInfo.some((e=>e&&g(e.minScale??0,e.maxScale??0))));const a=this._scaleRangeActive!==t;return this._scaleRangeActive=t,t&&!this.hasHandles(b)&&this.basemapTerrain?(this.addHandles(this.basemapTerrain.on("scale-change",(e=>this._scaleUpdateHandler(e))),b),this.layerScaleEnabled&&this.addHandles(this.basemapTerrain.on("tiles-visibility-changed",(()=>this._setDirty())),b)):!t&&this.hasHandles(b)&&this.removeHandles(b),a}get running(){return!(!this.graphicsCoreOwner.view.basemapTerrain||!this.updating)}runTask(e){const i=this.graphicsCoreOwner.view.basemapTerrain;if(this._extent&&i&&i.ready&&this._scaleRangeActive&&this.layerScaleEnabled){if(this._layerScaleRangeVisibilityQuery)return u.Yield;{this._layerScaleRangeVisibilityQuery=!0;const{minScale:e,maxScale:t}=this.layer.effectiveScaleRange;i.queryVisibleScaleRange(this._extent,e,t,(e=>this._finishUpdate(e)))}}else this._finishUpdate(!0);e.madeProgress()}_finishUpdate(e){this._layerScaleRangeVisibilityQuery=!1,this._set("suspended",!e),this._dirty=!1}_visibleAtLayerScale(e){const i=this.layer.effectiveScaleRange;return!this.layerScaleEnabled||y.scaleBoundsPredicate(e,i.minScale||0,i.maxScale||0)}_visibleAtLabelScale(e,i){return y.scaleBoundsPredicate(e,i.minScale||0,i.maxScale||0)}_graphicScale(e){let i;if(null!=e.centroid?i=e.centroid:null!=e.graphic.geometry&&"point"===e.graphic.geometry.type&&(i=e.graphic.geometry),i){return this.graphicsCoreOwner.view.basemapTerrain?this.graphicsCoreOwner.view.basemapTerrain.getScale(i):1}return null}_graphicVisible(e){if(!this.layerScaleEnabled)return!0;const i=this._graphicScale(e);return this._visibleAtLayerScale(i)}updateVisibility(e){if(this._scaleRangeActive){const i=this._graphicVisible(e);return e.setVisibilityFlag(p.VisibilityGroup.GRAPHIC,p.VisibilityFlag.SCALE_RANGE,i)}return!1}updateGraphicLabelScaleVisibility(e){if(!this._scaleRangeActive)return!1;if(!e.labelLayers||0===e.labelLayers.length)return!1;const i=this._graphicScale(e),t=this._updateLabelScaleVisibility(e,i);return t&&(this.graphicsCore.deconflictor?.setDirty(),this.graphicsCore.labeler?.setDirty()),t}_updateLabelScaleVisibility(e,i){if(!e.labelLayers||0===e.labelLayers.length)return!1;const t=e.labelLayers[0]._labelClass;if(null!=t?.minScale&&null!=t.maxScale){const a=this._visibleAtLabelScale(i,t);if(e.setVisibilityFlag(p.VisibilityGroup.LABEL,p.VisibilityFlag.SCALE_RANGE,a))return!0}return!1}_scaleUpdateHandler(e){if(this._setDirty(),!this.graphicsCore.visible)return;const i=e.extent,t=e.scale,r=this._visibleAtLayerScale(t);let s=!1;const l=this.graphicsCoreOwner.view.spatialReference,n=e.spatialReference;if(null==n)return void a.getLogger(this).error("scaleUpdate: Internal error, no SpatialReference given for tiles");const c=!n.equals(l);if(c){if(!o.projectBoundingRect(i,n,_,l))return void a.getLogger(this).error("scaleUpdate: Internal error, cannot project AABR from "+n+" to wkid "+l)}const h=c?_:i;this.queryGraphicUIDsInExtent(h,l,(e=>{const a=this.graphicsCore.getGraphics3DGraphicById(e);if(null==a)return;const l=a.centroid;null!=l&&(i[0]>l.x||i[1]>l.y||i[2]<l.x||i[3]<l.y)||(a.setVisibilityFlag(p.VisibilityGroup.GRAPHIC,p.VisibilityFlag.SCALE_RANGE,r)&&(s=!0),this._updateLabelScaleVisibility(a,t)&&(s=!0))})),s&&(this.graphicsCore.deconflictor?.setDirty(),this.graphicsCore.labeler?.setDirty())}layerMinMaxScaleChangeHandler(){this.updateScaleRangeActive()&&!this._scaleRangeActive?this.graphicsCore.modifyGraphics3DGraphicVisibilities((e=>e.setVisibilityFlag(p.VisibilityGroup.GRAPHIC,p.VisibilityFlag.SCALE_RANGE,!0))):this._scaleRangeActive&&this.graphicsCore.updateGraphicsVisibilities(),this._setDirty()}},i.__decorate([r.property()],e.Graphics3DScaleVisibility.prototype,"graphicsCoreOwner",void 0),i.__decorate([r.property()],e.Graphics3DScaleVisibility.prototype,"layer",void 0),i.__decorate([r.property()],e.Graphics3DScaleVisibility.prototype,"queryGraphicUIDsInExtent",void 0),i.__decorate([r.property()],e.Graphics3DScaleVisibility.prototype,"graphicsCore",void 0),i.__decorate([r.property()],e.Graphics3DScaleVisibility.prototype,"basemapTerrain",void 0),i.__decorate([r.property({constructOnly:!0})],e.Graphics3DScaleVisibility.prototype,"layerScaleEnabled",void 0),i.__decorate([r.property({readOnly:!0})],e.Graphics3DScaleVisibility.prototype,"suspended",void 0),i.__decorate([r.property({readOnly:!0})],e.Graphics3DScaleVisibility.prototype,"updating",null),i.__decorate([r.property()],e.Graphics3DScaleVisibility.prototype,"_dirty",void 0),e.Graphics3DScaleVisibility=i.__decorate([n.subclass("esri.views.3d.layers.graphics.Graphics3DScaleVisibility")],e.Graphics3DScaleVisibility);const b="terrain-events",_=h.create();Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
