/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../core/Error","../../../../core/has","../../../../core/maybe","../../../../core/promiseUtils","../../../../core/screenUtils","../../../../core/libs/gl-matrix-2/factories/vec2f64","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../core/libs/gl-matrix-2/factories/vec4f64","../../../../symbols/callouts/calloutUtils","./ElevationAligners","./elevationAlignmentUtils","./ElevationContext","./Graphics3DObject3DGraphicLayer","./Graphics3DObjectMetadata","./Graphics3DSymbolLayer","./graphicUtils","./LabelParameters","./placementUtils","./pointUtils","../../webgl-engine/lib/FontMetrics","../../webgl-engine/lib/GeometryUtil","../../webgl-engine/lib/TextRenderParameters","../../webgl-engine/lib/TextTextureFactory","../../webgl-engine/materials/HUDMaterial"],(function(e,t,n,r,a,i,l,s,o,c,h,d,m,u,p,f,g,y,b,x,v,O,P,S,E){"use strict";const G=s.freeze(0,0,1);class L extends f.Graphics3DSymbolLayer{constructor(e,t,n,r){super(e,t,n,r),this._elevationOptions={supportsOffsetAdjustment:!0,supportsOnTheGround:!1},this.ensureDrapedStatus(!1)}async doLoad(){if(!this._drivenProperties.size){const e=g.validateSymbolLayerSize(this.symbolLayer.size);if(e)throw new t("graphics3dtextsymbollayer:invalid-size",e)}await this._createTextRenderParameters()}async _createTextRenderParameters(){const e=this._context.graphicsCoreOwner.view.state.rasterPixelRatio;this._textRenderParameters=await P.TextRenderParameters.fromSymbol(this.symbolLayer,e)}destroy(){super.destroy()}createGraphics3DGraphic(e){const t=e.graphic,n=x.placePointOnGeometry(t.geometry);if(null==n)return this.logger.warn(`unsupported geometry type for text symbol: ${t.geometry.type}`),null;const r=this.symbolLayer.text;if(null==r||""===r)return null;const a=c.hasCalloutSupport(this.symbol)&&this.symbol.hasVisibleVerticalOffset()?this.symbol.verticalOffset:null;if(null!=a&&!c.textSymbolLayerSupportsVerticalOffset(this.symbolLayer))return this.logger.errorOncePerTick(`Callouts and vertical offset on text symbols are currently only supported with 'center' horizontal alignment (not with '${this.symbolLayer.horizontalAlignment}' alignment)`),null;const{verticalAlignment:i}=this.symbolLayer,l=new y.LabelPlacement(a);b.verticalScreenOffsetFromAlignment(i,l.screenOffset);const s=new y.LabelParameters(l,this.symbolLayer.horizontalAlignment,b.verticalPlacementFromAlignment(i));return this._createAs3DShape(t,n,r,s)}createLabel(e,t,n,r,a){const i=e.graphic,l=x.placePointOnGeometry(i.geometry);if(null==l)return this.logger.warn(`unsupported geometry type for label: ${i.geometry.type}`),null;const s=t.text;return!s||/^\s+$/.test(s)?null:this._createAs3DShape(i,l,s,t,n,r,a)}setGraphicElevationContext(e,t,n=0){return super.setGraphicElevationContext(e,t),t.addOffsetRenderUnits(n),t}layerOpacityChanged(){return this.logger.warn("layer opacity change not yet implemented in Graphics3DTextSymbolLayer"),!1}layerElevationInfoChanged(e,t){return _(e,t,((e,t)=>{this.updateGraphicElevationContext(t,e)})),d.SymbolUpdateType.UPDATE}slicePlaneEnabledChanged(e,t){return _(e,t,(e=>{for(const t of e.stageObject.geometries)t.material.setParameters({hasSlicePlane:this._context.slicePlaneEnabled})})),!0}physicalBasedRenderingChanged(){return!0}get pixelRatioChanged(){return!1}updateGraphicElevationContext(e,t){const n=t.elevationContext;this.setGraphicElevationContext(e,n,null!=t.metadata?t.metadata.elevationOffset:0),t.needsElevationUpdates=d.needsElevationUpdates2D(n.mode)||"absolute-height"===n.mode}updateGeometry(e,t){if(this.draped||!this._validateGeometry(t))return!1;const{elevationContext:n,stageObject:r}=e;if(n.mode!==this.getGeometryElevationMode(t))return!1;const a=x.placePointOnGeometry(t);if(!a)return!1;const i=x.updateStageObjectGeometry(r,this._context,a,n);if(null==i)return!1;const l=x.getLocalOriginForPoint(this._context,a);return r.geometries[0].localOrigin===l&&(e.alignedSampledElevation=i,x.extendPointGraphicElevationContext(e,a,this._context.elevationProvider),!0)}_defaultElevationInfoNoZ(){return z}_createAs3DShape(e,t,s,c,f=null,g=null,y=()=>c.placement.elevationOffset){const P=this.setGraphicElevationContext(e,new m.ElevationContext,c.placement.elevationOffset),L="polyline"===e.geometry?.type,_=e.uid;let z=null,C=null;if(null==g){const e=b.textRenderAlignmentFromHorizontalPlacement(c.horizontalPlacement);z=new S(s,e,this._textRenderParameters);let t=null;if(null!=this._context.sharedResources.textures){C=this._context.sharedResources.textures.fromData(z.key,(()=>z.create())),C.texture.events.on("unloaded",(()=>t=r.releaseMaybe(t)));const e=this._context.stage.renderView.textures.acquire(C.texture.id);if(null==e||a.isPromiseLike(e))return C.release(),null;t=e}}const D=!!n("enable-feature:non-occluded-hud"),U=w(z,c),A={occlusionTest:!D,occludedFragmentFade:D,horizonCullingEnabled:D,screenOffset:c.placement.screenOffset,anchorPosition:U,polygonOffset:!0,color:[1,1,1,1],centerOffsetUnits:c.placement.centerOffsetUnits,depthEnabled:!1,drawInSecondSlot:!0,isLabel:!0};if(L&&(A.shaderPolygonOffset=1e-4),g?A.textureId=g.id:C&&(A.textureId=C.texture.id),null!=c.placement.verticalOffset){const{screenLength:e,minWorldLength:t,maxWorldLength:n}=c.placement.verticalOffset;A.verticalOffset={screenLength:i.pt2px(e),minWorldLength:t||0,maxWorldLength:null!=n?n:1/0}}const T={screenOffset:A.screenOffset,anchorPosition:U,centerOffsetUnits:A.centerOffsetUnits,verticalOffset:A.verticalOffset,shaderPolygonOffset:A.shaderPolygonOffset,occlusionTest:A.occlusionTest};if(this._context.screenSizePerspectiveEnabled){const{screenSizePerspectiveSettings:e,screenSizePerspectiveSettingsLabels:t}=this._context.sharedResources,n=v.getFontMetrics(this._textRenderParameters);A.screenSizePerspective=t.overrideFontHeight(n.maxHeight),A.screenSizePerspectiveAlignment=e,T.fontHeight=n.maxHeight}A.hasSlicePlane=this._context.slicePlaneEnabled;const R=this._context.spherical,j=f?JSON.stringify(T):"";let F=f?.get(j);null==F&&(F=new E.HUDMaterial(A,R),f?.add(j,F));const H=c.placement.translation,M=z?l.fromValues(z.displayWidth,z.displayHeight):l.ZEROS,V=c.placement.centerOffset,W=G,I=g?o.fromValues(0,0,0,0):null,$=O.createPointGeometry(F,W,H,null,null,M,V,I,null),k=x.createStageObject(this._context,t,$,P,_);if(null==k)return null;const N=(t,n,r,a,i,l)=>{const s=y()||c.placement.elevationOffset,o=this.setGraphicElevationContext(e,n,s);return h.perObjectElevationAligner(t,o,r,a,i,l)},Z=new u.Graphics3DObject3DGraphicLayer(this,k.object,[$],null==f?[F]:null,C,N,P);Z.alignedSampledElevation=k.sampledElevation,Z.needsElevationUpdates=d.needsElevationUpdates2D(P.mode)||"absolute-height"===P.mode,Z.getScreenSize=(e=l.create())=>(e[0]=z?z.displayWidth:c.displaySize[0],e[1]=z?z.displayHeight:c.displaySize[1],e);const q=new p.Graphics3DObjectMetadata(c.placement.elevationOffset,s);return Z.metadata=q,x.extendPointGraphicElevationContext(Z,t,this._context.elevationProvider),Z}}function _(e,t,n){e&&e.forEach((e=>{const r=t(e);null!=r&&n(r,e.graphic)}))}function w(e,t){if("baseline"===t.verticalPlacement){const n=b.horizontalPlacementToAnchorX[t.horizontalPlacement],r=null!=e?e.baselineAnchorY:0;return l.fromValues(n,r)}const n=b.anchorFromPlacements(t.horizontalPlacement,t.verticalPlacement);return b.namedAnchorToHUDMaterialAnchorPos[n]}const z={mode:"relative-to-ground",offset:0};e.Graphics3DTextSymbolLayer=L,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
