/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../chunks/tslib.es6","../../../../Graphic","../../../../core/Accessor","../../../../core/handleUtils","../../../../core/maybe","../../../../core/promiseUtils","../../../../core/reactiveUtils","../../../../core/accessorSupport/decorators/property","../../../../core/has","../../../../core/Logger","../../../../core/RandomLCG","../../../../core/accessorSupport/decorators/subclass","../../../../core/accessorSupport/diffUtils","../../../../core/support/UpdatingHandles","../../../../layers/Layer","../../../../layers/graphics/hydratedFeatures","../../../../renderers/support/renderingInfoUtils","../../../../rest/support/Query","../interfaces","./constants","./Graphics3DCore","./Graphics3DElevationAlignment","./Graphics3DFrustumVisibility","./Graphics3DObjectStates","./Graphics3DScaleVisibility","./graphicUtils","../support/highlightUtils","../../webgl-engine/lib/UpdatePolicy"],(function(e,t,i,r,s,o,a,n,c,p,l,h,u,d,y,g,b,_,m,f,G,C,P,w,V,v,E,S,x){"use strict";e.GraphicsProcessor=class extends r{constructor(e){super(e),this.type="graphics-3d",this.graphicsCore=null,this.drapeSourceType=f.DrapeSourceType.Features,this.scaleVisibilityEnabled=!1,this.frustumVisibilityEnabled=!1,this._suspendResumeExtent=null,this._updatingHandles=new y.UpdatingHandles}initialize(){const{layer:e}=this,t="effectiveScaleRange"in e?e:null,i=this.scaleVisibilityEnabled&&null!=t,r=new C.Graphics3DCore({owner:this,layer:this.owner.layer,preferredUpdatePolicy:x.UpdatePolicy.SYNC,graphicSymbolSupported:!0,componentFactories:{elevationAlignment:(e,t)=>new P.Graphics3DElevationAlignment({graphicsCoreOwner:this,graphicsCore:e,queryGraphicUIDsInExtent:t,elevationProvider:this.view.elevationProvider}),scaleVisibility:i?(e,i)=>new v.Graphics3DScaleVisibility({graphicsCoreOwner:this,layer:t,queryGraphicUIDsInExtent:i,graphicsCore:e,basemapTerrain:this.owner.view.basemapTerrain}):null,objectStates:e=>new V.Graphics3DObjectStates(e)}});if(this._set("graphicsCore",r),this.frustumVisibilityEnabled&&this._set("frustumVisibility",new w.Graphics3DFrustumVisibility({graphicsCoreOwner:this})),"fullOpacity"in this.owner){const e=this.owner;this._updatingHandles.add((()=>e.fullOpacity),(()=>this.graphicsCore.opacityChange()))}if("elevationInfo"in e){const t=e;this._updatingHandles.add((()=>t.elevationInfo),((e,t)=>{d.diff(e,t)&&this._updatingHandles.addPromise(this.graphicsCore.elevationInfoChange())}))}this._set("initializePromise",this._initializeAsync()),this._updatingHandles.addPromise(this.initializePromise)}async _initializeAsync(){try{await this.graphicsCore.initializePromise}catch(e){if(a.isAbortError(e))return;throw e}this.destroyed||(this.addHandles(n.watch((()=>this.view.clippingArea),(()=>this._updateClippingExtent()),n.sync)),this._updateClippingExtent(),this._setupSuspendResumeExtent(),this.graphicsCore.startCreateGraphics())}destroy(){this._updatingHandles.destroy(),this._set("frustumVisibility",o.destroyMaybe(this.frustumVisibility)),this._set("graphicsCore",o.destroyMaybe(this.graphicsCore))}get layer(){return this.owner.layer}get view(){return this.owner.view}get scaleVisibility(){return this.graphicsCore?.scaleVisibility}get elevationAlignment(){return this.graphicsCore?.elevationAlignment}get scaleVisibilitySuspended(){return!(null==this.scaleVisibility||!this.scaleVisibility.suspended)}get frustumVisibilitySuspended(){return null!=this.frustumVisibility&&this.frustumVisibility.suspended}get suspended(){return this.owner.suspended??!1}get updating(){return!!(this.graphicsCore?.updating||null!=this.scaleVisibility&&this.scaleVisibility.updating||null!=this.frustumVisibility&&this.frustumVisibility.updating||this._updatingHandles.updating)}get graphics3DGraphics(){return this.graphicsCore?.graphics3DGraphics}get graphics3DGraphicsByObjectID(){return this.graphicsCore?.graphics3DGraphicsByObjectID}get loadedGraphics(){return this.owner.loadedGraphics}get fullOpacity(){return this.owner.fullOpacity??1}get slicePlaneEnabled(){return this.owner.slicePlaneEnabled}get updatePolicy(){return this.owner.updatePolicy}notifyGraphicGeometryChanged(e){this.graphicsCore.notifyGraphicGeometryChanged(e)}notifyGraphicVisibilityChanged(e){this.graphicsCore.notifyGraphicVisibilityChanged(e)}getRenderingInfo(e,t,i){const r=_.getRenderingInfo(e,{renderer:t,arcade:i});if(r?.color){const e=r.color;e[0]=e[0]/255,e[1]=e[1]/255,e[2]=e[2]/255}return r}getRenderingInfoAsync(e,t,i,r){return _.getRenderingInfoAsync(e,{renderer:t,arcade:i,...r})}getHit(e){if(this.owner.loadedGraphics){const t=this.owner.loadedGraphics.find((t=>t.uid===e));if(t){const e=this.layer instanceof g?this.layer:null,i=b.hydrateGraphic(t,e);return{type:"graphic",graphic:i,layer:i.layer}}}return null}whenGraphicBounds(e,t){return this.graphicsCore?this.graphicsCore.whenGraphicBounds(e,t):Promise.reject()}computeAttachmentOrigin(e,t){return this.graphicsCore?this.graphicsCore.computeAttachmentOrigin(e,t):null}getSymbolLayerSize(e,t){return this.graphicsCore?this.graphicsCore.getSymbolLayerSize(e,t):null}maskOccludee(e){const t=this.graphicsCore?.objectStates;if(!t)return s.makeHandle();const{set:i,handle:r}=t.acquireOccludeeSet(null);return t.setUid(i,e.uid),r}highlight(e,t){const r=this.graphicsCore?.objectStates;if(!r)return O;if(e instanceof m)return O;const s=S.normalizeHighlightTargetExceptQuery(e);if(0===s.length)return O;if(s[0]instanceof i){const e=s.map((e=>e.uid)),{set:i,handle:o}=r.acquireHighlightSet(t,null);return r.setUids(i,e),o}if("number"==typeof s[0]){const e=s,{set:i,handle:o}=r.acquireHighlightSet(t,null);return r.setObjectIds(i,e),o}return O}_setupSuspendResumeExtent(){const{scaleVisibility:e,frustumVisibility:t}=this;if(null==e&&null==t)return;const i=({computedExtent:i,extentPadding:r})=>{this._suspendResumeExtent=E.enlargeExtent(i,this._suspendResumeExtent,G.suspendResumeExtentOptimism,r),null!=e&&e.setExtent(this._suspendResumeExtent),null!=t&&t.setExtent(this._suspendResumeExtent)};this.addHandles(n.watch((()=>({computedExtent:this.graphicsCore?.computedExtent,extentPadding:this.graphicsCore?.extentPadding})),(e=>i(e)),n.syncAndInitial))}_updateClippingExtent(){const e=this.view.clippingArea;this.graphicsCore.setClippingExtent(e,this.view.spatialReference)&&this.graphicsCore.recreateAllGraphics()}},t.__decorate([c.property()],e.GraphicsProcessor.prototype,"type",void 0),t.__decorate([c.property({constructOnly:!0})],e.GraphicsProcessor.prototype,"owner",void 0),t.__decorate([c.property()],e.GraphicsProcessor.prototype,"layer",null),t.__decorate([c.property()],e.GraphicsProcessor.prototype,"view",null),t.__decorate([c.property({constructOnly:!0})],e.GraphicsProcessor.prototype,"graphicsCore",void 0),t.__decorate([c.property()],e.GraphicsProcessor.prototype,"scaleVisibility",null),t.__decorate([c.property({constructOnly:!0})],e.GraphicsProcessor.prototype,"frustumVisibility",void 0),t.__decorate([c.property()],e.GraphicsProcessor.prototype,"elevationAlignment",null),t.__decorate([c.property()],e.GraphicsProcessor.prototype,"scaleVisibilitySuspended",null),t.__decorate([c.property({readOnly:!0})],e.GraphicsProcessor.prototype,"frustumVisibilitySuspended",null),t.__decorate([c.property()],e.GraphicsProcessor.prototype,"suspended",null),t.__decorate([c.property({readOnly:!0})],e.GraphicsProcessor.prototype,"updating",null),t.__decorate([c.property()],e.GraphicsProcessor.prototype,"loadedGraphics",null),t.__decorate([c.property()],e.GraphicsProcessor.prototype,"fullOpacity",null),t.__decorate([c.property()],e.GraphicsProcessor.prototype,"slicePlaneEnabled",null),t.__decorate([c.property()],e.GraphicsProcessor.prototype,"drapeSourceType",void 0),t.__decorate([c.property()],e.GraphicsProcessor.prototype,"updatePolicy",null),t.__decorate([c.property({constructOnly:!0})],e.GraphicsProcessor.prototype,"scaleVisibilityEnabled",void 0),t.__decorate([c.property({constructOnly:!0})],e.GraphicsProcessor.prototype,"frustumVisibilityEnabled",void 0),t.__decorate([c.property()],e.GraphicsProcessor.prototype,"initializePromise",void 0),e.GraphicsProcessor=t.__decorate([u.subclass("esri.views.3d.layers.graphics.GraphicsProcessor")],e.GraphicsProcessor);const O=s.makeHandle();Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
