/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../chunks/tslib.es6","../../../../core/Accessor","../../../../core/asyncUtils","../../../../core/has","../../../../core/Logger","../../../../core/maybe","../../../../core/promiseUtils","../../../../core/reactiveUtils","../../../../core/accessorSupport/decorators/property","../../../../core/RandomLCG","../../../../core/accessorSupport/decorators/subclass","../../../../core/libs/gl-matrix-2/factories/vec2f64","../../../../layers/graphics/hydratedFeatures","../../../../layers/support/labelFormatUtils","../../../../symbols/callouts/calloutUtils","./enums","./Graphics3DCalloutSymbolLayerFactory","./Graphics3DLineCalloutSymbolLayer","./graphicSymbolUtils","./LabelParameters","./labelPlacement","./placementUtils","../../../../geometry/support/Indices","./pipeline/rendering/FeaturePipelineRenderManager","../../webgl-engine/lib/BoundingInfo","../../webgl-engine/lib/VertexAttribute","../../../ViewingMode","../../support/buffer/InterleavedLayout","../../webgl-engine/core/shaderLibrary/ShaderOutput","../../webgl-engine/core/shaderLibrary/attributes/NormalAttribute.glsl","../../webgl-engine/core/shaderLibrary/output/Emissions.glsl","../../webgl-engine/core/shaderLibrary/shading/Normals.glsl","../../webgl-engine/core/shaderLibrary/shading/PhysicallyBasedRenderingParameters.glsl","../../webgl-engine/lib/basicInterfaces","../../webgl-engine/core/shaderModules/interfaces","../../webgl-engine/lib/Material","../../webgl-engine/lib/OrderIndependentTransparency","../../webgl-engine/lib/RayIntersections","../../webgl-engine/lib/RenderSlot","../../webgl-engine/lib/verticalOffsetUtils","../../../../geometry/support/buffer/BufferView","../../../../core/mathUtils","../../../../chunks/boundedPlane","../../../../geometry/support/Axis","../../../../geometry/support/ray","../../../../geometry/support/vectorStacks","../../webgl-engine/core/shaderTechnique/BindType","../../webgl-engine/lib/DefaultVertexAttributeLocations","../../../../core/HeapSort","../../../webgl/checkWebGLError","../../../webgl/enums","../../../webgl/renderState","../../webgl-engine/lib/OITPass","../../webgl-engine/lib/StencilUtils","../support/symbolColorUtils","../../webgl-engine/core/shaderLibrary/attributes/TextureCoordinateAttribute.glsl","../support/FastSymbolUpdates","../../webgl-engine/effects/ssao/SSAO","../../webgl-engine/core/shaderModules/ShaderBuilder","../../webgl-engine/shaders/DefaultMaterialTechniqueConfiguration","../../webgl-engine/lib/MaterialCollection","../../webgl-engine/lib/TextRenderer","../../webgl-engine/lib/TextRenderParameters","../../webgl-engine/lib/TextTextureAtlas","../../webgl-engine/lib/WebGLLayer","../../../support/Scheduler","../../../support/Yield"],(function(e,t,i,l,s,a,r,n,o,c,h,b,g,u,d,y,p,f,x,C,m,_,L,w,v,A,G,D,I,T,S,P,R,V,E,O,F,M,U,z,H,k,B,N,W,j,q,Y,Z,$,J,K,Q,X,ee,te,ie,le,se,ae,re,ne,oe,ce,he,be,ge,ue){"use strict";class de{constructor(e,t){this.labelingContext=e,this.graphics3DGraphic=t,this.hasGraphics3DResources=!1,this.visible=!1,this.textureAtlasHandles=[],this.textInitialized=!1,this.textRenderers=new Array,this.textLabelPlacements=new Array}}class ye{constructor(e,t,i,l,s){this.labelClass=e,this.graphics3DSymbol=t,this.graphics3DCalloutSymbolLayer=i,this.textRenderParameters=l,this.labelFunction=s,this.calloutSymbolLayerIndex=0}}class pe{constructor(e,t,i,l,s,a,r,n){this.layer=t,this.graphics3DCore=i,this.scaleVisibility=l,this.emptySymbolLabelSupported=s,this.elevationInfoOverride=a,this.disablePlacement=r,this.active=n,this.labelClassAbortController=new AbortController,this.labelClassContexts=new Array,this.graphics=new Map,this.labelsToInitialize=new Map,this.stageLayer=new be.WebGLLayer(e,{pickable:!0,disableOctree:!0},t.uid)}destroy(){this.stageLayer.destroy()}}function fe(e,t){e.geometries[0].setAttributeData(G.VertexAttribute.SIZE,[t.displayWidth,t.displayHeight]),e.geometryVertexAttributeUpdated(e.geometries[0],G.VertexAttribute.SIZE)}function xe(e,t){e.geometries[0].setAttributeData(G.VertexAttribute.UV0,t),e.geometryVertexAttributeUpdated(e.geometries[0],G.VertexAttribute.UV0,!0)}function Ce(e){return!!e.labelClassPromise&&!!e.labelClassAbortController}function me(e){return!e||0===e.length}function _e(e){return!0===e.labelsVisible&&!!e.labelingInfo?.some((e=>!!e.symbol))}e.Labeler=class extends i{constructor(e){super(e),this._dirty=!1,this._labels=new Map,this._labelingContexts=new Array}setup(){this.dispose(),this.addHandles([o.watch((()=>this.view.state?.camera),(()=>this.setDirty())),o.watch((()=>this.view.state?.rasterPixelRatio),(()=>this._resetAllLabels())),this.view.resourceController.scheduler.registerTask(ge.TaskPriority.LABELER,this)]),this._textTextureAtlas=new he.TextTextureAtlas({view:this.view}),this._hudMaterialCollection=new ne.MaterialCollection(this.view._stage),this._calloutMaterialCollection=new ne.MaterialCollection(this.view._stage)}dispose(){this.removeAllHandles(),this._textTextureAtlas=r.disposeMaybe(this._textTextureAtlas),this._hudMaterialCollection=r.disposeMaybe(this._hudMaterialCollection),this._calloutMaterialCollection=r.disposeMaybe(this._calloutMaterialCollection),this._labelingContexts.length=0,this._labels.clear()}destroy(){this.dispose(),Le.graphic=null,Le.renderingInfo=null,Le.layer=null}_activateLabelingContext(e){e.graphics.forEach(((t,i)=>{const l=new de(e,t);this._labels.set(i,l),e.labelsToInitialize.set(i,l),t.setVisibilityFlag(p.VisibilityGroup.LABEL,p.VisibilityFlag.USER,!0)})),e.active=!0}_deactivateLabelingContext(e){e.graphics.forEach(((e,t)=>{e.setVisibilityFlag(p.VisibilityGroup.LABEL,p.VisibilityFlag.USER,!1),this.setLabelGraphicVisibility(e,!1),e.clearLabelGraphics(),this._labels.delete(t)})),e.active=!1}_addLabelTextureToAtlas(e){for(const t of e.graphics3DGraphic.labelLayers){if(!t._labelClass)continue;const i=e.textRenderers[t._labelIndex];i&&(e.textureAtlasHandles.push(this._textTextureAtlas.addText(i,(e=>xe(t.stageObject,e)))),fe(t.stageObject,i))}}_removeLabelTextureFromAtlas(e){e.textureAtlasHandles.forEach((e=>e.remove())),e.textureAtlasHandles.length=0}get running(){return this.view.ready&&(this._dirty||this.deconflictor.running)}runTask(e){return this._updateLabels(e),!this._dirty&&this.deconflictor.running&&this.deconflictor.runTask(e),ue.Yield}_updateLabels(e){if(this._dirty){this._dirty=!1;for(const t of this._labelingContexts)if(t.active)if(Ce(t))this._dirty=!0;else if(me(t.labelClassContexts)){if(null===t.labelClassContexts){this._deactivateLabelingContext(t);continue}this._createLabelClassContext(t),this._dirty=!0}else for(const[i,l]of t.labelsToInitialize)if(this._ensureGraphics3DResources(l)&&(this._labels.set(i,l),this.deconflictor.setDirty(),e.madeProgress()),(l.visible&&l.textInitialized||!l.visible&&l.hasGraphics3DResources)&&(t.labelsToInitialize.delete(i),e.madeProgress()),e.done){this._dirty=!0;break}this._dirty||this.notifyChange("updating")}}async _createLabelClassContextAsync(e){const t=e.labelClassAbortController?.signal;e.layer.when&&await e.layer.when(),n.throwIfAborted(t),e.scaleVisibility?.updateScaleRangeActive();const i=e.graphics3DCore,s=i.layer,r=s.labelingInfo?.filter((e=>!!e.symbol));if(!r||0===r.length)return;let o=!1;await l.forEach(r,(async(s,r)=>{const c=s.symbol,h=C.getGraphics3DSymbol(i.getOrCreateGraphics3DSymbol(c));if(null==h)return void a.getLogger(this).error("Failed to create Graphics3DSymbol for label");await h.load(),n.throwIfAborted(t);let b=null;y.hasCalloutSupport(c)&&c.hasVisibleCallout()&&(b=f.make(c,i.symbolCreationContext),await b.load(),n.throwIfAborted(t));const g=await l.result(d.createLabelFunction(s,e.layer.fieldsIndex,this.view.spatialReference));if(n.throwIfAborted(t),!0===g.ok){const i=await this._createTextRenderParameters(h.symbol);n.throwIfAborted(t),e.labelClassContexts[r]=new ye(s,h,b,i,g.value)}else a.getLogger(this).error(`Label expression failed to evaluate: ${g.error}`),o=!0})),n.throwIfAborted(t)}async _createLabelClassContext(e){return null==e.labelClassPromise&&(e.labelClassPromise=this._createLabelClassContextAsync(e).catch((t=>{if(n.isAbortError(t))throw t;e.labelClassContexts.length=0})).then((()=>{e.labelClassAbortController=null,this.notifyChange("updating")})).catch((()=>{})),this.notifyChange("updating")),e.labelClassPromise}async _createTextRenderParameters(e){const t=e.symbolLayers.at(0);return"text"!==t?.type?null:ce.TextRenderParameters.fromSymbol(t,this.view.state.rasterPixelRatio)}_destroyLabelClassContext(e){for(const i of e.labelClassContexts)--i.graphics3DSymbol.referenced;const t=e.labelClassAbortController;e.labelClassAbortController=new AbortController,r.abortMaybe(t),e.labelClassContexts.length=0,e.labelClassPromise=null,this.notifyChange("updating")}_createTextSymbolGraphic(e,t,i,l,s,a){const r=new m.LabelParameters(i,L.horizontalPlacementFromAnchor(i.anchor),L.verticalPlacementFromAnchor(i.anchor),e.text,g.fromValues(e.displayWidth,e.displayHeight));return Le.graphic=t,Le.renderingInfo=null,Le.layer=l,s.createLabel(Le,r,this._hudMaterialCollection,this._textTextureAtlas,(()=>{const e=_.getLabelPlacement(a);return e?e.elevationOffset:null}))}_createLineCalloutGraphic(e,t,i,l,s){Le.graphic=e,Le.layer=s;const a=l.screenOffset[0];return Le.renderingInfo=new x.LineCalloutSymbolLayerRenderingInfo(null,t,l.translation,l.centerOffset,a,l.centerOffsetUnits,l.elevationOffset,this._calloutMaterialCollection),i.createGraphics3DGraphic(Le)}_ensureGraphics3DResources(e){if(e.hasGraphics3DResources)return!1;const t=e.graphics3DGraphic;if(t.destroyed)return!1;this._ensureTextTextureResources(e);const i=e.labelingContext,l=i.labelClassContexts;if(me(l)||!i.emptySymbolLabelSupported&&0===t.layers.length)return!1;let s=!1;const a=t.graphic,r=i.layer,n=_e(i.layer);for(let o=0;o<l.length;o++){const c=e.textRenderers[o],h=e.textLabelPlacements[o];if(null==c||null==h)continue;const b=l[o],g=b.graphics3DSymbol,u=g.symbol&&"label-3d"===g.symbol.type?g.symbol:null,d=g.symbolLayers[0];if(!d)continue;d.setElevationInfoOverride(i.elevationInfoOverride);const y=new _.LabelInfo(t,u,b.labelClass),f=this._createTextSymbolGraphic(c,a,h,r,d,y);if(null==f)return!1;f._labelClass=b.labelClass,f._labelIndex=o,t.addLabelGraphic(f,i.stageLayer),t.deconflictionPriority=b.textRenderParameters?.definition.size??0,t.setVisibilityFlag(p.VisibilityGroup.LABEL,p.VisibilityFlag.USER,n),t.setVisibilityFlag(p.VisibilityGroup.LABEL,p.VisibilityFlag.SCALE_RANGE,!0),t.setVisibilityFlag(p.VisibilityGroup.LABEL,p.VisibilityFlag.DECONFLICTION,!1),s=!0;const x=b.graphics3DCalloutSymbolLayer;if(x&&h.hasLabelVerticalOffset){x.setElevationInfoOverride(i.elevationInfoOverride);const e=this._createLineCalloutGraphic(a,u,x,h,r);null!=e&&(b.calloutSymbolLayerIndex=t.labelLayers.length,t.addLabelGraphic(e,i.stageLayer))}break}return s&&i.scaleVisibility?.updateGraphicLabelScaleVisibility(t),e.hasGraphics3DResources=!0,!0}_destroyGraphics3DResources(e){const t=e.labelingContext.labelClassContexts;for(const i of e.graphics3DGraphic.labelLayers){if(null==i._labelClass)continue;const e=t[i._labelIndex].graphics3DSymbol.symbolLayers[0];e?.onRemoveGraphic(i)}e.graphics3DGraphic.deconflictionPriority=0,e.graphics3DGraphic.clearLabelGraphics(),e.hasGraphics3DResources=!1}_ensureTextTextureResources(e){if(e.textInitialized)return;const t=e.labelingContext,i=t.labelClassContexts;if(me(i))return;const l=e.graphics3DGraphic.graphic;for(let a=0;a<i.length;a++){const r=i[a];if(e.textRenderers[a]=null,e.textLabelPlacements[a]=null,null==r?.textRenderParameters)continue;const n=r.labelFunction;let o;if("arcade"===n.type)try{const e=n.needsHydrationToEvaluate()?u.hydrateGraphic(l,t.layer):l;o=n.evaluate(e)}catch(s){o=null}else o=n.evaluate(l);if(null==o||""===o||/^\s+$/.test(o))continue;const c=r.graphics3DSymbol,h="label-3d"===c.symbol?.type?c.symbol:null;if(!c.symbolLayers[0])continue;const b=e.graphics3DGraphic,g=r.labelClass,d=t.disablePlacement,y=_.getLabelPlacement({graphics3DGraphic:b,labelSymbol:h,labelClass:g,disablePlacement:d});if(null==y)continue;const p=L.horizontalPlacementFromAnchor(y.anchor),f=L.textRenderAlignmentFromHorizontalPlacement(p);e.textRenderers[a]=new oe.TextRenderer(o,f,r.textRenderParameters,he.TextTextureAtlas.maxSize),e.textLabelPlacements[a]=y}e.textInitialized=!0}_destroyTextTextureResources(e){e.textInitialized=!1,e.textRenderers.length=0,e.textLabelPlacements.length=0}_addGraphic(e,t){const i=t.graphic.uid;if(e.graphics.set(i,t),e.active){const l=new de(e,t);this._labels.set(i,l),e.labelsToInitialize.set(i,l)}this.setDirty(),this.deconflictor.setDirty()}_updateGraphicGeometry(e,t){const i=t.graphic.uid,l=this._labels.get(i);if(!l)return!0;for(const s of l.graphics3DGraphic.labelLayers){if(null==s._labelClass)continue;if(!e.labelClassContexts[s._labelIndex].graphics3DSymbol.symbolLayers[0].updateGeometry(s,t.graphic.geometry))return!1}return this.setDirty(),this.deconflictor.setDirty(),!0}_removeGraphic(e,t){const i=t.graphic.uid,l=this._labels.get(i);e.graphics.delete(i),l&&(this._destroyGraphic(l,i),e.labelsToInitialize.delete(i),this.setDirty(),this.deconflictor.setDirty())}_destroyGraphic(e,t){this._labels.delete(t),e.textureAtlasHandles.length&&this._removeLabelTextureFromAtlas(e),this._destroyTextTextureResources(e),e.hasGraphics3DResources&&this._destroyGraphics3DResources(e)}async _labelingInfoChange(e,t){if(!t)return this._visibilityInfoChange(e),this._resetLabels(e),this._createLabelClassContext(e);for(const i of t){const t=e.graphics.get(i);t&&(this._removeGraphic(e,t),this._addGraphic(e,t))}}_globalPropertyChanged(e,t){for(const i of t.labelClassContexts){const l=new Map;t.graphics.forEach((e=>l.set(e.graphic.uid,e)));const s=e=>e.labelLayers[0];if(i.graphics3DSymbol.symbolLayers[0].globalPropertyChanged(e,l,s),i.graphics3DCalloutSymbolLayer){const t=e=>e.labelLayers[i.calloutSymbolLayerIndex];i.graphics3DCalloutSymbolLayer.globalPropertyChanged(e,l,t)}}}_visibilityInfoChange(e){const t=_e(e.layer);t&&!e.active&&this._activateLabelingContext(e),!t&&e.active&&this._deactivateLabelingContext(e),this.setDirty()}_resetAllLabels(){for(const e of this._labelingContexts)this._resetLabels(e)}_resetLabels(e){e.graphics.forEach(((t,i)=>{const l=this._labels.get(i);l&&(this._destroyGraphic(l,i),l.visible=!1,e.labelsToInitialize.set(i,l))})),this._destroyLabelClassContext(e),this.setDirty(),this.deconflictor.setDirty()}_findLabelingContext(e){for(const t of this._labelingContexts)if(t.graphics3DCore===e)return t;return null}addGraphicsOwner(e,t,i){const l=i?.emptySymbolLabelSupported||!1,s=i?.elevationInfoOverride||null,a=i?.disablePlacement||null;if(this._findLabelingContext(e))return;const r=e.layer,n=new pe(this.view._stage,r,e,t,l,s,a,_e(r));return this._labelingContexts.push(n),this.setDirty(),{addGraphic:e=>this._addGraphic(n,e),removeGraphic:e=>this._removeGraphic(n,e),updateGraphicGeometry:e=>this._updateGraphicGeometry(n,e),layerLabelsEnabled:()=>_e(n.layer),labelingInfoChange:e=>this._labelingInfoChange(n,e),elevationInfoChange:()=>this._globalPropertyChanged("elevationInfo",n),slicePlaneEnabledChange:()=>this._globalPropertyChanged("slicePlaneEnabled",n),visibilityInfoChange:()=>this._visibilityInfoChange(n),reset:()=>this._resetLabels(n),remove:()=>this._removeGraphicsOwner(e),setDirty:()=>this.setDirty()}}_removeGraphicsOwner(e){const t=this._findLabelingContext(e);if(!t)return;const i=this._labelingContexts.indexOf(t);this._labelingContexts.splice(i,1),t.graphics.forEach((e=>this._removeGraphic(t,e))),t.destroy(),this.setDirty()}setLabelGraphicVisibility(e,t){const i=e.graphic.uid,l=this._labels.get(i);l&&l.visible!==t&&(t&&!l.textureAtlasHandles.length?(this._addLabelTextureToAtlas(l),l.textInitialized||l.labelingContext.labelsToInitialize.set(i,l)):!t&&l.textureAtlasHandles.length&&this._removeLabelTextureFromAtlas(l),l.visible=t,this.setDirty())}setDirty(){!this._dirty&&this._labelingContexts.length>0&&(this._dirty=!0,this.notifyChange("updating"))}get updating(){return this._dirty||this._textTextureAtlas?.updating||this.deconflictor.updating||this._labelingContexts.some((e=>Ce(e)))}get updatingProgress(){if(!this.updating||!this._textTextureAtlas)return 1;const e=this._labelingContexts.length>0?this._labelingContexts.reduce(((e,t)=>e+(Ce(t)?0:1)),0)/this._labelingContexts.length:1;return(this._dirty?0:.3)+(this._textTextureAtlas.updating?0:.1)+.1*e+.5*this.deconflictor.updatingProgress}get test(){}},t.__decorate([c.property({constructOnly:!0})],e.Labeler.prototype,"view",void 0),t.__decorate([c.property({constructOnly:!0})],e.Labeler.prototype,"deconflictor",void 0),t.__decorate([c.property()],e.Labeler.prototype,"_textTextureAtlas",void 0),t.__decorate([c.property({type:Boolean,readOnly:!0})],e.Labeler.prototype,"updating",null),e.Labeler=t.__decorate([b.subclass("esri.views.3d.layers.graphics.Labeler")],e.Labeler);const Le=new x.LineCalloutCreationContext(null,null,null);e.areLabelsVisible=_e,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
