/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../core/has","../../../../core/Logger","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../geometry/support/aaBoundingBox","./constants","./graphicSymbolUtils","./LabelParameters","../../webgl-engine/lib/TextRenderer","../../webgl-engine/materials/HUDMaterial"],(function(e,t,n,r,l,a,c,s,o,i,f){"use strict";const u=()=>n.getLogger("esri.views.3d.layers.graphics.labelPlacement");class b{constructor(e,t,n,r=null){this.graphics3DGraphic=e,this.labelSymbol=t,this.labelClass=n,this.disablePlacement=r}}function p(e){const t=C(e);if(null==t)return null;const n=h(e,t);if(null==n)return null;const r=n.anchor,l=!!t.hasLabelVerticalOffset,a=t.verticalOffset;return y(new o.LabelPlacement(a,r,l),n,e)}function h(e,t){if(t.anchor)return t;const n=e.labelClass.labelPlacement,r=x[n],l=r||d(e);return n&&!r&&u().warnOncePerTick(`the requested label placement '${n}' is currently unsupported in SceneView.`),g(l,e)}function m(e){const t=e.graphics3DGraphic.graphics3DSymbol,n=s.getGraphics3DSymbol(t);return null!=n?n.symbol.symbolLayers.at(0):null}function g(e,t){const n=t.graphics3DGraphic.graphic.geometry;if(null==n)return null;if(null!=t.disablePlacement){return t.labelClass.labelPlacement?(u().warnOncePerTick(O(e?.placement,t.disablePlacement.logEntityDescription)),d(t)):e}const r=n.type;switch(r){case"polyline":case"polygon":case"extent":case"multipoint":if(t.labelClass.labelPlacement)return u().warnOncePerTick(O(e?.placement,`'${r}' geometries`)),d(t);break;case"point":case"mesh":return e}return e}function O(e,t){return`the requested label placement '${e}' is currently unsupported for ${t} in SceneView.`}function d(e){const t=e.graphics3DGraphic.graphic.geometry;if(null==t)return null;switch(t.type){case"polyline":case"extent":case"multipoint":return{placement:"center-center",normalizedOffset:l.ZEROS,anchor:"center"};case"polygon":{const t=m(e);return null!=t&&"extrude"===t.type?x["above-center"]:{placement:"center-center",normalizedOffset:l.ZEROS,anchor:"center"}}case"point":case"mesh":return x["above-center"];default:return}}function y(e,t,n){const r=n.graphics3DGraphic.graphic.geometry;if(null==r)return null;switch(r.type){case"point":v(e,t,n);break;case"mesh":w(e,t,n);break;case"polygon":P(e,t,n)}const l=c.labelMarginPx-i.textVerticalPaddingPx;return e.screenOffset[0]+=l*t.normalizedOffset[0],e.screenOffset[1]+=l*t.normalizedOffset[1],e}function P(e,t,n){const l=m(n);if(null!=l)switch(l.type){case"extrude":{const l=n.graphics3DGraphic.layers[0];null!=l?(l.getBoundingBoxObjectSpace(k),a.center(k,e.translation),e.translation[2]=a.height(k)/2):r.set(e.translation,0,0,0),L(e,t,l);break}}}function v(e,t,n){const l=m(n);if(null==l)return;const a=n.graphics3DGraphic.layers[0];switch(null!=a?a.getCenterObjectSpace(e.translation):r.set(e.translation,0,0,0),l.type){case"icon":case"text":z(e,t,n,a);break;case"object":L(e,t,a)}}function w(e,t,n){const r=m(n);if(null==r)return;const l=n.graphics3DGraphic.layers[0];if("fill"===r.type)L(e,t,l)}function z(e,t,n,r){const{graphics3DGraphic:l}=n,a=null!=r?r.getScreenSize():null;if(l.isDraped||null==a)e.hasLabelVerticalOffset||"center"===e.anchor||(x[n.labelClass.labelPlacement]&&u().warnOncePerTick(`the requested placement '${t.placement}' is currently unsupported for draped graphics`),e.anchor="center");else{const r=S(n);e.screenOffset[0]=a[0]/2*(t.normalizedOffset[0]-r[0]);const l=a[1]/2*(t.normalizedOffset[1]-r[1]);e.hasLabelVerticalOffset?(e.centerOffset[1]=l,e.centerOffsetUnits="screen"):e.screenOffset[1]=l}}function S(e,t=G){const{graphics3DGraphic:n}=e,r=n.layers[0],l=r?.stageObject.geometries[0].material??null;if(l&&l instanceof f.HUDMaterial){const e=l.parameters.anchorPosition;t[0]=2*(e[0]-.5),t[1]=2*(e[1]-.5)}else t[0]=0,t[1]=0;return t}function L(e,t,n){const a=null!=n?n.getBoundingBoxObjectSpace(k):k,c=l.fromValues(a[3]-a[0],a[4]-a[1],a[5]-a[2]),s=Math.sqrt(c[0]*c[0]+c[1]*c[1]);e.centerOffset[0]=s/2*t.normalizedOffset[0];const o=e.translation[2],i=c[2]/2*t.normalizedOffset[1];e.translation[2]=0,e.elevationOffset=o+i;const f=r.length(c);e.centerOffset[2]=f/2*t.normalizedOffset[2]}function D(e){return"above-center"===e}function C(e){const t=e.labelClass.labelPlacement,{labelSymbol:n,graphics3DGraphic:r}=e,l=s.getGraphics3DSymbol(r.graphics3DSymbol),a="point-3d"===l?.symbol.type?l.symbol:null,c=x[t]||d(e);return null!=a&&a.supportsCallout()&&a.hasVisibleVerticalOffset()&&!r.isDraped?{placement:null,hasLabelVerticalOffset:!1,verticalOffset:a.verticalOffset.clone(),anchor:null,normalizedOffset:null}:!n||!n.hasVisibleVerticalOffset()||null!=a&&a.supportsCallout()&&a.verticalOffset&&!r.isDraped?{placement:null,verticalOffset:null,anchor:null,normalizedOffset:null,hasLabelVerticalOffset:!1}:c&&D(c.placement)?{placement:"above-center",verticalOffset:n.verticalOffset.clone(),anchor:"bottom",normalizedOffset:[0,c.normalizedOffset[1],0],hasLabelVerticalOffset:!0}:(u().errorOncePerTick("Callouts and vertical offset on labels are currently only supported with 'above-center' label placement (not with "+t+" placement)"),null)}const x={"above-center":{placement:"above-center",normalizedOffset:[0,1,0],anchor:"bottom"},"above-left":{placement:"above-left",normalizedOffset:[-1,1,0],anchor:"bottom-right"},"above-right":{placement:"above-right",normalizedOffset:[1,1,0],anchor:"bottom-left"},"below-center":{placement:"below-center",normalizedOffset:[0,-1,2],anchor:"top"},"below-left":{placement:"below-left",normalizedOffset:[-1,-1,0],anchor:"top-right"},"below-right":{placement:"below-right",normalizedOffset:[1,-1,0],anchor:"top-left"},"center-center":{placement:"center-center",normalizedOffset:[0,0,1],anchor:"center"},"center-left":{placement:"center-left",normalizedOffset:[-1,0,0],anchor:"right"},"center-right":{placement:"center-right",normalizedOffset:[1,0,0],anchor:"left"}},V={"above-center":["default","esriServerPointLabelPlacementAboveCenter"],"above-left":["esriServerPointLabelPlacementAboveLeft"],"above-right":["esriServerPointLabelPlacementAboveRight"],"below-center":["esriServerPointLabelPlacementBelowCenter"],"below-left":["esriServerPointLabelPlacementBelowLeft"],"below-right":["esriServerPointLabelPlacementBelowRight"],"center-center":["esriServerPointLabelPlacementCenterCenter"],"center-left":["esriServerPointLabelPlacementCenterLeft"],"center-right":["esriServerPointLabelPlacementCenterRight"]};for(const j in V){const e=V[j],t=x[j];e.forEach((e=>{x[e]=t}))}Object.freeze&&(Object.freeze(x),Object.keys(x).forEach((e=>{Object.freeze(x[e]),Object.freeze(x[e]?.normalizedOffset)})));const G=[0,0],k=a.create();e.LabelInfo=b,e.getLabelPlacement=p,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
