/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","exports","../../../../core/devEnvironmentUtils","../../../../core/mathUtils","../../../../core/libs/gl-matrix-2/math/mat3","../../../../core/libs/gl-matrix-2/factories/mat3f64","../../../../core/libs/gl-matrix-2/math/mat4","../../../../core/libs/gl-matrix-2/factories/mat4f64","../../../../core/libs/gl-matrix-2/factories/vec2f64","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../geometry/support/aaBoundingBox","../../../../geometry/support/FloatArray","../../../../geometry/support/buffer/BufferView","../../../../chunks/vec3","../../../../chunks/vec4","../../../../chunks/vec2","../../../../chunks/vec33","../../../../chunks/vec43","../../glTF/DefaultLoadingContext","../../glTF/internal/indexUtils","../../glTF/internal/resourceUtils","../../glTF/internal/TextureTransformUtils","./ProcessedObjectResource","./wosrLoader","../../webgl-engine/core/shaderLibrary/attributes/NormalAttribute.glsl","../../webgl-engine/lib/Attribute","../../webgl-engine/lib/basicInterfaces","../../webgl-engine/lib/Geometry","../../webgl-engine/lib/Texture","../../webgl-engine/lib/VertexAttribute","../../webgl-engine/materials/DefaultMaterial","../../webgl-engine/materials/DefaultMaterial_COLOR_GAMMA","../../webgl-engine/materials/pbrUtils"],(function(e,t,r,o,a,i,s,n,l,u,c,m,d,f,g,x,p,b,h,T,y,M,w,v,R,B,A,F,S,V,O,E,C,L){"use strict";async function D(t,o){const a=I(r.adjustStaticAGOUrl(t));if("wosr"===a.fileType){const e=await(o.cache?o.cache.loadWOSR(a.url,o):R.load(a.url,o)),{engineResources:t,referenceBoundingBox:r}=R.processLoadResult(e,o);return{lods:t,referenceBoundingBox:r,isEsriSymbolResource:!1,isWosr:!0}}let i;if(o.cache)i=await o.cache.loadGLTF(a.url,o,!!o.usePBR);else{const{loadGLTF:t}=await new Promise(((t,r)=>e(["../../glTF/loader"],t,r)));i=await t(new T.DefaultLoadingContext(o.streamDataRequester),a.url,o,o.usePBR)}const s=i.model.meta?.ESRI_proxyEllipsoid,n=i.meta.isEsriSymbolResource&&null!=s&&"EsriRealisticTreesStyle"===i.meta.ESRI_webstyle;n&&!i.customMeta.esriTreeRendering&&(i.customMeta.esriTreeRendering=!0,_(i,s));const l=!!o.usePBR,u=i.meta.isEsriSymbolResource?{usePBR:l,isSchematic:!1,treeRendering:n,mrrFactors:L.esriSymbologyMRRFactors}:{usePBR:l,isSchematic:!1,treeRendering:!1,mrrFactors:L.advancedMRRFactors},c={...o.materialParameters,treeRendering:n},{engineResources:m,referenceBoundingBox:d}=N(i,u,c,o,a.specifiedLodIndex);return{lods:m,referenceBoundingBox:d,isEsriSymbolResource:i.meta.isEsriSymbolResource,isWosr:!1}}function I(e){const t=e.match(/(.*\.(gltf|glb))(\?lod=([0-9]+))?$/);if(t)return{fileType:"gltf",url:t[1],specifiedLodIndex:null!=t[4]?Number(t[4]):null};return e.match(/(.*\.(json|json\.gz))$/)?{fileType:"wosr",url:e,specifiedLodIndex:null}:{fileType:"unknown",url:e,specifiedLodIndex:null}}function N(e,t,r,o,a){const i=e.model,s=new Array,n=new Map,l=new Map,u=i.lods.length,c=m.empty();return i.lods.forEach(((e,d)=>{const f=!0===o.skipHighLods&&(u>1&&0===d||u>3&&1===d)||!1===o.skipHighLods&&null!=a&&d!==a;if(f&&0!==d)return;const g=new v.ProcessedObjectResource(e.name,e.lodThreshold,[0,0,0]);e.parts.forEach((e=>{const a=f?new E.DefaultMaterial({},o):P(i,e,g,t,r,n,l,o),{geometry:s,vertexCount:u}=G(e,a??new E.DefaultMaterial({},o)),x=s.boundingInfo;null!=x&&0===d&&(m.expandWithVec3(c,x.bbMin),m.expandWithVec3(c,x.bbMax)),null!=a&&(g.stageResources.geometries.push(s),g.numberOfVertices+=u)})),f||s.push(g)})),{engineResources:s,referenceBoundingBox:c}}function P(e,t,r,o,a,i,s,n){const u=t.material+(t.attributes.normal?"_normal":"")+(t.attributes.color?"_color":"")+(t.attributes.texCoord0?"_texCoord0":"")+(t.attributes.tangent?"_tangent":""),c=e.materials.get(t.material),m=null!=t.attributes.texCoord0,d=null!=t.attributes.normal;if(null==c)return null;const f=k(c.alphaMode);if(!i.has(u)){if(m){const t=(t,r=!1)=>{if(null!=t&&!s.has(t)){const o=e.textures.get(t);if(null!=o){const e=o.data;s.set(t,new V.Texture(M.isEncodedMeshTexture(e)?e.data:e,{...o.parameters,preMultiplyAlpha:!M.isEncodedMeshTexture(e)&&r,encoding:M.isEncodedMeshTexture(e)&&null!=e.encoding?e.encoding:void 0}))}}};t(c.textureColor,f!==F.AlphaDiscardMode.Opaque),t(c.textureNormal),t(c.textureOcclusion),t(c.textureEmissive),t(c.textureMetallicRoughness)}const r=c.color[0]**(1/C.colorGamma),g=c.color[1]**(1/C.colorGamma),x=c.color[2]**(1/C.colorGamma),p=c.emissiveFactor[0]**(1/C.colorGamma),b=c.emissiveFactor[1]**(1/C.colorGamma),h=c.emissiveFactor[2]**(1/C.colorGamma),T=null!=c.textureColor&&m?s.get(c.textureColor):null,y=L.useSchematicPBR({normalTexture:c.textureNormal,metallicRoughnessTexture:c.textureMetallicRoughness,metallicFactor:c.metallicFactor,roughnessFactor:c.roughnessFactor,emissiveTexture:c.textureEmissive,emissiveFactor:c.emissiveFactor,occlusionTexture:c.textureOcclusion}),v=null!=c.normalTextureTransform?.scale?c.normalTextureTransform?.scale:l.ONES;i.set(u,new E.DefaultMaterial({...o,transparent:f===F.AlphaDiscardMode.Blend,customDepthTest:F.DepthTestFunction.Lequal,textureAlphaMode:f,textureAlphaCutoff:c.alphaCutoff,diffuse:[r,g,x],ambient:[r,g,x],opacity:c.opacity,doubleSided:c.doubleSided,doubleSidedType:"winding-order",cullFace:c.doubleSided?F.CullFaceOptions.None:F.CullFaceOptions.Back,hasVertexColors:!!t.attributes.color,hasVertexTangents:!!t.attributes.tangent,normalType:d?B.NormalType.Attribute:B.NormalType.ScreenDerivative,castShadows:!0,receiveShadows:c.receiveShadows,receiveAmbientOcclusion:c.receiveAmbientOcclustion,textureId:null!=T?T.id:void 0,colorMixMode:c.colorMixMode,normalTextureId:null!=c.textureNormal&&m?s.get(c.textureNormal).id:void 0,textureAlphaPremultiplied:null!=T&&!!T.parameters.preMultiplyAlpha,occlusionTextureId:null!=c.textureOcclusion&&m?s.get(c.textureOcclusion).id:void 0,emissiveTextureId:null!=c.textureEmissive&&m?s.get(c.textureEmissive).id:void 0,metallicRoughnessTextureId:null!=c.textureMetallicRoughness&&m?s.get(c.textureMetallicRoughness).id:void 0,emissiveFactor:[p,b,h],mrrFactors:y?L.schematicMRRFactors:[c.metallicFactor,c.roughnessFactor,o.mrrFactors[2]],isSchematic:y,colorTextureTransformMatrix:w.getTransformMatrix(c.colorTextureTransform),normalTextureTransformMatrix:w.getTransformMatrix(c.normalTextureTransform),scale:[v[0],v[1]],occlusionTextureTransformMatrix:w.getTransformMatrix(c.occlusionTextureTransform),emissiveTextureTransformMatrix:w.getTransformMatrix(c.emissiveTextureTransform),metallicRoughnessTextureTransformMatrix:w.getTransformMatrix(c.metallicRoughnessTextureTransform),...a},n))}const g=i.get(u);if(r.stageResources.materials.push(g),m){const e=e=>{null!=e&&r.stageResources.textures.push(s.get(e))};e(c.textureColor),e(c.textureNormal),e(c.textureOcclusion),e(c.textureEmissive),e(c.textureMetallicRoughness)}return g}function G(e,t){const r=e.attributes.position.count,i=y.convertPrimitiveToTriangles(e.indices||r,e.primitiveType),s=d.newFloatArray(3*r),{typedBuffer:n,typedBufferStride:l}=e.attributes.position;g.transformMat4(s,n,e.transform,3,l);const u=[[O.VertexAttribute.POSITION,new A.Attribute(s,i,3,!0)]];if(null!=e.attributes.normal){const t=d.newFloatArray(3*r),{typedBuffer:s,typedBufferStride:n}=e.attributes.normal;a.normalFromMat4(U,e.transform),g.transformMat3(t,s,U,3,n),o.hasScaling(U)&&g.normalize(t,t),u.push([O.VertexAttribute.NORMAL,new A.Attribute(t,i,3,!0)])}if(null!=e.attributes.tangent){const t=d.newFloatArray(4*r),{typedBuffer:s,typedBufferStride:n}=e.attributes.tangent;a.fromMat4(U,e.transform),x.transformMat3(t,s,U,4,n),o.hasScaling(U)&&g.normalize(t,t,4),u.push([O.VertexAttribute.TANGENT,new A.Attribute(t,i,4,!0)])}if(null!=e.attributes.texCoord0){const t=d.newFloatArray(2*r),{typedBuffer:o,typedBufferStride:a}=e.attributes.texCoord0;p.normalizeIntegerBuffer(t,o,2,a),u.push([O.VertexAttribute.UV0,new A.Attribute(t,i,2,!0)])}const c=e.attributes.color;if(null!=c){const t=new Uint8Array(4*r);4===c.elementCount?c instanceof f.BufferViewVec4f?x.scale(t,c,255):c instanceof f.BufferViewVec4u8?h.copy(t,c):c instanceof f.BufferViewVec4u16&&x.scale(t,c,1/256):(t.fill(255),c instanceof f.BufferViewVec3f?g.scale(t,c.typedBuffer,255,4,c.typedBufferStride):e.attributes.color instanceof f.BufferViewVec3u8?b.copy(t,c.typedBuffer,4,e.attributes.color.typedBufferStride):e.attributes.color instanceof f.BufferViewVec3u16&&g.scale(t,c.typedBuffer,1/256,4,c.typedBufferStride)),u.push([O.VertexAttribute.COLOR,new A.Attribute(t,i,4,!0)])}return{geometry:new S.Geometry(t,u),vertexCount:r}}const U=i.create();function k(e){switch(e){case"BLEND":return F.AlphaDiscardMode.Blend;case"MASK":return F.AlphaDiscardMode.Mask;case"OPAQUE":case null:case void 0:return F.AlphaDiscardMode.Opaque}}function _(e,t){for(let r=0;r<e.model.lods.length;++r){const o=e.model.lods[r];for(const a of o.parts){const o=a.attributes.normal;if(null==o)return;const i=a.attributes.position,l=i.count,m=c.create(),d=c.create(),g=c.create(),x=new Uint8Array(4*l),p=new Float64Array(3*l),b=s.invert(n.create(),a.transform);let h=0,T=0;for(let s=0;s<l;s++){i.getVec(s,d),o.getVec(s,m),u.transformMat4(d,d,a.transform),u.subtract(g,d,t.center),u.divide(g,g,t.radius);const n=g[2],l=u.length(g),c=Math.min(.45+.55*l*l,1);u.divide(g,g,t.radius),null!==b&&u.transformMat4(g,g,b),u.normalize(g,g),r+1!==e.model.lods.length&&e.model.lods.length>1&&(n>-1?u.lerp(g,g,m,.2):u.lerp(g,g,m,Math.min(-4*n-3.8,1))),p[h]=g[0],p[h+1]=g[1],p[h+2]=g[2],h+=3,x[T]=255*c,x[T+1]=255*c,x[T+2]=255*c,x[T+3]=255,T+=4}a.attributes.normal=new f.BufferViewVec3f(p),a.attributes.color=new f.BufferViewVec4u8(x)}}}t.fetch=D,t.parseUrl=I,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
