/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../core/Error","../../../../core/lang","../../../../core/Logger","./LEPCC","../../webgl-engine/lib/VertexAttribute"],(function(e,t,r,n,o,i){"use strict";const a=()=>n.getLogger("esri.views.3d.layers.i3s.I3SBinaryReader");function u(e,r,n){let o="",i=0;for(;i<n;){const a=e[r+i];if(a<128)o+=String.fromCharCode(a),i++;else if(a>=192&&a<224){if(i+1>=n)throw new t("utf8-decode-error","UTF-8 Decode failed. Two byte character was truncated.");const u=(31&a)<<6|63&e[r+i+1];o+=String.fromCharCode(u),i+=2}else if(a>=224&&a<240){if(i+2>=n)throw new t("utf8-decode-error","UTF-8 Decode failed. Multi byte character was truncated.");const u=(15&a)<<12|(63&e[r+i+1])<<6|63&e[r+i+2];o+=String.fromCharCode(u),i+=3}else{if(!(a>=240&&a<248))throw new t("utf8-decode-error","UTF-8 Decode failed. Invalid multi byte sequence.");{if(i+3>=n)throw new t("utf8-decode-error","UTF-8 Decode failed. Multi byte character was truncated.");const u=(7&a)<<18|(63&e[r+i+1])<<12|(63&e[r+i+2])<<6|63&e[r+i+3];if(u>=65536){const e=55296+(u-65536>>10),t=56320+(1023&u);o+=String.fromCharCode(e,t)}else o+=String.fromCharCode(u);i+=4}}}return o}function c(e,t){const r={byteOffset:0,byteCount:0,fields:Object.create(null)};let n=0;for(let o=0;o<t.length;o++){const i=t[o],a=i.valueType||i.type,u=h[a];r.fields[i.property]=u(e,n),n+=A[a].BYTES_PER_ELEMENT}return r.byteCount=n,r}function s(e,t,r){return f(e,t,r).map((e=>{const t=e?Date.parse(e):null;return null==t||Number.isNaN(t)?null:t}))}function f(e,r,n){const o=[];let i,a,c=0;for(a=0;a<e;a+=1){if(i=r[a],i>0){if(o.push(u(n,c,i-1)),0!==n[c+i-1])throw new t("string-array-error","Invalid string array: missing null termination.")}else o.push(null);c+=i}return o}function l(e,t){return new(0,A[t.valueType])(e,t.byteOffset,t.count*t.valuesPerElement)}function d(e,t){return new Uint8Array(e,t.byteOffset,t.byteCount)}function b(e,n,o){const i=null!=n.header?c(e,n.header):{byteOffset:0,byteCount:0,fields:{count:o}},a={header:i,byteOffset:i.byteCount,byteCount:0,entries:Object.create(null)};let u=i.byteCount;for(let c=0;c<n.ordering.length;c++){const e=n.ordering[c],o=r.clone(n[e]);if(o.count=i.fields.count??0,"String"===o.valueType){if(o.byteOffset=u,o.byteCount=i.fields[e+"ByteCount"],"UTF-8"!==o.encoding)throw new t("unsupported-encoding","Unsupported String encoding.",{encoding:o.encoding});if(o.timeEncoding&&"ECMA_ISO8601"!==o.timeEncoding)throw new t("unsupported-time-encoding","Unsupported time encoding.",{timeEncoding:o.timeEncoding})}else{if(!T(o.valueType))throw new t("unsupported-value-type","Unsupported binary valueType",{valueType:o.valueType});{const e=O(o.valueType);u+=u%e!=0?e-u%e:0,o.byteOffset=u,o.byteCount=e*o.valuesPerElement*o.count}}u+=o.byteCount??0,a.entries[e]=o}return a.byteCount=u-a.byteOffset,a}function y(e,r,n){if(r!==e&&a().error(`Invalid ${n} buffer size\n expected: ${e}, actual: ${r})`),r<e)throw new t("buffer-too-small","Binary buffer is too small",{expectedSize:e,actualSize:r})}function g(e){return{isDraco:!1,isLegacy:!1,color:null!=e.color,normal:null!=e.normal,uv0:null!=e.uv0,uvRegion:null!=e.uvRegion,featureIndex:null!=e.faceRange&&null!=e.featureId}}function p(e,t){const r=c(e,t&&t.header);let n=r.byteCount;const o={isDraco:!1,header:r,byteOffset:r.byteCount,byteCount:0,vertexAttributes:{}},i=r.fields,a=null!=i.vertexCount?i.vertexCount:i.count;for(const c of t.ordering){if(!t.vertexAttributes[c])continue;const e={...t.vertexAttributes[c],byteOffset:n,count:a},r=C[c]||"_"+c;o.vertexAttributes[r]=e,n+=O(e.valueType)*e.valuesPerElement*a}const u=i.faceCount;if(t.faces&&u){o.faces={};for(const e of t.ordering){if(!t.faces[e])continue;const r={...t.faces[e],byteOffset:n,count:u};o.faces[e]=r,n+=O(r.valueType)*r.valuesPerElement*u}}const s=i.featureCount;if(t.featureAttributes&&t.featureAttributeOrder&&s){o.featureAttributes={};for(const e of t.featureAttributeOrder){if(!t.featureAttributes[e])continue;const r={...t.featureAttributes[e],byteOffset:n,count:s};o.featureAttributes[e]=r;n+=("UInt64"===r.valueType?8:O(r.valueType))*r.valuesPerElement*s}}return y(n,e.byteLength,"geometry"),o.byteCount=n-o.byteOffset,o}function w(e,t){return!(!e||!e.compressedAttributes||"draco"!==e.compressedAttributes.encoding)?m(e.compressedAttributes.attributes):e?g(e):v(t)}function v(e){const t={isDraco:!1,isLegacy:!0,color:!1,normal:!1,uv0:!1,uvRegion:!1,featureIndex:!1};for(const r of e.ordering)if(e.vertexAttributes[r])switch(r){case"position":break;case"normal":t.normal=!0;break;case"color":t.color=!0;break;case"uv0":t.uv0=!0;break;case"region":t.uvRegion=!0}return e.featureAttributes&&e.featureAttributeOrder&&(t.featureIndex=!0),t}function m(e){const t={isDraco:!0,isLegacy:!1,color:!1,normal:!1,uv0:!1,uvRegion:!1,featureIndex:!1};for(const r of e)switch(r){case"position":break;case"normal":t.normal=!0;break;case"uv0":t.uv0=!0;break;case"color":t.color=!0;break;case"uv-region":t.uvRegion=!0;break;case"feature-index":t.featureIndex=!0}return t}const C={position:i.VertexAttribute.POSITION,normal:i.VertexAttribute.NORMAL,color:i.VertexAttribute.COLOR,uv0:i.VertexAttribute.UV0,region:i.VertexAttribute.UVREGION};function I(e,r,n){if("lepcc-rgb"===e.encoding)return o.decodeRGB(r);if("lepcc-intensity"===e.encoding)return o.decodeIntensity(r);if(null!=e.encoding&&""!==e.encoding)throw new t("unknown-attribute-storage-info-encoding","Unknown Attribute Storage Info Encoding");e["attributeByteCounts "]&&!e.attributeByteCounts&&(a().warn("Warning: Trailing space in 'attributeByteCounts '."),e.attributeByteCounts=e["attributeByteCounts "]),"ObjectIds"===e.ordering[0]&&e.hasOwnProperty("objectIds")&&(a().warn("Warning: Case error in objectIds"),e.ordering[0]="objectIds");const i=b(r,e,n);y(i.byteOffset+i.byteCount,r.byteLength,"attribute");const u=i.entries.attributeValues||i.entries.objectIds;if(u){if("String"===u.valueType){const e=i.entries.attributeByteCounts,t=l(r,e),n=d(r,u);return u.timeEncoding?s(e.count,t,n):f(e.count,t,n)}return l(r,u)}throw new t("bad-attribute-storage-info","Bad attributeStorageInfo specification.")}const A={Float32:Float32Array,Float64:Float64Array,UInt8:Uint8Array,Int8:Int8Array,UInt16:Uint16Array,Int16:Int16Array,UInt32:Uint32Array,Int32:Int32Array},h={Float32:(e,t)=>new DataView(e,0).getFloat32(t,!0),Float64:(e,t)=>new DataView(e,0).getFloat64(t,!0),UInt8:(e,t)=>new DataView(e,0).getUint8(t),Int8:(e,t)=>new DataView(e,0).getInt8(t),UInt16:(e,t)=>new DataView(e,0).getUint16(t,!0),Int16:(e,t)=>new DataView(e,0).getInt16(t,!0),UInt32:(e,t)=>new DataView(e,0).getUint32(t,!0),Int32:(e,t)=>new DataView(e,0).getInt32(t,!0)};function T(e){return A.hasOwnProperty(e)}function O(e){return T(e)?A[e].BYTES_PER_ELEMENT:0}e.createAttributeDataIndex=b,e.createGeometryDescriptor=w,e.createGeometryDescriptorForDraco=m,e.createGeometryDescriptorFromDefinition=g,e.createGeometryDescriptorFromSchema=v,e.createGeometryIndexFromSchema=p,e.createRawView=d,e.createTypedView=l,e.getBytesPerValue=O,e.isValueType=T,e.readBinaryAttribute=I,e.readDateStringArray=s,e.readHeader=c,e.readStringArray=f,e.valueType2ArrayBufferReader=h,e.valueType2TypedArrayClassMap=A,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
