/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../core/Error","../../../../core/maybe","../../../../core/MemCache","../../../../core/promiseUtils","../../../../core/uuid","../../../../core/libs/gl-matrix-2/math/mat3","../../../../core/libs/gl-matrix-2/factories/mat3f64","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../geometry/projection/projectBoundingSphere","../../../../geometry/support/meshVertexSpaceUtils","../../../../chunks/sphere","./I3SClientMaterialUtil"],(function(e,t,r,o,n,s,a,i,l,d,u,c,m,h){"use strict";class f{constructor(e,t,r,o){this._uid=e,this._worker=o,this._id2Meta=new Map,this._oid2Meta=new Map,this._indexSR=t.indexSR,this._vertexSR=t.vertexSR,this._renderSR=t.renderSR,this._memCache=r.newCache(`sl-client-mesh-data-${this._uid}`)}get uid(){return this._uid}get worker(){return this._worker}get indexSR(){return this._indexSR}get renderSR(){return this._renderSR}createMeshNodeInfo(e,t){const r=`mesh${t}`,o=e.extent,n=o.spatialReference,s=this._indexSR,a=x(o,e.origin);u.projectBoundingSphere(a,n,a,s);return{type:"mesh",id:r,version:S(e),oid:t,mbs:a,componentNodeIds:[],unloadedMesh:e,nodeIndex:null,loadMeshPromise:null}}addMeshNode(e,r){if(null!=this.getMeshNodeIndex(r.oid))throw new t(`I3SClientNodeLoader: client side mesh for feature oid=${r.oid} already exists`);r.nodeIndex=e,this._id2Meta.set(r.id,r),this._oid2Meta.set(r.oid,r)}getMeshNodeIndex(e){const t=this._oid2Meta.get(e);return null==t||"mesh"!==t.type?null:t.nodeIndex}getMeshNodeInfo(e){const t=this._oid2Meta.values();for(const r of t)if("mesh"===r.type&&r.id===e)return r;return null}removeNode(e){const t=this._id2Meta.get(e);null!=t&&(this._id2Meta.delete(e),"mesh"===t.type&&this._oid2Meta.delete(t.oid))}async loadNodeJSON(e){const r=this._id2Meta.get(e);if(null==r)throw new t(`I3SClientNodeLoader::loadNodeJSON unable to find node ${e}`);switch(r.type){case"mesh":return this._loadMeshNodeJSON(r);case"mesh-component":return p(r);default:throw new t(`I3SClientNodeLoader::loadNodeJSON unable to handle node ${e}`)}}async _loadMeshNodeJSON(e){const t=e.id,r=(await this._getMeshData(e)).loadedMesh;if(null==r.components||0===r.components.length)return{id:t,version:null,mbs:e.mbs,obb:null,sharedResource:null,geometryData:null,attributeData:null,featureData:null,children:null};const o=[],n=r.components;for(let s=0;s<n.length;++s){const r=`${t}-component${s}`,n={type:"mesh-component",id:r,mbs:e.mbs,componentIndex:s,meshNodeInfo:e,textureData:new Map};this._id2Meta.set(n.id,n),e.componentNodeIds.push(r),o.push({id:n.id,href:null,mbs:n.mbs,obb:null})}return{id:t,version:null,mbs:e.mbs,obb:null,sharedResource:null,geometryData:null,attributeData:null,featureData:null,children:o}}updateNodeIndex(e,t,r){const o=this._id2Meta.get(e);o&&"mesh"===o.type&&(o.nodeIndex=r)}async loadNodeData(e,o){const s=this._id2Meta.get(e);if(null==s||"mesh-component"!==s.type)throw new t(`Failed to load client node data for node ${e} (unexpected node info)`);const a=s.meshNodeInfo,i=await this._getMeshData(a),l=i.loadedMesh,d=a.oid;if(null==l.components)throw new t(`Failed to load client node data for node ${e} (unexpected null reference)`);const u=l.components[s.componentIndex],{material:c,requiredTextures:m,textureData:f}=await h.convertMeshMaterialToPBRMaterial(u.material);if(null!=f)for(const t of f)null!=t&&s.textureData.set(t.id,t);const p={params:{material:c},type:"ArrayBufferView"},{vertexSpace:x,origin:M,transform:S}=l,b=[M.x,M.y,M.z??0];i.projectionPromise||(r.assertIsSome(this._worker,"SceneLayerWorker is needed to project mesh"),i.projectionPromise=this._worker.project({positions:l.vertexAttributes.position,localMatrix:S?.localMatrix,vertexSpace:x.toJSON(),origin:b,inSpatialReference:l.spatialReference.toJSON(),outSpatialReference:this._vertexSR.toJSON()},o));const{projected:w,original:_,projectedOrigin:N}=await i.projectionPromise;l.vertexAttributes.position=_;const{transformed:I,original:v}=await y(u,i,this._worker,o);l.vertexAttributes.normal=v,n.throwIfAborted(o);const{geometryBuffer:D,geometryDescriptor:R}=g(w,u.faces,I,l.vertexAttributes.uv,l.vertexAttributes.color,d);return{geometryData:{featureDataPosition:N,featureIds:[],geometries:[p]},attributeDataInfo:{attributeData:{},loadedAttributes:[]},geometryBuffer:D,geometryDescriptor:R,requiredTextures:m,textureData:f,normalReferenceFrame:this._vertexSR.isGeographic?"east-north-up":"vertex-reference-frame"}}async loadAttributes(e,t,r){const o=e.numFeatures,n={};for(const{field:{name:s}}of t)n[s]=new Array(o);return n}async loadTextures(e,t,r){const o=e.id,n=this._id2Meta.get(o);if(null==n||"mesh-component"!==n.type)throw new Error(`Failed to load textures for node ${e.id} (unexpected node info)`);const s=[];for(const a of t)s.push(n.textureData.get(a.id)||null);return s}async _getMeshData(e){const t=e.version,r=this._memCache.get(t);if(null==r){if(null!=e.loadMeshPromise)return e.loadMeshPromise;const r=async(r,n)=>{const s=e.unloadedMesh.clone();try{await s.load()}catch(l){n(l)}const a=s.memoryUsage,i={loadedMesh:s,projectionPromise:null,normalsTransformPromise:null,usedMemoryInBytes:a};this._memCache.put(t,i,a,o.MinPriority),e.loadMeshPromise=null,r(i)};return e.loadMeshPromise=new Promise(((e,t)=>r(e,t))),e.loadMeshPromise}return r}}async function p(e){return{id:e.id,version:e.meshNodeInfo.version,mbs:e.mbs,obb:null,sharedResource:null,geometryData:null,attributeData:null,featureData:null,children:null,isEmpty:!1}}function x(e,t){const{spatialReference:r}=e,o=[1,-1],n=[.5*e.width,.5*e.height,e.hasZ?.5*(e.zmax-e.zmin):0],s=r.isGeographic?r.metersPerUnit:1,a=e.center;let i=0;if(e.hasZ)for(let l=0;l<2;++l)for(let e=0;e<2;++e)for(let r=0;r<2;++r){const d=(a.x+o[l]*n[0]-t.x)*s,u=(a.y+o[e]*n[1]-t.y)*s,c=a.z+o[r]*n[2]-t.z;i=Math.max(d*d+u*u+c*c,i)}else for(let l=0;l<2;++l)for(let e=0;e<2;++e){const r=(a.x+o[l]*n[0]-t.x)*s,d=(a.y+o[e]*n[1]-t.y)*s;i=Math.max(r*r+d*d,i)}return m.fromCenterAndRadius([t.x,t.y,t.z],Math.sqrt(i))}async function y(e,t,o,n){const{transform:s,vertexAttributes:u}=t.loadedMesh,c="source"===e.shading?u.normal:null;if(!(null!=c&&null!=s&&(0!==s.rotationAngle||!l.exactEquals(s.scale,d.ONES))))return{transformed:c,original:u.normal};if(!t.normalsTransformPromise){r.assertIsSome(o,"SceneLayerWorker is needed to transform mesh normals");const e=i.create();a.normalFromMat4(e,s.localMatrix),t.normalsTransformPromise=o.transformNormals({normalMatrix:e,normals:c},n)}return t.normalsTransformPromise}function g(e,t,r,o,n,s){const a=1,i=t.length/3,l=3*i;let d=0,u=0,c=!1,m=0,h=!1,f=0,p=!1,x=0,y=0,g=0;d+=b,d+=b,u=d,d+=3*l*w,null!=r&&(c=!0,m=d,d+=3*l*w),null!=o&&(h=!0,f=d,d+=2*l*w),null!=n&&(p=!0,x=d,d+=4*l*_),y=d,d+=a*N,g=d,d+=2*a*b;const S=new ArrayBuffer(d),I=new Uint8Array(S);M(I,0,l),M(I,b,a);const v=new Float32Array(S,u),D=null!=r?new Float32Array(S,m):null,R=null!=o?new Float32Array(S,f):null,A=null!=n?new Uint8Array(S,x):null;for(let M=0;M<i;++M){const s=3*M;for(let a=0;a<3;++a){const i=t[s+a],l=3*i,d=9*M+3*a;if(v[d]=e[l],v[d+1]=e[l+1],v[d+2]=e[l+2],null!=D&&(D[d]=r[l],D[d+1]=r[l+1],D[d+2]=r[l+2]),null!=R){const e=2*i,t=6*M+2*a;R[t]=o[e],R[t+1]=o[e+1]}if(null!=A){const e=4*i,t=12*M+4*a;A[t]=n[e],A[t+1]=n[e+1],A[t+2]=n[e+2],A[t+3]=n[e+3]}}}M(I,y,s),M(I,y+b,s/2**32),M(I,g,0),M(I,g+b,i-1);return{geometryBuffer:S,geometryDescriptor:{isDraco:!1,isLegacy:!0,color:p,normal:c,uv0:h,uvRegion:!1,featureIndex:!0}}}function M(e,t,r){e[t]=255&r,e[t+1]=255&r>>8,e[t+2]=255&r>>16,e[t+3]=255&r>>24}function S(e){const t=e.metadata.displaySource?.source;if(null==t||!Array.isArray(t)||!t.length||t[0]instanceof File)return s.generateUUID();const r=t;let o="";for(const n of r)o+=n.makeHash();return o+JSON.stringify(e.transform?.toJSON()??"")+(c.isRelativeVertexSpace(e.vertexSpace)?JSON.stringify(e.vertexSpace.origin):"")+JSON.stringify(e.spatialReference)}const b=4,w=4,_=1,N=8;e.I3SClientNodeLoader=f,e.createSphereFromExtent=x,e.sizeOfFloat32=w,e.sizeOfInt32=b,e.sizeOfUInt64=N,e.sizeOfUInt8=_,e.transformNormals=y,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
