/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../core/has","../../../../core/mathUtils","./enums","../../webgl-engine/core/material/RenderTexture","../../webgl-engine/core/shaderLibrary/util/AlphaCutoff","../../webgl-engine/core/shaderLibrary/util/EllipsoidMode","../../webgl-engine/lib/basicInterfaces","../../webgl-engine/lib/Texture","../../webgl-engine/materials/pbrUtils","../../../webgl/enums"],(function(e,r,a,t,o,n,s,u,l,i,c){"use strict";function d(e,a,o){const n=new Map,s=(e,r)=>{if(null==e)return-1;const a=n.get(e.id);if(a)return a.usage|=r,a.id;const t=n.size;return n.set(e.id,{id:t,usage:r}),t},l=a.pbrMetallicRoughness,c=l?.baseColorFactor,d=a.emissiveFactor,m=r("disable-feature:diffuse-rendering-i3s")||o?i.useSchematicPBRI3S({normalTexture:a.normalTexture,emissiveTexture:a.emissiveTexture,emissiveFactor:a.emissiveFactor,occlusionTexture:a.occlusionTexture,metallicRoughnessTexture:l?.metallicRoughnessTexture,metallicFactor:l?.metallicFactor,roughnessFactor:l?.roughnessFactor}):i.useSchematicPBR({normalTexture:a.normalTexture,emissiveTexture:a.emissiveTexture,emissiveFactor:a.emissiveFactor,occlusionTexture:a.occlusionTexture,metallicRoughnessTexture:l?.metallicRoughnessTexture,metallicFactor:l?.metallicFactor,roughnessFactor:l?.roughnessFactor}),x=m?i.schematicMRRFactors[0]:l?.metallicFactor??i.advancedMRRFactors[0],p=m?i.schematicMRRFactors[1]:l?.roughnessFactor??i.advancedMRRFactors[1],h="mask"===a.alphaMode?t.TextureUsage.Color|t.TextureUsage.AlphaMask:t.TextureUsage.Color,F={baseColorFactor:c?[c[0],c[1],c[2],c[3]]:[1,1,1,1],baseColorTextureId:s(l?.baseColorTexture,h),metallicRoughnessTextureId:s(l?.metallicRoughnessTexture,t.TextureUsage.MetallicRoughness),metallicFactor:x,roughnessFactor:p},f={alphaMode:a.alphaMode,alphaCutoff:a.alphaCutoff,doubleSided:a.doubleSided,cullFace:"none"===a.cullFace?u.CullFaceOptions.None:"back"===a.cullFace?u.CullFaceOptions.Back:"front"===a.cullFace?u.CullFaceOptions.Front:u.CullFaceOptions.None,normalTextureId:s(a.normalTexture,t.TextureUsage.Normal),emissiveTextureId:s(a.emissiveTexture,t.TextureUsage.Emissive),occlusionTextureId:s(a.occlusionTexture,t.TextureUsage.Occlusion),emissiveFactor:d?[d[0],d[1],d[2]]:[0,0,0],metallicRoughness:F,wrapTextures:!1,hasParametersFromSource:m},C=[];return n.forEach((({usage:r},a)=>{const t=null!=e&&e[a]&&e[a].formats,o=t?g(t.map((({name:e,format:r})=>({name:e,encoding:T[r]})))):[];C.push({id:a,usage:r,encodings:o})})),{material:f,textures:C}}function g(e){return e.sort(((e,r)=>e.encoding-r.encoding))}const T={ktx2:t.TextureEncoding.KTX2,basis:t.TextureEncoding.Basis,dds:t.TextureEncoding.DDS_S3TC,png:t.TextureEncoding.PNG,jpg:t.TextureEncoding.JPG,"ktx-etc2":t.TextureEncoding.KTX_ETC2},m={[u.TextureEncodingMimeType.KTX2_ENCODING]:t.TextureEncoding.Basis,[u.TextureEncodingMimeType.BASIS_ENCODING]:t.TextureEncoding.Basis,[u.TextureEncodingMimeType.DDS_ENCODING]:t.TextureEncoding.DDS_S3TC,"image/png":t.TextureEncoding.PNG,"image/jpg":t.TextureEncoding.JPG,"image/jpeg":t.TextureEncoding.JPG,"image/ktx":t.TextureEncoding.KTX_ETC2};function x(e){const r=e?.materialDefinitions?Object.keys(e.materialDefinitions)[0]:null,o=e?.textureDefinitions?Object.keys(e.textureDefinitions)[0]:null,n=r?e.materialDefinitions?.[r]:null,s=o?e.textureDefinitions?.[o]:null,l=p();if(null!=n){const e=n.params;e.diffuse&&(l.metallicRoughness.baseColorFactor=[e.diffuse[0],e.diffuse[1],e.diffuse[2],1]),null!=e.doubleSided&&(l.doubleSided=e.doubleSided,l.cullFace=e.doubleSided?u.CullFaceOptions.None:u.CullFaceOptions.Back),"none"!==e.cullFace&&"front"!==e.cullFace&&"back"!==e.cullFace||(l.cullFace="none"===e.cullFace?u.CullFaceOptions.None:"back"===e.cullFace?u.CullFaceOptions.Back:u.CullFaceOptions.Front),e.transparency&&(l.metallicRoughness.baseColorFactor[3]=a.clamp(1-e.transparency,0,1)),(e.useVertexColorAlpha||l.metallicRoughness.baseColorFactor[3]<1)&&(l.alphaMode="blend")}const i=[];if(null!=s){const e=0;!s.wrap||"repeat"!==s.wrap[0]&&"repeat"!==s.wrap[1]||(l.wrapTextures=!0);let r=t.TextureUsage.Color;"rgba"===s.channels&&(l.alphaMode="blend",r|=t.TextureUsage.AlphaMask);const a=s.images.length-1,o=s.images[a],n=e=>e?.split("/").pop(),u=Array.isArray(s.encoding)?g(s.encoding.map(((e,r)=>({name:n(o.href[r]),encoding:m[e]||0})))):[{name:n(o.href),encoding:m[s.encoding]||0}];i.push({id:e,usage:r,encodings:u}),l.metallicRoughness.baseColorTextureId=e}return{material:l,textures:i}}const p=()=>({alphaMode:"opaque",alphaCutoff:n.alphaCutoff,doubleSided:!0,cullFace:u.CullFaceOptions.None,normalTextureId:-1,emissiveTextureId:-1,occlusionTextureId:-1,emissiveFactor:[0,0,0],metallicRoughness:{baseColorFactor:[.8,.8,.8,1],baseColorTextureId:-1,metallicRoughnessTextureId:-1,metallicFactor:0,roughnessFactor:.6},wrapTextures:!1,hasParametersFromSource:!0});function h(e,r,a,o){if(null==e?.data)return null;const n=e.data,s=o.renderingContext.parameters.maxMaxAnisotropy,u=s>1,i=a||!r.wrapTextures?F:f,c=R(e.encoding),d=e.usage&t.TextureUsage.Color?"opaque"===r.alphaMode?3:4:3;return new l.Texture(n,{mipmap:u,maxAnisotropy:s,encoding:c,wrap:i,components:d,noUnpackFlip:!0})}const F={s:c.TextureWrapMode.CLAMP_TO_EDGE,t:c.TextureWrapMode.CLAMP_TO_EDGE},f={s:c.TextureWrapMode.REPEAT,t:c.TextureWrapMode.REPEAT};function C(e,r,l,c,d,g){const T=g.rendererTextureUsage,m=e=>b(c,l,e&T),x=r.metallicRoughness.baseColorFactor,p=a.clamp(r.metallicRoughness.baseColorFactor[3],0,1);e.baseColor=[x[0],x[1],x[2],p],e.hasParametersFromSource=!!r.hasParametersFromSource,e.usePBR=g.usePBR,e.mrrFactors=[r.metallicRoughness.metallicFactor,r.metallicRoughness.roughnessFactor,r.hasParametersFromSource?i.schematicMRRFactors[2]:i.advancedMRRFactors[2]],e.emissiveFactor=r.emissiveFactor,e.isIntegratedMesh=g.isIntegratedMesh,e.textureAlphaCutoff="mask"===r.alphaMode?r.alphaCutoff:n.alphaCutoff,e.alphaDiscardMode="opaque"===r.alphaMode?u.AlphaDiscardMode.Opaque:"mask"===r.alphaMode?u.AlphaDiscardMode.Mask:u.AlphaDiscardMode.MaskBlend;const h=[],F=m(t.TextureUsage.Color|t.TextureUsage.AlphaMask);null!=F&&(e.baseColorTexture=new o.RenderTexture(d,F),h.push(e.baseColorTexture.loadPromise));const f=m(t.TextureUsage.MetallicRoughness);null!=f&&(e.metallicRoughnessTexture=new o.RenderTexture(d,f),h.push(e.metallicRoughnessTexture.loadPromise));const C=m(t.TextureUsage.Emissive);null!=C&&(e.emissionTexture=new o.RenderTexture(d,C),h.push(e.emissionTexture.loadPromise));const E=m(t.TextureUsage.Occlusion);null!=E&&(e.occlusionTexture=new o.RenderTexture(d,E),h.push(e.occlusionTexture.loadPromise));const M=m(t.TextureUsage.Normal);return null!=M&&(e.normalTexture=new o.RenderTexture(d,M),h.push(e.normalTexture.loadPromise)),e.commonMaterialParameters.hasSlicePlane=g.slicePlaneEnabled,e.commonMaterialParameters.doubleSided=r.doubleSided,e.commonMaterialParameters.cullFace=r.cullFace,e.ellipsoidMode=s.getEllipsoidMode(g.viewSpatialReference),Promise.all(h)}function E(e){const a=!!e.compressedTextureS3TC,o=!!e.compressedTextureETC,n=r("disable-feature:i3s-basis")?0:t.TextureEncoding.Basis|t.TextureEncoding.KTX2,s=t.TextureEncoding.JPG|t.TextureEncoding.PNG,u=n|t.TextureEncoding.DDS_S3TC;return s|(a?u:0)|(o?n:0)}function M(e,r){if(null!=r)return e.find((e=>!!(e.encoding&r)))}function b(e,r,a){if(null==e||a===t.TextureUsage.None)return null;for(let t=0;t<e.length;t++){const o=e[t];if(null!=o&&o.usage&a){const e=r[t];return null!=e?e.id:null}}return null}function R(e){switch(e){case t.TextureEncoding.KTX2:return u.TextureEncodingMimeType.KTX2_ENCODING;case t.TextureEncoding.Basis:return u.TextureEncodingMimeType.BASIS_ENCODING;case t.TextureEncoding.DDS_S3TC:return u.TextureEncodingMimeType.DDS_ENCODING;case t.TextureEncoding.PNG:return"image/png";case t.TextureEncoding.JPG:return"image/jpeg";case t.TextureEncoding.KTX_ETC2:return"image/ktx";default:return""}}e.configureMaterial=C,e.createTexture=h,e.defaultMaterial=p,e.getMaterialAndTextures=d,e.getMaterialAndTexturesFromShared=x,e.getSupportedEncodings=E,e.selectEncoding=M,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
