/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","exports","../../../../chunks/tslib.es6","../../../../geometry","../../../../core/Accessor","../../../../core/arrayUtils","../../../../core/Logger","../../../../core/mathUtils","../../../../core/maybeUpdating","../../../../core/reactiveUtils","../../../../core/unitUtils","../../../../core/accessorSupport/decorators/property","../../../../core/has","../../../../core/accessorSupport/decorators/subclass","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../core/sql/WhereClause","../../../../geometry/ellipsoidUtils","../../../../geometry/projection","../../../../geometry/projection/projectBoundingSphere","../../../../geometry/projection/projectVectorToVector","../../../../geometry/support/aaBoundingBox","../../../../geometry/support/aaBoundingRect","../../../../geometry/support/DoubleArray","../../../../geometry/support/Ellipsoid","../../../../geometry/support/spatialReferenceUtils","../../../../chunks/sphere","../../../../geometry/support/webMercatorUtils","../../../../layers/support/FeatureFilter","./I3SUtil","../../../../geometry/SpatialReference"],(function(e,t,r,i,n,o,s,a,l,c,p,u,d,g,h,y,f,m,S,w,_,F,b,R,E,I,M,v,j,V,T){"use strict";const k="esri.views.3d.layers.i3s.I3SMeshViewFilter",D=()=>s.getLogger(k);t.I3SMeshViewFilter=class extends n{constructor(e){super(e),this._projectionEngineLoaded=!1}initialize(){c.whenOnce((()=>this.viewFilter?.geometry||null!=this.layerFilter)).then((()=>this.loadAsyncModule(new Promise(((t,r)=>e(["../../../../geometry/geometryEngine"],t,r))).then((e=>{this.destroyed||(this._geometryEngine=e)})))))}get sortedObjectIds(){if(null==this.viewFilter?.objectIds)return null;const e=R.doubleArrayFrom(this.viewFilter.objectIds);return e.sort(),e}get parsedWhereClause(){const e=this.viewFilter?.where;if(null==e||!e)return null;try{return f.WhereClause.create(e,{fieldsIndex:this.layerFieldsIndex})}catch(t){D().error(`Failed to parse filter where clause: ${t}`)}return null}addFilters(e,t,r,i){const n=this.sortedObjectIds;null!=n&&e.push((e=>V.objectIdFilter(n,!0,e))),this.addSqlFilter(e,this.parsedWhereClause),this.addTimeFilter(e,this.viewFilter?.timeExtent);const o=l.unwrapUpdating(this._layerMaskGeometries),s=this._geometryEngine;if(null!=o&&null!=this.layerFilter&&null!=s){const n=this.layerFilter.spatialRelationship;e.push(((e,a)=>O(s,e,a,i,t,r,o,n)))}const a=l.unwrapUpdating(this._viewMaskGeometries);if(null!=a&&null!=this.viewFilter&&null!=s){const n=this.viewFilter.spatialRelationship;e.push(((e,o)=>O(s,e,o,i,t,r,a,n)))}}isMBSGeometryVisible(e,t,r){const i=l.unwrapUpdating(this._layerMaskGeometries),n=this._geometryEngine;if(null!=i&&null!=this.layerFilter&&null!=n){const o=this.layerFilter.spatialRelationship,s=i[0].spatialReference||t;if(!w.projectBoundingSphere(e,r,B,s))return D().warnOnce("SceneLayer.mask geometry is using unsupported SpatialReference, skipping geometry filter for MBS"),!0;return U(n,B,i,s,o)}const o=l.unwrapUpdating(this._viewMaskGeometries);if(null!=o&&null!=this.viewFilter&&null!=n){const i=this.viewFilter.spatialRelationship,s=o[0].spatialReference||t;if(!w.projectBoundingSphere(e,r,B,s))return D().warnOnce("SceneLayerView.filter.geometry is using unsupported SpatialReference, skipping geometry filter for MBS"),!0;return U(n,B,o,s,i)}return!0}get parsedGeometry(){const e=l.unwrapUpdating(this._viewMaskGeometries),t=l.unwrapUpdating(this._layerMaskGeometries);return null==e||null==t?e||t:t.concat(e)}get _layerMaskGeometries(){const e=this.layerFilter;return null==e?null:null==this._geometryEngine?l.updating:"disjoint"===e.spatialRelationship?e.geometries.map((e=>({type:"polygon",rings:e.rings,spatialReference:e.spatialReference,cache:{}}))):[e.geometries.reduce(((e,t)=>(e.rings=[...e.rings,...t.rings],e)),{type:"polygon",rings:[],spatialReference:e.geometries[0].spatialReference,cache:{}})]}get _viewMaskGeometries(){if(null==this.viewFilter)return null;const{geometry:e}=this.viewFilter;if(null==e)return null;if(null==this.viewFilter||null==this._geometryEngine)return l.updating;const{distance:t,units:r}=this.viewFilter,i=this.viewFilter.spatialRelationship,n="mesh"===e.type?e.extent:e;if(null==t||0===t)return x(this._geometryEngine,n,i);const o=r||p.getUnitString(n.spatialReference);if(n.spatialReference.isWGS84){const e=this._geometryEngine.geodesicBuffer(n,t,o);return x(this._geometryEngine,e,i)}const s=v.project(n,T.WGS84);if(null!=s){const e=v.project(this._geometryEngine.geodesicBuffer(s,t,o),n.spatialReference);return x(this._geometryEngine,e,i)}if(!this._projectionEngineLoaded&&(this.loadAsyncModule(S.load().then((()=>this._projectionEngineLoaded=!0))),!this._projectionEngineLoaded))return null;let a=null;try{a=S.project(n,T.WGS84)}catch(c){}if(a)try{a=S.project(this._geometryEngine.geodesicBuffer(a,t,o),n.spatialReference)}catch(c){a=null}return a||D().error(`Filter by geodesic buffer (distance) unsupported, failed to project input geometry (${n.spatialReference.wkid}) to WGS84.`),x(this._geometryEngine,a,i)}get updating(){return l.isUpdating(this._layerMaskGeometries)||l.isUpdating(this._viewMaskGeometries)}static checkSupport(e){return null!=e&&(!!A(e.spatialRelationship)||(D().warn(`Filters with spatialRelationship other than ${G.join(", ")} are not supported for mesh scene layers`),!1))}},r.__decorate([u.property()],t.I3SMeshViewFilter.prototype,"layerFilter",void 0),r.__decorate([u.property({type:j})],t.I3SMeshViewFilter.prototype,"viewFilter",void 0),r.__decorate([u.property()],t.I3SMeshViewFilter.prototype,"layerFieldsIndex",void 0),r.__decorate([u.property()],t.I3SMeshViewFilter.prototype,"loadAsyncModule",void 0),r.__decorate([u.property()],t.I3SMeshViewFilter.prototype,"addSqlFilter",void 0),r.__decorate([u.property()],t.I3SMeshViewFilter.prototype,"addTimeFilter",void 0),r.__decorate([u.property({readOnly:!0})],t.I3SMeshViewFilter.prototype,"sortedObjectIds",null),r.__decorate([u.property({readOnly:!0})],t.I3SMeshViewFilter.prototype,"parsedWhereClause",null),r.__decorate([u.property({readOnly:!0})],t.I3SMeshViewFilter.prototype,"parsedGeometry",null),r.__decorate([u.property({readOnly:!0})],t.I3SMeshViewFilter.prototype,"_layerMaskGeometries",null),r.__decorate([u.property({readOnly:!0})],t.I3SMeshViewFilter.prototype,"_viewMaskGeometries",null),r.__decorate([u.property()],t.I3SMeshViewFilter.prototype,"updating",null),r.__decorate([u.property()],t.I3SMeshViewFilter.prototype,"_projectionEngineLoaded",void 0),r.__decorate([u.property()],t.I3SMeshViewFilter.prototype,"_geometryEngine",void 0),t.I3SMeshViewFilter=r.__decorate([g.subclass(k)],t.I3SMeshViewFilter);const G=(e=>e)(["contains","intersects","disjoint"]);function A(e){return null!=e&&G.includes(e)}var C;function x(e,t,r){if(null==t)return null;if("disjoint"===r&&"polygon"===t.type){const r=t.rings.length,i=t.spatialReference,n=new Array(r);for(let e=0;e<r;++e){const r=b.fromValues(1/0,1/0,-1/0,-1/0);b.expandWithNestedArray(r,t.rings[e]),n[e]={type:"polygon",rings:[t.rings[e]],spatialReference:i,cache:{},aabr:r}}n.sort(((e,t)=>e.aabr[0]-t.aabr[0]));const s=new Set,a=new o.PositionHint;for(let t=0;t<n.length;++t){const r=n[t],i=r.aabr[0];s.forEach((t=>{if(i>=t.aabr[2])return void s.delete(t);if(r.aabr[1]>t.aabr[3]||r.aabr[3]<t.aabr[1]||!e.intersects(r,t))return;r.rings=r.rings.concat(t.rings),b.expand(r.aabr,t.aabr,r.aabr),r.cache={},s.delete(t);const l=o.indexOf(n,t,n.length,a);n.splice(l,1)})),s.add(r)}for(const e of n)e.aabr=void 0;return n}return[t]}function U(e,t,r,i,n){if(t[3]>=.5*(t[2]+m.getReferenceEllipsoid(i).radius))return!0;const o=W(e,t,i);return r.every((t=>L(e,t,o,n)!==C.DISCARD))}function O(e,t,r,i,n,o,s,a){const l=s[0].spatialReference||n.spatialReference;if(!w.projectBoundingSphere(r.node.serviceMbsInIndexSR,o,B,l))return void D().warnOnce("SceneLayerView.filter.geometry is using unsupported SpatialReference, skipping geometry filter");const c=W(e,B,l),p=P(a,n,l,i,r.objectHandle);for(const u of s){if(0===t.length)return;switch(L(e,u,c,a)){case C.DISCARD:return void(t.length=0);case C.KEEP:continue}V.filterInPlace(t,r.featureIds,(t=>N(e,u,t,p)))}}!function(e){e[e.KEEP=0]="KEEP",e[e.DISCARD=1]="DISCARD",e[e.TEST=2]="TEST"}(C||(C={}));const B=M.fromValues(0,0,0,0);function P(e,t,r,i,n){const o=t.renderSpatialReference,s=new Map,a={type:"polygon",rings:[[[0,0,0],[0,0,0],[0,0,0],[0,0,0]]],spatialReference:r};a.rings[0][3]=a.rings[0][0];const l={indices:null,data:null,stride:0,startIndex:0,endIndex:0};let c,p;switch(e){case"intersects":c=(e,t,r)=>e.intersects(t,r)?C.KEEP:C.TEST,p=K;break;case"contains":c=(e,t,r)=>e.contains(t,r)?C.TEST:C.DISCARD,p=K;break;default:c=(e,t,r)=>e.disjoint(t,r)?C.TEST:C.DISCARD,p=q}return{collection:i,object:n,type:e,maskSR:r,renderSR:o,aabbCache:s,triangle:a,positions:l,triangleTest:c,geometryTest:p}}function W(e,t,r){const i={type:"point",x:t[0],y:t[1],hasZ:!1,hasM:!1,spatialReference:r},n=!I.isWGS84(r)&&!I.isWebMercator(r),o=Number.isNaN(t[3])?0:a.clamp(t[3],0,2*E.earth.radius),s=n?e.buffer(i,o,1):e.geodesicBuffer(i,o,1);return s.type="polygon",s}function L(e,t,r,i){switch(i){case"intersects":case"contains":return K(e,t,r);case"disjoint":return q(e,t,r)}}function K(e,t,r){return e.intersects(t,r)?e.contains(t,r)?C.KEEP:C.TEST:C.DISCARD}function q(e,t,r){return e.intersects(t,r)?e.contains(t,r)?C.DISCARD:C.TEST:C.KEEP}function N(e,t,r,i){const{collection:n,object:o,renderSR:s,maskSR:a,geometryTest:l,aabbCache:c}=i;let p=c.get(r);if(!p){const e=n.getObjectTransform(o);n.getComponentAabb(o,r,$);const t=[y.fromValues($[0],$[1],0),y.fromValues($[0],$[4],0),y.fromValues($[3],$[4],0),y.fromValues($[3],$[1],0)];for(let r=0;r<4;++r)h.transformMat3(t[r],t[r],e.rotationScale),h.add(t[r],t[r],e.position),_.projectVectorToVector(t[r],s,t[r],a);p={type:"polygon",rings:[t],spatialReference:a,cache:{}},p.rings[0][4]=p.rings[0][0],c.set(r,p)}switch(l(e,t,p)){case C.DISCARD:return!1;case C.KEEP:return!0}const{triangle:u,triangleTest:d,positions:g}=i,f=u.rings[0][0],m=u.rings[0][1],S=u.rings[0][2],w=n.getObjectTransform(o);n.getComponentPositions(o,r,g);const{indices:F,data:b,stride:R,startIndex:E,endIndex:I}=g;for(let y=E;y<I;y+=3){const r=R*F[y],i=R*F[y+1],n=R*F[y+2];switch(h.set(f,b[r],b[r+1],b[r+2]),h.set(m,b[i],b[i+1],b[i+2]),h.set(S,b[n],b[n+1],b[n+2]),h.transformMat3(f,f,w.rotationScale),h.transformMat3(m,m,w.rotationScale),h.transformMat3(S,S,w.rotationScale),h.add(f,f,w.position),h.add(m,m,w.position),h.add(S,S,w.position),_.projectVectorToVector(f,s,f,a),_.projectVectorToVector(m,s,m,a),_.projectVectorToVector(S,s,S,a),d(e,t,u)){case C.DISCARD:return!1;case C.KEEP:return!0}}return"intersects"!==i.type}const $=F.create();Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
