/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../chunks/tslib.es6","../../../../request","../../../../core/Accessor","../../../../core/arrayUtils","../../../../core/asyncUtils","../../../../core/byteSizeEstimations","../../../../core/Collection","../../../../core/handleUtils","../../../../core/has","../../../../core/Logger","../../../../core/maybe","../../../../core/promiseUtils","../../../../core/ReactiveSet","../../../../core/reactiveUtils","../../../../core/accessorSupport/decorators/property","../../../../core/accessorSupport/decorators/subclass","../../../../geometry/support/spatialReferenceUtils","../../../../intl/number","../../../../layers/support/featureQueryAll","../../../../rest/support/meshFeatureSet","../../../../support/requestUtils","../../../ViewingMode"],(function(e,t,r,s,i,a,o,n,d,c,h,l,u,y,p,g,m,_,b,f,v,O,I){"use strict";e.I3SOverrides=class extends s{constructor(e){super(e),this._warnMaximumChangedObjectsExceeded=!1,this._maximumNumberOfEditOVerrides=j,this._definitionExpressionDirty=!0,this._interactiveEditingSessions=new n,this.geometryOverrides=new n,this._clientGeometryCache=new Map,this._attributeChangedObjectIds=new y,this._geometryChangedObjectIds=new y,this._pendingFetchChangedObjectIds=null,this._pendingFetchAbortController=new AbortController,this._applyGeometryOverridesTask=null,this._featureIdLocks=new Map}initialize(){this._memCache=this.memoryController.newCache(`i3s-attribute-overrides-${this.layer.uid}`),this.addHandles(p.watch((()=>this.layer.definitionExpression),(async()=>{this._definitionExpressionDirty=!0,this._pendingFetchChangedObjectIds||(this._applyGeometryOverridesTask=l.abortMaybe(this._applyGeometryOverridesTask),this._applyGeometryOverridesTask=a.createTask((e=>this._queryAndAddGeometryOverrides(e))),await this._applyGeometryOverridesTask.promise)}),p.sync)),this._pendingFetchChangedObjectIds=this._fetchChangedObjectIds(this._pendingFetchAbortController?.signal),this._pendingFetchChangedObjectIds.finally((()=>{this._pendingFetchAbortController=null,this._pendingFetchChangedObjectIds=null}))}destroy(){this._set("layer",null),this._memCache=l.destroyMaybe(this._memCache),this._pendingFetchAbortController=l.abortMaybe(this._pendingFetchAbortController),this._pendingFetchChangedObjectIds=null,this._featureIdLocks.clear()}get is3DOFL(){return null!=this._associatedLayer?.infoFor3D}get sortedGeometryChangedObjectIds(){return this.is3DOFL?[...this._geometryChangedObjectIds].sort(((e,t)=>e-t)):[]}get _associatedLayer(){return null==this.layer?null:this.layer.associatedLayer}get hasGeometryChanges(){return this._geometryChangedObjectIds.size>0}get updating(){return!!this.is3DOFL&&!!(this._pendingFetchChangedObjectIds||this._applyGeometryOverridesTask&&!this._applyGeometryOverridesTask.finished)}get isEmpty(){return null==this._pendingFetchChangedObjectIds&&0===this._attributeChangedObjectIds.size&&0===this._geometryChangedObjectIds.size}featureHasGeometryChanges(e){return this._geometryChangedObjectIds.has(e)}featureHasAttributeChanges(e){return this._attributeChangedObjectIds.has(e)}createInteractiveEditSession(e){this._attributeChangedObjectIds.add(e);const t=this._interactiveEditingSessions,r=new C(e,(()=>{t.remove(r)}));return t.unshift(r),r}async applyAttributeOverrides(e,t,r,s=[]){if(this._pendingFetchChangedObjectIds&&await u.whenOrAbort(this._pendingFetchChangedObjectIds,r),null==t)return;const{attributeData:i,loadedAttributes:a}=t;if(null==a||null==i||0===this._attributeChangedObjectIds.size)return;const o=new Set;for(const d of a)o.add(d.index);for(const d of s)o.has(d.index)||(a.push(d),i[d.name]=new Array(e.length));const n=await this._lockFeatureIds(e);try{const t={attributeData:i,loadedAttributes:a},s=this._getOverridesFromCache(e,t,this._attributeChangedObjectIds),{objectIds:o,fieldNames:n}=s;if(0===o.length||0===n.length)return;const d=await this._queryAttributeOverridesFromAssociatedLayer(o,n,r);if(null==d)return;this._processOverridesFromAssociatedLayer(e,d,n,t)}finally{n.remove()}}updateGeometry(e,t){this._geometryChangedObjectIds.add(e);const r=this._clientGeometryCache.get(e);if(null!=r&&(this.geometryOverrides.remove(r),this._clientGeometryCache.delete(e)),null!=t){const r={oid:e,mesh:t};this.geometryOverrides.add(r),this._clientGeometryCache.set(e,r)}}updateAttributeValue(e,t,r){this._attributeChangedObjectIds.add(e),this._cacheAttributeValue(e,t,r)}featureAdded(e){this.is3DOFL&&this._geometryChangedObjectIds.add(e),this._attributeChangedObjectIds.add(e)}_cacheAttributeValue(e,t,r){this._memCache.put(this._getAttributeCacheKey(e,t),r,this._memCacheAttributeValueSize(r))}_getOverridesFromCache(e,{loadedAttributes:t,attributeData:r},s){const i=new Set,a=new Array;for(const n of t)a[n.index]=r[n.name];const o=new Set;for(let n=0;n<e.length;n++){const r=e[n];if(s.has(r))for(const e of t){const t=this._attributeFromCache(r,e.index);void 0===t?(i.add(r),o.add(e.name)):a[e.index][n]=t}}return{objectIds:Array.from(i),fieldNames:Array.from(o)}}_attributeFromCache(e,t){const r=this._fromInteractiveEditingSession(e,t);if(void 0!==r)return r;const s=this._getAttributeCacheKey(e,t);return this._memCache.get(s)}_fromInteractiveEditingSession(e,t){if(null!=this._interactiveEditingSessions)for(const r of this._interactiveEditingSessions){if(r.objectId!==e)continue;const s=r.getAttribute(t);if(void 0!==s)return s}}_getAttributeCacheKey(e,t){return`${e}-${t}`}async _queryAttributeOverridesFromAssociatedLayer(e,t,r){if(0===e.length)return null;this._logWarningIfMaximumObjectsExceeded();const{associatedLayer:s}=this.layer;if(null==s)return null;const i=s.createQuery(),{objectIdField:a}=s,o=[a,...t];i.where=this.layer.definitionExpression||"1=1",i.returnGeometry=!1,i.outFields=o,i.cacheHint=!0;const n=await this._executeBatchQuery(s,e,i,r),d=[];for(const c of n)if(c.ok)for(const e of c.value.features)d.push(e);return d}async _queryGeometryOverridesFromAssociatedLayer(e,t){if(0===e.length||!this.is3DOFL)return null;const r=this.layer.associatedLayer,s=r.infoFor3D,{spatialReference:i}=r,{state:{viewingMode:a},spatialReference:o}=this.view,n=a===I.ViewingMode.Global,d=i.isGeographic;if(n&&!d)return h.getLogger(this).warn("unsupported-pcs-edits-in-global-view",this.layer.title,A(i,o,this.view.viewingMode,S.Mode)),null;if(!n&&d)return h.getLogger(this).warn("unsupported-gcs-edits-in-local-view",this.layer.title,A(i,o,this.view.viewingMode,S.Mode)),null;if(!(_.equals(i,o)||n&&o.isWebMercator&&i.isWGS84))return h.getLogger(this).warn("unsupported-mismatched-spatial-reference-edits",this.layer.title,A(i,o,this.view.viewingMode,S.SpatialReference)),null;this._logWarningIfMaximumObjectsExceeded();const{objectIdField:c,globalIdField:l}=r,u=[c,...null!=l?[l]:[]],y=r.createQuery();y.where=this.layer.definitionExpression||"1=1",y.returnGeometry=!0,y.outFields=u,y.cacheHint=!0,y.returnZ=r.hasZ,y.returnM=r.hasM;const p=await this._executeBatchQuery(r,e,y,t),g=[];for(const h of p){if(!h.ok)continue;const e=h.value,{assetMaps:t,features:r,globalIdFieldName:a}=e;if(null==t)continue;const o=v.assetMapFromAssetMapsJSON(s,t);for(const n of r){const e=v.extractMesh(n,a,i,s,o),t=n;null!=e?(t.geometry=e,g.push(t)):t.geometry=null}}return g}_logWarningIfMaximumObjectsExceeded(){if(!this._warnMaximumChangedObjectsExceeded)return;this._warnMaximumChangedObjectsExceeded=!1;let e=`The number of edited objects that are not yet cached in the scene service exceeds the maximum limit. Attribute changes will only be available for the first ${b.formatNumber(this._maximumNumberOfEditOVerrides)} objects. Please consider re-caching the scene service`;const t=this.layer.portalItem;e+=t?.loaded?` (${t.portal.url}/home/item.html?id=${t.id}#settings)`:` (${this.layer.parsedUrl.path})`,h.getLogger(this).warn("#queryOverrides()",this.layer.title,`${e}.`)}async _executeBatchQuery(e,t,r,s){if(0===t.length)return[];const o=f.getMaximumQuerySize(e);t=[...t].sort(((e,t)=>e-t));const n=i.splitIntoChunks(t,o).map((t=>{const i=r.clone();return i.objectIds=t,a.resultOrAbort(f.queryAllJSON(e,i,{signal:s}))}));return Promise.all(n)}_processOverridesFromAssociatedLayer(e,t,r,{loadedAttributes:s,attributeData:i}){const a=this._associatedLayer;if(null==a)return;const o=a.objectIdField,n=r.map((t=>(t in i||(i[t]=new Array(e.length)),i[t]))),d=new Map(s.map((e=>[e.name,e.index]))),c=r.map((e=>d.get(e))),h=new Map(Array.from(e,((e,t)=>[e,t])));for(const l of t){const e=l.attributes[o];for(let t=0;t<r.length;t++){const s=c[t],i=h.get(e),a=l.attributes[r[t]];n[t][i]=a,this._cacheAttributeValue(e,s,a)}}}_memCacheAttributeValueSize(e){return"string"==typeof e?o.estimateStringByteSize(e):o.estimateNumberByteSize()}async _fetchChangedObjectIds(e){const t=this.layer;await t.load({signal:e}),this._geometryChangedObjectIds.clear(),this._attributeChangedObjectIds.clear();const{associatedLayer:s}=t;if(null==s||!s.capabilities?.operations?.supportsChangeTracking)return;const i=this._getFetchChangedObjectIdsServerGen();if(null==i)return;const o=s.layerId,n=this.is3DOFL,d={f:"json",returnIdsOnly:!0,layers:`[${o}]`,returnUpdates:!0,returnDeletes:n,returnInserts:n,layerServerGens:JSON.stringify([{id:o,serverGen:i}])};if(n){const e=s.infoFor3D;d.fieldsToCompare=JSON.stringify({fields:[...Object.values(e.transformFieldRoles),e.sourceHashField]})}const c=await a.result(r(`${s.url}/extractChanges`,{method:"post",query:d,timeout:w,signal:e}));if(!c.ok&&O.isTimeoutError(c.error)){const e=this.layer.title;h.getLogger(this).warn("extractChanges:timeout",e,`${e} could not obtain edited features that are not cached in the scene service. Display of features may not be up to date with the latest edits. Consider re-caching the scene service.`)}if(c.ok&&1===c.value.data?.edits?.length){const t=c.value.data.edits[0],r=t?.objectIds,s=t?.fieldUpdates,i=r?.adds??[],a=r?.updates??[],o=r?.deletes??[],d=[...i,...a,...o],h=n?[...i,...s??a,...o]:[],l=Math.min(this._maximumNumberOfEditOVerrides,d.length);l<d.length&&(this._warnMaximumChangedObjectsExceeded=!0);const u=d.sort(((e,t)=>e-t));for(let e=0;e<l;++e){const t=u[e];this._attributeChangedObjectIds.add(t)}for(const e of h)this._geometryChangedObjectIds.add(e);for(;this._definitionExpressionDirty;)await this._queryAndAddGeometryOverrides(e)}}async _queryAndAddGeometryOverrides(e){this._definitionExpressionDirty=!1;const t=this.layer,{associatedLayer:r}=t;if(null!=r&&r.capabilities?.operations?.supportsChangeTracking&&this.is3DOFL&&this._geometryChangedObjectIds.size>0){const t=await this._queryGeometryOverridesFromAssociatedLayer(Array.from(this._geometryChangedObjectIds),e);if(null!=t)for(const e of t)null!=e.geometry&&this.updateGeometry(e.attributes[r.objectIdField],e.geometry)}}_getFetchChangedObjectIdsServerGen(){const e=this.layer;if(null!=e.serviceUpdateTimeStamp?.lastUpdate)return e.serviceUpdateTimeStamp.lastUpdate;const t=e.associatedLayer;return null!=t?.serverGens?.minServerGen?t.serverGens.minServerGen:null}async _lockFeatureIds(e){const t=this._featureIdLocks;let r=!0;for(;r;){const s=new Array;for(const r of e){const e=t.get(r);e&&s.push(e)}0===s.length?r=!1:await Promise.all(s)}const s=u.createResolver(),i=s.promise;for(const a of e)t.set(a,i);return d.makeHandle((()=>{for(const r of e)t.delete(r);s.resolve()}))}get test(){}},t.__decorate([g.property({constructOnly:!0})],e.I3SOverrides.prototype,"view",void 0),t.__decorate([g.property({constructOnly:!0})],e.I3SOverrides.prototype,"layer",void 0),t.__decorate([g.property({readOnly:!0})],e.I3SOverrides.prototype,"is3DOFL",null),t.__decorate([g.property()],e.I3SOverrides.prototype,"_interactiveEditingSessions",void 0),t.__decorate([g.property({readOnly:!0})],e.I3SOverrides.prototype,"sortedGeometryChangedObjectIds",null),t.__decorate([g.property({readOnly:!0})],e.I3SOverrides.prototype,"geometryOverrides",void 0),t.__decorate([g.property()],e.I3SOverrides.prototype,"_clientGeometryCache",void 0),t.__decorate([g.property()],e.I3SOverrides.prototype,"_associatedLayer",null),t.__decorate([g.property({constructOnly:!0})],e.I3SOverrides.prototype,"memoryController",void 0),t.__decorate([g.property()],e.I3SOverrides.prototype,"_attributeChangedObjectIds",void 0),t.__decorate([g.property()],e.I3SOverrides.prototype,"_geometryChangedObjectIds",void 0),t.__decorate([g.property()],e.I3SOverrides.prototype,"hasGeometryChanges",null),t.__decorate([g.property()],e.I3SOverrides.prototype,"_pendingFetchChangedObjectIds",void 0),t.__decorate([g.property()],e.I3SOverrides.prototype,"_pendingFetchAbortController",void 0),t.__decorate([g.property()],e.I3SOverrides.prototype,"_applyGeometryOverridesTask",void 0),t.__decorate([g.property()],e.I3SOverrides.prototype,"updating",null),t.__decorate([g.property()],e.I3SOverrides.prototype,"isEmpty",null),e.I3SOverrides=t.__decorate([m.subclass("esri.views.3d.layers.i3s.I3SOverrides")],e.I3SOverrides);class C{constructor(e,t){this.objectId=e,this._remove=t,this._updates=new Map,this._isActive=!0}getAttribute(e){return this._updates.get(e)}setAttribute(e,t){this.isActive&&this._updates.set(e,t)}remove(){this.isActive&&(this._isActive=!1,this._remove())}get isActive(){return this._isActive}}const w=1e4,j=5e4;var S;function A(e,t,r,s){return`Displaying the edits of a SceneLayer with a${s===S.Mode?e.isGeographic?" geographic ":" projected ":" "}spatial reference (wkid:${e.wkid}) in ${r} viewing mode${s===S.SpatialReference?` with spatial reference (wkid:${t.wkid}) `:" "}is not supported. No geometry edits will be displayed for this layer.\nPlease consider re-caching the scene service or changing the ${s===S.Mode?"viewing mode":"view spatial reference"} to display edits.`}!function(e){e[e.Mode=0]="Mode",e[e.SpatialReference=1]="SpatialReference"}(S||(S={})),Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
