/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../core/has","../../../../core/mathUtils","../../../../core/libs/gl-matrix-2/math/mat3","../../../../core/libs/gl-matrix-2/factories/mat3f64","../../../../core/libs/gl-matrix-2/math/mat4","../../../../core/libs/gl-matrix-2/factories/mat4f64","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../renderers/support/lengthUtils","../../support/debugFlags","../../webgl-engine/core/shaderModules/interfaces"],(function(e,t,i,o,n,s,r,a,l,u,f,c){"use strict";var p,d;e.FastSizeType=void 0,(p=e.FastSizeType||(e.FastSizeType={}))[p.Undefined=0]="Undefined",p[p.DefinedSize=1]="DefinedSize",p[p.DefinedScale=2]="DefinedScale",e.FastRotationType=void 0,(d=e.FastRotationType||(e.FastRotationType={}))[d.Undefined=0]="Undefined",d[d.DefinedAngle=1]="DefinedAngle";class z{constructor(e){this.field=e}}class v extends z{constructor(t){super(t),this.minSize=[0,0,0],this.maxSize=[0,0,0],this.offset=[0,0,0],this.factor=[0,0,0],this.type=[e.FastSizeType.Undefined,e.FastSizeType.Undefined,e.FastSizeType.Undefined]}}class S extends z{constructor(e){super(e),this.colors=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],this.values=[0,0,0,0,0,0,0,0]}}class y extends z{constructor(e){super(e),this.values=[0,0,0,0,0,0,0,0],this.opacityValues=[0,0,0,0,0,0,0,0]}}class m extends z{constructor(e){super(e),this.offset=[0,0,0],this.factor=[1,1,1],this.type=[0,0,0]}}class h{}function x(e){return null!=e}function b(e){return"number"==typeof e}function g(e){return"string"==typeof e}function F(e){return null==e||g(e)}function T(e,t){e&&e.push(t)}function C(e,t,i,o=r.create()){const n=e||0,a=t||0,l=i||0;return 0!==n&&s.rotateZ(o,o,-n/180*Math.PI),0!==a&&s.rotateX(o,o,a/180*Math.PI),0!==l&&s.rotateY(o,o,l/180*Math.PI),o}function V(t,i,o,n,s){const r=t.minSize,a=t.maxSize;if(t.useSymbolValue){const t=n.symbolSize[o];return i.minSize[o]=t,i.maxSize[o]=t,i.offset[o]=i.minSize[o],i.factor[o]=0,i.type[o]=e.FastSizeType.DefinedSize,!0}if(x(t.field))return x(t.stops)?2===t.stops.length&&b(t.stops[0].size)&&b(t.stops[1].size)?(D(t.stops[0].size,t.stops[1].size,t.stops[0].value,t.stops[1].value,i,o),i.type[o]=e.FastSizeType.DefinedSize,!0):(T(s,"Could not convert size info: stops only supported with 2 elements"),!1):b(r)&&b(a)&&x(t.minDataValue)&&x(t.maxDataValue)?(D(r,a,t.minDataValue,t.maxDataValue,i,o),i.type[o]=e.FastSizeType.DefinedSize,!0):"unknown"===t.valueUnit?(T(s,"Could not convert size info: proportional size not supported"),!1):null!=u.meterIn[t.valueUnit]?(i.minSize[o]=-1/0,i.maxSize[o]=1/0,i.offset[o]=0,i.factor[o]=1/u.meterIn[t.valueUnit],i.type[o]=e.FastSizeType.DefinedSize,!0):(T(s,"Could not convert size info: scale-dependent size not supported"),!1);if(!x(t.field)){if(t.stops?.[0]&&b(t.stops[0].size))return i.minSize[o]=t.stops[0].size,i.maxSize[o]=t.stops[0].size,i.offset[o]=i.minSize[o],i.factor[o]=0,i.type[o]=e.FastSizeType.DefinedSize,!0;if(b(r))return i.minSize[o]=r,i.maxSize[o]=r,i.offset[o]=r,i.factor[o]=0,i.type[o]=e.FastSizeType.DefinedSize,!0}return T(s,"Could not convert size info: unsupported variant of sizeInfo"),!1}function D(e,t,i,o,n,s){const r=Math.abs(o-i)>0?(t-e)/(o-i):0;n.minSize[s]=r>0?e:t,n.maxSize[s]=r>0?t:e,n.offset[s]=e-i*r,n.factor[s]=r}function U(e,t,i,o){if(e.normalizationField||e.valueRepresentation)return T(o,"Could not convert size info: unsupported property"),null;if(!F(e.field))return T(o,"Could not convert size info: field is not a string"),null;if(t.size){if(e.field)if(t.size.field){if(e.field!==t.size.field)return T(o,"Could not convert size info: multiple fields in use"),null}else t.size.field=e.field}else t.size=new v(e.field);let n;switch(e.axis){case"width":return n=V(e,t.size,0,i,o),n?t:null;case"height":return n=V(e,t.size,2,i,o),n?t:null;case"depth":return n=V(e,t.size,1,i,o),n?t:null;case"width-and-depth":return n=V(e,t.size,0,i,o),n&&V(e,t.size,1,i,o),n?t:null;case null:case void 0:case"all":return n=V(e,t.size,0,i,o),n=n&&V(e,t.size,1,i,o),n=n&&V(e,t.size,2,i,o),n?t:null;default:return T(o,`Could not convert size info: unknown axis "${e.axis}""`),null}}function M(t,i,o){for(let s=0;s<3;++s){let o=i.unitInMeters;t.type[s]===e.FastSizeType.DefinedSize&&(o*=i.modelSize[s],t.type[s]=e.FastSizeType.DefinedScale),t.minSize[s]=t.minSize[s]/o,t.maxSize[s]=t.maxSize[s]/o,t.offset[s]=t.offset[s]/o,t.factor[s]=t.factor[s]/o}let n;if(t.type[0]!==e.FastSizeType.Undefined)n=0;else if(t.type[1]!==e.FastSizeType.Undefined)n=1;else{if(t.type[2]===e.FastSizeType.Undefined)return T(o,"No size axis contains a valid size or scale"),!1;n=2}for(let s=0;s<3;++s)t.type[s]===e.FastSizeType.Undefined&&(t.minSize[s]=t.minSize[n],t.maxSize[s]=t.maxSize[n],t.offset[s]=t.offset[n],t.factor[s]=t.factor[n],t.type[s]=t.type[n]);return!0}function w(e,t,i){e[4*t]=i.r/255,e[4*t+1]=i.g/255,e[4*t+2]=i.b/255,e[4*t+3]=i.a}function I(e,t,i){if(e.normalizationField)return T(i,"Could not convert color info: unsupported property"),null;if(g(e.field)){if(!e.stops)return T(i,"Could not convert color info: missing stops or colors"),null;{if(e.stops.length>8)return T(i,"Could not convert color info: too many color stops"),null;t.color=new S(e.field);const o=e.stops;for(let e=0;e<8;++e){const i=o[Math.min(e,o.length-1)];t.color.values[e]=i.value,w(t.color.colors,e,i.color)}}}else{if(!(e.stops&&e.stops.length>=0))return T(i,"Could not convert color info: no field and no colors/stops"),null;{const i=e.stops&&e.stops.length>=0&&e.stops[0].color;t.color={field:null,values:[0,0,0,0,0,0,0,0],colors:[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]};for(let e=0;e<8;e++)t.color.values[e]=1/0,w(t.color.colors,e,i)}}return t}function P(e,t,i){if(e.normalizationField)return T(i,"Could not convert opacity info: unsupported property"),null;if(g(e.field)){if(!e.stops)return T(i,"Could not convert opacity info: missing stops or opacities"),null;{if(e.stops.length>8)return T(i,"Could not convert opacity info: too many opacity stops"),null;t.opacity=new y(e.field);const o=e.stops;for(let e=0;e<8;++e){const i=o[Math.min(e,o.length-1)];t.opacity.values[e]=i.value,t.opacity.opacityValues[e]=i.opacity}}}else{if(!(e.stops&&e.stops.length>=0))return T(i,"Could not convert opacity info: no field and no opacities/stops"),null;{const i=e.stops&&e.stops.length>=0?e.stops[0].opacity:0;t.opacity={field:null,values:[0,0,0,0,0,0,0,0],opacityValues:[0,0,0,0,0,0,0,0]};for(let e=0;e<8;e++)t.opacity.values[e]=1/0,t.opacity.opacityValues[e]=i}}return t}function R(e,t,i){const o=2===i&&"arithmetic"===e.rotationType;t.offset[i]=o?90:0,t.factor[i]=o?-1:1,t.type[i]=1}function A(e,t,i){if(!g(e.field))return T(i,"Could not convert rotation info: field is not a string"),null;if(t.rotation){if(e.field)if(t.rotation.field){if(e.field!==t.rotation.field)return T(i,"Could not convert rotation info: multiple fields in use"),null}else t.rotation.field=e.field}else t.rotation={field:e.field,offset:[0,0,0],factor:[1,1,1],type:[0,0,0]};switch(e.axis){case"tilt":return R(e,t.rotation,0),t;case"roll":return R(e,t.rotation,1),t;case null:case void 0:case"heading":return R(e,t.rotation,2),t;default:return T(i,`Could not convert rotation info: unknown axis "${e.axis}""`),null}}class k{constructor(e,t=[1,1,1],i=[1,1,1],o=1,n=[0,0,0],s=[1,1,1],r=[0,0,0]){this.supports=e,this.modelSize=t,this.symbolSize=i,this.unitInMeters=o,this.anchor=n,this.scale=s,this.rotation=r}}function E(e,t,i){if(!e)return null;const o=e.reduce(((e,o)=>{if(!e)return e;if(o.valueExpression)return T(i,"Could not convert visual variables: arcade expressions not supported"),null;switch(o.type){case"size":return t.supports.size?U(o,e,t,i):e;case"color":return t.supports.color?I(o,e,i):e;case"opacity":return t.supports.opacity?P(o,e,i):null;case"rotation":return t.supports.rotation?A(o,e,i):e;default:return null}}),new h);return!(e.length>0&&o)||o.size||o.color||o.opacity||o.rotation?o?.size&&!M(o.size,t,i)?null:o:null}class O{constructor(e,t,i){this.visualVariables=e,this.materialParameters=t,this.requiresShaderTransformation=i}}function _(e,t){if(!e)return null;if(f.debugFlags.TESTS_DISABLE_FAST_UPDATES)return null;const i=E(e.visualVariables,t);return i?new O(i,j(i,t),!!i.size):null}function q(e,t,i){if(!t||!e)return!1;const o=e.visualVariables,n=E(t.visualVariables,i);return!!n&&(!!(N(o.size,n.size,"size")&&N(o.color,n.color,"color")&&N(o.rotation,n.rotation,"rotation")&&N(o.opacity,n.opacity,"opacity"))&&(e.visualVariables=n,e.materialParameters=j(n,i),e.requiresShaderTransformation=!!n.size,!0))}function N(e,t,i){if(!!e!=!!t)return!1;if(e&&e.field!==t?.field)return!1;if(e&&"rotation"===i){const i=e,o=t;for(let e=0;e<3;e++)if(i.type[e]!==o.type[e]||i.offset[e]!==o.offset[e]||i.factor[e]!==o.factor[e])return!1}return!0}class $ extends c.NoParameters{constructor(e){super(),this.vvSize=e?.size??null,this.vvColor=e?.color??null,this.vvOpacity=e?.opacity??null}}function j(e,t){const i=new $(e);return i.vvSize&&(i.vvSymbolAnchor=t.anchor,s.identity(G),C(t.rotation[2],t.rotation[0],t.rotation[1],G),i.vvSymbolRotationMatrix=i.vvSymbolRotationMatrix||n.create(),o.fromMat4(i.vvSymbolRotationMatrix,G)),i}function B(e,t,o){if(!e.vvSize)return o;s.copy(Y,o);const n=e.vvSymbolRotationMatrix;s.set(G,n[0],n[1],n[2],0,n[3],n[4],n[5],0,n[6],n[7],n[8],0,0,0,0,1),s.multiply(Y,Y,G);for(let s=0;s<3;++s){const o=e.vvSize.offset[s]+t[0]*e.vvSize.factor[s];Z[s]=i.clamp(o,e.vvSize.minSize[s],e.vvSize.maxSize[s])}return s.scale(Y,Y,Z),s.translate(Y,Y,e.vvSymbolAnchor),Y}function L(e,t,o){if(!t.vvSize)return a.set(e,1,1,1),e;for(let n=0;n<3;++n){const s=t.vvSize.offset[n]+o[0]*t.vvSize.factor[n];e[n]=i.clamp(s,t.vvSize.minSize[n],t.vvSize.maxSize[n])}return e}function X(e,t){const i=null==e?0:t.attributes[e];return"number"==typeof i&&isFinite(i)?i:0}const Y=r.create(),Z=l.create(),G=r.create();e.ConvertOptions=k,e.FastColorInfo=S,e.FastOpacityInfo=y,e.FastRotationInfo=m,e.FastSizeInfo=v,e.FastSymbolUpdatesState=O,e.FastVisualVariables=h,e.VisualVariablesParameters=$,e.convertVisualVariables=E,e.evaluateModelTransform=B,e.evaluateModelTransformScale=L,e.getAttributeValue=X,e.getMaterialParameters=j,e.initFastSymbolUpdatesState=_,e.updateFastSymbolUpdatesState=q,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
