/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../core/arrayUtils","../../../../core/signal","../../../../geometry/support/aaBoundingRect","../../../../layers/graphics/dehydratedFeatures","../graphics/graphicUtils"],(function(t,e,s,i,u,a){"use strict";const r=16438,h=new Set;class n{constructor(e){this.descriptor=e,this.fetchStatus=t.FetchStatus.FETCH_NEEDED,this.displayingFeatureResolution=0,this.fetchingFeatureResolution=0,this._featuresLength=s.signal(0),this._numVertices=0,this._featuresMissing=s.signal(!0),this._fetchFailed=s.signal(!1),this._shuffled=!1,this._numFeatures=l,this._emptyFeatureRatio=s.signal(0),this._estimatedSize=-1,this._estimatedUnusedSize=0,this._estimatedUnusedSizeDirty=!1,this._displayingFeatures=null,this.alive=!0,this.filtered=!1,this._features=null,this._featureLimit=s.signal(0),this._availableFields=h,this.fetchingFeatureResolution=e.resolution,this.displayingFeatureResolution=e.resolution}get featuresMissing(){return this._featuresMissing.value}set featuresMissing(t){this._featuresMissing.value=t}get missingAttributes(){return this._missingAttributes}get fetchFailed(){return this._fetchFailed.value}set fetchFailed(t){this._fetchFailed.value=t}get displayingFeatures(){return this._displayingFeatures}set displayingFeatures(t){this._displayingFeatures=t,this.extentIncludingBorrowedFeatures=null}get perTileMaximumNumberOfFeaturesExceeded(){const e=(this.fetchStatus===t.FetchStatus.DONE||this.fetchStatus===t.FetchStatus.FULL)&&this.featuresMissing;return!this.filtered&&(e||this.hasFeatureLimit)}get features(){return this._features}get featureLimit(){return this._featureLimit.value}set featureLimit(t){this._featureLimit.value!==t&&(this._featureLimit.value=t,this._estimatedUnusedSizeDirty=!0)}get hasFeatureLimit(){return this.featureLimit!==this._featuresLength.value}get hasAllFeatures(){return!(this.featuresMissing||this.fetchFailed||this.hasFeatureLimit)}get availableFields(){return this._availableFields}setFeatures(t,e,s,i){this._availableFields=s??h,this._features=t,this._featuresLength.value=t?.length??0,this._shuffled=!1,this._estimatedSize=-1,this._estimatedUnusedSizeDirty=!0,this._missingAttributes=i,t&&t.length>0?(this._emptyFeatureRatio.value=e/(t.length+e),this._numVertices=t.reduce(((t,e)=>t+u.numVertices(e.geometry)),0)):(this._emptyFeatureRatio.value=0,this._numVertices=0)}computeZQuantizationFactor(){if(this._features&&this._features.length>0){const t=this._features.reduce(((t,{geometry:e})=>Math.max(t,a.computeMaxZ(e)??0)),0);return Math.floor(t/this.descriptor.planetRadius)+1}return 1}get emptyFeatureRatio(){return this._emptyFeatureRatio.value}get numFeatures(){return this.hasPreciseFeatureCount?this._numFeatures:this._features?this._features.length:0}set numFeatures(t){this._numFeatures=t}get hasPreciseFeatureCount(){return this._numFeatures>l}get needsFeatureCount(){return this._numFeatures===l}get numVertices(){return this._numVertices}get id(){return this.descriptor.id}get estimatedSize(){return this.updateMemoryEstimates(),this._estimatedSize}get estimatedUnusedSize(){return this._estimatedUnusedSize}updateMemoryEstimates(){if(this._estimatedSize<0){if(this._estimatedSize=0,this._estimatedUnusedSize=0,this._features)for(let t=0;t<this._features.length;++t){const e=u.estimateSize(this._features[t]);this._estimatedSize+=e,t>=this.featureLimit&&(this._estimatedUnusedSize+=e)}return!0}if(this._estimatedUnusedSizeDirty){if(this._estimatedUnusedSize=0,this._estimatedUnusedSizeDirty=!1,this._features)for(let t=this.featureLimit;t<this._features.length;++t)this._estimatedUnusedSize+=u.estimateSize(this._features[t]);return!0}return!1}get isFetching(){return this.fetchStatus===t.FetchStatus.FETCHING||this.fetchStatus===t.FetchStatus.REFETCHING}get isRefetching(){return this.fetchStatus===t.FetchStatus.REFETCHING}get needsFetching(){return this.fetchStatus===t.FetchStatus.FETCH_NEEDED||this.fetchStatus===t.FetchStatus.REFETCH_NEEDED}get needsRefetching(){return this.fetchStatus===t.FetchStatus.REFETCH_NEEDED}get isFetched(){return this.fetchStatus===t.FetchStatus.DONE||this.fetchStatus===t.FetchStatus.FULL}resetFetching(){this.fetchStatus=this.fetchStatus===t.FetchStatus.REFETCHING?t.FetchStatus.REFETCH_NEEDED:t.FetchStatus.FETCH_NEEDED}get needsDisplayUpdate(){return!!this._features&&!F(this._features,this.displayingFeatures,this.featureLimit)}intersects(t){return null==t||!this.descriptor.extent||(i.fromExtent(t,_),i.intersects(this.descriptor.extent,_))}intersectionIncludingBorrowed(t,e){const s=null!=this.extentIncludingBorrowedFeatures?this.extentIncludingBorrowedFeatures:this.descriptor.extent;return t||s?(null!=t?(i.fromExtent(t,e),i.intersection(e,s,e)):i.copy(e,s),e):(i.copy(e,i.positiveInfinity),e)}_shuffle(t){this._features&&(this._features.sort(((e,s)=>u.getObjectId(e,t)-u.getObjectId(s,t))),e.shuffle(this._features,r),this._shuffled=!0,this._estimatedUnusedSizeDirty=!0)}reduceFeatures(e,s,i){if(e<=0)return!1;if(!this._features)return this.featureLimit=0,!1;let u=!1;this.featureLimit=Math.ceil(this.numFeatures*e),this.featureLimit>this._features.length&&(this.featureLimit=this._features.length,this.fetchStatus===t.FetchStatus.DONE&&this._features.length>0&&(this.fetchStatus=t.FetchStatus.REFETCH_NEEDED,u=!0)),!this._shuffled&&e<1&&this._shuffle(i);const a=Math.max(this.featureLimit,Math.ceil(s*this.numFeatures));return this._features.length>a&&(this._features.length=a,this._featuresLength.value=a,this.featuresMissing=!0,this.fetchStatus===t.FetchStatus.FULL&&(this.fetchStatus=t.FetchStatus.DONE)),u}get cache(){return{availableFields:this._availableFields,features:this._features,numFeatures:this._numFeatures,emptyFeatureRatio:this._emptyFeatureRatio.value,fetchStatus:this.fetchStatus,featuresMissing:this.featuresMissing}}set cache(t){this.requestController=null,this._availableFields=t.availableFields,this._features=t.features,this._featuresLength.value=t.features?.length??0,this._numFeatures=t.numFeatures,this._emptyFeatureRatio.value=t.emptyFeatureRatio,this.fetchStatus=t.fetchStatus,this.featuresMissing=t.featuresMissing,this._estimatedSize=-1,this._estimatedUnusedSizeDirty=!0}}const l=-1,f=-2;var c;function F(t,e,s){if(null==e||null==t||s!==e.length||s>t.length)return!1;for(let i=0;i<s;++i)if(t[i]!==e[i])return!1;return!0}t.FetchStatus=void 0,(c=t.FetchStatus||(t.FetchStatus={}))[c.FETCH_NEEDED=0]="FETCH_NEEDED",c[c.REFETCH_NEEDED=1]="REFETCH_NEEDED",c[c.FETCHING=2]="FETCHING",c[c.REFETCHING=3]="REFETCHING",c[c.DONE=4]="DONE",c[c.FULL=5]="FULL";const _=i.create();t.FeatureTile=n,t.failedFeatureCount=f,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
