/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../core/mathUtils","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../geometry/support/aaBoundingRect","../../../../geometry/support/frustum","../../../../geometry/support/ray","../../../ViewingMode","./FeatureTileDescriptor","./FeatureTileVisibility3D","../../webgl/RenderCamera"],(function(e,t,i,s,r,o,l,a,n,c,d){"use strict";class u{constructor(e){this._camera=new d,this._focusOnMap=[0,0],this._renderCoordsHelper=e.renderCoordsHelper,this._tilingScheme=e.tilingScheme,this._visibility=new c.FeatureTileVisibility3D(e.renderCoordsHelper,e.getIsGroundOpaque)}begin(e,t,i){this._camera.copyFrom(e),this._surfaceElevation=i,this._focusOnMap[0]=t.x,this._focusOnMap[1]=t.y,this._visibility.begin(this._camera)}end(){this._visibility.end()}updateTile(e){const{measures:t}=e;t.visibility=this._visibility.calculate(e),t.distance=r.distance(e.extent,this._focusOnMap),t.visibility!==n.Visibility.INVISIBLE&&this._updateSplitDecisionAndLod(e)}_calculateTileShouldSplitGlobal(e){const t=this._camera,{eye:s}=t,r=i.len(s),o=this._renderCoordsHelper,l=o.referenceEllipsoid.radius;if(r>2*l)return e.measures.effectiveLevelForLod=0,!1;const a=e.lij[0];if(a<=c.globalTileLevelThreshold)return e.measures.effectiveLevelForLod=a,!0;const n=h,{extent:d}=e,{_surfaceElevation:u}=this;i.set(n[0],d[0],d[1],u),i.set(n[1],d[2],d[1],u),i.set(n[2],d[2],d[3],u),i.set(n[3],d[0],d[3],u);const _=i.set(f,.5*(d[0]+d[2]),.5*(d[1]+d[3]),u),S=this._tilingScheme.spatialReference;for(let i=0;i<4;++i)o.toRenderCoords(n[i],S,n[i]);o.toRenderCoords(_,S,_);const y=i.normalize(p,_),g=i.dot(s,y),v=i.scale(m,y,g),T=i.len(s)-l;return i.copy(M.origin,b),i.copy(M.direction,y),this._calculateTileShouldSplitCommon(e,n,_,M,T,v)}_calculateTileShouldSplitLocal(e){const t=h,{extent:s}=e,{_surfaceElevation:r}=this;i.set(t[0],s[0],s[1],r),i.set(t[1],s[2],s[1],r),i.set(t[2],s[2],s[3],r),i.set(t[3],s[0],s[3],r);const o=this._tilingScheme.spatialReference;for(let i=0;i<4;++i)this._renderCoordsHelper.toRenderCoords(t[i],o,t[i]);const l=i.set(f,.5*(t[0][0]+t[2][0]),.5*(t[0][1]+t[2][1]),.25*(t[0][2]+t[1][2]+t[2][2]+t[3][2])),a=i.set(p,l[0],l[1],0),{eye:n,far:c}=this._camera,d=i.set(m,a[0],a[1],n[2]),u=n[2];i.set(M.origin,a[0],a[1],n[2]-2*c),i.copy(M.direction,_);const b=n[2]-2*c;return this._calculateTileShouldSplitCommon(e,t,l,M,u,d,S,b)}_calculateTileShouldSplitCommon(e,r,a,n,c,d,u,h){const f=Math.max(i.dist(r[0],r[2]),i.dist(r[1],r[3]),i.dist(r[0],a)+i.dist(a,r[2])),p=this._camera,{eye:m,near:_,far:S,fovY:b,viewForward:M}=p,v=t.clamp(i.dot(n.direction,M),.1,1),T=i.dot(m,M),R=i.dot(a,M)-T,C=2*Math.tan(.5*b),L=e=>e<=_?1:1/(e*C),x=Math.abs(c)/f,F=L(R),w=e.lij[0],O=i.dist(m,a);let V=0,E=1/0;for(const t of r){const e=i.dist(m,t);E=Math.min(E,e),V=Math.max(V,e)}const{perScreenPixelRatio:G}=p,D=e=>Math.max(0,w-2,w+Math.ceil(Math.log2(.002*e/G))),H=1,A=300*t.clamp(v,.1,1),I=.8,P=.7,j=i.dist(d,m)>P*f,z=R<_,B=e=>H*f/e,Z=D(j?B(O):z?A*f/Math.abs(c):I*F*f),k=Z+(E-_>.33*(S-_)?-1:0);if(e.measures.effectiveLevelForLod=k,w+2<k)return!0;if(w>=k)return!1;const{frustum:q}=p,N=x<y;if(i.dist(d,m)<_)return N;const Q=o.intersectsRay(q,n);if(j){const e=D(B(E)),t=D(B(V));if(Math.abs(e-t)>2||Math.abs(Z-t)>2||Math.abs(Z-e)>2)return!0}else{const e=i.dist(m,a),t=.5*f/Math.SQRT2;if(w<=k+3||e/t>.6)return!0}if(!this.isGlobalMode&&j&&u&&void 0!==h){let e=0;for(let t=0;t<4;++t){const a=u[t],n=h,c=s.create();i.scaleAndAdd(c,r[t],a,n);const d=l.fromValues(c,a);o.intersectsRay(q,d)&&++e}if(e>=3||e>=2&&Q)return!1;if(e<=2&&!Q&&w<Z+1)return!0}const U=o.intersectsPoint(q,a);let Y=0;for(let t=0;t<4;++t){const e=r[t];Y+=o.intersectsPoint(q,e)?1:0}if(U&&Y>=2)return!1;if(!U&&!Q&&Y<=1&&w<k)return N;let J=R;for(let t=0;t<4;++t){const e=r[t],s=i.dot(e,M)-T;J=Math.min(J,s)}if(J<=_)return N;return!(L(J)*f<.3)&&(w<k&&F*f>g&&Y<=2&&!U&&!Q)}_updateSplitDecisionAndLod(e){e.measures.shouldSplit=this.isGlobalMode?this._calculateTileShouldSplitGlobal(e):this._calculateTileShouldSplitLocal(e),e.updateResolution()}get isGlobalMode(){return this._renderCoordsHelper.viewingMode===a.ViewingMode.Global}}const h=[s.create(),s.create(),s.create(),s.create()],f=s.create(),p=s.create(),m=s.create(),_=s.freeze(0,0,1),S=[_,_,_,_],b=s.ZEROS,M=l.fromValues(s.ZEROS,_),y=1,g=.9;e.FeatureTileMeasurements3D=u,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
