/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../chunks/tslib.es6","../../../../core/Accessor","../../../../core/Collection","../../../../core/handleUtils","../../../../core/Logger","../../../../core/maybe","../../../../core/PooledArray","../../../../core/reactiveUtils","../../../../core/uid","../../../../core/accessorSupport/decorators/property","../../../../core/has","../../../../core/RandomLCG","../../../../core/accessorSupport/decorators/subclass","../../../../geometry/support/aaBoundingRect","./FeatureTileDescriptor","./FeatureTileMeasurements3D","../../support/extentUtils","../../../support/Scheduler"],(function(e,t,i,r,s,n,l,o,a,h,c,d,u,p,_,T,y,g,m){"use strict";e.FeatureTileTree3D=class extends i{constructor(e){super(e),this.tiles=new r,this.tileSize=512,this._idToTile=new Map,this._clients=new Set,this._dirty=!1,this._pendingTiles=null,this._newTiles=new o,this.tileBudget=100}initialize(){const e=()=>this._setDirty(),t=()=>this._reset();this.addHandles([a.watch((()=>this.tilingScheme),t,a.syncAndInitial),a.watch((()=>this.tileSize),t,a.syncAndInitial),a.watch((()=>this.cameraOnSurface?.location),e,a.syncAndInitial),a.watch((()=>this.viewState?.contentCamera),e,a.syncAndInitial),a.watch((()=>this.focus?.location),e,a.syncAndInitial),a.watch((()=>this.terrain?.baseOpacity??1),e)]),this._frameWorker=this.scheduler?.registerTask(m.TaskPriority.FEATURE_TILE_TREE,this)}destroy(){this._frameWorker=l.removeMaybe(this._frameWorker)}get tilingScheme(){const e=this.tilingSchemeOwner.tilingScheme;if(!e)return null;return e.clone()}set filterExtent(e){if(null!=e&&!e.spatialReference.equals(this.viewState.spatialReference))return void n.getLogger(this).error("#extent","extent spatial reference needs to be in the same spatial reference as the view");const t=this._get("filterExtent");if(t===e||null!=t&&e&&t.equals(e))return;const i=null!=e?e.clone():null;this._set("filterExtent",i),this._setDirty()}get _filterExtentRect(){if(null==this.filterExtent)return null;const e=_.create();return g.toBoundingRect(this.filterExtent,e,this.tilingScheme.spatialReference),e}get _rootTileIds(){const{tilingScheme:e}=this;return this._filterExtentRect&&e?e.rootTilesInExtent(this._filterExtentRect):[[0,0,0]]}set suspended(e){e!==this._get("suspended")&&(this._set("suspended",e),this._setDirty())}get updating(){return this._dirty||!!this._pendingTiles}addClient(){const e=h.generateUID();return this._clients.add(e),1===this._clients.size&&this._setDirty(),s.makeHandle((()=>this._removeClient(e)))}_removeClient(e){this._clients.delete(e),this._hasClients||this._clear()}get _hasClients(){return this._clients.size>0}_setDirty(){!this._hasClients||this.suspended||this._dirty||(this._frameWorker?(this._dirty=!0,this.notifyChange("updating")):this.runTask(m.noBudget))}_clear(){this.tiles.removeAll(),this._idToTile.clear(),this._reset(),this._dirty=!1,this.notifyChange("updating")}get running(){return this.updating}runTask(e){this._dirty=!1,this._pendingTiles||(this._startUpdate(),null!=this._frameWorker&&(this._frameWorker.priority=m.TaskPriority.FEATURE_TILE_TREE_ACTIVE)),this._subdivideTilesForView(e),this._pendingTiles||null==this._frameWorker||(this._frameWorker.priority=m.TaskPriority.FEATURE_TILE_TREE),this.notifyChange("updating")}_startUpdate(){if(this.suspended)return;if(!this.tilingScheme)return void this._clear();this._tileMeasurements||(this._tileMeasurements=new y.FeatureTileMeasurements3D({renderCoordsHelper:this.renderCoordsHelper,tilingScheme:this.tilingScheme,getIsGroundOpaque:()=>1===(this.terrain?.baseOpacity??1)}));const e=this.viewState.contentCamera;this._tileMeasurements.begin(e,this.focus.location,this.cameraOnSurface.location.z??0),this._pendingTiles=this._getRootTiles()}_reset(){this._newTiles.clear(),this._tileMeasurements=null,this._pendingTiles=null,this._setDirty()}_getRootTiles(){const e=this.tilingScheme;return this._rootTileIds.map((t=>new T.FeatureTileDescriptor(t[0],t[1],t[2],e)))}_subdivideTilesForView(e){if(!this._pendingTiles)return;const{tilingScheme:t}=this;for(;this._pendingTiles.length>0&&!e.done;){const i=this._pendingTiles.shift();if(e.madeProgress(),this._filterExtentRect&&!_.intersects(this._filterExtentRect,i.extent))continue;this._tileMeasurements.updateTile(i);const{measures:r}=i;if(r.visibility===T.Visibility.INVISIBLE)continue;const s=this._newTiles.length+this._pendingTiles.length+1;r.shouldSplit&&s<this.tileBudget?(t.ensureMaxLod(i.lij[0]+1),this._pendingTiles.push(...i.getChildren())):this._newTiles.push(i)}0===this._pendingTiles.length&&(this._updateTiles(this._newTiles.toArray()),this._newTiles.clear(),this._tileMeasurements.end(),this._pendingTiles=null)}_updateTiles(e){for(const r of this.tiles.items)r.used=!1;const t=e.filter((e=>{const t=this._idToTile.get(e.id);return t?(t.copyMeasurementsFrom(e),t.used=!0):this._idToTile.set(e.id,e),!t})),i=this.tiles.items.filter((e=>!e.used&&(this._idToTile.delete(e.id),!0)));this.tiles.removeMany(i),this.tiles.addMany(t),this._sortTiles(),this.tiles.emit("change")}_sortTiles(){this.viewState.fixedContentCamera||this.tiles.sort(((e,t)=>e.measures.distance-t.measures.distance)),this.tiles.forEach(((e,t)=>e.loadPriority=t))}},t.__decorate([c.property({constructOnly:!0})],e.FeatureTileTree3D.prototype,"scheduler",void 0),t.__decorate([c.property({constructOnly:!0})],e.FeatureTileTree3D.prototype,"renderCoordsHelper",void 0),t.__decorate([c.property({constructOnly:!0})],e.FeatureTileTree3D.prototype,"tilingSchemeOwner",void 0),t.__decorate([c.property({constructOnly:!0})],e.FeatureTileTree3D.prototype,"cameraOnSurface",void 0),t.__decorate([c.property({constructOnly:!0})],e.FeatureTileTree3D.prototype,"focus",void 0),t.__decorate([c.property({constructOnly:!0})],e.FeatureTileTree3D.prototype,"viewState",void 0),t.__decorate([c.property({constructOnly:!0})],e.FeatureTileTree3D.prototype,"terrain",void 0),t.__decorate([c.property()],e.FeatureTileTree3D.prototype,"tiles",void 0),t.__decorate([c.property()],e.FeatureTileTree3D.prototype,"tileSize",void 0),t.__decorate([c.property({readOnly:!0})],e.FeatureTileTree3D.prototype,"tilingScheme",null),t.__decorate([c.property()],e.FeatureTileTree3D.prototype,"filterExtent",null),t.__decorate([c.property({readOnly:!0})],e.FeatureTileTree3D.prototype,"_filterExtentRect",null),t.__decorate([c.property({readOnly:!0})],e.FeatureTileTree3D.prototype,"_rootTileIds",null),t.__decorate([c.property({value:!1})],e.FeatureTileTree3D.prototype,"suspended",null),t.__decorate([c.property({readOnly:!0})],e.FeatureTileTree3D.prototype,"updating",null),e.FeatureTileTree3D=t.__decorate([p.subclass("esri.views.3d.layers.support.FeatureTileTree3D")],e.FeatureTileTree3D),Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
