/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../chunks/tslib.es6","../../../../core/Accessor","../../../../core/Logger","../../../../core/maybe","../../../../core/promiseUtils","../../../../core/reactiveUtils","../../../../core/accessorSupport/decorators/property","../../../../core/has","../../../../core/RandomLCG","../../../../core/accessorSupport/decorators/subclass","../../../../core/support/UpdatingHandles","../../../../layers/support/FeatureFilter","../../../../layers/support/floorFilterUtils","../graphics/QueryEngine","../../../support/Scheduler"],(function(e,t,i,r,s,o,l,a,n,u,c,p,_,d,h,y){"use strict";e.FeatureVisibilityFilter=class extends i{constructor(e){super(e),this._frameTask=null,this._queryEngine=null,this._updateRequested=!0,this._updatingHandles=new p.UpdatingHandles,this._abortController=new AbortController}initialize(){const e=y.TaskPriority.FILTER_VISIBILITY,{layer:t,view:i}=this._configuration,{featureStore:r}=this.context,s=this._configuration.hasZ??!1,o=this._configuration.hasM??!1;this._queryEngine=new h.QueryEngine({context:{spatialReference:i.spatialReference,layer:t,scheduler:i.resourceController.scheduler,featureStore:r,hasM:o,hasZ:s},priority:e}),this._frameTask=i.resourceController.scheduler.registerTask(e),this._updatingHandles.add((()=>[this._compositedFeatureFilter,this._sceneFilter]),(()=>this._updateRequested=!0),l.initial),this._updatingHandles.addWhen((()=>!this._frameTask.updating&&this._updateRequested),(()=>{this._frameTask.schedule((()=>this._updateVisibility()),this._abortController.signal),this._updateRequested=!1}),l.initial)}destroy(){this._abortController.abort(),this._updatingHandles.destroy(),this.clear(),this._frameTask=s.removeMaybe(this._frameTask),this._queryEngine=s.destroyMaybe(this._queryEngine),this._set("context",null)}get updating(){return this._updateRequested||this._updatingHandles.updating||this._frameTask.updating}get defaultVisibility(){return null==this._compositedFeatureFilter&&null==this._sceneFilter}get _featureFilter(){return"filter"in this._configuration?this._configuration.filter:null}get _sceneFilter(){return"layerFilter"in this._configuration?this._configuration.layerFilter:null}get _floorFilter(){return d.getFloorFilterClause(this._configuration)}get _timeExtent(){return"timeExtent"in this._configuration?this._configuration.timeExtent:null}get _compositedFeatureFilter(){const{_featureFilter:e,_timeExtent:t,_floorFilter:i}=this;if(null==t&&null==i)return e;const r=e?.clone()??new _;if(null!=t&&(r.timeExtent=r.timeExtent?.intersection(t)??t),null!=i){const e=null==r.where||""===r.where;r.where=e?i:`(${r.where}) AND (${i})`}return r}get _configuration(){return this.context.configuration}reapply(){this._updateRequested=!0}clear(){this._queryEngine.clear(),this.context.clearFeaturesVisibility()}async _updateVisibility(){const e=this._compositedFeatureFilter,t=this._sceneFilter,{signal:i}=this._abortController,s=this._frameTask,{context:l}=this;if(o.throwIfAborted(i),null==e&&null==t||0===l.getFeatureCount())return await s.schedule((()=>this.clear()),i);try{const r=await this._queryEngine.executeQueryForIdSet(e,t,i);return o.throwIfAborted(i),await s.schedule((()=>{l.updateFeatureVisibilities((e=>r.has(e)))}),i)}catch(a){return o.throwIfAbortError(a),r.getLogger(this).warn(`FeatureFilter query failed: ${a}`,{error:a}),await s.schedule((()=>{l.setAllFeaturesVisibility(!0)}),i)}}},t.__decorate([a.property({constructOnly:!0})],e.FeatureVisibilityFilter.prototype,"context",void 0),t.__decorate([a.property()],e.FeatureVisibilityFilter.prototype,"updating",null),t.__decorate([a.property()],e.FeatureVisibilityFilter.prototype,"defaultVisibility",null),t.__decorate([a.property()],e.FeatureVisibilityFilter.prototype,"_featureFilter",null),t.__decorate([a.property()],e.FeatureVisibilityFilter.prototype,"_sceneFilter",null),t.__decorate([a.property()],e.FeatureVisibilityFilter.prototype,"_floorFilter",null),t.__decorate([a.property()],e.FeatureVisibilityFilter.prototype,"_timeExtent",null),t.__decorate([a.property()],e.FeatureVisibilityFilter.prototype,"_compositedFeatureFilter",null),t.__decorate([a.property()],e.FeatureVisibilityFilter.prototype,"_configuration",null),t.__decorate([a.property()],e.FeatureVisibilityFilter.prototype,"_updateRequested",void 0),e.FeatureVisibilityFilter=t.__decorate([c.subclass("esri.views.3d.layers.support.FeatureVisibilityFilter")],e.FeatureVisibilityFilter),Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
