/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../core/Accessor","../../../core/Evented","../../../core/reactiveUtils","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/Logger","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../../core/accessorSupport/watch","../../../core/libs/gl-matrix-2/factories/vec3f64","../../../geometry/ellipsoidUtils","../../ViewAnimation","../../ViewingMode","./Constraints","./controllers/AnimationController","./controllers/CameraController","../webgl/RenderCamera","../webgl-engine/lib/rendererUtils","../../support/PropertiesPool","../../support/RenderState"],(function(e,t,r,o,a,i,n,s,l,p,c,d,h,u,m,_,g,y,C,w,v){"use strict";let f=class extends t{constructor(e){super(e),this._propertiesPool=new w.PropertiesPool({camera:y},this),this._lastSeenCameraProjectionValues=new y,this.mode=v.RenderState.ANIMATING,this._cssCamera=new y,this._camera=new y,this.rasterPixelRatio=1,this.contentPixelRatio=1,this.constraints=new m.Constraints({state:this}),this.events=new r,this._cameraChanged=!1,this._updateQueue=new Array,this._processingUpdates=!1}reset(){this.cameraController=null,this._propertiesPool.destroy(),this._propertiesPool=new w.PropertiesPool({camera:y},this)}destroy(){this.cameraController=null,this._propertiesPool?.destroy(),this._propertiesPool=null}createInitialCamera(){if(this.viewingMode===u.ViewingMode.Global){const e=d.getReferenceEllipsoid(this.spatialReference).radius;this.camera=new y({eye:c.fromValues(4*e,0,0),center:c.fromValues(e,0,0),up:c.fromValues(0,0,1)})}else this.camera=new y({eye:c.fromValues(0,0,100),center:c.fromValues(0,0,0),up:c.fromValues(0,1,0)})}get animation(){return this.cameraController instanceof _.AnimationController&&null!=this.cameraController.viewAnimation?this.cameraController.viewAnimation:null}get cssCamera(){const e=this._cssCamera.copyFrom(this.camera),{height:t,width:r,pixelRatio:o}=this.camera;return e.pixelRatio=1,e.height=Math.round(t/o),e.width=Math.round(r/o),e}get camera(){return this._camera}set camera(e){e!==V&&V.copyFrom(e),V.computeUp(this.viewingMode),this.events.emit("before-camera-change",V);const t=this._camera;if(S(this._lastSeenCameraProjectionValues,V)&&(this._lastSeenCameraProjectionValues.copyFrom(V),this.events.emit("camera-projection-changed",this._lastSeenCameraProjectionValues)),!t.equals(V)&&(this._camera=this._propertiesPool.get("camera").copyFrom(V),this._cameraChanged=!t.almostEquals(V),this._cameraChanged)){const e=p.afterDispatch((()=>{this._cameraChanged=!1,e.remove()}))}}get pixelRatio(){return this.camera.pixelRatio}get alignPixelEnabled(){return this.pixelRatio===this.rasterPixelRatio&&this.mode===v.RenderState.IDLE}get updating(){return this.mode!==v.RenderState.IDLE}get contentCamera(){return this._contentCamera??this.camera}set contentCamera(e){this._contentCamera=null!=e?e.clone():null}get fixedContentCamera(){return null!=this._contentCamera}get isGlobal(){return this.viewingMode===u.ViewingMode.Global}get isLocal(){return this.viewingMode===u.ViewingMode.Local}get viewingMode(){return u.viewingModeFromString(this.view.viewingMode)}get spatialReference(){return this.view.spatialReference}get navigating(){return!!this.cameraController?.isInteractive}get stationary(){return!this._cameraChanged&&!this.navigating}get cameraController(){return this._get("cameraController")}set cameraController(e){this.stopActiveCameraController()?(this.cameraController?.destroy(),e&&(this.removeHandles(R),this.addHandles(o.when((()=>e.state===g.State.Finished||e.state===g.State.Stopped),(()=>{this._set("cameraController",null),this.updateCamera((t=>e.onControllerEnd(t)))}),{sync:!0,once:!0}),R),e.onControllerStart(this.camera)),this._set("cameraController",e)):e&&(e.state=g.State.Rejected)}switchCameraController(e){this.cameraController=e}stopActiveCameraController(){return!this.cameraController||this.cameraController.stopController()}updateCamera(e){this._updateQueue.push(e),this._processUpdateQueue()}_processUpdateQueue(){if(0===this._updateQueue.length||this._processingUpdates)return;this._processingUpdates=!0;const e=this._updateQueue.shift();V.copyFrom(this._get("camera")),e(V),this.camera=V,this._processingUpdates=!1,this._processUpdateQueue()}};e.__decorate([a.property({constructOnly:!0})],f.prototype,"view",void 0),e.__decorate([a.property()],f.prototype,"mode",void 0),e.__decorate([a.property({readOnly:!0,type:h})],f.prototype,"animation",null),e.__decorate([a.property({type:y})],f.prototype,"cssCamera",null),e.__decorate([a.property()],f.prototype,"_cssCamera",void 0),e.__decorate([a.property({type:y})],f.prototype,"camera",null),e.__decorate([a.property()],f.prototype,"_camera",void 0),e.__decorate([a.property({readOnly:!0})],f.prototype,"pixelRatio",null),e.__decorate([a.property()],f.prototype,"rasterPixelRatio",void 0),e.__decorate([a.property()],f.prototype,"contentPixelRatio",void 0),e.__decorate([a.property({readOnly:!0})],f.prototype,"alignPixelEnabled",null),e.__decorate([a.property({readOnly:!0})],f.prototype,"updating",null),e.__decorate([a.property({})],f.prototype,"_contentCamera",void 0),e.__decorate([a.property({type:y})],f.prototype,"contentCamera",null),e.__decorate([a.property({readOnly:!0})],f.prototype,"fixedContentCamera",null),e.__decorate([a.property({readOnly:!0})],f.prototype,"events",void 0),e.__decorate([a.property({readOnly:!0})],f.prototype,"isGlobal",null),e.__decorate([a.property({readOnly:!0})],f.prototype,"isLocal",null),e.__decorate([a.property({readOnly:!0})],f.prototype,"viewingMode",null),e.__decorate([a.property()],f.prototype,"navigating",null),e.__decorate([a.property()],f.prototype,"stationary",null),e.__decorate([a.property()],f.prototype,"_cameraChanged",void 0),e.__decorate([a.property()],f.prototype,"cameraController",null),f=e.__decorate([l.subclass("esri.views.3d.state.ViewState")],f);const P=f;function S(e,t){return e.fov!==t.fov||(e.fullViewport[0]!==t.fullViewport[0]||e.fullViewport[1]!==t.fullViewport[1]||e.fullViewport[2]!==t.fullViewport[2]||e.fullViewport[3]!==t.fullViewport[3]||(e.padding[C.PaddingSide.TOP]!==t.padding[C.PaddingSide.TOP]||e.padding[C.PaddingSide.RIGHT]!==t.padding[C.PaddingSide.RIGHT]||e.padding[C.PaddingSide.BOTTOM]!==t.padding[C.PaddingSide.BOTTOM]||e.padding[C.PaddingSide.LEFT]!==t.padding[C.PaddingSide.LEFT]))}const V=new y,R="ViewStateHandles";return P}));
