/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../chunks/tslib.es6","../../../Camera","../../../geometry","../../../Viewpoint","../../../core/Accessor","../../../core/Logger","../../../core/maybe","../../../core/reactiveUtils","../../../core/scheduling","../../../core/screenUtils","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../../chunks/vec32","../../../core/libs/gl-matrix-2/factories/vec3f64","../../../chunks/vec42","../../../core/libs/gl-matrix-2/factories/vec4f64","../../../geometry/Extent","../../../geometry/Point","../../../geometry/projection","../../ViewingMode","../camera/constraintUtils","../camera/intersectionUtils","./ConstraintsManager","./Frustum","./GoToOperation","./controllers/SurfaceCollisionCorrectionController","../support/cameraUtils","../support/viewpointUtils","../webgl/RenderCamera","../webgl-engine/lib/rendererUtils","../webgl-engine/lib/RenderFeature","../../support/PropertiesPool","../../support/RenderState","../../webgl/FramebufferObject","../../../geometry/Polygon"],(function(e,t,i,a,r,n,s,o,l,h,c,d,p,m,v,w,g,u,_,y,C,f,S,x,R,P,T,O,M,b,V,I,L,z,E,A,F,H){"use strict";e.ViewStateManager=class extends n{constructor(e){super(e),this.ready=!1,this._windowDevicePixelRatio=1,this._devicePixelRatioOverride=null,this._idleTimeout=J,this.test={viewStateManager:this,contentCameraResetState:new Map,setDevicePixelRatio:e=>this._devicePixelRatioOverride=e,renderState:null,get maximumPixelRatio(){return this.viewStateManager.view.qualitySettings.maximumPixelRatio},get updatingIgnoreRenderState(){return null!=this.renderState},get idleTimeoutEnabled(){return this.viewStateManager._idleTimeout>0},set idleTimeoutEnabled(e){this.viewStateManager._idleTimeout=e?J:0}},this._propertiesPool=new E.PropertiesPool({frustum:T.Frustum},this),this._cameraSetByUser=!1,this._gotoOperation=null,this._cameraChangeTime=0,this._tmpCanvasSize=new N}initialize(){this._cameraChangeTime=performance.now(),this.addHandles([l.on((()=>this.view.state.events),"before-camera-change",(e=>e&&this._updateElevation(e))),l.watch((()=>this.view.state?.camera),((e,t)=>this._cameraChangedHandler(e,t)),l.sync)]),l.when((()=>this.view.state?.camera),(e=>this._updateElevation(e)),{once:!0,sync:!0}),this.addHandles([h.addFrameTask({prepare:()=>this._prepareFrame()}),l.watch((()=>this.view.state.cameraController),(()=>{this._cameraSetByUser=!0,this.removeHandles(j)})),l.on((()=>this.view.state.events),"camera-projection-changed",(()=>this.notifyChange("scale")))])}destroy(){this.exit(),this._propertiesPool=o.destroyMaybe(this._propertiesPool)}get camera(){const e=this._get("camera");if(!this.ready)return e;const t=b.internalToExternal(this.view,this.view.state.camera,U);return t&&e&&t.equals(e)?e:t.clone()}set camera(e){this._updatePropertyBeforeReady("camera",e)||(this.view.elevationProvider?.enableCache(!0),this.setStateCamera(b.externalToInternal(this.view,e),{applyConstraints:!1})||s.getLogger(this).error("#camera=","Invalid camera",e),this.view.elevationProvider?.enableCache(!1))}get contentCamera(){const e=this._get("contentCamera");if(!this.ready)return e;const t=b.internalToExternal(this.view,this.view.state.contentCamera,U);return t&&e&&t.equals(e)?e:t.clone()}set contentCamera(e){if(this._updatePropertyBeforeReady("contentCamera",e))return;const t=b.externalToInternal(this.view,e);null!=t?(this._updateElevation(t),this.view.state.contentCamera=t):this.view.state.contentCamera=null}installContentCameraReset(e){if(this.removeHandles(W),this.test.contentCameraResetState.clear(),!this.view.state.fixedContentCamera)return!1;const t=this.zoom,i=this.view.state.camera.distance**2,a=g.fromArray(this.view.state.camera.center),r=e.sticky?this.contentCamera.clone():null;return this.addHandles([l.watch((()=>this.contentCamera),(()=>{e.sticky||(this.removeHandles(W),this.test.contentCameraResetState.clear())})),l.watch((()=>this.zoom),(e=>{void 0!==e&&void 0!==t&&(this.test.contentCameraResetState.set("view.zoom",Math.abs(e-t)/2),Math.abs(e-t)>2?this.contentCamera=null:this.view.state.fixedContentCamera||(this.contentCamera=r))})),l.watch((()=>this.view.state.camera),(e=>{const t=w.squaredDistance(a,e.center);this.test.contentCameraResetState.set("camera.center",t/i),t>i?this.contentCamera=null:this.view.state.fixedContentCamera||(this.contentCamera=r)}))],W),!0}get center(){return this.ready?this.view.pointsOfInterest.centerOnContent.location:this._get("center")}set center(e){this._updatePropertyBeforeReady("center",e)||(e?this.isCompatible(e)?this.setStateCamera(this._centerToCamera(e),{applyConstraints:!0})?this.view.pointsOfInterest.centerOnContent.runTask():s.getLogger(this).error("#center=","Invalid center",e):s.getLogger(this).error("#center=","Center has an incompatible spatial reference (center: "+(e.spatialReference?e.spatialReference.wkid:"none")+", view: "+this.view.spatialReference?.wkid+")",e):s.getLogger(this).error("#center=","Center may not be null or undefined"))}get visibleArea(){if(!this.ready){const e=this._get("extent");return e?H.fromExtent(e):null}return b.toArea(this.view,this.view.pointsOfInterest.focus.renderLocation)}get extent(){if(!this.ready)return this._get("extent");const e=this.view,t=b.toExtent(e,e.state.camera,e.pointsOfInterest.centerOnContent.renderLocation);return null!=t?t:this._get("extent")}set extent(e){this._updatePropertyBeforeReady("extent",e)||(e?this.isCompatible(e)?this.setStateCamera(this._extentToCamera(e),{applyConstraints:!0})||s.getLogger(this).error("#extent=","Invalid extent",e):s.getLogger(this).error("#extent=","Extent has an incompatible spatial reference (extent: "+(e.spatialReference?e.spatialReference.wkid:"none")+", view: "+this.view.spatialReference?.wkid+")",e):s.getLogger(this).error("#extent=","Extent may not be null or undefined"))}get frustum(){const e=this._propertiesPool.get("frustum");return e.renderCoordsHelper=this.view.renderCoordsHelper,e.update(this.view.state.camera),e}get constraintsManager(){return this._constraintsManager}get _initialViewpoint(){const e=this.view.map;return e&&"initialViewProperties"in e?e.initialViewProperties?.viewpoint:void 0}get hasInitialView(){return!!this._initialViewpoint}get scale(){if(!this.ready)return this._get("scale");const e=this.view.basemapTerrain.tilingScheme,t=this.view.pointsOfInterest.cameraOnSurface.scale;return e&&t?b.applyTiltAdjustToScale(this.view,t,this.view.state.contentCamera,e):this._get("scale")}set scale(e){this._updatePropertyBeforeReady("scale",e)||this.setStateCamera(this._scaleToCamera(e),{applyConstraints:!0})||s.getLogger(this).error("#scale=","Invalid scale",e)}get padding(){if(!this.ready)return this._get("padding");const e=this.view.state.camera,t=e.padding,i=e.pixelRatio,a=this._get("padding"),r=Math.round(t[L.PaddingSide.TOP]/i),n=Math.round(t[L.PaddingSide.RIGHT]/i),s=Math.round(t[L.PaddingSide.BOTTOM]/i),o=Math.round(t[L.PaddingSide.LEFT]/i);return null!=a&&a.top===r&&a.right===n&&a.bottom===s&&a.left===o?a:{top:r,right:n,bottom:s,left:o}}set padding(e){this._updatePropertyBeforeReady("padding",e)||(this._paddingToArray(e,this.view.state.camera.pixelRatio,q),this.view.state.updateCamera((e=>e.padding=q)))}_paddingToArray(e,t,i){e?u.set(i,e.top||0,e.right||0,e.bottom||0,e.left||0):u.set(i,0,0,0,0);for(let a=0;a<4;a++)i[a]=Math.round(i[a]*t)}get screenCenter(){const e=this.padding;return c.createScreenPoint((this.view.width-(e.left+e.right))/2+e.left,(this.view.height-(e.top+e.bottom))/2+e.top)}get viewpoint(){return this.ready?V.fromCamera(this.view,this.camera):this._get("viewpoint")}set viewpoint(e){if(!this._updatePropertyBeforeReady("viewpoint",e))if(e)if(this.isCompatible(e))this.setStateCamera(this._viewpointToCamera(e),{applyConstraints:!e.camera})||s.getLogger(this).error("#viewpoint=","Invalid viewpoint",e);else{const t=null!=e.camera?e.camera.position:e.targetGeometry,i=null!=t&&t.spatialReference;s.getLogger(this).error("#viewpoint=","Viewpoint has an incompatible spatial reference (viewpoint: "+(i?i.wkid:"none")+", view: "+this.view.spatialReference?.wkid+")",e)}else s.getLogger(this).error("#viewpoint=","Viewpoint may not be null or undefined")}get zoom(){return this.ready?b.scaleToZoom(this.view,this.scale):this._get("zoom")}set zoom(e){this._updatePropertyBeforeReady("zoom",e)||void 0===e||this.setStateCamera(this._zoomToCamera(e),{applyConstraints:!0})||s.getLogger(this).error("#zoom=","Invalid zoom",e)}_computeCanvasSize(){if(this._devicePixelRatioOverride)return this.view.state.contentPixelRatio=this._devicePixelRatioOverride,this._tmpCanvasSize.width=Math.round(this.view.surface.clientWidth*this._devicePixelRatioOverride),this._tmpCanvasSize.height=Math.round(this.view.surface.clientHeight*this._devicePixelRatioOverride),this._tmpCanvasSize.pixelRatio=this._devicePixelRatioOverride,this._tmpCanvasSize;const e=Math.min(this._windowDevicePixelRatio,this.view.qualitySettings.maximumPixelRatio),t=(this._usePhysicalPixelRendering?this._windowDevicePixelRatio:e)*this.view.resolutionScale;this._tmpCanvasSize.width=Math.round(this.view.surface.clientWidth*t),this._tmpCanvasSize.height=Math.round(this.view.surface.clientHeight*t);const i=this.view._stage.renderView.renderingContext?.parameters.maxTextureSize;return i&&F.ensureAttachmentMaxSize(this._tmpCanvasSize,i),this._tmpCanvasSize.pixelRatio=this._tmpCanvasSize.width>0?this._tmpCanvasSize.width/this.view.surface.clientWidth*.5+this._tmpCanvasSize.height/this.view.surface.clientHeight*.5:t,this.view.state&&(this.view.state.contentPixelRatio=Math.min(this._windowDevicePixelRatio,this.view.qualitySettings.maximumPixelRatio)),this._tmpCanvasSize}get _rasterPixelRatio(){return null!=this._devicePixelRatioOverride?this._devicePixelRatioOverride:this._usePhysicalPixelRenderingAny?this._windowDevicePixelRatio:Math.min(this._windowDevicePixelRatio,this.view.qualitySettings.maximumPixelRatio)}get _usePhysicalPixelRendering(){return this.view?._stage?.renderer.isFeatureEnabled(z.RenderFeature.PhysicalPixelRendering)??!1}get _usePhysicalPixelRenderingAny(){const e=this.view?._stage?.renderer;return e&&(e.isFeatureEnabled(z.RenderFeature.PhysicalPixelRendering,A.RenderState.IDLE)||e.isFeatureEnabled(z.RenderFeature.PhysicalPixelRendering,A.RenderState.INTERACTING)||e.isFeatureEnabled(z.RenderFeature.PhysicalPixelRendering,A.RenderState.ANIMATING))}preinit(e){return!(this._isOverridden("center")&&!f.isLoadedOrLoadFor(this.center.spatialReference,e))&&(!(this._isOverridden("camera")&&!f.isLoadedOrLoadFor(this.camera.position.spatialReference,e))&&(!(this._isOverridden("extent")&&!f.isLoadedOrLoadFor(this.extent.spatialReference,e))&&!!(!this._isOverridden("viewpoint")||f.isLoadedOrLoadFor(this.viewpoint.targetGeometry?.spatialReference,e)&&f.isLoadedOrLoadFor(this.viewpoint.camera?.position?.spatialReference,e))))}init(){this._constraintsManager=new P.ConstraintsManager({view:this.view}),this._prepareFrame();const e=this._getInitialProperties();this._cameraSetByUser=!1,this._set("ready",!0);for(const t of e)this.set(t.name,t.value);if(!this._cameraSetByUser){const e=this._initialViewpoint||this.view.initialExtent;e&&this.isCompatible(e)?this._setInitialView(e):this.view.state.viewingMode===S.ViewingMode.Local&&this.addHandles(l.when((()=>this.view.basemapTerrain.ready),(()=>{this.removeHandles(j),this._setInitialView(this.view.dataExtent)}),{once:!0,initial:!0}),j)}}exit(){this._cancelGoToOperation(),this.ready&&(this._override("padding",this.padding),this._set("ready",!1),this._clearOverride("hasInitialView"),this._cameraSetByUser=!1,this.removeHandles(j),this._constraintsManager=o.destroyMaybe(this._constraintsManager))}async goTo(e,t){return t={animate:!0,...t},null!=this._gotoOperation&&this._gotoOperation.abort(t.animate),this._gotoOperation=new O.GoToOperation(e,t,this.view),this.view.resourceController.scheduler.stopFrame(),this._gotoOperation.promise}debugSetCameraOnContent(){this.setStateCamera(R.cameraOnContentAlongViewDirection(this.view),{applyConstraints:!1})}step(e){const t=this.view.state,i=t?.cameraController;i&&(t.updateCamera((t=>i.stepController(e,t))),i.steppingFinished&&i.finishController())}_cancelGoToOperation(){null!=this._gotoOperation&&(this._gotoOperation.abort(),this._gotoOperation=null)}_getInitialProperties(){const e=new Set,t=[];for(const{propertyName:i,overrides:a}of B){const r=e.has(i),n=this._isOverridden(i);!r&&n&&t.push({name:i,value:this._get(i)}),this._clearOverride(i),(r||n)&&a.forEach((t=>e.add(t)))}return t}_setInitialView(e){if(null==e||this._cameraSetByUser)return;if(e instanceof i)return void this.setStateCamera(b.externalToInternal(this.view,e),{applyConstraints:!1});if(e instanceof r){if(e.targetGeometry instanceof y){const t=b.fromExtentSync(this.view,e.targetGeometry,0,.5,b.OrientationMode.LOCKED);return void(null!=t&&this.setStateCamera(b.externalToInternal(this.view,t),{applyConstraints:!0}))}const t={applyConstraints:!e.camera},i=this._viewpointToCamera(e);return void this.setStateCamera(i,t)}const t=b.fromExtentSync(this.view,e,0,.5,b.OrientationMode.LOCKED);null!=t&&this.setStateCamera(b.externalToInternal(this.view,t),{applyConstraints:!0})}_updatePropertyBeforeReady(e,t){return!this.ready&&(this._override(e,t),t&&D.has(e)&&this._override("hasInitialView",!0),!0)}isCompatible(e){return null!=e&&(e instanceof r?e.camera?this.isCompatible(e.camera):this.isCompatible(e.targetGeometry):e instanceof i?this.isCompatible(e.position):e.spatialReference&&!f.requiresLoad(e.spatialReference,this.view.spatialReference))}_getPreservingHeadingTilt(e=G){return this._cameraSetByUser?(e.heading=this.camera.heading,e.tilt=this.camera.tilt):(e.heading=0,e.tilt=.5),e}_centerPointAtDistanceToCamera(e,t,i=k){const{heading:a,tilt:r}=this._getPreservingHeadingTilt(),n=b.getObserverForPointAtDistanceSync(this.view,a,r,e,t,b.OrientationMode.ADJUST);return null==n?null:(i.copyFrom(this.view.state.camera),i.eye=n.eye,i.center=n.center,i.up=n.up,i)}_centerToCamera(e){let t;if(e.hasZ)t=this.view.state.camera.distance;else{const{centerOnContent:e}=this.view.pointsOfInterest;e.runTask(),t=e.distance}return this._centerPointAtDistanceToCamera(e,t)}_extentToCamera(e){const{heading:t,tilt:i}=this._getPreservingHeadingTilt(),a=b.fromExtentSync(this.view,e,t,i,b.OrientationMode.ADJUST,U);return a?b.externalToInternal(this.view,a):null}_scaleToCamera(e){if(null==e)return null;const t=this.view,i=t.pointsOfInterest.centerOnContent;i.runTask();const a=i.renderLocation,r=t.pointsOfInterest.cameraOnSurface.renderLocation,n=b.scaleToTargetDistance(t,e,t.state.contentCamera,a,r);return this._centerPointAtDistanceToCamera(a,n)}_zoomToCamera(e){return this._scaleToCamera(b.zoomToScale(this.view,e))}_viewpointToCamera(e){return b.externalToInternal(this.view,V.toCameraSync(this.view,e))}setStateCamera(e,t){return!(null==e||!this.view.state.stopActiveCameraController())&&(this._cameraSetByUser=!0,t.doNotCancelGoToOperation||this._cancelGoToOperation(),this.view.state.updateCamera((i=>{t.positionAndOrientationOnly?(i.eye=e.eye,i.center=e.center,i.up=e.up,i.fov=e.fov):i.copyFrom(e),t.applyConstraints&&x.applyAll(this.view,i)})),t.applyConstraints||(this.view.state.cameraController=new M.SurfaceCollisionCorrectionController({view:this.view,desiredCamera:e})),!0)}_prepareFrame(){const{surface:e,canvas:t}=this.view;if(!e||!t)return;this._windowDevicePixelRatio=window.devicePixelRatio;const i=this._computeCanvasSize();if(0!==i.width&&0!==i.height&&(t.width===i.width&&t.height===i.height||(t.width=i.width,t.height=i.height),this.view.state)){const e=this.view.state.camera;e.fullWidth===i.width&&e.fullHeight===i.height&&e.pixelRatio===i.pixelRatio||(k.copyFrom(e),k.pixelRatio!==i.pixelRatio&&(this._paddingToArray(this.padding,i.pixelRatio,q),k.padding=q),k.fullWidth=i.width,k.fullHeight=i.height,k.pixelRatio=i.pixelRatio,this.view.state.camera=k),this._updateViewState()}}_updateElevation(e){const t=this.view.basemapTerrain?.spatialReference,i=this.view.renderCoordsHelper?.getAltitude(e.eye)??0,a=t?R.surfaceElevationBelowRenderLocation(this.view,e.eye):0;e.relativeElevation=i-a}_updateViewState(){null!=this.test.renderState?this.view.state.mode=this.test.renderState:this.view.animation?this.view.state.mode=A.RenderState.ANIMATING:this.view.interacting?this.view.state.mode=A.RenderState.INTERACTING:(this.view.state.mode===A.RenderState.ANIMATING&&(this._cameraChangeTime=0),performance.now()-this._cameraChangeTime<this._idleTimeout?this.view.state.mode=A.RenderState.INTERACTING:this.view.state.mode=A.RenderState.IDLE),this.view.state.rasterPixelRatio=this._rasterPixelRatio}_cameraChangedHandler(e,t){e&&t&&e.almostEquals(t)||(this._cameraChangeTime=performance.now(),this._updateViewState())}},t.__decorate([d.property({type:i,dependsOn:["view.state.camera","ready"]})],e.ViewStateManager.prototype,"camera",null),t.__decorate([d.property({type:i,dependsOn:["view.state.contentCamera","ready"]})],e.ViewStateManager.prototype,"contentCamera",null),t.__decorate([d.property({type:C})],e.ViewStateManager.prototype,"center",null),t.__decorate([d.property()],e.ViewStateManager.prototype,"visibleArea",null),t.__decorate([d.property({type:y})],e.ViewStateManager.prototype,"extent",null),t.__decorate([d.property({readOnly:!0})],e.ViewStateManager.prototype,"frustum",null),t.__decorate([d.property()],e.ViewStateManager.prototype,"_constraintsManager",void 0),t.__decorate([d.property({readOnly:!0})],e.ViewStateManager.prototype,"constraintsManager",null),t.__decorate([d.property()],e.ViewStateManager.prototype,"_initialViewpoint",null),t.__decorate([d.property({readOnly:!0})],e.ViewStateManager.prototype,"hasInitialView",null),t.__decorate([d.property({readOnly:!0,type:Boolean})],e.ViewStateManager.prototype,"ready",void 0),t.__decorate([d.property({type:Number})],e.ViewStateManager.prototype,"scale",null),t.__decorate([d.property()],e.ViewStateManager.prototype,"padding",null),t.__decorate([d.property({readOnly:!0})],e.ViewStateManager.prototype,"screenCenter",null),t.__decorate([d.property({constructOnly:!0})],e.ViewStateManager.prototype,"view",void 0),t.__decorate([d.property({type:r})],e.ViewStateManager.prototype,"viewpoint",null),t.__decorate([d.property({type:Number})],e.ViewStateManager.prototype,"zoom",null),t.__decorate([d.property({readOnly:!0})],e.ViewStateManager.prototype,"_rasterPixelRatio",null),t.__decorate([d.property({readOnly:!0})],e.ViewStateManager.prototype,"_usePhysicalPixelRendering",null),t.__decorate([d.property({readOnly:!0})],e.ViewStateManager.prototype,"_usePhysicalPixelRenderingAny",null),t.__decorate([d.property()],e.ViewStateManager.prototype,"_windowDevicePixelRatio",void 0),t.__decorate([d.property()],e.ViewStateManager.prototype,"_devicePixelRatioOverride",void 0),e.ViewStateManager=t.__decorate([v.subclass("esri.views.3d.state.ViewStateManager")],e.ViewStateManager);class N{constructor(){this.width=0,this.height=0,this.pixelRatio=1}}const D=new Set(["camera","viewpoint","extent","scale","center","zoom"]),B=[{propertyName:"camera",overrides:["viewpoint"]},{propertyName:"viewpoint",overrides:["extent"]},{propertyName:"extent",overrides:["center","scale"]},{propertyName:"center",overrides:[]},{propertyName:"scale",overrides:["zoom"]},{propertyName:"zoom",overrides:[]},{propertyName:"padding",overrides:[]}],G={heading:0,tilt:0},U=new i,k=new I,q=_.create(),j="pending-initial-view",W="content-camera-reset",J=300,K=100;e.interactingTimeout=K,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
