/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../core/compilerUtils","../../../core/mathUtils","../../../core/libs/gl-matrix-2/math/mat4","../../../core/libs/gl-matrix-2/factories/mat4f64","../../../chunks/vec32","../../../core/libs/gl-matrix-2/factories/vec3f64","../../../geometry/ellipsoidUtils","../../../geometry/projection/computeTranslationToOriginAndRotation","../../../geometry/projection/projectBoundingRect","../../../geometry/projection/projectVectorToVector","../../../geometry/support/aaBoundingBox","../../../geometry/support/aaBoundingRect","../../../geometry/support/frustum","../../../geometry/support/lineSegment","../../../geometry/support/plane","../../../geometry/support/ray","../../ViewingMode","./intersectionUtils"],(function(e,t,i,n,r,o,s,a,c,l,d,p,h,g,_,x,u,m,f){"use strict";const R=.5*Math.PI,y=R/Math.PI*180;class A{constructor(e){this._renderCoordsHelper=e.renderCoordsHelper,this._extent=new Array(4),this._planes=new Array(6),this._maxSpan=0,this._center={origin:s.create(),direction:s.create()};for(let t=0;t<4;t++)this._extent[t]={origin:s.create(),direction:s.create(),cap:{next:null,direction:s.create()}},this._planes[t]=x.create();this._planes[g.PlaneIndex.NEAR]=x.create(),this._planes[g.PlaneIndex.FAR]=x.create(),this._planesWithoutFar=this._planes.slice(0,5)}update(e,t,i,n=!0){const r=this._extent;this._toRenderBoundingExtent(e,t,i),o.add(this._center.origin,r[0].origin,r[2].origin),o.scale(this._center.origin,this._center.origin,.5),this._renderCoordsHelper.worldUpAtPosition(this._center.origin,this._center.direction),n||o.scale(this._center.direction,this._center.direction,-1);for(let s=0;s<4;s++){const e=r[s];this._renderCoordsHelper.worldUpAtPosition(e.origin,e.direction);const t=r[3===s?0:s+1];e.cap.next=t.origin,o.direction(e.cap.direction,e.origin,t.origin),x.fromVectorsAndPoint(e.direction,e.cap.direction,e.origin,this._planes[s]),n||o.scale(e.direction,e.direction,-1)}x.fromVectorsAndPoint(r[0].cap.direction,r[1].cap.direction,r[0].origin,this._planes[g.PlaneIndex.NEAR]),n?x.negate(this._planes[g.PlaneIndex.NEAR],this._planes[g.PlaneIndex.FAR]):(x.copy(this._planes[g.PlaneIndex.FAR],this._planes[g.PlaneIndex.NEAR]),x.negate(this._planes[g.PlaneIndex.NEAR],this._planes[g.PlaneIndex.NEAR])),this._maxSpan=Math.max(Math.abs(e[0]-e[2]),Math.abs(e[1]-e[3])),this._maxSpanSpatialReference=t,this._minGlobalAltitude=.9*a.getReferenceEllipsoid(this._maxSpanSpatialReference).radius}isVisibleInFrustum(e,t,i=!1){if(null==e)return!1;if(this._renderCoordsHelper.viewingMode===m.ViewingMode.Global){const i=this._maxSpanSpatialReference.isGeographic?y:R*t;if(this._maxSpan>i)return!0;if(null!=e.altitude&&e.altitude>=this._minGlobalAltitude)return this._isVisibleInFrustumGlobal(e)}if(0===this._maxSpan){const t=this._extent[0];return!(i||!e.intersectsRay(u.wrap(t.origin,t.direction)))}for(let r=0;r<this._extent.length;r++){const t=this._extent[r];if(!i&&e.intersectsRay(u.wrap(t.origin,t.direction)))return!0;if(e.intersectsLineSegment(_.fromPoints(t.origin,t.cap.next,w),t.cap.direction))return!0}const n=i?this._planes:this._planesWithoutFar;for(let r=0;r<e.lines.length;r++){const t=e.lines[r];if(f.frustumLineSegment(n,t.origin,t.endpoint,t.direction))return!0}return!1}_toRenderBoundingExtentGlobal(e,t,r){const s=5;h.center(e,P),P[2]=r,c.computeTranslationToOriginAndRotation(t,P,I,this._renderCoordsHelper.spatialReference),n.invert(E,I),p.empty(M);for(const{x0:n,x1:a,y0:c,y1:l}of b)for(let h=0;h<s;h++){const g=h/(s-1);P[0]=i.lerp(e[n],e[a],g),P[1]=i.lerp(e[c],e[l],g),P[2]=r,d.projectVectorToVector(P,t,P,this._renderCoordsHelper.spatialReference),o.transformMat4(P,P,E),p.expandWithVec3(M,P)}o.set(this._extent[0].origin,M[0],M[1],M[2]),o.set(this._extent[1].origin,M[3],M[1],M[2]),o.set(this._extent[2].origin,M[3],M[4],M[2]),o.set(this._extent[3].origin,M[0],M[4],M[2]);for(let i=0;i<4;++i)o.transformMat4(this._extent[i].origin,this._extent[i].origin,I)}_toRenderBoundingExtentLocal(e,t,i){l.projectBoundingRect(e,t,S,this._renderCoordsHelper.spatialReference),o.set(this._extent[0].origin,S[0],S[1],i),o.set(this._extent[1].origin,S[2],S[1],i),o.set(this._extent[2].origin,S[2],S[3],i),o.set(this._extent[3].origin,S[0],S[3],i)}_toRenderBoundingExtent(e,i,n){switch(this._renderCoordsHelper.viewingMode){case m.ViewingMode.Global:this._toRenderBoundingExtentGlobal(e,i,n);break;case m.ViewingMode.Local:this._toRenderBoundingExtentLocal(e,i,n);break;default:t.neverReached(this._renderCoordsHelper.viewingMode)}}_isVisibleInFrustumGlobal(e){if(x.signedDistance(e.planes[g.PlaneIndex.NEAR],this._center.origin)<0&&o.dot(this._center.direction,e.direction)<0)return!0;for(let t=0;t<4;t++){const i=this._extent[t];if(x.signedDistance(e.planes[g.PlaneIndex.NEAR],i.origin)<0&&o.dot(i.direction,e.direction)<0)return!0}return!1}}const b=[{x0:0,y0:1,x1:2,y1:1},{x0:0,y0:3,x1:2,y1:3},{x0:0,y0:1,x1:0,y1:3},{x0:2,y0:1,x1:2,y1:3}],P=s.create(),I=r.create(),E=r.create(),M=p.create(),S=h.create(),w=_.create();e.FrustumExtentIntersection=A,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
