/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../chunks/tslib.es6","../../../request","../../../core/Accessor","../../../core/arrayUtils","../../../core/Error","../../../core/has","../../../core/lang","../../../core/maybe","../../../core/promiseUtils","../../../core/accessorSupport/decorators/property","../../../core/Logger","../../../core/accessorSupport/decorators/subclass","./AsyncWorkerQueue","./ImageWithType","../terrain/TerrainData","../webgl-engine/lib/Util","../../support/Scheduler"],(function(e,t,s,r,a,o,n,u,i,l,h,d,c,_,k,p,g,L){"use strict";e.StreamDataLoader=class extends r{constructor(){super(...arguments),this._tasks=new Map,this._onLoadQueue=new Array,this._doneQueue=new Array,this.updating=!1}setup(e,t,s){this._loadQueue=new _.AsyncWorkerQueue(((e,t)=>this._startLoading(e,t)),((e,t)=>this._doneLoadingCB(e,t)),e,t),s&&(this._frameTask=s.registerTask(L.TaskPriority.STREAM_DATA_LOADER,this))}destroy(){this._frameTask=i.removeMaybe(this._frameTask),this._tasks.forEach((e=>i.abortMaybe(e.abortController))),this._loadQueue=i.destroyMaybe(this._loadQueue),this._onLoadQueue=null,this._doneQueue=null,this._tasks=null}hasDownloadSlots(e){return this._loadQueue.hasQuota(e)}request(e,t,s,r={}){const a=l.createResolver();a.__signal=null!=r?r.signal:null;const o=this._createOrUpdateTask(e,t,s,r,a);return l.onAbort(r,(()=>this._cancelRequest(o,a))),a.promise}_createTask(e,t,s,r,a,o){const n=new b(e,t,s,r,a);return this._updateTask(n,o),this._tasks.set(a,n),1===this._tasks.size&&this._set("updating",!0),this._loadQueue.push(n),n}_cancelRequest(t,s){a.removeUnordered(t.resolvers,s),s.reject(l.createAbortError()),0===t.resolvers.length&&(t.status===e.TaskStatus.DOWNLOADING&&(t.status=e.TaskStatus.CANCELLED,this._loadQueue.cancel(t),t.abortController?.abort(),t.request=null,t.abortController=null),t.status=e.TaskStatus.CANCELLED,this._tasks.delete(t.key),0===this._tasks.size&&this._set("updating",!1))}_updateTask(e,t){e.resolvers.push(t)}_createOrUpdateTask(e,t,s,r,a){const o=y(r?.uid||e,t,s),n=this._tasks.get(o);return n?(this._updateTask(n,a),n):this._createTask(e,r,t,s,o,a)}_doneLoadingCB(t,s){this._loadQueue&&(g.assert(t.status===e.TaskStatus.DOWNLOADING),t.status=e.TaskStatus.DOWNLOADED,this._frameTask?this._doneQueue.push({task:t,err:s}):this._doneLoading(t,s))}get running(){return this._doneQueue.length>0||this._onLoadQueue.length>0}runTask(t){for(;!t.done&&this._onLoadQueue.length>0;){const e=this._onLoadQueue.shift();l.throwIfAborted(e.task.abortController),e.task.abortController=null,e.callback(e.task),t.madeProgress()}for(;!t.done&&this._doneQueue.length>0;){const s=this._doneQueue.shift();s.task.status!==e.TaskStatus.DOWNLOADED&&(s.err=s.err||l.createAbortError()),this._doneLoading(s.task,s.err),t.madeProgress()}}_doneLoading(e,t){if(t&&!l.isAbortError(t)&&e.numRetries>0)return--e.numRetries,void this._loadQueue.push(e);let s=p.isImageWithType(e.result)||e.result instanceof HTMLImageElement?0:e.resolvers.length;for(const r of e.resolvers)if(t)l.isAbortError(t)?r.reject(t):r.reject(new o("stream-data-loader:request-error",`Failed to request resource at '${e.url}'. ${t}`,{url:e.url,error:t}));else{--s;const t=s>0?u.clone(e.result):e.result;r.resolve(t)}this._tasks.delete(e.key),0===this._tasks.size&&this._set("updating",!1)}_startLoading(t,r){if(t.status===e.TaskStatus.CANCELLED)return!1;let a,o;switch(t.startTime=performance.now(),t.status=e.TaskStatus.DOWNLOADING,t.docType){case"binary":o="array-buffer",a=0;break;case"image":o="image";break;case"image+type":o="array-buffer";break;default:o="json"}t.abortController=new AbortController;const n=t.abortController.signal;t.request=s(t.url,{...t.options,responseType:o,timeout:a,signal:n});const u=e=>{t.duration=performance.now()-t.startTime,t.size=e instanceof ArrayBuffer?e.byteLength:t.size||0,t.result=e,this._frameTask?this._onLoadQueue.push({callback:r,task:t}):(t.abortController=null,r(t))},i=s=>{t.status===e.TaskStatus.DOWNLOADING&&r(t,s)};return"image+type"!==t.docType?(t.request.then((e=>u(e.data)),i),!0):(t.request.then((e=>{const r=e.data,l=T(r);if(o="image",t.size=r.byteLength,"unknown"===l)return t.request=s(t.url,{responseType:o,timeout:a,signal:n}),void t.request.then((e=>u(e.data)),i);const h=new Blob([r],{type:l}),d=window.URL.createObjectURL(h);t.request=s(d,{responseType:o,timeout:a,signal:n}),t.request.then((e=>u(new k.ImageWithType(e.data,l))),i).finally((()=>window.URL.revokeObjectURL(d)))}),i),!0)}get test(){}},t.__decorate([h.property({readOnly:!0})],e.StreamDataLoader.prototype,"updating",void 0),e.StreamDataLoader=t.__decorate([c.subclass("esri.views.3d.support.StreamDataLoader")],e.StreamDataLoader);const m={numRetries:0};function T(e){if(e.byteLength<2)return"unknown";const t=new Uint8Array(e,0,e.byteLength);return 137===t[0]&&80===t[1]?"image/png":71===t[0]&&73===t[1]?"image/gif":66===t[0]&&77===t[1]?"image/bmp":255===t[0]&&216===t[1]?"image/jpeg":"unknown"}class b extends _.BaseTask{constructor(t,s,r,a,o){super(a),this.url=t,this.options=s,this.docType=r,this.key=o,this.result=null,this.status=e.TaskStatus.QUEUED,this.request=null,this.abortController=null,this.resolvers=new Array,this.startTime=0,this.numRetries=m.numRetries}}function y(e,t,s){return`${e}:${t}:${s}`}var D;e.TaskStatus=void 0,(D=e.TaskStatus||(e.TaskStatus={}))[D.QUEUED=1]="QUEUED",D[D.DOWNLOADING=2]="DOWNLOADING",D[D.DOWNLOADED=3]="DOWNLOADED",D[D.CANCELLED=4]="CANCELLED",e.test=m,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
