/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../Camera","../../../core/Cyclical","../../../core/Logger","../../../core/mathUtils","../../../core/promiseUtils","../../../chunks/vec32","../../../core/libs/gl-matrix-2/factories/vec3f64","../../../geometry/ellipsoidUtils","../../../geometry/Point","../../../geometry/projection","../../../geometry/SpatialReference","../../../geometry/projection/projectPointToVector","../../../geometry/projection/projectVectorToPoint","../../../geometry/projection/projectVectorToVector","../../ViewingMode","../camera/intersectionUtils","../../../chunks/cameraUtilsPlanar","../../../chunks/cameraUtilsSpherical","./earthUtils","./ElevationProvider","../../support/spatialReferenceSupport"],(function(e,t,n,r,o,i,a,c,l,s,u,f,d,p,m,h,g,y,T,w,v,S){"use strict";const R=()=>r.getLogger("esri.views.3d.support.cameraUtils"),M=39.37,A=96,x=A*M,C=1,b=8,P=5,j=1,z={heading:0,tilt:0},D=c.create(),O=new n.Cyclical(-20037508.342788905,20037508.342788905),V=new n.Cyclical(-180,180);var U;function E(e){return e.spatialReference??f.WGS84}function I({state:e}){return e.isGlobal?T.cameraUtilsSpherical:y.cameraUtilsPlanar}function L(e,t,n,r,o){return I(e).headingTiltToDirectionUp(t,n,r,o)}function H(e,t){if(null==t)return null;const n=e.renderSpatialReference,r=I(e).headingTiltToDirectionUp,i=c.create();if(!d.projectPointToVector(t.position,i,n))return null;const l=r(i,t.heading,t.tilt);a.scale(l.direction,l.direction,e.state.camera.distance),a.add(l.direction,l.direction,i);const s=g.cameraOnContentAlongViewDirection(e,i,l.direction,l.up);return s.fov=o.deg2rad(t.fov),s.row=t.layout.row,s.rows=t.layout.rows,s.column=t.layout.column,s.columns=t.layout.columns,s}e.OrientationMode=void 0,(U=e.OrientationMode||(e.OrientationMode={}))[U.LOCKED=0]="LOCKED",U[U.ADJUST=1]="ADJUST";const F=c.create();function G(e,n,r){const i=e.renderSpatialReference,a=ee(e,n.eye,n.viewForward,n.up,z);let c=E(e);return m.projectVectorToVector(n.eye,i,F,c)||(c=f.WGS84,m.projectVectorToVector(n.eye,i,F,c)),null==r?r=new t(new s(F,c),a.heading,a.tilt,o.rad2deg(n.fov)):(r.position.x=F[0],r.position.y=F[1],r.position.z=F[2],r.position.spatialReference=c,r.heading=a.heading,r.tilt=a.tilt,r.fov=o.rad2deg(n.fov)),r.layout.row=n.row,r.layout.rows=n.rows,r.layout.column=n.column,r.layout.columns=n.columns,r}function J(e,t){const{camera:n}=e.state,{unitInMeters:r}=e.renderCoordsHelper;return n.width/2/n.pixelRatio/(A*M/(t/=r))/Math.tan(n.fovX/2)}function q(e,t){const{camera:n}=e.state,{unitInMeters:r}=e.renderCoordsHelper,o=t*Math.tan(n.fovX/2),i=n.width/2/n.pixelRatio;return x/(i/o)*r}function k(e,t,n,r){const o=r.levelAtScale(t),i=X(ee(e,n.eye,n.viewForward,n.up).tilt),a=Math.max(o-i,0);return r.scaleAtLevel(a)}function W(e,t,n){const r=n.levelAtScale(e),o=X(t);return n.scaleAtLevel(r+o)}function X(e){return 2*((e>90?180-e:e)/90)**2}function K(e,t,n){const r=e.basemapTerrain?.tilingScheme;if(!r)return 0;if(null==n){const t=e.pointsOfInterest?.cameraOnSurface?.renderLocation;n=(t&&e.renderCoordsHelper?.getAltitude(t))??0}const o=l.getReferenceEllipsoid(e.spatialReference).radius,i=e.state.viewingMode===h.ViewingMode.Local?t.eye[2]:a.length(t.eye)-o;return k(e,q(e,Math.abs(i-n)),t,r)}function Z(e,t,n){const r=H(e,t);return r?K(e,r,n):0}const Y=1,N=100;function B(t,n,r,i,c){if(0===n)return 0;const s=a.distance(r.eye,i),u=t.basemapTerrain?.tilingScheme;if(!u)return R().error("#scaleToTargetDistance()","Cannot compute distance from scale without a tiling scheme"),s;let f=s;const d=ee(t,r.eye,r.viewForward,r.up),p=d.tilt>90;if(t.state.viewingMode===h.ViewingMode.Local){const e=(J(t,W(n,d.tilt,u))-Math.abs(r.eye[2]-c[2]))/Math.cos(o.deg2rad(d.tilt));f=p?f-e:f+e}else{let m=1/0,h=0,g=ie(t,d.heading,d.tilt,i,s,e.OrientationMode.ADJUST);if(!g)return f;const y=a.length(c);for(;m>Y&&h<N;){const c=a.length(g.eye),s=p?180-g.tilt:g.tilt,T=o.deg2rad(s),w=Math.sin(T)*c,v=Math.cos(T)*c,S=J(t,W(n,g.tilt,u)),R=p?y-S:y+S,M=o.asinClamped(w/R),A=Math.cos(M)*R-v,x=a.distance(g.eye,i);f=p?x-A:x+A,g=ie(t,d.heading,d.tilt,i,f,e.OrientationMode.ADJUST);const C=Ce(t,g,o.rad2deg(r.fov));if(!g||!C)return f;const b=Z(t,C,y-l.getReferenceEllipsoid(t.spatialReference).radius);m=Math.abs(n-b),++h}}return f}async function Q(e,t,n,r,o,i){return _(e,t,J(e,n),r,o,i)}function $(e,t,n,r,o,i){return Ce(e,ie(e,r.heading,r.tilt,t,n,o),r.fov,i)}async function _(e,t,n,r,o,a){const c=await ae(e,r.heading,r.tilt,t,n,o,a);return i.throwIfAborted(a),be(e,c,r.fov,a)}function ee(e,t,n,r,o){return I(e).directionToHeadingTilt(t,n,r,o)}function te(e,t){return!!(e.basemapTerrain&&e.renderCoordsHelper.fromRenderCoords(t,D,e.spatialReference)&&e.elevationProvider&&(v.getElevationAtPoint(e.elevationProvider,D)??0)>D[2]-j)}async function ne(e,t,n){if(te(e,t))return!0;const{elevationProvider:r,spatialReference:o,renderCoordsHelper:a}=e;if(null==r||!a.fromRenderCoords(t,D,o))return!1;const[c,l,s]=D,u=await r.queryElevation(c,l,s,o,"ground",n)??0;return i.throwIfAborted(n),u>s-j}async function re(e,t,n){const r=c.create();if(null==t)return a.copy(r,e.state.camera.center);if(t instanceof s){const{renderSpatialReference:o,basemapTerrain:a,elevationProvider:c}=e,l=t.spatialReference;if(await d.projectPointToVectorAsync(t,r,o,0,{signal:n}),i.throwIfAborted(n),null==t.z&&null!=a&&null!=c){const o=await c.queryElevation(t.x,t.y,t.z??0,l,"ground",n);i.throwIfAborted(n),null!=o&&e.renderCoordsHelper.setAltitude(r,o)}return r}return a.copy(r,t)}function oe(e,t){const n=c.create();if(null==t)return a.copy(n,e.state.camera.center);if(t instanceof s){if(!d.projectPointToVector(t,n,e.renderSpatialReference))return null;const{basemapTerrain:r,elevationProvider:o}=e;if(null==t.z&&null!=r&&null!=o){const r=v.getElevationAtPoint(o,t);null!=r&&e.renderCoordsHelper.setAltitude(n,r)}return n}return a.copy(n,t)}function ie(e,t,n,r,o,i){return ce(e,t,n,r instanceof s?r:null,oe(e,r),o,i)}async function ae(e,t,n,r,o,a,c){const l=r instanceof s?r:null,u=await re(e,r,c);return i.throwIfAborted(c),le(e,t,n,l,u,o,a,c)}function ce(e,t,n,r,o,i,a){if(null==o)return null;if(!r&&(r=new s({spatialReference:E(e)}),!p.projectVectorToPoint(o,e.renderSpatialReference,r)))return null;const c=se(e,t,n,o,i,a);if(ue(e,n,a)&&te(e,c.eye)){const{tilt:a,mode:c}=fe(e,n,o,i);return ce(e,t,a,r,o,i,c)}return de(c,o)}async function le(e,t,n,r,o,a,c,l){r||(r=new s({spatialReference:E(e)}),await p.projectVectorToPointAsync(o,e.renderSpatialReference,r,{signal:l})||(r=null)),i.throwIfAborted(l);const u=se(e,t,n,o,a,c);if(ue(e,n,c)&&await ne(e,u.eye,l)){i.throwIfAborted(l);const{tilt:c,mode:s}=fe(e,n,o,a);return le(e,t,c,r,o,a,s,l)}return de(u,o)}function se(e,t,n,r,o,i){const a=ve(e,t,n,r,o=Math.max(o,e.state.constraints.minimumPoiDistance),i);return(0,I(e).eyeForCenterWithHeadingTilt)(r,o,a.heading,a.tilt)}function ue(t,n,r){const o=t.map.ground.navigationConstraint;return r===e.OrientationMode.ADJUST&&t.state.isGlobal&&n>0&&(null==o||"stay-above"===o.type)}function fe(t,n,r,o){const i=Ae(t,r,o,Me(t,o,n,r));return{tilt:i,mode:n-i<1?e.OrientationMode.LOCKED:e.OrientationMode.ADJUST}}function de(e,t){return{...e,center:c.clone(t)}}function pe(e,t){const{state:n,spatialReference:r}=e,o=t.spatialReference;return n.isGlobal&&S.isSpatialReferenceSupported(o,h.ViewingMode.Global)||n.isLocal&&r.equals(o)}function me(e,t){let n,r,o;if(e.state.isGlobal){const e=new s(t.xmin,t.ymin,t.spatialReference),i=new s(t.xmax,t.ymax,t.spatialReference),a=t.spatialReference.isGeographic?V:O;n=new s({x:a.center(e.x,i.x),y:(i.y+e.y)/2,z:null!=t.zmax&&null!=t.zmin?(t.zmax+t.zmin)/2:void 0,spatialReference:t.spatialReference});const c=l.getReferenceEllipsoid(t.spatialReference),u=w.getGreatCircleSpanAt(n,e,i);r=u.lon,o=u.lat,a.diff(e.x,i.x)>a.range/2&&(r+=c.halfCircumference),r=Math.min(r,c.halfCircumference),o=Math.min(o,c.halfCircumference)}else{const i=e.renderSpatialReference??t.spatialReference;i.equals(t.spatialReference)||(t=u.project(t,i)),r=t.xmax-t.xmin,o=t.ymax-t.ymin;const a=null!=t.zmax&&null!=t.zmin?(t.zmax+t.zmin)/2:void 0;n=new s({x:t.xmin+.5*r,y:t.ymin+.5*o,z:a,spatialReference:i})}const i=null!=t.zmax&&null!=t.zmin?t.zmax-t.zmin:0,a=e.state.camera,c=1/Math.tan(a.fovX/2),f=1/Math.tan(a.fovY/2),d=1/Math.tan(a.fov/2);return{center:n,distance:Math.max(.5*r*c,.5*o*f,.5*i*d)/C}}async function he(e,t,n,r,o,a){const c=pe(e,t)?t:await u.projectWithZConversion(t,e.spatialReference,{signal:a});i.throwIfAborted(a);const{center:l,distance:s}=me(e,c),f=await ae(e,n,r,l,s,o,a);return i.throwIfAborted(a),be(e,f,e.camera.fov,a)}function ge(e,t,n,r,o,i){let a;try{a=pe(e,t)?t:u.project(t,e.spatialReference)}catch(f){return null}const{center:c,distance:l}=me(e,a),s=ie(e,n,r,c,l,o);return null==s?null:Ce(e,s,e.camera.fov,i)}function ye(e,t,n){const r=e.renderSpatialReference,o=new s({spatialReference:E(e)});if(!p.projectVectorToPoint(n,r,o))return null;const i=Math.tan(t.fovX/2),c=Math.tan(t.fovY/2),l=a.dist(t.eye,n),u=2*l*i*C,f=2*l*c*C;return I(e).toExtent(e,o,u,f)}function Te(e,t){return I(e).toArea(e,t)}function we(e,t,n){const r=e.pointsOfInterest.centerOnSurfaceFrequent.distance;if(Math.log(n/r)/Math.LN2>b)return!0;const o=t,i=e.pointsOfInterest.centerOnSurfaceFrequent.renderLocation;return a.distance(o,i)/(Math.tan(.5*e.state.camera.fov)*r)>P}function ve(t,n,r,o,i,a){let c=0;return a===e.OrientationMode.ADJUST&&we(t,o,i)?(n=0,c=Re(t,i,r,o)):c=xe(t,o,i,r),c=t.state.constraints.clampTilt(i,c),{heading:n,tilt:r=Ae(t,o,i,c)}}const Se=.7;function Re(e,t,n,r){const o=xe(e,r,t,n);if(!e.state.constraints.tilt)return o;const i=e.state.constraints.tilt(t);i.max=Math.min(i.max,.5*Math.PI);const a=i.min*(1-Se)+i.max*Se;return Math.min(o,a)}function Me(e,t,n,r){let o=xe(e,r,t,n);if(!e.state.constraints.tilt)return o;const i=e.state.constraints.tilt(t);return o=Math.min(o,.5*Math.PI),i.min*(1-Se)+o*Se}function Ae(e,t,n,r){return I(e).lookAtTiltToEyeTilt(r,t,n)}function xe(e,t,n,r){return I(e).eyeTiltToLookAtTilt(r,t,n)}function Ce(e,n,r,o){if(null==n)return null;const i=e.renderSpatialReference,a=new s({spatialReference:E(e)});return p.projectVectorToPoint(n.eye,i,a)?(o??=new t,o.position=a,o.heading=n.heading,o.tilt=n.tilt,o.fov=r,o):null}async function be(e,n,r,o){const a=e.renderSpatialReference,c=new s({spatialReference:E(e)});return await p.projectVectorToPointAsync(n.eye,a,c,{signal:o}),i.throwIfAborted(o),new t(c,n.heading,n.tilt,r)}function Pe(e,t){const n=e.basemapTerrain?.tilingScheme;if(n)return n.levelAtScale(t);R().error("#scaleToZoom()","Cannot compute zoom from scale without a tiling scheme")}function je(e,t){const n=e.basemapTerrain?.tilingScheme;if(n)return n.scaleAtLevel(t);R().error("#zoomToScale()","Cannot compute scale from zoom without a tiling scheme")}e.applyTiltAdjustToScale=k,e.directionToHeadingTilt=ee,e.distanceToScale=q,e.externalCameraToScale=Z,e.externalToInternal=H,e.fromCenterDistanceAsync=_,e.fromCenterDistanceSync=$,e.fromCenterScale=Q,e.fromExtentAsync=he,e.fromExtentSync=ge,e.getObserverForPointAtDistanceAsync=ae,e.getObserverForPointAtDistanceSync=ie,e.getViewSR=E,e.headingTiltToDirectionUp=L,e.internalCameraToScale=K,e.internalToExternal=G,e.removeTiltAdjustFromScale=W,e.scaleErrorThreshold=Y,e.scaleToDistance=J,e.scaleToTargetDistance=B,e.scaleToZoom=Pe,e.toArea=Te,e.toExtent=ye,e.zoomToScale=je,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
