/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../geometry","../../../Graphic","../../../core/iteratorUtils","../../../core/screenUtils","../../../core/libs/gl-matrix-2/factories/vec3f64","../../../geometry/projection/projectVectorToVector","../../../layers/LayerConstants","../../../layers/support/layerUtils","./debugFlags","./ElevationProvider","../webgl-engine/lib/Intersector","../webgl-engine/lib/IntersectorInterfaces","../webgl-engine/lib/intersectorUtils","../webgl-engine/lib/intersectorUtilsConversions","../webgl-engine/lib/verticalOffsetUtils","../../../geometry/SpatialReference","../../../geometry/Point"],(function(e,t,n,r,i,s,c,o,l,a,u,d,p,g,f,y,m,I){"use strict";async function h(e,t,n,r){const s=n?T(e,n):r,c=i.createScreenPointArray(t.x,t.y);s.requiresGroundFeedback=!0,s.enableDraped=!0;const o=d.newIntersector(e.state.viewingMode);o.options.selectionMode=!0,o.options.store=p.StoreResults.ALL,e.sceneIntersectionHelper.intersectIntersectorScreen(c,o,s);const u=E(e,o.results.all,s.graphics),y=o.results.ground,m=f.toOwner(y,e),I=null!=m&&"type"in m&&l.isIntegratedMeshLayer(m.type)?m:null,h={screenPoint:t,results:u,ground:{mapPoint:U(e,y),distance:g.isValidIntersectorResult(y)?y.distanceInRenderSpace:0,layer:I}};return a.debugFlags.SCENEVIEW_HITTEST_RETURN_INTERSECTOR&&(h.intersector=o),h}function b(e,t,n,r){const s=n?T(e,n):r,c=!(!s.graphics?.include&&!s.graphics?.exclude),o=!(!s.mediaElements?.include&&!s.mediaElements?.exclude),l=i.screenPointObjectToArray(t);s.enableDraped=s.include&&!s.include.has(y.terrainId)||s.exclude?.has(y.terrainId);const a=e.sceneIntersectionHelper,u=d.newIntersector(e.state.viewingMode);if(u.options.selectionMode=!0,u.options.store=c||o?p.StoreResults.ALL:p.StoreResults.MIN,u.options.excludeLabels=n?.excludeLabels??!1,a.intersectIntersectorScreen(l,u,s),c||o){for(const t of u.results.all){const n=f.toHit(t,e);if(null==n)return U(e,t);if(c&&("graphic"!==n.type||w(s.graphics,n.graphic)))return U(e,t);if(o&&("media"!==n.type||L(s.mediaElements,n.element)))return U(e,t)}return null}return U(e,u.results.min)}function E(e,t,n){const r=new Array;let i=null;for(let s=0;s<t.length;s++){const c=t[s],o=f.toOwner(c,e);if(null!=o&&(o===e.map.ground||"type"in o&&l.isIntegratedMeshLayer(o.type)))break;const a=f.toHit(c,e);if(null==a)continue;if("graphic"===a.type){if(null==i&&s!==t.length-1&&(i=new Set),null!=i){const e=S(a.graphic);if(i.has(e))continue;i.add(e)}if(!w(n,a.graphic))continue}const u=U(e,c),d=c.distanceInRenderSpace;if("media"===a.type){const e=a.element.toSource(u);r.push({...a,mapPoint:u,distance:d,sourcePoint:e})}else r.push({...a,mapPoint:u,distance:d})}return r}function U(e,t,n){return t.getIntersectionPoint(C)?(n=R(e,C,n),t.intersector===p.IntersectorType.TERRAIN&&e.basemapTerrain&&(n.z=u.getElevationAtPoint(e.basemapTerrain,n)??0),n):null}function S(e){const t=e.sourceLayer,n=e.layer,r=t&&"objectIdField"in t?t:n&&"objectIdField"in n?n:t;if(r){const t=r.objectIdField??o.fallbackObjectIDAttribute,n=e.attributes?.[t];if(n)return`o-${r.id}-${n}`}return`u-${e.uid}`}function w(e,t){return L(e,S(t))}function L(e,t){return null==e||(null==e.include||e.include.has(t))&&(null==e.exclude||!e.exclude.has(t))}function R(e,t,n){let r=e.spatialReference||m.WGS84;return c.projectVectorToVector(t,e.renderSpatialReference,C,r)?t=C:(r=m.WGS84,c.projectVectorToVector(t,e.renderSpatialReference,C,r)&&(t=C)),n?(n.x=t[0],n.y=t[1],n.z=t[2],n.spatialReference=r):n=new I(t,r),n}function T(e,t){const n=x(e,t.include,D.INCLUDE),r=x(e,t.exclude,D.EXCLUDE);return{include:n.layerUids,exclude:r.layerUids,graphics:{include:n.graphicUids,exclude:r.graphicUids},mediaElements:{include:n.mediaElements,exclude:r.mediaElements}}}function x(e,t,i,s={layerUids:void 0,graphicUids:void 0,mediaElements:void 0}){if(!t)return s;if(t instanceof n)v(s,S(t)),i===D.INCLUDE&&(null!=e.graphicsView&&t.layer===e?P(s,e.graphicsView.processor.layer.id):t.layer&&P(s,t.layer.uid));else if("layer"in t&&"element"in t)V(s,t.element),i===D.INCLUDE&&P(s,t.layer.uid);else if(r.isIterable(t))for(const n of t)n===e.graphics&&null!=e.graphicsView?P(s,e.graphicsView.processor.layer.id):n===e.map.ground?P(s,y.terrainId):x(e,n,i,s);else"uid"in t&&P(s,t.uid);return s}function P(e,t){e.layerUids||(e.layerUids=new Set),e.layerUids.add(t)}function v(e,t){e.graphicUids||(e.graphicUids=new Set),e.graphicUids.add(t)}function V(e,t){e.mediaElements||(e.mediaElements=new Set),e.mediaElements.add(t)}const C=s.create();var D;!function(e){e[e.INCLUDE=0]="INCLUDE",e[e.EXCLUDE=1]="EXCLUDE"}(D||(D={})),e.computeMapPointFromVec3d=R,e.externalToInternalIntersectOptions=T,e.getGraphicFilterUid=S,e.hitTest=h,e.intersectResultToMapPoint=U,e.toMap=b,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
