/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../chunks/tslib.es6","../../../../core/Accessor","../../../../core/has","../../../../core/reactiveUtils","../../../../core/accessorSupport/decorators/property","../../../../core/Logger","../../../../core/RandomLCG","../../../../core/accessorSupport/decorators/subclass","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../geometry/support/ray","../debugFlags","../debugUtils","../geometryUtils/ray","./CameraOnSurface","./CenterOnSurface","./ContentGeometryUpdates","./Focus","./StableSurfaceCenter","./SurfaceGeometryUpdates","../../webgl-engine/lib/Intersector","../../webgl-engine/lib/IntersectorInterfaces","../../webgl-engine/lib/verticalOffsetUtils","../../../support/PropertiesPool","../../../support/Scheduler"],(function(e,t,r,n,s,i,o,a,c,u,d,h,p,f,_,l,C,y,O,g,A,I,w,m,S,P){"use strict";e.PointsOfInterest=class extends r{constructor(e){super(e),this.renderPointOfView=d.create(),this._pois=new Array,this._debugCenters=null,this._tmpRay=h.create(),this._centerRayDirty=!0,this._surfaceAltitudeAtCenter=0,this._surfaceAltitudeAtCenterDirty=!0,this._contentAltitudeAtCenter=0,this._contentAltitudeAtCenterDirty=!0,this._propertiesPool=new S.PropertiesPool({renderPointOfView:v},this)}initialize(){const{state:e,basemapTerrain:t,renderCoordsHelper:r,map:n}=this.view;this._surfaceIntersector=I.newIntersector(e.viewingMode),this._surfaceIntersector.options.invisibleTerrain=!1,this._surfaceIntersector.options.store=w.StoreResults.MIN,this._contentIntersector=I.newIntersector(e.viewingMode);const i=()=>this._estimateSurfaceAltitudeAtCenter(),o=this.view.resourceController.scheduler,a=this.view.basemapTerrain?.elevationQueryCache,c={state:e,scheduler:o,surface:t,renderCoordsHelper:r};this._set("centerOnSurfaceInfrequent",new C.CenterOnSurface({...c,task:P.TaskPriority.POINT_OF_INTEREST_INFREQUENT,estimateSurfaceAltitudeAtCenter:i})),this._set("centerOnSurfaceFrequent",new C.CenterOnSurface({...c,task:P.TaskPriority.POINT_OF_INTEREST_FREQUENT,estimateSurfaceAltitudeAtCenter:i})),this._set("centerOnContent",new C.CenterOnSurface({...c,task:P.TaskPriority.POINT_OF_INTEREST_FREQUENT,estimateSurfaceAltitudeAtCenter:()=>this._estimateContentAltitudeAtCenter()})),this._set("cameraOnSurface",new l.CameraOnSurface({...c,cache:a,task:P.TaskPriority.POINT_OF_INTEREST_INFREQUENT,map:n})),this._set("surfaceGeometryUpdates",new A.SurfaceGeometryUpdates({...c,centerOnSurfaces:[this.centerOnSurfaceFrequent,this.centerOnContent,this.centerOnSurfaceInfrequent]})),this._set("contentGeometryUpdates",new y.ContentGeometryUpdates({contentLayerViews:this.view.allLayerViews,renderCoordsHelper:r})),this._set("surfaceOrigin",new g.StableSurfaceCenter({cache:a,view:this.view})),this._set("focus",new O.Focus({state:e,scheduler:o,surface:t,renderCoordsHelper:r,centerOnSurface:this.centerOnSurfaceFrequent,estimateSurfaceIntersectionAtRenderPoint:(e,t)=>this._estimateSurfaceIntersectionAtRenderPoint(e,this.view.state.contentCamera,t)})),this._pois.push(this.centerOnContent,this.centerOnSurfaceFrequent,this.centerOnSurfaceInfrequent,this.cameraOnSurface,this.focus),this.addHandles([s.watch((()=>e.contentCamera),(e=>this._cameraChanged(e)),s.sync),s.watch((()=>t.extent),(()=>this._updateCenterPointsOfInterest())),s.watch((()=>this.view.map?.ground?.navigationConstraint?.type),(e=>{this._surfaceIntersector.options.backfacesTerrain="none"===e}),s.initial),s.when((()=>!t.updating),(()=>this._updateCenterPointsOfInterest()),s.sync),s.on((()=>this.surfaceGeometryUpdates.events),"request-update",(()=>this._updateCenterPointsOfInterest())),s.on((()=>this.contentGeometryUpdates.events),"request-update",(()=>this._updateCenterOnContent())),s.watch((()=>p.debugFlags.SHOW_POI),(e=>this._setDebug(e)),s.initial)]),this._cameraChanged(this.view.state.contentCamera);for(const s of this._pois)s.runTask()}destroy(){this._setDebug(!1),this._propertiesPool.destroy();for(const e of this._pois)e.destroy();this.surfaceOrigin.destroy()}get updating(){return!(!this.surfaceGeometryUpdates?.updating&&!this._pois.some((e=>e.updating)))}get _centerRay(){return this._centerRayDirty&&(this._centerRayCached=this.view.sceneIntersectionHelper.getCenterRayWithSubpixelOffset(this.view.state.contentCamera,this._tmpRay),this._centerRayDirty=!1),this._centerRayCached}_estimateContentAltitudeAtCenter(){if(!this._contentAltitudeAtCenterDirty)return this._contentAltitudeAtCenter;this._contentAltitudeAtCenterDirty=!1;const e=this._centerRay;return null==e||(this.view.sceneIntersectionHelper.intersectRay(e,this._contentIntersector,b,T)?this._contentAltitudeAtCenter=this.view.renderCoordsHelper.getAltitude(b):this._contentAltitudeAtCenter=this._estimateSurfaceAltitudeAtCenter()),this._contentAltitudeAtCenter}_estimateSurfaceAltitudeAtCenter(){if(!this.view.basemapTerrain)return 0;if(!this._surfaceAltitudeAtCenterDirty)return this._surfaceAltitudeAtCenter;this._surfaceAltitudeAtCenterDirty=!1;const e=this._centerRay;if(null==e)return this._surfaceAltitudeAtCenter;const t=e.origin,r=u.add(b,e.origin,e.direction);return this._surfaceIntersector.resetWithRay(e,this.view.state.contentCamera),this.view.basemapTerrain.intersect(this._surfaceIntersector,null,t,r),this._surfaceIntersector.results.min.getIntersectionPoint(b)&&(this._surfaceAltitudeAtCenter=this.view.renderCoordsHelper.getAltitude(b)),this._surfaceAltitudeAtCenter}_estimateSurfaceIntersectionAtRenderPoint(e,t,r){const n=_.fromRenderAtEye(t,e,R);if(null==n)return null;const s=n.origin,i=u.add(b,n.origin,n.direction);return this._surfaceIntersector.resetWithRay(n,t),this.view.basemapTerrain.intersect(this._surfaceIntersector,null,s,i),this._surfaceIntersector.results.min.getIntersectionPoint(r)?r:null}_cameraChanged(e){this._updateCenterPointsOfInterest();const t=e.eye;u.exactEquals(this.renderPointOfView,t)||this._set("renderPointOfView",u.copy(this._propertiesPool.get("renderPointOfView"),t))}_updateCenterPointsOfInterest(){this._centerRayDirty=!0,this._surfaceAltitudeAtCenterDirty=!0,this._contentAltitudeAtCenterDirty=!0;for(const e of this._pois)e.updateRenderLocation()}_updateCenterOnContent(){this._contentAltitudeAtCenterDirty=!0,this.centerOnContent.updateRenderLocation()}_setDebug(e){if(!e)return this._debugCenters?.forEach((e=>e.hide())),void this.removeHandles("debug");if(!this._debugCenters){this._debugCenters=new Map;const e=this.view.graphics;this._debugCenters.set(this.centerOnContent,new f.PointGraphics(e,"red","CenterOnContent")),this._debugCenters.set(this.centerOnSurfaceFrequent,new f.PointGraphics(e,"red","CenterOnSurface")),this._debugCenters.set(this.centerOnSurfaceInfrequent,new f.PointGraphics(e,"red","CenterOnSurface")),this._debugCenters.set(this.cameraOnSurface,new f.PointGraphics(e,"blue","CameraOnSurface")),this._debugCenters.set(this.focus,new f.PointGraphics(e,"green","Focus"))}for(const t of this._pois)this.addHandles(s.watch((()=>t.renderLocation),(e=>this._debugCenters?.get(t)?.show(e,t.renderCoordsHelper.spatialReference)),s.initial),"debug")}get test(){}},t.__decorate([i.property()],e.PointsOfInterest.prototype,"centerOnContent",void 0),t.__decorate([i.property()],e.PointsOfInterest.prototype,"centerOnSurfaceFrequent",void 0),t.__decorate([i.property()],e.PointsOfInterest.prototype,"centerOnSurfaceInfrequent",void 0),t.__decorate([i.property()],e.PointsOfInterest.prototype,"cameraOnSurface",void 0),t.__decorate([i.property()],e.PointsOfInterest.prototype,"focus",void 0),t.__decorate([i.property()],e.PointsOfInterest.prototype,"renderPointOfView",void 0),t.__decorate([i.property()],e.PointsOfInterest.prototype,"surfaceOrigin",void 0),t.__decorate([i.property()],e.PointsOfInterest.prototype,"contentGeometryUpdates",void 0),t.__decorate([i.property()],e.PointsOfInterest.prototype,"surfaceGeometryUpdates",void 0),t.__decorate([i.property({constructOnly:!0})],e.PointsOfInterest.prototype,"view",void 0),t.__decorate([i.property()],e.PointsOfInterest.prototype,"updating",null),e.PointsOfInterest=t.__decorate([c.subclass("esri.views.3d.support.pointsOfInterest.PointsOfInterest")],e.PointsOfInterest);const v=Array,b=d.create(),R=h.create(),T={exclude:new Set([m.terrainId])};Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
