/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../core/mathUtils","../../../core/libs/gl-matrix-2/math/mat4","../../../core/libs/gl-matrix-2/factories/mat4f64","../../../core/libs/gl-matrix-2/math/vec2","../../../core/libs/gl-matrix-2/factories/vec2f64","../../../chunks/vec32","../../../core/libs/gl-matrix-2/factories/vec3f64","../../ViewingMode","../../../chunks/SunCalc","./mathUtils"],(function(t,e,i,o,l,n,a,r,c,s,u){"use strict";const m={local:{altitude:1500,ambientAtNight:.1,ambientAtNoon:.45,ambientAtTwilight:.2,directAtNoon:.65,directAtTwilight:.7},global:{altitude:8e5,ambient:.015,direct:.75},planarDirection:{localAltitude:1e4,globalAltitude:1e6,globalAngles:{azimuth:1.3*Math.PI,altitude:.6*Math.PI}}};class f{constructor(t,e){this.direct=t,this.ambient=e}}function d(t,i,o,l,n,c){a.set(c.ambient.color,1,1,1),c.ambient.intensity=m.global.ambient,a.set(c.direct.color,1,1,1),c.direct.intensity=m.global.direct;const u=i[2],f=e.clamp((Math.abs(u)-m.local.altitude)/(m.global.altitude-m.local.altitude),0,1);let d;if(c.globalFactor=f,null!=t&&(d=s.SunCalc.getTimes(t,i[1],i[0])),f<1){let i;if(null!=t)i=X(t,d,l);else{const t=S(l);i={direct:{intensity:m.local.directAtNoon*t.direct,color:r.fromValues(1,1,1)},ambient:{intensity:m.local.ambientAtNoon*t.ambient,color:r.fromValues(1,1,1)},timeOfDay:"early afternoon"}}a.lerp(c.ambient.color,i.ambient.color,c.ambient.color,f),c.ambient.intensity=e.lerp(i.ambient.intensity,c.ambient.intensity,f),a.lerp(c.direct.color,i.direct.color,c.direct.color,f),c.direct.intensity=e.lerp(i.direct.intensity,c.direct.intensity,f),c.specularStrength="rainy"===l||"snowy"===l||"foggy"===l?0:1,c.environmentStrength="rainy"===l?.7:"snowy"===l||"foggy"===l?.75:1}c.noonFactor=null!=t?M(t,d):1,null!=t?h(t,i,o,c.direct.directionToLightSource):g(n,o,c.direct.directionToLightSource)}function g(t,e,o){e===c.ViewingMode.Global?a.normalize(Z,t.eye):a.set(Z,0,0,1),a.scale(q,t.viewForward,-1);const l=u.angle(q,Z),n=Math.max(l-2*J,0),r=.85*n/(n+1),s=Math.max(J,l-J-r);i.fromRotation(Y,-s,t.viewRight),a.transformMat4(o,q,Y),a.add(o,o,a.scale(B,t.viewRight,K)),a.normalize(o,o)}function h(t,o,l,n){const r=V,u=i.identity(w);if(l===c.ViewingMode.Global)s.SunCalc.getPosition(t,0,0,r),a.set(n,0,0,-1),i.rotateX(u,u,-r.azimuth),i.rotateY(u,u,-r.altitude),a.transformMat4(n,n,u);else{const l=m.planarDirection,c=l.globalAngles,f=o[2];let d=(Math.abs(f)-l.localAltitude)/(l.globalAltitude-l.localAltitude);d=e.clamp(d,0,1),d<1?(s.SunCalc.getPosition(t,o[1],o[0],r),r.azimuth=(1-d)*r.azimuth+d*c.azimuth,r.altitude=(1-d)*r.altitude+d*c.altitude):(r.azimuth=c.azimuth,r.altitude=c.altitude),a.set(n,0,-1,0),i.rotateZ(u,u,-r.azimuth),i.rotateX(u,u,-r.altitude),a.transformMat4(n,n,u)}}function b(t,e){if(e===c.ViewingMode.Global)return!0;const i=m.planarDirection;return Math.abs(t)<i.localAltitude}function p(t,e,i,o,l){const n=t.getTime(),a=e.getTime()-n,c=Math.floor(a/i)+1,s=new Array(c);for(let u=0;u<c;++u)j.setTime(n+i*u),s[u]=r.create(),h(j,o,l,s[u]);return s}const y=r.fromValues(.5773502691896258,-.5773502691896258,.5773502691896258);class A{constructor(){this.ambient={color:r.fromValues(1,1,1),intensity:.55},this.direct={color:r.fromValues(1,1,1),intensity:.55,directionToLightSource:r.clone(y)},this.noonFactor=.5,this.globalFactor=0,this.specularStrength=1,this.environmentStrength=1}}const w=o.create(),V={azimuth:0,altitude:0};function M(t,i){const o=t.valueOf();let l,n;i.polarException===s.SunCalc.PolarException.MIDNIGHT_SUN?(l=o-60*(t.getHours()+48)*60*1e3-60*t.getMinutes()*1e3,n=l+432e6):i.polarException===s.SunCalc.PolarException.POLAR_NIGHT?(l=o-2,n=o-1):(l=i.sunrise.valueOf(),n=i.sunset.valueOf());const a=l+(n-l)/2;return 1-e.clamp(Math.abs(o-a)/432e5,0,1)}function S(t){switch(t){case"disabled":case"sunny":case"cloudy":return new f(1,1);case"rainy":return new f(.4,1.2);case"snowy":return new f(.5,1.3);case"foggy":return new f(.2,1.6)}}function v(t,e){const i=(t[0]+t[1]+t[2])/3;t[0]+=(i-t[0])*e,t[1]+=(i-t[1])*e,t[2]+=(i-t[2])*e}const T=r.fromValues(.01,.01,.01),x=r.fromValues(1,.6,.5),N=r.fromValues(1,.98,.98),O=r.fromValues(1,1,1),z=r.fromValues(.8,.8,1),P=r.fromValues(.8,.8,1),C=r.fromValues(.98,.98,1),D=r.fromValues(1,1,1),I=n.fromValues(.01,m.local.ambientAtNight),E=n.fromValues(m.local.directAtTwilight,m.local.ambientAtTwilight),G=n.fromValues(.9*m.local.directAtNoon,m.local.ambientAtNoon),H=n.fromValues(m.local.directAtNoon,m.local.ambientAtNoon),L=G,F=N,R=C,U=E,_=x,k=P;function X(t,e,i){const o=t.valueOf();let c,u;e.polarException===s.SunCalc.PolarException.MIDNIGHT_SUN?(c=o-60*(t.getHours()+48)*60*1e3-60*t.getMinutes()*1e3,u=c+432e6):e.polarException===s.SunCalc.PolarException.POLAR_NIGHT?(c=o-2,u=o-1):(c=e.sunrise.valueOf(),u=e.sunset.valueOf());const m=u-c,f=c+m/2,d=m/4,g=f-d,h=f+d,b=.06*m,p=c-b/2,y=c+b/2,A=u-b/2,w=u+b/2,V=n.create(),M=r.create(),X=r.create();let j="";if(o<p||o>w)l.copy(V,I),a.copy(M,T),a.copy(X,z),j="night";else if(o<y){const t=(o-p)/(y-p);l.lerp(V,I,E,t),a.lerp(M,T,x,t),a.lerp(X,z,P,t),j="sun rising"}else if(o<g){const t=(o-y)/(g-y);l.lerp(V,E,G,t),a.lerp(M,x,N,t),a.lerp(X,P,C,t),j="early morning"}else if(o<f){const t=(o-g)/(f-g);l.lerp(V,G,H,t),a.lerp(M,N,O,t),a.lerp(X,C,D,t),j="late morning"}else if(o<h){const t=(o-f)/(h-f);l.lerp(V,H,L,t),a.lerp(M,O,F,t),a.lerp(X,D,R,t),j="early afternoon"}else if(o<A){const t=(o-h)/(A-h);l.lerp(V,L,U,t),a.lerp(M,F,_,t),a.lerp(X,R,k,t),j="late afternoon"}else if(o<w){const t=(o-A)/(w-A);l.lerp(V,U,I,t),a.lerp(M,_,T,t),a.lerp(X,k,z,t),j="sun setting"}let Y=0;switch(i){case"rainy":case"foggy":Y=.8;break;case"snowy":Y=.5}Y>0&&(v(M,Y),v(X,Y));const Z=S(i);return{direct:{intensity:V[0]*Z.direct,color:M},ambient:{intensity:V[1]*Z.ambient,color:X},timeOfDay:j}}const j=new Date(0),Y=o.create(),Z=r.create(),q=r.create(),B=r.create(),J=.25,K=.2;t.ColorAndIntensity=A,t.computeColorAndIntensity=d,t.computeDirectionsOverTime=p,t.computeShadowsEnabled=b,t.computeVirtualLightDirection=g,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
