/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../Camera","../../../geometry","../../../Graphic","../../../Viewpoint","../../../core/asyncUtils","../../../core/has","../../../core/Cyclical","../../../core/Error","../../../core/promiseUtils","../../../core/libs/gl-matrix-2/math/mat3","../../../core/libs/gl-matrix-2/factories/mat3f64","../../../core/libs/gl-matrix-2/factories/mat4f64","../../../chunks/vec32","../../../core/libs/gl-matrix-2/factories/vec3f64","../../../geometry/projection","../../../geometry/projection/computeTranslationToOriginAndRotation","../../../geometry/projection/projectPointToVector","../../../geometry/projection/projectVectorToPoint","../../../geometry/projection/projectVectorToVector","../../../geometry/support/aaBoundingBox","../../../geometry/support/aaBoundingRect","../../../geometry/support/frustum","../../../geometry/support/scaleUtils","../camera/intersectionUtils","./cameraUtils","./ElevationProvider","../../../geometry/Point","../../../geometry/Extent","../../../geometry/SpatialReference","../../../geometry/Geometry","../../../geometry/Multipoint"],(function(e,t,n,a,o,r,i,c,s,l,u,m,f,g,p,y,h,d,w,x,v,T,b,R,S,A,z,j,C,M,G,O){"use strict";const V=.66;function D(e){return 360-c.cyclicalDegrees.normalize(e)}function P(e){return c.cyclicalDegrees.normalize(360-e)}function E(e,t,n){const a=t.camera;if(null!=a)return B(a,A.getViewSR(e));const{targetGeometry:o}=t;if(null==o)return null;const{camera:r,mode:i}=F(e,t.rotation,n);if("point"===o.type)return U(e,t,o,r,i);const c=o.extent;return null==c?null:A.fromExtentSync(e,c,r.heading,r.tilt,i)}async function Z(e,t,n,a){const o=t.camera;if(null!=o)return W(o,A.getViewSR(e),a);const{targetGeometry:r}=t;if(null==r)throw new Error("Viewpoint has no targetGeometry!");const{camera:i,mode:c}=F(e,t.rotation,n);if("point"===r.type)return I(e,t,r,i,c,a);const s=r.extent;if(null==s)throw new Error("Target geometry has no extent!");return A.fromExtentAsync(e,s,i.heading,i.tilt,c,a)}function B(e,t){const n=e.position;let a;try{a=y.tryProjectWithZConversion(n,t)}catch(r){return null}if(!a)return null;const o=e.clone();return o.position=a.clone(),o}async function W(e,t,n){const a=e.position,o=await y.projectWithZConversion(a,t,{signal:n});l.throwIfAborted(n);const r=e.clone();return r.position=o.clone(),r}function F(e,t,n){const a=A.internalToExternal(e,e.state.camera);let o=A.OrientationMode.ADJUST;return null!=t&&(a.heading=D(t),o=A.OrientationMode.LOCKED),null!=n&&(a.tilt=n),{camera:a,mode:o}}function U(e,t,n,a,o){const r=e.spatialReference;let i;try{i=y.tryProjectWithZConversion(n.clone(),r)}catch(s){return null}if(!i)return null;const c=null!=t.scale?A.scaleToDistance(e,t.scale):e.state.camera.distance;return A.fromCenterDistanceSync(e,i,c,a,o)}async function I(e,t,n,a,o,r){const i=e.spatialReference,c=await y.projectWithZConversion(n.clone(),i,{signal:r});l.throwIfAborted(r);const s=null!=t.scale?A.scaleToDistance(e,t.scale):e.state.camera.distance;return A.fromCenterDistanceAsync(e,c,s,a,o,r)}function k(e,t,n=null){return null==n&&(n=new o),H(e,null,t.clone(),n)}async function J(e,n,a){const r=ie(e,n);if(!r)throw new s("viewpointutils-create:no-target","Missing target for creating viewpoint");const i=new t({fov:e.camera.fov}),c=new o({camera:i});if(r.target instanceof o){return ce(await _(e,r.target,r,a,c))}if(r.target instanceof t)return ce(await Q(e,r.target,a,c));const l=null!=r.scale||null!=r.zoom;if(r.target instanceof C){const t=r.target.xmin===r.target.xmax||r.target.ymin===r.target.ymax;return ce(l||t?await ee(e,r,r.target.center,i,a,c):await ae(e,r,r.target,i,a,c))}const u=new le,m=l?L(e,r):void 0;if(await X(e,r.target,m,u,a),isFinite(u.boundingBox[0])){let t;if(v.center(u.boundingBox,ue),xe.x=ue[0],xe.y=ue[1],xe.z=ue[2],xe.spatialReference=e.spatialReference,isFinite(xe.z)&&u.hasZ?t=v.isPoint(u.boundingBox):(xe.z=void 0,t=T.isPoint(v.toRect(u.boundingBox,pe))),l||t)return ce(await ee(e,r,xe,i,a,c));const n=se(e,u.screenSpaceObjects);return ce(await re(e,r,xe,u.boundingBox,n,i,a,c))}return r.position?ce(await te(e,r,i,c,a)):ce(await ne(e,r,i,a,c))}function K(e,t){return null==t.scale&&null!=t.zoom?A.zoomToScale(e,t.zoom):t.scale}function L(e,t){const n=K(e,t);return n?R.getResolutionInMetersForScale(n):void 0}function N(e,t){let n=!1;return null!=t.heading?(e.heading=t.heading,n=!0):null!=t.rotation&&(e.heading=D(t.rotation),n=!0),null!=t.tilt&&(e.tilt=t.tilt,n=!0),null!=t.fov&&(e.fov=t.fov),n}function H(e,t,n,a){const o=e.spatialReference||M.WGS84;if(t??=A.externalToInternal(e,n),null==t)return a;const r=new j({spatialReference:o});return w.projectVectorToPoint(t.center,e.renderSpatialReference,r)?(a.targetGeometry=r,a.scale=A.distanceToScale(e,t.distance),a.rotation=P(n.heading),a.camera=n,a):a}async function Y(e,t,n,a){const o=()=>new s("viewpointutils:invalid-geometry","The target is missing a valid geometry");if(!t)throw o();"mesh"===t.type&&(t=t.extent);const r=e.basemapTerrain.spatialReference;if(!t.hasZ&&e.basemapTerrain){let n;switch(t.type){case"point":n=t;break;case"multipoint":case"polyline":n=t.extent?.center;break;case"extent":n=t.center;break;case"polygon":n=t.centroid}null!=n&&r&&e.elevationProvider?(n=await y.projectWithZConversion(n,r,{signal:a}),ue[2]=z.getElevationAtPoint(e.elevationProvider,n)??0):ue[2]=0}const i=ve[t.type],c=new Array;if(i(t,t.hasZ?e=>{c.push([e[0],e[1],e[2]])}:e=>{c.push([e[0],e[1]])},ue),0===c.length)throw o();const l=t.spatialReference,u=e.spatialReference,m=await y.projectWithZConversion(new O({spatialReference:l,hasZ:t.hasZ,hasM:!1,points:c}),u,{signal:a});if(t.hasZ&&(n.hasZ=!0),t.hasZ)for(const[s,f,g]of m.points)ue[0]=s,ue[1]=f,ue[2]=g,v.expandWithVec3(n.boundingBox,ue);else for(const[s,f]of m.points)ue[0]=s,ue[1]=f,v.expandWithVec3(n.boundingBox,ue)}async function q(e,t,n,a,o){const i=await r.result(e.whenViewForGraphic(t));if(!1===i.ok||null==i.value||!("whenGraphicBounds"in i.value))return void await Y(e,t.geometry,a,o);const c=i.value,s=await r.result(c.whenGraphicBounds(t,{minDemResolution:n}));if(!1===s.ok||!s.value)return void await Y(e,t.geometry,a,o);const{screenSpaceObjects:l,boundingBox:u}=s.value;v.expandWithAABB(a.boundingBox,u),l&&l.forEach((e=>{a.screenSpaceObjects.push(e)})),isFinite(u[2])&&(a.hasZ=!0)}async function X(e,t,n,o,r){if(Array.isArray(t)&&2===t.length){const n=t[0],a=t[1];if("number"==typeof n&&"number"==typeof a)return xe.x=n,xe.y=a,xe.z=void 0,xe.spatialReference=e.spatialReference?.isGeographic?e.spatialReference:M.WGS84,void await Y(e,xe,o,r)}t&&"map"in t&&"function"==typeof t.map?await Promise.allSettled(t.map((t=>X(e,t,n,o,r)))):t instanceof G?await Y(e,t,o,r):t instanceof a&&await q(e,t,n,o,r)}async function _(e,t,n,a,o){if(t.camera)return Q(e,t.camera,a,o);o.scale=t.scale,o.rotation=t.rotation,o.targetGeometry=null!=t.targetGeometry?t.targetGeometry.clone():null,o.camera=null,null!=n.heading?o.rotation=P(n.heading):null!=n.rotation&&(o.rotation=n.rotation);const r=K(e,n);return null!=r&&(o.scale=r),o.camera=await Z(e,o,n.tilt,a),o}async function Q(e,t,n,a){const o=e.spatialReference,r=await y.projectWithZConversion(t.position,o,{signal:n}),i=t.clone();return i.position=r,H(e,null,i,a)}async function $(e,t,n,a,o,r,i){const c=e.renderSpatialReference;return await d.projectPointToVectorAsync(t,de,c,0,{signal:i}),await d.projectPointToVectorAsync(n,he,c,0,{signal:i}),r.targetGeometry=new j(t),o.position=new j(n),g.subtract(ye,de,he),A.directionToHeadingTilt(e,he,ye,a.up,o),r.scale=A.distanceToScale(e,g.distance(he,de)),r.rotation=P(o.heading),r.camera=o,r}async function ee(e,t,n,a,o,r){r.targetGeometry=n.clone();const i=S.cameraOnContentAlongViewDirection(e);if(t.position)return $(e,r.targetGeometry,t.position,i,a,r,o);if(t.zoomFactor){const n=i.distance/t.zoomFactor,a=g.scale(ue,i.viewForward,-n);i.eye=g.add(ue,i.center,a),r.scale=A.distanceToScale(e,n)}A.internalToExternal(e,i,a);const c=N(a,t)?A.OrientationMode.LOCKED:A.OrientationMode.ADJUST;if(!t.zoomFactor){const n=K(e,t);if(null==n){await d.projectPointToVectorAsync(r.targetGeometry,ue,e.renderSpatialReference,0,{signal:o});const t=b.intersectsPoint(i.frustum,ue)?g.distance(i.eye,ue):i.distance;r.camera=await A.fromCenterDistanceAsync(e,r.targetGeometry,t,a,c),r.scale=A.distanceToScale(e,t)}else r.scale=n,r.camera=await A.fromCenterScale(e,r.targetGeometry,r.scale,a,c,o)}return r}async function te(e,t,n,a,o){const r=S.cameraOnContentAlongViewDirection(e);g.copy(ye,r.viewForward),A.directionToHeadingTilt(e,r.eye,ye,r.up,we);const i=e.spatialReference,{position:c}=t;if(c){const e=await y.projectWithZConversion(c,i,{signal:o});n.position=e}else n.position=new j;return n.heading=null!=t.heading?t.heading:we.heading,n.tilt=null!=t.tilt?t.tilt:we.tilt,H(e,null,n,a)}async function ne(e,t,n,a,o){if(null!=t.heading||null!=t.rotation||null!=t.scale||null!=t.tilt||null!=t.zoom||null!=t.zoomFactor){const r=S.cameraOnContentAlongViewDirection(e),{spatialReference:i,renderSpatialReference:c}=e,s=new j({spatialReference:i});return w.projectVectorToPoint(r.center,c,s)?ee(e,t,s,n,a,o):o}return o.scale=e.scale,o.camera=e.camera.clone(),N(o.camera,t),o}async function ae(e,t,n,a,o,r){r.targetGeometry=n.clone();const i=S.cameraOnContentAlongViewDirection(e);A.internalToExternal(e,i,a);const c=N(a,t)?A.OrientationMode.LOCKED:A.OrientationMode.ADJUST;return r.camera=await A.fromExtentAsync(e,n,a.heading,a.tilt,c,o),r}function oe(e,t,n,a,o){let r=0;null!=n.z?r=n.z:e.basemapTerrain&&e.elevationProvider&&(r=z.getElevationAtPoint(e.elevationProvider,n)),g.set(ue,n.x,n.y,r),h.computeTranslationToOriginAndRotation(e.spatialReference,ue,me,e.renderSpatialReference),u.fromMat4(fe,me),u.transpose(fe,fe),v.empty(ge);const i=[[0,1,2],[3,1,2],[0,4,2],[3,4,2],[0,1,5],[3,1,5],[0,4,5],[3,4,5]];for(let u=0;u<i.length;u++){const t=i[u];let n=a[t[2]];isFinite(n)||(n=r),g.set(ue,a[t[0]],a[t[1]],n),x.projectVectorToVector(ue,e.spatialReference,ue,e.renderSpatialReference),v.expandWithVec3(ge,g.transformMat3(ue,ue,fe))}const c=v.width(ge),s=v.height(ge),l=v.depth(ge),m=1/Math.tan(t.fovX/2),f=1/Math.tan(t.fovY/2),p=.5*Math.sqrt(c*c+l*l)*Math.max(f,m)+.5*s,y=.5*s*f+.5*Math.max(c,l);return Math.max(p,y)/o}async function re(e,t,n,a,o,r,i,c){c.targetGeometry=n.clone();const s=S.cameraOnContentAlongViewDirection(e),l=oe(e,s,n,a,o);A.internalToExternal(e,s,r);const u=N(r,t)?A.OrientationMode.LOCKED:A.OrientationMode.ADJUST;return c.camera=await A.fromCenterDistanceAsync(e,c.targetGeometry,l,r,u,i),c.scale=A.distanceToScale(e,l),c}function ie(e,t){if(!t||!e.spatialReference)return null;const n={target:void 0};return"declaredClass"in t||Array.isArray(t)?n.target=t:(Object.assign(n,t),!n.target&&"center"in t&&t.center&&(n.target=t.center)),n}function ce(e){return null!=e?.camera&&(e.rotation=P(e.camera.heading)),e}function se(e,t){const n=V;if(!t.length)return n;let a=Number.NEGATIVE_INFINITY;for(let o=0;o<t.length;o++){const e=t[o].screenSpaceBoundingRect;a=Math.max(a,Math.abs(e[0]),Math.abs(e[1]),Math.abs(e[2]),Math.abs(e[3]))}return n-a/Math.min(e.width,e.height)*2}class le{constructor(){this.hasZ=!1,this.boundingBox=v.empty(),this.screenSpaceObjects=new Array}}const ue=p.create(),me=f.create(),fe=m.create(),ge=v.create(),pe=T.create(),ye=p.create(),he=p.create(),de=p.create(),we={heading:0,tilt:0},xe=new j,ve={point(e,t,n){n[0]=e.x,n[1]=e.y,null!=e.z&&(n[2]=e.z),t(n)},polygon(e,t,n){const a=e.hasZ;for(let o=0;o<e.rings.length;o++){const r=e.rings[o];for(let e=0;e<r.length;e++)n[0]=r[e][0],n[1]=r[e][1],a&&(n[2]=r[e][2]),t(n)}},polyline(e,t,n){const a=e.hasZ;for(let o=0;o<e.paths.length;o++){const r=e.paths[o];for(let e=0;e<r.length;e++)n[0]=r[e][0],n[1]=r[e][1],a&&(n[2]=r[e][2]),t(n)}},multipoint(e,t,n){const a=e.points,o=e.hasZ;for(let r=0;r<a.length;r++)n[0]=a[r][0],n[1]=a[r][1],o&&(n[2]=a[r][2]),t(n)},extent(e,t,n){null!=e.zmin&&null!=e.zmax?(t(g.set(n,e.xmin,e.ymin,e.zmin)),t(g.set(n,e.xmax,e.ymin,e.zmin)),t(g.set(n,e.xmin,e.ymax,e.zmin)),t(g.set(n,e.xmax,e.ymax,e.zmin)),t(g.set(n,e.xmin,e.ymin,e.zmax)),t(g.set(n,e.xmax,e.ymin,e.zmax)),t(g.set(n,e.xmin,e.ymax,e.zmax)),t(g.set(n,e.xmax,e.ymax,e.zmax))):(t(g.set(n,e.xmin,e.ymin,n[2])),t(g.set(n,e.xmax,e.ymin,n[2])),t(g.set(n,e.xmin,e.ymax,n[2])),t(g.set(n,e.xmax,e.ymax,n[2])))}};e.create=J,e.fromCamera=k,e.toCameraAsync=Z,e.toCameraSync=E,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
