/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../chunks/tslib.es6","../../../core/Accessor","../../../core/Cyclical","../../../core/has","../../../core/mathUtils","../../../core/maybe","../../../core/reactiveUtils","../../../core/accessorSupport/decorators/property","../../../core/Logger","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../../core/libs/gl-matrix-2/math/vec2","../../../chunks/vec32","../../../core/libs/gl-matrix-2/factories/vec3f64","../../../chunks/vec42","../../../core/libs/gl-matrix-2/factories/vec4f64","../../../geometry/ellipsoidUtils","../../../geometry/projection/projectVectorToVector","../../../geometry/support/aaBoundingRect","../../../geometry/support/ray","../../../chunks/sphere","../../../geometry/support/vector","../../../geometry/support/webMercatorUtils","../state/utils/viewUtils","../support/debugFlags","../support/debugUtils","./interfaces","./OverlayRenderer","../webgl-engine/lib/basicInterfaces","../webgl-engine/lib/Intersector","../webgl-engine/lib/LocalOriginFactory","../webgl-engine/lib/SortedRenderGeometryRenderer","../webgl-engine/lib/textureUtils","../webgl-engine/parts/renderUtils","../../support/Scheduler","../../support/Yield"],(function(e,t,r,s,i,a,n,o,l,c,d,h,u,p,y,_,g,v,R,O,f,m,w,x,T,S,D,E,P,M,I,b,C,N,U,A,q){"use strict";const V=1.3,G=[[-.1,-2,3.9,2],[-.1,-3.9,3.9,.1],[-2,-3.9,2,.1],[-3.9,-3.9,.1,.1],[-3.9,-2,.1,2],[-3.9,-.1,.1,3.9],[-2,-.1,2,3.9],[-.1,-.1,3.9,3.9]];let F;function L(e,t){const r=1e-5,s=S.debugFlags.TESTS_DISABLE_OPTIMIZATIONS?0:r*Math.max(e[2]-e[0],e[3]-e[1],t[2]-t[0],t[3]-t[1]);return Math.abs(t[0]-e[0])<=s&&Math.abs(t[1]-e[1])<=s&&Math.abs(t[2]-e[2])<=s&&Math.abs(t[3]-e[3])<=s}e.OverlayManager=class extends r{constructor(e){super(e),this._spatialReference=null,this._renderSR=null,this._overlaySREqualsRenderSR=!0,this._drapeSources=new Set,this._drapeTargets=new Set,this._placementDirty=!1,this._contentUpdated=!1,this._drawTexturesDirty=!1,this._drawTexturesAnimateDirty=!1,this._longitudeCyclical=null,this._latestOriginId=0,this._maxResolution=i("esri-mobile")?2048:4096}initialize(){const e=this.view;this.renderer=new P.OverlayRenderer({view:e,worldToPCSRatio:this._worldToPCSRatio,spatialReference:this._spatialReference}),e._stage.renderer.plugins.add(this.renderer);const t=()=>this.setDrawTexturesDirty();this._groundIntersector=I.newIntersector(this.view.state.viewingMode),this._groundIntersector.options.backfacesTerrain=!0,this._groundIntersector.options.invisibleTerrain=!0,this._groundIntersector.options.hud=!1,this.addHandles([o.watch((()=>this.renderer.hasHighlights),t),this.renderer.events.on("has-water",(()=>e._stage?.renderer.updateHasFlags())),this.renderer.events.on("content-changed",t),o.watch((()=>e.state.camera.pixelRatio),t),o.watch((()=>e.state.alignPixelEnabled),t),this.renderer.events.on("textures-disposed",(()=>this.surface.requestRender())),o.watch((()=>[e.pointsOfInterest?.renderPointOfView,e.pointsOfInterest?.centerOnSurfaceFrequent?.location]),(()=>this.setPlacementDirty())),o.watch((()=>[e.state?.pixelRatio,e.state?.contentPixelRatio]),(()=>this.setPlacementDirty()),o.sync),this.surface.on("elevation-change",(()=>this.setPlacementDirty())),e.on("resize",(()=>this.setPlacementDirty())),e.resourceController.scheduler.registerTask(A.TaskPriority.OVERLAY,this),e._stage.renderView.events.on("force-camera-for-screenshot",(e=>{this._updateOverlays(A.noBudget,e.camera,M.RenderRequestType.BACKGROUND),this.renderer.hasOverlays&&this._drawOverlays(M.RenderRequestType.BACKGROUND,e)}))]),e._stage.renderer.overlay=this}destroy(){this.view?._stage&&(this.view._stage.renderer.plugins.remove(this.renderer),this.view._stage.renderer.overlay=null),F&&(F.hide(),F=null),this.renderer=n.destroyMaybe(this.renderer)}get running(){return this._placementDirty&&(this._drapeSources.size>0||this.view.graphics.length>0||S.debugFlags.OVERLAY_DRAW_DEBUG_TEXTURE)&&!!this._spatialReference&&!this.suspended&&this.surface.ready}get _isSpherical(){return this.view.state.isGlobal}get _worldToPCSRatio(){return null!=this._spatialReference&&this._spatialReference.isGeographic&&!this.view.state.isLocal?v.getReferenceEllipsoid(this._spatialReference).metersPerDegree:1}get _overlayStretch(){return V/this.view.resolutionScale}get suspended(){return this.surface.suspended}get updating(){return this.running||this.renderer.updating||this._contentUpdated}get rendersOccludedDraped(){return this.renderer.rendersOccludedDraped}render(){if(this._contentUpdated=!1,this.renderer.processSyncDrapeSources(),this.renderer.hasOverlays)return this._precompileShaders()?this._drawOverlays(M.RenderRequestType.UPDATE):null}get hasOverlays(){return this.renderer.hasOverlays}setSpatialReference(e){this._spatialReference=e,this.renderer.spatialReference=e,this._longitudeCyclical=null;const t=this.view.renderSpatialReference;null!=e&&null!=t?(this._renderSR=t,this._overlaySREqualsRenderSR=e.equals(this._renderSR),this._isSpherical&&(this._longitudeCyclical=e.isWebMercator?new s.Cyclical(-20037508.342787,20037508.342787):new s.Cyclical(-180,180),this.renderer.longitudeCyclical=this._longitudeCyclical),this.renderer&&(this.renderer.worldToPCSRatio=this._worldToPCSRatio)):this.renderer.disposeOverlays()}registerDrapeSource(e,t,r){this._drapeSources.add(e),this.renderer.ensureOverlays(this._drapeTargets,this._drapeSources);const s=this.renderer.createDrapeSourceRenderer(e,t,r);return this._updateDrapeSourceExtent(e),this._setContentDirty(),this.notifyChange("running"),s}registerGeometryDrapeSource(e){return this.registerDrapeSource(e,C.SortedRenderGeometryRenderer)}_updateDrapeSourceExtent(e){2===this.renderer.overlays.length&&null!=e.setDrapingExtent&&null!=this._spatialReference&&e.setDrapingExtent(this.renderer.overlays,this._spatialReference)}unregisterDrapeSource(e){this._drapeSources.has(e)&&(this._drapeSources.delete(e),this.renderer.removeDrapeSourceRenderer(e),this.renderer.ensureDrapeSources(this._drapeSources),this._setContentDirty(),this.notifyChange("running"))}registerDrapeTarget(e){this._drapeTargets.add(e),this.renderer.ensureOverlays(this._drapeTargets,this._drapeSources)}unregisterDrapeTarget(e){this._drapeTargets.delete(e),this.renderer.ensureDrapeTargets(this._drapeTargets)}_setContentDirty(){this.setPlacementDirty(),this.setDrawTexturesDirty()}setPlacementDirty(){this._placementDirty=!0}runTask(e){return this._updateOverlays(e,this.view.state.contentCamera,M.RenderRequestType.UPDATE)}_updateOverlays(e,t,r){if(!this._spatialReference)return q.Yield;const s=this._computeOverlayResolution(t);this._computeOverlayExtents(t,s,k),this.renderer.ensureOverlays(this._drapeTargets,this._drapeSources,k.stretch);const i=this._updateOverlay(E.OverlayIndex.INNER,k.inner,s,1*k.pixelRatioAdjustment,k.mapUnitsPerPixel),a=O.width(k.inner)/O.width(k.outer),n=this._updateOverlay(E.OverlayIndex.OUTER,k.outer,s,a*k.pixelRatioAdjustment,k.mapUnitsPerPixel);i!==X.EXTENT&&n!==X.EXTENT||(this._drapeSources.forEach((e=>this._updateDrapeSourceExtent(e))),this.surface.updateTileOverlayParams(r)),i===X.NONE&&n===X.NONE||this.setDrawTexturesDirty(),this._placementDirty=!1,e.madeProgress()}_computeOverlayResolution(e){const t=this.view.state.contentPixelRatio*this.view.resolutionScale,r=e.fullWidth/e.pixelRatio*t,s=e.fullHeight/e.pixelRatio*t,i=Math.ceil(1.5*Math.max(r,s));return Math.min(N.applyTextureResizeModulo(i),this._maxResolution)}_updateOverlay(e,t,r,s,i){if(0===this.renderer.overlays.length)return X.NONE;const a=this.renderer.overlays[e],n=a.mapUnitsPerPixel;if(a.mapUnitsPerPixel=i,a.pixelRatio=s,L(t,a.extent)&&r===a.resolution)return n===i?X.NONE:X.RERENDER_ONLY;O.copy(a.extent,t),a.resolution=r;const o=O.center(a.extent);return a.renderLocalOrigin=b.fromValues(o[0],o[1],0,"OV_"+this._latestOriginId++),X.EXTENT}setTileParameters(e){const t=e.renderData.overlay;if(this.renderer.overlays.length>0){const r=this.renderer.overlays[E.OverlayIndex.INNER],s=this.renderer.overlays[E.OverlayIndex.OUTER],i=e.extent;this._rectInsideRect(r.extent,i)||this._rectanglesOverlap(i,r.extent)||this._rectanglesOverlap(i,s.extent)?(this._setTileOverlayData(i,E.OverlayIndex.INNER,t),this._setTileOverlayData(i,E.OverlayIndex.OUTER,t)):(this._clearTileOverlayData(E.OverlayIndex.INNER,t),this._clearTileOverlayData(E.OverlayIndex.OUTER,t))}else this._clearTileOverlayData(E.OverlayIndex.INNER,t),this._clearTileOverlayData(E.OverlayIndex.OUTER,t)}overlayPixelSizeInMapUnits(e,t){if(0===this.renderer.overlays.length)return t();const r=this.renderer.overlays[E.OverlayIndex.INNER],s=this.renderer.overlays[E.OverlayIndex.OUTER],i=this._pointIsInExtent(e,r.extent)?r:s;return(i.extent[2]-i.extent[0])/i.resolution}_setTileOverlayData(e,t,r){if(0===this.renderer.overlays.length)return;const s=this.renderer.overlays[t].extent,i=O.width(s),a=O.height(s);let n=e[0];if(this._longitudeCyclical){n=this._longitudeCyclical.minimalMonotonic(s[0],n);const t=this._longitudeCyclical.minimalMonotonic(s[0],e[2]);n>t&&(n=t-(e[2]-e[0]))}r.setScale(t,O.width(e)/i,O.height(e)/a),r.setOffset(t,(n-s[0])/i,(e[1]-s[1])/a)}_clearTileOverlayData(e,t){t.setScale(e,-1,-1),t.setOffset(e,-1,-1)}reloadShaders(){U.removeLoadedShaderModules(),this.setDrawTexturesDirty(),this.runTask(A.noBudget)}updateAnimation(e){return this.renderer.updateAnimation(e)&&(this._drawTexturesAnimateDirty=!0),this._drawTexturesAnimateDirty}setDrawTexturesDirty(){this.renderer.hasOverlays?(this._contentUpdated=!0,this._drawTexturesDirty=!0,this.view._stage.renderView.requestRender()):this.setPlacementDirty()}_intersectGroundFromView(e,t,r,s){const i=this.view.sceneIntersectionHelper.getCenterRayWithSubpixelOffset(e,W,t,r);if(null==i)return!1;const a=i.origin,n=p.add(H,i.origin,i.direction);return this._groundIntersector.reset(a,n,e),this._groundIntersector.intersect([]),this.view.basemapTerrain.intersect(this._groundIntersector,null,a,n),this._groundIntersector.results.min.getIntersectionPoint(s)}_findHorizonBasedPointOfInterest(e,t){let r=.5;const i=.55,n=this.view.renderCoordsHelper.getAltitude(e.eye),o=this.view.pointsOfInterest.centerOnSurfaceFrequent,l=1e-5,c=a.clamp(o.estimatedSurfaceAltitude,e.aboveGround?-1/0:n+l,e.aboveGround?n-l:1/0),d=e.aboveGround;if("global"===this.view.viewingMode){const t=H;m.closestPointOnSilhouette(m.fromRadius(m.tmpSphere,v.getReferenceEllipsoid(this.view.spatialReference).radius+c),f.wrap(e.eye,e.viewForward),t),p.subtract(t,t,e.eye);const a=s.cyclicalPI.normalize(w.angleAroundAxis(e.viewForward,t,e.viewRight))/e.fovY+.5,n=a<=0||a>=1?.5:i;r=d?n*a:a+n*(1-a)}else{const t=.5*Math.PI-Math.acos(-e.viewForward[2]),s=Math.tan(t),n=g.fromValues(0,s,1,0),o=_.transformMat4(n,n,e.projectionMatrix)[1],l=a.clamp(.5+.5*o,0,1);r=1===l||0===l?.5:d?l*i:1-(1-l)*i}return!!this._intersectGroundFromView(e,.5,r,t)&&p.sqrDist(t,e.eye)<o.distance*o.distance}_computeOverlayExtents(e,t,r){const s=this.view.pointsOfInterest.centerOnSurfaceFrequent.renderLocation,i=y.create();this._findHorizonBasedPointOfInterest(e,i)||p.copy(i,s),S.debugFlags.OVERLAY_SHOW_CENTER?(null==F&&(F=new D.PointGraphics(this.view.graphics,"red")),F.show(i,this._renderSR)):null!=F&&F.hide();const n=Math.max(.1,p.distance(e.eye,i)),o=T.viewAngle(this.view.renderCoordsHelper,s,e.eye);this._overlaySREqualsRenderSR||R.projectVectorToVector(i,this._renderSR,i,this._spatialReference);const l=this.surface.extent,c=!this._isSpherical&&this._spatialReference?.isGeographic,d=c&&this._spatialReference?1/v.getReferenceEllipsoid(this._spatialReference).metersPerDegree:1,h=this.view.state.contentPixelRatio,g=e.perScreenPixelRatio/h*n*d;r.mapUnitsPerPixel=g/this._worldToPCSRatio,r.stretch=this._overlayStretch;let f=t*g/2*r.stretch,m=!1,w=c?90:1/0;this._isSpherical&&l&&this._spatialReference&&(this._spatialReference.isWebMercator?(f/=Math.cos(x.y2lat(i[1])),w=l[3]):(m=!0,f/=v.getReferenceEllipsoid(this._spatialReference).metersPerDegree,w=90),f>=w&&(f=w,i[1]=0,this._spatialReference.isWebMercator&&(i[0]=0)));let E=1;m&&(E=1/Math.max(.2,Math.cos(Math.abs(a.deg2rad(i[1])))),f*E>180&&(E=180/f),r.mapUnitsPerPixel*=E);const P=Math.log(2)/12;f=Math.exp(Math.round(Math.log(f)/P)*P);const M=f*E,I=32,b=.5*t/(I*M),C=.5*t/(I*f);i[0]=Math.round(i[0]*b)/b,i[1]=Math.round(i[1]*C)/C;const N=r.inner;N[0]=i[0]-M,N[1]=i[1]-f,N[2]=i[0]+M,N[3]=i[1]+f,this._isSpherical&&this._shiftExtentToFitBounds(N,1/0,w);const U=r.outer;if(6*M>O.width(l))O.copy(U,l);else{if(Math.PI/2-Math.abs(o-Math.PI/2)<=.25*Math.PI)U[0]=N[0]-M,U[1]=N[1]-f,U[2]=N[2]+M,U[3]=N[3]+f;else{R.projectVectorToVector(e.eye,this._renderSR,H,this._spatialReference),u.subtract(j,i,H);let t=-Math.atan2(j[1],j[0])+.125*Math.PI;t<0&&(t+=2*Math.PI);const r=Math.floor(t/(.25*Math.PI));_.scale(j,G[r],2*f),j[0]*=E,j[2]*=E,_.add(U,N,j)}}if(this._isSpherical)U[0]=this._longitudeCyclical.clamp(U[0]),U[2]=this._longitudeCyclical.clamp(U[2]),U[1]=Math.max(U[1],-w),U[3]=Math.min(U[3],w);else{const e=O.intersection(N,l,Y),t=O.intersection(U,l,z);O.contains(e,t)&&(U[2]=U[0],U[3]=U[1])}const A=Math.abs(N[2]-N[0])/t;r.mapUnitsPerPixel=Math.max(r.mapUnitsPerPixel,A),r.pixelRatioAdjustment=r.mapUnitsPerPixel/A}_precompileShaders(){return!!this.renderer.hasOverlays&&(this.renderer.precompileShaders(this.view.state),!0)}_drawOverlays(e,t=this.view.state){if(!this._drawTexturesDirty&&!this._drawTexturesAnimateDirty)return this.renderer;const r=this._drawTexturesDirty;this._drawTexturesDirty=this._drawTexturesAnimateDirty=!1;const s=this.renderer.computeValidity();this.renderer.releaseRenderTargets(),this.renderer.drawOverlays(t);return s!==this.renderer.computeValidity()&&this.surface.updateTileOverlayParams(M.RenderRequestType.UPDATE),r?(this.surface.requestRender(e),e===M.RenderRequestType.UPDATE&&this.surface.requestUpdate()):this.surface.requestRender(M.RenderRequestType.BACKGROUND),this.renderer}_rectanglesOverlap(e,t){return null!=e&&(this._longitudeCyclical?(this._longitudeCyclical.contains(t[0],t[2],e[0])||this._longitudeCyclical.contains(t[0],t[2],e[2])||this._longitudeCyclical.contains(e[0],e[2],t[0]))&&!(e[1]>t[3]||e[3]<t[1]):O.intersects(e,t))}_rectInsideRect(e,t){return null!=t&&(this._longitudeCyclical?this._longitudeCyclical.contains(e[0],e[2],t[0])&&this._longitudeCyclical.contains(e[0],e[2],t[2])&&t[1]>e[1]&&t[3]<e[3]:O.contains(e,t))}_pointIsInExtent(e,t){if(this._longitudeCyclical)return this._longitudeCyclical.contains(t[0],t[2],e.x)&&e.y>=t[1]&&e.y<=t[3];const r=e.x,s=e.y;return r>t[0]&&r<t[2]&&s>t[1]&&s<t[3]}_shiftExtentToFitBounds(e,t,r){let s=0,i=0;e[0]<-t?s=e[0]+t:e[2]>t&&(s=t-e[2]),e[1]<-r?i=e[1]+r:e[3]>r&&(i=r-e[3]),O.offset(e,s,i)}get test(){}},t.__decorate([l.property()],e.OverlayManager.prototype,"_spatialReference",void 0),t.__decorate([l.property({readOnly:!0})],e.OverlayManager.prototype,"running",null),t.__decorate([l.property()],e.OverlayManager.prototype,"_placementDirty",void 0),t.__decorate([l.property()],e.OverlayManager.prototype,"_contentUpdated",void 0),t.__decorate([l.property()],e.OverlayManager.prototype,"_isSpherical",null),t.__decorate([l.property()],e.OverlayManager.prototype,"_worldToPCSRatio",null),t.__decorate([l.property()],e.OverlayManager.prototype,"renderer",void 0),t.__decorate([l.property({constructOnly:!0})],e.OverlayManager.prototype,"view",void 0),t.__decorate([l.property({constructOnly:!0})],e.OverlayManager.prototype,"surface",void 0),t.__decorate([l.property()],e.OverlayManager.prototype,"suspended",null),t.__decorate([l.property()],e.OverlayManager.prototype,"updating",null),t.__decorate([l.property({type:Boolean})],e.OverlayManager.prototype,"rendersOccludedDraped",null),e.OverlayManager=t.__decorate([h.subclass("esri.views.3d.terrain.OverlayManager")],e.OverlayManager);class B{constructor(){this.inner=O.create(),this.outer=O.create(),this.mapUnitsPerPixel=0,this.pixelRatioAdjustment=1,this.stretch=V}}const j=g.create(),H=y.create(),k=new B,Y=O.create(),z=O.create(),W=f.create();var X;!function(e){e[e.NONE=0]="NONE",e[e.EXTENT=1]="EXTENT",e[e.RERENDER_ONLY=2]="RERENDER_ONLY"}(X||(X={})),Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
