/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../chunks/tslib.es6","../../../core/Evented","../../../core/has","../../../core/MapUtils","../../../core/maybe","../../../core/PooledArray","../../../core/reactiveUtils","../../../core/SetUtils","../../../core/accessorSupport/decorators/property","../../../core/Logger","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../../core/libs/gl-matrix-2/math/mat4","../../../chunks/vec32","../../../core/libs/gl-matrix-2/factories/vec3f64","../layers/interfaces","../support/debugFlags","./interfaces","./Overlay","./OverlayContent","./OverlayRenderTargets","../webgl/RenderCamera","../webgl-engine/core/shaderLibrary/ShaderOutput","../webgl-engine/core/shaderLibrary/terrain/Overlay.glsl","../../../chunks/TextureOnly.glsl","../webgl-engine/effects/RenderPlugin","../webgl-engine/effects/highlight/Highlight","../webgl-engine/lib/GLMaterialRepository","../webgl-engine/lib/GridLocalOriginFactory","../webgl-engine/lib/Material","../webgl-engine/lib/OITPass","../webgl-engine/lib/RenderContext","../webgl-engine/lib/RenderSlot","../webgl-engine/lib/ShadowMap","../webgl-engine/lib/SortedRenderGeometryRenderer","../webgl-engine/lib/TextureTechnique","../webgl-engine/lib/TextureTechniqueConfiguration","../webgl-engine/lib/Update","../webgl-engine/lib/UpdatePolicy","../webgl-engine/lighting/Lightsources","../../../chunks/OverlayCompositing.glsl","../webgl-engine/shaders/OverlayCompositingTechnique","../../support/Scheduler","../../webgl/enums","../../webgl/Texture","../../webgl/TextureDescriptor"],(function(e,r,t,s,i,n,a,o,d,l,h,c,u,p,g,_,y,m,R,v,O,T,S,b,f,w,x,C,D,P,E,M,A,I,W,q,F,G,L,N,k,V,H,U,B,z,Y){"use strict";e.OverlayRenderer=class extends x.SyncRenderPlugin{constructor(e){super(e),this._overlays=null,this._renderTargets=null,this._overlayParameters=new V.OverlayCompositingPassParameters,this.hasHighlights=!1,this._hasWater=!1,this._renderers=new Map,this._sortedDrapeSourceRenderersDirty=!1,this._sortedRenderers=new a,this._passParameters=new w.TextureOnlyPassParameters,this._materials=null,this._screenToWorldRatio=1,this._localOriginFactory=null,this.unloadedMemory=0,this.ignoresMemoryFactor=!1,this._camera=new S,this.worldToPCSRatio=1,this.events=new t,this.longitudeCyclical=null,this.produces=new Map([[I.RenderSlot.DRAPED_MATERIAL,e=>e!==b.ShaderOutput.Highlight||this.hasHighlights],[I.RenderSlot.DRAPED_WATER,()=>this._hasWater]]),this._hasTargetWithoutRasterImage=!1,this._hasDrapedFeatureSource=!1,this._hasDrapedRasterSource=!1}initialize(){const{view:e}=this,{_stage:r}=e,t=r.renderer.fboCache,s=r.renderView,{waterTextures:i,textures:n}=s;this._renderContext=new A.OverlayRenderContext(this._rctx,new W.ShadowMap(t,e.state.viewingMode)),this.addHandles([o.watch((()=>i.updating),(()=>this.events.emit("content-changed")),o.syncAndInitial),o.watch((()=>this.spatialReference),(e=>this._localOriginFactory=new P.GridLocalOriginFactory(e)),o.syncAndInitial),o.on((()=>this.view.allLayerViews),"after-changes",(()=>this._sortedDrapeSourceRenderersDirty=!0)),o.watch((()=>C.trackHighlightOptions(this.view.highlights)),(()=>this._sortedDrapeSourceRenderersDirty=!0),o.syncAndInitial)]),this._materials=new D.GLMaterialRepository(n,this._techniques,(()=>{this.notifyChange("rendersOccludedDraped"),this.events.emit("content-changed"),this.notifyChange("updating"),this.notifyChange("isEmpty")}),(()=>this.events.emit("content-changed")));const{_bindParameters:a,_camera:d}=this;a.slot=I.RenderSlot.DRAPED_MATERIAL,a.mainDepth=null,d.near=1,d.far=1e4,d.relativeElevation=null,a.camera=this._camera,a.oitPass=M.OITPass.NONE,a.updateLighting([new k.AmbientLight(_.ones())],0,0,L.Update.Immediate),this.addHandles(this.view.resourceController.scheduler.registerTask(U.TaskPriority.STAGE,this))}destroy(){this._renderers.forEach((e=>e.destroy())),this._renderers.clear(),this._passParameters.texture=n.disposeMaybe(this._passParameters.texture),this.disposeOverlays()}get _bindParameters(){return this._renderContext.bind}get _rctx(){return this.view._stage.renderView.renderingContext}get _techniques(){return this.view._stage.renderView.techniques}get rctx(){return this._rctx}get materials(){return this._materials}get screenToWorldRatio(){return this._screenToWorldRatio}get localOriginFactory(){return this._localOriginFactory}get pluginContext(){return this._pluginContext}initializeRenderContext(e){this._pluginContext=e,this._techniques.precompile(H.OverlayCompositingTechnique)}uninitializeRenderContext(){}acquireTechniques(){return[]}render(){}get updating(){return this._sortedDrapeSourceRenderersDirty||i.someMap(this._renderers,(e=>e.updating))}get hasOverlays(){return null!=this._overlays&&null!=this._renderTargets}getMaterialRenderer(e){for(const r of this._renderers.values()){const t=r.getMaterialRenderer(e);if(t)return t}return null}get layers(){return this._sortedDrapeSourceRenderersDirty&&this._updateSortedDrapeSourceRenderers(),this._sortedRenderers.map((e=>e.drapeSource.layer)).filter((e=>!!e))}createGeometryDrapeSourceRenderer(e){return this.createDrapeSourceRenderer(e,q.SortedRenderGeometryRenderer)}createDrapeSourceRenderer(e,r,t){const s=this._renderers.get(e);null!=s&&s.destroy();const i=new r({...t,rendererContext:this,drapeSource:e});return this._renderers.set(e,i),this._sortedDrapeSourceRenderersDirty=!0,"fullOpacity"in e&&this.addHandles(o.watch((()=>e.fullOpacity),(()=>this.events.emit("content-changed"))),e),i}removeDrapeSourceRenderer(e){if(null==e)return;const r=this._renderers.get(e);null!=r&&(this._sortedDrapeSourceRenderersDirty=!0,this._renderers.delete(e),this.removeHandles(e),r.destroy())}computeValidity(){return this._renderTargets?.computeValidity()??0}releaseRenderTargets(){this._renderTargets?.dispose()}get overlays(){return this._overlays??[]}ensureDrapeTargets(e){this._hasTargetWithoutRasterImage=!!this._overlays&&d.someSet(e,(e=>e.drapeTargetType===y.DrapeTargetType.WithoutRasterImage))}ensureDrapeSources(e){this._overlays?(this._hasDrapedFeatureSource=d.someSet(e,(e=>e.drapeSourceType===y.DrapeSourceType.Features)),this._hasDrapedRasterSource=d.someSet(e,(e=>e.drapeSourceType===y.DrapeSourceType.RasterImage))):this._hasDrapedFeatureSource=this._hasDrapedRasterSource=!1}get _needsColorWithoutRasterImage(){return this._hasDrapedRasterSource&&this._hasDrapedFeatureSource&&this._hasTargetWithoutRasterImage}ensureOverlays(e,r,t=this._bindParameters.overlayStretch){null==this._overlays&&(this._renderTargets=new T.OverlayRenderTargets(this.view._stage.renderer.fboCache),this._overlays=[new v.Overlay,new v.Overlay]),this.ensureDrapeTargets(e),this.ensureDrapeSources(r),this._bindParameters.overlayStretch=t}disposeOverlays(){this._overlays=null,this._renderTargets=n.disposeMaybe(this._renderTargets),this.events.emit("textures-disposed")}getTexture(e){if(null!=e)return e===O.OverlayContent.ColorNoRasterImage&&!this._needsColorWithoutRasterImage&&this._hasDrapedFeatureSource?this._renderTargets?.getTexture(O.OverlayContent.Color):this._renderTargets?.getTexture(e)}get running(){return this.updating}runTask(e){this._processDrapeSources(e,(()=>!0))}_processDrapeSources(e,r){let t=!1;for(const[s,i]of this._renderers){if(e.done)break;(s.destroyed||r(s))&&(i.commitChanges()&&(t=!0,e.madeProgress()))}this._sortedDrapeSourceRenderersDirty&&(this._sortedDrapeSourceRenderersDirty=!1,t=!0,this._updateSortedDrapeSourceRenderers()),t&&(null!=this._overlays&&0===this._renderers.size&&this.disposeOverlays(),this.notifyChange("updating"),this.notifyChange("isEmpty"),this.events.emit("content-changed"),this.hasHighlights=i.someMap(this._renderers,(e=>e.hasHighlights)),this.notifyChange("rendersOccludedDraped"),this._updateHasWater())}processSyncDrapeSources(){this._processDrapeSources(U.noBudget,(e=>e.updatePolicy===N.UpdatePolicy.SYNC))}get isEmpty(){return!m.debugFlags.OVERLAY_DRAW_DEBUG_TEXTURE&&!i.someMap(this._renderers,(e=>!e.isEmpty))}get hasWater(){return this._hasWater}get rendersOccludedDraped(){const e=this._renderContext.renderOccludedMask;this._renderContext.renderOccludedMask=J,++this._techniques.precompiling;const r=this._sortedRenderers.some((({renderer:e})=>e.precompile(this._renderContext)));return--this._techniques.precompiling,this._renderContext.renderOccludedMask=e,r}renders(e){if(m.debugFlags.OVERLAY_DRAW_DEBUG_TEXTURE&&e!==O.OverlayContent.Occluded&&e!==O.OverlayContent.Highlight)return!0;++this._techniques.precompiling;const r=this._sortedRenderers.some((({renderer:e})=>e.precompile(this._renderContext)));return--this._techniques.precompiling,r}get mode(){return this.isEmpty?f.OverlayMode.Disabled:this._renderTargets?.getTexture(O.OverlayContent.WaterNormal)?f.OverlayMode.EnabledWithWater:this._renderTargets?.getTexture(O.OverlayContent.Color)?f.OverlayMode.Enabled:f.OverlayMode.Disabled}updateAnimation(e){let r=!1;return this._renderers.forEach((t=>r=t.updateAnimation(e)||r)),r}updateDrapeSourceOrder(){this._sortedDrapeSourceRenderersDirty=!0}precompileShaders(e){if(this._renderTargets){this._bindParameters.alignPixelEnabled=e.alignPixelEnabled,this._bindParameters.highlightGroupName=null,++this._techniques.precompiling;for(const e of this._renderTargets.targets){if(e.content===O.OverlayContent.ColorNoRasterImage&&!this._needsColorWithoutRasterImage)continue;const r=e.output;this._renderContext.output=r,this._bindParameters.slot=r===b.ShaderOutput.Normal?I.RenderSlot.DRAPED_WATER:I.RenderSlot.DRAPED_MATERIAL,e.content===O.OverlayContent.Occluded&&(this._renderContext.renderOccludedMask=J),this._sortedRenderers.forAll((({drapeSource:r,renderer:t})=>{e.content===O.OverlayContent.ColorNoRasterImage&&r.drapeSourceType===y.DrapeSourceType.RasterImage||t.precompile(this._renderContext)})),this._renderContext.renderOccludedMask=A.defaultRenderOccludedMask}--this._techniques.precompiling}}drawOverlays(e){if(this._overlays&&this._renderTargets){for(const e of this._overlays)this.longitudeCyclical?e.setupGeometryViewsCyclical(this.longitudeCyclical):e.setupGeometryView();this._bindParameters.alignPixelEnabled=e.alignPixelEnabled;for(const r of this._renderTargets.targets){if(r.content===O.OverlayContent.ColorNoRasterImage&&!this._needsColorWithoutRasterImage)continue;const t=this._drawTarget(R.OverlayIndex.INNER,r,e),s=this._drawTarget(R.OverlayIndex.OUTER,r,e);(t||s)&&r.fbo.generateMipMap()}}}_drawTarget(e,r,t){const s=this._overlays[e],i=s.canvasGeometries;if(0===i.numViews)return!1;const{contentPixelRatio:n}=t;this._screenToWorldRatio=n*s.mapUnitsPerPixel/this._bindParameters.overlayStretch;const a=r.output;if(this.isEmpty||a===b.ShaderOutput.Normal&&!this.hasWater||!s.hasSomeSizedView())return!1;const{_rctx:o,_bindParameters:d}=this;if(this._camera.pixelRatio=s.pixelRatio*n,this._renderContext.output=a,d.screenToWorldRatio=this._screenToWorldRatio,d.screenToPCSRatio=this._screenToWorldRatio*this.worldToPCSRatio,d.slot=a===b.ShaderOutput.Normal?I.RenderSlot.DRAPED_WATER:I.RenderSlot.DRAPED_MATERIAL,r.content===O.OverlayContent.Occluded&&(this._renderContext.renderOccludedMask=J),d.highlightGroupName=null,!this.renders(r.content))return this._renderContext.renderOccludedMask=A.defaultRenderOccludedMask,!1;const{resolution:l}=s,h=e===R.OverlayIndex.INNER?0:l;o.setViewport(h,0,l,l),this._bindTargetFBO(r),e===R.OverlayIndex.INNER&&(o.setClearColor(0,0,0,0),o.clear(B.FramebufferBit.COLOR));if(m.debugFlags.OVERLAY_DRAW_DEBUG_TEXTURE&&r.content!==O.OverlayContent.Occluded&&r.content!==O.OverlayContent.Highlight){this._techniques.precompile(F.TextureTechnique,K);const r=this._techniques.acquire(F.TextureTechnique,K);for(let t=0;t<i.numViews;t++)this._setViewParameters(i.extents[t],s),this._ensureDebugPatternResources(s.resolution,j[e]),o.bindTechnique(r,d,this._passParameters),o.screen.draw();r.release()}if(r.output===b.ShaderOutput.Highlight){const{fboCache:t}=this.view._stage.renderer,s=this._resolution;C.renderHighlightBuffer(o,t,{width:s,height:s},this.view.highlights,d,(()=>this._renderAllGeometry(e,r)),h,(()=>this._bindTargetFBO(r)))}else this._renderAllGeometry(e,r);return o.bindFramebuffer(null),this._renderContext.renderOccludedMask=A.defaultRenderOccludedMask,!0}_renderAllGeometry(e,r){const t=this._overlays[e],s=t.canvasGeometries;this._sortedRenderers.forAll((({drapeSource:i,renderer:n})=>{if(r.content===O.OverlayContent.ColorNoRasterImage&&i.drapeSourceType===y.DrapeSourceType.RasterImage)return;const{fullOpacity:a}=i,o=null!=a&&a<1&&r.output===b.ShaderOutput.Color&&this._bindTemporaryFBO();for(let e=0;e<s.numViews;e++)this._setViewParameters(s.extents[e],t),n.render(this._renderContext);if(o){this._bindTargetFBO(r),this._overlayParameters.texture=o.getTexture(),this._overlayParameters.opacity=a,this._overlayParameters.overlayIndex=e;const t=this._techniques.acquire(H.OverlayCompositingTechnique);this._rctx.bindTechnique(t,this._bindParameters,this._overlayParameters),this._rctx.screen.draw(),t.release(),o.release()}}))}_bindTargetFBO(e){const r=this._resolution,t=2*r;e.fbo.bind(this._rctx,t,r)}_bindTemporaryFBO(){const e=this._resolution,r=2*e,t=this.view._stage.renderer.fboCache,s=t.acquire(r,e,"overlay tmp");return t.rctx.bindFramebuffer(s.fbo),t.rctx.clear(B.FramebufferBit.COLOR),s}get _resolution(){return this._overlays?.[R.OverlayIndex.INNER].resolution??0}notifyContentChanged(){this.events.emit("content-changed")}intersect(e,r,t,s){this._sortedDrapeSourceRenderersDirty&&this._updateSortedDrapeSourceRenderers();let i=0;for(const{renderer:n}of this._sortedRenderers)i=n.intersect?.(e,r,t,s,i)??i}_updateSortedDrapeSourceRenderers(){if(this._sortedRenderers.clear(),0===this._renderers.size)return;const e=this.view.map.allLayers,r=e.length;this._renderers.forEach(((t,s)=>{const i=e.indexOf(s.layer),n=i>=0,a=s.renderGroup??(n?y.DrapedRenderGroup.MapLayer:y.DrapedRenderGroup.ViewLayer),o=r*a+(n?i:0);this._sortedRenderers.push(new X(s,t,o))})),this._sortedRenderers.sort(((e,r)=>e.index-r.index))}_setViewParameters(e,r){const t=this._camera;t.viewport=[0,0,r.resolution,r.resolution],p.ortho(t.projectionMatrix,0,e[2]-e[0],0,e[3]-e[1],t.near,t.far),p.fromTranslation(t.viewMatrix,[-e[0],-e[1],0])}_updateHasWater(){const e=i.someMap(this._renderers,(e=>e.hasWater));e!==this._hasWater&&(this._hasWater=e,this.events.emit("has-water"))}_ensureDebugPatternResources(e,r){if(g.set(this._passParameters.color,r[0],r[1],r[2]),this._passParameters.texture)return;const t=new Uint8Array(e*e*4);let s=0;for(let n=0;n<e;n++)for(let r=0;r<e;r++){const i=Math.floor(r/10),a=Math.floor(n/10);i<2||a<2||10*i>e-20||10*a>e-20?(t[s++]=255,t[s++]=255,t[s++]=255,t[s++]=255):(t[s++]=255,t[s++]=255,t[s++]=255,t[s++]=1&i&&1&a?1&r^1&n?0:255:1&i^1&a?0:128)}const i=new Y.TextureDescriptor(e);i.samplingMode=B.TextureSamplingMode.NEAREST,this._passParameters.texture=new z.Texture(this._rctx,i,t)}get test(){}},r.__decorate([l.property()],e.OverlayRenderer.prototype,"hasHighlights",void 0),r.__decorate([l.property()],e.OverlayRenderer.prototype,"_sortedDrapeSourceRenderersDirty",void 0),r.__decorate([l.property({constructOnly:!0})],e.OverlayRenderer.prototype,"view",void 0),r.__decorate([l.property({readOnly:!0})],e.OverlayRenderer.prototype,"_techniques",null),r.__decorate([l.property()],e.OverlayRenderer.prototype,"worldToPCSRatio",void 0),r.__decorate([l.property()],e.OverlayRenderer.prototype,"spatialReference",void 0),r.__decorate([l.property({type:Boolean,readOnly:!0})],e.OverlayRenderer.prototype,"updating",null),r.__decorate([l.property()],e.OverlayRenderer.prototype,"isEmpty",null),r.__decorate([l.property({readOnly:!0})],e.OverlayRenderer.prototype,"rendersOccludedDraped",null),e.OverlayRenderer=r.__decorate([u.subclass("esri.views.3d.terrain.OverlayRenderer")],e.OverlayRenderer);class X{constructor(e,r,t){this.drapeSource=e,this.renderer=r,this.index=t}}const j=[[1,.5,.5],[.5,.5,1]],Z=-2,J=E.RenderOccludedFlag.OccludeAndTransparent,K=new G.TextureTechniqueConfiguration;K.hasAlpha=!0,e.drapedZ=Z,e.overlayRenderOccludedFlag=J,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
