/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../core/arrayUtils","../../../core/has","../../../core/mathUtils","../../../core/maybe","../../../chunks/vec32","../../../core/libs/gl-matrix-2/factories/vec3f64","../../../geometry/support/aaBoundingRect","../../../geometry/support/Ellipsoid","../support/buffer/glUtil","./GeometryState","./interfaces","./LayerClass","./NeighborIndex","./PatchGeometry","./TerrainConst","./terrainUtils","./TextureFader","./TextureReference","./TileOverlayData","./tileUtils","../webgl-engine/lib/VertexArrayObject","../webgl-engine/shaders/TerrainTechnique","../../webgl/BufferObject","../../webgl/enums"],(function(e,t,r,i,s,n,a,l,o,d,g,h,c,u,m,f,y,p,x,_,A,v,b,C,E){"use strict";class T{constructor(){this.geometry=new m.PatchGeometry,this.intersectionData=null,this.geometryState=null,this._vao=null,this._texture=null,this._textureOpacity=1,this._textureRef=new p.TextureFader((()=>this._tile.surface.fadeDuration)),this.overlay=new _,this._localOrigin=null,this._geometryStateChangedSinceLastUpdate=!0,this._hasGeometry=!1,this._modifiedFlags=0}get tile(){return this._tile}get localOrigin(){return this._localOrigin}init(e,t){this.clear(),this._tile=e,this.geometry.reset(),this.intersectionData=null,this.geometryState=new g.GeometryState,this._localOrigin=t,this.overlay.clear()}clear(){this.releaseGeometry(),this.releaseTexture(),this._textureRef.clear(),this._tile=null,this.intersectionData=null,this.geometryState=null}updateGeometryIfNeeded(e){if((!this._vao||this._geometryStateChangedSinceLastUpdate||this.wireframeChanged||this.clippingAreaChanged||this.samplerDataChanged||this.numVerticesPerSideChanged||this.dirtyCorners||this.dirtyEdgeResolutions||this.dirtyEdges)&&(this._updateGeometry(e),this._geometryStateChangedSinceLastUpdate=!1),y.enableTerrainInternalChecks&&this.tile.intersectsClippingArea)for(let t=0;t<4;++t)y.internalAssert(this.geometry.getEdgeCount(t)===this.geometryState.edgeResolutions[t]+1)}_calculateEdgeResolution(e,t){const r=this.tile,i=this.geometryState.numVerticesPerSide-1;if(!r.surface.isGlobal){const t=r.surface.extent;if(null!=t&&(0===e&&r.extent[3]>t[3]||1===e&&r.extent[2]>t[2]||2===e&&r.extent[1]<t[1]||3===e&&r.extent[0]<t[0]))return i}const s=r.level,n=y.neighborEdgeIndices[e];if(!t)return y.internalAssert(null==r.surface?.rootTiles||r.surface.updatingRootTiles||!r.shouldHaveNeighbor(n)),i;if(t.loaded){const r=t,n=r.renderData.geometryState,a=s-r.level;if(y.internalAssert(a>=0),0===a){const e=n.numVerticesPerSide-1;return Math.max(e,i)}const l=2**a,o=n.edgeResolutions[(e+2)%4]/l;return Math.max(1,o)}y.internalAssert(!t.leaf);let a=i;return t.forAllSubtreeOnSide(y.oppositeEdge(n),(e=>e===r||(e.loaded?(a=Math.max(a,2**(e.level-s)),!0):(y.internalAssert(!e.leaf),!1)))),a}updateNeighborData(){const e=this.tile;if(!e.intersectsClippingArea)return;const t=e.renderData.geometryState,r=t=>(t.loaded||t.level===e.level)&&t?.intersectsClippingArea,s=t.edgePeerNeighbors,n=t.edgePeerNeighborSamplerVersions;for(let a=0;a<4;++a){const l=e.findNeighborTile(y.neighborEdgeIndices[a],r),o=P(e,l),d=o?.renderData?.geometryState.samplerDataVersion??-1,g=s[a],h=o!==P(e,g),c=n[a]!==d;y.enableTerrainInternalChecks&&l&&(y.internalAssert(e.level>=l.level),y.internalAssert(e.level-l.level<=f.maxTileNeighborLevelDelta)),s[a]=l,(h||c)&&(n[a]=d,this._markEdgeDirty(a));const u=t.edgeResolutions[a],m=this._calculateEdgeResolution(a,l);y.internalAssert(i.isPowerOfTwo(m)),y.internalAssert(m>=1),t.edgeResolutions[a]=m,u!==m&&this._markEdgeResolutionDirty(a)}for(let i=0;i<4;++i){const n=e.findNeighborTile(y.neighborCornerIndices[i],r);t.cornerPeerNeighbors[i]=n;const a=P(e,s[i]),l=P(e,s[(i+1)%4]),o=P(e,n);I[i]=o,I[(i+1)%4]=l,I[(i+2)%4]=e,I[(i+3)%4]=a,y.internalAssert(I.some((t=>t?.loaded||t===e)));const d=I.reduce(((e,t)=>Math.min(e,t?.level??1/0)),1/0);I.forEach(((e,t)=>{e&&e?.level>d&&(I[t]=null)})),y.internalAssert(I.some((t=>t?.loaded||t===e)));const g=t.cornerNeighborCornerTiles,h=t.cornerNeighborCornerTileSamplerVersions;for(let e=0;e<4;++e){const t=I[e],r=t?.renderData.geometryState.samplerDataVersion??-1,s=4*i+e,n=g[s]!==t,a=!n&&h[s]!==r;(n||a)&&(g[s]=t,h[s]=r,this._markCornerDirty(i))}y.enableTerrainInternalChecks&&y.internalAssert(U.some((t=>g[4*i+t]?.loaded||g[4*i+t]===e)))}y.enableTerrainInternalChecks&&y.internalAssert(this.geometryState.edgeResolutions.every((e=>e>0)));for(let i=0;i<4;++i)I[i]=null}_updateGeometry(e){if(!this.tile.intersectsClippingArea)return;y.enableTerrainInternalChecks&&y.internalAssert(!this.tile.intersectsClippingArea||this.geometryState.edgeResolutions.every((e=>e>0))),this.intersectionData=null;const{tile:t,_vao:r,geometry:i,geometryState:s}=this,n=!r||!{geometry:i}||this.wireframeChanged||this.samplerDataChanged||this.clippingAreaChanged||this.numVerticesPerSideChanged,a=0!==this.dirtyEdgeResolutions,l=s.edgeResolutions.reduce(((e,t)=>e+t+1),0),o=n||a&&l>(i?.maxEdgeVertexCount??0),d=!o&&a,g=!d&&(0!==this.dirtyEdges||a),h=!g&&0!==this.dirtyCorners;o?(this.releaseGeometry(),this._createGeometry(e)):d?t.updateEdgeElevationsAndResolutions():g||h?t.updateEdgeElevations():h?t.updateCornerElevations():console.warn("Update for no reason?"),this._modifiedFlags=0}get hasGeometry(){return this._hasGeometry}releaseGeometry(){return this._hasGeometry=!1,this.intersectionData=null,!!this._vao&&(this._vao=s.disposeMaybe(this._vao),this.geometry.release(),!0)}ensureTexture(e,t,r,i){const s=t?E.PixelFormat.RGBA:E.PixelFormat.RGB;return null!=this._texture&&(r===h.TextureUpdate.FADING&&this._tile.surface.fadeDuration>0&&this._isTextureVisible(this._texture)||this._texture.descriptor.width!==e||this._texture.descriptor.pixelFormat!==s)&&this.releaseTexture(),null==this._texture&&(this._texture=i(),this.tile.setMemoryDirty()),this._texture}releaseTexture(){null!=this._texture&&(this._texture.release(),this._texture=null,this.tile.setMemoryDirty())}reuseTexture(e,t){return!(!e||!this._texture)&&(e.setTextureReference(new x.TextureReference(this._texture,h.TextureUpdate.FADING,t,this._textureOpacity,0,1)),!0)}get numVerticesPerSideChanged(){return!!(this._modifiedFlags&O)}get samplerDataChanged(){return!!(this._modifiedFlags&F)}get clippingAreaChanged(){return!!(this._modifiedFlags&G)}get wireframeChanged(){return!!(this._modifiedFlags&j)}get dirtyEdges(){return this._modifiedFlags>>L&15}get dirtyCorners(){return this._modifiedFlags>>M&15}get dirtyEdgeResolutions(){return this._modifiedFlags>>k&15}_markCornerDirty(e){const t=1<<e<<M;this._modifiedFlags|=t}_markEdgeDirty(e){const t=1<<e<<L;this._modifiedFlags|=t,this._markCornerDirty((e+0)%4),this._markCornerDirty((e+3)%4)}_markEdgeResolutionDirty(e){const t=1<<e<<k;this._modifiedFlags|=t,this._markEdgeDirty(e)}_markAllEdgesAndCornersDirty(){this._modifiedFlags|=15<<M|15<<L|15<<k}updateGeometryState(){const e=this._elevationInfo,r=this.tile,i=e.samplerData?r.getElevationVerticesPerSide(e.maxTileLevel):r.minimumVerticesPerSide,s=Math.max(i,5);let n=r.clippingArea;r.intersectsClippingArea&&!r.withinClippingArea||(n=null);const a=this.geometryState;let l=!1;a.numVerticesPerSide!==s&&(this._modifiedFlags|=1,a.numVerticesPerSide=s,a.samplerDataVersion++,l=!0),e.changed&&(this._modifiedFlags|=2,a.samplerData=e.samplerData,a.samplerDataVersion++,l=!0),t.equals(a.clippingArea,n)||(this._modifiedFlags=4,a.clippingArea=n,l=!0);const o=r.surface.wireframe;return a.wireframe!==o&&(this._modifiedFlags=8,a.wireframe=o,l=!0),this._geometryStateChangedSinceLastUpdate||=l,l&&this._markAllEdgesAndCornersDirty(),this._hasGeometry=!0,this._geometryStateChangedSinceLastUpdate}_createGeometry(e){this.tile.createGeometry();const t=this.geometry.vertexAttributes,r=this.geometry.indices,i=e.gl;this._vao=new v.VertexArrayObject(e,b.vertexAttributeLocations,new Map([["geometry",d.glLayout(t.layout)]]),new Map([["geometry",C.BufferObject.createVertex(e,i.STATIC_DRAW,t.buffer)]]),C.BufferObject.createIndex(e,i.STATIC_DRAW,r)),this._hasGeometry=!0}get vao(){return this._vao}setTextureReference(e,t=p.ActivationTime.Immediate){e?.texture===this._texture?this._textureOpacity=e.opacities[0]:this.releaseTexture(),this._textureRef.push(e,t)}get textureReference(){return this._textureRef.current}get nextTextureReference(){return this._textureRef.next}get textureFadeFactor(){return this._textureRef.fadeFactor}get textureIsFading(){return this._textureRef.isFading}_isTextureVisible(e){return this._textureRef.current?.texture===e||this._textureRef.next?.texture===e&&this._textureRef.fadeFactor<1}get _elevationInfo(){const e=this.geometryState.samplerData,t=this.tile.layerInfo[c.LayerClass.ELEVATION],r=t.length,i=new Array(r);let s=0,n=0,a=!1;for(let d=0;d<r;d++){const r=t[d],l=r.upsampleInfo?.tile;if(l){const t=l.layerInfo[c.LayerClass.ELEVATION][d].data,r=t&&t.samplerData;e&&e[s]===r||(a=!0),i[s++]=r,n=Math.max(n,l.lij[0])}else if(r.data){const t=this.tile.surface.layerViewByIndex(d,c.LayerClass.ELEVATION);if(A.fallsWithinLayerView(this.tile,t)){const t=r.data;e&&e[s]===t.samplerData||(a=!0),i[s++]=t.samplerData,n=this.tile.level}}}null!=e&&e.length!==s&&(a=!0);const l=s>0,o=l?i:null;return l&&(i.length=s),{changed:a,samplerData:o,maxTileLevel:n}}get estimatedGeometryMemoryUsage(){const e=this.intersectionData?.estimatedMemoryUsage??0;return(this.geometry.indices?.byteLength??0)+(this.geometry.vertexAttributes?.byteLength??0)+e}get texture(){return this._texture}get test(){}checkGeometryWaterproofness(){if(!y.enableTerrainInternalChecks)return;const e=this.tile;if(!e.loaded||!e.intersectsClippingArea||0===e.level)return void y.internalAssert(e?.loaded);const t=e.surface.extent;if(null!=t&&!e.intersectsExtent(t))return;const r=y.neighborEdgeIndices.map(((r,i)=>null!=t&&(i<2?-1:1)*(e.extent[3-i]-t[3-i])<0)),s=e.level;y.internalAssert(0===this.dirtyCorners),y.internalAssert(0===this.dirtyEdges),y.internalAssert(0===this.dirtyEdgeResolutions),y.internalAssert(!this.numVerticesPerSideChanged),y.internalAssert(!this.samplerDataChanged),y.internalAssert(!this.clippingAreaChanged),y.internalAssert(!this.wireframeChanged);const d=y.neighborCornerIndices.map((t=>e.findNeighborCornerTileExact(t,(t=>!t.intersectsClippingArea||t.loaded||t.level===e.level))??null)).map((e=>e?.intersectsClippingArea?e:null)),g=this.geometryState;for(let i=0;i<4;++i){const t=g.cornerPeerNeighbors[i],r=d[i];y.internalAssert(r===t,`Tile[${e.lij}].corner[${i}] out of date: cur=[${t?.lij}] exp=[${r?.lij}]`)}y.neighborEdgeIndices.forEach(((t,d)=>{if(r[d])return;const g=e.findNeighborTile(t,(e=>(e.level===s||e?.loaded)&&e?.intersectsClippingArea));if(!g){const r=!e.surface.updatingRootTiles&&null!=e.surface.rootTiles&&e.surface.rootTiles.length>0&&e.shouldHaveNeighbor(t);return void y.internalAssert(!r)}y.internalAssert(g.loaded||g.level===e.level),y.internalAssert(g===this.geometryState.edgePeerNeighbors[d]);const h=s-g.level;if(!g.loaded)return y.internalAssert(!g.leaf),void y.internalAssert(0===h);const c=g.renderData;y.internalAssert(e.isEdgeNeighbor(g,t)),y.internalAssert(h>=0);const m=2**h;if(h<0)return void y.internalAssert(!1);const f=e.renderData,p=f.geometry,x=f.localOrigin,_=p.getEdgeCount(d),A=p.numVerticesPerSide-1,v=c.geometry;if(!v)return void y.internalAssert(!1);const b=c.localOrigin,C=this.geometryState.edgePeerNeighbors[d];if(C?.loaded){const e=C.renderData;y.internalAssert(f.geometryState.edgePeerNeighborSamplerVersions[d]===e.geometryState.samplerDataVersion),y.internalAssert(this.geometryState.edgePeerNeighborSamplerVersions[d]===e.geometryState.samplerDataVersion)}const E=(d+2)%4,T=v.getEdgeCount(E),I=_-1,P=T-1;y.internalAssert(I*m===P,`Tile[${e.lij}]:e${d},res=${I} edgeRes mismatch with Neighbor[${g.lij}]:e${E},res=${P} (expected:${I*m})`);const O=e.extent,F=t===u.NeighborIndex.NORTH||t===u.NeighborIndex.SOUTH,G=T-1,j=G>>h,L=_-1;if(j<1)return void y.internalAssert(1===L);y.internalAssert(j===L),y.internalAssert(i.isPowerOfTwo(j));const M=v.numVerticesPerSide-1;y.internalAssert(h>0||j===Math.max(M,A));const k=e.getNeighborEdgeStartVertexIndex(d,g);y.internalAssert(0<=k&&k<m);const U=k*j;y.internalAssert(0<=U&&U<=G-j);let B=0,X=U;p.getEdgeVertexPosition(d,S,x,0),p.getEdgeVertexPosition(d,$,x,_-1);const H=n.distance(S,$),W=Math.max(N,1e-4*H);for(let r=0;r<=j;++r){p.getEdgeVertexPosition(d,S,x,B),v.getEdgeVertexPosition(E,$,b,X);const i=r/j,s=F?O[0]+i*(O[2]-O[0]):t===u.NeighborIndex.WEST?O[0]:O[2],h=F?t===u.NeighborIndex.SOUTH?O[1]:O[3]:O[1]+i*(O[3]-O[1]),m=e.surface.extent;if(null==m||l.containsXY(m,s,h)){const t=n.dist(S,$),r=n.len(S)-o.earth.radius,i=n.len($)-o.earth.radius,l=t<W;if(!l){console.warn(`Tile edge vertex position mismatch: between [${e.lij}].edge${d}[${B}/${_}] and [${g.lij}].edge${E}[${X}/${T}]`),null!=m&&console.warn("  surface extent= ",m," x,y=",s,",",h);const o=a.create();n.subtract(o,f.localOrigin,c.localOrigin),n.len(o)>0&&console.warn(`   localOrigins: ${f.localOrigin} vs ${c.localOrigin} d=${n.len(o)} [${o}]`);(()=>{const t=a.clone(S),r=a.clone($);e.updateEdgeElevations(),g.updateEdgeElevations(),p.getEdgeVertexPosition(d,S,x,B),v.getEdgeVertexPosition(E,$,b,X);const i=a.create();n.sub(i,S,t),n.len(i)>0&&console.warn(`  XXX Tile[${e.lij}] edge out of date: ${t} vs ${S} d=${n.len(i)} [${i}]`),n.sub(i,$,r),n.len(i)>0&&console.warn(`  XXX Neighbor[${g.lij}] edge out of date: ${r} vs ${$} d=${n.len(i)} [${i}]`)})();const u=p.getEdgeCount(d),A=v.getEdgeCount(T);y.internalAssert(l,`Mismatch in tile [${e.lij}].edge[${d}][${B}/${u}] vs neighbor [${g.lij}].edge[${E}][${X}/${A}] ${y.v32s(S)} vs ${y.v32s($)}  dist=${t} h(t|n|d)=${r}|${i}|${i-r}`)}p.getEdgeNormal(d,D,B),v.getEdgeNormal(E,R,X),n.normalize(V,D),n.normalize(w,R);const u=n.dot(V,w),A=1-u<.01||!1||e===g;if(!A){const t=a.create();n.sub(t,D,R);const r=()=>`Mismatch in tile edge normal ${y.lij2s(e.lij)} (${B}/${_-1}) edge ${d} vs neighbor ${y.lij2s(g.lij)}  (${X}/${T-1}) nedge ${E} :${y.v32s(D)} vs ${y.v32s(R)}  dot = ${u} : ${y.v32s(t)}`;console.warn("Mismatch in tile edge normal: ",r());{e.updateEdgeElevations(),g.updateEdgeElevations();const t=a.create(),r=a.create();p.getEdgeNormal(d,t,B),v.getEdgeNormal(E,r,X),n.equals(D,t)||console.warn("Missing update in tile normal: ",y.v32s(D)," => ",y.v32s(t)),n.equals(R,r)||console.warn("Missing update in neighbor normal: ",y.v32s(R)," => ",y.v32s(r))}y.internalAssert(A,r())}}B+=1,X+=1}}))}}const S=a.create(),$=a.create(),D=a.create(),R=a.create(),V=a.create(),w=a.create(),N=1,I=[null,null,null,null];function P(e,t){return t?.loaded||t===e?t:null}const O=1,F=2,G=4,j=8,L=4,M=8,k=12,U=[0,1,2,3];Object.defineProperty(e,"ActivationTime",{enumerable:!0,get:()=>p.ActivationTime}),e.PatchRenderData=T,e.neighborTileIfLoadedOrSelf=P,e.zeroToFour=U,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
