/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../core/maybe","../../../chunks/RasterColorizer.glsl","../../webgl/enums","../../webgl/rasterUtils"],(function(e,t,r,s,i){"use strict";const o={bandCount:3,outMin:0,outMax:1,minCutOff:[0,0,0],maxCutOff:[255,255,255],factor:[1/255,1/255,1/255],useGamma:!1,gamma:[1,1,1],gammaCorrection:[1,1,1],colormap:null,colormapOffset:null,stretchType:"none",type:"stretch"};class a{constructor(e,t,r=null,s=null){this.lij=e,this.type="raster-tile",this._memoryUsed=null,this._source=null,this._symbolizerParameters=null,this._bandIds=null,this._interpolation=null,this._dirty=!1,this._transformGrid=null,this.isRendereredSource=!1,this.symbolizerRenderer=null,this.rawPixelData=null,this.opacity=1,this.source=t,this.width=r||t.width,this.height=s||t.height}get source(){return this._source}set source(e){this._source=e,this._rasterTexture=t.disposeMaybe(this._rasterTexture),this._memoryUsed=null}get symbolizerParameters(){return this.isRendereredSource?{...o,maxCutOff:[1,1,1],factor:[1,1,1]}:this._symbolizerParameters||o}set symbolizerParameters(e){this._symbolizerParameters=e}get bandIds(){return this._bandIds}set bandIds(e){if(null!=e&&e.length>0){this._bandIds&&e.every(((e,t)=>!!this._bandIds?.[t]&&e===this._bandIds[t]))||(this._bandIds=e,this._dirty=!0)}else this._bandIds=null}get interpolation(){return this._interpolation||"nearest"}set interpolation(e){if(this._interpolation=e,null!=this._rasterTexture){const t=this._getRasterTextureInterpolation(e);this._rasterTexture.setSamplingMode("bilinear"===t?s.TextureSamplingMode.LINEAR:s.TextureSamplingMode.NEAREST)}}get transformGrid(){return this._transformGrid}set transformGrid(e){this._transformGrid=e,this._transformGridTexture=t.disposeMaybe(this._transformGridTexture),this._memoryUsed=null}bind(e){return!!(this.source&&this.source.pixels&&this.source.pixels.length>0)&&((null==this._rasterTexture||this._dirty)&&this._updateRasterTexture(e,this.bandIds),null!=this._rasterTexture&&(this._updateColormapTexture(e),this.transformGrid&&null==this._transformGridTexture&&(this._transformGridTexture=i.createTransformTexture(e,this.transformGrid))),!0)}getUniforms(){const{symbolizerParameters:e,transformGrid:t,width:s,height:o,opacity:a}=this,l=i.getCommonUniforms(t,[s,o],[this.source.width,this.source.height],a),n=i.getColormapUniforms(e.colormap,e.colormapOffset),h="stretch"===this.symbolizerParameters.type?i.getStretchUniforms(this.symbolizerParameters):null,u="hillshade"===this.symbolizerParameters.type?i.getShadedReliefUniforms(this.symbolizerParameters):null;return new r.ColorizerUniforms(l,n,h||u,this._rasterTexture,this._transformGridTexture,this._colormapTexture)}get isBilinearWithStretchColorRamp(){const{symbolizerParameters:e}=this;return"bilinear"===this.interpolation&&null!=e.colormap&&"stretch"===e.type}get memoryUsage(){if(null==this._memoryUsed){const e=[this._rasterTexture,this._transformGridTexture,this._colormapTexture];this._memoryUsed=e.map((e=>null!=e?e.descriptor.width*e.descriptor.height*4:0)).reduce(((e,t)=>e+t),0)}return this._memoryUsed}release(){return this._rasterTexture=t.disposeMaybe(this._rasterTexture),this._transformGridTexture=t.disposeMaybe(this._transformGridTexture),this._colormapTexture=t.disposeMaybe(this._colormapTexture),this.source=null,this.transformGrid=null,this.rawPixelData=null,!0}_updateRasterTexture(e,r){const s=this.source?this.source.extractBands(r):null;if(!(s?.pixels&&s.pixels.length>0))return void(this._rasterTexture=t.disposeMaybe(this._rasterTexture));const o=null==r&&null==this.bandIds||null!=r&&null!=this.bandIds&&r.join("")===this.bandIds.join("");if(null!=this._rasterTexture&&o)return;this._rasterTexture=t.disposeMaybe(this._rasterTexture);const a=this._getRasterTextureInterpolation(this.interpolation);this._rasterTexture=i.createRasterTexture(e,s,a,this.isRendereredSource||this.hasStretchTypeNone())}hasStretchTypeNone(){return"stretchType"in this.symbolizerParameters&&"none"===this.symbolizerParameters.stretchType&&!this.symbolizerParameters.useGamma&&"u8"===this.source.pixelType}_getRasterTextureInterpolation(e){return"lut"===this.symbolizerParameters.type||"nearest"===e||"majority"===e||this.isBilinearWithStretchColorRamp?"nearest":"bilinear"}_updateColormapTexture(e){const r=this._colormap,s=this.symbolizerParameters.colormap;return s?r?s.length!==r.length||s.some(((e,t)=>e!==r[t]))?(this._colormapTexture=t.disposeMaybe(this._colormapTexture),this._colormapTexture=i.createColormapTexture(e,s),void(this._colormap=s)):void 0:(this._colormapTexture=i.createColormapTexture(e,s),void(this._colormap=s)):(this._colormapTexture=t.disposeMaybe(this._colormapTexture),void(this._colormap=null))}}e.RasterTile=a,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
