/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../chunks/tslib.es6","../../../Color","../../../core/has","../../../core/maybe","../../../core/MemCachePool","../../../core/ObjectPool","../../../core/reactiveUtils","../../../core/accessorSupport/decorators/property","../../../core/Logger","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../../core/libs/gl-matrix-2/factories/mat4f64","../../../chunks/vec32","../../../core/libs/gl-matrix-2/factories/vec3f64","../../../core/libs/gl-matrix-2/factories/vec4f64","../../../geometry/support/aaBoundingBox","../../../geometry/support/buffer/BufferView","../../ViewingMode","./interfaces","./LayerClass","./OverlayContent","./OverlayRenderer","./PatchRenderData","./RenderOrder","./TerrainAttributesCache","./terrainUtils","./TileRenderer","./TileUpdate","./tileUtils","./TransparencyMode","../webgl-engine/collections/Component/ComponentIntersectionData","../webgl-engine/core/shaderLibrary/ShaderOutput","../webgl-engine/core/shaderLibrary/terrain/TileBlendInput","../webgl-engine/effects/RenderPlugin","../webgl-engine/lib/Attribute","../webgl-engine/lib/basicInterfaces","../webgl-engine/lib/glUtil3D","../webgl-engine/lib/Intersector","../webgl-engine/lib/IntersectorInterfaces","../webgl-engine/lib/Material","../webgl-engine/lib/RayIntersections","../webgl-engine/lib/RenderSlot","../webgl-engine/lib/screenSizePerspectiveUtils","../webgl-engine/lib/VertexAttribute","../webgl-engine/lib/verticalOffsetUtils","../webgl-engine/materials/DrawParameters","../../../chunks/Terrain.glsl","../webgl-engine/shaders/TerrainTechnique","../webgl-engine/shaders/TerrainTechniqueConfiguration","../../webgl/enums"],(function(e,t,r,i,n,s,a,o,l,d,c,u,h,p,_,g,f,y,T,b,R,O,m,S,x,v,P,w,D,C,E,A,I,N,B,M,U,q,F,G,L,k,V,z,H,j,Y,Z,Q,W,X){"use strict";const K=7,J=10,$=f.create();e.TerrainRenderer=class extends B.SyncRenderPlugin{get _isGlobal(){return this._stage.viewingMode===T.ViewingMode.Global}get _techniques(){return this._context.techniques}get _rctx(){return this._context.renderContext.rctx}constructor(e,t,r,i,n){super({}),this._overlayRenderer=e,this._stage=t,this._allTiles=r,this._ellipsoidRadius=i,this.type=G.IntersectorType.TERRAIN,this.isGround=!0,this._tileSize=256,this._passParameters=new Z.TerrainPassParameters,this._drawParameters=new Y.DrawParameters,this._renderDataPool=new a(S.PatchRenderData),this._visiblePatchesByOrigin=new Map,this._allPatchesByOrigin=new Map,this._patchesByOriginDirty=!0,this._patchSortingDirty=!0,this._tileIterator=new C.IteratorPreorder,this._castShadows=!1,this._inViewshed=!1,this._emptyTex=null,this._tileRenderer=null,this._stencilEnabledLayerExtents=new Array,this._numTilesRendered=0,this._numTilesCulled=0,this._numOriginsRendered=0,this.renderOccludedFlags=L.RenderOccludedFlag.Occlude,this.produces=new Map([[V.RenderSlot.OPAQUE_TERRAIN,()=>this._produces()&&this.transparency===E.TransparencyMode.Opaque],[V.RenderSlot.TRANSPARENT_TERRAIN,()=>this._produces()&&(this.transparency===E.TransparencyMode.Transparent||this.transparency===E.TransparencyMode.InvisibleWithDraped)],[V.RenderSlot.OCCLUDED_TERRAIN,()=>this._produces()]]),this._configuration=new W.TerrainTechniqueConfiguration(t.viewingMode===T.ViewingMode.Global),this._tileTextureCache=new s.MemCachePool(((e,t)=>n.newCache(e,t)),"TileTexture"),this.tileGeometryCache=new v.TerrainAttributesCache(n)}normalizeCtorArgs(){return{}}initialize(){this._stage.addRenderPlugin(this),this.addHandles(o.watch((()=>this._overlayRenderer.rendersOccludedDraped),(e=>{this.renderOccludedFlags=e?m.overlayRenderOccludedFlag:L.RenderOccludedFlag.Occlude,this.setNeedsRender()}),o.sync))}destroy(){this._stage.removeRenderPlugin(this),this._tileTextureCache.destroy(),this.tileGeometryCache.destroy()}_produces(){return this.visible&&!!this._rootTiles&&!this.renderingDisabled}consumes(){return this._overlayRenderer.hasWater?B.ConsumesDepth:B.ConsumesNone}set renderingDisabled(e){this._set("renderingDisabled",!!e),this.setDirty()}set visible(e){this._set("visible",!!e),this.setDirty()}updateHeading(e){this._tileRenderer?.updateHeading(e)}set transparency(e){this._configuration.transparencyMode!==e&&(this._configuration.transparencyMode=e,this.setNeedsRender())}get transparency(){return this._configuration.transparencyMode}get renderPatchBorders(){return this._configuration.tileBorders}set renderPatchBorders(e){this._configuration.tileBorders!==e&&(this._configuration.tileBorders=e,this.setNeedsRender(),this.notifyChange("renderPatchBorders"))}get visualizeNormals(){return this._configuration.visualizeNormals}set visualizeNormals(e){this._configuration.visualizeNormals!==e&&(this._configuration.visualizeNormals=e,this.setNeedsRender(),this.notifyChange("visualizeNormals"))}get cullBackFaces(){return this._configuration.backfaceCullingEnabled}set cullBackFaces(e){this._configuration.backfaceCullingEnabled!==e&&(this._configuration.backfaceCullingEnabled=e,this.notifyChange("cullBackFaces"),this.setNeedsRender())}set renderOrder(e){this._set("renderOrder",e),this._setSortingDirty()}get layerUid(){return j.terrainId}get slicePlaneEnabled(){return this._configuration.hasSlicePlane}set slicePlaneEnabled(e){this._configuration.hasSlicePlane!==e&&(this._configuration.hasSlicePlane=e,this.setNeedsRender())}set textureFadingEnabled(e){this._configuration.textureFadingEnabled!==e&&(this._configuration.textureFadingEnabled=e,this.setNeedsRender())}set pbrMode(e){this._configuration.pbrMode!==e&&(this._configuration.pbrMode=e,this.setNeedsRender())}setDebugScreenSizePerspective(e){this._configuration.screenSizePerspective!==e&&(this._configuration.screenSizePerspective=e,this.setNeedsRender())}setRootTiles(e){this._rootTiles=e,this.setDirty()}setStencilEnabledLayerExtents(e){this._stencilEnabledLayerExtents=e,this._setSortingDirty()}setTileSize(e){this._tileSize=e,null!=this._tileRenderer&&(this._tileRenderer.tileSize=e),this.setDirty()}_ensureRenderData(e){e.renderData||(e.renderData=this._renderDataPool.acquire(),e.renderData.init(e,this._getLocalOriginOfTile(e)))}loadTile(e){this._ensureRenderData(e),this.updateTileGeometryState(e),this.reuseTextureFromParent(e)||this.updateTileTexture(e,D.TileUpdate.TEXTURE_FADING)}reuseTextureFromParent(e){const t=e.parent;if(!t)return!1;const r=g.fromValues(1&e.lij[2]?.5:0,1&e.lij[1]?0:.5,.5,.5);return t.renderData?.reuseTexture(e.renderData,r)??!1}updateTileTexture(e,t){null!=this._tileRenderer&&(this._tileRenderer.updateTileTexture(e,t===D.TileUpdate.TEXTURE_FADING?b.TextureUpdate.FADING:b.TextureUpdate.UNFADED),this.setNeedsRender(),e.resetPendingUpdate(t))}updateTileGeometryState(e){for(const r of e.layerInfo[R.LayerClass.ELEVATION])r.pendingUpdates&=~D.TileUpdate.GEOMETRY;e.resetPendingUpdate(D.TileUpdate.GEOMETRY);const t=e.renderData.updateGeometryState();return t&&this.setDirty(),t}updateGeometryIfNeeded(e){e.loaded&&e.renderData.updateGeometryIfNeeded(this._rctx)}unloadTile(e){const t=e.renderData;t&&(t.releaseGeometry(),this._renderDataPool.release(t),t.clear(),e.renderData=null,e.setMemoryDirty(),this.setDirty())}_getLocalOriginOfTile(e){const t=J-K,r=Math.max(0,Math.floor((e.level-t)/K)*K);if(this._isGlobal&&0===r)return _.ZEROS;for(;e.parent&&e.level>r;)e=e.parent;return e.centerAtSeaLevel}getStats(){return{numTilesRendered:this._numTilesRendered,numTilesCulled:this._numTilesCulled,numOriginsRendered:this._numOriginsRendered}}set wireframe(e){this._get("wireframe")!==e&&(this._set("wireframe",e),this.setNeedsRender())}setDirty(e=U.RenderRequestType.UPDATE){this._patchesByOriginDirty=!0,this._context.requestRender(e)}_setSortingDirty(e=U.RenderRequestType.UPDATE){this._patchSortingDirty=!0,this._context.requestRender(e)}setNeedsRender(e=U.RenderRequestType.UPDATE){this._context.requestRender(e)}initializeRenderContext(e){this._context=e,this._tileRenderer=new w.TileRenderer(this._rctx,this._tileSize,this._techniques,this._tileTextureCache),this.updateTileBackground(),this._emptyTex=q.createEmptyTexture(this._rctx)}uninitializeRenderContext(){this._emptyTex=n.disposeMaybe(this._emptyTex),this._tileRenderer=n.disposeMaybe(this._tileRenderer)}intersect(e,t,r,i){if(!this._rootTiles||e.options.selectOpaqueTerrainOnly&&e.options.selectionMode&&this.transparency!==E.TransparencyMode.Opaque)return;const n=ee,s=te;p.subtract(n,i,r),p.set(s,1/n[0],1/n[1],1/n[2]);const a=e.results.min,o=e.results.max,l=e.results.ground,d=e.options.store===G.StoreResults.MIN,c=!!e.results.ground.target,u=j.getVerticalOffsetTerrain(e.verticalOffset),_=e.tolerance;let g,T=d&&null!=a.dist?a.dist:1/0;const b=e.options,R=b.normalRequired||!b.backfacesTerrain,O=new k.MeshIntersectionOptions(!1,R),m=c=>{const m=c.renderData;if(!m?.vao)return;const S=m.geometry;f.set($,S.boundingBox);const x=m.localOrigin;null!=u&&(u.localOrigin=x,u.applyToAabb($));const v=$;if(re[0]=r[0]-x[0],re[1]=r[1]-x[1],re[2]=r[2]-x[2],!k.intersectAabbInvDirBefore(v,re,s,_,T))return;const P=(e,t,r)=>{e.set(this.type,c,t,r,h.IDENTITY),T=d&&null!=a.dist?a.dist:1/0},w=(s,d,c)=>{if((!R||null!=c)&&s>=0&&(b.backfacesTerrain||p.dot(c,n)<0)&&(b.invisibleTerrain||!b.selectionMode||null==t||t(r,i,s))){if((null==l.dist||s<l.dist)&&P(l,s,c),b.isFiltered)return;b.store===G.StoreResults.ALL&&(null==g?(g=F.newIntersectorResult(e.ray),P(g,s,c),e.results.all.push(g)):s<g.dist&&P(g,s,c)),(null==a.dist||s<a.dist)&&P(a,s,c),b.store!==G.StoreResults.MIN&&(null==o.dist||s>o.dist)&&P(o,s,c)}},D=ie;p.subtract(D,i,x);const{indices:C,indexCount:E}=S,I=S.vertexAttributes,N=I.getField(H.VertexAttribute.POSITION,y.BufferViewVec3f),B=new M.Vertices(N.typedBuffer,3,I.stride/4),U=E/3;if(!u&&U>A.componentMinimalSizeForIntersectionData){const e=c.renderData;null==e.intersectionData&&(e.intersectionData=new A.ComponentIntersectionData(C,0,U,B)),e.intersectionData.intersectRay(re,D,O,w)}else k.intersectTriangles(re,D,0,U,C,B,u,O,w)},S=this._rootTiles;if(null!=S){(()=>{const t=this._tileIterator;t.reset(S);const i=e.options.invisibleTerrain;for(let e=t.next();e;e=t.next())!(e.visible||i&&e.intersectsClippingArea)||null==u&&!e.intersectsRay(r,n,_,T)||c&&this._useStencilForTile(e)?t.skipSubtree():m(e)})()}}processScaleRangeQueries(e,t){if(!t.done)for(this._updatePatchGroups();e.updating&&!t.done;){e.prepare();for(const t of this._visiblePatchesByOrigin.values())for(const r of t)null!=r.renderData?.textureReference&&e.queriesForTile(r);e.process(),t.madeProgress()}}acquireTechniques(e){const t=!!i("enable-feature:terrain-shadows")&&e.bind.shadowMap.enabled;t!==this._castShadows&&(this._castShadows=t,this._patchesByOriginDirty=!0);const r=e.bind.viewshedEnabled;if(this._inViewshed!==r&&(this._inViewshed=r,this._patchesByOriginDirty=!0),e.bind.slot===V.RenderSlot.OCCLUDED_TERRAIN){if(!(e.renderOccludedMask&m.overlayRenderOccludedFlag))return null}else{const t=this.transparency===E.TransparencyMode.Opaque?V.RenderSlot.OPAQUE_TERRAIN:V.RenderSlot.TRANSPARENT_TERRAIN;if(e.bind.slot!==t)return null}if(this.transparency===E.TransparencyMode.Invisible)return null;switch(this._configuration.screenSpaceReflections=this._configuration.cloudReflections=this._configuration.receiveShadows=this._configuration.receiveAmbientOcclusion=!1,this._configuration.overlayMode=this._overlayRenderer.mode,e.output){case I.ShaderOutput.Color:case I.ShaderOutput.ColorEmission:return this._configuration.screenSpaceReflections=null!=e.bind.ssr.lastFrameColor,this._configuration.cloudReflections=null!=e.bind.clouds.data,this._configuration.receiveShadows=e.bind.shadowMap.ready,this._configuration.receiveAmbientOcclusion=null!=e.bind.ssao,this._acquireTechnique(e.output,e.bind.slot===V.RenderSlot.OCCLUDED_TERRAIN);case I.ShaderOutput.Shadow:case I.ShaderOutput.ShadowExcludeHighlight:return this._castShadows?this._acquireTechnique(I.ShaderOutput.Shadow,!1):null;case I.ShaderOutput.ViewshedShadow:return this._inViewshed?this._acquireTechnique(I.ShaderOutput.ViewshedShadow,!1):null;case I.ShaderOutput.Depth:case I.ShaderOutput.Normal:return this._acquireTechnique(e.output,!1);case I.ShaderOutput.ObjectAndLayerIdColor:return this._acquireTechnique(I.ShaderOutput.ObjectAndLayerIdColor,!1);case I.ShaderOutput.Highlight:return this._overlayRenderer.hasHighlights?this._acquireTechnique(I.ShaderOutput.Highlight,!1):null}return null}render(e,t){switch(this._updatePatchGroups(),t.useStencil=!1,e.output){case I.ShaderOutput.Color:case I.ShaderOutput.ColorEmission:{const r=e.bind.slot===V.RenderSlot.OCCLUDED_TERRAIN?O.OverlayContent.Occluded:O.OverlayContent.Color;this._renderMaterialPass(e,t,r);break}case I.ShaderOutput.Depth:case I.ShaderOutput.Normal:this._renderAuxiliaryPass(e,t,O.OverlayContent.Color,this._visiblePatchesByOrigin);break;case I.ShaderOutput.Highlight:this._overlayRenderer.hasHighlights&&this._overlayRenderer.renders(O.OverlayContent.Highlight)&&this._renderAuxiliaryPass(e,t,O.OverlayContent.Highlight,this._visiblePatchesByOrigin);break;case I.ShaderOutput.Shadow:case I.ShaderOutput.ShadowExcludeHighlight:case I.ShaderOutput.ViewshedShadow:this._renderAuxiliaryPass(e,t,null,this._allPatchesByOrigin);break;case I.ShaderOutput.ObjectAndLayerIdColor:this._renderAuxiliaryPass(e,t,O.OverlayContent.ObjectAndLayerIdColor,this._visiblePatchesByOrigin)}}updateTileBackground(e){if(null==this._tileRenderer)return;const t=this._tileRenderer;let i;if(null!=e){const t=r.toUnitRGBA(e);i=_.fromValues(t[0]||0,t[1]||0,t[2]||0)}t.setBackground(i),this._allTiles.forAll((e=>t.updateTileTexture(e,b.TextureUpdate.FADING))),this._configuration.tileBlendInput=t.backgroundIsGrid?N.TileBlendInput.GridComposite:null!=t.backgroundColor?N.TileBlendInput.ColorComposite:N.TileBlendInput.LayerOnly,this.setNeedsRender()}_updatePatchGroups(){if(this._patchesByOriginDirty&&(this._rebuildPatchGroups(),this._patchesByOriginDirty=!1,this._patchSortingDirty=!0),this._patchSortingDirty&&this.renderOrder!==x.RenderOrder.NONE){const e=Array.from(this._visiblePatchesByOrigin.values()),t=this._stencilEnabledLayerExtents;for(const r of e)C.sortTiles(this.renderOrder,r,t);e.sort(((e,t)=>C.compareTiles(e[0],t[0],this.renderOrder))),this._visiblePatchesByOrigin=new Map(e.map((e=>[e[0].renderData.localOrigin,e]))),this._patchSortingDirty=!1}}_rebuildPatchGroups(){const e=this._rootTiles;if(null!=e){e[0]?.surface.checkAllTilesWaterproofness(),this._visiblePatchesByOrigin.clear(),this._allPatchesByOrigin.clear();for(const t of e)this._rebuildPatchGroupsForRootTile(t)}}_rebuildPatchGroupsForRootTile(e){const t=this._tileIterator;for(t.resetOne(e);!t.done;){const e=t.next(),r=e.renderData;if(!r){this._numTilesCulled++;continue}const i=r.localOrigin;if(this._castShadows||this._inViewshed){let t=this._allPatchesByOrigin.get(i);t||(t=[],this._allPatchesByOrigin.set(i,t)),t.push(e)}if(!e.visible){this._numTilesCulled++,t.skipSubtree();continue}let n=this._visiblePatchesByOrigin.get(i);n||(n=[],this._visiblePatchesByOrigin.set(i,n)),n.push(e),t.skipSubtree()}}_useStencilForTile(e){for(const t of this._stencilEnabledLayerExtents)if(e.intersectsExtent(t))return!0;return!1}_renderAuxiliaryPass(e,t,r,i){const n=e.rctx;this._passParameters.overlayContent=r,n.bindTechnique(t,e.bind,this._passParameters);const s=this._stencilEnabledLayerExtents.length>0;i.forEach((i=>{this._drawParameters.origin=i[0].renderData.localOrigin,t.program.bindDraw(e.bind,this._passParameters,this._drawParameters);for(let n=0;n<i.length;n++)this._renderPatch(e,t,i[n],X.PrimitiveType.TRIANGLES,s,r)})),e.rctx.bindVAO(null)}_renderMaterialPass(e,t,r){const{rctx:i}=e;this._passParameters.overlayContent=r,i.bindTechnique(t,e.bind,this._passParameters),this._numTilesRendered=0,this._numTilesCulled=0,this._numOriginsRendered=0;const n=e.bind.camera,s=t.program;if(this._configuration.screenSizePerspective&&this.pointsOfInterest){const e=z.getSettings(this._stage.viewingMode,this._ellipsoidRadius),t=this.pointsOfInterest.centerOnSurfaceFrequent.distance;e.update({distance:t,fovY:n.fovY})}const a=this._stencilEnabledLayerExtents.length>0,o=r===O.OverlayContent.Occluded;o&&(s.bindTexture("tex",this._emptyTex),s.setUniform3fv("textureOpacities",_.ZEROS),s.setUniform4fv("texOffsetAndScale",g.ZEROS));const l=null!=this._tileRenderer?.backgroundColor?this._tileRenderer.backgroundColor:_.ZEROS;this._configuration.tileBlendInput===N.TileBlendInput.ColorComposite&&s.setUniform3fv("backgroundColor",l);const d=this.wireframe?X.PrimitiveType.LINES:X.PrimitiveType.TRIANGLES;this._configuration.textureFadingEnabled&&s.bindTexture("texNext",this._emptyTex);const c=this._visiblePatchesByOrigin;for(const u of c.values()){const i=u[0].renderData.localOrigin;this._drawParameters.origin=i,t.program.bindDraw(e.bind,this._passParameters,this._drawParameters),this._numOriginsRendered++;for(const n of u){const i=n.renderData,l=i.textureReference;if(null!=l){if(!o){s.setUniform4fv("texOffsetAndScale",l.offsetAndScale),s.bindTexture("tex",l.texture.texture);const e=i.textureFadeFactor,t=e<1?i.nextTextureReference:null;this._configuration.textureFadingEnabled&&null!=t&&e<1?(s.setUniform1f("fadeFactor",e),s.setUniform4fv("nextTexOffsetAndScale",t.offsetAndScale),s.setUniform3fv("nextTexOpacities",t.opacities),s.bindTexture("texNext",t.texture.texture)):s.setUniform1f("fadeFactor",1),i.textureIsFading&&this.setNeedsRender(),s.setUniform3fv("textureOpacities",l.opacities)}this._renderPatch(e,t,n,d,a,r),n.renderOrder=this._numTilesRendered,this._numTilesRendered++}}}e.rctx.bindVAO(null)}_renderPatch(e,t,r,i,n,s){const a=r.renderData,o=a.vao,l=o?.indexBuffer;if(!o||null==l)return void(P.enableTerrainInternalChecks&&console.error("Rendered tile with no indices: ",r.lij," : ",a));const d=t.program;null==s||this._overlayRenderer.isEmpty||this._bindOverlayPatchData(d,a.overlay),n&&(t.useStencil=this._useStencilForTile(r),e.rctx.setPipelineState(t.getPipeline()));const c=a.geometry.indexCount;e.rctx.bindVAO(o),d.assertCompatibleVertexAttributeLocations(o),e.rctx.drawElements(i,c,l.indexType,0)}_bindOverlayPatchData(e,t){e.setUniform4fv("overlayTexOffset",t.offsets),e.setUniform4fv("overlayTexScale",t.scales)}_acquireTechnique(e,t){return this._configuration.output=e,this._configuration.renderOccluded=t,this._techniques.acquire(Q.TerrainTechnique,this._configuration)}get test(){}},t.__decorate([l.property({readOnly:!0})],e.TerrainRenderer.prototype,"_isGlobal",null),t.__decorate([l.property()],e.TerrainRenderer.prototype,"renderOccludedFlags",void 0),t.__decorate([l.property({value:!1})],e.TerrainRenderer.prototype,"renderingDisabled",null),t.__decorate([l.property({value:!0})],e.TerrainRenderer.prototype,"visible",null),t.__decorate([l.property()],e.TerrainRenderer.prototype,"renderPatchBorders",null),t.__decorate([l.property()],e.TerrainRenderer.prototype,"visualizeNormals",null),t.__decorate([l.property()],e.TerrainRenderer.prototype,"cullBackFaces",null),t.__decorate([l.property({value:x.RenderOrder.FRONT_TO_BACK})],e.TerrainRenderer.prototype,"renderOrder",null),t.__decorate([l.property()],e.TerrainRenderer.prototype,"wireframe",null),e.TerrainRenderer=t.__decorate([u.subclass("esri.views.3d.terrain.TerrainRenderer")],e.TerrainRenderer);const ee=_.create(),te=_.create(),re=_.create(),ie=_.create();Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
