/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../../../chunks/tslib.es6","../../../Color","../../../core/Accessor","../../../core/arrayUtils","../../../core/CollectionFlattener","../../../core/Evented","../../../core/has","../../../core/Logger","../../../core/mathUtils","../../../core/maybe","../../../core/MemCachePool","../../../core/ObjectPool","../../../core/PooledArray","../../../core/promiseUtils","../../../core/reactiveUtils","../../../core/accessorSupport/decorators/property","../../../core/accessorSupport/decorators/subclass","../../../chunks/vec32","../../../core/libs/gl-matrix-2/factories/vec3f64","../../../core/support/UpdatingHandles","../../../geometry/ellipsoidUtils","../../../geometry/SpatialReference","../../../geometry/projection/projectors","../../../geometry/projection/projectPointToVector","../../../geometry/projection/projectVectorToVector","../../../geometry/support/aaBoundingRect","../../../geometry/support/frustum","../../../geometry/support/spatialReferenceUtils","../../../chunks/sphere","../../../layers/support/ElevationQueryTileCache","../../../layers/support/layerUtils","../support/debugFlags","../support/ElevationRange","../support/ElevationUpdateEvent","../support/extentUtils","../support/index","../support/updatingProperties","./ElevationBounds","./ElevationData","./ExtentHelper","./interfaces","./LayerClass","./OverlayManager","./PlanarPatch","./RenderOrder","./ScaleRangeQueries","./SphericalPatch","./SplitLimits","./TerrainConst","./TerrainRenderer","./TerrainSurfacePerformanceInfo","./terrainUtils","./Tile","./TilePerLayerInfo","./TileUpdate","./tileUtils","./TilingSchemeLogic","./TransparencyMode","./UpsampleInfo","../webgl-engine/core/shaderLibrary/output/BlendOptions","../webgl-engine/core/shaderLibrary/shading/PhysicallyBasedRenderingParameters.glsl","../webgl-engine/lib/basicInterfaces","../../support/RenderState","../../support/Scheduler","../../support/Yield"],(function(e,t,i,r,s,a,l,n,o,d,h,p,c,u,_,g,y,T,m,f,v,w,E,L,b,S,C,P,U,M,x,D,R,A,I,B,V,k,N,j,O,G,q,F,W,$,H,Q,z,X,Y,K,J,Z,ee,te,ie,re,se,ae,le,ne,oe,de,he,pe){"use strict";var ce;let ue=ce=class extends(l.EventedMixin(r)){constructor(e){super(e),this._scaleRangeQueries=new H.ScaleRangeQueries,this._iteratorPool=new c(ie.IteratorPreorder,(e=>e.remove=()=>this._iteratorPool.release(e))),this._postorderIterator=new ie.IteratorPostorder,this._hasPendingUpdates=!1,this._pendingUpdates=0,this._asyncWorkItems=0,this._allTilesDirty=!0,this._allTilesSorted=!0,this._usedMemory=null,this._performanceInfo=new K,this._viewChanged=!1,this.heading=0,this._inFrameTask=!1,this._viewChangeUpdateDirty=!1,this._eyePosRenderSR=f.create(),this._eyePosSurfaceSR=f.create(),this._splitLimits=new z.SplitLimits,this._frustum=P.create(),this._layerViews=[new Array,new Array],this._layerIndexByUid=[new Map,new Map],this._basemapLayerViewHandles=new Map,this._watchUpdatingTracking=new v.UpdatingHandles,this._frameTask=he.ImmediateTask,this._allTiles=new u,this._upsampleInfoPool=new c(ae.UpsampleInfo),this._shouldEmitChangeEvent=!1,this._destroying=!1,this._rootTilesExtent=C.create(),this.updatingProgress=.5,this._maxNumUpdating=1,this.maxTextureScale=1.2,this._spatialReference=E.WebMercator,this._elevationProjectorCache=new Map,this.visibleElevationBounds=new N.ElevationBounds(1/0,-1/0),this.rootTileElevationBounds=new N.ElevationBounds(1/0,-1/0),this._sebProjectorMap=new Map,this._sebProjectorCache=L.createEmptyProjectorCache(),this._tilingSchemeSpatialReference=null,this._radiusModifier=Math.cos(Math.PI/16/16),this._updatingRootTiles=!1,this._pendingTilesForElevationUpdateEvent=new Set,this._pendingTilesToUpdate=new Set,this.totalGeometryUpdates=0,this.totalTileUpdates=0,this._oneBatchPerFrameTask=!0,this._layerViewsDirty=!1,this.unloadedMemory=0,this.ignoresMemoryFactor=!1,this._isWebMercator=!1,this._isWebMercatorOnPlateCarree=!1,this.overlayManager=new F.OverlayManager({...e,surface:this}),this._isGlobal=!e.view?.state?.isLocal,this._isGeographic=this._spatialReference?.isGeographic??!1,this._tileConstructor=this._isGlobal?Q.SphericalPatch:W.PlanarPatch,this._ellipsoid=w.getReferenceEllipsoid(e.view.spatialReference)}initialize(){const t=this.view,i=t.resourceController,r=i.memoryController;this._tileCache=new p.MemCachePool(((e,t)=>r.newCache(e,t)),"terrain-tile"),this._upsampleMapCache=r.newCache("terrain-upsample",(e=>e.unloadMapData())),this._elevationQueryCache=new x.ElevationQueryTileCache(r.newCache("elevation-query"));const s=this.overlayManager;this._renderer=new Y.TerrainRenderer(s.renderer,t._stage,this._allTiles,this._ellipsoid.radius,r),this.addHandles([g.watch((()=>s.renderer.isEmpty),(()=>this._evaluateTransparency())),g.watch((()=>this.renderer.visible),(e=>this.suspended=!e)),g.watch((()=>this.heading),(e=>{this._renderer.updateHeading(e),this._updateTileTextures(G.TextureUpdate.FADING)})),g.watch((()=>({heading:t.camera?.heading,state:t.state?.mode})),(({heading:e,state:t})=>{if(null==e)return;if(this.isGlobal&&this.isGeographic||this.isWebMercatorOnPlateCarree)return void(this.heading=90*Math.round(e/90)%360);const i=Math.round(e)%360,r=Math.abs(i-this.heading);(t===de.RenderState.IDLE||Math.min(r,360-r)>=30)&&(this.heading=i)}))],"overlayManager"),this.addHandles([g.watch((()=>this.baseOpacity),(()=>{this._handleLayerViewChanges(),this._updateTileTextures(this._evaluateTransparency()?G.TextureUpdate.UNFADED:G.TextureUpdate.IMMEDIATE)}),g.syncAndInitial),g.watch((()=>this.hasCompositeBlendMode),(()=>this._updateTileTextures(this._evaluateTransparency()?G.TextureUpdate.UNFADED:G.TextureUpdate.IMMEDIATE)),g.syncAndInitial),g.watch((()=>this.backgroundColor),((e,t)=>{e?.equals(t)||(this._handleLayerViewChanges(),this._renderer.updateTileBackground(e))}),g.sync),g.watch((()=>this.snapLevel),(()=>this._viewChanged=!0),g.sync),g.watch((()=>this.view.pointsOfInterest),(e=>{this._renderer.pointsOfInterest=e,this._watchUpdatingTracking.removeAll(),e&&this._watchUpdatingTracking.add((()=>e.focus.renderLocation),(()=>this._allTilesSorted=!1))})),g.watch((()=>R.debugFlags.TERRAIN_TILE_TREE_SHOW_TILES),(i=>{i&&!this._treeDebugger?new Promise(((t,i)=>e(["../layers/support/TerrainTileTree3DDebugger"],t,i))).then((({TerrainTileTree3DDebugger:e})=>{!this._treeDebugger&&R.debugFlags.TERRAIN_TILE_TREE_SHOW_TILES&&(this._treeDebugger=new e({view:t}))})):i||(this._treeDebugger=h.destroyMaybe(this._treeDebugger))}),g.initial)]);const{spatialReference:l}=t;this._extentHelper=O.create(this.viewingMode,{layers:t.map.allLayers,layerViews:t.allLayerViews,viewSpatialReference:l});const n=new a({getCollections:()=>t.defaultsFromMap?.mapCollections?.map((({layers:e})=>e)),getChildrenFunction:e=>e&&"layers"in e?e.layers:null}),o=new re.TilingSchemeLogic({layers:n,extentHelper:this._extentHelper,viewingMode:this.viewingMode,viewSpatialReference:l});this._set("tilingSchemeLogic",o),this._updateTilingScheme(),this._elevationDataRequester=i.createStreamDataRequester(V.ClientType.ELEVATION),this._mapDataRequester=i.createStreamDataRequester(V.ClientType.BASEMAP);const d=i.scheduler;this._frameTask=d.registerTask(he.TaskPriority.TERRAIN_SURFACE,this),this.addHandles([g.watch((()=>this._extentHelper.stencilEnabledExtents),(e=>this._renderer.setStencilEnabledLayerExtents(e)),g.initial),g.watch((()=>this.tilingSchemeLogic.tilingScheme),(()=>this._updateTilingScheme()),g.sync),g.watch((()=>this.extent),(()=>this._updateRootTiles()),g.initial),t.on("resize",(()=>this._viewChangeUpdate())),g.watch((()=>{const e=t.state;return[this._lodBias,this.lodSnappingEnabled,t.quality,e.camera,e.contentCamera,e.fixedContentCamera]}),(()=>this._viewChangeUpdate()),g.syncAndInitial),g.watch((()=>t.qualitySettings?.fadeDuration),(e=>this._renderer.textureFadingEnabled=e>0),g.initial),g.watch((()=>t.qualitySettings?.physicallyBasedRenderingEnabled),(e=>this._renderer.pbrMode=e?ne.PBRMode.Simplified:ne.PBRMode.Disabled),g.initial),g.watch((()=>t.qualitySettings?.tiledSurface.elevationLevelDelta),(()=>this._updateAllTileGeometries())),g.watch((()=>this._userClippingExtent),(()=>this._updateClippingExtent()),g.sync)]),this.addHandles(t.allLayerViews.on("after-changes",(()=>this._layerViewsDirty=!0))),this._layerViewsDirty=!0,this._handleLayerViewChanges(),this._renderer.updateTileBackground(this.backgroundColor)}destroy(){this._destroying=!0,this._frameTask.remove(),this._watchUpdatingTracking.destroy(),this._removeAllTiles(),this._set("tilingSchemeLogic",h.destroyMaybe(this.tilingSchemeLogic)),this._basemapLayerViewHandles.forEach(((e,t)=>this._unregisterTiledLayerView(t))),this._elevationDataRequester=null,this._mapDataRequester=null,this._set("overlayManager",h.destroyMaybe(this.overlayManager)),this._tileCache=h.destroyMaybe(this._tileCache),Z.Tile.prune(),this._treeDebugger=h.destroyMaybe(this._treeDebugger),this._renderer=h.destroyMaybe(this._renderer),this._iteratorPool=h.destroyMaybe(this._iteratorPool),this._upsampleMapCache=h.destroyMaybe(this._upsampleMapCache),this._elevationQueryCache=h.destroyMaybe(this._elevationQueryCache),this._set("view",null),this._extentHelper=h.destroyMaybe(this._extentHelper),this._upsampleInfoPool=h.destroyMaybe(this._upsampleInfoPool),ee.printAllocations()}get renderer(){return this._renderer}get frustum(){return this._frustum}get snapLevel(){if(this.lodSnappingEnabled){const{view:e,tilingScheme:t}=this,i=e.scale;if(t&&i){const r=t.levelAtScale(i)+e.qualitySettings.tiledSurface.lodBias,s=t.getMaxLod();return r<=0?null:Math.min(r,s||1/0)}}return null}get lodSnappingEnabled(){return this.view.qualitySettings.tiledSurface.reduceTileLevelDifferences}get upsampleInfoPool(){return this._upsampleInfoPool}get upsampleMapCache(){return this._upsampleMapCache}get elevationQueryCache(){return this._elevationQueryCache}get hasStencilEnabledExtents(){return this._extentHelper.stencilEnabledExtents.length>0}get _userClippingExtent(){const{spatialReference:e}=this,{clippingArea:t}=this.view;if(null==t||null==e)return null;const i=C.create(),r=B.toBoundingRect(t,i,e)?i:null,s=this._get("extent");return C.equals(r,s)?s:r}get rootTilesExtent(){return this._rootTilesExtent}get extent(){const e=C.intersection(this.groundExtent,this._userClippingExtent,C.create()),t=this._get("extent");return C.equals(e,t)?t:e}get groundExtent(){return null!=this._tilingSchemeExtent?this._tilingSchemeExtent:this._rootTilesExtent}get _tilingSchemeExtent(){return this.tilingSchemeLogic?.extent}get updating(){return this._hasPendingUpdates||(this._maxNumUpdating=1),!!((this.running||this._watchUpdatingTracking?.updating||this._asyncWorkItems>0)&&this.ready&&!this.suspended||this.overlayManager?.updating)}get running(){return(this._hasPendingUpdates||this._viewChanged||this._allTilesDirty||!this._allTilesSorted||this._layerViewsDirty||this._scaleRangeQueries.updating||this._frameTask.updating)&&this.ready&&!this.suspended}get updatingProgressValue(){return this._maxNumUpdating=Math.max(this._pendingUpdates,this._maxNumUpdating),1-this._pendingUpdates/this._maxNumUpdating}get baseOpacity(){return this.view?.map?.ground?.opacity??1}set baseOpacity(e){this.view.map.ground.opacity=e}get viewingMode(){return this.view.state.viewingMode}get ready(){return null!=this._rootTiles}set renderOrder(e){this._renderer.renderOrder=e,this._set("renderOrder",e)}get rootTiles(){return this._rootTiles}get spatialReference(){return this.tilingScheme?.spatialReference??null}get backgroundColor(){return this.view?.map?.ground?.surfaceColor}set backgroundColor(e){this.view.map.ground.surfaceColor=e}set slicePlaneEnabled(e){this._renderer.slicePlaneEnabled=e,this._set("slicePlaneEnabled",e),this._evaluateTransparency()}get tilingSchemeLocked(){return this.tilingSchemeLogic?.tilingSchemeLocked??!1}get wireframe(){return this._renderer?.wireframe}set wireframe(e){e!==this._renderer.wireframe&&(this._renderer.wireframe=e,this._updateAllTileGeometries())}get opaque(){return this._renderer.transparency===se.TransparencyMode.Opaque}set suspended(e){this._set("suspended",e),this._viewChangeUpdate()}get fadeDuration(){return this.view.qualitySettings.fadeDuration??0}intersect(e,t,i,r){this._renderer.intersect(e,t,i,r)}getElevationLevelDelta(e){return e<4?3:this.view.qualitySettings.tiledSurface.elevationLevelDelta}getElevation(e,t,i,r){const s=this._rootTiles;if(!s?.length)return null;if(0===s[0].layerInfo[q.LayerClass.ELEVATION].length)return null;let a=this._elevationProjectorCache.get(r);if(void 0===a&&(a=L.getProjector(r,this._spatialReference)??null,this._elevationProjectorCache.set(r,a)),null==a)return o.getLogger(this).error("TerrainSurface.getElevation(): could not project given point to tiling scheme coordinate system"),null;const l=m.set(ge,e,t,i);a(l,0,l,0);return ve(s,l[0],l[1])}getElevations(e,t,i){const r=this._rootTiles,s=r?r[0].layerInfo[q.LayerClass.ELEVATION].length:0;if(r?.length&&0!==s)for(let a=0;a<t;++a){const t=3*a;i(a,ve(r,e[t],e[t+1]))}else for(let a=0;a<t;++a)i(a,null)}getScale(e){if(!this.tilingScheme)return null;if(!b.projectPointToVector(e,ge,this.spatialReference))return o.getLogger(this).error("TerrainSurface.getScale(): could not project given point to tiling scheme coordinate system"),null;const t=this._rootTiles;if(null!=t)for(const i of t)if(i?.containsPoint(ge)){let e=i;for(;e.children[0]&&!e.rendered;){const t=e.children[0].extent;let i=0;ge[0]>t[2]&&(i+=1),ge[1]<t[1]&&(i+=2),e=e.children[i]}return this._getLodBiasCorrectedScale(e.level)}return 1/0}_ensureSEBProject(e){const t=this._sebProjectorMap.get(e);if(t)return t;const i=L.getProjector(e,this._tilingSchemeSpatialReference,this._sebProjectorCache)??null;return this._sebProjectorMap.set(e,i),i}getSphereElevationBounds(e,t){const i=this._ensureSEBProject(t);if(null==i)return o.getLogger(this).error("TerrainSurface.getSphereElevationBounds(): could not project given point to tiling scheme coordinate system"),null;M.copy(e,ye);const r=M.getCenter(ye);i(r,0,r,0);const s=new A.ElevationRange,a=this._rootTiles;if(null!=a){const e=[];for(const i of a)e.push(i);let t=0;for(;t<e.length;){const i=e[t];if(++t,!C.intersectsSphere(i.extent,ye))continue;const r=i.children;if(null==r[0]||i.rendered)s.expandElevationRangeValues(i.elevationBoundsMin,i.elevationBoundsMax);else for(const t of r)e.push(t)}}return s}getRootElevationBounds(){return new A.ElevationRange(this.rootTileElevationBounds.min,this.rootTileElevationBounds.max)}getLowerBoundRadius(){const e=(this._ellipsoid.radius+this.visibleElevationBounds.min)*this._radiusModifier;return Math.min(e,this._ellipsoid.radius)}getSphereScale(e,t){if(!this.tilingScheme)return null;if(!b.projectPointToVector(e,M.getCenter(ye),this.spatialReference))return o.getLogger(this).error("TerrainSurface.getSphereScale(): could not project given point to tiling scheme coordinate system"),null;ye[3]=t;let i=null;const r=e=>{if(e&&C.intersectsSphere(e.extent,ye)){const t=e.children;if(t[0]&&!e.rendered)for(const e of t)r(e);else{const t=this._getLodBiasCorrectedScale(e.level);i=null==i?t:Math.min(i,t)}}},s=this._rootTiles;if(null!=s)for(const a of s)r(a);return i}queryVisibleScaleRange(e,t,i,r){const s=t?this.tilingScheme.levelAtScale(t):0,a=i?this.tilingScheme.levelAtScale(i):1/0,l=this._lodBias;this._scaleRangeQueries.queryVisibleLevelRange(e,s+l,a+l,r)}_evaluateTransparency(){const e=this.baseOpacity,t=this.overlayManager.renderer.isEmpty,i=this._renderer.transparency,r=this._allSurfaceLayersTransparent()?t?se.TransparencyMode.Invisible:se.TransparencyMode.InvisibleWithDraped:e>=1&&!this.hasCompositeBlendMode&&!this._renderer.slicePlaneEnabled?se.TransparencyMode.Opaque:se.TransparencyMode.Transparent;return this._renderer.transparency=r,i!==r}_updateTilingScheme(){const e=this.tilingSchemeLogic.tilingScheme;if(!(e!==this.tilingScheme))return;J.weakAssert(!!e,"tiling scheme cannot be reset to undefined"),this._isGlobal=!this.view?.state?.isLocal,this.tilingScheme&&this._removeAllTiles();const t=e?.spatialReference??E.WebMercator;this._spatialReference=t,this._isWebMercator=!!t?.isWebMercator,this._isWebMercatorOnPlateCarree=this._isWebMercator&&U.isPlateCarree(this.view?.renderSpatialReference),this._isGeographic=t?.isGeographic??!1,this._set("tilingScheme",e),this._tilingSchemeSpatialReference=this.tilingScheme?.spatialReference,this._sebProjectorMap.clear(),this._updateClippingExtent(),e&&(this._updateTiledLayers(),this._renderer.setTileSize(e.pixelSize),this.overlayManager.setSpatialReference(e.spatialReference),this._updateRootTiles())}_acquireTile(e,t,i,r){const s=this._tileCache.pop(ce._tileMemcacheKey);return s?(s.init(e,t,i,r,this),s):new this._tileConstructor(e,t,i,r,this)}get updatingRootTiles(){return this._updatingRootTiles}_updateRootTiles(){const{extent:e,tilingScheme:t}=this;if(!t)return;const i=Te;let r=t.rootTilesInExtent(e,i,5*X.maxRootTiles);if(null!=this._rootTiles){if(r.length>X.maxRootTiles)return void o.getLogger(this).warn(X.tooManyRootTilesAfterChangeError);const e=this._rootTiles.map((e=>e.lij)),t=s.difference(e,r,Z.lijEquals);if(this._updatingRootTiles=!0,t.removed.length>0||t.added.length>0){const e=this._rootTiles.filter((e=>!(t.removed.findIndex((t=>Z.lijEquals(t,e.lij)))>-1)||(this._purgeTile(e),!1)));t.added.forEach((t=>e.push(this._newRootTile(t)))),this._setRootTiles(e)}}else this._updatingRootTiles=!0,r.length>X.maxRootTiles&&(o.getLogger(this).warn(X.tooManyRootTilesForLayerError),r=t.rootTilesInExtent(e,i,X.maxRootTiles)),this._setRootTiles(r.map((e=>this._newRootTile(e))));C.equals(i,this._rootTilesExtent)||(this._rootTilesExtent=C.create(i)),this.renderer.visible=!0,this._viewChangeUpdate(),this.overlayManager.setPlacementDirty(),this.notifyChange("ready"),this._updateAllTileGeometries(),this._updatingRootTiles=!1,this.checkAllTilesWaterproofness()}_updateAllTileGeometries(){const e=this._allTiles.filter((e=>e.loaded&&e.intersectsClippingArea));e.sort(ie.compareTilesByLij),e.forEach((e=>this._renderer.updateTileGeometryState(e))),e.forEach((e=>e.renderData.updateNeighborData())),this._updateTilesGeometries(e),this._pendingTilesToUpdate.clear()}_updateTilesGeometries(e){if(0===e.length)return;e.sort(ie.compareTilesByLij);const t=this.renderer;e.forEach((e=>t.updateGeometryIfNeeded(e))),e.forEach((e=>this._pendingTilesForElevationUpdateEvent.add(e)))}_shouldSplit(e){return e.shouldSplit(this._splitLimits,this._eyePosRenderSR,this.snapLevel)===te.TileUpdate.SPLIT}_newRootTile(e){const t=this._acquireTile(0,e[1],e[2],null);return this._shouldSplit(t)&&t.setPendingUpdate(te.TileUpdate.SPLIT),this._loadTile(t),this._markTileToUpdate(t),this._updateRootTileElevationBounds(),t}_setRootTiles(e){if(this._rootTiles=e,this._allTiles.clear(),null!=e){const t=this._iteratorPool.acquire();for(t.reset(e);!t.done;)this._allTiles.push(t.next());t.remove()}this._renderer.setRootTiles(this._rootTiles),this._updateTilesVisibility(e)}_runViewChangeUpdateIfDirty(){this._viewChangeUpdateDirty&&(this._viewChangeUpdateDirty=!1,this._viewChangeUpdate())}_viewChangeUpdate(){this.view&&!this.suspended&&this.tilingScheme&&this.renderer.visible&&(this._inFrameTask?this._viewChangeUpdateDirty=!0:(this._viewChangeUpdateDirty=!1,this._updateViewDependentParameters(),this._updateTilesVisibility(this._rootTiles)))}_updateClippingStatus(e){e.updateClippingStatus(this.extent)&&e.resetPendingUpdate(te.TileUpdate.GEOMETRY)&&this._updateTileGeometryState(e)}_updateTilesVisibility(e){if(null==e)return;const t=ie.hasLoadableSiblings(e),i=this.visibleElevationBounds;let r=t?i.min:1/0,s=t?i.max:-1/0;const a=this.extent,l=this.view.state.contentCamera.viewProjectionMatrix;this.setTileTreeDirty();const n=this._iteratorPool.acquire();for(n.reset(e);!n.done;){const e=n.next();e.updateClippingStatus(a)&&e.resetPendingUpdate(te.TileUpdate.GEOMETRY)&&this._updateTileGeometryState(e),e.computeVisibility(),e.updateScreenDepth(l),e.renderData&&(r=Math.min(e.elevationBoundsMin,r),s=Math.max(e.elevationBoundsMax,s))}n.remove(),this._viewChanged=!0,this._allTilesDirty=!0,this._updatePendingTileGeometries(),isFinite(r)&&isFinite(s)&&(i.min!==r||i.max!==s)&&(this.visibleElevationBounds=new N.ElevationBounds(r,s))}_updateRootTileElevationBounds(){let e=1/0,t=-1/0;const i=this._rootTiles;null!=i&&i.forEach((({elevationBoundsMin:i,elevationBoundsMax:r})=>{e=Math.min(e,i),t=Math.max(t,r)}));const r=this.rootTileElevationBounds;r.min===e&&r.max===t||(this.rootTileElevationBounds=new N.ElevationBounds(e,t))}_updateViewDependentParameters(){const{camera:e,contentCamera:t}=this.view.state,i=Math.tan(.5*t.fovX),r=Math.tan(.5*t.fovY),s=this.tilingScheme.pixelSize,a=2**-this._lodBias*e.pixelRatio;this._splitLimits.aboveGround=e.aboveGround,this._splitLimits.fovX=i,this._splitLimits.fovY=r,this._splitLimits.relativeWidthLimit=s/e.width*this.maxTextureScale*a,this._splitLimits.relativeHeightLimit=s/e.height*this.maxTextureScale*a,this._splitLimits.maxLod=this.tilingScheme.getMaxLod(),this._splitLimits.angledSplitBias=this.view.qualitySettings.tiledSurface.angledSplitBias,this.view.state.fixedContentCamera?this._splitLimits.frustum=P.copy(this._splitLimits.frustum??P.create(),t.frustum):this._splitLimits.frustum=null,P.copy(this._frustum,e.frustum),m.copy(this._eyePosRenderSR,t.eye),S.projectVectorToVector(e.eye,this.view.renderSpatialReference,this._eyePosSurfaceSR,this.spatialReference)}_updateTileGeometryState(e){e.updateVisibility();this._renderer.updateTileGeometryState(e)&&this._markTileToUpdate(e),this._usedMemory=null}_markAllTileNeighborsForUpdate(e){e.forEachLoadedNeighbor((e=>{this._layerViews[q.LayerClass.MAP].some(J.isVectorTileLayerView)&&e.setPendingUpdate(te.TileUpdate.TEXTURE_FADING),this._pendingTilesToUpdate.add(e)}))}_updateTileTexture(e,t){const i=e.resetPendingUpdate(te.TileUpdate.TEXTURE_FADING)?te.TileUpdate.TEXTURE_FADING:!!e.resetPendingUpdate(te.TileUpdate.TEXTURE_NOFADING)&&te.TileUpdate.TEXTURE_NOFADING;i&&(this._renderer.updateTileTexture(e,i),this._usedMemory=null,t.madeProgress())}_emitElevationUpdateEventForTiles(){if(!this._shouldEmitChangeEvent)return;const e=me.extent;C.empty(e),this._pendingTilesForElevationUpdateEvent.forEach((t=>C.expand(e,t.extent,e))),this._pendingTilesForElevationUpdateEvent.clear(),me.spatialReference=this.spatialReference,this.emit("elevation-change",me),this._shouldEmitChangeEvent=!1}runTask(e){this._handleLayerViewChanges(e),this._frameTask.processQueue(e),this.renderer.processScaleRangeQueries(this._scaleRangeQueries,e),this._inFrameTask=!0,this._pendingUpdates=0,this._hasPendingUpdates=!1,this._updateAllTilesStatus(e),this._sortTiles(e);const t=!this.view.state.fixedContentCamera;if(this._mergeAndSplit(e,t),this._updateElevation(e),this._updateTextures(e),t||this._mergeAndSplit(e,!0),this._inFrameTask=!1,this._runViewChangeUpdateIfDirty(),this._updatePendingTileGeometries(),this._emitElevationUpdateEventForTiles(),e.done&&e.hasProgressed&&this.requestUpdate(),this.notifyChange("updatingProgressValue"),J.enableTerrainInternalChecks&&this._checkTileInvariant(),!e.hasProgressed)return pe.Yield}_checkTileInvariant(){const e=new Map;this._allTiles.forAll((t=>e.set(t,new Set))),this._allTiles.forAll((t=>{if(J.weakAssert(t.rendered===t.leaf,` rendered ${t.rendered} != ${t.leaf} leaf`),!t.leaf){const e=e=>0===e.unmergableChildCount&&0===e.maxLevelDeltaNeighborCount,i=t.children.reduce(((t,i)=>t+(e(i)?0:1)),0);if(J.weakAssert(t.unmergableChildCount===i,` Tile[${t.lij.toString()}] unmergeable child count mismatch: actual ${t.unmergableChildCount} vs ${i}`),t.hasPendingUpdate(te.TileUpdate.MERGE)){J.weakAssert(!t.hasPendingUpdate(te.TileUpdate.SPLIT),"Tile can be both split and merge at the same time");for(const e of t.children)J.weakAssert(e.leaf||e.hasPendingUpdate(te.TileUpdate.MERGE),"Child of tile to merge must also merge")}}for(let i=0;i<4;++i){if(t.rendered){const e=t.renderData?.geometryState.edgePeerNeighbors[i];if(null!=e){{const r=t.level-e.level<=X.maxTileNeighborLevelDelta;r||(console.log(`tile level delta [${t.lij.toString()}] vs [${e.lij.toString()}] > ${X.maxTileNeighborLevelDelta}  (edge[${i}])`),J.weakAssert(r,`tile level delta [${t.level}] vs [${e.level}] > ${X.maxTileNeighborLevelDelta}`))}J.weakAssert(t.level-e.level<=X.maxTileNeighborLevelDelta,`Max tile lod delta exceeded: [${t.lij.toString()}] vs [${e.lij.toString()}]`)}}const r=t.level-X.maxTileNeighborLevelDelta,s=e=>e.leaf||e.level===t.level,a=t.findNeighborTile(J.neighborEdgeIndices[i],s);if(null!=a){if(t.leaf&&t.level>=X.maxTileNeighborLevelDelta){let i=a;for(;t.level-i.level<X.maxTileNeighborLevelDelta;)i=i.parent;const s=[r,t.lij[1]>>X.maxTileNeighborLevelDelta,t.lij[2]>>X.maxTileNeighborLevelDelta];if(!Z.lijEquals(s,i.lij)){const r=e.get(i);J.weakAssert(!r.has(t),"Cannot already have neighbor"),r.add(t)}}J.weakAssert(a.rendered||a.level===t.level,"Non-same-level-neighbor of rendered must be rendered"),J.weakAssert(t.level-a.level<=X.maxTileNeighborLevelDelta,`Tile level delta [${t.level}] vs [${a.level}] > ${X.maxTileNeighborLevelDelta}`)}}})),this._allTiles.forAll((t=>{const i=t.maxLevelDeltaNeighborCount,r=e.get(t);J.weakAssert(i===r.size,`Tile[${t.lij.toString()}] merge-blocker mismatch: actual ${i} vs ${r.size}`)}))}_updateAllTilesStatus(e){if(!this._viewChanged||!this._rootTiles||e.done)return;this._viewChanged=!1;const t=new we(this._allTiles.length);t.pushAll(this._rootTiles);const i=this.snapLevel,r=this._splitLimits,s=this._eyePosRenderSR;this._allTiles.forAll((e=>{e.maxLevelDeltaNeighborCount=0,e.unmergableChildCount=0}));const a=this.view.state.contentCamera.viewProjectionMatrix;for(;!t.empty;){const e=t.pop(),l=e.parent,n=null!=l&&l.hasPendingUpdate(te.TileUpdate.MERGE),o=n?te.TileUpdate.MERGE:e.shouldSplit(r,s,i),d=o===te.TileUpdate.SPLIT;e.leaf?Ee(e,d):t.pushAll(e.children),n?(e.resetPendingUpdate(te.TileUpdate.SPLIT),e.leaf||e.setPendingUpdate(te.TileUpdate.MERGE),this._updateClippingStatus(e),e.updateVisibility(),e.updateScreenDepth(a)):d?(e.resetPendingUpdate(te.TileUpdate.MERGE),e.leaf&&e.setPendingUpdate(te.TileUpdate.SPLIT)):(e.resetPendingUpdate(te.TileUpdate.SPLIT)&&e.updateAgentSuspension(),o===te.TileUpdate.ELEVATION&&e.updateAgents(q.LayerClass.ELEVATION),e.leaf||(e.setPendingUpdate(te.TileUpdate.MERGE),e.resetPendingUpdate(te.TileUpdate.SPLIT)))}this.requestUpdate(),(this._shortBatches||!this._oneBatchPerFrameTask)&&this._updatePendingTileGeometries(),e.madeProgress()}_sortTiles(e){e.done||this._allTilesSorted||(ie.sortTilesByPOI(this._allTiles,this.view.pointsOfInterest.focus.renderLocation),this._allTilesSorted=!0,this._treeDebugger&&this._treeDebugger.update(),e.madeProgress())}_markTileToUpdate(e){J.internalAssert(e.loaded),e.intersectsClippingArea&&(this._pendingTilesToUpdate.add(e),this._markAllTileNeighborsForUpdate(e))}_updatePendingTileGeometries(){const e=this._pendingTilesToUpdate,t=Array.from(e.keys()).filter((e=>e.loaded&&e.intersectsClippingArea));if(0===t.length)return void e.clear();const i=(i,r)=>{!r?.loaded||!r.intersectsClippingArea||r.level<i.level||e.has(r)||(e.add(r),t.push(r),r.renderData.updateNeighborData())};t.sort(ie.compareTilesByLij);const r=t.length;for(let s=0;s<r;++s){const r=t[s];J.internalAssert(r.loaded),J.internalAssert(r.intersectsClippingArea);const a=r.renderData;a.updateNeighborData();const l=a.dirtyEdgeResolutions,n=a.geometryState,o=e=>{const t=J.neighborCornerIndices[e];i(r,n.cornerPeerNeighbors[e]?.findCorner(J.oppositeCorner(t),(e=>e.loaded)))};for(let t=0;t<4;++t)if(l&1<<t){const s=a.geometryState.edgePeerNeighbors[t];s&&s?.level>=r.level&&s.forAllSubtreeOnSide(J.oppositeEdge(J.neighborEdgeIndices[t]),(t=>!(!t.loaded||!t.intersectsClippingArea)&&(J.internalAssert(e.has(t)||ie.compareTilesByLij(r,t)<0),i(r,t),!0))),o((t+1)%4),o(t)}}e.clear(),this._updateTilesGeometries(t),this._shouldEmitChangeEvent=!0,J.enableTerrainInternalChecks&&J.enableWaterproofTests&&this.checkAllTilesWaterproofness()}_mergeAndSplit(e,t){if(this.suspended||e.done||!this._allTilesDirty)return;this._allTilesDirty=!1,this.requestUpdate();let i=!1;const r=this.view.state.fixedContentCamera;let s=!1;for(;!e.done;){s=!0;let a=!1;const l=!this._allTiles.some((s=>{if(!i&&!r&&!s.visible)return e.done;let l=s;if(s.hasPendingUpdate(te.TileUpdate.MERGE)){if(!t||s.unmergableChildCount>0)return e.done;for(s.resetPendingUpdate(te.TileUpdate.MERGE);null!=l.parent&&0===l.parent.unmergableChildCount&&l.parent.resetPendingUpdate(te.TileUpdate.MERGE);)l=l.parent;this._mergeTile(l),a=!0,e.madeProgress()}else if(s.resetPendingUpdate(te.TileUpdate.SPLIT)){let t=!0;const i=s.level;if(i>=X.maxTileNeighborLevelDelta){const e=e=>e.leaf||i-e.level<X.maxTileNeighborLevelDelta;for(let r=0;r<4;++r){const a=s.findNeighborTile(J.neighborEdgeIndices[r],e);null!=a&&i-a.level===X.maxTileNeighborLevelDelta&&(t=!1,J.enableTerrainInternalChecks&&(J.internalAssert(a.leaf),J.internalAssert(a.hasPendingUpdate(te.TileUpdate.SPLIT))))}}t?(this._splitTile(s),e.madeProgress(),a=!0):s.setPendingUpdate(te.TileUpdate.SPLIT)}return e.done}));if(a&&(this._allTilesSorted=!1,this._allTilesDirty=!0,!this._oneBatchPerFrameTask&&this._updatePendingTileGeometries()),l){if(!i){i=!0;continue}if(!a)break}else this._allTilesDirty=!0}s?e.madeProgress():this._allTilesDirty=!0,!this._oneBatchPerFrameTask&&this._updatePendingTileGeometries(),this._sortTiles(e)}_updateElevation(e){e.done||(this._allTiles.some((t=>(t.resetPendingUpdate(te.TileUpdate.GEOMETRY)&&(this._updateTileGeometryState(t),this._shortBatches&&this._updatePendingTileGeometries(),e.madeProgress()),e.done))),!this._oneBatchPerFrameTask&&this._updatePendingTileGeometries())}_updateTextures(e){e.done||this._allTiles.some((t=>(this._updateTileTexture(t,e),e.done)))}_updateClippingExtent(){this.spatialReference&&(this.updateTileOverlayParams(oe.RenderRequestType.UPDATE),this.overlayManager.setPlacementDirty(),this._updateRootTiles())}get _lodBias(){const e=this.view.quality;return this.view.qualitySettings.tiledSurface.lodBias-(1-e)*X.maxMemoryLodBias}_getLodBiasCorrectedScale(e){const t=this.tilingScheme.levels,i=d.clamp(e-this._lodBias,0,t.length-1),r=i-Math.floor(i);return t[Math.floor(i)].scale*(1-r)+t[Math.ceil(i)].scale*r}_removeAllTiles(){null!=this._rootTiles&&(this._rootTiles.forEach((e=>this._purgeTile(e))),this._setRootTiles(null),this.notifyChange("ready")),this._allTiles.clear(),this.renderer.visible=!1}_purgeSubtree(e){const t=e.children;t[0]&&(this._purgeTile(t[0]),this._purgeTile(t[1]),this._purgeTile(t[2]),this._purgeTile(t[3]),e.clearChildren())}_purgeTile(e){e.leaf?be(e):this._purgeSubtree(e),this._allTiles.removeUnordered(e),this._unloadTile(e),e.dispose(),this._tileCache.put(ce._tileMemcacheKey,e)}_unloadTile(e){this._pendingTilesToUpdate.delete(e),this._pendingTilesForElevationUpdateEvent.delete(e),e.unload(this._renderer)}_splitTile(e){J.weakAssert(e.leaf,"Tile that is already split should not be split again!"),J.weakAssert(e.rendered,"Tile marked to split is not rendered"),be(e);const t=e.createChildren();this._allTiles.pushArray(t),e.updateAgentSuspension(),J.weakAssert(e.rendered,"parent should be rendered"),t.forEach((e=>this._loadTile(e))),t.forEach((e=>this._pendingTilesToUpdate.add(e))),this._unloadTile(e),this._markAllTileNeighborsForUpdate(e),this._emitTileScaleChange(e,e.level+1),this._allTilesDirty=!0,this._shortBatches&&this._updatePendingTileGeometries(),t.forEach((e=>Ee(e,e.hasPendingUpdate(te.TileUpdate.SPLIT)))),++this._performanceInfo.numSplit}_emitTileScaleChange(e,t=e.level){fe.spatialReference=this.spatialReference,fe.extent=e.extent,fe.scale=this._getLodBiasCorrectedScale(t),this.emit("scale-change",fe)}createTile(e,t,i,r){J.weakAssert(!!r,"createTile sanity check");const s=this._acquireTile(e,t,i,r);return s.updateClippingStatus(this.extent),s.updateScreenDepth(this.view.state.contentCamera.viewProjectionMatrix),this._shouldSplit(s)&&s.setPendingUpdate(te.TileUpdate.SPLIT),s}get _shortBatches(){return this.view.state.mode!==de.RenderState.IDLE}_mergeTile(e){J.weakAssert(!e.hasPendingUpdate(te.TileUpdate.SPLIT),"_mergeTile sanity check"),J.weakAssert(!e.leaf,"Cannot merge a leaf"),e.leaf||(this._purgeSubtree(e),J.weakAssert(!e.renderData,"_mergeTile sanity check"),this._loadTile(e),this._markTileToUpdate(e),this._emitTileScaleChange(e),this._shortBatches&&this._updatePendingTileGeometries(),Ee(e,!1),this._allTilesDirty=!0,++this._performanceInfo.numMerged)}_loadTile(e){e.load(),this.requestUpdate(),this._allTilesDirty=!0,this.overlayManager&&this.overlayManager.hasOverlays&&this.overlayManager.setTileParameters(e)}_handleLayerViewChanges(e=he.noBudget){if(!this._layerViewsDirty)return;this._layerViewsDirty=!1;let t=!1;const i=new Set;let r=-1;for(let s=this.view.allLayerViews.length-1;s>=0;s--){const e=this.view.allLayerViews.items[s];if(i.add(e.uid),J.isSurfaceLayerView(e)||J.isGroupLayerView(e))if(this._basemapLayerViewHandles.has(e.uid)&&!J.isGroupLayerView(e)){const i=this._layerClassFromLayerView(e),s=this._getLayerIdxByUID(i,e.uid);null!=s&&((s<r||null==r)&&(t=!0),r=s)}else this._registerTiledLayerView(e),e.layer.loaded&&(t=!0)}this._basemapLayerViewHandles.forEach(((e,r)=>{i.has(r)||(this._unregisterTiledLayerView(r),t=!0)})),t&&this._updateTiledLayers(),this.hasCompositeBlendMode=this._hasCompositeBlendMode(),this._evaluateTransparency(),e.madeProgress()}_allSurfaceLayersTransparent(){let e=0===this.view.map?.ground?.opacity;for(const t of this.view.allLayerViews.items)if(J.isMapTileLayerView(t)&&!D.isBaseLayer(t.layer)&&0!==t.fullOpacity)return e=!1,e;return e}_hasCompositeBlendMode(){for(const e of this.view.allLayerViews.items)if((J.isBlendableLayerView(e)||J.isGroupLayerView(e))&&le.isCompositeBlendMode(le.blendModeFromString[e.layer.blendMode]))return!0;return!1}_layerClassFromLayerView(e){return J.isElevationLayerView(e)?q.LayerClass.ELEVATION:q.LayerClass.MAP}_registerTiledLayerView(e){const t=[];if((J.isBlendableLayerView(e)||J.isGroupLayerView(e))&&t.push(g.watch((()=>e.layer.blendMode),(()=>{this.hasCompositeBlendMode=this._hasCompositeBlendMode(),this._updateTileTextures(G.TextureUpdate.UNFADED)}))),!J.isGroupLayerView(e)){const i=this._layerClassFromLayerView(e);t.push(g.watch((()=>e.suspended),(()=>this._updateTiledLayers()))),t.push(g.watch((()=>e.fullOpacity),(()=>this._updateTileTextures(G.TextureUpdate.UNFADED)))),t.push(g.watch((()=>"effectiveScaleRange"in e.layer?e.layer.effectiveScaleRange:null),(()=>this._restartAllAgents(i)))),t.push(e.on("data-changed",(()=>{const t=this._getLayerIdxByUID(i,e.uid);null!=t&&this._invalidateLayerData(t,i)})))}this._unregisterTiledLayerView(e.uid),this._basemapLayerViewHandles.set(e.uid,t)}_unregisterTiledLayerView(e){const t=this._basemapLayerViewHandles.get(e);if(t){for(const e of t)e.remove();this._basemapLayerViewHandles.delete(e)}}_updateTiledLayers(){if(!this.tilingScheme||this.view.suspended)return;const e=this.view.allLayerViews,t=[[],[]];let i=null;e.forEach((e=>{if(!e.layer||e.suspended||!J.isSurfaceLayerView(e)||!e.fullExtent)return;const r=this._layerClassFromLayerView(e);if(r===q.LayerClass.MAP){const t=e.displayLevelRange.maxLevel;t!==1/0&&(null===i||t>i)&&(i=t)}t[r].push(e)}));for(const r of q.LayerClasses){const e=this._layerViews[r],i=t[r];i.reverse();const s=i.length;let a=e.length!==s;const l=new Array(s),n=new Array(e.length);this._layerIndexByUid[r].clear();for(let t=0;t<s;t++){const s=i[t].uid;this._layerIndexByUid[r].set(s,t);const o=e.indexOf(i[t]);l[t]=o,t!==o&&(a=!0),o>-1&&(n[o]=t)}if(a){const e=this._postorderIterator;for(e.reset(this._rootTiles);!e.done;)e.next().modifyLayers(n,l,r);this._layerViews[r]=i,this._restartAllAgents(r),this._updateTilesVisibility(this._rootTiles)}}this.tilingScheme.ensureMaxLod(i)&&(this._viewChangeUpdate(),this.notifyChange("tilingScheme"))}_restartAllAgents(e){const t=this._postorderIterator;for(t.reset(this._rootTiles);!t.done;){const i=t.next();i.restartAgents(e),e===q.LayerClass.ELEVATION&&i.computeElevationBounds()}this._updateRootTileElevationBounds()}layerViewByIndex(e,t){return this._layerViews[t][e]}numLayers(e){return this._layerViews[e].length}_updateTileTextures(e){this._allTiles.forAll((t=>{t.updateAgents(q.LayerClass.MAP),e===G.TextureUpdate.IMMEDIATE?this.renderer.updateTileTexture(t,te.TileUpdate.TEXTURE_NOFADING):t.updateRenderData(q.LayerClass.MAP,e)})),this._evaluateTransparency()}_invalidateLayerData(e,t){this._allTiles.forAll((i=>i.removeLayerAgent(e,t))),this._allTiles.forAll((i=>i.invalidateLayerData(e,t)))}setTileTreeDirty(){this._allTilesDirty=!0}requestRender(e=oe.RenderRequestType.UPDATE){this.renderer.setNeedsRender(e)}requestUpdate(){1==++this._pendingUpdates&&(this._hasPendingUpdates=!0)}requestTileData(e,t,i,r){const s=this.layerViewByIndex(t,i),a=s.layer;return!a.tilemapCache||J.isVectorTileLayerView(s)?this._requestTileData(e,i,s,r):(++this._asyncWorkItems,a.tilemapCache.fetchAvailability(e.lij[0],e.lij[1],e.lij[2],{...r,timeout:6e3}).then((()=>--this._asyncWorkItems)).catch((t=>{throw--this._asyncWorkItems,_.throwIfAborted(r),_.isAbortError(t)||this._dataMissing(e,i,s),t})).then((()=>this._frameTask.schedule((()=>this._requestTileData(e,i,s,r)),r.signal))))}_requestTileData(e,t,i,r){if(this._destroying)return Promise.resolve();const s=t===q.LayerClass.ELEVATION;return r.requester??=s?this._elevationDataRequester:this._mapDataRequester,s?J.isElevationLayerView(i)?this._requestElevationTileData(e,i,r):Promise.reject():J.isMapTileLayerView(i)?this._requestMapTileData(e,i,r):Promise.reject()}_requestElevationTileData(e,t,i){++this._asyncWorkItems;const r=r=>{!_.isAborted(i)&&r&&(this._usedMemory=null,this.requestUpdate(),this._elevationDataArrived(e,t,r))},s=i=>{_.isAbortError(i)||(o.getLogger(this).error(`Tile ${e.lij.toString()} layer ${q.LayerClass.ELEVATION}/${t.uid} error ${i}`),this._dataMissing(e,q.LayerClass.ELEVATION,t),this.requestUpdate())};return t.fetchTile(e.lij,i).then((e=>this._frameTask.schedule((()=>r(e)))),s).finally((()=>--this._asyncWorkItems))}_elevationDataArrived(e,t,i){const r=this._layerIndexByUid[q.LayerClass.ELEVATION].get(t.uid);if(null==r)return void o.getLogger(this).warn("TerrainSurface: received data from unknown layer %d %s",q.LayerClass.ELEVATION,e.lij.toString());const s=new j.ElevationData(e.lij,e.extent,i);e.dataArrived(r,q.LayerClass.ELEVATION,s);const a=[e],l=e.level,n=this._iteratorPool.acquire();for(n.reset(a);!n.done;){const e=n.next();e.findElevationBoundsForLayer(r,l),e.computeElevationBounds()}0===l&&this._updateRootTileElevationBounds(),n.remove(),this._updateTilesVisibility(a)}_requestMapTileData(e,t,i){++this._asyncWorkItems;const r=(r,s)=>{J.releaseTerrainData(s),_.isAborted(i)||(console.error(`Tile ${e.lij.toString()} layer ${q.LayerClass.MAP}/${t.uid} error ${r}`),this._dataMissing(e,q.LayerClass.MAP,t),this.requestUpdate())},s=e=>t=>r(t,e),a=r=>this._frameTask.schedule((()=>{this.requestUpdate(),_.isAborted(i)?J.releaseTerrainData(r):this._mapTileDataArrived(e,t,r)}),i.signal,s(r)).catch(s(r)),l=(e,t=null)=>this._frameTask.schedule((()=>r(e,t)));return t.fetchTile(e.lij,i).then(a,l).finally((()=>--this._asyncWorkItems))}_mapTileDataArrived(e,t,i){const r=this._getLayerIdxByUID(q.LayerClass.MAP,t.uid);if(null==r)return J.releaseTerrainData(i),void o.getLogger(this).warn("TerrainSurface: received data from unknown layer");e.dataArrived(r,q.LayerClass.MAP,i)}_getLayerIdxByUID(e,t){return this._layerIndexByUid[e].get(t)}_dataMissing(e,t,i){const r=this._getLayerIdxByUID(t,i.uid);null!=r?e.dataMissing(r,t):o.getLogger(this).warn("TerrainSurface: received data from unknown layer")}updateTileOverlayParams(e){this._rootTiles&&this.overlayManager&&(this._allTiles.forAll((e=>{e.renderData&&this.overlayManager.setTileParameters(e)})),this._renderer.setNeedsRender(e))}get performanceInfo(){const e=this._performanceInfo;return e.numNodes=this._allTiles.length,e.numLeaves=e.numVisible=e.numRendered=e.numLoadedPerLevel.length=e.numRenderedPerLevel.length=0,this._allTiles.forAll((t=>{t.leaf&&e.numLeaves++;const i=t.level;t.renderData&&(e.numLoadedPerLevel[i]=(e.numLoadedPerLevel[i]||0)+1),t.visible&&(e.numVisible++,t.rendered&&(e.numRenderedPerLevel[i]=(e.numRenderedPerLevel[i]||0)+1,e.numRendered++))})),e}get usedMemory(){return this.tilingScheme?(null==this._usedMemory&&(this._usedMemory=this._recalculateUsedMemory()),this._usedMemory??0):0}_recalculateUsedMemory(){return this.tilingScheme?Math.round(this._allTiles.reduce(((e,t)=>e+t.usedMemory),0)):null}getUsedMemoryForLayerView(e){let t=0;const i=this._layerClassFromLayerView(e),r=this._getLayerIdxByUID(i,e.uid);return null!=r&&this._allTiles.forAll((e=>t+=e.getUsedMemoryForLayer(i,r))),t}getTile(e){if(null==e||null==this._rootTiles)return null;const t=e.split("/").map((e=>+e));if(0===t[0])return this._rootTiles.find((e=>e.lij[1]===t[1]&&e.lij[2]===t[2]));const i=t[0],r=t[1]>>i,s=t[2]>>i;let a;if(this._rootTiles.some((e=>e.lij[1]===r&&e.lij[2]===s&&(a=e,!0))),a){let e=1<<t[0]-1;for(;a.lij[0]<t[0];){let i=t[1]&e?2:0;if((t[2]&e)>0&&i++,!a.children[i])return null;a=a.children[i],e>>=1}return J.weakAssert(a.lij[0]===t[0]&&a.lij[1]===t[1]&&a.lij[2]===t[2],"not the right tile?"),a}return null}get renderPatchBorders(){return this._renderer.renderPatchBorders}set renderPatchBorders(e){this._renderer.renderPatchBorders=e}get visualizeNormals(){return this._renderer.visualizeNormals}set visualizeNormals(e){this._renderer.visualizeNormals=e}get renderingDisabled(){return this._renderer.renderingDisabled}set renderingDisabled(e){this._renderer.renderingDisabled=e}get test(){}checkAllTilesWaterproofness(){if(!J.enableWaterproofTests)return;const e=this._rootTiles;if(null==e)return;const t=e=>e?.renderData?.geometry?.indices?.length>0,i=(e,i)=>{t(e)&&console.error("Tile[",e.lij,"] has geometry although parent[",i.lij,"] has geom")},r=e=>{if(e.intersectsClippingArea)if(e.renderData&&!e.renderData.geometryState&&console.error("Tile[",e.lij,"] has renderData but not geometryState"),e.renderData&&!e.renderData.geometry&&console.error("Tile[",e.lij,"] has renderData but not geometryInfo"),!e.renderData?.geometry||(e.renderData.geometry.indices?.length??0)>0||console.error("Tile[",e.lij,"] has renderData but no indices - geometryInfo: ",e.renderData.geometry),t(e)){e.checkGeometryWaterproofness();for(const t of e.children)i(t,e)}else if(e.leaf)console.error("Tile[",e.lij,"] has no geometry and no children, from root to leaf");else for(const t of e.children)r(t)},s=e=>{const t=e.parent?.visible??!0,i=e.visible;e.computeVisibility();const r=e.visible;if(i!==r&&t&&console.error(" Tile[",e.lij,"] has out of date visibility: ",i," instead of ",r),!e.leaf)for(const a of e.children)s(a)};for(const a of e)r(a),s(a)}get isGlobal(){return this._isGlobal}get isGeographic(){return this._isGeographic}get isWebMercator(){return this._isWebMercator}get isWebMercatorOnPlateCarree(){return this._isWebMercatorOnPlateCarree}isEastEndWrap(e){return this._isGlobal&&e[2]===this.lijEastEnd(e[0])-1}isWestEndWrap(e){return this._isGlobal&&0===e[2]}lijEastEnd(e){return 1<<e+(this._isGeographic?1:0)}wrapEastWest(e){const t=this.lijEastEnd(e[0]),i=e[2];if(0<=i&&i<t)return e;if(!this._isGlobal)return null;const r=(i+(i<0?t:0))%t;return[e[0],e[1],r]}enableInternalChecks(e){J.enableInternalTerrainChecks(e)}enableWaterproofnessChecks(e){J.enableTerrainWaterproofChecks(e)}};ue._tileMemcacheKey="TerrainTileMemcache",t.__decorate([y.property()],ue.prototype,"_renderer",void 0),t.__decorate([y.property({constructOnly:!0})],ue.prototype,"_scaleRangeQueries",void 0),t.__decorate([y.property({constructOnly:!0})],ue.prototype,"view",void 0),t.__decorate([y.property({constructOnly:!0})],ue.prototype,"overlayManager",void 0),t.__decorate([y.property()],ue.prototype,"_hasPendingUpdates",void 0),t.__decorate([y.property()],ue.prototype,"_asyncWorkItems",void 0),t.__decorate([y.property()],ue.prototype,"_allTilesDirty",void 0),t.__decorate([y.property()],ue.prototype,"_allTilesSorted",void 0),t.__decorate([y.property()],ue.prototype,"_viewChanged",void 0),t.__decorate([y.property({type:Number})],ue.prototype,"heading",void 0),t.__decorate([y.property()],ue.prototype,"_splitLimits",void 0),t.__decorate([y.property({readOnly:!0})],ue.prototype,"_watchUpdatingTracking",void 0),t.__decorate([y.property()],ue.prototype,"_frameTask",void 0),t.__decorate([y.property({readOnly:!0})],ue.prototype,"snapLevel",null),t.__decorate([y.property({readOnly:!0})],ue.prototype,"lodSnappingEnabled",null),t.__decorate([y.property()],ue.prototype,"_userClippingExtent",null),t.__decorate([y.property()],ue.prototype,"_rootTilesExtent",void 0),t.__decorate([y.property({readOnly:!0})],ue.prototype,"extent",null),t.__decorate([y.property({readOnly:!0})],ue.prototype,"groundExtent",null),t.__decorate([y.property({readOnly:!0})],ue.prototype,"_tilingSchemeExtent",null),t.__decorate([y.property({readOnly:!0})],ue.prototype,"updating",null),t.__decorate([y.property({readOnly:!0})],ue.prototype,"running",null),t.__decorate([y.property(k.updatingProgress)],ue.prototype,"updatingProgress",void 0),t.__decorate([y.property({readOnly:!0})],ue.prototype,"updatingProgressValue",null),t.__decorate([y.property()],ue.prototype,"_maxNumUpdating",void 0),t.__decorate([y.property()],ue.prototype,"baseOpacity",null),t.__decorate([y.property()],ue.prototype,"hasCompositeBlendMode",void 0),t.__decorate([y.property({readOnly:!0})],ue.prototype,"viewingMode",null),t.__decorate([y.property()],ue.prototype,"maxTextureScale",void 0),t.__decorate([y.property({readOnly:!0})],ue.prototype,"ready",null),t.__decorate([y.property({value:$.RenderOrder.FRONT_TO_BACK})],ue.prototype,"renderOrder",null),t.__decorate([y.property({readOnly:!0})],ue.prototype,"rootTiles",null),t.__decorate([y.property()],ue.prototype,"_rootTiles",void 0),t.__decorate([y.property({readOnly:!0})],ue.prototype,"spatialReference",null),t.__decorate([y.property({type:i})],ue.prototype,"backgroundColor",null),t.__decorate([y.property({value:!1})],ue.prototype,"slicePlaneEnabled",null),t.__decorate([y.property({readOnly:!0})],ue.prototype,"tilingScheme",void 0),t.__decorate([y.property({readOnly:!0})],ue.prototype,"tilingSchemeLocked",null),t.__decorate([y.property({readOnly:!0})],ue.prototype,"tilingSchemeLogic",void 0),t.__decorate([y.property()],ue.prototype,"wireframe",null),t.__decorate([y.property({value:!1})],ue.prototype,"suspended",null),t.__decorate([y.property()],ue.prototype,"fadeDuration",null),t.__decorate([y.property()],ue.prototype,"visibleElevationBounds",void 0),t.__decorate([y.property()],ue.prototype,"rootTileElevationBounds",void 0),t.__decorate([y.property()],ue.prototype,"_layerViewsDirty",void 0),t.__decorate([y.property()],ue.prototype,"renderPatchBorders",null),t.__decorate([y.property()],ue.prototype,"visualizeNormals",null),t.__decorate([y.property()],ue.prototype,"renderingDisabled",null),ue=ce=t.__decorate([T.subclass("esri.views.3d.terrain.TerrainSurface")],ue);const _e=ue,ge=f.create(),ye=M.create(),Te=C.create();new u;const me=new I.ElevationUpdateEvent("ground"),fe={spatialReference:null,extent:null,scale:0};function ve(e,t,i){for(const r of e){if(!r.containsPointXY(t,i))continue;let e=r;for(;e&&!e.renderData;){const r=(t>e.extentMidX?1:0)+(i<e.extentMidY?2:0);e=e.children[r]}const s=e?.renderData?.geometryState.samplerData??null;return j.sampleElevation(t,i,s)}return null}class we{constructor(e){this.capacity=e,this._head=0,this._tail=0,this._data=new Array(e)}push(e){const t=this._tail;if(!(t<this.capacity))throw new Error("Queue full");this._data[t]=e,this._tail=t+1}pushAll(e){const t=e.length;if(0===t)return;const i=this._tail;if(!(i+t<=this.capacity))throw new Error("Queue full");for(let r=0;r<t;++r)this._data[i+r]=e[r];this._tail=i+t}pop(){const e=this._head;if(e<this._tail){const t=this._data[e];return this._head=e+1,t}}get empty(){return this._head>=this._tail}get full(){return this._tail>=this._data.length}}function Ee(e,t){!e.leaf||e.level<X.maxTileNeighborLevelDelta||Ce(e,(e=>{t&&Le(e);const i=Se(e);if(e.maxLevelDeltaNeighborCount++,i){let t=e.parent;for(;t;){const e=Se(t);if(t.unmergableChildCount++,!e)break;t=t.parent}}}))}function Le(e){if(e.hasPendingUpdate(te.TileUpdate.SPLIT))return;let t=e.parent;for(;t?.resetPendingUpdate(te.TileUpdate.MERGE);)t=t.parent;e.resetPendingUpdate(te.TileUpdate.MERGE),e.leaf&&e.setPendingUpdate(te.TileUpdate.SPLIT),e.level<X.maxTileNeighborLevelDelta||Ce(e,(e=>{Le(e)}))}function be(e){e.level<X.maxTileNeighborLevelDelta||Ce(e,(e=>{if(e.maxLevelDeltaNeighborCount--,0===e.maxLevelDeltaNeighborCount&&0===e.unmergableChildCount){let t=e.parent;for(;t&&(t.unmergableChildCount--,Se(t));)t=t.parent}}))}function Se(e){return 0===e.maxLevelDeltaNeighborCount&&0===e.unmergableChildCount}function Ce(e,t){if(e.level<X.maxTileNeighborLevelDelta)return;const i=e.level-X.maxTileNeighborLevelDelta,r=e.lij[1]>>X.maxTileNeighborLevelDelta,s=e.lij[2]>>X.maxTileNeighborLevelDelta,a=e=>e.leaf||e.level===i;for(let l=0;l<4;++l){const n=e.findNeighborTile(J.neighborEdgeIndices[l],a);if(!n||n.level!==i)continue;const o=n.lij;o[1]===r&&o[2]===s||t(n)}}return _e}));
