/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../core/mathUtils","../../../core/maybe","../../../core/ObjectPool","../../../chunks/vec32","../../../core/libs/gl-matrix-2/factories/vec3f64","../../../geometry/ellipsoidUtils","../../../geometry/support/aaBoundingRect","../../../chunks/sphere","../../../layers/support/layerUtils","./ElevationBounds","./ElevationTileAgent","./interfaces","./LayerClass","./MapTileAgent","./NeighborIndex","./TerrainConst","./TerrainData","./terrainUtils","./TileAgent","./TileFrustumVisibility","./TilePerLayerInfo","./TileUpdate","./tileUtils"],(function(e,t,i,s,n,r,a,l,o,h,d,u,c,g,p,_,f,y,T,m,A,v,M,E){"use strict";const I=.1;class L{constructor(){this._lij=[0,0,0],this._children=[null,null,null,null],this._pendingUpdates=0,this.renderData=null,this._dirty=!0,this._previouslyRendered=!1,this.extent=l.create(),this._elevationBoundsMin=NaN,this._elevationBoundsMax=0,this.layerInfo=[[],[]],this.extentInRadians=l.create(),this.centerAtSeaLevel=r.create(),this._center=[r.create(),o.create(),r.create()],this.up=r.unitZ(),this._withinClippingArea=!0,this._intersectsClippingArea=!0,this._maxTesselation=0,this._usedMemory=0,this._rasterTileMemory=0,this._vectorTileMemory=0,this._mapDataRefCount=0,this.screenDepth=0,this.renderOrder=0,this._edgeLen=0,this._edgeLen2=0,this._curvatureHeight=0,this.extentMidX=0,this.extentMidY=0,this.distanceToPOI=-1,this._lastPOI=r.create(),this.maxLevelDeltaNeighborCount=0,this.unmergableChildCount=0}get lij(){return this._lij}get elevationLevelDelta(){return this._surface.getElevationLevelDelta(this.level)}static prune(){b.prune(0),C.prune(0),v.TilePerLayerInfo.prune()}get _cached(){return!this.leaf&&this._mapDataRefCount<=0}get withinClippingArea(){return this._withinClippingArea}get intersectsClippingArea(){return this._intersectsClippingArea}get clippingArea(){return this._clippingArea}get parent(){return this._parent}get children(){return this._children}get surface(){return this._surface}get elevationBoundsMin(){return this._elevationBoundsMin}get elevationBoundsMax(){return this._elevationBoundsMax}get level(){return this._lij[0]}get key(){return`${this._lij[0]}/${this._lij[1]}/${this._lij[2]}`}get edgeLen(){return this._edgeLen}get radius(){return this._center[e.CenterPosition.MIDDLE][3]}get visible(){return this._dirty&&this.computeVisibility(),this._visible}get frustumVisibility(){return this._dirty&&this.computeVisibility(),this._frustumVisibility}computeVisibility(){this._dirty=!1;const e=this.parent,t=e?.frustumVisibility??A.TileFrustumVisibility.INTERSECTS;this._frustumVisibility=t===A.TileFrustumVisibility.INSIDE?A.TileFrustumVisibility.INSIDE:t===A.TileFrustumVisibility.OUTSIDE?A.TileFrustumVisibility.OUTSIDE:this._calculateFrustumVisibilityStatus(this.surface.frustum);const i=this._frustumVisibility!==A.TileFrustumVisibility.OUTSIDE&&this._intersectsClippingArea;i!==this._visible&&(this._visible=i,this._surface.emit("tiles-visibility-changed"),this._surface.renderer.setDirty(),this.updateAgentSuspension())}get loadable(){return this.visible||this._surface.view.state.fixedContentCamera}get rendered(){const e=!!this.renderData;return e!==this._previouslyRendered&&(this._surface.emit("tiles-visibility-changed"),this._previouslyRendered=e,this._surface.renderer.setDirty()),e}init(t,i,s,n,r){this._lij[0]=t,this._lij[1]=i,this._lij[2]=s,this.ellipsoid=a.getReferenceEllipsoid(r.tilingScheme.spatialReference),r.tilingScheme.getExtent(t,i,s,this.extent),r.tilingScheme.convertExtentToRadians(this.extent,this.extentInRadians),this.extentMidX=.5*(this.extent[0]+this.extent[2]),this.extentMidY=.5*(this.extent[1]+this.extent[3]),this._withinClippingArea=!0,this._intersectsClippingArea=!0,this._clippingArea=null,this._mapDataRefCount=0,r.upsampleMapCache.pop(this.key),this._edgeLen=0,this._edgeLen2=0,this._center[e.CenterPosition.MIDDLE][3]=0,this.elevationLevel=t,n&&!Number.isNaN(n.elevationBoundsMin)?(this._elevationBoundsMin=n.elevationBoundsMin,this._elevationBoundsMax=n.elevationBoundsMax):(this._elevationBoundsMin=0,this._elevationBoundsMax=0),this._pendingUpdates=0,this.renderData=null,this.screenDepth=0,this._visible=!1,this._previouslyRendered=!1,this._parent=n,this.clearChildren(),this._surface=r,this.updateVisibility(),this.maxLevelDeltaNeighborCount=0,this.unmergableChildCount=0;for(const e of g.LayerClasses){const t=r.numLayers(e),i=this.layerInfo[e];for(const e of i)e.release();i.length=t;for(let s=0;s<t;s++)i[s]=v.TilePerLayerInfo.acquire(this._surface.upsampleInfoPool),e===g.LayerClass.ELEVATION&&this.findElevationBoundsForLayer(s,-1)}this.computeElevationBounds(),this._maxTesselation=Math.min(r.tilingScheme.pixelSize,f.maxPatchTesselation)}dispose(){T.weakAssert(!this.renderData,"tile.renderData was not unloaded"),this._surface.upsampleMapCache.pop(this.key),this.layerInfo.forEach((e=>{e.forEach((e=>e.release())),e.length=0})),this._parent=null,this.clearChildren(),this.setMemoryDirty()}refMapData(){++this._mapDataRefCount,this._cached||this._surface.upsampleMapCache.pop(this.key)}unrefMapData(){if(--this._mapDataRefCount,this._cached){const e=this._cachedMemory;e>0&&this._surface.upsampleMapCache.put(this.key,this,e)}}setMemoryDirty(){this._usedMemory=0}get usedMemory(){return this._ensureUsedMemory()+(this._cached?0:this._mapTileMemory)}get _cachedMemory(){return this._ensureUsedMemory(),this._cached?this._mapTileMemory:0}get _mapTileMemory(){return this._rasterTileMemory+this._vectorTileMemory}get _cpuImageMemorySize(){const e=4,t=this._surface.tilingScheme.pixelSize;return t*t*e}_ensureUsedMemory(){if(this._usedMemory>0)return this._vectorTileMemory=this.layerInfo[g.LayerClass.MAP].reduce(((e,{data:t})=>e+(y.isVectorTile(t)?t.usedMemoryPerReference:0)),0),this._usedMemory;this._usedMemory=this._baseUsedMemory,this._rasterTileMemory=0,this._vectorTileMemory=0;for(const{data:t}of this.layerInfo[g.LayerClass.MAP])y.isVectorTile(t)?this._vectorTileMemory+=t.usedMemoryPerReference:this._rasterTileMemory+=this._getTerrainDataMemory(t);const e=this._cpuImageMemorySize;for(const t of this.layerInfo[g.LayerClass.ELEVATION])this._usedMemory+=t.data?e:0;return this.renderData&&(this._usedMemory+=this.renderData.estimatedGeometryMemoryUsage,this._rasterTileMemory+=this.renderData.texture?.usedMemory??0),this._cached&&this._surface.upsampleMapCache.updateSize(this.key,this,this._mapTileMemory),this._usedMemory}getUsedMemoryForLayer(e,t){const i=this.layerInfo[e][t];return i?.data?e===g.LayerClass.MAP?this._cached?0:this._getTerrainDataMemory(i.data):e===g.LayerClass.ELEVATION?this._cpuImageMemorySize:0:0}_getTerrainDataMemory(e){return y.isTileTexture(e)?e.texture.usedMemory:y.isRasterTile(e)?e.memoryUsage:y.isVectorTile(e)?e.usedMemoryPerReference:y.isImageWithType(e)||e instanceof HTMLImageElement?this._cpuImageMemorySize:0}updateScreenDepth(t){const i=this._center[e.CenterPosition.MIDDLE],s=t,n=i[0],r=i[1],a=i[2],l=s[2]*n+s[6]*r+s[10]*a+s[14];this.screenDepth=l<0?0:l/(s[3]*n+s[7]*r+s[11]*a+s[15])}shouldSplit(t,i,s){if(!this.visible)return M.TileUpdate.NONE;if(t.frustum&&(!this._intersectsClippingArea||this._calculateFrustumVisibilityStatus(t.frustum)===A.TileFrustumVisibility.OUTSIDE))return M.TileUpdate.NONE;const r=this.level;n.subtract(R,o.getCenter(this._center[e.CenterPosition.MIDDLE]),i);let a=n.squaredLength(R),l=R,h=o.getCenter(this._center[e.CenterPosition.MIDDLE]);n.subtract(w,this._center[e.CenterPosition.TOP],i);const d=n.squaredLength(w);d<a&&(a=d,l=w,h=this._center[e.CenterPosition.TOP]),n.subtract(q,this._center[e.CenterPosition.BOTTOM],i);const u=n.squaredLength(q);if(u<a&&(a=u,l=q,h=this._center[e.CenterPosition.BOTTOM]),this._edgeLen2>a&&r<t.maxLod)return M.TileUpdate.SPLIT;const c=Math.sqrt(a),g=t.fovX*c*2,p=this._edgeLen/g,_=()=>{if(r<t.maxLod)return this.elevationLevel=r,M.TileUpdate.NONE;const e=r+Math.ceil(-Math.log2(t.relativeWidthLimit/p));return e!==this.elevationLevel?(this.elevationLevel=e,M.TileUpdate.ELEVATION):M.TileUpdate.NONE},f=null!=s?s-r:1/0;if(f<=.5)return _();const y=n.dot(this.up,R),T=this._elevationBoundsMax-this._elevationBoundsMin,m=T/this.edgeLen;if(t.aboveGround&&y>0&&m<.001){if(y/c-Math.sin(this._curvatureHeight/(this.edgeLen*Math.SQRT1_2)*Math.PI)-m>0)return M.TileUpdate.NONE}const v=null!=s?3-Math.min(f,2):1;if(p*v<t.relativeWidthLimit||r>=t.maxLod)return _();if(r<7)return M.TileUpdate.SPLIT;n.scale(j,this.up,y),n.subtract(j,j,l);const E=n.squaredLength(j);if(E<=this.radius*this.radius)return M.TileUpdate.SPLIT;n.scale(j,j,this.radius/Math.sqrt(E)),n.add(j,j,h),n.subtract(j,i,j);const L=Math.min(1,(Math.abs(n.dot(j,this.up))+.5*T+this._curvatureHeight)/n.length(j)),D=I/t.angledSplitBias,x=t.fovY*c*2;return L*(this._edgeLen/x*v)<D*t.relativeHeightLimit?M.TileUpdate.NONE:M.TileUpdate.SPLIT}createChildren(){const e=this._children,t=this.lij[0]+1,i=2*this.lij[1],s=2*this.lij[2];return e[0]=this.surface.createTile(t,i,s,this),e[1]=this.surface.createTile(t,i,s+1,this),e[2]=this.surface.createTile(t,i+1,s,this),e[3]=this.surface.createTile(t,i+1,s+1,this),e}clearChildren(){this._children[0]=this._children[1]=this._children[2]=this._children[3]=null}get loaded(){return this.renderData?.hasGeometry??!1}load(){this.refMapData();for(const e of g.LayerClasses)this._createOrUpdateAgents(0,e);this.surface.renderer.loadTile(this)}unload(e){this.renderData&&this.unrefMapData(),e.unloadTile(this);for(const t of g.LayerClasses){const e=this.layerInfo[t];for(const t of e)t.loadingAgent&&t.loadingAgent!==m.tileAgentDone&&(x(t.loadingAgent),t.loadingAgent=null),t.pendingUpdates=0}this.resetPendingUpdate(M.TileUpdate.GEOMETRY),this.resetPendingUpdate(M.TileUpdate.TEXTURE_NOFADING),this.resetPendingUpdate(M.TileUpdate.TEXTURE_FADING)}unloadMapData(){const e=this.layerInfo[g.LayerClass.MAP];for(const t of e)t.loadingAgent&&t.loadingAgent!==m.tileAgentDone&&(x(t.loadingAgent),t.loadingAgent=null),t.pendingUpdates=0,t.invalidateSourceData();this.renderData&&this.renderData.releaseTexture(),this.setMemoryDirty()}updateClippingStatus(e){if(l.equals(e,this._clippingArea))return!1;const t=this._intersectsClippingArea,i=this._withinClippingArea;null!=e?(this._intersectsClippingArea=this.intersectsExtent(e),this._withinClippingArea=this._isWithinExtent(e)):(this._intersectsClippingArea=!0,this._withinClippingArea=!0),this._clippingArea=e,this.updateVisibility();const s=i&&this._withinClippingArea,n=!(i||t||this._withinClippingArea||this._intersectsClippingArea);return!this.renderData||s||n||this.setPendingUpdate(M.TileUpdate.GEOMETRY),!0}updateVisibility(){this._dirty=!0,this._surface.setTileTreeDirty()}getLayerInfo(e,t){return this.layerInfo[t][e]}hasLayerData(e,t){const i=this.layerInfo[t][e];return!(!i?.data||i.dataInvalidated)}get updating(){if(this.hasPendingUpdates)return!0;for(const e of g.LayerClasses){const t=this.layerInfo[e];for(const e of t)if(e.loadingAgent&&e.loadingAgent!==m.tileAgentDone&&e.loadingAgent.updating)return!0}return!1}_isSuspended(e){return!!this.hasPendingUpdate(M.TileUpdate.SPLIT)||e!==g.LayerClass.ELEVATION&&!this.loadable}get hasPendingUpdates(){return 0!==this._pendingUpdates}hasPendingUpdate(e){return(this._pendingUpdates&e)===e}setPendingUpdate(e){const t=this._pendingUpdates;return this._pendingUpdates|=e,e===M.TileUpdate.SPLIT||e===M.TileUpdate.MERGE?this._surface.setTileTreeDirty():this._surface.requestUpdate(),t!==this._pendingUpdates}resetPendingUpdate(e){return!!this.hasPendingUpdate(e)&&(this._pendingUpdates&=~e,!0)}requestLayerData(e,t,s){const n=this.layerInfo[t][e];if(n.waitingAgents.has(s))return console.warn("agent already requested this piece of map data (tile %s, agent tile %s, layer: %d/%d)",this._lij.toString(),s.tile.lij.toString(),t,e),!0;if(n.waitingAgents.push(s),n.data&&!n.dataInvalidated){console.warn("agent requested existing data (tile %s, agent tile %s, layer: %d/%d)",this._lij.toString(),s.tile.lij.toString(),t,e);const i=y.isVectorTile(n.data);return s.dataArrived(this,i),!0}if(n.requestPromise)return!0;i.abortMaybe(n.requestAbort),n.requestAbort=new AbortController;const r=this._surface.requestTileData(this,e,t,n.requestAbort);if(!r)return n.requestAbort=null,!1;const a=()=>{n.requestPromise===r&&(n.requestPromise=null,n.requestAbort=null)};return n.requestPromise=r,r.then(a,a),!0}get leaf(){return null==this._children[0]}hasLij(e){return this._lij[0]===e[0]&&this._lij[1]===e[1]&&this._lij[2]===e[2]}findByLij(e){if(this.hasLij(e))return this;const t=this._children;if(!t[0])return null;return t[0].findByLij(e)||t[1].findByLij(e)||t[2].findByLij(e)||t[3].findByLij(e)}distanceToSquared(t){return n.squaredLength(n.subtract(j,o.getCenter(this._center[e.CenterPosition.MIDDLE]),t))}containsPoint(e){const t=this.extent;return e[0]>=t[0]&&e[1]>=t[1]&&e[0]<=t[2]&&e[1]<=t[3]}containsPointXY(e,t){const i=this.extent;return e>=i[0]&&t>=i[1]&&e<=i[2]&&t<=i[3]}unrequestLayerData(e,t,i){const s=this.layerInfo[t][e],n=s.waitingAgents,r=null!=n.removeUnordered(i);T.weakAssert(r,"agent has not requested this piece of map data"),n.length<1&&(s.abortRequest(),this.setMemoryDirty())}dataArrived(e,t,i){const s=y.isVectorTile(i),n=this.layerInfo[t][e];n.data=i,n.dataInvalidated=!1,n.waitingAgents.forAll((e=>e.dataArrived(this,s))),n.waitingAgents.clear(),this.setMemoryDirty()}dataMissing(e,t){const i=this.layerInfo[t][e];i.dataMissing=!0,i.waitingAgents.forAll((e=>e.dataMissing())),i.waitingAgents.clear(),this.setMemoryDirty()}updateRenderData(e,t,i){switch(i&&this.forEachLoadedNeighbor((i=>i.updateRenderData(e,t))),e){case g.LayerClass.MAP:return this._updateTexture(t);case g.LayerClass.ELEVATION:return this._updateGeometry()}}_updateTexture(e){this.renderData&&(this.resetPendingUpdate(e===c.TextureUpdate.FADING?M.TileUpdate.TEXTURE_NOFADING:M.TileUpdate.TEXTURE_FADING),this.setPendingUpdate(e===c.TextureUpdate.FADING?M.TileUpdate.TEXTURE_FADING:M.TileUpdate.TEXTURE_NOFADING))}_updateGeometry(){this.setPendingUpdate(M.TileUpdate.GEOMETRY);for(const e of this.layerInfo[g.LayerClass.ELEVATION])e.pendingUpdates|=M.TileUpdate.GEOMETRY}invalidateLayerData(e,t){this.layerInfo[t][e].invalidateSourceData(),this.restartAgents(t)}computeElevationBounds(){const e=this._elevationBoundsMin,t=this._elevationBoundsMax;let i=1/0,s=-1/0;const n=this.layerInfo[g.LayerClass.ELEVATION];let r=!0;for(const a of n)null!=a.elevationBounds&&(i=Math.min(i,a.elevationBounds.min),s=Math.max(s,a.elevationBounds.max),a.elevationBounds.hasNoDataValues||(r=!1));r&&(i=Math.min(i,0),s=Math.max(s,0)),e===i&&t===s||(this._elevationBoundsMin=i,this._elevationBoundsMax=s,this.updateRadiusAndCenter(),this._surface.setTileTreeDirty())}_updateCenter(){const t=this._elevationBoundsMin,i=this._elevationBoundsMax,s=.5*(t+i),r=this._center;n.scale(j,this.up,s),n.add(o.getCenter(r[e.CenterPosition.MIDDLE]),this.centerAtSeaLevel,j),n.scale(j,this.up,t),n.add(r[e.CenterPosition.TOP],this.centerAtSeaLevel,j),n.scale(j,this.up,i),n.add(r[e.CenterPosition.BOTTOM],this.centerAtSeaLevel,j)}findElevationBoundsForLayer(e,t){const i=this.layerInfo[g.LayerClass.ELEVATION][e],s=this.elevationLevelDelta,n=Math.max(this.elevationLevel-s,0),r=i.elevationBounds;if(null!=r&&r.level>=t&&r.level<=n)return;const a=this._surface.layerViewByIndex(e,g.LayerClass.ELEVATION);if(!E.fallsWithinLayerView(this,a))return;const l=U;let o=!1;const h=i.data;if(h&&h.level<=n){const e=i.data;l.min=e.samplerData.data.minValue,l.max=e.samplerData.data.maxValue,l.hasNoDataValues=e.samplerData.data.hasNoDataValues,l.level=this.level,o=!0}else{let t,i,r=0;for(let a=this._parent;a&&(!i||r<s)&&(r=this.elevationLevel-a.level,t=i||t,i=a.layerInfo[g.LayerClass.ELEVATION][e].data,!(!i&&t&&a.level<=n));a=a.parent);i=i||t,i&&(i.computeMinMaxValue(this._lij[0],this._lij[1],this._lij[2],l),l.min!==1/0&&(l.level=i.level,o=!0))}o&&(null==i.elevationBounds&&(i.elevationBounds=new d.ElevationBounds),i.elevationBounds.copyFrom(l))}modifyLayers(e,t,i){const s=this.layerInfo[i];for(const a of s)a.loadingAgent&&a.loadingAgent!==m.tileAgentDone&&(x(a.loadingAgent),a.loadingAgent=null),a.waitingAgents.clear();for(let a=0;a<s.length;++a)void 0===e[a]&&s[a].release();const n=new Array(...s),r=t.length;s.length=r;for(let a=0;a<r;a++){const e=t[a];s[a]=e>-1?n[e]:v.TilePerLayerInfo.acquire(this._surface.upsampleInfoPool)}this.setMemoryDirty()}restartAgents(e){this.renderData&&(this._createOrUpdateAgents(0,e),this.updateRenderData(e,c.TextureUpdate.FADING))}updateAgents(e){if(this.renderData){const t=this.layerInfo[e];for(const e of t)e.loadingAgent===m.tileAgentDone&&(e.loadingAgent=null);this._createOrUpdateAgents(0,e)}}updateAgentSuspension(){for(const e of g.LayerClasses){const t=this._isSuspended(e);for(const i of this.layerInfo[e])i.loadingAgent&&i.loadingAgent!==m.tileAgentDone&&(i.loadingAgent.setSuspension(t),i.loadingAgent===m.tileAgentDone&&this.updateRenderData(e,c.TextureUpdate.FADING))}}removeLayerAgent(e,t){const i=this.layerInfo[t][e];i.loadingAgent&&i.loadingAgent!==m.tileAgentDone&&i.loadingAgent.dispose(),i.loadingAgent=null}agentDone(e,t){const i=this.layerInfo[t][e];i.loadingAgent=m.tileAgentDone,i.data||null!=i.upsampleInfo||this._createOrUpdateAgents(e+1,t)}_hasBlendableAncestor(e){return"normal"!==e.blendMode||h.isGroupLayer(e.parent)&&this._hasBlendableAncestor(e.parent)}_hasBlendModes(e,t,i){for(let s=e;s<t;++s){const e=this._surface.layerViewByIndex(s,i);if(T.isBlendableLayerView(e)&&"normal"!==e?.layer?.blendMode||h.isGroupLayer(e?.layer?.parent)&&this._hasBlendableAncestor(e?.layer?.parent))return!0}return!1}_createOrUpdateAgents(e,t){const i=this.layerInfo[t];if(0===i.length)return;const s=this._isSuspended(t);for(let n=e;n<i.length;++n){const r=i[n],a=this._surface.layerViewByIndex(n,t);let l=!1;if(r.loadingAgent?E.fallsWithinLayerView(this,a)?(r.loadingAgent!==m.tileAgentDone&&r.loadingAgent.setSuspension(s),r.loadingAgent!==m.tileAgentDone&&(l=r.loadingAgent.update())):r.dispose():E.fallsWithinLayerView(this,a)&&(r.loadingAgent=D(this,n,t,s),l=r.loadingAgent.startLoading(),l?r.loadingAgent===m.tileAgentDone&&this.setPendingUpdate(M.TileUpdate.GEOMETRY):(x(r.loadingAgent),r.loadingAgent=m.tileAgentDone)),r.loadingAgent===m.tileAgentDone&&this.updateRenderData(t,c.TextureUpdate.FADING),!this._hasBlendModes(e,i.length,t)&&l&&a.isOpaque)return}}_isWithinExtent(e){const t=this.extent;return t[0]>=e[0]&&e[2]>=t[2]&&t[1]>=e[1]&&e[3]>=t[3]}intersectsExtent(e){const t=this.extent;return t[2]>=e[0]&&e[2]>=t[0]&&t[3]>=e[1]&&e[3]>=t[1]}getElevationVerticesPerSide(e){const i=this.elevationLevel-this.level,s=Math.max(this.level-e,this.elevationLevelDelta-i),n=t.clamp(1+(this._maxTesselation>>s),2,this._maxTesselation+1),r=this.minimumVerticesPerSide;return Math.max(n,r)}_findLIJ(e,t){if(!e)return null;const i=this.surface.rootTiles;if(null!=i)for(const s of i)if(S(s,e)){let i=s,n=e[0]-i.level-1;for(;n>=0&&!i.leaf&&!t(i);){const t=e[1]>>n&1,s=e[2]>>n&1;i=i.children[2*t+s],n--}return t(i)?i:null}return null}findNeighborTile(e,t){const i=this._lij,s=this._getNeighborLIJ(i,e);return s?P(i,s)?t(this)?this:null:this._findLIJ(s,t):null}findCorner(e,t){const i=e===_.NeighborIndex.NORTH_EAST?1:e===_.NeighborIndex.NORTH_WEST?0:e===_.NeighborIndex.SOUTH_WEST?2:3;let s=this;for(;s.children[0]&&(!t||!t(s));)s=s.children[i];return s}findNeighborCornerTileExact(e,t){return this.findNeighborTile(e,(e=>t(e)||e.level===this.level))?.findCorner(T.oppositeCorner(e),t)||null}forAllSubtreeOnSide(e,t){const i=e===_.NeighborIndex.NORTH?[0,1]:e===_.NeighborIndex.NORTH_EAST?[1]:e===_.NeighborIndex.EAST?[1,3]:e===_.NeighborIndex.SOUTH_EAST?[3]:e===_.NeighborIndex.SOUTH?[2,3]:e===_.NeighborIndex.SOUTH_WEST?[2]:e===_.NeighborIndex.WEST?[0,2]:[0],s=e=>{const n=e.children;!t(e)&&n[0]&&i.forEach((e=>s(n[e])))};s(this)}getNeighborEdgeStartVertexIndex(e,t){if(!t)return 0;const i=this.level-t.level;if(T.internalAssert(!T.enableTerrainInternalChecks||i>=0),0===i)return 0;const s=2**i,n=!(1&~e),r=n?0:1,a=t.lij[r+1]*s,l=this._lij[r+1],o=l-a,h=n?s-1-o:o;return T.enableTerrainInternalChecks&&(T.internalAssert(a<=l&&l<a+s),T.internalAssert(0<=h&&h<s)),h}forEachLoadedNeighbor(e){const t=this.level,i=e=>e.level===t||e.loaded;T.neighborEdgeIndices.forEach((t=>{const s=this.findNeighborTile(t,i);null!=s&&s!==this&&s.forAllSubtreeOnSide(T.oppositeEdge(t),(i=>!!i.loaded&&(e(i,t),!0)))})),T.neighborCornerIndices.forEach((t=>{const s=this.findNeighborTile(t,i)?.findCorner(T.oppositeCorner(t),(e=>e.loaded));T.internalAssert(!s||O(this,s,t)),s?.loaded&&e(s,t)}))}_getNeighborLIJ(e,t){const i=T.isNorth(t)?-1:T.isSouth(t)?1:0,s=T.isWest(t)?-1:T.isEast(t)?1:0,n=[e[0],e[1]+i,e[2]+s];return n[1]<0?null:this.surface.isGlobal?this._wrapLIJ(n):n[2]<0?null:n}_wrapLIJ(e){return!e||e[1]<0||e[1]>=2**e[0]?null:this.surface.wrapEastWest(e)}isEdgeNeighbor(e,t){if(null==e)return!1;if(0===this.level&&0===e.level){if(this._eastEnd&&e._westEnd&&t===_.NeighborIndex.EAST)return!0;if(this._westEnd&&e._eastEnd&&t===_.NeighborIndex.WEST)return!0}const i=Math.max(1e-6*(this.extent[2]-this.extent[0]),1);switch(t){case _.NeighborIndex.NORTH:return T.almostEquals(this.extent[3],e.extent[1],i);case _.NeighborIndex.SOUTH:return T.almostEquals(this.extent[1],e.extent[3],i);case _.NeighborIndex.EAST:return T.almostEquals(this.extent[2],e.extent[0],i)||T.almostEquals(this.extent[2],-e.extent[0],i);case _.NeighborIndex.WEST:return T.almostEquals(this.extent[0],e.extent[2],i)||T.almostEquals(this.extent[0],-e.extent[2],i)}}get _eastEnd(){return this._lij[2]===this.surface.lijEastEnd(this.level)-1}get _westEnd(){return 0===this._lij[2]}checkGeometryWaterproofness(){T.enableWaterproofTests&&(T.internalAssert(this.loaded),this.renderData?.checkGeometryWaterproofness())}shouldHaveNeighbor(e){const t=this.extent,i=this.surface.rootTilesExtent,s=.25*(t[2]-t[0]);if(T.isNorth(e)&&t[3]+s>=i[3])return!1;if(T.isSouth(e)&&t[1]-s<=i[1])return!1;const n=this.surface.isGlobal;return!(!n&&T.isWest(e)&&t[0]-s<=i[0])&&!(!n&&T.isEast(e)&&t[2]+s>=i[2])}updateDistanceToPOI(t){const i=this._lastPOI;if(this.distanceToPOI>=0&&i[0]===t[0]&&i[1]===t[1]&&i[2]===t[2])return;n.copy(this._lastPOI,t);const s=this._center[e.CenterPosition.MIDDLE],r=t[0]-s[0],a=t[1]-s[1],l=t[2]-s[2];this.distanceToPOI=r*r+a*a+l*l}}function D(e,t,i,s){const n=i===g.LayerClass.ELEVATION?C.acquire():b.acquire();return n.init(e,t,i,s),n}function x(e){e.dispose(),u.isElevationTileAgent(e)?C.release(e):p.isMapTileAgent(e)&&b.release(e)}const b=new s(p.MapTileAgent),C=new s(u.ElevationTileAgent),U=new d.ElevationBounds;var N;function S(e,t){const i=e.lij,s=t[0]-i[0];return!(s<0)&&(t[1]>>s===i[1]&&t[2]>>s===i[2])}function P(e,t){return e[0]===t[0]&&e[1]===t[1]&&e[2]===t[2]}function O(e,t,i){return null!=e&&null!=t&&t!==e&&(e.level>=t.level?B(e,t,i):B(t,e,T.oppositeCorner(i)))}function B(e,t,i){T.internalAssert(e.level>=t.level);const s=T.isWestCorner(i),n=T.isNorthCorner(i),r=e.extent,a=t.extent,l=[s?r[0]:r[2],n?r[3]:r[1]],o=[s?a[2]:a[0],n?a[1]:a[3]],h=1e-5*(r[2]-r[0]),d=T.almostEquals(l[0],o[0],h)||e.surface.isGlobal&&T.almostEquals(l[0],-o[0],h),u=T.almostEquals(l[1],o[1],h);if(d&&u)return!0;if(e.level===t.level)return T.internalAssert(!1),!1;if(!d&&!u)return T.internalAssert(!1),!1;const c=d?V(a[1],a[3],r[1],r[3],h):V(a[0],a[2],r[0],r[2],h);return T.internalAssert(c),c}function V(e,t,i,s,n){return e-n<=i&&i<=s&&s<=t+n}e.CenterPosition=void 0,(N=e.CenterPosition||(e.CenterPosition={}))[N.TOP=0]="TOP",N[N.MIDDLE=1]="MIDDLE",N[N.BOTTOM=2]="BOTTOM";const R=r.create(),w=r.create(),q=r.create(),j=r.create();e.Tile=L,e.isCornerNeighbor=O,e.lijEquals=P,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
