/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../core/Logger","../../../core/maybe","../../../core/libs/gl-matrix-2/factories/vec2f64","../../2d/engine/imagery/enums","../../2d/engine/vectorTiles/VectorTileRendererHelper3D","./BlendLayersTechnique","./BlendLayersTechniqueConfiguration","./LayerClass","./RasterColorizerTechnique","./RasterColorizerTechniqueConfiguration","./support/MultiSizeFramebuffer","../webgl-engine/core/shaderLibrary/output/BlendOptions","../webgl-engine/core/shaderLibrary/terrain/BaseOpacityMode","../webgl-engine/core/shaderLibrary/terrain/BlendLayersOutput","../webgl-engine/core/shaderLibrary/terrain/PremultipliedAlphaSource","../../../chunks/BlendLayers.glsl","../webgl-engine/lib/BindParameters","../webgl-engine/lib/glUtil3D","../../webgl/enums","../../webgl/Texture","../../webgl/Util"],(function(e,r,t,i,s,o,a,n,l,u,c,d,h,_,p,f,y,b,g,T,B,C){"use strict";const m=()=>r.getLogger("esri.views.3d.terrain");class O{constructor(e,r){this._rctx=e,this._techniques=r,this._fbos=[],this._vectorTileHelper=new o.VectorTileRendererHelper3D,this._bindParameters=new b.BindParameters(null),this._blendLayersTechniqueConfig=new n.BlendLayersTechniqueConfiguration,this._current=0,this._lastUsedIds=new Array,this._lastCreatedBufferId=0,this._onHoldIds=new Array,this._vaoQuad=g.createQuadVAO(this._rctx,g.Layout.Pos2Tex)}dispose(){this._fbos.forEach(t.disposeMaybe),this._fbos=null,this._vtFBO=t.disposeMaybe(this._vtFBO),this._vaoQuad=t.disposeMaybe(this._vaoQuad),this._vectorTileHelper=t.disposeMaybe(this._vectorTileHelper)}updateHeading(e){this._vectorTileHelper?.updateHeading(e)}_acquireBlendLayersTechnique(e,r,t,i=f.PremultipliedAlphaSource.Off,s=y.BackgroundMode.BelowLayer){return this._blendLayersTechniqueConfig.output=r,this._blendLayersTechniqueConfig.blendMode=e,this._blendLayersTechniqueConfig.baseOpacityMode=t,this._blendLayersTechniqueConfig.premultipliedSource=i,this._blendLayersTechniqueConfig.background=s,this._techniques.precompile(a.BlendLayersTechnique,this._blendLayersTechniqueConfig),this._techniques.acquire(a.BlendLayersTechnique,this._blendLayersTechniqueConfig)}drawBackground(e,r){const t=this._acquireBlendLayersTechnique(h.LayerBlendMode.Normal,r?p.BlendLayersOutput.ColorComposite:p.BlendLayersOutput.GridComposite,_.BaseOpacityMode.NotRequired,f.PremultipliedAlphaSource.Off,y.BackgroundMode.Only),i=this._rctx.bindTechnique(t,this._bindParameters,e);this._render(i),t.release()}_render(e){this._rctx.bindVAO(this._vaoQuad),e.assertCompatibleVertexAttributeLocations(this._vaoQuad),this._rctx.drawArrays(T.PrimitiveType.TRIANGLE_STRIP,0,C.vertexCount(this._vaoQuad,"geometry"))}drawGroup(e,r,t,i,s=f.PremultipliedAlphaSource.On){r===p.BlendLayersOutput.Composite&&(e.fboTexture=this._fbos[this.getLastOnHoldId()].get(t).colorTexture),e.texture=this.currentFBO(t).colorTexture,this.closeGroup(t);const o=e.baseOpacity<1?_.BaseOpacityMode.Required:_.BaseOpacityMode.NotRequired,a=this._acquireBlendLayersTechnique(i,r,o,s),n=this._rctx.bindTechnique(a,this._bindParameters,e);this._render(n),a.release()}drawImageData(e,r,t,i,s=f.PremultipliedAlphaSource.Off){if(null==e.texture)return;const o=e.baseOpacity<1?_.BaseOpacityMode.Required:_.BaseOpacityMode.NotRequired;e.fboTexture=r===p.BlendLayersOutput.GroupBackgroundComposite||i===h.LayerBlendMode.Normal&&o===_.BaseOpacityMode.NotRequired&&s===f.PremultipliedAlphaSource.Off?null:this.switch(t).colorTexture;const a=this._acquireBlendLayersTechnique(i,r,o,s),n=this._rctx.bindTechnique(a,this._bindParameters,e);this._render(n),a.release()}drawRasterData(e,r,t,i,s){const o=s.sourceLayerInfo.data;if(!o.source)return;if(s.tile.surface.layerViewByIndex(s.layerIndex,l.LayerClass.MAP).ensureSymbolizerParameters(o),!o.bind(this._rctx))return;const a=e.baseOpacity<1?_.BaseOpacityMode.Required:_.BaseOpacityMode.NotRequired;e.fboTexture=i===h.LayerBlendMode.Normal&&a===_.BaseOpacityMode.NotRequired?null:this.switch(t).colorTexture;const n=this._acquireRasterColorizerTechnique(o,r,i,a);o.opacity=e.opacity;const u=o.getUniforms();u.scale=s.scale,u.offset=s.offset,u.backgroundColor=e.backgroundColor,u.fboTexture=e.fboTexture,u.baseOpacity=e.baseOpacity;const c=this._rctx.bindTechnique(n,this._bindParameters,u);this._render(c),n.release()}_acquireRasterColorizerTechnique(e,r,t,i){const o=e.symbolizerParameters,a=["stretch","lut","hillshade"].indexOf(o.type);return null==this._rasterColorizerConfig&&(this._rasterColorizerConfig=new c.RasterColorizerTechniqueConfiguration,this._rctx.gl.getExtension("WEBGL_color_buffer_float"),this._rctx.gl.getExtension("OES_texture_float")),this._rasterColorizerConfig.output=r,this._rasterColorizerConfig.blendMode=t,this._rasterColorizerConfig.baseOpacityMode=i,this._rasterColorizerConfig.colorizerType=a,this._rasterColorizerConfig.applyColormap=!!o.colormap,this._rasterColorizerConfig.requireBilinearWithNN=e.isBilinearWithStretchColorRamp,this._rasterColorizerConfig.stretchType=e.hasStretchTypeNone()?s.RasterColorizerStretchType.Noop:s.RasterColorizerStretchType.PerBand,this._techniques.precompile(u.RasterColorizerTechnique,this._rasterColorizerConfig),this._techniques.acquire(u.RasterColorizerTechnique,this._rasterColorizerConfig)}drawVectorData(e,r,t,s,o,a,n,u){const c=this._rctx,y=o.sourceLayerInfo.data,b=o.tile.surface.layerViewByIndex(o.layerIndex,l.LayerClass.MAP),g=e.baseOpacity<1?_.BaseOpacityMode.Required:_.BaseOpacityMode.NotRequired,B=g===_.BaseOpacityMode.Required||e.opacity<1||s!==h.LayerBlendMode.Normal||r!==p.BlendLayersOutput.Composite,C=B?f.PremultipliedAlphaSource.On:f.PremultipliedAlphaSource.Off,O=this._acquireBlendLayersTechnique(s,r,g,C);c.setPipelineState(O.getPipeline());let x=null,q=null;B?(q=this.currentFBO(t),null==this._vtFBO&&(this._vtFBO=new d.MultiSizeFramebuffer(this._rctx)),x=this._vtFBO.get(t),c.bindFramebuffer(x),this._clearCurrentFBO()):u&&c.clear(T.FramebufferBit.DEPTH);try{this._vectorTileHelper.renderBackground(c,o.sourceLod,b.painter,b.layer.styleRepository,b.schemaHelper,Math.round(1/o.scale),o.offset,n,a,b.contentZoom),y&&this._vectorTileHelper.renderContent(c,o.sourceLod,y,o.vtlNeighborInfos,b.painter,b.layer.styleRepository,b.schemaHelper,Math.round(1/o.scale),o.offset,n,a,b.contentZoom)}catch(L){m().warnOnce("A render call containing vector tiles did not resolve correctly.",L)}return O.release(),!x||(c.bindFramebuffer(q),e.texture=x.colorTexture,e.offset=i.ZEROS,e.scale=1,this.drawImageData(e,r,t,s,C),u)}copyFBOToTexture(e){const r=this._rctx,t=r.bindTexture(e.texture,B.Texture.TEXTURE_UNIT_FOR_UPDATES),i=e.descriptor;r.gl.copyTexImage2D(T.TextureType.TEXTURE_2D,0,i.pixelFormat,0,0,i.width,i.height,0),e.generateMipmap(),r.bindTexture(t,B.Texture.TEXTURE_UNIT_FOR_UPDATES)}_clearCurrentFBO(){this._rctx.setStencilWriteMask(255),this._rctx.setClearColor(0,0,0,0),this._rctx.setClearDepth(1),this._rctx.setClearStencil(0),this._rctx.clear(T.FramebufferBit.COLOR|T.FramebufferBit.DEPTH|T.FramebufferBit.STENCIL)}_initFBO(e,r,t){this._rctx.bindFramebuffer(e),t&&(this._rctx.setViewport(0,0,r,r),this._clearCurrentFBO())}ensureBuffer(e){this._lastUsedIds.length=0,this._lastUsedIds.push(1),this._lastCreatedBufferId=1,this._onHoldIds.length=0,this.bind(e)}bind(e,r=0,t=!0){if(this._current=r,r>=this._fbos.length)for(let i=this._fbos.length;i<=r;i++)this._fbos.push(new d.MultiSizeFramebuffer(this._rctx));this._initFBO(this._fbos[r].get(e),e,t)}_bindNextFreeBuffer(e){this._lastUsedIds.length>0?this.bind(e,this._lastUsedIds.pop()):(this._lastCreatedBufferId++,this.bind(e,this._lastCreatedBufferId))}openGroup(e){this._onHoldIds.push(this._current),this._bindNextFreeBuffer(e)}switch(e){const r=this.currentFBO(e),t=this._current;return this._bindNextFreeBuffer(e),this._lastUsedIds.push(t),r}getLastOnHoldId(){return this._onHoldIds[this._onHoldIds.length-1]}closeGroup(e){const r=this._current;this._bindNextFreeBuffer(e),this._lastUsedIds.push(r),this._lastUsedIds.push(this._onHoldIds.pop())}unbind(){this._rctx.bindFramebuffer(null)}currentFBO(e){return this._fbos[this._current].get(e)}}e.TileCompositor=O,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
