/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../core/has","../../../core/maybe","../../../core/libs/gl-matrix-2/math/vec2","../../../core/libs/gl-matrix-2/factories/vec2f64","../../../core/libs/gl-matrix-2/factories/vec4f64","../../../layers/support/layerUtils","./BlendLayersTechnique","./interfaces","./LayerClass","./NeighborIndex","./TerrainData","./terrainUtils","./TextureFader","./TextureReference","./TileCompositor","./TileRenderInfo","./TileTexture","./TileUpdate","./tileUtils","../webgl-engine/core/shaderLibrary/output/BlendOptions","../webgl-engine/core/shaderLibrary/terrain/BlendLayersOutput","../webgl-engine/lib/glUtil3D","../../webgl/enums","../../webgl/Texture","../../webgl/TextureDescriptor"],(function(e,t,r,s,a,i,o,n,u,l,c,d,p,h,T,y,f,_,m,x,g,b,I,L,w,O){"use strict";class P{constructor(e,t,r,s,a,i){this.start=e,this.end=t,this.blendMode=r,this.opacity=s,this.output=a,this.baseOpacity=i}}class R{constructor(e,t,r,s){this._rctx=e,this.tileSize=t,this._techniques=r,this._cache=s,this._passParameters=new n.BlendLayersPassParameters,this._backgroundTexture=null,this._backgroundColor=null,this._backgroundDirty=!1,this._maxAnisotropy=this._rctx.parameters.maxMaxAnisotropy,this._compositor=new y.TileCompositor(this._rctx,this._techniques),this._ensureBackgroundTexture(this.tileSize)}dispose(){this._compositor=r.disposeMaybe(this._compositor),this._backgroundTexture=r.releaseMaybe(this._backgroundTexture)}get backgroundIsGrid(){return null==this._backgroundColor}get backgroundColor(){return this._backgroundColor}updateHeading(e){this._compositor?.updateHeading(e)}updateTileTexture(e,t){if(!e.renderData)return;const r=e.surface,s=r.baseOpacity;let a=0,i=0,n=this.tileSize,c=!1,d=!1;const h=r.view.state.contentPixelRatio;let T=!1;C.clear(),N.length=0;const y=e.layerInfo[l.LayerClass.MAP];let f=0,_=null;for(;f<y.length;f++){const t=r.layerViewByIndex(f,l.LayerClass.MAP),u=t.layer,g=!x.fallsWithinLayerView(e,t),b=u.opacity,I=t.fullOpacity;if(d=d||o.isBaseLayer(u),p.isBlendableLayerView(t)){let e="normal"!==t.layer.blendMode;if(o.isGroupLayer(u.parent)){const t=u.parent.uid;null!=t&&""!==t&&(e=B(u.parent)||e)}e&&(T=e,c=!1)}if((g||0===b)&&!T){y[f].pendingUpdates&=~(m.TileUpdate.TEXTURE_NOFADING&m.TileUpdate.TEXTURE_FADING);continue}++i;const L=p.isVectorTileLayerView(t),w=M(e,f,L);if(w){if(y[f].pendingUpdates&=~(m.TileUpdate.TEXTURE_NOFADING&m.TileUpdate.TEXTURE_FADING),o.isGroupLayer(u.parent)){const e=u.parent.uid;null!=e&&""!==e&&E(u.parent,f)}L?n=Math.max(n,this.tileSize*h):1===s&&1===I&&(t.isOpaque||this._dataToTexture(w)&&w.sourceLayerInfo.data.descriptor.isOpaque)&&(c=!0),++a,null===_&&(_=f)}}const g=n/this.tileSize,b=this._ensureBackgroundTexture(this.tileSize);0!==a&&null!==_?1===a&&!T&&this._useLayerTexture(e,_)||this._composeLayers(e,t,f-1,d,n,g,!c||T,C,T):k(e,i,b,t!==u.TextureUpdate.FADING)}_ensureBackgroundTexture(e){return null==this._backgroundTexture&&(this._backgroundTexture=this._buildTexture(e,!1),this._backgroundDirty=!0),this._backgroundDirty&&(this._compositor.bind(e),this._passParameters.offset=a.ZEROS,this._passParameters.scale=1,this._passParameters.opacity=1,this.backgroundColor&&(this._passParameters.backgroundColor=this.backgroundColor),this._compositor.drawBackground(this._passParameters,null!=this.backgroundColor),this._compositor.copyFBOToTexture(this._backgroundTexture),this._compositor.unbind(),this._backgroundDirty=!1),this._backgroundTexture}_useLayerTexture(e,t){const r=e.surface.layerViewByIndex(t,l.LayerClass.MAP),s=o.isBaseLayer(r.layer),a=s?e.surface.baseOpacity:1,n=s?1:e.surface.baseOpacity,c=r.fullOpacity,d=M(e,t,!1);return!!this._dataToTexture(d)&&(e.renderData.setTextureReference(new T.TextureReference(d.sourceLayerInfo.data,u.TextureUpdate.FADING,i.fromValues(d.offset[0],d.offset[1],d.scale,d.scale),a,n,c)),!0)}_composeLayers(e,t,r,s,i,n,u,c,d){this._compositor.ensureBuffer(i);const h=e.surface.baseOpacity;let y=!1,f=L.TextureSamplingMode.LINEAR_MIPMAP_LINEAR,_=!1,m=0;for(let T=r;T>=0;T--){const t=e.surface.layerViewByIndex(T,l.LayerClass.MAP),r=t.layer,I=p.isVectorTileLayerView(t),w=M(e,T,I),O=r.opacity,P=!x.fallsWithinLayerView(e,t);if(!w||(0===O||P)&&!d)continue;const R=!o.isBaseLayer(r)&&!y;R&&(y=!0);let B=!1;c.forEach((e=>{e.start===T&&(e.output=s?b.BlendLayersOutput.Composite:u&&R?this.backgroundIsGrid?b.BlendLayersOutput.GridComposite:b.BlendLayersOutput.ColorComposite:b.BlendLayersOutput.Composite,e.baseOpacity=R?h:1,N.push(e),this._compositor.openGroup(i),B=!0)}));const E=0===m,k=B?b.BlendLayersOutput.GroupBackgroundComposite:u&&E?this.backgroundIsGrid?b.BlendLayersOutput.GridComposite:b.BlendLayersOutput.ColorComposite:b.BlendLayersOutput.Composite,C=g.blendModeFromString[p.isBlendableLayerView(t)?t.layer.blendMode:"normal"];for(this._passParameters.baseOpacity=R&&!B&&h<1?h:1,this._passParameters.opacity=O,p.isVectorTileRenderInfo(w)?_=this._compositor.drawVectorData(this._passParameters,k,i,C,w,n,this.tileSize,_):p.isImageryTileRenderInfo(w)?(this._compositor.drawRasterData(this._passParameters,k,i,C,w),A(w)&&(f=L.TextureSamplingMode.NEAREST)):this._dataToTexture(w)&&(this._passParameters.texture=w.sourceLayerInfo.data.texture,this._passParameters.offset=w.offset,this._passParameters.scale=w.scale,this._compositor.drawImageData(this._passParameters,k,i,C));N.length>0&&N[N.length-1].end===T;){const e=N.pop();this._passParameters.baseOpacity=e.baseOpacity,this._passParameters.opacity=e.opacity,this._passParameters.offset=a.ZEROS,this._passParameters.scale=1,this._compositor.drawGroup(this._passParameters,e.output,i,g.blendModeFromString[e.blendMode])}m++}const I=e.renderData,w=d||y&&h<1,O=I.ensureTexture(i,w,t,(()=>this._buildTexture(i,w,f)));this._compositor.copyFBOToTexture(O),this._compositor.unbind(),I.setTextureReference(new T.TextureReference(O,t,S,y?1:h,0,1))}_dataToTexture(e){if(p.isImageSourceRenderInfo(e)){const t=e.sourceLayerInfo;t.data=this._buildTexture(t.data,!0),e.tile.setMemoryDirty()}return p.isTextureTileRenderInfo(e)}setBackground(e){this._backgroundColor!==e&&(this._backgroundColor=e,this._backgroundDirty=!0)}_buildTexture(e,t,r=L.TextureSamplingMode.LINEAR_MIPMAP_LINEAR){if(null==e)return null;const s=new O.TextureDescriptor;s.wrapMode=L.TextureWrapMode.CLAMP_TO_EDGE,s.samplingMode=r,s.maxAnisotropy=this._maxAnisotropy,s.preMultiplyAlpha=!0,s.flipped=!0,s.hasMipmap=!0,t||(s.pixelFormat=L.PixelFormat.RGB);const a=this._rctx;let i;if("number"==typeof e)s.width=s.height=e,i=this._buildTileTexture(s,e);else if(d.isImageWithType(e))s.isOpaque=e.isOpaque,s.isOpaque&&(s.pixelFormat=L.PixelFormat.RGB),i=this._buildTileTexture(s,e.element.width,e.element);else try{s.width=e.width,s.height=e.height,i=this._buildTileTexture(s,e.width,e)}catch(n){i=new _(I.createEmptyTexture(a)),console.warn("TileRenderer: failed to execute 'texImage2D', cross-origin image may not be loaded.")}const o=a.bindTexture(i.texture,w.Texture.TEXTURE_UNIT_FOR_UPDATES);return i.generateMipmap(),a.bindTexture(o,w.Texture.TEXTURE_UNIT_FOR_UPDATES),i}_buildTileTexture(e,t,r){const s=`${t} ${e.pixelFormat}`,a=this._cache.pop(s);return a?(a.retain(),a.texture.setData(r),a):new _(new w.Texture(this._rctx,e,r),this._cache)}get test(){}}function M(e,t,r){D.layerIndex=t,D.vtlNeighborInfos.clear();const a=e.layerInfo[l.LayerClass.MAP][t];if(s.set(D.offset,0,0),D.tile=e,D.scale=1,D.sourceLod=e.lij,D.sourceLayerInfo=a,D.isVTLBackground=r,a.data)return r&&e.forEachLoadedNeighbor(((r,s)=>{if(r.level!==e.level)return;const i=r.layerInfo[l.LayerClass.MAP][t];if(!p.isVectorTilePerLayerInfo(i)||a.data===i.data)return;const o=D.vtlNeighborInfos.pushNew();o.offset=U[s],o.sourceLod=r.lij,o.sourceLayerInfo=i})),D;const i=a.upsampleInfo,o=i?.tile?.layerInfo[l.LayerClass.MAP][t];return o?(D.tile=i.tile,s.copy(D.offset,i.offset),D.scale=i.scale,D.sourceLod=i.tile.lij,D.sourceLayerInfo=o,D):r?D:null}function A(e){const t=e.sourceLayerInfo.data;return!!t.source&&"nearest"===t.interpolation}function B(e){let t="normal"!==e.blendMode;return o.isGroupLayer(e.parent)&&(t=B(e.parent)||t),t}function E(e,t){o.isGroupLayer(e.parent)&&E(e.parent,t);const r=e.uid;if(null!=r&&""!==r){const s=C.get(r);s?s.start=t:C.set(r,new P(t,t,e.blendMode,e.opacity,b.BlendLayersOutput.Composite,1))}}function k(e,t,r,s){const a=e.renderData,i=!s&&null!=a.textureReference&&(e.surface.view.layerViewManager.updating||t>0)?h.ActivationTime.Delayed:h.ActivationTime.Immediate;a.setTextureReference(new T.TextureReference(r,u.TextureUpdate.FADING,S,e.surface.baseOpacity,0,1),i)}const C=new Map,N=new Array,D=new f.TileRenderInfo,S=i.fromValues(0,0,1,1),U=new Array;U[c.NeighborIndex.NORTH]=[0,-1],U[c.NeighborIndex.NORTH_EAST]=[-1,-1],U[c.NeighborIndex.EAST]=[-1,0],U[c.NeighborIndex.SOUTH_EAST]=[-1,1],U[c.NeighborIndex.SOUTH]=[0,1],U[c.NeighborIndex.SOUTH_WEST]=[1,1],U[c.NeighborIndex.WEST]=[1,0],U[c.NeighborIndex.NORTH_WEST]=[1,-1],e.GroupInfo=P,e.TileRenderer=R,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
