/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../geometry","../../../core/Error","../../../core/has","../../../core/mathUtils","../../../core/unitUtils","../../../geometry/Extent","../../../geometry/SpatialReference","../../../geometry/support/aaBoundingRect","../../../geometry/support/spatialReferenceUtils","../../../geometry/support/webMercatorUtils","../../../layers/support/LOD","../../../layers/support/TileInfo","../../../geometry/Point"],(function(e,t,i,s,l,n,r,o,a,h,c,u,g,p){"use strict";const m=12;class f{constructor(e){const t=f.checkUnsupported(e);if(null!=t)throw t;const i=e;this.spatialReference=i.spatialReference,this._isWebMercator=this.spatialReference.isWebMercator,this._isGCS=h.isGeographic(this.spatialReference),this.origin=[i.origin.x,i.origin.y],this.pixelSize=i.size[0],this.dpi=i.dpi;const s=i.lods.reduce(((e,t)=>(t.level<e.minLod.level&&(e.minLod=t),e.max=Math.max(e.max,t.level),e)),{minLod:i.lods[0],max:-1/0}),l=s.minLod,n=2**l.level;let r=l.resolution*n,o=l.scale*n;this.levels=new Array(s.max+1);for(let a=0;a<this.levels.length;a++)this.levels[a]={resolution:r,scale:o,tileSize:[r*i.size[0],r*i.size[1]]},r/=2,o/=2}clone(){return new f(this.toTileInfo())}toTileInfo(){return new g({dpi:this.dpi,origin:new p({x:this.origin[0],y:this.origin[1],spatialReference:this.spatialReference}),size:[this.pixelSize,this.pixelSize],spatialReference:this.spatialReference,lods:this.levels.map(((e,t)=>new u({level:t,scale:e.scale,resolution:e.resolution})))})}getExtent(e,t,i,s){const l=this.levels[e],n=l.tileSize[0],r=l.tileSize[1];s[0]=this.origin[0]+i*n,s[2]=this.origin[0]+(i+1)*n,s[3]=this.origin[1]-t*r,s[1]=this.origin[1]-(t+1)*r}convertExtentToRadians(e,t){this._isWebMercator?(t[0]=c.x2lon(e[0]),t[1]=c.y2lat(e[1]),t[2]=c.x2lon(e[2]),t[3]=c.y2lat(e[3])):this._isGCS&&(t[0]=l.deg2rad(e[0]),t[1]=l.deg2rad(e[1]),t[2]=l.deg2rad(e[2]),t[3]=l.deg2rad(e[3]))}getExtentGeometry(e,t,i,s=new r){return this.getExtent(e,t,i,v),s.spatialReference=this.spatialReference,s.xmin=v[0],s.ymin=v[1],s.xmax=v[2],s.ymax=v[3],s.zmin=void 0,s.zmax=void 0,s}ensureMaxLod(e){if(null==e)return!1;let t=!1;for(;this.levels.length<=e;){const{resolution:e,scale:i}=this.levels[this.levels.length-1],s=e/2*this.pixelSize;this.levels.push({resolution:e/2,scale:i/2,tileSize:[s,s]}),t=!0}return t}capMaxLod(e){this.levels.length>e+1&&(this.levels.length=e+1)}getMaxLod(){return this.levels.length-1}scaleAtLevel(e){return this.levels[0].scale/2**e}levelAtScale(e){const t=this.levels[0].scale;return e>=t?0:Math.log(t/e)*Math.LOG2E}resolutionAtLevel(e){return this.levels[0].resolution/2**e}compatibleWith(e,t=1/0){if(f.checkUnsupported(e))return!1;const i=new f(e);if(!i.spatialReference.equals(this.spatialReference))return!1;if(i.pixelSize!==this.pixelSize)return!1;const s=Math.min(this.levels.length-1,i.levels.length-1,t),n=this.levels[s].resolution;let r=.5*n;if(!l.floatEqualAbsolute(i.origin[0],this.origin[0],r)||!l.floatEqualAbsolute(i.origin[1],this.origin[1],r))return!1;return r=.5*n/2**s/this.pixelSize*m,l.floatEqualAbsolute(n,i.levels[s].resolution,r)}rootTilesInExtent(e,t=null,i=1/0){const s=new Array,l=this.levels[0].tileSize;if(null==e||0===l[0]||0===l[1])return s;f.computeRowColExtent(e,l,this.origin,v);let n=v[1],r=v[3],o=v[0],a=v[2];const h=a-o,c=r-n;if(h*c>i){const e=Math.floor(Math.sqrt(i));c>e&&(n=n+Math.floor(.5*c)-Math.floor(.5*e),r=n+e),h>e&&(o=o+Math.floor(.5*h)-Math.floor(.5*e),a=o+e)}for(let u=n;u<r;u++)for(let e=o;e<a;e++)s.push([0,u,e]);return null!=t&&(t[0]=this.origin[0]+o*l[0],t[1]=this.origin[1]-r*l[1],t[2]=this.origin[0]+a*l[0],t[3]=this.origin[1]-n*l[1]),s}static computeRowColExtent(e,t,i,s){const l=.001*(e[2]-e[0]+(e[3]-e[1]));s[0]=Math.max(0,Math.floor((e[0]+l-i[0])/t[0])),s[2]=Math.max(0,Math.ceil((e[2]-l-i[0])/t[0])),s[1]=Math.max(0,Math.floor((i[1]-e[3]+l)/t[1])),s[3]=Math.max(0,Math.ceil((i[1]-e[1]-l)/t[1]))}static isPowerOfTwo(e){const t=e.lods,i=t[0].resolution*2**t[0].level;return!t.some((e=>!l.floatEqualRelative(e.resolution,i/2**e.level)))}static hasGapInLevels(e){const t=e.lods.map((e=>e.level));t.sort(((e,t)=>e-t));for(let i=1;i<t.length;i++)if(t[i]!==t[0]+i)return!0;return!1}static tileSizeSupported(e){const t=e.size[1];return t===e.size[0]&&!(t&t-1)&&t>=128&&t<=512}static hasOriginPerLODs(e){const t=e.origin;return e.lods.some((e=>null!=e.origin&&(e.origin[0]!==t.x||e.origin[1]!==t.y)))}static getMissingTileInfoError(){return new i("tilingscheme:tile-info-missing","Tiling scheme must have tiling information")}static checkUnsupported(e){return null==e?x():e.lods.length<1?new i("tilingscheme:generic","Tiling scheme must have at least one level"):f.isPowerOfTwo(e)?f.hasGapInLevels(e)?new i("tilingscheme:gaps","Tiling scheme levels must not have gaps between min and max level"):f.tileSizeSupported(e)?f.hasOriginPerLODs(e)?new i("tilingscheme:multiple-origin","Tiling scheme levels must not have their own origin"):null:new i("tilingscheme:tile-size","Tiles must be square and size must be one of [128, 256, 512]"):new i("tilingscheme:power-of-two","Tiling scheme must be power of two")}static fromExtent(e,t){const i=e[2]-e[0],s=e[3]-e[1],l=n.getMetersPerUnitForSR(t),r=1.2*Math.max(i,s),o=256,a=r/o,h=a*l*(96/.0254),c=new f(new g({size:[o,o],origin:new p({x:e[0]-.5*(r-i),y:e[3]+.5*(r-s)}),lods:[new u({level:0,resolution:a,scale:h})],spatialReference:t}));return c.ensureMaxLod(20),c}static makeWebMercatorAuxiliarySphere(e){const t=new f(f.WebMercatorAuxiliarySphereTileInfo);return t.ensureMaxLod(e),t}static makeGCSWithTileSize(e,t=256,i=16){const s=256/t,l=new f(new g({size:[t,t],origin:new p({x:-180,y:90,spatialReference:e}),spatialReference:e,lods:[new u({level:0,resolution:.703125*s,scale:295497598.570834*s})]}));return l.ensureMaxLod(i),l}get test(){}}function x(){return new i("tilingscheme:tile-info-missing","Tiling scheme must have tiling information")}f.WebMercatorAuxiliarySphereTileInfo=new g({size:[256,256],origin:new p({x:-20037508.342787,y:20037508.342787,spatialReference:o.WebMercator}),spatialReference:o.WebMercator,lods:[new u({level:0,resolution:156543.03392800014,scale:591657527.591555})]}),f.WebMercatorAuxiliarySphere=f.makeWebMercatorAuxiliarySphere(19);const v=a.create();e.TilingScheme=f,e.getMissingTileInfoError=x,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
