/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../core/Collection","../../../geometry/support/spatialReferenceUtils","../../../layers/support/layerUtils","../../ViewingMode","./NeighborIndex","./TerrainData","../../../chunks/terrainUtilsPlanar","../../../chunks/terrainUtilsSpherical"],(function(e,n,r,t,i,o,l,a,u){"use strict";const s={[i.ViewingMode.Global]:u.terrainUtilsSpherical,[i.ViewingMode.Local]:a.terrainUtilsPlanar};function T(e,n){e||console.warn("Terrain: "+n)}function c(n){e.enableWaterproofTests=n,e.enableTerrainInternalChecks=e.enableTerrainInternalChecks||n}function f(n){e.enableTerrainInternalChecks=n}function I(n,r){if(e.enableTerrainInternalChecks&&!n){const e=(new Error).stack?.slice(5);throw console.warn("Terrain internal: "+(r??"")+" at "+e),new Error("Assertion failed"+(r?": "+r:""))}}function d(e){return"imagery-tile"===e?.type||"wcs"===e?.type}function h(e){return"imagery-tile-3d"===e?.type}function g(e){return"tile-3d"===e?.type}function b(e){return"vector-tile-3d"===e?.type}function S(e){return"wmts-3d"===e?.type}function N(e){return"elevation-3d"===e?.type}function x(e){return"elevation"===e?.type}function E(e){return"group"===e?.type}function p(e){return e&&(g(e)||S(e)||h(e)||b(e))}function y(e){return e&&(g(e)||h(e)||b(e)||S(e))}function O(e){return y(e)||N(e)}function H(e){return l.isRasterTile(e?.sourceLayerInfo?.data)}function L(e){return w(e?.sourceLayerInfo)||!!e?.isVTLBackground}function W(e){return l.isTileTexture(e?.sourceLayerInfo?.data)}function R(e){const n=e?.sourceLayerInfo?.data;return l.isImageWithType(n)||n instanceof HTMLImageElement||n instanceof HTMLCanvasElement||n instanceof ImageData}function w(e){return l.isVectorTile(e?.data)}function m(e){return null!=e&&"release"in e&&e.release(),null}function V(e){return e.fetchTile&&!1!==e.hasOverriddenFetchTile}function _(e,n,r,t,i){return s[t].checkIfTileInfoSupportedForViewSR(e,r,n,i)}function A(e,n,r){let t=null,o=null;if("wmts"===e?.type){const i=C(e,n,r);t=i.tileInfo,o=i.fullExtent}else{o=d(e)?e.getCompatibleFullExtent(n):e.fullExtent;const l=r===i.ViewingMode.Local;if(d(e))t=e.getCompatibleTileInfo(n,o,l);else if("vector-tile"===e?.type){t=l&&!U(n)||k.force512VTL?e.tileInfo:e.tileInfo.getCompatibleForVTL(256)}else t=e.tileInfo}const l="tilemapCache"in e?e.tilemapCache?.effectiveMaxLOD:void 0;return null!=t&&null!=o&&null==_(t,o,n,r,l)?{tileInfo:t,fullExtent:o}:null}function C(e,r,i){const o=t.getTileMaxtrixSetFromActiveLayer(e);if(null!=o){if(!n.isCollection(o))return{tileInfo:o.tileInfo,fullExtent:o.fullExtent};{const e=o.find((e=>null==_(e.tileInfo,e.fullExtent,r,i)));if(e)return{tileInfo:e.tileInfo,fullExtent:e.fullExtent}}}return{tileInfo:null,fullExtent:null}}function U(e){return e.isWGS84||e.isWebMercator||r.isCGCS2000(e)||!r.isEarth(e)}e.enableTerrainInternalChecks=!1,e.enableWaterproofTests=!1;const k={force512VTL:!1};function v(e){return"["+e[0]+","+e[1]+","+e[2]+"]"}function M(e){return"("+e[0]+","+e[1]+","+e[2]+")"}function F(e,n,r=X){return Math.abs(e-n)<r}function P(e){return e===o.NeighborIndex.NORTH_EAST?o.NeighborIndex.SOUTH_WEST:e===o.NeighborIndex.NORTH_WEST?o.NeighborIndex.SOUTH_EAST:e===o.NeighborIndex.SOUTH_WEST?o.NeighborIndex.NORTH_EAST:o.NeighborIndex.NORTH_WEST}function D(e){return e===o.NeighborIndex.NORTH?o.NeighborIndex.SOUTH:e===o.NeighborIndex.EAST?o.NeighborIndex.WEST:e===o.NeighborIndex.SOUTH?o.NeighborIndex.NORTH:o.NeighborIndex.EAST}function G(e){return e===o.NeighborIndex.NORTH_WEST||e===o.NeighborIndex.SOUTH_WEST}function j(e){return e===o.NeighborIndex.NORTH_WEST||e===o.NeighborIndex.NORTH_EAST}function B(e){return e===o.NeighborIndex.NORTH_WEST||e===o.NeighborIndex.WEST||e===o.NeighborIndex.SOUTH_WEST}function q(e){return e===o.NeighborIndex.NORTH_EAST||e===o.NeighborIndex.EAST||e===o.NeighborIndex.SOUTH_EAST}function z(e){return e===o.NeighborIndex.SOUTH_EAST||e===o.NeighborIndex.SOUTH||e===o.NeighborIndex.SOUTH_WEST}function J(e){return e===o.NeighborIndex.NORTH_EAST||e===o.NeighborIndex.NORTH||e===o.NeighborIndex.NORTH_WEST}const K=[o.NeighborIndex.NORTH,o.NeighborIndex.EAST,o.NeighborIndex.SOUTH,o.NeighborIndex.WEST],Q=[o.NeighborIndex.NORTH_EAST,o.NeighborIndex.SOUTH_EAST,o.NeighborIndex.SOUTH_WEST,o.NeighborIndex.NORTH_WEST],X=1e-5;e.almostEquals=F,e.checkIfTileInfoSupportedForView=_,e.enableInternalTerrainChecks=f,e.enableTerrainWaterproofChecks=c,e.eps=X,e.getTileInfoAndExtentFromWMTSLayer=C,e.getTiledLayerInfo=A,e.internalAssert=I,e.isBlendableLayerView=p,e.isEast=q,e.isElevationLayer=x,e.isElevationLayerView=N,e.isGroupLayerView=E,e.isImageSourceRenderInfo=R,e.isImageryTileLayerView=h,e.isImageryTileRenderInfo=H,e.isMapTileLayerView=y,e.isNorth=J,e.isNorthCorner=j,e.isProjectableRasterLayer=d,e.isSouth=z,e.isSurfaceLayerView=O,e.isTextureTileRenderInfo=W,e.isTileLayerView=g,e.isVectorTileLayerView=b,e.isVectorTilePerLayerInfo=w,e.isVectorTileRenderInfo=L,e.isWMTSLayerView=S,e.isWest=B,e.isWestCorner=G,e.lij2s=v,e.neighborCornerIndices=Q,e.neighborEdgeIndices=K,e.oppositeCorner=P,e.oppositeEdge=D,e.releaseTerrainData=m,e.test=k,e.useFetchTileForLayer=V,e.v32s=M,e.vtlAssumes256PixelSizeAsDefault=U,e.weakAssert=T,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
