/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../chunks/tslib.es6","../../../core/Accessor","../../../core/has","../../../core/PooledArray","../../../core/promiseUtils","../../../core/accessorSupport/decorators/property","../../../core/Logger","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../state/helpers/SceneIntersectionHelper","./lib/ChangeSet","./lib/UpdatePolicy","./lib/WebGLLayer","./parts/Model","./parts/RenderView","../../support/Scheduler","../../support/Yield"],(function(e,t,r,s,i,n,d,o,a,h,y,c,l,_,p,g,u,S){"use strict";e.Stage=class extends r{constructor(e){super(e),this._model=new p.Model,this._layers=new i,this._asyncChangeSet=new c.ChangeSet,this._syncChangeSet=new c.ChangeSet,this._layerSyncSet=new Set}initialize(){this._set("renderView",new g.RenderView(this)),this._frameTask=this.view.resourceController.scheduler.registerTask(u.TaskPriority.STAGE,this),this.addHandles(this._frameTask)}destroy(){this.renderView.destroy()}get viewingMode(){return this.view.state.viewingMode}get updating(){return this.running||this.renderView.updating||this._frameTask.updating}get renderer(){return this.renderView?.renderer}add(e){this._model.add(e),_.isWebGLLayer(e)&&this._addLayer(e),this.renderView.requestRender()}remove(e){null!=e&&!this.destroyed&&this._model.remove(e)&&(_.isWebGLLayer(e)&&this._removeLayer(e),this.renderView.requestRender())}addMany(e){null!=e&&(this._model.addMany(e),this.renderView.requestRender())}removeMany(e){null!=e&&(this._model?.removeMany(e),this.renderView?.requestRender())}forEachOfType(e,t){this._model.forEachOfType(e,t)}handleEvent(e,t){this.destroyed||(this._model.dirtySet[e](t),this.renderView.requestRender())}get running(){return this._model.dirtySet.dirty||!this._asyncChangeSet.empty}runTask(e){if(this._frameTask.processQueue(e),this._commit(e),!e.hasProgressed)return S.Yield}_commit(e){const t=this._model.dirtySet;this._asyncChangeSet.empty||e.done||(this.renderer.modify(this._asyncChangeSet,e),this.renderView.requestRender(),e.madeProgress()),this._layers.forAll((r=>{if(e.done)return;const s=this._layerSyncSet.has(r.id)||r.updatePolicy===l.UpdatePolicy.SYNC,i=s?this._syncChangeSet:this._asyncChangeSet;t.commitLayer(r.id,i),this._layerSyncSet.delete(r.id),i.empty||(this.renderer.modify(i,s?u.noBudget:e),this.renderView.requestRender(),e.madeProgress())})),this._syncChangeSet.empty||(this.renderer.modify(this._syncChangeSet,u.noBudget),this.renderView.requestRender(),e.madeProgress()),this._layers.forAll((r=>{e.done||this._layerSyncSet.has(r.id)||r.updatePolicy!==l.UpdatePolicy.ASYNC||(t.commitLayer(r.id,this._asyncChangeSet),this._asyncChangeSet.empty||(this.renderer.modify(this._asyncChangeSet,e),this.renderView.requestRender(),e.madeProgress()))})),this._layerSyncSet.clear(),this.notifyChange("running")}commitSyncLayers(){const e=this._model.dirtySet;this._layers.forAll((t=>{this._layerSyncSet.has(t.id)||t.updatePolicy===l.UpdatePolicy.SYNC?(e.commitLayer(t.id,this._syncChangeSet),this._layerSyncSet.delete(t.id)):e.commitSyncUpdates(t.id,this._syncChangeSet)}));for(const t of this._layerSyncSet)e.commitLayer(t,this._syncChangeSet);this._layerSyncSet.clear(),this._syncChangeSet.empty||(this.renderer.modify(this._syncChangeSet,u.noBudget),this.renderView.requestRender())}_commitLayer(e){this._model.dirtySet.commitLayer(e.id,this._syncChangeSet),this._layerSyncSet.delete(e.id),this._syncChangeSet.empty||(this.renderer.modify(this._syncChangeSet,u.noBudget),this.renderView.requestRender())}schedule(e,t){return this._frameTask.schedule(e,t)}reschedule(e,t){return this._frameTask.reschedule(e,t)}syncLayer(e){this._layerSyncSet.add(e),this.renderView.requestRender()}getObject(e){return this._model.getObject(e)}get layers(){return this._layers}_addLayer(e){this._layers.includes(e)||this._layers.push(e)}_removeLayer(e){this._commitLayer(e),null!=this._layers.removeUnordered(e)&&(this._model.dirtySet.getResidentRenderGeometries(e.id,this._syncChangeSet.removes),this.renderer.modify(this._syncChangeSet,u.noBudget))}addRenderPlugin(e,t){const r=this.renderer.plugins.add(e,t),s=()=>{y.isIntersectionHandler(e)&&this.view.sceneIntersectionHelper.addIntersectionHandler(e)};if(n.isPromiseLike(r))return r.then(s);s()}removeRenderPlugin(e){this.destroyed||(y.isIntersectionHandler(e)&&this.view.sceneIntersectionHelper.removeIntersectionHandler(e),this.renderer.plugins.remove(e))}get performanceInfo(){return this._model.getStats()}get test(){}},t.__decorate([d.property({constructOnly:!0})],e.Stage.prototype,"view",void 0),t.__decorate([d.property({constructOnly:!0})],e.Stage.prototype,"options",void 0),t.__decorate([d.property({readOnly:!0})],e.Stage.prototype,"viewingMode",null),t.__decorate([d.property({constructOnly:!0})],e.Stage.prototype,"container",void 0),t.__decorate([d.property({readOnly:!0})],e.Stage.prototype,"updating",null),t.__decorate([d.property({constructOnly:!0})],e.Stage.prototype,"_model",void 0),t.__decorate([d.property()],e.Stage.prototype,"renderView",void 0),t.__decorate([d.property({readOnly:!0})],e.Stage.prototype,"renderer",null),t.__decorate([d.property({readOnly:!0})],e.Stage.prototype,"running",null),e.Stage=t.__decorate([h.subclass("esri.views.3d.webgl-engine.Stage")],e.Stage),Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
