/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","exports","../../../../../core/Logger","../../../../../core/PooledArray","../../../../../core/typedArrayUtil","../../../../../chunks/vec32","../../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../../geometry/support/aaBoundingBox","../../../../../geometry/support/Indices","../../../../../chunks/vec3","../../../../../chunks/vec33","../../../../ViewingMode","../../../layers/support/symbolColorUtils","../../../support/orientedBoundingBox","../../../support/buffer/glUtil","../../../support/buffer/InterleavedLayout","./ComponentData","./ComponentObject","./IntersectionGeometry","./Renderable","./RenderGeometry","./RenderSubmitSystem","./SourceGeometry","./UniformComponentParameters","./Material/ComponentMaterial","./Material/ComponentTechnique","./Material/shader/ComponentData.glsl","../../effects/geometry/olidUtils","../../lib/ComponentUtils","../../lib/Util","../../lib/VertexAttribute","../../lib/verticalOffsetUtils","../../lib/TextureBackedBuffer/BufferManager","../../../../webgl/BufferObject","../../../../webgl/enums","../../../../webgl/VertexArrayObject"],(function(e,t,n,o,i,r,a,s,l,c,m,u,h,f,d,p,g,b,y,C,v,M,_,w,O,x,A,R,S,D,P,V,E,I,B,U){"use strict";const j=()=>n.getLogger("esri.views.3d.webgl-engine.collections.Component.ComponentObjectCollection");class L{constructor(e,t){this._renderManager=e,this._viewingMode=t,this._elevationRangeCacheVerticalOffset=NaN,this._elevationRangeCacheMin=NaN,this._elevationRangeCacheMax=NaN,this._visible=new o,this._hidden=new o,this._renderSubmit=new M.RenderSubmitSystem(this),this._renderManager.register(this._renderSubmit),this._componentBufferManager=new E.BufferManager(e.rctx,2+(R.olidEnabled()?1:0))}destroy(){D.assert(0===this._hidden.length&&0===this._visible.length,"ObjectCollection should be empty upon disposal"),this._componentBufferManager.destroy(),this._visible.forAll((e=>e.destroy())),this._hidden.forAll((e=>e.destroy())),this._visible.clear(),this._hidden.clear()}createObject(e){const t=e.geometry,n=new g(this._componentBufferManager,l.compactIndices(t.componentOffsets)),o=this._createRenderable(e,n),i=new y.IntersectionGeometry(this._viewingMode,t.positionData,n),r=new b.ComponentObject(e.transform,e.toMapSpace,e.obb.clone(),n,o,i);return(r.visible?this._visible:this._hidden).push(r),r}destroyObject(e){const t=e;(t.visible?this._visible:this._hidden).removeUnordered(t),t.destroy(),this._notifyDirty()}setObjectVisibility(e,t){const n=e;t!==n.visible&&(t?(this._hidden.removeUnordered(n),this._visible.push(n)):(this._visible.removeUnordered(n),this._hidden.push(n)),n.visible=t,this._notifyDirty())}preSubmit(e){const t=e.camera.eye;this.visibleObjects.forAll((e=>e.renderable.meta.cameraDepthSquared=r.squaredDistance(t,e.obb.center)))}getMaterial(e){return e.renderable.material}updateMaterial(e,t){const n=e.renderable.material;t(n),n.dirty&&this._notifyDirty()}setAllComponentVisibilities(e,t){const n=e;n.components.visibility.reset(t),n.components.visibilityDirty(),this._notifyDirty()}forEachVisibleComponent(e,t){return e.components.visibility.forEachComponent(t)}getComponentCount(e){const t=e,n=t.components.visibility.componentCount;return{visible:n,invisible:t.components.count-n}}setComponentData(e,t){const n=e,o=n.renderable.material,i=n.components,r=i.materialDataBuffer,a=i.materialDataIndices,s=new w.UniformComponentParameters,l=r.textureBuffer,c=new Uint8Array(4),m=new Uint32Array(c.buffer);let u=0,d=0,p=0,g=i.verticalOffsets,b=1/0,y=-1/0,C=!1,v=!1,M=0;for(let f=0;f<i.count;f++){t(f,s),u+=+(s.externalColor[3]<1),d+=+(s.externalColorMixMode===h.ColorMixModeEnum.Replace&&1===s.externalColor[3]),p+=+s.castShadows,h.encodeSymbolColor(s.externalColor,s.externalColorMixMode,c),c[2]=254&c[2]|+s.castShadows,l.setData(a[f],0,c[0],c[1],c[2],c[3]),C||=f>0&&M!==m[0],M=m[0],v||=0!==s.elevationOffset,v&&null==g&&(g=new Array(f).fill(0)),null!=g&&(g[f]=s.elevationOffset),b=Math.min(b,s.elevationOffset),y=Math.max(y,s.elevationOffset),A.encodeElevationOffset(s.elevationOffset,c),l.setData(a[f],1,c[0],c[1],c[2],c[3]);const e=s.objectAndLayerIdColor;null!=e&&l.setData(a[f],2,e[0],e[1],e[2],e[3]),s.pickable!==S.getVisibility(i.pickability,f)&&(i.pickability=S.updateVisibilityWithCount(i.pickability,i.count,f,s.pickable))}i.verticalOffsets=v?g:null,n.offsetObb=v?f.computeOffsetObb(n.obb,b,y,this._viewingMode,n.offsetObb??n.obb.clone()):null,C||v||R.olidEnabled()?(o.componentParameters=new O.ComponentParametersVarying,o.componentParameters.castShadows=T(p,i.count),o.componentParameters.transparent=T(u,i.count),o.componentParameters.opaqueOverride=T(d,i.count),o.componentParameters.texture=l,l.updateTexture()):(o.componentParameters=new O.ComponentParametersUniform,o.componentParameters.castShadows=s.castShadows?O.ComponentParameterSummary.All:O.ComponentParameterSummary.None,o.componentParameters.externalColor=s.externalColor,o.componentParameters.externalColorMixMode=s.externalColorMixMode),this._elevationRangeCacheVerticalOffset=NaN,this._notifyDirty()}getComponentAabb(e,t,n,o=!1){e.intersectionGeometry.getComponentAabb(t,n);const i=e,r=i.components.verticalOffsets;if(o||null==r)return n;const a=r[t];if(this._viewingMode===u.ViewingMode.Local||0===a)return n[2]+=a,n[5]+=a,n;const s=V.getVerticalOffsetI3S(a);return s.localOrigin=i.transform.position,s.applyToAabb(n)}getComponentObb(e){return e.obb}getObjectTransform(e){return e.transform}getComponentPositions(e,t,n){return e.intersectionGeometry.getComponentPositions(t,n)}expandRangeWithComponentObjectElevationRange(e,t,n,o){Number.isNaN(this._elevationRangeCacheVerticalOffset)||this._elevationRangeCacheVerticalOffset!==t||o.expandElevationRangeValues(this._elevationRangeCacheMin,this._elevationRangeCacheMax);const i=e,r=i.components,a=r.count,s=r.verticalOffsets,l=i.intersectionGeometry,c=this._viewingMode===u.ViewingMode.Local,m=l.getComponentAabbs(),h=G;let f=1/0,d=-1/0;for(let u=0;u<a;u++){const e=6*u,r=s?.[u]??0;let a=1/0,l=-1/0;if(c)a=m[e+2]+r+t,l=m[e+5]+r+t;else{if(h[0]=m[e],h[1]=m[e+1],h[2]=m[e+2],h[3]=m[e+3],h[4]=m[e+4],h[5]=m[e+5],0!==r){const e=V.getVerticalOffsetI3S(r);e.localOrigin=i.transform.position,e.applyToAabb(h)}const a=Math.max(Math.abs(h[3]),Math.abs(h[0])),s=Math.max(Math.abs(h[4]),Math.abs(h[1])),l=t+h[5]+n;o.expandElevationRangeValues(t+h[2],Math.sqrt(a*a+s*s+l*l)-n)}o.expandElevationRangeValues(a,l),f=Math.min(f,a),d=Math.max(d,l)}this._elevationRangeCacheVerticalOffset=t,this._elevationRangeCacheMin=f,this._elevationRangeCacheMax=d}intersect(e,t,n,o,i,r,a){const s=e,{transform:l}=s,{position:c}=l;return null!=i&&(i.localOrigin=c),s.intersectionGeometry.intersect(t,n,o,i,s.components.verticalOffsets,l,r,a)}addEdges(e,t,n,o,i){const r=e,{indices:a,positions:s}=r.intersectionGeometry,l=r.components.offsets;return t.addComponentObject(r,s,a,l,n,o,i)}async extractEdgeInformation(t,n,o){const i=t,r=i.components.visibility;if(r.allInvisible()){const{extractComponentsEdgeLocationsLayout:t}=await new Promise(((t,n)=>e(["../../lib/edgeRendering/edgeProcessing"],t,n)));return{buffer:t.createBuffer(0),origin:[0,0,0]}}const{indices:s,positions:l}=i.intersectionGeometry,u=i.components.offsets,{EdgeInputBufferLayout:h}=await new Promise(((t,n)=>e(["../../lib/edgeRendering/bufferLayouts"],t,n))),f=h.createBuffer(l.length/3);m.copy(f.position.typedBuffer,l,f.position.typedBufferStride,3),c.transformMat3View(f.position,f.position,i.transform.rotationScale),this._setComponentIndices(f.componentIndex,s,u);const d=f.count,p=this._computeVisibilityIndices(s,r,u,d);return{origin:a.clone(i.transform.position),buffer:await n.extractComponentsEdgeLocations({indices:p,indicesLength:p.length,skipDeduplicate:!0,data:f,writerSettings:{reducedPrecision:!1,variants:0}},o)}}_setComponentIndices(e,t,n){let o=0;for(let i=0;i<n.length-1;i++){const r=n[i],a=n[i+1];for(let n=r;n<a;n++){const i=t?t[n]:n;e.set(i,o)}o++}}_computeVisibilityIndices(e,t,n,o){if(e&&t.allVisible())return e;let r=0;t.forEachComponentRange(((e,t)=>(r+=n[t]-n[e],!0)));const a=i.isArray(e)?new Array(r):2===e?.BYTES_PER_ELEMENT||o<=65536?new Uint16Array(r):new Uint32Array(r);let s=0;return t.forEachComponentRange(((t,o)=>{const i=n[t],r=n[o];for(let n=i;n<r;n++)a[s++]=e?e[n]:n;return!0})),a}addComponentHighlight(e,t,n){const o=e.components;let i=o.highlightCounts,r=o.highlightGroups;null!=i&&null!=r||(i=new Uint32Array(o.count+1),o.highlightCounts=i,r=new Array(o.count+1),o.highlightGroups=r),r[t]=n;0===i[t]++&&(o.highlightsDirty(),this._notifyDirty()),i[o.count]++}removeComponentHighlight(e,t){const n=e.components,o=n.highlightCounts;if(null==o)return void j().warn("Removing non-existing highlight.");const i=o[t];if(0===i)return void j().warn("Removing non-existing highlight.");const r=o[n.count];if(i>1)return o[t]=i-1,void(o[n.count]=r-1);o[t]=0,n.highlightsDirty(),this._notifyDirty(),1===r?(n.highlightCounts=null,n.highlightGroups=null):o[n.count]=r-1}clearHighlights(e){const t=e.components;null!=t.highlightCounts&&(t.highlightCounts=null,t.highlightGroups=null,t.highlightsDirty(),this._notifyDirty())}getObjectGPUMemoryUsage(e){return e.renderable.meta.gpuMemoryEstimate}get visibleObjects(){return this._visible}_createRenderable(e,t){const n=this._renderManager.rctx,o=e.geometry,i=o.vertices.layoutParameters,r=I.BufferObject.createVertex(n,B.Usage.STATIC_DRAW,o.vertices.data),a=o.indices?I.BufferObject.createIndex(n,B.Usage.STATIC_DRAW,o.indices):null,s=d.glLayout(_.createVertexBufferLayout(i)),l=new Uint16Array(o.vertices.count);for(let d=0;d<t.count;d++){const e=t.offsets[d],n=t.offsets[d+1],i=t.materialDataIndices[d];if(null!=o.indices)for(let t=e;t<n;t++){l[o.indices[t]]=i}else for(let t=e;t<n;t++)l[t]=i}const c=I.BufferObject.createVertex(n,B.Usage.STATIC_DRAW,l.buffer),m=new O.ComponentMaterial(e.transform,e.toMapSpace),u=new U.VertexArrayObject(n,x.vertexAttributeLocations,new Map([["data",s],["componentIndices",N]]),new Map([["data",r],["componentIndices",c]]),a),h=new v.RenderGeometry(u,B.PrimitiveType.TRIANGLES,i,null!=a),f={cameraDepthSquared:.5,gpuMemoryEstimate:r.usedMemory+c.usedMemory+(null!=a?a.usedMemory:0)};return new C.Renderable(m,h,f)}_notifyDirty(){this._renderManager.notifyDirty()}}const N=d.glLayout(p.newLayout().u16(P.VertexAttribute.COMPONENTINDEX));function T(e,t){return e===t?O.ComponentParameterSummary.All:0===e?O.ComponentParameterSummary.None:O.ComponentParameterSummary.Some}const G=s.create();t.ComponentObjectCollection=L,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
