/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../../core/mathUtils","../../../../../core/libs/gl-matrix-2/factories/vec3f64","../../lib/triangleIntersectionUtils"],(function(t,e,n,i){"use strict";class s{constructor(t,e){this.elementCount=t,this.model=e,this._elementIndexMap=null,this._bspNodes=[],this._generatedBVH=!1,this.localMode=e.localMode,this.planetCenterZ=e.planetCenterZ,this.geometryMinZ=e.geometryMinZ,this.planetCenter=n.fromValues(0,0,this.planetCenterZ),this.maxBspNodeDepth=e.maxBspNodeDepth??8,this.minElementCountForBVH=e.minElementCountForBVH??15,this.minBspNodeElementCount=e.minBspNodeElementCount??5}get elementIndexMap(){return this._ensureBVH(),this._elementIndexMap}get _skipBVH(){return this.elementCount<this.minElementCountForBVH||this.geometryMinZ<.5*this.planetCenterZ}_ensureBVH(){this._generatedBVH||this._skipBVH||0===this._bspNodes.length&&this._generateBsp()}intersectRay(t,e,n){this.elementCount<1||(this._skipBVH?this._intersectRayWithoutBVH(n):this._intersectRayWithBVH(t,e,n))}_intersectRayWithoutBVH(t){this._intersectRange(0,this.elementCount)}_intersectRange(t,e){this.model.intersectRange(t,e)}_intersectRayWithBVH(t,e,n){this._ensureBVH(),n?this._intersectGeometryWithBVHVerticalRay(t):this._intersectGeometryWithBVHGeneralRay(t,e)}_intersectGeometryWithBVHVerticalRay(t){let e=t[0],n=t[1];if(!this.localMode){const{geometryMinZ:i,planetCenterZ:s}=this,h=(i-s)/(t[2]-s);e=t[0]*h,n=t[1]*h}const{_bspNodes:i}=this;let s=0;for(;s>=0;){const t=i[s],{d:h,dim:a,minIndexIndex:o,minMidIndexIndex:r,maxMidIndexIndex:c,maxIndexIndex:l,aabb2D:d}=t;if(e<d[0]||e>d[2]||n<d[1]||n>d[3])break;if(-1===a||-1===t.child0&&-1===t.child1){this._intersectRange(o,l);break}{this._intersectRange(r,c);const i=(0===a?e:n)-h;if(i<0){if(-1===t.child0){this._intersectRange(o,r);break}s=t.child0}else{if(!(i>0))break;if(-1===t.child1){this._intersectRange(c,l);break}s=t.child1}}}}_intersectGeometryWithBVHGeneralRay(t,n){let i=t[0],s=t[1],h=n[0],a=n[1];const{geometryMinZ:o}=this;if(!this.localMode){let e=0,r=1;const c=Math.min(.5*this.planetCenterZ,o),l=t[2],d=n[2];if(l<c&&d<c)return;if(l<c&&(e=(c-l)/(d-l)),d<c&&(r=(c-l)/(d-l)),e>r)return;const m=(1-e)*t[0]+e*n[0],u=(1-e)*t[1]+e*n[1],M=(1-e)*t[2]+e*n[2],x=(1-r)*t[0]+r*n[0],p=(1-r)*t[1]+r*n[1],f=(1-r)*t[2]+r*n[2],{planetCenterZ:g}=this,_=o-g,B=_/(M-g);i=m*B,s=u*B;const I=_/(f-g);h=x*I,a=p*I}const r=h-i,c=a-s,l=this._bspNodes;let d=1;{const{aabb2D:t}=l[0],e=(t,e,n,i)=>{if(Math.abs(e)<1e-5*Math.max(i-n,1))return!1;const s=e>0,h=s?i:n,a=t+d*e;return(s?a<h:a>h)&&(d=Math.max((h-t)/e,d),!0)},n=()=>e(i,r,t[0],t[2]),h=()=>e(s,c,t[1],t[3]);Math.abs(r)>=Math.abs(c)?n()||h():h()||n()}const m=[0,0,d];let u=0;for(;u<m.length;){const t=m[u];let n=m[u+1],h=m[u+2];if(u+=3,n>h)continue;const a=l[t],{minIndexIndex:o,maxIndexIndex:M}=a,{child0:x,child1:p,minMidIndexIndex:f,maxMidIndexIndex:g,aabb2D:_,d:B,dim:I}=a;{const t=i+n*r,e=i+h*r,s=Math.min(t,e),a=Math.max(t,e),o=_[0],c=_[2];if(a<o||c<s)continue;if(s<o){const t=(o-i)/r;r>0?n=Math.max(n,t):h=Math.min(h,t)}if(c<a){const t=(c-i)/r;r>0?h=Math.min(h,t):n=Math.max(n,t)}}{const t=s+n*c,e=s+h*c,i=Math.min(t,e),a=Math.max(t,e),o=_[1],r=_[3];if(a<o||r<i)continue;if(i<o){const t=(o-s)/c;c>0?n=Math.max(n,t):h=Math.min(h,t)}if(r<a){const t=(r-s)/c;c>0?h=Math.min(h,t):n=Math.max(n,t)}}if(-1===x&&-1===p)this._intersectRange(o,M);else{const t=0===I?i:s,a=0===I?r:c,l=t+n*a,u=t+h*a,_=Math.min(l,u),b=Math.max(l,u),V=e.clamp((B-t)/a,0,d);o<f&&_<=B&&(-1!==x?(m.push(x),m.push(a>=0?n:Math.max(n,V)),m.push(a>=0?Math.min(h,V):h)):this._intersectRange(o,f)),this._intersectRange(f,g),g<M&&B<=b&&(-1!==p?(m.push(p),m.push(a>=0?Math.max(n,V):n),m.push(a>=0?h:Math.min(h,V))):this._intersectRange(g,M))}}}_generateBsp(){const{elementCount:t}=this;if(t<1)return;const e=i.createUintArray(t,t);this._elementIndexMap=e;for(let i=0;i<t;++i)e[i]=i;const n=this.model.getAabbs2D();let s=0;const r=this._bspNodes;r.length=0;const{localMode:d}=this;let m=!1;if(!d){const{planetCenterZ:t,geometryMinZ:e}=this;m=t>=0||e<.5*t}const u=[],M=(t,e,n,i,s)=>{u.push(t),u.push(e),u.push(n),u.push(i<0?-1:(s?0:1)+2*i)},{maxBspNodeDepth:x,minBspNodeElementCount:p}=this,f=(t,i,s,u,f)=>{const g=r.length;if(g>0&&(m||s>=x||i-t<p))return;const _=[0,0,0,0];c(_,t,i,e,n);const{d:B,dim:I}=d?h(_):a(_),{rangeMidStart:b,rangeMidEnd:V}=o(t,i,I,B,e,n),y=s===x-1,H=!y&&b>=t+p,C=!y&&i>=V+p;if(H||C||0===g){const e=new l(t,b,V,i,I,B,_);if(H&&M(t,b,s+1,g,!0),C&&M(V,i,s+1,g,!1),r.push(e),-1!==u){const t=r[u];f?t.child0=g:t.child1=g}}};for(M(0,t,0,-1,!1);s<u.length;){const t=u[s],e=u[s+1],n=u[s+2],i=u[s+3];s+=4;const h=i>>1;f(t,e,n,h,i-(h<<1)==0)}this._generatedBVH=!0}}function h(t){const e=t[0],n=t[1],i=t[2],s=t[3];let h,a;return i-e>=s-n?(a=.5*(e+i),h=0):(a=.5*(n+s),h=1),{d:a,dim:h}}function a(t){const e=t[0],n=t[1],i=t[2],s=t[3];let h,a;return i-e>=s-n?(h=0,a=.5*(e+i)):(h=1,a=.5*(n+s)),{dim:h,d:a}}function o(t,e,n,i,s,h){let a=t;{let t=e;for(;a<t;){const e=s[a];r(e,n,i,h)<0?++a:(--t,s[a]=s[t],s[t]=e)}}const o=a;let c=a,l=e;for(;c<l;){const t=s[l-1];r(t,n,i,h)>0?--l:(s[l-1]=s[c],s[c]=t,++c)}return{rangeMidStart:o,rangeMidEnd:l}}function r(t,e,n,i){const s=4*t,h=i[s+0+e];return i[s+2+e]<n?-1:h>n?1:0}function c(t,e,n,i,s){let h=1/0,a=1/0,o=-1/0,r=-1/0;for(let c=e;c<n;++c){const t=4*i[c];h=Math.min(h,s[t+0]),a=Math.min(a,s[t+1]),o=Math.max(o,s[t+2]),r=Math.max(r,s[t+3])}t[0]=h,t[1]=a,t[2]=o,t[3]=r}class l{constructor(t,e,n,i,s,h,a){this.minIndexIndex=t,this.minMidIndexIndex=e,this.maxMidIndexIndex=n,this.maxIndexIndex=i,this.dim=s,this.d=h,this.aabb2D=a,this.child0=-1,this.child1=-1}}t.ElevationAgnosticBVH=s,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
