/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../core/Error","../../webgl/formats","../../webgl/ManagedColorAttachment","../../webgl/ManagedDepthAttachment","../../webgl/ManagedFBO","../../webgl/ManagedFBObject","./FBOPool","../../../webgl/enums","../../../webgl/FramebufferObject","../../../webgl/Renderbuffer","../../../webgl/RenderbufferDescriptor","../../../webgl/Texture","../../../webgl/TextureDescriptor"],(function(e,t,r,a,o,i,c,n,h,s,l,d,u,m){"use strict";class p{constructor(e){this.rctx=e,this._acquired=new Set,this._cache=new n.FBOPool(e.newCache,"FBOCache"),this._depthCache=new n.FBOPool(e.newCache,"DepthAttachmentCache"),this._colorCache=new n.FBOPool(e.newCache,"ColorAttachmentCache")}destroy(){this._cache.destroy(),this._depthCache.destroy(),this._colorCache.destroy()}clean(){this._cache.clean(),this._colorCache.clean(),this._depthCache.clean()}frameStart(){this._cache.frame(),this._colorCache.frame(),this._depthCache.frame(),this.debugCallback&&this.debugCallback()}frameEnd(){const e=this.debugCallback;e&&this._acquired.forEach((t=>t.type===c.AttachmentType.FBO&&e(t.name,t.fbo,t.numberOfColorAttachments)))}get usedMemory(){return Array.from(this._acquired.values()).reduce(((e,t)=>e+("getTexture"in t?t.getTexture()?.usedMemory??0:t.usedMemory)),this._cache.usedMemory+this._colorCache.usedMemory+this._depthCache.usedMemory)}set interactive(e){this._cache.interactive=this._colorCache.interactive=this._depthCache.interactive=e}acquire(e,a,o,c=r.ColorFormat.RGBA){const n=T(c,e,a);let l=this._cache.pop(n);if(l){l.retain(),l.setName(o);const e=this.rctx.getBoundFramebufferObject();if(this.rctx.bindFramebuffer(l.fbo),this.rctx.setDrawBuffers([h.ColorAttachment.COLOR_ATTACHMENT0]),!l.fbo)throw new t("attempt to use a not existing framebuffer");this.rctx.unbindTexture(l.fbo.colorTexture),this.rctx.bindFramebuffer(e)}else l=new i(n,o,new s.FramebufferObject(this.rctx,{...M[c],width:e,height:a}),(e=>{e??=r.DepthFormat.DEPTH_STENCIL_TEXTURE;const t=this._acquireDepth(e,l.fbo.width,l.fbo.height,`${l.name} depth`);return l.attachDepth(t),t.release(),l}),((t,o,i)=>{o??=r.ColorFormat.RGBA;const c=this._acquireColor(o,e,a,i??`${l.name} color ${t}`);return this.rctx.unbindTexture(c.attachment),l.attachColor(c,t),c.release(),l}),(()=>{this.debugCallback&&this.debugCallback(l.name,l.fbo,l.numberOfColorAttachments),this._acquired.delete(l),l.detachAll(),this._cache.put(l)}));return this._trackHandle(l)}acquireDepth(e,t,r,a){return this._acquireDepth(e,t,r,a)}_acquireDepth(e,t,a,i){const c=T(e,t,a),n=this._depthCache.pop(c);if(n)return n.retain(),n.name=i,this._trackHandle(n);const h=e===r.DepthFormat.DEPTH_STENCIL_TEXTURE?new o.ManagedDepthAttachment(c,new u.Texture(this.rctx,{...D[e],width:t,height:a}),(()=>{this._acquired.delete(h),this._depthCache.put(h)})):new o.ManagedDepthAttachment(c,new l.Renderbuffer(this.rctx,{...D[e],width:t,height:a}),(()=>{this._acquired.delete(h),this._depthCache.put(h)}));return h.name=i,this._trackHandle(h)}_acquireColor(e,t,r,o){const i=T(e,t,r),c=this._colorCache.pop(i);if(c)return c.retain(),c.name=o,this._trackHandle(c);const n=new a.ManagedColorAttachment(i,new u.Texture(this.rctx,{...M[e],width:t,height:r}),(()=>{this._acquired.delete(n),this._colorCache.put(n)}));return n.name=o,this._trackHandle(n)}_trackHandle(e){return this._acquired.add(e),e}}const _=new i("default","default",null,(()=>_),(()=>_),(()=>{}));function T(e,t,r){return`${e}x${t}x${r}`}_.release=()=>!1;const x=new m.TextureDescriptor;x.pixelFormat=h.PixelFormat.RED,x.internalFormat=h.SizedPixelFormat.R8,x.wrapMode=h.TextureWrapMode.CLAMP_TO_EDGE;const C=new m.TextureDescriptor;C.pixelFormat=h.PixelFormat.RG,C.internalFormat=h.SizedPixelFormat.RG8,C.wrapMode=h.TextureWrapMode.CLAMP_TO_EDGE;const F=new m.TextureDescriptor;F.internalFormat=h.SizedPixelFormat.RGBA4,F.dataType=h.PixelType.UNSIGNED_SHORT_4_4_4_4,F.wrapMode=h.TextureWrapMode.CLAMP_TO_EDGE;const f=new m.TextureDescriptor;f.wrapMode=h.TextureWrapMode.CLAMP_TO_EDGE;const b=new m.TextureDescriptor;b.wrapMode=h.TextureWrapMode.CLAMP_TO_EDGE,b.samplingMode=h.TextureSamplingMode.LINEAR_MIPMAP_LINEAR,b.hasMipmap=!0,b.maxAnisotropy=8;const w=new m.TextureDescriptor;w.pixelFormat=h.PixelFormat.RED,w.dataType=h.PixelType.HALF_FLOAT,w.internalFormat=h.SizedPixelFormat.R16F,w.samplingMode=h.TextureSamplingMode.NEAREST;const E=new m.TextureDescriptor;E.dataType=h.PixelType.HALF_FLOAT,E.internalFormat=h.SizedPixelFormat.RGBA16F,E.samplingMode=h.TextureSamplingMode.NEAREST;const M={[r.ColorFormat.RED]:x,[r.ColorFormat.RG]:C,[r.ColorFormat.RGBA4]:F,[r.ColorFormat.RGBA]:f,[r.ColorFormat.RGBA_MIPMAP]:b,[r.ColorFormat.R16F]:w,[r.ColorFormat.RGBA16F]:E},g=new m.TextureDescriptor;g.pixelFormat=h.PixelFormat.DEPTH_STENCIL,g.dataType=h.PixelType.UNSIGNED_INT_24_8,g.samplingMode=h.TextureSamplingMode.NEAREST,g.wrapMode=h.TextureWrapMode.CLAMP_TO_EDGE,g.internalFormat=h.PixelFormat.DEPTH24_STENCIL8;const D={[r.DepthFormat.DEPTH_STENCIL_TEXTURE]:g,[r.DepthFormat.DEPTH16_BUFFER]:new d.RenderbufferDescriptor(h.RenderbufferFormat.DEPTH_COMPONENT16,4)};e.FBOCache=p,e.defaultWebGLFBO=_,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
