/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../../chunks/tslib.es6","../../../../../core/Logger","../../../../../core/has","../../../../../core/RandomLCG","../../../../../core/Error","../../../../../core/accessorSupport/decorators/subclass","../../../../../core/libs/gl-matrix-2/math/mat3","../../../../../core/libs/gl-matrix-2/factories/mat3f64","../../../../../core/libs/gl-matrix-2/math/mat4","../../../../../chunks/vec32","../../../../../core/libs/gl-matrix-2/factories/vec3f64","./AllRenderPasses","./RenderPass","../shaderLibrary/ShaderOutput","../util/TwoVectorPosition","../../effects/RenderPlugin","../../lib/depthRange","../../lib/RenderSlot"],(function(e,s,t,a,r,i,h,n,o,u,d,l,c,p,m,P,g,_,S){"use strict";e.RenderPassManager=class extends g.SyncRenderPlugin{constructor(){super({}),this._passes=null,this.produces=new Map([[S.RenderSlot.OPAQUE_MATERIAL,e=>this._produces(e)],[S.RenderSlot.TRANSPARENT_MATERIAL,e=>!!(this._passes&&this._passes.materialTransparent.count>0)&&this._produces(e)],[S.RenderSlot.INTEGRATED_MESH,e=>this._produces(e)]]),this._materialPassParameters=new c.MaterialPassParameters,this._shadowPassParameters=new c.ShadowMapPassParameters,this._highlightPassParameters=new c.HighlightPassParameters,this._viewshedPassParameters=new c.ViewshedShadowMapPassParameters,this._systems=new Set}initializeRenderContext(e){this._context=e;const s=e.renderContext.rctx,t=e.techniques;this._passes={materialOpaque:new p.RenderPass(s,t),materialTransparent:new p.RenderPass(s,t,p.RenderPassSorting.BackToFront),materialIntegratedMesh:new p.RenderPass(s,t),shadowMap:new p.RenderPass(s,t),highlight:new p.RenderPass(s,t),highlightIntegratedMesh:new p.RenderPass(s,t),highlightShadowMap:new p.RenderPass(s,t),viewshedShadowMap:new p.RenderPass(s,t),defaultShadowMap:new p.RenderPass(s,t)}}get rctx(){return this._context.renderContext.rctx}uninitializeRenderContext(){}dispose(){this._context=null,this._systems.clear()}register(e){this._systems.add(e)}_produces(e){return 0!==this._systems.size&&null!==this._passes&&(e===m.ShaderOutput.Highlight?this._passes.highlight.count>0||this._passes.highlightIntegratedMesh.count>0:e!==m.ShaderOutput.ShadowHighlight||this._passes.highlight.count>0)}prepareRender(e){if(0!==this._systems.size&&null!==this._passes){for(const e of Object.values(this._passes))e.prepareSubmit();this._systems.forEach((s=>s.submit(this._passes,e.bind)));for(const e of Object.values(this._passes))e.finishSubmit();this._context.techniques.frameUpdate()}}acquireTechniques(e){if(0===this._systems.size)return null;const s=e.output===m.ShaderOutput.Shadow||e.output===m.ShaderOutput.ShadowHighlight||e.output===m.ShaderOutput.ShadowExcludeHighlight?this._shadowPassParameters:e.output===m.ShaderOutput.ViewshedShadow?this._viewshedPassParameters:e.output===m.ShaderOutput.Highlight?this._highlightPassParameters:this._materialPassParameters,t=e.bind;return this._updateParameters(t.camera,s,t.slot===S.RenderSlot.TRANSPARENT_MATERIAL),this._materialPassParameters.output=e.output,this._invoke(e,((s,t)=>s.acquire(t,e.bind)))}render(e,s){this._invoke(e,((t,a)=>t.dispatch(a,e.bind,s)))}_invoke(e,s){if(null===this._passes)return null;switch(e.bind.slot){case S.RenderSlot.OPAQUE_MATERIAL:switch(e.output){case m.ShaderOutput.Color:case m.ShaderOutput.ColorEmission:case m.ShaderOutput.Depth:case m.ShaderOutput.Normal:case m.ShaderOutput.ObjectAndLayerIdColor:return s(this._passes.materialOpaque,this._materialPassParameters);case m.ShaderOutput.Highlight:return s(this._passes.highlight,this._highlightPassParameters);case m.ShaderOutput.Shadow:return s(this._passes.shadowMap,this._shadowPassParameters);case m.ShaderOutput.ShadowHighlight:return s(this._passes.highlightShadowMap,this._shadowPassParameters);case m.ShaderOutput.ShadowExcludeHighlight:return s(this._passes.defaultShadowMap,this._shadowPassParameters);case m.ShaderOutput.ViewshedShadow:return s(this._passes.viewshedShadowMap,this._viewshedPassParameters)}break;case S.RenderSlot.TRANSPARENT_MATERIAL:switch(e.output){case m.ShaderOutput.Color:case m.ShaderOutput.ColorEmission:case m.ShaderOutput.Depth:case m.ShaderOutput.Normal:case m.ShaderOutput.ObjectAndLayerIdColor:return s(this._passes.materialTransparent,this._materialPassParameters)}break;case S.RenderSlot.INTEGRATED_MESH:switch(e.output){case m.ShaderOutput.Color:case m.ShaderOutput.ColorEmission:case m.ShaderOutput.Depth:case m.ShaderOutput.Normal:case m.ShaderOutput.ObjectAndLayerIdColor:return s(this._passes.materialIntegratedMesh,this._materialPassParameters);case m.ShaderOutput.Highlight:return s(this._passes.highlightIntegratedMesh,this._highlightPassParameters)}}return null}notifyDirty(){this._context.requestRender()}queryDepthRange(e){const s=new _.DepthRange;return this._systems.forEach((t=>_.union(s,t.queryShadowCasterDepthRange(e)))),s}get hasEmissions(){let e=!1;return this._systems.forEach((s=>e=s.hasEmissions||e)),e}_updateParameters(e,s,t){const a=e.viewInverseTransposeMatrix;d.set(w,a[3],a[7],a[11]),O.set(w),d.copy(s.transformWorldFromViewTH,O.high),d.copy(s.transformWorldFromViewTL,O.low),d.copy(s.slicePlaneLocalOrigin,w),n.fromMat4(s.transformViewFromCameraRelativeRS,e.viewMatrix),u.copy(s.transformProjFromView,e.projectionMatrix),s.identifier===c.RenderPassIdentifier.Material&&(this._materialPassParameters.transparent=t,n.transpose(R,s.transformViewFromCameraRelativeRS),n.invert(s.transformNormalViewFromGlobal,R))}},e.RenderPassManager=s.__decorate([h.subclass("esri.views.3d.webgl-engine.core.renderPasses.RenderPassManager")],e.RenderPassManager);const w=l.create(),R=o.create(),O=new P.TwoVectorPosition;Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
