/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../../core/Error","../../../../../core/has","../../../../../core/Logger","../shaderTechnique/BindType","../../lib/Util"],(function(e,t,r,n,s,i){"use strict";const o=()=>n.getLogger("esri.views.3d.webgl-engine.core.shaderModules.shaderBuilder");class a{constructor(){this._includedModules=new Map}include(e,t){this._includedModules.has(e)?this._includedModules.get(e):(this._includedModules.set(e,t),e(this.builder,t))}}class u extends a{constructor(){super(...arguments),this.vertex=new _,this.fragment=new _,this.attributes=new m,this.varyings=new l,this.extensions=new g,this.outputs=new f}get fragmentUniforms(){return this.fragment.uniforms.entries}get builder(){return this}generate(e){const t=this.extensions.generateSource(e),r=this.attributes.generateSource(e),n=this.varyings.generateSource(e),s="vertex"===e?this.vertex:this.fragment,i=s.uniforms.generateSource(),o=s.code.generateSource(),a=s.main.generateSource(),u="vertex"===e?p:b,c=s.constants.generateSource(),h=this.outputs.generateSource(e);return`#version 300 es\n${t.join("\n")}\n\n${u}\n\n${c.join("\n")}\n\n${i.join("\n")}\n\n${r.join("\n")}\n\n${n.join("\n")}\n\n${h.join("\n")}\n\n${o.join("\n")}\n\n${a.join("\n")}`}generateBindPass(e){const t=new Map;this.vertex.uniforms.entries.forEach((e=>{const r=e.bind[s.BindType.Pass];r&&t.set(e.name,r)})),this.fragment.uniforms.entries.forEach((e=>{const r=e.bind[s.BindType.Pass];r&&t.set(e.name,r)}));const r=Array.from(t.values()),n=r.length;return(t,s)=>{for(let i=0;i<n;++i)r[i](e,t,s)}}generateBindDraw(e){const t=new Map;this.vertex.uniforms.entries.forEach((e=>{const r=e.bind[s.BindType.Draw];r&&t.set(e.name,r)})),this.fragment.uniforms.entries.forEach((e=>{const r=e.bind[s.BindType.Draw];r&&t.set(e.name,r)}));const r=Array.from(t.values()),n=r.length;return(t,s,i)=>{for(let o=0;o<n;++o)r[o](e,i,t,s)}}}class c{constructor(e){this._stage=e,this._entries=new Map}add(...e){for(const t of e)this._add(t);return this._stage}get(e){return this._entries.get(e)}_add(e){if(null!=e){if(this._entries.has(e.name)&&!this._entries.get(e.name).equals(e))throw new t(`Duplicate uniform name ${e.name} for different uniform type`);this._entries.set(e.name,e)}else o().error(`Trying to add null Uniform from ${(new Error).stack}.`)}generateSource(){return Array.from(this._entries.values()).map((e=>null!=e.arraySize?`uniform ${e.type} ${e.name}[${e.arraySize}];`:`uniform ${e.type} ${e.name};`))}get entries(){return Array.from(this._entries.values())}}class h{constructor(e){this._stage=e,this._bodies=new Array}add(e){return this._bodies.push(e),this._stage}generateSource(){if(this._bodies.length>0)return[`void main() {\n ${this._bodies.join("\n")||""} \n}`];throw new t("Shader does not contain main function body.")}}class d{constructor(e){this._stage=e,this._entries=new Array}add(e){return this._entries.push(e),this._stage}generateSource(){return this._entries}}class _ extends a{constructor(){super(...arguments),this.uniforms=new c(this),this.main=new h(this),this.code=new d(this),this.constants=new S(this)}get builder(){return this}}class m{constructor(){this._entries=new Array}add(e,t){this._entries.push([e,t])}generateSource(e){return"fragment"===e?[]:this._entries.map((e=>`in ${e[1]} ${e[0]};`))}}class l{constructor(){this._entries=new Map}add(e,t){this._entries.has(e)&&i.assert(this._entries.get(e)===t),this._entries.set(e,t)}generateSource(e){const t=new Array;return this._entries.forEach(((r,n)=>t.push("vertex"===e?`out ${r} ${n};`:`in ${r} ${n};`))),t}}class g{constructor(){this._entries=new Set}add(e){this._entries.add(e)}generateSource(e){const t="vertex"===e?g.ALLOWLIST_VERTEX:g.ALLOWLIST_FRAGMENT;return Array.from(this._entries).filter((e=>t.includes(e))).map((e=>`#extension ${e} : enable`))}}g.ALLOWLIST_FRAGMENT=["GL_EXT_shader_texture_lod","GL_OES_standard_derivatives"],g.ALLOWLIST_VERTEX=[];class f{constructor(){this._entries=new Map}add(e,t,r=0){const n=this._entries.get(r);n?i.assert(n.name===e&&n.type===t,`Fragment shader output location ${r} occupied`):this._entries.set(r,{name:e,type:t})}generateSource(e){if("vertex"===e)return[];0===this._entries.size&&this._entries.set(0,{name:f.DEFAULT_NAME,type:f.DEFAULT_TYPE});const t=new Array;return this._entries.forEach(((e,r)=>t.push(`layout(location = ${r}) out ${e.type} ${e.name};`))),t}}f.DEFAULT_TYPE="vec4",f.DEFAULT_NAME="fragColor";class S{constructor(e){this._stage=e,this._entries=new Set}add(e,t,r){let n="ERROR_CONSTRUCTOR_STRING";switch(t){case"float":n=S._numberToFloatStr(r);break;case"int":n=S._numberToIntStr(r);break;case"bool":n=r.toString();break;case"vec2":n=`vec2(${S._numberToFloatStr(r[0])},                            ${S._numberToFloatStr(r[1])})`;break;case"vec3":n=`vec3(${S._numberToFloatStr(r[0])},                            ${S._numberToFloatStr(r[1])},                            ${S._numberToFloatStr(r[2])})`;break;case"vec4":n=`vec4(${S._numberToFloatStr(r[0])},                            ${S._numberToFloatStr(r[1])},                            ${S._numberToFloatStr(r[2])},                            ${S._numberToFloatStr(r[3])})`;break;case"ivec2":n=`ivec2(${S._numberToIntStr(r[0])},                             ${S._numberToIntStr(r[1])})`;break;case"ivec3":n=`ivec3(${S._numberToIntStr(r[0])},                             ${S._numberToIntStr(r[1])},                             ${S._numberToIntStr(r[2])})`;break;case"ivec4":n=`ivec4(${S._numberToIntStr(r[0])},                             ${S._numberToIntStr(r[1])},                             ${S._numberToIntStr(r[2])},                             ${S._numberToIntStr(r[3])})`;break;case"mat2":case"mat3":case"mat4":n=`${t}(${Array.prototype.map.call(r,(e=>S._numberToFloatStr(e))).join(", ")})`}return this._entries.add(`const ${t} ${e} = ${n};`),this._stage}static _numberToIntStr(e){return e.toFixed(0)}static _numberToFloatStr(e){return Number.isInteger(e)?e.toFixed(1):e.toString()}generateSource(){return Array.from(this._entries)}}const b="#ifdef GL_FRAGMENT_PRECISION_HIGH\n  precision highp float;\n  precision highp sampler2D;\n#else\n  precision mediump float;\n  precision mediump sampler2D;\n#endif",p="precision highp float;\nprecision highp sampler2D;";e.Code=d,e.Includes=a,e.Main=h,e.ShaderBuilder=u,e.Stage=_,e.Uniforms=c,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
