/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../../chunks/tslib.es6","../../../../../core/accessorSupport/decorators/property","../../../../../core/has","../../../../../core/Logger","../../../../../core/RandomLCG","../../../../../core/accessorSupport/decorators/subclass","../../../webgl/formats","../../../webgl/RenderNode","./FocusAreaColorTechnique","./FocusAreaMaskTechnique","../../lib/DefaultVertexAttributeLocations","../../lib/DefaultVertexBufferLayouts","../../lib/VertexArrayObject","../../../../../chunks/FocusAreaColor.glsl","../../../../../chunks/FocusAreaMask.glsl","../../../../webgl/BufferObject","../../../../webgl/enums"],(function(e,t,r,s,o,i,a,c,n,u,l,h,d,p,f,A,_,g){"use strict";e.FocusAreaRenderNode=class extends n{constructor(e){super(e),this.consumes={required:["final-color"]},this.produces="final-color",this.focusAreaGeometries=new Array,this._vaos=Array(),this._count=new Array,this._origins=new Array,this._colorParameters=new f.FocusAreaColorPassParameters,this._maskParameters=new A.FocusAreaMaskPassParameters,e.techniques.precompile(l.FocusAreaMaskTechnique),e.techniques.precompile(u.FocusAreaColorTechnique)}initialize(){this.setExtrudedVolume()}destroy(){this._vaos.forEach((e=>e.dispose())),this._vaos=[],this._count=[],this._origins=[]}render(t){const r=this.techniques.acquire(l.FocusAreaMaskTechnique),s=this.techniques.acquire(u.FocusAreaColorTechnique),o=this.bindParameters,i=t.find((({name:e})=>"final-color"===e)),a=i?.getTexture(),n=o.camera,h=n.fullViewport[2],d=n.fullViewport[3],p=this.fboCache.acquire(h,d,"focusArea",c.ColorFormat.RGBA),f=this.fboCache.acquire(h,d,this.produces);if(!r.compiled||!s.compiled||!this._vaos||this.effect===e.FocusAreaEffect.NONE)return this.requestRender(),r.release(),s.release(),f.release(),p.release(),i;const A=this.renderingContext;p.attachDepth(i.getAttachment(this.gl.DEPTH_STENCIL_ATTACHMENT)),A.bindFramebuffer(p.fbo),A.clear(g.FramebufferBit.COLOR|g.FramebufferBit.STENCIL),A.setViewport(0,0,h,d),A.gl.clearStencil(0),A.gl.clear(A.gl.STENCIL_BUFFER_BIT),A.setClearStencil(0);for(let e=0;e<this._vaos.length;e++){const t=this._vaos[e],s=this._count[e];t&&(this._maskParameters.origin=this._origins[e],A.bindTechnique(r,o,this._maskParameters),A.setFaceCullingEnabled(!1),A.setStencilTestEnabled(!0),A.setStencilWriteMask(255),A.setStencilFunction(g.CompareFunction.ALWAYS,0,255),A.setStencilOpSeparate(g.Face.FRONT,g.StencilOperation.KEEP,g.StencilOperation.INCR_WRAP,g.StencilOperation.KEEP),A.setStencilOpSeparate(g.Face.BACK,g.StencilOperation.KEEP,g.StencilOperation.DECR_WRAP,g.StencilOperation.KEEP),A.setDepthWriteEnabled(!1),A.setColorMask(!1,!1,!1,!1),A.bindVAO(t),A.drawArrays(g.PrimitiveType.TRIANGLES,0,s),A.setFaceCullingEnabled(!1),A.setDepthTestEnabled(!1),A.setStencilFunction(g.CompareFunction.NOTEQUAL,0,255),A.setStencilWriteMask(0),A.setColorMask(!0,!0,!0,!0),A.drawArrays(g.PrimitiveType.TRIANGLES,0,s))}return r.release(),A.gl.clear(A.gl.STENCIL_BUFFER_BIT),A.bindFramebuffer(f.fbo),this._colorParameters.color=a,this._colorParameters.focusArea=p.getTexture(),this._colorParameters.effect=this.effect,A.bindTechnique(s,o,this._colorParameters),A.screen.draw(),p.release(),s.release(),f.attachDepth(i.getAttachment(this.gl.DEPTH_STENCIL_ATTACHMENT)),f}setExtrudedVolume(){const e=this.focusAreaGeometries;this._vaos=[],this._count=[],this._origins=[];for(let t=0;t<e.length;t++){const r=e[t],s=new Array,o=r.indicesBottom;this._origins.push(r.origin);for(let e=0;e<o.length;e++)s.push(r.positions[3*(o[e]-1)]),s.push(r.positions[3*(o[e]-1)+1]),s.push(r.positions[3*(o[e]-1)+2]);const i=r.indicesExtruded;for(let e=0;e<i.length;e++)s.push(r.positions[3*i[e]]),s.push(r.positions[3*i[e]+1]),s.push(r.positions[3*i[e]+2]);const a=new Float32Array(s),c=new p.VertexArrayObject(this.renderingContext,h.Default3D,new Map([["geometry",d.Pos3]]),new Map([["geometry",_.BufferObject.createVertex(this.renderingContext,g.Usage.STATIC_DRAW,a)]]));this._vaos?.push(c),this._count.push(o.length+i.length)}}},t.__decorate([r.property()],e.FocusAreaRenderNode.prototype,"consumes",void 0),t.__decorate([r.property()],e.FocusAreaRenderNode.prototype,"produces",void 0),t.__decorate([r.property({constructOnly:!0})],e.FocusAreaRenderNode.prototype,"techniques",void 0),t.__decorate([r.property()],e.FocusAreaRenderNode.prototype,"focusAreaGeometries",void 0),t.__decorate([r.property()],e.FocusAreaRenderNode.prototype,"effect",void 0),e.FocusAreaRenderNode=t.__decorate([a.subclass("esri.views.3d.webgl-engine.effects.focusArea.FocusAreaRenderNode")],e.FocusAreaRenderNode);class m{constructor(e,t,r,s,o){this.positions=e,this.indicesBottom=t,this.indicesExtruded=r,this.height=s,this.origin=o}}var F;e.FocusAreaEffect=void 0,(F=e.FocusAreaEffect||(e.FocusAreaEffect={}))[F.NONE=0]="NONE",F[F.BRIGHT=1]="BRIGHT",F[F.DARK=2]="DARK";const E={none:e.FocusAreaEffect.NONE,bright:e.FocusAreaEffect.BRIGHT,dark:e.FocusAreaEffect.DARK};e.FocusAreaGeometry=m,e.effectsMapping=E,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
