/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../../chunks/tslib.es6","../../../../../core/has","../../../../../core/maybe","../../../../../core/reactiveUtils","../../../../../core/accessorSupport/decorators/property","../../../../../core/Logger","../../../../../core/RandomLCG","../../../../../core/accessorSupport/decorators/subclass","../../../../../core/libs/gl-matrix-2/math/vec2","../../../../../core/libs/gl-matrix-2/factories/vec4f64","../../../webgl","../../../webgl/formats","../../../webgl/RenderNode","./HighlightApplyTechnique","./HighlightDownsampleTechnique","./HighlightPassParameters","./HighlightToSingleTechnique","./SingleHighlightApplyTechnique","./SingleHighlightBlurTechnique","../../lib/basicInterfaces","../../lib/DefaultVertexAttributeLocations","../../lib/DefaultVertexBufferLayouts","../../lib/VertexArrayObject","../../../../../chunks/HighlightDownsample.glsl","../../../../../chunks/SingleHighlightBlur.glsl","../../../../support/HighlightDefaults","../../../../webgl/BufferObject","../../../../webgl/enums","../../../../webgl/Texture","../../../../webgl/TextureDescriptor"],(function(e,t,i,r,l,s,h,n,o,a,g,u,c,p,d,m,T,f,x,b,H,w,C,_,q,y,v,S,R,P,D){"use strict";e.Highlight=class extends p{constructor(e){super(e),this.produces=u.InternalRenderCategory.HIGHLIGHTS,this.consumes={required:[u.InternalRenderCategory.HIGHLIGHTS,"highlights"]},this.useMultipleHighlights=!!i("enable-feature:multiple-highlights"),this._optionsTexture=null,this._downsampleDrawParameters=new q.HighlightDownsampleDrawParameters,this._passParameters=new T.HighlightPassParameters,this._singleHighlightBlurDrawParameters=new y.SingleHighlightBlurDrawParameters,this._grid=new A,e.techniques.precompile(m.HighlightDownsampleTechnique),this.useMultipleHighlights?e.techniques.precompile(d.HighlightApplyTechnique):(e.techniques.precompile(f.HighlightToSingleTechnique),e.techniques.precompile(b.SingleHighlightBlurTechnique),e.techniques.precompile(x.SingleHighlightApplyTechnique))}initialize(){this.addHandles([l.watch((()=>z(this.view.highlights)),(()=>{this._optionsTexture=r.disposeMaybe(this._optionsTexture),this.requestRender(H.RenderRequestType.UPDATE)}),l.initial)])}destroy(){this._passParameters&&(this._passParameters.highlightOptionsTexture=null),this._grid.coverage=r.releaseMaybe(this._grid.coverage),this._grid.vao=r.disposeMaybe(this._grid.vao),this._optionsTexture=r.releaseMaybe(this._optionsTexture)}_updateOptionsTexture(e){const t=this.renderingContext;let i=this._optionsTexture;if(null==i){const e=new D.TextureDescriptor(16,2);e.internalFormat=R.PixelFormat.RGBA,e.samplingMode=R.TextureSamplingMode.NEAREST,i=new P.Texture(t,e,null),this._optionsTexture=i}i.setData(e),this._passParameters.highlightOptionsTexture=i}render(e){const t=e.find((({name:e})=>e===u.InternalRenderCategory.HIGHLIGHTS)),{techniques:i,bindParameters:r,_passParameters:l,renderingContext:s}=this;if(!r.decorations)return t;const h=i.acquire(m.HighlightDownsampleTechnique);if(!h.compiled)return h.release(),this.requestRender(H.RenderRequestType.UPDATE),t;const n=e.find((({name:e})=>"highlights"===e)).getTexture(),o=()=>{const{highlights:e}=this.view;this._optionsTexture||this._updateOptionsTexture(O(e)),l.highlightOptionsTexture=this._optionsTexture,this._gridUpdateResources(n);const t=this._gridComputeCoverage(h,n,r);h.release();const{horizontalCellCount:i,verticalCellCount:s}=t;return l.horizontalCellCount=i,l.verticalCellCount=s,l.coverageTexture=t.coverage?.getTexture(),t},a=e=>{const t=e.verticalCellCount*e.horizontalCellCount;s.bindVAO(e.vao),s.drawElementsInstanced(R.PrimitiveType.TRIANGLES,6,R.DataType.UNSIGNED_BYTE,0,t)},{camera:g}=r,c=()=>{s.bindFramebuffer(t.fbo),s.setViewport4fv(g.fullViewport)};return this.useMultipleHighlights?this._renderMultiple(n,o,a,c):this._renderSingle(n,o,a,c),l.highlightTexture=null,l.coverageTexture=null,t}_renderMultiple(e,t,i,r){const{techniques:l,bindParameters:s,_passParameters:h,renderingContext:n}=this,o=l.acquire(d.HighlightApplyTechnique);if(!o.compiled)return o.release(),void this.requestRender(H.RenderRequestType.UPDATE);const a=t();h.highlightTexture=e,h.pixelRatio=s.camera.pixelRatio,h.maxHighlightLevel=E(this.view.highlights)-1,n.bindTechnique(o,s,h),r(),i(a),o.release()}_renderSingle(e,t,i,r){const{fboCache:l,techniques:s,bindParameters:h,_passParameters:n,renderingContext:o}=this,g=s.acquire(f.HighlightToSingleTechnique),u=s.acquire(b.SingleHighlightBlurTechnique),p=s.acquire(x.SingleHighlightApplyTechnique);if(!p.compiled||!u.compiled||!g.compiled)return p.release(),u.release(),g.release(),void this.requestRender(H.RenderRequestType.UPDATE);const d=t(),{width:m,height:T}=e.descriptor;n.maxHighlightLevel=E(this.view.highlights)-1,n.highlightTexture=e;const{camera:w}=h,{fullWidth:C,fullHeight:_,pixelRatio:q}=w,y=Math.ceil(C/q),v=Math.ceil(_/q),{_singleHighlightBlurDrawParameters:S}=this;for(let f=0;f<=n.maxHighlightLevel;++f){n.highlightLevel=f,o.setClearColor(0,0,0,0);const e=l.acquire(m,T,"single highlight",c.ColorFormat.RG);o.bindFramebuffer(e.fbo),o.setViewport(0,0,m,T),o.clear(R.FramebufferBit.COLOR),o.bindTechnique(g,h,n),i(d),S.blurInput=e.getTexture(),a.set(S.blurSize,1/y,0);const t=l.acquire(y,v,"single highlight blur h",c.ColorFormat.RG);o.unbindTexture(t.fbo?.colorTexture),o.bindFramebuffer(t.fbo),o.setViewport(0,0,y,v),o.clear(R.FramebufferBit.COLOR),S.blurInput=e.getTexture(),a.set(S.blurSize,1/y,0),o.bindTechnique(u,h,n,S),i(d),e.release(),a.set(S.blurSize,0,1/v),n.singleHighlightBlurTexture=t.getTexture(),r(),o.bindTechnique(p,h,n,S),i(d),t.release()}g.release(),u.release(),p.release()}_gridUpdateResources(e){const t=this.renderingContext,i=this._grid,{width:r,height:l}=e.descriptor;if(i.horizontalCellCount=Math.ceil(r/q.gridCellPixelSize),i.verticalCellCount=Math.ceil(l/q.gridCellPixelSize),i.vao)return;const s=S.BufferObject.createIndex(t,R.Usage.STATIC_DRAW,F);i.vao=new _.VertexArrayObject(t,w.Default3D,new Map([["geometry",C.NoVertex]]),new Map([["geometry",S.BufferObject.createVertex(t,R.Usage.STATIC_DRAW)]]),s)}_gridComputeCoverage(e,t,i){const r=this.renderingContext,l=this._grid,s=t.descriptor,h=Math.ceil(s.width/q.gridCellPixelSize),n=Math.ceil(s.height/q.gridCellPixelSize);this._downsampleDrawParameters.input=t,l.coverage?.release();const o=this.fboCache.acquire(h,n,"highlight coverage",c.ColorFormat.RG);return l.coverage=o,r.bindFramebuffer(o.fbo),r.bindTechnique(e,i,this._passParameters,this._downsampleDrawParameters),r.setViewport(0,0,h,n),r.screen.draw(),l}get test(){}},t.__decorate([s.property()],e.Highlight.prototype,"produces",void 0),t.__decorate([s.property()],e.Highlight.prototype,"consumes",void 0),t.__decorate([s.property({constructOnly:!0})],e.Highlight.prototype,"techniques",void 0),e.Highlight=t.__decorate([o.subclass("esri.views.3d.webgl-engine.effects.highlight.Highlight")],e.Highlight);class A{constructor(){this.coverage=null,this.vao=null,this.verticalCellCount=0,this.horizontalCellCount=0,this.viewportWidth=0,this.viewportHeight=0}}function O(e){const t=new Uint8Array(128),i=(e,i)=>{t[e]=i},r=(e,t)=>{const r=4*e,l=4*e+64,{color:s}=t,h=t.haloColor??s;i(r+0,s.r),i(r+1,s.g),i(r+2,s.b),i(r+3,t.fillOpacity*s.a*255),i(l+0,h.r),i(l+1,h.g),i(l+2,h.b),i(l+3,t.haloOpacity*h.a*255)};return B(e,((e,t)=>{r(t,e.options)})),t}const M=new Array(v.maximumHighlights),I=new Array(v.maximumHighlights);function B(e,t){const i=Math.min(e.length,v.maximumHighlights);let r=v.maximumHighlights;for(let s=i-1;s>=0;--s){const t=e.at(s);if(t){const e=t.name;M.includes(e,r)||(--r,M[r]=e,I[r]=s)}}const l=v.maximumHighlights-r;for(let s=0;s<l;++s){const i=v.maximumHighlights-l+s,r=I[i];t(e.at(r),s)}}let G=0;function z(e){let t=0;const i=Math.min(v.maximumHighlights,e.length);for(let r=0;r<i;++r){const i=e.at(r);if(i){const{name:e,options:r}=i;t+=e.length;const{color:l,fillOpacity:s,haloColor:h,haloOpacity:n}=r;t+=l.r+(h?.r??1)+s+n}}{const i=e.at(0);if(i){const{shadowOpacity:e,shadowDifference:r,shadowColor:l}=i.options;t+=e+r+l.r}}return G+++(t>=0?0:1)}const F=new Uint8Array([0,1,2,2,1,3]);function L(e,t,i,r,l,s,h=0,n){const{highlightGroupIndices:o}=l;o.clear();const u=[];B(r,(e=>{const{name:t}=e;o.set(t,u.length),u.push(t)}));const p=o.size,{gl:d}=e;a.set(l.highlightMixOrigin,h,0);let m=null;p>1&&(m=t.acquire(i.width,i.height,"highlight mix",c.ColorFormat.RG),e.bindFramebuffer(m.fbo),e.clearFramebuffer(g.ZEROS));const T=m?.getTexture()??null;l.highlightMixTexture=T,n();for(let a=0;a<p;++a)a>0&&(e.bindTexture(T,0),d.copyTexSubImage2D(R.TextureType.TEXTURE_2D,0,0,0,h,0,i.width,i.height),e.bindTexture(null,0)),e.clear(R.FramebufferBit.DEPTH),l.highlightLevel=a,l.highlightGroupName=u[a],s();m?.release()}function E(e){const t=new Set;for(let i=0;i<v.maximumHighlights;++i){const r=e.at(i)?.name;r&&t.add(r)}return t.size}e.renderHighlightBuffer=L,e.trackHighlightOptions=z,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
