/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../../chunks/tslib.es6","../../../../../core/has","../../../../../core/maybe","../../../../../core/accessorSupport/decorators/property","../../../../../core/Logger","../../../../../core/RandomLCG","../../../../../core/accessorSupport/decorators/subclass","../../../../../chunks/vec32","../../../../../geometry/support/clipRay","../../../../../geometry/support/frustum","../../../../../geometry/support/lineSegment","../../../../../geometry/support/ray","../../../../ViewingMode","../../../webgl","../../../webgl/RenderNode","../blit/Blit","./LaserlinePathData","./LaserlinePathTechnique","./LaserlinePathTechniqueConfiguration","./LaserlineTechnique","./LaserlineTechniqueConfiguration","../../lib/basicInterfaces","../../materials/internal/MaterialUtil","../../shaders/CompositingTechniqueConfiguration","../../../../webgl/enums"],(function(e,t,i,n,r,s,a,l,h,o,c,d,u,p,g,P,_,b,m,E,R,f,q,L,T,D){"use strict";e.LaserLineRenderer=class extends P{constructor(e){super(e),this.produces=g.InternalRenderCategory.LASERLINES,this.consumes={required:[g.InternalRenderCategory.LASERLINES,"normals"]},this.requireGeometryDepth=!0,this._configuration=new f.LaserlineTechniqueConfiguration,this._pathTechniqueConfiguration=new E.LaserlinePathTechniqueConfiguration,this._heightManifoldEnabled=!1,this._pointDistanceEnabled=!1,this._lineVerticalPlaneEnabled=!1,this._intersectsLineEnabled=!1,this._intersectsLineInfinite=!1,this._pathVerticalPlaneEnabled=!1,this._passParameters=new m.LaserlinePathPassParameters;const t=e.view._stage.renderView.techniques,i=new E.LaserlinePathTechniqueConfiguration;i.contrastControlEnabled=e.contrastControlEnabled,t.precompile(m.LaserlinePathTechnique,i)}initialize(){this._passParameters.renderCoordsHelper=this.view.renderCoordsHelper,this._pathTechniqueConfiguration.spherical=this.view.state.viewingMode===p.ViewingMode.Global,this._pathTechniqueConfiguration.contrastControlEnabled=this.contrastControlEnabled,this._techniques.precompile(m.LaserlinePathTechnique,this._pathTechniqueConfiguration),this._blit=new _.Blit(this._techniques,T.BlitMode.PremultipliedAlpha)}destroy(){this._pathVerticalPlaneData=n.disposeMaybe(this._pathVerticalPlaneData),this._blit=null}get _techniques(){return this.view._stage.renderView.techniques}get heightManifoldEnabled(){return this._heightManifoldEnabled}set heightManifoldEnabled(e){this._heightManifoldEnabled!==e&&(this._heightManifoldEnabled=e,this.requestRender(q.RenderRequestType.UPDATE))}get heightManifoldTarget(){return this._passParameters.heightManifoldTarget}set heightManifoldTarget(e){h.copy(this._passParameters.heightManifoldTarget,e),this.requestRender(q.RenderRequestType.UPDATE)}get pointDistanceEnabled(){return this._pointDistanceEnabled}set pointDistanceEnabled(e){e!==this._pointDistanceEnabled&&(this._pointDistanceEnabled=e,this.requestRender(q.RenderRequestType.UPDATE))}get pointDistanceTarget(){return this._passParameters.pointDistanceTarget}set pointDistanceTarget(e){h.copy(this._passParameters.pointDistanceTarget,e),this.requestRender(q.RenderRequestType.UPDATE)}get pointDistanceOrigin(){return this._passParameters.pointDistanceOrigin}set pointDistanceOrigin(e){h.copy(this._passParameters.pointDistanceOrigin,e),this.requestRender(q.RenderRequestType.UPDATE)}get lineVerticalPlaneEnabled(){return this._lineVerticalPlaneEnabled}set lineVerticalPlaneEnabled(e){e!==this._lineVerticalPlaneEnabled&&(this._lineVerticalPlaneEnabled=e,this.requestRender(q.RenderRequestType.UPDATE))}get lineVerticalPlaneSegment(){return this._passParameters.lineVerticalPlaneSegment}set lineVerticalPlaneSegment(e){d.copy(e,this._passParameters.lineVerticalPlaneSegment),this.requestRender(q.RenderRequestType.UPDATE)}get intersectsLineEnabled(){return this._intersectsLineEnabled}set intersectsLineEnabled(e){e!==this._intersectsLineEnabled&&(this._intersectsLineEnabled=e,this.requestRender(q.RenderRequestType.UPDATE))}get intersectsLineSegment(){return this._passParameters.intersectsLineSegment}set intersectsLineSegment(e){d.copy(e,this._passParameters.intersectsLineSegment),this.requestRender(q.RenderRequestType.UPDATE)}get intersectsLineRadius(){return this._passParameters.intersectsLineRadius}set intersectsLineRadius(e){e!==this._passParameters.intersectsLineRadius&&(this._passParameters.intersectsLineRadius=e,this.requestRender(q.RenderRequestType.UPDATE))}get intersectsLineInfinite(){return this._intersectsLineInfinite}set intersectsLineInfinite(e){e!==this._intersectsLineInfinite&&(this._intersectsLineInfinite=e,this.requestRender(q.RenderRequestType.UPDATE))}get pathVerticalPlaneEnabled(){return this._pathVerticalPlaneEnabled}set pathVerticalPlaneEnabled(e){e!==this._pathVerticalPlaneEnabled&&(this._pathVerticalPlaneEnabled=e,null!=this._pathVerticalPlaneData&&this.requestRender(q.RenderRequestType.UPDATE))}set pathVerticalPlaneVertices(e){null==this._pathVerticalPlaneData&&(this._pathVerticalPlaneData=new b.LaserlinePathData(this._passParameters.renderCoordsHelper)),this._pathVerticalPlaneData.vertices=e,this.pathVerticalPlaneEnabled&&this.requestRender(q.RenderRequestType.UPDATE)}set pathVerticalPlaneBuffers(e){null==this._pathVerticalPlaneData&&(this._pathVerticalPlaneData=new b.LaserlinePathData(this._passParameters.renderCoordsHelper)),this._pathVerticalPlaneData.buffers=e,this.pathVerticalPlaneEnabled&&this.requestRender(q.RenderRequestType.UPDATE)}setParameters(e){L.updateParameters(this._passParameters,e)&&this.requestRender(q.RenderRequestType.UPDATE)}precompile(){this._acquireTechnique().release()}render(e){const t=e.find((({name:e})=>e===g.InternalRenderCategory.LASERLINES));if(!this.bindParameters.decorations||null==this._blit)return t;const i=this.renderingContext,n=e.find((({name:e})=>"normals"===e));this._passParameters.normals=n?.getTexture();const r=()=>{(this.heightManifoldEnabled||this.pointDistanceEnabled||this.lineVerticalPlaneSegment||this.intersectsLineEnabled)&&this._renderUnified(),this.pathVerticalPlaneEnabled&&this._renderPath()};if(!this.contrastControlEnabled)return i.bindFramebuffer(t.fbo),r(),t;this._passParameters.colors=t.getTexture();const s=this.fboCache.acquire(t.fbo.width,t.fbo.height,"laser lines");return i.bindFramebuffer(s.fbo),i.setClearColor(0,0,0,0),i.clear(D.FramebufferBit.COLOR|D.FramebufferBit.DEPTH),r(),i.unbindTexture(t.getTexture()),this._blit.blend(i,s,t,this.bindParameters)||this.requestRender(q.RenderRequestType.UPDATE),s.release(),t}_acquireTechnique(){return this._configuration.heightManifoldEnabled=this.heightManifoldEnabled,this._configuration.lineVerticalPlaneEnabled=this.lineVerticalPlaneEnabled,this._configuration.pointDistanceEnabled=this.pointDistanceEnabled,this._configuration.intersectsLineEnabled=this.intersectsLineEnabled,this._configuration.contrastControlEnabled=this.contrastControlEnabled,this._configuration.spherical=this.view.state.viewingMode===p.ViewingMode.Global,this._techniques.acquire(R.LaserlineTechnique,this._configuration)}_renderUnified(){if(!this._updatePassParameters())return;const e=this._acquireTechnique();if(e.compiled){const t=this.renderingContext;t.bindTechnique(e,this.bindParameters,this._passParameters),t.screen.draw()}else this.requestRender(q.RenderRequestType.UPDATE);e.release()}_renderPath(){if(null==this._pathVerticalPlaneData)return;const e=this._techniques.acquire(m.LaserlinePathTechnique,this._pathTechniqueConfiguration);if(e.compiled){const t=this.renderingContext;this._passParameters.origin=this._pathVerticalPlaneData.origin,t.bindTechnique(e,this.bindParameters,this._passParameters),this._pathVerticalPlaneData.draw(t)}else this.requestRender(q.RenderRequestType.UPDATE);e.release()}_updatePassParameters(){if(!this._intersectsLineEnabled)return!0;const e=this.bindParameters.camera,t=this._passParameters;if(this._intersectsLineInfinite){if(o.fromRay(u.wrap(t.intersectsLineSegment.origin,t.intersectsLineSegment.vector),y),y.c0=-Number.MAX_VALUE,!c.intersectClipRay(e.frustum,y))return!1;o.getStart(y,t.lineStartWorld),o.getEnd(y,t.lineEndWorld)}else h.copy(t.lineStartWorld,t.intersectsLineSegment.origin),h.add(t.lineEndWorld,t.intersectsLineSegment.origin,t.intersectsLineSegment.vector);return!0}get test(){}},t.__decorate([r.property({constructOnly:!0})],e.LaserLineRenderer.prototype,"contrastControlEnabled",void 0),t.__decorate([r.property({constructOnly:!0})],e.LaserLineRenderer.prototype,"isDecoration",void 0),t.__decorate([r.property()],e.LaserLineRenderer.prototype,"produces",void 0),t.__decorate([r.property()],e.LaserLineRenderer.prototype,"consumes",void 0),e.LaserLineRenderer=t.__decorate([l.subclass("esri.views.3d.webgl-engine.effects.laserlines.LaserLineRenderer")],e.LaserLineRenderer);const y=o.create();Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
