/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","exports","../../../../../chunks/tslib.es6","../../../../../core/maybe","../../../../../core/promiseUtils","../../../../../core/reactiveUtils","../../../../../core/accessorSupport/decorators/property","../../../../../core/has","../../../../../core/Logger","../../../../../core/RandomLCG","../../../../../core/accessorSupport/decorators/subclass","../../../../../support/requestImageUtils","../../../webgl","../../../webgl/formats","../../../webgl/RenderNode","./SMAABlendWeightsTechnique","./SMAABlurTechnique","./SMAAEdgeDetectTechnique","./SMAAPassParameters","../../lib/basicInterfaces","../../../../webgl/enums","../../../../webgl/Texture","../../../../webgl/TextureDescriptor"],(function(e,r,t,s,a,i,o,n,u,c,l,h,d,p,A,m,T,b,_,g,f,x,q){"use strict";function S(e,r,t,s){const a=new q.TextureDescriptor;return a.pixelFormat=t,a.wrapMode=f.TextureWrapMode.CLAMP_TO_EDGE,a.width=s.width,a.height=s.height,a.samplingMode=r,new x.Texture(e,a,s)}r.SMAA=class extends A{constructor(e){super(e),this.produces="disabled",this.consumes={required:[d.InternalRenderCategory.ANTIALIASING],optional:[d.RenderCategory.COMPOSITE]},this._areaTexture=null,this._searchTexture=null,this._smaaParameters=new _.SMAAPassParameters,e.techniques.precompile(b.SMAAEdgeDetectTechnique),e.techniques.precompile(m.SMAABlendWeightsTechnique),e.techniques.precompile(T.SMAABlurTechnique)}initialize(){this.addHandles([i.watch((()=>this.isEnabled()),(e=>e?this.enable():this.disable()),i.syncAndInitial)])}async enable(){if(this.produces=d.InternalRenderCategory.ANTIALIASING,this._abortController||this._areaTexture&&this._searchTexture)return;this._abortController=new AbortController;const r=this._abortController.signal;try{const t=await new Promise(((r,t)=>e(["./SMAAData"],r,t)));await this._loadTextures(t,r),this.requestRender(g.RenderRequestType.UPDATE)}catch{}this._abortController=null}async _loadTextures(e,r){a.throwIfAborted(r);const[t,s]=await Promise.allSettled([h.requestImage(e.areaTexture,{signal:r}),h.requestImage(e.searchTexure,{signal:r})]);if(a.throwIfAborted(r),"fulfilled"!==t.status||"fulfilled"!==s.status)return;const i=this.renderingContext;this._areaTexture=S(i,f.TextureSamplingMode.LINEAR,f.PixelFormat.RGB,t.value),this._searchTexture=S(i,f.TextureSamplingMode.NEAREST,f.PixelFormat.LUMINANCE,s.value)}disable(){this.produces="disabled"}destroy(){this._searchTexture=s.disposeMaybe(this._searchTexture),this._areaTexture=s.disposeMaybe(this._areaTexture)}render(e){const r=e.find((({name:e})=>e===d.InternalRenderCategory.ANTIALIASING));if(!this._areaTexture||!this._searchTexture)return this.requestRender(g.RenderRequestType.UPDATE),r;const t=this.techniques.acquire(b.SMAAEdgeDetectTechnique),s=this.techniques.acquire(m.SMAABlendWeightsTechnique),a=this.techniques.acquire(T.SMAABlurTechnique);if(!t.compiled||!s.compiled||!a.compiled)return t.release(),s.release(),a.release(),this.requestRender(g.RenderRequestType.UPDATE),r;const i=e.find((({name:e})=>e===d.RenderCategory.COMPOSITE));if(!i)return r;const o=i.fbo.width,n=i.fbo.height,u=this.renderingContext;u.setViewport(0,0,o,n);const c=this.fboCache.acquire(o,n,"smaa edges",p.ColorFormat.RG);u.bindFramebuffer(c.fbo),u.setClearColor(0,0,0,1),u.clear(f.FramebufferBit.COLOR),this._smaaParameters.color=i.getTexture();const l=this.bindParameters;u.bindTechnique(t,l,this._smaaParameters),u.screen.draw(),t.release();const h=this.fboCache.acquire(o,n,"smaa blend");return u.bindFramebuffer(h.fbo),u.setClearColor(0,0,1,1),u.clear(f.FramebufferBit.COLOR),this._smaaParameters.inputTexture=c.getTexture(),this._smaaParameters.areaTexture=this._areaTexture,this._smaaParameters.searchTexture=this._searchTexture,u.bindTechnique(s,l,this._smaaParameters),u.screen.draw(),s.release(),c.release(),u.bindFramebuffer(r.fbo),u.setClearColor(0,1,0,1),u.clear(f.FramebufferBit.COLOR),this._smaaParameters.inputTexture=h.getTexture(),u.bindTechnique(a,l,this._smaaParameters),u.screen.draw(),a.release(),h.release(),r}},t.__decorate([o.property()],r.SMAA.prototype,"produces",void 0),t.__decorate([o.property()],r.SMAA.prototype,"consumes",void 0),t.__decorate([o.property({constructOnly:!0})],r.SMAA.prototype,"isEnabled",void 0),t.__decorate([o.property({constructOnly:!0})],r.SMAA.prototype,"techniques",void 0),t.__decorate([o.property()],r.SMAA.prototype,"_abortController",void 0),r.SMAA=t.__decorate([l.subclass("esri.views.3d.webgl-engine.effects.smaa.SMAA")],r.SMAA),Object.defineProperty(r,Symbol.toStringTag,{value:"Module"})}));
