/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../core/libs/gl-matrix-2/math/mat4","../../../../core/libs/gl-matrix-2/factories/mat4f64","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../chunks/vec42","../../../../core/libs/gl-matrix-2/factories/vec4f64","../../../../geometry/support/ray","../../../ViewingMode","./IntersectorInterfaces","./IntersectorTarget","./intersectorUtils","./verticalOffsetUtils"],(function(t,r,e,s,i,n,a,o,c,h,l,d,f){"use strict";const y=1e-5;class u{constructor(t){this.options=new h.IntersectorOptions,this._results=new g,this.transform=new f.IntersectorTransform,this.tolerance=y,this.verticalOffset=null,this._ray=o.create(),this._rayEnd=i.create(),this._rayBeginTransformed=i.create(),this._rayEndTransformed=i.create(),this.viewingMode=t??c.ViewingMode.Global}get results(){return this._results}get ray(){return this._ray}get rayBegin(){return this._ray.origin}get rayEnd(){return this._rayEnd}reset(t,r,e){this.resetWithRay(o.fromPoints(t,r,this._ray),e)}resetWithRay(t,r){this.camera=r,t!==this._ray&&o.copy(t,this._ray),0!==this.options.verticalOffset?this.viewingMode===c.ViewingMode.Local?this._ray.origin[2]-=this.options.verticalOffset:this.verticalOffset=this.options.verticalOffset:this.verticalOffset=null,s.add(this._rayEnd,this._ray.origin,this._ray.direction),this._results.init(this._ray)}intersect(t=null,r,e,s,i){this.point=r,this.filterPredicate=s,this.tolerance=e??y;const n=f.getVerticalOffsetObject3D(this.verticalOffset);if(t&&t.length>0){const r=i?t=>{i(t)&&this.intersectObject(t)}:t=>{this.intersectObject(t)};for(const e of t){const t=e.getSpatialQueryAccelerator?.();null!=t?(null!=n?t.forEachAlongRayWithVerticalOffset(this._ray.origin,this._ray.direction,r,n):t.forEachAlongRay(this._ray.origin,this._ray.direction,r),this.options.selectionMode&&this.options.hud&&t.forEachDegenerateObject(r)):e.objects.forAll((t=>r(t)))}}this.sortResults()}intersectObject(t){const r=t.geometries;if(!r)return;const i=t.effectiveTransformation,n=f.getVerticalOffsetObject3D(this.verticalOffset);for(const a of r){if(!a.visible)continue;const{material:r,id:o}=a;if(!r.visible)continue;this.transform.setAndInvalidateLazyTransforms(i,a.transformation),s.transformMat4(this._rayBeginTransformed,this.rayBegin,this.transform.inverse),s.transformMat4(this._rayEndTransformed,this.rayEnd,this.transform.inverse);const c=this.transform.transform;null!=n&&(n.objectTransform=this.transform),r.intersect(a,this.transform.transform,this,this._rayBeginTransformed,this._rayEndTransformed,((r,s,i,n,a,d)=>{if(r>=0){if(null!=this.filterPredicate&&!this.filterPredicate(this._ray.origin,this._rayEnd,r))return;const f=n?this._results.hud:this._results,y=n?n=>{const c=new l.HudTarget(t,o,i,d);n.set(h.IntersectorType.HUD,c,r,s,e.IDENTITY,a)}:e=>e.set(h.IntersectorType.OBJECT,{object:t,geometryId:o,triangleNr:i},r,s,c,a);if((null==f.min.drapedLayerOrder||a>=f.min.drapedLayerOrder)&&(null==f.min.dist||r<f.min.dist)&&y(f.min),this.options.store!==h.StoreResults.MIN&&(null==f.max.drapedLayerOrder||a<f.max.drapedLayerOrder)&&(null==f.max.dist||r>f.max.dist)&&y(f.max),this.options.store===h.StoreResults.ALL)if(n){const t=new O(this._ray);y(t),this._results.hud.all.push(t)}else{const t=new _(this._ray);y(t),this._results.all.push(t)}}}))}}sortResults(t=this._results.all){t.sort(((t,r)=>t.dist!==r.dist?(t.dist??0)-(r.dist??0):t.drapedLayerOrder!==r.drapedLayerOrder?m(t.drapedLayerOrder,r.drapedLayerOrder):m(t.drapedLayerGraphicOrder,r.drapedLayerGraphicOrder)))}}function m(t,r){return(r??-Number.MAX_VALUE)-(t??-Number.MAX_VALUE)}function p(t){return new u(t)}class g{constructor(){this.min=new _(o.create()),this.max=new _(o.create()),this.hud={min:new O(o.create()),max:new O(o.create()),all:new Array},this.ground=new _(o.create()),this.all=[]}init(t){this.min.init(t),this.max.init(t),this.ground.init(t),this.all.length=0,this.hud.min.init(t),this.hud.max.init(t),this.hud.all.length=0}}class _{get ray(){return this._ray}get distanceInRenderSpace(){return null!=this.dist?(s.scale(L,this.ray.direction,this.dist),s.length(L)):null}getIntersectionPoint(t){return!!d.isValidIntersectorResult(this)&&(s.scale(L,this.ray.direction,this.dist),s.add(t,this.ray.origin,L),!0)}getTransformedNormal(t){return s.copy(I,this.normal),I[3]=0,n.transformMat4(I,I,this.transformation),s.copy(t,I),s.normalize(t,t)}constructor(t){this.intersector=h.IntersectorType.OBJECT,this.normal=i.create(),this.transformation=e.create(),this._ray=o.create(),this.init(t)}init(t){this.dist=null,this.target=null,this.drapedLayerOrder=null,this.drapedLayerGraphicOrder=null,this.intersector=h.IntersectorType.OBJECT,o.copy(t,this._ray)}set(t,n,a,o,c,h,l){this.intersector=t,this.dist=a,s.copy(this.normal,o??i.UNIT_Z),r.copy(this.transformation,c??e.IDENTITY),this.target=n,this.drapedLayerOrder=h,this.drapedLayerGraphicOrder=l}copy(t){o.copy(t.ray,this._ray),this.intersector=t.intersector,this.dist=t.dist,this.target=t.target,this.drapedLayerOrder=t.drapedLayerOrder,this.drapedLayerGraphicOrder=t.drapedLayerGraphicOrder,s.copy(this.normal,t.normal),r.copy(this.transformation,t.transformation)}}class O extends _{constructor(){super(...arguments),this.intersector=h.IntersectorType.HUD}}function T(t){return new _(t)}const L=i.create(),I=a.create();t.defaultTolerance=y,t.newIntersector=p,t.newIntersectorResult=T,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
