/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../../chunks/tslib.es6","../../../../core/Accessor","../../../../core/has","../../../../core/uid","../../../../core/accessorSupport/decorators/property","../../../../core/Logger","../../../../core/RandomLCG","../../../../core/accessorSupport/decorators/subclass","./ModelDirtyTypes","./Util"],(function(e,t,r,o,i,s,d,a,n,c){"use strict";class y{constructor(e,t,r,o){this.operation=e,this.geometry=t,this.states=r,this.sync=o}}let h=class extends t{constructor(e){super(e),this._residentGeomRecords=new Map,this._dirtyGeomRecords=new Map,this._dirtyRecordCount=0}get dirty(){return this._dirtyRecordCount>0}commitLayer(e,t){const r=this._dirtyGeomRecords.get(e);if(!r)return;let o=0;r.forEach(((r,i)=>{const s=this._ensureGeomRecord(e,i);o+=r.size,r.forEach((({geometry:e,operation:r,states:o},d)=>{let a=!1;if(r===n.DirtyOperation.UPDATE){const r=s.get(d);if(r){if(o&n.DirtyState.TRANSFORMATION){const t=this.model.getObject(i);this.model.updateRenderGeometryTransformation(t,e,r)&&(a=!0)}a||t.updates.push({renderGeometry:r,updateType:o})}else c.assert(!1,"ModelDirtySet.commitLayer: invalid update")}if(r===n.DirtyOperation.REMOVE||a){const e=s.get(d);e?(t.removes.push(e),s.delete(d)):r===n.DirtyOperation.REMOVE&&c.assert(!1,"ModelDirtySet.commitLayer: invalid remove")}if(r===n.DirtyOperation.ADD||a){const r=this.model.getObject(i);if(null!=r){const o=this.model.getRenderGeometry(r,e);t.adds.push(o),s.set(d,o)}}})),0===s.size&&this._residentGeomRecords.get(e).delete(i)})),0===this._residentGeomRecords.get(e).size&&this._residentGeomRecords.delete(e),this._dirtyGeomRecords.delete(e),this._dirtyRecordCount-=o}commitSyncUpdates(e,t){const r=this._dirtyGeomRecords.get(e);r&&r.forEach(((r,o)=>{const i=this._ensureGeomRecord(e,o);r.forEach((({geometry:e,operation:r,states:s,sync:d},a)=>{let y=!1;if(r===n.DirtyOperation.UPDATE&&d){const r=i.get(a);if(r){if(s&n.DirtyState.TRANSFORMATION){const t=this.model.getObject(o);this.model.updateRenderGeometryTransformation(t,e,r)&&(y=!0)}y||t.updates.push({renderGeometry:r,updateType:s})}else c.assert(!1,"ModelDirtySet.commitSyncUpdates: invalid update")}}))}))}getResidentRenderGeometries(e,t){const r=this._residentGeomRecords.get(e);r&&r.forEach((e=>e.forEach((e=>t.push(e)))))}_objectStateChanged(e,t){for(const r of t.geometries)this._updateOrCreateDirtyRecord(t,r,null,n.DirtyOperation.UPDATE,e)}visibilityChanged(e){this._objectStateChanged(n.DirtyState.VISIBILITY,e)}highlightChanged(e){this._objectStateChanged(n.DirtyState.HIGHLIGHT,e)}occlusionChanged(e){this._objectStateChanged(n.DirtyState.OCCLUDEE,e)}attributesChanged({object:e,geometry:t,sync:r}){this._updateOrCreateDirtyRecord(e,t,null,n.DirtyOperation.UPDATE,n.DirtyState.GEOMETRY,r)}layerAdded(e){e.objects.forAll((t=>this._layerObjectAdded(e,t)))}layerRemoved(e){e.objects.forAll((t=>this._layerObjectRemoved(e,t)))}layerObjectAdded(e){this._layerObjectAdded(e.layer,e.object)}_layerObjectAdded(e,t){const r=e.id;for(const o of t.geometries)this._geometryAdded(t,o,r)}layerObjectRemoved(e){this._layerObjectRemoved(e.layer,e.object)}layerObjectsAdded(e){for(const t of e.objects)this._layerObjectAdded(e.layer,t)}layerObjectsRemoved(e){for(const t of e.objects)this._layerObjectRemoved(e.layer,t)}_layerObjectRemoved(e,t){const r=e.id;for(const o of t.geometries)this._geometryRemoved(t,o,r)}transformationChanged(e){const t=this._getParentLayerId(e),r=e.id;this._ensureGeomRecord(t,r).forEach((r=>{this._updateOrCreateDirtyRecord(e,r.geometry,t,n.DirtyOperation.UPDATE,n.DirtyState.TRANSFORMATION)}))}shaderTransformationChanged(e){const t=this._getParentLayerId(e),r=e.id;this._ensureGeomRecord(t,r).forEach((t=>{t.objectShaderTransformationChanged(e.shaderTransformation)}))}geometryAdded(e){this._geometryAdded(e.object,e.geometry)}_geometryAdded(e,t,r=null){this._updateOrCreateDirtyRecord(e,t,r,n.DirtyOperation.ADD)}geometryRemoved(e){this._geometryRemoved(e.object,e.geometry)}_geometryRemoved(e,t,r=null){this._updateOrCreateDirtyRecord(e,t,r,n.DirtyOperation.REMOVE)}_updateOrCreateDirtyRecord(e,t,r,o,i=n.DirtyState.NONE,s=!1){r=r??this._getParentLayerId(e);const d=e.id,a=t.id,h=this._ensureDirtyRecord(r,d),l=h.get(a);if(l){const e=l.operation;e===n.DirtyOperation.REMOVE&&o===n.DirtyOperation.ADD&&l.states!==n.DirtyState.NONE?l.operation=n.DirtyOperation.UPDATE:e===n.DirtyOperation.REMOVE&&o===n.DirtyOperation.ADD||e===n.DirtyOperation.ADD&&o===n.DirtyOperation.REMOVE?(h.delete(a),this._dirtyRecordCount--):e!==n.DirtyOperation.UPDATE||o!==n.DirtyOperation.REMOVE&&o!==n.DirtyOperation.UPDATE?(c.assert((e===n.DirtyOperation.REMOVE||e===n.DirtyOperation.ADD)&&o===n.DirtyOperation.UPDATE,"ModelDirtySet.objectGeometryAdded: inconsistent state"),l.states|=i):(l.operation=o,l.states|=i),l.sync=l.sync||s}else h.set(a,new y(o,t,i,s)),this._dirtyRecordCount++}_ensureGeomRecord(e,t){let r=this._residentGeomRecords.get(e);r||(r=new Map,this._residentGeomRecords.set(e,r));let o=r.get(t);return o||(o=new Map,r.set(t,o)),o}_ensureDirtyRecord(e,t){let r=this._dirtyGeomRecords.get(e);r||(r=new Map,this._dirtyGeomRecords.set(e,r));let o=r.get(t);return o||(o=new Map,r.set(t,o)),o}_getParentLayerId(e){return e.parentLayer?e.parentLayer.id:o.nullUid}formatDebugInfo(){const e=["ADD","UPD",void 0,"REM"];let t="";return this._dirtyGeomRecords.forEach(((r,o)=>{r.forEach(((r,i)=>{t.length>0&&(t+="\n"),t+=o+"."+i;const s=[];r.forEach((e=>{const t=e.operation;s[t]||(s[t]=[]),s[t].push(e.geometry.id)}));for(let o=0;o<s.length;o++)if(s[o]){t+=" "+e[o-1]+": ";for(let e=0;e<s[o].length;e++)t+=s[o][e]+", "}}))})),t}get test(){}};e.__decorate([i.property()],h.prototype,"_dirtyRecordCount",void 0),e.__decorate([i.property({constructOnly:!0})],h.prototype,"model",void 0),h=e.__decorate([a.subclass("esri.views.3d.webgl-engine.lib.ModelDirtySet")],h);return h}));
