/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../core/has","../../../../core/libs/gl-matrix-2/math/mat4","../../../../core/libs/gl-matrix-2/factories/mat4f64","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../chunks/sphere","../../support/mathUtils","./basicInterfaces","./ContentObject","./ContentObjectType","./Object3DStateID","./Util","./VertexAttribute","../materials/renderers/utils"],(function(t,e,i,s,r,a,o,n,h,m,c,l,d,u,b){"use strict";class g extends m.ContentObject{get geometries(){return this._geometries}get transformation(){return this._transformation??s.IDENTITY}set transformation(t){this._transformation=i.copy(this._transformation??s.create(),t),this._invalidateBoundingVolume(),this._emit("transformationChanged",this)}get shaderTransformation(){return this._shaderTransformation}set shaderTransformation(t){this._shaderTransformation=t?i.copy(this._shaderTransformation??s.create(),t):null,this._invalidateBoundingVolume(),this._emit("shaderTransformationChanged",this)}get effectiveTransformation(){return this.shaderTransformation??this.transformation}constructor(t={}){super(),this.type=c.ContentObjectType.Object,this._shaderTransformation=null,this._parentLayer=null,this._visible=!0,this.castShadow=t.castShadow??!0,this.usesVerticalDistanceToGround=t.usesVerticalDistanceToGround??!1,this.graphicUid=t.graphicUid,this.layerUid=t.layerUid,t.isElevationSource&&(this.lastValidElevationBB=new f),this._geometries=t.geometries?Array.from(t.geometries):new Array}dispose(){this._geometries.length=0}get parentLayer(){return this._parentLayer}set parentLayer(t){d.assert(null==this._parentLayer||null==t,"Object3D can only be added to a single Layer"),this._parentLayer=t}addGeometry(t){t.visible=this._visible,this._geometries.push(t),this._emit("geometryAdded",{object:this,geometry:t}),this._invalidateBoundingVolume()}removeGeometry(t){const e=this._geometries.splice(t,1)[0];e&&(this._emit("geometryRemoved",{object:this,geometry:e}),this._invalidateBoundingVolume())}removeAllGeometries(){for(;this._geometries.length>0;)this.removeGeometry(0)}geometryVertexAttributeUpdated(t,e,i=!1){this._emit("attributesChanged",{object:this,geometry:t,attribute:e,sync:i}),u.affectsGeometry(e)&&this._invalidateBoundingVolume()}get visible(){return this._visible}set visible(t){if(this._visible!==t){this._visible=t;for(const t of this._geometries)t.visible=this._visible;this._emit("visibilityChanged",this)}}maskOccludee(){const t=new l.Object3DOccludeeStateID;for(const e of this._geometries)e.occludees=b.addObject3DStateID(e.occludees,t);return this._emit("occlusionChanged",this),t}removeOcclude(t){for(const e of this._geometries)e.occludees=b.removeObject3DStateID(e.occludees,t);this._emit("occlusionChanged",this)}highlight(t){const e=new l.Object3DHighlightStateID(t);for(const i of this._geometries)i.addHighlight(e);return this._emit("highlightChanged",this),e}removeHighlight(t){for(const e of this._geometries)e.removeHighlight(t);this._emit("highlightChanged",this)}removeStateID(t){t.channel===h.Object3DState.Highlight?this.removeHighlight(t):this.removeOcclude(t)}getCombinedStaticTransformation(t,e){return i.multiply(e,this.transformation,t.transformation)}getCombinedShaderTransformation(t,e=s.create()){return i.multiply(e,this.effectiveTransformation,t.transformation)}get boundingVolumeWorldSpace(){return this._bvWorldSpace||(this._bvWorldSpace=this._bvWorldSpace||new _,this._validateBoundingVolume(this._bvWorldSpace,j.WorldSpace)),this._bvWorldSpace}get boundingVolumeObjectSpace(){return this._bvObjectSpace||(this._bvObjectSpace=this._bvObjectSpace||new _,this._validateBoundingVolume(this._bvObjectSpace,j.ObjectSpace)),this._bvObjectSpace}_validateBoundingVolume(t,e){const i=e===j.ObjectSpace;for(const s of this._geometries){const e=s.boundingInfo;e&&p(e,t,i?s.transformation:this.getCombinedShaderTransformation(s))}r.lerp(o.getCenter(t.bounds),t.min,t.max,.5);for(const s of this._geometries){const e=s.boundingInfo;if(null==e)continue;const a=i?s.transformation:this.getCombinedShaderTransformation(s),h=n.maxScale(a);r.transformMat4(O,e.center,a);const m=r.distance(O,o.getCenter(t.bounds)),c=e.radius*h;t.bounds[3]=Math.max(t.bounds[3],m+c)}}_invalidateBoundingVolume(){const t=this._bvWorldSpace?.bounds;this._bvObjectSpace=this._bvWorldSpace=void 0,this._parentLayer&&t&&this._parentLayer.notifyObjectBBChanged(this,t)}_emit(t,e){this._parentLayer&&this._parentLayer.events.emit(t,e)}get test(){}}class f{constructor(){this.min=a.fromValues(Number.MAX_VALUE,Number.MAX_VALUE,Number.MAX_VALUE),this.max=a.fromValues(-Number.MAX_VALUE,-Number.MAX_VALUE,-Number.MAX_VALUE)}isEmpty(){return this.max[0]<this.min[0]&&this.max[1]<this.min[1]&&this.max[2]<this.min[2]}}class _ extends f{constructor(){super(...arguments),this.bounds=o.create()}}function p(t,e,s){const a=t.bbMin,o=t.bbMax;if(i.hasIdentityRotation(s)){const t=r.set(v,s[12],s[13],s[14]);r.add(y,a,t),r.add(S,o,t);for(let i=0;i<3;++i)e.min[i]=Math.min(e.min[i],y[i]),e.max[i]=Math.max(e.max[i],S[i])}else if(r.transformMat4(y,a,s),r.exactEquals(a,o))for(let i=0;i<3;++i)e.min[i]=Math.min(e.min[i],y[i]),e.max[i]=Math.max(e.max[i],y[i]);else{r.transformMat4(S,o,s);for(let t=0;t<3;++t)e.min[t]=Math.min(e.min[t],y[t],S[t]),e.max[t]=Math.max(e.max[t],y[t],S[t]);for(let t=0;t<3;++t){r.copy(y,a),r.copy(S,o),y[t]=o[t],S[t]=a[t],r.transformMat4(y,y,s),r.transformMat4(S,S,s);for(let t=0;t<3;++t)e.min[t]=Math.min(e.min[t],y[t],S[t]),e.max[t]=Math.max(e.max[t],y[t],S[t])}}}const v=a.create(),y=a.create(),S=a.create(),O=a.create();var j;!function(t){t[t.WorldSpace=0]="WorldSpace",t[t.ObjectSpace=1]="ObjectSpace"}(j||(j={})),t.Object3D=g,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
