/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../../core/ObjectPool","../../../../core/PooledArray","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../geometry/support/frustum","../../../../geometry/support/ray","../../../../chunks/sphere","./Util"],(function(e,t,n,o,r,i,s,a){"use strict";class h{get bounds(){return this._root.bounds}get halfSize(){return this._root.halfSize}get root(){return this._root.node}get maximumObjectsPerNode(){return this._maximumObjectsPerNode}get maximumDepth(){return this._maximumDepth}get objectCount(){return this._objectCount}constructor(e,t){this.objectToBoundingSphere=e,this._maximumObjectsPerNode=10,this._maximumDepth=20,this._degenerateObjects=new Set,this._root=new l,this._objectCount=0,t&&(void 0!==t.maximumObjectsPerNode&&(this._maximumObjectsPerNode=t.maximumObjectsPerNode),void 0!==t.maximumDepth&&(this._maximumDepth=t.maximumDepth))}destroy(){this._degenerateObjects.clear(),l.clearPool(),B[0]=null,V.prune(),k.prune()}add(e,t=e.length){this._objectCount+=t,this._grow(e,t);const n=l.acquire();for(let o=0;o<t;o++){const t=e[o];this._isDegenerate(t)?this._degenerateObjects.add(t):(n.init(this._root),this._add(t,n))}l.release(n)}remove(e,t=null){this._objectCount-=e.length;const n=l.acquire();for(const o of e){const e=t??s.copy(this.objectToBoundingSphere(o),v);z(e[3])?(n.init(this._root),c(o,e,n)):this._degenerateObjects.delete(o)}l.release(n),this._shrink()}update(e,t){if(!z(t[3])&&this._isDegenerate(e))return;const n=D(e);this.remove(n,t),this.add(n)}forEachAlongRay(e,t,n){const o=i.wrap(e,t);d(this._root,(e=>{if(!m(o,e))return!1;const t=e.node;return t.terminals.forAll((e=>{this._intersectsObject(o,e)&&n(e)})),null!==t.residents&&t.residents.forAll((e=>{this._intersectsObject(o,e)&&n(e)})),!0}))}forEachAlongRayWithVerticalOffset(e,t,n,o){const r=i.wrap(e,t);d(this._root,(e=>{if(!_(r,e,o))return!1;const t=e.node;return t.terminals.forAll((e=>{this._intersectsObjectWithOffset(r,e,o)&&n(e)})),null!==t.residents&&t.residents.forAll((e=>{this._intersectsObjectWithOffset(r,e,o)&&n(e)})),!0}))}forEach(e){d(this._root,(t=>{const n=t.node;return n.terminals.forAll(e),null!==n.residents&&n.residents.forAll(e),!0})),this._degenerateObjects.forEach(e)}forEachDegenerateObject(e){this._degenerateObjects.forEach(e)}findClosest(e,t,o,i=()=>!0,a=1/0){let h=1/0,l=1/0,d=null;const c=j(e,t),f=n=>{if(--a,!i(n))return;const u=this.objectToBoundingSphere(n);if(!r.intersectsSphere(o,u))return;const c=T(e,t,s.getCenter(u)),f=c-u[3],m=c+u[3];f<h&&(h=f,l=m,d=n)};return u(this._root,(i=>{if(a<=0||!r.intersectsSphere(o,i.bounds))return!1;n.scale(A,c,i.halfSize),n.add(A,A,s.getCenter(i.bounds));if(T(e,t,A)>l)return!1;const h=i.node;return h.terminals.forAll((e=>f(e))),null!==h.residents&&h.residents.forAll((e=>f(e))),!0}),e,t),d}forEachInDepthRange(e,t,o,i,a,l,d){let c=-1/0,f=1/0;const m={setRange:e=>{o===h.DepthOrder.FRONT_TO_BACK?(c=Math.max(c,e.near),f=Math.min(f,e.far)):(c=Math.max(c,-e.far),f=Math.min(f,-e.near))}};m.setRange(i);const _=T(t,o,e),p=j(t,o),b=j(t,-o),g=e=>{if(!d(e))return;const n=this.objectToBoundingSphere(e),i=s.getCenter(n),h=T(t,o,i)-_,u=h-n[3],p=h+n[3];u>f||p<c||!r.intersectsSphere(l,n)||a(e,m)};u(this._root,(e=>{if(!r.intersectsSphere(l,e.bounds))return!1;n.scale(A,p,e.halfSize),n.add(A,A,s.getCenter(e.bounds));if(T(t,o,A)-_>f)return!1;n.scale(A,b,e.halfSize),n.add(A,A,s.getCenter(e.bounds));if(T(t,o,A)-_<c)return!1;const i=e.node;return i.terminals.forAll((e=>g(e))),null!==i.residents&&i.residents.forAll((e=>g(e))),!0}),t,o)}forEachNode(e){d(this._root,(t=>e(t.node,t.bounds,t.halfSize,t.depth)))}forEachNeighbor(e,t){const o=s.getRadius(t),r=s.getCenter(t),i=t=>{const i=this.objectToBoundingSphere(t),a=s.getRadius(i),h=o+a;return!(n.squaredDistance(s.getCenter(i),r)-h*h<=0)||e(t)};let a=!0;const h=e=>{a&&(a=i(e))};d(this._root,(e=>{const t=s.getRadius(e.bounds),i=o+t;if(n.squaredDistance(s.getCenter(e.bounds),r)-i*i>0)return!1;const l=e.node;return l.terminals.forAll(h),a&&null!==l.residents&&l.residents.forAll(h),a})),a&&this.forEachDegenerateObject(h)}_intersectsObject(e,t){const n=this.objectToBoundingSphere(t);return!(n[3]>0)||s.intersectsRay(n,e)}_intersectsObjectWithOffset(e,t,n){const o=this.objectToBoundingSphere(t);return!(o[3]>0)||s.intersectsRay(n.applyToBoundingSphere(o),e)}_add(e,t){t.advanceTo(this.objectToBoundingSphere(e))?t.node.terminals.push(e):(t.node.residents.push(e),t.node.residents.length>this._maximumObjectsPerNode&&t.depth<this._maximumDepth&&this._split(t))}_split(e){const t=e.node.residents;e.node.residents=null;for(let n=0;n<t.length;n++){const o=l.acquire().init(e);this._add(t.at(n),o),l.release(o)}}_grow(e,t){if(0!==t&&(O(e,t,(e=>this.objectToBoundingSphere(e)),w),z(w[3])&&!this._fitsInsideTree(w)))if(p(this._root.node))s.copy(w,this._root.bounds),this._root.halfSize=1.25*this._root.bounds[3],this._root.updateBoundsRadiusFromHalfSize();else{const e=this._rootBoundsForRootAsSubNode(w);this._placingRootViolatesMaxDepth(e)?this._rebuildTree(w,e):this._growRootAsSubNode(e),l.release(e)}}_rebuildTree(e,t){n.copy(s.getCenter(E),s.getCenter(t.bounds)),E[3]=t.halfSize,O([e,E],2,(e=>e),P);const o=l.acquire().init(this._root);this._root.initFrom(null,P,P[3]),this._root.increaseHalfSize(1.25),d(o,(e=>(this.add(e.node.terminals.data,e.node.terminals.length),null!==e.node.residents&&this.add(e.node.residents.data,e.node.residents.length),!0))),l.release(o)}_placingRootViolatesMaxDepth(e){const t=Math.log(e.halfSize/this._root.halfSize)*Math.LOG2E;let n=0;return d(this._root,(e=>(n=Math.max(n,e.depth),n+t<=this._maximumDepth))),n+t>this._maximumDepth}_rootBoundsForRootAsSubNode(e){const t=e[3],n=e;let o=-1/0;const r=this._root.bounds,i=this._root.halfSize;for(let a=0;a<3;a++){const e=r[a]-i-(n[a]-t),s=n[a]+t-(r[a]+i),h=Math.max(0,Math.ceil(e/(2*i))),l=Math.max(0,Math.ceil(s/(2*i)))+1,d=2**Math.ceil(Math.log(h+l)*Math.LOG2E);o=Math.max(o,d),q[a].min=h,q[a].max=l}for(let a=0;a<3;a++){let e=q[a].min,t=q[a].max;const n=(o-(e+t))/2;e+=Math.ceil(n),t+=Math.floor(n);const s=r[a]-i-e*i*2;R[a]=s+(t+e)*i}const s=o*i;return R[3]=s*M,l.acquire().initFrom(null,R,s,0)}_growRootAsSubNode(e){const t=this._root.node;n.copy(s.getCenter(w),s.getCenter(this._root.bounds)),w[3]=this._root.halfSize,this._root.init(e),e.advanceTo(w,null,!0),e.node.children=t.children,e.node.residents=t.residents,e.node.terminals=t.terminals}_shrink(){for(;;){const e=this._findShrinkIndex();if(-1===e)break;this._root.advance(e),this._root.depth=0}}_findShrinkIndex(){if(0!==this._root.node.terminals.length||this._root.isLeaf())return-1;let e=null;const t=this._root.node.children;let n=0,o=0;for(;o<t.length&&null==e;)n=o++,e=t[n];for(;o<t.length;)if(t[o++])return-1;return n}_isDegenerate(e){return!z(this.objectToBoundingSphere(e)[3])}_fitsInsideTree(e){const t=this._root.bounds,n=this._root.halfSize;return e[3]<=n&&e[0]>=t[0]-n&&e[0]<=t[0]+n&&e[1]>=t[1]-n&&e[1]<=t[1]+n&&e[2]>=t[2]-n&&e[2]<=t[2]+n}toJSON(){const{maximumDepth:e,maximumObjectsPerNode:t,_objectCount:n}=this,o=this._nodeToJSON(this._root.node);return{maximumDepth:e,maximumObjectsPerNode:t,objectCount:n,root:{bounds:this._root.bounds,halfSize:this._root.halfSize,depth:this._root.depth,node:o}}}_nodeToJSON(e){const t=e.children.map((e=>e?this._nodeToJSON(e):null)),n=e.residents?.map((e=>this.objectToBoundingSphere(e))),o=e.terminals?.map((e=>this.objectToBoundingSphere(e)));return{children:t,residents:n,terminals:o}}static fromJSON(e){const t=new h((e=>e),{maximumDepth:e.maximumDepth,maximumObjectsPerNode:e.maximumObjectsPerNode});return t._objectCount=e.objectCount,t._root.initFrom(e.root.node,e.root.bounds,e.root.halfSize,e.root.depth),t}}class l{constructor(){this.bounds=s.create(),this.halfSize=0,this.initFrom(null,null,0,0)}init(e){return this.initFrom(e.node,e.bounds,e.halfSize,e.depth)}initFrom(e,t,n,o=this.depth){return this.node=null!=e?e:l.createEmptyNode(),t&&s.copy(t,this.bounds),this.halfSize=n,this.depth=o,this}increaseHalfSize(e){this.halfSize*=e,this.updateBoundsRadiusFromHalfSize()}updateBoundsRadiusFromHalfSize(){this.bounds[3]=this.halfSize*M}advance(e){let t=this.node.children[e];t||(t=l.createEmptyNode(),this.node.children[e]=t),this.node=t,this.halfSize/=2,this.depth++;const n=C[e];return this.bounds[0]+=n[0]*this.halfSize,this.bounds[1]+=n[1]*this.halfSize,this.bounds[2]+=n[2]*this.halfSize,this.updateBoundsRadiusFromHalfSize(),this}advanceTo(e,t,n=!1){for(;;){if(this.isTerminalFor(e))return t&&t(this,-1),!0;if(this.isLeaf()){if(!n)return t&&t(this,-1),!1;this.node.residents=null}const o=this._childIndex(e);t&&t(this,o),this.advance(o)}}isLeaf(){return null!=this.node.residents}isTerminalFor(e){return e[3]>this.halfSize/2}_childIndex(e){const t=this.bounds;return(t[0]<e[0]?1:0)+(t[1]<e[1]?2:0)+(t[2]<e[2]?4:0)}static createEmptyNode(){return{children:[null,null,null,null,null,null,null,null],terminals:new t({shrink:!0}),residents:new t({shrink:!0})}}static acquire(){return l._pool.acquire()}static release(e){l._pool.release(e)}static clearPool(){l._pool.prune()}}function d(e,t){let n=l.acquire().init(e);const o=[n];for(;0!==o.length;){if(n=o.pop(),t(n)&&!n.isLeaf())for(let e=0;e<n.node.children.length;e++){n.node.children[e]&&o.push(l.acquire().init(n).advance(e))}l.release(n)}}function u(e,t,n,o=h.DepthOrder.FRONT_TO_BACK){let r=l.acquire().init(e);const i=[r];for(x(n,o,I);0!==i.length;){if(r=i.pop(),t(r)&&!r.isLeaf())for(let e=7;e>=0;--e){const t=I[e];r.node.children[t]&&i.push(l.acquire().init(r).advance(t))}l.release(r)}}function c(e,t,n){V.clear();const o=n.advanceTo(t,((e,t)=>{V.push(e.node),V.push(t)}))?n.node.terminals:n.node.residents;if(o.removeUnordered(e),0===o.length)for(let r=V.length-2;r>=0;r-=2){if(!f(V.data[r],V.data[r+1]))break}}function f(e,n){return n>=0&&(e.children[n]=null),!!p(e)&&(null===e.residents&&(e.residents=new t({shrink:!0})),!0)}function m(e,t){return S(s.getCenter(t.bounds),2*-t.halfSize,y),S(s.getCenter(t.bounds),2*t.halfSize,F),a.rayBoxTest(e.origin,e.direction,y,F)}function _(e,t,n){return S(s.getCenter(t.bounds),2*-t.halfSize,y),S(s.getCenter(t.bounds),2*t.halfSize,F),n.applyToMinMax(y,F),a.rayBoxTest(e.origin,e.direction,y,F)}function p(e){if(0!==e.terminals.length)return!1;if(null!==e.residents)return 0===e.residents.length;for(let t=0;t<e.children.length;t++)if(e.children[t])return!1;return!0}function b(e,t){e[0]=Math.min(e[0],t[0]-t[3]),e[1]=Math.min(e[1],t[1]-t[3]),e[2]=Math.min(e[2],t[2]-t[3])}function g(e,t){e[0]=Math.max(e[0],t[0]+t[3]),e[1]=Math.max(e[1],t[1]+t[3]),e[2]=Math.max(e[2],t[2]+t[3])}function S(e,t,n){n[0]=e[0]+t,n[1]=e[1]+t,n[2]=e[2]+t}function O(e,t,o,r){if(1===t){const t=o(e[0]);s.copy(t,r)}else{y[0]=1/0,y[1]=1/0,y[2]=1/0,F[0]=-1/0,F[1]=-1/0,F[2]=-1/0;for(let n=0;n<t;n++){const t=o(e[n]);z(t[3])&&(b(y,t),g(F,t))}n.lerp(s.getCenter(r),y,F,.5),r[3]=Math.max(F[0]-y[0],F[1]-y[1],F[2]-y[2])/2}}function x(e,t,n){if(!k.length)for(let o=0;o<8;++o)k.push({index:0,distance:0});for(let o=0;o<8;++o){const n=C[o];k.data[o].index=o,k.data[o].distance=T(e,t,n)}k.sort(((e,t)=>e.distance-t.distance));for(let o=0;o<8;++o)n[o]=k.data[o].index}function j(e,t){let n,o=1/0;for(let r=0;r<8;++r){const i=T(e,t,N[r]);i<o&&(o=i,n=N[r])}return n}function T(e,t,n){return t*(e[0]*n[0]+e[1]*n[1]+e[2]*n[2])}function z(e){return!isNaN(e)&&e!==-1/0&&e!==1/0&&e>0}l._pool=new e(l),function(e){var t;(t=e.DepthOrder||(e.DepthOrder={}))[t.FRONT_TO_BACK=1]="FRONT_TO_BACK",t[t.BACK_TO_FRONT=-1]="BACK_TO_FRONT"}(h||(h={}));const C=[o.fromValues(-1,-1,-1),o.fromValues(1,-1,-1),o.fromValues(-1,1,-1),o.fromValues(1,1,-1),o.fromValues(-1,-1,1),o.fromValues(1,-1,1),o.fromValues(-1,1,1),o.fromValues(1,1,1)],N=[o.fromValues(-1,-1,-1),o.fromValues(-1,-1,1),o.fromValues(-1,1,-1),o.fromValues(-1,1,1),o.fromValues(1,-1,-1),o.fromValues(1,-1,1),o.fromValues(1,1,-1),o.fromValues(1,1,1)],M=Math.sqrt(3),B=[null];function D(e){return B[0]=e,B}const R=s.create(),A=o.create(),y=o.create(),F=o.create(),V=new t,v=s.create(),w=s.create(),E=s.create(),P=s.create(),q=[{min:0,max:0},{min:0,max:0},{min:0,max:0}],k=new t,I=[0,0,0,0,0,0,0,0];return h}));
