/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","exports","../../../../chunks/tslib.es6","../../../../core/arrayUtils","../../../../core/asyncUtils","../../../../core/colorUtils","../../../../core/has","../../../../core/maybe","../../../../core/promiseUtils","../../../../core/reactiveUtils","../../../../core/signal","../../../../core/accessorSupport/decorators/property","../../../../core/Logger","../../../../core/accessorSupport/interfaces","../../../../core/accessorSupport/tracking/Flags","../../../../core/Warning","../../../../core/Error","../../../../core/libs/gl-matrix-2/math/mat4","../../../../core/libs/gl-matrix-2/factories/mat4f64","../../../../chunks/vec42","../../../../core/libs/gl-matrix-2/factories/vec4f64","../../webgl","../../support/debugFlags","../../webgl/formats","../core/FBOCache","../core/renderPasses/RenderPassManager","../core/shaderLibrary/ShaderOutput","../core/shaderLibrary/hud/HUDRenderStyle","../core/shaderLibrary/shading/ScreenSpaceConstants","../effects/RenderNodes","../effects/RenderPlugin","../effects/RenderPluginManager","../effects/blit/Blit","../effects/highlight/Highlight","../effects/transparency/OITBlend","./AnimationTimer","./AnimationTimeStep","./basicInterfaces","./BoundingInfo","./depthRange","./depthRangeUtils","./MainFramebuffer","./Material","./OITPass","./RenderContext","./rendererUtils","./RenderFeature","./RenderPluginInput","./RenderSlot","./ShadowAccumulator","./ShadowMap","./SliceHelper","./edgeRendering/interfaces","../materials/renderers/MergedRenderer","../parts/renderUtils","../statistics/RendererPerformanceInfo","../../../support/RenderState","../../../webgl/enums"],(function(e,t,r,i,s,a,n,h,o,d,l,_,u,p,c,m,g,f,b,R,T,S,E,A,P,C,y,I,D,w,O,N,M,H,x,L,F,U,v,q,G,B,V,W,Q,k,z,j,X,Y,Z,J,K,$,ee,te,re,ie){"use strict";class se{constructor(e,t,r,i,s,h){this._stage=e,this._techniques=r,this._rctx=i,this._compositingHelper=s,this._requestRender=h,this._pluginsHas={hudElements:!1,water:!1},this._renderers=new Map,this.renderPassManager=new C.RenderPassManager,this._isRendering=!1,this._inGlobeView=!1,this._backgroundColor=T.fromValues(0,0,0,1),this._sliceHelper=new J,this._blit=null,this._oitblend=null,this._state=l.signal(re.RenderState.IDLE),this._highQualityTransparencyEnabled=!0,this._ssrEnabled=!1,this._hasAnimations=!1,this._animationTimestep=new F.AnimationTimeStep,this._loadEdgeViewTask=null,this._edgeViewCallbacks=[],this._reprojectionMatrixVersion=l.signal(0),this._renderHiddenTransparentEdges=()=>{},this._pluginInput=new j.RenderPluginInput,this._releaseNormals=e=>{e.some((({name:e})=>"normals"===e))&&this._pluginInput.release("normals")},this._debugNeedsDepth=!1,this.fboCache=new P.FBOCache(i),this._renderStateFeatures=l.signal(z.setupFeatureDefaults(!n("disable-feature:high-quality-idle"),e.view.qualityProfile)),this._framebuffer=new B.MainFramebuffer(this.fboCache),this.performanceInfo=new te.RendererPerformanceInfo(this._rctx),this._shadowMap=new Z.ShadowMap(this.fboCache,e.viewingMode),this._shadowAccumulator=new Y.ShadowAccumulator(this.fboCache,r,e,(e=>{const t=this.shadowsEnabled;this._shadowMap.enabled=!0,this._ensureBindParametersCamera(e.camera,e.contentCamera),this._plugins.prepareRender(),this._shadowMap.enabled=t}),((e,t,r)=>{const i=this._stage.view.qualitySettings.maximumPixelRatio;e.shadowMap.start(e.camera,t,r,!0,i),this._renderShadowCascades(y.ShaderOutput.Shadow,e.shadowMap),e.shadowMap.finish(),e.camera.setGLViewport(this._rctx),this._ensureBindParametersCamera(e.camera,e.contentCamera)}),h),this._renderContext=new Q.RenderContext(this._rctx,this._shadowMap,r),this._nodes=new w.RenderNodes(this._renderContext),this._plugins=new N.RenderPluginManager({renderContext:this._renderContext,techniques:r,materials:t,requestRender:h,controller:e,fbos:this.fboCache,isFeatureEnabled:e=>this.isFeatureEnabled(e)}),this._plugins.add(this.renderPassManager),this._handles=[d.watch((()=>this._stage.view.state.camera),(()=>h()),d.syncAndInitial),d.watch((()=>E.debugFlags.EDGES_SHOW_HIDDEN_TRANSPARENT_EDGES),(e=>{this._renderHiddenTransparentEdges=e?()=>this._renderEdges(K.Transparency.TRANSPARENT):()=>{},h()}),d.initial),d.watch((()=>this._stage.view.environment.background?.color),(e=>{const t=e?a.unitRGBAFromColor(e):T.ZEROS;R.set(this._backgroundColor,t[0]*t[3],t[1]*t[3],t[2]*t[3],t[3]),h()}),d.syncAndInitial),d.watch((()=>this._stage.view.state.camera.relativeElevation),(e=>this._inGlobeView=(e??1/0)>=D.distanceFadeEnd),d.syncAndInitial),d.watch((()=>this._bindParameters.clouds.fadeFactor),(()=>this._bindParameters.fadeLighting()),d.sync),d.watch((()=>this._bindParameters.clouds.data?.state),(()=>this._requestRender(U.RenderRequestType.UPDATE)),d.sync)]}destroy(){this._handles.forEach((e=>e.remove())),this._gpuTimerHandle=h.removeMaybe(this._gpuTimerHandle),this._nodes.destroy(),this._framebuffer.dispose(),this._shadowMap.dispose(),this._shadowAccumulator.dispose(),this._loadEdgeViewTask=h.abortMaybe(this._loadEdgeViewTask),this._edgeView=h.destroyMaybe(this._edgeView),this.renderPassManager.dispose(),this._releaseFBOs(),this._disposeOffscreenBuffers(),this.fboCache.destroy(),this._plugins.destroy(),this._renderers.clear(),this._blit=null,this._oitblend=null,v.BoundingInfo.prune()}get renderContext(){return this._renderContext}get _bindParameters(){return this._renderContext.bind}get _framebufferSize(){return this._framebuffer.size}updateRenderFeatures(e=null,t=!n("disable-feature:high-quality-idle")){this._renderStateFeatures.value=z.setupFeatureDefaults(t,e),this._plugins.renderFeatureChanged(),this._requestRender()}isFeatureEnabled(e,t=this._state.value){return this._renderStateFeatures.value.get(t,e)??!1}setFeatureEnabled(e,t,r){this._renderStateFeatures.mutate((i=>i.set(t,e,r))),this._requestRender()}get _highQualityTransparency(){return this._highQualityTransparencyEnabled||this.isFeatureEnabled(z.RenderFeature.HighQualityTransparency)}get hasReflections(){return this._pluginsHas.water&&(this._ssrEnabled||this.isFeatureEnabled(z.RenderFeature.WaterReflection))}get hasHighlights(){return this._plugins.produces(y.ShaderOutput.Highlight,X.RenderSlot.OPAQUE_MATERIAL,X.RenderSlot.TRANSPARENT_MATERIAL,X.RenderSlot.DRAPED_MATERIAL,X.RenderSlot.HUD_MATERIAL,X.RenderSlot.LABEL_MATERIAL)}get hasHighlightsOnHUD(){return this._plugins.produces(y.ShaderOutput.Highlight,X.RenderSlot.HUD_MATERIAL,X.RenderSlot.LABEL_MATERIAL)}get hasSSAO(){return(this._stage.view.qualitySettings.ambientOcclusion||this.isFeatureEnabled(z.RenderFeature.SSAO))&&!this._inGlobeView}get hasSMAA(){return this._stage.view.qualitySettings.antialiasingEnabled||this.isFeatureEnabled(z.RenderFeature.Antialiasing)}get fullResolutionAtmosphere(){return this._stage.view.qualitySettings.highResolutionAtmosphere||this.isFeatureEnabled(z.RenderFeature.HighResolutionAtmosphere)}_releaseFBOs(){this._bindParameters.ssr.lastFrameColor=h.releaseMaybe(this._bindParameters.ssr.lastFrameColor),this._bindParameters.terrainDepth=h.releaseMaybe(this._bindParameters.terrainDepth),this._bindParameters.geometryDepth=h.releaseMaybe(this._bindParameters.geometryDepth)}_disposeOffscreenBuffers(){this._framebuffer.dispose(),this._disposeBindBuffers()}_disposeBindBuffers(){this._shadowMap.disposeOffscreenBuffers(),this._bindParameters.depth=h.releaseMaybe(this._bindParameters.depth),this._bindParameters.hudVisibility=h.releaseMaybe(this._bindParameters.hudVisibility)}get updating(){return null!=this._edgeView&&this._edgeView.updating||this._shadowAccumulator.running||this._plugins.updating||!this.isCameraFinal}loadEdgeView(){return this._loadEdgeViewTask||(this._loadEdgeViewTask=s.createTask((async t=>{const{EdgeView:r}=await new Promise(((t,r)=>e(["./edgeRendering/EdgeView"],t,r)));o.throwIfAborted(t);const i=this._edgeView=new r({rctx:this._rctx,renderSR:this._stage.view.renderSpatialReference,viewingMode:this._stage.viewingMode,techniques:this._techniques,setNeedsRender:()=>this._requestRender(),schedule:ce(this._stage.view.resourceController)});return this._handles.push(d.watch((()=>i.updating),(()=>this._requestRender()),d.sync)),this._requestRender(),this._edgeViewCallbacks.forEach((e=>e(i))),this._edgeViewCallbacks.length=0,i}))),this._loadEdgeViewTask.promise}withEdgeView(e){this.loadEdgeView(),null==this._edgeView?this._edgeViewCallbacks.push(e):e(this._edgeView)}get edgeView(){return this._edgeView}get isCameraFinal(){return this._reprojectionMatrixVersion.value>=0&&f.equals(this._bindParameters.ssr.reprojectionMatrix,b.IDENTITY)}set _reprojectionMatrix(e){i.update(this._bindParameters.ssr.reprojectionMatrix,e)&&this._reprojectionMatrixVersion.value++}get shadowsEnabled(){return!!this._shadowMap?.enabled}setParameters(e){const{_shadowMap:t,_bindParameters:r}=this;if(void 0!==e.qualitySettings?.reflections&&this._ssrEnabled!==e.qualitySettings.reflections&&(this._ssrEnabled=e.qualitySettings.reflections,this._requestRender()),void 0!==e.shadowMap&&this._shadowMap.enabled!==e.shadowMap&&(this._shadowMap.enabled=e.shadowMap,this._requestRender()),void 0!==e.shadowMapMaxCascades&&t.maxCascades!==e.shadowMapMaxCascades&&(t.maxCascades=e.shadowMapMaxCascades,this._requestRender()),null!=e.environment){null!=e.environment.weather&&(this._bindParameters.weather=e.environment.weather,this._bindParameters.weatherVisible=!!e.weatherVisible);const t="virtual"!==e.environment.lighting.type;r.enableFillLights!==t&&(r.enableFillLights=t,this._requestRender())}void 0!==e.highQualityTransparency&&this._highQualityTransparencyEnabled!==e.highQualityTransparency&&(this._highQualityTransparencyEnabled=e.highQualityTransparency,this._requestRender()),void 0!==e.shadowCast&&this._shadowAccumulator.setOptions(e.shadowCast)}set slicePlane(e){this._sliceHelper.plane!==e&&(this._sliceHelper.plane=e,this._requestRender())}get plugins(){return this._plugins}getMaterialRenderer(e){return this._renderers.get(e)}get _hasOITSupport(){return this._rctx.driverTest.floatBufferBlend.result}get _oitEnabled(){return this._highQualityTransparency&&this._hasOITSupport}modify(e,t){this._isRendering&&console.warn("Renderer.modify called while rendering");const{adds:r,removes:i,updates:s}=e;if(0===r.length&&0===i.length&&0===s.length)return;k.splitRenderGeometryChangeSetByMaterial(e).forEach(((r,i)=>{if(t.done)return;let s=this._renderers.get(i);null==s&&r.adds.length>0&&(s=new $.MergedRenderer({material:i}),s.initializeRenderContext(this._plugins.context),this._plugins.add(s),this._renderers.set(i,s)),s&&(s.modify(r),0===s.numGeometries&&(this._renderers.delete(s.material),this._plugins.remove(s),s.destroy())),r.removes.forEach((t=>e.removes.removeUnordered(t))),r.adds.forEach((t=>e.adds.removeUnordered(t))),r.updates.forEach((t=>e.updates.removeUnordered(t))),t.madeProgress()})),this.updateHasFlags()}updateHasFlags(){const e=this._pluginsHas;e.hudElements=this._plugins.produces(y.ShaderOutput.Color,X.RenderSlot.LINE_CALLOUTS_HUD_DEPTH,X.RenderSlot.HUD_MATERIAL,X.RenderSlot.LABEL_MATERIAL),e.water=this._plugins.produces(y.ShaderOutput.Normal,X.RenderSlot.DRAPED_WATER),this._bindParameters.hasOccludees=this._plugins.hasOccludees,this._requestRender()}updateAnimation(e,t){this._animationTimer??=new L.AnimationTimer(e.camera,t),this._animationTimer.advance(e.camera,t,this._animationTimeDilation),null!=e.forcedAnimationTime&&this._animationTimer.forceTime(e.forcedAnimationTime);const r=this._hasAnimations;return this._hasAnimations=this._plugins.updateAnimation(this._animationTimer),this._hasAnimations=this._nodes.updateAnimation(this._animationTimer)||this._hasAnimations,this._hasAnimations=this.overlay?.updateAnimation(this._animationTimer)||this._hasAnimations,this._hasAnimations!==r&&(this._gpuTimerHandle=r?h.removeMaybe(this._gpuTimerHandle):this.performanceInfo.enableGPUPerformanceInfo()),this._hasAnimations}get animationTimestep(){return this._animationTimestep.value}get _animationTimeDilation(){return this._animationTimestep.timeDilation}resetAnimation(){this._animationTimestep.clear()}tick(){this.fboCache.clean()}render(e,t,r=k.RendererTarget.Default,i=!1){try{return this._isRendering=!0,this._render(e,t,r,i)}catch(s){console.error(`Exception during rendering: ${s}`)}finally{this._isRendering=!1}return new ee.RenderSceneResult(this._pluginInput.get("final-color"),null)}_render(e,t,r=k.RendererTarget.Default,i){this.performanceInfo.startFrame(),this.fboCache.frameStart(),this.fboCache.interactive=r===k.RendererTarget.Default,this._disposeBindBuffers();const s=this._framebuffer,{camera:a,contentCamera:n,mode:o,alignPixelEnabled:d}=e;this._state.value=o,this._bindParameters.overlay=this.overlay?.render(t),this._bindParameters.overlay&&this.performanceInfo.advance(te.PerformanceCategory.OVERLAY),this._renderContext.time=t,this._bindParameters.oitPass=W.OITPass.NONE,this._bindParameters.alignPixelEnabled=d,this._bindParameters.decorations=!i,this._bindParameters.mainDepth=null,this._bindParameters.viewshedEnabled=this._nodes.produces(S.InternalRenderCategory.VIEWSHED);const l=this._nodes.produces("magnifier-color"),_=this._nodes.produces("final-color");this._bindParameters.slicePlane=this._sliceHelper.plane,a.setGLViewport(this._rctx);const u=this._nodes.require("emissive")>0&&this._plugins.hasEmissions,p=u?y.ShaderOutput.ColorEmission:y.ShaderOutput.Color,c=s.initialize(a.fullWidth,a.fullHeight,this._backgroundColor,u);this.hasReflections?(c?.setName("last frame color"),this._bindParameters.ssr.lastFrameColor=c):c?.release(),this._ensureBindParametersCamera(a,n),this._plugins.prepareRender(),this._bindParameters.shadowHighlightsVisible=this._needsShadowHighlight&&!i;const m=this._highQualityTransparency&&this._needsTransparentTerrain,g=this._plugins.produces(y.ShaderOutput.Color,...de);this._precompilePrepasses(),this.performanceInfo.advance(te.PerformanceCategory.PREPARE);const f=this._computeDepthRange(a);this._renderShadowMap(a,this._bindParameters.lighting.mainLight.direction,f),this._ensureBindParametersCamera(a,n),this._pluginInput.set("normals",this._renderNormals()),this._renderRemainingGeometryDepth(),this._renderShadowAccumulation(f,a,n),this._ensureBindParametersSSR(t),this._precompileShaders(m,g,p),this._renderContext.output=p,s.bind(),this._bindParameters.mainDepth=s.depth.attachment;const b=this.plugins.produces(y.ShaderOutput.Color,...oe);b&&this._renderOpaqueGeometry(),s.update((e=>this._renderNodes(S.RenderCategory.OPAQUE,e,b))),this.fboCache.debugCallback?.("opaque-color",s.color.fbo),s.update((e=>this._renderNodes(S.InternalRenderCategory.OPAQUE_ENVIRONMENT,e))),this.fboCache.debugCallback?.(S.InternalRenderCategory.OPAQUE_ENVIRONMENT,s.color.fbo),this._renderTerrainDepth(m),this._setMultipassTerrain(m),this._renderEdges(K.Transparency.OPAQUE),s.bind(),this._renderPlugins(X.RenderSlot.VOXEL,te.PerformanceCategory.VOXEL),this._renderHiddenTransparentEdges(),g&&(this._oitEnabled?this._renderOIT(ae.Geometry,p):this._renderTransparentGeometry()),s.update((e=>this._renderNodes(S.RenderCategory.TRANSPARENT,e,g))),this.fboCache.debugCallback?.("transparent-color",s.color.fbo),this._renderGeometryDepth(m),this._renderHUDVisibility(),m||this._plugins.render(this._pluginInput,X.RenderSlot.LINE_CALLOUTS);const R=r===k.RendererTarget.ObjectAndLayerID?this._renderObjectAndLayerIdColor():null;this._renderEdges(K.Transparency.TRANSPARENT);const T=this._needsTransparentTerrain?this._renderTransparentTerrain():null;T&&(this.performanceInfo.advance(te.PerformanceCategory.TRANSPARENT_TERRAIN),this._bindParameters.hudVisibility&&(m?this._renderLineCallouts(I.HUDRenderStyle.Occluded):(this._rctx.bindFramebuffer(this._bindParameters.hudVisibility?.fbo),this._compositingHelper.compositeHUD(this._bindParameters,T.getTexture())),this._renderHUD(I.HUDRenderStyle.Occluded,s.color,p))),this._cullAboveTerrain(!1),T&&(s.bind(),this._compositingHelper.compositePreMultipliedAlpha(this._bindParameters,T.getTexture()),T.release(),m&&(this._renderEdges(K.Transparency.OPAQUE),g&&(this._oitEnabled?this._renderOIT(ae.Geometry,p):this._renderTransparentGeometry(),this.performanceInfo.advance(te.PerformanceCategory.TRANSPARENT)),this._renderEdges(K.Transparency.TRANSPARENT))),this._bindParameters.ssao=h.releaseMaybe(this._bindParameters.ssao),m&&this._renderLineCallouts(I.HUDRenderStyle.NotOccluded),this._setTerrainDepthTest(!1),this._renderTransparentEnvironment(),s.update((e=>this._renderNodes(S.InternalRenderCategory.TRANSPARENT_ENVIRONMENT,e))),s.update((e=>this._renderNodes(S.InternalRenderCategory.VIEWSHED,e))),s.update((e=>this._renderNodes(S.InternalRenderCategory.LASERLINES,e))),s.update((e=>this._renderNodes(S.InternalRenderCategory.OCCLUDED,e))),this._pluginInput.set("highlights",this._renderHighlightPrepass()),s.update((e=>this._renderNodes(S.RenderCategory.COMPOSITE,e)));const E=!(r!==k.RendererTarget.Default||_||l&&!i&&r===k.RendererTarget.Default),A=this._pluginInput.get(S.RenderCategory.COMPOSITE),C=E?P.defaultWebGLFBO:this.fboCache.acquire(A.fbo.width,A.fbo.height,S.InternalRenderCategory.ANTIALIASING),D=this._nodes.produces(S.InternalRenderCategory.ANTIALIASING)?this._renderNodes(S.InternalRenderCategory.ANTIALIASING,C):this._blitFBO(A,C,!1);let w;this._pluginInput.set(S.InternalRenderCategory.ANTIALIASING,D),this.hasHighlightsOnHUD?(this._renderHUD(I.HUDRenderStyle.NotOccluded,D,p),w=this._renderNodes(S.InternalRenderCategory.HIGHLIGHTS,D)):(w=this._renderNodes(S.InternalRenderCategory.HIGHLIGHTS,D),this._renderHUD(I.HUDRenderStyle.NotOccluded,w,p));const O=this._renderNodes(S.InternalRenderCategory.MAGNIFIER,w);return l&&!i&&r===k.RendererTarget.Default&&!_&&this._blitFBO(O),_?(O.attachDepth(s.depth),this._blitFBO(this._renderNodes(S.RenderCategory.FINAL,O)),O.detachDepth()):this._pluginInput.set(S.RenderCategory.FINAL,O),this._pluginInput.release("highlights"),this.onPostRender&&this.onPostRender(),this._releaseFBOs(),s.releaseDepth(),this._renderContext.lastFrameCamera.copyFrom(this._bindParameters.camera),this.fboCache.frameEnd(),this.performanceInfo.finishFrame(),r!==k.RendererTarget.Default&&(this._releaseFBOs(),this._disposeOffscreenBuffers()),new ee.RenderSceneResult(this._pluginInput.get("final-color"),R)}_precompileShaders(e,t,r){++this._plugins.context.techniques.precompiling,this._renderContext.output=r,this._precompileOpaqueGeometry(),this._setMultipassTerrain(e),this._renderContext.output=y.ShaderOutput.Depth,this._plugins.precompile(X.RenderSlot.TRANSPARENT_TERRAIN),e&&(this._precompileOpaqueGeometry(),this._precompileTransparentGeometry()),this._renderContext.output=r,this._plugins.precompile(X.RenderSlot.TRANSPARENT_TERRAIN),t&&(this._precompileTransparentGeometry(),this._needsTransparentTerrain&&(this._cullAboveTerrain(!1),this._precompileTransparentGeometry(),this._cullAboveTerrain(e))),this._needsHUDVisibility&&this._plugins.precompile(X.RenderSlot.OCCLUSION_PIXELS),e&&!this._needsHUDVisibility||this._plugins.precompile(X.RenderSlot.LINE_CALLOUTS),this._setMultipassTerrain(!1),this._nodes.precompile(S.InternalRenderCategory.VIEWSHED,S.InternalRenderCategory.LASERLINES,S.InternalRenderCategory.OCCLUDED,S.RenderCategory.COMPOSITE,S.InternalRenderCategory.MAGNIFIER),this._shadowAccumulator.precompile(),this._plugins.precompile(X.RenderSlot.TRANSPARENT_MATERIAL_WITHOUT_DEPTH),--this._plugins.context.techniques.precompiling}_renderObjectAndLayerIdColor(){if(!this._nodes.produces("olid"))return null;++this._techniques.precompiling;const e=this._framebufferSize;let t=this.fboCache.acquire(e.width,e.height,"olid");return t.acquireDepth(A.DepthFormat.DEPTH_STENCIL_TEXTURE),t=this._nodes.render(t,this._pluginInput),--this._techniques.precompiling,this.performanceInfo.advance(te.PerformanceCategory.OBJECT_AND_LAYER_ID_COLOR),t}finish(e){this._hasAnimations||this._animationTimestep.clear();const t=this.performanceInfo.gpuSamplingEnabled,r=e===U.RenderRequestType.BACKGROUND;if(r||t){const e=r?this.performanceInfo.elapsedTime:0;let i=0;t?i=this.performanceInfo.totalGPUTimeSampler.last:this._rctx.gl.finish();const s=Math.max(e,i);this._animationTimestep.frame(s,r)}}readMainDepth(e,t){const{mainDepth:r,camera:i}=this._bindParameters;if(!r)return;const s=this.fboCache.acquire(this._framebufferSize.width,this._framebufferSize.height,"linear-depth");this._rctx.bindFramebuffer(s.fbo),i.setGLViewport(this._rctx),this._rctx.setScissorRect(e[0],e[1],e[2],e[3]),this._rctx.setScissorTestEnabled(!0),this._rctx.clearFramebuffer(T.ZEROS),this._compositingHelper.blitDepthToLinearDepth(this._bindParameters,r),this._rctx.setScissorTestEnabled(!1),this._rctx.setScissorRect(0,0,this._rctx.gl.canvas.width,this._rctx.gl.canvas.width),s.fbo?.readPixels(e[0],e[1],e[2],e[3],ie.PixelFormat.RGBA,ie.PixelType.UNSIGNED_BYTE,t),s.release()}readHUDVisibility(e,t,r,i,s){this._bindParameters.hudVisibility?.fbo?.readPixels(e,t,r,i,ie.PixelFormat.RGBA,ie.PixelType.UNSIGNED_BYTE,s)}readAccumulatedShadow(e){return this._shadowAccumulator.readAccumulatedShadow(e[0],e[1])}_setMultipassTerrain(e){this._setTerrainDepthTest(e),this._cullAboveTerrain(e)}_setTerrainDepthTest(e){this._bindParameters.terrainDepthTest=e}_cullAboveTerrain(e){this._bindParameters.cullAboveTerrain=e}_renderEdges(e){const t=this._edgeView;if(!t?.shouldRender())return;const r=this._framebufferSize,i=this.fboCache.acquire(r.width,r.height,"edges"),s=()=>t.render(this._bindParameters,e),a=this._bindParameters.geometryDepth;this.renderToTargets(s,i,a??this._framebuffer.depth,T.ZEROS),this._framebuffer.bind(),this._compositingHelper.composite(this._bindParameters,i.getTexture()),i.release(),this.performanceInfo.advance(e===K.Transparency.OPAQUE?te.PerformanceCategory.OPAQUE_EDGES:te.PerformanceCategory.TRANSPARENT_EDGES)}_renderShadowMap(e,t,r){if(!this.shadowsEnabled)return;const i=this._shadowMap;i.start(e,t,r,this.isFeatureEnabled(z.RenderFeature.HighResolutionShadows),this._stage.view.qualitySettings.maximumPixelRatio),this._needsShadowHighlight?(this._renderShadowCascades(y.ShaderOutput.ShadowHighlight,this._shadowMap),i.moveSnapshot(Z.SnapshotSlot.Highlight),this._renderShadowCascades(y.ShaderOutput.ShadowExcludeHighlight,this._shadowMap),i.copySnapshot(Z.SnapshotSlot.ExcludeHighlight),this._renderShadowCascades(y.ShaderOutput.ShadowHighlight,this._shadowMap)):this._renderShadowCascades(y.ShaderOutput.Shadow),i.finish(),e.setGLViewport(this._rctx),this.performanceInfo.advance(te.PerformanceCategory.SHADOW_MAP)}_precompileShadowCascades(e){for(const t of this._shadowMap.cascades)t.camera.setGLViewport(this._rctx),this._ensureBindParametersCamera(t.camera,t.camera),this._precompileAllGeometry(e)}_renderShadowCascades(e,t=this._shadowMap){for(const r of t.cascades)r.camera.setGLViewport(this._rctx),this._ensureBindParametersCamera(r.camera,r.camera),this.renderAllGeometry(e)}get _needsDepth(){return this._plugins.consumes(y.ShaderOutput.Depth)||this._nodes.requireGeometryDepth()||this.hasReflections||this._needsShadowHighlight||this._needsShadowAccumulation||this._debugNeedsDepth}_renderRemainingGeometryDepth(){const e=this._pluginInput.get("normals"),t=this._needsDepth;if(e){const r=t?e.getAttachment(ie.DepthStencilAttachment):null;r?.retain(),this._pluginInput.set(S.InternalRenderCategory.SSAO,this._renderSSAO()),this._renderGeometryWithoutNormalsDepth(t,r)}else this._renderAllGeometryDepth(t)}_renderGeometryWithoutNormalsDepth(e,t){if(!e||!t)return void(this._bindParameters.depth=h.releaseMaybe(this._bindParameters.depth));const r=this._framebufferSize,i=this.fboCache.acquire(r.width,r.height,"depth");i.attachDepth(t),t.release(),this._rctx.bindFramebuffer(i.fbo),this._rctx.clear(ie.FramebufferBit.STENCIL),this._renderGeometryWithoutNormals(y.ShaderOutput.Depth),h.releaseMaybe(this._bindParameters.depth),this._bindParameters.depth=i.obtainDepthTexture(),i.release(),this.performanceInfo.advance(te.PerformanceCategory.DEPTH)}_renderAllGeometryDepth(e){if(!e)return void(this._bindParameters.depth=h.releaseMaybe(this._bindParameters.depth));const t=this._framebufferSize,r=this.fboCache.acquire(t.width,t.height,"depth").acquireDepth(A.DepthFormat.DEPTH_STENCIL_TEXTURE);this._rctx.bindFramebuffer(r.fbo),this._rctx.clear(ie.FramebufferBit.DEPTH|ie.FramebufferBit.STENCIL),this.renderAllGeometry(y.ShaderOutput.Depth),h.releaseMaybe(this._bindParameters.depth),this._bindParameters.depth=r.obtainDepthTexture(),r.release(),this.performanceInfo.advance(te.PerformanceCategory.DEPTH)}_renderTerrainDepth(e){if(!e)return void(this._bindParameters.terrainDepth=h.releaseMaybe(this._bindParameters.terrainDepth));const t=this._renderContext.output;this._renderContext.output=y.ShaderOutput.Depth;const r=this._framebufferSize,i=this.fboCache.acquire(r.width,r.height,"terrain depth").acquireDepth(A.DepthFormat.DEPTH_STENCIL_TEXTURE);this._rctx.bindFramebuffer(i.fbo),this._rctx.clear(ie.FramebufferBit.DEPTH|ie.FramebufferBit.STENCIL),this._renderTransparentTerrain(),h.releaseMaybe(this._bindParameters.terrainDepth),this._bindParameters.terrainDepth=i.obtainDepthTexture(),this._renderContext.output=t,i.release()}_renderGeometryDepth(e){if(!e)return void(this._bindParameters.geometryDepth=h.releaseMaybe(this._bindParameters.geometryDepth));const t=this._renderContext.output,{width:r,height:i}=this._framebufferSize,s=this.fboCache.acquire(r,i,"geometry depth").acquireDepth(A.DepthFormat.DEPTH_STENCIL_TEXTURE);this._rctx.bindFramebuffer(s.fbo),this._rctx.clear(ie.FramebufferBit.DEPTH|ie.FramebufferBit.STENCIL),this._renderOpaqueAndTransparentGeometry(y.ShaderOutput.Depth),this._renderContext.output=t,h.releaseMaybe(this._bindParameters.geometryDepth),this._bindParameters.geometryDepth=s.obtainDepthTexture(),s.release()}get _needsDepthRange(){return this._shadowMap.enabled||this._needsShadowAccumulation}_computeDepthRange(e){if(!this._needsDepthRange)return q.zero;const t=G.depthRangeFromScene(e,this._plugins.plugins,this._stage.layers);return q.union(t,this._plugins.queryDepthRange(e)),t.near=Math.max(e.near,t.near),t.far=Math.min(e.far,t.far),t}get _normalsRequired(){const e=this._nodes.require("normals","final-color",S.RenderCategory.COMPOSITE,"opaque-color","transparent-color","laserline-color");return(this.hasSSAO?1:0)+e}_precompilePrepasses(){this._normalsRequired&&this._precompileAllGeometry(y.ShaderOutput.Normal),this._needsDepth&&this._precompileAllGeometry(y.ShaderOutput.Depth),this.shadowsEnabled&&(this._needsShadowHighlight?(this._precompileShadowCascades(y.ShaderOutput.ShadowHighlight),this._precompileShadowCascades(y.ShaderOutput.ShadowExcludeHighlight),this._precompileShadowCascades(y.ShaderOutput.ShadowHighlight)):this._precompileShadowCascades(y.ShaderOutput.Shadow)),this._needsShadowAccumulation&&this._precompileAllGeometry(y.ShaderOutput.Shadow)}_renderNormals(){const e=this._normalsRequired;if(0===e)return;const t=this._framebufferSize,r=this.fboCache.acquire(t.width,t.height,"normals",A.ColorFormat.RGBA);r.acquireDepth(A.DepthFormat.DEPTH_STENCIL_TEXTURE),this._rctx.bindFramebuffer(r.fbo),this._rctx.clearFramebuffer(T.ZEROS,!0,!0),this._renderGeometryWithNormals(y.ShaderOutput.Normal);const i=this._nodes.optional("normals","final-color",S.RenderCategory.COMPOSITE,"opaque-color","transparent-color","viewshed-color");return r.retain(e+i-1),this.performanceInfo.advance(te.PerformanceCategory.NORMALS),r}_renderSSAO(){const e=this._pluginInput.get("normals");if(!this.hasSSAO||!e)return void e?.detachDepth();P.defaultWebGLFBO.setName(S.InternalRenderCategory.SSAO);const t=this._nodes.render(P.defaultWebGLFBO,this._pluginInput);return this._bindParameters.ssao=t,e.detachDepth(),this._pluginInput.release("normals"),this.performanceInfo.advance(te.PerformanceCategory.SSAO),t}_precompileAllGeometry(e){const t=this._renderContext.output;this._renderContext.output=e,this._precompileOpaqueGeometry(),this._precompileTransparentGeometry(),this._plugins.precompile(X.RenderSlot.TRANSPARENT_TERRAIN),this._renderContext.output=t}renderAllGeometry(e){this._renderContext.output=e,this._renderOpaqueAndTransparentGeometry(e),this._renderTransparentTerrain()}precompileSlots(e,...t){for(const r of t)this._bindParameters.slot=r,e.precompile(this._renderContext)}precompileOccludedSlots(e,t){for(const r of t)this._renderContext.renderOccludedMask=r,this.precompileSlots(e,...le);this._renderContext.renderOccludedMask=Q.defaultRenderOccludedMask}renderSlots(e,...t){for(const r of t)this._bindParameters.slot=r,e.forAll((e=>{const t=e.acquireTechniques(this._renderContext);t&&(e.render(this._renderContext,t,this._pluginInput),O.releaseTechniques(t))}))}renderOccludedSlots(e,t){this._renderContext.renderOccludedMask=t,this.plugins.renderOccludedFlags>V.RenderOccludedFlag.Occlude&&this._plugins.render(this._pluginInput,X.RenderSlot.OCCLUDED_TERRAIN),this.renderSlots(e,...le),this._renderContext.renderOccludedMask=Q.defaultRenderOccludedMask}renderHUD(e){this._bindParameters.hudRenderStyle=e,this._plugins.render(this._pluginInput,X.RenderSlot.HUD_MATERIAL)}precompileViewshedShadowMap(){this._precompileAllGeometry(y.ShaderOutput.ViewshedShadow)}renderViewshedShadowMap(e){const{camera:t,contentCamera:r}=this._bindParameters,i=this._renderContext.output;e.setGLViewport(this._rctx),this._ensureBindParametersCamera(e,e),this.renderAllGeometry(y.ShaderOutput.ViewshedShadow),this._ensureBindParametersCamera(t,r),this._bindParameters.camera.setGLViewport(this._rctx),this._renderContext.output=i}_renderOpaqueAndTransparentGeometry(e){this._renderContext.output=e,this._renderOpaqueGeometry(),this._renderTransparentGeometry()}_renderGeometryWithNormals(e){this._renderContext.output=e,this._plugins.render(this._pluginInput,...ne),this._renderTransparentTerrain()}_renderGeometryWithoutNormals(e){this._renderContext.output=e,this._plugins.render(this._pluginInput,...he)}_precompileOpaqueGeometry(){this._plugins.precompile(...oe)}_renderOpaqueGeometry(){this._plugins.render(this._pluginInput,...oe)}_renderTransparentGeometry(){this._plugins.render(this._pluginInput,...de)}get _needsTransparentTerrain(){return this._plugins.produces(y.ShaderOutput.Color,X.RenderSlot.TRANSPARENT_TERRAIN)}_renderTransparentTerrain(){const e=()=>this._plugins.render(this._pluginInput,X.RenderSlot.TRANSPARENT_TERRAIN);if(!y.isColorOrColorEmission(this._renderContext.output))return void e();const t=this._framebufferSize,r=this.fboCache.acquire(t.width,t.height,"transparent terrain");return this.renderToTargets(e,r,this._framebuffer.depth,T.ZEROS),r}get _needsHUDVisibility(){return this._plugins.produces(this._renderContext.output,X.RenderSlot.OCCLUSION_PIXELS)}_renderHUDVisibility(){if(!this._needsHUDVisibility)return void(this._bindParameters.hudVisibility=h.releaseMaybe(this._bindParameters.hudVisibility));const{width:e,height:t}=this._framebufferSize;let r=this._bindParameters.hudVisibility;r?.fbo?.width===e&&r?.fbo?.height===t||(r?.release(),r=this.fboCache.acquire(e,t,"hud visibility",A.ColorFormat.RGBA4),this._bindParameters.hudVisibility=r);const i=this._bindParameters.geometryDepth;r.attachDepth(i||this._framebuffer.depth),this._rctx.bindFramebuffer(r.fbo),this._rctx.clearFramebuffer([0,1,0,1]),this._plugins.render(this._pluginInput,X.RenderSlot.OCCLUSION_PIXELS),r.detachDepth(),this._framebuffer.bind(),this.performanceInfo.advance(te.PerformanceCategory.HUD_VISIBILITY)}_renderLineCallouts(e){if(this._bindParameters.hudRenderStyle=e,e===I.HUDRenderStyle.Occluded){const e=()=>this._plugins.render(this._pluginInput,X.RenderSlot.LINE_CALLOUTS),t=this._framebufferSize,r=this.fboCache.acquireDepth(A.DepthFormat.DEPTH16_BUFFER,t.width,t.height,"line callouts");this.renderToTargets(e,this._framebuffer.color,r,void 0,!0,!0),r.release()}else this._plugins.render(this._pluginInput,X.RenderSlot.LINE_CALLOUTS)}_renderHUD(e,t,r){if(this._pluginsHas.hudElements){if(this._oitEnabled){const i=this._renderOIT(ae.HUD,r,e);this._rctx.bindFramebuffer(t.fbo),this._compositingHelper.compositePreMultipliedAlpha(this._bindParameters,i.getTexture()),i.release()}else if(e===I.HUDRenderStyle.Occluded){this._renderContext.output=y.ShaderOutput.Color;const t=()=>this._renderHUDElements(e),r=this._framebufferSize,i=this.fboCache.acquireDepth(A.DepthFormat.DEPTH16_BUFFER,r.width,r.height,"hud");this.renderToTargets(t,this._framebuffer.color,i,void 0,!0,!0),i.release()}else this._renderContext.output=y.ShaderOutput.Color,t.acquireDepth(A.DepthFormat.DEPTH16_BUFFER),this._rctx.bindFramebuffer(t.fbo),this._renderHUDElements(e),t.detachDepth();this.performanceInfo.advance(e===I.HUDRenderStyle.Occluded?te.PerformanceCategory.HUD_OCCLUDED:te.PerformanceCategory.HUD)}}_renderHUDElements(e){this._bindParameters.hudRenderStyle=e,this._plugins.precompile(X.RenderSlot.LINE_CALLOUTS_HUD_DEPTH,X.RenderSlot.HUD_MATERIAL,X.RenderSlot.LABEL_MATERIAL),this._plugins.render(this._pluginInput,X.RenderSlot.LINE_CALLOUTS_HUD_DEPTH,X.RenderSlot.HUD_MATERIAL,X.RenderSlot.LABEL_MATERIAL)}get _needsShadowHighlight(){return this.shadowsEnabled&&this._plugins.produces(y.ShaderOutput.ShadowHighlight,X.RenderSlot.OPAQUE_MATERIAL)}_renderHighlightPrepass(){if(!this.hasHighlights)return;const{fboCache:e,_rctx:t,_bindParameters:r}=this,i=this._framebufferSize,s=e.acquire(i.width,i.height,"highlights",A.ColorFormat.RG);return s.acquireDepth(A.DepthFormat.DEPTH_STENCIL_TEXTURE),t.bindFramebuffer(s.fbo),t.clearFramebuffer(T.ZEROS,!0),this._renderContext.output=y.ShaderOutput.Highlight,H.renderHighlightBuffer(t,e,i,this._stage.view.highlights,r,(()=>this._renderHighlightGeometries()),0,(()=>t.bindFramebuffer(s.fbo))),this.performanceInfo.advance(te.PerformanceCategory.HIGHLIGHTS),s}_renderHighlightGeometries(){const e=[X.RenderSlot.TRANSPARENT_MATERIAL,X.RenderSlot.TRANSPARENT_MATERIAL_WITHOUT_NORMALS,X.RenderSlot.OPAQUE_MATERIAL,X.RenderSlot.OPAQUE_MATERIAL_WITHOUT_NORMALS];0===this._bindParameters.highlightLevel&&e.push(X.RenderSlot.TRANSPARENT_TERRAIN,X.RenderSlot.INTEGRATED_MESH,X.RenderSlot.OPAQUE_TERRAIN),this._plugins.precompile(...e),this._plugins.render(this._pluginInput,...e),this._rctx.clear(ie.FramebufferBit.DEPTH),this._renderHUDElements(I.HUDRenderStyle.Both)}get _needsShadowAccumulation(){return this._shadowAccumulator.isAccumulating}_renderShadowAccumulation(e,t,r){this._needsShadowAccumulation&&this._bindParameters.depth&&this._shadowAccumulator.renderAccumulation(this._bindParameters.depth,e,t,r)&&this.performanceInfo.advance(te.PerformanceCategory.ACCUMULATED_SHADOWS)}_precompileTransparentGeometry(){++this._plugins.context.techniques.precompiling,this._oitEnabled&&y.isColorOrColorEmission(this._renderContext.output)?(this._bindParameters.oitPass=W.OITPass.ColorAlpha,this._plugins.precompile(...de),this._bindParameters.oitPass=W.OITPass.FrontFace,this._plugins.precompile(...de),this._bindParameters.oitPass=W.OITPass.NONE):this._plugins.precompile(...de),--this._plugins.context.techniques.precompiling}_renderOIT(e,t,r=I.HUDRenderStyle.Both){const i=e===ae.HUD,s=this._framebufferSize,a=i?this.fboCache.acquire(s.width,s.height,"oit hud composite"):null,n=i?()=>this._renderHUDElements(r):()=>this._renderTransparentGeometry(),h=this._bindParameters,o=this._renderContext.output;this._renderContext.output=t,h.oitPass=W.OITPass.ColorAlpha;const d=a?"oit hud color alpha":"oit color alpha",l=this.fboCache.acquire(s.width,s.height,d,A.ColorFormat.RGBA16F);l.acquireColor(ie.ColorAttachment.COLOR_ATTACHMENT1,A.ColorFormat.R16F),a||l.attachDepth(this._framebuffer.depth),this._rctx.bindFramebuffer(l.fbo),this._rctx.clearFramebuffer([0,0,0,1]),n(),l.detachDepth(),h.oitPass=W.OITPass.FrontFace;const _=this.fboCache.acquire(s.width,s.height,a?"oit hud front":"oit front");return a?_.acquireDepth(A.DepthFormat.DEPTH16_BUFFER):_.attachDepth(this._framebuffer.depth),this._rctx.bindFramebuffer(_.fbo),this._rctx.clearFramebuffer(T.ZEROS,!!a),n(),_.detachDepth(),h.oitPass=W.OITPass.NONE,a?(this._rctx.bindFramebuffer(a.fbo),this._rctx.setClearColor(0,0,0,1e-13),this._rctx.clear(ie.FramebufferBit.COLOR)):this._framebuffer.bind(),this._oitblend??=new x.OITBlend(this._techniques),this._oitblend.blend(this._rctx,l,_,h),a?.detachDepth(),_.release(),l.release(),this._renderContext.output=o,a}_renderTransparentEnvironment(){this._shadowAccumulator.render(this._bindParameters),this.performanceInfo.advance(te.PerformanceCategory.APPLY_ACCUMULATED_SHADOWS),this._framebuffer.bind(),this._plugins.render(this._pluginInput,X.RenderSlot.TRANSPARENT_MATERIAL_WITHOUT_DEPTH),this.performanceInfo.advance(te.PerformanceCategory.TRANSPARENT_MATERIAL_WITHOUT_DEPTH)}_renderPlugins(e,t){this._plugins.produces(this._renderContext.output,e)&&(this._plugins.render(this._pluginInput,e),this.performanceInfo.advance(t))}_renderNodes(e,t,r=!1){if(t.setName(e),this._pluginInput.set(e,t),!this._nodes.produces(e))return r&&this.performanceInfo.advance(e),t;const i=this._nodes.render(t,this._pluginInput,this._releaseNormals);return this.performanceInfo.advance(e),i}_blitFBO(e,t=P.defaultWebGLFBO,r=!0){return this._blit??=new M.Blit(this._techniques),this._blit.blit(this._rctx,e,t,this._bindParameters),this._pluginInput.set(e.name,t),r&&e.release(),t}_ensureBindParametersCamera(e,t){this._bindParameters.camera=e,this._bindParameters.contentCamera=t}_ensureBindParametersSSR(e){if(this._bindParameters.ssr.lastFrameColor){null==this._ssrEnableTime&&(this._ssrEnableTime=e),this._renderContext.lastFrameCamera.equals(this._bindParameters.camera)?this._reprojectionMatrix=b.IDENTITY:(f.invert(ue,this._bindParameters.camera.viewMatrix),f.invert(_e,this._bindParameters.camera.projectionMatrix),f.multiply(pe,ue,_e),f.multiply(pe,this._renderContext.lastFrameCamera.viewMatrix,pe),f.multiply(pe,this._renderContext.lastFrameCamera.projectionMatrix,pe),this._reprojectionMatrix=pe);const t=this._stage.view.qualitySettings.fadeDuration;this._bindParameters.ssr.fadeFactor=t>0?Math.min(t,e-this._ssrEnableTime)/t:1,this._bindParameters.ssr.fadeFactor<1&&this._requestRender()}else this._reprojectionMatrix=b.IDENTITY,this._ssrEnableTime=null}addRenderNode(e){this._nodes.add(e),this._requestRender()}removeRenderNode(e){this._nodes.remove(e),this._requestRender()}updateLighting(e,t,r,i){this._bindParameters.updateLighting(e,t,r,i),this._requestRender(U.RenderRequestType.UPDATE)}get usedMemory(){return{fbos:this.fboCache.usedMemory,plugins:this._plugins.usedMemory,edges:this.edgeView?.usedMemory??0}}renderToTargets(e,t,r,i,s=!1,a=!1){t.attachDepth(r),this._rctx.bindFramebuffer(t.fbo),this._rctx.clearFramebuffer(i,s,a),e(),t.detachDepth()}get test(){}}var ae;r.__decorate([_.property({readOnly:!0})],se.prototype,"fullResolutionAtmosphere",null),r.__decorate([_.property()],se.prototype,"_edgeView",void 0),r.__decorate([_.property()],se.prototype,"updating",null),function(e){e[e.Geometry=0]="Geometry",e[e.HUD=1]="HUD"}(ae||(ae={}));const ne=[X.RenderSlot.INTEGRATED_MESH,X.RenderSlot.OPAQUE_TERRAIN,X.RenderSlot.OPAQUE_MATERIAL,X.RenderSlot.TRANSPARENT_MATERIAL],he=[X.RenderSlot.OPAQUE_MATERIAL_WITHOUT_NORMALS,X.RenderSlot.TRANSPARENT_MATERIAL_WITHOUT_NORMALS],oe=[X.RenderSlot.INTEGRATED_MESH,X.RenderSlot.OPAQUE_TERRAIN,X.RenderSlot.OPAQUE_MATERIAL,X.RenderSlot.OPAQUE_MATERIAL_WITHOUT_NORMALS],de=[X.RenderSlot.TRANSPARENT_MATERIAL,X.RenderSlot.TRANSPARENT_MATERIAL_WITHOUT_NORMALS],le=[X.RenderSlot.OPAQUE_MATERIAL,X.RenderSlot.TRANSPARENT_MATERIAL,X.RenderSlot.TRANSPARENT_MATERIAL_WITHOUT_DEPTH],_e=b.create(),ue=b.create(),pe=b.create();function ce(e){return t=>e.immediate.schedule(t)}t.Renderer=se,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
