/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../chunks/tslib.es6","../../../../core/Accessor","../../../../core/arrayUtils","../../../../core/has","../../../../core/mathUtils","../../../../core/maybe","../../../../core/reactiveUtils","../../../../core/accessorSupport/decorators/property","../../../../core/Logger","../../../../core/accessorSupport/decorators/subclass","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../core/shaderLibrary/shading/ReadShadowMap.glsl","./BindParameters","./depthRange","./glUtil3D","./ShadowCastRenderer","./ShadowMap","../../../../chunks/ShadowCastAccumulate.glsl","../shaders/ShadowCastAccumulateTechnique","../../../support/Scheduler","../../../webgl/enums","../../../webgl/FramebufferObject","../../../webgl/TextureDescriptor","../../../webgl/Util"],(function(e,t,r,s,i,a,o,c,h,n,u,d,_,l,p,m,g,w,b,v,y,A,f,S,R,C){"use strict";e.ShadowAccumulator=class extends r{constructor(e,t,r,s,i,a){super({}),this.fbos=e,this._techniques=t,this._stage=r,this._prepareForShadowMapPass=s,this._renderToShadowMap=i,this._requestRender=a,this._progress=0,this._sampleCount=0,this._passParameters=new l.ReadShadowMapPassParameters,this._cachedLightDirections=[],this._depthRange=m.zero,this._previewing=!1,this._cameraForcedForScreenshot=!1,this._shadowAccumulatorKey="shadowAccumulator",this._rctx=e.rctx,this._bindParameters=new p.BindParameters(new b.ShadowMap(e,r.viewingMode)),this._bindParameters.shadowMap.enabled=!0,this._vao=g.createQuadVAO(this._rctx),this._accumulationRenderer=new w.ShadowCastRenderer(t,this._rctx,this,a);const o=this._stage.view.resourceController.scheduler;this.addHandles([o.registerTask(A.TaskPriority.SHADOW_ACCUMULATOR,this),c.watch((()=>r.renderView),(e=>{this.removeHandles(F),null!=e&&this.addHandles(e.events.on("force-camera-for-screenshot",(()=>this._cameraForcedForScreenshot=!0)),F)}),c.syncAndInitial),c.watch((()=>this._previewing),(()=>this._requestRenderIfEnabled()),c.sync)],this._shadowAccumulatorKey),t.precompile(y.ShadowCastAccumulateTechnique)}normalizeCtorArgs(){return{}}dispose(){this._disable(),this.removeHandles(this._shadowAccumulatorKey),this._accumulationRenderer=o.disposeMaybe(this._accumulationRenderer),this._bindParameters.shadowMap.dispose(),this._fbo=o.disposeMaybe(this._fbo),this._vao=o.disposeMaybe(this._vao),this._cachedLightDirections.length=0,this._sampleCount=0}get computedSamples(){return this._progress}get shadowCastTexture(){return this._fbo?.colorTexture}get isAccumulating(){return this._isPreviewing||this._isRefining}get _isRefining(){return this._isActive&&!this._isDoneAccumulating&&!this._previewing}get _isPreviewing(){return this._isActive&&this._previewing}get _isActive(){return null!=this._fbo&&this._sampleCount>0}get canAccumulate(){return null!=this._bindParameters.depth&&this._depthRange!==m.zero&&this._opacityFromElevation>w.shadowCastDisabledElevationThreshold}get _isDoneAccumulating(){return this._progress>=this._sampleCount}get _lightDirections(){return this._cachedLightDirections}set _lightDirections(e){const t=this._cachedLightDirections;if(s.equals(t,e,d.equals))return;const r=Math.min(v.ShadowCastMaxSamples,e.length);t.length=r,this._sampleCount=r;for(let s=0;s<r;++s)t[s]=d.copy(t[s]??_.create(),e[s]);this._invalidate()}get _opacityFromElevation(){return this._accumulationRenderer.opacityFromElevation}set _opacityFromElevation(e){this._accumulationRenderer.opacityFromElevation=e}get running(){return this._isRefining&&this.canAccumulate&&this._progress>0}runTask(e){for(this._prepareForShadowMapPass(this._bindParameters);!e.done&&!this._isDoneAccumulating;)this._accumulateShadow(),e.madeProgress();this._requestRender()}renderAccumulation(e,t,r,s){if(this._depthRange=t,this._updateCamera(r),this._bindParameters.contentCamera=s,this._bindParameters.depth=e,this._passParameters.origin=this._bindParameters.camera.center,this.notifyChange("canAccumulate"),!this.isAccumulating||!this.canAccumulate)return!1;(this._previewing||0===this._progress||this._cameraForcedForScreenshot)&&this._clear();const i=this._cameraForcedForScreenshot?this._sampleCount:Math.min(P,this._sampleCount-this._progress);for(let a=0;a<i;++a)this._accumulateShadow();return this._cameraForcedForScreenshot=!1,this._requestRender(),i>0}precompile(){this._accumulationRenderer.precompile()}render(e){this._accumulationRenderer.render(e)}setOptions(e){if(void 0!==e.enabled){const t=null!=this._fbo;e.enabled!==t&&(e.enabled?this._enable():this._disable())}void 0!==e.previewing&&(this._previewing=e.previewing),void 0!==e.lightDirections&&(this._lightDirections=e.lightDirections),this._accumulationRenderer.setOptions(e)}readAccumulatedShadow(e,t){return!this._isActive||!this._fbo||this._progress<1||e<0||e>=this._fbo.width||t<0||t>=this._fbo.height?0:(this._fbo.readPixels(e,t,1,1,f.PixelFormat.RGBA,f.PixelType.UNSIGNED_BYTE,x),x[0]/this._progress)}_enable(){this._progress=0;const e=new R.TextureDescriptor;e.pixelFormat=f.PixelFormat.RED,e.internalFormat=f.SizedPixelFormat.R8,e.wrapMode=f.TextureWrapMode.CLAMP_TO_EDGE,this._fbo=new S.FramebufferObject(this._rctx,e),this._requestRender()}_disable(){this._fbo=o.disposeMaybe(this._fbo),this._requestRender()}_invalidate(){this._progress=0,this._requestRenderIfEnabled()}_clear(){this._rctx.bindFramebuffer(this._fbo),this._rctx.setClearColor(0,0,0,0),this._rctx.clear(f.FramebufferBit.COLOR),this._progress=0}_accumulateShadow(){this._renderToShadowMap(this._bindParameters,this._lightDirections[this._progress++],this._depthRange);const e=this._techniques.acquire(y.ShadowCastAccumulateTechnique);this._rctx.bindFramebuffer(this._fbo),this._rctx.bindTechnique(e,this._bindParameters,this._passParameters),this._rctx.bindVAO(this._vao),this._rctx.drawArrays(e.primitiveType,0,C.vertexCount(this._vao,"geometry")),e.release()}_updateCamera(e){const t=this._fbo;if(null==t)return;const r=this._bindParameters.camera;e.equals(r)||r.copyFrom(e),t.resize(e.fullWidth,e.fullHeight),this._opacityFromElevation=1-a.smoothstep(w.shadowCastDisableElevationMin,w.shadowCastDisableElevationMax,e.relativeElevation)}_requestRenderIfEnabled(){this._fbo&&this._requestRender()}get test(){}},t.__decorate([h.property()],e.ShadowAccumulator.prototype,"_progress",void 0),t.__decorate([h.property()],e.ShadowAccumulator.prototype,"_sampleCount",void 0),t.__decorate([h.property()],e.ShadowAccumulator.prototype,"_fbo",void 0),t.__decorate([h.property()],e.ShadowAccumulator.prototype,"_depthRange",void 0),t.__decorate([h.property()],e.ShadowAccumulator.prototype,"_previewing",void 0),t.__decorate([h.property()],e.ShadowAccumulator.prototype,"_accumulationRenderer",void 0),t.__decorate([h.property()],e.ShadowAccumulator.prototype,"_isRefining",null),t.__decorate([h.property()],e.ShadowAccumulator.prototype,"_isActive",null),t.__decorate([h.property()],e.ShadowAccumulator.prototype,"canAccumulate",null),t.__decorate([h.property()],e.ShadowAccumulator.prototype,"_isDoneAccumulating",null),t.__decorate([h.property()],e.ShadowAccumulator.prototype,"_opacityFromElevation",null),t.__decorate([h.property()],e.ShadowAccumulator.prototype,"running",null),e.ShadowAccumulator=t.__decorate([u.subclass("esri.views.3d.webgl-engine.lib.ShadowAccumulator")],e.ShadowAccumulator);const P=6,F="renderView",x=new Uint8Array(4);Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
