/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../core/has","../../../../core/mathUtils","../../../../core/maybe","../../../../core/libs/gl-matrix-2/factories/mat3f64","../../../../core/libs/gl-matrix-2/math/mat4","../../../../core/libs/gl-matrix-2/factories/mat4f64","../../../../core/libs/gl-matrix-2/math/vec2","../../../../core/libs/gl-matrix-2/factories/vec2f64","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../chunks/vec42","../../../../core/libs/gl-matrix-2/factories/vec4f64","../../../ViewingMode","../../webgl/formats","./CascadeCamera","./textureUtils","./Util","../../../webgl/enums","../../../webgl/Texture"],(function(t,e,s,a,i,r,h,c,o,n,l,d,u,_,m,g,f,p,x,b){"use strict";var y;t.SnapshotSlot=void 0,(y=t.SnapshotSlot||(t.SnapshotSlot={}))[y.Highlight=0]="Highlight",y[y.ExcludeHighlight=1]="ExcludeHighlight";class M{constructor(){this.camera=new g.CascadeCamera,this.lightMat=h.create()}}class T{constructor(){this.maxNumCascadesHighQuality=4,this.maxNumCascadesLowQuality=4,this.textureSizeModHighQuality=1.3,this.textureSizeModLowQuality=.9,this.splitSchemeLambda=0}}class w{constructor(t,s){this._fbos=t,this._viewingMode=s,this._enabled=!1,this._snapshots=new Array,this._textureHeight=0,this._numCascades=1,this.settings=new T,this._projectionView=h.create(),this._projectionViewInverse=h.create(),this._modelViewLight=h.create(),this._cascadeDistances=[0,0,0,0,0],this._usedCascadeDistances=u.create(),this._cascades=[new M,new M,new M,new M],this._lastOrigin=null,this._maxTextureWidth=Math.min(e("esri-mobile")?4096:16384,t.rctx.parameters.maxTextureSize)}dispose(){this.enabled=!1,this.disposeOffscreenBuffers()}get depthTexture(){return this._handle?.getTexture()}get _textureWidth(){return this._textureHeight*this._numCascades}get numCascades(){return this._numCascades}get cascadeDistances(){return d.set(this._usedCascadeDistances,this._cascadeDistances[0],this._numCascades>1?this._cascadeDistances[1]:1/0,this._numCascades>2?this._cascadeDistances[2]:1/0,this._numCascades>3?this._cascadeDistances[3]:1/0)}disposeOffscreenBuffers(){this._handle=a.releaseMaybe(this._handle),this._discardSnapshots()}set maxCascades(t){this.settings.maxNumCascadesHighQuality=s.clamp(Math.floor(t),1,4)}get maxCascades(){return this.settings.maxNumCascadesHighQuality}set enabled(t){this._enabled=t,t||this.disposeOffscreenBuffers()}get enabled(){return this._enabled}get ready(){return this._enabled&&null!=this.depthTexture}get cascades(){for(let t=0;t<this._numCascades;++t)O[t]=this._cascades[t];return O.length=this._numCascades,O}start(t,e,s,a,i){p.assert(this.enabled);const{near:r,far:h}=tt(s);this._computeCascadeDistances(r,h,a),this._textureHeight=this._computeTextureHeight(t,i,a),this._setupMatrices(t,e);const{viewMatrix:c,projectionMatrix:o}=t;for(let n=0;n<this._numCascades;++n)this._constructCascade(n,o,c,e);this._lastOrigin=null,this.clear()}finish(){p.assert(this.enabled),this._handle?.detachDepth()}getShadowMapMatrices(t){if(!this._lastOrigin||!n.exactEquals(t,this._lastOrigin)){this._lastOrigin=this._lastOrigin||l.create(),n.copy(this._lastOrigin,t);for(let e=0;e<this._numCascades;++e){r.translate(j,this._cascades[e].lightMat,t);for(let t=0;t<16;++t)N[16*e+t]=j[t]}}return N}moveSnapshot(t){p.assert(this.enabled),this._handle?.detachDepth(),this._snapshots[t]?.release(),this._snapshots[t]=this._handle,this._handle=null,this.clear()}copySnapshot(e){const s=this._handle?.getTexture()?.descriptor;if(!this.enabled||!s)return;this._snapshots[e]?.release();const{width:a,height:i}=s,r=e===t.SnapshotSlot.Highlight?"shadow highlight snapshot":"shadow no highlight snapshot";this._snapshots[e]=this._fbos.acquire(a,i,r,m.ColorFormat.RGBA4);const h=this._fbos.rctx;this._bindFbo();const c=h.bindTexture(this._snapshots[e]?.getTexture(),b.Texture.TEXTURE_UNIT_FOR_UPDATES);h.gl.copyTexSubImage2D(x.TextureType.TEXTURE_2D,0,0,0,0,0,a,i),h.bindTexture(c,b.Texture.TEXTURE_UNIT_FOR_UPDATES)}getSnapshot(t){return this.enabled?this._snapshots[t]?.getTexture():null}clear(){const t=this._fbos.rctx;this._ensureFbo(),this._bindFbo(),t.setClearColor(1,1,1,1),t.clear(x.FramebufferBit.COLOR|x.FramebufferBit.DEPTH)}_computeTextureHeight(t,e,s){const a=Math.min(window.devicePixelRatio,e)/t.pixelRatio,i=s?this.settings.textureSizeModHighQuality:this.settings.textureSizeModLowQuality,r=f.applyTextureResizeModulo(Math.floor(Math.max(t.fullWidth,t.fullHeight)*a*i)),h=Math.min(this._maxTextureWidth,this._numCascades*r);return f.applyTextureResizeFloorModulo(h/this._numCascades)}_ensureFbo(){this._handle?.fbo?.width===this._textureWidth&&this._handle?.fbo.height===this._textureHeight||(this._handle?.release(),this._handle=this._fbos.acquire(this._textureWidth,this._textureHeight,"shadow map",m.ColorFormat.RGBA4)),this._handle?.acquireDepth(m.DepthFormat.DEPTH16_BUFFER)}_discardSnapshot(t){this._snapshots[t]=a.releaseMaybe(this._snapshots[t])}_discardSnapshots(){for(let t=0;t<this._snapshots.length;++t)this._discardSnapshot(t);this._snapshots.length=0}_bindFbo(){this._fbos.rctx.bindFramebuffer(this._handle?.fbo)}_constructCascade(t,e,s,a){const i=this._cascades[t],h=-this._cascadeDistances[t],c=-this._cascadeDistances[t+1],o=(e[10]*h+e[14])/Math.abs(e[11]*h+e[15]),l=(e[10]*c+e[14])/Math.abs(e[11]*c+e[15]);p.assert(o<l);for(let r=0;r<8;++r){d.set(D,r%4==0||r%4==3?-1:1,r%4==0||r%4==1?-1:1,r<4?o:l,1);const t=v[r];d.transformMat4(t,D,this._projectionViewInverse),t[0]/=t[3],t[1]/=t[3],t[2]/=t[3]}n.negate(I,v[0]),i.camera.viewMatrix=r.translate(C,this._modelViewLight,I);for(let r=0;r<8;++r)n.transformMat4(v[r],v[r],i.camera.viewMatrix);let u=v[0][2],_=v[0][2];for(let r=1;r<8;++r)u=Math.min(u,v[r][2]),_=Math.max(_,v[r][2]);u-=200,_+=200,i.camera.near=-_,i.camera.far=-u,$(s,a,u,_,i.camera),r.multiply(i.lightMat,i.camera.projectionMatrix,i.camera.viewMatrix);const m=this._textureHeight;i.camera.viewport=[t*m,0,m,m]}_setupMatrices(t,e){r.multiply(this._projectionView,t.projectionMatrix,t.viewMatrix),r.invert(this._projectionViewInverse,this._projectionView);const s=this._viewingMode===_.ViewingMode.Global?t.eye:n.set(I,0,0,1);r.lookAt(this._modelViewLight,[0,0,0],[-e[0],-e[1],-e[2]],s)}_computeCascadeDistances(t,e,a){const i=a?this.settings.maxNumCascadesHighQuality:this.settings.maxNumCascadesLowQuality;this._numCascades=Math.min(1+Math.floor(p.logWithBase(e/t,4)),i);const r=(e-t)/this._numCascades,h=(e/t)**(1/this._numCascades);let c=t,o=t;for(let n=0;n<this._numCascades+1;++n)this._cascadeDistances[n]=s.lerp(c,o,this.settings.splitSchemeLambda),c*=h,o+=r}get test(){}}const C=h.create(),D=u.create(),v=[];for(let et=0;et<8;++et)v.push(u.create());const S=o.create(),H=o.create(),R=o.create(),E=o.create(),F=o.create(),I=l.create(),O=[],j=h.create(),N=h.IDENTITY.concat(h.IDENTITY,h.IDENTITY,h.IDENTITY,h.IDENTITY),U=o.create(),V=o.create(),L=[o.create(),o.create(),o.create(),o.create()],Q=o.create(),z=o.create(),B=o.create(),A=o.create(),q=o.create(),W=o.create(),P=o.create();function Y(t,e,s,a,i,r,h,o){c.set(U,0,0);for(let p=0;p<4;++p)c.add(U,U,t[p]);c.scale(U,U,.25),c.set(V,0,0);for(let p=4;p<8;++p)c.add(V,V,t[p]);c.scale(V,V,.25),c.lerp(L[0],t[4],t[5],.5),c.lerp(L[1],t[5],t[6],.5),c.lerp(L[2],t[6],t[7],.5),c.lerp(L[3],t[7],t[4],.5);let n=0,l=c.squaredDistance(L[0],U);for(let p=1;p<4;++p){const t=c.squaredDistance(L[p],U);t<l&&(l=t,n=p)}c.subtract(Q,L[n],t[n+4]);const d=Q[0];let u,_;Q[0]=-Q[1],Q[1]=d,c.subtract(z,V,U),c.dot(z,Q)<0&&c.negate(Q,Q),c.lerp(Q,Q,z,s),c.normalize(Q,Q),u=_=c.dot(c.subtract(B,t[0],U),Q);for(let p=1;p<8;++p){const e=c.dot(c.subtract(B,t[p],U),Q);e<u?u=e:e>_&&(_=e)}c.copy(a,U),c.scale(B,Q,u-e),c.add(a,a,B);let m=-1,g=1,f=0,x=0;for(let p=0;p<8;++p){c.subtract(A,t[p],a),c.normalize(A,A);const e=Q[0]*A[1]-Q[1]*A[0];e>0?e>m&&(m=e,f=p):e<g&&(g=e,x=p)}p.verify(m>0,"leftArea"),p.verify(g<0,"rightArea"),c.scale(q,Q,u),c.add(q,q,U),c.scale(W,Q,_),c.add(W,W,U),P[0]=-Q[1],P[1]=Q[0];const b=p.rayRay2D(a,t[x],W,c.add(B,W,P),1,i),y=p.rayRay2D(a,t[f],W,B,1,r),M=p.rayRay2D(a,t[f],q,c.add(B,q,P),1,h),T=p.rayRay2D(a,t[x],q,B,1,o);p.verify(b,"rayRay"),p.verify(y,"rayRay"),p.verify(M,"rayRay"),p.verify(T,"rayRay")}function k(t,e){return 3*e+t}const G=o.create();function X(t,e){return c.set(G,t[e],t[e+3]),G}const J=o.create(),K=i.create();function Z(t,e,s,a,i){c.subtract(J,s,a),c.scale(J,J,.5),K[0]=J[0],K[1]=J[1],K[2]=0,K[3]=J[1],K[4]=-J[0],K[5]=0,K[6]=J[0]*J[0]+J[1]*J[1],K[7]=J[0]*J[1]-J[1]*J[0],K[8]=1,K[k(0,2)]=-c.dot(X(K,0),t),K[k(1,2)]=-c.dot(X(K,1),t);let r=c.dot(X(K,0),s)+K[k(0,2)],h=c.dot(X(K,1),s)+K[k(1,2)],o=c.dot(X(K,0),a)+K[k(0,2)],n=c.dot(X(K,1),a)+K[k(1,2)];r=-(r+o)/(h+n),K[k(0,0)]+=K[k(1,0)]*r,K[k(0,1)]+=K[k(1,1)]*r,K[k(0,2)]+=K[k(1,2)]*r,r=1/(c.dot(X(K,0),s)+K[k(0,2)]),h=1/(c.dot(X(K,1),s)+K[k(1,2)]),K[k(0,0)]*=r,K[k(0,1)]*=r,K[k(0,2)]*=r,K[k(1,0)]*=h,K[k(1,1)]*=h,K[k(1,2)]*=h,K[k(2,0)]=K[k(1,0)],K[k(2,1)]=K[k(1,1)],K[k(2,2)]=K[k(1,2)],K[k(1,2)]+=1,r=c.dot(X(K,1),e)+K[k(1,2)],h=c.dot(X(K,2),e)+K[k(2,2)],o=c.dot(X(K,1),s)+K[k(1,2)],n=c.dot(X(K,2),s)+K[k(2,2)],r=-.5*(r/h+o/n),K[k(1,0)]+=K[k(2,0)]*r,K[k(1,1)]+=K[k(2,1)]*r,K[k(1,2)]+=K[k(2,2)]*r,r=c.dot(X(K,1),e)+K[k(1,2)],h=c.dot(X(K,2),e)+K[k(2,2)],o=-h/r,K[k(1,0)]*=o,K[k(1,1)]*=o,K[k(1,2)]*=o,i[0]=K[0],i[1]=K[1],i[2]=0,i[3]=K[2],i[4]=K[3],i[5]=K[4],i[6]=0,i[7]=K[5],i[8]=0,i[9]=0,i[10]=1,i[11]=0,i[12]=K[6],i[13]=K[7],i[14]=0,i[15]=K[8]}function $(t,e,a,i,r){const h=1/v[0][3],c=1/v[4][3];p.assert(h<c);let o=h+Math.sqrt(h*c);const n=Math.sin(s.acosClamped(t[2]*e[0]+t[6]*e[1]+t[10]*e[2]));o/=n,Y(v,o,n,S,H,R,E,F),Z(S,H,E,F,r.projectionMatrix),r.projectionMatrix[10]=2/(a-i),r.projectionMatrix[14]=-(a+i)/(a-i)}function tt(t){let{near:e,far:s}=t;return e<2&&(e=2),s<2&&(s=2),e>=s&&(e=2,s=4),{near:e,far:s}}t.ShadowMap=w,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
