/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../chunks/tslib.es6","../../../../core/Accessor","../../../../core/has","../../../../core/MapUtils","../../../../core/PooledArray","../../../../core/accessorSupport/decorators/property","../../../../core/Logger","../../../../core/RandomLCG","../../../../core/accessorSupport/decorators/subclass","../../../../core/libs/gl-matrix-2/factories/vec2f64","../../../../chunks/sphere","../../terrain/Intersector","../core/shaderLibrary/ShaderOutput","../effects/RenderPlugin","./ChangeSet","./Intersector","./IntersectorInterfaces","./Material","./ModelDirtyTypes","./rendererUtils","./RenderSlot","../materials/renderers/MergedRenderer"],(function(e,r,t,s,i,n,o,d,a,h,l,c,p,u,g,y,m,_,R,f,S,G,v){"use strict";e.SortedRenderGeometryRenderer=class extends t{constructor(e){super(e),this._pending=new C,this._changes=new y.ChangeSet,this._renderers=new Map,this._sortedRenderers=new n,this._geometries=new Map,this._hasHighlights=!1,this._hasWater=!1}destroy(){this._changes.prune(),this._renderers.forEach((e=>e.destroy())),this._renderers.clear(),this._sortedRenderers.clear(),this._geometries.clear(),this._pending.clear()}get updating(){return!this._pending.empty||this._changes.updates.length>0}get rctx(){return this.rendererContext.rctx}get _materials(){return this.rendererContext.materials}get _localOriginFactory(){return this.rendererContext.localOriginFactory}get hasHighlights(){return this._hasHighlights}get hasWater(){return this._hasWater}get rendersOccludedDraped(){for(const e of this._renderers.values())if(0!==e.numGeometries&&!e.queryRenderOccludedState(R.RenderOccludedFlag.Occlude))return!0;return!1}get isEmpty(){return!this.updating&&0===this._renderers.size&&0===this._geometries.size}getMaterialRenderer(e){return this._renderers.get(e)}get sortedRenderers(){return this._sortedRenderers}commitChanges(){if(!this.updating)return!1;this._processAddsRemoves();const e=S.splitRenderGeometryChangeSetByMaterial(this._changes);let r=!1;return e.forEach(((e,t)=>{let s=this._renderers.get(t);!s&&e.adds.length>0&&(s=new v.MergedRenderer({material:t}),s.initializeRenderContext(this.rendererContext.pluginContext,this._materials),this._renderers.set(t,s),r=!0),s&&(s.modify(e),0===s.numGeometries&&(this._renderers.delete(t),s.destroy(),r=!0))})),this._changes.clear(),r&&this._updateSortedMaterialRenderers(),this._hasHighlights=i.someMap(this._renderers,(e=>{const r=e.produces.get(G.RenderSlot.DRAPED_MATERIAL);return!!r&&r(u.ShaderOutput.Highlight)})),this._hasWater=i.someMap(this._renderers,(e=>{const r=e.produces.get(G.RenderSlot.DRAPED_WATER);return!!r&&r(u.ShaderOutput.Normal)})),this.notifyChange("updating"),!0}addGeometries(e,r){if(0===e.length)return;const t=this._validateRenderGeometries(e);for(const i of t)this._geometries.set(i.id,i);const s=this._pending.empty;for(const i of t)this._pending.adds.add(i);s&&this.notifyChange("updating"),r===f.DirtyOperation.UPDATE&&this._notifyGraphicGeometryChanged(e)}removeGeometries(e,r){const t=this._pending.empty,s=this._pending.adds;for(const i of e)s.has(i)?(this._pending.removed.add(i),s.delete(i)):this._pending.removed.has(i)||this._pending.removes.add(i),this._geometries.delete(i.id);t&&!this._pending.empty&&this.notifyChange("updating"),r===f.DirtyOperation.UPDATE&&this._notifyGraphicGeometryChanged(e)}modifyGeometries(e,r){const t=0===this._changes.updates.length;for(const s of e){const e=this._changes.updates.pushNew();e.renderGeometry=this._validateRenderGeometry(s),e.updateType=r}switch(t&&this._changes.updates.length>0&&this.notifyChange("updating"),r){case f.DirtyState.TRANSFORMATION:case f.DirtyState.GEOMETRY:return this._notifyGraphicGeometryChanged(e);case f.DirtyState.VISIBILITY:return this._notifyGraphicVisibilityChanged(e)}}updateAnimation(e){let r=!1;return this._sortedRenderers.forAll((t=>r=!!t.updateAnimation&&t.updateAnimation(e)||r)),r}precompile(e){return this._sortedRenderers.reduce(((r,t)=>t.precompile(e)||r),!1)}render(e){this._sortedRenderers.forAll((r=>{const t=r.acquireTechniques(e);t&&(r.render(e,t),g.releaseTechniques(t))}))}intersect(e,r,t,s,i){for(const n of this._geometries.values()){if(!s(n))continue;this._intersectRenderGeometry(n,t,r,0,e,i);const o=this.rendererContext.longitudeCyclical;o&&(n.boundingSphere[0]-n.boundingSphere[3]<o.min&&this._intersectRenderGeometry(n,t,r,o.range,e,i),n.boundingSphere[0]+n.boundingSphere[3]>o.max&&this._intersectRenderGeometry(n,t,r,-o.range,e,i)),i++}return i}_updateSortedMaterialRenderers(){this._sortedRenderers.clear();let e=0;for(const r of this._renderers.values())r.drapedPriority=e++,this._sortedRenderers.push(r);this._sortedRenderers.sort(((e,r)=>r.material?.renderPriority===e.material?.renderPriority?e.drapedPriority-r.drapedPriority:(r.material?.renderPriority||0)-(e.material?.renderPriority||0)))}_processAddsRemoves(){this._changes.adds.clear(),this._changes.removes.clear(),this._changes.adds.pushArray(Array.from(this._pending.adds)),this._changes.removes.pushArray(Array.from(this._pending.removes)),this._changes.updates.filterInPlace((({renderGeometry:e})=>!this._pending.has(e))),this._pending.clear()}_intersectRenderGeometry(e,r,t,s,i,n){if(!e.visible||!e.material.visible)return;let o=0;s+=e.transformation[12],o=e.transformation[13],A[0]=t[0]-s,A[1]=t[1]-o,e.screenToWorldRatio=this.rendererContext.screenToWorldRatio,e.material.intersectDraped(e,null,i,A,((t,s,o)=>{O(r,o,n,e.material.renderPriority,i,e.layerUid,e.graphicUid)}),r)}_notifyGraphicGeometryChanged(e){if(null==this.drapeSource.notifyGraphicGeometryChanged)return;let r;for(const{graphicUid:t}of e)null!=t&&t!==r&&(this.drapeSource.notifyGraphicGeometryChanged(t),r=t)}_notifyGraphicVisibilityChanged(e){if(null==this.drapeSource.notifyGraphicVisibilityChanged)return;let r;for(const{graphicUid:t}of e)null!=t&&t!==r&&(this.drapeSource.notifyGraphicVisibilityChanged(t),r=t)}_validateRenderGeometries(e){for(const r of e)this._validateRenderGeometry(r);return e}_validateRenderGeometry(e){return null==e.localOrigin&&(e.localOrigin=this._localOriginFactory.getOrigin(c.getCenter(e.boundingSphere))),e}get test(){}},r.__decorate([o.property()],e.SortedRenderGeometryRenderer.prototype,"drapeSource",void 0),r.__decorate([o.property()],e.SortedRenderGeometryRenderer.prototype,"updating",null),r.__decorate([o.property()],e.SortedRenderGeometryRenderer.prototype,"rctx",null),r.__decorate([o.property({constructOnly:!0})],e.SortedRenderGeometryRenderer.prototype,"rendererContext",void 0),r.__decorate([o.property()],e.SortedRenderGeometryRenderer.prototype,"_materials",null),r.__decorate([o.property()],e.SortedRenderGeometryRenderer.prototype,"_localOriginFactory",null),r.__decorate([o.property({readOnly:!0})],e.SortedRenderGeometryRenderer.prototype,"isEmpty",null),r.__decorate([o.property()],e.SortedRenderGeometryRenderer.prototype,"_renderers",void 0),r.__decorate([o.property()],e.SortedRenderGeometryRenderer.prototype,"_geometries",void 0),e.SortedRenderGeometryRenderer=r.__decorate([h.subclass("esri.views.3d.webgl-engine.lib.SortedRenderGeometryRenderer")],e.SortedRenderGeometryRenderer);class C{constructor(){this.adds=new Set,this.removes=new Set,this.removed=new Set}get empty(){return 0===this.adds.size&&0===this.removes.size&&0===this.removed.size}has(e){return this.adds.has(e)||this.removes.has(e)||this.removed.has(e)}clear(){this.adds.clear(),this.removes.clear(),this.removed.clear()}}function O(e,r,t,s,i,n,o){const d=new p.OverlayTarget(n,o,r),a=r=>{r.set(_.IntersectorType.OVERLAY,d,e.dist,e.normal,e.transformation,t,s)};if((null==i.results.min.drapedLayerOrder||t>=i.results.min.drapedLayerOrder)&&(null==i.results.min.dist||i.results.ground.dist<=i.results.min.dist)&&a(i.results.min),i.options.store!==_.StoreResults.MIN&&(null==i.results.max.drapedLayerOrder||t<i.results.max.drapedLayerOrder)&&(null==i.results.max.dist||i.results.ground.dist>i.results.max.dist)&&a(i.results.max),i.options.store===_.StoreResults.ALL){const e=m.newIntersectorResult(i.ray);a(e),i.results.all.push(e)}}const A=l.create();Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
