/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../core/mathUtils","../../support/debugFlags","./FontMetrics","./TextHelperCanvas"],(function(t,e,i,n,s){"use strict";const r=1;class h{constructor(t,e,i,n){this.text=t,this._alignment=e,this._parameters=i,this._maxSize=n,this._textWidths=[],this._lineWidths=[],this._renderPixelRatio=null,this._metricsCached=null,this.key=`${t}--${this._parameters.key}-${this._alignment}`,this._lines=t.replaceAll(" "," ").split(/\r?\n/)}get displayWidth(){return Math.ceil(this._displayWidth+2*this._horizontalPadding)}get displayHeight(){let t=this._metrics.firstLineAscent;for(let e=0;e<this._lines.length-1;e++)t+=this._lineSpacing;return t+=this._metrics.lastLineDescent,Math.ceil(t+2*this._haloSize+2*this._verticalPadding)}get renderedWidth(){return this._toRoundedRenderUnit(this.displayWidth)}get renderedHeight(){return this._toRoundedRenderUnit(this.displayHeight)}get firstRenderedBaselinePosition(){return this._toRenderUnit(this._firstLineYOffset+this._metrics.firstLineAscent)}get _firstLineYOffset(){return this._verticalPadding+this._haloSize}get _metrics(){if(null==this._metricsCached){const t=s.getTextHelperCanvas(d,_,_).getContext("2d"),e=this._parameters.definition.pixelRatio,i=this._fontSize*e;this._parameters.setFontProperties(t,i);let r=2*this._haloSize;const h=this._parameters.definition.font;"italic"!==h.style&&"oblique"!==h.style&&"bold"!==h.weight&&"bolder"!==h.weight||(r+=.3*t.measureText("A").width),this._textWidths.length=0,this._lineWidths.length=0;let a=0,o=0,l=0,c=0,m=0;this._lines.forEach(((i,n)=>{const s=t.measureText(i),h=s.width/e,d=h+r;this._textWidths.push(h),this._lineWidths.push(d),a=Math.max(a,d),c=Math.max(c,s.actualBoundingBoxAscent/e),m=Math.max(m,s.actualBoundingBoxDescent/e),0===n&&(o=s.actualBoundingBoxAscent/e),n===this._lines.length-1&&(l=s.actualBoundingBoxDescent/e)}));const u=n.getFontMetrics(this._parameters),f=Math.max(c,u.maxAscent),p=Math.max(m,u.maxDescent),x=o,R="underline"===this._parameters.definition.font.decoration?p:l,S=a;this._metricsCached=new g(x,R,f,p,S)}return this._metricsCached}get _lineSpacing(){return(this._midLineHeight+this._linePadding)*this._parameters.definition.lineSpacingFactor}get _midLineHeight(){return this._metrics.midLineHeight}get _linePadding(){return this._midLineHeight*l}get _midLineAscent(){return this._metrics.maxLineAscent}get _renderedFontSize(){return this._toRenderUnit(this._fontSize)}get _fontSize(){return this._parameters.definition.size}get _renderedHaloSize(){return this._toRenderUnit(this._haloSize)}get _haloSize(){return this._parameters.haloSize}get _horizontalPadding(){return this._hasBackground?this._parameters.definition.background.padding[0]:0}get _verticalPadding(){return Math.max(this._hasBackground?this._parameters.definition.background.padding[1]:0,r)}get _hasBackground(){return!!this._parameters.backgroundStyle}get renderPixelRatio(){if(null==this._renderPixelRatio){const t=this._parameters.definition.pixelRatio;this._renderPixelRatio=Math.min(t,Math.min(this._maxSize[0]/this.displayWidth,this._maxSize[1]/this.displayHeight))}return this._renderPixelRatio}_getLineXOffset(e){switch(this._alignment){case t.TextRenderAlignment.Left:return this._horizontalPadding;case t.TextRenderAlignment.Center:return(this.displayWidth-this._lineWidths[e])/2;case t.TextRenderAlignment.Right:return this.displayWidth-this._horizontalPadding-this._lineWidths[e]}}render(t,e,n){t.save();const s=e/=this.renderPixelRatio,r=n/=this.renderPixelRatio,h=this._haloSize,a=this._firstLineYOffset+this._metrics.firstLineAscent;e+=h,n+=a;const o=this._haloSize>0;o&&this._renderHalo(t,s,r,h,a),this._parameters.setFontProperties(t,this._renderedFontSize);for(let i=0;i<this._lines.length;++i){const s=this._lines[i],r=this._getLineXOffset(i);o&&(t.globalCompositeOperation="destination-out",t.fillStyle="rgb(0, 0, 0)",this._fillText(t,s,e+r,n),this._renderLineDecoration(t,e+r,n,this._textWidths[i])),t.globalCompositeOperation="source-over",t.fillStyle=this._parameters.textStyle,this._fillText(t,s,e+this._getLineXOffset(i),n),this._renderLineDecoration(t,e+r,n,this._textWidths[i]),n+=this._lineSpacing}if(i.debugFlags.TEXT_SHOW_BASELINE){t.strokeStyle=c,t.setLineDash([2,2]),t.lineWidth=1;let e=r+a;for(let i=0;i<this._lines.length;++i)this._drawLine(t,[s,e],[s+this.displayWidth,e]),e+=this._lineSpacing}if(i.debugFlags.TEXT_SHOW_BORDER&&(t.strokeStyle=c,t.setLineDash([]),t.lineWidth=1,this._drawBox(t,[s,r],[this.displayWidth,this.displayHeight])),this._hasBackground){const e=this._parameters.definition.background.borderRadius*this.renderPixelRatio;this._roundedRect(t,s,r,e),t.globalCompositeOperation="destination-over",t.fillStyle=this._parameters.backgroundStyle,t.fill()}t.restore()}_renderLineDecoration(t,e,i,n,s=!1){if("none"===this._parameters.definition.font.decoration||0===n)return;const r=1,h=Math.max(this._parameters.definition.size/16,r);switch(this._parameters.definition.font.decoration){case"underline":i+=2*h;break;case"line-through":i-=.33*this._midLineAscent}const a=s?this._haloSize:0;t.strokeStyle=s?this._parameters.haloStyle:this._parameters.textStyle,t.lineWidth=this._toRenderUnit(h+2*a),t.beginPath(),t.moveTo(this._toRenderUnit(e-a),this._toRenderUnit(i)),t.lineTo(this._toRenderUnit(e+n+a),this._toRenderUnit(i)),t.stroke()}_roundedRect(t,i,n,s){i=this._toRenderUnit(i),n=this._toRenderUnit(n);const r=this.renderedWidth,h=this.renderedHeight;0!==s?(s=e.clamp(s,0,Math.floor(h/2)),t.beginPath(),t.moveTo(i,n+s),t.arcTo(i,n,i+s,n,s),t.lineTo(i+r-s,n),t.arcTo(i+r,n,i+r,n+s,s),t.lineTo(i+r,n+h-s),t.arcTo(i+r,n+h,i+r-s,n+h,s),t.lineTo(i+s,n+h),t.arcTo(i,n+h,i,n+h-s,s),t.closePath()):t.rect(i,n,r,h)}_renderHalo(t,e,i,n,r){const h=this.renderedWidth,a=this.renderedHeight,o=s.getTextHelperCanvas(d,Math.max(h,_),Math.max(a,_)),l=o.getContext("2d");l.clearRect(0,0,h,a),this._parameters.setFontProperties(l,this._renderedFontSize),l.fillStyle=this._parameters.haloStyle,l.strokeStyle=this._parameters.haloStyle;const c=this._renderedHaloSize<3;l.lineJoin=c?"miter":"round",c?this._renderHaloEmulated(l,n,r):this._renderHaloNative(l,n,r);let g=r;for(let s=0;s<this._lines.length;++s){const t=this._getLineXOffset(s);this._renderLineDecoration(l,n+t,g,this._textWidths[s],!0),g+=this._lineSpacing}t.globalAlpha=this._parameters.definition.halo.color[3],t.drawImage(o,0,0,h,a,this._toRenderUnit(e),this._toRenderUnit(i),h,a),t.globalAlpha=1}_renderHaloEmulated(t,e,i){for(let n=0;n<this._lines.length;++n){const s=this._lines[n],r=this._getLineXOffset(n);for(const[n,h]of a)this._fillText(t,s,e+r+this._haloSize*n,i+this._haloSize*h);i+=this._lineSpacing}}_renderHaloNative(t,e,i){const n=2*this._haloSize;for(let s=0;s<this._lines.length;++s){const r=this._lines[s],h=this._getLineXOffset(s),a=5,o=.1;for(let s=0;s<a;s++){const d=1-(a-1)*o+s*o;t.lineWidth=this._toRenderUnit(d*n),this._strokeText(t,r,e+h,i)}i+=this._lineSpacing}}get _displayWidth(){return this._metrics.displayWidth}_toRenderUnit(t){return t*this.renderPixelRatio}_toRoundedRenderUnit(t){return Math.round(t*this.renderPixelRatio)}_fillText(t,e,i,n){t.fillText(e,this._toRenderUnit(i),this._toRenderUnit(n))}_strokeText(t,e,i,n){t.strokeText(e,this._toRenderUnit(i),this._toRenderUnit(n))}_drawLine(t,e,i){t.beginPath(),t.moveTo(this._toRoundedRenderUnit(e[0])+.5,this._toRoundedRenderUnit(e[1])+.5),t.lineTo(this._toRoundedRenderUnit(i[0])+.5,this._toRoundedRenderUnit(i[1])+.5),t.stroke()}_drawBox(t,e,i){const n=this._toRenderUnit(e[0]),s=this._toRenderUnit(e[1]),r=this._toRenderUnit(i[0]),h=this._toRenderUnit(i[1]),a=Math.floor(n)+.5,o=Math.ceil(n+r)-.5,d=Math.floor(s)+.5,l=Math.ceil(s+h)-.5;t.beginPath(),t.moveTo(a,d),t.lineTo(o,d),t.lineTo(o,l),t.lineTo(a,l),t.lineTo(a,d),t.stroke()}}const a=[];{const t=16;for(let e=0;e<360;e+=360/t)a.push([Math.cos(Math.PI*e/180),Math.sin(Math.PI*e/180)])}var o;t.TextRenderAlignment=void 0,(o=t.TextRenderAlignment||(t.TextRenderAlignment={}))[o.Left=0]="Left",o[o.Center=1]="Center",o[o.Right=2]="Right";const d={canvas:null},l=.2,_=512,c="rgb(255, 0, 255, 0.5)";class g{get firstLineHeight(){return this.firstLineAscent+this.maxLineDescent}get midLineHeight(){return this.maxLineAscent+this.maxLineDescent}get lastLineHeight(){return this.maxLineAscent+this.lastLineDescent}constructor(t,e,i,n,s){this.firstLineAscent=t,this.lastLineDescent=e,this.maxLineAscent=i,this.maxLineDescent=n,this.displayWidth=s}}t.TextRenderer=h,t.textVerticalPaddingPx=r,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
