/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../chunks/tslib.es6","../../../../core/Accessor","../../../../core/Evented","../../../../core/has","../../../../core/maybe","../../../../core/uid","../../../../core/accessorSupport/decorators/property","../../../../core/Logger","../../../../core/RandomLCG","../../../../core/accessorSupport/decorators/subclass","../../../../chunks/vec42","../../../../core/libs/gl-matrix-2/factories/vec4f64","./ContentObjectType","./testUtils","./textureUtils","../../../support/Scheduler","../../../support/Yield","../../../webgl/enums","../../../webgl/Texture","../../../webgl/TextureDescriptor"],(function(e,t,s,i,r,a,h,n,l,o,_,c,d,u,x,g,p,m,T,f,v){"use strict";const w=4096;e.TextTextureAtlas=class extends s{constructor(e){super(e),this.type=u.ContentObjectType.Texture,this.id=h.generateUID(),this.events=new i,this._glTexture=null,this._atlas=new b(256,256),this._needsRepack=!1,this._canRepack=!0,this._elementsToRender=new Map,this._elements=new Map,this._uvCallbacks=new Map,this.updating=!1}initialize(){this._canvas=document.createElement("canvas"),this._canvas.setAttribute("id","textAtlasCanvas"),this._canvas.setAttribute("style","display:none"),this._ctx=this._canvas.getContext("2d"),this._stage=this.view._stage,this._stage.add(this),this._updateCanvasElementSize(this._atlas),this._reset()}unload(){this._glTexture=a.disposeMaybe(this._glTexture),this._frameWorker=a.removeMaybe(this._frameWorker),this.updating=!1,this.events.emit("unloaded")}get glTexture(){return this._glTexture}static get maxSize(){return M=x.textTextureAtlas.stableRendering?y:0,[w-y-M,w-y-M-k]}load(e){if(this._glTexture)return this._glTexture;const t=new v.TextureDescriptor;return t.wrapMode=T.TextureWrapMode.CLAMP_TO_EDGE,t.samplingMode=T.TextureSamplingMode.LINEAR_MIPMAP_LINEAR,t.hasMipmap=!0,t.preMultiplyAlpha=!0,t.maxAnisotropy=e.parameters.maxMaxAnisotropy,this._glTexture=new f.Texture(e,t,this._canvas),this._frameWorker=this.view.resourceController.scheduler.registerTask(p.TaskPriority.TEXT_TEXTURE_ATLAS,this),this.setDirty(),this._glTexture}dispose(){this._elements.clear(),this._elementsToRender.clear(),this._frameWorker=a.removeMaybe(this._frameWorker),this._glTexture&&(this._stage.remove(this),this._glTexture=a.disposeMaybe(this._glTexture)),this._canvas.width=0,this._canvas.height=0,this._canvas=null,this._ctx=null}_updateCanvasElementSize(e){this._canvas.width=e.width,this._canvas.height=e.height}_resizeAtlas(e,t){const{width:s,height:i}=this._atlas;s===e&&i===t||(this._atlas.width=e,this._atlas.height=t,this._glTexture?.resize(e,t),this._glTexture?.updateData(0,0,0,s,i,this._canvas),this._updateCanvasElementSize(this._atlas),this._elements.forEach((e=>this._uvCallbacks.get(e.textRenderer.key)?.forEach((t=>t(e.uv))))),this._reset())}_reset(){this._elementsToRender.clear(),this._atlas.reset(),this._needsRepack=!0,this.setDirty()}_addAtlasElement(e,t,s,i){const r=this._atlas;if(r.width<s||r.height<i)return!1;let a=r.cursors.get(i);if(!a){if(r.height<r.nextY+i)return!1;a=[new A(r.nextY)],r.cursors.set(i,a),r.nextY+=i}let h=a.find((e=>r.width>=e.x+s));if(null==h){if(r.height<r.nextY+i)return!1;h=new A(r.nextY),r.nextY+=i,a.push(h)}return e.setNewPosition(h),this._elements.set(t,e),this._elementsToRender.set(t,e),h.x+=s,!0}_ensureCallbacks(e){const t=this._uvCallbacks.get(e);if(t)return t;const s=new Set;return this._uvCallbacks.set(e,s),s}_addCallback(e,t){this._ensureCallbacks(e).add(t)}_removeCallback(e,t){const s=this._uvCallbacks.get(e);return!(!s?.delete(t)||0!==s.size)&&(this._uvCallbacks.delete(e),!0)}_processAddition(e){const t=e.textRenderer.key;if(this._needsRepack)return void this._elements.set(t,e);const s=this._atlas,i=e.textRenderer.renderedWidth,r=e.textRenderer.renderedHeight,a=i+y,h=r+y+k;if(!this._addAtlasElement(e,t,a,h)){if(this._canRepack)this._reset();else if(s.width<a){const e=Math.min(g.applyTextureResizeModulo(Math.max(a,1.5*s.width)),w);this._resizeAtlas(e,s.height)}else{const e=s.nextY+h,t=Math.min(g.applyTextureResizeModulo(Math.max(e,1.5*s.height)),w);if(t>s.height)this._resizeAtlas(s.width,t);else if(s.width<w){const e=Math.min(g.applyTextureResizeModulo(1.5*s.width),w);this._resizeAtlas(e,s.height)}}this._elements.set(t,e)}}_renderElement(e){const t=e.commitNewPosition(),s=e.textRenderer;this._ctx.clearRect(t[0]-y,t[1]-y,s.renderedWidth+2*y,s.renderedHeight+2*y),s.render(this._ctx,t[0],t[1]),this._uvCallbacks.get(s.key)?.forEach((t=>t(e.uv)))}get running(){return this.updating}runTask(e){if(null==this._glTexture)return m.Yield;for(;this._needsRepack&&(this._canRepack||this._atlas.height<w&&this._atlas.height<w);){this._canRepack=this._needsRepack=!1;const t=this._elements;this._elements=new Map,t.forEach((e=>this._processAddition(e))),e.madeProgress()}if(this._elementsToRender.size>0){for(const[t,s]of this._elementsToRender){if(e.done)break;this._renderElement(s),this._elementsToRender.delete(t),e.madeProgress()}this._glTexture.setData(this._canvas)}this.updating=this._elementsToRender.size>0}addText(e,t){const s=e.key;this._addCallback(s,t);let i=this._elements.get(s);return i?c.exactEquals(i.uv,d.ZEROS)||t(i.uv):(i=new R(this._atlas,e),this._processAddition(i),this.setDirty()),{remove:()=>this._removeText(e,t)}}_removeText(e,t){const s=e.key;this._elements.get(s)&&this._removeCallback(s,t)&&(this._elements.delete(s),this._elementsToRender.delete(s),this._canRepack=!0)}setDirty(){this._glTexture&&(this.updating=!0)}get test(){}},t.__decorate([n.property({constructOnly:!0})],e.TextTextureAtlas.prototype,"view",void 0),t.__decorate([n.property({type:Boolean})],e.TextTextureAtlas.prototype,"updating",void 0),e.TextTextureAtlas=t.__decorate([_.subclass("esri.views.3d.webgl-engine.lib.TextTextureAtlas")],e.TextTextureAtlas);const y=2,k=2;class R{constructor(e,t){this._atlas=e,this.textRenderer=t,this._uv=d.create(),this._newPosition=[0,0]}get uv(){if(null==this._xOffset||null==this._yOffset)return d.ZEROS;const{renderedWidth:e,renderedHeight:t}=this.textRenderer;return c.set(this._uv,this._xOffset/this._atlas.width,(this._yOffset+t)/this._atlas.height,(this._xOffset+e)/this._atlas.width,this._yOffset/this._atlas.height)}setNewPosition(e){this._newPosition[0]=e.x,this._newPosition[1]=e.y}commitNewPosition(){return this._xOffset=this._newPosition[0],this._yOffset=this._newPosition[1],this._newPosition}get xOffset(){return this._xOffset}get yOffset(){return this._yOffset}}class b{constructor(e,t){this.width=e,this.height=t,this.cursors=new Map,this.nextY=0}reset(){this.cursors.clear(),this.nextY=M}}class A{constructor(e){this.y=e,this.x=M}}let M=0;Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
