/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../core/has","../../../../core/Error","../../../../core/Evented","../../../../core/maybe","../../../../core/promiseUtils","../../../../core/typedArrayUtil","../../../../core/urlUtils","../../../../support/requestImageUtils","../../../../support/requestUtils","./basicInterfaces","./BasisUtil","./ContentObject","./ContentObjectType","./DDSUtil","./textureUtils","./Util","../../../webgl/enums","../../../webgl/Texture","../../../webgl/TextureDescriptor"],(function(e,t,r,a,i,s,o,n,l,m,d,h,_,p,c,u,g,T,A,E){"use strict";class x extends _.ContentObject{get parameters(){return this._parameters}constructor(e,t){super(),this._data=e,this.type=p.ContentObjectType.Texture,this._glTexture=null,this._loadingPromise=null,this._loadingController=null,this.events=new a,this._parameters={...M,...t},this._startPreload(e)}dispose(){this.unload(),this._data=this.frameUpdate=void 0}_startPreload(e){null!=e&&(e instanceof HTMLVideoElement?(this.frameUpdate=t=>this._frameUpdate(e,t),this._startPreloadVideoElement(e)):e instanceof HTMLImageElement&&this._startPreloadImageElement(e))}_startPreloadVideoElement(e){if(!(n.isBlobProtocol(e.src)||"auto"===e.preload&&e.crossOrigin)){e.preload="auto",e.crossOrigin="anonymous";const t=!e.paused;if(e.src=e.src,t&&e.autoplay){const t=()=>{e.removeEventListener("canplay",t),e.play()};e.addEventListener("canplay",t)}}}_startPreloadImageElement(e){n.isDataProtocol(e.src)||n.isBlobProtocol(e.src)||e.crossOrigin||(e.crossOrigin="anonymous",e.src=e.src)}_createDescriptor(e){const t=new E.TextureDescriptor;return t.wrapMode=this._parameters.wrap??T.TextureWrapMode.REPEAT,t.flipped=!this._parameters.noUnpackFlip,t.samplingMode=this._parameters.mipmap?T.TextureSamplingMode.LINEAR_MIPMAP_LINEAR:T.TextureSamplingMode.LINEAR,t.hasMipmap=!!this._parameters.mipmap,t.preMultiplyAlpha=!!this._parameters.preMultiplyAlpha,t.maxAnisotropy=this._parameters.maxAnisotropy??(this._parameters.mipmap?e.parameters.maxMaxAnisotropy:1),t}get glTexture(){return this._glTexture}get memoryEstimate(){return this._glTexture?.usedMemory||y(this._data,this._parameters)}load(e){if(this._glTexture)return this._glTexture;if(this._loadingPromise)return this._loadingPromise;const t=this._data;return null==t?(this._glTexture=new A.Texture(e,this._createDescriptor(e),null),this._glTexture):(this._parameters.reloadable||(this._data=void 0),"string"==typeof t?this._loadFromURL(e,t):t instanceof Image?this._loadFromImageElement(e,t):t instanceof HTMLVideoElement?this._loadFromVideoElement(e,t):t instanceof ImageData||t instanceof HTMLCanvasElement?this._loadFromImage(e,t):o.isUint8Array(t)&&this._parameters.encoding===d.TextureEncodingMimeType.DDS_ENCODING?this._loadFromDDSData(e,t):o.isArrayBuffer(t)&&this._parameters.encoding===d.TextureEncodingMimeType.DDS_ENCODING?this._loadFromDDSData(e,new Uint8Array(t)):(o.isArrayBuffer(t)||o.isUint8Array(t))&&this._parameters.encoding===d.TextureEncodingMimeType.KTX2_ENCODING?this._loadFromKTX2(e,t):(o.isArrayBuffer(t)||o.isUint8Array(t))&&this._parameters.encoding===d.TextureEncodingMimeType.BASIS_ENCODING?this._loadFromBasis(e,t):o.isUint8Array(t)?this._loadFromPixelData(e,t):o.isArrayBuffer(t)?this._loadFromPixelData(e,new Uint8Array(t)):null)}_frameUpdate(e,t){return null==this._glTexture||e.readyState<f.HAVE_CURRENT_DATA||t===e.currentTime?t:(this._glTexture.setData(e),this._glTexture.descriptor.hasMipmap&&this._glTexture.generateMipmap(),this._parameters.updateCallback&&this._parameters.updateCallback(),e.currentTime)}_loadFromDDSData(e,t){return this._glTexture=c.createDDSTexture(e,this._createDescriptor(e),t),this._glTexture}_loadFromKTX2(e,t){return this._loadAsync((()=>h.createTextureKTX2(e,this._createDescriptor(e),t).then((e=>(this._glTexture=e,e)))))}_loadFromBasis(e,t){return this._loadAsync((()=>h.createTextureBasis(e,this._createDescriptor(e),t).then((e=>(this._glTexture=e,e)))))}_loadFromPixelData(e,t){g.assert(this._parameters.width>0&&this._parameters.height>0);const r=this._createDescriptor(e);return r.pixelFormat=1===this._parameters.components?T.PixelFormat.LUMINANCE:3===this._parameters.components?T.PixelFormat.RGB:T.PixelFormat.RGBA,r.width=this._parameters.width??0,r.height=this._parameters.height??0,this._glTexture=new A.Texture(e,r,t),this._glTexture}_loadFromURL(e,t){return this._loadAsync((async r=>{const a=await l.requestImage(t,{signal:r});return s.throwIfAborted(r),this._loadFromImage(e,a)}))}_loadFromImageElement(e,t){return t.complete?this._loadFromImage(e,t):this._loadAsync((async r=>{const a=await m.loadImageAsync(t,t.src,!1,r);return s.throwIfAborted(r),this._loadFromImage(e,a)}))}_loadFromVideoElement(e,t){return t.readyState>=f.HAVE_CURRENT_DATA?this._loadFromImage(e,t):this._loadFromVideoElementAsync(e,t)}_loadFromVideoElementAsync(e,t){return this._loadAsync((a=>new Promise(((o,n)=>{const l=()=>{t.removeEventListener("loadeddata",m),t.removeEventListener("error",d),i.removeMaybe(h)},m=()=>{t.readyState>=f.HAVE_CURRENT_DATA&&(l(),o(this._loadFromImage(e,t)))},d=e=>{l(),n(e||new r("Failed to load video"))};t.addEventListener("loadeddata",m),t.addEventListener("error",d);const h=s.onAbort(a,(()=>d(s.createAbortError())))}))))}_loadFromImage(e,t){let r=t;if(!(r instanceof HTMLVideoElement)){const{maxTextureSize:t}=e.parameters;r=this._parameters.downsampleUncompressed?u.downsampleImage(r,t):u.ensureImageMaxSize(r,t)}const a=D(r);this._parameters.width=a.width,this._parameters.height=a.height;const i=this._createDescriptor(e);return i.pixelFormat=3===this._parameters.components?T.PixelFormat.RGB:T.PixelFormat.RGBA,i.width=a.width,i.height=a.height,this._glTexture=new A.Texture(e,i,r),this._glTexture}_loadAsync(e){const t=new AbortController;this._loadingController=t;const r=e(t.signal);this._loadingPromise=r;const a=()=>{this._loadingController===t&&(this._loadingController=null),this._loadingPromise===r&&(this._loadingPromise=null)};return r.then(a,a),r}unload(){if(this._glTexture=i.disposeMaybe(this._glTexture),null!=this._loadingController){const e=this._loadingController;this._loadingController=null,this._loadingPromise=null,e.abort()}this.events.emit("unloaded")}}function y(e,t){if(null==e)return 0;if(o.isArrayBuffer(e)||o.isUint8Array(e))return t.encoding===d.TextureEncodingMimeType.KTX2_ENCODING?h.estimateMemoryKTX2(e,!!t.mipmap):t.encoding===d.TextureEncodingMimeType.BASIS_ENCODING?h.estimateMemoryBasis(e,!!t.mipmap):e.byteLength;const{width:r,height:a}=e instanceof Image||e instanceof ImageData||e instanceof HTMLCanvasElement||e instanceof HTMLVideoElement?D(e):t;return(t.mipmap?4/3:1)*r*a*(t.components||4)||0}function D(e){return e instanceof HTMLVideoElement?{width:e.videoWidth,height:e.videoHeight}:e}var f;!function(e){e[e.HAVE_NOTHING=0]="HAVE_NOTHING",e[e.HAVE_METADATA=1]="HAVE_METADATA",e[e.HAVE_CURRENT_DATA=2]="HAVE_CURRENT_DATA",e[e.HAVE_FUTURE_DATA=3]="HAVE_FUTURE_DATA",e[e.HAVE_ENOUGH_DATA=4]="HAVE_ENOUGH_DATA"}(f||(f={}));const M={wrap:{s:T.TextureWrapMode.REPEAT,t:T.TextureWrapMode.REPEAT},mipmap:!0,noUnpackFlip:!1,preMultiplyAlpha:!1,downsampleUncompressed:!1};e.Texture=x,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
