/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../chunks/tslib.es6","../../../../core/Collection","../../../../core/mathUtils","../../../../core/maybe","../../../../core/reactiveUtils","../../../../core/accessorSupport/decorators/property","../../../../core/has","../../../../core/Logger","../../../../core/RandomLCG","../../../../core/accessorSupport/decorators/subclass","../../../../core/libs/gl-matrix-2/math/mat4","../../../../core/libs/gl-matrix-2/factories/mat4f64","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../chunks/sphere","../../webgl","../../webgl/RenderNode","./basicInterfaces","./RenderFeature","./ViewshedShadowMap","../../../../chunks/Viewshed.glsl","../shaders/ViewshedTechnique"],(function(e,s,t,r,i,a,o,n,d,h,c,p,w,l,u,_,f,v,V,m,g,y,b){"use strict";function M(e,s){const t=u.create();return l.sub(t,e,s)}function S(e,s,t){const r=u.fromValues(.5,.5,.5);return p.fromTranslation(t,r),p.scale(t,t,r),p.mul(t,t,e),p.mul(t,t,s),t}function R(e,s){const t=_.fromCenterAndRadius(s.observerRenderSpace,s.farDistanceRenderSpace);return!!e.ready&&e.frustum.intersectsSphere(t)}function P(e,s,t){if(null==e)return 0;const{observerRenderSpace:r,targetRenderSpace:i}=e,a=l.distance(t,r)>l.distance(t,i)?e.observer:e.target;return s.pixelSizeAt(a)}e.Viewshed=class extends v{get shadowMap(){return this._shadowMap}get hasViewsheds(){return this._viewsheds.length>0}get _contentPixelRatio(){return this.view.state.contentPixelRatio}get _viewshedsInView(){return this._viewsheds.items.filter((e=>R(this.view,e)))}constructor(e){super(e),this._techniques=null,this._passParameters=new y.ViewshedPassParameters,this._viewsheds=new t,this._shadowMap=null,this.consumes={required:[f.InternalRenderCategory.VIEWSHED],optional:["normals"]},this.produces=f.InternalRenderCategory.VIEWSHED,this.requireGeometryDepth=!0}initialize(){this._shadowMap=new g.ViewshedShadowMap(this.fboCache),this.addHandles([a.watch((()=>this.view.resolutionScale),(e=>{const s=this._shadowMap;s&&(s.settings.textureSizeQuality=e)}),a.initial),a.when((()=>!this.hasViewsheds),(()=>this._shadowMap?.dispose())),a.when((()=>this.view._stage.renderView.techniques),(e=>this._techniques=e),a.initial),a.watch((()=>this._viewshedsInView.map((e=>[e.observerRenderSpace,e.heading,e.tilt,e.farDistance,e.horizontalFieldOfView,e.verticalFieldOfView]))),(()=>this.requestRender(V.RenderRequestType.UPDATE)),a.sync)])}destroy(){this._shadowMap=i.disposeMaybe(this._shadowMap)}precompile(){if(this.hasViewsheds){this._techniques?.precompile(b.ViewshedTechnique);for(const e of this._viewshedsInView)if(this._shadowMap?.isActive(e))return void this.view._stage.renderer.precompileViewshedShadowMap()}}render(e){const s=this.bindParameters,t=this.renderingContext,r=e.find((({name:e})=>e===f.InternalRenderCategory.VIEWSHED));if(!this.hasViewsheds||!s.depth)return r;this._passParameters.shadowMap=this._shadowMap??this._passParameters.shadowMap,this._passParameters.normals=e.find((({name:e})=>"normals"===e))?.getTexture();const i=this._techniques?.acquire(b.ViewshedTechnique);if(!i?.compiled)return this.requestRender(V.RenderRequestType.UPDATE),i?.release(),r;const a=this.view._stage.renderer.isFeatureEnabled(m.RenderFeature.HighResolutionViewshed);for(const o of this._viewshedsInView){if(!this._renderShadowCubeMap(s,o,a)||!this._shadowMap?.ready)continue;const e=this._setupViewshedParameters(o,s.camera);t.bindTechnique(i,s,e),t.bindFramebuffer(r.fbo),t.screen.draw()}return i.release(),this.shadowMap?.dispose(),r}updateViewsheds(e){const s=this._viewsheds,{removes:t,adds:r}=e;if(t&&(Array.isArray(t)?s.removeMany(t):s.remove(t)),r)if(Array.isArray(r)){const e=r.filter((e=>!s.includes(e)));s.addMany(e)}else s.includes(r)||s.add(r)}_renderShadowCubeMap(e,s,t){const r=this._shadowMap;if(!r)return!1;const i=this.view.basemapTerrain.hasStencilEnabledExtents,a=r.start(e.camera,s,t,this._contentPixelRatio,i);return a&&r.faces.forEach((e=>this.view._stage.renderer.renderViewshedShadowMap(e))),r.finish(),a}_setupViewshedParameters(e,s){const t=this._shadowMap;if(!t)return this._passParameters;const i=this._passParameters,a=e.effectiveObserverRenderSpace;i.localOrigin=a,i.observerOffset=l.sub(q,e.observerRenderSpace,e.effectiveObserverRenderSpace),i.fovs=[r.deg2rad(e.horizontalFieldOfView),r.deg2rad(e.verticalFieldOfView)],i.headingAndTilt=[r.deg2rad(e.heading),r.deg2rad(e.tiltParallelToSurface)],i.upVector=e.tiltedUpVector;const o=M(e.targetRenderSpace,a);i.targetVector=o;const n=new Array,d=new Array;for(let r=0;r<t.numActiveFaces;r++)p.translate(x,t.viewshedViewMatrices[r],a),n.push(...x),S(t.viewshedProjectionMatrices[r],x,I),d.push(...I);return i.viewMatrices=n,i.projectionMatrices=d,i.volumeOffset=this.selectedViewshed?.()===e.viewshed?P(e,this.view,s.eye):0,i}get test(){return{viewsheds:this._viewsheds,shadowMap:this._shadowMap,viewshedsInView:this._viewshedsInView}}},s.__decorate([o.property()],e.Viewshed.prototype,"_techniques",void 0),s.__decorate([o.property()],e.Viewshed.prototype,"selectedViewshed",void 0),s.__decorate([o.property()],e.Viewshed.prototype,"shadowMap",null),s.__decorate([o.property()],e.Viewshed.prototype,"hasViewsheds",null),s.__decorate([o.property()],e.Viewshed.prototype,"_contentPixelRatio",null),s.__decorate([o.property()],e.Viewshed.prototype,"_viewshedsInView",null),s.__decorate([o.property()],e.Viewshed.prototype,"consumes",void 0),s.__decorate([o.property()],e.Viewshed.prototype,"produces",void 0),e.Viewshed=s.__decorate([c.subclass("esri.views.3d.webgl-engine.lib.Viewshed")],e.Viewshed);const q=u.create(),x=w.create(),I=w.create();e.computeOffsetScale=P,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
