/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../core/has","../../../../core/mathUtils","../../../../core/maybe","../../../../core/libs/gl-matrix-2/math/mat4","../../../../core/libs/gl-matrix-2/factories/mat4f64","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../webgl/formats","./textureUtils","./ViewshedFaceCamera","../../../webgl/enums"],(function(t,e,i,s,r,a,h,o,c,n,l,u){"use strict";class d{constructor(){this.textureSizeQuality=1,this.textureSizeModHighQuality=1.3,this.textureSizeModLowQuality=.9,this.textureSizeMultiple=128,this.toleranceSides=5,this.toleranceBottomTop=10}textureSizeModifier(t){const e=t?this.textureSizeModHighQuality:this.textureSizeModLowQuality;return this.textureSizeQuality*e}textureResizeModulo(t){return Math.ceil(t/this.textureSizeMultiple)*this.textureSizeMultiple}}const f=["front","left","right","back","top","bottom"];function m(t){return!["top","bottom"].includes(t)}class _{constructor(t){this._fbos=t,this._minTextureSize=16,this._faces={},this._width=0,this._height=0,this.settings=new d,this._maxTextureSize=Math.min(e("esri-mobile")?4096:16384,t.rctx.parameters.maxTextureSize)}get depthTexture(){return this._handle?.getTexture()}get ready(){return null!=this.depthTexture&&0!==this._width&&0!==this._height}get nearFar(){const t=this.faces;return 0===t.length?null:t[0].nearFar}get numActiveFaces(){const t=this._faces;let e=0;return Object.keys(t).forEach((i=>{t[i]&&(e+=1)})),e}get faces(){const t=this._faces,e=[];for(const i of f){const s=t[i];s&&e.push(s)}return e}get atlasRegions(){return this.faces.map((t=>[t.x/this._width,(t.x+t.width)/this._width,t.y/this._height,(t.y+t.height)/this._height]))}get viewshedProjectionMatrices(){return this.faces.map((t=>t.projectionMatrix))}get viewshedViewMatrices(){return this.faces.map((t=>t.viewMatrix))}_setupFaceCamera(t,e,s,c){const{effectiveObserverRenderSpace:n,tiltedUpVector:u,targetRenderSpace:d,farDistanceRenderSpace:f,horizontalFieldOfView:_,verticalFieldOfView:g}=e,p=o.create();h.sub(p,d,n);const x=o.create(),b=o.create(),w=(t,e)=>{const i=o.create(),s=a.create();return r.fromRotation(s,t,e),h.transformMat4(i,p,s),h.add(i,n,i),i};let M,F=u;const S=Math.min(90,_),z=Math.min(90,Math.max(0,(_-90)/2));let T=-45,v=45,y=-45,B=45;if(m(t)){const t=t=>i.clamp(t,-45,45);y=t(-g/2)-this.settings.toleranceBottomTop,B=t(+g/2)+this.settings.toleranceBottomTop}switch(t){case"front":M=d,T=-S/2,v=S/2;break;case"left":M=w(Math.PI/2,u),T=45-z;break;case"right":M=w(-Math.PI/2,u),v=-45+z;break;case"top":M=h.add(x,n,u),F=h.negate(b,p);break;case"bottom":M=h.sub(x,n,u),F=p;break;case"back":M=w(Math.PI,u)}const R=new l.ViewshedFaceCamera({center:M,eye:n,up:F,far:f});R.sectionAnglesDeg=[T-this.settings.toleranceSides,v+this.settings.toleranceSides,y,B],R.fovY=Math.PI/2;const O=R.setViewport(s,c);return this._faces[t]=R,O}isActive(t){return this._computeActiveFaces(t).size>0}_computeActiveFaces(t){const e=new Set,{horizontalFieldOfView:i,verticalFieldOfView:s}=t,r=-s/2,a=s/2;return 0===i||0===s||(r<=45&&a>=-45&&e.add("front"),i>90&&(e.add("left"),e.add("right")),i>270&&e.add("back"),a>45-this.settings.toleranceBottomTop&&e.add("top"),r<-45+this.settings.toleranceBottomTop&&e.add("bottom")),e}_computeBaseTextureSize(t,e,s,r){const a=e/t.pixelRatio,h=this.settings.textureSizeModifier(s),o=Math.max(t.fullWidth,t.fullHeight),c=n.applyTextureResizeModulo(Math.floor(o*a*h)),l=Math.floor(this._maxTextureSize/r),u=i.clamp(c,this._minTextureSize,l);return n.applyTextureResizeFloorModulo(u)}_ensureFBO(t){const e=this._width,i=this._height;this._handle?.fbo?.width===e&&this._handle?.fbo?.height===i||(this._handle?.release(),this._handle=this._fbos.acquire(e,i,"viewshed shadow map",c.ColorFormat.RGBA4));const s=t?c.DepthFormat.DEPTH_STENCIL_TEXTURE:c.DepthFormat.DEPTH16_BUFFER;this._handle.acquireDepth(s)}clearFBO(t){const e=this._fbos.rctx;this._ensureFBO(t),e.bindFramebuffer(this._handle?.fbo),e.setClearColor(1,1,1,1),e.clear(u.FramebufferBit.COLOR|u.FramebufferBit.DEPTH)}dispose(){this._handle=s.releaseMaybe(this._handle)}start(t,e,i,s,r=!1){this._faces={};const a=this._computeActiveFaces(e),h=a.size;if(0===h)return!1;const o=this._computeBaseTextureSize(t,s,i,h);let c=0,n=0,l=0;return f.filter((t=>a.has(t))).forEach((t=>{const i=g(t,h);i>n&&(l=Math.max(l,c),c=0),n=i;const s=i*o;c+=this._setupFaceCamera(t,e,[c,s],o)})),l=Math.max(l,c),this._width=this.settings.textureResizeModulo(l),this._height=p(h)*o,this.clearFBO(r),!0}finish(){this._handle?.detachDepth()}get test(){return{faces:this._faces,faceTypes:f,width:this._width,height:this._height,getFBO:()=>this._fbos.acquire(this._width,this._height,"viewshed shadow map",c.ColorFormat.RGBA4)}}}function g(t,e){if(e<4)return 0;const i="front"===t||"left"===t;return 4===e?i?0:1:i||"right"===t?0:1}function p(t){return t<4?1:2}t.ViewshedShadowMap=_,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
