/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../core/PooledArray","../../../../core/libs/gl-matrix-2/math/mat4","../../../../core/libs/gl-matrix-2/factories/mat4f64","../../../../chunks/vec32","../../../../chunks/vec42","../../../../core/libs/gl-matrix-2/factories/vec4f64","../../../../geometry/support/frustum","../../../../chunks/sphere","../../support/mathUtils","./depthRange","./Octree","./Util"],(function(e,t,r,n,i,a,s,o,h,f,c,l,u){"use strict";const _=1e4,d=100,m=500,g=500,p=.1;function b(e,t,r){let n=0;if(!t.some((e=>!!e.material&&(n+=e.numGeometries,n>=_))))return N.compute(e,t);const i=c.empty();return r.forAll((t=>c.union(i,w(e,t)))),i}function w(e,t){if(!t.visible)return;const r=c.empty(),n=t.getSpatialQueryAccelerator();return n?v(r,e,n):R(r,e,t.objects),r}function v(e,t,r){const n=t.eye,i=t.viewForward,a=t.frustum,s=e=>e.visible,o=r.objectCount;if(o<m)c.set(I,t.near,Math.min(e.near,t.far)),r.forEachInDepthRange(n,i,l.DepthOrder.FRONT_TO_BACK,I,((r,n)=>{C(e,t,r),I.far=e.near,n.setRange(I)}),a,s),c.set(I,Math.max(e.far,t.near),t.far),r.forEachInDepthRange(n,i,l.DepthOrder.BACK_TO_FRONT,I,((r,n)=>{C(e,t,r),I.near=e.far,n.setRange(I)}),a,s);else{const n=Math.max(Math.min(o,g),Math.ceil(o*p)),h=r.findClosest(i,l.DepthOrder.FRONT_TO_BACK,a,s,n),f=r.findClosest(i,l.DepthOrder.BACK_TO_FRONT,a,s,n);h&&f&&(O(e,t,h.boundingVolumeWorldSpace.bounds),O(e,t,f.boundingVolumeWorldSpace.bounds))}}function R(e,t,r){P.clear(),r.forAll((e=>{e.visible&&0!==e.geometries.length&&P.add(e)})),P.empty||(P.sort(t),c.set(I,t.near,Math.min(e.near,t.far)),P.forEachInDepthRange(I,l.DepthOrder.FRONT_TO_BACK,((r,n)=>{n<e.near&&C(e,t,r)})),c.set(I,Math.max(e.far,t.near),t.far),P.forEachInDepthRange(I,l.DepthOrder.BACK_TO_FRONT,((t,r,n)=>{e.far=Math.max(e.far,n)})))}function C(e,t,n){if(!n.visible)return;if(!o.intersectsSphere(t.frustum,n.boundingVolumeWorldSpace.bounds))return;const i=n.transformation,a=S;n.geometries.forEach((n=>{r.multiply(a,i,n.transformation);const s=f.maxScale(a);M(e,t,n.boundingInfo,a,s)}))}function M(e,t,r,n,a){if(null==r)return;i.transformMat4(h.getCenter(T),r.center,n);const{eye:s,viewForward:f}=t,c=f[0]*(T[0]-s[0])+f[1]*(T[1]-s[1])+f[2]*(T[2]-s[2]);if(T[3]=r.radius*a,!(c-T[3]>e.near&&c+T[3]<e.far)&&o.intersectsSphere(t.frustum,T))if(r.radius>d&&r.getChildren())for(const i of r.getChildren())M(e,t,i,n,a);else W.unionDepthRangeWithAABB(e,t.viewProjectionMatrix,n,r.bbMin,r.bbMax)}function O(e,t,r){const n=t.eye,i=t.viewForward,a=(r[0]-n[0])*i[0]+(r[1]-n[1])*i[1]+(r[2]-n[2])*i[2];e.near=Math.min(e.near,a-r[3]),e.far=Math.max(e.far,a+r[3])}class A{constructor(){this._items=new t({allocator:e=>e||{object:null,distance:0,near:0,far:0},deallocator:e=>(e.object=null,e.distance=0,e.near=0,e.far=0,e)})}get length(){return this._items.length}get empty(){return 0===this._items.length}clear(){this._items.clear()}add(e){this._items.pushNew().object=e}sort(e){const t=e.eye,r=e.viewForward;this._items.forAll((e=>{const n=e.object.boundingVolumeWorldSpace.bounds,i=(n[0]-t[0])*r[0]+(n[1]-t[1])*r[1]+(n[2]-t[2])*r[2];e.distance=i,e.near=i-n[3],e.far=i+n[3]})),this._items.sort(((e,t)=>e.distance-t.distance))}forEachInDepthRange(e,t,r){if(t===l.DepthOrder.FRONT_TO_BACK)for(let n=0;n<this._items.length;++n){const t=this._items.data[n];t.far<e.near||t.near>e.far||r(t.object,t.near,t.far)}else for(let n=this._items.length-1;n>=0;--n){const t=this._items.data[n];t.far<e.near||t.near>e.far||r(t.object,t.near,t.far)}}}class y{constructor(){this._view=n.create(),this._viewProj=n.create(),this._frustum=o.create(),this._geometries=new Array,this._near=[],this._far=[],this._nearCandidates=[],this._farCandidates=[],this._looseRange={near:0,far:0}}compute(e,t){this._reset(),r.copy(this._view,e.viewMatrix),r.multiply(this._viewProj,e.projectionMatrix,this._view),o.copy(this._frustum,e.frustum);const n=this._view,i=n[2],a=n[6],s=n[10],h=n[14];t.forAll((e=>{e.forEachGeometry((e=>{if(!e.visible||!e.castShadow)return;const t=e.boundingSphere,r=i*t[0]+a*t[1]+s*t[2]+h,n=r-t[3],o=r+t[3];this._geometries.push(e),this._near.push(-o),this._far.push(-n)}))}));const f=new c.DepthRange;if(0===this._geometries.length)return f;for(let r=0;r<this._geometries.length;++r)this._near[r]>f.far&&(f.far=this._near[r]),this._near[r]>2&&this._far[r]<f.near&&(f.near=this._far[r]);const l=this._looseRange;l.near=Math.max(.5*f.near,2),l.far=2*f.far;let u=0,_=0;for(let r=0;r<this._geometries.length;++r)this._near[r]<f.near&&(this._near[r]>=l.near?f.near=this._near[r]:this._nearCandidates[u++]=r),this._far[r]>f.far&&(this._far[r]<=l.far?f.far=this._far[r]:this._farCandidates[_++]=r);if(0===this._nearCandidates.length&&0===this._farCandidates.length)return f;this._nearCandidates.sort(((e,t)=>this._near[e]<this._near[t]?-1:this._near[e]>this._near[t]?1:0)),this._farCandidates.sort(((e,t)=>this._far[e]<this._far[t]?1:this._far[e]>this._far[t]?-1:0));for(let r=0;r<this._nearCandidates.length;++r){const e=this._nearCandidates[r];if(this._near[e]<f.near){const t=this._geometries[e],r=t.boundingInfo;this._includeNearBoundingInfoRec(r,t.shaderTransformation,f)}}for(let r=0;r<this._farCandidates.length;++r){const e=this._farCandidates[r];if(this._far[e]>f.far){const t=this._geometries[e],r=t.boundingInfo;this._includeFarBoundingInfoRec(r,t.shaderTransformation,f)}}return this._reset(),f}_reset(){this._geometries.length=0,this._near.length=0,this._far.length=0,this._nearCandidates.length=0,this._farCandidates.length=0}_includeNearBoundingInfoRec(e,t,r){if(null==e)return;const n=e.center;i.transformMat4(h.getCenter(T),n,t);const a=f.maxScale(t),s=T[0],o=T[1],c=T[2],l=e.radius*a,u=this._frustum;if(u[0][0]*s+u[0][1]*o+u[0][2]*c+u[0][3]>l||u[1][0]*s+u[1][1]*o+u[1][2]*c+u[1][3]>l||u[2][0]*s+u[2][1]*o+u[2][2]*c+u[2][3]>l||u[3][0]*s+u[3][1]*o+u[3][2]*c+u[3][3]>l)return;const _=this._view[2]*s+this._view[6]*o+this._view[10]*c+this._view[14],m=_+l;if(!(-(_-l)<2||-m>=r.near))if(-m>this._looseRange.near)r.near=-m;else{if(l>d){const n=e.getChildren();if(void 0!==n){for(const e of n)this._includeNearBoundingInfoRec(e,t,r);return}}W.unionDepthRangeWithAABB(r,this._viewProj,t,e.bbMin,e.bbMax)}}_includeFarBoundingInfoRec(e,t,r){if(null==e)return;let n=e.radius;const a=e.center;i.transformMat4(h.getCenter(T),a,t);const s=f.maxScale(t),o=T[0],c=T[1],l=T[2];n*=s;const u=this._frustum;if(u[0][0]*o+u[0][1]*c+u[0][2]*l+u[0][3]>n||u[1][0]*o+u[1][1]*c+u[1][2]*l+u[1][3]>n||u[2][0]*o+u[2][1]*c+u[2][2]*l+u[2][3]>n||u[3][0]*o+u[3][1]*c+u[3][2]*l+u[3][3]>n)return;const _=this._view[2]*o+this._view[6]*c+this._view[10]*l+this._view[14]-n;if(!(-_<=r.far))if(-_<this._looseRange.far)r.far=-_;else{if(n>d){const n=e.getChildren();if(void 0!==n){for(const e of n)this._includeFarBoundingInfoRec(e,t,r);return}}W.unionDepthRangeWithAABB(r,this._viewProj,t,e.bbMin,e.bbMax)}}}class B{constructor(){this._modelViewProj=n.create(),this._clipPosition=[s.create(),s.create(),s.create(),s.create(),s.create(),s.create(),s.create(),s.create()]}unionDepthRangeWithAABB(e,t,n,i,a){const s=this._modelViewProj;r.multiply(s,t,n);let o=!1;for(let r=0;r<8;++r){const e=this._clipPosition[r],t=0===r||3===r||4===r||7===r?i[0]:a[0],n=0===r||1===r||4===r||5===r?i[1]:a[1],o=r<4?i[2]:a[2];e[0]=s[0]*t+s[4]*n+s[8]*o+s[12],e[1]=s[1]*t+s[5]*n+s[9]*o+s[13],e[2]=s[2]*t+s[6]*n+s[10]*o+s[14],e[3]=s[3]*t+s[7]*n+s[11]*o+s[15]}for(let r=0;r<12;++r){const t=x(this._clipPosition[F[r][0]],this._clipPosition[F[r][1]],this._clipPosition[F[r][2]]);let n=!0;for(let e=0;e<t.length;++e){if(t[e][3]>=2){n=!1;break}}if(!n){o=!0;for(let r=0;r<t.length;++r){const n=t[r][3];Number.isFinite(n)&&(e.near=Math.min(n,e.near),e.far=Math.max(n,e.far))}}}return o}}function x(e,t,r){let n=[e,t,r];for(let i=0;i<4;++i){const e=n;n=[];for(let t=0;t<e.length;++t){const r=e[t],a=e[(t+1)%e.length];D(a,i)?(D(r,i)||n.push(j(r,a,i)),n.push(a)):D(r,i)&&n.push(j(r,a,i))}}return n}function D(e,t){return 0===t?e[0]>=-e[3]:1===t?e[1]>=-e[3]:2===t?e[0]<=e[3]:3===t?e[1]<=e[3]:void u.assert(!1)}function j(e,t,r){let n=0;return 0===r?n=(-e[3]-e[0])/(t[0]-e[0]+t[3]-e[3]):1===r?n=(-e[3]-e[1])/(t[1]-e[1]+t[3]-e[3]):2===r?n=(e[3]-e[0])/(t[0]-e[0]-t[3]+e[3]):3===r&&(n=(e[3]-e[1])/(t[1]-e[1]-t[3]+e[3])),a.lerp(s.create(),e,t,n)}const F=[[0,1,3],[2,3,1],[1,5,2],[6,2,5],[5,4,6],[7,6,4],[4,0,7],[3,7,0],[3,2,7],[6,7,2],[4,5,0],[1,0,5]],T=h.create(),S=n.create(),I=c.empty(),P=new A,N=new y,W=new B;e.DepthRangeFromRenderGeometries=y,e.depthRangeFromScene=b,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
