/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../../chunks/tslib.es6","../../../../../core/Accessor","../../../../../core/arrayUtils","../../../../../core/has","../../../../../core/Logger","../../../../../core/mathUtils","../../../../../core/maybe","../../../../../core/promiseUtils","../../../../../core/accessorSupport/decorators/property","../../../../../core/accessorSupport/decorators/subclass","../../../../../core/libs/gl-matrix-2/math/mat3","../../../../../core/libs/gl-matrix-2/factories/mat3f64","../../../../../core/libs/gl-matrix-2/factories/mat4f64","../../../../../chunks/vec32","../../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../../core/support/UpdatingHandles","../../../../../chunks/sphere","../../../../../chunks/vec33","../../../../ViewingMode","../../collections/Component/Material/shader/ComponentData.glsl","../../core/util/TwoVectorPosition","../Attribute","../GridLocalOriginFactory","../localOriginHelper","../LocalOriginManager","../Object3D","../VertexArrayObject","../VertexAttribute","./bufferLayouts","./edgeBufferWriters","./EdgeRenderer","./EdgeShaderParameters","./EdgeWorkerHandle","./interfaces","./strokes","./util","../TextureBackedBuffer/BufferManager","../../shaders/sources/edgeRenderer/EdgeUtil.glsl","../../../../webgl/BufferObject","../../../../webgl/enums"],(function(e,t,r,n,s,i,o,a,c,l,d,u,g,h,f,p,m,_,b,y,O,E,w,x,M,R,v,T,j,A,V,C,L,P,S,D,B,U,I,k,q){"use strict";const H=128;function W(e){e?.vao&&(e.vao.vertexBuffers.get("instances")?.dispose(),e.vao.disposeVAOOnly(),e.vao=null)}function G(e){let t=null,r=null;for(const s of e.geometries){if(s.material.supportsEdges){if(t){if(!n.equals(t,s.transformation))return!1}else t=s.transformation;if(r||null==s.localOrigin){if(null!=r?.localOrigin&&null!=s.localOrigin&&r.localOrigin.id!==s.localOrigin.id)return!1}else r=s}}return!0}e.EdgeView=class extends r{constructor(e){super(e),this._updatingHandles=new m.UpdatingHandles,this._objectEntries=new Map,this._pendingDeletions=new Map,this._renderers=new Map,this._gpuMemoryUsage=0,this._workerAbort=new AbortController,this._tmpModelPosition=p.create(),this._localOrigins=new R.LocalOriginManager(new x.GridLocalOriginFactory(e.renderSR));const t=A.VertexLayout.createBuffer(4);for(let r=0;r<4;r++)t.sideness.set(r,0,0===r||3===r?0:1),t.sideness.set(r,1,0===r||1===r?0:1);this._verticesBufferObject=k.BufferObject.createVertex(e.rctx,q.Usage.STATIC_DRAW,t.buffer)}initialize(){this._worker=new P.EdgeWorkerHandle(this.schedule),this._componentColorManager=new U.BufferManager(this.rctx,3)}destroy(){this.destroyed||(this._objectEntries.forEach((e=>this._discardObjectEntry(e))),this._objectEntries.clear(),this._pendingDeletions.forEach((e=>this._discardObjectEntry(e))),this._pendingDeletions.clear(),this._strokesTexture=a.disposeMaybe(this._strokesTexture),this._componentColorManager=a.destroyMaybe(this._componentColorManager),this._workerAbort.abort(),this._worker.destroy(),this._verticesBufferObject.dispose(),this._renderers.clear(),this._updatingHandles.destroy(),this._set("schedule",ie))}get updating(){return this._updatingHandles.updating}get usedMemory(){return this._gpuMemoryUsage}shouldRender(){return this._renderers.size>0}async addComponentObject(e,t,r,n,s,i,o){if(this.hasObject(e))return this._getObjectMemoryUsage(e);let a;const c=new N(null,new Promise((e=>a=e)),e.obb.center,e.obb.radius);this._objectEntries.set(e,c);const l=await this._updatingHandles.addPromise(this._addComponentGeometry(e.transform,c,t,r,n,s,i,o));return this.setNeedsRender(),a(),l}async addOrUpdateObject3D(e,t,r,n){if(this.destroyed)return void i.getLogger(this).warn("Attempt to add an object to a destroyed instance");const s=new AbortController;let o;const a=e.boundingVolumeWorldSpace.bounds,l=new N(s,new Promise((e=>o=e)),_.getCenter(a),_.getRadius(a)),d=this._objectEntries.get(e);d&&(this._pendingDeletions.has(e)?this._discardObjectEntry(d):this._pendingDeletions.set(e,d)),this._objectEntries.set(e,l);try{const s=new Array;if(e.geometries.length>1&&G(e))s.push(this._addObjectMergedGeometries(e,l,t,r,n));else for(const i of e.geometries)i.material.supportsEdges&&s.push(this._addGeometry(e,l,i,t,r,n));await this._updatingHandles.addPromise(Promise.all(s)),this._removePendingDeletion(e)}catch(u){c.isAbortError(u)?this._discardObjectEntry(l):this._removePendingDeletion(e)}finally{this.setNeedsRender(),o()}}removeObject(e){const t=this._objectEntries.get(e);this._objectEntries.delete(e),this._discardObjectEntry(t),this._removePendingDeletion(e)}_removePendingDeletion(e){const t=this._pendingDeletions.get(e);this._pendingDeletions.delete(e),this._discardObjectEntry(t)}async _getObjectEntry(e){const t=this._objectEntries.get(e);if(!t)throw new Error("no object");return await t.loaded,null==t.loaded?null:t}fastUpdateObject3DEdgesTransform(e){if(this.destroyed)return!1;const t=this._objectEntries.get(e);if(!t)return!1;const{geometries:r}=e,{renderables:n}=t;if(0===r.length||0===n.length)return!0;if(n.length>1)return!1;const[s]=n,i=s.transform;if(!(i instanceof K))return!1;const[o]=r;if(o.localOrigin!==i.origin.origin)return!1;const a=h.create(),c=this._computeModelTransformWithLocalOrigin(e,o,a);return s.transform=new K(a,c),this.setNeedsRender(),!0}_discardObjectEntry(e){e&&(e.abort?.abort(),e.renderables.length&&(e.renderables.forEach((e=>this._removeRenderable(e))),this.setNeedsRender()),e.loaded=null)}hasObject(e){return this._objectEntries.has(e)}async updateAllComponentOpacities(e,t){const r=await this._updatingHandles.addPromise(this._getObjectEntry(e));if(null==r)return;const n=Array.isArray(t)?e=>t[e]:()=>t;r.renderables.forEach((e=>{const t=e.components.meta.length;for(let r=0;r<t;r++){const t=n(r),s=e.components.meta[r],i=s.index;s.material.opacity=t,e.components.buffer.textureBuffer.setDataElement(i,1,3,255*t)}this._updateTransparency(e)})),this.setNeedsRender()}async _getObjectMemoryUsage(e){const t=await this._getObjectEntry(e);return t?t.renderables.reduce(((e,t)=>e+t.statistics.gpuMemoryUsage),0):0}async updateAllComponentMaterials(e,t,r,n){const s=e instanceof v.Object3D,i=B.determineRendererType(t),o=C.EdgeRenderer.getKey(i,r,s),a=await this._updatingHandles.addPromise(this._getObjectEntry(e));null!=a&&(a.renderables.forEach((e=>{if(o!==e.rendererKey){const t=this._renderers.get(e.rendererKey),n=this._acquireRenderer(i,r,s);t.removeRenderable(e),--t.refCount,e.rendererKey=o,n.addRenderable(e)}if(Array.isArray(t))for(let r=0;r<t.length;r++)e.components.meta[r].material=t[r];else e.components.meta[0].material=t;n&&X(e.components),this._updateTransparency(e)})),this.setNeedsRender())}async updateAllVerticalOffsets(e,t){const r=await this._updatingHandles.addPromise(this._getObjectEntry(e));null!=r&&this._updateAllVerticalOffsets(r,t)}_updateAllVerticalOffsets(e,t){e.renderables.forEach((e=>{const r=e.components.meta;for(let n=0;n<r.length;n++)e.components.meta[n].verticalOffset=t?.[n]??0;X(e.components)})),this.setNeedsRender()}async updateObjectVisibility(e,t){const r=await this._updatingHandles.addPromise(this._getObjectEntry(e));r&&(r.renderables.forEach((e=>e.visible=t)),this.setNeedsRender())}render(e,t){if(null==this._componentColorManager)return;this._localOrigins.updateViewMatrices(e.camera.viewMatrix);const r=e.camera.viewInverseTransposeMatrix,n=p.create(),s=new E.TwoVectorPosition;let i=0,o=0;if(this._renderers.forEach((r=>{0!==r.refCount?(++this.techniques.precompiling,r.forEachRenderable((t=>{t.visible&&(i+=t.statistics.averageEdgeLength,o++,t.regular&&r.acquireTechnique(e,!1).release(),t.silhouette&&r.acquireTechnique(e,!0).release())}),t),--this.techniques.precompiling):this._renderers.delete(r.key)})),this._componentColorManager.garbageCollect(),this._componentColorManager.updateTextures(),0===o)return;const a=40*i/o,c=new L.EdgePassParameters(a,t);f.set(n,r[3],r[7],r[11]),s.set(n),f.copy(c.transformWorldFromViewTH,s.high),f.copy(c.transformWorldFromViewTL,s.low),u.fromMat4(c.transformViewFromCameraRelativeRS,e.camera.viewMatrix),u.transpose(se,c.transformViewFromCameraRelativeRS),u.invert(c.transformNormalViewFromGlobal,se),c.transformProjFromView=e.camera.projectionMatrix,this._updateObjectCameraDistances(e),this._renderers.forEach((t=>{Y(t,e,c),Z(t,e,c)}))}_updateTransparency(e){const t=B.determineEdgeTransparency(e.components.meta),r=B.determineObjectTransparency(e.components.meta);t===e.edgeTransparency&&r===e.objectTransparency||(e.edgeTransparency=t,e.objectTransparency=r,this._renderers.get(e.rendererKey).setRenderablesDirty())}_computeModelTransformWithLocalOrigin(e,t,r){e.getCombinedShaderTransformation(t,r);const n=null!=t.localOrigin?this._localOrigins.register(t.localOrigin):this._localOrigins.acquire(f.set(this._tmpModelPosition,r[12],r[13],r[14]));return t.localOrigin=n.origin,M.applyToModelMatrix(n.origin.vec3,r),n}_createComponentBuffers(e){if(null==this._componentColorManager)return null;const t=new Array,r=this._componentColorManager.getBuffer(e.length);for(let s=0;s<e.length;s++){const n=e[s],i=r.acquireIndex();t.push({index:i,verticalOffset:0,material:n})}const n=new F(r,t);return X(n),n}_extractEdges(e,t,r,n,s,i,o=i.length){return o<H&&(s=!0),this._worker.process({data:r,indices:i,indicesLength:o,writerSettings:t,skipDeduplicate:n},e,s)}_createRenderable(e,t,r,n,s){const i=t=>new z(new T.VertexArrayObject(this.rctx,A.vertexAttributeLocations,new Map([["vertices",A.glVertexLayout],["instances",t===I.EdgeSilhouette.REGULAR?V.RegularEdgeBufferWriter.glLayout:V.SilhouetteEdgeBufferWriter.glLayout]]),new Map([["vertices",this._verticesBufferObject],["instances",k.BufferObject.createVertex(this.rctx,q.Usage.STATIC_DRAW,t===I.EdgeSilhouette.REGULAR?e.regular.instancesData.buffer:e.silhouette.instancesData.buffer)]])),t===I.EdgeSilhouette.REGULAR?e.regular.lodInfo:e.silhouette.lodInfo),o=e.regular.lodInfo.lengths.length>0?i(I.EdgeSilhouette.REGULAR):null,a=e.silhouette.lodInfo.lengths.length>0?i(I.EdgeSilhouette.SILHOUETTE):null,c=(o?.vao.usedMemory??0)+(a?.vao.usedMemory??0);return new J(o,a,{gpuMemoryUsage:c,externalMemoryUsage:s,averageEdgeLength:e.averageEdgeLength},r,B.determineEdgeTransparency(t.meta),B.determineObjectTransparency(t.meta),t,n)}async _addGeometry(e,t,r,n,s,i){if(r.edgeIndicesLength<=0)return;const o=r.attributes.get(j.VertexAttribute.POSITION),a=h.create(),c=this._computeModelTransformWithLocalOrigin(e,r,a),l=new ne(o,a,c);return this._addPositionData(t,l,r.edgeIndicesLength,n,s,i)}async _addPositionData(e,t,r,n,s,i=!1){if(null==e.loaded)return;const o=this._createComponentBuffers([n]);if(null==o)return;const a=this._acquireRenderer(n.type,s,!0),{modelTransform:c,origin:l}=t,d=t.position.indices,u=t.position,g=u.data.length/u.size,h=A.EdgeInputBufferLayout.createBuffer(g);for(let m=0;m<g;m++)h.position.set(m,0,u.data[m*u.size]),h.position.set(m,1,u.data[m*u.size+1]),h.position.set(m,2,u.data[m*u.size+2]);B.fillComponentBufferIndices(o.meta,[0,h.componentIndex.count],h.componentIndex);const f=await this._updatingHandles.addPromise(this._extractEdges(e.abort?.signal||this._workerAbort.signal,a.writerSettings,h,!1,i,d,r));if(null==e.loaded)return;const p=this._createRenderable(f,o,new K(c,l),a.key,!1);e.renderables.push(p),a.addRenderable(p),this._gpuMemoryUsage+=p.statistics.gpuMemoryUsage}async _addComponentGeometry(e,t,r,n,s,i,o,a){if(null==t.loaded)return 0;const c=this._createComponentBuffers(i);if(null==c)return 0;const l=B.determineRendererType(i),d=this._acquireRenderer(l,o||!1,!1),u=A.EdgeInputBufferLayout.createBuffer(r.length/3);b.copy(u.position.typedBuffer,r,u.position.typedBufferStride,3),B.fillComponentBufferIndices(c.meta,s,u.componentIndex,n);const g=!0,h=d.writerSettings,f=await this._updatingHandles.addPromise(this._extractEdges(this._workerAbort.signal,h,u,g,!1,n));if(null==t.loaded)return 0;const p=this._createRenderable(f,c,e,d.key,!0);return t.renderables.push(p),d.addRenderable(p),this._updateAllVerticalOffsets(t,a),p.statistics.gpuMemoryUsage}async _addObjectMergedGeometries(e,t,r,n,s){const i=new Map;let o=0,a=0,c=null;const l=e.geometries.filter((e=>{if(e.edgeIndicesLength<=0||!e.material.supportsEdges)return!1;!c&&e.localOrigin&&(c=e);const t=e.attributes.get(j.VertexAttribute.POSITION);return a+=t.data.length/t.size,o+=e.edgeIndicesLength,!0}));if(0===l.length)return;const d=a>=65536?Uint32Array:Uint16Array,u=o?new d(o):null,g=[];let f=0;l.forEach((e=>{const t=e.attributes.get(j.VertexAttribute.POSITION),r=t.indices;let n=i.get(t.data);if(null==n){n=g.length/3;for(let e=0;e<t.data.length;e+=t.size)g.push(t.data[e]),g.push(t.data[e+1]),g.push(t.data[e+2]);i.set(t.data,n)}for(let s=0;s<e.edgeIndicesLength;s++)u[f++]=n+r[s]}));const p=c||e.geometries[0],m=h.create(),_=this._computeModelTransformWithLocalOrigin(e,p,m);for(let h=0;h<e.geometries.length;h++)e.geometries[h].localOrigin=_.origin;const b=new ne(new w.Attribute(g,u,3),m,_);await this._updatingHandles.addPromise(this._addPositionData(t,b,u.length,r,n,s))}_acquireRenderer(e,t,r){const n=C.EdgeRenderer.getKey(e,t,r);let s=this._renderers.get(n);return null==this._strokesTexture&&(this._strokesTexture=D.generateStrokesTexture(this.rctx)),s||(s=new C.EdgeRenderer(this.rctx,this.techniques,{type:e,hasSlicePlane:t,strokesTexture:this._strokesTexture,legacy:r,spherical:this.viewingMode===y.ViewingMode.Global}),this._renderers.set(n,s)),++s.refCount,s}_removeRenderable(e){W(e.regular),W(e.silhouette);const t=this._renderers.get(e.rendererKey);if(t){t.removeRenderable(e),--t.refCount,this._localOrigins.release(e.transform.origin),this._gpuMemoryUsage-=e.statistics.externalMemoryUsage?0:e.statistics.gpuMemoryUsage;for(const t of e.components.meta)e.components.buffer.releaseIndex(t.index)}}_updateObjectCameraDistances(e){const t=e.camera.eye,r=e.camera.viewForward,n=p.create(),s=e=>{f.sub(n,e.center,t);const s=f.dot(n,r),i=e.radius,o=s<-i?1/0:s<i?0:s-i;e.renderables.forEach((e=>e.distanceToCamera=o))};this._objectEntries.forEach(s),this._pendingDeletions.forEach(s)}get test(){}},t.__decorate([l.property({constructOnly:!0})],e.EdgeView.prototype,"rctx",void 0),t.__decorate([l.property({constructOnly:!0})],e.EdgeView.prototype,"renderSR",void 0),t.__decorate([l.property({constructOnly:!0})],e.EdgeView.prototype,"viewingMode",void 0),t.__decorate([l.property({constructOnly:!0})],e.EdgeView.prototype,"techniques",void 0),t.__decorate([l.property({constructOnly:!0})],e.EdgeView.prototype,"setNeedsRender",void 0),t.__decorate([l.property({constructOnly:!0})],e.EdgeView.prototype,"schedule",void 0),t.__decorate([l.property({readOnly:!0})],e.EdgeView.prototype,"_updatingHandles",void 0),t.__decorate([l.property({readOnly:!0})],e.EdgeView.prototype,"updating",null),e.EdgeView=t.__decorate([d.subclass("esri.views.3d.webgl-engine.lib.edgeRendering.EdgeView")],e.EdgeView);class N{constructor(e,t,r,n){this.abort=e,this.radius=n,this.renderables=new Array;const s=e?c.onAbortOrThrow(e.signal,(()=>e.abort())):null;this.loaded=t,this.loaded.then((()=>{null!=this.loaded&&(this.loaded=!0),this.abort=null,s?.remove()})),this.center=p.clone(r)}}class F{constructor(e,t){this.buffer=e,this.meta=t}}class z{constructor(e,t){this.vao=e,this.lod=t}}class K{constructor(e,t){this.modelMatrix=e,this.origin=t}}class J{constructor(e,t,r,n,s,i,o,a){this.regular=e,this.silhouette=t,this.statistics=r,this.transform=n,this.edgeTransparency=s,this.objectTransparency=i,this.components=o,this.rendererKey=a,this.distanceToCamera=0,this.visible=!0}}class Q extends J{}function X(e){const{meta:t,buffer:r}=e,n=new Uint8Array(4);for(let s=0;s<t.length;s++){const e=t[s].material,i=t[s].index,a=o.clamp(Math.round(e.size*C.lineWidthFractionFactor),0,255),c=o.clamp(e.extensionLength,-C.extensionLengthOffset,255-C.extensionLengthOffset)+C.extensionLengthOffset,l=255*e.opacity,d=e.color,u=255*d[0],g=255*d[1],h=255*d[2],f=255*d[3];r.textureBuffer.setData(i,0,u,g,h,f),r.textureBuffer.setData(i,1,a,c,e.type,l),O.encodeElevationOffset(t[s].verticalOffset,n),r.textureBuffer.setData(i,2,n[0],n[1],n[2],n[3])}}function Y(e,t,r){let n,s;const i=r.transparency,o=t.camera.perScreenPixelRatio;e.forEachRenderable((i=>{if(!$(i)||!i.visible)return;n??=e.acquireTechnique(t,!1),s??=e.rctx.bindTechnique(n,t,r);const a=re(i.regular.lod.lengths,i.distanceToCamera,o);e.renderRegularEdges(s,i,r,t,a)}),i),n?.release()}function Z(e,t,r){let n,s;const i=r.transparency,o=t.camera.perScreenPixelRatio;e.forEachRenderable((i=>{if(!te(i)||!i.visible)return;n??=e.acquireTechnique(t,!0),s??=e.rctx.bindTechnique(n,t,r);const a=re(i.silhouette.lod.lengths,i.distanceToCamera,o);e.renderSilhouetteEdges(s,i,r,t,a)}),i),n?.release()}function $(e){return null!=e.regular}class ee extends J{}function te(e){return null!=e.silhouette}function re(e,t,r){const s=t*r,i=n.binaryIndexOf(e,s,!0);return-1===i?s<e[0]?e.length:0:e.length-i}class ne{constructor(e,t,r){this.position=e,this.modelTransform=t,this.origin=r}}const se=g.create(),ie=()=>Promise.reject();e.LegacyTransform=K,e.RegularRenderable=Q,e.Renderable=J,e.SilhouetteRenderable=ee,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
