/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../../chunks/tslib.es6","../../../../../core/arrayUtils","../../../../../core/Error","../../../../../core/MapUtils","../../../../../core/maybe","../../../../../core/promiseUtils","../../../../../core/accessorSupport/decorators/property","../../../../../core/has","../../../../../core/Logger","../../../../../core/accessorSupport/decorators/subclass","../../../../../core/libs/gl-matrix-2/factories/mat4f64","../../../../../chunks/vec32","../../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../../core/libs/gl-matrix-2/factories/vec4f64","../../../support/debugFlags","../../../support/buffer/glUtil","../../../support/buffer/InterleavedLayout","../../../webgl/RenderCamera","../../core/shaderLibrary/ShaderOutput","../../effects/RenderPlugin","../DefaultVertexAttributeLocations","../IntersectorInterfaces","../Octree","../RenderSlot","../Util","../VertexAttribute","./InstanceData","./InstanceOctree","./LevelSelector","./LodLevel","./RenderInstanceData","../../materials/internal/MaterialUtil","../../materials/renderers/utils","../../shaders/DefaultMaterialTechnique","../../../../support/Scheduler","../../../../webgl/Util"],(function(e,t,a,r,n,s,i,o,l,c,d,h,u,_,p,g,f,I,m,y,b,R,v,C,S,A,D,E,L,T,O,x,M,F,N,V,w){"use strict";const U=e=>{const t=e.baseBoundingSphere.radius,a=e.levels.map((e=>e.minScreenSpaceRadius));return new T.LevelSelector(t,a)};function H(e,t,a){const r=e.allocateHead();B(t,a,e.view,r)}function B(e,t,a,r){F.encodeDoubleVec3(e.modelOrigin,t,a.modelOriginHi,a.modelOriginLo,r),a.model.copyFrom(r,e.model,t),a.modelNormal.copyFrom(r,e.modelNormal,t),e.color&&a.color&&a.color.copyFrom(r,e.color,t),e.objectAndLayerIdColor&&a.objectAndLayerIdColor&&a.objectAndLayerIdColor.copyFrom(r,e.objectAndLayerIdColor,t),e.featureAttribute&&a.featureAttribute&&a.featureAttribute.copyFrom(r,e.featureAttribute,t)}function G(e){let t=I.newLayout().vec3f(D.VertexAttribute.INSTANCEMODELORIGINHI).vec3f(D.VertexAttribute.INSTANCEMODELORIGINLO).mat3f(D.VertexAttribute.INSTANCEMODEL).mat3f(D.VertexAttribute.INSTANCEMODELNORMAL);return null!=e&&e.includes("featureAttribute")&&(t=t.vec4f(D.VertexAttribute.INSTANCEFEATUREATTRIBUTE)),null!=e&&e.includes("color")&&(t=t.vec4u8(D.VertexAttribute.INSTANCECOLOR)),null!=e&&e.includes("objectAndLayerIdColor")&&(t=t.vec4u8(D.VertexAttribute.INSTANCEOBJECTANDLAYERIDCOLOR)),t}e.LodRenderer=class extends b.AsyncRenderPlugin{constructor(e,t){super(e),this.type=v.IntersectorType.LOD,this.isGround=!1,this._levels=[],this._defaultRenderInstanceData=new Array,this._highlightRenderInstanceDataMap=new Map,this._instanceIndex=0,this._cycleStartIndex=0,this._slicePlane=!1,this._camera=new m,this._updateCyclesWithStaticCamera=-1,this._needFullCycle=!1,this.produces=new Map([[S.RenderSlot.OPAQUE_MATERIAL,e=>this._produces(e)],[S.RenderSlot.TRANSPARENT_MATERIAL,e=>!!this._hasTransparentLevels()&&this._produces(e)]]),this._instanceData=new E.InstanceData({shaderTransformation:e.shaderTransformation},e.optionalFields),this.addHandles(t.registerTask(V.TaskPriority.LOD_RENDERER,this))}initialize(){this._instanceBufferLayout=G(this.optionalFields),this._glInstanceBufferLayout=f.glLayout(this._instanceBufferLayout,1),this.addHandles([this._instanceData.events.on("instances-changed",(()=>this._requestUpdateCycle())),this._instanceData.events.on("instance-transform-changed",(({index:e})=>{this._requestUpdateCycle(),this.metadata.notifyGraphicGeometryChanged(e)})),this._instanceData.events.on("instance-visibility-changed",(({index:e})=>{this._requestUpdateCycle(!0),this.metadata.notifyGraphicVisibilityChanged(e)})),this._instanceData.events.on("instance-highlight-changed",(()=>this._requestUpdateCycle(!0)))])}get _allRenderInstanceData(){const e=[this._defaultRenderInstanceData];for(const t of this._highlightRenderInstanceDataMap)e.push(t[1]);return e}get _enableLevelSelection(){return this.symbol.levels.length>1}get levels(){return this._levels}get baseBoundingBox(){return this._levels[this._levels.length-1].boundingBox}get baseBoundingSphere(){return this._levels[this._levels.length-1].boundingSphere}get baseMaterial(){return this._levels[this._levels.length-1].components[0].material}get slicePlaneEnabled(){return this._slicePlane}set slicePlaneEnabled(e){this._slicePlane=e}get layerUid(){return this.metadata.layerUid}get instanceData(){return this._instanceData}get hasEmissions(){return this.baseMaterial.hasEmissions}get usedMemory(){return this._allRenderInstanceData.reduce(((e,t)=>t.reduce(((e,t)=>e+t.usedMemory),e)),0)}get renderStats(){const e=this._instanceData.size,t=[];return this._levels.forEach(((e,a)=>{const r=this._allRenderInstanceData[0][a].size+this._allRenderInstanceData[1][a].size,n=e.triangleCount;t.push({renderedInstances:r,renderedTriangles:r*n,trianglesPerInstance:n})})),{totalInstances:e,renderedInstances:t.reduce(((e,t)=>e+t.renderedInstances),0),renderedTriangles:t.reduce(((e,t)=>e+t.renderedTriangles),0),levels:t}}_createRenderInstanceDataArray(e=[]){const{rctx:t}=this._context.renderContext;return this.symbol.levels.map((a=>{e.push(new x.RenderInstanceData(t,this._instanceBufferLayout))})),e}async initializeRenderContext(e,t){this._context=e,this._createRenderInstanceDataArray(this._defaultRenderInstanceData);const r=await Promise.allSettled(this.symbol.levels.map((a=>O.LodLevel.create(e,a,t)))),n=r.map((e=>"fulfilled"===e.status?e.value:null)).filter(a.isSome);if(i.isAborted(t)||n.length!==r.length){n.forEach((e=>e.destroy())),i.throwIfAborted(t);for(const e of r)if("rejected"===e.status)throw e.reason}this._levels=n,this._levelSelector=U(this)}uninitializeRenderContext(){this._invalidateOctree(),this._levels.forEach((e=>e.destroy())),this._defaultRenderInstanceData.forEach((e=>e.destroy())),this._highlightRenderInstanceDataMap.forEach((e=>e.forEach((e=>e.destroy()))))}_hasTransparentLevels(){return this._levels.some((e=>e.components.some((e=>{const t=e.material.produces.get(S.RenderSlot.TRANSPARENT_MATERIAL);return t?.(y.ShaderOutput.Color)}))))}hasHighlights(){return n.someMap(this._highlightRenderInstanceDataMap,(e=>e.some((e=>e.size>0))))}_produces(e){return e!==y.ShaderOutput.Highlight&&e!==y.ShaderOutput.ShadowHighlight||this.hasHighlights()}prepareRender(e){if(!g.debugFlags.LOD_INSTANCE_RENDERER_DISABLE_UPDATES){if(this._enableLevelSelection){const t=e.bind.contentCamera.equals(this._camera);this._camera.copyFrom(e.bind.contentCamera),t||this._requestUpdateCycle()}this._needFullCycle&&(this.runTask(V.noBudget),this._needFullCycle=!1)}}acquireTechniques(e){if(!this.baseMaterial.visible||!this.baseMaterial.isVisibleForOutput(e.output))return null;const t=this._getInstanceDatas(e);if(!t)return null;const a=new Array,r=this.levels;return t.forEach((t=>r.forEach((({components:r},n)=>r.forEach((r=>a.push(this._beginComponent(e,t[n],r)))))))),a}render(e,t){const a=this._getInstanceDatas(e);if(!a||null==t)return;let r=0;e.rctx.bindVAO();const n=this.levels;a.forEach((a=>n.forEach((({components:n},s)=>n.forEach((n=>this._renderComponent(e,t[r++],a[s],n,s)))))))}_getInstanceDatas(e){const{output:t,bind:a}=e,r=t===y.ShaderOutput.Highlight,n=!r&&t!==y.ShaderOutput.ShadowHighlight,s=t!==y.ShaderOutput.ShadowExcludeHighlight;if(n)return s?this._allRenderInstanceData:[this._defaultRenderInstanceData];if(s){if(r){const{highlightGroupName:e}=a;if(!e)return null;const t=this._highlightRenderInstanceDataMap.get(e);return t?[t]:null}const e=[];for(const t of this._highlightRenderInstanceDataMap)e.push(t[1]);return e}return null}intersect(e,t,a,r){if(!this.baseMaterial.visible||null==this._octree)return;const n=_.create();u.subtract(n,r,a);const s=n=>{this._instanceData.getCombinedModelTransform(n,z),e.transform.set(z),u.transformMat4(j,a,e.transform.inverse),u.transformMat4(k,r,e.transform.inverse);const s=this._instanceData.getState(n),i=this._instanceData.getLodLevel(n),o=this._levels.length;A.assert(!!(s&E.StateFlags.ACTIVE),"invalid instance state"),A.assert(i>=0&&i<o,"invaid lod level"),this._levels[i].intersect(e,t,j,k,n,this.metadata,o)};this.baseMaterial.parameters.verticalOffset?this._octree.forEach(s):this._octree.forEachAlongRay(a,n,s)}notifyShaderTransformationChanged(){this._invalidateOctree(),this._requestUpdateCycle()}get _octree(){if(null==this._octreeCached){const e=this._instanceData,t=e.view?.state;if(!t)return null;this._octreeCached=new L.InstanceOctree(e,this.baseBoundingSphere);for(let a=0;a<e.capacity;++a)t.get(a)&E.StateFlags.ACTIVE&&this._octreeCached.addInstance(a)}return this._octreeCached}_invalidateOctree(){this._octreeCached=s.destroyMaybe(this._octreeCached)}queryDepthRange(e){if(null==this._octree)return{near:1/0,far:-1/0};const t=e.viewForward,a=this._octree.findClosest(t,C.DepthOrder.FRONT_TO_BACK,e.frustum),r=this._octree.findClosest(t,C.DepthOrder.BACK_TO_FRONT,e.frustum);if(null==a||null==r)return{near:1/0,far:-1/0};const n=e.eye,s=this._instanceData.view;s.boundingSphere.getVec(a,q),u.subtract(q,q,n);const i=u.dot(q,t)-q[3];s.boundingSphere.getVec(r,q),u.subtract(q,q,n);const o=u.dot(q,t)+q[3];return{near:Math.max(e.near,i),far:Math.min(e.far,o)}}_requestUpdateCycle(e=!1){this._updateCyclesWithStaticCamera=-1,this._cycleStartIndex=this._instanceIndex,e&&(this._needFullCycle=!0,this._context.requestRender())}_startUpdateCycle(){this._updateCyclesWithStaticCamera++,this._allRenderInstanceData.forEach((e=>e.forEach((e=>e.startUpdateCycle()))))}get running(){return this._instanceData.size>0&&this._updateCyclesWithStaticCamera<1}runTask(e){const{_enableLevelSelection:t,_camera:a,_levelSelector:n}=this;this._allRenderInstanceData.forEach((e=>e.forEach((e=>e.beginUpdate()))));const s=this._instanceData,i=s.view;let o=s.size;const l=s.capacity;let c=this._instanceIndex;const d=Math.ceil(l/500);for(let h=0;h<o&&!e.done;++h){c===this._cycleStartIndex&&this._startUpdateCycle();const h=i.state.get(c);let u=0;if(!(h&E.StateFlags.ALLOCATED)){c=c+1===l?0:c+1,o++;continue}const _=i.lodLevel.get(c);if(h&E.StateFlags.DEFAULT_ACTIVE&&this._defaultRenderInstanceData[_].freeTail(),h&E.StateFlags.HIGHLIGHT_ACTIVE&&s.foreachHighlightGroupPrev(c,(e=>{const t=this._highlightRenderInstanceDataMap.get(e);if(!t)throw new r("Internal error in lodRenderer");t[_].freeTail()})),h&E.StateFlags.REMOVE)s.freeInstance(c);else if(h&E.StateFlags.VISIBLE){let e=0;t&&(i.modelOrigin.getVec(c,P),e=n.selectLevel(P,s.getCombinedMedianScaleFactor(c),a)),u=h&~(E.StateFlags.ACTIVE|E.StateFlags.TRANSFORM_CHANGED),e>=0&&(h&E.StateFlags.HIGHLIGHT?(s.foreachHighlightGroup(c,(t=>{let a=this._highlightRenderInstanceDataMap.get(t);if(a||(a=this._createRenderInstanceDataArray(),a.forEach((e=>e.beginUpdate())),this._highlightRenderInstanceDataMap.set(t,a)),e>=a.length)throw new r(`LodRenderer internal error - missing lodLevel ${e}`);H(a[e],i,c)})),u|=E.StateFlags.HIGHLIGHT_ACTIVE):(H(this._defaultRenderInstanceData[e],i,c),u|=E.StateFlags.DEFAULT_ACTIVE)),i.state.set(c,u),i.lodLevel.set(c,e)}else u=h&~(E.StateFlags.ACTIVE|E.StateFlags.TRANSFORM_CHANGED),i.state.set(c,u);if(null!=this._octreeCached){const e=!!(h&E.StateFlags.ACTIVE),t=!!(u&E.StateFlags.ACTIVE);!e&&t?this._octreeCached.addInstance(c):e&&!t?this._octreeCached.removeInstance(c):e&&t&&h&E.StateFlags.TRANSFORM_CHANGED&&(this._octreeCached.removeInstance(c),this._octreeCached.addInstance(c))}c=c+1===l?0:c+1,c%d==0&&e.madeProgress()}this._instanceIndex=c,this._allRenderInstanceData.forEach((e=>e.forEach((e=>e.endUpdate())))),this._context.requestRender()}_beginComponent(e,t,a){if(0===t.size)return null;const r=a.glMaterials.load(e.rctx,e.bind.slot,e.output);return r?.beginSlot(e.bind)}_renderComponent(e,t,a,r,n){if(!t)return;const{bind:s,rctx:i}=e;i.runAppleAmdDriverHelper();const o=i.bindTechnique(t,s,r.material.parameters,K);i.bindVAO(r.vao),t.ensureAttributeLocations(r.vao),g.debugFlags.LOD_INSTANCE_RENDERER_COLORIZE_BY_LEVEL&&e.output===y.ShaderOutput.Color&&(o.setUniform4fv("externalColor",W[Math.min(n,W.length-1)]),o.setUniform1i("colorMixMode",M.colorMixModes.replace));const l=a.capacity,c=a.headIndex,d=a.tailIndex,h=a.firstIndex,u=this._glInstanceBufferLayout,_=(e,n)=>{w.bindVertexBufferLayout(i,R.Default3D,a.buffer,u,e),i.drawArraysInstanced(t.primitiveType,0,r.vertexCount,n-e),w.unbindVertexBufferLayout(i,R.Default3D,a.buffer,u)};r.material.parameters.transparent&&null!=h?c>d?(A.assert(h>=d&&h<=c,"invalid firstIndex"),_(h,c),_(d,h)):c<d&&(h<=c?(A.assert(h>=0&&h<=c,"invalid firstIndex"),_(h,c),_(d,l),_(0,h)):(A.assert(h>=d&&h<=l,"invalid firstIndex"),_(h,l),_(0,c),_(d,h))):c>d?_(d,c):c<d&&(_(0,c),_(d,l)),i.bindVAO(null)}},t.__decorate([o.property({constructOnly:!0})],e.LodRenderer.prototype,"symbol",void 0),t.__decorate([o.property({constructOnly:!0})],e.LodRenderer.prototype,"optionalFields",void 0),t.__decorate([o.property({constructOnly:!0})],e.LodRenderer.prototype,"metadata",void 0),t.__decorate([o.property({constructOnly:!0})],e.LodRenderer.prototype,"shaderTransformation",void 0),t.__decorate([o.property()],e.LodRenderer.prototype,"_instanceData",void 0),t.__decorate([o.property()],e.LodRenderer.prototype,"_cycleStartIndex",void 0),t.__decorate([o.property({readOnly:!0})],e.LodRenderer.prototype,"_enableLevelSelection",null),t.__decorate([o.property()],e.LodRenderer.prototype,"_updateCyclesWithStaticCamera",void 0),t.__decorate([o.property({readOnly:!0})],e.LodRenderer.prototype,"running",null),e.LodRenderer=t.__decorate([d.subclass("esri.views.3d.webgl-engine.lib.lodRendering.LodRenderer")],e.LodRenderer);const P=_.create(),q=p.create(),z=h.create(),j=_.create(),k=_.create(),W=[p.fromValues(1,0,1,1),p.fromValues(0,0,1,1),p.fromValues(0,1,0,1),p.fromValues(1,1,0,1),p.fromValues(1,0,0,1)],K=new N.DefaultMaterialDrawParameters;Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
