/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../ViewingMode","../../support/buffer/InterleavedLayout","../core/shaderLibrary/ShaderOutput","../core/shaderLibrary/attributes/NormalAttribute.glsl","../core/shaderLibrary/output/Emissions.glsl","../core/shaderLibrary/shading/Normals.glsl","../core/shaderLibrary/shading/PhysicallyBasedRenderingParameters.glsl","../core/shaderLibrary/util/AlphaCutoff","../effects/geometry/olidUtils","../lib/basicInterfaces","../lib/GLTextureMaterial","../lib/Material","../lib/OrderIndependentTransparency","../lib/RayIntersections","../lib/RenderSlot","../lib/VertexAttribute","../lib/verticalOffsetUtils","./DefaultBufferWriter","./internal/MaterialUtil","../shaders/DefaultMaterialTechnique","../shaders/DefaultMaterialTechniqueConfiguration","../shaders/RealisticTreeTechnique"],(function(e,t,r,i,a,s,o,n,u,l,c,h,f,d,m,g,p,T,x,b,S,v,_,M,O){"use strict";class R extends m.Material{constructor(e,t){super(e,w),this.materialType="default",this.supportsEdges=!0,this.produces=new Map([[T.RenderSlot.OPAQUE_MATERIAL,e=>(s.is3DGeometryOutputMRT(e)||s.isShadowRelatedOutput(e))&&!this.parameters.transparent],[T.RenderSlot.TRANSPARENT_MATERIAL,e=>(s.is3DGeometryOutputMRT(e)||s.isShadowRelatedOutput(e))&&this.parameters.transparent&&this.parameters.writeDepth],[T.RenderSlot.TRANSPARENT_MATERIAL_WITHOUT_DEPTH,e=>(s.is3DGeometryOutput(e)||s.isShadowRelatedOutput(e))&&this.parameters.transparent&&!this.parameters.writeDepth]]),this._vertexBufferLayout=D(this.parameters),this._configuration=new M.DefaultMaterialTechniqueConfiguration(t.spherical,t.doublePrecisionRequiresObfuscation)}isVisibleForOutput(e){return e!==s.ShaderOutput.Shadow&&e!==s.ShaderOutput.ShadowExcludeHighlight&&e!==s.ShaderOutput.ShadowHighlight||this.parameters.castShadows}get visible(){const e=this.parameters;if(e.layerOpacity<c.alphaCutoff)return!1;const{hasInstancedColor:t,hasVertexColors:r,hasSymbolColors:i,vvColor:a}=e,s=t||a||i,o="replace"===e.colorMixMode,n=e.opacity>=c.alphaCutoff;if(r&&s)return o||n;const u=e.externalColor&&e.externalColor[3]>=c.alphaCutoff;return r?o?u:n:s?o||n:o?u:n}get hasEmissions(){return!!this.parameters.emissiveTextureId||!t.exactEquals(this.parameters.emissiveFactor,r.ZEROS)}getConfiguration(e,t){const r=this.parameters,{treeRendering:i,doubleSided:a,doubleSidedType:s}=r;return this._configuration.output=e,this._configuration.hasNormalTexture=!i&&!!r.normalTextureId,this._configuration.hasColorTexture=!!r.textureId,this._configuration.hasVertexTangents=!i&&r.hasVertexTangents,this._configuration.instanced=r.isInstanced,this._configuration.instancedDoublePrecision=r.instancedDoublePrecision,this._configuration.vvSize=!!r.vvSize,this._configuration.hasVerticalOffset=null!=r.verticalOffset,this._configuration.hasScreenSizePerspective=null!=r.screenSizePerspective,this._configuration.hasSlicePlane=r.hasSlicePlane,this._configuration.hasSliceHighlight=r.hasSliceHighlight,this._configuration.alphaDiscardMode=r.textureAlphaMode,this._configuration.normalType=i?o.NormalType.Attribute:r.normalType,this._configuration.transparent=r.transparent,this._configuration.writeDepth=r.writeDepth,null!=r.customDepthTest&&(this._configuration.customDepthTest=r.customDepthTest),this._configuration.hasOccludees=t.hasOccludees,this._configuration.cullFace=r.hasSlicePlane?f.CullFaceOptions.None:r.cullFace,this._configuration.terrainDepthTest=t.terrainDepthTest,this._configuration.cullAboveTerrain=t.cullAboveTerrain,this._configuration.hasModelTransformation=!i&&null!=r.modelTransformation,this._configuration.hasVertexColors=r.hasVertexColors,this._configuration.hasSymbolColors=r.hasSymbolColors,this._configuration.doubleSidedMode=i?u.NormalsDoubleSidedMode.WindingOrder:a&&"normal"===s?u.NormalsDoubleSidedMode.View:a&&"winding-order"===s?u.NormalsDoubleSidedMode.WindingOrder:u.NormalsDoubleSidedMode.None,this._configuration.instancedColor=r.hasInstancedColor,this._configuration.receiveShadows=r.receiveShadows&&r.receiveShadows,this._configuration.receiveAmbientOcclusion=r.receiveAmbientOcclusion&&null!=t.ssao,this._configuration.vvColor=!!r.vvColor,this._configuration.textureAlphaPremultiplied=!!r.textureAlphaPremultiplied,this._configuration.pbrMode=r.usePBR?r.isSchematic?l.PBRMode.Schematic:l.PBRMode.Normal:l.PBRMode.Disabled,this._configuration.hasMetallicRoughnessTexture=!i&&!!r.metallicRoughnessTextureId,this._configuration.emissionSource=i?n.EmissionSource.None:null!=r.emissiveTextureId?n.EmissionSource.Texture:r.usePBR?n.EmissionSource.Value:n.EmissionSource.None,this._configuration.hasOcclusionTexture=!i&&!!r.occlusionTextureId,this._configuration.offsetBackfaces=!(!r.transparent||!r.offsetTransparentBackfaces),this._configuration.oitPass=t.oitPass,this._configuration.enableOffset=t.camera.relativeElevation<g.OITPolygonOffsetLimit,this._configuration.snowCover=A(t),this._configuration.hasColorTextureTransform=!!r.colorTextureTransformMatrix,this._configuration.hasNormalTextureTransform=!!r.normalTextureTransformMatrix,this._configuration.hasEmissionTextureTransform=!!r.emissiveTextureTransformMatrix,this._configuration.hasOcclusionTextureTransform=!!r.occlusionTextureTransformMatrix,this._configuration.hasMetallicRoughnessTextureTransform=!!r.metallicRoughnessTextureTransformMatrix,this._configuration}intersect(e,r,a,s,o,n){if(null!=this.parameters.verticalOffset){const e=a.camera;t.set(N,r[12],r[13],r[14]);let n=null;switch(a.viewingMode){case i.ViewingMode.Global:n=t.normalize(V,N);break;case i.ViewingMode.Local:n=t.copy(V,I)}let u=0;const l=t.subtract(E,N,e.eye),c=t.length(l),h=t.scale(l,l,1/c);let f=null;this.parameters.screenSizePerspective&&(f=t.dot(n,h)),u+=v.verticalOffsetAtDistance(e,c,this.parameters.verticalOffset,f??0,this.parameters.screenSizePerspective),t.scale(n,n,u),t.transformMat3(L,n,a.transform.inverseRotation),s=t.subtract(P,s,L),o=t.subtract(C,o,L)}p.intersectTriangleGeometry(e,a,s,o,b.getVerticalOffsetObject3D(a.verticalOffset),n)}createGLMaterial(e){return new y(e)}createBufferWriter(){return new S.DefaultBufferWriter(this._vertexBufferLayout)}}class y extends d.GLTextureMaterial{constructor(e){super({...e,...e.material.parameters})}beginSlot(e){this._material.setParameters({receiveShadows:e.shadowMap.enabled});const r=this._material.parameters;this.updateTexture(r.textureId);const i=e.camera.viewInverseTransposeMatrix;return t.set(r.origin,i[3],i[7],i[11]),this._material.setParameters(this.textureBindParameters),this.acquireTechnique(r.treeRendering?O.RealisticTreeTechnique:_.DefaultMaterialTechnique,e)}}class w extends _.DefaultMaterialPassParameters{constructor(){super(...arguments),this.initTextureTransparent=!1,this.treeRendering=!1,this.hasVertexTangents=!1}}function A(e){return null!=e.weather&&e.weatherVisible&&"snowy"===e.weather.type&&"enabled"===e.weather.snowCover}function D(e){const t=a.newLayout().vec3f(x.VertexAttribute.POSITION);e.normalType===o.NormalType.Compressed?t.vec2i16(x.VertexAttribute.NORMALCOMPRESSED,{glNormalized:!0}):t.vec3f(x.VertexAttribute.NORMAL),e.hasVertexTangents&&t.vec4f(x.VertexAttribute.TANGENT);return(e.textureId||e.normalTextureId||e.metallicRoughnessTextureId||e.emissiveTextureId||e.occlusionTextureId)&&t.vec2f(x.VertexAttribute.UV0),e.hasVertexColors&&t.vec4u8(x.VertexAttribute.COLOR),e.hasSymbolColors&&t.vec4u8(x.VertexAttribute.SYMBOLCOLOR),h.olidEnabled()&&t.vec4u8(x.VertexAttribute.OBJECTANDLAYERIDCOLOR),t}const P=r.create(),C=r.create(),I=r.fromValues(0,0,1),V=r.create(),L=r.create(),N=r.create(),E=r.create();e.DefaultGLMaterial=y,e.DefaultMaterial=R,e.DefaultMaterialParameters=w,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
