/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../core/mathUtils","../../../../core/libs/gl-matrix-2/math/mat3","../../../../core/libs/gl-matrix-2/factories/mat3f64","../../../../core/libs/gl-matrix-2/math/mat4","../../../../core/libs/gl-matrix-2/factories/mat4f64","../../../../core/libs/gl-matrix-2/math/vec2","../../../../core/libs/gl-matrix-2/factories/vec2f64","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../core/libs/gl-matrix-2/factories/vec4f64","../../../../core/libs/gl-matrix-2/types/mat4","../../../../geometry/support/aaBoundingRect","../../../../geometry/support/buffer/BufferView","../../layers/support/FastSymbolUpdates","../../support/debugFlags","../../support/buffer/InterleavedLayout","../core/shaderLibrary/ShaderOutput","../core/shaderLibrary/hud/HUD.glsl","../core/shaderLibrary/util/AlphaCutoff","../effects/geometry/olidUtils","../lib/GLTextureMaterial","../lib/Material","../lib/RenderSlot","../lib/screenSizePerspectiveUtils","../lib/Util","../lib/VertexAttribute","./ScaleInfo","./internal/bufferWriterUtils","./internal/MaterialUtil","../../../../chunks/HUDMaterial.glsl","../shaders/HUDMaterialTechnique","../shaders/HUDMaterialTechniqueConfiguration"],(function(e,t,r,i,a,s,n,o,l,c,u,f,h,d,p,g,m,b,S,A,O,T,x,v,E,I,V,R,_,y,C,P,D){"use strict";class M extends x.Material{constructor(e,t){super(e,ae),this.produces=new Map([[v.RenderSlot.HUD_MATERIAL,e=>b.isColorHighlightOrOID(e)&&!this.parameters.drawInSecondSlot],[v.RenderSlot.LABEL_MATERIAL,e=>b.isColorHighlightOrOID(e)&&this.parameters.drawInSecondSlot],[v.RenderSlot.OCCLUSION_PIXELS,()=>this.parameters.occlusionTest],[v.RenderSlot.DRAPED_MATERIAL,e=>this.parameters.draped&&b.isColorHighlightOrOID(e)]]),this._visible=!0,this._configuration=new D.HUDMaterialTechniqueConfiguration(t)}getConfiguration(e,t){return this._configuration.output=e,this._configuration.hasSlicePlane=this.parameters.hasSlicePlane,this._configuration.hasVerticalOffset=!!this.parameters.verticalOffset,this._configuration.hasScreenSizePerspective=!!this.parameters.screenSizePerspective,this._configuration.screenCenterOffsetUnitsEnabled="screen"===this.parameters.centerOffsetUnits,this._configuration.hasPolygonOffset=this.parameters.polygonOffset,this._configuration.draped=this.parameters.draped,this._configuration.occlusionTestEnabled=this.parameters.occlusionTest,this._configuration.pixelSnappingEnabled=this.parameters.pixelSnappingEnabled,this._configuration.signedDistanceFieldEnabled=this.parameters.textureIsSignedDistanceField,this._configuration.sampleSignedDistanceFieldTexelCenter=this.parameters.sampleSignedDistanceFieldTexelCenter,this._configuration.hasRotation=this.parameters.hasRotation,this._configuration.vvSize=!!this.parameters.vvSize,this._configuration.vvColor=!!this.parameters.vvColor,this._configuration.occlusionPass=t.slot===v.RenderSlot.OCCLUSION_PIXELS,this._configuration.occludedFragmentFade=this.parameters.occludedFragmentFade,this._configuration.horizonCullingEnabled=this.parameters.horizonCullingEnabled,this._configuration.depthTestEnabled=this.parameters.depthEnabled||t.slot===v.RenderSlot.OCCLUSION_PIXELS,e===b.ShaderOutput.Color&&(this._configuration.debugDrawLabelBorder=!!g.debugFlags.LABELS_SHOW_BORDER),this._configuration.oitPass=t.oitPass,this._configuration.terrainDepthTest=t.terrainDepthTest,this._configuration.cullAboveTerrain=t.cullAboveTerrain,this._configuration}intersect(e,t,i,s,n,o){const{options:{selectionMode:u,hud:f,excludeLabels:h},point:d,camera:p}=i,{parameters:g}=this;if(!u||!f||h&&g.isLabel||!e.visible||!d)return;const{scaleX:m,scaleY:b}=this._getScreenScale(e,p.pixelRatio);r.fromMat4(Z,t),e.attributes.has(V.VertexAttribute.FEATUREATTRIBUTE)&&w(Z);const S=e.attributes.get(V.VertexAttribute.POSITION),A=e.attributes.get(V.VertexAttribute.SIZE),O=e.attributes.get(V.VertexAttribute.NORMAL),T=e.attributes.get(V.VertexAttribute.ROTATION),x=e.attributes.get(V.VertexAttribute.CENTEROFFSETANDDISTANCE);I.assert(S.size>=3);const v=C.calculateAnchorPosForRendering(g),R="screen"===this.parameters.centerOffsetUnits;for(let r=0;r<S.data.length/S.size;r++){const e=r*S.size;l.set(B,S.data[e],S.data[e+1],S.data[e+2]),l.transformMat4(B,B,t),l.transformMat4(B,B,p.viewMatrix);const s=r*x.size;if(l.set(J,x.data[s],x.data[s+1],x.data[s+2]),!R&&(B[0]+=J[0],B[1]+=J[1],0!==J[2])){const e=J[2];l.normalize(J,B),l.subtract(B,B,l.scale(J,J,e))}const n=r*O.size;if(l.set(H,O.data[n],O.data[n+1],O.data[n+2]),L(H,Z,p,$),this._applyVerticalOffsetTransformationView(B,$,p,U),p.applyProjection(B,q),q[0]>-1){R&&(J[0]||J[1])&&(q[0]+=J[0]*p.pixelRatio,0!==J[1]&&(q[1]+=E.applyScaleFactor(J[1],U.factorAlignment)*p.pixelRatio),p.unapplyProjection(q,B)),q[0]+=this.parameters.screenOffset[0]*p.pixelRatio,q[1]+=this.parameters.screenOffset[1]*p.pixelRatio,q[0]=Math.floor(q[0]),q[1]=Math.floor(q[1]);const e=r*A.size;re[0]=A.data[e],re[1]=A.data[e+1],E.applyPrecomputedScaleFactor(re,U.factor,re);const t=ee*p.pixelRatio;let s=0;if(g.textureIsSignedDistanceField){s=Math.min(g.outlineSize,.5*re[0])*p.pixelRatio/2}re[0]*=m,re[1]*=b;const n=r*T.size,u=g.rotation+T.data[n];if(N(d,q[0],q[1],re,t,s,u,g,v)){const e=i.ray;if(l.transformMat4(W,B,a.invert(k,p.viewMatrix)),q[0]=d[0],q[1]=d[1],p.unprojectFromRenderScreen(q,B)){const t=c.create();l.copy(t,e.direction);const r=1/l.length(t);l.scale(t,t,r);o(l.distance(e.origin,B)*r,t,-1,!0,1,W)}}}}}intersectDraped(e,t,r,i,a,s){const n=e.attributes.get(V.VertexAttribute.POSITION),o=e.attributes.get(V.VertexAttribute.SIZE),l=e.attributes.get(V.VertexAttribute.ROTATION),c=this.parameters,u=C.calculateAnchorPosForRendering(c),{scaleX:f,scaleY:h}=this._getScreenScale(e,e.screenToWorldRatio),d=te*e.screenToWorldRatio;for(let p=0;p<n.data.length/n.size;p++){const t=p*n.size,r=n.data[t],g=n.data[t+1],m=p*o.size;re[0]=o.data[m],re[1]=o.data[m+1];let b=0;if(c.textureIsSignedDistanceField){b=Math.min(c.outlineSize,.5*re[0])*e.screenToWorldRatio/2}re[0]*=f,re[1]*=h;const S=p*l.size,A=c.rotation+l.data[S];N(i,r,g,re,d,b,A,c,u)&&a(s.dist,s.normal,-1,!1)}}createBufferWriter(){return new oe}_updateScaleInfo(e,t,r){const i=this.parameters;null!=i.screenSizePerspective?E.precomputeScaleFactor(r,t,i.screenSizePerspective,e.factor):(e.factor.scale=1,e.factor.factor=0,e.factor.minScaleFactor=0),null!=i.screenSizePerspectiveAlignment?E.precomputeScaleFactor(r,t,i.screenSizePerspectiveAlignment,e.factorAlignment):(e.factorAlignment.factor=e.factor.factor,e.factorAlignment.scale=e.factor.scale,e.factorAlignment.minScaleFactor=e.factor.minScaleFactor)}applyShaderOffsetsView(e,t,r,i,a,s,n){const o=L(t,r,a,$);return this._applyVerticalGroundOffsetView(e,o,a,n),this._applyVerticalOffsetTransformationView(n,o,a,s),this._applyPolygonOffsetView(n,o,i[3],a,n),this._applyCenterOffsetView(n,i,n),n}applyShaderOffsetsNDC(e,t,r,i,a){return this._applyCenterOffsetNDC(e,t,r,i),null!=a&&l.copy(a,i),this._applyPolygonOffsetNDC(i,t,r,i),i}_applyPolygonOffsetView(e,r,i,a,s){const n=a.aboveGround?1:-1;let o=Math.sign(i);0===o&&(o=n);const c=n*o;if(this.parameters.shaderPolygonOffset<=0)return l.copy(s,e);const u=t.clamp(Math.abs(r.cosAngle),.01,1),f=1-Math.sqrt(1-u*u)/u/a.viewport[2];return c>0?l.scale(s,e,f):l.scale(s,e,1/f),s}_applyVerticalGroundOffsetView(e,t,r,i){const a=l.length(e),s=r.aboveGround?1:-1,n=r.computeRenderPixelSizeAtDist(a)*S.HUDVerticalPixelOffset,o=l.scale(B,t.normal,s*n);return l.add(i,e,o),i}_applyVerticalOffsetTransformationView(e,t,r,i){const a=this.parameters;if(!a.verticalOffset?.screenLength){if(a.screenSizePerspective||a.screenSizePerspectiveAlignment){const r=l.length(e);this._updateScaleInfo(i,r,t.cosAngle)}else i.factor.scale=1,i.factorAlignment.scale=1;return e}const s=l.length(e),n=a.screenSizePerspectiveAlignment??a.screenSizePerspective,o=y.verticalOffsetAtDistance(r,s,a.verticalOffset,t.cosAngle,n);return this._updateScaleInfo(i,s,t.cosAngle),l.scale(t.normal,t.normal,o),l.add(e,e,t.normal)}_applyCenterOffsetView(e,t,r){const i="screen"!==this.parameters.centerOffsetUnits;return r!==e&&l.copy(r,e),i&&(r[0]+=t[0],r[1]+=t[1],t[2]&&(l.normalize(H,r),l.add(r,r,l.scale(H,H,t[2])))),r}_applyCenterOffsetNDC(e,t,r,i){const a="screen"!==this.parameters.centerOffsetUnits;return i!==e&&l.copy(i,e),a||(i[0]+=t[0]/r.fullWidth*2,i[1]+=t[1]/r.fullHeight*2),i}_applyPolygonOffsetNDC(e,t,r,i){const a=this.parameters.shaderPolygonOffset;if(e!==i&&l.copy(i,e),a){const e=r.aboveGround?1:-1,s=e*Math.sign(t[3]);i[2]-=(s||e)*a}return i}set visible(e){this._visible=e}get visible(){const{color:e,outlineSize:t,outlineColor:r}=this.parameters,i=e[3]>=A.alphaCutoff||t>=A.alphaCutoff&&r[3]>=A.alphaCutoff;return this._visible&&i}createGLMaterial(e){return new F(e)}calculateRelativeScreenBounds(e,t,r=h.create()){return z(this.parameters,e,t,r),r[2]=r[0]+e[0],r[3]=r[1]+e[1],r}_getScreenScale(e,t){const r=e.attributes.get(V.VertexAttribute.FEATUREATTRIBUTE);if(null==r)return{scaleX:t,scaleY:t};const i=u.fromArray(r.data,Q);return p.evaluateModelTransformScale(K,this.parameters,i),{scaleX:K[0]*t,scaleY:K[1]*t}}}class F extends T.GLTextureMaterial{constructor(e){super({...e,...e.material.parameters})}beginSlot(e){return this.updateTexture(this._material.parameters.textureId),this._material.setParameters(this.textureBindParameters),this.acquireTechnique(P.HUDMaterialTechnique,e)}}function z(e,t,r,i){i[0]=e.anchorPosition[0]*-t[0]+e.screenOffset[0]*r,i[1]=e.anchorPosition[1]*-t[1]+e.screenOffset[1]*r}function L(e,t,i,a){return f.isMat4(t)&&(t=r.fromMat4(j,t)),l.transformMat3(a.normal,e,t),l.transformMat4(a.normal,a.normal,i.viewInverseTransposeMatrix),a.cosAngle=l.dot(G,ie),a}function w(e){const t=e[0],r=e[1],i=e[2],a=e[3],s=e[4],n=e[5],o=e[6],l=e[7],c=e[8],u=1/Math.sqrt(t*t+r*r+i*i),f=1/Math.sqrt(a*a+s*s+n*n),h=1/Math.sqrt(o*o+l*l+c*c);return e[0]=t*u,e[1]=r*u,e[2]=i*u,e[3]=a*f,e[4]=s*f,e[5]=n*f,e[6]=o*h,e[7]=l*h,e[8]=c*h,e}function N(e,r,i,a,s,o,l,c,u){let f=r-s-a[0]*u[0],h=f+a[0]+2*s,d=i-s-a[1]*u[1],p=d+a[1]+2*s;const g=c.distanceFieldBoundingBox;return c.textureIsSignedDistanceField&&null!=g&&(f+=a[0]*g[0],d+=a[1]*g[1],h-=a[0]*(1-g[2]),p-=a[1]*(1-g[3]),f-=o,h+=o,d-=o,p+=o),n.set(Y,r,i),n.rotate(X,e,Y,t.deg2rad(l)),X[0]>f&&X[0]<h&&X[1]>d&&X[1]<p}const U=new R.ScaleInfo,B=c.create(),H=c.create(),q=u.create(),G=c.create(),W=c.create(),X=o.create(),Y=o.create(),Z=i.create(),j=i.create(),k=s.create(),J=c.create(),K=c.create(),Q=u.create(),$={normal:G,cosAngle:0},ee=1,te=2,re=[0,0],ie=c.fromValues(0,0,1);class ae extends T.GLTextureMaterialBindParameters{constructor(){super(...arguments),this.renderOccluded=x.RenderOccludedFlag.Occlude,this.isDecoration=!1,this.color=u.freeze(1,1,1,1),this.polygonOffset=!1,this.anchorPosition=o.fromValues(.5,.5),this.screenOffset=[0,0],this.shaderPolygonOffset=1e-5,this.textureIsSignedDistanceField=!1,this.sampleSignedDistanceFieldTexelCenter=!1,this.outlineColor=u.freeze(1,1,1,1),this.outlineSize=0,this.rotation=0,this.hasRotation=!1,this.vvSizeEnabled=!1,this.vvSize=null,this.vvColor=null,this.vvOpacity=null,this.vvSymbolAnchor=null,this.vvSymbolRotationMatrix=null,this.hasSlicePlane=!1,this.pixelSnappingEnabled=!0,this.occlusionTest=!0,this.occludedFragmentFade=!1,this.horizonCullingEnabled=!1,this.centerOffsetUnits="world",this.drawInSecondSlot=!1,this.depthEnabled=!0,this.draped=!1,this.isLabel=!1}}const se=m.newLayout().vec3f(V.VertexAttribute.POSITION).vec3f(V.VertexAttribute.NORMAL).vec2f(V.VertexAttribute.UV0).vec4u8(V.VertexAttribute.COLOR).vec2f(V.VertexAttribute.SIZE).f32(V.VertexAttribute.ROTATION).vec4f(V.VertexAttribute.CENTEROFFSETANDDISTANCE).vec4f(V.VertexAttribute.FEATUREATTRIBUTE),ne=se.clone().vec4u8(V.VertexAttribute.OBJECTANDLAYERIDCOLOR);class oe{constructor(){this.vertexBufferLayout=O.olidEnabled()?ne:se}elementCount(e){return 6*e.get(V.VertexAttribute.POSITION).indices.length}write(e,t,r,i,a,s){_.writePosition(r.get(V.VertexAttribute.POSITION),e,a.position,s,6),_.writeNormal(r.get(V.VertexAttribute.NORMAL),t,a.normal,s,6);const n=r.get(V.VertexAttribute.UV0)?.data;let o=0,l=0,c=1,u=1;n&&n.length>=4&&(o=n[0],l=n[1],c=n[2],u=n[3]),c=Math.min(1.99999,c+1),u=Math.min(1.99999,u+1);let f=r.get(V.VertexAttribute.POSITION).indices.length,h=s;const p=a.uv0;for(let d=0;d<f;++d)p.set(h,0,o),p.set(h,1,l),h++,p.set(h,0,c),p.set(h,1,l),h++,p.set(h,0,c),p.set(h,1,u),h++,p.set(h,0,c),p.set(h,1,u),h++,p.set(h,0,o),p.set(h,1,u),h++,p.set(h,0,o),p.set(h,1,l),h++;_.writeColor(r.get(V.VertexAttribute.COLOR),4,a.color,s,6);const{data:g,indices:m}=r.get(V.VertexAttribute.SIZE);f=m.length;const b=a.size;h=s;for(let d=0;d<f;++d){const e=g[2*m[d]],t=g[2*m[d]+1];for(let r=0;r<6;++r)b.set(h,0,e),b.set(h,1,t),h++}if(_.writeBufferFloat(r.get(V.VertexAttribute.ROTATION),a.rotation,s,6),r.get(V.VertexAttribute.CENTEROFFSETANDDISTANCE)?_.writeBufferVec4(r.get(V.VertexAttribute.CENTEROFFSETANDDISTANCE),a.centerOffsetAndDistance,s,6):_.writeBufferVec4Zeros(a.centerOffsetAndDistance,s,6*f),r.get(V.VertexAttribute.FEATUREATTRIBUTE)?_.writeBufferVec4(r.get(V.VertexAttribute.FEATUREATTRIBUTE),a.featureAttribute,s,6):_.writeBufferVec4Zeros(a.featureAttribute,s,6*f),null!=i){const e=r.get(V.VertexAttribute.POSITION)?.indices;if(e){const t=e.length,r=a.getField(V.VertexAttribute.OBJECTANDLAYERIDCOLOR,d.BufferViewVec4u8);_.writeObjectAndLayerIdColor(i,r,t,s,6)}}}}e.HUDMaterial=M,e.Parameters=ae,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
