/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../support/buffer/InterleavedLayout","../core/shaderLibrary/ShaderOutput","../core/shaderLibrary/util/AlphaCutoff","../lib/GLTextureMaterial","../lib/Material","../lib/RenderSlot","../lib/VertexAttribute","./VisualVariablePassParameters","../shaders/LineMarkerTechnique","../shaders/LineMarkerTechniqueConfiguration","../shaders/RibbonLineTechniqueConfiguration"],(function(e,t,r,i,a,s,n,o,h,c,u,l,p,d){"use strict";class T extends o.Material{constructor(e){super(e,m),this._configuration=new p.LineMarkerTechniqueConfiguration,this.vertexAttributeLocations=l.vertexAttributeLocations,this.produces=new Map([[h.RenderSlot.OPAQUE_MATERIAL,e=>e===a.ShaderOutput.Highlight||a.isColor(e)&&this.parameters.renderOccluded===o.RenderOccludedFlag.OccludeAndTransparentStencil],[h.RenderSlot.OPAQUE_MATERIAL_WITHOUT_NORMALS,e=>a.isDepth(e)],[h.RenderSlot.OCCLUDER_MATERIAL,e=>a.isColorHighlightOrDepth(e)&&this.parameters.renderOccluded===o.RenderOccludedFlag.OccludeAndTransparentStencil],[h.RenderSlot.TRANSPARENT_OCCLUDER_MATERIAL,e=>a.isColorHighlightOrDepth(e)&&this.parameters.renderOccluded===o.RenderOccludedFlag.OccludeAndTransparentStencil],[h.RenderSlot.TRANSPARENT_MATERIAL,e=>a.isColor(e)&&this.parameters.writeDepth],[h.RenderSlot.TRANSPARENT_MATERIAL_WITHOUT_DEPTH,e=>a.isColor(e)&&!this.parameters.writeDepth],[h.RenderSlot.DRAPED_MATERIAL,e=>e===a.ShaderOutput.Color||e===a.ShaderOutput.Highlight]]),this._layout=this.createLayout()}getConfiguration(e,t){return this._configuration.output=e,this._configuration.space=t.slot===h.RenderSlot.DRAPED_MATERIAL?p.LineMarkerSpace.Draped:this.parameters.worldSpace?p.LineMarkerSpace.World:p.LineMarkerSpace.Screen,this._configuration.hideOnShortSegments=this.parameters.hideOnShortSegments,this._configuration.hasCap=this.parameters.cap!==d.CapType.BUTT,this._configuration.anchor=this.parameters.anchor,this._configuration.hasTip=this.parameters.hasTip,this._configuration.hasSlicePlane=this.parameters.hasSlicePlane,this._configuration.hasOccludees=t.hasOccludees,this._configuration.writeDepth=this.parameters.writeDepth,this._configuration.vvSize=!!this.parameters.vvSize,this._configuration.vvColor=!!this.parameters.vvColor,this._configuration.vvOpacity=!!this.parameters.vvOpacity,this._configuration.occluder=this.parameters.renderOccluded===o.RenderOccludedFlag.OccludeAndTransparentStencil,this._configuration.oitPass=t.oitPass,this._configuration.terrainDepthTest=t.terrainDepthTest,this._configuration.cullAboveTerrain=t.cullAboveTerrain,this._configuration}get visible(){return this.parameters.color[3]>=s.alphaCutoff}intersect(){}createLayout(){const e=i.newLayout().vec3f(c.VertexAttribute.POSITION).vec3f(c.VertexAttribute.PREVPOSITION).vec2f(c.VertexAttribute.UV0);return this.parameters.worldSpace&&e.vec3f(c.VertexAttribute.NORMAL),this.parameters.vvSize?e.f32(c.VertexAttribute.SIZEFEATUREATTRIBUTE):e.f32(c.VertexAttribute.SIZE),this.parameters.vvColor?e.f32(c.VertexAttribute.COLORFEATUREATTRIBUTE):e.vec4f(c.VertexAttribute.COLOR),this.parameters.vvOpacity&&e.f32(c.VertexAttribute.OPACITYFEATUREATTRIBUTE),e}createBufferWriter(){return new S(this._layout,this.parameters)}createGLMaterial(e){return new A(e)}}class A extends n.GLTextureMaterial{constructor(){super(...arguments),this._markerPrimitive=null}dispose(){super.dispose(),this._markerTextures.release(this._markerPrimitive),this._markerPrimitive=null}beginSlot(e){const t=this._material.parameters.markerPrimitive;return t!==this._markerPrimitive&&(this._material.setParameters({markerTexture:this._markerTextures.swap(t,this._markerPrimitive)}),this._markerPrimitive=t),this._material.setParameters(this.textureBindParameters),this.acquireTechnique(l.LineMarkerTechnique,e)}}class m extends u.VisualVariablePassParameters{constructor(){super(...arguments),this.width=0,this.color=[1,1,1,1],this.markerPrimitive="arrow",this.placement="end",this.cap=d.CapType.BUTT,this.anchor=p.LineMarkerAnchor.Center,this.hasTip=!1,this.worldSpace=!1,this.hideOnShortSegments=!1,this.writeDepth=!0,this.hasSlicePlane=!1,this.vvFastUpdate=!1,this.markerTexture=null}}class S{constructor(e,t){this.vertexBufferLayout=e,this._parameters=t}elementCount(){return"begin-end"===this._parameters.placement?12:6}write(e,r,i,a,s,n){const o=i.get(c.VertexAttribute.POSITION).data,h=o.length/3;let u=[1,0,0];const l=i.get(c.VertexAttribute.NORMAL);this._parameters.worldSpace&&null!=l&&(u=l.data);let p=1,d=0;this._parameters.vvSize?d=i.get(c.VertexAttribute.SIZEFEATUREATTRIBUTE).data[0]:i.has(c.VertexAttribute.SIZE)&&(p=i.get(c.VertexAttribute.SIZE).data[0]);let T=[1,1,1,1],A=0;this._parameters.vvColor?A=i.get(c.VertexAttribute.COLORFEATUREATTRIBUTE).data[0]:i.has(c.VertexAttribute.COLOR)&&(T=i.get(c.VertexAttribute.COLOR).data);let m=0;this._parameters.vvOpacity&&(m=i.get(c.VertexAttribute.OPACITYFEATUREATTRIBUTE).data[0]);const S=new Float32Array(s.buffer);let O=n*(this.vertexBufferLayout.stride/4);const _=(e,t,r,i)=>{if(S[O++]=e[0],S[O++]=e[1],S[O++]=e[2],S[O++]=t[0],S[O++]=t[1],S[O++]=t[2],S[O++]=r[0],S[O++]=r[1],this._parameters.worldSpace&&(S[O++]=u[0],S[O++]=u[1],S[O++]=u[2]),this._parameters.vvSize?S[O++]=d:S[O++]=p,this._parameters.vvColor)S[O++]=A;else{const e=Math.min(4*i,T.length-4);S[O++]=T[e],S[O++]=T[e+1],S[O++]=T[e+2],S[O++]=T[e+3]}this._parameters.vvOpacity&&(S[O++]=m)};let f;!function(e){e[e.ASCENDING=1]="ASCENDING",e[e.DESCENDING=-1]="DESCENDING"}(f||(f={}));const R=(r,i)=>{const a=t.set(g,o[3*r],o[3*r+1],o[3*r+2]),s=v;let n=r+i;do{t.set(s,o[3*n],o[3*n+1],o[3*n+2]),n+=i}while(t.equals(a,s)&&n>=0&&n<h);e&&(t.transformMat4(a,a,e),t.transformMat4(s,s,e)),_(a,s,[-1,-1],r),_(a,s,[1,-1],r),_(a,s,[1,1],r),_(a,s,[-1,-1],r),_(a,s,[1,1],r),_(a,s,[-1,1],r)},E=this._parameters.placement;"begin"!==E&&"begin-end"!==E||R(0,f.ASCENDING),"end"!==E&&"begin-end"!==E||R(h-1,f.DESCENDING)}}const g=r.create(),v=r.create();e.LineMarkerMaterial=T,e.Parameters=m,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
