/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../core/Logger","../../../../core/mathUtils","../../../../core/screenUtils","../../../../core/libs/gl-matrix-2/math/vec2","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../core/libs/gl-matrix-2/factories/vec4f64","../../../../geometry/support/frustum","../../../../geometry/support/lineSegment","../../../../geometry/support/plane","../core/shaderLibrary/ShaderOutput","../core/shaderLibrary/util/AlphaCutoff","../lib/GLMaterial","../lib/Material","../lib/RenderSlot","../lib/Util","../lib/VertexAttribute","./DefaultBufferWriter","./DefaultLayouts","../shaders/NativeLineTechnique","../shaders/NativeLineTechniqueConfiguration"],(function(e,t,r,i,n,a,s,o,c,l,u,d,f,g,h,m,p,b,P,y,S,A){"use strict";class x extends h.Material{constructor(e){super(e,R),this._configuration=new A.NativeLineTechniqueConfiguration,this.produces=new Map([[m.RenderSlot.OPAQUE_MATERIAL,e=>d.isColorHighlightOrOID(e)]])}getConfiguration(e,t){return this._configuration.output=e,this._configuration.hasSlicePlane=this.parameters.hasSlicePlane,this._configuration.hasVertexColors=this.parameters.hasVertexColors,this._configuration.transparent=this.parameters.color[3]<1||this.parameters.width<1,this._configuration.hasOccludees=t.hasOccludees,this._configuration}get visible(){return this.parameters.color[3]>=f.alphaCutoff}intersect(e,r,i,s,o,d){if(!i.options.selectionMode||!e.visible)return;if(!p.isTranslationMatrix(r))return void t.getLogger("esri.views.3d.webgl-engine.materials.NativeLineMaterial").error("intersection assumes a translation-only matrix");const f=e.attributes.get(b.VertexAttribute.POSITION).data,g=i.camera,h=_;n.copy(h,i.point);const m=2;a.set(w[0],h[0]-m,h[1]+m,0),a.set(w[1],h[0]+m,h[1]+m,0),a.set(w[2],h[0]+m,h[1]-m,0),a.set(w[3],h[0]-m,h[1]-m,0);for(let t=0;t<4;t++)if(!g.unprojectFromRenderScreen(w[t],U[t]))return;u.fromPoints(g.eye,U[0],U[1],j),u.fromPoints(g.eye,U[1],U[2],q),u.fromPoints(g.eye,U[2],U[3],B),u.fromPoints(g.eye,U[3],U[0],W);let P=Number.MAX_VALUE,y=0;for(let t=0;t<f.length-5;t+=3){if(N[0]=f[t]+r[12],N[1]=f[t+1]+r[13],N[2]=f[t+2]+r[14],M[0]=f[t+3]+r[12],M[1]=f[t+4]+r[13],M[2]=f[t+5]+r[14],u.signedDistance(j,N)<0&&u.signedDistance(j,M)<0||u.signedDistance(q,N)<0&&u.signedDistance(q,M)<0||u.signedDistance(B,N)<0&&u.signedDistance(B,M)<0||u.signedDistance(W,N)<0&&u.signedDistance(W,M)<0)continue;if(g.projectToRenderScreen(N,T),g.projectToRenderScreen(M,E),T[2]<0&&E[2]>0){a.subtract(v,N,M);const e=g.frustum,t=-u.signedDistance(e[c.PlaneIndex.NEAR],N)/a.dot(v,u.getNormal(e[c.PlaneIndex.NEAR]));a.scale(v,v,t),a.add(N,N,v),g.projectToRenderScreen(N,T)}else if(T[2]>0&&E[2]<0){a.subtract(v,M,N);const e=g.frustum,t=-u.signedDistance(e[c.PlaneIndex.NEAR],M)/a.dot(v,u.getNormal(e[c.PlaneIndex.NEAR]));a.scale(v,v,t),a.add(M,M,v),g.projectToRenderScreen(M,E)}else if(T[2]<0&&E[2]<0)continue;T[2]=0,E[2]=0;const e=l.distance2(l.fromPoints(T,E,I),h);e<P&&(P=e,a.copy(O,N),a.copy(C,M),y=t/3)}const S=i.rayBegin,A=i.rayEnd;if(P<m*m){let e=Number.MAX_VALUE;if(l.closestLineSegmentPoint(l.fromPoints(O,C,I),l.fromPoints(S,A,V),D)){a.subtract(D,D,S);const t=a.length(D);a.scale(D,D,1/t),e=t/a.distance(S,A)}d(e,D,y,!1)}}intersectDraped(e,t,i,n,a,s){if(!i.options.selectionMode)return;const o=e.attributes.get(b.VertexAttribute.POSITION).data,c=e.attributes.get(b.VertexAttribute.SIZE),l=c?c.data[0]:0,u=n[0],d=n[1],f=((l+1)/2+4)*e.screenToWorldRatio;let g=Number.MAX_VALUE,h=0;for(let m=0;m<o.length-5;m+=3){const e=o[m],t=o[m+1],i=u-e,n=d-t,a=o[m+3]-e,s=o[m+4]-t,c=a*i+s*n,l=a*a+s*s,f=r.clamp(c/l,0,1),p=a*f-i,b=s*f-n,P=p*p+b*b;P<g&&(g=P,h=m/3)}g<f*f&&a(s.dist,s.normal,h,!1)}createGLMaterial(e){return new L(e)}createBufferWriter(){const e=this.parameters.hasVertexColors?y.PositionColorLayout:y.PositionLayout;return new P.DefaultBufferWriter(e)}}class L extends g{beginSlot(e){return this.acquireTechnique(S.NativeLineTechnique,e)}}class R extends h.MaterialParameters{constructor(){super(...arguments),this.color=o.ONES,this.hasVertexColors=!1,this.hasSlicePlane=!1,this.width=1}}const N=s.create(),M=s.create(),v=s.create(),D=s.create(),T=i.createRenderScreenPointArray3(),E=i.createRenderScreenPointArray3(),O=s.create(),C=s.create(),I=l.create(),V=l.create(),_=s.create(),w=[i.createRenderScreenPointArray3(),i.createRenderScreenPointArray3(),i.createRenderScreenPointArray3(),i.createRenderScreenPointArray3()],U=[s.create(),s.create(),s.create(),s.create()],j=u.create(),q=u.create(),B=u.create(),W=u.create();e.NativeLineMaterial=x,e.Parameters=R,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
