/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../core/mathUtils","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../geometry/support/aaBoundingBox","../../support/buffer/InterleavedLayout","../core/shaderLibrary/ShaderOutput","../core/shaderLibrary/output/Emissions.glsl","../core/shaderLibrary/shading/Normals.glsl","../core/shaderLibrary/shading/PhysicallyBasedRenderingParameters.glsl","../core/shaderLibrary/util/AlphaCutoff","../effects/geometry/olidUtils","../lib/GLMaterial","../lib/Material","../lib/PathGeometry","../lib/RayIntersections","../lib/RenderSlot","../lib/VertexAttribute","./DefaultBufferWriter","./PathTechnique","./PathTechniqueConfiguration"],(function(e,t,i,r,a,s,o,n,u,h,c,l,d,b,p,f,m,S,g,v,P){"use strict";class O extends b.Material{constructor(e,t){super(e,y),this._vertexBufferLayout=R(),this.vertexAttributeLocations=v.vertexAttributeLocations,this.supportsEdges=!0,this.produces=new Map([[m.RenderSlot.OPAQUE_MATERIAL,e=>(this.parameters.castShadows&&o.isShadowRelatedOutput(e)||o.is3DGeometryOutputMRT(e))&&!this.parameters.transparent],[m.RenderSlot.TRANSPARENT_MATERIAL,e=>(this.parameters.castShadows&&o.isShadowRelatedOutput(e)||o.is3DGeometryOutputMRT(e))&&this.parameters.transparent]]),this._configuration=new P.PathTechniqueConfiguration(t.spherical,t.doublePrecisionRequiresObfuscation)}get hasEmissions(){return!i.exactEquals(this.parameters.emissiveFactor,r.ZEROS)}getConfiguration(e,t){return this._configuration.output=e,this._configuration.vvSize=!!this.parameters.vvSize,this._configuration.vvColor=!!this.parameters.vvColor,this._configuration.vvOpacity=!!this.parameters.vvOpacity,this._configuration.hasSlicePlane=this.parameters.hasSlicePlane,this._configuration.transparent=this.parameters.transparent,this._configuration.hasOccludees=t.hasOccludees,o.isColorOrColorEmission(e)&&(this._configuration.doubleSidedMode=this.parameters.doubleSided&&"normal"===this.parameters.doubleSidedType?u.NormalsDoubleSidedMode.View:this.parameters.doubleSided&&"winding-order"===this.parameters.doubleSidedType?u.NormalsDoubleSidedMode.WindingOrder:u.NormalsDoubleSidedMode.None,this._configuration.receiveShadows=t.shadowMap.enabled,this._configuration.receiveAmbientOcclusion=null!=t.ssao),this._configuration.pbrMode=this.parameters.usePBR?h.PBRMode.Schematic:h.PBRMode.Disabled,this._configuration.emissionSource=this.parameters.usePBR?n.EmissionSource.Value:n.EmissionSource.None,this._configuration.oitPass=t.oitPass,this._configuration.terrainDepthTest=t.terrainDepthTest,this._configuration.cullAboveTerrain=t.cullAboveTerrain,this._configuration}isVisibleForOutput(e){return e!==o.ShaderOutput.Shadow&&e!==o.ShaderOutput.ShadowExcludeHighlight&&e!==o.ShaderOutput.ShadowHighlight||this.parameters.castShadows}get visible(){return this.parameters.opacity>=c.alphaCutoff}intersect(e,i,r,s,o,n){const u=e;if(!p.isPathGeometry(u))return;const h=u.path,c=[this.parameters.size[0],this.parameters.size[1]];if(this.parameters.vvSize){const{offset:e,factor:i,minSize:r,maxSize:a}=this.parameters.vvSize,s=h.sizeAttributeValue;c[0]*=t.clamp(e[0]+s*i[0],r[0],a[0]),c[1]*=t.clamp(e[2]+s*i[2],r[2],a[2])}const l=new f.MeshIntersectionOptions(!1,r.options.normalRequired),d=Math.max(c[0],c[1]),b=e.boundingInfo;if(null==b)return void A(h,c,s,o,l,n);const m=a.fromValues(b.bbMin[0]-d,b.bbMin[1]-d,b.bbMin[2]-d,b.bbMax[0]+d,b.bbMax[1]+d,b.bbMax[2]+d),S=[o[0]-s[0],o[1]-s[1],o[2]-s[2]],g=Math.sqrt(S[0]*S[0]+S[1]*S[1]+S[2]*S[2]),v=[g/S[0],g/S[1],g/S[2]];f.intersectAabbInvDir(m,s,v,r.tolerance)&&A(h,c,s,o,l,n)}createBufferWriter(){return new g.DefaultBufferWriter(this._vertexBufferLayout)}createGLMaterial(e){return new M(e)}}function R(){const e=s.newLayout().vec3f(S.VertexAttribute.POSITION).vec4f(S.VertexAttribute.PROFILERIGHT).vec4f(S.VertexAttribute.PROFILEUP).vec4f(S.VertexAttribute.PROFILEVERTEXANDNORMAL).vec4f(S.VertexAttribute.FEATUREVALUE);return l.olidEnabled()&&e.vec4u8(S.VertexAttribute.OBJECTANDLAYERIDCOLOR),e}class M extends d{beginSlot(e){return this.acquireTechnique(v.PathTechnique,e)}}function A(e,t,i,r,a,s){e.baked.size&&e.baked.size[0]===t[0]&&e.baked.size[1]===t[1]||e.baked.bake(t),e.baked.intersect(i,r,a,s)}class y extends v.PathPassParameters{constructor(){super(...arguments),this.doubleSided=!1,this.doubleSidedType="normal",this.castShadows=!0,this.hasSlicePlane=!1,this.transparent=!1,this.usePBR=!1}}e.Parameters=y,e.PathMaterial=O,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
