/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../core/Logger","../../../../core/mathUtils","../../../../core/screenUtils","../../../../core/libs/gl-matrix-2/math/vec2","../../../../chunks/vec32","../../../../core/libs/gl-matrix-2/factories/vec3f64","../../../../core/libs/gl-matrix-2/factories/vec4f64","../../../../geometry/support/frustum","../../../../geometry/support/lineSegment","../../../../geometry/support/plane","../../support/buffer/InterleavedLayout","../core/shaderLibrary/ShaderOutput","../core/shaderLibrary/util/AlphaCutoff","../effects/geometry/olidUtils","../lib/GLMaterial","../lib/Material","../lib/RenderSlot","../lib/Util","../lib/VertexAttribute","./VisualVariablePassParameters","../shaders/LineMarkerTechniqueConfiguration","../../../../chunks/RibbonLine.glsl","../shaders/RibbonLineTechnique","../shaders/RibbonLineTechniqueConfiguration"],(function(e,t,r,i,a,s,n,o,c,l,u,d,h,p,T,f,A,m,_,R,E,g,S,O,b){"use strict";var I;!function(e){e[e.LEFT_JOIN_START=-2]="LEFT_JOIN_START",e[e.LEFT_JOIN_END=-1]="LEFT_JOIN_END",e[e.LEFT_CAP_START=-4]="LEFT_CAP_START",e[e.LEFT_CAP_END=-5]="LEFT_CAP_END",e[e.RIGHT_JOIN_START=2]="RIGHT_JOIN_START",e[e.RIGHT_JOIN_END=1]="RIGHT_JOIN_END",e[e.RIGHT_CAP_START=4]="RIGHT_CAP_START",e[e.RIGHT_CAP_END=5]="RIGHT_CAP_END"}(I||(I={}));class P extends A.Material{constructor(e){super(e,L),this._configuration=new b.RibbonLineTechniqueConfiguration,this.vertexAttributeLocations=O.vertexAttributeLocations,this.produces=new Map([[m.RenderSlot.OPAQUE_MATERIAL,e=>h.isHighlightOrOID(e)||h.isColor(e)&&this.parameters.renderOccluded===A.RenderOccludedFlag.OccludeAndTransparentStencil],[m.RenderSlot.OPAQUE_MATERIAL_WITHOUT_NORMALS,e=>h.isDepth(e)],[m.RenderSlot.OCCLUDER_MATERIAL,e=>h.isColorHighlightOIDOrDepth(e)&&this.parameters.renderOccluded===A.RenderOccludedFlag.OccludeAndTransparentStencil],[m.RenderSlot.TRANSPARENT_OCCLUDER_MATERIAL,e=>h.isColorHighlightOIDOrDepth(e)&&this.parameters.renderOccluded===A.RenderOccludedFlag.OccludeAndTransparentStencil],[m.RenderSlot.TRANSPARENT_MATERIAL,e=>e===h.ShaderOutput.Color&&this.parameters.writeDepth&&this.parameters.renderOccluded!==A.RenderOccludedFlag.OccludeAndTransparentStencil],[m.RenderSlot.TRANSPARENT_MATERIAL_WITHOUT_DEPTH,e=>e===h.ShaderOutput.Color&&!this.parameters.writeDepth&&this.parameters.renderOccluded!==A.RenderOccludedFlag.OccludeAndTransparentStencil],[m.RenderSlot.DRAPED_MATERIAL,e=>h.is2DGeometryOutput(e)]])}getConfiguration(e,t){this._configuration.output=e,this._configuration.oitPass=t.oitPass,this._configuration.draped=t.slot===m.RenderSlot.DRAPED_MATERIAL;const r=null!=this.parameters.stipplePattern&&e!==h.ShaderOutput.Highlight;return this._configuration.stippleEnabled=r,this._configuration.stippleOffColorEnabled=r&&null!=this.parameters.stippleOffColor,this._configuration.stipplePreferContinuous=r&&this.parameters.stipplePreferContinuous,this._configuration.hasSlicePlane=this.parameters.hasSlicePlane,this._configuration.roundJoins="round"===this.parameters.join,this._configuration.capType=this.parameters.cap,this._configuration.applyMarkerOffset=null!=this.parameters.markerParameters&&y(this.parameters.markerParameters),this._configuration.hasPolygonOffset=this.parameters.hasPolygonOffset,this._configuration.writeDepth=this.parameters.writeDepth,this._configuration.vvSize=!!this.parameters.vvSize,this._configuration.vvColor=!!this.parameters.vvColor,this._configuration.vvOpacity=!!this.parameters.vvOpacity,this._configuration.innerColorEnabled=this.parameters.innerWidth>0&&null!=this.parameters.innerColor,this._configuration.falloffEnabled=this.parameters.falloff>0,this._configuration.hasOccludees=t.hasOccludees,this._configuration.occluder=this.parameters.renderOccluded===A.RenderOccludedFlag.OccludeAndTransparentStencil,this._configuration.terrainDepthTest=t.terrainDepthTest,this._configuration.cullAboveTerrain=t.cullAboveTerrain,this._configuration.wireframe=this.parameters.wireframe,this._configuration}get visible(){return this.parameters.color[3]>=p.alphaCutoff||null!=this.parameters.stipplePattern&&(this.parameters.stippleOffColor?.[3]??0)>p.alphaCutoff}intersectDraped({attributes:e,screenToWorldRatio:t},i,a,s,n,o){if(!a.options.selectionMode)return;const c=e.get(R.VertexAttribute.SIZE);let l=this.parameters.width;if(this.parameters.vvSize){const t=e.get(R.VertexAttribute.SIZEFEATUREATTRIBUTE).data[0];l*=r.clamp(this.parameters.vvSize.offset[0]+t*this.parameters.vvSize.factor[0],this.parameters.vvSize.minSize[0],this.parameters.vvSize.maxSize[0])}else c&&(l*=c.data[0]);const u=s[0],d=s[1],h=(l/2+4)*t;let p=Number.MAX_VALUE,T=0;const f=e.get(R.VertexAttribute.POSITION).data,A=x(this.parameters,e)?f.length-2:f.length-5;for(let m=0;m<A;m+=3){const e=f[m],t=f[m+1],i=(m+3)%f.length,a=u-e,s=d-t,n=f[i]-e,o=f[i+1]-t,c=n*a+o*s,l=n*n+o*o,h=r.clamp(c/l,0,1),A=n*h-a,_=o*h-s,R=A*A+_*_;R<p&&(p=R,T=m/3)}p<h*h&&n(o.dist,o.normal,T,!1)}intersect(e,i,n,o,d,h){if(!n.options.selectionMode||!e.visible)return;if(!_.isTranslationMatrix(i))return void t.getLogger("esri.views.3d.webgl-engine.materials.RibbonLineMaterial").error("intersection assumes a translation-only matrix");const p=e.attributes,T=p.get(R.VertexAttribute.POSITION).data;let f=this.parameters.width;if(this.parameters.vvSize){const e=p.get(R.VertexAttribute.SIZEFEATUREATTRIBUTE).data[0];f*=r.clamp(this.parameters.vvSize.offset[0]+e*this.parameters.vvSize.factor[0],this.parameters.vvSize.minSize[0],this.parameters.vvSize.maxSize[0])}else p.has(R.VertexAttribute.SIZE)&&(f*=p.get(R.VertexAttribute.SIZE).data[0]);const A=n.camera,m=M;a.copy(m,n.point);const E=f*A.pixelRatio/2+4*A.pixelRatio;s.set(W[0],m[0]-E,m[1]+E,0),s.set(W[1],m[0]+E,m[1]+E,0),s.set(W[2],m[0]+E,m[1]-E,0),s.set(W[3],m[0]-E,m[1]-E,0);for(let t=0;t<4;t++)if(!A.unprojectFromRenderScreen(W[t],q[t]))return;u.fromPoints(A.eye,q[0],q[1],Y),u.fromPoints(A.eye,q[1],q[2],X),u.fromPoints(A.eye,q[2],q[3],Q),u.fromPoints(A.eye,q[3],q[0],K);let g=Number.MAX_VALUE,S=0;const O=x(this.parameters,p)?T.length-2:T.length-5;for(let t=0;t<O;t+=3){D[0]=T[t]+i[12],D[1]=T[t+1]+i[13],D[2]=T[t+2]+i[14];const e=(t+3)%T.length;if(V[0]=T[e]+i[12],V[1]=T[e+1]+i[13],V[2]=T[e+2]+i[14],u.signedDistance(Y,D)<0&&u.signedDistance(Y,V)<0||u.signedDistance(X,D)<0&&u.signedDistance(X,V)<0||u.signedDistance(Q,D)<0&&u.signedDistance(Q,V)<0||u.signedDistance(K,D)<0&&u.signedDistance(K,V)<0)continue;if(A.projectToRenderScreen(D,w),A.projectToRenderScreen(V,J),w[2]<0&&J[2]>0){s.subtract(F,D,V);const e=A.frustum,t=-u.signedDistance(e[c.PlaneIndex.NEAR],D)/s.dot(F,u.getNormal(e[c.PlaneIndex.NEAR]));s.scale(F,F,t),s.add(D,D,F),A.projectToRenderScreen(D,w)}else if(w[2]>0&&J[2]<0){s.subtract(F,V,D);const e=A.frustum,t=-u.signedDistance(e[c.PlaneIndex.NEAR],V)/s.dot(F,u.getNormal(e[c.PlaneIndex.NEAR]));s.scale(F,F,t),s.add(V,V,F),A.projectToRenderScreen(V,J)}else if(w[2]<0&&J[2]<0)continue;w[2]=0,J[2]=0;const r=l.distance2(l.fromPoints(w,J,z),m);r<g&&(g=r,s.copy(B,D),s.copy(H,V),S=t/3)}const b=n.rayBegin,I=n.rayEnd;if(g<E*E){let e=Number.MAX_VALUE;if(l.closestLineSegmentPoint(l.fromPoints(B,H,z),l.fromPoints(b,I,G),U)){s.subtract(U,U,b);const t=s.length(U);s.scale(U,U,1/t),e=t/s.distance(b,I)}h(e,U,S,!1)}}get _layout(){const e=d.newLayout().vec3f(R.VertexAttribute.POSITION).vec3f(R.VertexAttribute.PREVPOSITION).vec3f(R.VertexAttribute.NEXTPOSITION).f32(R.VertexAttribute.SUBDIVISIONFACTOR).vec2f(R.VertexAttribute.UV0);return this.parameters.vvSize?e.f32(R.VertexAttribute.SIZEFEATUREATTRIBUTE):e.f32(R.VertexAttribute.SIZE),this.parameters.vvColor?e.f32(R.VertexAttribute.COLORFEATUREATTRIBUTE):e.vec4f(R.VertexAttribute.COLOR),this.parameters.vvOpacity&&e.f32(R.VertexAttribute.OPACITYFEATUREATTRIBUTE),T.olidEnabled()&&e.vec4u8(R.VertexAttribute.OBJECTANDLAYERIDCOLOR),e}createBufferWriter(){return new N(this._layout,this.parameters)}createGLMaterial(e){return new v(e)}validateParameters(e){"miter"!==e.join&&(e.miterLimit=0),null!=e.markerParameters&&(e.markerScale=e.markerParameters.width/e.width)}}class v extends f{constructor(){super(...arguments),this._stipplePattern=null}dispose(){super.dispose(),this._stippleTextures.release(this._stipplePattern),this._stipplePattern=null}beginSlot(e){const t=this._material.parameters.stipplePattern;return this._stipplePattern!==t&&(this._material.setParameters({stippleTexture:this._stippleTextures.swap(t,this._stipplePattern)}),this._stipplePattern=t),this.acquireTechnique(O.RibbonLineTechnique,e)}}class L extends E.VisualVariablePassParameters{constructor(){super(...arguments),this.width=0,this.color=o.ONES,this.join="miter",this.cap=b.CapType.BUTT,this.miterLimit=5,this.writeDepth=!0,this.hasPolygonOffset=!1,this.stippleTexture=null,this.stipplePreferContinuous=!0,this.markerParameters=null,this.markerScale=1,this.hasSlicePlane=!1,this.vvFastUpdate=!1,this.isClosed=!1,this.falloff=0,this.innerWidth=0,this.wireframe=!1}get transparent(){return this.color[3]<1||null!=this.stipplePattern&&(this.stippleOffColor?.[3]??0)<1}}class N{constructor(e,t){this.vertexBufferLayout=e,this._parameters=t,this.numJoinSubdivisions=0;const r=t.stipplePattern?1:0;switch(this._parameters.join){case"miter":case"bevel":this.numJoinSubdivisions=r;break;case"round":this.numJoinSubdivisions=S.ribbonlineNumRoundJoinSubdivisions+r}}_isClosed(e){return x(this._parameters,e)}allocate(e){return this.vertexBufferLayout.createBuffer(e)}elementCount(e){const t=2,r=e.get(R.VertexAttribute.POSITION).indices.length/2+1,i=this._isClosed(e);let a=i?2:2*t;return a+=((i?r:r-1)-(i?0:1))*(2*this.numJoinSubdivisions+4),a+=2,this._parameters.wireframe&&(a=2+4*(a-2)),a}write(e,t,r,i,a,n){const o=k,c=j,l=Z,u=r.get(R.VertexAttribute.POSITION),d=u.indices,h=u.data.length/3,p=r.get(R.VertexAttribute.DISTANCETOSTART)?.data;d&&d.length!==2*(h-1)&&console.warn("RibbonLineMaterial does not support indices");const f=r.get(R.VertexAttribute.SIZEFEATUREATTRIBUTE)?.data[0]??r.get(R.VertexAttribute.SIZE)?.data[0]??1;let A=[1,1,1,1],m=0;const _=this.vertexBufferLayout.fields.has(R.VertexAttribute.COLORFEATUREATTRIBUTE);_?m=r.get(R.VertexAttribute.COLORFEATUREATTRIBUTE).data[0]:r.has(R.VertexAttribute.COLOR)&&(A=r.get(R.VertexAttribute.COLOR).data);const E=this.vertexBufferLayout.fields.has(R.VertexAttribute.OPACITYFEATUREATTRIBUTE),g=E?r.get(R.VertexAttribute.OPACITYFEATUREATTRIBUTE).data[0]:0,S=new Float32Array(a.buffer),O=T.olidEnabled()?new Uint8Array(a.buffer):null,b=this.vertexBufferLayout.stride/4;let P=n*b;const v=P;let L=0;const N=p?(e,t,r)=>L=p[r]:(e,t,r)=>L+=s.distance(e,t),x=(e,t,r,a,s,n,o)=>{if(S[P++]=t[0],S[P++]=t[1],S[P++]=t[2],S[P++]=e[0],S[P++]=e[1],S[P++]=e[2],S[P++]=r[0],S[P++]=r[1],S[P++]=r[2],S[P++]=a,S[P++]=o,S[P++]=s,S[P++]=f,_)S[P++]=m;else{const e=Math.min(4*n,A.length-4);S[P++]=A[e],S[P++]=A[e+1],S[P++]=A[e+2],S[P++]=A[e+3]}E&&(S[P++]=g),T.olidEnabled()&&(i&&(O[4*P]=i[0],O[4*P+1]=i[1],O[4*P+2]=i[2],O[4*P+3]=i[3]),P++)};P+=b,s.set(c,u.data[0],u.data[1],u.data[2]),e&&s.transformMat4(c,c,e);const y=this._isClosed(r);if(y){const t=u.data.length-3;s.set(o,u.data[t],u.data[t+1],u.data[t+2]),e&&s.transformMat4(o,o,e)}else s.set(l,u.data[3],u.data[4],u.data[5]),e&&s.transformMat4(l,l,e),x(c,c,l,1,I.LEFT_CAP_START,0,0),x(c,c,l,1,I.RIGHT_CAP_START,0,0),s.copy(o,c),s.copy(c,l);const D=y?0:1,V=y?h:h-1;for(let T=D;T<V;T++){const t=(T+1)%h*3;s.set(l,u.data[t],u.data[t+1],u.data[t+2]),e&&s.transformMat4(l,l,e),N(o,c,T),x(o,c,l,0,I.LEFT_JOIN_END,T,L),x(o,c,l,0,I.RIGHT_JOIN_END,T,L);const r=this.numJoinSubdivisions;for(let e=0;e<r;++e){const t=(e+1)/(r+1);x(o,c,l,t,I.LEFT_JOIN_END,T,L),x(o,c,l,t,I.RIGHT_JOIN_END,T,L)}x(o,c,l,1,I.LEFT_JOIN_START,T,L),x(o,c,l,1,I.RIGHT_JOIN_START,T,L),s.copy(o,c),s.copy(c,l)}y?(s.set(l,u.data[3],u.data[4],u.data[5]),e&&s.transformMat4(l,l,e),L=N(o,c,V),x(o,c,l,0,I.LEFT_JOIN_END,D,L),x(o,c,l,0,I.RIGHT_JOIN_END,D,L)):(L=N(o,c,V),x(o,c,c,0,I.LEFT_CAP_END,V,L),x(o,c,c,0,I.RIGHT_CAP_END,V,L)),C(S,v+b,S,v,b);P=C(S,P-b,S,P,b),this._parameters.wireframe&&this._addWireframeVertices(a,v,P,b)}_addWireframeVertices(e,t,r,i){const a=new Float32Array(e.buffer,r*Float32Array.BYTES_PER_ELEMENT),s=new Float32Array(e.buffer,t*Float32Array.BYTES_PER_ELEMENT,r-t);let n=0;const o=e=>n=C(s,e,a,n,i);for(let c=0;c<s.length-1;c+=2*i)o(c),o(c+2*i),o(c+1*i),o(c+2*i),o(c+1*i),o(c+3*i)}}function C(e,t,r,i,a){for(let s=0;s<a;s++)r[i++]=e[t++];return i}function x(e,t){if(!e.isClosed)return!1;return t.get(R.VertexAttribute.POSITION).indices.length>2}function y(e){return e.anchor===g.LineMarkerAnchor.Tip&&e.hideOnShortSegments&&"begin-end"===e.placement&&e.worldSpace}const D=n.create(),V=n.create(),F=n.create(),U=n.create(),M=n.create(),w=i.createRenderScreenPointArray3(),J=i.createRenderScreenPointArray3(),B=n.create(),H=n.create(),z=l.create(),G=l.create(),k=n.create(),j=n.create(),Z=n.create(),W=[i.createRenderScreenPointArray3(),i.createRenderScreenPointArray3(),i.createRenderScreenPointArray3(),i.createRenderScreenPointArray3()],q=[n.create(),n.create(),n.create(),n.create()],Y=u.create(),X=u.create(),Q=u.create(),K=u.create();e.Parameters=L,e.RibbonLineMaterial=P,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
