/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../../chunks/tslib.es6","../../../../../core/arrayUtils","../../../../../core/has","../../../../../core/mathUtils","../../../../../core/maybe","../../../../../core/NestedMap","../../../../../core/PooledArray","../../../../../core/SetUtils","../../../../../core/accessorSupport/decorators/property","../../../../../core/Logger","../../../../../core/accessorSupport/decorators/subclass","../../../../../core/libs/gl-matrix-2/math/mat4","../../../../../core/libs/gl-matrix-2/factories/mat4f64","../../../support/buffer/glUtil","../../core/shaderLibrary/ShaderOutput","../../effects/RenderPlugin","../../lib/GLMaterials","../../lib/ModelDirtyTypes","../../lib/RenderSlot","../../lib/Util","../DrawParameters","./BufferRange","./Instance","./PerBufferData","./PerOriginData"],(function(e,t,r,i,s,a,n,o,l,u,h,d,c,f,g,m,p,y,_,b,w,v,O,S,C,A){"use strict";e.MergedRenderer=class extends p.SyncRenderPlugin{get _hasAnyHighlight(){return this._highlightGroups.size>0}constructor(e){super(e),this._dataByOrigin=new Map,this._drawParameters=new v.DrawParameters,this._highlightGroups=new Set,this.drapedPriority=0,this._produces=new Map,this._hasOccludees=!1}destroy(){this._glMaterials=a.disposeMaybe(this._glMaterials),this._dataByOrigin.forEach((e=>e.dispose())),this._dataByOrigin.clear(),this._vaoCache=null}initialize(){this.material.produces.forEach(((e,t)=>{this._produces.set(t,(t=>!(0===this._dataByOrigin.size||!(t!==m.ShaderOutput.Highlight&&t!==m.ShaderOutput.ShadowHighlight||this._hasAnyHighlight))&&e(t)))}))}initializeRenderContext(e,t){this._glMaterials=new y.GLMaterials(this.material,t??e.materials),this._bufferWriter=this.material.createBufferWriter(),this._vaoCache=e.renderContext.rctx.getVaoCache(this.material.vertexAttributeLocations,g.glLayout(this._bufferWriter.vertexBufferLayout))}uninitializeRenderContext(){}get produces(){return this._produces}get hasOccludees(){return this._hasOccludees}get hasEmissions(){return this.material.hasEmissions}get isDecoration(){return this.material.parameters.isDecoration}queryRenderOccludedState(e){return this.material.queryRenderOccludedState(e)}get numGeometries(){let e=0;return this._dataByOrigin.forEach((t=>e+=t.buffers.reduce(((e,t)=>e+t.instances.size),0))),e}get usedMemory(){let e=0;return this._dataByOrigin.forEach((t=>e+=t.buffers.reduce(((e,t)=>e+t.vao.usedMemory),0))),e}forEachGeometry(e){this._dataByOrigin.forEach((t=>t.buffers.forEach((t=>t.instances.forEach((({geometry:t})=>e(t)))))))}modify(e){this._updateGeometries(e.updates),this._addAndRemoveGeometries(e.adds,e.removes),this._updateDrawCommands()}_updateGeometries(e){const t=this._bufferWriter;if(null==t)return;const r=t.vertexBufferLayout.stride/4;for(const i of e){const e=i.renderGeometry,s=this._dataByOrigin.get(e.localOrigin.id),a=s?.findBuffer(e.id);if(null==a)return;const n=a.instances.get(e.id);if(i.updateType&(_.DirtyState.GEOMETRY|_.DirtyState.TRANSFORMATION)){const i=T(t.elementCount(n.geometry.geometry.attributes)*r),s=t.vertexBufferLayout.createView(i.buffer);this._writeGeometry(e,s,0),a.vao.vertexBuffers.get("geometry").setSubData(i,n.from*r,0,n.numElements*r)}i.updateType&(_.DirtyState.HIGHLIGHT|_.DirtyState.OCCLUDEE|_.DirtyState.VISIBILITY)&&(a.drawCommandsDirty=!0)}}_computeDeltas(e,t){const r=new n.NestedMap;for(const i of e){const e=i.localOrigin;if(null==e)continue;let t=r.get(e.id,null);null==t&&(t=new R(e.vec3),r.set(e.id,null,t)),t.changes.push(i)}for(const i of t){const e=i.localOrigin;if(null==e)continue;const t=this._dataByOrigin.get(e.id),s=t?.findBuffer(i.id);if(null==s)continue;let a=r.get(e.id,s);null==a&&(a=new R(e.vec3),r.set(e.id,s,a)),a.changes.push(i)}return r}_addAndRemoveGeometries(e,t){if(null==this._bufferWriter||null==this._vaoCache)return;const{_bufferWriter:i,_dataByOrigin:s}=this,a=i.vertexBufferLayout.stride/4,n=this._computeDeltas(e,t);n.forEach(((e,t)=>{const o=e.get(null),l=o?.changes??[];n.delete(t,null);let u=s.get(t);if(e.forEach(((e,o)=>{if(n.delete(t,o),null==o)return void w.assert(!1,"No VAO for removed geometries");if(o.instances.size===e.changes.length)return this._vaoCache.deleteVao(o.vao),r.removeUnordered(u.buffers,o),void(0===u.buffers.length&&0===l.length&&s.delete(t));const h=o.numElements,d=o.vao.byteSize/4,c=l.reduce(((e,t)=>e+i.elementCount(t.geometry.attributes)),0),f=e.changes.reduce(((e,t)=>e+i.elementCount(t.geometry.attributes)),0),g=Math.min((h+c-f)*a,I),m=g>d;g>x&&g<d/2?(e.changes.forEach((({id:e})=>o.deleteInstance(e))),o.instances.forEach((({geometry:e})=>l.push(e))),this._vaoCache.deleteVao(o.vao),r.removeUnordered(u.buffers,o)):m?this._applyAndRebuild(o,l,e):this._applyRemoves(o,e)})),l.length>0)for(null==u&&(u=new A.PerOriginData(o.origin),s.set(t,u)),u.buffers.forEach((e=>this._applyAdds(e,l)));l.length>0;)u.buffers.push(this._applyAndRebuild(new C.PerBufferData,l,null))}))}_updateDrawCommands(){this._highlightGroups.clear(),this._hasOccludees=!1,this._dataByOrigin.forEach((e=>{e.buffers.forEach((e=>{e.updateIfDrawCommandsDirty(this._bufferWriter.vertexBufferLayout.stride),e.hasHighlights&&l.addMany(this._highlightGroups,e.highlightGroups),this._hasOccludees=this._hasOccludees||e.hasOccludees}))}))}_applyAndRebuild(e,t,r){if(r)for(const f of r.changes)e.deleteInstance(f.id);const i=this._bufferWriter,s=i.vertexBufferLayout.stride,a=s/4,n=Math.floor(I/a);let o=e.numElements;for(;t.length>0;){const r=t.pop(),s=i.elementCount(r.geometry.attributes);if(o+s>n&&o>0){t.push(r);break}o+=s;const a=new S.Instance(r,0,0);w.assert(null==e.instances.get(r.id)),e.addInstance(r.id,a)}const l=o*a,u=T(l),h=i.vertexBufferLayout.createView(u.buffer);let d=0;e.resetInstanceSummary(),e.instances.forEach(((t,r)=>{this._writeGeometry(t.geometry,h,d);const s=d;d+=i.elementCount(t.geometry.geometry.attributes),e.updateInstance(r,s,d),e.updateDrawState(t)})),this._vaoCache.deleteVao(e.vao),e.vao=this._vaoCache.newVao(z(l)),e.vao.vertexBuffers.get("geometry").setSubData(u,0,0,d*a),e.holes.clear();const c=e.holes.pushNew();return c.from=d,c.to=Math.floor(e.vao.byteSize/s),e.updateDrawCommands(s),e}_applyRemoves(e,t){if(0===t.changes.length||null==this._bufferWriter)return;for(const n of t.changes){const t=n.id,r=e.instances.get(t);if(!r)continue;e.deleteInstance(t);const i=M.back();if(i){if(i.to===r.from){i.to=r.to;continue}if(i.from===r.to){i.from=r.from;continue}}const s=M.pushNew();s.from=r.from,s.to=r.to}O.mergeAdjacentRanges(M);const r=this._bufferWriter.vertexBufferLayout.stride/4,i=M.reduce(((e,t)=>Math.max(e,t.numElements)),0)*r,s=T(i);s.fill(0,0,i);const a=e.vao.vertexBuffers.get("geometry");M.forAll((e=>a.setSubData(s,e.from*r,0,e.numElements*r))),e.holes.pushArray(M.data,M.length),M.forAll(((e,t)=>M.data[t]=null)),M.clear(),e.drawCommandsDirty=!0}_applyAdds(e,t){if(0===t.length||null==this._bufferWriter)return;if(!C.hasVao(e))return void this._applyAndRebuild(e,t,null);const i=this._bufferWriter,s=i.vertexBufferLayout.stride/4,a=e.numElements,n=t.reduce(((e,t)=>e+i.elementCount(t.geometry.attributes)),0),o=Math.min((a+n)*s,I),l=4*o;if(e.vao.byteSize<z(I-x)&&l>e.vao.byteSize)return void this._applyAndRebuild(e,t,null);O.mergeAdjacentRanges(e.holes);const u=new Array;for(const r of t){const t=i.elementCount(r.geometry.attributes),s=D(e.holes,t);u.push(s)}const h=e.vao.vertexBuffers.get("geometry");let d=0,c=0,f=0;const g=T(o),m=i.vertexBufferLayout.createView(g.buffer);t.forEach(((t,r)=>{const a=u[r];if(null==a)return;if(!(f===a)){const e=f-c;e>0&&h.setSubData(g,c*s,0,e*s),c=a,d=0}const n=i.elementCount(t.geometry.attributes);this._writeGeometry(t,m,d),d+=n,f=a+n;const o=new S.Instance(t,a,a+n);w.assert(null==e.instances.get(t.id)),e.addInstance(t.id,o),e.drawCommandsDirty=!0}));const p=f-c;p>0&&h.setSubData(g,c*s,0,p*s),r.filterInPlace(t,((e,t)=>null==u[t]))}_writeGeometry(e,t,r){null!=this._bufferWriter&&(c.copy(E,e.transformation),E[12]-=e.localOrigin.vec3[0],E[13]-=e.localOrigin.vec3[1],E[14]-=e.localOrigin.vec3[2],c.invert(B,E),c.transpose(B,B),this._bufferWriter.write(E,B,e.geometry.attributes,e.geometry.objectAndLayerIdColor,t,r))}updateAnimation(e){return this.material.update(e)}acquireTechniques(e){if(!this.material.shouldRender(e))return null;const{output:t,bind:r}=e,i=this.material.produces.get(r.slot);if(!i?.(t))return null;const{highlightGroupName:s,slot:a}=r,n=t===m.ShaderOutput.ShadowHighlight,o=t===m.ShaderOutput.Highlight,l=o||n,u=e=>l&&(0===this._highlightGroups.size||o&&!!s&&!e.has(s));if(u(this._highlightGroups))return null;const h=t===m.ShaderOutput.ShadowExcludeHighlight,d=!(l||h);for(const{buffers:c}of this._dataByOrigin.values())for(const i of c){if(u(i.highlightGroups))continue;const o=n?i.drawCommandsHighlights.size>0:l?s?i.drawCommandsHighlights.get(s):i.drawCommandsHighlights.size>0:((h&&i.needsMultipleCommands()?i.drawCommandsShadowHighlightRest:i.drawCommandsDefault)||null)?.length??!1,c=d&&i.drawCommandsOccludees||null;if(o||c?.length){const i=this._glMaterials.load(e.rctx,a,t),s=i?.beginSlot(r);if(s)return s}}return null}render(e,t){const{output:r,bind:i}=e,{slot:s,highlightGroupName:a}=i,n=r===m.ShaderOutput.Highlight;if(n&&!a)return;const o=r===m.ShaderOutput.ShadowHighlight,l=n||o,u=r===m.ShaderOutput.ShadowExcludeHighlight,h=!(l||u),d=s===b.RenderSlot.OCCLUDER_MATERIAL||s===b.RenderSlot.TRANSPARENT_OCCLUDER_MATERIAL?s:null,{rctx:c}=e;c.runAppleAmdDriverHelper();const f=c.bindTechnique(t,i,this.material.parameters);for(const g of this._dataByOrigin.values())for(const e of g.buffers){if(n&&(!e.hasHighlights||!e.drawCommandsHighlights.has(a)))continue;if(o&&!e.hasHighlights)continue;const r=()=>{const t=[];for(const r of e.drawCommandsHighlights.values())t.push(r);return t},s=l&&!o?e.drawCommandsHighlights.get(a)??null:null,m=o?r():l?s?[s]:W:(u&&e.needsMultipleCommands()?[e.drawCommandsShadowHighlightRest]:[e.drawCommandsDefault])||W,p=m.some((e=>e.length>0)),y=h&&e.drawCommandsOccludees||null;if(p||y?.length){if(this._drawParameters.origin=g.origin,f.bindDraw(i,this.material.parameters,this._drawParameters),t.ensureAttributeLocations(e.vao),c.bindVAO(e.vao),p)for(const e of m)c.setPipelineState(t.getPipeline(!1,d)),e.forAll((e=>c.drawArrays(t.primitiveType,e.first,e.count)));y?.length&&(c.setPipelineState(t.getPipeline(!0,d)),y.forAll((e=>c.drawArrays(t.primitiveType,e.first,e.count))))}}}get test(){}},t.__decorate([u.property({constructOnly:!0})],e.MergedRenderer.prototype,"material",void 0),e.MergedRenderer=t.__decorate([d.subclass("esri.views.3d.webgl-engine.materials.renderers.MergedRenderer")],e.MergedRenderer);class R{constructor(e){this.origin=e,this.changes=new Array}}function D(e,t){const r=e.find((e=>e.numElements>=t));if(null==r)return null;const i=r.from;return r.from+=t,r.from>=r.to&&e.removeUnordered(r),i}const E=f.create(),B=f.create(),M=new o({allocator:e=>e||new O.BufferRange,deallocator:null}),x=65536,G=4*x,H=1024,L=16777216,I=L/4;let P=new Float32Array(x);function T(e){return P.length<e&&(P=new Float32Array(e)),P}function z(e){const t=4*e;return t<=H?H:t<G?s.nextHighestPowerOfTwo(t):Math.max(Math.min(Math.ceil(1.5*t/G)*G,L),t)}const W=[];e.sizeForVao=z,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
