/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../chunks/tslib.es6","../../../../core/Accessor","../../../../core/Evented","../../../../core/floatRGBA","../../../../core/has","../../../../core/Logger","../../../../core/maybe","../../../../core/reactiveUtils","../../../../core/scheduling","../../../../core/time","../../../../core/accessorSupport/decorators/property","../../../../core/RandomLCG","../../../../core/accessorSupport/decorators/subclass","../../../../geometry/support/spatialReferenceUtils","../../../ViewingMode","../../environment/ChapmanAtmosphere","../../environment/CloudsComposition","../../environment/Fog","../../environment/LocalAtmosphere","../../environment/MarsAtmosphere","../collections/Component/ComponentObjectCollection","../core/shaderTechnique/ShaderTechniqueConstructionContext","../core/shaderTechnique/ShaderTechniqueRepository","../effects/geometry/ObjectAndLayerIDRenderNode","../effects/geometry/olidUtils","../effects/geometry/RenderOccludedRenderNode","../effects/haze/Haze","../effects/highlight/Highlight","../effects/highlight/ShadowHighlight","../effects/magnifier/Magnifier","../effects/smaa/SMAA","../effects/ssao/SSAO","../effects/stars/Stars","../lib/basicInterfaces","../lib/CompositingHelper","../lib/GLMaterialRepository","../lib/ObjectAndLayerIdRenderHelper","../lib/Renderer","../lib/RenderingContext","../lib/TextureRepository","../materials/markerTextureRepository","../materials/stippleTextureRepository","../materials/internal/WaterTextureRepository","./contextCache","./renderUtils","./ScreenshotManager","./testUtils","../../../support/RenderState"],(function(e,t,r,i,n,s,o,a,h,d,c,p,l,u,_,y,R,g,w,m,x,v,f,b,q,A,C,T,M,S,O,U,L,D,V,k,j,E,H,F,W,B,G,I,N,z,P,K,X){"use strict";function J(e,t){const r=(e,r)=>t.view.resourceController.memoryController.newCache(e,r),i={disabledExtensions:t.options.deactivatedWebGLExtensions||{},debugWebGLExtensions:t.options.debugWebGLExtensions||{},maxAnisotropy:8,newCache:r};if(K.contextCache.enabled){let t=Q.get(e);return t?(t.configure(i),t.ref(),t):(t=new F.RenderingContext(e,i),Q.set(e,t),t.ref(),t)}return new F.RenderingContext(e,i)}e.RenderView=class extends r{constructor(e){super({}),this.events=new i,this.waterTextures=new I.WaterTextureRepository,this.olidRenderHelper=A.olidEnabled()?new E.ObjectAndLayerIdRenderHelper:null,this._needsUpdate=!0,this._needsRender=!0,this._idleSuspend=!0,this._needsWaterReflectionUpdate=!1,this._lastAnimationUpdate=0,this._container=e.container,this._viewingMode=e.viewingMode;try{this._initializeContext(e)}catch(n){return void console.error("Failed to initialize context",n)}const{memoryController:t}=e.view.resourceController;this.stippleTextures=G.createStippleTextureRepository(this._rctx,t),this.markerTextures=B.createMarkerTextureRepository(this._rctx,t),this._techniques=new b.ShaderTechniqueRepository(new f.ShaderTechniqueConstructionContext(this._rctx,e.viewingMode,this.stippleTextures,this.waterTextures,this.markerTextures)),this._textures=new W.TextureRepository(e,this._techniques,this._rctx),this.addHandles(this._textures.events.on("changed",(e=>this.requestRender(e)))),this._materials=new j.GLMaterialRepository(this._textures,this._techniques,(()=>this.requestRender()),(()=>this.requestRender())),this._compositingHelper=new k(this._rctx,this._techniques),this.renderer=new H.Renderer(e,this._materials,this._techniques,this._rctx,this._compositingHelper,(e=>this.requestRender(e))),this.addHandles([h.watch((()=>e.view.ready),(t=>{t&&this._createRenderNodes(e.view,e.viewingMode)}),h.initial),h.watch((()=>this.waterTextures?.updating),(()=>this.requestRender()),h.initial),h.watch((()=>e.view.qualityProfile),(e=>this.renderer?.updateRenderFeatures(e)),h.syncAndInitial)]);const r={renderScene:(e,t,r,i)=>this.renderer.render(e,t,r,i),requestRenderScene:e=>this.requestRender(e),prepareOverlay:()=>e.options.screenshot.prepareOverlay(),renderOverlay:(t,r,i)=>e.options.screenshot.renderOverlay(t,r,i)};this._screenshotManager=new P.ScreenshotManager(this._rctx,r,(e=>this.events.emit("force-camera-for-screenshot",e))),this._registerFrameTask(e)}normalizeCtorArgs(){return{}}destroy(){this._container.contains(this._canvas)&&this._container.removeChild(this._canvas),this._frameTask=a.removeMaybe(this._frameTask),this._techniques=a.destroyMaybe(this._techniques),this._componentObjects=a.destroyMaybe(this._componentObjects),this._screenshotManager=a.destroyMaybe(this._screenshotManager),a.destroyMaybe(this.renderer),this._textures=a.destroyMaybe(this._textures),a.destroyMaybe(this.waterTextures),a.destroyMaybe(this.markerTextures),a.destroyMaybe(this.stippleTextures),this._canvas=null,this._container=null,this._rctx=a.destroyMaybe(this._rctx)}_createRenderNodes(e,t){new D.Stars({view:e,techniques:this._techniques}),_.isMoon(e.spatialReference)||(t===y.ViewingMode.Local?new m.LocalAtmosphere({view:e,techniques:this._techniques}):_.isMars(e.spatialReference)?new x({view:e,techniques:this._techniques}):(new R.ChapmanAtmosphere({view:e,techniques:this._techniques}),new g.CloudsComposition({view:e,techniques:this._techniques}),new T.Haze({view:e,techniques:this._techniques}),new w.Fog({view:e,techniques:this._techniques}))),new L.SSAO({view:e,isEnabled:()=>this.renderer.hasSSAO,techniques:this._techniques}),new U.SMAA({view:e,isEnabled:()=>this.renderer.hasSMAA,techniques:this._techniques}),new O.Magnifier({view:e,techniques:this._techniques}),new M.Highlight({view:e,techniques:this._techniques}),new S.ShadowHighlight({view:e,viewingMode:t,techniques:this._techniques}),new C.RenderOccludedRenderNode({view:e,techniques:this._techniques}),A.olidEnabled()&&new q.ObjectAndLayerIDRenderNode({view:e})}requestRender(e=V.RenderRequestType.UPDATE){this._needsRender=!0,e===V.RenderRequestType.UPDATE&&(this._needsUpdate=!0)}get updating(){return this._needsUpdate||this._needsWaterReflectionUpdate||this.renderer.updating||this._textures.updating||this.waterTextures.updating}get textures(){return this._textures}get techniques(){return this._techniques}get compositingHelper(){return this._compositingHelper}setIdleSuspend(e){this._idleSuspend!==e&&(this._idleSuspend=e,this.requestRender())}get renderingContext(){return this._rctx}get capabilities(){return this._rctx.capabilities}get canvas(){return this._canvas}takeScreenshot(e){return this._screenshotManager.takeScreenshot(e).then((e=>e[0]))}takeScreenshotWithOID(e){return e.objectAndLayerIdColor=!0,this._screenshotManager.takeScreenshot(e)}getAlpha(){return!!this._rctx.contextAttributes.alpha}getMinimalDepthForArea(e,t,r,i,s,o=s){const a=i.constrainWindowSize(t,r,s*i.pixelRatio,o*i.pixelRatio),h=this._ensureLinearDepthArrayBuffer(a);this.renderer.readMainDepth(a,h);const d=(e,t,r)=>n.unpackFloatRGBA(t,e)*(r[1]-r[0])+r[0];let c=Number.MAX_VALUE;for(let n=0;n<a[2]*a[3];n++){const e=d(4*n,h,i.nearFar);c>e&&e!==i.nearFar[0]&&e!==i.nearFar[1]&&(c=e)}if(e){const n=e.pickDepth(t*i.pixelRatio,r*i.pixelRatio,i);null!=n&&c>n&&n!==i.nearFar[0]&&n!==i.nearFar[1]&&(c=n)}return c===Number.MAX_VALUE?void 0:c}_ensureLinearDepthArrayBuffer(e){const t=4*e[2]*e[3];return(null==this._tmpDepthBuffer||this._tmpDepthBuffer.byteLength<t)&&(this._tmpDepthBuffer=new Uint8Array(t)),this._tmpDepthBuffer}async reloadShaders(){z.removeLoadedShaderModules(),await this._techniques.reloadAll(),this.renderer.overlay?.reloadShaders(),this.requestRender()}_registerFrameTask(e){const t=e.view.state;let r=!1,i=V.RenderRequestType.BACKGROUND,n=!1;const s={preRender:({time:n})=>{r=this.updating,i=this._needsUpdate?V.RenderRequestType.UPDATE:V.RenderRequestType.BACKGROUND,e.commitSyncLayers();(c.Milliseconds(n-this._lastAnimationUpdate)>this.renderer.animationTimestep||null!=t.forcedAnimationTime||r||this._needsRender)&&(this.renderer.updateAnimation(t,n)&&this.requestRender(V.RenderRequestType.BACKGROUND),this._lastAnimationUpdate=n)},render:({time:e})=>{if((this._needsRender||!this._idleSuspend||!this.renderer.isCameraFinal||this._needsWaterReflectionUpdate)&&t.camera.fullWidth>0&&t.camera.fullHeight>0){const r=this._needsUpdate&&this._idleSuspend&&this.renderer.isCameraFinal;this._needsRender=!1,this._needsUpdate=!1,this._needsWaterReflectionUpdate=!1,this.renderer.render(t,e),n=!0,r&&this.renderer.hasReflections&&(this.requestRender(V.RenderRequestType.BACKGROUND),this._needsWaterReflectionUpdate=!0)}},update:({time:e})=>{this._textures.update();const r=new P.ScreenshotContext(t,this.renderer.fboCache);this._screenshotManager.update(r,e)},finish:()=>{n&&(this.renderer.finish(t.mode===X.RenderState.IDLE?i:V.RenderRequestType.UPDATE),n=!1)}};this._frameTask=d.addFrameTask(s)}_initializeContext(e){const t=e.options;this._canvas=t.canvas,this._canvas||(this._canvas=document.createElement("canvas")),this._canvas.setAttribute("style","width: 100%; height:100%; display:block;");const r={alpha:t.alpha||!1,premultipliedAlpha:!0,antialias:!1,depth:!0,stencil:t.stencil??!0,powerPreference:"high-performance",preserveDrawingBuffer:t.preserveDrawingBuffer??!1},i=this._canvas.getContext("webgl2",r);null!=i?(this._rctx=J(i,e),this._loadShaderOnlyExtensions(),!t.alpha&&this._rctx.contextAttributes.alpha&&o.getLogger(this).error("WebGL context has alpha channel even though no alpha channel was requested"),!this._rctx.contextAttributes.alpha&&s("safari")>=11&&(this._container.style.backgroundColor="black"),this._container.appendChild(this._canvas)):o.getLogger(this).error("A WebGL2 context could not be created.")}_loadShaderOnlyExtensions(){this._rctx.capabilities.enable("textureFloatLinear")}getObjectAndLayerIdColor(e){return this.olidRenderHelper?.getObjectAndLayerIdColor(e)}get componentObjectCollection(){return null==this._componentObjects&&(this._componentObjects=new v.ComponentObjectCollection(this.renderer.renderPassManager,this._viewingMode)),this._componentObjects}set componentObjectCollection(e){this._componentObjects=e}},t.__decorate([p.property({type:Boolean,readOnly:!0})],e.RenderView.prototype,"updating",null),t.__decorate([p.property()],e.RenderView.prototype,"_rctx",void 0),t.__decorate([p.property()],e.RenderView.prototype,"_container",void 0),t.__decorate([p.property()],e.RenderView.prototype,"_canvas",void 0),t.__decorate([p.property()],e.RenderView.prototype,"stippleTextures",void 0),t.__decorate([p.property()],e.RenderView.prototype,"markerTextures",void 0),t.__decorate([p.property()],e.RenderView.prototype,"waterTextures",void 0),t.__decorate([p.property({readOnly:!0})],e.RenderView.prototype,"olidRenderHelper",void 0),t.__decorate([p.property()],e.RenderView.prototype,"_textures",void 0),t.__decorate([p.property({readOnly:!0})],e.RenderView.prototype,"renderer",void 0),t.__decorate([p.property()],e.RenderView.prototype,"_screenshotManager",void 0),t.__decorate([p.property()],e.RenderView.prototype,"componentObjectCollection",null),t.__decorate([p.property()],e.RenderView.prototype,"_componentObjects",void 0),t.__decorate([p.property()],e.RenderView.prototype,"_needsUpdate",void 0),t.__decorate([p.property()],e.RenderView.prototype,"_needsWaterReflectionUpdate",void 0),e.RenderView=t.__decorate([u.subclass("esri.views.3d.webgl-engine.parts.RenderView")],e.RenderView);const Q=N.getContextCache();Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
