/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../chunks/tslib.es6","../core/domUtils","../core/events","../core/Logger","../core/maybe","../core/reactiveUtils","../core/scheduling","../core/accessorSupport/decorators/property","../core/has","../core/RandomLCG","../core/accessorSupport/decorators/subclass","./overlay/ViewOverlay"],(function(e,t,s,i,r,o,n,a,d,h,l,c,u){"use strict";const p=[0,0];function _(e){const t=(e.ownerDocument||window.document).defaultView,s=e.getBoundingClientRect();return p[0]=s.left+(t?.pageXOffset??0),p[1]=s.top+(t?.pageYOffset??0),p}function y(e){e&&(e.textContent="",e.parentNode&&e.parentNode.removeChild(e))}function g(e){const t=document.createElement("div");return e.appendChild(t),t}const f=16,v=750,m=512,w=2,C=e=>{let h=class extends e{constructor(...e){super(...e),this._freqInfo={freq:f,time:v},this._overlayRenderTaskHandle=null,this.height=0,this.messagesCommon=null,this.overlay=null,this.position=null,this.resizing=!1,this.root=null,this.surface=null,this.suspended=!0,this.ui=null,this.userContent=null,this.width=0,this.widthBreakpoint=null,this.addHandles([n.watch((()=>this.cursor),(e=>{const{surface:t}=this;t&&t.setAttribute("data-cursor",e)})),n.watch((()=>this.navigating),(e=>{const{surface:t}=this;t&&t.setAttribute("data-navigating",e.toString())}))])}initialize(){this.addHandles([n.watch((()=>this.ui),((e,t)=>this._handleUIChange(e,t)),n.initial),this.on("focus",(()=>this.notifyChange("focused"))),this.on("blur",(()=>this.notifyChange("focused")))])}destroy(){this.destroyed||(this.ui=o.destroyMaybe(this.ui),this.container=null)}get container(){return this._get("container")??null}set container(e){const t=this._get("container"),i=s.byId(e);if(i||"string"!=typeof e||r.getLogger(this).error("#container",`element with id '${e}' not found`),t===i)return;if(this._stopMeasuring(),t&&(t.classList.remove("esri-view"),this._overlayRenderTaskHandle&&(this._overlayRenderTaskHandle.remove(),this._overlayRenderTaskHandle=null),this.overlay&&(this.overlay.destroy(),this._set("overlay",null)),this.root&&(y(this.root),this._set("root",null)),this.userContent&&(s.reparent(this.userContent,t),y(this.userContent),this._set("userContent",null))),!i)return this._set("width",0),this._set("height",0),this._set("position",null),this._set("suspended",!0),this._set("surface",null),void this._set("container",null);i.classList.add("esri-view");const d=document.createElement("div");d.className="esri-view-user-storage",s.reparent(i,d),i.appendChild(d),this._set("userContent",d);const h=document.createElement("div");h.className="esri-view-root",i.insertBefore(h,i.firstChild),this._set("root",h);const l=document.createElement("div");l.className="esri-view-surface",l.setAttribute("role","application"),l.tabIndex=0,h.appendChild(l),this._set("surface",l);const c=new u;h.appendChild(c.surface),this._set("overlay",c),this.addHandles(n.watch((()=>c.needsRender),(e=>{e&&!this._overlayRenderTaskHandle?this._overlayRenderTaskHandle=a.addFrameTask({render:()=>this.overlay?.render()}):this._overlayRenderTaskHandle=o.removeMaybe(this._overlayRenderTaskHandle)}))),this.forceDOMReadyCycle(),this._set("container",i),this._startMeasuring()}get focused(){const e=document.activeElement===this.surface;return document.hasFocus()&&e}get size(){return[this.width,this.height]}blur(){this.surface?.blur()}focus(){this.surface?.focus()}pageToContainer(e,t,s){const i=this.position;return e-=i?i[0]:0,t-=i?i[1]:0,s?(s[0]=e,s[1]=t):s=[e,t],s}containerToPage(e,t,s){const i=this.position;return e+=i?i[0]:0,t+=i?i[1]:0,s?(s[0]=e,s[1]=t):s=[e,t],s}_handleUIChange(e,t){this.removeHandles("ui"),t&&t!==e&&t.destroy(),e&&(e.view=this,this.addHandles(n.watch((()=>this.root),(t=>{e.container=t?g(t):null}),n.initial),"ui")),this._set("ui",e)}_stopMeasuring(){this.removeHandles("measuring"),this._get("resizing")&&this._set("resizing",!1)}_startMeasuring(){const e=this._freqInfo;e.freq=f,e.time=v,this.addHandles([i.on(window,"resize",(()=>{e.freq=f,e.time=v})),a.addFrameTask({prepare:e=>{const t=this._measure(),s=this._freqInfo;if(s.time+=e.deltaTime,t&&(s.freq=f,this._get("resizing")||this._set("resizing",!0)),s.time<s.freq)return;s.time=0;const i=this._position();s.freq=i||t?f:Math.min(v,s.freq*w),!t&&s.freq>=m&&this._get("resizing")&&this._set("resizing",!1)}})],"measuring"),this._measure(),this._position()}_measure(){const e=this.container,t=e?e.clientWidth:0,s=e?e.clientHeight:0;if(0===t||0===s)return this.suspended||this._set("suspended",!0),!1;const i=this.width,r=this.height;return t===i&&s===r?(this.suspended&&this._set("suspended",!1),!1):(this._set("width",t),this._set("height",s),this.suspended&&this._set("suspended",!1),this.emit("resize",{oldWidth:i,oldHeight:r,width:t,height:s}),!0)}_position(){const e=this.container,t=this.position,s=e&&_(e);return!!s&&((!t||s[0]!==t[0]||s[1]!==t[1])&&(this._set("position",[s[0],s[1]]),!0))}forceDOMReadyCycle(){}};return t.__decorate([d.property()],h.prototype,"container",null),t.__decorate([d.property({readOnly:!0})],h.prototype,"focused",null),t.__decorate([d.property({readOnly:!0})],h.prototype,"height",void 0),t.__decorate([d.property()],h.prototype,"messagesCommon",void 0),t.__decorate([d.property({type:u})],h.prototype,"overlay",void 0),t.__decorate([d.property({readOnly:!0})],h.prototype,"position",void 0),t.__decorate([d.property({readOnly:!0})],h.prototype,"resizing",void 0),t.__decorate([d.property({readOnly:!0})],h.prototype,"root",void 0),t.__decorate([d.property({value:null,readOnly:!0})],h.prototype,"size",null),t.__decorate([d.property({readOnly:!0})],h.prototype,"surface",void 0),t.__decorate([d.property({readOnly:!0})],h.prototype,"suspended",void 0),t.__decorate([d.property()],h.prototype,"ui",void 0),t.__decorate([d.property({readOnly:!0})],h.prototype,"userContent",void 0),t.__decorate([d.property({readOnly:!0})],h.prototype,"width",void 0),t.__decorate([d.property()],h.prototype,"widthBreakpoint",void 0),h=t.__decorate([c.subclass("esri.views.DOMContainer")],h),h};e.DOMContainer=C,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
