/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../Camera","../geometry","../Viewpoint","../core/Collection","../core/domUtils","../core/Error","../core/events","../core/handleUtils","../core/has","../core/Logger","../core/maybe","../core/ObservableChangesType","../core/promiseUtils","../core/reactiveUtils","../core/scheduling","../core/screenUtils","../core/unitUtils","../core/workers/workers","../core/accessorSupport/decorators/property","../core/accessorSupport/decorators/cast","../core/RandomLCG","../core/accessorSupport/decorators/subclass","../core/accessorSupport/ensureType","../core/accessorSupport/overrideDefaultsFrom","../core/libs/gl-matrix-2/factories/vec3f64","../core/support/OwningCollection","../geometry/HeightModelInfo","../geometry/projection","../geometry/projection/projectBoundingRect","../geometry/projection/projectPointToVector","../geometry/support/aaBoundingRect","../chunks/boundedPlane","../geometry/support/coordinateSystem","../geometry/support/scaleUtils","../layers/support/layerUtils","../support/AnalysesCollection","./BreakpointsOwner","./DOMContainer","./GroundView","./PopupView","./View","./ViewAnimation","./ViewingMode","./3d/layerViewModuleImportUtils","./3d/analysis/AnalysisViewManager3D","./3d/constraints/Constraints","./3d/environment/EnvironmentManager","./3d/environment/SceneViewEnvironment","./3d/input/SceneInputManager","./3d/layers/graphics/GraphicsDeconflictor","./3d/layers/graphics/Labeler","./3d/layers/support/FeatureTileTree3D","./3d/state/ViewState","./3d/state/ViewStateManager","./3d/state/helpers/SceneIntersectionHelper","./3d/support/CombinedElevationProvider","./3d/support/debugFlags","./3d/support/DisplayQualityProfile","./3d/support/ElevationProvider","./3d/support/HighlightGroup","./3d/support/HighlightOptions","./3d/support/hitTest","./3d/support/popupHitTest","./3d/support/QualitySettings","./3d/support/RenderCoordsHelper","./3d/support/ResourceController","./3d/support/SceneViewPerformanceInfo","./3d/support/SharedSymbolResources","./3d/support/TextureCollection","./3d/support/pointsOfInterest/PointsOfInterest","./3d/terrain/TerrainSurface","./3d/terrain/terrainUtils","./3d/webgl-engine/Stage","./3d/webgl-engine/effects/geometry/olidUtils","./3d/webgl-engine/lib/Intersector","./3d/webgl-engine/lib/verticalOffsetUtils","./support/HighlightDefaults","./support/layerViewUtils","./support/PropertiesPool","./support/screenUtils","./support/spatialReferenceSupport","./support/WebGLRequirements","./ui/DefaultUI","./ui/3d/DefaultUI3D","../webscene/Environment","../geometry/Extent","../geometry/SpatialReference","../geometry/Point"],(function(e,t,r,i,a,n,s,o,l,p,h,d,c,u,g,y,_,m,w,f,v,b,M,S,V,T,C,R,O,x,P,E,L,I,H,A,G,D,F,U,W,k,j,q,z,B,N,Q,Y,Z,$,J,K,X,ee,te,re,ie,ae,ne,se,oe,le,pe,he,de,ce,ue,ge,ye,_e,me,we,fe,ve,be,Me,Se,Ve,Te,Ce,Re,Oe,xe,Pe,Ee,Le,Ie,He,Ae){"use strict";const Ge=e=>Object.freeze(Object.defineProperty({__proto__:null,default:e},Symbol.toStringTag,{value:"Module"}));let De=class extends(F.BreakpointsOwner(k.PopupView(U.DOMContainer(j)))){constructor(e){super(e),this._userClippingArea=null,this._clippingArea=null,this._initialDefaultSpatialReference=null,this._overrideDefaultEnvironmentOnly=!0,this._createGraphicsViewController=null,this._resolveWhenReady=[],this._propertiesPool=new Ce.PropertiesPool({slicePlane:I.BoundedPlaneClass},this),this._resourceController=ue.newResourceController(this),this._defaultToMapOptions={include:new Set},this._defaultHitTestOptions={exclude:new Set},this.deconflictor=new J.GraphicsDeconflictor({view:this}),this.labeler=new K.Labeler({view:this,deconflictor:this.deconflictor.labels}),this.sharedSymbolResources=null,this.analyses=new D.AnalysesCollection,this.basemapTerrain=null,this.elevationProvider=null,this.canvas=null,this.constraints=new Q.Constraints,this.environment=new Z,this.environmentManager=new Y.EnvironmentManager,this.floors=new n,this.fullOpacity=1,this.graphicsView=null,this.analysisViewManager=new N({view:this}),this.groundView=null,this.map=null,this.screenSizePerspectiveEnabled=!0,this.state=new ee({view:this}),this.spatialReference=null,this.alphaCompositingEnabled=!1,this.preserveDrawingBufferEnabled=!1,this.supersampleScreenshotsEnabled=!0,this.type="3d",this.ui=new Ee,this._numUpdating=0,this._lastUpdateTime=0,this.updatingProgress=.5,this.highlights=oe.makeDefaultHighlightGroups(),f.initialize();const t=(e=null)=>{null!=e&&e.type===u.ObservableChangesType.MOVE||(this._updatingChanged(),this.map&&this.map.allLayers.forEach((async e=>{try{await e.when()}catch{}this._updatingChanged()})))};this.addHandles([y.on((()=>this.map?.allLayers),"after-changes",(e=>t(e)),{onListenerAdd:()=>t(),onListenerRemove:()=>t(),sync:!0}),this.allLayerViews.on("after-changes",(e=>this._updateUpdatingMonitors(e))),y.watch((()=>this.map),(e=>{e&&"load"in e&&e.load&&e.load().catch((()=>{}))}))]),this.inputManager=new $({view:this}),this.stateManager=new te.ViewStateManager({view:this})}initialize(){this.groundView=new W({view:this}),this._updateUpdatingMonitors();const e=()=>this._updateDefaultToMapOptions();this.addHandles(y.on((()=>this.map?.allLayers),"after-changes",e,{onListenerAdd:e,onListenerRemove:e})),this.updatingHandles.add((()=>this.qualitySettings.memoryLimit),(e=>{this.resourceController&&(this.resourceController.memoryController.maxMemory=e)}),y.initial),this.updatingHandles.add((()=>this.qualitySettings.additionalCacheMemory),(e=>{this.resourceController&&(this.resourceController.memoryController.additionalCacheMemory=e)}),y.initial),this.updatingHandles.add((()=>this.qualitySettings.frameRate??0),(e=>_.setFrameDuration(e>0?1e3/Math.ceil(e):0)),y.initial),this.updatingHandles.add((()=>this.map?.ground),e,y.syncAndInitial),this.updatingHandles.add((()=>this.map?.ground?.opacity),(()=>this._updateDefaultHitTestOptions()),y.syncAndInitial),this.addHandles(y.watch((()=>this.spatialReference),(()=>this.notifyChange("clippingArea")),y.sync))}destroy(){this.destroyed||(this.updatingHandles.removeAll(),this.invalidate(),this.activeTool=null,this.layerViewManager.clear(),this._exitSurface(),this._disposeGraphicsView(),this.sharedSymbolResources=c.destroyMaybe(this.sharedSymbolResources),this._set("labeler",c.destroyMaybe(this.labeler)),this._set("deconflictor",c.destroyMaybe(this.deconflictor)),this._resourceController=c.destroyMaybe(this._resourceController),this._set("stateManager",c.destroyMaybe(this.stateManager)),this._set("inputManager",c.destroyMaybe(this.inputManager)),this.state.destroy(),this._propertiesPool.destroy(),this.removeHandles("updatingMonitors"),this._set("environmentManager",c.destroyMaybe(this.environmentManager)),this._set("environment",c.destroyMaybe(this.environment)),this.groundView=c.destroyMaybe(this.groundView),this._exitBasemapTerrain(),this._stage?.destroy(),this.highlights.destroy())}get renderSpatialReference(){return this.renderCoordsHelper&&this.renderCoordsHelper.spatialReference}get basemapSpatialReference(){return this.basemapTerrain?.spatialReference}get animation(){return this.state.animation}get camera(){return this.stateManager?.camera}set camera(e){this.stateManager&&(this.stateManager.camera=e)}get contentCamera(){return this.stateManager?.contentCamera}set contentCamera(e){this.stateManager&&(this.stateManager.contentCamera=e)}installContentCameraReset(e={sticky:!1}){return this.stateManager.installContentCameraReset(e)}get center(){return this.stateManager?.center}set center(e){this.stateManager&&(this.stateManager.center=e)}get clippingArea(){if("global"===this.viewingMode)return null;const e=this.map;let t=this._userClippingArea||c.maybeProperty(e,"clippingArea");return!this._userClippingArea&&!c.maybeProperty(e,"clippingEnabled")||null==t?(this._clippingArea=null,null):t instanceof Ie?this.spatialReference&&(t=Fe(t,this.spatialReference),null==t)?(d.getLogger(this).error("#clippingArea","setting clippingArea with incompatible SpatialReference"),this._clippingArea):(t=t.clone(),null==t.intersection(this._groundAndLayersExtent)&&(t.xmin=t.xmax,t.ymin=t.ymax),t.zmin=void 0,t.zmax=void 0,t.equals(this._clippingArea)||(this._clippingArea=t),this._clippingArea):(d.getLogger(this).error("#clippingArea","only clippingArea geometries of type Extent are supported"),this._clippingArea)}set clippingArea(e){this.ready&&"global"===this.viewingMode&&null!=e?d.getLogger(this).error("#clippingArea=","Clipping area is only supported in local viewingMode"):this._userClippingArea=e}get renderDataExtent(){if(this.state.viewingMode===z.ViewingMode.Global)return null;const e=this.renderSpatialReference,t=this.dataExtent;return null==t||null==e||t.spatialReference.equals(e)?t:Fe(t,e)}get tileInfo(){return this.basemapTerrain?.tilingScheme?.toTileInfo()}get dataExtent(){let e=this._groundAndLayersExtent;const t=this.spatialReference||He.WGS84,r=Fe(this.clippingArea,t);null!=r&&(e=null!=e?e.intersection(r):r);const i=this._get("dataExtent");return null!=e&&e.equals(i)?i:e}get _groundAndLayersExtent(){const e=this.spatialReference||He.WGS84;let t;const r=r=>{const i=Fe(r,e);null!=i&&(null!=t?t.union(i):t=i.clone())},i=this.basemapTerrain;if(i?.spatialReference){const e=i.groundExtent;r(new Ie({xmin:e[0],ymin:e[1],zmin:0,xmax:e[2],ymax:e[3],zmax:0,spatialReference:i.spatialReference}))}if(this.map){const e=e=>{null==e.fullExtent||"graphics"===e.type&&e.internal||r(e.fullExtent)};this.map.allLayers.forEach((t=>e(t)))}if(null==t)return null;t.hasZ?(t.zmin=Math.min(0,t.zmin??0),t.zmax=Math.max(0,t.zmax??0)):(t.zmin=0,t.zmax=0);const a=this._get("_groundAndLayersExtent");return t.equals(a)?a:t}castEnvironment(e){return e?e instanceof Z?e:e instanceof Le?this.environment?.cloneWithWebsceneEnvironment(e)??Z.fromWebsceneEnvironment(e):V.ensureType(Z,e):new Z}get extent(){return this.stateManager?.extent}set extent(e){this.stateManager&&(this.stateManager.extent=e)}get screenCenter(){return this.stateManager?.screenCenter}get frustum(){return this.stateManager?.frustum}get initialExtentRequired(){return this.stateManager&&!this.stateManager.hasInitialView}get defaultsFromMapSettings(){return{required:{tileInfo:!1,heightModelInfo:!0,extent:!1}}}get interacting(){return this.navigating||(this.toolViewManager?.interacting??!1)}get stationary(){return!this.animation&&!this.resizing&&(this.state?.stationary??!0)}get navigating(){return this.state?.navigating??!1}get padding(){return this.stateManager?.padding}set padding(e){this.stateManager&&(this.stateManager.padding=e)}set qualityProfile(e){ne.isValidProfile(e)&&(ne.apply(e,this.qualitySettings),this._set("qualityProfile",e))}get qualityProfile(){return this._get("qualityProfile")||ne.getDefaultProfile()}set slicePlane(e){if(null!=this._stage&&(this._stage.renderer.slicePlane=e),null==e)return void this._set("slicePlane",null);const t=this._propertiesPool.get("slicePlane");I.copy(e,t),this._set("slicePlane",t)}get typeSpecificPreconditionsReady(){return!!this.viewingMode&&!!this.stateManager?.preinit(this.spatialReference)}get resolution(){return null!=this.spatialReference?A.getResolutionForScale(this.scale,this.spatialReference):0}get scale(){return this.stateManager?.scale}set scale(e){this.stateManager&&(this.stateManager.scale=e)}get heightModelInfo(){const e=this.getDefaultHeightModelInfo();return null!=e?O.deriveUnitFromSR(e,this.spatialReference):null}get updating(){if(this.destroyed)return!1;let e=0,t=this.layerViewManager.updating,r=t?this.layerViewManager.updatingRemaining:0;this.allLayerViews.forEach((i=>{if(i.isFulfilled()){if(i.updating){if(t=!0,i.suspended||fe.isSurfaceLayerView(i))return;++r,e+=i.updatingProgress}}else++r}));for(const a of this._updatingObjects)if(null!=a&&a.updating){const t=.1;r+=t,e+=.5*t}for(const a of this._updatingObjectsWithProgress)null!=a&&a.updating&&(++r,e+=a.updatingProgress);const i=!this.stateManager.test.updatingIgnoreRenderState&&this.state.updating;if(t=!!(t||r>0||this.updatingHandles.updating||!this.ready||!this.stationary||i||this._createGraphicsViewController||this.inputManager?.updating||this.map?.allLayers?.some((e=>!e.isFulfilled()))||this.textures?.updating),t?(this._numUpdating=Math.max(r,this._numUpdating),e+=this._numUpdating-r):this._numUpdating=0,this._numUpdating>0?e/=this._numUpdating:e=t?0:1,this._get("updatingProgress")!==e){const r=performance.now();if(e<1){const t=Math.min((r-this._lastUpdateTime)/2e3,1);e=this.updatingProgress*(1-t)+e*t}this._set("updatingProgress",e),this._lastUpdateTime=t&&e<1?r:0}return t}get _updatingObjects(){return[this.graphicsView,this.basemapView,this._resourceController,this._stage,this.featureTiles,this.pointsOfInterest,this.environmentManager,this.overlay,this._featureTreeDebugger,this.toolViewManager,this.analysisViewManager]}get _updatingObjectsWithProgress(){return[this.deconflictor,this.labeler,this.basemapTerrain]}get viewingMode(){const e=this._predeterminedViewingMode;if(null!=e)return z.stringFromViewingMode(e);const t=this.spatialReference;return t?null!=this.defaultsFromMap?.viewingMode&&t.equals(this.defaultsFromMap.spatialReference)?z.stringFromViewingMode(this.defaultsFromMap.viewingMode):Oe.isSpatialReferenceSupported(t,z.ViewingMode.Global)?"global":"local":"global"}set viewingMode(e){this.ready?d.getLogger(this).error("#viewingMode","viewingMode cannot be set once view is ready"):this._overrideIfSome("viewingMode",e)}get viewpoint(){return this.stateManager?.viewpoint}set viewpoint(e){this.stateManager&&(this.stateManager.viewpoint=e)}get visibleArea(){return this.stateManager?.visibleArea}get zoom(){return this.stateManager.zoom}set zoom(e){this.stateManager&&(this.stateManager.zoom=e)}get highlightOptions(){for(const e of this.highlights)if(e.name===Ve.defaultHighlightName)return e.options;return new le}set highlightOptions(e){for(const t of this.highlights)if(t.name===Ve.defaultHighlightName)return void(t.options=e)}get resourceController(){return this._resourceController}get quality(){return this._resourceController?.memoryController?.memoryFactor??1}get resolutionScale(){return Math.sqrt(Math.min(1,this.quality/.75))}get performanceInfo(){return new ge(this)}on(e,t,r,i){const a=this.viewEvents.on(e,t,r,i);return a||super.on(e,t)}hasEventListener(e){return super.hasEventListener(e)||this.viewEvents.hasHandler(e)}toMap(e,t){if(!this.ready)return d.getLogger(this).error("#toMap()","Scene view cannot be used before it is ready"),null;const r=Re.isSupportedScreenPointEvent(e)?Re.createScreenPointFromSupportedEvent(this,e):e;return pe.toMap(this,r,t,this._defaultToMapOptions)}toScreen(e){if(!this.ready)return d.getLogger(this).error("#toScreen()","Scene view cannot be used before it is ready"),null;const t=(null==e.z?se.getElevationAtPoint(this.elevationProvider,e):null)??0;return E.projectPointToVector(e,Ue,this.renderSpatialReference,t),this.state.camera.projectToScreen(Ue,We),m.createScreenPoint(We[0],We[1])}pixelSizeAt(e,t){if(!this.ready)return d.getLogger(this).error("#pixelSizeAt()","Scene view cannot be used before it is ready"),null;if(!e)return 0;const r=this.renderSpatialReference;E.projectPointToVector(e,Ue,r);const i=this.state.camera.computeScreenPixelSizeAt(Ue);return t&&r!==t?i*w.getMetersPerUnitForSR(r)/w.getMetersPerUnitForSR(t):i}overlayPixelSizeInMapUnits(e){const t=this.basemapTerrain.overlayManager;return t?t.overlayPixelSizeInMapUnits(e,(()=>this.pixelSizeAt(e))):1}hitTest(e,t){if(!this.ready)return d.getLogger(this).error("#hitTest()","Scene view cannot be used before it is ready"),null;const r=Re.isSupportedScreenPointEvent(e)?Re.createScreenPointFromSupportedEvent(this,e):e;return pe.hitTest(this,r,t,this._defaultHitTestOptions)}async popupHitTest(e){return he.popupHitTest(this,e)}goTo(e,t){return this.updatingHandles.addPromise(this.stateManager.goTo(e,t))}async whenAnalysisView(e){if(null==e.parent)throw new o("view:no-analysisview-for-analysis","The analysis has not been added to view.analyses",{analysis:e});switch(e.parent.type){case"line-of-sight":case"dimension":case"viewshed":return(await this.whenLayerView(e.parent)).whenAnalysisView();default:return this.analysisViewManager.whenAnalysisView(e)}}whenLayerView(e){return super.whenLayerView(e)}async takeScreenshot(t){const r=await this._completeSettings(t);await this.whenReady();const i=await this._stage.renderView.takeScreenshot(r);return(await new Promise(((t,r)=>e(["./support/screenshotUtils"],t,r)))).encode(i,r,this._pixelFormat())}async _takeScreenshot(t){const r=await this._completeSettings(t);await this.whenReady();const i=await this._stage.renderView.takeScreenshot(r);return(await new Promise(((t,r)=>e(["./support/screenshotUtils"],t,r)))).encodeData(i,this._pixelFormat())}async _takeScreenshotWithObjectAndLayerId(t){const r=await this._completeSettings(t);await this.whenReady();const i=await this._stage.renderView.takeScreenshotWithOID(r),{encodeData:a}=await new Promise(((t,r)=>e(["./support/screenshotUtils"],t,r)));return[a(i[0],this._pixelFormat()),a(i[1],this._pixelFormat())]}async _completeSettings(t){const{toRenderSettings:r,screenshotSuperSampleSettings:i}=await new Promise(((t,r)=>e(["./support/screenshotUtils"],t,r))),a=r(t,this);return a.pixelRatio/=this.state.pixelRatio,i(a,this.supersampleScreenshotsEnabled,this.padding)}_pixelFormat(){return{flipY:!0,premultipliedAlpha:this._stage.renderView.getAlpha()}}get test(){}async takeScreenshotWithObjectAndLayerId(t){if(!be.olidEnabled())throw new o("360vr:objectAndLayerId-rendering-disabled","has enable-feature:objectAndLayerId-rendering must be true");const{encode:r}=await new Promise(((t,r)=>e(["./support/screenshotUtils"],t,r))),i=await this._completeSettings(t);await this.whenReady();const a=await this._stage.renderView.takeScreenshotWithOID(i),n=r(a[0],i,this._pixelFormat()),s=await this._completeSettings(t);s.format="png";return[n,r(a[1],s,this._pixelFormat())]}getColorToObjectAndLayerIdMapping(){const e=this._stage.renderView.olidRenderHelper;if(e)return e.getColorToObjectAndLayerIdMapping();throw new o("360vr:objectAndLayerId-rendering-disabled","has enable-feature:objectAndLayerId-rendering must be true")}addUpdatingPromise(e){return this.updatingHandles.addPromise(e)}importLayerView(e){return B.layerView3DImporter.importLayerView(e)}hasLayerViewModule(e){return B.layerView3DImporter.hasLayerViewModule(e)}forceDOMReadyCycle(){this.forceReadyCycle()}getDefaultSpatialReference(){return this.map&&"initialViewProperties"in this.map&&this.map.initialViewProperties?.spatialReference||this.defaultsFromMap?.spatialReference||this.defaultsFromMap?.ready&&this._initialDefaultSpatialReference||null}async validate(){let e=xe.check(this.type);const t=h("safari");if(t&&t<9&&(e=new o("sceneview:browser-not-supported","This browser is not supported by SceneView (Safari < 9)",{type:"safari",requiredVersion:9,detectedVersion:t})),null!=e)throw d.getLogger(this).warn("#validate()",e.message),e}get _predeterminedViewingMode(){const e=this._isOverridden("viewingMode")?this._get("viewingMode"):(this.map&&"initialViewProperties"in this.map?this.map.initialViewProperties?.viewingMode:null)??null;return null!=e?z.viewingModeFromString(e):null}getSpatialReferenceSupport(e,t){const r=this._predeterminedViewingMode;if(null!=r)return this._validateSpatialReferenceForViewingMode(e,t,r)?{constraints:this._makeSpatialReferenceConstraints(e,t,r)}:null;const i=this._validateSpatialReferenceForViewingMode(e,t,z.ViewingMode.Local),a=this._validateSpatialReferenceForViewingMode(e,t,z.ViewingMode.Global);return i||a?i&&a?{constraints:this._makeSpatialReferenceConstraints(e,t,null)}:i?{constraints:this._makeSpatialReferenceConstraints(e,t,z.ViewingMode.Local)}:{constraints:this._makeSpatialReferenceConstraints(e,t,z.ViewingMode.Global)}:null}_validateSpatialReferenceForViewingMode(e,t,r){return!!Oe.isSpatialReferenceSupported(e,r)&&(null==t||(!!G.isImageryTileLayer(t)||(!G.isTiledLayer(t)||null!=fe.getTiledLayerInfo(t,e,r))&&(!G.isVoxelLayer(t)||r!==z.ViewingMode.Global)))}_makeSpatialReferenceConstraints(e,t,r){if(null==t)return[{spatialReference:e,viewingMode:r}];const{isWebMercator:i,isWGS84:a}=e;if(G.isImageryTileLayer(t)&&(i||a)){return!a||r===z.ViewingMode.Local||null===fe.checkIfTileInfoSupportedForView(t.tileInfo,t.fullExtent,e,z.ViewingMode.Global)?[{spatialReference:e,viewingMode:r},{spatialReference:He.WebMercator,viewingMode:r}]:[{spatialReference:i?He.WGS84:He.WebMercator,viewingMode:r}]}return G.isTiledLayer(t)||G.isVoxelLayer(t)||!i&&!a?G.isTiledLayer(t)&&i&&r!==z.ViewingMode.Global?[{spatialReference:e,viewingMode:r},{spatialReference:He.WGS84,viewingMode:z.ViewingMode.Local}]:[{spatialReference:e,viewingMode:r}]:[{spatialReference:e,viewingMode:r},{spatialReference:i?He.WGS84:He.WebMercator,viewingMode:r}]}_validateSpatialReference(e){const t=null!=this.getSpatialReferenceSupport(e),r=this._predeterminedViewingMode;return t||(null!=r?d.getLogger(this).warnOnce(`Spatial reference defined on view not supported in ${z.stringFromViewingMode(r)} viewing mode.`):e.isGeographic&&d.getLogger(this).warnOnce("Spatial reference is geographic but not supported.")),t}whenReady(){return new Promise((e=>{this.ready?e(this):this._resolveWhenReady.push(e)}))}trackGraphicState(e){if(!e.graphic)return d.getLogger(this).error("trackGraphicState","GraphicState.graphic must not be null or undefined to start tracking"),null;const t=this.getViewForGraphic(e.graphic);let r=null,i=!1;const a=t=>{!i&&null!=t&&"processor"in t&&"graphics-3d"===t.processor?.type&&t.processor.graphicsCore&&(r=t.processor.graphicsCore.trackGraphicState(e))};return null!=t?a(t):this.whenViewForGraphic(e.graphic,{waitForLayer:!0}).then((e=>a(e)),(()=>{})).catch((()=>{})),p.makeHandle((()=>{i=!0,null!=r&&(r.remove(),r=null)}))}highlight(e){if(Array.isArray(e))return p.handlesGroup(e.map((e=>this.highlight(e))));if(n.isCollection(e))return p.handlesGroup(e.toArray().map((e=>this.highlight(e))));const t=this.getViewForGraphic(e);return t&&"highlight"in t?t.highlight(e):p.makeHandle()}maskOccludee(e){if(!e)return d.getLogger(this).error("maskOccludee","GraphicState.graphic must not be null or undefined to mask an occludee"),null;const t=this.getViewForGraphic(e);let r=null,i=!1;const a=t=>{!i&&null!=t&&Te.occludeesSupported(t)&&(r=t.maskOccludee(e))};return null!=t?a(t):this.whenViewForGraphic(e,{waitForLayer:!0}).then((e=>a(e)),(()=>{})).catch((()=>{})),p.makeHandle((()=>{i=!0,null!=r&&(r.remove(),r=null)}))}getViewForGraphic(e){return e.layer===this.graphics?this.graphicsView:e.layer?this.allLayerViews.find((t=>t.layer===e.layer)):null}graphicChanged(e){null!=this.graphicsView&&this.graphicsView.graphicChanged(e)}async whenViewForGraphic(e,t){if(e.layer===this)return await y.whenOnce((()=>this.graphicsView)),this.graphicsView;if(!e.layer||!this.map)throw new o("no-view-for-graphic");return t&&t.waitForLayer&&!this.map.allLayers.includes(e.layer)?new Promise(((t,r)=>{const i=this.map.allLayers.on("change",(a=>{a.added.includes(e.layer)&&(i.remove(),this.whenLayerView(e.layer).then(t,r))}))})):this.whenLayerView(e.layer)}_initBasemapTerrain(){this._set("basemapTerrain",new we({view:this})),this._set("elevationProvider",new ie.CombinedElevationProvider({view:this})),this.elevationProvider.register("ground",this.basemapTerrain)}_exitBasemapTerrain(){this.basemapTerrain&&(this.elevationProvider.unregister(this.basemapTerrain),this.elevationProvider.destroy(),this._set("elevationProvider",null),this.basemapTerrain.destroy(),this._set("basemapTerrain",null))}_initGlobe(){this._initCoordinateSystem(),this.state.createInitialCamera(),this._initBasemapTerrain(),this._set("pointsOfInterest",new me.PointsOfInterest({view:this})),this._set("featureTiles",new X.FeatureTileTree3D({renderCoordsHelper:this.renderCoordsHelper,cameraOnSurface:this.pointsOfInterest.cameraOnSurface,focus:this.pointsOfInterest.focus,tilingSchemeOwner:this.basemapTerrain,viewState:this.state,scheduler:this._resourceController.scheduler,terrain:this.basemapTerrain}));const t=()=>{const e=this.basemapTerrain?.extent;if(this.clippingArea||e)if(e&&this.basemapTerrain.spatialReference){const e=null!=this.basemapTerrain.extent&&null!=this.basemapTerrain.spatialReference?x.project(L.toExtent(this.basemapTerrain.extent,this.basemapTerrain.spatialReference),this.spatialReference):null;null!=this.clippingArea?this.featureTiles.filterExtent=this.clippingArea.intersection(e):this.featureTiles.filterExtent=e}else this.featureTiles.filterExtent=this.clippingArea;else this.featureTiles.filterExtent=null};this.addHandles([this.updatingHandles.add((()=>ae.debugFlags.FEATURE_TILE_TREE_SHOW_TILES),(t=>{t&&this.featureTiles&&!this._featureTreeDebugger?this.updatingHandles.addPromise(new Promise(((t,r)=>e(["./3d/layers/support/FeatureTileTree3DDebugger"],t,r)))).then((({FeatureTileTree3DDebugger:e})=>{!this._featureTreeDebugger&&ae.debugFlags.FEATURE_TILE_TREE_SHOW_TILES&&(this._featureTreeDebugger=new e({view:this}))})):t||!this._featureTreeDebugger||ae.debugFlags.FEATURE_TILE_TREE_SHOW_TILES||(this._featureTreeDebugger.destroy(),this._featureTreeDebugger=null)}),y.syncAndInitial),this.updatingHandles.add((()=>this.clippingArea),t,y.syncAndInitial),this.updatingHandles.add((()=>this.basemapTerrain.extent),t,y.syncAndInitial)],"feature-tiles"),this.stateManager.init()}_exitGlobe(){this.featureTiles&&(this.stateManager.exit(),this.removeHandles("render-coords-helper"),this.removeHandles("feature-tiles"),this._set("featureTiles",c.destroyMaybe(this.featureTiles)),this._set("pointsOfInterest",c.destroyMaybe(this.pointsOfInterest)),this._exitBasemapTerrain(),this.state.reset(),this._exitCoordinateSystem())}_initCoordinateSystem(){if(this.spatialReference){const e=this.spatialReference,t=this.state.isGlobal,r=H.renderSRFromViewSR(t,e);r!==this.renderSpatialReference&&(this._set("renderCoordsHelper",ce.RenderCoordsHelper.create(this.state.viewingMode,r)),t||this.addHandles(y.watch((()=>this.basemapTerrain?.extent),(e=>{const t=this.renderCoordsHelper.spatialReference;null==e||0===e[0]&&0===e[1]&&0===e[2]&&0===e[3]||!P.projectBoundingRect(e,this.basemapTerrain.spatialReference,ke,t)||(this.renderCoordsHelper.extent=ke)}),y.sync),"render-coords-helper"),this.sceneIntersectionHelper&&this.sceneIntersectionHelper.setTolerance(Me.defaultTolerance/this.renderCoordsHelper.unitInMeters))}else this._set("renderCoordsHelper",null)}_exitCoordinateSystem(){this.removeHandles("render-coords-helper"),this._set("renderCoordsHelper",null)}_updatingChanged(){this.notifyChange("updating")}_updateUpdatingMonitors(e=null){null!=e&&e.type===u.ObservableChangesType.MOVE||(this.removeHandles("updatingMonitors"),this.allLayerViews.forEach((e=>{e.destroyed||(this.addHandles(y.watch((()=>[e.updating,e.updatingProgress]),(()=>this._updatingChanged()),y.sync),"updatingMonitors"),e.when((()=>this._updatingChanged()),(()=>this._updatingChanged())))})),this._updatingChanged())}async _prepareScreenshotOverlay(){this.overlay&&await this.overlay.prepare()}_renderScreenshotOverlay(e,t,r){if(!this.overlay||!this.overlay.hasVisibleItems)return r;const i=e.getContext("2d");return i.putImageData(r,0,0),this.overlay.renderCanvas(e,{disableDecorations:t}),i.getImageData(0,0,r.width,r.height)}_initStage(){const e={deactivatedWebGLExtensions:this.deactivatedWebGLExtensions,debugWebGLExtensions:this.debugWebGLExtensions,alpha:this.alphaCompositingEnabled,preserveDrawingBuffer:this.preserveDrawingBufferEnabled,canvas:this.renderCanvas,screenshot:{prepareOverlay:()=>this._prepareScreenshotOverlay(),renderOverlay:(e,t,r)=>this._renderScreenshotOverlay(e,t,r)}},t=new re.SceneIntersectionHelper(this.state.viewingMode,(e=>this._stage.layers.forAll(e)),this);this._set("sceneIntersectionHelper",t);const r=s.byId(this.surface);this._stage=new ve.Stage({view:this,options:e,container:r}),this._stage.renderer.slicePlane=this.slicePlane,this.addHandles([this.updatingHandles.add((()=>this.qualitySettings.highQualityTransparency),(e=>this._stage.renderer.setParameters({highQualityTransparency:e})),y.initial),this.on("pointer-move",(()=>this._stage?.renderer.resetAnimation())),l.on(this._stage.renderView.canvas,"webglcontextlost",(e=>{this.fatalError=new o("webgl-context-lost",e.statusMessage)}))],"stage"),this.renderCoordsHelper&&this.sceneIntersectionHelper.setTolerance(Me.defaultTolerance/this.renderCoordsHelper.unitInMeters),this._set("canvas",this._stage.renderView.canvas)}_exitStage(){this._set("sceneIntersectionHelper",null),this._stage=c.destroyMaybe(this._stage),this.removeHandles("stage"),this._set("canvas",null)}_initSurface(e){this._exitSurface(),this._initStage(),this._initGlobe(),this.sharedSymbolResources=new ye.SharedSymbolResources({view:this,viewingMode:e,resourceController:this._resourceController,pointsOfInterest:this.pointsOfInterest,viewState:this.state})}_exitSurface(){this.sharedSymbolResources&&(this.sharedSymbolResources.objectResourceCache.destroy(),this.sharedSymbolResources.destroy(),this.sharedSymbolResources=null,this._exitGlobe(),this._exitStage())}_createGraphicsViewIfNeeded(){if(this.graphicsView||this._createGraphicsViewController)return;if(0===this.graphics.length)return;this.removeHandles("graphics-view"),this._createGraphicsViewController=new AbortController;const e=()=>{this._createGraphicsViewController=null,this._updatingChanged()};this._createGraphicsViewAsync(this._createGraphicsViewController.signal).then(e,e),this._updatingChanged()}async _createGraphicsViewAsync(t){const r=(await new Promise(((t,r)=>e(["./3d/layers/GraphicsView3D"],(e=>t(Ge(e))),r)))).default;g.throwIfAborted(t),await y.whenOnce((()=>this.basemapTerrain?.ready),t),this._set("graphicsView",new r({view:this}))}_disposeGraphicsView(){this._createGraphicsViewController&&(this._createGraphicsViewController.abort(),this._createGraphicsViewController=null),this.removeHandles("graphics-view"),null!=this.graphicsView&&(this.removeHandles(this.graphicsView.processor.layer.id),this.graphicsView.destroy(),this._set("graphicsView",null))}_startup(){const e=z.viewingModeFromString(this.viewingMode);e===z.ViewingMode.Global&&(this._clippingArea=null),this._initSurface(e),this._set("ready",!0),this.addHandles(y.on((()=>this.graphics),"after-changes",(()=>this._createGraphicsViewIfNeeded())),"graphics-view"),this._createGraphicsViewIfNeeded();const t=this.map&&"initialViewProperties"in this.map?this.map.initialViewProperties:null,r=t?.environment;r&&(this._overrideDefaultEnvironmentOnly?T.overrideDefaultsFrom(this.environment,r):this.environment=this.environment.cloneWithWebsceneEnvironment(r)),this.timeExtent=t?.timeExtent,this.labeler.setup(),this.environmentManager.connectView(this),this.inputManager.connect(),this._set("textures",new _e.TextureCollection(this._stage,this.resourceController.scheduler));const i=this._resolveWhenReady;this._resolveWhenReady=[],i.forEach((e=>e(this)))}_teardown(){this._initialDefaultSpatialReference=null,this.inputManager.disconnect(),this.environmentManager.disconnectView(),this._overrideDefaultEnvironmentOnly=!1,this.labeler.dispose(),this._disposeGraphicsView(),this.removeHandles("graphics-view"),this._set("textures",c.destroyMaybe(this.textures)),this._exitSurface(),this._set("ready",!1)}_updateDefaultToMapOptions(){if(this._defaultToMapOptions.include.clear(),this.map){this.map.ground&&this._defaultToMapOptions.include.add(Se.terrainId);for(const e of this.map.allLayers.items)G.isIntegratedMeshLayer(e.type)&&this._defaultToMapOptions.include.add(e.uid)}}_updateDefaultHitTestOptions(){if(this._defaultHitTestOptions.exclude.clear(),this.map){this.map.ground&&this.map.ground.opacity<1&&this._defaultHitTestOptions.exclude.add(Se.terrainId);for(const e of this.map.allLayers.items)G.isIntegratedMeshLayer(e.type)&&e.opacity<1&&this._defaultHitTestOptions.exclude.add(e.uid)}}};function Fe(e,t){return null!=e&&x.canProjectWithoutEngine(e.spatialReference,t)?x.project(e,t):null}De.type="3d",t.__decorate([v.property()],De.prototype,"_userClippingArea",void 0),t.__decorate([v.property()],De.prototype,"_resourceController",void 0),t.__decorate([v.property()],De.prototype,"_stage",void 0),t.__decorate([v.property({readOnly:!0})],De.prototype,"deconflictor",void 0),t.__decorate([v.property({readOnly:!0})],De.prototype,"labeler",void 0),t.__decorate([v.property(R.owningCollectionProperty(D.AnalysesCollection,"analyses"))],De.prototype,"analyses",void 0),t.__decorate([v.property({type:q,readOnly:!0})],De.prototype,"animation",null),t.__decorate([v.property({readOnly:!0})],De.prototype,"basemapTerrain",void 0),t.__decorate([v.property({readOnly:!0})],De.prototype,"elevationProvider",void 0),t.__decorate([v.property()],De.prototype,"camera",null),t.__decorate([v.property({type:r})],De.prototype,"contentCamera",null),t.__decorate([v.property({readOnly:!0})],De.prototype,"canvas",void 0),t.__decorate([v.property({type:Ae})],De.prototype,"center",null),t.__decorate([v.property({type:Ie})],De.prototype,"clippingArea",null),t.__decorate([v.property({type:Q.Constraints})],De.prototype,"constraints",void 0),t.__decorate([v.property({type:Ie,readOnly:!0})],De.prototype,"renderDataExtent",null),t.__decorate([v.property({readOnly:!0})],De.prototype,"tileInfo",null),t.__decorate([v.property({type:Ie,readOnly:!0})],De.prototype,"dataExtent",null),t.__decorate([v.property({type:Ie,readOnly:!0})],De.prototype,"_groundAndLayersExtent",null),t.__decorate([v.property({type:Z})],De.prototype,"environment",void 0),t.__decorate([b.cast("environment")],De.prototype,"castEnvironment",null),t.__decorate([v.property({readOnly:!0})],De.prototype,"environmentManager",void 0),t.__decorate([v.property({type:Ie})],De.prototype,"extent",null),t.__decorate([v.property()],De.prototype,"floors",void 0),t.__decorate([v.property()],De.prototype,"screenCenter",null),t.__decorate([v.property()],De.prototype,"frustum",null),t.__decorate([v.property({type:Number,readOnly:!0})],De.prototype,"fullOpacity",void 0),t.__decorate([v.property({readOnly:!0})],De.prototype,"graphicsView",void 0),t.__decorate([v.property({readOnly:!0})],De.prototype,"analysisViewManager",void 0),t.__decorate([v.property()],De.prototype,"groundView",void 0),t.__decorate([v.property({type:Boolean})],De.prototype,"initialExtentRequired",null),t.__decorate([v.property()],De.prototype,"defaultsFromMapSettings",null),t.__decorate([v.property()],De.prototype,"interacting",null),t.__decorate([v.property()],De.prototype,"stationary",null),t.__decorate([v.property()],De.prototype,"navigating",null),t.__decorate([v.property()],De.prototype,"map",void 0),t.__decorate([v.property()],De.prototype,"padding",null),t.__decorate([v.property({type:me.PointsOfInterest,readOnly:!0})],De.prototype,"pointsOfInterest",void 0),t.__decorate([v.property({type:X.FeatureTileTree3D,readOnly:!0})],De.prototype,"featureTiles",void 0),t.__decorate([v.property()],De.prototype,"_featureTreeDebugger",void 0),t.__decorate([v.property({type:Boolean})],De.prototype,"screenSizePerspectiveEnabled",void 0),t.__decorate([v.property({constructOnly:!0})],De.prototype,"deactivatedWebGLExtensions",void 0),t.__decorate([v.property({constructOnly:!0})],De.prototype,"debugWebGLExtensions",void 0),t.__decorate([v.property({constructOnly:!0})],De.prototype,"renderCanvas",void 0),t.__decorate([v.property({constructOnly:!0})],De.prototype,"state",void 0),t.__decorate([v.property({readOnly:!0})],De.prototype,"inputManager",void 0),t.__decorate([v.property({readOnly:!0})],De.prototype,"stateManager",void 0),t.__decorate([v.property({type:["low","medium","high"]})],De.prototype,"qualityProfile",null),t.__decorate([v.property({type:de,get(){let e=this._get("qualitySettings");return e||(e=new de,ne.apply(this.qualityProfile,e)),e}})],De.prototype,"qualitySettings",void 0),t.__decorate([v.property()],De.prototype,"slicePlane",null),t.__decorate([v.property({readOnly:!0})],De.prototype,"typeSpecificPreconditionsReady",null),t.__decorate([v.property({readOnly:!0})],De.prototype,"renderCoordsHelper",void 0),t.__decorate([v.property({readOnly:!0})],De.prototype,"sceneIntersectionHelper",void 0),t.__decorate([v.property({type:Number,dependsOn:["scale","spatialReference"],readOnly:!0})],De.prototype,"resolution",null),t.__decorate([v.property({type:Number})],De.prototype,"scale",null),t.__decorate([v.property()],De.prototype,"heightModelInfo",null),t.__decorate([v.property()],De.prototype,"spatialReference",void 0),t.__decorate([v.property({type:Boolean,constructOnly:!0})],De.prototype,"alphaCompositingEnabled",void 0),t.__decorate([v.property({constructOnly:!0})],De.prototype,"preserveDrawingBufferEnabled",void 0),t.__decorate([v.property({type:Boolean})],De.prototype,"supersampleScreenshotsEnabled",void 0),t.__decorate([v.property({readOnly:!0})],De.prototype,"type",void 0),t.__decorate([v.property(),b.cast((e=>e instanceof Pe?e:V.ensureClass(Ee,e)))],De.prototype,"ui",void 0),t.__decorate([v.property({type:Boolean,readOnly:!0,dependsOn:["graphicsView.updating","basemapView.updating","basemapTerrain.updating","layerViewManager.updating","layerViewManager.updatingRemaining","_resourceController.updating","_stage.updating","featureTiles.updating","pointsOfInterest.updating","environmentManager.updating","overlay.updating","updatingHandles.updating","featureTreeDebugger.updating","labeler.updating","deconflictor.updating","ready","stationary","inputManager.updating","toolViewManager.updating","analysisViewManager.updating","state.updating","textures.updating"]})],De.prototype,"updating",null),t.__decorate([v.property()],De.prototype,"_updatingObjects",null),t.__decorate([v.property()],De.prototype,"_updatingObjectsWithProgress",null),t.__decorate([v.property({type:Number,readOnly:!0,dependsOn:["updating"]})],De.prototype,"updatingProgress",void 0),t.__decorate([v.property({type:["global","local"]})],De.prototype,"viewingMode",null),t.__decorate([v.property({type:a})],De.prototype,"viewpoint",null),t.__decorate([v.property({readOnly:!0})],De.prototype,"visibleArea",null),t.__decorate([v.property({type:Number})],De.prototype,"zoom",null),t.__decorate([v.property({type:le})],De.prototype,"highlightOptions",null),t.__decorate([v.property({type:n.ofType(oe.HighlightGroup)})],De.prototype,"highlights",void 0),t.__decorate([v.property({readOnly:!0})],De.prototype,"quality",null),t.__decorate([v.property({readOnly:!0})],De.prototype,"resolutionScale",null),t.__decorate([v.property()],De.prototype,"textures",void 0),De=t.__decorate([S.subclass("esri.views.SceneView")],De);const Ue=C.create(),We=m.createScreenPointArray(),ke=L.create();return De}));
