/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../core/arrayUtils","../core/Collection","../core/collectionUtils","../core/Evented","../core/MapUtils","../core/maybe","../core/ReactiveMap","../core/reactiveUtils","../core/SetUtils","../core/accessorSupport/decorators/property","../core/has","../core/Logger","../core/accessorSupport/decorators/subclass","../layers/support/layerUtils","../rest/support/Query","./support/selectionUtils"],(function(e,t,s,i,n,o,l,r,c,a,h,u,d,p,y,f,_){"use strict";let g=class extends n.EventedAccessor{constructor(e){super(e),this._selectionMap=new r,this._sources=new s,this._trashCan=[],this._layerEditHandles=new s,this._vizTaskId=0,this.showHighlight=!0}initialize(){this.addHandles([c.watch((()=>[this.view,this.showHighlight]),(()=>this._refreshVisualization())),c.on((()=>this.sources),"change",(e=>{const t=this._selectionMap;for(const s of e.removed)t.delete(s);this._refreshListeners(),this._refreshVisualization()}),{onListenerAdd:()=>this._refreshListeners()})]);const e=new s;this.view.when().then((()=>{this.view.map&&(this.view.map.allLayers.flatten((e=>"sublayers"in e&&e.sublayers?e.sublayers:null)).forEach((t=>{(_.isSelectableLayer(t)&&!y.isSubtypeGroupLayer(t)||y.isSubtypeSublayer(t))&&e.add(t)})),this.sources=e)}))}destroy(){this._layerEditHandles.drain(l.removeMaybe)}get selections(){return Array.from(this._selectionMap.entries()).map((e=>{const[t,s]=e;return{layer:t,selection:[...s.selection]}}))}get count(){let e=0;for(const t of this._selectionMap.values())e+=t.selection.length;return e}get hasSelection(){return this.count>0}get sources(){return this._sources}set sources(e){i.referenceSetter(e,this._sources)}async getSelectedFeatures(e,t={},s="layerView"){const{view:i,selections:n}=this,o=(void 0!==e?n.filter((t=>e.includes(t.layer))):n).filter((e=>e.selection.length>0)).map((async e=>{const{layer:n,selection:o}=e,l=y.isSubtypeSublayer(n)?n.parent:n;if(null==l||!b(l))return null;if("layer"===s)return m(l,o,t);if(v(l))return null;const r=await i.whenLayerView(l).catch((()=>null));return r?m(r,o,t):null}));return(await Promise.all(o)).filter((e=>null!=e))}updateSelection(e){const s=new Map;for(const[t,o]of this._selectionMap)s.set(t,[...o.selection]);let i=!1;const n=e.current.concat(e.added);for(const t of n){const e=t.sourceLayer,n=t.getObjectId();if(this.sources.includes(e)&&(_.isSelectableLayer(e)||y.isSubtypeSublayer(e))&&null!==n){const t=o.getOrCreateMapValue(s,e,(()=>[]));t.includes(n)||(t.push(n),i=!0)}}for(const t of e.removed){const e=t.sourceLayer,n=t.getObjectId();if(this.sources.includes(e)&&(_.isSelectableLayer(e)||y.isSubtypeSublayer(e))&&null!==n){const t=s.get(e),o=t?.indexOf(n);void 0!==o&&o>=0&&(t?.splice(o,1),i=!0)}}if(i){const{_selectionMap:e,_trashCan:i}=this,n=[];for(const[o,l]of s){const s=e.get(o);void 0!==s&&i.push(s),e.set(o,{selection:l}),n.push({layer:o,selection:l,...t.difference(void 0!==s?s.selection:[],l)})}this._onSelectionChange(n)}}setSelection(e,t){this._setSelection(e,t)}getSelection(e){const t=this._selectionMap.get(e);return t?.selection}appendToSelection(e,t){const s=this._selectionMap.get(e),i=void 0!==s?[...s.selection]:[];for(const n of t)i.includes(n)||i.push(n);this._setSelection(e,i)}removeFromSelection(e,t){const s=this._selectionMap.get(e);if(!s)return;const i=[];for(const n of s.selection)t.includes(n)||i.push(n);this._setSelection(e,i)}toggleInSelection(e,t){const s=this._selectionMap.get(e);if(!s||0===s.selection.length)return void this._setSelection(e,t);const i=new Set(s.selection),n=new Set(t),o=a.symmetricDifference(i,n);this._setSelection(e,Array.from(o))}clear(){const e=this._selectionMap.values();this._trashCan.push(...e);const t=[];for(const[s,i]of this._selectionMap.entries())t.push({layer:s,added:[],removed:[...i.selection],selection:[]});this._selectionMap.clear(),this._onSelectionChange(t)}_onSelectionChange(e){this._refreshVisualization(),this.emit("selection-change",{view:this.view,changes:e})}_refreshVisualization(){if(null==this.view||null==this.sources)return;for(this._vizTaskId++;this._trashCan.length>0;){const e=this._trashCan.pop();e?.highlightHandle?.remove()}const{sources:e,view:t,_selectionMap:s,showHighlight:i}=this,n=this._vizTaskId;for(const o of e){const e=s.get(o),l=y.isSubtypeSublayer(o)?o.parent:o;if(null!=l&&b(l)){if(v(l))continue;t.whenLayerView(l).then((t=>{e?.highlightHandle?.remove(),null!=e&&i&&n===this._vizTaskId&&"highlight"in t&&"function"==typeof t.highlight&&e.selection.length>0&&(e.highlightHandle=t.highlight(e.selection,"selection"))})).catch((()=>{e?.highlightHandle?.remove()}))}}}_refreshListeners(){this._layerEditHandles.drain(l.removeMaybe);for(const e of this.sources){const t=y.isSubtypeSublayer(e)?e.parent:e;if(null!=t&&_.isSelectableLayer(t)){const s=t.on("edits",(t=>{this._handleEditChanges(t,e)}));this._layerEditHandles.push(s)}}}_handleEditChanges(e,s){if(void 0!==e.deletedFeatures&&e.deletedFeatures.length>0&&this._selectionMap.has(s)){const i=e.deletedFeatures.filter((e=>null==e.error)).map((e=>e.objectId)).filter(t.isSome);this.removeFromSelection(s,i)}}_setSelection(e,s){if(!this.sources.includes(e))throw new Error(`Cannot set selection on layer ${e.title} because it is not in 'sources'`);const i=this._selectionMap.get(e);if(void 0===i||!w(i,{selection:s})){void 0!==i&&this._trashCan.push(i),this._selectionMap.set(e,{selection:[...s]});const n={layer:e,selection:[...s],...t.difference(void 0!==i?i.selection:[],s)};this._onSelectionChange([n])}}};e.__decorate([h.property({readOnly:!0,nonNullable:!0})],g.prototype,"selections",null),e.__decorate([h.property({readOnly:!0,nonNullable:!0})],g.prototype,"count",null),e.__decorate([h.property({constructOnly:!0,nonNullable:!0})],g.prototype,"view",void 0),e.__decorate([h.property({readOnly:!0,nonNullable:!0})],g.prototype,"hasSelection",null),e.__decorate([h.property()],g.prototype,"showHighlight",void 0),e.__decorate([h.property()],g.prototype,"sources",null),g=e.__decorate([p.subclass("esri.views.SelectionManager")],g);const v=e=>y.isSubtypeSublayer(e)?!0===e.parent?.isTable:e.isTable,S=e=>void 0!==e.layer,b=e=>void 0!==e?.when,w=(e,t)=>{if(null==e&&null==t)return!0;if(null!=e&&null==t||null==e&&null!=t)return!1;if(null!=e&&null!=t&&null!=e.selection&&null!=t.selection){const s=[...e.selection],i=[...t.selection];if(s.length!==i.length)return!1;s.sort(),i.sort();for(let e=0;e<s.length;e++)if(s[e]!==i[e])return!1}return!0},m=async(e,t,s={})=>{let i;if(S(e)){const n=e;i=void 0===n?null:await n.queryFeatures(new f({...s,objectIds:t})).then((t=>({data:t,layer:e.layer})))}else{const n=e;i=void 0===n?null:await n.queryFeatures(new f({...s,objectIds:t})).then((e=>({data:e,layer:n})))}return i};return g}));
