/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../chunks/tslib.es6","../core/Accessor","../core/clock","../core/Collection","../core/has","../core/Logger","../core/maybe","../core/reactiveUtils","../core/accessorSupport/decorators/property","../core/RandomLCG","../core/accessorSupport/decorators/subclass","../core/support/UpdatingHandles","./input/InputManager","./input/ViewEvents","./interactive/interactiveToolUtils","./interactive/interfaces","./interactive/ToolViewManagerManipulatorState"],(function(t,e,o,i,a,r,n,s,l,c,h,u,p,d,_,v,g,T){"use strict";const m="attached",E="tools",w=1e3;t.ToolViewManager=class extends o{constructor(t){super(t),this._updatingHandles=new p.UpdatingHandles,this._clock=i.clock,this._manipulatorState=new T.ToolViewManagerManipulatorState,this.tools=new a,this.cursor=null,this._interacting=!1,this._interactingTimeout=w,this._interactingTimeoutHandle=null,this._forEachTool=t=>{for(const e of this.tools.items)if(t(e))return}}initialize(){this.addHandles([this.view.on(_.eventTypes,(t=>{this._handleInputEvent(t)}),d.ViewEventPriorities.TOOL),...v.getToolCollectionHandles(this.tools),this.tools.on("before-add",(({item:t})=>{this._updateToolEditableFlag(t)})),this.tools.on("before-remove",(({item:t})=>{this._manipulatorState.clearPointers(t,this._manipulatorStateEventArgs),this._updateCursor()})),this.tools.on("change",(()=>{this._refreshToolWatchers()}))])}destroy(){this.activeTool=null,this.tools.drain((t=>t.destroy())),this._clearInteractingTimeout(),this._interacting=!1,this._updatingHandles.destroy()}get _manipulatorStateEventArgs(){return{forEachTool:this._forEachTool,activeTool:this.activeTool,setActiveTool:t=>{this.activeTool=t},view:this.view}}set activeTool(t){if(null!=t&&!this.view.ready)return void n.getLogger(this).error("Cannot set active tool while view is not ready.");if(t===this.activeTool)return;const e=this.activeTool;this._set("activeTool",t),null!=e&&e.deactivate(),null!=t&&t.activate(),this._removeIncompleteTools(t);for(const o of this.tools){this._updateToolEditableFlag(o);const t=v.areToolManipulatorsEditable(o);null!=this.activeTool&&t||this._manipulatorState.clearPointers(o,this._manipulatorStateEventArgs,!t)}this._updateCursor()}get updating(){return this._updatingHandles.updating||this.tools.some((t=>t.updating))}get interacting(){return this._interacting}_clearInteractingTimeout(){this._interactingTimeoutHandle=s.removeMaybe(this._interactingTimeoutHandle)}_startInteractingTimeout(){this._clearInteractingTimeout(),this._interactingTimeoutHandle=this._clock.setTimeout((()=>this._interacting=!1),this._interactingTimeout)}attach(){"3d"===this.view.type?this.addHandles([l.watch((()=>{const{state:t}=this.view;return"camera"in t&&t.camera}),(()=>this._forEachManipulator((t=>t.onViewChange())))),this.view.elevationProvider?.on("elevation-change",(t=>this._forEachManipulator((e=>e.onElevationChange(t)))))],m):this.addHandles(l.watch((()=>this.view.extent),(()=>this._forEachManipulator((t=>t.onViewChange())))))}detach(){this.activeTool=null,this.tools.removeAll(),this.removeHandles(m),this._clearInteractingTimeout(),this._interacting=!1}_forEachManipulator(t){this._forEachTool((e=>{e.manipulators&&e.manipulators.forEach((({manipulator:o})=>t(o,e)))}))}_handleInputEvent(t){let e=!1;const o={...t,stopPropagation:()=>{e=!0,t.stopPropagation()}};null!=this.activeTool?this.activeTool.handleInputEvent&&this.activeTool.handleInputEvent(o):this._forEachTool((t=>{!e&&t.visible&&t.handleInputEvent(o)})),!e&&"key-down"===t.type&&"Escape"===t.key&&this.activeTool&&(t.stopPropagation(),this.activeTool=null),this._manipulatorState.handleInputEvent(o,this._manipulatorStateEventArgs),e||null==this.activeTool||this.activeTool.handleInputEventAfter(o),this._manipulatorState.handleHoverEvent(o,this._forEachTool),this._updateCursor(),"pointer-move"===t.type&&(this._manipulatorState.hasFocusedManipulators()||this.activeTool)&&(this._interacting=!0,this._startInteractingTimeout())}_refreshToolWatchers(){this.removeHandles(E),this._forEachTool((t=>{if(t instanceof o){const e=l.watch((()=>[t.cursor,t.visible,t.editable]),(()=>{v.areToolManipulatorsEditable(t)||this._manipulatorState.clearPointers(t,this._manipulatorStateEventArgs),this._updateCursor()}));this.addHandles(e,E)}t.manipulators&&this.addHandles([t.manipulators.on("after-remove",(e=>{this._manipulatorState.clearPointers(t,this._manipulatorStateEventArgs,!0,e.item.manipulator)})),t.manipulators.on("change",(()=>{this._manipulatorState.updateHoveredStateFromKnownPointers(this._forEachTool),this._updateCursor()}))],E)})),this._manipulatorState.updateHoveredStateFromKnownPointers(this._forEachTool),this._updateCursor()}_updateToolEditableFlag(t){t.setEditableFlag?.(g.EditableFlag.MANAGER,null==this.activeTool||t===this.activeTool)}_updateCursor(){let t=this._manipulatorState.cursor;null==t&&this._forEachTool((e=>!(null==e.cursor||!e.visible)&&(t=e.cursor,!0))),this._get("cursor")!==t&&this._set("cursor",t)}_removeIncompleteTools(t){this.tools.filter((e=>(null==t||e!==t)&&!e.created&&e.removeIncompleteOnCancel)).forEach((t=>{this.tools.remove(t)}))}get test(){}},e.__decorate([c.property({constructOnly:!0,nonNullable:!0})],t.ToolViewManager.prototype,"view",void 0),e.__decorate([c.property({value:null})],t.ToolViewManager.prototype,"activeTool",null),e.__decorate([c.property({readOnly:!0,type:a})],t.ToolViewManager.prototype,"tools",void 0),e.__decorate([c.property({readOnly:!0})],t.ToolViewManager.prototype,"cursor",void 0),e.__decorate([c.property({readOnly:!0})],t.ToolViewManager.prototype,"updating",null),e.__decorate([c.property()],t.ToolViewManager.prototype,"_interacting",void 0),e.__decorate([c.property({readOnly:!0})],t.ToolViewManager.prototype,"interacting",null),t.ToolViewManager=e.__decorate([u.subclass("esri.views.ToolViewManager")],t.ToolViewManager),t.interactingTimeout=w,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
