/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../Map","../core/Accessor","../core/asyncUtils","../core/Collection","../core/CollectionFlattener","../core/Error","../core/Evented","../core/Handles","../core/handleUtils","../core/has","../core/Loadable","../core/Logger","../core/maybe","../core/Promise","../core/promiseUtils","../core/reactiveUtils","../core/accessorSupport/decorators/property","../core/RandomLCG","../core/accessorSupport/decorators/subclass","../core/support/OwningCollection","../core/support/UpdatingHandles","../geometry/Extent","../geometry/HeightModelInfo","../geometry/SpatialReference","../geometry/support/spatialReferenceUtils","../support/AnalysesCollection","../support/GraphicsCollection","../time/TimeExtent","../time/timeZoneUtils","./BasemapView","./LayerViewManager","./Magnifier","./SelectionManager","./Theme","./ToolViewManager","./input/Input","./input/ViewEvents","./navigation/Navigation","./support/DefaultsFromMap"],(function(e,t,r,i,a,o,s,n,l,p,d,h,y,c,u,_,g,w,m,f,v,M,V,R,S,b,E,T,F,x,L,C,k,O,I,Z,D,H,P,A){"use strict";var q;let U=q=class extends(n.EventedMixin(u.EsriPromiseMixin(r))){constructor(e){super(e),this._userSpatialReference=null,this._cursor=null,this.handles=new l,this.updatingHandles=new M.UpdatingHandles,this.allLayerViews=new o({getCollections:()=>[this.basemapView?.baseLayerViews,this.groundView?.layerViews,this.layerViews,this.basemapView?.referenceLayerViews],getChildrenFunction:z}),this.groundView=null,this.basemapView=null,this.fatalError=null,this.graphics=new T.GraphicsCollection,this.analyses=new E.AnalysesCollection,this.typeSpecificPreconditionsReady=!0,this.layerViews=new a,this.magnifier=new k,this.padding={left:0,top:0,right:0,bottom:0},this.ready=!1,this.spatialReferenceWarningDelay=1e3,this.supportsGround=!0,this.type=null,this.scale=null,this.updating=!1,this.initialExtentRequired=!0,this.input=new D,this.navigation=new P,this.layerViewManager=null,this.analysisViewManager=null,this.isHeightModelInfoRequired=!1,this.width=null,this.height=null,this.resizing=!1,this.suspended=!1,this.viewEvents=new H.ViewEvents(this),this.persistableViewModels=new a,this._isValid=!1,this._readyCycleForced=!1,this._lockedSpatialReference=null,this._userTimeZone=null,this._lockedTimeZone=null,this._userTimeExtent=null,this._lockedTimeExtent=null,this.theme=null,this.handles.add(g.watch((()=>this.preconditionsReady),(e=>{const t=this.ready;if(e?(this._lockedSpatialReference=this.spatialReference,this._lockedTimeZone=this.timeZone,this._lockedTimeExtent=this.timeExtent,q.views.add(this)):(this._lockedSpatialReference=null,q.views.remove(this)),this.notifyChange("spatialReference"),!e&&t)this.toolViewManager?.detach(),null!=this.analysisViewManager&&this.analysisViewManager.detach(),this.layerViewManager?.clear(),this._teardown();else if(e&&!t){try{this._startup()}catch(r){return void queueMicrotask((()=>{this.fatalError=new s("startup-error",null,r)}))}null!=this.analysisViewManager&&this.analysisViewManager.attach(),this.toolViewManager.attach()}}),g.sync))}initialize(){this.addResolvingPromise(Promise.all([this.loadAsyncDependencies(),this.validate()]).then((()=>(this._isValid=!0,g.whenOnce((()=>this.ready)))))),this.basemapView=new L({view:this}),this.layerViewManager=new C({view:this,layerViewImporter:{importLayerView:e=>this.importLayerView(e),hasLayerViewModule:e=>this.hasLayerViewModule(e)},supportsGround:this.supportsGround}),this.toolViewManager=new Z.ToolViewManager({view:this}),this._setupSpatialReferenceLogger(),this.selectionManager=new O({view:this}),this.addHandles([g.watch((()=>this.initialExtentRequired),(e=>this.defaultsFromMap.required={...this.defaultsFromMap.required,extent:e}),g.syncAndInitial),g.watch((()=>this.ready),(e=>{this.defaultsFromMap&&(this.defaultsFromMap.suspended=e,this.defaultsFromMap.userSpatialReference=e?this.spatialReference:this._userSpatialReference)}),g.sync),g.watch((()=>this._userSpatialReference),(e=>{this.defaultsFromMap&&(this.defaultsFromMap.userSpatialReference=e)}),g.syncAndInitial)])}_setupSpatialReferenceLogger(){let e=null;this.addHandles([g.watch((()=>this.defaultsFromMap?.ready),(t=>{const r=this.map?.allLayers.length>0;if(t&&!this.spatialReference&&r){if(null!=e)return;const t=p.makeHandle((()=>e=c.abortMaybe(e)));e=i.createTask((async t=>{try{await _.after(this.spatialReferenceWarningDelay,null,t)}catch{return}finally{e=null}y.getLogger(this).warn("#spatialReference","no spatial reference could be derived from the currently added map layers")})),this.addHandles(t,"spatial-reference-logger-task")}else this.removeHandles("spatial-reference-logger-task")}),{sync:!0})])}destroy(){this.destroyed||(q.views.remove(this),this.viewEvents.destroy(),this.allLayerViews.destroy(),this.navigation&&(this.navigation.destroy(),this._set("navigation",null)),this.graphics=c.destroyMaybe(this.graphics),this.analyses=c.destroyMaybe(this.analyses),this.defaultsFromMap.destroy(),this._set("defaultsFromMap",null),c.destroyMaybe(this.analysisViewManager),this.toolViewManager=c.destroyMaybe(this.toolViewManager),this.layerViewManager=c.destroyMaybe(this.layerViewManager),this.selectionManager=c.destroyMaybe(this.selectionManager),this.basemapView=c.destroyMaybe(this.basemapView),this.groundView?.destroy(),this.layerViews?.forEach((e=>e.destroy())),this.layerViews.length=0,this.invalidate(),this._emitter.clear(),this.handles.destroy(),this.map=c.destroyMaybe(this.map),this.updatingHandles.destroy())}_startup(){this._set("ready",!0)}_teardown(){this._set("ready",!1)}whenReady(){return Promise.resolve(this)}toMap(){return y.getLogger(this).error("#toMap()","Not implemented on this instance of View"),null}get activeTool(){return this.toolViewManager?.activeTool}set activeTool(e){this.toolViewManager&&(this.toolViewManager.activeTool=e)}get animation(){return this._get("animation")}set animation(e){this._set("animation",e)}get center(){return null}get defaultsFromMapSettings(){return{}}get defaultsFromMap(){return new A.DefaultsFromMap({required:{tileInfo:!1,heightModelInfo:!1,extent:!1},map:()=>this.map,getSpatialReferenceSupport:(e,t)=>this.getSpatialReferenceSupport(e,t),...this.defaultsFromMapSettings})}get extent(){return this._get("extent")}set extent(e){this._set("extent",e)}get heightModelInfo(){return this.getDefaultHeightModelInfo()}get interacting(){return this.navigating}get navigating(){return!1}get preconditionsReady(){return!(this.fatalError||!this._isValid||this._readyCycleForced||!this.map||h.isLoadable(this.map)&&!this.map.loaded||0===this.width||0===this.height||!this.spatialReference||!this._validateSpatialReference(this.spatialReference)||!this._lockedSpatialReference&&!this.defaultsFromMap?.ready||!this.typeSpecificPreconditionsReady)}get resolution(){return 0}set map(e){e!==this._get("map")&&(e?.destroyed&&(y.getLogger(this).warn("#map","The provided map is already destroyed",{map:e}),e=null),h.isLoadable(e)&&e.load().catch((()=>{})),this.constructed&&!this.destroyed&&(this.forceReadyCycle(),this._lockedSpatialReference=null),this._set("map",e))}get spatialReference(){const e=this._userSpatialReference||this._lockedSpatialReference||this.getDefaultSpatialReference()||null;if(e&&this.defaultsFromMap?.required?.heightModelInfo){const t=e.clone();return t.vcsWkid=this.defaultsFromMap.vcsWkid,t.latestVcsWkid=this.defaultsFromMap.latestVcsWkid,t}return e}set spatialReference(e){const t=!b.equals(e,this._get("spatialReference"));this._set("_userSpatialReference",e),t&&(this._set("spatialReference",e),this._spatialReferenceChanged(e))}_spatialReferenceChanged(e){}get stationary(){return!this.animation&&!this.navigating&&!this.resizing}get timeExtent(){return this._userTimeExtent??this._lockedTimeExtent??this.getDefaultTimeExtent()??null}set timeExtent(e){this._userTimeExtent=e}get timeZone(){return this._userTimeZone??this._lockedTimeZone??this.getDefaultTimeZone()??x.system}set timeZone(e){this._userTimeZone=e,x.isTimeZoneValid(e)||y.getLogger(this).warn("#timeZone",`the parsed value '${e}' may not be a valid IANA time zone`)}get tools(){return this.toolViewManager?.tools}get initialExtent(){return this.defaultsFromMap?.extent}get cursor(){return this.toolViewManager?.cursor??this._cursor??"default"}set cursor(e){this._cursor=e,this.notifyChange("cursor")}get size(){return[this.width,this.height]}get effectiveTheme(){return this.theme??new I}whenLayerView(e){return this.layerViewManager?.whenLayerView(e)??Promise.reject()}getDefaultSpatialReference(){return this.defaultsFromMap?.spatialReference}getDefaultHeightModelInfo(){return(this.map&&"heightModelInfo"in this.map?this.map.heightModelInfo:void 0)??this.defaultsFromMap?.heightModelInfo??null}getDefaultTimeZone(){return null}getDefaultTimeExtent(){return null}importLayerView(e){throw new s("importLayerView() not implemented")}hasLayerViewModule(e){return!1}async validate(){}async loadAsyncDependencies(){}invalidate(){this._isValid=!1}getSpatialReferenceSupport(){return{constraints:null}}_validateSpatialReference(e){return null!=this.getSpatialReferenceSupport(e)}when(e,t){return this.isResolved()&&!this.ready&&y.getLogger(this).warn("#when()","Calling view.when() while the view is no longer ready but was already resolved once will resolve immediately. Use reactiveUtils.whenOnce(() => view.ready).then(...) instead."),super.when(e,t)}forceReadyCycle(){this.ready&&(g.when((()=>this.destroyed||!1===this.preconditionsReady),(()=>this._readyCycleForced=!1),{once:!0}),this._readyCycleForced=!0)}addAndActivateTool(e){this.toolViewManager.tools.add(e),this.activeTool=e}tryFatalErrorRecovery(){this.fatalError=null}};U.views=new a,e.__decorate([w.property()],U.prototype,"_userSpatialReference",void 0),e.__decorate([w.property()],U.prototype,"activeTool",null),e.__decorate([w.property({readOnly:!0})],U.prototype,"allLayerViews",void 0),e.__decorate([w.property()],U.prototype,"groundView",void 0),e.__decorate([w.property()],U.prototype,"animation",null),e.__decorate([w.property()],U.prototype,"basemapView",void 0),e.__decorate([w.property()],U.prototype,"center",null),e.__decorate([w.property()],U.prototype,"defaultsFromMapSettings",null),e.__decorate([w.property()],U.prototype,"defaultsFromMap",null),e.__decorate([w.property()],U.prototype,"fatalError",void 0),e.__decorate([w.property({type:V})],U.prototype,"extent",null),e.__decorate([w.property(v.owningCollectionProperty(T.GraphicsCollection,"graphics"))],U.prototype,"graphics",void 0),e.__decorate([w.property(v.owningCollectionProperty(E.AnalysesCollection,"analyses"))],U.prototype,"analyses",void 0),e.__decorate([w.property({readOnly:!0,type:R})],U.prototype,"heightModelInfo",null),e.__decorate([w.property({readOnly:!0})],U.prototype,"interacting",null),e.__decorate([w.property({readOnly:!0})],U.prototype,"navigating",null),e.__decorate([w.property({readOnly:!0,dependsOn:["fatalError","_isValid","_readyCycleForced","map","map.loaded?","width","height","spatialReference","_lockedSpatialReference","defaultsFromMap.ready","typeSpecificPreconditionsReady"]})],U.prototype,"preconditionsReady",null),e.__decorate([w.property({readOnly:!0})],U.prototype,"typeSpecificPreconditionsReady",void 0),e.__decorate([w.property({type:a,readOnly:!0})],U.prototype,"layerViews",void 0),e.__decorate([w.property()],U.prototype,"resolution",null),e.__decorate([w.property({type:k})],U.prototype,"magnifier",void 0),e.__decorate([w.property({value:null,type:t})],U.prototype,"map",null),e.__decorate([w.property()],U.prototype,"padding",void 0),e.__decorate([w.property({readOnly:!0})],U.prototype,"ready",void 0),e.__decorate([w.property({type:S})],U.prototype,"spatialReference",null),e.__decorate([w.property()],U.prototype,"spatialReferenceWarningDelay",void 0),e.__decorate([w.property()],U.prototype,"stationary",null),e.__decorate([w.property({readOnly:!0})],U.prototype,"supportsGround",void 0),e.__decorate([w.property({type:F})],U.prototype,"timeExtent",null),e.__decorate([w.property({type:String,nonNullable:!0})],U.prototype,"timeZone",null),e.__decorate([w.property()],U.prototype,"tools",null),e.__decorate([w.property()],U.prototype,"toolViewManager",void 0),e.__decorate([w.property({readOnly:!0})],U.prototype,"type",void 0),e.__decorate([w.property({type:Number})],U.prototype,"scale",void 0),e.__decorate([w.property({readOnly:!0})],U.prototype,"updating",void 0),e.__decorate([w.property({readOnly:!0})],U.prototype,"initialExtentRequired",void 0),e.__decorate([w.property({readOnly:!0})],U.prototype,"initialExtent",null),e.__decorate([w.property()],U.prototype,"cursor",null),e.__decorate([w.property({readOnly:!0})],U.prototype,"input",void 0),e.__decorate([w.property({type:P,nonNullable:!0})],U.prototype,"navigation",void 0),e.__decorate([w.property()],U.prototype,"layerViewManager",void 0),e.__decorate([w.property()],U.prototype,"analysisViewManager",void 0),e.__decorate([w.property()],U.prototype,"selectionManager",void 0),e.__decorate([w.property()],U.prototype,"width",void 0),e.__decorate([w.property()],U.prototype,"height",void 0),e.__decorate([w.property({readOnly:!0})],U.prototype,"resizing",void 0),e.__decorate([w.property({value:null,readOnly:!0})],U.prototype,"size",null),e.__decorate([w.property({readOnly:!0})],U.prototype,"suspended",void 0),e.__decorate([w.property({readOnly:!0})],U.prototype,"viewEvents",void 0),e.__decorate([w.property({readOnly:!0})],U.prototype,"persistableViewModels",void 0),e.__decorate([w.property()],U.prototype,"_isValid",void 0),e.__decorate([w.property()],U.prototype,"_readyCycleForced",void 0),e.__decorate([w.property()],U.prototype,"_lockedSpatialReference",void 0),e.__decorate([w.property()],U.prototype,"_userTimeZone",void 0),e.__decorate([w.property()],U.prototype,"_lockedTimeZone",void 0),e.__decorate([w.property()],U.prototype,"_userTimeExtent",void 0),e.__decorate([w.property()],U.prototype,"_lockedTimeExtent",void 0),e.__decorate([w.property({type:I})],U.prototype,"theme",void 0),e.__decorate([w.property({readOnly:!0,type:I})],U.prototype,"effectiveTheme",null),U=q=e.__decorate([f.subclass("esri.views.View")],U);const G=globalThis.$arcgis;G&&!G.views&&Object.defineProperty(G,"views",{configurable:!1,enumerable:!0,writable:!1,value:U.views});function z(e){return e.layerViews}return U}));
