/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../geometry","../Viewpoint","../core/Collection","../core/CollectionFlattener","../core/Error","../core/has","../core/Logger","../core/maybe","../core/reactiveUtils","../core/workers/workers","../core/accessorSupport/decorators/property","../core/accessorSupport/decorators/cast","../core/RandomLCG","../core/accessorSupport/decorators/subclass","../core/accessorSupport/ensureType","../geometry/projection","../layers/support/TileInfo","./BreakpointsOwner","./DOMContainer","./PopupView","./View","./2d/AnimationManager","./2d/FrameTask","./2d/GoToManager","./2d/layerViewModuleImportUtils","./2d/MapViewConstraints","./2d/tiling/TileInfoView","./2d/tiling/TileKey","./2d/tiling/TileQueue","./2d/tiling/TileStrategy","./2d/viewpointUtils","./2d/ViewStateManager","./2d/input/MapViewInputManager","./2d/layers/features/support/TileStore","./2d/layers/support/util","./2d/support/clippingUtils","./2d/support/HighlightGroup","./2d/support/highlightGroupUtils","./2d/support/HighlightOptions","./2d/support/hitTestUtils","./2d/support/screenshotUtils","./2d/support/StationaryManager","./2d/support/Timeline","./support/screenUtils","./support/WebGLRequirements","./ui/DefaultUI","./ui/2d/DefaultUI2D","../webmap/utils","../webmap/background/ColorBackground","../geometry/Polygon"],(function(e,t,i,r,a,s,n,o,p,l,h,d,g,c,u,y,w,_,m,f,M,V,v,b,S,O,T,L,R,k,C,D,P,E,x,G,I,A,z,U,q,F,W,H,N,$,B,Z,j,J,K,Q){"use strict";let X,Y,ee,te,ie,re,ae;async function se(){const[,{GraphicsView2D:t,GraphicContainer:i,LabelManager:r,MapViewNavigation:a,MagnifierView2D:s,GridView2D:n,Stage:o}]=await Promise.all([new Promise(((t,i)=>e(["./2d/webglDeps"],t,i))),new Promise(((t,i)=>e(["./2d/mapViewDeps"],t,i)))]);Y=t,ee=i,te=r,ie=a,re=s,ae=n,X=o}let ne=class extends(f.BreakpointsOwner(V.PopupView(M.DOMContainer(v)))){constructor(e){super(e),this._magnifierView=null,this._gridView=null,this.stage=null,this._resolveWhenReady=[],this.rootLayerViews=new s({getCollections:()=>[this.basemapView?.baseLayerViews,this.layerViews,this.basemapView?.referenceLayerViews],getChildrenFunction:()=>null}),this.featuresTilingScheme=null,this.fullOpacity=1,this.goToManager=new O.GoToManager({view:this}),this.graphicsView=null,this.stateManager=new E.ViewStateManager({constraints:new L({view:this})}),this.stationaryManager=new H.StationaryManager,this.labelManager=null,this.mapViewNavigation=null,this.renderingOptions={samplingMode:"dynamic",edgeLabelsVisible:!0,labelsAnimationTime:125,labelCollisionsEnabled:!0},this.supersampleScreenshotsEnabled=!0,this.supportsGround=!1,this.frameTask=new S(this),this.floors=new a,this.grid=null,this.highlights=U.createInitialHighlightGroups(),this.inputManager=new x({view:this}),this.map=null,this.spatialReferenceLocked=!1,this.timeline=new N.Timeline,this.type="2d",this.view2dType=null,this.ui=new j,this.test={takeScreenshot:async e=>W.takeRawScreenshot(this._getScreenshotView(e),e)},this.padding={top:0,right:0,bottom:0,left:0},this.addHandles([h.watch((()=>this.viewpoint),(()=>this.stationaryManager.flip()),h.sync),this.on("resize",(e=>this.stateManager.resize(e.width,e.height)))]),d.initialize()}destroy(){this.layerViewManager.clear(),this._set("preconditionsReady",!1),this.frameTask=l.destroyMaybe(this.frameTask),this.goToManager.destroy(),this.rootLayerViews.destroy(),this.inputManager.destroy(),this._set("inputManager",null)}get graphicsTileStore(){return new G(this.featuresTilingScheme)}get constraintsInfo(){const e=this.defaultsFromMap?.tileInfo,t=this.spatialReference;return{lods:e?.spatialReference?.equals(t)?e.lods:null,spatialReference:t}}get state(){return this.stateManager.state}get initialExtentRequired(){if(!this.stateManager)return!1;const{scale:e,constraints:t,center:i,viewpoint:r,extent:a}=this;let s=this.zoom;return!(this.map&&"initialViewProperties"in this.map&&this.map.initialViewProperties?.viewpoint)&&(!a&&(t?.effectiveLODs||(s=-1),(!i||0===e&&-1===s)&&(null==r?.targetGeometry||"extent"!==r.targetGeometry.type&&!r.scale)))}get defaultsFromMapSettings(){return{required:{extent:!1,heightModelInfo:!1,tileInfo:!0},requiresExtentInSpatialReference:this.spatialReferenceLocked}}get scheduler(){return this.frameTask.scheduler}get typeSpecificPreconditionsReady(){const e=this._getDefaultViewpoint();if(!e)return!1;const t=e.targetGeometry,i=this.spatialReference;return _.isLoadedOrLoadFor(t.spatialReference,i)}set animation(e){const t=this._get("animation");if(e===t)return;if(t&&t.stop(),e!==this.animationManager.animation&&this.animationManager.stop(),!e||e.isFulfilled())return void this._set("animation",null);this._set("animation",e);const i=()=>{this.destroyed||e===this._get("animation")&&(this._set("animation",null),this.frameTask?.requestFrame())};e.when(i,i)}get background(){return J.isWebMap(this.map)?this.map.initialViewProperties.background:null}set background(e){this._override("background",e)}get center(){return this.stateManager?.center??null}set center(e){this.stateManager.center=e}get constraints(){return this.stateManager?.constraints}set constraints(e){e.view=this;const t=this.stateManager.constraints;this.stateManager.constraints=e,t?.destroy()}get extent(){return this.stateManager?.extent??null}set extent(e){this.stateManager.extent=e}get highlightOptions(){return U.getDefaultHighlightOptions(this)}set highlightOptions(e){U.setDefaultHighlightOptions(this,e)}get padding(){return this.stateManager?.padding}set padding(e){this.stateManager&&(this.stateManager.padding=e)}get rendering(){return this.stage?.renderRequested??!1}get resizeAlign(){return this.stateManager.resizeAlign}set resizeAlign(e){this.stateManager.resizeAlign=e}get resolution(){return this.stateManager.resolution??0}get rotation(){return this.stateManager.rotation??0}set rotation(e){const{rotationEnabled:t}=this.constraints;this.constraints.rotationEnabled=!0,this.stateManager.rotation=e,this.constraints.rotationEnabled=t}get scale(){return this.stateManager?.scale??0}set scale(e){this.stateManager&&(this.stateManager.scale=e)}get stationary(){return!this.animation&&!this.navigating&&!this.resizing&&this.stationaryManager.stationary}get tileInfo(){return this.featuresTilingScheme?.tileInfo}get updating(){const e=!(!this.magnifier.visible||null===this.magnifier.position||!this._magnifierView?.updatingHandles.updating),t=!this.destroyed&&(!this.layerViewManager||!this.labelManager||!this.graphicsView||!0===this.layerViewManager.updating||!0===this.labelManager.updating||!0===this.graphicsView.updating||this.allLayerViews.some((e=>!e.destroyed&&!("layerViews"in e)&&!0===e.updating))||e);if(o("esri-2d-log-updating")){const i=this.allLayerViews.reduce(((e,t)=>({...e,[`${t.layer.id}(${t.layer.type})`]:!t.destroyed&&!("layerViews"in t)&&t.updating})),{});console.log(`Updating MapView: ${t}\n-> Null LayerViewManager: ${!this.layerViewManager}\n-> Null LabelManager: ${!this.labelManager}\n-> Null GraphicsView: ${!this.graphicsView}\n-> layerViewManager.updating: ${this.layerViewManager?.updating}\n-> labelManager.updating: ${this.labelManager?.updating}\n-> graphicsView.updating: ${this.graphicsView?.updating}\n-> allLayerViews: ${JSON.stringify(i)}\n-> updatingMagnifier: ${e}\n`)}return t}get viewpoint(){return this.stateManager.viewpoint??null}set viewpoint(e){this.stateManager.viewpoint=e,this.frameTask.requestFrame()}get visibleArea(){const e=this.stateManager.visibleArea;return e?new Q({rings:[e.map((e=>[e[0],e[1]]))],spatialReference:this.spatialReference}):e}get zoom(){return this.stateManager.zoom??-1}set zoom(e){this.stateManager.zoom=e}get navigating(){return this.mapViewNavigation?.interacting??!1}goTo(e,t){return this.goToManager.goTo(e,t)}async hitTest(e,t){return F.hitTest(this,e,t)}async takeScreenshot(e){return W.takeScreenshot(this._getScreenshotView(e),e)}toMap(e){if(!this.ready)return null;const t=$.isSupportedScreenPointEvent(e)?$.createScreenPointFromSupportedEvent(this,e):e;return this.stateManager.toMap(t)}toScreen(e,t){return this.stateManager.toScreen(e,t)}on(e,t,i,r){const a=this.inputManager&&this.viewEvents.on(e,t,i,r);return a||super.on(e,t)}hasEventListener(e){return super.hasEventListener(e)||this.viewEvents.hasHandler(e)}whenLayerView(e){return super.whenLayerView(e)}graphicChanged(e){if(this.graphicsView){this.graphicsView.graphicUpdateHandler(e)}}whenReady(){return new Promise((e=>{this.ready?e(this):this._resolveWhenReady.push(e)}))}forceDOMReadyCycle(){this.forceReadyCycle()}getDefaultSpatialReference(){return this.map&&"initialViewProperties"in this.map&&this.map.initialViewProperties.spatialReference||this.defaultsFromMap?.spatialReference||null}getDefaultTimeZone(){return J.isWebMap(this.map)?this.map.initialViewProperties.timeZone:null}getDefaultTimeExtent(){return J.isWebMap(this.map)?this.map.initialViewProperties.timeExtent:null}hasLayerViewModule(e){return T.layerView2DImporter.hasLayerViewModule(e)}importLayerView(e){return T.layerView2DImporter.importLayerView(e)}pixelSizeAt(){return this.ready?this.resolution:(p.getLogger(this).error("#pixelSizeAt()","Map view cannot be used before it is ready"),null)}async popupHitTest(e){const t=this.toMap(e),i=await this.hitTest(e),r=this.allLayerViews.toArray().filter((i=>i.clips.every((i=>A.clipContainsPoint(this,i,e,t))))).reverse(),a=new globalThis.Map(r.map((e=>[e.layer.uid,e]))),s=[];let n=0,o=0;for(;n<i.results.length||o<r.length;){const e=i.results.at(n);if(e&&"graphic"!==e.type){++n;continue}const p=a.get((e?.layer??e?.graphic.layer)?.uid);if((!e||p)&&o<r.length&&r.at(o)!==p){const e=r.at(o);"fetchPopupFeaturesAtLocation"in e&&s.push({mapPoint:t,layerView:e}),++o}else e&&(s.push({graphic:e.graphic,layerView:p}),++n)}return{hits:s,location:t}}requestUpdate(){this.ready&&this.frameTask.requestUpdate()}async validate(){let e=B.check(this.type);if(o("safari")&&o("safari")<9&&(e=new n("mapview:browser-not-supported","This browser is not supported by MapView (Safari < 9)",{type:"safari",requiredVersion:9,detectedVersion:o("safari")})),null!=e)throw p.getLogger(this).warn("#validate()",e.message),e}loadAsyncDependencies(){return se()}_getDefaultViewpoint(){const{constraints:e,initialExtent:t,map:i,padding:a,size:s}=this;if(!e)return null;const n=i&&"initialViewProperties"in i?i.initialViewProperties:void 0,o=this.stateManager.getUserStartupOptions(this.size),p=n?.viewpoint,l=p?.targetGeometry?.extent??t,h=l?.center,d=p?.rotation??0,g=p?.scale||l&&P.extentToScale(l,[s[0]-a.left-a.right,s[1]-a.top-a.bottom]),c=o.center??h,u=o.rotation??d,y=o.scale??g;return c&&y?new r({targetGeometry:c,scale:y,rotation:u}):null}_startup(){this.timeline.begin("MapView Startup");const e=this._getDefaultViewpoint();this.stateManager.startup(e,this.size,this.spatialReference,this.defaultsFromMap.extent?.center),this.graphics.owner=this;const t=new X(this.surface,{canvas:this.renderCanvas,contextOptions:{disabledExtensions:this.deactivatedWebGLExtensions,debugWebGLExtensions:this.debugWebGLExtensions},renderingOptions:this.renderingOptions,timeline:this.timeline});this.stage=t,this._magnifierView=new re,this._magnifierView.magnifier=this.magnifier,this._gridView=new ae;const i=new te({view:this});this._set("labelManager",i);const r=new b({view:this});this._set("animationManager",r);const a=new ie({view:this,animationManager:r});this._set("mapViewNavigation",a),this._setupSpatialReferenceDependentProperties(),this.addHandles([this.rootLayerViews.on("change",(()=>this._updateStageChildren())),t.on("webgl-error",(e=>this.fatalError=e.error)),h.watch((()=>this.stationary),(e=>t.stationary=e),h.syncAndInitial),h.watch((()=>this.background),(e=>{t.backgroundColor=e?.color,this._magnifierView.backgroundColor=e?.color}),h.syncAndInitial),h.watch((()=>this.magnifier),(e=>this._magnifierView.magnifier=e),h.syncAndInitial),h.watch((()=>this.grid),(e=>this._gridView.grid=e),h.syncAndInitial),h.watch((()=>this.renderingOptions),(e=>t.renderingOptions=e),h.syncAndInitial),h.watch((()=>this.highlights.items.map((e=>({name:e.name,options:{fillColor:e.options.color,haloColor:e.options.haloColor,fillOpacity:e.options.fillOpacity,haloOpacity:e.options.haloOpacity,haloWidth:e.options.haloWidth,haloBlur:e.options.haloBlur}})))),(()=>{t.highlightGradient=I.createOrReuseHighlightGradient(t.highlightGradient,this.highlights.items)}),h.syncAndInitial),h.watch((()=>this.state.id),(()=>t.state=this.state),h.syncAndInitial)],"map-view"),this._updateStageChildren();const s=this._resolveWhenReady;this._resolveWhenReady=[],s.forEach((e=>e(this))),this.timeline.end("MapView Startup"),this.frameTask.start(),this._set("ready",!0)}_teardown(){this._destroySpatialReferenceDependentProperties(),this.removeHandles("map-view"),this.mapViewNavigation.destroy(),this._set("mapViewNavigation",null),this.animation=null,this.animationManager.destroy(),this._set("animationManager",null),this.layerViewManager.clear(),this.labelManager.destroy(),this._magnifierView.destroy(),this._gridView.destroy(),this.stage.destroy(),this.stage=null,this._set("graphicsView",null),this._magnifierView=null,this._gridView=null,this._set("labelManager",null),this._set("mapViewNavigation",null),this.graphics.owner=null,this.frameTask.stop(),this.stationaryManager.clear(),this._set("ready",!1),this.stateManager.teardown()}_updateStageChildren(){this.stage.removeAllChildren(),this.rootLayerViews.forEach((e=>{this.stage.addChild(e.container)}));const e=this.graphicsView;this.stage.addChild(e.container),this.stage.addChild(this._magnifierView),this.stage.addChild(this._gridView)}_setupSpatialReferenceDependentProperties(){const e=new R(m.create({spatialReference:this.spatialReference,size:512,numLODs:36}));this._set("featuresTilingScheme",e);const t=new Y({view:this,graphics:this.graphics,requestUpdateCallback:()=>this.requestUpdate(),container:new ee(e)});this._set("graphicsView",t)}_destroySpatialReferenceDependentProperties(){const e=this.graphicsView;this._set("graphicsView",null),e.destroy(),this._set("featuresTilingScheme",null)}_getScreenshotView(e){const{allLayerViews:t,padding:i,size:r,stage:a}=this;return{allLayerViews:t,backgroundColor:e?.ignoreBackground?null:this.background?.color,padding:i,size:r,stage:a}}_spatialReferenceChanged(e){if(this.ready){this.frameTask.stop();for(const e of this.allLayerViews)e.processDetach();this._destroySpatialReferenceDependentProperties(),this.stateManager.changeSpatialReference(e),this.stage.state=this.state,this._setupSpatialReferenceDependentProperties();for(const e of this.allLayerViews)e.processAttach();this.frameTask.requestFrame(),this.frameTask.start(),this._updateStageChildren()}}};ne.type="2d",t.__decorate([g.property({readOnly:!0})],ne.prototype,"animationManager",void 0),t.__decorate([g.property({constructOnly:!0})],ne.prototype,"deactivatedWebGLExtensions",void 0),t.__decorate([g.property({constructOnly:!0})],ne.prototype,"debugWebGLExtensions",void 0),t.__decorate([g.property({readOnly:!0})],ne.prototype,"featuresTilingScheme",void 0),t.__decorate([g.property({readOnly:!0})],ne.prototype,"fullOpacity",void 0),t.__decorate([g.property()],ne.prototype,"goToManager",void 0),t.__decorate([g.property({readOnly:!0})],ne.prototype,"graphicsTileStore",null),t.__decorate([g.property()],ne.prototype,"graphicsView",void 0),t.__decorate([g.property()],ne.prototype,"stateManager",void 0),t.__decorate([g.property()],ne.prototype,"constraintsInfo",null),t.__decorate([g.property({readOnly:!0})],ne.prototype,"state",null),t.__decorate([g.property()],ne.prototype,"initialExtentRequired",null),t.__decorate([g.property()],ne.prototype,"labelManager",void 0),t.__decorate([g.property({readOnly:!0})],ne.prototype,"mapViewNavigation",void 0),t.__decorate([g.property({constructOnly:!0})],ne.prototype,"renderCanvas",void 0),t.__decorate([g.property()],ne.prototype,"renderingOptions",void 0),t.__decorate([g.property({constructOnly:!0})],ne.prototype,"supersampleScreenshotsEnabled",void 0),t.__decorate([g.property({readOnly:!0})],ne.prototype,"supportsGround",void 0),t.__decorate([g.property()],ne.prototype,"defaultsFromMapSettings",null),t.__decorate([g.property({readOnly:!0})],ne.prototype,"typeSpecificPreconditionsReady",null),t.__decorate([g.property()],ne.prototype,"animation",null),t.__decorate([g.property({type:K})],ne.prototype,"background",null),t.__decorate([g.property()],ne.prototype,"center",null),t.__decorate([g.property({type:L})],ne.prototype,"constraints",null),t.__decorate([g.property()],ne.prototype,"extent",null),t.__decorate([g.property()],ne.prototype,"floors",void 0),t.__decorate([g.property()],ne.prototype,"grid",void 0),t.__decorate([g.property({type:q})],ne.prototype,"highlightOptions",null),t.__decorate([g.property({type:a.ofType(z.HighlightGroup)})],ne.prototype,"highlights",void 0),t.__decorate([g.property({readOnly:!0})],ne.prototype,"inputManager",void 0),t.__decorate([g.property()],ne.prototype,"map",void 0),t.__decorate([g.property()],ne.prototype,"padding",null),t.__decorate([g.property({readOnly:!0})],ne.prototype,"rendering",null),t.__decorate([g.property()],ne.prototype,"resizeAlign",null),t.__decorate([g.property({readOnly:!0})],ne.prototype,"resolution",null),t.__decorate([g.property()],ne.prototype,"rotation",null),t.__decorate([g.property()],ne.prototype,"scale",null),t.__decorate([g.property({constructOnly:!0})],ne.prototype,"spatialReferenceLocked",void 0),t.__decorate([g.property()],ne.prototype,"stationary",null),t.__decorate([g.property({readOnly:!0})],ne.prototype,"tileInfo",null),t.__decorate([g.property({type:N.Timeline,readOnly:!0})],ne.prototype,"timeline",void 0),t.__decorate([g.property({readOnly:!0})],ne.prototype,"type",void 0),t.__decorate([g.property({readOnly:!0})],ne.prototype,"updating",null),t.__decorate([g.property({readOnly:!0})],ne.prototype,"view2dType",void 0),t.__decorate([g.property()],ne.prototype,"viewpoint",null),t.__decorate([g.property({readOnly:!0})],ne.prototype,"visibleArea",null),t.__decorate([g.property()],ne.prototype,"zoom",null),t.__decorate([g.property({readOnly:!0})],ne.prototype,"navigating",null),t.__decorate([g.property(),c.cast((e=>e instanceof Z?e:w.ensureClass(j,e)))],ne.prototype,"ui",void 0),ne=t.__decorate([y.subclass("esri.views.View2D")],ne);return ne}));
