/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../chunks/tslib.es6","../../Graphic","../../UndoRedo","../../core/asyncUtils","../../core/Evented","../../core/handleUtils","../../core/maybe","../../core/reactiveUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/Logger","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../../geometry/coordinateFormatter","../../layers/GraphicsLayer","../../layers/graphics/dehydratedFeatureComparison","./support/CreateOperationGeometry","./support/createUtils","./support/surfaceCoordinateSystems","./support/tooltipUtils","../interactive/InteractiveToolBase","../interactive/sketch/SketchOptions","../interactive/tooltip/tooltipCommonUtils","../../core/accessorSupport/trackingUtils"],(function(e,t,r,o,i,a,n,s,p,l,c,d,h,u,y,m,_,g,v,w,G,O,T,f,C){"use strict";e.DrawGraphicTool=class extends(a.EventedMixin(O.InteractiveToolBase)){constructor(e){super(e),this._graphic=null,this._coordinateFormatterLoadTask=null,this._createOperationGeometry=null,this.defaultZ=0,this.directionOptions=null,this.geometryType=null,this.hasZ=!0,this.geometryToPlace=null,this.snappingManager=null,this.snapToScene=!1,this.sketchOptions=new T}initialize(){const{view:e}=this;this.internalGraphicsLayer=new m({listMode:"hide",internal:!0}),this.view.map.layers.add(this.internalGraphicsLayer);const t=this.drawOperation=this.makeDrawOperation();this.tooltipInfos=G.createTooltipInfos(e.type,this.sketchOptions);const r=f.makeTooltip((()=>({view:e,options:this.sketchOptions.tooltips})));this.tooltip=r,G.initializeConstraints(this._tooltipsContext),this._coordinateFormatterLoadTask=i.createTask((()=>y.load())),this.addHandles([t.on("vertex-add",(e=>this.onVertexAdd(e))),t.on("vertex-remove",(e=>this.onVertexRemove(e))),t.on("vertex-update",(e=>this.onVertexUpdate(e))),t.on("cursor-update",(e=>this.onCursorUpdate(e))),t.on("cursor-remove",(()=>this._updateGraphic())),t.on("complete",(e=>this.onComplete(e))),this._coordinateFormatterLoadTask,r.on("paste",(e=>f.pasteLocation(e,this.activeTooltipInfo))),p.watch((()=>this.cursor),(e=>{t.cursor=e}),p.syncAndInitial),C.autorun((()=>{const{activeTooltipInfo:e,sketchOptions:t}=this;G.updateTooltipInfo(e,this._tooltipsContext),r.info=t.tooltips.effectiveEnabled?e:null})),C.autorun((()=>{t.constraintZ=G.getConstraintZ(this._tooltipsContext)}),p.sync)]),this.finishToolCreation()}destroy(){this.drawOperation=s.destroyMaybe(this.drawOperation),this.tooltip=s.destroyMaybe(this.tooltip),this._destroyAllVisualizations(),this.view.map.remove(this.internalGraphicsLayer),this.internalGraphicsLayer=s.destroyMaybe(this.internalGraphicsLayer),this._set("view",null)}get _drawSpatialReference(){return this.drawOperation.coordinateHelper.spatialReference}get _tooltipsContext(){return{createOperationGeometry:this._createOperationGeometry,defaultZ:this.defaultZ,directionOptions:this.directionOptions,drawOperation:this.drawOperation,forceUniformSize:this.forceUniformSize,geometryType:this.geometryType,graphic:this.graphic,sketchOptions:this.sketchOptions,tooltipInfos:this.tooltipInfos,view:this.view}}get canRedo(){return this.drawOperation.canRedo}get canUndo(){return this.drawOperation.canUndo}set centered(e){this._set("centered",e),this._updateGraphic()}get cursor(){return this._get("cursor")}set cursor(e){this._set("cursor",e)}set enabled(e){this.drawOperation.interactive=e,this._set("enabled",e)}set forceUniformSize(e){this._set("forceUniformSize",e),this._updateGraphic()}get graphic(){return this._graphic}set graphicSymbol(e){this._set("graphicSymbol",e),null!=this._graphic&&(this._graphic.symbol=e)}set mode(e){const t=this.drawOperation;t&&(t.drawingMode=e),this._set("mode",e)}get updating(){return this.drawOperation?.updating??!1}get undoRedo(){const{view:{type:e,map:t}}=this;return"2d"===e&&t&&"undoRedo"in t&&t.undoRedo instanceof o.UndoRedo?t.undoRedo:null}set undoRedo(e){this._override("undoRedo",e)}completeCreateOperation(){this.drawOperation.complete()}onInputEvent(e){this.destroyed||f.enterInputModeIfAvailable(e,this.tooltip)||this.drawOperation.onInputEvent(e)}redo(){this.drawOperation.redo()}reset(){}undo(){this.drawOperation.undo(),0===this.drawOperation.numCommittedVertices&&G.initializeConstraints(this._tooltipsContext)}_destroyAllVisualizations(){this.removeHandles(V.outline),this.removeHandles(V.regularVertices),this.removeHandles(V.activeVertex),this.removeHandles(V.activeEdge),this.removeHandles(x)}_createOrUpdateGraphic(e){if(null!=this._graphic)return this.updateGraphicGeometry(e),this._graphic;const t=new r({...this.graphicProperties,symbol:this.graphicSymbol});return this._graphic=t,this.updateGraphicGeometry(e),this.internalGraphicsLayer.add(t),this.addHandles(this.initializeGraphic(t)),this.notifyChange("graphic"),this.addHandles(n.makeHandle((()=>{this.internalGraphicsLayer.remove(t),this._graphic===t&&(this._graphic=null)})),x),t}updateGraphicGeometry(e){this._graphic.geometry=e}_getCreateOperationGeometry(e={operationComplete:!1}){if(null==this.drawOperation)return;const{coordinateHelper:t,view:r,visualizationCursorVertex:o,lastVertex:i,committedVertices:a,geometryIncludingUncommittedVertices:n,numCommittedVertices:s}=this.drawOperation;if(!(s>0||null!=o))return;const p=e.operationComplete?a:n,l=p.length,c=null!=o?t.pointToArray(o):null,d=this._drawSpatialReference,h="3d"===r.type&&"global"===r.viewingMode,u=new g.CreateOperationGeometry;u.committedVertices=a,u.cursorVertex=c;const{geometryType:y}=this;switch(y){case"point":case"mesh":u.full=t.arrayToPoint(p[0]);break;case"multipoint":u.full=l>0?v.createMultipoint(p,d):null;break;case"polyline":case"polygon":l>0&&(u.full="polygon"===y?v.createPolygon([p],d,h,!0):v.createPolyline([p],d,h),u.cursorEdge=null!=c&&i&&!_.pointEquals(o,i)?v.createPolyline([[c,t.pointToArray(i)]],d,h):null,u.outline=l>1?u.full:null);break;case"circle":case"rectangle":{if(u.committedVertices=u.cursorVertex=null,!l)break;const t=w.createViewAlignedCoordinateSystem(r,p[0]),o=p[0],i=t.makeMapPoint(o[0]+D*r.resolution,o[1]);"circle"===y?1===l&&e.operationComplete?u.circle=v.createCircle([o,i],t,!0):2===l&&(this.forceUniformSize?u.circle=v.createCircle(p,t,this.centered):u.rectangle=v.createEllipse(p,t,this.centered)):1===l&&e.operationComplete?u.rectangle=v.createSquare([o,i],t,!0):2===l&&(u.rectangle=this.forceUniformSize?v.createSquare(p,t,this.centered):v.createRectangle(p,t,this.centered)),u.full=null!=u.circle?u.circle.geometry:u.rectangle?.geometry,u.outline="polygon"===u.full?.type?u.full:null;break}default:return null}return u}initializeGraphic(e){return n.makeHandle()}onComplete(e){if(!this.drawOperation)return;this._updateGraphic();let t=null;if(this.drawOperation.isCompleted){const e=this._getCreateOperationGeometry({operationComplete:!0});null!=e&&(t=this._createOrUpdateGraphic(e.full))}this._createOperationGeometry=null,this.emit("complete",{graphic:t,...e})}onCursorUpdate(e){this._updateGraphic(),this.emit("cursor-update",e)}onDeactivate(){const{drawOperation:e}=this;e&&(e.isCompleted||e.cancel())}onOutlineChanged(e){return n.makeHandle()}onCursorEdgeChanged(e){return n.makeHandle()}onVertexAdd(e){G.unlockConstraintsOnVertexAddOrRemove(this._tooltipsContext),this._updateGraphic(),G.lockElevationOnVertexAdd(e.vertices.at(0)?.coordinates,this._tooltipsContext),this.emit("vertex-add",e)}onVertexRemove(e){G.unlockConstraintsOnVertexAddOrRemove(this._tooltipsContext),this._updateGraphic(),this.emit("vertex-remove",e)}onVertexUpdate(e){this._updateGraphic(),this.emit("vertex-update",e)}_updateGraphic(){const e=this._getCreateOperationGeometry();this._createOperationGeometry=e,null!=e?(null!=e.cursorEdge?this.addHandles(this.onCursorEdgeChanged(e.cursorEdge),V.activeEdge):this.removeHandles(V.activeEdge),null!=e.outline?this.addHandles(this.onOutlineChanged(e.outline),V.outline):this.removeHandles(V.outline),null!=e.committedVertices?this.addHandles(this.onRegularVerticesChanged(e.committedVertices),V.regularVertices):this.removeHandles(V.regularVertices),null!=e.cursorVertex?this.addHandles(this.onActiveVertexChanged(e.cursorVertex),V.activeVertex):this.removeHandles(V.activeVertex),null!=e.full?this._createOrUpdateGraphic(e.full):this.removeHandles(x)):this._destroyAllVisualizations()}get activeTooltipInfo(){return this._coordinateFormatterLoadTask?.finished?G.getActiveTooltipInfo(this._tooltipsContext):null}},t.__decorate([l.property()],e.DrawGraphicTool.prototype,"_coordinateFormatterLoadTask",void 0),t.__decorate([l.property()],e.DrawGraphicTool.prototype,"_createOperationGeometry",void 0),t.__decorate([l.property()],e.DrawGraphicTool.prototype,"_tooltipsContext",null),t.__decorate([l.property({value:!0})],e.DrawGraphicTool.prototype,"centered",null),t.__decorate([l.property()],e.DrawGraphicTool.prototype,"cursor",null),t.__decorate([l.property({nonNullable:!0})],e.DrawGraphicTool.prototype,"defaultZ",void 0),t.__decorate([l.property({constructOnly:!0})],e.DrawGraphicTool.prototype,"directionOptions",void 0),t.__decorate([l.property()],e.DrawGraphicTool.prototype,"drawOperation",void 0),t.__decorate([l.property({value:!0})],e.DrawGraphicTool.prototype,"enabled",null),t.__decorate([l.property({value:!0})],e.DrawGraphicTool.prototype,"forceUniformSize",null),t.__decorate([l.property({constructOnly:!0})],e.DrawGraphicTool.prototype,"geometryType",void 0),t.__decorate([l.property()],e.DrawGraphicTool.prototype,"graphic",null),t.__decorate([l.property({constructOnly:!0})],e.DrawGraphicTool.prototype,"graphicProperties",void 0),t.__decorate([l.property()],e.DrawGraphicTool.prototype,"graphicSymbol",null),t.__decorate([l.property({constructOnly:!0})],e.DrawGraphicTool.prototype,"hasZ",void 0),t.__decorate([l.property({constructOnly:!0})],e.DrawGraphicTool.prototype,"geometryToPlace",void 0),t.__decorate([l.property()],e.DrawGraphicTool.prototype,"mode",null),t.__decorate([l.property()],e.DrawGraphicTool.prototype,"snappingManager",void 0),t.__decorate([l.property()],e.DrawGraphicTool.prototype,"snapToScene",void 0),t.__decorate([l.property()],e.DrawGraphicTool.prototype,"tooltip",void 0),t.__decorate([l.property()],e.DrawGraphicTool.prototype,"tooltipInfos",void 0),t.__decorate([l.property({constructOnly:!0,type:T})],e.DrawGraphicTool.prototype,"sketchOptions",void 0),t.__decorate([l.property()],e.DrawGraphicTool.prototype,"updating",null),t.__decorate([l.property({constructOnly:!0,nonNullable:!0})],e.DrawGraphicTool.prototype,"view",void 0),t.__decorate([l.property({constructOnly:!0})],e.DrawGraphicTool.prototype,"undoRedo",null),t.__decorate([l.property()],e.DrawGraphicTool.prototype,"activeTooltipInfo",null),e.DrawGraphicTool=t.__decorate([u.subclass("esri.views.draw.DrawGraphicTool")],e.DrawGraphicTool);const x=Symbol("create-operation-graphic"),V={outline:Symbol("outline-visual"),regularVertices:Symbol("regular-vertices-visual"),activeVertex:Symbol("active-vertex-visual"),activeEdge:Symbol("active-edge-visual")};function b(e){switch(e){case"point":case"polyline":case"polygon":case"multipoint":return e;case"circle":case"rectangle":return"segment";case"mesh":return"point"}}const D=48;e.geometryTypeToDrawOperationGeometryType=b,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
