/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../chunks/tslib.es6","../../core/Accessor","../../core/Evented","../../core/lang","../../core/maybe","../../core/memoize","../../core/promiseUtils","../../core/ReactiveSet","../../core/reactiveUtils","../../core/screenUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/Logger","../../core/accessorSupport/decorators/subclass","../../core/accessorSupport/diffUtils","../../core/support/UpdatingHandles","../../layers/graphics/dehydratedFeatureComparison","../../support/elevationInfoUtils","../ViewingMode","./DrawingMode","./DrawManipulator","../interactive/coordinateHelper","../interactive/dragEventPipeline","../interactive/editGeometry/EditGeometry","../interactive/editGeometry/EditGeometryOperations","../interactive/sketch/constraints","../interactive/sketch/constraintUtils","../interactive/sketch/SketchLabelOptions","../interactive/snapping/SnappingContext","../interactive/snapping/SnappingDragPipelineStep","../interactive/snapping/SnappingOperation","../interactive/snapping/snappingUtils"],(function(e,t,r,i,n,o,s,a,p,c,l,d,h,u,g,_,y,m,v,w,f,O,x,D,C,b,S,P,T,M,V,E,I){"use strict";const H="crosshair",G="progress",k=Symbol(),Z=Symbol();function A(e,t,r){const i=e.x-t.x,n=e.y-t.y;return i*i+n*n<=r}e.DrawOperation=class extends(i.EventedMixin(r)){constructor(e){super(e),this._createOperationCompleted=!1,this._hideDefaultCursor=!1,this._pointerDownStates=new p,this._stagedScreenPoint=null,this._stagedPointerType=null,this._updatingHandles=new y.UpdatingHandles,this._stagedPointerId=null,this.constraintsEnabled=!1,this.constraints=void 0,this._getPointConstraint=s.memoize(P.getPointConstraint),this._getPolylineOrPolygonConstraint=s.memoize(P.getPolylineOrPolygonConstraint),this.constraintZ=null,this.defaultZ=null,this.isDraped=!0,this.labelOptions=new T,this.cursor=null,this.loading=!1,this.snapToSceneEnabled=null,this.firstVertex=null,this.lastVertex=null,this.secondToLastVertex=null,null==e.elevationInfo&&(this.elevationInfo=v.getEffectiveElevationInfo(!!e.hasZ))}initialize(){const{geometryType:e,view:t}=this,r=t.spatialReference,i="viewingMode"in t.state?t.state.viewingMode:w.ViewingMode.Local,n="segment"===e||"multipoint"===e?"polyline":e;this.coordinateHelper=x.createCoordinateHelper(this.hasZ,this.hasM,r),this._editGeometryOperations=new b.EditGeometryOperations(new C.EditGeometry(n,this.coordinateHelper),i),this._snappingOperation=new E.SnappingOperation({view:t}),this.addHandles([c.watch((()=>({stagedPoint:this._snappingOperation.stagedPoint,constraint:this._constraint})),(({stagedPoint:e,constraint:t},r)=>{const{snappingOptions:i}=this;i&&(i.forceDisabled=null!=t&&S.isPoint(t));if(null!=r&&e===r.stagedPoint&&t!==r.constraint)return this._onKeyboardBasedChange();this._processCursor(e??this._screenToMap(this._stagedScreenPoint))}),{equals:(e,t)=>e.stagedPoint===t.stagedPoint&&o.equalsMaybe(e.constraint,t.constraint)}),c.watch((()=>this.view.viewpoint),((e,t)=>{e&&t&&_.diff(e,t)&&this._onKeyboardBasedChange()}))]),this._activeComponent=new C.Component(r,i),this._editGeometryOperations.data.components.push(this._activeComponent);const s=this.segmentLabels;null!=s&&(s.context={view:t,editGeometryOperations:this._editGeometryOperations,elevationInfo:this.elevationInfo,labelOptions:this.labelOptions},this.addHandles(c.watch((()=>this.labelOptions.enabled),(e=>{s.visible=e}),c.syncAndInitial))),this.addHandles(this._editGeometryOperations.on(["vertex-add","vertex-update","vertex-remove"],(e=>{const t=e.vertices.map((e=>({componentIndex:0,vertexIndex:e.index,coordinates:this.coordinateHelper.vectorToArray(e.pos)}))),r=t.map((e=>e.coordinates)),i=this.coordinateHelper.vectorToDehydratedPoint(this._activeComponent.getFirstVertex()?.pos)??null;m.pointEquals(i,this.firstVertex)||(this.firstVertex=i);const n=this.coordinateHelper.vectorToDehydratedPoint(this._activeComponent.getLastVertex()?.pos)??null;m.pointEquals(n,this.lastVertex)||(this.lastVertex=n);const o=this.coordinateHelper.vectorToDehydratedPoint(this._activeComponent.edges.at(-1)?.leftVertex?.pos)??null;switch(m.pointEquals(o,this.secondToLastVertex)||(this.secondToLastVertex=o),this._processCursor(this.cursorVertex),e.type){case"vertex-add":this.emit(e.type,{...e,added:r,vertices:t});break;case"vertex-update":this.emit(e.type,{...e,updated:r,vertices:t});break;case"vertex-remove":this.emit(e.type,{...e,removed:r,vertices:t})}})));const p=this._manipulator=new O.DrawManipulator({consumesClicks:!1,grabbableForEvent:e=>"click"!==this.drawingMode||"touch"===e.pointerType&&this._snappingEnabled&&1===this._pointerDownStates.size});this.manipulators.add(p),p.grabbable="point"!==e,this.addHandles([p.events.on("immediate-click",(e=>this._onImmediateClick(e))),p.events.on("immediate-double-click",(e=>this._onImmediateDoubleClick(e))),c.watch((()=>this.drawingMode),(()=>{this.removeHandles(k),this.addHandles(this._createManipulatorDragPipeline(p),k)}),c.syncAndInitial),c.watch((()=>({effectiveCursor:this.effectiveCursor})),(({effectiveCursor:e})=>{p.cursor=e}),c.syncAndInitial)]),I.setupSnappingToggleHandles(this,(()=>{const e=this.view.inputManager.latestPointerType??"mouse",t=this._getSnappingContext(e);if(null!=this.snappingManager){const e=this._snappingOperation.snapAgainNearPreviousMapPoint(this.snappingManager,t);this._updatingHandles.addPromise(a.ignoreAbortErrors(e))}}))}destroy(){o.destroyMaybe(this.segmentLabels),o.destroyMaybe(this._snappingOperation),this._editGeometryOperations=o.destroyMaybe(this._editGeometryOperations),this._updatingHandles.destroy()}get _isDragging(){const{_stagedPointerId:e,_manipulator:t}=this;return null!=e&&this._pointerDownStates.has(e)||t.grabbing||!t.interactive}get _snappingEnabled(){return null!=this.snappingManager&&this.snappingManager.options.effectiveEnabled}get _requiresScenePoint(){const e=this._updateAndGetEffectiveDrawSurface();return"3d"===this.view.type&&this.drawSurface!==e}get canRedo(){return this._editGeometryOperations.canRedo}get canUndo(){return this._editGeometryOperations.canUndo}get committedVertices(){return this._activeComponent.vertices.map((e=>this.coordinateHelper.vectorToArray(e.pos)))}get _constraint(){const{constraints:e,constraintsEnabled:t}=this;if(e&&t)switch(this.geometryType){case"point":return this._getPointConstraint(e);case"polygon":case"polyline":return this._getPolylineOrPolygonConstraint(this.lastVertex,this.secondToLastVertex,e)}}set drawingMode(e){this._set("drawingMode",e??f.defaultDrawingMode)}get effectiveCursor(){return this.loading?G:this._hideDefaultCursor?null:this.cursor||H}get interactive(){return this._manipulator.interactive}set interactive(e){this._manipulator.interactive=e}get isCompleted(){return this._createOperationCompleted}get numCommittedVertices(){return this._activeComponent.vertices.length}get snappingOptions(){return null!=this.snappingManager?this.snappingManager.options:null}get cursorVertex(){return this._get("cursorVertex")}get visualizationCursorVertex(){return"mouse"===this._stagedPointerType?this.cursorVertex:null}get committableVertex(){const{cursorVertex:e,lastVertex:t,firstVertex:r,geometryType:i}=this;return"polygon"===i&&m.pointNear(e,r)||m.pointNear(e,t)?null:e}get updating(){return this._updatingHandles.updating}get geometryIncludingUncommittedVertices(){const{committedVertices:e,committableVertex:t,coordinateHelper:r}=this,i=e.slice();return null!=t&&i.push(r.pointToArray(t)),i}cancel(){this.complete({aborted:!0})}commitStagedVertex(){this._snappingOperation.abort();const{committableVertex:e}=this;null!=e&&this._editGeometryOperations.appendVertex(this.coordinateHelper.pointToVector(e))}complete(e){const t=e?.aborted||!1;this._snappingOperation.abort(),this.snappingManager?.doneSnapping();const{geometryType:r,numCommittedVertices:i}=this,n="multipoint"===r&&0===i||"polyline"===r&&i<2||"polygon"===r&&i<3;"segment"!==r&&"point"!==r||this.commitStagedVertex(),this._createOperationCompleted=!n,(this.isCompleted||t)&&(this._stagedScreenPoint=null,this._stagedPointerId=null,this._stagedPointerType=null,this._processCursor(null),this.emit("complete",{vertices:this.committedVertices.map(((e,t)=>({componentIndex:0,vertexIndex:t,coordinates:e}))),aborted:t,type:"complete"}))}onInputEvent(e){switch(e.type){case"pointer-down":this._pointerDownStates.add(e.pointerId);break;case"pointer-up":this._pointerDownStates.delete(e.pointerId)}switch(e.type){case"pointer-move":return this._onPointerMove(e);case"hold":return this._onHold(e)}}redo(){this._editGeometryOperations.redo()}undo(){null!=this.snappingManager&&this.snappingManager.doneSnapping(),this._editGeometryOperations.undo()}_processCursor(e){const t=n.clone(this.cursorVertex),r=n.clone(e),i=r&&(this._updateAndGetEffectiveDrawSurface()?.constrainZ(r)??r),o=this._snapToClosingVertex(i),s=this._applyConstraints(o);m.pointNear(t,s)||(this._set("cursorVertex",s),this.segmentLabels?.set("stagedVertex",null!=s?this.coordinateHelper.pointToVector(s):null),null==s||"mouse"!==this._stagedPointerType?this.emit("cursor-remove"):this.emit("cursor-update",{updated:null,vertices:[{componentIndex:0,vertexIndex:this._activeComponent.vertices.length,coordinates:this.coordinateHelper.pointToArray(s)}],operation:"apply",type:"vertex-update"}))}_snapToClosingVertex(e){if(null==e||this._isDragging||"polygon"!==this.geometryType||this.numCommittedVertices<=2)return e;const t=this._mapToScreen(e);if(!t)return e;const r=this._activeComponent;return this._vertexWithinPointerDistance(r.vertices[0].pos,t)?this.firstVertex:this._vertexWithinPointerDistance(r.vertices.at(-1).pos,t)?this.lastVertex:e}_createManipulatorDragPipeline(e){switch(this.drawingMode){case"click":return this._createManipulatorDragPipelineClick(e);case"freehand":return this._createManipulatorDragPipelineFreehand(e);case"hybrid":return this._createManipulatorDragPipelineHybrid(e)}}_createManipulatorDragPipelineClick(e){return D.createManipulatorDragEventPipeline(e,((e,t,r,i)=>{const n="touch"===i&&this._snappingEnabled;if(this.isCompleted||!n)return;const{snappingStep:o,cancelSnapping:s}=V.createSnapDragEventPipelineStep({predicate:()=>n,snappingManager:this.snappingManager,snappingContext:new M.SnappingContext({editGeometryOperations:this._editGeometryOperations,elevationInfo:this.elevationInfo,feature:this.graphic,pointer:i,visualizer:this.snappingVisualizer,drawConstraints:this.constraints}),updatingHandles:this._updatingHandles,useZ:!this._requiresScenePoint});r=r.next((e=>(n&&null!=this.snappingManager&&this.snappingManager.doneSnapping(),e))).next(s),t.next(this._screenToMapDragEventStep()).next((e=>("start"===e.action&&(this._processCursor(e.mapStart),("segment"===this.geometryType||n&&!this.numCommittedVertices)&&this.commitStagedVertex()),e))).next(D.sceneSnappingAtLocation(this.view,this.elevationInfo)).next(...o).next((e=>(n&&(this._processCursor(e.mapEnd),"end"===e.action&&this.commitStagedVertex()),e))).next((e=>("end"===e.action&&("mouse"!==this._stagedPointerType&&this._snappingOperation.abort(),"segment"!==this.geometryType&&"point"!==this.geometryType||this.complete()),e)))}))}_createManipulatorDragPipelineFreehand(e){return D.createManipulatorDragEventPipeline(e,((e,t)=>{this.isCompleted||t.next(this._screenToMapDragEventStep()).next((e=>("start"===e.action&&(this._snappingOperation.abort(),null==this.committableVertex&&this._processCursor(e.mapStart),"segment"===this.geometryType&&this.commitStagedVertex()),e))).next((e=>{switch(e.action){case"start":case"update":this._processCursor(e.mapEnd),"polygon"!==this.geometryType&&"polyline"!==this.geometryType||this.commitStagedVertex();break;case"end":this.complete()}return e}))}))}_createManipulatorDragPipelineHybrid(e){return D.createManipulatorDragEventPipeline(e,((e,t)=>{this.isCompleted||t.next(this._screenToMapDragEventStep()).next((e=>("start"===e.action&&(this._snappingOperation.abort(),this.addHandles(this._editGeometryOperations.createUndoGroup(),Z),this._processCursor(e.mapStart),this.commitStagedVertex()),e))).next((e=>{switch(e.action){case"start":case"update":this._processCursor(e.mapEnd),"polygon"!==this.geometryType&&"polyline"!==this.geometryType||this.commitStagedVertex();break;case"end":"mouse"!==this._stagedPointerType&&this._snappingOperation.abort(),this.removeHandles(Z),"segment"!==this.geometryType&&"point"!==this.geometryType||this.complete()}return e}))}))}get _drawAtFixedElevation(){const{constraintsEnabled:e,constraintZ:t,geometryType:r,numCommittedVertices:i}=this;return e?null!=t||"segment"===r&&i>0:("segment"===r||"polygon"===r)&&i>0}_updateAndGetEffectiveDrawSurface(){const{constraintsEnabled:e,coordinateHelper:t,drawSurface:r,elevationDrawSurface:i,snapToSceneEnabled:n}=this;if(null==i)return r;if(!this.hasZ)return i.defaultZ=null,i;const o=this.elevationInfo?.mode;let s=this.defaultZ,a=e||"absolute-height"===o;if(null!=n&&(a=n),"on-the-ground"===o&&(a=!1),this._drawAtFixedElevation){s=(e?this.constraintZ:null)??t.getZ(this._activeComponent.vertices[0].pos),a=!1}return a?r:(i.defaultZ=s,i)}_mapToScreen(e){return this._updateAndGetEffectiveDrawSurface()?.mapToScreen(e)}_onHold(e){this._snappingOperation.abort(),"click"===this.drawingMode&&"touch"===e.pointerType&&this._snappingEnabled&&this._processCursor(e.mapPoint),e.stopPropagation()}_onImmediateClick(e){if(!("mouse"===e.pointerType&&2===e.button||this._manipulator.dragging))try{const{drawingMode:t,geometryType:r}=this;this._stagedPointerType=e.pointerType,this._stagedScreenPoint=e.screenPoint;const i=this._screenToMap(e.screenPoint);if(null==i)return;if(null==i||"freehand"===t&&"point"!==r)return;if(this._snappingEnabled&&null!=this.cursorVertex||this._processCursor(i),null==this.committableVertex)return void this.complete();this.commitStagedVertex(),"mouse"!==e.pointerType&&this._processCursor(null),("freehand"===t||"point"===r||"segment"===r&&2===this.numCommittedVertices||"segment"===r&&"hybrid"===t&&1===this.numCommittedVertices)&&this.complete()}finally{e.stopPropagation()}}_onImmediateDoubleClick(e){this._manipulator.dragging||"point"===this.geometryType||(this.complete(),e.stopPropagation())}_onPointerMove(e){const t=l.createScreenPoint(e.x,e.y);this._stagedScreenPoint=t,this._stagedPointerType=e.pointerType,this._stagedPointerId=e.pointerId,this._isDragging?this._snappingOperation.abort():(e.stopPropagation(),this._processCursorMovementRelativeToSurface(t,e.pointerType))}_onKeyboardBasedChange(){"mouse"===this._stagedPointerType&&this._stagedScreenPoint&&null!=this._stagedPointerId&&!this._isDragging?this._processCursorMovementRelativeToSurface(this._stagedScreenPoint,this._stagedPointerType):this._snappingOperation.abort()}_processCursorMovementRelativeToSurface(e,t){const r=this._snappingOperation,i=this._screenToMap(e),n=this._requiresScenePoint?this.drawSurface?.screenToMap(e):null;if(null==i)return this._hideDefaultCursor=!0,this._processCursor(null),void r.abort();this._hideDefaultCursor=!1;const o=this.snappingManager;if(null==o)return this._processCursor(i),void r.abort();const s=this._getSnappingContext(t);this._updatingHandles.addPromise(a.ignoreAbortErrors(r.snap({point:i,scenePoint:n},o,s)))}_applyConstraints(e){const{_constraint:t,constraints:r}=this;if(!e||!r||!t)return e;const{context:i}=r,n=P.pointToConstraintSpace(e,i),o=n?t.closestTo(n):void 0;if(!o)return e;const s=P.constraintSpaceToPoint(o,e,i),a="2d"===this.view.type||"absolute-height"!==i.elevationInfo.mode;return null!=s&&a&&null!=this.constraintZ&&this.hasZ&&(s.z=this.constraintZ),s}_screenToMap(e){return e?this._updateAndGetEffectiveDrawSurface()?.screenToMap(e):null}_screenToMapDragEventStep(){let e=null;return t=>{if("start"===t.action&&(e=this._screenToMap(t.screenStart)),null==e)return null;const r=this._screenToMap(t.screenEnd);return null!=r?{...t,mapStart:e,mapEnd:r}:null}}_vertexWithinPointerDistance(e,t){const r=25,i=this._mapToScreen(this.coordinateHelper.vectorToDehydratedPoint(e));return null!=i&&A(i,t,r)}_getSnappingContext(e){const t=this._drawAtFixedElevation?this.elevationDrawSurface?.defaultZ:null;return new M.SnappingContext({editGeometryOperations:this._editGeometryOperations,elevationInfo:this.elevationInfo,pointer:e,feature:this.graphic,visualizer:this.snappingVisualizer,selfSnappingZ:null!=t?{value:t,elevationInfo:this.elevationInfo}:null,drawConstraints:this.constraints})}},t.__decorate([d.property()],e.DrawOperation.prototype,"_hideDefaultCursor",void 0),t.__decorate([d.property()],e.DrawOperation.prototype,"_stagedPointerId",void 0),t.__decorate([d.property()],e.DrawOperation.prototype,"_isDragging",null),t.__decorate([d.property()],e.DrawOperation.prototype,"_snappingOperation",void 0),t.__decorate([d.property()],e.DrawOperation.prototype,"_snappingEnabled",null),t.__decorate([d.property({constructOnly:!0})],e.DrawOperation.prototype,"graphic",void 0),t.__decorate([d.property()],e.DrawOperation.prototype,"constraintsEnabled",void 0),t.__decorate([d.property()],e.DrawOperation.prototype,"constraints",void 0),t.__decorate([d.property()],e.DrawOperation.prototype,"_constraint",null),t.__decorate([d.property()],e.DrawOperation.prototype,"constraintZ",void 0),t.__decorate([d.property()],e.DrawOperation.prototype,"defaultZ",void 0),t.__decorate([d.property()],e.DrawOperation.prototype,"isDraped",void 0),t.__decorate([d.property({value:f.defaultDrawingMode})],e.DrawOperation.prototype,"drawingMode",null),t.__decorate([d.property({constructOnly:!0})],e.DrawOperation.prototype,"elevationDrawSurface",void 0),t.__decorate([d.property({constructOnly:!0})],e.DrawOperation.prototype,"elevationInfo",void 0),t.__decorate([d.property({constructOnly:!0,type:T})],e.DrawOperation.prototype,"labelOptions",void 0),t.__decorate([d.property({constructOnly:!0})],e.DrawOperation.prototype,"geometryType",void 0),t.__decorate([d.property({constructOnly:!0})],e.DrawOperation.prototype,"hasM",void 0),t.__decorate([d.property({constructOnly:!0})],e.DrawOperation.prototype,"hasZ",void 0),t.__decorate([d.property()],e.DrawOperation.prototype,"cursor",void 0),t.__decorate([d.property()],e.DrawOperation.prototype,"effectiveCursor",null),t.__decorate([d.property()],e.DrawOperation.prototype,"loading",void 0),t.__decorate([d.property({constructOnly:!0})],e.DrawOperation.prototype,"manipulators",void 0),t.__decorate([d.property({constructOnly:!0})],e.DrawOperation.prototype,"drawSurface",void 0),t.__decorate([d.property({constructOnly:!0})],e.DrawOperation.prototype,"segmentLabels",void 0),t.__decorate([d.property({constructOnly:!0})],e.DrawOperation.prototype,"snappingManager",void 0),t.__decorate([d.property({constructOnly:!0})],e.DrawOperation.prototype,"snappingVisualizer",void 0),t.__decorate([d.property()],e.DrawOperation.prototype,"snapToSceneEnabled",void 0),t.__decorate([d.property({readOnly:!0})],e.DrawOperation.prototype,"cursorVertex",null),t.__decorate([d.property({readOnly:!0})],e.DrawOperation.prototype,"visualizationCursorVertex",null),t.__decorate([d.property()],e.DrawOperation.prototype,"committableVertex",null),t.__decorate([d.property()],e.DrawOperation.prototype,"firstVertex",void 0),t.__decorate([d.property()],e.DrawOperation.prototype,"lastVertex",void 0),t.__decorate([d.property()],e.DrawOperation.prototype,"secondToLastVertex",void 0),t.__decorate([d.property()],e.DrawOperation.prototype,"updating",null),t.__decorate([d.property({constructOnly:!0})],e.DrawOperation.prototype,"view",void 0),e.DrawOperation=t.__decorate([g.subclass("esri.views.draw.DrawOperation")],e.DrawOperation),e.defaultCursor=H,e.defaultLoadingCursor=G,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
