/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../geometry","../../core/accessorSupport/decorators/property","../../core/has","../../core/Logger","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../ViewingMode","./DrawAction","./DrawTool","./input/DrawEvents","./support/surfaceCoordinateSystems","../input/InputManager","../interactive/keybindings","../interactive/editGeometry/EditGeometry","../interactive/editGeometry/EditGeometryOperations","../support/screenUtils","../../geometry/Point"],(function(e,t,i,r,s,o,n,a,d,h,p,c,l,_,v,g,w,m){"use strict";const u=["freehand","click"];let P=class extends d{constructor(e){super(e),this._isDragging=!1,this._panEnabled=!1,this._addVertexOnPointerUp=!1,this._drawTool=null,this.viewAlignedCoordinateSystem=null,this.mode="freehand"}initialize(){"2d"===this.view.type?this._addViewHandles():this._addDrawTool()}destroy(){this._removeDrawTool(),this.emit("destroy")}complete(){this._completeDrawing()}_getGeometryZValue(){return this.hasZ&&this.vertices.length>0?this.vertices[0][2]:this.defaultZ}_addViewHandles(){"click"===this.mode?this.addHandles(this._getClickModeViewHandles()):this.addHandles(this._getDragModeViewHandles())}_getDragModeViewHandles(){return[this.view.on("immediate-click",(e=>{if(e.stopPropagation(),e.mapPoint&&!this._panEnabled){null!=this.getCoordsFromScreenPoint(w.createScreenPointFromEvent(e))&&(this._vertexAddHandler(e),this._drawCompleteHandler(e))}}),l.ViewEventPriorities.TOOL),this.view.on("pointer-down",(e=>{this._shouldHandlePointerEvent(e)&&(this._abortSnapping(),this._panEnabled||(this._resetGeometry(),this._addVertexOnPointerUp=!0,this._cursorScreenPoint=w.createScreenPointFromEvent(e),this._activePointerId=e.pointerId,this._vertexAddHandler(e),this._isDragging=!1,"touch"===e.pointerType&&this._updateCursor()))}),l.ViewEventPriorities.TOOL),this.view.on("pointer-move",(e=>{this._abortSnapping(),null==this._activePointerId&&"touch"!==e.pointerType&&(this._cursorScreenPoint=w.createScreenPointFromEvent(e),this._updateCursor())}),l.ViewEventPriorities.TOOL),this.view.on("pointer-drag",(e=>{this._shouldHandlePointerEvent(e)&&(this._abortSnapping(),this._isDragging=!0,this._cursorScreenPoint=w.createScreenPointFromEvent(e),this._updateCursor())}),l.ViewEventPriorities.TOOL),this.view.on("pointer-up",(e=>{this._shouldHandlePointerEvent(e)&&this._addVertexOnPointerUp&&(this._abortSnapping(),this._activePointerId=null,this._isDragging&&this._vertexAddHandler(e),2===this._committedVertices.length&&this._drawCompleteHandler(e),this._isDragging=!1)}),l.ViewEventPriorities.TOOL),this.view.on("key-down",(e=>{e.key===_.sketchKeys.complete&&this._cursorScreenPoint?(this._abortSnapping(),this._vertexAddHandler(e),this._drawCompleteHandler(e)):e.key===_.sketchKeys.pan&&(this._panEnabled=!0)}),l.ViewEventPriorities.TOOL),this.view.on("key-up",(e=>{e.key===_.sketchKeys.pan&&(this._panEnabled=!1)}),l.ViewEventPriorities.TOOL),this.view.on("drag",(e=>{null!=this._activePointerId&&e.stopPropagation()}),l.ViewEventPriorities.TOOL),this.view.on("drag",["Shift"],(e=>{e.stopPropagation()}),l.ViewEventPriorities.TOOL)]}_getClickModeViewHandles(){return[this.view.on("pointer-down",(e=>{this._abortSnapping(),this._cursorScreenPoint=w.createScreenPointFromEvent(e),this._activePointerId=e.pointerId,this._isDragging=!1,"touch"===e.pointerType&&this._updateCursor()}),l.ViewEventPriorities.TOOL),this.view.on("pointer-move",(e=>{this._abortSnapping(),this._cursorScreenPoint=w.createScreenPointFromEvent(e),null==this._activePointerId&&"touch"!==e.pointerType&&this._updateCursor()}),l.ViewEventPriorities.TOOL),this.view.on("pointer-drag",(e=>{this._shouldHandlePointerEvent(e)&&(this._abortSnapping(),this._isDragging=!0)}),l.ViewEventPriorities.TOOL),this.view.on("pointer-up",(e=>{this._shouldHandlePointerEvent(e)&&(this._abortSnapping(),this._activePointerId=null,e.stopPropagation(),this._isDragging||this._vertexAddHandler(e),2!==this.vertices.length||this._isDragging||this._drawCompleteHandler(e),this._isDragging=!1)}),l.ViewEventPriorities.TOOL),this.view.on("key-down",(e=>{e.key===_.sketchKeys.vertexAdd&&this._cursorScreenPoint&&(this._vertexAddHandler(e),2===this.vertices.length&&this._drawCompleteHandler(e)),e.key===_.sketchKeys.complete&&this._cursorScreenPoint&&2===this.vertices.length&&(this._vertexAddHandler(e),this._drawCompleteHandler(e))}),l.ViewEventPriorities.TOOL)]}_addDrawTool(){const e=new h.DrawTool({view:this.view,elevationInfo:this.elevationInfo,hasZ:this.hasZ,geometryType:"segment",mode:this.mode});this._drawTool=e,this.view.addAndActivateTool(e),this.addHandles([e.on("vertex-add",(t=>{1===t.vertices.length&&this.emit("vertex-add",new p.VertexAddEvent(this.view,t.vertices[0].vertexIndex,e.getVertexCoords()))})),e.on("cursor-update",(t=>{1===t.vertices.length&&this.emit("cursor-update",new p.CursorUpdateEvent(this.view,t.vertices[0].vertexIndex,e.getVertexCoords()))})),e.on("complete",(t=>{this.emit("draw-complete",new p.DrawCompleteEvent(e.getVertexCoords())),this._removeDrawTool()})),this.view.on("key-down",(t=>{t.key!==_.sketchKeys.vertexAdd||t.repeat||"click"!==this.mode?t.key!==_.sketchKeys.complete||t.repeat||e.completeCreateOperation():e.drawOperation.numCommittedVertices>0?e.completeCreateOperation():e.drawOperation.commitStagedVertex()}),l.ViewEventPriorities.TOOL)])}_removeDrawTool(){this._drawTool&&(this.view.tools.remove(this._drawTool),this._drawTool=null)}_addVertex(e){const t=this._coordinateHelper.arrayToVector(e);if(this._isDuplicateOfLastVertex(t))return;this._lastVertexUnsnapped=this._stagedVertexUnsnapped,this._popCursorVertex(),this._editGeometryOperations.appendVertex(t),1===this._committedVertices.length&&(this.viewAlignedCoordinateSystem=c.createViewAlignedCoordinateSystem(this.view,this._committedVertices[0]));const i=this._committedVertices.length-1,r=new p.VertexAddEvent(this.view,i,this.vertices);this.emit("vertex-add",r)}_updateCursor(){if(this._popCursorVertex(),!this._cursorScreenPoint)return;const e=this.getCoordsAndPointFromScreenPoint(this._cursorScreenPoint);null!=e&&this._pushCursorVertex(e.vertex,(()=>this.emit("cursor-update",new p.CursorUpdateEvent(this.view,this._activeComponent.vertices.length,this.vertices,null!=this._stagedVertex?new m(this._stagedVertex):null))))}_completeDrawing(){if(this._drawTool)return this._drawTool.completeCreateOperation(),void this.removeAllHandles();if(this._activePointerId=null,this._popCursorVertex(),this._cursorScreenPoint=null,this._isDragging=!1,this._abortSnapping(),null!=this._snappingManager&&this._snappingManager.doneSnapping(),this.vertices.length<1)return;const e=new p.DrawCompleteEvent(this.vertices);this.emit("draw-complete",e),e.defaultPrevented||this.removeAllHandles()}_resetGeometry(){this._editGeometryOperations.destroy(),this._editGeometryOperations=new g.EditGeometryOperations(new v.EditGeometry("polygon",this._coordinateHelper),a.ViewingMode.Local),this._activeComponent=new v.Component(this._coordinateHelper.spatialReference,a.ViewingMode.Local),this._editGeometryOperations.data.components.push(this._activeComponent)}};e.__decorate([i.property({type:u})],P.prototype,"mode",void 0),P=e.__decorate([n.subclass("esri.views.draw.SegmentDrawAction")],P);return P}));
