/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../core/quantityUtils","../../../core/unitUtils","../../../support/elevationInfoUtils","./helpMessageUtils","./helpMessageUtils3d","../../interactive/sketch/constraintUtils","../../interactive/tooltip/tooltipCommonUtils","../../interactive/tooltip/infos/DrawCircleTooltipInfo","../../interactive/tooltip/infos/DrawMeshTooltipInfo","../../interactive/tooltip/infos/DrawPointTooltipInfo","../../interactive/tooltip/infos/DrawPolygonTooltipInfo","../../interactive/tooltip/infos/DrawPolylineTooltipInfo","../../interactive/tooltip/infos/DrawRectangleTooltipInfo","../../support/angularMeasurementUtils","../../support/automaticAreaMeasurementUtils","../../support/automaticLengthMeasurementUtils","../../support/euclideanLengthMeasurementUtils"],(function(e,t,o,n,i,r,l,a,c,s,p,u,d,f,m,y,g,w){"use strict";function v(e,t){return{point:new p.DrawPointTooltipInfo({sketchOptions:t,viewType:e}),polyline:new d.DrawPolylineTooltipInfo({sketchOptions:t,viewType:e}),polygon:new u.DrawPolygonTooltipInfo({sketchOptions:t,viewType:e}),mesh:new s.DrawMeshTooltipInfo({sketchOptions:t,viewType:e}),rectangle:new f.DrawRectangleTooltipInfo({sketchOptions:t}),circle:new c.DrawCircleTooltipInfo({sketchOptions:t})}}function h(e){const{directionOptions:t,geometryType:o,sketchOptions:n,tooltipInfos:i}=e,r=t=>{const o=q(e).mode,n=i[t].elevation;"relative-to-ground"===o||"relative-to-scene"===o||"on-the-ground"===o?n.lock(E(e)):n.unlock()},l=e=>{if(t){const o=i[e].direction;o.committed=t.angle,o.unlockOnVertexPlacement=!1,n.values.directionMode=t.mode}};switch(o){case"polygon":case"polyline":r(o),l(o);break;case"point":case"mesh":r(o)}}function O(e,t){const{drawOperation:o,view:n}=t,i=k(t),r=q(t);if("2d"===n.type||!e||"absolute-height"!==r.mode||1!==o?.numCommittedVertices||!i||"draw-polyline"!==i.type&&"draw-polygon"!==i.type||i.elevation.locked)return;const[l,a,c]=e,s=R(l,a,c,r,t);null!=s&&i.elevation.lock(s)}function M(e){k(e)?.allFields.forEach((e=>{e.unlockOnVertexPlacement&&e.unlock()}))}function k({geometryType:e,graphic:t,tooltipInfos:o}){return"multipoint"===e||t?.geometry?.type!==D[e]?null:o[e]}const D={point:"point",mesh:"mesh",polyline:"polyline",polygon:"polygon",circle:"polygon",rectangle:"polygon"};function T(e,t){switch(e?.type){case"draw-point":x(e,t);break;case"draw-polyline":b(e,t);break;case"draw-polygon":V(e,t);break;case"draw-rectangle":S(e,t);break;case"draw-circle":C(e,t);break;case"draw-mesh":I(e,t)}}function x(e,t){const o=t.graphic?.geometry;"point"===o?.type&&(P(e,o,t),e.helpMessage=i.getDrawHelpMessage("point",o))}function I(e,t){const{graphic:o,view:n}=t,i=o?.geometry;"3d"!==n.type||i&&"mesh"!==i.type||(P(e,i?.origin,t),i&&a.updateTooltipInfoFromMeshTransform(e,i),e.helpMessage=r.getDrawMeshHelpMessage(o,n))}function P(e,t,o){const{drawOperation:n,view:i,sketchOptions:r}=o,{cursorVertex:l}=n;if(e.sketchOptions=r,e.viewType=i.type,e.setLocationFromPoint(t,B(o)),F(e.elevation,o),!l)return void(n.constraints=void 0);const a=l;n.constraints={context:X(a,o),x:e.x.committed,y:e.y.committed,longitude:e.longitude.committed,latitude:e.latitude.committed,elevation:e.elevation.committed,distance:null,direction:null}}function b(e,o){const{createOperationGeometry:n,drawOperation:r}=o,l=null!=n?n.full:null;l&&"polyline"!==l.type||(z(e,o),e.totalLength.actual=r.lastVertex?(l?g.autoLength2D(l):null)??t.zeroMeters:null,e.helpMessage=i.getDrawHelpMessage("polyline",l))}function V(e,o){const{createOperationGeometry:n,drawOperation:r}=o,l=null!=n?n.full:null;l&&"polygon"!==l.type||(z(e,o),e.area.actual=r.lastVertex?(l?y.autoArea2D(l):null)??t.zeroSquareMeters:null,e.helpMessage=i.getDrawHelpMessage("polygon",l))}function z(e,o){const{drawOperation:n,sketchOptions:i,view:r}=o,{cursorVertex:l,lastVertex:a,secondToLastVertex:c}=n,s=i.values.effectiveDirectionMode;e.sketchOptions=i,e.viewType=r.type;const p=a&&l?g.autoDistanceBetweenPoints2D(a,l)??t.zeroMeters:null;if(e.distance.actual=p,e.distance.readOnly=null==a,e.direction.actual=null,e.direction.readOnly=!0,a&&l&&("absolute"===s||c)){const o=m.directionForVertices(c,a,l,s);e.direction.actual=o??t.zeroDegreesGeographic,e.direction.readOnly=!1}e.setLocationFromPoint(l,B(o)),F(e.elevation,o);const u=U(a,o);e.xyMode=u,e.direction.visible="direction-distance"===u,e.distance.visible="direction-distance"===u,e.effectiveX.visible="coordinates"===u,e.effectiveY.visible="coordinates"===u;const d=l??a;n.constraints=d?{context:X(d,o),x:e.x.committed,y:e.y.committed,longitude:e.longitude.committed,latitude:e.latitude.committed,elevation:e.elevation.committed,distance:e.distance.committed,direction:e.direction.committed}:void 0}function U(e,{sketchOptions:t}){const o=t.tooltips.xyMode;return"auto"===o?e?"direction-distance":"coordinates":o}function S(e,t){e.sketchOptions=t.sketchOptions,e.xSize=A(t),e.ySize=G(t),e.area=L(t)}function C(e,t){const{forceUniformSize:o,sketchOptions:n}=t;e.sketchOptions=n,e.radius=o?H(t):null,e.xSize=o?null:A(t),e.ySize=o?null:G(t),e.area=L(t)}function F(e,t){const{drawOperation:o}=t,n=o?.cursorVertex??o?.lastVertex;e.actual=w.elevationFromPoint(n)??E(t),e.visible=o.hasZ,e.readOnly=!1,e.showAsZ=!0}function L(e){const o=e.createOperationGeometry?.full;return"polygon"!==o?.type?t.zeroSquareMeters:y.autoArea2D(o)??t.zeroSquareMeters}function A(e){const o=e.createOperationGeometry?.rectangle?.midpoints;return(null!=o?g.autoDistanceBetweenPoints2D(o.left,o.right):null)??t.zeroMeters}function G(e){const o=e.createOperationGeometry?.rectangle?.midpoints;return(null!=o?g.autoDistanceBetweenPoints2D(o.top,o.bottom):null)??t.zeroMeters}function H({createOperationGeometry:e}){return(null!=e?.circle?.center&&null!=e.circle.edge?g.autoDistanceBetweenPoints2D(e.circle.center,e.circle.edge):null)??t.zeroMeters}function Z(e){const{geometryType:n,tooltipInfos:i}=e;switch(n){case"point":case"mesh":case"polyline":case"polygon":{const r=i[n].elevation.committed;if(!r)return;return t.valueInUnit(r,"meters")/o.getMetersPerVerticalUnitForSR(B(e))}default:return}}function R(e,t,o,i,r){const{view:l,drawOperation:a}=r;if("3d"!==l.type||!a)return;o??=0;const c=B(r),s=q(r),p=n.getConvertedElevationFromXYZ(l,e,t,o,c,s,i);return w.elevationFromZ(p,c)??E(r)}function q(e){return e.drawOperation.elevationInfo??n.absoluteHeightElevationInfo}function B(e){return e.drawOperation.coordinateHelper.spatialReference}function E(e){const n=o.getMetersPerVerticalUnitForSR(B(e));return t.createLength(e.defaultZ*n,"meters")}function X(e,t){return l.getConstraintContext(e,t.view,B(t),q(t),t.drawOperation.coordinateHelper.hasZ(),t.sketchOptions.values.effectiveDirectionMode)}e.createTooltipInfos=v,e.getActiveTooltipInfo=k,e.getConstraintZ=Z,e.initializeConstraints=h,e.lockElevationOnVertexAdd=O,e.unlockConstraintsOnVertexAddOrRemove=M,e.updateTooltipInfo=T,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
