/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../core/has","../../core/handleUtils","../../core/mathUtils","../../core/screenUtils","./InputHandler","./InputManager","./IViewEvents"],(function(t,e,n,a,i,r,o,s){"use strict";const c=["click","double-click","immediate-click","immediate-double-click","hold","drag","key-down","key-up","pointer-down","pointer-move","pointer-up","pointer-drag","mouse-wheel","pointer-enter","pointer-leave","gamepad","focus","blur"],p={};function l(t){return!!p[t]}function u(t){for(const e of t)if(!l(e))return!1;return!0}c.forEach((t=>{p[t]=!0}));class d{constructor(t){this._handlers=new Map,this._counter=0,this._handlerCounts=new Map,this.view=t,this.inputManager=null}connect(t){t&&this.disconnect(),this.inputManager=t,this._handlers.forEach((({handler:t,priority:e},n)=>this.inputManager?.installHandlers(n,[t],e)))}disconnect(){this.inputManager&&this._handlers.forEach(((t,e)=>this.inputManager?.uninstallHandlers(e))),this.inputManager=null}destroy(){this.disconnect(),this._handlers.clear(),this.view=null}on(t,e,a,i){const r=Array.isArray(t)?t:t.split(",");if(!u(r))return r.some(l)&&console.error("Error: registering input events and other events on the view at the same time is not supported."),null;let s,c;Array.isArray(e)?c=e:(s=e,c=[]),"function"==typeof a?s=a:i=a,i=null!=i?i:o.ViewEventPriorities.DEFAULT;const p=this._createUniqueGroupName(),d=new m(this.view,r,c,s);this._handlers.set(p,{handler:d,priority:i});for(const n of r){const t=this._handlerCounts.get(n)||0;this._handlerCounts.set(n,t+1)}return this.inputManager&&this.inputManager.installHandlers(p,[d],i),n.makeHandle((()=>this._removeHandler(p,r)))}hasHandler(t){return!!this._handlerCounts.get(t)}_removeHandler(t,e){if(this._handlers.has(t)){this._handlers.delete(t);for(const t of e){const e=this._handlerCounts.get(t);void 0===e||(1===e?this._handlerCounts.delete(t):this._handlerCounts.set(t,e-1))}}this.inputManager&&this.inputManager.uninstallHandlers(t)}_createUniqueGroupName(){return this._counter+=1,`viewEvents_${this._counter}`}}class m extends r.InputHandler{constructor(t,e,n,a){super(!0),this._latestDragStart=void 0,this.view=t;for(const i of e)switch(i){case"click":this.registerIncoming("click",n,(e=>a(v(t,e))));break;case"double-click":this.registerIncoming("double-click",n,(e=>a(h(t,e))));break;case"immediate-click":this.registerIncoming("immediate-click",n,(e=>a(b(t,e))));break;case"immediate-double-click":this.registerIncoming("immediate-double-click",n,(e=>a(f(t,e))));break;case"hold":this.registerIncoming("hold",n,(e=>a(k(t,e))));break;case"drag":this.registerIncoming("drag",n,(t=>{const e=this._wrapDrag(t);e&&a(e)}));break;case"key-down":this.registerIncoming("key-down",n,(t=>a(P(t))));break;case"key-up":this.registerIncoming("key-up",n,(t=>a(D(t))));break;case"pointer-down":this.registerIncoming("pointer-down",n,(t=>a(_(t,"pointer-down"))));break;case"pointer-move":this.registerIncoming("pointer-move",n,(t=>a(_(t,"pointer-move"))));break;case"pointer-up":this.registerIncoming("pointer-up",n,(t=>a(_(t,"pointer-up"))));break;case"pointer-drag":this.registerIncoming("pointer-drag",n,(t=>a(w(t))));break;case"mouse-wheel":this.registerIncoming("mouse-wheel",n,(t=>a(x(t))));break;case"pointer-enter":this.registerIncoming("pointer-enter",n,(t=>a(_(t,"pointer-enter"))));break;case"pointer-leave":this.registerIncoming("pointer-leave",n,(t=>a(_(t,"pointer-leave"))));break;case"gamepad":this.registerIncoming("gamepad",n,(t=>{a(T(t))}));break;case"focus":this.registerIncoming("focus",n,(t=>{a(g(t))}));break;case"blur":this.registerIncoming("blur",n,(t=>{a(y(t))}))}}_wrapDrag(t){const e=t.data,{x:n,y:i}=e.center,{action:r,pointerType:o,button:s}=e;if("start"===r&&(this._latestDragStart=e),!this._latestDragStart)return;const c=e.pointer.native,p=e.buttons,{cancelable:l,timestamp:u}=t,d={x:this._latestDragStart.center.x,y:this._latestDragStart.center.y};return"end"===r&&(this._latestDragStart=void 0),{type:"drag",action:r,x:n,y:i,origin:d,pointerType:o,button:s,buttons:p,radius:e.radius,angle:a.rad2deg(e.angle),native:c,timestamp:u,cancelable:l,stopPropagation:()=>t.stopPropagation(),async:e=>t.async(e),preventDefault:()=>t.preventDefault()}}}function g(t){return{type:"focus",timestamp:t.timestamp,native:t.data.native,cancelable:t.cancelable,stopPropagation:()=>t.stopPropagation(),async:e=>t.async(e),preventDefault:()=>t.preventDefault()}}function y(t){return{type:"blur",timestamp:t.timestamp,native:t.data.native,cancelable:t.cancelable,stopPropagation:()=>t.stopPropagation(),async:e=>t.async(e),preventDefault:()=>t.preventDefault()}}function v(t,e){const{pointerType:n,button:a,buttons:r,x:o,y:s,native:c,eventId:p}=e.data,{cancelable:l,timestamp:u}=e;return{type:"click",pointerType:n,button:a,buttons:r,x:o,y:s,native:c,timestamp:u,screenPoint:i.createScreenPoint(o,s),mapPoint:I(t,o,s),eventId:p,cancelable:l,stopPropagation:()=>e.stopPropagation(),async:t=>e.async(t),preventDefault:()=>e.preventDefault()}}function h(t,e){const{pointerType:n,button:a,buttons:i,x:r,y:o,native:s,eventId:c}=e.data,{cancelable:p,timestamp:l}=e;return{type:"double-click",pointerType:n,button:a,buttons:i,x:r,y:o,native:s,timestamp:l,mapPoint:I(t,r,o),eventId:c,cancelable:p,stopPropagation:()=>e.stopPropagation(),async:t=>e.async(t),preventDefault:()=>e.preventDefault()}}function b(t,e){const{pointerType:n,button:a,buttons:i,x:r,y:o,native:s,eventId:c}=e.data,p=s.pointerId,{cancelable:l,timestamp:u}=e;return{type:"immediate-click",pointerId:p,pointerType:n,button:a,buttons:i,x:r,y:o,native:s,timestamp:u,mapPoint:I(t,r,o),eventId:c,cancelable:l,stopPropagation:()=>e.stopPropagation(),async:t=>e.async(t),preventDefault:()=>e.preventDefault()}}function f(t,e){const{pointerType:n,button:a,buttons:i,x:r,y:o,native:s,eventId:c}=e.data,p=s.pointerId,{cancelable:l,timestamp:u}=e;return{type:"immediate-double-click",pointerId:p,pointerType:n,button:a,buttons:i,x:r,y:o,native:s,timestamp:u,mapPoint:I(t,r,o),eventId:c,cancelable:l,stopPropagation:()=>e.stopPropagation(),async:t=>e.async(t),preventDefault:()=>e.preventDefault()}}function k(t,e){const{pointerType:n,button:a,buttons:i,x:r,y:o,native:s}=e.data,{cancelable:c,timestamp:p}=e;return{type:"hold",pointerType:n,button:a,buttons:i,x:r,y:o,native:s,timestamp:p,mapPoint:I(t,r,o),cancelable:c,stopPropagation:()=>e.stopPropagation(),async:t=>e.async(t),preventDefault:()=>e.preventDefault()}}function I(t,e,n){return t.toMap(i.createScreenPoint(e,n),{exclude:[]})}function P(t){const{key:e,repeat:n,native:a}=t.data,{cancelable:i,timestamp:r}=t;return{type:"key-down",key:e,repeat:n,native:a,timestamp:r,cancelable:i,stopPropagation:()=>t.stopPropagation(),async:e=>t.async(e),preventDefault:()=>t.preventDefault()}}function D(t){const{key:e,native:n}=t.data,{cancelable:a,timestamp:i}=t;return{type:"key-up",key:e,native:n,timestamp:i,cancelable:a,stopPropagation:()=>t.stopPropagation(),async:e=>t.async(e),preventDefault:()=>t.preventDefault()}}function _(t,e){const{x:n,y:a,button:i,buttons:r,native:o,eventId:s}=t.data,c=o.pointerId,p=o.pointerType,{cancelable:l,timestamp:u}=t;return{type:e,x:n,y:a,pointerId:c,pointerType:p,button:i,buttons:r,native:o,timestamp:u,eventId:s,cancelable:l,stopPropagation:()=>t.stopPropagation(),async:e=>t.async(e),preventDefault:()=>t.preventDefault()}}function w(t){const{x:e,y:n,buttons:a,native:i,eventId:r}=t.data.currentEvent,{button:o}=t.data.startEvent,s=t.data.startEvent.native.pointerId,c=t.data.startEvent.native.pointerType,p=t.data.action,l={x:t.data.startEvent.x,y:t.data.startEvent.y},{cancelable:u,timestamp:d}=t;return{type:"pointer-drag",x:e,y:n,pointerId:s,pointerType:c,button:o,buttons:a,action:p,origin:l,native:i,timestamp:d,eventId:r,cancelable:u,stopPropagation:()=>t.stopPropagation(),async:e=>t.async(e),preventDefault:()=>t.preventDefault()}}function x(t){const{cancelable:e,data:n,timestamp:a}=t,{x:i,y:r,deltaY:o,native:s}=n;return{type:"mouse-wheel",x:i,y:r,deltaY:o,native:s,timestamp:a,cancelable:e,stopPropagation:()=>t.stopPropagation(),async:e=>t.async(e),preventDefault:()=>t.preventDefault()}}function T(t){const{action:e,state:n,device:a}=t.data,{cancelable:i,timestamp:r}=t,{buttons:o,axes:s}=n;return{type:"gamepad",device:a,timestamp:r,action:e,buttons:o,axes:s,cancelable:i,stopPropagation:()=>t.stopPropagation(),async:e=>t.async(e),preventDefault:()=>t.preventDefault()}}Object.defineProperty(t,"MouseButton",{enumerable:!0,get:()=>s.MouseButton}),t.ViewEvents=d,t.eventTypes=c,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
