/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../chunks/tslib.es6","../../core/Accessor","../../core/Evented","../../core/reactiveUtils","../../core/screenUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/Logger","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../../core/libs/gl-matrix-2/math/vec2","../../chunks/vec32","../../core/libs/gl-matrix-2/factories/vec3f64","../../geometry/projection","../../geometry/projection/projectPointToVector","../../support/elevationInfoUtils","../../symbols/support/defaults","../../symbols/support/ElevationInfo","./support/utils","../support/drapedUtils"],(function(e,t,o,i,r,a,l,s,n,c,p,h,u,y,d,g,b,_,m,f,S){"use strict";e.GraphicManipulator=class extends o{set graphic(e){this._circleCollisionCache=null,this._originalSymbol=e.symbol,this._set("graphic",e),this.attachSymbolChanged()}get elevationInfo(){const{layer:e}=this.graphic,t=e&&"elevationInfo"in e?e.elevationInfo:null,o=b.getGraphicEffectiveElevationMode(this.graphic),i=t?t.offset:0;return new m({mode:o,offset:i})}set focusedSymbol(e){e!==this._get("focusedSymbol")&&(this._set("focusedSymbol",e),this._updateGraphicSymbol(),this._circleCollisionCache=null)}grabbableForEvent(){return!0}set grabbing(e){e!==this._get("grabbing")&&(this._set("grabbing",e),this._updateGraphicSymbol())}set hovering(e){e!==this._get("hovering")&&(this._set("hovering",e),this._updateGraphicSymbol())}set selected(e){e!==this._get("selected")&&(this._set("selected",e),this._updateGraphicSymbol(),this.events.emit("select-changed",{action:e?"select":"deselect"}))}get _focused(){return this._get("hovering")||this._get("grabbing")}constructor(e){super(e),this.layer=null,this.interactive=!0,this.selectable=!1,this.grabbable=!0,this.dragging=!1,this.cursor=null,this.consumesClicks=!0,this.events=new i.EventEmitter,this._circleCollisionCache=null,this._graphicSymbolChangedHandle=null,this._originalSymbol=null}destroy(){this.detachSymbolChanged(),this._resetGraphicSymbol(),this._set("view",null)}intersectionDistance(e){const t=this.graphic;if(!1===t.visible)return null;const o=t.geometry;if(null==o)return null;const i=this._get("focusedSymbol"),r=null!=i?i:t.symbol;return"2d"===this.view.type?this._intersectDistance2D(this.view,e,o,r):this._intersectDistance3D(this.view,e,t)}attach(){this.attachSymbolChanged(),null!=this.layer&&this.layer.add(this.graphic)}detach(){this.detachSymbolChanged(),this._resetGraphicSymbol(),null!=this.layer&&this.layer.remove(this.graphic)}attachSymbolChanged(){this.detachSymbolChanged(),this._graphicSymbolChangedHandle=r.watch((()=>this.graphic?.symbol),(e=>{null!=e&&e!==this.focusedSymbol&&e!==this._originalSymbol&&(this._originalSymbol=e,this._focused&&null!=this.focusedSymbol&&(this.graphic.symbol=this.focusedSymbol))}),r.sync)}detachSymbolChanged(){null!=this._graphicSymbolChangedHandle&&(this._graphicSymbolChangedHandle.remove(),this._graphicSymbolChangedHandle=null)}onElevationChange(){}onViewChange(){}_updateGraphicSymbol(){this.graphic.symbol=this._focused&&null!=this.focusedSymbol?this.focusedSymbol:this._originalSymbol}_resetGraphicSymbol(){this.graphic.symbol=this._originalSymbol}_intersectDistance2D(e,t,o,i){if(null==(i=i||_.getDefaultSymbol2D(o)))return null;const r=1;let l=this._circleCollisionCache;if("point"===o.type&&"cim"===i.type&&"CIMPointSymbol"===i.data.symbol?.type&&i.data.symbol.symbolLayers){const{offsetX:l,offsetY:s,size:n}=f.getSymbolInfo(i),c=a.screenPointObjectToArray(t,G),p=n/2,u=e.toScreen(o),y=u.x+l,d=u.y+s;return h.squaredDistance(c,[y,d])<p*p?r:null}if("point"!==o.type||"simple-marker"!==i.type)return S.intersectsDrapedGeometry(t,o,e)?r:null;if(null==l||!l.originalPoint.equals(o)){const t=o,r=e.spatialReference;if(d.canProjectWithoutEngine(t.spatialReference,r)){const e=d.project(t,r);l={originalPoint:t.clone(),mapPoint:e,radiusPx:a.pt2px(i.size)},this._circleCollisionCache=l}}if(null!=l){const o=a.screenPointObjectToArray(t,G),s=e.toScreen?.(l.mapPoint);if(!s)return null;const n=l.radiusPx,c=s.x+a.pt2px(i.xoffset),p=s.y-a.pt2px(i.yoffset);return h.squaredDistance(o,[c,p])<n*n?r:null}return null}_intersectDistance3D(e,t,o){const i=e.toMap(t,{include:[o]});return i&&g.projectPointToVector(i,v,e.renderSpatialReference)?u.distance(v,e.state.camera.eye):null}},t.__decorate([l.property({constructOnly:!0,nonNullable:!0})],e.GraphicManipulator.prototype,"graphic",null),t.__decorate([l.property()],e.GraphicManipulator.prototype,"elevationInfo",null),t.__decorate([l.property({constructOnly:!0,nonNullable:!0})],e.GraphicManipulator.prototype,"view",void 0),t.__decorate([l.property({value:null})],e.GraphicManipulator.prototype,"focusedSymbol",null),t.__decorate([l.property({constructOnly:!0})],e.GraphicManipulator.prototype,"layer",void 0),t.__decorate([l.property()],e.GraphicManipulator.prototype,"interactive",void 0),t.__decorate([l.property()],e.GraphicManipulator.prototype,"selectable",void 0),t.__decorate([l.property()],e.GraphicManipulator.prototype,"grabbable",void 0),t.__decorate([l.property({value:!1})],e.GraphicManipulator.prototype,"grabbing",null),t.__decorate([l.property()],e.GraphicManipulator.prototype,"dragging",void 0),t.__decorate([l.property()],e.GraphicManipulator.prototype,"hovering",null),t.__decorate([l.property({value:!1})],e.GraphicManipulator.prototype,"selected",null),t.__decorate([l.property()],e.GraphicManipulator.prototype,"cursor",void 0),e.GraphicManipulator=t.__decorate([p.subclass("esri.views.interactive.GraphicManipulator")],e.GraphicManipulator);const v=y.create(),G=a.createScreenPointArray();Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
