/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../core/iteratorUtils","../../core/mathUtils","../../core/screenUtils","./interactiveToolUtils","../support/screenUtils"],(function(e,t,o,a,n,r){"use strict";class i{constructor(){this._pointerLocations=new Map,this._hoveredManipulators=new Map,this._grabbedManipulators=new Map,this._draggedManipulators=new Map,this._stopDrag=!1,this._externallyDragging=!1,this._revertToNullActiveTool=!1,this._cursor=null}get cursor(){return this._cursor}hasFocusedManipulators(){return this._grabbedManipulators.size>0||this._draggedManipulators.size>0}handleInputEvent(e,t){const a=()=>e.stopPropagation();switch(e.type){case"pointer-move":p(e.pointerType)&&this._pointerLocations.set(e.pointerId,{x:e.x,y:e.y,pointerType:e.pointerType});break;case"drag":this._grabbedManipulators.size>0?this._stopDrag=!0:"start"===e.action?this._externallyDragging=!0:"end"===e.action&&(this._externallyDragging=!1),this._stopDrag&&(a(),"end"===e.action&&(this._stopDrag=!1));break;case"pointer-down":{if(!u(e))break;const o=r.createScreenPointFromEvent(e),n=l(o,e.pointerType,t.forEachTool);if(null==n)break;const i=n.manipulator,s=n.tool;null==i||null==s||!i.interactive||i.grabbable&&i.grabbableForEvent(e)||!i.grabbing||i.dragging||this._releaseManipulatorBeforeDragging(i,e,t),null!=i&&null!=s&&i.interactive&&i.grabbable&&i.grabbableForEvent(e)&&!i.grabbing&&(this._grabbedManipulators.set(e.pointerId,{manipulator:i,tool:s,start:o,pointerType:e.pointerType}),1===this._grabbedManipulators.size&&null==t.activeTool&&(this._revertToNullActiveTool=!0,t.setActiveTool(n.tool)),i.grabbing=!0,i.events.emit("grab-changed",{action:"start",pointerType:e.pointerType,screenPoint:o}),a());break}case"pointer-up":this._draggedManipulators.has(e.pointerId)||this._handlePointerEnd(e,t);break;case"pointer-drag":{if(!u(e))break;const n=this._grabbedManipulators.get(e.pointerId),i=n?.manipulator,s=n?.tool;if(null==i||null==s)break;const l=r.createScreenPointFromEvent(e);l.x=o.clamp(l.x,0,t.view.width),l.y=o.clamp(l.y,0,t.view.height);const p=n.start,c=this._draggedManipulators.get(e.pointerId);switch(e.action){case"start":case"update":"update"!==e.action&&1!==this._grabbedManipulators.size||(i.dragging=!0,c?i.events.emit("drag",{action:"update",start:p,screenPoint:l}):i.events.emit("drag",{action:"start",start:p,screenPoint:l,pointerType:e.pointerType}),this._draggedManipulators.set(e.pointerId,{tool:s,manipulator:i,start:p}));break;case"end":i.dragging=!1,c&&i.events.emit("drag",{action:"end",start:p,screenPoint:l}),this._draggedManipulators.delete(e.pointerId),this._handlePointerEnd(e,t)}a();break}case"immediate-click":{const o=r.createScreenPointFromEvent(e),n=l(o,e.pointerType,t.forEachTool);if(c(e)||t.forEachTool((e=>{if((null==n||n.tool!==e||e.automaticManipulatorSelection)&&e.manipulators){let t=!1;e.manipulators.forEach((({manipulator:e})=>{e.selected&&(e.selected=!1,t=!0)})),t&&e.onManipulatorSelectionChanged&&e.onManipulatorSelectionChanged()}})),null==n)break;const{manipulator:i,tool:s}=n;if(!i.interactive)break;i.selectable&&s.automaticManipulatorSelection&&(i.selected=!i.selected,s.onManipulatorSelectionChanged&&s.onManipulatorSelectionChanged());const p=e.native.shiftKey;i.events.emit("immediate-click",{screenPoint:o,button:e.button,pointerType:e.pointerType,shiftKey:p,stopPropagation:a}),d(i,a);break}case"click":{const o=r.createScreenPointFromEvent(e),n=l(o,e.pointerType,t.forEachTool),i=n?.manipulator;if(null==i||!i.interactive)break;const s=e.native.shiftKey;i.events.emit(e.type,{screenPoint:o,button:e.button,pointerType:e.pointerType,shiftKey:s}),a();break}case"double-click":{const o=r.createScreenPointFromEvent(e),n=l(o,e.pointerType,t.forEachTool),i=null!=n?n.manipulator:null;if(null==i||!i.interactive)break;const s=e.native.shiftKey;i.events.emit("double-click",{screenPoint:o,button:e.button,pointerType:e.pointerType,shiftKey:s,stopPropagation:a}),d(i,a);break}case"immediate-double-click":{const o=r.createScreenPointFromEvent(e),n=l(o,e.pointerType,t.forEachTool),i=null!=n?n.manipulator:null;if(null==i||!i.interactive)break;const s=e.native.shiftKey;i.events.emit("immediate-double-click",{screenPoint:o,button:e.button,pointerType:e.pointerType,shiftKey:s,stopPropagation:a}),"mouse"===e.pointerType&&d(i,a);break}}this._onFocusChange(t.forEachTool)}_releaseManipulatorBeforeDragging(e,t,o){e.grabbing=!1,e.events.emit("grab-changed",{action:"end",pointerType:t.pointerType,screenPoint:r.createScreenPointFromEvent(t)}),this._grabbedManipulators.forEach((({manipulator:t},o)=>{t===e&&this._grabbedManipulators.delete(o)})),this._afterManipulatorRelease(o.setActiveTool)}_handlePointerEnd(e,t){const o=this._grabbedManipulators.get(e.pointerId)?.manipulator;null!=o&&o.grabbing&&(o.grabbing=!1,o.events.emit("grab-changed",{action:"end",pointerType:e.pointerType,screenPoint:r.createScreenPointFromEvent(e)}),this._grabbedManipulators.delete(e.pointerId),this._afterManipulatorRelease(t.setActiveTool))}_onFocusChange(e){this._updateCursor(),this._updateFocusedManipulatorTools(e)}_updateCursor(){this._grabbedManipulators.size>0?this._cursor=s(this._grabbedManipulators)||"grabbing":this._hoveredManipulators.size>0?this._cursor=s(this._hoveredManipulators)||"pointer":this._cursor=null}_updateFocusedManipulatorTools(e){const o=new Set,a=new Set;this._grabbedManipulators.forEach((({tool:e})=>{o.add(e)})),this._hoveredManipulators.forEach((({tool:e})=>{a.add(e)})),e((e=>{e.hasGrabbedManipulators=o.has(e),e.hasHoveredManipulators=a.has(e);const n=this._grabbedManipulators.values(),r=t.find(n,(({tool:t})=>t===e));e.firstGrabbedManipulator=null!=r?r.manipulator:null}))}clearPointers(e,{forEachTool:t,setActiveTool:o},a=!0,n){const r=(t,o)=>t===e&&(null==n||n===o);this._grabbedManipulators.forEach((({tool:e,manipulator:t,pointerType:o},a)=>{r(e,t)&&(this._grabbedManipulators.delete(a),t.grabbing=!1,t.events.emit("grab-changed",{action:"end",screenPoint:null,pointerType:o}))})),this._draggedManipulators.forEach((({tool:e,manipulator:t},o)=>{r(e,t)&&(this._draggedManipulators.delete(o),t.dragging=!1,t.events.emit("drag",{action:"cancel"}))})),a&&this._hoveredManipulators.forEach((({tool:e,manipulator:t},o)=>{r(e,t)&&(this._hoveredManipulators.delete(o),t.hovering=!1)})),this._afterManipulatorRelease(o),this._onFocusChange(t)}updateHoveredStateFromKnownPointers(e){this._pointerLocations.forEach(((t,o)=>{this._updateHoveredStateForPointerAtScreenPosition(a.createScreenPoint(t.x,t.y),o,t.pointerType,e)}))}handleHoverEvent(e,t){const o=e.type;"pointer-up"!==o&&"immediate-click"!==o&&"pointer-move"!==o||!p(e.pointerType)||("pointer-up"!==o&&this._externallyDragging?this._clearHoveredManipulatorStates(e.pointerId):this._updateHoveredStateForPointerAtScreenPosition(r.createScreenPointFromEvent(e),e.pointerId,e.pointerType,t))}_updateHoveredStateForPointerAtScreenPosition(e,t,o,a){let n=l(e,o,a);const r=this._hoveredManipulators.get(t)?.manipulator;null==n||n.manipulator.interactive||(n=null),null!=n&&r===n.manipulator||(null!=r&&(r.hovering=!1),null!=n?(n.manipulator.hovering=!0,this._hoveredManipulators.set(t,n)):this._hoveredManipulators.delete(t),this._onFocusChange(a))}_afterManipulatorRelease(e){0===this._grabbedManipulators.size&&this._revertToNullActiveTool&&(e(null),this._revertToNullActiveTool=!1)}_clearHoveredManipulatorStates(e){this._hoveredManipulators.forEach((({manipulator:t},o)=>{e===o&&(this._hoveredManipulators.delete(e),t.hovering=!1)}))}}function s(e){for(const{manipulator:t}of e.values())if(null!=t&&t.interactive){if(t.grabbing&&t.grabCursor)return t.grabCursor;if(t.cursor)return t.cursor}return null}function l(e,t,o){let a=null;return o((o=>{if(null==o.manipulators||!n.areToolManipulatorsEditable(o))return!1;const r=o.manipulators.intersect(e,t);return null!=r&&(a={tool:o,manipulator:r},!0)})),a}function p(e){return"mouse"===e}function u(e){return"mouse"!==e.pointerType||0===e.button}function c(e){return!!e.native.shiftKey}function d(e,t){e?.consumesClicks&&t()}e.ToolViewManagerManipulatorState=i,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
