/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../core/Evented","../../core/events","../../core/maybe","../../core/reactiveUtils","../../core/screenUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/Logger","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../../support/themeUtils","./tooltip/css","./tooltip/content/tooltipContentFactory","../../widgets/support/widgetUtils"],(function(t,e,o,n,i,r,s,c,a,l,p,d,u,h,f){"use strict";const y={base:`${u.base}`,ltr:`${u.base}--ltr`,rtl:`${u.base}--rtl`,debug:`${u.base}--debug`},_=20,v=16,g="bottom-end";let m=class extends e.EventedAccessor{constructor(t){super(t),this.info=null,this.options=null,this.position=null,this.content=null,this._focused=!1,this.outerContainer=document.createElement("div"),this.debug=!1,this._lastPosition=null,this._rtl=!1,this._prevXY=[0,0]}initialize(){const{outerContainer:t}=this;this.addHandles([i.watch((()=>this.view.overlay?.surface),(e=>{t.remove(),e?.appendChild(t),this._rtl=f.isRTL(e)}),i.syncAndInitial),i.watch((()=>this.info),((e,o)=>{if(null!=this.content&&null!=e&&null!=o&&e.type===o.type)this.content.info=e;else{n.destroyMaybe(this.content);const o=h.tooltipContentFactory(this,e);o?(this.content=o,o.container&&t.appendChild(o.container),this.exitInputMode()):this.content=null}}),i.syncAndInitial),i.watch((()=>({container:this.outerContainer,style:this._outerContainerStyle})),(({container:t,style:e})=>{Object.assign(t.style,e)}),i.initial),i.watch((()=>({outerContainer:this.outerContainer,placement:this.effectivePlacement,effectiveOffset:this._effectiveOffset,rtl:this._rtl,debug:this.debug})),(({outerContainer:t,placement:e,effectiveOffset:o,rtl:n,debug:i})=>{const{classList:r}=t;r.add(y.base),r.toggle(y.rtl,n),r.toggle(y.ltr,!n),r.toggle(y.debug,i),this.outerContainer.style.setProperty("--offset",`${o}px`),d.setCalciteThemeClass(t),w(t,e)}),i.initial),i.when((()=>"feedback"===this.mode),(()=>{this.position=null,this._clearOverride("effectivePlacement")}),i.sync),o.on(this.outerContainer,"paste",(t=>{this.emit("paste",t)})),o.on(this.outerContainer,["focusin","focusout"],(()=>{setTimeout((()=>{this._focused=this.content?.container?.contains(document.activeElement)??!1}))}))])}destroy(){this.info=null,this.content=n.destroyMaybe(this.content),this.outerContainer.remove()}get mode(){return this.content?.mode??"feedback"}get focused(){return this._focused}get visible(){return"none"!==this._outerContainerStyle.display}get contentContainer(){return this.content?.container}get effectivePlacement(){const t=this.options?.placement;return"auto"===t?"bottom-end":t??g}get _screenPoint(){const{inputManager:t}=this.view;return t?.multiTouchActive?null:t?.latestPointerLocation}get _effectiveOffset(){return this.options?.offset??_}get _outerContainerStyle(){const t=this.position??this._screenPoint;if(this._lastPosition=r.cloneScreenPoint(t),null!=t&&null!=this.content){return{display:"block",transform:`translate(${Math.round(t.x)}px, ${Math.round(t.y)}px)`}}return{display:"none",transform:"none"}}clear(){this.info=null}async enterInputMode(t){const e=this.position??this._lastPosition??this._screenPoint,o=this.position=r.cloneScreenPoint(e),{effectivePlacement:n}=this;this._override("effectivePlacement",n);const i=()=>{o&&(this.position=b(this.contentContainer,o,this._effectiveOffset,this.view),Object.assign(this.outerContainer.style,this._outerContainerStyle))};await(this.content?.enterInputMode(t,i))}async exitInputMode(t){await(this.content?.exitInputMode(t))}onDragStart(t,e){this._prevXY=[t,e]}onDrag(t,e){const o=t-this._prevXY[0],n=e-this._prevXY[1];this._prevXY=[t,e];const{position:i}=this;if(i){const{view:s}=this,c=t-s.position[0],a=e-s.position[1];if(c<0||c>s.width||a<0||a>s.height-v)return;this.position=r.createScreenPoint(i.x+o,i.y+n)}}onDragEnd(){this._prevXY=[0,0]}};function b(t,e,o,n){if(!t||!n.container)return e;const i=t.getBoundingClientRect(),{left:s,top:c}=n.container.getBoundingClientRect();let{x:a,y:l}=e;const p=i.left-s-o;p<0&&(a-=p);const d=i.right-s+o-n.width;d>0&&(a-=d);const u=i.top-c-o;u<0&&(l-=u);const h=i.bottom-c+o-n.height;return h>0&&(l-=h),r.createScreenPoint(a,l)}t.__decorate([s.property({nonNullable:!0})],m.prototype,"view",void 0),t.__decorate([s.property()],m.prototype,"info",void 0),t.__decorate([s.property()],m.prototype,"options",void 0),t.__decorate([s.property()],m.prototype,"position",void 0),t.__decorate([s.property()],m.prototype,"content",void 0),t.__decorate([s.property({readOnly:!0})],m.prototype,"mode",null),t.__decorate([s.property()],m.prototype,"_focused",void 0),t.__decorate([s.property({readOnly:!0})],m.prototype,"focused",null),t.__decorate([s.property({readOnly:!0})],m.prototype,"outerContainer",void 0),t.__decorate([s.property({readOnly:!0})],m.prototype,"contentContainer",null),t.__decorate([s.property({readOnly:!0})],m.prototype,"effectivePlacement",null),t.__decorate([s.property()],m.prototype,"debug",void 0),t.__decorate([s.property()],m.prototype,"_lastPosition",void 0),t.__decorate([s.property()],m.prototype,"_screenPoint",null),t.__decorate([s.property()],m.prototype,"_rtl",void 0),t.__decorate([s.property()],m.prototype,"_effectiveOffset",null),t.__decorate([s.property()],m.prototype,"_outerContainerStyle",null),m=t.__decorate([p.subclass("esri.views.interactive.Tooltip")],m);const C=["top","bottom","leading","trailing"].flatMap((t=>[P(`${t}-start`),P(t),P(`${t}-end`)]));function P(t){return`${y.base}--${t}`}function w({classList:t},e){C.forEach((e=>t.remove(e))),t.add(P(e))}return m}));
