/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../geometry","../../../core/quantityUtils","../../../core/unitUtils","../../../chunks/vec32","../../../geometry/projection/projectVectorToVector","../../../geometry/support/geodesicUtils","../../../layers/graphics/dehydratedPoint","../../../support/elevationInfoUtils","./constraints","./normalizedPoint","../../support/angularMeasurementUtils","../../../geometry/SpatialReference"],(function(e,t,n,r,o,i,l,c,a,u,s,d,f){"use strict";function g(e,t,n,r,o,c){let a="geodesic",u=l.geodesicCompatibleSpatialReference(n);const d=s.createWritable();return s.fromPoint(e,t,r,d),d[2]=0,u&&i.projectVectorToVector(d,n,d,u)||(a="euclidean",u=n),{mode:a,view:t,elevationInfo:r,hasZ:o,directionMode:c,spatialReference:e.spatialReference,measurementSR:u,origin:d}}function p(e,t,o){if(null==t||null==e)return;const i=r.lengthUnitFromSpatialReference(o.measurementSR);if(null==i)return;const l=w(e,o);if(null==l)return;const c=n.valueInUnit(t,i);return new u.VerticalCylinderConstraint(l,c)}function m(e,t,r,o){if(null==r||null==e)return;const i=w(e,o);if(null==i)return;const l=d.getDegreesGeographic(r),c=10,a=e=>{if(null==e)return;const t=s.createWritable(),r=n.createAngle(e,"degrees","geographic");return d.pointFromDistanceAlongAzimuth(t,i,o.measurementSR,c,r,o.mode)?new u.VerticalHalfPlaneConstraint(i,t):void 0},f=()=>{if(null!=t&&null!=e)return d.getDegreesGeographic(d.directionBetweenPoints(t,e))};switch(o.directionMode){case d.DirectionMode.Absolute:return a(l);case d.DirectionMode.Relative:{const e=f();if(null==e)return;return a(e+l)}case d.DirectionMode.RelativeBilateral:{const e=f();if(null==e)return;return u.constraintOrSet([a(e+l),a(e-l)])}}}function v(e,t){const n=b(e,t);return null!=n?new u.HorizontalPlaneConstraint(n):void 0}function R(e,t,n){const{context:r,longitude:o,latitude:i,direction:l,distance:c,elevation:a}=n;if(null!=o||null!=i||null!=c||null!=a||null!=l){if(null!=o||null!=i){const e=d.getDegreesGeographic(o),t=d.getDegreesGeographic(i),n=b(a,r);return new u.CoordinateConstraint(e,t,n)}return h(e,t,n)}}function h(e,t,{context:r,direction:o,distance:l,elevation:c}){if(null==t)return v(c,r);const{view:a,elevationInfo:f,measurementSR:g}=r,p=s.fromPoint(t,a,f);if(!g||!i.projectVectorToVector(p,t.spatialReference,M,g))return;const[m,R]=M,h=null!=l?n.valueInUnit(l,"meters"):void 0,y=d.getDegreesGeographic(o),C=b(c,r),S=e=>{const t=new u.GeodesicConstraint([m,R],g,h,C,e);return null==h||null==e||null==C&&r.hasZ?t:new u.PointConstraint(t.closestTo(p))};if(null==y)return S(void 0);const P=()=>{if(null!=e&&null!=t)return d.getDegreesGeographic(d.directionBetweenPoints(e,t))};switch(r.directionMode){case d.DirectionMode.Absolute:return S(y);case d.DirectionMode.Relative:{const e=P();if(null==e)return;return S(e+y)}case d.DirectionMode.RelativeBilateral:{const e=P();if(null==e)return;return u.constraintOrSet([S(e+y),S(e-y)])}}}function y(e){return"geodesic"===e.context.mode?R(null,null,e):S(e)}function C(e,t,n){const{context:r,x:o,y:i,distance:l,direction:c,elevation:a}=n;return"geodesic"===r.mode?R(t,e,n):null!=o||null!=i?S(n):P([p(e,l,r),m(e,t,c,r),v(a,r)])}function S({x:e,y:t,elevation:n,context:r}){G.x=e?.value??0,G.y=t?.value??0,G.spatialReference=r.spatialReference;const o=w(G,r,x);return new u.CoordinateConstraint(null!=e&&null!=o?o[0]:void 0,null!=t&&null!=o?o[1]:void 0,b(n,r))}function P(e){let t;for(const n of e)n&&(t=t?.intersect(n)??n);return t}function w(e,t,n=s.createWritable()){const{view:r,elevationInfo:l,measurementSR:c,origin:a,mode:u}=t;if(s.fromPoint(e,r,l,n),i.projectVectorToVector(n,e.spatialReference,n,c))return"geodesic"!==u&&o.subtract(n,n,a),n}function D(e,t,n,r){const{view:l,measurementSR:c,spatialReference:a,origin:u,mode:d}=n;if("geodesic"===d?o.copy(U,e):o.add(U,e,u),i.projectVectorToVector(U,c,U,a))return s.toElevationAlignedDehydratedPoint(U,l,t,n,r)}function b(e,t){return V(e,t)?.value??void 0}function V(e,{view:t,origin:o,elevationInfo:i,hasZ:l,measurementSR:c}){if(null==e||!l)return;const u=r.verticalLengthUnitFromSpatialReference(c);if(null==u)return;const[s,d]=o,f=n.valueInUnit(e,u),g="3d"===t?.type?a.getConvertedElevationFromXYZ(t,s,d,f,c,i):f;return null!=g?n.createLength(g,u):void 0}const M=s.createWritable(),x=s.createWritable(),U=s.createWritable(),G=c.makeDehydratedPoint(0,0,0,f.WGS84);e.constraintSpaceToPoint=D,e.getConstraintContext=g,e.getGeodesicConstraint=R,e.getPointConstraint=y,e.getPolylineOrPolygonConstraint=C,e.intersectAll=P,e.pointToConstraintSpace=w,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
