/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../core/arrayUtils","../../../core/mathUtils","../../../core/libs/gl-matrix-2/math/vec2","../../../core/libs/gl-matrix-2/factories/vec2f64","../../../chunks/vec32","../../../core/libs/gl-matrix-2/factories/vec3f64","../../../chunks/vec42","../../../core/libs/gl-matrix-2/factories/vec4f64","../../../geometry/support/geodesicConstants","../../../geometry/support/geodesicUtils","../../../geometry/support/plane","../../../chunks/sphere","../../3d/support/mathUtils","./normalizedPoint","../../support/geometry3dUtils","../../support/geometry2dUtils"],(function(e,t,n,r,s,i,c,a,o,l,u,d,h,f,p,P,L){"use strict";class C{intersect(e){return F(this,e)}closestPoints(e){return[this.closestTo(e)]}}class g extends C{constructor(e){super(),this.point=e}equals(e){return this===e||me(e)&&i.exactEquals(this.point,e.point)}closestTo(){return p.clone(this.point)}}class V extends C{constructor(e,t,n){super(),this.start=e,this.end=t,this.lineLike={start:e,end:t,type:n}}equals(e){return this===e||_e(e)&&this.lineLike.type===e.lineLike.type&&i.exactEquals(this.start,e.start)&&i.exactEquals(this.end,e.end)}closestTo(e){const t=p.createWritable();return P.projectPointToLineLike(e,this.lineLike,t),t}}class m extends V{constructor(e,t){super(e,t,L.LineType.LINE)}}class _ extends V{constructor(e,t){super(e,t,L.LineType.RAY)}}class y extends C{constructor(e){super(),this.constraints=e}equals(e){return this===e||Ve(e)&&t.equals(this.constraints,e.constraints,((e,t)=>e.equals(t)))}closestTo(e){let t,n=1/0;for(const r of this.constraints){const s=r.closestTo(e),c=i.squaredDistance(e,s);c<n&&(n=c,t=s)}return p.clone(t??e)}closestPoints(e){return this.constraints.flatMap((t=>t===this?[]:t.closestPoints(e)))}}class A extends C{constructor(e,t){super(),this.center=e,this.radius=t}equals(e){return this===e||ke(e)&&this.center[0]===e.center[0]&&this.center[1]===e.center[1]&&this.radius===e.radius}closestTo(e){const t=p.createWritable();return P.projectPointToVerticalCylinder(e,this.center,this.radius,t),t}}class k extends C{constructor(e,t){super(),this.center=e,this.radius=t}equals(e){return this===e||xe(e)&&i.exactEquals(this.center,e.center)&&this.radius===e.radius}closestTo(e){const t=p.createWritable();return P.projectPointToVerticalCylinder(e,this.center,this.radius,t),t[2]=this.center[2],t}asCircle(){return new x(p.clone(this.center),this.radius,p.fromValues(0,0,1))}}class x extends C{constructor(e,t,n,r=void 0){super(),this.center=e,this.radius=t,this.normal=n,this.slicePlane=r}equals(e){return this===e||qe(e)&&i.exactEquals(this.center,e.center)&&i.exactEquals(this.normal,e.normal)&&this.radius===e.radius}closestTo(e){const{center:t,radius:n}=this;d.projectPoint(this.getPlane(T),e,q);const r=i.sub(q,q,t),s=i.squaredLength(r);if(P.isClose(s,0))return p.clone(e);const c=n/Math.sqrt(s),a=p.createWritable();i.scaleAndAdd(a,t,r,c);const{slicePlane:o}=this;if(o&&!P.isPointInsidePlane(o,a)){const t=K(o,this);return t?.closestTo(e)??p.clone(e)}return a}getPlane(e=d.create()){return d.fromPositionAndNormal(this.center,this.normal,e)}}const q=c.create(),T=d.create();class v extends C{constructor(e){super(),this.z=e}equals(e){return this===e||ye(e)&&this.z===e.z}closestTo(e){return p.fromValues(e[0],e[1],this.z)}getPlane(e=d.create()){return i.set(z,0,0,this.z),d.fromPositionAndNormal(z,c.UNIT_Z,e)}}const z=c.create();class M extends C{constructor(e,t,n){super(),this.start=e,this.end=t,this.planeLike={start:p.asVec2(e),end:p.asVec2(t),type:n}}equals(e){return this===e||Ae(e)&&this.planeLike.type===e.planeLike.type&&i.exactEquals(this.start,e.start)&&i.exactEquals(this.end,e.end)}closestTo(e){const t=p.createWritable();return P.projectPointToVerticalPlane(e,this.planeLike,t),t}closestEndTo(e){const{start:t,end:n}=this.planeLike;return Math.sign(r.dot(r.subtract(b,n,t),r.subtract(E,p.asVec2(e),t)))>0?this.end:this.start}getPlane(e=d.create()){const t=i.copy(w,this.end);return t[2]+=1,d.fromPoints(this.start,this.end,t,e)}getSlicePlane(e=d.create()){const{start:t,end:n,type:r}=this.planeLike;if(r===P.VerticalPlaneType.PLANE)return;const s=i.set(w,t[0],t[1],0),c=i.set(S,n[0],n[1],0),a=i.subtract(S,c,s);return d.fromPositionAndNormal(s,a,e),e}}const b=s.create(),E=s.create(),w=c.create(),S=c.create();class D extends M{constructor(e,t){super(e,t,P.VerticalPlaneType.HALF_PLANE)}}class I extends M{constructor(e,t){super(e,t,P.VerticalPlaneType.PLANE)}}class R extends C{constructor(e,t){super(),this.sphere=h.fromCenterAndRadius(e,t)}equals(e){return this===e||Te(e)&&h.exactEquals(this.sphere,e.sphere)}closestTo(e){const t=p.createWritable();return h.projectPoint(this.sphere,e,t),t}get center(){return h.getCenter(this.sphere)}get radius(){return this.sphere[3]}}class N extends C{constructor(e,t,n){super(),this.start=e,this.end=t,this.getZ=n,this.planeLike={start:p.asVec2(e),end:p.asVec2(t),type:P.VerticalPlaneType.PLANE}}equals(e){return this===e||ve(e)&&i.exactEquals(this.start,e.start)&&i.exactEquals(this.end,e.end)&&this.getZ===e.getZ}closestTo(e){return O(this,e)}addIfOnTheGround(e,t){for(const n of t){const t=this.getZ(n[0],n[1])??0;P.isClose(n[2],t)&&(n[2]=t,e.push(n))}}}class G extends C{constructor(e,t,n){super(),this._x=e,this._y=t,this._z=n}equals(e){return this===e||Me(e)&&this._x===e._x&&this._y===e._y&&this._z===e._z}closestTo([e,t,n]){return p.create(this._x??e,this._y??t,this._z??n)}}class W extends C{constructor(e,t,n,r,s){super(),this._origin=e,this._spatialReference=t,this._distanceMeters=n,this._z=r,this._directionDegrees=s}equals(e){return this===e||ze(e)&&r.exactEquals(this._origin,e._origin)&&this._spatialReference===e._spatialReference&&this._distanceMeters===e._distanceMeters&&this._z===e._z&&this._directionDegrees===e._directionDegrees}closestTo([e,t,n]){return r.set(j,e,t),r.exactEquals(j,this._origin)||this._applyDirectionAndDistance(j),p.create(j[0],j[1],this._z??n)}_applyDirectionAndDistance(e){if(null!=this._directionDegrees&&null!=this._distanceMeters)u.directGeodeticSolver(e,this._origin,this._directionDegrees,this._distanceMeters,this._spatialReference);else if(null!=this._directionDegrees)U(e,this._origin,this._directionDegrees,e,this._spatialReference);else if(null!=this._distanceMeters){const{azimuth:t}=u.inverseGeodeticSolver(Z,this._origin,e,this._spatialReference);u.directGeodeticSolver(e,this._origin,t??0,this._distanceMeters,this._spatialReference)}}}const j=[0,0],Z=new u.InverseGeodeticSolverResult;function U(e,t,n,r,s){let{azimuth:i,distance:c}=u.inverseGeodeticSolver(H,t,r,s);i??=0;let a=c*Math.cos((i-n)*l.toRadians);a=Math.max(0,a),u.directGeodeticSolver(e,t,n,a,s)}const H=new u.InverseGeodeticSolverResult;function O(e,t){const n=p.createWritable();return P.projectPointToVerticalPlane(t,e.planeLike,n),n[2]=e.getZ(n[0],n[1])??be,n}function F(e,t){if(Ve(e)){const n=[];for(const r of e.constraints){const e=r.intersect(t);e&&n.push(e)}return ge(n)}if(Ve(t))return F(t,e);if(ve(e))return pe(e,t);if(ve(t))return pe(t,e);if(me(e)){const{point:n}=e;if(me(t))return i.exactEquals(n,t.point)?e:void 0;const r=t.closestTo(n);return i.equals(r,n)?e:void 0}if(_e(e)){if(me(t))return F(t,e);if(_e(t))return Le(P.intersectLineLikes(e.lineLike,t.lineLike));if(ye(t))return Y(e,t);if(Ae(t))return Le(P.intersectVerticalPlaneAndLineLike(t.planeLike,e.lineLike));if(ke(t))return Le(P.intersectLineLikeAndVerticalCylinder(e.lineLike,t.center,t.radius));if(qe(t))return Le(P.intersectLineLikeAndCircle(e.lineLike,t));if(xe(t))return B(e,t);if(Te(t))return J(e,t)}else if(ye(e)){if(me(t)||_e(t))return F(t,e);if(ye(t))return Q(e,t);if(Ae(t))return X(e,t);if(ke(t))return $(e,t);if(qe(t))return te(e,t);if(xe(t))return ee(e,t);if(Te(t))return ne(e,t)}else if(Ae(e)){if(me(t)||_e(t)||ye(t))return F(t,e);if(Ae(t))return Pe(P.intersectVerticalPlanes(e.planeLike,t.planeLike));if(ke(t))return Pe(P.intersectVerticalPlaneAndVerticalCylinder(e.planeLike,t.center,t.radius));if(qe(t))return se(e,t);if(xe(t))return re(e,t);if(Te(t))return ie(e,t)}else if(ke(e)){if(me(t)||_e(t)||ye(t)||Ae(t))return F(t,e);if(ke(t))return Pe(P.intersectVerticalCylinders(p.asVec2(e.center),e.radius,p.asVec2(t.center),t.radius));if(qe(t))return ce();if(xe(t))return ae(e,t);if(Te(t))return oe()}else if(qe(e)){if(me(t)||_e(t)||ye(t)||Ae(t)||ke(t))return F(t,e);if(qe(t))return le();if(xe(t))return le(t.asCircle());if(Te(t))return ue()}else if(xe(e)){if(me(t)||_e(t)||ye(t)||Ae(t)||ke(t)||qe(t))return F(t,e);if(xe(t))return de(t,e);if(Te(t))return he()}else if(Te(e)){if(me(t)||_e(t)||ye(t)||Ae(t)||ke(t)||xe(t))return F(t,e);if(Te(t))return fe()}}const Y=(()=>{const e=d.create();return(t,n)=>{const{start:r,end:s}=t;if(P.vectorsHaveCloseZ(r,s)&&P.isClose(r[2],n.z))return t;const i=p.createWritable();return d.intersectLine(n.getPlane(e),r,s,i)?new g(i):void 0}})();function B({lineLike:e},{center:t,radius:n}){const r=t[2];return Le(P.intersectLineLikeAndVerticalCylinder(e,t,n).filter((e=>P.isClose(e[2],r))))}function J({lineLike:e},{sphere:t}){return Le(h.intersectLine(t,e.start,e.end))}const K=(()=>{const e=o.create(),t=c.create(),r=c.create();return(s,o,l)=>{const{normal:u,center:h,radius:L}=o;f.tangentFrame(u,t,r);const C=d.getNormal(s),V=L*i.dot(C,t),m=L*i.dot(C,r);a.set(e,h[0],h[1],h[2],1);const _=a.dot(s,e),y=Math.hypot(V,m),A=P.isClose(y,0);if(P.isClose(d.distance(s,h),0)){if(A)return o;if(P.isClose(L,0))return!l||P.isPointInsidePlane(l,h)?new g(p.clone(h)):void 0;i.cross(t,C,u),i.normalize(t,t);const e=new Array,n=c.clone(h);i.scaleAndAdd(n,n,t,L),l&&!P.isPointInsidePlane(l,n)||e.push(n);const r=c.clone(h);return i.scaleAndAdd(r,r,t,-L),l&&!P.isPointInsidePlane(l,r)||e.push(r),Le(e)}if(A)return;const k=-_/y;if(Math.abs(k)>1||P.isClose(k,1))return;const x=Math.atan(V/m),q=n.asinClamped(k)-x,T=Math.PI-q,v=new Array,z=c.create();i.scaleAndAdd(z,h,t,L*Math.cos(q)),i.scaleAndAdd(z,z,r,L*Math.sin(q)),v.push(z);const M=c.create();return i.scaleAndAdd(M,h,t,L*Math.cos(T)),i.scaleAndAdd(M,M,r,L*Math.sin(T)),v.push(M),Le(l?P.pointsInsidePlane(l,v):v)}})();function Q(e,t){return P.isClose(e.z,t.z)?e:void 0}function X({z:e},{planeLike:t}){const[n,r]=t.start,[s,i]=t.end,c=p.fromValues(n,r,e),a=p.fromValues(s,i,e);return t.type===P.VerticalPlaneType.PLANE?new m(c,a):new _(c,a)}function $(e,t){const[n,r]=t.center;return new k(p.fromValues(n,r,e.z),t.radius)}function ee(e,t){return P.isClose(t.center[2],e.z)?t:void 0}const te=(()=>{const e=d.create();return(t,n)=>K(t.getPlane(e),n,n.slicePlane)})();function ne(e,{center:t,radius:n}){const r=Math.abs(t[2]-e.z);if(r>n&&!P.isClose(r,n))return;const s=p.fromValues(t[0],t[1],e.z),i=Math.sqrt(n**2-r**2);return P.isClose(i,0)?void 0:new k(s,i)}const re=(()=>{const e=d.create();return(t,{center:n,radius:r})=>{const s=P.intersectVerticalPlaneAndVerticalCylinder(t.planeLike,n,r),i=n[2];t.getSlicePlane(e);const c=new Array;for(const[a,o]of s){const t=[a,o,i];P.isPointInsidePlane(e,t)&&c.push(t)}return Le(c)}})(),se=(()=>{const e=d.create(),t=d.create();return(n,r)=>K(n.getPlane(e),r,n.getSlicePlane(t))})(),ie=(()=>{const e=d.create();return(t,{center:n,radius:r})=>{const s=t.getPlane(e),a=d.signedDistance(s,n),o=Math.abs(a);if(o>r&&!P.isClose(o,r))return;const l=Math.sqrt(r**2-a**2);if(P.isClose(l,0)){const e=p.createWritable();return d.projectPoint(s,n,e),new g(e)}const u=p.createWritable(),h=c.clone(d.getNormal(s));return i.scaleAndAdd(u,n,h,a),new x(u,l,h,t.getSlicePlane())}})();function ce(e,t){}function ae(e,t){const n=r.squaredDistance(p.asVec2(e.center),p.asVec2(t.center));if(P.isClose(n,0)&&P.isClose(e.radius,t.radius))return t;return Ce(P.intersectVerticalCylinders(p.asVec2(e.center),e.radius,p.asVec2(t.center),t.radius),t.center[2])}function oe(e,t){}function le(e,t){}function ue(e,t){}function de(e,t){if(!P.vectorsHaveCloseZ(e.center,t.center))return;const n=r.squaredDistance(p.asVec2(e.center),p.asVec2(t.center));if(P.isClose(n,0)&&P.isClose(e.radius,t.radius))return e;return Ce(P.intersectVerticalCylinders(p.asVec2(e.center),e.radius,p.asVec2(t.center),t.radius),e.center[2])}function he(e,t){}function fe(e,t){}function pe(e,t){const{planeLike:n,getZ:r}=e,s=new Array;if(me(t))e.addIfOnTheGround(s,P.intersectVerticalPlaneAndPoint(n,t.point));else if(_e(t))e.addIfOnTheGround(s,P.intersectVerticalPlaneAndLineLike(n,t.lineLike));else if(ke(t))for(const[i,a]of P.intersectVerticalPlaneAndVerticalCylinder(n,t.center,t.radius)){const e=r(i,a);null!=e&&s.push(c.fromValues(i,a,e))}else if(Ae(t)||ve(t))for(const[i,a]of P.intersectVerticalPlanes(n,t.planeLike)){const e=r(i,a)??be;s.push(c.fromValues(i,a,e))}return Le(s)}function Pe(e){return ge(e.map((([e,t])=>{const n=p.fromValues(e,t,0),r=p.fromValues(e,t,1);return new m(n,r)})))}function Le(e){return ge(e.map((e=>e?new g(p.fromVec3(e)):void 0)))}function Ce(e,t){return Le(e.map((([e,n])=>[e,n,t])))}function ge(e){if(0!==e.length)return 1===e.length?e[0]??void 0:new y(e.filter(t.isSome))}function Ve(e){return e instanceof y}function me(e){return e instanceof g}function _e(e){return e instanceof V}function ye(e){return e instanceof v}function Ae(e){return e instanceof M}function ke(e){return e instanceof A}function xe(e){return e instanceof k}function qe(e){return e instanceof x}function Te(e){return e instanceof R}function ve(e){return e instanceof N}function ze(e){return e instanceof W}function Me(e){return e instanceof G}const be=0;e.CircleConstraint=x,e.Constraint=C,e.CoordinateConstraint=G,e.DrapedLineConstraint=N,e.GeodesicConstraint=W,e.HorizontalCircleConstraint=k,e.HorizontalPlaneConstraint=v,e.LineConstraint=m,e.LineLikeConstraint=V,e.PointConstraint=g,e.RayConstraint=_,e.SetConstraint=y,e.SphereConstraint=R,e.VerticalCylinderConstraint=A,e.VerticalHalfPlaneConstraint=D,e.VerticalPlaneConstraint=I,e.VerticalPlaneLikeConstraint=M,e.constraintOrSet=ge,e.isPoint=me,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
