/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","exports","../../../chunks/tslib.es6","../../../core/Accessor","../../../core/arrayUtils","../../../core/handleUtils","../../../core/has","../../../core/promiseUtils","../../../core/reactiveUtils","../../../core/unitUtils","../../../core/accessorSupport/decorators/property","../../../core/Logger","../../../core/accessorSupport/decorators/subclass","../../../core/libs/gl-matrix-2/math/vec2","../../../chunks/vec32","../../../core/libs/gl-matrix-2/factories/vec3f64","../../../core/libs/gl-matrix-2/math/common","../../../core/support/UpdatingHandles","../../../support/elevationInfoUtils","../sketch/constraints","../sketch/normalizedPoint","./FeatureSnappingSourceInfo","./SnappingDomain","./snappingUtils","./candidates/DrapedEdgeSnappingCandidate","./candidates/EdgeSnappingCandidate","./candidates/FeatureSnappingCandidate","./candidates/RightAngleSnappingCandidate","../support/viewUtils"],(function(e,t,n,r,a,i,s,o,c,u,l,p,d,g,S,h,y,f,m,_,v,w,F,b,E,C,x,P,R){"use strict";function I(e){return(e instanceof C.EdgeSnappingCandidate||e instanceof E.DrapedEdgeSnappingCandidate)&&!M(e)}function M({constraint:{start:e,end:t}}){const n=S.squaredDistance(e,t),r=g.squaredDistance(v.asVec2(e),v.asVec2(t));return n<y.getEpsilon()||r/n<H}function A(e,t,n,r,a,i,{spatialReference:s}){const o=S.copy(V,t);o[0]+=n,o[1]+=r,o[2]+=a;const c=R.vectorToScreenPoint(o,s,m.absoluteHeightElevationInfo,i);return c?b.screenDistance(c,e):1/0}t.FeatureSnappingEngine=class extends r{get updating(){return this._snappingSources.some((e=>null==e?.valid||!0===e.valid&&!0===e.snappingSource?.updating))||this._updatingHandles.updating}constructor(e){super(e),this.options=null,this._domain=F.SnappingDomain.FEATURE,this._updatingHandles=new f.UpdatingHandles,this._sourceModules={featureService:{module:null,loader:null},featureCollection:{module:null,loader:null},graphics:{module:null,loader:null},notes:{module:null,loader:null},scene:{module:null,loader:null}}}initialize(){const e=c.mapCollectionAsync((()=>this.options?._effectiveFeatureSources),((e,t)=>this._createSourceInfo(e,t)));this._snappingSources=e,this.addHandles([i.destroyHandle(e),c.watch((()=>({rulesEnabled:!!this.options?.attributeRulesEnabled,sources:this._snappingSources.filter(a.isSome)})),(({rulesEnabled:e,sources:t})=>{for(const n of t)n.attributeRulesEnabled=e}),c.sync)])}destroy(){this._set("options",null),this._updatingHandles.destroy()}async fetchCandidates(e,t,n,r){if(!(t&this._domain&&null!=this.options&&this.options.effectiveFeatureEnabled))return[];const a=[],i=this._computeScreenSizeDistanceParameters(e,n);for(const o of this._snappingSources){if(!o?.valid||!o.snappingSource?.layerSource?.enabled||o.layerView?.suspended)continue;const t=o.getFetchCandidatesParameters(e,n,i);for(const e of t)a.push(o.snappingSource.fetchCandidates(e,r).then((e=>e.filter((e=>!this._candidateIsExcluded(o.snappingSource,e,n.excludeFeature))))))}const s=(await o.allSettledValues(a)).flat();return this._addRightAngleCandidates(s,e,i,n),o.throwIfAborted(r),b.sortCandidatesInPlace(e,s),s}_addRightAngleCandidates(e,t,n,r){const a=null!=r.vertexHandle?r.vertexHandle.rightEdge?.rightVertex?.pos:null!=r.editGeometryOperations&&"polygon"===r.editGeometryOperations.data.type?r.editGeometryOperations.data.components[0]?.getFirstVertex()?.pos:null,i=null!=r.vertexHandle?r.vertexHandle.leftEdge?.leftVertex?.pos:null!=r.editGeometryOperations?r.editGeometryOperations.data.components[0]?.getLastVertex()?.pos:null,{view:s}=this,o=v.fromAnyMapPoint(a,s,r),c=v.fromAnyMapPoint(i,s,r),u=e.length;for(let l=0;l<u;l++)this._addRightAngleCandidate(e[l],c,t,n,e),this._addRightAngleCandidate(e[l],o,t,n,e)}_addRightAngleCandidate(e,t,n,r,a){if(null==t||!I(e))return;const i=e.constraint.closestTo(t),s=(i[0]-n[0])/r.x,o=(i[1]-n[1])/r.y,{start:c,end:u}=e.constraint;if(s*s+o*o<=1){const n=g.squaredDistance(v.asVec2(i),v.asVec2(c))>g.squaredDistance(v.asVec2(i),v.asVec2(u))?c:u,r=new P.RightAngleSnappingCandidate({targetPoint:v.markAsTarget(i),otherVertex:t,otherVertexType:P.OtherVertexType.NEXT,previousVertex:n,constraint:new _.VerticalHalfPlaneConstraint(t,i),objectId:e.objectId,isDraped:e.isDraped,domain:F.SnappingDomain.FEATURE});a.push(r)}}_computeScreenSizeDistanceParameters(e,t){let n=null!=this.options?this.options.distance*("touch"===t.pointer?this.options.touchSensitivityMultiplier:1):0;return null==this.view?{x:n,y:n,z:n,distance:n}:"2d"===this.view.type?(n*=this.view.resolution,{x:n,y:n,z:n,distance:n}):this._computeScreenSizeDistanceParameters3D(e,n,this.view,t)}_computeScreenSizeDistanceParameters3D(e,t,n,r){const{spatialReference:a}=r;n.renderCoordsHelper.toRenderCoords(e,a,D);const i=n.state.camera.computeScreenPixelSizeAt(D),s=i*n.renderCoordsHelper.unitInMeters,o=s/u.getMetersPerUnitForSR(a),c=s/u.getMetersPerVerticalUnitForSR(a),l=t*o,p=t*c,d=R.vectorToScreenPoint(e,a,m.absoluteHeightElevationInfo,n),g=d?A(d,e,o,0,0,n,r):0,S=d?A(d,e,0,o,0,n,r):0,h=d?A(d,e,0,0,c,n,r):0;return{x:0===g?0:l/g,y:0===S?0:l/S,z:0===h?0:p/h,distance:i*t}}_candidateIsExcluded(e,t,n){if(null==n)return!1;const r=this._getCandidateObjectId(t);if(null==r)return!1;const a=e.layerSource.layer;return"graphics"===a.type?n.uid===r:n.sourceLayer===a&&(!(!n.attributes||!("objectIdField"in a))&&n.attributes[a.objectIdField]===r)}_getCandidateObjectId(e){return e instanceof x.FeatureSnappingCandidate?e.objectId:null}async _createSourceInfo(e,t){const n=e.layer;n.loaded||(await n.load(),o.throwIfAborted(t));const{view:r}=this,a=await this._createFeatureSnappingSourceType(e);return o.throwIfAborted(t),null==a?new w.FeatureSnappingSourceInfo({}):new w.FeatureSnappingSourceInfo({snappingSource:a,view:r,layer:n})}async _createFeatureSnappingSourceType(e){switch(e.layer.type){case"feature":case"geojson":case"csv":case"oriented-imagery":case"subtype-group":case"wfs":return this._createFeatureSnappingSourceFeatureLayer(e);case"graphics":return this._createFeatureSnappingSourceGraphicsLayer(e);case"map-notes":return this._createFeatureSnappingSourceMapNotesLayer(e);case"scene":case"building-scene":return this._createFeatureSnappingSourceSceneLayer(e)}return null}async _createFeatureSnappingSourceSceneLayer(e){const{view:t}=this;if(null==t||"3d"!==t.type)return null;return new((await this._getSourceModule("scene")).SceneLayerSnappingSource)({layerSource:e,view:t})}async _createFeatureSnappingSourceFeatureLayer(e){switch(e.layer.source?.type){case"feature-layer":case"oriented-imagery":return new((await this._getSourceModule("featureService")).FeatureServiceSnappingSource)({spatialReference:this.spatialReference,view:this.view,layerSource:e});case"memory":case"csv":case"geojson":case"wfs":if("mesh"===e.layer.geometryType)return null;return new((await this._getSourceModule("featureCollection")).FeatureCollectionSnappingSource)({layerSource:e,view:this.view})}return null}async _createFeatureSnappingSourceGraphicsLayer(e){return new((await this._getSourceModule("graphics")).GraphicsSnappingSource)({getGraphicsLayers:()=>[e.layer],spatialReference:this.spatialReference,view:this.view,layerSource:e})}async _createFeatureSnappingSourceMapNotesLayer(e){return new((await this._getSourceModule("notes")).GraphicsSnappingSource)({getGraphicsLayers:()=>e.layer.sublayers?.toArray()??[],spatialReference:this.spatialReference,view:this.view,layerSource:e})}async _getSourceModule(e){const t=this._sourceModules[e];if(null==t.loader){const t=this._loadSourceModule(e),n={module:null,loader:t};this._sourceModules[e]=n;const r=await t,a={module:r,loader:t};return this._sourceModules[e]=a,r}return null==t.module?t.loader:t.module}_loadSourceModule(t){const n=this._updatingHandles;switch(t){case"featureService":return n.addPromise(new Promise(((t,n)=>e(["./featureSources/FeatureServiceSnappingSource"],t,n))));case"featureCollection":return n.addPromise(new Promise(((t,n)=>e(["./featureSources/FeatureCollectionSnappingSource"],t,n))));case"graphics":case"notes":return n.addPromise(new Promise(((t,n)=>e(["./featureSources/GraphicsSnappingSource"],t,n))));case"scene":return n.addPromise(new Promise(((t,n)=>e(["./featureSources/SceneLayerSnappingSource"],t,n))))}}get test(){}},n.__decorate([l.property({constructOnly:!0})],t.FeatureSnappingEngine.prototype,"spatialReference",void 0),n.__decorate([l.property({constructOnly:!0})],t.FeatureSnappingEngine.prototype,"view",void 0),n.__decorate([l.property()],t.FeatureSnappingEngine.prototype,"options",void 0),n.__decorate([l.property({readOnly:!0})],t.FeatureSnappingEngine.prototype,"updating",null),n.__decorate([l.property()],t.FeatureSnappingEngine.prototype,"_snappingSources",void 0),t.FeatureSnappingEngine=n.__decorate([d.subclass("esri.views.interactive.snapping.FeatureSnappingEngine")],t.FeatureSnappingEngine);const D=h.create(),V=h.create(),H=1e-4;Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
