/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../chunks/tslib.es6","../../../core/Accessor","../../../core/has","../../../core/Logger","../../../core/reactiveUtils","../../../core/sql","../../../core/accessorSupport/decorators/property","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../../layers/support/FeatureFilter","../../../layers/support/floorFilterUtils","../../../layers/support/layerUtils","./snappingUtils","../../support/layerViewUtils"],(function(e,r,t,i,a,l,n,o,s,u,p,c,d,y,f){"use strict";function g(){return{returnEdge:!0,vertexMode:"all"}}function h(e,r){return null==e?new p({where:r}):e.where?new p({where:n.sqlAnd(e.where,r)}):new p({where:r})}e.FeatureSnappingSourceInfo=class extends t{set attributeRulesEnabled(e){this._set("attributeRulesEnabled",e),e&&this.loadRules()}get layerView(){return this.view?.allLayerViews?.find((e=>e.layer===this.layer))}get valid(){const{_valid:e,snappingSource:r,layer:t}=this;return!(!r||!t)&&e}get subtypeFilter(){const{layer:e,snappingSource:r}=this;if(!d.isSubtypeGroupLayer(e)||!e.subtypes?.length||!r)return{mode:"not-in-use",filter:null};const t=r.layerSource.sublayerSources.filter((e=>e.enabled&&e.layer.visible&&f.scaleBoundsPredicate(this.view?.scale,e.layer.effectiveScaleRange.minScale,e.layer.effectiveScaleRange.maxScale))).map((e=>e.layer.subtypeCode));if(!t.length)return{mode:"none-visible",filter:null};if(t.length===e.subtypes.length)return{mode:"all-visible",filter:null};const i=e.fieldsIndex.get(e.subtypeField)?.name??e.subtypeField;return 1===t.length?{mode:"in-use",filter:`${i} = ${t.getItemAt(0)}`}:{mode:"in-use",filter:`${i} IN (${t.join(", ")})`}}get floorFilter(){const{view:e,layer:r}=this;return e&&r?c.getFloorFilterClause({view:e,layer:r}):null}constructor(e){super(e),this.layer=null,this.snappingSource=null,this.rulesTable=null,this._valid=null}initialize(){if(!this.snappingSource||!this.layer)return void(this._valid=!1);const{layer:e,snappingSource:r}=this;if("refresh"in e){const t=e;this.addHandles(t.on("refresh",(()=>r.refresh())))}this.loadRules(),this.addHandles([l.watch((()=>r.updating),(e=>r.layerSource.updating=e),l.syncAndInitial),l.watch((()=>r.availability),(e=>r.layerSource.availability=e),l.syncAndInitial)])}getFetchCandidatesParameters(e,r,t){if(!this.valid)return[];const{layer:a,layerView:l,floorFilter:o,rulesTable:s,subtypeFilter:u}=this,c={distance:t,mode:this.view?.type??"2d",point:e,coordinateHelper:r.coordinateHelper,...g(),filter:l&&"filter"in l?l.filter:null};if(o&&(c.filter=h(c.filter,o)),"not-in-use"!==u.mode&&"all-visible"!==u.mode){if("none-visible"===u.mode)return[];c.filter?c.filter.where=n.sqlAnd(c.filter.where,u.mode):c.filter=new p({where:u.filter})}if(!this.attributeRulesEnabled)return[c];const f=r.feature,S="subtype-sublayer"===f?.sourceLayer?.type?f.sourceLayer.parent:f?.sourceLayer;if(s&&f&&y.isUtilityNetworkWebMap(this.view?.map)&&(d.isFeatureLayer(a)||d.isSubtypeGroupLayer(a))&&a.layerId&&(d.isFeatureLayer(S)||d.isSubtypeGroupLayer(S))&&this.view.map.utilityNetworks?.find((e=>e.isUtilityLayer(S)))){if("loaded"!==s.loadStatus)return[];const e=[],r=a.layerId,t=s.getFeatureSQL(S,f)?.[r];if(!t)return[];const l=t.anyVertex;let n=t.endVertex;return n&&l&&n===l&&(n=""),n&&e.push({...c,returnEdge:!1,vertexMode:"ends",filter:h(c.filter,n)}),l&&e.push({...c,returnEdge:i("snapping-include-edges-when-applying-any-vertex-rule")??!1,vertexMode:"all",filter:h(c.filter,l)}),e}return[c]}async loadRules(){this._valid=null;const{layer:e,view:r,attributeRulesEnabled:t}=this;if(t&&e&&r&&y.isUtilityNetworkWebMap(r?.map)&&(d.isFeatureLayer(e)||d.isSubtypeGroupLayer(e)))try{await Promise.allSettled(r.map.utilityNetworks?.map((e=>e.load()))??[]);const t=r.map.utilityNetworks?.find((r=>r.isUtilityLayer(e)));t&&(this.rulesTable=await t.getRulesTable(),await(this.rulesTable?.load()))}catch(i){return this._valid=!1,void a.getLogger("esri.views.interactive.snapping.FeatureSnappingSourceInfo").error("Failed to load rules table for snapping source",e.title)}this._valid=!0}remove(){this.destroy()}destroy(){this.snappingSource?.destroy()}},r.__decorate([o.property({constructOnly:!0})],e.FeatureSnappingSourceInfo.prototype,"layer",void 0),r.__decorate([o.property({constructOnly:!0})],e.FeatureSnappingSourceInfo.prototype,"snappingSource",void 0),r.__decorate([o.property({constructOnly:!0})],e.FeatureSnappingSourceInfo.prototype,"view",void 0),r.__decorate([o.property({value:!1})],e.FeatureSnappingSourceInfo.prototype,"attributeRulesEnabled",null),r.__decorate([o.property()],e.FeatureSnappingSourceInfo.prototype,"layerView",null),r.__decorate([o.property()],e.FeatureSnappingSourceInfo.prototype,"rulesTable",void 0),r.__decorate([o.property()],e.FeatureSnappingSourceInfo.prototype,"valid",null),r.__decorate([o.property()],e.FeatureSnappingSourceInfo.prototype,"subtypeFilter",null),r.__decorate([o.property()],e.FeatureSnappingSourceInfo.prototype,"floorFilter",null),r.__decorate([o.property()],e.FeatureSnappingSourceInfo.prototype,"_valid",void 0),e.FeatureSnappingSourceInfo=r.__decorate([u.subclass("esri.views.interactive.snapping.FeatureSnappingSourceInfo")],e.FeatureSnappingSourceInfo),Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
