/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","exports","../../../chunks/tslib.es6","../../../core/Accessor","../../../core/asyncUtils","../../../core/Evented","../../../core/has","../../../core/promiseUtils","../../../core/reactiveUtils","../../../core/accessorSupport/decorators/property","../../../core/Logger","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../../geometry/projection","../../../support/elevationInfoUtils","../sketch/normalizedPoint","./Settings","./SnappingDomain","./SnappingOptions","./snappingUtils","./candidates/DrapedEdgeSnappingCandidate","./candidates/EdgeSnappingCandidate","./candidates/IntersectionSnappingCandidate","./candidates/LineSnappingCandidate","./candidates/ParallelLineSnappingCandidate","./candidates/RightAngleSnappingCandidate","./candidates/RightAngleTriangleSnappingCandidate","../support/viewUtils"],(function(e,n,t,i,a,s,r,o,p,d,c,h,l,u,g,f,S,_,v,y,C,w,E,P,m,T,M,A){"use strict";var I;n.SnappingManager=class extends(s.EventedMixin(i)){constructor(e){super(e),this.options=new v,this._engineCache=new Map,this._loadTask=null,this._engines=[],this._currentMainCandidate=null,this._currentOtherActiveCandidates=[],this._currentSnappedType=I.MAIN}initialize(){this.addHandles([p.watch((()=>{const{distance:e,touchSensitivityMultiplier:n,effectiveSelfEnabled:t,effectiveFeatureEnabled:i,effectiveGridEnabled:a}=this.options;return{selfEnabled:t,featureEnabled:i,gridEnabled:"2d"===this.view.type&&a,viewReady:this.view.ready,viewSpatialReference:this.view.spatialReference,distance:e,touchSensitivityMultiplier:n}}),((e,n)=>{n&&(this.doneSnapping(),this.emit("changed")),this._loadTask?.abort(),this._loadTask=a.createTask((t=>this._updateEngines(e,n,t)))}),p.syncAndInitial),p.watch((()=>this.options),(e=>{for(const n of this._engines)n.options=e}),p.sync)])}destroy(){this._destroyEngines()}get updating(){return this._engines.some((e=>e.updating))||!this._loadTask?.finished}_destroyEngines(){this._engineCache.forEach((e=>e.destroy())),this._engineCache.clear(),this._engines=[]}async _updateEngines(e,n,t){if(!e.viewReady)return void this._destroyEngines();n?.viewSpatialReference!==e.viewSpatialReference&&this._destroyEngines();const{_engineCache:i}=this,a=[];e.featureEnabled&&!i.has("feature")&&a.push(this._setupFeatureSnappingEngine(t)),e.selfEnabled&&!i.has("self")&&a.push(this._setupSelfSnappingEngine(t)),e.gridEnabled&&!i.has("grid")&&"2d"===this.view.type&&a.push(this._setupGridSnappingEngine(t)),await Promise.allSettled(a),t.aborted||(this._engines=Array.from(i.values()))}async _setupSelfSnappingEngine(n){const{SelfSnappingEngine:t}=await new Promise(((n,t)=>e(["./SelfSnappingEngine"],n,t)));o.throwIfAborted(n);const i=new t({view:this.view,options:this.options});this._engineCache.set("self",i)}async _setupGridSnappingEngine(n){const{view:t}=this,{GridSnappingEngine:i}=await new Promise(((n,t)=>e(["./GridSnappingEngine"],n,t)));if(o.throwIfAborted(n),"2d"===t.type){const e=new i({view:t,options:this.options});this._engineCache.set("grid",e)}}async _setupFeatureSnappingEngine(n){const{FeatureSnappingEngine:t}=await new Promise(((n,t)=>e(["./FeatureSnappingEngine"],n,t)));o.throwIfAborted(n);const{view:i,options:a,_engineCache:s}=this,r=new t({view:i,options:a,spatialReference:i.spatialReference});s.set("feature",r)}get _squaredMouseProximityThreshold(){return this.options.distance*this.options.distance}get _squaredTouchProximityThreshold(){const{distance:e,touchSensitivityMultiplier:n}=this.options,t=e*n;return t*t}snap(e){return z(e)?this._snapMultiPoint(e):this._snapSinglePoint(e)}update(e){const{point:n,context:t}=e;this._removeVisualization();const i=this._currentMainCandidate;if(null==i)return n;const a=this._selectUpdateInput(e);if(null==a)return n;const{spatialReference:s}=t,r=u.project(a,s);if(null==r)return n;const{view:o}=this,{elevationInfo:p,visualizer:d}=t,c=[],h=f.fromPoint(r,o,p),l=i.constraint.closestTo(h);if(!this._arePointsWithinScreenThreshold(h,l,t)||!q(i,t.drawConstraints))return this._resetSnappingState(),n;i.targetPoint=f.markAsTarget(l),c.push(...i.hints);for(const u of this._currentOtherActiveCandidates)q(u,t.drawConstraints)&&(u.targetPoint=f.markAsTarget(l),c.push(...u.hints));return null!=d&&this.addHandles(d.draw(c,{spatialReference:s,elevationInfo:k(t),view:o,selfSnappingZ:t.selfSnappingZ}),R),f.toElevationAlignedDehydratedPoint(l,o,n,t)}doneSnapping(){this._removeVisualization(),this._resetSnappingState()}_selectUpdateInput({point:e,scenePoint:n}){switch(this._currentSnappedType){case I.MAIN:return e;case I.SCENE:return n}}_resetSnappingState(){this._currentMainCandidate=null,this._currentOtherActiveCandidates=[],this._currentSnappedType=I.MAIN}_removeVisualization(){this.removeHandles(R)}async _snapSinglePoint({point:e,context:n,signal:t}){const{view:i}=this,{elevationInfo:a}=n,s=f.fromPoint(e,i,a),r=await this._fetchCandidates(s,_.SnappingDomain.ALL,n,t);return this._createSnapResult(s,I.MAIN,r,i,e,n,t)}async _snapMultiPoint({point:e,scenePoint:n,context:t,signal:i}){const{view:a}=this,{coordinateHelper:s,elevationInfo:r,spatialReference:o}=t;await u.initializeProjection(n.spatialReference,o);const p=u.project(n,o),d=f.fromPoint(p,a,r),c=await this._fetchCandidates(d,_.SnappingDomain.FEATURE,t,i);if(c.length>0){const e=await this._fetchCandidates(d,_.SnappingDomain.SELF,t,i);return this._createSnapResult(d,I.SCENE,[...c,...e],a,p,t,i)}const h=f.fromPoint(e,a,r),l=await this._fetchCandidates(h,_.SnappingDomain.SELF,t,i);return this._createSnapResult(h,I.MAIN,l,a,{z:s.hasZ()&&e.hasZ?e.z??0:void 0,m:s.hasM()&&e.hasM?e.m??0:void 0},t,i)}async _fetchCandidates(e,n,t,i){return(await Promise.all(this._engines.map((a=>a.fetchCandidates(e,n,t,i))))).flat()}_createSnapResult(e,n,t,i,a,s,r){return{get valid(){return!o.isAborted(r)},apply:()=>{const{spatialReference:r}=s,{snappedPoint:o,hints:p}=this._processCandidates(e,n,t,s);return this._removeVisualization(),null!=s.visualizer&&this.addHandles(s.visualizer.draw(p,{spatialReference:r,elevationInfo:g.absoluteHeightElevationInfo,view:i,selfSnappingZ:s.selfSnappingZ}),R),f.toElevationAlignedDehydratedPoint(o,i,a,s)}}}_processCandidates(e,n,t,i){if(t.length<1)return this.doneSnapping(),{snappedPoint:e,hints:[]};this._currentSnappedType!==n&&this._resetSnappingState(),y.sortCandidatesInPlace(e,t);const a=this._currentMainCandidate;if(null!=a){const s=x(a,t);if(s>=0){if(!(t[s]instanceof E.IntersectionSnappingCandidate))return this._intersectWithOtherCandidates(s,t,e,n,i);if(this._arePointsWithinScreenThreshold(e,a.targetPoint,i))return this._updateSnappingCandidate(a,n,t,i)}}return this._intersectWithOtherCandidates(0,t,e,n,i)}_intersectWithOtherCandidates(e,n,t,i,a){const{coordinateHelper:s}=a,r=n[e],o=[];for(let p=0;p<n.length;++p){if(p===e)continue;const i=n[p],a=r.constraint.intersect(i.constraint);if(a)for(const e of a.closestPoints(r.targetPoint))o.push([new E.IntersectionSnappingCandidate(f.markAsTarget(e),r,i,i.isDraped),this._squaredScreenDistance(t,e,s)])}return o.length>0&&(o.sort(((e,n)=>e[1]-n[1])),o[0][1]<this._squaredPointProximityThreshold(a.pointer))?this._updateSnappingCandidate(o[0][0],i,n,a):q(r,a.drawConstraints)?this._updateSnappingCandidate(r,i,n,a):{snappedPoint:t,hints:[]}}_updateSnappingCandidate(e,n,t,i){this.doneSnapping(),this._currentMainCandidate=e,this._currentSnappedType=n;const a=this._currentMainCandidate.targetPoint,s=[];s.push(...e.hints);for(const r of t){if(e instanceof E.IntersectionSnappingCandidate){if(r.constraint.equals(e.first.constraint)||r.constraint.equals(e.second.constraint))continue}else if(r.constraint.equals(e.constraint))continue;const n=r.constraint.closestTo(a);this._squaredScreenDistance(n,a,i.coordinateHelper)<b()&&(r.targetPoint=a,this._currentOtherActiveCandidates.push(r),s.push(...r.hints))}return{snappedPoint:a,hints:s}}_squaredPointProximityThreshold(e){return"touch"===e?this._squaredTouchProximityThreshold:this._squaredMouseProximityThreshold}_arePointsWithinScreenThreshold(e,n,t){return this._squaredScreenDistance(e,n,t.coordinateHelper)<this._squaredPointProximityThreshold(t.pointer)}_squaredScreenDistance(e,n,t){return y.squaredScreenDistance(this._toScreen(e,t),this._toScreen(n,t))}_toScreen(e,n){return A.vectorToScreenPoint(e,n.spatialReference,g.absoluteHeightElevationInfo,this.view)}get test(){}},t.__decorate([d.property({constructOnly:!0})],n.SnappingManager.prototype,"view",void 0),t.__decorate([d.property()],n.SnappingManager.prototype,"options",void 0),t.__decorate([d.property({readOnly:!0})],n.SnappingManager.prototype,"updating",null),t.__decorate([d.property()],n.SnappingManager.prototype,"_loadTask",void 0),t.__decorate([d.property()],n.SnappingManager.prototype,"_engines",void 0),t.__decorate([d.property()],n.SnappingManager.prototype,"_squaredMouseProximityThreshold",null),t.__decorate([d.property()],n.SnappingManager.prototype,"_squaredTouchProximityThreshold",null),n.SnappingManager=t.__decorate([l.subclass("esri.views.interactive.snapping.SnappingManager")],n.SnappingManager),function(e){e[e.MAIN=0]="MAIN",e[e.SCENE=1]="SCENE"}(I||(I={}));const R="visualization-handle";function b(){return S.defaults.satisfiesConstraintScreenThreshold*S.defaults.satisfiesConstraintScreenThreshold}function q(e,n){return!n||null==n.direction&&null==n.distance||!(e instanceof C.DrapedEdgeSnappingCandidate||e instanceof w.EdgeSnappingCandidate||e instanceof P.LineSnappingCandidate||e instanceof m.ParallelLineSnappingCandidate||e instanceof M.RightAngleTriangleSnappingCandidate)&&(!(e instanceof T.RightAngleSnappingCandidate)||null==n.direction&&e.selfSnappingType===T.SelfSnappingRightAngleType.LastVertex)}function x(e,n){return e instanceof E.IntersectionSnappingCandidate?D(n,e.first)>=0&&D(n,e.second)>=0?0:-1:D(n,e)}function D(e,n){let t=-1;for(let i=0;i<e.length;++i)if(n.constraint.equals(e[i].constraint)){t=i;break}return t}function z(e){return null!=e.scenePoint}function k({coordinateHelper:e,elevationInfo:n}){return e.hasZ()?g.absoluteHeightElevationInfo:n}Object.defineProperty(n,Symbol.toStringTag,{value:"Module"})}));
