/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../../../chunks/tslib.es6","../../../../../geometry","../../../../../core/Evented","../../../../../core/promiseUtils","../../../../../core/reactiveUtils","../../../../../core/accessorSupport/decorators/property","../../../../../core/has","../../../../../core/Logger","../../../../../core/RandomLCG","../../../../../core/accessorSupport/decorators/subclass","../../../../../core/support/UpdatingHandles","../../../../../geometry/SpatialReference","../../../../../layers/graphics/data/FeatureStore","../../../../../layers/graphics/data/QueryEngine","../../../../../layers/support/TileInfo","../../../../../rest/support/Query","../../../../../symbols/support/ElevationInfo","../snappingCandidateElevationAlignment","../snappingCandidateElevationFilter","../symbologySnappingCandidates","./FeatureServiceTiledFetcher","./FeatureServiceTileStore","../../../../../geometry/support/jsonUtils"],(function(e,t,i,r,a,n,s,o,l,d,u,h,c,p,g,f,y,_,m,S,w,I,F){"use strict";let v=class extends i.EventedAccessor{constructor(){super(...arguments),this._isInitializing=!0,this.remoteClient=null,this._whenSetup=r.createResolver(),this._elevationAligner=_.getSnappingCandidateElevationAligner(),this._elevationFilter=m.getSnappingCandidateElevationFilter(),this._symbologyCandidatesFetcher=S.getSymbologySnappingCandidatesFetcher(),this._updatingHandles=new u.UpdatingHandles,this._alignPointsInFeatures=async(e,t)=>{const i={query:e},a=await this.remoteClient.invoke("alignElevation",i,{signal:t});return r.throwIfAborted(t),a},this._getSymbologyCandidates=async(e,t)=>{const i={candidates:e,spatialReference:this._spatialReference.toJSON()},a=await this.remoteClient.invoke("getSymbologyCandidates",i,{signal:t});return r.throwIfAborted(t),a}}get updating(){return this._isInitializing||this._updatingHandles.updating||this._featureFetcher.updating}destroy(){this._featureFetcher?.destroy(),this._queryEngine?.destroy(),this._featureStore?.clear()}async setup(e){if(this.destroyed)return{result:{}};const{geometryType:t,objectIdField:i,timeInfo:r,fieldsIndex:n}=e.serviceInfo,{hasZ:s}=e,o=h.fromJSON(e.spatialReference);this._spatialReference=o,this._featureStore=new c({...e.serviceInfo,hasZ:s,hasM:!1}),this._queryEngine=new p.QueryEngine({spatialReference:e.spatialReference,featureStore:this._featureStore,geometryType:t,fieldsIndex:n,hasZ:s,hasM:!1,objectIdField:i,timeInfo:r}),this._featureFetcher=new w.FeatureServiceTiledFetcher({store:new I.FeatureServiceTileStore({featureStore:this._featureStore}),url:e.serviceInfo.url,objectIdField:e.serviceInfo.objectIdField,globalIdField:e.serviceInfo.globalIdField,capabilities:e.serviceInfo.capabilities,spatialReference:o,sourceSpatialReference:h.fromJSON(e.serviceInfo.spatialReference),customParameters:e.configuration.customParameters});const l="3d"===e.configuration.viewType;return this._elevationAligner=_.getSnappingCandidateElevationAligner(l,{elevationInfo:null!=e.elevationInfo?y.fromJSON(e.elevationInfo):null,alignPointsInFeatures:this._alignPointsInFeatures}),this._elevationFilter=m.getSnappingCandidateElevationFilter(l),this.addHandles([a.watch((()=>this._featureFetcher.availability),(e=>this.emit("notify-availability",{availability:e})),a.sync),a.watch((()=>this.updating),(()=>this._notifyUpdating()))]),this._whenSetup.resolve(),this._isInitializing=!1,this.configure(e.configuration)}async configure(e){return await this._updatingHandles.addPromise(this._whenSetup.promise),this._updateFeatureFetcherConfiguration(e),C}async setSuspended(e,t){return await this._updatingHandles.addPromise(this._whenSetup.promise),r.throwIfAborted(t),this._featureFetcher.suspended=e,C}async updateOutFields(e,t){return await this._updatingHandles.addPromise(this._whenSetup.promise),r.throwIfAborted(t),this._featureFetcher.outFields=new Set(e??[]),C}async fetchCandidates(e,t){await this._whenSetup.promise,r.throwIfAborted(t);const i=b(e),a=t?.signal,n=await this._queryEngine.executeQueryForSnapping(i,a);r.throwIfAborted(a);const s=await this._elevationAligner.alignCandidates(n.candidates,h.fromJSON(e.point.spatialReference)??h.WGS84,a);r.throwIfAborted(a);const o=await this._symbologyCandidatesFetcher.fetch(s,a);r.throwIfAborted(a);const l=0===o.length?s:s.concat(o);return{result:{candidates:this._elevationFilter.filter(i,l)}}}async updateTiles(e,t){return await this._updatingHandles.addPromise(this._whenSetup.promise),r.throwIfAborted(t),this._featureFetcher.tileSize=e.tileSize,this._featureFetcher.tilesOfInterest=e.tiles,this._featureFetcher.tileInfo=null!=e.tileInfo?g.fromJSON(e.tileInfo):null,C}async refresh(e,t){return await this._updatingHandles.addPromise(this._whenSetup.promise),r.throwIfAborted(t),this._featureFetcher.refresh(),C}async whenNotUpdating(e,t){return await this._updatingHandles.addPromise(this._whenSetup.promise),r.throwIfAborted(t),await a.whenOnce((()=>!this.updating),t),r.throwIfAborted(t),C}async getDebugInfo(e,t){return r.throwIfAborted(t),{result:this._featureFetcher.debugInfo}}async handleEdits(e,t){return await this._updatingHandles.addPromise(this._whenSetup.promise),r.throwIfAborted(t),await this._updatingHandles.addPromise(this._featureFetcher.handleEdits(e)),r.throwIfAborted(t),C}async setHistoricMoment(e,t){return this._featureFetcher.setHistoricMoment(e.moment),C}async notifyElevationSourceChange(e,t){return this._elevationAligner.notifyElevationSourceChange(),C}async notifySymbologyChange(e,t){return this._symbologyCandidatesFetcher.notifySymbologyChange(),C}async setSymbologySnappingSupported(e){return this._symbologyCandidatesFetcher=S.getSymbologySnappingCandidatesFetcher(e,this._getSymbologyCandidates),C}_updateFeatureFetcherConfiguration(e){this._featureFetcher.filter=null!=e.filter?f.fromJSON(e.filter):null,this._featureFetcher.customParameters=e.customParameters}_notifyUpdating(){this.emit("notify-updating",{updating:this.updating})}};e.__decorate([n.property({readOnly:!0})],v.prototype,"updating",null),e.__decorate([n.property()],v.prototype,"_isInitializing",void 0),v=e.__decorate([d.subclass("esri.views.interactive.snapping.featureSources.featureServiceSource.FeatureServiceSnappingSourceWorker")],v);function b(e){if(!e.filter)return{...e,query:{where:"1=1"}};const{distance:t,units:i,spatialRel:r,where:a,timeExtent:n,objectIds:s}=e.filter,o={geometry:e.filter.geometry?F.fromJSON(e.filter.geometry):void 0,distance:t,units:i,spatialRel:r,timeExtent:n,objectIds:s,where:a??"1=1"};return{...e,query:o}}const C={result:{}};return v}));
