/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../../chunks/tslib.es6","../../../../../core/Accessor","../../../../../core/arrayUtils","../../../../../core/asyncUtils","../../../../../core/Logger","../../../../../core/promiseUtils","../../../../../core/reactiveUtils","../../../../../core/SetUtils","../../../../../core/uuid","../../../../../core/accessorSupport/decorators/property","../../../../../core/has","../../../../../core/accessorSupport/decorators/subclass","../../../../../core/support/UpdatingHandles","../../../../../geometry/Extent","../../../../../geometry/support/aaBoundingRect","../../../../../layers/graphics/featureConversionUtils","../../../../../layers/support/arcgisLayerUrl","../../../../../rest/query/operations/pbfOptimizedFeatureSet","../../../../../rest/query/operations/query","../../../../../rest/support/Query","./PendingFeatureTile"],(function(e,t,i,r,s,o,n,a,l,u,c,d,h,p,_,y,f,g,F,m,T,v){"use strict";e.FeatureServiceTiledFetcher=class extends i{get _minimumVerticesPerFeature(){switch(this.store?.featureStore.geometryType){case"esriGeometryPoint":case"esriGeometryMultipoint":return 1;case"esriGeometryPolygon":return 4;case"esriGeometryPolyline":return 2}}get _mandatoryOutFields(){const e=new Set;return this.objectIdField&&e.add(this.objectIdField),this.globalIdField&&e.add(this.globalIdField),e}set outFields(e){const t=this._get("outFields"),i=l.union(e,this._mandatoryOutFields);l.equals(i,t)||(this._set("outFields",i),l.isSubsetOf(i,t)||this.refresh())}get outFields(){return this._get("outFields")??this._mandatoryOutFields}set filter(e){const t=this._get("filter"),i=this._filterProperties(e);JSON.stringify(t)!==JSON.stringify(i)&&this._set("filter",i)}set customParameters(e){const t=this._get("customParameters");JSON.stringify(t)!==JSON.stringify(e)&&this._set("customParameters",e)}get _configuration(){return{filter:this.filter,customParameters:this.customParameters,tileInfo:this.tileInfo,tileSize:this.tileSize}}set tileInfo(e){const t=this._get("tileInfo");t!==e&&(null!=e&&null!=t&&JSON.stringify(e)===JSON.stringify(t)||(this._set("tileInfo",e),this.store.tileInfo=e))}set tileSize(e){this._get("tileSize")!==e&&this._set("tileSize",e)}get updating(){return this._updatingHandles.updating}get hasZ(){return this.store.featureStore.hasZ}constructor(e){super(e),this.suspended=!0,this._historicMoment=null,this.tilesOfInterest=[],this.availability=0,this._pendingTiles=new Map,this._updatingHandles=new p.UpdatingHandles}initialize(){this._initializeFetchExtent(),this._updatingHandles.add((()=>this._configuration),(()=>this.refresh())),this._updatingHandles.add((()=>this.tilesOfInterest),((e,t)=>{r.equals(e,t,(({id:e},{id:t})=>e===t))||this._process()}),a.sync),this.addHandles(a.when((()=>!this.suspended),(()=>this._process())))}destroy(){this._pendingTiles.forEach((e=>this._deletePendingTile(e))),this._pendingTiles.clear(),this.store.destroy(),this.tilesOfInterest.length=0,this._updatingHandles.destroy()}refresh(){this.store.refresh(),this._pendingTiles.forEach((e=>this._deletePendingTile(e))),this._process()}async handleEdits(e){if(e.historicMoment&&(this._historicMoment=e.historicMoment),!e.addedFeatures.length&&!e.updatedFeatures.length&&!e.deletedFeatures.length)return;for(const r of this._pendingTiles.values())r.reset();const t={...e,deletedFeatures:e.deletedFeatures.map((({objectId:e,globalId:t})=>e&&-1!==e?e:this._lookupObjectIdByGlobalId(t)))},i=s.createTask((async e=>{try{await this.store.processEdits(t,((e,t)=>this._queryFeaturesById(e,t)),e),this._processPendingTiles()}catch(i){n.throwIfAbortError(i),o.getLogger(this).warn("Failed to apply edits",i)}}));this.addHandles(i),await this._updatingHandles.addPromise(i.promise)}setHistoricMoment(e){e?.getTime()!==this._historicMoment?.getTime()&&(this._historicMoment=e,this.refresh())}_initializeFetchExtent(){if(!this.capabilities.query.supportsExtent||!g.isHostedAgolService(this.url))return;const e=s.createTask((async e=>{try{const t=await m.executeQueryForExtent(this.url,new T({where:"1=1",outSpatialReference:this.spatialReference,cacheHint:this.capabilities.query.supportsCacheHint??void 0}),{query:this._configuration.customParameters,signal:e});this.store.extent=_.fromJSON(t.data?.extent)}catch(t){n.throwIfAbortError(t),o.getLogger(this).warn("Failed to fetch data extent",t)}}));this._updatingHandles.addPromise(e.promise.then((()=>this._process()))),this.addHandles(e)}get debugInfo(){return{numberOfFeatures:this.store.featureStore.numFeatures,tilesOfInterest:this.tilesOfInterest,pendingTiles:Array.from(this._pendingTiles.values()).map((e=>e.debugInfo)),storedTiles:this.store.debugInfo}}_process(){this._markTilesNotAlive(),this._createPendingTiles(),this._deletePendingTiles(),this._processPendingTiles()}_markTilesNotAlive(){for(const e of this._pendingTiles.values())e.alive=!1}_createPendingTiles(){if(this.suspended)return;const e=this._collectMissingTilesInfo();if(this._setAvailability(null==e?1:e.coveredArea/e.fullArea),null!=e)for(const{data:t,resolution:i}of e.missingTiles){const e=this._pendingTiles.get(t.id);e?(e.resolution=i,e.alive=!0):this._createPendingTile(t,i)}}_collectMissingTilesInfo(){let e=null;for(let t=this.tilesOfInterest.length-1;t>=0;t--){const i=this.tilesOfInterest[t],r=this.store.process(i,((e,t)=>this._verifyTileComplexity(e,t)),this.outFields);null==e?e=r:e.prepend(r)}return e}_deletePendingTiles(){for(const e of this._pendingTiles.values())e.alive||this._deletePendingTile(e)}_processPendingTiles(){const e={fetchCount:(e,t)=>this._fetchCount(e,t),fetchFeatures:(e,t,i)=>this._fetchFeatures(e,t,i),finish:(e,t)=>this._finishPendingTile(e,t),resume:()=>this._processPendingTiles()};if(this._ensureFetchAllCounts(e))for(const t of this._pendingTiles.values())this._verifyTileComplexity(this.store.getFeatureCount(t.data),t.resolution)&&this._updatingHandles.addPromise(t.process(e))}_verifyTileComplexity(e,t){return this._verifyVertexComplexity(e)&&this._verifyFeatureDensity(e,t)}_verifyVertexComplexity(e){return e*this._minimumVerticesPerFeature<P}_verifyFeatureDensity(e,t){if(null==this.tileInfo)return!1;const i=this.tileSize*t;return e*(I/(i*i))<O}_ensureFetchAllCounts(e){let t=!0;for(const i of this._pendingTiles.values())i.state.type<v.StateType.FETCHED_COUNT&&this._updatingHandles.addPromise(i.process(e)),i.state.type<=v.StateType.FETCH_COUNT&&(t=!1);return t}_finishPendingTile(e,t){this.store.add(e.data,t),this._deletePendingTile(e),this._updateAvailability()}_updateAvailability(){const e=this._collectMissingTilesInfo();this._setAvailability(null==e?1:e.coveredArea/e.fullArea)}_setAvailability(e){this._set("availability",e)}_createPendingTile(e,t){const i=new v.PendingFeatureTile(e,t);return this._pendingTiles.set(e.id,i),i}_deletePendingTile(e){e.reset(),this._pendingTiles.delete(e.data.id)}async _fetchCount(e,t){return this.store.fetchCount(e.data,this.url,this._createCountQuery(e),{query:this.customParameters,timeout:b,signal:t})}async _fetchFeatures(e,t,i){let r=0;const s=[];let o=0,n=t;for(;;){const a=this._createFeaturesQuery(e),l=this._setPagingParameters(a,r,n),{features:u,exceededTransferLimit:c}=await this._queryFeatures(a,i);l&&(r+=a.num),o+=u.length;for(const e of u)s.push(e);if(n=t-o,!l||!c||n<=0)return s}}_filterProperties(e){return null==e?{where:"1=1",gdbVersion:void 0,timeExtent:void 0}:{where:e.where||"1=1",timeExtent:e.timeExtent,gdbVersion:e.gdbVersion}}_lookupObjectIdByGlobalId(e){const t=this.globalIdField,i=this.objectIdField;if(null==t)throw new Error("Expected globalIdField to be defined");let r=null;const s=e?u.normalizeGlobalID(e):e;if(this.store.featureStore.forEach((e=>{s===u.normalizeGlobalID(e.attributes[t])&&(r=e.objectId??e.attributes[i])})),null==r)throw new Error(`Expected to find a feature with globalId ${e}`);return r}_queryFeaturesById(e,t){const i=this._createFeaturesQuery();return i.objectIds=e,this._queryFeatures(i,t)}_queryFeatures(e,t){return this.capabilities.query.supportsFormatPBF?this._queryFeaturesPBF(e,t):this._queryFeaturesJSON(e,t)}async _queryFeaturesPBF(e,t){const{sourceSpatialReference:i}=this,{data:r}=await m.executeQueryPBF(this.url,e,new F.OptimizedFeatureSetParserContext({sourceSpatialReference:i}),{query:this._configuration.customParameters,timeout:b,signal:t});return f.unquantizeOptimizedFeatureSet(r)}async _queryFeaturesJSON(e,t){const{sourceSpatialReference:i}=this,{data:r}=await m.executeQuery(this.url,e,i,{query:this._configuration.customParameters,timeout:b,signal:t});return f.convertFromFeatureSet(r,this.objectIdField)}_createCountQuery(e){const t=this._createBaseQuery(e);return this.capabilities.query.supportsCacheHint&&(t.cacheHint=!0),t}_createFeaturesQuery(e=null){const t=this._createBaseQuery(e),i=null!=e?.data?this.store.getAttributesForTile(e?.data?.id):null,r=l.union(l.difference(this.outFields,i??new Set),this._mandatoryOutFields);return t.outFields=Array.from(r),t.returnGeometry=!0,null!=e&&(this.capabilities.query.supportsResultType?t.resultType="tile":this.capabilities.query.supportsCacheHint&&(t.cacheHint=!0)),t}_createBaseQuery(e){const t=new T({returnZ:this.hasZ,returnM:!1,historicMoment:this._historicMoment,geometry:null!=this.tileInfo&&null!=e?y.toExtent(e.data.extent,this.tileInfo.spatialReference):void 0}),i=this._configuration.filter;return null!=i&&(t.where=i.where,t.gdbVersion=i.gdbVersion,t.timeExtent=i.timeExtent),t.outSpatialReference=this.spatialReference,t}_setPagingParameters(e,t,i){if(!this.capabilities.query.supportsPagination)return!1;const{supportsMaxRecordCountFactor:r,supportsCacheHint:s,tileMaxRecordCount:o,maxRecordCount:n,supportsResultType:a}=this.capabilities.query,l=r?T.MAX_MAX_RECORD_COUNT_FACTOR:1,u=l*((a||s)&&o?o:n||S);return e.start=t,r?(e.maxRecordCountFactor=Math.min(l,Math.ceil(i/u)),e.num=Math.min(i,e.maxRecordCountFactor*u)):e.num=Math.min(i,u),!0}},t.__decorate([c.property({constructOnly:!0})],e.FeatureServiceTiledFetcher.prototype,"url",void 0),t.__decorate([c.property({constructOnly:!0})],e.FeatureServiceTiledFetcher.prototype,"objectIdField",void 0),t.__decorate([c.property({constructOnly:!0})],e.FeatureServiceTiledFetcher.prototype,"globalIdField",void 0),t.__decorate([c.property({constructOnly:!0})],e.FeatureServiceTiledFetcher.prototype,"capabilities",void 0),t.__decorate([c.property({constructOnly:!0})],e.FeatureServiceTiledFetcher.prototype,"sourceSpatialReference",void 0),t.__decorate([c.property({constructOnly:!0})],e.FeatureServiceTiledFetcher.prototype,"spatialReference",void 0),t.__decorate([c.property({constructOnly:!0})],e.FeatureServiceTiledFetcher.prototype,"store",void 0),t.__decorate([c.property({readOnly:!0})],e.FeatureServiceTiledFetcher.prototype,"_minimumVerticesPerFeature",null),t.__decorate([c.property()],e.FeatureServiceTiledFetcher.prototype,"_mandatoryOutFields",null),t.__decorate([c.property()],e.FeatureServiceTiledFetcher.prototype,"outFields",null),t.__decorate([c.property()],e.FeatureServiceTiledFetcher.prototype,"suspended",void 0),t.__decorate([c.property()],e.FeatureServiceTiledFetcher.prototype,"_historicMoment",void 0),t.__decorate([c.property()],e.FeatureServiceTiledFetcher.prototype,"filter",null),t.__decorate([c.property()],e.FeatureServiceTiledFetcher.prototype,"customParameters",null),t.__decorate([c.property({readOnly:!0})],e.FeatureServiceTiledFetcher.prototype,"_configuration",null),t.__decorate([c.property()],e.FeatureServiceTiledFetcher.prototype,"tileInfo",null),t.__decorate([c.property()],e.FeatureServiceTiledFetcher.prototype,"tileSize",null),t.__decorate([c.property()],e.FeatureServiceTiledFetcher.prototype,"tilesOfInterest",void 0),t.__decorate([c.property({readOnly:!0})],e.FeatureServiceTiledFetcher.prototype,"updating",null),t.__decorate([c.property({readOnly:!0})],e.FeatureServiceTiledFetcher.prototype,"availability",void 0),t.__decorate([c.property()],e.FeatureServiceTiledFetcher.prototype,"hasZ",null),e.FeatureServiceTiledFetcher=t.__decorate([h.subclass("esri.views.interactive.snapping.featureSources.featureServiceSource.FeatureServiceTiledFetcher")],e.FeatureServiceTiledFetcher);const S=2e3,b=6e5,P=1e6,I=25,O=1;Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
