/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","exports","../../../../chunks/tslib.es6","../../../../core/reactiveUtils","../../../../core/scheduling","../../../../core/accessorSupport/decorators/property","../../../../core/has","../../../../core/Logger","../../../../core/RandomLCG","../../../../core/accessorSupport/decorators/subclass","../../keybindings","../css","../../../../widgets/Widget","../../../../chunks/componentsUtils","../../../../widgets/support/widgetUtils","../../../../widgets/support/jsxFactory"],(function(t,e,i,o,n,s,l,a,r,d,c,u,p,_,h,f){"use strict";const y=`${u.base}-editable-field`,k={base:y,inputMode:`${y}--input`,feedbackMode:`${y}--feedback`,readOnly:`${y}--read-only`,locked:`${y}--locked`,title:`${y}__title`,value:`${y}__value`,valueContent:`${y}__value__content`,valueContentReadOnly:`${y}__value__content--read-only`,lockIcon:`${y}__lock-icon`,input:`${y}__input`,inputSuffix:`${y}__input-suffix`,button:`${y}__button`},m={lock:"lock",unlock:"unlock"};e.TooltipEditableField=class extends p{constructor(){super(...arguments),this._input=null,this._lock=null,this._onLockClick=()=>{this.field.toggleLock(this.context)},this._onLockAfterCreate=t=>{this._lock=t},this._onLockAfterRemoved=()=>{this._lock=null},this._onKeyDown=t=>{t.key===c.tooltipKeys.discard&&"input"===this.mode&&this._input&&this.context.onDiscard(this._input)},this._onInputKeyDown=t=>{const e=this._input;if(e)switch(t.key){case c.tooltipKeys.commit:return this.field.onCommit("commit-and-exit",e,this.context);case c.tooltipKeys.next:{t.preventDefault(),t.stopPropagation();const i=t.shiftKey?"commit-and-previous":"commit-and-next";return this.field.onCommit(i,e,this.context)}}},this._onInput=t=>{this.field.onInput(t.target.value)},this._onInputBlur=t=>{const e=this._input;e&&t.relatedTarget!==this._lock&&this.field.onCommit("commit-on-blur",e,this.context)},this._selectText=()=>{const t=()=>{this._input===document.activeElement&&this._input?.selectText()};t(),n.waitAnimationFrame().then(t)},this._onAfterCreate=t=>{this._input=t,t.addEventListener("paste",this._onPaste),t.addEventListener("beforeinput",this._onBeforeInput)},this._onAfterRemoved=t=>{t.removeEventListener("paste",this._onPaste),t.removeEventListener("beforeinput",this._onBeforeInput)},this._onPaste=t=>{const e=t.clipboardData?.getData("text");if(!e)return;null!=this.field.parse(e,this.context)&&(t.stopPropagation(),this.field.onInput(e))},this._onBeforeInput=t=>{("historyUndo"===t.inputType||"historyRedo"===t.inputType)&&!this.field.dirty&&t.preventDefault()}}initialize(){this.addHandles(o.watch((()=>this._rawDisplayValue),(()=>{const{committed:t,inputValue:e}=this.field;t||e||this._input!==document.activeElement||this._selectText()})))}loadDependencies(){return _.loadCalciteComponents({button:()=>new Promise(((e,i)=>t(["../../../../chunks/calcite-button"],e,i))),icon:()=>new Promise(((e,i)=>t(["../../../../chunks/calcite-icon"],e,i))),input:()=>new Promise(((e,i)=>t(["../../../../chunks/calcite-input"],e,i)))})}render(){const{field:t,mode:e}=this,i="input"===e,{locked:o,readOnly:n}=t;return f.tsx("div",{class:this.classes({[k.base]:!0,[k.feedbackMode]:"feedback"===e,[k.inputMode]:"input"===e,[k.locked]:o,[k.readOnly]:n})},f.tsx("div",{class:k.title,key:"title"},this._title),f.tsx("div",{class:k.value,key:"value",onkeydown:this._onKeyDown},i?this._renderValueInputMode():this._renderValueFeedbackMode()))}get _formattedValue(){return this.field.getFormattedValue(this.context)||v}get _rawDisplayValue(){return this.field.getRawDisplayValue(this.context)}get _suffix(){return this.field.getSuffix(this.context)}get _title(){const{title:t}=this.field;return"string"==typeof t?t:t(this.context)}_renderValueFeedbackMode(){return f.tsx(f.tsxFragment,null,f.tsx("div",{class:k.valueContent,key:"value-feedback"},this._formattedValue),this.field.locked&&"input"!==this.mode?f.tsx("calcite-icon",{class:k.lockIcon,icon:m.lock,key:"icon",scale:"s"}):null)}_renderValueInputMode(){return this.field.readOnly?this._renderValueReadOnly():this._renderValueWritable()}_renderValueReadOnly(){return f.tsx("div",{class:this.classes(k.valueContent,k.valueContentReadOnly),key:"value-read-only"},this._formattedValue)}_renderValueWritable(){const{field:t}=this,{name:e,invalid:i,locked:o}=t,n=this.context?.messages.sketch??{},s=o?n.unlockConstraint:n.lockConstraint;return f.tsx(f.tsxFragment,null,f.tsx("calcite-input",{afterCreate:this._onAfterCreate,afterRemoved:this._onAfterRemoved,class:k.input,"data-field-name":e,"data-testid":`tooltip-field-${e}`,key:"input",onblur:this._onInputBlur,onfocus:this._selectText,onkeydown:this._onInputKeyDown,scale:"s",status:i?"invalid":"idle",type:"text",value:this._rawDisplayValue??v,onCalciteInputInput:this._onInput}),f.tsx("div",{class:k.inputSuffix,key:"suffix"},this._suffix),t.lockable?f.tsx("calcite-button",{afterCreate:this._onLockAfterCreate,afterRemoved:this._onLockAfterRemoved,alignment:"center",appearance:"transparent",class:k.button,"data-testid":`tooltip-field-${e}-lock`,iconStart:o?m.lock:m.unlock,key:"lock",kind:"neutral",label:s,onclick:this._onLockClick,scale:"s",tabIndex:-1,title:s}):f.tsx("div",{key:"lock-empty"}))}},i.__decorate([s.property()],e.TooltipEditableField.prototype,"field",void 0),i.__decorate([s.property()],e.TooltipEditableField.prototype,"context",void 0),i.__decorate([s.property()],e.TooltipEditableField.prototype,"mode",void 0),i.__decorate([s.property()],e.TooltipEditableField.prototype,"_input",void 0),i.__decorate([s.property()],e.TooltipEditableField.prototype,"_lock",void 0),i.__decorate([s.property()],e.TooltipEditableField.prototype,"_formattedValue",null),i.__decorate([s.property()],e.TooltipEditableField.prototype,"_rawDisplayValue",null),i.__decorate([s.property()],e.TooltipEditableField.prototype,"_suffix",null),i.__decorate([s.property()],e.TooltipEditableField.prototype,"_title",null),e.TooltipEditableField=i.__decorate([d.subclass("esri.views.interactive.tooltip.components.TooltipEditableField")],e.TooltipEditableField);const v="—";Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
