/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../core/quantityUtils","./parsingAndFormattingUtils","./TooltipField","./TooltipFieldElevation","./TooltipFieldOrientation","./TooltipFieldSize","../../../support/angularMeasurementUtils"],(function(e,t,a,i,r,n,o,s){"use strict";function l(e){const r=e=>e.inputUnitInfos.angle.unit,n=e=>e.sketchOptions.values.effectiveDirectionMode;return new i.TooltipField({name:"direction",actual:t.zeroDegrees,parse:a.makeQuantityParser({createQuantity:(e,a)=>t.createAngle(e,r(a),"geographic"),sanitize:a.sanitizeAngle}),format:(e,t)=>{const a=n(t),i=s.getNormalizedDirection(e,a);switch(a){case s.DirectionMode.Absolute:return t.formatters.direction(i);case s.DirectionMode.Relative:return t.formatters.directionRelative(i);case s.DirectionMode.RelativeBilateral:return t.formatters.directionRelativeBilateral(i)}},formatForInputMode:(e,a)=>{const i=s.getNormalizedDirection(e,n(a));return a.formatters.scalar(t.toUnit(i,r(a)))},suffix:e=>e.inputUnitInfos.angle.abbreviation,title:e=>{const t=n(e),{absolute:a,relative:i}=e.messages.sketch.direction;switch(t){case s.DirectionMode.Absolute:return a;case s.DirectionMode.Relative:case s.DirectionMode.RelativeBilateral:return i}},...e})}function u(e){const r=e=>e.inputUnitInfos.length.unit;return new i.TooltipField({name:"distance",actual:t.zeroMeters,parse:a.makeQuantityParser({createQuantity:(e,a)=>t.createLength(Math.max(e,0),r(a))}),format:(e,t)=>t.formatters.length(e),formatForInputMode:(e,a)=>a.formatters.scalar(t.toUnit(e,r(a))),suffix:e=>e.inputUnitInfos.length.abbreviation,title:e=>e.messages.sketch.distance,...e})}function c(e){return u({format:(e,t)=>t.formatters.totalLength(e),title:e=>e.messages.sketch.totalLength,readOnly:!0,...e})}function m(e){return u({...e})}function f(e){const i=e=>e.inputUnitInfos.length.unit;return u({...e,parse:a.makeQuantityParser({createQuantity:(e,a)=>t.createLength(e,i(a))}),format:(e,t)=>t.formatters.lengthRelative(e)})}function d(e){return new r.TooltipFieldElevation(e)}function p(e){return new n.TooltipFieldOrientation(e)}function g(e){return new o.TooltipFieldSize(e)}function F(e){return y("scale",{name:"scale",actual:null,parse:a.makeQuantityParser({createQuantity:e=>t.createScalar(Math.abs(e))}),...e})}function k(e){const r=e=>e.inputUnitInfos.area.unit;return new i.TooltipField({name:"area",actual:t.zeroSquareMeters,parse:a.makeQuantityParser({createQuantity:(e,a)=>t.createArea(e,r(a))}),format:(e,t)=>t.formatters.area(e),formatForInputMode:(e,a)=>a.formatters.scalar(t.toUnit(e,r(a))),suffix:e=>e.inputUnitInfos.area.abbreviation,title:e=>e.messages.sketch.area,readOnly:!0,...e})}function h(e){return new i.TooltipField({name:"x",actual:t.zeroDegrees,parse:a.parseLongitude,format:(e,t)=>t.formatters.longitudeDecimalDegrees(e),formatForInputMode:e=>a.formatLongitudeDecimalDegreesForInputMode(e),suffix:e=>e.inputUnitInfos.angle.abbreviation,title:e=>e.messages.sketch.longitude,...e})}function D(e){return new i.TooltipField({name:"y",actual:t.zeroDegrees,parse:a.parseLatitude,format:(e,t)=>t.formatters.latitudeDecimalDegrees(e),formatForInputMode:e=>a.formatLatitudeDecimalDegreesForInputMode(e),suffix:e=>e.inputUnitInfos.angle.abbreviation,title:e=>e.messages.sketch.latitude,...e})}function M(e){return y("x",{name:"x",...e})}function v(e){return y("y",{name:"y",...e})}function y(e,r){return new i.TooltipField({actual:t.createScalar(0),parse:a.makeQuantityParser({createQuantity:e=>t.createScalar(e)}),format:(e,t)=>t.formatters.scalar(e),formatForInputMode:(e,t)=>t.formatters.scalar(e),title:t=>t.messages.sketch[e],...r})}e.makeAreaField=k,e.makeDirectionField=l,e.makeDistanceField=m,e.makeElevationField=d,e.makeLatitudeField=D,e.makeLengthField=u,e.makeLongitudeField=h,e.makeOrientationField=p,e.makeRelativeDistanceField=f,e.makeScaleField=F,e.makeSizeField=g,e.makeTotalLengthField=c,e.makeXField=M,e.makeYField=v,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
