/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../core/Error","../../core/has","../../core/Logger","../../core/promiseUtils","../../core/reactiveUtils","../../core/accessorSupport/decorators/property","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../../layers/support/FeatureEffect","../../layers/support/FeatureFilter","../../layers/support/fieldUtils","../../layers/support/floorFilterUtils","../../rest/support/Query","../../support/arcadeOnDemand","./support/popupUtils"],(function(e,t,r,i,l,o,s,n,a,u,d,p,c,f,y,h){"use strict";return r=>{let n=class extends r{constructor(...e){super(...e),this._updatingRequiredFieldsPromise=null,this.dataUpdating=!1,this.filter=null,this.layer=null,this.requiredFields=[],this.view=null}initialize(){this.addHandles([o.watch((()=>{const e=this.layer;return[e&&"elevationInfo"in e?e.elevationInfo?.featureExpressionInfo:null,e&&"displayField"in e?e.displayField:null,e&&"timeInfo"in e&&e.timeInfo,e&&"renderer"in e&&e.renderer,e&&"labelingInfo"in e&&e.labelingInfo,e&&"floorInfo"in e&&e.floorInfo,this.filter,this.featureEffect,this.timeExtent]}),(()=>this._handleRequiredFieldsChange()),o.syncAndInitial),o.on((()=>this.view?.floors),"change",(()=>this._handleRequiredFieldsChange())),o.on((()=>{const e=this.layer;return e&&"sublayers"in e?e.sublayers:null}),"change",(()=>this._handleRequiredFieldsChange()))])}get availableFields(){if(!this.layer)return[];const{layer:e,layer:{fieldsIndex:t},requiredFields:r}=this;return"outFields"in e&&e.outFields?p.fixFields(t,[...p.unpackFieldNames(t,e.outFields),...r]):p.fixFields(t,r)}get featureEffect(){return this.layer&&"featureEffect"in this.layer?this.layer.featureEffect:null}set featureEffect(e){this._override("featureEffect",e)}get maximumNumberOfFeatures(){return 0}set maximumNumberOfFeatures(e){i.getLogger(this).error("#maximumNumberOfFeatures=","Setting maximum number of features is not supported")}get maximumNumberOfFeaturesExceeded(){return!1}highlight(e){throw new Error("missing implementation")}createQuery(){const e={outFields:["*"],returnGeometry:!0,outSpatialReference:this.view.spatialReference},t=null!=this.filter?this.filter.createQuery(e):new f(e);if("floorInfo"in this.layer&&this.layer.floorInfo){const e=c.getFloorFilterClause(this);null!=e&&(t.where=t.where?`(${t.where}) AND (${e})`:e)}return null!=this.timeExtent&&(t.timeExtent=null!=t.timeExtent?t.timeExtent.intersection(this.timeExtent):this.timeExtent.clone()),t}createAggregateQuery(){const e={outFields:["*"],returnGeometry:!0,outSpatialReference:this.view.spatialReference};return new f(e)}queryFeatures(e,t){throw new Error("missing implementation")}queryObjectIds(e,t){throw new Error("missing implementation")}queryFeatureCount(e,t){throw new Error("missing implementation")}queryExtent(e,t){throw new Error("missing implementation")}async fetchPopupFeaturesFromGraphics(e,t){return this._validateFetchPopupFeatures(e,t),this._fetchPopupFeatures(e,t)}_loadArcadeModules(e){return e.expressionInfos?.length||Array.isArray(e.content)&&e.content.some((e=>"expression"===e.type))?y.loadArcade():Promise.resolve()}_handleRequiredFieldsChange(){const e=this._updateRequiredFields();this._set("_updatingRequiredFieldsPromise",e),e.then((()=>{this._updatingRequiredFieldsPromise===e&&this._set("_updatingRequiredFieldsPromise",null)}))}async _updateRequiredFields(){if(!this.layer||!this.view)return;const e="3d"===this.view.type,{layer:t,layer:{fieldsIndex:r,objectIdField:l}}=this,o="renderer"in t&&t.renderer,s="orderBy"in t&&t.orderBy,n="featureReduction"in t?t.featureReduction:null,a=new Set,u=await Promise.allSettled([o?o.collectRequiredFields(a,r):null,p.collectLabelingFields(a,t),e&&"elevationInfo"in t?p.collectElevationFields(a,t):null,null!=this.filter?p.collectFilterFields(a,t,this.filter):null,e||null==this.featureEffect?null:p.collectFilterFields(a,t,this.featureEffect.filter),!e&&n?p.collectFeatureReductionFields(a,t,n):null,!e&&s?p.collectOrderByInfos(a,t,s):null]);if("timeInfo"in t&&t.timeInfo&&this.timeExtent&&p.collectFields(a,t.fieldsIndex,[t.timeInfo.startField,t.timeInfo.endField]),"floorInfo"in t&&t.floorInfo&&p.collectFields(a,t.fieldsIndex,[t.floorInfo.floorField]),"feature"===t.type&&e&&null!=t.infoFor3D&&(null==t.globalIdField&&i.getLogger(this).error("globalIdField missing on 3DObjectFeatureLayer"),p.collectFields(a,t.fieldsIndex,[t.globalIdField])),"subtype-group"===t.type){p.collectField(a,r,t.subtypeField);const e=t.sublayers.map((e=>Promise.all([e.renderer?.collectRequiredFields(a,r),p.collectLabelingFields(a,e)])));await Promise.allSettled(e)}if("catalog-footprint"===t.type&&t.parent){const e=t.parent;p.collectFields(a,r,[e.itemNameField,e.itemSourceField,e.itemTypeField,e.maxScaleField,e.minScaleField])}for(const p of u)"rejected"===p.status&&i.getLogger(this).error(p.reason);p.collectField(a,r,l),e&&"displayField"in t&&t.displayField&&p.collectField(a,r,t.displayField);const d=Array.from(a).sort();this._set("requiredFields",d)}_validateFetchPopupFeatures(e,r){if(null!=r)for(const i of e){const e=i.origin&&"layer"in i.origin?i.origin.layer:i.layer;if("popupEnabled"in e&&!e.popupEnabled)throw new t("featurelayerview:fetchPopupFeatures","Popups are disabled",{layer:e});if(i.isAggregate){const r="featureReduction"in e?e.featureReduction:null;if(!(r&&"popupTemplate"in r&&r.popupEnabled&&r.popupTemplate))throw new t("featurelayerview:fetchPopupFeatures","Popups are disabled",{layer:e})}else if("popupTemplate"in e){if(!h.getFetchPopupTemplate(e,r))throw new t("featurelayerview:fetchPopupFeatures","Layer does not define a popup template",{layer:e})}}}_popupFeatureHasRequiredFields(e,t){return p.featureHasFields(t,e)}async _fetchPopupFeatures(e,t){const r=new Array(e.length),i=new Map,o=await this._createPopupQuery(e.map((e=>e.origin?.layer??e.layer)),t);for(let s=0;s<e.length;s++){const n=e[s];if(n.isAggregate){r[s]=n;continue}const a=n.origin?.layer??n.layer;if(!a||!("popupEnabled"in a))continue;const u=p.unpackFieldNames(this.layer.fieldsIndex,o.outFields),d=h.getFetchPopupTemplate(a,t);if(null==d)continue;const c=await this._loadArcadeModules(d);l.throwIfAborted(t);c&&c.arcadeUtils.hasGeometryOperations(d)||!this._popupFeatureHasRequiredFields(n,u)?i.set(n.getObjectId(),{graphic:n,index:s}):r[s]=n}if("stream"===this.layer.type||"parquet"===this.layer.type||0===i.size)return r.filter(Boolean);o.objectIds=Array.from(i.keys());try{const e=await this.layer.queryFeatures(o,t);for(const t of e.features){const{graphic:{geometry:e,origin:l},index:o}=i.get(t.getObjectId());t.geometry||=e,t.origin=l,r[o]=t}}catch{}return r.filter(Boolean)}async _createPopupQuery(e,t){const r=this.layer.createQuery(),i=new Set;let o=!1;const s=e??[this.layer];for(const n of s){if(!("popupEnabled"in n))continue;const e=h.getFetchPopupTemplate(n,t);if(null==e)continue;const r=await this._loadArcadeModules(e);l.throwIfAborted(t);const s=r&&r.arcadeUtils.hasGeometryOperations(e);o=!("point"!==this.layer.geometryType&&!s);const a=await h.getRequiredFields(this.layer,e);l.throwIfAborted(t);for(const t of a)i.add(t)}if(r.returnGeometry=o,r.returnZ=o,r.returnM=o,r.outFields=Array.from(i),r.outSpatialReference=this.view.spatialReference,"floorInfo"in this.layer&&this.layer.floorInfo){const e=c.getFloorFilterClause(this);null!=e&&(r.where=r.where?`(${r.where}) AND (${e})`:e)}return r}canResume(){return!!super.canResume()&&(null==this.timeExtent||!this.timeExtent.isEmpty)}getTest(){}get test(){}};return e.__decorate([s.property()],n.prototype,"_updatingRequiredFieldsPromise",void 0),e.__decorate([s.property({readOnly:!0})],n.prototype,"availableFields",null),e.__decorate([s.property({readOnly:!0})],n.prototype,"dataUpdating",void 0),e.__decorate([s.property({type:u})],n.prototype,"featureEffect",null),e.__decorate([s.property({type:d})],n.prototype,"filter",void 0),e.__decorate([s.property()],n.prototype,"layer",void 0),e.__decorate([s.property({type:Number})],n.prototype,"maximumNumberOfFeatures",null),e.__decorate([s.property({readOnly:!0,type:Boolean})],n.prototype,"maximumNumberOfFeaturesExceeded",null),e.__decorate([s.property({readOnly:!0})],n.prototype,"requiredFields",void 0),e.__decorate([s.property()],n.prototype,"suspended",void 0),e.__decorate([s.property()],n.prototype,"view",void 0),n=e.__decorate([a.subclass("esri.views.layers.FeatureLayerView")],n),n}}));
