/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../../chunks/tslib.es6","../../core/arrayUtils","../../core/Logger","../../core/maybe","../../core/maybeUpdating","../../core/promiseUtils","../../core/reactiveUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/accessorSupport/decorators/subclass","../../geometry/projection","./LayerView"],(function(e,r,t,o,n,i,l,a,s,p,c,y,u){"use strict";let d=class extends u{constructor(){super(...arguments),this.layer=null,this.filter=null,this._geometryEngine=null,this._projectionEngineLoaded=!1,this._abortController=new AbortController}get availableFields(){return[]}get maximumNumberOfFeatures(){return 0}set maximumNumberOfFeatures(e){throw new Error("Not implemented")}get maximumNumberOfFeaturesExceeded(){return!1}get layerFilter(){return i.unwrapUpdating(this._layerFilter)}get _layerFilter(){const e=this.layer?.filter;if(null==e||e.geometries.length<1)return null;const r=this._geometryEngine;if(null==r||!this._projectionEngineLoaded&&this._filterNeedsProjectionEngine)return i.updating;const n=e.geometries.at(0).spatialReference,l=e.geometries.toArray().map((e=>{try{e=r.simplify(e)}catch(t){return o.getLogger(this).warnOncePerTick("Failed to simplify scene filter mask polygon. Polygon will be ignored."),null}if(null==e)return null;if(e.spatialReference.equals(n))return e;try{return y.project(e,n)}catch(t){return o.getLogger(this).warnOncePerTick("Failed to project scene filter mask polygon. Polygon will be ignored."),null}})).filter(t.isSome).sort(((e,r)=>e.extent.xmin-r.extent.xmin)),a=new Set,s=new Array,p=new Array;for(let t of l){const e=t.extent.xmin;if(s.length=0,a.forEach((o=>{if(e>=o.extent.xmax)return p.push(o),void a.delete(o);t.extent.ymin<=o.extent.ymax&&t.extent.ymax>=o.extent.ymin&&r.intersects(t,o)&&s.push(o)})),s.length>0){s.push(t);try{t=r.union(s)}catch(c){o.getLogger(this).warnOncePerTick("Failed to unify filter mask polygons. Polygon will be ignored.");continue}s.pop(),s.forEach((e=>a.delete(e)))}a.add(t)}return a.forEach((e=>p.push(e))),p.length>0?{spatialRelationship:e.spatialRelationship,geometries:p}:null}get _filterNeedsProjectionEngine(){const e=this.layer.filter;if(null==e||e.geometries.length<=1)return!1;const r=e.geometries.at(0).spatialReference;return e.geometries.some((({spatialReference:e})=>!e.equals(r)&&!y.canProjectWithoutEngine(e,r)))}get layerFilterUpdating(){return i.isUpdating(this._layerFilter)}initialize(){const{signal:r}=this._abortController;a.whenOnce((()=>this.destroyed||!this._geometryEngine&&this.layer?.filter?.geometries?.length),r).then((async()=>{l.throwIfAbortError(r),this._geometryEngine=await new Promise(((r,t)=>e(["../../geometry/geometryEngine"],r,t)))})).catch(l.throwIfNotAbortError),this._projectionEngineLoaded=y.isLoaded(),a.whenOnce((()=>this.destroyed||!this._projectionEngineLoaded&&this._filterNeedsProjectionEngine),r).then((async()=>{l.throwIfAbortError(r),await y.load(),this._projectionEngineLoaded=!0})).catch(l.throwIfNotAbortError)}destroy(){this._abortController=n.abortMaybe(this._abortController)}highlight(e){throw new Error("Not implemented")}queryFeatures(e,r){throw new Error("Not implemented")}queryObjectIds(e,r){throw new Error("Not implemented")}queryFeatureCount(e,r){throw new Error("Not implemented")}createQuery(){throw new Error("Not implemented")}queryExtent(e,r){throw new Error("Not implemented")}};r.__decorate([s.property()],d.prototype,"layer",void 0),r.__decorate([s.property()],d.prototype,"availableFields",null),r.__decorate([s.property()],d.prototype,"maximumNumberOfFeatures",null),r.__decorate([s.property({readOnly:!0})],d.prototype,"maximumNumberOfFeaturesExceeded",null),r.__decorate([s.property()],d.prototype,"filter",void 0),r.__decorate([s.property({readOnly:!0})],d.prototype,"layerFilter",null),r.__decorate([s.property({readOnly:!0})],d.prototype,"_layerFilter",null),r.__decorate([s.property()],d.prototype,"_geometryEngine",void 0),r.__decorate([s.property()],d.prototype,"_projectionEngineLoaded",void 0),r.__decorate([s.property()],d.prototype,"_filterNeedsProjectionEngine",null),r.__decorate([s.property()],d.prototype,"layerFilterUpdating",null),d=r.__decorate([c.subclass("esri.views.layers.SceneLayerView")],d);return d}));
