/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","exports","../../../chunks/tslib.es6","../../../chunks/languageUtils","../../../core/Accessor","../../../core/arrayUtils","../../../core/Collection","../../../core/Error","../../../core/handleUtils","../../../core/has","../../../core/MapUtils","../../../core/promiseUtils","../../../core/reactiveUtils","../../../core/sql","../../../core/unitUtils","../../../core/accessorSupport/decorators/property","../../../core/Logger","../../../core/accessorSupport/decorators/subclass","../../../geometry/Extent","../../../geometry/support/scaleUtils","../../../layers/support/fieldUtils","../../../layers/support/floorFilterUtils","../../../renderers/support/clickToleranceUtils","../../../rest/identify","../../../rest/support/IdentifyParameters","../../../support/arcadeOnDemand","../../../symbols/SimpleMarkerSymbol","../../3d/layers/support/highlightUtils","./popupUtils"],(function(e,t,r,i,s,a,o,l,n,c,p,u,y,h,d,f,g,m,w,b,v,S,F,_,P,x,V,H,U){"use strict";let L=null;function M(e,t){return"tile"===t.type||"map-image"===t.type}function G(e,t,r){const i=[];if(!e)return i;const s=e=>{const a=0===e.minScale||t<=e.minScale,o=0===e.maxScale||t>=e.maxScale;if(e.visible&&a&&o)if(e.sublayers)e.sublayers.forEach(s);else if(e.popupEnabled){const t=U.getFetchPopupTemplate(e,{...r,defaultPopupTemplateEnabled:!1});null!=t&&i.unshift({sublayer:e,popupTemplate:t})}};return e.map(s),i}function R(e){return e.expressionInfos?.length||Array.isArray(e.content)&&e.content.some((e=>"expression"===e.type))?x.loadArcade():Promise.resolve()}async function A(e,t){if(e.capabilities?.operations?.supportsQuery)return!0;try{return await Promise.any(t.map((({sublayer:e})=>e.load().then((()=>e.capabilities.operations.supportsQuery)))))}catch{return!1}}async function T(e,t,r){const i=e.renderer;return i&&"defaultSymbol"in i&&!i.defaultSymbol&&(t=i.valueExpression?await Promise.all(t.map((e=>i.getSymbolAsync(e,r).then((t=>t?e:null))))).then((e=>e.filter((e=>null!=e)))):t.filter((e=>null!=i.getSymbol(e)))),t}t.MapServiceLayerViewHelper=class extends s{constructor(e){super(e),this._featuresResolutions=new WeakMap,this.highlightGraphics=null,this.highlightGraphicUpdated=null,this.updateHighlightedFeatures=u.debounce((async e=>{this.destroyed||this.updatingHandles.addPromise(this._updateHighlightedFeaturesGeometries(e).catch((()=>{})))}))}initialize(){const e=e=>{this.updatingHandles.addPromise(this._updateHighlightedFeaturesSymbols(e).catch((()=>{}))),this.updateHighlightedFeatures(this._highlightGeometriesResolution)};this.addHandles([y.on((()=>this.highlightGraphics),"change",(t=>e(t.added)),{onListenerAdd:t=>e(t)})])}async fetchPopupFeaturesAtLocation(e,t){const{layerView:{layer:r,view:{scale:i}}}=this;if(!e)throw new l("fetchPopupFeatures:invalid-area","Nothing to fetch without area",{layer:r});const s=G(r.sublayers,i,t);if(!s.length)return[];const a=await A(r,s);if(!((r.capabilities?.operations?.supportsIdentify??!0)&&r.version>=10.5)&&!a)throw new l("fetchPopupFeatures:not-supported","query operation is disabled for this service",{layer:r});return a?this._fetchPopupFeaturesUsingQueries(e,s,t):this._fetchPopupFeaturesUsingIdentify(e,s,t)}clearHighlights(){this.highlightGraphics?.removeAll()}highlight(e){const t=this.highlightGraphics;if(!e||!t)return H.emptyHighlightHandle;let r=i.isGraphic(e)?[e]:o.isCollection(e)?e.toArray():Array.isArray(e)?e:[];if(r=r?.filter(a.isSome),0===(r?.length??0))return H.emptyHighlightHandle;for(const i of r){const{sourceLayer:e}=i;null!=e&&"geometryType"in e&&"point"===e.geometryType&&(i.visible=!1)}return t.addMany(r),n.makeHandle((()=>t.removeMany(r??[])))}async _updateHighlightedFeaturesSymbols(t){const{layerView:{view:r},highlightGraphics:i,highlightGraphicUpdated:s}=this;if(i&&s)for(const a of t){const t=a.sourceLayer&&"renderer"in a.sourceLayer&&a.sourceLayer.renderer;a.sourceLayer&&"geometryType"in a.sourceLayer&&"point"===a.sourceLayer.geometryType&&t&&"getSymbolAsync"in t&&t.getSymbolAsync(a).then((async o=>{o||=new V;let l=null;const n="visualVariables"in t?t.visualVariables?.find((e=>"size"===e.type)):void 0;n&&(L||(L=(await new Promise(((t,r)=>e(["../../../renderers/visualVariables/support/visualVariableUtils"],t,r)))).getSize),l=L(n,a,{view:r.type,scale:r.scale,shape:"simple-marker"===o.type?o.style:null})),l||="width"in o&&"height"in o&&null!=o.width&&null!=o.height?Math.max(o.width,o.height):"size"in o?o.size:16,i.includes(a)&&(a.symbol=new V({style:"square",size:l,xoffset:"xoffset"in o?o.xoffset:0,yoffset:"yoffset"in o?o.yoffset:0}),s(a,"symbol"),a.visible=!0)}))}}async _updateHighlightedFeaturesGeometries(e){const{layerView:{layer:t,view:r},highlightGraphics:i,highlightGraphicUpdated:s}=this;if(this._highlightGeometriesResolution=e,!s||!i?.length||!t.capabilities.operations.supportsQuery)return;const a=this._getTargetResolution(e),o=new Map;for(const c of i)if(!this._featuresResolutions.has(c)||this._featuresResolutions.get(c)>a){const e=c.sourceLayer;p.getOrCreateMapValue(o,e,(()=>new Map)).set(c.getObjectId(),c)}const l=Array.from(o,(([e,t])=>{const i=e.createQuery();return i.objectIds=[...t.keys()],i.outFields=[e.objectIdField],i.returnGeometry=!0,i.maxAllowableOffset=a,i.outSpatialReference=r.spatialReference,e.queryFeatures(i)})),n=await Promise.all(l);if(!this.destroyed)for(const{features:c}of n)for(const e of c){const t=e.sourceLayer,r=o.get(t).get(e.getObjectId());r&&i.includes(r)&&(r.geometry=e.geometry,s(r,"geometry"),this._featuresResolutions.set(r,a))}}_getTargetResolution(e){const t=e*d.getMetersPerUnitForSR(this.layerView.view.spatialReference),r=t/16;return r<=10?0:e/t*r}async _fetchPopupFeaturesUsingIdentify(e,t,r){const i=await this._createIdentifyParameters(e,t,r);if(null==i)return[];const{results:s}=await _.identify(this.layerView.layer.parsedUrl,i,r);return s.map((e=>e.feature))}async _createIdentifyParameters(e,t,r){const{floors:i,layer:s,timeExtent:a,view:{spatialReference:o,scale:l}}=this.layerView;if(!t.length)return null;await Promise.all(t.map((({sublayer:e})=>e.load(r).catch((()=>{})))));const n=Math.min(c("mapservice-popup-identify-max-tolerance"),s.allSublayers.reduce(((e,t)=>t.renderer?F.calculateTolerance({renderer:t.renderer,pointerType:r?.pointerType}):e),2)),p=this.createFetchPopupFeaturesQueryGeometry(e,n),u=b.getResolutionForScale(l,o),y=Math.round(p.width/u),h=new w({xmin:p.center.x-u*y,ymin:p.center.y-u*y,xmax:p.center.x+u*y,ymax:p.center.y+u*y,spatialReference:p.spatialReference});return new P({floors:i,gdbVersion:"gdbVersion"in s?s.gdbVersion:void 0,geometry:e,height:y,layerOption:"popup",mapExtent:h,returnGeometry:!0,spatialReference:o,sublayers:s.sublayers,timeExtent:a,tolerance:n,width:y})}async _fetchPopupFeaturesUsingQueries(e,t,r){const{layerView:{floors:i,timeExtent:s}}=this,o=t.map((async({sublayer:t,popupTemplate:a})=>{if(await t.load(r).catch((()=>{})),t.capabilities&&!t.capabilities.operations.supportsQuery)return[];const o=t.createQuery(),l=F.calculateTolerance({renderer:t.renderer,pointerType:r?.pointerType}),n=this.createFetchPopupFeaturesQueryGeometry(e,l),c=new Set,[p]=await Promise.all([U.getRequiredFields(t,a),t.renderer?.collectRequiredFields(c,t.fieldsIndex)]);u.throwIfAborted(r),v.collectFields(c,t.fieldsIndex,p);const y=Array.from(c).sort();o.geometry=n,o.outFields=y,o.timeExtent=s;const d=S.getLayerFloorFilterClause(i,t);o.where=h.sqlAnd(o.where,d);const f=this._getTargetResolution(n.width/l),g=await R(a);u.throwIfAborted(r);const m="point"===t.geometryType||g&&g.arcadeUtils.hasGeometryOperations(a);m||(o.maxAllowableOffset=f);let{features:w}=await t.queryFeatures(o,r);const b=m?0:f;w=await T(t,w,r);for(const e of w)this._featuresResolutions.set(e,b);return w}));return(await Promise.allSettled(o)).reduce(((e,t)=>"fulfilled"===t.status?[...e,...t.value]:e),[]).filter(a.isSome)}},r.__decorate([f.property({constructOnly:!0})],t.MapServiceLayerViewHelper.prototype,"createFetchPopupFeaturesQueryGeometry",void 0),r.__decorate([f.property({constructOnly:!0})],t.MapServiceLayerViewHelper.prototype,"layerView",void 0),r.__decorate([f.property({constructOnly:!0})],t.MapServiceLayerViewHelper.prototype,"highlightGraphics",void 0),r.__decorate([f.property({constructOnly:!0})],t.MapServiceLayerViewHelper.prototype,"highlightGraphicUpdated",void 0),r.__decorate([f.property({constructOnly:!0})],t.MapServiceLayerViewHelper.prototype,"updatingHandles",void 0),t.MapServiceLayerViewHelper=r.__decorate([m.subclass("esri.views.layers.support.MapServiceLayerViewHelper")],t.MapServiceLayerViewHelper),t.collectPopupProviders=G,t.isMapServiceLayerView=M,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
