/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../chunks/tslib.es6","../../core/Accessor","../../core/asyncUtils","../../core/maybe","../../core/promiseUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/Logger","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../../geometry/support/heightModelInfoUtils","../ViewingMode","./projectionUtils"],(function(e,t,a,r,n,s,o,i,l,p,u,c,d,f){"use strict";e.DefaultsFromMap=class extends a{constructor(e){super(e),this.required={extent:!1,heightModelInfo:!1,tileInfo:!1},this.defaultSpatialReference=null,this.userSpatialReference=null,this.sourcePreloadCount=10,this.priorityCollection=null,this.requiresExtentInSpatialReference=!0,this.suspended=!1,this._projectExtentTask={task:null,input:null,output:null,spatialReference:null}}destroy(){this._projectExtentTask.task&&(this._projectExtentTask.task=n.abortMaybe(this._projectExtentTask.task)),this._set("map",null)}get ready(){return!this._spatialReferenceTask.updating&&!this._tileInfoTask.updating&&!this._extentTask.updating}get heightModelInfoReady(){return!this._heightModelInfoTask.updating}get spatialReference(){return this.userSpatialReference??this._spatialReferenceTask.spatialReference}get extent(){return this._extentTask.extent}get heightModelInfo(){return this._heightModelInfoTask.heightModelInfo}get vcsWkid(){return this._heightModelInfoTask.vcsWkid}get latestVcsWkid(){return this._heightModelInfoTask.latestVcsWkid}get viewingMode(){return null==this.userSpatialReference||this.userSpatialReference.equals(this._spatialReferenceTask.spatialReference)?this._spatialReferenceTask.viewingMode:null}get tileInfo(){return this._tileInfoTask.tileInfo}get mapCollections(){const e=this.map?.(),t=[];return null!=this.priorityCollection&&t.push(this.priorityCollection),t.push({parent:e?.basemap,layers:e?.basemap?.baseLayers},{layers:e?.layers},{parent:e?.ground,layers:e?.ground?.layers},{parent:e?.basemap,layers:e?.basemap?.referenceLayers}),t}get _spatialReferenceTask(){if(this.suspended)return this._get("_spatialReferenceTask")??{updating:!1};let e;if(this._collectLayers(this.mapCollections,(t=>{const a=this._getSupportedSpatialReferences(t);if(a.length>0){const t=this._narrowDownSpatialReferenceCandidates(e,a);null!=t&&(e=t)}return 1===e?.length}))&&1!==e?.length)return{updating:!0};const t=this._pickSpatialReferenceCandidate(e);return{spatialReference:t?.spatialReference??null,viewingMode:t?.viewingMode??null,updating:!1}}get _tileInfoTask(){if(!this.required.tileInfo)return this._get("_tileInfoTask")??{updating:!1};const e=this.map?.(),t=this.spatialReference;if(!t)return{updating:this._spatialReferenceTask.updating};let a;const r=this._collectLayers([{parent:e?.basemap,layers:e?.basemap?.baseLayers},{layers:e?.layers}],(e=>!(!("tileInfo"in e)||!e.tileInfo?.spatialReference.equals(t))&&(a=e,!0)),(e=>"tileInfo"in e));if(a){return{tileInfo:a.tileInfo,updating:!1}}return{updating:r}}get _heightModelInfoTask(){if(!this.required.heightModelInfo||this.suspended&&this._get("_heightModelInfoTask")?.heightModelInfo)return this._get("_heightModelInfoTask")??{updating:!1};let e={};const t=this._collectLayers(this.mapCollections,(t=>{const a=c.deriveHeightModelInfoFromLayer(t);return!!a&&(e={heightModelInfo:a,vcsWkid:t.spatialReference?.vcsWkid,latestVcsWkid:t.spatialReference?.latestVcsWkid},!0)}),(e=>c.supportsHeightModelInfo(e)));return{...e,updating:t}}get _extentCandidatesTask(){if(this.suspended||!this.required.extent)return this._get("_extentCandidatesTask")??{updating:!1};if(!this.spatialReference)return{updating:this._spatialReferenceTask.updating};const e=[],t=this._collectLayers(this.mapCollections,(t=>{const a="fullExtents"in t&&t.fullExtents||(null!=t.fullExtent?[t.fullExtent]:[]),r=this.requiresExtentInSpatialReference?null:a[0],n=a.find((e=>e.spatialReference.equals(this.spatialReference)))??r;if(n)return e.push({extent:n,layer:t}),!0;if(this._getSupportedSpatialReferences(t).length>0)for(const s of a)e.push({extent:s,layer:t});return!1}));return{candidates:e,updating:t}}get _extentTask(){const{candidates:e,updating:t}=this._extentCandidatesTask;if(t)return{updating:t};if(null==e||0===e.length)return{updating:!1};if(!this.spatialReference)return{updating:this._spatialReferenceTask.updating};const a=this._pickExtentCandidate(e),o=this.spatialReference;return a.extent.equals(this._projectExtentTask.input)&&o.equals(this._projectExtentTask.spatialReference)?{extent:this._projectExtentTask.output,updating:null!=this._projectExtentTask.task&&!this._projectExtentTask.task.finished}:(null!=this._projectExtentTask.task&&(this._projectExtentTask.task=n.abortMaybe(this._projectExtentTask.task)),this._projectExtentTask={input:a.extent.clone(),output:null,spatialReference:o.clone(),task:r.createTask((async e=>{try{const t=await f.projectWithEngineOrService(a.extent,o,"portalItem"in a.layer?a.layer.portalItem:void 0,e);this._projectExtentTask={...this._projectExtentTask,task:null,output:t}}catch(t){if(s.isAborted(e))return;this._projectExtentTask={...this._projectExtentTask,task:null}}}))},{updating:!0})}_narrowDownSpatialReferenceCandidates(e,t){if(null==e)return t;const a=new Array;for(const r of e)for(const e of t){if(!r.spatialReference.equals(e.spatialReference))continue;const t=_(r.viewingMode,e.viewingMode);if(!1!==t){a.push({spatialReference:r.spatialReference,viewingMode:t});break}}return a.length>0?a:null}_pickSpatialReferenceCandidate(e){const t=this.defaultSpatialReference;return null==e||e.length<1?t?{spatialReference:t,viewingMode:null}:null:(null!=t&&e.length>1&&e.some((({spatialReference:e})=>e.equals(t)))&&(e=e.filter((({spatialReference:e})=>e.equals(t)))),e.length>1&&e.some((({viewingMode:e})=>e!==d.ViewingMode.Local))&&(e=e.filter((({viewingMode:e})=>e!==d.ViewingMode.Local))),e[0])}_getSupportedSpatialReferences(e){const t="supportedSpatialReferences"in e&&e.supportedSpatialReferences||(e.spatialReference?[e.spatialReference]:[]);if(0===t.length)return[];const a=[];for(const r of t){const t=this.getSpatialReferenceSupport(r,e);if(null!=t){const e=t.constraints??[{spatialReference:r,viewingMode:null}];for(const{spatialReference:t,viewingMode:r}of e)this.requiresExtentInSpatialReference&&null!=this.userSpatialReference&&!t.equals(this.userSpatialReference)||a.push({spatialReference:t,viewingMode:r})}}return a}_pickExtentCandidate(e){const t=this.spatialReference;return e.find((({extent:e})=>t.equals(e.spatialReference)))||e[0]}_collectLayers(e,t,a=()=>!0){if("loaded"!==this._loadMaybe(this.map?.()))return!0;const r=new h(a,t);for(const n of e)if(this._collectCollection(n,r),r.done||r.preloading===this.sourcePreloadCount)break;return r.updating}_collectCollection(e,t){if(e.layers){switch(this._loadMaybe(e.parent)){case"loading":return t.updating=!0,void++t.preloading;case"failed":return}for(const a of e.layers)if(t.layerFilter(a)){switch(this._loadMaybe(a)){case"failed":continue;case"loading":t.updating=!0,++t.preloading;break;case"loaded":if(t.updating||(t.done=t.pushLayer(a)),t.done||t.preloading===this.sourcePreloadCount)break;"layers"in a&&this._collectCollection({layers:a.layers},t)}if(t.done||t.preloading===this.sourcePreloadCount)break}}}_loadMaybe(e){return e&&"loadStatus"in e&&null!=e.loadStatus?"not-loaded"===e.loadStatus?(e.load().catch((e=>{s.isAbortError(e)})),"loading"):e.loadStatus:"loaded"}},t.__decorate([o.property()],e.DefaultsFromMap.prototype,"required",void 0),t.__decorate([o.property({constructOnly:!0})],e.DefaultsFromMap.prototype,"map",void 0),t.__decorate([o.property({constructOnly:!0})],e.DefaultsFromMap.prototype,"getSpatialReferenceSupport",void 0),t.__decorate([o.property()],e.DefaultsFromMap.prototype,"defaultSpatialReference",void 0),t.__decorate([o.property()],e.DefaultsFromMap.prototype,"userSpatialReference",void 0),t.__decorate([o.property()],e.DefaultsFromMap.prototype,"sourcePreloadCount",void 0),t.__decorate([o.property()],e.DefaultsFromMap.prototype,"priorityCollection",void 0),t.__decorate([o.property()],e.DefaultsFromMap.prototype,"requiresExtentInSpatialReference",void 0),t.__decorate([o.property()],e.DefaultsFromMap.prototype,"suspended",void 0),t.__decorate([o.property({readOnly:!0})],e.DefaultsFromMap.prototype,"ready",null),t.__decorate([o.property({readOnly:!0})],e.DefaultsFromMap.prototype,"heightModelInfoReady",null),t.__decorate([o.property({readOnly:!0})],e.DefaultsFromMap.prototype,"spatialReference",null),t.__decorate([o.property({readOnly:!0})],e.DefaultsFromMap.prototype,"extent",null),t.__decorate([o.property({readOnly:!0})],e.DefaultsFromMap.prototype,"heightModelInfo",null),t.__decorate([o.property({readOnly:!0})],e.DefaultsFromMap.prototype,"vcsWkid",null),t.__decorate([o.property({readOnly:!0})],e.DefaultsFromMap.prototype,"latestVcsWkid",null),t.__decorate([o.property({readOnly:!0})],e.DefaultsFromMap.prototype,"viewingMode",null),t.__decorate([o.property({readOnly:!0})],e.DefaultsFromMap.prototype,"tileInfo",null),t.__decorate([o.property({readOnly:!0})],e.DefaultsFromMap.prototype,"mapCollections",null),t.__decorate([o.property({readOnly:!0})],e.DefaultsFromMap.prototype,"_spatialReferenceTask",null),t.__decorate([o.property({readOnly:!0})],e.DefaultsFromMap.prototype,"_tileInfoTask",null),t.__decorate([o.property({readOnly:!0})],e.DefaultsFromMap.prototype,"_heightModelInfoTask",null),t.__decorate([o.property({readOnly:!0})],e.DefaultsFromMap.prototype,"_extentCandidatesTask",null),t.__decorate([o.property()],e.DefaultsFromMap.prototype,"_extentTask",null),t.__decorate([o.property()],e.DefaultsFromMap.prototype,"_projectExtentTask",void 0),e.DefaultsFromMap=t.__decorate([u.subclass("esri.views.support.DefaultsFromMap")],e.DefaultsFromMap);class h{constructor(e,t){this.layerFilter=e,this.pushLayer=t,this.preloading=-1,this.updating=!1,this.done=!1}}function _(e,t){return null!=e?null!=t?e===t&&e:e:t}Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
