/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../core/Handles","../../core/has","../../core/Logger","../../core/maybe","../../core/PerformanceSampler","../../core/PooledArray","../../core/promiseUtils","../../core/reactiveUtils","../../core/signal","../../core/time","../../layers/support/PromiseQueue","./debugFlags","./RenderState","./Yield"],(function(e,t,s,i,r,a,n,o,_,h,u,d,T,E,l){"use strict";function c(){return new y.Scheduler}var I;e.TaskPriority=void 0,(I=e.TaskPriority||(e.TaskPriority={})).RESOURCE_CONTROLLER_IMMEDIATE="immediate",I.RESOURCE_CONTROLLER="schedule",I.SLIDE="slide",I.STREAM_DATA_LOADER="stream loader",I.ELEVATION_QUERY="elevation query",I.TERRAIN_SURFACE="terrain",I.SURFACE_GEOMETRY_UPDATES="surface geometry updates",I.LOD_RENDERER="LoD renderer",I.GRAPHICS_CORE="Graphics3D",I.I3S_CONTROLLER="I3S",I.POINT_CLOUD_LAYER="point cloud",I.FEATURE_TILE_FETCHER="feature fetcher",I.OVERLAY="overlay",I.STAGE="stage",I.GRAPHICS_DECONFLICTOR="graphics deconflictor",I.FILTER_VISIBILITY="Graphics3D filter visibility",I.SCALE_VISIBILITY="Graphics3D scale visibility",I.FRUSTUM_VISIBILITY="Graphics3D frustum visibility",I.POINT_OF_INTEREST_FREQUENT="POI frequent",I.POINT_OF_INTEREST_INFREQUENT="POI infrequent",I.LABELER="labeler",I.FEATURE_QUERY_ENGINE="feature query",I.FEATURE_TILE_TREE="feature tile tree",I.FEATURE_TILE_TREE_ACTIVE="fast feature tile tree",I.ELEVATION_ALIGNMENT="elevation alignment",I.ELEVATION_ALIGNMENT_SCENE="elevation alignment scene",I.TEXT_TEXTURE_ATLAS="text texture atlas",I.TEXTURE_UNLOAD="texture unload",I.LINE_OF_SIGHT_TOOL="line of sight tool",I.LINE_OF_SIGHT_TOOL_INTERACTIVE="interactive line of sight tool",I.ELEVATION_PROFILE="elevation profile",I.SNAPPING="snapping",I.SHADOW_ACCUMULATOR="shadow accumulator",I.CLOUDS_GENERATOR="clouds generator",I.MAPVIEW_FETCH_QUEUE="mapview fetch queue",I.MAPVIEW_LAYERVIEW_UPDATE="mapview layerview update",I.MAPVIEW_VECTOR_TILE_PARSING_QUEUE="mapview vector tile parsing queue",I[I.NONE=0]="NONE",I[I.TEST_PRIO=1]="TEST_PRIO";const g=0,m=new Map([[e.TaskPriority.RESOURCE_CONTROLLER_IMMEDIATE,g],[e.TaskPriority.RESOURCE_CONTROLLER,4],[e.TaskPriority.SLIDE,g],[e.TaskPriority.STREAM_DATA_LOADER,g],[e.TaskPriority.ELEVATION_QUERY,g],[e.TaskPriority.TERRAIN_SURFACE,1],[e.TaskPriority.SURFACE_GEOMETRY_UPDATES,1],[e.TaskPriority.LOD_RENDERER,2],[e.TaskPriority.GRAPHICS_CORE,2],[e.TaskPriority.I3S_CONTROLLER,2],[e.TaskPriority.POINT_CLOUD_LAYER,2],[e.TaskPriority.FEATURE_TILE_FETCHER,2],[e.TaskPriority.CLOUDS_GENERATOR,2],[e.TaskPriority.OVERLAY,4],[e.TaskPriority.STAGE,4],[e.TaskPriority.GRAPHICS_DECONFLICTOR,4],[e.TaskPriority.FILTER_VISIBILITY,4],[e.TaskPriority.SCALE_VISIBILITY,4],[e.TaskPriority.FRUSTUM_VISIBILITY,4],[e.TaskPriority.POINT_OF_INTEREST_FREQUENT,6],[e.TaskPriority.POINT_OF_INTEREST_INFREQUENT,30],[e.TaskPriority.LABELER,8],[e.TaskPriority.FEATURE_QUERY_ENGINE,8],[e.TaskPriority.FEATURE_TILE_TREE,16],[e.TaskPriority.FEATURE_TILE_TREE_ACTIVE,g],[e.TaskPriority.ELEVATION_ALIGNMENT,12],[e.TaskPriority.ELEVATION_ALIGNMENT_SCENE,14],[e.TaskPriority.TEXT_TEXTURE_ATLAS,12],[e.TaskPriority.TEXTURE_UNLOAD,12],[e.TaskPriority.LINE_OF_SIGHT_TOOL,16],[e.TaskPriority.LINE_OF_SIGHT_TOOL_INTERACTIVE,g],[e.TaskPriority.SNAPPING,g],[e.TaskPriority.SHADOW_ACCUMULATOR,30],[e.TaskPriority.MAPVIEW_FETCH_QUEUE,g],[e.TaskPriority.MAPVIEW_LAYERVIEW_UPDATE,2],[e.TaskPriority.MAPVIEW_VECTOR_TILE_PARSING_QUEUE,g]]);function k(e){return m.has(e)?m.get(e):"number"==typeof e?e:1}const R=u.Milliseconds(6.5),P=u.Milliseconds(1),A=u.Milliseconds(30),S=u.Milliseconds(1e3/30),p=u.Milliseconds(100),L=.9;var y,f;!function(s){class o{get updating(){return this._updating.value}_updatingChanged(){this._updating.value=this._tasks.some((e=>e.needsUpdate))}constructor(){this._updating=h.signal(!0),this._microTaskQueued=!1,this._frameNumber=0,this.performanceInfo={total:new a("total"),tasks:new Map},this._frameTaskTimes=new Map,this._budget=new I,this._state=E.RenderState.INTERACTING,this._tasks=new n,this._runQueue=new n,this._load=0,this._idleStateCallbacks=new n,this._idleUpdatesStartFired=!1,this._forceTask=!1,this._debug=!1,this._debugHandle=_.watch((()=>T.SCHEDULER_LOG_SLOW_TASKS),(e=>this._debug=e),_.initial);for(const t of Object.keys(e.TaskPriority))this.performanceInfo.tasks.set(e.TaskPriority[t],new a(e.TaskPriority[t]))}destroy(){this._tasks.toArray().forEach((e=>e.remove())),this._tasks.clear(),r.removeMaybe(this._debugHandle),this._microTaskQueued=!1,this._updatingChanged()}taskRunningChanged(e){this._updatingChanged(),e&&this._budget.remaining>0&&!this._microTaskQueued&&(this._microTaskQueued=!0,queueMicrotask((()=>{this._microTaskQueued&&(this._microTaskQueued=!1,this._budget.remaining>0&&this._schedule()&&this.frame())})))}registerTask(e,t){const s=new c(this,e,t);return this._tasks.push(s),this._updatingChanged(),this.performanceInfo.tasks.has(e)||this.performanceInfo.tasks.set(e,new a(e)),s}registerIdleStateCallbacks(e,t){const s={idleBegin:e,idleEnd:t};this._idleStateCallbacks.push(s),this.state===E.RenderState.IDLE&&this._idleUpdatesStartFired&&s.idleBegin();const i=this;return{remove:()=>this._removeIdleStateCallbacks(s),set idleBegin(e){i._idleUpdatesStartFired&&(s.idleEnd(),i._state===E.RenderState.IDLE&&e()),s.idleBegin=e},set idleEnd(e){s.idleEnd=e}}}get load(){return this._load}set state(e){this._state!==e&&(this._state=e,this.state!==E.RenderState.IDLE&&this._idleUpdatesStartFired&&(this._idleUpdatesStartFired=!1,this._idleStateCallbacks.forAll((e=>e.idleEnd()))))}get state(){return this._state}updateBudget(e){this._test&&(this._test.usedBudget=0),++this._frameNumber;let t=R,s=e.frameDuration,i=P;switch(this.state){case E.RenderState.IDLE:t=u.Milliseconds(0),s=u.Milliseconds(Math.max(p,e.frameDuration)),i=A;break;case E.RenderState.INTERACTING:s=u.Milliseconds(Math.max(S,e.frameDuration));case E.RenderState.ANIMATING:}return s=u.Milliseconds(s-e.elapsedFrameTime-t),this.state!==E.RenderState.IDLE&&s<P&&!this._forceTask?(this._forceTask=!0,!1):(s=u.Milliseconds(Math.max(s,i)),this._budget.reset(s,this.state),this._updateLoad(),this._schedule())}frame(){switch(this._forceTask=!1,this._microTaskQueued=!1,this.state){case E.RenderState.IDLE:this._idleUpdatesStartFired||(this._idleUpdatesStartFired=!0,this._idleStateCallbacks.forAll((e=>e.idleBegin()))),this._runIdle();break;case E.RenderState.INTERACTING:this._runInteracting();break;default:this._runAnimating()}this._test&&(this._test.usedBudget=this._budget.elapsed)}stopFrame(){this._budget.reset(u.Milliseconds(0),this._state),this._budget.madeProgress()}_removeIdleStateCallbacks(e){this._idleUpdatesStartFired&&e.idleEnd(),this._idleStateCallbacks.removeUnordered(e)}removeTask(e){this._tasks.removeUnordered(e),this._runQueue.removeUnordered(e),this._updatingChanged()}_updateTask(e){this._tasks.forAll((t=>{t.name===e&&t.setPriority(e)}))}_getState(t){if(this._runQueue.some((e=>e.name===t)))return e.TaskState.SCHEDULED;let s=e.TaskState.IDLE;return this._tasks.forAll((i=>{i.name===t&&i.needsUpdate&&(i.schedulePriority<=1?s=e.TaskState.READY:s!==e.TaskState.READY&&(s=e.TaskState.WAITING))})),s}_getRuntime(e){let t=0;return this._tasks.forAll((s=>{s.name===e&&(t+=s.runtime)})),t}_resetRuntimes(){this._tasks.forAll((e=>e.runtime=0))}_getRunning(){const e=new Map;if(this._tasks.forAll((t=>{t.needsUpdate&&e.set(t.name,(e.get(t.name)||0)+1)})),0===e.size)return null;let t="";return e.forEach(((e,s)=>{t+=e>1?` ${e}x ${s}`:` ${s}`})),t}_runIdle(){this._run()}_runInteracting(){this._run()}_runAnimating(){this._run()}_updateLoad(){const e=this._tasks.reduce(((e,t)=>t.needsUpdate?++e:e),0);this._load=this._load*L+e*(1-L)}_schedule(){for(this._runQueue.filterInPlace((e=>!!e.needsUpdate||(e.schedulePriority=e.basePriority,!1))),this._tasks.forAll((e=>{e.basePriority===g&&e.needsUpdate&&!this._runQueue.includes(e)&&e.blockFrame!==this._frameNumber&&this._runQueue.unshift(e)}));0===this._runQueue.length;){let e=!1,t=0;if(this._tasks.forAll((s=>{if(s.needsUpdate&&0!==s.schedulePriority&&s.basePriority!==g&&s.blockFrame!==this._frameNumber)if(e=!0,t=Math.max(t,s.basePriority),1===s.schedulePriority)s.schedulePriority=0,this._runQueue.push(s);else--s.schedulePriority})),!e)return this._updatingChanged(),!1}return this._updatingChanged(),!0}_run(){const t=this._budget.now();this._startFrameTaskTimes();do{for(;this._runQueue.length>0;){const r=this._budget.now(),a=this._runQueue.pop();this._budget.resetProgress();try{a.task.runTask(this._budget)===l.Yield&&(a.blockFrame=this._frameNumber)}catch(s){i.getLogger("esri.views.support.Scheduler").error(`Exception in task "${a.name}"`,s),a.blockFrame=this._frameNumber}!this._budget.hasProgressed&&a.blockFrame!==this._frameNumber&&a.needsUpdate&&(a.name,e.TaskPriority.I3S_CONTROLLER,a.blockFrame=this._frameNumber),a.schedulePriority=a.basePriority;const n=this._budget.now()-r;if(a.runtime+=n,this._frameTaskTimes.set(a.priority,this._frameTaskTimes.get(a.priority)+n),this._budget.remaining<=0)return this._updatingChanged(),void this._recordFrameTaskTimes(this._budget.now()-t)}}while(this._schedule());this._updatingChanged(),this._recordFrameTaskTimes(this._budget.now()-t)}_startFrameTaskTimes(){for(const t of Object.keys(e.TaskPriority))this._frameTaskTimes.set(e.TaskPriority[t],0)}_recordFrameTaskTimes(e){this._frameTaskTimes.forEach(((e,t)=>this.performanceInfo.tasks.get(t).push(e))),this.performanceInfo.total.push(e)}get test(){return this._test}}s.Scheduler=o;class c{get task(){return this._task.value}get updating(){return this._queue.running}constructor(e,s,i){this._scheduler=e,this.name=s,this.blockFrame=0,this.runtime=0,this._queue=new d.PromiseQueue,this._handles=new t,this._basePriority=k(s),this.schedulePriority=this._basePriority,this._task=h.signal(null!=i?i:this._queue),this._handles.add(_.when((()=>this.task.running),(t=>e.taskRunningChanged(t))))}remove(){this.processQueue(N),this._scheduler.removeTask(this),this.schedule=O.schedule,this.reschedule=O.reschedule,this._handles.destroy()}get basePriority(){return this._basePriority}setPriority(e){if(this.name===e)return;this.name=e;const t=k(e);this._basePriority!==g&&0===this.schedulePriority||(this.schedulePriority=t),this._basePriority=t}get priority(){return this.name}set priority(e){this.setPriority(e)}get needsUpdate(){return this.updating||this.task.running}schedule(e,t,s){return this._queue.push(e,t,s)}reschedule(e,t,s){return this._queue.unshift(e,t,s)}processQueue(e){return this._queue.runTask(e)}}class I{constructor(){this._begin="undefined"!=typeof performance?performance.now():0,this._budget=0,this._state=E.RenderState.IDLE,this._done=!1,this._progressed=!1,this._enabled=!0}run(e){return!this.done&&(!0===e()&&this.madeProgress(),!0)}get done(){return this._done}get budget(){return this._budget}madeProgress(){return this._progressed=!0,this._done=this.elapsed>=this._budget&&this._enabled,this._done}get state(){return this._state}get enabled(){return this._enabled}set enabled(e){this._enabled=e}reset(e,t){this._begin=this.now(),this._budget=e,this._state=t,this.resetProgress()}get remaining(){return Math.max(this._budget-this.elapsed,0)}now(){return performance.now()}get elapsed(){return this.now()-this._begin}resetProgress(){this._progressed=!1,this._done=!1}get hasProgressed(){return this._progressed}}s.Budget=I}(y||(y={})),e.TaskState=void 0,(f=e.TaskState||(e.TaskState={})).SCHEDULED="s",f.READY="r",f.WAITING="w",f.IDLE="i";const N=(()=>{const e=new y.Budget;return e.enabled=!1,e})();class b{remove(){}processQueue(){}schedule(e,t,s){try{if(o.isAborted(t)){const e=o.createAbortError();return s?Promise.resolve(s(e)):Promise.reject(e)}return o.when(e(N))}catch(i){return Promise.reject(i)}}reschedule(e,t,s){return this.schedule(e,t,s)}}const O=new b;e.ImmediateTask=O,e.getTaskPriority=k,e.newScheduler=c,e.noBudget=N,e.taskPriorities=m,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
