/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../intl","../../core/Accessor","../../core/arrayUtils","../../core/Evented","../../core/handleUtils","../../core/reactiveUtils","../../core/accessorSupport/decorators/property","../../core/accessorSupport/decorators/cast","../../core/has","../../core/accessorSupport/decorators/subclass","../../support/themeUtils","./Component","../../widgets/support/widgetUtils","../../intl/locale"],(function(t,e,n,o,i,r,s,a,d,p,c,l,h,m,u){"use strict";const _={left:0,top:0,bottom:0,right:0},f={bottom:30,top:15,right:15,left:15},g="esri-ui",y={ui:g,corner:`${g}-corner`,innerContainer:`${g}-inner-container`,manualContainer:`${g}-manual-container`,cornerContainer:`${g}-corner-container`,topLeft:`${g}-top-left`,topRight:`${g}-top-right`,bottomLeft:`${g}-bottom-left`,bottomRight:`${g}-bottom-right`};function C(t){return t&&!t._started&&"function"==typeof t.postMixInProperties&&"function"==typeof t.buildRendering&&"function"==typeof t.postCreate&&"function"==typeof t.startup}function v(t){return 0===t?"0":`${t}px`}function b(t){const e="object"==typeof t&&null!==t&&Object.getPrototypeOf(t);return(null===e||e===Object.prototype)&&("component"in t||"index"in t||"position"in t)?t:null}function w(t,{top:e,bottom:n,left:o,right:i}){t.style.top=e,t.style.bottom=n,t.style.left=o,t.style.right=i}let L=class extends i.EventedAccessor{constructor(t){super(t),this._cornerNameToContainerLookup={},this._positionNameToContainerLookup={},this._components=new Array,this._componentMap=new Map,this._removeWidgetHandleKey=Symbol("componentOnRemoveSymbol"),this._locale=u.getLocale(),this.view=null,this._applyViewPadding=()=>{const t=this.container;t&&w(t,this._toPixelPosition(this._getViewPadding()))},this._applyUIPadding=()=>{const t=this._innerContainer;t&&w(t,this._toPixelPosition(this.padding))},this._initContainers()}initialize(){this.addHandles([s.watch((()=>[this.view?.padding,this.container]),this._applyViewPadding,s.initial),s.watch((()=>this.padding),this._applyUIPadding,s.initial),s.watch((()=>[this.container,this._locale]),(([t,e])=>{t&&t.setAttribute("lang",e)}),s.initial),u.onLocaleChange((t=>{this._locale=t}))])}destroy(){this.container=null;for(const t of this._components)t.destroy();this._components.length=0,this._componentMap.clear()}set container(t){const e=this._get("container");t!==e&&(t&&(t.classList.add(y.ui),l.setCalciteThemeClass(t),this._attachContainers(t)),e&&(e.classList.remove(y.ui),w(e,{top:"",bottom:"",left:"",right:""}),e.textContent=""),this._set("container",t))}get height(){const t=this.view?.height??0;if(0===t)return t;const e=this._getViewPadding(),{top:n,bottom:o}=e;return Math.max(t-n-o,0)}get padding(){return this._get("padding")}set padding(t){this._overrideIfSome("padding",t)}castPadding(t){return"number"==typeof t?{bottom:t,top:t,right:t,left:t}:{...f,...t}}get width(){const t=this.view?.width??0;if(0===t)return t;const e=this._getViewPadding(),{left:n,right:o}=e;return Math.max(t-n-o,0)}add(t,e){let n,o,i;if(Array.isArray(t))return void t.forEach((t=>this.add(t,e)));const r=b(t);r&&({index:n,position:e,component:t,key:o}=r),e&&"object"==typeof e&&({index:n,key:o,position:e,internal:i}=e),!t||e&&!this._isValidPosition(e)||this._add(t,e,n,o,i)}remove(t,e){if(!t)return;if(Array.isArray(t))return t.map((t=>this.remove(t,e)));const n=this._find(t);if(n){if(this._componentMap.has(n)&&this._componentMap.get(n)?.key!==e)return;const t=this._components.indexOf(n),o=n.node.parentNode;return o?.removeChild(n.node),this._componentMap.delete(n),n.widget?.removeHandlesReference(this._removeWidgetHandleKey),this._components.splice(t,1)[0]}}empty(t,e={removeInternal:!1}){if(Array.isArray(t)){for(const n of t)this.empty(n,e);return}const n=this._positionNameToContainerLookup[t??"manual"],o=Array.prototype.slice.call(n.children).map((t=>this._findByNode(t))).filter((t=>{if(null==t)return!1;return!(this._componentMap.get(t)?.internal??!1)||e.removeInternal}));for(const i of o)this.remove(i)}move(t,e){if(Array.isArray(t)&&t.forEach((t=>this.move(t,e))),!t)return;let n;const o=b(t)||b(e);if(o&&(n=o.index,e=o.position,t=o.component||t),e&&!this._isValidPosition(e))return;const i=this.remove(t);i&&this.add(i,{position:e,index:n})}find(t){if(!t)return null;const e=this._findById(t);return e&&(e.widget||e.node)}getComponents(t,e={includeInternal:!1}){return t?Array.isArray(t)?t.flatMap((t=>this._getComponentsAtPosition(t,e))):this._getComponentsAtPosition(t,e):this._components.filter((t=>e.includeInternal||!this._componentMap.get(t)?.internal)).map((({widget:t,node:e})=>t??e))}getPosition(t){for(const e in this._positionNameToContainerLookup){if(this._positionNameToContainerLookup[e].contains(t))return e}return null}_add(t,e,o,i,s){t instanceof h||(t=new h({node:t}));const{widget:a}=t;null!=a&&a instanceof n&&a.addHandles(r.makeHandle((()=>{queueMicrotask((()=>this.remove(t)))})),this._removeWidgetHandleKey),this._place({component:t,position:e,index:o}),this._components.push(t),this._componentMap.set(t,{key:i,internal:s})}_find(t){return t?t instanceof h?this._findByComponent(t):"string"==typeof t?this._findById(t):this._findByNode(t.domNode||t):null}_getViewPadding(){return this.view?.padding??_}_attachContainers(t){t.appendChild(this._innerContainer),t.appendChild(this._manualContainer)}_initContainers(){const t=document.createElement("div");t.classList.add(y.innerContainer,y.cornerContainer);const e=document.createElement("div");e.classList.add(y.innerContainer,y.manualContainer);const n=document.createElement("div");n.classList.add(y.topLeft,y.corner),t.appendChild(n);const o=document.createElement("div");o.classList.add(y.topRight,y.corner),t.appendChild(o);const i=document.createElement("div");i.classList.add(y.bottomLeft,y.corner),t.appendChild(i);const r=document.createElement("div");r.classList.add(y.bottomRight,y.corner),t.appendChild(r),this._innerContainer=t,this._manualContainer=e;const s=m.isRTL();this._cornerNameToContainerLookup={"top-left":n,"top-right":o,"bottom-left":i,"bottom-right":r,"top-leading":s?o:n,"top-trailing":s?n:o,"bottom-leading":s?r:i,"bottom-trailing":s?i:r},this._positionNameToContainerLookup={manual:e,...this._cornerNameToContainerLookup}}_isValidPosition(t){return!!this._positionNameToContainerLookup[t]}_place(t){const e=t.position??"manual",{component:n,index:o}=t,i=this._positionNameToContainerLookup[e],r=null!=o&&o>-1;if(C(n.widget)&&n.widget.startup(),!r)return void i.appendChild(n.node);const s=Array.from(i.children);if(0===o){const{firstChild:t}=i;return void(t?t.parentNode?.insertBefore(n.node,t):i.appendChild(n.node))}if(o>=s.length)return void i.appendChild(n.node);const a=s[o];a.parentNode?.insertBefore(n.node,a)}_toPixelPosition(t){return{top:v(t.top),left:v(t.left),right:v(t.right),bottom:v(t.bottom)}}_findByComponent(t){return this._components.find((e=>e===t))??null}_findById(t){return this._components.find((({id:e})=>e===t))??null}_findByNode(t){return this._components.find((({node:e})=>e===t))??null}_getComponentsAtPosition(t,e){const n=this._positionNameToContainerLookup[t];return Array.prototype.slice.call(n.children).map((t=>this._findByNode(t))).filter(o.isSome).filter((t=>e.includeInternal||!this._componentMap.get(t)?.internal)).map((({widget:t,node:e})=>t??e))}};t.__decorate([a.property()],L.prototype,"_locale",void 0),t.__decorate([a.property()],L.prototype,"container",null),t.__decorate([a.property()],L.prototype,"height",null),t.__decorate([a.property({value:f})],L.prototype,"padding",null),t.__decorate([d.cast("padding")],L.prototype,"castPadding",null),t.__decorate([a.property()],L.prototype,"view",void 0),t.__decorate([a.property()],L.prototype,"width",null),L=t.__decorate([c.subclass("esri.views.ui.UI")],L);return L}));
