/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../core/arrayUtils","../../core/has","../../core/Logger","../../core/typedArrayUtil","./checkWebGLError","./enums"],(function(e,t,i,r,s,n,f){"use strict";const a=()=>r.getLogger("esri.views.webgl.BufferObject"),u=null;class _{static createIndex(e,t,i){return new _(e,f.BufferType.ELEMENT_ARRAY_BUFFER,t,i)}static createVertex(e,t,i){return new _(e,f.BufferType.ARRAY_BUFFER,t,i)}static createUniform(e,t,i){return new _(e,f.BufferType.UNIFORM_BUFFER,t,i)}static createPixelPack(e,t=f.Usage.STREAM_READ,i){const r=new _(e,f.BufferType.PIXEL_PACK_BUFFER,t);return i&&r.setSize(i),r}static createPixelUnpack(e,t=f.Usage.STREAM_DRAW,i){return new _(e,f.BufferType.PIXEL_UNPACK_BUFFER,t,i)}static createTransformFeedback(e,t=f.Usage.STATIC_DRAW,i){const r=new _(e,f.BufferType.TRANSFORM_FEEDBACK_BUFFER,t);return r.setSize(i),r}constructor(e,t,i,r){this._context=e,this.bufferType=t,this.usage=i,this._glName=null,this._size=-1,this._indexType=void 0,e.instanceCounter.increment(f.ResourceType.BufferObject,this),this._glName=this._context.gl.createBuffer(),n.checkWebGLError(this._context.gl),r&&this.setData(r)}get glName(){return this._glName}get size(){return this._size}get indexType(){return this._indexType}get usedMemory(){if(this.bufferType===f.BufferType.ELEMENT_ARRAY_BUFFER){if(this._indexType===f.DataType.UNSIGNED_INT)return 4*this._size;if(this._indexType===f.DataType.UNSIGNED_SHORT)return 2*this._size}return this._size}get _isVAOAware(){return this.bufferType===f.BufferType.ELEMENT_ARRAY_BUFFER||this.bufferType===f.BufferType.ARRAY_BUFFER}dispose(){if(this._context?.gl){if(this._glName){this._context.gl.deleteBuffer(this._glName),this._glName=null}this._context.instanceCounter.decrement(f.ResourceType.BufferObject,this),this._context=null}else this._glName&&a().warn("Leaked WebGL buffer object")}setSize(e,t=null){if(this.bufferType===f.BufferType.ELEMENT_ARRAY_BUFFER&&null!=t)switch(this._indexType=t,t){case f.DataType.UNSIGNED_SHORT:e*=2;break;case f.DataType.UNSIGNED_INT:e*=4}this._setBufferData(e)}setData(e){if(!e)return;let t=e.byteLength;this.bufferType===f.BufferType.ELEMENT_ARRAY_BUFFER&&(s.isUint8Array(e)?this._indexType=f.DataType.UNSIGNED_BYTE:s.isUint16Array(e)?(t/=2,this._indexType=f.DataType.UNSIGNED_SHORT):s.isUint32Array(e)&&(t/=4,this._indexType=f.DataType.UNSIGNED_INT)),this._setBufferData(t,e)}_setBufferData(e,t=null){this._size=e;const i=this._context.getBoundVAO();this._isVAOAware&&this._context.bindVAO(null),this._context.bindBuffer(this);const r=this._context.gl;null!=t?r.bufferData(this.bufferType,t,this.usage):r.bufferData(this.bufferType,e,this.usage),n.checkWebGLError(r),this._isVAOAware&&this._context.bindVAO(i)}setSubData(e,t,i,r){if(!e)return;const s=this._context.getBoundVAO();this._isVAOAware&&this._context.bindVAO(null),this._context.bindBuffer(this);const{gl:f}=this._context;f.bufferSubData(this.bufferType,t*e.BYTES_PER_ELEMENT,e,i,r-i),n.checkWebGLError(f),this._isVAOAware&&this._context.bindVAO(s)}getSubData(e,t=0,i,r){if(i<0||r<0)return;const s=c(e)?e.BYTES_PER_ELEMENT:1;if(s*((i??0)+(r??0))>e.byteLength)return;t+s*(r??0)>this.usedMemory&&a().warn("Potential problem getting subdata: requested data exceeds buffer size!");const n=this._context.gl;this.bufferType===f.BufferType.TRANSFORM_FEEDBACK_BUFFER?(this._context.bindBuffer(this,f.BufferType.TRANSFORM_FEEDBACK_BUFFER),n.getBufferSubData(f.BufferType.TRANSFORM_FEEDBACK_BUFFER,t,e,i,r),this._context.unbindBuffer(f.BufferType.TRANSFORM_FEEDBACK_BUFFER)):(this._context.bindBuffer(this,f.BufferType.COPY_READ_BUFFER),n.getBufferSubData(f.BufferType.COPY_READ_BUFFER,t,e,i,r),this._context.unbindBuffer(f.BufferType.COPY_READ_BUFFER))}async getSubDataAsync(e,t=0,i,r){await this._context.clientWaitAsync(),this.getSubData(e,t,i,r)}}function c(e){return t.isArrayLike(e)}e.BufferObject=_,e.tracer=u,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
