/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../core/has","./checkWebGLError","./enums","./ShaderTranspiler"],(function(t,e,n,o,i){"use strict";const r=4294967295;class s{constructor(t,e,s,h,m=new Map,f=[]){this._context=t,this._locations=h,this._uniformBlockBindings=m,this._transformFeedbackVaryings=f,this._refCount=1,this._compiled=!1,this._linesOfCode=0,this._nameToUniformLocation=new Map,this._nameToUniform1=new Map,this._nameToUniform1v=new Map,this._nameToUniform2=new Map,this._nameToUniform3=new Map,this._nameToUniform4=new Map,this._nameToUniformMatrix3=new Map,this._nameToUniformMatrix4=new Map,t||console.error("RenderingContext isn't initialized!"),0===e.length&&console.error("Shaders source should not be empty!"),e=i.transpileShader(e,o.ShaderType.VERTEX_SHADER),s=i.transpileShader(s,o.ShaderType.FRAGMENT_SHADER),this._vShader=a(this._context,o.ShaderType.VERTEX_SHADER,e),this._fShader=a(this._context,o.ShaderType.FRAGMENT_SHADER,s),c.enabled&&(this._linesOfCode=e.match(/\n/g).length+s.match(/\n/g).length+2,this._context.instanceCounter.increment(o.ResourceType.LinesOfCode,this._vShader,this._linesOfCode)),this._vShader&&this._fShader||console.error("Error loading shaders!"),this._context.instanceCounter.increment(o.ResourceType.Shader,this),n.webglValidateShadersEnabled()&&(this.vertexShader=e,this.fragmentShader=s),this.usedMemory=e.length+s.length;const _=this._context.gl,l=_.createProgram();_.attachShader(l,this._vShader),_.attachShader(l,this._fShader),this._locations.forEach(((t,e)=>_.bindAttribLocation(l,t,e))),this._transformFeedbackVaryings?.length&&_.transformFeedbackVaryings(l,this._transformFeedbackVaryings,_.SEPARATE_ATTRIBS),_.linkProgram(l),n.webglValidateShadersEnabled()&&!_.getProgramParameter(l,_.LINK_STATUS)&&console.error(`Could not link shader\nvalidated: ${_.getProgramParameter(l,_.VALIDATE_STATUS)}, gl error ${_.getError()}, vertex: ${_.getShaderParameter(this._vShader,_.COMPILE_STATUS)}, fragment: ${_.getShaderParameter(this._fShader,_.COMPILE_STATUS)}, info log: ${_.getProgramInfoLog(l)}, vertex source: ${this.vertexShader}, fragment source: ${this.fragmentShader}`);for(const[n,o]of this._uniformBlockBindings){const t=_.getUniformBlockIndex(l,n);t<r&&_.uniformBlockBinding(l,t,o)}this._glName=l,this._context.instanceCounter.increment(o.ResourceType.Program,this)}get glName(){return this._glName}get hasGLName(){return null!=this._glName}get hasTransformFeedbackVaryings(){return!!this._transformFeedbackVaryings?.length}get compiled(){if(this._compiled)return!0;const t=this._context.gl.getExtension("KHR_parallel_shader_compile");return null==t||null==this.glName?(this._compiled=!0,!0):(this._compiled=!!this._context.gl.getProgramParameter(this.glName,t.COMPLETION_STATUS_KHR),this._compiled)}dispose(){if(--this._refCount>0)return;const t=this._context.gl,e=this._context.instanceCounter;this._nameToUniformLocation.forEach((t=>t&&e.decrement(o.ResourceType.Uniform,t))),this._nameToUniformLocation.clear(),this._vShader&&(this._linesOfCode>0&&(e.decrement(o.ResourceType.LinesOfCode,this._vShader,this._linesOfCode),this._linesOfCode=0),t.deleteShader(this._vShader),this._vShader=null,e.decrement(o.ResourceType.Shader,this)),this._fShader&&(t.deleteShader(this._fShader),this._fShader=null),this._glName&&(t.deleteProgram(this._glName),this._glName=null,e.decrement(o.ResourceType.Program,this))}ref(){++this._refCount}_getUniformLocation(t){const e=this._nameToUniformLocation.get(t);if(void 0!==e)return e;if(this.glName){const e=this._context.gl.getUniformLocation(this.glName,t);return this._nameToUniformLocation.set(t,e),e&&this._context.instanceCounter.increment(o.ResourceType.Uniform,e),e}return null}hasUniform(t){return null!=this._getUniformLocation(t)}setUniform1i(t,e){const n=this._nameToUniform1.get(t);void 0!==n&&e===n||(this._context.gl.uniform1i(this._getUniformLocation(t),e),this._nameToUniform1.set(t,e))}setUniform1iv(t,e){f(this._nameToUniform1v,t,e)&&this._context.gl.uniform1iv(this._getUniformLocation(t),e)}setUniform2iv(t,e){f(this._nameToUniform2,t,e)&&this._context.gl.uniform2iv(this._getUniformLocation(t),e)}setUniform3iv(t,e){f(this._nameToUniform3,t,e)&&this._context.gl.uniform3iv(this._getUniformLocation(t),e)}setUniform4iv(t,e){f(this._nameToUniform4,t,e)&&this._context.gl.uniform4iv(this._getUniformLocation(t),e)}setUniform1f(t,e){const n=this._nameToUniform1.get(t);void 0!==n&&e===n||(this._context.gl.uniform1f(this._getUniformLocation(t),e),this._nameToUniform1.set(t,e))}setUniform1fv(t,e){f(this._nameToUniform1v,t,e)&&this._context.gl.uniform1fv(this._getUniformLocation(t),e)}setUniform2f(t,e,n){const o=this._nameToUniform2.get(t);void 0===o?(this._context.gl.uniform2f(this._getUniformLocation(t),e,n),this._nameToUniform2.set(t,[e,n])):e===o[0]&&n===o[1]||(this._context.gl.uniform2f(this._getUniformLocation(t),e,n),o[0]=e,o[1]=n)}setUniform2fv(t,e){f(this._nameToUniform2,t,e)&&this._context.gl.uniform2fv(this._getUniformLocation(t),e)}setUniform3f(t,e,n,o){const i=this._nameToUniform3.get(t);void 0===i?(this._context.gl.uniform3f(this._getUniformLocation(t),e,n,o),this._nameToUniform3.set(t,[e,n,o])):e===i[0]&&n===i[1]&&o===i[2]||(this._context.gl.uniform3f(this._getUniformLocation(t),e,n,o),i[0]=e,i[1]=n,i[2]=o)}setUniform3fv(t,e){const n=this._getUniformLocation(t);null!=n&&f(this._nameToUniform3,t,e)&&this._context.gl.uniform3fv(n,e)}setUniform4f(t,e,n,o,i){const r=this._nameToUniform4.get(t);void 0===r?(this._context.gl.uniform4f(this._getUniformLocation(t),e,n,o,i),this._nameToUniform4.set(t,[e,n,o,i])):void 0!==r&&e===r[0]&&n===r[1]&&o===r[2]&&i===r[3]||(this._context.gl.uniform4f(this._getUniformLocation(t),e,n,o,i),r[0]=e,r[1]=n,r[2]=o,r[3]=i)}setUniform4fv(t,e){const n=this._getUniformLocation(t);null!=n&&f(this._nameToUniform4,t,e)&&this._context.gl.uniform4fv(n,e)}setUniformMatrix3fv(t,e,n=!1){const o=this._getUniformLocation(t);null!=o&&f(this._nameToUniformMatrix3,t,e)&&this._context.gl.uniformMatrix3fv(o,n,e)}setUniformMatrix4fv(t,e,n=!1){const o=this._getUniformLocation(t);null!=o&&f(this._nameToUniformMatrix4,t,e)&&this._context.gl.uniformMatrix4fv(o,n,e)}stop(){}}function a(t,e,i){const r=t.gl,s=r.createShader(e);return r.shaderSource(s,i),r.compileShader(s),n.webglValidateShadersEnabled()&&!r.getShaderParameter(s,r.COMPILE_STATUS)&&(console.error("Compile error in ".concat(e===o.ShaderType.VERTEX_SHADER?"vertex":"fragment"," shader")),console.error(r.getShaderInfoLog(s)),console.error(h(i))),s}function h(t){let e=2;return t.replaceAll("\n",(()=>"\n"+m(e++)+":"))}function m(t){return t>=1e3?t.toString():("  "+t).slice(-3)}function f(t,e,n){const o=t.get(e);if(!o)return t.set(e,Array.from(n)),!0;const i=n.length;if(o.length!==i)return t.set(e,Array.from(n)),!0;for(let r=0;r<i;++r){const t=n[r];if(o[r]!==t){for(o[r]=t;r<i;++r)o[r]=n[r];return!0}}return!1}const c={enabled:!1};t.Program=s,t.test=c,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
