/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../core/has","./enums","./reservedWordsGLSL3","./testUtils"],(function(e,t,r,a,n){"use strict";const o=["precision","highp","mediump","lowp","attribute","const","uniform","varying","break","continue","do","for","while","if","else","in","out","inout","float","int","void","bool","true","false","discard","return","mat2","mat3","mat4","vec2","vec3","vec4","ivec2","ivec3","ivec4","bvec2","bvec3","bvec4","sampler1D","sampler2D","sampler3D","samplerCube","sampler1DShadow","sampler2DShadow","struct","asm","class","union","enum","typedef","template","this","packed","goto","switch","default","inline","noinline","volatile","public","static","extern","external","interface","long","short","double","half","fixed","unsigned","input","output","hvec2","hvec3","hvec4","dvec2","dvec3","dvec4","fvec2","fvec3","fvec4","sampler2DRect","sampler3DRect","sampler2DRectShadow","sizeof","cast","namespace","using"],i=["<<=",">>=","++","--","<<",">>","<=",">=","==","!=","&&","||","+=","-=","*=","/=","%=","&=","^^","^=","|=","(",")","[","]",".","!","~","*","/","%","+","-","<",">","&","^","|","?",":","=",",",";","{","}"],l=["abs","acos","all","any","asin","atan","ceil","clamp","cos","cross","dFdx","dFdy","degrees","distance","dot","equal","exp","exp2","faceforward","floor","fract","gl_BackColor","gl_BackLightModelProduct","gl_BackLightProduct","gl_BackMaterial","gl_BackSecondaryColor","gl_ClipPlane","gl_ClipVertex","gl_Color","gl_DepthRange","gl_DepthRangeParameters","gl_EyePlaneQ","gl_EyePlaneR","gl_EyePlaneS","gl_EyePlaneT","gl_Fog","gl_FogCoord","gl_FogFragCoord","gl_FogParameters","gl_FragColor","gl_FragCoord","gl_FragData","gl_FragDepth","gl_FragDepthEXT","gl_FrontColor","gl_FrontFacing","gl_FrontLightModelProduct","gl_FrontLightProduct","gl_FrontMaterial","gl_FrontSecondaryColor","gl_LightModel","gl_LightModelParameters","gl_LightModelProducts","gl_LightProducts","gl_LightSource","gl_LightSourceParameters","gl_MaterialParameters","gl_MaxClipPlanes","gl_MaxCombinedTextureImageUnits","gl_MaxDrawBuffers","gl_MaxFragmentUniformComponents","gl_MaxLights","gl_MaxTextureCoords","gl_MaxTextureImageUnits","gl_MaxTextureUnits","gl_MaxVaryingFloats","gl_MaxVertexAttribs","gl_MaxVertexTextureImageUnits","gl_MaxVertexUniformComponents","gl_ModelViewMatrix","gl_ModelViewMatrixInverse","gl_ModelViewMatrixInverseTranspose","gl_ModelViewMatrixTranspose","gl_ModelViewProjectionMatrix","gl_ModelViewProjectionMatrixInverse","gl_ModelViewProjectionMatrixInverseTranspose","gl_ModelViewProjectionMatrixTranspose","gl_MultiTexCoord0","gl_MultiTexCoord1","gl_MultiTexCoord2","gl_MultiTexCoord3","gl_MultiTexCoord4","gl_MultiTexCoord5","gl_MultiTexCoord6","gl_MultiTexCoord7","gl_Normal","gl_NormalMatrix","gl_NormalScale","gl_ObjectPlaneQ","gl_ObjectPlaneR","gl_ObjectPlaneS","gl_ObjectPlaneT","gl_Point","gl_PointCoord","gl_PointParameters","gl_PointSize","gl_Position","gl_ProjectionMatrix","gl_ProjectionMatrixInverse","gl_ProjectionMatrixInverseTranspose","gl_ProjectionMatrixTranspose","gl_SecondaryColor","gl_TexCoord","gl_TextureEnvColor","gl_TextureMatrix","gl_TextureMatrixInverse","gl_TextureMatrixInverseTranspose","gl_TextureMatrixTranspose","gl_Vertex","greaterThan","greaterThanEqual","inversesqrt","length","lessThan","lessThanEqual","log","log2","matrixCompMult","max","min","mix","mod","normalize","not","notEqual","pow","radians","reflect","refract","sign","sin","smoothstep","sqrt","step","tan","texture2D","texture2DLod","texture2DProj","texture2DProjLod","textureCube","textureCubeLod","texture2DLodEXT","texture2DProjLodEXT","textureCubeLodEXT","texture2DGradEXT","texture2DProjGradEXT","textureCubeGradEXT","textureSize","texelFetch"];var s=999,c=9999,d=0,u=1,g=2,p=3,f=4,h=5,_=6,x=7,y=8,m=9,w=10,M=11,T=["block-comment","line-comment","preprocessor","operator","integer","float","ident","builtin","keyword","whitespace","eof","integer"];function v(){var e,t,r,a=0,n=0,v=s,b=[],P=[],E=1,C=0,k=0,D=!1,S=!1,j="";return function(e){return P=[],null!==e?L(e.replace?e.replace(/\r\n/g,"\n"):e):R()};function F(e){e.length&&P.push({type:T[v],data:e,position:k,line:E,column:C})}function L(t){var o;for(a=0,r=(j+=t).length;e=j[a],a<r;){switch(o=a,v){case d:a=I();break;case u:a=G();break;case g:a=A();break;case p:a=O();break;case f:a=B();break;case M:a=q();break;case h:a=H();break;case c:a=N();break;case m:a=X();break;case s:a=V()}if(o!==a)if("\n"===j[o])C=0,++E;else++C}return n+=a,j=j.slice(a),P}function R(e){return b.length&&F(b.join("")),v=w,F("(eof)"),P}function V(){return b=b.length?[]:b,"/"===t&&"*"===e?(k=n+a-1,v=d,t=e,a+1):"/"===t&&"/"===e?(k=n+a-1,v=u,t=e,a+1):"#"===e?(v=g,k=n+a,a):/\s/.test(e)?(v=m,k=n+a,a):(D=/\d/.test(e),S=/[^\w_]/.test(e),k=n+a,v=D?f:S?p:c,a)}function X(){return/[^\s]/g.test(e)?(F(b.join("")),v=s,a):(b.push(e),t=e,a+1)}function A(){return"\r"!==e&&"\n"!==e||"\\"===t?(b.push(e),t=e,a+1):(F(b.join("")),v=s,a)}function G(){return A()}function I(){return"/"===e&&"*"===t?(b.push(e),F(b.join("")),v=s,a+1):(b.push(e),t=e,a+1)}function O(){if("."===t&&/\d/.test(e))return v=h,a;if("/"===t&&"*"===e)return v=d,a;if("/"===t&&"/"===e)return v=u,a;if("."===e&&b.length){for(;U(b););return v=h,a}if(";"===e||")"===e||"("===e){if(b.length)for(;U(b););return F(e),v=s,a+1}var r=2===b.length&&"="!==e;if(/[\w_\d\s]/.test(e)||r){for(;U(b););return v=s,a}return b.push(e),t=e,a+1}function U(e){for(var t,r,a=0;;){if(t=i.indexOf(e.slice(0,e.length+a).join("")),r=i[t],-1===t){if(a--+e.length>0)continue;r=e.slice(0,1).join("")}return F(r),k+=r.length,(b=b.slice(r.length)).length}}function q(){return/[^a-fA-F0-9]/.test(e)?(F(b.join("")),v=s,a):(b.push(e),t=e,a+1)}function B(){return"."===e||/[eE]/.test(e)?(b.push(e),v=h,t=e,a+1):"x"===e&&1===b.length&&"0"===b[0]?(v=M,b.push(e),t=e,a+1):/[^\d]/.test(e)?(F(b.join("")),v=s,a):(b.push(e),t=e,a+1)}function H(){return"f"===e&&(b.push(e),t=e,a+=1),/[eE]/.test(e)||"-"===e&&/[eE]/.test(t)?(b.push(e),t=e,a+1):/[^\d]/.test(e)?(F(b.join("")),v=s,a):(b.push(e),t=e,a+1)}function N(){if(/[^\d\w_]/.test(e)){var r=b.join("");return v=o.indexOf(r)>-1?y:l.indexOf(r)>-1?x:_,F(b.join("")),v=s,a}return b.push(e),t=e,a+1}}function b(e){var t=v(),r=[];return r=(r=r.concat(t(e))).concat(t(null))}function P(e){return b(e)}function E(e){return e.map((e=>"eof"!==e.type?e.data:"")).join("")}const C=new Set(["GL_OES_standard_derivatives","GL_EXT_frag_depth","GL_EXT_draw_buffers","GL_EXT_shader_texture_lod"]);function k(e,t="100",r="300 es"){const a=/^\s*#version\s+([0-9]+(\s+[a-zA-Z]+)?)\s*/;for(const n of e)if("preprocessor"===n.type){const e=a.exec(n.data);if(e){const a=e[1].replaceAll(/\s{2,}/g," ");if(a===r)return a;if(a===t)return n.data="#version "+r,t;throw new Error("unknown glsl version: "+a)}}return e.splice(0,0,{type:"preprocessor",data:"#version "+r},{type:"whitespace",data:"\n"}),null}function D(e,t){for(let r=t-1;r>=0;r--){const t=e[r];if("whitespace"!==t.type&&"block-comment"!==t.type){if("keyword"!==t.type)break;if("attribute"===t.data||"in"===t.data)return!0}}return!1}function S(e,t,r,a){a=a||r;for(const n of e)if("ident"===n.type&&n.data===r){a in t?t[a]++:t[a]=0;return S(e,t,a+"_"+t[a],a)}return r}function j(e,t,r="afterVersion"){function a(e,t){for(let r=t;r<e.length;r++){const t=e[r];if("operator"===t.type&&";"===t.data)return r}return null}function n(e){let t=-1,n=0,o=-1;for(let i=0;i<e.length;i++){const l=e[i];if("preprocessor"===l.type&&(/#(if|ifdef|ifndef)\s+.+/.test(l.data)?++n:/#endif\s*.*/.test(l.data)&&--n),"afterVersion"!==r&&"afterPrecision"!==r||"preprocessor"===l.type&&l.data.startsWith("#version")&&(o=Math.max(o,i)),"afterPrecision"===r&&"keyword"===l.type&&"precision"===l.data){const t=a(e,i);if(null===t)throw new Error("precision statement not followed by any semicolons!");o=Math.max(o,t)}t<o&&0===n&&(t=i)}return t+1}const o={data:"\n",type:"whitespace"},i=t=>t<e.length&&/[^\r\n]$/.test(e[t].data);let l=n(e);i(l-1)&&e.splice(l++,0,o);for(const s of t)e.splice(l++,0,s);i(l-1)&&i(l)&&e.splice(l,0,o)}function F(e,t,r,a="lowp"){j(e,[{type:"keyword",data:"out"},{type:"whitespace",data:" "},{type:"keyword",data:a},{type:"whitespace",data:" "},{type:"keyword",data:r},{type:"whitespace",data:" "},{type:"ident",data:t},{type:"operator",data:";"}],"afterPrecision")}function L(e,t,r,a,n="lowp"){j(e,[{type:"keyword",data:"layout"},{type:"operator",data:"("},{type:"keyword",data:"location"},{type:"whitespace",data:" "},{type:"operator",data:"="},{type:"whitespace",data:" "},{type:"integer",data:a.toString()},{type:"operator",data:")"},{type:"whitespace",data:" "},{type:"keyword",data:"out"},{type:"whitespace",data:" "},{type:"keyword",data:n},{type:"whitespace",data:" "},{type:"keyword",data:r},{type:"whitespace",data:" "},{type:"ident",data:t},{type:"operator",data:";"}],"afterPrecision")}function R(e,t){let r,a,n=-1;for(let o=t;o<e.length;o++){const t=e[o];if("operator"===t.type&&("["===t.data&&(r=o),"]"===t.data)){a=o;break}"integer"===t.type&&(n=parseInt(t.data,10))}return r&&a&&e.splice(r,a-r+1),n}function V(e,t){if(e.startsWith("#version 300"))return e;const n=A(e);if(null!=n)return n;const o=P(e);if("300 es"===k(o,"100","300 es"))return e;let i=null,l=null;const s={},c={};for(let d=0;d<o.length;++d){const e=o[d];switch(e.type){case"keyword":t===r.ShaderType.VERTEX_SHADER&&"attribute"===e.data?e.data="in":"varying"===e.data&&(e.data=t===r.ShaderType.VERTEX_SHADER?"out":"in");break;case"builtin":if(/^texture(2D|Cube)(Proj)?(Lod|Grad)?(EXT)?$/.test(e.data.trim())&&(e.data=e.data.replaceAll(/(2D|Cube|EXT)/g,"")),t===r.ShaderType.FRAGMENT_SHADER&&"gl_FragColor"===e.data&&(i||(i=S(o,s,"fragColor"),F(o,i,"vec4")),e.data=i),t===r.ShaderType.FRAGMENT_SHADER&&"gl_FragData"===e.data){const t=R(o,d+1),r=S(o,s,"fragData");L(o,r,"vec4",t,"mediump"),e.data=r}else t===r.ShaderType.FRAGMENT_SHADER&&"gl_FragDepthEXT"===e.data&&(l||(l=S(o,s,"gl_FragDepth")),e.data=l);break;case"ident":if(a.includes(e.data)){if(t===r.ShaderType.VERTEX_SHADER&&D(o,d))throw new Error("attribute in vertex shader uses a name that is a reserved word in glsl 300 es");e.data in c||(c[e.data]=S(o,s,e.data)),e.data=c[e.data]}}}for(let r=o.length-1;r>=0;--r){const e=o[r];if("preprocessor"===e.type){const t=e.data.match(/#extension\s+(.*):/);if(t?.[1]&&C.has(t[1].trim())){const e=o[r+1];o.splice(r,e&&"whitespace"===e.type?2:1)}const a=e.data.match(/#ifdef\s+(.*)/);a?.[1]&&C.has(a[1].trim())&&(e.data="#if 1");const n=e.data.match(/#ifndef\s+(.*)/);n?.[1]&&C.has(n[1].trim())&&(e.data="#if 0")}}return G(e,E(o))}const X=new Map;function A(e){return n.shaderTranspiler.enableCache?X.get(e):null}function G(e,t){return n.shaderTranspiler.enableCache&&X.set(e,t),t}e.transpileShader=V,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
