/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../core/has","./checkWebGLError","./enums","./getDataTypeBytes"],(function(e,r,t,a,i){"use strict";function o(e){const r=e.gl;switch(r.getError()){case r.NO_ERROR:return null;case r.INVALID_ENUM:return"An unacceptable value has been specified for an enumerated argument";case r.INVALID_VALUE:return"An unacceptable value has been specified for an argument";case r.INVALID_OPERATION:return"The specified command is not allowed for the current state";case r.INVALID_FRAMEBUFFER_OPERATION:return"The currently bound framebuffer is not framebuffer complete";case r.OUT_OF_MEMORY:return"Not enough memory is left to execute the command";case r.CONTEXT_LOST_WEBGL:return"WebGL context is lost"}return"Unknown error"}function s(e,r){return(e.vertexBuffers.get(r)?.usedMemory??0)/c(e.layout.get(r))}function c(e){return e[0].stride}function n(e,r,a,s,c=0){const n=e.gl;e.bindBuffer(a);for(const m of s){const a=r.get(m.name);if(null==a){console.warn(`There is no location for vertex attribute '${m.name}' defined.`);continue}const s=c*m.stride;if(m.count<=4)n.vertexAttribPointer(a,m.count,m.type,m.normalized,m.stride,m.offset+s),n.enableVertexAttribArray(a),m.divisor>0&&e.gl.vertexAttribDivisor(a,m.divisor);else if(9===m.count)for(let r=0;r<3;r++)n.vertexAttribPointer(a+r,3,m.type,m.normalized,m.stride,m.offset+12*r+s),n.enableVertexAttribArray(a+r),m.divisor>0&&e.gl.vertexAttribDivisor(a+r,m.divisor);else if(16===m.count)for(let r=0;r<4;r++)n.vertexAttribPointer(a+r,4,m.type,m.normalized,m.stride,m.offset+16*r+s),n.enableVertexAttribArray(a+r),m.divisor>0&&e.gl?.vertexAttribDivisor(a+r,m.divisor);else console.error("Unsupported vertex attribute element count: "+m.count);if(t.webglDebugEnabled()){const r=o(e),t=i.getDataTypeBytes(m.type),a=m.offset,c=Math.round(t/a)!==t/a?`. Offset not a multiple of stride. DataType requires ${t} bytes, but descriptor has an offset of ${a}`:"";r&&console.error(`Unable to bind vertex attribute "${m.name}" with baseInstanceOffset ${s}${c}:`,r,m)}}}function m(e,r,t,i){const o=e.gl;e.bindBuffer(t);for(const a of i){const t=r.get(a.name);if(a.count<=4)o.disableVertexAttribArray(t),a.divisor&&a.divisor>0&&e.gl?.vertexAttribDivisor(t,0);else if(9===a.count)for(let r=0;r<3;r++)o.disableVertexAttribArray(t+r),a.divisor&&a.divisor>0&&e.gl?.vertexAttribDivisor(t+r,0);else if(16===a.count)for(let r=0;r<4;r++)o.disableVertexAttribArray(t+r),a.divisor&&a.divisor>0&&e.gl?.vertexAttribDivisor(t+r,0);else console.error("Unsupported vertex attribute element count: "+a.count)}e.unbindBuffer(a.BufferType.ARRAY_BUFFER)}function l(e){switch(e){case a.PixelFormat.ALPHA:case a.PixelFormat.LUMINANCE:case a.PixelFormat.RED:case a.PixelFormat.RED_INTEGER:case a.SizedPixelFormat.R8:case a.SizedPixelFormat.R8I:case a.SizedPixelFormat.R8UI:case a.SizedPixelFormat.R8_SNORM:case a.RenderbufferFormat.STENCIL_INDEX8:return 1;case a.PixelFormat.LUMINANCE_ALPHA:case a.PixelFormat.RG:case a.PixelFormat.RG_INTEGER:case a.SizedPixelFormat.RGBA4:case a.SizedPixelFormat.R16F:case a.SizedPixelFormat.R16I:case a.SizedPixelFormat.R16UI:case a.SizedPixelFormat.RG8:case a.SizedPixelFormat.RG8I:case a.SizedPixelFormat.RG8UI:case a.SizedPixelFormat.RG8_SNORM:case a.SizedPixelFormat.RGB565:case a.SizedPixelFormat.RGB5_A1:case a.RenderbufferFormat.DEPTH_COMPONENT16:return 2;case a.PixelFormat.DEPTH_COMPONENT:case a.PixelFormat.RGB:case a.PixelFormat.RGB_INTEGER:case a.SizedPixelFormat.RGB8:case a.SizedPixelFormat.RGB8I:case a.SizedPixelFormat.RGB8UI:case a.SizedPixelFormat.RGB8_SNORM:case a.SizedPixelFormat.SRGB8:case a.RenderbufferFormat.DEPTH_COMPONENT24:return 3;case a.PixelFormat.DEPTH_STENCIL:case a.PixelFormat.DEPTH24_STENCIL8:case a.PixelFormat.RGBA:case a.PixelFormat.RGBA_INTEGER:case a.SizedPixelFormat.RGBA8:case a.SizedPixelFormat.R32F:case a.SizedPixelFormat.R11F_G11F_B10F:case a.SizedPixelFormat.RG16F:case a.SizedPixelFormat.R32I:case a.SizedPixelFormat.R32UI:case a.SizedPixelFormat.RG16I:case a.SizedPixelFormat.RG16UI:case a.SizedPixelFormat.RGBA8I:case a.SizedPixelFormat.RGBA8UI:case a.SizedPixelFormat.RGBA8_SNORM:case a.SizedPixelFormat.SRGB8_ALPHA8:case a.SizedPixelFormat.RGB9_E5:case a.SizedPixelFormat.RGB10_A2UI:case a.SizedPixelFormat.RGB10_A2:case a.RenderbufferFormat.DEPTH_STENCIL:case a.RenderbufferFormat.DEPTH_COMPONENT32F:case a.RenderbufferFormat.DEPTH24_STENCIL8:return 4;case a.RenderbufferFormat.DEPTH32F_STENCIL8:return 5;case a.SizedPixelFormat.RGB16F:case a.SizedPixelFormat.RGB16I:case a.SizedPixelFormat.RGB16UI:return 6;case a.SizedPixelFormat.RG32F:case a.SizedPixelFormat.RG32I:case a.SizedPixelFormat.RG32UI:case a.SizedPixelFormat.RGBA16F:case a.SizedPixelFormat.RGBA16I:case a.SizedPixelFormat.RGBA16UI:return 8;case a.SizedPixelFormat.RGB32F:case a.SizedPixelFormat.RGB32I:case a.SizedPixelFormat.RGB32UI:return 12;case a.SizedPixelFormat.RGBA32F:case a.SizedPixelFormat.RGBA32I:case a.SizedPixelFormat.RGBA32UI:return 16;case a.CompressedTextureFormat.COMPRESSED_RGB_S3TC_DXT1_EXT:case a.CompressedTextureFormat.COMPRESSED_RGBA_S3TC_DXT1_EXT:return.5;case a.CompressedTextureFormat.COMPRESSED_RGBA_S3TC_DXT3_EXT:case a.CompressedTextureFormat.COMPRESSED_RGBA_S3TC_DXT5_EXT:return 1;case a.CompressedTextureFormat.COMPRESSED_R11_EAC:case a.CompressedTextureFormat.COMPRESSED_SIGNED_R11_EAC:case a.CompressedTextureFormat.COMPRESSED_RGB8_ETC2:case a.CompressedTextureFormat.COMPRESSED_SRGB8_ETC2:case a.CompressedTextureFormat.COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2:case a.CompressedTextureFormat.COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2:return.5;case a.CompressedTextureFormat.COMPRESSED_RG11_EAC:case a.CompressedTextureFormat.COMPRESSED_SIGNED_RG11_EAC:case a.CompressedTextureFormat.COMPRESSED_RGBA8_ETC2_EAC:case a.CompressedTextureFormat.COMPRESSED_SRGB8_ALPHA8_ETC2_EAC:return 1}return 0}e.bindVertexBufferLayout=n,e.getBytesPerElementFormat=l,e.getErrorString=o,e.getStride=c,e.unbindVertexBufferLayout=m,e.vertexCount=s,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
