/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","exports","../../core/Error","../../core/MultiOriginJSONSupport","../../core/reactiveUtils","../../core/urlUtils","../../core/accessorSupport/originUtils","../../geometry/SpatialReference","../../geometry/support/spatialReferenceUtils","../../geometry/support/webMercatorUtils","../../layers/support/arcgisLayerUrl","../../layers/support/layerUtils","../../portal/Portal","../../portal/PortalItem","../../portal/support/jsonContext","../../portal/support/portalItemUtils","../../rest/geometryService/project","../../rest/support/ProjectParameters","../../support/basemapUtils","./resourceUtils","./saveUtils"],(function(e,t,r,a,o,i,n,s,l,p,c,d,u,y,w,m,f,h,v,g,T){"use strict";const b=["NatGeo_World_Map","Ocean_Basemap","USA_Topo_Maps","World_Imagery","World_Street_Map","World_Terrain_Base","World_Topo_Map","World_Hillshade","Canvas/World_Light_Gray_Base","Canvas/World_Light_Gray_Reference","Canvas/World_Dark_Gray_Base","Canvas/World_Dark_Gray_Reference","Ocean/World_Ocean_Base","Ocean/World_Ocean_Reference","Reference/World_Boundaries_and_Places","Reference/World_Reference_Overlay","Reference/World_Transportation"].map((e=>e.toLowerCase()));async function _(e,t,r){r??={},R(e,t),await o.whenOnce((()=>!t.updatingFromView)),await t.load(),await I(t),await T.beforeSave(t),await W(e,t);const a=t.portalItem,{json:i,jsonContext:n}=await S(t,a);return T.evaluateWriteErrors(n,{errorName:`${e.name}:save`},r),await A(t,a),await ce(e,t,a,i,n),await Promise.all([t.updateItemThumbnail(),g.saveResources(t.resourceReferences,n)]),a}async function S(e,t){const r=w.createForItemWrite(t,"web-map",!0),a=e.write({},r);return await Promise.all(r.resources.pendingOperations),{json:a,jsonContext:r}}async function K(e,t,r,a){a??={};const i=P(e,r);await o.whenOnce((()=>!t.updatingFromView)),await t.load(),await I(t),await T.beforeSave(t),await W(e,t);const{json:n,jsonContext:s}=await S(t,i);T.evaluateWriteErrors(s,{errorName:`${e.name}:save`},a),await $(t,i);const l=t.getThumbnailState();return await de(e,t,i,n,s,a)&&(t.resourceReferences.portalItem=i),t.restoreThumbnailFromState(l),await Promise.all([t.updateItemThumbnail(),g.saveResources(t.resourceReferences,s)]),i}function R(e,t){if(!t.portalItem)throw new r(`${e.name}:portal-item-not-set`,"Portal item to save to has not been set on the WebMap");O(e,t.portalItem)}function O(e,t){if(t.type!==e.itemType)throw new r(`${e.name}:portal-item-wrong-type`,`Portal item needs to have type "${e.itemType}"`)}async function W(e,t){if(!t.basemap?.baseLayers.length)throw new r(`${e.name}:save`,"Map does not have a valid basemap with a base layer.");let a=null;if(await o.whenOnce((()=>{const e=v.findSpatialReference(t.initialViewProperties,t.basemap);return a=e.spatialReference,!e.updating})),!l.equals(a,t.initialViewProperties.spatialReference))throw new r(`${e.name}:save`,"The spatial reference of the basemap is not compatible with the one from the map.",{expected:t.initialViewProperties.spatialReference,actual:a})}function P(e,t){let r=y.from(t);return r.id&&(r=r.clone(),r.id=null),r.type||(r.type=e.itemType),r.portal||(r.portal=u.getDefault()),O(e,r),r}function I(e){const t=[];return e.basemap&&t.push(e.basemap.load()),e.ground&&t.push(e.ground.load()),Promise.allSettled(t).then((()=>{}))}async function A(e,t){t.extent=await ae(e.portalItem,e.initialViewProperties.viewpoint.targetGeometry),await J(e,t)}const U=m.typeKeyword.JSAPI,C="CollectorDisabled",L="Collector",M="Data Editing",j="OfflineDisabled",D="Offline",E="Workforce Project",G="Workforce Worker",N="Workforce Dispatcher",V="Offline Map Areas",k="FieldMapsDisabled",x=m.typeKeyword.DEVELOPER_BASEMAP,B="UtilityNetwork",F="IPS";async function $(e,t){m.removeTypeKeyword(t,C),m.removeTypeKeyword(t,k),m.removeTypeKeyword(t,m.typeKeyword.METADATA),m.removeTypeKeyword(t,j),m.removeTypeKeyword(t,V),m.removeTypeKeyword(t,N),m.removeTypeKeyword(t,E),m.removeTypeKeyword(t,G),await A(e,t)}async function J(e,t){m.addTypeKeyword(t,U),await q(e),X(e,t),Y(e,t),Z(e,t),ee(e,t),te(e,t),re(e,t),t.typeKeywords&&(t.typeKeywords=t.typeKeywords.filter(((e,t,r)=>r.indexOf(e)===t)))}function q(e){const t=H(e).map((e=>e.load())).toArray();return Promise.allSettled(t).then((()=>{}))}function H(e){return e.allLayers.concat(e.allTables)}function z(e){return H(e).some((e=>e.loaded&&d.isLayerWithFeatureLayerSource(e)&&e.capabilities.operations.supportsEditing&&e.editingEnabled&&("subtype-group"!==e.type||e.sublayers.some((e=>e.editingEnabled)))))}function Q(e){return H(e).filter((e=>"group"!==e.type)).every((t=>t.loaded&&ne(e,t)))}function X(e,t){m.hasTypeKeyword(t,C)||m.hasTypeKeyword(t,E)||m.hasTypeKeyword(t,G)||m.hasTypeKeyword(t,N)||!z(e)?m.removeTypeKeyword(t,L):m.addTypeKeyword(t,L)}function Y(e,t){z(e)?m.addTypeKeyword(t,M):m.removeTypeKeyword(t,M)}function Z(e,t){!m.hasTypeKeyword(t,j)&&Q(e)?m.addTypeKeyword(t,D):m.removeTypeKeyword(t,D)}function ee(e,t){v.hasDeveloperBasemapLayer(e.basemap)?m.addTypeKeyword(t,x):m.removeTypeKeyword(t,x)}function te(e,t){e.utilityNetworks?.length?m.addTypeKeyword(t,B):m.removeTypeKeyword(t,B)}function re(e,t){e.ipsInfo?m.addTypeKeyword(t,F):m.removeTypeKeyword(t,F)}async function ae(e,t){const r=t.clone().normalize();let a;if(r.length>1)for(const o of r)a?o.width>a.width&&(a=o):a=o;else a=r[0];return oe(e,a)}async function oe(t,r){const a=r.spatialReference;if(a.isWGS84)return r.clone();if(a.isWebMercator)return p.webMercatorToGeographic(r);const{getGeometryServiceURL:o}=await new Promise(((t,r)=>e(["../../portal/support/geometryServiceUtils"],t,r))),i=await o(t),n=new h({geometries:[r],outSpatialReference:s.WGS84});return(await f.project(i,n))[0]}function ie(e){return d.isFeatureCollectionLayer(e)||"map-notes"===e.type||"route"===e.type}function ne(e,t){return d.isLayerWithFeatureLayerSource(t)&&t.capabilities.operations.supportsSync||ie(t)&&!t.portalItem||se(t)&&!le(t)&&t.spatialReference.equals(e.initialViewProperties.spatialReference)}function se(e){return("tile"===e.type||"vector-tile"===e.type)&&(e.capabilities.operations.supportsExportTiles||pe(e)||v.isDeveloperBasemapLayer(e))}function le(e){return"vector-tile"===e.type&&Object.keys(e.sourceNameToSource).length>1}function pe(e){return"tile"===e.type&&(c.isServerOrServicesAGOLUrl(e.url)&&b.some((t=>e.url?.toLowerCase().includes("/"+t+"/"))))}async function ce(e,t,r,a,o){await r.update({data:a}),we(e,t,r,a,o)}async function de(e,t,a,o,i,n){const s=t.portalItem,l={item:s,authenticated:!(!s?.id||!s.portal.user)},p=a.portal;await p.signIn();const{copyAllowed:c,itemReloaded:d}=await ue(l,p);if(l.authenticated||=d,!c)throw new r(`${e.name}:save-as-copy-not-allowed`,"Owner of this map does not allow others to save a copy");const u=await ye(a,l,o,n);return t.portalItem=a,we(e,t,a,o,i),u}async function ue(e,t){const{item:r,authenticated:a}=e;return r?.id&&r.typeKeywords?.includes("useOnly")?r.portal.portalHostname!==t.portalHostname?{copyAllowed:!1,itemReloaded:!1}:(a||await r.reload(),{copyAllowed:"admin"===r.itemControl||"update"===r.itemControl,itemReloaded:!0}):{copyAllowed:!0,itemReloaded:!1}}async function ye(e,t,r,a){const o=e.portal,{item:n}=t,{folder:s,copyAllResources:l}=a;let p=!1;if(l&&n?.id&&i.hasSameCanonicalPortal(n.portal.url,o.url)&&parseInt(n.portal.currentVersion,10)>=2023){const{total:e}=await n.fetchResources();p=!!e}if(p){const t=await n.copy({copyResources:"all",folder:s});e.id=t.id,e.portal=t.portal;const a=e.toJSON();await e.load(),e.read(a),await e.update({data:r})}else await o.user.addItem({item:e,folder:s,data:r});return p}function we(e,t,r,o,s){a.MultiOriginJSONSupport.prototype.read.call(t,{version:o.version,authoringApp:o.authoringApp,authoringAppVersion:o.authoringAppVersion},{origin:e.origin,ignoreDefaults:!0,url:r.itemUrl?i.urlToObject(r.itemUrl):void 0}),n.updateOrigins(s),t.resourceInfo=o}t.createJSON=S,t.initializeNewItem=ye,t.isCopyAllowed=ue,t.save=_,t.saveAs=K,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
