/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../Basemap","../Viewpoint","../core/asyncUtils","../core/Clonable","../core/Collection","../core/collectionUtils","../core/JSONSupport","../core/Logger","../core/mathUtils","../core/maybe","../core/promiseUtils","../core/reactiveUtils","../core/accessorSupport/decorators/property","../core/accessorSupport/decorators/cast","../core/RandomLCG","../core/has","../core/accessorSupport/decorators/subclass","../core/accessorSupport/ensureType","../chunks/vec32","../core/libs/gl-matrix-2/factories/vec3f64","../layers/Layer","../support/basemapUtils","../views/support/Scheduler","../webdoc/support/SlideThumbnail","../webdoc/support/timeProperties","./SunLighting","./VirtualLighting","./support/Description","./support/SlideEnvironment","./support/SlideGround","./support/SlideVisibleLayer","./support/Title"],(function(e,t,i,n,r,a,o,s,l,p,c,d,h,u,y,m,g,b,v,w,_,T,f,L,C,S,E,k,V,U,x,j,A,D){"use strict";let I=0;const P=o.ofType(A.SlideVisibleLayer),q=["caption","cover","none"];let M=class extends(a.ClonableMixin(l.JSONSupport)){constructor(e){super(e),this.id=Date.now().toString(16)+"-slide-"+I++,this.title=new D,this.description=new U,this.hidden=!1,this.thumbnail=new S.SlideThumbnail,this.viewpoint=null,this.basemap=null,this.ground=null,this.layout="caption",this.environment=new x.SlideEnvironment,this.timeExtent=null,this.visibleLayers=new P}destroy(){this.visibleLayers.removeAll(),this.basemap=null,this.thumbnail=d.destroyMaybe(this.thumbnail),this.description=null,this.title=null,this.thumbnail=null}castTitle(e){return"string"==typeof e?new D({text:e}):w.ensureType(D,e)}castDescription(e){return"string"==typeof e?new U({text:e}):w.ensureType(U,e)}castThumbnail(e){return"string"==typeof e?new S.SlideThumbnail({url:e}):w.ensureType(S.SlideThumbnail,e)}castBasemap(e){return L.ensureType(e)}set visibleLayers(e){this._set("visibleLayers",s.referenceSetter(e,this._get("visibleLayers"),P))}castVisibleLayers(e){return e&&"function"==typeof e.map?e.map((e=>{if("string"==typeof e)return{id:e};if(e instanceof f){const t=R(e);return{id:e.id,sublayerIds:t}}return e.id?{id:e.id,sublayerIds:"sublayerIds"in e?e.sublayerIds:void 0}:(p.getLogger(this).warn('Invalid visible layer, expected { id }, Layer or "id"'),e)})):null}async _updateVisibleLayersFrom(e){const t=[];await Promise.allSettled(this._getLayers(e.map).map((i=>e.whenLayerView(i).then((e=>{if(e.visible){const n=R(i);t.push(new A.SlideVisibleLayer({id:e.layer.id,sublayerIds:n}))}})))).toArray()),this.visibleLayers.removeAll(),this.visibleLayers.addMany(t)}updateFrom(e,t){const i={format:"png",quality:80,width:120,height:75,disableDecorations:!0,...t?.screenshot};return e.when((()=>(this.viewpoint=e.viewpoint.clone(),this.environment.lighting="virtual"===e.environment.lighting.type?V.prototype.clone.apply(e.environment.lighting):k.prototype.clone.apply(e.environment.lighting),this.environment.weather=e.environment.weather.clone(),this.basemap=e.map.basemap&&e.map.basemap.clone()||null,this.ground=e.map.ground?j.fromGround(e.map.ground):null,this.timeExtent=e.timeExtent?.clone()??null,this._updateVisibleLayersFrom(e)))).then((()=>e.takeScreenshot(i))).then((e=>(this.thumbnail=new S.SlideThumbnail({url:e.dataUrl}),this)))}async applyTo(e,t){null!=this._applyToController&&this._applyToController.abort();let i=new AbortController;this._applyToController=i;const n=h.onAbortOrThrow(t,(()=>i?.abort())),a=()=>{this._applyToController===i&&(this._applyToController=null),i=null,n?.remove()};try{await u.whenOnce((()=>e.ready),i.signal)}catch(d){throw a(),d}if(i.signal.aborted)throw a(),h.createAbortError();const o=e.resourceController.scheduler.registerTask(C.TaskPriority.SLIDE);let s=!1;const l={animate:!0,...t,signal:this._applyToController.signal},p=async()=>{await Promise.all([o.schedule((async()=>s=await this._setViewpointOfInterest(e,l))),o.schedule((()=>this._applyBasemap(e,l)),l.signal),o.schedule((()=>this._loadLayersWithSublayerVisibility(e)))]),await Promise.all([o.schedule((()=>this._applyLayerVisibility(e)),l.signal),o.schedule((()=>this._applyGround(e)),l.signal),o.schedule((()=>this._applyViewpoint(e,l)),l.signal),o.schedule((()=>e.timeExtent=this.timeExtent?.clone()??null),l.signal),o.schedule((()=>e.environment.weather=this.environment.weather.clone()))])},c=await r.result(e.addUpdatingPromise(p()));if(s&&(e.contentCamera=null),o.remove(),a(),!1===c.ok)throw c.error;return this}async _applyBasemap(e,t){if(this.basemap){try{await this.basemap.load(t)}catch(i){if(h.isAbortError(i))throw i}e.map.basemap=L.clonePreservingTiledLayers(this.basemap,e.map.basemap)}}_applyGround(e){this.ground&&(e.map.ground=this.ground.cloneAndApplyTo(e.map.ground))}_getLayers(e){const t=new o;return this._collectLayers(e,t),this._collectLayers(e.ground,t),t}_collectLayers(e,t){e.layers.forEach((e=>{e.persistenceEnabled&&(t.add(e),"layers"in e&&this._collectLayers(e,t))}))}async _loadLayersWithSublayerVisibility(e){this.visibleLayers&&await Promise.allSettled(this._getLayers(e.map).items.map((e=>{const t=this.visibleLayers.find((t=>t.id===e.id))?.sublayerIds;return t?e.load():null})))}_applyLayerVisibility(e){if(!this.visibleLayers)return;this._getLayers(e.map).forEach((e=>{const t=this.visibleLayers.find((t=>t.id===e.id));e.visible=null!=t;const i=t?.sublayerIds,n=O(e);i&&n&&n.forEach((e=>e.visible=i.includes(e.id)))}))}async _setViewpointOfInterest(t,i){if(t.state.fixedContentCamera||!this.viewpoint||i?.ignoreViewpoint||!i?.useDestinationCamera)return!1;const{toCameraAsync:n}=await new Promise(((t,i)=>e(["../views/3d/support/viewpointUtils"],t,i))),r=await n(t,this.viewpoint);return t.contentCamera=r,null!=r}async _applyViewpoint(e,t){if(this._applyCachedCameraTrackingEnabled(e),this.viewpoint&&!t.ignoreViewpoint){const i=this.environment.lighting;if(t.animate&&"sun"===i.type&&i.date)return this._animateToLighting(e,t);t.animate&&(e.environment.applyLighting(i.clone()),await e.goTo(this.viewpoint,t)),e.viewpoint=this.viewpoint}e.environment.applyLighting(this.environment.lighting.clone())}async _animateToLighting(e,t){let i=null;"virtual"!==e.environment.lighting.type&&"virtual"!==this.environment.lighting.type&&("global"===e.viewingMode&&(i=this._animateLightingWithCamera(e,e.environment.lighting,this.environment.lighting)),e.environment.cachedCameraTrackingEnabled=e.environment.lighting.cameraTrackingEnabled,e.environment.lighting.cameraTrackingEnabled=!1),e.environment.lighting.directShadowsEnabled=this.environment.lighting.directShadowsEnabled,"virtual"===this.environment.lighting.type||"virtual"===e.environment.lighting.type?(e.environment.applyLighting(this.environment.lighting.clone()),"virtual"!==e.environment.lighting.type&&(e.environment.cachedCameraTrackingEnabled=e.environment.lighting.cameraTrackingEnabled,e.environment.lighting.cameraTrackingEnabled=!1)):null!=this.environment.lighting.displayUTCOffset&&(e.environment.lighting.displayUTCOffset=this.environment.lighting.displayUTCOffset);return e.goTo(this.viewpoint,t).then((()=>{this._applyCachedCameraTrackingEnabled(e),e.environment.applyLighting(this.environment.lighting.clone())})).catch((t=>{throw null==e.animation&&this._applyCachedCameraTrackingEnabled(e),t})).finally((()=>{d.removeMaybe(i)}))}_applyCachedCameraTrackingEnabled(e){null!=e.environment.cachedCameraTrackingEnabled&&(e.environment.lighting.cameraTrackingEnabled=e.environment.cachedCameraTrackingEnabled,e.environment.cachedCameraTrackingEnabled=null)}_getTime(e){return[e.getTime(),3600*e.getUTCHours()+60*e.getUTCMinutes()+e.getUTCSeconds()]}_setTime(e,t,i){return e.setTime(t),e.setUTCHours(i/3600),e.setUTCMinutes(i%3600/60),e.setUTCSeconds(i%3600%60),e}_animateLightingWithCamera(e,t,i){const n=new Date(t.date.toString()),[r,a]=this._getTime(n),[o,s]=this._getTime(i.date),l=G(a,s),p=e.renderCoordsHelper,c=T.create();p.toRenderCoords(e.camera.position,c);const d=T.create(),h=T.create();null!=this.viewpoint.camera&&p.toRenderCoords(this.viewpoint.camera.position,d);const y=new Date;return u.when((()=>e.camera),(e=>{p.toRenderCoords(e.position,h);const i=_.squaredDistance(c,h),n=_.squaredDistance(d,h);let s=0;i+n!==0&&(s=i/(i+n));const u=r+(o-r)*s,m=N(a,l*s);t.date=this._setTime(y,u,m)}))}static createFrom(e,t){return(new this).updateFrom(e,t)}};t.__decorate([y.property({type:String,json:{write:{isRequired:!0}}})],M.prototype,"id",void 0),t.__decorate([y.property({type:D,json:{default:()=>new D({text:""}),write:{isRequired:!0}}})],M.prototype,"title",void 0),t.__decorate([m.cast("title")],M.prototype,"castTitle",null),t.__decorate([y.property({type:U,json:{write:{overridePolicy:e=>({enabled:!(!e||!e.text)})}}})],M.prototype,"description",void 0),t.__decorate([m.cast("description")],M.prototype,"castDescription",null),t.__decorate([y.property({type:Boolean,nonNullable:!0,json:{write:!0,default:!1}})],M.prototype,"hidden",void 0),t.__decorate([y.property({type:S.SlideThumbnail,json:{default:()=>new S.SlideThumbnail({url:""}),write:{isRequired:!0}}})],M.prototype,"thumbnail",void 0),t.__decorate([m.cast("thumbnail")],M.prototype,"castThumbnail",null),t.__decorate([y.property({type:n,nonNullable:!0,json:{write:{isRequired:!0}}})],M.prototype,"viewpoint",void 0),t.__decorate([y.property({type:i,json:{read:{source:"baseMap"},write:{target:"baseMap"}}})],M.prototype,"basemap",void 0),t.__decorate([m.cast("basemap")],M.prototype,"castBasemap",null),t.__decorate([y.property({type:j,json:{write:!0}})],M.prototype,"ground",void 0),t.__decorate([y.property({type:q,json:{write:!0,default:"caption"},nonNullable:!0})],M.prototype,"layout",void 0),t.__decorate([y.property({type:P,json:{write:{isRequired:!0}}})],M.prototype,"visibleLayers",null),t.__decorate([m.cast("visibleLayers")],M.prototype,"castVisibleLayers",null),t.__decorate([y.property({type:x.SlideEnvironment,json:{write:!0}})],M.prototype,"environment",void 0),t.__decorate([y.property(E.timeExtent)],M.prototype,"timeExtent",void 0),M=t.__decorate([v.subclass("esri.webscene.Slide")],M);function O(e){if("building-scene"===e.type||"map-image"===e.type)return e.allSublayers.toArray()}function R(e){const t=O(e);if(t)return t.filter((e=>e.visible)).map((e=>e.id))}const B=86400,F=43200;function G(e,t){let i=t-e;return i>F&&(i-=B),i<-F&&(i+=B),i}function N(e,t){return c.moduloPositive(e+t,B)}return M}));
