/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../chunks/tslib.es6","../../geometry","../../Graphic","../../intl","../../symbols","../../core/colorUtils","../../core/maybe","../../core/reactiveUtils","../../core/unitFormatUtils","../../core/unitUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/Logger","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../../core/support/UpdatingHandles","../../geometry/geometryEngine","../../geometry/projection","../../geometry/support/geodesicUtils","../../layers/GraphicsLayer","../../views/ViewingMode","../../views/2d/interactive/SnappingVisualizer2D","../../views/draw/Draw","../../views/interactive/coordinateHelper","../../views/interactive/dragEventPipeline","../../views/interactive/GraphicManipulator","../../views/interactive/InteractiveToolBase","../../views/interactive/editGeometry/EditGeometry","../../views/interactive/editGeometry/EditGeometryOperations","../../views/interactive/snapping/SnappingContext","../../views/interactive/snapping/SnappingDragPipelineStep","../../views/interactive/snapping/SnappingManagerPool","../../views/interactive/snapping/snappingUtils","../../intl/messages","../../intl/locale","../../geometry/Point","../../symbols/SimpleFillSymbol","../../symbols/SimpleLineSymbol","../../symbols/TextSymbol","../../symbols/Font","../../symbols/SimpleMarkerSymbol","../../geometry/Polyline","../../geometry/SpatialReference","../../geometry/Polygon"],(function(e,t,r,i,s,a,n,o,l,c,p,m,u,h,d,g,y,_,v,f,w,L,b,M,S,A,D,G,T,x,q,k,C,j,O,R,H,E,U,P,z,V,W,I,B){"use strict";const F=1e5;function N(e,t,r){const s=8,a={style:"circle",color:n.multiplyOpacity(t.effectiveTheme.accentColor,.5),outline:{type:"simple-line",width:0}},o=new V({...a,size:s}),l=new V({...a,size:1.5*s}),c=new i({geometry:e,symbol:o});return new D.GraphicManipulator({view:t,layer:r,graphic:c,focusedSymbol:l})}function J(e,t,r){if(2===e.length){const i=new W({paths:[e],spatialReference:t});let s;if(t.isGeographic)if(f.isSupported(t))s=f.geodesicDensify(i,F);else{const e=v.project(i,I.WGS84),r=f.geodesicDensify(e,F);s=v.project(r,t)}else if(t.isWebMercator)s=_.geodesicDensify(i,F,"meters");else{if(_.planarLength(i,"meters")>=Z(r)){const e=v.project(i,I.WGS84),r=f.geodesicDensify(e,F);s=v.project(r,t)}else s=i}return{measurement:null,fillGeometry:null,outlineGeometry:s}}e.push(e[0]);const i=new W({paths:[e],spatialReference:t}),s=new B({rings:[e],spatialReference:t});let a,n,o=null,l=null;if(t.isGeographic)if(f.isSupported(t)){if(o=f.geodesicDensify(i,F),l=f.geodesicDensify(s,F),l=_.simplify(l),!l)return null;a=f.geodesicLengths([i],"meters")[0],n=f.geodesicAreas([l],"square-meters")[0]}else{const e=I.WGS84,r=v.project(i,e),c=v.project(s,e);if(o=f.geodesicDensify(r,F),l=f.geodesicDensify(c,F),l=_.simplify(l),!l)return null;a=f.geodesicLengths([r],"meters")[0],n=f.geodesicAreas([l],"square-meters")[0],o=v.project(o,t),l=v.project(l,t)}else if(t.isWebMercator){if(o=_.geodesicDensify(i,F,"meters"),l=_.geodesicDensify(s,F,"meters"),l=_.simplify(l),!l)return null;a=_.geodesicLength(i,"meters"),n=_.geodesicArea(l,"square-meters")}else{const e=_.planarLength(i,"meters");if(e>=Z(r)){const e=I.WGS84,r=v.project(i,e),c=v.project(s,e);if(o=f.geodesicDensify(r,F),l=f.geodesicDensify(c,F),l=_.simplify(l),!l)return null;a=f.geodesicLengths([r],"meters")[0],n=f.geodesicAreas([l],"square-meters")[0],o=v.project(o,t),l=v.project(l,t)}else{if(o=i,l=_.simplify(s),!l)return null;a=e,n=_.planarArea(l,"square-meters")}}return{measurement:{geometry:l,area:n,perimeter:a},fillGeometry:l,outlineGeometry:o}}function K(e){return null!=e}function Q(e){if(!e)return!1;const{isGeographic:t,isWebMercator:r,isWGS84:i}=e;return t&&!i&&!f.isSupported(e)||!t&&!r}function X(e,t,r){if(!t||!e)return null;const i={area:null,perimeter:null},{area:s,perimeter:a}=t;switch(r){case"metric":i.area=c.formatMetricArea(e,s,"square-meters");break;case"imperial":i.area=c.formatImperialArea(e,s,"square-meters");break;default:{const t=p.convertUnit(s,"square-meters",r);i.area=c.formatDecimal(e,t,r);break}}const n=Y(r);if(n)switch(n){case"metric":i.perimeter=c.formatMetricLength(e,a,"meters");break;case"imperial":i.perimeter=c.formatImperialLength(e,a,"meters");break;default:{const t=p.convertUnit(a,"meters",n);i.perimeter=c.formatDecimal(e,t,n);break}}else i.perimeter="";return i}function Y(e){switch(e){case"metric":case"ares":case"hectares":return"metric";case"imperial":case"acres":return"imperial";case"square-inches":return"inches";case"square-feet":return"feet";case"square-yards":return"yards";case"square-miles":return"miles";case"square-us-feet":return"us-feet";case"square-meters":return"meters";case"square-kilometers":return"kilometers";case"square-millimeters":return"millimeters";case"square-centimeters":return"centimeters";case"square-decimeters":return"decimeters";default:return null}}function Z(e){return e??1/0}e.AreaMeasurement2DTool=class extends G.InteractiveToolBase{constructor(e){super(e),this._drawActive=!1,this._measurementLayer=new w({internal:!0,listMode:"hide",visible:!1}),this._manipulatorLayer=new w({internal:!0,listMode:"hide",visible:!1}),this._snappingLayer=new w({internal:!0,listMode:"hide",visible:!1}),this._updatingHandles=new y.UpdatingHandles,this._vertices=[],this.geodesicDistanceThreshold=null,this.measurement=null,this.measurementLabel=null}initialize(){O.fetchMessageBundle("esri/core/t9n/Units").then((e=>{this.messages=e}));const e=this.view;this._draw=new M({view:e}),e.map.addMany([this._measurementLayer,this._manipulatorLayer,this._snappingLayer]),e.focus(),this._snappingManagerResult=C.acquire(e),this.addHandles([R.onLocaleChange((async()=>{this.messages=await O.fetchMessageBundle("esri/core/t9n/Units")})),l.watch((()=>[this.unit,this.geodesicDistanceThreshold,this.messages]),(()=>{this._updateGraphics()}),l.initial),l.watch((()=>[this.view.effectiveTheme.accentColor,this.view.effectiveTheme.textColor]),(()=>{if(!this._vertices.length)return;const e=this._vertices.map((({coord:e})=>e));for(const{handle:t}of this._vertices)t.remove();this._vertices=[],this._measurementLayer.removeAll(),this._manipulatorLayer.removeAll(),this._snappingLayer.removeAll(),this.manipulators.removeAll(),this._updateSketch(e)})),l.watch((()=>this.snappingOptions.featureSources),(e=>{for(const t of e)t.layer!==this._measurementLayer&&t.layer!==this._manipulatorLayer||(t.enabled=!1)}),l.initial),this._snappingManagerResult]),j.setupSnappingToggleHandles(this)}destroy(){const{map:e}=this.view;this._draw.view=null,this._draw=o.destroyMaybe(this._draw),e.removeMany([this._measurementLayer,this._manipulatorLayer,this._snappingLayer]),this._measurementLayer.removeAll(),this._manipulatorLayer.removeAll(),this._snappingLayer.removeAll(),this._set("measurement",null),this._set("measurementLabel",null),this._measurementLayer=o.destroyMaybe(this._measurementLayer),this._manipulatorLayer=o.destroyMaybe(this._manipulatorLayer),this._snappingLayer=o.destroyMaybe(this._snappingLayer),this._updatingHandles=o.destroyMaybe(this._updatingHandles),this._resetVertices()}get _snappingManager(){return this._snappingManagerResult.snappingManager}get cursor(){return this._drawActive?"crosshair":null}set editable(e){this._set("editable",e),e||this._draw.reset()}get snappingOptions(){return this._snappingManager.options}get updating(){return this._updatingHandles.updating||this._snappingManager.updating}onActivate(){this._drawActive||0!==this._vertices.length||this._startSketch()}onShow(){this._measurementLayer.visible=!0,this._manipulatorLayer.visible=!0,this._snappingLayer.visible=!0}onHide(){this._measurementLayer.visible=!1,this._manipulatorLayer.visible=!1,this._snappingLayer.visible=!1}reset(){this.manipulators.removeAll(),this._resetVertices(),this._measurementLayer.removeAll(),this._manipulatorLayer.removeAll(),this._set("measurement",null),this._set("measurementLabel",null),this._draw.reset(),this._drawActive=!1}_getSnappingContext(e){return new q.SnappingContext({elevationInfo:{mode:"on-the-ground",offset:0},pointer:e,editGeometryOperations:new x.EditGeometryOperations(new T.EditGeometry("point",S.createCoordinateHelper(!1,!1,this.view.spatialReference)),L.ViewingMode.Local),visualizer:new b.SnappingVisualizer2D(this._snappingLayer)})}_resetVertices(){for(const{handle:e}of this._vertices)e.remove();this._vertices=[]}_startSketch(){this._drawActive=!0;const e=this._snappingManager,t=this._draw.create("polyline",{mode:"click",snappingManager:e});t.on(["vertex-add","vertex-update","vertex-remove","cursor-update","undo","redo"],(e=>this._updateSketch(e.vertices))),t.on("draw-complete",(()=>this._stopSketch()))}_stopSketch(){if(this._vertices.length<3)return this.reset(),void this._startSketch();this.manipulators.forEach((({manipulator:e})=>{e.interactive=!0})),this._drawActive=!1,this.finishToolCreation()}_updateSketch(e){const t=this.view.spatialReference;if(t&&(!Q(t)||v.isLoaded())){for(;this._vertices.length>e.length;){const{handle:e,manipulator:t}=this._vertices.pop();e.remove(),this.manipulators.remove(t)}for(let r=this._vertices.length;r<e.length;r++){const[i,s]=e[r],a=new H({x:i,y:s,spatialReference:t}),n=N(a,this.view,this._manipulatorLayer);this.manipulators.add(n);const o=x.EditGeometryOperations.fromGeometry(a,L.ViewingMode.Local);o.on("vertex-update",(e=>{const t=e.vertices.at(0);t&&(this._vertices[r].coord=[t.pos[0],t.pos[1]],this._updateGraphics())}));const l=A.createManipulatorDragEventPipeline(n,((e,t,r,i)=>{const s=this._getSnappingContext(i),a=this._snappingManager,n=this._updatingHandles,{snappingStep:l}=k.createSnapDragEventPipelineStep({snappingContext:s,snappingManager:a,updatingHandles:n});t.next(A.screenToMap(this.view)).next((t=>{if("start"===t.action){const r=new H(t.mapStart);e.graphic.geometry=r,o.trySetGeometry(r)}return t})).next(...l).next(A.dragManipulatedObject({operations:o})).next((()=>{e.graphic.geometry=o.data.geometry}))}));this._vertices.push({manipulator:n,coord:[i,s],handle:l})}if(this._vertices.length){const r=this._vertices.length-1,i=this._vertices[r],[s,a]=e[r];i.coord[0]===s&&i.coord[1]===a||(i.coord=[s,a],i.manipulator.graphic.geometry=new H({x:s,y:a,spatialReference:t}));const n=this._drawActive?this._vertices[r].manipulator:null;this.manipulators.forEach((({manipulator:e})=>{e.interactive=null==n||e!==n}))}this._updateGraphics()}}_updateGraphics(){if(this._vertices.length<2)return void this._measurementLayer.removeAll();const e=J(this._vertices.map((({coord:e})=>e)),this.view.spatialReference,this.geodesicDistanceThreshold);if(!e)return;const{measurement:t,fillGeometry:r,outlineGeometry:s}=e;this._set("measurement",t);const a=t?X(this.messages,t,this.unit):null;if(this._set("measurementLabel",a),!r&&!s)return;let o,l,c;const{graphics:p}=this._measurementLayer,m=3===p.length,{effectiveTheme:u}=this.view;m?(o=p.at(0),l=p.at(1),c=p.at(2)):(o=new i({symbol:new E({color:n.multiplyOpacity(u.accentColor,.3),outline:null})}),l=new i({symbol:new U({color:u.accentColor,width:2})}),c=new i({symbol:new P({color:u.textColor,font:new z({size:14,family:"sans-serif"}),haloColor:n.multiplyOpacity(n.getContrast(u.textColor,n.BrightnessThreshold.Low),.5),haloSize:2})}),p.removeAll(),p.addMany([o,l,c])),o.geometry=r,l.geometry=s,c.geometry=r?.centroid,c.symbol.text=a?.area??""}},t.__decorate([m.property()],e.AreaMeasurement2DTool.prototype,"_drawActive",void 0),t.__decorate([m.property({readOnly:!0})],e.AreaMeasurement2DTool.prototype,"cursor",null),t.__decorate([m.property({value:!0})],e.AreaMeasurement2DTool.prototype,"editable",null),t.__decorate([m.property({type:Number})],e.AreaMeasurement2DTool.prototype,"geodesicDistanceThreshold",void 0),t.__decorate([m.property({readOnly:!0})],e.AreaMeasurement2DTool.prototype,"measurement",void 0),t.__decorate([m.property({readOnly:!0})],e.AreaMeasurement2DTool.prototype,"measurementLabel",void 0),t.__decorate([m.property()],e.AreaMeasurement2DTool.prototype,"messages",void 0),t.__decorate([m.property()],e.AreaMeasurement2DTool.prototype,"unit",void 0),t.__decorate([m.property()],e.AreaMeasurement2DTool.prototype,"updating",null),t.__decorate([m.property({constructOnly:!0})],e.AreaMeasurement2DTool.prototype,"view",void 0),e.AreaMeasurement2DTool=t.__decorate([g.subclass("esri.widgets.AreaMeasurement2D.AreaMeasurement2DTool")],e.AreaMeasurement2DTool),e.createAreaMeasurementInfo2D=J,e.createAreaMeasurementLabel=X,e.isProjectionEngineRequired=Q,e.isSupported=K,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
