/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../core/Error","../core/reactiveUtils","../core/unitFormatUtils","../core/accessorSupport/decorators/property","../core/accessorSupport/decorators/cast","../core/RandomLCG","../core/has","../core/accessorSupport/decorators/subclass","./Widget","./Attachments/AttachmentsViewModel","./Attachments/support/attachmentUtils","../chunks/componentsUtils","./support/globalCss","./support/legacyIcon","./support/widgetUtils","./support/decorators/messageBundle","./support/jsxFactory"],(function(e,t,s,i,a,n,l,o,r,d,c,m,h,u,p,b,_,g,v){"use strict";const y={addButton:!0,addSubmitButton:!0,cancelAddButton:!0,cancelUpdateButton:!0,deleteButton:!0,errorMessage:!0,progressBar:!0,updateButton:!0},f="esri-attachments",w={base:f,loaderContainer:`${f}__loader-container`,loader:`${f}__loader`,fadeIn:`${f}--fade-in`,container:`${f}__container`,containerList:`${f}__container--list`,containerPreview:`${f}__container--preview`,actions:`${f}__actions`,deleteButton:`${f}__delete-button`,addAttachmentButton:`${f}__add-attachment-button`,errorMessage:`${f}__error-message`,items:`${f}__items`,item:`${f}__item`,itemButton:`${f}__item-button`,itemMask:`${f}__item-mask`,itemMaskIcon:`${f}__item-mask--icon`,itemImage:`${f}__image`,itemImageResizable:`${f}__image--resizable`,itemLabel:`${f}__label`,itemFilename:`${f}__filename`,itemChevronIcon:`${f}__item-chevron-icon`,itemLink:`${f}__item-link`,itemLinkOverlay:`${f}__item-link-overlay`,itemLinkOverlayIcon:`${f}__item-link-overlay-icon`,itemEditIcon:`${f}__item-edit-icon`,itemAddIcon:`${f}__item-add-icon`,itemAddButton:`${f}__item-add-button`,formNode:`${f}__form-node`,fileFieldset:`${f}__file-fieldset`,fileLabel:`${f}__file-label`,fileName:`${f}__file-name`,fileInput:`${f}__file-input`,metadata:`${f}__metadata`,metadataFieldset:`${f}__metadata-fieldset`,progressBar:`${f}__progress-bar`},A=window.CSS;let I=class extends c{constructor(e,t){super(e,t),this.displayType="auto",this.messages=null,this.messagesUnits=null,this.selectedFile=null,this.submitting=!1,this.viewModel=null,this.visibleElements={...y},this._supportsImageOrientation=A&&A.supports&&A.supports("image-orientation","from-image"),this._addAttachmentForm=null,this._updateAttachmentForm=null}normalizeCtorArgs(e){return e?.viewModel||(e={viewModel:new m,...e}),e}initialize(){this.addHandles([i.on((()=>this.viewModel?.attachmentInfos),"change",(()=>this.scheduleRender())),i.on((()=>this.viewModel?.fileInfos),"change",(()=>this.scheduleRender())),i.watch((()=>this.viewModel?.mode),(()=>this._modeChanged()),i.initial)])}loadDependencies(){return u.loadCalciteComponents({icon:()=>new Promise(((t,s)=>e(["../chunks/calcite-icon"],t,s)))})}get capabilities(){return this.viewModel.capabilities}set capabilities(e){this.viewModel.capabilities=e}get effectiveDisplayType(){const{displayType:e}=this;return e&&"auto"!==e?e:this.viewModel.supportsResizeAttachments?"preview":"list"}get graphic(){return this.viewModel.graphic}set graphic(e){this.viewModel.graphic=e}get icon(){return"attachment"}set icon(e){this._overrideIfSome("icon",e)}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}castVisibleElements(e){return{...y,...e}}addAttachment(){const{_addAttachmentForm:e,viewModel:t}=this;return this._set("submitting",!0),this._set("error",null),t.addAttachment(e).then((e=>(this._set("submitting",!1),this._set("error",null),t.mode="view",e))).catch((e=>{throw this._set("submitting",!1),this._set("error",new s("attachments:add-attachment",this.messages.addErrorMessage,e)),e}))}deleteAttachment(e){const{viewModel:t}=this;return this._set("submitting",!0),this._set("error",null),t.deleteAttachment(e).then((e=>(this._set("submitting",!1),this._set("error",null),t.mode="view",e))).catch((e=>{throw this._set("submitting",!1),this._set("error",new s("attachments:delete-attachment",this.messages.deleteErrorMessage,e)),e}))}updateAttachment(){const{viewModel:e}=this,{_updateAttachmentForm:t}=this;return this._set("submitting",!0),this._set("error",null),e.updateAttachment(t).then((t=>(this._set("submitting",!1),this._set("error",null),e.mode="view",t))).catch((e=>{throw this._set("submitting",!1),this._set("error",new s("attachments:update-attachment",this.messages.updateErrorMessage,e)),e}))}addFile(){const e=this.viewModel.addFile(this.selectedFile,this._addAttachmentForm);return this.viewModel.mode="view",e}updateFile(){const{viewModel:e}=this,t=e.updateFile(this.selectedFile,this._updateAttachmentForm,e.activeFileInfo);return e.mode="view",t}deleteFile(e){const t=this.viewModel.deleteFile(e||this.viewModel.activeFileInfo?.file);return this.viewModel.mode="view",t}render(){const{submitting:e,viewModel:t}=this,{state:s}=t;return v.tsx("div",{class:this.classes(w.base,p.globalCss.widget)},e?this._renderProgressBar():null,"loading"===s?this._renderLoading():this._renderAttachments(),this._renderErrorMessage())}_renderErrorMessage(){const{error:e,visibleElements:t}=this;return e&&t.errorMessage?v.tsx("div",{class:w.errorMessage,key:"error-message"},e.message):null}_renderAttachments(){const{activeFileInfo:e,mode:t,activeAttachmentInfo:s}=this.viewModel;return"add"===t?this._renderAddForm():"edit"===t?this._renderDetailsForm(s||e):this._renderAttachmentContainer()}_renderLoading(){return v.tsx("div",{class:w.loaderContainer,key:"loader"},v.tsx("div",{class:w.loader}))}_renderProgressBar(){return this.visibleElements.progressBar?v.tsx("div",{class:w.progressBar,key:"progress-bar"}):null}_renderAddForm(){const{submitting:e,selectedFile:t}=this,s=e||!t,i=this.visibleElements.cancelAddButton?v.tsx("button",{bind:this,class:this.classes(p.globalCss.button,p.globalCss.buttonTertiary,p.globalCss.buttonSmall,p.globalCss.buttonHalf,e&&p.globalCss.buttonDisabled),disabled:e,onclick:this._cancelForm,type:"button"},this.messages.cancel):null,a=this.visibleElements.addSubmitButton?v.tsx("button",{class:this.classes(p.globalCss.button,p.globalCss.buttonSecondary,p.globalCss.buttonSmall,p.globalCss.buttonHalf,{[p.globalCss.buttonDisabled]:s}),disabled:s,type:"submit"},this.messages.add):null,n=t?v.tsx("span",{class:w.fileName,key:"file-name"},t.name):null,l=v.tsx("form",{afterCreate:_.storeNode,afterRemoved:_.discardNode,bind:this,"data-node-ref":"_addAttachmentForm",onsubmit:this._submitAddAttachment},v.tsx("fieldset",{class:w.fileFieldset},n,v.tsx("label",{class:this.classes(w.fileLabel,p.globalCss.button,p.globalCss.buttonSecondary)},t?this.messages.changeFile:this.messages.selectFile,v.tsx("input",{bind:this,class:w.fileInput,name:"attachment",onchange:this._handleFileInputChange,type:"file"}))),a,i);return v.tsx("div",{class:w.formNode,key:"add-form-container"},l)}_renderDetailsForm(e){const{visibleElements:t,viewModel:s,selectedFile:i,submitting:n}=this,{capabilities:l}=s,o=n||!i;let r,d,c,m;i?(r=i.type,d=i.name,c=i.size):e&&"file"in e?(r=e.file.type,d=e.file.name,c=e.file.size):e&&"contentType"in e&&(r=e.contentType,d=e.name,c=e.size,m=e.url);const h=l.editing&&l.operations?.delete&&t.deleteButton?v.tsx("button",{bind:this,class:this.classes(p.globalCss.button,p.globalCss.buttonSmall,p.globalCss.buttonTertiary,w.deleteButton,{[p.globalCss.buttonDisabled]:n}),disabled:n,key:"delete-button",onclick:t=>this._submitDeleteAttachment(t,e),type:"button"},this.messages.delete):void 0,u=l.editing&&l.operations?.update&&t.updateButton?v.tsx("button",{class:this.classes(p.globalCss.button,p.globalCss.buttonSmall,p.globalCss.buttonThird,{[p.globalCss.buttonDisabled]:o}),disabled:o,key:"update-button",type:"submit"},this.messages.update):void 0,b=this.visibleElements.cancelUpdateButton?v.tsx("button",{bind:this,class:this.classes(p.globalCss.button,p.globalCss.buttonSmall,p.globalCss.buttonTertiary,p.globalCss.buttonThird,{[p.globalCss.buttonDisabled]:n}),disabled:n,key:"cancel-button",onclick:this._cancelForm,type:"button"},this.messages.cancel):void 0,g=l.editing&&l.operations?.update?v.tsx("fieldset",{class:w.fileFieldset,key:"file"},v.tsx("span",{class:w.fileName,key:"file-name"},d),v.tsx("label",{class:this.classes(w.fileLabel,p.globalCss.button,p.globalCss.buttonSecondary)},this.messages.changeFile,v.tsx("input",{bind:this,class:w.fileInput,name:"attachment",onchange:this._handleFileInputChange,type:"file"}))):void 0,y=v.tsx("fieldset",{class:w.metadataFieldset,key:"size"},v.tsx("label",null,a.formatFileSize(this.messagesUnits,c??0))),f=v.tsx("fieldset",{class:w.metadataFieldset,key:"content-type"},v.tsx("label",null,r)),A=null!=m?v.tsx("a",{class:w.itemLink,href:m,rel:"noreferrer",target:"_blank"},this._renderImageMask(e,400),v.tsx("div",{class:w.itemLinkOverlay},v.tsx("span",{class:w.itemLinkOverlayIcon},v.tsx("calcite-icon",{icon:"launch"})))):this._renderImageMask(e,400),I=v.tsx("form",{afterCreate:_.storeNode,afterRemoved:_.discardNode,bind:this,"data-node-ref":"_updateAttachmentForm",onsubmit:t=>this._submitUpdateAttachment(t,e)},v.tsx("div",{class:w.metadata},y,f),g,v.tsx("div",{class:w.actions},h,b,u));return v.tsx("div",{class:w.formNode,key:"edit-form-container"},A,I)}_renderImageMask(e,t){return e?"file"in e?this._renderGenericImageMask(e.file.name,e.file.type):this._renderImageMaskForAttachment(e,t):null}_renderGenericImageMask(e,t){const{supportsResizeAttachments:s}=this.viewModel,i=h.getIconPath(t),a={[w.itemImageResizable]:s};return v.tsx("div",{class:this.classes(w.itemMaskIcon,w.itemMask),key:i},v.tsx("img",{alt:e,class:this.classes(a,w.itemImage),src:i,title:e}))}_renderImageMaskForAttachment(e,t){const{supportsResizeAttachments:s}=this.viewModel;if(!e)return null;const{contentType:i,name:a,url:n}=e;if(!s||!h.isSupportedImage(i))return this._renderGenericImageMask(a,i);const l=this._getCSSTransform(e),o=l?{transform:l,"image-orientation":"none"}:{},r=`${n}${n?.includes("?")?"&":"?"}w=${t}`,d={[w.itemImageResizable]:s};return v.tsx("div",{class:this.classes(w.itemMask),key:r},v.tsx("img",{alt:a,class:this.classes(d,w.itemImage),src:r,styles:o,title:a}))}_renderFile(e){const{file:t}=e;return v.tsx("li",{class:w.item,key:t},v.tsx("button",{"aria-label":this.messages.attachmentDetails,bind:this,class:w.itemButton,key:"details-button",onclick:()=>this._startEditFile(e),title:this.messages.attachmentDetails,type:"button"},this._renderImageMask(e),v.tsx("label",{class:w.itemLabel},v.tsx("span",{class:w.itemFilename},t.name||this.messages.noTitle),v.tsx("span",{"aria-hidden":"true",class:this.classes(w.itemChevronIcon,_.isRTL(this.container)?b.legacyIcon.left:b.legacyIcon.right)}))))}_renderAttachmentInfo({attachmentInfo:e,displayType:t}){const{viewModel:s,effectiveDisplayType:i}=this,{capabilities:a,supportsResizeAttachments:n}=s,{contentType:l,name:o,url:r}=e,d=this._renderImageMask(e,"list"===t?48:400),c=a.editing?v.tsx("span",{"aria-hidden":"true",class:this.classes(w.itemChevronIcon,_.isRTL(this.container)?b.legacyIcon.left:b.legacyIcon.right)}):null,m=[d,"preview"===i&&n&&h.isSupportedImage(l)?null:v.tsx("label",{class:w.itemLabel},v.tsx("span",{class:w.itemFilename},o||this.messages.noTitle),c)],u=a.editing?v.tsx("button",{"aria-label":this.messages.attachmentDetails,bind:this,class:w.itemButton,"data-attachment-info-id":e.id,key:"details-button",onclick:()=>this._startEditAttachment(e),title:this.messages.attachmentDetails,type:"button"},m):v.tsx("a",{class:w.itemButton,href:r??void 0,key:"details-link",rel:"noreferrer",target:"_blank"},m);return v.tsx("li",{class:w.item,key:e},u)}_renderAttachmentContainer(){const{effectiveDisplayType:e,viewModel:t,visibleElements:s}=this,{attachmentInfos:i,capabilities:a,fileInfos:n}=t,l=!!i?.length,o=!!n?.length,r={[w.containerList]:"preview"!==e,[w.containerPreview]:"preview"===e},d=a.editing&&a.operations?.add&&s.addButton?v.tsx("button",{bind:this,class:this.classes(p.globalCss.button,p.globalCss.buttonTertiary,w.addAttachmentButton),onclick:()=>this._startAddAttachment(),type:"button"},v.tsx("span",{"aria-hidden":"true",class:this.classes(w.itemAddIcon,b.legacyIcon.plus)}),this.messages.add):void 0,c=l?v.tsx("ul",{class:w.items,key:"attachments-list"},i.toArray().map((t=>this._renderAttachmentInfo({attachmentInfo:t,displayType:e})))):void 0,m=o?v.tsx("ul",{class:w.items,key:"file-list"},n.toArray().map((e=>this._renderFile(e)))):void 0,h=o||l?void 0:v.tsx("div",{class:p.globalCss.empty},this.messages.noAttachments);return v.tsx("div",{class:this.classes(w.container,r),key:"attachments-container"},c,m,h,d)}_modeChanged(){this._set("error",null),this._set("selectedFile",null)}_handleFileInputChange(e){const t=e.target,s=t.files?.item(0);this._set("selectedFile",s)}_submitDeleteAttachment(e,t){e.preventDefault(),t&&("file"in t?this.deleteFile(t.file):t&&this.deleteAttachment(t))}_submitAddAttachment(e){e.preventDefault(),this.viewModel.filesEnabled?this.addFile():this.addAttachment()}_submitUpdateAttachment(e,t){e.preventDefault(),t&&"file"in t?this.updateFile():this.updateAttachment()}_startEditAttachment(e){const{viewModel:t}=this;t.activeFileInfo=null,t.activeAttachmentInfo=e,t.mode="edit"}_startEditFile(e){const{viewModel:t}=this;t.activeAttachmentInfo=null,t.activeFileInfo=e,t.mode="edit"}_startAddAttachment(){this.viewModel.mode="add"}_cancelForm(e){e.preventDefault(),this.viewModel.mode="view"}_getCSSTransform(e){const{orientationInfo:t}=e;return!this._supportsImageOrientation&&t?[t.rotation?`rotate(${t.rotation}deg)`:"",t.mirrored?"scaleX(-1)":""].join(" "):""}};t.__decorate([n.property()],I.prototype,"capabilities",null),t.__decorate([n.property()],I.prototype,"displayType",void 0),t.__decorate([n.property({readOnly:!0})],I.prototype,"effectiveDisplayType",null),t.__decorate([n.property()],I.prototype,"graphic",null),t.__decorate([n.property()],I.prototype,"icon",null),t.__decorate([n.property()],I.prototype,"label",null),t.__decorate([n.property(),g.messageBundle("esri/widgets/Attachments/t9n/Attachments")],I.prototype,"messages",void 0),t.__decorate([n.property(),g.messageBundle("esri/core/t9n/Units")],I.prototype,"messagesUnits",void 0),t.__decorate([n.property({readOnly:!0})],I.prototype,"selectedFile",void 0),t.__decorate([n.property({readOnly:!0})],I.prototype,"submitting",void 0),t.__decorate([n.property({readOnly:!0})],I.prototype,"error",void 0),t.__decorate([n.property({type:m})],I.prototype,"viewModel",void 0),t.__decorate([n.property()],I.prototype,"visibleElements",void 0),t.__decorate([l.cast("visibleElements")],I.prototype,"castVisibleElements",null),I=t.__decorate([d.subclass("esri.widgets.Attachments")],I);return I}));
