/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../assets","../core/reactiveUtils","../core/accessorSupport/decorators/property","../core/has","../core/Logger","../core/RandomLCG","../core/accessorSupport/decorators/subclass","../support/basemapUtils","./Widget","./BasemapGallery/BasemapGalleryViewModel","./BasemapGallery/css","../chunks/componentsUtils","./support/globalCss","./support/Heading","./support/decorators/accessibleHandler","./support/decorators/messageBundle","./support/jsxFactory","./support/widgetUtils"],(function(e,s,t,a,i,r,o,l,n,d,c,p,m,h,u,g,_,y,b,v){"use strict";const w={small:200,default:280,wide:420};let B=class extends c{constructor(e,s){super(e,s),this.disabled=!1,this.headingLevel=2,this.messages=null,this.viewModel=new p,this._focusBasemapItemEnabled=!1,this._container=null,this._width=0,this._onContainerCreated=e=>{this._container=e}}initialize(){this.addHandles([v.onResize((()=>this._container),(({contentRect:e})=>{this._width=e.width})),a.when((()=>this.source),(()=>this.viewModel.loadSource()),{sync:!0,initial:!0})])}loadDependencies(){return h.loadCalciteComponents({scrim:()=>new Promise(((s,t)=>e(["../chunks/calcite-scrim"],s,t))),chip:()=>new Promise(((s,t)=>e(["../chunks/calcite-chip"],s,t)))})}get activeBasemap(){return this.viewModel.activeBasemap}set activeBasemap(e){this.viewModel.activeBasemap=e}get icon(){return"basemap"}set icon(e){this._overrideIfSome("icon",e)}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}get source(){return this.viewModel.source}set source(e){this.viewModel.source=e}get view(){return this.viewModel.view}set view(e){this.viewModel.view=e}render(){const e="loading"===this.source.state,s=this.disabled||"disabled"===this.viewModel.state,t={[m.css.sourceLoading]:e,[u.globalCss.disabled]:s},a=this._width;a<=w.small||a>=w.wide?t[m.css.layoutGrid]=!0:a<w.default&&(t[m.css.narrowItems]=!0);const i=this._getContext();return b.tsx("div",{afterCreate:this._onContainerCreated,class:this.classes(m.css.base,u.globalCss.widget,u.globalCss.panel,t),key:"container",styles:{"--esri-basemap-gallery-small":`${w.small}px`}},0===this._width?null:i)}_getContext(){if("unsupported"===this.viewModel.state)return b.tsx("div",{class:u.globalCss.empty,key:"empty-message"},b.tsx(g.Heading,{level:this.headingLevel},this.messages.unsupported));if("loading"===this.source.state)return b.tsx("div",{class:m.css.loader,key:"loader"});const e=this.viewModel.items;return e.length>0?b.tsx("ul",{"aria-disabled":this.disabled,"aria-label":this.label,bind:this,class:m.css.itemContainer,key:"item-container",onkeydown:this._handleKeyDown,role:"radiogroup"},e.map(((e,s)=>this._renderBasemapGalleryItem(e,s))).toArray()):b.tsx("div",{class:u.globalCss.empty,key:"empty-message"},b.tsx(g.Heading,{level:this.headingLevel},this.messages.noBasemaps))}_getRoundRobinIndex(e,s){return(e+s)%s}_handleKeyDown(e){const{key:s}=e;if(!["ArrowUp","ArrowDown","ArrowRight","ArrowLeft"].includes(s))return;e.preventDefault();const{items:t,activeBasemapIndex:a}=this.viewModel,i="ArrowUp"===s||"ArrowLeft"===s?this._getRoundRobinIndex(Math.max(a-1,-1),t.length):this._getRoundRobinIndex(a+1,t.length),r=t.at(i);"ready"===r?.state&&(this.viewModel.activeBasemap=r.basemap),this._focusBasemapItemEnabled=!0}_focusBasemapItem(e){this._focusBasemapItemEnabled&&0===e.tabIndex&&(e.focus(),this._focusBasemapItemEnabled=!1)}_handleClick(e){const s=e.currentTarget["data-item"];"ready"===s.state&&(this.viewModel.activeBasemap=s.basemap)}_renderBasemapGalleryItem(e,s){const a=d.getBasemapThumbnailUrl(e.basemap)||t.getAssetUrl("esri/themes/base/images/basemap-toggle-64.svg"),i=e.basemap.title,r=e.basemap.portalItem?.snippet,o=e.error?.message||r||i,{viewModel:{state:l,activeBasemapIndex:n}}=this,c=this.disabled||"disabled"===l,p=n===s,h=p||-1===n&&0===s?0:-1,g="loading"===l,_={[m.css.selectedItem]:p,[m.css.itemError]:"error"===e.state},y=`basemapgallery-item-${e.uid}`;return b.tsx("li",{afterUpdate:this._focusBasemapItem,"aria-checked":p.toString(),"aria-disabled":c.toString(),"aria-labelledby":y,bind:this,class:this.classes(m.css.item,_),"data-item":e,key:e.uid,onclick:this._handleClick,onkeydown:this._handleClick,role:"radio",tabIndex:h,title:o},b.tsx("img",{alt:"",class:m.css.itemThumbnail,src:a}),b.tsx("div",{class:m.css.itemContent,key:"content"},b.tsx("div",{class:m.css.itemTitle,key:"title"},b.tsx("span",{id:y},i)),d.isBasemap3D(e.basemap)?this._renderTags(e.basemap):null),"loading"===e.state||p&&g?b.tsx("calcite-scrim",null,b.tsx("span",{"aria-hidden":"true",class:u.globalCss.loaderAnimation,key:"loader",role:"presentation"})):null)}_renderTags(e){return b.tsx("div",{class:m.css.itemTagsContainer,key:"tag"},this._render3DTag(),d.isBasemapInBeta(e)?this._renderBetaTag():null)}_render3DTag(){const{messages:e}=this;return b.tsx("calcite-chip",{key:"tag-3d",scale:"s",value:e.tag3D},this.messages.tag3D)}_renderBetaTag(){const{messages:e}=this;return b.tsx("calcite-chip",{appearance:"outline-fill",key:"tag-beta",scale:"s",value:e.tagBeta},this.messages.tagBeta)}};s.__decorate([i.property()],B.prototype,"activeBasemap",null),s.__decorate([i.property()],B.prototype,"disabled",void 0),s.__decorate([i.property()],B.prototype,"headingLevel",void 0),s.__decorate([i.property()],B.prototype,"icon",null),s.__decorate([i.property()],B.prototype,"label",null),s.__decorate([i.property(),y.messageBundle("esri/widgets/BasemapGallery/t9n/BasemapGallery")],B.prototype,"messages",void 0),s.__decorate([i.property()],B.prototype,"source",null),s.__decorate([i.property()],B.prototype,"view",null),s.__decorate([i.property()],B.prototype,"viewModel",void 0),s.__decorate([i.property()],B.prototype,"_focusBasemapItemEnabled",void 0),s.__decorate([i.property()],B.prototype,"_container",void 0),s.__decorate([i.property()],B.prototype,"_width",void 0),s.__decorate([_.accessibleHandler()],B.prototype,"_handleClick",null),B=s.__decorate([n.subclass("esri.widgets.BasemapGallery")],B);return B}));
