/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../core/Collection","../core/deprecate","../core/Identifiable","../core/Logger","../core/ReactiveMap","../core/reactiveUtils","../core/accessorSupport/decorators/property","../core/has","../core/RandomLCG","../core/accessorSupport/decorators/subclass","./Widget","./BasemapLayerList/BasemapLayerListViewModel","./BasemapLayerList/BasemapLayerListVisibleElements","./BasemapLayerList/css","./LayerList/LayerListItem","./LayerList/ListItem","./LayerList/support/layerListUtils","../chunks/componentsUtils","./support/globalCss","./support/Heading","./support/listUtils","./support/widgetUtils","./support/decorators/messageBundle","./support/decorators/vmEvent","./support/jsxFactory"],(function(e,t,i,s,o,r,l,a,n,d,c,p,h,m,u,_,y,g,b,f,L,v,I,w,E,F,C){"use strict";const T=e=>Object.freeze(Object.defineProperty({__proto__:null,default:e},Symbol.toStringTag,{value:"Module"})),M=i.ofType(g),P=".*\\S+.*",O="data-basemap-layer-type";let x=class extends(o.IdentifiableMixin(h)){constructor(e,t){super(e,t),this._activeItem=null,this._tooltipReferenceMap=new Map,this._editTitleInput=null,this._focusRootFlowItem=!1,this._focusPanelFlowItem=!1,this._focusLayerFlowItem=null,this._focusEditingFlowItem=!1,this._layerListMap=new l,this._lastDragDetail=null,this._selectedDragItemLayerUid=null,this._rootGroupUid=`basemap-${this.uid}`,this._openedLayersController=null,this.catalogLayerList=null,this.catalogOptions=null,this.collapsed=!1,this.dragEnabled=!1,this.editingTitle=!1,this.filterPlaceholder="",this.baseFilterText="",this.referenceFilterText="",this.listItemCanGiveFunction=null,this.listItemCanReceiveFunction=null,this.headingLevel=2,this.knowledgeGraphOptions=null,this.layerTablesEnabled=new i(["knowledge-graph"]),this.mapImageOptions=null,this.messages=null,this.messagesCommon=null,this.minFilterItems=b.minFilterItems,this.openedLayers=new i,this.openedLayerLists=new i,this.tableList=null,this.selectedItems=new M,this.selectionMode="none",this.tileOptions=null,this.viewModel=new m,this.visibilityAppearance="default",this.visibleElements=new u,this._canMove=({dragEl:e,fromEl:t,toEl:i},s)=>{const o="pull"===s?this.listItemCanGiveFunction:this.listItemCanReceiveFunction,r=b.getItem(e);if(!r?.sortable)return!1;const l=b.getItem(t),a=b.getLayerType(t),n=b.getItem(i),d=b.getLayerType(i),c=!!a&&!!d&&a===d,p={selected:r,from:l,to:n},h=t.group,m=i.group,u=l?.layer?.type??"",_=n?.layer?.type??"",y=new Set(["map-image","catalog","knowledge-graph"]),g="sublayer";return h&&m&&"function"==typeof o?o.call(null,p):c&&!y.has(u)&&!y.has(_)&&r?.layer?.type!==g},this._onTriggerAction=(e,t)=>{this.triggerAction(e,t)},this._onTooltipReferenceChange=(e,t)=>{t?this._tooltipReferenceMap.set(e,t):this._tooltipReferenceMap.delete(e)},this._onSelectedDragItemLayerUidChange=e=>{this._selectedDragItemLayerUid=e},this._onTablesOpen=e=>{this.openedLayers.push(e.layer),this._focusLayerFlowItem=e.layer.uid},this._onPanelOpen=()=>{this._focusPanelFlowItem=!0},this._onCatalogOpen=e=>{this.openedLayers.push(e.layer.parent),this._focusLayerFlowItem=e.layer.uid},this._clearActiveItem=()=>{this._activeItem=null},this._setActiveItem=e=>{if("default"!==this.visibilityAppearance)return;const t=Array.from(e.composedPath()).find((e=>e.classList?.contains(_.css.item)));this._activeItem=b.getItem(t)},this._onCalciteListOrderChange=e=>{const{_lastDragDetail:t}=this,{toEl:i,fromEl:s,dragEl:o,newIndex:r}=e;if(!s||!i||t?.newIndex===r&&t?.dragEl===o&&t?.toEl===i&&t?.fromEl===s)return;this._lastDragDetail=e;const l=s,a=i;if(l!==a)this._moveLayerFromChildList({toEl:a,fromEl:l,dragEl:o,newIndex:r});else{const e=Array.from(s.children).filter((e=>e?.matches("calcite-list-item"))).map((e=>e.value));this._sortLayers(l,e)}}}initialize(){this.addHandles(a.on((()=>this.openedLayers),"change",(()=>this._handleOpenedLayersChange()),a.initial))}normalizeCtorArgs(e){return null!=e?.editingEnabled&&null!=e.visibleElements?{...e,visibleElements:new u({...e.visibleElements,editTitleButton:e.editingEnabled})}:e}loadDependencies(){return f.loadCalciteComponents({action:()=>new Promise(((t,i)=>e(["../chunks/calcite-action"],t,i))),block:()=>new Promise(((t,i)=>e(["../chunks/calcite-block"],t,i))),label:()=>new Promise(((t,i)=>e(["../chunks/calcite-label"],t,i))),input:()=>new Promise(((t,i)=>e(["../chunks/calcite-input"],t,i))),button:()=>new Promise(((t,i)=>e(["../chunks/calcite-button"],t,i))),flow:()=>new Promise(((t,i)=>e(["../chunks/calcite-flow"],t,i))),"flow-item":()=>new Promise(((t,i)=>e(["../chunks/calcite-flow-item"],t,i))),list:()=>new Promise(((t,i)=>e(["../chunks/calcite-list"],t,i))),notice:()=>new Promise(((t,i)=>e(["../chunks/calcite-notice"],t,i))),tooltip:()=>new Promise(((t,i)=>e(["../chunks/calcite-tooltip"],t,i)))})}destroy(){this._tooltipReferenceMap.clear(),this._destroyOpenedLayerLists()}get _totalBaseItems(){return this.viewModel.baseItems.flatten((e=>e.children.filter((e=>"catalog-dynamic-group"!==e.layer.type)))).length}get _totalReferenceItems(){return this.viewModel.referenceItems.flatten((e=>e.children.filter((e=>"catalog-dynamic-group"!==e.layer.type)))).length}get _baseFilterEnabled(){return this._totalBaseItems>=this.minFilterItems&&this.visibleElements.filter}get _referenceFilterEnabled(){return this._totalReferenceItems>=this.minFilterItems&&this.visibleElements.filter}get _renderedOpenLayerFlowItems(){return this.openedLayers.toArray().map((e=>this._renderLayerFlowItem(e)))}get basemapTitle(){return this.viewModel.basemapTitle}set basemapTitle(e){this.viewModel.basemapTitle=e}get baseListItemCreatedFunction(){return this.viewModel.baseListItemCreatedFunction}set baseListItemCreatedFunction(e){this.viewModel.baseListItemCreatedFunction=e}get editingEnabled(){return s.deprecatedProperty(r.getLogger(this),"editingEnabled",{replacement:"selectionMode, dragEnabled, visibleElements.editTitleButton",version:"4.29",warnOnce:!0}),"none"!==this.selectionMode&&this.dragEnabled&&this.visibleElements.editTitleButton}set editingEnabled(e){s.deprecatedProperty(r.getLogger(this),"editingEnabled",{replacement:"selectionMode, dragEnabled, visibleElements.editTitleButton",version:"4.29",warnOnce:!0}),this.dragEnabled=e,this.visibleElements.editTitleButton=e,this.selectionMode=e?this.multipleSelectionEnabled?"multiple":"single":"none"}get icon(){return"layers"}set icon(e){this._overrideIfSome("icon",e)}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}get multipleSelectionEnabled(){return s.deprecatedProperty(r.getLogger(this),"multipleSelectionEnabled",{replacement:"selectionMode",version:"4.29",warnOnce:!0}),"multiple"===this.selectionMode}set multipleSelectionEnabled(e){s.deprecatedProperty(r.getLogger(this),"multipleSelectionEnabled",{replacement:"selectionMode",version:"4.29",warnOnce:!0}),this.selectionMode=e?"multiple":this.editingEnabled?"single":"none"}get referenceListItemCreatedFunction(){return this.viewModel.referenceListItemCreatedFunction}set referenceListItemCreatedFunction(e){this.viewModel.referenceListItemCreatedFunction=e}get baseItems(){return this.viewModel.baseItems}get referenceItems(){return this.viewModel.referenceItems}get view(){return this.viewModel.view}set view(e){this.viewModel.view=e}triggerAction(e,t){return this.viewModel.triggerAction(e,t)}render(){const{state:e}=this.viewModel,t={[L.globalCss.hidden]:"loading"===e,[L.globalCss.disabled]:"disabled"===e};return C.tsx("div",{class:this.classes(_.css.base,L.globalCss.widget,L.globalCss.panel,t)},this._renderItems())}async _createCatalogLayerList(t){const{default:i}=await new Promise(((t,i)=>e(["./CatalogLayerList"],(e=>t(T(e))),i))),{headingLevel:s,catalogOptions:o,view:r,filterPlaceholder:l,minFilterItems:a,selectionMode:n,visibilityAppearance:d,_onCatalogOpen:c,_onTablesOpen:p,layerTablesEnabled:h}=this;return new i({headingLevel:s,view:r,filterPlaceholder:l,minFilterItems:a,selectionMode:n,visibilityAppearance:d,...o,catalogLayer:t,layerTablesEnabled:h,onCatalogOpen:c,onTablesOpen:p})}_getTableListParams(e){switch(e.type){case"knowledge-graph":return{...this.knowledgeGraphOptions,tables:e.tables};case"map-image":return{...this.mapImageOptions,tables:e.subtables};case"tile":return{...this.tileOptions,tables:e.subtables};default:return null}}async _createTableList(t){const{default:i}=await new Promise(((t,i)=>e(["./TableList"],(e=>t(T(e))),i))),{headingLevel:s,selectionMode:o,dragEnabled:r}=this;return new i({headingLevel:s,selectionMode:o,dragEnabled:r,...this._getTableListParams(t)})}async _createFlowList(e,t){const{_layerListMap:i}=this,s=i.get(e);if(s)return s;const o="catalog"===e.type?await this._createCatalogLayerList(e):await this._createTableList(e);return t.aborted||i.set(e,o),o}async _handleOpenedLayersChange(){const{_layerListMap:e,openedLayers:t,openedLayerLists:i}=this;this._openedLayersController?.abort();const s=new AbortController,{signal:o}=s;this._openedLayersController=s,e.forEach(((i,s)=>{t.includes(s)||(i.destroy(),e.delete(s))}));const r=await Promise.all(t.map((e=>this._createFlowList(e,o))));if(o.aborted)return;i.removeAll(),i.addMany(r);const l=i.at(-1);l?"catalogLayer"in l?(this._set("catalogLayerList",l),this._set("tableList",null)):(this._set("catalogLayerList",null),this._set("tableList",l)):(this._set("catalogLayerList",null),this._set("tableList",null))}_destroyOpenedLayerLists(){this.openedLayerLists.destroyAll(),this.openedLayers.removeAll(),this._layerListMap.clear()}_renderItemTooltip(e){return e?C.tsx("calcite-tooltip",{key:`tooltip-${e.layer.uid}`,referenceElement:this._tooltipReferenceMap.get(e.layer.uid)},this.messages.layerIncompatibleTooltip):null}_renderItemTooltipNodes(e){return e.incompatible?this._renderItemTooltip(e):e.children?.filter((e=>!e.hidden)).toArray().map((e=>this._renderItemTooltipNodes(e)))}_renderItemTooltips(e){return e?.toArray().map((e=>this._renderItemTooltipNodes(e)))}_focusLayerFlowItemNode(e){this._focusLayerFlowItem===e.dataset.layerUid&&(this._focusLayerFlowItem=null,w.setFocus(e))}_renderPanelFlowItems(e){return e?e.flatten((e=>e.children)).filter((({hidden:e,panel:t})=>!e&&t?.open&&!t.disabled&&t.flowEnabled)).toArray().map((({title:e,panel:t})=>{const i=()=>this._handlePanelFlowItemBack(t);return C.tsx("calcite-flow-item",{afterCreate:this._focusPanelFlowItemNode,afterUpdate:this._focusPanelFlowItemNode,bind:this,description:e,heading:t.title,headingLevel:this.headingLevel,key:`flow-panel-${t.uid}`,onCalciteFlowItemBack:e=>{e.preventDefault(),i()}},t.render(),C.tsx("calcite-button",{appearance:"transparent",onclick:i,slot:"footer-actions",width:"full"},this.messagesCommon.back))})):[]}_handlePanelFlowItemBack(e){e.open=!1,this._focusRootFlowItem=!0}_focusEditingFlowItemNode(e){this._focusEditingFlowItem&&(this._focusEditingFlowItem=!1,w.setFocus(e))}_focusRootFlowItemNode(e){this._focusRootFlowItem&&(this._focusRootFlowItem=!1,w.setFocus(e))}_focusPanelFlowItemNode(e){this._focusPanelFlowItem&&(this._focusPanelFlowItem=!1,w.setFocus(e))}_renderItem(e,t,i,s){return C.tsx(y,{activeItem:this._activeItem,canMove:this._canMove,css:_.css,dragEnabled:!t&&this.dragEnabled,item:e,key:`layerListItem-${e.layer.uid}`,layerTablesEnabled:this.layerTablesEnabled,listModeDisabled:this.viewModel.listModeDisabled,messages:this.messages,messagesCommon:this.messagesCommon,parent:i,parentTitles:s,rootGroupUid:this._rootGroupUid,selectedDragItemLayerUid:this._selectedDragItemLayerUid,selectedItems:this.selectedItems,selectionMode:this.selectionMode,visibilityAppearance:this.visibilityAppearance,visibleElements:this.visibleElements,onAction:this._onTriggerAction,onCatalogOpen:this._onCatalogOpen,onPanelOpen:this._onPanelOpen,onSelectedDragItemLayerUidChange:this._onSelectedDragItemLayerUidChange,onTablesOpen:this._onTablesOpen,onTooltipReferenceChange:this._onTooltipReferenceChange})}_moveLayerFromChildList({toEl:e,fromEl:t,dragEl:i,newIndex:s}){const o=b.getItem(i),r=b.getItem(e),l=b.getItem(t),a=k(t),n=k(e);a&&n&&this.viewModel.moveListItem({targetItem:o,fromParentItem:l,toParentItem:r,newIndex:s,from:a,to:n})}_handleCalciteListDragEnd(e){const{fromEl:t,dragEl:i,oldIndex:s}=e;t.insertBefore(i,t.children[s])}_sortLayers(e,t){if(e)if(e.group===this._rootGroupUid){const i=k(e),s="base"===i?this.view?.map?.basemap?.baseLayers:"reference"===i?this.view?.map?.basemap?.referenceLayers:null;b.sortLayersToIds(s,t)}else{const i=b.getItem(e);if(!i)return;b.sortChildLayersToIds(i,t)}}_handleCalciteListChange(e){const{selectionMode:t,selectedItems:i}=this;if("none"===t)return;const s=e.target.selectedItems.map((e=>b.getItem(e))).filter(Boolean);i.removeAll(),i.addMany(s)}_renderEditingInput(){const{messages:e}=this,{basemapTitle:t}=this.viewModel;return C.tsx("div",{class:_.css.editing},C.tsx("calcite-label",null,e.basemapTitle,C.tsx("calcite-input",{afterCreate:e=>this._editTitleInput=e,label:e.basemapTitle,name:"basemaptitle",pattern:P,placeholder:e.basemapTitle,required:!0,title:e.basemapTitle,type:"text",value:t??void 0})))}_renderCancelButton(){const{messagesCommon:{cancel:e}}=this;return C.tsx("calcite-button",{appearance:"outline",bind:this,label:e,onclick:this._toggleEditingTitle,slot:"footer",title:e,width:"half"},e)}_renderSubmitButton(){const{messagesCommon:e}=this;return C.tsx("calcite-button",{label:e.form.submit,slot:"footer",title:e.form.submit,type:"submit",width:"half"},e.form.ok)}_renderEditingForm(){return this.editingTitle?C.tsx("form",{bind:this,onsubmit:this._formSubmit},C.tsx("calcite-flow-item",{afterCreate:this._focusEditingFlowItemNode,afterUpdate:this._focusEditingFlowItemNode,bind:this,heading:this.visibleElements.heading?this.messages.basemapTitle:void 0,headingLevel:this.headingLevel,onCalciteFlowItemBack:e=>{e.preventDefault(),this._toggleEditingTitle()}},this._renderEditingInput(),this._renderCancelButton(),this._renderSubmitButton())):null}_renderEditTitleButton(){const{editingTitle:e,visibleElements:t,messagesCommon:i}=this,s=i.edit;return t.editTitleButton&&!e?C.tsx("calcite-action",{bind:this,icon:"pencil",onclick:this._toggleEditingTitle,slot:"header-actions-end",text:s,title:s}):null}_renderNoLayersInfoMessage(e){return C.tsx("div",{slot:"message"},e)}_renderNoLayersInfo(e,t){return C.tsx("div",{class:_.css.itemMessage},C.tsx("calcite-notice",{icon:"information",key:t,kind:"info",open:!0,width:"full"},this._renderNoLayersInfoMessage(e)))}_getFilteredItems(e){return e?.filter((e=>!e.hidden&&(this.visibleElements.errors||!e.error)))}_renderItems(){const{collapsed:e,visible:t,visibleElements:{closeButton:i,collapseButton:s,heading:o,flow:r},messages:l,viewModel:a,referenceItems:n,baseItems:d}=this,c=this.visibleElements.referenceLayers?this._getFilteredItems(n):null,p=this.visibleElements.baseLayers?this._getFilteredItems(d):null,h=[C.tsx("calcite-flow-item",{afterCreate:this._focusRootFlowItemNode,afterUpdate:this._focusRootFlowItemNode,bind:this,closable:i,closed:!t,collapsed:e,collapsible:s,heading:o?a.basemapTitle??l.widgetLabel:void 0,headingLevel:this.headingLevel,key:"root-flow-item",onCalciteFlowItemClose:()=>this.visible=!1},this._renderEditTitleButton(),this._renderReferenceSection(c),this._renderBaseSection(p,1===p?.length)),this._renderEditingForm(),this._renderPanelFlowItems(p),this._renderPanelFlowItems(c),this._renderedOpenLayerFlowItems];return t?[r?C.tsx("calcite-flow",{key:"root-flow"},h):h,this._renderItemTooltips(c),this._renderItemTooltips(p)]:null}_renderLayerFlowItem(e){const{messages:t,openedLayers:i}=this,s=e.title||this.messages.untitledLayer;return C.tsx("calcite-flow-item",{afterCreate:this._focusLayerFlowItemNode,afterUpdate:this._focusLayerFlowItemNode,bind:this,"data-layer-uid":e.uid,description:s,heading:t["catalog"===e.type?"catalogLayers":"tables"],headingLevel:this.headingLevel,key:`flow-layer-list-${e.uid}`,onCalciteFlowItemBack:e=>{e.preventDefault(),i.pop();const t=i.at(-1);t?this._focusLayerFlowItem=t.uid:this._focusRootFlowItem=!0}},this._layerListMap.get(e)?.render())}_renderList(e,t,i){const{messages:s,dragEnabled:o,selectionMode:r,filterPlaceholder:l,baseFilterText:a,referenceFilterText:n,_baseFilterEnabled:d,_referenceFilterEnabled:c,_rootGroupUid:p}=this,h="reference"===t?s.noReferenceLayers:s.noBaseLayers,m="reference"===t?c:d;return C.tsx("calcite-block",{class:_.css.section,collapsible:!0,heading:"reference"===t?s.referenceHeading:s.baseHeading,headingLevel:v.incrementHeadingLevel(this.headingLevel),key:`block-${t}`,open:!0},0===e?.length?this._renderNoLayersInfo(h,t):null,C.tsx("calcite-list",{afterCreate:e=>{e.addEventListener("focusin",this._setActiveItem),e.addEventListener("focusout",this._clearActiveItem)},afterRemoved:e=>{e.removeEventListener("focusin",this._setActiveItem),e.removeEventListener("focusout",this._clearActiveItem)},canPull:e=>this._canMove(e,"pull"),canPut:e=>this._canMove(e,"put"),filterProps:I.calciteListFilterProps,[O]:t,"data-layer-type":p,dragEnabled:o,filterEnabled:m,filterPlaceholder:l,filterText:m?"reference"===t?n:a:"",group:p,key:`list-${t}`,label:s.widgetLabel,onmouseleave:this._clearActiveItem,onmouseover:this._setActiveItem,selectionAppearance:"border",selectionMode:r,onCalciteListChange:e=>this._handleCalciteListChange(e),onCalciteListDragEnd:e=>this._handleCalciteListDragEnd(e.detail),onCalciteListFilter:e=>this["reference"===t?"referenceFilterText":"baseFilterText"]=e.target?.filterText??"",onCalciteListOrderChange:e=>this._onCalciteListOrderChange(e.detail)},e?.toArray().map((e=>this._renderItem(e,i))),e?.length&&m?C.tsx("div",{class:_.css.filterNoResults,slot:"filter-no-results"},C.tsx("calcite-notice",{kind:"info",open:!0,width:"full"},this._renderNoLayersInfoMessage(h))):null))}_renderBaseSection(e,t){return this.visibleElements.baseLayers?this._renderList(e,"base",t):null}_renderReferenceSection(e){return this.visibleElements.referenceLayers?this._renderList(e,"reference",!1):null}_toggleEditingTitle(){const{editingTitle:e}=this,t=!e;this.editingTitle=t,t?this._focusEditingFlowItem=!0:this._focusRootFlowItem=!0}_formSubmit(e){e.preventDefault();const t=this._editTitleInput?.value;t?.trim()&&(this.basemapTitle=t),this._toggleEditingTitle()}};function k(e){return e?.closest(`[${O}]`)?.getAttribute(O)}t.__decorate([n.property()],x.prototype,"_activeItem",void 0),t.__decorate([n.property()],x.prototype,"_tooltipReferenceMap",void 0),t.__decorate([n.property()],x.prototype,"_focusRootFlowItem",void 0),t.__decorate([n.property()],x.prototype,"_focusPanelFlowItem",void 0),t.__decorate([n.property()],x.prototype,"_focusLayerFlowItem",void 0),t.__decorate([n.property()],x.prototype,"_focusEditingFlowItem",void 0),t.__decorate([n.property()],x.prototype,"_layerListMap",void 0),t.__decorate([n.property()],x.prototype,"_totalBaseItems",null),t.__decorate([n.property()],x.prototype,"_totalReferenceItems",null),t.__decorate([n.property()],x.prototype,"_baseFilterEnabled",null),t.__decorate([n.property()],x.prototype,"_referenceFilterEnabled",null),t.__decorate([n.property()],x.prototype,"_renderedOpenLayerFlowItems",null),t.__decorate([n.property()],x.prototype,"basemapTitle",null),t.__decorate([n.property({readOnly:!0})],x.prototype,"catalogLayerList",void 0),t.__decorate([n.property()],x.prototype,"catalogOptions",void 0),t.__decorate([n.property()],x.prototype,"collapsed",void 0),t.__decorate([n.property()],x.prototype,"dragEnabled",void 0),t.__decorate([n.property()],x.prototype,"editingTitle",void 0),t.__decorate([n.property()],x.prototype,"filterPlaceholder",void 0),t.__decorate([n.property()],x.prototype,"baseFilterText",void 0),t.__decorate([n.property()],x.prototype,"referenceFilterText",void 0),t.__decorate([n.property()],x.prototype,"listItemCanGiveFunction",void 0),t.__decorate([n.property()],x.prototype,"listItemCanReceiveFunction",void 0),t.__decorate([n.property()],x.prototype,"baseListItemCreatedFunction",null),t.__decorate([n.property()],x.prototype,"editingEnabled",null),t.__decorate([n.property()],x.prototype,"headingLevel",void 0),t.__decorate([n.property()],x.prototype,"icon",null),t.__decorate([n.property()],x.prototype,"knowledgeGraphOptions",void 0),t.__decorate([n.property()],x.prototype,"label",null),t.__decorate([n.property()],x.prototype,"layerTablesEnabled",void 0),t.__decorate([n.property()],x.prototype,"mapImageOptions",void 0),t.__decorate([n.property(),E.messageBundle("esri/widgets/BasemapLayerList/t9n/BasemapLayerList")],x.prototype,"messages",void 0),t.__decorate([n.property(),E.messageBundle("esri/t9n/common")],x.prototype,"messagesCommon",void 0),t.__decorate([n.property()],x.prototype,"minFilterItems",void 0),t.__decorate([n.property()],x.prototype,"multipleSelectionEnabled",null),t.__decorate([n.property({readOnly:!0})],x.prototype,"openedLayers",void 0),t.__decorate([n.property({readOnly:!0})],x.prototype,"openedLayerLists",void 0),t.__decorate([n.property()],x.prototype,"referenceListItemCreatedFunction",null),t.__decorate([n.property({readOnly:!0})],x.prototype,"tableList",void 0),t.__decorate([n.property({readOnly:!0})],x.prototype,"baseItems",null),t.__decorate([n.property({readOnly:!0})],x.prototype,"referenceItems",null),t.__decorate([n.property()],x.prototype,"selectedItems",void 0),t.__decorate([n.property()],x.prototype,"selectionMode",void 0),t.__decorate([n.property()],x.prototype,"tileOptions",void 0),t.__decorate([n.property()],x.prototype,"view",null),t.__decorate([F.vmEvent("trigger-action"),n.property({type:m})],x.prototype,"viewModel",void 0),t.__decorate([n.property()],x.prototype,"visibilityAppearance",void 0),t.__decorate([n.property({type:u,nonNullable:!0})],x.prototype,"visibleElements",void 0),x=t.__decorate([p.subclass("esri.widgets.BasemapLayerList")],x);return x}));
