/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../core/Collection","../../core/Evented","../../core/reactiveUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/Logger","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../LayerList/ListItem","../LayerList/support/layerListUtils"],(function(e,t,s,i,a,r,l,c,o,n,m){"use strict";const d={view:"view",basemap:"basemap",baseLayers:"base-layers",referenceLayers:"reference-layers",baseLayersListMode:"reference-layers-list-mode",referenceLayersListMode:"base-layers-list-mode",baseLayerViews:"base-layer-views",referenceLayerViews:"reference-layer-views",children:"children"},h="hide",y=t.ofType(n);let p=class extends s.EventedAccessor{constructor(e){super(e),this.baseItems=new y,this.baseListItemCreatedFunction=null,this.checkPublishStatusEnabled=!1,this.listModeDisabled=!1,this.referenceListItemCreatedFunction=null,this.referenceItems=new y,this.view=null,this._compileBaseList=this._compileBaseList.bind(this),this._compileReferenceList=this._compileReferenceList.bind(this)}initialize(){this.addHandles([i.watch((()=>[this.view?.map?.basemap,!0===this.view?.ready,this.view?.basemapView]),(()=>this._watchBasemapLayers()),i.initial),i.watch((()=>[this.baseListItemCreatedFunction,this.checkPublishStatusEnabled,this.listModeDisabled]),(()=>this._baseListItemCreatedFunctionChanged())),i.watch((()=>[this.referenceListItemCreatedFunction,this.checkPublishStatusEnabled,this.listModeDisabled]),(()=>this._referenceListItemCreatedFunctionChanged()))],d.view)}destroy(){this.view=null,this._removeAllBaseItems(),this._removeAllReferenceItems()}get basemapTitle(){return this.view?.map?.basemap?.title??null}set basemapTitle(e){this._override("basemapTitle",e)}get state(){return this.view?.ready?"ready":this.view?"loading":"disabled"}get totalBaseItems(){return this.baseItems.flatten((e=>e.children)).length}get totalReferenceItems(){return this.referenceItems.flatten((e=>e.children)).length}triggerAction(e,t){e&&!e.disabled&&this.emit("trigger-action",{action:e,item:t})}moveListItem({targetItem:e,fromParentItem:t,toParentItem:s,from:i,to:a,newIndex:r}){const l=e?.layer;if(!l||"subtype-sublayer"===l.type||"sublayer"===l.type)return;const c=this.view?.map?.basemap,o=c?.baseLayers,n=c?.referenceLayers,d=t?m.getItemLayers(t):"base"===i?o:n,h=s?m.getItemLayers(s):"base"===a?o:n;if(!d||!h)return;const{baseItems:y,referenceItems:p}=this,b="base"===i?y:p,L="base"===a?y:p,_=t?.children||b,u=s?.children||L,I=h.length-r;e.parent=s||null,_.remove(e),d.remove(l),u.includes(e)||u.add(e,I),h.includes(l)||h.add(l,I),this._compileLists()}_createItemChangeHandles({items:e,key:t,callback:s}){this.removeHandles(t),s(),e&&this.addHandles(e.on("change",(()=>s())),t)}_createListItem({layer:e,type:t}){const{view:s,baseListItemCreatedFunction:i,referenceListItemCreatedFunction:a,checkPublishStatusEnabled:r,listModeDisabled:l}=this;return new n({layer:e,checkPublishStatusEnabled:r,listItemCreatedFunction:"base"===t?i:a,listModeDisabled:l,view:s})}_watchLayersListMode({layers:e,key:t,callback:s}){this.removeHandles(t),e&&!this.listModeDisabled&&this.addHandles(i.watch((()=>e.filter((e=>"listMode"in e)).map((e=>e.listMode)).toArray()),(()=>s())),t)}_getViewableLayers(e){return e?this.listModeDisabled?e:e.filter((e=>m.findLayerListMode(e)!==h)):void 0}_compileListItems({layers:e,items:t,key:s,type:i,callback:a}){this._watchLayersListMode({layers:e,key:s,callback:a});const r=this._getViewableLayers(e);r?.length?(this._createNewItems({type:i,items:t,layers:r}),this._removeItems({items:t,layers:r}),this._sortItems(t,r)):"base"===i?this._removeAllBaseItems():this._removeAllReferenceItems()}_compileReferenceList(){const{referenceItems:e}=this,t=this.view?.map?.basemap?.referenceLayers;this._compileListItems({type:"reference",layers:t,items:e,key:d.referenceLayersListMode,callback:this._compileReferenceList})}_compileBaseList(){const{baseItems:e}=this,t=this.view?.map?.basemap?.baseLayers;this._compileListItems({type:"base",layers:t,items:e,key:d.baseLayersListMode,callback:this._compileBaseList})}_compileLists(){this._compileReferenceList(),this._compileBaseList()}_createNewItems({items:e,layers:t,type:s}){t?.forEach((t=>{e.some((e=>e.layer===t))||e.add(this._createListItem({type:s,layer:t}))}))}_removeItems({items:e,layers:t}){e&&e.forEach((s=>{if(!s)return;const i=t?.some((e=>s.layer===e));i||(this.removeHandles(`${d.children}-${s.uid}`),e.remove(s),s.destroy())}))}_sortItems(e,t){e&&t&&e.sort(((e,s)=>{const i=t.indexOf(e.layer),a=t.indexOf(s.layer);return i>a?-1:i<a?1:0}))}_removeAllBaseItems(){this.baseItems.drain((e=>{this.removeHandles(`${d.children}-${e.uid}`),e.destroy()}))}_removeAllReferenceItems(){this.referenceItems.drain((e=>{this.removeHandles(`${d.children}-${e.uid}`),e.destroy()}))}_baseListItemCreatedFunctionChanged(){this._removeAllBaseItems(),this._compileLists()}_referenceListItemCreatedFunctionChanged(){this._removeAllReferenceItems(),this._compileLists()}_watchBasemapLayers(){const{view:e}=this;if(this.removeHandles([d.baseLayers,d.referenceLayers,d.basemap,d.baseLayerViews,d.referenceLayerViews]),!e?.ready)return this._removeAllBaseItems(),void this._removeAllReferenceItems();this._compileLists(),this.addHandles([i.watch((()=>this.view?.map?.basemap?.baseLayers),(e=>this._createItemChangeHandles({items:e,key:d.baseLayers,callback:this._compileBaseList})),i.initial),i.watch((()=>this.view?.map?.basemap?.referenceLayers),(e=>this._createItemChangeHandles({items:e,key:d.referenceLayers,callback:this._compileReferenceList})),i.initial),i.watch((()=>this.view?.basemapView?.baseLayerViews),(e=>this._createItemChangeHandles({items:e,key:d.baseLayerViews,callback:this._compileBaseList})),i.initial),i.watch((()=>this.view?.basemapView?.referenceLayerViews),(e=>this._createItemChangeHandles({items:e,key:d.referenceLayerViews,callback:this._compileReferenceList})),i.initial)],d.basemap)}};e.__decorate([a.property({type:y,readOnly:!0})],p.prototype,"baseItems",void 0),e.__decorate([a.property()],p.prototype,"basemapTitle",null),e.__decorate([a.property()],p.prototype,"baseListItemCreatedFunction",void 0),e.__decorate([a.property()],p.prototype,"checkPublishStatusEnabled",void 0),e.__decorate([a.property({nonNullable:!0})],p.prototype,"listModeDisabled",void 0),e.__decorate([a.property()],p.prototype,"referenceListItemCreatedFunction",void 0),e.__decorate([a.property({type:y,readOnly:!0})],p.prototype,"referenceItems",void 0),e.__decorate([a.property({readOnly:!0})],p.prototype,"state",null),e.__decorate([a.property()],p.prototype,"totalBaseItems",null),e.__decorate([a.property()],p.prototype,"totalReferenceItems",null),e.__decorate([a.property()],p.prototype,"view",void 0),p=e.__decorate([o.subclass("esri.widgets.BasemapLayerList.BasemapLayerListViewModel")],p);return p}));
