/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../intl","../core/has","../core/accessorSupport/decorators/property","../core/Logger","../core/RandomLCG","../core/accessorSupport/decorators/subclass","./Widget","./BatchAttributeForm/BatchAttributeFormViewModel","./BatchAttributeForm/css","./BatchAttributeForm/VisibleElements","./BatchAttributeForm/inputs/support/inputUtils","../chunks/componentsUtils","./support/dateUtils","./support/globalCss","./support/Heading","./support/widgetUtils","./support/decorators/messageBundle","./support/jsxFactory","../intl/substitute"],(function(e,t,i,s,n,r,a,o,l,d,u,c,p,m,b,h,v,y,_,x,k){"use strict";let g=class extends l{constructor(e,t){super(e,t),this.headingLevel=2,this.messagesCommon=null,this.messages=null,this.readOnly=!1,this.viewModel=new d,this.visibleElements=new c.VisibleElements}loadDependencies(){return m.loadCalciteComponents({input:()=>new Promise(((t,i)=>e(["../chunks/calcite-input"],t,i))),block:()=>new Promise(((t,i)=>e(["../chunks/calcite-block"],t,i))),"input-date-picker":()=>new Promise(((t,i)=>e(["../chunks/calcite-input-date-picker"],t,i))),"input-number":()=>new Promise(((t,i)=>e(["../chunks/calcite-input-number"],t,i))),"input-time-picker":()=>new Promise(((t,i)=>e(["../chunks/calcite-input-time-picker"],t,i))),"input-time-zone":()=>new Promise(((t,i)=>e(["../chunks/calcite-input-time-zone"],t,i))),"text-area":()=>new Promise(((t,i)=>e(["../chunks/calcite-text-area"],t,i))),label:()=>new Promise(((t,i)=>e(["../chunks/calcite-label"],t,i))),combobox:()=>new Promise(((t,i)=>e(["../chunks/calcite-combobox"],t,i))),"combobox-item":()=>new Promise(((t,i)=>e(["../chunks/calcite-combobox-item"],t,i))),"radio-button":()=>new Promise(((t,i)=>e(["../chunks/calcite-radio-button"],t,i))),"radio-button-group":()=>new Promise(((t,i)=>e(["../chunks/calcite-radio-button-group"],t,i))),switch:()=>new Promise(((t,i)=>e(["../chunks/calcite-switch"],t,i)))})}get activeFeatureIndex(){return this.viewModel.activeFeatureIndex}set activeFeatureIndex(e){this.viewModel.activeFeatureIndex=e}get disabled(){return this.viewModel.disabled}set disabled(e){this.viewModel.disabled=e}get features(){return this.viewModel.features}set features(e){this.viewModel.features=e}get icon(){return"edit-attributes"}set icon(e){this._overrideIfSome("icon",e)}render(){return x.tsx("div",{class:this.classes(u.css.base,h.globalCss.widget,h.globalCss.panel)},this._renderForm())}_renderForm(){return"single"!==this.viewModel.mode?x.tsx("div",null,x.tsx("form",null,this._renderHeader(),this._renderContent())):x.tsx("div",null)}_renderHeader(){const e="title",t="description",i=x.tsx(v.Heading,{key:"title",level:this.headingLevel},e),s=x.tsx("p",{key:"description"},t);return e||t?x.tsx("div",null,i,s):null}_renderContent(){const{inputs:e}=this.viewModel.activeForm;return e.items.filter((e=>e.visible)).map((e=>this._renderInput(e)))}_renderInput(e){return p.isGroupInput(e)?this._renderGroupInput(e):p.isFieldInput(e)?this._renderLabeledField(e):void 0}_renderGroupInput(e){const{inputs:t,template:i}=e,s=t.filter((e=>e.visible));return x.tsx("calcite-block",{class:this.classes(u.css.group,u.css.groupSequential,u.css.block),collapsible:!0,description:i.description??void 0,disabled:!1,heading:i.label??"",headingLevel:this.headingLevel,key:`{${i.elementId}-key}`,open:!0},s.map((e=>this._renderInput(e))))}_renderLabeledField(e){const{fieldName:t,description:i,label:s,field:n,elementId:r}=e.template,a=n.nullable,o=a?k.substitute(this.messages.requiredFieldLabel,{name:s}):s;return x.tsx("calcite-label",{"aria-label":o,class:u.css.label,key:`field--${r}`},x.tsx("div",{class:u.css.labelTextContent,key:"labelTextContainer"},s,i?x.tsx("span",{title:`${t}`},i):void 0,a?x.tsx("span",{"aria-hidden":"true",title:this.messagesCommon.required},"*"):void 0),n.editable?this._renderFieldInput(e):this._renderReadOnlyComponent(e))}_renderFieldInput(e){const t=this.getCommonInputProps(e),{template:i}=e;if(i.input){const{type:s}=i.input;if(b.isDateType(s))return this._renderDateComponents(e,t);if("coded-value"===i.field.domain?.type){const{domain:n}=i.field;return this._renderCodedInputs({input:e,domain:n,type:s,props:t})}return b.isNumberType(s)?this._renderNumberComponent(e,t):this._renderStringComponent(e,t)}return null}_renderCodedInputs({input:e,domain:t,type:i,props:s}){const n=this.viewModel.getCodedValueOptions(t);switch(i){case"combo-box":return this._renderComboBoxComponent({input:e,options:n,props:s});case"switch":return this._renderSwitchComponent(s);case"radio-buttons":return this._renderRadioButtonGroupComponent({input:e,options:n,props:s});default:return null}}_renderSwitchComponent(e){return x.tsx("calcite-switch",{...e,checked:!1,class:u.css.inputSwitch})}_renderComboBoxComponent({input:e,options:t,props:i}){const{label:s,field:n}=e.template,r=t.map((e=>this.renderComboboxItem({value:`${e.value}`,text:e.name,selected:n.defaultValue===e.value.toString()})));return x.tsx("calcite-combobox",{...i,label:s??"",selectionMode:"single"},r)}renderComboboxItem({text:e,value:t,selected:i}){return x.tsx("calcite-combobox-item",{key:t,selected:i,textLabel:e,value:t})}_renderRadioButtonGroupComponent({input:e,options:t,props:i}){const s=t.map((({name:t,value:i})=>this._renderRadioButtons({label:t,name:t,value:i,checked:i===e.template.field.defaultValue})));return x.tsx("calcite-radio-button-group",{...i,layout:"vertical",name:i.label??""},s)}_renderRadioButtons({name:e,value:t,checked:i,label:s}){return x.tsx("calcite-label",{class:u.css.inputRadioLabel,key:e,layout:"inline"},x.tsx("calcite-radio-button",{checked:i,name:e,value:`${t}`}),s)}_renderStringComponent(e,t){const{template:i}=e;return i.field.editable?i.input&&"text-area"===i.input.type?x.tsx("calcite-text-area",{...t,class:this.classes(u.css.group,u.css.groupSequential,u.css.individualElement),resize:"vertical"}):x.tsx("calcite-input",{...t,class:this.classes(u.css.group,u.css.groupSequential,u.css.individualElement),type:"text"}):this._renderReadOnlyComponent(e)}_renderNumberComponent(e,t){return x.tsx("calcite-input-number",{...t,type:"number",value:e.template.field.defaultValue?e.template.field.defaultValue.toString():void 0})}_renderReadOnlyComponent(e,t){const i=this.getCommonInputProps(e);return x.tsx("calcite-input",{class:this.classes(u.css.fieldInput,u.css.inputDisabled,u.css.individualElement),readOnly:!0,type:"text",value:null!=t?`${t}`:i.value})}_renderDateComponents(e,t){const{input:i}=e.template;switch(i?.type){case"datetime-picker":return this._renderDateFieldComponents(t);case"date-picker":return this._renderDateOnlyFieldComponent(t);case"time-picker":return this._renderTimeOnlyFieldComponent(t);case"datetimeoffset-picker":return this._renderTimestampOffsetFieldComponents(t);default:return this._renderReadOnlyComponent(e,b.getLabelForDateFieldValue(e.field,t.value))}}_renderDateOnlyFieldComponent(e){const{class:t,key:i}=e;return x.tsx("calcite-input-date-picker",{class:t,"data-date-part":"date","data-field-name":"fieldNameAttribute",key:`${i}-date-input`,overlayPositioning:"fixed",value:void 0})}_renderTimeOnlyFieldComponent(e){const{class:t,key:i}=e;return x.tsx("calcite-input-time-picker",{class:t,"data-date-part":"time","data-field-name":"fieldNameAttribute",key:`${i}-time-input`,overlayPositioning:"fixed",value:void 0})}_renderTimestampOffsetFieldComponents(e){const{class:t,key:i}=e;return x.tsx("div",{class:u.css.dateInputContainer,key:`${i}-date-time-container`},x.tsx("calcite-input-date-picker",{class:t,"data-date-part":"date",key:`${i}-date-input`,value:void 0}),x.tsx("calcite-input-time-picker",{class:t,"data-date-part":"time",key:`${i}-time-input`,value:void 0}),null)}_renderDateFieldComponents(e){const{class:t,key:i}=e;return x.tsx("div",{class:u.css.dateInputContainer,key:`${i}-date-time-container`},x.tsx("calcite-input-date-picker",{class:t,"data-date-part":"date",key:`${i}-date-input`,value:void 0}),x.tsx("calcite-input-time-picker",{"data-date-part":"time",key:`${i}-time-input`,step:1,value:void 0}))}getCommonInputProps(e){const{disabled:t}=this,{template:i,field:s,valid:n}=e,{editable:r,name:a,nullable:o,defaultValue:l}=s,d=e.userHasChangedValue,c=!r||t;return{"aria-invalid":n?"false":"true",class:this.classes(u.css.fieldInput,c?u.css.inputDisabled:null),status:d&&!n?"invalid":"idle",key:i.elementId,label:a,placeholder:i.hint??void 0,readOnly:c,required:!o,value:null==l?"":`${l}`}}};t.__decorate([n.property()],g.prototype,"activeFeatureIndex",null),t.__decorate([n.property()],g.prototype,"disabled",null),t.__decorate([n.property()],g.prototype,"features",null),t.__decorate([n.property()],g.prototype,"headingLevel",void 0),t.__decorate([n.property()],g.prototype,"icon",null),t.__decorate([n.property(),_.messageBundle("esri/t9n/common")],g.prototype,"messagesCommon",void 0),t.__decorate([n.property(),_.messageBundle("esri/widgets/BatchAttributeForm/t9n/BatchAttributeForm")],g.prototype,"messages",void 0),t.__decorate([n.property()],g.prototype,"readOnly",void 0),t.__decorate([n.property()],g.prototype,"viewModel",void 0),t.__decorate([n.property({type:c.VisibleElements,nonNullable:!0})],g.prototype,"visibleElements",void 0),g=t.__decorate([o.subclass("esri.widgets.BatchAttributeForm")],g);return g}));
