/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../core/asyncUtils","../../core/Collection","../../core/Error","../../core/Evented","../../core/MapUtils","../../core/maybe","../../core/promiseUtils","../../core/ReactiveMap","../../core/reactiveUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/Logger","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../../core/support/UpdatingHandles","./batchAttributeFormUtils","./expressions/ArcadeExecutorProvider","./inputs/BatchFormInputs","./inputs/support/createBatchFormInputs","./templates/BatchFormTemplate","./templates/support/createBatchFormTemplate"],(function(e,t,r,a,o,s,i,p,n,d,c,u,l,h,m,_,y,F,v,g,f,w){"use strict";let I=class extends o.EventedAccessor{constructor(e){super(e),this.activeFeatureIndex=-1,this.disabled=!1,this.editType="NA",this.features=new r,this.userHasChangedValues=!1,this._arcadeExecutorProvider=new F.ArcadeExecutorProvider,this._activeFormInputsByFieldName=new Map,this._emptyForm=new v.BatchFormInputs({inputs:new r}),this._emptyFormTemplate=new f({elements:[]}),this._featureFormMap=new Map,this._prepareTask=null,this._updatingHandles=new _.UpdatingHandles,this._layerTemplateMap=new n,this._workingFeatures=new r,this.sharedForm=this._emptyForm,this.sharedFormTemplate=this._emptyFormTemplate}initialize(){this.addHandles([d.on((()=>this.features),"after-changes",(()=>this._prepare()),{onListenerAdd:()=>this._prepare(),sync:!0}),d.watch((()=>this.activeForm),(()=>this._activeFormInputsByFieldName.clear()),d.sync)]),this._prepare()}destroy(){this._prepareTask=i.abortMaybe(this._prepareTask),this._workingFeatures.destroyAll(),this._emptyForm.destroy(),this._emptyFormTemplate.destroy()}get activeFeature(){const e=this.activeFeatureIndex;return e<0?null:this.features.at(e)}get activeForm(){if("batch"===this.mode)return this.sharedForm;const e=this._workingFeatures.at(this.activeFeatureIndex);if(!e)return this._emptyForm;const t=this._featureFormMap.get(e);if(t)return t;const r=this._makeBatchFormInputsForFeature(e);return r!==this._emptyForm&&this._featureFormMap.set(e,r),r}get activeFormIsValid(){return!0}get allHiddenErrors(){const e=this.hiddenIndividualFormErrors,t=this.hiddenSharedFormErrors;return Array.from(new Set([...e,...t]))}get hiddenIndividualFormErrors(){if("batch"===this.mode)return[];const e=[];return this.activeForm.inputs.forEach((t=>{!1!==t.visible||t.valid||e.push(t)})),e}get hiddenSharedFormErrors(){const e=[];return this.sharedForm?.inputs.forEach((t=>{!1!==t.visible||t.valid||e.push(t)})),e}get status(){const e=this._prepareTask;return null==e?"not-loaded":e.finished?null!=e.error?"failed":"loaded":"loading"}get submittable(){return this.valid,!0}get updating(){return this._updatingHandles.updating}get valid(){return!0}get layers(){const e=new Set;return this.features.forEach((t=>{const r=t.sourceLayer??t.layer;e.add(r)})),Array.from(e)}get mode(){return this.activeFeatureIndex>-1?"single":"batch"}getValues(e){const t=this._workingFeatures.find((({original:t})=>t===e));if(!t)throw new a("feature-not-found","The given feature is not present in the BatchAttributeForm");return{...t.attributes}}setFieldInputValue(e,t){e.setValueFromUser(t),this.emit("value-change",{features:e.features.toArray().map((e=>e.original)),fieldName:e.fieldName,name:"value-change",value:t})}setValue(e,t){const r=s.getOrCreateMapValue(this._activeFormInputsByFieldName,e,(()=>{const t=this.activeForm.allFieldInputs.find((t=>t.fieldName===e));if(!t)throw new a("no-FieldInput-found",`Cannot set the value of field '${e}' because there is no FieldInput representing it`);return t}));this.setFieldInputValue(r,t)}validate(){return!1}getCodedValueOptions(e){return e.codedValues.map((({name:e,code:t})=>({name:e,value:t})))}_makeBatchFormInputsForFeature(e){const t=this._layerTemplateMap.get(e.layer);return t?g.createBatchFormInputsFromBatchFormTemplate(t,new r([e])):this._emptyForm}async _prepare(){this._prepareTask=i.abortMaybe(this._prepareTask),this._updateWorkingFeatures();const{layers:e}=this;if(0===e.length)return;const r=t.createTask((async t=>{p.throwIfAborted(t);const r=new Map;for(const o of e){const e=await w.createBatchFormTemplate(o,{arcadeExecutorProvider:this._arcadeExecutorProvider});this._layerTemplateMap.set(o,e);for(const t of e.elements){const{elementId:e}=t;r.has(e)?r.get(e).foldIn(t):r.set(e,t.clone())}}const a=new f({elements:Array.from(r.values())});this.sharedFormTemplate=a,this.sharedForm=g.createBatchFormInputsFromBatchFormTemplate(a,this._workingFeatures)}));this._updatingHandles.addPromise(r.promise),this._prepareTask=r}_updateWorkingFeatures(){this._workingFeatures.destroyAll();const{features:e}=this;0!==e.length&&this._workingFeatures.addMany(e.map(y.createReactiveGraphic))}};e.__decorate([c.property({readOnly:!0})],I.prototype,"activeFeature",null),e.__decorate([c.property()],I.prototype,"activeFeatureIndex",void 0),e.__decorate([c.property({readOnly:!0})],I.prototype,"activeForm",null),e.__decorate([c.property()],I.prototype,"activeFormIsValid",null),e.__decorate([c.property()],I.prototype,"disabled",void 0),e.__decorate([c.property()],I.prototype,"editType",void 0),e.__decorate([c.property()],I.prototype,"features",void 0),e.__decorate([c.property()],I.prototype,"hiddenIndividualFormErrors",null),e.__decorate([c.property()],I.prototype,"updating",null),e.__decorate([c.property()],I.prototype,"valid",null),e.__decorate([c.property()],I.prototype,"layers",null),e.__decorate([c.property()],I.prototype,"mode",null),e.__decorate([c.property()],I.prototype,"sharedForm",void 0),e.__decorate([c.property()],I.prototype,"sharedFormTemplate",void 0),e.__decorate([c.property()],I.prototype,"userHasChangedValues",void 0),e.__decorate([c.property()],I.prototype,"_arcadeExecutorProvider",void 0),e.__decorate([c.property()],I.prototype,"_prepareTask",void 0),e.__decorate([c.property()],I.prototype,"_layerTemplateMap",void 0),e.__decorate([c.property()],I.prototype,"_workingFeatures",void 0),I=e.__decorate([m.subclass("esri.widgets.BatchAttributeForm.BatchAttributeFormViewModel")],I);return I}));
