/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../core/arrayUtils","../core/deprecate","../core/Identifiable","../core/Logger","../core/accessorSupport/decorators/property","../core/has","../core/accessorSupport/decorators/subclass","../intl/date","../time/timeZoneUtils","../webdoc/support/SlideThumbnail","./Widget","./Bookmarks/BookmarksUserState","./Bookmarks/BookmarksViewModel","./Bookmarks/BookmarksVisibleElements","./Bookmarks/css","../chunks/componentsUtils","./support/globalCss","./support/Heading","./support/listUtils","./support/widgetUtils","./support/decorators/messageBundle","./support/decorators/vmEvent","./support/jsxFactory"],(function(e,t,o,i,r,a,s,n,l,d,c,m,u,k,h,p,_,b,g,v,B,w,f,E,x){"use strict";let y=class extends(r.IdentifiableMixin(u)){constructor(e,t){super(e,t),this._addInputNode=null,this._editInputNode=null,this._urlEditInputNode=null,this._lastDragDetail=null,this._selectedDragBookmarkUid=null,this._editIncludeTimeExtent=void 0,this._userState=null,this._focusRootFlowItem=!1,this._focusAddFlowItem=!1,this._focusEditFlowItem=!1,this.disabled=!1,this.dragEnabled=!1,this.filterPlaceholder="",this.filterText="",this.headingLevel=2,this.messages=null,this.messagesCommon=null,this.viewModel=new h,this.visibleElements=new p,this._onCalciteListOrderChange=e=>{const{_lastDragDetail:t,bookmarks:o}=this,{toEl:i,fromEl:r,dragEl:a,newIndex:s}=e;if(!o.length)return;if(!r||!i||t?.newIndex===s&&t?.dragEl===a&&t?.toEl===i&&t?.fromEl===r)return;this._lastDragDetail=e;const n=Array.from(r.children).filter((e=>e?.matches("calcite-list-item"))).map((e=>e.value));o.sort(((e,t)=>{const o=n.indexOf(e.uid),i=n.indexOf(t.uid);return o>i?1:o<i?-1:0}))}}normalizeCtorArgs(e){return null!=e?.editingEnabled&&null!=e.visibleElements?{...e,visibleElements:new p({...e.visibleElements,addBookmarkButton:e.editingEnabled,editBookmarkButton:e.editingEnabled})}:e}loadDependencies(){return b.loadCalciteComponents({action:()=>new Promise(((t,o)=>e(["../chunks/calcite-action"],t,o))),button:()=>new Promise(((t,o)=>e(["../chunks/calcite-button"],t,o))),"chip-group":()=>new Promise(((t,o)=>e(["../chunks/calcite-chip-group"],t,o))),chip:()=>new Promise(((t,o)=>e(["../chunks/calcite-chip"],t,o))),fab:()=>new Promise(((t,o)=>e(["../chunks/calcite-fab"],t,o))),flow:()=>new Promise(((t,o)=>e(["../chunks/calcite-flow"],t,o))),"flow-item":()=>new Promise(((t,o)=>e(["../chunks/calcite-flow-item"],t,o))),icon:()=>new Promise(((t,o)=>e(["../chunks/calcite-icon"],t,o))),input:()=>new Promise(((t,o)=>e(["../chunks/calcite-input"],t,o))),"input-message":()=>new Promise(((t,o)=>e(["../chunks/calcite-input-message"],t,o))),label:()=>new Promise(((t,o)=>e(["../chunks/calcite-label"],t,o))),list:()=>new Promise(((t,o)=>e(["../chunks/calcite-list"],t,o))),"list-item":()=>new Promise(((t,o)=>e(["../chunks/calcite-list-item"],t,o))),loader:()=>new Promise(((t,o)=>e(["../chunks/calcite-loader"],t,o))),notice:()=>new Promise(((t,o)=>e(["../chunks/calcite-notice"],t,o))),scrim:()=>new Promise(((t,o)=>e(["../chunks/calcite-scrim"],t,o))),switch:()=>new Promise(((t,o)=>e(["../chunks/calcite-switch"],t,o))),table:()=>new Promise(((t,o)=>e(["../chunks/calcite-table"],t,o))),"table-cell":()=>new Promise(((t,o)=>e(["../chunks/calcite-table-cell"],t,o))),"table-header":()=>new Promise(((t,o)=>e(["../chunks/calcite-table-header"],t,o))),"table-row":()=>new Promise(((t,o)=>e(["../chunks/calcite-table-row"],t,o)))})}get defaultCreateOptions(){return this.viewModel.defaultCreateOptions}set defaultCreateOptions(e){this.viewModel.defaultCreateOptions=e}get defaultEditOptions(){return this.viewModel.defaultEditOptions}set defaultEditOptions(e){this.viewModel.defaultEditOptions=e}get bookmarks(){return this.viewModel.bookmarks}set bookmarks(e){this.viewModel.bookmarks=e}get editingEnabled(){return i.deprecatedProperty(a.getLogger(this),"editingEnabled",{replacement:"dragEnabled, visibleElements.editBookmarkButton, visibleElements.addBookmarkButton",version:"4.29",warnOnce:!0}),this.dragEnabled&&this.visibleElements.editBookmarkButton&&this.visibleElements.addBookmarkButton}set editingEnabled(e){i.deprecatedProperty(a.getLogger(this),"editingEnabled",{replacement:"dragEnabled, visibleElements.editBookmarkButton, visibleElements.addBookmarkButton",version:"4.29",warnOnce:!0}),this.dragEnabled=e,this.visibleElements.editBookmarkButton=e,this.visibleElements.addBookmarkButton=e}get goToOverride(){return this.viewModel.goToOverride}set goToOverride(e){this.viewModel.goToOverride=e}get icon(){return"bookmark"}set icon(e){this._overrideIfSome("icon",e)}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}get view(){return this.viewModel.view}set view(e){this.viewModel.view=e}endAddBookmark(){this._userState=null}goTo(e){return this.viewModel.goTo(e)}render(){return x.tsx("div",{class:this.classes(_.css.base,g.globalCss.widget,g.globalCss.panel)},this._renderBookmarksContainer())}startAddBookmark(){this._userState=new k({state:"add"}),this._focusAddFlowItem=!0}_renderNoBookmarksContainer(e){const{messages:t,viewModel:{state:o}}=this;return e.length||"loading"===o?null:x.tsx("div",{class:g.globalCss.empty,key:"no-bookmarks"},x.tsx("calcite-icon",{icon:"bookmark",scale:"l"}),x.tsx(v.Heading,{class:this.classes(g.globalCss.heading,_.css.noBookmarksHeader),level:this.headingLevel},t?.noBookmarksHeading),x.tsx("p",{class:_.css.noBookmarksDescription},t.noBookmarksDescription))}_renderEditBookmarkFlowItems(){const{_userState:e}=this,t=e?.editedBookmark;return t&&"edit"===e?.state?this._renderEditingBookmark(t):[]}_renderBookmarkItems(e){return e?e.toArray().map((e=>this._renderBookmark(e))):[]}_handleCalciteListDragEnd(e){const{fromEl:t,dragEl:o,oldIndex:i}=e;t.insertBefore(o,t.children[i])}_renderBookmarksContainer(){const{viewModel:{state:e,bookmarks:t},dragEnabled:i,messages:r,disabled:a,filterPlaceholder:s,filterText:n,visible:l,headingLevel:d,visibleElements:{closeButton:c,collapseButton:m,filter:u,heading:k,flow:h},uid:p}=this,b=t.filter(o.isSome),g=b.length?x.tsx("calcite-list",{class:_.css.list,dragEnabled:i,filterEnabled:u,filterPlaceholder:s,filterProps:B.calciteListFilterProps,filterText:n,group:`bookmarks-${p}`,key:"bookmark-list",label:r.widgetLabel,selectionAppearance:"border",selectionMode:"none",onCalciteListDragEnd:e=>this._handleCalciteListDragEnd(e.detail),onCalciteListFilter:e=>this.filterText=e.target?.filterText??"",onCalciteListOrderChange:e=>this._onCalciteListOrderChange(e.detail)},this._renderBookmarkItems(b),u?x.tsx("div",{class:_.css.filterNoResults,slot:"filter-no-results"},x.tsx("calcite-notice",{kind:"info",open:!0,width:"full"},x.tsx("div",{slot:"message"},r.noBookmarksHeading),";")):null):null,v=[x.tsx("calcite-flow-item",{afterCreate:this._focusRootFlowItemNode,afterUpdate:this._focusRootFlowItemNode,bind:this,closable:c,closed:!l,collapsible:m,disabled:a,heading:k?r.widgetLabel:void 0,headingLevel:d,loading:"loading"===e,onCalciteFlowItemClose:()=>this.visible=!1},this._renderNoBookmarksContainer(b),g,this._renderAddBookmarkButton()),this._renderAddingBookmark(),this._renderEditBookmarkFlowItems()];return l?h?x.tsx("calcite-flow",{key:"root-flow"},v):v:null}_renderAddBookmarkButton(){const{messages:e,_userState:t,disabled:o,viewModel:{view:i,state:r},visibleElements:{addBookmarkButton:a}}=this,s=t?.loading??!1;return i&&"loading"!==r&&a?x.tsx("calcite-fab",{appearance:"outline-fill",bind:this,class:_.css.addBookmarkButton,disabled:o||s,icon:"plus",key:"add-bookmark-item",kind:"neutral",loading:s,onclick:this.startAddBookmark,slot:"fab",text:e.addBookmark,textEnabled:!0,title:e.addBookmark,type:"button"}):null}_renderEditContainer(e){const{messagesCommon:t,visibleElements:{editBookmarkButton:o}}=this,i=`${t.edit} ${this._getBookmarkTitle(e)}`;return o?x.tsx("calcite-action",{appearance:"transparent",icon:"pencil",key:"edit-action",onclick:()=>this._showEditBookmarkForm(e),slot:"actions-end",text:i,title:i}):null}_renderBookmarkImage(e,t){return t?x.tsx("img",{alt:"",class:_.css.bookmarkImage,key:"bookmark-image",src:e.thumbnail?.url}):null}_renderBookmarkTimeSwitch(e){const{messages:t,viewModel:{view:o}}=this,{timeExtent:i}=e;return o?.timeExtent??i?x.tsx("calcite-label",{layout:"inline-space-between"},t.includeTimeExtent,x.tsx("calcite-switch",{checked:!!i,onCalciteSwitchChange:e=>{this._editIncludeTimeExtent=!!e.target.checked}})):null}_renderEditBookmarkTimeExtent(e){return this._editIncludeTimeExtent?this._renderBookmarkTimeExtent(e):null}_getTimeExtentStrings(e){const{visibleElements:t}=this,{timeExtent:o}=e;if(!o)return{};const{start:i,end:r}=o,a=null!=r&&(null==i||i.getTime()!==r.getTime()),s=i?this._formatDate(i):"",n=i&&t.time?this._formatTime(i):"";if(!a)return{startDate:s,startTime:n};return{startDate:s,startTime:n,endDate:this._formatDate(r),endTime:t.time?this._formatTime(r):""}}_renderTimeExtentDescription(e){const{startDate:t,startTime:o,endDate:i,endTime:r}=this._getTimeExtentStrings(e);if(!t)return"";const a=`${t} ${o}`;return i?`${a} - ${`${i} ${r}`}`:a}_renderBookmarkTimeExtent(e,t=!1){const{messages:o}=this,{startDate:i,startTime:r,endDate:a,endTime:s}=this._getTimeExtentStrings(e),n=t?null:x.tsx("calcite-table-row",{slot:"table-header"},x.tsx("calcite-table-header",{heading:o.startDate}),a?x.tsx("calcite-table-header",{heading:o.endDate}):null);return i?x.tsx("calcite-table",{caption:o.timeExtent,scale:"s"},n,x.tsx("calcite-table-row",null,x.tsx("calcite-table-cell",null,i," ",r?[x.tsx("br",null),r]:null),a?x.tsx("calcite-table-cell",null,a,s?[x.tsx("br",null),s]:null):null)):null}_renderBookmarkActiveScrim(e,t){return this.viewModel.activeBookmark===e&&t?x.tsx("calcite-scrim",{key:"bookmark-active-scrim",loading:!0}):null}_renderBookmarkActiveLoader(e,t){return this.viewModel.activeBookmark!==e||t?null:x.tsx("calcite-loader",{class:_.css.loader,inline:!0,key:"bookmark-active-loader",label:this.messagesCommon.loading})}_renderBookmarkImageIcon(e,t){return this.viewModel.activeBookmark===e||t?null:x.tsx("calcite-icon",{icon:"bookmark",key:"bookmark-icon",scale:"s"})}_renderBookmarkThumbnail(e){const t=this.visibleElements.thumbnail&&!!e.thumbnail?.url;return x.tsx("div",{class:_.css.bookmarkImageContainer,slot:"content-start"},this._renderBookmarkActiveScrim(e,t),this._renderBookmarkImage(e,t),this._renderBookmarkActiveLoader(e,t),this._renderBookmarkImageIcon(e,t))}_focusSelectedDragEl(e,t){this._selectedDragBookmarkUid===t.uid&&w.setFocus(e)}_handleCalciteListItemDragHandleChange(e,t){e.stopPropagation();const o=e.target.dragSelected;this._selectedDragBookmarkUid=o?t.uid:null}_renderBookmark(e){return x.tsx("calcite-list-item",{afterCreate:t=>this._focusSelectedDragEl(t,e),afterUpdate:t=>this._focusSelectedDragEl(t,e),class:this.classes({[_.css.dragEnabled]:this.dragEnabled}),description:this._renderTimeExtentDescription(e),dragSelected:e.uid===this._selectedDragBookmarkUid,key:e.uid,label:this._getBookmarkTitle(e),value:e.uid,onCalciteListItemDragHandleChange:t=>this._handleCalciteListItemDragHandleChange(t,e),onCalciteListItemSelect:()=>this._goToBookmark(e)},this._renderBookmarkThumbnail(e),this._renderBookmarkContent(e),this._renderEditContainer(e))}_renderBookmarkContent(e){return x.tsx("div",{class:_.css.bookmarkContent,slot:"content"},x.tsx("span",{class:_.css.bookmarkContentLabel},this._getBookmarkTitle(e)),this._renderBookmarkTimeExtent(e,!0))}_renderEditingBookmarkName(e){const{messages:t,_userState:o}=this,i="name-required"===o?.validationState;return x.tsx("calcite-label",null,t.title,x.tsx("calcite-input",{afterCreate:this._storeEditInput,bind:this,class:_.css.editBookmarkInput,name:"bookmark-name",placeholder:t.titlePlaceholder,required:!0,type:"text",value:e.name}),i?x.tsx("calcite-input-message",{icon:"exclamation-mark-triangle",status:"invalid"},t.invalidTitle):null)}_renderEditingBookmarkActions(){const{messagesCommon:e,_userState:t}=this,o=t?.bookmark;return[x.tsx("calcite-button",{appearance:"transparent",kind:"danger",onclick:()=>this._deleteBookmark(o),slot:"footer",type:"button",width:"full"},e.delete),x.tsx("calcite-button",{appearance:"outline",bind:this,onclick:this._closeEditBookmarkForm,slot:"footer",type:"button",width:"full"},e.cancel),x.tsx("calcite-button",{slot:"footer",type:"submit",width:"full"},e.save)]}_handleUrlEditInputChange(){const{_userState:e,_urlEditInputNode:t}=this,o=t?.value;if(!e?.editedBookmark||!o)return;e.validationState=void 0,e.editedBookmark.thumbnail?.isDataURI&&(e.screenshotUrl=e.editedBookmark.thumbnail?.url);const i=new m.SlideThumbnail({url:o});i.isSecureUrl&&(e.customUrl=o,e.editedBookmark.thumbnail=i)}_renderEditingTimeExtent(e){const{capabilities:t,view:o}=this.viewModel,{timeExtent:i}=e;return t.time&&(o?.timeExtent??i)?x.tsx("div",{key:"edit-bookmark-time-container"},this._renderBookmarkTimeSwitch(e),this._renderEditBookmarkTimeExtent(e)):null}_renderEditingBookmarkImage(e){const{_userState:t}=this,o=t?.thumbnailState,i=e.thumbnail?.isSecureUrl?"url"===o:e.thumbnail?.isDataURI?"screenshot"===o:null;if(i)return this._renderBookmarkImage(e,i)}_renderEditingThumbnail(e){const{_userState:t,visibleElements:o}=this,i=t?.thumbnailState;return o.thumbnail&&"none"!==i?x.tsx("div",{class:_.css.authoringImageContainer},this._renderEditingBookmarkImage(e)):null}_renderUpdateThumbnailButton(){const{visibleElements:e,messages:t,_userState:o}=this,i=o?.thumbnailState;return e.thumbnail&&"screenshot"===i?x.tsx("calcite-button",{appearance:"outline",class:_.css.authoringRefreshThumbnailButton,iconStart:"refresh",key:"update-thumbnail",kind:"neutral",onclick:()=>{this._updateThumbnail()},width:"half"},t.updateThumbnail):null}_renderEditingBookmarkUrlInput(e){const{messages:t,_userState:o}=this,i=e.thumbnail?.url,r=e.thumbnail?.isSecureUrl?i:void 0,a=i&&"absolute-url-required"===o?.validationState,s=o?.thumbnailState;return"url"===s?x.tsx("calcite-label",{key:"thumbnail-url-input"},x.tsx("calcite-input",{afterCreate:this._storeUrlEditInput,bind:this,name:"bookmark-thumbnail-url",pattern:"https://.*",placeholder:t?`https://<${t.imageUrlPlaceholder}>`:void 0,required:!0,title:t.imageUrlTooltip,type:"text",value:r,onCalciteInputChange:this._handleUrlEditInputChange,onCalciteInputInput:this._handleUrlEditInputChange}),a?x.tsx("calcite-input-message",{icon:"exclamation-mark-triangle",status:"invalid"},t.invalidImageUrl):null):null}_renderThumbnailSelector(){const{visibleElements:e,messages:t,_userState:o}=this,i=o?.thumbnailState;return e.thumbnail?x.tsx("calcite-label",{key:"thumbnail-chip-group"},t.thumbnail,x.tsx("calcite-chip-group",{label:t.thumbnail,selectionMode:"single-persist",onCalciteChipGroupSelect:e=>this._handleThumbnailTypeSelect(e.target.selectedItems[0].value)},x.tsx("calcite-chip",{selected:"screenshot"===i,value:"screenshot"},t.screenshot),x.tsx("calcite-chip",{selected:"url"===i,value:"url"},t.url),x.tsx("calcite-chip",{selected:"none"===i,value:"none"},t.none))):null}_renderEditingBookmark(e){const{disabled:t,messagesCommon:o,headingLevel:i}=this;return e?x.tsx("form",{bind:this,class:_.css.form,disabled:this.disabled,onsubmit:this._editBookmarkSubmit},x.tsx("calcite-flow-item",{afterCreate:this._focusEditFlowItemNode,afterUpdate:this._focusEditFlowItemNode,bind:this,disabled:t,heading:o.edit,headingLevel:i,key:"edit-bookmark-form",onCalciteFlowItemBack:e=>{e.preventDefault(),this._closeEditBookmarkForm()}},x.tsx("div",{class:_.css.formContent},x.tsx("div",{class:_.css.authoring},this._renderEditingBookmarkName(e),this._renderThumbnailSelector(),this._renderEditingThumbnail(e),this._renderEditingBookmarkUrlInput(e),this._renderUpdateThumbnailButton(),this._renderEditingTimeExtent(e))),this._renderEditingBookmarkActions())):null}_renderAddingBookmarkName(){const{_userState:e,messages:t}=this,o="name-required"===e?.validationState;return x.tsx("calcite-label",null,t.title,x.tsx("calcite-input",{afterCreate:this._storeAddInput,bind:this,class:_.css.addBookmarkInput,name:"bookmark-name",placeholder:t.titlePlaceholder,required:!0,type:"text",value:""}),o?x.tsx("calcite-input-message",{icon:"exclamation-mark-triangle",status:"invalid"},t.invalidTitle):null)}_renderAddingBookmarkActions(){const{messagesCommon:e}=this;return[x.tsx("calcite-button",{appearance:"outline",bind:this,onclick:this._endAddBookmark,slot:"footer",type:"button",width:"half"},e.cancel),x.tsx("calcite-button",{slot:"footer",type:"submit",width:"half"},e.add)]}_renderAddingBookmark(){const{disabled:e,messages:t,headingLevel:o,_userState:i}=this;return"add"===i?.state?x.tsx("form",{bind:this,class:_.css.form,disabled:e,onsubmit:this._addBookmarkSubmitClick},x.tsx("calcite-flow-item",{afterCreate:this._focusAddFlowItemNode,afterUpdate:this._focusAddFlowItemNode,bind:this,disabled:e,heading:t.addBookmark,headingLevel:o,key:"add-bookmark-form",onCalciteFlowItemBack:e=>{e.preventDefault(),this._endAddBookmark()}},x.tsx("div",{class:_.css.formContent},this._renderAddingBookmarkName()),this._renderAddingBookmarkActions())):null}_getBookmarkTitle(e){return e?.name||this.messagesCommon.untitled}_formatDate(e){return e?d.formatDate(e,{...d.convertDateFormatToIntlOptions("short-date"),timeZone:this.viewModel.view?.timeZone??c.system}):""}_formatTime(e){return e?d.formatDate(e,{...d.convertDateFormatToIntlOptions("long-time"),timeZone:this.viewModel.view?.timeZone??c.system}):""}_endAddBookmark(){this.endAddBookmark(),this._focusRootFlowItem=!0}_showEditBookmarkForm(e){e&&(this._editIncludeTimeExtent=!!e.timeExtent,this._userState=new k({bookmark:e,state:"edit"}),this._focusEditFlowItem=!0,this.viewModel.goTo(e))}async _createNewScreenshotUrl(){const e=await this.viewModel.createBookmark();return e.thumbnail?.url??null}_storeCurrentUrl(){const{_userState:e}=this,t=e?.editedBookmark?.thumbnail?.url;t&&(e?.editedBookmark?.thumbnail?.isSecureUrl?e.customUrl=t:e?.editedBookmark?.thumbnail?.isDataURI&&(e.screenshotUrl=t))}async _handleThumbnailTypeSelect(e){const{_userState:t}=this;if(!t)return;const{screenshotUrl:o,customUrl:i,editedBookmark:r}=t,a="screenshot"===e?o??await this._createNewScreenshotUrl():"url"===e&&i?i:null;this._storeCurrentUrl(),r&&a&&(r.thumbnail=new m.SlideThumbnail({url:a})),t.validationState=void 0,t.thumbnailState=e}_closeEditBookmarkForm(){this._userState=null,this._focusRootFlowItem=!0}_addBookmarkSubmitClick(e){e.preventDefault(),this._addBookmarkSubmit()}async _addBookmarkSubmit(){const{_addInputNode:e,_userState:t,viewModel:o,viewModel:{bookmarks:i}}=this;if(!t)return;const r=e?e.value.trim():null;if(!r)return void(t.validationState="name-required");t.loading=!0;const a=await o.createBookmark();a.name=r,i.add(a),this._endAddBookmark()}async _editBookmarkAndClose(e,t){const{viewModel:o,viewModel:{defaultEditOptions:i}}=this;await o.editBookmark(e,{...i,...t}),this._closeEditBookmarkForm()}_editBookmarkSubmit(e){e.preventDefault();const{_editInputNode:t,_userState:o,_editIncludeTimeExtent:i,_urlEditInputNode:r}=this;if(!o?.bookmark||!o.editedBookmark)return;o.validationState=void 0,o.customUrl=void 0,o.screenshotUrl=void 0;const a=t?.value.trim();if(!a)return void(o.validationState="name-required");o.bookmark.name=a,o.bookmark.thumbnail=o.editedBookmark.thumbnail,i||(o.bookmark.timeExtent=null);const s=o.thumbnailState;if("url"===s&&r){const e=r.value,t=new m.SlideThumbnail({url:e});if(!t.isSecureUrl)return void(o.validationState="absolute-url-required");o.bookmark.thumbnail=t}else"none"===s&&(o.bookmark.thumbnail=null);this._editBookmarkAndClose(o.bookmark,{takeScreenshot:!1,captureTimeExtent:i})}_storeEditInput(e){this._editInputNode=e}_storeAddInput(e){this._addInputNode=e}_storeUrlEditInput(e){this._urlEditInputNode=e}_deleteBookmark(e){this._closeEditBookmarkForm(),e&&(this.viewModel.bookmarks.remove(e),e.destroy())}_goToBookmark(e){this.endAddBookmark(),this.viewModel.goTo(e)}async _updateThumbnail(){const{_userState:e,viewModel:t}=this;e&&(e.validationState=void 0,await t.editBookmark(e.editedBookmark,{takeScreenshot:!0,captureViewpoint:!1,captureRotation:!1,captureScale:!1,captureTimeExtent:!1}))}_focusRootFlowItemNode(e){this._focusRootFlowItem&&(this._focusRootFlowItem=!1,w.setFocus(e))}_focusEditFlowItemNode(e){this._focusEditFlowItem&&(this._focusEditFlowItem=!1,w.setFocus(e))}_focusAddFlowItemNode(e){this._focusAddFlowItem&&(this._focusAddFlowItem=!1,w.setFocus(e))}};t.__decorate([s.property()],y.prototype,"_editIncludeTimeExtent",void 0),t.__decorate([s.property({type:k})],y.prototype,"_userState",void 0),t.__decorate([s.property()],y.prototype,"_focusRootFlowItem",void 0),t.__decorate([s.property()],y.prototype,"_focusAddFlowItem",void 0),t.__decorate([s.property()],y.prototype,"_focusEditFlowItem",void 0),t.__decorate([s.property()],y.prototype,"defaultCreateOptions",null),t.__decorate([s.property()],y.prototype,"defaultEditOptions",null),t.__decorate([s.property()],y.prototype,"bookmarks",null),t.__decorate([s.property()],y.prototype,"disabled",void 0),t.__decorate([s.property()],y.prototype,"dragEnabled",void 0),t.__decorate([s.property()],y.prototype,"editingEnabled",null),t.__decorate([s.property()],y.prototype,"filterPlaceholder",void 0),t.__decorate([s.property()],y.prototype,"filterText",void 0),t.__decorate([s.property()],y.prototype,"headingLevel",void 0),t.__decorate([s.property()],y.prototype,"goToOverride",null),t.__decorate([s.property()],y.prototype,"icon",null),t.__decorate([s.property()],y.prototype,"label",null),t.__decorate([s.property(),f.messageBundle("esri/widgets/Bookmarks/t9n/Bookmarks")],y.prototype,"messages",void 0),t.__decorate([s.property(),f.messageBundle("esri/t9n/common")],y.prototype,"messagesCommon",void 0),t.__decorate([s.property()],y.prototype,"uiStrings",void 0),t.__decorate([s.property()],y.prototype,"view",null),t.__decorate([s.property({type:h}),E.vmEvent(["select-bookmark","bookmark-edit","bookmark-select"])],y.prototype,"viewModel",void 0),t.__decorate([s.property({type:p,nonNullable:!0})],y.prototype,"visibleElements",void 0),t.__decorate([s.property()],y.prototype,"endAddBookmark",null),t.__decorate([s.property()],y.prototype,"startAddBookmark",null),y=t.__decorate([l.subclass("esri.widgets.Bookmarks")],y);return y}));
