/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../../../chunks/tslib.es6","../../../core/events","../../../core/mathUtils","../../../core/reactiveUtils","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/Logger","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../Widget","../../../chunks/constants","./css","./Label","./LevelItem","../../../chunks/componentsUtils","../../support/globalCss","../../support/widgetUtils","../../support/jsxFactory"],(function(e,t,s,i,l,o,n,r,a,h,v,d,_,c,p,g,u,m,L){"use strict";const y={selectLevel:"selectLevel",clearLevel:"clearLevel",nextLevel:"nextLevel",previousLevel:"previousLevel",currentLevel:"{{value}}"};let P=class extends v{constructor(e,t){super(e,t),this._levelHandlesKey="levelHandles",this._levelEventHandlesKey="levelEventHandles",this._levelWidgets=[],this._labelWidget=new c.Label({onClear:()=>this.vm.clear()}),this._hoveredLevel=null,this._expandedLevelsHeight=void 0,this._normalizedPointerPosition=0,this._hovering=!1,this._containerPosTop=null,this._levelsContainer=null,this._onKeyDown=e=>{switch(e.key){case"ArrowDown":case"ArrowLeft":e.preventDefault(),e.stopPropagation(),this.vm.previous(),this._focusCurrentLevel();break;case"ArrowUp":case"ArrowRight":e.preventDefault(),e.stopPropagation(),this.vm.next(),this._focusCurrentLevel()}},this._onFocus=()=>{this._hoveredLevel=this._levels.length>0?this._levels[0]:null},this._onArrowUpClick=()=>{this.vm.next()},this._onArrowDownClick=()=>{this.vm.previous()},this._onPointerUp=()=>{if(window.getSelection()?.removeAllRanges(),null==this._hoveredLevel)return;const{vm:e}=this;e.enabled&&this._hoveredLevel===e.value?e.clear():e.select(this._hoveredLevel)},this._onPointerEnter=()=>{this._hovering||null==this._levelsContainer||(this._hovering=!0,this._containerPosTop=this._levelsContainer.getBoundingClientRect().top??0)},this._onPointerLeave=()=>{this._hovering&&(this._normalizedPointerPosition=0,this._hoveredLevel=null,this._hovering=!1)},this._onPointerMove=e=>{if(!this._hovering)return!1;if(window.getSelection()?.removeAllRanges(),null!=this._containerPosTop){const t=this._containerPosTop,s=d.levelsPadding*d.levelsMarginFactor,i=this._expandedLevelsMargin;let l=this._levelsHeight,o=t+s+i;const n=this._levelHeight/2;o+=n,l-=n;let r=(e.clientY-o)/l;r+=d.levelsPointerAdjustment,this._normalizedPointerPosition=r}return!1}}loadDependencies(){return g.loadCalciteComponents({action:()=>new Promise(((t,s)=>e(["../../../chunks/calcite-action"],t,s)))})}postInitialize(){this.addHandles([l.watch((()=>this._levelsContainer),(()=>this._onContainerChange()),l.initial),l.watch((()=>this._levels),(()=>this._createLevelWidgets()),l.initial),l.watch((()=>this.messages),(()=>{this._labelWidget.messages=this.messages??y}),l.initial)])}destroy(){this._levelWidgets.forEach((e=>e.destroy())),this._labelWidget.destroy()}get _levels(){return this.vm.allowedValues}get _numLevels(){return this._levels.length}get _levelsHeight(){return Math.round(this._levelHeight*this._numLevels)}get _expandedLevelsMargin(){return Math.round(((this._expandedLevelsHeight??0)-this._levelsHeight)/2)}get _levelWidth(){const{levelWidthNominator:e,levelWidthConstant:t}=d.constants,s=e/Math.sqrt(this._numLevels)+t;return Math.round(i.clamp(s,d.levelWidthMin,d.levelWidthMax))}get _levelHeight(){const e=d.levelHeightDefault,t=2*e/Math.sqrt(this._numLevels);return Math.round(i.clamp(t,2,e))}get _gaussianFactor(){const e=this._numLevels;return e/Math.log(d.alphaLevelDependencyFactor*e)*d.alphaSpreadFactor}get _levelClosestToPointer(){if(!this._hovering)return null;const e=this._numLevels-1,t=this._normalizedPointerPosition;return e>=0&&null!=t?this._levels[Math.round((1-t)*e)]:null}render(){const e=this._levelWidgets.length,t=e>1?this._levelWidgets.map((e=>e.render())):null,s=d.levelsPadding*d.levelsMarginFactor,i=-s/d.levelsMarginFactor,l=this._levelsHeight,o=l+2*s;return L.tsx("div",{class:this.classes(u.globalCss.widget,_.css.container,{[_.css.animateLevel]:!this._hovering,[_.css.noLevel]:e<2}),key:this,onkeydown:this._onKeyDown},this._renderLabelContainer(),L.tsx("div",{afterCreate:e=>this._levelsContainer=e,class:_.css.levelsContainer,"data-node-ref":"",onfocus:this._onFocus,styles:{height:`${o}px`,marginBlockStart:`${i}px`,marginBlockEnd:`${i}px`}},L.tsx("div",{class:_.css.innerLevelsContainer,styles:{height:`${l}px`,margin:"0",marginBlockStart:d.levelsPadding-this._expandedLevelsMargin+"px"}},t)))}_renderLabelContainer(){const{hasPrevious:e,hasNext:t}=this.vm,s=this.messages??y,i=s.previousLevel,l=s.nextLevel;return L.tsx("div",{class:_.css.labelContainer,tabIndex:0},C({className:_.css.arrowUp,disabled:!t,icon:"chevron-up",onClick:this._onArrowUpClick,text:l}),this._labelWidget.render(),C({className:_.css.arrowDown,disabled:!e,icon:"chevron-down",onClick:this._onArrowDownClick,text:i}))}_updateComponents(){const e=this.messages??y,t=this.vm.enabled?this.vm.value:null,s=null!=this._hoveredLevel?this._hoveredLevel:t;this._levelWidgets.forEach((s=>{const i=this.vm.getValueLabel(s.level);s.label=null!=i?i:e.currentLevel?.replace("{{level}}",String(s.level)),s.active=s.level===t,s.hovering=s.level===this._hoveredLevel})),this._labelWidget.level=s,this._labelWidget.active=s===t,this._labelWidget.hovering=null!=this._hoveredLevel}_createLevelWidgets(){this._levelWidgets.forEach((e=>e.destroy())),this._levelWidgets=this._levels.map((e=>new p.LevelItem({level:e,onSelect:()=>this._onLevelToggle(e)}))),this.removeHandles(this._levelHandlesKey),this.addHandles([l.watch((()=>{const{vm:e}=this;return[this.messages,e?.value,e?.enabled,this._hoveredLevel,this._hovering]}),(()=>this._updateComponents()),l.initial),l.watch((()=>[this._normalizedPointerPosition,this._hovering]),(()=>this._onPointerPositionChange()),l.initial),l.watch((()=>this._levelWidth),(e=>this._levelWidgets.forEach((t=>t.width=e))),l.initial)],this._levelHandlesKey)}_onContainerChange(){const e=this._levelsContainer;null!=e&&(this.removeHandles(this._levelEventHandlesKey),this.addHandles([s.on(e,"pointerenter",this._onPointerEnter),s.on(e,"pointerover",this._onPointerEnter),s.on(e,"pointerleave",this._onPointerLeave),s.on(e,"pointerup",this._onPointerUp),s.on(e,"pointermove",this._onPointerMove)],this._levelEventHandlesKey))}_focusCurrentLevel(){const e=this._levelWidgets.find((e=>e.level===this.vm.value));e?.focus()}_onLevelToggle(e){const{vm:t}=this;t.enabled&&t.value===e?t.clear():t.select(e)}_onPointerPositionChange(){let e=0;this._levelWidgets.forEach(((t,s)=>{const{width:i,height:l}=this._getLevelWidgetSize(s);t.height=l,t.width=i,e+=l})),this._hoveredLevel=this._levelClosestToPointer;const t=this._expandedLevelsHeight;(null==t||Math.abs(t-e)>30)&&(this._expandedLevelsHeight=e)}_getLevelWidgetSize(e){const t={width:this._levelWidth,height:this._levelHeight};if(this._hovering){const s=this._getGaussianFactor(e,this._normalizedPointerPosition);t.width+=d.levelHoveredExtraWidth*s,t.height+=d.levelHoveredExtraHeight*s}return t}_getGaussianFactor(e,t){const s=this._numLevels-1,i=(s-e)/s,l=this._gaussianFactor*(i-t);return Math.exp(-(l**2))}};function C(e){return L.tsx("calcite-action",{appearance:"transparent",class:e.className,disabled:e.disabled,icon:e.icon,key:e.className,onclick:e.onClick,scale:"s",text:e.text,textEnabled:!1,title:e.text})}t.__decorate([o.property()],P.prototype,"vm",void 0),t.__decorate([o.property()],P.prototype,"messages",void 0),t.__decorate([o.property()],P.prototype,"_levelWidgets",void 0),t.__decorate([o.property()],P.prototype,"_labelWidget",void 0),t.__decorate([o.property()],P.prototype,"_hoveredLevel",void 0),t.__decorate([o.property()],P.prototype,"_levels",null),t.__decorate([o.property()],P.prototype,"_numLevels",null),t.__decorate([o.property({readOnly:!0})],P.prototype,"_levelsHeight",null),t.__decorate([o.property()],P.prototype,"_expandedLevelsHeight",void 0),t.__decorate([o.property({readOnly:!0})],P.prototype,"_expandedLevelsMargin",null),t.__decorate([o.property({readOnly:!0})],P.prototype,"_levelWidth",null),t.__decorate([o.property({readOnly:!0})],P.prototype,"_levelHeight",null),t.__decorate([o.property({readOnly:!0})],P.prototype,"_gaussianFactor",null),t.__decorate([o.property({readOnly:!0})],P.prototype,"_levelClosestToPointer",null),t.__decorate([o.property({type:Number,range:{min:0,max:1}})],P.prototype,"_normalizedPointerPosition",void 0),t.__decorate([o.property()],P.prototype,"_hovering",void 0),t.__decorate([o.property()],P.prototype,"_containerPosTop",void 0),t.__decorate([o.property()],P.prototype,"_levelsContainer",void 0),P=t.__decorate([h.subclass("esri.widgets.BuildingExplorer.BuildingLevelPicker.BuildingLevelPicker")],P);return P}));
