/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../core/Collection","../core/Identifiable","../core/ReactiveMap","../core/reactiveUtils","../core/accessorSupport/decorators/property","../core/has","../core/Logger","../core/RandomLCG","../core/accessorSupport/decorators/subclass","./Widget","./CatalogLayerList/CatalogLayerListViewModel","./CatalogLayerList/CatalogLayerListVisibleElements","./CatalogLayerList/css","./LayerList/LayerListItem","./LayerList/ListItem","./LayerList/support/layerListUtils","../chunks/componentsUtils","./support/globalCss","./support/listUtils","./support/widgetUtils","./support/decorators/messageBundle","./support/decorators/vmEvent","./support/jsxFactory"],(function(e,t,o,s,i,r,a,l,n,p,d,c,h,y,m,_,u,g,L,v,f,w,I,b,C){"use strict";const F=e=>Object.freeze(Object.defineProperty({__proto__:null,default:e},Symbol.toStringTag,{value:"Module"}));var M;const O=o.ofType(u);let T=M=class extends(s.IdentifiableMixin(c)){constructor(e,t){super(e,t),this._activeItem=null,this._tooltipReferenceMap=new i,this._focusRootFlowItem=!1,this._focusPanelFlowItem=!1,this._focusLayerFlowItem=null,this._layerListMap=new i,this._rootGroupUid=`operational-${this.uid}`,this._openedLayersController=null,this.catalogLayerList=null,this.catalogOptions=null,this.collapsed=!1,this.filterPlaceholder="",this.filterText="",this.headingLevel=2,this.knowledgeGraphOptions=null,this.layerTablesEnabled=new o(["knowledge-graph"]),this.mapImageOptions=null,this.messages=null,this.messagesCommon=null,this.minFilterItems=g.minFilterItems,this.openedLayers=new o,this.openedLayerLists=new o,this.selectedItems=new O,this.selectionMode="none",this.tableList=null,this.tileOptions=null,this.viewModel=new h,this.visibilityAppearance="default",this.visibleElements=new y,this._onTablesOpen=e=>{this.onTablesOpen?this.onTablesOpen(e):(this.openedLayers.push(e.layer),this._focusLayerFlowItem=e.layer.uid)},this._onCatalogOpen=e=>{this.onCatalogOpen?this.onCatalogOpen(e):(this.openedLayers.push(e.layer.parent),this._focusLayerFlowItem=e.layer.uid)},this._onPanelOpen=()=>{this._focusPanelFlowItem=!0},this._onTooltipReferenceChange=(e,t)=>{t?this._tooltipReferenceMap.set(e,t):this._tooltipReferenceMap.delete(e)},this._onTriggerAction=(e,t)=>{this.triggerAction(e,t)},this._clearActiveItem=()=>{this._activeItem=null},this._setActiveItem=e=>{if("default"!==this.visibilityAppearance)return;const t=Array.from(e.composedPath()).find((e=>e.classList?.contains(m.css.item)));this._activeItem=g.getItem(t)}}initialize(){this.addHandles(r.on((()=>this.openedLayers),"change",(()=>this._handleOpenedLayersChange()),r.initial))}loadDependencies(){return L.loadCalciteComponents({button:()=>new Promise(((t,o)=>e(["../chunks/calcite-button"],t,o))),flow:()=>new Promise(((t,o)=>e(["../chunks/calcite-flow"],t,o))),"flow-item":()=>new Promise(((t,o)=>e(["../chunks/calcite-flow-item"],t,o))),list:()=>new Promise(((t,o)=>e(["../chunks/calcite-list"],t,o))),notice:()=>new Promise(((t,o)=>e(["../chunks/calcite-notice"],t,o))),tooltip:()=>new Promise(((t,o)=>e(["../chunks/calcite-tooltip"],t,o)))})}destroy(){this._destroyOpenedLayerLists(),this._tooltipReferenceMap.clear()}get _filterEnabled(){return this.viewModel.totalItems>=this.minFilterItems&&this.visibleElements.filter}get _renderedOpenLayerFlowItems(){return this.openedLayers.toArray().map((e=>this._renderLayerFlowItem(e)))}get catalogItems(){return this.viewModel.catalogItems}set catalogItems(e){this.viewModel.catalogItems=e}get catalogLayer(){return this.viewModel.catalogLayer}set catalogLayer(e){this.viewModel.catalogLayer=e}get icon(){return"catalog-dataset"}set icon(e){this._overrideIfSome("icon",e)}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}get listItemCreatedFunction(){return this.viewModel.listItemCreatedFunction}set listItemCreatedFunction(e){this.viewModel.listItemCreatedFunction=e}get view(){return this.viewModel.view}set view(e){this.viewModel.view=e}triggerAction(e,t){return this.viewModel.triggerAction(e,t)}render(){const e=this.viewModel?.state,t={[v.globalCss.hidden]:"loading"===e,[v.globalCss.disabled]:"disabled"===e},o=this.catalogItems?.filter((e=>!e.hidden&&(this.visibleElements.errors||!e.error)));return C.tsx("div",{class:this.classes(m.css.base,v.globalCss.widget,v.globalCss.panel,t)},o?.length?[this._renderItemTooltips(o),this._renderItems(o)]:this._renderNoItems())}async _createFlowList(e,t){const{_layerListMap:o}=this,s=o.get(e);if(s)return s;const i="catalog"===e.type?await this._createCatalogLayerList(e):await this._createTableList(e);return t.aborted||o.set(e,i),i}async _handleOpenedLayersChange(){const{_layerListMap:e,openedLayers:t,openedLayerLists:o}=this;this._openedLayersController?.abort();const s=new AbortController,{signal:i}=s;this._openedLayersController=s,e.forEach(((o,s)=>{t.includes(s)||(o.destroy(),e.delete(s))}));const r=await Promise.all(t.map((e=>this._createFlowList(e,i))));if(i.aborted)return;o.removeAll(),o.addMany(r);const a=o.at(-1);a?"catalogLayer"in a?(this._set("catalogLayerList",a),this._set("tableList",null)):(this._set("catalogLayerList",null),this._set("tableList",a)):(this._set("catalogLayerList",null),this._set("tableList",null))}_destroyOpenedLayerLists(){this.openedLayerLists.destroyAll(),this.openedLayers.removeAll(),this._layerListMap.clear()}_renderItemTooltip(e){const{_tooltipReferenceMap:t,messages:o}=this;return e?C.tsx("calcite-tooltip",{key:`tooltip-${e.layer.uid}`,referenceElement:t.get(e.layer.uid)},o.layerIncompatibleTooltip):null}_renderItemTooltipNodes(e){return e.incompatible?this._renderItemTooltip(e):e.children?.filter((e=>!e.hidden)).toArray().map((e=>this._renderItemTooltipNodes(e)))}_renderItemTooltips(e){return e?.toArray().map((e=>this._renderItemTooltipNodes(e)))}_renderNoItemsMessage(){return C.tsx("div",{slot:"message"},this.messages.noItemsToDisplay)}_renderNoItems(){return C.tsx("div",{class:m.css.itemMessage,key:"esri-layer-list__no-items"},C.tsx("calcite-notice",{icon:"information",kind:"info",open:!0,width:"full"},this._renderNoItemsMessage()))}_renderPanelFlowItems(e){return e?e.flatten((e=>e.children)).filter((({hidden:e,panel:t})=>!e&&t?.open&&!t.disabled&&t.flowEnabled)).toArray().map((({title:e,panel:t})=>{const o=()=>this._handlePanelFlowItemBack(t);return C.tsx("calcite-flow-item",{afterCreate:this._focusPanelFlowItemNode,afterUpdate:this._focusPanelFlowItemNode,bind:this,description:e,heading:t.title,headingLevel:this.headingLevel,key:`flow-panel-${t.uid}`,onCalciteFlowItemBack:e=>{e.preventDefault(),o()}},t.render(),C.tsx("calcite-button",{appearance:"transparent",onclick:o,slot:"footer-actions",width:"full"},this.messagesCommon.back))})):[]}_handlePanelFlowItemBack(e){e.open=!1,this._focusRootFlowItem=!0}_focusRootFlowItemNode(e){this._focusRootFlowItem&&(this._focusRootFlowItem=!1,w.setFocus(e))}_focusPanelFlowItemNode(e){this._focusPanelFlowItem&&(this._focusPanelFlowItem=!1,w.setFocus(e))}_renderItems(e){const{visible:t,collapsed:o,_filterEnabled:s,_rootGroupUid:i,visibleElements:{closeButton:r,collapseButton:a,heading:l,flow:n},selectionMode:p,filterText:d,filterPlaceholder:c,messages:h}=this,y=[C.tsx("calcite-flow-item",{afterCreate:this._focusRootFlowItemNode,afterUpdate:this._focusRootFlowItemNode,bind:this,closable:r,closed:!t,collapsed:o,collapsible:a,heading:l?h.widgetLabel:void 0,headingLevel:this.headingLevel,key:"root-flow-item",onCalciteFlowItemClose:()=>this.visible=!1},C.tsx("calcite-list",{afterCreate:e=>{e.addEventListener("focusin",this._setActiveItem),e.addEventListener("focusout",this._clearActiveItem)},afterRemoved:e=>{e.removeEventListener("focusin",this._setActiveItem),e.removeEventListener("focusout",this._clearActiveItem)},"data-layer-type":i,filterEnabled:s,filterPlaceholder:c,filterProps:f.calciteListFilterProps,filterText:s?d:"",group:i,key:"root-list",label:h.widgetLabel,onmouseleave:this._clearActiveItem,onmouseover:this._setActiveItem,selectionAppearance:"border",selectionMode:p,onCalciteListChange:e=>this._handleCalciteListChange(e),onCalciteListFilter:e=>this.filterText=e.target?.filterText??""},e?.toArray().map((e=>this._renderItem(e))),e?.length&&s?C.tsx("div",{class:m.css.filterNoResults,slot:"filter-no-results"},C.tsx("calcite-notice",{kind:"info",open:!0,width:"full"},this._renderNoItemsMessage())):null)),this._renderPanelFlowItems(e),this._renderedOpenLayerFlowItems];return t?n?C.tsx("calcite-flow",{key:"root-flow"},y):y:null}_focusLayerFlowItemNode(e){this._focusLayerFlowItem===e.dataset.layerUid&&(this._focusLayerFlowItem=null,w.setFocus(e))}_renderLayerFlowItem(e){const{messages:t,openedLayers:o}=this,s=e.title||this.messages.untitledLayer;return C.tsx("calcite-flow-item",{afterCreate:this._focusLayerFlowItemNode,afterUpdate:this._focusLayerFlowItemNode,bind:this,"data-layer-uid":e.uid,description:s,heading:t["catalog"===e.type?"catalogLayers":"tables"],headingLevel:this.headingLevel,key:`flow-layer-list-${e.uid}`,onCalciteFlowItemBack:e=>{e.preventDefault(),o.pop();const t=o.at(-1);t?this._focusLayerFlowItem=t.uid:this._focusRootFlowItem=!0}},this._layerListMap.get(e)?.render())}async _createCatalogLayerList(e){const{headingLevel:t,catalogOptions:o,view:s,filterPlaceholder:i,listItemCreatedFunction:r,minFilterItems:a,selectionMode:l,visibilityAppearance:n,onCatalogOpen:p,onTablesOpen:d}=this;return new M({headingLevel:t,view:s,filterPlaceholder:i,listItemCreatedFunction:r,minFilterItems:a,selectionMode:l,visibilityAppearance:n,...o,catalogLayer:e,onCatalogOpen:p,onTablesOpen:d})}_getTableListParams(e){switch(e.type){case"knowledge-graph":return{...this.knowledgeGraphOptions,tables:e.tables};case"map-image":return{...this.mapImageOptions,tables:e.subtables};case"tile":return{...this.tileOptions,tables:e.subtables};default:return null}}async _createTableList(t){const{default:o}=await new Promise(((t,o)=>e(["./TableList"],(e=>t(F(e))),o))),{headingLevel:s,selectionMode:i}=this;return new o({headingLevel:s,selectionMode:i,...this._getTableListParams(t)})}_renderItem(e,t,o){return C.tsx(_,{activeItem:this._activeItem,css:m.css,dragEnabled:!1,item:e,key:`layerListItem-${e.layer.uid}`,layerTablesEnabled:this.layerTablesEnabled,listModeDisabled:this.viewModel.listModeDisabled,messages:this.messages,messagesCommon:this.messagesCommon,parent:t,parentTitles:o,rootGroupUid:this._rootGroupUid,selectedDragItemLayerUid:null,selectedItems:this.selectedItems,selectionMode:this.selectionMode,visibilityAppearance:this.visibilityAppearance,visibleElements:this.visibleElements,onAction:this._onTriggerAction,onCatalogOpen:this._onCatalogOpen,onPanelOpen:this._onPanelOpen,onTablesOpen:this._onTablesOpen,onTooltipReferenceChange:this._onTooltipReferenceChange})}_handleCalciteListChange(e){const{selectionMode:t,selectedItems:o}=this;if("none"===t)return;const s=e.target.selectedItems.map((e=>g.getItem(e))).filter(Boolean);o.removeAll(),o.addMany(s)}};t.__decorate([a.property()],T.prototype,"_activeItem",void 0),t.__decorate([a.property()],T.prototype,"_tooltipReferenceMap",void 0),t.__decorate([a.property()],T.prototype,"_focusRootFlowItem",void 0),t.__decorate([a.property()],T.prototype,"_focusPanelFlowItem",void 0),t.__decorate([a.property()],T.prototype,"_focusLayerFlowItem",void 0),t.__decorate([a.property()],T.prototype,"_layerListMap",void 0),t.__decorate([a.property()],T.prototype,"_filterEnabled",null),t.__decorate([a.property()],T.prototype,"_renderedOpenLayerFlowItems",null),t.__decorate([a.property()],T.prototype,"catalogItems",null),t.__decorate([a.property()],T.prototype,"catalogLayer",null),t.__decorate([a.property({readOnly:!0})],T.prototype,"catalogLayerList",void 0),t.__decorate([a.property()],T.prototype,"catalogOptions",void 0),t.__decorate([a.property()],T.prototype,"collapsed",void 0),t.__decorate([a.property()],T.prototype,"filterPlaceholder",void 0),t.__decorate([a.property()],T.prototype,"filterText",void 0),t.__decorate([a.property()],T.prototype,"headingLevel",void 0),t.__decorate([a.property()],T.prototype,"icon",null),t.__decorate([a.property()],T.prototype,"knowledgeGraphOptions",void 0),t.__decorate([a.property()],T.prototype,"label",null),t.__decorate([a.property()],T.prototype,"layerTablesEnabled",void 0),t.__decorate([a.property()],T.prototype,"listItemCreatedFunction",null),t.__decorate([a.property()],T.prototype,"mapImageOptions",void 0),t.__decorate([a.property(),I.messageBundle("esri/widgets/CatalogLayerList/t9n/CatalogLayerList")],T.prototype,"messages",void 0),t.__decorate([a.property(),I.messageBundle("esri/t9n/common")],T.prototype,"messagesCommon",void 0),t.__decorate([a.property()],T.prototype,"minFilterItems",void 0),t.__decorate([a.property({readOnly:!0})],T.prototype,"openedLayers",void 0),t.__decorate([a.property({readOnly:!0})],T.prototype,"openedLayerLists",void 0),t.__decorate([a.property()],T.prototype,"onCatalogOpen",void 0),t.__decorate([a.property()],T.prototype,"onTablesOpen",void 0),t.__decorate([a.property()],T.prototype,"selectedItems",void 0),t.__decorate([a.property()],T.prototype,"selectionMode",void 0),t.__decorate([a.property({readOnly:!0})],T.prototype,"tableList",void 0),t.__decorate([a.property()],T.prototype,"tileOptions",void 0),t.__decorate([a.property()],T.prototype,"view",null),t.__decorate([b.vmEvent("trigger-action"),a.property({type:h})],T.prototype,"viewModel",void 0),t.__decorate([a.property()],T.prototype,"visibilityAppearance",void 0),t.__decorate([a.property({type:y,nonNullable:!0})],T.prototype,"visibleElements",void 0),T=M=t.__decorate([d.subclass("esri.widgets.CatalogLayerList")],T);return T}));
