/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../core/Logger","../core/maybe","../core/accessorSupport/decorators/property","../core/accessorSupport/decorators/cast","../core/RandomLCG","../core/has","../core/accessorSupport/decorators/subclass","./Widget","./CoordinateConversion/CoordinateConversionViewModel","./CoordinateConversion/support/Conversion","../chunks/componentsUtils","./support/globalCss","./support/Heading","./support/legacyIcon","./support/decorators/accessibleHandler","./support/decorators/messageBundle","./support/jsxFactory","./support/widgetUtils"],(function(e,t,o,s,i,n,r,a,l,p,c,d,u,h,_,v,g,m,b,y){"use strict";const C="esri-coordinate-conversion",w={base:C,captureMode:`${C}--capture-mode`,noBasemap:`${C}--no-basemap`,popup:`${C}__popup`,clipboardPopup:`${C}__clipboard-popup`,conversionList:`${C}__conversion-list`,conversionRow:`${C}__row`,coordDisplay:`${C}__display`,expandButton:`${C}__expand-button`,expanded:`${C}__conversions-view--expanded`,expandDown:`${C}__conversions-view--expand-down`,expandUp:`${C}__conversions-view--expand-up`,conversionsView:`${C}__conversions-view`,rowSelect:`${C}__select-row`,toolDisplay:`${C}__tools`,modeToggle:`${C}__mode-toggle`,rowButton:`${C}__row-button`,coordinateInput:`${C}__input-coordinate`,inputForm:`${C}__input-form`,inputFormGroup:`${C}__input-group`,inputSelect:`${C}__input-select`,sectionHeading:`${C}__heading`,patternInput:`${C}__pattern-input`,settings:`${C}__settings`,settingsFormGroup:`${C}__settings-group`,settingsFormGroupHorizontal:`${C}__settings-group-horizontal`,previewCoordinate:`${C}__preview-coordinate`},x={settingsButton:!0,inputButton:!0,captureButton:!0,expandButton:!0},f=750,T=2500;let I=class extends p{constructor(e,t){super(e,t),this._popupMessage=null,this._popupTimeoutId=void 0,this._clipboardPopupTimeoutId=void 0,this._coordinateInput=null,this._badInput=!1,this._goToEnabled=!1,this._conversionFormat=null,this._settingsFormat=null,this._previewConversion=null,this._expanded=!1,this._clipboardPopupVisible=!1,this._popupVisible=!1,this._settingsVisible=!1,this._inputVisible=!1,this.headingLevel=4,this.messages=null,this.messagesCommon=null,this.orientation="auto",this.viewModel=new c,this.visibleElements={...x}}loadDependencies(){return u.loadCalciteComponents({button:()=>new Promise(((t,o)=>e(["../chunks/calcite-button"],t,o))),checkbox:()=>new Promise(((t,o)=>e(["../chunks/calcite-checkbox"],t,o))),input:()=>new Promise(((t,o)=>e(["../chunks/calcite-input"],t,o))),label:()=>new Promise(((t,o)=>e(["../chunks/calcite-label"],t,o))),option:()=>new Promise(((t,o)=>e(["../chunks/calcite-option"],t,o))),select:()=>new Promise(((t,o)=>e(["../chunks/calcite-select"],t,o)))})}get conversions(){return this.viewModel.conversions}set conversions(e){this.viewModel.conversions=e}get currentLocation(){return this.viewModel.currentLocation}set currentLocation(e){this.viewModel.currentLocation=e}get formats(){return this.viewModel.formats}set formats(e){this.viewModel.formats=e}get goToOverride(){return this.viewModel.goToOverride}set goToOverride(e){this.viewModel.goToOverride=e}get icon(){return"coordinate-system"}set icon(e){this._overrideIfSome("icon",e)}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}get mode(){return this.viewModel.mode}set mode(e){this.viewModel.mode=e}set multipleConversions(e){!1===e&&(this._expanded=!1,this.conversions.splice(1,this.conversions.length-1)),this._set("multipleConversions",e)}get multipleConversions(){const e=this._get("multipleConversions");return"boolean"!=typeof e||e}get locationSymbol(){return this.viewModel.locationSymbol}set locationSymbol(e){this.viewModel.locationSymbol=e}get storageEnabled(){return this.viewModel.storageEnabled}set storageEnabled(e){this.viewModel.storageEnabled=e}get storageType(){return this.viewModel.storageType}set storageType(e){this.viewModel.storageType=e}get view(){return this.viewModel.view}set view(e){this.viewModel.view=e}castVisibleElements(e){return{...x,...e}}reverseConvert(e,t){return this.viewModel.reverseConvert(e,t)}render(){const e=this.viewModel?.state,t="disabled"===e?b.tsx("div",{key:"esri-coordinate__no-basemap"},this.messages?.noBasemap):null,o=!t&&this._inputVisible?this._renderInputForm():null,s=!t&&this._settingsVisible?this._renderSettings():null,i=t||o||s?null:this._renderConversionsView(),n=this._popupVisible?this._renderPopup():null,r={[w.captureMode]:"capture"===this.mode,[h.globalCss.disabled]:"loading"===e,[w.noBasemap]:"disabled"===e};return b.tsx("div",{class:this.classes(w.base,h.globalCss.widget,r)},n,t,i,s,o)}_addConversion(e){const t=e.target,o=t.selectedOption.value,s=P(t);if(null==o||null==s)return;const i=new d({format:o});t.value="default",s>=0?(this.conversions.removeAt(s),this.conversions.add(i,s)):this.conversions.add(i)}_findSettingsFormat(){return this._settingsFormat||this.conversions.reduceRight(((e,t)=>{const o=t.format;return o?.hasDisplayProperties?o:e}),null)||this.formats.find((e=>e.hasDisplayProperties))}_hidePopup(){this._popupTimeoutId&&(clearTimeout(this._popupTimeoutId),this._popupTimeoutId=void 0),this._popupVisible=!1,this._popupMessage=null,this.scheduleRender()}_hideClipboardPopup(){this._clipboardPopupTimeoutId&&(clearTimeout(this._clipboardPopupTimeoutId),this._clipboardPopupTimeoutId=void 0),this._clipboardPopupVisible=!1,this.scheduleRender()}_onConvertComplete(){this._inputVisible=!1,this._coordinateInput.value=""}_onCopy(e){const t=M(e.currentTarget)?.displayCoordinate;null!=t&&(e.clipboardData?.setData("text/plain",t),this._showClipboardPopup(),e.preventDefault())}_processUserInput(e){const t=s.maybeProperty(e,"key"),i=this.viewModel;if("Enter"!==t&&t)this._badInput&&(this._badInput=!1);else{const e=this._conversionFormat||this.conversions.at(0).format;if(!e)return;const t=this._coordinateInput.value;this._reverseConvert(t,e).then((e=>{"capture"===this.mode?i.resume():this.mode="capture",this.currentLocation=e,i.setLocation(e),this._onConvertComplete()})).catch((e=>{o.getLogger(this).error(e),this._showPopup(this.messages?.invalidCoordinate),this._badInput=!0}))}}async _reverseConvert(e,t){const s=this.viewModel,i=await t.reverseConvert(e);return this._goToEnabled&&i&&s.goToLocation(i).catch((e=>{o.getLogger(this).warn(e),this._showPopup(this.messages?.locationOffBasemap)})),i}_setInputFormat(e){const t=e.target.selectedOption.value;null!=t&&(this._conversionFormat=t)}_setPreviewConversion(){const e=this._findSettingsFormat(),t=this.viewModel;if(e){const o=this.conversions.find((t=>t.format===e));this._previewConversion=new d({format:e,position:{location:this.currentLocation,coordinate:o?.position?.coordinate}}),this._previewConversion.position?.coordinate||t.previewConversion(this._previewConversion)}}_setSettingsFormat(e){const t=e.target.selectedOption.value;null!=t&&(this._settingsFormat=t,this._setPreviewConversion())}_showClipboardPopup(){this._clipboardPopupVisible?clearTimeout(this._clipboardPopupTimeoutId):this._clipboardPopupVisible=!0,this.scheduleRender(),this._popupTimeoutId=setTimeout((()=>{this._popupTimeoutId=void 0,this._hideClipboardPopup()}),f)}_showPopup(e,t=T){this._popupMessage=e,this._popupVisible?clearTimeout(this._popupTimeoutId):this._popupVisible=!0,this.scheduleRender(),this._popupTimeoutId=setTimeout((()=>{this._popupTimeoutId=void 0,this._hidePopup()}),t)}_toggleGoTo(){this._goToEnabled=!this._goToEnabled}_updateCurrentPattern(e){e.stopPropagation();const t=e.target,o=this._findSettingsFormat();o&&(o.currentPattern=t.value)}_renderConversion(e,t){const{messages:o}=this;if(!o)return b.tsx("li",null);const{format:s}=e,i=s?.label??"",n=`${this.id}__list-item-${t}`,r=`${i} ${o.conversionOutputSuffix}`,a=0===t,l=a||this._expanded,p=a?this._renderFirstConversion(e):this._renderTools(t,e,n),c=a&&!e.displayCoordinate?o.noLocation:e.displayCoordinate,d=b.tsx("div",{"aria-label":c,class:w.coordDisplay,"data-conversion":e,role:"listitem",tabIndex:0,title:c??""},c),u=this._renderOptions(this.formats.filter((e=>e!==s)));return l?b.tsx("li",{"aria-label":r,class:w.conversionRow,id:n,key:e,role:"group",tabIndex:0,title:r},b.tsx("calcite-select",{"aria-controls":n,bind:this,class:w.rowSelect,"data-index":t,label:o.selectFormat,scale:"s",onCalciteSelectChange:this._addConversion},b.tsx("calcite-option",{label:i.toUpperCase(),selected:!0},i.toUpperCase()),u),d,p):null}_renderCopyButton(e){const t=this._clipboardPopupVisible&&this._renderClipboardPopup(),{messagesCommon:o}=this;return o?b.tsx("li",{"aria-label":o.copy,bind:this,class:this.classes(h.globalCss.widgetButton,w.rowButton),"data-conversion":e,onclick:this._copyCoordinateOutput,oncopy:this._onCopy,onkeydown:this._copyCoordinateOutput,role:"button",tabIndex:0,title:o.copy},t,b.tsx("span",{"aria-hidden":"true",class:v.legacyIcon.duplicate})):b.tsx("li",null)}_renderFirstConversion(e){const t=this.id,{messages:o,messagesCommon:s,multipleConversions:i,visibleElements:n}=this;if(!s||!o)return b.tsx("ul",null);const r="live"===this.mode?o.captureMode:o.liveMode,a=this._expanded?s.collapse:s.expand,l=e.displayCoordinate&&"capture"===this.mode?this._renderCopyButton(e):null,p=i&&n.expandButton&&this._renderIconButton({iconType:this._expanded?"chevron-down":"chevron-up",clickFunction:this._toggleExpand,classes:[w.expandButton],attributes:{"aria-controls":`${t}__${w.conversionList}`,label:a}}),c=!i&&n.captureButton&&this._renderIconButton({iconType:"live"===this.mode?"pin-tear":"pin-tear-f",clickFunction:this._toggleMode,classes:[w.modeToggle],attributes:{label:r}});return b.tsx("ul",{class:w.toolDisplay},l,p,c)}_renderInputForm(){const e=this._conversionFormat||this.conversions.at(0).format,t=this.formats.findIndex((t=>t.name===e?.name)),o=this.id,s=`${o}__${w.coordinateInput}`,i=`${o}__${w.coordinateInput}__header`,n=this._renderOptions(this.formats,!0,t),{messages:r,messagesCommon:a,headingLevel:l}=this;if(!a||!r)return b.tsx("div",null);const p=this._renderIconButton({iconType:y.isRTL(this.container)?"arrow-right":"arrow-left",clickFunction:this._toggleInputVisibility,attributes:{label:a.back}});return b.tsx("div",{"aria-labelledby":i,class:w.inputForm,key:"esri-coordinate-conversion__input-form",role:"search"},b.tsx("div",{class:w.sectionHeading},p,b.tsx(_.Heading,{class:h.globalCss.heading,id:i,level:l},r.inputCoordTitle)),b.tsx("div",{class:w.inputFormGroup},b.tsx("calcite-select",{"aria-controls":s,bind:this,class:w.inputSelect,label:r.selectFormat,scale:"s",onCalciteSelectChange:this._setInputFormat},n),b.tsx("calcite-input",{afterCreate:y.storeNode,"aria-labelledby":i,bind:this,class:w.coordinateInput,"data-format":e,"data-node-ref":"_coordinateInput",id:s,onkeydown:this._processUserInput,placeholder:r.inputCoordTitle,required:!0,scale:"s",spellcheck:!1,status:this._badInput?"invalid":"idle"})),b.tsx("div",{class:w.inputFormGroup},b.tsx("calcite-label",{layout:"inline",scale:"s"},b.tsx("calcite-checkbox",{bind:this,checked:this._goToEnabled,onCalciteCheckboxChange:this._toggleGoTo}),r.goTo),b.tsx("calcite-button",{appearance:"outline",bind:this,kind:"neutral",onclick:this._processUserInput,type:"button",width:"auto"},r.convert)))}_renderConversionsView(){const{messages:e}=this;if(!e)return b.tsx("div",null);const t=`${this.id}__${w.conversionList}`,o=this._renderPrimaryTools(),s=this._renderOptions(this.formats),i=this.conversions.map(((e,t)=>this._renderConversion(e,t))).toArray(),n=this._expanded?b.tsx("div",{class:w.conversionRow},b.tsx("calcite-select",{"aria-controls":t,bind:this,"data-index":-1,label:e.addConversion,scale:"s",onCalciteSelectChange:this._addConversion},b.tsx("calcite-option",{disabled:!0,selected:!0,value:"default"},e.addConversion),s),o):null,r={[w.expanded]:this._expanded,[w.expandUp]:"expand-up"===this.orientation,[w.expandDown]:"expand-down"===this.orientation};return b.tsx("div",{class:this.classes(w.conversionsView,r),key:"esri-coordinate-conversion__main-view"},b.tsx("ul",{"aria-expanded":this._expanded?"true":"false",class:w.conversionList,id:t},i),n)}_renderOptions(e,t,o){const s=this.conversions.at(0),i=s.format?.name;return e.map(((e,n)=>{const r=!(t||!s)&&(i===e.name||this.conversions.map((e=>e.format?.name)).includes(e.name));return b.tsx("calcite-option",{disabled:r,key:e.name??"unnamed-format",label:e.label.toUpperCase(),selected:n===o,value:e},e.label)})).toArray()}_renderPopup(){return b.tsx("div",{class:w.popup,role:"alert"},this._popupMessage)}_renderClipboardPopup(){const{messages:e}=this;return e?b.tsx("div",{class:this.classes(w.popup,w.clipboardPopup),role:"alert"},e.copySuccessMessage):b.tsx("div",null)}_renderPrimaryTools(){const{messages:e,visibleElements:t}=this;if(!e)return b.tsx("ul",null);const o="live"===this.mode?e.captureMode:e.liveMode,s=t.inputButton&&this._renderIconButton({iconType:"pencil",clickFunction:this._toggleInputVisibility,attributes:{label:e.inputCoordTitle}}),i=t.captureButton&&this._renderIconButton({iconType:"live"===this.mode?"pin-tear":"pin-tear-f",clickFunction:this._toggleMode,classes:[w.modeToggle],attributes:{label:o}}),n=t.settingsButton&&this._renderIconButton({iconType:"gear",clickFunction:this._toggleSettingsVisibility,attributes:{label:e.settingsTitle}});return b.tsx("ul",{class:w.toolDisplay},s,i,n)}_renderSettings(){const e=this.id,t=`${e}__${w.patternInput}`,o=`${e}__${w.patternInput}__header`,s=`${e}__${w.previewCoordinate}`,i=this.formats.filter((e=>e.hasDisplayProperties)),n=this._findSettingsFormat(),r=n?i.indexOf(n):-1,a=this._renderOptions(i,!0,r),l=n?.currentPattern,{messages:p,messagesCommon:c,headingLevel:d}=this;if(!c||!p)return b.tsx("div",null);const u=this._renderIconButton({iconType:y.isRTL(this.container)?"arrow-right":"arrow-left",clickFunction:this._toggleSettingsVisibility,attributes:{label:c.back}}),v=this._renderIconButton({iconType:"refresh",clickFunction:this._setDefaultPattern,attributes:{label:p.defaultPattern}});return b.tsx("div",{"aria-labelledby":o,class:w.settings,key:w.settings},b.tsx("div",{class:w.sectionHeading},u,b.tsx(_.Heading,{class:h.globalCss.heading,id:o,level:d},p.settingsTitle)),b.tsx("div",{class:w.settingsFormGroup},b.tsx("label",{for:t},p.changeCoordinateDisplay),b.tsx("calcite-select",{bind:this,label:p.selectFormat,width:"full",onCalciteSelectChange:this._setSettingsFormat},a),b.tsx("div",{class:w.settingsFormGroupHorizontal},b.tsx("calcite-input",{"aria-controls":s,bind:this,class:w.patternInput,id:t,spellcheck:!1,type:"text",value:l,onCalciteInputInput:this._updateCurrentPattern}),v)),b.tsx("div",{class:w.settingsFormGroup},b.tsx("label",null,c.preview,b.tsx("div",{class:w.previewCoordinate,id:s,tabIndex:0},this._previewConversion?.displayCoordinate))))}_renderIconButton(e){const{iconType:t,clickFunction:o,classes:s,attributes:i}=e;return b.tsx("calcite-button",{appearance:"transparent",bind:this,class:this.classes(s),iconStart:t,kind:"neutral",onclick:o,onkeydown:o,...i})}_renderTools(e,t,o){const s=t.displayCoordinate&&"capture"===this.mode?this._renderCopyButton(t):null,{messages:i}=this;if(!i)return b.tsx("ul",null);const n=this._renderIconButton({iconType:"x",clickFunction:this._removeConversion,attributes:{"aria-controls":o,label:i.removeConversion,"data-index":e}});return b.tsx("ul",{class:w.toolDisplay,role:"listitem"},s,b.tsx("li",{class:this.classes(w.rowButton)},n))}_copyCoordinateOutput(e){const t=e.target;if(!("createTextRange"in document.body)){const e=window.getSelection(),o=document.createRange();o.selectNodeContents(t),e?.removeAllRanges(),e?.addRange(o)}document.execCommand("copy")}_removeConversion(e){const t=P(e.currentTarget);null!=t&&this.conversions.removeAt(t)}_setDefaultPattern(e){e.stopPropagation();const t=this._findSettingsFormat();t&&(t.currentPattern=t.defaultPattern)}_toggleExpand(){this._expanded=!this._expanded}_toggleInputVisibility(){this._inputVisible=!this._inputVisible,this._popupVisible&&this._hidePopup(),this._inputVisible?this.viewModel.pause():this.viewModel.resume()}_toggleMode(){this.mode="live"===this.mode?"capture":"live"}_toggleSettingsVisibility(){this._settingsVisible=!this._settingsVisible,this._popupVisible&&this._hidePopup(),this._settingsVisible?(this._setPreviewConversion(),this.viewModel.pause()):this.viewModel.resume()}};t.__decorate([i.property()],I.prototype,"conversions",null),t.__decorate([i.property()],I.prototype,"currentLocation",null),t.__decorate([i.property()],I.prototype,"formats",null),t.__decorate([i.property()],I.prototype,"goToOverride",null),t.__decorate([i.property()],I.prototype,"headingLevel",void 0),t.__decorate([i.property()],I.prototype,"icon",null),t.__decorate([i.property()],I.prototype,"label",null),t.__decorate([i.property(),m.messageBundle("esri/widgets/CoordinateConversion/t9n/CoordinateConversion")],I.prototype,"messages",void 0),t.__decorate([i.property(),m.messageBundle("esri/t9n/common")],I.prototype,"messagesCommon",void 0),t.__decorate([i.property()],I.prototype,"mode",null),t.__decorate([i.property()],I.prototype,"orientation",void 0),t.__decorate([i.property()],I.prototype,"multipleConversions",null),t.__decorate([i.property()],I.prototype,"locationSymbol",null),t.__decorate([i.property()],I.prototype,"storageEnabled",null),t.__decorate([i.property()],I.prototype,"storageType",null),t.__decorate([i.property()],I.prototype,"view",null),t.__decorate([i.property({type:c})],I.prototype,"viewModel",void 0),t.__decorate([i.property()],I.prototype,"visibleElements",void 0),t.__decorate([n.cast("visibleElements")],I.prototype,"castVisibleElements",null),t.__decorate([g.accessibleHandler()],I.prototype,"_copyCoordinateOutput",null),t.__decorate([g.accessibleHandler()],I.prototype,"_removeConversion",null),t.__decorate([g.accessibleHandler()],I.prototype,"_setDefaultPattern",null),t.__decorate([g.accessibleHandler()],I.prototype,"_toggleExpand",null),t.__decorate([g.accessibleHandler()],I.prototype,"_toggleInputVisibility",null),t.__decorate([g.accessibleHandler()],I.prototype,"_toggleMode",null),t.__decorate([g.accessibleHandler()],I.prototype,"_toggleSettingsVisibility",null),I=t.__decorate([l.subclass("esri.widgets.CoordinateConversion")],I);function P(e){return e["data-index"]}function M(e){return e["data-conversion"]}return I}));
