/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../assets","../../Graphic","../../intl","../../core/Collection","../../core/Error","../../core/Evented","../../core/Logger","../../core/reactiveUtils","../../core/accessorSupport/decorators/property","../../core/accessorSupport/decorators/cast","../../core/RandomLCG","../../core/has","../../core/accessorSupport/decorators/subclass","../../geometry/Point","../../geometry/projection","../../symbols/PictureMarkerSymbol","./support/Conversion","./support/coordinateConversionUtils","./support/formatUtils","../support/GoTo","../../intl/locale","../../intl/messages"],(function(t,e,o,i,s,n,r,a,c,h,d,l,p,v,u,m,_,g,f,w,y,C,b){"use strict";const L={default:"default",crosshair:"crosshair"},M=new u([0,0,500]),P="xy",S=["mgrs","utm","usng","dd","dms","ddm"],F="esri__coordinateConversionWidgetState",G={conversions:"conversions",formats:"formats",view:"view",viewChange:"view-change"},H="esri/images/search/search-symbol-32.png";let E=class extends(y.GoToMixin(r.EventedAccessor)){constructor(t){super(t),this._conversionPromise=null,this._locationGraphic=null,this._pointerCount=0,this.conversions=new s,this.formats=new s,this.formatterAvailable=!1,this.messages=null,this.filteredFormats=new s,this.locationSymbol=new _({url:e.getAssetUrl(H),width:24,height:24}),this.storageEnabled=!0,this.storageType="session",this.view=null,this._saveWidgetState=this._saveWidgetState.bind(this),this._handleFormatChange=this._handleFormatChange.bind(this),this._handleConversionChange=this._handleConversionChange.bind(this),this._handleViewChange=this._handleViewChange.bind(this),this._onClick=this._onClick.bind(this),this._onPointerMove=this._onPointerMove.bind(this),this._onPointerDown=this._onPointerDown.bind(this),this._onPointerUp=this._onPointerUp.bind(this)}initialize(){const t=async()=>this.messages=await b.fetchMessageBundle("esri/widgets/CoordinateConversion/t9n/CoordinateConversion");this.formats.addMany(w.generateDefaultFormats()),t().then((()=>{if(!this.destroyed&&(w.setDefaultPatterns(this.messages,this.formats),this.storageEnabled&&this._loadWidgetState(),this.formats.forEach((t=>{t.viewModel=this,this.addHandles(c.watch((()=>t.currentPattern),this._saveWidgetState),t.name??"unnamed-format")})),this.addHandles(this.conversions.on("change",this._handleConversionChange),G.conversions),this.addHandles(this.formats.on("change",this._handleFormatChange),G.formats),this.addHandles(C.onLocaleChange((()=>{t().then((()=>{w.setDefaultPatterns(this.messages,this.formats)}))}))),m.load().then((()=>{this.formatterAvailable=!0})).catch((t=>{a.getLogger(this).error(new n("coordinate-conversion:projection-load-failed","Failed to load the projection module.",{error:t})),this.formatterAvailable=!1,this._filterFormatsAndConversions()})).then((()=>this.addHandles(c.watch((()=>this.view),this._handleViewChange,c.initial),G.viewChange))),0===this.conversions.length)){const t=this.formats.find((t=>t.name===P))||this.formats.at(0);this.conversions.add(new g({format:t}))}}))}destroy(){this.removeHandles(),this._cleanUpView(this.view),this.view=null}castConversions(t){return this._castToConversions(t)}set currentLocation(t){this._set("currentLocation",t),this._updateConversions()}get currentLocation(){return this._get("currentLocation")||null}set mode(t){switch(t){case"capture":this.currentLocation=null,this._startCaptureMode(),this._set("mode",t);break;case"live":this._startLiveMode(),this._set("mode",t)}}get mode(){return this._get("mode")||"live"}get state(){const{messages:t,view:e}=this,o=e?.ready;return t?o?"ready":e?"loading":"disabled":"disabled"}get storage(){const{storageType:t}=this;return"session"===t?sessionStorage:localStorage}get waitingForConversions(){return null!=this._conversionPromise}setLocation(t){if(this._locationGraphic&&this.view?.graphics.remove(this._locationGraphic),!t)return;const e=t.clone();e.hasZ&&(e.z=void 0),this._locationGraphic=new o({geometry:e,symbol:this.locationSymbol}),this.view?.graphics.add(this._locationGraphic)}async convert(t,e){if(!f.isValidPoint(e))throw new n("coordinate-conversion:invalid-point","Invalid point cannot be converted.",{point:e});return Promise.resolve().then((()=>t.convert(e)))}async goToLocation(t){const{view:e}=this;if(!e)throw new n("coordinate-conversion:go-to-failed","no view");const o="3d"===e.type?e.clippingArea:null,i=e.map?.basemap?.baseLayers;if(o||i?.length>0){const e=o??i.at(0)?.fullExtent;if(null!=e&&!e.contains(t))throw new n("coordinate-conversion:go-to-failed","Point outside basemap extent.",{point:t})}return this.callGoTo({target:t})}pause(){this.currentLocation=null,this.removeHandles(G.view),this.view&&(this.view.cursor=L.default,this._locationGraphic&&this.view.graphics.remove(this._locationGraphic))}async previewConversion(t,e=this.currentLocation||M){return(await x(t,e)).displayCoordinate}resume(){"capture"===this.mode?this._startCaptureMode():this._startLiveMode()}reverseConvert(t,e){return e.reverseConvert(t)}async updateConversions(t,e){if("point"!==e?.type)throw this._clearConversions(this.conversions),new n("coordinate-conversion:invalid-input-point","Point is invalid, conversions cannot be updated.",{point:e});return this._convertMany(t,e)}_castToConversions(t){const e=new s;return t.forEach((t=>{let o=null;if(t instanceof g)o=t;else if("string"==typeof t){const e=this.formats.find((e=>e.name===t));e&&(o=new g({format:e}))}o&&e.add(o)})),e}_cleanUpView(t){t&&(this._locationGraphic&&t.graphics.remove(this._locationGraphic),this.removeHandles(G.view),t.cursor=L.default)}_clearConversions(t){t.forEach((t=>{t.position={location:null,coordinate:null}}))}async _convertMany(t,e){return Promise.all(t.map((t=>x(t,e))))}_handleConversionChange(t){for(const e of t.added){const{format:t}=e;t&&(t.viewModel=this,this.currentLocation&&(this._set("waitingForConversions",!0),this.convert(t,this.currentLocation).then((t=>{e.position=t,this._set("waitingForConversions",!1)}))))}this._saveWidgetState()}_handleFormatChange(t){t.added.forEach((t=>{this.addHandles(c.watch((()=>t.currentPattern),this._saveWidgetState),t.name??"unnamed-format"),t.viewModel=this})),t.removed.forEach((t=>{t.viewModel=null;const e=this.conversions.filter((e=>e.format===t));this.conversions.removeMany(e),t.name&&this.removeHandles(t.name)}))}_loadWidgetState(){try{const t=JSON.parse(this.storage.getItem(F));t&&this._setWidgetState(t)}catch(t){a.getLogger(this).error(new n("coordinate-conversion:invalid-session-storage-json","Could not read from storage.",{error:t}))}}_startCaptureMode(){this.removeHandles(G.view),this.view&&(this.view.cursor=L.crosshair,this.currentLocation&&this.setLocation(this.currentLocation),this.addHandles(this.view.on("click",this._onClick),G.view))}_startLiveMode(){this._pointerCount=0,this.removeHandles(G.view),this.view&&(this.view.cursor=L.default,this._locationGraphic&&this.view.graphics.remove(this._locationGraphic),this.addHandles([this.view.on("pointer-down",this._onPointerDown),this.view.on("pointer-up",this._onPointerUp),this.view.on("pointer-move",this._onPointerMove)],G.view))}_handleViewChange(t,e){e&&e!==t&&this._cleanUpView(e),t&&("capture"===this.mode?this._startCaptureMode():this._startLiveMode(),e&&this._filterFormatsAndConversions())}_onClick(t){if(0===t.button){const e=this.view?.toMap(t),o=e?.normalize();this.setLocation(o),this.currentLocation=o}}_onPointerDown(t){const{pointerType:e}=t;if(this._pointerCount++,("touch"===e||"pen"===e)&&1===this._pointerCount){const e=this.view?.toMap(t);this.currentLocation=e?.normalize()}}_onPointerMove(t){const{pointerType:e}=t;if("mouse"===e||1===this._pointerCount){const e=this.view?.toMap(t);this.currentLocation=e?.normalize()}}_onPointerUp(){this._pointerCount--}_setWidgetState(t){try{t.formats.forEach((e=>{const o=this.formats.find((t=>t.name===e.name));o&&t.locale===C.getLocale()&&e.currentPattern&&(o.currentPattern=e.currentPattern),o&&e.index>=0&&this.conversions.add(new g({format:o}))}))}catch(e){a.getLogger(this).warn(new n("coordinate-conversion:session-storage-read-error","Could not get widget state from stored JSON.",{error:e}))}}_saveWidgetState(){if(!this.storageEnabled)return;const t=this._toJSON();try{this.storage.setItem(F,JSON.stringify({formats:t,locale:C.getLocale()}))}catch(e){a.getLogger(this).error(new n("coordinate-conversion:local-storage-write-error","Could not write to localStorage.",{error:e}))}}async _updateConversions(){try{await this.updateConversions(this.conversions.toArray(),this.currentLocation)}catch{}}_toJSON(){return this.formats.filter((t=>{const e=t.name;return"xy"===e||"basemap"===e||f.isSupportedNotation(e)})).map((t=>({name:t.name,currentPattern:t.currentPattern,defaultPattern:t.defaultPattern,index:this.conversions.findIndex((e=>e.format===t))}))).sort(((t,e)=>t.index-e.index)).toArray()}_filterFormatsAndConversions(){const{formatterAvailable:t,conversions:e,formats:o}=this;t||this.addHandles(c.when((()=>this.view?.spatialReference),(t=>{const i=t.isWebMercator||t.isWGS84,s=o.filter((t=>{const{name:e}=t;return!!W(e)||"xy"===e&&!i})),n=this.filteredFormats.filter((t=>"xy"===t.name&&i&&!this.formats.includes(t))),r=e.filter((t=>s.includes(t.format)));o.removeMany(s),e.removeMany(r),this.filteredFormats.addMany(s.filter((t=>!this.filteredFormats.includes(t)))),o.addMany(n)}),{once:!0,initial:!0}),G.view)}};async function x(t,e){try{t.position=await(t.format?.convert(e))}catch(o){t.position=null}return t}function W(t){return S.includes(t)}t.__decorate([h.property()],E.prototype,"conversions",void 0),t.__decorate([d.cast("conversions")],E.prototype,"castConversions",null),t.__decorate([h.property({type:u})],E.prototype,"currentLocation",null),t.__decorate([h.property()],E.prototype,"formats",void 0),t.__decorate([h.property()],E.prototype,"messages",void 0),t.__decorate([h.property()],E.prototype,"mode",null),t.__decorate([h.property()],E.prototype,"filteredFormats",void 0),t.__decorate([h.property({readOnly:!0})],E.prototype,"state",null),t.__decorate([h.property()],E.prototype,"locationSymbol",void 0),t.__decorate([h.property({readOnly:!0,dependsOn:["storageType"]})],E.prototype,"storage",null),t.__decorate([h.property()],E.prototype,"storageEnabled",void 0),t.__decorate([h.property()],E.prototype,"storageType",void 0),t.__decorate([h.property({readOnly:!0})],E.prototype,"waitingForConversions",null),t.__decorate([h.property()],E.prototype,"view",void 0),E=t.__decorate([v.subclass("esri.widgets.CoordinateConversion.CoordinateConversionViewModel")],E);return E}));
