/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../geometry","../../../core/Accessor","../../../core/Error","../../../core/has","../../../core/accessorSupport/decorators/property","../../../core/Logger","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../../geometry/coordinateFormatter","../../../geometry/projection","../../../geometry/support/spatialReferenceUtils","../../../geometry/support/webMercatorUtils","./coordinateConversionUtils","../../../geometry/SpatialReference"],(function(e,t,r,o,n,a,i,s,c,l,p,u,d,h,f){"use strict";let m=class extends r{constructor(e){super(e),this.conversionInfo=null,this.coordinateSegments=null,this._currentPattern=void 0,this.defaultPattern=null,this.name=null,this.viewModel=null}get currentPattern(){return(this._currentPattern||this.defaultPattern)??""}set currentPattern(e){this._currentPattern=e}get label(){return this.name??""}set label(e){this._overrideIfSome("label",e)}get hasDisplayProperties(){return!(!this.defaultPattern||!this.coordinateSegments)}get spatialReference(){return"basemap"===this.name?this._viewSpatialReference:this.conversionInfo?.spatialReference??f.WGS84}set spatialReference(e){this._overrideIfSome("spatialReference",e)}get _viewSpatialReference(){return this.viewModel?.view?.spatialReference??f.WGS84}get _additionalCharactersPattern(){const e=this.coordinateSegments;if(!e)return null;const t=e.map((e=>e.alias)),r=this.currentPattern.replaceAll(new RegExp(`["nsew${t.join()}]`,"gi"),"").replaceAll(" ","");return new RegExp(`[${r}]`,"g")}get test(){}async convert(e){if(!h.isValidPoint(e))throw new o("format:invalid-point","Could not convert invalid point.",{point:e});const t=this.conversionInfo?.convert;if(t)return Promise.resolve().then((()=>t(e)));const r=await this._project(e,this.spatialReference);return{location:r,coordinate:await this._getCoordinate(r)}}getConversionStrategy(){const e=this._viewSpatialReference;return this.conversionInfo?.convert||this.viewModel?.formatterAvailable||"xy"===this.name&&(e.isWebMercator||e.isWGS84)||"basemap"===this.name?"client":"server"}getDisplayCoordinate(e){if(!e)return null;if(!this.coordinateSegments||!this.currentPattern)return e;let t=this.currentPattern;const r=this._getSegmentMatches(e,!1);for(let o=this.coordinateSegments.length-1;o>=0;o--){const e=this.coordinateSegments[o];t=t.replace(e.alias,r[o])}return t}_parseUserInput(e){const{defaultPattern:t,_additionalCharactersPattern:r,coordinateSegments:o}=this;if(!t||!r)return"";let n=t.replace(r,"");e=e.replace(r,"");const a=this._getSegmentMatches(e,!0);if(o)for(let i=o.length-1;i>=0;i--){const e=o[i];n=n.replace(e.alias,a[i])}return n}_getSegmentMatches(e,t){const r=new Array,{coordinateSegments:o}=this;if(!o)return r;for(let n=0;n<o.length;n++){const a=o[n],i=e.match(a.searchPattern);if(!i){r.push("");continue}let s=i[0];if(e=e.replace(s,"").trim(),a.substitution){const e=t?a.substitution.input(s):a.substitution.output(s);e&&(s=`${e}`)}r.push(s)}return r}async reverseConvert(e){const t=this._parseUserInput(e),r=this.conversionInfo?.reverseConvert;let n;if(r)n=r(t);else if("xy"===this.name||"basemap"===this.name)n=h.fromXY(t,this.spatialReference);else if(this.viewModel?.formatterAvailable)switch(this.name){case"dd":case"ddm":case"dms":n=l.fromLatitudeLongitude(t,this.spatialReference);break;case"mgrs":{const e="automatic";n=l.fromMgrs(t,this.spatialReference,e);break}case"utm":{const e="latitude-band-indicators";n=l.fromUtm(t,this.spatialReference,e);break}case"usng":n=l.fromUsng(t,this.spatialReference);break;default:n=null}if(!n)throw new o("format:invalid-input","Could not parse input into point.",{userInput:e});return this._project(n,this._viewSpatialReference)}async _getCoordinate(e){const t=this.viewModel?.view?.scale??0;if(!h.isValidPoint(e))throw new o("format:invalid-point","Could not transform invalid point into coordinate.",{point:e});if(this.viewModel?.formatterAvailable||"basemap"===this.name||"xy"===this.name)switch(this.name){case"dd":case"ddm":case"dms":{const r=h.getDegreePrecision(t);return l.toLatitudeLongitude(e,this.name,r)}case"mgrs":{const t=!1,r=5,o="automatic";return l.toMgrs(e,o,r,t)}case"usng":{const t=!1,r=5;return l.toUsng(e,r,t)}case"utm":{const t=!0,r="latitude-band-indicators";return l.toUtm(e,r,t)}default:return h.pointToCoordinate(e,t)}return h.pointToCoordinate(e,t)}async _project(e,t){if(u.equals(e.spatialReference,t)||!t)return e;if(this.viewModel?.formatterAvailable&&p.isLoaded())return p.project(e,t);if(!this.viewModel?.formatterAvailable){const r=d.project(e,t);if(null!=r)return r}return null}};e.__decorate([a.property()],m.prototype,"conversionInfo",void 0),e.__decorate([a.property()],m.prototype,"coordinateSegments",void 0),e.__decorate([a.property()],m.prototype,"currentPattern",null),e.__decorate([a.property()],m.prototype,"_currentPattern",void 0),e.__decorate([a.property()],m.prototype,"label",null),e.__decorate([a.property()],m.prototype,"defaultPattern",void 0),e.__decorate([a.property({readOnly:!0})],m.prototype,"hasDisplayProperties",null),e.__decorate([a.property()],m.prototype,"name",void 0),e.__decorate([a.property({type:f})],m.prototype,"spatialReference",null),e.__decorate([a.property()],m.prototype,"viewModel",void 0),e.__decorate([a.property({readOnly:!0})],m.prototype,"_viewSpatialReference",null),e.__decorate([a.property({readOnly:!0})],m.prototype,"_additionalCharactersPattern",null),m=e.__decorate([c.subclass("esri.widgets.CoordinateConversion.support.Format")],m);return m}));
