/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../core/number","../../../intl/locale","./Format"],(function(t,e,i,n){"use strict";const a=e.getCustoms().decimal,s={N:"north",S:"south",E:"east",W:"west"},r=`°${"‎"}`,o=new RegExp(`-?\\d+[\\.|\\${a}]?\\d*`),u=/^[\\0]+(?=\d)/;function d(t,n){const a="ar"===i.getLocale(),o=t.abbreviatedDirections.north,u=t.abbreviatedDirections.south,d=t.abbreviatedDirections.east,c=t.abbreviatedDirections.west,b=e.getCustoms().decimal,h={[o]:"N",[u]:"S",[d]:"E",[c]:"W"},g=new RegExp(`-?\\d+[\\.|\\${b}]?\\d*`),P=new RegExp(`N|S|${o}|${u}`,"i"),$=new RegExp(`E|W|${d}|${c}`,"i"),m={ddm:`Y${r} A'${t.abbreviatedDirections.north}, X${r} B'${t.abbreviatedDirections.east}`,dms:`Y${r} A' B"${t.abbreviatedDirections.north}, X${r} C' D"${t.abbreviatedDirections.east}`,dd:`Y${r}${t.abbreviatedDirections.north}, X${r}${t.abbreviatedDirections.east}`,xy:`X${r}, Y${r}`,basemap:"X, Y"},w={ddm:`${t.abbreviatedDirections.north}${r}Y 'A ,${t.abbreviatedDirections.east}${r}X 'B`,dms:`${t.abbreviatedDirections.north}${r}Y 'A "B ,${t.abbreviatedDirections.east}${r}X 'C "D`,dd:`${t.abbreviatedDirections.north}${r}Y ,${t.abbreviatedDirections.east}${r}X`,xy:`X${r} ,Y${r}`,basemap:"X ,Y"},D=t=>null!=t&&Object.keys(m).includes(t),v=new RegExp(`\\d{1,2}[\\.|\\${b}]?\\d*`,"i"),E=new RegExp(`\\d{1,3}[\\.|\\${b}]?\\d*`,"i");n.forEach((e=>{const{name:i}=e;if("dd"===i?e.coordinateSegments=[{alias:"Y",description:"degrees latitude",searchPattern:v,substitution:{input:t=>l(t),output:t=>p(t)}},{alias:t.abbreviatedDirections.north,description:"north/south indicator",searchPattern:P,substitution:{input:t=>h[t],output:e=>t.abbreviatedDirections[s[e]]}},{alias:"X",description:"degrees longitude",searchPattern:E,substitution:{input:t=>l(t),output:t=>p(t)}},{alias:t.abbreviatedDirections.east,description:"east/west indicator",searchPattern:$,substitution:{input:t=>h[t],output:e=>t.abbreviatedDirections[s[e]]}}]:"ddm"===i?e.coordinateSegments=[{alias:"Y",description:"degrees latitude",searchPattern:v,substitution:{input:t=>l(t),output:t=>p(t)}},{alias:"A",description:"minutes latitude",searchPattern:v,substitution:{input:t=>l(t),output:t=>p(t)}},{alias:t.abbreviatedDirections.north,description:"north/south indicator",searchPattern:P,substitution:{input:t=>h[t],output:e=>t.abbreviatedDirections[s[e]]}},{alias:"X",description:"degrees longitude",searchPattern:E,substitution:{input:t=>l(t),output:t=>p(t)}},{alias:"B",description:"minutes longitude",searchPattern:v,substitution:{input:t=>l(t),output:t=>p(t)}},{alias:t.abbreviatedDirections.east,description:"east/west indicator",searchPattern:$,substitution:{input:t=>h[t],output:e=>t.abbreviatedDirections[s[e]]}}]:"dms"===i?e.coordinateSegments=[{alias:"Y",description:"degrees latitude",searchPattern:v,substitution:{input:t=>l(t),output:t=>p(t)}},{alias:"A",description:"minutes latitude",searchPattern:v,substitution:{input:t=>l(t),output:t=>p(t)}},{alias:"B",description:"seconds latitude",searchPattern:v,substitution:{input:t=>l(t),output:t=>p(t)}},{alias:t.abbreviatedDirections.north,description:"north/south indicator",searchPattern:P,substitution:{input:t=>h[t],output:e=>t.abbreviatedDirections[s[e]]}},{alias:"X",description:"degrees longitude",searchPattern:E,substitution:{input:t=>l(t),output:t=>p(t)}},{alias:"C",description:"minutes longitude",searchPattern:v,substitution:{input:t=>l(t),output:t=>p(t)}},{alias:"D",description:"seconds longitude",searchPattern:v,substitution:{input:t=>l(t),output:t=>p(t)}},{alias:t.abbreviatedDirections.east,description:"east/west indicator",searchPattern:$,substitution:{input:t=>h[t],output:e=>t.abbreviatedDirections[s[e]]}}]:("xy"===e.name||"basemap"===e.name)&&(e.coordinateSegments=[{alias:"X",description:"easting",searchPattern:g,substitution:{input:t=>l(t),output:t=>p(t)}},{alias:"Y",description:"northing",searchPattern:g,substitution:{input:t=>l(t),output:t=>p(t)}}]),D(i)){const t=a?w[i]:m[i];e.defaultPattern=t,e.currentPattern=t}}))}function c(){const t=new RegExp("N|S","i"),e=new RegExp("E|W","i");return[new n({name:"basemap",coordinateSegments:[{alias:"X",description:"easting",searchPattern:o,substitution:{input:t=>l(t),output:t=>p(t)}},{alias:"Y",description:"northing",searchPattern:o,substitution:{input:t=>l(t),output:t=>p(t)}}],defaultPattern:"X, Y",viewModel:null}),new n({name:"dd",coordinateSegments:[{alias:"Y",description:"degrees latitude",searchPattern:new RegExp(`\\d{1,2}[\\.|\\${a}]?\\d*(?=\\D*?[N|S])`,"i"),substitution:{input:t=>l(t),output:t=>p(t)}},{alias:"N",description:"north/south indicator",searchPattern:t},{alias:"X",description:"degrees longitude",searchPattern:new RegExp(`\\d{1,3}[\\.|\\${a}]?\\d*(?=\\D*?[E|W|])`,"i"),substitution:{input:t=>l(t),output:t=>p(t)}},{alias:"E",description:"east/west indicator",searchPattern:e}],defaultPattern:`Y${r}N, X${r}E`,viewModel:null}),new n({name:"ddm",coordinateSegments:[{alias:"Y",description:"degrees latitude",searchPattern:new RegExp("\\d{1,2}(?=.*?\\s+.*?[N|S])","i"),substitution:{input:t=>l(t),output:t=>p(t)}},{alias:"A",description:"minutes latitude",searchPattern:new RegExp(`\\d{1,2}[\\.\\${a}]?\\d*(?=.*?[N|S])`,"i"),substitution:{input:t=>l(t),output:t=>p(t)}},{alias:"N",description:"north/south indicator",searchPattern:t},{alias:"X",description:"degrees longitude",searchPattern:new RegExp("\\d{1,3}(?=\\D*?\\s+.*?[E|W])","i"),substitution:{input:t=>l(t),output:t=>p(t)}},{alias:"B",description:"minutes longitude",searchPattern:new RegExp(`\\d{1,2}[\\.|\\|${a}]?\\d*(?=.*?[E|W])`,"i"),substitution:{input:t=>l(t),output:t=>p(t)}},{alias:"E",description:"east/west indicator",searchPattern:e}],defaultPattern:`Y${r} A'N, X${r} B'E`,viewModel:null}),new n({name:"dms",coordinateSegments:[{alias:"Y",description:"degrees latitude",searchPattern:new RegExp("\\d{1,2}(?=.*?\\s+.*?[N|S])","i"),substitution:{input:t=>l(t),output:t=>p(t)}},{alias:"A",description:"minutes latitude",searchPattern:new RegExp("\\d{1,2}(?=.*?[N|S])","i"),substitution:{input:t=>l(t),output:t=>p(t)}},{alias:"B",description:"seconds latitude",searchPattern:new RegExp(`\\d{1,2}[\\.|\\${a}]?\\d*(?=.*?[N|S])`,"i"),substitution:{input:t=>l(t),output:t=>p(t)}},{alias:"N",description:"north/south indicator",searchPattern:t},{alias:"X",description:"degrees longitude",searchPattern:new RegExp("\\d{1,3}(?=.*?\\s+.*?[E|W])","i"),substitution:{input:t=>l(t),output:t=>p(t)}},{alias:"C",description:"minutes longitude",searchPattern:new RegExp("\\d{1,2}(?=.*?[E|W])","i"),substitution:{input:t=>l(t),output:t=>p(t)}},{alias:"D",description:"seconds longitude",searchPattern:new RegExp(`\\d{1,2}[\\.|\\${a}]?\\d*(?=.*?[E|W])`,"i"),substitution:{input:t=>l(t),output:t=>p(t)}},{alias:"E",description:"east/west indicator",searchPattern:e}],defaultPattern:`Y${r} A' B"N, X${r} C' D"E`,viewModel:null}),new n({name:"xy",coordinateSegments:[{alias:"X",description:"longitude",searchPattern:o,substitution:{input:t=>l(t),output:t=>p(t)}},{alias:"Y",description:"latitude",searchPattern:o,substitution:{input:t=>l(t),output:t=>p(t)}}],defaultPattern:`X${r}, Y${r}`,viewModel:null}),new n({name:"mgrs",coordinateSegments:[{alias:"Z",description:"grid zone",searchPattern:/\d{1,2}\w|[abyz]/i},{alias:"S",description:"grid square",searchPattern:/\w{2}/},{alias:"X",description:"easting",searchPattern:/^\d{5}(?=.?\d{5}$)|^\d{4}(?=.?\d{4}$)|^\d{3}(?=.?\d{3}$)|^\d{2}(?=.?\d{2}$)|^\d(?=.?\d$)/},{alias:"Y",description:"northing",searchPattern:/^\d{1,5}/}],defaultPattern:"Z S X Y",viewModel:null}),new n({name:"usng",coordinateSegments:[{alias:"Z",description:"grid zone",searchPattern:/\d{1,2}\w|[abyz]/i},{alias:"S",description:"grid square",searchPattern:/\w{2}/},{alias:"X",description:"easting",searchPattern:/^\d{5}(?=.?\d{5}$)|^\d{4}(?=.?\d{4}$)|^\d{3}(?=.?\d{3}$)|^\d{2}(?=.?\d{2}$)|^\d(?=.?\d$)/},{alias:"Y",description:"northing",searchPattern:/^\d{1,5}/}],defaultPattern:"Z S X Y",viewModel:null}),new n({name:"utm",coordinateSegments:[{alias:"Z",description:"zone number",searchPattern:/\d{1,2}|[abyz]/i},{alias:"B",description:"latitude band",searchPattern:/^\D/},{alias:"X",description:"easting",searchPattern:/\d{1,7}(?=\s*\d{7}$)/},{alias:"Y",description:"northing",searchPattern:/\d{1,7}/}],defaultPattern:"ZB X Y",viewModel:null})]}function p(t){const i=t.match(u),n=i?i[0]:"",a=t.includes(".")?t.split(".")[1].length:0;return n+e.format(Number(t),{pattern:"###0.###",places:a,round:-1})}function l(t){return e.parse(t)}t.degreeSymbol=r,t.generateDefaultFormats=c,t.setDefaultPatterns=d,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
