/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../core/Logger","../core/reactiveUtils","../core/accessorSupport/decorators/property","../core/has","../core/RandomLCG","../core/accessorSupport/decorators/subclass","./Widget","./Daylight/css","./Daylight/DaylightViewModel","./Daylight/VisibleElements","./Daylight/support/daylightUtils","./Daylight/support/SliderWithDropdown","../chunks/componentsUtils","./support/globalCss","./support/Heading","./support/timeWidgetUtils","./support/widgetUtils","./support/decorators/messageBundle","./support/jsxFactory"],(function(e,t,s,i,l,o,a,n,r,d,c,h,p,g,u,y,b,_,m,k,w){"use strict";const v="date";let S=class extends r{constructor(e,t){super(e,t),this.headingLevel=3,this.viewModel=new c,this.visibleElements=new h,this.dateOrSeason=v,this._timeSlider=new g({viewModel:this.viewModel.timeSliderViewModel,steps:this.timeSliderSteps,labelInputsEnabled:!1,visibleElements:{labels:!0},tickConfigs:[{mode:"position",values:[0,360,720,1080,1439],labelsVisible:!0,tickCreatedFunction:(e,t,s)=>_.onPrimaryTickCreated({tickElement:t,labelElement:s,tickClasses:C,onClick:this._makeGoToTime(e)})},{mode:"position",values:[120,240,480,600,840,960,1200,1320],tickCreatedFunction:(e,t)=>_.onSecondaryTickCreated({tickElement:t,tickClasses:C,onClick:this._makeGoToTime(e)})}]}),this._datePicker=null,this._onPlayDayClick=()=>{this.viewModel.toggleDayPlaying()},this._onDatePickerAfterCreate=e=>{this._datePicker=e},this._onDateChange=e=>{const t=e.target.valueAsDate;this.viewModel.onDateChange(Array.isArray(t)?t[0]:t)},this._onYearPlayClick=()=>{this.viewModel.toggleYearPlaying()},this._onSeasonChange=e=>{this.viewModel.currentSeason=e.target.value},this._onSunLightingCheckboxChange=()=>{this.viewModel.toggleSunLightingEnabled()},this._onShadowCheckboxChange=()=>{this.viewModel.toggleDirectShadowsEnabled()}}get icon(){return"brightness"}set icon(e){this._overrideIfSome("icon",e)}get label(){return this.messages?.title??""}set label(e){this._overrideIfSome("label",e)}get playSpeedMultiplier(){return this.viewModel.playSpeedMultiplier}set playSpeedMultiplier(e){this.viewModel.playSpeedMultiplier=e}get timeSliderSteps(){return this._timeSlider?.steps??5}set timeSliderSteps(e){this._timeSlider.steps=e}get view(){return this.viewModel.view}set view(e){this.viewModel.view=e}postInitialize(){this.viewModel.isSupported&&this.addHandles([i.watch((()=>this.viewModel.timeSliderViewModel),(e=>this._timeSlider.viewModel=e),i.syncAndInitial),i.watch((()=>this.visibleElements?.timezone),(e=>this._timeSlider.showDropDown=e),i.syncAndInitial),i.watch((()=>!this.viewModel.sunLightingEnabled),(e=>{this._timeSlider.disabled=e}),i.syncAndInitial),i.when((()=>!this.visible),(()=>{this._datePicker&&(this._datePicker.open=!1)}),i.sync)])}destroy(){this._timeSlider.destroy()}render(){const{messages:e,viewModel:t,visibleElements:s}=this,i=t.isSupported;return w.tsx("div",{class:this.classes(d.css.base,y.globalCss.widget)},i?w.tsx(w.tsxFragment,null,s.header?w.tsx(b.Heading,{level:this.headingLevel},e.title):null,this._renderTimeOptions(),s.datePicker?this._renderDateOrSeason():null,s.sunLightingToggle?this._renderSunLightingToggle():null,s.shadowsToggle?this._renderShadowsToggle():null):w.tsx("div",{class:d.css.panelError,key:"unsupported"},w.tsx("p",null,e.unsupported)))}loadDependencies(){return u.loadCalciteComponents({button:()=>new Promise(((t,s)=>e(["../chunks/calcite-button"],t,s))),checkbox:()=>new Promise(((t,s)=>e(["../chunks/calcite-checkbox"],t,s))),label:()=>new Promise(((t,s)=>e(["../chunks/calcite-label"],t,s))),"input-date-picker":()=>new Promise(((t,s)=>e(["../chunks/calcite-input-date-picker"],t,s))),option:()=>new Promise(((t,s)=>e(["../chunks/calcite-option"],t,s))),select:()=>new Promise(((t,s)=>e(["../chunks/calcite-select"],t,s)))})}_renderTimeOptions(){const{viewModel:e,visibleElements:t,messages:s}=this,{directShadowsEnabled:i,dayPlaying:l}=e,o=!e.sunLightingEnabled;return w.tsx("div",{class:this.classes(d.css.dayContainer,{[d.css.sliderShadowOn]:i,[d.css.sliderShadowOff]:!i,[d.css.sliderDateOn]:t.datePicker,[d.css.sliderDateOff]:!t.datePicker,[d.css.sliderAmPmOn]:_.useAmPm(),[d.css.containerDisabled]:o}),key:"daylight-time-options"},this._timeSlider.render(),t.playButtons?this._renderPlayPauseButton({playing:l,disabled:o,label:s.playDay,onClick:this._onPlayDayClick}):null)}_renderDateOptions(){const{viewModel:e,visibleElements:t,messages:s}=this,{yearPlaying:i}=e,l=!e.sunLightingEnabled;return w.tsx("div",{class:this.classes(d.css.dateContainer,l&&d.css.containerDisabled),key:d.css.dateContainer},w.tsx("calcite-input-date-picker",{afterCreate:this._onDatePickerAfterCreate,class:d.css.datePicker,"data-testid":"daylight-date-picker",disabled:l,key:d.css.datePicker,overlayPositioning:"fixed",placement:"bottom",valueAsDate:e.localDate,onCalciteInputDatePickerChange:this._onDateChange}),t.playButtons?this._renderPlayPauseButton({playing:i,disabled:l,label:s.playYear,onClick:this._onYearPlayClick}):null)}_renderPlayPauseButton({playing:e,disabled:t,label:s,onClick:i}){return w.tsx("calcite-button",{appearance:"solid",class:d.css.playPauseButton,disabled:t,iconStart:e?"pause-f":"play-f",label:s,onclick:i,round:!0,title:s,type:"button"})}_renderSeasonSelect(){const{messages:e,viewModel:t}=this,s=!t.sunLightingEnabled;return w.tsx("calcite-select",{class:this.classes(d.css.seasonPicker),disabled:s,label:e.season,onCalciteSelectChange:this._onSeasonChange},p.orderedSeasons.map((s=>w.tsx("calcite-option",{selected:t.currentSeason===s,value:s},e[s]))))}_renderDateOrSeason(){return"date"===this.dateOrSeason?this._renderDateOptions():this._renderSeasonSelect()}_renderSunLightingToggle(){const e=this.messages?.sunLightingToggle;return w.tsx("calcite-label",{key:"date-time-toggle",layout:"inline",scale:"s",title:e?.tooltip},w.tsx("calcite-checkbox",{checked:this.viewModel.sunLightingEnabled,class:d.css.sunLightingCheckbox,onCalciteCheckboxChange:this._onSunLightingCheckboxChange}),e?.label)}_renderShadowsToggle(){const e=this.messages.shadowsToggle;return w.tsx("calcite-label",{key:"shadow-toggle",layout:"inline",scale:"s",title:e?.tooltip},w.tsx("calcite-checkbox",{checked:this.viewModel.directShadowsEnabled,class:d.css.shadowsCheckbox,onCalciteCheckboxChange:this._onShadowCheckboxChange}),e.label)}_makeGoToTime(e){return()=>{this.viewModel.timeSliderPosition=e}}};t.__decorate([l.property(),k.messageBundle("esri/widgets/Daylight/t9n/Daylight")],S.prototype,"messages",void 0),t.__decorate([l.property(),k.messageBundle("esri/widgets/support/t9n/timezone")],S.prototype,"timezoneMessages",void 0),t.__decorate([l.property()],S.prototype,"headingLevel",void 0),t.__decorate([l.property()],S.prototype,"icon",null),t.__decorate([l.property()],S.prototype,"label",null),t.__decorate([l.property()],S.prototype,"playSpeedMultiplier",null),t.__decorate([l.property()],S.prototype,"timeSliderSteps",null),t.__decorate([l.property()],S.prototype,"view",null),t.__decorate([l.property({type:c})],S.prototype,"viewModel",void 0),t.__decorate([l.property({type:h,nonNullable:!0})],S.prototype,"visibleElements",void 0),t.__decorate([l.property({cast(e){return"season"===e||"date"===e?e:(s.getLogger(this).warn(`"${e}" is not a valid option. Acceptable values are only "date" or "season". Defaulting to "${v}".`),v)}})],S.prototype,"dateOrSeason",void 0),t.__decorate([l.property()],S.prototype,"_timeSlider",void 0),t.__decorate([l.property()],S.prototype,"_datePicker",void 0),S=t.__decorate([n.subclass("esri.widgets.Daylight")],S);const C=[y.globalCss.interactive,y.globalCss.anchor];return S}));
