/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../core/Accessor","../../core/handleUtils","../../core/Logger","../../core/maybe","../../core/reactiveUtils","../../core/scheduling","../../core/timeUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../../views/SceneView","../../views/3d/environment/SunLighting","../../views/3d/environment/VirtualLighting","../../views/3d/support/earthUtils","./support/daylightUtils","./support/SliderWithDropdownViewModel","../support/timeWidgetUtils"],(function(t,e,i,n,s,a,l,r,o,h,d,g,p,c,u,y,_,m,f){"use strict";let w=class extends e{constructor(t){super(t),this.view=null,this.timeSliderViewModel=new m.SliderWithDropdownViewModel({min:0,max:1439,values:[0],labelFormatFunction:f.formatSliderLabel,inputFormatFunction:f.formatSliderLabel}),this.lightingUpdateInterval=200,this._oldLighting=null,this.playSpeedMultiplier=1,this._lastTime=null,this._sunrise=null,this._sunset=null,this._cachedLightingDateUTC=new Date(0),this._cachedDisplayUTCOffset=0,this._firstInteraction=!0,this._lastLightingUpdate=0,this._lightingUpdateHandle=null}initialize(){this.addHandles([a.when((()=>this.view),(t=>t.when((()=>this._updateLighting()))),a.initial),a.watch((()=>{const t=this._lighting;return"sun"===t?.type?this._ensureValidDate(t):null}),(t=>this._scheduleLightingUpdate(t))),a.on((()=>this._lighting),"timezone-will-change",(t=>this._timezoneWillChange(t)),{onListenerAdd:()=>this._timezoneWillChange(null)}),a.watch((()=>!0===this.view?.stationary),(()=>{(this.dayPlaying||this.yearPlaying)&&this._updateSunriseAndSunset()}),a.initial),a.watch((()=>{const t=this.timeSliderViewModel;return{vm:t,state:t.state,sliderPosition:this.timeSliderPosition}}),(({vm:t,state:e,sliderPosition:i})=>{"ready"===e&&t.setValue(0,i)})),a.watch((()=>this.timeSliderViewModel?.utcOffset),(t=>{null!=t&&(this.utcOffset=t)})),a.watch((()=>({utcOffset:this.utcOffset,sliderViewModel:this.timeSliderViewModel})),(({utcOffset:t,sliderViewModel:e})=>{e&&(e.utcOffset=t)}),a.syncAndInitial),a.watch((()=>this.timeSliderViewModel.timezonePickerOpen),(()=>this.stopPlaying())),a.watch((()=>this.timeSliderViewModel.values),(t=>this._setTimeSliderPosition(t?.[0]??0,{forceLightingUpdate:!1})))])}destroy(){this._cancelLightingUpdate(),this.view=null}get isSupported(){return null==this.view||"3d"===this.view.type}get utcOffset(){return this._cachedDisplayUTCOffset}set utcOffset(t){t!==this.utcOffset&&null!=this._lighting&&"virtual"!==this._lighting.type&&(this._lighting.displayUTCOffset=t,this._updateLighting())}get localDate(){return r.truncateLocalTime(this._lightingDateDisplay)}set localDate(t){this.view?.ready?r.isValidDate(t)&&t.getTime()!==this.localDate.getTime()&&(this._lightingDateDisplay=r.resetUTCDate(this._lightingDateDisplay,t)):n.getLogger(this).error("The localDate property cannot be set before the view and the widget are ready.")}get timeSliderPosition(){return _.dateTimeToSliderPos(this._lightingDateDisplay)}set timeSliderPosition(t){this.view?.ready&&"ready"===this.timeSliderViewModel?.state?this._setTimeSliderPosition(t,{forceLightingUpdate:!0}):n.getLogger(this).error("The timeSliderPosition property cannot be set before the view and the widget are ready.")}_setTimeSliderPosition(t,e){Math.abs(t-this.timeSliderPosition)<=1/60||(this.stopPlaying(),this._enableDirectShadowsIfFirstInteraction(),e.forceLightingUpdate&&(this._cancelLightingUpdate(),this._updateLighting()),this._lightingDateDisplay=_.sliderPosToDateTime(this._lightingDateDisplay,t))}_timezoneFromCamera(t,e){if(null==e||!t.cameraTrackingEnabled)return 0;const i=y.positionToTimezoneInfo([e.longitude,e.latitude]);return null==i?0:Math.round(i.hours+i.minutes/60+i.seconds/3600)}get directShadowsEnabled(){return this._lighting?.directShadowsEnabled??!1}set directShadowsEnabled(t){const e=this._lighting;e&&(e.directShadowsEnabled=t)}get sunLightingEnabled(){return"sun"===this._lightingType}set sunLightingEnabled(t){const e=this._environment;if(t===this._get("sunLightingEnabled")||null==e)return;const i=e.lighting,n=this._oldLighting;this._oldLighting=i;const s={directShadowsEnabled:i.directShadowsEnabled,cameraTrackingEnabled:i.cameraTrackingEnabled},a=t?"sun":"virtual";let l;l=null!=n&&n.type===a?n:t?new c:new u,l.set(s),e.lighting=l,t||(this.stopPlaying(),this.timeSliderViewModel.timezonePickerOpen=!1)}set playingState(t){this.playingState!==t&&(this._set("playingState",t),"none"!==t&&this.sunLightingEnabled&&(this._updateSunriseAndSunset(),this._lastTime=Date.now(),this._play(),this._enableDirectShadowsIfFirstInteraction()))}get dayPlaying(){return"day"===this.playingState}set dayPlaying(t){t?this.playingState="day":this.dayPlaying&&(this.playingState="none")}get yearPlaying(){return"year"===this.playingState}set yearPlaying(t){t?this.playingState="year":this.yearPlaying&&(this.playingState="none")}get currentSeason(){return _.getSeasonFromDate(this.localDate,this._currentHemisphere)}set currentSeason(t){this.stopPlaying();const e=_.getNorthernHemisphereSeason(t,this._currentHemisphere);this.localDate=_.getSeasonDate(this.localDate,e,_.Hemisphere.NORTHERN)}get _currentHemisphere(){const t=this.view?.camera?.position?.latitude;return null==t||t>=0?_.Hemisphere.NORTHERN:_.Hemisphere.SOUTHERN}get _environment(){return this.view?.environment}get _lighting(){return this._environment?.lighting}get _lightingType(){return this._lighting?.type}get _lightingDateDisplay(){return r.offsetDate(this._cachedLightingDateUTC,this._cachedDisplayUTCOffset,"hours")}set _lightingDateDisplay(t){const e=this._lighting;if(null==e||!this.sunLightingEnabled||"virtual"===e.type||!r.isValidDate(t))return;const i=this._ensureValidDate(e),n=r.offsetDate(t,-this._cachedDisplayUTCOffset,"hours");n.getTime()!==i.getTime()&&(e.date=n,this._updateLighting())}stopPlaying(){this.playingState="none"}toggleDayPlaying(){this.dayPlaying=!this.dayPlaying}toggleYearPlaying(){this.yearPlaying=!this.yearPlaying}toggleSunLightingEnabled(){this.stopPlaying(),this.sunLightingEnabled=!this.sunLightingEnabled}toggleDirectShadowsEnabled(){this.stopPlaying(),this.directShadowsEnabled=!this.directShadowsEnabled}onDateChange(t){this.dayPlaying=!1,this.localDate=t}_enableDirectShadowsIfFirstInteraction(){this._firstInteraction&&(this._firstInteraction=!1,this.directShadowsEnabled=!0)}_updateLighting(t){const e=Date.now();this._lastLightingUpdate=e;const{view:i}=this,n=this._lighting;if(null==i||null==n||"virtual"===n.type)return;t??=this._ensureValidDate(n);const s=n.displayUTCOffset,a=null!==s?s:this._timezoneFromCamera(n,i.camera?.position);this._cachedLightingDateUTC.getTime()!==t.getTime()&&(this._cachedLightingDateUTC=new Date(t.getTime())),this._cachedDisplayUTCOffset!==a&&(this._cachedDisplayUTCOffset=a)}_timezoneWillChange(t){const e=this._lighting;if(null==e||"virtual"===e.type||!e.cameraTrackingEnabled)return;let i;if(t)i=t.timezoneOffset;else{if(null!=e.displayUTCOffset)return;i=c.calculateTimezoneOffset(e.positionTimezoneInfo)}e.displayUTCOffset=i,this._scheduleLightingUpdate()}_scheduleLightingUpdate(t){if(t&&(this._lightingUpdateHandle=s.removeMaybe(this._lightingUpdateHandle),!r.isValidDate(t)))return;if(this._lightingUpdateHandle)return;const e=Date.now()-this._lastLightingUpdate,n=this.lightingUpdateInterval-e;let a=null;const o=()=>{this._updateLighting(t),this._lightingUpdateHandle===a&&(this._lightingUpdateHandle=null)};if(n<=0)this._lightingUpdateHandle=a=l.schedule(o);else{const t=setTimeout(o,n);this._lightingUpdateHandle=a=i.makeHandle((()=>clearTimeout(t)))}}_cancelLightingUpdate(){this._lightingUpdateHandle=s.removeMaybe(this._lightingUpdateHandle)}_play(){const t=this._lighting;if(null==t||!this.sunLightingEnabled||"virtual"===t.type)return;const e=this._ensureValidDate(t);if(this.dayPlaying||this.yearPlaying){const i=Date.now()-(this._lastTime??0);if(this.dayPlaying){this._lastTime=Date.now();const n=_.calculatePlaySpeed(this._sunrise,this._sunset,e)*this.playSpeedMultiplier/100*i;if(n>0){let i=new Date(e.getTime()+n);const s=t.displayUTCOffset??0;if(((i.getUTCHours()+s)%24+24)%24<((e.getUTCHours()+s)%24+24)%24){const t=864e5;i=new Date(e.getTime()+n-t)}t.date=i}}else{if(i>1e3){this._lastTime=Date.now();const i=(e.getUTCMonth()+1)%12,n=new Date(e.getTime());n.setUTCMonth(i),t.date=n}}requestAnimationFrame((()=>this._play()))}}_updateSunriseAndSunset(){const t=this._lighting;if(null==t||"virtual"===t.type||!this.sunLightingEnabled)return;const e=this.view?.camera?.position;if(null==e)return;const{latitude:i,longitude:n}=e,{date:s,displayUTCOffset:a}=t,l=f.getSunriseAndSunsetTimes(s,i,n,a??0);l&&(this._sunrise=new Date(l.sunrise),this._sunset=new Date(l.sunset))}_ensureValidDate(t){return r.isValidDate(t.date)||(n.getLogger(this).warn("Invalid date. Reverting to the current date/time."),t.date=new Date),t.date}};t.__decorate([o.property({type:p})],w.prototype,"view",void 0),t.__decorate([o.property({type:m.SliderWithDropdownViewModel,nonNullable:!0})],w.prototype,"timeSliderViewModel",void 0),t.__decorate([o.property()],w.prototype,"isSupported",null),t.__decorate([o.property()],w.prototype,"lightingUpdateInterval",void 0),t.__decorate([o.property()],w.prototype,"utcOffset",null),t.__decorate([o.property()],w.prototype,"localDate",null),t.__decorate([o.property()],w.prototype,"timeSliderPosition",null),t.__decorate([o.property()],w.prototype,"directShadowsEnabled",null),t.__decorate([o.property()],w.prototype,"sunLightingEnabled",null),t.__decorate([o.property({type:["none","day","year"],value:"none"})],w.prototype,"playingState",null),t.__decorate([o.property()],w.prototype,"dayPlaying",null),t.__decorate([o.property()],w.prototype,"yearPlaying",null),t.__decorate([o.property()],w.prototype,"playSpeedMultiplier",void 0),t.__decorate([o.property()],w.prototype,"currentSeason",null),t.__decorate([o.property()],w.prototype,"_lastTime",void 0),t.__decorate([o.property()],w.prototype,"_sunrise",void 0),t.__decorate([o.property()],w.prototype,"_sunset",void 0),t.__decorate([o.property()],w.prototype,"_cachedLightingDateUTC",void 0),t.__decorate([o.property()],w.prototype,"_cachedDisplayUTCOffset",void 0),t.__decorate([o.property()],w.prototype,"_firstInteraction",void 0),t.__decorate([o.property()],w.prototype,"_currentHemisphere",null),t.__decorate([o.property()],w.prototype,"_environment",null),t.__decorate([o.property()],w.prototype,"_lighting",null),t.__decorate([o.property()],w.prototype,"_lightingType",null),t.__decorate([o.property()],w.prototype,"_lightingDateDisplay",null),w=t.__decorate([g.subclass("esri.widgets.Daylight.DaylightViewModel")],w);return w}));
