/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../core/reactiveUtils","../core/accessorSupport/decorators/property","../core/has","../core/Logger","../core/RandomLCG","../core/accessorSupport/decorators/subclass","./Widget","./Compass/utils","./DirectionalPad/constants","./DirectionalPad/css","./DirectionalPad/DirectionalPadViewModel","./DirectionalPad/utils","./DirectionalPad/VisibleElements","../chunks/componentsUtils","./support/globalCss","./support/widgetUtils","./support/decorators/messageBundle","./support/jsxFactory"],(function(e,t,i,o,s,n,r,a,l,d,c,u,p,h,_,v,b,m,g,w){"use strict";let y=class extends l{constructor(e,t){super(e,t),this._buttonsContainer=null,this._buttons={},this.messages=null,this.visibleElements=new _,this.viewModel=new p,this.visualScale="s",this._rotateIcon=e=>({"--rotation":`rotate(${e}deg)`}),this._afterButtonContainerCreate=e=>{this._buttonsContainer=e,this._buttonsContainer.addEventListener("contextmenu",this._onContextMenu,{capture:!0})},this._afterButtonContainerRemoved=()=>{this._buttonsContainer?.removeEventListener("contextmenu",this._onContextMenu,{capture:!0}),this._buttonsContainer=null},this._afterButtonCreate=(e,t)=>{this._buttons[e]=t},this._afterButtonRemoved=e=>{this._buttons[e]=void 0},this._onContextMenu=e=>e.preventDefault(),this._onButtonPointerDown=e=>{if(null===this._buttonsContainer)return;const t=e.target,i=t?.shadowRoot?.querySelector("button");i?.hasPointerCapture(e.pointerId)&&i.releasePointerCapture(e.pointerId);const o=h.findElementCenter(this._buttonsContainer);this.viewModel.beginFollowingPointer(e,o)},this._onKeyDown=(e,{key:t})=>{m.isActivationKey(t)&&this.viewModel.moveOnce(e)},this._onSliderInput=({target:e})=>{"number"==typeof e.value&&(this.viewModel.rotation=e.value)},this._onRotationReset=()=>{this.viewModel.rotation=0}}loadDependencies(){return v.loadCalciteComponents({action:()=>new Promise(((t,i)=>e(["../chunks/calcite-action"],t,i))),"action-group":()=>new Promise(((t,i)=>e(["../chunks/calcite-action-group"],t,i))),"action-pad":()=>new Promise(((t,i)=>e(["../chunks/calcite-action-pad"],t,i))),icon:()=>new Promise(((t,i)=>e(["../chunks/calcite-icon"],t,i))),slider:()=>new Promise(((t,i)=>e(["../chunks/calcite-slider"],t,i)))})}initialize(){this.addHandles(i.watch((()=>this.viewModel.angle),(()=>{const e=this._buttonsContainer?.contains(document.activeElement);e&&(null==this.viewModel.angle?this.container?.focus():m.setFocus(this._buttons[this.viewModel.angle]))})))}get disabled(){return this.viewModel.disabled}set disabled(e){this.viewModel.disabled=e}get icon(){return"move"}set icon(e){this._overrideIfSome("icon",e)}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}get view(){return this.viewModel.view}set view(e){this.viewModel.view=e}get speed(){return this.viewModel.speed}set speed(e){this.viewModel.speed=e}get _rotationEnabled(){return!this.view?.ready||this.view.constraints.rotationEnabled}render(){const{label:e,disabled:t,viewModel:i}=this,o=this.classes(u.css.base,b.globalCss.widget,t?b.globalCss.disabled:null);return w.tsx("div",{"aria-label":e,class:o,tabIndex:-1},i.supported?this._renderContent():this._renderUnsupportedMessage())}_renderUnsupportedMessage(){return w.tsx("section",{class:u.css.error,key:"unsupported"},w.tsx("p",null,this.messages.unsupported))}_renderContent(){return[this.visibleElements.directionalButtons?this._renderDirectionalButtons():void 0,this.visibleElements.rotationSlider?this._renderRotation():void 0]}_renderDirectionalButtons(){return w.tsx("calcite-action-pad",{expandDisabled:!0,key:"directional-buttons-container",layout:"grid"},w.tsx("calcite-action-group",{afterCreate:this._afterButtonContainerCreate,afterRemoved:this._afterButtonContainerRemoved,class:u.css.buttonsContainer,dir:"ltr"},c.directionalPadAngles.slice(0,4).map((e=>this._renderButton(e))),this._renderCompass(),c.directionalPadAngles.slice(4).map((e=>this._renderButton(e)))))}_renderButton(e){const{label:t,iconName:i}=c.directionalPadArrows[e],o=this.messages[t];return w.tsx("calcite-action",{active:this.viewModel.angle===e,afterCreate:t=>this._afterButtonCreate(e,t),afterRemoved:()=>this._afterButtonRemoved(e),alignment:"center",class:u.css.button,"data-angle":e.toString(),disabled:this.disabled,key:e,onkeydown:this._onKeyDown.bind(void 0,e),onpointerdown:this._onButtonPointerDown,scale:this.visualScale,text:o,title:o},w.tsx("calcite-icon",{icon:i,scale:this.visualScale}))}_renderCompass(){const e=this.disabled||d.canShowNorth(this.view)?"compass-needle":"arrow-up",t=0===this.viewModel.rotation,i=this.messages.resetHeading;return w.tsx("calcite-action",{alignment:"center",class:u.css.compassButton,disabled:this.disabled||!this._rotationEnabled||t,key:"compass",onclick:this._onRotationReset,scale:this.visualScale,styles:this._rotateIcon(this.viewModel.rotation),text:i,title:i},!t&&w.tsx("calcite-icon",{icon:e,scale:this.visualScale}))}_renderRotation(){return w.tsx("calcite-action-pad",{expandDisabled:!0,key:"slider-container",layout:"horizontal"},w.tsx("calcite-action-group",{class:u.css.rotationContainer},this.visibleElements.rotationResetButton?this._renderRotationResetButton():null,this._renderRotationSlider()))}_renderRotationResetButton(){const e=this.messages.resetHeading;return w.tsx("calcite-action",{alignment:"center",class:u.css.rotationReset,disabled:this.disabled||!this._rotationEnabled,onclick:this._onRotationReset,scale:this.visualScale,text:e,title:e},w.tsx("calcite-icon",{flipRtl:!0,icon:"rotate",scale:this.visualScale}))}_renderRotationSlider(){return w.tsx("div",{class:u.css.rotationSliderContainer},w.tsx("calcite-slider",{"aria-label":this.messages.heading,disabled:this.disabled||!this._rotationEnabled,labelHandles:!0,max:360,min:0,required:!0,scale:this.visualScale,value:Math.round(this.viewModel.rotation),onCalciteSliderInput:this._onSliderInput}))}};t.__decorate([o.property()],y.prototype,"_buttonsContainer",void 0),t.__decorate([o.property()],y.prototype,"_buttons",void 0),t.__decorate([o.property()],y.prototype,"disabled",null),t.__decorate([o.property()],y.prototype,"icon",null),t.__decorate([o.property()],y.prototype,"label",null),t.__decorate([o.property(),g.messageBundle("esri/widgets/DirectionalPad/t9n/DirectionalPad")],y.prototype,"messages",void 0),t.__decorate([o.property({type:_,nonNullable:!0})],y.prototype,"visibleElements",void 0),t.__decorate([o.property()],y.prototype,"view",null),t.__decorate([o.property()],y.prototype,"viewModel",void 0),t.__decorate([o.property()],y.prototype,"visualScale",void 0),t.__decorate([o.property()],y.prototype,"speed",null),t.__decorate([o.property({readOnly:!0})],y.prototype,"_rotationEnabled",null),y=t.__decorate([a.subclass("esri.widgets.DirectionalPad")],y);return y}));
