/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../core/Collection","../../core/Error","../../core/Evented","../../core/promiseUtils","../../core/reactiveUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/Logger","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../../intl/date","../../intl/locale","../../rest/networkService","../../rest/support/RouteParameters","../../rest/support/Stop","../../rest/support/TravelMode","../../time/timeZoneUtils","./support/directionsUtils","../support/dateUtils","../support/GoTo","../../chunks/datetime"],(function(e,t,r,i,o,s,a,l,n,u,d,c,p,h,m,v,y,_,T,f,g,w){"use strict";function D(e){return"esri.Graphic"===e?.declaredClass}function C(e){return"esri.rest.support.Stop"===e?.declaredClass}var S;!function(e){e[e.Active=0]="Active",e[e.Complete=1]="Complete",e[e.Failed=2]="Failed",e[e.Idle=3]="Idle",e[e.Suspended=4]="Suspended"}(S||(S={}));let b=class extends(g.GoToMixin(i.EventedAccessor)){constructor(e){super(e),this._highlight=null,this._loadPromise=null,this._loadController=null,this._routeController=null,this._serviceDescriptionStatus=S.Idle,this.apiKey=void 0,this.defaultTravelMode=null,this.departureIsoDate=null,this.departureIsoTime=null,this.departureOption=T.DepartureTimeOption.NOW,this.departureTime="now",this.lastError=null,this.lastRoute=null,this.layer=null,this.maxStops=50,this.routeParameters=new m({directionsLengthUnits:"kilometers",findBestSequence:!1,returnZ:!0,startTime:null,startTimeIsUTC:!0,useTimeWindows:!1}),this.serviceDescription=null,this.view=null}initialize(){this.addHandles([s.on((()=>this.layer?.stops),"change",(()=>{this.clearResults()})),s.watch((()=>this.layer),(e=>{if(null!=e){for(;e.stops.length<2;)e.stops.add(new v);this._set("defaultTravelMode",null),this.addHandles(s.when((()=>null!=this.serviceDescription?e.routeInfo?.analysisSettings?.travelMode:null),(e=>{this.defaultTravelMode=this._resolveDefaultTravelMode(e)}),{once:!0}))}}),s.syncAndInitial)]);const e=c.resolveTimeZone(this.view?.timeZone??_.system),t=w.DateTime.fromMillis(Date.now());this.departureIsoDate=t.toFormat(f.defaultDatePattern,f.getDefaultLocaleOptions(e)),this.departureIsoTime=t.toFormat(f.defaultTimePattern,f.getDefaultLocaleOptions(e))}get _directionsLanguage(){if(null==this.serviceDescription)return;const e=this.serviceDescription.directionsSupportedLanguages;if(!e)return;const t=(this.routeParameters.directionsLanguage??p.getLocale()).slice(0,2);return e.find((e=>e.toLowerCase().slice(0,2)===t))}get formattedEta(){const e=this.layer?.routeInfo?.endTime,t=this.layer?.routeInfo?.endTimeOffset;if(this.departureOption===T.DepartureTimeOption.UNSPECIFIED||!e||!t)return null;const r=w.DateTime.fromJSDate(e,{zone:w.FixedOffsetZone.instance(t)}),i=w.DateTime.fromJSDate(e,{zone:w.IANAZone.create(c.resolveTimeZone(this.view?.timeZone??_.system))}),o=w.DateTime.fromJSDate(new Date,{zone:w.IANAZone.create(c.resolveTimeZone(this.view?.timeZone??_.system))}),s=o.year===i.year&&o.month===i.month&&o.day===i.day,a=i.offset===t?void 0:_.shortTimeZoneName,l=s?void 0:c.convertDateFormatToIntlOptions("short-date"),n=c.convertDateFormatToIntlOptions("short-time");return c.formatTimestamp(r.toISO(),{...l,...n,timeZoneName:a})}get impedanceAttribute(){const e=this.routeParameters.travelMode?.impedanceAttributeName??this.routeParameters.impedanceAttribute??this.serviceDescription?.impedance??null;return this.getCostAttribute(e)}get selectedTravelMode(){return null==this.serviceDescription?null:this.defaultTravelMode??this.serviceDescription.defaultTravelMode??this.serviceDescription.supportedTravelModes?.[0]??null}set selectedTravelMode(e){this._override("selectedTravelMode",e)}get state(){if(null!=this._routeController)return"routing";if(null!=this.lastError)return"error";switch(this._serviceDescriptionStatus){case S.Suspended:return"unauthenticated";case S.Idle:return"disabled";case S.Active:return"initializing";case S.Failed:return"error";default:return"ready"}}get timeAttribute(){const e=this.routeParameters.travelMode?.timeAttributeName??this.routeParameters.directionsTimeAttribute??this.serviceDescription?.directionsTimeAttribute??null;return this.getCostAttribute(e)}get travelModes(){const e=this.serviceDescription?.supportedTravelModes?.slice()??[];return null==this.defaultTravelMode||e.includes(this.defaultTravelMode)||e.unshift(this.defaultTravelMode),e}async load(){if(null!=this._loadPromise)return this._loadPromise;this._loadPromise=this._load(),await this._loadPromise,this._loadPromise=null}async highlight(e){if(this.clearHighlights(),!this.view||!this.layer)return;const t=await this.view.whenLayerView(this.layer);this._highlight=t.highlight(e)}clearHighlights(){null!=this._highlight&&(this._highlight.remove(),this._highlight=null)}centerAt(e){if(null==this.view)return;const t=C(e)||D(e)?e.geometry:e;null!=t&&this.callGoTo({target:t})}clearResults(){this._set("lastRoute",null),this.layer?.removeResult()}async getDirections(){const{apiKey:e,layer:t,state:i}=this;if(null==t)throw new r("directions-view-model:missing-route-layer","A route layer must be associated with the view model.");if("unauthenticated"===i||"initializing"===i||"disabled"===i||this._serviceDescriptionStatus===S.Failed)throw new r("directions-view-model:not-loaded","Cannot get directions until view model loads.");this._set("lastError",null),null!=this._routeController&&(this._routeController.abort(),this._routeController=null);const{startTime:s,startTimeIsUTC:a}=this._getStartTimeParameters(),l=this.view?.spatialReference??null,n=this.routeParameters.clone();n.set({startTime:s,startTimeIsUTC:a,directionsLanguage:this._directionsLanguage,apiKey:e,outSpatialReference:l}),null!=this.selectedTravelMode&&(n.travelMode=this.selectedTravelMode);if(t.stops.filter((({geometry:e})=>null!=e)).length<2){const e=new r("directions-view-model:not-enough-stops","Not enough stops for routing");throw this._set("lastError",e),e}this._routeController=new AbortController;const{signal:u}=this._routeController;let d=null;try{d=await t.solve(n,{signal:u})}catch(c){if(!o.isAbortError(c)){const e=new r("directions-view-model:unable-to-route","Unable to route to these addresses",{error:c});throw this._set("lastError",e),this._set("lastRoute",null),e}}finally{this._routeController=null}for(const r of d.stops)null==r.geometry&&(r.name=null);return t.update(d),this._set("lastRoute",d),this.zoomToRoute(),d}getCostAttribute(e){return(this.serviceDescription?.networkDataset?.networkAttributes??[]).find((({name:t,usageType:r})=>t===e&&"cost"===r))??null}reset(){this.clearHighlights(),this.clearResults(),null!=this.layer&&(this.layer.removeAll(),this.layer.stops=new t([new v,new v]))}save(){if(!this.layer)throw new r("directions-view-model:missing-layer","save() requires a layer");return this.layer.save()}saveAs(e,t={}){if(!this.layer)throw new r("directions-view-model:missing-layer","saveAs() requires a layer");return this.layer.saveAs(e,t)}updateDepartureTime(){if(this.departureIsoDate&&this.departureIsoTime)switch(this.departureOption){case T.DepartureTimeOption.NOW:this.departureTime="now";break;case T.DepartureTimeOption.DEPART_AT:{const e=w.DateTime.fromISO(`${this.departureIsoDate}T${this.departureIsoTime}`,{zone:w.FixedOffsetZone.instance(0)});this.departureTime=e.toJSDate();break}case T.DepartureTimeOption.UNSPECIFIED:this.departureTime=null}}zoomToRoute(){const{view:e,layer:t}=this;if(null==e||null==t?.routeInfo)return;const{geometry:r}=t.routeInfo;if(null==r)return;const i=r.extent;if(!i)return;const o=i.width>i.height,s=i.clone().expand(o?2:1);this.callGoTo({target:s})}_getStartTimeParameters(){if("now"===this.departureTime){return{startTime:this.serviceDescription?.capabilities.supportsNow??!1?"now":new Date,startTimeIsUTC:!0}}return null==this.departureTime?{startTime:void 0,startTimeIsUTC:void 0}:{startTime:this.departureTime,startTimeIsUTC:!1}}async _load(){if(null==this.layer)return;null!=this._loadController&&(this._loadController.abort(),this._loadController=null),this._loadController=new AbortController;const{signal:e}=this._loadController;try{this._serviceDescriptionStatus=S.Active;const t=await h.fetchServiceDescription(this.layer.url,this.apiKey,{signal:e});this._set("serviceDescription",t),this._serviceDescriptionStatus=S.Complete}catch(t){if(o.isAbortError(t))return void(this._serviceDescriptionStatus=S.Idle);if("identity-manager:user-aborted"===t.name)return void(this._serviceDescriptionStatus=S.Suspended);const e=new r("directions-view-model:service-metadata-unavailable","Cannot load route service metadata",{error:t});throw this._serviceDescriptionStatus=S.Failed,this._set("lastError",e),e}finally{this._loadController=null}}_resolveDefaultTravelMode(e){if(null==this.serviceDescription)return null;const{defaultTravelMode:t,supportedTravelModes:r}=this.serviceDescription,i=/^<(?<name>.*)>$/i.exec(e.name)?.groups?.name;if(i){const o=r?.find((({name:e})=>e.toLocaleLowerCase()===i.trim().toLocaleLowerCase())),s=o??t;return y.fromJSON({...s?.toJSON(),...e.toJSON()})}const o=r?.find((({name:t})=>t.toLocaleLowerCase()===e.name.toLocaleLowerCase()));return o??t}};e.__decorate([a.property()],b.prototype,"_directionsLanguage",null),e.__decorate([a.property()],b.prototype,"_routeController",void 0),e.__decorate([a.property()],b.prototype,"_serviceDescriptionStatus",void 0),e.__decorate([a.property()],b.prototype,"apiKey",void 0),e.__decorate([a.property()],b.prototype,"defaultTravelMode",void 0),e.__decorate([a.property()],b.prototype,"departureTime",void 0),e.__decorate([a.property()],b.prototype,"formattedEta",null),e.__decorate([a.property({readOnly:!0})],b.prototype,"impedanceAttribute",null),e.__decorate([a.property()],b.prototype,"lastError",void 0),e.__decorate([a.property({readOnly:!0})],b.prototype,"lastRoute",void 0),e.__decorate([a.property()],b.prototype,"layer",void 0),e.__decorate([a.property({type:Number,range:{min:2,max:50},nonNullable:!0})],b.prototype,"maxStops",void 0),e.__decorate([a.property({type:m,nonNullable:!0})],b.prototype,"routeParameters",void 0),e.__decorate([a.property()],b.prototype,"selectedTravelMode",null),e.__decorate([a.property({readOnly:!0})],b.prototype,"serviceDescription",void 0),e.__decorate([a.property({readOnly:!0})],b.prototype,"state",null),e.__decorate([a.property({readOnly:!0})],b.prototype,"timeAttribute",null),e.__decorate([a.property()],b.prototype,"travelModes",null),e.__decorate([a.property()],b.prototype,"view",void 0),e.__decorate([a.property()],b.prototype,"getDirections",null),e.__decorate([a.property()],b.prototype,"zoomToRoute",null),b=e.__decorate([d.subclass("esri.widgets.Directions.DirectionsViewModel")],b);return b}));
