/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","exports","../../../chunks/tslib.es6","../../../core/promiseUtils","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/Logger","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../../portal/Portal","../../Widget","../../../chunks/componentsUtils","../../support/widgetUtils","../../support/decorators/messageBundle","../../support/jsxFactory"],(function(e,s,t,r,a,o,i,l,n,c,h,d,m,p,u){"use strict";const g="esri-save-layer",_={panel:`${g}`,error:`${g}__error`,errorIcon:`${g}__error-icon`,errorLabel:`${g}__error-label`,layerNameLabel:`${g}__layer-name-label`,portalFolderLabel:`${g}__portal-folder-label`,processLabel:`${g}__process-label`,processLoader:`${g}__process-loader`};s.SaveLayer=class extends h{constructor(e,s){super(e,s),this._folders=null,this._layer=null,this._layerNameInput=null,this._portalFolderCombobox=null,this._userName=null,this.messages=null,this.messagesCommon=null,this.messagesIdentity=null,this.opened=!1,this.state="initialized",this.close=()=>{this.opened=!1,this.state="initialized"}}loadDependencies(){return d.loadCalciteComponents({button:()=>new Promise(((s,t)=>e(["../../../chunks/calcite-button"],s,t))),combobox:()=>new Promise(((s,t)=>e(["../../../chunks/calcite-combobox"],s,t))),"combobox-item":()=>new Promise(((s,t)=>e(["../../../chunks/calcite-combobox-item"],s,t))),icon:()=>new Promise(((s,t)=>e(["../../../chunks/calcite-icon"],s,t))),input:()=>new Promise(((s,t)=>e(["../../../chunks/calcite-input"],s,t))),label:()=>new Promise(((s,t)=>e(["../../../chunks/calcite-label"],s,t))),loader:()=>new Promise(((s,t)=>e(["../../../chunks/calcite-loader"],s,t))),panel:()=>new Promise(((s,t)=>e(["../../../chunks/calcite-panel"],s,t)))})}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}async open(e){this.state="initialized",this.opened=!0,this._layer=e,this.state="connect-to-portal";const s=c.getDefault();try{await s.signIn()}catch(a){return void(r.isAbortError(a)||"identity-manager:user-aborted"===a.name?this.close():this.state="connect-to-portal-error")}this.state="fetch-portal-information";const{user:t}=s;this._userName=t?.username;try{this._folders=await(t?.fetchFolders())}catch{return void(this.state="fetch-portal-information-error")}this.state="save-layer"}render(){switch(this.state){case"initialized":return this._renderInitialized();case"connect-to-portal":return this._renderProcess(this.messagesIdentity.lblSigning);case"connect-to-portal-error":return this._renderError(this.messages.errors.authenticating);case"fetch-portal-information":return this._renderProcess(this.messages.processing.fetching);case"fetch-portal-information-error":return this._renderError(this.messages.errors.fetching);case"save-layer":return this._renderSaveLayer();case"saving":return this._renderProcess(this.messages.processing.saving);case"saving-error":return this._renderError(this.messages.errors.saving)}}_renderError(e){return u.tsx("calcite-panel",{class:_.panel,heading:this.messages.widgetLabel,key:`${g}-error-panel`},u.tsx("div",{class:_.error},u.tsx("calcite-icon",{class:_.errorIcon,icon:"exclamation-mark-triangle",scale:"l",textLabel:this.messagesCommon.errorMessage}),u.tsx("calcite-label",{class:_.errorLabel},e)),u.tsx("calcite-button",{appearance:"outline",onclick:this.close,slot:"footer-actions",width:"half"},this.messagesCommon.close))}_renderInitialized(){return u.tsx("calcite-panel",{class:_.panel,heading:this.messages.widgetLabel,key:`${g}-initialize-panel`})}_renderProcess(e){return u.tsx("calcite-panel",{class:_.panel,heading:this.messages.widgetLabel,key:`${g}-process-panel`},u.tsx("calcite-loader",{class:_.processLoader,label:e}),u.tsx("calcite-label",{alignment:"center",class:_.processLabel},e))}_renderSaveLayer(){if(null==this._layer||null==this._folders||null==this._userName)return this._renderInitialized();const{stops:e}=this._layer,s=`${e.at(0).name} - ${e.at(-1).name}`,t=this._folders.map((e=>u.tsx("calcite-combobox-item",{key:`${g}-folder-${e.id}`,textLabel:e.title??"",value:e.id})));return t.unshift(u.tsx("calcite-combobox-item",{key:`${g}-folder-home`,selected:!0,textLabel:`${this._userName} (${this.messagesCommon.home})`,value:null})),u.tsx("calcite-panel",{class:_.panel,heading:this.messages.widgetLabel,key:`${g}-save-panel`},u.tsx("calcite-label",{class:_.layerNameLabel},this.messages.laverName,u.tsx("calcite-input",{afterCreate:e=>{this._layerNameInput=e},label:this.messages.laverName,value:s})),u.tsx("calcite-label",{class:_.portalFolderLabel},this.messages.saveInFolder,u.tsx("calcite-combobox",{afterCreate:e=>{this._portalFolderCombobox=e},label:this.messages.saveInFolder,overlayPositioning:"fixed",selectionMode:"single"},t)),u.tsx("calcite-button",{onclick:()=>this._saveButtonClick(),slot:"footer-actions",width:"half"},this.messagesCommon.save),u.tsx("calcite-button",{appearance:"outline",onclick:()=>{this.close()},slot:"footer-actions",width:"half"},this.messagesCommon.cancel))}_saveButtonClick(){this.state="saving",this._saveLayer().then((()=>{this.close()})).catch((()=>{this.state="saving-error"}))}async _saveLayer(){if(null==this._layer||null==this._folders)return;const e=this._layerNameInput?.value,s=this._portalFolderCombobox?.value,t=this._folders.find((e=>e.id===s));await this._layer.saveAs({title:e},{folder:t})}},t.__decorate([a.property()],s.SaveLayer.prototype,"label",null),t.__decorate([a.property(),p.messageBundle("esri/widgets/support/t9n/SaveLayer")],s.SaveLayer.prototype,"messages",void 0),t.__decorate([a.property(),p.messageBundle("esri/t9n/common")],s.SaveLayer.prototype,"messagesCommon",void 0),t.__decorate([a.property(),p.messageBundle("esri/identity/t9n/identity")],s.SaveLayer.prototype,"messagesIdentity",void 0),t.__decorate([a.property()],s.SaveLayer.prototype,"opened",void 0),t.__decorate([a.property()],s.SaveLayer.prototype,"state",void 0),s.SaveLayer=t.__decorate([n.subclass("esri.widgets.Directions.components.SaveLayer")],s.SaveLayer),Object.defineProperty(s,Symbol.toStringTag,{value:"Module"})}));
