/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../chunks/tslib.es6","../../geometry","../../Graphic","../../intl","../../symbols","../../core/colorUtils","../../core/handleUtils","../../core/maybe","../../core/reactiveUtils","../../core/unitFormatUtils","../../core/unitUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/Logger","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../../core/support/UpdatingHandles","../../geometry/geometryEngine","../../geometry/projection","../../geometry/support/geodesicUtils","../../layers/GraphicsLayer","../../views/ViewingMode","../../views/2d/interactive/SnappingVisualizer2D","../../views/draw/Draw","../../views/interactive/coordinateHelper","../../views/interactive/dragEventPipeline","../../views/interactive/GraphicManipulator","../../views/interactive/InteractiveToolBase","../../views/interactive/editGeometry/EditGeometry","../../views/interactive/editGeometry/EditGeometryOperations","../../views/interactive/snapping/SnappingContext","../../views/interactive/snapping/SnappingDragPipelineStep","../../views/interactive/snapping/SnappingManagerPool","../../views/interactive/snapping/snappingUtils","../../intl/messages","../../intl/locale","../../geometry/Point","../../symbols/CIMSymbol","../../symbols/TextSymbol","../../symbols/Font","../../symbols/SimpleMarkerSymbol","../../geometry/Polyline","../../geometry/SpatialReference"],(function(e,t,i,s,r,n,a,o,l,p,c,h,m,d,u,g,y,v,_,w,f,M,L,b,S,D,T,C,x,G,A,E,R,O,P,H,k,U,I,j,z,B,V,W){"use strict";const F=1e5;function q(e,t,i){const r=a.multiplyOpacity(t.effectiveTheme.accentColor,.5),n={type:"simple-line",width:0},o=8,l=new B({style:"circle",color:r,size:o,outline:n}),p=new B({style:"circle",color:r,size:1.5*o,outline:n}),c=new s({geometry:e,symbol:l});return new C.GraphicManipulator({view:t,layer:i,graphic:c,focusedSymbol:p})}function N(e,t,i){const s=new V({paths:[e],spatialReference:t});let r,n;if(t.isGeographic)if(f.isSupported(t))r=f.geodesicLengths([s],"meters")[0],n=f.geodesicDensify(s,F);else{const e=w.project(s,W.WGS84),i=f.geodesicDensify(e,F);r=f.geodesicLengths([e],"meters")[0],n=w.project(i,t)}else if(t.isWebMercator)r=_.geodesicLength(s,"meters"),n=_.geodesicDensify(s,F,"meters");else{const e=_.planarLength(s,"meters");if(null!=i&&e>=i){const e=w.project(s,W.WGS84),i=f.geodesicDensify(e,F);r=f.geodesicLengths([e],"meters")[0],n=w.project(i,t)}else r=e,n=s}return{measurement:{geometry:n,length:r},original:s,drawing:n}}function J(e){return null!=e}function K(e){if(!e)return!1;const{isGeographic:t,isWebMercator:i,isWGS84:s}=e;return t&&!s&&!f.isSupported(e)||!t&&!i}function Q(e,t,i){if(!t||!e)return"";switch(i){case"metric":return c.formatMetricLength(e,t.length,"meters");case"imperial":return c.formatImperialLength(e,t.length,"meters");default:return c.formatDecimal(e,h.convertUnit(t.length,"meters",i),i)}}e.DistanceMeasurement2DTool=class extends x.InteractiveToolBase{constructor(e){super(e),this._drawActive=!1,this._measurementLayer=new M({internal:!0,listMode:"hide",visible:!1}),this._manipulatorLayer=new M({internal:!0,listMode:"hide",visible:!1}),this._snappingLayer=new M({internal:!0,listMode:"hide",visible:!1}),this._updatingHandles=new v.UpdatingHandles,this._vertices=[],this.geodesicDistanceThreshold=null,this.measurement=null,this.measurementLabel=null}initialize(){H.fetchMessageBundle("esri/core/t9n/Units").then((e=>{this.messages=e}));const e=this.view;this._draw=new S({view:e}),e.map.addMany([this._measurementLayer,this._manipulatorLayer,this._snappingLayer]),e.focus(),this._snappingManagerResult=O.acquire(e),this.addHandles([k.onLocaleChange((async()=>{this.messages=await H.fetchMessageBundle("esri/core/t9n/Units")})),p.watch((()=>[this.unit,this.geodesicDistanceThreshold,this.messages]),(()=>{this._updatePolylines()}),p.initial),p.watch((()=>[this.view.effectiveTheme.accentColor,this.view.effectiveTheme.textColor]),(()=>{if(!this._vertices.length)return;const e=this._vertices.map((({coord:e})=>e));for(const{handle:t}of this._vertices)t.remove();this._vertices=[],this._measurementLayer.removeAll(),this._manipulatorLayer.removeAll(),this._snappingLayer.removeAll(),this.manipulators.removeAll(),this._updateSketch(e)})),p.watch((()=>this.snappingOptions.featureSources),(e=>{for(const t of e)t.layer!==this._measurementLayer&&t.layer!==this._manipulatorLayer||(t.enabled=!1)}),p.initial),this._snappingManagerResult]),P.setupSnappingToggleHandles(this)}destroy(){const{map:e}=this.view;this._draw.view=null,this._draw=l.destroyMaybe(this._draw),e.removeMany([this._measurementLayer,this._manipulatorLayer,this._snappingLayer]),this._measurementLayer.removeAll(),this._manipulatorLayer.removeAll(),this._snappingLayer.removeAll(),this._set("measurement",null),this._set("measurementLabel",null),this._measurementLayer=l.destroyMaybe(this._measurementLayer),this._manipulatorLayer=l.destroyMaybe(this._manipulatorLayer),this._snappingLayer=l.destroyMaybe(this._snappingLayer),this._updatingHandles=l.destroyMaybe(this._updatingHandles),this._resetVertices()}get _snappingManager(){return this._snappingManagerResult.snappingManager}get cursor(){return this._drawActive?"crosshair":null}set editable(e){this._set("editable",e),e||this._draw.reset()}get snappingOptions(){return this._snappingManager.options}get updating(){return this._updatingHandles.updating||this._snappingManager.updating}onActivate(){this._drawActive||0!==this._vertices.length||this._startSketch()}onShow(){this._measurementLayer.visible=!0,this._manipulatorLayer.visible=!0,this._snappingLayer.visible=!0}onHide(){this._measurementLayer.visible=!1,this._manipulatorLayer.visible=!1,this._snappingLayer.visible=!1}_getSnappingContext(e){return new E.SnappingContext({elevationInfo:{mode:"on-the-ground",offset:0},pointer:e,editGeometryOperations:new A.EditGeometryOperations(new G.EditGeometry("point",D.createCoordinateHelper(!1,!1,this.view.spatialReference)),L.ViewingMode.Local),visualizer:new b.SnappingVisualizer2D(this._snappingLayer)})}_resetVertices(){for(const{handle:e}of this._vertices)e.remove();this._vertices=[]}_startSketch(){this._drawActive=!0;const e=this._snappingManager,t=this._draw.create("polyline",{mode:"click",snappingManager:e});t.on(["vertex-add","vertex-update","vertex-remove","cursor-update","undo","redo"],(e=>this._updateSketch(e.vertices))),t.on("draw-complete",(()=>{this._stopSketch()}))}_stopSketch(){this.manipulators.forEach((({manipulator:e})=>{e.interactive=!0})),this._drawActive=!1,this.finishToolCreation()}_updateSketch(e){const{spatialReference:t}=this.view;for(;this._vertices.length>e.length;){const{handle:e,manipulator:t}=this._vertices.pop();e.remove(),this.manipulators.remove(t)}for(let l=this._vertices.length;l<e.length;l++){const[i,s]=e[l],r=new U({x:i,y:s,spatialReference:t}),n=q(r,this.view,this._manipulatorLayer);this.manipulators.add(n);const a=A.EditGeometryOperations.fromGeometry(r,L.ViewingMode.Local),p=[a.on("vertex-update",(e=>{const t=e.vertices.at(0);t&&(this._vertices[l].coord=[t.pos[0],t.pos[1]],this._updatePolylines())})),T.createManipulatorDragEventPipeline(n,((e,t,i,s)=>{const r=this._getSnappingContext(s),n=this._snappingManager,o=this._updatingHandles,{snappingStep:l}=R.createSnapDragEventPipelineStep({snappingContext:r,snappingManager:n,updatingHandles:o});t.next(T.screenToMap(this.view)).next((t=>{if("start"===t.action){const i=new U(t.mapStart);e.graphic.geometry=i,a.trySetGeometry(i)}return t})).next(...l).next(T.dragManipulatedObject({operations:a})).next((()=>{e.graphic.geometry=a.data.geometry}))}))];this._vertices.push({manipulator:n,coord:[i,s],handle:o.handlesGroup(p)})}const i=this._vertices.length-1,s=this._vertices[i],[r,n]=e[i];s.coord[0]===r&&s.coord[1]===n||(s.coord=[r,n],s.manipulator.graphic.geometry=new U({x:r,y:n,spatialReference:t}));const a=this._drawActive?this._vertices[i].manipulator:null;this.manipulators.forEach((({manipulator:e})=>{e.interactive=null==a||e!==a})),this._updatePolylines()}_updatePolylines(){if(this._vertices.length<2)return void this._measurementLayer.removeAll();const e=this._vertices.map((({coord:e})=>e)),{measurement:t,drawing:i,original:r}=N(e,this.view.spatialReference,this.geodesicDistanceThreshold);this._set("measurement",t);const n=Q(this.messages,t,this.unit);let o,l;this._set("measurementLabel",n);const{graphics:p}=this._measurementLayer,c=2===p.length,{effectiveTheme:h}=this.view;c?(o=p.at(0),l=p.at(1)):(o=new s({symbol:new I({data:{type:"CIMSymbolReference",symbol:{type:"CIMLineSymbol",symbolLayers:[{type:"CIMSolidStroke",effects:[{type:"CIMGeometricEffectDashes",dashTemplate:[14,12],lineDashEnding:"FullGap",controlPointEnding:"NoConstraint"}],enable:!0,capStyle:"Butt",joinStyle:"Round",width:3.5,color:a.getContrast(h.accentColor).toArray()},{type:"CIMSolidStroke",enable:!0,capStyle:"Butt",joinStyle:"Round",width:5,color:h.accentColor.toArray()}]}}})}),l=new s({symbol:new j({color:h.textColor,haloColor:a.multiplyOpacity(a.getContrast(h.textColor,a.BrightnessThreshold.Low),.5),haloSize:2,font:new z({size:14,family:"sans-serif"})})}),p.removeAll(),p.addMany([o,l])),o.geometry=i,l.geometry=r.extent?.center,l.symbol.text=n}},t.__decorate([m.property()],e.DistanceMeasurement2DTool.prototype,"_drawActive",void 0),t.__decorate([m.property({readOnly:!0})],e.DistanceMeasurement2DTool.prototype,"cursor",null),t.__decorate([m.property({value:!0})],e.DistanceMeasurement2DTool.prototype,"editable",null),t.__decorate([m.property({type:Number})],e.DistanceMeasurement2DTool.prototype,"geodesicDistanceThreshold",void 0),t.__decorate([m.property({readOnly:!0})],e.DistanceMeasurement2DTool.prototype,"measurement",void 0),t.__decorate([m.property({readOnly:!0})],e.DistanceMeasurement2DTool.prototype,"measurementLabel",void 0),t.__decorate([m.property()],e.DistanceMeasurement2DTool.prototype,"messages",void 0),t.__decorate([m.property()],e.DistanceMeasurement2DTool.prototype,"unit",void 0),t.__decorate([m.property()],e.DistanceMeasurement2DTool.prototype,"updating",null),t.__decorate([m.property({constructOnly:!0})],e.DistanceMeasurement2DTool.prototype,"view",void 0),e.DistanceMeasurement2DTool=t.__decorate([y.subclass("esri.widgets.DistanceMeasurement2D.DistanceMeasurement2DTool")],e.DistanceMeasurement2DTool),e.createDistanceMeasurementInfo2D=N,e.createDistanceMeasurementLabel=Q,e.isProjectionEngineRequired=K,e.isSupported=J,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
