/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../intl","../core/deprecate","../core/handleUtils","../core/Logger","../core/maybe","../core/promiseUtils","../core/reactiveUtils","../core/accessorSupport/decorators/property","../core/has","../core/RandomLCG","../core/accessorSupport/decorators/subclass","../views/interactive/sketch/SketchValueOptions","./Attachments","./FeatureForm","./FeatureTemplates","./Spinner","./Widget","./Editor/css","./Editor/EditorViewModel","./Editor/modelUploadUtils","./Editor/VisibleElements","./Editor/components/CreateFeaturesPanelContent","./Editor/components/FeatureList","./Editor/components/FooterActions","./Editor/components/Notices","./Editor/components/PanelContent","./Editor/components/PanelToolbar","./Editor/components/Prompt","./Editor/components/UpdateFeaturePanelContent","./Editor/components/UploadDetails","./FeatureTemplates/ItemList","../chunks/componentsUtils","./support/globalCss","./support/Heading","./support/widgetUtils","./support/decorators/messageBundle","./support/decorators/vmEvent","./support/jsxFactory","../intl/substitute"],(function(e,t,s,o,a,r,i,n,l,d,c,p,h,m,u,g,_,w,v,y,f,k,F,M,b,C,P,A,W,E,T,x,L,U,I,S,D,O,B,V,H){"use strict";let G=class extends v{constructor(e,t){super(e,t),this._featureForm=new g,this._attachments=new u({visibleElements:{addSubmitButton:!1,cancelAddButton:!1,cancelUpdateButton:!1,deleteButton:!1,errorMessage:!1,progressBar:!1,updateButton:!1}}),this._featureTemplates=new _({enableListScroll:!1,renderItemContentEnd:e=>e.supportsUpload?V.tsx("calcite-icon",{class:y.css.templateItemContentEnd,icon:"upload-to",key:"upload-icon"}):null,renderItemLabel:e=>e.label,renderCustomGroupContent:e=>this._renderCustomTemplateGroupContent(e)}),this._filterText="",this._prompt=null,this._spinner=new w,this._loading=!1,this.headingLevel=4,this.messages=null,this.messagesCommon=null,this.messagesTemplates=null,this.supportingWidgetDefaults=null,this.viewModel=new f,this.visibleElements=new F,this._renderAttachments=()=>this._attachments.render(),this._renderFeatureForm=()=>this._featureForm.render(),this._renderFeatureTemplates=()=>this._featureTemplates.render(),this._renderSelectIcon=()=>V.tsx("calcite-icon",{icon:"cursor",slot:"content-start"}),this.EditorPanel=({heading:e,key:t},...s)=>{const{visibleElements:o}=this;return V.tsx("calcite-flow-item",{closable:!1,heading:e,headingLevel:this.headingLevel,key:t,loading:this._loading,onCalciteFlowItemBack:this._onBack},o.settingsMenu?V.tsx(W.PanelToolbar,{editorViewModel:this.viewModel,messagesCommon:this.messagesCommon,visibleElements:o}):null,...s)},this._showDiscardEditsPrompt=()=>{const{messages:e,activeWorkflow:t}=this;return"create-features"===t?.type&&k.isModelUpload(t.data.creationInfo)?this._showPromptAndWait("success"===t.data.upload?.state?e.modelUploads.cancelPlacementPrompt:e.modelUploads.cancelUploadPrompt):this._showPromptAndWait({title:e.cancelEditTitle,message:e.cancelEditWarningMessage,yesLabel:e.discardEdits,noLabel:e.continueEditing})},this._showGenericCancelPrompt=()=>{const{messages:e,messagesCommon:t}=this;return this._showPromptAndWait({title:e.cancelRequestTitle,message:e.cancelRequestWarningMessage,yesLabel:t.form.yes,noLabel:t.form.no})},this._showPrompt=e=>{this._prompt?.cancel?.(),this._prompt=e},this._clearPrompt=()=>{this._prompt=null},this._onSave=()=>{this.viewModel.saveWorkflow()},this._onDelete=()=>{const{messages:e,messagesCommon:t}=this;this._showPrompt({title:e.deleteWarningTitle,message:e.deleteWarningMessage,context:"danger",actions:{primary:{label:t.delete,action:()=>{this.deleteFeatureFromWorkflow(),this._clearPrompt()}},secondary:{label:e.keepFeature,action:this._clearPrompt}}})},this._onToggleUpdateWorkflow=()=>this.viewModel.toggleUpdateWorkflow(),this._onBack=e=>(e?.stopPropagation(),this.viewModel.back()),this._onAttachmentAdd=()=>{const{activeWorkflow:e}=this.viewModel;e&&("create-features"===e.type||"update"===e.type&&"create-features"===e.activeWorkflow?.type?(this._attachments.addFile(),e.back()):this._attachments.addAttachment().then((()=>e.back())))},this._onAttachmentUpdate=()=>{const{activeWorkflow:e}=this.viewModel;e&&("create-features"===e.type?(this._attachments.updateFile(),e.back()):this._attachments.updateAttachment().then((()=>e.back())))},this._onAttachmentDelete=()=>{const{messages:e,messagesCommon:t}=this;this._showPrompt({title:e.deleteAttachmentWarningTitle,message:e.deleteAttachmentWarningMessage,context:"danger",actions:{primary:{label:t.delete,action:this._onAttachmentDeleteConfirm},secondary:{label:e.keepAttachment,action:this._clearPrompt}}})},this._onAttachmentDeleteConfirm=async()=>{const e=this._attachments,{activeWorkflow:t}=this.viewModel;t&&("create-features"===t.type?e.deleteFile():(await e.deleteAttachment(e.viewModel.activeAttachmentInfo),this._clearPrompt()),await t.back(),this._clearPrompt())},this._onAttachmentsError=e=>{this._showPrompt({title:this.messages.errorWarningTitle,message:e.message,context:"warning",actions:{primary:{label:this.messagesCommon.form.ok,action:this._clearPrompt}}})}}initialize(){this._featureForm.showPrompt=this._showPrompt,this._featureForm.clearPrompt=this._clearPrompt,this.addHandles([l.watch((()=>S.incrementHeadingLevel(this.headingLevel)),(e=>{this._featureForm.headingLevel=e,this._featureTemplates.headingLevel=e}),l.initial),l.on((()=>this.viewModel.activeWorkflow),"cancel-request",(({controller:e})=>{(this.viewModel.hasPendingEdits?this._showDiscardEditsPrompt():this._showGenericCancelPrompt()).then((t=>t?e.allow():e.deny()))})),l.when((()=>this.viewModel.featureFormViewModel),(e=>{this._featureForm.viewModel=e}),l.initial),l.watch((()=>this.viewModel),(e=>{this._attachments.viewModel=e?.attachmentsViewModel??null,this._featureTemplates.viewModel=e?.featureTemplatesViewModel??null,this._spinner.viewModel=e?.spinnerViewModel??null,e.showDiscardEditsPrompt=this._showDiscardEditsPrompt}),l.initial),l.watch((()=>this.view),((e,t)=>{const s=`editor-${this.id}-spinner`;t?.ui.remove(this._spinner,s),e?.ui.add(this._spinner,{key:s,position:"manual"})}),l.initial),l.watch((()=>[this.supportingWidgetDefaults,this.viewModel.sketchViewModel]),(([e])=>{e&&(this._featureForm.set(e.featureForm),this._attachments.set(e.attachments),this._featureTemplates.set(e.featureTemplates),this.viewModel.sketchViewModel?.set(e.sketch))}),l.initial),l.when((()=>this._attachments?.error),(e=>this._onAttachmentsError(e))),l.when((()=>this.viewModel?.failures),(e=>{const{messages:t}=this,[{error:s,retry:o,cancel:a}]=e;this._showPrompt({title:t.errorWarningTitle,message:H.substitute(t.errorWarningMessageTemplate,{errorMessage:s.message}),context:"warning",actions:{primary:{label:t.retry,action:()=>{o(),this._clearPrompt()}},secondary:{label:t.ignore,action:()=>{a(),this._clearPrompt()}}}})})),l.watch((()=>this.viewModel?.state),(e=>{switch(e){case"awaiting-feature-to-update":case"ready":case"disabled":this._filterText="",this._featureTemplates.filterText=""}})),l.watch((()=>this.viewModel.featureFormDisabled),(e=>this._featureForm.disabled=e)),this._connectDelayedLoading()])}destroy(){this._attachments.destroy(),this._featureForm.destroy(),this._featureTemplates.destroy()}loadDependencies(){return Promise.all([U.loadCalciteComponents({"flow-item":()=>new Promise(((t,s)=>e(["../chunks/calcite-flow-item"],t,s))),flow:()=>new Promise(((t,s)=>e(["../chunks/calcite-flow"],t,s))),icon:()=>new Promise(((t,s)=>e(["../chunks/calcite-icon"],t,s))),list:()=>new Promise(((t,s)=>e(["../chunks/calcite-list"],t,s)))}),M.loadCreateFeaturesPanelContentComponents(),b.loadFeatureListComponents(),C.loadFooterActionsComponents(),P.loadNoticesComponents(),A.loadPanelContentComponents(),W.loadPanelToolbarComponents(),E.loadPromptComponents(),T.loadUpdateFeaturePanelContentComponents(),x.loadUploadDetailsComponents()])}get _deleteButtonCommonInfo(){return{appearance:"outline",kind:"danger"}}_connectDelayedLoading(){const e=250;let t;return a.handlesGroup([l.watch((()=>{const{viewModel:e}=this;return e.syncing||e.updating||this._attachments.submitting}),(s=>{clearTimeout(t),t=void 0,s?t=setTimeout((()=>{clearTimeout(t),t=void 0,this._loading=s}),e):this._loading=s}),l.syncAndInitial),a.makeHandle((()=>clearTimeout(t)))])}get activeWorkflow(){return this.viewModel.activeWorkflow}get allowedWorkflows(){return this.viewModel.allowedWorkflows}set allowedWorkflows(e){o.deprecatedProperty(r.getLogger(this),"allowedWorkflows",{replacement:"visibleElements",version:"4.29",warnOnce:!0}),this.viewModel.allowedWorkflows=e}get hideTemplatesForInactiveLayers(){return this.viewModel.hideTemplatesForInactiveLayers}set hideTemplatesForInactiveLayers(e){this.viewModel.hideTemplatesForInactiveLayers=e}get icon(){return"pencil"}set icon(e){this._overrideIfSome("icon",e)}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}get labelOptions(){return this.viewModel.labelOptions}set labelOptions(e){this.viewModel.labelOptions=e}get layerInfos(){return this.viewModel.layerInfos}set layerInfos(e){this.viewModel.layerInfos=e}get snappingOptions(){return this.viewModel.snappingOptions}set snappingOptions(e){this.viewModel.snappingOptions=e}get tooltipOptions(){return this.viewModel.tooltipOptions}set tooltipOptions(e){this.viewModel.tooltipOptions=e}get valueOptions(){return this.viewModel.valueOptions}set valueOptions(e){this.viewModel.valueOptions=e}get view(){return this.viewModel.view}set view(e){this.viewModel.view=e}startCreateFeaturesWorkflowAtFeatureTypeSelection(){return this.viewModel.startCreateFeaturesWorkflowAtFeatureTypeSelection()}startCreateFeaturesWorkflowAtFeatureCreation(e){return this.viewModel.startCreateFeaturesWorkflowAtFeatureCreation(e)}startCreateFeaturesWorkflowAtFeatureEdit(e){return this.viewModel.startCreateFeaturesWorkflowAtFeatureEdit(e)}startUpdateWorkflowAtFeatureSelection(){return this.viewModel.startUpdateWorkflowAtFeatureSelection()}startUpdateWorkflowAtMultipleFeatureSelection(e){return this.viewModel.startUpdateWorkflowAtMultipleFeatureSelection(e)}startUpdateWorkflowAtFeatureEdit(e){return this.viewModel.startUpdateWorkflowAtFeatureEdit(e)}deleteFeatureFromWorkflow(){return this.viewModel.deleteFeatureFromWorkflow()}cancelWorkflow(e){return this.viewModel.cancelWorkflow(e)}render(){const{viewModel:e}=this,t=this.classes(y.css.base,I.globalCss.widget,I.globalCss.panel);return e?V.tsx("div",{class:t,key:"base"},V.tsx("calcite-flow",{key:"flow"},e.pageStack.map((e=>this._renderPage(e)))),this._prompt?V.tsx(E.Prompt,{...this._prompt,headingLevel:this.headingLevel}):void 0):V.tsx("div",{class:t,key:"empty"})}_renderPage(e){switch(e){case"disabled":break;case"ready":return this._renderReady();case"awaiting-feature-creation-info":return this._renderAwaitingFeatureCreationInfo();case"creating-features-upload-details":return this._renderUploadDetails();case"creating-features":return this._renderCreatingFeatures();case"editing-existing-feature":case"editing-attributes":return this._renderUpdateFeature();case"awaiting-update-feature-candidate":return this._renderFeatureList();case"adding-attachment":return this._renderAttachmentAdding();case"editing-attachment":return this._renderAttachmentEditing()}return V.tsx("div",{key:"empty-page"})}_renderAwaitingFeatureCreationInfo(){const{EditorPanel:e,messages:t}=this;return V.tsx(e,{heading:t.selectTemplate,key:"templates-panel"},V.tsx(A.PanelContent,{key:"feature-templates"},V.tsx(A.PanelContentSection,null,this._renderFeatureTemplates())))}_renderUploadDetails(){const{EditorPanel:e,activeWorkflow:t,messages:s}=this;if("create-features"!==t?.type)return null;const o=t.data.upload;return o?V.tsx(e,{heading:s.createFeatures,key:"upload-details-panel"},V.tsx(x.UploadDetails,{helpMessage:this._helpMessage,messages:s,upload:o})):null}_renderCreatingFeatures(){const{EditorPanel:e,activeWorkflow:t,messages:s,messagesCommon:o,headingLevel:a,viewModel:r}=this;if(!t)return null;const i="create-features"===t.type&&t.numPendingFeatures>0||"update"===t.type&&"create-features"===t?.activeWorkflow?.type&&t.activeWorkflow?.numPendingFeatures>0;return V.tsx(e,{heading:s.createFeatures,key:"create-features-panel"},i?V.tsx(T.UpdateFeaturePanelContent,{editorViewModel:r,headingLevel:a,messages:s,messagesCommon:o,renderAttachments:this._renderAttachments,renderFeatureForm:this._renderFeatureForm,onDelete:this._onDelete,onSave:this._onSave}):V.tsx(M.CreateFeaturesPanelContent,{helpMessage:this._helpMessage}))}_renderUpdateFeature(){const{EditorPanel:e,messages:t,messagesCommon:s,headingLevel:o,viewModel:a}=this;return V.tsx(e,{heading:t.editFeature,key:"update-feature-panel"},V.tsx(T.UpdateFeaturePanelContent,{editorViewModel:a,headingLevel:o,messages:t,messagesCommon:s,renderAttachments:this._renderAttachments,renderFeatureForm:this._renderFeatureForm,onDelete:this._onDelete,onSave:this._onSave}))}_renderCustomTemplateGroupContent(e){const{messages:t,viewModel:s}=this,o=i.mappedFind(e.group.items,(e=>s.itemHasInvalidFormTemplate(e)?t.formFieldCreateError:void 0));return o?V.tsx(P.Notice,{kind:"warning",message:o}):null}_renderAttachmentAdding(){const{EditorPanel:e,_attachments:t,messages:s,messagesCommon:o}=this;return V.tsx(e,{heading:s.addAttachment,key:"attachment-adding-panel"},V.tsx(A.PanelContent,{key:"attachments"},this._renderAttachments()),V.tsx(C.FooterActions,{buttons:[{label:t.submitting?o.cancel:o.add,disabled:t.submitting||!t.selectedFile,onClick:this._onAttachmentAdd}]}))}_renderAttachmentEditing(){const{EditorPanel:e,_attachments:t,activeWorkflow:s,messages:o,messagesCommon:a}=this;return s?V.tsx(e,{heading:o.editAttachment,key:"attachment-editing-panel"},V.tsx(A.PanelContent,{key:"attachments"},this._renderAttachments()),s.shouldAllowAttachmentEditing?V.tsx(C.FooterActions,{buttons:[{label:a.update,disabled:t.submitting||!t.selectedFile,onClick:this._onAttachmentUpdate},{...this._deleteButtonCommonInfo,onClick:this._onAttachmentDelete,disabled:t.submitting,label:a.delete}]}):void 0):null}_renderReady(){const{EditorPanel:e,messages:t,viewModel:s,visibleElements:o}=this,a=this._helpMessage;return V.tsx(e,{heading:t.widgetLabel,key:"landing-panel"},V.tsx(A.PanelContent,{key:"landing-content"},s.editorItems.length?[o.editFeaturesSection?V.tsx(A.PanelContentSection,{key:"edit-actions"},this._renderUpdateActions()):null,o.createFeaturesSection&&s.canCreateVisible?V.tsx(A.PanelContentSection,{key:"create-actions"},this._renderCreateActions()):null]:V.tsx(A.PanelContentMessage,{key:"no-content"},t.noEditableLayers)),a?V.tsx("div",{class:y.css.helpMessage,key:"footer-actions",slot:"footer"},a):void 0)}get _helpMessage(){const{activeWorkflow:e,messages:t,view:s}=this,o=e?.helpMessage;return o?t["3d"===s?.type?"helpMessages3d":"helpMessages2d"]?.[o]:void 0}_renderUpdateActions(){const{messages:e,messagesCommon:t,viewModel:s}=this,o={id:"select",label:t.select};return V.tsx("div",{class:y.css.updateActions,key:"update-actions"},V.tsx(S.Heading,{level:S.incrementHeadingLevel(this.headingLevel)},e.editFeatures),V.tsx("calcite-list",{class:y.css.updateActionsList,selectionAppearance:"border",selectionMode:"single"},L.renderItem({disabled:!s.canUpdateVisible,grouped:!1,item:o,selectedItem:"awaiting-feature-to-update"===s.activeWorkflow?.stepId?o:void 0,renderIcon:this._renderSelectIcon,onItemSelect:this._onToggleUpdateWorkflow})))}_renderCreateActions(){return V.tsx("div",{key:"create-actions"},V.tsx(S.Heading,{level:S.incrementHeadingLevel(this.headingLevel)},this.messages.createFeatures),V.tsx("div",{class:y.css.featureTemplatesContainer,key:"templates"},this._renderFeatureTemplates()))}_renderFeatureList(){const{EditorPanel:e,viewModel:t}=this,{activeWorkflow:s}=t;if("update"!==s?.type)return null;const o=s.data.candidates,a=H.substitute(this.messages.multipleFeaturesTemplate,{total:o.length});return V.tsx(e,{heading:a,key:"feature-list"},V.tsx(b.FeatureList,{editorItems:t.editorItems,filterText:this._filterText,id:this.id,messagesTemplates:this.messagesTemplates,workflow:s,onFilterTextChange:e=>this._filterText=e,onSelectFeature:(e,s)=>t.selectFeature(e,s)}))}_showPromptAndWait({title:e,message:t,yesLabel:s,noLabel:o}){const a=n.createResolver(),{view:r}=this,i=r?.focused;return this._showPrompt({title:e,message:t,context:"danger",actions:{primary:{label:s,action:()=>a.resolve(!0)},secondary:{label:o,action:()=>a.resolve(!1)}}}),a.promise.finally((()=>{this._clearPrompt(),i&&r?.focus()}))}};t.__decorate([d.property()],G.prototype,"_featureForm",void 0),t.__decorate([d.property()],G.prototype,"_attachments",void 0),t.__decorate([d.property()],G.prototype,"_featureTemplates",void 0),t.__decorate([d.property()],G.prototype,"_filterText",void 0),t.__decorate([d.property()],G.prototype,"_prompt",void 0),t.__decorate([d.property()],G.prototype,"_spinner",void 0),t.__decorate([d.property()],G.prototype,"_deleteButtonCommonInfo",null),t.__decorate([d.property()],G.prototype,"_loading",void 0),t.__decorate([d.property({readOnly:!0})],G.prototype,"activeWorkflow",null),t.__decorate([d.property()],G.prototype,"allowedWorkflows",null),t.__decorate([d.property()],G.prototype,"headingLevel",void 0),t.__decorate([d.property()],G.prototype,"hideTemplatesForInactiveLayers",null),t.__decorate([d.property()],G.prototype,"icon",null),t.__decorate([d.property()],G.prototype,"label",null),t.__decorate([d.property()],G.prototype,"labelOptions",null),t.__decorate([d.property()],G.prototype,"layerInfos",null),t.__decorate([d.property(),O.messageBundle("esri/widgets/Editor/t9n/Editor")],G.prototype,"messages",void 0),t.__decorate([d.property(),O.messageBundle("esri/t9n/common")],G.prototype,"messagesCommon",void 0),t.__decorate([d.property(),O.messageBundle("esri/widgets/FeatureTemplates/t9n/FeatureTemplates")],G.prototype,"messagesTemplates",void 0),t.__decorate([d.property()],G.prototype,"snappingOptions",null),t.__decorate([d.property()],G.prototype,"tooltipOptions",null),t.__decorate([d.property()],G.prototype,"supportingWidgetDefaults",void 0),t.__decorate([d.property({type:m,nonNullable:!0})],G.prototype,"valueOptions",null),t.__decorate([d.property()],G.prototype,"view",null),t.__decorate([d.property(),B.vmEvent(["sketch-create","sketch-delete","sketch-update","workflow-cancel","workflow-commit"])],G.prototype,"viewModel",void 0),t.__decorate([d.property({type:F,nonNullable:!0})],G.prototype,"visibleElements",void 0),t.__decorate([d.property()],G.prototype,"_helpMessage",null),G=t.__decorate([h.subclass("esri.widgets.Editor")],G);return G}));
