/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../../chunks/tslib.es6","../../Graphic","../../core/arrayUtils","../../core/Error","../../core/handleUtils","../../core/has","../../core/maybe","../../core/promiseUtils","../../core/reactiveUtils","../../core/uuid","../../core/accessorSupport/decorators/property","../../core/Logger","../../core/accessorSupport/decorators/subclass","../../layers/GraphicsLayer","../../layers/support/layerUtils","../../views/draw/support/helpMessageUtils","../../views/input/InputManager","../../views/interactive/sketch/SketchOptions","../../views/interactive/snapping/FeatureSnappingLayerSource","./CreateFeaturesWorkflowData","./modelUploadUtils","./Workflow","./workflowUtils","../FeatureForm/FeatureFormViewModel","../Sketch/SketchViewModel"],(function(e,t,a,r,i,n,s,o,l,d,c,h,u,p,f,g,w,y,m,_,v,b,M,F,k,I){"use strict";var A;const H=Symbol(),V=Symbol(),C=Symbol(),S=Symbol();let U=A=class extends M{constructor(e){super(e),this.type="create-features",this.createFeatureState="create-new",this.data=void 0,this.isNested=!1,this._getDrawMeshHelpMessage=void 0,this._featureFormHandle=null,this._visualVariableAttributes={rotation:null,size:null},this._featureFormViewModel=new k,this._sketchViewModel=null,this._attachmentFileInfos=new Map,this._highlightHandles=new Map,this._preventDefaultActionOnCancel=!1,this._lastActiveGraphics=[],this._isActive=!0,this._updateGraphicDebounced=l.debounce(((e,t,a)=>F.updateGraphicSymbolWhenRequired(e,t,a)))}initialize(){this.isNested&&(this._isActive=!1),this._initializeSketchViewModel()}destroy(){this._sketchViewModel.destroy()}get featureFormViewModel(){return this._featureFormViewModel}get hasPendingEdits(){if(this.pendingFeatures.some((e=>!!this.data.getEditsForPendingFeature(e)?.modified)))return!0;const{creationInfo:e,upload:t}=this.data,a=this._sketchViewModel,{activeComponent:r}=a,i=a.createGraphic?.geometry?.type;return!("polyline"!==i&&"polygon"!==i&&"multipoint"!==i||"draw-2d"!==r?.type&&"draw-3d"!==r?.type)&&r.drawOperation.committedVertices.length>0||(!(!t||"pending"!==t.state&&"success"!==t.state)||!!e?.geometryToPlace)}get helpMessage(){const{creationInfo:t,viewModel:a}=this.data;if("creating-features"!==this.stepId||!t)return;const r=t.layer.geometryType,i=this._sketchViewModel.createGraphic;if("mesh"===r){this._getDrawMeshHelpMessage||new Promise(((t,a)=>e(["../../views/draw/support/helpMessageUtils3d"],t,a))).then((e=>{this._getDrawMeshHelpMessage=e.getDrawMeshHelpMessage}));const{view:t}=a;return"3d"===t?.type?this._getDrawMeshHelpMessage?.(i,t):void 0}return w.getDrawHelpMessage(r,i?.geometry)}get layer(){return this.data.creationInfo?.layer}get numPendingFeatures(){return this.pendingFeatures.length}get parent(){return this.data.parent}get parentLayer(){return this.parent?.data.editorItem.layer}get pendingFeatures(){return this.data.pendingFeatures}get keyboardCancellationEnabled(){return 0===this.numPendingFeatures}get reliesOnOwnerAdminPrivileges(){return this.data.editorItem?.capabilities.create.reliesOnOwnerAdminPrivileges??!1}get shouldShowAttachments(){return this.data.editorItem?.capabilities.create.attachments.enabled??!1}get shouldAllowAttachmentEditing(){return this.shouldShowAttachments}get sketchViewModel(){return this._sketchViewModel}get test(){}async enter(){this._isActive=!0,"awaiting-feature-creation-info"!==this.stepId&&this._setUpCreatingFeaturesStep()}exit(){this._isActive=!1,this.removeHandles([C])}async updatePendingFeature(e,t){return this._preventDefaultActionOnCancel=!0,this._sketchViewModel.cancel(),r.remove(this._lastActiveGraphics,e),this._startUpdating({feature:e,webStyleCache:t})}async start(){return await super.start(),g.isTable(this.data.creationInfo?.layer)?null:{enter:async()=>{},exit:async()=>{},viewModel:this._sketchViewModel}}static create(e){const{addAttachmentsCallback:t,applyEditsCallback:a,isNested:r,creationInfo:i,parent:n,snappingManager:s,startAt:o,viewModel:l}=e,d=e.sketchOptions??new m,c=i?.layer,h=c?l.findEditorItemForLayer(c):void 0,u=new A({data:new v.CreateFeaturesWorkflowData({creationInfo:i,editorItem:h,parent:n,sketchOptions:d,snappingManager:s,viewModel:l}),isNested:r,onCommit:async e=>{const{creationInfo:r}=e;if(!r)return;const i=e.pendingFeatures.toArray(),{layer:n}=r,s=n.capabilities?.editing.supportsGlobalId&&"globalIdField"in n,o=u._attachmentFileInfos;if(s){const e=D(i,n,o);return void await a(n,e,{globalIdUsed:!0})}const l=await a(n,{addFeatures:i});if(o.size>0){const e=l?.addFeatureResults??[];await t(n,T(i,e,n,o))}}});return u._set("steps",this._createWorkflowSteps(u,o)),u}_fadeExistingFeatures(e){if("effect"in e){const t=e.effect;return e.effect="saturate(0.6) opacity(0.8)",n.makeHandle((()=>e.effect=t))}const t=e.opacity;return e.opacity=.7,n.makeHandle((()=>e.opacity=t))}_highlight(e){const t=this.data.viewModel.view;"3d"===t?.type&&this._highlightHandles.set(e,t.highlight(e))}_removeHighlight(e){o.removeMaybe(this._highlightHandles.get(e)),this._highlightHandles.delete(e)}async _startCreating(e){this.removeHandles(V);const{creationInfo:t}=this.data;if(!t)return;this.createFeatureState="create-new";const a=await F.startCreatingNewFeature(this._sketchViewModel,t,e);this.addHandles(a,V)}async _startUpdating({feature:e,webStyleCache:t,initialFeature:a=e}){const{data:r,pendingFeatures:i}=this;i.includes(e)||r.addPendingFeature(e,a);const{_featureFormViewModel:s,_sketchViewModel:l}=this,{creationInfo:c,viewModel:h}=r,{attachmentsViewModel:u,layerInfos:p,view:f}=h;if(!f||!c)return;const w=c.layer,y=F.findLayerInfo(p,w),m=y?.formTemplate,_=f.spatialReference;s.set({arcadeEditType:"INSERT",feature:e,formTemplate:m,spatialReference:_,map:f.map}),"add"!==u.mode&&"edit"!==u.mode||h.activeWorkflow?.previous(),u.graphic=e,u.fileInfos.removeAll(),u.mode="view";if((this._attachmentFileInfos.get(e)||[]).forEach((({file:e,form:t})=>u.addFile(e,t))),this._removeHighlight(e),await F.updateGraphicSymbolWhenRequired(e,t,"2d"===f.type?f.scale:null),this.removeHandles(V),o.removeMaybe(this._featureFormHandle),"2d"===f.type){const a=d.watch((()=>f.scale),(a=>this._updateGraphicDebounced(e,t,a)));this.addHandles(a,V)}const v=r.getEditsForPendingFeature(e);return this._featureFormHandle=n.handlesGroup([s.on("value-change",(async()=>{v?.updateAttributes(s.getValues()),await F.updateGraphicSymbolWhenRequired(e,t,"2d"===f.type?f.scale:null)})),l.on(["update","undo","redo"],(e=>{("undo"===e.type||"redo"===e.type||"update"===e.type&&null!=e.toolEventInfo&&F.isTerminalUpdateEventType(e.toolEventInfo.type))&&s.notifyFeatureGeometryChanged()})),d.watch((()=>s.feature?.sourceLayer),(t=>e.sourceLayer=t))]),this.createFeatureState="update-pending",this._visualVariableAttributes=F.getVisualVariableAttributes(e),g.isTable(w)?void 0:F.startUpdatingFeature({graphic:e,sketchViewModel:l,sourceLayer:w,visualVariables:this._visualVariableAttributes,webStyleCache:t})}static _createWorkflowSteps(e,t="awaiting-feature-creation-info"){const{data:a}=e,r={"awaiting-feature-creation-info":()=>({id:"awaiting-feature-creation-info",async setUp(){const{creationInfo:t,viewModel:r}=a,{view:i}=r;i&&(b.isModelUpload(t)?e.addHandles(await b.handleModelUpload({view:i,data:a,next:()=>e.next(),cancel:()=>r.cancelWorkflow({warnIfNoWorkflow:!1})}),this.id):(a.parent&&t&&(e.addHandles(r.lockFeatureTemplatesViewModel(),this.id),r.featureTemplatesViewModel.layers=[t.layer]),e.addHandles(r.featureTemplatesViewModel.on("select",(({item:t})=>{t&&(a.creationInfo={...a.creationInfo,layer:t.layer,template:t.template},e.next())})),this.id)))},async tearDown(){e.removeHandles([this.id,V])}}),"creating-features":()=>({id:"creating-features",async setUp(){e._isActive&&await e._setUpCreatingFeaturesStep()},async tearDown(t){const{viewModel:r}=a;t.canceled&&(e.removeHandles([C,H,V,S]),r.attachmentsViewModel.fileInfos.removeAll(),e._attachmentFileInfos.clear())}}),"adding-attachment":()=>({id:"adding-attachment",parent:"creating-features",async setUp(){},async tearDown(){const{attachmentsViewModel:t}=a.viewModel,{graphic:r,fileInfos:i}=t;e._attachmentFileInfos.set(r,i.toArray()),t.mode="view"}}),"editing-attachment":()=>({id:"editing-attachment",parent:"creating-features",async setUp(){},async tearDown(){const{attachmentsViewModel:t}=a.viewModel,{graphic:r,fileInfos:i}=t;e._attachmentFileInfos.set(r,i.toArray()),t.mode="view"}})},i=F.createWorkflowSteps(["awaiting-feature-creation-info","creating-features","adding-attachment","editing-attachment"],t,r);return F.avoidFeatureTemplateSelectionWithOnlyOneItem(a,i)}static _configureSketchViewModel(e,t){const{data:a}=e,{creationInfo:i,viewModel:s}=a,{view:o}=s,l=e._sketchViewModel;let c=null;const h=[];if(!o)return n.makeHandle();"2d"===o.type&&i&&h.push(e._fadeExistingFeatures(i.layer));const u=async a=>{if("cancel"===a.state){if(e._preventDefaultActionOnCancel)return void(e._preventDefaultActionOnCancel=!1);if(null==o.activeTool){if(e._lastActiveGraphics.length<1)return e._startCreating(t);const a=e._lastActiveGraphics.pop();return e._startUpdating({feature:a,webStyleCache:t})}return e._waitForActiveToolCleared().then((()=>e._startCreating(t)))}if("complete"===a.state&&a.graphic){const r=a.graphic.clone();return r.geometry=null,e._startUpdating({feature:a.graphic,webStyleCache:t,initialFeature:r})}},p=async a=>{const{attachmentsViewModel:r}=s,{_featureFormViewModel:n}=e,l=a.graphics[0];if("complete"===a.state){l!==c&&(e._lastActiveGraphics.push(l),e._highlight(l)),c=null;const{hasPendingSubtypeChoice:h,submittable:u}=n;if(e.numPendingFeatures===i?.maxFeatures||h||!u){!u&&n.submit();const a=e._lastActiveGraphics.pop();return null===s.view?.activeTool?e._startUpdating({feature:a,webStyleCache:t}):e._waitForActiveToolCleared().then((()=>e._startUpdating({feature:a,webStyleCache:t})))}if("add"!==r.mode&&"edit"!==r.mode||s.activeWorkflow?.previous(),a.aborted&&e._preventDefaultActionOnCancel)return void(e._preventDefaultActionOnCancel=!1);if(e.addHandles([F.showProgressCursor(o),o.on("click",(e=>e.preventDefault()))],H),await d.whenOnce((()=>!n.updating)),e.removeHandles(H),null!=s.view?.activeTool)return e._waitForActiveToolCleared().then((()=>{const a=e._lastActiveGraphics.pop();if(a)return e._startUpdating({feature:a,webStyleCache:t})}));e._startCreating(t)}"start"===a.state&&e._removeHighlight(l);const h=e._visualVariableAttributes;await F.visualVariableInteractiveUpdate(o,l,a,h,t);const u=l.attributes,{rotation:p,size:f}=h;if(null!=p){const{field:e}=p;n.setValue(e,u[e])}if(null!=f){const{field:e}=f;n.setValue(e,u[e])}},f=t=>{const i=t.graphics[0];a.removePendingFeature(i),r.remove(e._lastActiveGraphics,i),c=i},g=async a=>{if(b.isModelUpload(i))return;const{results:r}=await o.hitTest(a,{include:l.layer}),n=r.find((e=>"graphic"===e.type&&e.graphic.sourceLayer===i?.layer));if(!n)return;const s=n.graphic;if("transform"===l.activeTool||"reshape"===l.activeTool){if(l.updateGraphics.at(0)===s)return;const{submittable:a,hasPendingSubtypeChoice:r}=e._featureFormViewModel;if(!a||r)return;await e.updatePendingFeature(s,t)}};h.push(l.on("create",(t=>e._updatingHandles.addPromise(u(t)))),l.on("update",(t=>e._updatingHandles.addPromise(p(t)))),l.on("delete",(e=>f(e))),o.on("immediate-click",(t=>e._updatingHandles.addPromise(g(t))),y.ViewEventPriorities.TOOL),n.makeHandle((()=>{e._preventDefaultActionOnCancel=!0,l.cancel()})),O(l,a));const w=n.handlesGroup(h);return l.addHandles(w),w}_initializeSketchViewModel(){const{data:e}=this,{view:t}=e.viewModel,a=new f({elevationInfo:e.creationInfo?.layer.elevationInfo,internal:!0,listMode:"hide"}),r=new I({layer:a,sketchOptions:e.sketchOptions,snappingManager:e.snappingManager,updateOnGraphicClick:!1,view:t});this._sketchViewModel=r,t?.map.add(a),this.addHandles(n.makeHandle((()=>{t?.destroyed||t?.map.remove(a),a.destroy()})))}async _setUpCreatingFeaturesStep(){if(this.hasHandles(C))return;const{data:e}=this,{creationInfo:t,viewModel:r}=e,{attachmentsViewModel:s,view:l}=r;if(!l||!t?.layer)throw new i("missing-parameters","CreateFeaturesWorkflow requires a view and creationInfo.");this._preventDefaultActionOnCancel=!1;const{initialFeature:c,layer:h}=t,u=this._sketchViewModel,p=new Map,f=[];this._lastActiveGraphics=[],this._featureFormHandle=o.removeMaybe(this._featureFormHandle),this._visualVariableAttributes={rotation:null,size:null},this.data.editorItem=r.findEditorItemForLayer(t.layer),F.prepareAttachmentsForCreateFeaturesWorkflow(s),f.push(d.watch((()=>s.mode),(e=>{switch(e){case"add":this.go("adding-attachment");break;case"edit":this.go("editing-attachment")}})));const w=F.showProgressCursor(l);f.push(w);const y=g.isTable(t.layer);try{if(y){const e=c??new a({attributes:{...t.template?.prototype.attributes,...t.attributeOverrides},sourceLayer:h});await this._startUpdating({feature:e,webStyleCache:p})}else f.push(A._configureSketchViewModel(this,p)),c?(u.layer.add(c),await this._startUpdating({feature:c,webStyleCache:p})):await this._startCreating(p)}finally{w.remove()}const m=n.makeHandle((()=>{for(const t of e.pendingFeatures)u.layer.remove(t),e.removePendingFeature(t)})),_=d.watch((()=>l?.timeZone),(e=>this._featureFormViewModel.timeZone=e),d.initial),v=n.makeHandle((()=>{b.isModelUpload(t)&&r.cancelWorkflow({warnIfNoWorkflow:!1})}));this._featureFormHandle&&f.push(this._featureFormHandle),this.addHandles(f,this._handleKeys.beforeCommit),this.addHandles([n.makeHandle((()=>s.fileInfos.removeAll())),n.handlesGroup(f),v,m,_],C)}async _waitForActiveToolCleared(){const e=this.data.viewModel.view;if(null==e?.activeTool)return;const t=new AbortController;this.addHandles(n.abortHandle(t),S),await d.whenOnce((()=>null==e?.activeTool),t.signal),t.abort()}};function O(e,t){let a=null;const r=()=>e.snappingOptions.featureSources,i=()=>(a=new _({layer:e.layer}),r().add(a),a),s=()=>{null!=a&&(r().remove(a),a=o.destroyMaybe(a))};return n.handlesGroup([d.watch((()=>{const e=t.creationInfo?.layer,a=r().find((t=>t.layer===e));return{hasFeatureLayerSource:!!a,enabled:a?.enabled??!1}}),(({hasFeatureLayerSource:e,enabled:t})=>{if(!e)return s();a??=i(),a.enabled=t}),d.syncAndInitial),n.makeHandle(s)])}function T(e,t,a,r){const i=[];return t.forEach(((t,n)=>{if(!t.error){const s=e[n],o=r.get(s)||[];s.attributes[a.objectIdField]=t.objectId,o.forEach((({form:e})=>i.push({feature:s,attachment:e})))}})),i}function D(e,t,a){const r=[],i=t.globalIdField;return e.forEach(((t,n)=>{e[n].attributes[i]??=c.generateBracedUUID(),(a?.get(t)||[]).forEach((({file:e})=>r.push({feature:t,attachment:{globalId:c.generateBracedUUID(),data:e}})))})),r.length?{addFeatures:e,addAttachments:r}:{addFeatures:e}}t.__decorate([h.property()],U.prototype,"createFeatureState",void 0),t.__decorate([h.property()],U.prototype,"data",void 0),t.__decorate([h.property({constructOnly:!0})],U.prototype,"isNested",void 0),t.__decorate([h.property()],U.prototype,"featureFormViewModel",null),t.__decorate([h.property()],U.prototype,"hasPendingEdits",null),t.__decorate([h.property()],U.prototype,"_getDrawMeshHelpMessage",void 0),t.__decorate([h.property()],U.prototype,"helpMessage",null),t.__decorate([h.property()],U.prototype,"layer",null),t.__decorate([h.property()],U.prototype,"parent",null),t.__decorate([h.property()],U.prototype,"parentLayer",null),t.__decorate([h.property()],U.prototype,"keyboardCancellationEnabled",null),t.__decorate([h.property()],U.prototype,"reliesOnOwnerAdminPrivileges",null),t.__decorate([h.property()],U.prototype,"shouldShowAttachments",null),t.__decorate([h.property()],U.prototype,"shouldAllowAttachmentEditing",null),t.__decorate([h.property()],U.prototype,"sketchViewModel",null),U=A=t.__decorate([p.subclass("esri.widgets.Editor.CreateFeaturesWorkflow")],U);return U}));
