/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../core/asyncUtils","../../core/Collection","../../core/deprecate","../../core/Error","../../core/Evented","../../core/handleUtils","../../core/Logger","../../core/maybe","../../core/promiseUtils","../../core/reactiveUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../../core/support/UpdatingHandles","../../layers/GraphicsLayer","../../layers/support/editableLayers","../../layers/support/layerUtils","../../portal/support/urlUtils","../../views/interactive/sketch/SketchOptions","../../views/interactive/snapping/SnappingManager","../../views/interactive/snapping/SnappingOptions","../Attachments/AttachmentsViewModel","./CreateFeaturesWorkflow","./UpdateWorkflow","./workflowUtils","./support/EditorItem","../FeatureTemplates/FeatureTemplatesViewModel","../Sketch/SketchViewModel","../Spinner/SpinnerViewModel"],(function(e,t,a,r,i,o,s,n,l,p,d,c,h,u,w,y,f,_,m,g,k,v,W,b,I,F,M,E,C,O,V){"use strict";const U="esri.widgets.Editor.EditorViewModel",A=()=>n.getLogger(U),L=["create-features","update"];function T(e,t,a){A().error(new i(e,t,a))}function S(e,t){return e?.find((e=>e.layer===t))}let P=class extends o.EventedAccessor{constructor(e){super(e),this._sketchEventListenerHandle=null,this._sketchGraphicsLayer=new f({listMode:"hide",internal:!0}),this._snappingManager=null,this._updateItemsTask=null,this._updatingHandles=new y.UpdatingHandles,this._featureTemplatesViewModelLocked=!1,this.activeWorkflow=null,this._activityQueue=new a,this.editorItems=new a,this.failures=[],this.hideTemplatesForInactiveLayers=!1,this.attachmentsViewModel=new b({capabilities:{editing:!0}}),this.featureTemplatesViewModel=new C({disabledItemFunction:({layer:e})=>this._itemIsSuspended(e)}),this.layerInfos=null,this.ownSketchViewModel=new O({layer:this._sketchGraphicsLayer}),this.sketchOptions=new k,this.snappingOptions=new W({attributeRulesEnabled:!0}),this.spinnerViewModel=new V,this.pageStack=[],this.showDiscardEditsPrompt=()=>Promise.resolve(!0),this._candidateCommitted=!1,this.back=async()=>{this.canGoBack&&(this.activeWorkflow?.hasPreviousStep?await this.activeWorkflow.back(this.showDiscardEditsPrompt):await this._cancelWorkflow({force:!this.hasPendingEdits}))},this.saveWorkflow=async()=>{const{featureFormViewModel:e}=this;if(e){if(e.submit(),!e.submittable||e.hasPendingSubtypeChoice)return;const t=e.getValues();if(e.validateContingencyConstraints(t,{includeIncompleteViolations:!0}).length>0)return}await(this.activeWorkflow?.save())},this.selectFeature=(e,t=!1)=>{const a=this.activeWorkflow;this._candidateCommitted||"update"!==a?.type||(a.data.rootFeature=e,t&&(a.next(),this._candidateCommitted=!0))}}initialize(){this.addHandles([d.watch((()=>{const e=this.view,t=e?.map?.editableLayers,a=e?.allLayerViews,r=a?.filter((e=>!!t?.includes(e.layer)));return[t,r,this.layerInfos,this.allowedWorkflows]}),(()=>this._updateEditorItems()),d.syncAndInitial),d.watch((()=>this.hideTemplatesForInactiveLayers),(()=>this.syncFeatureTemplates())),d.on((()=>this.activeWorkflow),"cancel",(()=>this.emit("workflow-cancel"))),d.on((()=>this.activeWorkflow),"commit",(()=>this.emit("workflow-commit"))),d.on((()=>this.activeWorkflow),"complete",(()=>{this.emit("workflow-commit"),this._set("activeWorkflow",null)})),d.when((()=>this.view?.map),(e=>e.add(this._sketchGraphicsLayer)),d.initial),d.on((()=>this.editorItems),"change",(()=>this._afterEditorItemsChange())),d.watch((()=>[this.canCreate,this.canUpdateVisible]),(()=>this._afterEditorItemsChange())),d.watch((()=>this.page),((e,t)=>{const a=[...this.pageStack];if(-1===a.indexOf(e))a.push(e);else for(;a.length&&a.at(-1)!==e;)a.pop();this.pageStack=a}),d.syncAndInitial),d.when((()=>"awaiting-update-feature-candidate"===this.state),(()=>this._candidateCommitted=!1)),d.on((()=>this.featureTemplatesViewModel),"select",(async({item:e,oldItem:t})=>{const{activeWorkflow:a}=this;if(a){if("update"===a.type&&"awaiting-feature-creation-info"===a.activeWorkflow?.stepId)return;try{await this.cancelWorkflow({force:!this.hasPendingEdits})}catch{return void this.featureTemplatesViewModel.select(t,{emit:!1})}}if(!e)return;const r={layer:e.layer,template:e.template};if(e.supportsUpload)return this.featureTemplatesViewModel.select(t,{emit:!1}),this.startCreateFeaturesWorkflow(r);this.startCreateFeaturesWorkflowAtFeatureCreation(r)})),d.on((()=>this.view),"key-down",(e=>{"Escape"===e.key&&this.activeWorkflow?.keyboardCancellationEnabled&&(e.stopPropagation(),this.back())})),d.on((()=>this.sketchViewModel),["create","delete","update"],(e=>{const{activeWorkflow:t}=this,a="update"===t?.type,r=a?t.activeWorkflow?.layer:t?.layer,i=a?t?.activeWorkflow?.parentLayer:void 0,o=`sketch-${e.type}`;this.emit(o,{type:o,detail:e,layer:r,parentLayer:i})}),d.sync),d.watch((()=>this.view),(e=>{if(this._snappingManager=l.destroyMaybe(this._snappingManager),!e)return;const t=this.snappingOptions;this._snappingManager=new v.SnappingManager({view:e,options:t}),this.ownSketchViewModel.snappingManager=this._snappingManager}),d.syncAndInitial),d.watch((()=>this.snappingOptions),(e=>{this._snappingManager&&(this._snappingManager.options=e)}),d.syncAndInitial)])}destroy(){this._cancelWorkflow({warnIfNoWorkflow:!1}).then((()=>{this.view?.map?.remove(this._sketchGraphicsLayer),this.view=null})),this._updateItemsTask=l.abortMaybe(this._updateItemsTask),this._updatingHandles.destroy(),this._sketchEventListenerHandle=l.removeMaybe(this._sketchEventListenerHandle)}get allowedWorkflows(){return this._get("allowedWorkflows")}set allowedWorkflows(e){r.deprecatedProperty(n.getLogger(this),"allowedWorkflows",{replacement:"Editor.visibleElements",version:"4.29",warnOnce:!0}),e&&0!==e.length||(e=[...L]),this._set("allowedWorkflows",e)}get canCreate(){return this.editorItems.some((e=>e.supportsCreateFeaturesWorkflow))}get canCreateVisible(){return!!this.featureTemplatesLayers.length}get canUpdate(){return this.editorItems.some((e=>e.supportsUpdateWorkflow))}get canUpdateVisible(){return this.editorItems.some((e=>e.supportsUpdateWorkflow&&e.visible))}get featureTemplatesLayers(){const e=new a;for(const t of this.editorItems){const a=t.supportsCreateFeaturesWorkflow&&!t.isTable,r=this.hideTemplatesForInactiveLayers&&!t.visible;a&&!r&&e.push(t.layer)}return e}get editableItems(){return r.deprecatedProperty(n.getLogger(this),"editableItems",{replacement:"editorItems",version:"4.29",warnOnce:!0}),this.editorItems.map((e=>{const{capabilities:t,disabled:a,hasInvalidFormTemplate:r,layer:i}=e,o=[],s=t.create,n=t.update,l=t.delete;return s.enabled&&o.push("create"),n.enabled&&o.push("update"),l.enabled&&o.push("delete"),{layer:i,supports:o,suspended:a,attributeUpdatesEnabled:n.attributes,geometryUpdatesEnabled:n.geometry,attachmentsOnCreateEnabled:s.attachments.enabled,attachmentsOnUpdateEnabled:n.attachments.enabled,hasInvalidFormTemplate:r,hasAttachments:t.attachments.enabled}}))}get featureFormViewModel(){const{activeWorkflow:e}=this;return"update"===e?.type?e.activeFeatureFormViewModel:"create-features"===e?.type?e.featureFormViewModel:null}get labelOptions(){return this.sketchOptions.labels}set labelOptions(e){this.sketchOptions.labels=e}get sketchViewModel(){const{activeWorkflow:e}=this;return"update"===e?.type?e.activeSketchViewModel:"create-features"===e?.type?e.sketchViewModel:this.ownSketchViewModel}get state(){if(!this.view?.ready)return"disabled";const e=this.attachmentsViewModel.mode;if("add"===e)return"adding-attachment";if("edit"===e)return"editing-attachment";const{activeWorkflow:t}=this;return t?.stepId?"update"===t.type&&t.activeWorkflow?.stepId?t.activeWorkflow.stepId:t.stepId:"ready"}get syncing(){return this._activityQueue.length>0}get updating(){return this._updatingHandles.updating||!0===this.activeWorkflow?.updating}get tooltipOptions(){return this.sketchOptions.tooltips}set tooltipOptions(e){this.sketchOptions.tooltips=e}get valueOptions(){return this.sketchOptions.values}set valueOptions(e){this.sketchOptions.values=e}set view(e){this.ownSketchViewModel.view=e,this.spinnerViewModel.view=e,this._set("view",e)}get page(){const{activeWorkflow:e,state:t}=this;if("update"===e?.type&&"awaiting-feature-to-update"===e.stepId)return"ready";if("create-features"===e?.type&&0===e.numPendingFeatures){const t=e.data.upload;if(t)return"default"===t.state?"ready":"creating-features-upload-details"}return t??"disabled"}get featureFormDisabled(){const{activeWorkflow:e}=this;return"update"===e?.type&&!1===e.activeEditorItem?.capabilities.update.attributes}get canGoBack(){return null!=this.activeWorkflow&&!this.syncing}get shouldShowDeleteButton(){const{activeWorkflow:e}=this;return!!e&&"update"===e.type&&!!e.activeEditorItem?.capabilities.delete.enabled}get hasPendingEdits(){return this.activeWorkflow?.hasPendingEdits??!1}get snappingManager(){return this._snappingManager}async startCreateFeaturesWorkflowAtFeatureTypeSelection(){return this.startCreateFeaturesWorkflow()}async startCreateFeaturesWorkflowAtFeatureCreation(e){return this.startCreateFeaturesWorkflow(e,"creating-features")}async startCreateFeaturesWorkflow(e,t="awaiting-feature-creation-info"){if(await d.whenOnce((()=>!this.updating)),!this.canCreate)throw new i("editing:unsupported-workflow","Creating features is unsupported or disabled.");const a=this._createUpdatingResolver();try{await this._cancelWorkflow();const a=this._createCreateFeaturesWorkflow(e,t);this._set("activeWorkflow",a),await a.start()}catch(r){this._logErrorAndCancelWorkflow(r)}finally{a.resolve()}}async startCreateFeaturesWorkflowAtFeatureEdit(e){await d.whenOnce((()=>!this.updating));const t=this._createUpdatingResolver();try{const{initialFeature:t}=e,a=t.sourceLayer=t.layer,r=a?this.findEditorItemForLayer(a):void 0;if(!r?.supportsCreateFeaturesWorkflow)throw new i("editing:unsupported-workflow","Creating features is unsupported or disabled for this layer.");await this._cancelWorkflow();const o=this._createCreateFeaturesWorkflow({initialFeature:t,layer:r.layer,maxFeatures:1},"creating-features");this._set("activeWorkflow",o),await o.start()}catch(a){this._logErrorAndCancelWorkflow(a)}finally{t.resolve()}}async startUpdateWorkflowAtFeatureSelection(){if(await d.whenOnce((()=>!this.updating)),!this.canUpdate)return void T("editing:unsupported-workflow","Update workflow is unsupported or disabled.");const e=this._createUpdatingResolver();try{await this._cancelWorkflow();const e=this._createUpdateWorkflow();this._set("activeWorkflow",e),await e.start()}catch(t){this._logErrorAndCancelWorkflow(t)}finally{e.resolve()}}async startUpdateWorkflowAtMultipleFeatureSelection(e){if(await d.whenOnce((()=>!this.updating)),!this.canUpdate)return void T("editing:unsupported-workflow","Update workflow is unsupported or disabled.");const t=this._createUpdatingResolver();try{await this._cancelWorkflow();const t=this._createUpdateWorkflow("awaiting-update-feature-candidate");t.data.candidates=e,this._set("activeWorkflow",t),await t.start()}catch(a){this._logErrorAndCancelWorkflow(a)}finally{t.resolve()}}async startUpdateWorkflowAtFeatureEdit(e){if(await d.whenOnce((()=>!this.updating)),!this.canUpdate)return void T("editing:unsupported-workflow","Update workflow is unsupported or disabled.");const t=this._createUpdatingResolver();try{await this._cancelWorkflow();const t=this._createUpdateWorkflow("editing-existing-feature");t.data.rootFeature=e,this._set("activeWorkflow",t),await t.start()}catch(a){this._logErrorAndCancelWorkflow(a)}finally{t.resolve()}}async deleteFeatureFromWorkflow(){const{activeWorkflow:e}=this;e&&"update"===e.type?await e.deleteActiveFeature():T("editing:unsupported-workflow","Deleting requires an active update workflow.")}async cancelWorkflow(e){return this._cancelWorkflow({warnIfNoWorkflow:!0,...e})}findEditorItemForLayer(e){return this.editorItems.find((t=>t.layer===e))}itemHasInvalidFormTemplate(e){return null!=e&&!0===this.findEditorItemForLayer(e.layer)?.hasInvalidFormTemplate}syncFeatureTemplates(){this._featureTemplatesViewModelLocked||(this.featureTemplatesViewModel.layers=this.featureTemplatesLayers.toArray())}async toggleUpdateWorkflow(){this.canUpdate&&(this.hasPendingEdits&&!await this.showDiscardEditsPrompt()||(this.activeWorkflow&&"awaiting-feature-to-update"===this.state?await this.cancelWorkflow({force:!0}):await this.startUpdateWorkflowAtFeatureSelection()))}lockFeatureTemplatesViewModel(){return this._featureTemplatesViewModelLocked=!0,s.makeHandle((()=>{this._featureTemplatesViewModelLocked=!1,this.syncFeatureTemplates()}))}async _getEditorItemCandidates(e){const{view:t}=this;if(!t?.map)return[];const{map:a}=t,r=a.editableLayers.toArray()??[],i=a.allTables.toArray().filter(m.isFeatureLayer)??[];return await Promise.allSettled([...r.map((e=>"subtype-group"===e.type?e.loadAll():Promise.resolve())),...i.map((e=>e.load()))]),p.throwIfAborted(e),[...r.reverse(),...i.reverse()].filter((e=>_.isEditableLayer(e)&&("mesh"!==e.geometryType||"3d"===t.type))).flatMap((e=>"subtype-group"===e.type?e.sublayers.toArray():e))}_drainEditorItems(){this.editorItems.drain((e=>e.destroy()))}async _updateEditorItems(){l.abortMaybe(this._updateItemsTask);const{view:e}=this,a=t.createTask((async t=>{if(!e?.map||!e?.allLayerViews)return;const a=await this._getEditorItemCandidates(t);if(!a.length)return void this._drainEditorItems();const r=[],i=[],o=[],{layerInfos:s}=this;for(const l of a){const t=S(s,l),a=await M.whenEditorLayerView(e,l).catch((()=>null));(t?r:a?i:o).push(new E({layer:l,layerInfo:t,layerView:a}))}s?.length&&r.sort(((e,t)=>s.findIndex((({layer:t})=>t===e.layer))-s.findIndex((({layer:e})=>e===t.layer))));const n=[...r,...i,...o];t.aborted||(this._drainEditorItems(),this.editorItems.addMany(n))}));this._updatingHandles.addPromise(a.promise),this._updateItemsTask=a}_afterEditorItemsChange(){const{activeWorkflow:e}=this;if(this.syncFeatureTemplates(),!e)return;const{stepId:t}=e;"create-features"!==e.type?"update"===e.type&&("awaiting-feature-to-update"===t&&!this.canUpdateVisible||"awaiting-update-feature-candidate"===t&&!e.hasUpdatableCandidates)&&this._cancelWorkflow():"awaiting-feature-creation-info"!==t||this.canCreate||this._cancelWorkflow()}async _cancelWorkflow(e){const t=this.activeWorkflow;if(!t)return void(e?.warnIfNoWorkflow&&T("editing:no-active-workflow","There is no active workflow to cancel."));if(!e||!1!==e.force)return this.emit("workflow-cancel"),this._set("activeWorkflow",null),void await t.cancel(e);await t.cancel(e),this._set("activeWorkflow",null)}_createCreateFeaturesWorkflow(e,t){return I.create({viewModel:this,creationInfo:e,sketchOptions:this.sketchOptions,snappingManager:this._snappingManager,startAt:t,applyEditsCallback:(e,t,a)=>this._applyEdits(e,t,a),addAttachmentsCallback:(e,t)=>this._addAttachments(e,t)})}_createUpdateWorkflow(e){return F.create({viewModel:this,sketchOptions:this.sketchOptions,snappingManager:this._snappingManager,startAt:e,applyEditsCallback:(e,t,a)=>this._applyEdits(e,t,a),addAttachmentsCallback:(e,t)=>this._addAttachments(e,t)})}_addAttachments(e,t){const a=t.map((t=>this._addAttachment(e,t.feature,t.attachment)))??[];return Promise.all(a)}async _addAttachment(e,t,a){let r=null;if(!("addAttachment"in e)||null==e.capabilities?.attachment)throw new i("editor:attachments-not-supported","Adding attachments is not supported for this layer type");return await this._queueOperation((async()=>(r=await(e.addAttachment?.(t,a).catch((e=>{throw e?.error||e})))??null,r))),r}async _applyEdits(e,t,a){let r=null;const i=e.url?await m.getOwningPortalUrl(e.url):null,o={returnServiceEditsOption:(!i||!g.parseKnownArcGISOnlineDomain(i))&&!RegExp("/hosted/","i").test(e.url)?"original-and-current-features":void 0,...a};return await this._queueOperation((async()=>{const{view:a}=this;if(!a)return null;const i=await M.whenEditorLayerView(a,e).catch((()=>null));return r=await e.applyEdits(t,o),i&&await d.whenOnce((()=>!i.updating)),r})),r}_queueOperation(e){this._activityQueue.push(e);const t=(e,t)=>{const a=t.indexOf(e);a>-1&&t.splice(a,1)};return e().then((e=>{if(null!=e&&"error"in e&&null!=e.error)throw e.error;if(null!=e&&"addFeatureResults"in e){const{addFeatureResults:t,deleteFeatureResults:a,updateFeatureResults:r}=e,i=t.find((e=>!!e.error))||r.find((e=>!!e.error))||a.find((e=>!!e.error));if(i)throw i.error}return e})).catch((a=>{T("editing:operation-error","An error occurred.",{error:a});const r={error:a,retry:()=>(t(r,this.failures),this._queueOperation(e)),cancel:()=>{t(r,this.failures)}};this._set("failures",[...this.failures,r])})).then((()=>{t(e,this._activityQueue)}))}_createUpdatingResolver(){const e=p.createResolver();return this._updatingHandles.addPromise(e.promise),e}_logErrorAndCancelWorkflow(e){const{name:t,message:a,details:r}=e;T(t??"editing:workflow-start-failed",a??void 0,r??e),this._cancelWorkflow({force:!0})}_itemIsSuspended(e){const t=this.findEditorItemForLayer(e);return null!=t&&(!t.visible||t.disabled)}};e.__decorate([c.property()],P.prototype,"_snappingManager",void 0),e.__decorate([c.property({readOnly:!0})],P.prototype,"activeWorkflow",void 0),e.__decorate([c.property({readOnly:!0})],P.prototype,"_activityQueue",void 0),e.__decorate([c.property({value:[...L]})],P.prototype,"allowedWorkflows",null),e.__decorate([c.property({readOnly:!0})],P.prototype,"canCreate",null),e.__decorate([c.property()],P.prototype,"canCreateVisible",null),e.__decorate([c.property({readOnly:!0})],P.prototype,"canUpdate",null),e.__decorate([c.property()],P.prototype,"canUpdateVisible",null),e.__decorate([c.property()],P.prototype,"featureTemplatesLayers",null),e.__decorate([c.property()],P.prototype,"editableItems",null),e.__decorate([c.property()],P.prototype,"editorItems",void 0),e.__decorate([c.property({readOnly:!0})],P.prototype,"failures",void 0),e.__decorate([c.property()],P.prototype,"hideTemplatesForInactiveLayers",void 0),e.__decorate([c.property()],P.prototype,"attachmentsViewModel",void 0),e.__decorate([c.property()],P.prototype,"featureFormViewModel",null),e.__decorate([c.property()],P.prototype,"featureTemplatesViewModel",void 0),e.__decorate([c.property()],P.prototype,"labelOptions",null),e.__decorate([c.property()],P.prototype,"layerInfos",void 0),e.__decorate([c.property()],P.prototype,"ownSketchViewModel",void 0),e.__decorate([c.property()],P.prototype,"sketchOptions",void 0),e.__decorate([c.property()],P.prototype,"sketchViewModel",null),e.__decorate([c.property({type:W,nonNullable:!0})],P.prototype,"snappingOptions",void 0),e.__decorate([c.property()],P.prototype,"spinnerViewModel",void 0),e.__decorate([c.property()],P.prototype,"state",null),e.__decorate([c.property({readOnly:!0})],P.prototype,"syncing",null),e.__decorate([c.property()],P.prototype,"updating",null),e.__decorate([c.property()],P.prototype,"tooltipOptions",null),e.__decorate([c.property()],P.prototype,"valueOptions",null),e.__decorate([c.property()],P.prototype,"view",null),e.__decorate([c.property()],P.prototype,"pageStack",void 0),e.__decorate([c.property()],P.prototype,"showDiscardEditsPrompt",void 0),e.__decorate([c.property()],P.prototype,"_candidateCommitted",void 0),e.__decorate([c.property()],P.prototype,"page",null),e.__decorate([c.property()],P.prototype,"featureFormDisabled",null),e.__decorate([c.property()],P.prototype,"canGoBack",null),e.__decorate([c.property()],P.prototype,"shouldShowDeleteButton",null),e.__decorate([c.property()],P.prototype,"hasPendingEdits",null),e.__decorate([c.property()],P.prototype,"snappingManager",null),P=e.__decorate([w.subclass(U)],P);return P}));
