/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../chunks/tslib.es6","../../core/Error","../../core/handleUtils","../../core/has","../../core/maybe","../../core/reactiveUtils","../../core/accessorSupport/decorators/property","../../core/Logger","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../../layers/GraphicsLayer","../../support/elevationInfoUtils","../../views/support/layerViewUtils","./UpdateFeatureWorkflowData","./UpdateRecordWorkflow","./workflowUtils","../Sketch/SketchViewModel"],(function(e,t,i,a,o,s,r,l,d,n,h,c,p,u,w,y,f,g){"use strict";var k;const m={...y.handleKeys,highlights:Symbol(),sketchGraphics:Symbol(),sketchViewModel:Symbol(),waitingForTool:Symbol()};e.UpdateFeatureWorkflow=k=class extends y.UpdateRecordWorkflow{constructor(e){super(e),this.type="update-feature",this._layerViewEditSession=null,this._sketchGraphicClone=null,this._sketchViewModel=null,this._webStyleCache=new Map}destroy(){this._layerViewEditSession?.rollback()}async commit(){this.removeHandles(m.sketchGraphics);try{const e=this.data.edits.stagedForDelete;await super.commit();const t=this._layerViewEditSession;e?t?.rollback():t?.commit()}catch(e){throw await this._configureSketchViewModel(),new i("editor-workflow:failed-to-commit","An error occurred when sending the updates to the service",{error:e})}}async start(){return await super.start(),await this._initializeSketchViewModel()}_initializeFeatureFormViewModel(){super._initializeFeatureFormViewModel(),this.addHandles([this._featureFormViewModel.on("value-change",(e=>{this._layerViewEditSession?.setAttribute(e.fieldName,e.value)})),r.watch((()=>this._featureFormViewModel.feature?.sourceLayer),(e=>this._sketchGraphicClone.sourceLayer=e))])}_configureHighlight(){const{edits:e,layerView:t}=this.data;u.highlightsSupported(t)&&this.addHandles(t.highlight(e.feature),m.highlights)}async _configureSketchViewModel(){const e=this._sketchViewModel;if(!e)return;const{data:t,_featureFormViewModel:i,_sketchGraphicClone:a}=this,{edits:o,viewModel:s}=t,r=o.feature,{view:l}=s,d=f.getVisualVariableAttributes(r),n=await f.setUpGeometryUpdate({feature:r,featureClone:a,visualVariableAttributes:d,sketchViewModel:e,view:l,onUpdate:({geometry:e,attributes:t},a)=>{if(o.updateAttributes(t),o.updateGeometry(e),i.feature&&(i.feature.geometry=e),null!=d.rotation){const{field:e}=d.rotation;i.setValue(e,t[e])}if(null!=d.size){const{field:e}=d.size;i.setValue(e,t[e])}("undo"===a.type||"redo"===a.type||"update"===a.type&&null!=a.toolEventInfo&&f.isTerminalUpdateEventType(a.toolEventInfo.type))&&i.notifyFeatureGeometryChanged()},addUpdatingPromise:e=>{this._updatingHandles.addPromise(e)},addHandle:e=>{this.addHandles(e,m.waitingForTool)},webStyleCache:this._webStyleCache});this.addHandles(n,m.sketchGraphics),e.addHandles(n)}async _initializeSketchViewModel(){const{data:e,_sketchGraphicClone:t}=this,i=e.edits.feature,{capabilities:o,layer:r}=e.editorItem,{view:l}=e.viewModel;if(this.removeHandles([m.highlights,m.sketchGraphics,m.sketchViewModel,m.waitingForTool]),!o.update.geometry||"3d"===l?.type&&p.hasEffectiveFeatureExpressionInfo(r.elevationInfo))return{enter:async()=>{this.hasHandles(m.highlights)||this._configureHighlight()},exit:()=>this.removeHandles([m.highlights])};const d=new c({elevationInfo:r.elevationInfo,internal:!0,listMode:"hide"}),n=new g({allowDeleteKey:!1,layer:d,sketchOptions:e.sketchOptions,snappingManager:e.snappingManager,updateOnGraphicClick:!1,view:l});return this._sketchViewModel=n,l?.map.add(d),this.addHandles(a.makeHandle((()=>{l?.destroyed||l?.map.remove(d),d.destroy(),this._sketchViewModel=s.destroyMaybe(n)})),m.sketchViewModel),await f.updateGraphicSymbolWhenRequired(t,this._webStyleCache,"2d"===l?.type?l.scale:null),this.addHandles([await f.swapForEditingSession(n,i,t)]),{enter:async()=>{this.hasHandles(m.sketchGraphics)||await this._configureSketchViewModel()},exit:()=>this.removeHandles([m.sketchGraphics]),viewModel:n}}_onFullFeatureLoaded(e){super._onFullFeatureLoaded(e);const t=this._sketchGraphicClone=f.cloneGraphicExceptMesh(e),{edits:i,layerView:a}=this.data;i.updateGeometry(e.geometry),i.trackChanges(),f.canCreateInteractiveEditSession(a)&&(this._layerViewEditSession=a.createInteractiveEditSession(t))}static async create(e){const t=new k({data:await w.create(e),onCommit:this._onCommitFactory(e.applyEdits)});return t._set("steps",this._createWorkflowSteps(t)),t}get test(){}},t.__decorate([l.property()],e.UpdateFeatureWorkflow.prototype,"_layerViewEditSession",void 0),t.__decorate([l.property()],e.UpdateFeatureWorkflow.prototype,"_sketchGraphicClone",void 0),t.__decorate([l.property()],e.UpdateFeatureWorkflow.prototype,"_sketchViewModel",void 0),e.UpdateFeatureWorkflow=k=t.__decorate([h.subclass("esri.widgets.Editor.UpdateFeatureWorkflow")],e.UpdateFeatureWorkflow),e.handleKeys=m,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
