/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../chunks/tslib.es6","../../core/Error","../../core/handleUtils","../../core/promiseUtils","../../core/reactiveUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/Logger","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../../views/draw/support/HighlightHelper","./UpdateRecordWorkflowData","./Workflow","./workflowUtils","../FeatureForm/FeatureFormViewModel"],(function(e,t,r,a,o,i,d,l,s,n,c,p,u,h,m,w){"use strict";var f;const g={exit:Symbol()};e.UpdateRecordWorkflow=f=class extends h{constructor(e){super(e),this._highlightHelper=null,this.fullFeature=null,this.type="update-table-record"}initialize(){const{data:e}=this,{edits:t}=e,{view:i}=e.viewModel,d=t.feature,l=new AbortController;this.addHandles(a.abortHandle(l)),this._updatingHandles.addPromise(m.fetchFullFeature(d,e.viewModel.view.spatialReference,l.signal).then((e=>{o.isAborted(l)||(this._onFullFeatureLoaded(e),this._initializeFeatureFormViewModel())}),(e=>this.cancel({force:!0,error:new r("editor:failed-to-fetch-full-feature","Failed to retrieve all information for this feature. The update cannot proceed.",{detail:{error:e}})})))),i&&(this._highlightHelper=new p({view:i}),this.addHandles(a.makeHandle((()=>this._highlightHelper?.removeAll()))))}get editorItem(){return this.data.editorItem}get featureFormViewModel(){return this._featureFormViewModel}get hasPendingEdits(){return this.data.edits.modified}get layer(){return this.data.editorItem.layer}get parent(){return this.data.parent}get parentLayer(){return this.parent?.data.editorItem.layer}get shouldShowAttachments(){return this.editorItem.capabilities.attachments.enabled}get shouldAllowAttachmentEditing(){return this.editorItem.capabilities.update.attachments.enabled}get reliesOnOwnerAdminPrivileges(){const e=this.editorItem.capabilities;return e.update.reliesOnOwnerAdminPrivileges||e.delete.reliesOnOwnerAdminPrivileges}async deleteAndCommit(){return this.data.edits.stageDelete(),this.commit()}async enter(){this._configureAttachmentsViewModel()}exit(e){this.removeHandles(g.exit)}async start(){return await super.start(),null}_configureAttachmentsViewModel(){const{data:e,fullFeature:t}=this,{attachmentsCapabilities:r,viewModel:o}=e,{attachmentsViewModel:d}=o;d.set({capabilities:r,graphic:t,filesEnabled:!1,mode:"view"}),this.addHandles([a.makeHandle((()=>d.fileInfos.removeAll())),i.watch((()=>d.mode),(e=>{switch(e){case"add":this.go("adding-attachment");break;case"edit":this.go("editing-attachment")}}))],g.exit)}_initializeFeatureFormViewModel(){const{edits:e,formTemplate:t,viewModel:{view:r}}=this.data,a=this._featureFormViewModel=new w({arcadeEditType:"UPDATE",feature:this.fullFeature,formTemplate:t,highlightHelper:this._highlightHelper,map:r?.map,spatialReference:r.spatialReference,timeZone:r?.timeZone});a.relatedRecordCallbacks={...this.data.relatedRecordCallbacks,showAllRelatedRecords:e=>a.relationshipId=e.relationshipId};const{initialFeature:o}=e;o&&a.overrideInitialFeature(o),this.addHandles([a.on("value-change",(()=>{e.updateAttributes(a.getValues()),this.fullFeature.attributes=e.feature.attributes})),i.watch((()=>r?.timeZone),(e=>a.timeZone=e))])}_onFullFeatureLoaded(e){this.fullFeature=e;const{edits:t}=this.data;t.updateAttributes(e.attributes),t.trackChanges()}static async create(e){const t=new f({data:await u.create(e),onCommit:this._onCommitFactory(e.applyEdits)});return t._set("steps",this._createWorkflowSteps(t)),t}static _createWorkflowSteps(e){const{attachmentsViewModel:t}=e.data.viewModel;return[{id:"editing-attributes",async setUp(){},async tearDown(){}},{id:"adding-attachment",async setUp(){},async tearDown(){t.mode="view"}},{id:"editing-attachment",async setUp(){},async tearDown(){t.mode="view"}}]}},e.UpdateRecordWorkflow._onCommitFactory=e=>async t=>{const{edits:r}=t,{feature:a}=r;if(!a)return;const o=a.sourceLayer,i=a.clone();if(!r.attributesModified||r.stagedForDelete){const e=o.objectIdField;if(i.attributes={[e]:a.getAttribute(e)},"scene"===o.type&&null!=o.infoFor3D){const e=o.associatedLayer?.globalIdField;null!=e&&i.setAttribute(e,a.getAttribute(e))}}r.geometryModified&&!r.stagedForDelete||(i.geometry=null);const d=r.stagedForDelete?"deleteFeatures":"updateFeatures";await e(o,{[d]:[i]})},t.__decorate([d.property()],e.UpdateRecordWorkflow.prototype,"editorItem",null),t.__decorate([d.property()],e.UpdateRecordWorkflow.prototype,"featureFormViewModel",null),t.__decorate([d.property()],e.UpdateRecordWorkflow.prototype,"fullFeature",void 0),t.__decorate([d.property()],e.UpdateRecordWorkflow.prototype,"hasPendingEdits",null),t.__decorate([d.property()],e.UpdateRecordWorkflow.prototype,"layer",null),t.__decorate([d.property()],e.UpdateRecordWorkflow.prototype,"parent",null),t.__decorate([d.property()],e.UpdateRecordWorkflow.prototype,"parentLayer",null),t.__decorate([d.property()],e.UpdateRecordWorkflow.prototype,"shouldShowAttachments",null),t.__decorate([d.property()],e.UpdateRecordWorkflow.prototype,"shouldAllowAttachmentEditing",null),t.__decorate([d.property()],e.UpdateRecordWorkflow.prototype,"reliesOnOwnerAdminPrivileges",null),e.UpdateRecordWorkflow=f=t.__decorate([c.subclass("esri.widgets.Editor.UpdateRecordWorkflow")],e.UpdateRecordWorkflow),e.handleKeys=g,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
