/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../Graphic","../../core/Error","../../core/handleUtils","../../core/Logger","../../core/maybe","../../core/promiseUtils","../../core/Queue","../../core/reactiveUtils","../../core/SetUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../../layers/support/editableLayers","../../layers/support/layerUtils","../../views/draw/support/HighlightHelper","../../views/input/InputManager","../../views/interactive/sketch/SketchOptions","./CreateFeaturesWorkflow","./UpdateFeatureWorkflow","./UpdateRecordWorkflow","./UpdateWorkflowData","./Workflow","./workflowUtils","../Feature/support/featureUtils","../support/templateUtils"],(function(e,t,a,o,r,i,n,s,l,d,c,p,u,w,h,f,k,g,y,v,m,_,b,W,M,C,S){"use strict";var F;const A="esri.widgets.Editor.UpdateWorkflow",U=()=>r.getLogger(A);let E=F=class extends W{constructor(e){super(e),this._workflowStack=new s(d.last),this._sketchStack=new s(d.last),this.data=void 0,this.type="update"}get activeEditorItem(){return this.activeWorkflow?.data.editorItem??void 0}get activeFeatureFormViewModel(){return this.activeWorkflow?.featureFormViewModel}get activeSketchViewModel(){return this._sketchStack.peek()?.viewModel}get activeWorkflow(){return this._workflowStack.last()}get updating(){return this._updatingHandles.updating||!!this.activeWorkflow?.updating}get hasPreviousStep(){return this._stepIndex>0||this.nestedWorkflowCount>1||null!=this.activeWorkflow?.featureFormViewModel.relationshipId||"view"!==this.data.viewModel.attachmentsViewModel.mode}get hasUpdatableCandidates(){const{candidates:e,viewModel:t}=this.data;return e.some((({layer:e})=>t.findEditorItemForLayer(e)?.supportsUpdateWorkflow))}get nestedWorkflowCount(){return this._workflowStack.length}get shouldShowAttachments(){return!!this.activeEditorItem?.capabilities.attachments.enabled}get shouldAllowAttachmentEditing(){return!!this.activeEditorItem?.capabilities.update.attachments.enabled}get hasPendingEdits(){return Array.from(this._workflowStack).some((e=>e.hasPendingEdits))}get helpMessage(){return this.activeWorkflow?.helpMessage?this.activeWorkflow.helpMessage:"awaiting-feature-to-update"===this.stepId?"select":void 0}get reliesOnOwnerAdminPrivileges(){return this.activeWorkflow?.reliesOnOwnerAdminPrivileges??!1}get hasInvalidFormTemplate(){return!!this.activeEditorItem?.hasInvalidFormTemplate}async back(e=()=>Promise.resolve(!0)){const{activeWorkflow:t}=this;if(null==t?.featureFormViewModel.relationshipId)if(t){if(t.hasPendingEdits){if(!await e())return}t.hasPreviousStep?await t.previous({cancelCurrentStep:!0}):await this.cancelActiveWorkflow({force:!0})}else this.hasPreviousStep?await this.previous({cancelCurrentStep:!0}):await this.cancel({force:!0});else t.featureFormViewModel.relationshipId=null}async cancelActiveWorkflow(e){await(this.activeWorkflow?.cancel(e)),await this._popWorkflow()}async commit(){await this._drainWorkflowStack((e=>e.commit())),await super.commit()}static create(e){const{viewModel:t,snappingManager:a,startAt:o,addAttachmentsCallback:r,applyEditsCallback:i}=e,n=e.sketchOptions??new y,s=new F({data:new b({addAttachmentsCallback:r,applyEditsCallback:i,sketchOptions:n,snappingManager:a,viewModel:t}),onCommit:async()=>{}});return s._set("steps",this._createWorkflowSteps(s,o)),s}async save(){this.nestedWorkflowCount>1?(await(this.activeWorkflow?.commit()),await this._popWorkflow()):await this.commit()}async startCreatingRelatedRecord(e){try{const t=await this._createNestedCreateFeaturesWorkflow(e);await this._pushWorkflow(t)}catch(t){throw new a("editor:unable-to-start-creating","Could not begin updating the provided feature or table record.",{error:t})}}async startUpdating(e){try{const t=await this._createNestedUpdateWorkflow(e);await this._pushWorkflow(t)}catch(t){throw new a("editor:unable-to-start-updating","Could not begin updating the provided feature or table record.",{error:t})}}async deleteActiveFeature(){const{activeWorkflow:e}=this;if(!e)throw new a("editor:nothing-to-delete","There is no feature to delete");R(e)?await e.deleteAndCommit():await e.cancel(),1===this.nestedWorkflowCount?await this.reset():await this._popWorkflow()}async cancelAll(){await this._drainWorkflowStack((e=>e.cancel({force:!0})))}async _createNestedCreateFeaturesWorkflow(e){const{relatedLayer:t}=e,{addAttachmentsCallback:o,applyEditsCallback:r,sketchOptions:i,snappingManager:n,viewModel:s}=this.data;if(!h.isEditableLayer(t))throw new a("editor:unsupported-layer","Editing is not supported on the provided layer");const l=this._getCreationInfoForNestedCreateFeaturesWorkflow(e),d=l.template||l.initialFeature?"creating-features":"awaiting-feature-creation-info",c="create-features"!==this.activeWorkflow?.type?this.activeWorkflow:void 0;return v.create({addAttachmentsCallback:o,applyEditsCallback:r,creationInfo:l,isNested:!0,parent:c,sketchOptions:i,snappingManager:n,startAt:d,viewModel:s})}_getCreationInfoForNestedCreateFeaturesWorkflow(e){const{relatedLayer:o}=e;if(!h.isEditableLayer(o)||f.isSubtypeGroupLayer(o))throw new a("editor:unsupported-layer","Editing is not supported on the provided layer");const r={layer:o,maxFeatures:1},i=this._makeRelatedRecordAttributes(e),n=S.getAllTemplatesForLayer(o);return n?.length>0?(r.attributeOverrides=i,1===n.length&&(r.template=n[0])):r.initialFeature=new t({sourceLayer:o,attributes:i}),r}async _createNestedUpdateWorkflow(e){const t=f.isTable(e.sourceLayer)?_.UpdateRecordWorkflow:m.UpdateFeatureWorkflow,{applyEditsCallback:a,sketchOptions:o,snappingManager:r,viewModel:i}=this.data,n="create-features"!==this.activeWorkflow?.type?this.activeWorkflow:void 0,s=await t.create({feature:e,parent:n,sketchOptions:o,snappingManager:r,viewModel:i,applyEdits:a,relatedRecordCallbacks:{addRelatedRecord:async e=>await this.startCreatingRelatedRecord(e),editRelatedRecord:async({relatedFeature:e})=>await this.startUpdating(e)}});return await l.whenOnce((()=>!s.updating)),s}async _drainWorkflowStack(e){const t=this._workflowStack,a=[];for(;t.length>0;){const o=t.pop();this._sketchStack.pop();const r=e(o).then((()=>o.destroy()));this._updatingHandles.addPromise(r),a.push(r)}await Promise.all(a)}_makeRelatedRecordAttributes(e){const{parentFeature:t,relatedLayer:a,relationshipId:o}=e;if(!C.isGraphicForRelatableFeatureSupportedLayer(t))return;const r=a.relationships?.find((e=>e.id===o));if(!r)return void P("relationship-not-found","Could not begin creating a related record because the relationship specified could not be found on the destination layer.");if("origin"===r.role)return void P("unsupported-role","Creating new related records in the 'origin' table of a relationship is not yet supported");const i=t.sourceLayer;r.relatedTableId!==i.layerId&&P("invalid-argument-combination","The given parent feature does not belong to the relationship designated by the given relationship ID.");const n=i.relationships?.find((e=>e.id===o));if(!n)return void P("relationship-not-found","Could not begin creating a related record because the relationship specified could not be found on the origin layer.");const s=I(i,n),l=t.getAttribute(s);l||P("no-key-on-origin-feature","The given parent feature does not have a value for the relationship's origin primary key field.");const d=I(a,r);return{[d]:l}}async _popWorkflow(){this._workflowStack.pop()?.destroy(),this._sketchStack.pop();const e=await this._reconcileWorkflowStack();if(e.failureCount>0)throw new a("editor:next-workflow-failed","Popped the top workflow, but the next workflow in the stack failed to activate",e)}async _pushWorkflow(e){const t=this._workflowRequiresSketchViewModel(e);this.activeWorkflow?.exit({removeSketchHandles:t});const o=this._sketchStack,r=await(e?.start()),i=o.peek();r?(i?.exit(),o.push(r)):o.push(this._cloneSketchController(i)),this._workflowStack.push(e);const n=await this._reconcileWorkflowStack();if(n.failureCount>0)throw new a("editor:failed-to-start-updating-feature","Failed to enter the provided workflow.",n)}async _reconcileWorkflowStack(){const e=this._workflowStack,t=this._sketchStack;try{const a=e.peek();return await(a?.enter()),await(t.peek()?.enter()),{activeWorkflow:a,failureCount:0}}catch(a){e.pop().destroy(),t.pop();const{activeWorkflow:o,failureCount:r}=await this._reconcileWorkflowStack();return{activeWorkflow:o,failureCount:r+1}}}_cloneSketchController(e){return{enter:e?.enter??(async()=>{}),exit:e?.exit??(async()=>{}),viewModel:e?.viewModel}}_workflowRequiresSketchViewModel(e){const{type:t}=e;return"update-feature"===t||"create-features"===t&&!f.isTable(e.data.creationInfo?.layer)}static _createWorkflowSteps(e,t="awaiting-feature-to-update"){const{data:r}=e,s={"awaiting-feature-to-update":()=>({id:"awaiting-feature-to-update",async setUp(){const{spinnerViewModel:t}=r.viewModel,a=r.viewModel.view;a.activeTool=null;let s=null;e.addHandles(o.makeHandle((()=>{s=i.abortMaybe(s)})),this.id),r.rootFeature=null,r.candidates=[];const d=a.on("immediate-click",(async o=>{const i=n.createResolver();e._updatingHandles.addPromise(i.promise);try{t.location=o.mapPoint,t.visible=!0,s?.abort();const{editorItems:i}=r.viewModel;s=new AbortController;const l=await o.async((()=>new Promise(((e,t)=>{n.onAbort(s?.signal,(()=>t(n.createAbortError()))),e(M.fetchCandidates(i,a,o,s?.signal))}))));if(n.throwIfAborted(s),r.candidates=l.filter((e=>"fulfilled"===e.status)).flatMap((e=>e.value)).filter((e=>!e.isAggregate)),t.visible=1===r.candidates.length,0===r.candidates.length)return;o.stopPropagation(),1===r.candidates.length?(r.rootFeature=r.candidates[0],e.go("editing-existing-feature").catch((()=>{})).then((()=>t.visible=!1))):e.next()}finally{i.resolve()}}),g.ViewEventPriorities.TOOL),c=l.when((()=>null!=a.activeTool),(()=>e.cancel({force:!0})),{once:!0});a.focus(),e.addHandles([d,c],this.id)},async tearDown(){0===r.candidates.length&&(r.viewModel.spinnerViewModel.visible=!1),e.removeHandles(this.id)}}),"awaiting-update-feature-candidate":()=>({id:"awaiting-update-feature-candidate",async setUp(){r.rootFeature=null;const{view:t}=r.viewModel;if(!t)return;const a=new k({view:t});e.addHandles([l.watch((()=>r.rootFeature),((e,t)=>{a.remove(t),a.add(e)}),l.sync),o.makeHandle((()=>a.removeAll()))],this.id)},async tearDown(){e.removeHandles(this.id)}}),"editing-existing-feature":()=>({id:"editing-existing-feature",async setUp(){const{rootFeature:t,viewModel:o}=e.data;if(!t)throw new a("editor:no-feature-specified","Cannot setup the 'updating-existing-feature' step until the root feature is defined");await e.startUpdating(t),o.spinnerViewModel.visible=!1;const r=n.debounce((async()=>{await l.whenOnce((()=>!e.updating)),e.previous()}));e.addHandles([l.watch((()=>e.nestedWorkflowCount),((e,t)=>{0===e&&0!==t&&r()}),l.sync)],this.id)},async tearDown(){await e.cancelAll(),e.removeHandles(this.id)}}),"adding-attachment":()=>({id:"adding-attachment",parent:"editing-existing-feature",async setUp(){},async tearDown(){r.viewModel.attachmentsViewModel.mode="view"}}),"editing-attachment":()=>({id:"editing-attachment",parent:"editing-existing-feature",async setUp(){},async tearDown(){r.viewModel.attachmentsViewModel.mode="view"}})};return M.createWorkflowSteps(["awaiting-feature-to-update","awaiting-update-feature-candidate","editing-existing-feature","adding-attachment","editing-attachment"],t,s)}};function I(e,{keyField:t}){return e.getField(t)?.name??t}e.__decorate([c.property()],E.prototype,"activeEditorItem",null),e.__decorate([c.property()],E.prototype,"activeFeatureFormViewModel",null),e.__decorate([c.property()],E.prototype,"activeSketchViewModel",null),e.__decorate([c.property()],E.prototype,"activeWorkflow",null),e.__decorate([c.property()],E.prototype,"updating",null),e.__decorate([c.property()],E.prototype,"data",void 0),e.__decorate([c.property()],E.prototype,"hasPreviousStep",null),e.__decorate([c.property()],E.prototype,"hasUpdatableCandidates",null),e.__decorate([c.property()],E.prototype,"nestedWorkflowCount",null),e.__decorate([c.property()],E.prototype,"shouldShowAttachments",null),e.__decorate([c.property()],E.prototype,"shouldAllowAttachmentEditing",null),e.__decorate([c.property()],E.prototype,"hasPendingEdits",null),e.__decorate([c.property()],E.prototype,"helpMessage",null),e.__decorate([c.property()],E.prototype,"reliesOnOwnerAdminPrivileges",null),e.__decorate([c.property()],E.prototype,"hasInvalidFormTemplate",null),E=F=e.__decorate([w.subclass(A)],E);const P=(e,t)=>U().warn(`editor:${e}`,t,"The create operation will be allowed to proceed, but the resulting feature may not be related to the given parent feature."),R=e=>!!e&&/update-/.test(e.type);return E}));
