/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","exports","../../Graphic","../../core/arrayUtils","../../core/asyncUtils","../../core/has","../../core/handleUtils","../../core/lang","../../core/promiseUtils","../../core/reactiveUtils","../../core/screenUtils","../../core/accessorSupport/diffUtils","../../layers/support/fieldUtils","../../renderers/support/clickToleranceUtils","../../renderers/support/lengthUtils","../../renderers/visualVariables/support/sizeVariableUtils","../../renderers/visualVariables/support/visualVariableUtils","../../symbols/support/symbolConversion","../../symbols/support/symbolUtils","../../views/3d/layers/graphics/GraphicState","../../views/support/drapedUtils","../../views/support/hitTestSelectUtils","../support/templateUtils"],(function(e,t,a,i,r,n,l,s,o,c,u,p,y,d,f,h,g,b,w,m,v,S,I){"use strict";function U(e){return"update"===e.type}function T(e){const t=e.sourceLayer;if(!t||"feature"!==t.type||!L(t.renderer))return{rotation:null,size:null};let a=null,i=null;const r=t.renderer.getVisualVariablesForType("rotation").filter((t=>(!t.axis||"heading"===t.axis)&&t.field&&!t.valueExpression&&null!=g.getRotationAngle(t,e)));1===r.length&&(a=V(r[0],t));const n=t.renderer.getVisualVariablesForType("size").filter((t=>t.field&&!t.useSymbolValue&&!t.valueExpression&&h.getTransformationType(t)===h.TransformationType.RealWorldSize&&null!=g.getSize(t,e)));return 1===n.length&&(i=z(n[0],t)),{rotation:a,size:i}}function V(e,t){const a="heading"===(e.axis||"heading")&&"arithmetic"===e.rotationType?-1:1,i=e.field,r=t.fields&&t.fields.filter((e=>e.name===i)),n=r&&1===r.length?r[0].type:"double",l={initial:0,current:0};return{field:i,fieldType:n,getDefault:()=>Promise.resolve(0),getValue:e=>(l.current=l.initial-a*e,A((l.current+360)%360,n)),setInitialValue:e=>{l.initial=e,l.current=0},isUpdatingInteractively:!1,rotationType:e.rotationType??"geographic"}}function F(e,t){switch(t){case"width":return e[0];case"depth":return e[1];case"height":return e[2];default:return e[2]||e[1]||e[0]}}async function x(t,a,i){if(null==a)return 0;const{symbol:r}=b.to3D(a);if(null==r||"web-style"===r.type||"cim"===r.type)return 0;const n=r.symbolLayers.at(0);if(!n)return 0;switch(n.type){case"icon":{const{computeIconLayerResourceSize:t}=await new Promise(((t,a)=>e(["../../symbols/support/symbolLayerUtils"],t,a)));return n.size||Math.min(Y.icon,(await t(n,Y.icon))[0])||Y.icon}case"text":return n.size||Y.text;case"line":return n.size||Y.line;case"object":{const{computeObjectLayerResourceSize:a}=await new Promise(((t,a)=>e(["../../symbols/support/symbolLayerUtils"],t,a)));return F(await a(n,t.scale/Y.viewScaleSizeFactor),i)}case"path":return(null!=n.width?n.width:n.height)||t.scale/Y.viewScaleSizeFactor;case"extrude":return n.size||t.scale/Y.viewScaleSizeFactor;default:return 0}}function z(e,t){const a=e.field,i=e.axis,r=t.fields&&t.fields.filter((e=>e.name===a)),n=r&&1===r.length?r[0].type:"double",l={initial:0,current:0},s=f.meterIn[e.valueUnit]??1;let o;return o="area"===e.valueRepresentation?e=>(e*s/2)**2*Math.PI:"radius"===e.valueRepresentation||"distance"===e.valueRepresentation?e=>e*s/2:e=>e*s,{field:a,fieldType:n,getDefault:async(e,t)=>A(o(await x(t,e,i)),n),getValue:(e,t)=>(l.initial||(l.initial=t.pixelSizeAt(t.center)),l.current=l.initial*e,A(l.current,n)),setInitialValue:e=>{l.initial=e,l.current=0},isUpdatingInteractively:!1,displayUnit:ee(e.valueUnit),axis:e.axis}}function A(e,t){switch(t){case"small-integer":case"integer":case"long":return Math.round(e);case"double":case"single":return e;default:return 0}}function L(e){switch(e?.type){case"class-breaks":case"simple":case"unique-value":case"dot-density":case"dictionary":case"pie-chart":return!0;default:return!1}}async function k(e,t,a){const i=await w.getDisplayedSymbol(e,{useSourceLayer:!0,ignoreGraphicSymbol:!0,webStyleCache:t,scale:a});null!=p.diff(e.symbol,i)&&(e.symbol=i)}function O(e){if(!e)throw new Error("no geometry type");return"multipatch"===e?"mesh":e}async function G(e,t,a){const i=t.layer,r=C(t);let n=null;const{view:s}=e,u="2d"===s?.type;if(await E(e,i,r,a,u?s.scale:null),u){const t=o.debounce((t=>E(e,i,r,a,t)));n=c.watch((()=>s.scale),(e=>t(e)))}const{data:p,editing:y}=i.capabilities;return e.layer.elevationInfo=i.elevationInfo,null==t.geometryToPlace?await e.create(O(i.geometryType),{graphicProperties:{attributes:r,sourceLayer:i},hasZ:p.supportsZ,defaultZ:(u?y.zDefault:null)??e.defaultCreateOptions.defaultZ}):await e.place(t.geometryToPlace,{graphicProperties:{attributes:r,sourceLayer:i}}),n??l.makeHandle()}function C(e){return{...e.template?.prototype.attributes,...e.attributeOverrides}}async function E(e,t,i,r,n){const l=new a({sourceLayer:t,attributes:i}),{rotation:s,size:o}=T(l);let c=await w.getDisplayedSymbol(l,{useSourceLayer:!0,webStyleCache:r,scale:n}),u=!1;for(const a of[o,s]){if(null==a)continue;null==i[a.field]&&(i[a.field]=await a.getDefault(c,e.view),u=!0)}switch(u&&(c=await w.getDisplayedSymbol(l,{useSourceLayer:!0,webStyleCache:r,scale:n})),c?.type){case"simple-fill":case"polygon-3d":e.polygonSymbol=c;break;case"simple-line":case"line-3d":e.polylineSymbol=c;break;case"simple-marker":case"picture-marker":case"point-3d":case"cim":e.pointSymbol=c;break;case"mesh-3d":e.meshSymbol=c}P(e.tooltipOptions,o,s)}function P(e,t,a){e.visualVariables=null!=t||null!=a?{size:null!=t?{unit:t.displayUnit,axis:t.axis,valueType:t.fieldType}:null,rotation:null!=a?{valueType:a.fieldType,rotationType:a.rotationType??"geographic"}:null}:null}function D(e,t){return e?.find((e=>e.layer===t))}async function M(e,t,a,i){switch(t.type){case"3d":return j(e,t,a,i);case"2d":return R(e,t,a,i)}}async function j(e,t,a,r){if(0===e.length)return[];const{updatable:n,graphicsByLayer:l}=await a.async((async()=>{const{results:i}=await o.whenOrAbort(S.hitTestSelectSimilarDistance(t,a),r),n=new Map,l=e=>{const t=e.layer,a=n.get(t);if(!a){const e=new Array;return n.set(t,e),e}return a};S.filterGraphicHits(i).forEach((({graphic:e})=>l(e).push(e)));const s=e.filter((({capabilities:e,layer:t})=>e.update.enabled&&n.has(t)));return 0!==s.length&&a.stopPropagation(),{updatable:s,graphicsByLayer:n}}));return o.whenOrAbort(Promise.allSettled(n.map((async({layer:e})=>{const t=l.get(e),a=H(e);if(t.every((e=>y.featureHasFields(a,e))))return t;const n=[];for(const r of t){n.push(r.getObjectId());const e=Object.keys(r.attributes);i.addMany(a,e)}const s=e.createQuery();return s.returnGeometry=!1,s.objectIds=n,s.outFields=y.fixFields(e.fieldsIndex,a),e.queryFeatures(s,{signal:r}).then((({features:e})=>e))}))),r)}async function R(e,t,a,i){if(0===e.length)return[];const{mapPoint:r}=a;if(null==r)return[];let n=null;const l=await a.async((async()=>{const{results:r}=await o.whenOrAbort(t.hitTest(a),i);if(0===r.length)return[];const l=new Set;n=S.filterGraphicHits(r),n.forEach((({graphic:e})=>e&&l.add(e.layer)));const s=e.filter((e=>l.has(e.layer)&&e.supportsUpdateWorkflow));return s.length>0&&a.stopPropagation(),s}));return o.whenOrAbort(Promise.allSettled(l.map((async({layer:e})=>{const l=e.createQuery();l.returnGeometry=!1,l.outFields=H(e);const s="renderer"in e?d.calculateTolerance({renderer:e.renderer,pointerType:a.pointerType}):0;l.geometry=v.createQueryGeometry(r,s,t),l.outSpatialReference=t.spatialReference;const{features:o}=await e.queryFeatures(l,{signal:i});return n?.forEach((({graphic:t})=>{t.layer!==e||o.some((e=>e.getObjectId()===t.getObjectId()))||o.push(t)})),o}))),i)}function H(e){return y.fixFields(e.fieldsIndex,[e.objectIdField,y.getDisplayFieldName({displayField:"displayField"in e?e.displayField:null,fields:e.fields})])}async function q(e,t,a){const{sourceLayer:i}=e,r=i.createQuery();r.objectIds=[e.getAttribute(i.objectIdField)],r.outFields=["*"],r.returnM=i.capabilities.data.supportsM,r.returnZ=i.capabilities.data.supportsZ,"scene"===i.type&&null!=i.infoFor3D||(r.outSpatialReference=t);const n=await i.queryFeatures(r,{signal:a});o.throwIfAborted(a);return n.features[0]}async function W(e){const{graphic:t,sketchViewModel:a,sourceLayer:i,visualVariables:r,webStyleCache:n}=e;let l=!1;const{rotation:s,size:o}=r;if([s,o].forEach((async e=>{if(null==e)return;const i=t.getAttribute(e.field);if(null!=i)e.setInitialValue(i);else{const i=await e.getDefault(t.symbol,a.view);e.setInitialValue(i),t.setAttribute(e.field,i),l=!0}})),l){const e="2d"===a.view?.type?a.view.scale:null;await k(t,n,e)}const c={multipleSelectionEnabled:!1};return"point"===i.geometryType&&(c.enableRotation=null!=s,c.enableScaling=null!=o),P(a.tooltipOptions,o,s),a.layer.elevationInfo=i.elevationInfo,a.update(t,c)}function Z(e){return null==e||"rotate-start"!==e.type&&"rotate"!==e.type&&"rotate-stop"!==e.type?null:e}function Q(e){return null==e||"scale-start"!==e.type&&"scale"!==e.type&&"scale-stop"!==e.type?null:e}async function B(e,t,a,i,r){if(null==t.geometry||"point"!==t.geometry?.type)return;const n=i.rotation,l=Z(a.toolEventInfo);if(null!=n&&null!=l){const{field:a,getValue:i}=n;"rotate-stop"===l.type?(n.isUpdatingInteractively=!1,n.setInitialValue(t.getAttribute(a))):(n.isUpdatingInteractively=!0,t.setAttribute(a,i(l.angle,e)))}const s=i.size,o=Q(a.toolEventInfo);if(null!=s&&null!=o){const{field:a,getValue:i}=s;"scale-stop"===o.type?(s.isUpdatingInteractively=!1,s.setInitialValue(t.getAttribute(a))):(s.isUpdatingInteractively=!0,t.setAttribute(a,i(o.xScale,e)))}await k(t,r,"2d"===e.type?e.scale:null)}async function N({feature:e,featureClone:t,visualVariableAttributes:a,sketchViewModel:i,view:r,onUpdate:n,webStyleCache:s,addUpdatingPromise:u,addHandle:p}){await k(t,s,"2d"===r.type?r.scale:null);let y=null;if("2d"===i?.view?.type){const e=o.debounce((e=>k(t,s,e)));y=c.watch((()=>i?.view?.scale),(t=>e(t)))}const d=t.sourceLayer,f=ie(r,d);await W({graphic:t,sketchViewModel:i,sourceLayer:d,visualVariables:a,webStyleCache:s});let h=null;f.then((e=>h=e)).catch((()=>{}));const g=a.size,b=a.rotation,w=c.watch((()=>e.attributes),(async e=>{let a=!1;for(const i in e){const r=e[i];r!==t.getAttribute(i)&&(t.setAttribute(i,r),null==g||g.isUpdatingInteractively||g.field!==i||g.setInitialValue(r),null==b||b.isUpdatingInteractively||b.field!==i||b.setInitialValue(r),(null==h||h.requiredFields.includes(i))&&(a=!0))}a&&await k(t,s,"2d"===r.type?r.scale:null)})),m=i.on("update",(async e=>{const t=e.graphics[0],o={graphic:t,sketchViewModel:i,sourceLayer:d,visualVariables:a,webStyleCache:s};if("complete"===e.state){if(null===r.activeTool)return W(o);const e=new AbortController,t=l.abortHandle(e);return p(t),u(c.whenOnce((()=>null===r.activeTool),e.signal).then((()=>(e.abort(),W(o)))))}await B(r,t,e,a,s),n(ne(t),e)})),v=i.on(["undo","redo"],(async e=>{n(ne(e.graphics[0]),e)}));return l.handlesGroup([v,m,l.makeHandle((()=>i.cancel())),w,y])}async function J(e,t,a){const i=e.view;e.layer.add(a);const n=t.sourceLayer,s=t.layer,u=t.getAttribute(s.objectIdField);let p=null;function y(e){p?.abort(),p=r.createTask((async t=>{const a=await ie(i,n);o.throwIfAborted(t),a.setVisibility?.(u,e)}))}return await X(i,a),y(!1),l.handlesGroup([K(i,a,(e=>y(!e))),l.makeHandle((async()=>{y(!0);try{const e=await ie(i,n);await c.whenOnce((()=>!e.updating))}finally{e.layer.remove(a)}}))])}function K(e,t,a){if("3d"===e.type){const i=new m.GraphicState({graphic:t});return l.handlesGroup([e.trackGraphicState(i),c.watch((()=>i.displaying),a)])}return c.watch((()=>t.visible),a)}async function X(e,t){if("3d"===e.type){const a=new m.GraphicState({graphic:t}),i=e.trackGraphicState(a);await c.whenOnce((()=>a.displaying||a.error)),i.remove()}else await c.whenOnce((()=>t.visible))}const Y={icon:u.px2pt(24),text:u.px2pt(12),line:u.px2pt(1),viewScaleSizeFactor:100};function $(e,t,a){let i=!1;return e.filter((e=>!!i||(i=e===t,i))).map((e=>a[e]()))}function _(e,t){e.viewModel.syncFeatureTemplates();const a=e.creationInfo;if("awaiting-feature-creation-info"===t[0].id&&a){const e=a.layer,i=I.getAllTemplatesForLayer(e);1===i.length&&"scene"!==e.type&&(a.template=i[0],t.shift())}return t}function ee(e){return"unknown"===e?null:e}function te(e){e.filesEnabled=!0,e.mode="view",e.capabilities={editing:!0,operations:{add:!0,update:!0,delete:!0}}}const ae=e=>/-stop/.test(e)||/vertex-/.test(e),ie=(e,t)=>{const a="subtype-sublayer"===t.type?t.parent:t;return e.whenLayerView(a)};function re(e){return"createInteractiveEditSession"in e}function ne(e){const t=e.geometry;if("mesh"===t?.type){const a=e.cloneShallow();return a.attributes=s.clone(e.attributes),a.geometry=t.cloneShallow(),a.geometry.transform=t.transform?.clone()??null,a}return e.clone()}function le(e){const t=e.cursor;return e.cursor="progress",l.makeHandle((()=>e.cursor=t))}t.avoidFeatureTemplateSelectionWithOnlyOneItem=_,t.canCreateInteractiveEditSession=re,t.cloneGraphicExceptMesh=ne,t.createWorkflowSteps=$,t.fetchCandidates=M,t.fetchFullFeature=q,t.findLayerInfo=D,t.getCreationAttributes=C,t.getVisualVariableAttributes=T,t.isTerminalUpdateEventType=ae,t.isUpdateWorkflow=U,t.prepareAttachmentsForCreateFeaturesWorkflow=te,t.setUpGeometryUpdate=N,t.showProgressCursor=le,t.sizeDefaults=Y,t.sizeVariableUnitToLengthUnit=ee,t.startCreatingNewFeature=G,t.startUpdatingFeature=W,t.swapForEditingSession=J,t.updateGraphicSymbolWhenRequired=k,t.visualVariableInteractiveUpdate=B,t.whenEditorLayerView=ie,t.whenGraphicDisplayed=X,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
