/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../core/asyncUtils","../core/maybe","../core/memoize","../core/promiseUtils","../core/reactiveUtils","../core/accessorSupport/decorators/property","../core/has","../core/Logger","../core/RandomLCG","../core/accessorSupport/decorators/subclass","./Widget","./ElevationProfile/css","./ElevationProfile/ElevationProfileViewModel","./ElevationProfile/ElevationProfileVisibleElements","./ElevationProfile/components/Legend","./ElevationProfile/components/SettingsButton","./ElevationProfile/support/constants","../chunks/componentsUtils","./support/globalCss","./support/widgetUtils","./support/decorators/messageBundle","./support/jsxFactory"],(function(e,t,r,s,i,o,n,a,l,c,h,d,p,u,_,m,v,C,y,g,f,b,w,S){"use strict";var k;!function(e){e.Sketch="sketch",e.SketchCancel="sketch-cancel",e.SketchDone="sketch-done",e.Select="select",e.SelectCancel="select-cancel"}(k||(k={}));const E=[{type:k.Select},{type:k.Sketch}],M={[y.ElevationProfileErrorState.None]:null,[y.ElevationProfileErrorState.NoValidInput]:"noProfile",[y.ElevationProfileErrorState.NoVisibleProfiles]:"noProfile",[y.ElevationProfileErrorState.RefinedButNoChartData]:"noProfile",[y.ElevationProfileErrorState.TooComplex]:"tooComplex",[y.ElevationProfileErrorState.UnknownError]:"unknown",[y.ElevationProfileErrorState.InvalidGeometry]:"invalidGeometry",[y.ElevationProfileErrorState.InvalidElevationInfo]:"invalidElevationInfo"},P=Symbol("resize-observer-handle");let B=class extends p{constructor(e,t){super(e,t),this.viewModel=null,this.visibleElements=new m,this.messages=null,this.messagesCommon=null,this.messagesUnits=null,this._contentWrapper=null,this._chartContainer=null,this._chart=null,this._chartInitTask=null,this._chartIsRefined=!1,this._width=0,this._zoomOutButtonVisible=!1,this._getChartUpdateParamsMemoized=i.memoize(((e,t,r,s)=>({chart:e,data:t,stationary:r,messages:s}))),this._onZoomOutButtonClick=()=>{this._chart?.zoomOut()},this._onClearButtonClick=()=>{this.viewModel.clear()},e?.viewModel||(this._defaultViewModel=new _({view:e?.view}),this.viewModel=this._defaultViewModel)}loadDependencies(){return g.loadCalciteComponents({action:()=>new Promise(((t,r)=>e(["../chunks/calcite-action"],t,r))),button:()=>new Promise(((t,r)=>e(["../chunks/calcite-button"],t,r))),loader:()=>new Promise(((t,r)=>e(["../chunks/calcite-loader"],t,r)))})}postInitialize(){this.addHandles([n.watch((()=>({container:this._chartContainer,width:this._width})),(({container:e,width:t})=>{this._destroyChart(),null!=e&&t>0&&this._initializeChart(e)}),n.initial),n.watch((()=>this._chartUpdateParams),(()=>this._updateChart(this._chartUpdateParams)),n.initial)])}destroy(){this._destroyChart(),null!=this._defaultViewModel&&this.viewModel!==this._defaultViewModel&&this._defaultViewModel.destroy()}get view(){return this.viewModel.view}set view(e){this.viewModel.view=e}get input(){return this.viewModel.input}set input(e){this.viewModel.input=e}get profiles(){return this.viewModel.profiles}set profiles(e){this.viewModel.profiles=e}get unitOptions(){return this.viewModel.unitOptions}set unitOptions(e){this.viewModel.unitOptions=e}get unit(){return this.viewModel.unit}set unit(e){this.viewModel.unit=e}get geodesicDistanceThreshold(){return this.viewModel.geodesicDistanceThreshold}set geodesicDistanceThreshold(e){this.viewModel.geodesicDistanceThreshold=e}get icon(){return"altitude"}set icon(e){this._overrideIfSome("icon",e)}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}get visible(){return this.viewModel.visible}set visible(e){this.viewModel.visible=e}get _portrait(){return this._width<y.getConfig().portraitModePixelBreakpoint}get _selectButtonVisible(){return!0===this.visibleElements.selectButton&&this.viewModel.selectAvailable}get _chartUpdateParams(){const e=this.view;return this._getChartUpdateParamsMemoized(this._chart,this.viewModel.chartData,null==e||e.stationary,this._chartMessages)}get _chartMessages(){return{...this.messagesUnits,...this.messages}}get _profilesArray(){return this.profiles.toArray()}render(){const{viewModel:e,visible:t}=this;return S.tsx("div",{"aria-label":this.messages.widgetLabel,class:this.classes({[u.css.base]:t,[f.globalCss.widget]:t,[f.globalCss.panel]:t,[f.globalCss.widgetDisabled]:t&&"disabled"===e.state,[u.css.portrait]:this._portrait,[u.css.refined]:1===e.progress}),key:this},S.tsx("div",{afterCreate:this._onContentWrapperUpdate,afterRemoved:this._onContentWrapperRemoved,afterUpdate:this._onContentWrapperUpdate,bind:this,key:"content-wrapper"},t?this._renderContentForState():null))}_renderContentForState(){switch(this.viewModel.state){case y.ElevationProfileState.Ready:return this._renderContentForReadyState();case y.ElevationProfileState.Selecting:return this._renderContentForSelectingState();case y.ElevationProfileState.Creating:return this._renderContentForCreatingState();case y.ElevationProfileState.Selected:return this._renderContentForSelectedState();case y.ElevationProfileState.Created:return this._renderContentForCreatedState();case y.ElevationProfileState.Disabled:return this._renderContentForReadyState()}}_renderContentForReadyState(){const{messages:e,visibleElements:t,_selectButtonVisible:r}=this,{sketchButton:s}=t;let i;return i=s&&r?e.readyPrompt:s?e.readyPromptCreateOnly:r?e.readyPromptSelectOnly:e.errors?.noProfile,this._renderContent({prompt:i,chart:!1,actions:E})}_renderContentForSelectingState(){const{view:e}=this;if(null==e)return null;const t=this.messages[`selectingPrompt-${e.type}`];return this._renderContent({prompt:t,chart:!1,actions:[{type:k.SelectCancel}]})}_renderContentForCreatingState(){const{view:e,viewModel:t}=this;if(null==e)return null;const r=t.hasVertices?[{type:k.SketchCancel},{type:k.SketchDone,disabled:!t.tool.interaction.canStopCreating}]:[{type:k.Select},{type:k.Sketch,disabled:!0}];if(t.errorState===y.ElevationProfileErrorState.NoValidInput){const t=this.messages[`creatingPrompt-${e.type}`];return this._renderContent({chart:!1,actions:r,prompt:t})}const s=this._getErrorMessage();return s?this._renderContent({chart:!1,actions:r,prompt:s}):this._renderContent({chart:!0,actions:r})}_renderContentForSelectedState(){const e=this._getErrorMessage();return e?this._renderContent({chart:!1,actions:E,prompt:e}):this._renderContent({chart:!0,actions:E})}_renderContentForCreatedState(){const e=this._getErrorMessage();return e?this._renderContent({chart:!1,actions:E,prompt:e}):this._renderContent({chart:!0,actions:E})}_getErrorMessage(){const e=M[this.viewModel.errorState];return e?this.messages?.errors?.[e]:null}_renderContent(e){const t=null!=e.prompt?this._renderPrompt(e.prompt):e.chart&&this._renderChart(),{viewModel:r}=this,s=null!=r.input;return S.tsx(S.tsxFragment,null,S.tsx("header",{class:u.css.header,key:"header"},this._zoomOutButtonVisible?this._renderZoomOutButton():null,this.visibleElements.clearButton&&s?this._renderClearButton():null,this.visibleElements.settingsButton?S.tsx(C.SettingsButton,{messages:this.messages,uniformChartScaling:r.uniformChartScaling,unit:r.unit,unitOptions:r.unitOptions,visibleElements:this.visibleElements,onUniformChartScalingChange:e=>r.uniformChartScaling=e,onUnitChange:e=>r.unit=e}):null),S.tsx("div",{class:u.css.mainContainer,key:"main-container"},t),this.visibleElements.legend?S.tsx(v.Legend,{effectiveUnits:r.effectiveUnits,messages:this.messages,profiles:this._profilesArray}):null,this._renderActions(e))}_renderZoomOutButton(){const e=this.messages.zoomOut;return S.tsx("calcite-action",{appearance:"transparent",class:u.css.zoomOutButton,"data-testid":"zoom-out-button",icon:"magnifying-glass-minus",key:"zoom-out",onclick:this._onZoomOutButtonClick,scale:"s",text:e,title:e})}_renderClearButton(){const e=this.messages.clearProfile;return S.tsx("calcite-action",{appearance:"transparent",class:u.css.clearButton,"data-testid":"clear-button",icon:"trash",key:"clear-profile",onclick:this._onClearButtonClick,scale:"s",text:e,title:e})}_renderPrompt(e){return[S.tsx("div",{bind:this,class:u.css.promptContainer,key:"prompt-container"},S.tsx("p",null,e))]}_renderChart(){if(!this.visibleElements.chart)return S.tsx("div",{class:u.css.chartContainer,key:"empty-chart-container"});const{chartData:e,progress:t}=this.viewModel,r=this._chartIsRefined||this._canRenderChart(),s=null!=e&&t<1;return r?S.tsx(S.tsxFragment,null,this._renderSpinner({size:r?"small":"large",visible:s}),S.tsx("div",{afterCreate:this._onChartContainerUpdate,afterRemoved:this._onChartContainerRemoved,afterUpdate:this._onChartContainerUpdate,bind:this,class:u.css.chartContainer,key:"chart-container"})):S.tsx(S.tsxFragment,null,this._renderSpinner({size:"large",visible:s}),S.tsx("div",{class:u.css.chartContainer,key:"chart-container-empty"}))}_renderSpinner(e){const t="small"===e.size,r=e.visible??!0;return S.tsx("calcite-loader",{class:this.classes(u.css.chartSpinner,t&&u.css.chartSpinnerSmall,r&&u.css.chartSpinnerVisible),inline:t,key:"spinner",label:"",scale:"s"})}_canRenderChart(){const e=this.viewModel.chartData;if(null==e)return!1;if(!this.viewModel.inputIsSketched)return e.refined;let t=0;for(const{samples:r}of e.lines)t+=null!=r?r.length:0;return e.refined||t<=y.getConfig().largeChartSamples}_renderActions({actions:e}){const t=e.map((e=>{switch(e.type){case k.Sketch:return this.visibleElements.sketchButton&&this._renderAction({action:e,className:u.css.sketchButton,label:this.messages.sketchButtonLabel,onClick:this._onSketchButtonClick,primary:!0});case k.SketchCancel:return this.visibleElements.sketchButton&&this._renderAction({action:e,onClick:this._onCancelButtonClick,className:u.css.sketchCancelButton,label:this.messagesCommon.cancel,primary:!1});case k.SketchDone:return this.visibleElements.sketchButton&&this._renderAction({action:e,onClick:this._onDoneButtonClick,className:u.css.sketchDoneButton,label:this.messagesCommon.done,primary:!0});case k.Select:return this._selectButtonVisible&&this._renderAction({action:e,onClick:this._onSelectButtonClick,className:u.css.selectButton,label:this.messages.selectButtonLabel,primary:!1});case k.SelectCancel:return this._selectButtonVisible&&this._renderAction({action:e,onClick:this._onCancelButtonClick,className:u.css.selectCancelButton,label:this.messagesCommon.cancel,primary:!1})}})).filter(Boolean);return t.length?S.tsx("footer",{class:u.css.footer,key:"footer"},t):null}_renderAction({action:e,className:t,label:r,onClick:s,primary:i}){return S.tsx("calcite-button",{appearance:i?"solid":"outline-fill",bind:this,class:this.classes(u.css.actionButton,t),disabled:e.disabled,key:`action-${e.type}`,onclick:s},r)}_onSketchButtonClick(){this.viewModel.start({mode:"sketch"})}_onSelectButtonClick(){this.viewModel.start({mode:"select"})}_onCancelButtonClick(){this.viewModel.cancel()}_onDoneButtonClick(){this.viewModel.stop()}_onContentWrapperUpdate(e){e!==this._contentWrapper&&(this._contentWrapper=e,this.removeHandles(P),this.addHandles(b.onResize(e,(e=>{this._width=e.contentRect.width})),P))}_onContentWrapperRemoved(){this.removeHandles(P),this._contentWrapper=null}_updateChart(e){const{data:t,chart:r,messages:s,stationary:i}=e;null!=r&&null!=s&&i&&this._canRenderChart()&&(r.update(e),this._chartIsRefined=null!=t&&t.refined)}_onChartContainerUpdate(e){this._chartContainer=e}_onChartContainerRemoved(){this._chartContainer=null}_initializeChart(t){s.abortMaybe(this._chartInitTask),this._chartInitTask=r.createTask((async r=>{const{createChart:i}=await new Promise(((t,r)=>e(["./ElevationProfile/support/chartUtils"],t,r)));o.throwIfAborted(r);const n=await i({container:t,abortOptions:{signal:r},onRangeChange:(e,t)=>{this._zoomOutButtonVisible=1!==e||1!==t},onCursorPositionChange:e=>{this.viewModel.hoveredChartPosition=e}});if(r.aborted)throw s.destroyMaybe(n),o.createAbortError();this._chart=n,this._updateChart(this._chartUpdateParams)}))}_destroyChart(){this._chartInitTask=s.abortMaybe(this._chartInitTask),this._chart=s.destroyMaybe(this._chart),this._chartIsRefined=!1}};t.__decorate([a.property({type:_})],B.prototype,"viewModel",void 0),t.__decorate([a.property()],B.prototype,"view",null),t.__decorate([a.property()],B.prototype,"input",null),t.__decorate([a.property()],B.prototype,"profiles",null),t.__decorate([a.property()],B.prototype,"unitOptions",null),t.__decorate([a.property()],B.prototype,"unit",null),t.__decorate([a.property()],B.prototype,"geodesicDistanceThreshold",null),t.__decorate([a.property({type:m,nonNullable:!0})],B.prototype,"visibleElements",void 0),t.__decorate([a.property()],B.prototype,"icon",null),t.__decorate([a.property()],B.prototype,"label",null),t.__decorate([a.property()],B.prototype,"visible",null),t.__decorate([a.property(),w.messageBundle("esri/widgets/ElevationProfile/t9n/ElevationProfile")],B.prototype,"messages",void 0),t.__decorate([a.property(),w.messageBundle("esri/t9n/common")],B.prototype,"messagesCommon",void 0),t.__decorate([a.property(),w.messageBundle("esri/core/t9n/Units")],B.prototype,"messagesUnits",void 0),t.__decorate([a.property()],B.prototype,"_contentWrapper",void 0),t.__decorate([a.property()],B.prototype,"_chartContainer",void 0),t.__decorate([a.property()],B.prototype,"_chart",void 0),t.__decorate([a.property()],B.prototype,"_chartInitTask",void 0),t.__decorate([a.property()],B.prototype,"_chartIsRefined",void 0),t.__decorate([a.property()],B.prototype,"_width",void 0),t.__decorate([a.property()],B.prototype,"_portrait",null),t.__decorate([a.property()],B.prototype,"_zoomOutButtonVisible",void 0),t.__decorate([a.property()],B.prototype,"_selectButtonVisible",null),t.__decorate([a.property()],B.prototype,"_chartUpdateParams",null),t.__decorate([a.property()],B.prototype,"_chartMessages",null),t.__decorate([a.property()],B.prototype,"_profilesArray",null),B=t.__decorate([d.subclass("esri.widgets.ElevationProfile")],B);return B}));
