/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../chunks/tslib.es6","../../Graphic","../../core/Accessor","../../core/asyncUtils","../../core/handleUtils","../../core/has","../../core/maybe","../../core/promiseUtils","../../core/reactiveUtils","../../core/accessorSupport/decorators/property","../../core/Logger","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../../layers/GraphicsLayer","../../symbols/CIMSymbol","../../symbols/SimpleLineSymbol","../../views/input/InputManager","./support/geometryUtils","../Sketch/SketchViewModel"],(function(t,e,i,s,a,n,o,r,l,c,h,p,d,u,_,y,v,g,S,I){"use strict";var m,b;function f(t){return"2d"===t?new y({data:{type:"CIMSymbolReference",symbol:{type:"CIMLineSymbol",symbolLayers:[{type:"CIMSolidStroke",effects:[{type:"CIMGeometricEffectDashes",dashTemplate:[5,4],lineDashEnding:"FullGap",controlPointEnding:"NoConstraint"}],enable:!0,capStyle:"Butt",joinStyle:"Round",width:1.5,color:[0,0,0,255]},{type:"CIMSolidStroke",enable:!0,capStyle:"Butt",joinStyle:"Round",width:1.5,color:[255,255,255,255]}]}}}):new v({color:[0,0,0,0]})}function k(t){if(S.isPolyline(t)){const e=t.clone();return e.paths=[e.paths[0].slice(0,-1)],e}return t}t.State=void 0,(m=t.State||(t.State={})).Ready="ready",m.Creating="creating",m.Reshaping="reshaping",m.ReshapingDisabled="reshaping-disabled",m.Selecting="selecting",m.Selected="selected",function(t){t.View="view",t.Main="main",t.Interaction="interaction"}(b||(b={})),t.ElevationProfileInteraction=class extends s{constructor(e){super(e),this.state=t.State.Ready,this._pendingStartOptions=null,this._previousInputInfo=null,this._shouldRemoveLastPoint=!1,this._sketchedGraphics=new WeakSet,this._creationToolPromise=null,this._updateToolPromise=null,this._updateDisabled=!1}initialize(){this.addHandles(c.watch((()=>({view:this.tool.viewModel.view,visible:this.tool.visible})),(({view:t,visible:e})=>{null!=t&&e?this._attach(t):this._detach()}),c.syncAndInitial),b.View)}destroy(){this._detach()}get canStopCreating(){const t=this._geometry,e=this._shouldRemoveLastPoint?3:2;return S.isPolyline(t)&&t.paths.length>0&&t.paths[0].length>=e}get _input(){return this.tool.viewModel.input}set _input(t){this.tool.viewModel.input=t}get _geometry(){return this._input?.geometry}get _visibleAndEditable(){return this.tool.visible&&this.tool.editable}get _view(){return this.tool.viewModel.view}get test(){}start(e={mode:"sketch"}){if(!this.tool.editable)return;const i=this._view;if(null!=i&&i.ready)switch(this._pendingStartOptions=null,this._stopInteraction(),null==this._previousInputInfo&&this._storePreviousInput(this._input),this._setSketchedGraphic(null),e.mode){case"sketch":this._set("state",t.State.Creating),this._startCreationInteraction();break;case"select":this._set("state",t.State.Selecting),this._startSelectionInteraction()}else this._pendingStartOptions=e}stop(){this._pendingStartOptions=null,this._stopInteractionAndUpdate(),this._clearPreviousInput()}cancel(){this._pendingStartOptions=null,this._stopInteractionAndUpdate(),this._restorePreviousInput()}clear(){this._stopInteractionAndUpdate(),this._set("state",t.State.Ready),this._clearPreviousInput(),this._input=null,this._pendingStartOptions=null}isSketchedGraphic(t){return null!=t&&this._sketchedGraphics.has(t)}_attach(t){this._detach();const e={mode:"3d"===t.type?"relative-to-ground":"on-the-ground",offset:null};this._graphicsLayer=new _({listMode:"hide",internal:!0,elevationInfo:e});const i=f(t.type);this._sketchVM=new I({layer:this._graphicsLayer,view:t,defaultCreateOptions:{mode:"click",hasZ:!1},updateOnGraphicClick:!1,defaultUpdateOptions:{reshapeOptions:{shapeOperation:"none"},enableRotation:!1,enableScaling:!1,enableMoveAllGraphics:!1,enableZ:!1,multipleSelectionEnabled:!1,toggleToolOnClick:!1,tool:"reshape"},polylineSymbol:i,activeLineSymbol:i}),this.addHandles([c.when((()=>t.ready),(()=>{const t=this._pendingStartOptions;t&&this.start(t)}),c.syncAndInitial),c.watch((()=>[this._input,this._visibleAndEditable]),(()=>this._update()),c.syncAndInitial),c.watch((()=>({map:t.map,graphicsLayer:this._graphicsLayer})),(({map:t,graphicsLayer:e})=>{null!=t&&null!=e&&t.add(e),this._update()}),c.syncAndInitial)],b.Main)}_detach(){this.removeHandles(b.Main),this._sketchVM=r.destroyMaybe(this._sketchVM),this._creationToolPromise=null,this._updateToolPromise=null;const e=this._view?.map,i=this._graphicsLayer;null!=e&&null!=i&&e.remove(i),this._graphicsLayer=r.destroyMaybe(this._graphicsLayer),this._shouldRemoveLastPoint=!1,this._set("state",t.State.Ready)}_startCreationInteraction(){this._stopInteractionAndUpdate();const t=this._view,e=this._sketchVM;if(null==t||null==e)return;this._shouldRemoveLastPoint=!1;const s=e.on("create",(t=>{const e=t.graphic;switch(t.state){case"complete":this._shouldRemoveLastPoint=!1,this._setSketchedGraphic(e),this._stopInteractionAndUpdate(),this._clearPreviousInput();break;case"cancel":this.cancel();break;case"active":this._setSketchedGraphic(e),"cursor-update"===t.toolEventInfo?.type&&(this._shouldRemoveLastPoint=!0);break;case"start":this._setSketchedGraphic(e)}})),a=()=>{s.remove();const t=this.canStopCreating,a=this._geometry?.clone();e.cancel(),this._creationToolPromise=null,null!=a&&t?this._shouldRemoveLastPoint&&this._setSketchedGraphic(new i({geometry:k(a)})):this._input=null};this.removeHandles(b.Interaction),this.addHandles(n.makeHandle(a),b.Interaction),this._creationToolPromise=l.ignoreAbortErrors(e.create("polyline"))}_startReshapeInteraction(){this._stopInteraction();const t=this._view,e=this._sketchVM;if(null==t||null==e)return;const i=e.on("update",(t=>{const e=t.graphics[0];switch(t.state){case"complete":this._setSketchedGraphic(e),this._stopInteractionAndUpdate(),this._clearPreviousInput();break;case"active":case"start":this._setSketchedGraphic(e)}})),s=()=>{i.remove(),e.cancel(),this._updateToolPromise=null};this.removeHandles(b.Interaction),this.addHandles(n.makeHandle(s),b.Interaction);const a=this._input;a&&(a.visible=!0,this._updateToolPromise=l.ignoreAbortErrors(e.update(a,{tool:"reshape"})))}_startSelectionInteraction(){this._stopInteraction();const t=this._view;if(null==t)return;const e=t.cursor,i=n.makeHandle((()=>t.cursor=e));t.cursor="crosshair",t.closePopup();let s=null;const o=n.makeHandle((()=>r.abortMaybe(s))),c=t.on("immediate-click",(e=>{e.async((async()=>{r.abortMaybe(s),s=a.createTask((async i=>{const{results:s}=await t.hitTest(e);l.throwIfAborted(i);const a=s.filter((t=>"graphic"===t.type)).map((t=>t.graphic)).find((t=>null!=t.geometry&&"polyline"===t.geometry.type));a&&(e.preventDefault(),e.stopPropagation(),this._input=a,this._clearPreviousInput(),this._stopInteractionAndUpdate())})),await s.promise}))}),g.ViewEventPriorities.TOOL),h=t.on("key-down",(t=>{"Escape"===t.key&&this.cancel()}));this.removeHandles(b.Interaction),this.addHandles([c,h,o,i],b.Interaction),t.ready&&t.focus()}_stopInteraction(){this.removeHandles(b.Interaction)}_stopInteractionAndUpdate(){this.hasHandles(b.Interaction)&&(this._updateDisabled=!0,this._stopInteraction(),this._updateDisabled=!1,this._triggerUpdate())}_triggerUpdate(){this._set("state",t.State.Ready),this._update()}_update(){if(this._updateDisabled)return;const e=this.state;if(e!==t.State.Selecting){if(this._visibleAndEditable){if(e===t.State.Creating||e===t.State.Reshaping&&this.isSketchedGraphic(this._input))return}else this.cancel();this._set("state",this._getNextState()),this._updateVisuals()}else this.stop()}_getNextState(){return null==this._input?t.State.Ready:this.isSketchedGraphic(this._input)?this.state===t.State.Creating?t.State.Creating:this._visibleAndEditable?t.State.Reshaping:t.State.ReshapingDisabled:t.State.Selected}_updateVisuals(){switch(this.state){case t.State.Creating:break;case t.State.Reshaping:this._startReshapeInteraction();break;case t.State.ReshapingDisabled:{this._stopInteractionAndUpdate();const t=this._input;null!=t&&this.isSketchedGraphic(t)&&(t.visible=!1);break}case t.State.Ready:case t.State.Selected:this._stopInteractionAndUpdate();case t.State.Selecting:}this._updateSketchedGraphic()}_storePreviousInput(t){this._previousInputInfo={graphic:t}}_restorePreviousInput(){const t=this._previousInputInfo;null!=t&&(this._clearPreviousInput(),this._input=t.graphic,this._triggerUpdate())}_clearPreviousInput(){this._previousInputInfo=null}_updateSketchedGraphic(){const t=this._graphicsLayer;if(null==t)return;const e=t.graphics,i=this._input;if(null==i||!this.isSketchedGraphic(i))return void e.removeAll();if(-1===e.indexOf(i))e.removeAll(),e.add(i);else if(1!==e.length){const t=e.filter((t=>t!==i));e.removeMany(t)}}_setSketchedGraphic(t){null!=t&&this._sketchedGraphics.add(t),this._input=t,this._updateSketchedGraphic()}},e.__decorate([h.property({nonNullable:!0})],t.ElevationProfileInteraction.prototype,"state",void 0),e.__decorate([h.property({nonNullable:!0})],t.ElevationProfileInteraction.prototype,"tool",void 0),e.__decorate([h.property()],t.ElevationProfileInteraction.prototype,"canStopCreating",null),e.__decorate([h.property()],t.ElevationProfileInteraction.prototype,"_graphicsLayer",void 0),e.__decorate([h.property()],t.ElevationProfileInteraction.prototype,"_sketchVM",void 0),e.__decorate([h.property()],t.ElevationProfileInteraction.prototype,"_input",null),e.__decorate([h.property()],t.ElevationProfileInteraction.prototype,"_geometry",null),e.__decorate([h.property()],t.ElevationProfileInteraction.prototype,"_visibleAndEditable",null),e.__decorate([h.property()],t.ElevationProfileInteraction.prototype,"_view",null),e.__decorate([h.property()],t.ElevationProfileInteraction.prototype,"_shouldRemoveLastPoint",void 0),t.ElevationProfileInteraction=e.__decorate([u.subclass("esri.widgets.ElevationProfile.ElevationProfileInteraction")],t.ElevationProfileInteraction),Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
