/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../Graphic","../../core/Accessor","../../core/arrayUtils","../../core/ByteSizeUnit","../../core/Collection","../../core/collectionUtils","../../core/deprecate","../../core/Logger","../../core/LRUCache","../../core/maybe","../../core/memoize","../../core/reactiveUtils","../../core/unitUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/accessorSupport/decorators/subclass","../../layers/support/ElevationQueryTileCache","../../properties/defaultUnit","./ElevationProfileController","./ElevationProfileLineGround","./elevationProfileLineTypes","./ElevationProfileTool","./support/constants","./support/geometryUtils","./support/ProfileGenerationError","./support/profileUtils","./support/statisticsUtils"],(function(e,t,r,i,o,l,n,s,a,p,u,c,h,d,y,f,_,v,g,m,E,P,b,U,S,C,w,O){"use strict";let T=class extends r{constructor(e){super(e),this.view=null,this.input=null,this._getEffectiveUnitsMemoized=c.memoize(((e,t)=>({distance:e,elevation:t}))),this.hoveredChartPosition=null,this.uniformChartScaling=!1,this.defaultUnit=null,this.queue=null,this._currentTileCache=null,this.error=null,this._defaultProfileLineGround=new E,this._userUnitOptions=null,this._userUnit=null,e?.profiles||(this.profiles=new l([this._defaultProfileLineGround]))}initialize(){this.addHandles(h.watch((()=>this.view),(e=>{if(null==e)return void a.getLogger(this).warnOnce("no view. Widget will be disabled until a view is provided.");this.removeHandles(D);const t="3d"===e.type?e.resourceController:void 0;this.queue?.destroy(),this.queue=w.createProfileQueue(t?.scheduler);const r=t?.addUpdatingObject(this);r&&this.addHandles(r,D)}),h.syncAndInitial)),this.tool=new b.ElevationProfileTool({viewModel:this}),this._controller=new m.ElevationProfileController({viewModel:this})}destroy(){this._defaultProfileLineGround=u.destroyMaybe(this._defaultProfileLineGround),this._controller=u.destroyMaybe(this._controller),this._currentTileCache=u.destroyMaybe(this._currentTileCache),this.tool=u.destroyMaybe(this.tool),this.queue=u.destroyMaybe(this.queue)}get profiles(){return this._get("profiles")}set profiles(e){const t=this._get("profiles"),r=e??new l;this._set("profiles",n.referenceSetter(r,t))}get state(){const e=this.view;return null!=e&&e.ready?this.tool.state:U.ElevationProfileState.Disabled}get progress(){let e=0,t=0;for(const r of this.visibleProfiles)e++,t+=r.progress;return e>0?t/e:0}set unitOptions(e){this._userUnitOptions=e,this._set("unitOptions",this._filteredOrAllUnits(this._userUnitOptions))}get unitOptions(){return this._filteredOrAllUnits(this._userUnitOptions)}set unit(e){this._userUnit=e?this._findSelectableUnit(e,this._userUnit):null,this.notifyChange("unit")}get unit(){return this._userUnit?(this._userUnit=this._findSelectableUnit(this._userUnit,this.defaultUnit),this._userUnit):this._findSelectableUnit(this.defaultUnit)}get effectiveUnits(){const e=O.getBoundsInMeters(this.visibleProfiles.map((e=>e.result))),t=d.adaptiveLengthUnit(e.maxDistance,"meters",this.unit),r=d.adaptiveVerticalLengthUnit(e.maxElevation,"meters",this.unit);return this._getEffectiveUnitsMemoized(t,r)}get geodesicDistanceThreshold(){return this._get("geodesicDistanceThreshold")}set geodesicDistanceThreshold(e){s.deprecatedProperty(a.getLogger(this),"geodesicDistanceThreshold",{version:"4.29",warnOnce:!0}),this._set("geodesicDistanceThreshold",e)}get highlightEnabled(){return this.tool.highlightEnabled}set highlightEnabled(e){this.tool.highlightEnabled=e}get hasVertices(){const e=this.input?.geometry;return S.isPolyline(e)&&e.paths.reduce(((e,t)=>e+t.length),0)>0}get hoveredPoints(){return null!=this.input&&this.visible&&this.tool.editable?this.visibleProfiles.map((e=>{const t=e.hoveredPoint;return null!=t?{hoveredPoint:t,color:e.color}:null})).filter(i.isSome):[]}get statistics(){return O.mergeStatistics(this.visibleProfiles.map((e=>e.statistics)))}get chartData(){if(null==this.input)return null;const{effectiveUnits:e,progress:t,statistics:r,visibleProfiles:i,uniformChartScaling:o}=this,l=i.filter((e=>e.hasZ)).map((e=>({id:e.id,type:e.type,title:e.title,color:e.color,samples:e.samples,progress:e.progress,chartFillEnabled:e.chartFillEnabled,chartStrokeWidth:e.chartStrokeWidth,chartStrokeOffsetY:e.chartStrokeOffsetY,viewVisualizationEnabled:e.viewVisualizationEnabled})));return 0===l.length?null:{lines:l,effectiveUnits:e,statistics:r,refined:1===t,dynamicElevationRange:i.some((e=>"view"===e.type)),uniformScaling:o}}get visibleProfiles(){return this.profiles.toArray().filter((e=>e.available&&e.visible))}get minDemResolutions(){const e=[];for(const{minDemResolution:t}of this.visibleProfiles)null!=t&&e.push(t);return e}get minDemResolution(){return i.min(this.minDemResolutions)}get errorState(){const e=this.input?.geometry;if(!S.isValidInputPath(e))return U.ElevationProfileErrorState.NoValidInput;if(null!=this.error){if(C.isProfileGenerationError(this.error))switch(this.error.cause){case C.ProfileGenerationErrorCause.TooComplex:return U.ElevationProfileErrorState.TooComplex;case C.ProfileGenerationErrorCause.InvalidGeometry:return U.ElevationProfileErrorState.InvalidGeometry;case C.ProfileGenerationErrorCause.InvalidElevationInfo:return U.ElevationProfileErrorState.InvalidElevationInfo;case C.ProfileGenerationErrorCause.ElevationQueryError:return U.ElevationProfileErrorState.NoValidInput}return U.ElevationProfileErrorState.UnknownError}return 0===this.visibleProfiles.length?U.ElevationProfileErrorState.NoVisibleProfiles:null==this.chartData&&1===this.progress?U.ElevationProfileErrorState.RefinedButNoChartData:U.ElevationProfileErrorState.None}get tileCache(){this._currentTileCache=u.destroyMaybe(this._currentTileCache);const e=this.view;if(null!=e&&"3d"===e?.type){const t=e.basemapTerrain?.elevationQueryCache;if(null!=t)return t}return null==this._currentTileCache&&(this._currentTileCache=new v.ElevationQueryTileCache(new p.LRUCache(20*o.ByteSizeUnit.MEGABYTES))),this._currentTileCache}get visible(){return this.tool.visible}set visible(e){this.tool.visible=e}get selectAvailable(){for(const e of this.view?.map?.allLayers??[]){if("graphics"===e.type&&!e.internal&&e.graphics.some((e=>"polyline"===e.geometry?.type)))return!0;if("geometryType"in e&&"polyline"===e.geometryType)return!0}return!!this.view?.graphics?.some((e=>"polyline"===e.geometry?.type))}get inputIsSketched(){return this.tool.interaction.isSketchedGraphic(this.input)}get elevationProvider(){const e=this.view;return null!=e&&"3d"===e.type?e.elevationProvider:null}get updating(){const{progress:e}=this,t=!!this.queue?.updating;return e>0&&e<1||t}start(e){this.tool.interaction.start(e)}stop(){this.tool.interaction.stop()}cancel(){this.tool.interaction.cancel()}clear(){this.tool.interaction.clear()}_findSelectableUnit(e,t){const r=this.unitOptions;return null!=e&&r.includes(e)?e:t?this._findSelectableUnit(t):r[0]}_filteredOrAllUnits(e){const t=(null!=e?e:[]).filter((e=>d.measurementLengthUnits.includes(e)));return 0===t.length?d.measurementLengthUnits.slice():t}};e.__decorate([y.property()],T.prototype,"view",void 0),e.__decorate([y.property({type:t})],T.prototype,"input",void 0),e.__decorate([y.property({type:P.ElevationProfileLineCollection,nonNullable:!0})],T.prototype,"profiles",null),e.__decorate([y.property({readOnly:!0})],T.prototype,"state",null),e.__decorate([y.property({readOnly:!0})],T.prototype,"progress",null),e.__decorate([y.property()],T.prototype,"unitOptions",null),e.__decorate([y.property()],T.prototype,"unit",null),e.__decorate([y.property({readOnly:!0})],T.prototype,"effectiveUnits",null),e.__decorate([y.property()],T.prototype,"geodesicDistanceThreshold",null),e.__decorate([y.property()],T.prototype,"hoveredChartPosition",void 0),e.__decorate([y.property()],T.prototype,"uniformChartScaling",void 0),e.__decorate([y.property()],T.prototype,"highlightEnabled",null),e.__decorate([y.property({readOnly:!0})],T.prototype,"hoveredPoints",null),e.__decorate([y.property({readOnly:!0})],T.prototype,"statistics",null),e.__decorate([y.property()],T.prototype,"chartData",null),e.__decorate([y.property()],T.prototype,"visibleProfiles",null),e.__decorate([y.property()],T.prototype,"minDemResolutions",null),e.__decorate([y.property({readOnly:!0})],T.prototype,"minDemResolution",null),e.__decorate([y.property({readOnly:!0})],T.prototype,"errorState",null),e.__decorate([y.property(g.defaultUnitPropertyMetadata)],T.prototype,"defaultUnit",void 0),e.__decorate([y.property()],T.prototype,"queue",void 0),e.__decorate([y.property()],T.prototype,"tileCache",null),e.__decorate([y.property()],T.prototype,"tool",void 0),e.__decorate([y.property()],T.prototype,"visible",null),e.__decorate([y.property()],T.prototype,"error",void 0),e.__decorate([y.property()],T.prototype,"selectAvailable",null),e.__decorate([y.property()],T.prototype,"inputIsSketched",null),e.__decorate([y.property()],T.prototype,"elevationProvider",null),e.__decorate([y.property()],T.prototype,"updating",null),e.__decorate([y.property()],T.prototype,"_defaultProfileLineGround",void 0),e.__decorate([y.property()],T.prototype,"_userUnitOptions",void 0),e.__decorate([y.property()],T.prototype,"_controller",void 0),e.__decorate([y.property()],T.prototype,"_userUnit",void 0),T=e.__decorate([_.subclass("esri.widgets.ElevationProfile.ElevationProfileViewModel")],T);const D=Symbol("updating-object");return T}));
