/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../chunks/ResponsiveTheme","../../../intl","../../../core/handleUtils","../../../core/promiseUtils","../../../core/signal","../../../core/unitFormatUtils","../../../core/unitUtils","../../../core/libs/gl-matrix-2/math/common","./constants","./intlUtils","./niceScale","./profileUtils","../../../chunks/chartUtilsAm5","../../support/widgetUtils","../../../support/themeUtils","../../../chunks/LineSeries","../../../chunks/Theme","../../../chunks/Tooltip","../../../intl/substitute","../../../intl/number"],(function(e,t,i,n,o,s,a,l,r,d,c,u,p,x,m,f,g,h,A,v,b){"use strict";const T="#f8f8f8",y="#a9a9a9",L="#323232",M="line",S="fill",F=15,k=12,C=.001,P=.1,X=.02,Y={fontFamily:"Avenir Next",paddingBottom:k/2,paddingLeft:0,paddingRight:0,paddingTop:0,axisGridStroke:"#f4f4f4",axisLabelsFontSize:9,axisLabelsFontWeight:"400",axisLabelsColor:y,axisTooltipFontSize:12,axisTooltipBackgroundColor:L,axisTooltipLabelColor:T,axisTooltipPaddingTop:Math.round(k/4),axisTooltipPaddingBottom:Math.round(k/4),axisTooltipPaddingHorizontal:Math.round(F/4),xAxisMinGridDistance:50,xAxisLabelsSpacing:Math.round(k/2),xAxisMinLabelPosition:.05,xAxisMaxLabelPosition:.9,yAxisMinGridDistance:30,yAxisLabelSpacing:Math.round(F/4),yAxisMinLabelPosition:0,yAxisMaxLabelPosition:.8,seriesTooltipFontSize:12,seriesTooltipBackgroundColor:T,seriesTooltipLabelColor:L,seriesFillLighten:.9,seriesTooltipSpacing:k/2,seriesTooltipPaddingVertical:Math.round(F/4),seriesTooltipPaddingHorizontal:Math.round(F/4)},z={...Y,axisGridStroke:L,axisLabelsColor:y,axisTooltipBackgroundColor:L,axisTooltipLabelColor:T,seriesTooltipBackgroundColor:L,seriesTooltipLabelColor:T,seriesFillLighten:-.75},w={minX:void 0,maxX:void 0,minY:void 0,maxY:void 0};async function R(e){const i=await x.createRoot(e.container);o.throwIfAborted(e.abortOptions);const a=f.isDarkTheme(),l=a?z:Y;i.setThemes(a?[t.ResponsiveTheme.new(i),t.DarkTheme.new(i)]:[t.ResponsiveTheme.new(i)]);const r=m.isRTL(e.container),d=i.container.children.push(g.XYChart.new(i,{panX:!0,panY:!0,paddingTop:l.paddingTop,paddingBottom:l.paddingBottom,paddingLeft:r?l.paddingRight:l.paddingLeft,paddingRight:r?l.paddingLeft:l.paddingRight,maxTooltipDistance:0}));d.zoomOutButton.set("forceHidden",!0);const c=d.xAxes.push(g.ValueAxis.new(i,{renderer:g.AxisRendererX.new(i,{})})),u=d.yAxes.push(g.ValueAxis.new(i,{renderer:g.AxisRendererY.new(i,{})})),p=s.signal(null),h=s.signal("loading"),A={params:e,chart:d,xAxis:c,yAxis:u,seriesInfos:new Map,messages:null,theme:l,pointerIsOver:!1,get state(){return h.value},get data(){return p.value},set data(e){p.value=e}};B(A),D(A),U(A);const v=n.handlesGroup([J(A,e.onRangeChange),Q(A,e.onCursorPositionChange),ce(i.events.once("frameended",(()=>{h.value="ready"}))),ce(i)]);return{destroy:()=>{v.remove(),h.value="destroyed"},update:e=>{e.data===A.data&&e.messages===A.messages||H(A)||G(A,e)},zoomOut:()=>O(A)}}function H(e){return"destroyed"===e.state}function U({chart:e,xAxis:t,yAxis:i}){const n=g.XYCursor.new(e.root,{behavior:"none",xAxis:t,yAxis:i});n.lineY.set("visible",!1),e.set("cursor",n)}function B(e){const{chart:t,xAxis:i,theme:n}=e;i.setAll({extraMax:0,extraMin:0,maxDeviation:0,numberFormatter:se(e,"distance"),strictMinMax:!0,strictMinMaxSelection:!0}),i.axisHeader.set("forceHidden",!0);const o=i.get("renderer");o.setAll({inside:!1,minGridDistance:n.xAxisMinGridDistance}),o.labels.template.setAll({centerX:h.p0,centerY:h.p0,fill:h.color(n.axisLabelsColor),fontFamily:n.fontFamily,fontSize:n.axisLabelsFontSize,fontWeight:n.axisLabelsFontWeight,maxPosition:n.xAxisMaxLabelPosition,minPosition:n.xAxisMinLabelPosition,paddingLeft:0,paddingRight:0,paddingTop:n.xAxisLabelsSpacing});const s=i.set("tooltip",A.Tooltip.new(t.root,{paddingBottom:0,paddingLeft:0,paddingRight:0,paddingTop:0}));s.get("background")?.setAll({fill:h.color(n.axisTooltipBackgroundColor),stroke:void 0}),s.label.setAll({fill:h.color(n.axisTooltipLabelColor),fontFamily:n.fontFamily,fontSize:n.axisTooltipFontSize,paddingBottom:n.axisTooltipPaddingBottom,paddingLeft:n.axisTooltipPaddingHorizontal,paddingRight:n.axisTooltipPaddingHorizontal,paddingTop:n.axisTooltipPaddingTop}),o.grid.template.setAll({strokeOpacity:1,stroke:h.color(n.axisGridStroke)})}function D(e){const{yAxis:t,theme:i}=e;t.setAll({baseValue:d.getConfig().noDataValue,extraMax:0,extraMin:0,maxDeviation:0,numberFormatter:se(e,"elevation"),strictMinMax:!0,strictMinMaxSelection:!0,tooltip:void 0}),t.axisHeader.set("visible",!1);const n=m.isRTL(e.params.container),o=t.get("renderer");o.setAll({minGridDistance:i.yAxisMinGridDistance,opposite:n,inside:!0}),o.labels.template.setAll({centerX:h.p0,centerY:h.p100,fill:h.color(i.axisLabelsColor),fontFamily:i.fontFamily,fontSize:i.axisLabelsFontSize,fontWeight:i.axisLabelsFontWeight,maxPosition:i.yAxisMaxLabelPosition,minPosition:i.yAxisMinLabelPosition,paddingBottom:0,paddingLeft:n?0:i.yAxisLabelSpacing,paddingRight:n?i.yAxisLabelSpacing:0,paddingTop:0,textAlign:"start"}),o.grid.template.setAll({strokeOpacity:1,stroke:h.color(i.axisGridStroke)})}function G(e,t){if(H(e))return;const i=e.data??void 0,n=t.data??void 0;e.chart.get("cursor")?.set("forceHidden",!n?.refined);const o=i!==n,s=i?.effectiveUnits!==n?.effectiveUnits,a=i?.uniformScaling!==n?.uniformScaling;e.data=n,e.messages=t.messages,(o||s)&&(W(e),$(e)),a&&O(e),ee(e)}function O(e){H(e)||(e.xAxis.zoom(0,1),e.yAxis.zoom(0,1))}function W(e){const{chart:t,data:i,xAxis:n,yAxis:o}=e,{minX:s,maxX:a,minY:l,maxY:r}=V({data:i,pixelWidth:n.width(),pixelHeight:o.height()}),d=!!i?.uniformScaling,c=!!i?.refined;t.setAll({panX:!0,panY:d,pinchZoomX:c,pinchZoomY:c&&d,wheelX:"panX",wheelY:c?d?"zoomXY":"zoomX":"none"}),n.setAll({max:a,min:s,panX:!0,panY:!1,zoomX:!0,zoomY:d}),o.setAll({max:r,min:l,panX:!1,panY:d,zoomX:d,zoomY:d})}function V({data:e,pixelWidth:t,pixelHeight:i}){if(null==e)return w;const n=e.statistics,o=0,s=n?.maxDistance;let a=n?.minElevation,r=n?.maxElevation;if(null==s||null==a||null==r)return w;const c=Math.max(s-o,C);let p=Math.max(r-a,C);const x=e.effectiveUnits;if(e.dynamicElevationRange){const e=l.convertUnit(c,x.distance,x.elevation);p=Math.max(p,e/d.getConfig().maxChartRatio)}return a-=X*p,r=a+p+P*p,[a,r]=u.niceScale(a,r,10),p=r-a,e.uniformScaling?E({data:e,bounds:{minX:o,maxX:s,minY:a,maxY:r},pixelWidth:t,pixelHeight:i,centered:!0}):{minX:o,maxX:o+c,minY:a,maxY:a+p}}function E({data:e,bounds:t,pixelWidth:i,pixelHeight:n,centered:o}){if(null==e)return t;let{minX:s,maxX:a,minY:r,maxY:d}=t;if(null==s||null==a||null==r||null==d)return w;const c=a-s,u=d-r,p=e.effectiveUnits,x=l.convertUnit(u,p.elevation,p.distance)/n/(c/i);return x>=1?[s,a]=I([s,a],x,o):[r,d]=I([r,d],1/x,o),{minX:s,maxX:a,minY:r,maxY:d}}function I([e,t],i,n){const o=(t-e)*i;if(n){const i=(e+t)/2-o/2;return[i,i+o]}return[e,e+o]}function $(e){const{chart:t,data:i,seriesInfos:n,xAxis:o,yAxis:s}=e;if(null==i||0===i.lines.length)return void t.series.clear();const a=new Map,l=new Set(t.series.values),r=i.lines.length;for(let d=0;d<r;d++){const o=i.lines[d];let s=n.get(o.id);s?(s.fill&&l.delete(s.fill),l.delete(s.line)):(s=j(e,o),s.fill&&t.series.push(s.fill),t.series.push(s.line)),a.set(s.id,s);const c=r-d-1;s.fill?.set("layer",c),s.line.set("layer",r+c),N(e,s,o)}e.seriesInfos=a;for(const d of l)t.series.removeValue(d);o.set("layer",r+1),s.set("layer",r+2)}function N({theme:e},t,i){const n=h.color(i.color.toCss()),o=i.samples??[],s=o.length>0,{line:a,fill:l}=t;a.set("visible",s),a.set("stroke",n),l?.set("visible",s),l?.set("fill",h.Color.lighten(n,e.seriesFillLighten)),a.data.setAll(o),l?.data.setAll(o)}function j(e,t){const{id:i}=t,n=Z(e,`${M}-${i}`);n.setAll({dy:t.chartStrokeOffsetY,tooltip:q(e)}),n.strokes.template.setAll({strokeWidth:t.chartStrokeWidth});let o=null;return t.chartFillEnabled&&(o=Z(e,`${S}-${i}`),o.fills.template.setAll({fillOpacity:1,visible:!0})),{id:i,line:n,fill:o}}function Z(e,t){return g.LineSeries.new(e.chart.root,{connect:!1,excludeFromTotal:!0,fill:void 0,id:t,stroke:void 0,valueXField:"distance",valueYField:"elevation",xAxis:e.xAxis,yAxis:e.yAxis})}function q({theme:e,chart:t}){const i=A.Tooltip.new(t.root,{autoTextColor:!1,forceHidden:!0,getFillFromSprite:!1,getLabelFillFromSprite:!1,pointerOrientation:"vertical",visible:!1}),n=e.seriesTooltipPaddingHorizontal,o=e.seriesTooltipPaddingVertical;return i.label.setAll({fill:h.color(e.seriesTooltipLabelColor),fontFamily:e.fontFamily,fontSize:e.seriesTooltipFontSize,paddingBottom:o,paddingLeft:n,paddingRight:n,paddingTop:o,textAlign:"start"}),i.get("background")?.setAll({stroke:void 0,fill:h.color(e.seriesTooltipBackgroundColor)}),i.adapters.add("dy",(t=>{const n=e.seriesTooltipSpacing,o=i.get("pointTo")?.y??0;return(t??0)+(i.y()>o?n:-n)})),i}function J(e,t){const{xAxis:i,yAxis:n}=e,o=()=>{t(K(i),K(n))},s=e=>[e.on("start",o),e.on("end",o)];return de([...s(i),...s(n)])}function K(e){const t=Math.abs((e.get("end")??0)-(e.get("start")??0)),i=0!==t?1/t:1;return Math.abs(1-i)<r.getEpsilon()?1:i}function Q(e,t){const{chart:i,xAxis:n,yAxis:o}=e,s=i.get("cursor"),a=i.plotContainer.events,l=t=>{e.pointerIsOver=t,ee(e)},r=()=>{l(!1),t(null,null)};return de([s?.events.on("cursormoved",(()=>{if(!e.pointerIsOver)return;ee(e);let i=s?.getPrivate("positionX")??0,a=s?.getPrivate("positionY")??0;const l=e.data;if(null!=l?.statistics){const{maxDistance:e,minElevation:t,maxElevation:s}=l.statistics;if(null!=e){i=_(i,le(n),re(n),0,e)}if(null!=t&&null!=s){a=_(a,le(o),re(o),t,s)}}t(i,a)})),a.on("pointerover",(()=>l(!0))),a.on("pointerout",r),a.on("blur",r)])}function _(e,t,i,n,o){return(t+e*(i-t)-n)/(o-n)}function ee(e){const t=te(e);if(!t)return void e.seriesInfos.forEach((e=>{e.line.get("tooltip")?.set("forceHidden",!0)}));e.seriesInfos.forEach((e=>{const i=e.line.get("tooltip");i.set("forceHidden",!1),i.label.set("text",t)}));e.xAxis.getTooltip().setAll({tooltipText:oe(e)})}function te(e){const{data:t}=e,i=t?.lines.map((t=>({line:t,y:ae(e,t)?.elevation}))).sort(ie);return i&&0!==i.length&&null!=i[0].y?i.map((({y:t,line:i})=>ne(e,i,t))).join("\n"):null}function ie({y:e},{y:t}){return null==e?1:null==t?-1:t-e}function ne(e,t,i){const{data:n,messages:o}=e;if(null==n||null==o)return"";const s=d.getConfig().formatPrecision,l=v.substitute(o.chartTooltip,{name:c.getTranslatedLineTitle(t,o),elevation:null!=i?a.formatDecimal(o,i,n.effectiveUnits.elevation,s):d.notAvailable});return`[${t.color.toHex()}]●[/] ${l}`}function oe(e){const{data:t,messages:i}=e;if(null==t||null==i)return"";const n=t.lines[0],o=n?ae(e,n):null,s=d.getConfig().formatPrecision;return null!=o?a.formatDecimal(i,o.distance,t.effectiveUnits.distance,s):"-"}function se(e,t){const i=x.NumberFormatter.new(e.chart.root,{});return i.format=(i,n,o)=>{const{data:s,messages:l}=e;if(null==l||null==s||"string"==typeof i)return"";return`${b.formatNumber(i,{maximumFractionDigits:o})} ${a.unitName(l,s.effectiveUnits[t],"abbr")}`},i}function ae({chart:e,xAxis:t},i){const n=i.samples??[];if(0===n.length)return null;const o=e.get("cursor"),s=o?.getPrivate("positionX")??0,a=t.toAxisPosition(s),l=t.positionToValue(a);return p.binaryFindClosest(n,l,(e=>e.distance))}function le(e){return e.positionToValue(e.get("start")??0)}function re(e){return e.positionToValue(e.get("end")??1)}function de(e){return n.handlesGroup(e.map(ce))}function ce(e){return n.makeHandle((()=>{e?.dispose()}))}e.createChart=R,e.getAdjustedBounds=V,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
