/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","exports","../../../core/mathUtils","../../../core/promiseUtils","../../../core/unitUtils","../../../core/libs/gl-matrix-2/math/vec2","../../../chunks/vec32","../../../geometry/Polyline","../../../geometry/projection","../../../geometry/SpatialReference","../../../geometry/support/geodesicUtils","../../../support/elevationInfoUtils","./ProfileGenerationError"],(function(e,t,n,r,o,i,s,a,c,l,u,f,h){"use strict";async function d(t,n,i,s,a,f,d){let m,P,w;const y=t.spatialReference,R=y.isGeographic||y.isWebMercator;let v=0;if(!R){const{planarLength:n}=await new Promise(((t,n)=>e(["../../../geometry/geometryEngineAsync"],t,n)));r.throwIfAborted(d),v=await n(t,"meters"),r.throwIfAborted(d)}const S=1/o.getMetersPerUnitForSR(s),A=a.geodesicDistanceThreshold??1/0;if(R||v>=A){await c.initializeProjection([{source:y,dest:s},{source:y,dest:l.WGS84}],d);const e=x(t);m=u.geodesicLengths([e],"meters")[0];const r=p(m,a);if(I(t,m,r)>f)throw new h.ProfileGenerationError(h.ProfileGenerationErrorCause.TooComplex);const o=g(e,n,i);({densifiedPath:P,distances:w}=G(o,r,S)),P=c.project(P,s)}else{await c.initializeProjection([{source:y,dest:s}],d),m=v;const e=p(m,a);if(I(t,m,e)>f)throw new h.ProfileGenerationError(h.ProfileGenerationErrorCause.TooComplex);const o=g(t,n,i);({densifiedPath:P,distances:w}=b(o,e,S)),r.throwIfAborted(d),P=c.project(P,s)}return{densifiedPath:P,pathLength:m*S,distances:w}}function p(e,t){const n=e/t.densificationMaxSamples;return Math.max(t.samplingDistance,n)}function g(e,t,n){if(null==t)return w(e);const r=e.spatialReference,o=t.mode,i=f.getElevationOffset(t,r);let s=null;switch(n.type){case"2d":s=m(e,o,i);break;case"3d":s=P(e,o,i,n)}return null==s?w(e):new a({hasZ:!0,hasM:!1,spatialReference:r,paths:y(e.paths,s)})}function m({hasZ:e},t,n){return"absolute-height"===t?e?([e,t,r])=>[e,t,r+n]:([e,t])=>[e,t,n]:null}function P({spatialReference:e,hasZ:t},n,r,{elevationProvider:o}){const i=(t,n,r,i)=>o?.getElevation(t,n,r,e,i)??0;switch(n){case"on-the-ground":return([e,t])=>[e,t,i(e,t,0,"ground")];case"absolute-height":return t?([e,t,n])=>[e,t,n+r]:([e,t])=>[e,t,r];case"relative-to-ground":return t?([e,t,n])=>[e,t,n+i(e,t,n,"ground")+r]:([e,t])=>[e,t,i(e,t,0,"ground")+r];case"relative-to-scene":return t?([e,t,n])=>[e,t,n+i(e,t,n,"scene")+r]:([e,t])=>[e,t,i(e,t,0,"scene")+r];default:return null}}function w(e){return e.hasZ?new a({hasZ:!1,hasM:!1,spatialReference:e.spatialReference,paths:y(e.paths,(([e,t])=>[e,t]))}):e}function y(e,t){const n=e.length,r=new Array(n);for(let o=0;o<n;++o){const n=e[o],i=n.length,s=new Array(n.length);r[o]=s;for(let e=0;e<i;++e)s[e]=t(n[e])}return r}function R(e){return v(e)&&e.paths.length>0&&e.paths.every((e=>e.length>=2))}function v(e){return null!=e&&"polyline"===e.type}function S(e,t,r,i,s){const{spatialReference:c,hasZ:l}=e,u={from:null,to:null,distance:0,azimuth:0,reverseAzimuth:0,spatialReference:c,metersPerSR:o.getMetersPerUnitForSR(c)},f=[],h=[];let d=0;for(let o=0;o<e.paths.length;++o){const a=e.paths[o],c=new Array,l=new Array;let p=0;for(let e=1;e<a.length;++e){const o=a[e-1],f=a[e],h=i(u,o,f);let g;for(g=p;g<h.distance&&!n.floatEqualUlp(g,h.distance);g+=t)c.push(s(h,g)),l.push((d+g)*r);p=g-h.distance,d+=h.distance,c.push(f),l.push(d*r)}f[o]=c,h[o]=l}return{densifiedPath:new a({spatialReference:c,hasZ:l,paths:f}),distances:h}}function b(e,t,n){const{hasZ:r}=e;return S(e,t,n,E,r?j:U)}function G(e,t,n){const{hasZ:r}=e;return S(e,t,n,A,r?Z:M)}function A(e,t,n){return e.distance=0,u.inverseGeodeticSolver(e,t,n,e.spatialReference),e.from=t,e.to=n,e}function E(e,t,n){return e.from=t,e.to=n,e.distance=i.distance(n,t)*e.metersPerSR,e}function M({from:e,azimuth:t,spatialReference:n},r){return u.directGeodeticSolver([0,0],e,t,r,n)}function Z({from:e,to:t,azimuth:r,distance:o,spatialReference:i},s){const a=s/o,c=[0,0,n.lerp(e[2],t[2],a)];return u.directGeodeticSolver(c,e,r,s,i),c}function U({from:e,to:t,distance:n},r){return i.lerp([0,0],e,t,r/n)}function j({from:e,to:t,distance:n},r){return s.lerp([0,0,0],e,t,r/n)}function x(e){return u.isSupported(e.spatialReference)?e:c.project(e,l.WGS84)}function z(e){return e.paths.reduce(((e,t)=>e+t.length),0)}function I(e,t,n){return z(e)+Math.floor(t/n)+Math.max(0,e.paths.reduce((e=>1+e),0)-1)}t.countPoints=z,t.densifyPath=d,t.isPolyline=v,t.isValidInputPath=R,t.toAbsoluteHeightElevation=g,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
