/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../core/arrayUtils","../../../core/mathUtils","../../../core/promiseUtils","../../../geometry/Multipoint","../../../geometry/support/coordsUtils","../../../geometry/support/spatialReferenceUtils","../../../views/support/QueueProcessor","../../../views/support/Scheduler","./constants","./geometryUtils","./ProfileGenerationError","./statisticsUtils","../../support/traversalUtils"],(function(e,t,r,n,o,s,i,l,a,u,c,f,p,d){"use strict";async function*h(e,t){const{view:r,geometry:o,elevationInfo:s,providers:i,options:l}=e,a=r.spatialReference;if(!a||null==o||!c.isValidInputPath(o))throw new f.ProfileGenerationError(f.ProfileGenerationErrorCause.InvalidGeometry);const p=i.length;if(0===p)return null;const d=Math.round(l.maxTotalSamples/p);if(c.countPoints(o)>d)throw new f.ProfileGenerationError(f.ProfileGenerationErrorCause.TooComplex);const h=await c.densifyPath(o,s,r,a,l,d,t);let y=0;const g=new Array(p),w=new Array(p);for(let n=0;n<p;n++){const r=E(h);g[n]=r,y+=r.samples.length;const o={...e,provider:i[n],result:r,densificationResult:h};w[n]=m(o,t)[Symbol.iterator]()}if(y>l.maxTotalSamples)throw new f.ProfileGenerationError(f.ProfileGenerationErrorCause.TooComplex);const P=await Promise.all(w.map((e=>{const t=e.next();return!0===t.done?Promise.resolve(null):t.value})));n.throwIfAborted(t);for(let n=0;n<p;n++)g[n]=P[n];yield g,await n.after(e.delayAfterPreview??u.getConfig().delayAfterPreviewMillis,null,t.signal);const v=[];try{let e;do{e=!1;for(let t=0;t<p;t++){const r=w[t].next();!1===r.done&&(v.push({resultPromise:r.value,index:t}),e=!0)}}while(e)}finally{w.forEach((e=>e.return?.()))}for(const{resultPromise:u,index:c}of v)g[c]=await u,n.throwIfAborted(t),yield g;for(const n of g)null!=n&&(n.progress=1);yield g}function*m(e,r){const{densificationResult:n}=e,o={...e,abortOptions:r,densificationResult:n},s=d.breadthFirstBinaryPartitioning(0,o.result.samples.length),i=s.slice(0,o.provider.numSamplesForPreview);yield y(o,i,!0);const l=t.splitIntoChunks(s,o.provider.numSamplesPerChunk);for(const t of l)yield y(o,t,!1)}async function y({densificationResult:e,result:t,provider:r,queue:s,abortOptions:i,cache:l},a,c){const{densifiedPath:f,pathLength:p}=e,d=t.spatialReference,{samples:h}=t,m=[];for(let n=0;n<a.length;n++){const e=h[a[n]];m[n]=e.coordinate}try{return await s.push({geometry:new o({spatialReference:d,points:m,hasZ:f.hasZ}),provider:r,indices:a,preview:c,result:t,queryOptions:{...u.getConfig().defaultQueryOptions(),minDemResolution:c?Math.round(p/r.numSamplesForPreview):Math.round(p/h.length),cache:l}},i),{...t}}catch(y){return n.isAbortError(y)?null:u.errorResult}}function g(e){return new l.QueueProcessor({priority:a.TaskPriority.ELEVATION_PROFILE,concurrency:1,scheduler:e,process:async e=>{n.throwIfAborted(e.queryOptions);try{await w(e)}catch(t){n.throwIfNotAbortError(t)}}})}async function w({geometry:e,provider:t,indices:r,preview:n,result:o,queryOptions:s}){if(0===r.length)return;const i=(await C(t,e,s)).geometry,{hasZ:l,points:a}=i,u=s.noDataValue,{samples:c}=o;for(let f=0;f<r.length;f++){const e=c[r[f]];if(e.isHole)continue;const t=l?a[f][2]:null;null===t||t===u?e.sampledZ=null:(o.hasZ=!0,e.sampledZ=t),e.sampled=!0}P(c),o.progress=n?0:o.progress+r.length/c.length,o.statistics=p.getStatistics(o.samples,o.spatialReference)}function P(e){const t=e.length-1;let r=0;for(let n=1;n<=t;n++){(e[n].sampled||n===t)&&(v(e,r,n),r=n)}}function v(e,t,n){if(n-t==1)return;const o=e[t],s=o.sampledZ,i=e[n],l=i.sampledZ;if(null==s||null==l){for(let r=t+1;r<n;r++)e[r].sampledZ=null;return}const a=o.distance,u=i.distance-a;for(let c=t+1;c<n;c++){const t=e[c],n=(t.distance-a)/u;t.sampledZ=r.lerp(s,l,n)}}function E({densifiedPath:e,distances:t}){const r=e.spatialReference,n=i.getInfo(r),o=e.paths,l=o.length,a=[];let u=null,c=0;for(let i=0;i<l;i++){const e=o[i],r=e.length,l=t[i];for(let t=0;t<r;t++){const r=e[t],o=l[t];n&&(r[0]=s.unnormalizedCoordinate(r[0],n.valid[0],n.valid[1])),u&&0===t&&R(a,u,r,c,o),a.push(Z(r,o)),u=r,c=o}}return{progress:0,samples:a,hasZ:!1,statistics:null,spatialReference:r}}function R(e,t,r,n,o){e.push(b(t,n)),e.push(b(r,o))}function Z(e,t){return{coordinate:e,distance:t,sampledZ:null,sampled:!1,isHole:!1}}function b(e,t){return{coordinate:e,distance:t,sampledZ:null,sampled:!0,isHole:!0}}async function C(e,t,r){try{return await e.queryElevation(t,r)}catch(n){throw new f.ProfileGenerationError(f.ProfileGenerationErrorCause.ElevationQueryError)}}function I(e,t,r){if(!e||0===e.length)return;const n=e.length-1,o=e[0];if(t<=r(o))return o;const s=e[n];if(t>=r(s))return s;let i=0,l=0,a=n;for(;i<a;){l=i+Math.floor((a-i)/2);const o=e[l],s=r(o);if(s===t)return o;if(t<s){if(l>0){const n=e[l-1],i=r(n);if(t>i)return t-i>=s-t?o:n}a=l}else{if(l<n){const n=e[l+1],i=r(n);if(t<i)return t-s>=i-t?n:o}i=l+1}}return e[l]}e.binaryFindClosest=I,e.createProfileQueue=g,e.generateProfile=m,e.generateProfiles=h,e.interpolateElevations=P,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
