/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../intl","../core/reactiveUtils","../core/accessorSupport/decorators/property","../core/accessorSupport/decorators/cast","../core/RandomLCG","../core/has","../core/accessorSupport/decorators/subclass","./Widget","./Feature/FeatureAttachments","./Feature/FeatureContent","./Feature/FeatureExpression","./Feature/FeatureFields","./Feature/FeatureMedia","./Feature/FeatureRelationship","./Feature/FeatureUtilityNetworkAssociations","./Feature/FeatureViewModel","./Feature/resources","./Feature/support/FeatureContentMixin","../chunks/componentsUtils","./support/globalCss","./support/Heading","./support/widgetUtils","./support/decorators/messageBundle","./support/jsxFactory","../intl/substitute"],(function(e,t,s,n,i,r,o,l,d,a,c,u,p,h,y,_,m,v,g,w,M,f,E,b,x,C,W){"use strict";const F={title:!0,content:!0,lastEditedInfo:!0};let k=class extends(w.FeatureContentMixin(a)){constructor(e,t){super(e,t),this._contentWidgets=[],this.flowType="feature",this.flowItems=null,this.headingLevel=2,this.messages=null,this.messagesCommon=null,this.visibleElements={...F},this.viewModel=new v}initialize(){this.addHandles(n.watch((()=>this.viewModel?.contentViewModels),(()=>this._setupContentWidgets()),n.initial))}loadDependencies(){return M.loadCalciteComponents({notice:()=>new Promise(((t,s)=>e(["../chunks/calcite-notice"],t,s))),loader:()=>new Promise(((t,s)=>e(["../chunks/calcite-loader"],t,s)))})}destroy(){this._destroyContentWidgets()}get graphic(){return this.viewModel.graphic}set graphic(e){this.viewModel.graphic=e}get defaultPopupTemplateEnabled(){return this.viewModel.defaultPopupTemplateEnabled}set defaultPopupTemplateEnabled(e){this.viewModel.defaultPopupTemplateEnabled=e}get isTable(){return this.viewModel.isTable}get icon(){return"polygon"}set icon(e){this._overrideIfSome("icon",e)}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}get location(){return this.viewModel.location}set location(e){this.viewModel.location=e}get spatialReference(){return this.viewModel.spatialReference}set spatialReference(e){this.viewModel.spatialReference=e}get timeZone(){return this.viewModel.timeZone}set timeZone(e){this.viewModel.timeZone=e}get title(){return this.viewModel.title}castVisibleElements(e){return{...F,...e}}get map(){return this.viewModel.map}set map(e){this.viewModel.map=e}get view(){return this.viewModel.view}set view(e){this.viewModel.view=e}setActiveMedia(e,t){return this.viewModel.setActiveMedia(e,t)}nextMedia(e){return this.viewModel.nextMedia(e)}previousMedia(e){return this.viewModel.previousMedia(e)}render(){const{state:e}=this.viewModel,t=C.tsx("div",{class:g.css.container,key:"container"},this._renderTitle(),"error"===e?this._renderError():"loading"===e?this._renderLoading():this._renderContentContainer());return C.tsx("div",{class:this.classes(g.css.base,f.globalCss.widget)},t)}_renderError(){const{messagesCommon:e,messages:t,visibleElements:s}=this;return C.tsx("calcite-notice",{icon:"exclamation-mark-circle",kind:"danger",open:!0,scale:"s"},s.title?C.tsx("div",{key:"error-title",slot:"title"},e.errorMessage):null,C.tsx("div",{key:"error-message",slot:"message"},t.loadingError))}_renderLoading(){return C.tsx("div",{class:g.css.loadingSpinnerContainer,key:"loading-container"},C.tsx("calcite-loader",{inline:!0,label:""}))}_renderContentContainer(){const{visibleElements:e}=this;return e.content?C.tsx("div",{class:g.css.main},[this._renderContent(),this._renderLastEditInfo()]):null}_renderTitle(){const{visibleElements:e,title:t}=this;return e.title?C.tsx(E.Heading,{class:g.css.title,innerHTML:t,level:this.headingLevel}):null}_renderContent(){const e=this.viewModel.content,t="content";if(!e)return null;if(Array.isArray(e))return e.length?C.tsx("div",{class:g.css.contentNode,key:`${t}-content-elements`},e.map(this._renderContentElement,this)):null;if("string"==typeof e){const e=this._contentWidgets[0];return!e||e.destroyed?null:C.tsx("div",{class:this.classes(g.css.contentNode,g.css.contentNodeText),key:`${t}-content`},e.render())}return this.renderNodeContent(e)}_renderContentElement(e,t){const{visibleElements:s}=this;if("boolean"!=typeof s.content&&!s.content?.[e.type])return null;switch(e.type){case"attachments":return this._renderAttachments(t);case"custom":return this._renderCustom(e,t);case"fields":return this._renderFields(t);case"media":return this._renderMedia(t);case"text":return this._renderText(e,t);case"expression":return this._renderExpression(t);case"relationship":return this._renderRelationship(t);case"utility-network-associations":return this._renderAssociation(t);default:return null}}_renderAttachments(e){const t=this._contentWidgets[e];if(!t||t.destroyed)return null;const{state:s,attachmentInfos:n}=t.viewModel;return"loading"===s||n.length>0?C.tsx("div",{class:this.classes(g.css.contentElement),key:this._buildKey("attachments-element",e)},t.render()):null}_renderRelationship(e){const t=this._contentWidgets[e];return t&&!t.destroyed&&this.flowItems?C.tsx("div",{class:g.css.contentElement,key:this._buildKey("relationship-element",e)},t.render()):null}_renderAssociation(e){const t=this._contentWidgets[e];return t&&!t.destroyed&&this.flowItems?C.tsx("div",{class:g.css.contentElement,key:this._buildKey("utility-network-association-element",e)},t.render()):null}_renderExpression(e){const t=this._contentWidgets[e];return t&&!t.destroyed&&t.viewModel.contentElement?C.tsx("div",{class:g.css.contentElement,key:this._buildKey("expression-element",e)},t.render()):null}_renderCustom(e,t){const{creator:s}=e,n=this._contentWidgets[t];return!n||n.destroyed?null:s?C.tsx("div",{class:g.css.contentElement,key:this._buildKey("custom-element",t)},n.render()):null}_renderFields(e){const t=this._contentWidgets[e];return!t||t.destroyed?null:C.tsx("div",{class:g.css.contentElement,key:this._buildKey("fields-element",e)},t.render())}_renderMedia(e){const t=this._contentWidgets[e];return!t||t.destroyed?null:C.tsx("div",{class:g.css.contentElement,key:this._buildKey("media-element",e)},t.render())}_renderLastEditInfo(){const{visibleElements:e,messages:t}=this,{lastEditInfo:s}=this.viewModel;if(!s||!e.lastEditedInfo)return null;const{date:n,user:i}=s,r="edit"===s.type?i?t.lastEditedByUser:t.lastEdited:i?t.lastCreatedByUser:t.lastCreated,o=W.substitute(r,{date:n,user:i});return C.tsx("div",{class:this.classes(g.css.lastEditedInfo,g.css.contentElement),key:"edit-info-element"},o)}_renderText(e,t){const s=e.text,n=this._contentWidgets[t];return!n||n.destroyed?null:s?C.tsx("div",{class:this.classes(g.css.contentElement,g.css.text),key:this._buildKey("text-element",t)},n.render()):null}_buildKey(e,...t){return`${e}__${this.viewModel?.graphic?.uid||"0"}-${t.join("-")}`}_destroyContentWidget(e){e&&(e.viewModel=null,!e.destroyed&&e.destroy())}_destroyContentWidgets(){this._contentWidgets.forEach((e=>this._destroyContentWidget(e))),this._contentWidgets=[]}_setupContentWidgets(){this._destroyContentWidgets();const{headingLevel:e,visibleElements:t,flowItems:s,viewModel:n}=this,i=n?.content,{contentViewModels:r}=n;if(Array.isArray(i))i.forEach(((i,o)=>{if("attachments"===i.type&&(this._contentWidgets[o]=new c({displayType:i.displayType,headingLevel:t.title&&e<6?e+1:e,viewModel:r[o]})),"fields"===i.type&&(this._contentWidgets[o]=new h({viewModel:r[o]})),"media"===i.type&&(this._contentWidgets[o]=new y({viewModel:r[o]})),"text"===i.type&&(this._contentWidgets[o]=new u({viewModel:r[o]})),"custom"===i.type&&(this._contentWidgets[o]=new u({viewModel:r[o]})),"expression"===i.type&&(this._contentWidgets[o]=new p({viewModel:r[o]})),"relationship"===i.type){const e=new _({flowItems:s,featureVisibleElements:t,viewModel:r[o]});this._contentWidgets[o]=e}if("utility-network-associations"===i.type){const e=new m({flowItems:s,parentFeatureViewModel:n,featureVisibleElements:t,viewModel:r[o]});this._contentWidgets[o]=e}}),this);else{const e=r[0];e&&!e.destroyed&&(this._contentWidgets[0]=new u({viewModel:e}))}this.scheduleRender()}};t.__decorate([i.property()],k.prototype,"flowType",void 0),t.__decorate([i.property()],k.prototype,"graphic",null),t.__decorate([i.property()],k.prototype,"defaultPopupTemplateEnabled",null),t.__decorate([i.property()],k.prototype,"flowItems",void 0),t.__decorate([i.property()],k.prototype,"headingLevel",void 0),t.__decorate([i.property({readOnly:!0})],k.prototype,"isTable",null),t.__decorate([i.property()],k.prototype,"icon",null),t.__decorate([i.property()],k.prototype,"label",null),t.__decorate([i.property()],k.prototype,"location",null),t.__decorate([i.property(),x.messageBundle("esri/widgets/Feature/t9n/Feature")],k.prototype,"messages",void 0),t.__decorate([i.property(),x.messageBundle("esri/t9n/common")],k.prototype,"messagesCommon",void 0),t.__decorate([i.property()],k.prototype,"spatialReference",null),t.__decorate([i.property()],k.prototype,"timeZone",null),t.__decorate([i.property({readOnly:!0})],k.prototype,"title",null),t.__decorate([i.property()],k.prototype,"visibleElements",void 0),t.__decorate([r.cast("visibleElements")],k.prototype,"castVisibleElements",null),t.__decorate([i.property()],k.prototype,"map",null),t.__decorate([i.property()],k.prototype,"view",null),t.__decorate([i.property({type:v})],k.prototype,"viewModel",void 0),k=t.__decorate([d.subclass("esri.widgets.Feature")],k);return k}));
