/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../../chunks/tslib.es6","../../intl","../../core/a11yUtils","../../core/reactiveUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/Logger","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../../renderers/support/utils","../Widget","./FeatureMedia/FeatureMediaViewModel","./support/FeatureElementInfo","./support/featureUtils","../../chunks/componentsUtils","../support/widgetUtils","../support/decorators/messageBundle","../support/jsxFactory","../../support/themeUtils","../../intl/substitute"],(function(e,t,i,r,a,s,o,n,l,d,c,m,h,u,p,_,f,g,v,M,w){"use strict";const A="esri-feature-media",I={base:A,mediaContainer:`${A}__container`,mediaItemContainer:`${A}__item-container`,mediaItem:`${A}__item`,mediaItemText:`${A}__item-text`,mediaItemTitle:`${A}__item-title`,mediaItemCaption:`${A}__item-caption`,mediaNavigation:`${A}__item-navigation`,mediaPagination:`${A}__pagination`,mediaPaginationText:`${A}__pagination-text`,mediaPrevious:`${A}__previous`,mediaPreviousIconLTR:`${A}__previous-icon`,mediaPreviousIconRTL:`${A}__previous-icon--rtl`,mediaNext:`${A}__next`,mediaNextIconLTR:`${A}__next-icon`,mediaNextIconRTL:`${A}__next-icon--rtl`,mediaChart:`${A}__chart`,mediaPaginationButton:`${A}__pagination-button`,mediaPaginationIcon:`${A}__pagination-icon`,mediaChartRendered:`${A}__chart--rendered`},y=15,x="category",C="value",T="rgba(50, 50, 50, 1)",b=250,R=500,S=200;let F=class extends m{constructor(t,i){super(t,i),this._refreshTimer=null,this._refreshIntervalInfo=null,this._featureElementInfo=null,this._chartRootMap=new WeakMap,this.viewModel=new h,this.messages=null,this._disposeChart=e=>{this._chartRootMap.get(e)?.dispose(),this._chartRootMap.delete(e)},this._createChart=async t=>{const{destroyed:i,viewModel:r}=this;if(i||!r||!t)return;const{createRoot:a}=await new Promise(((t,i)=>e(["../support/chartUtilsAm5"],t,i))),s=await a(t);this._chartRootMap.set(t,s),this._renderChart({mediaInfo:r.activeMediaInfo,root:s})}}initialize(){this._featureElementInfo=new u,this.addHandles([a.watch((()=>[this.viewModel?.activeMediaInfo,this.viewModel?.activeMediaInfoIndex]),(()=>this._setupMediaRefreshTimer()),a.initial),a.watch((()=>[this.viewModel?.description,this.viewModel?.title]),(()=>this._setupFeatureElementInfo()),a.initial)])}loadDependencies(){return _.loadCalciteComponents({icon:()=>new Promise(((t,i)=>e(["../../chunks/calcite-icon"],t,i)))})}destroy(){this._clearMediaRefreshTimer(),this._featureElementInfo?.destroy()}get attributes(){return this.viewModel.attributes}set attributes(e){this.viewModel.attributes=e}get activeMediaInfoIndex(){return this.viewModel.activeMediaInfoIndex}set activeMediaInfoIndex(e){this.viewModel.activeMediaInfoIndex=e}get description(){return this.viewModel.description}set description(e){this.viewModel.description=e}get fieldInfoMap(){return this.viewModel.fieldInfoMap}set fieldInfoMap(e){this.viewModel.fieldInfoMap=e}get layer(){return this.viewModel.layer}set layer(e){this.viewModel.layer=e}get mediaInfos(){return this.viewModel.mediaInfos}set mediaInfos(e){this.viewModel.mediaInfos=e}get popupTemplate(){return this.viewModel.popupTemplate}set popupTemplate(e){this.viewModel.popupTemplate=e}get relatedInfos(){return this.viewModel.relatedInfos}set relatedInfos(e){this.viewModel.relatedInfos=e}get title(){return this.viewModel.title}set title(e){this.viewModel.title=e}render(){return v.tsx("div",{bind:this,class:I.base,onkeyup:this._handleMediaKeyup},this._featureElementInfo?.render(),this._renderMedia())}_renderMedia(){const{formattedMediaInfoCount:e,activeMediaInfoIndex:t}=this.viewModel,i=this._renderMediaText();return e?v.tsx("div",{class:I.mediaContainer,key:"media-element-container"},this._renderMediaInfo(),v.tsx("div",{class:I.mediaNavigation},i,e>1?v.tsx("div",{class:I.mediaPagination},this._renderMediaPageButton("previous"),v.tsx("span",{class:I.mediaPaginationText},w.substitute(this.messages.pageText,{index:t+1,total:e})),this._renderMediaPageButton("next")):null)):null}_renderMediaText(){const{activeMediaInfo:e}=this.viewModel;if(!e)return null;const t=e&&e.title?v.tsx("div",{class:I.mediaItemTitle,innerHTML:e.title,key:"media-title"}):null,i=e&&e.caption?v.tsx("div",{class:I.mediaItemCaption,innerHTML:e.caption,key:"media-caption"}):null;return t||i?v.tsx("div",{class:I.mediaItemText,key:"media-text"},t,i):null}_renderImageMediaInfo(e){if(!e.value)return null;const{_refreshIntervalInfo:t}=this,{activeMediaInfoIndex:i,formattedMediaInfoCount:r}=this.viewModel,{value:a,refreshInterval:s,altText:o,title:n,type:l}=e,{sourceURL:d,linkURL:c}=a,m=p.shouldOpenInNewTab(c??void 0)?"_blank":"_self",h="_blank"===m?"noreferrer":"",u=s?t:null,_=u?u.timestamp:0,f=u?u.sourceURL:d,g=v.tsx("img",{alt:o||n,key:`media-${l}-${i}-${r}-${_}`,src:f??void 0});return(c?v.tsx("a",{href:c,rel:h,target:m,title:n},g):null)??g}_renderChartMediaInfo(e){const{activeMediaInfoIndex:t,formattedMediaInfoCount:i}=this.viewModel;return v.tsx("div",{afterCreate:this._createChart,afterRemoved:this._disposeChart,bind:this,class:I.mediaChart,key:`media-${e.type}-${t}-${i}`})}_renderMediaInfoType(){const{activeMediaInfo:e}=this.viewModel;return e?"image"===e.type?this._renderImageMediaInfo(e):e.type.includes("chart")?this._renderChartMediaInfo(e):null:null}_renderMediaInfo(){const{activeMediaInfo:e}=this.viewModel;return e?v.tsx("div",{class:I.mediaItemContainer,key:"media-container"},v.tsx("div",{class:I.mediaItem,key:"media-item-container"},this._renderMediaInfoType())):null}_renderMediaPageButton(e){if(this.viewModel.formattedMediaInfoCount<2)return null;const t="previous"===e,i=t?this.messages.previous:this.messages.next,r=t?"chevron-left":"chevron-right",a=t?"media-previous":"media-next",s=t?this._previous:this._next;return v.tsx("button",{"aria-label":i,bind:this,class:I.mediaPaginationButton,key:a,onclick:s,tabIndex:0,title:i,type:"button"},v.tsx("calcite-icon",{class:I.mediaPaginationIcon,icon:r,scale:"s"}))}_setupFeatureElementInfo(){const{description:e,title:t}=this;this._featureElementInfo?.set({description:e,title:t})}_next(){this.viewModel.next()}_previous(){this.viewModel.previous()}_getRenderer(){if(!this.viewModel)return;const{isAggregate:e,layer:t}=this.viewModel;return e&&t?.featureReduction&&"renderer"in t.featureReduction?t.featureReduction.renderer:t?.renderer}async _getSeriesColors(t){const{colorAm5:i}=await new Promise(((t,i)=>e(["./FeatureMedia/chartCommon"],t,i))),r=new Map;return t.forEach((e=>{e.color&&r.set(e,i(e.color.toCss(!0)))})),r}async _getRendererColors(){const{colorAm5:t}=await new Promise(((t,i)=>e(["./FeatureMedia/chartCommon"],t,i))),i=new Map,r=this._getRenderer(),a="default";if(!r)return i;const s=await c.getColorsFromRenderer(r);s.delete(a);return Array.from(s.values()).every((e=>1===e?.length))?(Array.from(s.keys()).forEach((e=>{const r=s.get(e)?.[0]?.toCss(!0);r&&i.set(e,t(r))})),i):i}_handleMediaKeyup(e){const{key:t}=e;"ArrowLeft"===t&&(e.stopPropagation(),this.viewModel.previous()),"ArrowRight"===t&&(e.stopPropagation(),this.viewModel.next())}_canAnimateChart(){return!!this.viewModel&&(!!this.viewModel.abilities.chartAnimation&&!r.prefersReducedMotion())}_getChartAnimationMS(){return this._canAnimateChart()?b:0}_getChartSeriesAnimationMS(){return this._canAnimateChart()?R:0}async _renderChart(t){const{root:i,mediaInfo:r}=t,{value:a,type:s}=r,{ResponsiveThemeAm5:o,DarkThemeAm5:n,AnimatedThemeAm5:l,ColorSetAm5:d,ThemeAm5:c,esriChartColorSet:m}=await new Promise(((t,i)=>e(["./FeatureMedia/chartCommon"],t,i))),h=c.new(i);h.rule("ColorSet").set("colors",m),h.rule("ColorSet").set("reuse",!0);const u=[o.new(i),h];M.isDarkTheme()&&u.push(n.new(i)),this._canAnimateChart()&&u.push(l.new(i)),i.setThemes(u);const p=await this._getRendererColors(),_=await this._getSeriesColors(a.series),f=d.new(i,{}),g=_.get(a.series[0]),v=g?{lineSettings:{stroke:g}}:void 0,w=a.series.map(((e,t)=>{const i=_.get(e)||p.get(e.fieldName)||f.getIndex(t);return{[x]:e.tooltip,[C]:e.value,columnSettings:{fill:i,stroke:i},...v}})).filter((e=>"pie-chart"!==s||null!=e.value&&e.value>0));"pie-chart"===s?this._createPieChart(t,w):this._createXYChart(t,w)}_getDirection(){return f.isRTL(this.container)?"rtl":"ltr"}async _customizeChartTooltip(t,i="horizontal"){const{colorAm5:r}=await new Promise(((t,i)=>e(["./FeatureMedia/chartCommon"],t,i)));t.setAll({pointerOrientation:i}),t.get("background")?.setAll({stroke:r(T)}),t.label.setAll({direction:this._getDirection(),oversizedBehavior:"wrap",maxWidth:S})}async _createPieChart(t,i){const{TooltipAm5:r}=await new Promise(((t,i)=>e(["./FeatureMedia/chartCommon"],t,i))),{PieChartAm5:a,PieSeriesAm5:s}=await new Promise(((t,i)=>e(["./FeatureMedia/pieChart"],t,i))),{mediaInfo:o,root:n}=t,{title:l}=o,d=5,c=o?.altText||o?.title||"",m=n.container.children.push(a.new(n,{ariaLabel:c,focusable:!0,paddingBottom:d,paddingTop:d,paddingLeft:d,paddingRight:d})),h="{category}: {valuePercentTotal.formatNumber('0.00')}%\n ({value})",u=r.new(n,{labelText:h}),p=m.series.push(s.new(n,{name:l,valueField:C,categoryField:x,tooltip:u}));p.ticks.template.set("forceHidden",!0),p.labels.template.set("forceHidden",!0),p.slices.template.states.create("active",{shiftRadius:d}),this._customizeChartTooltip(u),p.slices.template.setAll({ariaLabel:h,focusable:!0,templateField:"columnSettings"}),p.data.setAll(i),p.appear(this._getChartSeriesAnimationMS()),m.appear(this._getChartAnimationMS()),m.root.dom.classList.toggle(I.mediaChartRendered,!0)}_getMinSeriesValue(e){let t=0;return e.forEach((e=>t=Math.min(e.value,t))),t}async _createColumnChart(t,i,r){const{TooltipAm5:a,ScrollbarAm5:s}=await new Promise(((t,i)=>e(["./FeatureMedia/chartCommon"],t,i))),{CategoryAxisAm5:o,AxisRendererXAm5:n,ValueAxisAm5:l,AxisRendererYAm5:d,ColumnSeriesAm5:c}=await new Promise(((t,i)=>e(["./FeatureMedia/xyChart"],t,i))),{mediaInfo:m,root:h}=i,{value:u,title:p}=m;t.setAll({wheelX:"panX",wheelY:"zoomX"});const _=t.xAxes.push(o.new(h,{renderer:n.new(h,{inversed:f.isRTL(this.container)}),categoryField:x}));_.get("renderer").labels.template.setAll({forceHidden:!0});const g=t.yAxes.push(l.new(h,{renderer:d.new(h,{inside:!1}),min:this._getMinSeriesValue(u.series)}));g.get("renderer").labels.template.setAll({direction:this._getDirection()});const v="{categoryX}",M=a.new(h,{labelText:v}),w=t.series.push(c.new(h,{name:p,xAxis:_,yAxis:g,valueYField:C,categoryXField:x,tooltip:M}));this._customizeChartTooltip(M),w.columns.template.setAll({ariaLabel:v,focusable:!0,templateField:"columnSettings"}),u.series.length>y&&t.set("scrollbarX",s.new(h,{orientation:"horizontal"})),_.data.setAll(r),w.data.setAll(r),w.appear(this._getChartSeriesAnimationMS()),t.appear(this._getChartAnimationMS())}async _createBarChart(t,i,r){const{TooltipAm5:a,ScrollbarAm5:s}=await new Promise(((t,i)=>e(["./FeatureMedia/chartCommon"],t,i))),{CategoryAxisAm5:o,AxisRendererXAm5:n,ValueAxisAm5:l,AxisRendererYAm5:d,ColumnSeriesAm5:c}=await new Promise(((t,i)=>e(["./FeatureMedia/xyChart"],t,i))),{mediaInfo:m,root:h}=i,{value:u,title:p}=m;t.setAll({wheelX:"panY",wheelY:"zoomY"});const _=t.yAxes.push(o.new(h,{renderer:d.new(h,{inversed:!0}),categoryField:x}));_.get("renderer").labels.template.setAll({forceHidden:!0});const g=t.xAxes.push(l.new(h,{renderer:n.new(h,{inside:!1,inversed:f.isRTL(this.container)}),min:this._getMinSeriesValue(u.series)}));g.get("renderer").labels.template.setAll({direction:this._getDirection()});const v="{categoryY}",M=a.new(h,{labelText:v}),w=t.series.push(c.new(h,{name:p,xAxis:g,yAxis:_,valueXField:C,categoryYField:x,tooltip:M}));this._customizeChartTooltip(M,"vertical"),w.columns.template.setAll({ariaLabel:v,focusable:!0,templateField:"columnSettings"}),u.series.length>y&&t.set("scrollbarY",s.new(h,{orientation:"vertical"})),_.data.setAll(r),w.data.setAll(r),w.appear(this._getChartSeriesAnimationMS()),t.appear(this._getChartAnimationMS())}async _createLineChart(t,i,r){const{TooltipAm5:a,ScrollbarAm5:s}=await new Promise(((t,i)=>e(["./FeatureMedia/chartCommon"],t,i))),{CategoryAxisAm5:o,AxisRendererXAm5:n,ValueAxisAm5:l,AxisRendererYAm5:d,LineSeriesAm5:c}=await new Promise(((t,i)=>e(["./FeatureMedia/xyChart"],t,i))),{root:m,mediaInfo:h}=i,{value:u,title:p}=h;t.setAll({wheelX:"panX",wheelY:"zoomX"});const _=t.xAxes.push(o.new(m,{renderer:n.new(m,{inversed:f.isRTL(this.container)}),categoryField:x}));_.get("renderer").labels.template.setAll({forceHidden:!0});const g=t.yAxes.push(l.new(m,{renderer:d.new(m,{inside:!1}),min:this._getMinSeriesValue(u.series)}));g.get("renderer").labels.template.setAll({direction:this._getDirection()});const v="{categoryX}",M=r[0]?.lineSettings?.stroke,w=a.new(m,{getFillFromSprite:!M,labelText:v});M&&w.get("background")?.setAll({fill:M});const A=t.series.push(c.new(m,{name:p,xAxis:_,yAxis:g,valueYField:C,categoryXField:x,tooltip:w}));A.strokes.template.setAll({templateField:"lineSettings"}),this._customizeChartTooltip(w,"vertical"),u.series.length>y&&t.set("scrollbarX",s.new(m,{orientation:"horizontal"})),_.data.setAll(r),A.data.setAll(r),A.appear(this._getChartSeriesAnimationMS()),t.appear(this._getChartAnimationMS())}async _createXYChart(t,i){const{XYChartAm5:r,XYCursorAm5:a}=await new Promise(((t,i)=>e(["./FeatureMedia/xyChart"],t,i))),{root:s,mediaInfo:o}=t,{type:n}=o,l=o?.altText||o?.title||"",d=s.container.children.push(r.new(s,{ariaLabel:l,focusable:!0,panX:!0,panY:!0}));d.set("cursor",a.new(s,{})),"column-chart"===n&&await this._createColumnChart(d,t,i),"bar-chart"===n&&await this._createBarChart(d,t,i),"line-chart"===n&&await this._createLineChart(d,t,i),d.root.dom.classList.toggle(I.mediaChartRendered,!0)}_clearMediaRefreshTimer(){const{_refreshTimer:e}=this;e&&(clearTimeout(e),this._refreshTimer=null)}_updateMediaInfoTimestamp(e){const t=Date.now();this._refreshIntervalInfo={timestamp:t,sourceURL:e&&this._getImageSource(e,t)}}_setupMediaRefreshTimer(){this._clearMediaRefreshTimer();const{activeMediaInfo:e}=this.viewModel;"image"===e?.type&&e?.refreshInterval>0&&this._setRefreshTimeout(e)}_setRefreshTimeout(e){const{refreshInterval:t,value:i}=e,r=6e4*t;this._updateMediaInfoTimestamp(i.sourceURL);const a=setInterval((()=>{this._updateMediaInfoTimestamp(i.sourceURL)}),r);this._refreshTimer=a}_getImageSource(e,t){const i=e.includes("?")?"&":"?",[r,a=""]=e.split("#");return`${r}${i}timestamp=${t}${a?"#":""}${a}`}};t.__decorate([s.property()],F.prototype,"_refreshIntervalInfo",void 0),t.__decorate([s.property()],F.prototype,"attributes",null),t.__decorate([s.property()],F.prototype,"activeMediaInfoIndex",null),t.__decorate([s.property()],F.prototype,"description",null),t.__decorate([s.property()],F.prototype,"fieldInfoMap",null),t.__decorate([s.property()],F.prototype,"layer",null),t.__decorate([s.property()],F.prototype,"mediaInfos",null),t.__decorate([s.property()],F.prototype,"popupTemplate",null),t.__decorate([s.property()],F.prototype,"relatedInfos",null),t.__decorate([s.property()],F.prototype,"title",null),t.__decorate([s.property({type:h})],F.prototype,"viewModel",void 0),t.__decorate([s.property(),g.messageBundle("esri/widgets/Feature/t9n/Feature")],F.prototype,"messages",void 0),F=t.__decorate([d.subclass("esri.widgets.Feature.FeatureMedia")],F);return F}));
