/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../core/Accessor","../../../core/arrayUtils","../../../core/accessorSupport/decorators/property","../../../core/accessorSupport/decorators/cast","../../../core/has","../../../core/accessorSupport/decorators/subclass","../../../popup/FieldInfo","../../../popup/content/support/ChartMediaInfoValueSeries","../support/featureUtils","../support/relatedFeatureUtils"],(function(e,t,i,r,o,a,s,l,n,d,p){"use strict";const u={chartAnimation:!0};let f=class extends t{constructor(e){super(e),this.abilities={...u},this.activeMediaInfoIndex=0,this.attributes=null,this.description=null,this.fieldInfoMap=null,this.formattedAttributes=null,this.expressionAttributes=null,this.isAggregate=!1,this.layer=null,this.mediaInfos=null,this.popupTemplate=null,this.relatedInfos=null,this.title=null}castAbilities(e){return{...u,...e}}get activeMediaInfo(){return this.formattedMediaInfos[this.activeMediaInfoIndex]||null}get formattedMediaInfos(){return this._formatMediaInfos()||[]}get formattedMediaInfoCount(){return this.formattedMediaInfos.length}setActiveMedia(e){this._setContentElementMedia(e)}next(){this._pageContentElementMedia(1)}previous(){this._pageContentElementMedia(-1)}_setContentElementMedia(e){const{formattedMediaInfoCount:t}=this,i=(e+t)%t;this.activeMediaInfoIndex=i}_pageContentElementMedia(e){const{activeMediaInfoIndex:t}=this,i=t+e;this._setContentElementMedia(i)}_formatMediaInfos(){const{mediaInfos:e,layer:t}=this,r=this.attributes??{},o=this.formattedAttributes??{},a=this.expressionAttributes??{},s=this.fieldInfoMap??new Map;return e?.map((e=>{const i=e?.clone();if(!i)return null;if(i.title=d.substituteFieldsInLinksAndAttributes({attributes:r,fieldInfoMap:s,globalAttributes:o,expressionAttributes:a,layer:t,text:i.title}),i.caption=d.substituteFieldsInLinksAndAttributes({attributes:r,fieldInfoMap:s,globalAttributes:o,expressionAttributes:a,layer:t,text:i.caption}),i.altText=d.substituteFieldsInLinksAndAttributes({attributes:r,fieldInfoMap:s,globalAttributes:o,expressionAttributes:a,layer:t,text:i.altText}),"image"===i.type){if(!i.value)return;return this._setImageValue({value:i.value,formattedAttributes:o,layer:t}),i.value.sourceURL?i:void 0}if("pie-chart"===i.type||"line-chart"===i.type||"column-chart"===i.type||"bar-chart"===i.type){if(!i.value)return;return this._setChartValue({value:i.value,chartType:i.type,attributes:r,formattedAttributes:o,layer:t,expressionAttributes:a}),i}return null})).filter(i.isSome)??[]}_setImageValue(e){const t=this.fieldInfoMap??new Map,{value:i,formattedAttributes:r,layer:o}=e,{linkURL:a,sourceURL:s}=i;if(s){const e=d.fixTokens(s,o);i.sourceURL=d.substituteAttributes({formattedAttributes:r,template:e,fieldInfoMap:t})}if(a){const e=d.fixTokens(a,o);i.linkURL=d.substituteAttributes({formattedAttributes:r,template:e,fieldInfoMap:t})}}_setChartValue(e){const{value:t,attributes:i,formattedAttributes:r,chartType:o,layer:a,expressionAttributes:s}=e,{popupTemplate:l,relatedInfos:n}=this,{fields:p,normalizeField:u}=t,f=a;t.fields=d.getFixedFieldNames(p,f),u&&(t.normalizeField=d.getFixedFieldName(u,f));if(!p.some((e=>!!(null!=r[e]||d.isRelatedField(e)&&n?.size))))return;const c=l?.fieldInfos??[];p.forEach(((e,a)=>{const l=t.colors?.[a];if(d.isRelatedField(e))return void(t.series=[...t.series,...this._getRelatedChartInfos({fieldInfos:c,fieldName:e,formattedAttributes:r,chartType:o,value:t,color:l})]);const n=this._getChartOption({value:t,attributes:i,chartType:o,formattedAttributes:r,expressionAttributes:s,fieldName:e,fieldInfos:c,color:l});t.series.push(n)}))}_getRelatedChartInfos(e){const{fieldInfos:t,fieldName:i,formattedAttributes:r,chartType:o,value:a,color:s}=e,l=[],n=p.getRelatedFieldInfo(i),d=n&&this.relatedInfos?.get(n.layerId.toString());if(!d)return l;const{relatedFeatures:u,relation:f}=d;if(!f||!u)return l;const{cardinality:c}=f;u.forEach((e=>{const{attributes:d}=e;d&&Object.keys(d).forEach((e=>{e===n.fieldName&&l.push(this._getChartOption({value:a,attributes:d,formattedAttributes:r,fieldName:i,chartType:o,relatedFieldName:e,hasMultipleRelatedFeatures:u?.length>1,fieldInfos:t,color:s}))}))}));return"one-to-many"===c||"many-to-many"===c?l:[l[0]]}_getTooltip({label:e,value:t,chartType:i}){return"pie-chart"===i?`${e}`:`${e}: ${t}`}_getChartOption(e){const{value:t,attributes:i,formattedAttributes:r,expressionAttributes:o,fieldName:a,relatedFieldName:s,fieldInfos:u,chartType:f,hasMultipleRelatedFeatures:c,color:h}=e,y=this.layer,m=this.fieldInfoMap??new Map,{normalizeField:b,tooltipField:I}=t,_=b?d.isRelatedField(b)?i[p.getRelatedFieldInfo(b).fieldName]:i[b]:null,v=d.isExpressionField(a)&&o&&void 0!==o[a]?o[a]:s&&void 0!==i[s]?i[s]:void 0!==i[a]?i[a]:r[a],A=new n({fieldName:a,color:h,value:void 0===v?null:v&&_?v/_:v});if(d.isRelatedField(a)){const e=m.get(a.toLowerCase()),t=I&&m.get(I.toLowerCase()),o=e?.fieldName??a,l=c&&I?p.getRelatedFieldInfo(I).fieldName:t?.fieldName??I,n=c&&l?i[l]:r[l]??e?.label??e?.fieldName??s,d=c&&s?i[s]:r[o];return A.tooltip=this._getTooltip({label:n,value:d,chartType:f}),A}const M=d.getFieldInfo(u,a),g=d.getFixedFieldName(a,y),F=I&&void 0!==r[I]?r[I]:d.getFieldInfoLabel(M||new l({fieldName:g}),this.popupTemplate?.expressionInfos),x=r[g];return A.tooltip=this._getTooltip({label:F,value:x,chartType:f}),A}};e.__decorate([r.property()],f.prototype,"abilities",void 0),e.__decorate([o.cast("abilities")],f.prototype,"castAbilities",null),e.__decorate([r.property()],f.prototype,"activeMediaInfoIndex",void 0),e.__decorate([r.property({readOnly:!0})],f.prototype,"activeMediaInfo",null),e.__decorate([r.property()],f.prototype,"attributes",void 0),e.__decorate([r.property()],f.prototype,"description",void 0),e.__decorate([r.property()],f.prototype,"fieldInfoMap",void 0),e.__decorate([r.property()],f.prototype,"formattedAttributes",void 0),e.__decorate([r.property()],f.prototype,"expressionAttributes",void 0),e.__decorate([r.property({readOnly:!0})],f.prototype,"formattedMediaInfos",null),e.__decorate([r.property()],f.prototype,"isAggregate",void 0),e.__decorate([r.property()],f.prototype,"layer",void 0),e.__decorate([r.property({readOnly:!0})],f.prototype,"formattedMediaInfoCount",null),e.__decorate([r.property()],f.prototype,"mediaInfos",void 0),e.__decorate([r.property()],f.prototype,"popupTemplate",void 0),e.__decorate([r.property()],f.prototype,"relatedInfos",void 0),e.__decorate([r.property()],f.prototype,"title",void 0),f=e.__decorate([s.subclass("esri.widgets.Feature.FeatureMedia.FeatureMediaViewModel")],f);return f}));
