/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../../chunks/tslib.es6","../../intl","../../core/maybe","../../core/promiseUtils","../../core/reactiveUtils","../../core/accessorSupport/decorators/property","../../core/accessorSupport/decorators/cast","../../core/RandomLCG","../../core/has","../../core/accessorSupport/decorators/subclass","../Widget","./FeatureRelationship/FeatureRelationshipViewModel","./support/FeatureElementInfo","../../chunks/componentsUtils","../support/globalCss","../support/widgetUtils","../support/decorators/messageBundle","../support/jsxFactory","../../intl/substitute"],(function(e,t,s,r,i,o,n,l,a,d,c,u,h,p,_,v,m,w,y,b){"use strict";const g=e=>Object.freeze(Object.defineProperty({__proto__:null,default:e},Symbol.toStringTag,{value:"Module"}));var f;const F="esri-feature",I=`${F}-relationship`,M={base:I,listContainer:`${I}__list`,listItem:`${I}__list-item`,listItemHidden:`${I}__list-item--hidden`,listContainerQuerying:`${I}__list--querying`,featureObserver:`${F}__feature-observer`,stickySpinnerContainer:`${F}__sticky-loading-container`,loadingSpinnerContainer:`${F}__loading-container`},C={title:!0,description:!0};let O=f=class extends u{constructor(e,t){super(e,t),this._featureElementInfo=null,this._relatedFeatureIntersectionObserverNode=null,this._relatedFeatureIntersectionObserver=new IntersectionObserver((([e])=>{e?.isIntersecting&&this._increaseFeaturePage()}),{root:window.document}),this.flowItems=null,this.flowType="feature-relationship",this.headingLevel=2,this.viewModel=new h,this.messages=null,this.messagesCommon=null,this.visibleElements={...C},this._increaseFeaturePage=()=>{const{state:e,showAllEnabled:t,relatedFeatures:s,featuresPerPage:r,featurePage:i}=this.viewModel;"ready"===e&&t&&s.length>=r*i&&this.viewModel.featurePage++}}initialize(){this._featureElementInfo=new p,this.addHandles([o.watch((()=>[this.viewModel.description,this.viewModel.title,this.headingLevel]),(()=>this._setupFeatureElementInfo()),o.initial),o.watch((()=>[this.viewModel.state,this.viewModel.showAllEnabled,this._relatedFeatureIntersectionObserverNode]),(()=>this._handleRelatedFeatureObserverChange())),o.on((()=>this.viewModel.relatedFeatureViewModels),"change",(()=>this._setupRelatedFeatureViewModels()))])}loadDependencies(){return _.loadCalciteComponents({icon:()=>new Promise(((t,s)=>e(["../../chunks/calcite-icon"],t,s))),list:()=>new Promise(((t,s)=>e(["../../chunks/calcite-list"],t,s))),"list-item":()=>new Promise(((t,s)=>e(["../../chunks/calcite-list-item"],t,s))),loader:()=>new Promise(((t,s)=>e(["../../chunks/calcite-loader"],t,s))),notice:()=>new Promise(((t,s)=>e(["../../chunks/calcite-notice"],t,s)))})}destroy(){this._unobserveRelatedFeatureObserver(),this._featureElementInfo=r.destroyMaybe(this._featureElementInfo)}get displayShowAllButton(){const{showAllEnabled:e,featureCount:t,displayCount:s,state:r}=this.viewModel;return!e&&!!t&&"ready"===r&&(t>s||0===s)}get displayListItems(){return this.displayShowAllButton||this.viewModel.relatedFeatureViewModels.length>0}get description(){return this.viewModel.description}set description(e){this.viewModel.description=e}get featureCountDescription(){const{messages:e}=this,{featureCount:t}=this.viewModel;return b.substitute(e?.numberRecords,{number:t})}get title(){return this.viewModel.title}set title(e){this.viewModel.title=e}castVisibleElements(e){return{...C,...e}}render(){const{state:e}=this.viewModel;return y.tsx("div",{class:this.classes(M.base,v.globalCss.widget)},this._featureElementInfo?.render(),"loading"===e?this._renderLoading():"disabled"===e?this._renderRelationshipNotFound():this._renderRelatedFeatures())}async _selectRecord(t){const{flowItems:s,featureVisibleElements:r}=this;if(!s)return;t.abilities={relationshipContent:!0};const{default:i}=await new Promise(((t,s)=>e(["../Feature"],(e=>t(g(e))),s)));s.push(new i({flowItems:s,flowType:this.flowType,viewModel:t,visibleElements:r}))}_showAllRecords(){const{flowItems:e}=this;if(!e)return;const{viewModel:t,featureVisibleElements:s}=this;t.showAllEnabled=!0;const r=new f({flowItems:e,featureVisibleElements:s,visibleElements:{title:!1,description:!1},viewModel:t});e.push(r)}_renderStickyLoading(){return"querying"===this.viewModel.state?y.tsx("div",{class:M.stickySpinnerContainer,key:"sticky-loader"},this._renderLoadingIcon()):null}_renderLoadingIcon(){return y.tsx("calcite-loader",{inline:!0,label:""})}_renderLoading(){return y.tsx("div",{class:M.loadingSpinnerContainer,key:"loading-container"},this._renderLoadingIcon())}_renderShowAllIconNode(){return y.tsx("calcite-icon",{icon:"list",scale:"s",slot:"content-end"})}_renderChevronIconNode(){const e=m.isRTL(this.container)?"chevron-left":"chevron-right";return y.tsx("calcite-icon",{icon:e,scale:"s",slot:"content-end"})}_renderRelatedFeature(e){const{itemDescriptionFieldName:t}=this.viewModel,s=e.title;e.description=t&&e.formattedAttributes?.global[t];const r="loading"===e.state;return y.tsx("calcite-list-item",{class:this.classes(M.listItem,{[M.listItemHidden]:r}),description:e.description??"",key:e.uid,label:s,onCalciteListItemSelect:()=>this._selectRecord(e)},this._renderChevronIconNode())}_renderShowAllListItem(){return this.displayShowAllButton?y.tsx("calcite-list-item",{description:this.featureCountDescription,key:"show-all-item",label:this.messages?.showAll,onCalciteListItemSelect:()=>this._showAllRecords()},this._renderShowAllIconNode()):null}_renderNoRelatedFeaturesMessage(){return y.tsx("calcite-notice",{icon:"information",key:"no-related-features-message",kind:"brand",open:!0,scale:"s",width:"full"},y.tsx("div",{slot:"message"},this.messages?.noRelatedFeatures))}_renderFeatureObserver(){return y.tsx("div",{afterCreate:this._relatedFeatureIntersectionObserverCreated,bind:this,class:M.featureObserver,key:"feature-observer"})}_renderList(){const{relatedFeatureViewModels:e}=this.viewModel;return y.tsx("calcite-list",null,e.toArray().map((e=>this._renderRelatedFeature(e))),this._renderShowAllListItem())}_renderRelatedFeatures(){const{displayListItems:e}=this,{state:t}=this.viewModel;return y.tsx("div",{class:this.classes(M.listContainer,{[M.listContainerQuerying]:"querying"===t}),key:"list-container"},e?this._renderList():"ready"===t?this._renderNoRelatedFeaturesMessage():null,this._renderStickyLoading(),this._renderFeatureObserver())}_renderRelationshipNotFound(){return y.tsx("calcite-notice",{icon:"exclamation-mark-triangle",key:"relationship-not-found",kind:"danger",open:!0,scale:"s",width:"full"},y.tsx("div",{slot:"message"},this.messages?.relationshipNotFound))}_setupRelatedFeatureViewModels(){const{relatedFeatureViewModels:e}=this.viewModel,t="related-feature-viewmodels";this.removeHandles(t),e?.forEach((e=>{this.addHandles(o.watch((()=>[e.title,e.state]),(()=>this.scheduleRender()),o.initial),t)})),this.scheduleRender()}_setupFeatureElementInfo(){const{headingLevel:e,visibleElements:t}=this,s=t.description&&this.description,r=t.title&&this.title;this._featureElementInfo?.set({description:s,title:r,headingLevel:e})}async _handleRelatedFeatureObserverChange(){this._unobserveRelatedFeatureObserver();const{state:e,showAllEnabled:t}=this.viewModel;await i.after(0),this._relatedFeatureIntersectionObserverNode&&"ready"===e&&t&&this._relatedFeatureIntersectionObserver.observe(this._relatedFeatureIntersectionObserverNode)}_relatedFeatureIntersectionObserverCreated(e){this._relatedFeatureIntersectionObserverNode=e}_unobserveRelatedFeatureObserver(){this._relatedFeatureIntersectionObserverNode&&this._relatedFeatureIntersectionObserver.unobserve(this._relatedFeatureIntersectionObserverNode)}};t.__decorate([n.property()],O.prototype,"_relatedFeatureIntersectionObserverNode",void 0),t.__decorate([n.property({readOnly:!0})],O.prototype,"displayShowAllButton",null),t.__decorate([n.property({readOnly:!0})],O.prototype,"displayListItems",null),t.__decorate([n.property()],O.prototype,"description",null),t.__decorate([n.property({readOnly:!0})],O.prototype,"featureCountDescription",null),t.__decorate([n.property()],O.prototype,"featureVisibleElements",void 0),t.__decorate([n.property()],O.prototype,"flowItems",void 0),t.__decorate([n.property()],O.prototype,"flowType",void 0),t.__decorate([n.property()],O.prototype,"headingLevel",void 0),t.__decorate([n.property()],O.prototype,"title",null),t.__decorate([n.property({type:h})],O.prototype,"viewModel",void 0),t.__decorate([n.property(),w.messageBundle("esri/widgets/Feature/t9n/Feature")],O.prototype,"messages",void 0),t.__decorate([n.property(),w.messageBundle("esri/t9n/common")],O.prototype,"messagesCommon",void 0),t.__decorate([n.property()],O.prototype,"visibleElements",void 0),t.__decorate([l.cast("visibleElements")],O.prototype,"castVisibleElements",null),O=f=t.__decorate([c.subclass("esri.widgets.Feature.FeatureRelationship")],O);return O}));
