/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../../chunks/tslib.es6","../../core/maybe","../../core/reactiveUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/Logger","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../Widget","./FeatureUtilityNetworkAssociationType","./FeatureUtilityNetworkAssociations/FeatureUtilityNetworkAssociationsViewModel","./FeatureUtilityNetworkAssociations/VisibleElements","./support/FeatureElementInfo","../../chunks/componentsUtils","../support/globalCss","../support/widgetUtils","../support/decorators/messageBundle","../support/jsxFactory"],(function(e,t,i,s,o,n,r,a,l,c,d,u,p,h,y,_,m,w,g){"use strict";const v="esri-feature",f=`${v}-relationship`,C={base:f,listContainer:`${f}__list`,listItem:`${f}__list-item`,listItemHidden:`${f}__list-item--hidden`,listContainerQuerying:`${f}__list--querying`,featureObserver:`${v}__feature-observer`,stickySpinnerContainer:`${v}__sticky-loading-container`,loadingSpinnerContainer:`${v}__loading-container`,expander:`${f}__expander`};let k=class extends c{constructor(e,t){super(e,t),this._featureElementInfo=null,this.flowType="feature-utility-network-associations",this.flowItems=null,this.parentFeatureViewModel=null,this.headingLevel=2,this.viewModel=new u,this.messages=null,this.messagesCommon=null,this.visibleElements=new p}initialize(){this._featureElementInfo=new h,this.addHandles([s.watch((()=>[this.viewModel.description,this.viewModel.title,this.headingLevel]),(()=>this._setupFeatureElementInfo()),s.initial)])}loadDependencies(){return y.loadCalciteComponents({chip:()=>new Promise(((t,i)=>e(["../../chunks/calcite-chip"],t,i))),icon:()=>new Promise(((t,i)=>e(["../../chunks/calcite-icon"],t,i))),loader:()=>new Promise(((t,i)=>e(["../../chunks/calcite-loader"],t,i))),notice:()=>new Promise(((t,i)=>e(["../../chunks/calcite-notice"],t,i))),list:()=>new Promise(((t,i)=>e(["../../chunks/calcite-list"],t,i))),"list-item":()=>new Promise(((t,i)=>e(["../../chunks/calcite-list-item"],t,i)))})}destroy(){this._featureElementInfo=i.destroyMaybe(this._featureElementInfo)}get description(){return this.viewModel.description}set description(e){this.viewModel.description=e}get title(){return this.viewModel.title}set title(e){this.viewModel.title=e}render(){const{state:e}=this.viewModel;return g.tsx("div",{class:this.classes(C.base,_.globalCss.widget)},this._featureElementInfo?.render(),"loading"===e?this._renderLoading():"disabled"===e?this._renderAssociationNotFound():this._renderContent())}_renderStickyLoading(){return"querying"===this.viewModel.state?g.tsx("div",{class:C.stickySpinnerContainer,key:"sticky-loader"},this._renderLoadingIcon()):null}_renderLoadingIcon(){return g.tsx("calcite-loader",{inline:!0,label:""})}_renderLoading(){return g.tsx("div",{class:C.loadingSpinnerContainer,key:"loading-container"},this._renderLoadingIcon())}_renderAssociationNotFound(){return g.tsx("calcite-notice",{icon:"exclamation-mark-triangle",key:"association-not-found",kind:"danger",open:!0,scale:"s",width:"full"},g.tsx("div",{slot:"message"},this.messages?.noAssociations))}_setupFeatureElementInfo(){const{headingLevel:e,visibleElements:t}=this,i=t.description&&this.description,s=t.title&&this.title;this._featureElementInfo?.set({description:i,title:s,headingLevel:e})}_getAssociationTypeTitle(e){const{messages:t}=this;if(e.title)return e.title;switch(e.type){case"attachment":return t.associationsAttachments;case"connectivity":return t.associationsConnectivity;case"structure":return t.associationsStructure;case"content":return t.associationsContents;case"container":return t.associationsContainer}}_selectAssociationType(e){const{viewModel:t,flowItems:i,parentFeatureViewModel:s}=this;if(!i)return;const{associationTypes:o}=t;o.forEach((t=>{t.type===e.type?t.open=!0:t.open=!1}));const n=new d({viewModel:t,parentFeatureViewModel:s,listType:e,title:this._getAssociationTypeTitle(e),featureVisibleElements:this.featureVisibleElements,description:this.parentFeatureViewModel?.title,flowItems:i});i.push(n)}_renderAssociationType(e){const t=this._getAssociationTypeTitle(e);return g.tsx("calcite-list-item",{description:e.description,key:`association-type-${e.type}`,label:t,value:e.type,onCalciteListItemSelect:()=>this._selectAssociationType(e)},g.tsx("calcite-chip",{scale:"s",slot:"content-end",value:e.type},this._getFeatureCount(e.type)),g.tsx("calcite-icon",{flipRtl:!0,icon:"chevron-right",scale:"s",slot:"content-end"}))}_getFeatureCount(e){switch(e){case"attachment":return this.viewModel.attachmentsFeatureCount;case"structure":return this.viewModel.structureFeatureCount;case"content":return this.viewModel.contentFeatureCount;case"container":return this.viewModel.containerFeatureCount;case"connectivity":return this.viewModel.connectivityFeatureCount}}_renderAssociations(e){return g.tsx("div",null,this._getFeatureCount(e.type)>0?this._renderAssociationType(e):null)}_renderContent(){const{state:e,associationTypes:t}=this.viewModel;return g.tsx("div",{class:this.classes(C.listContainer,{[C.listContainerQuerying]:"querying"===e}),key:"list-container"},"ready"===e?g.tsx("calcite-list",null,t.map((e=>this._renderAssociations(e)))):null,this._renderStickyLoading())}};t.__decorate([o.property()],k.prototype,"flowType",void 0),t.__decorate([o.property()],k.prototype,"flowItems",void 0),t.__decorate([o.property()],k.prototype,"parentFeatureViewModel",void 0),t.__decorate([o.property()],k.prototype,"featureVisibleElements",void 0),t.__decorate([o.property()],k.prototype,"description",null),t.__decorate([o.property()],k.prototype,"headingLevel",void 0),t.__decorate([o.property()],k.prototype,"title",null),t.__decorate([o.property({type:u})],k.prototype,"viewModel",void 0),t.__decorate([o.property(),w.messageBundle("esri/widgets/Feature/t9n/Feature")],k.prototype,"messages",void 0),t.__decorate([o.property(),w.messageBundle("esri/t9n/common")],k.prototype,"messagesCommon",void 0),t.__decorate([o.property({type:p,nonNullable:!0})],k.prototype,"visibleElements",void 0),k=t.__decorate([l.subclass("esri.widgets.Feature.FeatureUtilityNetworkAssociations")],k);return k}));
