/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../Graphic","../../../core/Accessor","../../../core/Clonable","../../../core/Collection","../../../core/Identifiable","../../../core/promiseUtils","../../../core/ReactiveMap","../../../core/reactiveUtils","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/Logger","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../../layers/FeatureLayer","../../../networks/support/typeUtils","../../../rest/networks/support/Association","../../../rest/networks/support/NetworkElement","../../../rest/support/Query","./resources","../support/featureUtils"],(function(e,t,r,o,s,a,i,n,l,u,c,d,y,p,h,_,w,b,g,m,I){"use strict";const f=100;let F=class extends(o.ClonableMixin(a.IdentifiableMixin(r))){constructor(e){super(e),this._loaded=!1,this._queryAbortController=null,this._queryPageAbortController=null,this._queryFeatureCountAbortController=null,this.networkSourceIdsInUse=new Set,this.description=null,this.graphic=null,this.layer=null,this.map=null,this.featureCount=0,this.associationTypes=null,this.showAllEnabled=!1,this.title=null,this.attachmentsFeatureCount=0,this.structureFeatureCount=0,this.contentFeatureCount=0,this.containerFeatureCount=0,this.connectivityFeatureCount=0,this._cancelQuery=()=>{const{_queryAbortController:e}=this;e&&e.abort(),this._queryAbortController=null},this._cancelQueryFeatureCount=()=>{const{_queryFeatureCountAbortController:e}=this;e&&e.abort(),this._queryFeatureCountAbortController=null},this._queryController=async e=>{this._cancelQuery();const t=new AbortController;this._queryAbortController=t,await i.ignoreAbortErrors(this._query(e)),this._queryAbortController===t&&(this._queryAbortController=null)},this._queryFeatureCountController=async()=>{this._loaded=!1,this._cancelQueryFeatureCount();const e=new AbortController;this._queryFeatureCountAbortController=e,await i.ignoreAbortErrors(this._queryFeatureCount()),this._queryFeatureCountAbortController===e&&(this._queryFeatureCountAbortController=null),this._loaded=!0},this._queryDebounced=i.debounce(this._queryController,f),this._queryFeatureCountDebounced=i.debounce(this._queryFeatureCountController,f)}initialize(){this.associationTypes?.forEach((e=>{e.open=!1})),this.addHandles([...this.associationTypes?.map((e=>l.watch((()=>e.open),(()=>{e.open&&this._queryDebounced(e)}))))??[],l.watch((()=>[this.graphic,this.layer,this.map,this.associationTypes,this.objectId,this.globalId,this.canQuery]),(()=>this._queryFeatureCountDebounced()),l.initial)])}destroy(){this._cancelQuery(),this._cancelQueryFeatureCount(),this._destroyAssociatedFeatureViewModels()}get supportsCacheHint(){return!!this.layer?.capabilities?.query?.supportsCacheHint}get canLoad(){return!!this.map&&!!this.associationTypes&&"string"==typeof this.globalId}get canQuery(){const e=this.layer?.capabilities?.query;return!!this.associationTypes&&"string"==typeof this.globalId&&!!e?.supportsPagination}get objectId(){return(this.objectIdField&&this.graphic?.attributes?.[this.objectIdField])??null}get objectIdField(){return this.layer?.objectIdField||null}get globalId(){return(this.globalIdField&&this.graphic?.attributes?.[this.globalIdField])??null}get globalIdField(){const{layer:e}=this;return"subtype-sublayer"===e?.type&&e?.parent?e.parent.globalIdField??null:e?.globalIdField??null}get state(){const{_queryAbortController:e,_queryFeatureCountAbortController:t,_queryPageAbortController:r,canQuery:o,_loaded:s,canLoad:a}=this;return t||a&&!s?"loading":e||r?"querying":o&&0!==this.featureCount?"ready":"disabled"}get utilityNetwork(){const{layer:e,map:t}=this;return e?.loaded&&t?"subtype-sublayer"===e?.type&&e?.parent?I.findUtilityNetwork(t,e.parent)??null:I.findUtilityNetwork(t,e)??null:null}get associationsLayer(){const{utilityNetwork:e}=this;return e?.loaded?new h({url:e.networkSystemLayers.associationsTableUrl,gdbVersion:e.gdbVersion}):null}get attachmentsAssociations(){return this._get("attachmentsAssociations")||new s}get structureAssociations(){return this._get("structureAssociations")||new s}get contentAssociations(){return this._get("contentAssociations")||new s}get containerAssociations(){return this._get("containerAssociations")||new s}get connectivityAssociations(){return this._get("connectivityAssociations")||new s}get associationFeatures(){return this._get("associationFeatures")||new n}get associationViewModels(){return this._get("associationViewModels")||new Map}refresh(){this._queryFeatureCountDebounced()}_destroyAssociatedFeatureViewModels(){this.associationViewModels.forEach((e=>e.destroyAll()))}_generateGlobalIdWhereClause(e,t){const{globalId:r,networkSourceIdsInUse:o}=this,{associatedNetworkSourceId:s}=e,a=t.fieldsIndex.get(m.featureUtilityNetworkFields.fromGlobalId),i=t.fieldsIndex.get(m.featureUtilityNetworkFields.toGlobalId),n=t.fieldsIndex.get(m.featureUtilityNetworkFields.fromNetworkSourceId),l=t.fieldsIndex.get(m.featureUtilityNetworkFields.toNetworkSourceId),u=null!=s,c=`(${Array.from(o.values())})`,d=u?` AND ${l.name} = ${s} AND ${l.name} IN ${c}`:"",y=u?` AND ${n.name} = ${s} AND ${n.name} IN ${c}`:"";switch(e.type){case"connectivity":return`((${a.name} = '${r}'${d}) OR (${i.name} = '${r}'${y}))`;case"attachment":case"content":return`${a.name} = '${r}'${d}`;case"container":case"structure":return`${i.name} = '${r}'${y}`;default:return""}}_generateNetworkSourceIdWhereClause(e){const{networkSourceIdsInUse:t}=this,r=`(${Array.from(t.values())})`,o=e.fieldsIndex.get(m.featureUtilityNetworkFields.fromNetworkSourceId),s=e.fieldsIndex.get(m.featureUtilityNetworkFields.toNetworkSourceId);return`(${o.name} IN ${r} AND ${s.name} IN ${r})`}_generateAssociationTypeWhereClause(e,t){const r=t.fieldsIndex.get(m.featureUtilityNetworkFields.associationType);switch(e.type){case"attachment":case"structure":return`${r.name} = 3`;case"connectivity":return`${r.name} IN  (1, 4, 5, 6)`;case"container":case"content":return`${r.name} = 2`;default:return""}}_generateWhereClause(e,t){const r=t.fieldsIndex.get(m.featureUtilityNetworkFields.status),o=`(${_.AssociationOpenStatus.join(",")})`,s=`${r.name} IN ${o}`;return`(${this._generateGlobalIdWhereClause(e,t)} AND ${s} AND ${this._generateAssociationTypeWhereClause(e,t)})`}async _loadUtiltyNetworks(){const e=this.map;if(!e)return;await Promise.allSettled(e.utilityNetworks?.map((async e=>{await e.load()}))??[]);const t=e=>{if("layerId"in e&&r.isUtilityLayer(e)){const t=r.getSourceIdByLayerId(e.layerId);null!==t&&this.networkSourceIdsInUse.add(t)}},r=this.utilityNetwork;this._set("networkSourceIdsInUse",new Set),e.allLayers.forEach(t),e.allTables.forEach(t)}async _findLayersBySourceId(e){const{utilityNetwork:t,map:r}=this,o=e=>{const r=e;if(!e.url)return!1;if(r.layerId===s){return e.url.replace(/\/\d+$/,"")===t?.featureServiceUrl}return!1};await(t?.load());const s=t.getLayerIdBySourceId(e),a=r.allLayers.filter(o),i=r.allTables.filter(o),n=a.concat(i).toArray();return await Promise.allSettled(n.map((e=>e.load()))),n}_clearAssociations(){this.attachmentsAssociations.removeAll(),this.structureAssociations.removeAll(),this.contentAssociations.removeAll(),this.containerAssociations.removeAll(),this.connectivityAssociations.removeAll()}_clearFeatures(){this.associationFeatures.forEach((e=>e.removeAll())),this.associationFeatures.clear()}_getAssociationsByType(e){switch(e){case"attachment":return this.attachmentsAssociations;case"structure":return this.structureAssociations;case"connectivity":return this.connectivityAssociations;case"container":return this.containerAssociations;case"content":return this.contentAssociations}}_createAssociationFromFeature(e,t){if(!e)return null;const r=_.AssociationTypeDict.get(t.attributes[e.fieldsIndex.get(m.featureUtilityNetworkFields.associationType).name]);return new w({globalId:t.attributes[e.fieldsIndex.get(m.featureUtilityNetworkFields.globalId).name],fromNetworkElement:new b({globalId:t.attributes[e.fieldsIndex.get(m.featureUtilityNetworkFields.fromGlobalId).name],networkSourceId:t.attributes[e.fieldsIndex.get(m.featureUtilityNetworkFields.fromNetworkSourceId).name],terminalId:t.attributes[e.fieldsIndex.get(m.featureUtilityNetworkFields.fromTerminalId).name]}),toNetworkElement:new b({globalId:t.attributes[e.fieldsIndex.get(m.featureUtilityNetworkFields.toGlobalId).name],networkSourceId:t.attributes[e.fieldsIndex.get(m.featureUtilityNetworkFields.toNetworkSourceId).name],terminalId:t.attributes[e.fieldsIndex.get(m.featureUtilityNetworkFields.toTerminalId).name]}),associationType:r,status:t.attributes[e.fieldsIndex.get(m.featureUtilityNetworkFields.status).name],isContentVisible:t.attributes[e.fieldsIndex.get(m.featureUtilityNetworkFields.isContentVisible).name],percentAlong:t.attributes[e.fieldsIndex.get(m.featureUtilityNetworkFields.percentAlong).name]})}async _queryLayer(e,t,r,o,s){const a=e.fieldsIndex.get(m.featureUtilityNetworkFields.assetGroup),i=e.fieldsIndex.get(m.featureUtilityNetworkFields.assetType),n=null!=r,l=null!=o,u="("+t.map((e=>`'${e}'`)).join(", ")+")",c=n?` AND ${a?.name} = ${r}`:"",d=n&&l?` AND ${i?.name} = ${o}`:"",y=`${e.globalIdField} IN ${u}`+c+d,p=new g({outFields:["*"],cacheHint:this.supportsCacheHint,where:y});return await this._queryAll(p,e,{signal:s?.signal})}async _createAssociationFeatureObjects(e,t,r,o,s,a){if(0===e.length)return[];const i=new Map;for(const[l,u]of t){const e=await this._findLayersBySourceId(l);for(const t of e){(await this._queryLayer(t,u,o,s,a)).forEach((e=>{if(e.getEffectivePopupTemplate()&&e.layer){const r=i.get(e.attributes[t.globalIdField])??[];r.push(e),i.set(e.attributes[t.globalIdField],r)}}))}}const n=[];return e.toArray().forEach((e=>{const t=e.fromNetworkElement.globalId===r?e.toNetworkElement:e.fromNetworkElement;(i.get(t.globalId)??[]).forEach((r=>{const o=this.utilityNetwork?.getTerminalById(t?.terminalId)?.name;n.push({association:e,feature:r,terminalName:o})}))})),n}_parseFeatureObjects(e,t){e.forEach((e=>{const r=e?.feature,o=r.layer,a=t.get(o)??new s;a.add(e),t.set(o,a)}))}async _queryAll(e,t,r){const o=[];let s=0,a=!1;e.num=t.sourceJSON?.maxRecordCount??2e3;do{e.start=s;const i=await t.queryFeatures(e,r);o.push(...i.features),a=i.exceededTransferLimit,a&&(s+=i.features.length)}while(a);return o}async _queryAssociatedFeatureCount(e){const{layer:t,globalId:r,supportsCacheHint:o,associationTypes:s,associationsLayer:a,utilityNetwork:i,canQuery:n}=this;if(await Promise.allSettled([t?.load(),i?.load(),a?.load()]),this._clearAssociations(),!(n&&t&&s&&a))return;const l=a.fieldsIndex.get(m.featureUtilityNetworkFields.toGlobalId).name,u=a.fieldsIndex.get(m.featureUtilityNetworkFields.fromGlobalId).name,c=s.map((e=>this._generateWhereClause(e,a))),d=this._generateNetworkSourceIdWhereClause(a),y=c.join(" OR "),p=new g({outFields:["*"],cacheHint:o,returnGeometry:!1,where:`(${y}) AND (${d})`}),h=await this._queryAll(p,a,{signal:e?.signal}),_=new Map;s.forEach((e=>{_.set(e.type,[])})),h.forEach((e=>{const t=a.fieldsIndex.get(m.featureUtilityNetworkFields.associationType);switch(e.attributes[t.name]){case 1:case 4:case 5:case 6:e.attributes[u]===r?_.get("connectivity").push(e.attributes[l]):_.get("connectivity").push(e.attributes[u]),this.connectivityAssociations.add(this._createAssociationFromFeature(a,e));break;case 2:e.attributes[u]===r?(_.get("content").push(e.attributes[l]),this.contentAssociations.add(this._createAssociationFromFeature(a,e))):(_.get("container").push(e.attributes[u]),this.containerAssociations.add(this._createAssociationFromFeature(a,e)));break;case 3:e.attributes[u]===r?(_.get("attachment").push(e.attributes[l]),this.attachmentsAssociations.add(this._createAssociationFromFeature(a,e))):(_.get("structure").push(e.attributes[u]),this.structureAssociations.add(this._createAssociationFromFeature(a,e)))}}));const w=s.map((async t=>{const{associatedNetworkSourceId:r,associatedAssetGroup:o,associatedAssetType:s}=t,a=_.get(t.type),i=null!=o?await this._countAssociatedFeatures(r,a,o,s,e):a.length;switch(t.type){case"attachment":this._set("attachmentsFeatureCount",i);break;case"structure":this._set("structureFeatureCount",i);break;case"content":this._set("contentFeatureCount",i);break;case"container":this._set("containerFeatureCount",i);break;case"connectivity":this._set("connectivityFeatureCount",i)}}));await Promise.allSettled(w)}async _countAssociatedFeatureCount(e,t,r,o,s){const a=e.fieldsIndex.get(m.featureUtilityNetworkFields.assetGroup),i=e.fieldsIndex.get(m.featureUtilityNetworkFields.assetType),n=null!=o,l="("+t.map((e=>`'${e}'`)).join(", ")+")",u=` AND ${a?.name} = ${r}`,c=n?` AND ${i?.name} = ${o}`:"",d=`${e.globalIdField} IN ${l}`+u+c;return e.queryFeatureCount({where:d,outFields:["*"],returnGeometry:!1},{signal:s?.signal})}async _countAssociatedFeatures(e,t,r,o,s){if(0===t.length)return 0;const a=(await this._findLayersBySourceId(e)).map((async e=>this._countAssociatedFeatureCount(e,t,r,o,s)));return(await Promise.all(a)).reduce(((e,t)=>e+t),0)}async _queryAssociatedFeatures(e,t){const{layer:r,globalId:o,associationTypes:s,associationsLayer:a,utilityNetwork:i,canQuery:n,associationFeatures:l}=this;if(await Promise.allSettled([r?.load(),i?.load(),a?.load()]),!(n&&r&&s&&a))return;const u=this._getAssociationsByType(e.type),{associatedAssetGroup:c,associatedAssetType:d}=e,y=new Map;u.forEach((e=>{const{networkSourceId:t,elementGlobalId:r}=e.fromNetworkElement.globalId===o?{networkSourceId:e.toNetworkElement.networkSourceId,elementGlobalId:e.toNetworkElement.globalId}:{networkSourceId:e.fromNetworkElement.networkSourceId,elementGlobalId:e.fromNetworkElement.globalId},s=y.get(t)||[];s.push(r),y.set(t,s)}));const p=await this._createAssociationFeatureObjects(u,y,o,c,d,t);this._parseFeatureObjects(p,l)}async _queryFeatureCount(){await this._loadUtiltyNetworks();const{_queryFeatureCountAbortController:e,canQuery:t}=this;t?(await this._queryAssociatedFeatureCount(e),this._set("featureCount",this.attachmentsFeatureCount+this.structureFeatureCount+this.contentFeatureCount+this.containerFeatureCount+this.connectivityFeatureCount)):this._set("featureCount",0)}async _query(e){await this._loadUtiltyNetworks();const{_queryAbortController:t}=this;this.featureCount&&(this._destroyAssociatedFeatureViewModels(),this._clearFeatures(),this.destroyed||await this._queryAssociatedFeatures(e,{signal:t?.signal}))}};e.__decorate([u.property()],F.prototype,"_loaded",void 0),e.__decorate([u.property()],F.prototype,"_queryAbortController",void 0),e.__decorate([u.property()],F.prototype,"_queryPageAbortController",void 0),e.__decorate([u.property()],F.prototype,"_queryFeatureCountAbortController",void 0),e.__decorate([u.property({readOnly:!0})],F.prototype,"supportsCacheHint",null),e.__decorate([u.property({readOnly:!0})],F.prototype,"canLoad",null),e.__decorate([u.property({readOnly:!0})],F.prototype,"canQuery",null),e.__decorate([u.property()],F.prototype,"networkSourceIdsInUse",void 0),e.__decorate([u.property()],F.prototype,"description",void 0),e.__decorate([u.property({type:t})],F.prototype,"graphic",void 0),e.__decorate([u.property()],F.prototype,"layer",void 0),e.__decorate([u.property()],F.prototype,"map",void 0),e.__decorate([u.property({readOnly:!0})],F.prototype,"objectId",null),e.__decorate([u.property({readOnly:!0})],F.prototype,"objectIdField",null),e.__decorate([u.property({readOnly:!0})],F.prototype,"globalId",null),e.__decorate([u.property({readOnly:!0})],F.prototype,"globalIdField",null),e.__decorate([u.property()],F.prototype,"featureCount",void 0),e.__decorate([u.property()],F.prototype,"associationTypes",void 0),e.__decorate([u.property()],F.prototype,"showAllEnabled",void 0),e.__decorate([u.property()],F.prototype,"state",null),e.__decorate([u.property()],F.prototype,"title",void 0),e.__decorate([u.property({readOnly:!0})],F.prototype,"utilityNetwork",null),e.__decorate([u.property({readOnly:!0})],F.prototype,"associationsLayer",null),e.__decorate([u.property({readOnly:!0})],F.prototype,"attachmentsFeatureCount",void 0),e.__decorate([u.property({readOnly:!0})],F.prototype,"structureFeatureCount",void 0),e.__decorate([u.property({readOnly:!0})],F.prototype,"attachmentsAssociations",null),e.__decorate([u.property({readOnly:!0})],F.prototype,"structureAssociations",null),e.__decorate([u.property({readOnly:!0})],F.prototype,"contentFeatureCount",void 0),e.__decorate([u.property({readOnly:!0})],F.prototype,"containerFeatureCount",void 0),e.__decorate([u.property({readOnly:!0})],F.prototype,"contentAssociations",null),e.__decorate([u.property({readOnly:!0})],F.prototype,"containerAssociations",null),e.__decorate([u.property({readOnly:!0})],F.prototype,"connectivityFeatureCount",void 0),e.__decorate([u.property({readOnly:!0})],F.prototype,"connectivityAssociations",null),e.__decorate([u.property({readOnly:!0})],F.prototype,"associationFeatures",null),e.__decorate([u.property({readOnly:!0})],F.prototype,"associationViewModels",null),F=e.__decorate([p.subclass("esri.widgets.Feature.FeatureUtilityNetworkAssociations.FeatureUtilityNetworkAssociationsViewModel")],F);return F}));
