/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../geometry","../../Graphic","../../arcade/featureset/support/FeatureSetQueryInterceptor","../../core/Accessor","../../core/arrayUtils","../../core/Collection","../../core/Identifiable","../../core/Logger","../../core/promiseUtils","../../core/reactiveUtils","../../core/throttle","../../core/accessorSupport/decorators/property","../../core/accessorSupport/decorators/cast","../../core/has","../../core/accessorSupport/decorators/subclass","../../popup/content/TextContent","../../support/popupUtils","../../time/timeZoneUtils","./FeatureAttachments/FeatureAttachmentsViewModel","./FeatureContent/FeatureContentViewModel","./FeatureExpression/FeatureExpressionViewModel","./FeatureFields/FeatureFieldsViewModel","./FeatureMedia/FeatureMediaViewModel","./FeatureRelationship/FeatureRelationshipViewModel","./FeatureUtilityNetworkAssociations/FeatureUtilityNetworkAssociationsViewModel","./support/arcadeFeatureUtils","./support/featureUtils","./support/relatedFeatureUtils","../../geometry/Point"],(function(e,t,i,r,o,s,a,n,l,c,p,d,u,h,f,_,m,y,b,g,A,w,I,M,F,v,C,x,T,V){"use strict";var E;const R=1,L="content-view-models",P="relationship-view-models",k="association-view-models",O={attachmentsContent:!0,chartAnimation:!0,customContent:!0,expressionContent:!0,fieldsContent:!0,mediaContent:!0,textContent:!0,relationshipContent:!0,utilityNetworkAssociationsContent:!0};let Z=E=class extends(n.IdentifiableMixin(o)){constructor(e){super(e),this._error=null,this._featureAbortController=null,this._associationVMAbortController=null,this._graphicChangedThrottled=d.throttle(this._graphicChanged,R,this),this._expressionAttributes=null,this._graphicExpressionAttributes=null,this.abilities={...O},this.content=null,this.contentViewModels=[],this.description=null,this.defaultPopupTemplateEnabled=!1,this.formattedAttributes=null,this.lastEditInfo=null,this.location=null,this.relatedInfos=new Map,this.title="",this.view=null,this._isAllowedContentType=e=>{const{abilities:t}=this;return"attachments"===e.type&&!!t.attachmentsContent||"custom"===e.type&&!!t.customContent||"fields"===e.type&&!!t.fieldsContent||"media"===e.type&&!!t.mediaContent||"text"===e.type&&!!t.textContent||"expression"===e.type&&!!t.expressionContent||"relationship"===e.type&&!!t.relationshipContent||"utility-network-associations"===e.type&&!!t.utilityNetworkAssociationsContent},this.addHandles(p.watch((()=>[this.graphic,this._effectivePopupTemplate,this.abilities,this.timeZone]),(()=>this._graphicChangedThrottled()),p.initial))}initialize(){this.addHandles(this._graphicChangedThrottled)}destroy(){this._clear(),this._cancelFeatureQuery(),this._error=null,this.graphic=null,this._destroyContentViewModels(),this.relatedInfos.clear()}get _effectivePopupTemplate(){return null!=this.graphic?this.graphic.getEffectivePopupTemplate(this.defaultPopupTemplateEnabled):null}get _fieldInfoMap(){return x.createFieldInfoMap(x.getAllFieldInfos(this._effectivePopupTemplate),this._sourceLayer)}get _sourceLayer(){return x.getSourceLayer(this.graphic)}castAbilities(e){return{...O,...e}}get isTable(){return this._sourceLayer?.isTable||!1}get state(){return this.graphic?this._error?"error":this.waitingForContent?"loading":"ready":"disabled"}set graphic(e){this._featureAbortController=new AbortController,this._set("graphic",e?.clone()??null)}get spatialReference(){return this.view?.spatialReference??null}set spatialReference(e){this._override("spatialReference",e)}get timeZone(){return this.view?.timeZone??b.system}set timeZone(e){this._overrideIfSome("timeZone",e)}get map(){return this.view?.map||null}set map(e){this._override("map",e)}get waitingForContent(){return!(!this._featureAbortController&&!this._associationVMAbortController)}setActiveMedia(e,t){const i=this.contentViewModels[e];i instanceof M&&i.setActiveMedia(t)}nextMedia(e){const t=this.contentViewModels[e];t instanceof M&&t.next()}previousMedia(e){const t=this.contentViewModels[e];t instanceof M&&t.previous()}async updateGeometry(){const{graphic:e,spatialReference:t,_sourceLayer:i}=this;await(i?.load());const r=i?.objectIdField;if(!r||!e||!i)return;const o=e?.attributes?.[r];if(null==o)return;const s=[o];if(!e.geometry){const r=await x.querySourceLayer({layer:i,graphic:e,outFields:[],objectIds:s,returnGeometry:!0,spatialReference:t}),o=r?.geometry;o&&(e.geometry=o)}}_clear(){this._set("title",""),this._set("content",null),this._set("formattedAttributes",null)}async _graphicChanged(){this._cancelFeatureQuery(),this._error=null,this._clear();const{graphic:e}=this;if(!e)return;const t=new AbortController;this._featureAbortController=t;try{await this._queryFeature({signal:t.signal})}catch(i){c.isAbortError(i)||(this._error=i,l.getLogger(this).error("error","The popupTemplate could not be displayed for this feature.",{error:i,graphic:e,popupTemplate:this._effectivePopupTemplate}))}this._featureAbortController===t&&(this._featureAbortController=null)}_cancelFeatureQuery(){const{_featureAbortController:e}=this;e&&e.abort(),this._featureAbortController=null}_compileContentElement(e,t){return"attachments"===e.type?this._compileAttachments(e,t):"custom"===e.type?this._compileCustom(e,t):"fields"===e.type?this._compileFields(e,t):"media"===e.type?this._compileMedia(e,t):"text"===e.type?this._compileText(e,t):"expression"===e.type?this._compileExpression(e,t):"relationship"===e.type?this._compileRelationship(e,t):"utility-network-associations"===e.type?this._compileUtilityNetworkAssociation(e,t):void 0}_compileContent(e){if(this._destroyContentViewModels(),this.graphic)return Array.isArray(e)?e.filter(this._isAllowedContentType).map(((e,t)=>this._compileContentElement(e,t))).filter(s.isSome):"string"==typeof e?this._compileText(new m({text:e}),0).text:e}_destroyContentViewModels(){this.removeHandles(P),this.removeHandles(L),this.contentViewModels.forEach((e=>e&&!e.destroyed&&e.destroy())),this._set("contentViewModels",[])}_matchesFeature(e,t){const i=e?.graphic?.getObjectId(),r=t?.getObjectId();return null!=i&&null!=r&&i===r}_setRelatedFeaturesViewModels({relatedFeatureViewModels:e,relatedFeatures:t,map:i}){const{view:r,spatialReference:o,timeZone:s}=this;t?.filter(Boolean).forEach((t=>{e.some((e=>this._matchesFeature(e,t)))||e.add(new E({abilities:{relationshipContent:!1},map:i,view:r,spatialReference:o,timeZone:s,graphic:t}))})),e.forEach((i=>{const r=t?.find((e=>this._matchesFeature(i,e)));r||e.remove(i)}))}_setExpressionContentVM(e,t){const i=this.formattedAttributes,{contentElement:r,contentElementViewModel:o}=e,s=r?.type;o&&s&&("fields"===s&&(this._createFieldsFormattedAttributes({contentElement:r,contentElementIndex:t,formattedAttributes:i}),o.set(this._createFieldsVMParams(r,t))),"media"===s&&(this._createMediaFormattedAttributes({contentElement:r,contentElementIndex:t,formattedAttributes:i}),o.set(this._createMediaVMParams(r,t))),"text"===s&&o.set(this._createTextVMParams(r)))}_compileRelationship(e,t){const{displayCount:i,orderByFields:r,relationshipId:o,title:s,description:a}=e,{_sourceLayer:n,graphic:l,map:c}=this;if(!x.isRelatableFeatureSupportedLayer(n))return;const d=new F({displayCount:i,graphic:l,orderByFields:r,relationshipId:o,layer:n,map:c,...this._compileTitleAndDesc({title:s,description:a})});return this.contentViewModels[t]=d,this.addHandles(p.on((()=>d.relatedFeatures),"change",(()=>this._setRelatedFeaturesViewModels(d))),P),e}_matchesGlobalFeature(e,t){const i=e?.association.globalId,r=t?.association.globalId;return null!=i&&null!=r&&i===r}async _setUpUtilityNetworkAssociationsViewModels(e,t,i){const{view:r,spatialReference:o,timeZone:s}=this;e.forEach(((i,r)=>{const o=t.get(r);o?i.forEach((t=>{o.find((e=>this._matchesGlobalFeature(t,e)))||(i.remove(t),0===i.length&&e.delete(r))})):(i.removeAll(),e.delete(r))})),t.forEach(((t,n)=>{const l=e.get(n)||new a;t?.filter(Boolean).forEach((e=>{l.some((t=>this._matchesGlobalFeature(t,e)))||l.add({association:e.association,featureViewModel:new E({abilities:{utilityNetworkAssociationsContent:!1},map:i,view:r,spatialReference:o,timeZone:s,graphic:e.feature}),terminalName:e.terminalName})})),e.set(n,l)}));const n=new AbortController;this._associationVMAbortController=n,await this._sortListObjectsByTitle(e,{signal:n.signal}),this._associationVMAbortController===n&&(this._associationVMAbortController=null)}async _sortListObjectsByTitle(e,t){for(const i of e.values()){const e=i.map((e=>p.whenOnce((()=>"ready"===e.featureViewModel.state),t?.signal)));await Promise.all(e),i.sort(this._compareByFeatureTitle)}}_compareByFeatureTitle(e,t){const i=y.getFeaturePopupTitle(e.featureViewModel),r=y.getFeaturePopupTitle(t.featureViewModel);return i.localeCompare(r,void 0,{numeric:!0})}_compileUtilityNetworkAssociation(e,t){const{title:i,description:r,associationTypes:o}=e,{_sourceLayer:s,graphic:a,map:n}=this;if(!x.isAssociatedFeatureSupportedLayer(s))return;const l=new v({graphic:a,associationTypes:o,layer:s,map:n,...this._compileTitleAndDesc({title:i,description:r})});return this.contentViewModels[t]=l,this.addHandles([p.watch((()=>l.associationFeatures.values()),(()=>this._setUpUtilityNetworkAssociationsViewModels(l.associationViewModels,l.associationFeatures,l.map)))],k),e}_compileExpression(e,t){const{expressionInfo:i}=e,{graphic:r,map:o,spatialReference:s,view:a,location:n}=this,l=new w({expressionInfo:i,graphic:r,interceptor:E.interceptor,map:o,spatialReference:s,view:a,location:n});return this.contentViewModels[t]=l,this.addHandles(p.watch((()=>l.contentElementViewModel),(()=>this._setExpressionContentVM(l,t)),p.initial),L),e}_compileAttachments(e,t){const{graphic:i}=this,{description:r,title:o}=e;return this.contentViewModels[t]=new g({graphic:i,...this._compileTitleAndDesc({title:o,description:r})}),e}_compileCustom(e,t){const{graphic:i}=this,{creator:r,destroyer:o}=e;return this.contentViewModels[t]=new A({graphic:i,creator:r,destroyer:o}),e}_compileTitleAndDesc({title:e,description:t}){const{_fieldInfoMap:i,_sourceLayer:r,graphic:o,formattedAttributes:s}=this,a=o?.attributes,n=this._expressionAttributes,l=s.global;return{title:x.substituteFieldsInLinksAndAttributes({attributes:a,fieldInfoMap:i,globalAttributes:l,expressionAttributes:n,layer:r,text:e}),description:x.substituteFieldsInLinksAndAttributes({attributes:a,fieldInfoMap:i,globalAttributes:l,expressionAttributes:n,layer:r,text:t})}}_createFieldsVMParams(e,t){const i=this._effectivePopupTemplate,r=this.formattedAttributes,o={...r?.global,...r?.content[t]},s=e?.fieldInfos||i?.fieldInfos,a=s?.filter((({fieldName:e})=>!!e&&(x.isExpressionField(e)||x.isRelatedField(e)||o.hasOwnProperty(e)))),n=i?.expressionInfos,{description:l,title:c}=e;return{attributes:o,expressionInfos:n,fieldInfos:a,...this._compileTitleAndDesc({title:c,description:l})}}_compileFields(e,t){const i=e.clone(),r=new I(this._createFieldsVMParams(e,t));return this.contentViewModels[t]=r,i.fieldInfos=r.formattedFieldInfos.slice(),i}_createMediaVMParams(e,t){const{abilities:i,graphic:r,_fieldInfoMap:o,_effectivePopupTemplate:s,relatedInfos:a,_sourceLayer:n,_expressionAttributes:l}=this,c=this.formattedAttributes,p=r?.attributes??{},{description:d,mediaInfos:u,title:h}=e;return{abilities:{chartAnimation:i.chartAnimation},activeMediaInfoIndex:e.activeMediaInfoIndex||0,attributes:p,isAggregate:r?.isAggregate,layer:n,fieldInfoMap:o,formattedAttributes:{...c?.global,...c?.content[t]},expressionAttributes:l,mediaInfos:u,popupTemplate:s,relatedInfos:a,...this._compileTitleAndDesc({title:h,description:d})}}_compileMedia(e,t){const i=e.clone(),r=new M(this._createMediaVMParams(e,t));return i.mediaInfos=r.formattedMediaInfos.slice(),this.contentViewModels[t]=r,i}_createTextVMParams(e){const{graphic:t,_fieldInfoMap:i,_sourceLayer:r,_expressionAttributes:o}=this;if(e&&e.text){const s=t?.attributes??{},a=this.formattedAttributes?.global??{};e.text=x.substituteFieldsInLinksAndAttributes({attributes:s,fieldInfoMap:i,globalAttributes:a,expressionAttributes:o,layer:r,text:e.text})}return{graphic:t,creator:e.text}}_compileText(e,t){const i=e.clone();return this.contentViewModels[t]=new A(this._createTextVMParams(i)),i}_compileLastEditInfo(){const{_effectivePopupTemplate:e,_sourceLayer:t,graphic:i,timeZone:r}=this;if(!e)return;const{lastEditInfoEnabled:o}=e,s=t?.editFieldsInfo;return o&&s?x.formatEditInfo(s,i?.attributes,r,t):void 0}_compileTitle(e){const{_fieldInfoMap:t,_sourceLayer:i,graphic:r,_expressionAttributes:o}=this,s=r?.attributes??{},a=this.formattedAttributes?.global??{};return x.substituteFieldsInLinksAndAttributes({attributes:s,fieldInfoMap:t,globalAttributes:a,expressionAttributes:o,layer:i,text:e})}async _getTitle(){const{_effectivePopupTemplate:e,graphic:t}=this;return t?x.graphicCallback({type:"title",value:e?.title,event:{graphic:t}}):null}async _getContent(){const{_effectivePopupTemplate:e,graphic:t}=this;return t?x.graphicCallback({type:"content",value:e?.content,event:{graphic:t}}):null}async _queryFeature(e){const{_featureAbortController:t,_sourceLayer:i,graphic:r,_effectivePopupTemplate:o}=this,s=this.map,a=this.view,n=this.spatialReference,l=this.location;if(t!==this._featureAbortController||!r)return;await x.queryUpdatedFeature({graphic:r,popupTemplate:o,layer:i,spatialReference:n},e);const{content:{value:p},title:{value:d}}=await c.eachAlways({content:this._getContent(),title:this._getTitle()}),{expressionAttributes:{value:u}}=await c.eachAlways({checkForRelatedFeatures:this._checkForRelatedFeatures(e),expressionAttributes:C.createCompiledExpressions({expressionInfos:o?.expressionInfos,spatialReference:n,graphic:r,map:s,interceptor:E.interceptor,view:a,options:e,location:l})});t===this._featureAbortController&&r&&(this._expressionAttributes=u,this._graphicExpressionAttributes={...r.attributes,...u},this._set("formattedAttributes",this._createFormattedAttributes(p)),this._set("title",this._compileTitle(d)),this._set("lastEditInfo",this._compileLastEditInfo()||null),this._set("content",this._compileContent(p)||null))}_createMediaFormattedAttributes({contentElement:e,contentElementIndex:t,formattedAttributes:i}){const{_effectivePopupTemplate:r,graphic:o,relatedInfos:s,_sourceLayer:a,_fieldInfoMap:n,_graphicExpressionAttributes:l,timeZone:c}=this;i.content[t]=x.formatAttributes({fieldInfos:r?.fieldInfos,graphic:o,attributes:{...l,...e.attributes},layer:a,fieldInfoMap:n,relatedInfos:s,timeZone:c})}_createFieldsFormattedAttributes({contentElement:e,contentElementIndex:t,formattedAttributes:i}){if(e.fieldInfos){const{graphic:r,relatedInfos:o,_sourceLayer:s,_fieldInfoMap:a,_graphicExpressionAttributes:n,timeZone:l}=this;i.content[t]=x.formatAttributes({fieldInfos:e.fieldInfos,graphic:r,attributes:{...n,...e.attributes},layer:s,fieldInfoMap:a,relatedInfos:o,timeZone:l})}}_createFormattedAttributes(e){const{_effectivePopupTemplate:t,graphic:i,relatedInfos:r,_sourceLayer:o,_fieldInfoMap:s,_graphicExpressionAttributes:a,timeZone:n}=this,l=t?.fieldInfos,c={global:x.formatAttributes({fieldInfos:l,graphic:i,attributes:a,layer:o,fieldInfoMap:s,relatedInfos:r,timeZone:n}),content:[]};return Array.isArray(e)&&e.forEach(((e,t)=>{"fields"===e.type&&this._createFieldsFormattedAttributes({contentElement:e,contentElementIndex:t,formattedAttributes:c}),"media"===e.type&&this._createMediaFormattedAttributes({contentElement:e,contentElementIndex:t,formattedAttributes:c})})),c}_checkForRelatedFeatures(e){const{graphic:t,_effectivePopupTemplate:i}=this;return this._queryRelatedInfos(t,x.getAllFieldInfos(i),e)}async _queryRelatedInfos(e,t,i){const{relatedInfos:r,_sourceLayer:o}=this;r.clear();const s=null!=o?.associatedLayer?await(o?.associatedLayer.load(i)):o;if(!s||!e)return;const a=t.filter((e=>!!e.fieldName&&x.isRelatedField(e.fieldName)));if(!a?.length)return;t.forEach((e=>this._configureRelatedInfo(e,s)));const n=await T.queryLayerInfos({relatedInfos:r,layer:s},i);Object.keys(n).forEach((e=>{const t=r.get(e.toString()),i=n[e]?.value;t&&i&&(t.layerInfo=i.data)}));const l=await T.queryRelatedFeatures({graphic:e,relatedInfos:r,layer:s},i);Object.keys(l).forEach((e=>{T.setRelatedFeatures(l[e]?.value,r.get(e.toString()))}))}_configureRelatedInfo(e,t){const{relatedInfos:i}=this,r=T.getRelatedFieldInfo(e.fieldName||"");if(!r)return;const{layerId:o,fieldName:s}=r;if(!o)return;const a=i.get(o.toString())||T.createRelatedInfo(o,t);a&&(T.updateRelatedInfo({relatedInfo:a,fieldName:s,fieldInfo:e}),this.relatedInfos.set(o,a))}};Z.interceptor=new r.FeatureSetQueryInterceptor(x.preLayerQueryCallback,x.preRequestCallback),e.__decorate([u.property()],Z.prototype,"_error",void 0),e.__decorate([u.property()],Z.prototype,"_featureAbortController",void 0),e.__decorate([u.property()],Z.prototype,"_associationVMAbortController",void 0),e.__decorate([u.property({readOnly:!0})],Z.prototype,"_effectivePopupTemplate",null),e.__decorate([u.property({readOnly:!0})],Z.prototype,"_fieldInfoMap",null),e.__decorate([u.property({readOnly:!0})],Z.prototype,"_sourceLayer",null),e.__decorate([u.property()],Z.prototype,"abilities",void 0),e.__decorate([h.cast("abilities")],Z.prototype,"castAbilities",null),e.__decorate([u.property({readOnly:!0})],Z.prototype,"content",void 0),e.__decorate([u.property({readOnly:!0})],Z.prototype,"contentViewModels",void 0),e.__decorate([u.property()],Z.prototype,"description",void 0),e.__decorate([u.property({type:Boolean})],Z.prototype,"defaultPopupTemplateEnabled",void 0),e.__decorate([u.property({readOnly:!0})],Z.prototype,"isTable",null),e.__decorate([u.property({readOnly:!0})],Z.prototype,"state",null),e.__decorate([u.property({readOnly:!0})],Z.prototype,"formattedAttributes",void 0),e.__decorate([u.property({type:i,value:null})],Z.prototype,"graphic",null),e.__decorate([u.property({readOnly:!0})],Z.prototype,"lastEditInfo",void 0),e.__decorate([u.property({type:V})],Z.prototype,"location",void 0),e.__decorate([u.property({readOnly:!0})],Z.prototype,"relatedInfos",void 0),e.__decorate([u.property()],Z.prototype,"spatialReference",null),e.__decorate([u.property()],Z.prototype,"timeZone",null),e.__decorate([u.property({readOnly:!0})],Z.prototype,"title",void 0),e.__decorate([u.property()],Z.prototype,"map",null),e.__decorate([u.property({readOnly:!0})],Z.prototype,"waitingForContent",null),e.__decorate([u.property()],Z.prototype,"view",void 0),Z=E=e.__decorate([_.subclass("esri.widgets.Feature.FeatureViewModel")],Z);return Z}));
