/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../core/has","../../../core/Logger","../../../core/string","../../../intl/date","../../../intl/number","../../../layers/support/fieldUtils","../../../layers/support/layerUtils","../../../smartMapping/support/utils","../../../support/arcadeOnDemand","../../../time/timeZoneUtils"],(function(e,t,r,n,i,a,o,l,u,s,f){"use strict";const c="esri.widgets.Feature.support.featureUtils",d=()=>r.getLogger(c),p=/href=(""|'')/gi,y=/(\{([^{\r\n]+)\})/g,m=/'/g,b=/^\s*expression\//i,g=/(\n)/gi,I=/[\u00A0-\u9999<>&]/gim,h=/href\s*=\s*(?:"([^"]+)"|'([^']+)')/gi,F=/^(?:mailto:|tel:)/,T="relationships/",w=i.convertDateFormatToIntlOptions("short-date-short-time");function N(e){if(null!=e)return(e.sourceLayer||e.layer)??void 0}async function L({type:e,value:t,event:r}){try{return"function"==typeof t?t(r):await t}catch(n){return void d().error("error",`An error occurred when calling the "${e}" function`,{error:n,graphic:r.graphic,value:t})}}function A(e=""){if(e)return!F.test(e.trim().toLowerCase())}function v(e){return!!e&&b.test(e)}function x(e,t){if(!t||!v(t)||!e)return;const r=t.replace(b,"").toLowerCase();return e.find((({name:e})=>e.toLowerCase()===r))}function Z(e,t){const r=x(t,e?.fieldName);return r?r.title||null:e?e.label||e.fieldName:null}function E(e,t){const r=t.get(e.toLowerCase());return`{${r?.fieldName||e}}`}function C(e){return e.replaceAll(p,"")}function R(e,t){const r=M(t,e);return r?r.name:e}function q(e,t){return e&&e.map((e=>R(e,t)))}function M(e,t){return e&&"function"==typeof e.getField&&t?e.getField(t)??null:null}function U(e){return`${e}`.trim()}function j({attributes:e,globalAttributes:t,layer:r,text:n,expressionAttributes:i,fieldInfoMap:a}){return n?k({formattedAttributes:t,template:z(n,{...t,...i,...e},r),fieldInfoMap:a}):""}function k({formattedAttributes:e,template:t,fieldInfoMap:r}){return U(C(n.replace(n.replace(t,(e=>E(e,r))),e)))}function D(e,t,r=!1){const n=t[e];if("string"==typeof n){const i="%27",a=(r?encodeURIComponent(n):n).replaceAll(m,i);t[e]=a}}function O(e,t=!1){const r={...e};return Object.keys(r).forEach((e=>D(e,r,t))),r}function $(e,t,r){const i=(t=U(t))&&"{"!==t[0];return n.replace(e,O(r,i||!1))}function S(e,t){return e.replaceAll(y,((e,r,n)=>{const i=M(t,n);return i?`{${i.name}}`:r}))}function z(e,t,r){const n=S(e,r);return n?n.replaceAll(h,((e,r,n)=>$(e,r||n,t))):n}function G(e,t){if("string"==typeof e&&t&&null==t.dateFormat&&(null!=t.places||null!=t.digitSeparator)){const t=Number(e);if(!isNaN(t))return t}return e}function P(e){return null!=e&&"object"==typeof e&&"fieldsIndex"in e&&"geometryType"in e&&"getField"in e&&"load"in e&&"loaded"in e&&"objectIdField"in e&&"spatialReference"in e&&"type"in e&&("feature"===e.type||"scene"===e.type||"subtype-sublayer"===e.type||"sublayer"===e.type)&&"when"in e}function H(e){return null!=e&&"object"==typeof e&&"createQuery"in e&&"queryFeatureCount"in e&&"queryObjectIds"in e&&"queryRelatedFeatures"in e&&"queryRelatedFeaturesCount"in e&&"relationships"in e}function Q(e){return!!(e&&"object"==typeof e&&"createQuery"in e&&"queryFeatureCount"in e&&"type"in e)&&("subtype-sublayer"===e.type&&"parent"in e&&e.parent&&"object"==typeof e.parent?"globalIdField"in e.parent:"globalIdField"in e)}function V(e){return P(e)&&H(e)}function _(e){return P(e)&&Q(e)}function K(e){return!!e&&"object"==typeof e&&"sourceLayer"in e&&V(e.sourceLayer)}function B(e,t){const{fieldInfos:r,fieldName:n,preventPlacesFormatting:i,layer:l,timeZone:s}=t,f=X(r,n),c=M(l,n);if(f&&!o.isRasterPixelValueField(n)){const t=c?.type,r=f.format?.dateFormat;if("date"===t||"date-only"===t||"time-only"===t||"timestamp-offset"===t||r)return u.formatAnyDate(e,{format:r,fieldType:t,timeZoneOptions:{layerTimeZone:l&&"preferredTimeZone"in l?l.preferredTimeZone:null,viewTimeZone:s,datesInUnknownTimezone:!(!l||!("datesInUnknownTimezone"in l))&&!!l.datesInUnknownTimezone}})}const d=f?.format;return"string"==typeof e&&o.isRasterPixelValueField(n)&&d?J(e,d):"string"==typeof(e=G(e,d))||null==e||null==d?ae(e):i?a.formatNumber(e,{...a.convertNumberFormatToIntlOptions(d),minimumFractionDigits:0,maximumFractionDigits:20}):a.formatNumber(e,a.convertNumberFormatToIntlOptions(d))}function J(e,t){return e=e.trim(),/\d{2}-\d{2}/.test(e)?e:e.includes(",")?W(e,",",", ",t):e.includes(";")?W(e,";","; ",t):e.includes(" ")?W(e," "," ",t):a.formatNumber(Number(e),a.convertNumberFormatToIntlOptions(t))}function W(e,t,r,n){return e.trim().split(t).map((e=>a.formatNumber(Number(e),a.convertNumberFormatToIntlOptions(n)))).join(r)}function X(e,t){if(e?.length&&t)return e.find((e=>e.fieldName?.toLowerCase()===t.toLowerCase()))}function Y({fieldName:e,graphic:t,layer:r}){if(ce(e))return null;if(!r||"function"!=typeof r.getFeatureType)return null;const{typeIdField:n}=r;if(!n||e!==n)return null;const i=r.getFeatureType(t);return i?i.name:null}function ee({fieldName:e,value:r,graphic:n,layer:i}){if(ce(e))return null;if(!i||"function"!=typeof i.getFieldDomain)return null;const a=n&&i.getFieldDomain(e,{feature:n,excludeImpliedDomains:t("esri-widget-legacy-field-domain-calculation")});return a&&"coded-value"===a.type?a.getName(r):null}function te(e,t,r,n){const{creatorField:a,creationDateField:o,editorField:l,editDateField:u}=e;if(!t)return;const s=f.getTimeZoneFormattingOptions(n&&"preferredTimeZone"in n?n.preferredTimeZone:null,!(!n||!("datesInUnknownTimezone"in n))&&!!n.datesInUnknownTimezone,r,w,"date"),c={...w,...s},d=t[u];if("number"==typeof d){const e=t[l];return{type:"edit",date:i.formatDate(d,c),user:e}}const p=t[o];if("number"==typeof p){const e=t[a];return{type:"create",date:i.formatDate(p,c),user:e}}return null}function re(e,t){const r=new Map;if(!e)return r;for(const n of e){if(!n.fieldName)continue;const e=R(n.fieldName,t);n.fieldName=e,r.set(e.toLowerCase(),n)}return r}function ne(e){const t=[];if(!e)return t;const{fieldInfos:r,content:n}=e;return r&&t.push(...r),n&&Array.isArray(n)?(n.forEach((e=>{if("fields"===e.type){const r=e?.fieldInfos;r&&t.push(...r)}})),t):t}function ie(e){return e.replaceAll(I,(e=>`&#${e.charCodeAt(0)};`))}function ae(e){return"string"==typeof e?e.replaceAll(g,'<br class="esri-text-new-line" />'):e}function oe(e){const{value:t,fieldName:r,fieldInfos:n,fieldInfoMap:i,layer:a,graphic:l,timeZone:s}=e;if(null==t)return"";const f=ee({fieldName:r,value:t,graphic:l,layer:a});if(f)return f;const c=Y({fieldName:r,graphic:l,layer:a});if(c)return c;if(i.get(r.toLowerCase()))return B(t,{fieldInfos:n||Array.from(i.values()),fieldName:r,layer:a,timeZone:s});const d=a?.fieldsIndex?.get(r);return d&&(u.isAnyDateField(d)||o.isTimeOnlyField(d))?u.formatAnyDate(t,{fieldType:d.type,timeZoneOptions:{layerTimeZone:a&&"preferredTimeZone"in a?a.preferredTimeZone:null,viewTimeZone:s,datesInUnknownTimezone:!(!a||!("datesInUnknownTimezone"in a))&&!!a.datesInUnknownTimezone}}):ae(t)}function le({fieldInfos:e,attributes:t,layer:r,graphic:n,fieldInfoMap:i,relatedInfos:a,timeZone:o}){const l={};return a?.forEach((t=>ye({attributes:l,relatedInfo:t,fieldInfoMap:i,fieldInfos:e,layer:r,timeZone:o}))),t&&Object.keys(t).forEach((a=>{const u=t[a];l[a]=oe({fieldName:a,fieldInfos:e,fieldInfoMap:i,layer:r,value:u,graphic:n,timeZone:o})})),l}async function ue(e,t){const{layer:r,graphic:n,outFields:i,objectIds:a,returnGeometry:o,spatialReference:u}=e,s=a[0];if("number"!=typeof s&&"string"!=typeof s){const e="Could not query required fields for the specified feature. The feature's ID is invalid.",t={layer:r,graphic:n,objectId:s,requiredFields:i};return d().warn(e,t),null}if(!l.getEffectiveLayerCapabilities(r)?.operations?.supportsQuery){const e="The specified layer cannot be queried. The following fields will not be available.",t={layer:r,graphic:n,requiredFields:i,returnGeometry:o};return d().warn(e,t),null}const f=r.createQuery();f.objectIds=a,f.outFields=i?.length?i:[r.objectIdField],f.returnGeometry=!!o,f.returnZ=!!o,f.returnM=!!o,f.outSpatialReference=u;return(await r.queryFeatures(f,t)).features[0]}async function se(e){if(!e.expressionInfos?.length)return!1;const t=await s.loadArcade(),{arcadeUtils:{hasGeometryFunctions:r}}=t;return r(e)}async function fe({graphic:e,popupTemplate:t,layer:r,spatialReference:n},i){if(!r||!t)return;if("function"==typeof r.load&&await r.load(i),!e.attributes)return;const a=r.objectIdField,l=e.attributes[a];if(null==l)return;const u=[l],s=await t.getRequiredFields(r.fieldsIndex),f=o.featureHasFields(s,e),c=f?[]:s.includes(a)?s:[...s,a],d=t.returnGeometry||await se(t);if(f&&!d)return;const p=await ue({layer:r,graphic:e,outFields:c,objectIds:u,returnGeometry:d,spatialReference:n},i);p&&(p.geometry&&(e.geometry=p.geometry),p.attributes&&(e.attributes={...e.attributes,...p.attributes}))}function ce(e=""){return!!e&&e.includes(T)}function de(e){return e?`${T}${e.layerId}/${e.fieldName}`:""}function pe({attributes:e,graphic:t,relatedInfo:r,fieldInfos:n,fieldInfoMap:i,layer:a,timeZone:o}){e&&t&&r&&Object.keys(t.attributes).forEach((l=>{const u=de({layerId:r.relation.id.toString(),fieldName:l}),s=t.attributes[l];e[u]=oe({fieldName:u,fieldInfos:n,fieldInfoMap:i,layer:a,value:s,graphic:t,timeZone:o})}))}function ye({attributes:e,relatedInfo:t,fieldInfoMap:r,fieldInfos:n,layer:i,timeZone:a}){e&&t&&(t.relatedFeatures?.forEach((o=>pe({attributes:e,graphic:o,relatedInfo:t,fieldInfoMap:r,fieldInfos:n,layer:i,timeZone:a}))),t.relatedStatsFeatures?.forEach((o=>pe({attributes:e,graphic:o,relatedInfo:t,fieldInfoMap:r,fieldInfos:n,layer:i,timeZone:a}))))}const me=e=>{if(!e)return!1;const t=e.toUpperCase();return t.includes("CURRENT_TIMESTAMP")||t.includes("CURRENT_DATE")||t.includes("CURRENT_TIME")},be=({layer:e,method:t,query:r,definitionExpression:n})=>{if(!e.capabilities?.query?.supportsCacheHint||"attachments"===t)return;const i=null!=r.where?r.where:null,a=null!=r.geometry?r.geometry:null;me(n)||me(i)||"extent"===a?.type||"tile"===r.resultType||(r.cacheHint=!0)},ge=({query:e,layer:t,method:r})=>{be({layer:t,method:r,query:e,definitionExpression:`${t.definitionExpression} ${t.serviceDefinitionExpression??""}`})},Ie=({queryPayload:e,layer:t,method:r})=>{be({layer:t,method:r,query:e,definitionExpression:`${t.definitionExpression} ${t.serviceDefinitionExpression??""}`})};function he(e,t,r){return e&&t&&r?"sublayer"===t.type?we({layers:t.layer?.sublayers,map:e,relatedLayer:t,relationship:r})||we({layers:t.layer?.subtables,map:e,relatedLayer:t,relationship:r}):we({layers:e.allLayers,map:e,relatedLayer:t,relationship:r})||we({layers:e.allTables,map:e,relatedLayer:t,relationship:r}):null}function Fe(e,t){return e&&"utilityNetworks"in e&&t?e.utilityNetworks?.find((e=>e.isUtilityLayer(t))):null}function Te(e,t){return e?.allTables.find((e=>"feature"===e.type&&e.layerId===t.id&&e.url===t.layer?.url))}function we({map:e,relationship:t,relationship:{relatedTableId:r},relatedLayer:n,layers:i}){if(!i)return null;for(const a of i){if("map-image"===a.type){const r=we({layers:a.sublayers,map:e,relatedLayer:n,relationship:t})||we({layers:a.subtables,map:e,relatedLayer:n,relationship:t});if(r)return r;continue}if(!V(a))continue;if("sublayer"===n.type){if(a!==n&&a.id===r)return a.isTable?Te(e,a):a;continue}const i="scene"===n.type&&n.associatedLayer?n.associatedLayer.url:n.url;if(!i)return null;if("sublayer"!==a.type){if(a!==n&&a.url===i&&a.layerId===r)return a}else if(a!==n&&a.layer?.url===i&&a.id===r)return a.isTable?Te(e,a):a}return null}function Ne(e){const t=e.getObjectId();return null!=t?`oid:${t}`:`uid:${e.uid}`}e.applyTextFormattingHTML=ae,e.createFieldInfoMap=re,e.findRelatedLayer=he,e.findUtilityNetwork=Fe,e.fixTokens=S,e.formatAttributes=le,e.formatEditInfo=te,e.formatValueToFieldInfo=B,e.getAllFieldInfos=ne,e.getFieldInfo=X,e.getFieldInfoLabel=Z,e.getFixedFieldName=R,e.getFixedFieldNames=q,e.getHighlightKeyForFeature=Ne,e.getSourceLayer=N,e.graphicCallback=L,e.htmlEntities=ie,e.isAssociatedFeatureSupportedLayer=_,e.isAssociatedLayer=Q,e.isExpressionField=v,e.isFeatureSupportedLayer=P,e.isGraphicForRelatableFeatureSupportedLayer=K,e.isRelatableFeatureSupportedLayer=V,e.isRelatableLayer=H,e.isRelatedField=ce,e.preLayerQueryCallback=ge,e.preRequestCallback=Ie,e.querySourceLayer=ue,e.queryUpdatedFeature=fe,e.shouldOpenInNewTab=A,e.substituteAttributes=k,e.substituteFieldsInLinksAndAttributes=j,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
