/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../intl","../core/arrayUtils","../core/has","../core/Logger","../core/promiseUtils","../core/reactiveUtils","../core/accessorSupport/decorators/property","../core/accessorSupport/decorators/subclass","../layers/support/fieldUtils","../layers/support/layerUtils","./Widget","./Editor/components/Prompt","./FeatureForm/css","./FeatureForm/featureFormUtils","./FeatureForm/FeatureFormViewModel","../chunks/componentsUtils","./support/dataUtils","./support/dateUtils","./support/globalCss","./support/Heading","./support/widgetUtils","./support/decorators/messageBundle","./support/decorators/vmEvent","./support/jsxFactory","../intl/substitute"],(function(e,t,i,n,s,a,o,r,l,d,u,p,c,m,h,_,v,g,b,C,y,f,F,w,x,R,I){"use strict";const k="data-field-name";let O=class extends c{constructor(e,t){super(e,t),this._attemptFocusOnNextRender=!1,this._dateComponentMap=new Map,this._inputsWithChanges=new Set,this._focusedFieldName=null,this._pendingSubtypeChoice=null,this._listObserverNode=null,this._listObserver=new IntersectionObserver((e=>{e.length&&e[0].isIntersecting&&this._incrementRelatedRecordPage()}),{root:window.document}),this._prompt=null,this.groupDisplay="all",this.headingLevel=2,this.messages=null,this.messagesCommon=null,this.messagesFeature=null,this.messagesTemplates=null,this.viewModel=new v,this._onShowAllRelatedRecordsClick=e=>{const{feature:t,relatedRecordCallbacks:i}=this;t&&i?.showAllRelatedRecords&&i.showAllRelatedRecords({parentFeature:t,relationshipId:e})},this._onAddRelatedRecordsClick=(e,t)=>{const{feature:i,relatedRecordCallbacks:n}=this;i&&n?.addRelatedRecord&&n.addRelatedRecord({parentFeature:i,relatedLayer:t,relationshipId:e})},this._onFormKeyDown=this._onFormKeyDown.bind(this),this._onFormSubmit=this._onFormSubmit.bind(this),this._onGroupToggle=this._onGroupToggle.bind(this),this._onComponentBlur=this._onComponentBlur.bind(this),this._onComponentFocus=this._onComponentFocus.bind(this),this._onComponentKeyDown=this._onComponentKeyDown.bind(this),this._afterComponentCreate=this._afterComponentCreate.bind(this),this._afterComponentCreateOrUpdate=this._afterComponentCreateOrUpdate.bind(this),this._afterDateComponentCreate=this._afterDateComponentCreate.bind(this),this._afterDateComponentCreateOrUpdate=this._afterDateComponentCreateOrUpdate.bind(this),this._afterRadioGroupCreateOrUpdate=this._afterRadioGroupCreateOrUpdate.bind(this)}initialize(){this.addHandles([r.watch((()=>this.feature),(()=>{this._inputsWithChanges.clear(),this._dateComponentMap.clear(),r.whenOnce((()=>!this.viewModel.updating)).then((()=>{const e=this._getFocusableInput("forward");this._syncGroupInputStates(),this._focusedFieldName=e?.name||null,this._attemptFocusOnNextRender=!0}))})),r.watch((()=>this.groupDisplay),(()=>this._syncGroupInputStates())),this.on("submit",(e=>{if(e.invalid.length>0){const[t]=e.invalid;e.invalid.forEach((e=>this._inputsWithChanges.add(e))),this._focusedFieldName=t,this._attemptFocusOnNextRender=!0,this.scheduleRender()}})),r.watch((()=>[this.viewModel.activeRelationshipInput,this._listObserverNode]),(()=>this._onObserverChange()))])}loadDependencies(){return g.loadCalciteComponents({block:()=>new Promise(((t,i)=>e(["../chunks/calcite-block"],t,i))),button:()=>new Promise(((t,i)=>e(["../chunks/calcite-button"],t,i))),combobox:()=>new Promise(((t,i)=>e(["../chunks/calcite-combobox"],t,i))),"combobox-item":()=>new Promise(((t,i)=>e(["../chunks/calcite-combobox-item"],t,i))),"combobox-item-group":()=>new Promise(((t,i)=>e(["../chunks/calcite-combobox-item-group"],t,i))),icon:()=>new Promise(((t,i)=>e(["../chunks/calcite-icon"],t,i))),input:()=>new Promise(((t,i)=>e(["../chunks/calcite-input"],t,i))),"input-date-picker":()=>new Promise(((t,i)=>e(["../chunks/calcite-input-date-picker"],t,i))),"input-message":()=>new Promise(((t,i)=>e(["../chunks/calcite-input-message"],t,i))),"input-number":()=>new Promise(((t,i)=>e(["../chunks/calcite-input-number"],t,i))),"input-time-picker":()=>new Promise(((t,i)=>e(["../chunks/calcite-input-time-picker"],t,i))),"input-time-zone":()=>new Promise(((t,i)=>e(["../chunks/calcite-input-time-zone"],t,i))),label:()=>new Promise(((t,i)=>e(["../chunks/calcite-label"],t,i))),list:()=>new Promise(((t,i)=>e(["../chunks/calcite-list"],t,i))),"list-item":()=>new Promise(((t,i)=>e(["../chunks/calcite-list-item"],t,i))),loader:()=>new Promise(((t,i)=>e(["../chunks/calcite-loader"],t,i))),notice:()=>new Promise(((t,i)=>e(["../chunks/calcite-notice"],t,i))),"radio-button":()=>new Promise(((t,i)=>e(["../chunks/calcite-radio-button"],t,i))),"radio-button-group":()=>new Promise(((t,i)=>e(["../chunks/calcite-radio-button-group"],t,i))),switch:()=>new Promise(((t,i)=>e(["../chunks/calcite-switch"],t,i))),"text-area":()=>new Promise(((t,i)=>e(["../chunks/calcite-text-area"],t,i)))})}destroy(){this._listObserverNode&&this._listObserver.unobserve(this._listObserverNode)}get _relatedRecordsEnabled(){const e=this.relatedRecordCallbacks;return!(!e||!(e.addRelatedRecord||e.editRelatedRecord||e.showAllRelatedRecords))}get _subtypes(){return p.getSubtypesFromLayer(this.layer)}get disabled(){return this.viewModel.disabled}set disabled(e){this.viewModel.disabled=e}get feature(){return this.viewModel.feature}set feature(e){this.viewModel.feature=e}get formTemplate(){return this.viewModel.formTemplate}set formTemplate(e){this.viewModel.formTemplate=e}get icon(){return"form-field"}set icon(e){this._overrideIfSome("icon",e)}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}get layer(){return this.viewModel.layer}set layer(e){this.viewModel.layer=e}get map(){return this.viewModel.map}set map(e){this.viewModel.map=e}get relatedRecordCallbacks(){return this.viewModel.relatedRecordCallbacks}set relatedRecordCallbacks(e){this.viewModel.relatedRecordCallbacks=e}get relationshipId(){return this.viewModel.relationshipId}set relationshipId(e){this.viewModel.relationshipId=e}get spatialReference(){return this.viewModel.spatialReference}set spatialReference(e){this.viewModel.spatialReference=e}get strict(){return this.viewModel.strict}set strict(e){this.viewModel.strict=e}get timeZone(){return this.viewModel.timeZone}set timeZone(e){this.viewModel.timeZone=e}get showPrompt(){return e=>{this._prompt?.cancel?.(),this._prompt=e}}set showPrompt(e){this._overrideIfSome("showPrompt",e)}get clearPrompt(){return()=>this._prompt=null}set clearPrompt(e){this._overrideIfSome("clearPrompt",e)}getValues(){return this.viewModel.getValues()}submit(){return this.viewModel.submit()}render(){const{state:e}=this.viewModel;return R.tsx("div",{class:this.classes(h.css.base,y.globalCss.widget,y.globalCss.panel)},"ready"===e?this._renderForm():null)}_renderForm(){return R.tsx("div",null,R.tsx("form",{class:h.css.form,novalidate:!0,onkeydown:this._onFormKeyDown,onsubmit:this._onFormSubmit},this._renderHeader(),this._renderContent()),this._prompt?R.tsx(m.Prompt,{...this._prompt,headingLevel:this.headingLevel}):void 0)}_renderHeader(){const e=this.viewModel;if(!e.formHeaderVisible)return;const t=null!=e.formTitle&&R.tsx(f.Heading,{key:"title",level:this.headingLevel},e.formTitle),i=null!=e.formDescription&&R.tsx("p",{class:h.css.description,key:"description"},e.formDescription);return R.tsx("div",{class:h.css.formHeader},t,i)}_renderContent(){const{viewModel:e}=this;return e.activeRelationshipInput?this._renderRelationshipInput(e.activeRelationshipInput):e.inputs.filter(n.isSome).filter((e=>e.visible)).map((e=>this._renderInput(e)))}_renderInput(e){return _.isGroupInput(e)?this._renderGroup(e):_.isFieldInput(e)?this._renderLabeledField(e):_.isRelationshipInput(e)?this._renderRelationshipInput(e):_.isTextElementInput(e)?this._renderTextElementInput(e):void 0}_renderDescriptionOrEmpty(e,t){return null==e?null:R.tsx("div",{class:this.classes(h.css.description),id:t},e)}_renderGroup(e){const{disabled:t,formTemplate:i,headingLevel:n}=this,{description:s,id:a,inputs:o,label:r,open:l}=e,d=o.filter((e=>e.visible)),u=this.viewModel.findField(this._focusedFieldName),p=u?.group===e,c="sequential"===this.groupDisplay;return R.tsx("calcite-block",{class:this.classes(h.css.group,c?h.css.groupSequential:null,p?h.css.groupActive:null,t?h.css.inputDisabled:null),collapsible:!0,"data-group":e,description:s||void 0,disabled:t,heading:`${r}`,headingLevel:i?.title?f.incrementHeadingLevel(n):n,id:a,key:a,open:l,onCalciteBlockToggle:({target:t})=>this._onGroupToggle(t,e)},d.map((e=>this._renderInput(e))))}_getFocusableInput(e,t){const i=_.flattenInputs(this.viewModel.inputs);let n;if("backward"===e&&i.reverse(),t)if(_.isGroupInput(t)){const e=t.inputs.find((e=>e.visible));n=e?i.indexOf(e):0}else{let s;if(_.isInputInGroupInput(t)&&!t.group.open){const i=t.group.inputs.filter(_.isFieldInput);s="forward"===e?i[i.length-1]:i[0]}else s=t;n=i.indexOf(s)+1}else n=0;for(let s=n;s<i.length;s++){const e=i[s];if(e.visible&&_.isFieldInput(e))return e}return null}_renderLabeledField(e){const{dataType:t,feature:i,label:n,layer:s,required:a}=e,o={"aria-label":a?I.substitute(this.messages.requiredFieldLabel,{name:n}):n,class:h.css.label,key:`${s.id}-${i.uid}-${e.name}`},r=[R.tsx("div",{class:h.css.labelTextContent,key:"labelTextContainer"},n,a?R.tsx("span",{"aria-hidden":"true",title:this.messagesCommon.required},"*"):void 0),"unsupported"!==t?this._renderFieldInput(e):this._renderReadOnlyComponent(e),this._renderAuxiliaryText(e)];return"date"===t&&"coded-value"!==e.domain?.type?R.tsx("label",{...o},r):R.tsx("calcite-label",{...o},r)}_renderFieldInput(e){const{dataType:t,domain:i,inputType:n,name:s}=e,a=this.getCommonInputProps(e);if("coded-value"===i?.type){const t=this.viewModel.getFieldValueOptionsForField(s,this.messages.empty);return"switch"!==n||e.hasInvalidSwitchValue?"radio-buttons"===n?this._renderRadioButtonComponents(e,t.flat(),a):this._renderComboBoxComponent(e,t,a):this._renderSwitchComponent(e,a)}return"datetime-picker"===n||"date"===t?this._renderDateComponents(e,a):"number"===t?this._renderNumberComponent(e,a):this._renderStringComponent(e,a)}_renderStringComponent(e,t){return"text-area"===e.inputType?t.readOnly?R.tsx("calcite-input",{...t,loading:e.updating,type:"textarea",onCalciteInputInput:e=>this._saveValueFromComponent(e.target)}):R.tsx("calcite-text-area",{...t,resize:"vertical",onCalciteTextAreaInput:e=>this._saveValueFromComponent(e.target)}):R.tsx("calcite-input",{...t,loading:e.updating,type:"text",onCalciteInputInput:e=>this._saveValueFromComponent(e.target)})}_renderNumberComponent(e,t){return R.tsx("calcite-input-number",{...t,integer:u.isIntegerField(e.field),loading:e.updating,type:"number",onCalciteInputNumberInput:e=>this._saveValueFromComponent(e.target)})}_renderDateComponents(e,t){const{field:i}=e;switch(i.type){case"date":return this._renderDateFieldComponents(e,t);case"date-only":return this._renderDateOnlyFieldComponent(e,t);case"time-only":return this._renderTimeOnlyFieldComponent(e,t);case"timestamp-offset":return this._renderTimestampOffsetFieldComponents(e,t);default:return this._renderReadOnlyComponent(e,C.getLabelForDateFieldValue(i,t.value,{timeZone:this.timeZone,...C.getIntlOptionsForField(i)}))}}_renderDateOnlyFieldComponent(e,t){const{range:i,valid:n,value:s}=e,{class:a,key:o,readOnly:r}=t,{rawMax:l,rawMin:d}=i;return R.tsx("calcite-input-date-picker",{afterCreate:this._afterDateComponentCreate,afterUpdate:this._afterDateComponentCreateOrUpdate,"aria-invalid":!n,class:a,"data-date-part":"date","data-field-name":t[k],key:`${o}-date-input`,max:b.isString(l)?l:void 0,min:b.isString(d)?d:void 0,numberingSystem:C.numberingSystem,onblur:e=>{this._focusedFieldName=null,this._saveValueFromDateComponent(e.target)},onfocus:this._onComponentFocus,overlayPositioning:"fixed",readOnly:r,value:null!=s?`${s}`:void 0,onCalciteInputDatePickerChange:e=>this._saveValueFromDateComponent(e.target)})}_renderTimeOnlyFieldComponent(e,t){const{valid:i,value:n}=e,{class:s,key:a,readOnly:o}=t;return R.tsx("calcite-input-time-picker",{afterCreate:this._afterDateComponentCreate,afterUpdate:this._afterDateComponentCreateOrUpdate,"aria-invalid":!i,class:s,"data-date-part":"time","data-field-name":t[k],key:`${a}-time-input`,numberingSystem:C.numberingSystem,onblur:e=>{this._focusedFieldName=null,this._saveValueFromDateComponent(e.target)},onfocus:this._onComponentFocus,overlayPositioning:"fixed",readOnly:o,step:e.timeStep,value:null!=n?`${n}`:void 0,onCalciteInputTimePickerChange:e=>this._saveValueFromDateComponent(e.target)})}_renderTimestampOffsetFieldComponents(e,t){const{name:i,range:n,timeZone:s,valid:a,value:o}=e,{class:r,key:l,readOnly:d}=t,{rawMax:u,rawMin:p}=n,c={afterCreate:this._afterDateComponentCreate,afterUpdate:this._afterDateComponentCreateOrUpdate,"aria-invalid":!a,numberingSystem:C.numberingSystem,overlayPositioning:"fixed",readOnly:d,[k]:i,onfocus:this._onComponentFocus},m=C.prepareISOFieldValueForDateComponents(u,s),_=C.prepareISOFieldValueForDateComponents(p,s),v=C.prepareISOFieldValueForDateComponents(o,s);return R.tsx("div",{class:h.css.dateInputContainer,key:`${l}-date-time-container`},R.tsx("calcite-input-date-picker",{...c,class:r,"data-date-part":"date",key:`${l}-date-input`,max:m?.date??void 0,min:_?.date??void 0,onblur:e=>{this._focusedFieldName=null,this._saveValueFromDateComponent(e.target)},value:v.date??void 0,onCalciteInputDatePickerChange:e=>this._saveValueFromDateComponent(e.target)}),R.tsx("calcite-input-time-picker",{...c,class:r,"data-date-part":"time",key:`${l}-time-input`,onblur:e=>{this._focusedFieldName=null,this._saveValueFromDateComponent(e.target)},step:e.timeStep,value:v.time??void 0,onCalciteInputTimePickerChange:e=>this._saveValueFromDateComponent(e.target)}),e.includeTimeOffset?R.tsx("calcite-input-time-zone",{...c,class:r,"data-date-part":"timeZone",disabled:d,key:`${l}-timezone-input`,onblur:e=>{this._focusedFieldName=null,this._saveValueFromDateComponent(e.target)},value:v.timeZoneOffset??"0",onCalciteInputTimeZoneChange:e=>this._saveValueFromDateComponent(e.target)}):null)}_renderDateFieldComponents(e,t){const{includeTime:i,name:n,valid:s,value:a}=e,{class:o,key:r,max:l,min:d,readOnly:u}=t,{timeZone:p}=this,c={afterCreate:this._afterDateComponentCreate,afterUpdate:this._afterDateComponentCreateOrUpdate,"aria-invalid":!s,numberingSystem:C.numberingSystem,overlayPositioning:"fixed",readOnly:u,[k]:n,onfocus:this._onComponentFocus},m=C.prepareUnixFieldValueForDateComponents(a,p),_=C.prepareUnixFieldValueForDateComponents(l,p),v=C.prepareUnixFieldValueForDateComponents(d,p);return R.tsx("div",{class:h.css.dateInputContainer,key:`${r}-date-time-container`},R.tsx("calcite-input-date-picker",{...c,class:o,"data-date-part":"date",key:`${r}-date-input`,max:_?.date??void 0,min:v?.date??void 0,onblur:e=>{this._focusedFieldName=null,this._saveValueFromDateComponent(e.target)},value:m.date??void 0,onCalciteInputDatePickerChange:e=>this._saveValueFromDateComponent(e.target)}),i?R.tsx("calcite-input-time-picker",{...c,class:o,"data-date-part":"time",key:`${r}-time-input`,onblur:e=>{this._focusedFieldName=null,this._saveValueFromDateComponent(e.target)},step:1,value:m.time??void 0,onCalciteInputTimePickerChange:e=>this._saveValueFromDateComponent(e.target)}):null)}_renderReadOnlyComponent(e,t){const i=this.getCommonInputProps(e);return R.tsx("calcite-input",{...i,class:this.classes(h.css.fieldInput,h.css.inputDisabled),readOnly:!0,type:"text",value:null!=t?`${t}`:i.value})}_renderComboBoxComponent(e,t,i){const{value:n,name:s}=e,{viewModel:a,_inputsWithChanges:o}=this,r="INSERT"===a.arcadeEditType,l=o.has(s),d=null==n&&(!r||l),u=r&&e.showNoValueOptionEnabled&&!l?()=>{}:i.onblur;return R.tsx("calcite-combobox",{...i,allowCustomValues:!1,clearDisabled:!0,disabled:i.readOnly,onblur:u,overlayPositioning:"fixed",selectionMode:"single",onCalciteComboboxChange:({target:t})=>{d&&0===t.selectedItems.length?this._ignoreDeselectionOfNoValueOption(t):e.isSubtypeField&&0===t.selectedItems.length?t.value=`${e.value}`:this._saveValueFromComponent(t)}},this.renderComboboxOptionsList(e,t))}renderComboboxOptionsList(e,t){const{value:i,name:n}=e,{messages:s,messagesTemplates:a,viewModel:o,_inputsWithChanges:r}=this,[l,d,u]=t.map((e=>e.map((({name:e,value:t})=>R.tsx("calcite-combobox-item",{key:`#${t}`,selected:i===t,textLabel:e,value:`${t}`}))))),p=[];d.length>0&&p.push(R.tsx("calcite-combobox-item-group",{key:"other",label:a.other},d)),u.length>0&&p.push(R.tsx("calcite-combobox-item-group",{key:"unsupported",label:s.subtypes.unsupportedDomainGroupTitle},u)),p.length>0?p.unshift(R.tsx("calcite-combobox-item-group",{key:"recommended",label:s.recommended},l)):p.push(...l);const c="INSERT"===o.arcadeEditType,m=r.has(n),h=null==i&&(!c||m);return e.showNoValueOptionEnabled&&p.unshift(R.tsx("calcite-combobox-item",{key:"empty-option",selected:h,textLabel:e.showNoValueLabel||s.empty,value:""})),p}_renderRadioButtonComponents(e,t,i){const{name:n,value:s}=e,a=t.map((({name:e,value:t})=>this._renderRadioButtonComponent({key:e,label:e,name:n,value:t,selected:t===s,props:i})));if(e.showNoValueOptionEnabled){const t="",o=e.showNoValueLabel||this.messages.empty,r=s===t||null===s;a.unshift(this._renderRadioButtonComponent({key:"empty-option",label:o,name:n,value:t,selected:r,props:i}))}return R.tsx("calcite-radio-button-group",{afterCreate:this._afterRadioGroupCreateOrUpdate,afterUpdate:this._afterRadioGroupCreateOrUpdate,class:h.css.inputRadioGroup,"data-field-name":i[k],key:`${i.key}-radio-group`,layout:"vertical",name:i.key,required:i.required},a)}_renderSwitchComponent(e,t){const{value:i}=e,n=!!_.isFieldElementWithInputType(e.element,"switch")&&i===e.element.input.onValue;return R.tsx("calcite-switch",{...t,checked:n,class:h.css.inputSwitch,disabled:t.readOnly,onblur:()=>{this._focusedFieldName=null},onCalciteSwitchChange:e=>this._saveValueFromComponent(e.target)})}_renderRadioButtonComponent({key:e,name:t,value:i,selected:n,label:s,props:a}){return R.tsx("calcite-label",{class:h.css.inputRadioLabel,key:e,layout:"inline"},R.tsx("calcite-radio-button",{...a,afterCreate:void 0,afterUpdate:void 0,checked:n,class:h.css.inputRadio,disabled:a.readOnly,name:t,onblur:()=>{this._focusedFieldName=null},value:i,onCalciteRadioButtonChange:({target:e})=>{e.checked&&this._saveValueFromComponent(e)}}),s)}_renderAuxiliaryText(e){const t=e.name,i=this._inputsWithChanges.has(t)&&!e.valid?_.getErrorMessageForFieldInput(e,this.messages,this.timeZone):null!=this.viewModel.contingencyConstraintViolations.get(t)?this.messages.validationErrors.valuesIncompatible:null!=e.valueExpressionExecutor&&e.valueExpressionExecutor.stale?this.messages.valueExpressionError:null;return null!=i?R.tsx("calcite-input-message",{icon:!0,status:"invalid"},i):this._inputsWithChanges.has(t)&&e.valueIsOutOfDomain?R.tsx("calcite-input-message",{icon:!0,status:"idle"},this.messages.subtypes.fieldOutOfSubtypeDomainWarning):this._renderDescriptionOrEmpty(e.description)}_renderShowAllRelatedRecordsListItem(e){const{featureCount:t,relationshipId:i,showAllActionVisible:n}=e,{relatedRecordCallbacks:s}=this;if(!n||!s?.showAllRelatedRecords)return;const a=this.messages;return R.tsx("calcite-list-item",{description:I.substitute(a.totalCount,{count:t}),label:a.showAll,value:!0,onCalciteListItemSelect:()=>this._onShowAllRelatedRecordsClick(i)},R.tsx("calcite-icon",{icon:"list",scale:"s",slot:"content-end"}))}_renderAddRelatedRecordButton(e){const{canAddRelatedFeature:t,relationshipId:i,relatedLayer:n}=e,{messages:s,relatedRecordCallbacks:a}=this;if(t&&a?.addRelatedRecord&&n)return R.tsx("calcite-button",{alignment:"center",appearance:"outline-fill",class:h.css.centeredButton,disabled:e.updating||!e.originHasValidKey,iconStart:"plus",key:`${i}-add-button`,onclick:()=>{!e.updating&&e.originHasValidKey&&this._onAddRelatedRecordsClick(i,n)},round:!0,scale:"s",width:"half"},e.relatedLayerIsTable?s.addRecord:s.addFeature)}_renderRelatedRecordListItem(e,t){const{feature:i,description:n,title:s}=e,{feature:a,relatedRecordCallbacks:o}=this,{highlightHelper:r}=this.viewModel,l=()=>{r?.removeAll(),o?.editRelatedRecord&&a&&o.editRelatedRecord({parentFeature:a,relationshipId:t,relatedFeature:i})},d=r?()=>r.add(i):void 0,u=r?()=>r.remove(i):void 0;return R.tsx("calcite-list-item",{bind:this,description:n,key:`${t}-${i.uid}`,label:s,onclick:l,onmouseenter:d,onmouseleave:u,value:s},R.tsx("calcite-icon",{icon:_.getIconForFeature(i),slot:"content-start"}),R.tsx("calcite-icon",{icon:"chevron-right",scale:"s",slot:"content-end"}))}_renderRelationshipInput(e){if(!this._relatedRecordsEnabled||!e.editable)return;const{featureCount:t,relationshipId:i,showAllEnabled:n}=e,s=n?null:this._renderDescriptionOrEmpty(e.description),a=t>0?this._renderRelatedRecordsList(e):e.loaded?e.originHasValidKey?this._renderNoRelatedRecordsNotice():this._renderNoValidOriginKeyNotice(e):void 0;return R.tsx("calcite-label",{class:this.classes(h.css.label,h.css.relatedRecordsLabel),key:`relationship-${i}-container`},R.tsx("div",null,this._renderRelatedRecordsHeaderContainer(e),s,a),this._renderAddRelatedRecordButton(e))}_renderRelatedRecordsHeaderContainer(e){const t=e.updating||!e.loaded;return R.tsx("div",{class:h.css.relatedRecordsHeader,key:`relationship-${e.relationshipId}-header`},R.tsx("span",null,e.label),t?R.tsx("calcite-loader",{inline:!0,key:"loader",label:this.messagesCommon?.loading,scale:"s",type:"indeterminate"}):void 0)}_renderRelatedRecordsList(e){const{relationshipId:t}=e;return R.tsx("calcite-list",{class:h.css.relatedRecordsList},e.relatedFeatureInfos.map((e=>this._renderRelatedRecordListItem(e,t))),this._renderShowAllRelatedRecordsListItem(e),this._renderObserverNode())}_renderNoValidOriginKeyNotice(e){const{messages:t}=this,i=e.relatedLayerIsTable?t.noOriginKeyRecord:t.noOriginKeyFeature,n=e.relationship?.keyField,s=this.viewModel.findField(n),a=e.layer?.fieldsIndex.get(n),o=s?.label||a?.alias||n,r=I.substitute(i,{relatedLayerName:e.relatedLayer?.title,originKeyField:o});return R.tsx("calcite-notice",{icon:"information",kind:"brand",open:!0,scale:"s",width:"full"},R.tsx("div",{slot:"message"},r))}_renderNoRelatedRecordsNotice(){return R.tsx("calcite-notice",{icon:"information",kind:"brand",open:!0,scale:"s",width:"full"},R.tsx("div",{slot:"message"},this.messagesFeature.noRelatedFeatures))}_renderObserverNode(){if(this.viewModel.activeRelationshipInput?.showAllEnabled)return R.tsx("div",{afterCreate:this._afterListObserverCreated,afterRemoved:this._afterListObserverRemoved,bind:this,class:h.css.listObserver,key:"feature-observer"})}_renderTextElementInput(e){return R.tsx("div",{class:h.css.textElement,innerHTML:e.text,key:e.id})}getCommonInputProps(e){const{disabled:t}=this,{editable:i,hint:n,label:s,maxLength:a,minLength:o,name:r,range:{max:l,min:d},required:u,valid:p,value:c}=e,m=this._inputsWithChanges.has(r),_=!i||t;return{afterCreate:this._afterComponentCreate,afterUpdate:this._afterComponentCreateOrUpdate,"aria-invalid":p?"false":"true",class:this.classes(h.css.fieldInput,_?h.css.inputDisabled:null),status:m&&!p?"invalid":"idle",key:r,label:s,max:null!=l?l:void 0,min:null!=d?d:void 0,maxLength:a>-1?a:void 0,minLength:o>-1?o:void 0,placeholder:n??void 0,readOnly:_,required:u,value:null==c?"":`${c}`,onblur:this._onComponentBlur,onfocus:this._onComponentFocus,onkeydown:this._onComponentKeyDown,[k]:r}}_getFieldInputFromHTMLElement(e){return this.viewModel.findField(e.getAttribute(k))}_afterDateComponentCreate(e){const t=this._getFieldInputFromHTMLElement(e),i=e.dataset.datePart,n=this._dateComponentMap.get(t.name);if("valueAsDate"in e&&null!=e.value&&null!=t.value){const i=new ResizeObserver((()=>{switch(e.value=void 0,t.field.type){case"date":e.value=C.prepareUnixFieldValueForDateComponents(t.value,this.timeZone).date??"";break;case"timestamp-offset":e.value=C.prepareISOFieldValueForDateComponents(t.value,this.timeZone).date??"";break;default:e.value=`${t.value}`}i.unobserve(e)}));i.observe(e)}if(null!=n)switch(i){case"date":n.date=e;break;case"time":n.time=e;break;case"timeZone":n.timeZone=e}else this._dateComponentMap.set(t.name,{[i]:e});this._afterDateComponentCreateOrUpdate(e)}_afterDateComponentCreateOrUpdate(e){this._afterComponentCreateOrUpdate(e)}_afterComponentCreate(e){const t=this._getFieldInputFromHTMLElement(e);_.isNumberFieldInput(t)&&null!=e.value&&"setNumberValue"in e&&e.setNumberValue({committing:!1,value:e.value,origin:"direct"}),this._afterComponentCreateOrUpdate(e)}_afterRadioGroupCreateOrUpdate(e){const t=e.selectedItem,i=e.querySelector("calcite-radio-button"),n=t||i;n&&this._afterComponentCreateOrUpdate(n)}_afterComponentCreateOrUpdate(e){const{viewModel:t}=this,i=this._getFieldInputFromHTMLElement(e),n=t.findField(this._focusedFieldName);this._attemptFocusOnNextRender&&n===i&&(this._attemptFocusOnNextRender=!1,_.isInputInGroupInput(i)&&(i.group.open=!0),F.setFocus(e))}_onComponentFocus(e){const t=e.target,i=this._getFieldInputFromHTMLElement(t);this._focusedFieldName=i.name}_onComponentBlur(e){const t=e.target;this._focusedFieldName=null,this._saveValueFromComponent(t)}_saveValueFromDateComponent(e){const{timeZone:t}=this,i=this._getFieldInputFromHTMLElement(e),n=i.field.type,{name:s,range:a}=i,o=this._dateComponentMap.get(s);if(!o)return;let r=this.viewModel.getValue(s),l=null;"date-only"===n?l=Array.isArray(e.value)?e.value[0]:e.value:"time-only"===n?(r=C.normalizeTimeOnlyString(r),l=C.normalizeTimeOnlyString(e.value)):l="timestamp-offset"===n?null!=e.value?C.getISOFieldValueFromDateComponents({dateComponent:o.date,timeComponent:o.time,timeZoneComponent:o.timeZone,oldValue:r,defaultTimeZone:t}):null:null!=e.value?C.getUnixFieldValueFromDateComponents({oldValue:r,dateComponent:o.date,timeComponent:o.time,timeZone:t,max:a.max,min:a.min}):null,null!==l&&e.value?r!==l&&this._updateFieldValue(s,l):this._updateFieldValue(s,null)}_saveValueFromComponent(e){const t=this._getFieldInputFromHTMLElement(e),i=this._parseValue(e),n=t.value;t.isSubtypeField&&_.subtypeChangeShouldPrompt(this.layer,n,i)?this._pendingSubtypeChoice||i===n||(this._pendingSubtypeChoice=this._handleSubtypeChoice(t,i)):this._updateFieldValue(t.name,i)}async _handleSubtypeChoice(e,t){const{value:i,name:n}=e,{messages:s,viewModel:a,messagesCommon:r,_subtypes:l}=this;if(this._updateFieldValue(n,t),!l?.length)return;const d=l.find((e=>e.code===t)),u=l.find((e=>e.code===i))?.name??`${i}`;if(!d)return;a.hasPendingSubtypeChoice=!0;const p=o.createResolver();let c="update-fields";const m=[{label:s.subtypes.useDefaultValuesOption,value:"update-fields"},{label:s.subtypes.keepCurrentValuesOption,value:"keep-existing"}],h={context:"info",title:s.subtypes.changeWarningTitle,message:I.substitute(s.subtypes.changeWarning,{originalType:u,newType:d.name}),radios:m,defaultRadioSelection:"update-fields",onRadioSelection:e=>c=e,actions:{primary:{label:r.apply,action:()=>p.resolve(c),type:"positive"},secondary:{label:r.cancel,type:"neutral",action:()=>p.resolve("undo")}},cancel:()=>p.reject()};try{this.showPrompt(h);switch(await p.promise){case"update-fields":a.applySubtypeDefaults(d),this._validateContingenciesForNonNullFields();break;case"keep-existing":this._validateContingenciesForNonNullFields();break;case"undo":this._updateFieldValue(e.name,i)}}finally{a.hasPendingSubtypeChoice=!1,this.clearPrompt(),this._pendingSubtypeChoice=null}}_onComponentKeyDown({key:e,target:t}){const i=this._getFieldInputFromHTMLElement(t);"Enter"===e&&_.isInputInGroupInput(i)&&!i.group.open&&(i.group.open=!0)}_updateFieldValue(e,t){const i=this.viewModel.getValue(e);this.viewModel.setValue(e,t),this._inputsWithChanges.add(e);i!==t&&this.viewModel.fieldsWithContingentValues.has(e)&&this._validateContingenciesForNonNullFields()}_validateContingenciesForNonNullFields(){const e=Object.fromEntries(Object.entries(this.getValues()).filter((([e,t])=>null!=t)));this.viewModel.validateContingencyConstraints(e)}_parseValue(e){const t=this._getFieldInputFromHTMLElement(e),i=e.value;return _.isFieldElementWithInputType(t.element,"switch")?e.checked?t.element.input.onValue:t.element.input.offValue:null==i||""===i?null:"number"===t.dataType?"-0"===i||"-0."===i||"-0,"===i?i:parseFloat(i):"date"===t.field.type?parseFloat(i):i}_ignoreDeselectionOfNoValueOption(e){const{firstChild:t,selectedItems:i}=e;0===i.length&&t&&"selected"in t?t.selected=!0:a.getLogger(this).warnOnce("Failed to override user attempt to deselect 'No value' option.")}_onGroupToggle(e,t){e.open?(t.open=!0,this._focusedFieldName=this._getFocusableInput("forward",t)?.name||null,this._attemptFocusOnNextRender=!0,"sequential"===this.groupDisplay&&this.viewModel.allGroupInputs.forEach((e=>{e!==t&&(e.open=!1)}))):t.open=!1,this.scheduleRender()}_onFormSubmit(e){e.preventDefault()}_onFormKeyDown(e){"Enter"===e.key&&this.viewModel.submit()}_afterListObserverCreated(e){this.viewModel.activeRelationshipInput&&(this._listObserverNode=e)}_afterListObserverRemoved(){this._listObserverNode=null}_onObserverChange(){this._listObserverNode&&this._listObserver.unobserve(this._listObserverNode);const e=this.viewModel.activeRelationshipInput;e&&this._listObserverNode&&e.showAllEnabled&&this._listObserver.observe(this._listObserverNode)}_incrementRelatedRecordPage(){const e=this.viewModel.activeRelationshipInput;e?.incrementPage()}_syncGroupInputStates(){if("sequential"!==this.groupDisplay)return;const e=this.viewModel.allGroupInputs;if(!e.length)return;const t=e.filter((e=>e.open));0===t.length?e[0].open=!0:t.length>1&&t.slice(1).forEach((e=>e.open=!1))}get test(){return{inputsWithChanges:this._inputsWithChanges,updateValue:this._saveValueFromComponent.bind(this)}}};t.__decorate([l.property()],O.prototype,"_listObserverNode",void 0),t.__decorate([l.property()],O.prototype,"_relatedRecordsEnabled",null),t.__decorate([l.property()],O.prototype,"_prompt",void 0),t.__decorate([l.property()],O.prototype,"_subtypes",null),t.__decorate([l.property()],O.prototype,"disabled",null),t.__decorate([l.property()],O.prototype,"feature",null),t.__decorate([l.property()],O.prototype,"formTemplate",null),t.__decorate([l.property()],O.prototype,"groupDisplay",void 0),t.__decorate([l.property()],O.prototype,"headingLevel",void 0),t.__decorate([l.property()],O.prototype,"icon",null),t.__decorate([l.property()],O.prototype,"label",null),t.__decorate([l.property()],O.prototype,"layer",null),t.__decorate([l.property()],O.prototype,"map",null),t.__decorate([l.property(),w.messageBundle("esri/widgets/FeatureForm/t9n/FeatureForm")],O.prototype,"messages",void 0),t.__decorate([l.property(),w.messageBundle("esri/t9n/common")],O.prototype,"messagesCommon",void 0),t.__decorate([l.property(),w.messageBundle("esri/widgets/Feature/t9n/Feature")],O.prototype,"messagesFeature",void 0),t.__decorate([l.property(),w.messageBundle("esri/widgets/FeatureTemplates/t9n/FeatureTemplates")],O.prototype,"messagesTemplates",void 0),t.__decorate([l.property()],O.prototype,"relatedRecordCallbacks",null),t.__decorate([l.property()],O.prototype,"relationshipId",null),t.__decorate([l.property()],O.prototype,"spatialReference",null),t.__decorate([l.property()],O.prototype,"strict",null),t.__decorate([l.property()],O.prototype,"timeZone",null),t.__decorate([l.property()],O.prototype,"showPrompt",null),t.__decorate([l.property()],O.prototype,"clearPrompt",null),t.__decorate([l.property(),x.vmEvent(["value-change","submit"])],O.prototype,"viewModel",void 0),t.__decorate([l.property()],O.prototype,"test",null),O=t.__decorate([d.subclass("esri.widgets.FeatureForm")],O);return O}));
