/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../core/Error","../../core/reactiveUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/Logger","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../../layers/support/domainUtils","../../layers/support/fieldUtils","../../smartMapping/support/utils","../Feature/support/featureUtils","./EditableInput","./featureFormUtils","../support/dataUtils","../support/dateUtils","../support/forms/formUtils"],(function(e,t,i,r,l,n,a,o,s,u,p,d,y,m,c,h,_){"use strict";let f=class extends y{constructor(e){super(e),this._storedValue=null,this.error=null,this.preservesValueWhenHidden=!0,this.field=null,this.group=null,this.requiredExpressionExecutor=null,this.type="field",this._fieldInputWasVisibleDuringLifetime=!1,this.valueExpressionExecutor=null}initialize(){this.addHandles(i.watch((()=>this.feature),(()=>this._fieldInputWasVisibleDuringLifetime=!1),i.sync))}get _dateFormRange(){const{element:e,field:t}=this;if("date"!==this.dataType)return{};const i=e?.domain?s.getDomainRange(t,e.domain):null;if(!e?.input)return i??{};const r=e.input,{type:l}=r;let n={};if("date-picker"!==l&&"time-picker"!==l&&"datetimeoffset-picker"!==l||(n=s.dateTimeFieldValuesToNumericRange(t,r.max,r.min)),"datetime-picker"===l){const{max:e,min:t}=r;n={max:null!=e&&g(e)?e.getTime():null,min:null!=t&&g(t)?t.getTime():null}}const{max:a,min:o}=n;if(i){const{max:e,min:t}=i,r=c.isNumber(e)&&(null==a||null!=a&&e<a),l=c.isNumber(t)&&(null==o||null!=o&&t>o);return{max:r?e:a??null,min:l?t:o??null,rawMax:r?i.rawMax:n?.rawMax??null,rawMin:l?i.rawMin:n?.rawMin??null}}return{min:o,max:a,rawMax:n?.rawMax??null,rawMin:n?.rawMin??null}}get _dateRange(){const{_dateFormRange:e,field:t}=this;if("date"!==this.dataType)return{};const i=s.getDomainRange(t);if(!i)return e;const{max:r,min:l,rawMax:n,rawMin:a}=e;if("date"===t.type){const{max:e,min:t}=i;return{max:c.isNumber(r)&&(null===e||null!=e&&r<e)?r:e??null,min:c.isNumber(l)&&(null===t||null!=t&&l>t)?l:t??null}}if("date-only"===t.type||"time-only"===t.type||"timestamp-offset"===t.type){const{max:e,min:t,rawMax:o,rawMin:s}=i,u=c.isNumber(r)&&n&&(null==e||r<e);return{max:u?r:e,min:c.isNumber(l)&&a&&(null==t||l>t)?l:t,rawMax:u?n:o,rawMin:u?a:s}}return{max:null,min:null}}get _configAllowsEdits(){const{element:e,layer:t,name:i}=this;if(null!=e)return e.editableExpression?!!this.evaluatedEditableExpression:!1!==e.editable;if(t?.userHasUpdateItemPrivileges)return!0;const r=t&&"popupTemplate"in t?t?.popupTemplate?.fieldInfos?.find((({fieldName:e})=>e===i)):null;return r?.isEditable??!0}get _layerAndFieldAllowEdits(){return this.layerAllowsEdits&&this.field?.editable}get _isVisibleByDefault(){const{field:e,layer:t}=this;return!!e?.visible&&u.isFieldVisibleByDefault(e,t)}get _isEditTrackingField(){return u.getLowerCaseEditTrackingFields(this.layer).includes(this.name?.toLowerCase())}get _shouldUseValueExpression(){return this._layerAndFieldAllowEdits&&!this._configAllowsEdits&&null!=this.valueExpressionExecutor}get isSubtypeField(){const{layer:e}=this;if(e&&"subtypeField"in e){const{subtypeField:t,fieldsIndex:i}=e;return(i.get(t)?.name??t)===this.name}return!1}get valueIsOutOfDomain(){const{domain:e,value:t,field:i}=this;return!(!e||null==t)&&null!==s.validateDomainValue(i,t,e)}get dataType(){const{field:e}=this;return u.isNumericField(e)?_.FieldInputDataTypes.Number:u.isStringField(e)?_.FieldInputDataTypes.Text:p.isAnyDateField(e)||u.isTimeOnlyField(e)?_.FieldInputDataTypes.Date:_.FieldInputDataTypes.Unsupported}get dateDataType(){if(this.dataType===_.FieldInputDataTypes.Date)return"date"!==this.field.type?"string":"number"}get domain(){const{layer:e,feature:t,name:i,element:r}=this,l=r?.domain;return null!=l&&this._isDomainCompatible(l)?l:e.getFieldDomain(i,{feature:t})}get editable(){return!!this._layerAndFieldAllowEdits&&(this.evaluatedEditableExpression??this._configAllowsEdits)}get evaluatedRequiredExpression(){const{requiredExpressionExecutor:e}=this;return null!=e?!!e.lastEvaluatedValue:null}get evaluatedValueExpression(){const{valueExpressionExecutor:e}=this;return null!=e?e.lastEvaluatedValue:null}get hint(){return this.element?.hint}get includeDate(){return!(this.dataType!==_.FieldInputDataTypes.Date||"time-only"===this.field.type)}get includeTime(){const{element:e,field:t}=this;if(this.dataType!==_.FieldInputDataTypes.Date)return!1;if("time-only"===t.type)return!0;if("date-only"===t.type)return!1;const i="datetime-picker"===e?.input?.type?e.input.includeTime:void 0;return void 0===i||i}get includeTimeOffset(){if("timestamp-offset"!==this.field.type)return!1;const e=this.element?.input;return!e||"datetimeoffset-picker"===e.type&&e.includeTimeOffset}set initialFeature(e){this._set("initialFeature",e),this.notifyChange("valid")}get inputType(){return this.element?.input?.type}get hasInvalidSwitchValue(){const{element:e}=this,t=m.isFieldElementWithInputType(e,"switch")?e.input:null;return!t||m.valueIsInvalidSwitchValue(this.value,t)}get isRelationshipKeyField(){const{field:e,layer:t}=this;return d.isRelatableFeatureSupportedLayer(t)&&!!t.relationships?.some((t=>t.keyField===e.name))}get label(){const{field:e}=this;return this.getFormattedLabel(this.element?.label)??e.alias??e.name}get maxLength(){const e=-1;if(this.dataType===_.FieldInputDataTypes.Date)return e;const{field:t,element:i}=this,r=t?.length??-1,l=m.isFieldElementWithTextInput(i)?i.input.maxLength:NaN;return null!=l&&!isNaN(l)&&l>=e&&(r===e||l<=r)?l:r}get minLength(){const e=-1;if(this.dataType===_.FieldInputDataTypes.Date)return e;const{field:t,element:i}=this,r=t?.length??-1,l=m.isFieldElementWithTextInput(i)?i.input.minLength:NaN;return null!=l&&!isNaN(l)&&l>=e&&(r===e||l<=r)?l:e}get name(){return this.field?.name}get range(){const{domain:e,element:t,field:i}=this;if("date"===this.dataType)return this._dateRange;const r=s.getDomainRange(i,e)||u.getFieldRange(i,e),l=r?.max===Number.MAX_VALUE?null:r?.max??null,n=r?.min===-Number.MAX_VALUE?null:r?.min??null;if(!t?.domain||"range"!==t.domain.type)return{max:l,min:n};const{max:a,min:o}=s.getDomainRange(i)||{};return{max:null!=a&&(null===l||null!=l&&a<l)?a:l,min:null!=o&&(null===n||null!=n&&o>n)?o:n}}get required(){const{editable:e,evaluatedRequiredExpression:t,field:i,visible:r,isSubtypeField:l}=this;if(!e)return!1;if(!1===i?.nullable)return!0;if(l)return!0;return!(!r||!1===this.group?.visible||null==t)&&t}set required(e){this._overrideIfSome("required",e)}get showNoValueOptionEnabled(){const{element:e}=this;return!this.required&&(!m.isFieldElementWithShowNoValueOptionInput(e)||e.input.showNoValueOption)}get showNoValueLabel(){const{element:e}=this;return m.isFieldElementWithShowNoValueOptionInput(e)?e.input.noValueOptionLabel:null}get submittable(){const{field:e,required:t,valid:i,value:r}=this;return(!t||null!=r)&&(!!i||this.initialFeature.getAttribute(e.name)===r)}get timeResolution(){const e=this.element?.input;if(e&&("datetimeoffset-picker"===e.type||"time-picker"===e.type))return e.timeResolution??"minutes"}get timeStep(){return null!=this.timeResolution?h.timeResolutionToStepMap.get(this.timeResolution):void 0}get updating(){const{editableExpressionExecutor:e,valueExpressionExecutor:t,visibilityExpressionExecutor:i,preservesValueWhenHidden:r}=this;return null!=t&&t.updating||null!=e&&e.updating||!1===r&&null!=i&&i.updating}get valid(){const e=this.editable?this._validate():null;return this._set("error",e),null===e}get value(){if(this._fieldInputWasVisibleDuringLifetime=this._fieldInputWasVisibleDuringLifetime||this.visible&&!1!==this.group?.visible,!1===this.preservesValueWhenHidden&&this._fieldInputWasVisibleDuringLifetime&&(!1===this.visibilityExpressionExecutor?.lastEvaluatedValue||!1===this.group?.visibilityExpressionExecutor?.lastEvaluatedValue))return null!==this._storedValue&&this.set("_storedValue",null),null;if(this._shouldUseValueExpression){const e=this.evaluatedValueExpression;return this.dataType===_.FieldInputDataTypes.Date?this._arcadeOutputToDateFieldValue(e):null!=e&&"object"==typeof e?e.toString():e}return this._storedValue}set value(e){this.notifyChange("evaluatedVisibilityExpression"),this.set("_storedValue",e)}get visible(){return!this._isEditTrackingField&&(null!=this.evaluatedVisibilityExpression?this.evaluatedVisibilityExpression:null!=this.element&&!1!==this.field?.visible||this._isVisibleByDefault)}_arcadeOutputToDateFieldValue(e){const i=this.field.type;try{if("object"==typeof e){if(null===e)throw new t("feature-form:invalid-date-value");if(h.isArcadeDate(e))return h.arcadeDateToFieldValue(e,i);if("getTime"in e&&"function"==typeof e.getTime&&"date"===i)return parseInt(e.getTime(),10);if("date-only"===i||"time-only"===i||"timestamp-offset"===i)return e.toString()}else{if("string"==typeof e)return"date"===i?parseInt(e,10):e;if("number"==typeof e&&"date"===i)return e}throw new t("feature-form:invalid-date-value")}catch{return"date"===i?NaN:""}}_isDomainCompatible(e){const{field:t}=this;if("coded-value"===e?.type){const i=typeof e.codedValues[0].code;if("string"===i&&u.isStringField(t)||"number"===i&&u.isNumericField(t))return!0}return!!("range"===e?.type&&u.isNumericField(t)||p.isAnyDateField(t)||u.isTimeOnlyField(t))}_validate(){const{dataType:e,domain:t,field:i,initialFeature:r,minLength:l,range:n,required:a,valid:o,value:p,maxLength:d}=this,y=a&&null==p,c=void 0!==o;if(!y&&r.getAttribute(i.name)===p&&c)return null;if(y)return u.TypeValidationError.INVALID_TYPE;if("text"===e&&"string"==typeof p){if(l>-1&&p.length<l)return m.LengthValidationError.TOO_SHORT;if(d>-1&&p.length>d)return m.LengthValidationError.TOO_LONG}return"date"!==e||null==p||h.dateTimeIsInRange({type:i.type,range:n,value:p})?t?null!==p||a?s.validateDomainValue(i,p,t):null:u.validateFieldValue(i,p):u.NumericRangeValidationError.OUT_OF_RANGE}};e.__decorate([r.property()],f.prototype,"_dateFormRange",null),e.__decorate([r.property()],f.prototype,"_dateRange",null),e.__decorate([r.property()],f.prototype,"_storedValue",void 0),e.__decorate([r.property()],f.prototype,"_configAllowsEdits",null),e.__decorate([r.property()],f.prototype,"_layerAndFieldAllowEdits",null),e.__decorate([r.property()],f.prototype,"_isVisibleByDefault",null),e.__decorate([r.property()],f.prototype,"_isEditTrackingField",null),e.__decorate([r.property()],f.prototype,"_shouldUseValueExpression",null),e.__decorate([r.property()],f.prototype,"isSubtypeField",null),e.__decorate([r.property()],f.prototype,"valueIsOutOfDomain",null),e.__decorate([r.property()],f.prototype,"dataType",null),e.__decorate([r.property()],f.prototype,"dateDataType",null),e.__decorate([r.property()],f.prototype,"domain",null),e.__decorate([r.property()],f.prototype,"editable",null),e.__decorate([r.property({readOnly:!0})],f.prototype,"error",void 0),e.__decorate([r.property({constructOnly:!0})],f.prototype,"preservesValueWhenHidden",void 0),e.__decorate([r.property()],f.prototype,"evaluatedRequiredExpression",null),e.__decorate([r.property()],f.prototype,"evaluatedValueExpression",null),e.__decorate([r.property()],f.prototype,"field",void 0),e.__decorate([r.property()],f.prototype,"group",void 0),e.__decorate([r.property({readOnly:!0})],f.prototype,"hint",null),e.__decorate([r.property()],f.prototype,"includeDate",null),e.__decorate([r.property()],f.prototype,"includeTime",null),e.__decorate([r.property()],f.prototype,"includeTimeOffset",null),e.__decorate([r.property()],f.prototype,"initialFeature",null),e.__decorate([r.property({readOnly:!0})],f.prototype,"inputType",null),e.__decorate([r.property()],f.prototype,"hasInvalidSwitchValue",null),e.__decorate([r.property()],f.prototype,"isRelationshipKeyField",null),e.__decorate([r.property()],f.prototype,"label",null),e.__decorate([r.property()],f.prototype,"maxLength",null),e.__decorate([r.property()],f.prototype,"minLength",null),e.__decorate([r.property({readOnly:!0})],f.prototype,"name",null),e.__decorate([r.property()],f.prototype,"range",null),e.__decorate([r.property()],f.prototype,"required",null),e.__decorate([r.property()],f.prototype,"requiredExpressionExecutor",void 0),e.__decorate([r.property()],f.prototype,"showNoValueOptionEnabled",null),e.__decorate([r.property()],f.prototype,"submittable",null),e.__decorate([r.property()],f.prototype,"timeResolution",null),e.__decorate([r.property()],f.prototype,"timeStep",null),e.__decorate([r.property({readOnly:!0})],f.prototype,"type",void 0),e.__decorate([r.property()],f.prototype,"updating",null),e.__decorate([r.property()],f.prototype,"valid",null),e.__decorate([r.property({value:null})],f.prototype,"value",null),e.__decorate([r.property()],f.prototype,"valueExpressionExecutor",void 0),e.__decorate([r.property()],f.prototype,"visible",null),f=e.__decorate([o.subclass("esri.widgets.FeatureForm.FieldInput")],f);const g=e=>e&&!Number.isNaN(e.valueOf());return f}));
