/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../intl","../../core/arrayUtils","../../core/compilerUtils","../../core/lang","../../core/Logger","../../core/string","../../form/support/formUtils","../../layers/support/domainUtils","../../layers/support/fieldUtils","../../layers/support/layerUtils","../../smartMapping/support/utils","../support/dateUtils","../../intl/substitute"],(function(e,t,n,i,r,l,o,a,s,u,p,d,m,c){"use strict";const f=e=>"field"===e?.type,y=e=>"group"===e?.type,g=e=>"relationship"===e?.type,F=e=>"text"===e.type,b=e=>!y(e)&&null!=e.group,x=e=>e.reduce(((e,t)=>y(t)?[...e,...t.inputs]:[...e,t]),[]),h=e=>x(e).filter(f),T=e=>x(e).filter(g),I=e=>null!=e&&(E(e,"combo-box")||E(e,"radio-buttons")),E=(e,t)=>null!=e&&e.input?.type===t,V=e=>null!=e&&(E(e,"text-box")||E(e,"text-area")),O=({domain:e,inputType:t="text-box",dataType:n})=>"number"===n&&"text-box"===t&&(!e||"coded-value"!==e.type);function v(e){const{attributes:t,fieldsIndex:i,label:r,timeZone:l}=e;if(!t||"object"!=typeof t)return r;const a=Object.keys(t).filter((e=>o.templateHasKey(r,e))),s=a.map((e=>t[e])),u=a.map((e=>i.get(e))).filter(n.isSome);return w(r,D({values:s,fields:u,timeZone:l}))}const N="expression/",L="expr/",S="field/";function R(e){const[t,n]=e.split(N);return""===t&&n?n:(l.getLogger("esri.widgets.FeatureForm/featureFormUtils").error("extractExpressionNameFromString:invalid-input",`The string ${e} is not a valid expression reference of the form '${N}/expressionName'`),"")}function U(e){return`${N}${e}`}function _(e){return`${S}${e}`}function j(e){return e.startsWith(N)}function A(e){return e.startsWith(L)}function D(e){const{fields:t,values:n}=e,i=e.timeZone??void 0,r=t.map(((e,t)=>{let r=n[t];if(e.domain&&"coded-value"===e.domain.type){const t=e.domain.codedValues.find((e=>e.code===r));t?.name&&(r=t.name)}return(d.isAnyDateField(e)||u.isTimeOnlyField(e))&&(r=m.getLabelForDateFieldValue(e,r,{timeZone:i,...m.getIntlOptionsForField(e)})),[e.name,r]}));return Object.fromEntries(r)}function w(e,t){return o.replace(o.replace(e,(e=>`{${e.toLowerCase()}}`)),Object.fromEntries(Object.entries(t).map((([e,t])=>[e.toLowerCase(),t]))))}const C=e=>{const t={typeFieldName:null,types:[]};return e?("subtype-sublayer"===e.type?(t.typeFieldName=e.parent?.subtypeField,t.types=e.parent?.subtypes??[]):"subtype-group"===e.type||"feature"===e.type&&e.subtypes?.length?(t.typeFieldName=e.subtypeField,t.types=e.subtypes??[]):"types"in e&&e.types&&(t.typeFieldName=e.typeIdField,t.types=e.types.map((({id:e,name:t,domains:n})=>({code:e,name:t,domains:n})))),null!=t.typeFieldName&&(t.typeFieldName=e.getField(t.typeFieldName)?.name??t.typeFieldName),t):t};var $;e.LengthValidationError=void 0,($=e.LengthValidationError||(e.LengthValidationError={})).TOO_SHORT="length-validation-error::too-short",$.TOO_LONG="length-validation-error::too-long";const G={type:"number"},H={type:"number",intlOptions:{notation:"scientific"}};function M(e){return e>=1e7||e<=-1e7}function P(e,{validationErrors:t}){return null!=e.max&&null!=e.min?t.outsideRange:null!=e.max?t.outsideRangeMax:t.outsideRangeMin}const W=(t,n,i)=>{const{dataType:r,error:l,minLength:o,value:a,required:p}=t,d=n?.validationErrors;if(!d||!l)return null;if(p&&null===a)return d.cannotBeNull;if(l===s.DomainValidationError.VALUE_OUT_OF_RANGE||l===u.NumericRangeValidationError.OUT_OF_RANGE){const{field:e,range:l}=t,o={type:"date",intlOptions:{timeZone:"date"===e.type&&i?i:void 0,...m.getIntlOptionsForField(e)}},a=P(l,n);return c.substitute(a,l,{format:{max:"date"===r?o:null!=l.max&&M(l.max)?H:G,min:"date"===r?o:null!=l.min&&M(l.min)?H:G}})}return l===s.DomainValidationError.INVALID_CODED_VALUE?d.invalidCodedValue:l===u.TypeValidationError.INVALID_TYPE?d.invalidType:l===e.LengthValidationError.TOO_SHORT?c.substitute(d.tooShort,{min:o}):(e.LengthValidationError.TOO_LONG,null)},Z=e=>{if(!e)return;const t=e.layer,n=t&&"geometryType"in t?t.geometryType:void 0,i=e.geometry?.type;return"polyline"===i||"polyline"===n?"line":"mesh"===i||"mesh"===n||"multipatch"===n?"cube":"multipoint"===i||"multipoint"===n?"point":i||n||"table"},K=e=>{const t=[];if(e.formTemplate){const{description:n,title:i}=e.formTemplate;e.fields?.forEach((e=>{const r=i&&o.templateHasKey(i,e.name),l=n&&o.templateHasKey(n,e.name);(r||l)&&t.push(e.name)}))}return t};function q(e,t){const n=t??("formTemplate"in e&&e.formTemplate);if(n){return(n.elements?.filter(a.isFieldElement)??[]).some((({fieldName:t})=>!e.fieldsIndex.get(t)))}return!1}function k(e,t){return null==e||t.onValue!==e&&t.offValue!==e}function z(e,t){switch(t.objectType){case"any":return!0;case"null":return null==e;case"code":return e===t.codedValue?.code;case"range":return null!=e&&null!=t.minValue&&null!=t.maxValue&&+e>=t.minValue&&+e<=t.maxValue;default:return i.neverReached(t.objectType),!1}}function B(e,t,n){const i=p.getSubtypesFromLayer(e),l=i?.find((e=>e.code===n));if(!l)return!1;const o=i?.find((e=>e.code===t));return!r.equalsShallow(l.defaultValues,o?.defaultValues)&&Object.values(l.defaultValues).some((e=>null!=e))}e.extractExpressionNameFromString=R,e.flattenFieldInputs=h,e.flattenInputs=x,e.flattenRelationshipInputs=T,e.formTemplateHasInvalidFields=q,e.getComputedAttributes=D,e.getErrorMessageForFieldInput=W,e.getFieldsInTitleAndDesc=K,e.getIconForFeature=Z,e.getNormalizedFeatureTypeInfo=C,e.isExpressionReference=j,e.isFieldElementWithInputType=E,e.isFieldElementWithShowNoValueOptionInput=I,e.isFieldElementWithTextInput=V,e.isFieldInput=f,e.isGroupInput=y,e.isInputInGroupInput=b,e.isLegacyFieldMapsExpressionReference=A,e.isNumberFieldInput=O,e.isRelationshipInput=g,e.isTextElementInput=F,e.parseFormTemplateString=v,e.prependExpressionPrefix=U,e.prependFieldPrefix=_,e.substituteFieldTemplatesInString=w,e.subtypeChangeShouldPrompt=B,e.valueIsInvalidSwitchValue=k,e.valueIsValidContingentValue=z,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
