/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../intl","../core/arrayUtils","../core/reactiveUtils","../core/unitFormatUtils","../core/accessorSupport/decorators/property","../core/has","../core/Logger","../core/accessorSupport/decorators/subclass","../layers/catalog/catalogUtils","../layers/support/layerUtils","../tables/AttributeTableTemplate","./Widget","./Attachments/support/attachmentUtils","./Editor/components/Prompt","./FeatureTable/ColumnMenuVisibleElements","./FeatureTable/FeatureTableViewModel","./FeatureTable/VisibleElements","./FeatureTable/support/tableUtils","../chunks/componentsUtils","./support/globalCss","./support/widgetUtils","./support/decorators/messageBundle","./support/decorators/vmEvent","./support/jsxFactory","../intl/substitute"],(function(e,t,i,o,l,s,n,r,a,c,d,h,p,u,m,g,w,b,_,y,v,f,M,C,S,T,A){"use strict";var x;const E="esri-feature-table",I=`${E}__prompt`,V=`${E}__attachments-view`,k={base:E,content:`${E}__content`,menuPopover:`${E}__menu-popover`,layerDropdownMenu:`${E}__layer-switcher-menu`,tableContainer:`${E}__table-container`,tableContainerWithAttachments:`${E}__table-container--attachments`,tableNavigation:`${E}__table-navigation`,attachmentsView:V,attachmentsViewContent:`${V}__content`,attachmentsViewDropArea:`${V}__drop-area`,attachmentsViewIcon:`${V}__icon`,attachmentsViewInformation:`${V}__information`,attachmentsViewList:`${V}__list`,attachmentsViewListFileSize:`${V}__list__filesize`,attachmentsViewListItemDelete:`${V}__list-item--delete`,attachmentsViewListThumbnail:`${V}__list__thumbnail`,expanded:`${E}__expanded`,collapsed:`${E}__collapsed`,promptContainer:I,promptHeader:`${I}__header`,promptHeading:`${I}__header__heading`,promptMessage:`${I}__message`,promptDivider:`${I}__divider`,promptActions:`${I}__actions`},R={attachment:"attachment",chevronDown:"chevron-down",chevronLeft:"chevron-left",chevronRight:"chevron-right",clearSelection:"clear-selection",downloadTo:"download-to",exclamationMarkTriangle:"exclamation-mark-triangle",exportToCSV:"file-csv",folderOpen:"folder-open",delete:"trash",launch:"launch",layers:"layers",moveUp:"move-up",plus:"plus",refresh:"refresh",replaceImage:"replace-image",save:"save",showAll:"selection-x",showColumn:"show-column",showSelected:"selection-filter",upload:"upload",zoomToSelection:"zoom-to-object"};let P=x=class extends u{constructor(e,t){super(e,t),this._attachmentsInput=null,this._columnVisibilityActions=new Map,this.attachmentsList=null,this.description=null,this.disabled=!1,this.layers=null,this.menuConfig=null,this.title=null,this.viewModel=new b,this.visibleElements=new _,this._showDeletePrompt=this._showDeletePrompt.bind(this),this._onDeleteSelectionClick=this._onDeleteSelectionClick.bind(this)}initialize(){this.addHandles([l.watch((()=>[this.viewModel.store.querying,this.viewModel.store.syncing,this.editingEnabled]),(()=>this.scheduleRender())),l.watch((()=>[this._effectiveVisibleElements,this._effectiveVisibleElements.columnDescriptions,this._effectiveVisibleElements.columnMenus,this._effectiveVisibleElements.columnMenuItems,this.columns.length]),(()=>{this.columns.forEach((e=>e.visibleElements=this._effectiveVisibleElements)),this.refreshCellContent()}),l.sync),l.watch((()=>this._effectiveVisibleElements.selectionColumn),(e=>{this.grid&&(this.grid.selectionColumnEnabled=e)}),l.initial),l.on((()=>this.viewModel),"show-related-table",(e=>this._onShowRelatedTable(e))),l.watch((()=>this.editingEnabled),(()=>{const{attachmentsViewOptions:e}=this;this.clearPrompt(),e&&(e.form?.reset(),e.candidates=null)}))])}loadDependencies(){return Promise.all([v.loadCalciteComponents({action:()=>new Promise(((t,i)=>e(["../chunks/calcite-action"],t,i))),alert:()=>new Promise(((t,i)=>e(["../chunks/calcite-alert"],t,i))),button:()=>new Promise(((t,i)=>e(["../chunks/calcite-button"],t,i))),chip:()=>new Promise(((t,i)=>e(["../chunks/calcite-chip"],t,i))),dropdown:()=>new Promise(((t,i)=>e(["../chunks/calcite-dropdown"],t,i))),"dropdown-group":()=>new Promise(((t,i)=>e(["../chunks/calcite-dropdown-group"],t,i))),"dropdown-item":()=>new Promise(((t,i)=>e(["../chunks/calcite-dropdown-item"],t,i))),icon:()=>new Promise(((t,i)=>e(["../chunks/calcite-icon"],t,i))),label:()=>new Promise(((t,i)=>e(["../chunks/calcite-label"],t,i))),list:()=>new Promise(((t,i)=>e(["../chunks/calcite-list"],t,i))),"list-item":()=>new Promise(((t,i)=>e(["../chunks/calcite-list-item"],t,i))),pagination:()=>new Promise(((t,i)=>e(["../chunks/calcite-pagination"],t,i))),panel:()=>new Promise(((t,i)=>e(["../chunks/calcite-panel"],t,i))),popover:()=>new Promise(((t,i)=>e(["../chunks/calcite-popover"],t,i))),progress:()=>new Promise(((t,i)=>e(["../chunks/calcite-progress"],t,i))),switch:()=>new Promise(((t,i)=>e(["../chunks/calcite-switch"],t,i))),tooltip:()=>new Promise(((t,i)=>e(["../chunks/calcite-tooltip"],t,i)))}),g.loadPromptComponents(),y.loadFieldColumnComponents()])}destroy(){this.drainRelatedTables(),this.clearPrompt()}get _effectiveDescription(){const{description:e}=this;return null!=e?M.renderingSanitizer.sanitize("function"==typeof e?e():e):void 0}get _effectiveLayers(){const{layer:e,layers:t}=this,i=t?.length?t.filter(y.isIFeatureTableSupportedLayer):[],o=i.length?i:[...this._viewLayers];return e&&!o.includes(e)&&o.push(e),o}get _effectiveTitle(){const{layer:e,messages:t,state:i,highlightIds:o,title:l,size:s}=this;if(l)return M.renderingSanitizer.sanitize("function"==typeof l?l():l);if(!e)return t.noLayer;switch(i){case"disabled":return t.errorLayer;case"ready":case"loading":return t.loading;case"error":return t.errorData}return A.substitute(t.header,{title:M.renderingSanitizer.sanitize(e.title),count:s,selected:o.length})}get _effectiveVisibleElements(){return this.visibleElementsOverride??this.visibleElements}get _filteredTables(){const e=this.relatedTables.toArray(),t=1===e.length;return this.allRelatedTablesVisible?e:t?[e[0]]:this._shouldShowAttachmentsView?e.slice(-1):e.slice(-2)}get _hasAttachmentsViewError(){return null!=this.attachmentsViewOptions.error}get _hasCustomMenuItems(){return!!this.menuConfig?.items?.length}get _hasDefaultMenuItems(){return!!(this._showClearSelectionAction||this._showDeleteSelectionAction||this._showExportSelectionToCSVAction||this._showRefreshDataAction||this._showZoomToSelectionAction||this._showSelectedRecordsShowSelectedAction||this._showSelectedRecordsShowAllAction||this._showColumnsVisibilityAction)}get _shouldShowGrid(){return this.allRelatedTablesVisible||1===this.relatedTables.length&&!this._shouldShowAttachmentsView}get _shouldShowMenu(){const{header:e,menu:t}=this._effectiveVisibleElements;return!(!e||!t||!this._hasDefaultMenuItems&&!this._hasCustomMenuItems)}get _shouldShowAttachmentsView(){return!(null==this.attachmentsViewOptions.objectId&&!this.relatedTables.some((e=>null!=e.attachmentsViewOptions.objectId)))}get _showClearSelectionAction(){return!(!this.highlightIds.length||!this._effectiveVisibleElements.menuItems?.clearSelection||this.relatedTables.length)}get _showColumnsVisibilityAction(){const{header:e,menu:t,menuItems:i}=this._effectiveVisibleElements;return!(!(e&&t&&i?.toggleColumns)||this.showRelatedTableCallback||this.allRelatedTablesVisible||this._shouldShowAttachmentsView)}get _showDeleteSelectionAction(){return!(!(this.editingEnabled&&this.highlightIds.length&&this._effectiveVisibleElements.menuItems?.deleteSelection&&this.layer?.capabilities?.operations?.supportsDelete)||this.relatedTables.length)}get _showExportSelectionToCSVAction(){return!(!(this._effectiveVisibleElements.menuItems.exportSelectionToCSV&&this.layer&&this.highlightIds.length)||this.relatedTables.length)}get _showLayerDropdown(){return!(!this._effectiveLayers.length||!this._effectiveVisibleElements.layerDropdown)}get _shouldShowNavigationBar(){const e=!!this.relatedTable||this._shouldShowAttachmentsView;return!this.tableParent&&e}get _showRefreshDataAction(){return!!this._effectiveVisibleElements.menuItems?.refreshData}get _showSelectedRecordsShowSelectedAction(){const e=this.objectIds.length,t=this.highlightIds.length;return!(!t||!this._effectiveVisibleElements.menuItems?.selectedRecordsShowSelectedToggle||e&&t===e||this.relatedTables.length)}get _showSelectedRecordsShowAllAction(){return!(!this._effectiveVisibleElements.menuItems?.selectedRecordsShowAllToggle||!this.objectIds.length||this.relatedTables.length)}get _showZoomToSelectionAction(){return!(!this.view||!this.highlightIds.length||this.effectiveTable.layer?.isTable||!this._effectiveVisibleElements.menuItems?.zoomToSelection)}get _viewLayers(){const e=this.view?.map;if(!e)return[];const t=new Set,i=e=>{!y.isIFeatureTableSupportedLayer(e)||h.isSubtypeGroupLayer(e)||t.has(e)||t.add(e)},o=e=>{d.isLayerFromCatalog(e)||"catalog-footprint"===e.type||(h.isKnowledgeGraphLayer(e)?(e.layers?.forEach(i),e.tables?.forEach(i)):y.isMapImageLayer(e)?(e.sublayers?.forEach(i),e.subtables?.forEach(i)):h.isSubtypeGroupLayer(e)?e.sublayers?.forEach(i):i(e))};return e.allLayers.forEach(o),e.allTables.forEach(o),[...t.values()]}get grid(){return this.viewModel.grid}get actionColumnConfig(){return this.viewModel.actionColumnConfig}set actionColumnConfig(e){this.viewModel.actionColumnConfig=e}get activeFilters(){return this.viewModel.activeFilters}get activeSortOrders(){return this.viewModel.activeSortOrders}get allColumns(){return this.viewModel.allColumns}get allRelatedTablesVisible(){return this.viewModel.allRelatedTablesVisible}get attachmentsEnabled(){return this.viewModel.attachmentsEnabled}set attachmentsEnabled(e){this.viewModel.attachmentsEnabled=e}get attachmentsViewOptions(){return this.viewModel.attachmentsViewOptions}set attachmentsViewOptions(e){this.viewModel.attachmentsViewOptions=e}get attributeTableTemplate(){return this.viewModel.attributeTableTemplate}set attributeTableTemplate(e){this.viewModel.attributeTableTemplate=e}get autoRefreshEnabled(){return this.viewModel.autoRefreshEnabled}set autoRefreshEnabled(e){this.viewModel.autoRefreshEnabled=e}get clearPrompt(){return this.viewModel.clearPrompt}set clearPrompt(e){this.viewModel.clearPrompt=e}get columnPerformanceModeEnabled(){return this.viewModel.columnPerformanceModeEnabled}set columnPerformanceModeEnabled(e){this.viewModel.columnPerformanceModeEnabled=e}get columnReorderingEnabled(){return this.viewModel.columnReorderingEnabled}set columnReorderingEnabled(e){this.viewModel.columnReorderingEnabled=e}get columns(){return this.viewModel.columns}get editingEnabled(){return this.viewModel.editingEnabled}set editingEnabled(e){this.viewModel.editingEnabled=e}get effectiveSize(){return this.viewModel.effectiveSize}get effectiveTable(){return this.relatedTable||this}get filterGeometry(){return this.viewModel.filterGeometry}set filterGeometry(e){this.viewModel.filterGeometry=e}get filterBySelectionEnabled(){return this.viewModel.filterBySelectionEnabled}set filterBySelectionEnabled(e){this.viewModel.filterBySelectionEnabled=e}get hiddenFields(){return this.viewModel.hiddenFields}set hiddenFields(e){this.viewModel.hiddenFields=e}get highlightEnabled(){return this.viewModel.highlightEnabled}set highlightEnabled(e){this.viewModel.highlightEnabled=e}get highlightIds(){return this.viewModel.highlightIds}set highlightIds(e){this.viewModel.highlightIds=e}get icon(){return"table"}set icon(e){this._overrideIfSome("icon",e)}get initialSize(){return this.viewModel.initialSize}set initialSize(e){this.viewModel.initialSize=e}get isQueryingOrSyncing(){return this.viewModel.isQueryingOrSyncing}get isSyncingAttachments(){return this.viewModel.isSyncingAttachments}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}get layer(){return this.viewModel.layer}set layer(e){this.viewModel.layer=e}get layerView(){return this.viewModel.layerView}get maxSize(){return this.viewModel.maxSize}set maxSize(e){this.viewModel.maxSize=e}get messages(){return this.viewModel.messages}set messages(e){this.viewModel.messages=e}get messagesCommon(){return this.viewModel.messagesCommon}set messagesCommon(e){this.viewModel.messagesCommon=e}get messagesUnits(){return this.viewModel.messagesUnits}set messagesUnits(e){this.viewModel.messagesUnits=e}get messagesURIUtils(){return this.viewModel.messagesURIUtils}set messagesURIUtils(e){this.viewModel.messagesURIUtils=e}get multipleSelectionEnabled(){return this.viewModel.multipleSelectionEnabled}set multipleSelectionEnabled(e){this.viewModel.multipleSelectionEnabled=e}get multiSortEnabled(){return this.viewModel.multiSortEnabled}set multiSortEnabled(e){this.viewModel.multiSortEnabled=e}get objectIds(){return this.viewModel.objectIds}set objectIds(e){this.viewModel.objectIds=e}get outFields(){return this.viewModel.outFields}set outFields(e){this.viewModel.outFields=e}get pageCount(){return this.viewModel.pageCount}get pageIndex(){return this.viewModel.pageIndex}set pageIndex(e){this.viewModel.pageIndex=e}get pageSize(){return this.viewModel.pageSize}set pageSize(e){this.viewModel.pageSize=e}get paginationEnabled(){return this.viewModel.paginationEnabled}set paginationEnabled(e){this.viewModel.paginationEnabled=e}get prompt(){return this.viewModel.prompt}set prompt(e){this.viewModel.prompt=e}get relatedRecordsEnabled(){return this.viewModel.relatedRecordsEnabled}set relatedRecordsEnabled(e){this.viewModel.relatedRecordsEnabled=e}get relatedTable(){return this.viewModel.relatedTable}get relatedTables(){return this.viewModel.relatedTables}set relatedTables(e){this.viewModel.relatedTables=e}get relationship(){return this.viewModel.relationship}get relationshipColumnConfigs(){return this.viewModel.relationshipColumnConfigs}set relationshipColumnConfigs(e){this.viewModel.relationshipColumnConfigs=e}get relationshipConfig(){return this.viewModel.relationshipConfig}set relationshipConfig(e){this.viewModel.relationshipConfig=e}get returnGeometryEnabled(){return this.viewModel.returnGeometryEnabled}set returnGeometryEnabled(e){this.viewModel.returnGeometryEnabled=e}get returnMEnabled(){return this.viewModel.returnMEnabled}set returnMEnabled(e){this.viewModel.returnMEnabled=e}get returnZEnabled(){return this.viewModel.returnZEnabled}set returnZEnabled(e){this.viewModel.returnZEnabled=e}get rowHighlightIds(){return this.viewModel.rowHighlightIds}set rowHighlightIds(e){this.viewModel.rowHighlightIds=e}get selectionSource(){return this.viewModel.selectionSource}set selectionSource(e){this.viewModel.selectionSource=e}get showAllRelatedTables(){return this.viewModel.showAllRelatedTables}set showAllRelatedTables(e){this.viewModel.showAllRelatedTables=e}get showPrompt(){return this.viewModel.showPrompt}set showPrompt(e){this.viewModel.showPrompt=e}get showRelatedTableCallback(){return this.viewModel.showRelatedTableCallback}set showRelatedTableCallback(e){this.viewModel.showRelatedTableCallback=e}get size(){return this.viewModel.size}get state(){return this.viewModel.state}get tableController(){return this.viewModel.tableController}set tableController(e){this.viewModel.tableController=e}get tableParent(){return this.viewModel.tableParent}set tableParent(e){this.viewModel.tableParent=e}get tableTemplate(){return this.viewModel.tableTemplate}set tableTemplate(e){this.viewModel.tableTemplate=e}get tableTemplateOverride(){return this.viewModel.tableTemplateOverride}set tableTemplateOverride(e){this.viewModel.tableTemplateOverride=e}get timeExtent(){return this.viewModel.timeExtent}set timeExtent(e){this.viewModel.timeExtent=e}get timeZone(){return this.viewModel.timeZone}set timeZone(e){this.viewModel.timeZone=e}get view(){return this.viewModel.view}set view(e){this.viewModel.view=e}get visibleElementsOverride(){const{attachmentsViewOptions:e,relatedTable:t,tableController:i,visibleElements:o}=this,{columnDescriptions:l,columnMenus:s,tooltips:n}=o,r=null!=e.objectId;if(t)return new _({columnDescriptions:l,columnMenus:s,tooltips:n,close:o.close,header:o.header,layerDropdown:o.layerDropdown,menu:o.menu,menuItems:o.menuItems,progress:o.progress,selectionColumn:!1,columnMenuItems:new w({sortAscending:!1,sortDescending:!1})});if(i){const e=i.relatedTable===this,t=i.allRelatedTablesVisible,a=e&&o.selectionColumn&&!t&&!r,c=e&&!t&&!r;return new _({columnDescriptions:l,columnMenus:s,tooltips:n,selectionColumn:a,close:!1,header:!1,layerDropdown:!1,menu:!1,progress:!1,columnMenuItems:new w({sortAscending:c,sortDescending:c})})}return r?new _({columnDescriptions:l,columnMenus:s,tooltips:n,close:o.close,header:o.header,layerDropdown:o.layerDropdown,menu:o.menu,menuItems:o.menuItems,progress:o.progress,selectionColumn:!1,columnMenuItems:new w({sortAscending:!1,sortDescending:!1})}):null}clearSelectionFilter(){this.viewModel.clearSelectionFilter()}async deleteAttachments(e,t,i){null!=e&&t?.length&&(i?this._showDeleteAttachmentPrompt(e,t):await this.viewModel.deleteAttachments(e,t))}deleteSelection(e){return this.highlightIds.length?e?(this._showDeletePrompt(),this.scheduleRender(),Promise.resolve()):this.viewModel.deleteSelection():Promise.resolve()}async downloadAttachmentById(e,t){return this.viewModel.downloadAttachmentById(e,t)}drainRelatedTables(){this.viewModel.drainRelatedTables()}exportSelectionToCSV(e){this.viewModel.exportSelectionToCSV(e)}filterBySelection(){this.viewModel.filterBySelection()}findColumn(e){return this.viewModel.findColumn(e)}goToPage(e){this.viewModel.goToPage(e)}hideColumn(e){this.grid?.hideColumn(e)}nextPage(){this.viewModel.nextPage()}previousPage(){this.viewModel.previousPage()}async refresh(){await this.viewModel.refresh()}refreshCellContent(){this.viewModel.refreshCellContent()}async saveAttachmentsViewForm(){await this.viewModel.saveAttachmentsViewForm()}showAllColumns(){this.viewModel.showAllColumns()}showColumn(e){this.grid?.showColumn(e)}sortColumn(e,t){this.viewModel.sortColumn(e,t)}scrollLeft(){this.viewModel.scrollLeft()}scrollToBottom(){this.viewModel.scrollToBottom()}scrollToIndex(e){this.viewModel.scrollToIndex(e)}scrollToRow(e){this.viewModel.scrollToRow(e)}scrollToTop(){this.viewModel.scrollToTop()}toggleColumnVisibility(e){this.viewModel.toggleColumnVisibility(e)}zoomToSelection(){this.effectiveTable.viewModel.zoomToSelection()}render(){const{_effectiveVisibleElements:e,isQueryingOrSyncing:t,menuConfig:i,state:o}=this;return T.tsx("div",{bind:this,class:this.classes(k.base,f.globalCss.widget)},T.tsx("calcite-panel",{bind:this,class:k.content,closable:e.close,description:this._effectiveDescription,disabled:this.disabled||"disabled"===o&&!this._effectiveLayers?.length,heading:e.header?this._effectiveTitle:void 0,loading:"loading"===o,menuOpen:!!i?.open,overlayPositioning:"fixed",onCalcitePanelClose:e=>{e.target.closed=!1,this.emit("close")}},e.progress?T.tsx("calcite-progress",{type:t?"indeterminate":"determinate"}):null,this._showLayerDropdown?this._renderLayerDropdown():null,this._renderColumnVisibilityAction(),this._renderHeaderMenuActions(),this._renderNavigationBar(),this._renderTables(),this._renderError()),this._renderPrompt())}_renderTables(){const{grid:e,relatedTables:t}=this,i=this.classes(k.tableContainer);if(t.length){const o=this.classes(k.base,this.allRelatedTablesVisible?k.expanded:k.collapsed,this._shouldShowAttachmentsView?k.tableContainerWithAttachments:void 0);return T.tsx("div",{class:i},T.tsx("calcite-panel",{overlayPositioning:"fixed"},T.tsx("div",null,[this._shouldShowGrid?T.tsx("div",{class:o},e?.render(),this._renderPagination()):void 0,...this._filteredTables.map((e=>{const i=t.indexOf(e);return T.tsx("div",{class:o,key:`related-${i}`},e.render())})),,])))}return null!=this.attachmentsViewOptions.objectId?T.tsx("div",{class:i},T.tsx("calcite-panel",{overlayPositioning:"fixed"},T.tsx("div",null,[T.tsx("div",{class:this.classes(k.base,k.collapsed)},e?.render(),this._renderPagination()),this._renderAttachmentsView()]))):[T.tsx("div",{class:i},e?.render()),this._renderPagination()]}_renderPagination(){if(this.paginationEnabled)return T.tsx("calcite-pagination",{pageSize:1,startItem:this.pageIndex+1,totalItems:this.pageCount,onCalcitePaginationChange:e=>this.goToPage(e.target.startItem-1)})}_renderError(){const{messages:e}=this;return T.tsx("calcite-alert",{autoClose:!0,autoCloseDuration:"fast",icon:R.exclamationMarkTriangle,kind:"danger",label:e.errorOccured,open:this._hasAttachmentsViewError,slot:"alerts",onCalciteAlertClose:()=>{this.attachmentsViewOptions.error=null}},T.tsx("span",{slot:"message"},e.errorOccured))}_renderPrompt(){return this.prompt?T.tsx(g.Prompt,{...this.prompt,headingLevel:2}):void 0}_showDeletePrompt(){const{messages:e,messagesCommon:t}=this,i=A.substitute(e.deleteSelectionCount,{count:this.highlightIds.length});this.showPrompt({title:i,message:e.deleteRecordsRemoved,context:"danger",actions:{primary:{label:t.delete,action:this._onDeleteSelectionClick},secondary:{label:e.keepRecords,action:()=>this.clearPrompt()}}})}_showDeleteAttachmentPrompt(e,t){const{messages:i,messagesCommon:o}=this,l=A.substitute(i.deleteAttachmentCount,{count:t.length});this.showPrompt({title:l,message:i.deleteAttachmentConfirmation,context:"danger",actions:{primary:{label:o.delete,action:async()=>{try{await this.deleteAttachments(e,t,!1)}finally{this.clearPrompt()}}},secondary:{label:o.cancel,action:()=>this.clearPrompt()}}})}async _onDeleteSelectionClick(){try{await this.viewModel.deleteSelection()}finally{this.clearPrompt()}}_renderHeaderMenuAction(e){const{disabled:t,hidden:i,icon:o,text:l,clickFunction:s}=e;if(!i)return T.tsx("calcite-action",{disabled:t??this.menuConfig?.disabled,icon:o??void 0,key:l,onclick:()=>s(),slot:"header-menu-actions",text:l,textEnabled:!0,title:l})}_renderHeaderMenuActions(){return this._shouldShowMenu?[this._renderDefaultHeaderMenuActions(),this._renderCustomHeaderMenuActions()]:[]}_renderDefaultHeaderMenuActions(){if(!this._hasDefaultMenuItems)return[];const{messages:e}=this;return[this._showRefreshDataAction&&{icon:R.refresh,text:e.refreshData,clickFunction:()=>this.refresh()},this._showDeleteSelectionAction&&{icon:R.delete,text:e.deleteSelection,clickFunction:()=>this.deleteSelection(!0)},this._showClearSelectionAction&&{icon:R.clearSelection,text:e.clearSelection,clickFunction:()=>this.highlightIds?.removeAll()},this._showZoomToSelectionAction&&{icon:R.zoomToSelection,text:e.zoomToSelection,clickFunction:()=>this.zoomToSelection()},this._showSelectedRecordsShowSelectedAction&&{icon:R.showSelected,text:e.showSelected,clickFunction:()=>{const{objectIds:e}=this;e.removeAll(),e.addMany(this.highlightIds.toArray())}},this._showSelectedRecordsShowAllAction&&{icon:R.showAll,text:e.showAllRecords,clickFunction:()=>this.objectIds.removeAll()},this._showExportSelectionToCSVAction&&{icon:R.exportToCSV,text:e.exportSelectionCSV,clickFunction:()=>this.exportSelectionToCSV()}].filter(o.isSome).map((e=>e&&this._renderHeaderMenuAction(e)))}_renderCustomHeaderMenuActions(){return this.menuConfig?.items?.map((({disabled:e,hidden:t,icon:i,label:o,clickFunction:l})=>this._renderHeaderMenuAction({hidden:"function"==typeof t?t():t,icon:i,text:o,disabled:e,clickFunction:e=>l(e)})))??[]}_renderColumnVisibilityAction(){if(!this._showColumnsVisibilityAction)return[];const{_columnVisibilityActions:e,_effectiveVisibleElements:t,effectiveTable:i,id:o,messages:l}=this,s=i.columns.toArray(),n=l?.toggleColumns,r=`${o}__toggle-columns-action`,a=[T.tsx("calcite-action",{afterCreate:t=>e.set(o,t),afterRemoved:()=>e.delete(o),appearance:"transparent",bind:this,disabled:i.menuConfig?.disabled,icon:R.showColumn,id:r,slot:"header-actions-end",text:n},t.tooltips?T.tsx("calcite-tooltip",{closeOnClick:!0,overlayPositioning:"fixed",placement:"bottom-end",slot:"tooltip"},n):null)];return i.menuConfig?.disabled||a.push(T.tsx("calcite-popover",{autoClose:!0,class:k.menuPopover,label:n,overlayPositioning:"fixed",placement:"top-end",pointerDisabled:!0,referenceElement:e.get(o)},T.tsx("calcite-list",{filterEnabled:!0,filterPlaceholder:l.toggleColumns,selectionMode:"multiple"},...s.map((e=>{const t="columns"in e&&e.columns?.length?e.columns.map((e=>this._renderColumnListItem({column:e,table:i,ignoreSelect:!0}))):void 0;return this._renderColumnListItem({column:e,table:i,items:t})}))))),a}_renderColumnListItem(e){const{column:t,table:i,items:o,ignoreSelect:l}=e,{effectiveLabel:s,fieldName:n,hidden:r}=t,a=!(!o?.length||r)||void 0;return T.tsx("calcite-list-item",{key:`toggle-columns__item-${n}`,label:s,open:a,selected:!r,value:n,onCalciteListItemSelect:e=>{l||i.toggleColumnVisibility(e.target.value)}},o)}_renderLayerDropdown(){const e=this.messages.selectALayer;return T.tsx("div",{class:k.layerDropdownMenu,key:`${this.id}-layerDropdown`,slot:"header-actions-start"},T.tsx("calcite-dropdown",{bind:this,maxItems:5,overlayPositioning:"fixed",placement:"bottom-start"},T.tsx("calcite-action",{icon:R.layers,slot:"trigger",text:e,title:e}),T.tsx("calcite-dropdown-group",{selectionMode:"single"},this._effectiveLayers.map(((e,t)=>this._renderLayerDropdownItem(e,t)))??null)))}_renderLayerDropdownItem(e,t){return T.tsx("calcite-dropdown-item",{key:`dropdown-item-${t}`,label:e.title??"",selected:e===this.layer,value:e.id,onCalciteDropdownItemSelect:()=>{this.layer=e}},e.title)}_onRelatedNavigationItemClick(e){this.viewModel.drainRelatedTablesAboveIndex(e)}_collapseRelatedTable(e){this.viewModel.collapseRelatedTable(this.effectiveTable,e)}_onShowRelatedTable(e){this.showRelatedTableCallback||(this._collapseRelatedTable(e),this._createRelatedTable(e))}async _createRelatedTable(e){const{editingEnabled:t,effectiveTable:i,paginationEnabled:o,pageSize:l,view:s,viewModel:n}=this,{layer:r,objectId:a,relatedLayer:c,relationshipId:d}=e;await r.load();const h=this.attachmentsEnabled&&y.isIFeatureTableSupportedLayerWithAttachments(r),p=new x({layer:r,attachmentsEnabled:h,editingEnabled:t,paginationEnabled:o,pageSize:l,relatedRecordsEnabled:!0,relationshipConfig:{objectId:a,relatedLayer:c,relationshipId:d},relationshipColumnConfigs:y.getRelationshipIdsToShow(r,d),tableController:this,tableParent:i,view:s,showRelatedTableCallback:e=>n.emit("show-related-table",e)});this.relatedTables.add(p),this.scheduleRender()}_renderAttachmentsView(){const{attachmentInfos:e,mode:t,objectId:i}=this.attachmentsViewOptions;return"file"!==t&&e.length&&null!=i?this._renderAttachmentsViewList():this._renderAttachmentsViewFilePane()}_renderAttachmentsViewFilePane(){const{attachmentsViewOptions:e,isSyncingAttachments:t,messages:i,messagesUnits:o,viewModel:{supportsAddAttachments:l}}=this,{attachmentId:n,attachmentInfos:r,candidates:a,objectId:c}=e,d=r.find((e=>e.id===n)),h=r.length,p=a?.length,u=d?T.tsx("calcite-label",{alignment:"center",key:"replace-file-node",scale:"l"},i.replaceFile):void 0,m=p?void 0:T.tsx("calcite-label",{alignment:"center",key:"message-node",scale:"m"},l?null==c?i.noFeature:i.dragAndDropToUpload:i.editingRestricted),g=Array.from(a??[]).pop(),w=g?T.tsx("calcite-label",{key:"filename-node"},g.name):void 0,b=l&&null!=c,_=b&&p,y=T.tsx("input",{afterCreate:M.storeNode,afterRemoved:M.discardNode,afterUpdate:M.storeNode,bind:this,"data-node-ref":"_attachmentsInput",files:a,hidden:!0,name:"attachment",onchange:e=>this._onAttachmentsViewCandidateChange(e),type:"file"}),v=b?T.tsx("calcite-button",{appearance:"outline-fill",bind:this,disabled:t,iconStart:R.folderOpen,key:"select-node",loading:!1,onclick:()=>{this._attachmentsInput?.click()},width:"full"},i.selectFile):void 0,f=_?T.tsx("calcite-button",{appearance:"outline-fill",bind:this,disabled:t,iconStart:R.save,key:"save-node",loading:t,onclick:()=>{this.saveAttachmentsViewForm()},width:"full"},d?i.updateAttachment:i.addAttachment):void 0,C=h||p?T.tsx("calcite-button",{appearance:"transparent",bind:this,disabled:t,key:"cancel-node",onclick:()=>{this._attachmentsInput&&(this._attachmentsInput.value=""),e.reset(),e.attachmentInfos?.length&&(e.mode="list")},width:"full"},this.messagesCommon.cancel):void 0;return[T.tsx("div",{class:k.attachmentsView,key:"attachments-view"},T.tsx("div",{class:k.attachmentsViewContent,key:"attachments-view-content"},T.tsx("div",{bind:this,class:k.attachmentsViewDropArea,ondragover:e=>e.preventDefault(),ondrop:this._onAttachmentsViewDrop},T.tsx("calcite-icon",{class:k.attachmentsViewIcon,icon:R.upload,scale:"l"}),u,m,T.tsx("form",{afterCreate:t=>e.form=t,afterRemoved:()=>e.form=null,bind:this,key:"attachments-form"},T.tsx("fieldset",null,w,y,v,f,C)))),null!=c&&null!=d?T.tsx("div",{class:k.attachmentsViewInformation,key:"information"},this._renderAttachmentsViewThumbnail(d,200),T.tsx("label",{key:"file-label"},i.fileName),T.tsx("span",{key:"file-span"},d.name),T.tsx("label",{key:"size-label"},i.size),T.tsx("span",{key:"size-span"},s.formatFileSize(o,d.size??0))):void 0)]}_renderAttachmentsViewList(){const{attachmentsViewOptions:e,messages:t,messagesUnits:i,viewModel:{store:{syncingAttachmentEdits:o},supportsDeleteAttachments:l,supportsUpdateAttachments:n}}=this,{attachmentInfos:r,objectId:a}=e;return T.tsx("calcite-list",{afterCreate:M.storeNode,afterRemoved:M.discardNode,afterUpdate:M.storeNode,bind:this,class:k.attachmentsViewList,"data-node-ref":"attachmentsList",key:`attachments-list-${a}`,loading:o,ondragover:e=>e.preventDefault(),ondrop:this._onAttachmentsViewDrop,selectionMode:"multiple",onCalciteListChange:()=>this.scheduleRender()},...r?.map((o=>{const{id:r,name:c,size:d,url:h}=o,p=s.formatFileSize(i,d??0);return T.tsx("calcite-list-item",{afterRemoved:()=>this.scheduleRender(),key:`attachment-${r}`,label:c,value:r},this._renderAttachmentsViewListThumbnail(o),T.tsx("span",{class:k.attachmentsViewListFileSize,slot:"actions-end",title:p},p),T.tsx("calcite-action",{appearance:"transparent",icon:R.downloadTo,key:`download-attachment-${r}`,label:`${c}`,onclick:e=>{e.preventDefault(),this.downloadAttachmentById(a??-1,r)},slot:"actions-end",text:t.downloadAttachment,title:t.downloadAttachment}),n&&null!=a?T.tsx("calcite-action",{appearance:"transparent",disabled:!n,icon:R.replaceImage,key:`replace-attachment-${r}`,label:`${c}`,onclick:()=>{e.mode="file",e.attachmentId=r},slot:"actions-end",text:t.updateAttachment,title:t.updateAttachment}):void 0,T.tsx("calcite-action",{appearance:"transparent",icon:R.launch,key:`launch-attachment-${r}`,label:`${c}`,onclick:()=>{h&&window.open(h,"_blank")},slot:"actions-end",text:t.viewAttachment,title:t.viewAttachment}),l&&null!=a?T.tsx("calcite-action",{appearance:"transparent",class:k.attachmentsViewListItemDelete,disabled:!l,icon:R.delete,key:`delete-attachment-${r}`,label:`${c}`,onclick:()=>{this.deleteAttachments(a,[r],!0)},slot:"actions-end",text:t.deleteAttachment,title:t.deleteAttachment}):void 0)})))}_renderAttachmentsViewListThumbnail(e){return T.tsx("div",{class:k.attachmentsViewListThumbnail,slot:"content-start"},T.tsx("a",{href:e.url??"",rel:"noreferrer",target:"_blank"},this._renderAttachmentsViewThumbnail(e)))}_renderAttachmentsViewThumbnail(e,t=64){const{contentType:i,name:o,size:l,url:s}=e,n=`${s}${s?.includes("?")?"&":"?"}w=${t}&s=${l}`;return this.viewModel.supportsResizeAttachments&&m.isSupportedImage(i)?T.tsx("img",{alt:o,key:`thumbnail-image-${o}`,src:n,title:o}):T.tsx("calcite-icon",{icon:m.getCalciteIconForAttachment(i),key:`thumbnail-icon-${o}`,scale:"l",textLabel:o,title:o})}_onAttachmentsViewCandidateChange({target:e}){this.attachmentsViewOptions.candidates=e?.files}_onAttachmentsViewDrop(e){const{viewModel:t}=this;e.preventDefault(),(t.supportsAddAttachments||t.supportsUpdateAttachments)&&this.attachmentsViewOptions.set({mode:"file",candidates:e.dataTransfer?.files})}_renderNavigationBar(){const{effectiveTable:e,messages:t,messagesCommon:i,relatedTable:o,relatedTables:l}=this;if(!this._shouldShowNavigationBar)return;const{attachmentsList:s,attachmentsViewOptions:n,layer:r,viewModel:{supportsAddAttachments:a,supportsDeleteAttachments:c}}=e;if(!r)return;const{attachmentInfos:d,objectId:h}=n,p=null!=h,u=d.length,m=s?.selectedItems?.length??0,g=`${r.objectIdField}: ${h}`,w=A.substitute(t.selectedCount,{count:m}),b=A.substitute(t.attachmentsCount,{count:u}),_=p?T.tsx("calcite-action",{bind:this,icon:R.chevronRight,iconFlipRtl:!0,key:"navigation-feature",onclick:()=>e.scrollToRow(h),text:g,textEnabled:!0,title:g}):void 0,y=p?T.tsx("calcite-action",{icon:R.chevronRight,iconFlipRtl:!0,key:"navigation-attachments-label",label:b,onclick:()=>{u>0&&(n.mode="list")},text:b,textEnabled:!0,title:b}):void 0,v=p?T.tsx("calcite-chip",{closable:!0,closed:0===m,key:"navigation-chip",kind:"inverse",label:w,selected:!0,title:w,value:"selected",onCalciteChipClose:()=>s?.selectedItems?.forEach((e=>e.selected=!1))},w):void 0,f=o?T.tsx("calcite-label",{layout:"inline"},t.showAllTables,T.tsx("calcite-switch",{checked:this.allRelatedTablesVisible,onCalciteSwitchChange:e=>this.showAllRelatedTables=!!e.target.checked})):void 0,M=p&&"list"===n.mode&&null!=h&&m&&c?T.tsx("calcite-action",{icon:R.delete,iconFlipRtl:!0,key:"attachments-trash-all",onclick:()=>{e.deleteAttachments(h,s?.selectedItems?.map((e=>e.value))??[],!0)},text:i.delete,textEnabled:!0,title:A.substitute(t.deleteAttachmentCount,{count:m})}):void 0,C=p&&"list"===n.mode&&a?T.tsx("calcite-action",{bind:this,icon:R.plus,iconFlipRtl:!0,key:"attachments-add",onclick:()=>{n.attachmentId=null,n.mode="file"},text:t.addAttachment,textEnabled:!0,title:t.addAttachment}):void 0;return T.tsx("div",{class:k.tableNavigation,key:"table-nav"},T.tsx("calcite-action",{icon:R.moveUp,iconFlipRtl:!0,key:"go-back",onclick:()=>{o&&this.drainRelatedTables(),e.attachmentsViewOptions.objectId=null},text:this.layer?.title??"",textEnabled:!1,title:o?t.exitRelatedRecords:t.exitAttachments}),l.toArray().map(((e,t)=>this._renderRelatedTableNavigationAction(e,t))),_,y,T.tsx("div",null,v,f,M,C))}_renderRelatedTableNavigationAction(e,t){const i=this._getLabelForRelatedTableNavigationAction(e);return T.tsx("calcite-action",{icon:R.chevronRight,iconFlipRtl:!0,key:t,onclick:()=>this._onRelatedNavigationItemClick(t),text:i,textEnabled:!0,title:e.layer?.title||""})}_getLabelForRelatedTableNavigationAction(e){const t=e.layer?.title;if(!t)return"";const{relatedTables:i}=this;if(i.length<=1)return t;return i.indexOf(e)!==i.length-1&&t.length>20?`${t.slice(0,20)}...`:t}};t.__decorate([n.property()],P.prototype,"_attachmentsInput",void 0),t.__decorate([n.property()],P.prototype,"_columnVisibilityActions",void 0),t.__decorate([n.property()],P.prototype,"_effectiveDescription",null),t.__decorate([n.property()],P.prototype,"_effectiveLayers",null),t.__decorate([n.property()],P.prototype,"_effectiveTitle",null),t.__decorate([n.property()],P.prototype,"_effectiveVisibleElements",null),t.__decorate([n.property()],P.prototype,"_filteredTables",null),t.__decorate([n.property()],P.prototype,"_hasAttachmentsViewError",null),t.__decorate([n.property()],P.prototype,"_hasCustomMenuItems",null),t.__decorate([n.property()],P.prototype,"_hasDefaultMenuItems",null),t.__decorate([n.property()],P.prototype,"_shouldShowGrid",null),t.__decorate([n.property()],P.prototype,"_shouldShowMenu",null),t.__decorate([n.property()],P.prototype,"_shouldShowAttachmentsView",null),t.__decorate([n.property()],P.prototype,"_showClearSelectionAction",null),t.__decorate([n.property()],P.prototype,"_showColumnsVisibilityAction",null),t.__decorate([n.property()],P.prototype,"_showDeleteSelectionAction",null),t.__decorate([n.property()],P.prototype,"_showExportSelectionToCSVAction",null),t.__decorate([n.property()],P.prototype,"_showLayerDropdown",null),t.__decorate([n.property()],P.prototype,"_shouldShowNavigationBar",null),t.__decorate([n.property()],P.prototype,"_showRefreshDataAction",null),t.__decorate([n.property()],P.prototype,"_showSelectedRecordsShowSelectedAction",null),t.__decorate([n.property()],P.prototype,"_showSelectedRecordsShowAllAction",null),t.__decorate([n.property()],P.prototype,"_showZoomToSelectionAction",null),t.__decorate([n.property()],P.prototype,"_viewLayers",null),t.__decorate([n.property()],P.prototype,"attachmentsList",void 0),t.__decorate([n.property({readOnly:!0})],P.prototype,"grid",null),t.__decorate([n.property()],P.prototype,"actionColumnConfig",null),t.__decorate([n.property({readOnly:!0})],P.prototype,"activeFilters",null),t.__decorate([n.property({readOnly:!0})],P.prototype,"activeSortOrders",null),t.__decorate([n.property()],P.prototype,"allColumns",null),t.__decorate([n.property({readOnly:!0})],P.prototype,"allRelatedTablesVisible",null),t.__decorate([n.property()],P.prototype,"attachmentsEnabled",null),t.__decorate([n.property()],P.prototype,"attachmentsViewOptions",null),t.__decorate([n.property({type:p})],P.prototype,"attributeTableTemplate",null),t.__decorate([n.property()],P.prototype,"autoRefreshEnabled",null),t.__decorate([n.property()],P.prototype,"clearPrompt",null),t.__decorate([n.property()],P.prototype,"columnPerformanceModeEnabled",null),t.__decorate([n.property()],P.prototype,"columnReorderingEnabled",null),t.__decorate([n.property({readOnly:!0})],P.prototype,"columns",null),t.__decorate([n.property()],P.prototype,"description",void 0),t.__decorate([n.property()],P.prototype,"disabled",void 0),t.__decorate([n.property()],P.prototype,"editingEnabled",null),t.__decorate([n.property()],P.prototype,"effectiveSize",null),t.__decorate([n.property()],P.prototype,"effectiveTable",null),t.__decorate([n.property()],P.prototype,"filterGeometry",null),t.__decorate([n.property()],P.prototype,"filterBySelectionEnabled",null),t.__decorate([n.property()],P.prototype,"hiddenFields",null),t.__decorate([n.property()],P.prototype,"highlightEnabled",null),t.__decorate([n.property()],P.prototype,"highlightIds",null),t.__decorate([n.property()],P.prototype,"icon",null),t.__decorate([n.property()],P.prototype,"initialSize",null),t.__decorate([n.property()],P.prototype,"isQueryingOrSyncing",null),t.__decorate([n.property()],P.prototype,"isSyncingAttachments",null),t.__decorate([n.property()],P.prototype,"label",null),t.__decorate([n.property()],P.prototype,"layer",null),t.__decorate([n.property()],P.prototype,"layers",void 0),t.__decorate([n.property()],P.prototype,"layerView",null),t.__decorate([n.property()],P.prototype,"maxSize",null),t.__decorate([n.property(),C.messageBundle("esri/widgets/FeatureTable/t9n/FeatureTable")],P.prototype,"messages",null),t.__decorate([n.property(),C.messageBundle("esri/t9n/common")],P.prototype,"messagesCommon",null),t.__decorate([n.property(),C.messageBundle("esri/core/t9n/Units")],P.prototype,"messagesUnits",null),t.__decorate([n.property(),C.messageBundle("esri/widgets/support/t9n/uriUtils")],P.prototype,"messagesURIUtils",null),t.__decorate([n.property()],P.prototype,"menuConfig",void 0),t.__decorate([n.property()],P.prototype,"multipleSelectionEnabled",null),t.__decorate([n.property()],P.prototype,"multiSortEnabled",null),t.__decorate([n.property()],P.prototype,"objectIds",null),t.__decorate([n.property()],P.prototype,"outFields",null),t.__decorate([n.property()],P.prototype,"pageCount",null),t.__decorate([n.property()],P.prototype,"pageIndex",null),t.__decorate([n.property()],P.prototype,"pageSize",null),t.__decorate([n.property()],P.prototype,"paginationEnabled",null),t.__decorate([n.property()],P.prototype,"prompt",null),t.__decorate([n.property()],P.prototype,"relatedRecordsEnabled",null),t.__decorate([n.property()],P.prototype,"relatedTable",null),t.__decorate([n.property()],P.prototype,"relatedTables",null),t.__decorate([n.property()],P.prototype,"relationship",null),t.__decorate([n.property()],P.prototype,"relationshipColumnConfigs",null),t.__decorate([n.property()],P.prototype,"relationshipConfig",null),t.__decorate([n.property()],P.prototype,"returnGeometryEnabled",null),t.__decorate([n.property()],P.prototype,"returnMEnabled",null),t.__decorate([n.property()],P.prototype,"returnZEnabled",null),t.__decorate([n.property()],P.prototype,"rowHighlightIds",null),t.__decorate([n.property()],P.prototype,"selectionSource",null),t.__decorate([n.property()],P.prototype,"showAllRelatedTables",null),t.__decorate([n.property()],P.prototype,"showPrompt",null),t.__decorate([n.property()],P.prototype,"showRelatedTableCallback",null),t.__decorate([n.property()],P.prototype,"size",null),t.__decorate([n.property({readOnly:!0})],P.prototype,"state",null),t.__decorate([n.property({constructOnly:!0})],P.prototype,"tableController",null),t.__decorate([n.property({constructOnly:!0})],P.prototype,"tableParent",null),t.__decorate([n.property()],P.prototype,"tableTemplate",null),t.__decorate([n.property()],P.prototype,"tableTemplateOverride",null),t.__decorate([n.property()],P.prototype,"title",void 0),t.__decorate([n.property()],P.prototype,"timeExtent",null),t.__decorate([n.property()],P.prototype,"timeZone",null),t.__decorate([n.property()],P.prototype,"view",null),t.__decorate([n.property({type:b}),S.vmEvent(["cell-click","cell-dblclick","cell-pointerover","cell-pointerout","cell-keydown","column-reorder","show-related-table"])],P.prototype,"viewModel",void 0),t.__decorate([n.property({type:_,nonNullable:!0})],P.prototype,"visibleElements",void 0),t.__decorate([n.property({type:_})],P.prototype,"visibleElementsOverride",null),P=x=t.__decorate([c.subclass("esri.widgets.FeatureTable")],P);return P}));
