/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../intl","../../core/arrayUtils","../../core/Collection","../../core/collectionUtils","../../core/deprecate","../../core/Error","../../core/Handles","../../core/Logger","../../core/promiseUtils","../../core/reactiveUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/accessorSupport/decorators/subclass","../../layers/support/fieldUtils","../../layers/support/layerUtils","../../support/popupUtils","../../tables/AttributeTableTemplate","../../views/support/layerViewUtils","../../views/support/selectionUtils","./ActionColumn","./AttachmentsColumn","./FieldColumn","./RelationshipColumn","./Grid/Column","./Grid/Grid","./Grid/GridViewModel","./Grid/GroupColumn","./support/AttachmentsColumnTemplate","./support/AttachmentsViewOptions","./support/columnUtils","./support/exportUtils","./support/FeatureStore","./support/FieldColumnTemplate","./support/RelationshipColumnTemplate","./support/TableTemplate","./support/tableUtils","../support/widgetUtils","../support/decorators/messageBundle","../../intl/locale","../../intl/substitute","../../intl/messages"],(function(e,t,i,s,o,l,n,a,r,d,h,c,m,p,u,g,b,y,f,_,w,T,C,I,v,E,F,A,S,R,x,U,j,O,V,W,P,z,N,B,L,Z){"use strict";const G="80px";let k=class extends F{constructor(e){super(e),this._debounceRefresh=d.debounce((()=>this._refresh())),this._highlights=new a,this.actionColumnConfig=null,this.attachmentsViewOptions=new R,this.attributeTableTemplate=null,this.autoRefreshEnabled=!0,this.columns=new s,this.dataProvider=async(e,t)=>{const{layer:i,store:s}=this;if(!t)return;if(!i||!s)return void(t&&t([]));await i.load();const{objectIds:o}=this;if(this.filterBySelectionEnabled&&!this.highlightIds.length||1===o.length&&-1===o.items[0])return void t([]);"loaded"!==s.state&&"loading"!==s.state&&await s.load();const l=this.paginationEnabled?this.pageIndex:e.page,n=await s.fetchItems({...e,page:l});t&&t(n)},this.editingEnabled=!1,this.grid=null,this.highlightEnabled=!0,this.itemIdPath="objectId",this.messages=null,this.messagesCommon=null,this.messagesUnits=null,this.messagesURIUtils=null,this.prompt=null,this.relatedTables=new s,this.relationshipColumnConfigs=null,this.selectionSource="table",this.showRelatedTableCallback=null,this.store=null,this.tableController=null,this.tableParent=null,this.tableTemplate=null,this.tableTemplateOverride=null,this._onLayerRefresh=this._onLayerRefresh.bind(this),this._onShowPromptCallback=this._onShowPromptCallback.bind(this),this._set("store",new j),this._set("grid",new E({itemIdPath:this.itemIdPath,viewModel:this}))}initialize(){const e=async()=>{this.messages=await Z.fetchMessageBundle("esri/widgets/FeatureTable/t9n/FeatureTable"),this.messagesCommon=await Z.fetchMessageBundle("esri/t9n/common"),this.messagesUnits=await Z.fetchMessageBundle("esri/core/t9n/Units"),this.messagesURIUtils=await Z.fetchMessageBundle("esri/widgets/support/t9n/uriUtils")};e(),this.addHandles([B.onLocaleChange((()=>{e(),this._generateColumns()})),h.watch((()=>[this.messages,this.messagesCommon,this.messagesURIUtils]),(()=>{const e=this.messages;this.grid&&(this.grid.messages=e),this.allColumns.forEach((t=>{t.messages=e,t.messagesCommon=this.messagesCommon,t.messagesURIUtils=this.messagesURIUtils})),this.refreshCellContent()}),h.initial),h.on((()=>this.highlightIds),"change",(e=>this._onHighlightIdsChange(e)),{onListenerAdd:()=>this._syncSelection(),onListenerRemove:()=>this._highlights.removeAll()}),h.watch((()=>this.attachmentsEnabled),(()=>this.layer?.loaded&&this._generateColumns())),h.watch((()=>this._viewSelection),(()=>{this._viewSelectionReady&&(this.highlightIds.items=this._viewSelection)})),h.watch((()=>[this._tableHighlightsReady,this._viewSelectionReady]),(()=>this._syncSelection())),h.watch((()=>this.layer),(async(e,t)=>{const i=this.grid;i&&(i.clearSort(),e&&t&&await this.reset()),this.goToPage(0),this._drainColumns(),this.store.layer=e,e&&(e.loaded?this._onLayerLoad():e.load().catch((()=>{})))})),h.watch((()=>this.layer?.loaded),(e=>e&&this._onLayerLoad())),h.watch((()=>this.store.state),(e=>{"loaded"===e&&(this.scrollToTop(),this.refreshCellContent())})),h.watch((()=>this._effectiveTableTemplate),(()=>{this.scrollLeft(),this.layer?.loaded&&this._generateColumns()})),h.watch((()=>this.editingEnabled),(e=>{this.editableColumns.forEach((t=>t.tableEditingEnabled=e)),this.refreshCellContent()})),h.watch((()=>this.timeZone??this.view?.timeZone),(()=>this.refreshCellContent())),h.watch((()=>this.layer?.definitionExpression),((e,t)=>(e||t)&&"loaded"===this.store.state&&this.reset())),h.watch((()=>this.layer?.timeExtent),((e,t)=>(e||t)&&!this.timeExtent&&"loaded"===this.store.state&&this.reset())),h.on((()=>this.layer),"refresh",(e=>this._onLayerRefresh(e))),h.on((()=>this.grid),["cell-click","cell-dblclick","cell-pointerover","cell-pointerout","cell-keydown","column-reorder"],(({index:e,item:t,native:i,path:s,type:o})=>{const l=t?.feature,n=l?.getObjectId(),a="cell-keydown"===o&&i&&i instanceof KeyboardEvent&&"Enter"===i.key;this.emit(o,{feature:l,index:e,native:i,type:o,fieldName:s??void 0,objectId:n}),(a||"cell-click"===o)&&this._onCellInteraction(n)})),h.watch((()=>this.actionColumnConfig),(e=>{const{actionColumn:t,columns:i}=this;t?e?t.set(e):i.remove(t):e&&i.length&&i.add(this._generateActionColumn(),!1!==e.frozenToEnd?void 0:this._getIndexOfFirstFrozenToEndColumn())})),h.watch((()=>this.relatedRecordsEnabled),(()=>this.layer?.loaded&&this._generateColumns())),h.on((()=>this.objectIds),"change",(()=>this._onObjectIdsChange()),{onListenerAdd:()=>this._onObjectIdsChange()}),h.watch((()=>[this.paginationEnabled,this.pageIndex]),(()=>this.refreshPageCache())),h.watch((()=>this.activeSortOrders),(e=>this.store.sortOrders=e)),h.watch((()=>this.pageCount),(()=>{this.pageIndex>=this.pageCount&&this.goToPage(0)})),h.watch((()=>this.state),(e=>{"disabled"===e&&this.relatedTables.length&&this.drainRelatedTables()})),h.on((()=>this.tableParent?.highlightIds),"change",(({added:e})=>{const{relationshipConfig:t}=this,i=e[0];if(null==i||!t)return;const{relatedLayer:s,relationshipId:o}=t;this.relationshipConfig={objectId:i,relatedLayer:s,relationshipId:o}})),h.on((()=>this.tableParent),"cell-click",(e=>{const{tableParent:t}=this,{objectId:i}=e;t&&null!=i&&t.highlightIds.add(i)})),h.watch((()=>this.attachmentsViewOptions.objectId),((e,t)=>{null!=e?null==t&&this.showAttachmentsView({objectId:e}):this.hideAttachmentsView()}))])}destroy(){this._drainColumns(),this._highlights.removeAll(),this._highlights.destroy(),this.grid?.destroy(),this.columns.destroyed||this.columns.destroy(),this.layer=null,this.view=null}get _defaultHiddenFields(){return u.getLowerCaseDefaultHiddenFields(this.layer)}get _effectiveTableTemplate(){return this.tableTemplateOverride||this.tableTemplate}get _effectiveAttributeTableTemplate(){return this.attributeTableTemplate||this.layer?.attributeTableTemplate}get _highlightableLayerView(){const e=this.layerView;return f.highlightsSupported(e)?e:null}get _relationshipInfos(){return this.store.relationshipInfos}get _selectionManager(){const{view:e}=this;return!e||e.destroyed?null:e.selectionManager?.sources?.length?e.selectionManager:null}get _selectableLayer(){const{layer:e}=this;return _.isSelectableLayer(e)&&this._selectionManager?.sources.includes(e)?e:null}get _subtypes(){return g.getSubtypesFromLayer(this.layer)}get _tableHighlightsReady(){return!("table"!==this.selectionSource||!this.highlightEnabled||!this._highlightableLayerView)}get _viewSelection(){const{_selectableLayer:e}=this;return e?this._selectionManager?.getSelection(e)??[]:[]}get _viewSelectionReady(){return!(!this.layer||"view"!==this.selectionSource||!this._selectionManager)}get allRelatedTablesVisible(){return!!(this.relatedRecordsEnabled&&this.relatedTables.length&&this.showAllRelatedTables)}get activeFilters(){const{filterGeometry:e,objectIds:t,filterBySelectionEnabled:i,highlightIds:o}=this,l=new s;return e&&l.push({type:"geometry",geometry:e}),i?l.push({type:"selection",objectIds:o.toArray()}):t.length&&l.push({type:"objectId",objectIds:t.toArray()}),l}get activeSortOrders(){return this.grid?.sortOrders?this.grid.sortOrders.map((({path:e,direction:t})=>({fieldName:e,direction:t}))).filter((e=>e.fieldName&&e.direction)):[]}get attachmentsEnabled(){return this.store.attachmentsEnabled}set attachmentsEnabled(e){this.store.attachmentsEnabled=e}get clearPrompt(){return()=>this.prompt=null}set clearPrompt(e){this._overrideIfSome("clearPrompt",e)}get filterGeometry(){return this.store.filterGeometry}set filterGeometry(e){this.store.filterGeometry=e}get filterBySelectionEnabled(){return!!this._get("filterBySelectionEnabled")}set filterBySelectionEnabled(e){const{objectIds:t}=this,i=t.length;e?(i&&(t.removeAll(),this._logWarning("Selection filter has been applied with an objectID filter. Object ID filter has been removed.")),this.filterGeometry&&this._logWarning("Selection filter has been applied with a geometry filter. Results may appear inconsistent"),this._syncObjectIdsWithStore(this.highlightIds.toArray())):i||this._syncObjectIdsWithStore(null),this._set("filterBySelectionEnabled",e)}get hiddenFields(){return this._get("hiddenFields")??new s}set hiddenFields(e){this._set("hiddenFields",o.referenceSetter(e,this._get("hiddenFields"),s))}get initialSize(){return this.store.initialSize}set initialSize(e){this.store.initialSize=e}get isQueryingOrSyncing(){const{store:e}=this;return e?.syncing||e?.querying||this.relatedTables.some((e=>!!e.isQueryingOrSyncing))}get isSyncingAttachments(){return this.store.syncingAttachmentEdits||this.relatedTables.some((e=>!!e.isSyncingAttachments))}get layer(){return this._get("layer")}set layer(e){this._highlights.removeAll(),this.drainRelatedTables(),this._set("layer",e)}get layerView(){return this.store.layerView}get outFields(){return this.store.outFields}set outFields(e){this.store.outFields=e}get relatedRecordsEnabled(){return this.store.relatedRecordsEnabled}set relatedRecordsEnabled(e){this.store.relatedRecordsEnabled=e}get relatedTable(){return this.relatedTables.at(-1)}get relationship(){const e=this.relationshipConfig?.relationshipId;return null==e?null:this.relationships?.find((({id:t})=>t===e))}get relationshipConfig(){return this.store.relationshipConfig}set relationshipConfig(e){this.highlightIds.removeAll(),this.objectIds.removeAll(),this.filterBySelectionEnabled=!1,this.store.relationshipConfig=e}get relationships(){return this.store.relationships}get returnGeometryEnabled(){return this.store.returnGeometry}set returnGeometryEnabled(e){this.store.returnGeometry=e}get returnMEnabled(){return this.store.returnM}set returnMEnabled(e){this.store.returnM=e}get returnZEnabled(){return this.store.returnZ}set returnZEnabled(e){this.store.returnZ=e}get showAllRelatedTables(){return this._get("showAllRelatedTables")}set showAllRelatedTables(e){const{relatedTable:t}=this;this._set("showAllRelatedTables",e),t&&(e?this._showAllRelatedTables(t):this._hideAllRelatedTables(t))}get showPrompt(){return e=>{this.prompt?.cancel?.(),this.prompt=e}}set showPrompt(e){this._overrideIfSome("showPrompt",e)}get supportsAttachments(){return this.store.supportsAttachments}get supportsAddAttachments(){const{store:{supportsAddingAttachments:e,supportsEditing:t}}=this;return this.editingEnabled&&t&&e}get supportsDeleteAttachments(){const{store:{supportsDeletingAttachments:e,supportsEditing:t}}=this;return this.editingEnabled&&t&&e}get supportsResizeAttachments(){return this.store.supportsResizeAttachments}get supportsUpdateAttachments(){const{store:{supportsUpdateAttachments:e,supportsEditing:t}}=this;return this.editingEnabled&&t&&e}get timeExtent(){return this.store.timeExtent}set timeExtent(e){this.store.timeExtent=e}get timeZone(){return this._get("timeZone")}set timeZone(e){this.allColumns.forEach((t=>t.tableTimeZone=e)),this._set("timeZone",e)}get view(){return this.store.view}set view(e){this.store.view=e,this.fieldColumns.forEach((t=>t.view=e)),this.refreshCellContent()}async addAttachment(e,t){const{attachmentsViewOptions:i,store:s}=this,o=i.objectId===e;await s.addAttachment(e,t).catch((e=>{o&&e&&"object"==typeof e&&"error"in e&&e.error instanceof n&&(this._logWarning(`Unable to add attachment. ${e.error.name} ${e.error.message}`),i.error=e.error)})),o&&!i.error&&(i.onEditComplete(),i.attachmentInfos=await s.getAttachmentsByObjectId(e,!0)),this.refreshCellContent()}async deleteAttachments(e,t){const{attachmentsViewOptions:i,store:s}=this,o=i.objectId===e;await s.deleteAttachments(e,t).catch((e=>{o&&e&&"object"==typeof e&&"error"in e&&e.error instanceof n&&(this._logWarning(`Unable to delete attachment(s). ${e.error.name} ${e.error.message}`),i.error=e.error)})),o&&!i.error&&(i.onEditComplete(),i.attachmentInfos=await s.getAttachmentsByObjectId(e,!0)),this.refreshCellContent()}collapseRelatedTable(e,t){const{relatedLayer:i,objectId:o,relationshipId:l}=t,{objectIdField:n}=i,a=P.findRelationship(i,l),r=i.displayField||a?.keyField||n;e.set({highlightIds:new s([o]),multipleSelectionEnabled:!1,tableTemplateOverride:this._getTableTemplateForRelatedTableView(e,r,l)});const d=e.hiddenFields;d.includes(P.uniqueColumnNames.action)||d.add(P.uniqueColumnNames.action),d.includes(P.uniqueColumnNames.attachments)||d.add(P.uniqueColumnNames.attachments),e.scrollLeft()}async deleteSelection(){const e=this.highlightIds.toArray();if(!e?.length)return;const{deleteFeatureResults:t}=await this.store.deleteRowsByObjectId(e),i=t.filter((e=>!e.error)).map((e=>e.objectId));i.length&&(this.highlightIds.removeMany(i),await this.refresh())}async downloadAttachmentById(e,t){const i=(await this.store.getAttachmentsByObjectId(e,!0)).find((e=>e.id===t));U.downloadAttachmentInfo(i)}drainRelatedTables(){this.relatedTables.drain((e=>e.destroy())),this.set({multipleSelectionEnabled:!0,relationshipColumnConfigs:null,showAllRelatedTables:!1,tableTemplateOverride:null}),this.hiddenFields.removeMany([P.uniqueColumnNames.action,P.uniqueColumnNames.attachments])}drainRelatedTablesAboveIndex(e){const{relatedTables:t}=this,i=t.slice(e+1);t.removeMany(i).forEach((e=>e.destroy()));const s=t.at(-1);s&&(s.attachmentsViewOptions.objectId=null,this.allRelatedTablesVisible?this._showAllRelatedTables(s):this._hideAllRelatedTables(s))}async exportSelectionToCSV(e){const{highlightIds:t,layer:i,outFields:s}=this;i&&t.length?await U.exportToCSV({layer:i,objectIds:t.toArray(),outFields:s,includeGeometry:e}):this._logWarning("Export failed.")}filterBySelection(){this.filterBySelectionEnabled?this._logWarning("Property 'filterBySelectionEnabled' is already 'true'. This method has no effect."):(l.deprecatedFunction(r.getLogger(this),"`FeatureTable.filterBySelection` is deprecated in favor of 'filterBySelectionEnabled' and 'objectIds'",{replacement:"FeatureTable.filterBySelectionEnabled or FeatureTable.objectIds",version:"4.30",warnOnce:!0}),this.objectIds.addMany(this.highlightIds.toArray()))}getObjectIdIndex(e){return this.store.getItemIndexByObjectId(e)}getValue(e,t){const i=this.store.getItemByObjectId(e);return i?.feature?.attributes[t]}getVirtualPageIndex(){return this.grid?.getVirtualPageIndex()??0}goToPage(e){if(null==e||!Number.isInteger(e))return void this._logWarning("Invalid 'page' parameter provided to 'goToPage()'. Current page will remain the same.");const{pageCount:t}=this;(e>=t||-1===e)&&(e=t-1),e<-1&&(e=0),e!==this.pageIndex&&(this.pageIndex=e),this.paginationEnabled||this.scrollToIndex(e*this.pageSize)}hideAttachmentsView(){this.attachmentsViewOptions.objectId=null,this.set({relationshipColumnConfigs:null,multipleSelectionEnabled:!0,tableTemplateOverride:null}),this.hiddenFields.remove(P.uniqueColumnNames.action)}nextPage(){const e=this.paginationEnabled?this.pageIndex:this.getVirtualPageIndex();this.goToPage(e+1)}previousPage(){const e=this.paginationEnabled?this.pageIndex:this.getVirtualPageIndex();this.goToPage(e-1)}async refresh(){return this.relatedTables.forEach((async e=>await e.refresh())),d.ignoreAbortErrors(this._debounceRefresh())}refreshCellContent(){this.grid?.requestContentUpdate()}refreshPageCache(){this.grid?.refreshPageCache()}async reset(){this.goToPage(0),await(this.grid?.reset())}scrollLeft(){this.grid?.scrollLeft(0)}scrollToBottom(){this.grid?.scrollToBottom()}scrollToIndex(e){this.grid?.scrollToIndex(e)}scrollToRow(e){const t=this.store.getItemIndexByObjectId(e);t>-1?this.grid?.scrollToIndex(t):this._logWarning("Row not found. Associated data may not be loaded yet.")}scrollToTop(){this.grid?.scrollToTop()}async saveAttachmentsViewForm(){const{attachmentId:e,form:t,objectId:i}=this.attachmentsViewOptions;null!=i&&t&&(null!=e?await this.updateAttachment(i,e,t):await this.addAttachment(i,t))}async showAttachmentsView({objectId:e}){const{attachmentsViewOptions:t,hiddenFields:i,layer:o}=this;if(!this.attachmentsEnabled||!o)return void this._logWarning("The 'attachmentsEnabled' property is currently false.");await o.load();const l=o.displayField||o.objectIdField,n=await this.store.getAttachmentsByObjectId(e,!0),a=this.store.getItemIndexByObjectId(e);t.set({attachmentInfos:n,mode:n.length?"list":"file",objectId:e}),this.set({highlightIds:new s([e]),multipleSelectionEnabled:!1,relationshipColumnConfigs:[],tableTemplateOverride:this._getTableTemplateForAttachmentsView(l)}),i.includes(P.uniqueColumnNames.action)||i.add(P.uniqueColumnNames.action),null!=a&&this.scrollToIndex(a)}clearSelectionFilter(){l.deprecatedFunction(r.getLogger(this),"`FeatureTable.clearSelectionFilter` is deprecated in favor of 'filterBySelectionEnabled' and 'objectIds'",{replacement:"FeatureTable.filterBySelectionEnabled or FeatureTable.objectIds",version:"4.30",warnOnce:!0}),this.objectIds.removeAll()}async updateAttachment(e,t,i){const{attachmentsViewOptions:s,store:o}=this,l=s.objectId===e;await o.updateAttachment(e,t,i).catch((e=>{l&&e&&"object"==typeof e&&"error"in e&&e.error instanceof n&&(this._logWarning(`Unable to update attachment. ${e.error.name} ${e.error.message}`),s.error=e.error)})),l&&!s.error&&(s.onEditComplete(),s.attachmentInfos=await o.getAttachmentsByObjectId(e,!0)),this.refreshCellContent()}async zoomToSelection(){const{layer:e,view:t}=this,i=this.highlightIds.toArray();if(!e||!t||!i.length)return;const s=e.createQuery();s.objectIds=i,s.returnGeometry=!0;const o=await e.queryFeatures(s);try{await t.goTo(o.features)}catch(l){"AbortError"!==l.name&&console.error(l)}}async _refresh(){await this.store.refresh();const e=this.highlightIds.toArray();if(e.length){(await this.store.verifyFeaturesByObjectId(e)).forEach(((t,i)=>{t||this.highlightIds.remove(e[i])}))}this.refreshPageCache();const t=this.attachmentsViewOptions;null!=t?.objectId&&(t.attachmentInfos=await this.store.getAttachmentsByObjectId(t.objectId,!0))}async _onLayerLoad(){const{layer:e,pageSize:t}=this;if(!e)return;e.parent&&g.isSubtypeGroupLayer(e.parent)&&await e.parent.loadAll();const i=e.capabilities.query?.maxRecordCount,s=i&&i<t,o=s?i:t;s&&(this._logWarning("The value for 'pageSize' has been adjusted due to the provided layer's max record count."),this.pageSize=o),this.grid?.set("pageSize",o),this.store.load(),this._generateColumns()}_onLayerRefresh(e){this.autoRefreshEnabled&&e.dataChanged&&this.refresh()}_generateColumns(){this._drainColumns();const{_effectiveTableTemplate:e,_effectiveAttributeTableTemplate:t}=this,i=e?.columnTemplates,s=this._generateColumnsFromColumnTemplates(i)??this._generateColumnsFromAttributeTableTemplate(t)??this._generateDefaultFieldColumns();s.length&&(this.attachmentsEnabled&&!s.some((e=>x.isAttachmentsColumn(e)))&&s.push(this._generateDefaultAttachmentsColumn()),this.relatedRecordsEnabled&&this._relationshipInfos.length&&!s.some((e=>x.isRelationshipColumn(e)))&&s.push(...this._generateDefaultRelationshipColumns()),this.actionColumnConfig&&s.push(this._generateActionColumn()),s.sort(((e,t)=>e.frozen&&t.frozen||e.frozenToEnd&&t.frozenToEnd?0:e.frozen||t.frozenToEnd?-1:0)),this.columns.addMany(s))}_generateColumnsFromAttributeTableTemplate(e){const{layer:t}=this;if(!e||!t)return null;const{elements:s,orderByFields:o}=e,l=b.createFieldInfos(t),n=[];n.push(...this._generateColumnsFromAttributeTableElements(s,o));const a=l.map((e=>{if(!e.fieldName||P.hasColumnForField(e.fieldName,n))return null;const{fieldName:i}=e,s=P.findField(t,i);return s?this._generateDefaultFieldColumn(s,{hidden:!0,orderByFields:o}):(this._logTemplateWarning("A valid 'field' could not be found for the provided template."),null)})).filter(i.isSome);return n.push(...a),this.attachmentsEnabled&&P.isIFeatureTableSupportedLayerWithAttachments(t)&&!n.some((e=>x.isAttachmentsColumn(e)))&&n.push(this._generateDefaultAttachmentsColumn({hidden:!0})),this.relatedRecordsEnabled&&P.isIFeatureTableSupportedLayerWithRelationships(t)&&t.relationships?.forEach((({id:e},t)=>{const i=this._relationshipInfos.find((t=>t.relationshipId===e));i&&!n.some((t=>x.isRelationshipColumn(t)&&t.relationshipId===e))&&n.push(this._generateDefaultRelationshipColumn({hidden:!0,info:i,index:t}))})),n.length?n:null}_generateColumnsFromAttributeTableElements(e,t){const{layer:i}=this;return i?e?.map(((e,i)=>{switch(e.type){case"field":return this._createFieldColumnFromElement({element:e,orderByFields:t});case"group":return this._createGroupColumnFromElement({element:e,orderByFields:t});case"attachment":return this._createAttachmentColumnFromElement({element:e,index:i});case"relationship":return this._createRelationshipColumnFromElement({element:e,index:i})}})).filter((e=>!!e))??[]:[]}_createFieldColumnFromElement(e){const{layer:t}=this;if(!t)return null;const{element:i,orderByFields:s}=e,{fieldName:o}=i;if(null==o)return this._logTemplateWarning("A valid 'fieldName' must be provided."),null;const l=P.findField(t,o);if(!l)return this._logTemplateWarning("A valid 'field' could not be found for the provided template."),null;const{description:n,label:a}=i,r=s?.findIndex((({field:e})=>e&&e===o))??-1,d=r>-1?s?.at(r)?.order:void 0,h=r>-1?r:null,{editingEnabled:c,grid:m,messages:p,messagesCommon:u,messagesURIUtils:g,store:b,timeZone:y,view:f}=this;return new C({description:n,direction:d,field:l,fieldName:o,grid:m,initialSortPriority:h,label:a,layer:t,messages:p,messagesCommon:u,messagesURIUtils:g,store:b,tableEditingEnabled:c,tableTimeZone:y,view:f,onShowPromptCallback:this._onShowPromptCallback})}_createGroupColumnFromElement(e){const{element:t,orderByFields:i}=e,{description:s,label:o}=t;if(!o)return this._logTemplateWarning("Group columns require a label."),null;if(!t.elements.length)return this._logTemplateWarning("Group columns require child columns."),null;const{grid:l,messages:n,messagesCommon:a,messagesURIUtils:r,store:d,timeZone:h}=this;return new A({columns:this._generateColumnsFromAttributeTableElements(t.elements,i),description:s,grid:l,label:o,messages:n,messagesCommon:a,messagesURIUtils:r,store:d,tableTimeZone:h})}_createAttachmentColumnFromElement(e){if(!this.attachmentsEnabled)return void this._logTemplateWarning("The 'attachmentsEnabled' property is currently false.");const{element:t,index:i}=e,{description:s,label:o}=t,{grid:l,layer:n,messages:a,messagesCommon:r,messagesURIUtils:d,store:h,timeZone:c}=this;return new T({description:s,fieldName:`${P.uniqueColumnNames.attachments}-${i}`,grid:l,label:o,layer:n,messages:a,messagesCommon:r,messagesURIUtils:d,store:h,tableTimeZone:c,onShowAttachments:e=>this._onShowAttachments(e)})}_createRelationshipColumnFromElement(e){if(!this.relatedRecordsEnabled)return void this._logTemplateWarning("Relationship columns require related records to be enabled on the table.");const{element:t,index:i}=e,{description:s,label:o,relationshipId:l}=t,n=this._relationshipInfos.find((e=>e.relationshipId===l));if(!n)return this._logTemplateWarning("Unable to find valid related layer target based on the provided relationship id."),null;const{grid:a,messages:r,messagesCommon:d,messagesURIUtils:h,store:c,timeZone:m}=this;return new I({description:s,fieldName:`${P.uniqueColumnNames.relationship}-${l}-${i}`,grid:a,label:o,messages:r,messagesCommon:d,messagesURIUtils:h,relationshipId:l,store:c,tableTimeZone:m,layer:n.relatedLayer,relatedLayer:n.layer,showRelatedTableCallback:e=>this._onShowRelatedTable(e)})}_generateColumnsFromColumnTemplates(e){const{editingEnabled:t,grid:i,layer:s,messages:o,messagesCommon:l,messagesURIUtils:n,store:a,timeZone:r,view:d}=this;if(!e?.length||!s)return null;const h=[];return e.forEach(((e,c)=>{const{autoWidth:m,description:p,direction:u,flexGrow:g,fieldName:b,formatFunction:y,frozen:f,frozenToEnd:_,icon:w,initialSortPriority:T,invalid:I,label:E,menuConfig:F,resizable:S,sortable:R,textAlign:x,textWrap:U,timeZone:j,type:O,width:V}=e;if(!O)return void this._logTemplateWarning("Property 'type' is missing from the provided template.");if(f&&_)return void this._logTemplateWarning("Properties 'frozen' and 'frozenToEnd' cannot both be true for the same column.");const W=!1===e.visible;if("group"===O){if(!e.columnTemplates?.length)return void this._logTemplateWarning("Group columns must contain column templates.");if(!e.label)return void this._logTemplateWarning("Group columns require a label.");const t=this._generateColumnsFromColumnTemplates(e.columnTemplates),s=W||this._isFieldHidden(e.label);h.push(new A({autoWidth:m,columns:t,description:p,flexGrow:g,frozen:f,frozenToEnd:_,grid:i,hidden:s,icon:w,invalid:I,label:E,menuConfig:F,messages:o,messagesCommon:l,messagesURIUtils:n,resizable:S,tableTimeZone:r,textAlign:x,textWrap:U,timeZone:j,width:V}))}else if("attachment"===O){if(!this.attachmentsEnabled)return void this._logTemplateWarning("Attachment columns require attachments to be enabled on the table.");h.push(this._generateAttachmentsColumnFromTemplate(e,c))}else if("relationship"===O){if(!this.relatedRecordsEnabled)return void this._logTemplateWarning("Relationship columns require related records to be enabled on the table.");const{relationshipId:t}=e;if(null==t)return void this._logTemplateWarning("Property 'relationshipId' is missing from the provided template.");const i=this._relationshipInfos.find((e=>e.relationshipId===t));if(!i)return void this._logTemplateWarning("Unable to find valid related layer target based on the provided relationship id.");h.push(this._generateRelationshipColumnFromTemplate(i,e,c))}else if(!b)return void this._logTemplateWarning("Value for 'fieldName' property was missing from the provided template.");const z=W||this._isFieldHidden(b);if("column"===O)h.push(new v({autoWidth:m,description:p,direction:u,fieldName:b,flexGrow:g,formatFunction:y,frozen:f,frozenToEnd:_,grid:i,hidden:z,icon:w,initialSortPriority:T,invalid:I,label:E,menuConfig:F,messages:o,messagesCommon:l,messagesURIUtils:n,resizable:S,sortable:R,tableTimeZone:r,textAlign:x,textWrap:U,timeZone:j,width:V}));else if("field"===O){const c=P.findField(s,e.fieldName);if(!c)return void this._logTemplateWarning("A valid 'field' could not be found for the provided template.");const{editable:b,required:v}=e;h.push(new C({autoWidth:m,description:p,direction:u,editable:b,field:c,fieldName:c.name,flexGrow:g,formatFunction:y,frozen:f,frozenToEnd:_,grid:i,hidden:z,icon:w,initialSortPriority:T,invalid:I,label:E,layer:s,messages:o,messagesCommon:l,messagesURIUtils:n,menuConfig:F,required:v,resizable:S,sortable:R,store:a,tableEditingEnabled:t,tableTimeZone:r,template:e,textAlign:x,textWrap:U,timeZone:j,width:V,view:d,onShowPromptCallback:this._onShowPromptCallback}))}})),h.length?h:null}_generateDefaultFieldColumns(){return this.layer?.fields?.map((e=>this._generateDefaultFieldColumn(e))).filter(i.isSome)??[]}_generateDefaultFieldColumn(e,t){const{editingEnabled:i,grid:s,layer:o,messages:l,messagesCommon:n,messagesURIUtils:a,store:r,timeZone:d,view:h}=this,c=t?.orderByFields;if(!e.visible||"geometry"===e.type)return null;const m=e.name,p=c?.findIndex((e=>e.field&&e.field===m)),u=null!=p?c?.at(p)?.order:null,g=null!=p&&p>-1?p:void 0;return new C({direction:u,field:e,fieldName:m,grid:s,hidden:t?.hidden||this._isFieldHidden(m),initialSortPriority:g,layer:o,messages:l,messagesCommon:n,messagesURIUtils:a,store:r,tableEditingEnabled:i,tableTimeZone:d,view:h,onShowPromptCallback:this._onShowPromptCallback})}_generateAttachmentsColumnFromTemplate(e,t){const{grid:i,layer:s,messages:o,messagesCommon:l,messagesURIUtils:n,store:a,timeZone:r}=this,{attachmentsViewEnabled:d,autoWidth:h,description:c,flexGrow:m,fieldName:p,formatFunction:u,frozen:g,frozenToEnd:b,icon:y,invalid:f,label:_,menuConfig:w,resizable:C,textAlign:I,textWrap:v,thumbnailAppearance:E,thumbnailCount:F,thumbnailIconScale:A,thumbnailsEnabled:S,timeZone:R,width:x}=e;return new T({attachmentsViewEnabled:d,autoWidth:h,description:c,fieldName:`${P.uniqueColumnNames.attachments}-${t}`,flexGrow:m,formatFunction:u,frozen:g,frozenToEnd:b,grid:i,hidden:!1===e.visible||this._isFieldHidden(_)||this._isFieldHidden(p),icon:y,invalid:f,label:_,layer:s,menuConfig:w,messages:o,messagesCommon:l,messagesURIUtils:n,resizable:C,store:a,tableTimeZone:r,textAlign:I,textWrap:v,thumbnailAppearance:E,thumbnailCount:F,thumbnailIconScale:A,thumbnailsEnabled:S,timeZone:R,width:x,onShowAttachments:e=>this._onShowAttachments(e)})}_generateDefaultAttachmentsColumn(e){const{grid:t,layer:i,messages:s,messagesCommon:o,messagesURIUtils:l,store:n,timeZone:a}=this,r=P.uniqueColumnNames.attachments;return new T({fieldName:r,grid:t,hidden:e?.hidden||this._isFieldHidden(r),layer:i,messages:s,messagesCommon:o,messagesURIUtils:l,store:n,tableTimeZone:a,onShowAttachments:e=>this._onShowAttachments(e)})}_generateRelationshipColumnFromTemplate(e,t,i){const{grid:s,messages:o,messagesCommon:l,messagesURIUtils:n,store:a,timeZone:r}=this,{autoWidth:d,collapsed:h,description:c,flexGrow:m,fieldName:p,formatFunction:u,frozen:g,frozenToEnd:b,icon:y,invalid:f,label:_,menuConfig:w,relationshipId:T,resizable:C,textAlign:v,textWrap:E,timeZone:F,width:A}=t;return new I({autoWidth:d,collapsed:h,description:c,fieldName:`${P.uniqueColumnNames.relationship}-${T}-${i}`,flexGrow:m,formatFunction:u,frozen:g,frozenToEnd:b,grid:s,hidden:!1===t.visible||this._isFieldHidden(_)||this._isFieldHidden(p),icon:y,invalid:f,label:_,menuConfig:w,messages:o,messagesCommon:l,messagesURIUtils:n,relationshipId:T,resizable:C,store:a,tableTimeZone:r,textAlign:v,textWrap:E,timeZone:F,width:A,layer:e.relatedLayer,relatedLayer:e.layer,showRelatedTableCallback:e=>this._onShowRelatedTable(e)})}_generateDefaultRelationshipColumns(){const{_relationshipInfos:e,relationshipColumnConfigs:t}=this,i=[];return e?.length?(t?t.forEach(((t,s)=>{const{relationshipId:o}=t,l=e.find((e=>e.relationshipId===o));l&&i.push(this._generateDefaultRelationshipColumn({config:t,index:s,info:l}))})):e.forEach(((e,t)=>i.push(this._generateDefaultRelationshipColumn({index:t,info:e})))),i):i}_generateDefaultRelationshipColumn(e){const{config:t,hidden:i,index:s,info:o}=e,{grid:l,messages:n,messagesCommon:a,messagesURIUtils:r}=this,{relationshipId:d}=o;return new I({...t,fieldName:`${P.uniqueColumnNames.relationship}-${d}-${s}`,grid:l,hidden:i,messages:n,messagesCommon:a,messagesURIUtils:r,layer:o.relatedLayer,relatedLayer:o.layer,relationshipId:d,showRelatedTableCallback:e=>this._onShowRelatedTable(e)})}_generateActionColumn(){return new w({hidden:this._isFieldHidden(P.uniqueColumnNames.action),...this.actionColumnConfig})}_isFieldHidden(e){const t=e?.toLowerCase();return(this.hiddenFields??this._defaultHiddenFields).some((e=>e.toLowerCase()===t))}_addTableHighlight(e){const{_highlightableLayerView:t,layer:i}=this;if(t&&i){const s=this.store.getItemByObjectId(e),o=s?.feature??e;this._highlights.add(t.highlight(o),`${i.id}-${e}`)}}_removeTableHighlight(e){const{layer:t}=this;t&&this._highlights.remove(`${t.id}-${e}`)}_syncSelection(){this._highlights.removeAll(),this._tableHighlightsReady?this.highlightIds.forEach((e=>this._addTableHighlight(e))):this._viewSelectionReady&&(this.highlightIds.items=this._viewSelection)}_appendToViewSelection(e){const{_selectableLayer:t}=this;t&&this._selectionManager?.appendToSelection(t,e)}_removeFromViewSelection(e){const{_selectableLayer:t}=this;t&&this._selectionManager?.removeFromSelection(t,e)}async _onHighlightIdsChange(e){const{added:t,removed:i}=e,{attachmentsViewOptions:s}=this;if(this._tableHighlightsReady?(i.forEach((e=>this._removeTableHighlight(e))),t.forEach((e=>this._addTableHighlight(e)))):this._viewSelectionReady&&(this._removeFromViewSelection(i),this._appendToViewSelection(t)),this.filterBySelectionEnabled&&this._syncObjectIdsWithStore(this.highlightIds.toArray()),null!=s.objectId){const e=this.highlightIds.at(0);if(null!=e){const t=await this.store.getAttachmentsByObjectId(e,!0);s.set({attachmentInfos:t,objectId:e,mode:t.length?"list":"file"})}}}_onShowRelatedTable(e){const{highlightIds:t}=this,{objectId:i}=e;t.removeAll(),t.add(i),this.showRelatedTableCallback?this.showRelatedTableCallback(e):this.emit("show-related-table",e)}_onObjectIdsChange(){const e=this.objectIds.toArray();e.length&&this.filterBySelectionEnabled&&(this.filterBySelectionEnabled=!1,this._logWarning("Object ID filter was applied while a selection filter was applied. Selection filter has been removed.")),this._syncObjectIdsWithStore(e)}_syncObjectIdsWithStore(e){this.store.objectIds=e,this.refreshPageCache()}_drainColumns(){this.columns.drain((e=>!e.destroyed&&e.destroy()))}_showAllRelatedTables(e){const t=e.layer;if(!t)return;const i=t.displayField||t.objectIdField;e.set({relationshipColumnConfigs:[],tableTemplateOverride:this._getTableTemplateForShowAllTablesView(e,i)});const s=e.hiddenFields;s.includes(P.uniqueColumnNames.action)||s.add(P.uniqueColumnNames.action),s.includes(P.uniqueColumnNames.attachments)||s.add(P.uniqueColumnNames.attachments)}_hideAllRelatedTables(e){const{layer:t,relationship:i}=e;if(t&&null!=i?.id)if(null!=e.attachmentsViewOptions.objectId){const t=e.layer?.displayField||e.layer?.objectIdField||"";e.set({multipleSelectionEnabled:!1,relationshipColumnConfigs:[],showAllRelatedTables:!1,tableTemplateOverride:this._getTableTemplateForAttachmentsView(t)})}else e.set({multipleSelectionEnabled:!0,relationshipColumnConfigs:P.getRelationshipIdsToShow(t,i.id),showAllRelatedTables:!1,tableTemplateOverride:null}),e.hiddenFields.removeMany([P.uniqueColumnNames.action,P.uniqueColumnNames.attachments])}_getTableTemplateForRelatedTableView(e,t,i){return new W({columnTemplates:[new O({fieldName:t,editable:!1,menuConfig:{selectionMode:"single",icon:"chevron-down",items:this._extractFieldColumnInfosFromTableTemplate(e.viewModel).map((([s,o])=>({selected:s===t,label:o||s,clickFunction:()=>{e.tableTemplateOverride=this._getTableTemplateForRelatedTableView(e,s,i)}})))},resizable:!1}),new V({autoWidth:!1,collapsed:!0,flexGrow:0,label:"",resizable:!1,relationshipId:i,width:G})]})}_getTableTemplateForShowAllTablesView(e,t){const i=[new O({fieldName:t,editable:!1,menuConfig:{selectionMode:"single",icon:"chevron-down",items:this._extractFieldColumnInfosFromTableTemplate(e.viewModel).map((([i,s])=>({selected:i===t,label:s||i,clickFunction:()=>{e.tableTemplateOverride=this._getTableTemplateForShowAllTablesView(e,i)}})))},resizable:!1})];return null!=e.attachmentsViewOptions.objectId&&i.push(new S({attachmentsViewEnabled:!1,autoWidth:!1,flexGrow:0,label:"",resizable:!1,thumbnailsEnabled:!1,width:G})),new W({columnTemplates:i})}async _onShowPromptCallback(e){const{column:t,objectId:i,oldValue:s,value:o}=e,{_subtypes:l,layer:n}=this;if(!n||!l.length)return void t.cancel();const a=l.find((e=>e.code===o));if(!a)return void t.cancel();const r=d.createResolver(),h=this._createSubtypeEditPrompt(s,a,r),c=!!n.parent;try{this.showPrompt(h);const e=await r.promise,s=[{fieldName:t.fieldName,value:o}];switch(e){case"update-fields":for(const[e,t]of Object.entries(a.defaultValues))null!=t&&s.push({fieldName:e,value:t});await t.updateItems({objectId:i,updates:s}),c&&this.refresh();break;case"keep-existing":await t.updateItems({objectId:i,updates:s}),c&&this.refresh();break;case"undo":t.cancel()}}finally{this.clearPrompt()}}_createSubtypeEditPrompt(e,t,i){const{_subtypes:s,messages:o,messagesCommon:l}=this,n=s.find((t=>t.code===e))?.name??`${e}`;let a="update-fields";const r=[{label:o.subtypes.useDefaultValuesOption,value:"update-fields"},{label:o.subtypes.keepCurrentValuesOption,value:"keep-existing"}];return{context:"info",title:o.subtypes.changeWarningTitle,message:L.substitute(o.subtypes.changeWarning,{originalType:n,newType:t.name}),radios:r,defaultRadioSelection:"update-fields",onRadioSelection:e=>{a=e},actions:{primary:{label:l.apply,action:()=>i.resolve(a),type:"positive"},secondary:{label:l.cancel,type:"neutral",action:()=>i.resolve("undo")}},cancel:()=>i.reject()}}_onShowAttachments({objectId:e}){this.attachmentsViewOptions.objectId=e}_getTableTemplateForAttachmentsView(e){return new W({columnTemplates:[new O({fieldName:e,editable:!1,menuConfig:{selectionMode:"single",icon:"chevron-down",items:this._extractFieldColumnInfosFromTableTemplate(this).map((([t,i])=>({selected:t===e,label:i||t,clickFunction:()=>{this.tableTemplateOverride=this._getTableTemplateForAttachmentsView(t)}})))},resizable:!1}),new S({attachmentsViewEnabled:!1,autoWidth:!1,flexGrow:0,label:"",resizable:!1,thumbnailsEnabled:!1,width:G})]})}_extractFieldColumnInfosFromTableTemplate(e){const t=e??this,{layer:i,tableTemplate:s}=t;return s?s.columnTemplates.filter((({type:e})=>"field"===e||"column"===e)).map((({fieldName:e,label:t})=>[e,t])):i?.fields.map((e=>[e.name,e.alias]))??[]}_getIndexOfFirstFrozenToEndColumn(){const e=this.columns.findIndex((e=>e.frozenToEnd));return e>-1?e:void 0}_logWarning(e,t){t?r.getLogger(this).warnOnce(e):r.getLogger(this).warn(e)}_logTemplateWarning(e){this._logWarning(`${e} Skipped generating a column using the provided template.`,!0)}_onCellInteraction(e){null!=e&&null!=this.attachmentsViewOptions.objectId&&this.highlightIds.add(e)}};e.__decorate([c.property()],k.prototype,"_defaultHiddenFields",null),e.__decorate([c.property()],k.prototype,"_effectiveTableTemplate",null),e.__decorate([c.property()],k.prototype,"_effectiveAttributeTableTemplate",null),e.__decorate([c.property()],k.prototype,"_highlights",void 0),e.__decorate([c.property()],k.prototype,"_highlightableLayerView",null),e.__decorate([c.property()],k.prototype,"_relationshipInfos",null),e.__decorate([c.property()],k.prototype,"_selectionManager",null),e.__decorate([c.property()],k.prototype,"_selectableLayer",null),e.__decorate([c.property()],k.prototype,"_subtypes",null),e.__decorate([c.property()],k.prototype,"_tableHighlightsReady",null),e.__decorate([c.property()],k.prototype,"_viewSelection",null),e.__decorate([c.property()],k.prototype,"_viewSelectionReady",null),e.__decorate([c.property()],k.prototype,"actionColumnConfig",void 0),e.__decorate([c.property()],k.prototype,"allRelatedTablesVisible",null),e.__decorate([c.property()],k.prototype,"activeFilters",null),e.__decorate([c.property({readOnly:!0})],k.prototype,"activeSortOrders",null),e.__decorate([c.property()],k.prototype,"attachmentsEnabled",null),e.__decorate([c.property()],k.prototype,"attachmentsViewOptions",void 0),e.__decorate([c.property({type:y})],k.prototype,"attributeTableTemplate",void 0),e.__decorate([c.property()],k.prototype,"autoRefreshEnabled",void 0),e.__decorate([c.property()],k.prototype,"clearPrompt",null),e.__decorate([c.property({readOnly:!0})],k.prototype,"columns",void 0),e.__decorate([c.property()],k.prototype,"dataProvider",void 0),e.__decorate([c.property()],k.prototype,"editingEnabled",void 0),e.__decorate([c.property()],k.prototype,"filterGeometry",null),e.__decorate([c.property()],k.prototype,"filterBySelectionEnabled",null),e.__decorate([c.property({readOnly:!0})],k.prototype,"grid",void 0),e.__decorate([c.property()],k.prototype,"hiddenFields",null),e.__decorate([c.property()],k.prototype,"highlightEnabled",void 0),e.__decorate([c.property()],k.prototype,"initialSize",null),e.__decorate([c.property()],k.prototype,"isQueryingOrSyncing",null),e.__decorate([c.property()],k.prototype,"isSyncingAttachments",null),e.__decorate([c.property({readOnly:!0})],k.prototype,"itemIdPath",void 0),e.__decorate([c.property()],k.prototype,"layer",null),e.__decorate([c.property()],k.prototype,"layerView",null),e.__decorate([c.property()],k.prototype,"messages",void 0),e.__decorate([c.property(),N.messageBundle("esri/t9n/common")],k.prototype,"messagesCommon",void 0),e.__decorate([c.property(),N.messageBundle("esri/core/t9n/Units")],k.prototype,"messagesUnits",void 0),e.__decorate([c.property(),N.messageBundle("esri/widgets/support/t9n/uriUtils")],k.prototype,"messagesURIUtils",void 0),e.__decorate([c.property()],k.prototype,"outFields",null),e.__decorate([c.property()],k.prototype,"prompt",void 0),e.__decorate([c.property()],k.prototype,"relatedRecordsEnabled",null),e.__decorate([c.property()],k.prototype,"relatedTable",null),e.__decorate([c.property()],k.prototype,"relatedTables",void 0),e.__decorate([c.property()],k.prototype,"relationship",null),e.__decorate([c.property()],k.prototype,"relationshipColumnConfigs",void 0),e.__decorate([c.property()],k.prototype,"relationshipConfig",null),e.__decorate([c.property()],k.prototype,"relationships",null),e.__decorate([c.property()],k.prototype,"returnGeometryEnabled",null),e.__decorate([c.property()],k.prototype,"returnMEnabled",null),e.__decorate([c.property()],k.prototype,"returnZEnabled",null),e.__decorate([c.property()],k.prototype,"selectionSource",void 0),e.__decorate([c.property()],k.prototype,"showAllRelatedTables",null),e.__decorate([c.property()],k.prototype,"showPrompt",null),e.__decorate([c.property()],k.prototype,"showRelatedTableCallback",void 0),e.__decorate([c.property({readOnly:!0,type:j})],k.prototype,"store",void 0),e.__decorate([c.property()],k.prototype,"supportsAttachments",null),e.__decorate([c.property()],k.prototype,"supportsAddAttachments",null),e.__decorate([c.property()],k.prototype,"supportsDeleteAttachments",null),e.__decorate([c.property()],k.prototype,"supportsResizeAttachments",null),e.__decorate([c.property()],k.prototype,"supportsUpdateAttachments",null),e.__decorate([c.property()],k.prototype,"tableController",void 0),e.__decorate([c.property()],k.prototype,"tableParent",void 0),e.__decorate([c.property({type:W})],k.prototype,"tableTemplate",void 0),e.__decorate([c.property()],k.prototype,"tableTemplateOverride",void 0),e.__decorate([c.property()],k.prototype,"timeExtent",null),e.__decorate([c.property()],k.prototype,"timeZone",null),e.__decorate([c.property()],k.prototype,"view",null),k=e.__decorate([p.subclass("esri.widgets.FeatureTable.FeatureTableViewModel")],k);return k}));
