/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../core/Logger","../../core/accessorSupport/decorators/property","../../core/has","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../../intl/date","../../intl/number","../../layers/support/editableLayers","../../layers/support/featureLayerUtils","../../layers/support/fieldUtils","../../smartMapping/support/utils","../../time/timeZoneUtils","../FeatureForm/FieldInput","./Grid/EditorColumn","./support/tableUtils","../support/dateUtils","../support/widgetUtils"],(function(e,t,i,n,r,o,a,l,s,u,p,d,c,m,f,h,y,_){"use strict";const g={cancelEdit:"Escape"},F="esri-column",v={input:`${F}__cell-input`,inputContainer:`${F}__cell__input-container`},D=a.convertDateFormatToIntlOptions("short-date-short-time"),b=a.convertDateFormatToIntlOptions("short-date"),C={useGrouping:!0,maximumFractionDigits:20};let I=class extends f{constructor(e){super(e),this._activeFieldInput=null,this.cellValueFormatFunction=({root:e,rowData:t,value:i})=>{const{formatFunction:n}=this;if(n&&t){const{index:r,item:{attachments:o,feature:a,relatedRecords:l}}=t;return n({attachments:o,column:this,feature:a,field:this.field,index:r,relatedRecords:l,value:_.renderingSanitizer.sanitize(i),virtualIndex:this.getVirtualRowIndex(e)})}if(null===i)return"&nbsp;";const{field:r}=this,o=this._getDomainForFeature(t?.item?.feature);if(o){const e=this._getComputedDomain(i,o);if("date"===r.type&&"range"===o.type)return this._formatDateValueForDisplay(r,e);if(this._isNumericField&&"range"===o.type){const e=this.template?.format,t=e?l.convertNumberFormatToIntlOptions(e):C;return l.formatNumber(parseFloat(i),t)}return y.dateFieldsWithStringFieldValue.has(r.type)?"range"===o.type?_.renderingSanitizer.sanitize(y.getLabelForDateFieldValue(r,e)):_.renderingSanitizer.sanitize(e):e}if("date"===r.type||y.dateFieldsWithStringFieldValue.has(r.type))return this._formatDateValueForDisplay(r,i);if(this._isNumericField){const e=this.template?.format,t=e?l.convertNumberFormatToIntlOptions(e):C;return l.formatNumber(parseFloat(i),t)}return _.renderingSanitizer.sanitize(i)},this.cellValueValidatorFunction=({oldValue:e,value:i})=>{const{_effectiveRange:n,field:r}=this,{max:o,min:a}=n;if(this.effectiveRequired&&(null==i||""===i))return!1;if(this._isNumericField&&(p.validateFieldValue(r,i)||!y.valueIsInRange({max:o,min:a,value:i})))return t.getLogger(this).warn("value-exceeds-valid-range","Field value exceeds valid range. Attempted edit was rejected."),!1;if(this._isAnyDateOrTimeField){const e=r.type;if(!y.dateTimeIsInRange({type:e,range:n,value:i}))return!1}return e!==i},this.field=null,this.formatFunction=null,this.inputRenderFunction=async({root:e,column:i,rowData:n})=>{if(this.editInfo||!this.effectiveEditable)return;const r=this.getCellValue(n),{field:o}=this;if("big-integer"===o.type&&p.validateFieldValue(o,r))return void t.getLogger(this).warn("value-exceeds-valid-range","Field value is beyond supported limit. Editing is disabled for this field value.");const a=n?.item.feature;if(!a)return;this._activeFieldInput=this._setUpFieldInput(a,r);const l=document.createElement("div");l.classList.add(v.inputContainer);const s=[],u="coded-value"===this._effectiveDomain?.type;if(this._isAnyDateOrTimeField&&!u){const e=document.createElement("div"),t=this._setUpDateComponents(r),i=this._setUpDateActionBar();t.forEach((t=>e.appendChild(t))),l.appendChild(e),l.appendChild(i),s.push(...t)}else{const e=this.createInputElement({value:r});l.appendChild(e),s.push(e)}this._set("editInfo",{column:i,inputs:s,root:e,rowData:n,oldValue:r}),this.removeCellContent(e),e.appendChild(l),this._syncRowEditingState(e,!0),this.grid?.generateCellPartNames();const d=s[0];await _.setFocus(d),"selectText"in d&&await d.selectText()},this.layer=null,this.parseInputValueFunction=({inputs:e})=>{const{editInfo:t,field:i,includeTime:n}=this;if(!t||!e.length)return null;const r=e[0];if(this._isAnyDateOrTimeField){const{timeZone:o}=this.effectiveTimeZoneOptions,a=t.oldValue??void 0;if("coded-value"===this._effectiveDomain?.type)return null!=r.value?parseFloat(r.value):null;switch(i.type){case"date-only":{const e=r.value;return""!==e?e:null}case"time-only":{const e=y.normalizeTimeOnlyString(r.value);return""!==e?e:null}case"timestamp-offset":{const t=n?e[1]:void 0,i=e.at(-1);return y.getISOFieldValueFromDateComponents({oldValue:a,dateComponent:r,timeComponent:t,timeZoneComponent:i,defaultTimeZone:o})}case"date":{const{max:t,min:i}=this._effectiveRange;return y.getUnixFieldValueFromDateComponents({oldValue:a,dateComponent:r,timeComponent:e[1],timeZone:o,max:t,min:i})}}return null}const o=r.value,{effectiveRequired:a}=this;return a||null!=o&&""!==o?this._isNumericField?parseFloat(o):this._isStringField?o.trim():o:null},this.sortable=!0,this.store=null,this.template=null,this.view=null}get _effectiveDomain(){const e=this._activeFieldInput?.feature;return e?this._getDomainForFeature(e):null}get _effectiveRange(){return this._activeFieldInput?.range??{max:null,min:null}}get _isAnyDateOrTimeField(){const{field:e}=this;return d.isAnyDateField(e)||p.isTimeOnlyField(e)}get _isIntegerField(){return p.isIntegerField(this.field)}get _isNumericField(){return p.isNumericField(this.field)}get _isStringField(){return p.isStringField(this.field)}get _isSubtypeField(){const{layer:e}=this;if(e?.subtypeField){const{subtypeField:t,fieldsIndex:i}=e;return(i.get(t)?.name??t)===this.fieldName}return!1}get alias(){return this.field?.alias}get defaultValue(){return this.field?.defaultValue}get effectiveDescription(){const{description:e,field:t}=this,i=t.description,n=h.isEmptyStringOrWhitespace(e)?h.isEmptyStringOrWhitespace(i)?null:i:e;return null==n?null:_.renderingSanitizer.sanitize(n)}get effectiveEditable(){const{editable:e,field:t,layer:i,tableEditingEnabled:n}=this;if(!t||!i)return!1;const r=s.isEditableLayer(i),o=i.effectiveCapabilities??i.capabilities,a=o?.operations?.supportsUpdate;return!!(t.editable&&r&&a&&"oid"!==t.type&&n)&&e}get effectiveLabel(){return _.renderingSanitizer.sanitize(this.label||this.alias||this.fieldName)}get effectiveRequired(){return!this.nullable||this._isSubtypeField||this._activeFieldInput?.required||this.required}get effectiveTimeZoneOptions(){const{layer:e,field:t}=this;if(!e||"date"!==t?.type&&"timestamp-offset"!==t?.type)return{timeZone:void 0,timeZoneName:void 0};const{tableTimeZone:i,timeZone:n,view:r}=this;return c.getTimeZoneFormattingOptions(e.preferredTimeZone||null,!!e.datesInUnknownTimezone,n??i??r?.timeZone??c.system,a.convertDateFormatToIntlOptions("short-time"),t.type)}get includeTime(){const{field:e,template:t}=this;return"time-only"===e.type||"date-only"!==e.type&&(!t?.input||"includeTime"in t.input&&!1!==t.input.includeTime)}get loadingMessage(){return this.messages?.loading||"..."}get maxLength(){const{field:e,template:t}=this,i=e?.length??-1,n=t?.input&&"maxLength"in t.input?t.input.maxLength:null;return null!=n&&!isNaN(n)&&n>=-1&&(-1===i||n<=i)?n:i}get minLength(){const{template:e,maxLength:t}=this,i=e?.input&&"minLength"in e.input?e.input.minLength:null;return t&&i<=t?i:null}get name(){return this.field?.name}get nullable(){return!1!==this.field.nullable}get shouldShowPrompt(){return this._isSubtypeField}createInputElement({value:e}){const{_effectiveDomain:t,maxLength:i,minLength:n,effectiveRequired:r}=this;let o;if("coded-value"===t?.type)o=this.createCalciteSelect(e,t.codedValues.map((({code:e,name:t})=>({value:e,name:t})))),o.addEventListener("calciteSelectChange",(()=>this.onInputBlur(o)));else if(this._isNumericField){const{_effectiveRange:{max:t,min:i}}=this;o=document.createElement("calcite-input"),o.type="number",this._isIntegerField&&(o.step=1),null!=t&&(o.max=t),null!=i&&(o.min=i),o.status=y.valueIsInRange({max:t,min:i,value:e})?"idle":"invalid"}else o=document.createElement("calcite-input"),o.addEventListener("calciteInputChange",(()=>this.onInputBlur(o))),i>-1&&(o.maxLength=i),n>0&&(o.minLength=n);return o.classList.add(v.input),o.required=r,o.value=e,o.onkeydown=e=>{e.key===g.cancelEdit&&this.onInputBlur(o,!0)},o.onblur=()=>this.onInputBlur(o),o}onEditComplete(){const e=this.editInfo?.root;e&&this._syncRowEditingState(e,!1),this._activeFieldInput=null,super.onEditComplete()}_clearActiveEditValues(){this.editInfo?.inputs?.forEach((e=>e.value=""))}_setUpDateActionBar(){const{messagesCommon:e}=this,t=e?.cancel??"",i=e?.clear??"",n=e?.save??"",r=document.createElement("calcite-action-bar");return r.expandDisabled=!0,r.layout="horizontal",r.appendChild(this.createCalciteAction({text:n,icon:"save",onclick:()=>this.submit()})),this.effectiveRequired||r.appendChild(this.createCalciteAction({text:i,icon:"trash",onclick:()=>{this._clearActiveEditValues(),this.submit()}})),r.appendChild(this.createCalciteAction({text:t,icon:"x",onclick:()=>this.cancel()})),r}_formatDateValueForDisplay(e,t){const{timeZone:i,timeZoneName:n}=this.effectiveTimeZoneOptions;return null!=t?y.getLabelForDateFieldValue(e,t,{...this._getDateFormatOptions(),timeZone:i,timeZoneName:n}):null}_setUpDateComponents(e){const{_effectiveRange:{max:t,min:i,rawMax:n,rawMin:r},field:o,effectiveRequired:a}=this,l=this._getDateFieldValuesForComponents(o,e),s=[];if(d.isAnyDateField(o)){const e=this.createDateComponent(),u=p.isDateOnlyField(o)||p.isTimestampOffsetField(o)?n:t,d=p.isDateOnlyField(o)||p.isTimestampOffsetField(o)?r:i,c=this._getDateFieldValuesForComponents(o,u??null),m=this._getDateFieldValuesForComponents(o,d??null);e.value=l.date??"",e.max=c.date??"",e.min=m.date??"",e.required=a,e.addEventListener("calciteInputDatePickerOpen",(()=>this._onDateComponentOpen(e))),s.push(e)}if(this.includeTime){const e=this.createTimeComponent();e.value=l.time??"",e.required=a,e.addEventListener("calciteInputTimePickerOpen",(()=>this._onDateComponentOpen(e))),s.push(e)}if("timestamp-offset"===o.type){const e=this.createTimeZoneComponent();e.value=l.timeZoneOffset??"0",e.addEventListener("calciteInputTimeZoneOpen",(()=>this._onDateComponentOpen(e))),s.push(e)}return s}_onDateComponentOpen(e){this.editInfo?.inputs.forEach((t=>{t!==e&&"open"in t&&(t.open=!1)}))}_syncRowEditingState(e,t=!1){const i=this.grid?.getRowContainingNode(e);i&&(t?i.setAttribute("editing","true"):i.removeAttribute("editing"))}_getDateFieldValuesForComponents(e,t){switch(e.type){case"date":return y.prepareUnixFieldValueForDateComponents(t,this.effectiveTimeZoneOptions.timeZone);case"date-only":return{date:t};case"time-only":return{time:t};case"timestamp-offset":return y.prepareISOFieldValueForDateComponents(t);default:return{}}}_setUpFieldInput(e,t){const{field:i,layer:n,effectiveTimeZoneOptions:{timeZone:r}}=this,o=new m({feature:e,field:i,initialFeature:e.clone(),layer:n,timeZone:r});return o.set("value",t),o}_isDomainCompatible(e){if(!e)return!1;const{_isNumericField:t,_isStringField:i}=this,{type:n}=e;if("coded-value"===n){const n=typeof e.codedValues[0].code;if("string"===n&&i||"number"===n&&t)return!0}return!("range"!==n||!t)}_getDomainForFeature(e){const{fieldName:t,layer:i,template:n}=this;if(!e||!i?.getFieldDomain)return null;if("wfs"===i.type||"geojson"===i.type||"csv"===i.type||"knowledge-graph-sublayer"===i.type)return null;if(n?.domain&&this._isDomainCompatible(n.domain))return n.domain;if("feature"!==i.type&&"subtype-group"!==i.type&&null==i.getField(t)?.domain){const e=u.computeDomainFromTypes(i,t);if(e)return e}return i.getFieldDomain(t,{feature:e})}_getComputedDomain(e,t){if(!t)return null;if("range"===t.type)return e;if("coded-value"===t.type){const i=t.codedValues.filter((t=>t.hasOwnProperty("code")&&t.code===e));return i&&i.length?i[0].name:e}return null}_getDateFormatOptions(){const{template:e}=this,t=e?.format?.dateFormat;return t?a.convertDateFormatToIntlOptions(t):e?.input&&"includeTime"in e.input&&!1===e.input.includeTime?b:D}};e.__decorate([i.property()],I.prototype,"_effectiveDomain",null),e.__decorate([i.property()],I.prototype,"_activeFieldInput",void 0),e.__decorate([i.property()],I.prototype,"_effectiveRange",null),e.__decorate([i.property()],I.prototype,"_isAnyDateOrTimeField",null),e.__decorate([i.property()],I.prototype,"_isIntegerField",null),e.__decorate([i.property()],I.prototype,"_isNumericField",null),e.__decorate([i.property()],I.prototype,"_isStringField",null),e.__decorate([i.property()],I.prototype,"_isSubtypeField",null),e.__decorate([i.property({readOnly:!0})],I.prototype,"alias",null),e.__decorate([i.property()],I.prototype,"cellValueFormatFunction",void 0),e.__decorate([i.property()],I.prototype,"cellValueValidatorFunction",void 0),e.__decorate([i.property({readOnly:!0})],I.prototype,"defaultValue",null),e.__decorate([i.property()],I.prototype,"effectiveDescription",null),e.__decorate([i.property()],I.prototype,"effectiveEditable",null),e.__decorate([i.property()],I.prototype,"effectiveLabel",null),e.__decorate([i.property()],I.prototype,"effectiveRequired",null),e.__decorate([i.property()],I.prototype,"effectiveTimeZoneOptions",null),e.__decorate([i.property()],I.prototype,"field",void 0),e.__decorate([i.property()],I.prototype,"formatFunction",void 0),e.__decorate([i.property()],I.prototype,"includeTime",null),e.__decorate([i.property()],I.prototype,"inputRenderFunction",void 0),e.__decorate([i.property()],I.prototype,"layer",void 0),e.__decorate([i.property({readOnly:!0})],I.prototype,"loadingMessage",null),e.__decorate([i.property()],I.prototype,"maxLength",null),e.__decorate([i.property()],I.prototype,"minLength",null),e.__decorate([i.property({readOnly:!0})],I.prototype,"name",null),e.__decorate([i.property({readOnly:!0})],I.prototype,"nullable",null),e.__decorate([i.property()],I.prototype,"parseInputValueFunction",void 0),e.__decorate([i.property()],I.prototype,"shouldShowPrompt",null),e.__decorate([i.property()],I.prototype,"sortable",void 0),e.__decorate([i.property()],I.prototype,"store",void 0),e.__decorate([i.property()],I.prototype,"template",void 0),e.__decorate([i.property()],I.prototype,"view",void 0),I=e.__decorate([o.subclass("esri.widgets.FeatureTable.FieldColumn")],I);return I}));
