/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../core/Collection","../../../core/collectionUtils","../../../core/Evented","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/Logger","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../support/columnUtils","../support/tableUtils"],(function(e,t,o,r,i,n,l,s,p,d,a){"use strict";let u=class extends r.EventedAccessor{constructor(e){super(e),this.cellPartNameGenerator=(e,t)=>{let o="";t?.item&&this.rowHighlightIds.includes(t.item.objectId)&&(o+=" highlight");const r=this.findColumn(e?.path);return r?(r.invalid&&(o+=" invalid"),r.textWrap&&(o+=" text-wrap"),"editInfo"in r&&r.editInfo&&r.editInfo.rowData?.index===t.index&&(o+=" editing"),o):o},this.columnPerformanceModeEnabled=!0,this.columnReorderingEnabled=!0,this.columns=new t,this.dataProvider=async(e,t)=>{const{store:o}=this;if(!t)return;if(!o)return void(t&&t([]));t(await o.fetchItems(e))},this.maxSize=null,this.multipleSelectionEnabled=!0,this.multiSortEnabled=!1,this.paginationEnabled=!1,this.rowDetailsRenderer=null,this.store=null}get actionColumn(){return this.allColumns.find((e=>e.fieldName===a.uniqueColumnNames.action))}get allColumns(){return this.columns.toArray().flatMap((e=>[e,...d.isGroupColumn(e)&&e.columns?.length?e.columns:[]]))}get columnMenuIsOpen(){return this.allColumns.some((e=>e.menuIsOpen))}get editing(){return this.editableColumns.some((e=>e.editInfo))}get editableColumns(){return this.allColumns.filter((e=>"editable"in e))}get effectiveSize(){const{filterBySelectionEnabled:e,highlightIds:t,objectIds:o,pageSize:r,size:i}=this;if(this.paginationEnabled){const n=this.pageCount===this.pageIndex+1?i%r:r;return e?Math.min(t.length,n):o.length?Math.min(o.length,n):n}return e?t.length:o.length?o.length:i}get fieldColumns(){return this.allColumns.filter((e=>d.isFieldColumn(e)))}get filterBySelectionEnabled(){return!!this._get("filterBySelectionEnabled")}set filterBySelectionEnabled(e){this._set("filterBySelectionEnabled",e)}get groupColumns(){return this.columns.toArray().filter((e=>d.isGroupColumn(e)))}get hasInvalidColumnConfiguration(){return this.visibleColumns.every((e=>e.frozen||e.frozenToEnd))}get highlightIds(){return this._get("highlightIds")||new t}set highlightIds(e){const r=Array.isArray(e)?new t(e):e;this.multipleSelectionEnabled||r.splice(1,r.length-1),this._set("highlightIds",o.referenceSetter(r,this._get("highlightIds"),t))}get objectIds(){return this._get("objectIds")??new t}set objectIds(e){this._set("objectIds",o.referenceSetter(e,this._get("objectIds"),t))}get pageCount(){const{pageSize:e,size:t}=this;return 0===t||0===e?1:Math.ceil(t/e)}get pageIndex(){return this._get("pageIndex")||0}set pageIndex(e){const{pageCount:t}=this;a.isPageIndexValid(e,t)&&this._set("pageIndex",e)}get pageSize(){return this._get("pageSize")??50}set pageSize(e){this.store?.set("pageSize",e),this._set("pageSize",e)}get relationshipColumns(){return this.allColumns.filter((e=>d.isRelationshipColumn(e)))}get rowHighlightIds(){return this._get("rowHighlightIds")||new t}set rowHighlightIds(e){this._set("rowHighlightIds",o.referenceSetter(e,this._get("rowHighlightIds"),t))}get size(){const e=this.store?.count??0,{maxSize:t}=this;return null!=e&&null!=t?Math.min(t,e):e}get state(){return this.store?.state??"disabled"}get visibleColumns(){return this.columns.toArray().filter((e=>!e.hidden))}closeColumnMenus(){this.allColumns.forEach((e=>e.closeMenu()))}sortColumn(e,t){if(!e)return;const o=this.findColumn(e);o&&(o.direction=t)}hideColumn(e){const t=this.findColumn(e);!1===t?.hidden&&(t.hidden=!0)}showColumn(e){const t=this.findColumn(e);t?.hidden&&(t.hidden=!1)}showAllColumns(){this.allColumns.forEach((e=>{e.hidden&&(e.hidden=!1)}))}findColumn(e){return this.allColumns.find((t=>t.fieldName===e))}refresh(){this.store&&(this.store.reset(),this.store.load())}toggleColumnVisibility(e){const t=this.findColumn(e);t&&(t.hidden=!t.hidden)}};e.__decorate([i.property()],u.prototype,"actionColumn",null),e.__decorate([i.property()],u.prototype,"allColumns",null),e.__decorate([i.property()],u.prototype,"cellPartNameGenerator",void 0),e.__decorate([i.property()],u.prototype,"columnMenuIsOpen",null),e.__decorate([i.property()],u.prototype,"columnPerformanceModeEnabled",void 0),e.__decorate([i.property()],u.prototype,"columnReorderingEnabled",void 0),e.__decorate([i.property()],u.prototype,"columns",void 0),e.__decorate([i.property()],u.prototype,"dataProvider",void 0),e.__decorate([i.property()],u.prototype,"editing",null),e.__decorate([i.property()],u.prototype,"editableColumns",null),e.__decorate([i.property()],u.prototype,"effectiveSize",null),e.__decorate([i.property()],u.prototype,"fieldColumns",null),e.__decorate([i.property()],u.prototype,"filterBySelectionEnabled",null),e.__decorate([i.property()],u.prototype,"groupColumns",null),e.__decorate([i.property()],u.prototype,"hasInvalidColumnConfiguration",null),e.__decorate([i.property()],u.prototype,"highlightIds",null),e.__decorate([i.property()],u.prototype,"maxSize",void 0),e.__decorate([i.property()],u.prototype,"multipleSelectionEnabled",void 0),e.__decorate([i.property()],u.prototype,"multiSortEnabled",void 0),e.__decorate([i.property()],u.prototype,"objectIds",null),e.__decorate([i.property()],u.prototype,"pageCount",null),e.__decorate([i.property()],u.prototype,"pageIndex",null),e.__decorate([i.property()],u.prototype,"pageSize",null),e.__decorate([i.property()],u.prototype,"paginationEnabled",void 0),e.__decorate([i.property()],u.prototype,"relationshipColumns",null),e.__decorate([i.property()],u.prototype,"rowHighlightIds",null),e.__decorate([i.property()],u.prototype,"rowDetailsRenderer",void 0),e.__decorate([i.property({readOnly:!0})],u.prototype,"size",null),e.__decorate([i.property()],u.prototype,"store",void 0),e.__decorate([i.property({readOnly:!0})],u.prototype,"state",null),e.__decorate([i.property()],u.prototype,"visibleColumns",null),u=e.__decorate([p.subclass("esri.widgets.FeatureTable.Grid.GridViewModel")],u);return u}));
