/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../Graphic","../../../core/Accessor","../../../core/arrayUtils","../../../core/Collection","../../../core/Error","../../../core/lang","../../../core/Logger","../../../core/ReactiveMap","../../../core/reactiveUtils","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/accessorSupport/decorators/subclass","../../../layers/support/layerUtils","../../../rest/support/AttachmentQuery","../../../rest/support/RelationshipQuery","./tableUtils"],(function(e,t,r,s,o,a,i,n,p,u,l,d,c,h,y,_,m){"use strict";let g=class extends r{constructor(e){super(e),this._attachmentsOperationQueue=new o,this._defaultOutFields=["*"],this._editOperationQueue=new o,this._loaded=!1,this._loadError=!1,this._loading=!1,this._objectIdCache=new o,this._queryOperationQueue=new o,this.attachmentsEnabled=!1,this.count=0,this.failures=new o,this.filterGeometry=null,this.initialSize=null,this.layer=null,this.objectIds=null,this.outFields=null,this.pageCache=new p,this.pageSize=50,this.relationshipConfig=null,this.relatedRecordsEnabled=!1,this.returnGeometry=!1,this.returnZ=!1,this.returnM=!1,this.sortOrders=[],this.timeExtent=null,this.view=null,this.where=null}initialize(){this.addHandles([u.watch((()=>[this.filterGeometry,this.layer,this.objectIds,this.outFields,this.pageSize,this.relationshipConfig,this.returnGeometry,this.returnM,this.returnZ,this.timeExtent,this.where]),(()=>this._reset())),u.watch((()=>this.orderByFields),(()=>this._clearCaches()),{equals:s.equals}),u.when((()=>this.attachmentsEnabled),(()=>this._reset())),u.when((()=>this.relatedRecordsEnabled),(()=>this._reset()))])}destroy(){this.layer=null,this.itemCache?.destroy(),this.failures?.destroy()}get _capabilities(){const{layer:e}=this;return e?.effectiveCapabilities??e?.capabilities}get _effectiveReturnZ(){return this.returnZ&&this.supportsZ}get _effectiveReturnM(){return this.returnM&&this.supportsM}get _layerWithAttachments(){const{layer:e}=this;return e&&this._capabilities&&this.attachmentsEnabled&&this.supportsAttachments&&m.isIFeatureTableSupportedLayerWithAttachments(e)?e:null}get _layerWithAttachmentsEditing(){const{_layerWithAttachments:e}=this;return e&&m.isIFeatureTableSupportedLayerWithAttachmentsEditing(e)&&this.supportsEditing?e:null}get _layerWithEditing(){const e=this.layer;return m.isIFeatureTableSupportedLayerWithEditing(e)&&this.supportsEditing?e:null}get _layerWithRelationships(){const e=this.layer;return m.isIFeatureTableSupportedLayerWithRelationships(e)&&this.supportsQueryRelated?e:null}get _relatedLayer(){return this.relationshipConfig?.relatedLayer}get _relatedLayerCapabilities(){const{_relatedLayer:e}=this;return e?.effectiveCapabilities??e?.capabilities}get _relatedLayerSupportsCacheHint(){return!!this._relatedLayerCapabilities?.queryRelated?.supportsCacheHint}get _relatedLayerSupportsQuery(){return!!this._relatedLayerCapabilities?.operations.supportsQuery}get _relatedLayerSupportsQueryRelated(){const{_relatedLayerCapabilities:e}=this;return!!e?.queryRelated?.supportsCount&&!!e?.queryRelated?.supportsPagination}get _sortedFieldNames(){return this.sortOrders.map((({fieldName:e})=>e))}get _canUseRelatedLayer(){return!(!this._relatedLayerSupportsQuery||!this._relatedLayerSupportsQueryRelated)}get canAddRelatedFeature(){const{state:e,relationship:t,supportsAdd:r,supportsEditing:s}=this;if("loaded"!==e||!t||!r||!s)return!1;const{count:o}=this,{cardinality:a,role:i}=t,n=o>0;return("one-to-one"!==a||!n)&&("one-to-many"!==a||"origin"!==i||!n)}get effectiveOutFields(){const{layer:e,outFields:t}=this;if(!e||!t?.length)return this._defaultOutFields;const r=[];t.forEach((t=>{const s=e.fieldsIndex.normalizeFieldName(t);s&&r.push(s)}));const{objectIdField:s}=e,o=e.fieldsIndex.normalizeFieldName(s)??s;return o&&!r.includes(o)&&r.unshift(o),r}get effectiveTimeExtent(){const{layer:e,timeExtent:t}=this;return t||e&&"timeExtent"in e&&e.timeExtent||null}get effectiveWhere(){return this.where||this.layer?.definitionExpression||"1=1"}get itemCache(){return new o({items:[...this.pageCache.values()].flat()})}get layerView(){const{layer:e,view:t}=this;if(!e||!t)return null;const r="sublayer"===e.type?e.parent:e;return t.allLayerViews.find((e=>e.layer===r))}get orderByFields(){const{_sortedFieldNames:e,layer:t,sortOrders:r}=this,s=r.filter((({fieldName:t,direction:r},s)=>e.indexOf(t)===s&&null!=r)).map((({fieldName:e,direction:t})=>`${e} ${t?.toUpperCase()}`));if(t&&!s.length&&!t.objectIdField&&t.fields?.length){const e=t.fields.find((e=>e.name));if(e){const r=t.fieldsIndex.normalizeFieldName(e.name);r&&s.push(`${r} ASC`)}}return s}get querying(){return this._queryOperationQueue.length>0}get relationship(){const{relationshipConfig:e}=this;return null==e?.relationshipId?null:this.relationships?.find((t=>t.id===e.relationshipId))}get relationshipIds(){return this.relationships?.map((e=>e.id))??[]}get relationshipInfos(){const{_layerWithRelationships:e,relatedRecordsEnabled:t,relationships:r,view:s}=this,o=[];return t&&e?.loaded&&s?.map&&r?.length?(r.forEach((t=>{const r=m.findRelatedLayer(e,s,t);r&&(r.load(),o.push({layer:e,relatedLayer:r,relationshipId:t.id}))})),o):o}get relationships(){return this._layerWithRelationships?.relationships}get state(){const{layer:e,_loaded:t,_loadError:r,_loading:s}=this;return!e||e.destroyed?"disabled":r||e.loadError?"error":"loaded"===e.loadStatus&&t?"loaded":s?"loading":"ready"}get supportsAdd(){return!!this._capabilities?.operations.supportsAdd}get supportsAddingAttachments(){return!(!this._layerWithAttachmentsEditing||!this.supportsAdd)}get supportsAttachments(){const{_capabilities:e}=this;return!(!e?.data?.supportsAttachment||!e?.operations.supportsQueryAttachments)}get supportsCacheHint(){return!!this._capabilities?.query?.supportsCacheHint}get supportsCacheHintQueryRelated(){return!!this._capabilities?.queryRelated?.supportsCacheHint}get supportsDelete(){return!!this._capabilities?.operations.supportsDelete}get supportsDeletingAttachments(){return!(!this._layerWithAttachmentsEditing||!this.supportsDelete)}get supportsEditing(){return!!this._capabilities?.operations.supportsEditing}get supportsM(){return!!this.layer?.hasM&&!!this._capabilities?.data?.supportsM}get supportsOrderBy(){return!!this._capabilities?.query?.supportsOrderBy}get supportsPagination(){return!!this._capabilities?.query?.supportsPagination}get supportsQuery(){return!!this._capabilities?.operations.supportsQuery}get supportsQueryRelated(){const{_capabilities:e}=this;return!!e?.queryRelated?.supportsCount&&!!e?.queryRelated?.supportsPagination}get supportsResizeAttachments(){const{_capabilities:e}=this;return!(!this.supportsAttachments||!e?.operations?.supportsResizeAttachments)}get supportsUpdate(){return!!this._capabilities?.operations.supportsUpdate}get supportsUpdateAttachments(){return!(!this._layerWithAttachmentsEditing||!this.supportsUpdate)}get supportsZ(){return!!this.layer?.hasZ&&!!this._capabilities?.data?.supportsZ}get syncing(){return this.syncingFeatureEdits||this.syncingAttachmentEdits}get syncingAttachmentEdits(){return this._attachmentsOperationQueue.length>0}get syncingFeatureEdits(){return this._editOperationQueue.length>0}async addAttachment(e,t){const{_layerWithAttachmentsEditing:r}=this;if(!r||!this.supportsAddingAttachments)return{};const s=await this._queueAttachmentsOperation(e,(()=>r.addAttachment(this._createBaseGraphic(r,e),t)));return this._ensureArrayContent(s)}async deleteAttachments(e,t){const{_layerWithAttachmentsEditing:r}=this;if(!r||!this.supportsDeletingAttachments||!t.length)return[];const s=await this._queueAttachmentsOperation(e,(()=>r.deleteAttachments(this._createBaseGraphic(r,e),t)));return this._ensureArray(s)}async deleteRowsByObjectId(e){const{_layerWithEditing:t}=this;if(!this.supportsDelete||!t)throw new a("store:delete-error","Delete is not supported.");const r=e.map((e=>this.getItemByObjectId(e)?.feature)).filter(s.isSome);return this._queueEditOperation((()=>t.applyEdits({deleteFeatures:r})))}async fetchItems(e){const{page:t}=e,{pageSize:r}=this,s=t*r,o=s+r,{layer:a,state:i}=this;return a&&"loaded"===i?this._query({layer:a,start:s,num:o,page:t,pageSize:r}):[]}async getAttachmentsByObjectId(e,t){const r=this.getItemByObjectId(e)?.attachments??[];if(!r.length&&t){return(await this._queryAttachments([e]))[e]??[]}return r}getItemByObjectId(e){for(const t of this.pageCache.values())for(const r of t)if(r.objectId===e)return r}getItemIndexByObjectId(e){const{pageCache:t,pageSize:r}=this,s=t.entries();let o=-1;for(const[a,i]of s)if(i.some(((t,s)=>{const i=t.objectId===e;return i&&(o=a*r+s),i})),o>-1)break;return o}async load(){const{layer:e}=this;if(!this._loading&&!this._loaded&&e){this._reset(),this._loading=!0;try{await e.load(),e.parent&&h.isSubtypeGroupLayer(e.parent)&&await e.parent.loadAll(),await e.when();const t=this.initialSize;this.initialSize=null,await this.refresh(t),this._loaded=!0,this._loading=!1}catch(t){throw this._reset(),this._loadError=!0,this._logError("store:load-error","An error occurred."),t}}}async query(e){const{state:t}=this;return this.supportsQuery&&"loaded"===t?this._query(e):[]}async refresh(e){this._clearCaches(),await this._syncCount(e),await this._syncObjectIdCache()}async reset(){this._reset()}async updateAttachment(e,t,r){const{_layerWithAttachmentsEditing:s}=this;if(!s||!this.supportsUpdateAttachments)return{};const o=await this._queueAttachmentsOperation(e,(()=>s.updateAttachment(this._createBaseGraphic(s,e),t,r)));return this._ensureArrayContent(o)}async updateItem(e){const{_sortedFieldNames:t}=this,r=e.updates.map((({fieldName:e})=>e)),s=await this._update(e);return!s.updateFeatureResults.find((e=>e.error))&&r.some((e=>t.includes(e)))&&this._clearCaches(),s}async verifyFeaturesByObjectId(e){const{layer:t,state:r}=this;if(!t||"loaded"!==r)return[];const{objectIdField:s}=t,o=await this._verifyFeaturesByObjectId(e);return e.map((e=>o.some((t=>{const r=t.getObjectId()??t.attributes[s];return e===r}))))}_clearCaches(){this.pageCache.clear(),this._objectIdCache.removeAll()}_createBaseGraphic(e,r){return new t({attributes:{[e.objectIdField]:r}})}_ensureArray(e){return Array.isArray(e)?e:[e]}_ensureArrayContent(e){return Array.isArray(e)?e[0]:e}_getObjectIdsForPage(e,t){const r=this._objectIdCache.toArray();return r.length>=e+t?r.slice(e,e+t):r.slice(e)}_logError(e,t){n.getLogger(this).error(e,t)}_reset(){this._clearCaches(),this.failures.removeAll(),this._attachmentsOperationQueue.removeAll(),this._editOperationQueue.removeAll(),this._queryOperationQueue.removeAll(),this._loading=!1,this._loaded=!1,this._loadError=!1,this._set("count",0)}async _syncCount(e){null==e?await this._queryCount().then((e=>this._set("count",e))):this._set("count",e)}async _syncObjectIdCache(){if(this.supportsPagination)return;const e=await this._queryObjectIds();this._objectIdCache.removeAll(),this._objectIdCache.addMany(e)}async _verifyFeaturesByObjectId(e){const{layer:t}=this;if(!t||!this.supportsQuery)throw new a("store:query-error","Layer does not support query operation.");const{effectiveTimeExtent:r,effectiveWhere:s,orderByFields:o,supportsCacheHint:i,supportsOrderBy:n}=this,p=t.createQuery();p.where=s,p.timeExtent=r,p.returnGeometry=!1,p.objectIds=e.length?e:void 0,p.outFields=[t.objectIdField],n&&(p.orderByFields=o),i&&(p.cacheHint=!0);return(await t.queryFeatures(p)).features}async _update(e){const{objectId:r,updates:s}=e,{_layerWithEditing:o}=this;if(!this.supportsUpdate||!o)throw new a("store:update-error","Update is not supported.");const n=this.getItemByObjectId(r)?.feature;if(!n)throw new a("store:update-error","Feature with provided 'objectId' not found.");const p=i.clone(n.attributes);s.forEach((({fieldName:e,value:t})=>p[e]=t));const u=new t({attributes:p}),l=o.applyEdits({updateFeatures:[u]}).then((e=>{const{updateFeatureResults:t}=e,r=t.find((e=>!!e.error));if(r)throw r.error;return t.length&&(n.attributes=p),e}));return this._queueEditOperation((()=>l))}_prepareFeatureData(e){const{attachments:t,features:r,layer:s,relatedRecords:o}=e,a=s.objectIdField;return r.map((e=>{const r=e.getObjectId()??e.attributes[a],i=[];return e.layer||e.sourceLayer||(e.layer=s,e.sourceLayer=s),o.forEach(((e,t)=>{i.push({relationshipId:t,count:e[r]??0})})),{objectId:r,feature:e,attachments:t[r]??null,relatedRecords:i}}))}async _query(e){const{page:t,refresh:r}=e;!0===r&&await this.refresh();const s=this.pageCache.get(t);if(s)return s;const o=await this._queryPage(e);return this.pageCache.set(t,o),o}_queryAttachments(e){const{_layerWithAttachments:t,effectiveWhere:r}=this;return t?e.some((e=>"number"!=typeof e))?Promise.reject(new a("invalid-object-id","Only numeric object ids are valid to query attachments")):t.queryAttachments(new y({objectIds:e,where:r,returnMetadata:!0})):Promise.resolve({})}async _queryCount(){const{_relatedLayerSupportsCacheHint:e,layer:t,relationshipConfig:r,supportsCacheHint:s}=this;if(!t)return 0;if(r&&this._canUseRelatedLayer){const{objectId:t,relatedLayer:s,relationshipId:o}=r;return(await s.queryRelatedFeaturesCount(new _({cacheHint:e,relationshipId:o,objectIds:[t]})))[t]??0}const{effectiveTimeExtent:o,effectiveWhere:a,filterGeometry:i,objectIds:n}=this,p=t.createQuery();return p.geometry=i,p.returnGeometry=!1,p.where=a,p.timeExtent=o,p.objectIds=n?.length?n:void 0,s&&(p.cacheHint=!0),t.queryFeatureCount(p)}async _queryFeatures(e){const{relationshipConfig:t}=this;if(t&&this._canUseRelatedLayer)return this._queryRelatedFeatures(e,t);const{_effectiveReturnM:r,_effectiveReturnZ:s,effectiveOutFields:o,effectiveTimeExtent:a,effectiveWhere:i,filterGeometry:n,objectIds:p,orderByFields:u,pageSize:l,returnGeometry:d,supportsCacheHint:c,supportsOrderBy:h,supportsPagination:y}=this,{layer:_,start:m}=e,g=p?.length,f=_.createQuery();f.returnGeometry=d,f.outFields=o,f.returnM=r,f.returnZ=s,y?(f.start=m,f.num=l,f.where=i,f.timeExtent=a,f.objectIds=g?p:void 0):f.objectIds=g?p:this._getObjectIdsForPage(m,l??0),h&&(f.orderByFields=u),n&&(f.geometry=n),c&&(f.cacheHint=!0);return(await _.queryFeatures(f)).features}_queryObjectIds(){const{effectiveTimeExtent:e,effectiveWhere:t,filterGeometry:r,layer:s,objectIds:o,orderByFields:a,supportsCacheHint:i,supportsOrderBy:n}=this;if(!s)return Promise.resolve([]);const p=s.createQuery();return p.geometry=r,p.outFields=[s.objectIdField],p.returnGeometry=!1,p.where=t,p.timeExtent=e,p.objectIds=o?.length?o:void 0,n&&(p.orderByFields=a),i&&(p.cacheHint=!0),s.queryObjectIds(p)}async _queryPage(e){const{layer:t}=e;return this._queueQueryOperation((async()=>{const r=await this._queryFeatures(e),s=r.map((e=>e.getObjectId()??e.attributes[t.objectIdField])),o=await this._queryAttachments(s),a=await this._queryRelatedCounts(s);return this._prepareFeatureData({layer:t,features:r,attachments:o,relatedRecords:a})||[]}))}async _queryRelatedCounts(e){const{_layerWithRelationships:t,relationshipIds:r,supportsCacheHintQueryRelated:s}=this,o=new Map;return t&&e?.length&&r.length?(await Promise.allSettled(r.map((async r=>{const a=await t.queryRelatedFeaturesCount(new _({cacheHint:s,relationshipId:r,objectIds:e}));o.set(r,a)}))),o):o}async _queryRelatedFeatures(e,t){const{_defaultOutFields:r,_effectiveReturnM:s,_effectiveReturnZ:o,orderByFields:a,pageSize:i,returnGeometry:n,supportsCacheHint:p}=this,{layer:u,start:l}=e,{objectId:d,relatedLayer:c,relationshipId:h}=t,y=u.createQuery(),m=new _({cacheHint:p,num:i,objectIds:[d],orderByFields:a,outFields:r,relationshipId:h,returnGeometry:n,returnM:s,returnZ:o,start:l,where:y.where??void 0}),g=await c.queryRelatedFeatures(m);return g[d]?.features||[]}_queueAttachmentsOperation(e,t){return this._attachmentsOperationQueue.push(t),t().then((async r=>{this._attachmentsOperationQueue.remove(t);const s=this._ensureArray(r),o=s.some((e=>e.error)),a=this.getItemByObjectId(e);if(a&&(!o||s.length>1)){const t=await this._queryAttachments([e]);a.attachments=t[e]}return r})).catch((async r=>{this._logError("store:attachment-error","An error occurred.");const s={error:r,retry:()=>{this.failures.remove(s),this._queueAttachmentsOperation(e,t)},cancel:()=>this.failures.remove(s)};throw this.failures.add(s),this._attachmentsOperationQueue.remove(t),r}))}_queueEditOperation(e){return this._editOperationQueue.push(e),e().then((t=>(this._editOperationQueue.remove(e),t))).catch((t=>{this._logError("store:edit-error","An error occurred.");const r={error:t,retry:()=>{this.failures.remove(r),this._queueEditOperation(e)},cancel:()=>this.failures.remove(r)};throw this.failures.add(r),this._editOperationQueue.remove(e),t}))}_queueQueryOperation(e){return this._queryOperationQueue.push(e),e().then((t=>this._queryOperationQueue.includes(e)?t:[])).catch((t=>{this._logError("store:query-error","An error occurred.");const r={error:t,retry:()=>{this.failures.remove(r),this._queueQueryOperation(e)},cancel:()=>this.failures.remove(r)};return this.failures.add(r),[]})).then((t=>(this._queryOperationQueue.remove(e),t)))}};e.__decorate([l.property()],g.prototype,"_attachmentsOperationQueue",void 0),e.__decorate([l.property({readOnly:!0})],g.prototype,"_capabilities",null),e.__decorate([l.property()],g.prototype,"_defaultOutFields",void 0),e.__decorate([l.property()],g.prototype,"_editOperationQueue",void 0),e.__decorate([l.property()],g.prototype,"_effectiveReturnZ",null),e.__decorate([l.property()],g.prototype,"_effectiveReturnM",null),e.__decorate([l.property({readOnly:!0})],g.prototype,"_layerWithAttachments",null),e.__decorate([l.property({readOnly:!0})],g.prototype,"_layerWithAttachmentsEditing",null),e.__decorate([l.property({readOnly:!0})],g.prototype,"_layerWithEditing",null),e.__decorate([l.property({readOnly:!0})],g.prototype,"_layerWithRelationships",null),e.__decorate([l.property()],g.prototype,"_loaded",void 0),e.__decorate([l.property()],g.prototype,"_loadError",void 0),e.__decorate([l.property()],g.prototype,"_loading",void 0),e.__decorate([l.property()],g.prototype,"_objectIdCache",void 0),e.__decorate([l.property()],g.prototype,"_queryOperationQueue",void 0),e.__decorate([l.property({readOnly:!0})],g.prototype,"_relatedLayer",null),e.__decorate([l.property({readOnly:!0})],g.prototype,"_relatedLayerCapabilities",null),e.__decorate([l.property({readOnly:!0})],g.prototype,"_relatedLayerSupportsCacheHint",null),e.__decorate([l.property()],g.prototype,"_relatedLayerSupportsQuery",null),e.__decorate([l.property()],g.prototype,"_relatedLayerSupportsQueryRelated",null),e.__decorate([l.property()],g.prototype,"_sortedFieldNames",null),e.__decorate([l.property()],g.prototype,"_canUseRelatedLayer",null),e.__decorate([l.property()],g.prototype,"attachmentsEnabled",void 0),e.__decorate([l.property()],g.prototype,"canAddRelatedFeature",null),e.__decorate([l.property({readOnly:!0})],g.prototype,"count",void 0),e.__decorate([l.property()],g.prototype,"effectiveOutFields",null),e.__decorate([l.property()],g.prototype,"effectiveTimeExtent",null),e.__decorate([l.property()],g.prototype,"effectiveWhere",null),e.__decorate([l.property({readOnly:!0})],g.prototype,"failures",void 0),e.__decorate([l.property()],g.prototype,"filterGeometry",void 0),e.__decorate([l.property()],g.prototype,"initialSize",void 0),e.__decorate([l.property({readOnly:!0})],g.prototype,"itemCache",null),e.__decorate([l.property()],g.prototype,"layer",void 0),e.__decorate([l.property()],g.prototype,"layerView",null),e.__decorate([l.property()],g.prototype,"objectIds",void 0),e.__decorate([l.property()],g.prototype,"orderByFields",null),e.__decorate([l.property()],g.prototype,"outFields",void 0),e.__decorate([l.property({readOnly:!0})],g.prototype,"pageCache",void 0),e.__decorate([l.property()],g.prototype,"pageSize",void 0),e.__decorate([l.property({readOnly:!0})],g.prototype,"querying",null),e.__decorate([l.property()],g.prototype,"relationship",null),e.__decorate([l.property()],g.prototype,"relationshipConfig",void 0),e.__decorate([l.property()],g.prototype,"relationshipIds",null),e.__decorate([l.property()],g.prototype,"relationshipInfos",null),e.__decorate([l.property()],g.prototype,"relationships",null),e.__decorate([l.property()],g.prototype,"relatedRecordsEnabled",void 0),e.__decorate([l.property()],g.prototype,"returnGeometry",void 0),e.__decorate([l.property()],g.prototype,"returnZ",void 0),e.__decorate([l.property()],g.prototype,"returnM",void 0),e.__decorate([l.property()],g.prototype,"sortOrders",void 0),e.__decorate([l.property({readOnly:!0})],g.prototype,"state",null),e.__decorate([l.property()],g.prototype,"supportsAdd",null),e.__decorate([l.property()],g.prototype,"supportsAddingAttachments",null),e.__decorate([l.property()],g.prototype,"supportsAttachments",null),e.__decorate([l.property()],g.prototype,"supportsCacheHint",null),e.__decorate([l.property()],g.prototype,"supportsCacheHintQueryRelated",null),e.__decorate([l.property()],g.prototype,"supportsDelete",null),e.__decorate([l.property()],g.prototype,"supportsDeletingAttachments",null),e.__decorate([l.property()],g.prototype,"supportsEditing",null),e.__decorate([l.property()],g.prototype,"supportsM",null),e.__decorate([l.property()],g.prototype,"supportsOrderBy",null),e.__decorate([l.property()],g.prototype,"supportsPagination",null),e.__decorate([l.property()],g.prototype,"supportsQuery",null),e.__decorate([l.property()],g.prototype,"supportsQueryRelated",null),e.__decorate([l.property()],g.prototype,"supportsResizeAttachments",null),e.__decorate([l.property()],g.prototype,"supportsUpdate",null),e.__decorate([l.property()],g.prototype,"supportsUpdateAttachments",null),e.__decorate([l.property()],g.prototype,"supportsZ",null),e.__decorate([l.property({readOnly:!0})],g.prototype,"syncing",null),e.__decorate([l.property({readOnly:!0})],g.prototype,"syncingAttachmentEdits",null),e.__decorate([l.property({readOnly:!0})],g.prototype,"syncingFeatureEdits",null),e.__decorate([l.property()],g.prototype,"timeExtent",void 0),e.__decorate([l.property()],g.prototype,"view",void 0),e.__decorate([l.property()],g.prototype,"where",void 0),g=e.__decorate([c.subclass("esri.widgets.FeatureTable.support.FeatureStore")],g);return g}));
