/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../core/reactiveUtils","../core/accessorSupport/decorators/property","../core/has","../core/Logger","../core/RandomLCG","../core/accessorSupport/decorators/subclass","../layers/support/layerUtils","./Widget","./FeatureTemplates/featureTemplatesUtils","./FeatureTemplates/FeatureTemplatesViewModel","./FeatureTemplates/ItemList","./FeatureTemplates/TemplateItem","./FeatureTemplates/VisibleElements","../chunks/componentsUtils","./support/globalCss","./support/widgetUtils","./support/decorators/messageBundle","./support/decorators/vmEvent","./support/jsxFactory"],(function(e,t,r,o,s,i,n,l,a,d,c,p,u,m,h,y,v,_,b,I,f){"use strict";const g={base:"esri-feature-templates"};function C(e){return e.length>0&&c.isTemplateItemGroup(e[0])}function w(e){return e.id}let T=class extends d{constructor(e,t){super(e,t),this.enableListScroll=!0,this.filterText="",this.headingLevel=4,this.messages=null,this.messagesCommon=null,this.selectionMode="none",this.viewModel=new p,this.visibleElements=new h,this.renderCustomItem=e=>null,this.renderCustomGroupContent=e=>null,this.renderItemLabel=()=>null,this.renderItemDescription=()=>null,this.renderItemContent=e=>null,this.renderItemContentEnd=e=>null,this._iconIntersectionObserver=new IntersectionObserver(((e,t)=>{e.forEach((async e=>{if(e.isIntersecting){const r=e.target;if(F(r))return void t.unobserve(r);const o=M(r),{layer:s,template:i}=o;L(r,!0);const n=await m.fetchThumbnail(s,i).catch((()=>(L(r,!1),null)));if(null==n)return;r.appendChild(n)}}))})),this._renderItemIcon=e=>a.isTable(e.layer)?f.tsx("span",{"data-has-icon":!0,"data-item":e,key:"icon"},f.tsx("calcite-icon",{icon:"table"})):f.tsx("span",{afterCreate:this._afterItemCreateOrUpdate,afterRemoved:this._afterItemRemoved,afterUpdate:this._afterItemCreateOrUpdate,"data-has-icon":!1,"data-item":e,key:"icon"}),this._afterItemCreateOrUpdate=e=>{this._iconIntersectionObserver?.observe(e)},this._afterItemRemoved=e=>{this._iconIntersectionObserver?.unobserve(e)}}initialize(){const e=({label:e})=>!this.filterText||!!e?.toLowerCase().includes(this.filterText.toLowerCase());this.addHandles(r.watch((()=>this.viewModel),((t,r)=>{t&&!t.filterFunction&&(this.filterFunction=e),r&&r!==t&&r.filterFunction===e&&(r.filterFunction=null)}),r.initial))}destroy(){this._iconIntersectionObserver?.disconnect(),this._iconIntersectionObserver=null}loadDependencies(){return y.loadCalciteComponents({icon:()=>new Promise(((t,r)=>e(["../chunks/calcite-icon"],t,r))),loader:()=>new Promise(((t,r)=>e(["../chunks/calcite-loader"],t,r))),input:()=>new Promise(((t,r)=>e(["../chunks/calcite-input"],t,r))),list:()=>new Promise(((t,r)=>e(["../chunks/calcite-list"],t,r))),"list-item":()=>new Promise(((t,r)=>e(["../chunks/calcite-list-item"],t,r))),notice:()=>new Promise(((t,r)=>e(["../chunks/calcite-notice"],t,r)))})}get disabled(){return this.viewModel.disabled}set disabled(e){this.viewModel.disabled=e}get filterFunction(){return this.viewModel.filterFunction}set filterFunction(e){this.viewModel.filterFunction=e}get groupBy(){return this.viewModel.groupBy}set groupBy(e){this.viewModel.groupBy=e}get icon(){return"list-rectangle"}set icon(e){this._overrideIfSome("icon",e)}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}get layers(){return this.viewModel.layers}set layers(e){this.viewModel.layers=e}get selectedItem(){return this.viewModel.selectedItem}select(e,t){return this.viewModel.select(e,t)}render(){const{disabled:e,enableListScroll:t,filterText:r,headingLevel:o,messages:s,viewModel:{items:i,numberOfFeatureTemplates:n,selectedItem:l,state:a}}=this,d=this.visibleElements.filter&&n>1;if(C(i)){const e=i.find((e=>e.label===p.nullGroupBy.label));e&&(e.label=s.other)}return f.tsx("div",{"aria-label":s.widgetLabel,class:this.classes(g.base,v.globalCss.widget)},"loading"===a?f.tsx("calcite-loader",{key:"loader",label:this.messagesCommon.loading,type:"indeterminate"}):"ready"===a?f.tsx(u.ItemList,{disabled:e,enableListScroll:t,filterEnabled:d,filterText:r,headingLevel:o,id:this.id,identify:w,items:i,messages:{filterPlaceholder:s.filterPlaceholder,noItems:s.noItems,noMatches:s.noMatches},renderCustomGroupContent:this.renderCustomGroupContent,renderCustomItem:this.renderCustomItem,renderIcon:this._renderItemIcon,renderItemContent:this.renderItemContent,renderItemContentEnd:this.renderItemContentEnd,renderItemDescription:this.renderItemDescription,renderItemLabel:this.renderItemLabel,selectedItem:l??void 0,selectionMode:this.selectionMode??void 0,onFilterChange:e=>{this.filterText=e},onItemSelect:e=>!c.isTemplateItemGroup(e)&&this.viewModel.select(e)}):null)}};function M(e){return e?.["data-item"]}function F(e){return!!e?.["data-has-icon"]}function L(e,t){e&&(e["data-has-icon"]=t)}t.__decorate([o.property()],T.prototype,"disabled",null),t.__decorate([o.property()],T.prototype,"enableListScroll",void 0),t.__decorate([o.property()],T.prototype,"filterFunction",null),t.__decorate([o.property()],T.prototype,"filterText",void 0),t.__decorate([o.property()],T.prototype,"groupBy",null),t.__decorate([o.property()],T.prototype,"headingLevel",void 0),t.__decorate([o.property()],T.prototype,"icon",null),t.__decorate([o.property()],T.prototype,"label",null),t.__decorate([o.property()],T.prototype,"layers",null),t.__decorate([o.property(),b.messageBundle("esri/widgets/FeatureTemplates/t9n/FeatureTemplates")],T.prototype,"messages",void 0),t.__decorate([o.property(),b.messageBundle("esri/t9n/common")],T.prototype,"messagesCommon",void 0),t.__decorate([o.property({readOnly:!0})],T.prototype,"selectedItem",null),t.__decorate([o.property()],T.prototype,"selectionMode",void 0),t.__decorate([o.property(),I.vmEvent("select")],T.prototype,"viewModel",void 0),t.__decorate([o.property({type:h,nonNullable:!0})],T.prototype,"visibleElements",void 0),t.__decorate([o.property()],T.prototype,"renderCustomItem",void 0),t.__decorate([o.property()],T.prototype,"renderCustomGroupContent",void 0),t.__decorate([o.property()],T.prototype,"renderItemLabel",void 0),t.__decorate([o.property()],T.prototype,"renderItemDescription",void 0),t.__decorate([o.property()],T.prototype,"renderItemContent",void 0),t.__decorate([o.property()],T.prototype,"renderItemContentEnd",void 0),T=t.__decorate([l.subclass("esri.widgets.FeatureTemplates")],T);return T}));
