/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../core/asyncUtils","../../core/Evented","../../core/maybe","../../core/promiseUtils","../../core/reactiveUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/Logger","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../../core/support/UpdatingHandles","../../layers/support/layerUtils","./featureTemplatesUtils","./TemplateItem","./TemplateItemGroup","../support/templateUtils"],(function(e,t,s,r,o,l,a,i,n,p,u,y,c,d,m,h,_){"use strict";var f;const g=({layer:e})=>({key:e,label:e.title??""}),I=({layer:e})=>({key:e.geometryType,label:e.geometryType??""});let b=f=class extends s.EventedAccessor{constructor(e){super(e),this._allItems=[],this._updatingHandles=new y.UpdatingHandles,this._updateAllItemsTask=null,this.disabled=!1,this.disabledItemFunction=null,this.filterFunction=null,this.selectedItem=null}initialize(){this._get("groupBy")||(this.groupBy="layer"),this.addHandles([l.watch((()=>[this._featureTemplatesByLayer,this._groupByFunction]),(()=>{this._updateAllItemsTask=r.abortMaybe(this._updateAllItemsTask);const e=t.createTask((e=>this._updateAllItems(e)));this._updateAllItemsTask=e,this._updatingHandles.addPromise(e.promise)}),l.syncAndInitial),l.watch((()=>this.filterFunction),(e=>{for(const t of this._allItems)d.isTemplateItemGroup(t)&&(t.filterFunction=e)}),l.sync)])}get _featureTemplatesByLayer(){const e=new Map;if(!this.layers)return e;for(const t of this.layers)if("subtype-group"===t.type)for(const s of t.sublayers)e.set(s,_.getAllTemplatesForLayer(s));else e.set(t,_.getAllTemplatesForLayer(t));return e}set groupBy(e){if(this._set("groupBy",e),"function"!=typeof e)switch(e){case"layer":this._groupByFunction=g;break;case"geometry":this._groupByFunction=I;break;default:this._groupByFunction=null}else this._groupByFunction=t=>this._ensureGroupByObject(e(t))}get layers(){return this._get("layers")}set layers(e){const t="layers";if(this.removeHandles(t),e){const s=()=>this.notifyChange("state");this.addHandles(e.map((e=>l.when((()=>e.loadStatus),s))),t)}this._set("layers",e)}get state(){return this.updating?"loading":0===this.layers.length?"disabled":"ready"}get numberOfFeatureTemplates(){return Array.from(this._featureTemplatesByLayer.values()).reduce(((e,t)=>e+t.length),0)}get items(){const{filterFunction:e}=this;return null==e?this._allItems:this._allItems.filter((t=>d.isTemplateItemGroup(t)?t.items.length>0:e(t)))}get updating(){return this._updatingHandles.updating}refresh(){this.notifyChange("filterFunction");for(const e of this._allItems)d.isTemplateItemGroup(e)&&e.reapplyFilter()}select(e,{emit:t=!0}={}){const s=this.selectedItem,r=e?.clone()||null;this._set("selectedItem",r),t&&this.emit("select",{item:r,oldItem:s,template:r?.template??null})}_createItem(e,t){return new m({disabledFunction:this.disabledItemFunction,layer:t,template:e})}_ensureGroupByObject(e){return"string"==typeof e?{key:e,label:e}:e}async _updateAllItems(e){const t=this._allItems;if(0===this.numberOfFeatureTemplates)return F(t),void(this._allItems=[]);const[s,r]=d.mapItemsByTemplate(t),l={signal:e},a=this._featureTemplatesByLayer,i=[];for(const[y,m]of a){await d.loadLayerWithTemplates(y,l),o.throwIfAborted(e);const t=c.getEffectiveLayerCapabilities(y)?.operations;if(t?.supportsEditing&&t?.supportsAdd)for(const e of m)s.has(e)?(i.push(s.get(e)),s.delete(e)):i.push(this._createItem(e,y))}for(const o of[...s.values(),...r])o.destroy();if(null==this._groupByFunction)return o.throwIfAborted(e),void(this._allItems=i);const n=new Map;for(const o of i){const e=this._groupByFunction(o),{key:t,label:s}=null!=e.key?e:f.nullGroupBy;n.has(t)||n.set(t,{label:s,items:[]}),n.get(t)?.items.push(o)}const{filterFunction:p}=this,u=Array.from(n.values()).map((({label:e,items:t})=>new h({allItems:t,filterFunction:p,label:e})));o.throwIfAborted(e),1===u.length&&u[0].label===f.nullGroupBy.label?this._allItems=u[0].allItems:this._allItems=u}};function F(e){for(const t of e){if(d.isTemplateItemGroup(t))for(const e of t.items)e.destroy();t.destroy()}}b.nullGroupBy={key:Symbol(),label:"Other​"},e.__decorate([a.property()],b.prototype,"_allItems",void 0),e.__decorate([a.property()],b.prototype,"_featureTemplatesByLayer",null),e.__decorate([a.property()],b.prototype,"_groupByFunction",void 0),e.__decorate([a.property()],b.prototype,"_updatingHandles",void 0),e.__decorate([a.property()],b.prototype,"disabled",void 0),e.__decorate([a.property()],b.prototype,"disabledItemFunction",void 0),e.__decorate([a.property({value:null})],b.prototype,"filterFunction",void 0),e.__decorate([a.property()],b.prototype,"groupBy",null),e.__decorate([a.property({value:[]})],b.prototype,"layers",null),e.__decorate([a.property()],b.prototype,"state",null),e.__decorate([a.property({readOnly:!0})],b.prototype,"numberOfFeatureTemplates",null),e.__decorate([a.property({readOnly:!0})],b.prototype,"items",null),e.__decorate([a.property({readOnly:!0})],b.prototype,"selectedItem",void 0),e.__decorate([a.property()],b.prototype,"updating",null),b=f=e.__decorate([u.subclass("esri.widgets.FeatureTemplates.FeatureTemplatesViewModel")],b);return b}));
