/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../intl","../core/Collection","../core/Logger","../core/promiseUtils","../core/reactiveUtils","../core/scheduling","../core/throttle","../core/accessorSupport/decorators/property","../core/has","../core/RandomLCG","../core/accessorSupport/decorators/subclass","../geometry/support/geometryUtils","../support/actions/actionUtils","./Feature","./Spinner","./Widget","./Feature/resources","./Feature/support/FeatureContentMixin","./Features/css","./Features/FeaturesDrillIn","./Features/FeaturesViewModel","./Features/FeaturesVisibleElements","./Popup/actions","./Popup/actionUtils","../chunks/componentsUtils","./support/globalCss","./support/Heading","./support/widgetUtils","./support/decorators/messageBundle","./support/decorators/vmEvent","./support/jsxFactory","../intl/substitute","../intl/number"],(function(e,t,i,o,s,r,n,l,a,c,d,u,h,p,_,v,w,g,m,M,f,y,b,F,I,x,C,A,k,N,O,T,E,L,W){"use strict";const S="selected-index",B=0,P="features-spinner";function R(e){return e?.declaredClass.startsWith("esri.layers.")??!1}let V=class extends(M.FeatureContentMixin(g)){constructor(e,t){super(e,t),this._featureMenuIntersectionObserverCallback=([e])=>{e?.isIntersecting&&null!=this.viewModel.featurePage&&this.viewModel.featurePage++},this._featureMenuIntersectionObserver=new IntersectionObserver(this._featureMenuIntersectionObserverCallback,{root:window.document}),this._featureMenuIntersectionObserverNode=null,this._spinner=null,this._feature=null,this._focusAbortController=null,this._drillInFlowItems=new o,this._drillInWidget=new y({flowItems:this._drillInFlowItems}),this._rootFlowItemNode=null,this._featureMenuViewportNode=null,this._actionBarMenuNode=null,this.collapsed=!1,this.featureNavigationTop=!1,this.headerActions=new I.ActionsCollection,this.headingLevel=2,this.messages=null,this.messagesCommon=null,this.responsiveActionsEnabled=!1,this.viewModel=new b,this.visibleElements=new F,this._renderAction=(e,t)=>{const i=this._getActionTitle(e),{type:o,active:s,uid:r,disabled:n,indicator:l}=e;return e.visible?E.tsx("calcite-action",{active:"toggle"===o&&e.value,appearance:"solid",bind:this,"data-action-uid":r,disabled:n,icon:this._getActionIcon(e),indicator:l,key:`action-${t}`,loading:s,onclick:this._triggerAction,scale:"s",text:i,title:this._hideActionText?i:void 0},this._getFallbackIcon(e)):null},this._openFeatureMenu=()=>{this.featureMenuOpen=!0,this._focusFlowItemNode("menu-flow-item")},this._previousFeature=()=>{this.viewModel.selectedFeatureIndex--},this._nextFeature=()=>{this.viewModel.selectedFeatureIndex++},this._handleFeatureMenuBack=()=>{this.featureMenuOpen&&(this._focusFlowItemNode("root-flow-item"),this.featureMenuOpen=!1)},this._displaySpinnerThrottled=a.throttle((()=>this._displaySpinner()),B),this._addSelectedFeatureIndexHandle(),this.addHandles([this._displaySpinnerThrottled,n.watch((()=>this.viewModel?.active),(()=>this._toggleScreenLocationEnabled())),n.watch((()=>this.viewModel?.active),(e=>this._drillInWidget.closed=!e)),n.watch((()=>this.visibleElements?.closeButton),(e=>this._drillInWidget.closable=e)),n.watch((()=>this.visibleElements?.spinner),(e=>this._spinnerEnabledChange(e))),n.watch((()=>this.viewModel?.view),((e,t)=>this._viewChange(e,t))),n.watch((()=>this.viewModel?.view?.ready),((e,t)=>this._viewReadyChange(e??!1,t??!1))),n.watch((()=>[this.viewModel?.waitingForResult,this.viewModel?.location]),(()=>{this._hideSpinner(),this._displaySpinnerThrottled()})),n.watch((()=>this.viewModel?.screenLocation),(()=>this._closeOpenActionMenu())),n.watch((()=>this.selectedFeatureWidget),(()=>this._destroyDrillInFlowItemWidgets())),n.watch((()=>{const e=this.selectedFeatureWidget?.viewModel;return[e?.title,e?.state]}),(()=>this._setTitleFromFeatureWidget())),n.watch((()=>{const e=this.selectedFeatureWidget?.viewModel;return[e?.content,e?.state]}),(()=>this._setContentFromFeatureWidget())),n.watch((()=>this.viewModel?.featureViewModels),(()=>this._featureMenuViewportScrollTop())),this._drillInWidget.on("close",(()=>this.close())),this._drillInWidget.on("exit",(()=>this._destroyDrillInFlowItemWidgets())),this._drillInWidget.on("open-feature",(({feature:e})=>this._openRelatedFeature(e))),this._drillInWidget.on("zoom-to-feature",(({featureWidget:e})=>x.zoomToLocation(this.viewModel,e)))])}loadDependencies(){return C.loadCalciteComponents({action:()=>new Promise(((t,i)=>e(["../chunks/calcite-action"],t,i))),"action-bar":()=>new Promise(((t,i)=>e(["../chunks/calcite-action-bar"],t,i))),"action-group":()=>new Promise(((t,i)=>e(["../chunks/calcite-action-group"],t,i))),button:()=>new Promise(((t,i)=>e(["../chunks/calcite-button"],t,i))),flow:()=>new Promise(((t,i)=>e(["../chunks/calcite-flow"],t,i))),"flow-item":()=>new Promise(((t,i)=>e(["../chunks/calcite-flow-item"],t,i))),list:()=>new Promise(((t,i)=>e(["../chunks/calcite-list"],t,i))),"list-item":()=>new Promise(((t,i)=>e(["../chunks/calcite-list-item"],t,i))),"list-item-group":()=>new Promise(((t,i)=>e(["../chunks/calcite-list-item-group"],t,i))),loader:()=>new Promise(((t,i)=>e(["../chunks/calcite-loader"],t,i)))})}destroy(){this._destroyDrillInFlowItemWidgets(),this._destroySelectedFeatureWidget(),this._destroySpinner(),this._unobserveFeatureMenuObserver(),this._featureMenuIntersectionObserver?.disconnect(),this._drillInWidget?.destroy(),this._focusAbortController?.abort()}get _hideActionText(){if(!this.responsiveActionsEnabled)return!1;const e=this.view?.widthBreakpoint;return"xsmall"===e||"small"===e||"medium"===e}get _featureNavigationVisible(){return this.viewModel.active&&this.viewModel.featureCount>1&&this.visibleElements.featureNavigation}get _isCollapsed(){return this._collapseEnabled&&this.collapsed}get _collapseEnabled(){return this.visibleElements.collapseButton&&!!this.title&&!!this.content}get active(){return this.viewModel.active}get content(){return this.viewModel.content}set content(e){this.viewModel.content=e}get icon(){return null}get featureMenuOpen(){return this.viewModel.featureMenuOpen}set featureMenuOpen(e){this.viewModel.featureMenuOpen=e}get features(){return this.viewModel.features}set features(e){this.viewModel.features=e}get goToOverride(){return this.viewModel.goToOverride}set goToOverride(e){this.viewModel.goToOverride=e}get location(){return this.viewModel.location}set location(e){this.viewModel.location=e}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}get map(){return this.viewModel.map}set map(e){this.viewModel.map=e}get promises(){return this.viewModel.promises}set promises(e){this.viewModel.promises=e}get selectedFeature(){return this.viewModel.selectedFeature}get selectedDrillInFeature(){const e=Array.from(this._drillInFlowItems).at(-1);if(!e)return null;const{flowType:t}=e;return"feature-association"===t||"feature-relationship"===t?e.graphic??null:null}get selectedFeatureIndex(){return this.viewModel.selectedFeatureIndex}set selectedFeatureIndex(e){this.viewModel.selectedFeatureIndex=e}get selectedFeatureWidget(){const{_feature:e,headingLevel:t,_drillInFlowItems:i,timeZone:o,spatialReference:s,map:r}=this,{selectedFeatureViewModel:n}=this.viewModel,l={title:!1};return n?(e?(e.viewModel=n,e.visibleElements=l):this._feature=new v({flowItems:i,headingLevel:t+1,timeZone:o,spatialReference:s,map:r,viewModel:n,visibleElements:l}),this._feature):null}get spatialReference(){return this.viewModel.spatialReference}set spatialReference(e){this.viewModel.spatialReference=e}get title(){return this.viewModel.title}set title(e){this.viewModel.title=e}get timeZone(){return this.viewModel.timeZone}set timeZone(e){this.viewModel.timeZone=e}get updateLocationEnabled(){return this.viewModel.updateLocationEnabled}set updateLocationEnabled(e){this.viewModel.updateLocationEnabled=e}get view(){return this.viewModel.view}set view(e){this.viewModel.view=e}get visible(){return this.viewModel.visible}set visible(e){this.viewModel.visible=e}blur(){const{active:e}=this.viewModel;e?this._rootFlowItemNode?.blur():s.getLogger(this).warn("Features can only be blurred when currently active.")}clear(){return this.viewModel.clear()}close(){this.viewModel.visible=!1}fetchFeatures(e,t){return this.viewModel.fetchFeatures(e,t)}focus(){const{active:e}=this.viewModel;e?this._focusFlowItemNode(this.featureMenuOpen?"menu-flow-item":"root-flow-item"):s.getLogger(this).warn("Features can only be focused when currently active.")}next(){return this.viewModel.next()}open(e){this.removeHandles(S);const t={collapsed:e?.collapsed??!1};this.set(t),this.viewModel.open(e),this.addHandles(n.when((()=>!this.viewModel.waitingForResult),(()=>this._addSelectedFeatureIndexHandle()),{once:!0}))}previous(){return this.viewModel.previous()}triggerAction(e){return this.viewModel.triggerAction(e)}render(){return E.tsx("div",{bind:this,class:this.classes(f.css.base,A.globalCss.widget,A.globalCss.panel),onkeydown:this._onMainKeydown},this._renderHeader(),this._renderContentContainer())}_renderFeatureNavigation(){return[this._renderPagination(),this._renderFeatureMenuButton()]}_renderHeader(){return!this.featureMenuOpen&&this.featureNavigationTop&&this._featureNavigationVisible?E.tsx("div",{class:f.css.header,key:"header-actions"},this._renderFeatureNavigation()):null}_renderFooter(){return this.featureMenuOpen||this.featureNavigationTop||!this._featureNavigationVisible?null:E.tsx("div",{class:f.css.footer,key:"footer-actions",slot:"footer"},this._renderFeatureNavigation())}_renderFeatureMenuButton(){const{messages:e,viewModel:t}=this,{featureCount:i,selectedFeatureIndex:o,pendingPromisesCount:s}=t;return E.tsx("calcite-action",{appearance:"solid",bind:this,icon:"list",key:"feature-menu-button",label:e.selectFeature,loading:s>0,onclick:this._openFeatureMenu,scale:"s",text:L.substitute(e.pageText,{index:W.formatNumber(o+1),total:W.formatNumber(i)}),textEnabled:!0,title:e.selectFeature})}_renderPagination(){const{previous:e,next:t}=this.messagesCommon.pagination;return E.tsx("calcite-action-bar",{class:f.css.paginationActionBar,expandDisabled:!0,key:"pagination-action-bar",layout:"horizontal",overflowActionsDisabled:!0,scale:"s"},E.tsx("calcite-action-group",{scale:"s"},E.tsx("calcite-action",{appearance:"solid",class:f.css.paginationPrevious,icon:"chevron-left",iconFlipRtl:!0,label:e,onclick:this._previousFeature,scale:"s",text:e,title:e}),E.tsx("calcite-action",{appearance:"solid",icon:"chevron-right",iconFlipRtl:!0,label:t,onclick:this._nextFeature,scale:"s",text:t,title:t})))}_renderFeatureMenuItem(e){const{selectedFeatureViewModel:t,featureViewModels:i}=this.viewModel,o=e===t,s=i.indexOf(e);return E.tsx("calcite-list-item",{bind:this,"data-feature-index":s,key:`feature-menu-item-${e.uid}`,onblur:this._removeActiveFeature,onfocus:this._setActiveFeature,onmouseleave:this._removeActiveFeature,onmouseover:this._setActiveFeature,selected:o,onCalciteListItemSelect:this._selectFeature},E.tsx("span",{innerHTML:e.title||this.messagesCommon.untitled,slot:"content"}))}_groupResultsByLayer(){const{featureViewModels:e}=this.viewModel,t=new Map;return e.forEach((e=>{const i=e?.graphic;if(!i)return;const{layer:o,sourceLayer:s}=i,r=(R(o)?o:null)||(R(s)?s:null),n=t.get(r)??[];t.set(r,[...n,e])})),t}_renderFeatureMenu(){const{featureViewModels:e}=this.viewModel,t=this._groupResultsByLayer();return e.length?E.tsx("calcite-list",{selectionAppearance:"icon",selectionMode:"single"},Array.from(t.keys(),(e=>{const i=t.get(e)?.map((e=>this._renderFeatureMenuItem(e))),o=e?e.title??this.messagesCommon.untitled:null;return this.visibleElements.featureListLayerTitle&&null!==o?E.tsx("calcite-list-item-group",{heading:o,key:e?.uid||"map-graphics"},i):i}))):null}_renderHeaderAction(e,t){const i=e.title||"";return e.visible?E.tsx("calcite-action",{active:"toggle"===e.type&&e.value,appearance:"solid",bind:this,"data-action-uid":e.uid,disabled:e.disabled,icon:e.icon??void 0,indicator:e.indicator,key:`header-action-${t}`,loading:e.active,onclick:this._triggerHeaderAction,slot:"header-actions-end",text:i,title:i}):null}_renderHeaderActions(){return this.headerActions.map(((e,t)=>this._renderHeaderAction(e,t))).toArray()}_renderContentFeature(){const{headingLevel:e,visibleElements:t,_isCollapsed:i,_collapseEnabled:o,featureNavigationTop:s}=this,{title:r,active:n}=this.viewModel,l=t.heading&&r?r:"";return E.tsx("calcite-flow-item",{afterCreate:this._storeRootFlowItemNode,bind:this,class:this.classes({[f.css.contentFeature]:!0,[f.css.flowItemCollapsed]:i}),closable:t.closeButton,closed:!n,collapsed:i,collapseDirection:s?"down":"up",collapsible:o,headingLevel:e,key:"root-flow-item",onCalciteFlowItemClose:this.close,onCalciteFlowItemToggle:this._handleCollapseToggle},l?E.tsx(k.Heading,{class:this.classes(f.css.featuresHeading,A.globalCss.heading),innerHTML:l,key:"header-content",level:this.headingLevel,slot:"header-content"}):null,this._renderHeaderActions(),this._renderActionBar(),i?null:E.tsx("div",{class:this.classes(f.css.container,f.css.contentContainer)},this._renderContent()),this._renderFooter())}_renderFeatureMenuContainer(){const{viewModel:e,featureMenuOpen:t,messages:i,messagesCommon:o}=this,{active:s,featureViewModels:r,pendingPromisesCount:n}=e;return t?E.tsx("calcite-flow-item",{afterCreate:this._storeFeatureMenuFlowItemNode,bind:this,closable:!1,closed:!s,description:L.substitute(i.total,{total:r.length}),heading:i.selectFeature,key:"feature-menu",loading:e.waitingForContents,onCalciteFlowItemBack:e=>{e.preventDefault(),this._handleFeatureMenuBack()}},n>0?E.tsx("calcite-loader",{class:f.css.loader,inline:!0,key:"feature-menu-loader",label:o.loading,slot:"header-actions-end"}):null,E.tsx("div",{class:f.css.container},this._renderFeatureMenu()),E.tsx("div",{afterCreate:this._featureMenuIntersectionObserverCreated,bind:this,class:f.css.featureMenuObserver}),E.tsx("calcite-button",{appearance:"transparent",onclick:this._handleFeatureMenuBack,slot:"footer-actions",width:"full"},o.back)):null}_renderContentContainer(){const e=[this._renderContentFeature(),this._renderFeatureMenuContainer(),this._drillInWidget.render()];return this.visibleElements.flow?E.tsx("calcite-flow",{key:"content-container"},e):e}_getFallbackIcon(e){const{className:t,icon:i}=e;if(i)return null;const o=_.substituteActionImage({action:e,feature:this.selectedFeature}),s={[f.css.icon]:!!t,[f.css.actionImage]:!!o};return t&&(s[t]=!0),o||t?E.tsx("span",{"aria-hidden":"true",class:this.classes(f.css.icon,s),key:"icon",styles:_.getActionStyles(o)}):null}_renderActionBar(){return!this._isCollapsed&&this.visibleElements.actionBar&&this.viewModel.allActions?.length?E.tsx("calcite-action-bar",{expandDisabled:!0,expanded:!this._hideActionText,key:"header-action-bar",scale:"s",slot:"action-bar"},E.tsx("calcite-action-group",{afterCreate:e=>this._actionBarMenuNode=e,overlayPositioning:"fixed",scale:"s"},this._renderActions())):null}_renderActions(){return this.viewModel.allActions.toArray().map(this._renderAction)}_renderContent(){const e=this.viewModel?.content;return e?"string"==typeof e?E.tsx("div",{class:m.css.contentNode,innerHTML:e,key:e}):this.renderNodeContent(e):null}_handleCollapseToggle(){this.collapsed=!this.collapsed}async _openRelatedFeature(e){await e.viewModel.updateGeometry();const t=e.graphic,i=t?.geometry;if(null==i||null==t)return;this._destroyDrillInFlowItemWidgets(),await this.viewModel.zoomTo({target:i});const o=p.getPointFromGeometry(i);this.open({features:[t],location:null!=o?o:void 0})}async _focusFlowItemNode(e){this._focusAbortController?.abort(),this._focusAbortController=new AbortController;const t=this._focusAbortController.signal;await r.ignoreAbortErrors(l.waitAnimationFrame(t));const i="menu-flow-item"===e?this._featureMenuViewportNode:this._rootFlowItemNode;N.setFocus(i)}_storeRootFlowItemNode(e){this._rootFlowItemNode=e}_storeFeatureMenuFlowItemNode(e){this._featureMenuViewportNode=e}_setActiveFeature(e){const{viewModel:t}=this,i=e.currentTarget["data-feature-index"];t.activeFeature=t.features?.[i]||null}_removeActiveFeature(){this.viewModel.activeFeature=null}_selectFeature(e){const t=e.currentTarget["data-feature-index"];isNaN(t)||(this.viewModel.selectedFeatureIndex=t),this._handleFeatureMenuBack()}_unobserveFeatureMenuObserver(){this._featureMenuIntersectionObserverNode&&this._featureMenuIntersectionObserver.unobserve(this._featureMenuIntersectionObserverNode)}_featureMenuIntersectionObserverCreated(e){this._unobserveFeatureMenuObserver(),this._featureMenuIntersectionObserver.observe(e),this._featureMenuIntersectionObserverNode=e}_getActionIcon(e){return e.icon?e.icon:e.image||e.className?void 0:"question"}_getActionTitle(e){const{messages:t,selectedFeature:i,messagesCommon:o}=this,{id:s}=e,r=i?.attributes,n=e.title??"",l="zoom-to-feature"===s?L.substitute(n,{messages:t}):"remove-selected-feature"===s?L.substitute(n,{messages:o}):"zoom-to-clustered-features"===s||"browse-clustered-features"===s?L.substitute(n,{messages:t}):e.title;return l&&r?L.substitute(l,r):l??""}_onMainKeydown(e){const{key:t}=e;"ArrowLeft"===t&&(e.stopPropagation(),this._handleFeatureMenuBack(),this.previous()),"ArrowRight"===t&&(e.stopPropagation(),this._handleFeatureMenuBack(),this.next())}_featureMenuViewportScrollTop(){this._featureMenuViewportNode&&this._featureMenuViewportNode.scrollContentTo({top:0})}_setContentFromFeatureWidget(){const{selectedFeatureWidget:e}=this;e&&(this.viewModel.content=e)}_setTitleFromFeatureWidget(){const{selectedFeatureWidget:e,messagesCommon:t}=this,i=e?.viewModel;e&&(this.viewModel.title="error"===i?.state?t?.errorMessage:i?.title||"")}_addSelectedFeatureIndexHandle(){const e=n.watch((()=>this.viewModel?.selectedFeatureIndex),((e,t)=>this._selectedFeatureIndexUpdated(e,t)));this.addHandles(e,S)}_selectedFeatureIndexUpdated(e,t){const{featureCount:i}=this.viewModel;i&&e!==t&&-1!==e&&(this._destroyDrillInFlowItemWidgets(),this._rootFlowItemNode&&this._rootFlowItemNode.scrollContentTo({top:0}))}_triggerHeaderAction(e){const t=e.currentTarget;if(t.disabled)return;const i=t.dataset.actionUid,o=this.headerActions.find((({uid:e})=>e===i));o&&!o.disabled&&("toggle"===o?.type&&(o.value=!o.value),this.emit("trigger-header-action",{action:o}))}_triggerAction(e){const t=e.currentTarget;if(t.disabled)return;const i=t.dataset.actionUid,{allActions:o}=this.viewModel,s=o.findIndex((e=>e.uid===i)),r=o.at(s);r&&"toggle"===r.type&&(r.value=!r.value),this.viewModel.triggerAction(s)}_createSpinner(e){e&&(this._spinner=new w({view:e}),e.ui.add(this._spinner,{key:P,position:"manual",internal:!0}))}_wireUpView(e){this._destroySpinner(),e&&this.visibleElements?.spinner&&this._createSpinner(e)}_hideSpinner(){const{_spinner:e}=this;e&&(e.location=null,e.hide())}_viewReadyChange(e,t){e?this._wireUpView(this.viewModel?.view):t&&this.viewModel.clear()}_viewChange(e,t){e&&t&&this.viewModel.clear()}_destroySelectedFeatureWidget(){const{_feature:e}=this;e&&(e.viewModel=null,!e.destroyed&&e.destroy()),this._feature=null}_closeOpenActionMenu(){const{_actionBarMenuNode:e}=this;e&&(e.menuOpen=!1)}_destroyDrillInFlowItemWidgets(){this._drillInFlowItems.drain((e=>{"showAllEnabled"in e.viewModel&&(e.viewModel.showAllEnabled=!1),e.viewModel=null,e.destroy()}))}_toggleScreenLocationEnabled(){const{viewModel:e}=this;e&&(e.screenLocationEnabled=e.active)}_displaySpinner(){const{_spinner:e}=this;if(!e)return;const{location:t,waitingForResult:i}=this.viewModel;i&&t?e.show({location:t}):e.hide()}_destroySpinner(){const{_spinner:e,view:t}=this;e&&(t?.ui?.remove(e,P),e.destroy(),this._spinner=null)}_spinnerEnabledChange(e){this._destroySpinner(),e&&this._createSpinner(this.viewModel?.view)}};t.__decorate([c.property()],V.prototype,"_drillInFlowItems",void 0),t.__decorate([c.property()],V.prototype,"_hideActionText",null),t.__decorate([c.property()],V.prototype,"_featureNavigationVisible",null),t.__decorate([c.property()],V.prototype,"_isCollapsed",null),t.__decorate([c.property()],V.prototype,"_collapseEnabled",null),t.__decorate([c.property({readOnly:!0})],V.prototype,"active",null),t.__decorate([c.property()],V.prototype,"collapsed",void 0),t.__decorate([c.property()],V.prototype,"content",null),t.__decorate([c.property()],V.prototype,"icon",null),t.__decorate([c.property()],V.prototype,"featureMenuOpen",null),t.__decorate([c.property()],V.prototype,"featureNavigationTop",void 0),t.__decorate([c.property()],V.prototype,"features",null),t.__decorate([c.property()],V.prototype,"goToOverride",null),t.__decorate([c.property({type:I.ActionsCollection})],V.prototype,"headerActions",void 0),t.__decorate([c.property()],V.prototype,"headingLevel",void 0),t.__decorate([c.property()],V.prototype,"location",null),t.__decorate([c.property()],V.prototype,"label",null),t.__decorate([c.property()],V.prototype,"map",null),t.__decorate([c.property(),O.messageBundle("esri/widgets/Features/t9n/Features")],V.prototype,"messages",void 0),t.__decorate([c.property(),O.messageBundle("esri/t9n/common")],V.prototype,"messagesCommon",void 0),t.__decorate([c.property()],V.prototype,"promises",null),t.__decorate([c.property()],V.prototype,"responsiveActionsEnabled",void 0),t.__decorate([c.property({readOnly:!0})],V.prototype,"selectedFeature",null),t.__decorate([c.property({readOnly:!0})],V.prototype,"selectedDrillInFeature",null),t.__decorate([c.property()],V.prototype,"selectedFeatureIndex",null),t.__decorate([c.property({readOnly:!0})],V.prototype,"selectedFeatureWidget",null),t.__decorate([c.property()],V.prototype,"spatialReference",null),t.__decorate([c.property()],V.prototype,"title",null),t.__decorate([c.property()],V.prototype,"timeZone",null),t.__decorate([c.property()],V.prototype,"updateLocationEnabled",null),t.__decorate([c.property()],V.prototype,"view",null),t.__decorate([c.property({type:b}),T.vmEvent(["triggerAction","trigger-action"])],V.prototype,"viewModel",void 0),t.__decorate([c.property({type:F,nonNullable:!0})],V.prototype,"visibleElements",void 0),t.__decorate([c.property()],V.prototype,"visible",null),V=t.__decorate([h.subclass("esri.widgets.Features")],V);return V}));
