/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../intl","../core/reactiveUtils","../core/accessorSupport/decorators/property","../core/has","../core/Logger","../core/RandomLCG","../core/accessorSupport/decorators/subclass","./Widget","./FloorFilter/css","./FloorFilter/FloorFilterViewModel","./support/globalCss","./support/Heading","./support/legacyIcon","./support/widgetUtils","./support/decorators/messageBundle","./support/jsxFactory","../intl/substitute"],(function(e,t,s,i,l,o,n,a,r,c,d,h,u,v,g,p,m,M){"use strict";const _=new Set(["ArrowUp","ArrowDown","End","Home"]);let f=class extends r{constructor(e,t){super(e,t),this._activeMenu=null,this._activeMenuIndex={levels:-1,menuItems:-1},this._baseNode=null,this._facilitiesListNode=null,this._levelsListNode=null,this._sitesListNode=null,this._searchInput=null,this.viewModel=new d,this.messages=null,this.messagesCommon=null,this.headingLevel=2,this._resizeObserver=new ResizeObserver((()=>this.scheduleRender())),this.addHandles(s.watch((()=>this._searchInput),(()=>this._focusSearch())))}destroy(){this._resizeObserver?.disconnect()}get enabled(){return this.viewModel.enabled}set enabled(e){this.viewModel.enabled=e}get longNames(){return this.viewModel.longNames}set longNames(e){this.viewModel.longNames=e}get minimized(){return this.viewModel.minimized}set minimized(e){this.viewModel.minimized=e}get pinnedLevels(){return this.viewModel.pinnedLevels}set pinnedLevels(e){this.viewModel.pinnedLevels=e}get site(){return this.viewModel.site}set site(e){this.viewModel.site=e}get facility(){return this.viewModel.facility}set facility(e){this.viewModel.facility=e}get level(){return this.viewModel.level}set level(e){this.viewModel.level=e}get view(){return this.viewModel.view}set view(e){this.viewModel.view=e}get goToOverride(){return this.viewModel.goToOverride}set goToOverride(e){this.viewModel.goToOverride=e}get icon(){return"floor-plan"}set icon(e){this._overrideIfSome("icon",e)}updateWebDocument(e){return this.viewModel.updateWebDocument(e)}render(){const{longNames:e}=this,t=e&&this.viewModel.isNormalMode?"expanded":"collapsed",s=this._renderButtons(),i=this._renderFilterMenu(),l=m.tsx("div",{class:this.classes(c.css.separator)}),o=this._getComponentPosition(),n=this._getPosition(o),a="top-right"===o||"bottom-right"===o,r="top-left"===o||"bottom-left"===o,d=g.isRTL(this.container),u=d&&r||!d&&a?i:s,v=d&&r||!d&&a?s:i;return m.tsx("div",{afterCreate:this._afterBaseNodeCreate,class:this.classes(c.css.floorFilter,h.globalCss.widget,`${c.css.floorFilterLayout}${t}`,`${c.css.floorFilterPosition}${n}`),key:"floor-filter-menu"},u,this.viewModel?.filterMenuOpen?l:null,v)}_renderButtons(){const e=this._getComponentPosition(),t=[];return"top"===this._getPosition(e)?(t.push(this._renderBrowseButton()),t.push(this._renderLevelButtons()),t.push(this._renderCloseLevelsButton()),t.push(this._renderZoomButton()),t.push(this._renderCollapseToggleButton())):(t.push(this._renderCollapseToggleButton()),t.push(this._renderZoomButton()),t.push(this._renderCloseLevelsButton()),t.push(this._renderLevelButtons()),t.push(this._renderBrowseButton())),m.tsx("div",{class:this.classes(h.globalCss.widget,c.css.buttonContainer),key:"button-container"},t)}_renderBrowseButton(){const{longNames:e,messages:t}=this;return m.tsx("button",{"aria-expanded":this.viewModel.filterMenuOpen.toString(),"aria-label":t.buttons.browse,bind:this,class:this.classes(h.globalCss.widget,h.globalCss.widgetButton,h.globalCss.interactive,("loading"===this.viewModel.state||"disabled"===this.viewModel.state)&&h.globalCss.buttonDisabled,c.css.browseButton,this.viewModel?.filterMenuOpen&&h.globalCss.widgetButtonActive),key:"browse-button",onclick:this._toggleFilterMenu,title:t.buttons.browse,type:"button"},m.tsx("div",{class:this.classes(c.css.buttonInfo)},m.tsx("span",{class:this.classes(v.legacyIcon.icon,v.legacyIcon.urbanModel)}),m.tsx("span",{class:this.classes(c.css.buttonLabel)},e&&this.viewModel.isNormalMode?t.buttons.browse:null)))}_renderLevelButtons(){if(!this.viewModel?.filterFeatures?.levels?.levelsInfo||!this.facility)return null;const{facility:e,messagesCommon:t,messages:s}=this,i=this.viewModel?.getFacility(e),l=this.viewModel?.getFacilityLevels(e),o=l.map((e=>this._renderLevelButton(e)));if(!o.length)return null;const n=i&&M.substitute(s.selector.levelsLabel,{name:`"${i.name}"`});if(this._isWebScene(this.view?.map)&&o?.length>1){const s={id:`all--${e}`,facilityId:e,shortName:t.all,longName:t.all,levelNumber:null,verticalOrder:null},i=this._renderLevelButton(s);o.push(i)}return m.tsx("ul",{afterCreate:g.storeNode,"aria-label":n,bind:this,class:this.classes(c.css.levelsContainer),"data-id":"levels","data-node-ref":"_levelsListNode",key:"levels-button-container",onkeydown:this._handleListKeydown},o)}_renderLevelButton(e){const{longNames:t}=this,{shortName:s,longName:i,id:l}=e,o=`levels--${l}`,n=this.level===l,a=t&&this.viewModel.isNormalMode?i:s;return this.viewModel.isNormalMode||n||this.viewModel.levelsExpanded?m.tsx("li",{key:o},m.tsx("button",{bind:this,class:this.classes(h.globalCss.widgetButton,n?h.globalCss.widgetButtonActive:null,h.globalCss.interactive,c.css.levelButton),"data-id":l,"data-list-id":"levels",onclick:this._levelSelected,onfocus:this._onItemFocus,type:"button"},a)):null}_renderCloseLevelsButton(){if(!this.level||this.viewModel.isNormalMode||!this.viewModel.levelsExpanded)return null;const{messagesCommon:e}=this;return m.tsx("button",{"aria-label":e.close,bind:this,class:this.classes(h.globalCss.widget,h.globalCss.widgetButton,h.globalCss.interactive,c.css.closeLevelsButton),key:"close-levels-button",onclick:this._closeLevels,title:e.close,type:"button"},m.tsx("div",{class:this.classes(c.css.buttonInfo)},m.tsx("span",{class:this.classes(v.legacyIcon.icon,v.legacyIcon.close)})))}_renderZoomButton(){const{longNames:e,messages:t,facility:s,site:i}=this,l=this.viewModel?.filterMenuType,o=this.viewModel?.filterMenuOpen,n=this.viewModel?.getSite(i),a=this.viewModel?.getFacility(s),r="site"===l&&o?!n:!a;return m.tsx("button",{"aria-label":t.buttons.zoomTo,bind:this,class:this.classes(h.globalCss.widget,h.globalCss.widgetButton,r&&h.globalCss.buttonDisabled,h.globalCss.interactive,this.viewModel?.getFacilityLevels(s).length>0?c.css.zoomButtonLevels:c.css.zoomButton),key:"zoom-button",onclick:this._zoomToClicked,title:t.buttons.zoomTo,type:"button"},m.tsx("div",{class:this.classes(c.css.buttonInfo)},m.tsx("span",{class:this.classes(v.legacyIcon.icon,v.legacyIcon.zoomToObject)}),m.tsx("span",{class:this.classes(c.css.buttonLabel)},e&&this.viewModel.isNormalMode?t.buttons.zoomTo:null)))}_renderCollapseToggleButton(){const{longNames:e,messagesCommon:t}=this,s=e?v.legacyIcon.collapse:v.legacyIcon.expand,i=this.classes(v.legacyIcon.icon,s,c.css.iconFlip),l=e?t.collapse:t.expand;return m.tsx("button",{"aria-label":l,bind:this,class:this.classes(h.globalCss.widget,h.globalCss.widgetButton,h.globalCss.interactive,c.css.minimizeToggleButton),key:"minimize-toggle-button",onclick:this._toggleCollapsed,title:l,type:"button"},m.tsx("div",{class:this.classes(c.css.buttonInfo)},m.tsx("span",{class:i}),m.tsx("span",{class:this.classes(c.css.buttonLabel)},e&&this.viewModel.isNormalMode?t.collapse:null)))}_renderFilterMenu(){return this.viewModel?.filterMenuOpen?"site"===this.viewModel?.filterMenuType?this._renderSiteFilterMenu():"facility"===this.viewModel?.filterMenuType?this._renderFacilityFilterMenu():null:null}_renderSiteFilterMenu(){const{messages:e,messagesCommon:t}=this,s=this.site?this.viewModel?.getSite(this.site)?.name:e.selector.selectSite,i=m.tsx("div",{class:this.classes(`${c.css.filterMenuHeader}`),key:"filter-menu-site-header"},m.tsx("div",{class:this.classes(c.css.filterMenuHeaderTextGroup)},m.tsx(u.Heading,{class:this.classes(c.css.filterMenuHeaderText),level:this.headingLevel},s)),m.tsx("button",{bind:this,class:this.classes(v.legacyIcon.icon,v.legacyIcon.close),onclick:this._closeClicked,title:t.close,type:"button"})),l=this._renderSearchInput(),o=this._renderSiteItems();return m.tsx("div",{class:this.classes(c.css.filterMenu),key:"filter-menu-site"},i,l,o)}_renderFacilityFilterMenu(){const{messages:e,messagesCommon:t,site:s}=this,i=this.viewModel?.getSite(s)?.name,l=this.facility&&this.viewModel?.getFacility(this.facility)?.name||e.selector.selectFacility,o=this.viewModel.hasMultipleSites?m.tsx("button",{bind:this,class:this.classes(c.css.filterMenuHeaderBack),onclick:this._backClicked,title:t.back,type:"button"},m.tsx("span",{class:this.classes(g.isRTL(this.container)?v.legacyIcon.right:v.legacyIcon.left)})):null,n=this.viewModel.hasMultipleSites?m.tsx(u.Heading,{class:this.classes(c.css.filterMenuHeaderSubtext),level:u.incrementHeadingLevel(this.headingLevel)},i):null,a=m.tsx("div",{class:this.classes(c.css.filterMenuHeader),key:"filter-menu-site-header"},o,m.tsx("div",{class:this.classes(c.css.filterMenuHeaderTextGroup)},m.tsx(u.Heading,{class:this.classes(c.css.filterMenuHeaderText),level:this.headingLevel},l),n),m.tsx("button",{bind:this,class:this.classes(v.legacyIcon.icon,v.legacyIcon.close),onclick:this._closeClicked,title:t.close,type:"button"})),r=this._renderSearchInput(),d=this._renderFacilityItems();return m.tsx("div",{class:this.classes(c.css.filterMenu),key:"filter-menu-facility"},a,r,d)}_renderSearchInput(){const{messagesCommon:e}=this,t=!!(this.viewModel.searchTerm&&this.viewModel.searchTerm?.length>0);return m.tsx("div",{class:this.classes(c.css.filterMenuSearch),key:"filter-menu-search"},m.tsx("span",{class:this.classes(v.legacyIcon.icon,v.legacyIcon.search),key:"filter-menu-search-icon"}),m.tsx("input",{afterCreate:g.storeNode,bind:this,class:this.classes(c.css.filterMenuSearchInput),"data-node-ref":"_searchInput",oninput:this._onSearchChange,onpaste:this._onSearchChange,placeholder:e.search,value:this.viewModel.searchTerm??void 0}),t?m.tsx("span",{bind:this,class:this.classes(v.legacyIcon.icon,v.legacyIcon.close),key:"filter-menu-search-clear",onclick:this._onSearchClear,title:e.clear}):null)}_renderBlueCircle(){return m.tsx("span",{class:this.classes(c.css.selectedItemCircle),key:"floor-filter__selected-item-circle"})}_renderSiteItems(){if(!this.viewModel?.filterFeatures?.sites?.sitesInfo)return null;const{messages:e}=this,t=this.viewModel.filterFeatures.sites.sitesInfo,s=this.viewModel.filterSites(t).map((e=>this._renderSiteItem(e))),i=0===s.length&&this.viewModel?.searchTerm&&m.tsx("div",{class:this.classes(h.globalCss.empty)},e.noResults);return m.tsx("ul",{afterCreate:g.storeNode,"aria-label":e.selector.sitesLabel,bind:this,class:this.classes(c.css.filterMenuItems),"data-id":"sites","data-node-ref":"_sitesListNode",key:"filter-menu-items--sites",onkeydown:this._handleListKeydown,tabIndex:-1},s,i)}_renderSiteItem(e){const{name:t,id:s}=e,i=`filter-menu-site--${s}`,l=this.site===s;return m.tsx("li",{key:i},m.tsx("button",{bind:this,class:this.classes(c.css.filterMenuSite),"data-id":s,"data-list-id":"sites",onclick:this._siteSelected,onfocus:this._onItemFocus,type:"button"},l?this._renderBlueCircle():null,m.tsx("span",{class:this.classes(l?c.css.filterMenuSelectedItem:c.css.filterMenuItemName)},t),m.tsx("span",{class:this.classes(g.isRTL(this.container)?v.legacyIcon.left:v.legacyIcon.right)})))}_renderFacilityItems(){if(!this.viewModel?.filterFeatures?.facilities?.facilitiesInfo)return null;const{messages:e,site:t}=this,s=this.viewModel.getSite(t),i=this.viewModel.filterFeatures.facilities.facilitiesInfo,l=this.viewModel.filterFacilities(i).map((e=>this._renderFacilityItem(e))),o=0===l.length&&this.viewModel?.searchTerm&&m.tsx("div",{class:this.classes(h.globalCss.empty)},e.noResults),n=s?M.substitute(e.selector.siteFacilitiesLabel,{name:`"${s.name}"`}):e.selector.facilitiesLabel;return m.tsx("ul",{afterCreate:g.storeNode,"aria-label":n,bind:this,class:this.classes(c.css.filterMenuItems),"data-id":"facilities","data-node-ref":"_facilitiesListNode",key:"filter-menu-items--facilities",onkeydown:this._handleListKeydown,tabIndex:-1},l,o)}_renderFacilityItem(e){const{name:t,id:s}=e,i=`filter-menu-facility--${s}`,l=this.facility===s;return m.tsx("li",{key:i},m.tsx("button",{bind:this,class:this.classes(c.css.filterMenuFacility),"data-id":s,"data-list-id":"facilities",onclick:this._facilitySelected,onfocus:this._onItemFocus,type:"button"},l?this._renderBlueCircle():null,m.tsx("span",{class:this.classes(l?c.css.filterMenuSelectedItem:c.css.filterMenuItemName)},t)))}_afterBaseNodeCreate(e){this._baseNode&&this._resizeObserver?.unobserve(this._baseNode),this._baseNode=e,this._resizeObserver?.observe(this._baseNode)}_toggleCollapsed(){this.longNames=!this.longNames}_toggleFilterMenu(){const e=this.viewModel?.filterMenuOpen??!1;this.viewModel.filterMenuOpen=!e}_setFilterMenuType(e){this.viewModel.filterMenuType=e}_zoomToClicked(){if(this.site&&"site"===this.viewModel?.filterMenuType&&this.viewModel?.filterMenuOpen){const e=this.viewModel?.getSite(this.site);this.viewModel.goTo(e)}else if(this.facility){const e=this.viewModel?.getFacility(this.facility);this.viewModel.goTo(e)}else if(this.site){const e=this.viewModel?.getSite(this.site);this.viewModel.goTo(e)}}_onSearchChange(e){const t=e.target;""===t.value?this.viewModel.searchTerm=null:t.value&&this.viewModel?.searchTerm!==t.value&&(this.viewModel.searchTerm=t.value)}_onSearchClear(){this.viewModel.searchTerm=null}_closeClicked(){this.viewModel.searchTerm=null,this.viewModel.filterMenuOpen=!1}_backClicked(){this._setFilterMenuType("site"),this.viewModel.searchTerm=null}_siteSelected(e){const t=e.currentTarget.getAttribute("data-id"),s=this.viewModel.getSite(t);let i=!1;this.site!==t&&(this.facility=null,this.level=null,i=!0,this.viewModel.levelsExpanded=!1),this.site=t,this.viewModel.searchTerm=null,this._setFilterMenuType("facility"),this.viewModel.goTo(s),i&&this.viewModel.setFloors(null)}_facilitySelected(e){const t=e.currentTarget.getAttribute("data-id"),s=this.viewModel.getFacility(t);let i=!1;if(this.facility!==t){if("base-floors"===this.viewModel.filterMode){const e=this.viewModel?.getBaseLevel(s);this.level=e?e.id:null}else this.level=null;i=!0,this.viewModel.levelsExpanded=!1}if(this.facility=t,this.viewModel.goTo(s),i){const e=this.viewModel.getLevel(this.level);this.viewModel.setFloors(e)}if(!this.viewModel.isNormalMode){const e=this.viewModel.getFacilityLevels(t);e?.length>1&&(this.viewModel.levelsExpanded=!0)}setTimeout((()=>this._focusActiveLevel()),50)}_levelSelected(e){const t=e.currentTarget.getAttribute("data-id");this.level=t}_closeLevels(){this.viewModel.levelsExpanded=!1}_isWebScene(e){return"esri.WebScene"===e?.declaredClass}_getComponentPosition(){return null!=this.container?this.view?.ui?.getPosition(this.container):null}_getPosition(e){switch(e){case"bottom-right":case"bottom-left":return"bottom";default:return"top"}}_handleListKeydown(e){const t=e.currentTarget.getAttribute("data-id");let s=null;"sites"===t||"facilities"===t?(this._activeMenu!==t&&(this._activeMenuIndex.menuItems=-1),this._activeMenu=t,s="menuItems"):"levels"===t&&(s="levels");const i="sites"===t?this._sitesListNode:"facilities"===t?this._facilitiesListNode:"levels"===t?this._levelsListNode:null,{key:l}=e,o="Tab"===l,n=_.has(l);n&&e.preventDefault();const a=i?.getElementsByTagName("li");a&&0!==a.length&&(n||o)&&this._handleItemNavigation(l,e.shiftKey,a,o,s)}_handleItemNavigation(e,t,s,i,l){if(!l)return;this._activeMenuIndex[l]===s.length&&this._activeMenuIndex[l]--,-1===this._activeMenuIndex[l]&&this._activeMenuIndex[l]++;const o=this._activeMenuIndex[l];switch(e){case"Home":this._activeMenuIndex[l]=0;break;case"End":this._activeMenuIndex[l]=s.length-1;break;case"ArrowUp":this._activeMenuIndex[l]=this._activeMenuIndex[l]<=0?s.length-1:this._activeMenuIndex[l]-1;break;case"ArrowDown":this._activeMenuIndex[l]=this._activeMenuIndex[l]===s.length-1?0:this._activeMenuIndex[l]+1}if("Tab"===e&&t&&this._activeMenuIndex[l]>=0&&this._activeMenuIndex[l]--,"Tab"===e&&!t&&this._activeMenuIndex[l]<s.length&&this._activeMenuIndex[l]++,o!==this._activeMenuIndex[l]&&this._activeMenuIndex[l]>-1&&this._activeMenuIndex[l]<s.length&&!i){const e=s[this._activeMenuIndex[l]].getElementsByTagName("button"),t=1===e?.length?e[0]:null;t?.focus()}}_focusSearch(){this._searchInput?.focus()}_focusActiveLevel(){const{level:e}=this,t=this._levelsListNode,s=t?.getElementsByTagName("li");if(!e||!t||!s)return;const i=this._facilitiesListNode?.getElementsByTagName("li");this._activeMenuIndex.menuItems=i?i.length-1:-1;const l=[];for(let o=0;o<s.length;o++){const e=s[o].getElementsByTagName("button");1===e?.length&&l.push(e[0])}l.forEach(((t,s)=>{t.getAttribute("data-id")===e&&(t.focus(),this._activeMenuIndex.levels=s)}))}_onItemFocus(e){const t=e.currentTarget,s=t.getAttribute("data-list-id"),i=t.getAttribute("data-id"),l="sites"===s?this._sitesListNode:"facilities"===s?this._facilitiesListNode:"levels"===s?this._levelsListNode:null;if(!l)return;const o=l?.getElementsByTagName("li");if(!o)return;const n=[];Array.from(o).forEach((e=>{const t=e.getElementsByTagName("button");1===t?.length&&n.push(t[0])}));let a=null;switch(s){case"sites":case"facilities":a="menuItems";break;case"levels":a="levels"}if(!a)return;const r=a;n.forEach(((e,t)=>{e.getAttribute("data-id")===i&&this._activeMenuIndex[r]!==t&&(this._activeMenuIndex[r]=t)}))}};e.__decorate([i.property()],f.prototype,"_searchInput",void 0),e.__decorate([i.property()],f.prototype,"enabled",null),e.__decorate([i.property()],f.prototype,"longNames",null),e.__decorate([i.property()],f.prototype,"minimized",null),e.__decorate([i.property()],f.prototype,"pinnedLevels",null),e.__decorate([i.property()],f.prototype,"site",null),e.__decorate([i.property()],f.prototype,"facility",null),e.__decorate([i.property()],f.prototype,"level",null),e.__decorate([i.property()],f.prototype,"view",null),e.__decorate([i.property({type:d})],f.prototype,"viewModel",void 0),e.__decorate([i.property(),p.messageBundle("esri/widgets/FloorFilter/t9n/FloorFilter")],f.prototype,"messages",void 0),e.__decorate([i.property(),p.messageBundle("esri/t9n/common")],f.prototype,"messagesCommon",void 0),e.__decorate([i.property()],f.prototype,"goToOverride",null),e.__decorate([i.property()],f.prototype,"headingLevel",void 0),e.__decorate([i.property()],f.prototype,"icon",null),f=e.__decorate([a.subclass("esri.widgets.FloorFilter")],f);return f}));
