/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../intl","../core/accessorSupport/decorators/property","../core/has","../core/Logger","../core/RandomLCG","../core/accessorSupport/decorators/subclass","./Widget","./Histogram/HistogramViewModel","./support/globalCss","./support/widgetUtils","./support/decorators/messageBundle","./support/jsxFactory","../intl/substitute"],(function(e,t,r,i,a,s,n,o,l,d,u,h,c,p){"use strict";var _;const g="esri-histogram",b={base:g,horizontalLayout:`${g}--horizontal`,verticalLayout:`${g}--vertical`,content:`${g}__content`,svg:`${g}__svg`,bar:`${g}__bar`,bars:`${g}__bars`,label:`${g}__label`,dataLines:`${g}__data-lines`,dataLinesSubgroup:`${g}__data-lines-subgroup`,dataLine:`${g}__data-line`,averageLabel:`${g}__average-label`,averageDataLine:`${g}__average-data-line`,averageSymbol:`${g}__average-symbol`};let m=_=class extends o{constructor(e,t){super(e,t),this._bgFillId=`${this.id}-bg-fill`,this._containerNode=null,this._containerDimensions={width:0,height:0},this._defaultBarColor="#d8d8d8",this.barCreatedFunction=null,this.dataLines=null,this.dataLineCreatedFunction=null,this.dataLineUpdatedFunction=null,this.messages=null,this.viewModel=new l}get average(){return this.viewModel.average}set average(e){this.viewModel.average=e}get bins(){return this.viewModel.bins}set bins(e){this.viewModel.bins=e}get icon(){return"graph-histogram"}set icon(e){this._overrideIfSome("icon",e)}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}get labelFormatFunction(){return this.viewModel.labelFormatFunction}set labelFormatFunction(e){this.viewModel.labelFormatFunction=e}set layout(e){"vertical"!==e&&(e="horizontal"),this._set("layout",e)}get max(){return this.viewModel.max}set max(e){this.viewModel.max=e}get min(){return this.viewModel.min}set min(e){this.viewModel.min=e}get state(){return this.viewModel.state}static fromHistogramResult(e){const{bins:t,maxValue:r,minValue:i}=e;return new _({bins:t,max:r,min:i})}render(){const{label:e,layout:t,state:r}=this,i=this.classes(b.base,d.globalCss.widget,"horizontal"===t?b.horizontalLayout:b.verticalLayout,"disabled"===r?d.globalCss.disabled:null);return c.tsx("div",{afterCreate:this._afterContainerNodeCreate,"aria-label":e,bind:this,class:i},"ready"===r?this._renderContent():null)}_renderContent(){if(!this._containerNode)return;const e=this._bgFillId,t=`clip-path: url(#${e})`;return c.tsx("div",{class:b.content},c.tsx("svg",{class:b.svg,xmlns:"http://www.w3.org/2000/svg"},c.tsx("defs",null,this._renderFillDefinition(e)),c.tsx("g",{style:t},this._renderBarsGroup()),this._renderLinesGroup()))}_renderBarsGroup(){return c.tsx("g",{class:this.classes(b.bars)},this._renderBars())}_renderBars(){const{layout:e,viewModel:{binRange:t,range:r}}=this;if(!t||!r)return;const i=t/r,{width:a,height:s}=this._containerDimensions;if(0===s&&0===a)return;if(0===s&&0!==a)return void this.scheduleRender();const[n,o]="vertical"===e?[s*i,a]:[s,a*i];return this._getBarDimensions(n,o).map((([e,t],r)=>this._renderBar(r,e,t)))}_renderBar(e,t,r){const{bins:i,layout:a,max:s,messages:n,viewModel:{range:o}}=this;if(!i||null==s)return;const{width:l,height:d}=this._containerDimensions,u=i.slice()[e],{count:h,maxValue:_,minValue:g}=u,m=s-_,[v,y]="vertical"===a?[0,m*(d/o)]:[l-r-m*(l/o),d-t],L=p.substitute(n.barLabel,{count:h,maxValue:_,minValue:g});return c.tsx("rect",{afterCreate:this._afterBarCreate,"aria-label":L,bind:this,class:b.bar,"data-index":e,fill:this._defaultBarColor,height:t,role:"img","shape-rendering":"crispEdges","stroke-width":"0",width:r,x:v,y})}_renderLinesGroup(){return c.tsx("g",{class:this.classes(b.dataLines)},this._renderAverageLine(),this._renderCustomLines())}_renderAverageLine(){const{average:e}=this;if(null==e)return;const t=[c.tsx("tspan",{class:this.classes(b.averageSymbol)},"x̄ "),c.tsx("tspan",{class:this.classes(b.averageLabel)},this.labelFormatFunction?this.labelFormatFunction(e,"average"):e)];return c.tsx("g",{afterCreate:this._afterLinesSubgroupCreate,afterUpdate:this._afterLinesSubgroupUpdate,bind:this,class:this.classes(b.dataLinesSubgroup)},c.tsx("title",{key:"title"},e),this._renderLine(e,this.classes(b.averageDataLine)),this._renderLabel({label:t,value:e}))}_renderCustomLines(){if(this.dataLines?.length)return this.dataLines.map(((e,t)=>this._renderLineSubgroup(e,t)))}_renderLineSubgroup(e,t){const{value:r}=e;return c.tsx("g",{afterCreate:this._afterLinesSubgroupCreate,afterUpdate:this._afterLinesSubgroupUpdate,bind:this,class:this.classes(b.dataLinesSubgroup),"data-index":t},c.tsx("title",{key:"title"},r),this._renderLine(r),this._renderLabel(e))}_renderLine(e,t){const[r,i,a,s]=this._getLinePosition(e);return c.tsx("line",{class:this.classes(b.dataLine,t),"shape-rendering":"crispEdges",x1:r,x2:i,y1:a,y2:s})}_renderLabel(e,t){const{label:r,value:i}=e,[a,s]=this._getLabelPosition(i),n=2;return c.tsx("text",{class:this.classes(b.label,t),"text-anchor":"end",transform:"horizontal"===this.layout?"rotate(270)":null,x:a,y:s-n},r??"")}_renderFillDefinition(e){const{width:t,height:r}=this._containerDimensions;return c.tsx("clipPath",{id:e},c.tsx("rect",{height:r,width:t,x:"0",y:"0"}))}_afterContainerNodeCreate(e){this._containerNode=e,this.addHandles(u.onResize(e,(e=>{const{width:t,height:r}=e.contentRect;this._containerDimensions={width:t,height:r}})))}_getIndexFromElement(e){const t=e.dataset?.index,r=e.getAttribute("data-index");return null!=t?parseInt(t,10):null!=r?parseInt(r,10):null}_afterBarCreate(e){if(this.barCreatedFunction){const t=this._getIndexFromElement(e)??-1;this.barCreatedFunction(t,e)}}_afterLinesSubgroupCreate(e){if(this.dataLineCreatedFunction){const t=this._getIndexFromElement(e),r=e.childNodes[1],i=e.childNodes[2]?e.childNodes[2]:null;this.dataLineCreatedFunction(r,i,t)}}_afterLinesSubgroupUpdate(e){if(this.dataLineUpdatedFunction){const t=this._getIndexFromElement(e),r=e.childNodes[1],i=e.childNodes[2]?e.childNodes[2]:null;this.dataLineUpdatedFunction(r,i,t)}}_getBarDimensions(e,t){const{bins:r,layout:i}=this,a=r?r.map((e=>e.count)):[],s=Math.max.apply(Math,a);return a.map((r=>"vertical"===i?[e/a.length,0!==s?r/s*t:0]:[0!==s?r/s*e:0,t/a.length]))}_getLinePosition(e){const{layout:t,min:r,viewModel:{range:i}}=this;if(null==r)return[0,0,0,0];const a=Math.round((e-r)/i*100)/100,{width:s,height:n}=this._containerDimensions,[o,l]=[a*s||1,n-a*n||1];return"vertical"===t?[0,"100%",l,l]:[o,o,"100%",0]}_getLabelPosition(e){const{layout:t,min:r,viewModel:{range:i}}=this;if(null==r)return[0,0];const a=Math.round((e-r)/i*100)/100,{width:s,height:n}=this._containerDimensions;return"vertical"===t?[s,n-a*n]:[0,a*s]}};e.__decorate([r.property()],m.prototype,"_bgFillId",void 0),e.__decorate([r.property()],m.prototype,"_containerNode",void 0),e.__decorate([r.property()],m.prototype,"_containerDimensions",void 0),e.__decorate([r.property()],m.prototype,"_defaultBarColor",void 0),e.__decorate([r.property()],m.prototype,"average",null),e.__decorate([r.property()],m.prototype,"barCreatedFunction",void 0),e.__decorate([r.property()],m.prototype,"dataLines",void 0),e.__decorate([r.property()],m.prototype,"dataLineCreatedFunction",void 0),e.__decorate([r.property()],m.prototype,"dataLineUpdatedFunction",void 0),e.__decorate([r.property()],m.prototype,"icon",null),e.__decorate([r.property()],m.prototype,"label",null),e.__decorate([r.property()],m.prototype,"labelFormatFunction",null),e.__decorate([r.property({value:"horizontal"})],m.prototype,"layout",null),e.__decorate([r.property()],m.prototype,"max",null),e.__decorate([r.property(),h.messageBundle("esri/widgets/Histogram/t9n/Histogram")],m.prototype,"messages",void 0),e.__decorate([r.property()],m.prototype,"min",null),e.__decorate([r.property({readOnly:!0})],m.prototype,"state",null),e.__decorate([r.property()],m.prototype,"viewModel",void 0),m=_=e.__decorate([n.subclass("esri.widgets.Histogram")],m);return m}));
