/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../Color","../core/reactiveUtils","../core/accessorSupport/decorators/property","../core/accessorSupport/ensureType","../core/RandomLCG","../core/has","../core/accessorSupport/decorators/subclass","./Histogram","./Slider","./Widget","./HistogramRangeSlider/HistogramRangeSliderViewModel","./smartMapping/support/utils","./support/globalCss","./support/widgetUtils","./support/decorators/messageBundle","./support/jsxFactory"],(function(e,t,r,i,a,s,o,n,l,d,h,u,p,c,g,_,m){"use strict";const v="esri-histogram-range-slider",b={base:v,sliderContainer:`${v}__slider-container`,histogramContainer:`${v}__histogram-container`,rangeTypePrefix:`${v}__range-type--`};let y=class extends h{constructor(e,r){super(e,r),this._barElements=[],this._histogram=null,this._slider=null,this.barCreatedFunction=null,this.dataLines=null,this.dataLineCreatedFunction=null,this.excludedBarColor=new t("#d7e5f0"),this.includedBarColor=new t("#599dd4"),this.messages=null,this.standardDeviationCount=1,this.viewModel=new u}initialize(){const{average:e,bins:t,hasTimeData:i,max:a,min:s,viewModel:o}=this;this._updateBarFill=this._updateBarFill.bind(this),this._histogram=new l({average:e,bins:t,barCreatedFunction:(e,t)=>{0===e&&(this._barElements=[]),this._barElements.push(t),this._updateBarFill(e,t),this.barCreatedFunction&&this.barCreatedFunction(e,t)},dataLines:this._getDataLines(),dataLineCreatedFunction:(e,t)=>{this.dataLineCreatedFunction&&this.dataLineCreatedFunction(e,t)},labelFormatFunction:this.labelFormatFunction,layout:"horizontal",max:a,min:s}),this._slider=new d({labelFormatFunction:this.labelFormatFunction,layout:"horizontal",visibleElements:{labels:!0,rangeLabels:!0},rangeLabelInputsEnabled:!i,viewModel:o}),this.addHandles([this._slider.on("max-change",(e=>this.emit("max-change",e))),this._slider.on("min-change",(e=>this.emit("min-change",e))),this._slider.on("segment-drag",(e=>{this._updateBarFills(),this.emit("segment-drag",e)})),this._slider.on("thumb-change",(e=>{this._updateBarFills(),this.emit("thumb-change",e)})),this._slider.on("thumb-drag",(e=>{this._updateBarFills(),this.emit("thumb-drag",e)})),r.watch((()=>this.bins),(e=>{if(e&&this._histogram.bins){const t=this._histogram.bins.length-e.length;this._barElements.splice(-t,t)}else this._barElements=[];this._histogram.set({bins:e}),this._updateBarFills(),this.scheduleRender()})),r.watch((()=>[this.max,this.min,this.rangeType,this.values]),(([e,t])=>{this._histogram.set({max:e,min:t}),this._updateBarFills(),this.scheduleRender()})),r.watch((()=>[this.average,this.dataLines,this.standardDeviation,this.standardDeviationCount]),(([e])=>{this._histogram.set({average:e,dataLines:this._getDataLines()})})),r.watch((()=>this.labelFormatFunction),(e=>{this._histogram.set({labelFormatFunction:e})})),r.watch((()=>this.hasTimeData),(e=>{this._slider.set({rangeLabelInputsEnabled:!e})}))])}get average(){return this.viewModel.average}set average(e){this.viewModel.average=e}get bins(){return this.viewModel.bins}set bins(e){this.viewModel.bins=e}get hasTimeData(){return this.viewModel.hasTimeData}set hasTimeData(e){this.viewModel.hasTimeData=e}get icon(){return"arrow-double-horizontal"}set icon(e){this._overrideIfSome("icon",e)}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}get labelFormatFunction(){return this.viewModel.labelFormatFunction}set labelFormatFunction(e){this.viewModel.labelFormatFunction=e}get max(){return this.viewModel.max}set max(e){this.viewModel.max=e}get min(){return this.viewModel.min}set min(e){this.viewModel.min=e}get precision(){return this.viewModel.precision}set precision(e){this.viewModel.precision=e}get rangeType(){return this.viewModel.rangeType}set rangeType(e){this.viewModel.rangeType=e}get standardDeviation(){return this.viewModel.standardDeviation}set standardDeviation(e){this.viewModel.standardDeviation=e}get values(){return this.viewModel.values}set values(e){this.viewModel.values=e}generateWhereClause(e){return this.viewModel.generateWhereClause(e)}render(){const{rangeType:e,viewModel:t,label:r}=this,i=this.classes(b.base,c.globalCss.widget,`${b.rangeTypePrefix}${e}`,"disabled"===t.state?c.globalCss.disabled:null);return m.tsx("div",{"aria-label":r,class:i},"disabled"===t.state?null:this._renderContent())}_renderContent(){return[this._renderHistogram(),this._renderSlider()]}_renderSlider(){return m.tsx("div",{class:b.sliderContainer,key:`${this.id}-slider-container`},this._slider.render())}_renderHistogram(){return m.tsx("div",{class:b.histogramContainer},this._histogram.render())}_getDataLines(){return[...this._getStandardDeviationDataLines(),...this.dataLines||[]]}_getStandardDeviationDataLines(){const{average:e,standardDeviation:t,standardDeviationCount:r}=this;return p.getDeviationValues(t,e,r).map((e=>({value:e})))}_updateBarFills(){this._barElements.forEach(((e,t)=>this._updateBarFill(t,e)))}_updateBarFill(e,t){t.setAttribute("fill",this._getFillForBar(e)?.toHex()??"")}_getFillForBar(e){const{bins:t,rangeType:r,values:i}=this;if(-1===e||!t?.length||!r||!i?.length)return null;const a=t[e];if(!a)return null;const{maxValue:s,minValue:o}=a,n=s-o,l=i[0]>o&&i[0]<s;switch(r){case"equal":case"not-equal":return this.includedBarColor;case"less-than":case"at-most":return l?this._getBlendedColor((i[0]-o)/n):s<=i[0]?this.includedBarColor:this.excludedBarColor;case"greater-than":case"at-least":return l?this._getBlendedColor(1-(i[0]-o)/n):o>=i[0]?this.includedBarColor:this.excludedBarColor;case"between":if(2===i.length)return i[0]>o&&i[0]<s?this._getBlendedColor(1-(i[0]-o)/n):i[1]>o&&i[1]<s?this._getBlendedColor((i[1]-o)/n):o>=i[0]&&s<=i[1]?this.includedBarColor:this.excludedBarColor;break;case"not-between":if(2===i.length)return i[0]>o&&i[0]<s?this._getBlendedColor((i[0]-o)/n):i[1]>o&&i[1]<s?this._getBlendedColor(1-(i[1]-o)/n):o>i[0]&&s<i[1]?this.excludedBarColor:this.includedBarColor}return this.includedBarColor}_getBlendedColor(e){return t.blendColors(this.excludedBarColor,this.includedBarColor,e)}};e.__decorate([i.property()],y.prototype,"average",null),e.__decorate([i.property()],y.prototype,"barCreatedFunction",void 0),e.__decorate([i.property()],y.prototype,"bins",null),e.__decorate([i.property()],y.prototype,"dataLines",void 0),e.__decorate([i.property()],y.prototype,"dataLineCreatedFunction",void 0),e.__decorate([i.property({type:t,json:{type:[a.Integer],write:!0}})],y.prototype,"excludedBarColor",void 0),e.__decorate([i.property()],y.prototype,"hasTimeData",null),e.__decorate([i.property({type:t,json:{type:[a.Integer],write:!0}})],y.prototype,"includedBarColor",void 0),e.__decorate([i.property()],y.prototype,"icon",null),e.__decorate([i.property()],y.prototype,"label",null),e.__decorate([i.property()],y.prototype,"labelFormatFunction",null),e.__decorate([i.property()],y.prototype,"max",null),e.__decorate([i.property(),_.messageBundle("esri/widgets/HistogramRangeSlider/t9n/HistogramRangeSlider")],y.prototype,"messages",void 0),e.__decorate([i.property()],y.prototype,"min",null),e.__decorate([i.property()],y.prototype,"precision",null),e.__decorate([i.property()],y.prototype,"rangeType",null),e.__decorate([i.property()],y.prototype,"standardDeviation",null),e.__decorate([i.property()],y.prototype,"standardDeviationCount",void 0),e.__decorate([i.property()],y.prototype,"values",null),e.__decorate([i.property()],y.prototype,"viewModel",void 0),y=e.__decorate([n.subclass("esri.widgets.HistogramRangeSlider")],y);return y}));
