/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../core/Collection","../core/deprecate","../core/Identifiable","../core/Logger","../core/ReactiveMap","../core/reactiveUtils","../core/accessorSupport/decorators/property","../core/has","../core/RandomLCG","../core/accessorSupport/decorators/subclass","./Widget","./LayerList/css","./LayerList/LayerListItem","./LayerList/LayerListViewModel","./LayerList/LayerListVisibleElements","./LayerList/ListItem","./LayerList/support/layerListUtils","../chunks/componentsUtils","./support/globalCss","./support/listUtils","./support/widgetUtils","./support/decorators/messageBundle","./support/decorators/vmEvent","./support/jsxFactory"],(function(e,t,o,i,s,r,l,a,n,d,c,p,h,m,y,_,u,g,L,I,v,f,b,w,E,C){"use strict";const F=e=>Object.freeze(Object.defineProperty({__proto__:null,default:e},Symbol.toStringTag,{value:"Module"})),M=o.ofType(g);let O=class extends(s.IdentifiableMixin(h)){constructor(e,t){super(e,t),this._activeItem=null,this._tooltipReferenceMap=new l,this._focusRootFlowItem=!1,this._focusPanelFlowItem=!1,this._focusLayerFlowItem=null,this._layerListMap=new l,this._lastDragDetail=null,this._selectedDragItemLayerUid=null,this._rootGroupUid=`operational-${this.uid}`,this._openedLayersController=null,this.catalogLayerList=null,this.catalogOptions=null,this.collapsed=!1,this.dragEnabled=!1,this.filterPlaceholder="",this.filterText="",this.headingLevel=2,this.knowledgeGraphOptions=null,this.layerTablesEnabled=new o(["knowledge-graph"]),this.listItemCanGiveFunction=null,this.listItemCanReceiveFunction=null,this.mapImageOptions=null,this.messages=null,this.messagesCommon=null,this.minDragEnabledItems=L.minDragEnabledItems,this.minFilterItems=L.minFilterItems,this.openedLayers=new o,this.openedLayerLists=new o,this.selectedItems=new M,this.selectionMode="none",this.tableList=null,this.tileOptions=null,this.viewModel=new _,this.visibilityAppearance="default",this.visibleElements=new u,this._canMove=({dragEl:e,fromEl:t,toEl:o},i)=>{const s="pull"===i?this.listItemCanGiveFunction:this.listItemCanReceiveFunction,r=L.getItem(e);if(!r?.sortable)return!1;const l=L.getItem(t),a=L.getLayerType(t),n=L.getItem(o),d=L.getLayerType(o),c=!!a&&!!d&&a===d,p={selected:r,from:l,to:n},h=t.group,m=o.group,y=l?.layer?.type??"",_=n?.layer?.type??"",u=new Set(["map-image","catalog","knowledge-graph"]),g="sublayer";return h&&m&&"function"==typeof s?s.call(null,p):c&&!u.has(y)&&!u.has(_)&&r?.layer?.type!==g},this._onCatalogOpen=e=>{this.openedLayers.push(e.layer.parent),this._focusLayerFlowItem=e.layer.uid},this._onTablesOpen=e=>{this.openedLayers.push(e.layer),this._focusLayerFlowItem=e.layer.uid},this._onPanelOpen=()=>{this._focusPanelFlowItem=!0},this._onSelectedDragItemLayerUidChange=e=>{this._selectedDragItemLayerUid=e},this._onTooltipReferenceChange=(e,t)=>{t?this._tooltipReferenceMap.set(e,t):this._tooltipReferenceMap.delete(e)},this._onTriggerAction=(e,t)=>{this.triggerAction(e,t)},this._clearActiveItem=()=>{this._activeItem=null},this._setActiveItem=e=>{if("default"!==this.visibilityAppearance)return;const t=Array.from(e.composedPath()).find((e=>e.classList?.contains(m.css.item)));this._activeItem=L.getItem(t)},this._onCalciteListOrderChange=e=>{const{_lastDragDetail:t}=this,{toEl:o,fromEl:i,dragEl:s,newIndex:r}=e;if(i&&o&&!(t?.newIndex===r&&t?.dragEl===s&&t?.toEl===o&&t?.fromEl===i))if(this._lastDragDetail=e,i!==o)this._moveLayerFromChildList({toEl:o,fromEl:i,dragEl:s,newIndex:r});else{const e=Array.from(i.children).filter((e=>e?.matches("calcite-list-item"))).map((e=>e.value));this._sortLayers(i,e)}}}initialize(){this.addHandles(a.on((()=>this.openedLayers),"change",(()=>this._handleOpenedLayersChange()),a.initial))}loadDependencies(){return I.loadCalciteComponents({button:()=>new Promise(((t,o)=>e(["../chunks/calcite-button"],t,o))),flow:()=>new Promise(((t,o)=>e(["../chunks/calcite-flow"],t,o))),"flow-item":()=>new Promise(((t,o)=>e(["../chunks/calcite-flow-item"],t,o))),list:()=>new Promise(((t,o)=>e(["../chunks/calcite-list"],t,o))),notice:()=>new Promise(((t,o)=>e(["../chunks/calcite-notice"],t,o))),tooltip:()=>new Promise(((t,o)=>e(["../chunks/calcite-tooltip"],t,o)))})}destroy(){this._destroyOpenedLayerLists(),this._tooltipReferenceMap.clear()}get _totalItems(){return this.viewModel.operationalItems.flatten((e=>e.children.filter((e=>"catalog-dynamic-group"!==e.layer.type)))).length}get _dragEnabled(){return this._totalItems>=this.minDragEnabledItems&&this.dragEnabled}get _filterEnabled(){return this._totalItems>=this.minFilterItems&&this.visibleElements.filter}get _renderedOpenLayerFlowItems(){return this.openedLayers.toArray().map((e=>this._renderLayerFlowItem(e)))}get icon(){return"layers"}set icon(e){this._overrideIfSome("icon",e)}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}get listItemCreatedFunction(){return this.viewModel.listItemCreatedFunction}set listItemCreatedFunction(e){this.viewModel.listItemCreatedFunction=e}get multipleSelectionEnabled(){return i.deprecatedProperty(r.getLogger(this),"multipleSelectionEnabled",{replacement:"selectionMode",version:"4.29",warnOnce:!0}),"multiple"===this.selectionMode}set multipleSelectionEnabled(e){i.deprecatedProperty(r.getLogger(this),"multipleSelectionEnabled",{replacement:"selectionMode",version:"4.29",warnOnce:!0}),this.selectionMode=e?"multiple":this.selectionEnabled?"single":"none"}get operationalItems(){return this.viewModel.operationalItems}set operationalItems(e){this.viewModel.operationalItems=e}get selectionEnabled(){return i.deprecatedProperty(r.getLogger(this),"selectionEnabled",{replacement:"selectionMode, dragEnabled",version:"4.29",warnOnce:!0}),"none"!==this.selectionMode&&this.dragEnabled}set selectionEnabled(e){i.deprecatedProperty(r.getLogger(this),"selectionEnabled",{replacement:"selectionMode, dragEnabled",version:"4.29",warnOnce:!0}),this.dragEnabled=e,this.selectionMode=e?this.multipleSelectionEnabled?"multiple":"single":"none"}get view(){return this.viewModel.view}set view(e){this.viewModel.view=e}triggerAction(e,t){return this.viewModel.triggerAction(e,t)}render(){const e=this.viewModel?.state,t={[v.globalCss.hidden]:"loading"===e,[v.globalCss.disabled]:"disabled"===e},o=this.operationalItems?.filter((e=>!e.hidden&&(this.visibleElements.errors||!e.error)));return C.tsx("div",{class:this.classes(m.css.base,v.globalCss.widget,v.globalCss.panel,t)},o?.length?[this._renderItemTooltips(o),this._renderItems(o)]:this._renderNoItems())}async _createFlowList(e,t){const{_layerListMap:o}=this,i=o.get(e);if(i)return i;const s="catalog"===e.type?await this._createCatalogLayerList(e):await this._createTableList(e);return t.aborted||o.set(e,s),s}async _handleOpenedLayersChange(){const{_layerListMap:e,openedLayers:t,openedLayerLists:o}=this;this._openedLayersController?.abort();const i=new AbortController,{signal:s}=i;this._openedLayersController=i,e.forEach(((o,i)=>{t.includes(i)||(o.destroy(),e.delete(i))}));const r=await Promise.all(t.map((e=>this._createFlowList(e,s))));if(s.aborted)return;o.removeAll(),o.addMany(r);const l=o.at(-1);l?"catalogLayer"in l?(this._set("catalogLayerList",l),this._set("tableList",null)):(this._set("catalogLayerList",null),this._set("tableList",l)):(this._set("catalogLayerList",null),this._set("tableList",null))}_destroyOpenedLayerLists(){this.openedLayerLists.destroyAll(),this.openedLayers.removeAll(),this._layerListMap.clear()}_renderItemTooltip(e){const{_tooltipReferenceMap:t,messages:o}=this;return e?C.tsx("calcite-tooltip",{key:`tooltip-${e.layer.uid}`,referenceElement:t.get(e.layer.uid)},o.layerIncompatibleTooltip):null}_renderItemTooltipNodes(e){return e.incompatible?this._renderItemTooltip(e):e.children?.filter((e=>!e.hidden)).toArray().map((e=>this._renderItemTooltipNodes(e)))}_renderItemTooltips(e){return e?.toArray().map((e=>this._renderItemTooltipNodes(e)))}_renderNoItemsMessage(){return C.tsx("div",{slot:"message"},this.messages.noItemsToDisplay)}_renderNoItems(){return C.tsx("div",{class:m.css.itemMessage,key:"esri-layer-list__no-items"},C.tsx("calcite-notice",{icon:"information",kind:"info",open:!0,width:"full"},this._renderNoItemsMessage()))}async _createCatalogLayerList(t){const{default:o}=await new Promise(((t,o)=>e(["./CatalogLayerList"],(e=>t(F(e))),o))),{headingLevel:i,catalogOptions:s,view:r,filterPlaceholder:l,listItemCreatedFunction:a,minFilterItems:n,selectionMode:d,visibilityAppearance:c,_onCatalogOpen:p,_onTablesOpen:h,layerTablesEnabled:m}=this;return new o({headingLevel:i,view:r,filterPlaceholder:l,listItemCreatedFunction:a,minFilterItems:n,selectionMode:d,visibilityAppearance:c,...s,catalogLayer:t,layerTablesEnabled:m,onCatalogOpen:p,onTablesOpen:h})}_getTableListParams(e){switch(e.type){case"knowledge-graph":return{...this.knowledgeGraphOptions,tables:e.tables};case"map-image":return{...this.mapImageOptions,tables:e.subtables};case"tile":return{...this.tileOptions,tables:e.subtables};default:return null}}async _createTableList(t){const{default:o}=await new Promise(((t,o)=>e(["./TableList"],(e=>t(F(e))),o))),{headingLevel:i,selectionMode:s,dragEnabled:r}=this;return new o({headingLevel:i,selectionMode:s,dragEnabled:r,...this._getTableListParams(t)})}_renderLayerFlowItem(e){const{messages:t,openedLayers:o}=this,i=e.title||this.messages.untitledLayer;return C.tsx("calcite-flow-item",{afterCreate:this._focusLayerFlowItemNode,afterUpdate:this._focusLayerFlowItemNode,bind:this,"data-layer-uid":e.uid,description:i,heading:t["catalog"===e.type?"catalogLayers":"tables"],headingLevel:this.headingLevel,key:`flow-layer-list-${e.uid}`,onCalciteFlowItemBack:e=>{e.preventDefault(),o.pop();const t=o.at(-1);t?this._focusLayerFlowItem=t.uid:this._focusRootFlowItem=!0}},this._layerListMap.get(e)?.render())}_renderPanelFlowItems(e){return e?e.flatten((e=>e.children)).filter((({hidden:e,panel:t})=>!e&&t?.open&&!t.disabled&&t.flowEnabled)).toArray().map((({title:e,panel:t})=>{const o=()=>this._handlePanelFlowItemBack(t);return C.tsx("calcite-flow-item",{afterCreate:this._focusPanelFlowItemNode,afterUpdate:this._focusPanelFlowItemNode,bind:this,description:e,heading:t.title,headingLevel:this.headingLevel,key:`flow-panel-${t.uid}`,onCalciteFlowItemBack:e=>{e.preventDefault(),o()}},t.render(),C.tsx("calcite-button",{appearance:"transparent",onclick:o,slot:"footer-actions",width:"full"},this.messagesCommon.back))})):[]}_handlePanelFlowItemBack(e){e.open=!1,this._focusRootFlowItem=!0}_focusRootFlowItemNode(e){this._focusRootFlowItem&&(this._focusRootFlowItem=!1,b.setFocus(e))}_focusLayerFlowItemNode(e){this._focusLayerFlowItem===e.dataset.layerUid&&(this._focusLayerFlowItem=null,b.setFocus(e))}_focusPanelFlowItemNode(e){this._focusPanelFlowItem&&(this._focusPanelFlowItem=!1,b.setFocus(e))}_renderItems(e){const{visible:t,collapsed:o,_filterEnabled:i,_rootGroupUid:s,visibleElements:{closeButton:r,collapseButton:l,heading:a,flow:n},_dragEnabled:d,selectionMode:c,filterText:p,filterPlaceholder:h,messages:y}=this,_=[C.tsx("calcite-flow-item",{afterCreate:this._focusRootFlowItemNode,afterUpdate:this._focusRootFlowItemNode,bind:this,closable:r,closed:!t,collapsed:o,collapsible:l,heading:a?y.widgetLabel:void 0,headingLevel:this.headingLevel,key:"root-flow-item",onCalciteFlowItemClose:()=>this.visible=!1},C.tsx("calcite-list",{afterCreate:e=>{e.addEventListener("focusin",this._setActiveItem),e.addEventListener("focusout",this._clearActiveItem)},afterRemoved:e=>{e.removeEventListener("focusin",this._setActiveItem),e.removeEventListener("focusout",this._clearActiveItem)},canPull:e=>this._canMove(e,"pull"),canPut:e=>this._canMove(e,"put"),"data-layer-type":s,dragEnabled:d,filterEnabled:i,filterPlaceholder:h,filterProps:f.calciteListFilterProps,filterText:i?p:"",group:s,key:"root-list",label:y.widgetLabel,onmouseleave:this._clearActiveItem,onmouseover:this._setActiveItem,selectionAppearance:"border",selectionMode:c,onCalciteListChange:e=>this._handleCalciteListChange(e),onCalciteListDragEnd:e=>this._handleCalciteListDragEnd(e.detail),onCalciteListFilter:e=>this.filterText=e.target?.filterText??"",onCalciteListOrderChange:e=>this._onCalciteListOrderChange(e.detail)},e?.toArray().map((e=>this._renderItem(e))),e?.length&&i?C.tsx("div",{class:m.css.filterNoResults,slot:"filter-no-results"},C.tsx("calcite-notice",{kind:"info",open:!0,width:"full"},this._renderNoItemsMessage())):null)),this._renderPanelFlowItems(e),this._renderedOpenLayerFlowItems];return t?n?C.tsx("calcite-flow",{key:"root-flow"},_):_:null}_renderItem(e,t,o){return C.tsx(y,{activeItem:this._activeItem,canMove:this._canMove,css:m.css,dragEnabled:this.dragEnabled,item:e,key:`layerListItem-${e.layer.uid}`,layerTablesEnabled:this.layerTablesEnabled,listModeDisabled:this.viewModel.listModeDisabled,messages:this.messages,messagesCommon:this.messagesCommon,parent:t,parentTitles:o,rootGroupUid:this._rootGroupUid,selectedDragItemLayerUid:this._selectedDragItemLayerUid,selectedItems:this.selectedItems,selectionMode:this.selectionMode,visibilityAppearance:this.visibilityAppearance,visibleElements:this.visibleElements,onAction:this._onTriggerAction,onCatalogOpen:this._onCatalogOpen,onPanelOpen:this._onPanelOpen,onSelectedDragItemLayerUidChange:this._onSelectedDragItemLayerUidChange,onTablesOpen:this._onTablesOpen,onTooltipReferenceChange:this._onTooltipReferenceChange})}_moveLayerFromChildList({toEl:e,fromEl:t,dragEl:o,newIndex:i}){const s=L.getItem(o),r=L.getItem(e),l=L.getItem(t);this.viewModel.moveListItem(s,l,r,i)}_handleCalciteListDragEnd(e){const{fromEl:t,dragEl:o,oldIndex:i}=e;t.insertBefore(o,t.children[i])}_sortLayers(e,t){if(e)if(e.group===this._rootGroupUid)L.sortLayersToIds(this.view?.map?.layers,t);else{const o=L.getItem(e);if(!o)return;L.sortChildLayersToIds(o,t)}}_handleCalciteListChange(e){const{selectionMode:t,selectedItems:o}=this;if("none"===t)return;const i=e.target.selectedItems.map((e=>L.getItem(e))).filter(Boolean);o.removeAll(),o.addMany(i)}};t.__decorate([n.property()],O.prototype,"_activeItem",void 0),t.__decorate([n.property()],O.prototype,"_tooltipReferenceMap",void 0),t.__decorate([n.property()],O.prototype,"_focusRootFlowItem",void 0),t.__decorate([n.property()],O.prototype,"_focusPanelFlowItem",void 0),t.__decorate([n.property()],O.prototype,"_focusLayerFlowItem",void 0),t.__decorate([n.property()],O.prototype,"_layerListMap",void 0),t.__decorate([n.property()],O.prototype,"_totalItems",null),t.__decorate([n.property()],O.prototype,"_dragEnabled",null),t.__decorate([n.property()],O.prototype,"_filterEnabled",null),t.__decorate([n.property()],O.prototype,"_renderedOpenLayerFlowItems",null),t.__decorate([n.property({readOnly:!0})],O.prototype,"catalogLayerList",void 0),t.__decorate([n.property()],O.prototype,"catalogOptions",void 0),t.__decorate([n.property()],O.prototype,"collapsed",void 0),t.__decorate([n.property()],O.prototype,"dragEnabled",void 0),t.__decorate([n.property()],O.prototype,"filterPlaceholder",void 0),t.__decorate([n.property()],O.prototype,"filterText",void 0),t.__decorate([n.property()],O.prototype,"headingLevel",void 0),t.__decorate([n.property()],O.prototype,"icon",null),t.__decorate([n.property()],O.prototype,"knowledgeGraphOptions",void 0),t.__decorate([n.property()],O.prototype,"label",null),t.__decorate([n.property()],O.prototype,"layerTablesEnabled",void 0),t.__decorate([n.property()],O.prototype,"listItemCanGiveFunction",void 0),t.__decorate([n.property()],O.prototype,"listItemCanReceiveFunction",void 0),t.__decorate([n.property()],O.prototype,"listItemCreatedFunction",null),t.__decorate([n.property()],O.prototype,"mapImageOptions",void 0),t.__decorate([n.property(),w.messageBundle("esri/widgets/LayerList/t9n/LayerList")],O.prototype,"messages",void 0),t.__decorate([n.property(),w.messageBundle("esri/t9n/common")],O.prototype,"messagesCommon",void 0),t.__decorate([n.property()],O.prototype,"minDragEnabledItems",void 0),t.__decorate([n.property()],O.prototype,"minFilterItems",void 0),t.__decorate([n.property()],O.prototype,"multipleSelectionEnabled",null),t.__decorate([n.property({readOnly:!0})],O.prototype,"openedLayers",void 0),t.__decorate([n.property({readOnly:!0})],O.prototype,"openedLayerLists",void 0),t.__decorate([n.property()],O.prototype,"operationalItems",null),t.__decorate([n.property()],O.prototype,"selectionEnabled",null),t.__decorate([n.property()],O.prototype,"selectedItems",void 0),t.__decorate([n.property()],O.prototype,"selectionMode",void 0),t.__decorate([n.property({readOnly:!0})],O.prototype,"tableList",void 0),t.__decorate([n.property()],O.prototype,"tileOptions",void 0),t.__decorate([n.property()],O.prototype,"view",null),t.__decorate([E.vmEvent("trigger-action"),n.property({type:_})],O.prototype,"viewModel",void 0),t.__decorate([n.property()],O.prototype,"visibilityAppearance",void 0),t.__decorate([n.property({type:u,nonNullable:!0})],O.prototype,"visibleElements",void 0),O=t.__decorate([p.subclass("esri.widgets.LayerList")],O);return O}));
