/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../../chunks/tslib.es6","../../core/accessorSupport/decorators/property","../../core/has","../../core/Logger","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../../layers/catalog/catalogUtils","../../support/actions/actionUtils","../Widget","./support/layerListUtils","../../chunks/componentsUtils","../support/jsxFactory","../support/widgetUtils"],(function(e,t,i,n,o,r,s,a,l,c,d,p,g,u){"use strict";var y;let m=y=class extends c{constructor(e){super(e),this.dragEnabled=!1,this.listModeDisabled=!1,this.parent=null,this.parentTitles=null,this.viewModel=null,this._onActionMenuOpen=e=>{this.item.actionsOpen=e.target.open},this._setTooltipReference=e=>{this.onTooltipReferenceChange?.(this.item.layer.uid,e)},this._removeTooltipReference=()=>{this.onTooltipReferenceChange?.(this.item.layer.uid,null)}}loadDependencies(){return p.loadCalciteComponents({"action-group":()=>new Promise(((t,i)=>e(["../../chunks/calcite-action-group"],t,i))),"action-menu":()=>new Promise(((t,i)=>e(["../../chunks/calcite-action-menu"],t,i))),action:()=>new Promise(((t,i)=>e(["../../chunks/calcite-action"],t,i))),icon:()=>new Promise(((t,i)=>e(["../../chunks/calcite-icon"],t,i))),"list-item":()=>new Promise(((t,i)=>e(["../../chunks/calcite-list-item"],t,i))),list:()=>new Promise(((t,i)=>e(["../../chunks/calcite-list"],t,i))),notice:()=>new Promise(((t,i)=>e(["../../chunks/calcite-notice"],t,i)))})}render(){const e=this.parentTitles??[],{_title:t,item:i,activeItem:n,selectedDragItemLayerUid:o,selectionMode:r,selectedItems:s,messages:a,parent:l,css:c}=this,d="visibleAtCurrentTimeExtent"in i&&"layerInvisibleAtTime"in a&&!i.visibleAtCurrentTimeExtent?`${t} (${a.layerInvisibleAtTime})`:"visibleAtCurrentScale"in i&&"layerInvisibleAtScale"in a&&!i.visibleAtCurrentScale?`${t} (${a.layerInvisibleAtScale})`:t,p="parent"in i&&"catalog"===i.parent?.layer?.type,{layer:u}=i,y="visibleAtCurrentScale"in i&&!i.visibleAtCurrentScale||"visibleAtCurrentTimeExtent"in i&&!i.visibleAtCurrentTimeExtent;return g.tsx("calcite-list-item",{afterCreate:e=>this._focusSelectedDragEl(e,i),afterUpdate:e=>this._focusSelectedDragEl(e,i),class:this.classes(c.item,"itemActive"in c&&{[c.itemActive]:n===i}),"data-item":i,"data-layer-id":u.id,dragDisabled:!i.sortable||p,dragSelected:u.uid===o,id:u.uid,key:`list-item-${u.uid}`,label:t,metadata:{parentTitles:e,_title:t},open:"open"in i&&i.open,selected:"none"!==r&&s.includes(i),title:d,unavailable:y,value:u.uid,onCalciteListItemDragHandleChange:e=>this._handleCalciteListItemDragHandleChange(e,i),onCalciteListItemSelect:e=>"visible"in i&&this._handleCalciteListItemSelect(e,i,l),onCalciteListItemToggle:e=>"open"in i&&this._handleCalciteListItemToggle(e,i)},this._renderedCatalogFootprintIcon,this._renderedCatalogDynamicIcon,g.tsx("div",{class:this.classes(c.itemContent,"itemInvisible"in c&&{[c.itemInvisible]:y}),slot:"content"},t),this._renderedItemStatus,this._renderedItemToggle,this._renderedCatalogSelectNode,this._renderedItemTemporaryIcon,this._renderedChildList,this._renderedItemMessage,this._renderedPanel,this._renderedPanelAction,this._renderedActions)}get _title(){const{messages:e}=this;return this.item.title||("untitledTable"in e?e.untitledTable:e.untitledLayer)}get _renderedItemStatus(){const{item:e,parent:t,visibleElements:i,css:n}=this;if(!i.statusIndicators)return null;const{publishing:o}=e,r="updating"in e&&e.updating&&!t,s="connectionStatus"in e?e.connectionStatus:void 0,a=!!s;return g.tsx("calcite-icon",{class:this.classes(n.statusIndicator,{[n.publishing]:o},"updating"in n&&{[n.updating]:r},"connectionStatus"in n&&{[n.connectionStatus]:a},"connectionStatusConnected"in n&&{[n.connectionStatusConnected]:a&&"connected"===s}),icon:d.getStatusIcon({connectionStatus:s,publishing:o}),key:"layer-item-status",scale:"s",slot:"content-end"})}get _renderedItemTemporaryIcon(){const{item:e,visibleElements:t,css:i}=this,{layer:n}=e,o="temporaryLayerIndicators"in t&&t.temporaryLayerIndicators,r="temporaryTableIndicators"in t&&t.temporaryTableIndicators,s="persistenceEnabled"in n&&(a.isLayerFromCatalog(n)||!n.persistenceEnabled);return(o||r)&&s?g.tsx("calcite-icon",{class:i.itemTemporaryIcon,icon:"temporary",key:"temporary-icon",scale:"s",slot:"actions-start",title:this.messages.temporary}):null}get _renderedItemToggle(){const{item:e,parent:t,messages:i,visibilityAppearance:n,css:o}=this;if(!("visible"in e&&"layerVisibility"in i&&"visibleToggle"in o&&n))return null;const{visible:r}=e,s=t?.visibilityMode;if("inherited"===s)return null;const a=d.getVisibilityIcon({visible:r,exclusive:"exclusive"===s,visibilityAppearance:n}),l="checkbox"===n,c=i.layerVisibility;return g.tsx("calcite-action",{appearance:"transparent",class:o.visibleToggle,icon:l?a:void 0,key:"visibility-toggle",onclick:()=>this._toggleVisibility(e,t),scale:"s",slot:l?"actions-start":"actions-end",text:c,title:c},l?null:g.tsx("calcite-icon",{class:this.classes({[o.visibleIcon]:"exclusive"!==s&&r}),icon:a,scale:"s"}))}get _renderedPanel(){const{panel:e}=this.item;return!e?.open||e.disabled||e.flowEnabled?null:g.tsx("div",{class:this.css.itemContentBottom,key:`content-panel-${e.uid}`,slot:"content-bottom"},e.render())}get _renderedPanelAction(){const{panel:e}=this.item;if(!e?.visible)return null;const{open:t,title:i,disabled:n}=e;return g.tsx("calcite-action",{active:t,appearance:"transparent",disabled:n,icon:l.getActionIcon(e),key:`action-${e.uid}`,onclick:()=>this._togglePanel(e),scale:"s",slot:"actions-end",text:i??"",title:i??void 0},this._renderFallbackIcon(e))}get _renderedActions(){switch(this._actionsCount){case 0:return null;case 1:return this._singleAction;default:return this._renderedActionMenu}}get _renderedActionMenu(){const{item:e,messagesCommon:t}=this,i=t.options;return g.tsx("calcite-action-menu",{appearance:"transparent",key:"item-action-menu",label:t.menu,open:e.actionsOpen,overlayPositioning:"fixed",placement:"bottom-end",scale:"s",slot:"actions-end",onCalciteActionMenuOpen:this._onActionMenuOpen},g.tsx("calcite-action",{appearance:"transparent",icon:"ellipsis",scale:"s",slot:"trigger",text:i,title:i}),this._renderedActionMenuContent)}get _renderedActionMenuContent(){return this._filteredSections.toArray().map((e=>g.tsx("calcite-action-group",{key:`action-section-${e.uid}`},e.toArray().map((e=>this._renderAction({action:e,textEnabled:!0}))))))}get _renderedCatalogFootprintIcon(){const{css:e}=this,t="catalog-footprint"===this.item.layer?.type;return"itemCatalogIcon"in e&&t?g.tsx("calcite-icon",{class:e.itemCatalogIcon,icon:"footprint",key:"footprint",scale:"s",slot:"content-start"}):null}get _renderedCatalogDynamicIcon(){const{css:e}=this,t="catalog-dynamic-group"===this.item.layer?.type;return"itemCatalogIcon"in e&&t?g.tsx("calcite-icon",{class:e.itemCatalogIcon,icon:"catalog-dataset",key:"catalog-dataset",scale:"s",slot:"content-start"}):null}get _renderedCatalogSelectNode(){const{_title:e,item:t,visibleElements:i}=this;if(!("visible"in t))return;const{layer:n}=t,o="catalog-dynamic-group"===n?.type;return"catalogLayerList"in i&&i.catalogLayerList&&o?g.tsx("calcite-action",{appearance:"transparent",disabled:!n.visible,icon:"chevron-right",iconFlipRtl:!0,onclick:()=>this._triggerOnCatalogOpen(t),scale:"s",slot:"actions-end",text:e}):null}get _renderedChildList(){const{dragEnabled:e,item:t,rootGroupUid:i,listModeDisabled:n,selectionMode:o}=this;if(!("visible"in t))return;const r=[...this.parentTitles??[],t.title],{children:s,layer:a}=t,l="catalog-dynamic-group"!==a?.type&&d.listItemHasChildren(t),c=!n&&d.areChildrenHidden(a);return l||!c&&!l&&e&&"group"===a?.type?g.tsx("calcite-list",{canPull:e=>!!this.canMove&&this.canMove(e,"pull"),canPut:e=>!!this.canMove&&this.canMove(e,"put"),"data-item":t,"data-layer-type":i,dragEnabled:!!e&&(t.childrenSortable&&d.canSortSublayers(t)),group:`${i}-${a.uid}`,key:`child-list-${a.uid}`,selectionAppearance:"border",selectionMode:o},s?.filter((e=>!e.hidden)).toArray().map((e=>this._renderItem(e,t,r))),this._renderedTablesItem):null}get _hasTables(){const{layerTablesEnabled:e}=this,t=this.item.layer;if(!e||!t)return!1;switch(t.type){case"knowledge-graph":return e.includes(t.type)&&!!t.tables?.length;case"map-image":case"tile":return e.includes(t.type)&&!!t.subtables?.length;default:return!1}}get _renderedTablesItem(){const{item:e,messages:t,css:i}=this,{layer:n}=e;return"itemTableIcon"in i&&"visible"in e&&"tables"in t&&this._hasTables?g.tsx("calcite-list-item",{class:i.item,"data-layer-id":n.id,dragDisabled:!0,key:`list-item-table-list-tables-${n.uid}`,title:t.tables,onCalciteListItemSelect:()=>this._triggerOnTablesOpen(e)},g.tsx("div",{class:i.itemContent,slot:"content"},t.tables),g.tsx("calcite-icon",{class:i.itemTableIcon,icon:"table",scale:"s",slot:"content-start"}),g.tsx("calcite-icon",{flipRtl:!0,icon:"chevron-right",scale:"s",slot:"content-end"})):null}get _renderedItemMessage(){const{item:e,messages:t,css:i}=this;return e.error?g.tsx("div",{class:i.itemMessage,key:"esri-layer-list__error",slot:"content-bottom"},g.tsx("calcite-notice",{icon:"exclamation-mark-triangle",kind:"warning",open:!0,scale:"s",width:"full"},g.tsx("div",{slot:"message"},"tableError"in t?t.tableError:t.layerError))):"incompatible"in e&&e.incompatible&&"layerIncompatible"in t?g.tsx("div",{class:i.itemMessage,key:"esri-layer-list__incompatible",slot:"content-bottom"},g.tsx("calcite-notice",{afterCreate:this._setTooltipReference,afterRemoved:this._removeTooltipReference,bind:this,icon:"exclamation-mark-triangle",kind:"warning",open:!0,scale:"s",tabIndex:0,width:"full"},g.tsx("div",{slot:"message"},t.layerIncompatible))):null}get _singleAction(){return this._renderAction({action:d.getSingleAction(this._filteredSections),textEnabled:!1})}get _filteredSections(){return this.item.actionsSections.map((e=>e.filter((e=>e.visible))))}get _actionsCount(){return this.item.actionsSections.reduce(((e,t)=>e+t.length),0)}_renderAction(e){const{item:t}=this,{action:i,textEnabled:n}=e;if(!i)return null;const{active:o,disabled:r,title:s,type:a,indicator:c}=i;return g.tsx("calcite-action",{active:"toggle"===a&&i.value,appearance:"transparent",disabled:r,icon:l.getActionIcon(i),indicator:c,key:`action-${i.uid}`,loading:o,onclick:()=>this._triggerAction(t,i),scale:"s",slot:n?void 0:"actions-end",text:s??"",textEnabled:n,title:s??void 0},this._renderFallbackIcon(i))}_renderFallbackIcon(e){const{css:t}=this,{className:i,icon:n}=e;if(n)return null;const o="image"in e?e.image:void 0,r={[t.itemActionIcon]:!!i,[t.itemActionImage]:!!o};return i&&(r[i]=!0),o||i?g.tsx("span",{"aria-hidden":"true",class:this.classes(t.itemActionIcon,r),key:"icon",styles:l.getActionStyles(o)}):null}_renderItem(e,t,i=[]){return g.tsx(y,{activeItem:this.activeItem,canMove:this.canMove,css:this.css,dragEnabled:this.dragEnabled,item:e,key:`layerListItem-${e.layer.uid}`,layerTablesEnabled:this.layerTablesEnabled,listModeDisabled:this.listModeDisabled,messages:this.messages,messagesCommon:this.messagesCommon,parent:t,parentTitles:i,rootGroupUid:this.rootGroupUid,selectedDragItemLayerUid:this.selectedDragItemLayerUid,selectedItems:this.selectedItems,selectionMode:this.selectionMode,visibilityAppearance:this.visibilityAppearance,visibleElements:this.visibleElements,onAction:this.onAction,onCatalogOpen:this.onCatalogOpen,onPanelOpen:this.onPanelOpen,onSelectedDragItemLayerUidChange:this.onSelectedDragItemLayerUidChange,onTablesOpen:this.onTablesOpen,onTooltipReferenceChange:this.onTooltipReferenceChange})}_triggerAction(e,t){t&&e&&("toggle"===t.type&&(t.value=!t.value),this.onAction(t,e))}_triggerOnTablesOpen(e){e&&this.onTablesOpen&&this.onTablesOpen(e)}_triggerOnCatalogOpen(e){e&&this.onCatalogOpen?.(e)}_focusSelectedDragEl(e,t){this.selectedDragItemLayerUid===t.layer.uid&&u.setFocus(e)}_handleCalciteListItemToggle(e,t){e.stopPropagation(),t.open=e.target.open}_handleCalciteListItemDragHandleChange(e,t){e.stopPropagation();const i=e.target.dragSelected;this.onSelectedDragItemLayerUidChange?.(i?t.layer.uid:null)}_handleCalciteListItemSelect(e,t,i){d.getItem(e.target)===t&&"none"===this.selectionMode&&"inherited"!==i?.visibilityMode&&this._toggleVisibility(t,i)}_togglePanel(e){e.open=!e.open,e.open&&this.onPanelOpen()}_toggleVisibility(e,t){if(!e)return;const i=t?.visibilityMode;"exclusive"===i&&e.visible||(e.visible=!e.visible)}};m.vnodeSelector="calcite-list-item",t.__decorate([i.property()],m.prototype,"activeItem",void 0),t.__decorate([i.property()],m.prototype,"canMove",void 0),t.__decorate([i.property()],m.prototype,"css",void 0),t.__decorate([i.property()],m.prototype,"dragEnabled",void 0),t.__decorate([i.property()],m.prototype,"item",void 0),t.__decorate([i.property()],m.prototype,"layerTablesEnabled",void 0),t.__decorate([i.property()],m.prototype,"listModeDisabled",void 0),t.__decorate([i.property()],m.prototype,"messages",void 0),t.__decorate([i.property()],m.prototype,"messagesCommon",void 0),t.__decorate([i.property()],m.prototype,"onAction",void 0),t.__decorate([i.property()],m.prototype,"onPanelOpen",void 0),t.__decorate([i.property()],m.prototype,"onCatalogOpen",void 0),t.__decorate([i.property()],m.prototype,"onTablesOpen",void 0),t.__decorate([i.property()],m.prototype,"onSelectedDragItemLayerUidChange",void 0),t.__decorate([i.property()],m.prototype,"onTooltipReferenceChange",void 0),t.__decorate([i.property()],m.prototype,"parent",void 0),t.__decorate([i.property()],m.prototype,"parentTitles",void 0),t.__decorate([i.property()],m.prototype,"rootGroupUid",void 0),t.__decorate([i.property()],m.prototype,"selectionMode",void 0),t.__decorate([i.property()],m.prototype,"selectedItems",void 0),t.__decorate([i.property()],m.prototype,"selectedDragItemLayerUid",void 0),t.__decorate([i.property()],m.prototype,"visibleElements",void 0),t.__decorate([i.property()],m.prototype,"visibilityAppearance",void 0),t.__decorate([i.property()],m.prototype,"_title",null),t.__decorate([i.property()],m.prototype,"_renderedItemStatus",null),t.__decorate([i.property()],m.prototype,"_renderedItemTemporaryIcon",null),t.__decorate([i.property()],m.prototype,"_renderedItemToggle",null),t.__decorate([i.property()],m.prototype,"_renderedPanel",null),t.__decorate([i.property()],m.prototype,"_renderedPanelAction",null),t.__decorate([i.property()],m.prototype,"_renderedActions",null),t.__decorate([i.property()],m.prototype,"_renderedActionMenu",null),t.__decorate([i.property()],m.prototype,"_renderedActionMenuContent",null),t.__decorate([i.property()],m.prototype,"_renderedCatalogFootprintIcon",null),t.__decorate([i.property()],m.prototype,"_renderedCatalogDynamicIcon",null),t.__decorate([i.property()],m.prototype,"_renderedCatalogSelectNode",null),t.__decorate([i.property()],m.prototype,"_renderedChildList",null),t.__decorate([i.property()],m.prototype,"_hasTables",null),t.__decorate([i.property()],m.prototype,"_renderedTablesItem",null),t.__decorate([i.property()],m.prototype,"_renderedItemMessage",null),t.__decorate([i.property()],m.prototype,"_singleAction",null),t.__decorate([i.property()],m.prototype,"_filteredSections",null),t.__decorate([i.property()],m.prototype,"_actionsCount",null),m=y=t.__decorate([s.subclass("esri.widgets.LayerList.LayerListItem")],m);return m}));
