/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../intl","../../core/Accessor","../../core/Collection","../../core/reactiveUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/Logger","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../../core/accessorSupport/get","../../views/2d/layers/features/layerAdapters/featureReductionUtils","./support/ActiveLayerInfo","../../intl/locale"],(function(e,i,r,t,s,a,n,o,l,y,d,c,h,L){"use strict";const p={state:"state",view:"view",allLayerViews:"all-layer-views",legendProperties:"legend-properties"},u=t.ofType(h),f=new Set(["esri.layers.BuildingSceneLayer","esri.layers.CatalogLayer","esri.layers.CSVLayer","esri.layers.FeatureLayer","esri.layers.GeoJSONLayer","esri.layers.GeoRSSLayer","esri.layers.GroupLayer","esri.layers.HeatmapLayer","esri.layers.ImageryLayer","esri.layers.ImageryTileLayer","esri.layers.MapImageLayer","esri.layers.OGCFeatureLayer","esri.layers.OrientedImageryLayer","esri.layers.PointCloudLayer","esri.layers.StreamLayer","esri.layers.SceneLayer","esri.layers.SubtypeGroupLayer","esri.layers.TileLayer","esri.layers.VoxelLayer","esri.layers.WFSLayer","esri.layers.WMSLayer","esri.layers.WMTSLayer","esri.layers.WCSLayer","esri.layers.LinkChartLayer","esri.layers.catalog.CatalogFootprintLayer","esri.layers.catalog.CatalogDynamicGroupLayer","esri.layers.knowledgeGraph.KnowledgeGraphSublayer","esri.layers.KnowledgeGraphLayer"]),_="view.basemapView.baseLayerViews",w="view.groundView.layerViews",v="view.basemapView.referenceLayerViews",I=[_,w,"view.layerViews",v];let g=class extends r{constructor(e){super(e),this._layerViewByLayerId={},this._layerInfosByLayerViewId={},this._activeLayerInfosByLayerViewId={},this._activeLayerInfosWithNoParent=new t,this.activeLayerInfos=new u,this.basemapLegendVisible=!1,this.groundLegendVisible=!1,this.hideLayersNotInCurrentView=!1,this.keepCacheOnDestroy=!1,this.respectLayerDefinitionExpression=!1,this.respectLayerVisibility=!0,this.layerInfos=[],this.view=null}initialize(){this.addHandles(s.watch((()=>this.view),(()=>this._viewHandles()),s.initial),p.view),this.addHandles(L.onLocaleChange((()=>this._refresh())))}destroy(){this._destroyViewActiveLayerInfos(),this.view=null}get state(){return this.view?.ready?"ready":"disabled"}_viewHandles(){this.removeHandles(p.state),this.view&&this.addHandles(s.watch((()=>this.state),(()=>this._stateHandles()),s.initial),p.state)}_stateHandles(){this._resetAll(),"ready"===this.state&&this._watchPropertiesAndAllLayerViews()}_resetAll(){this.removeHandles([p.allLayerViews,p.legendProperties]),this._destroyViewActiveLayerInfos(),this.activeLayerInfos.removeAll()}_destroyViewActiveLayerInfos(){Object.keys(this._activeLayerInfosByLayerViewId).forEach(this._destroyViewActiveLayerInfo,this)}_destroyViewActiveLayerInfo(e){this.removeHandles(e);const i=this._activeLayerInfosByLayerViewId[e];delete this._activeLayerInfosByLayerViewId[e],i?.parent&&i.parent.children.remove(i)}_watchPropertiesAndAllLayerViews(){const{view:e}=this;if(!e)return;const{allLayerViews:i}=e;i.length&&this._refresh(),this.addHandles(i.on("change",(e=>this._allLayerViewsChangeHandle(e))),p.allLayerViews),this.addHandles(s.watch((()=>[this.layerInfos,this.basemapLegendVisible,this.groundLegendVisible]),(()=>this._propertiesChangeHandle())),p.legendProperties)}_allLayerViewsChangeHandle(e){e.moved.length?this._propertiesChangeHandle():(e.removed.forEach((e=>this._destroyViewActiveLayerInfo(e.uid))),this._refresh())}_propertiesChangeHandle(){this._destroyViewActiveLayerInfos(),this._refresh()}_refresh(){this._layerInfosByLayerViewId={},this.activeLayerInfos.removeAll(),this._generateLayerViews().filter(this._filterLayerViewsByLayerInfos,this).filter(this._isLayerViewSupported,this).forEach(this._generateActiveLayerInfo,this),this._sortActiveLayerInfos(this.activeLayerInfos)}_sortActiveLayerInfos(e){const i=this.view;if(e.length<2||!i)return;const r=[];e.forEach((i=>{if(!i.parent){const t=i.layer.parent,s=t&&"uid"in t&&this._layerViewByLayerId[t.uid],a=s&&this._activeLayerInfosByLayerViewId[s.uid];a&&e.includes(a)&&(r.push(i),i.parent=a,a.children.add(i),this._sortActiveLayerInfos(a.children))}})),e.removeMany(r);const t={};i.allLayerViews.forEach(((e,i)=>t[e.layer.uid]=i)),e.sort(((e,i)=>{const r=t[e.layer.uid]||0;return(t[i.layer.uid]||0)-r}))}_generateLayerViews(){const e=[];return I.filter(this._filterLayerViews,this).map((e=>d.get(this,e))).filter((e=>null!=e)).forEach(this._collectLayerViews("layerViews",e)),e}_filterLayerViews(e){const i=!this.basemapLegendVisible&&(e===_||e===v),r=!this.groundLegendVisible&&e===w;return!i&&!r}_collectLayerViews(e,i){const r=t=>(t&&t.forEach((t=>{i.push(t),r(t[e])})),i);return r}_filterLayerViewsByLayerInfos(e){const i=this.layerInfos;return!i||!i.length||i.some((i=>this._hasLayerInfo(i,e)))}_hasLayerInfo(e,i){const r=this._isLayerUIDMatching(e.layer,i.layer.uid);return r&&(this._layerInfosByLayerViewId[i.uid]=e),r}_isLayerUIDMatching(e,i){return e&&(e.uid===i||this._hasLayerUID(e.layers,i))}_hasLayerUID(e,i){return e&&e.some((e=>this._isLayerUIDMatching(e,i)))}_isLayerViewSupported(e){return!!f.has(e.layer.declaredClass)&&(this._layerViewByLayerId[e.layer.uid]=e,!0)}_generateActiveLayerInfo(e){this._isLayerActive(e)?this._buildActiveLayerInfo(e):(this.removeHandles(e.uid),this.addHandles(s.watch((()=>[e.legendEnabled,e.layer?.legendEnabled]),(()=>this._layerActiveHandle(e))),e.uid))}_layerActiveHandle(e){this._isLayerActive(e)&&(this.removeHandles(e.uid),this._buildActiveLayerInfo(e))}_isLayerActive(e){return!this.respectLayerVisibility||e.legendEnabled&&e.layer?.legendEnabled}_buildActiveLayerInfo(e){const i=e.layer,r=e.uid,t=this._layerInfosByLayerViewId[r];let a=this._activeLayerInfosByLayerViewId[r];if(!a){const s=void 0!==t?.title&&t.layer.uid===i.uid;a=new h({layer:i,layerView:e,title:s?t.title:i.title,view:this.view??void 0,respectLayerDefinitionExpression:this.respectLayerDefinitionExpression,respectLayerVisibility:this.respectLayerVisibility,hideLayersNotInCurrentView:this.hideLayersNotInCurrentView,keepCacheOnDestroy:this.keepCacheOnDestroy,sublayerIds:t?.sublayerIds||[]}),this._activeLayerInfosByLayerViewId[r]=a}const n=i.parent&&"uid"in i.parent?this._layerViewByLayerId[i.parent?.uid]:null;if(a.parent=this._activeLayerInfosByLayerViewId[n?.uid],!this.hasHandles(r)){const t=[s.watch((()=>i.title),(e=>this._titleHandle(e,a))),s.watch((()=>[i.opacity,"renderer"in i&&i.renderer,"pointSymbol"in i&&i.pointSymbol,"lineSymbol"in i&&i.lineSymbol,"polygonSymbol"in i&&i.polygonSymbol]),(()=>this._constructLegendElements(a))),s.when((()=>!0===this.view?.stationary),(()=>this._scaleHandle(a)),s.initial),s.watch((()=>e.layer?c.getEffectiveFeatureReduction(e.layer,e.view):null),(()=>this._constructLegendElements(a))),s.watch((()=>e.updating),(()=>{if(null==e.layer)return;null!=c.getEffectiveFeatureReduction(e.layer,e.view)&&this._constructLegendElements(a)})),s.watch((()=>"effect"in i&&i.effect),(()=>this._constructLegendElements(a))),s.when((()=>this.view?.timeZone),(()=>this._constructLegendElements(a)),s.initial)];if(this.respectLayerVisibility){const r=s.watch((()=>e.legendEnabled),(e=>this._legendEnabledHandle(e,a))),n=s.watch((()=>i.legendEnabled),(e=>this._legendEnabledHandle(e,a)));t.push(r,n)}if(this.respectLayerDefinitionExpression&&"definitionExpression"in i){const e=s.watch((()=>[i.definitionExpression,this.respectLayerDefinitionExpression]),(()=>{a.respectLayerDefinitionExpression=this.respectLayerDefinitionExpression,this._constructLegendElements(a)}));t.push(e)}this.addHandles(t,r)}a.isScaleDriven||this._constructLegendElements(a),this._addActiveLayerInfo(a)}_titleHandle(e,i){i.title=e,this._constructLegendElements(i)}_legendEnabledHandle(e,i){e?this._addActiveLayerInfo(i):this._removeActiveLayerInfo(i)}_scaleHandle(e){(e.isScaleDriven||e.hideLayersNotInCurrentView)&&this._constructLegendElements(e)}_addActiveLayerInfo(e){const{layerView:i,layer:r}=e;if(this._isLayerActive(i)&&!this.activeLayerInfos.includes(e)){const i=e.parent;if(i)i.children.includes(e)||i.children.push(e),this._sortActiveLayerInfos(i.children);else{const i=this.layerInfos?.some((e=>e.layer.uid===r.uid)),t=r.parent;(t&&"uid"in t?this._layerViewByLayerId[t.uid]:null)&&!i?this._activeLayerInfosWithNoParent.add(e):(this.activeLayerInfos.add(e),this._sortActiveLayerInfos(this.activeLayerInfos))}if(this._activeLayerInfosWithNoParent.length){const e=[];this._activeLayerInfosWithNoParent.forEach((i=>{const r=i.layer.parent,t=r&&"uid"in r?this._layerViewByLayerId[r?.uid]:null,s=this._activeLayerInfosByLayerViewId[t?.uid];s&&(e.push(i),i.parent=s)})),e.length&&(this._activeLayerInfosWithNoParent.removeMany(e),e.forEach((e=>this._addActiveLayerInfo(e))))}}}_removeActiveLayerInfo(e){const i=e.parent;i?i.children.remove(e):this.activeLayerInfos.remove(e)}_constructLegendElements(e){const i=e.layer;"featureCollections"in i&&i.featureCollections?e.buildLegendElementsForFeatureCollections(i.featureCollections):"featureReduction"in i&&i.featureReduction&&"renderer"in i.featureReduction&&("binning"===i.featureReduction.type||"cluster"===i.featureReduction.type)&&(!this.view||i.featureReduction.maxScale<=this.view.scale)?e.buildLegendElementsForFeatureReduction(i.featureReduction):"renderer"in i&&i.renderer&&!("sublayers"in i)?e.buildLegendElementsForRenderer(i.renderer):"url"in i&&i.url&&"catalog"!==i.type&&"knowledge-graph"!==i.type?e.buildLegendElementsForTools():e.children.forEach((e=>this._constructLegendElements(e)))}};e.__decorate([a.property({type:u})],g.prototype,"activeLayerInfos",void 0),e.__decorate([a.property()],g.prototype,"basemapLegendVisible",void 0),e.__decorate([a.property()],g.prototype,"groundLegendVisible",void 0),e.__decorate([a.property()],g.prototype,"hideLayersNotInCurrentView",void 0),e.__decorate([a.property()],g.prototype,"keepCacheOnDestroy",void 0),e.__decorate([a.property()],g.prototype,"respectLayerDefinitionExpression",void 0),e.__decorate([a.property()],g.prototype,"respectLayerVisibility",void 0),e.__decorate([a.property()],g.prototype,"layerInfos",void 0),e.__decorate([a.property({readOnly:!0})],g.prototype,"state",null),e.__decorate([a.property()],g.prototype,"view",void 0),g=e.__decorate([y.subclass("esri.widgets.Legend.LegendViewModel")],g);return g}));
