/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/Logger","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../Widget","./ClassicCSS","./support/relationshipUtils","./support/univariateUtils","../support/styleUtils","../../support/globalCss","../../support/Heading","../../support/widgetUtils","../../support/decorators/messageBundle","../../support/jsxFactory"],(function(e,s,t,a,r,l,i,o,n,c,p,d,y,m,v,h){"use strict";const g=`${o.legend}__`,b=24,u={display:"flex",alignItems:"flex-start"},x={marginLeft:"3px"},f={display:"table-cell",verticalAlign:"middle"};let L=class extends i{constructor(e,s){super(e,s),this.activeLayerInfos=null,this.headingLevel=3,this.messages=null,this.type="classic"}render(){const e=this.activeLayerInfos,s=e?.toArray().map((e=>this._renderLegendForLayer(e))).filter((e=>!!e));return h.tsx("div",null,s?.length?s:h.tsx("div",{class:o.css.message},this.messages.noLegend))}_renderLegendForLayer(e,s){if(!e.ready)return null;const t=!!e.children.length,a=`${e.layer.uid}-version-${e.version}`,r=`${g}${s?`${s}-`:""}${a}`,l=e.title?y.Heading({level:this.headingLevel,class:this.classes(d.globalCss.heading,o.css.label)},e.title):null;if(t){const s=e.children.map((e=>this._renderLegendForLayer(e,a))).toArray();return h.tsx("div",{class:this.classes(o.css.service,o.css.groupLayer),key:r},l,s)}{const s=e.legendElements;if(s&&!s.length)return null;const t=s.map((s=>this._renderLegendForElement(s,e.layer,e.effectList,r))).filter((e=>!!e));if(!t.length)return null;const a={[o.css.groupLayerChild]:!!e.parent};return h.tsx("div",{class:this.classes(o.css.service,a),key:r},l,h.tsx("div",{class:o.css.layer},t))}}_renderLegendForElement(e,s,t,a,r){const l="color-ramp"===e.type,i="opacity-ramp"===e.type,c="size-ramp"===e.type;let d=null;const y=`${a}-${e.type}`;if("symbol-table"===e.type||c){const a=e.infos.map((a=>this._renderLegendForElementInfo(a,s,t,c,e.legendType,y))).filter((e=>!!e));a.length&&(d=h.tsx("div",{class:o.css.layerBody},a))}else"color-ramp"===e.type||"opacity-ramp"===e.type||"heatmap-ramp"===e.type||"stretch-ramp"===e.type?d=this._renderLegendForRamp(e,s.opacity,y):"relationship-ramp"===e.type?d=n.renderRelationshipRamp(e,this.id,{opacity:s.opacity,effectList:t,ariaLabel:this.messages.previewRelationshipRampAriaLabel,key:y}):"pie-chart-ramp"===e.type?d=this._renderPieChartRamp(e,y):"univariate-above-and-below-ramp"===e.type?d=this._renderUnivariateAboveAndBelowRamp(e,s.opacity,t,y):"univariate-color-size-ramp"===e.type&&(d=this._renderUnivariateColorSizeRamp(e,s.opacity,t,y));if(!d)return null;const m=e.title;let v=null;if("string"==typeof m)v=m;else if(m){const e=p.getTitle(this.messages,m,l||i);v=p.isRendererTitle(m,l||i)&&m.title?`${m.title} (${e})`:e}const g=r?o.css.layerChildTable:o.css.layerTable,b=v?h.tsx("div",{class:o.css.layerCaption},v):null,u={[o.css.layerTableSizeRamp]:c||!r};return h.tsx("div",{class:this.classes(g,u),key:`${a}-table`},b,d)}_renderPieChartRamp(e,s){return h.tsx("div",{afterCreate:p.attachToNode,bind:e.preview,key:`${s}-preview`})}_renderUnivariateAboveAndBelowRamp(e,s,t,a){const{sizeRampElement:r,colorRampElement:l}=c.getUnivariateAboveAndBelowRampElements(e,s);if(!r)return null;const i=this.messages?.previewColorRampAriaLabel,n=c.getUnivariateColorRampSize(r,"above",!0),d=c.getUnivariateColorRampSize(r,"below",!0),y=12,m=c.getUnivariateColorRampPreview(l,{width:y,height:n,rampAlignment:"vertical",opacity:s,type:"above",effectList:t,ariaLabel:i}),v=c.getUnivariateColorRampPreview(l,{width:y,height:d,rampAlignment:"vertical",opacity:s,type:"below",effectList:t,ariaLabel:i}),g=c.getUnivariateColorRampMargin(r),b=r.infos.map((e=>e.label)),L=b.map(((e,s)=>{const t=2===s;return 0===s?h.tsx("div",{class:e?m?o.css.univariateAboveAndBelowLabel:o.css.rampLabel:void 0,key:`${a}-color-ramp-above-label-${e??s}`},e):t?h.tsx("div",null):null})),C=b.length-1,w=Math.floor(b.length/2),R=b.map(((e,s)=>s===w||s===C?h.tsx("div",{class:e?m?o.css.univariateAboveAndBelowLabel:o.css.rampLabel:void 0,key:`${a}-color-ramp-below-label-${e??s}`},e):null)),$={display:"table-cell",verticalAlign:"middle"},_={marginTop:`${g}px`},A={height:`${n}px`},T={height:`${d}px`};return h.tsx("div",{key:`${a}-container`,styles:u},h.tsx("div",{class:o.css.layerBody},r.infos.map(((e,s)=>h.tsx("div",{class:this.classes(o.css.layerRow,o.css.sizeRamp),key:`${a}-row-${s}`},h.tsx("div",{afterCreate:p.attachToNode,bind:e.preview,class:o.css.symbol,styles:$}),m||s%2!=0?null:h.tsx("div",{class:o.css.layerInfo},b[s]))))),m?h.tsx("div",{styles:_},h.tsx("div",{styles:x},h.tsx("div",{styles:f},h.tsx("div",{afterCreate:p.attachToNode,bind:m,class:o.css.rampContainer})),h.tsx("div",{styles:f},h.tsx("div",{class:o.css.rampLabelsContainer,styles:A},L))),h.tsx("div",{styles:x},h.tsx("div",{styles:f},h.tsx("div",{afterCreate:p.attachToNode,bind:v,class:o.css.rampContainer})),h.tsx("div",{styles:f},h.tsx("div",{class:o.css.rampLabelsContainer,styles:T},R)))):null)}_renderUnivariateColorSizeRamp(e,s,t,a){const{sizeRampElement:r,colorRampElement:l}=c.getUnivariateColorSizeRampElements(e);if(!r)return null;const i=c.getUnivariateColorRampMargin(r),n=12,d=c.getUnivariateColorRampSize(r,"full",!1),y=c.getUnivariateColorRampPreview(l,{width:n,height:d,rampAlignment:"vertical",opacity:s,type:"full",effectList:t,ariaLabel:this.messages?.previewColorRampAriaLabel}),m=r.infos.length-1,v=r.infos.map(((e,s)=>0===s||s===m?h.tsx("div",{class:e.label?l?o.css.univariateAboveAndBelowLabel:o.css.rampLabel:void 0,key:`${a}-color-ramp-label-${e.label??s}`},e.label):null)),g={display:"table-cell",verticalAlign:"middle"},b={marginTop:`${i}px`},L={height:`${d}px`};return h.tsx("div",{key:`${a}-container`,styles:u},h.tsx("div",{class:o.css.layerBody},r.infos.map(((e,s)=>h.tsx("div",{class:this.classes(o.css.layerRow,o.css.sizeRamp),key:`${a}-row-${s}`},h.tsx("div",{afterCreate:p.attachToNode,bind:e.preview,class:o.css.symbol,styles:g}))))),h.tsx("div",{styles:b},h.tsx("div",{styles:x},h.tsx("div",{styles:f},h.tsx("div",{afterCreate:p.attachToNode,bind:y,class:o.css.rampContainer})),h.tsx("div",{styles:f},h.tsx("div",{class:o.css.rampLabelsContainer,styles:L},v)))))}_renderLegendForRamp(e,s,t){const a=e.infos,r="opacity-ramp"===e.type,l="heatmap-ramp"===e.type,i="stretch-ramp"===e.type,n=e.preview,c=r?o.css.opacityRamp:"";n.className=`${o.css.colorRamp} ${c}`,null!=s&&(n.style.opacity=s.toString());const d=a.map(((e,s)=>h.tsx("div",{class:e.label?o.css.rampLabel:void 0,key:`${t}-stop-${e.label??s}-label`},l?this.messages[e.label]||e.label:i?p.getStretchStopLabel(e,this.messages):e.label))),y={width:`${b}px`},m={height:n.style.height};return h.tsx("div",{class:o.css.layerRow,key:`${t}-row`},h.tsx("div",{class:o.css.symbolContainer,styles:y},h.tsx("div",{afterCreate:p.attachToNode,bind:n,class:o.css.rampContainer})),h.tsx("div",{class:o.css.layerInfo},h.tsx("div",{class:o.css.rampLabelsContainer,styles:m},d)))}_renderLegendForElementInfo(e,s,t,a,r,l){const i=`${l}-${e.label}`;if(e.type)return this._renderLegendForElement(e,s,t,i,!0);let n=null;const c=p.isImageryStretchedLegend(s,r);if(e.preview?n=h.tsx("div",{afterCreate:p.attachToNode,bind:e.preview,class:o.css.symbol}):e.src&&(n=this._renderImage(e,s,c)),!n)return null;const d={[o.css.imageryLayerInfoStretched]:c},y={[o.css.imageryLayerInfoStretched]:c,[o.css.sizeRamp]:!c&&a};return h.tsx("div",{class:o.css.layerRow,key:`${i}-row`},h.tsx("div",{class:this.classes(o.css.symbolContainer,y)},n),h.tsx("div",{class:this.classes(o.css.layerInfo,d)},p.getTitle(this.messages,e.label,!1)||""))}_renderImage(e,s,t){const{label:a,src:r,opacity:l}=e,i={[o.css.imageryLayerStretchedImage]:t,[o.css.symbol]:!t},n={opacity:`${null!=l?l:s.opacity}`};return h.tsx("img",{alt:p.getTitle(this.messages,a,!1),"aria-label":p.getTitle(this.messages,a,!1),border:0,class:this.classes(i),height:e.height,src:r,styles:n,width:e.width})}};e.__decorate([s.property()],L.prototype,"activeLayerInfos",void 0),e.__decorate([s.property()],L.prototype,"headingLevel",void 0),e.__decorate([s.property(),v.messageBundle("esri/widgets/Legend/t9n/Legend")],L.prototype,"messages",void 0),e.__decorate([s.property({readOnly:!0})],L.prototype,"type",void 0),L=e.__decorate([l.subclass("esri.widgets.Legend.styles.Classic")],L);return L}));
