/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../../../chunks/tslib.es6","../../../Color","../../../intl","../../../kernel","../../../request","../../../symbols","../../../core/Accessor","../../../core/arrayUtils","../../../core/Collection","../../../core/has","../../../core/jsonMap","../../../core/Logger","../../../core/promiseUtils","../../../core/reactiveUtils","../../../core/screenUtils","../../../core/sql","../../../core/urlUtils","../../../core/accessorSupport/decorators/property","../../../core/accessorSupport/decorators/subclass","../../../core/accessorSupport/PropertyOrigin","../../../layers/effects/EffectView","../../../layers/effects/jsonUtils","../../../layers/support/ExportImageParameters","../../../layers/support/fieldUtils","../../../layers/support/layerUtils","../../../layers/support/rasterFormats/pixelRangeUtils","../../../renderers/support/jsonUtils","../../../renderers/support/rendererConversion","../../../renderers/visualVariables/SizeVariable","../../../renderers/visualVariables/support/SizeVariableLegendOptions","../../../smartMapping/renderers/support/referenceSizeUtils","../../../symbols/support/cimSymbolUtils","../../../symbols/support/previewUtils","../../../symbols/support/renderUtils","../../../symbols/support/symbolUtils","../../../symbols/support/utils","./clusterUtils","./colorRampUtils","./heatmapRampUtils","./relationshipRampUtils","./sizeRampUtils","./utils","../../smartMapping/support/utils","../../../symbols/SimpleMarkerSymbol","../../../symbols/SimpleFillSymbol","../../../intl/messages","../../../intl/substitute"],(function(e,t,i,l,s,r,n,a,o,u,c,d,y,h,p,f,m,g,b,S,_,w,v,L,C,E,R,I,F,V,x,D,T,z,P,M,O,A,U,k,B,H,N,q,$,W,G,j){"use strict";const J=16,Q="https://utility.arcgis.com/sharing/tools/legend",Z="esri.layers.ImageryLayer",K="esri.layers.ImageryTileLayer",X="esri.layers.WCSLayer",Y=/^\s*(return\s+)?\$view\.scale\s*(;)?\s*$/i,ee=new d.JSONMap({esriGeometryPoint:"point",esriGeometryMultipoint:"multipoint",esriGeometryPolyline:"polyline",esriGeometryPolygon:"polygon",esriGeometryMultiPatch:"multipatch"}),te=new $({size:6,outline:{color:[128,128,128,.5],width:.5}}),ie=new W({style:"solid"});function le(e){return"flow"===e.type}function se(e){return"vector-field"===e.type}function re(e){return"raster-colormap"===e.type}function ne(e){return"raster-stretch"===e.type}function ae(e){return"raster-shaded-relief"===e.type}function oe(e){return"esri.renderers.SimpleRenderer"===e.declaredClass}function ue(e){return"esri.renderers.ClassBreaksRenderer"===e.declaredClass}function ce(e){return"esri.renderers.UniqueValueRenderer"===e.declaredClass}function de(e){return"esri.renderers.HeatmapRenderer"===e.declaredClass}function ye(e){return pe(e)||fe(e)||me(e)||he(e)}function he(e){return"esri.renderers.PointCloudRGBRenderer"===e.declaredClass}function pe(e){return"esri.renderers.PointCloudClassBreaksRenderer"===e.declaredClass}function fe(e){return"esri.renderers.PointCloudStretchRenderer"===e.declaredClass}function me(e){return"esri.renderers.PointCloudUniqueValueRenderer"===e.declaredClass}function ge(e){return"esri.renderers.DotDensityRenderer"===e.declaredClass}function be(e){return"esri.renderers.PieChartRenderer"===e.declaredClass}function Se(e,t){return oe(e)||ue(e)||ce(e)||de(e)||ge(e)||be(e)?"2d"===t.type||F.isSupportedRenderer3D(e):ne(e)||re(e)||ae(e)||pe(e)||fe(e)||me(e)||se(e)||le(e)}function _e(e){return"esri.layers.BuildingSceneLayer"===e.declaredClass}function we(e){return"esri.layers.SubtypeGroupLayer"===e.declaredClass}function ve(e){return"esri.layers.VoxelLayer"===e.declaredClass}function Le(e){return"esri.layers.WMSLayer"===e.declaredClass}function Ce(e){return"esri.layers.WMTSLayer"===e.declaredClass}function Ee(e){return"esri.layers.MapImageLayer"===e.declaredClass}function Re(e){return"esri.layers.TileLayer"===e.declaredClass}function Ie(e){return e.declaredClass===Z}function Fe(e){return e.declaredClass===K}function Ve(e){return e.declaredClass===X}function xe(e){return"stretch-ramp"===e.type}function De(e){const t="authoringInfo"in e?e?.authoringInfo:null;return"univariate-color-size"===t?.type}function Te(e){const t="authoringInfo"in e?e?.authoringInfo:null;return"univariate-color-size"===t?.type&&"above-and-below"===t?.univariateTheme}function ze(e){return"sublayers"in e}async function Pe(e,t){const i=await G.fetchMessageBundle("esri/widgets/Legend/t9n/Legend");return"previewTemplateAriaLabel"!==e||t||(e="previewAriaLabel"),j.substitute(i[e],{label:t})}function Me(e,t){const{field:i,field2:l,field3:s,fieldDelimiter:r,valueExpression:n}=e;if(!i)return null;const a=!(!i&&!n||!l&&!s)?t?.toString().split(r||""):[t],o=i?{[i]:a?.[0]}:null;return o&&(l&&(o[l]=a?.[1]),s&&(o[s]=a?.[2])),o}const Oe=new $({style:"path",path:"M10,5 L5,0 0,5 M5,0 L5,15",size:15,outline:{width:1,color:[85,85,85,1]}});let Ae={},Ue=class extends a{constructor(e){super(e),this._hasColorRamp=!1,this._hasOpacityRamp=!1,this._hasSizeRamp=!1,this._webStyleSymbolCache=new Map,this._dotDensityUrlCache=new Map,this._scaleDrivenSizeVariable=null,this._hasClusterSizeVariable=!1,this._layerDefinitionExpression=null,this._layerDefinitionExpressionClause=null,this.children=new u,this.layerView=null,this.layer=null,this.legendElements=[],this.parent=null,this.hideLayersNotInCurrentView=!1,this.keepCacheOnDestroy=!1,this.respectLayerDefinitionExpression=!1,this.respectLayerVisibility=!0,this.sublayerIds=[],this.title=null,this.view=null}initialize(){const e=()=>this.notifyChange("ready");this.addHandles([p.on((()=>this.children),"change",(t=>{const{added:i,removed:l}=t;i.forEach((t=>{const i=`activeLayerInfo-ready-watcher-${t.layer.uid}`;this.addHandles(p.watch((()=>t.ready),e,p.initial),i)})),l.forEach((e=>this.removeHandles(e.layer.uid))),e()}))]),this.keepCacheOnDestroy||(Ae={})}destroy(){this._webStyleSymbolCache=null,this._dotDensityUrlCache=null,this._scaleDrivenSizeVariable=null,this.keepCacheOnDestroy||(Ae=null),this._layerDefinitionExpressionClause=null}get effectList(){const e=this.layer;let t=null;return"effect"in e&&e.effect&&(t=new w.EffectView,t.effect=e.effect,t.endTransition(),t.scale=this.scale),t}get opacity(){const e=this.layer.opacity,t=this.parent?.opacity,i=this.layer.parent,l=i&&"uid"in i?this._getParentLayerOpacity(i):null;return null!=t?t*e:null!=l?l*e:e}get ready(){return null===this.layer||(this.children.length>0?this._isGroupActive():this.legendElements.length>0)}get scale(){return this.view?.scale??0}get isScaleDriven(){const e=this.layer;if(null===e)return!1;if("effect"in e&&e.effect&&Array.isArray(e.effect))return!0;if("featureReduction"in e&&e.featureReduction){if("cluster"===e.featureReduction.type)return!0;if("binning"===e.featureReduction.type&&"renderer"in e.featureReduction&&e.featureReduction.renderer)return this._isRendererScaleDriven(e.featureReduction.renderer)}return"renderer"in e&&e.renderer?this._isRendererScaleDriven(e.renderer):this._isLayerScaleDriven(this.layer)}get version(){return this._get("version")+1}async buildLegendElementsForFeatureCollections(e){if(!(!this.hideLayersNotInCurrentView||await this._isLayerInCurrentView()))return this.legendElements=[],void this.notifyChange("ready");const t=Array.from(e,(e=>{if(E.isFeatureLayer(e))return this._getRendererLegendElements(e.renderer,{title:e.title});if(e.featureSet?.features.length){const t=e.layerDefinition,i=t?.drawingInfo,l=i&&I.fromJSON(i.renderer),s=ee.read(t.geometryType);return l?this._getRendererLegendElements(l,{title:e.name,geometryType:s}):(y.getLogger(this).warn("drawingInfo not available!"),null)}return null}));try{const e=[],i=await Promise.allSettled(t);for(const t of i)if("fulfilled"===t.status)for(const i of t.value??[])e.push(i);this.legendElements=e,this.notifyChange("ready")}catch(i){y.getLogger(this).warn("error while building legend for layer!",i)}}async buildLegendElementsForRenderer(e){try{const t=!this.hideLayersNotInCurrentView||await this._isLayerInCurrentView();this.legendElements=t?await this._getRendererLegendElements(e):[],this.notifyChange("ready")}catch(t){y.getLogger(this).warn("error while building legend for layer!",t)}}async buildLegendElementsForFeatureReduction(e){try{const t=!this.hideLayersNotInCurrentView||await this._isLayerInCurrentView();this.legendElements=t?await this._getLegendElementsForFeatureReduction(e):[],this.notifyChange("ready")}catch(t){y.getLogger(this).warn("error while building legend for layer!",t)}}async buildLegendElementsForTools(){const e=this.layer;if(ve(e))this._constructLegendElementsForVoxelLayer();else if(Ce(e))this._constructLegendElementsForWMTSlayer();else if(Le(e))await this._constructLegendElementsForWMSSublayers();else if(_e(e))await this._constructLegendElementsForBuildingSceneLayer();else if(Ee(e)||Re(e)||we(e))await this._constructLegendElementsForSublayers();else{this.removeHandles("imageryLayers-watcher");let t="default";if(Ie(e)){const i=e;t=(i?.rasterFunction?.functionName||"default")+"_"+(e.bandIds?.length?e.bandIds.join(""):"###")}if(Fe(e)||"link-chart"===e.type)return;await this._getLegendLayers(`${e.uid}-${t}`).then((async t=>{this.legendElements=[],this.notifyChange("ready");const i=t.map((async t=>{if(Ie(e)){const t=p.watch((()=>[e.rasterFunction,e.bandIds]),(()=>h.debounce((async()=>{Ae.default=null,e.renderer?await this.buildLegendElementsForRenderer(e.renderer):await this.buildLegendElementsForTools()}))()));this.addHandles(t,"imageryLayers-watcher")}const i=this._generateSymbolTableElementForLegendLayer(t);i?.infos.length&&(Ie(e)&&(i.title=e.title),this.legendElements.push(i)),this.notifyChange("ready")}));await Promise.allSettled(i)})).catch((e=>{y.getLogger(this).warn("Request to server for legend has failed!",e)}))}}async _isLayerInCurrentView(){const e=this.layer,t=this.layerView,i=t&&"createQuery"in t&&"queryFeatureCount"in t;if(!i&&!(t&&"createQuery"in e&&"queryFeatureCount"in e))return!0;await p.whenOnce((()=>!t.updating));const l=i?"createQuery"in t&&t.createQuery():"createQuery"in e&&e.createQuery();if(!l)return!0;l.geometry=this.view.extent;return 0!==(i?"queryFeatureCount"in t&&await t.queryFeatureCount(l):"queryFeatureCount"in e&&await e.queryFeatureCount(l))}_getParentLayerOpacity(e){let t=1;const i=e.parent;return i&&"uid"in i&&(t=this._getParentLayerOpacity(i)),e.opacity*t}_isGroupActive(){return this.children.some((e=>e.ready))}_isRendererScaleDriven(e){if("dot-density"===e.type)return!0;const t="valueExpression"in e?e.valueExpression:null;if(Y.test(t))return!0;const i="visualVariables"in e?e.visualVariables:null;return!!i?.some((e=>this._isScaleDrivenSizeVariable(e)))||this._hasScaleDrivenSymbols(e)}_hasScaleDrivenSymbols(e){switch(e.type){case"simple":return this._isScaleDrivenSymbol(e.symbol);case"class-breaks":return this._isScaleDrivenSymbol(e.defaultSymbol)||e.classBreakInfos.some((e=>this._isScaleDrivenSymbol(e.symbol)));case"unique-value":return this._isScaleDrivenSymbol(e.defaultSymbol)||!!e.uniqueValueInfos?.some((e=>this._isScaleDrivenSymbol(e.symbol)))}return!1}_isScaleDrivenSymbol(e){if("cim"===e?.type){const{primitiveOverrides:t,minScale:i,maxScale:l}=e.data,s=t?.some((e=>/\$view\.scale/.test(e.valueExpressionInfo?.expression||"")))??!1;return null!=i||null!=l||s}return!1}_isScaleDrivenSizeVariable(e){if(e&&"size"!==e.type)return!1;const t=e,i=t.minSize,l=t.maxSize;return!("object"!=typeof i||!i||!this._isScaleDrivenSizeVariable(i))||(!("object"!=typeof l||!l||!this._isScaleDrivenSizeVariable(l))||Y.test(t.valueExpression))}_isLayerScaleDriven(e){if("minScale"in e&&e.minScale>0||"maxScale"in e&&e.maxScale>0)return!0;if("sublayers"in e&&e.sublayers)return e.sublayers.some((e=>this._isLayerScaleDriven(e)));const t=e.parent;if(!1===e.loaded&&t&&Ee(t)&&"source"in e&&e.source&&"map-layer"===e.source.type)for(const i of t.sourceJSON.layers??[])if(i.id===e.source.mapLayerId&&(i.minScale>0||i.maxScale>0))return!0;return!1}async _constructLegendElementsForVoxelLayer(){this.legendElements=[],this.removeHandles("voxel-style-watcher"),this.removeHandles("voxel-current-variable");const e=this.layer;this.addHandles(p.watch((()=>e.currentVariableId),(()=>this._constructLegendElementsForVoxelLayer())),"voxel-current-variable"),this.addHandles(p.watch((()=>e.getVariableStyles()),(()=>this._constructLegendElementsForVoxelLayer())),"voxel-style-watcher");const t=e.getVariableStyle(null),i=[];if(t)if(t.uniqueValues?.length){const e=[];t.uniqueValues.forEach((t=>{t.enabled&&e.push({label:t.label||`${t.value}`,value:t.value,symbol:new W({color:t.color,outline:null})})})),e.length&&i.push({type:"symbol-table",title:t.label,infos:e})}else if(t.transferFunction){const{colorStops:e,stretchRange:l}=t.transferFunction,s=e.toArray().reverse(),r=l.map(((e,t)=>`${0===t?N.specialCharsLessThan:N.specialCharsGreaterThan} ${q.formatNumberLabel(e)}`)).reverse(),n=s.map((e=>({color:e.color,value:null,label:null})));n[0].label=r[0],n[n.length-1].label=r[1],i.push({type:"color-ramp",title:t.label,infos:n,preview:M.renderColorRampPreviewHTML(s.map((e=>e.color)),{ariaLabel:await Pe("previewColorRampAriaLabel")})})}const l=e.opacity,s=i.reduce(((e,t)=>[...e,...this._getAllInfos(t)]),[]).filter((e=>!!e?.symbol)).map((e=>this._getSymbolPreview(e,l)));await Promise.allSettled(s),this.legendElements=i,this.notifyChange("ready")}_constructLegendElementsForWMTSlayer(){this.legendElements=[],this.removeHandles("wmts-activeLayer-watcher");const e=this.layer.activeLayer;this.addHandles(p.watch((()=>{const{layer:e}=this;return e&&"activeLayer"in e&&e.activeLayer}),(()=>this._constructLegendElementsForWMTSlayer())),"wmts-activeLayer-watcher");const t=e.styleId?e.styles?.find((({id:t})=>t===e.styleId))?.legendUrl:void 0;t&&(this.legendElements=[{type:"symbol-table",title:e.title,infos:[{src:t,opacity:this.opacity}]}]),this.notifyChange("ready")}async _constructLegendElementsForWMSSublayers(){this.legendElements=[],this.removeHandles("wms-sublayers-watcher");const e=this.layer;let t=null;(e.customParameters||e.customLayerParameters)&&(t={...e.customParameters,...e.customLayerParameters}),this.addHandles(p.watch((()=>{const{layer:e}=this;return e&&"sublayers"in e&&e.sublayers}),(()=>this._constructLegendElementsForWMSSublayers())),"wms-sublayers-watcher"),this.legendElements=await this._generateLegendElementsForWMSSublayers(e.sublayers,t),this.notifyChange("ready")}async _generateLegendElementsForWMSSublayers(e,t){const i=this.layer,l=[];this.addHandles(e.on("change",(()=>this._constructLegendElementsForWMSSublayers())),"wms-sublayers-watcher");const s=this.sublayerIds?.map((e=>i.findSublayerById(e)))?.filter(o.isSome)??[],r=s.length?s:e.toArray();for(const n of r){const e=p.watch((()=>[n.title,n.visible,n.legendEnabled]),(()=>this._constructLegendElementsForWMSSublayers()));if(this.addHandles(e,"wms-sublayers-watcher"),!this.respectLayerVisibility||n.visible&&n.legendEnabled){const e=await this._generateSymbolTableElementForWMSSublayer(n,t);e?.infos.length&&l.unshift(e)}}return l}async _generateSymbolTableElementForWMSSublayer(e,t){if(!e.legendUrl&&e.sublayers){const i=(await this._generateLegendElementsForWMSSublayers(e.sublayers,t)).filter((e=>e));return{type:"symbol-table",title:e.title,infos:i}}return this._generateSymbolTableElementForLegendUrl(e,t)}async _generateSymbolTableElementForLegendUrl(e,t){let i=e.legendUrl;if(!i)return;const l={type:"symbol-table",title:e.title||e.name||String(e.id??""),infos:[]};t&&(i=g.addQueryParameters(i,t));let s=null;const n=e.layer?.opacity;try{s=(await r(i,{responseType:"image"})).data,s&&(s.style.opacity=n)}catch{}return l.infos.push({src:i,preview:s,opacity:n}),l}_getLegendLayers(e,t){const i=Ae&&Ae[e];return i?Promise.resolve(i):this._legendRequest(t).then((t=>{const i=t.layers;return Ae[e]=i,i}))}_legendRequest(e){const t=this.layer;let i={f:"json",dynamicLayers:e};if(Ie(t)){const e=t.exportImageServiceParameters.rasterFunction;if(e&&(i.renderingRule=JSON.stringify(e.functionDefinition?.toJSON()||e.toJSON())),t.bandIds&&(i.bandIds=t.bandIds.join()),t.raster||t.viewId||t.customParameters){const{raster:e,viewId:l,customParameters:s}=t;i={raster:e,viewId:l,...i,...s}}}let l=t.url.replace(/(\/)+$/,"");if("version"in t&&+t.version>=10.01){const e=l.indexOf("?");e>-1?l=l.slice(0,e)+"/legend"+l.slice(e):l+="/legend"}else{const e=l.toLowerCase().indexOf("/rest/"),t=-1===e?l:l.slice(0,e)+l.slice(e+5);l=Q+"?soapUrl="+encodeURI(t)+"&returnbytes=true"}return r(l,{query:i}).then((e=>e.data))}async _constructLegendElementsForBuildingSceneLayer(){this.legendElements=[],this.removeHandles("sublayers-watcher");const e=this.layer;this.addHandles(p.watch((()=>e.sublayers),(()=>this._constructLegendElementsForBuildingSceneLayer())),"sublayers-watcher");try{this.legendElements=await this._generateLegendElementsForBuildingSublayers(e.sublayers,this.opacity),this.notifyChange("ready")}catch(t){y.getLogger(this).warn("Request to server for legend has failed!",t)}}async _generateLegendElementsForBuildingSublayers(e,t){let i=[];this.addHandles(e.on("change",(()=>this._constructLegendElementsForBuildingSceneLayer())),"sublayers-watcher");const l=e.toArray();for(const s of l){const e=p.watch((()=>["renderer"in s&&s.renderer,s.opacity,s.title,s.visible]),(()=>this._constructLegendElementsForBuildingSceneLayer()));if(this.addHandles(e,"sublayers-watcher"),!this.respectLayerVisibility||s.visible){const e=null!=s?.opacity?s.opacity:null,l=null!=e?e*t:t;if("building-group"===s.type){const e={type:"symbol-table",title:s.title,infos:[]},t=await this._generateLegendElementsForBuildingSublayers(s.sublayers,l);e.infos.push(...t),i=[e,...i]}else if(s.renderer){i=[...await this._getRendererLegendElements(s.renderer,{title:s.title,opacity:l,sublayer:s}),...i]}}}return i.filter((e=>!!e&&(!("infos"in e)||!e.infos||e.infos.length>0)))}async _constructLegendElementsForSublayers(){this.legendElements=[],this.removeHandles("sublayers-watcher");const e=this.layer;if(Ee(e)||Re(e)||we(e)){this.addHandles(p.watch((()=>e.sublayers),(()=>this._constructLegendElementsForSublayers)),"sublayers-watcher");try{this.legendElements=await this._generateLegendElementsForSublayers(e.sublayers,this.opacity),this.notifyChange("ready")}catch(t){y.getLogger(this).warn("Request to server for legend has failed!",t)}}}async _generateLegendElementsForSublayers(e,t,i){const l=this.layer;let s=[];this.addHandles(e.on("change",(()=>this._constructLegendElementsForSublayers())),"sublayers-watcher");let r=e.toArray();!i&&this.sublayerIds&&this.sublayerIds.length&&(r=we(l)?this.sublayerIds.map((e=>l.findSublayerForSubtypeCode(e))).filter(o.isSome):this.sublayerIds.map((e=>l.findSublayerById(e))).filter(o.isSome));for(const n of r){const e=p.watch((()=>[n.renderer,n.opacity,n.title,n.visible,n.legendEnabled]),(()=>this._constructLegendElementsForSublayers()));if(this.addHandles(e,"sublayers-watcher"),!this.respectLayerVisibility||n.visible&&n.legendEnabled&&this._isSublayerInScale(n)){const e=null!=n?.opacity?n.opacity:null,l=null!=e?e*t:t,r=!ze(n)||n.originIdOf("renderer")>_.OriginId.SERVICE&&!n.sublayers;if(n.renderer&&r){await n.load();s=[...await this._getRendererLegendElements(n.renderer,{title:n.title,opacity:l,sublayer:n}),...s]}else if(ze(n)){const e=await this._generateSymbolTableElementForSublayer(n,l,i);e&&s.unshift(e)}}}return s.filter((e=>!!e&&(!("infos"in e)||!e.infos||e.infos.length>0)))}async _generateSymbolTableElementForSublayer(e,t,i){if(!i){i=new Map;const t=this.layer,l=e.source;let s=null;if(!(!l||"map-layer"===l.type&&l.mapLayerId===e.id&&(!l.gdbVersion||l.gdbVersion===("gdbVersion"in t&&t.gdbVersion)))||e.originIdOf("renderer")>_.OriginId.SERVICE||e.originIdOf("labelingInfo")>_.OriginId.SERVICE||e.originIdOf("labelsVisible")>_.OriginId.SERVICE){const e=new L.ExportImageParameters({layer:this.layer});s=e.hasDynamicLayers?e.dynamicLayers:null,e.destroy()}const r=s||`${t.uid}-default`;(await this._getLegendLayers(r,s)).forEach((e=>i.set(e.layerId,e)))}const l=i.get(e.id);if((!l||l?.subLayerIds&&l.defaultVisibility)&&e.sublayers){const l=await this._generateLegendElementsForSublayers(e.sublayers,t,i);return{type:"symbol-table",title:e.title,infos:l}}return this._generateSymbolTableElementForLegendLayer(l,e,t)}_generateSymbolTableElementForLegendLayer(e,t,i){if(!e?.legend||this.respectLayerVisibility&&!this._isLegendLayerInScale(e,t))return null;const l=t?.renderer;let s=t?.title||e.layerName;if(l&&(!t||t?.originIdOf("renderer")>_.OriginId.SERVICE)){const e=t?.title||this._getRendererTitle(l,t);e&&(s&&"string"!=typeof e&&"title"in e&&(e.title=s),s=e)}const r={type:"symbol-table",title:s,legendType:e.legendType||null,infos:[]},n=t?this._sanitizeLegendForSublayer(e.legend.slice(),t):e.legend;return e.legendGroups&&e.legendGroups.length>0?e.legendGroups.forEach((t=>{const l={type:"symbol-table",title:t.heading,legendType:e.legendType||null,infos:this._generateSymbolTableElementInfosForLegendLayer(n.filter((e=>e.groupId===t.id)),e.layerId,i)};l.infos?.length>0&&r.infos.push(l)})):r.infos=this._generateSymbolTableElementInfosForLegendLayer(n,e.layerId,i),r.infos.length>0?r:null}_generateSymbolTableElementInfosForLegendLayer(e,t,i){return e.map((e=>{let l=e.url;if(e.imageData&&e.imageData.length>0)l=`data:image/png;base64,${e.imageData}`;else{if(0===l.indexOf("http"))return null;l=s.addTokenParameter(`${this.layer.url}/${t}/images/${l}`)}return{label:e.label,src:l,opacity:i??this.opacity,width:e.width,height:e.height}})).filter(o.isSome)}_isSublayerInScale(e){const t=e.minScale||0,i=e.maxScale||0;return!(t>0&&t<this.scale||i>this.scale)}_isLegendLayerInScale(e,t){const i=t||this.layer;let l=null,s=null,r=!0;return!i.minScale&&0!==i.minScale||!i.maxScale&&0!==i.maxScale?(0===e.minScale&&i.tileInfo&&(l=i.tileInfo.lods[0].scale),0===e.maxScale&&i.tileInfo&&(s=i.tileInfo.lods[i.tileInfo.lods.length-1].scale)):(l=Math.min(i.minScale,e.minScale)||i.minScale||e.minScale,s=Math.max(i.maxScale,e.maxScale)),(l>0&&l<this.scale||s>this.scale)&&(r=!1),r}_sanitizeLegendForSublayer(e,t){if("version"in this.layer&&+this.layer.version<10.1||0===e.length)return e;const i=t.renderer,l=e.some((e=>e.values));let s=0,r=null;return l&&e.some(((e,t)=>(e.values||(s=t,r=e,r.label||(r.label="others")),null!=r))),i?"unique-value"===i.type?r&&(e.splice(s,1),e.push(r)):"class-breaks"===i.type&&(r&&e.splice(s,1),e.reverse(),r&&e.push(r)):r&&(e.splice(s,1),e.push(r)),e}async _getRendererLegendElements(e,t={}){if(!Se(e,this.view))return y.getLogger(this).warn(`Renderer of type '${e.type}' not supported!`),[];if(ye(e))return this._constructPointCloudRendererLegendElements(e,t);if(ge(e))return this._constructDotDensityRendererLegendElements(e);const i=await this._loadRenderer(e);return be(i)?this._constructPieChartRendererLegendElements(i):this._constructRendererLegendElements(i,t)}async _getLegendElementsForFeatureReduction(e){let t=null;return"binning"===e.type?t=e.renderer:"cluster"===e.type&&(t=this._getClusterRenderer(e)),t?this._getRendererLegendElements(t):[]}_getPointCloudRendererTitle(e){return(e.legendOptions?.title||e.field)??""}async _constructPointCloudRendererLegendElements(e,t={}){const i=t.title,l=[];let s=null,r=null;if(pe(e))s={type:"symbol-table",title:i||this._getPointCloudRendererTitle(e),infos:[]},e.colorClassBreakInfos.forEach((e=>{s.infos.unshift({label:e.label||e.minValue+" - "+e.maxValue,value:[e.minValue,e.maxValue],symbol:this._getAppliedCloneSymbol(te,e.color)})}));else if(fe(e)){const t=e.stops;let l=null;if(t?.length&&(1===t.length&&(l=t[0].color),!l)){const e=t[0].value,i=t[t.length-1].value;if(null!=e&&null!=i){const s=e+(i-e)/2;l=U.getColorFromPointCloudStops(s,t)}}s={type:"symbol-table",title:null,infos:[{label:null,value:null,symbol:this._getAppliedCloneSymbol(te,l||te.color)}]};const n=U.getRampStopsForPointCloud(e.stops??[])??[];r={type:"color-ramp",title:i||this._getPointCloudRendererTitle(e),infos:n,preview:M.renderColorRampPreviewHTML(n.map((e=>e.color)),{ariaLabel:await Pe("previewColorRampAriaLabel")})}}else me(e)&&(s={type:"symbol-table",title:i||this._getPointCloudRendererTitle(e),infos:[]},e.colorUniqueValueInfos?.forEach((e=>{s.infos.push({label:e.label||e.values.join(", "),value:e.values.join(", "),symbol:this._getAppliedCloneSymbol(te,e.color)})})));s?.infos.length&&l.push(s),r?.infos.length&&l.push(r);const n=l.reduce(((e,t)=>[...e,...t.infos??[]]),[]).filter((e=>!!e.symbol)).map((t=>this._getSymbolPreview(t,this.opacity,{symbolConfig:{applyColorModulation:!!e.colorModulation}})));return await Promise.allSettled(n),l}async _getElementInfoForDotDensity(e,t){const{color:i,label:l,valueExpressionTitle:s}=t,{backgroundColor:r,outline:n,dotSize:a}=e,o=this.effectList,u=o?.effects.map((e=>e.toJSON())),c=v.effectFunctionsFromJSON(u),d=await Pe("previewTemplateAriaLabel",l||s),y=a+"-"+i+"-"+r+"-"+(n&&JSON.stringify(n.toJSON()))+"-"+c,h=this._dotDensityUrlCache,p=h.has(y)?h.get(y):M.renderDotDensityPreviewHTML(e,i,{ariaLabel:d});h.set(y,p);const f={shape:{type:"image",x:0,y:0,width:p.width,height:p.height,src:p.src},fill:null,stroke:null,offset:[0,0]},m=P.renderSymbol([[f]],[p.width,p.height],{effectView:this.effectList,ariaLabel:d});return{opacity:1,src:p.src,preview:m,width:p.width,height:p.height}}async _constructDotDensityRendererLegendElements(e){const t=e.calculateDotValue(this.view.scale),i=e.legendOptions?.unit,l={type:"symbol-table",title:{value:t&&Math.round(t),unit:i||""},infos:[]};for(const s of e.attributes){const t=await this._getElementInfoForDotDensity(e,s);t.label=s.label||s.valueExpressionTitle||s.field,l.infos.push(t)}return[l]}async _constructPieChartRendererLegendElements(e){const t=this.layer.opacity,i=[];let l=null;const s=e.outline;e.attributes.forEach((e=>{const t=new $({color:e.color,outline:s}),l=e.label||e.valueExpressionTitle||e.field;i.push({label:l,symbol:t})}));const r=i.length?[...i]:[];if(e.othersCategory?.color&&0!==e.othersCategory?.threshold){const t=new $({color:e.othersCategory.color,outline:s});l=e.othersCategory.label||"Other",i.push({label:l,symbol:t})}if(e.defaultColor?.a){const t=new $({color:e.defaultColor,outline:s});i.push({label:e.defaultLabel,symbol:t})}const n=await this._getVisualVariableLegendElements(e,this.layer)||[];if(i.length){n.unshift({type:"symbol-table",title:null,infos:i});const t=r.filter((e=>e.label!==l)).map((e=>e.symbol.color)).filter(Boolean),a=M.renderPieChartPreviewHTML(t,{holePercentage:e.holePercentage,backgroundColor:e.backgroundFillSymbol?.color,effectList:this.effectList,outline:s,ariaLabel:await Pe("previewPieChartAriaLabel")});n.unshift({type:"pie-chart-ramp",title:this._getRendererTitle(e,this.layer),infos:i,preview:a})}const a=n.reduce(((e,t)=>[...e,...this._getAllInfos(t)]),[]).filter((e=>!!e?.symbol&&!e?.preview)).map((e=>this._getSymbolPreview(e,t,{effectList:this.effectList})));return await Promise.allSettled(a),n}async _constructRendererLegendElements(e,t={}){const{title:i,sublayer:l}=t,s=l||this.layer,r=N.getReferenceSizeAuthoringInfoVisualVariable(e);if("definitionExpression"in s){const t=s.definitionExpression;if(t&&this.respectLayerDefinitionExpression&&ce(e)){if(this._layerDefinitionExpression!==t){this._layerDefinitionExpressionClause=await m.parseWhereClause(t,s.fieldsIndex);const i=new Set((await C.getRendererFields(e,s.fieldsIndex)).map((e=>e.toLowerCase()))),l=this._layerDefinitionExpressionClause?.fieldNames.map((e=>e.toLowerCase()));l?.every((e=>i.has(e)))||(this._layerDefinitionExpressionClause=null,l?.length&&y.getLogger(this).warn("Definition expression will be ignored in the Legend, as fields in the expression do not match with renderer fields"))}}else this._layerDefinitionExpressionClause=null;this._layerDefinitionExpression=t}this._hasColorRamp=!1,this._hasOpacityRamp=!1,this._hasSizeRamp=!1,this._scaleDrivenSizeVariable=null;const n=await this._getVisualVariableLegendElements(e,s)||[],a={type:"symbol-table",title:i||this._getRendererTitle(e,s),infos:[]};let o=null,u=!1;const c=new Set;if(le(e)&&!this._hasSizeRamp){const t=await N.getSymbolForFlowRenderer(e);a.infos.push({label:null,symbol:t})}else if(De(e)){let t=i;const l=Te(e)?"univariate-above-and-below-ramp":"univariate-color-size-ramp",s=n.findIndex((e=>"color-ramp"===e.type)),r=-1!==s?n.splice(s,1)[0]:null,a=n.findIndex((e=>"size-ramp"===e.type)),o=-1!==a?n.splice(a,1)[0]:null,u=[];r&&(t=r.title,u.push(r)),o&&(t=o.title,u.push(o)),u.length>0&&n.push({type:l,title:t,infos:u})}else if(de(e)){const t=k.getHeatmapRampStops(e);n.push({type:"heatmap-ramp",title:i||this._getRendererTitle(e,s),infos:t,preview:M.renderColorRampPreviewHTML(t.map((e=>e.color)),{effectList:this.effectList,ariaLabel:await Pe("previewColorRampAriaLabel")})})}else if(ce(e)){const t=e.authoringInfo;if(t&&"relationship"===t.type){const{numClasses:i,field1:l,field2:r}=t,o=t.focus;if(i&&l&&r){const t=[l,r];let u=B.getRotationAngleForFocus(o)||0;for(const e of t){const{field:t,normalizationField:i,label:l}=e,r=l||{field:this._getFieldAlias(t,s),normField:i&&this._getFieldAlias(i,s)},n=Oe.clone();n.angle=u,a.infos.push({label:r,symbol:n}),c.add(n),u+=90}const d=B.getRelationshipRampElement({focus:o,numClasses:i,infos:e.uniqueValueInfos??[]});n.unshift(d)}}else if(Ie(this.layer)||Fe(this.layer))e.uniqueValueInfos?.forEach((t=>{t.symbol&&this._checkDefinitionExpressionForUVR(e,t.value)&&a.infos.push({label:t.label||t.value,value:t.value,symbol:t.symbol})}));else{const{field:t,field2:l,field3:n,fieldDelimiter:o,valueExpression:c,defaultSymbol:d}=e,y=!(!t&&!c||!l&&!n),h=[];if(e.uniqueValueGroups?.forEach((i=>{const a={type:"symbol-table",title:i.heading,infos:[]};i.classes?.forEach((i=>{const{symbol:u,values:d}=i;if(u){const h=[],p=[];for(const e of d??[]){const{value:i,value2:r,value3:a}=e,u=[],d=[];(t||c)&&(u.push(i),d.push(this._getDomainName(t,i,s))),l&&(u.push(r),d.push(this._getDomainName(l,r,s))),n&&(u.push(a),d.push(this._getDomainName(n,a,s))),h.push(y?u.join(o||""):u[0]),p.push(d.join(" - "))}const f=h.join(", ");let m=i.label;if(!m){const e=p.filter(Boolean);m=e.length?e.join(", "):f}const g=u.clone();"cim"===g.type&&r&&D.updateReferenceSizeSymbol(g,{innerDotSize:.5*J,outerRingSize:J}),h.some((t=>this._checkDefinitionExpressionForUVR(e,t)))&&a.infos.push({label:m,value:f,symbol:g})}})),a.infos.length&&h.push(a)})),h.length){const t=h[0];1===h.length&&"title"in t&&!t.title?a.infos.push(...t.infos??[]):(d&&(h.push({type:"symbol-table",infos:[{label:e.defaultLabel||"others",symbol:d}]}),u=!0),a.infos.push(...h)),i||e.legendOptions?.title||e.valueExpressionTitle||(a.title=null)}}e.defaultSymbol&&!u&&(a.infos.push({label:e.defaultLabel||"others",symbol:e.defaultSymbol}),u=!0)}else if(ue(e)){if(!r){o=this._isUnclassedRenderer(e);if(!o||!this._hasSizeRamp){const t=e.classBreakInfos.filter((({symbol:e})=>e));for(const{label:e,minValue:i,maxValue:l,symbol:s}of t)a.infos.unshift({label:e||(o?null:`${i} - ${l}`),value:[i,l],symbol:s});o&&(a.title=null),this._updateInfosForClassedSizeRenderer(e,a.infos)}e.defaultSymbol&&!o&&(a.infos.push({label:e.defaultLabel||"others",symbol:e.defaultSymbol}),u=!0)}}else if(ne(e))if(Fe(this.layer)||Ve(this.layer)){const t=await this._constructTileImageryStretchRendererElements(e);xe(t)?n.push(t):a.infos=t}else{const t=this.layer;let i,l;e.customStatistics?.length&&({min:i,max:l}=e.customStatistics[0]);let s=[],r=t.serviceRasterInfo;if(t.rasterFunction)try{r=await t.generateRasterInfo(t.rasterFunction)}catch{}const o=R.getPixelValueRange(r.pixelType);if(1===r.bandCount){const s=t.bandIds?.[0]||0;i=null!=i?i:r.statistics?r.statistics[s].min:o[0],l=null!=l?l:r.statistics?r.statistics[s].max:o[1],i||l?n.push(await this._getStretchLegendElements(e,{min:i,max:l})):this._getServerSideLegend()}else if(t.bandIds&&1===t.bandIds.length)i=null!=i?i:r.statistics?r.statistics[t.bandIds[0]].min:o[0],l=null!=l?l:r.statistics?r.statistics[t.bandIds[0]].max:o[1],i||l?n.push(await this._getStretchLegendElements(e,{min:i,max:l})):this._getServerSideLegend();else if(r.bandCount>=3){const{bandInfos:e}=r,{bandIds:i}=t;e.length>=r.bandCount?3===i?.length?(s=i.map((t=>e[t].name)),a.infos=this._createSymbolTableElementMultiBand(s)):"lerc"===t.format?(s=[0,1,2].map((t=>e[t].name)),a.infos=this._createSymbolTableElementMultiBand(s)):this._getServerSideLegend():"lerc"===t.format?(s=["band1","band2","band3"],a.infos=this._createSymbolTableElementMultiBand(s)):this._getServerSideLegend()}else this._getServerSideLegend()}else if(re(e))e.colormapInfos.forEach((e=>{a.infos.push({label:e.label,value:e.value,symbol:this._getAppliedCloneSymbol(ie,e.color)})}));else if(oe(e)){let i=e.symbol;switch(t.geometryType){case"point":i="pointSymbol"in s?s.pointSymbol:null;break;case"polyline":i="lineSymbol"in s?s.lineSymbol:null;break;case"polygon":i="polygonSymbol"in s?s.polygonSymbol:null}const l=this._hasClusterSizeVariable&&this._getClusterSymbol()||!this._hasSizeRamp;e.symbol&&l&&a.infos.push({label:e.label,symbol:i})}else if(se(e)){e.outputUnit&&(this.title="("+e.toJSON().outputUnit+")"),a.title=e.attributeField;const t=e.getClassBreakInfos();t?.length?t.forEach((e=>{a.infos.push({label:e.minValue+" - "+e.maxValue,symbol:e.symbol})})):a.infos.push({label:e.attributeField,symbol:e.getDefaultSymbol()})}else ae(e)&&n.push(await this._getStretchLegendElements(e,{min:0,max:255}));const d=e.defaultSymbol;!d||u||oe(e)||o&&!this._hasColorRamp&&!this._hasSizeRamp&&!this._hasOpacityRamp||n.push({type:"symbol-table",infos:[{label:e.defaultLabel||"others",symbol:d}]}),a.infos.length&&n.unshift(a);const h=null==t.opacity?this.opacity:t.opacity,p=this._isTallSymbol("visualVariables"in e?e.visualVariables:null),f=Ie(this.layer)||Fe(this.layer),g=n.reduce(((e,t)=>[...e,...this._getAllInfos(t)]),[]).filter((e=>!!e?.symbol)).filter((e=>{if("cim"===e.symbol.type){const{minScale:t,maxScale:i}=e.symbol.data;if(t&&t<this.scale||i&&i>this.scale)return!1}return!0})).map((e=>this._getSymbolPreview(e,h,{isDefault:e.symbol===d,applyScaleDrivenSize:!c.has(e.symbol),symbolConfig:{isTall:p,isSquareFill:f},effectList:c.has(e.symbol)?null:this.effectList})));return e=null,await Promise.allSettled(g),n}_checkDefinitionExpressionForUVR(e,t){if(!this._layerDefinitionExpressionClause)return!0;const i=Me(e,t);return(i&&this._layerDefinitionExpressionClause.testFeature(i))??!0}_getServerSideLegend(){setTimeout((()=>this.buildLegendElementsForTools()),0)}_getAllInfos(e){const t=e?.infos;return t?t.reduce(((e,t)=>e.concat(this._getAllInfos(t))),[]):[e]}async _constructTileImageryStretchRendererElements(e){const t=this.layer,i=t.symbolizer.rasterInfo??t.raster.rasterInfo;let l,s;const r=e?.customStatistics?.length?e.customStatistics:i?.statistics;if(r)({min:l,max:s}=r[0]);else{const e=R.getPixelValueRange(i.pixelType);l=e[0],s=e[1]}if(t.hasStandardTime()&&(l=t.getStandardTimeValue(l),s=t.getStandardTimeValue(s)),1===i.bandCount||1===t.bandIds?.length)return this._getStretchLegendElements(e,{min:l,max:s});const n=(t?.bandIds?.length?t.bandIds:Array.from(Array(Math.min(i.bandCount,3)).keys())).map((e=>i.bandInfos[e].name));return n.length<3?n.push(n[1]):n.length>3&&n.splice(3),this._createSymbolTableElementMultiBand(n)}async _getStretchLegendElements(e,t){const i=e.colorRamp,l=U.getStretchRampStops(i,t);return{type:"stretch-ramp",title:"",infos:l,preview:M.renderColorRampPreviewHTML(l.map((e=>e.color)),{ariaLabel:await Pe("previewColorRampAriaLabel")})}}_getClusterSymbol(){const e=this.layer,t="featureReduction"in e&&e.featureReduction,i=t&&"symbol"in t&&t.renderer;return i&&!0!==i?.authoringInfo?.isAutoGenerated?null:t&&"symbol"in t?t.symbol:null}async _getSizeLegendElement(e,t,i,l){return{type:"size-ramp",title:this._hasClusterSizeVariable?this._getClusterTitle(t):e,infos:await H.getRampStops(i,t,await N.getMedianColor(i),this.scale,this.view,l,this._hasClusterSizeVariable?this._getClusterSymbol():null)}}_createSymbolTableElementMultiBand(e){const t=[],i=["red","green","blue"];return e.forEach(((e,l)=>{t.push({label:{colorName:i[l],bandName:e},src:N.rgbImgSource[l],opacity:this.opacity??1})})),t}_updateInfosForClassedSizeRenderer(e,t){const i=e.authoringInfo&&"class-breaks-size"===e.authoringInfo.type,l=e.classBreakInfos.some((e=>O.isVolumetricSymbol(e.symbol)));if(i&&l){const i=H.realWorldMaxSize,l=H.realWorldMinSize,s=e.classBreakInfos.length,r=(i-l)/(s>1?s-1:s);t.forEach(((e,t)=>{e.size=i-r*t}))}}_isTallSymbol(e){let t=!1,i=!1;if(e)for(let l=0;l<e.length&&(!t||!i);l++){const s=e[l];"size"===s.type&&("height"===s.axis&&(t=!0),"width-and-depth"===s.axis&&(i=!0))}return t&&i}async _getSymbolPreview(t,i,l){let s=!l?.isDefault&&null==t.size&&this._hasSizeRamp?f.px2pt(z.SymbolSizeDefaults.size):t.size;if(this._scaleDrivenSizeVariable&&l?.applyScaleDrivenSize){const{getSize:i}=await new Promise(((t,i)=>e(["../../../renderers/visualVariables/support/visualVariableUtils"],t,i)));s=i(this._scaleDrivenSizeVariable,null,{view:this.view.type,scale:this.scale,shape:"simple-marker"===t.symbol.type?t.symbol.style:null})}const r=!l?.isDefault&&this._hasSizeRamp||!(!this._scaleDrivenSizeVariable||!l?.applyScaleDrivenSize);return M.renderPreviewHTML(t.symbol,{size:s,opacity:i,scale:!1,symbolConfig:l?.symbolConfig,effectView:l?.effectList,style:"legend",cimOptions:{allowScalingUp:r,viewParams:this.isScaleDriven?{viewingMode:"2d"===this.view?.type?"map":this.view?.viewingMode,scale:this.view?.scale}:null},ariaLabel:t.label&&"string"!=typeof t.label?null:await Pe("previewTemplateAriaLabel",t.label)}).then((e=>(t.preview=e,t))).catch((()=>(t.preview=null,t)))}_getClusterRenderer(e){this._hasClusterSizeVariable=!1;const t="renderer"in this.layer?this.layer.renderer:null,i=e.renderer?.clone()||t?.clone(),l=A.getEffectiveClusterSizeVariable(e,this.layerView,this.view);if(l&&null!=i&&"visualVariables"in i){const t=i.visualVariables?.some((e=>"size"===e.type&&"outline"!==e.target&&!Y.test(e.valueExpression)));if(!t){if("clusterMinSize"in e&&"clusterMaxSize"in e){const{clusterMinSize:t,clusterMaxSize:i}=e;l.legendOptions=new x({showLegend:t!==i})}const t=i.visualVariables||[];i.visualVariables=t.concat([l]),this._hasClusterSizeVariable=!0}}return i}async _loadRenderer(e){const t=[],i=e.clone(),l=await N.getMedianColor(i);if(ue(i)||ce(i)){const e=(i.classBreakInfos||i.uniqueValueInfos).map((e=>this._fetchSymbol(e.symbol,l).then((t=>{e.symbol=t})).catch((()=>{e.symbol=null}))));Array.prototype.push.apply(t,e)}return t.push(this._fetchSymbol(i.symbol||i.defaultSymbol,i.defaultSymbol?null:l).then((e=>{this._applySymbolToRenderer(i,e,oe(i))})).catch((()=>{this._applySymbolToRenderer(i,null,oe(i))}))),await Promise.allSettled(t),i}_applySymbolToRenderer(e,t,i){i?e.symbol=t:e.defaultSymbol=t}async _fetchSymbol(e,t){if(!e)throw new Error;if("web-style"===e.type){const i=this._webStyleSymbolCache;try{const l=await("2d"===this.view.type?e.fetchCIMSymbol({cache:i}):e.fetchSymbol({cache:i}));return this._getAppliedCloneSymbol(l,t)}catch{throw y.getLogger(this).warn("Fetching web-style failed!"),new Error}}return this._getAppliedCloneSymbol(e,t)}_getAppliedCloneSymbol(e,t){if(!e||!t)return e;const l=e.clone(),s=t&&t.toRgba();return l.type.includes("3d")?this._applyColorTo3dSymbol(l,s):"cim"===l.type?T.applyCIMSymbolColor(l,t):l.color&&(l.color=new i(s||l.color)),l}_applyColorTo3dSymbol(e,t){t&&e.symbolLayers.forEach((e=>{e&&(e.material||(e.material={}),e.material.color=new i(t))}))}async _getVisualVariableLegendElements(e,t){if(!("visualVariables"in e)||"vector-field"===e.type)return null;const i=e.visualVariables??[],l=[],s=[],r=[],n=N.getReferenceSizeAuthoringInfoVisualVariable(e);if(2===n?.sizeStops?.length&&(ue(e)||ce(e))){const[e,t]=n.sizeStops;s.push(new V({field:n.field??void 0,normalizationField:n.normalizationField,minSize:e.size,maxSize:t.size,minDataValue:e.value,maxDataValue:t.value}))}for(const o of i)"color"===o.type?l.push(o):"size"===o.type?s.push(o):"opacity"===o.type&&r.push(o);const a=[...l,...s,...r];let u,c;if(0===l.length&&ue(e)&&e.classBreakInfos&&1===e.classBreakInfos.length){const t=e.classBreakInfos[0];u=t&&t.symbol}if(0===l.length&&oe(e)&&(u=e.symbol),u)if(u.type.includes("3d")){const e=u.symbolLayers.at(0);"water"===e.type?null!=e.color&&(c=e.color):null!=e.material?.color&&(c=e.material.color)}else u.url||(c=u.color);const d=this.effectList;return(await Promise.all(a.map((async i=>{if(!i.legendOptions||!1!==i.legendOptions.showLegend){const l=le(e)?i.field:this._getRampTitle(i,t);let s=null;const r=N.getDateFormatOptions(t,i,this.view.timeZone);if("color"===i.type){const e=await U.getRampStops(i,null,r)??[];s={type:"color-ramp",title:l,infos:e,preview:M.renderColorRampPreviewHTML(e.map((e=>e.color)),{effectList:d,ariaLabel:await Pe("previewColorRampAriaLabel")})},this._hasColorRamp||(this._hasColorRamp=e.length>0)}else if("size"===i.type&&"outline"!==i.target)Y.test(i.valueExpression)?this._hasClusterSizeVariable||(this._scaleDrivenSizeVariable=i):(s=await this._getSizeLegendElement(l,i,e,r),this._hasSizeRamp||(this._hasSizeRamp=!(null==s.infos||!s.infos.length)));else if("opacity"===i.type){const e=await U.getRampStops(i,c,r)??[];s={type:"opacity-ramp",title:l,infos:e,preview:M.renderColorRampPreviewHTML(e.map((e=>e.color)),{effectList:d,ariaLabel:await Pe("previewColorRampAriaLabel")})},this._hasOpacityRamp||(this._hasOpacityRamp=e.length>0)}return s?.infos?s:null}})))).filter(o.isSome)}_getDomainName(e,t,i){if(e&&"function"!=typeof e){const l="getField"in i&&i.getField?.(e),s=l&&"getFieldDomain"in i&&i.getFieldDomain?i.getFieldDomain(l.name,{excludeImpliedDomains:c("esri-widget-legacy-field-domain-calculation")}):null;return"coded-value"===s?.type?s.getName(t):null}return null}_getClusterTitle(e){const t=this.layer,i=e.field;if("featureReduction"in t&&t.featureReduction&&"cluster"===t.featureReduction.type){const e=t.featureReduction,l="popupTemplate"in e&&e.popupTemplate,s=l&&l.fieldInfos;if(s)for(const t of s)if(t.fieldName===i)return"cluster_count"===i?t.label||{showCount:!0}:t.label}return{showCount:!0}}_getRampTitle(e,t){let i=e.field,l=e.normalizationField,s=!1,r=!1,n=!1,a=null;i="function"==typeof i?null:i,l="function"==typeof l?null:l;const o=e.legendOptions?.title;if(null!=o)a=o;else if(e.valueExpressionTitle)a=e.valueExpressionTitle;else{if("renderer"in t&&t.renderer&&"authoringInfo"in t.renderer&&t.renderer.authoringInfo?.visualVariables){const e=t.renderer.authoringInfo.visualVariables;for(let t=0;t<e.length;t++){const i=e[t];if("color"===i.type){if("ratio"===i.style){s=!0;break}if("percent"===i.style){r=!0;break}if("percent-of-total"===i.style){n=!0;break}}}}a={field:i&&this._getFieldAlias(i,t),normField:l&&this._getFieldAlias(l,t),ratio:s,ratioPercent:r,ratioPercentTotal:n}}return a}_getRendererTitle(e,t){const i=e;if(i.legendOptions?.title)return i.legendOptions.title;if(i.valueExpressionTitle)return i.valueExpressionTitle;let l=i.field,s=null,r=null;if(ue(i)&&(s=i.normalizationField,r="percent-of-total"===i.normalizationType),l="function"==typeof l?null:l,s="function"==typeof s?null:s,ce(i)){const{field2:e,field3:s,fieldDelimiter:r}=i;let n=l&&this._getFieldAlias(l,t);return e&&(n=`<${n}>${r}<${this._getFieldAlias(e,t)}>`,s&&(n=`${n}${r}<${this._getFieldAlias(s,t)}>`)),n}let n=null;return(l||s)&&(n={field:l&&this._getFieldAlias(l,t),normField:s&&this._getFieldAlias(s,t),normByPct:r}),n}_getFieldAlias(e,t){const i="popupTemplate"in t?t.popupTemplate:null,l=i?.fieldInfos;let s=l?.find((t=>e===t.fieldName)),r=null;"getField"in t&&t.getField?r=t.getField(e):"fieldsIndex"in t&&t.fieldsIndex&&(r=t.fieldsIndex.get(e));let n=null;const a="featureReduction"in t&&t.featureReduction;a&&(s??="popupTemplate"in a?a.popupTemplate?.fieldInfos?.find((t=>e?.toLowerCase()===t.fieldName?.toLowerCase())):void 0,"fields"in a&&a.fields&&(n=a.fields.find((t=>t.name?.toLowerCase()===e?.toLowerCase()))));const o=s||r||n;let u=null;return o&&(u=s?.label||r?.alias||n?.alias||"name"in o&&o.name||"fieldName"in o&&o.fieldName||null),u}_isUnclassedRenderer(e){const t=e.visualVariables;let i=!1;return ue(e)&&e.classBreakInfos&&1===e.classBreakInfos.length&&t&&(i=e.field?t.some((t=>!(!t||e.field!==t.field||(e.normalizationField||t.normalizationField)&&e.normalizationField!==t.normalizationField))):!!t.length),i}};t.__decorate([b.property()],Ue.prototype,"children",void 0),t.__decorate([b.property({readOnly:!0})],Ue.prototype,"effectList",null),t.__decorate([b.property()],Ue.prototype,"layerView",void 0),t.__decorate([b.property()],Ue.prototype,"layer",void 0),t.__decorate([b.property()],Ue.prototype,"legendElements",void 0),t.__decorate([b.property({readOnly:!0})],Ue.prototype,"opacity",null),t.__decorate([b.property()],Ue.prototype,"parent",void 0),t.__decorate([b.property({readOnly:!0,dependsOn:[]})],Ue.prototype,"ready",null),t.__decorate([b.property()],Ue.prototype,"hideLayersNotInCurrentView",void 0),t.__decorate([b.property()],Ue.prototype,"keepCacheOnDestroy",void 0),t.__decorate([b.property()],Ue.prototype,"respectLayerDefinitionExpression",void 0),t.__decorate([b.property()],Ue.prototype,"respectLayerVisibility",void 0),t.__decorate([b.property({readOnly:!0})],Ue.prototype,"scale",null),t.__decorate([b.property()],Ue.prototype,"sublayerIds",void 0),t.__decorate([b.property({readOnly:!0})],Ue.prototype,"isScaleDriven",null),t.__decorate([b.property()],Ue.prototype,"title",void 0),t.__decorate([b.property({readOnly:!0,dependsOn:["ready"],value:0})],Ue.prototype,"version",null),t.__decorate([b.property()],Ue.prototype,"view",void 0),Ue=t.__decorate([S.subclass("esri.widgets.Legend.support.ActiveLayerInfo")],Ue);return Ue}));
