/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../intl","../core/a11yUtils","../core/deprecate","../core/Logger","../core/mathUtils","../core/reactiveUtils","../core/accessorSupport/decorators/property","../core/has","../core/RandomLCG","../core/accessorSupport/decorators/subclass","../layers/orientedImagery/transformations/utils","../layers/support/rasterDatasets/RasterFactory","./Widget","./OrientedImageryViewer/arcUtils","./OrientedImageryViewer/constants","./OrientedImageryViewer/css","./OrientedImageryViewer/OrientedImageryViewerViewModel","./OrientedImageryViewer/OrientedImageryViewerVisibleElements","./OrientedImageryViewer/components/ImageOverlays","../chunks/componentsUtils","./support/globalCss","./support/widgetUtils","./support/decorators/messageBundle","./support/jsxFactory","../intl/substitute"],(function(e,t,i,s,a,r,o,n,l,c,d,h,g,m,v,p,u,y,_,w,b,C,M,x,I,O,A){"use strict";const f={overlayMapFeatures:"overlay-map-features",overlayed:"overlayed"};let T=class extends v{constructor(e,t){super(e,t),this.galleryOpened=!1,this.imageEnhancementToolActive=!1,this.imageOverlaysOpened=!1,this.navigationToolActive=!1,this.viewModel=new _,this.messagesCommon=null,this.visibleElements=new w,this._navigationToolExpanded=!1,this._navigationTool=null,this._imageOverlays=new b,this._warningTitleElement=null,this._actionItems=new Map,this._galleryController=new AbortController,this._galleryObserver=new IntersectionObserver(this._lazyLoadImage.bind(this)),this._createAndAddOverlayLayerVisibilityHandle=e=>{this.addHandles(n.watch((()=>e.visible),(()=>{this.viewModel.toggleOverlayMapFeatures(e.id,e.visible)})),`${f.overlayed}-${e.id}`)},this._createHandlesForOverlayMapFeatures=()=>{this.viewModel.removeAllOverlayMapFeatures();const{selectedItems:e}=this._imageOverlays.layerList;e.forEach(this._handleOverlayLayerSelect)},this._createOverlayLayersListChangeHandle=()=>{this.addHandles(this._imageOverlays.layerList.selectedItems.on("change",(({added:e,removed:t})=>{e.forEach(this._handleOverlayLayerSelect),t.forEach(this._handleOverlayLayerDeselect)})))},this._handleOverlayLayerDeselect=e=>{const t=e.layer;this.viewModel.removeOverlayedGraphicsOnImage(`${t.id}`),this.removeHandles(`${f.overlayed}-${t.id}`)},this._handleOverlayLayerSelect=e=>{const t=e.layer;this.viewModel.overlayMapFeatures(t,this._imageOverlays.showMapFeatures),this._createAndAddOverlayLayerVisibilityHandle(t)},this._highlight=e=>{const t=e.target?.dataset.objectid;t&&this.viewModel.highlight(t)},this._removeHighlight=()=>this.viewModel.removeHighlight(),this._scaleNavigationTool=()=>{this._navigationToolExpanded=!this._navigationToolExpanded},this._toggleImageAttributes=()=>{this.viewModel.toggleImageAttributes()},this._loadImageFromGallery=this._loadImageFromGallery.bind(this),this._registerGalleryItem=this._registerGalleryItem.bind(this),this._unregisterGalleryItem=this._unregisterGalleryItem.bind(this),this._renderViewerContainer=this._renderViewerContainer.bind(this),this.loadImageFromSource=this.loadImageFromSource.bind(this),this.updateSuitabilities=this.updateSuitabilities.bind(this)}initialize(){this._createOverlayLayersListChangeHandle(),this.addHandles([n.watch((()=>[this.viewModel?.bestFeatureAngle,this._navigationTool]),(([e,t])=>{t&&this._updateNavigationTool(t)}),n.initial),n.watch((()=>this.currentCoverageVisible),(e=>this._onCurrentCoverageVisibilityChange(e))),n.watch((()=>this.isAdditionalCoverageVisible),(e=>this._onAdditionalCoverageVisibilityChange(e))),n.watch((()=>this.isAdditionalPointSourcesVisible),(e=>this._onAdditionalCameraLocationsVisibility(e))),n.watch((()=>this.viewModel),(()=>this._imageOverlays.viewModel=this.viewModel),n.syncAndInitial),n.watch((()=>this.messages),(()=>this._imageOverlays.messages=this.messages),n.syncAndInitial),n.watch((()=>[this.currentBestFeature,this._imageOverlays.showCameraLocations,this.viewModel.state]),(([e,t,i])=>{"image-loaded"===i&&this.viewModel.overlayCameraLocations(t)}),n.syncAndInitial),n.watch((()=>[this.currentBestFeature,this._imageOverlays.showMapFeatures,this.viewModel.state]),((e,t)=>{t?.[1]!==e[1]&&this.viewModel.toggleAllOverlayMapFeatures(e[1]),e[0]&&e[0]!==t?.[0]&&n.whenOnce((()=>"image-loaded"===this.viewModel.state)).then(this._createHandlesForOverlayMapFeatures)}),n.initial)])}loadDependencies(){return C.loadCalciteComponents({"action-bar":()=>new Promise(((t,i)=>e(["../chunks/calcite-action-bar"],t,i))),"action-group":()=>new Promise(((t,i)=>e(["../chunks/calcite-action-group"],t,i))),action:()=>new Promise(((t,i)=>e(["../chunks/calcite-action"],t,i))),label:()=>new Promise(((t,i)=>e(["../chunks/calcite-label"],t,i))),notice:()=>new Promise(((t,i)=>e(["../chunks/calcite-notice"],t,i))),panel:()=>new Promise(((t,i)=>e(["../chunks/calcite-panel"],t,i))),slider:()=>new Promise(((t,i)=>e(["../chunks/calcite-slider"],t,i))),tooltip:()=>new Promise(((t,i)=>e(["../chunks/calcite-tooltip"],t,i)))})}destroy(){this._galleryController.abort(),this._galleryObserver.disconnect()}get activeLayer(){return a.deprecatedProperty(r.getLogger(this),"activeLayer",{replacement:"layer"}),this.layer}set activeLayer(e){a.deprecatedProperty(r.getLogger(this),"activeLayer",{replacement:"layer"}),this.layer=e}get currentBestFeature(){return this.viewModel.currentBestFeature}set currentBestFeature(e){this.viewModel.currentBestFeature=e}get currentCoverageVisible(){return this.viewModel.currentCoverageVisible}set currentCoverageVisible(e){this.viewModel.currentCoverageVisible=e}get disabled(){return this.viewModel.disabled}set disabled(e){this.viewModel.disabled=e}get displayMessage(){return this.viewModel.displayMessage}get features(){return this.viewModel.features}get imagePointsInView(){return this.viewModel.imagePointsInView}get icon(){return"oriented-imagery-widget"}set icon(e){this._overrideIfSome("icon",e)}get imageGalleryEnabled(){return this.viewModel.imageGalleryEnabled}get invalidCameraHeading(){return this.viewModel.invalidCameraHeading}get isAdditionalCoverageVisible(){return this.viewModel.isAdditionalCoverageVisible}set isAdditionalCoverageVisible(e){this.viewModel.isAdditionalCoverageVisible=e}get isAdditionalPointSourcesVisible(){return this.viewModel.isAdditionalPointSourcesVisible}set isAdditionalPointSourcesVisible(e){this.viewModel.isAdditionalPointSourcesVisible=e}get mapImageConversionToolState(){return this.viewModel.mapImageConversionToolState}set mapImageConversionToolState(e){this.viewModel.mapImageConversionToolState=e}get layer(){return this.viewModel.layer}set layer(e){this.viewModel.layer=e}get popupEnabled(){const{popupEnabled:e,state:t}=this.viewModel;return"image-loaded"===t&&e}get referencePoint(){return this.viewModel.referencePoint??null}get view(){return this.viewModel.view}set view(e){this.viewModel.view=e}set determineWorkflowForFeature(e){this.viewModel.determineWorkflowForFeature=e}get determineWorkflowForFeature(){return this.viewModel.determineWorkflowForFeature}set updateFootprint(e){this.viewModel.updateFootprint=e}get updateFootprint(){return this.viewModel.updateFootprint}async _getThumbnailPixelBlockInternal(e,t){const{level:i,offset:s,size:a}=this._getMaxLevelRasterParameters(e);try{const{pixelBlock:r}=await e.fetchRawPixels(i,s,a,t);return r}catch(o){r.getLogger(this).warn("failed to create canvas with pixel data",o)}return null}_getMaxLevelRasterParameters(e){const{storageInfo:t,width:i,height:s}=e.rasterInfo,{maximumPyramidLevel:a,pyramidScalingFactor:r}=t,o=r??2;return{level:a,offset:{x:0,y:0},size:{width:Math.ceil(i/o**a),height:Math.ceil(s/o**a)}}}async _getThumbnailPixelBlock(e){const{signal:t}=this._galleryController;try{const{origin:i,pathname:s,searchParams:a}=new URL(e),r=await m.open({ioConfig:{customFetchParameters:Object.fromEntries(a),skipMapInfo:!0},url:`${i}${s}`,signal:t});return r?await this._getThumbnailPixelBlockInternal(r,{signal:t}):null}catch(i){r.getLogger(this).error("failed to create thumbnail",i)}return null}_handleBrightnessChange(e){this.viewModel.brightness=e.target.value??0}_handleContrastChange(e){this.viewModel.contrast=e.target.value??0}_handleSharpnessChange(e){this.viewModel.sharpness=e.target.value??0}_lazyLoadImage(e,t){e.forEach((async e=>{if(e.isIntersecting){const i=e.target,s=i.getAttribute("data-src"),a=i.getAttribute("data-rotation"),n=a?parseFloat(a)%360:null;if(!s)return;const l=await this._getThumbnailPixelBlock(s);if(!l)return;i.width=l.width,i.height=l.height;const c=i.getContext("2d");if(!c)return;const d=c.createImageData(i.width,i.height);if(d.data.set(l.getAsRGBA()),"number"==typeof n&&0!==n){const e=o.deg2rad(n),s=document.createElement("canvas"),a=s.getContext("2d");if(a){s.width=d.width,s.height=d.height,a.putImageData(d,0,0);const r=g.rotatePixel(0,0,e),o=g.rotatePixel(d.width,0,e),n=g.rotatePixel(d.width,d.height,e),l=g.rotatePixel(0,d.height,e),h=Math.max(r[0],o[0],n[0],l[0])-Math.min(r[0],o[0],n[0],l[0]),m=Math.max(r[1],o[1],n[1],l[1])-Math.min(r[1],o[1],n[1],l[1]),v=Math.min(i.width/h,i.height/m);return c.save(),c.clearRect(0,0,i.width,i.height),c.translate(i.width/2,i.height/2),c.rotate(e),c.scale(v,v),c.drawImage(s,-d.width/2,-d.height/2,d.width,d.height),c.restore(),t.unobserve(i)}r.getLogger(this).warn("oriented-imagery-viewer:image-gallery","failed to apply rotation on thumbnail")}c.putImageData(d,0,0),t.unobserve(i)}}))}_loadImageFromGallery(e){const{target:t}=e;if(!t)return;const i=t.getAttribute("data-objectid");i&&this.viewModel.currentBestFeature?.attributes.objectId!==Number(i)&&this.viewModel.selectBestFeature(i)}_onAdditionalCoverageVisibilityChange(e){this.viewModel.setAdditionalCoverageVisibility(e)}_onAdditionalCameraLocationsVisibility(e){this.viewModel.setAdditionalCameraLocationsVisibility(e)}_onCurrentCoverageVisibilityChange(e){this.viewModel.setCurrentCoverageVisibility(e)}_registerGalleryItem(e){this._galleryObserver.observe(e)}_renderActionTooltips(){return[...this._actionItems].map((([e,t])=>O.tsx("calcite-tooltip",{key:e,label:e,referenceElement:t},O.tsx("span",null,e))))}_renderBody(){return O.tsx("div",{class:y.css.body},this._renderViewerContainer(),this.invalidCameraHeading?[this._renderWarning(this.messages.invalidCameraHeadingWarningTitle),this._renderWarningTooltip(this.messages.invalidCameraHeadingWarningDescription)]:[this._renderImageGallery(),this._renderNavigation(),this._renderImageOverlays()],this._renderImageEnhancementTools())}_renderImageEnhancementAction(){const{state:e,mode:t}=this.viewModel;return O.tsx("calcite-action",{active:this.imageEnhancementToolActive,afterCreate:this._storeActionElement,bind:this,disabled:"default"!==t||"image-loaded"!==e,icon:"sliders-horizontal",onclick:this._toggleImageEnhancementToolState,text:this.messages.imageEnhancement})}_renderImageEnhancementTools(){const{imageEnhancementToolActive:e,viewModel:{brightness:t,contrast:i,sharpness:s,state:a}}=this;return e&&"image-loaded"===a?O.tsx("calcite-panel",{bind:this,class:y.css.imageEnhancementWrapper,closable:!0,closed:!e,heading:this.messages.imageEnhancement,key:this.messages.imageEnhancement,onCalcitePanelClose:this._toggleImageEnhancementToolState},O.tsx("div",{class:y.css.imageEnhancementTools},O.tsx("div",{class:y.css.imageEnhancementToolContainer},O.tsx("calcite-label",null,this.messages.brightness,O.tsx("calcite-slider",{bind:this,labelTicks:!0,max:10,min:-10,ticks:5,value:t,onCalciteSliderInput:this._handleBrightnessChange}))),O.tsx("div",{class:y.css.imageEnhancementToolContainer},O.tsx("calcite-label",null,this.messages.contrast,O.tsx("calcite-slider",{bind:this,labelTicks:!0,max:10,min:-10,ticks:5,value:i,onCalciteSliderInput:this._handleContrastChange}))),O.tsx("div",{class:y.css.imageEnhancementToolContainer},O.tsx("calcite-label",null,this.messages.sharpness,O.tsx("calcite-slider",{bind:this,labelTicks:!0,max:1,min:0,step:.1,ticks:.5,value:s,onCalciteSliderInput:this._handleSharpnessChange})))),O.tsx("calcite-action",{bind:this,icon:"reset",onclick:this._resetImageTools,slot:"header-actions-end",text:this.messagesCommon.reset})):null}_renderImageGallery(){const{container:e,galleryOpened:t,imageGalleryEnabled:i,viewModel:{thumbnails:s},invalidCameraHeading:a}=this;return i&&t&&(e&&s)?O.tsx("calcite-panel",{bind:this,class:y.css.carousel,closable:!0,closed:!t,disabled:a,heading:this.messages.imageGallery,key:this.messages.imageGallery,onCalcitePanelClose:this._toggleImageGallery},O.tsx("div",{class:y.css.carouselContainer},this._renderThumbnails(s))):null}_renderImageOverlaysAction(){const{viewModel:{state:e},imageOverlaysOpened:t,invalidCameraHeading:i}=this;return O.tsx("calcite-action",{active:t,afterCreate:this._storeActionElement,bind:this,disabled:"image-loaded"!==e||i,icon:"layers",onclick:this._toggleImageOverlays,text:this.messages.imageOverlays})}_renderImageOverlays(){const{imageOverlaysOpened:e,viewModel:{state:t}}=this;if(e&&"image-loaded"===t)return this._imageOverlays.closed&&(this._imageOverlays.closed=!1),n.once((()=>this._imageOverlays.closed)).then((()=>this.imageOverlaysOpened=!1)),O.tsx("div",{class:y.css.imageOverlaysContainer,key:this.messages.imageOverlays},this._imageOverlays.render())}_renderWarning(e){const{invalidCameraHeading:t,viewModel:{state:i}}=this;return t&&"image-loaded"===i?[O.tsx("calcite-notice",{class:y.css.alert,closable:!0,icon:"exclamation-mark-triangle-f",iconFlipRtl:!0,kind:"warning",open:!0,scale:"s"},O.tsx("div",{afterCreate:e=>this._storeWarningTitleElement(e),slot:"title"},e))]:null}_renderWarningTooltip(e){const{_warningTitleElement:t}=this;if(e?.length&&t)return O.tsx("calcite-tooltip",{closeOnClick:!0,referenceElement:t},e)}_renderMapImageConversionTool(){const{mapImageConversionToolState:e,viewModel:{state:t},invalidCameraHeading:i}=this;return O.tsx("calcite-action",{active:e,afterCreate:this._storeActionElement,bind:this,disabled:"image-loaded"!==t||i,icon:"image-pin",onclick:this._toggleMapImageConversionToolState,text:this.messages.mapImageConversionTool})}_renderNavigation(){const{viewModel:{sectorData:e,navigatorCurrentBestFeature:t,currentBestFeature:i,state:a}}=this;if(!this.container||!i)return null;let r,o,n,l,c;if(t){const{x:e,y:i,direction:s}=t,[a,d,h,g]=u.segmentArcs[s];r=`M ${e} ${i} L ${a} ${d} A ${u.sectorsRadii[2]} ${u.sectorsRadii[2]} 0 0 1 ${h} ${g} Z`,o=e,l=i,n=u.segmentArcs[s][4],c=u.segmentArcs[s][5]}const d=e=>{const t=e.target.dataset?.sector;t&&this.viewModel.handleSectorClick(+t)},h=e=>{const t=e.target.dataset;if(!t)return;const{featureIndexInSector:i,sector:s}=t;i&&s&&this.viewModel.handleFeatureClick({sector:s,featureIndexInSector:+i})},g=e=>{e.removeEventListener("click",h)},m=i.attributes.objectId,v=e?.map((e=>e?.items)).filter(Boolean).flatMap((e=>e?.map((({x:e,y:t,objectID:i,featureIndexInSector:s,sector:a})=>O.tsx("circle",{afterRemoved:g,class:this.classes(y.css.feature,{selected:m===i}),cx:e,cy:t,"data-feature-index-in-sector":s,"data-sector":a,key:`${y.css.feature}-${i}`,onclick:h,r:u.featureCircleRadius}))))),_=e=>{e.removeEventListener("click",d)},w=this.classes({[y.css.navigationWrapper]:!0,[y.css.navigationZoomed]:this._navigationToolExpanded});return this.navigationToolActive&&"image-loaded"===a?O.tsx("div",{bind:this,class:w,key:this.messages.navigationTool},O.tsx("svg",{afterCreate:e=>this._storeNavigationToolReference(e),class:s.prefersReducedMotion()?y.navigation:y.css.rotateWithAnimation,focusable:"false",height:u.navigationToolDimensionLength,role:"img",width:u.navigationToolDimensionLength,xmlns:"http://www.w3.org/2000/svg"},O.tsx("defs",null,O.tsx("linearGradient",{gradientUnits:"userSpaceOnUse",id:`${this.id}-coverage-fill`,x1:o,x2:n,y1:l,y2:c},O.tsx("stop",{class:y.css.navigationPathOffset0,offset:0}),O.tsx("stop",{class:y.css.navigationPathOffset1,offset:1}))),O.tsx("g",null,O.tsx("circle",{class:this.classes(y.css.sector,y.css.outerSector),cx:u.sectorsRadii[3],cy:u.sectorsRadii[3],onclick:this._scaleNavigationTool,r:u.sectorsRadii[3]}),O.tsx("circle",{class:y.css.sector,cx:u.sectorsRadii[3],cy:u.sectorsRadii[3],r:u.sectorsRadii[2]}),O.tsx("circle",{class:y.css.sector,cx:u.sectorsRadii[3],cy:u.sectorsRadii[3],r:u.sectorsRadii[1]}),O.tsx("circle",{class:y.css.sector,cx:u.sectorsRadii[3],cy:u.sectorsRadii[3],r:u.sectorsRadii[0]}),O.tsx("path",{class:y.css.pointer,d:"M 56.5 6.06217782649107 L 60 0 L 63.5 6.06217782649107 Z",key:`${y.css.pointer}-west`}),O.tsx("path",{class:this.classes(y.css.pointer,y.css.north),d:"M 113.93782217350893 56.5 L 120 60 L 113.93782217350893 63.5 Z",key:`${y.css.pointer}-north`}),O.tsx("path",{class:y.css.pointer,d:"M 56.5 113.93782217350893 L 60 120 L 63.5 113.93782217350893 Z",key:`${y.css.pointer}-east`}),O.tsx("path",{class:y.css.pointer,d:"M 6.06217782649107 56.5 L 0 60 L 6.06217782649107 63.5 Z",key:`${y.css.pointer}-south`}),O.tsx("path",{class:this.classes(y.css.sector,y.css.sectorSeparator),d:"M 23.937554159486076 23.937554159486076 L 96.06244584051393 96.06244584051393 M 23.937554159486076 96.06244584051393 L 96.06244584051393 23.937554159486076",key:y.css.sectorSeparator}),p.getAllArcPath([u.sectorsRadii[2],u.sectorsRadii[1],u.sectorsRadii[0]],u.sectorsRadii[3],u.sectorsRadii[3]).map(((t,i)=>O.tsx("path",{afterRemoved:_,class:this.classes(y.css.sector,e?.[i]?.length?y.css.sectorEnabled:y.css.sectorDisabled),d:t,"data-sector":`${i}`,key:`${y.css.sector}-${i}`,onclick:d}))),O.tsx("path",{class:this.classes(y.css.sector,y.css.sectorCross),d:"M 56.4 56.4 L 63.53 63.53 M 63.53 56.4 L 56.4 63.53",key:y.css.sectorCross}),v,i.attributes.cameraPitch>=5&&r?O.tsx("path",{class:y.css.selectedFeaturePath,d:r,fill:`url(#${this.id}-coverage-fill)`,key:y.css.selectedFeaturePath}):null))):null}_renderNavigationToolAction(){const{state:e}=this.viewModel;return O.tsx("calcite-action",{active:this.navigationToolActive,afterCreate:this._storeActionElement,bind:this,disabled:"image-loaded"!==e||this.invalidCameraHeading,icon:"explore",onclick:this._toggleNavigationTool,text:this.messages.navigationTool})}_renderMenuBarContainer(){const{currentCoverageVisible:e,isAdditionalCoverageVisible:t,isAdditionalPointSourcesVisible:i,imageGalleryEnabled:s,invalidCameraHeading:a}=this;return O.tsx("calcite-action-bar",{expandDisabled:!0,layout:"horizontal",slot:"action-bar"},O.tsx("calcite-action-group",{expanded:!0},O.tsx("calcite-action",{active:e,afterCreate:this._storeActionElement,bind:this,class:y.css.currentCoverage,disabled:a,icon:"trapezoid-area",onclick:this._toggleCurrentCoverage,text:this.messages.currentFootprint}),O.tsx("calcite-action",{active:t,afterCreate:this._storeActionElement,bind:this,class:y.css.addCoverage,disabled:a,icon:"trapezoid-area",onclick:this._toggleAdditionalCoverage,text:this.messages.additionalFootprints}),O.tsx("calcite-action",{active:i,afterCreate:this._storeActionElement,bind:this,class:y.css.addExpPoints,disabled:a,icon:"circle-area",onclick:this._toggleAdditionalCameraLocations,text:this.messages.additionalCameraLocations})),O.tsx("calcite-action-group",{layout:"horizontal"},this.visibleElements.mapImageConversionTool?this._renderMapImageConversionTool():null,this.visibleElements.navigationTool?this._renderNavigationToolAction():null,this.visibleElements.imageEnhancement?this._renderImageEnhancementAction():null),O.tsx("calcite-action-group",null,O.tsx("calcite-action",{active:this.galleryOpened,afterCreate:this._storeActionElement,bind:this,disabled:!s||a,icon:"images",onclick:this._toggleImageGallery,text:this.messages.imageGallery,textEnabled:!0}),this.visibleElements.imageOverlays?this._renderImageOverlaysAction():null,this.visibleElements.showPopupsAction?this._renderPopupAction():null),this._renderActionTooltips())}_renderMessageBox(){const{messages:e,viewModel:{displayMessage:t}}=this;if(!t)return null;const{data:i,key:s,map:a}=t,r=`${a?A.substitute(e[s],a):e[s]}`;return O.tsx("span",{class:y.css.messageBox},i?`${r} ${i}`:r)}_renderPopupAction(){return O.tsx("calcite-action",{afterCreate:this._storeActionElement,bind:this,disabled:!this.popupEnabled,icon:"popup",onclick:this._toggleImageAttributes,text:this.messages.showPopups,textEnabled:!0})}_renderThumbnails(e){const{currentBestFeature:t}=this.viewModel;return t?O.tsx("div",{class:y.css.carouselContent},e.items.map((({url:e,objectId:i,rotation:s},a)=>O.tsx("div",{class:`${y.css.carouselItemWrapper}${t.attributes.objectId===i?"--selected":""}`,key:`${y.css.carouselItemWrapper}-${a}`},O.tsx("canvas",{afterCreate:this._registerGalleryItem,afterRemoved:this._unregisterGalleryItem,alt:`thumbnail-${i}`,class:y.css.carouselItem,"data-objectid":`${i}`,"data-rotation":`${s}`,"data-src":e,onclick:this._loadImageFromGallery,onmouseenter:this._highlight,onmouseleave:this._removeHighlight}))))):null}_renderViewerContainer(){return O.tsx("div",{class:y.css.viewerContainer},this._renderImageViewer(),this._renderPanoramicViewer(),this._renderMessageBox())}_renderImageViewer(){const{displayMessage:e,loadImageViewer:t,mode:i}=this.viewModel,s=null!=e||"default"!==i,a=this.classes({[y.css.viewer]:!s,[y.css.viewerHidden]:s});return O.tsx("calcite-panel",{afterCreate:t,bind:this,class:a})}_renderPanoramicViewer(){const{displayMessage:e,loadPanoramicViewer:t,mode:i}=this.viewModel,s=null!=e||"panoramic"!==i,a=this.classes({[y.css.viewer]:!s,[y.css.viewerHidden]:s});return O.tsx("calcite-panel",{afterCreate:t,bind:this,class:a})}_resetImageTools(){this.viewModel.sharpness=this.viewModel.brightness=this.viewModel.contrast=0}_storeActionElement(e){this._actionItems.set(e.text,e)}_storeNavigationToolReference(e){this._navigationTool=e}_storeWarningTitleElement(e){this._warningTitleElement=e}_toggleAdditionalCameraLocations(){this.isAdditionalPointSourcesVisible=!this.isAdditionalPointSourcesVisible}_toggleAdditionalCoverage(){this.isAdditionalCoverageVisible=!this.isAdditionalCoverageVisible}_toggleCurrentCoverage(){this.currentCoverageVisible=!this.currentCoverageVisible}_toggleImageEnhancementToolState(e){e.stopPropagation(),this.imageEnhancementToolActive=!this.imageEnhancementToolActive,this.imageEnhancementToolActive&&(this.galleryOpened&&(this.galleryOpened=!1),this.navigationToolActive&&(this.navigationToolActive=!1),this.imageOverlaysOpened&&(this.imageOverlaysOpened=!1))}_toggleImageOverlays(e){e.stopPropagation(),this.imageOverlaysOpened=!this.imageOverlaysOpened,this.imageOverlaysOpened&&(this.galleryOpened&&(this.galleryOpened=!1),this.navigationToolActive&&(this.navigationToolActive=!1),this.imageEnhancementToolActive&&(this.imageEnhancementToolActive=!1))}_toggleImageGallery(e){e.stopPropagation(),this.galleryOpened=!!this.imageGalleryEnabled&&!this.galleryOpened,this.galleryOpened&&(this.imageEnhancementToolActive&&(this.imageEnhancementToolActive=!1),this.navigationToolActive&&(this.navigationToolActive=!1),this.imageOverlaysOpened&&(this.imageOverlaysOpened=!1))}_toggleNavigationTool(){this.navigationToolActive=!this.navigationToolActive,this.navigationToolActive&&(this.galleryOpened&&(this.galleryOpened=!1),this.imageEnhancementToolActive&&(this.imageEnhancementToolActive=!1),this.imageOverlaysOpened&&(this.imageOverlaysOpened=!1))}_toggleMapImageConversionToolState(){this.mapImageConversionToolState=!this.mapImageConversionToolState}_unregisterGalleryItem(e){this._galleryObserver.unobserve(e)}_updateNavigationTool(e){const{previousFeatureAngle:t,bestFeatureAngle:i}=this.viewModel,s=(i-t+540)%360-180;e.style.setProperty(y.navigationToolRotationFrom,`${t}deg`),e.style.setProperty(y.navigationToolRotationTo,`${t+s}deg`)}async loadBestImage(e){return this.viewModel.loadBestImage(e)}loadImageFromSource(e,t){return this.viewModel.loadImageFromSource(e,t)}async plotMapPoint(e){return this.viewModel.plotMapPoint(e)}plotReferencePointOnGround(e){this.viewModel.plotReferencePointOnGround(e)}plotReferencePointOnImage(e){this.viewModel.plotReferencePointOnImage(e)}resetImage(){this.viewModel.resetImage()}render(){const{viewModel:{state:e}}=this;return O.tsx("div",{class:this.classes(M.globalCss.widget,y.root)},O.tsx("calcite-panel",{bind:this,heading:this.visibleElements.title?this.messages.title:void 0,loading:"image-loading"===e},this.visibleElements.coverageMenu?this._renderMenuBarContainer():null,this._renderBody()))}updateSuitabilities(e){this.viewModel.updateSuitabilities(e)}};t.__decorate([l.property()],T.prototype,"activeLayer",null),t.__decorate([l.property()],T.prototype,"currentBestFeature",null),t.__decorate([l.property()],T.prototype,"currentCoverageVisible",null),t.__decorate([l.property()],T.prototype,"disabled",null),t.__decorate([l.property()],T.prototype,"features",null),t.__decorate([l.property()],T.prototype,"imagePointsInView",null),t.__decorate([l.property()],T.prototype,"galleryOpened",void 0),t.__decorate([l.property()],T.prototype,"icon",null),t.__decorate([l.property()],T.prototype,"imageEnhancementToolActive",void 0),t.__decorate([l.property({readOnly:!0})],T.prototype,"imageGalleryEnabled",null),t.__decorate([l.property()],T.prototype,"imageOverlaysOpened",void 0),t.__decorate([l.property({readOnly:!0})],T.prototype,"invalidCameraHeading",null),t.__decorate([l.property()],T.prototype,"isAdditionalCoverageVisible",null),t.__decorate([l.property()],T.prototype,"isAdditionalPointSourcesVisible",null),t.__decorate([l.property()],T.prototype,"mapImageConversionToolState",null),t.__decorate([l.property()],T.prototype,"layer",null),t.__decorate([l.property()],T.prototype,"navigationToolActive",void 0),t.__decorate([l.property({type:_})],T.prototype,"viewModel",void 0),t.__decorate([l.property(),I.messageBundle("esri/widgets/OrientedImageryViewer/t9n/OrientedImageryViewer")],T.prototype,"messages",void 0),t.__decorate([l.property(),I.messageBundle("esri/t9n/common")],T.prototype,"messagesCommon",void 0),t.__decorate([l.property({readOnly:!0})],T.prototype,"popupEnabled",null),t.__decorate([l.property()],T.prototype,"referencePoint",null),t.__decorate([l.property()],T.prototype,"view",null),t.__decorate([l.property({type:w,nonNullable:!0})],T.prototype,"visibleElements",void 0),t.__decorate([l.property()],T.prototype,"determineWorkflowForFeature",null),t.__decorate([l.property()],T.prototype,"updateFootprint",null),t.__decorate([l.property()],T.prototype,"_navigationToolExpanded",void 0),t.__decorate([l.property()],T.prototype,"_navigationTool",void 0),t.__decorate([l.property()],T.prototype,"_imageOverlays",void 0),t.__decorate([l.property()],T.prototype,"_warningTitleElement",void 0),T=t.__decorate([h.subclass("esri.widgets.OrientedImageryViewer")],T);return T}));
