/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../../chunks/tslib.es6","../../geometry","../../Graphic","../../symbols","../../core/arrayUtils","../../core/asyncUtils","../../core/Collection","../../core/deprecate","../../core/Error","../../core/Evented","../../core/JSONSupport","../../core/lang","../../core/Logger","../../core/mathUtils","../../core/maybe","../../core/Promise","../../core/promiseUtils","../../core/ReactiveMap","../../core/reactiveUtils","../../core/sql","../../core/unitUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/accessorSupport/decorators/subclass","../../core/support/UpdatingHandles","../../geometry/geometryEngineAsync","../../geometry/projection","../../geometry/support/coordsUtils","../../geometry/support/webMercatorUtils","../../layers/GraphicsLayer","../../layers/orientedImagery/queries","../../layers/orientedImagery/core/bestImageUtils","../../layers/orientedImagery/core/coverageUtils","../../layers/orientedImagery/core/ElevationSourceDefinitions","../../layers/orientedImagery/transformations/imageToWorld","../../layers/orientedImagery/transformations/updateElevation","../../layers/orientedImagery/transformations/updateElevationUtils","../../layers/orientedImagery/transformations/utils","../../layers/orientedImagery/transformations/worldToImage","../../layers/support/floorFilterUtils","../../rest/support/AttachmentQuery","../../views/draw/support/drawUtils","../../views/input/InputManager","../PanoramicViewer","./constants","./symbols","./utils","./components/ImageViewer","../../geometry/Point","../../geometry/SpatialReference","../../symbols/SimpleLineSymbol","../../geometry/Multipoint","../../geometry/Polyline","../../geometry/Polygon"],(function(e,t,r,a,i,o,s,n,l,c,p,d,h,u,m,y,g,_,v,f,b,w,F,P,I,S,C,A,V,M,O,R,k,T,E,L,H,B,x,G,D,U,j,W,z,q,N,$,J,Z,K,Q,X,Y,ee){"use strict";const te=e=>Object.freeze(Object.defineProperty({__proto__:null,default:e},Symbol.toStringTag,{value:"Module"})),re={click:"view-click",imageClick:"image-click",interactionHandles:"interaction-handles",footprintHandles:"footprint-handles"},ae=new Set(["JPG","JPEG"]),ie=/\.(\w+)$/,oe=e=>"FA"===e;let se=class extends(p.EventedMixin(g.EsriPromise)){constructor(t){super(t),this.additionalFeatures=new n,this.additionalCameraLocations=new n,this.additionalFootprints=new n,this.bestFeatureAngle=0,this.bestFeatureCurrentFootprint=null,this.bestFeatureFootprint=null,this.coverageFrustums=new n,this.coveragePolygons=new n,this.currentBestFeature=null,this.currentBestFeatureLocation=null,this.currentCoverageVisible=!0,this.determineWorkflowForFeature=async(e,t,r)=>{const{currentBestFeature:a,selectedPoint:i,view:o}=this;if(o?.closePopup(),a&&i){this._initialCurrentCoverageUpdate=!0;try{await this._updatePointsAndPolygons(r),await this._loadImage(r)}catch(s){_.isAbortError(s)||(this.loadImageError(s),u.getLogger(this).error("#loadIImage()","error occured while loading image",s))}}},this.disabled=!1,this.displayMessage={key:"onLoadMessage",type:"info"},this.features=new n,this.isAdditionalCoverageVisible=!1,this.isAdditionalPointSourcesVisible=!1,this.layer=null,this.localPort=null,this.mapImageConversionToolState=!1,this.navigatorCurrentBestFeature=null,this.overlayedCameraLocations=new n,this.overlayedMapFeatures=new v,this.pointSources=new n,this.previousFeatureAngle=0,this.selectedPoint=null,this.shouldShowSelectedImage=!1,this.updateFootprint=async(e,t)=>{"image-loaded"===this.state&&await(this._adapter?.updateFootprint(e,t))},this.updateFootprintPanorama=async(e,t)=>{await(this._adapter?.updateFootprintPanorama(e,t))},this._adapter=null,this._highlightedFeatureHandle=null,this._imageViewer=new J,this._initialCurrentCoverageUpdate=!0,this._overlays=new O({listMode:"hide",internal:!0,elevationInfo:{mode:"absolute-height"}}),this._panoramicViewer=new z,this._referencePointOnGround=null,this._referencePointOnImage=null,this._sectorData=null,this._updatingHandles=new S.UpdatingHandles,this._clickTask=null,this._crossSymbol=null,this.footprintExtent=null,this._featureChangedTask=null,this._openPopupTask=null,this._suitabilities=null,this._transformController=new AbortController,this._updateFootprintTask=null,this.highlight=e=>{if(!this._overlaysView)return;this.removeHighlight();const t=this.additionalFootprints.find((({attributes:{imageID:t}})=>t===Number(e)));this._highlightedFeatureHandle=t?this._overlaysView?.highlight(t):null},this.loadImageFromSource=async(e,t)=>this._updatingHandles.addPromise(this._loadImageFromSourceInternal(e,t)),this.loadImageViewer=e=>{this._imageViewer.container=e},this.loadPanoramicViewer=e=>{this._panoramicViewer.container=e},this.removeHighlight=()=>this._highlightedFeatureHandle?.remove(),this.toggleImageAttributes=()=>{y.abortMaybe(this._openPopupTask),this._openPopupTask=s.createTask((async e=>{const{currentBestFeature:t,popupEnabled:r,layer:i,view:o}=this;if(o?.closePopup(),!(o&&t&&r&&i))return;const{attributes:s,geometry:n}=t,l=new a({geometry:n,attributes:s.toJSON(),layer:i});_.throwIfAborted(e),await o.openPopup({features:[l],location:s.location.clone()})}))},this._createViewClickHandle=()=>{if(this.removeHandles(re.click),"disabled"===this.state||null==this.view)return;const e=this.mapImageConversionToolState&&"image-loaded"===this.state?this._mapImageConversionToolViewClickHandler:this._viewClickHandler;this.addHandles(this.view.on("click",e,W.ViewEventPriorities.WIDGET),re.click)},this._createImageClickHandle=()=>{this.removeHandles(re.imageClick);const{mapImageConversionToolState:e,mode:t,activeViewer:r,currentBestFeature:a,footprintExtent:i}=this,o=r?.imageSize;if(!(e&&"none"!==t&&o&&i&&a))return;r.clickAction="pixel-location";let n=null;const l=f.on((()=>r),"pixel-location",(e=>{this.plotReferencePointOnImage(e),n?.abort(),n=s.createTask((async r=>{if(!e)return;const i=await this.getMapPoint(e,{feature:a,imageSize:o,mode:t}).then((e=>{const t=this.view?.spatialReference;return x.or(!t,e.spatialReference.equals(t))?e:A.projectWithZConversion(e,t)}));_.throwIfAborted(r),this.plotReferencePointOnGround(i)}))}));this.addHandles(l,re.imageClick)},this._getImageSourceFromAttachment=async(e,t,r)=>{const a=new U({objectIds:[t]}),i=await e.queryAttachments(a,r),o=i[`${t}`]?.[0],s=o?.url;if(!s)throw new c("NoAttachmentError","no attachments found",{[e.objectIdField]:t,layer:e});return{datasetFormat:o.contentType.split("/")[1].toUpperCase(),url:s}},this._loadAdapter=async t=>{const{view:r}=this;if(r)switch(r.type){case"2d":{const{default:r}=await new Promise(((t,r)=>e(["./adapters/OrientedImageryViewerViewModelAdapter2D"],(e=>t(te(e))),r)));_.throwIfAborted(t),this._adapter=new r(this);break}case"3d":{const{default:r}=await new Promise(((t,r)=>e(["./adapters/OrientedImageryViewerViewModelAdapter3D"],(e=>t(te(e))),r)));_.throwIfAborted(t),this._adapter=new r(this);break}}else this._adapter=null},this._loadImage=async e=>{const{currentBestFeature:t,layer:r,mode:a}=this;if(this.clearGraphics(),!r||!t||"none"===a)return;const{attributes:i}=t,{imagePath:o,imageRotation:s,cameraHeading:n,cameraRoll:l,cameraPitch:c,objectId:p,cameraOrientation:d,location:h}=i,m=(l??0)+(s??0),y=h.spatialReference.isWGS84&&4!==d?.type?M.geographicToWebMercator(h):new Z(h);let g=o;if(oe(o))try{g=await this._getImageSourceFromAttachment(r,p,e)}catch(v){if(_.isAbortError(v))return;return $.isNoAttachmentError(v)?(u.getLogger(this).error(v),void this.setMessage("noAttachment","error",`${r.objectIdField}: ${p}`)):(u.getLogger(this).error(v,{[r.objectIdField]:p,layer:r}),void this.setMessage("imageLoadError","error",`query-attachments-failed:${r.objectIdField} ${p}`))}try{await this.loadImageFromSource(g,{imageRotation:m,options:e,pitch:c,yaw:n,mode:a,cameraLocation:y}),_.throwIfAborted(e),await this.transformAndPlotSelectedLocation(e)}catch(v){_.isAbortError(v)||this.loadImageError(v)}},this._loadImageFromSourceInternal=async(e,t)=>{const{mode:r,imageRotation:a,options:i}=t,o="string"==typeof e,s=o?e:e.url,{pathname:n,searchParams:l}=new URL(s);let c=o?n.match(ie)?.[1]:e.datasetFormat;if(!c){const e=await $.getContentType(s,{...t.options});c=e?.split("/")[1]??"UNKNOWN FORMAT"}switch(r){case"default":this._imageViewer.imageSource={datasetFormat:c.toUpperCase(),url:s.split("?")[0]},this._imageViewer.customParameters=Object.fromEntries(l),this._imageViewer.imageRotation=a??0,await this._imageViewer.loadImage(i);break;case"panoramic":if(ae.has(c.toUpperCase())){const{selectedPoint:e}=this,{pitch:r,yaw:a,cameraLocation:o,viewAngle:n}=t;this._panoramicViewer.imageSource=s;let l=a??0;"number"==typeof n?l=n-l:o&&e&&(l=await x.getInitialAngle(o,e)-l),this._panoramicViewer.pitch=r??0,this._panoramicViewer.yaw=l,await this._panoramicViewer.loadImage(i)}else this.setMessage("unsupportedPanoramicImageryError","error",void 0,{datasetFormat:c});break}},this._mapImageConversionToolViewClickHandler=e=>{e.stopPropagation(),e.preventDefault(),e.mapPoint&&this.plotMapPoint(e.mapPoint)},this._viewClickHandler=e=>{this._clickTask?.abort(),this._clickTask=s.createTask((async t=>{const{pointerType:r,button:a,mapPoint:i}=e;if(("mouse"!==r||0===a)&&i)return e.stopPropagation(),e.preventDefault(),this._updatingHandles.addPromise(this.loadBestImage(i,{signal:t}))}))},this.plotSelectedPointOnImage=async(e,t)=>{if(await _.waitTick(t),!e)return;const r=new Z({...d.isSerializable(e)?e.toJSON():e});if("default"===this.mode)r.x-=.5,r.y=.5-r.y,r.spatialReference=this._imageViewer.imageRenderer.spatialReference.clone(),this._crossSymbol=new a({geometry:r,symbol:N.crossSymbol}),this._imageViewer.addGraphic(this._crossSymbol,0);else if("panoramic"===this.mode){const{imageSize:t}=this._panoramicViewer;if(!t)return;const[r,i]=t,{heading:o,pitch:s}=x.convertPixelToHeadingPitch(e,r,i),n=x.convertHeadingPitchToSphereVertex(o,s);this._crossSymbol=new a({geometry:new Z(n,K.WebMercator),symbol:N.crossSymbol3D}),this._panoramicViewer.addGraphic(this._crossSymbol,0)}},this.handleSectorClick=this.handleSectorClick.bind(this),this.searchBestImage=this.searchBestImage.bind(this),this.transformAndPlotReferencePointOnImage=this.transformAndPlotReferencePointOnImage.bind(this),this.updateSuitabilities=this.updateSuitabilities.bind(this),this.selectBestFeature=this.selectBestFeature.bind(this)}initialize(){this.addHandles([f.watch((()=>this.view),(()=>{this.load()}),f.syncAndInitial),f.watch((()=>this.view?.map),((e,t)=>{t?.layers.remove(this._overlays),e?.layers.add(this._overlays)}),f.initial),f.watch((()=>this.view?.map?.allLayers?.length),(e=>{e&&this.view?.map?.layers.reorder(this._overlays,e-1)}),f.initial),f.watch((()=>[this.state,this.mapImageConversionToolState,this.view]),(()=>{this._createViewClickHandle(),this._createImageClickHandle()}),f.syncAndInitial),f.watch((()=>this.bestFeatureAngle),((e,t)=>{this.previousFeatureAngle=t??0}),f.syncAndInitial),f.watch((()=>this.currentBestFeature),(async(e,t)=>{y.abortMaybe(this._featureChangedTask),this._featureChangedTask=s.createTask((async r=>this.determineWorkflowForFeature.apply(this,[e,t,{signal:r}]))),await this._featureChangedTask.promise}),{sync:!0}),f.watch((()=>this.mode),(e=>{switch(this.removeHandles(re.interactionHandles),e){case"default":this.addHandles(f.watch((()=>this._imageViewer.imagePointsInView),(e=>{e&&(y.abortMaybe(this._updateFootprintTask),this._updateFootprintTask=s.createTask((async t=>{await this.updateFootprint(e,{signal:t})})))}),{...f.syncAndInitial,equals:(e,t)=>o.equals(e,t,h.equalsShallow)}),re.interactionHandles);break;case"panoramic":this.addHandles(f.watch((()=>{const{currentBestFeature:e,state:t}=this,{imageSize:r,vfov:a,hfov:i,pitch:o,yaw:s}=this._panoramicViewer;return e&&r&&"image-loading"!==t?[a,i,s,o]:null}),(e=>{if(!e||"image-loading"===this.state)return;const[t,r,a,i]=e;y.abortMaybe(this._updateFootprintTask),this._updateFootprintTask=s.createTask((async e=>{await this.updateFootprintPanorama({verticalFieldOfView:t,horizontalFieldOfView:r,yaw:a,pitch:i},{signal:e})}))}),{...f.syncAndInitial,equals:(e,t)=>o.equals(e,t,h.equalsShallow)}),re.interactionHandles)}}),f.syncAndInitial),f.watch((()=>[this.brightness,this.contrast,this.sharpness]),(()=>{const{_imageViewer:e,brightness:t,contrast:r,mode:a,sharpness:i}=this;"default"===a&&(e.brightness=t,e.contrast=r,e.sharpness=i)}),f.syncAndInitial)])}destroy(){this._updateFootprintTask=y.abortMaybe(this._updateFootprintTask),this._clickTask=y.abortMaybe(this._clickTask),this.coverageFrustums.destroy(),this.coveragePolygons.destroy(),this.pointSources.destroy(),this.additionalFootprints.destroy(),this.additionalCameraLocations.destroy(),this.bestFeatureFootprint=y.destroyMaybe(this.bestFeatureFootprint),this.bestFeatureCurrentFootprint=y.destroyMaybe(this.bestFeatureCurrentFootprint),this._crossSymbol=y.destroyMaybe(this._crossSymbol),this._referencePointOnGround=y.destroyMaybe(this._referencePointOnGround),this._referencePointOnImage=y.destroyMaybe(this._referencePointOnImage),this._overlays&&this.view?.map?.remove(this._overlays),this._overlays.destroy()}get activeLayer(){return l.deprecatedProperty(u.getLogger(this),"activeLayer",{replacement:"layer"}),this.layer}set activeLayer(e){l.deprecatedProperty(u.getLogger(this),"activeLayer",{replacement:"layer"}),this.layer=e}get activeViewer(){const{_imageViewer:e,_panoramicViewer:t,mode:r}=this;switch(r){case"default":return e;case"panoramic":return t;default:return null}}get brightness(){return this._get("brightness")??0}set brightness(e){this._set("brightness",m.clamp(e,-10,10))}get contrast(){return this._get("contrast")??0}set contrast(e){this._set("contrast",m.clamp(e,-10,10))}get featureCount(){return this.features?.length??0}get imageGalleryEnabled(){return $.isTifOrMrf(this.currentBestFeature?.attributes.imagePath.trim())}get imageLoaded(){return l.deprecatedProperty(u.getLogger(this),"imageLoaded",{replacement:'Use OrientedImageryViewer.state === "image-loaded"',version:"4.29",warnOnce:!0}),"image-loaded"===this.state}get invalidCameraHeading(){return this.currentBestFeature?.attributes?.cameraHeading===q.invalidCameraHeading}get imagePointsInView(){const{mode:e,_imageViewer:t}=this;return"default"===e?t.imagePointsInView:null}get layerView(){const{layer:e,view:t}=this;if(e&&t)return t.allLayerViews.find($.filterOILLayerView(e))}get layerFloorFilterClause(){const{layerView:e}=this;return e?D.getFloorFilterClause(e):null}get mode(){const e=this.currentBestFeature?.attributes;if(!e)return"none";const{horizontalFieldOfView:t,isSpherical:r}=e;return 360===t||r?"panoramic":"default"}get popupEnabled(){return!0===this.layer?.popupEnabled}get referencePoint(){return this._referencePointOnGround?.geometry}get sectorData(){const{_sectorData:e}=this;return e?q.sectorsInOrder.map((t=>e[t])):null}get sharpness(){return this._get("sharpness")??0}set sharpness(e){this._set("sharpness",m.clamp(e,0,1))}get state(){const{mode:e,disabled:t}=this;if(t)return"disabled";if(!this.isFulfilled())return"loading";if(this.isRejected())return"error";if(this._updatingHandles.updating)return"image-loading";if("error"===this.displayMessage?.type)return"image-load-error";switch(e){case"default":return this._imageViewer.state;case"panoramic":return this._panoramicViewer.state}return"ready"}get thumbnails(){const{features:e}=this;return e?new n(e.map((({attributes:{imagePath:e,objectId:t,cameraRoll:r,imageRotation:a}})=>{const i=e.trim();return $.isTifOrMrf(i)?{url:i,objectId:t,rotation:(r??0)+(a??0)}:null})).filter(o.isSome)):null}set view(e){this._set("view",e)}get _overlaysView(){return this.view?.layerViews.find((({layer:e})=>e===this._overlays))}filterByFootprints(e,t){const r=[],a=[],i=[];return e.forEach((e=>{const{layer:{coveragePercent:o},attributes:s}=e;let n;const l=w.getMetersPerUnitForSR(e.geometry.spatialReference);s.cameraHeight/=l,s.farDistance/=l,s.nearDistance/=l,E.isConstantElevation(s.elevationSource)&&(s.elevationSource.constantElevation/=l);const{polygon:c,frustum:p}=T.createCoveragePolygon(s);if(n=c.clone(),s.isInspection&&(n=T.computePolygonForInspection(s)),o&&(n=T.resizePolygon(n,o)),T.checkIfPolygonContainsSelectedPoint(n,t)){i.push(e);const{geometry:t,objectId:o,cameraHeight:n,cameraHeading:l}=s,d=t.clone();d.z=n,d.imageID=o,this.pointSources.push(d),l!==q.invalidCameraHeading&&(r.push(c),p&&a.push(p))}})),{features:i,polygons:r,frustums:a}}handleSectorClick(e){if(isNaN(e))return;const t=this._sectorData?.[q.sectorsInOrder[e]];t?.length&&this._updateCurrentBestFeature(t.at(0))}handleFeatureClick(e){const{sector:t,featureIndexInSector:r}=e;if(isNaN(r))return;const a=this._sectorData?.[t];a?.length&&this._updateCurrentBestFeature(a.at(r))}async load(e){return this.addResolvingPromise(this._loadAdapter(e).catch((e=>{if(!_.isAbortError(e))throw e}))),this}async loadBestImage(e,t){return this.view?.closePopup(),this.displayMessage=null,this.selectedPoint=e.spatialReference.isGeographic?M.geographicToWebMercator(e):e.clone(),this.features.removeAll(),this.currentBestFeature=null,this.additionalFeatures.removeAll(),this.additionalFootprints.removeAll(),this.additionalCameraLocations.removeAll(),this.bestFeatureCurrentFootprint=y.destroyMaybe(this.bestFeatureCurrentFootprint),this._overlays?.removeAll(),this._fetchFeaturesWithController(e,t)}loadImageError(e){u.getLogger(this).error("oriented-imagery-viewer:load-image",e),this.setMessage("imageLoadError","error",e.message)}async overlayCameraLocations(e){const{activeViewer:t,currentBestFeature:r,overlayedCameraLocations:i,layer:o,mode:s,state:n}=this,l=t?.imageSize;if(!l||!r||!o||"none"===s||n.includes("loading"))return;const{polygon:c}=T.createCoveragePolygon(r.attributes);if(t.removeManyGraphics(i.toArray()),i.removeAll(),e){const{features:e}=await o.queryFeatures({where:`${o.objectIdField} <> ${r.attributes.objectId}`,geometry:c,returnGeometry:!0,outFields:[o.objectIdField]}),n=await Promise.all(e.map((async e=>{const{attributes:t,geometry:i}=e,o=await this.getPixels(i,{feature:r,imageSize:l,mode:s}),n=N.sourcePointSymbol.clone();return n.outline=new Q({color:[0,0,0],width:1}),new a({attributes:t,symbol:n,geometry:o})})));i.addMany(n),t.addManyGraphics(i.toArray())}}overlayGraphicsOnImage(e,t){this.overlayedMapFeatures.set(e,t),this.activeViewer?.addManyGraphics(t.toArray())}async overlayMapFeatures(e,t=!1){const{activeViewer:r,currentBestFeature:i,mode:s,state:l}=this,c=r?.imageSize;if(!c||!i||"none"===s||l.includes("loading"))return;const{polygon:p}=T.createCoveragePolygon(i.attributes),{features:d}=await e.queryFeatures({geometry:p,returnGeometry:!0,outFields:[e.objectIdField]}),h=new n((await Promise.all(d.map((async r=>{const{attributes:o,geometry:n}=r,l=r.symbol?.clone()??e.renderer?.getSymbol(r).clone();switch(n?.type){case"point":{const r=await this.getPixels(n,{feature:i,imageSize:c,mode:s});return new a({attributes:o,layer:e,symbol:l,geometry:r,visible:e.visible&&t})}case"polygon":{const{rings:r,spatialReference:p}=n,d=r.map((e=>e.map((([e,t,r])=>new Z({x:e,y:t,z:r,spatialReference:p}))))),h=await Promise.all(d.map((async e=>this.getPixels(e,{feature:i,imageSize:c,mode:s}).then((e=>e.map(x.pointToArray))))));return new a({attributes:o,layer:e,symbol:l,geometry:new ee({rings:h,spatialReference:K.WebMercator}),visible:e.visible&&t})}case"polyline":{const{paths:r,spatialReference:p}=n,d=r.map((e=>e.map((([e,t,r])=>new Z({x:e,y:t,z:r,spatialReference:p}))))),h=await Promise.all(d.map((async e=>this.getPixels(e,{feature:i,imageSize:c,mode:s}).then((e=>e.map(x.pointToArray))))));return new a({attributes:o,layer:e,symbol:l,geometry:new Y({paths:h,spatialReference:K.WebMercator}),visible:e.visible&&t})}case"multipoint":{const{points:r,spatialReference:p}=n,d=r.map((([e,t,r])=>new Z({x:e,y:t,z:r,spatialReference:p}))),h=await this.getPixels(d,{feature:i,imageSize:c,mode:s}).then((e=>e.map(x.pointToArray)));return new a({attributes:o,layer:e,symbol:l,geometry:new X({points:h,spatialReference:K.WebMercator}),visible:e.visible&&t})}}return null})))).filter(o.isSome));this.overlayGraphicsOnImage(`${e.id}`,h)}async getPixels(e,t){const{imageSize:r,mode:a}=t,i=(await this.worldToImage(Array.isArray(e)?e:[e])).map((e=>{if("default"===a)return new Z({x:e.x-.5,y:.5-e.y,spatialReference:K.WebMercator});const[t,i]=r,{heading:o,pitch:s}=x.convertPixelToHeadingPitch(e,t,i),n=x.convertHeadingPitchToSphereVertex(o,s);return new Z(n,K.WebMercator)}));return Array.isArray(e)?i:i[0]}async getMapPoint(e,t){const{feature:r,mode:a,imageSize:i}=t,{elevationSample:o,attributes:s}=r,{elevationSource:n,location:l,elevation:c,cameraHeight:p}=s;let d=l.clone();d.spatialReference.isGeographic&&(d=await A.projectWithZConversion(d,K.WebMercator));const h=await x.getUpdateElevationProps(c??(l.z??0)-p,{elevationSample:o,elevationSource:n,extent:this.footprintExtent});let u;if("elevationSample"in h&&x.isElevationSampler(h.elevationSample)&&(r.elevationSample=h.elevationSample),"default"===a){const t=x.getImageToWorldProperties(s,i[0],i[1]);u=await L.imageToWorld(Array.isArray(e)?e:[e],{...t,cameraLocation:d},h)}else{const t=x.getImageToWorldPanoramicProperties(s,i[0],i[1]);u=await L.imageToWorldPanoramic(Array.isArray(e)?e:[e],{...t,cameraLocation:d},h)}return Array.isArray(e)?u:u[0]}async plotMapPoint(e){return this.plotReferencePoint(e),this.transformAndPlotReferencePointOnImage({feature:this.currentBestFeature,selectedLocation:e,options:{signal:this._transformController?.signal}})}plotReferencePointOnGround(e){this._referencePointOnGround&&(this._overlays?.remove(this._referencePointOnGround),this._referencePointOnGround.destroy()),null!=e&&(this._referencePointOnGround=new a({geometry:new Z({...e.toJSON()}),symbol:N.diamondSymbol}),this.view?this._overlays?.add(this._referencePointOnGround):this.emit("plot-ground-point",{data:{point:this._referencePointOnGround?.geometry}}))}plotReferencePointOnImage(e){if("image-loaded"===this.state)switch(this.clearReferencePointOnImage(),this.mode){case"default":{const t=d.isSerializable(e)?e.toJSON():e;t.x-=.5,t.y=.5-t.y,this._referencePointOnImage=new a({geometry:new Z({spatialReference:this._imageViewer.imageRenderer.spatialReference.clone(),...t}),symbol:N.diamondSymbol}),this._imageViewer.addGraphic(this._referencePointOnImage,0);break}case"panoramic":{const{imageSize:t}=this._panoramicViewer;if(!t)return;const[r,i]=t,{heading:o,pitch:s}=x.convertPixelToHeadingPitch(e,r,i),n=x.convertHeadingPitchToSphereVertex(o,s);this._referencePointOnImage=new a({geometry:new Z(n,K.WebMercator),symbol:N.diamondSymbol3D}),this._panoramicViewer.addGraphic(this._referencePointOnImage,0);break}}}removeAllOverlayMapFeatures(){this.overlayedMapFeatures.forEach((e=>{this._imageViewer.removeManyGraphics(e.toArray())})),this.overlayedMapFeatures.clear()}removeOverlayedGraphicsOnImage(e){const t=this.overlayedMapFeatures.get(e);t?.length&&(this.activeViewer?.removeManyGraphics(t.toArray()),this.overlayedMapFeatures.delete(e))}resetImage(){switch(this.setMessage("onLoadMessage","info"),this.mode){case"default":this._imageViewer.clearImage(),this._imageViewer.clearGraphics();break;case"panoramic":this._panoramicViewer.clearGraphics()}this._clickTask=y.abortMaybe(this._clickTask)}async searchBestImage(e,t){try{const r=await R.searchImages(e,t);r&&await this._processFeatureResponse(r,e.point,{signal:t?.signal})}catch(r){_.isAbortError(r)||(this.setMessage("imageLoadError","error",r.message),u.getLogger(this).error("error occurred while finding best image",r))}}selectBestFeature(e){this.currentBestFeature=this.features?.find((({attributes:t})=>t.objectId===Number(e)))}setAdditionalCameraLocationsVisibility(e){this.additionalCameraLocations.forEach((t=>{t.visible=e}))}setAdditionalCoverageVisibility(e){this.additionalFootprints.forEach((t=>{t.visible=e}))}setCurrentCoverageVisibility(e){this.bestFeatureCurrentFootprint&&(this.bestFeatureCurrentFootprint.visible=e),this.currentBestFeatureLocation&&(this.currentBestFeatureLocation.visible=e)}setMapImageConversionToolState(e){this.mapImageConversionToolState=e}toggleAllOverlayMapFeatures(e){this.overlayedMapFeatures.forEach((t=>{this._toggleVisiblity(t,e)}))}toggleOverlayMapFeatures(e,t){const r=this.overlayedMapFeatures.get(e);r&&this._toggleVisiblity(r,t)}async transformAndPlotReferencePointOnImage(e){const{selectedLocation:t,options:r}=e;let a=!1,i=!1;const o=this.bestFeatureFootprint?.geometry;switch(o?.type){case"polygon":{const e=t.spatialReference.equals(o.spatialReference)?t:await A.projectWithZConversion(t,o.spatialReference);a=o.contains(e);break}case"mesh":{const e=t.spatialReference.equals(o.spatialReference)?t:await A.projectWithZConversion(t,o.spatialReference);i=o.extent.contains(e);break}}if(!a&&!i)return void this.clearReferencePointOnImage();const s=await this.worldToImage(t,r);if(s)return _.throwIfAborted(r),this.plotReferencePointOnImage(s),{x:s.x,y:s.y};this.clearReferencePointOnImage()}updateSuitabilities(e){e.sort(((e,t)=>e.suitability-t.suitability)),this._suitabilities=e;const t=this._suitabilities.map((({feature:e})=>e));this._initialCurrentCoverageUpdate=!0,this._updateFeatures(t),this._groupFeaturesBySectors()}async _fetchFeatures(e,t){if(!this.view)return;const r=this.layer;if(r){const a={include:r},i=this.view.toScreen(e);if(!i)return;const o=await this.view.hitTest(i,a);return this._processHitTestResults(r,o,t)}}async _fetchFeaturesWithController(e,t){try{await this._fetchFeatures(e,t)}catch(r){if(_.isAbortError(r))return;this.setMessage("imageLoadError","error"),u.getLogger(this).error("error occurred while fetching features",r)}}_groupFeaturesBySectors(){const{_suitabilities:e,additionalFeatures:t,currentBestFeature:r,features:a,invalidCameraHeading:i}=this;if(!e||!t||!r||!a||i)return void(this._sectorData=null);this._sectorData={};for(const c of q.sectorsInOrder)this._sectorData[c]=new n;const o=e.map(((e,t)=>({...e,featureIndex:t})));o.sort(((e,t)=>e.trueSuitability-t.trueSuitability));const s=o.map((({distance:e})=>e)),l=Math.max(...s);o.forEach((e=>{const{distance:t,angle:r,featureIndex:i}=e,o=t/l*q.sectorsRadii[2],s=$.calculateSegment(t,l),n=$.calculateDirection(r);if(!this._sectorData)return;const c=q.sectorsRadii[3]+o*Math.sin(r*Math.PI/180),p=q.sectorsRadii[3]+o*Math.cos(r*Math.PI/180);let d;const h=a.at(i),u=h===this.currentBestFeature,m=this.currentBestFeature?.attributes.cameraPitch&&this.currentBestFeature?.attributes.cameraPitch<5;if(u&&m)d=-90;else{const e=c-q.sectorsRadii[3],t=p-q.sectorsRadii[3],r=t/Math.sqrt(e**2+t**2);let a=180*Math.acos(r)/Math.PI;(e<0&&t<0||e<0&&t>0)&&(a*=-1),d=a}const y=""===s?n:`${s}_${n}`;u&&(d===this.bestFeatureAngle?this.previousFeatureAngle=d:this.bestFeatureAngle=d,this.navigatorCurrentBestFeature=m?null:{x:c,y:p,direction:n});const g=this._sectorData[y];g.add({angle:r,featureIndex:i,x:c,y:p,objectID:h.attributes.objectId,sector:y,featureIndexInSector:g.length})}))}async _processFeatureResponse(e,t,r){const{features:a}=e;if(!a?.length)return this.setMessage("noImageError","error"),void(this.currentBestFeature=null);this.coveragePolygons.removeAll(),this.coverageFrustums.removeAll(),this.pointSources.removeAll();const{features:i,polygons:o,frustums:s}=this.filterByFootprints(a,t);if(!i.length)return this.setMessage("noImageError","error"),void(this.currentBestFeature=null);let n;if(this.coveragePolygons.addMany(o),this.coverageFrustums.addMany(s),o[0]){let e=new ee({spatialReference:o[0].spatialReference});for(const r of o)e=await C.union(e,r);const t=[];for(const{geometry:r}of i)e.contains(r)||t.push([r.x,r.y]);if(t.sort(((e,t)=>+V.isClockwise([e,t]))),e.addRing(t),this.footprintExtent=j.scale(e.extent,2,2),this.view?.supportsGround)try{n=await this.view.map.ground.createElevationSampler(this.footprintExtent,r)}catch(l){_.isAbortError(l)||u.getLogger(this).error(l)}}if((n||i[0].attributes.elevationSource)&&this.footprintExtent){const e=i[0].attributes.elevationSource;E.isElevationSource(e)&&!n&&(n=await B.getElevationSampler({extent:this.footprintExtent,lod:e.lod,url:e.url,rasterFunction:e.rasterFunction}));const r=await x.getUpdateElevationProps((i[0].attributes.location.z??0)-i[0].attributes.cameraHeight,{elevationSample:n,elevationSource:e,extent:this.footprintExtent}),[a,...o]=await H([t,...i.map((e=>e.attributes.geometry.clone()))],r);i[0].elevationSample=n??r.elevationSample,t.elevation=a.z,i.forEach(((e,t)=>{e.attributes.elevation=o[t].z}))}i[0].elevationSample&&i.forEach((e=>{e.elevationSample=i[0].elevationSample})),this._suitabilities=k.calculateSuitabilities({features:i,selectedPoint:t,camera:$.isSceneView(this.view)?this.view.camera:null,currentImage:this.currentBestFeature}),this.updateSuitabilities(this._suitabilities)}async _processHitTestResults(e,t,r){const{screenPoint:a,results:[i]}=t,o="graphic"===i?.type&&this.shouldShowSelectedImage,s=i?.mapPoint??this.view?.toMap(a);if(!s)return;const{layerFloorFilterClause:n}=this,l=b.sqlAnd("1=1",b.sqlAnd(e.definitionExpression,n)),c=s.spatialReference.isGeographic?1:w.getMetersPerUnitForSR(s.spatialReference),p={layerInstanceOrURL:e,point:s,queryParams:{where:l,maximumDistance:e.maximumDistance?e.maximumDistance/c:void 0,objectIds:o?[i.graphic.getAttribute(e.objectIdField)]:void 0}};await this.searchBestImage(p,r)}_toggleVisiblity(e,t){e.forEach((e=>{e.visible=t}))}_updateFeatures(e){if(!e.length)return this.currentBestFeature=null,void this.additionalFeatures.removeAll();this.features.removeAll(),this.features.addMany(e),e.length>1?this.additionalFeatures.addMany(e.slice(1)):this.additionalFeatures.removeAll(),this.currentBestFeature=e[0]}async _updatePointsAndPolygons(e){const{pointSources:t,currentBestFeature:r,currentCoverageVisible:i,isAdditionalPointSourcesVisible:o}=this;if(r&&(this.additionalFootprints.removeAll(),this.additionalCameraLocations.removeAll(),this.bestFeatureCurrentFootprint&&(this.bestFeatureCurrentFootprint.destroy(),this.bestFeatureCurrentFootprint=null,this.bestFeatureFootprint=null),!this.invalidCameraHeading)){await(this._adapter?.createFootprints(e)),_.throwIfAborted(e);for(const e of t)e.imageID===r.attributes.objectId?this.currentBestFeatureLocation=new a({attributes:{imageID:e.imageID},geometry:e,symbol:N.activeSourcePointSymbol,visible:i}):this.additionalCameraLocations.push(new a({attributes:{imageID:e.imageID},geometry:e,symbol:N.sourcePointSymbol,visible:o}))}}_updateCurrentBestFeature(e){if(!e)return;this.currentBestFeature=this.features?.at(e.featureIndex);const t=this.currentBestFeature?.attributes.cameraPitch&&this.currentBestFeature?.attributes.cameraPitch<5;let r;if(t)r=-90;else{const t=e.x-q.sectorsRadii[3],a=e.y-q.sectorsRadii[3],i=a/Math.sqrt(t**2+a**2);let o=180*Math.acos(i)/Math.PI;(t<0&&a<0||t<0&&a>0)&&(o*=-1),r=o}r===this.bestFeatureAngle?this.previousFeatureAngle=r:this.bestFeatureAngle=r,this.navigatorCurrentBestFeature=t?null:{x:e.x,y:e.y,direction:e.sector.includes("_")?e.sector.split("_")[1]:e.sector}}clearGraphics(){this._imageViewer.clearGraphics(),this._panoramicViewer.clearGraphics()}clearReferencePointOnImage(){this._referencePointOnImage&&(this._imageViewer.removeGraphic(this._referencePointOnImage),this._panoramicViewer.removeGraphic(this._referencePointOnImage),this._referencePointOnImage=y.destroyMaybe(this._referencePointOnImage))}plotReferencePoint(e){"mapPoint"in e?this.plotReferencePointOnGround(e.mapPoint):this.plotReferencePointOnGround(e)}setMessage(e,t,r,a){this.displayMessage={key:e,type:t,data:r,map:a}}async transformAndPlotSelectedLocation(e){const{currentBestFeature:t,invalidCameraHeading:r,selectedPoint:a,state:i}=this;if(this._crossSymbol&&(this._panoramicViewer.removeGraphic(this._crossSymbol),this._imageViewer.removeGraphic(this._crossSymbol),this._crossSymbol=y.destroyMaybe(this._crossSymbol)),!a||!t||"image-loaded"!==i||r)return;let o;try{o=await this.worldToImage(a,e),_.throwIfAborted(e),await this.plotSelectedPointOnImage(o,e)}catch(s){_.isAbortError(s)||u.getLogger(this).error("failed to transform map point to pixel, cross symbol will not be plotted on image",{error:s,selectedPoint:a,feature:t})}}async worldToImage(e,t){const{footprintExtent:r}=this,{imageSize:a}=this.activeViewer;if("none"===this.mode||!this.currentBestFeature||!a||!r)return;const{attributes:{location:i,elevationSource:o,cameraHeading:s,elevation:n,cameraHeight:l},elevationSample:c}=this.currentBestFeature;let p=i.clone();const d=await x.getUpdateElevationProps(n??(i.z??0)-l,{elevationSample:c,elevationSource:o});this.currentBestFeature.elevationSample=d.elevationSample;const h=Array.isArray(e)?e:[e];let u,m=await Promise.all(h.map((e=>new Promise((t=>{if(!e.hasZ)return t(H(e,d));t(e)})))));if(i.spatialReference.isGeographic&&(p=await A.projectWithZConversion(p,K.WebMercator,t)),m=await Promise.all(m.map((async e=>p.spatialReference.equals(e.spatialReference)?e:await A.projectWithZConversion(e,p.spatialReference,t)))),_.throwIfAborted(t),"panoramic"===this.mode)u=G.worldToImagePanoramic(m,{imageHeight:a[1],imageWidth:a[0],cameraHeading:s,cameraLocation:p});else{const e=x.getWorldToImageProperties(this.currentBestFeature.attributes,a[0],a[1]);u=G.worldToImage(m,{...e,cameraLocation:p})}return Array.isArray(e)?u:u[0]}updateCurrentCoveragePolygon(e){const{additionalFootprints:t,additionalCameraLocations:r,currentBestFeature:i,currentBestFeatureLocation:o,currentCoverageVisible:s,selectedPoint:n,view:l,_adapter:c}=this,{attributes:{objectId:p},elevationSample:d}=i;if(this._initialCurrentCoverageUpdate){if(this._overlays?.removeAll(),this._initialCurrentCoverageUpdate=!1,this.bestFeatureCurrentFootprint=y.destroyMaybe(this.bestFeatureCurrentFootprint),e&&!this.invalidCameraHeading&&(e.visible=s,this.bestFeatureCurrentFootprint=e),l){const e=[...t,...r,this.bestFeatureCurrentFootprint,o].filter($.isGraphic);l.supportsGround&&d&&c?.updateGroundElevation&&c.updateGroundElevation(e,d),n&&e.push(new a({geometry:n.clone(),symbol:N.crossSymbol.clone(),attributes:{imageID:p}})),this._overlays.graphics.addMany(e)}}else if(l){if(this.invalidCameraHeading)return;this.bestFeatureCurrentFootprint&&(this._overlays?.remove(this.bestFeatureCurrentFootprint),this.bestFeatureCurrentFootprint=y.destroyMaybe(this.bestFeatureCurrentFootprint));const t=this.bestFeatureCurrentFootprint&&this._overlays?this._overlays.graphics.indexOf(this.bestFeatureCurrentFootprint):-1;e&&(this.bestFeatureCurrentFootprint=e,l?.supportsGround&&d&&c?.updateGroundElevation&&c.updateGroundElevation([e],d),e.visible=this.currentCoverageVisible,this._overlays?.graphics.add(this.bestFeatureCurrentFootprint,t>=0?t:this._overlays.graphics.length-1))}}};t.__decorate([F.property()],se.prototype,"activeLayer",null),t.__decorate([F.property({readOnly:!0})],se.prototype,"activeViewer",null),t.__decorate([F.property()],se.prototype,"additionalFeatures",void 0),t.__decorate([F.property({type:n.ofType(a)})],se.prototype,"additionalCameraLocations",void 0),t.__decorate([F.property({type:n.ofType(a)})],se.prototype,"additionalFootprints",void 0),t.__decorate([F.property()],se.prototype,"bestFeatureAngle",void 0),t.__decorate([F.property()],se.prototype,"bestFeatureCurrentFootprint",void 0),t.__decorate([F.property({type:a})],se.prototype,"bestFeatureFootprint",void 0),t.__decorate([F.property({type:Number})],se.prototype,"brightness",null),t.__decorate([F.property({type:Number})],se.prototype,"contrast",null),t.__decorate([F.property()],se.prototype,"coverageFrustums",void 0),t.__decorate([F.property()],se.prototype,"coveragePolygons",void 0),t.__decorate([F.property()],se.prototype,"currentBestFeature",void 0),t.__decorate([F.property()],se.prototype,"currentBestFeatureLocation",void 0),t.__decorate([F.property()],se.prototype,"currentCoverageVisible",void 0),t.__decorate([F.property({json:{write:!1}})],se.prototype,"determineWorkflowForFeature",void 0),t.__decorate([F.property()],se.prototype,"disabled",void 0),t.__decorate([F.property()],se.prototype,"displayMessage",void 0),t.__decorate([F.property({readOnly:!0})],se.prototype,"featureCount",null),t.__decorate([F.property()],se.prototype,"features",void 0),t.__decorate([F.property({readOnly:!0})],se.prototype,"imageGalleryEnabled",null),t.__decorate([F.property({readOnly:!0})],se.prototype,"imageLoaded",null),t.__decorate([F.property({readOnly:!0})],se.prototype,"invalidCameraHeading",null),t.__decorate([F.property()],se.prototype,"imagePointsInView",null),t.__decorate([F.property()],se.prototype,"isAdditionalCoverageVisible",void 0),t.__decorate([F.property()],se.prototype,"isAdditionalPointSourcesVisible",void 0),t.__decorate([F.property()],se.prototype,"layer",void 0),t.__decorate([F.property()],se.prototype,"layerView",null),t.__decorate([F.property({readOnly:!0})],se.prototype,"layerFloorFilterClause",null),t.__decorate([F.property({type:Number})],se.prototype,"localPort",void 0),t.__decorate([F.property()],se.prototype,"mapImageConversionToolState",void 0),t.__decorate([F.property({readOnly:!0,value:"none"})],se.prototype,"mode",null),t.__decorate([F.property()],se.prototype,"navigatorCurrentBestFeature",void 0),t.__decorate([F.property({type:n.ofType(a)})],se.prototype,"overlayedCameraLocations",void 0),t.__decorate([F.property()],se.prototype,"overlayedMapFeatures",void 0),t.__decorate([F.property()],se.prototype,"pointSources",void 0),t.__decorate([F.property({readOnly:!0})],se.prototype,"popupEnabled",null),t.__decorate([F.property()],se.prototype,"previousFeatureAngle",void 0),t.__decorate([F.property()],se.prototype,"referencePoint",null),t.__decorate([F.property({readOnly:!0})],se.prototype,"sectorData",null),t.__decorate([F.property()],se.prototype,"selectedPoint",void 0),t.__decorate([F.property({type:Number})],se.prototype,"sharpness",null),t.__decorate([F.property()],se.prototype,"shouldShowSelectedImage",void 0),t.__decorate([F.property({readOnly:!0})],se.prototype,"state",null),t.__decorate([F.property({readOnly:!0})],se.prototype,"thumbnails",null),t.__decorate([F.property()],se.prototype,"updateFootprint",void 0),t.__decorate([F.property()],se.prototype,"updateFootprintPanorama",void 0),t.__decorate([F.property({value:null})],se.prototype,"view",null),t.__decorate([F.property()],se.prototype,"_adapter",void 0),t.__decorate([F.property()],se.prototype,"_highlightedFeatureHandle",void 0),t.__decorate([F.property()],se.prototype,"_imageViewer",void 0),t.__decorate([F.property()],se.prototype,"_initialCurrentCoverageUpdate",void 0),t.__decorate([F.property()],se.prototype,"_overlays",void 0),t.__decorate([F.property({readOnly:!0})],se.prototype,"_overlaysView",null),t.__decorate([F.property()],se.prototype,"_panoramicViewer",void 0),t.__decorate([F.property()],se.prototype,"_referencePointOnGround",void 0),t.__decorate([F.property()],se.prototype,"_referencePointOnImage",void 0),t.__decorate([F.property()],se.prototype,"_sectorData",void 0),t.__decorate([F.property({readOnly:!0})],se.prototype,"_updatingHandles",void 0),t.__decorate([F.property()],se.prototype,"footprintExtent",void 0),se=t.__decorate([I.subclass("esri.widgets.OrientedImageryViewer.OrientedImageryViewerViewModel")],se);return se}));
