/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../geometry","../../../Map","../../../core/Error","../../../core/Evented","../../../core/Logger","../../../core/mathUtils","../../../core/maybe","../../../core/promiseUtils","../../../core/reactiveUtils","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../../geometry/geometryEngine","../../../layers/GraphicsLayer","../../../layers/ImageryTileLayer","../../../layers/support/RasterFunction","../../../layers/support/rasterFunctionConstants","../../../layers/support/TileInfo","../../../views/MapView","../../../views/2d/viewpointUtils","../utils","../../../geometry/SpatialReference","../../../geometry/Polygon","../../../geometry/Point"],(function(e,t,r,a,i,o,s,n,l,h,c,d,m,p,g,y,_,u,v,R,w,f,x,I,C,b){"use strict";const P={click:"click-handle",enhancements:"enhancements-handle",rotation:"rotation-handle"};let S=class extends i.EventedAccessor{constructor(e){super(e),this._imageChanged=!1,this._panConstraint=null,this._image=null,this._loadController=null,this._overlays=new y({blendMode:"source-atop"}),this._map=new r,this.autoLoad=!1,this.clickAction="none",this.error=null,this.imageSource=null,this.imageRotation=0,this.state="ready",this._cancelLoadWithController=()=>{this._loadController?.abort(),this._loadController=null},this._createImageHandles=()=>{this.removeHandles(P.enhancements),this.addHandles(h.watch((()=>[this.brightness,this.contrast,this.sharpness]),(([e,t,r])=>{this.image?.loaded&&(this.image.effect=`contrast(${10*(t+10)}%) brightness(${10*(e+10)}%)`,this.sharpenImage(this.image,r))}),h.syncAndInitial))},this._createPanConstraint=()=>{const{image:e,imageRenderer:t}=this,r=r=>{if(!(e&&t&&r.targetGeometry&&e.serviceRasterInfo))return r;const{extent:a}=e.serviceRasterInfo,{constraints:i,rotation:o,width:s,height:n}=t,{extent:l}=g.rotate(C.fromExtent(a),o),{width:h,height:c}=l,d=r.targetGeometry.clone(),m=i.scaleToZoom(r.scale),p=1/2**m,y=s/n;let _=p*h,u=p*c;m&&(h/s>c/n?u=_/y:_=u*y);const v=l.clone();return v.xmin+=_/2,v.xmax-=_/2,v.ymin+=u/2,v.ymax-=u/2,r.targetGeometry=g.nearestCoordinate(v,d).coordinate,this.state="image-loaded",r};return{constrain:r,applyPanConstraint:r}},this._createResizeHandles=e=>{e.removeHandles("resize"),e.addHandles(h.watch((()=>{if(!this.imageRenderer.ready)return;const{extent:t}=e.serviceRasterInfo,{width:r,height:a,rotation:i}=this.imageRenderer,{extent:o}=g.rotate(C.fromExtent(t),i),{width:s,height:n}=o;return Math.max(s/r,n/a)}),(e=>{if(!this.imageRenderer||null==e)return;const{constraints:t,scale:r,spatialReference:a}=this.imageRenderer,i=t.minScale,o=f.getResolutionToScaleFactor(a),s=.25*o,n=o*e;let l=n;const h=[];for(;l>s;)h.push(l),l/=2;h.push(l);const{lods:c}=R.create({scales:h});if(t.set({minScale:n,lods:c}),this._imageChanged)return this.imageRenderer.scale=n,void(this._imageChanged=!1);this.imageRenderer.scale=Math.abs(r-i)<=1e-6?n:r}),h.syncAndInitial),"resize")},this._loadImageInternal=(e,t={})=>{this.clearImage(),this.error=null,this._imageChanged=!0,this.state="image-loading";const r="string"==typeof e,a=r?void 0:e.datasetFormat,i=r?e:e.url,{customParameters:s,options:n}=t;return this._image=new _({ioConfig:{skipExtensions:["aux.xml","jgw"],skipMapInfo:!0,datasetFormat:a},url:i,customParameters:s}),this._image.when((e=>{this._updatePanConstraint(),this._createResizeHandles(e),this._map.add(e),this.state="image-loaded"}),(t=>{l.isAbortError(t)?this.state="image-load-aborted":(this.state="image-load-error",this.error=t,o.getLogger(this).error(`error occurred while loading image ${r?e:JSON.stringify(e)}`,t),this.imageSource=null)})),this._image.load(n)},this._loadWithController=()=>{this._cancelLoadWithController(),this._loadController=new AbortController,this.loadImage(this._loadController)},this._updatePanConstraint=()=>{this._panConstraint&&this.imageRenderer.constraints.customConstraints.remove(this._panConstraint),this._panConstraint=this._createPanConstraint(),this.imageRenderer.constraints.customConstraints.add(this._panConstraint)},this.addGraphic=(e,t)=>{this._overlays.graphics.add(e,t)},this.addManyGraphics=e=>{this._overlays.addMany(e)},this.clearGraphics=()=>{this._overlays.graphics.removeAll()},this.clearImage=()=>{this.image&&(this._map.layers.remove(this.image),this._image=n.destroyMaybe(this._image))},this.loadImage=e=>{const{customParameters:t,imageSource:r}=this;return r?this._loadImageInternal(r,{customParameters:t,options:e}):x.logAndThrow(this.declaredClass,new a(x.getMissingPropertyErrorName("image-viewer"),x.getMissingPropertyErrorMessage("ImageViewerViewModel","imageSource")))},this.removeGraphic=e=>{this._overlays.remove(e)},this.removeManyGraphics=e=>{this._overlays.removeMany(e)},this._imageRenderer=new w({constraints:{snapToZoom:!0,rotationEnabled:!1},map:this._map,popupEnabled:!1,spatialReference:I.WebMercator,ui:{components:["zoom"]}})}initialize(){this.state="initialized",this.addHandles([h.watch((()=>this.imageSource),(e=>{e&&this.autoLoad&&this._loadWithController()}),h.syncAndInitial),h.watch((()=>this.image?.loaded),(()=>{this._createImageHandles()})),h.watch((()=>this.imageRotation),(()=>{this._rotateImage()})),h.watch((()=>this.imageRenderer.map),((e,t)=>{t?.layers.remove(this._overlays),e?.layers.add(this._overlays)}),h.initial),h.watch((()=>this.imageRenderer.map.allLayers.length),(e=>{e&&this.imageRenderer.map.layers.reorder(this._overlays,e-1)}),h.syncAndInitial),h.watch((()=>this.clickAction),(e=>{this.removeHandles(P.click),"none"!==e&&this.addHandles(this.imageRenderer.on("click",(t=>{if(this.image?.loaded&&this.imageRenderer.ready)switch(e){case"emit":t.stopPropagation(),this.emit("click",t);break;case"hittest":t.stopPropagation(),t.async((async()=>{const e=await this.imageRenderer.hitTest(t.screenPoint,{include:this._overlays});this.emit("hittest-response",e)}));break;case"pixel-location":{if(t.stopPropagation(),!this.image?.serviceRasterInfo||!t.mapPoint)return void this.emit("pixel-location",null);const{extent:e,pixelSize:r}=this.image.serviceRasterInfo,a=(t.mapPoint.x-e.xmin)*r.x,i=(e.ymax-t.mapPoint.y)*r.y,o=new b({x:a,y:i,spatialReference:e.spatialReference});this.emit("pixel-location",o);break}}})))}),h.syncAndInitial)])}get brightness(){return this._get("brightness")??0}set brightness(e){this._set("brightness",s.clamp(e,-10,10))}get contrast(){return this._get("contrast")??0}set contrast(e){this._set("contrast",s.clamp(e,-10,10))}get image(){return this._image}get imagePointsInView(){const{extent:e,ready:t}=this.imageRenderer,r=this.imageRotation,a=this.image?.fullExtent,i=this.image?.serviceRasterInfo,o=!0===this._imageRenderer.allLayerViews.find((({layer:e})=>e===this.image))?.attached;if(!(t&&e&&a&&i&&o))return null;const s=g.rotate(C.fromExtent(e),r),n=C.fromExtent(a),l=g.intersect(s,n),{rings:h}=l;return h.flat().map((([e,t])=>({x:(e-i.extent.xmin)*i.pixelSize.x,y:(i.extent.ymax-t)*i.pixelSize.y})))}get imageSize(){const{image:e}=this;if(!e?.raster)return null;const{width:t,height:r}=e.raster.rasterInfo;return[t,r]}get imageRenderer(){return this._imageRenderer}get imageView(){return this.imageRenderer.allLayerViews.find((e=>e.layer===this.image))}get sharpness(){return this._get("sharpness")??0}set sharpness(e){this._set("sharpness",s.clamp(e,0,1))}_rotateImage(){this.imageRenderer.constraints.rotationEnabled=!0,this.imageRenderer.rotation=this.imageRotation,this.imageRenderer.constraints.rotationEnabled=!1}sharpenImage(e,t){if(!t)return void(e.rasterFunction=null);const r=[0,-1*t,0,-1*t,4*t+1,-1*t,0,-1*t,0],a=new u({functionName:"Convolution",functionArguments:{type:v.convolutionKernel.userDefined,cols:3,rows:3,kernel:r,convolutionType:v.convolutionKernel.userDefined}});e.rasterFunction=a}};e.__decorate([c.property()],S.prototype,"_image",void 0),e.__decorate([c.property()],S.prototype,"_imageRenderer",void 0),e.__decorate([c.property()],S.prototype,"_loadController",void 0),e.__decorate([c.property()],S.prototype,"_overlays",void 0),e.__decorate([c.property()],S.prototype,"_map",void 0),e.__decorate([c.property({type:Boolean})],S.prototype,"autoLoad",void 0),e.__decorate([c.property({type:Number})],S.prototype,"brightness",null),e.__decorate([c.property()],S.prototype,"clickAction",void 0),e.__decorate([c.property({type:Number})],S.prototype,"contrast",null),e.__decorate([c.property({type:Object})],S.prototype,"customParameters",void 0),e.__decorate([c.property({type:a})],S.prototype,"error",void 0),e.__decorate([c.property({readOnly:!0})],S.prototype,"image",null),e.__decorate([c.property({readOnly:!0})],S.prototype,"imagePointsInView",null),e.__decorate([c.property({readOnly:!0})],S.prototype,"imageSize",null),e.__decorate([c.property({cast:x.castImageSource})],S.prototype,"imageSource",void 0),e.__decorate([c.property({readOnly:!0})],S.prototype,"imageRenderer",null),e.__decorate([c.property({type:Number})],S.prototype,"imageRotation",void 0),e.__decorate([c.property()],S.prototype,"imageView",null),e.__decorate([c.property({type:Number})],S.prototype,"sharpness",null),e.__decorate([c.property()],S.prototype,"state",void 0),S=e.__decorate([p.subclass("esri.widgets.OrientedImageryViewer.components.ImageViewerViewModel")],S);return S}));
