/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../Camera","../../geometry","../../Ground","../../Map","../../request","../../core/Collection","../../core/Error","../../core/Evented","../../core/jsonMap","../../core/mathUtils","../../core/maybe","../../core/promiseUtils","../../core/reactiveUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/Logger","../../core/RandomLCG","../../core/accessorSupport/decorators/enumeration","../../core/accessorSupport/decorators/subclass","../../layers/GraphicsLayer","../../layers/orientedImagery/transformations/utils","../../views/SceneView","../Zoom","../OrientedImageryViewer/utils","./constants","./PanoramicZoomConditions","./PanoramicZoomViewModel","./utils","../../geometry/SpatialReference"],(function(e,t,i,a,o,r,s,n,h,d,c,l,m,p,g,_,u,y,v,w,V,f,M,z,C,O,P,R,H,I){"use strict";const S={autoLoad:"auto-load",default:"default",navigation:"navigation",fovConstraint:"fov-constraint",clickAction:"image-click-action"};let b=class extends h.EventedAccessor{constructor(e){super(e),this._startPosition=null,this._targetPosition=null,this._graphics=new V({elevationInfo:{mode:"relative-to-ground"}}),this._imageGraphic=null,this._loadController=null,this._map=new o({ground:new a({opacity:0,navigationConstraint:null}),layers:new s([this._graphics])}),this._zoomViewModel=null,this.autoLoad=!1,this.clickAction="none",this.imageSize=null,this.imageSource=null,this.pitch=90,this.state="ready",this.yaw=0,this._addNavigationHandles=()=>{this.imageRenderer.basemapTerrain.suspended=!0,this.imageRenderer.constraints.tilt.max=180,this.removeHandles(S.navigation),this.addHandles([this.imageRenderer.on("mouse-wheel",this._handleWheel),this.imageRenderer.on("double-click",this._handleDoubleClick),this.imageRenderer.on("drag",this._handleDrag),this.imageRenderer.on("key-down",(e=>{const t=["+","-","Shift","_","=","ArrowUp","ArrowDown","ArrowRight","ArrowLeft"],i=e.key;t.includes(i)&&e.stopPropagation()}))],S.navigation)},this._addHFOVHandles=()=>{this.removeHandles(S.fovConstraint),this.addHandles(p.watch((()=>[this.maxHFOV,this.minHFOV]),(()=>{this._zoomViewModel&&(this._zoomViewModel.panoramicZoomConditions=new P({view:this.imageRenderer,maxFOV:this.maxHFOV,minFOV:this.minHFOV}))}),p.syncAndInitial),S.fovConstraint)},this._addZoomHandles=()=>{this._zoomViewModel=new R({view:this.imageRenderer,panoramicZoomConditions:new P({maxFOV:this.maxHFOV,minFOV:this.minHFOV})});const e=new z({viewModel:this._zoomViewModel});this.imageRenderer.ui.add(e,"top-left"),this._addHFOVHandles()},this._cancelLoadWithController=()=>{this._loadController?.abort(),this._loadController=null},this._handleDoubleClick=e=>{e.stopPropagation(),e.native.ctrlKey?this._zoomOut():this._zoomIn()},this._handleDrag=e=>{e.stopPropagation();const{action:t,x:i,y:a}=e;switch(t){case"start":this._startPosition=this._targetPosition={x:i,y:a};break;case"update":this._targetPosition={x:i,y:a},this._updateCameraHeadingAndTilt()}},this._handleImageClick=e=>{if("image-loaded"===this.state&&this.imageRenderer.ready)switch(this.clickAction){case"emit":e.stopPropagation(),this.emit("click",e);break;case"hittest":e.stopPropagation(),e.async((async()=>{const t=await this.imageRenderer.hitTest(e.screenPoint,{include:this._graphics});this.emit("hittest-response",t)}));break;case"pixel-location":{if(e.stopPropagation(),!this.imageSize||!e.mapPoint)return void this.emit("pixel-location",null);const t=f.convertSphereVertexToPixelLocation(e.mapPoint,this.imageSize[0],this.imageSize[1]);this.emit("pixel-location",{...t,spatialReference:I.WebMercator});break}}},this._handleWheel=e=>{const t=e.deltaX??e.native.deltaX;e.stopPropagation(),t>0||e.deltaY>0?this._zoomOut():this._zoomIn()},this._loadWithController=()=>{this._cancelLoadWithController(),this._loadController=new AbortController,this.loadImage(this._loadController)},this._zoomIn=()=>this._zoomViewModel?.zoomIn(),this._zoomOut=()=>this._zoomViewModel?.zoomOut(),this.addGraphic=(e,t)=>"image-loaded"===this.state&&!this._graphics.graphics.includes(e)&&(this._graphics.graphics.add(e,t),!0),this.addManyGraphics=e=>{if("image-loaded"!==this.state)return!1;const t=e.filter((e=>!this._graphics.graphics.includes(e)));return this._graphics.graphics.addMany(t),!0},this.clearGraphics=()=>{this._graphics.graphics.removeAll()},this.clearImage=()=>{this.imageSize=null,this._removeImageSphere()},this.removeGraphic=e=>!("image-loaded"!==this.state||!this._graphics.graphics.includes(e))&&(this._graphics.remove(e),!0),this.removeManyGraphics=e=>{if("image-loaded"!==this.state)return!1;const t=e.filter((e=>this._graphics.graphics.includes(e)));return this._graphics.removeMany(t),!0},this._imageRenderer=new M({map:this._map,viewingMode:"local",camera:{position:O.defaultImageSphereCenter},environment:{atmosphereEnabled:!1,starsEnabled:!1,lighting:{type:"virtual"}},popupEnabled:!1,spatialReference:I.WebMercator,ui:{components:["attribution"]}})}initialize(){this.state="initialized",this.addHandles([p.watch((()=>this.imageSource),(()=>{this.imageSource&&this.autoLoad&&this._loadWithController()}),p.syncAndInitial),p.watch((()=>this.fov),(()=>{this._reloadCamera()}),p.syncAndInitial),p.watch((()=>this.yaw),(e=>{this.camera.heading=e,this._reloadCamera()}),p.syncAndInitial),p.watch((()=>this.pitch),(e=>{this.camera.tilt=e,this._reloadCamera()}),p.syncAndInitial),p.when((()=>this.imageRenderer.ready),(()=>{this._addNavigationHandles(),this._addZoomHandles()}),p.syncAndInitial),p.watch((()=>this.clickAction),(e=>{this.removeHandles(S.clickAction),"none"!==e&&this.addHandles(this.imageRenderer.on("click",this._handleImageClick))}),p.syncAndInitial)],S.default)}get camera(){return this.imageRenderer.camera}set camera(e){e&&(this.imageRenderer.camera=e.clone())}get fov(){return this.camera.fov}set fov(e){Number.isFinite(e)&&this._zoomViewModel?.zoomTo(e)}get hfov(){const{fov:e}=this.camera,{size:[t,i]}=this.imageRenderer,a=t/i,o=Math.atan(a);return 2*c.rad2deg(Math.atan(Math.tan(c.deg2rad(e/2))*Math.sin(o)))}get imageRenderer(){return this._imageRenderer}get maxHFOV(){const{size:[e,t]}=this.imageRenderer;return H.findDiagonalFOV(O.maxPanoramicViewerHFOV,e/t)}get minHFOV(){const{size:[e,t]}=this.imageRenderer;return H.findDiagonalFOV(O.minPanoramicViewerHFOV,e/t)}get vfov(){const{fov:e}=this.camera,{size:[t,i]}=this.imageRenderer,a=t/i,o=Math.atan(a);return 2*c.rad2deg(Math.atan(Math.tan(c.deg2rad(e/2))*Math.cos(o)))}async _loadImageInternal(e,t){let i;this.state="image-loading";try{i=(await r(e,{responseType:"image",...t})).data}catch(a){throw m.isAbortError(a)?this.state="image-load-aborted":this.state="image-load-error",a}return this._updateImageSphere(i,t)}_reloadCamera(){this.camera=this.camera.clone()}_removeImageSphere(){this._imageGraphic&&(this._graphics.remove(this._imageGraphic),this._imageGraphic=l.destroyMaybe(this._imageGraphic)),this.state="ready",this.imageSize=null}_updateCameraHeadingAndTilt(){if(!this._startPosition||!this._targetPosition)return;const e=this.camera.heading+(this._startPosition.x-this._targetPosition.x)/this.imageRenderer.width*this.camera.fov;this.yaw=(e+360)%360;const t=this.camera.tilt-(this._startPosition.y-this._targetPosition.y)/this.imageRenderer.height*this.imageRenderer.camera.tilt;this.pitch=Math.min(179.5,Math.max(.5,t)),this._startPosition=this._targetPosition}async _updateImageSphere(e,t){await m.waitTick(t);const{size:[i,a]}=this.imageRenderer;return this._imageGraphic=H.meshToGraphic(H.createImageSphere(e)),this._graphics.add(this._imageGraphic),this.fov=H.findDiagonalFOV(O.humanBinocularHFOV,i/a),this.state="image-loaded",this.imageSize=[e.width,e.height],this._imageGraphic.geometry}async loadImage(e){return this._removeImageSphere(),this.imageSource?this._loadImageInternal(this.imageSource,e):C.logAndThrow(this.declaredClass,new n(C.getMissingPropertyErrorName("panoramic-viewer"),C.getMissingPropertyErrorMessage("PanoramicViewerViewModel","imageSource")))}};e.__decorate([g.property()],b.prototype,"_graphics",void 0),e.__decorate([g.property()],b.prototype,"_imageGraphic",void 0),e.__decorate([g.property()],b.prototype,"_imageRenderer",void 0),e.__decorate([g.property()],b.prototype,"_loadController",void 0),e.__decorate([g.property()],b.prototype,"_map",void 0),e.__decorate([g.property()],b.prototype,"_zoomViewModel",void 0),e.__decorate([g.property({type:Boolean})],b.prototype,"autoLoad",void 0),e.__decorate([g.property({type:t})],b.prototype,"camera",null),e.__decorate([v.enumeration(new d.JSONMap({emit:"emit",hittest:"hittest",none:"none","pixel-location":"pixel-location"}))],b.prototype,"clickAction",void 0),e.__decorate([g.property({type:Number})],b.prototype,"fov",null),e.__decorate([g.property({readOnly:!0})],b.prototype,"hfov",null),e.__decorate([g.property({readOnly:!0})],b.prototype,"imageRenderer",null),e.__decorate([g.property()],b.prototype,"imageSize",void 0),e.__decorate([g.property()],b.prototype,"imageSource",void 0),e.__decorate([g.property({readOnly:!0})],b.prototype,"maxHFOV",null),e.__decorate([g.property({readOnly:!0})],b.prototype,"minHFOV",null),e.__decorate([g.property({type:Number})],b.prototype,"pitch",void 0),e.__decorate([g.property()],b.prototype,"state",void 0),e.__decorate([g.property({readOnly:!0})],b.prototype,"vfov",null),e.__decorate([g.property({type:Number})],b.prototype,"yaw",void 0),b=e.__decorate([w.subclass("esri.widgets.PanoramicViewer.PanoramicViewerViewModel")],b);return b}));
