/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../core/deprecate","../core/Logger","../core/promiseUtils","../core/reactiveUtils","../core/scheduling","../core/accessorSupport/decorators/property","../core/has","../core/RandomLCG","../core/accessorSupport/decorators/subclass","../support/actions/ActionButton","./Features","./Widget","./Popup/css","./Popup/PopupViewModel","./Popup/PopupVisibleElements","./support/globalCss","./support/widgetUtils","./support/decorators/messageBundle","./support/decorators/vmEvent","./support/jsxFactory"],(function(e,t,i,o,n,s,r,l,a,c,d,p,h,u,g,_,v,b,w,m,f){"use strict";const y=200,E={buttonEnabled:!0,position:"auto",breakpoint:{width:544}};let k=class extends h{constructor(e,t){super(e,t),this._dockAction=new d({id:"popup-dock-action"}),this._featuresWidget=new p({responsiveActionsEnabled:!0}),this._containerNode=null,this._mainContainerNode=null,this._pointerOffsetInPx=16,this._focusAbortController=null,this.alignment="auto",this.dockEnabled=!1,this.headingLevel=2,this.messages=null,this.viewModel=new g,this.visibleElements=new _}initialize(){this.addHandles([n.watch((()=>[this.viewModel?.view?.widthBreakpoint,this.dockEnabled]),(()=>this._handleDockIcon()),n.initial),n.watch((()=>[this.dockEnabled,this.messages?.undock,this.messages?.dock]),(()=>this._handleDockEnabled()),n.initial),n.watch((()=>this.dockOptions),(e=>{const{_dockAction:t}=this,i=this._featuresWidget.headerActions;i.remove(t),e.buttonEnabled&&i.add(t)}),n.initial),n.watch((()=>this.viewModel?.screenLocation),(()=>this._positionContainer())),n.watch((()=>[this.viewModel?.active,this.dockEnabled]),(()=>this._toggleScreenLocationEnabled())),n.watch((()=>[this.viewModel?.screenLocation,this.viewModel?.view?.padding,this.viewModel?.view?.size,this.viewModel?.active,this.viewModel?.location,this.alignment]),(()=>this.reposition())),n.watch((()=>this.viewModel?.view?.size),((e,t)=>this._updateDockEnabledForViewSize(e,t))),n.watch((()=>this.viewModel?.view),((e,t)=>this._viewChange(e,t))),n.watch((()=>this.viewModel?.view?.ready),((e,t)=>this._viewReadyChange(e??!1,t??!1))),n.watch((()=>this.viewModel),(()=>this._featuresWidget.viewModel=this.viewModel),n.initial),n.watch((()=>this._featureNavigationTop),(e=>this._featuresWidget.featureNavigationTop=e),n.initial),n.watch((()=>this.headingLevel),(e=>this._featuresWidget.headingLevel=e),n.initial),n.watch((()=>this.visibleElements.actionBar),(e=>this._featuresWidget.visibleElements.actionBar=!!e),n.initial),n.watch((()=>this.visibleElements.closeButton),(e=>this._featuresWidget.visibleElements.closeButton=!!e),n.initial),n.watch((()=>this.visibleElements.collapseButton),(e=>this._featuresWidget.visibleElements.collapseButton=!!e),n.initial),n.watch((()=>this.visibleElements.heading),(e=>this._featuresWidget.visibleElements.heading=!!e),n.initial),n.watch((()=>this.visibleElements.spinner),(e=>this._featuresWidget.visibleElements.spinner=!!e),n.initial),n.watch((()=>this.visibleElements.featureNavigation),(e=>this._featuresWidget.visibleElements.featureNavigation=!!e),n.initial),n.watch((()=>this.visibleElements.featureListLayerTitle),(e=>this._featuresWidget.visibleElements.featureListLayerTitle=!!e),n.initial),n.on((()=>this._featuresWidget),"trigger-header-action",(e=>{e.action===this._dockAction&&(this.dockEnabled=!this.dockEnabled)}))])}normalizeCtorArgs(e){const t={...e};return null!=e?.visibleElements&&(t.visibleElements=new _(e.visibleElements),null!=e.collapseEnabled&&(t.visibleElements.collapseButton=e.collapseEnabled),null!=e.spinnerEnabled&&(t.visibleElements.spinner=e.spinnerEnabled)),t}destroy(){this._dockAction.destroy(),this._featuresWidget?.destroy(),this._focusAbortController?.abort()}get _featureNavigationTop(){const{currentAlignment:e,currentDockPosition:t}=this;return"bottom-left"===e||"bottom-center"===e||"bottom-right"===e||"top-left"===t||"top-center"===t||"top-right"===t}get actions(){return this.viewModel.actions}set actions(e){this.viewModel.actions=e}get active(){return this.viewModel.active}get autoCloseEnabled(){return this.viewModel.autoCloseEnabled}set autoCloseEnabled(e){this.viewModel.autoCloseEnabled=e}get defaultPopupTemplateEnabled(){return this.viewModel.defaultPopupTemplateEnabled}set defaultPopupTemplateEnabled(e){this.viewModel.defaultPopupTemplateEnabled=e}get content(){return this.viewModel.content}set content(e){this.viewModel.content=e}get collapsed(){return this._featuresWidget.collapsed}set collapsed(e){this._featuresWidget.collapsed=e}get collapseEnabled(){return t.deprecatedProperty(i.getLogger(this),"collapseEnabled",{replacement:"PopupVisibleElements.collapseButton",version:"4.29"}),this.visibleElements.collapseButton}set collapseEnabled(e){t.deprecatedProperty(i.getLogger(this),"collapseEnabled",{replacement:"PopupVisibleElements.collapseButton",version:"4.29"}),this.visibleElements.collapseButton=e}get currentAlignment(){return this._getCurrentAlignment()}get currentDockPosition(){return this._getCurrentDockPosition()}get dockOptions(){return this._get("dockOptions")||E}set dockOptions(e){const t={...E},i=this.viewModel?.view?.breakpoints,o={};i&&(o.width=i.xsmall,o.height=i.xsmall);const n={...t,...e},s={...t.breakpoint,...o},{breakpoint:r}=n;"object"==typeof r?n.breakpoint={...s,...r}:r&&(n.breakpoint=s),this._set("dockOptions",n),this._setCurrentDockPosition(),this.reposition()}get featureCount(){return this.viewModel.featureCount}get featureMenuOpen(){return this.viewModel.featureMenuOpen}set featureMenuOpen(e){this.viewModel.featureMenuOpen=e}get features(){return this.viewModel.features}set features(e){this.viewModel.features=e}get goToOverride(){return this.viewModel.goToOverride}set goToOverride(e){this.viewModel.goToOverride=e}get highlightEnabled(){return this.viewModel.highlightEnabled}set highlightEnabled(e){this.viewModel.highlightEnabled=e}get icon(){return"popup"}set icon(e){this._overrideIfSome("icon",e)}get location(){return this.viewModel.location}set location(e){this.viewModel.location=e}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}get promises(){return this.viewModel.promises}set promises(e){this.viewModel.promises=e}get selectedFeature(){return this.viewModel.selectedFeature}get selectedFeatureIndex(){return this.viewModel.selectedFeatureIndex}set selectedFeatureIndex(e){this.viewModel.selectedFeatureIndex=e}get selectedFeatureWidget(){return this._featuresWidget.selectedFeatureWidget}get spinnerEnabled(){return t.deprecatedProperty(i.getLogger(this),"spinnerEnabled",{replacement:"PopupVisibleElements.spinner",version:"4.29"}),this.visibleElements.spinner}set spinnerEnabled(e){t.deprecatedProperty(i.getLogger(this),"spinnerEnabled",{replacement:"PopupVisibleElements.spinner",version:"4.29"}),this.visibleElements.spinner=e}get title(){return this.viewModel.title}set title(e){this.viewModel.title=e}get updateLocationEnabled(){return this.viewModel.updateLocationEnabled}set updateLocationEnabled(e){this.viewModel.updateLocationEnabled=e}get view(){return this.viewModel.view}set view(e){this.viewModel.view=e}get visible(){return this.viewModel.visible}set visible(e){this.viewModel.visible=e}blur(){const{active:e}=this.viewModel;e||i.getLogger(this).warn("Popup can only be blurred when currently active."),this._featuresWidget.blur()}clear(){return this.viewModel.clear()}close(){this.visible=!1}fetchFeatures(e,t){return this.viewModel.fetchFeatures(e,t)}focus(){const{active:e}=this.viewModel;e||i.getLogger(this).warn("Popup can only be focused when currently active."),this._handleFocus()}next(){return this.viewModel.next()}open(e){const t=!!e&&!!e.featureMenuOpen,i={collapsed:!!e&&!!e.collapsed,featureMenuOpen:t};this.set(i),this.viewModel.open(e),e?.shouldFocus&&this._handleFocus(!0)}previous(){return this.viewModel.previous()}reposition(){this.renderNow(),this._positionContainer(),this._setCurrentAlignment()}triggerAction(e){return this.viewModel.triggerAction(e)}render(){const{dockEnabled:e,currentAlignment:t,currentDockPosition:i}=this,{active:o,screenLocation:n}=this.viewModel,s=o&&e,r=o&&!e,l=this.selectedFeature?.layer?.title,a=this.selectedFeature?.layer?.id,c={[u.css.alignTopCenter]:"top-center"===t,[u.css.alignBottomCenter]:"bottom-center"===t,[u.css.alignTopLeft]:"top-left"===t,[u.css.alignBottomLeft]:"bottom-left"===t,[u.css.alignTopRight]:"top-right"===t,[u.css.alignBottomRight]:"bottom-right"===t,[u.css.isDocked]:s,[u.css.shadow]:r,[u.css.isDockedTopLeft]:"top-left"===i,[u.css.isDockedTopCenter]:"top-center"===i,[u.css.isDockedTopRight]:"top-right"===i,[u.css.isDockedBottomLeft]:"bottom-left"===i,[u.css.isDockedBottomCenter]:"bottom-center"===i,[u.css.isDockedBottomRight]:"bottom-right"===i};return f.tsx("div",{afterCreate:this._positionContainer,afterUpdate:this._positionContainer,bind:this,class:this.classes(u.css.base,c,{[u.css.baseHidden]:!n&&!e}),"data-layer-id":a,"data-layer-title":l,role:"presentation"},o?[this._renderMainContainer(),this._renderPointer()]:null)}_renderPointer(){return this.dockEnabled?null:f.tsx("div",{class:u.css.pointer,key:"popup-pointer",role:"presentation"},f.tsx("div",{class:this.classes(u.css.pointerDirection,u.css.shadow)}))}_renderMainContainer(){const{dockEnabled:e}=this,t={[u.css.shadow]:e};return f.tsx("div",{afterCreate:this._setMainContainerNode,afterUpdate:this._setMainContainerNode,bind:this,class:this.classes(u.css.main,v.globalCss.widget,t)},this._featuresWidget.render())}_getAnimationDurationMS(){const{_containerNode:e}=this;return e?1e3*parseFloat(window.getComputedStyle(e).animationDuration):y}async _handleFocus(e=!1){this._focusAbortController?.abort(),this._focusAbortController=new AbortController;const t=this._focusAbortController.signal;e&&await n.whenOnce((()=>!0===this.viewModel?.active),{signal:t}),await o.ignoreAbortErrors(s.waitAnimationFrame(t)),await o.ignoreAbortErrors(o.after(this._getAnimationDurationMS(),t)),this._featuresWidget.focus()}_isOutsideView(e){const{popupHeight:t,popupWidth:i,screenLocation:o,side:n,view:s}=e;if(isNaN(i)||isNaN(t)||!s||!o)return!1;const r=s.padding;return"right"===n&&o.x+i/2>s.width-r.right||("left"===n&&o.x-i/2<r.left||("top"===n&&o.y-t<r.top||"bottom"===n&&o.y+t>s.height-r.bottom))}_calculateAutoAlignment(e){if("auto"!==e)return e;const{_pointerOffsetInPx:t,_containerNode:i,_mainContainerNode:o,viewModel:n}=this,{screenLocation:s,view:r}=n;if(null==s||!r||!i)return"top-center";function l(e){return parseInt(e.replaceAll(/[^-\d.]/g,""),10)}const a=o?window.getComputedStyle(o,null):null,c=a?l(a.getPropertyValue("max-height")):0,d=a?l(a.getPropertyValue("height")):0,{height:p,width:h}=i.getBoundingClientRect(),u=h+t,g=Math.max(p,c,d)+t,_=this._isOutsideView({popupHeight:g,popupWidth:u,screenLocation:s,side:"right",view:r}),v=this._isOutsideView({popupHeight:g,popupWidth:u,screenLocation:s,side:"left",view:r}),b=this._isOutsideView({popupHeight:g,popupWidth:u,screenLocation:s,side:"top",view:r}),w=this._isOutsideView({popupHeight:g,popupWidth:u,screenLocation:s,side:"bottom",view:r});return v?b?"bottom-right":"top-right":_?b?"bottom-left":"top-left":b?w?"top-center":"bottom-center":"top-center"}_callCurrentAlignment(e){return"function"==typeof e?e.call(this):e}_getCurrentAlignment(){const{alignment:e,dockEnabled:t}=this;return t||!this.viewModel.active?null:this._calculatePositionResult(this._calculateAutoAlignment(this._callCurrentAlignment(e)))}_setCurrentAlignment(){this._set("currentAlignment",this._getCurrentAlignment())}_setCurrentDockPosition(){this._set("currentDockPosition",this._getCurrentDockPosition())}_calculatePositionResult(e){const t=["left","right"];return b.isRTL(this.container)&&t.reverse(),e?.replace(/leading/gi,t[0]).replaceAll(/trailing/gi,t[1])}_callDockPosition(e){return"function"==typeof e?e.call(this):e}_getDockPosition(){return this._calculatePositionResult(this._calculateAutoDockPosition(this._callDockPosition(this.dockOptions?.position)))}_getCurrentDockPosition(){return this.dockEnabled&&this.viewModel.active?this._getDockPosition():null}_calculateAutoDockPosition(e){if("auto"!==e)return e;const t=this.viewModel?.view,i=b.isRTL(this.container)?"top-left":"top-right";if(!t)return i;const o=t.padding||{left:0,right:0,top:0,bottom:0},n=t.width-o.left-o.right,{breakpoints:s}=t;return s&&n<=s.xsmall?"bottom-center":i}_getDockIcon(){const e=this._getDockPosition();if(this.dockEnabled)return"minimize";switch(e){case"top-left":case"bottom-left":return"dock-left";case"top-center":return"maximize";case"bottom-center":return"dock-bottom";default:return"dock-right"}}_handleDockIcon(){this._dockAction.icon=this._getDockIcon()}_handleDockEnabled(){this._dockAction.title=this.dockEnabled?this.messages?.undock:this.messages?.dock}_setMainContainerNode(e){this._mainContainerNode=e}_positionContainer(e=this._containerNode){if(e&&(this._containerNode=e),!this._containerNode)return;const{screenLocation:t}=this.viewModel,{width:i}=this._containerNode.getBoundingClientRect(),o=this._calculatePositionStyle(t,i);o&&Object.assign(this._containerNode.style,o)}_calculateFullWidth(e){const{currentAlignment:t,_pointerOffsetInPx:i}=this;return"top-left"===t||"bottom-left"===t||"top-right"===t||"bottom-right"===t?e+i:e}_calculateAlignmentPosition(e,t,i,o){const{currentAlignment:n,_pointerOffsetInPx:s}=this;if(!i)return;const{padding:r}=i,l=o/2,a=i.height-t,c=i.width-e;return"bottom-center"===n?{top:t+s-r.top,left:e-l-r.left}:"top-left"===n?{bottom:a+s-r.bottom,right:c+s-r.right}:"bottom-left"===n?{top:t+s-r.top,right:c+s-r.right}:"top-right"===n?{bottom:a+s-r.bottom,left:e+s-r.left}:"bottom-right"===n?{top:t+s-r.top,left:e+s-r.left}:"top-center"===n?{bottom:a+s-r.bottom,left:e-l-r.left}:void 0}_calculatePositionStyle(e,t){const{dockEnabled:i,view:o}=this;if(!o)return;if(i)return{left:"",top:"",right:"",bottom:""};if(null==e||!t)return;const n=this._calculateFullWidth(t),s=this._calculateAlignmentPosition(e.x,e.y,o,n);return s?{top:void 0!==s.top?`${s.top}px`:"auto",left:void 0!==s.left?`${s.left}px`:"auto",bottom:void 0!==s.bottom?`${s.bottom}px`:"auto",right:void 0!==s.right?`${s.right}px`:"auto"}:void 0}_viewChange(e,t){e&&t&&(this.close(),this.clear())}_viewReadyChange(e,t){e?this._wireUpView():t&&(this.close(),this.clear())}_wireUpView(){this._setDockEnabledForViewSize(this.dockOptions)}_dockingThresholdCrossed(e,t,i){const[o,n]=e,[s,r]=t,{width:l=0,height:a=0}=i??{};return o<=l&&s>l||o>l&&s<=l||n<=a&&r>a||n>a&&r<=a}_updateDockEnabledForViewSize(e,t){if(!e||!t)return;const i=this.viewModel?.view?.padding||{left:0,right:0,top:0,bottom:0},o=i.left+i.right,n=i.top+i.bottom,s=[],r=[];s[0]=e[0]-o,s[1]=e[1]-n,r[0]=t[0]-o,r[1]=t[1]-n;const{dockOptions:l}=this,a=l.breakpoint;this._dockingThresholdCrossed(s,r,a)&&this._setDockEnabledForViewSize(l),this._setCurrentDockPosition()}_toggleScreenLocationEnabled(){const{dockEnabled:e,viewModel:t}=this;if(!t)return;const i=t.active&&!e;t.screenLocationEnabled=i}_shouldDockAtCurrentViewSize(e){const t=e.breakpoint,i=this.viewModel?.view?.ui;if(!i)return!1;const{width:o,height:n}=i;if(isNaN(o)||isNaN(n))return!1;if(!t)return!1;const s=t.hasOwnProperty("width")&&o<=(t.width??0),r=t.hasOwnProperty("height")&&n<=(t.height??0);return s||r}_setDockEnabledForViewSize(e){e.breakpoint&&(this.dockEnabled=this._shouldDockAtCurrentViewSize(e))}};e.__decorate([r.property({readOnly:!0})],k.prototype,"_featureNavigationTop",null),e.__decorate([r.property()],k.prototype,"actions",null),e.__decorate([r.property({readOnly:!0})],k.prototype,"active",null),e.__decorate([r.property()],k.prototype,"alignment",void 0),e.__decorate([r.property()],k.prototype,"autoCloseEnabled",null),e.__decorate([r.property()],k.prototype,"defaultPopupTemplateEnabled",null),e.__decorate([r.property()],k.prototype,"content",null),e.__decorate([r.property()],k.prototype,"collapsed",null),e.__decorate([r.property()],k.prototype,"collapseEnabled",null),e.__decorate([r.property({readOnly:!0})],k.prototype,"currentAlignment",null),e.__decorate([r.property({readOnly:!0})],k.prototype,"currentDockPosition",null),e.__decorate([r.property()],k.prototype,"dockOptions",null),e.__decorate([r.property()],k.prototype,"dockEnabled",void 0),e.__decorate([r.property({readOnly:!0})],k.prototype,"featureCount",null),e.__decorate([r.property()],k.prototype,"featureMenuOpen",null),e.__decorate([r.property()],k.prototype,"features",null),e.__decorate([r.property()],k.prototype,"goToOverride",null),e.__decorate([r.property()],k.prototype,"headingLevel",void 0),e.__decorate([r.property()],k.prototype,"highlightEnabled",null),e.__decorate([r.property()],k.prototype,"icon",null),e.__decorate([r.property()],k.prototype,"location",null),e.__decorate([r.property()],k.prototype,"label",null),e.__decorate([r.property(),w.messageBundle("esri/widgets/Popup/t9n/Popup")],k.prototype,"messages",void 0),e.__decorate([r.property()],k.prototype,"promises",null),e.__decorate([r.property({readOnly:!0})],k.prototype,"selectedFeature",null),e.__decorate([r.property()],k.prototype,"selectedFeatureIndex",null),e.__decorate([r.property({readOnly:!0})],k.prototype,"selectedFeatureWidget",null),e.__decorate([r.property()],k.prototype,"spinnerEnabled",null),e.__decorate([r.property()],k.prototype,"title",null),e.__decorate([r.property()],k.prototype,"updateLocationEnabled",null),e.__decorate([r.property()],k.prototype,"view",null),e.__decorate([r.property({type:g}),m.vmEvent(["triggerAction","trigger-action"])],k.prototype,"viewModel",void 0),e.__decorate([r.property()],k.prototype,"visible",null),e.__decorate([r.property({type:_,nonNullable:!0})],k.prototype,"visibleElements",void 0),k=e.__decorate([c.subclass("esri.widgets.Popup")],k);return k}));
