/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../geometry","../intl","../core/Collection","../core/jsonMap","../core/reactiveUtils","../core/unitFormatUtils","../core/urlUtils","../core/accessorSupport/decorators/property","../core/accessorSupport/ensureType","../core/RandomLCG","../core/has","../core/accessorSupport/decorators/subclass","../geometry/support/spatialReferenceUtils","../portal/support/urlUtils","../rest/utils","../rest/support/fileFormat","./Widget","./Print/FileLink","./Print/PrintViewModel","../chunks/componentsUtils","./support/globalCss","./support/Heading","./support/legacyIcon","./support/widgetUtils","./support/decorators/messageBundle","./support/jsxFactory","../geometry/SpatialReference","../intl/number"],(function(e,t,a,l,i,s,o,n,r,c,p,d,u,h,m,b,_,x,y,v,g,w,f,T,k,C,S,O,$,I){"use strict";const E=i.ofType(v),L="map-only";var F;!function(e){e.layout="layoutTab",e.mapOnly="mapOnlyTab",e.export="exportTab"}(F||(F={}));const M="esri-print",P=`${M}__advanced-options-button`,B={base:M,headerTitle:`${M}__header-title`,layoutTabList:`${M}__layout-tab-list`,layoutTab:`${M}__layout-tab`,layoutSection:`${M}__layout-section`,mapOnlySection:`${M}__map-only-section`,panelItemsCentered:`${M}__panel-items--centered`,loader:`${M}__loader`,advancedOptionsButton:P,advancedOptionsButtonContainer:`${P}-container`,advancedOptionsButtonTitle:`${P}-title`,advancedOptionsButtonIconOpened:`${P}-icon--opened`,advancedOptionsButtonIconClosed:`${P}-icon--closed`,advancedOptionsButtonIconClosed_RTL:`${P}-icon--closed-rtl`,swapButton:`${M}__swap-button`,printButton:`${M}__export-button`,printButtonSection:`${M}__export-button-section`,printButtonSectionDivider:`${M}__export-button-section--divider`,templateSelectContainer:`${M}__template-select-container`,templateSelectBlock:`${M}__template-select-block`,templateSelectIcon:`${M}__template-select-icon`,templateSelectError:`${M}__template-select-error`,templateSelectArrow:`${M}__template-select-arrow`,formSectionContainer:`${M}__form-section-container`,formCheckboxLabel:`${M}__form-checkbox-label`,advancedOptionsSection:`${M}__advanced-options-section`,advancedOptionsContainer:`${M}__advanced-options-container`,browseTemplateButtonContainer:`${M}__browse-template-button-container`,browseTemplateButtonContainerFilter:`${M}__browse-template-button-container-filter`,exportedFilesContainer:`${M}__export-panel-container`,exportedFilesTitle:`${M}__export-title`,exportedFile:`${M}__exported-file`,exportedFileLink:`${M}__exported-file-link`,exportedFileLinkTitle:`${M}__exported-file-link-title`,exportedFileLinkDescription:`${M}__exported-file-link-description`,exportedFilesEmpty:`${M}__exported-files-empty`,printWidgetContainer:`${M}__container`,content:`${M}__content`,panelContainer:`${M}__panel-container`,scaleInfoContainer:`${M}__scale-info-container`,scaleInputContainer:`${M}__scale-input-container`,scaleInput:`${M}__scale-input`,sizeContainer:`${M}__size-container`,panelError:`${M}__panel--error`,exportedFileError:`${M}__exported-file--error`,exportedFileLoader:`${M}__exported-file--loader`,exportSection:`${M}__export-section`,exportSectionCentered:`${M}__export-section--centered`,templateButtonContainer:`${M}__template-button-container`,templateDoneButton:`${M}__template-done-button`,templateSelectFlowItemContainer:`${M}__template-select-flow-item-container`,templateSelectFlowItemContent:`${M}__template-select-flow-item-content`,templateSelectFlowItemListHeading:`${M}__template-select-flow-item-list-heading`,srLabel:`${M}__sr-label`,invalidWkidText:`${M}__invalid-wkid-text`};function A(e,t,a,l){const i=a/t,s=l/t;return{width:Math.round(e*i),height:Math.round(e*s)}}function N(e){return!isNaN(e)&&e>0}function R(e){return e?.toLowerCase()===L}function D(e){const{state:t,extension:a}=e;switch(t){case"pending":return"spinner";case"error":return"exclamation-mark-circle";default:return a?.toLowerCase()?.includes("pdf")?"file-pdf":"file"}}const V=new s.JSONMap({inch:"inches",foot:"feet",yard:"yards",mile:"miles","nautical-mile":"nautical-miles",millimeter:"millimeters",centimeter:"centimeters",decimeter:"decimeters",meter:"meters",kilometer:"kilometers"}),U=new Map([["a3-landscape","a3-landscape"],["a3-portrait","a3-portrait"],["a4-landscape","a4-landscape"],["a4-portrait","a4-portrait"],["letter-ansi-a-landscape","ansi-a-landscape"],["letter-ansi-a-portrait","ansi-a-portrait"],["tabloid-ansi-b-landscape","ansi-b-landscape"],["tabloid-ansi-b-portrait","ansi-b-portrait"]]);let H=class extends y{constructor(e,t){super(e,t),this._activeTabFocusRequested=!1,this._awaitingServerResponse=!1,this._exportedFileNameMap={},this._selectedTab=F.layout,this._pendingExportScroll=!1,this._rootNode=null,this._selectedTemplate=null,this._formats=[],this._showTemplates=!1,this._isValidSpatialReference=!0,this.allowedFormatsForSaving=null,this.browseTemplateButtonOnClick=null,this.exportedLinks=new E,this.headerVisible=!0,this.headingLevel=3,this.messagesCommon=null,this.messagesUnits=null,this.saveExportEnabled=!1,this.saveExportHidden=!0,this.saveAsButtonCallback=null,this.viewModel=new g,this._onInput=e=>{this._selectedTab===F.layout?this.templateOptions.title=e.target.value:this._selectedTab===F.mapOnly&&(this.templateOptions.fileName=e.target.value)},this._handleLinkClick=e=>{const t=e.currentTarget["data-item"];if(!t||"ready"!==t.state||!t.url)return;const a=_.getToken(this.viewModel.effectivePrintServiceUrl),l=t.url,i=document.createElement("a");if(i.target="_blank",i.href=l,i.rel="noreferrer",i.download=t.formattedName??"",!a)return i.click(),void e.stopPropagation();e.preventDefault();const s=new URL(l);s.searchParams.set("token",a),i.href=s.href,i.click(),i.href=l},this._focusOnTabChange=this._focusOnTabChange.bind(this)}initialize(){this.addHandles([o.watch((()=>[this.templateOptions.format,this.viewModel.templatesInfo?.format]),(()=>{const{templatesInfo:e}=this.viewModel;if(!e)return;if(this._formats.length!==e.format.choiceList.length){const t=x.formatJsonMap.apiValues;this._formats=e.format.choiceList.map((e=>{const a=t.find((t=>new RegExp(`\\b${t}\\b`,"i").test(e)))??e;return{value:a,label:e===a?e.toUpperCase():e}})).sort(((e,t)=>e.label.localeCompare(t.label)))}const t=this._formats.some((({value:e})=>new RegExp(`\\b${e}\\b`,"i").test(this.templateOptions.format)));if(!e.format.defaultValue||t);else{const t=this._formats.find((({value:t})=>new RegExp(`\\b${t}\\b`,"i").test(e.format.defaultValue)))?.value;t&&(this.templateOptions.format=t)}})),o.watch((()=>[this.templateOptions.id,this.viewModel.loaded]),(async()=>{const{layout:e}=this.templateOptions;this._selectedTab=R(e)?F.mapOnly:F.layout,this._selectedTab===F.layout&&this.viewModel.loaded&&(this._selectedTemplate=this.viewModel.getLayoutTemplateById(this.templateOptions.id))})),o.watch((()=>this.templateOptions.dpi),(e=>{e<=0&&(this.templateOptions.dpi=1)})),o.watch((()=>this.viewModel.view?.scale),(e=>{!e||this.templateOptions.scaleEnabled&&this.templateOptions.scale||(this.templateOptions.scale=e)}))]);for(const{name:l,extension:i}of this.exportedLinks)l&&i&&this._updateExportedFileNameMap(`${l}${i}`);const{height:e,width:t}=this.templateOptions;this.templateOptions.width=t||800,this.templateOptions.height=e||1100;const a=setTimeout((()=>{this._awaitingServerResponse=!0,this.scheduleRender()}),500);this.viewModel.load().then((()=>{clearTimeout(a),this._awaitingServerResponse=!1}))}loadDependencies(){return w.loadCalciteComponents({action:()=>new Promise(((t,a)=>e(["../chunks/calcite-action"],t,a))),block:()=>new Promise(((t,a)=>e(["../chunks/calcite-block"],t,a))),button:()=>new Promise(((t,a)=>e(["../chunks/calcite-button"],t,a))),checkbox:()=>new Promise(((t,a)=>e(["../chunks/calcite-checkbox"],t,a))),combobox:()=>new Promise(((t,a)=>e(["../chunks/calcite-combobox"],t,a))),"combobox-item":()=>new Promise(((t,a)=>e(["../chunks/calcite-combobox-item"],t,a))),flow:()=>new Promise(((t,a)=>e(["../chunks/calcite-flow"],t,a))),"flow-item":()=>new Promise(((t,a)=>e(["../chunks/calcite-flow-item"],t,a))),icon:()=>new Promise(((t,a)=>e(["../chunks/calcite-icon"],t,a))),input:()=>new Promise(((t,a)=>e(["../chunks/calcite-input"],t,a))),"input-number":()=>new Promise(((t,a)=>e(["../chunks/calcite-input-number"],t,a))),label:()=>new Promise(((t,a)=>e(["../chunks/calcite-label"],t,a))),list:()=>new Promise(((t,a)=>e(["../chunks/calcite-list"],t,a))),"list-item":()=>new Promise(((t,a)=>e(["../chunks/calcite-list-item"],t,a))),loader:()=>new Promise(((t,a)=>e(["../chunks/calcite-loader"],t,a))),switch:()=>new Promise(((t,a)=>e(["../chunks/calcite-switch"],t,a))),chip:()=>new Promise(((t,a)=>e(["../chunks/calcite-chip"],t,a))),popover:()=>new Promise(((t,a)=>e(["../chunks/calcite-popover"],t,a))),link:()=>new Promise(((t,a)=>e(["../chunks/calcite-link"],t,a)))})}destroy(){this.viewModel.destroy()}get allowedFormats(){return this.viewModel.allowedFormats}set allowedFormats(e){this.viewModel.allowedFormats=e}get allowedLayouts(){return this.viewModel.allowedLayouts}set allowedLayouts(e){this.viewModel.allowedLayouts=e}get error(){return this.viewModel.error}get extraParameters(){return this.viewModel.extraParameters}set extraParameters(e){this.viewModel.extraParameters=e}get icon(){return"print"}set icon(e){this._overrideIfSome("icon",e)}get includeDefaultTemplates(){return this.viewModel.includeDefaultTemplates}set includeDefaultTemplates(e){this.viewModel.includeDefaultTemplates=e}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}get outSpatialReference(){return this.viewModel.outSpatialReference}set outSpatialReference(e){this.viewModel.outSpatialReference=e}get portal(){return this.viewModel.portal}set portal(e){this.viewModel.portal=e}get showPrintAreaEnabled(){return this.viewModel.showPrintAreaEnabled}set showPrintAreaEnabled(e){this.viewModel.showPrintAreaEnabled=e}get printServiceUrl(){return this.viewModel.printServiceUrl}set printServiceUrl(e){this.viewModel.printServiceUrl=e}get templateCustomTextElements(){return this.viewModel.templateCustomTextElements}set templateCustomTextElements(e){this.viewModel.templateCustomTextElements=e}get templateOptions(){return this.viewModel.templateOptions}set templateOptions(e){this.viewModel.templateOptions=e}get view(){return this.viewModel.view}set view(e){this.viewModel.view=e}render(){const{messages:e,templateOptions:t,viewModel:a,view:l}=this,{attributionEnabled:i,author:s,copyright:o,dpi:n,format:r,height:c,layout:d,layoutItem:u,legendEnabled:h,northArrowEnabled:b,scaleBarEnabled:_,scaleEnabled:x,scale:y,width:v}=t,g="ready"!==a.state||this._awaitingServerResponse||!(d||u),w=this._renderTitleOrFileNameSection(),S=O.tsx("div",{class:B.formSectionContainer},O.tsx("calcite-label",null,e.fileFormatTitle,O.tsx("calcite-combobox",{clearDisabled:!0,label:e.formatDefaultOption,maxItems:6,placeholder:e.formatDefaultOption,selectionMode:"single-persist",onCalciteComboboxChange:({target:e})=>{this.templateOptions.format=e.selectedItems[0]?.value??"pdf"}},this._formats.map((({value:e,label:t},a)=>O.tsx("calcite-combobox-item",{key:`file-format-${a}`,selected:e===this.templateOptions.format,textLabel:t,value:e})))))),I=O.tsx("calcite-label",{layout:"inline"},O.tsx("calcite-switch",{checked:this.showPrintAreaEnabled,onCalciteSwitchChange:e=>{this.showPrintAreaEnabled=!!e.target.checked}}),e.printPreview),E=O.tsx("div",null,O.tsx("div",{class:B.formSectionContainer},O.tsx("calcite-label",null,e.template,O.tsx("calcite-block",{class:B.templateSelectContainer,collapsible:!1,description:this._getPageSizeLabel(this._selectedTemplate),heading:this._getTemplateLabel(this._selectedTemplate,!0),key:"template-select-block",loading:"loading"===this._selectedTemplate?.state,onclick:()=>{this._showTemplates=!0}},O.tsx("calcite-icon",{class:B.templateSelectIcon,icon:(this._selectedTemplate?.layout?U.get(this._selectedTemplate.layout):null)||"custom-print",key:"template-select-icon",scale:"l",slot:"content-start"}),"error"===this._selectedTemplate?.state?O.tsx("calcite-icon",{class:B.templateSelectError,icon:"exclamation-mark-circle",key:"template-select-error",scale:"s",slot:"actions-end"}):null,O.tsx("calcite-icon",{class:B.templateSelectArrow,icon:C.isRTL()?"chevron-left":"chevron-right",key:"template-select-arrow",scale:"s",slot:"actions-end"})))),I),L=O.tsx("div",{class:B.formSectionContainer},O.tsx("calcite-label",null,e.dpi,O.tsx("calcite-input-number",{bind:this,"data-input-name":"dpi",min:1,value:`${n}`,onCalciteInputNumberInput:this._handleDPIChange}))),M=O.tsx("div",{class:B.formSectionContainer},O.tsx("calcite-label",null,O.tsx("div",{class:B.srLabel},e.outSpatialReference,O.tsx("calcite-link",{href:"https://developers.arcgis.com/rest/services-reference/enterprise/using-spatial-references/",target:"_blank"},"(WKID)")),O.tsx("calcite-input-number",{bind:this,"data-input-name":"outSpatialReference",integer:!0,numberButtonType:"none",value:a.outSpatialReference?.wkid?.toString()??"",onCalciteInputNumberInput:({target:e})=>{const t=p.ensureInteger(e.value);a.outSpatialReference=Number.isNaN(t)||null==t?null:new $({wkid:t}),this._isValidSpatialReference=!a.outSpatialReference||m.isValid(a.outSpatialReference)}}),this._isValidSpatialReference?null:O.tsx("div",{class:B.invalidWkidText,key:`out-sr-${a.outSpatialReference?.wkid}`},e.invalidWkid))),P=O.tsx("div",{class:this.classes(B.scaleInfoContainer,B.formSectionContainer)},O.tsx("calcite-label",{layout:"inline"},O.tsx("calcite-checkbox",{bind:this,checked:x,"data-option-name":"scaleEnabled",onCalciteCheckboxChange:this._toggleInputValue}),e.scale),O.tsx("div",{class:B.scaleInputContainer},O.tsx("calcite-input-number",{"aria-label":e.scaleLabel,"aria-valuenow":`${y}`,bind:this,class:B.scaleInput,"data-input-name":"scale",disabled:!x,value:`${y}`,onCalciteInputNumberInput:this._updateNumberInputValue}),O.tsx("calcite-button",{appearance:"outline","aria-label":e.reset,bind:this,disabled:!x,iconStart:"refresh",kind:"neutral",onclick:this._resetToCurrentScale}))),A=O.tsx("div",{"aria-labelledby":`${this.id}__advancedOptionsForLayout`,class:B.advancedOptionsContainer,key:"advanced-section-for-layout"},P,this._selectedTemplate?.layoutTemplateInfo?.layoutOptions?.hasAuthorText??1?O.tsx("div",{class:B.formSectionContainer,key:"author-info"},O.tsx("calcite-label",null,e.author,O.tsx("calcite-input",{bind:this,"data-input-name":"author",value:s??"",onCalciteInputInput:this._updateInputValue}))):null,this._selectedTemplate?.layoutTemplateInfo?.layoutOptions?.hasCopyrightText??1?O.tsx("div",{class:B.formSectionContainer,key:"copyright-text"},O.tsx("calcite-label",null,e.copyright,O.tsx("calcite-input",{bind:this,"data-input-name":"copyright",value:o??"",onCalciteInputInput:this._updateInputValue}))):null,L,M,this._renderCustomTextElementSection(),this._selectedTemplate?.layoutTemplateInfo?.layoutOptions?.hasLegend??1?O.tsx("div",{class:B.formSectionContainer,key:"legend-info"},O.tsx("calcite-label",{layout:"inline"},O.tsx("calcite-checkbox",{bind:this,checked:h,"data-option-name":"legendEnabled",onCalciteCheckboxChange:this._toggleInputValue}),e.legend)):null,this._selectedTemplate?.mapSurroundInfoOptions?.northArrow.length?O.tsx("div",{class:B.formSectionContainer,key:"north-arrow"},O.tsx("calcite-label",{layout:"inline"},O.tsx("calcite-checkbox",{bind:this,checked:b,"data-option-name":"northArrowEnabled",onCalciteCheckboxChange:this._toggleInputValue}),e.northArrow)):null,this._selectedTemplate?.mapSurroundInfoOptions?.scaleBar.length?O.tsx("div",{class:B.formSectionContainer,key:"scale-bar"},O.tsx("calcite-label",{layout:"inline"},O.tsx("calcite-checkbox",{bind:this,checked:_,"data-option-name":"scaleBarEnabled",onCalciteCheckboxChange:this._toggleInputValue}),e.scaleBar)):null),N=O.tsx("div",{"aria-labelledby":`${this.id}__advancedOptionsForMapOnly`,class:B.advancedOptionsContainer},P,L,M,O.tsx("div",{class:B.formSectionContainer},O.tsx("calcite-label",{layout:"inline"},O.tsx("calcite-checkbox",{bind:this,checked:i,"data-option-name":"attributionEnabled",onCalciteCheckboxChange:this._toggleInputValue}),e.attribution)),this._renderCustomTextElementSection()),R=this.exportedLinks.toArray(),D=this._renderExportedLink(R),V={[B.exportSectionCentered]:!R.length},H=this._selectedTab===F.layout?O.tsx("section",{"aria-labelledby":`${this.id}__layoutTab`,class:B.layoutSection,id:`${this.id}__layoutContent`,key:"esri-print__layoutContent",role:"tabpanel"},O.tsx("div",{class:B.panelContainer},this._selectedTemplate?.layoutTemplateInfo?.layoutOptions?.hasTitleText??1?w:null,E,this._selectedTab===F.layout?S:null,O.tsx("calcite-block",{"aria-label":e.advancedOptions,class:this.classes(B.panelContainer,B.advancedOptionsSection),collapsible:!0,disabled:!(d||u?.id),heading:e.advancedOptions,id:"advancedOptionsForLayout",key:"advanced-options-for-layout"},A))):this._selectedTab===F.mapOnly?O.tsx("section",{"aria-labelledby":`${this.id}__mapOnlyTab`,class:B.mapOnlySection,id:`${this.id}__mapOnlyContent`,key:"esri-print__mapOnlyContent",role:"tabpanel"},O.tsx("div",{class:B.panelContainer},w,S,O.tsx("div",null,O.tsx("div",{class:this.classes(B.sizeContainer,B.formSectionContainer)},O.tsx("calcite-label",null,e.width,O.tsx("calcite-input-number",{bind:this,"data-input-name":"width",value:`${v}`,onCalciteInputNumberInput:this._updateNumberInputValue})),O.tsx("calcite-label",null,e.height,O.tsx("calcite-input-number",{bind:this,"data-input-name":"height",value:`${c}`,onCalciteInputNumberInput:this._updateNumberInputValue})),O.tsx("button",{"aria-label":e.swap,bind:this,class:this.classes(f.globalCss.widgetButton,B.swapButton,k.legacyIcon.swap),onclick:this._switchInput,type:"button"})),I),O.tsx("calcite-block",{"aria-label":e.advancedOptions,class:this.classes(B.panelContainer,B.advancedOptionsSection),collapsible:!0,heading:e.advancedOptions,id:"advancedOptionsForMapOnly",key:"advanced-options-for-map-only"},N))):O.tsx("section",{"aria-labelledby":`${this.id}__exportTab`,class:this.classes(B.exportSection,V),id:`${this.id}__exportContent`,key:"esri-print__exportContent",role:"tabpanel"},O.tsx("div",{class:B.panelContainer},O.tsx("div",{afterUpdate:this._scrollExportIntoView,bind:this,class:B.exportedFilesContainer},0===R.length?O.tsx("div",{class:B.exportedFilesEmpty},O.tsx("calcite-icon",{icon:"file",scale:"l"}),O.tsx("div",null,O.tsx(T.Heading,{class:B.exportedFilesTitle,level:this.headingLevel},e.noExportedFiles),O.tsx("div",null,e.exportHint))):D))),z="2d"!==l?.type,W=O.tsx("div",{class:B.panelError},l?z?e.sceneViewError:e.serviceError:e.noViewError),q=R.some((({state:e})=>"pending"===e)),j=O.tsx("div",{class:B.content,key:"panel"},O.tsx("div",null,O.tsx("ul",{bind:this,class:B.layoutTabList,onclick:this._toggleLayoutPanel,onkeydown:this._handleLayoutPanelKeyDown,role:"tablist"},O.tsx("li",{afterCreate:this._focusOnTabChange,afterUpdate:this._focusOnTabChange,"aria-selected":`${this._selectedTab===F.layout}`,class:B.layoutTab,"data-tab-id":F.layout,id:`${this.id}__layoutTab`,role:"tab",tabIndex:0},e.layoutTab),O.tsx("li",{afterCreate:this._focusOnTabChange,afterUpdate:this._focusOnTabChange,"aria-selected":`${this._selectedTab===F.mapOnly}`,class:B.layoutTab,"data-tab-id":F.mapOnly,id:`${this.id}__mapOnlyTab`,role:"tab",tabIndex:0},e.mapOnlyTab),O.tsx("li",{afterCreate:this._focusOnTabChange,afterUpdate:this._focusOnTabChange,"aria-selected":`${this._selectedTab===F.export}`,class:B.layoutTab,"data-tab-id":F.export,id:`${this.id}__exportedFilesTab`,role:"tab",tabIndex:0},q?O.tsx("calcite-loader",{inline:!0,label:"loading",scale:"s"}):null,e.exportsTab)),H),this._selectedTab!==F.export?O.tsx("div",{class:this.classes(B.printButtonSection,!this.saveExportHidden&&this.portal?B.printButtonSectionDivider:null),key:"export-button-section"},!this.saveExportHidden&&this.portal?O.tsx("calcite-label",{layout:"inline"},O.tsx("calcite-checkbox",{bind:this,checked:this.saveExportEnabled,onCalciteCheckboxChange:e=>{this.saveExportEnabled=!!e.target.checked}}),e.saveExportToMyContent):null,O.tsx("calcite-button",{"aria-label":e.exportDescription,bind:this,class:this.classes(B.printButton),disabled:g||!(d||u?.id)&&!r,onclick:this._handlePrintMap,scale:"l",width:"full"},e.export)):null),K=O.tsx("calcite-flow",{key:"root-flow"},O.tsx("calcite-flow-item",{bind:this,key:"root-flow-item"},O.tsx("div",{class:B.printWidgetContainer},this.headerVisible?O.tsx("header",{class:B.headerTitle},e.export):null,this.error||z||!l?W:j)),this._renderChooseTemplateFlowItem()),J="initializing"===a.state,G=J?this._renderLoader():K,Q={[B.panelItemsCentered]:J};return O.tsx("div",{bind:this,class:this.classes(B.base,f.globalCss.widget,f.globalCss.panel,Q)},G)}_getPageSizeLabel(e){if(!e)return;const t=e.layoutTemplateInfo;if(!t)return;const a=V.fromJSON(t.pageUnits.toLowerCase());return`${I.formatNumber(t.pageSize[0])} x ${I.formatNumber(t.pageSize[1])} ${n.unitName(this.messagesUnits,a,"abbr")}`}_getTemplateLabel(e,t=!1){if(!e)return t?this.messages.selectTemplate:this.messages.untitled;const{label:a,layout:l,layoutItem:i,type:s}=e;if("print-service-template"===s)return this.messages[l];const o=a??l??i?.id;return o?.replaceAll("_"," ")??this.messages.untitled}_getPortalTemplates(){const{portalTemplateIds:e}=this.viewModel;return this.includeDefaultTemplates?this.viewModel.defaultTemplates.toArray().filter((({layout:t,layoutItem:a})=>!R(t)&&!!a?.id&&e.includes(a.id))):[]}_getDefaultTemplates(){const{portalTemplateIds:e}=this.viewModel;return this.includeDefaultTemplates?this.viewModel.defaultTemplates.toArray().filter((({layout:t,layoutItem:a})=>!(R(t)||a?.id&&e.includes(a.id)))):[]}_getPrintServiceTemplates(){return this.includeDefaultTemplates&&this._getDefaultTemplates().length?[]:this.viewModel.printServiceTemplates.toArray().filter((({layout:e})=>!R(e)))}_renderLayoutTemplates(e,t=!1,a=!1){return t&&e.sort(((e,t)=>(e.label??"")>(t.label??"")?1:-1)),e.map((e=>O.tsx("calcite-list-item",{description:this._getPageSizeLabel(e),key:`template-${e.id}-${e.id===this.templateOptions.id}`,label:this._getTemplateLabel(e),selected:e.id===this.templateOptions.id,title:e.description??"",value:e},O.tsx("calcite-icon",{icon:(e.layout?U.get(e.layout):null)||"custom-print",slot:"content-start"}),"loading"===e.state?O.tsx("calcite-loader",{inline:!0,key:`template-loader-${e.id}`,label:"loading",scale:"s",slot:"content-end"}):null,"error"===e?.state?O.tsx("calcite-icon",{class:B.templateSelectError,icon:"exclamation-mark-circle",key:`template-error-${e.id}`,scale:"s",slot:"content-end"}):null,a?O.tsx("calcite-action",{icon:"trash",onclick:()=>this.viewModel.removePortalTemplate(e),slot:"actions-end",text:"delete"}):null)))}_renderChooseTemplateFlowItem(){if(!this._showTemplates)return null;const{messages:e}=this,t=b.reArcGISOnlineDomain.test(this.portal?.url),a=this.viewModel.browseTemplates.toArray(),l=this._getPortalTemplates(),i=this._getDefaultTemplates(),s=this._getPrintServiceTemplates(),o=a.length+l.length+i.length+s.length>15,n=this.browseTemplateButtonOnClick?O.tsx("calcite-button",{appearance:"outline",class:o?B.browseTemplateButtonContainerFilter:B.browseTemplateButtonContainer,iconStart:"folder",key:"browse-template-button",onclick:this.browseTemplateButtonOnClick,slot:o?"filter-actions-end":"default"},o?null:e.browseTemplates):null;return O.tsx("calcite-flow-item",{bind:this,closable:!1,heading:e.chooseTemplate,key:"template-flow-item",onCalciteFlowItemBack:e=>{e.preventDefault(),this._showTemplates=!1}},O.tsx("div",{class:B.templateSelectFlowItemContainer},O.tsx("div",{class:B.templateSelectFlowItemContent},o?null:n,O.tsx("calcite-list",{filterEnabled:o,filterProps:["label"],key:"template-list",selectionMode:"single-persist",onCalciteListChange:({target:e})=>this.viewModel.applyTemplate(e.selectedItems[0]?.value)},o?n:null,a.length?O.tsx("div",{key:"my-templates"},O.tsx("div",{class:B.templateSelectFlowItemListHeading},e.myTemplates,O.tsx("calcite-chip",{appearance:"outline",kind:"neutral",scale:"s",value:e.beta},e.beta)),this._renderLayoutTemplates(a,!0,!0)):null,l.length?O.tsx("div",{key:"org-templates"},O.tsx("div",{class:B.templateSelectFlowItemListHeading},e.organizationTemplates,t?O.tsx("calcite-chip",{appearance:"outline",kind:"neutral",scale:"s",value:e.beta},e.beta):null),this._renderLayoutTemplates(l)):null,a.length||l.length?i.length?O.tsx("div",{key:"default-templates"},O.tsx("div",{class:B.templateSelectFlowItemListHeading},e.defaultTemplates),this._renderLayoutTemplates(i,!0)):null:this._renderLayoutTemplates(i,!0),a.length||l.length?s.length?O.tsx("div",{key:"service-templates"},O.tsx("div",{class:B.templateSelectFlowItemListHeading},e.defaultTemplates),this._renderLayoutTemplates(s)):null:this._renderLayoutTemplates(s))),O.tsx("div",{class:B.templateButtonContainer},O.tsx("calcite-button",{class:B.templateDoneButton,onclick:()=>this._showTemplates=!1},this.messagesCommon.done))))}_renderCustomTextElementSection(){const{customTextElements:e}=this.templateOptions;return e?O.tsx("div",{class:B.formSectionContainer,key:"custom-text-elements"},e.map(((e,t)=>{const[a,l]=Object.entries(e)[0];return"date"===a?null:O.tsx("calcite-label",{key:`custom-text-elements-${a}-${t}`},a,O.tsx("calcite-input",{bind:this,"data-input-custom":!0,"data-input-name":a,value:l??"",onCalciteInputInput:this._updateInputValue}))}))):null}_renderTitleOrFileNameSection(){const{title:e,fileName:t,titlePlaceHolder:a,fileNamePlaceHolder:l}=this.messages,i=this._selectedTab===F.layout?e:t,s=this._selectedTab===F.layout?a:l,o=this._selectedTab===F.layout?this.templateOptions.title:this.templateOptions.fileName;return O.tsx("div",{class:B.formSectionContainer,key:i},O.tsx("calcite-label",null,i,O.tsx("calcite-input",{placeholder:s,value:o??"",onCalciteInputInput:this._onInput})))}_focusOnTabChange(e){if(!this._activeTabFocusRequested)return;const t=e.getAttribute("data-tab-id");("layoutTab"===t&&this._selectedTab===F.layout||"mapOnlyTab"===t&&this._selectedTab===F.mapOnly||"exportTab"===t&&this._selectedTab===F.export)&&(e.focus(),this._activeTabFocusRequested=!1)}_renderLoader(){const e={[B.loader]:this._awaitingServerResponse};return O.tsx("div",{class:this.classes(e),key:"loader"})}_updateExportedFileNameMap(e){void 0!==this._exportedFileNameMap[e]?this._exportedFileNameMap[e]++:this._exportedFileNameMap[e]=0}_createFileLink(e,t){const a=t||this.messages.untitled,l=e.format.toLowerCase(),i=l.includes("png")?"png":l,s=a+i;return this._updateExportedFileNameMap(s),new v({name:a,extension:i,count:this._exportedFileNameMap[s]})}_resetToCurrentScale(){this.templateOptions.scale=this.viewModel.view?.scale}_updateCustomTextElementValue(e,t,a){e.find((e=>{const[a]=Object.entries(e)[0];return a===t}))[t]=a}_updateInputValue(e){const t=e.target,a=t.getAttribute("data-input-name"),l=!!t["data-input-custom"],{templateOptions:i}=this;l?this._updateCustomTextElementValue(i.customTextElements,a,t.value):i[a]=t.value}_updateNumberInputValue(e){const t=e.target,a=t.getAttribute("data-input-name"),{templateOptions:l}=this,i=Number(t.value);if(N(i))l[a]=i;else{const e=l[a];t.value=`${e}`}}_handleDPIChange(e){const{templateOptions:t}=this,a=t.dpi;this._updateNumberInputValue(e);const l=t.dpi,{height:i,width:s}=A(l,a,t.width,t.height);t.height=i,t.width=s}_handlePrintMap(){this._pendingExportScroll=!0;const{templateOptions:e,saveExportEnabled:t}=this,a=this.viewModel.toPrintTemplate(e),l=this._selectedTab===F.layout?a.layoutOptions?.titleText:e.fileName,i=this._createFileLink(a,l);this.exportedLinks.add(i),this.emit("submit",{link:i,saveExportEnabled:t}),this._selectedTab=F.export,this.viewModel.print(a).then((e=>{i.set({url:e&&e.url,state:"ready"})})).catch((e=>{i.set({error:e,state:"error"})})).then((()=>{this.emit("complete",{link:i,saveExportEnabled:t}),this.scheduleRender()}))}_switchInput(){[this.templateOptions.width,this.templateOptions.height]=[this.templateOptions.height,this.templateOptions.width]}_scrollExportIntoView(){if(!this._pendingExportScroll)return;this._pendingExportScroll=!1;const e=this._rootNode;if(!e)return;const{clientHeight:t,scrollHeight:a}=e,l=a-t;l>0&&(e.scrollTop=l)}_toggleInputValue(e){const t=e.target,a=t.getAttribute("data-option-name");this.templateOptions[a]=t.checked,"scaleEnabled"===a&&this._resetToCurrentScale()}_renderExportedLink(e){const t=this.messages,a=e.map((e=>{const{error:a,url:l,state:i}=e,s=e.formattedName??"",n="error"===i,c="pending"===i,p="ready"===i;let d=l||null;d&&(d=r.addProxy(d));const u=r.hasSameOrigin(l,location.href);let h;h=c?t.pending:p?t.ready:t.errorMessage;const m=n?"print-task:cim-symbol-unsupported"===a?.name?t.exportWebMapCIMError:t.exportWebMapError:"";return O.tsx("calcite-list-item",{"aria-label":h,key:s,title:m},O.tsx("div",{class:B.exportedFile,"data-item":e,onclick:this._handleLinkClick,slot:"content"},O.tsx("div",null,O.tsx("div",{class:B.exportedFileLinkTitle},s),O.tsx("div",{class:B.exportedFileLinkDescription},c?t.generatingExport:m||(u?t.ready:t.linkReady))),p?O.tsx("calcite-icon",{"aria-label":`${s}. ${t.linkReady}`,icon:u?"download-to":"launch",key:`${s}-end-icon`,scale:"s",slot:"content-end"}):null),c?O.tsx("calcite-loader",{class:B.exportedFileLoader,inline:!0,key:`${s}-loader`,label:t.generatingExport,scale:"m",slot:"content-start"}):O.tsx("calcite-icon",{icon:D(e),key:`${s}-start-icon`,scale:"s",slot:"content-start"}),c?null:this.saveAsButtonCallback&&!n&&this._isFormatAllowedForSaving(e.extension)?O.tsx("calcite-action",{"aria-label":`${m}`,icon:"ellipsis",id:`${s}-popover-button`,key:`${s}-action`,slot:"actions-end",text:`${m}`},O.tsx("calcite-popover",{autoClose:!0,key:`${s}-popover`,label:"Popover",offsetDistance:1,overlayPositioning:"fixed",pointerDisabled:!0,referenceElement:`${s}-popover-button`,scale:"s"},O.tsx("calcite-list",null,e.portalItem?O.tsx("calcite-list-item",{label:t.openItem,onCalciteListItemSelect:()=>{const t=e.portalItem;if(!t||!t.itemPageUrl)return;const a=document.createElement("a");a.target="_blank",a.href=t.itemPageUrl,a.rel="noreferrer",a.click()}},O.tsx("calcite-icon",{icon:"launch2",key:`${s}-launch-icon`,scale:"s",slot:"content-start"})):O.tsx("calcite-list-item",{label:t.saveAs,onCalciteListItemSelect:async()=>{this.saveAsButtonCallback&&(o.whenOnce((()=>e.portalItem)).then((e=>{e.itemPageUrl&&this.scheduleRender()})),await this.saveAsButtonCallback(e))}},O.tsx("calcite-icon",{icon:"save",key:`${s}-save-icon`,scale:"s",slot:"content-start"})),O.tsx("calcite-list-item",{label:this.messagesCommon.delete,onCalciteListItemSelect:()=>this.exportedLinks.remove(e)},O.tsx("calcite-icon",{icon:"trash",key:`${s}-delete-icon`,scale:"s",slot:"content-start"}))))):O.tsx("calcite-action",{"aria-label":`${m}`,icon:"x",key:`${s}-action`,onclick:()=>{this.exportedLinks.remove(e)},slot:"actions-end",text:`${m}`}))}));return O.tsx("calcite-list",{filterEnabled:e?.length>10},a)}_isFormatAllowedForSaving(e){return!this.allowedFormatsForSaving||"all"===this.allowedFormatsForSaving||!(!e||!this.allowedFormatsForSaving.includes(e))}_toggleLayoutPanel(e){const t=e.target;this._toggleTab(t.getAttribute("data-tab-id"))}_toggleTab(e,t=!0){if(this._selectedTab=e,this._selectedTab===F.mapOnly)this.templateOptions.reset(),this.templateOptions.layout=L;else if(this._selectedTab===F.layout){const e=this._selectedTemplate??this.viewModel.defaultTemplate;e?this.viewModel.applyTemplate(e):this.templateOptions.reset()}t&&(this._activeTabFocusRequested=!0)}_handleLayoutPanelKeyDown(e){const{key:t}=e,a=e.target.getAttribute("data-tab-id");if(C.isActivationKey(t))return this._toggleTab(a),e.preventDefault(),void e.stopPropagation();if("ArrowLeft"===t||"ArrowRight"===t){switch(a){case F.layout:this._toggleTab("ArrowLeft"===t?F.export:F.mapOnly);break;case F.mapOnly:this._toggleTab("ArrowLeft"===t?F.layout:F.export);break;case F.export:this._toggleTab("ArrowLeft"===t?F.mapOnly:F.layout)}e.preventDefault(),e.stopPropagation()}}};t.__decorate([c.property()],H.prototype,"_showTemplates",void 0),t.__decorate([c.property()],H.prototype,"_isValidSpatialReference",void 0),t.__decorate([c.property()],H.prototype,"allowedFormats",null),t.__decorate([c.property()],H.prototype,"allowedFormatsForSaving",void 0),t.__decorate([c.property()],H.prototype,"allowedLayouts",null),t.__decorate([c.property()],H.prototype,"browseTemplateButtonOnClick",void 0),t.__decorate([c.property()],H.prototype,"error",null),t.__decorate([c.property({type:E})],H.prototype,"exportedLinks",void 0),t.__decorate([c.property()],H.prototype,"extraParameters",null),t.__decorate([c.property()],H.prototype,"headerVisible",void 0),t.__decorate([c.property()],H.prototype,"headingLevel",void 0),t.__decorate([c.property()],H.prototype,"icon",null),t.__decorate([c.property()],H.prototype,"includeDefaultTemplates",null),t.__decorate([c.property()],H.prototype,"label",null),t.__decorate([c.property(),S.messageBundle("esri/widgets/Print/t9n/Print")],H.prototype,"messages",void 0),t.__decorate([c.property(),S.messageBundle("esri/t9n/common")],H.prototype,"messagesCommon",void 0),t.__decorate([c.property(),S.messageBundle("esri/core/t9n/Units")],H.prototype,"messagesUnits",void 0),t.__decorate([c.property({type:$})],H.prototype,"outSpatialReference",null),t.__decorate([c.property()],H.prototype,"portal",null),t.__decorate([c.property()],H.prototype,"saveExportEnabled",void 0),t.__decorate([c.property()],H.prototype,"saveExportHidden",void 0),t.__decorate([c.property()],H.prototype,"showPrintAreaEnabled",null),t.__decorate([c.property()],H.prototype,"printServiceUrl",null),t.__decorate([c.property()],H.prototype,"saveAsButtonCallback",void 0),t.__decorate([c.property()],H.prototype,"templateCustomTextElements",null),t.__decorate([c.property()],H.prototype,"templateOptions",null),t.__decorate([c.property()],H.prototype,"view",null),t.__decorate([c.property({type:g})],H.prototype,"viewModel",void 0),H=t.__decorate([h.subclass("esri.widgets.Print")],H);return H}));
