/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../geometry","../../request","../../core/arrayUtils","../../core/Collection","../../core/Error","../../core/jsonMap","../../core/lang","../../core/Loadable","../../core/promiseUtils","../../core/ReactiveMap","../../core/reactiveUtils","../../core/screenUtils","../../core/unitUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/Logger","../../core/accessorSupport/decorators/subclass","../../intl/date","../../intl/locale","../../portal/Portal","../../portal/PortalQueryParams","../../portal/support/urlUtils","../../rest/print","../../rest/support/fileFormat","../../rest/support/layoutTemplate","../../rest/support/PrintParameters","../../rest/support/PrintTemplate","../../views/2d/viewpointUtils","../../views/input/InputManager","../../views/overlay/BoxOverlayItem","./CustomTemplate","./TemplateOptions","./utils","../../geometry/Extent","../../geometry/SpatialReference"],(function(t,e,a,i,o,s,r,l,n,p,d,h,u,m,c,y,f,v,T,_,w,I,g,O,b,S,P,x,U,E,L,k,C,H,D,F){"use strict";const M=[30,144,255,255],A=[237,211,23,255],R=[216,48,32,255],W=new Set(["GISProfessionalStdUT","GISProfessionalAdvUT"]),J=/(\/GPServer\/).+/i,V=new r.JSONMap({inch:"inches",foot:"feet",yard:"yards",mile:"miles","nautical-mile":"nautical-miles",millimeter:"millimeters",centimeter:"centimeters",decimeter:"decimeters",meter:"meters",kilometer:"kilometers"}),N=o.ofType(k);function G(t){t.layoutOptions??={},t.layoutOptions.customTextElements??=[];const e="date";if(!t.layoutOptions.customTextElements.find((t=>e in t))){const{customTextElements:e}=t.layoutOptions;let a=T.formatDate(Date.now(),T.convertDateFormatToIntlOptions("short-date"));"ar"===_.getLanguage()&&(a="‏"+a),e.push({date:a})}}function q(t,e,a){if(!e)return;!(e.visible===a)&&t.layoutOptions&&(t.layoutOptions.elementOverrides?t.layoutOptions.elementOverrides[e.name]={visible:a}:t.layoutOptions.elementOverrides={[e.name]:{visible:a}})}let z=class extends n{constructor(t){super(t),this._serviceTemplateCustomTextElements=null,this._templateIdToCustomTemplate=new d,this._isFreeHand=!1,this._freeHandWidth=0,this._freehandHeight=0,this._asyncPrintTaskUrl=null,this._layoutInfoTaskUrl=null,this.allowedFormats="all",this.allowedLayouts="all",this.browseTemplates=new N,this.defaultTemplates=new N,this.error=null,this.extraParameters=null,this.includeDefaultTemplates=!0,this.outSpatialReference=null,this.portal=w.getDefault(),this.portalTemplateIds=[],this.printServiceTemplates=new N,this.defaultTemplate=null,this.showPrintAreaEnabled=!1,this.printServiceUrl=null,this.printTimeout=12e4,this.templatesInfo=null,this.updateDelay=1e3,this.view=null,this.templateCustomTextElements=null,this.templateOptions=new C}initialize(){this.addHandles([h.watch((()=>[this.showPrintAreaEnabled,this.view]),(()=>{this.showPrintAreaEnabled?this._enablePrintPreview():(this.removeHandles("overlay-handler"),this.view?.overlay?.removeItem(this._getOverlayItem()))})),h.watch((()=>[this.templateOptions.layout,this.templateOptions.layoutItem]),(()=>{this.loaded&&this._processTemplateOptions()}))])}destroy(){this.removeHandles("overlay-handler"),this.view&&(this._overlayItem&&(this.view.overlay?.removeItem(this._overlayItem),this._overlayItem.destroy(),this._overlayItem=null),this.view=null)}get effectivePrintServiceUrl(){return this.printServiceUrl??null}get effectiveTemplateCustomTextElements(){if(!this._serviceTemplateCustomTextElements)return{};const t=l.clone(this._serviceTemplateCustomTextElements);return this.templateCustomTextElements&&Object.keys(this.templateCustomTextElements).forEach((e=>{const a=t[e];if(a){const t=this.templateCustomTextElements?.[e];a.forEach((e=>{const[a]=Object.entries(e)[0];t?.forEach((t=>{const[i,o]=Object.entries(t)[0];a===i&&(e[a]=o)}))}))}})),Object.freeze(t)}get state(){return"loading"===this.loadStatus?"initializing":"failed"===this.loadStatus||this.error?"error":"loaded"===this.loadStatus&&this.view?.ready?"ready":"disabled"}async load(t){return this.addResolvingPromise(this._loadResources(t).catch((t=>this.error=t))),this}async print(t){const{view:e,extraParameters:a,updateDelay:i,outSpatialReference:o}=this;if(!e)throw new s("print:view-required","view is not set");G(t);const r=this._getOverlayItem(),l=t.scalePreserved||!this.showPrintAreaEnabled?void 0:U.getExtent(new D,e.viewpoint,"map-only"===t.layout?[t.exportOptions.width,t.exportOptions.height]:[r.boxWidth,r.boxHeight]),n=new P({view:e,template:t,extent:l,extraParameters:a,updateDelay:i,outSpatialReference:o});try{const e=!!t.layoutItem?.id&&(this.portalTemplateIds.includes(t.layoutItem.id)||this.browseTemplates.some((e=>e.layoutItem?.id===t.layoutItem?.id)));return await O.execute(e&&this._asyncPrintTaskUrl?this._asyncPrintTaskUrl:this.effectivePrintServiceUrl,n,{timeout:this.printTimeout})}catch(p){throw new s("print:export-error","An error occurred while exporting the web map.",{error:p})}}toPrintTemplate({attributionEnabled:t,author:e,copyright:a,customTextElements:i,dpi:o,forceFeatureAttributes:r,format:l,height:n,id:p,includeTables:d,layout:h,layoutItem:u,legendEnabled:m,northArrowEnabled:c,scale:y,scaleEnabled:f,title:v,width:T}){if(!h&&!u)throw new s("print:layout-required","layout is not set");const _=new x({attributionVisible:t,forceFeatureAttributes:r,format:l,includeTables:d,layout:h,layoutItem:u,layoutOptions:{authorText:e||"",copyrightText:a||"",customTextElements:i,titleText:v||""},outScale:y??0,scalePreserved:f});if(T&&(_.exportOptions.width=T),n&&(_.exportOptions.height=n),o&&(_.exportOptions.dpi=o),_.layoutOptions){m||(_.layoutOptions.legendLayers=[]);const t=this.getLayoutTemplateById(p)?.mapSurroundInfoOptions;if(t){q(_,t.northArrow[0],c);const e=t.scaleBar;for(const t of e)q(_,t,f)}}return _}getLayoutTemplateById(t){return t?this._templateIdToCustomTemplate.get(t):null}async addPortalTemplate(t){if(!this.portal||!t?.id)return;try{t.loaded||await t.load()}catch{return void this.applyTemplate(this.defaultTemplate)}const e=new k({type:"browse-template",layoutInfoTaskUrl:this._layoutInfoTaskUrl,label:t.title,layoutItem:t});this._templateIdToCustomTemplate.set(e.id,e),this.browseTemplates.add(e)}removePortalTemplate(t){t.layoutItem&&this.templateOptions.id===t.layoutItem.id&&(this.defaultTemplate?this.applyTemplate(this.defaultTemplate):this.templateOptions.reset()),this.browseTemplates.remove(t),this._templateIdToCustomTemplate.delete(t.id)}async applyTemplate(t){if(!t)return void this.templateOptions.reset();!t.layout||!this.templatesInfo||this.templatesInfo.layout.choiceList.includes(t.layout)||(this.defaultTemplate?t=this.defaultTemplate:this.templateOptions.reset());const e=t.layout?this.effectiveTemplateCustomTextElements[t.layout]:null;await this.templateOptions.applyTemplate(t,e)}async _loadResources(t){if(this.destroyed)return;await this._loadUrls(t);const[e,a]=await Promise.all([this._getLayoutToLayoutTemplateInfos(t),this._getPrintServiceTemplatesInfo(t)]);await this._loadAllTemplates(e,a,t),this._processPrintServiceTemplatesInfo(a),await this._processTemplateOptions(),this._updateOverLayItem()}async _processTemplateOptions(){const{layout:t,layoutItem:e}=this.templateOptions;if("map-only"!==t&&!this.templateOptions.id)if(e?.id){try{e.loaded||await e.load()}catch{return void this.applyTemplate(this.defaultTemplate)}let t=this._templateIdToCustomTemplate.get(e.id);t||(t=new k({label:e.title,layoutItem:e,layoutInfoTaskUrl:this._layoutInfoTaskUrl}),this._templateIdToCustomTemplate.set(t.id,t)),await this.applyTemplate(t)}else if(t){const t=this.defaultTemplates.find((t=>t.layout===this.templateOptions.layout))??this.printServiceTemplates.find((t=>t.layout===this.templateOptions.layout));await this.applyTemplate(t??this.defaultTemplate)}}async _loadPortal(t){try{await this.portal.load(t)}catch(e){throw new s("print:could-not-load-portal","Cannot load print resource information from portal",{error:e,url:this.effectivePrintServiceUrl})}}async _loadUrls(t){if(this.printServiceUrl)this._set("effectivePrintServiceUrl",this.printServiceUrl),await this._updateLayoutInfoTaskUrl(this.effectivePrintServiceUrl);else{await this._loadPortal(t);const{printTask:e,asyncPrintTask:a,layoutInfoTask:i}=this.portal?.helperServices??{};this._set("effectivePrintServiceUrl",e?.url),this._asyncPrintTaskUrl=a?.url,await this._updateLayoutInfoTaskUrl(i?.url||this.effectivePrintServiceUrl)}const e=this.effectivePrintServiceUrl?.toLowerCase().split("/");if(!e?.includes("gpserver"))throw new s("print:invalid-print-service-url","Can't fetch print templates information from provided URL",{url:this.effectivePrintServiceUrl})}async _updateLayoutInfoTaskUrl(t,e){if(!t)return;const a=(await O.getTasks(t,e)).find((t=>t.includes("Get Layout Templates Info")));a&&(this._layoutInfoTaskUrl=t.replace(J,`$1${encodeURI(a)}`))}_getPortalDefaultTemplates(t,e){return this.portal?.helperServices?.printTask?.templates?.filter((t=>"map_only"!==t.layout.toLowerCase()&&(!e||e.includes(S.fromJSON(t.layout)))))?.map((e=>{const a=k.fromJSON(e);if(a.type="default-template",a.layoutInfoTaskUrl=this._layoutInfoTaskUrl,a.layout){const e=t.get(a.layout);e&&a.setLayoutTemplateInfo(e)}return a}))??[]}async _getPortalCustomTemplates(t){if(this.printServiceUrl||!this.portal)return[];const{layoutGroupQuery:e,user:a}=this.portal,i=g.reArcGISOnlineDomain.test(this.portal.url),o=a?.userLicenseTypeId,s=o&&W.has(o);if(!e||i&&!s)return[];const r=new I({query:e,disableExtraQuery:!0}),l=await this.portal.queryGroups(r,t);if(!l.total)return[];const n=l.results[0],p=new I({num:100,query:"type:Layout",sortField:n.sortField,sortOrder:n.sortOrder??void 0}),d=(await n.queryItems(p,t)).results;if(!d.length)return[];return d.map((t=>(this.portalTemplateIds.push(t.id),new k({type:"default-template",label:t.title,layoutItem:t,layoutInfoTaskUrl:this._layoutInfoTaskUrl}))))}async _loadAllTemplates(t,e,a){let i=!1;const o=e?.layout?.choiceList;if(this.includeDefaultTemplates&&this.portal&&!this.printServiceUrl){const e=this._getPortalDefaultTemplates(t,o);i=!!e.length,this.defaultTemplates.addMany(e);const s=await this._getPortalCustomTemplates(a);this.defaultTemplates.addMany(s);for(const t of this.defaultTemplates)this._templateIdToCustomTemplate.set(t.id,t)}i||t.forEach(((t,e)=>{if(!o||o.includes(e)){const a=new k({type:"print-service-template",layout:e,layoutInfoTaskUrl:this._layoutInfoTaskUrl});a.setLayoutTemplateInfo(t),this.printServiceTemplates.add(a),this._templateIdToCustomTemplate.set(a.id,a)}}))}_processPrintServiceTemplatesInfo(t){this._set("templatesInfo",t);const e=t?.layout?.defaultValue;if(e&&"map-only"!==e){const t=this.defaultTemplates.find((t=>t.layout===e))??this.printServiceTemplates.find((t=>t.layout===e))??this.defaultTemplates.at(0)??this.printServiceTemplates.at(0);this._set("defaultTemplate",t)}}async _getLayoutToLayoutTemplateInfos(t){const e=await H.fetchLayoutTemplateInfos(this._layoutInfoTaskUrl,void 0,t),a=new Map,i={};for(const o of e){const t=S.fromJSON(o.layoutTemplate);a.set(t,o),i[t]=o.layoutOptions.customTextElements}return this._serviceTemplateCustomTextElements=Object.freeze(i),a}async _getPrintServiceTemplatesInfo(t){let e;try{({data:e}=await a(this.effectivePrintServiceUrl,{...t,query:{f:"json"},timeout:this.printTimeout}))}catch(l){throw p.isAbortError(l)?l:new s("print:unavailable-service-info","Can't fetch templates info from service",{error:l})}const{parameters:i}=e,o=i.find((({name:t})=>"Format"===t)),r=i.find((({name:t})=>"Layout_Template"===t));return{format:this._getFormat(o),layout:this._getLayout(r)}}_getFormat(t){const e="all"===this.allowedFormats?t.choiceList:t.choiceList.filter((t=>"string"!=typeof this.allowedFormats&&this.allowedFormats.some((e=>new RegExp(`\\b${e}\\b`,"i").test(t))))),a=(e.length?e:t.choiceList).map((t=>b.formatJsonMap.fromJSON(t))).filter(i.isSome),o=b.formatJsonMap.fromJSON(t.defaultValue),s=a.some((t=>new RegExp(`\\b${o}\\b`,"i").test(t)))?o:a[0];return{choiceList:a,defaultValue:s}}_getLayout(t){const e=t.choiceList.filter((t=>"map_only"!==t.toLowerCase())),a="all"===this.allowedLayouts?e:e.filter((t=>this.allowedLayouts.includes(S.fromJSON(t)))),o=(a.length?a:e).map(S.fromJSON).filter(i.isSome),s=S.fromJSON(t.defaultValue),r=o.includes(s)?s:o.find((t=>/(?=.*letter)(?=.*landscape)/i.test(t)))??o.find((t=>/(?=.*a4)(?=.*landscape)/i.test(t)))??o[0];return{choiceList:o,defaultValue:r}}_getOverlayItem(){return this._overlayItem||(this._overlayItem=new L({strokeDash:[5],strokeWidth:2,strokeColor:[30,144,255,255]})),this._overlayItem}_enablePrintPreview(){if(!this.view?.overlay)return;const t=this.templateOptions,e=this._getOverlayItem();this.addHandles([h.watch((()=>[t.width,t.height,t.scaleEnabled,t.scale,t.layout,t.layoutItem,t.id,t.state,this.view?.scale,this.view?.size,this.view?.state.paddedViewState.size,this.view?.state.padding,this.loaded]),(()=>this._updateOverLayItem()),h.initial),this.view?.on("drag",["Shift"],(t=>this._handleDrag(t)),E.ViewEventPriorities.WIDGET),this.view?.on("key-down",["Escape"],(()=>this._resetDrag()),E.ViewEventPriorities.WIDGET)],"overlay-handler"),this.view.overlay.addItem(e)}_updateOverLayItem(){if(!this.view)return;const t=this.templateOptions,e=this._getOverlayItem(),a=t.layoutItem?.id??t.layout,i=this.view,o=i.spatialReference,[s,r]=i.state.paddedViewState.size,l=i.state.padding;let n=0,p=0;if("map-only"===a)null!=t.width&&null!=t.height&&(n=t.width,p=t.height);else if(a){const e=t.id?this._templateIdToCustomTemplate.get(t.id):null,{webMapFrameSize:a,pageUnits:i}=e?.layoutTemplateInfo??{};let l=!1;if(a&&i)if(this._isFreeHand){const t=a[0]/a[1];n=this._freeHandWidth,p=this._freehandHeight,n>p?p=n/t:n=p*t}else{const t=V.fromJSON(i.toLowerCase()),e=o.unit;m.unitType(t)===m.unitType(e)?(n=m.convertUnit(a[0],t,e),p=m.convertUnit(a[1],t,e)):(l=!0,n=a[0],p=a[1])}if(!this._isFreeHand)if(t.scaleEnabled&&t.scale){const e=l?Math.min(s/n,r/p):m.getMetersPerUnitForSR(o)*m.inchesPerMeter*t.dpi;n*=e,p*=e}else if(0===n||0===p)n=s,p=r;else{const t=(s-.1*s)/n,e=(r-.1*r)/p,a=Math.min(t,e);n*=a,p*=a}}const{scaleEnabled:d,scale:h}=t,u=d&&h?h/this.view.scale:1;if(e.boxWidth=n*u||s,e.boxHeight=p*u||r,l&&(e.padding=l),e.backgroundWidth=s??0,e.backgroundHeight=r??0,"loading"===this.loadStatus)e.strokeColor=A;else if("loaded"===this.loadStatus)switch(this.templateOptions.state){case"pending":e.strokeColor=A;break;case"ready":e.strokeColor=M;break;case"error":e.strokeColor=R}}_resetDrag(){this._isFreeHand=!1,this._updateOverLayItem()}_handleDrag(t){switch(t.action){case"start":this._start();break;case"update":this._update(t);break;case"end":this._end()}t.stopPropagation()}_start(){this._isFreeHand=!0}_update(t){const e=this._getOverlayItem(),{x:a,y:i}=t,{x:o,y:s}=t.origin;a>o?(e.x=o,e.boxWidth=a-o):(e.x=a,e.boxWidth=o-a),i>s?(e.y=s,e.boxHeight=i-s):(e.y=i,e.boxHeight=s-i)}_end(){const t=this._getOverlayItem();if(!this.view||null==t.x||null==t.y)return;const e=this.view,a=e.toMap(u.createScreenPoint(t.x+.5*t.boxWidth,t.y+.5*t.boxHeight));t.x=null,t.y=null,e.goTo({center:a}),this._freeHandWidth=t.boxWidth,this._freehandHeight=t.boxHeight,"map-only"===this.templateOptions.layout&&(this.templateOptions.width=this._freeHandWidth,this.templateOptions.height=this._freehandHeight),this.templateOptions.scale=this.view.scale,this._updateOverLayItem()}};t.__decorate([c.property()],z.prototype,"_serviceTemplateCustomTextElements",void 0),t.__decorate([c.property()],z.prototype,"_templateIdToCustomTemplate",void 0),t.__decorate([c.property()],z.prototype,"allowedFormats",void 0),t.__decorate([c.property()],z.prototype,"allowedLayouts",void 0),t.__decorate([c.property({type:N})],z.prototype,"browseTemplates",void 0),t.__decorate([c.property({type:N})],z.prototype,"defaultTemplates",void 0),t.__decorate([c.property()],z.prototype,"error",void 0),t.__decorate([c.property()],z.prototype,"extraParameters",void 0),t.__decorate([c.property()],z.prototype,"includeDefaultTemplates",void 0),t.__decorate([c.property({readOnly:!0})],z.prototype,"effectivePrintServiceUrl",null),t.__decorate([c.property()],z.prototype,"effectiveTemplateCustomTextElements",null),t.__decorate([c.property({type:F})],z.prototype,"outSpatialReference",void 0),t.__decorate([c.property({type:w})],z.prototype,"portal",void 0),t.__decorate([c.property()],z.prototype,"portalTemplateIds",void 0),t.__decorate([c.property({type:N})],z.prototype,"printServiceTemplates",void 0),t.__decorate([c.property({readOnly:!0})],z.prototype,"defaultTemplate",void 0),t.__decorate([c.property()],z.prototype,"showPrintAreaEnabled",void 0),t.__decorate([c.property()],z.prototype,"printServiceUrl",void 0),t.__decorate([c.property()],z.prototype,"printTimeout",void 0),t.__decorate([c.property({readOnly:!0})],z.prototype,"state",null),t.__decorate([c.property({readOnly:!0})],z.prototype,"templatesInfo",void 0),t.__decorate([c.property()],z.prototype,"updateDelay",void 0),t.__decorate([c.property()],z.prototype,"view",void 0),t.__decorate([c.property()],z.prototype,"templateCustomTextElements",void 0),t.__decorate([c.property({type:C})],z.prototype,"templateOptions",void 0),z=t.__decorate([v.subclass("esri.widgets.Print.PrintViewModel")],z);return z}));
