/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../intl","../core/events","../core/maybe","../core/reactiveUtils","../core/accessorSupport/decorators/property","../core/accessorSupport/decorators/cast","../core/RandomLCG","../core/has","../core/accessorSupport/decorators/subclass","./Slider","./Widget","./ScaleRangeSlider/css","./ScaleRangeSlider/scalePreviewUtils","./ScaleRangeSlider/ScaleRanges","./ScaleRangeSlider/ScaleRangeSliderViewModel","../chunks/componentsUtils","./support/globalCss","./support/widgetUtils","./support/decorators/messageBundle","./support/jsxFactory","../intl/number","../intl/substitute"],(function(e,t,i,a,s,l,r,n,c,o,d,u,m,p,h,v,S,_,b,M,g,w,y,x){"use strict";const f={preview:!0,scaleMenus:{maxScaleMenu:!0,minScaleMenu:!0}},I={maximumFractionDigits:0},C="1:",L=16;let T=class extends m{constructor(e,t){super(e,t),this._activeMenu=null,this._activeThumb=null,this._customInput=null,this._maxThumbNode=null,this._minThumbNode=null,this._previewAutoCloseTimeoutId=void 0,this._previewPopover=null,this._slider=new u({thumbCreatedFunction:(e,t,i)=>{0===e?this._minThumbNode=i:1===e&&(this._maxThumbNode=i),this.addHandles([a.on(i,"mouseenter",(()=>{this._activeThumb=e,this.scheduleRender()})),a.on(i,"mouseleave",(()=>{this._previewAutoCloseTimeoutId||(this._activeThumb=null,this.scheduleRender())}))])}}),this.disabled=!1,this.messages=null,this.region="US",this.viewModel=new S,this.visibleElements=f,this._afterInputNumberCreate=e=>{"value"in e&&null!=e.value&&"setNumberValue"in e&&e.setNumberValue({committing:!1,value:e.value,origin:"direct"}),this._customInput=e},this._handleCustomScaleInputChange=(e,t)=>{const{viewModel:{scaleRanges:i}}=this,a=Number.parseFloat(t.value);Number.isNaN(a)?t.value=e:this._setScale(i.clampScale(a))}}loadDependencies(){return _.loadCalciteComponents({button:()=>new Promise(((t,i)=>e(["../chunks/calcite-button"],t,i))),dropdown:()=>new Promise(((t,i)=>e(["../chunks/calcite-dropdown"],t,i))),"dropdown-group":()=>new Promise(((t,i)=>e(["../chunks/calcite-dropdown-group"],t,i))),"dropdown-item":()=>new Promise(((t,i)=>e(["../chunks/calcite-dropdown-item"],t,i))),icon:()=>new Promise(((t,i)=>e(["../chunks/calcite-icon"],t,i))),"input-number":()=>new Promise(((t,i)=>e(["../chunks/calcite-input-number"],t,i))),label:()=>new Promise(((t,i)=>e(["../chunks/calcite-label"],t,i))),popover:()=>new Promise(((t,i)=>e(["../chunks/calcite-popover"],t,i)))})}initialize(){this.addHandles([l.watch((()=>this.viewModel),(e=>this._slider.viewModel=e?.sliderViewModel??null),l.initial),l.watch((()=>this._interactive),(e=>{this._slider.disabled=!e,e||this._setActiveMenu(null)}),l.initial),this._slider.on("thumb-drag",(({index:e})=>{this._activeThumb=e,clearTimeout(this._previewAutoCloseTimeoutId);const t=250;this._previewAutoCloseTimeoutId=setTimeout((()=>{this._previewAutoCloseTimeoutId=void 0,this._activeThumb=null}),t)})),l.when((()=>!0===this.view?.stationary),(()=>this.scheduleRender()))])}destroy(){this._slider=s.destroyMaybe(this._slider)}get _maxScaleMenuEnabled(){const{scaleMenus:e}=this.visibleElements;return!0===e||"boolean"!=typeof e&&e.maxScaleMenu}get _minScaleMenuEnabled(){const{scaleMenus:e}=this.visibleElements;return!0===e||"boolean"!=typeof e&&e.minScaleMenu}get _interactive(){return"disabled"!==this.viewModel?.state&&!this.disabled}get effectiveMaxScale(){return this.viewModel.effectiveMaxScale}get effectiveMinScale(){return this.viewModel.effectiveMinScale}get effectiveMaxScaleLimit(){return this.viewModel.effectiveMaxScaleLimit}get effectiveMinScaleLimit(){return this.viewModel.effectiveMinScaleLimit}get icon(){return"actual-size"}set icon(e){this._overrideIfSome("icon",e)}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}get layer(){return this.viewModel.layer}set layer(e){this.viewModel.layer=e}get maxScale(){return this.viewModel.maxScale}set maxScale(e){this.viewModel.maxScale=e}get maxScaleLimit(){return this.viewModel.maxScaleLimit}set maxScaleLimit(e){this.viewModel.maxScaleLimit=e}get mode(){return this.viewModel.mode}set mode(e){this.viewModel.mode=e}get minScale(){return this.viewModel.minScale}set minScale(e){this.viewModel.minScale=e}get minScaleLimit(){return this.viewModel.minScaleLimit}set minScaleLimit(e){this.viewModel.minScaleLimit=e}get view(){return this.viewModel.view}set view(e){this.viewModel.view=e}castVisibleElements(e){return{...f,...e,scaleMenus:"boolean"==typeof e?.scaleMenus?e.scaleMenus:{...f.scaleMenus,...e?.scaleMenus}}}formatScale(e){return`${C}${y.formatNumber(e,I)}`}render(){const{_interactive:e,_slider:t,label:i,view:a,viewModel:{state:s}}=this,l=this._getLabel("min"),r=this._getLabel("max"),{segmentElements:n}=t,c=n.at("min-scale-only"===this.mode?-1:-2);return c&&c.classList.add(p.css.segmentElementActive),w.tsx("div",{"aria-label":i,class:this.classes(p.css.base,b.globalCss.widget,e?null:b.globalCss.disabled)},w.tsx("div",{class:p.css.scaleIndicatorWrapper,dir:"ltr"},"ready"===s&&a?this._renderCurrentScaleIndicator():null,t.render(),this._renderPreviewPopover()),w.tsx("div",{class:p.css.scaleMenuContainer},this._minScaleMenuEnabled&&l?this._renderScaleMenuToggle("min",l):null,w.tsx("div",{class:p.css.scaleMenuSeparator}),this._maxScaleMenuEnabled&&r?this._renderScaleMenuToggle("max",r):null))}_renderPreviewPopover(){const{_activeThumb:e}=this,t=null!=e&&this.visibleElements.preview,i=t?0===e?this._minThumbNode:this._maxThumbNode:"";return w.tsx("calcite-popover",{afterCreate:M.storeNode,afterUpdate:()=>this._previewPopover?.reposition(),bind:this,"data-node-ref":"_previewPopover",label:this.messages.preview,offsetDistance:L,open:t,overlayPositioning:"fixed",placement:"top",referenceElement:i,triggerDisabled:!0},this._renderScalePreview())}_renderScalePreview(){const{_activeThumb:e,_slider:t,region:i,viewModel:{scaleRanges:a}}=this,s=0===e||"range"!==this.mode?t.values[0]:t.values[1],l=Object.keys(v.RecommendedScales).indexOf(a.findScaleRangeByIndex(s).id),r={backgroundImage:h.getScalePreviewSource(i),backgroundPosition:h.getScalePreviewSpriteBackgroundPosition(l)};return w.tsx("div",{class:p.css.scalePreview},w.tsx("div",{class:p.css.scalePreviewThumbnail,styles:r}))}_getLabel(e){const{_slider:t,messages:i,mode:a,viewModel:{scaleRanges:s}}=this,[l,r]=t.values,n="min"===e||"range"!==a?l:r,c=i.scaleRangeLabels[s.findScaleRangeByIndex(n).id];switch(a){case"range":return c;case"max-scale-only":return"min"===e?null:c;case"min-scale-only":return"min"===e?c:null}}_renderScaleMenuToggle(e,t){const{_activeMenu:i,_interactive:a}=this,s=i===e;return[w.tsx("calcite-dropdown",{closeOnSelectDisabled:!0,"data-type":e,open:s,overlayPositioning:"fixed",placement:"max"===e?"bottom-end":"bottom-start",scale:"s",onCalciteDropdownClose:({target:t})=>{this._activeMenu===e&&this._setActiveMenu(null),M.setFocus(t.querySelector("calcite-button"))},onCalciteDropdownOpen:()=>this._setActiveMenu(e)},w.tsx("calcite-button",{appearance:s?"outline":"transparent","aria-pressed":s.toString(),class:p.css.scaleMenuToggle,disabled:!a,iconEnd:"chevron-down",scale:"s",slot:"trigger"},t),s&&"max"===e?this._renderMaxScaleMenu():null,s&&"min"===e?this._renderMinScaleMenu():null)]}_renderMinScaleMenu(){const{effectiveMaxScale:e,effectiveMinScaleLimit:t,view:i,viewModel:{scaleRanges:a}}=this,s=i?i.scale:void 0;return this._renderScaleMenu({type:"min",min:t,max:a.findScaleRange(e).minScale,viewScale:s})}_renderMaxScaleMenu(){const{effectiveMinScale:e,effectiveMaxScaleLimit:t,view:i,viewModel:{scaleRanges:a}}=this,s=i?i.scale:void 0;return this._renderScaleMenu({type:"max",min:a.findScaleRange(e).maxScale,max:t,viewScale:s})}_renderScaleMenu({viewScale:e,min:t,max:i,type:a}){const{effectiveMaxScale:s,effectiveMinScale:l,messages:r}=this,n="max"===a?s:l,c=v.fromScaleRange({minScale:t,maxScale:i}),o=this.messages.featuredScaleLabels,d=v.RecommendedScales,u=Object.keys(d).filter((e=>c.contains(d[e]))).map((e=>this._renderScaleMenuItem({scaleLabel:o[e],scaleValue:d[e],isSelected:n===d[e],valueVisible:"world"!==e})));return w.tsx("calcite-dropdown-group",{key:`${this.id}__scale-menu--${a}`},this._renderCustomScaleValue({currentScale:n}),null!=e?this._renderScaleMenuItem({scaleValue:e,scaleLabel:r.featuredScaleLabels.current,isSelected:n===e,valueVisible:!0}):null,u)}_renderCustomScaleValue({currentScale:e}){const{messages:t}=this,i=Math.round(e).toString();return w.tsx("calcite-dropdown-item",{afterCreate:e=>{M.setFocus(e)},key:"custom-scale",label:t.featuredScaleLabels.custom,onCalciteDropdownItemSelect:()=>{M.setFocus(this._customInput)}},w.tsx("calcite-label",{scale:"s"},w.tsx("span",null,t.featuredScaleLabels.custom),w.tsx("calcite-input-number",{afterCreate:this._afterInputNumberCreate,groupSeparator:!0,inputMode:"numeric",max:v.RecommendedScales.world,min:0,numberButtonType:"none",placeholder:t.customScaleInputTooltip,prefixText:C,scale:"s",step:1,value:i,onCalciteInputNumberChange:({target:e})=>this._handleCustomScaleInputChange(i,e)})))}_renderScaleMenuItem(e){const{scaleValue:t,scaleLabel:i,valueVisible:a,isSelected:s}=e;return w.tsx("calcite-dropdown-item",{key:i,label:i,selected:s,onCalciteDropdownItemSelect:this._setScale.bind(this,t)},i,a?w.tsx("div",{class:p.css.scaleMenuSubLabel},this.formatScale(t)):void 0)}_renderCurrentScaleIndicator(){const{_slider:e,messages:t,view:i,viewModel:{scaleRanges:a}}=this,s=a.clampScale(i.scale),l=this.viewModel.mapScaleToSlider(s),r=l/e.max,n=t.scaleRangeLabels[a.findScaleRangeByIndex(l).id],c=x.substitute(t.currentScaleTooltip,{scaleLabel:n});return w.tsx("div",{class:p.css.scaleIndicatorContainer,key:"scale-indicator"},w.tsx("div",{"aria-label":c,class:p.css.scaleIndicator,styles:{left:100*r+"%"},title:c},this.renderCurrentScaleIndicatorIcon()))}renderCurrentScaleIndicatorIcon(){return w.tsx("calcite-icon",{class:p.css.scaleIndicatorIcon,icon:"caret-up",scale:"s"})}_setScale(e){"max"===this._activeMenu?this.maxScale=Math.min(e,this.effectiveMinScale-1):this.minScale=Math.max(e,this.effectiveMaxScale+1),this._setActiveMenu(null)}_setActiveMenu(e){this._activeMenu=e}};t.__decorate([r.property()],T.prototype,"_activeMenu",void 0),t.__decorate([r.property()],T.prototype,"_activeThumb",void 0),t.__decorate([r.property()],T.prototype,"_customInput",void 0),t.__decorate([r.property()],T.prototype,"_maxScaleMenuEnabled",null),t.__decorate([r.property()],T.prototype,"_minScaleMenuEnabled",null),t.__decorate([r.property()],T.prototype,"_slider",void 0),t.__decorate([r.property({readOnly:!0})],T.prototype,"_interactive",null),t.__decorate([r.property()],T.prototype,"disabled",void 0),t.__decorate([r.property()],T.prototype,"effectiveMaxScale",null),t.__decorate([r.property()],T.prototype,"effectiveMinScale",null),t.__decorate([r.property()],T.prototype,"effectiveMaxScaleLimit",null),t.__decorate([r.property()],T.prototype,"effectiveMinScaleLimit",null),t.__decorate([r.property()],T.prototype,"icon",null),t.__decorate([r.property()],T.prototype,"label",null),t.__decorate([r.property()],T.prototype,"layer",null),t.__decorate([r.property()],T.prototype,"maxScale",null),t.__decorate([r.property()],T.prototype,"maxScaleLimit",null),t.__decorate([r.property(),g.messageBundle("esri/widgets/ScaleRangeSlider/t9n/ScaleRangeSlider")],T.prototype,"messages",void 0),t.__decorate([r.property()],T.prototype,"mode",null),t.__decorate([r.property()],T.prototype,"minScale",null),t.__decorate([r.property()],T.prototype,"minScaleLimit",null),t.__decorate([r.property()],T.prototype,"region",void 0),t.__decorate([r.property()],T.prototype,"view",null),t.__decorate([r.property()],T.prototype,"viewModel",void 0),t.__decorate([r.property()],T.prototype,"visibleElements",void 0),t.__decorate([n.cast("visibleElements")],T.prototype,"castVisibleElements",null),T=t.__decorate([d.subclass("esri.widgets.ScaleRangeSlider")],T);return T}));
