/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../core/Accessor","../../core/reactiveUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/Logger","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","./ScaleRanges","../Slider/SliderViewModel"],(function(e,a,i,t,l,s,r,n,c,o){"use strict";let d=class extends a{constructor(e){super(e),this.layer=null,this.mode="range",this.scaleRanges=c.fromScaleRange({minScale:0,maxScale:0}),this.sliderViewModel=(()=>{const{max:e}=this._getSliderIndexRange(this.scaleRanges.length-1);return new o({precision:10,min:0,max:e,values:[0,e]})})()}initialize(){this.addHandles([i.watch((()=>this.layer),(e=>e?.load().catch((()=>{})))),i.watch((()=>this.mode),(e=>{"range"===e&&1===this.sliderViewModel.values?.length?this.sliderViewModel.values=[this.sliderViewModel.min,this.sliderViewModel.values[0]]:2===this.sliderViewModel.values?.length&&("min-scale-only"===e?this.sliderViewModel.values=[this.sliderViewModel.values[0]]:"max-scale-only"===e&&(this.sliderViewModel.values=[this.sliderViewModel.values[1]]))})),i.watch((()=>({loaded:this.layer?.loaded,ready:this.view?.ready})),(({loaded:e,ready:a})=>{if(!e||!a)return;if(this._hasTiledLayer()){const e=this._getLayerResampling()?void 0:this.mapScaleToSlider(this._getTiledLayerMaxScale()),a=this.mapScaleToSlider(this._getTiledLayerMinScale());this.sliderViewModel.effectiveMax=e,this.sliderViewModel.effectiveMin=a}else{const e=this.layer&&"maxScaleRange"in this.layer?this.layer.maxScaleRange:null,{minScale:a=0,maxScale:i=0}=e??{};this.sliderViewModel.effectiveMax=0===i?void 0:this.mapScaleToSlider(i),this.sliderViewModel.effectiveMin=0===a?void 0:this.mapScaleToSlider(a)}const i=this.layer;i&&"minScale"in i&&"maxScale"in i?(this.minScale=i.minScale,this.maxScale=i.maxScale):(this.minScale=void 0,this.maxScale=void 0)}),i.initial)])}get effectiveMaxScale(){return 0===this.maxScale?this.maxScaleLimit:this.maxScale}get effectiveMinScale(){return 0===this.minScale?this.minScaleLimit:this.minScale}get effectiveMaxScaleLimit(){return this.mapSliderToScale(this.sliderViewModel.effectiveMax??this.sliderViewModel.max)}get effectiveMinScaleLimit(){return this.mapSliderToScale(this.sliderViewModel.effectiveMin??this.sliderViewModel.min)}get maxScale(){return this._getScale("max")}set maxScale(e){this._setMaxScaleOnSlider(e)}get maxScaleLimit(){return this.mapSliderToScale(this.sliderViewModel.max)}set maxScaleLimit(e){this._setSliderRange({maxScale:e,minScale:this.minScaleLimit})}get minScale(){return this._getScale("min")}set minScale(e){this._setMinScaleOnSlider(e)}get minScaleLimit(){return this.mapSliderToScale(this.sliderViewModel.min)}set minScaleLimit(e){this._setSliderRange({maxScale:this.maxScaleLimit,minScale:e})}get state(){const{view:e,layer:a}=this;return!e&&!a||!e&&a?.loaded||!a&&e?.ready||e&&e.ready&&a?.loaded?"ready":"disabled"}set view(e){this._set("view",e)}mapScaleToSlider(e){const a=this.scaleRanges.scaleToRangeIndex(e),i=this.scaleRanges.findScaleRangeByIndex(a),{maxScale:t,minScale:l}=i,{max:s,min:r}=this._getSliderIndexRange(a);return this._mapToRange(e,l,t,r,s)}mapSliderToScale(e){const a=this.scaleRanges.findScaleRangeByIndex(e),{maxScale:i,minScale:t}=a,{max:l,min:s}=this._getSliderIndexRange(e);return this._mapToRange(e,s,l,t,i)}_setSliderRange(e){this.scaleRanges=c.fromScaleRange(e);const{max:a}=this._getSliderIndexRange(this.scaleRanges.length-1);this.sliderViewModel.max=a,this.sliderViewModel.min=0,this.notifyChange("maxScaleLimit"),this.notifyChange("minScaleLimit")}_getSliderIndexRange(e){const a=Math.floor(e);return{min:a,max:a+.99999}}_mapToRange(e,a,i,t,l){return t+(e-a)*(l-t)/(i-a)}_getSliderValue(e){const{min:a,max:i,values:t}=this.sliderViewModel,[l,s]=t;switch(this.mode){case"max-scale-only":return"min"===e?a:l;case"min-scale-only":return"min"===e?l:i;default:return"min"===e?l??a:s??i}}_getScale(e){const a=this.mapSliderToScale(this._getSliderValue(e));return this._normalizeScale(e,a)}_setMaxScaleOnSlider(e){const{scaleRanges:a,sliderViewModel:i}=this;if(void 0!==e){const t=this.mapScaleToSlider(this._constrainMaxScaleToLayer(a.clampMaxScale(e)));switch(this.mode){case"range":i.values=[i.values[0],t];break;case"max-scale-only":i.values=[t]}}}_setMinScaleOnSlider(e){const{scaleRanges:a,sliderViewModel:i}=this;if(void 0!==e){const t=this.mapScaleToSlider(this._constrainMinScaleToLayer(a.clampMinScale(e)));switch(this.mode){case"range":i.values=[t,i.values[1]];break;case"min-scale-only":i.values=[t]}}}_constrainMinScaleToLayer(e){const{scaleRanges:a}=this;if(this._hasTiledLayer()){const{firstRange:i}=a,t=this._getTiledLayerMinScale(),l=.85;e=this._mapToRange(e,i.maxScale,i.minScale,0,1)>l||e>t?t:e}return e}_constrainMaxScaleToLayer(e){if(this._hasTiledLayer()&&!this._getLayerResampling()){const a=this._getTiledLayerMaxScale();e=e<a?a:e}return e}_normalizeScale(e,a){const i="max"===e?"maxScale":"minScale",t=this._hasTiledLayer()?"min"===e?this._getTiledLayerMinScale():this._getTiledLayerMaxScale():this.scaleRanges[i],l=this._hasTiledLayer()?"min"===e?this._getTiledLayerRealMinScale():this._getTiledLayerRealMaxScale():t,s=1e-6,r=0===a||l===a||Math.abs(l-a)<=s;return Number((r?0:a).toFixed(6))}_getLayerLODS(){if(!this.layer?.loaded||!("tileInfo"in this.layer))return null;return"imagery-tile"===this.layer?.type&&"Raster"===this.layer.raster?.tileType?null:this.layer.tileInfo?.lods}_getLayerResampling(){return!!this.layer?.loaded&&(!("resampling"in this.layer)||this.layer.resampling)}_getTiledLayerMinScale(){const e=this._getLayerLODS();return this.scaleRanges.clampMinScale(e[0].scale)}_getTiledLayerMaxScale(){const e=this._getLayerLODS();return e[e.length-1].scale}_getTiledLayerRealMinScale(){const e=this._getLayerLODS(),a=this.layer,i=a&&"sourceJSON"in a?a.sourceJSON?.tileInfo?.lods??e:e;return this.scaleRanges.clampMinScale(i[0].scale)}_getTiledLayerRealMaxScale(){const e=this._getLayerLODS(),a=this.layer,i=a&&"sourceJSON"in a?a.sourceJSON?.tileInfo?.lods??e:e;return i[i.length-1].scale}_hasTiledLayer(){return!!this._getLayerLODS()}};e.__decorate([t.property({readOnly:!0})],d.prototype,"effectiveMaxScale",null),e.__decorate([t.property({readOnly:!0})],d.prototype,"effectiveMinScale",null),e.__decorate([t.property()],d.prototype,"effectiveMaxScaleLimit",null),e.__decorate([t.property()],d.prototype,"effectiveMinScaleLimit",null),e.__decorate([t.property()],d.prototype,"layer",void 0),e.__decorate([t.property()],d.prototype,"maxScale",null),e.__decorate([t.property()],d.prototype,"maxScaleLimit",null),e.__decorate([t.property()],d.prototype,"mode",void 0),e.__decorate([t.property()],d.prototype,"minScale",null),e.__decorate([t.property()],d.prototype,"minScaleLimit",null),e.__decorate([t.property()],d.prototype,"scaleRanges",void 0),e.__decorate([t.property()],d.prototype,"sliderViewModel",void 0),e.__decorate([t.property({readOnly:!0})],d.prototype,"state",null),e.__decorate([t.property()],d.prototype,"view",null),d=e.__decorate([n.subclass("esri.widgets.ScaleRangeSlider.ScaleRangeSliderViewModel")],d);return d}));
