/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../intl","../core/maybe","../core/promiseUtils","../core/reactiveUtils","../core/scheduling","../core/string","../core/accessorSupport/decorators/property","../core/has","../core/Logger","../core/RandomLCG","../core/accessorSupport/decorators/subclass","./Widget","./Search/css","./Search/SearchResultRenderer","./Search/SearchViewModel","./support/globalCss","./support/legacyIcon","./support/widgetUtils","./support/decorators/messageBundle","./support/decorators/vmEvent","./support/jsxFactory","../intl/substitute"],(function(e,t,s,r,o,n,i,a,l,u,c,d,h,g,p,_,v,m,M,y,b,w,S){"use strict";const I=/<[a-z/][\s\S]*>/i,x=(e,t)=>{const s=i.escapeRegExpString(t).split(/\s/),r=new RegExp(`(${s.join("|")})`,"gi");return e.replace(r,(e=>`<strong>${e}</strong>`))};let C=class extends h{constructor(e,t){super(e,t),this._activeMenuItemIndex=-1,this._inputNode=null,this._focusAbortController=null,this._menuItemCount=0,this._sourceMenuButtonNode=null,this._sourceListNode=null,this._suggestionListNode=null,this._searchResultRenderer=new p,this._suggestController=null,this._searchController=null,this._locateFailed=!1,this._container=null,this.activeMenu="none",this.disabled=!1,this.messages=null,this.messagesCommon=null,this.viewModel=new _,this._clearActiveMenu=()=>{this.activeMenu="none"},this._removeActiveMenu=e=>{const t=e.relatedTarget;t&&this._container?.contains(t)||this._clearActiveMenu()},this._renderSearchResultsContent=()=>this._searchResultRenderer,this.addHandles([o.watch((()=>this.searchTerm),(e=>{(e&&"warning"===this.activeMenu||!e&&!this.viewModel?.selectedSuggestion?.location)&&this._clearActiveMenu()})),o.on((()=>this.viewModel?.allSources),"change",(()=>this._watchSourceChanges())),o.watch((()=>this.activeMenu),(()=>this._resetActiveMenuItemIndex()),o.initial),o.watch((()=>this.viewModel),(e=>this._searchResultRenderer.viewModel=e),o.initial),o.watch((()=>this.viewModel.results),(()=>this._searchResultRenderer.showMoreResultsOpen=!1)),o.watch((()=>this.viewModel?.defaultPopupTemplate),(e=>{e&&(e.content=this._renderSearchResultsContent)}),o.initial)])}destroy(){this._cancelSuggest(),this._cancelSearch(),this._searchResultRenderer=s.destroyMaybe(this._searchResultRenderer),this._focusAbortController?.abort()}get displayedSearchTerm(){return`${this.viewModel.searchTerm}`.trim()}get inputId(){return this._buildId("input")}get suggestionsMenuId(){return this._buildId("suggest-menu")}get sourceMenuId(){return this._buildId("source-menu")}get sourceMenuButtonId(){return this._buildId("source-menu-button")}get activeSource(){return this.viewModel?.activeSource}get activeSourceIndex(){return this.viewModel.activeSourceIndex}set activeSourceIndex(e){this.viewModel.activeSourceIndex=e}get allPlaceholder(){return this.viewModel.allPlaceholder}set allPlaceholder(e){this.viewModel.allPlaceholder=e}get allSources(){return this.viewModel.allSources}get autoNavigate(){return this.viewModel.autoNavigate}set autoNavigate(e){this.viewModel.autoNavigate=e}get autoSelect(){return this.viewModel.autoSelect}set autoSelect(e){this.viewModel.autoSelect=e}get defaultSources(){return this.viewModel.defaultSources}get goToOverride(){return this.viewModel.goToOverride}set goToOverride(e){this.viewModel.goToOverride=e}get icon(){return"search"}set icon(e){this._overrideIfSome("icon",e)}get includeDefaultSources(){return this.viewModel.includeDefaultSources}set includeDefaultSources(e){this.viewModel.includeDefaultSources=e}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}get locationEnabled(){return this.viewModel.locationEnabled}set locationEnabled(e){this.viewModel.locationEnabled=e}get maxResults(){return this.viewModel.maxResults}set maxResults(e){this.viewModel.maxResults=e}get maxSuggestions(){return this.viewModel.maxSuggestions}set maxSuggestions(e){this.viewModel.maxSuggestions=e}get minSuggestCharacters(){return this.viewModel.minSuggestCharacters}set minSuggestCharacters(e){this.viewModel.minSuggestCharacters=e}get popupEnabled(){return this.viewModel.popupEnabled}set popupEnabled(e){this.viewModel.popupEnabled=e}get popupTemplate(){return this.viewModel.popupTemplate}set popupTemplate(e){this.viewModel.popupTemplate=e}get portal(){return this.viewModel?.portal}set portal(e){this.viewModel&&(this.viewModel.portal=e)}get resultGraphic(){return this.viewModel.resultGraphic}set resultGraphic(e){this.viewModel.resultGraphic=e}get resultGraphicEnabled(){return this.viewModel.resultGraphicEnabled}set resultGraphicEnabled(e){this.viewModel.resultGraphicEnabled=e}get results(){return this.viewModel.results}get searchAllEnabled(){return this.viewModel.searchAllEnabled}set searchAllEnabled(e){this.viewModel.searchAllEnabled=e}get searchTerm(){return this.viewModel.searchTerm}set searchTerm(e){this.viewModel.searchTerm=e}get selectedResult(){return this.viewModel.selectedResult}get sources(){return this.viewModel.sources}set sources(e){this.viewModel.sources=e}get suggestions(){return this.viewModel.suggestions}get suggestionsEnabled(){return this.viewModel.suggestionsEnabled}set suggestionsEnabled(e){this.viewModel.suggestionsEnabled=e}get view(){return this.viewModel.view}set view(e){this.viewModel.view=e}clear(){this.viewModel.clear()}focus(){this._handleFocus(),this.emit("search-focus")}async _handleFocus(){this._focusAbortController?.abort(),this._focusAbortController=new AbortController;const e=this._focusAbortController.signal;await r.ignoreAbortErrors(n.waitAnimationFrame(e)),this._inputNode?.focus()}blur(){this._inputNode?.blur(),this.emit("search-blur")}async search(e){this._clearActiveMenu(),this._cancelSuggest(),this._cancelSearch();const t=new AbortController,{signal:s}=t;this._searchController=t;try{const r=await this.viewModel.search(e,{signal:s});if(this._searchController!==t)return;return this.activeMenu=r?.numResults?"none":"warning",this._searchController=null,r}catch(r){if(this._searchController!==t)return;return this._clearActiveMenu(),void(this._searchController=null)}}async suggest(e){this._cancelSuggest();const t=new AbortController,{signal:s}=t;this._suggestController=t;try{const r=await this.viewModel.suggest(e,null,{signal:s});if(this._suggestController!==t)return;return this._suggestController=null,r?.numResults&&this._openSuggestionMenu(),this._scrollToTopSuggestion(),r}catch(r){return this._suggestController!==t||(this._suggestController=null),null}}render(){const{state:e}=this.viewModel,t={[v.globalCss.disabled]:"disabled"===e,[v.globalCss.widgetDisabled]:this.disabled};return w.tsx("div",{class:this.classes(g.css.base,v.globalCss.widget,t)},"loading"===e?this._renderLoader():this._renderContainer())}_renderSubmitButton(){const{messages:e,disabled:t}=this;return w.tsx("button",{"aria-label":e.searchButtonTitle,bind:this,class:this.classes(g.css.submitButton,v.globalCss.widgetButton),disabled:t,key:"esri-search__submit-button",onclick:this._handleSearchButtonClick,title:e.searchButtonTitle,type:"button"},w.tsx("span",{"aria-hidden":"true",class:m.legacyIcon.search}))}_renderWarningMenu(){return w.tsx("div",{class:this.classes(v.globalCss.menu,g.css.warningMenu),key:"esri-search__error-menu"},w.tsx("div",{class:g.css.warningMenuBody},this._renderWarning()))}_renderSourceMenuButton(){const{messages:e,activeMenu:t,sourceMenuId:s,sourceMenuButtonId:r,disabled:o}=this,{activeSourceIndex:n,allSources:i}=this.viewModel;return i.length>1?w.tsx("button",{afterCreate:M.storeNode,"aria-controls":s,"aria-expanded":("source"===t).toString(),"aria-haspopup":"true","aria-label":e.searchIn,bind:this,class:this.classes(g.css.sourcesButton,v.globalCss.widgetButton),"data-node-ref":"_sourceMenuButtonNode",disabled:o,id:r,key:"esri-search__source-menu-button",onclick:this._handleSourcesMenuToggleClick,onfocus:this._handleSourcesMenuToggleFocus,title:e.searchIn,type:"button"},w.tsx("span",{"aria-hidden":"true",class:this.classes(m.legacyIcon.downArrow,g.css.sourcesButtonDown)}),w.tsx("span",{"aria-hidden":"true",class:this.classes(m.legacyIcon.upArrow,g.css.sourcesButtonUp)}),w.tsx("span",{class:g.css.sourceName},this._getSourceName(n))):null}_renderSourcesList(){const{allSources:e,searchAllEnabled:t}=this.viewModel,{_activeMenuItemIndex:s,activeMenu:r,sourceMenuId:o,sourceMenuButtonId:n}=this,i="source"===r&&s>-1?this._buildId("source-item",s):null;return e.length>1?w.tsx("ul",{afterCreate:M.storeNode,"aria-activedescendant":i,"aria-labelledby":n,bind:this,class:v.globalCss.menuList,"data-node-ref":"_sourceListNode",id:o,onkeydown:this._handleSourceMenuKeydown,onkeyup:this._handleSourceMenuKeyup,role:"menu",tabIndex:-1},t?this._renderSource(_.ALL_INDEX):null,e.map(((e,t)=>this._renderSource(t))).toArray()):null}_renderSourcesMenu(){const{allSources:e}=this.viewModel;return e.length>1?w.tsx("div",{class:this.classes(v.globalCss.menu,g.css.sourcesMenu),key:"esri-search__source-menu"},this._renderSourcesList()):null}_renderLoader(){const{messages:e,messagesCommon:t,disabled:s}=this;return w.tsx("div",{class:v.globalCss.loader,key:"base-loader",tabIndex:s?-1:void 0},w.tsx("span",{"aria-hidden":"true",class:v.globalCss.loaderAnimation}),w.tsx("span",{class:m.legacyIcon.fontFallbackText},e.searchButtonTitle),w.tsx("span",{class:v.globalCss.loaderText},t.loading))}_renderContainer(){const{allSources:e,state:t}=this.viewModel,{activeMenu:s}=this,r={[g.css.hasMultipleSources]:e.length>1,[g.css.isLoading]:"loading"===t,[g.css.isSearching]:"searching"===t,[g.css.showWarning]:"warning"===s,[g.css.showSources]:"source"===s,[g.css.showSuggestions]:"suggestion"===s};return w.tsx("div",{afterCreate:e=>{this._container=e,e.addEventListener("focusout",this._removeActiveMenu)},afterRemoved:e=>{e.removeEventListener("focusout",this._removeActiveMenu)},class:this.classes(r,g.css.container),key:"base-container",tabIndex:-1},this._renderSourceMenuButton(),this._renderSourcesMenu(),this._renderInputContainer(),this._renderSubmitButton(),this._renderWarningMenu())}_renderClearButton(){return this.searchTerm?w.tsx("button",{bind:this,class:this.classes(g.css.clearButton,v.globalCss.widgetButton),disabled:this.disabled,key:"esri-search__clear-button",onclick:this._handleClearButtonClick,onfocus:this._clearActiveMenu,title:this.messages.clearButtonTitle,type:"button"},w.tsx("span",{"aria-hidden":"true",class:m.legacyIcon.close})):null}_renderLocationGroup(){const{messages:e,locationEnabled:t,displayedSearchTerm:s}=this,r=t&&!s,o="suggestion"===this.activeMenu&&0===this._activeMenuItemIndex;return r?w.tsx("ul",{class:this.classes(v.globalCss.menuList,g.css.suggestionList,g.css.suggestionListCurrentLocation),key:"esri-search__suggestion-list-current-location",role:"group"},w.tsx("li",{"aria-selected":("suggestion"===this.activeMenu&&0===this._activeMenuItemIndex).toString(),bind:this,class:this.classes(v.globalCss.menuItem,o?v.globalCss.menuItemFocus:null),"data-current-location-item":!0,id:this._buildId("suggestion-item",0),onclick:this._handleUseCurrentLocationClick,role:"option"},w.tsx("span",{"aria-hidden":"true",class:m.legacyIcon.locateCircled})," ",e.useCurrentLocation)):null}_renderInput(){const{activeMenu:e,locationEnabled:t,displayedSearchTerm:s,messages:r,suggestionsMenuId:o,inputId:n,_activeMenuItemIndex:i,disabled:a}=this,{maxInputLength:l,placeholder:u,searchTerm:c,suggestionCount:d}=this.viewModel,h=!(!(t&&!s)&&!d),p="suggestion"===e&&i>-1?this._buildId("suggestion-item",i):null;return w.tsx("input",{afterCreate:M.storeNode,"aria-activedescendant":p,"aria-autocomplete":"list","aria-controls":h?o:null,"aria-expanded":(h&&"suggestion"===e).toString(),"aria-haspopup":"listbox","aria-label":r.searchButtonTitle,autocomplete:"off",bind:this,class:this.classes(v.globalCss.input,g.css.input),"data-node-ref":"_inputNode",disabled:a,id:n,maxlength:l,onblur:this.blur,onclick:this._openSuggestionMenu,onfocus:this.focus,oninput:this._handleInputPaste,onkeyup:this._handleInputKeyup,onpaste:this._handleInputPaste,placeholder:u,role:"combobox",title:c?"":u,type:"text",value:c})}_renderForm(){return w.tsx("form",{bind:this,class:g.css.form,disabled:this.disabled,key:"esri-search__form",onsubmit:this._formSubmit,role:"search"},this._renderInput())}_renderSuggestList(e){const{sourceIndex:t}=e,{results:s}=e,r=s?.length;return r?w.tsx("ul",{class:this.classes(v.globalCss.menuList,g.css.suggestionList),key:`esri-search__suggestion-list-${t}`,role:"group"},s?.map((e=>this._renderSuggestion(e,this._menuItemCount++)))):null}_renderSuggestionsGroup(){const{suggestions:e}=this.viewModel;return e?e.map((e=>[this._renderSuggestionHeader(e),this._renderSuggestList(e)])):[]}_renderSuggestionsMenu(){const{displayedSearchTerm:e,locationEnabled:t,suggestionsMenuId:s,inputId:r}=this,{suggestionCount:o}=this.viewModel,n=t&&!e||o;return this._menuItemCount=0,n?w.tsx("div",{afterCreate:M.storeNode,"aria-labelledby":r,bind:this,class:this.classes(v.globalCss.menu,g.css.suggestionsMenu),"data-node-ref":"_suggestionListNode",id:s,key:"esri-search__suggestions-menu",role:"listbox"},this._renderLocationGroup(),this._renderSuggestionsGroup()):null}_renderInputContainer(){return w.tsx("div",{class:g.css.inputContainer,key:"esri-search__input-container"},this._renderForm(),this._renderSuggestionsMenu(),this._renderClearButton())}_renderSuggestionHeader(e){const{allSources:t,activeSourceIndex:s}=this.viewModel,{sourceIndex:r}=e,o=e.results?.length,n=t.length>1&&s===_.ALL_INDEX;return o&&n?w.tsx("div",{class:v.globalCss.menuHeader,key:`esri-search__suggestion-header-${r}`},this._getSourceName(r)):null}_renderSuggestion(e,t){const{_activeMenuItemIndex:s,viewModel:{searchTerm:r}}=this;if(!r)return;const o="suggestion"===this.activeMenu&&s===t;return w.tsx("li",{"aria-selected":("suggestion"===this.activeMenu&&this._activeMenuItemIndex===t).toString(),bind:this,class:this.classes(v.globalCss.menuItem,o?v.globalCss.menuItemFocus:null),"data-suggestion":e,id:this._buildId("suggestion-item",t),innerHTML:this._getSuggestResultHTML(e.text,r),key:`esri-search__suggestion_${t}`,onclick:this._handleSuggestionClick,role:"option"})}_renderSource(e){const{activeSourceIndex:t,searchAllEnabled:s}=this.viewModel,r={[v.globalCss.menuItemActive]:e===t,[v.globalCss.menuItemFocus]:"source"===this.activeMenu&&e===(s?this._activeMenuItemIndex-1:this._activeMenuItemIndex)},o=s?e+1:e;return w.tsx("li",{"aria-checked":(e===t).toString(),bind:this,class:this.classes(g.css.source,v.globalCss.menuItem,r),"data-source-index":e,id:this._buildId("source-item",o),key:`esri-search__source-${e}`,onclick:this._handleSourceClick,role:"menuitemradio"},this._getSourceName(e))}_renderNoResultsWarning(e){const{messages:t}=this,s=e?S.substitute(t.noResultsFoundForValue,{value:`"${e}"`}):t.noResultsFound;return w.tsx("div",{key:"esri-search__no_results"},w.tsx("div",{class:g.css.warningMenuHeader},t.noResults),w.tsx("div",{class:g.css.warningMenuText},s))}_renderEmptySearchWarning(){const{messages:e}=this;return w.tsx("div",{key:"esri-search__empty-search"},w.tsx("span",{"aria-hidden":"true",class:m.legacyIcon.noticeTriangle}),w.tsx("span",{class:g.css.noValueText},e.emptyValue))}_renderLocateWarning(){const{messages:e}=this;return w.tsx("div",{key:"esri-search__locate-error"},w.tsx("span",{"aria-hidden":"true",class:m.legacyIcon.noticeTriangle}),w.tsx("span",{class:g.css.noValueText},e.locateError))}_renderWarning(){const{displayedSearchTerm:e,_locateFailed:t}=this,{viewModel:s}=this;return t?this._renderLocateWarning():s.selectedSuggestion?.location||e?this._renderNoResultsWarning(e):this._renderEmptySearchWarning()}_resetActiveMenuItemIndex(){this._activeMenuItemIndex=-1}_buildId(e,t){return`${this.id}-${e}${void 0===t?"":`-${t}`}`}_watchSourceChanges(){const{viewModel:{allSources:e}}=this,t="sources";this.removeHandles(t),e.forEach((e=>this.addHandles(o.watch((()=>e.name),(()=>this.scheduleRender())),t)))}_handleSourcesMenuToggleFocus(){"source"!==this.activeMenu&&this._clearActiveMenu()}_handleSourcesMenuToggleClick(){const e="source"===this.activeMenu;this.activeMenu=e?"none":"source",this.renderNow(),"source"===this.activeMenu&&this._sourceListNode?.focus()}_handleClearButtonClick(){this.viewModel.clear(),this._focus()}_handleSearchButtonClick(){this.search()}_handleSuggestionClick(e){const t=f(e.currentTarget);t&&(this._focus(),this.search(t))}_handleUseCurrentLocationClick(){this._useCurrentLocation()}_useCurrentLocation(){this._focus("none"),this._cancelSuggest(),this._cancelSearch();const e=new AbortController,{signal:t}=e;this._searchController=e;(async()=>{try{const e=await this.viewModel.searchNearby({signal:t});this.activeMenu=e?.numResults?"none":"warning"}catch(e){this._locateFailed=!0,this.activeMenu="warning"}finally{this._searchController=null}})()}_handleSourceClick(e){this._setSourceFromMenuItem(e.currentTarget)}_setSourceFromMenuItem(e){if(!e)return;const t=T(e);null!=t&&(this.viewModel.activeSourceIndex=t,this._clearActiveMenu(),this._sourceMenuButtonNode?.focus())}_cancelSuggest(){this._suggestController=s.abortMaybe(this._suggestController)}_cancelSearch(){this._searchController=s.abortMaybe(this._searchController),this._locateFailed=!1}_handleInputKeyup(e){const{key:t}=e;if(e.ctrlKey||e.metaKey||"Copy"===t||"ArrowLeft"===t||"ArrowRight"===t||"Shift"===t)return;if("Tab"===t||"Escape"===t||e.shiftKey&&"Tab"===t)return this._cancelSuggest(),void("Escape"===t&&this._clearActiveMenu());const s="Home"===t||"End"===t||"ArrowUp"===t||"ArrowDown"===t;if("Enter"===t&&this._activeMenuItemIndex<0)return void this._cancelSuggest();const r=this._suggestionListNode?.getElementsByTagName("li");if(r?.length){if("suggestion"!==this.activeMenu&&this._openSuggestionMenu(),s)return e.preventDefault(),this._cancelSuggest(),void this._handleItemNavigation(t,r,this._suggestionListNode);const o=r[this._activeMenuItemIndex];if("Enter"===t&&o){const e=f(o);return void(e?(this._focus(),this.search(e)):E(o)&&this._useCurrentLocation())}}this.viewModel.searchTerm&&this.suggest()}_handleItemNavigation(e,t,s){const r=this._activeMenuItemIndex;"Home"===e&&(this._activeMenuItemIndex=0),"End"===e&&(this._activeMenuItemIndex=t.length-1),"ArrowUp"===e&&(this._activeMenuItemIndex=this._activeMenuItemIndex<=0?t.length-1:this._activeMenuItemIndex-1),"ArrowDown"===e&&(this._activeMenuItemIndex=this._activeMenuItemIndex===t.length-1?0:this._activeMenuItemIndex+1),r!==this._activeMenuItemIndex&&s&&A(t[this._activeMenuItemIndex],s)}_scrollToTopSuggestion(){this._suggestionListNode&&(this._suggestionListNode.scrollTop=0)}_openSuggestionMenu(){this.activeMenu="suggestion"}_handleInputPaste(e){const t=e.target;this.viewModel.searchTerm!==t.value&&(this.viewModel.searchTerm=t.value),this.viewModel.searchTerm&&this.suggest()}_handleSourceMenuKeydown(e){const{key:t}=e;if(M.isActivationKey(t)){e.preventDefault();const t=this._sourceListNode?.getElementsByTagName("li"),s=t?.[this._activeMenuItemIndex];this._setSourceFromMenuItem(s)}else"ArrowUp"!==t&&"ArrowDown"!==t&&"End"!==t&&"Home"!==t||e.preventDefault()}_handleSourceMenuKeyup(e){const{key:t}=e,s="ArrowUp"===t||"ArrowDown"===t||"End"===t||"Home"===t;if(s&&e.preventDefault(),"Escape"===t)return this._clearActiveMenu(),void this._sourceMenuButtonNode?.focus();const r=this._sourceListNode?.getElementsByTagName("li");return r&&0!==r.length&&s?("source"!==this.activeMenu&&(this.activeMenu="source"),void this._handleItemNavigation(t,r,this._sourceListNode?.parentElement)):void 0}_focus(e){this.focus(),e&&(this.activeMenu=e)}_formSubmit(e){e.preventDefault(),-1===this._activeMenuItemIndex&&this.search()}_getSourceName(e){const{messages:t}=this,s=this.viewModel,{allSources:r}=s,o=r.at(e);return e===_.ALL_INDEX?t.all:o&&o.name||t.untitledSource}_getSuggestResultHTML(e,t){return e?I.test(e)?e:x(e,t):this.messages.untitledResult}};function f(e){return e?.["data-suggestion"]}function T(e){return e?.["data-source-index"]}function E(e){return!!e?.["data-current-location-item"]}function A(e,t){const s=e.getBoundingClientRect(),r=t.getBoundingClientRect(),o=s.top+s.height,n=r.top+r.height,i=s.top,a=r.top;(o>n||i<a)&&e.scrollIntoView({block:"end"})}e.__decorate([a.property()],C.prototype,"_activeMenuItemIndex",void 0),e.__decorate([a.property()],C.prototype,"displayedSearchTerm",null),e.__decorate([a.property({readOnly:!0})],C.prototype,"inputId",null),e.__decorate([a.property({readOnly:!0})],C.prototype,"suggestionsMenuId",null),e.__decorate([a.property({readOnly:!0})],C.prototype,"sourceMenuId",null),e.__decorate([a.property({readOnly:!0})],C.prototype,"sourceMenuButtonId",null),e.__decorate([a.property()],C.prototype,"activeMenu",void 0),e.__decorate([a.property({readOnly:!0})],C.prototype,"activeSource",null),e.__decorate([a.property()],C.prototype,"activeSourceIndex",null),e.__decorate([a.property()],C.prototype,"allPlaceholder",null),e.__decorate([a.property({readOnly:!0})],C.prototype,"allSources",null),e.__decorate([a.property()],C.prototype,"autoNavigate",null),e.__decorate([a.property()],C.prototype,"autoSelect",null),e.__decorate([a.property({readOnly:!0})],C.prototype,"defaultSources",null),e.__decorate([a.property()],C.prototype,"disabled",void 0),e.__decorate([a.property()],C.prototype,"goToOverride",null),e.__decorate([a.property()],C.prototype,"icon",null),e.__decorate([a.property()],C.prototype,"includeDefaultSources",null),e.__decorate([a.property()],C.prototype,"label",null),e.__decorate([a.property()],C.prototype,"locationEnabled",null),e.__decorate([a.property()],C.prototype,"maxResults",null),e.__decorate([a.property()],C.prototype,"maxSuggestions",null),e.__decorate([a.property(),y.messageBundle("esri/widgets/Search/t9n/Search")],C.prototype,"messages",void 0),e.__decorate([a.property(),y.messageBundle("esri/t9n/common")],C.prototype,"messagesCommon",void 0),e.__decorate([a.property()],C.prototype,"minSuggestCharacters",null),e.__decorate([a.property()],C.prototype,"popupEnabled",null),e.__decorate([a.property()],C.prototype,"popupTemplate",null),e.__decorate([a.property()],C.prototype,"portal",null),e.__decorate([a.property()],C.prototype,"resultGraphic",null),e.__decorate([a.property()],C.prototype,"resultGraphicEnabled",null),e.__decorate([a.property({readOnly:!0})],C.prototype,"results",null),e.__decorate([a.property()],C.prototype,"searchAllEnabled",null),e.__decorate([a.property()],C.prototype,"searchTerm",null),e.__decorate([a.property({readOnly:!0})],C.prototype,"selectedResult",null),e.__decorate([a.property()],C.prototype,"sources",null),e.__decorate([a.property({readOnly:!0})],C.prototype,"suggestions",null),e.__decorate([a.property()],C.prototype,"suggestionsEnabled",null),e.__decorate([a.property()],C.prototype,"view",null),e.__decorate([b.vmEvent(["search-complete","search-clear","search-start","select-result","suggest-start","suggest-complete"]),a.property({type:_})],C.prototype,"viewModel",void 0),C=e.__decorate([d.subclass("esri.widgets.Search")],C);return C}));
