/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../assets","../../config","../../Graphic","../../PopupTemplate","../../symbols","../../core/Accessor","../../core/arrayUtils","../../core/Collection","../../core/Error","../../core/Evented","../../core/Logger","../../core/maybe","../../core/promiseUtils","../../core/reactiveUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/accessorSupport/decorators/subclass","../../geometry/Point","../../geometry/SpatialReference","../../geometry/support/geometryUtils","../../intl/locale","../../intl/messages","../../portal/Portal","../../views/support/layerViewUtils","./LayerSearchSource","./LocatorSearchSource","./SearchSource","./support/locatorUtils","../support/geolocationUtils","../support/GoTo","../../symbols/PictureMarkerSymbol","../../symbols/SimpleLineSymbol","../../symbols/SimpleFillSymbol","../../symbols/TextSymbol"],(function(e,t,r,s,o,a,i,l,n,u,c,p,h,d,g,y,_,m,S,f,w,v,b,x,L,I,T,E,F,R,P,G,A,C,O){"use strict";function M(e,t){return e.hasOwnProperty(t)&&null!=e[t]&&""!==e[t]}const N=()=>b.fetchMessageBundle("esri/widgets/Search/t9n/Search"),D="highlight",U=n.ofType({key:e=>e.layer?"layer":"locator",base:E,typeMap:{layer:I,locator:T}}),V=f.WGS84,k="esri/images/search/search-symbol-32.png",J=/<[\s\S]*?>/g,H=-1;let B=class extends(P.GoToMixin(c.EventedMixin(i))){constructor(e){super(e),this._gotoController=null,this._searching=null,this._updatingPromise=null,this._createdFeatureLayers=[],this.autoNavigate=!0,this.autoSelect=!0,this.defaultPopupTemplate=null,this.defaultSources=new U,this.defaultSymbols={point:new G({url:t.getAssetUrl(k),size:24,width:24,height:24}),polyline:new A({color:[130,130,130,1],width:2}),polygon:new C({color:[235,235,235,.4],outline:{color:[130,130,130,1],width:2}})},this.includeDefaultSources=!0,this.maxInputLength=128,this.maxResults=6,this.maxSuggestions=6,this.messages=null,this.minSuggestCharacters=3,this.popupEnabled=!0,this.popupTemplate=null,this.portal=x.getDefault(),this.resultCount=null,this.resultGraphicEnabled=!0,this.resultGraphic=null,this.results=null,this.selectedSuggestion=null,this.searchAllEnabled=!0,this.selectedResult=null,this.sources=new U,this.suggestionDelay=350,this.suggestionCount=null,this.suggestions=null,this.suggestionsEnabled=!0,this.view=null}initialize(){const e=async()=>{const e=await N();this.messages=e,this.defaultPopupTemplate=new o({title:e.searchResult,content:"{Match_addr}"})};e(),this.addHandles([g.watch((()=>[this.includeDefaultSources,this.view,this.portal]),(()=>this._update()),g.initial),v.onLocaleChange(e)])}destroy(){this._destroyFeatureLayers(),this._abortGoTo(),this.clearGraphics()}get activeSource(){return this.allSources.at(this.activeSourceIndex)??null}get activeSourceIndex(){return 1===this.allSources.length||!this.searchAllEnabled?0:H}set activeSourceIndex(e){this._overrideIfSome("activeSourceIndex",e)}get allPlaceholder(){return this.messages?.allPlaceholder}set allPlaceholder(e){this._overrideIfSome("allPlaceholder",e)}get allSources(){const{sources:e,defaultSources:t,includeDefaultSources:r}=this,s="function"==typeof r?r.call(null,{sources:e,defaultSources:t}):r?t.concat(e):e,o=this._get("allSources")||new U;return o.removeAll(),o.addMany(s.filter(Boolean)),o}get locationEnabled(){return this._get("locationEnabled")||R.supported()}set locationEnabled(e){if(void 0===e)return void this._clearOverride("locationEnabled");const t=R.supported();if(e&&!t){const e=new u("locationEnabled:geolocation-unsupported","Geolocation API is unsupported.",{geolocation:navigator.geolocation});p.getLogger(this).error(e)}this._override("locationEnabled",!!e&&t)}get placeholder(){const{allSources:e,activeSourceIndex:t,allPlaceholder:r}=this;if(t===H)return r??"";const s=e.at(t);return s?.placeholder??""}set searchTerm(e){this._set("searchTerm",e||""),this.clearGraphics(),this.selectedSuggestion&&this.selectedSuggestion.text!==e&&this._set("selectedSuggestion",null),""===e&&this._clear()}get searchTerm(){return this._get("searchTerm")||""}get state(){return this._searching?"searching":this.updating?"loading":0===this.allSources.length?"disabled":"ready"}get updating(){return null!=this._updatingPromise}clear(){this.searchTerm=""}clearGraphics(){this._removeHighlight(),this._closePopup();const{view:e,resultGraphic:t}=this;e&&t&&e.graphics.remove(t),this._set("resultGraphic",null)}search(e,t){this.emit("search-start"),this.clearGraphics();const r=this._createSuggestionForSearch(e),s=(async()=>{try{await this.when();const e=await this._getResultsFromSources(r,t);if(t?.signal?.aborted)return null;const s={activeSourceIndex:this.activeSourceIndex,searchTerm:r.text??"",numResults:0,numErrors:0,errors:[],results:[]};this._formatResponse(s,e,r);const o=this._getFirstResult(s.results),a=r.location&&o?o.name:r.text,i=a?.replace(J,"");return this._set("searchTerm",i),(r.key&&"number"==typeof r.sourceIndex||r.location)&&this._set("selectedSuggestion",r),this._set("results",s.results),this._set("resultCount",s.results.reduce(((e,t)=>e+(t.results?.length??0)),0)),this.emit("search-complete",s),await this._selectFirstResult(o),s}finally{this._clearSearching()}})();return this._searching=s,s}async searchNearby(e){if(!this.locationEnabled){const e=new u("searchNearby:geolocation-unsupported","Geolocation API is unsupported.",{geolocation:navigator.geolocation});throw p.getLogger(this).error(e),e}const t=(async()=>{try{const t=await R.getCurrentPosition(),r=await R.positionToPoint({position:t,view:this.view},e);return await this.search(r,e)}finally{this._clearSearching()}})();return this._searching=t,t}async select(e){if(this.clearGraphics(),!e){const t=new u("select:missing-parameter","Cannot select without a searchResult.",{searchResult:e});throw p.getLogger(this).error(t),t}const{view:t}=this,r=M(e,"sourceIndex")?e.sourceIndex:this._getSourceIndexOfResult(e),o=null!=r?this.allSources.at(r):null;if(!o){const e=new u("select:missing-source","Cannot select without a source.",{source:o});throw p.getLogger(this).error(e),e}const a=o instanceof I?this._getLayerSourcePopupTemplate(o):o.popupTemplate,i=o.resultSymbol||this._getDefaultSymbol(e),l=M(o,"resultGraphicEnabled")?o.resultGraphicEnabled:this.resultGraphicEnabled,n=M(o,"autoNavigate")?o.autoNavigate:this.autoNavigate,c=M(o,"popupEnabled")?o.popupEnabled:this.popupEnabled,h=c?a||this.popupTemplate||this.defaultPopupTemplate:null,{feature:g}=e;if(!g){const e=new u("select:missing-feature","Cannot select without a feature.",{feature:g});throw p.getLogger(this).error(e),e}const{attributes:y,geometry:_,layer:m,sourceLayer:S}=g,f=_?w.getPointFromGeometry(_):null,v={layerViewQuery:this._getLayerView(g),elevationQuery:t&&null!=f?w.getPointWithElevation(f,t):Promise.resolve(f)},b=await d.eachAlways(v),x=b.layerViewQuery.value,T=b.elevationQuery.value;i instanceof O&&(i.text=e.name);const E=t&&n?e.target||e.extent:null,F=null!=E?this._goToSearchResult(E):Promise.resolve();await F;const R=x?g:new s({geometry:_,symbol:i,attributes:y,layer:m,sourceLayer:S,popupTemplate:h}),P=t?.popup,G=P&&c&&R.getEffectivePopupTemplate(P.defaultPopupTemplateEnabled);return G&&await t.openPopup({features:[R],location:T}),x&&L.highlightsSupported(x)&&!G&&this._highlightFeature({graphic:R,layerView:x}),!x&&l&&t&&t.graphics.push(R),this._setResultFloor(e),this._set("selectedResult",e),this._set("resultGraphic",R),this.emit("select-result",{result:e,source:o,sourceIndex:r}),e}async suggest(e,t,r){const s=e||this.searchTerm;this.emit("suggest-start",{searchTerm:s}),await this._suggestTimer(t,r);const o=await this._suggestImmediate(s,r);return this._set("suggestions",o?.results),this._set("suggestionCount",o?.results.reduce(((e,t)=>e+(t.results?.length??0)),0)??null),this.emit("suggest-complete",o),o}async when(){await g.whenOnce((()=>!this.updating))}async _update(){const{portal:e,view:t}=this;if(this.includeDefaultSources){const r=this._updatingPromise=d.eachAlways([e?.load(),t?.when()]);if(this.destroyed)return;if(await r,r!==this._updatingPromise)return}await g.whenOnce((()=>this.messages)),this.destroyed||this._updateDefaultSources(),this._updatingPromise=null}_clearSearching(){this._searching=null}_convertHelperServices(){const e=this.portal?.helperServices?.geocode;if(!e)return[];return e.map((e=>{if(!1===e.placefinding)return;const t=r.apiKey&&F.isArcGISWorldGeocoder(e.url)?{url:F.meteredArcGISLocatorUrl}:null,s=T.fromJSON({...e,...t}),o=s.url;if(F.isArcGISWorldGeocoder(o)||F.isProxiedArcGISWorldGeocoder(o)||F.isMeteredArcGISWorldGeocoder(o)){const e=s.outFields??["Addr_type","Match_addr","StAddr","City"],t=(s.placeholder||this.messages?.placeholder)??"",r="number"==typeof s.defaultZoomScale?s.defaultZoomScale:2500;s.singleLineFieldName="SingleLine",s.outFields=e,s.placeholder=t,s.defaultZoomScale=r}return s.singleLineFieldName?s:void 0})).filter(l.isSome)}_destroyFeatureLayers(){this._createdFeatureLayers.forEach((e=>e?.destroy())),this._createdFeatureLayers=[]}_getLayerSources(e,t){const r=this.view?.map;return e.map((e=>{const s=r.findLayerById(e.id);if(!s)return;const o=this._getLayerJSON(e),a=I.fromJSON(o);return a.placeholder=t,this._getLayer(s,o).then((e=>{a.layer=e})),a})).filter(l.isSome).toArray()}_getTableSources(e,t){const r=this.view?.map;return e.map((e=>{if(!e.id)return;const s=r.findTableById(e.id);if(!s)return;const o=this._getLayerJSON(e),a=I.fromJSON(o);return a.placeholder=t,this._getLayer(s,o).then((e=>{a.layer=e})),a})).filter(l.isSome).toArray()}_convertApplicationProperties(){const e=this.view?.map,t=e?.applicationProperties?.viewing?.search;if(!t)return[];const{enabled:r,hintText:s,layers:o,tables:a}=t;if(!r)return[];return[...this._getLayerSources(o,s),...this._getTableSources(a,s)]}async _getSubLayer(e,t){if(await e.load(),!e.allSublayers)throw new Error;const r=e.allSublayers.find((e=>e.id===t.subLayer));if(!r)throw new Error;const s=await(r.createFeatureLayer?.());if(!s)throw new Error;return this._createdFeatureLayers.push(s),s}async _getBuildingSubLayer(e,t){await e.load();const r=e.allSublayers.find((e=>e.id===t.subLayer));if("building-component"!==r?.type)throw new Error;if(await r.load(),null==r.associatedLayer)throw new Error;return await r.associatedLayer.load(),r}async _getLayer(e,t){if("feature"===e.type||"scene"===e.type||"csv"===e.type||"geojson"===e.type||"ogc-feature"===e.type)return e;if("map-image"===e.type)try{return await this._getSubLayer(e,t)}catch(r){const t=new u("search:create-featurelayer","Could not create a FeatureLayer from the MapImageLayer",{layer:e});return p.getLogger(this).error(t),null}return"building-scene"===e.type?this._getBuildingSubLayer(e,t):null}_getLayerJSON(e){return"function"==typeof e.toJSON?e.toJSON():e}_updateDefaultSources(){const{defaultSources:e,includeDefaultSources:t}=this;this._destroyFeatureLayers(),e.removeAll(),t&&e.addMany([...this._convertApplicationProperties(),...this._convertHelperServices()])}_abortGoTo(){this._gotoController&&this._gotoController.abort(),this._gotoController=null}_clear(){this._abortGoTo(),this._set("resultCount",null),this._set("results",null),this._set("suggestions",null),this._set("suggestionCount",null),this._set("selectedResult",null),this._set("selectedSuggestion",null),this.emit("search-clear")}_closePopup(){const e=this.view?.popup,{resultGraphic:t}=this;if(!e||!t)return;const r="selectedFeature"in e,s=r?e.selectedFeature:null;r&&(s&&s===t)&&e.close()}_suggestTimer(e,t){const r=null!=e?e:this.suggestionDelay;return d.after(r,null,t?.signal)}_createLocationForSearch(e){return e instanceof s&&e.geometry?w.getPointFromGeometry(e.geometry):e instanceof S?e:Array.isArray(e)&&2===e.length?new S({longitude:e[0],latitude:e[1]}):null}_createSuggestionForSearch(e){if(e&&M(e,"key")&&M(e,"text")&&M(e,"sourceIndex"))return e;const t=this._createLocationForSearch(e),r="string"==typeof e?e:this.searchTerm,{selectedSuggestion:s,selectedResult:o}=this,a=!e&&s&&o,i=a&&s.key===o.key&&s.sourceIndex===o.sourceIndex,l=a&&s.location;return i||l?s:{location:t,text:t?"":r,sourceIndex:null,key:null}}_getFirstResult(e){return h.mappedFind(e,(({results:e})=>e?.[0]))??null}async _selectFirstResult(e){return this.autoSelect&&e?this.select(e):null}async _suggestImmediate(e,t){await this.when();const r=await this._getSuggestionsFromSources(e,t);if(t?.signal?.aborted)return null;const s={activeSourceIndex:this.activeSourceIndex,searchTerm:e??"",numResults:0,numErrors:0,errors:[],results:[]};return this._formatResponse(s,r),s}_formatSourceResponse(e,t,r){const s=t?.value||[],o=t?.error,a=this.allSources.at(r);if(o){const t={sourceIndex:r,source:a,error:o};e.errors.push(t),p.getLogger(this).error(o),e.numErrors++}else{const t={sourceIndex:r,source:a,results:s};e.results.push(t),e.numResults+=s.length}}_formatResponse(e,t,r){if(t)if(e.activeSourceIndex===H){const s=r&&M(r,"sourceIndex")&&-1!==r.sourceIndex?r.sourceIndex:void 0;t.forEach(((t,r)=>{const o=void 0!==s?s:r;this._formatSourceResponse(e,t,o)}))}else this._formatSourceResponse(e,t[0],e.activeSourceIndex)}async _getResultsFromSources(e,t){const{allSources:r}=this,s=!e.location&&M(e,"sourceIndex")?e.sourceIndex:this.activeSourceIndex,o=[];if(!r.length){const e=new u("search:no-sources-defined","At least one source is required.",{allSources:r});throw p.getLogger(this).error(e),e}return s===H?r.forEach(((r,s)=>{o.push(this._getResultsFromSource(e,s,t))})):o.push(this._getResultsFromSource(e,s,t)),d.eachAlways(o)}async _getSuggestionsFromSources(e,t){const{allSources:r,activeSourceIndex:s}=this,o=[];if(!r.length){const e=new u("suggest:no-sources-defined","At least one source is required.",{allSources:r});throw p.getLogger(this).error(e),e}return s===H?r.forEach(((r,s)=>{o.push(this._getSuggestionsFromSource(e,s,t))})):o.push(this._getSuggestionsFromSource(e,s,t)),d.eachAlways(o)}async _getResultsFromSource(e,t,r){const s=null!=t?this.allSources.at(t):null;if(!s)return null;const{location:o=null}=e,a=this.view?.spatialReference||V,i=M(s,"maxResults")?s.maxResults:this.maxResults,l=!!(s instanceof I&&M(s,"exactMatch"))&&s.exactMatch,{view:n}=this;return s.getResults?.({view:n,sourceIndex:t,location:o,suggestResult:e,spatialReference:a,exactMatch:l,maxResults:i},r)}async _getSuggestionsFromSource(e,t,r){const s=this.allSources.at(t);if(!s)return null;e??="";const o=M(s,"suggestionsEnabled")?s.suggestionsEnabled:this.suggestionsEnabled,a=e?.length,i=M(s,"minSuggestCharacters")?s.minSuggestCharacters:this.minSuggestCharacters;if(o&&e.trim()&&a>=i){const o=this.view?.spatialReference||V,a=M(s,"maxSuggestions")?s.maxSuggestions:this.maxSuggestions,{view:i}=this,l=!!(s instanceof I&&M(s,"exactMatch"))&&s.exactMatch;return s.getSuggestions?.({view:i,sourceIndex:t,suggestTerm:e,spatialReference:o,maxSuggestions:a,exactMatch:l},r)}return null}_getLayerSourcePopupTemplate(e){const{layer:t}=e;if(t)return M(e,"popupTemplate")?e.popupTemplate:t.popupTemplate}_getSourceIndexOfResult(e){return h.mappedFind(this.results??[],(({results:t,sourceIndex:r})=>{const s=t?.includes(e);return s?r:null}))??null}async _goToSearchResult(e){this._abortGoTo();const t=new AbortController;this._gotoController=t;const r={target:{target:e},options:{signal:t.signal}};e||(r.options.animate=!1),await this.callGoTo(r),this._gotoController=null}_getDefaultSymbol(e){const{defaultSymbols:t}=this,r=e.feature?.geometry;if(null==r)return null;switch(r.type){case"point":case"multipoint":return t.point;case"polyline":return t.polyline;case"extent":case"polygon":return t.polygon;default:return null}}_removeHighlight(){this.removeHandles(D)}async _getLayerView(e){const{view:t}=this;if(!e||!t||"building-component"===e.layer?.type||"subtype-sublayer"===e.layer?.type)return null;const{layer:r}=e;return r?(await t.when(),t.whenLayerView(r)):null}_highlightFeature(e){const{graphic:t,layerView:r}=e,{attributes:s,layer:o}=t,{objectIdField:a}=o,i=(a&&s?.[a])??null,l=r.highlight(i??t);this.addHandles(l,D)}_setResultFloor(e){const{view:t}=this,r=e.feature?.attributes,s=e.feature?.sourceLayer;if(s&&"floorInfo"in s&&s?.floorInfo?.floorField&&r){const e=r[s.floorInfo.floorField];t?.emit("select-result-floor",e)}}};B.ALL_INDEX=H,e.__decorate([y.property()],B.prototype,"_searching",void 0),e.__decorate([y.property()],B.prototype,"_updatingPromise",void 0),e.__decorate([y.property({readOnly:!0,value:null})],B.prototype,"activeSource",null),e.__decorate([y.property()],B.prototype,"activeSourceIndex",null),e.__decorate([y.property()],B.prototype,"allPlaceholder",null),e.__decorate([y.property({readOnly:!0})],B.prototype,"allSources",null),e.__decorate([y.property()],B.prototype,"autoNavigate",void 0),e.__decorate([y.property()],B.prototype,"autoSelect",void 0),e.__decorate([y.property()],B.prototype,"defaultPopupTemplate",void 0),e.__decorate([y.property({readOnly:!0})],B.prototype,"defaultSources",void 0),e.__decorate([y.property()],B.prototype,"defaultSymbols",void 0),e.__decorate([y.property()],B.prototype,"includeDefaultSources",void 0),e.__decorate([y.property()],B.prototype,"locationEnabled",null),e.__decorate([y.property()],B.prototype,"maxInputLength",void 0),e.__decorate([y.property()],B.prototype,"maxResults",void 0),e.__decorate([y.property()],B.prototype,"maxSuggestions",void 0),e.__decorate([y.property()],B.prototype,"messages",void 0),e.__decorate([y.property()],B.prototype,"minSuggestCharacters",void 0),e.__decorate([y.property({readOnly:!0})],B.prototype,"placeholder",null),e.__decorate([y.property()],B.prototype,"popupEnabled",void 0),e.__decorate([y.property({type:o})],B.prototype,"popupTemplate",void 0),e.__decorate([y.property({type:x})],B.prototype,"portal",void 0),e.__decorate([y.property()],B.prototype,"resultCount",void 0),e.__decorate([y.property()],B.prototype,"resultGraphicEnabled",void 0),e.__decorate([y.property({readOnly:!0})],B.prototype,"resultGraphic",void 0),e.__decorate([y.property({readOnly:!0})],B.prototype,"results",void 0),e.__decorate([y.property({readOnly:!0})],B.prototype,"selectedSuggestion",void 0),e.__decorate([y.property()],B.prototype,"searchAllEnabled",void 0),e.__decorate([y.property({readOnly:!0})],B.prototype,"selectedResult",void 0),e.__decorate([y.property()],B.prototype,"searchTerm",null),e.__decorate([y.property({type:U})],B.prototype,"sources",void 0),e.__decorate([y.property({readOnly:!0})],B.prototype,"state",null),e.__decorate([y.property()],B.prototype,"suggestionDelay",void 0),e.__decorate([y.property()],B.prototype,"suggestionCount",void 0),e.__decorate([y.property({readOnly:!0})],B.prototype,"suggestions",void 0),e.__decorate([y.property()],B.prototype,"suggestionsEnabled",void 0),e.__decorate([y.property({readOnly:!0})],B.prototype,"updating",null),e.__decorate([y.property()],B.prototype,"view",void 0),e.__decorate([y.property()],B.prototype,"clear",null),B=e.__decorate([m.subclass("esri.widgets.Search.SearchViewModel")],B);return B}));
