/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../intl","../../../core/Error","../../../core/has","../../../core/lang","../../../core/Logger","../../../core/maybe","../../../core/unitUtils","../../../geometry/Polygon","../../../geometry/support/geometryUtils","../../../rest/support/FullTextSearch","../../../intl/substitute","../../../intl/date"],(function(e,t,r,i,n,l,o,s,u,a,c,d,f){"use strict";const g=/https?:\/\/services.*\.arcgis\.com/i,m=/(?:\{([^}]+)\})/g,p=()=>l.getLogger("esri.widgets.Search.support.layerSearchUtils");function y(e,t){const{exactMatch:i=!1,location:n,maxResults:l,spatialReference:o,source:u,sourceIndex:a,suggestResult:c,view:d}=e,{layer:f,filter:g,zoomScale:m}=u,y=d?.scale,h=x(u,d),I=t?.signal;return v(f).then((()=>{const e=f.popupTemplate;return e?e.getRequiredFields(f.fieldsIndex):null})).then((e=>{const{objectIdField:t,returnZ:x}=f,v=L(u);if(!E(f,v))throw p().error("invalid-field: displayField is invalid."),new r("getResults():invalid-field","displayField is invalid.");const M=e?.length?e:[v],j=u.outFields||M,C=F(j);j.includes(t)||C||j.push(t),f.floorInfo?.floorField&&j.push(f.floorInfo.floorField);if(!(C||R(f,j)))throw p().error("invalid-field: outField is invalid."),new r("getResults():invalid-field","outField is invalid.");const D=f.createQuery(),{orderByFields:A}=u;if(A&&(D.orderByFields=A),o){D.outSpatialReference=o;const e=1/s.getMetersPerUnitForSR(o);e&&(D.maxAllowableOffset=e)}const O="mesh"===f.geometryType||"multipatch"===f.geometryType,k=f.capabilities?.data?.supportsZ&&!O;if(D.returnZ=k&&!1!==x,D.returnGeometry=!0,D.multipatchOption=O?"xyFootprint":null,j&&(D.outFields=j),n)D.geometry=n;else if(c.key)D.objectIds=[c.key];else{const e=u.searchFields||[v];if(!R(f,e))throw p().error("invalid-field: search field is invalid."),new r("getResults():invalid-field","search field is invalid.");T(f)&&(D.num=l),h&&(D.geometry=h);const t=c.text?.trim();if(!t)return[];const n=c.text,{prefix:o="",suffix:s=""}=u,a=q(`${o}${n}${s}`);b(f)&&$(f,e)&&!i&&n&&(D.fullText=S({text:n,searchFields:e}));const d=N({searchTerm:a,layer:f,searchFields:e,filter:g,exactMatch:i,query:D,type:"search"});if(D.where=d,!w(D))return[]}return f.queryFeatures(D,{signal:I}).then((e=>Z(e,d,u,a,v,y,m)))}))}function h(e,t){const{source:i,spatialReference:n,view:l,suggestTerm:o,maxSuggestions:s,sourceIndex:u,exactMatch:a}=e,{layer:c,filter:d}=i,f=t?.signal,g=x(i,l);return v(c).then((()=>{if(!T(c))return[];const e=L(i),t=i.searchFields||[e],l=[];i.suggestionTemplate?i.suggestionTemplate.replaceAll(m,((e,t)=>(l.push(t),e))):l.push(e);const y=F(l);l.includes(c.objectIdField)||y||l.push(c.objectIdField);const h=E(c,e),x=y||R(c,l),v=R(c,t);if(!h)throw p().error("invalid-field: displayField is invalid."),new r("getSuggestions():invalid-field","displayField is invalid.");if(!x)throw p().error("invalid-field: outField is invalid."),new r("getSuggestions():invalid-field","outField is invalid.");if(!v)throw p().error("invalid-field: search field is invalid."),new r("getSuggestions():invalid-field","search field is invalid.");const I=c.createQuery(),{orderByFields:M}=i;M&&(I.orderByFields=M),I.outSpatialReference=n,I.returnGeometry=!1,I.num=s,I.outFields=l,g&&(I.geometry=g);if(!o.trim())return[];const{prefix:j="",suffix:C=""}=i,D=q(`${j}${o}${C}`);b(c)&&$(c,t)&&!a&&o&&(I.fullText=S({text:o,searchFields:t}));const A=N({searchTerm:D,layer:c,searchFields:t,filter:d,exactMatch:a,query:I,type:"suggest"});return I.where=A,w(I)?c.queryFeatures(I,{signal:f}).then((t=>U(t,i,u,e))):[]}))}function x(e,t){const{filter:r,withinViewEnabled:i}=e,n=t?.extent,l=r?.geometry;return l??(i&&n?n:void 0)}function F(e){return e&&e.includes("*")}async function v(e){e&&await e.load()}function w(e){return!(!e.fullText&&!e.where)}function $(e,t){const r=e?.indexes;if(!r||!t?.length)return!1;return r.filter((e=>"FullText"===e.indexType)).some((e=>{const r=e.fields?.split(",").map((e=>e.trim().toLowerCase()))||[];return t.every((e=>r.includes(e.toLowerCase())))}))}function S({text:e,searchFields:t}){return e.trim().split(" ").filter((e=>!!e.trim())).map((e=>new c({onFields:t,searchTerm:e,searchType:"prefix"})))}function b(e){return e?.capabilities?.query?.supportsFullTextSearch??!1}function T(e){return e?.capabilities?.query?.supportsPagination??!1}function I(e){return e?.fieldsIndex?.fields?.find((e=>"string"===e.type))?.name??""}function L(e){return e.displayField||e.layer.displayField||I(e.layer)}function R(e,t){return!(!e||!t?.length)&&t.every((t=>E(e,t)))}function E(e,t){return!!e.getField(t)}function M(e){for(let t=0;t<e.length;t++)if(e.charCodeAt(t)>255)return!0;return!1}function j({codedValues:e},t,r){return o.mappedFind(e??[],(e=>{const i=e.name,n=r?i:i.toLowerCase();return(r?t:t.toLowerCase())===n?e.code.toString():null}))??null}function q(e){return e.replaceAll("'","''")}function C(e,t){const r=t?.where;return r?`(${e}) AND (${r})`:e}function D({currentTerm:e,field:t,filter:r,exactMatch:i,url:n,type:l}){const o=t?.type,s=t?.name;if("string"===o||"date"===o||"global-id"===o){const t=g.test(n??""),o=t&&M(e)?"N":"";if(i&&"search"===l)return C(`${s} = ${o}'${e}'`,r);if(t){return C(`${s} LIKE ${o}${`'${e}%'`}`,r)}return C(`${`LOWER(${s})`} LIKE ${o}${`'${e.toLowerCase()}%'`}`,r)}if("oid"===o||"small-integer"===o||"integer"===o||"single"===o||"double"===o){const t=Number(e);return isNaN(t)?null:C(`${s} = ${t}`,r)}return C(`${s} = ${e}`,r)}function A(e,t){return e?` OR (${t})`:`(${t})`}function N({searchTerm:e,layer:t,searchFields:r,filter:n,exactMatch:l,query:o,type:s}){const{definitionExpression:u,url:a}=t;let c="";return!o.fullText&&e&&r&&r.forEach((r=>{const o=t.getField(r),u=t.getFieldDomain?.(r,{excludeImpliedDomains:i("esri-widget-legacy-field-domain-calculation")}),d=(u&&"coded-value"===u.type?j(u,e,l):null)||e||null;if(null!==d){const e=D({currentTerm:d,field:o,filter:n,exactMatch:l,url:a,type:s});e&&(c+=A(c,e))}})),u&&c?`(${u}) AND (${c})`:u||c}function O(e,t){let r=null;const{codedValues:i}=e;return i&&i.length&&i.some((e=>e.code===t&&(r=e.name,!0))),r}function k(e,t){return e[t]??e[Object.keys(e).find((e=>e.toLowerCase()===t.toLowerCase()))]}function B(e,t,r){const n=e.sourceLayer,{attributes:l}=e,o=n.getFieldDomain?.(r,{feature:e,excludeImpliedDomains:i("esri-widget-legacy-field-domain-calculation")});if(t)return d.substitute(t,l);if(r&&l){const e=n.getField(r),t=k(l,r);return null==t?"":o&&"coded-value"===o.type?O(o,t)??"":"date"===e?.type?f.formatDate(new Date(t)):"number"==typeof t?t.toString():"string"!=typeof t?"":t.trim()}return""}function P(e,t,r,i){const n=e.sourceLayer,{attributes:l}=e,{objectIdField:o}=n,s=o?l[o]:null;return{text:B(e,t.suggestionTemplate,i),key:s,sourceIndex:r}}function U(e,t,r,i){return e.features.map((e=>P(e,t,r,i)))}function G(e){return null!=e&&null!=e.minScale&&null!=e.maxScale}function V(e,t,r,i,l,o,s){const c=e.clone(),d=e.sourceLayer,f=d?.objectIdField,g=f?e.attributes[f]:null,m=B(e,r.searchTemplate,l);null!=o&&G(d)&&(d.minScale&&d.minScale<o?o=d.minScale:d.maxScale&&d.maxScale>o&&(o=d.maxScale));const p=c.geometry?a.createExtentFromGeometry(c.geometry,t??void 0,o??void 0):void 0,y="number"==typeof s&&p?a.scaleExtent(n.clone(p),t??void 0,s):p,h=e.clone();return null!=y&&(h.geometry=u.fromExtent(y)),{extent:y,target:h,feature:c,key:g,name:m,sourceIndex:i}}function Z(e,t,r,i,n,l,o){return e.features.map((e=>V(e,t,r,i,n,l,o)))}e.createFullTextSearchInfos=S,e.getResults=y,e.getSuggestions=h,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
