/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../intl","../core/has","../core/maybe","../core/reactiveUtils","../core/timeUtils","../core/accessorSupport/decorators/property","../core/Logger","../core/RandomLCG","../core/accessorSupport/decorators/subclass","../intl/substitute","./Slider","./Widget","./ShadowCast/css","./ShadowCast/ShadowCastState","./ShadowCast/ShadowCastViewModel","./ShadowCast/ShadowCastVisibleElements","./ShadowCast/ShadowVisualizationType","./ShadowCast/components/DiscreteConfigurator","./ShadowCast/components/DurationConfigurator","./ShadowCast/components/ShadowTooltip","./ShadowCast/components/ThresholdConfigurator","../chunks/componentsUtils","./support/globalCss","./support/Heading","./support/timeWidgetUtils","./support/TimezonePicker","./support/widgetUtils","./support/decorators/messageBundle","./support/jsxFactory","../intl/date"],(function(e,t,i,s,o,a,n,l,r,d,c,h,u,p,m,v,w,g,y,_,b,S,C,f,k,T,M,z,D,V,x,P){"use strict";var O;!function(e){e.Slider="slider"}(O||(O={}));const E={labelFormatFunction:M.formatSliderLabel,min:0,max:1439,steps:15,rangeLabelInputsEnabled:!1,visibleElements:{labels:!1,rangeLabels:!1},tickConfigs:[{mode:"position",values:[0,360,720,1080,1439],labelsVisible:!0,tickCreatedFunction:(e,t,i)=>M.onPrimaryTickCreated({tickElement:t,labelElement:i})},{mode:"position",values:[120,240,480,600,840,960,1200,1320],tickCreatedFunction:(e,t)=>M.onSecondaryTickCreated({tickElement:t})}]};let R=class extends p{constructor(e,t){super(e,t),this.viewModel=null,this.headingLevel=4,this.visibleElements=new g,this._defaultViewModel=null,this._timeSlider=new u({...E,container:document.createElement("div")}),this._tooltip=null,this._onTimezoneChange=e=>{this.viewModel.utcOffset=e},this._onDateChange=e=>{const t=e.target.valueAsDate;this.viewModel.date=Array.isArray(t)?t[0]:t},e?.viewModel||(this._defaultViewModel=new w({view:e?.view}),this.viewModel=this._defaultViewModel)}initialize(){this.addHandles([a.watch((()=>({viewModel:this.viewModel,slider:this._timeSlider})),(e=>this._connectTimeSlider(e)),a.syncAndInitial),a.watch((()=>({container:this.view?.surface,viewModel:this.viewModel,tooltipVisible:this.visibleElements.tooltip})),(({container:e,viewModel:t,tooltipVisible:i})=>{this._tooltip=o.destroyMaybe(this._tooltip),null!=e&&i&&(this._tooltip=new S.ShadowTooltip({viewModel:t,container:e}))}),a.syncAndInitial),a.watch((()=>({viewModel:this.viewModel,visible:this.visible})),(({viewModel:e,visible:t})=>e.setRunning(t)),a.syncAndInitial)])}destroy(){this._timeSlider=o.destroyMaybe(this._timeSlider),null!=this._defaultViewModel&&this.viewModel!==this._defaultViewModel&&this._defaultViewModel.destroy()}loadDependencies(){return f.loadCalciteComponents({"input-date-picker":()=>new Promise(((t,i)=>e(["../chunks/calcite-input-date-picker"],t,i))),option:()=>new Promise(((t,i)=>e(["../chunks/calcite-option"],t,i))),select:()=>new Promise(((t,i)=>e(["../chunks/calcite-select"],t,i)))})}render(){const{visibleElements:e,viewModel:t}=this,i=t.state===v.ShadowCastState.Disabled;return x.tsx("div",{class:this.classes(m.css.base,k.globalCss.widget,k.globalCss.panel,{[k.globalCss.widgetDisabled]:i}),key:this},this._renderTimeRangeSection(),e.visualizationOptions?this._renderVisualizationOptionsSection():null)}get view(){return this.viewModel?.view}set view(e){this.viewModel&&(this.viewModel.view=e)}get icon(){return"measure-building-height-shadow"}set icon(e){this._overrideIfSome("icon",e)}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}get testData(){}_connectTimeSlider({viewModel:e,slider:t}){if(this.removeHandles(O.Slider),null==t)return;const i=e=>n.convertTime(e,"milliseconds","minutes"),s=e=>n.convertTime(e,"minutes","milliseconds"),o=({index:t,value:i})=>{0===t?e.startTimeOfDay=s(i):e.endTimeOfDay=s(i)};this.addHandles([a.watch((()=>[e.startTimeOfDay,e.endTimeOfDay]),(e=>{t.values=e.map(i)}),a.syncAndInitial),t.on("thumb-change",o),t.on("thumb-drag",o),t.on("segment-drag",(()=>{[e.startTimeOfDay,e.endTimeOfDay]=t.values.map(s)}))],O.Slider)}_renderTimeRangeSection(){const{visibleElements:e}=this;return e.timeRangeSlider||e.datePicker?x.tsx("section",{class:m.css.timeRange,key:"time-range"},x.tsx(T.Heading,{level:this.headingLevel},this.messages.timeLabel),e.timeRangeSlider?this._renderTimeRange():null,e.datePicker?this._renderDatePicker():null):null}_renderTimeRange(){const{messages:e,viewModel:t,visibleElements:i}=this,{startTimeOfDay:s,endTimeOfDay:o}=t,[a,n]=[s,o].map((e=>P.formatDate(new Date(e),M.timeStringFormattingOptions)));return[x.tsx("div",{class:m.css.timeRangeIndicator,key:"time-range-indicator"},h.substitute(e.timeRange,{start:a,end:n}),i.timezone?x.tsx(z.TimezonePicker,{value:t.utcOffset,onChange:this._onTimezoneChange}):null),x.tsx("div",{afterCreate:this._timeSliderContainerAfterCreate,afterRemoved:this._timeSliderContainerAfterRemoved,bind:this,key:"time-slider-container"})]}_timeSliderContainerAfterCreate(e){const t=this._timeSlider?.container;t&&e.appendChild(t)}_timeSliderContainerAfterRemoved(e){const t=this._timeSlider?.container;t&&e.removeChild(t)}_renderDatePicker(){return x.tsx("div",{class:m.css.datePickerContainer,key:m.css.datePickerContainer},x.tsx("calcite-input-date-picker",{class:m.css.datePicker,"data-testid":"date-picker",key:m.css.datePicker,overlayPositioning:"fixed",placement:"bottom",valueAsDate:this.viewModel.date,onCalciteInputDatePickerChange:this._onDateChange}))}_renderVisualizationOptionsSection(){const{headingLevel:e,messages:t,viewModel:i,visibleElements:s}=this,o=s.colorPicker,a=e=>this.classes(i.visualizationType===e?null:m.css.visualizationConfigHidden);return x.tsx("section",{class:m.css.visualization,key:"visualization"},x.tsx(T.Heading,{level:e},t.visualizationLabel),this._renderVisualizationSelect(),x.tsx("div",{class:a(y.ShadowVisualizationType.Threshold),key:"threshold-configurator"},x.tsx(C.ThresholdConfigurator,{colorPickerVisible:o,options:i.thresholdOptions})),x.tsx("div",{class:a(y.ShadowVisualizationType.Duration),key:"duration-configurator"},x.tsx(b.DurationConfigurator,{colorPickerVisible:o,options:i.durationOptions})),x.tsx("div",{class:a(y.ShadowVisualizationType.Discrete),key:"discrete-configurator"},x.tsx(_.DiscreteConfigurator,{colorPickerVisible:o,options:i.discreteOptions})))}_renderVisualizationSelect(){const e=this.messages,t=this.viewModel.visualizationType;return x.tsx("calcite-select",{bind:this,class:m.css.visualizationSelect,key:"visualization-select",label:e.visualizationLabel,onCalciteSelectChange:this._onVisualizationTypeChange},[{type:y.ShadowVisualizationType.Threshold,label:e.threshold.label},{type:y.ShadowVisualizationType.Duration,label:e.duration.label},{type:y.ShadowVisualizationType.Discrete,label:e.discrete.label}].map((({type:e,label:i})=>x.tsx("calcite-option",{selected:e===t,value:e},i))))}_onVisualizationTypeChange(e){const t=e.target.selectedOption?.value;this.viewModel.visualizationType=t??y.ShadowVisualizationType.Threshold}};t.__decorate([l.property()],R.prototype,"viewModel",void 0),t.__decorate([l.property()],R.prototype,"view",null),t.__decorate([l.property()],R.prototype,"headingLevel",void 0),t.__decorate([l.property()],R.prototype,"icon",null),t.__decorate([l.property()],R.prototype,"label",null),t.__decorate([l.property({type:g,nonNullable:!0})],R.prototype,"visibleElements",void 0),t.__decorate([l.property(),V.messageBundle("esri/widgets/ShadowCast/t9n/ShadowCast")],R.prototype,"messages",void 0),t.__decorate([l.property()],R.prototype,"_defaultViewModel",void 0),t.__decorate([l.property()],R.prototype,"_timeSlider",void 0),t.__decorate([l.property()],R.prototype,"_tooltip",void 0),R=t.__decorate([c.subclass("esri.widgets.ShadowCast")],R);return R}));
