/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../Color","../../core/Accessor","../../core/arrayUtils","../../core/asyncUtils","../../core/has","../../core/maybe","../../core/promiseUtils","../../core/reactiveUtils","../../core/screenUtils","../../core/timeUtils","../../core/accessorSupport/decorators/property","../../core/Logger","../../core/accessorSupport/decorators/subclass","../../core/libs/gl-matrix-2/factories/vec3f64","../../views/3d/support/earthUtils","../../views/3d/support/sunUtils","../../views/3d/webgl-engine/shaders/ShadowCastVisualizeTechniqueConfiguration","./DiscreteOptions","./DurationMode","./DurationOptions","./ShadowCastState","./ShadowTooltipViewModel","./ShadowVisualizationType","./ThresholdOptions","../support/traversalUtils"],(function(e,t,r,i,o,s,a,n,l,d,p,c,u,h,_,y,f,w,v,g,m,T,D,b,O,P){"use strict";const z=[],C=_.create(),S=[],V=255,U=p.convertTime(1,"hours","milliseconds"),A=500;let E=class extends r{constructor(e){super(e),this.view=null,this.tooltip=new D.ShadowTooltipViewModel({getDuration:(e,t)=>this.getDuration(e,t)}),this.startTimeOfDay=p.convertTime(10,"hours","milliseconds"),this.endTimeOfDay=p.convertTime(16,"hours","milliseconds"),this.visualizationType=b.ShadowVisualizationType.Threshold,this.thresholdOptions=new O,this.durationOptions=new m,this.discreteOptions=new v,this._running=!0,this._stopPreviewingTask=null,this._forcePreview=!1,this._autoRestoreForcePreviewEnabled=!0,this._utcOffset=null,this.date=new Date}initialize(){this.addHandles([l.watch((()=>({view:this.view,tooltipEnabled:this._tooltipEnabled})),(({view:e,tooltipEnabled:t})=>{this.tooltip.view=e,this.tooltip.enabled=t}),l.syncAndInitial),l.watch((()=>this._forcePreviewDependencies),(()=>{a.abortMaybe(this._stopPreviewingTask),this._forcePreview=!0,this._autoRestoreForcePreviewEnabled&&(this._stopPreviewingTask=o.createTask((async e=>{await n.after(A,e),n.throwIfAborted(e),this._forcePreview=!1})))}),l.syncAndInitial),l.watch((()=>({renderer:this.renderer,parameters:this._visualizationParameters})),(e=>R(e.renderer,e.parameters)),l.syncAndInitial),l.watch((()=>({renderer:this.renderer,parameters:{lightDirections:this._lightDirections}})),(e=>R(e.renderer,e.parameters)),l.syncAndInitial),l.watch((()=>({renderer:this.renderer,parameters:{enabled:this._running}})),(e=>R(e.renderer,e.parameters)),l.syncAndInitial),l.watch((()=>({renderer:this.renderer,parameters:{previewing:this._previewing}})),(e=>R(e.renderer,e.parameters)),l.syncAndInitial)])}destroy(){this.stop(),R(this.renderer,{enabled:!1}),a.destroyMaybe(this.tooltip)}get state(){return null!=this.view&&this.view.ready&&null!=this._referencePosition?T.ShadowCastState.Ready:T.ShadowCastState.Disabled}set date(e){const t=new Date(e);t.setHours(0,0,0,0),this._set("date",t)}get utcOffset(){return this._utcOffset??this._utcOffsetAuto}set utcOffset(e){this._utcOffset=e}get testData(){}get _previewing(){const{view:e}=this;return null==e?.allLayerViews||(this._forcePreview||!e.stationary||e.allLayerViews.some((e=>M(e)&&e.updating)))}get _utcOffsetAuto(){const e=this._referencePosition;return null!=e?y.longitudeToTimezone(e[0],!1):0}get _dateUTCOffset(){let e=this.date;return e=p.offsetDateUTC(e,-e.getTimezoneOffset(),"minutes"),e=p.offsetDateUTC(e,-this.utcOffset,"hours"),e}get _startDateTimeUTC(){return p.offsetDateUTC(this._dateUTCOffset,this.startTimeOfDay)}get _endDateTimeUTC(){return p.offsetDateUTC(this._dateUTCOffset,this.endTimeOfDay)}get _referencePosition(){return this.view?.environmentManager?.referencePositionGeographic}get _interval(){const e=this._duration>0?Math.floor(this._duration/V):V,t=this.discreteOptions.interval;switch(this.visualizationType){case b.ShadowVisualizationType.Threshold:case b.ShadowVisualizationType.Duration:return e;case b.ShadowVisualizationType.Discrete:return t>0?t:e}}get _sampleCount(){return this._lightDirections.length}get _duration(){return this.endTimeOfDay-this.startTimeOfDay}get _lightDirections(){const{view:e}=this;if(null==e)return z;const t="global"===e.viewingMode?C:this._referencePosition;if(null==t)return z;const r=this._interval,i=f.computeDirectionsOverTime(this._startDateTimeUTC,this._endDateTimeUTC,r,t,e.state.viewingMode),o=i.length;S.length=0;const s=P.breadthFirstBinaryPartitioning(0,o,S),a=new Array(o);for(let n=0;n<o;++n)a[n]=i[s[n]];return a}get _tooltipEnabled(){return this.state===T.ShadowCastState.Ready&&this.visualizationType!==b.ShadowVisualizationType.Discrete&&this._running&&!this._previewing}get _visualizationParameters(){if(!this._running)return null;switch(this.visualizationType){case b.ShadowVisualizationType.Threshold:return this._thresholdVisualizationParameters;case b.ShadowVisualizationType.Duration:return this._durationVisualizationParameters;case b.ShadowVisualizationType.Discrete:return this._discreteVisualizationParameters}}get _thresholdVisualizationParameters(){const{value:e,color:r}=this.thresholdOptions,i=this._duration;return{visualization:w.ShadowCastVisualization.Threshold,color:t.toUnitRGBA(r),threshold:i>0?e/this._duration:0}}get _durationVisualizationParameters(){const{color:e,mode:r}=this.durationOptions,i=this._duration,o=i>0&&r===g.DurationMode.Hourly?U/i:0;return{color:t.toUnitRGBA(e),visualization:w.ShadowCastVisualization.Gradient,bandsEnabled:o>0,bandSize:o}}get _discreteVisualizationParameters(){return{color:t.toUnitRGBA(this.discreteOptions.color),visualization:w.ShadowCastVisualization.Gradient,bandsEnabled:!1,bandSize:0}}get _forcePreviewDependencies(){const{view:e}=this;if(null==e)return null;const t=e.slicePlane,r=e.allLayerViews.toArray().filter(M),o=r.map((e=>e.layer)).filter(i.isSome),s=r.map((e=>e.visible)),a=o.map((e=>e.visible)),n=o.map((e=>e.opacity)),l=o.filter((e=>"definitionExpression"in e)).map((e=>e.definitionExpression)),d=r.filter((e=>"filter"in e)).map((e=>e.filter));return{slicePlane:t,startDateUTC:this._startDateTimeUTC,endDateUTC:this._endDateTimeUTC,layerViewVisibilities:s,layerVisibilities:a,layerOpacities:n,filters:d,definitionExpressions:l}}get renderer(){const{view:e}=this;if(null==e)return null;const t=e._stage;return null==t?null:t.renderer}start(){this.setRunning(!0)}stop(){this.setRunning(!1)}setRunning(e){this._running=e}async getDuration(e,t){const{view:r,renderer:i}=this;if(null==r||null==i)return 0;const o=r.state.camera.screenToRender(d.createScreenPointArray(e.x,e.y),d.createRenderScreenPointArray()),s=i.readAccumulatedShadow(o),a=this._sampleCount;if(0===a)return 0;return s*a*(this._duration/a)}};function R(e,t){null!=e&&null!=t&&e.setParameters({shadowCast:t})}function M(e){if(e.suspended)return!1;switch(e.type){case"building-scene-3d":case"csv-3d":case"elevation-3d":case"feature-3d":case"geojson-3d":case"graphics-3d":case"integrated-mesh-3d":case"integrated-mesh-3dtiles":case"ogc-feature-3d":case"route-3d":case"scene-layer-3d":case"scene-layer-graphics-3d":case"stream-3d":case"wms-3d":return!0;case"base-dynamic-3d":case"catalog-3d":case"catalog-footprint-3d":case"catalog-dynamic-group-3d":case"dimension-3d":case"imagery-3d":case"imagery-tile-3d":case"line-of-sight-3d":case"focusArea-3d":case"map-image-3d":case"point-cloud-3d":case"tile-3d":case"vector-tile-3d":case"viewshed-3d":case"voxel-3d":case"wfs-3d":case"wmts-3d":case"media-3d":default:return!1;case"group":return e.layerViews.toArray().some((e=>M(e)))}}e.__decorate([c.property()],E.prototype,"state",null),e.__decorate([c.property()],E.prototype,"view",void 0),e.__decorate([c.property()],E.prototype,"tooltip",void 0),e.__decorate([c.property({nonNullable:!0})],E.prototype,"date",null),e.__decorate([c.property({nonNullable:!0})],E.prototype,"utcOffset",null),e.__decorate([c.property({nonNullable:!0})],E.prototype,"startTimeOfDay",void 0),e.__decorate([c.property({nonNullable:!0})],E.prototype,"endTimeOfDay",void 0),e.__decorate([c.property({nonNullable:!0})],E.prototype,"visualizationType",void 0),e.__decorate([c.property({type:O,nonNullable:!0})],E.prototype,"thresholdOptions",void 0),e.__decorate([c.property({type:m,nonNullable:!0})],E.prototype,"durationOptions",void 0),e.__decorate([c.property({type:v,nonNullable:!0})],E.prototype,"discreteOptions",void 0),e.__decorate([c.property()],E.prototype,"_running",void 0),e.__decorate([c.property()],E.prototype,"_stopPreviewingTask",void 0),e.__decorate([c.property()],E.prototype,"_forcePreview",void 0),e.__decorate([c.property()],E.prototype,"_autoRestoreForcePreviewEnabled",void 0),e.__decorate([c.property()],E.prototype,"_previewing",null),e.__decorate([c.property()],E.prototype,"_utcOffset",void 0),e.__decorate([c.property()],E.prototype,"_utcOffsetAuto",null),e.__decorate([c.property()],E.prototype,"_dateUTCOffset",null),e.__decorate([c.property()],E.prototype,"_startDateTimeUTC",null),e.__decorate([c.property()],E.prototype,"_endDateTimeUTC",null),e.__decorate([c.property()],E.prototype,"_referencePosition",null),e.__decorate([c.property()],E.prototype,"_interval",null),e.__decorate([c.property()],E.prototype,"_sampleCount",null),e.__decorate([c.property()],E.prototype,"_duration",null),e.__decorate([c.property()],E.prototype,"_lightDirections",null),e.__decorate([c.property()],E.prototype,"_tooltipEnabled",null),e.__decorate([c.property()],E.prototype,"_visualizationParameters",null),e.__decorate([c.property()],E.prototype,"_thresholdVisualizationParameters",null),e.__decorate([c.property()],E.prototype,"_durationVisualizationParameters",null),e.__decorate([c.property()],E.prototype,"_discreteVisualizationParameters",null),e.__decorate([c.property()],E.prototype,"_forcePreviewDependencies",null),e.__decorate([c.property()],E.prototype,"renderer",null),E=e.__decorate([h.subclass("esri.widgets.ShadowCast.ShadowCastViewModel")],E);return E}));
