/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../intl","../core/handleUtils","../core/maybe","../core/promiseUtils","../core/reactiveUtils","../core/accessorSupport/decorators/property","../core/has","../core/Logger","../core/RandomLCG","../core/accessorSupport/decorators/subclass","../views/interactive/sketch/SketchValueOptions","./Widget","./Sketch/SketchViewModel","./Sketch/VisibleElements","../chunks/componentsUtils","./support/globalCss","./support/SelectionToolbar","./support/SketchTooltipControls","./support/SnappingControls","./support/widgetUtils","./support/decorators/messageBundle","./support/decorators/vmEvent","./support/jsxFactory","../intl/substitute"],(function(e,t,o,i,s,n,l,r,a,c,d,p,u,h,_,v,g,y,m,b,w,T,C,f,M,O){"use strict";const x="esri-sketch",S={base:x,verticalLayout:`${x}--vertical`,horizontalLayout:`${x}--horizontal`,panel:`${x}__panel`,infoPanel:`${x}__info-panel`,section:`${x}__section`,toolSection:`${x}__tool-section`,infoSection:`${x}__info-section`,infoCountSection:`${x}__info-count-section`,menuContainer:`${x}__menu-container`,menuHeader:`${x}__menu-header`,menuTitle:`${x}__menu-title`,featureCountBadge:`${x}__feature-count-badge`,featureCountText:`${x}__feature-count-text`,featureCountNumber:`${x}__feature-count-number`,actionToggle:`${x}__action-toggle`,actionToggleOn:`${x}__action-toggle--on`,actionTitle:`${x}__item-action-title`,actionIcon:`${x}__item-action-icon`};let k=class extends h{constructor(e,t){super(e,t),this._activeCustomToolOptions=null,this._activeCreateOptions=null,this._menuOpen=!1,this._selectionToolbar=null,this._viewModelHandlesGroup=null,this.availableCreateTools=["point","polyline","polygon","rectangle","circle"],this.creationMode="continuous",this.customToolOptions=null,this.layout="horizontal",this.messages=null,this.messagesCommon=null,this.visibleElements=new v,this._activateCreateTool=this._activateCreateTool.bind(this),this.viewModel=e?.viewModel||new _}initialize(){const{layer:e,view:t}=this,o=new m({view:"2d"===t?.type?t:null,sources:e?[e]:null});this.addHandles([l.watch((()=>this.viewModel),(e=>{this._viewModelHandlesGroup=s.removeMaybe(this._viewModelHandlesGroup),e&&(this._viewModelHandlesGroup=i.handlesGroup([e.on("create",(e=>{this.scheduleRender(),this._onCreateOperation(e)})),e.on("update",(()=>this.scheduleRender())),e.on("delete",(e=>this.emit("delete",e))),e.on("undo",(()=>this.scheduleRender())),e.on("redo",(()=>this.scheduleRender())),l.watch((()=>e.layer),(e=>{this._selectionToolbar&&(this._selectionToolbar.sources=e?[e]:null)})),l.watch((()=>e.view),(e=>{this._selectionToolbar&&(this._selectionToolbar.view="2d"===e?.type?e:null)})),l.watch((()=>e.state),(()=>this.notifyChange("state")))]))}),l.syncAndInitial),l.when((()=>o.activeToolInfo),(()=>this.viewModel.cancel())),o.on("complete",(e=>this._onSelectionOperationComplete(e))),l.watch((()=>{const{selectionTools:e}=this.visibleElements;return{lassoTool:!!e?.["lasso-selection"],rectangleTool:!!e?.["rectangle-selection"]}}),(e=>{Object.assign(o.visibleElements,e)}),l.syncAndInitial)]),this._selectionToolbar=o}loadDependencies(){return g.loadCalciteComponents({action:()=>new Promise(((t,o)=>e(["../chunks/calcite-action"],t,o))),icon:()=>new Promise(((t,o)=>e(["../chunks/calcite-icon"],t,o)))})}destroy(){this._selectionToolbar?.destroy(),this._viewModelHandlesGroup=s.removeMaybe(this._viewModelHandlesGroup)}get activeTool(){const e=this._selectionToolbar?.activeToolInfo;if(e)switch(e.toolName){case"lasso":return"lasso-selection";case"rectangle":return"rectangle-selection";case"default":return"custom-selection"}return this.viewModel.activeTool}get activeTooltip(){return this.viewModel.activeTooltip}get createGraphic(){return this.viewModel.createGraphic}get defaultCreateOptions(){return this.viewModel.defaultCreateOptions}set defaultCreateOptions(e){this.viewModel.defaultCreateOptions=e}get defaultUpdateOptions(){return this.viewModel.defaultUpdateOptions}set defaultUpdateOptions(e){this.viewModel.defaultUpdateOptions=e}get icon(){return"pencil"}set icon(e){this._overrideIfSome("icon",e)}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}get labelOptions(){return this.viewModel.labelOptions}set labelOptions(e){this.viewModel.labelOptions=e}get layer(){return this.viewModel.layer}set layer(e){this.viewModel.layer=e}get snappingOptions(){return this.viewModel.snappingOptions}set snappingOptions(e){this.viewModel.snappingOptions=e}get state(){return this._selectionToolbar?.activeToolInfo?"active":this.viewModel.state}get tooltipOptions(){return this.viewModel.tooltipOptions}set tooltipOptions(e){this.viewModel.tooltipOptions=e}get updateGraphics(){return this.viewModel.updateGraphics}get valueOptions(){return this.viewModel.valueOptions}set valueOptions(e){this.viewModel.valueOptions=e}get view(){return this.viewModel.view}set view(e){this.viewModel.view=e}set viewModel(e){const t=this._get("viewModel");e!==t&&(t&&s.destroyMaybe(t),this._set("viewModel",e))}get _effectiveAvailableCreateTools(){const{availableCreateTools:e,visibleElements:t}=this;return e?.filter((e=>!!t.createTools?.[e]))}create(e,t,o){const i=o?.createOptions??t;return this._activeCreateOptions=i||null,this._activeCustomToolOptions=o,n.ignoreAbortErrors(this.viewModel.create(e,i))}update(e,t){return n.ignoreAbortErrors(this.viewModel.update(e,t))}complete(){this.viewModel.complete()}cancel(){this._selectionToolbar?.cancel(),this.viewModel.cancel(),this._activeCustomToolOptions=null}undo(){this.viewModel.undo(),this.view?.focus()}redo(){this.viewModel.redo(),this.view?.focus()}delete(){this.viewModel.delete()}duplicate(){return this.viewModel.duplicate()}render(){const{label:e,layout:t,viewModel:{state:o}}=this;return M.tsx("div",{"aria-label":e,class:this.classes(S.base,y.globalCss.widget,{[y.globalCss.disabled]:"disabled"===o,[S.verticalLayout]:"vertical"===t,[S.horizontalLayout]:"horizontal"===t})},M.tsx("div",{class:S.panel,role:"toolbar"},this._renderTopPanelContents()),M.tsx("div",{class:this.classes(S.panel,S.infoPanel)},this._renderInfoPanelContents()))}_renderTopPanelContents(){const e=this.classes(S.section,S.toolSection),{_effectiveAvailableCreateTools:t,customToolOptions:o,visibleElements:i,viewModel:s}=this,n=s.updateOnGraphicClick||this._selectionToolbar?.visibleToolCount,l=!(!t?.length&&!o?.length);return[n?M.tsx("div",{class:e,key:"selection-button-container",role:"menu"},this._renderDefaultSelectionButton(),this._renderSelectionToolbar()):null,l?M.tsx("div",{class:e,role:"menu"},this._renderDrawActions(),this._renderCustomToolActions()):null,i.undoRedoMenu?M.tsx("div",{class:e,key:"undo-redo-menu-button-container",role:"menu"},this._renderUndoRedoMenuButtons()):null,i.settingsMenu?M.tsx("div",{class:S.section,key:"settings-menu-button-container"},this._renderSettingsMenuButton()):null]}_renderInfoPanelContents(){return this._menuOpen?this._renderSettingsMenu():this.updateGraphics.length?[M.tsx("div",{class:this.classes(S.section,S.infoSection,S.infoCountSection),key:"feature-count-container"},this._renderFeatureCount()),M.tsx("div",{class:this.classes(S.section,S.infoSection),key:"delete-button-container"},this._renderDuplicateButton(),this._renderDeleteButton())]:void 0}_renderSettingsMenu(){const{messagesCommon:e,snappingOptions:t,view:o,viewModel:i,visibleElements:s}=this,n={directionModePicker:s.directionModePicker,labelsToggle:s.labelsToggle,tooltipsToggle:s.tooltipsToggle};return M.tsx("div",{class:S.menuContainer,"data-testid":"menu",key:"settings-menu-container",role:"menu"},M.tsx("header",{class:S.menuHeader,key:"settings-menu-header"},M.tsx("span",{class:S.menuTitle},e.settings)),Object.values(n).includes(!0)?M.tsx(b,{sketchOptions:i.sketchOptions,viewType:o?.type,visibleElements:n}):void 0,s.snappingControls&&o&&t?M.tsx(w,{snappingManager:this.viewModel.snappingManager,snappingOptions:t,view:o,visibleElements:s.snappingControlsElements}):void 0)}_renderFeatureCount(){const{layout:e,messages:t,updateGraphics:{length:o}}=this,i=O.substitute(t.selectedCount,{count:o});return M.tsx("div",{"aria-label":i,class:S.featureCountBadge},M.tsx("span",{class:S.featureCountNumber},"vertical"===e?o:i))}_renderDuplicateButton(){if(!this.visibleElements.duplicateButton)return;const e=this.messages,t=this.updateGraphics.length>1?e.duplicateFeatures:e.duplicateFeature;return M.tsx("calcite-action",{bind:this,onclick:this._onDuplicateSelect,scale:"s",text:t,title:t},M.tsx("calcite-icon",{icon:"copy",scale:"s"}))}_renderDeleteButton(){const e=this.messages,t=this.updateGraphics.length>1?e.deleteFeatures:e.deleteFeature;return M.tsx("calcite-action",{bind:this,onclick:this.delete,scale:"s",text:t,title:t},M.tsx("calcite-icon",{icon:"trash",scale:"s"}))}_renderDefaultSelectionButton(){if(!this.viewModel.updateOnGraphicClick)return;const{messages:e,state:t}=this,o=e.selectFeature;return M.tsx("calcite-action",{active:"ready"===t,bind:this,disabled:"disabled"===t,onclick:this._activateDefaultSelectTool,scale:"s",text:o,title:o},M.tsx("calcite-icon",{icon:"cursor",scale:"s"}))}_renderSelectionToolbar(){if("2d"===this.view?.type&&this._selectionToolbar)return this._selectionToolbar.render()}_renderDrawActions(){const{messages:e}=this;return this._effectiveAvailableCreateTools?.map((t=>{switch(t){case"point":return this._renderAction(t,e.drawPoint,"pin");case"polyline":return this._renderAction(t,e.drawPolyline,"line");case"polygon":return this._renderAction(t,e.drawPolygon,"polygon");case"rectangle":return this._renderAction(t,e.drawRectangle,"rectangle");case"circle":return this._renderAction(t,e.drawCircle,"circle");default:return}}))}_renderCustomToolActions(){return this.customToolOptions?.map((e=>this._renderCustomToolAction(e)))}_renderCustomToolAction(e){const{icon:t,label:o,toolKey:i,toolName:s}=e;return M.tsx("calcite-action",{active:this._activeCustomToolOptions?.toolKey===i,bind:this,disabled:"disabled"===this.state,onclick:()=>this._activateCreateTool(s,null,e),scale:"s",text:o,title:o},M.tsx("calcite-icon",{icon:t,scale:"s"}))}_renderAction(e,t,o){return M.tsx("calcite-action",{active:this.activeTool===e&&!this._activeCustomToolOptions,bind:this,disabled:"disabled"===this.state,onclick:()=>this._activateCreateTool(e),scale:"s",text:t,title:t},M.tsx("calcite-icon",{icon:o,scale:"s"}))}_renderUndoRedoMenuButtons(){return[this._renderUndoButton(),this._renderRedoButton()]}_renderUndoButton(){const e=this.messages.undo;return M.tsx("calcite-action",{bind:this,disabled:!this.viewModel.canUndo()||"disabled"===this.state,onclick:this.undo,scale:"s",text:e,title:e},M.tsx("calcite-icon",{icon:T.isRTL(this.container)?"redo":"undo",scale:"s"}))}_renderRedoButton(){const e=this.messages.redo;return M.tsx("calcite-action",{bind:this,disabled:!this.viewModel.canRedo()||"disabled"===this.state,onclick:this.redo,scale:"s",text:e,title:e},M.tsx("calcite-icon",{icon:T.isRTL(this.container)?"undo":"redo",scale:"s"}))}_renderSettingsMenuButton(){const e=this.messagesCommon.settings;return M.tsx("calcite-action",{active:this._menuOpen,bind:this,"data-testid":"settings-menu-action",disabled:"disabled"===this.state,onclick:this._toggleMenu,scale:"s",text:e,title:e},M.tsx("calcite-icon",{icon:"gear",scale:"s"}))}_activateCreateTool(e,t,o){const i=this._activeCustomToolOptions;if(o||i){if(o?.toolKey===i?.toolKey)return void this.cancel()}else if(this.activeTool===e)return void this.cancel();this._selectionToolbar?.cancel(),this.create(e,t,o)}_onCreateOperation(e){if("complete"!==e.state)return;const{creationMode:t}=this,{type:o}=e;if("create"===o){const{tool:o,graphic:i}=e,s=this._activeCreateOptions;this._activeCreateOptions=null,"continuous"===t?this.create(o,s,this._activeCustomToolOptions):(this._activeCustomToolOptions=null,"update"===t&&this.update([i]))}}_toggleMenu(){this._menuOpen=!this._menuOpen,this.scheduleRender()}_onDuplicateSelect(){const e=this.duplicate(),t=this.viewModel.activeTool;"transform"!==t&&"reshape"!==t||this.update(e,{tool:t})}_onSelectionOperationComplete(e){const{viewModel:{defaultUpdateOptions:t}}=this,{selection:o}=e;if(!e.aborted&&o.length){const e=t.tool,i=o.length>1&&"reshape"===e?"transform":e;this.update(o,{...t,tool:i})}this.notifyChange("state")}_activateDefaultSelectTool(){this.cancel(),this.view?.focus()}};t.__decorate([r.property()],k.prototype,"_activeCustomToolOptions",void 0),t.__decorate([r.property()],k.prototype,"_activeCreateOptions",void 0),t.__decorate([r.property()],k.prototype,"activeTool",null),t.__decorate([r.property({readOnly:!0})],k.prototype,"activeTooltip",null),t.__decorate([r.property({cast:e=>{if(!e?.length)return null;const t=new Set(["point","polyline","polygon","rectangle","circle"]);return e.filter((e=>t.has(e)))}})],k.prototype,"availableCreateTools",void 0),t.__decorate([r.property({readOnly:!0})],k.prototype,"createGraphic",null),t.__decorate([r.property()],k.prototype,"creationMode",void 0),t.__decorate([r.property()],k.prototype,"customToolOptions",void 0),t.__decorate([r.property()],k.prototype,"defaultCreateOptions",null),t.__decorate([r.property()],k.prototype,"defaultUpdateOptions",null),t.__decorate([r.property()],k.prototype,"icon",null),t.__decorate([r.property()],k.prototype,"label",null),t.__decorate([r.property()],k.prototype,"labelOptions",null),t.__decorate([r.property()],k.prototype,"layer",null),t.__decorate([r.property({type:["horizontal","vertical"]})],k.prototype,"layout",void 0),t.__decorate([r.property(),C.messageBundle("esri/widgets/Sketch/t9n/Sketch")],k.prototype,"messages",void 0),t.__decorate([r.property(),C.messageBundle("esri/t9n/common")],k.prototype,"messagesCommon",void 0),t.__decorate([r.property()],k.prototype,"snappingOptions",null),t.__decorate([r.property()],k.prototype,"state",null),t.__decorate([r.property()],k.prototype,"tooltipOptions",null),t.__decorate([r.property({readOnly:!0})],k.prototype,"updateGraphics",null),t.__decorate([r.property({type:u,nonNullable:!0})],k.prototype,"valueOptions",null),t.__decorate([r.property()],k.prototype,"view",null),t.__decorate([r.property(),f.vmEvent(["create","update","undo","redo"])],k.prototype,"viewModel",null),t.__decorate([r.property({type:v,nonNullable:!0})],k.prototype,"visibleElements",void 0),t.__decorate([r.property()],k.prototype,"_effectiveAvailableCreateTools",null),k=t.__decorate([p.subclass("esri.widgets.Sketch")],k);return k}));
