/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../../chunks/tslib.es6","../../symbols","../../core/Collection","../../core/Error","../../core/Evented","../../core/handleUtils","../../core/has","../../core/Logger","../../core/maybe","../../core/promiseUtils","../../core/reactiveUtils","../../core/accessorSupport/decorators/property","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../../geometry/ellipsoidUtils","../../geometry/projection","../../geometry/support/coordsUtils","../../geometry/support/spatialReferenceUtils","../../layers/GraphicsLayer","../../layers/support/layerUtils","../../views/3d/interactive/editingTools/isSupportedObjectUtils","../../views/3d/interactive/editingTools/move/isSupportedObject","../../views/3d/interactive/editingTools/reshape/isSupportedObject","../../views/3d/interactive/editingTools/transform/isSupportedGraphic","../../views/draw/support/layerUtils","../../views/input/InputManager","../../views/interactive/keybindings","../../views/interactive/sketch/SketchLabelOptions","../../views/interactive/sketch/SketchOptions","../../views/interactive/sketch/SketchTooltipOptions","../../views/interactive/sketch/SketchValueOptions","../../views/interactive/snapping/SnappingManager","../../views/interactive/snapping/SnappingOptions","../../views/interactive/snapping/snappingUtils","../../views/support/hitTestSelectUtils","../../views/support/screenUtils","./support/OperationHandle","../../symbols/SimpleMarkerSymbol","../../symbols/SimpleFillSymbol","../../symbols/SimpleLineSymbol","../../symbols/MeshSymbol3D","../../symbols/FillSymbol3DLayer"],(function(e,t,o,i,a,r,s,n,p,l,c,h,d,u,y,v,g,m,_,b,w,f,O,G,T,E,S,k,M,A,C,H,R,P,D,I,U,x,V,L,j,K,F){"use strict";const W=e=>Object.freeze(Object.defineProperty({__proto__:null,default:e},Symbol.toStringTag,{value:"Module"})),Z={defaultZ:0},q={reshapeOptions:{edgeOperation:"split",shapeOperation:"move",vertexOperation:"move"},enableMoveAllGraphics:!0,enableRotation:!0,enableScaling:!0,multipleSelectionEnabled:!0,preserveAspectRatio:!1,toggleToolOnClick:!0,enableZ:!0,highlightOptions:{enabled:!0},tool:"transform"};let z=class extends r.EventedAccessor{constructor(e){super(e),this._numUpdating=0,this._defaultSnappingManager=null,this._internalGraphicsLayer=new b({listMode:"hide",internal:!0,title:"SVM Internal"}),this._operationHandle=null,this._viewHandlesKey="viewHandles",this.activeFillSymbol=null,this.activeLineSymbol=null,this.activeVertexSymbol=null,this.allowDeleteKey=!0,this.layer=null,this.pointSymbol=new V({style:"circle",size:6,color:[255,255,255],outline:{color:[50,50,50],width:1}}),this.polygonSymbol=new L({color:[150,150,150,.2],outline:{color:[50,50,50],width:2}}),this.polylineSymbol=new j({color:[130,130,130,1],width:2}),this.meshSymbol=new K({symbolLayers:new i([new F])}),this.updateGraphics=new i,this.updateOnGraphicClick=!0,this.vertexSymbol=new V({style:"circle",size:6,color:[255,255,255],outline:{color:[50,50,50],width:1}}),this.sketchOptions=new A,this._moduleLoaderAbortController=null,this._viewReadyAbortController=null,this._originalPopupEnabled=null,this.defaultCreateOptions=Z,this.defaultUpdateOptions=q,this.snappingOptions=e?.snappingManager?.options??e?.snappingOptions??new P}initialize(){this.addHandles([h.on((()=>this.view?.map?.layers),"change",(e=>{e.removed.includes(this.layer)&&this.cancel()})),h.on((()=>this.layer?.graphics),"change",(e=>{if(null!=this._operationHandle)for(const t of e.removed)this.updateGraphics.includes(t)&&(this.updateGraphics.length>1?this._operationHandle.removeFromSelection(t):this._operationHandle.cancel())})),h.watch((()=>this.layer?.elevationInfo??null),(e=>{e!==this._internalGraphicsLayer.elevationInfo&&(this.cancel(),this._internalGraphicsLayer.elevationInfo=e)}),h.syncAndInitial),h.watch((()=>this.view),(t=>{this._defaultSnappingManager=l.destroyMaybe(this._defaultSnappingManager),t&&(this.snappingManager||(this._defaultSnappingManager=new R.SnappingManager({view:t,options:this.snappingOptions})),"2d"===t.type?new Promise(((t,o)=>e(["../../views/2d/interactive/editingTools"],t,o))):"3d"===t.type&&(new Promise(((t,o)=>e(["../../views/3d/interactive/editingTools"],t,o))),new Promise(((t,o)=>e(["../../views/3d/layers/GraphicsLayerView3D"],(e=>t(W(e))),o)))))}),h.syncAndInitial),h.watch((()=>this.view?.spatialReference),((e,t)=>{e&&t&&!e.equals(t)&&this.cancel()}))]),D.setupSnappingToggleHandles(this)}destroy(){this.cancel(),this._removeDefaultLayer(),this._defaultSnappingManager=l.destroyMaybe(this._defaultSnappingManager),this._set("snappingManager",null),this._set("view",null),this.emit("destroy")}get updating(){return this._numUpdating>0||null!=this.snappingManager&&this.snappingManager.updating}get activeTool(){return this._operationHandle?.tool??null}get activeTooltip(){const{activeComponent:e,destroyed:t}=this,o=!t&&e&&"tooltip"in e?e.tooltip:null;return o?.visible?o:null}get activeComponent(){return this._operationHandle?.activeComponent??null}get createGraphic(){return null==this.activeComponent||"draw-3d"!==this.activeComponent.type&&"draw-2d"!==this.activeComponent.type?this._get("createGraphic"):this.activeComponent.graphic}get defaultCreateOptions(){return this._get("defaultCreateOptions")}set defaultCreateOptions(e){this._set("defaultCreateOptions",{...Z,...e})}get defaultUpdateOptions(){return this._get("defaultUpdateOptions")}set defaultUpdateOptions(e){this._set("defaultUpdateOptions",{...q,...e,reshapeOptions:{...q.reshapeOptions,...e?.reshapeOptions},highlightOptions:{...q.highlightOptions,...e?.highlightOptions}})}get labelOptions(){return this.sketchOptions.labels}set labelOptions(e){this.sketchOptions.labels=e}get snappingOptions(){return this.snappingManager?.options??this._get("snappingOptions")}set snappingOptions(e){null!=this._defaultSnappingManager&&(this._defaultSnappingManager.options=e),this._set("snappingOptions",e)}get snappingManager(){return this._isOverridden("snappingManager")&&this._get("snappingManager"),this._defaultSnappingManager}set snappingManager(e){if(e)this._isOverridden("snappingManager")||(this._defaultSnappingManager=l.destroyMaybe(this._defaultSnappingManager)),this._override("snappingManager",e);else{const{view:e}=this;!this._defaultSnappingManager&&e&&(this._defaultSnappingManager=new R.SnappingManager({options:this.snappingOptions,view:e})),this._clearOverride("snappingManager")}}get state(){const e=!(!this.view?.ready||!this.layer),t=this._operationHandle;return e&&t?"active":e?"ready":"disabled"}get tooltipOptions(){return this.sketchOptions.tooltips}set tooltipOptions(e){this.sketchOptions.tooltips=e}get valueOptions(){return this.sketchOptions.values}set valueOptions(e){this.sketchOptions.values=e}get view(){return this._get("view")}set view(e){const t=this._get("view");if(t){const{container:e,map:o}=t;e&&(t.cursor=null),o?.remove(this._internalGraphicsLayer),this.removeHandles(this._viewHandlesKey),this.cancel()}const o="view-ready";this.removeHandles(o),e&&this.addHandles(h.when((()=>e.ready),(t=>{this.removeHandles(this._viewHandlesKey),t&&this.addHandles(this._generateViewHandles(e),this._viewHandlesKey)}),h.syncAndInitial),o),this._set("view",e)}cancel(){this._moduleLoaderAbortController=l.abortMaybe(this._moduleLoaderAbortController),this._viewReadyAbortController=l.abortMaybe(this._viewReadyAbortController),this._operationHandle&&this._operationHandle.cancel()}complete(){this._operationHandle&&this._operationHandle.complete()}delete(){const{state:e,updateGraphics:t}=this;if("active"===e&&t.length){const{activeTool:e,layer:o}=this,i=t.toArray();o.removeMany(i),this.cancel(),this._emitDeleteEvent({graphics:i,tool:e})}}duplicate(){if("active"===this.state&&this.updateGraphics.length){const e=this.updateGraphics.map((e=>e.clone())).toArray();return this.layer.addMany(e),this.emit("duplicate",{graphics:e,type:"duplicate"}),e}return[]}async create(e,t){this.cancel(),await this._waitViewReady();const{view:o,layer:i}=this;if(!o||"disabled"===this.state)throw i||this._logMissingLayer(),c.createAbortError();if(null!=o.activeTool&&(o.activeTool=null),!e)return void this._logError("sketch:missing-parameter","Missing parameter 'tool'.");E.addUniqueLayer(o,this._internalGraphicsLayer);const a=await this._setupCreateOperation(e,t);if(null==a||this.destroyed)return void o.map.remove(this._internalGraphicsLayer);const r=()=>{if(a===this._operationHandle){const t=this.createGraphic,o=this._operationHandle.cancelled;this._operationHandle.destroy(),this._operationHandle=null,this._set("createGraphic",null),this.view?.map&&this.view.map.remove(this._internalGraphicsLayer),a.cancelled||null==t||i.add(t),this.emit("create",{graphic:t,state:o?"cancel":"complete",tool:e,toolEventInfo:null,type:"create"})}};a.on("complete",r),this._operationHandle=a,o.ready&&o.focus()}async place(e,t){return this.create("mesh",{mode:"click",hasZ:e.hasZ,geometryToPlace:e,...t})}async update(e,t){this.cancel(),await this._waitViewReady();const{layer:o,view:i,state:a}=this;if(!i||"disabled"===a)throw o||this._logMissingLayer(),c.createAbortError();null!=i.activeTool&&(i.activeTool=null);const r=Array.isArray(e)?e:[e];if(null==e||!r?.length)return void this._logError("sketch:missing-parameter","Missing parameter 'graphics'.");if(r.some((e=>e.layer!==o?(this._logError("sketch:invalid-parameter","Parameter 'graphics' contains one or more graphics missing from the supplied GraphicsLayer."),!0):null==e.geometry&&(this._logError("sketch:invalid-parameter","Parameter 'graphics' contains one or more graphics with an unsupported geometry."),!0))))return;const s=await this._setupUpdateOperation(r,t);this.destroyed||null==s||oe(s)||(E.addUniqueLayer(i,this._internalGraphicsLayer),this._setUpdateOperationHandle(s,t),this.emit("update",{graphics:r,state:"start",aborted:!1,tool:s.tool,toolEventInfo:null,type:"update"}))}async _updateSpatialReference(e){const t=this.view;if(t){this._beginAsyncOperation(),e=Array.isArray(e)?e:[e];for(const o of e)null==o.geometry||"mesh"===o.geometry.type||_.equals(o.geometry.spatialReference,t.spatialReference)||(g.canProjectWithoutEngine(o.geometry.spatialReference,t.spatialReference)||g.isLoaded()||await g.load(),o.geometry=g.project(o.geometry,t.spatialReference));this._endAsyncOperation()}else this._logMissingView()}undo(){this.canUndo()&&this._operationHandle?.undo()}redo(){this.canRedo()&&this._operationHandle?.redo()}canUndo(){return!!this._operationHandle?.canUndo()}canRedo(){return!!this._operationHandle?.canRedo()}toggleUpdateTool(){this._operationHandle?.toggleTool()}async _getFirstHit(e){const t=this.view;if(!t)return this._logMissingView(),null;if("2d"===t.type){const o=[];t.map.allLayers.forEach((e=>{"vector-tile"!==e.type&&"imagery"!==e.type||o.push(e)}));const i=await t.hitTest(e,{exclude:o});return I.findFirstGraphicHit(i.results)}const o=[t.map.ground];t.map.allLayers.forEach((e=>{w.isIntegratedMeshLayer(e.type)&&o.push(e)}));const i=await t.hitTest(e,{exclude:o});if(i.results.length>0){const e=i.results[0];if(null!=e&&"graphic"===e.type&&e.graphic&&(!i.ground.mapPoint||t.map.ground.opacity<1||i.ground.distance-(e.distance??0)>-Math.min(3*i.ground.distance,"global"===t.viewingMode?v.getReferenceEllipsoid(t.renderCoordsHelper.spatialReference).radius/t.renderCoordsHelper.unitInMeters:Number.POSITIVE_INFINITY)))return e}return null}_generateViewHandles(e){return[e.on("immediate-click",(async t=>{const o="active"===this.state&&"create"===this._operationHandle?.type;if("disabled"===this.state||o||!this.updateOnGraphicClick)return;this._beginAsyncOperation();const i=await t.async((()=>this._getFirstHit(U.createScreenPointFromEvent(t))));let a=null;if(null!=i){const o=i.graphic;this.updateGraphics.includes(o)||o.layer===this.layer?(t.stopPropagation(),a=o):"2d"!==e.type||this._isComponentGraphic(o)||"active"!==this.state||this.cancel()}else"active"===this.state&&this.cancel();null==a||this.updateGraphics.includes(a)||await this.update([a],{...this.defaultUpdateOptions,reshapeOptions:{...this.defaultUpdateOptions.reshapeOptions}}),this._endAsyncOperation()}),S.ViewEventPriorities.WIDGET)]}async _setupCreateOperation(e,t){const o=this.view;if(!o)return this._logMissingView(),null;const i={hasZ:"3d"===o.type,...this.defaultCreateOptions,...t},a=await this._setupDrawGraphicTool(e,o,i);return null==a?null:(o.tools.add(a),o.activeTool=a,this._setupCreateOperationHandle(a))}async _setupDrawGraphicTool(e,t,o){if("multipoint"===e&&"3d"===t.type)return this._logError("sketch:create","Multipoint geometries are not supported in SceneView."),null;if(!t)return this._logMissingView(),null;const{cursor:i,defaultZ:a,hasZ:r,geometryToPlace:s,graphicProperties:n,mode:p,preserveAspectRatio:l}=o,c="rectangle"===e||"circle"===e?"hybrid":"click",h=l??"rectangle"!==e,d={centered:"rectangle"!==e&&!("circle"===e&&!h),cursor:i,defaultZ:a,forceUniformSize:h,graphicProperties:n,geometryToPlace:s,geometryType:e,graphicSymbol:this._getGraphicSymbolFromTool(e),hasZ:r,mode:p??c,snappingManager:this.snappingManager,snapToScene:!1,view:t};return"2d"===t.type?this._makeDrawGraphicTool2D(d):this._makeDrawGraphicTool3D(d)}async _makeDrawGraphicTool2D(t){const o=await this._requireModule(new Promise(((t,o)=>e(["../../views/2d/interactive/editingTools"],t,o))));return oe(o)||this.destroyed?null:new o.module.DrawGraphicTool2D({...t,activeVertexSymbol:this.activeVertexSymbol,regularVerticesSymbol:this.vertexSymbol,activeLineSymbol:this.activeLineSymbol,activeFillSymbol:$(t.geometryType)?this.activeFillSymbol:null,sketchOptions:this.sketchOptions})}async _makeDrawGraphicTool3D(t){const o=await this._requireModule(new Promise(((t,o)=>e(["../../views/3d/interactive/editingTools"],t,o))));if(oe(o)||this.destroyed)return null;const{elevationInfo:i}=this.layer;return new o.module.DrawGraphicTool3D({...t,elevationInfo:i,snapToScene:!0,sketchOptions:this.sketchOptions})}_setupCreateOperationHandle(e){const t=this.view;if(!t)return this._logMissingView(),null;let o=null;const i=e.forceUniformSize,a=e.centered,r=[t.on("key-down",(t=>{if(t.key===k.sketchKeys.pan)t.stopPropagation(),t.repeat||(e.enabled=!1);else if(t.key===k.sketchKeys.complete)t.stopPropagation(),e.completeCreateOperation();else if(t.key!==k.sketchKeys.vertexAdd||t.repeat)t.key===k.sketchKeys.undo?(t.stopPropagation(),n.undo()):t.key===k.sketchKeys.redo?(t.stopPropagation(),n.redo()):t.key!==k.sketchKeys.constraint||"rectangle"!==e.geometryType&&"circle"!==e.geometryType||t.repeat?t.key===k.sketchKeys.center&&(t.repeat||(e.centered=!a,t.stopPropagation())):(e.forceUniformSize=!i,t.stopPropagation());else{const o=e.drawOperation.geometryType;"polyline"!==o&&"polygon"!==o&&"multipoint"!==o||(t.stopPropagation(),e.drawOperation.commitStagedVertex())}}),S.ViewEventPriorities.WIDGET),t.on("key-up",(t=>{t.key===k.sketchKeys.pan?e.enabled=!0:t.key!==k.sketchKeys.constraint||"rectangle"!==e.geometryType&&"circle"!==e.geometryType?t.key===k.sketchKeys.center&&(e.centered=a,t.stopPropagation()):(e.forceUniformSize=i,t.stopPropagation())}),S.ViewEventPriorities.WIDGET),e.on("vertex-add",(t=>{switch(o=null==o?"start":"active",t.operation){case"apply":this.emit("create",{graphic:e.graphic,state:o,tool:this.activeTool,toolEventInfo:t,type:"create"});break;case"undo":this._emitUndoEvent({graphics:[e.graphic],tool:e.geometryType});break;case"redo":this._emitRedoEvent({graphics:[e.graphic],tool:e.geometryType})}})),e.on("cursor-update",(t=>{e.drawOperation.numCommittedVertices>0&&this.emit("create",{graphic:e.graphic,state:"active",tool:this.activeTool,toolEventInfo:{coordinates:t.vertices[0].coordinates,type:"cursor-update"},type:"create"})})),e.on("vertex-remove",(t=>{switch(t.operation){case"apply":this.emit("create",{graphic:e.graphic,state:"active",tool:this.activeTool,toolEventInfo:t,type:"create"});break;case"undo":this._emitUndoEvent({graphics:[e.graphic],tool:e.geometryType});break;case"redo":this._emitRedoEvent({graphics:[e.graphic],tool:e.geometryType})}})),e.on("complete",(e=>{this._set("createGraphic",e.graphic),o="complete",e.aborted?n&&n.cancel():n&&n.complete()})),h.watch((()=>this._getGraphicSymbolFromTool(e.geometryType)),(t=>{e.graphicSymbol=t}))],n=new x.CreateOperationHandle({activeComponent:e,tool:e.geometryType,type:"create",onEnd:()=>{s.drainHandles(r),t.tools?.remove(e)},undo:()=>{e.canUndo&&e.undo()},redo:()=>{e.canRedo&&e.redo()},canUndo:()=>e.canUndo,canRedo:()=>e.canRedo});return n}_getGraphicSymbolFromTool(e){switch(e){case"point":case"multipoint":return this.pointSymbol;case"polyline":return this.polylineSymbol;case"circle":case"rectangle":case"polygon":return this.polygonSymbol;case"mesh":return this.meshSymbol}}async _setupUpdateOperation(e,t){const{layer:o,view:i}=this;if(!i)return this._logMissingView(),null;const a={...this.defaultUpdateOptions,...t,reshapeOptions:{...this.defaultUpdateOptions.reshapeOptions,...t?.reshapeOptions},highlightOptions:{...this.defaultUpdateOptions.highlightOptions,...t?.highlightOptions}};let r=a.tool??q.tool;for(const s of e)o.remove(s),o.add(s);if("3d"===i.type){if(0===e.length)return null;switch(r){case"move":return this._setupMove3DOperation(e,a,i,r);case"reshape":return e.length>1?(this._logError("sketch:reshape-multiple","Reshape operation does not support multiple graphics."),null):this._setupReshape3DOperation(e[0],a,i);case"transform":return this._setupGraphicTransform3DOperation(e,a,i)}}switch(r){case"move":return this._setupMove2DOperation(e,a,i);case"reshape":return e.length>1?(this._logError("sketch:reshape-multiple","Reshape operation does not support multiple graphics."),null):this._setupTransformOrReshape2DOperation(e,r,a,i);case"transform":if(1===e.length){const t=e[0].geometry?.type;"point"!==t&&"multipoint"!==t||(r="reshape")}return this._setupTransformOrReshape2DOperation(e,r,a,i)}}async _setupMove3DOperation(t,o,i,a,r=!1){const n=await this._requireModule(new Promise(((t,o)=>e(["../../views/3d/interactive/editingTools"],t,o))));if(oe(n))return n;const{ManipulatedObject3DGraphic:p,MoveTool3D:l}=n.module,c=new Map,h=()=>{c.forEach((e=>e.destroy())),c.clear()};for(const e of t){const t=new p({view:i,graphic:e}),o=O.isSupportedObject(t);if(o!==f.SupportedObjectResult.SUPPORTED)return h(),this._logError("sketch:move",`Move operation not supported for provided graphic(s) (${f.isSupportedObjectResultMessage(o)}).`),null;c.set(e,t)}const d=new l({view:i,enableZ:o.enableZ,snappingManager:this.snappingManager,sketchOptions:this.sketchOptions});i.tools.add(d),d.objects.addMany(Array.from(c.values())),r||this.updateGraphics.addMany(t);const u=[],y=new x.UpdateOperationHandle({activeComponent:d,tool:a,type:"update",onEnd:()=>{s.drainHandles(u),te(i,d),h()},undo:()=>{X(this.view,d),Y(y,this.updateGraphics.toArray()),this._emitUndoEvent({graphics:this.updateGraphics.toArray(),tool:a})},redo:()=>{J(y,this.updateGraphics.toArray()),this._emitRedoEvent({graphics:this.updateGraphics.toArray(),tool:a})},addToSelection:e=>{this.updateGraphics.push(e);const t=new p({view:i,graphic:e});c.set(e,t),d.objects.push(t),this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{added:[e],removed:[],type:"selection-change"},type:"update"})},removeFromSelection:e=>{const t=this.updateGraphics.indexOf(e);if(y.history.undo.forEach((e=>e.updates.splice(t,1))),y.history.redo.forEach((e=>e.updates.splice(t,1))),this.updateGraphics.remove(e),this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{added:[],removed:[e],type:"selection-change"},type:"update"}),0===this.updateGraphics.length)return void y.complete();const o=c.get(e);o&&(d.objects.remove(o),o.destroy(),c.delete(e))},toggleTool:async()=>{if(1!==this.updateGraphics.length||!1===o.toggleToolOnClick)return;if("transform"!==a)return;const e=this.updateGraphics.at(0),t=await this._setupReshape3DOperation(e,o,i,!0);t&&!oe(t)&&(y.onEnd(),y.destroy(),this._setUpdateOperationHandle(t,o))}});return u.push(...this._getHandlesForComponent(y,o),i.on("immediate-click",(e=>this._getCommonUpdateOperationClickHandlers(y,e,o)),S.ViewEventPriorities.WIDGET),i.on("key-down",(e=>{this._getCommonUpdateOperationKeyDownHandlers(y,e)}),S.ViewEventPriorities.WIDGET)),y}_setupGraphicTransform3DOperation(e,t,o,i=!1){if(1===e.length&&T.isSupportedGraphic(e[0])===f.SupportedObjectResult.SUPPORTED){const a=e[0],r=a.geometry;if(null!=r&&("point"===r.type||"mesh"===r.type))return this._setupPointTransform3DOperation(a,t,o);if(null!=r&&("polygon"===r.type||"polyline"===r.type))return this._setupPolyTransform3DOperation(a,t,o,i)}return this._setupMove3DOperation(e,t,o,"transform",i)}async _setupPointTransform3DOperation(t,o,i){const a="transform",{enableRotation:r,enableScaling:n,enableZ:p}=o,l=await this._requireModule(new Promise(((t,o)=>e(["../../views/3d/interactive/editingTools"],t,o))));if(oe(l))return l;const{TransformTool3D:c,ManipulatedObject3DGraphic:h}=l.module,d=new h({graphic:t,view:i}),u=new c({object:d,view:i,enableRotation:r,enableScaling:n,enableZ:p,snappingManager:this.snappingManager,sketchOptions:this.sketchOptions});i.tools.add(u),this.updateGraphics.add(t);const y=[],v=new x.UpdateOperationHandle({activeComponent:u,tool:a,type:"update",onEnd:()=>{s.drainHandles(y),te(i,u),d.destroy()},undo:()=>{X(this.view,u),Y(v,this.updateGraphics.toArray()),this._emitUndoEvent({graphics:this.updateGraphics.toArray(),tool:a})},redo:()=>{J(v,this.updateGraphics.toArray()),this._emitRedoEvent({graphics:this.updateGraphics.toArray(),tool:a})},addToSelection:async e=>{this.updateGraphics.add(e),this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{added:[e],removed:[],type:"selection-change"},type:"update"}),v.onEnd(),v.destroy();const t=await this._setupMove3DOperation(this.updateGraphics.toArray(),o,i,"transform",!0);oe(t)||this._setUpdateOperationHandle(t,o)},removeFromSelection:e=>{this.updateGraphics.remove(e),this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{added:[],removed:[e],type:"selection-change"},type:"update"}),v.complete()},toggleTool:()=>{}});return y.push(...this._getHandlesForComponent(v,o),i.on("immediate-click",(e=>this._getCommonUpdateOperationClickHandlers(v,e,o)),S.ViewEventPriorities.WIDGET),i.on("key-down",(e=>{this._getCommonUpdateOperationKeyDownHandlers(v,e)}),S.ViewEventPriorities.WIDGET)),v}async _setupPolyTransform3DOperation(t,o,i,a=!1){const r="transform",{enableRotation:n,enableScaling:p,enableZ:l,preserveAspectRatio:c}=o,h=await this._requireModule(new Promise(((t,o)=>e(["../../views/3d/interactive/editingTools"],t,o))));if(oe(h))return h;const{ManipulatedObject3DGraphic:d,ExtentTransformTool:u}=h.module,y=this.view?.inputManager?.isModifierKeyDown(k.sketchKeys.constraint),v=new d({view:i,graphic:t}),g=new u({object:v,view:i,enableRotation:n,enableScaling:p,enableZ:l,preserveAspectRatio:!!c!=!!y,sketchOptions:this.sketchOptions});i.tools.add(g),a||this.updateGraphics.add(t);const m=[],_=new x.UpdateOperationHandle({activeComponent:g,tool:r,type:"update",onEnd:()=>{s.drainHandles(m),te(i,g),v.destroy()},canUndo:()=>!g.destroyed&&g.canUndo,undo:()=>{g.destroyed||(g.undo(),this._emitUndoEvent({graphics:this.updateGraphics.toArray(),tool:r}))},canRedo:()=>!g.destroyed&&g.canRedo,redo:()=>{g.destroyed||(g.redo(),this._emitRedoEvent({graphics:this.updateGraphics.toArray(),tool:r}))},addToSelection:async e=>{this.updateGraphics.add(e),this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{added:[e],removed:[],type:"selection-change"},type:"update"}),_.onEnd(),_.destroy();const t=await this._setupMove3DOperation(this.updateGraphics.toArray(),o,i,"transform",!0);oe(t)||this._setUpdateOperationHandle(t,o)},removeFromSelection:e=>{this.updateGraphics.remove(e),this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{added:[],removed:[e],type:"selection-change"},type:"update"}),_.complete()},toggleTool:async()=>{if(1!==this.updateGraphics.length||!1===o.toggleToolOnClick)return;const e=await this._setupReshape3DOperation(t,o,i,!0);e&&!oe(e)&&(_.onEnd(),_.destroy(),this._setUpdateOperationHandle(e,o))}});return m.push(...this._getHandlesForComponent(_,o),i.on("immediate-click",(e=>this._getCommonUpdateOperationClickHandlers(_,e,o)),S.ViewEventPriorities.WIDGET),i.on("key-down",(e=>this._getCommonUpdateOperationKeyDownHandlers(_,e)),S.ViewEventPriorities.WIDGET),i.on("key-down",(e=>{e.key!==k.sketchKeys.constraint||e.repeat||(g.preserveAspectRatio=!g.preserveAspectRatio,e.stopPropagation())}),S.ViewEventPriorities.WIDGET),i.on("key-up",(e=>{e.key===k.sketchKeys.constraint&&(g.preserveAspectRatio=!g.preserveAspectRatio,e.stopPropagation())}),S.ViewEventPriorities.WIDGET)),_}async _setupMove2DOperation(e,t,o){const i="move";this.updateGraphics.addMany(e),await this._updateSpatialReference(e);const a=await this._getGraphicMover(e,t,o);if(oe(a))return a;const r=new x.UpdateOperationHandle({activeComponent:a,tool:i,type:"update",onEnd:()=>{this._displayDefaultCursor(),s.drainHandles(l),s.drainHandles(p),a.destroy(),this._internalGraphicsLayer?.removeMany([...this.updateGraphics.toArray()])},undo:()=>{const e=this.updateGraphics.toArray();Y(r,e),r.refreshComponent(),this._emitUndoEvent({graphics:e,tool:i})},redo:()=>{const e=this.updateGraphics.toArray();J(r,e),r.refreshComponent(),this._emitRedoEvent({graphics:e,tool:i})},addToSelection:async e=>{await this._updateSpatialReference(e),this.updateGraphics.push(e),a.graphics=this.updateGraphics.toArray(),this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{added:[e],removed:[],type:"selection-change"},type:"update"})},removeFromSelection:e=>{const t=this.updateGraphics.indexOf(e);r.history.undo.forEach((e=>e.updates.splice(t,1))),r.history.redo.forEach((e=>e.updates.splice(t,1))),this.updateGraphics.remove(e);const o=this.updateGraphics.toArray();this.emit("update",{graphics:o,state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{added:[],removed:[e],type:"selection-change"},type:"update"}),0!==this.updateGraphics.length?a.graphics=o:r.complete()}});let n=!1;const p=[o.on("immediate-click",(e=>this._getCommonUpdateOperationClickHandlers(r,e,t)),S.ViewEventPriorities.WIDGET),o.on("key-down",(e=>{this._getCommonUpdateOperationKeyDownHandlers(r,e),e.key!==k.sketchKeys.constraint||e.repeat||(n=!0,a.enableMoveAllGraphics=!a.enableMoveAllGraphics)}),S.ViewEventPriorities.WIDGET),o.on("key-up",(e=>{e.key===k.sketchKeys.constraint&&n&&(n=!1,a.enableMoveAllGraphics=!a.enableMoveAllGraphics)}),S.ViewEventPriorities.WIDGET)],l=this._getHandlesForComponent(r,t);return r}async _setupReshape3DOperation(t,o,i,a=!1){const r="reshape",n=await this._requireModule(new Promise(((t,o)=>e(["../../views/3d/interactive/editingTools"],t,o))));if(oe(n))return n;const{ManipulatedObject3DGraphic:p,ReshapeTool3D:l}=n.module,c=new p({view:i,graphic:t}),h=G.isSupportedObject(c);if(h!==f.SupportedObjectResult.SUPPORTED)return c.destroy(),this._logError("sketch:reshape",`Reshape operation not supported for provided graphic(s) (${f.isSupportedObjectResultMessage(h)}).`),null;const d=o.reshapeOptions,u=new l({view:i,object:c,enableZVertex:o.enableZ&&"move"===d?.vertexOperation,enableZShape:o.enableZ&&"move"===d?.shapeOperation,enableMoveObject:"move"===d?.shapeOperation||"move-xy"===d?.shapeOperation,enableMidpoints:"split"===d?.edgeOperation,enableEdgeOffset:"offset"===d?.edgeOperation,snappingManager:this.snappingManager,sketchOptions:this.sketchOptions});i.tools.add(u),a||this.updateGraphics.add(c.graphic);const y=[],v=new x.UpdateOperationHandle({activeComponent:u,tool:r,type:"update",onEnd:()=>{s.drainHandles(y),te(i,u),c.destroy()},canUndo:()=>!u.destroyed&&u.canUndo,undo:()=>{u.destroyed||(u.undo(),this._emitUndoEvent({graphics:this.updateGraphics.toArray(),tool:r}))},canRedo:()=>!u.destroyed&&u.canRedo,redo:()=>{u.destroyed||(u.redo(),this._emitRedoEvent({graphics:this.updateGraphics.toArray(),tool:r}))},addToSelection:async e=>{this.updateGraphics.add(e),this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{added:[e],removed:[],type:"selection-change"},type:"update"}),v.onEnd(),v.destroy();const t=await this._setupMove3DOperation(this.updateGraphics.toArray(),o,i,"transform",!0);oe(t)||this._setUpdateOperationHandle(t,o)},removeFromSelection:e=>{this.updateGraphics.remove(e),this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{added:[],removed:[e],type:"selection-change"},type:"update"}),v.complete()},toggleTool:async()=>{if(!1===o.toggleToolOnClick)return;v.onEnd(),v.destroy();const e=await this._setupGraphicTransform3DOperation(this.updateGraphics.toArray(),o,i,!0);oe(e)||this._setUpdateOperationHandle(e,o)}});return y.push(...this._getHandlesForComponent(v,o),i.on("immediate-click",(e=>this._getCommonUpdateOperationClickHandlers(v,e,o)),S.ViewEventPriorities.WIDGET),i.on("key-down",(e=>{this._getCommonUpdateOperationKeyDownHandlers(v,e)}),S.ViewEventPriorities.WIDGET)),v}async _setupTransformOrReshape2DOperation(e,t,o,i){this.updateGraphics.addMany(e),await this._updateSpatialReference(e);const a="transform"===t?await this._getBox(e,o,i):await this._getReshape(e,o,i);if(oe(a))return a;const r=new x.UpdateOperationHandle({activeComponent:a,type:"update",onEnd:()=>{s.drainHandles(p),s.drainHandles(n),r.activeComponent&&!r.activeComponent.destroyed&&r.activeComponent.destroy(),this._internalGraphicsLayer.removeMany(this.updateGraphics.toArray())},undo:()=>{Y(r,this.updateGraphics.toArray()),r.refreshComponent(),this._emitUndoEvent({graphics:this.updateGraphics.toArray(),tool:r.tool})},redo:()=>{J(r,this.updateGraphics.toArray()),r.refreshComponent(),this._emitRedoEvent({graphics:this.updateGraphics.toArray(),tool:r.tool})},addToSelection:async e=>{let t=r.activeComponent;if("reshape"===t?.type){const t=[...this.updateGraphics,e];this.updateGraphics.removeAll(),r.onEnd(),r.destroy();const a=await this._setupTransformOrReshape2DOperation(t,"transform",o,i);if(oe(a))return;this._setUpdateOperationHandle(a,o)}else this.updateGraphics.add(e),t.graphics=this.updateGraphics.toArray(),t.refresh(),r.resetHistory();this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{added:[e],removed:[],type:"selection-change"},type:"update"})},removeFromSelection:async e=>{const t=this.updateGraphics.indexOf(e);r.history.undo.forEach((e=>e.updates.splice(t,1))),r.history.redo.forEach((e=>e.updates.splice(t,1))),this.updateGraphics.remove(e);const o=this.updateGraphics.toArray();if(0===o.length)r.complete();else{const e=o[0].geometry;1!==o.length||null==e||"point"!==e.type&&"multipoint"!==e.type?r.activeComponent.graphics=o:r.toggleTool()}this.emit("update",{graphics:o,state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{added:[],removed:[e],type:"selection-change"},type:"update"})},toggleTool:async()=>{if(this.updateGraphics.length>1)return;const e=this.updateGraphics.at(0),t=e.geometry;if(null!=t&&("reshape"===r.tool&&("point"===t.type||"multipoint"===t.type)||"transform"===r.tool&&"extent"===t.type))return;let a=null;"transform"===r.tool?a=await this._getReshape([e],o,i):"reshape"===r.tool&&(a=await this._getBox([e],o,i)),oe(a)||(r.activeComponent?.destroy(),r.activeComponent=a,r.activeComponent&&(s.drainHandles(p),p=this._getHandlesForComponent(r,o)))}}),n=[i.on("immediate-click",(e=>this._getCommonUpdateOperationClickHandlers(r,e,o)),S.ViewEventPriorities.WIDGET),i.on("key-down",(e=>{if(this._getCommonUpdateOperationKeyDownHandlers(r,e),e.key===k.sketchKeys.constraint&&!e.repeat&&r){const e=r.activeComponent;e&&"box"===e.type&&(e.preserveAspectRatio=!e.preserveAspectRatio)}}),S.ViewEventPriorities.WIDGET),i.on("key-up",(e=>{if(e.key===k.sketchKeys.constraint&&r){const e=r.activeComponent;e&&"box"===e.type&&(e.preserveAspectRatio=!e.preserveAspectRatio)}}),S.ViewEventPriorities.WIDGET)];let p=this._getHandlesForComponent(r,o);return r}async _getGraphicMover(t,o,i){const{enableMoveAllGraphics:a,highlightOptions:r}=o,s=await this._requireModule(new Promise(((t,o)=>e(["../../views/draw/support/GraphicMover"],(e=>t(W(e))),o))));return oe(s)?s:new s.module.default({enableMoveAllGraphics:a,highlightsEnabled:!!r?.enabled,indicatorsEnabled:!1,graphics:t,view:i,callbacks:{onGraphicMoveStart:({dx:e,dy:t,graphic:o})=>{this._displayGrabbingCursor(),this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{dx:e,dy:t,mover:o,type:"move-start"},type:"update"})},onGraphicMove:({dx:e,dy:t,graphic:o})=>this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{dx:e,dy:t,mover:o,type:"move"},type:"update"}),onGraphicMoveStop:({dx:e,dy:t,graphic:o})=>{this._displayPointerCursor(),this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{dx:e,dy:t,mover:o,type:"move-stop"},type:"update"})},onGraphicPointerOver:()=>this._displayPointerCursor(),onGraphicPointerOut:()=>this._displayDefaultCursor()}})}async _getBox(t,o,i){const{enableRotation:a,enableScaling:r,highlightOptions:s,preserveAspectRatio:n}=o,p=await this._requireModule(new Promise(((t,o)=>e(["../../views/draw/support/Box"],(e=>t(W(e))),o))));if(oe(p))return p;const l=this.view?.inputManager?.isModifierKeyDown(k.sketchKeys.constraint);return new p.module.default({graphics:t,enableRotation:a,enableScaling:r,highlightsEnabled:!!s?.enabled,preserveAspectRatio:!!n!=!!l,layer:this._internalGraphicsLayer,view:i,sketchOptions:this.sketchOptions,callbacks:{onMoveStart:e=>this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{...e},type:"update"}),onMove:e=>this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{...e},type:"update"}),onMoveStop:e=>this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{...e},type:"update"}),onScaleStart:e=>this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{...e},type:"update"}),onScale:e=>this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{...e},type:"update"}),onScaleStop:e=>this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{...e},type:"update"}),onRotateStart:e=>this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{...e},type:"update"}),onRotate:e=>this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{...e},type:"update"}),onRotateStop:e=>this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{...e},type:"update"})}})}async _getReshape(t,o,i){const a="split"===o.reshapeOptions?.edgeOperation,r="move"===o.reshapeOptions?.shapeOperation,s=!!o.highlightOptions?.enabled,n=await this._requireModule(new Promise(((t,o)=>e(["../../views/draw/support/Reshape"],(e=>t(W(e))),o))));return oe(n)?n:new n.module.default({enableMidpoints:a,enableMovement:r,graphic:t[0],highlightsEnabled:s,layer:this._internalGraphicsLayer,snappingManager:this.snappingManager,sketchOptions:this.sketchOptions,view:i,callbacks:{onReshapeStart:e=>this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{...e},type:"update"}),onReshape:e=>this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{...e},type:"update"}),onReshapeStop:({mover:e,type:t})=>this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{mover:e,type:t},type:"update"}),onMoveStart:({dx:e,dy:t,mover:o,type:i})=>this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{dx:e,dy:t,mover:o,type:i},type:"update"}),onMove:({dx:e,dy:t,mover:o,type:i})=>this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{dx:e,dy:t,mover:o,type:i},type:"update"}),onMoveStop:({dx:e,dy:t,mover:o,type:i})=>this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{dx:e,dy:t,mover:o,type:i},type:"update"}),onVertexAdd:({added:e,type:t,vertices:o})=>{const i=e.map((e=>m.geometryToCoordinates(e.geometry)));this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{added:i,vertices:o,type:t},type:"update"})},onVertexRemove:({removed:e,type:t,vertices:o})=>{const i=e.map((e=>m.geometryToCoordinates(e.geometry)));this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{removed:i,vertices:o,type:t},type:"update"})}}})}_getHandlesForComponent(e,t){const o=e.activeComponent;if(!o)return[];switch(o.type){case"graphic-mover":return[o.on("graphic-click",(({graphic:t,viewEvent:o})=>{o.native?.shiftKey&&(o.stopPropagation(),e.removeFromSelection(t))})),o.on("graphic-move-start",(t=>e.addToHistory(ee(t.allGraphics))))];case"box":return[o.on("graphic-click",(o=>this._onTransformOrReshape2DGraphicClick(e,t,o))),o.on("move-start",(t=>e.addToHistory(ee(t.graphics)))),o.on("rotate-start",(t=>e.addToHistory(ee(t.graphics)))),o.on("scale-start",(t=>e.addToHistory(ee(t.graphics))))];case"reshape":return[o.on("graphic-click",(o=>this._onTransformOrReshape2DGraphicClick(e,t,o))),o.on("move-start",(t=>e.addToHistory(ee([t.mover])))),o.on("reshape-start",(t=>e.addToHistory(ee([t.graphic])))),o.on("vertex-add",(t=>e.addToHistory(ee([t.oldGraphic])))),o.on("vertex-remove",(t=>e.addToHistory(ee([t.oldGraphic]))))];case"move-3d":return[o.events.on("record-undo",(({updates:t})=>{e.addToHistory({updates:t})})),o.events.on("move-start",(e=>{this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{dx:0,dy:0,mover:e.objects.length>0?e.objects[0].graphic:null,type:"move-start"},type:"update"})})),o.events.on("move",(e=>{this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{dx:e.dx,dy:e.dy,mover:e.objects.length>0?e.objects[0].graphic:null,type:"move"},type:"update"})})),o.events.on("move-stop",(e=>{this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{dx:0,dy:0,mover:e.objects.length>0?e.objects[0].graphic:null,type:"move-stop"},type:"update"})})),o.events.on("immediate-click",(o=>{o.shiftKey?this._toggleSelection([o.object.graphic],e,t):e.toggleTool()}))];case"transform-3d":return[o.events.on("record-undo",(({updates:t})=>{e.addToHistory({updates:t})})),o.events.on("translate-start",(e=>{this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{mover:e.object.graphic,dx:e.dxScreen,dy:e.dyScreen,type:"move-start"},type:"update"})})),o.events.on("translate-stop",(e=>{this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{mover:e.object.graphic,dx:e.dxScreen,dy:e.dyScreen,type:"move-stop"},type:"update"})})),o.events.on("rotate-start",(e=>{this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{mover:e.object.graphic,angle:e.angle,type:"rotate-start"},type:"update"})})),o.events.on("rotate-stop",(e=>{this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{mover:e.object.graphic,angle:e.angle,type:"rotate-stop"},type:"update"})})),o.events.on("scale-start",(e=>{this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{mover:e.object.graphic,xScale:e.xScale,yScale:e.yScale,type:"scale-start"},type:"update"})})),o.events.on("scale-stop",(e=>{this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{mover:e.object.graphic,xScale:e.xScale,yScale:e.yScale,type:"scale-stop"},type:"update"})})),o.events.on("translate",(e=>{this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{mover:e.object.graphic,dx:e.dxScreen,dy:e.dyScreen,type:"move"},type:"update"})})),o.events.on("rotate",(e=>{this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{mover:e.object.graphic,angle:e.angle,type:"rotate"},type:"update"})})),o.events.on("scale",(e=>{this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{mover:e.object.graphic,xScale:e.xScale,yScale:e.yScale,type:"scale"},type:"update"})})),o.events.on("immediate-click",(o=>{o.shiftKey?this._toggleSelection([o.object.graphic],e,t):e.toggleTool()}))];case"reshape-3d":return[o.events.on("reshape",(e=>{this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{...e,mover:e.object.graphic},type:"update"})})),o.events.on("move",(e=>{this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:{...e,mover:e.object.graphic},type:"update"})})),o.events.on("vertex-add",(e=>{this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:e,type:"update"})})),o.events.on("vertex-remove",(e=>{this.emit("update",{graphics:this.updateGraphics.toArray(),state:"active",aborted:!1,tool:this.activeTool,toolEventInfo:e,type:"update"})})),o.events.on("immediate-click",(o=>{o.shiftKey?this._toggleSelection([o.object.graphic],e,t):e.toggleTool()}))]}}_onTransformOrReshape2DGraphicClick(e,t,o){const{graphic:i,viewEvent:a}=o;return a.native?.shiftKey&&i.layer===this.layer?(a.stopPropagation(),e.removeFromSelection(i)):t.toggleToolOnClick?(a.stopPropagation(),e.toggleTool()):void 0}_setUpdateOperationHandle(e,t){this._operationHandle=e;const o=this.view?.map;this._disablePopup(t);const i=()=>{if(e===this._operationHandle){const i=this.updateGraphics.toArray(),a=this._operationHandle.tool;this._operationHandle.destroy(),this._operationHandle=null,this._internalGraphicsLayer.removeMany(this.updateGraphics.toArray()),this.updateGraphics.removeAll(),o&&o.remove(this._internalGraphicsLayer),this._restorePopup(t),this.emit("update",{graphics:i,state:"complete",aborted:e.cancelled,tool:a,toolEventInfo:null,type:"update"})}};e.on("complete",i)}async _getCommonUpdateOperationClickHandlers(e,t,o){const i=U.createScreenPointFromEvent(t),a=await t.async((()=>this._getFirstHit(i)));if(null==a)return void e.complete();if(t.native.shiftKey&&this._toggleSelection([a.graphic],e,o))return void t.stopPropagation();this.updateGraphics.includes(a.graphic)?t.stopPropagation():e.complete()}_toggleSelection(e,t,o){const i=!!o.multipleSelectionEnabled;return e.some((e=>null!=e&&(!(!i||e.layer!==this.layer)&&(this.updateGraphics.includes(e)?t.removeFromSelection(e):t.addToSelection(e),!0))))}_getCommonUpdateOperationKeyDownHandlers(e,t){if(!e)return;const o=t.key;o===k.sketchKeys.undo&&e.canUndo()?(t.stopPropagation(),e.undo()):o===k.sketchKeys.redo&&e.canRedo()?(t.stopPropagation(),e.redo()):o===k.sketchKeys.cancel?(t.stopPropagation(),e.cancel()):this.allowDeleteKey&&k.sketchKeys.delete.includes(o)&&this._onDeleteKey(t)}_onDeleteKey(e){if(!this._operationHandle||"update"!==this._operationHandle.type)return;const t=this.activeComponent,o=this.updateGraphics.toArray();null!=t&&("reshape"!==t.type||1===o.length&&"point"===o[0].geometry?.type)&&(e.stopPropagation(),this.delete())}_removeDefaultLayer(){this._internalGraphicsLayer&&(this.view?.map?.remove(this._internalGraphicsLayer),this._internalGraphicsLayer=l.destroyMaybe(this._internalGraphicsLayer))}_isComponentGraphic(e){const{activeComponent:t}=this;return!(!e||null==t)&&(e.attributes?.esriSketchTool||"draw-2d"===t.type&&t.graphic===e||("box"===t.type||"reshape"===t.type)&&t.isUIGraphic(e))}_displayPointerCursor(){this.view?.container&&"pointer"!==this.view.cursor&&(this.view.cursor="pointer")}_displayGrabbingCursor(){this.view?.container&&"grabbing"!==this.view.cursor&&(this.view.cursor="grabbing")}_displayDefaultCursor(){this.view?.container&&null!==this.view.cursor&&(this.view.cursor=null)}_logError(e,t,o){p.getLogger(this).error(new a(e,t,o))}async _requireModule(e){const t=new AbortController;this._moduleLoaderAbortController=t;const o=await e;return this._moduleLoaderAbortController!==t||t.signal.aborted?{requireError:"aborted"}:{module:o}}_emitUndoEvent(e){this.emit("undo",{...e,type:"undo"})}_emitRedoEvent(e){this.emit("redo",{...e,type:"redo"})}_emitDeleteEvent(e){this.emit("delete",{...e,type:"delete"})}get test(){}wait(){return h.whenOnce((()=>!this.updating))}_beginAsyncOperation(){this._numUpdating+=1,this.notifyChange("updating")}_endAsyncOperation(){this._numUpdating-=1,this.notifyChange("updating")}_disablePopupEnabled(e){return"3d"!==this.view?.type||this.updateOnGraphicClick||(e?.toggleToolOnClick??!1)}_disablePopup(e){this._disablePopupEnabled(e)&&this.view&&null==this._originalPopupEnabled&&(this._originalPopupEnabled=this.view.popupEnabled,this.view.popupEnabled=!1)}_restorePopup(e){this._disablePopupEnabled(e)&&this.view&&null!=this._originalPopupEnabled&&(this.view.popupEnabled=this._originalPopupEnabled,this._originalPopupEnabled=null)}async _waitViewReady(){const e=this.view;e?(l.abortMaybe(this._viewReadyAbortController),this._viewReadyAbortController=new AbortController,await c.whenOrAbort(h.whenOnce((()=>e?.ready)),this._viewReadyAbortController.signal)):this._logMissingView()}_logMissingView(){this._logError("sketch:missing-property",B("view"))}_logMissingLayer(){this._logError(N,B("layer"))}};t.__decorate([d.property()],z.prototype,"_defaultSnappingManager",void 0),t.__decorate([d.property()],z.prototype,"updating",null),t.__decorate([d.property()],z.prototype,"_operationHandle",void 0),t.__decorate([d.property({readOnly:!0})],z.prototype,"activeTool",null),t.__decorate([d.property()],z.prototype,"activeTooltip",null),t.__decorate([d.property()],z.prototype,"activeFillSymbol",void 0),t.__decorate([d.property()],z.prototype,"activeLineSymbol",void 0),t.__decorate([d.property()],z.prototype,"activeVertexSymbol",void 0),t.__decorate([d.property()],z.prototype,"allowDeleteKey",void 0),t.__decorate([d.property({readOnly:!0})],z.prototype,"createGraphic",null),t.__decorate([d.property()],z.prototype,"defaultCreateOptions",null),t.__decorate([d.property()],z.prototype,"defaultUpdateOptions",null),t.__decorate([d.property({type:M,nonNullable:!0})],z.prototype,"labelOptions",null),t.__decorate([d.property()],z.prototype,"layer",void 0),t.__decorate([d.property({types:o.symbolTypes})],z.prototype,"pointSymbol",void 0),t.__decorate([d.property({types:o.symbolTypes})],z.prototype,"polygonSymbol",void 0),t.__decorate([d.property({types:o.symbolTypes})],z.prototype,"polylineSymbol",void 0),t.__decorate([d.property()],z.prototype,"meshSymbol",void 0),t.__decorate([d.property({type:P,nonNullable:!0})],z.prototype,"snappingOptions",null),t.__decorate([d.property()],z.prototype,"snappingManager",null),t.__decorate([d.property({readOnly:!0})],z.prototype,"state",null),t.__decorate([d.property({type:C,nonNullable:!0})],z.prototype,"tooltipOptions",null),t.__decorate([d.property({readOnly:!0})],z.prototype,"updateGraphics",void 0),t.__decorate([d.property()],z.prototype,"updateOnGraphicClick",void 0),t.__decorate([d.property({type:H,nonNullable:!0})],z.prototype,"valueOptions",null),t.__decorate([d.property({types:o.symbolTypes})],z.prototype,"vertexSymbol",void 0),t.__decorate([d.property({value:null})],z.prototype,"view",null),t.__decorate([d.property({constructOnly:!0,type:A})],z.prototype,"sketchOptions",void 0),z=t.__decorate([y.subclass("esri.widgets.Sketch.SketchViewModel")],z);const N="sketch:missing-property",B=e=>`Property '${e}' is missing on SketchViewModel.`;function $(e){return"polygon"===e||"rectangle"===e||"circle"===e}function Y(e,t){Q("undo",e.history.undo,e.history.redo,t)}function J(e,t){Q("redo",e.history.redo,e.history.undo,t)}function Q(e,t,o,i){const a=t.pop();if(!a)return;const r=a.updates,s=[];i.forEach(((t,o)=>{const i=r[o];null!=i&&("geometry"in i&&null!=i.geometry&&(s.push({geometry:t.geometry}),t.geometry=i.geometry),"symbol"in i&&null!=i.symbol&&(s.push({symbol:t.symbol}),t.symbol=i.symbol),"undo"in i&&(s.push(i),i[e](t)))})),o.push({updates:s})}function X(e,t){null!=e&&t.hasGrabbedManipulators&&(e.activeTool=null)}function ee(e){return{updates:e.map((({geometry:e})=>"mesh"===e?.type?{geometry:e.cloneShallow()}:{geometry:e}))}}function te(e,t){e.tools?.remove(t),t.destroyed||t.destroy()}function oe(e){return"requireError"in e&&"aborted"===e.requireError}return z}));
