/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../core/promiseUtils","../core/accessorSupport/decorators/property","../core/has","../core/Logger","../core/RandomLCG","../core/accessorSupport/decorators/subclass","./Widget","./Slice/SliceViewModel","../chunks/componentsUtils","./support/globalCss","./support/Heading","./support/widgetUtils","./support/decorators/messageBundle","./support/jsxFactory"],(function(e,t,s,i,l,r,o,n,c,a,d,u,p,y,h,_){"use strict";const x="esri-slice",v={base:x,actions:`${x}__actions`,cancelButton:`${x}__cancel-button`,container:`${x}__container`,error:`${x}__error`,excludeButton:`${x}__exclude-button`,hint:`${x}__hint`,hintText:`${x}__hint-text`,layerItem:`${x}__layer-item`,layerList:`${x}__layer-list`,layerListHeading:`${x}__layer-list-title`,newSliceButton:`${x}__clear-button`};let g=class extends c{constructor(e,t){super(e,t),this.headingLevel=3,this.messages=null,this.viewModel=new a,this._onNewSliceClick=()=>{s.ignoreAbortErrors(this.viewModel.start())}}loadDependencies(){return d.loadCalciteComponents({action:()=>new Promise(((t,s)=>e(["../chunks/calcite-action"],t,s))),button:()=>new Promise(((t,s)=>e(["../chunks/calcite-button"],t,s))),"list-item":()=>new Promise(((t,s)=>e(["../chunks/calcite-list-item"],t,s))),list:()=>new Promise(((t,s)=>e(["../chunks/calcite-list"],t,s)))})}get active(){return this.viewModel.active}get analysis(){return this.viewModel.analysis}set analysis(e){this.viewModel.analysis=e}get excludedLayers(){return this.viewModel.excludedLayers}set excludedLayers(e){this.viewModel.excludedLayers=e}get excludeGroundSurface(){return this.viewModel.excludeGroundSurface}set excludeGroundSurface(e){this.viewModel.excludeGroundSurface=e}get icon(){return"slice"}set icon(e){this._overrideIfSome("icon",e)}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}get view(){return this.viewModel.view}set view(e){this.viewModel.view=e}get visible(){return this.viewModel.visible}set visible(e){this.viewModel.visible=e}get hasVoxelLayers(){const e=this.viewModel?.view;return null!=e&&e.allLayerViews.some((e=>"voxel-3d"===e.type))}render(){return _.tsx("div",{class:this.classes(v.base,u.globalCss.widget,u.globalCss.panel),role:"presentation"},this.visible?_.tsx("div",{class:v.container},this.viewModel.supported?[this._renderHint(),this._renderLayerList(),this._renderActions()]:this._renderUnsupported()):null)}_renderUnsupported(){return _.tsx("div",{class:v.error,key:"unsupported"},_.tsx("p",null,this.messages.unsupported))}_renderHint(){const{hasVoxelLayers:e,messages:t,viewModel:s}=this,{active:i,layersMode:l,state:r}=s;let o=null;return i&&("exclude"===l?o=t.excludeHint:"ready"===r&&(o=e?t.voxelHint:t.hint)),o?_.tsx("div",{class:v.hint,key:"hint"},_.tsx("p",{class:v.hintText},o),_.tsx("p",{class:v.hintText},t.verticalHint)):null}_renderLayerList(){const{excludedLayers:e,excludeGroundSurface:t,headingLevel:s,messages:i,viewModel:l}=this,{layersMode:r,state:o}=l,n="slicing"===o||"sliced"===o,c=e?e.toArray().map((e=>this._renderLayerItem({uid:e.uid,title:e.title,onClick:()=>(this.excludedLayers.remove(e),!1)}))):[];return t&&c.push(this._renderLayerItem({uid:"ground",title:i.ground,onClick:()=>(this.excludeGroundSurface=!1,!1)})),"exclude"!==r&&n&&0!==c.length?_.tsx("div",{class:v.layerList,key:"settings"},_.tsx(p.Heading,{class:v.layerListHeading,level:s},i.excludedLayers),_.tsx("calcite-list",{selectionMode:"none"},c)):null}_renderActions(){const{messages:e,viewModel:t}=this,{active:s,state:i}=t,l="disabled"===i,r="slicing"===i||"sliced"===i,o="exclude"===t.layersMode,n=[];return s&&!r||o||n.push(_.tsx("calcite-button",{class:v.newSliceButton,disabled:l,key:"new-slice",onclick:this._onNewSliceClick},e.newSlice)),r&&!o&&n.push(_.tsx("calcite-button",{appearance:"outline-fill",class:v.excludeButton,disabled:l,key:"exclude",onclick:()=>t.enterExcludeLayerMode()},e.excludeLayer)),s&&o&&n.push(_.tsx("calcite-button",{appearance:"outline-fill",class:v.cancelButton,disabled:l,key:"cancel-exclude",onclick:()=>t.exitExcludeLayerMode()},e.cancel)),0===n.length?null:_.tsx("div",{class:v.actions},n)}_renderLayerItem(e){const t=this.messages.includeLayer;return _.tsx("calcite-list-item",{class:v.layerItem,"data-testid":`list-item-${e.uid}`,key:e.uid,label:e.title??""},_.tsx("calcite-action",{icon:"x",onclick:e.onClick,scale:"s",slot:"actions-end",text:t,title:t}))}};t.__decorate([i.property()],g.prototype,"active",null),t.__decorate([i.property({constructOnly:!0,nonNullable:!0})],g.prototype,"analysis",null),t.__decorate([i.property()],g.prototype,"excludedLayers",null),t.__decorate([i.property()],g.prototype,"excludeGroundSurface",null),t.__decorate([i.property()],g.prototype,"headingLevel",void 0),t.__decorate([i.property()],g.prototype,"icon",null),t.__decorate([i.property()],g.prototype,"label",null),t.__decorate([i.property(),h.messageBundle("esri/widgets/Slice/t9n/Slice")],g.prototype,"messages",void 0),t.__decorate([i.property()],g.prototype,"view",null),t.__decorate([i.property({type:a})],g.prototype,"viewModel",void 0),t.__decorate([i.property()],g.prototype,"visible",null),t.__decorate([i.property()],g.prototype,"hasVoxelLayers",null),g=t.__decorate([n.subclass("esri.widgets.Slice")],g);return g}));
