/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../core/Collection","../core/deprecate","../core/Identifiable","../core/Logger","../core/accessorSupport/decorators/property","../core/has","../core/RandomLCG","../core/accessorSupport/decorators/subclass","./Widget","./LayerList/LayerListItem","./LayerList/support/layerListUtils","../chunks/componentsUtils","./support/globalCss","./support/listUtils","./support/widgetUtils","./support/decorators/messageBundle","./support/decorators/vmEvent","./support/jsxFactory","./TableList/css","./TableList/ListItem","./TableList/TableListViewModel","./TableList/TableListVisibleElements","./TableList/support/tableListUtils"],(function(e,t,o,s,l,i,r,n,a,d,c,p,m,h,g,u,_,b,y,I,f,v,w,E,L){"use strict";const C=o.ofType(v);let M=class extends(l.IdentifiableMixin(c)){constructor(e,t){super(e,t),this._focusRootFlowItem=!1,this._focusPanelFlowItem=!1,this._lastDragDetail=null,this._selectedDragItemLayerUid=null,this._rootGroupUid=`table-${this.uid}`,this.collapsed=!1,this.dragEnabled=!1,this.filterPlaceholder="",this.filterText="",this.headingLevel=2,this.listItemCanGiveFunction=null,this.listItemCanReceiveFunction=null,this.messages=null,this.messagesCommon=null,this.minDragEnabledItems=m.minDragEnabledItems,this.minFilterItems=m.minFilterItems,this.selectedItems=new C,this.selectionMode="none",this.viewModel=new w,this.visibleElements=new E,this._canMove=({dragEl:e,fromEl:t,toEl:o},s)=>{const l="pull"===s?this.listItemCanGiveFunction:this.listItemCanReceiveFunction,i=L.getItem(e);if(!i?.sortable)return!1;const r=L.getItem(t),n=m.getLayerType(t),a=L.getItem(o),d=m.getLayerType(o),c=!!n&&!!d&&n===d,p={selected:i,from:r,to:a},h=t.group,g=o.group;return h&&g&&"function"==typeof l?l.call(null,p):c},this._onCalciteListOrderChange=e=>{const{_lastDragDetail:t}=this,{toEl:o,fromEl:s,dragEl:l,newIndex:i}=e;if(!s||!o||t?.newIndex===i&&t?.dragEl===l&&t?.toEl===o&&t?.fromEl===s)return;this._lastDragDetail=e;const r=Array.from(s.children).filter((e=>e?.matches("calcite-list-item"))).map((e=>e.value));L.sortTablesToIds(this.map?.tables,r)},this._onTriggerAction=(e,t)=>{this.triggerAction(e,t)},this._onPanelOpen=()=>{this._focusPanelFlowItem=!0},this._onSelectedDragItemLayerUidChange=e=>{this._selectedDragItemLayerUid=e}}loadDependencies(){return h.loadCalciteComponents({button:()=>new Promise(((t,o)=>e(["../chunks/calcite-button"],t,o))),flow:()=>new Promise(((t,o)=>e(["../chunks/calcite-flow"],t,o))),"flow-item":()=>new Promise(((t,o)=>e(["../chunks/calcite-flow-item"],t,o))),list:()=>new Promise(((t,o)=>e(["../chunks/calcite-list"],t,o))),notice:()=>new Promise(((t,o)=>e(["../chunks/calcite-notice"],t,o)))})}get _dragEnabled(){return this.viewModel.totalItems>=this.minDragEnabledItems&&this.dragEnabled}get _filterEnabled(){return this.viewModel.totalItems>=this.minFilterItems&&this.visibleElements.filter}get icon(){return"table"}set icon(e){this._overrideIfSome("icon",e)}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}get listItemCreatedFunction(){return this.viewModel.listItemCreatedFunction}set listItemCreatedFunction(e){this.viewModel.listItemCreatedFunction=e}get map(){return this.viewModel.map}set map(e){this.viewModel.map=e}get multipleSelectionEnabled(){return s.deprecatedProperty(i.getLogger(this),"multipleSelectionEnabled",{replacement:"selectionMode",version:"4.29",warnOnce:!0}),"multiple"===this.selectionMode}set multipleSelectionEnabled(e){s.deprecatedProperty(i.getLogger(this),"multipleSelectionEnabled",{replacement:"selectionMode",version:"4.29",warnOnce:!0}),this.selectionMode=e?"multiple":this.selectionEnabled?"single":"none"}get selectionEnabled(){return s.deprecatedProperty(i.getLogger(this),"selectionEnabled",{replacement:"selectionMode, dragEnabled",version:"4.29",warnOnce:!0}),"none"!==this.selectionMode&&this.dragEnabled}set selectionEnabled(e){s.deprecatedProperty(i.getLogger(this),"selectionEnabled",{replacement:"selectionMode, dragEnabled",version:"4.29",warnOnce:!0}),this.dragEnabled=e,this.selectionMode=e?this.multipleSelectionEnabled?"multiple":"single":"none"}get tableItems(){return this.viewModel.tableItems}get tables(){return this.viewModel.tables}set tables(e){this.viewModel.tables=e}triggerAction(e,t){return this.viewModel.triggerAction(e,t)}render(){const e=this.viewModel?.state,t={[g.globalCss.hidden]:"loading"===e,[g.globalCss.disabled]:"disabled"===e},o=this.tableItems?.filter((e=>!e.hidden&&(this.visibleElements.errors||!e.error)));return I.tsx("div",{class:this.classes(f.css.base,g.globalCss.widget,g.globalCss.panel,t)},o?.length?this._renderItems(o):this._renderNoItems())}_renderNoItemsMessage(){return I.tsx("div",{slot:"message"},this.messages.noItemsToDisplay)}_renderNoItems(){return I.tsx("div",{class:f.css.itemMessage,key:"esri-layer-list__no-items"},I.tsx("calcite-notice",{icon:"information",kind:"info",open:!0,width:"full"},this._renderNoItemsMessage()))}_renderPanelFlowItems(e){return e?.toArray().filter((({panel:e})=>e?.open&&!e.disabled&&e.flowEnabled)).map((({title:e,panel:t})=>{const o=()=>this._handlePanelFlowItemBack(t);return I.tsx("calcite-flow-item",{afterCreate:this._focusPanelFlowItemNode,afterUpdate:this._focusPanelFlowItemNode,bind:this,description:e,heading:t.title,headingLevel:this.headingLevel,key:`flow-panel-${t.uid}`,onCalciteFlowItemBack:e=>{e.preventDefault(),o()}},t.render(),I.tsx("calcite-button",{appearance:"transparent",onclick:o,slot:"footer-actions",width:"full"},this.messagesCommon.back))}))}_handlePanelFlowItemBack(e){e.open=!1,this._focusRootFlowItem=!0}_focusRootFlowItemNode(e){this._focusRootFlowItem&&(this._focusRootFlowItem=!1,_.setFocus(e))}_focusPanelFlowItemNode(e){this._focusPanelFlowItem&&(this._focusPanelFlowItem=!1,_.setFocus(e))}_renderItems(e){const{visible:t,collapsed:o,visibleElements:{closeButton:s,collapseButton:l,heading:i,flow:r},_dragEnabled:n,_filterEnabled:a,_rootGroupUid:d,selectionMode:c,messages:p,filterPlaceholder:m,filterText:h}=this,g=[I.tsx("calcite-flow-item",{afterCreate:this._focusRootFlowItemNode,afterUpdate:this._focusRootFlowItemNode,bind:this,closable:s,closed:!t,collapsed:o,collapsible:l,heading:i?p.widgetLabel:void 0,headingLevel:this.headingLevel,key:"root-flow-item",onCalciteFlowItemClose:()=>this.visible=!1},I.tsx("calcite-list",{canPull:e=>this._canMove(e,"pull"),canPut:e=>this._canMove(e,"put"),"data-layer-type":d,dragEnabled:n,filterEnabled:a,filterPlaceholder:m,filterProps:u.calciteListFilterProps,filterText:a?h:"",group:d,key:"root-list",label:p.widgetLabel,selectionAppearance:"border",selectionMode:c,onCalciteListChange:e=>this._handleCalciteListChange(e),onCalciteListDragEnd:e=>this._handleCalciteListDragEnd(e.detail),onCalciteListFilter:e=>this.filterText=e.target?.filterText??"",onCalciteListOrderChange:e=>this._onCalciteListOrderChange(e.detail)},e?.toArray().map((e=>this._renderItem(e))),e?.length&&a?I.tsx("div",{class:f.css.filterNoResults,slot:"filter-no-results"},I.tsx("calcite-notice",{kind:"info",open:!0,width:"full"},this._renderNoItemsMessage())):null)),this._renderPanelFlowItems(e)];return t?r?I.tsx("calcite-flow",{key:"root-flow"},g):g:null}_handleCalciteListDragEnd(e){const{fromEl:t,dragEl:o,oldIndex:s}=e;t.insertBefore(o,t.children[s])}_renderItem(e){return I.tsx(p,{canMove:this._canMove,css:f.css,dragEnabled:this.dragEnabled,item:e,key:`layerListItem-${e.layer.uid}`,listModeDisabled:this.viewModel.listModeDisabled,messages:this.messages,messagesCommon:this.messagesCommon,rootGroupUid:this._rootGroupUid,selectedDragItemLayerUid:this._selectedDragItemLayerUid,selectedItems:this.selectedItems,selectionMode:this.selectionMode,visibleElements:this.visibleElements,onAction:this._onTriggerAction,onPanelOpen:this._onPanelOpen,onSelectedDragItemLayerUidChange:this._onSelectedDragItemLayerUidChange})}_handleCalciteListChange(e){const{selectionMode:t,selectedItems:o}=this;if("none"===t)return;const s=e.target.selectedItems.map((e=>L.getItem(e))).filter(Boolean);o.removeAll(),o.addMany(s)}};t.__decorate([r.property()],M.prototype,"_focusRootFlowItem",void 0),t.__decorate([r.property()],M.prototype,"_focusPanelFlowItem",void 0),t.__decorate([r.property()],M.prototype,"_dragEnabled",null),t.__decorate([r.property()],M.prototype,"_filterEnabled",null),t.__decorate([r.property()],M.prototype,"collapsed",void 0),t.__decorate([r.property()],M.prototype,"dragEnabled",void 0),t.__decorate([r.property()],M.prototype,"filterPlaceholder",void 0),t.__decorate([r.property()],M.prototype,"filterText",void 0),t.__decorate([r.property()],M.prototype,"headingLevel",void 0),t.__decorate([r.property()],M.prototype,"icon",null),t.__decorate([r.property()],M.prototype,"label",null),t.__decorate([r.property()],M.prototype,"listItemCanGiveFunction",void 0),t.__decorate([r.property()],M.prototype,"listItemCanReceiveFunction",void 0),t.__decorate([r.property()],M.prototype,"listItemCreatedFunction",null),t.__decorate([r.property()],M.prototype,"map",null),t.__decorate([r.property(),b.messageBundle("esri/widgets/TableList/t9n/TableList")],M.prototype,"messages",void 0),t.__decorate([r.property(),b.messageBundle("esri/t9n/common")],M.prototype,"messagesCommon",void 0),t.__decorate([r.property()],M.prototype,"minDragEnabledItems",void 0),t.__decorate([r.property()],M.prototype,"minFilterItems",void 0),t.__decorate([r.property()],M.prototype,"multipleSelectionEnabled",null),t.__decorate([r.property()],M.prototype,"selectionEnabled",null),t.__decorate([r.property()],M.prototype,"selectedItems",void 0),t.__decorate([r.property()],M.prototype,"selectionMode",void 0),t.__decorate([r.property({readOnly:!0})],M.prototype,"tableItems",null),t.__decorate([r.property()],M.prototype,"tables",null),t.__decorate([y.vmEvent("trigger-action"),r.property({type:w})],M.prototype,"viewModel",void 0),t.__decorate([r.property({type:E,nonNullable:!0})],M.prototype,"visibleElements",void 0),M=t.__decorate([d.subclass("esri.widgets.TableList")],M);return M}));
