/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../core/arrayUtils","../core/compilerUtils","../core/deprecate","../core/Logger","../core/reactiveUtils","../core/timeUtils","../core/accessorSupport/decorators/property","../core/accessorSupport/decorators/subclass","../intl/date","../time/TimeInterval","../time/timeZoneUtils","./Slider","./Widget","../chunks/componentsUtils","./support/globalCss","./support/legacyIcon","./support/decorators/accessibleHandler","./support/decorators/messageBundle","./support/decorators/vmEvent","./support/jsxFactory","./support/widgetUtils","../support/themeUtils","./TimeSlider/css","./TimeSlider/TimeSliderViewModel"],(function(e,t,i,s,a,r,o,n,l,u,m,c,d,p,h,v,y,g,x,f,b,_,w,k,T,E){"use strict";const S=3,M=858,C=[{minor:{value:100,unit:"milliseconds"},major:{value:1,unit:"seconds"},format:{second:"numeric"}},{minor:{value:500,unit:"milliseconds"},major:{value:5,unit:"seconds"},format:{second:"numeric"}},{minor:{value:1,unit:"seconds"},major:{value:20,unit:"seconds"},format:{minute:"numeric",second:"numeric"}},{minor:{value:2,unit:"seconds"},major:{value:30,unit:"seconds"},format:{minute:"numeric",second:"numeric"}},{minor:{value:10,unit:"seconds"},major:{value:1,unit:"minutes"},format:{minute:"numeric"}},{minor:{value:15,unit:"seconds"},major:{value:5,unit:"minutes"},format:{hour:"numeric",minute:"numeric"}},{minor:{value:1,unit:"minutes"},major:{value:20,unit:"minutes"},format:{hour:"numeric",minute:"numeric"}},{minor:{value:5,unit:"minutes"},major:{value:2,unit:"hours"},format:{hour:"numeric",minute:"numeric"}},{minor:{value:15,unit:"minutes"},major:{value:6,unit:"hours"},format:{hour:"numeric",minute:"numeric"}},{minor:{value:1,unit:"hours"},major:{value:1,unit:"days"},format:{day:"numeric",month:"short"}},{minor:{value:6,unit:"hours"},major:{value:1,unit:"weeks"},format:{day:"numeric",month:"short"}},{minor:{value:1,unit:"days"},major:{value:1,unit:"months"},format:{month:"long"}},{minor:{value:2,unit:"days"},major:{value:1,unit:"months"},format:{month:"short"}},{minor:{value:3,unit:"days"},major:{value:1,unit:"months"},format:{month:"short"}},{minor:{value:4,unit:"days"},major:{value:3,unit:"months"},format:{month:"short",year:"numeric"}},{minor:{value:1,unit:"weeks"},major:{value:1,unit:"years"},format:{year:"numeric"}},{minor:{value:1,unit:"months"},major:{value:1,unit:"years"},format:{year:"numeric"}},{minor:{value:2,unit:"months"},major:{value:2,unit:"years"},format:{year:"numeric"}},{minor:{value:1,unit:"years"},major:{value:1,unit:"decades"},format:{year:"numeric"}},{minor:{value:2,unit:"years"},major:{value:5,unit:"decades"},format:{year:"numeric"}},{minor:{value:5,unit:"decades"},major:{value:10,unit:"centuries"},format:{era:"short",year:"numeric"}},{minor:{value:1,unit:"centuries"},major:{value:10,unit:"centuries"},format:{era:"short",year:"numeric"}},{minor:{value:2,unit:"centuries"},major:{value:20,unit:"centuries"},format:{era:"short",year:"numeric"}},{minor:{value:5,unit:"centuries"},major:{value:50,unit:"centuries"},format:{era:"short",year:"numeric"}},{minor:{value:10,unit:"centuries"},major:{value:100,unit:"centuries"},format:{era:"short",year:"numeric"}},{minor:{value:20,unit:"centuries"},major:{value:200,unit:"centuries"},format:{era:"short",year:"numeric"}},{minor:{value:50,unit:"centuries"},major:{value:500,unit:"centuries"},format:{era:"short",year:"numeric"}},{minor:{value:100,unit:"centuries"},major:{value:1e3,unit:"centuries"},format:{era:"short",year:"numeric"}},{minor:{value:200,unit:"centuries"},major:{value:1e3,unit:"centuries"},format:{era:"short",year:"numeric"}},{minor:{value:500,unit:"centuries"},major:{value:5e3,unit:"centuries"},format:{era:"short",year:"numeric"}},{minor:{value:1e3,unit:"centuries"},major:{value:1e4,unit:"centuries"},format:{era:"short",year:"numeric"}}];let F=class extends h{constructor(e,t){super(e,t),this._ignoreNextSliderUpdate=!1,this._slider=new p({precision:0,visibleElements:{rangeLabels:!1},rangeLabelInputsEnabled:!1,thumbsConstrained:!1}),this._tickFormat=null,this.disabled=!1,this.labelFormatFunction=null,this.messages=null,this.messagesCommon=null,this.tickConfigs=null,this.timeVisible=!1,this.viewModel=new E}initialize(){this.addHandles([o.watch((()=>this._slider.values),(e=>{if(this._ignoreNextSliderUpdate)return void(this._ignoreNextSliderUpdate=!1);const t=this.viewModel.valuesToTimeExtent(e);null!=this.timeExtent?null!=t?this.timeExtent.equals(t)||(this.timeExtent=t):this.timeExtent=null:null!=t&&(this.timeExtent=t)})),o.watch((()=>this.effectiveStops),(()=>this._updateSliderSteps()),o.initial)])}loadDependencies(){return v.loadCalciteComponents({action:()=>new Promise(((t,i)=>e(["../chunks/calcite-action"],t,i))),"action-menu":()=>new Promise(((t,i)=>e(["../chunks/calcite-action-menu"],t,i)))})}destroy(){this._slider.destroy(),this._tickFormat=null}get _dateFormat(){return this._getIntlOptions("short-date")}get _timeFormat(){return this._getIntlOptions("long-time")}get actions(){return this.viewModel.actions}set actions(e){this.viewModel.actions=e}get effectiveStops(){return this.viewModel.effectiveStops}get fullTimeExtent(){return this.viewModel.fullTimeExtent}set fullTimeExtent(e){this.viewModel.fullTimeExtent=e}get icon(){return"clock"}set icon(e){this._overrideIfSome("icon",e)}get interactive(){return!(this.disabled||"disabled"===this.viewModel.state||this.timeZone===d.unknown)}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}set layout(e){["auto","compact","wide"].includes(e)||(e="auto"),this._set("layout",e)}get loop(){return this.viewModel.loop}set loop(e){this.viewModel.loop=e}get mode(){return this.viewModel.mode}set mode(e){this.viewModel.mode=e}get playRate(){return this.viewModel.playRate}set playRate(e){this.viewModel.playRate=e}get stops(){return this.viewModel.stops}set stops(e){this.viewModel.stops=e}get tickFormats(){const{timeZone:e}=this;return C.map((({minor:t,major:i,format:s})=>({minor:new c(t),major:new c(i),format:{...s,timeZone:e}})))}get timeExtent(){return this.viewModel.timeExtent}set timeExtent(e){this.viewModel.timeExtent=e}get timeZone(){return this.viewModel.view?.timeZone??d.system}set timeZone(e){this._overrideIfSome("timeZone",e)}get view(){return this.viewModel.view}set view(e){this.viewModel.view=e}static async getPropertiesFromWebMap(e,t){return a.deprecatedFunction(r.getLogger("esri.widgets.TimeSlider"),"`TimeSlider.getPropertiesFromWebMap` is deprecated in favor of 'timeUtils.getTimeSliderSettingsFromWebDocument'",{replacement:"timeUtils.getTimeSliderSettingsFromWebDocument",version:"4.29",see:"https://developers.arcgis.com/javascript/latest/api-reference/esri-support-timeUtils.html#getTimeSliderSettingsFromWebDocument",warnOnce:!0}),E.getPropertiesFromWebMap(e,t)}next(){return this.viewModel.next()}play(){return this.viewModel.play()}previous(){return this.viewModel.previous()}stop(){return this.viewModel.stop()}render(){const{_slider:e,actions:t,domNode:s,effectiveStops:a,fullTimeExtent:r,interactive:o,messages:n,messagesCommon:l,mode:u,tickConfigs:c,timeExtent:d,timeVisible:p,viewModel:{state:h,timeExtentValues:v}}=this;if(null!=r){const{start:t,end:i}=r;if(null!=t&&null!=i){const s=t.getTime(),a=i.getTime(),r=e.min!==s||e.max!==a;if(r&&(e.min=s,e.max=a),null!=c)e.tickConfigs!==c&&(e.tickConfigs=c);else{const t=(a-s)/(e.trackElement?.offsetWidth||400),i=this.tickFormats.find((e=>e.minor.toMilliseconds()>S*t))??this.tickFormats.at(-1),o=this._tickFormat!==i&&null!=i;if(o&&(this._tickFormat=i),r||o){const t={mode:"position",values:this._getTickPositions(i.minor),labelsVisible:!1,tickCreatedFunction:(e,t)=>{t?.classList.add(T.css.sliderMinorTick)}},s={mode:"position",values:this._getTickPositions(i.major),labelsVisible:!0,tickCreatedFunction:(e,t)=>{t?.classList.add(T.css.sliderMajorTick)},labelFormatFunction:e=>m.formatDate(e,i.format)};e.tickConfigs=[t,s]}}}}const x=null==this.fullTimeExtent?.start||null==this.fullTimeExtent.end||null==this.timeExtent||this.timeExtent.isAllTime||this.timeExtent.isEmpty||null!=this.timeExtent.start&&(this.timeExtent.start<this.fullTimeExtent.start||this.timeExtent.start>this.fullTimeExtent.end)||null!=this.timeExtent.end&&(this.timeExtent.end>this.fullTimeExtent.end||this.timeExtent.end<this.fullTimeExtent.start);if(x)switch(this._ignoreNextSliderUpdate=!0,u){case"time-window":e.values=[e.min,e.max];break;case"instant":case"cumulative-from-end":e.values=[e.min];break;case"cumulative-from-start":e.values=[e.max]}else null!=v?i.equals(e.values,v)||(e.values=v):e.values=null;e.disabled=!o;const f="ready"===h,b="playing"===h,E=x||!o||null==a||0===a.length,C="auto"===this.layout?s.clientWidth<M?"compact":"wide":this.layout,F=_.tsx("div",{class:T.css.animation},_.tsx("button",{"aria-disabled":E?"true":"false","aria-label":b?l.control.stop:l.control.play,bind:this,class:this.classes(y.globalCss.widgetButton,T.css.animationButton,E&&y.globalCss.buttonDisabled),disabled:E,onclick:this._playOrStopClick,title:b?l.control.stop:l.control.play,type:"button"},_.tsx("div",{class:this.classes((f||E)&&g.legacyIcon.play,b&&g.legacyIcon.pause)}))),j=null!=this.labelFormatFunction?_.tsx("div",{afterCreate:this._createLabel,afterUpdate:this._createLabel,bind:this,class:T.css.timeExtentDate,"data-date":d?[d.start,d.end]:null,"data-layout":C,"data-type":"extent",key:"extent"}):null==d||null!=d&&d.isAllTime?[_.tsx("div",{class:this.classes(T.css.warning,g.legacyIcon.noticeTriangle)}),_.tsx("div",{class:T.css.warningText,key:"warning-text"},n.noTimeExtent)]:d.isEmpty?[_.tsx("div",{class:this.classes(T.css.warning,g.legacyIcon.noticeTriangle)}),_.tsx("div",{class:T.css.warningText,key:"warning-text"},n.emptyTimeExtent)]:[null!=d.start&&_.tsx("div",{class:T.css.timeExtentGroup,key:"start-date-group"},_.tsx("div",{class:T.css.timeExtentDate,key:"start-date"},this._formatDate(d.start)),p?_.tsx("div",{class:T.css.timeExtentTime,key:"start-time"},this._formatTime(d.start)):null),null!=d.start&&null!=d.end&&d.start.getTime()!==d.end.getTime()&&_.tsx("div",{class:T.css.timeExtentSeparator,key:"separator"},"–"),null!=d.end&&(null==d.start||d.start.getTime()!==d.end.getTime())&&_.tsx("div",{class:T.css.timeExtentGroup,key:"end-date-group"},_.tsx("div",{class:T.css.timeExtentDate,key:"end-date"},this._formatDate(d.end)),p?_.tsx("div",{class:T.css.timeExtentTime,key:"end-time"},this._formatTime(d.end)):null)],D=_.tsx("div",{class:this.classes(T.css.timeExtent,!o&&y.globalCss.buttonDisabled)},[j]),U=null!=this.labelFormatFunction?_.tsx("div",{afterCreate:this._createLabel,afterUpdate:this._createLabel,bind:this,class:T.css.minDate,"data-date":r?.start,"data-layout":C,"data-type":"min",key:"min-date"}):null!=r?.start&&[_.tsx("div",{class:T.css.minDate,key:"min-date"},this._formatDate(r.start)),p&&_.tsx("div",{class:T.css.minTime,key:"min-time"},this._formatTime(r.start))],I=_.tsx("div",{class:this.classes(T.css.min,!o&&y.globalCss.buttonDisabled)},[U]),L=_.tsx("div",{class:T.css.slider},e.render()),Z=null!=this.labelFormatFunction?_.tsx("div",{afterCreate:this._createLabel,afterUpdate:this._createLabel,bind:this,class:T.css.maxDate,"data-date":r?.end,"data-layout":C,"data-type":"max",key:"max-date"}):null!=r?.end&&[_.tsx("div",{class:T.css.maxDate,key:"max-date"},this._formatDate(r.end)),p&&_.tsx("div",{class:T.css.maxTime,key:"max-time"},this._formatTime(r.end))],R=_.tsx("div",{class:this.classes(T.css.max,!o&&y.globalCss.buttonDisabled)},[Z]),B=_.tsx("div",{class:T.css.previous},_.tsx("button",{"aria-disabled":E?"true":"false","aria-label":l.pagination.previous,bind:this,class:this.classes(y.globalCss.widgetButton,T.css.previousButton,(b||E)&&y.globalCss.buttonDisabled),disabled:E,onclick:this._previousClick,title:l.pagination.previous,type:"button"},_.tsx("div",{class:g.legacyIcon.reverse}))),O=_.tsx("div",{class:T.css.next},_.tsx("button",{"aria-disabled":E?"true":"false","aria-label":l.pagination.next,bind:this,class:this.classes(y.globalCss.widgetButton,T.css.nextButton,(b||E)&&y.globalCss.buttonDisabled),disabled:E,onclick:this._nextClick,title:l.pagination.next,type:"button"},_.tsx("div",{class:g.legacyIcon.forward}))),W=t?.length>0,P=W&&_.tsx("div",{class:T.css.actions,title:l.options},_.tsx("calcite-action-menu",{class:T.css.actionsButton,label:l.options},t.toArray().map((e=>_.tsx("calcite-action",{bind:this,icon:e.icon,id:e.id,onclick:()=>this.viewModel.triggerAction(e),text:e.title,textEnabled:!0,title:e.title})))));return _.tsx("div",{afterCreate:e=>{this.addHandles(w.onResize(e,(()=>this.scheduleRender())))},"aria-label":n.widgetLabel,class:this.classes(T.css.timeSlider,y.globalCss.widget,`${T.css.timeSliderMode}${u}`,`${T.css.timeSliderLayout}${C}`,!o&&y.globalCss.disabled,x&&T.css.timeSliderOutOfBounds,W&&T.css.hasActions,k.getCalciteThemeClass())},"wide"===C&&_.tsx("div",{class:T.css.timeSliderRow},_.tsx("div",{class:T.css.playbackControls},[F,D,I,L,R,B,O]),P),"compact"===C&&[_.tsx("div",{class:T.css.timeSliderRow,key:"time-slider-row-1"},[D,P]),_.tsx("div",{class:T.css.timeSliderRow,key:"time-slider-row-2"},[L]),_.tsx("div",{class:T.css.timeSliderRow,key:"time-slider-row-3"},[I,B,F,O,R])])}updateWebDocument(e){this.viewModel?.updateWebDocument(e)}_createLabel(e){if(null==this.labelFormatFunction)return;const t=e.getAttribute("data-type"),i=e.getAttribute("data-layout"),s=e["data-date"];this.labelFormatFunction(s,t,e,i)}_formatDate(e){return m.formatDate(e,this._dateFormat)}_formatTime(e){return m.formatDate(e,this._timeFormat)}_getIntlOptions(e){const{timeZone:t}=this;return{...m.convertDateFormatToIntlOptions(e),timeZone:t}}_getTickPositions(e){const{fullTimeExtent:t}=this;if(null==t?.start||null==t.end)return[];const{start:i,end:s}=t,a=[],{value:r,unit:o}=e;let l=n.truncateDate(i,o,this.timeZone);for(;l.getTime()<=s.getTime();)l.getTime()>=i.getTime()&&a.push(l.getTime()),l=n.offsetDate(l,r,o,this.timeZone);return a}_updateSliderSteps(){this._slider.steps=null!=this.effectiveStops&&this.effectiveStops.length>0?this.effectiveStops.map((e=>e.getTime())):null}_playOrStopClick(){switch(this.viewModel.state){case"ready":this.viewModel.play();break;case"playing":this.viewModel.stop();break;case"disabled":break;default:s.neverReached(this.viewModel.state)}}_previousClick(){this.viewModel.previous()}_nextClick(){this.viewModel.next()}};t.__decorate([l.property()],F.prototype,"_dateFormat",null),t.__decorate([l.property()],F.prototype,"_timeFormat",null),t.__decorate([l.property()],F.prototype,"actions",null),t.__decorate([l.property()],F.prototype,"disabled",void 0),t.__decorate([l.property()],F.prototype,"effectiveStops",null),t.__decorate([l.property()],F.prototype,"fullTimeExtent",null),t.__decorate([l.property()],F.prototype,"icon",null),t.__decorate([l.property({readOnly:!0})],F.prototype,"interactive",null),t.__decorate([l.property()],F.prototype,"label",null),t.__decorate([l.property()],F.prototype,"labelFormatFunction",void 0),t.__decorate([l.property({value:"auto"})],F.prototype,"layout",null),t.__decorate([l.property()],F.prototype,"loop",null),t.__decorate([l.property(),f.messageBundle("esri/widgets/TimeSlider/t9n/TimeSlider")],F.prototype,"messages",void 0),t.__decorate([l.property(),f.messageBundle("esri/t9n/common")],F.prototype,"messagesCommon",void 0),t.__decorate([l.property()],F.prototype,"mode",null),t.__decorate([l.property()],F.prototype,"playRate",null),t.__decorate([l.property()],F.prototype,"stops",null),t.__decorate([l.property()],F.prototype,"tickConfigs",void 0),t.__decorate([l.property()],F.prototype,"tickFormats",null),t.__decorate([l.property()],F.prototype,"timeExtent",null),t.__decorate([l.property({nonNullable:!0})],F.prototype,"timeVisible",void 0),t.__decorate([l.property()],F.prototype,"timeZone",null),t.__decorate([l.property()],F.prototype,"view",null),t.__decorate([l.property({type:E}),b.vmEvent("trigger-action")],F.prototype,"viewModel",void 0),t.__decorate([x.accessibleHandler()],F.prototype,"_playOrStopClick",null),t.__decorate([x.accessibleHandler()],F.prototype,"_previousClick",null),t.__decorate([x.accessibleHandler()],F.prototype,"_nextClick",null),F=t.__decorate([u.subclass("esri.widgets.TimeSlider")],F);return F}));
