/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../../chunks/tslib.es6","../../core/Collection","../../core/deprecate","../../core/Evented","../../core/Logger","../../core/promiseUtils","../../core/reactiveUtils","../../core/timeUtils","../../core/accessorSupport/decorators/property","../../core/accessorSupport/ensureType","../../core/RandomLCG","../../core/has","../../core/accessorSupport/decorators/subclass","../../time/TimeExtent","../../time/TimeInterval","../../webdoc/Widgets","../../webdoc/widgets/TimeSlider"],(function(t,e,i,n,r,l,s,o,a,u,m,p,d,c,h,_,g,w){"use strict";const f=1e4;function y(t){return null!=t&&void 0!==t.count}function v(t){return null!=t&&void 0!==t.interval}function T(t){return null!=t&&void 0!==t.dates}let x=class extends r.EventedAccessor{constructor(t){super(t),this._animationController=null,this._isViewTimeExtentInitialized=!1,this._timerId=null,this.actions=new i,this.fullTimeExtent=null,this.loop=!1,this.mode="time-window",this.stops={count:10},this.timeExtent=null,this.view=null}initialize(){this.addHandles([o.watch((()=>this.effectiveStops),(()=>{null==this.timeExtent&&(this.timeExtent=this._getDefaultTimeExtent())}),o.initial),o.watch((()=>this.view),((t,e)=>{this._unregisterWidget(e),this._registerWidget(t)}),o.syncAndInitial),o.watch((()=>this.timeExtent),(t=>{if(null==this.view)return;const e=this.view.timeExtent;(null!=t&&!t.isAllTime||null!=e&&!e.isAllTime)&&(null!=t&&null!=e&&t.equals(e)||(this.view.timeExtent=t))}),o.initial),o.watch((()=>this.view?.timeExtent),(t=>{this._isViewTimeExtentInitialized?(null!=t&&!t.isAllTime||null!=this.timeExtent&&!this.timeExtent.isAllTime)&&(null!=t&&null!=this.timeExtent&&t.equals(this.timeExtent)||(this.timeExtent=t)):this._isViewTimeExtentInitialized=!0}))])}destroy(){null!=this._timerId&&(clearInterval(this._timerId),this._timerId=null),this._unregisterWidget(this.view),this.view=null,null!=this._animationController&&(this._animationController.abort(),this._animationController=null)}get effectiveStops(){const{fullTimeExtent:t,stops:e}=this;if(T(e)){const{dates:i}=e;if(null==i||0===i.length)return null;const n=i.sort(((t,e)=>t.getTime()-e.getTime()));if(null==t)return n;const{start:r,end:l}=t;if(null==r||null==l)return n;return n.filter((t=>!(t.getTime()<r.getTime()||t.getTime()>l.getTime())))}if(y(e)){const i=e.timeExtent??t;return this._divideTimeExtentByCount(i,e.count)}if(v(e)){const i=e.timeExtent??t;return this._divideTimeExtentByInterval(i,e.interval)}return[]}set playRate(t){t<=0||t>36e5||("playing"===this.state&&this._startAnimation(),this._set("playRate",t))}get state(){return null==this.fullTimeExtent?"disabled":null!=this._animationController?"playing":"ready"}get timeExtentValues(){const{mode:t,timeExtent:e}=this;if(null==e||e.isAllTime||e.isEmpty)return null;const{start:i,end:n}=e;switch(t){case"cumulative-from-end":case"instant":return null!=i?[i.getTime()]:null;case"cumulative-from-start":return null!=n?[n.getTime()]:null;case"time-window":return null!=i&&null!=n?[i.getTime(),n.getTime()]:null}}static async getPropertiesFromWebMap(e,i){n.deprecatedFunction(l.getLogger("esri.widgets.TimeSlider.TimeSliderViewModel"),"`TimeSliderViewModel.getPropertiesFromWebMap` is deprecated in favor of 'timeUtils.getTimeSliderSettingsFromWebDocument'",{replacement:"timeUtils.getTimeSliderSettingsFromWebDocument",version:"4.29",see:"https://developers.arcgis.com/javascript/latest/api-reference/esri-support-timeUtils.html#getTimeSliderSettingsFromWebDocument",warnOnce:!0});const{getTimeSliderSettingsFromWebDocument:r}=await new Promise(((e,i)=>t(["../../support/timeUtils"],e,i)));return r(e,i)}next(){this._step({forward:!0,allowRestart:!1})}play(){this._startAnimation()}previous(){this._step({forward:!1,allowRestart:!1})}stop(){this._stopAnimation()}triggerAction(t){this.emit("trigger-action",{action:t})}updateWebDocument(t){const e=new w({currentTimeExtent:this.timeExtent,fullTimeExtent:this.fullTimeExtent,loop:this.loop,numStops:y(this.stops)?this.stops.count:null,numThumbs:"time-window"===this.mode?2:1,stopDelay:this.playRate,stopInterval:v(this.stops)?this.stops.interval:null,stops:T(this.stops)?this.stops.dates:null});t.widgets?t.widgets.timeSlider=e:t.widgets=new g({timeSlider:e})}valuesToTimeExtent(t){if(null==t)return null;const e=t.sort(((t,e)=>t-e)).map((t=>new Date(t))),i=e.length>0?e[0]:null,n=e.length>1?e[1]:null;switch(this.mode){case"time-window":return new h({start:i,end:n});case"instant":return new h({start:i,end:i});case"cumulative-from-start":return new h({start:null,end:i});case"cumulative-from-end":return new h({start:i,end:null});default:return h.allTime}}async _animate(){try{const t=this.view,e=this._animationController?.signal;await Promise.all([s.after(this.playRate,null,e),null!=t&&o.whenOnce((()=>!1===t.updating),e)])}catch(t){return s.isAbortError(t)||l.getLogger(this).error(t),void(this._animationController=null)}this._step({forward:!0,allowRestart:!1}),null!=this._animationController&&this._animate()}_divideTimeExtentByCount(t,e=10){if(!t||!e)return[];const{start:i,end:n}=t;if(null==i||null==n)return[];if(e>f)return this._divideTimeExtentByCount(t);const r=[],l=i.getTime(),s=n.getTime()-l;for(let o=0;o<=e;o++)r.push(new Date(l+o/e*s));return r}_divideTimeExtentByInterval(t,e,i=f){if(!t||!e)return[];const{start:n,end:r}=t;if(null==n||null==r)return[];const l=r.getTime()-n.getTime(),s=e.toMilliseconds();if(s<=0||l/s>i)return this._divideTimeExtentByCount(t);const o=[],{value:u,unit:m}=e;let p=n;for(;p.getTime()<=r.getTime();)o.push(new Date(p.getTime())),p=a.offsetDate(p,u,m);return o}_getDefaultTimeExtent(){const{effectiveStops:t,mode:e}=this;if(null==t||!e)return null;switch(e){case"time-window":return t.length>1?new h({start:t[0],end:t[1]}):null;case"cumulative-from-start":return t.length>0?new h({start:null,end:t[0]}):null;case"cumulative-from-end":return t.length>0?new h({start:t[0],end:null}):null;case"instant":return t.length>0?new h({start:t[0],end:t[0]}):null;default:return null}}_registerWidget(t){if(null!=t){t.persistableViewModels.includes(this)||t.persistableViewModels.add(this)}}_startAnimation(){this._stopAnimation(),this._animationController=new AbortController,this._step({forward:!0,allowRestart:!0}),this._animate()}_step(t){const{forward:e,allowRestart:i}=t,{effectiveStops:n}=this;if(null==this.timeExtentValues||null==n)return;const r=n.map((t=>t.getTime())),l=this.timeExtentValues.map((t=>{const e=r.indexOf(t);if(-1!==e)return e;const i=r.reduce(((e,i)=>Math.abs(i-t)<Math.abs(e-t)?i:e));return r.indexOf(i)})),s=l.map((t=>t+(e?1:-1))),o=s.some((t=>t<0||t>r.length-1)),{loop:a,state:u}=this;if(o)if(a||i){const t=Math.min(...l),i=Math.max(...l),n=(e?l.map((e=>e-t)):l.map((t=>t+(r.length-1-i)))).map((t=>r[t]));this.timeExtent=this.valuesToTimeExtent(n)}else"playing"===u&&this.stop();else{const t=s.map((t=>r[t]));this.timeExtent=this.valuesToTimeExtent(t)}}_stopAnimation(){null!=this._animationController&&(this._animationController.abort(),this._animationController=null)}_unregisterWidget(t){null!=t&&t.persistableViewModels.remove(this)}};e.__decorate([u.property()],x.prototype,"_animationController",void 0),e.__decorate([u.property({type:i})],x.prototype,"actions",void 0),e.__decorate([u.property({readOnly:!0})],x.prototype,"effectiveStops",null),e.__decorate([u.property({type:h})],x.prototype,"fullTimeExtent",void 0),e.__decorate([u.property({nonNullable:!0})],x.prototype,"loop",void 0),e.__decorate([u.property({nonNullable:!0})],x.prototype,"mode",void 0),e.__decorate([u.property({nonNullable:!0,value:1e3})],x.prototype,"playRate",null),e.__decorate([u.property({readOnly:!0})],x.prototype,"state",null),e.__decorate([u.property({cast:t=>null==t?null:(v(t)&&(t.interval=m.ensureType(_,t.interval)),(v(t)||y(t))&&(t.timeExtent=m.ensureType(h,t.timeExtent)),t)})],x.prototype,"stops",void 0),e.__decorate([u.property({type:h})],x.prototype,"timeExtent",void 0),e.__decorate([u.property({readOnly:!0})],x.prototype,"timeExtentValues",null),e.__decorate([u.property()],x.prototype,"view",void 0),e.__decorate([u.property()],x.prototype,"next",null),e.__decorate([u.property()],x.prototype,"play",null),e.__decorate([u.property()],x.prototype,"previous",null),e.__decorate([u.property()],x.prototype,"stop",null),e.__decorate([u.property()],x.prototype,"updateWebDocument",null),x=e.__decorate([c.subclass("esri.widgets.TimeSlider.TimeSliderViewModel")],x);return x}));
