/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../Graphic","../../intl","../../core/Accessor","../../core/Collection","../../core/Error","../../core/Logger","../../core/reactiveUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../../core/support/UpdatingHandles","../../layers/GraphicsLayer","../../symbols/LineSymbolMarker","../../symbols/SimpleLineSymbol","../../views/draw/support/layerUtils","../../intl/locale","../../intl/messages"],(function(t,i,e,s,o,r,n,a,c,l,h,y,u,p,d,m,A,w,v){"use strict";const _={noAssociationTypeSpecified:-2147208504};let L=class extends s{constructor(t){super(t),this._internalGraphicsLayerConnectivity=this._createInternalGraphicsLayer("Connectivity Associations (Internal)"),this._internalGraphicsLayerStructuralAttachment=this._createInternalGraphicsLayer("Structural Attachment Associations (Internal)"),this._initialValidationsFinished=!1,this._updatingHandles=new u.UpdatingHandles,this.autoRefreshAssociations=!1,this.connectivityAssociationsLineSymbol=new m({style:"short-dash",width:2,color:[190,159,159,1]}),this.executionError="",this.loadErrors=new o,this.maxAllowableAssociations=250,this.showAssociationsEnabled=!1,this.showArrowsConnectivity=!1,this.showArrowsStructuralAttachment=!1,this.structuralAttachmentAssociationsLineSymbol=new m({style:"short-dash",width:2,color:[159,190,159,1]})}initialize(){const t=async()=>{this.messages||(this.messages=await v.fetchMessageBundle("esri/widgets/UtilityNetworkAssociations/t9n/UtilityNetworkAssociations"))};t().then((()=>{this.view||(this.view=null),this.utilityNetwork||(this.utilityNetwork=null),this.addHandles([a.watch((()=>[this.view,this.utilityNetwork]),(async()=>{const{loadErrors:t,messages:{info:{noUtilityNetwork:i,noView:e}}}=this;this._initialValidationsFinished=!1,t.removeAll();let s=!1,o=!1;this.removeAssociations(),"utility"!==this.utilityNetwork?.type?(this.loadErrors.push(i),n.getLogger(this).error(new r("utilityNetworkAssociations:missing-property",i))):(this.utilityNetwork.loaded||await this.utilityNetwork.load(),s=!0),"2d"!==this.view?.type?(this.loadErrors.push(e),n.getLogger(this).error(new r("utilityNetworkAssociations:missing-property",e))):(A.addUniqueLayer(this.view,this._internalGraphicsLayerConnectivity),A.addUniqueLayer(this.view,this._internalGraphicsLayerStructuralAttachment),o=!0),s&&o&&this.showAssociationsEnabled&&await this.showAssociations(),this._internalGraphicsLayerConnectivity.visible=this.includeConnectivityAssociations,this._internalGraphicsLayerStructuralAttachment.visible=this.includeStructuralAttachmentAssociations,this._initialValidationsFinished=!0}),{initial:!0}),a.watch((()=>[this.view?.stationary,this.showAssociationsEnabled,this.maxAllowableAssociations]),(async()=>{this.view?.stationary&&this.showAssociationsEnabled&&(this.includeConnectivityAssociations||this.includeStructuralAttachmentAssociations)&&await this.showAssociations()})),a.watch((()=>[this.showArrowsConnectivity]),(()=>{const t=this.connectivityAssociationsLineSymbol.clone();t.marker=null,this.showArrowsConnectivity&&(t.marker=new d({color:this.connectivityAssociationsLineSymbol.color,placement:"end",style:"arrow"}));for(const i of this._internalGraphicsLayerConnectivity.graphics)i.symbol=t})),a.watch((()=>[this.showArrowsStructuralAttachment]),(()=>{const t=this.structuralAttachmentAssociationsLineSymbol.clone();t.marker=null,this.showArrowsStructuralAttachment&&(t.marker=new d({color:this.structuralAttachmentAssociationsLineSymbol.color,placement:"end",style:"arrow"}));for(const i of this._internalGraphicsLayerStructuralAttachment.graphics)i.symbol=t})),a.watch((()=>{const{cap:t,color:i,style:e,width:s,marker:o}=this.connectivityAssociationsLineSymbol;return[t,i,e,s,o]}),(()=>{const t=this.connectivityAssociationsLineSymbol.clone();for(const i of this._internalGraphicsLayerConnectivity.graphics)i.symbol=t;this.showArrowsConnectivity=!1,t.marker=null,this.connectivityAssociationsLineSymbol.marker&&(this.showArrowsConnectivity=!0,t.marker=new d({color:this.connectivityAssociationsLineSymbol.color,placement:"end",style:"arrow"}))})),a.watch((()=>{const{cap:t,color:i,style:e,width:s,marker:o}=this.structuralAttachmentAssociationsLineSymbol;return[t,i,e,s,o]}),(()=>{const t=this.structuralAttachmentAssociationsLineSymbol.clone();for(const i of this._internalGraphicsLayerStructuralAttachment.graphics)i.symbol=t;this.showArrowsStructuralAttachment=!1,t.marker=null,this.structuralAttachmentAssociationsLineSymbol.marker&&(this.showArrowsStructuralAttachment=!0,t.marker=new d({color:this.structuralAttachmentAssociationsLineSymbol.color,placement:"end",style:"arrow"}))})),w.onLocaleChange(t)])}))}destroy(){this._updatingHandles.destroy(),this.view=null,this._removeInternalGraphicsLayers()}set includeConnectivityAssociations(t){this._set("includeConnectivityAssociations",t),this._internalGraphicsLayerConnectivity.visible=t}set includeStructuralAttachmentAssociations(t){this._set("includeStructuralAttachmentAssociations",t),this._internalGraphicsLayerStructuralAttachment.visible=t}get state(){return this.loadErrors.length?"disabled":this._updatingHandles.updating?"executing":""!==this.executionError?"warning":this._initialValidationsFinished?"ready":"loading"}set utilityNetwork(t){this._get("utilityNetwork")!==t&&this._set("utilityNetwork",t)}set view(t){this._get("view")!==t&&this._set("view",t)}removeAssociations(){this._internalGraphicsLayerConnectivity.removeAll(),this._internalGraphicsLayerStructuralAttachment.removeAll()}async showAssociations(){const{messages:{info:{maxAllowableAssociationsExceeded:t,noAssociationsFound:e,noAssociationTypeSpecified:s}},utilityNetwork:o}=this;this._set("executionError","");const n={extent:this.view?.extent,gdbVersion:this.utilityNetwork?.gdbVersion,maxGeometryCount:this.maxAllowableAssociations,moment:this.utilityNetwork?.historicMoment,outSpatialReference:this.view?.spatialReference.clone(),returnConnectivityAssociations:this.includeConnectivityAssociations,returnAttachmentAssociations:this.includeStructuralAttachmentAssociations};this._updatingHandles.addPromise(o?.synthesizeAssociationGeometries(n).then((s=>{let o=[],r=[];return s?.maxGeometryCountExceeded?(this.removeAssociations(),void this._set("executionError",t)):0===s?.associations.length?(this.removeAssociations(),void this._set("executionError",e)):void(s&&(o=s?.associations.filter((({associationType:t})=>"connectivity"===t)).map((t=>(this.connectivityAssociationsLineSymbol.marker=null,this.showArrowsConnectivity&&(this.connectivityAssociationsLineSymbol.marker=new d({color:this.connectivityAssociationsLineSymbol.color,placement:"end",style:"arrow"})),new i({geometry:t.geometry.clone(),symbol:this.connectivityAssociationsLineSymbol})))),r=s.associations.filter((({associationType:t})=>"attachment"===t)).map((t=>(this.structuralAttachmentAssociationsLineSymbol.marker=null,this.showArrowsStructuralAttachment&&(this.structuralAttachmentAssociationsLineSymbol.marker=new d({color:this.structuralAttachmentAssociationsLineSymbol.color,placement:"end",style:"arrow"})),new i({geometry:t.geometry.clone(),symbol:this.structuralAttachmentAssociationsLineSymbol})))),this._internalGraphicsLayerConnectivity.removeAll(),o.length>0&&this._internalGraphicsLayerConnectivity.addMany(o),this._internalGraphicsLayerStructuralAttachment.removeAll(),r.length>0&&this._internalGraphicsLayerStructuralAttachment.addMany(r)))}),(t=>{let i="Error: "+t;if(t instanceof r&&t.details?.raw)if(t.details.raw.extendedCode===_.noAssociationTypeSpecified)i=s;else i=t.details.message;this._set("executionError",i)})))}_createInternalGraphicsLayer(t){return new p({listMode:"hide",internal:!0,title:t})}_removeInternalGraphicsLayers(){this._internalGraphicsLayerConnectivity&&this._internalGraphicsLayerStructuralAttachment&&this.view?.map&&(this.view.map.remove(this._internalGraphicsLayerConnectivity),this.view.map.remove(this._internalGraphicsLayerStructuralAttachment))}};t.__decorate([c.property()],L.prototype,"_initialValidationsFinished",void 0),t.__decorate([c.property()],L.prototype,"autoRefreshAssociations",void 0),t.__decorate([c.property({type:m,nonNullable:!0})],L.prototype,"connectivityAssociationsLineSymbol",void 0),t.__decorate([c.property({readOnly:!0})],L.prototype,"executionError",void 0),t.__decorate([c.property({type:Boolean,value:!0})],L.prototype,"includeConnectivityAssociations",null),t.__decorate([c.property({type:Boolean,value:!0})],L.prototype,"includeStructuralAttachmentAssociations",null),t.__decorate([c.property()],L.prototype,"loadErrors",void 0),t.__decorate([c.property()],L.prototype,"maxAllowableAssociations",void 0),t.__decorate([c.property()],L.prototype,"messages",void 0),t.__decorate([c.property()],L.prototype,"showAssociationsEnabled",void 0),t.__decorate([c.property()],L.prototype,"showArrowsConnectivity",void 0),t.__decorate([c.property()],L.prototype,"showArrowsStructuralAttachment",void 0),t.__decorate([c.property({readOnly:!0})],L.prototype,"state",null),t.__decorate([c.property({type:m,nonNullable:!0})],L.prototype,"structuralAttachmentAssociationsLineSymbol",void 0),t.__decorate([c.property()],L.prototype,"utilityNetwork",null),t.__decorate([c.property()],L.prototype,"view",null),L=t.__decorate([y.subclass("esri.widgets.UtilityNetworkAssociations.UtilityNetworkAssociationsViewModel")],L);return L}));
