/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../core/deprecate","../core/Logger","../core/reactiveUtils","../core/accessorSupport/decorators/property","../core/has","../core/RandomLCG","../core/accessorSupport/decorators/subclass","../layers/support/CodedValueDomain","./Widget","../chunks/componentsUtils","./support/globalCss","./support/widgetUtils","./support/decorators/messageBundle","./support/decorators/vmEvent","./support/jsxFactory","./UtilityNetworkTrace/UtilityNetworkTraceViewModel","./UtilityNetworkTrace/support/GraphicHandler"],(function(e,t,s,i,r,l,o,a,n,c,d,h,u,p,g,_,w,m,v){"use strict";const b="esri-utility-trace-network",y={base:b,loaderContainer:`${b}__loader-container`,loader:`${b}__loader`,fadeIn:`${b}--fade-in`,addButtonContainer:`${b}__add-button-container`,noticeContainer:`${b}__notice-container`,listContainer:`${b}__list-container`,resultsContainer:`${b}__results-container`,flow:`${b}__flow`,numberInput:`${b}__number-input`,clearPrompt:`${b}__reset-prompt`,promptDivider:`${b}__divider`,paddingTop:`${b}__padTop`};function x(e){return{height:e+"px"}}function T(e){return{width:e+"px"}}function f(){return{width:"75%"}}function S(){return{textAlign:"center",padding:"1rem"}}function k(e){return{width:"100%",height:window.getComputedStyle(e).getPropertyValue("max-height")}}function R(){return{height:"100%"}}function C(e){return{display:"flex",flexDirection:e}}function A(e){return e instanceof c}const F={noExtension:-2147208474};let M=class extends d{constructor(e,t){super(e,t),this._selectToolActive=!1,this._activeTrace=null,this._activeSwatch="",this._traceHeaderForFlow="",this._assetGroupHeader="",this._assetTypeHeader="",this._traceResultsFunctions=[],this._traceResultsAssetGroup=[],this._traceResultsAssetType=[],this._traceResultsIndividual=[],this._showTraceResultFunctions=!1,this._showTraceResultAssetGroup=!1,this._showTraceResultAssetType=!1,this._showIndividualRecords=!1,this._activeTab="input",this._flagViewType="starting-point",this._alertRemoveModal=!1,this._warningNoFlag=!1,this._warningNoTraceSelected=!1,this._warningNoStartAssetFound=!1,this._warningNoBarrierAssetFound=!1,this._warningNoTerminal=!1,this._confirmReset=!1,this._showResultOptions=!1,this._resultObjectIdField="objectid",this._resultDisplayField="objectid",this._resultSortField="objectid",this._resultSortOrder="desc",this._swatchNode=null,this._individualResultNode=null,this._symbolStartFlag=null,this._symbolBarrier=null,this._watchHandler=null,this._loadUNError=!0,this._errorMessage="",this.disabled=!0,this.inputSettings=[],this.messages=null,this.messagesCommon=null,this.messagesUnits=null,this.viewModel=new m,this._afterComponentCreate=this._afterComponentCreate.bind(this)}initialize(){this._utilityNetworkTraceInitialized(),this.addHandles(r.watch((()=>this.viewModel?.resultAreaProperties),(()=>this.scheduleRender())))}get defaultGraphicColor(){return this.viewModel.defaultGraphicColor}set defaultGraphicColor(e){this.viewModel.defaultGraphicColor=e}get flags(){return this.viewModel.flags}set flags(e){this.viewModel.flags=e}get gdbVersion(){return s.deprecatedFunction(i.getLogger(this),"gdbVersion will be removed and the gdbVersion of the UtilityNetwork will be consumed directly.",{replacement:"UtilityNetwork.gdbVersion",version:"4.31"}),this.viewModel.gdbVersion}set gdbVersion(e){s.deprecatedFunction(i.getLogger(this),"gdbVersion will be removed and the gdbVersion of the UtilityNetwork will be consumed directly.",{replacement:"UtilityNetwork.gdbVersion",version:"4.31"}),this.viewModel.gdbVersion=e}get icon(){return"utility-network-trace"}set icon(e){this._overrideIfSome("icon",e)}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}get resultAreaProperties(){return this.viewModel.resultAreaProperties}set resultAreaProperties(e){this.viewModel.resultAreaProperties=e}get selectedTraces(){return this.viewModel.selectedTraces}set selectedTraces(e){this.viewModel.selectedTraces=e}get selectOnComplete(){return this.viewModel.selectOnComplete}set selectOnComplete(e){this.viewModel.selectOnComplete=e}get showGraphicsOnComplete(){return this.viewModel.showGraphicsOnComplete}set showGraphicsOnComplete(e){this.viewModel.showGraphicsOnComplete=e}get enableResultArea(){return this.viewModel.enableResultArea}set enableResultArea(e){this.viewModel.enableResultArea=e}get showSelectionAttributes(){return this.viewModel.showSelectionAttributes}set showSelectionAttributes(e){this.viewModel.showSelectionAttributes=e}get utilityNetwork(){return this.viewModel.utilityNetwork}set utilityNetwork(e){this.viewModel.utilityNetwork=e}get view(){return this.viewModel.view}set view(e){this.viewModel.view=e}async checkCanTrace(){this._confirmReset=!1;const e=this.viewModel.checkCanTrace();e.status?(this._warningNoFlag=!1,this._warningNoTraceSelected=!1,this._warningNoTraceSelected=!1,this._warningNoTerminal=!1,this._showTraceResultFunctions=!1,this._showTraceResultAssetGroup=!1,this._showTraceResultAssetType=!1,this._showIndividualRecords=!1,this.switchTab("result"),this.viewModel._activeProgress=!0,this.viewModel.removeAllResultAreaGraphics(),await this.viewModel.callTrace(),this.viewModel._activeProgress=!1):e.issues.forEach((e=>{switch(e){case"noStart":this._warningNoFlag=!0;break;case"noTerminalSelected":this._warningNoTerminal=!0;break;default:this._warningNoTraceSelected=!0}}))}confirmReset(){this._confirmReset=!0}render(){const{state:e}=this.viewModel;this._mixCustomStrings(),this._overrideFlagSymbol();const t="loading"===e?this._renderWarningMessage("noTraceConfig",!1):this._renderUtilityNetworkTrace();return w.tsx("div",{class:this.classes(y.base,u.globalCss.widget,u.globalCss.panel,{[u.globalCss.widgetDisabled]:this.disabled}),styles:R()},t)}loadDependencies(){return h.loadCalciteComponents({action:()=>new Promise(((t,s)=>e(["../chunks/calcite-action"],t,s))),"action-group":()=>new Promise(((t,s)=>e(["../chunks/calcite-action-group"],t,s))),"action-pad":()=>new Promise(((t,s)=>e(["../chunks/calcite-action-pad"],t,s))),block:()=>new Promise(((t,s)=>e(["../chunks/calcite-block"],t,s))),"block-section":()=>new Promise(((t,s)=>e(["../chunks/calcite-block-section"],t,s))),button:()=>new Promise(((t,s)=>e(["../chunks/calcite-button"],t,s))),checkbox:()=>new Promise(((t,s)=>e(["../chunks/calcite-checkbox"],t,s))),"color-picker-swatch":()=>new Promise(((t,s)=>e(["../chunks/calcite-color-picker-swatch"],t,s))),combobox:()=>new Promise(((t,s)=>e(["../chunks/calcite-combobox"],t,s))),"combobox-item":()=>new Promise(((t,s)=>e(["../chunks/calcite-combobox-item"],t,s))),flow:()=>new Promise(((t,s)=>e(["../chunks/calcite-flow"],t,s))),"flow-item":()=>new Promise(((t,s)=>e(["../chunks/calcite-flow-item"],t,s))),icon:()=>new Promise(((t,s)=>e(["../chunks/calcite-icon"],t,s))),"input-number":()=>new Promise(((t,s)=>e(["../chunks/calcite-input-number"],t,s))),label:()=>new Promise(((t,s)=>e(["../chunks/calcite-label"],t,s))),list:()=>new Promise(((t,s)=>e(["../chunks/calcite-list"],t,s))),"list-item":()=>new Promise(((t,s)=>e(["../chunks/calcite-list-item"],t,s))),loader:()=>new Promise(((t,s)=>e(["../chunks/calcite-loader"],t,s))),notice:()=>new Promise(((t,s)=>e(["../chunks/calcite-notice"],t,s))),option:()=>new Promise(((t,s)=>e(["../chunks/calcite-option"],t,s))),panel:()=>new Promise(((t,s)=>e(["../chunks/calcite-panel"],t,s))),popover:()=>new Promise(((t,s)=>e(["../chunks/calcite-popover"],t,s))),scrim:()=>new Promise(((t,s)=>e(["../chunks/calcite-scrim"],t,s))),select:()=>new Promise(((t,s)=>e(["../chunks/calcite-select"],t,s))),tab:()=>new Promise(((t,s)=>e(["../chunks/calcite-tab"],t,s))),"tab-nav":()=>new Promise(((t,s)=>e(["../chunks/calcite-tab-nav"],t,s))),"tab-title":()=>new Promise(((t,s)=>e(["../chunks/calcite-tab-title"],t,s))),tabs:()=>new Promise(((t,s)=>e(["../chunks/calcite-tabs"],t,s))),tooltip:()=>new Promise(((t,s)=>e(["../chunks/calcite-tooltip"],t,s)))})}switchTab(e){this._activeTab=e}switchToFunctions(e,t){this._traceResultsFunctions=e,this._showTraceResultFunctions=t}switchToAssetGroup(e,t,s){this._traceHeaderForFlow=t,this._traceResultsAssetGroup=e,this._showTraceResultAssetGroup=s}switchToAssetType(e,t,s){this._assetGroupHeader=t,this._traceResultsAssetType=e,this._showTraceResultAssetType=s}switchToIndividualRecords(e,t,s){this._assetTypeHeader=t,this._traceResultsIndividual=e,this._showIndividualRecords=s}_renderUtilityNetworkTrace(){const{messages:e,messagesCommon:t}=this;let s=w.tsx("calcite-tabs",{layout:"center",position:"top",styles:k(this.container)},w.tsx("calcite-tab-nav",{slot:"title-group"},w.tsx("calcite-tab-title",{onclick:()=>{this.switchTab("input")},selected:"input"===this._activeTab},e.inputsStrings.headerTabInputs),w.tsx("calcite-tab-title",{onclick:()=>{this.switchTab("result")},selected:"result"===this._activeTab},e.resultsStrings.headerTabResults)),w.tsx("calcite-tab",{selected:"input"===this._activeTab},this._renderInputPanel()),w.tsx("calcite-tab",{selected:"result"===this._activeTab},this.viewModel._activeProgress?w.tsx("calcite-loader",{label:e.alertsStrings.traceExecuting,text:e.alertsStrings.traceExecuting,type:"indeterminate"}):this.viewModel.traceResults.length>0?this._renderResultPanel():this._renderWarningMessage("noTraceExecuted",!1),this._confirmReset?w.tsx("calcite-scrim",{key:"prompt"},w.tsx("div",{class:y.clearPrompt},w.tsx("h3",{slot:"header"},e.resultsStrings.startOverButton),w.tsx("div",{slot:"content"},e.resultsStrings.startOverValidation),w.tsx("div",{class:y.promptDivider}),w.tsx("div",{styles:C("row")},w.tsx("calcite-button",{appearance:"outline",onclick:()=>{this._confirmReset=!1},slot:"secondary",width:"full"},t.cancel),w.tsx("calcite-button",{onclick:()=>{this._confirmReset=!1,this.viewModel.reset(),this.switchTab("input")},slot:"primary",width:"full"},t.form.ok)))):null));return 0===this.viewModel.traces.length&&(s=w.tsx("calcite-panel",null,this._renderWarningMessage("noTraceConfig",!1))),this._loadUNError||(s=w.tsx("calcite-panel",null,this._renderWarningMessage("loadUNError",!1,this._errorMessage))),s}_renderInputPanel(){const{messages:e}=this;return w.tsx("calcite-flow",{class:y.flow},w.tsx("calcite-flow-item",null,this._warningNoFlag?this._renderWarningMessage("flag",!0):null,this._warningNoTerminal?this._renderWarningMessage("noTerminal",!0):null,this._warningNoTraceSelected?this._renderWarningMessage("trace",!0):null,this._renderTraceSelectorContainer(),this._renderStartFlagsContainer(),this._renderBarriersFlagsContainer(),this._warningNoFlag&&this._warningNoTraceSelected?w.tsx("div",{styles:x(10)}):null,w.tsx("calcite-button",{kind:"brand",onclick:()=>{this.checkCanTrace()},slot:"footer",width:"full"},e.tracingStrings.runTrace)),this._selectToolActive?this._renderActiveTool():null)}_renderResultPanel(){return w.tsx("calcite-flow",{styles:R()},this._renderTraceResults(),this._showTraceResultFunctions?this._renderTraceResultFunctions():null,this._showTraceResultAssetGroup?this._renderTraceResultByAssetGroup():null,this._showTraceResultAssetType?this._renderTraceResultByAssetType():null,this._showIndividualRecords?this._renderTraceResultIndividual():null,this._showIndividualRecords?this._renderTraceResultIndividualPopover():null)}_renderStartFlagsContainer(){const{messages:e}=this,t=[];let s=[];s=this.viewModel._flags.filter((e=>"starting-point"===e.type)),s.forEach((e=>{e.displayValue&&t.push(this._renderFlagRow(e,"start"))}));let i=null;return this._symbolStartFlag&&(i=this._getSymbolIcon(this._symbolStartFlag)),w.tsx("calcite-block",{collapsible:!0,heading:e.inputsStrings.headerStartingPoint+" ("+s.length+")",open:!0,overlayPositioning:"fixed"},w.tsx("div",{slot:"icon"},i||w.tsx("calcite-icon",{icon:"pin",scale:"s"})),w.tsx("div",null,e.inputsStrings.startingPointHint),w.tsx("div",{class:y.listContainer},t),this._warningNoStartAssetFound?this._renderWarningMessage("noStartAsset",!0):null,w.tsx("div",{class:y.addButtonContainer},w.tsx("calcite-button",{alignment:"center",appearance:"outline",href:"",iconStart:"plus",label:e.inputsStrings.addPointOption,onclick:()=>{this._changeCursor("crosshair"),this._flagViewType="starting-point",this._selectToolActive=!0,this._warningNoStartAssetFound=!1,this.viewModel.addFlagByHit("starting-point",this._symbolStartFlag).then((e=>{this._changeCursor("default"),e?this._warningNoFlag=!1:this._warningNoStartAssetFound=!0,this._selectToolActive=!1}))},round:!0})))}_renderBarriersFlagsContainer(){const{messages:e}=this,t=[];let s=[];s=this.viewModel._flags.filter((e=>"barrier"===e.type)),s.forEach((e=>{e.displayValue&&t.push(this._renderFlagRow(e,"barrier"))}));let i=null;return this._symbolBarrier&&(i=this._getSymbolIcon(this._symbolBarrier)),w.tsx("calcite-block",{collapsible:!0,heading:e.inputsStrings.headerBarrier+" ("+s.length+")",open:!1,overlayPositioning:"fixed"},w.tsx("div",{slot:"icon"},i||w.tsx("calcite-icon",{icon:"x-circle-f",scale:"s"})),w.tsx("div",null,e.inputsStrings.barrierPointHint),w.tsx("div",{class:y.listContainer},t),this._warningNoBarrierAssetFound?this._renderWarningMessage("noBarrierAsset",!0):null,w.tsx("div",{class:y.addButtonContainer},w.tsx("calcite-button",{alignment:"center",appearance:"outline",href:"",iconStart:"plus",kind:"brand",label:e.inputsStrings.addPointOption,onclick:()=>{this._changeCursor("crosshair"),this._flagViewType="barrier",this._selectToolActive=!0,this._warningNoBarrierAssetFound=!1,this.viewModel.addFlagByHit("barrier",this._symbolBarrier).then((e=>{this._changeCursor("default"),e||(this._warningNoBarrierAssetFound=!0),this._selectToolActive=!1}))},round:!0})))}_renderFlagRow(e,t){const{messages:s,messagesCommon:i}=this,r=[];let l=!1;return null!=e.allTerminals&&e.allTerminals.terminals.length>0&&(l=!0,e.allTerminals.terminals.forEach((t=>{let s=!1;e?.selectedTerminals?.includes(t.id)&&(s=!0),r.push(w.tsx("calcite-combobox-item",{key:t.name,selected:s,textLabel:t.name,value:t.id}))}))),w.tsx("calcite-block",{collapsible:null!==e.allTerminals||"barrier"===e.type,heading:e.displayValue?.value??"",key:"pop"+e.globalId+e.type+e.id+t,overlayPositioning:"fixed"},w.tsx("calcite-action",{icon:"trash",label:i.remove,onclick:()=>{this.viewModel.removeFlag(e)},scale:"s",slot:"header-menu-actions",text:i.remove,textEnabled:!0}),w.tsx("calcite-action",{icon:"zoom-to-object",label:s.globalStrings.zoomToFeature,onclick:()=>{this.viewModel.zoomToAsset(e.details.geometry)},scale:"s",slot:"header-menu-actions",text:s.globalStrings.zoomToFeature,textEnabled:!0}),"barrier"===e.type?w.tsx("calcite-label",{layout:"inline",scale:"s"},w.tsx("calcite-checkbox",{checked:e.isFilterBarrier,onclick:()=>{this.viewModel.manageFilterBarrier(!e.isFilterBarrier,e)},scale:"s"}),s.inputsStrings.barrierFilter):null,l?w.tsx("calcite-combobox",{label:s.globalStrings.selectTerminalPlaceholder,maxItems:0,placeholder:s.globalStrings.selectTerminalPlaceholder,scale:"s",selectionMode:"multiple",onCalciteComboboxChange:t=>{t.target.selectedItems.length>0?(e.selectedTerminals=[],t.target.selectedItems.forEach((t=>{this.viewModel.addTerminal(t.value,e)}))):e.selectedTerminals=[]},onCalciteComboboxChipClose:t=>{t.preventDefault(),this.viewModel.removeTerminal(t.target.value,e)}},r):null)}_renderActiveTool(){const{messages:e}=this;let t=null;return"starting-point"===this._flagViewType?this._symbolStartFlag&&(t=this._getSymbolIcon(this._symbolStartFlag)):this._symbolBarrier&&(t=this._getSymbolIcon(this._symbolBarrier)),w.tsx("calcite-flow-item",{heading:e.inputsStrings.addPointOption,onCalciteFlowItemBack:()=>{this.viewModel.removeClickHandler(),this.view?.popup&&(this.view.popupEnabled=!0),this._changeCursor("default"),this._selectToolActive=!1}},w.tsx("calcite-block",{collapsible:!1,heading:"",open:!0,overlayPositioning:"fixed"},w.tsx("div",{styles:S()},t||w.tsx("calcite-icon",{icon:"starting-point"===this._flagViewType?"pin-plus":"x-circle-f"})),w.tsx("div",{styles:S()},e.inputsStrings.addPointHint)))}_renderTraceSelectorContainer(){const{messages:e}=this,t=[];let s=e.tracingStrings.traceOperation,i=0;return this.viewModel.traces.length>0&&this.viewModel.traces.forEach((e=>{t.push(w.tsx("calcite-combobox-item",{key:e.globalId,selected:e.selected,textLabel:e.title,value:e.globalId,onCalciteComboboxItemChange:e=>{const t=e.target;this.viewModel.selectTraces(t.selected,t.value),this.viewModel.traces.length>0&&(this._warningNoTraceSelected=!1)}})),e.selected&&i++})),s+=` (${i})`,w.tsx("calcite-block",{collapsible:!0,heading:s,open:!0,overlayPositioning:"fixed"},w.tsx("calcite-icon",{icon:"utility-network-trace",scale:"s",slot:"icon"}),w.tsx("calcite-combobox",{label:e.inputsStrings.selectTraces,maxItems:0,overlayPositioning:"fixed",placeholder:e.inputsStrings.selectTraces,scale:"s",selectionMode:"multiple"},t))}_renderStartOverContainer(){const{messages:e}=this;return w.tsx("calcite-button",{kind:"brand",onclick:()=>{this.confirmReset()},slot:"footer",width:"full"},e.resultsStrings.startOverButton)}_renderWarningMessage(e,t,s){const{messages:i}=this;let r=i.alertsStrings.NoRunAlertHeader,l=i.alertsStrings.noResultsInfo;switch(e){case"flag":r=i.alertsStrings.startingPointAlertHeader,l=i.alertsStrings.startingPointAlert;break;case"noTerminal":r=i.alertsStrings.noTerminalDefinedHeader,l=i.alertsStrings.noTerminalDefined;break;case"trace":r=i.alertsStrings.selectTraceAlertHeader,l=i.alertsStrings.selectTraceAlert;break;case"noTraceExecuted":r=i.alertsStrings.NoRunAlertHeader,l=i.alertsStrings.noResultsInfo;break;case"noBarrierAsset":case"noStartAsset":r=i.alertsStrings.noAssetsFoundHeader,l=i.alertsStrings.noAssetFound;break;case"noTraceConfig":r="",l=i.alertsStrings.noTraceSupported;break;default:r=i.alertsStrings.genericErrorHeader,l=s||""}return w.tsx("div",{class:y.noticeContainer,key:e},w.tsx("calcite-notice",{closable:t,icon:!0,key:e,kind:"danger",open:!0,scale:"s",width:"auto",onCalciteNoticeClose:()=>{switch(e){case"flag":this._warningNoFlag=!1;break;case"noTerminal":this._warningNoTerminal=!1;break;case"trace":this._warningNoTraceSelected=!1;break;case"noStartAsset":this._warningNoStartAssetFound=!1;break;case"noBarrierAsset":this._warningNoBarrierAssetFound=!1}}},w.tsx("div",{slot:"title"},r),w.tsx("div",{slot:"message"},l)))}_renderRemoveTraceContainer(e){const{messages:t}=this;return w.tsx("calcite-action",{icon:"trash",label:t.globalStrings.clearResults,onclick:()=>{this._alertRemoveModal=!0,this._activeTrace=e.trace},scale:"s",slot:"header-menu-actions",text:t.globalStrings.clearResults,textEnabled:!0})}_renderHighlightColorPicker(e,t,s){const{messages:i}=this,{graphicHandler:r}=this.viewModel,l=[],o=new RegExp(`^${e.hex}$`,"i"),a=r.highlightColor.length>v.defaultSwatchColors.length?5:4;for(const n of r.highlightColor)l.push(w.tsx("calcite-action",{active:o.test(n.hex),key:n.hex,label:i.resultsStrings.graphicColor,onclick:()=>{"aggregate"===s?this.viewModel.changeResultGraphicColor(n,t):this.viewModel.changeResultAreaColor(t,n)},scale:"s",text:i.resultsStrings.graphicColor},w.tsx("calcite-color-picker-swatch",{active:o.test(n.hex),color:n.hex,scale:"s"})));return w.tsx("calcite-action-pad",{expandDisabled:!0,layout:"grid",position:"start"},w.tsx("calcite-action-group",{columns:a,layout:"grid"},l))}_renderTraceResults(){const{messages:e,messagesCommon:t}=this,{selectFeatures:s}=e.resultsStrings,i=this.viewModel.traceResults,r=[];return i.forEach(((t,i)=>{let l=[],o=[],a=!1,n=!1,c=!1,d="";null!==t.results&&t.results.hasOwnProperty("elements")?(null!==t.results.aggregatedGeometry&&(n=!0),null!==t.results.globalFunctionResults&&t.results.globalFunctionResults.length>0&&(o=t.results.globalFunctionResults,o.length>0&&(c=!0)),t.results.elements&&t.results.elements.length>0&&(l=t.results.elements,l.length>0&&(a=!0)),(n||a)&&(d=this.messagesUnits.units[t.resultArea?.unit]?.abbr),r.push(w.tsx("calcite-block",{collapsible:!0,description:t.trace.description??"",heading:t.trace.title,key:`${t.trace.title}${i}`,open:!0,overlayPositioning:"fixed"},this._renderRemoveTraceContainer(t),w.tsx("calcite-list",null,c?w.tsx("calcite-list-item",{label:e.resultsStrings.functionHeader+" ("+o.length+")",onCalciteListItemSelect:()=>{this.switchToFunctions(o,!0)}},w.tsx("calcite-icon",{icon:"chevron-right",scale:"s",slot:"content-end"})):null,a&&this.viewModel.showSelectionAttributes?w.tsx("calcite-list-item",{key:this.id,label:e.resultsStrings.viewFeatures+" ("+l.length+")",onCalciteListItemSelect:()=>{this.switchToAssetGroup(this._groupResultsByAssetGroup(t),t.trace.title+" ("+l.length+")",!0)}},w.tsx("calcite-icon",{icon:"chevron-right",scale:"s",slot:"content-end"})):this.viewModel.showSelectionAttributes?w.tsx("calcite-label",{layout:"inline",scale:"s"},e.resultsStrings.noSelectionResults):null),a?w.tsx("div",{class:y.paddingTop},w.tsx("calcite-label",{layout:"inline",onclick:e=>{e.preventDefault(),e.stopPropagation(),this.viewModel.mergeSelection(!t.selectionEnabled,t.trace)},scale:"s"},w.tsx("calcite-checkbox",{checked:t.selectionEnabled,onclick:e=>{e.preventDefault(),e.stopPropagation(),this.viewModel.mergeSelection(!t.selectionEnabled,t.trace)}}),this.viewModel.showSelectionAttributes?s:`${s} (${l.length})`)):null,n?w.tsx("calcite-block-section",{key:`aggregate-${t.trace.title}-${i}`,open:t.graphicEnabled,text:e.resultsStrings.highlightTrace,toggleDisplay:"switch",onCalciteBlockSectionToggle:e=>{e.target.open?this.viewModel.changeResultGraphicColor(t.graphicColor,t):this.viewModel.removeResultGraphicFromView(t)}},w.tsx("calcite-list",{selectionMode:"none"},w.tsx("calcite-list-item",{label:e.resultsStrings.graphicColor,onclick:e=>{const t=e.target;this._swatchNode=t,this._activeSwatch="aggGeom_"+i}},w.tsx("calcite-color-picker-swatch",{color:t.graphicColor.hex,scale:"s",slot:"actions-end"})))):null,this.enableResultArea&&(n||a)?w.tsx("calcite-block-section",{key:`area-${t.trace.title}-${i}`,open:t.resultArea?.show,text:e.resultsStrings.resultAreaHeader,toggleDisplay:"switch",onCalciteBlockSectionToggle:e=>{e.target.open?t.resultAreaGraphic?this.viewModel.addResultAreaToMap(t,t.resultAreaGraphic):this.viewModel.addResultAreaToMap(t):this.viewModel.removeResultAreaFromMap(t)}},w.tsx("calcite-list",{selectionMode:"none"},w.tsx("calcite-list-item",{label:e.resultsStrings.graphicColor,onclick:e=>{const t=e.target;this._swatchNode=t,this._activeSwatch="resultArea_"+i}},w.tsx("calcite-color-picker-swatch",{color:t.resultArea?.color.hex,scale:"s",slot:"actions-end"}))),w.tsx("calcite-list",{selectionMode:"none"},w.tsx("calcite-list-item",{label:e.resultsStrings.resultAreaBuffer},w.tsx("calcite-input-number",{afterCreate:this._afterComponentCreate,class:y.numberInput,max:999999,maxLength:999999,min:0,scale:"s",slot:"actions-end",suffixText:d,value:t.resultArea?.distance.toString(),onCalciteInputNumberChange:e=>{if(!this.view?.popup)return;this.view.popup.visible&&this.view.closePopup();const s=e.target;t.resultArea.distance>=0?(t.resultArea.distance=parseInt(s.value,10),this.viewModel.removeResultAreaFromMap(t),this.viewModel.addResultAreaToMap(t)):(t.resultArea.distance=0,this.viewModel.removeResultAreaFromMap(t),this.viewModel.addResultAreaToMap(t))}})))):null,w.tsx("calcite-popover",{autoClose:!0,closable:!0,label:e.resultsStrings.graphicColor,offsetDistance:0,offsetSkidding:0,open:this._activeSwatch==="aggGeom_"+i||this._activeSwatch==="resultArea_"+i,placement:"auto-start",referenceElement:this._swatchNode,scale:"s",onCalcitePopoverClose:()=>{this._swatchNode=null,this._activeSwatch=null}},this._renderHighlightColorPicker(this._activeSwatch==="resultArea_"+i?t.resultArea?.color:t.graphicColor,t,this._activeSwatch==="resultArea_"+i?"resultArea":"aggregate"))))):r.push(w.tsx("calcite-block",{collapsible:!1,heading:t.trace.title,key:"error-"+i,open:!0,overlayPositioning:"fixed"},this._renderRemoveTraceContainer(t),this._renderWarningMessage("noController",!1,t.status)))})),w.tsx("calcite-flow-item",{key:"traceResults",styles:R()},r,this._renderStartOverContainer(),this._alertRemoveModal?w.tsx("calcite-scrim",{key:"prompt"},w.tsx("div",{class:y.clearPrompt},w.tsx("h3",{slot:"header"},e.globalStrings.clearResults),w.tsx("div",{slot:"content"},e.alertsStrings.clearResultsAlert),w.tsx("div",{class:y.promptDivider}),w.tsx("div",{styles:C("row")},w.tsx("calcite-button",{appearance:"outline",onclick:()=>{this._alertRemoveModal=!1},slot:"secondary",width:"full"},t.cancel),w.tsx("calcite-button",{onclick:()=>{this._activeTrace&&this.viewModel.clearResult(this._activeTrace),this._alertRemoveModal=!1,0===this.viewModel.traceResults.length?this.switchTab("input"):(this._activeTrace=this.viewModel.traceResults[0].trace,this._showTraceResultFunctions=!1,this._showTraceResultAssetGroup=!1,this._showTraceResultAssetType=!1,this._showIndividualRecords=!1)},slot:"primary",width:"full"},t.form.ok)))):null)}_renderTraceResultFunctions(){const{messages:e}=this,t=this._traceResultsFunctions,s=[];return t.forEach((e=>{s.push(this._renderResultRowFunctions(e))})),w.tsx("calcite-flow-item",{heading:e.resultsStrings.functionHeader,key:"functionResultMultiple",onCalciteFlowItemBack:()=>{this.switchToFunctions([],!1)}},s,this._renderStartOverContainer())}_renderTraceResultByAssetGroup(){const e=this._traceResultsAssetGroup,t=[];for(const s in e){const i=e[s];for(const e in i)t.push(this._renderResultRowAssetGroup(i[e]))}return w.tsx("calcite-flow-item",{heading:this._traceHeaderForFlow,key:"assetGroupResultMultiple",onCalciteFlowItemBack:()=>{this.switchToAssetGroup([],"",!1)}},w.tsx("calcite-list",null,t),this._renderStartOverContainer())}_renderTraceResultByAssetType(){const e=this._traceResultsAssetType,t=[];for(const s in e)e[s].length>0&&t.push(this._renderResultRowAssetType(e[s]));return w.tsx("calcite-flow-item",{heading:this._assetGroupHeader,key:"assetTypeResult",onCalciteFlowItemBack:()=>{this.switchToAssetType([],"",!1)}},w.tsx("calcite-list",{selectionMode:"none"},t),this._renderStartOverContainer())}_renderTraceResultIndividual(){const{messages:e}=this,t=this._traceResultsIndividual;t.sort(this._compare(this._resultSortField,this._resultSortOrder));const s=[];if(t.length>0){(t[0].details?.fields.some((({name:e})=>e.toLowerCase()===this._resultDisplayField.toLocaleLowerCase()))??!1)||(this._resultDisplayField=this._resultObjectIdField,this._resultSortField=this._resultObjectIdField),t.forEach((e=>{e?.details&&s.push(this._renderResultRowIndividual(e))})),0===s.length&&s.push(w.tsx("calcite-list-item",{label:e.resultsStrings.noFeaturesInMap}))}return w.tsx("calcite-flow-item",{heading:this._assetTypeHeader,key:"individualResult",onCalciteFlowItemBack:()=>{this._showResultOptions=!1,this.switchToIndividualRecords([],"",!1)}},w.tsx("calcite-action",{afterCreate:p.storeNode,bind:this,"data-node-ref":"_individualResultNode",icon:"gear",id:"field_options"+this.id,label:e.resultsStrings.displayAttribute,onclick:()=>{this._showResultOptions=!0},slot:"header-actions-end",text:e.resultsStrings.displayAttribute}),w.tsx("calcite-list",{selectionMode:"none"},s),this._renderStartOverContainer())}_renderTraceResultIndividualPopover(){const{messages:e}=this,t=this._traceResultsIndividual,s=[],i=[];return t.length>0&&(t[0].details?t[0].details.fields.forEach((({name:e,alias:t})=>{s.push(w.tsx("calcite-option",{key:`display-${e}`,label:t??e,selected:e===this._resultDisplayField,value:e})),i.push(w.tsx("calcite-option",{key:`sort-${e}`,label:t??e,selected:e===this._resultSortField,value:e}))})):(s.push(w.tsx("calcite-option",{key:`display-${this._resultDisplayField}`,label:this._resultDisplayField,value:this._resultDisplayField})),i.push(w.tsx("calcite-option",{key:`sort-${this._resultDisplayField}`,label:this._resultDisplayField,value:this._resultDisplayField})))),w.tsx("calcite-popover",{autoClose:!0,label:e.resultsStrings.displayAttribute,offsetDistance:0,offsetSkidding:0,open:this._showResultOptions,overlayPositioning:"fixed",placement:"left-start",referenceElement:this._individualResultNode,styles:null!==this.domNode?T(.75*this.domNode.clientWidth):f()},w.tsx("calcite-block",{heading:"",open:!0,overlayPositioning:"fixed"},w.tsx("calcite-label",{scale:"s"},e.resultsStrings.displayAttribute,w.tsx("calcite-select",{label:e.resultsStrings.displayAttribute,scale:"s",onCalciteSelectChange:e=>{const t=e.target;this._resultDisplayField=t.selectedOption.value,this._showResultOptions=!1}},s)),w.tsx("calcite-label",{scale:"s"},e.resultsStrings.sortBy,w.tsx("calcite-select",{label:e.resultsStrings.sortBy,scale:"s",onCalciteSelectChange:e=>{const s=e.target;this._resultSortField=s.selectedOption.value,t.sort(this._compare(this._resultSortField,this._resultSortOrder)),this._traceResultsIndividual=t,this._showResultOptions=!1}},i))))}_renderResultRowFunctions(e){return w.tsx("calcite-block",{collapsible:!1,heading:e.networkAttributeName+" "+e.functionType+" = "+e.result,overlayPositioning:"fixed"})}_renderResultRowAssetGroup(e){const t=this._getAssetGroupName(e[0]);return w.tsx("calcite-list-item",{label:t+" ("+e.length+")",onCalciteListItemSelect:()=>{this.switchToAssetType(this._groupResultsByAssetType(e),t+" ("+e.length+")",!0)}},w.tsx("calcite-icon",{icon:"chevron-right",scale:"s",slot:"content-end"}))}_renderResultRowAssetType(e){const t=this._getAssetTypeName(e[0]);return w.tsx("calcite-list-item",{label:t+" ("+e.length+")",onCalciteListItemSelect:()=>{this.viewModel.queryFeaturesById(e).then((s=>{if(s?.length){this._resultObjectIdField=s[0].layer.objectIdField,"objectid"===this._resultDisplayField&&(this._resultDisplayField=s[0].layer.objectIdField),"objectid"===this._resultSortField&&(this._resultSortField=s[0].layer.objectIdField);const i=this._appendAttributes(e,s,"objectId");this.switchToIndividualRecords(i,t+" ("+e.length+")",!0)}else this.switchToIndividualRecords(e,t+" ("+e.length+")",!0)}))}},w.tsx("calcite-icon",{icon:"chevron-right",scale:"s",slot:"content-end"}))}_renderResultRowIndividual(e){const{messages:t}=this,s=`display-${e.objectId}-nso`,{nonSpatialObject:i,zoomToFeature:r}=t.globalStrings;let l="",o=null;if(o=e?.details?.fields.find((({name:e})=>e===this._resultDisplayField)),"date"===o?.type){l=new Date(e.details.attributes[this._resultDisplayField]).toDateString()}else if("assetgroup"===this._resultDisplayField.toLowerCase())l=this._getAssetGroupName(e);else if("assettype"===this._resultDisplayField.toLowerCase())l=this._getAssetTypeName(e);else if(o?.domain&&A(o.domain)){const t=o.domain.codedValues.find((({code:t})=>t===e.details.attributes[this._resultDisplayField]));l=t?.name}else l=e.details?.attributes[this._resultDisplayField]??e.objectId;return l&&""!==l&&null!==l?"string"==typeof l&&(l.trim()||(l=t.resultsStrings.noValue)):l=t.resultsStrings.noValue,null!==e?.details?.geometry?w.tsx("calcite-list-item",{label:l,onCalciteListItemSelect:()=>{this.viewModel.zoomToAsset(e.details.geometry)}},w.tsx("calcite-icon",{icon:"zoom-to-object",scale:"s",slot:"content-end",textLabel:r})):w.tsx("calcite-list-item",{label:l},w.tsx("calcite-icon",{icon:"table",id:s,scale:"s",slot:"content-end",textLabel:i}),w.tsx("calcite-tooltip",{label:i,referenceElement:s},w.tsx("span",null,i)))}_afterComponentCreate(e){"value"in e&&null!=e.value&&"setNumberValue"in e&&e.setNumberValue({committing:!1,value:e.value,origin:"direct"})}_mixCustomStrings(){const{messages:e}=this;this.inputSettings.length>0&&this.inputSettings.forEach((t=>{"starting-point"===t.type&&(e.inputsStrings.headerStartingPoint=t.label,e.inputsStrings.startingPointHint=t.description),"barrier"===t.type&&(e.inputsStrings.headerBarrier=t.label,e.inputsStrings.barrierPointHint=t.description)}))}_overrideFlagSymbol(){this.inputSettings.length>0&&this.inputSettings.forEach((e=>{"starting-point"===e.type?this._symbolStartFlag=e.symbol:this._symbolBarrier=e.symbol,this.viewModel.changeFlagSymbol(e.type,e.symbol)}))}_utilityNetworkTraceInitialized(){return this.viewModel.loadUtilityNetwork().then((e=>{if(e)return this.viewModel.selectTracesOnLoad(),this._registerWatchers(),this.viewModel.flags.length>0&&this._processFlagOnLoad(),this.view?.when().then((()=>{this._watchViewState()}));this.disabled=!1})).catch((e=>{const{messages:t}=this;this._loadUNError=!1,"utility-network:no-user-type-extension"===e.name||e.details.raw.extendedCode===F.noExtension?this._errorMessage=t.alertsStrings.noUserExtension:this._errorMessage=e.message,this.disabled=!1}))}_processFlagOnLoad(){return this.view?.when().then((()=>{this._watchHandler=r.when((()=>!this.view?.updating),(async()=>{this._warningNoFlag=!1,this._warningNoBarrierAssetFound=!1,this._warningNoStartAssetFound=!1;const e=await this.viewModel.addFlagsOnLoad();this.viewModel.removeFlagsOnLoadWatcher(),e.includes("barrier")&&(this._warningNoBarrierAssetFound=!0),e.includes("starting-point")&&(this._warningNoStartAssetFound=!0),this.disabled=!1,null!==this._watchHandler&&this._watchHandler.remove()}))}))}_registerWatchers(){this.addHandles([r.watch((()=>this.selectedTraces),(()=>{this.viewModel.selectTracesOnLoad(),this.scheduleRender()})),r.watch((()=>this.defaultGraphicColor),(()=>{this.viewModel.traceResults.length>0&&this.viewModel.traceResults.forEach((e=>{this.viewModel.changeResultGraphicColor(this.viewModel.defaultGraphicColor,e)})),this.scheduleRender()}))])}_groupResultsByAssetGroup(e){const t=[],s=e.results?.elements,i=this._groupBy(s??[],"networkSourceId");for(const r in i)t.push(this._groupBy(i[r],"assetGroupCode"));return t}_groupResultsByAssetType(e){return this._groupBy(e,"assetTypeCode")}_appendAttributes(e,t,s){const i=[];return e.forEach((e=>{t.forEach((t=>{t.featureSet.features.forEach((r=>{e[s]===r.attributes[this._resultObjectIdField]&&(e.details=r,e.details.fields=t.featureSet.fields,i.push(e))}))}))})),i}_getAssetGroupName(e){let t=e.assetGroupCode.toString();const s=e.assetGroupCode,i=this.viewModel.getValidSources().find((t=>t.sourceId===e.networkSourceId));if(i){const e=i.assetGroups.find((e=>e.assetGroupCode===s));e&&(t=e.assetGroupName)}return t}_getAssetTypeName(e){let t=e.assetTypeCode.toString();const s=e.assetGroupCode,i=this.viewModel.getValidSources().find((t=>t.sourceId===e.networkSourceId));if(i){const r=i.assetGroups.find((e=>e.assetGroupCode===s));if(r){const s=r.assetTypes.find((t=>t.assetTypeCode===e.assetTypeCode));s&&(t=s.assetTypeName)}}return t}_compare(e,t){return(s,i)=>{let r=0,l=s.details?.attributes[e]??s.objectId,o=i.details?.attributes[e]??i.objectId;return isNaN(l)&&(l=l.toLowerCase()),isNaN(o)&&(o=o.toLowerCase()),"desc"===t?l>o?r=1:l<o&&(r=-1):l<o?r=1:l>o&&(r=-1),r}}_groupBy(e,t){return e.reduce(((e,s)=>((e[s[t]]=e[s[t]]||[]).push(s),e)),{})}_getSymbolIcon(e){return"picture-marker"===e.type?w.tsx("img",{height:e.height,src:e.url??void 0,width:e.width}):null}_watchViewState(){this._watchHandler=r.when((()=>!this.view?.updating),(()=>{this.disabled=!1,null!==this._watchHandler&&this._watchHandler.remove()}),{initial:!0})}_changeCursor(e="default"){const t=this.view?.container?.style;t&&(t.cursor=e)}};t.__decorate([l.property()],M.prototype,"_selectToolActive",void 0),t.__decorate([l.property()],M.prototype,"_activeTrace",void 0),t.__decorate([l.property()],M.prototype,"_activeSwatch",void 0),t.__decorate([l.property()],M.prototype,"_traceHeaderForFlow",void 0),t.__decorate([l.property()],M.prototype,"_assetGroupHeader",void 0),t.__decorate([l.property()],M.prototype,"_assetTypeHeader",void 0),t.__decorate([l.property()],M.prototype,"_traceResultsFunctions",void 0),t.__decorate([l.property()],M.prototype,"_traceResultsAssetGroup",void 0),t.__decorate([l.property()],M.prototype,"_traceResultsAssetType",void 0),t.__decorate([l.property()],M.prototype,"_traceResultsIndividual",void 0),t.__decorate([l.property()],M.prototype,"_showTraceResultFunctions",void 0),t.__decorate([l.property()],M.prototype,"_showTraceResultAssetGroup",void 0),t.__decorate([l.property()],M.prototype,"_showTraceResultAssetType",void 0),t.__decorate([l.property()],M.prototype,"_showIndividualRecords",void 0),t.__decorate([l.property()],M.prototype,"_activeTab",void 0),t.__decorate([l.property()],M.prototype,"_alertRemoveModal",void 0),t.__decorate([l.property()],M.prototype,"_warningNoFlag",void 0),t.__decorate([l.property()],M.prototype,"_warningNoTraceSelected",void 0),t.__decorate([l.property()],M.prototype,"_confirmReset",void 0),t.__decorate([l.property()],M.prototype,"_swatchNode",void 0),t.__decorate([l.property()],M.prototype,"_errorMessage",void 0),t.__decorate([l.property()],M.prototype,"defaultGraphicColor",null),t.__decorate([l.property()],M.prototype,"disabled",void 0),t.__decorate([l.property()],M.prototype,"flags",null),t.__decorate([l.property()],M.prototype,"gdbVersion",null),t.__decorate([l.property()],M.prototype,"icon",null),t.__decorate([l.property()],M.prototype,"inputSettings",void 0),t.__decorate([l.property()],M.prototype,"label",null),t.__decorate([l.property(),g.messageBundle("esri/widgets/UtilityNetworkTrace/t9n/UtilityNetworkTrace")],M.prototype,"messages",void 0),t.__decorate([l.property(),g.messageBundle("esri/t9n/common")],M.prototype,"messagesCommon",void 0),t.__decorate([l.property(),g.messageBundle("esri/core/t9n/Units")],M.prototype,"messagesUnits",void 0),t.__decorate([l.property()],M.prototype,"resultAreaProperties",null),t.__decorate([l.property()],M.prototype,"selectedTraces",null),t.__decorate([l.property()],M.prototype,"selectOnComplete",null),t.__decorate([l.property()],M.prototype,"showGraphicsOnComplete",null),t.__decorate([l.property()],M.prototype,"enableResultArea",null),t.__decorate([l.property()],M.prototype,"showSelectionAttributes",null),t.__decorate([l.property()],M.prototype,"utilityNetwork",null),t.__decorate([l.property()],M.prototype,"view",null),t.__decorate([_.vmEvent(["add-flag","add-flag-complete","add-flag-error","select-features","clear-selection","add-result-area","remove-result-area","create-result-area","reset"]),l.property({type:m})],M.prototype,"viewModel",void 0),M=t.__decorate([n.subclass("esri.widgets.UtilityNetworkTrace")],M);return M}));
