/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../core/lang","../core/reactiveUtils","../core/accessorSupport/decorators/property","../core/has","../core/Logger","../core/accessorSupport/decorators/subclass","../intl/date","../views/VideoView","./Slider","./Widget","../chunks/componentsUtils","./support/globalCss","./support/widgetUtils","./support/decorators/messageBundle","./support/jsxFactory","./VideoPlayer/css","./VideoPlayer/VideoPlayerViewModel","./VideoPlayer/components/MetadataSection","./VideoPlayer/components/PlayerActionsGroup","./VideoPlayer/components/PlayerControlsGroup","./VideoPlayer/components/SettingsButton"],(function(e,t,s,i,r,o,a,n,l,d,c,p,u,h,v,m,g,w,y,_,M,V,P){"use strict";let b=class extends p{constructor(e,t){super(e,t),this._settings=s.clone(P.defaultSettings),this._metadataVisible=!1,this._slider=new c({visibleElements:{labels:!1,rangeLabels:!1},min:0,max:100,values:[0],thumbsConstrained:!1}),this.videoView=new d({container:document.createElement("div")}),this.viewModel=new y}initialize(){this.addHandles([i.watch((()=>this.viewModel.layer),(()=>{this.videoView.layer=this.viewModel.layer}),i.initial),this._slider.on(["thumb-change","thumb-drag"],(({value:e})=>{const t=e*this.viewModel.duration/100;this.viewModel.seekTo(t)}))])}loadDependencies(){return Promise.all([M.loadPlayerActionsGroupComponents(),V.loadPlayerControlsGroupComponents(),_.loadMetadataSectionComponents(),u.loadCalciteComponents({progress:()=>new Promise(((t,s)=>e(["../chunks/calcite-progress"],t,s))),panel:()=>new Promise(((t,s)=>e(["../chunks/calcite-panel"],t,s))),scrim:()=>new Promise(((t,s)=>e(["../chunks/calcite-scrim"],t,s)))})])}get icon(){return"video-web"}set icon(e){this._overrideIfSome("icon",e)}get layer(){return this.viewModel.layer}set layer(e){this.viewModel.layer=e}get view(){return this.viewModel.view}set view(e){this.viewModel.view=e}render(){return g.tsx("div",{class:this.classes(w.css.base,h.globalCss.widget)},g.tsx("calcite-panel",{heading:this.layer?.title||"Video Player"},this._renderLoadingScrim(),this._renderBuffering(),this._renderVideoSection(),this._renderActionBar(),this._renderMetadataSection()))}_renderLoadingScrim(){const{state:e}=this.viewModel;return this.videoView.ready?null:g.tsx("calcite-scrim",{loading:"error"!==e},"error"===e?this.messages.errorLoadingLayer:null)}_renderBuffering(){const{currentTime:e,buffered:t,duration:s}=this.viewModel,i=t/(s||1),r=e/(s||1);return this.viewModel.ended||i>r?null:g.tsx("calcite-progress",{type:"indeterminate"})}_renderVideoSection(){const{buffered:e,currentTime:t,duration:s}=this.viewModel,i=this.videoView.container;if(!i)return null;i.className=w.css.videoView;const r=e/(s||1),o=t/(s||1);return this._slider.values=[100*o],g.tsx("section",{afterCreate:x,bind:i},g.tsx("div",{class:w.css.sliderProgressContainer},g.tsx("progress",{class:w.css.progress,max:"1",value:`${r}`}),g.tsx("div",{class:w.css.slider},this._slider.render())))}_renderActionBar(){return g.tsx("div",{class:w.css.playerToolbar},g.tsx(M.PlayerActionsGroup,{messages:this.messages,viewModel:this.viewModel}),g.tsx("div",{class:w.css.playerTimecode},f(this.viewModel.currentTime)," / ",f(this.viewModel.duration)),g.tsx(V.PlayerControlsGroup,{messages:this.messages,settings:this._settings,toggleMetadata:()=>this._metadataVisible=!this._metadataVisible,viewModel:this.viewModel}))}_renderMetadataSection(){return this._metadataVisible?g.tsx(_.MetadataSection,{messages:this.messages,viewModel:this.viewModel}):null}};function f(e){return l.formatDate(1e3*Math.round(e),{minute:"2-digit",second:"2-digit"})}function x(e){const t=this;e.prepend(t)}t.__decorate([r.property()],b.prototype,"_settings",void 0),t.__decorate([r.property()],b.prototype,"icon",null),t.__decorate([r.property()],b.prototype,"layer",null),t.__decorate([r.property(),m.messageBundle("esri/widgets/VideoPlayer/t9n/VideoPlayer")],b.prototype,"messages",void 0),t.__decorate([r.property()],b.prototype,"videoView",void 0),t.__decorate([r.property({type:y})],b.prototype,"viewModel",void 0),t.__decorate([r.property()],b.prototype,"view",null),b=t.__decorate([n.subclass("esri.widgets.VideoPlayer")],b);return b}));
