/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../chunks/tslib.es6","../core/memoize","../core/accessorSupport/decorators/property","../core/has","../core/Logger","../core/RandomLCG","../core/accessorSupport/decorators/subclass","../views/3d/environment/weather","./Widget","../chunks/componentsUtils","./support/globalCss","./support/Heading","./support/widgetUtils","./support/decorators/messageBundle","./support/jsxFactory","./Weather/css","./Weather/enums","./Weather/LabeledSlider","./Weather/VisibleElements","./Weather/WeatherViewModel"],(function(e,t,r,o,s,n,a,i,l,c,d,u,p,h,g,y,v,b,w,C,m){"use strict";const _={sunny:"brightness",cloudy:"partly-cloudy",rainy:"rain",snowy:"snow",foggy:"fog"};let k=class extends c{constructor(e){super(e),this.viewModel=new m,this.headingLevel=4,this.visibleElements=new C,this._renderWeatherTypeButton=e=>{const t=this.viewModel,r=this.messages[e].label,o=t.state===b.WeatherState.Disabled,s=!o&&t.current.type===e;return y.tsx("calcite-button",{appearance:s?"solid":"outline","aria-checked":s?"true":"false",disabled:o,iconStart:_[e],key:`${e}-type-button`,kind:s?"brand":"neutral",label:r,onclick:()=>{s||t.setWeatherByType(e)},scale:"l",title:r})},this._memoizedCallbacks=r.memoize((e=>({onCloudCoverChange:t=>{"cloudCover"in e&&(e.cloudCover=t)},onPrecipitationChange:t=>{"precipitation"in e&&(e.precipitation=t)},onFogStrengthChange:t=>{"fogStrength"in e&&(e.fogStrength=t)},onSnowCoverChange:e=>{this.viewModel.setSnowCoverEnabled(e.target.checked)}})))}render(){const e=this.viewModel.state===b.WeatherState.Disabled;return y.tsx("div",{"aria-label":this.messages.widgetLabelAccessible,class:this.classes(v.css.base,u.globalCss.widget,e&&u.globalCss.widgetDisabled),role:"region"},this._renderContent())}loadDependencies(){return d.loadCalciteComponents({button:()=>new Promise(((t,r)=>e(["../chunks/calcite-button"],t,r))),checkbox:()=>new Promise(((t,r)=>e(["../chunks/calcite-checkbox"],t,r))),icon:()=>new Promise(((t,r)=>e(["../chunks/calcite-icon"],t,r))),label:()=>new Promise(((t,r)=>e(["../chunks/calcite-label"],t,r)))})}get view(){return this.viewModel?.view}set view(e){this.viewModel&&(this.viewModel.view=e)}get icon(){return"partly-cloudy"}set icon(e){this._overrideIfSome("icon",e)}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}get _errorMessage(){const e=this.messages.error;switch(this.viewModel.error){case b.WeatherError.LocalScene:return e.localScene;case b.WeatherError.NoAtmosphere:return e.noAtmosphere;case b.WeatherError.UnsupportedView:return e.unsupported;default:return null}}get _warningMessage(){if(this.viewModel.error===b.WeatherError.NotVisible){return null!=this.view&&"3d"===this.view?.type&&this.view.environment.atmosphereEnabled?this.messages.error.notVisible:null}return null}_renderContent(){const{headingLevel:e,messages:t,viewModel:r,visibleElements:o}=this,s=this._warningMessage,n=r.current,a=r.state===b.WeatherState.Error;return y.tsx(y.tsxFragment,null,o.header?y.tsx(p.Heading,{level:e},t.widgetLabel):null,a?y.tsx("div",{class:v.css.error,key:"error"},this._errorMessage):null,y.tsx("div",{class:h.classes({[v.css.content]:!0,[v.css.hasError]:a}),key:"content"},y.tsx("div",{"aria-label":t.weatherType,class:v.css.selector,key:"type-selector",role:"radiogroup"},l.weatherTypesArray.map(this._renderWeatherTypeButton)),Object.values(r.weatherByType).map((e=>y.tsx("div",{class:h.classes({[v.css.options]:!0,[v.css.optionsHidden]:e.type!==n?.type}),key:"options-container"},this._renderOptions(e)))),null!=s?this._renderWarning(s):null))}_renderOptions(e){const{viewModel:t,messages:r}=this,o=t.state===b.WeatherState.Disabled,s=this._memoizedCallbacks(e);switch(e.type){case"sunny":return y.tsx(w.LabeledSlider,{disabled:o,key:"sunny-cover",label:r.sunny.cloudCover,value:e.cloudCover,onChange:s.onCloudCoverChange});case"cloudy":return y.tsx(w.LabeledSlider,{disabled:o,key:"cloudy-cover",label:r.cloudy.cloudCover,value:e.cloudCover,onChange:s.onCloudCoverChange});case"rainy":return y.tsx(y.tsxFragment,null,y.tsx(w.LabeledSlider,{disabled:o,key:"rainy-cover",label:r.rainy.cloudCover,value:e.cloudCover,onChange:s.onCloudCoverChange}),y.tsx(w.LabeledSlider,{disabled:o,key:"rainy-precipitation",label:r.rainy.precipitation,value:e.precipitation,onChange:s.onPrecipitationChange}));case"snowy":return y.tsx(y.tsxFragment,null,y.tsx(w.LabeledSlider,{disabled:o,key:"snowy-cloud-cover",label:r.snowy.cloudCover,value:e.cloudCover,onChange:s.onCloudCoverChange}),y.tsx(w.LabeledSlider,{disabled:o,key:"snowy-precipitation",label:r.snowy.precipitation,value:e.precipitation,onChange:s.onPrecipitationChange}),y.tsx("calcite-label",{key:"snow-cover",layout:"inline",scale:"s",title:r.snowy.snowCoverTooltip},y.tsx("calcite-checkbox",{checked:"enabled"===e.snowCover,disabled:o,onCalciteCheckboxChange:s.onSnowCoverChange}),r.snowy.snowCover));case"foggy":return y.tsx(w.LabeledSlider,{disabled:o,key:"foggy-cover",label:r.foggy.fogStrength,value:e.fogStrength,onChange:s.onFogStrengthChange})}}_renderWarning(e){return y.tsx("div",{class:v.css.warning,key:"warning"},y.tsx("calcite-icon",{icon:"exclamation-mark-triangle",scale:"s"}),e)}};t.__decorate([o.property()],k.prototype,"viewModel",void 0),t.__decorate([o.property()],k.prototype,"view",null),t.__decorate([o.property()],k.prototype,"headingLevel",void 0),t.__decorate([o.property({type:C,nonNullable:!0})],k.prototype,"visibleElements",void 0),t.__decorate([o.property()],k.prototype,"icon",null),t.__decorate([o.property()],k.prototype,"label",null),t.__decorate([o.property(),g.messageBundle("esri/widgets/Weather/t9n/Weather")],k.prototype,"messages",void 0),t.__decorate([o.property()],k.prototype,"_errorMessage",null),t.__decorate([o.property()],k.prototype,"_warningMessage",null),k=t.__decorate([i.subclass("esri.widgets.Weather")],k);return k}));
