/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../intl","../core/deprecate","../core/domUtils","../core/Evented","../core/events","../core/has","../core/lang","../core/Logger","../core/maybe","../core/Promise","../core/promiseUtils","../core/reactiveUtils","../core/uuid","../core/accessorSupport/decorators/property","../core/accessorSupport/decorators/cast","../core/accessorSupport/decorators/subclass","../core/accessorSupport/tracking","../core/accessorSupport/tracking/SimpleTrackingTarget","../libs/maquette-advanced-projector/projector","../chunks/componentsUtils","./support/jsxWidgetSupport","./support/symbols","./support/tests","./support/vnodeCache","./support/widgetUtils","../intl/locale","../intl/messages"],(function(e,t,r,o,s,i,n,a,d,c,l,h,p,u,_,g,y,v,m,b,f,w,S,C,R,j,E,N){"use strict";var P;const k="esri.widgets.Widget";let T=0;function I(e,t){const r=Object.prototype.hasOwnProperty;for(const o in t)r.call(t,o)&&r.call(e,o)&&(null!=e[o]&&null!=t[o]&&"object"==typeof e[o]&&"object"==typeof t[o]?I(e[o],t[o]):e[o]=t[o]);return e}const L=b.createAdvancedProjector({postProcessProjectionOptions(e){const t=e.eventHandlerInterceptor,r=/capture$/i;e.eventHandlerInterceptor=(e,o,s,i)=>{const n=t?.(e,o,s,i),a=r.test(e);if(!((e=e.replace(r,"")).toLowerCase()in s)||a){const t=e[2].toLowerCase()+e.slice(3),r=e=>n?.call(s,e);s.addEventListener(t,r,a);const o=()=>s.removeEventListener(t,r,a),d=i.afterRemoved;i.afterRemoved=e=>{d?.(e),o()}}return n}},handleInterceptedEvent(e,t,r,o){const{eventPhase:s,type:i}=o,n=s===Event.CAPTURING_PHASE;let a=`on${i}${n?"capture":""}`;const d=t.properties;(d&&a in d||(a=`on${i[0].toUpperCase()}${i.slice(1)}${n?"Capture":""}`,d&&a in d))&&(R.clearVNodeCache(),e.scheduleRender(),d[a].call(d.bind||r,o))}});let F=!1,H=class extends(l.EsriPromiseMixin(s.EventedAccessor)){constructor(e,t){super(e,t),this._attached=!1,this._projector=L,this._readyForTrueRender=!1,this.key=this,this.autoRenderingEnabled=!0,this._loadLocale=h.debounce((async()=>{if(this._messageBundleProps?.length){const e=await Promise.allSettled(this._messageBundleProps.map((async({bundlePath:e,propertyName:t})=>{if(this.destroyed)return;let r=await N.fetchMessageBundle(e);this.uiStrings&&Object.keys(this.uiStrings)&&(r=I(a.clone(r),this.uiStrings)),this[t]=r})));if(this.destroyed)return;for(const t of e)"rejected"===t.status&&d.getLogger(this).error("widget-intl:locale-error",this.declaredClass,t.reason)}await this.loadLocale()})),f.commitAssetPath();const r="esri-widget-uid-"+u.generateUUID(),o=this.render.bind(this);this._trackingTarget=new m.SimpleTrackingTarget((()=>{this.autoRenderingEnabled&&this.scheduleRender()}));const s=()=>({vnodeSelector:"div",properties:{key:`${r}-hidden`,class:"",styles:{display:"none"}},domNode:null,children:void 0,text:void 0}),i=()=>{if(!this._readyForTrueRender||this.destroyed)return null;const e=o()??s(),t=e.properties??={};if(t.key??=r,w.isWidgetConstructor(e.vnodeSelector)){if(!this.visible)return s()}else this.visible?t.styles||(t.styles={}):(t.class="",t.styles={display:"none"}),t.styles.display??="";let i=0;return e.children?.forEach((e=>{w.isWidgetConstructor(e.vnodeSelector)||(e.properties??={},e.properties.key??=`${this.id}--${i++}`)})),w.processWidgets(this,e)};this.render=()=>{if(F)return i();let e=R.getVNodeCache(this)??null;if(e)return e;this._trackingTarget.clear(),F=!0;try{e=v.runTracked(this._trackingTarget,i)}catch(t){throw d.getLogger(this).error(t),t}finally{F=!1}return e&&R.setVNodeCache(this,e),e};const n=this.beforeFirstRender();n?this._resourcesFetch=n.then((()=>{this._readyForTrueRender=!0,this._postInitialize()})):(this._resourcesFetch=Promise.resolve().then((()=>{this._postInitialize()})),this._readyForTrueRender=!0),this.addResolvingPromise(this._resourcesFetch),C.registerLoading(this._resourcesFetch)}normalizeCtorArgs(e,t){const r={...e};return t&&(r.container=t),r}postInitialize(){}beforeFirstRender(){const e=this.loadDependencies();return this._messageBundleProps?.length||e?Promise.all([e,this._loadLocale()]).then((()=>{})).catch(h.throwIfNotAbortError):null}loadDependencies(){return null}loadLocale(){return null}destroy(){this.destroyed||(c.destroyMaybe(this._trackingTarget),c.destroyMaybe(this.viewModel),this._detach(this.container),this._set("container",null),this._emitter.clear(),this.render=()=>null,this._projector=null,R.deleteVNodeCache(this))}set container(e){this._get("container")||this._set("container",e)}castContainer(e){return o.byId(e)}get domNode(){return this.container}set domNode(e){this.container=e}get icon(){return null}set icon(e){this._overrideIfSome("icon",e)}get id(){return this._get("id")||this.container?.id||Date.now().toString(16)+"-widget-"+T++}set id(e){e&&this._set("id",e)}get label(){return this.declaredClass.split(".").pop()}set label(e){this._overrideIfSome("label",e)}get renderable(){return this._resourcesFetch}get visible(){return this._get("visible")}set visible(e){this._set("visible",e)}get[(P=S.widgetSymbol,S.widgetTestDataSymbol)](){return{projector:this._projector}}render(){throw new Error("not implemented")}scheduleRender(){this.destroyed||(R.deleteVNodeCache(this),this._projector.scheduleRender())}own(e){r.deprecatedFunction(d.getLogger(this),"`Widget.own()` is deprecated in favor of 'Widget.addHandles()'",{replacement:"Widget.addHandles()",version:"4.28"}),this.addHandles(e)}classes(...e){return j.classes.apply(this,e)}renderNow(){R.deleteVNodeCache(this),this._projector.renderNow()}_postInitialize(){if(this.destroyed)return;this.scheduleRender(),this._delegatedEventNames?.length&&this.addHandles(p.watch((()=>this.viewModel),((e,t)=>{t&&this.removeHandles("delegated-events"),e&&i.isEventedOrEventTarget(e)&&this.addHandles(this._delegatedEventNames.map((t=>i.on(e,t,(e=>{this.emit(t,e)})))),"delegated-events")}),p.syncAndInitial)),this.postInitialize();const e=async()=>{await this._loadLocale().catch(h.throwIfNotAbortError),this.scheduleRender()};this.addHandles([E.onLocaleChange(e),p.watch((()=>this.uiStrings),e),p.when((()=>this.container),(e=>{this.destroyed||this._attach(e)}),{initial:!0,once:!0})])}_attach(e){e&&(this._projector.merge(e,this.render),this._attached=!0)}_detach(e){this._attached&&(this._projector.detach(this.render),this._attached=!1),e?.parentNode?.removeChild(e)}};H[P]=!0,H.vnodeSelector="div",e.__decorate([_.property()],H.prototype,"_readyForTrueRender",void 0),e.__decorate([_.property({value:null})],H.prototype,"container",null),e.__decorate([g.cast("container")],H.prototype,"castContainer",null),e.__decorate([_.property()],H.prototype,"icon",null),e.__decorate([_.property()],H.prototype,"id",null),e.__decorate([_.property()],H.prototype,"label",null),e.__decorate([_.property()],H.prototype,"renderable",null),e.__decorate([_.property()],H.prototype,"uiStrings",void 0),e.__decorate([_.property()],H.prototype,"viewModel",void 0),e.__decorate([_.property({value:!0})],H.prototype,"visible",null),e.__decorate([_.property()],H.prototype,"key",void 0),e.__decorate([_.property()],H.prototype,"children",void 0),e.__decorate([_.property()],H.prototype,"afterCreate",void 0),e.__decorate([_.property()],H.prototype,"afterUpdate",void 0),e.__decorate([_.property()],H.prototype,"afterRemoved",void 0),H=e.__decorate([y.subclass(k)],H);return H}));
