/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../Color","../../core/accessorSupport/decorators/property","../../core/accessorSupport/decorators/cast","../../core/RandomLCG","../../core/has","../../core/accessorSupport/decorators/subclass","../../renderers/support/authoringInfoUtils","../../renderers/visualVariables/support/SizeStop","../../symbols/support/cimSymbolUtils","./SmartMappingSliderBase","./BinaryColorSizeSlider/BinaryColorSizeSliderViewModel","./support/utils","../support/globalCss","../support/widgetUtils","../support/decorators/messageBundle","../support/jsxFactory"],(function(e,r,t,s,a,o,i,l,n,d,p,c,m,u,h,g,y){"use strict";var b;const v="esri-binary-color-size-slider",_={base:v,rampElement:`${v}__ramp`,sliderContainer:`${v}__slider-container`,histogramContainer:`${v}__histogram-container`,zoomCapTop:`${v}__zoom-cap-top`,zoomCapBottom:`${v}__zoom-cap-bottom`,zoomCapLine:`${v}__zoom-cap-line`,zoomCapMask:`${v}__zoom-cap-mask`,zoomCapUnderline:`${v}__zoom-cap-underline`,primaryHandle:`${v}--primary-handle`,track:`${v}--interactive-track`},S={trackBackgroundColor:new r([224,224,224]),trackAboveFillColor:new r([149,149,149]),trackBelowFillColor:new r([149,149,149])};let f=b=class extends p.SmartMappingSliderBase{constructor(e,r){super(e,r),this._minRampFillWidth=.2,this._rampNode=null,this.messages=null,this.style={...S},this.viewModel=new c,this._rampFillId=`${this.id}-linear-gradient`}get handlesSyncedToPrimary(){return this.viewModel.handlesSyncedToPrimary}set handlesSyncedToPrimary(e){this.viewModel.handlesSyncedToPrimary=e}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}get persistSizeRangeEnabled(){return this.viewModel.persistSizeRangeEnabled}set persistSizeRangeEnabled(e){this.viewModel.persistSizeRangeEnabled=e}get stops(){return this.viewModel.stops}set stops(e){this.viewModel.stops=e}castStyle(e){return{...S,...e}}static fromRendererResult(e,r){const{size:{visualVariables:t},statistics:s}=e,{avg:a,stddev:o}=s,i=t[0].stops,[n,d]=l.authoringInfoFirstVariableSliderMinMax(e.renderer.authoringInfo),p=w(e.renderer.classBreakInfos);return new b({max:d,min:n,stops:i??void 0,histogramConfig:{average:a??void 0,standardDeviation:o??void 0,bins:r?r.bins:[]},style:p,handlesSyncedToPrimary:!0,persistSizeRangeEnabled:!0})}updateFromRendererResult(e,r){const{size:{visualVariables:t},statistics:s}=e,{avg:a,stddev:o}=s,i=t[0].stops,[n,d]=l.authoringInfoFirstVariableSliderMinMax(e.renderer.authoringInfo),p=w(e.renderer.classBreakInfos);this.set({max:d,min:n,stops:i,histogramConfig:{average:a,standardDeviation:o,bins:r?r.bins:[]},style:p,handlesSyncedToPrimary:!0,persistSizeRangeEnabled:!0})}updateRenderer(e){if("univariate-color-size"!==e.authoringInfo?.type||"above-and-below"!==e.authoringInfo?.univariateTheme)return console.error("Input renderer must be a univariate renderer with an above-and-below theme."),null;const r=e.clone(),t=r.visualVariables?.find((e=>"size"===e.type&&"outline"!==e.target&&e.stops)),{stops:s}=this;if(!r.visualVariables||!t||!s)return console.error("No size stops available."),null;const a=r.visualVariables.indexOf(t);r.visualVariables.splice(a,1),t.stops=s,r.visualVariables.push(t);const o=s[5===s.length?2:1].value;return r.classBreakInfos[0].maxValue=o,r.classBreakInfos[1].minValue=o,r}updateFromVisualVariable(e){if(!e)return;const{maxDataValue:r,minDataValue:t,stops:s}=e;if(s)this.stops=s;else{const[s,a]=m.getSizesFromVariable(e);this.stops=[new n({value:t??void 0,size:a}),new n({value:r??void 0,size:s})]}}render(){const{label:e,state:r,viewModel:{primaryHandleEnabled:t},visibleElements:s}=this,a="disabled"===r,o=this.classes(_.base,u.globalCss.widget,u.globalCss.panel,{[u.globalCss.disabled]:a,[_.primaryHandle]:t,[_.track]:!!s.interactiveTrack});return y.tsx("div",{"aria-label":e,class:o},a?null:this.renderContent(this._renderRamp(),_.sliderContainer,_.histogramContainer))}_renderRamp(){const{style:{trackBackgroundColor:e},zoomOptions:r}=this;return y.tsx("div",{afterCreate:h.storeNode,bind:this,class:_.rampElement,"data-node-ref":"_rampNode"},y.tsx("svg",{key:"ramp-svg",xmlns:"http://www.w3.org/2000/svg"},y.tsx("rect",{fill:m.getFillFromColor(e),height:"100%",width:"100%",x:"0",y:"0"}),this._renderPrimaryRamp(),this._renderPath()),r?this.renderZoomCaps():null)}_renderPrimaryRamp(){const{_rampFillId:e,style:{trackAboveFillColor:r,trackBelowFillColor:t},viewModel:s}=this;return[y.tsx("defs",null,this.renderRampFillDefinition(e,s.getGradientStopInfo(r,t)))]}_renderPath(){if(!this._rampNode)return;const{offsetHeight:e=0,offsetWidth:r=0}=this._rampNode;if(null==e||null==r)return;const{stops:t,viewModel:{max:s,min:a},_rampFillId:o,_minRampFillWidth:i}=this,l=m.getDynamicPathForSizeStops({max:s,min:a,pathHeight:e,pathWidth:r,stops:t,padding:i});return y.tsx("path",{d:l,fill:`url(#${o})`})}};e.__decorate([t.property()],f.prototype,"handlesSyncedToPrimary",null),e.__decorate([t.property()],f.prototype,"label",null),e.__decorate([t.property(),g.messageBundle("esri/widgets/smartMapping/SizeSlider/t9n/SizeSlider")],f.prototype,"messages",void 0),e.__decorate([t.property()],f.prototype,"persistSizeRangeEnabled",null),e.__decorate([t.property()],f.prototype,"stops",null),e.__decorate([t.property()],f.prototype,"style",void 0),e.__decorate([s.cast("style")],f.prototype,"castStyle",null),e.__decorate([t.property()],f.prototype,"viewModel",void 0),f=b=e.__decorate([i.subclass("esri.widgets.smartMapping.BinaryColorSizeSlider")],f);function w(e){if(e.length<=1)return{};const r=e=>{if("cim"===e.type)return d.getCIMSymbolColor(e);if(e.symbolLayers){const r=e.symbolLayers?.at(0);return r.material?.color}return e.color};return{trackBelowFillColor:r(e[0].symbol)??void 0,trackAboveFillColor:r(e[1].symbol)??void 0}}return f}));
