/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../core/Error","../../core/accessorSupport/decorators/property","../../core/has","../../core/Logger","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../../renderers/support/authoringInfoUtils","../../renderers/visualVariables/support/ColorSizeStop","../../renderers/visualVariables/support/ColorStop","../../renderers/visualVariables/support/SizeStop","./SmartMappingSliderBase","./ColorSizeSlider/ColorSizeSliderViewModel","./support/utils","../support/globalCss","../support/widgetUtils","../support/decorators/messageBundle","../support/jsxFactory"],(function(e,r,t,s,i,a,l,o,n,d,p,u,m,h,c,g,b,v){"use strict";var S;const f="esri-color-size-slider",z={base:f,rampElement:`${f}__ramp`,sliderContainer:`${f}__slider-container`,histogramContainer:`${f}__histogram-container`,primaryHandle:`${f}--primary-handle`,track:`${f}--interactive-track`};let y=S=class extends u.SmartMappingSliderBase{constructor(e,r){super(e,r),this._backgroundFillColor="#e0e0e0",this._minRampFillWidth=.2,this._rampNode=null,this._maxRampFillWidth=1,this.messages=null,this.viewModel=new m,this._bgFillId=`${this.id}-bg-fill`,this._rampFillId=`${this.id}-linear-gradient`}get handlesSyncedToPrimary(){return this.viewModel.handlesSyncedToPrimary}set handlesSyncedToPrimary(e){this.viewModel.handlesSyncedToPrimary=e}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}get persistSizeRangeEnabled(){return this.viewModel.persistSizeRangeEnabled}set persistSizeRangeEnabled(e){this.viewModel.persistSizeRangeEnabled=e}get primaryHandleEnabled(){return this.viewModel.primaryHandleEnabled}set primaryHandleEnabled(e){this.viewModel.primaryHandleEnabled=e}get stops(){return this.viewModel.stops}set stops(e){this.viewModel.stops=e}static fromRendererResult(e,t){const s=e.size.visualVariables,i=e.renderer.authoringInfo?.univariateTheme,a=e.color?.visualVariable.stops,{statistics:l}=e,{avg:d,stddev:p}=l;if(!a)throw new r("ColorSizeSlider-fromRendererResult:invalid-renderer-result","'result' must include 'color' variable.");const u="above-and-below"===i,[m,h]=o.authoringInfoFirstVariableSliderMinMax(e.renderer.authoringInfo),c=s.find((e=>"outline"!==e?.target&&!(e?.axis&&!e?.field&&!e?.valueExpression)&&(e?.field||e?.valueExpression))),g=c.stops,b=a.map(((e,r)=>{const{color:t,label:s,value:i}=e;let l;return l=g&&g.length>0?g[r].size:0===r?c.minSize:r===a.length-1?c.maxSize:null,new n({color:t,label:s,value:i,size:l})}));return new S({max:h,min:m,stops:b,primaryHandleEnabled:u,handlesSyncedToPrimary:u,persistSizeRangeEnabled:u,histogramConfig:{average:d??void 0,standardDeviation:p??void 0,bins:t?t.bins:[]}})}updateFromRendererResult(e,t){const s=e.size.visualVariables,i=e.renderer.authoringInfo?.univariateTheme,a=e.color?.visualVariable.stops,{statistics:l}=e,{avg:d,stddev:p}=l;if(!a)throw new r("ColorSizeSlider-fromRendererResult:invalid-renderer-result","'result' must include 'color' variable.");const u="above-and-below"===i,[m,h]=o.authoringInfoFirstVariableSliderMinMax(e.renderer.authoringInfo),c=s.find((e=>"outline"!==e?.target&&!(e?.axis&&!e?.field&&!e?.valueExpression)&&(e?.field||e?.valueExpression))),g=c.stops,b=a.map(((e,r)=>{const{color:t,label:s,value:i}=e;let l;return l=g&&g.length>0?g[r].size:0===r?c.minSize:r===a.length-1?c.maxSize:null,new n({color:t,label:s,value:i,size:l})}));this.set({max:h,min:m,stops:b,primaryHandleEnabled:u,handlesSyncedToPrimary:u,persistSizeRangeEnabled:u,histogramConfig:{average:d,standardDeviation:p,bins:t?t.bins:[]}})}updateRenderer(e){const{stops:r}=this,t=r[0],s=r[r.length-1],i=r[Math.floor(r.length/2)],a=e.clone(),l=a.visualVariables?.map((e=>{if("size"===e.type){if("outline"===e?.target||e?.axis&&!e?.field&&!e?.valueExpression)return e;null!=e.minSize&&null!=e.maxSize?e.set({maxDataValue:s.value,minDataValue:t.value,maxSize:s.size,minSize:t.size}):e.stops&&e.set({stops:r.map((e=>{const{label:r,size:t,value:s}=e;return new p({label:r,size:t,value:s})}))})}else"color"===e.type&&e.set({stops:this.stops.map((e=>{const{color:r,label:t,value:s}=e;return new d({color:r,label:t,value:s})}))});return e}))??null;if(a.visualVariables=l,a.classBreakInfos.length>1){const e=i.value;a.classBreakInfos[0].maxValue=e,a.classBreakInfos[1].minValue=e}return a}updateVisualVariables(e){return e.map((e=>{const r=e.clone();if("size"===e.type){if("outline"===e?.target||e?.axis&&!e?.field&&!e?.valueExpression)return r;if(null!=e.minSize&&null!=e.maxSize){const{stops:e}=this,t=e[0],s=e[e.length-1];r.set({maxDataValue:s.value,minDataValue:t.value,maxSize:s.size,minSize:t.size})}else e.stops&&r.set({stops:this.stops.map((e=>{const{label:r,size:t,value:s}=e;return new p({label:r,size:t,value:s})}))})}else"color"===e.type&&r.set({stops:this.stops.map((e=>{const{color:r,label:t,value:s}=e;return new d({color:r,label:t,value:s})}))});return r}))}render(){const{label:e,primaryHandleEnabled:r,state:t,visibleElements:s}=this,i="disabled"===t,a=this.classes(z.base,c.globalCss.widget,c.globalCss.panel,{[c.globalCss.disabled]:i,[z.primaryHandle]:r,[z.track]:!!s.interactiveTrack});return v.tsx("div",{"aria-label":e,class:a},i?null:this.renderContent(this._renderRamp(),z.sliderContainer,z.histogramContainer))}_renderRamp(){const{_bgFillId:e,_rampFillId:r,viewModel:t,zoomOptions:s}=this,i=t.getStopInfo();return v.tsx("div",{afterCreate:g.storeNode,bind:this,class:z.rampElement,"data-node-ref":"_rampNode"},v.tsx("svg",{xmlns:"http://www.w3.org/2000/svg"},v.tsx("defs",null,this.renderRampFillDefinition(r,i),this.renderBackgroundFillDefinition(e)),v.tsx("rect",{fill:this._backgroundFillColor,height:"100%",width:"100%",x:"0",y:"0"}),this._renderPaths()),s?this.renderZoomCaps():null)}_renderPaths(){if(!this._rampNode)return;const{offsetHeight:e=0,offsetWidth:r=0}=this._rampNode;if(null==e||null==r)return;const{primaryHandleEnabled:t,stops:s,values:i,viewModel:{max:a,min:l},_bgFillId:o,_maxRampFillWidth:n,_minRampFillWidth:d,_rampFillId:p}=this,u=[n,d];s[0].size<s[s.length-1].size&&u.reverse();const m=i.slice().sort(((e,r)=>e>r?1:-1)),[c,g]=u,[b,S]=m,f=t?h.getDynamicPathForSizeStops({max:a,min:l,pathHeight:e,pathWidth:r,stops:s,padding:d}):h.getPathForSizeStops({bottomValue:b,bottomWidth:c,max:a,min:l,pathHeight:e,pathWidth:r,topValue:S,topWidth:g});return[v.tsx("path",{d:f,fill:`url(#${o})`,key:"background"}),v.tsx("path",{d:f,fill:`url(#${p})`,key:"fill"})]}};e.__decorate([t.property()],y.prototype,"label",null),e.__decorate([t.property(),b.messageBundle("esri/widgets/smartMapping/ColorSizeSlider/t9n/ColorSizeSlider")],y.prototype,"messages",void 0),e.__decorate([t.property()],y.prototype,"persistSizeRangeEnabled",null),e.__decorate([t.property()],y.prototype,"primaryHandleEnabled",null),e.__decorate([t.property()],y.prototype,"stops",null),e.__decorate([t.property()],y.prototype,"viewModel",void 0),y=S=e.__decorate([l.subclass("esri.widgets.smartMapping.ColorSizeSlider")],y);return y}));
