/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../chunks/tslib.es6","../../core/accessorSupport/decorators/property","../../core/has","../../core/Logger","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../Slider/SliderViewModel","./support/utils"],(function(t,e,s,o,i,n,a,r){"use strict";let l=class extends a{constructor(t){super(t),this._initialStopValues=[],this._max=null,this._min=null,this.hasTimeData=!1,this.inputFormatFunction=(t,e)=>"max"===e?this.getUnzoomedMax().toString():"min"===e?this.getUnzoomedMin().toString():t.toString(),this.inputParseFunction=null,this.labelFormatFunction=t=>{if(this.hasTimeData)return r.formatDateLabel(t);const{max:e,min:s,precision:o}=this,i=e-s>10?2:o;return r.formatNumberLabel(parseFloat(t.toFixed(i)))},this.thumbsConstrained=!1,this.zoomingEnabled=!0}set breaks(t){this._set("breaks",t),this.notifyChange("max"),this.notifyChange("min")}set stops(t){if(t?.length){const{max:e,min:s}=this,o=this.getValuesFromStops(t),i={};null!=s&&o.some((t=>t<s))&&(i.min=Math.min(...o)),null!=e&&o.some((t=>t>e))&&(i.max=Math.max(...o)),this.set({...i}),this._initialStopValues=o}else this._initialStopValues=null;this._set("stops",t||null),this.notifyChange("values")}get labels(){const{values:t}=this,e=t&&t.length?t.map(((t,e)=>this.getLabelForValue(t,"value",e))):[],s=this.getUnzoomedMax(),o=this.getUnzoomedMin();return{max:this.getLabelForValue(s,"max"),min:this.getLabelForValue(o,"min"),values:e}}get max(){const{breaks:t}=this;return t?.length?t[t.length-1].max:this.max}set max(t){const{zoomOptions:e}=this;if(null!=e?.max){const s=this.values;let o=e.max;if(t<o&&(o=t,e.max=t),s&&s.length)for(let e=0;e<s.length;e++)t<s[e]&&this.setValue(e,t);this._storeZoomMax(o,t)}else this.updateBreakMax(t),this.setMax(t);this.notifyChange("labels")}get min(){const{breaks:t}=this;return t?.length?t[0].min:this.min}set min(t){const{zoomOptions:e}=this;if(null!=e?.min){const s=this.values;let o=e.min;if(t>o&&(o=t,e.min=t),s&&s.length)for(let e=0;e<s.length;e++)t>s[e]&&this.setValue(e,t);this._storeZoomMin(o,t)}else this.updateBreakMin(t),this.setMin(t);this.notifyChange("labels")}get state(){const{max:t,min:e,values:s}=this;return null!=t&&null!=e&&s.length>0?"ready":"disabled"}get values(){const{breaks:t,stops:e}=this;if(!t&&!e)return[];if(t?.length){const e=t.map((t=>t.max));return e.pop(),e}if(e?.length<2)return[];const s=this.getValuesFromStops();return[s[0],s[s.length-1]]}set zoomOptions(t){const{zoomingEnabled:e,zoomOptions:s}=this;if(e){if(s){const e=null!=this._max?this._max:this.max,s=null!=this._min?this._min:this.min;if(t){const{max:o,min:i}=t,n=null!=o,a=null!=i,r=a?t.min:s,l=a?s:null,h=n?t.max:e,m=n?e:null;this._storeZoomMin(r,l),this._storeZoomMax(h,m)}else this.setMax(e),this.setMin(s),this._min=null,this._max=null}else if(t){const{max:e,min:s}=t;null!=s&&this._storeZoomMin(t.min,this.min),null!=e&&this._storeZoomMax(t.max,this.max)}this._set("zoomOptions",t),this.notifyChange("max"),this.notifyChange("min")}}getStopIndexFromValueIndex(t){const{stops:e}=this,s=this.values[t];if(0===t){return s<=this.values[1]?0:e.length-1}if(1===t){return this.values[0]>=s?0:e.length-1}return null}getStopChanges(t,e){const s=this.stops,o=this.getStopIndexFromValueIndex(t),i=this.getValuesFromStops();i[o]=e;const[n,a]=[i[0],i[i.length-1]].sort(((t,e)=>t>e?1:-1)),r=a-n,l=s.length-1;return i.map(((t,e)=>({index:e,value:this.toPrecision(n+e*r/l)})))}setValue(t,e){const{max:s,min:o,values:i}=this,n=i[t];if(isNaN(e)||n===e||e>s||e<o)return;i[t]=this.toPrecision(e),this._set("values",[...i]);const a=i.slice().sort(((t,e)=>t>e?1:-1)),l=a[0],h=a[a.length-1],m=r.getStopChanges(l,h,this._initialStopValues??[]);this.updateStops(m),this.updateBreaks(),this.notifyChange("labels")}getValuesFromStops(t){const e=t||this.stops;return e?.map((t=>t.hasOwnProperty("ratio")?t.ratio:t.value))}updateBreaks(){const{breaks:t,values:e}=this;t?.length&&e.slice().sort(((t,e)=>t>e?1:-1)).forEach(((e,s)=>{t[s].max=e,null!=t[s+1]&&(t[s+1].min=e)}))}updateBreakMax(t){const{breaks:e,max:s,min:o}=this;!isNaN(t)&&s!==t&&null!=o&&t>o&&e?.length&&(e[e.length-1].max=t)}updateBreakMin(t){const{breaks:e,max:s,min:o}=this;!isNaN(t)&&o!==t&&null!=s&&t<s&&e?.length&&(e[0].min=t)}updateStops(t){const{stops:e}=this,s=this.getValuesFromStops();if(s?.length){for(const e of t)s[e.index]=e.value;e.forEach(((t,e)=>{t.hasOwnProperty("ratio")?t.ratio=s[e]:t.value=s[e]}))}}getUnzoomedMax(){return this.zoomOptions&&null!=this._max?this._max:this.max}getUnzoomedMin(){return this.zoomOptions&&null!=this._min?this._min:this.min}_storeZoomMax(t,e){this._max=e,this.setMax(t)}_storeZoomMin(t,e){this._min=e,this.setMin(t)}};t.__decorate([e.property()],l.prototype,"breaks",null),t.__decorate([e.property()],l.prototype,"stops",null),t.__decorate([e.property()],l.prototype,"hasTimeData",void 0),t.__decorate([e.property()],l.prototype,"inputFormatFunction",void 0),t.__decorate([e.property()],l.prototype,"inputParseFunction",void 0),t.__decorate([e.property()],l.prototype,"labelFormatFunction",void 0),t.__decorate([e.property({readOnly:!0})],l.prototype,"labels",null),t.__decorate([e.property()],l.prototype,"max",null),t.__decorate([e.property()],l.prototype,"min",null),t.__decorate([e.property({readOnly:!0})],l.prototype,"state",null),t.__decorate([e.property()],l.prototype,"thumbsConstrained",void 0),t.__decorate([e.property({readOnly:!0})],l.prototype,"values",null),t.__decorate([e.property()],l.prototype,"zoomingEnabled",void 0),t.__decorate([e.property()],l.prototype,"zoomOptions",null),l=t.__decorate([n.subclass("esri.widgets.smartMapping.SmartMappingSliderViewModel")],l);return l}));
