/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../chunks/tslib.es6","../../core/Accessor","../../core/asyncUtils","../../core/has","../../core/Logger","../../core/maybe","../../core/promiseUtils","../../core/reactiveUtils","../../core/accessorSupport/decorators/property","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass"],(function(e,t,s,i,n,a,r,o,l,c,h,y){"use strict";var w;function d(e){return null!=e&&e.state>=w.RUNNING?(e.abort(),null):e}!function(e){e[e.PENDING=0]="PENDING",e[e.WAIT_FOR_VIEW_READY=1]="WAIT_FOR_VIEW_READY",e[e.RUNNING=2]="RUNNING"}(w||(w={})),e.AnalysisViewModel=class extends s{constructor(e={}){super(e),this.view=null,this.analysisView=null,this._reconnectViewTask=null,this._forceInteractiveHandle=null,this._parentChangeFromReconnect=!1,this._startUserOperation=null;const t=e?.analysis;null!=t?this.analysis=t:(this._set("analysis",this.constructAnalysis()),this._set("isAnalysisOwner",!0)),null!=e?.visible&&(this.visible=e.visible)}normalizeCtorArgs(e){const{analysis:t,...s}=e;return s}initialize(){this.addHandles([l.watch((()=>({readyAndNotSupported:null!=this.view&&this.view.ready&&!this.supported})),(({readyAndNotSupported:e})=>{e&&a.getLogger(this).errorOnce(this.unsupportedErrorMessage)}),l.syncAndInitial),l.watch((()=>this.analysis?.parent),(e=>{this._parentChangeFromReconnect||e===this.view||this._set("isAnalysisOwner",!1);const t=!this._parentChangeFromReconnect;this._parentChangeFromReconnect=!1,t&&this._scheduleViewReconnect()}),l.sync),l.watch((()=>({view:this.view,ready:null!=this.view&&this.view.ready,supported:this.supported})),(({view:e},t)=>{const s=t?.view;e!==s&&(this._startUserOperation=r.abortMaybe(this._startUserOperation),this._disconnectFromView(s)),this._scheduleViewReconnect()}),l.syncAndInitial)])}destroy(){this._reconnectViewTask=r.abortMaybe(this._reconnectViewTask),this._startUserOperation=r.abortMaybe(this._startUserOperation),null!=this.analysisView&&(this.analysisView.visible=void 0),this._disconnectFromView(this.view),this._set("view",null),null!=this.analysis&&this.isAnalysisOwner&&(this.analysis.destroy(),this._set("analysis",null))}get supported(){return null==this.view||this.view.type===this.supportedViewType}set visible(e){this._set("visible",e),null!=this.analysisView&&(this.analysisView.visible=e)}get active(){return null!=this.tool&&this.tool.active}get disabled(){return null==this.view||!this.view.ready||!this.supported}set analysis(e){e!==this._get("analysis")&&(this._startUserOperation=r.abortMaybe(this._startUserOperation),this._disconnectFromView(this.view),this._setExternalAnalysis(e),this._scheduleViewReconnect())}get ready(){return null!=this.analysisView&&!this.connectingToView}get connectingToView(){return null!=this._reconnectViewTask}get isAnalysisOwner(){return this._get("isAnalysisOwner")}get tool(){return null!=this.analysisView?this.analysisView.tool:null}clear(){this._startUserOperation=r.abortMaybe(this._startUserOperation),this._resetInteractiveCreationState(),null!=this.tool&&null!=this.view&&this.view.activeTool===this.tool&&(this.view.activeTool=null)}async start(){if(!this.visible)return void a.getLogger(this).warn("Cannot start analysis when not visible");this.clear();const e={task:null,abort:null,state:w.PENDING},t=i.createTask((async t=>{if(e.state=w.WAIT_FOR_VIEW_READY,await l.whenOnce((()=>this.ready),t),e.state=w.RUNNING,null==this.analysisView||null==this.view)return;const s=this.analysisView.tool;null!=s&&(this.view.activeTool=s,l.when((()=>s.created),(()=>{s.active&&null!=this.view&&(this.view.activeTool=null)}),{initial:!0,once:!0}))}));return e.task=t,e.abort=()=>t.abort(),this._startUserOperation=e,t.promise}onConnectToAnalysisView(e){}onDisconnectFromAnalysisView(){}_scheduleViewReconnect(){this._reconnectViewTask=r.abortMaybe(this._reconnectViewTask);const e=i.createTask((async t=>{try{await this._reconnectView(t)}catch(s){if(o.throwIfAborted(t),!o.isAbortError(s))return void a.getLogger(this).warn("Failed to use analysis in view model",s);throw s}finally{e===this._reconnectViewTask&&(this._reconnectViewTask=null)}}));this._reconnectViewTask=e}async _reconnectView(e){const{view:t}=this,s=null!=t&&t.ready&&this.supported,i=this.analysis;if(this._startUserOperation=d(this._startUserOperation),this._disconnectFromView(t),s&&null!=t&&null!=i){if(this.isAnalysisOwner){if(null!=i.parent)return void a.getLogger(this).errorOnce("expected owned analysis to have null parent when connecting to view");this._parentChangeFromReconnect=!0,t.analyses.add(i)}this.analysisView=await t.whenAnalysisView(i),o.isAborted(e)?this._startUserOperation=d(this._startUserOperation):(this.analysisView.visible=this.visible,this._forceInteractiveHandle=this.analysisView.forceInteractiveForViewModel(),this.addHandles(this._forceInteractiveHandle),this.onConnectToAnalysisView(this.analysisView))}}_disconnectFromView(e){null!=e&&this.isAnalysisOwner&&e.analyses.includes(this.analysis)&&(this._parentChangeFromReconnect=!0,this.analysis.clear(),e.analyses.remove(this.analysis)),this.onDisconnectFromAnalysisView(),this._forceInteractiveHandle=r.removeMaybe(this._forceInteractiveHandle),this.analysisView=null}_setExternalAnalysis(e){null==this.analysisView||this.isAnalysisOwner||(this.analysisView.visible=void 0,this._forceInteractiveHandle=r.removeMaybe(this._forceInteractiveHandle)),this.analysisView=null,this._set("isAnalysisOwner",!1),this._set("analysis",e),this._parentChangeFromReconnect=!1}_resetInteractiveCreationState(){this.analysis.clear(),null!=this.tool&&this.tool.resetCreated()}get testInfo(){}},t.__decorate([c.property()],e.AnalysisViewModel.prototype,"supported",null),t.__decorate([c.property()],e.AnalysisViewModel.prototype,"view",void 0),t.__decorate([c.property({type:Boolean,value:!0})],e.AnalysisViewModel.prototype,"visible",null),t.__decorate([c.property()],e.AnalysisViewModel.prototype,"active",null),t.__decorate([c.property()],e.AnalysisViewModel.prototype,"disabled",null),t.__decorate([c.property({nonNullable:!0})],e.AnalysisViewModel.prototype,"analysis",null),t.__decorate([c.property()],e.AnalysisViewModel.prototype,"analysisView",void 0),t.__decorate([c.property()],e.AnalysisViewModel.prototype,"ready",null),t.__decorate([c.property()],e.AnalysisViewModel.prototype,"connectingToView",null),t.__decorate([c.property({readOnly:!0})],e.AnalysisViewModel.prototype,"isAnalysisOwner",null),t.__decorate([c.property()],e.AnalysisViewModel.prototype,"_reconnectViewTask",void 0),t.__decorate([c.property()],e.AnalysisViewModel.prototype,"_forceInteractiveHandle",void 0),t.__decorate([c.property()],e.AnalysisViewModel.prototype,"tool",null),e.AnalysisViewModel=t.__decorate([y.subclass("esri.widgets.support.AnalysisViewModel")],e.AnalysisViewModel),Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
