/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../../chunks/tslib.es6","../../Color","../../intl","../../core/reactiveUtils","../../core/unitFormatUtils","../../core/accessorSupport/decorators/property","../../core/has","../../core/Logger","../../core/RandomLCG","../../core/accessorSupport/decorators/subclass","../Widget","../../chunks/componentsUtils","./globalCss","./LabeledSwitch","./widgetUtils","./decorators/messageBundle","./jsxFactory","./GridControls/GridControlsViewModel","./GridControls/gridUtils","./GridControls/VisibleElements","../../intl/substitute"],(function(e,t,i,n,s,l,a,o,r,c,d,p,u,g,h,m,b,v,_,w,C,x){"use strict";const y="esri-grid-controls",M={base:y,borderedSwitch:`${y}__switch--bordered`,container:`${y}__container`,numericInputsContainer:`${y}__numeric-inputs__container`,tilegroup:`${y}__tilegroup`,tile:`${y}__tile`,tileDisabled:`${y}__tile--disabled`,tileContent:`${y}__tile__content`,suffixedInputContainer:`${y}__input-with-suffix__container`,inputSuffix:`${y}__input-with-suffix__suffix-part`,inlineIcon:`${y}__inline-icon`},f={widgetIcon:"grid-unit",gridTheme:{light:"circle",dark:"circle-area",custom:"palette"},placementState:{interactive:"maximum-territory-distance",place:"move",rotate:"rotate"},warning:"exclamation-mark-triangle"},S=i.fromArray([115,115,115]),k=i.fromArray([200,200,200]),I=["interactive","place","rotate"];let T=class extends p{constructor(e,t){super(e,t),this.customColor=null,this.messages=null,this.messagesUnits=null,this.viewModel=new _,this.visibleElements=new C}initialize(){this.addHandles([s.watch((()=>this.view?.grid?.majorLineColor),(e=>{!e||S.equals(e)||k.equals(e)||(this.customColor=e)}),s.initial)])}loadDependencies(){return Promise.all([u.loadCalciteComponents({action:()=>new Promise(((t,i)=>e(["../../chunks/calcite-action"],t,i))),"action-bar":()=>new Promise(((t,i)=>e(["../../chunks/calcite-action-bar"],t,i))),label:()=>new Promise(((t,i)=>e(["../../chunks/calcite-label"],t,i))),icon:()=>new Promise(((t,i)=>e(["../../chunks/calcite-icon"],t,i))),popover:()=>new Promise(((t,i)=>e(["../../chunks/calcite-popover"],t,i))),tooltip:()=>new Promise(((t,i)=>e(["../../chunks/calcite-tooltip"],t,i))),"color-picker":()=>new Promise(((t,i)=>e(["../../chunks/calcite-color-picker"],t,i))),"input-number":()=>new Promise(((t,i)=>e(["../../chunks/calcite-input-number"],t,i)))}),h.loadLabeledSwitchComponents()])}get icon(){return f.widgetIcon}set icon(e){this._overrideIfSome("icon",e)}get label(){return this.messages.widgetLabel}set label(e){this._overrideIfSome("label",e)}get snappingManager(){return this.viewModel.snappingManager}set snappingManager(e){this.viewModel.snappingManager=e}get snappingOptions(){return this.viewModel.snappingOptions}set snappingOptions(e){this.viewModel.snappingOptions=e}get theme(){const e=this.viewModel.grid?.majorLineColor;return e?S.equals(e)?"dark":k.equals(e)?"light":"custom":null}set theme(e){const{viewModel:t,customColor:i,view:n}=this;switch(e){case"light":t.gridColor=k;break;case"dark":t.gridColor=S;break;case"custom":t.gridColor=i??n?.effectiveTheme.accentColor??S}}get view(){return this.viewModel.view}set view(e){this.viewModel.view=e}render(){return v.tsx("div",{"aria-label":this.label,class:this.classes(M.base,g.globalCss.widget,g.globalCss.panel)},v.tsx("div",{class:M.container},this._renderContent()))}_renderContent(){const{visibleElements:e}=this;return[e.gridEnabledToggle?this._renderEnabledToggle():null,e.placementButtons?this._renderGridPlacementButtons():null,e.numericInputs?this._renderNumericInputs():null,e.lineIntervalInput?this._renderIntervalInput():null,e.gridSnapEnabledToggle&&this.viewModel.snappingOptions?this._renderSnappingToggle():null,e.dynamicScaleToggle?this._renderDynamicScaleToggle():null,e.rotateWithMapToggle?this._renderRotateToggle():null,e.colorSelection?this._renderColorSelection():null]}_renderGridPlacementButtons(){const{interactivePlacementState:e,placementDisabled:t,gridControlsEnabled:i}=this.viewModel,n=t||!i;return v.tsx("calcite-label",{key:"grid-placement-buttons",scale:"s"},this.messages.placementOptions,v.tsx("calcite-action-bar",{expandDisabled:!0,layout:"horizontal"},I.map((t=>this._renderPlacementModeButton(t,n,e)))))}_renderPlacementModeButton(e,t,i){const n=this.messages.placementState[e],s=`__placement-action-${e}`;return v.tsx("div",null,v.tsx("calcite-action",{active:i===e,alignment:"center",disabled:t,icon:f.placementState[e],id:s,onclick:()=>this.viewModel.togglePlacementState(e),text:n}),v.tsx("calcite-tooltip",{placement:"top",referenceElement:s},n))}_renderNumericInputs(){const{rotation:e,spacing:t,effectiveSpacingAfterDynamicScaling:i,numericSpacingInputShouldBeVisible:n,unit:s="meters"}=this.viewModel,a=this.messagesUnits.units[s].abbr,o=this.viewModel.gridControlsEnabled,r=null!=i&&i!==this.viewModel.spacing,c=`__spacing_input_scaled-${this.id}`;return v.tsx("div",{class:this.classes(M.numericInputsContainer)},[n?v.tsx("calcite-label",{key:"spacing-label",scale:"s"},v.tsx("span",null,this.messages.inputLabel.spacing,r?v.tsx("calcite-icon",{class:this.classes(M.inlineIcon),icon:f.warning,id:c,scale:"s",tabIndex:0}):void 0),v.tsx("div",{class:M.suffixedInputContainer},v.tsx("calcite-input-number",{disabled:!o,numberButtonType:"none",suffixText:a,value:`${t?.toFixed(2)}`,onCalciteInputNumberChange:({target:e})=>{const t=parseFloat(e.value);this.viewModel.spacing=t,t!==this.viewModel.spacing&&(e.value=`${this.viewModel.spacing}`)}}),r?v.tsx("calcite-tooltip",{overlayPositioning:"fixed",placement:"leading",referenceElement:c},x.substitute(this.messages.warnings.dynamicSpacing,{actualSpacingIncludingUnit:l.formatDecimal(this.messagesUnits,i,s,2,"plural")})):void 0)):void 0,v.tsx("calcite-label",{key:"angle-label",scale:"s"},this.messages.inputLabel.angle,v.tsx("calcite-input-number",{disabled:!o,integer:!0,numberButtonType:"none",suffixText:this.messagesUnits.units.degrees.abbr,value:`${w.gridRotationToDegrees(e)}`,onCalciteInputNumberChange:({target:e})=>this.viewModel.rotation=w.userInputToGridRotation(e.value)}))])}_renderIntervalInput(){const{majorLineInterval:e,gridControlsEnabled:t}=this.viewModel;return v.tsx("div",{class:this.classes(M.numericInputsContainer)},v.tsx("calcite-label",{scale:"s"},this.messages.inputLabel.interval,v.tsx("calcite-input-number",{disabled:!t,integer:!0,max:15,min:1,numberButtonType:"vertical",value:`${e}`,onCalciteInputNumberChange:({target:e})=>{const t=Number.parseInt(e.value,10);this.viewModel.majorLineInterval=t,t!==this.viewModel.majorLineInterval&&(e.value=`${this.viewModel.majorLineInterval}`)}})))}_renderSnappingToggle(){const{snappingOptions:e,gridControlsEnabled:t}=this.viewModel,i=e?.gridEnabled??!1,n=t&&!!e;return v.tsx(h.LabeledSwitch,{checked:!!i,disabled:!n,key:"grid-snap-enabled-toggle",label:this.messages.switchLabel.snap,onChange:e=>this.viewModel.snappingOptions?.set("gridEnabled",e)})}_renderDynamicScaleToggle(){const{viewModel:e,messages:t}=this,i=this.visibleElements.outOfScaleWarning&&e.gridOutOfScale;return v.tsx(h.LabeledSwitch,{checked:e.dynamicScaling,disabled:!e.gridControlsEnabled,hint:i?t.warnings.outOfScale:void 0,hintIcon:f.warning,hintKind:"warning",key:`grid-dynamic-scale-toggle-${this.id}`,label:t.switchLabel.scaling,onChange:t=>e.dynamicScaling=t})}_renderRotateToggle(){const{gridControlsEnabled:e,rotateWithMap:t}=this.viewModel;return v.tsx(h.LabeledSwitch,{checked:t,disabled:!e,key:"grid-rotate-map-toggle",label:this.messages.switchLabel.rotateWithMap,onChange:e=>this.viewModel.rotateWithMap=e})}_renderEnabledToggle(){return v.tsx("div",{class:M.borderedSwitch},v.tsx(h.LabeledSwitch,{checked:this.viewModel.displayEnabled,disabled:!!this.viewModel.interactivePlacementState,key:"grid-enabled-toggle",label:this.messages.switchLabel.display,onChange:e=>this.viewModel.trySetDisplayEnabled(e)}))}_renderColorSelection(){const{customColor:e}=this,t=`${this.id}--custom-grid-color-button`;return v.tsx("calcite-label",{scale:"s"},this.messages.inputLabel.theme,v.tsx("div",{class:M.tilegroup},[this._renderThemeTile({value:"dark"}),this._renderThemeTile({value:"light"}),this._renderThemeTile({value:"custom",id:t}),v.tsx("calcite-popover",{autoClose:!0,label:this.messages.gridLineColorPopoverLabel,overlayPositioning:"fixed",referenceElement:t},v.tsx("calcite-color-picker",{alphaChannel:!0,savedDisabled:!0,value:e?.toHex({digits:8})??"#000000ff",onCalciteColorPickerChange:e=>{const t=i.fromHex(e.target.value);t&&(this.customColor=t,this.theme="custom")}}))]))}_renderThemeTile(e){const{theme:t}=this,{value:i}=e,n=this.messages.gridTheme[i],s=`${this.id}--theme_tile_${i}`,l=`${s}__label`,a=f.gridTheme[i],o=this.viewModel.gridControlsEnabled;return v.tsx("div",{class:m.classes({[M.tile]:!0,[M.tileDisabled]:!o}),id:e.id,role:"button"},v.tsx("input",{"aria-labelledby":l,checked:t===i,disabled:!o,id:s,name:`${this.id}--theme`,onchange:e=>{this.theme=i,e.target?.focus()},tabIndex:0,type:"radio"}),v.tsx("div",{class:M.tileContent},v.tsx("calcite-icon",{icon:a,scale:"l"}),v.tsx("calcite-label",{for:s,id:l},n)))}};t.__decorate([a.property()],T.prototype,"customColor",void 0),t.__decorate([a.property()],T.prototype,"icon",null),t.__decorate([a.property()],T.prototype,"label",null),t.__decorate([a.property(),b.messageBundle("esri/widgets/support/GridControls/t9n/GridControls")],T.prototype,"messages",void 0),t.__decorate([a.property(),b.messageBundle("esri/core/t9n/Units")],T.prototype,"messagesUnits",void 0),t.__decorate([a.property()],T.prototype,"snappingManager",null),t.__decorate([a.property()],T.prototype,"snappingOptions",null),t.__decorate([a.property()],T.prototype,"theme",null),t.__decorate([a.property()],T.prototype,"view",null),t.__decorate([a.property({type:_})],T.prototype,"viewModel",void 0),t.__decorate([a.property({type:C,nonNullable:!0})],T.prototype,"visibleElements",void 0),T=t.__decorate([d.subclass("esri.widgets.support.GridControls")],T);return T}));
