/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../Color","../../../geometry","../../../symbols","../../../core/Evented","../../../core/Logger","../../../core/mathUtils","../../../core/maybe","../../../core/reactiveUtils","../../../core/unitUtils","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","../../../geometry/projection","../../../geometry/support/scaleUtils","../../../grids/MeasuredGrid","../../../layers/graphics/dehydratedPoint","../../../properties/defaultUnit","../../../views/2d/grid/constants","../../../views/2d/grid/gridUtils","../../../views/2d/interactive/editingTools/draw/DrawGraphicTool2D","../../../views/2d/interactive/editingTools/ControlPointsTransformTool","../../../views/2d/interactive/editingTools/TransformTool","../../../views/2d/interactive/editingTools/MediaTransformToolsWrapper","../../../views/interactive/snapping/snappingUtils","../../../views/overlay/CrosshairOverlayItem","../../../views/overlay/TextOverlayItem","../../CoordinateConversion/support/formatUtils","./gridUtils","../../../geometry/Point","../../../symbols/SimpleLineSymbol","../../../symbols/SimpleMarkerSymbol"],(function(e,t,i,r,o,s,a,n,l,c,d,h,p,g,_,y,u,v,m,w,S,b,f,P,T,C,G,x,R,O,M,L,I){"use strict";const U=Symbol("grid-interactivity");let k=class extends o.EventedAccessor{constructor(e){super(e),this._drawGraphicTool=null,this._crosshairLabel=null,this._crosshairItem=null,this.snappingManager=null,this.snappingOptions=null,this.view=null,this.placementDisabled=!1,this._mostRecentlyShownGrid=null,this._sketchedVertexCount=0}initialize(){this.addHandles([l.when((()=>!this.displayEnabled),(()=>{this.interactivePlacementState=null})),l.watch((()=>this.view?.viewpoint),(()=>{this._renderOverlays()})),l.watch((()=>this.snappingOptions?.gridEnabled),(e=>{null!=e&&this.trySetDisplayEnabled(e)})),l.watch((()=>this.view?.grid),((e,t)=>{this._mostRecentlyShownGrid=!e&&t?t:null}))])}destroy(){this._resetGridPlacementState(),this._crosshairItem&&(this.view?.overlay?.removeItem(this._crosshairItem),this._crosshairItem=n.destroyMaybe(this._crosshairItem)),this._crosshairLabel&&(this.view?.overlay?.removeItem(this._crosshairLabel),this._crosshairLabel=n.destroyMaybe(this._crosshairLabel))}get displayEnabled(){return!!this.view?.grid}get dynamicScaling(){return this.grid?.dynamicScaling??!1}set dynamicScaling(e){this.grid&&(this.grid.dynamicScaling=e)}get grid(){return this.view?.grid??this._mostRecentlyShownGrid}set gridColor(e){this._set("gridColor",e);const[t,i,r,o]=e.toArray();O.applyColorToGrid(this.grid,[t,i,r,o/255])}get gridControlsEnabled(){return this.displayEnabled&&!this.interactivePlacementState}set interactivePlacementState(e){this._set("interactivePlacementState",e),this._resetGridPlacementState(),e&&this._startGridManipulation(e)}get majorLineInterval(){return this.grid?.majorLineInterval??10}set majorLineInterval(e){this.grid&&(this.grid.majorLineInterval=e<1?1:e>15?15:e)}get rotateWithMap(){return this.grid?.rotateWithMap??!1}set rotateWithMap(e){this.grid&&(this.grid.rotateWithMap=e)}get rotation(){return this.grid?.rotation??-180}set rotation(e){this.grid&&(this.grid.rotation=e)}get snappingEnabled(){return(this.grid&&this.snappingOptions?.gridEnabled)??!1}set snappingEnabled(e){const{snappingOptions:t}=this;t&&(t.gridEnabled=e)}get spacing(){return this.grid?.spacing??1}set spacing(e){this.grid&&e>0&&(this.grid.spacing=e)}get unit(){return this.grid?.units}set unit(e){this.grid&&(this.grid.units=e)}get gridOutOfScale(){return!this.dynamicScaling&&null!=this._pixelsPerStride&&this._pixelsPerStride<w.minimumPixelsPerStrideForDisplayWhenScalingOff}get effectiveSpacingAfterDynamicScaling(){return this.majorLineInterval<1||!this.dynamicScaling||!this.view||null==this._pixelsPerStride||!this.grid?.spacing?null:this.grid.spacing*S.getScaleFactor(this.majorLineInterval,this._pixelsPerStride,this.dynamicScaling)}get numericSpacingInputShouldBeVisible(){return!!this.view?.spatialReference&&S.shouldUsePlanar(this.view.spatialReference)}get _metersPerSRUnit(){if(!(this.view&&this.displayEnabled&&this.grid&&_.isLoadedOrLoadFor(this.grid.center.spatialReference,this.view.spatialReference)))return null;const e=_.project(this.grid.center,this.view.spatialReference);return S.measureMetersPerUnitAtReferencePoint(e)}get _pixelsPerStride(){if(!this.view?.scale||!this.displayEnabled||!this.grid||null==this._metersPerSRUnit)return null;const e=this.grid,{scale:t,spatialReference:i}=this.view;return c.convertUnit(e.spacing,e.units,"meters")/(this._metersPerSRUnit*y.getResolutionForScale(t,i))}get _isPlacing(){if(!this._drawGraphicTool)return!1;const e=this.interactivePlacementState;return"place"===e||"interactive"===e&&0===this._sketchedVertexCount}get _isRotating(){if(!this._drawGraphicTool)return!1;const e=this.interactivePlacementState;return"rotate"===e||"interactive"===e&&1===this._sketchedVertexCount}get _isScaling(){if(!this._drawGraphicTool)return!1;return"interactive"===this.interactivePlacementState&&1===this._sketchedVertexCount}togglePlacementState(e){this.interactivePlacementState=this.interactivePlacementState===e?null:e}trySetDisplayEnabled(e){const{view:t}=this;if(t?.ready)if(!t.grid&&e)if(this._mostRecentlyShownGrid)t.grid=this._mostRecentlyShownGrid;else{const e="imperial"===this.defaultUnit?"feet":"meters";t.grid=new u.MeasuredGrid({units:e,center:t.center??new M,rotateWithMap:!0}),O.applyColorToGrid(this.grid,[115,115,115])}else e||(t.grid=null);else s.getLogger(this).warn("Attempting to enable grid display while view is not ready")}startPlacement(e){const{view:t,snappingManager:i}=this;if(!t)return;this._set("interactivePlacementState",e),this._sketchedVertexCount=0;const r=new b.DrawGraphicTool2D({view:t,graphicProperties:{attributes:{[C.gridPlacementGraphicSymbol]:C.gridPlacementGraphicSymbol}},sketchOptions:{tooltips:{enabled:!0,visibleElements:{direction:!1,rotation:!1,totalLength:!1,elevation:!1,distance:!1,area:!1}}},geometryType:"polyline",mode:"click",snapToScene:!1,snappingManager:i,forceUniformSize:!0,centered:!1,cursor:"interactive"===this.interactivePlacementState||"place"===this.interactivePlacementState?"none":null,regularVerticesSymbol:void 0,activeVertexSymbol:D,activeLineSymbol:V,graphicSymbol:V});this._drawGraphicTool=r,t.addAndActivateTool(r),this._renderOverlays(),this.addHandles([r.on("cursor-update",(e=>this._onCursorUpdate(e))),r.on("complete",(()=>this._onDrawComplete())),r.on("vertex-add",(t=>this._onVertexAdd(t,e)))],U)}async _startGridManipulation(e){const{view:t}=this;if(!t)return void(this.interactivePlacementState=null);const i=new CustomEvent("before-placement",{cancelable:!0});this.emit("before-placement",i),i.defaultPrevented||this.startPlacement(e)}_onCursorUpdate(e){try{if(this._isPlacing){const t=e.vertices[0].coordinates;return void this._handlePlace(t)}if(this._drawGraphicTool.cursor=null,this._isRotating&&this._handleRotate(e.vertices[0].coordinates),this._isScaling){const e=this._drawGraphicTool?.drawOperation.cursorVertex;this._handleScale(e)}}finally{this._renderOverlays()}}_onDrawComplete(){this._drawGraphicTool.cursor=null,this.interactivePlacementState=null}_onVertexAdd(e,t){const i=e.vertices[0].coordinates;this._isPlacing&&this._handlePlace(i),this._isRotating&&this._sketchedVertexCount>0&&this._handleRotate(i),this._isScaling&&this._sketchedVertexCount>0&&this._handleScale(v.makeDehydratedPoint(i[0],i[1],void 0,this.view.spatialReference)),this._sketchedVertexCount++,this._drawGraphicTool.cursor=null,2!==this._sketchedVertexCount&&"interactive"===t||(this.interactivePlacementState=null),this._renderOverlays()}_handlePlace(e){const{grid:t,view:i}=this;t&&i&&(t.center=new M({x:e[0],y:e[1],spatialReference:i.spatialReference}))}_handleRotate(e){const{grid:t,view:i}=this;if(!t||!i)return;this._drawGraphicTool?.sketchOptions.tooltips.set("enabled",!1);const{x:r,y:o}=t.center,[s,n]=e,l=i.toScreen(t.center,{pickClosestTarget:!0}),c=l&&i.toMap(l),d=i.toScreen(v.makeDehydratedPoint(s,n,void 0,i.spatialReference),{pickClosestTarget:!0}),h=d&&i.toMap(d),p=c?c.x:r,g=c?c.y:o,_=p-(h?h.x:s),y=g-(h?h.y:n);if(0===_&&0===y)return;const u=Math.atan2(y,_),m=a.rad2deg(u),w=t.rotateWithMap,S=i.viewpoint.rotation??0,b=w?m:m-S;t.rotation=Math.fround(b)%360}_handleScale(e){const{view:t,grid:i,_drawGraphicTool:r,interactivePlacementState:o,_metersPerSRUnit:s}=this;if(!(e&&t&&i&&r&&s))return;r.sketchOptions.tooltips.enabled=!1;const a="interactive"===o?i.center:r.drawOperation.firstVertex;if(!a||!e)return;const n=t?.toScreen(a),l=n&&t.toMap(n),d=t?.toScreen(e),h=l??a,p=(d&&t.toMap(d))??e,g=Math.sqrt((h.x-p.x)**2+(h.y-p.y)**2)*s,_=c.convertUnit(g,"meters",i.units);this.spacing=_}_renderOverlays(){this._renderCrosshairOverlay(),this._renderTextOverlay()}_renderTextOverlay(){const{grid:e,view:t,_drawGraphicTool:i}=this,r=this._getCrosshairLabel();if(!(e&&t?.overlay&&i&&r))return;const o=t.toScreen(e.center,{pickClosestTarget:!0});o&&(r.position=[o.x+12,o.y+12]),this._isRotating?(r.text=`${O.gridRotationToDegrees(e.rotation)}${R.degreeSymbol}`,r.visible=!0):r.visible=!1}_renderCrosshairOverlay(){const{grid:e,view:t,_drawGraphicTool:i}=this;if(!e||!t?.overlay||!i)return;const r=this._getCrosshair();if(!r)return;const o=t.toScreen(e.center);o&&(r.x=o.x,r.y=o.y,r.rotation=e.rotateWithMap?t.viewpoint.rotation-e.rotation:-e.rotation,r.visible=!!i)}_getCrosshairLabel(){if(this._crosshairLabel)return this._crosshairLabel;const{grid:e,view:i,_drawGraphicTool:r}=this;if(!e||!i?.overlay||!r)return null;const o=new x({anchor:"top-left",fontSize:10,textColor:new t([21,21,21]),backgroundColor:new t([248,248,248]),padding:8,borderRadius:20});return i.overlay.addItem(o),this._crosshairLabel=o,o}_getCrosshair(){const{_crosshairItem:e,view:t}=this;return t?.overlay?e&&t.overlay.items.includes(e)?e:(this._crosshairItem=new G({color:t.effectiveTheme.accentColor,thickness:4,length:36,visible:!0}),t.overlay?.addItem(this._crosshairItem),this._crosshairItem):null}_resetGridPlacementState(){this.removeHandles(U),this._crosshairItem&&(this._crosshairItem.visible=!1),this._crosshairLabel&&(this._crosshairLabel.visible=!1),this._drawGraphicTool&&(this.view?.activeTool===this._drawGraphicTool&&(this.view.activeTool=null),this.view?.tools.remove(this._drawGraphicTool)),this._drawGraphicTool=n.destroyMaybe(this._drawGraphicTool)}};e.__decorate([d.property(m.defaultUnitPropertyMetadata)],k.prototype,"defaultUnit",void 0),e.__decorate([d.property({readOnly:!0})],k.prototype,"displayEnabled",null),e.__decorate([d.property()],k.prototype,"dynamicScaling",null),e.__decorate([d.property()],k.prototype,"grid",null),e.__decorate([d.property()],k.prototype,"gridColor",null),e.__decorate([d.property({readOnly:!0})],k.prototype,"gridControlsEnabled",null),e.__decorate([d.property()],k.prototype,"interactivePlacementState",null),e.__decorate([d.property()],k.prototype,"majorLineInterval",null),e.__decorate([d.property()],k.prototype,"rotateWithMap",null),e.__decorate([d.property()],k.prototype,"rotation",null),e.__decorate([d.property()],k.prototype,"snappingEnabled",null),e.__decorate([d.property()],k.prototype,"snappingManager",void 0),e.__decorate([d.property()],k.prototype,"snappingOptions",void 0),e.__decorate([d.property()],k.prototype,"spacing",null),e.__decorate([d.property()],k.prototype,"unit",null),e.__decorate([d.property()],k.prototype,"view",void 0),e.__decorate([d.property({readOnly:!0})],k.prototype,"gridOutOfScale",null),e.__decorate([d.property({readOnly:!0})],k.prototype,"effectiveSpacingAfterDynamicScaling",null),e.__decorate([d.property({readOnly:!0})],k.prototype,"numericSpacingInputShouldBeVisible",null),e.__decorate([d.property()],k.prototype,"placementDisabled",void 0),e.__decorate([d.property()],k.prototype,"_metersPerSRUnit",null),e.__decorate([d.property()],k.prototype,"_pixelsPerStride",null),e.__decorate([d.property()],k.prototype,"_isPlacing",null),e.__decorate([d.property()],k.prototype,"_isRotating",null),e.__decorate([d.property()],k.prototype,"_isScaling",null),e.__decorate([d.property()],k.prototype,"_mostRecentlyShownGrid",void 0),e.__decorate([d.property()],k.prototype,"_sketchedVertexCount",void 0),k=e.__decorate([g.subclass("esri.widgets.support.GridControls.GridControlsViewModel")],k);const E=k,V=new L({width:0}),D=new I({color:t.fromArray([0,0,0,0]),outline:new L({color:t.fromArray([0,0,0,0])})});return E}));
