/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../../chunks/tslib.es6","../../core/deprecate","../../core/handleUtils","../../core/Logger","../../core/maybe","../../core/accessorSupport/decorators/property","../../core/accessorSupport/decorators/cast","../../core/RandomLCG","../../core/has","../../core/accessorSupport/decorators/subclass","../Widget","../../chunks/componentsUtils","./globalCss","./widgetUtils","./decorators/messageBundle","./jsxFactory","./SelectionToolbar/SelectionToolbarViewModel"],(function(e,o,t,s,l,i,r,a,c,n,d,p,u,h,v,g,_,T){"use strict";const b={lassoTool:!0,rectangleTool:!0},m={createTool:"polygon",mode:"freehand"},y={createTool:"rectangle"},w="esri-selection-toolbar",f={base:w,container:`${w}__container`,toolButton:`${w}__tool-button`};let C=class extends p{constructor(e,o){super(e,o),this._viewModelHandlesGroup=null,this.activeToolInfo=null,this.messages=null,this.toolConfigs=[],this.viewModel=new T,this.visibleElements={...b},this._viewModelHandlesGroup=s.handlesGroup([this.viewModel.on("complete",(e=>{this._set("activeToolInfo",null),this.emit("complete",e)}))])}destroy(){this._viewModelHandlesGroup=i.removeMaybe(this._viewModelHandlesGroup)}loadDependencies(){return u.loadCalciteComponents({action:()=>new Promise(((o,t)=>e(["../../chunks/calcite-action"],o,t))),icon:()=>new Promise(((o,t)=>e(["../../chunks/calcite-icon"],o,t)))})}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}get layers(){return t.deprecatedProperty(l.getLogger(this),"layers",{replacement:"Use SelectionToolbar.sources instead."}),this.viewModel.sources}set layers(e){t.deprecatedProperty(l.getLogger(this),"layers",{replacement:"Use SelectionToolbar.sources instead."}),this.viewModel.sources=e}get sources(){return this.viewModel.sources}set sources(e){this.viewModel.sources=e}get view(){return this.viewModel.view}set view(e){this.viewModel.view=e}castVisibleElements(e){return{...b,...e}}get visibleToolCount(){const{view:e,toolConfigs:o,visibleElements:t}=this;return(o?.length??0)+("2d"===e?.type?(t.lassoTool?1:0)+(t.rectangleTool?1:0):0)}activate(e){if(this.cancel(),"disabled"!==this.viewModel.state)switch(e){case"lasso":this._activateTool("lasso");break;case"rectangle":this._activateTool("rectangle");break;default:this._activateTool(e)}}cancel(){this.viewModel.cancel(),this._set("activeToolInfo",null)}render(){return _.tsx("div",{"aria-label":this.label,class:this.classes(f.base,h.globalCss.widget)},_.tsx("div",{class:f.container},this._renderDefaultTools(),this._renderCustomTools()))}_renderDefaultTools(){if("2d"===this.view?.type)return[this._renderRectangleTool(),this._renderLassoTool()]}_renderCustomTools(){if(this.toolConfigs?.length)return this.toolConfigs.map((({toolName:e,icon:o})=>_.tsx("calcite-action",{active:this.activeToolInfo?.toolName===e,bind:this,class:f.toolButton,disabled:"disabled"===this.viewModel.state,onclick:()=>this._onCustomToolClick(e),scale:"s",text:e,title:e},_.tsx("calcite-icon",{icon:o||"selection",scale:"s"}))))}_renderLassoTool(){const{activeToolInfo:e,messages:o,visibleElements:t}=this;if(!t.lassoTool)return;const s=o.selectByLasso;return _.tsx("calcite-action",{active:"lasso"===e?.toolName,bind:this,disabled:"disabled"===this.viewModel.state,onclick:this._onLassoToolClick,scale:"s",text:s,title:s},_.tsx("calcite-icon",{icon:"lasso-select",scale:"s"}))}_renderRectangleTool(){const{activeToolInfo:e,messages:o,visibleElements:t}=this;if(!t.rectangleTool)return;const s=o.selectByRectangle;return _.tsx("calcite-action",{active:"rectangle"===e?.toolName,bind:this,disabled:"disabled"===this.viewModel.state,onclick:this._onRectangleToolClick,scale:"s",text:s,title:s},_.tsx("calcite-icon",{icon:"cursor-marquee",scale:"s"}))}_onCustomToolClick(e){this._toggleTool(e)}_onLassoToolClick(){this._toggleTool("lasso")}_onRectangleToolClick(){this._toggleTool("rectangle")}_activateTool(e){const o=this._getToolOptions(e);if(!o)return;const t=this.viewModel.activate(o);t&&this._set("activeToolInfo",{toolName:e,operation:t})}_toggleTool(e){if(this.activeToolInfo){const o=this.activeToolInfo.toolName;if(this.cancel(),o===e)return}this._activateTool(e)}_getToolOptions(e){return"lasso"===e?m:"rectangle"===e?y:this.toolConfigs.find((o=>o.toolName===e))}};o.__decorate([r.property({readOnly:!0})],C.prototype,"activeToolInfo",void 0),o.__decorate([r.property()],C.prototype,"label",null),o.__decorate([r.property()],C.prototype,"layers",null),o.__decorate([r.property(),g.messageBundle("esri/widgets/support/SelectionToolbar/t9n/SelectionToolbar")],C.prototype,"messages",void 0),o.__decorate([r.property()],C.prototype,"sources",null),o.__decorate([r.property()],C.prototype,"toolConfigs",void 0),o.__decorate([r.property()],C.prototype,"view",null),o.__decorate([r.property()],C.prototype,"viewModel",void 0),o.__decorate([r.property()],C.prototype,"visibleElements",void 0),o.__decorate([a.cast("visibleElements")],C.prototype,"castVisibleElements",null),o.__decorate([r.property()],C.prototype,"visibleToolCount",null),C=o.__decorate([d.subclass("esri.widgets.support.SelectionToolbar")],C);return C}));
