/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","../../chunks/tslib.es6","../../core/arrayUtils","../../core/asyncUtils","../../core/maybe","../../core/reactiveUtils","../../core/uid","../../core/accessorSupport/decorators/property","../../core/has","../../core/Logger","../../core/accessorSupport/decorators/subclass","../Widget","../../chunks/componentsUtils","./globalCss","./LabeledSwitch","./widgetUtils","./decorators/messageBundle","./jsxFactory","./SnappingControls/SnappingControlsViewModel","./SnappingControls/snappingLayerListUtils","./SnappingControls/VisibleElements"],(function(e,t,s,i,l,n,a,r,o,d,p,c,g,h,_,b,u,y,m,L,w){"use strict";const v=e=>Object.freeze(Object.defineProperty({__proto__:null,default:e},Symbol.toStringTag,{value:"Module"})),k="esri-snapping-controls",C={base:k,container:`${k}__container`,item:`${k}__item`,toggleBlock:`${k}__toggle-block`,layerListBlock:`${k}__layer-list-block`,layerList:`${k}__layer-list`,layerListFilter:`${k}__layer-list__filter`,layerListButton:`${k}__layer-list__button`,layerListItem:`${k}__layer-list__item`,layerListGroup:`${k}__layer-list__group`,nestedContainer:`${k}__nested-container`};let E=class extends c{constructor(e,t){super(e,t),this._defaultViewModel=null,this._layerListFilter=null,this._gridLoadTask=null,this.layerListOpen=!0,this.gridOptionsOpen=!1,this.messages=null,this.messagesCommon=null,this.snappingManager=null,this.visibleElements=new w,this._enableSnappingSwitchChange=e=>{this.snappingOptions.enabled=e},this._featureEnabledSwitchChange=e=>{this.snappingOptions.featureEnabled=e},this._gridEnabledSwitchChange=e=>{this.snappingOptions.gridEnabled=e,e&&this._startLoadGrid()},this._selfEnabledSwitchChange=e=>{this.snappingOptions.selfEnabled=e},this._onToggleLayersButtonClick=e=>{this.viewModel.toggleSnappingForAllLayers(!this.viewModel.allLayersEnabled),b.setFocus(e.target)};const{snappingOptions:s,view:i,viewModel:l}=e;this.viewModel=l??(this._defaultViewModel=new m({snappingOptions:s,view:i}))}normalizeCtorArgs(e){const{snappingOptions:t,view:s,viewModel:i,...l}=e;return l}destroy(){this.viewModel!==this._defaultViewModel&&(this._defaultViewModel=l.destroyMaybe(this._defaultViewModel))}loadDependencies(){return Promise.all([g.loadCalciteComponents({block:()=>new Promise(((t,s)=>e(["../../chunks/calcite-block"],t,s))),button:()=>new Promise(((t,s)=>e(["../../chunks/calcite-button"],t,s))),input:()=>new Promise(((t,s)=>e(["../../chunks/calcite-input"],t,s))),list:()=>new Promise(((t,s)=>e(["../../chunks/calcite-list"],t,s))),"list-item":()=>new Promise(((t,s)=>e(["../../chunks/calcite-list-item"],t,s))),checkbox:()=>new Promise(((t,s)=>e(["../../chunks/calcite-checkbox"],t,s))),loader:()=>new Promise(((t,s)=>e(["../../chunks/calcite-loader"],t,s)))}),_.loadLabeledSwitchComponents()])}initialize(){this.addHandles(n.watch((()=>"2d"===this.view?.type&&!!this.view.grid),(e=>{this.visibleElements.gridControls&&(this.snappingOptions.gridEnabled=e)})))}get _openAndReady(){return this.gridOptionsOpen&&this.snappingOptions.gridEnabled&&this.snappingOptions.enabled}get icon(){return"snap-to-point"}set icon(e){this._overrideIfSome("icon",e)}get label(){return this.messages?.widgetLabel??""}set label(e){this._overrideIfSome("label",e)}get snappingOptions(){return this.viewModel.snappingOptions}set snappingOptions(e){this.viewModel.snappingOptions=e}get view(){return this.viewModel.view}set view(e){this.viewModel.view=e}set viewModel(e){e!==this._get("viewModel")&&(null!=this._defaultViewModel&&this._defaultViewModel===e||(this._defaultViewModel=l.destroyMaybe(this._defaultViewModel)),this._set("viewModel",e))}render(){const{label:e}=this;return y.tsx("div",{"aria-label":e,class:this.classes(C.base,h.globalCss.widget)},y.tsx("div",{class:C.container},this._renderContent()))}_renderContent(){return[this._renderToggles(),this._renderLayerList(),"2d"===this.view?.type&&this.visibleElements.gridControls?this._renderGridOptions():null]}_renderToggles(){const{visibleElements:e,view:t}=this,i=[e.selfEnabledToggle?this._renderSelfEnabledToggle():null,e.featureEnabledToggle?this._renderFeatureEnabledToggle():null,e.gridEnabledToggle&&"2d"===t?.type?this._renderGridEnabledToggle():null].filter(s.isSome),l=[e.enabledToggle?this._renderEnabledToggle():null,i.length>0?y.tsx("div",{class:C.nestedContainer},i):null].filter(s.isSome);return 0===l.length?null:y.tsx("calcite-block",{class:C.toggleBlock,heading:e.header?this.label:"",key:"toggle-block",open:!0},l)}_renderEnabledToggle(){return y.tsx(_.LabeledSwitch,{checked:this.viewModel.snappingOptions.enabled,disabled:this._enabledToggleDisabled,key:`${this.id}__enabled-toggle`,label:this.messages.enableSnapping,onChange:this._enableSnappingSwitchChange})}_renderSelfEnabledToggle(){return y.tsx(_.LabeledSwitch,{checked:this.viewModel.snappingOptions.selfEnabled,disabled:this._secondaryElementsDisabled,key:`${this.id}__self-enabled-toggle`,label:this.messages.geometryGuides,onChange:this._selfEnabledSwitchChange})}_renderFeatureEnabledToggle(){return y.tsx(_.LabeledSwitch,{checked:this.viewModel.snappingOptions.featureEnabled,disabled:this._secondaryElementsDisabled,key:`${this.id}__feature-enabled-toggle`,label:this.messages.featureToFeature,onChange:this._featureEnabledSwitchChange})}_renderGridEnabledToggle(){return y.tsx(_.LabeledSwitch,{checked:this.viewModel.snappingOptions.gridEnabled,disabled:this._secondaryElementsDisabled,key:`${this.id}__grid-enabled-toggle`,label:this.messages.grid,onChange:this._gridEnabledSwitchChange})}_renderLayerList(){if(!this.visibleElements.layerList)return null;const{messages:e,viewModel:t}=this,s=({target:{value:e}})=>{this._layerListFilter=""===e?null:new RegExp(e,"i")},i=t.layerListViewModel.operationalItems.length>9?y.tsx("calcite-input",{class:C.layerListFilter,clearable:!0,placeholder:e?.searchLayers,onCalciteInputInput:s}):null,l=this._secondaryElementsDisabled,n=this.layerListOpen&&!l;return y.tsx("calcite-block",{class:C.layerListBlock,collapsible:!0,disabled:this._secondaryElementsDisabled,heading:e.snappingLayers,key:"list-block",open:n,onCalciteBlockToggle:e=>this.layerListOpen=e.target.open},i,this._renderToggleLayersButton(),y.tsx("calcite-list",{class:C.layerList,selectionMode:"none"},this._renderLayerListItemCollection(t.layerListViewModel.operationalItems)))}_renderGridOptions(){const{view:e,visibleElements:t,snappingManager:s,snappingOptions:i,_openAndReady:l}=this,{gridEnabled:n,enabled:a}=i;(l||"2d"===e?.type&&e.grid)&&this._startLoadGrid();const r=this._gridLoadTask?.value,o=r&&"2d"===e?.type&&y.tsx(r,{snappingManager:s,snappingOptions:i,view:e,visibleElements:t.gridControlsElements});return y.tsx("calcite-block",{class:C.layerListBlock,collapsible:!0,disabled:!n||!a,heading:this.messages.gridOptionsHeading,key:"grid-block",open:l,onCalciteBlockClose:()=>this.gridOptionsOpen=!1,onCalciteBlockOpen:()=>this.gridOptionsOpen=!0},o??y.tsx("calcite-loader",{label:this.messagesCommon.loading,scale:"s",text:this.messagesCommon.loading}))}async _startLoadGrid(){!this._gridLoadTask&&this.visibleElements.gridControls&&"2d"===this.view?.type&&(this._gridLoadTask=i.createTask((async()=>(await new Promise(((t,s)=>e(["./GridControls"],(e=>t(v(e))),s)))).default)))}_renderLayerListItemCollection(e){const t=this._layerListFilter;return e.map((e=>{switch(t?L.itemTitleMatchesFilter(e,t):null){case"children":{const s=e.children.filter((e=>!1!==L.itemTitleMatchesFilter(e,t)));return this._renderLayerListItemGroup(e,s)}case"self":case null:return this._renderLayerListItemOrGroup(e);case!1:return"self"===L.itemTitleMatchesFilter(e.parent,t)?this._renderLayerListItemOrGroup(e):null}})).toArray().filter(s.isSome)}_renderToggleLayersButton(){if(!this.visibleElements.layerListToggleLayersButton)return null;const{viewModel:{allLayersEnabled:e},messages:t}=this,s=e?t.disableAllLayers:t.enableAllLayers;return y.tsx("calcite-button",{appearance:"transparent",class:C.layerListButton,label:s,name:"layer-toggle",onclick:this._onToggleLayersButtonClick},s)}_renderLayerListItemOrGroup(e){if(e.children.length)return this._renderLayerListItemGroup(e);const{messages:{untitledLayer:t}}=this,s=e.title||t,i=()=>{this.viewModel.toggleSnappingForLayers([e.layer.id],"enabled"!==e.enabled)};return y.tsx("calcite-list-item",{class:C.layerListItem,key:`${this.id}-list-item-${e.uid}`,label:s,onCalciteListItemSelect:e=>{e.stopPropagation(),i()}},y.tsx("calcite-checkbox",{checked:"enabled"===e.enabled,slot:"actions-start",onCalciteCheckboxChange:i}))}_renderLayerListItemGroup(e,t){const{children:s,title:i}=e,l=i||this.messages.untitledLayer,n=i&&""!==i?i:a.generateUID(),r=!!t?.length,o=t??s,d=()=>{this.viewModel.toggleSnappingForLayers(e.childLayerIds,"enabled"!==e.enabled)};return y.tsx("calcite-list-item",{class:C.layerListGroup,key:n,label:l,open:r,onCalciteListItemSelect:e=>{e.stopPropagation(),d()}},y.tsx("calcite-checkbox",{checked:"enabled"===e.enabled,indeterminate:"indeterminate"===e.enabled,slot:"actions-start",onCalciteCheckboxChange:d}),y.tsx("calcite-list",null,this._renderLayerListItemCollection(o)))}get _enabledToggleDisabled(){const e=this.snappingOptions;return e.enabledToggled||e.forceDisabled}get _secondaryElementsDisabled(){return this._enabledToggleDisabled||!this.snappingOptions.enabled}};t.__decorate([r.property()],E.prototype,"_defaultViewModel",void 0),t.__decorate([r.property()],E.prototype,"_layerListFilter",void 0),t.__decorate([r.property()],E.prototype,"_gridLoadTask",void 0),t.__decorate([r.property()],E.prototype,"_openAndReady",null),t.__decorate([r.property()],E.prototype,"label",null),t.__decorate([r.property({type:Boolean,nonNullable:!0})],E.prototype,"layerListOpen",void 0),t.__decorate([r.property({type:Boolean,nonNullable:!0})],E.prototype,"gridOptionsOpen",void 0),t.__decorate([r.property(),u.messageBundle("esri/widgets/support/SnappingControls/t9n/SnappingControls")],E.prototype,"messages",void 0),t.__decorate([r.property(),u.messageBundle("esri/t9n/common")],E.prototype,"messagesCommon",void 0),t.__decorate([r.property()],E.prototype,"snappingOptions",null),t.__decorate([r.property()],E.prototype,"snappingManager",void 0),t.__decorate([r.property()],E.prototype,"view",null),t.__decorate([r.property()],E.prototype,"viewModel",null),t.__decorate([r.property({type:w,nonNullable:!0})],E.prototype,"visibleElements",void 0),t.__decorate([r.property()],E.prototype,"_enabledToggleDisabled",null),t.__decorate([r.property()],E.prototype,"_secondaryElementsDisabled",null),E=t.__decorate([p.subclass("esri.widgets.support.SnappingControls")],E);return E}));
