/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../intl","../../core/has","../../core/Error","../../core/mathUtils","../../core/maybe","../../intl/date","../../time/timeZoneUtils","./dataUtils","../../chunks/datetime","../../intl/locale"],(function(e,t,n,i,a,o,l,r,m,u,s){"use strict";const f=r.utc,c={date:null,time:null,timeZoneOffset:null},d=new Map([["hours",3600],["minutes",60],["seconds",1],["deciseconds",.1],["centiseconds",.01],["milliseconds",.001]]);var p;e.TimeStampOffsetPattern=void 0,(p=e.TimeStampOffsetPattern||(e.TimeStampOffsetPattern={})).HM="HH:mm",p.HMS="HH:mm:ss",p.HMS_MS="HH:mm:ss.SSS";const T=[e.TimeStampOffsetPattern.HMS_MS,e.TimeStampOffsetPattern.HMS,e.TimeStampOffsetPattern.HM,"TT"],S="yyyy-MM-dd",y=e.TimeStampOffsetPattern.HMS,D="latn",O=new Set(["date-only","time-only","timestamp-offset"]),g=e=>"valueAsDate"in e;function F(e){return{locale:s.getLocale(),numberingSystem:D,zone:e??f}}function h(e){return e?.isValid?e.toMillis():null}function v(e,t){return null===e?null:u.DateTime.fromMillis(e,F(t))}function I(t,n){if(null==t||!m.isString(t)||""===t){if(n){const e=u.DateTime.local({zone:n});return{date:null,time:null,timeZoneOffset:e.isValid?e.offset.toString():null}}return c}const i=u.DateTime.fromISO(t,{setZone:!0});return{date:i.toFormat(S,F()),time:i.toFormat(e.TimeStampOffsetPattern.HMS_MS,F()),timeZoneOffset:i.offset.toString()}}function M(e,t){if(null==e||!m.isNumber(e)||isNaN(e))return c;const n=v(e,t);return n?{date:n.toFormat(S,F(t)),time:n.toFormat(y,F(t))}:c}function V(e){switch(e.type){case"date":default:return l.convertDateFormatToIntlOptions("short-date-short-time");case"date-only":return l.convertDateFormatToIntlOptions("short-date");case"time-only":return l.convertDateFormatToIntlOptions("short-time");case"timestamp-offset":return{...l.convertDateFormatToIntlOptions("short-date-short-time"),timeZone:void 0,timeZoneName:"short"}}}function w(e,t,n){if(!e||null==t)return null;switch(e.type){case"date":return l.formatDate(t,n);case"date-only":return l.formatDateOnly(t,n);case"time-only":return l.formatTimeOnly(t,n);case"timestamp-offset":return l.formatTimestamp(t,n);default:return null}}function b(e){const{dateComponent:t,defaultTimeZone:n,timeComponent:i,timeZoneComponent:a,oldValue:o}=e;if(!t?.value)return null;const{year:l,month:m,day:s}=u.DateTime.fromFormat(t.value,S),{hour:f,minute:c,second:d,millisecond:p}=Z(i,r.utc)??u.DateTime.now(),T=I(o,n),y=a?.value?parseInt(a.value,10):null!=T.timeZoneOffset?parseInt(T.timeZoneOffset,10):(new Date).getTimezoneOffset(),D=u.FixedOffsetZone.instance(y),O=u.DateTime.fromObject({year:l,month:m,day:s,hour:f,minute:c,second:d,millisecond:p},{zone:D});return O.isValid?O.toISO({includeOffset:!0}):null}function x(e,t="system"){return u.DateTime.fromJSDate(e,{zone:t}).isInDST}function H(e){const{dateComponent:t,timeComponent:n,timeZone:i,max:a,min:o,oldValue:l}=e,r=Z(t,i);let m=!!e.applyRange;if(!r)return null;let s=null;if(null!=n?.value){const e=Z(n,i),t=Date.now(),o=null!=a&&a<t?a:t,l=u.DateTime.fromMillis(o,F(i)),m=r||l,{year:f,month:c,day:d}=m,{hour:p,minute:T,second:S,millisecond:y}=e||l;s=m.set({year:f,month:c,day:d,hour:p,minute:T,second:S,millisecond:y})}else{const e=v(P({value:l??Date.now(),max:a,min:o}),i),{year:t,month:n,day:u}=r,{hour:f,minute:c,second:d,millisecond:p}=e;m=!0,s=r.set({year:t,month:n,day:u,hour:f,minute:c,second:d,millisecond:p})}if(!s.isValid)return null;const f=s.toMillis();return m?P({value:f,max:a,min:o}):f}function Z(e,t){if(null==e?.value||Array.isArray(e.value))return null;let n=null;return n=g(e)?u.DateTime.fromFormat(e.value,S,F(t)):R(e.value),n?.isValid?n:null}function C(e){const{max:t,min:n,value:i}=e;return!isNaN(i)&&(!(null!=t&&i>t)&&!(null!=n&&i<n))}function P(e){const{max:t,min:n,value:i}=e;return null!=t&&null!=n?a.clamp(i,n,t):null!=t&&i>t?t:null!=n&&i<n?n:i}function k(e){if(!e)return"";const t=e.split(".").at(0);if(!t||t.length<1)throw new i("invalid time-only field",`Cannot parse valid time-only field value from ${e}`);const n=t.split(":"),a=new Array(3);for(let i=0;i<3;i++){const e=n.at(i)??"";a[i]=e.padStart(2,"0")}return a.join(":")}function N(e,t){switch(t){case"date":return e.getTime();case"date-only":return e.toISODate();case"time-only":return k(e.toISOTime(!0,!1));case"timestamp-offset":return e.toISOString(!1);default:return null}}function z(e){return!!e&&"object"==typeof e&&"getTime"in e&&"toISOString"in e&&"timeZone"in e}function A(e){if(!e||!m.isString(e))return null;const t=u.DateTime.fromFormat(e,S);return t.isValid?t:null}function R(e){return e&&m.isString(e)?o.mappedFind(T,(t=>{const n=u.DateTime.fromFormat(e,t);return n.isValid?n:null}))??null:null}function U(e){if(!e||!m.isString(e))return null;const t=u.DateTime.fromISO(e);return t.isValid?t:null}function j(e){const{type:t,range:n,value:i}=e;if(null==i||!n||i===n.min||i===n.max)return!0;if("date"===t)return C({value:i,min:n.min,max:n.max});const{rawMax:a,rawMin:o}=n;let l=null,r=null,m=null;switch(t){case"date-only":l=A(a),r=A(o),m=A(i);break;case"time-only":l=R(a),r=R(o),m=R(i);break;case"timestamp-offset":l=U(a),r=U(o),m=U(i)}return!m||C({value:m.valueOf(),min:r?.valueOf(),max:l?.valueOf()})}const L=new Set(["small-integer","big-integer","integer","single","double"]);function _(e){return L.has(e)}const E=new Set(["date-picker","time-picker","datetimeoffset-picker","datetime-picker"]);function J(e){return E.has(e)}e.arcadeDateToFieldValue=N,e.clampValueToRange=P,e.createDateTimeFromFieldValue=v,e.dateFieldsWithStringFieldValue=O,e.dateOnlyToDateTime=A,e.dateTimeIsInRange=j,e.dateTimeToFieldValue=h,e.defaultDatePattern=S,e.defaultTimePattern=y,e.getDefaultLocaleOptions=F,e.getISOFieldValueFromDateComponents=b,e.getIntlOptionsForField=V,e.getLabelForDateFieldValue=w,e.getLocalDateTimeFromComponent=Z,e.getUnixFieldValueFromDateComponents=H,e.isArcadeDate=z,e.isCalciteDateComponent=g,e.isDateType=J,e.isInDST=x,e.isNumberType=_,e.normalizeTimeOnlyString=k,e.numberingSystem=D,e.prepareISOFieldValueForDateComponents=I,e.prepareUnixFieldValueForDateComponents=M,e.supportedTimeFormats=T,e.timeOnlyToDateTime=R,e.timeResolutionToStepMap=d,e.timestampOffsetToDateTime=U,e.valueIsInRange=C,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
